<a href="https://pypi.org/project/clawpack/"><img alt="PyPI" src="https://img.shields.io/pypi/v/clawpack"></a>
<a href="https://pepy.tech/project/clawpack"><img alt="Downloads" src="https://pepy.tech/badge/clawpack"></a>
<a href="https://anaconda.org/conda-forge/clawpack/"><img alt="conda-forge" src="https://img.shields.io/conda/dn/conda-forge/clawpack.svg?label=conda-forge"></a>

Please see the documentation for Clawpack at http://www.clawpack.org.

If you are cloning this repository, the following pages may be of particular interest:

- <a href="http://www.clawpack.org/developers.html#installation-instructions-for-developers">Installation instructions for Developers'</a> (or more generally from this repository),
- <a href="http://www.clawpack.org/installing.html">Other installation options,</a>
- <a href="http://www.clawpack.org/packages.html">Which Clawpack solver should I use?</a>
- <a href="http://www.clawpack.org/developers.html">Developers' Guide</a>, including guidelines for contributing to the project,
- <a href="http://www.clawpack.org/regression.html">Regression testing,</a>
- <a href="http://www.clawpack.org/git_versions.html">Keeping track of repository versions with git,</a>
- <a href="http://www.clawpack.org/community.html">Clawpack Community,</a> with links to Google groups, issue trackers, Developers' workshops, etc.

[![Build Status](https://travis-ci.com/clawpack/pyclaw.svg?branch=master)](https://travis-ci.com/clawpack/pyclaw)
[![Coverage Status](https://img.shields.io/coveralls/clawpack/pyclaw.svg)](https://coveralls.io/r/clawpack/pyclaw?branch=master)

[![PyPI version](https://badge.fury.io/py/clawpack.svg)](https://badge.fury.io/py/clawpack)


# PyClaw

Pyclaw is a Python-based solver for hyperbolic PDEs that includes the algorithms
of Clawpack and SharpClaw.  
It has been designed with easy extensibility, performance, and exploration in mind.
PyClaw also includes a scalable parallel implementation of Clawpack using PETSc.

Documentation is available at http://clawpack.org/pyclaw/.

If you use PyClaw in research that leads to publication, please
[cite PyClaw](http://www.clawpack.org/pyclaw/index.html#citing-pyclaw)
(see also [citing Clawpack](http://www.clawpack.org/about.html#citing-this-work)).

# Riemann Solver Repository

This repository is a centralized location for all Clawpack-compatible Riemann
solvers.  If you have developed a Riemann solver that is not already here,
please send it to us or issue a pull request.  The format for Riemann solvers
has changed significantly since Clawpack 4.3, but if you have a 4.3-style solver,
send it along and we will update it.

# Adding a Riemann solver

When adding a new Riemann solver, in addition to adding the normal and
(optionally) transverse solver code files in src/, you should do the following
in order to ensure the new solver is importable in PyClaw.  To make things
concrete, suppose you are committing a 2D elasticity solver, so your Fortran 
files are named `rpn2_vc_elasticity.f90` and `rpt2_vc_elasticity.f90`.  Then you should:

1. Add the following to `clawpack/riemann/riemann/__init__.py`:
```
import vc_elasticity_2D
```
2. Add `vc_elasticity` to `two_d_riemann` in `clawpack/riemann/riemann/setup.py`.
3. Add appropriate entries for `num_eqn` and `num_waves` in `clawpack/riemann/riemann/static.py`.

If you are adding a Python solver, then you should have a `vc_elasticity_2D_py.py` 
file in `clawpack/riemann/riemann`. Assuming it contains a function `vc_elasticity_2D`, then 
you should do:

1. Add the following to `clawpack/riemann/riemann/__init__.py`:
```
from vc_elasticity_2D_py import vc_elasticity_2D
```
2. Add appropriate entries for `num_eqn` and `num_waves` in `clawpack/riemann/riemann/static.py`.

Scratch directory for data files that are either downloaded from the web or
generated via scripts.  

Running some of the examples will generate large files in this directory.
They can be safely removed after you are done exploring the example.

This directory is for documentation.

To make the documentation in this directory, run
  make htmls
in the doc directory of the doc repository, after insuring that
  visclaw_doc
is a link to this directory.

Index to files in claw/matlab
------------------------------

CHANGES ... might list some recent changes

UserVariableFiles:
------------------

mach.m
pressure.m
xvelocity.m
yvelocity.m
zvelocity.m

Colormaps:
----------

setColors.m    ... set colors based on q values
yrbcolormap.m  ...  yellow -> red -> blue
rybcolormap.m  ...  red -> yellow -> blue
redwhite.m     ...  red -> pink -> white
whitemap.m
allblue.m
standsout.m


For manipulating data:
----------------------
coarsen.m ... takes a 1d or 2d array of data and coarsens it to a smaller size
make2drad.m ... converts 1d data into radially symmetric 2d data 


Printing and producing gifs and animations:
-------------------------------------------
printgif.m
makeframegif.m

Utilities for plotclaw:
-----------------------
query.m
queryframe.m


1d graphics:
------------

plotclaw1.m
plotframe1.m
infoplot1.m
infoframe1.m
setplot1.m
hdf_frame1.m
plothdf1.m
compare1.m  ... compare coarse grid with finer grid solution

2d graphics:
------------

plotclaw2.m
plotframe2.m
infoplot2.m
infoframe2.m
setplot2.m
hdf_frame2.m
plothdf2.m

3d graphics:
------------

plotclaw3.m
plotframe3.m
setplot3.m
hdf_frame3.m
plothdf3.m

drawContours.m
intersectQWithSlices.m
maskPatches.m
plotCube.m
plotSliceContour.m
plotSliceIntersection.m
plotSlicePatch.m
projectBorder.m

Insructions on using the Matlab graphics for visualizing Clawpack/PyClaw
output :

   -- First, make sure that $CLAW/visclaw/src/matlab is in your Matlab
      path.  You can do this either by setting the environment variable
      MATLABPATH, or by using the Matlab ADDPATH command.

   -- To get started with the plotting, you can type

           >> plotclaw2
      or
           >> plotclaw3

      at the Matlab prompt to plot output in fort.XXXX files produced by Clawpack
      or PyClaw.  Other file formats (HDF) are supported to a limited extent.  See
      READAMRDATA for ideas on how to support your own file format.

   -- The ClawGraphics routines will run files setplot2.m or setplot3.m to initialize
      graphics parameters.  To customize properties like axis limits, camera view angles,
      colormaps, gridlines, patchborders, etc.  you can supply an 'afterframe.m' file
      which gets run after each frame has been plotted.  Both the setplot<n>.m files and
      afterframe file can be customized for particular examples, and should be located in
      your working directory.

For a suite of examples using this Clawpack graphics library, see

    http://math.boisestate.edu/~calhoun/visclaw/matlab_gallery/test_graphics/index.html

Contributers to ClawGraphics :

       R. J. LeVeque (University of Washington, rjl@u.washington.edu)
       D. Calhoun (Boise State University, donnacalhoun@boisetate.edu)

----------------------- end of README --------------------------------

This folder contains the following files

Makefile: to build the FRS.so module from the fortran code main.90 created by Kyle Mandli in ../ directory. You need to have f2py tool and gfortran from http://r.research.att.com/tools/. Hpc gfortran 4.5 version did not work for me. 

RiemannSolver.py: is the python wrapper for main.90. It imports FRS and contains one class that provides several methods.

riemannSolverDemo.py: is a demonstration example of using class RiemannSolver.py and plotting some of the results

riemannSolverAssertion.py: is a test file to assert the result of computation with a certain tolerance. It reads the input from q.npy and aux.npy, calculate the output and compare it with a previously calculated output stored in s.npy and waves.npy. (it needs to be modified to read all the inputs not only q and aux)
 
riemannSolverSerialTimer.py: This script calculates the execution time for different input sizes and different numbers of time steps and plots the timing results.

This directory contains a few examples to get users started using
this software.  In most directories you should be able to type:
    make all
and the code should run and a set of plots produced.  

However, see the individual README files in the directories.

To run all examples in all subdirectories:
    python $CLAW/clawutil/src/python/clawutil/run_examples.py
You might want to first check your environment variables, or you can set
them explicitly by modifying the script.

In addition to doing `make all`, this script also runs any Jupyter notebooks
found in the subdirectories.

It may take some time for these examples to all run. Two files 
    make_all_output.txt
    make_all_errors.txt
will be created that contain the output normally sent to the screen and any
error messages from running the examples.

A quicker set of tests can be run from the amrclaw/tests directory.  See the
README file in that directory.

# PyClaw examples

These directories contain several prepared examples of how to run PyClaw.
There are multiple ways to run and plot an example:

### Method 1: From the command line

    cd examples/acoustics_1d_homogeneous
    python acoustics_1d.py iplot=1

The command-line option `iplot=1` will cause an interactive plotting session
to be launched after the simulation is complete.

### Method 2: From IPython

    ipython --matplotlib
    from clawpack.pyclaw import examples
    claw = examples.acoustics_1d.setup()
    claw.run()
    claw.plot()

Some of the more basic examples are the homogeneous acoustics, advection,
burgers, traffic, and shallow water examples.  Advanced examples include
`Rossby_wave` (2D grid mapped to a sphere) `shock_bubble_interaction` (cylindrical
symmetry with geometric source terms), and `psystem_2d` (shows how to set up gauges, 
a `before_step` function, and more).

This directory is for regression tests.

To run all tests:
    python run_tests.py
or: 
    make tests
which does the same thing.  This runs nosetests but also saves all output to
a file in case you want to check it.

To just run nosetests in all subdirectories:
    nosetests */

To clean up afterwards, removing all executables, output, and test results:
    make clobber

Each test does a short run with regions and gauges set to exercise the code,
The test passes if the code runs and if the sum of t values and of q values
agree with archived results for each gauge.

Developers: To create new archived results for a test case, go into the
directory and type:
    python regression_tests.py True
Then 'git add' and issue a pull request if you believe the new results are
more correct.

This directory is for regression tests.

To run all tests, at the command line type:
    nosetests
or, for more verbose output:
    nosetests -sv

Each test does a short run and computes a few numbers based on all solution
values to see if they agree with archived results.


Developers: To create new archived results for a test case, go into the
directory and type:
    python regression_tests.py True
Then 'git add' and issue a pull request if you believe the new results are 
more correct.

You can also run `make .output` as usual in a subdirectory if you want to
examine all the output, which is removed automatically if nosetests runs a
test and it passes.  (If it fails, the output is preserved in a directory
with a name like `Acoustics1DHeterogeneousTest_output` if the failing test
was in drirectory `acoustics_1d_heterogeneous`.)

GeoClaw Boussinesq solver examples

The radial_flat subdirectory contains one example using the Boussinesq
solver introduced in Clawpack v5.10.0.

Several other examples can be found in this repository:
    https://github.com/rjleveque/ImplicitAMR-paper
which are described in the paper found at:
    Implicit Adaptive Mesh Refinement for Dispersive Tsunami Propagation
    by Marsha J. Berger and Randall J. LeVeque, submitted, 2023
    Preprint: https://arxiv.org/abs/2307.05816

Running these codes requires PETSc  Version 3.20 (or later) in order to use
OpenMP along with MPI.  Some flags have to be set as environment variables
or directly in the application Makefile, e.g. see the lines commented out in
radial_flat/Makefile.

The file setenv.sh illustrates how you might set some environment
variables for the bash shell.

A file petscMPIoptions is also required to set some PETSc parameters for the
iterative method used to solve the large sparse linear systems that arise at 
each refinement level when the Boussinesq equations are solved. 
One of the environment variables mentioned above points to this file, and a
sample is included in this directory.

This test problem is based on examples/tsunami/bowl-slosh-netcdf.

This uses the `clawpack.geoclaw.topotools` capabilities to create the netCDF
topofile `bowl.nc`, using the Python module `netCDF4`.
This must be installed for this to work.
See `<https://unidata.github.io/netcdf4-python/netCDF4/index.html>`_.

Running the Fortran code also requires netCDF properly installed in
order to read in the `bowl.nc` file.  The `Makefile` refers to an
environment variable `NETCDF4_DIR` that must be set appropriately.
See `<https://www.unidata.ucar.edu/software/netcdf/docs-fortran/>`_.

The file tsunami3_runup.zip from
    https://nctr.pmel.noaa.gov/benchmark/Solitary_wave/
was unzipped to obtain data in directory:
    experimental_data

qinit.f90 is set up for case B with amplitude H/d = 0.259.

Compare the figure generated by compare_gauges.py to KimFigure4.png,
which is Figure 4 in the original BoussClaw paper 

    Kim, J., Pedersen, G. K., Løvholt, F. & LeVeque, R. J.,
    A Boussinesq type extension of the GeoClaw model - a study of wave breaking 
    phenomena applying dispersive long wave models. 
    Coastal Engineering 122, 75–86 (2017).
    http://dx.doi.org/10.1016/j.coastaleng.2017.01.005

This plot shows the time history at gauges 5, 7, and 8.
See that paper for more details on the problem and data.

See also 
    compare_BoussSWE.py
which runs the code with various settings and plots the results together.

c
c --------------------------------------------------------------
c
      subroutine advanc (level,nvar,dtlevnew,vtime,naux)
c
      use amr_module
      use bouss_module
      !use fixedgrids_module
      use topo_module, only: topo_finalized

      implicit double precision (a-h,o-z)


      logical vtime, doUpdate, implicitSolveDone
      logical debug
      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      integer listgrids(numgrids(level))
      integer(kind=8) :: clock_start, clock_finish, clock_rate
      integer(kind=8) :: clock_startStepgrid, clock_finishStepgrid
      integer(kind=8) :: clock_startBound, clock_finishBound
      real(kind=8) cpu_start, cpu_finish
      real(kind=8) cpu_startBound,cpu_finishBound
      real(kind=8) cpu_startStepgrid, cpu_finishStepgrid

      type(matrix_levInfo),  pointer :: minfo


c     maxgr is maximum number of grids  many things are
c     dimensioned at, so this is overall. only 1d array
c     though so should suffice. problem is
c     not being able to dimension at maxthreads


c
c  ::::::::::::::; ADVANC :::::::::::::::::::::::::::::::::::::::::::
c  integrate all grids at the input  'level' by one step of its delta(t)
c  this includes:  setting the ghost cells 
c                  advancing the solution on the grid
c                  adjusting fluxes for flux conservation step later
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
#ifdef WHERE_AM_I
      write(*,*)"starting advance with level ",level
#endif
      flush(66)

      !debug = .true.
      debug = .false.

      call system_clock(clock_start,clock_rate)
      call cpu_time(cpu_start)
      hx   = hxposs(level)
      hy   = hyposs(level)
      delt = possk(level)
      time = rnode(timemult,lstart(level))
      implicitSolveDone = .false.
      ! need to start on level 1 once enough time passed
      ! include .not. startWithBouss so only print once
      if (level .eq. 1 .and. startBoussTime .le. time 
     &                 .and. .not. startWithBouss) then
            write(*,*)"Using/Switching to Boussinesq equations"
            write(outunit,*)"Using/Switching to Boussinesq equations",
     &                      "at time ",time
            startWithBouss = .true.
      endif
c 
      if (debug) then
         write(*,*)"at start of  advanc level ",level
         call valout(level,level,time,nvar,naux)
      endif
c
      !! initial conditions were put in new storage
      !! save to old. implicit_update counts on this
      if (level .lt. lfine) call copyNew2Old(level,nvar)
c
c     set up for Bouss step
      if (ibouss .gt. 0) then
       if (level .ge. minLevelBouss .and. level .le. maxLevelBouss .and.
     &     startWithBouss) then
         minfo =>  matrix_info_allLevs(level) 
         doUpdate = .true. ! update momenta after implicit solve
         call implicit_update(nvar,naux,level,minfo%numBoussCells,
     &                        doUpdate,time)
         implicitSolveDone = .true. ! also indicates that bound was called
       endif
      endif

      if (debug) then
         write(*,*)"in advanc level ",level," after 1st implicit call"
         call valout(level,level,time,nvar,naux)
      endif


c    dont call bound here, since called for implicit update above
c    and momentum updated in ghost cells in solnUpdate
c    dont want to overwrite
c
cc     maxthreads initialized to 1 above in case no openmp
c!$    maxthreads = omp_get_max_threads()
c
c We want to do this regardless of the threading type

      if (.not. implicitSolveDone) then ! this level needs to call bound
        call system_clock(clock_startBound,clock_rate)
        call cpu_time(cpu_startBound)
!$OMP PARALLEL DO PRIVATE(j,locnew,locaux,mptr,nx,ny,mitot,
!$OMP&                    mjtot,time,levSt),
!$OMP&            SHARED(level,nvar,naux,alloc,intrat,delt,nghost,
!$OMP&                   node,rnode,numgrids,listStart,listOfGrids),
!$OMP&            SCHEDULE (dynamic,1)
!$OMP&            DEFAULT(none)
        do  j = 1, numgrids(level)
            levSt  = listStart(level)
            mptr   = listOfGrids(levSt+j-1)
            nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
            ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
            mitot  = nx + 2*nghost
            mjtot  = ny + 2*nghost
            locnew = node(store1,mptr)
            locaux = node(storeaux,mptr)
            time   = rnode(timemult,mptr)
c
            call bound(time,nvar,nghost,alloc(locnew),mitot,mjtot,mptr,
     1                 alloc(locaux),naux)

        end do
!$OMP END PARALLEL DO
        call system_clock(clock_finishBound,clock_rate)
        call cpu_time(cpu_finishBound)
        timeBound = timeBound + clock_finishBound - clock_startBound
        timeBoundCPU=timeBoundCPU+cpu_finishBound-cpu_startBound
      endif
c
c
c save coarse level values if there is a finer level for wave fixup
      if (level+1 .le. mxnest) then
         if (lstart(level+1) .ne. null) then
            call saveqc(level+1,nvar,naux)
         endif
      endif
c
      time = rnode(timemult,lstart(level))
c      call fgrid_advance(time,delt)
      
      dtlevnew = rinfinity
      cfl_level = 0.d0    !# to keep track of max cfl seen on each level

      if (.not. topo_finalized) then
         call topo_update(time)
          if (debug) then
             write(*,*)"after topoupdate level ",level
             call valout(level,level,time,nvar,naux)
          endif
         endif
c 
      call system_clock(clock_startStepgrid,clock_rate)
      call cpu_time(cpu_startStepgrid)
        
!$OMP PARALLEL DO 
!$OMP&            PRIVATE(j,mptr,nx,ny,mitot,mjtot)  
!$OMP&            PRIVATE(mythread,dtnew,levSt)
!$OMP&            SHARED(rvol,rvoll,level,nvar,mxnest,alloc,intrat)
!$OMP&            SHARED(nghost,intratx,intraty,hx,hy,naux,listsp)
!$OMP&            SHARED(node,rnode,dtlevnew,numgrids)
!$OMP&            SHARED(listStart,listOfGrids)
!$OMP&            SCHEDULE (DYNAMIC,1)
!$OMP&            DEFAULT(none)
      do  j = 1, numgrids(level)
          levSt  = listStart(level)
          mptr   = listOfGrids(levSt+j-1)
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
c
c         call to set up for finite volume update
          call par_advanc(mptr,mitot,mjtot,nvar,naux,dtnew)
!$OMP CRITICAL (newdt)
          !write(*,555) mptr, dtnew
555       format(" grid ",i5," has new dt ",e15.7)
          dtlevnew = dmin1(dtlevnew,dtnew)
!$OMP END CRITICAL (newdt)    

      end do
!$OMP END PARALLEL DO
      call system_clock(clock_finishStepgrid,clock_rate)
      call cpu_time(cpu_finishStepgrid)
      timeStepgrid = timeStepgrid + 
     &               clock_finishStepgrid-clock_startStepgrid
      timeStepgridCPU = timeStepgridCPU + 
     &               cpu_finishStepgrid-cpu_startStepgrid

      if (debug) then
       write(*,*)"after bound/sw step before 2nd impl call level ",level
       call valout(level,level,time,nvar,naux)
      endif
c
c
c     set up for post SWE  Bouss step, for updated corrections
c     needed for finer grid interp, but actually dont update momentum
c     don't need psi on finest level after stepping either 
      if (ibouss .gt. 0) then
       if (level .ge. minLevelBouss .and. level .le. maxLevelBouss .and.
     &   level.lt.mxnest .and. startWithBouss) then
         minfo =>  matrix_info_allLevs(level) 
         time = rnode(timemult,lstart(level))
         doUpdate = .false. ! only need psi, for
         call implicit_update(nvar,naux,level,minfo%numBoussCells,
     &                        doUpdate,time)
       endif
      endif
c
      call system_clock(clock_finish,clock_rate)
      call cpu_time(cpu_finish)
      tvoll(level) = tvoll(level) + clock_finish - clock_start
      tvollCPU(level) = tvollCPU(level) + cpu_finish - cpu_start

      if (debug) then
         write(*,*)"in advanc level ",level," after 2nd implicit call"
         call valout(level,level,time,nvar,naux)
      endif

c
#ifdef WHERE_AM_I
      write(*,*)"ending   advance with level ",level
#endif
      return
      end
c
c -------------------------------------------------------------
c
       subroutine prepgrids(listgrids,num, level)

       use amr_module
       implicit double precision (a-h,o-z)
       integer listgrids(num)

       mptr = lstart(level)
       do j = 1, num
          listgrids(j) = mptr
          mptr = node(levelptr, mptr)
       end do

      if (mptr .ne. 0) then
         write(*,*)" Error in routine setting up grid array "
         stop
      endif

      return
      end

c
c --------------------------------------------------------------
c
      subroutine par_advanc (mptr,mitot,mjtot,nvar,naux,dtnew)
c
      use amr_module
      use gauges_module, only: update_gauges, num_gauges
      implicit double precision (a-h,o-z)


      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/

      double precision fp(nvar,mitot,mjtot),fm(nvar,mitot,mjtot)
      double precision gp(nvar,mitot,mjtot),gm(nvar,mitot,mjtot)


c
c  :::::::::::::: PAR_ADVANC :::::::::::::::::::::::::::::::::::::::::::
c  integrate this grid. grids are done in parallel.
c  extra subr. used to allow for stack based allocation of
c  flux arrays. They are only needed temporarily. If used alloc
c  array for them it has too long a lendim, makes too big
c  a checkpoint file, and is a big critical section.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
      delt  =  possk(level)
      nx    = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny    = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      time  = rnode(timemult,mptr)

!$         mythread = omp_get_thread_num()

      locold = node(store2, mptr)
      locnew = node(store1, mptr)

c
c  copy old soln. values into  next time steps soln. values
c  since integrator will overwrite it. only for grids not at
c  the finest level. finest level grids do not maintain copies
c  of old and new time solution values.
c
!         if (level .lt. mxnest) then
!            ntot   = mitot * mjtot * nvar
!cdir$ ivdep
!            do i = 1, ntot
!              alloc(locold + i - 1) = alloc(locnew + i - 1)
!            enddo
!         endif
c
      xlow = rnode(cornxlo,mptr) - nghost*hx
      ylow = rnode(cornylo,mptr) - nghost*hy

!$OMP CRITICAL(rv)
      rvol = rvol + nx * ny
      rvoll(level) = rvoll(level) + nx * ny
!$OMP END CRITICAL(rv)


      locaux = node(storeaux,mptr)
c
      if (node(ffluxptr,mptr) .ne. 0) then
         lenbc  = 2*(nx/intratx(level-1)+ny/intraty(level-1))
         locsvf = node(ffluxptr,mptr)
         locsvq = locsvf + nvar*lenbc
         locx1d = locsvq + nvar*lenbc
         call qad(alloc(locnew),mitot,mjtot,nvar,
     1            alloc(locsvf),alloc(locsvq),lenbc,
     2            intratx(level-1),intraty(level-1),hx,hy,
     3            naux,alloc(locaux),alloc(locx1d),delt,mptr)
      endif

c        # See if the grid about to be advanced has gauge data to output.
c        # This corresponds to previous time step, but output done
c        # now to make linear interpolation easier, since grid
c        # now has boundary conditions filled in.

c     should change the way print_gauges does io - right now is critical section
c     NOW changed, mjb 2/6/2015.
c     NOTE that gauge subr called before stepgrid, so never get
c     the very last gauge time at end of run.

      if (num_gauges > 0) then
           call update_gauges(alloc(locnew:locnew+nvar*mitot*mjtot),
     .                       alloc(locaux:locaux+naux*mitot*mjtot),
     .                       xlow,ylow,nvar,mitot,mjtot,naux,mptr)
           endif

c
      call stepgrid(alloc(locnew),fm,fp,gm,gp,
     2            mitot,mjtot,nghost,
     3            delt,dtnew,hx,hy,nvar,
     4            xlow,ylow,time,mptr,naux,alloc(locaux),.true.)

      if (node(cfluxptr,mptr) .ne. 0)
     2   call fluxsv(mptr,fm,fp,gm,gp,
     3               alloc(node(cfluxptr,mptr)),mitot,mjtot,
     4               nvar,listsp(level),delt,hx,hy)
      if (node(ffluxptr,mptr) .ne. 0) then
         lenbc = 2*(nx/intratx(level-1)+ny/intraty(level-1))
         locsvf = node(ffluxptr,mptr)
         call fluxad(fm,fp,gm,gp,
     2               alloc(locsvf),mptr,mitot,mjtot,nvar,
     4               lenbc,intratx(level-1),intraty(level-1),
     5               nghost,delt,hx,hy)
      endif

          rnode(timemult,mptr)  = rnode(timemult,mptr)+delt
c
      return
      end
c
c -----------------------------------------------------------
c
      subroutine copyNew2Old(level,nvar)

      use amr_module
      implicit none

      integer, intent(in) :: level, nvar
      integer:: i,j, levSt, mptr,nx,ny,mitot,mjtot,locold, locnew,ntot

      do  j = 1, numgrids(level)
          levSt  = listStart(level)
          mptr   = listOfGrids(levSt+j-1)
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          locold = node(store2, mptr)
          locnew = node(store1, mptr)

          ntot   = mitot * mjtot * nvar
!cdir$ ivdep
          do i = 1, ntot
            alloc(locold + i - 1) = alloc(locnew + i - 1)
          enddo
      enddo

      return
      end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
! Riemann solver in the transverse direction for the acoustics equations
! on general quadrilateral grids.

! Split asdq (= A^* \Delta q, where * = + or -)
! into down-going flux difference bmasdqb (= B^- A^* \Delta q)
! and up-going flux difference bpasdq (= B^+ A^* \Delta q)

    implicit none

    integer, intent(in) :: maxm, meqn, mwaves, mbc, mx, imp, maux
    double precision, intent(in)      :: ql(meqn, 1-mbc:maxm+mbc)
    double precision, intent(in)      :: qr(meqn, 1-mbc:maxm+mbc)
    double precision, intent(out)   :: asdq(meqn, 1-mbc:maxm+mbc)
    double precision, intent(out) :: bmasdq(meqn, 1-mbc:maxm+mbc)
    double precision, intent(out) :: bpasdq(meqn, 1-mbc:maxm+mbc)
    double precision, intent(in)    :: aux1(maux,    1-mbc:maxm+mbc)
    double precision, intent(in)    :: aux2(maux,    1-mbc:maxm+mbc)
    double precision, intent(in)    :: aux3(maux,    1-mbc:maxm+mbc)

    integer :: ixy, ixtran, iytran, ilenrat, i1, i, m
    double precision :: cm, cp, zm, zz, zp, xtran, ytran, asdqt, a1, a2
    double precision :: asdqp, bpasdqp, bpasdqt, bmasdqp, bmasdqt

    if (ixy.eq.1) then
        ixtran = 4
        iytran = 5
        ilenrat = 6
    else
        ixtran = 1
        iytran = 2
        ilenrat = 3
    endif

    do i=2-mbc,mx+mbc
        if (imp.eq.1) then
            i1 = i-1
        else
            i1 = i
        endif

!       pressure component of asdq:
        asdqp = asdq(1,i)
!
!       sound speed in each row of cells:
        cm = aux1(9,i1)
        cp = aux3(9,i1)
!
!       impedances:
        zm = aux1(8,i1)
        zz = aux2(8,i1)
        zp = aux3(8,i1)

!       up-going:
        xtran = aux3(ixtran,i)
        ytran = aux3(iytran,i)

        asdqt = xtran*asdq(2,i) + ytran*asdq(3,i)
        a2 = (asdqp + zz*asdqt) / (zz+zp)
        bpasdqp = a2*zp
        bpasdqt = a2

        bpasdq(1,i) = cp * bpasdqp
        bpasdq(2,i) = cp * xtran*bpasdqt
        bpasdq(3,i) = cp * ytran*bpasdqt

!       down-going:

        xtran = aux2(ixtran,i)
        ytran = aux2(iytran,i)

        asdqt = xtran*asdq(2,i) + ytran*asdq(3,i)
        a1 = (-asdqp + zz*asdqt) / (zm + zz)
        bmasdqp = -a1*zm
        bmasdqt = a1

        bmasdq(1,i) = -cm * bmasdqp
        bmasdq(2,i) = -cm * xtran*bmasdqt
        bmasdq(3,i) = -cm * ytran*bmasdqt

!       scale by ratio of lengths:
        do m=1,3
            bmasdq(m,i) = bmasdq(m,i)*aux2(ilenrat,i)
            bpasdq(m,i) = bpasdq(m,i)*aux3(ilenrat,i)
        enddo
    enddo
    return
    end subroutine rpt2

subroutine qinit(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    
    use geoclaw_module, only: sea_level
    
    implicit none
    
    ! Subroutine arguments
    integer, intent(in) :: meqn,mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Locals
    integer :: i,j
    real(kind=8) :: r0,x,y,r

    real(kind=8) :: eta, width, ampl

    width = 100.d0    ! controls width of Gaussian
    r0 = 0.d0   ! initial radius of Gaussian
    ampl = 5.0d0  ! amplitude

    ! Set flat state based on sea_level
    q = 0.d0
    forall(i=1:mx, j=1:my)
        q(1,i,j) = max(0.d0, sea_level - aux(1,i,j))
    end forall


    do i=1,mx
      x = (xlower + (i-0.5d0)*dx)
      do j=1,my
          if (q(1,i,j) > 0.d0) then
              y = (ylower + (j-0.5d0)*dy)
              r = sqrt(x**2 + y**2)
              eta = ampl * exp(-(((r-r0)/width)**2))
              
              q(1,i,j) = max(0.d0, eta - aux(1,i,j))
              q(2,i,j) = 0.d0
              q(3,i,j) = 0.d0

              endif
          enddo
       enddo

    
end subroutine qinit

c     ==================================================================
      subroutine setaux(mbc,mx,my,mz,xlower,ylower,zlower,
     &                  dx,dy,dz,maux,aux)
c     ==================================================================
c
c     # set auxiliary arrays
c
c     # advection
c     #    aux(i,j,k,1) is u velocity on left face of cell
c     #    aux(i,j,k,2) is v velocity on bottom face of cell
c     #    aux(i,j,k,3) is w velocity on back face of cell
c
c
      implicit none

      integer  mx, my, mz, mbc, maux, i,j,k
      double precision xlower, ylower, zlower, dx, dy, dz,
     &      pi, pi2, dx2, dy2, dz2, compute_u, compute_v, compute_w
      double precision aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      double precision xc(1-mbc:mx+mbc)
      double precision yc(1-mbc:my+mbc)
      double precision zc(1-mbc:mz+mbc)

      common /piconstants/ pi, pi2

      pi = 4.d0*atan(1.d0)
      pi2 = 2.d0*pi

c

      do i = 1-mbc,mx+mbc
         xc(i) = xlower + (i-0.5d0)*dx
      enddo

      do j = 1-mbc,my+mbc
         yc(j) = ylower + (j-0.5d0)*dy
      enddo

      do k = 1-mbc,mz+mbc
         zc(k) = zlower + (k-0.5d0)*dz
      enddo

      dx2 = 0.5d0*dx
      dy2 = 0.5d0*dy
      dz2 = 0.5d0*dz

      do  k = 1-mbc,mz+mbc
         do j = 1-mbc,my+mbc
            do i = 1-mbc,mx+mbc
               aux(1,i,j,k) = compute_u(xc(i)-dx2, yc(j),zc(k))
               aux(2,i,j,k) = compute_v(xc(i),yc(j)-dy2, zc(k))
               aux(3,i,j,k) = compute_w(xc(i),yc(j), zc(k)-dz2)
            enddo
         enddo
      enddo

      return
      end

      double precision function compute_u(x,y,z)
      implicit none
      double precision x,y,z,pi, pi2

      common /piconstants/ pi, pi2

      compute_u = 2.d0 * dsin(pi*x)**2 * dsin(pi2*y) * dsin(pi2*z)
      end

      double precision function compute_v(x,y,z)
      implicit none
      double precision x,y,z,pi, pi2

      common /piconstants/ pi, pi2

      compute_v = -dsin(pi2*x) * dsin(pi*y)**2 * dsin(pi2*z)
      end

      double precision function compute_w(x,y,z)
      implicit none
      double precision x,y,z,pi, pi2

      common /piconstants/ pi, pi2

      compute_w = -dsin(pi2*x) * dsin(pi2*y) * dsin(pi*z)**2
      end

      subroutine opendatafile(iunit, fname)
c     #
c     # Open the file fname and determine how many leading lines are
c     # comments.  Then rewind and skip over the comment lines so that the
c     # file is ready for reading data from.
c     #
c     # All comment lines must start with # in the first column.

      integer iunit, commentlines


c     This allows for a variable name length and obsolves (I think) the
c     length problem that appeared for some compilers (notably ifort)
      character(len=*) :: fname

      character*1 firstchar
      logical foundFile
      
      inquire(file=fname,exist=foundFile)
      if (.not. foundFile) then
          if (.not. foundFile) then
            print "(2a)",'*** in opendatafile, file not found:', fname 
            stop
          endif
      else
          open(unit=iunit,file=fname,status='old',form='formatted')
          print "(2a)",'Reading data file: ', fname
      endif

      firstchar = '#'
      commentlines = -1
      do commentlines=-1,1000
          if (firstchar .eq. '#') then
              read(iunit,"(a1)") firstchar
          else
              exit
          endif
      enddo
      
      write(6,602) commentlines
  602 format('         first',i2,
     &       ' lines are comments and will be skipped')
     
      return
      end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
      implicit double precision (a-h,o-z)
!
!     # Riemann solver in the transverse direction for the Euler equations.
!     # Split asdq (= A^* \Delta q, where * = + or -)
!     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
!     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)
!
!     # Uses Roe averages and other quantities which were 
!     # computed in rpn2eu and stored in the common block comroe.
!
      dimension     ql(meqn, 1-mbc:maxm+mbc)
      dimension     qr(meqn, 1-mbc:maxm+mbc)
      dimension   asdq(meqn, 1-mbc:maxm+mbc)
      dimension bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension bpasdq(meqn, 1-mbc:maxm+mbc)
!
      common /cparam/  gamma
      dimension waveb(4,3),sb(3)
      parameter (maxm2 = 1800)  !# assumes at most 200x200 grid with mbc=2
!
      double precision u2v2(-6:maxm2+7), &
            u(-6:maxm2+7),v(-6:maxm2+7),enth(-6:maxm2+7),a(-6:maxm2+7), &
            g1a2(-6:maxm2+7),euv(-6:maxm2+7) 

      if (mbc > 7 .OR. maxm2 < maxm) then
         write(6,*) 'need to increase maxm2 or 7 in rpn'
         stop
      endif
!
      gamma1 = gamma - 1.d0

      if (ixy.eq.1) then
          mu = 2
          mv = 3
        else
          mu = 3
          mv = 2
        endif
!
!     # compute the Roe-averaged variables needed in the Roe solver.
!     # These are stored in the common block comroe since they are
!     # later used in routine rpt2eu to do the transverse wave splitting.
!
      do 10 i = 2-mbc, mx+mbc
         rhsqrtl = dsqrt(qr(1,i-1))
         rhsqrtr = dsqrt(ql(1,i))
         pl = gamma1*(qr(4,i-1) - 0.5d0*(qr(2,i-1)**2 + &
             qr(3,i-1)**2)/qr(1,i-1))
         pr = gamma1*(ql(4,i) - 0.5d0*(ql(2,i)**2 + &
             ql(3,i)**2)/ql(1,i))
         rhsq2 = rhsqrtl + rhsqrtr
         u(i) = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
         v(i) = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
         enth(i) = (((qr(4,i-1)+pl)/rhsqrtl &
                  + (ql(4,i)+pr)/rhsqrtr)) / rhsq2
         u2v2(i) = u(i)**2 + v(i)**2
         a2 = gamma1*(enth(i) - .5d0*u2v2(i))
         a(i) = dsqrt(a2)
         g1a2(i) = gamma1 / a2
         euv(i) = enth(i) - u2v2(i) 
   10    continue
!
         do 20 i = 2-mbc, mx+mbc
            a3 = g1a2(i) * (euv(i)*asdq(1,i) &
                  + u(i)*asdq(mu,i) + v(i)*asdq(mv,i) - asdq(4,i))
            a2 = asdq(mu,i) - u(i)*asdq(1,i)
            a4 = (asdq(mv,i) + (a(i)-v(i))*asdq(1,i) - a(i)*a3) &
                   / (2.d0*a(i))
            a1 = asdq(1,i) - a3 - a4
!
            waveb(1,1) = a1
            waveb(mu,1) = a1*u(i)
            waveb(mv,1) = a1*(v(i)-a(i))
            waveb(4,1) = a1*(enth(i) - v(i)*a(i))
            sb(1) = v(i) - a(i)
!
            waveb(1,2) = a3
            waveb(mu,2) = a3*u(i) + a2
            waveb(mv,2) = a3*v(i)
            waveb(4,2) = a3*0.5d0*u2v2(i) + a2*u(i)
            sb(2) = v(i)
!
            waveb(1,3) = a4
            waveb(mu,3) = a4*u(i)
            waveb(mv,3) = a4*(v(i)+a(i))
            waveb(4,3) = a4*(enth(i)+v(i)*a(i))
            sb(3) = v(i) + a(i)
!
!           # compute the flux differences bmasdq and bpasdq
!
            do m=1,meqn
               bmasdq(m,i) = 0.d0
               bpasdq(m,i) = 0.d0
               do mw=1,3
                  bmasdq(m,i) = bmasdq(m,i) &
                              + dmin1(sb(mw), 0.d0) * waveb(m,mw)
                  bpasdq(m,i) = bpasdq(m,i) &
                              + dmax1(sb(mw), 0.d0) * waveb(m,mw)
                end do
            end do
!                 
   20       continue
!
      return
      end

c
c -----------------------------------------------------------------------
c
       subroutine setIndices(ist,iend,jst,jend,ilo,ihi,jlo,jhi,
     &                       ishift,jshift,level)

       use amr_module
       implicit double precision (a-h,o-z)

       dimension ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)

c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!> setIndices:  for periodicity a region that sticks out is wrapped into
!!              another region.
c
c  this is just annoying code this is needed in several places so it became a routine
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       ist(1) = ilo
       ist(2) = 0
       ist(3) = iregsz(level)

       iend(1) = -1
       iend(2) = iregsz(level)-1
       iend(3) = ihi

       jst(1) = jlo
       jst(2) = 0
       jst(3) = jregsz(level)

       jend(1) = -1
       jend(2) = jregsz(level)-1
       jend(3) = jhi

       if (xperdom) then ! regions that stick out of domain get periodically wrapped indices
          ishift(1) = iregsz(level)
          ishift(2) = 0
          ishift(3) = -iregsz(level)
       else   ! no shifting of indices
          ishift(1) = 0
          ishift(2) = 0
          ishift(3) = 0
       endif

       if (yperdom) then
          jshift(1) = jregsz(level)
          jshift(2) = 0
          jshift(3) = -jregsz(level)
       else  ! no shifting of indices
          jshift(1) = 0
          jshift(2) = 0
          jshift(3) = 0
       endif


       return
       end

! ::::::::::::::::::::: flagregions ::::::::::::::::::::::::::::::::::
!
!> Modify array of flagged points to respect minlevels and maxlevels
!! specified by regions.
!
!
! amrflags  = array to be flagged with either the value
!             DONTFLAG (no refinement needed)  or
!             DOFLAG   (refinement desired)    
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine flagregions(mx,my,mbuff,xlower,ylower,dx,dy,level,t, &
                            amrflags,DONTFLAG,DOFLAG)

    use regions_module

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,my,level,mbuff
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbuff:mx+mbuff,1-mbuff:my+mbuff)
    real(kind=8), intent(in) :: DONTFLAG
    real(kind=8), intent(in) :: DOFLAG
    
    ! Locals
    integer :: i,j,m,minlevel,maxlevel
    real(kind=8) :: x_low,y_low,x_hi,y_hi

    
    ! Loop over interior points on this grid
    ! (i,j) grid cell is [x_low,x_hi] x [y_low,y_hi]
    do j=1,my
        y_low = ylower + (j - 1) * dy
        y_hi = ylower + j * dy
        
        do i = 1,mx
            x_low = xlower + (i - 1) * dx
            x_hi = xlower + i * dx

            minlevel = 0
            maxlevel = 0

            do m=1,num_regions
                if (t >= regions(m)%t_low .and. t <= regions(m)%t_hi .and. &
                   x_hi > regions(m)%x_low .and. x_low < regions(m)%x_hi .and. &
                   y_hi > regions(m)%y_low .and. y_low < regions(m)%y_hi ) then
                        minlevel = max(minlevel, regions(m)%min_level)
                        maxlevel = max(maxlevel, regions(m)%max_level)
                endif
             enddo

             if (minlevel > maxlevel) then
                  write(6,*) '*** Error: this should never happen!'
                  write(6,*) '*** minlevel > maxlevel in flagregions'
                  stop
             endif

             if (maxlevel /= 0) then
                 ! this point lies in at least one region, so may need
                 ! to modify the exisiting flag at this point...
                 if (level < minlevel) then
                     ! Require refinement of this cell:
                     amrflags(i,j) = DOFLAG
                 else if (level >= maxlevel) then
                     ! Do not refine of this cell:
                     amrflags(i,j) = DONTFLAG
                 ! else leave amrflags(i,j) alone.
                 endif
              endif

        enddo 
    enddo 
   
end subroutine flagregions

! ============================================================================
!  File:        geoclaw_mod
! ============================================================================
!    Copyright (C) 2010-04-21 Clawpack Developers http://www.clawpack.org
!
!  Distributed under the terms of the Berkeley Software Distribution (BSD)
!  license
!                     http://www.opensource.org/licenses/
! ============================================================================

module geoclaw_module

    implicit none
    save

    logical, private :: module_setup = .false.
    
    ! ========================================================================
    !  Constants
    ! ========================================================================
    integer, parameter :: GEO_PARM_UNIT = 78
    integer, parameter :: KAPPA_UNIT = 42
    real(kind=8), parameter :: pi = 4.d0*datan(1.d0)
    real(kind=8), parameter :: DEG2RAD = pi / 180.d0
    real(kind=8), parameter :: RAD2DEG = 180.d0 / pi
    
    ! ========================================================================
    !  Physics
    ! ========================================================================
    real(kind=8) :: grav, rho_air, ambient_pressure, earth_radius, sea_level
    ! Water density can be an array to handle multiple layers
    real(kind=8), allocatable :: rho(:)
    integer :: coordinate_system, sphere_source

    ! Rotational velocity of Earth
    real(kind=8), parameter :: omega = 2.0d0 * pi / 86164.2d0
    
    ! Forcing
    logical :: coriolis_forcing ! True then coriolis terms included in src
    real(kind=8) :: theta_0 ! Used if using the beta-plane approximation
    logical :: friction_forcing ! Friction forcing will be applied
    real(kind=8), dimension(:),allocatable :: manning_coefficient, manning_break
    integer :: num_manning
    real(kind=8) :: friction_depth
    
    ! Method parameters    
    real(kind=8) :: dry_tolerance

contains

    ! ========================================================================
    !  set_geo(fname)
    ! ========================================================================
    !  Reads in user parameters from the given file name if provided
    ! ========================================================================
    subroutine set_geo(file_name)

        use utility_module, only: get_value_count
        
        use amr_module, only: mcapa, rinfinity

        implicit none

        ! Input
        character(len=*), intent(in), optional :: file_name

        ! Locals
        integer, parameter :: unit = 127

        integer :: i
        character(len=128) :: line

        if (.not.module_setup) then
            open(unit=GEO_PARM_UNIT,file='fort.geo',status="unknown",action="write")

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'Physics Parameters:'
            write(GEO_PARM_UNIT,*) '-------------------'

            ! Read user parameters from setgeo.data
            if (present(file_name)) then
                call opendatafile(unit, file_name)
            else
                call opendatafile(unit, 'geoclaw.data')
            endif

            read(unit,*) grav
            read(unit,'(a)') line
            allocate(rho(get_value_count(line)))
            read(line,*) (rho(i), i=1, size(rho, 1))
            read(unit,*) rho_air
            read(unit,*) ambient_pressure
            read(unit,*) earth_radius
            read(unit,*) coordinate_system
            read(unit,*) sphere_source
            read(unit,*) sea_level
            read(unit,*)
            read(unit,*) coriolis_forcing
            if (coordinate_system == 1 .and. coriolis_forcing) then
                read(unit,*) theta_0
            else
                theta_0 = 0.d0
            endif
            read(unit,*) friction_forcing
            if (friction_forcing) then
                read(unit,*) num_manning
                allocate(manning_coefficient(num_manning))
                allocate(manning_break(num_manning))
                manning_break(num_manning) = rinfinity
                read(unit,*) manning_coefficient(:)
                read(unit,*) manning_break(1:num_manning-1)
                read(unit,*) friction_depth
            else
                friction_depth = rinfinity
            endif
            read(unit,*)
            read(unit,*) dry_tolerance
            
            close(unit)

            ! coordinate_system = 1 means Cartesian grid in meters
            ! coordinate_system = 2 means lat-long grid on sphere
            ! Check that coordinate_system is consistent with mcapa:
            if ((coordinate_system > 1) .and. (mcapa == 0)) then
                print *, 'ERROR in setgeo:  if coordinate_system > 1 then'
                print *, '      mcapa should be nonzero'
                stop
            endif
            if ((coordinate_system == 1) .and. (mcapa > 0)) then
                print *, 'ERROR in setgeo:  if coordinate_system = 1 then'
                print *, '      mcapa should be zero'
                stop
            endif

            write(GEO_PARM_UNIT,*) '   gravity:',grav
            write(GEO_PARM_UNIT,*) '   density water:',rho
            write(GEO_PARM_UNIT,*) '   density air:',rho_air
            write(GEO_PARM_UNIT,*) '   ambient pressure:',ambient_pressure
            write(GEO_PARM_UNIT,*) '   earth_radius:',earth_radius
            write(GEO_PARM_UNIT,*) '   coordinate_system:',coordinate_system
            write(GEO_PARM_UNIT,*) '   sea_level:',sea_level
            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '   coriolis_forcing:',coriolis_forcing
            write(GEO_PARM_UNIT,*) '   theta_0:',theta_0
            write(GEO_PARM_UNIT,*) '   friction_forcing:',friction_forcing
            if (friction_forcing) then
                write(GEO_PARM_UNIT,*) '   manning_coefficient:', manning_coefficient
                write(GEO_PARM_UNIT,*) '   friction_depth:',friction_depth
            else
                write(GEO_PARM_UNIT,*) '   manning_coefficient: not used'
                write(GEO_PARM_UNIT,*) '   friction_depth: not used'
            end if

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '   dry_tolerance:', dry_tolerance

            module_setup = .true.
        end if

    end subroutine set_geo


    ! ==========================================================================
    !  Calculate the coriolis constant f
    !   If coordinate_system == 1 then
    !       A beta-plane approximation is used and y should be in meters
    !   if coordinate_system == 2 then
    !       Grid is in lat-long and y should be in degrees which is converted
    !       to radians
    ! ==========================================================================
    real(kind=8) pure function coriolis(y)

        implicit none
        
        ! Input
        real(kind=8), intent(in) :: y
        
        ! Locals
        real(kind=8) :: theta
        
        ! Assume beta plane approximation and y is in meters    
        if (coordinate_system == 1) then
            theta = y / 111d3 * DEG2RAD + theta_0
            coriolis = 2.d0 * omega * (sin(theta_0) + (theta - theta_0)     &
                                                    * cos(theta_0))
        else if (coordinate_system == 2) then        
            coriolis = 2.d0 * omega * sin(y * DEG2RAD)
        else
            ! Unknown coordinate system, return nothing
            coriolis = 0.d0
        endif
    end function coriolis
    
    ! ==========================================================================
    !  Calculate the absolute value of the coriolis constant f
    !   Calling `unsigned_coriolis(y)` is the same as `abs(coriolis(y))`.
    !   See the `coriolis` function for details.
    ! ==========================================================================
    real(kind=8) pure function unsigned_coriolis(y)

        implicit none
        
        ! Input
        real(kind=8), intent(in) :: y
        
        unsigned_coriolis = abs(coriolis(y))
    end function unsigned_coriolis

    ! ==========================================================================
    !  Calculate the distance along a sphere
    !    real(kind=8) spherical_distance(x1,y1,x2,y2)
    !       x1 = (long,lat)
    !       x2 = (long,lat)
    ! ==========================================================================
    real(kind=8) pure function spherical_distance(x1,y1,x2,y2) result(distance)

        implicit none

        ! Input
        real(kind=8), intent(in) :: x1,y1,x2,y2

        ! Locals
        real(kind=8) :: dx ,dy

        dx = (x2 - x1) * DEG2RAD
        dy = (y2 - y1) * DEG2RAD

        distance = earth_radius * 2.d0 * asin(sqrt(sin(0.5d0*dy)**2 &
                                   + cos(y1 * DEG2RAD)*cos(y2 * DEG2RAD) &
                                   * sin(0.5d0*dx)**2))

    end function spherical_distance

    !=================================================================
    ! Transform long,lat --> (x,y) coordinates.
    !
    ! On input:
    !    coords(2) = (longitude (E/W),latitude (N/S))
    !    projection_center(2) = (longitude (E/W),latitude (N/S)) - coordinates 
    !                        where projection is true
    !
    ! On output:
    !    x(2)          (meters)
    !=================================================================
    pure function latlon2xy(coords,projection_center) result(x)

        real(kind=8), intent(in) :: coords(2), projection_center(2)
        real(kind=8) :: x(2)

        x(1) = deg2rad * earth_radius * (coords(1) - &
                    projection_center(1)) * cos(deg2rad * projection_center(2))
        x(2) = deg2rad * earth_radius * coords(2)

    end function latlon2xy

    !=================================================================
    ! Transform (x,y) --> (lat,lon) coordinates.
    !
    ! On input:
    !    x(2) = (meters)          
    !    projection_center(2) = (longitude (E/W),latitude (N/S)) - coordinates 
    !                        where projection is true
    !
    ! On output:
    !    coords(2) = (longitude,latitude)
    !=================================================================
    pure function xy2latlon(x,projection_center) result(coords)

        real(kind=8), intent(in) :: x(2), projection_center(2)
        real(kind=8) :: coords(2)

        coords(1) = projection_center(1) + x(1) &
                / (deg2rad * earth_radius * cos(deg2rad * projection_center(2)))
        coords(2) = x(2) / (deg2rad * earth_radius)
    end function xy2latlon

end module geoclaw_module

subroutine src1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)

    ! Called to update q by solving source term equation
    ! $q_t = \psi(q)$ over time dt starting at time t.
    !
    ! This default version integrates manning friction or other friction terms if present
    
    ! Version from 1D branch of GeoClaw originally from Dave George

    ! Also handles radial source term, if desired.
    ! Note: assumes radial about lower boundary, wall bc should be imposed

    
    use geoclaw_module, only: dry_tolerance, grav, DEG2RAD
    use geoclaw_module, only: friction_forcing
    use geoclaw_module, only: frictioncoeff => friction_coefficient
    use geoclaw_module, only: earth_radius, coordinate_system, sphere_source
    use grid_module, only: xcell


    implicit none
    integer, intent(in) :: mbc,mx,meqn,maux
    real(kind=8), intent(in) :: xlower,dx,t,dt
    real(kind=8), intent(in) ::  aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) ::  q(meqn,1-mbc:mx+mbc)

    !Locals
    real(kind=8) :: gamma, u, tanxR
    integer :: i

      if (frictioncoeff.gt.0.d0 .and. friction_forcing) then
          ! integrate source term based on Manning formula
            do i=1,mx
               if (q(1,i)<=dry_tolerance) then
                  q(2,i) = 0.0
               else
                  gamma= dsqrt(q(2,i)**2)*(grav*frictioncoeff**2)/(q(1,i)**(7.0/3.0))
                  q(2,i)= q(2,i)/(1.d0 + dt*gamma)
              endif
            enddo
        endif

!      ----------------------------------------------------------------

    if (coordinate_system == -1) then
        ! radial source term for SWE:
        do i=1,mx
            if (q(1,i) .gt. dry_tolerance) then
                ! x is radial coordinate in meters, x>=0, 
                ! u = radial velocity
                q(1,i) = q(1,i) - dt/xcell(i) * q(2,i)
                u = q(2,i)/q(1,i)
                q(2,i) = q(2,i) - dt/xcell(i) * q(1,i)*u**2
            endif
         enddo
     endif

!      ----------------------------------------------------------------

    if ((coordinate_system == 2) .and. (sphere_source > 0)) then
        ! add in spherical source term in mass equation
        ! if sphere_source in [1,2],
        ! and also in momentum equations if sphere_source == 2
        ! In this case, x = latitude in degrees -90 <= x <= 90,
        ! u = velocity in latitude direction (m/s) on sphere:
        do i=1,mx
            if (q(1,i) .gt. dry_tolerance) then
                tanxR = tan(xcell(i)*DEG2RAD) / earth_radius
                q(1,i) = q(1,i) + dt * tanxR * q(2,i)
                if (sphere_source == 2) then
                    u = q(2,i)/q(1,i)
                    q(2,i) = q(2,i) + dt * tanxR * q(1,i)*u**2
                endif
            endif
         enddo
     endif



end subroutine src1

! =========================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =========================================================

! solve Riemann problems for the 1D Euler equations using the HLLE
! approximate Riemann solver.

! waves: 2
! equations: 3

! Conserved quantities:
!       1 density
!       2 momentum
!       3 energy

    implicit none

    integer, intent(in) :: maxmx, meqn, mwaves, mbc, mx, maux
    double precision, dimension(meqn,1-mbc:maxmx+mbc), intent(in) :: ql, qr
    double precision, dimension(maux,1-mbc:maxmx+mbc), intent(in) :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxmx+mbc), intent(out) :: wave
    double precision, dimension(meqn, 1-mbc:maxmx+mbc), intent(out) :: amdq, apdq
    double precision, dimension(mwaves, 1-mbc:maxmx+mbc), intent(out) :: s

    double precision :: u_l, u_r, c_l, c_r, u_hat, c_hat
    double precision :: p_l, p_r, H_l, H_r, rhsqrt_l, rhsqrt_r
    double precision :: rhsq2, H_hat, gamma, gamma1, E_l, E_r
    double precision :: rho_m, rhou_m, E_m, s1, s2
    integer :: m, i, mw

    common /cparam/  gamma

    gamma1 = gamma - 1.d0

    do i=2-mbc,mx+mbc
        ! Velocity
        u_l = qr(2,i-1) / qr(1,i-1)
        u_r = ql(2,i  ) / ql(1,i  )
        ! Pressure
        p_l = gamma1 * (qr(3,i-1) - qr(1,i-1)*u_l**2/2.d0)
        p_r = gamma1 * (ql(3,i  ) - ql(1,i  )*u_r**2/2.d0)
        ! Enthalpy
        H_l = (qr(3,i-1) + p_l) / qr(1,i-1)
        H_r = (ql(3,i  ) + p_l) / ql(1,i  )
        ! Sound speed
        c_l = dsqrt(gamma1*H_l-u_l**2/2.)
        c_r = dsqrt(gamma1*H_r-u_r**2/2.)

        E_l = qr(3,i-1)
        E_r = ql(3,i  )


        rhsqrt_l = dsqrt(qr(1,i-1))
        rhsqrt_r = dsqrt(ql(1,i))
        rhsq2 = rhsqrt_l + rhsqrt_r
        u_hat = (qr(2,i-1)/rhsqrt_l + ql(2,i)/rhsqrt_r) / rhsq2
        H_hat = (((qr(3,i-1)+p_l)/rhsqrt_l + (ql(3,i)+p_r)/rhsqrt_r)) / rhsq2
        c_hat = dsqrt(gamma1*(H_hat - .5d0*u_hat**2))

        s1 = min(u_l - c_l, u_hat - c_hat)
        s2 = max(u_r + c_r, u_hat + c_hat)
        rho_m = (ql(2,i) - qr(2,i-1) - s2*ql(1,i) + s1*qr(1,i-1))/(s1-s2)
        rhou_m = (ql(1,i)*u_r**2 - qr(1,i-1)*u_l**2 + p_r - p_l - s2*ql(2,i) + s1*qr(2,i-1))/(s1-s2)
        E_m = ( u_r*(E_r+p_r) - u_l*(E_l+p_l) -s2*E_r + s1*E_l)/(s1-s2)

        wave(1,1,i) = rho_m - qr(1,i-1)
        wave(2,1,i) = rhou_m - qr(2,i-1)
        wave(3,1,i) = E_m - qr(3,i-1)
        s(1,i) = s1
    
        wave(1,2,i) = ql(1,i) - rho_m
        wave(2,2,i) = ql(2,i) - rhou_m
        wave(3,2,i) = ql(3,i) - E_m
        s(2,i) = s2

    end do 

    do m=1,3
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1,mwaves
                if (s(mw,i) < 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                else
                    apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                endif
            end do
        end do
    end do

end subroutine rp1

subroutine fgmax_frompatch(mx,my,meqn,mbc,maux,q,aux,dx,dy, &
           xlower,ylower,level,time,time_afterstep)

    ! Do the new fixed grid stuff on all fgrids, updating 
    ! based on the patch passed in.

    !----------------------------------------------------------------------
    ! Modified to use speed for flagging arrival time, rather than h or h+B
    ! Can only be used if FG_NUM_VAL > 1 so speeds are computed
    !----------------------------------------------------------------------

    use fgmax_module
    use geoclaw_module, only: sea_level, dry_tolerance

    implicit none
    integer, intent(in) :: mx,my,meqn,mbc,maux,level
    real(kind=8), intent(in) :: q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: dx,dy,xlower,ylower,time,time_afterstep

    real(kind=8), allocatable, dimension(:,:) :: fg_values
    logical, allocatable, dimension(:) :: mask_fgrid
    type(fgrid), pointer :: fg
    integer :: ifg,k,mv
    real(kind=8) :: s

    !print *, '+++ FG_DEBUG = ', FG_DEBUG

    if (FG_num_fgrids == 0) then
        return
        endif 

    if (FG_NUM_VAL == 1) then
        write(6,*) '*** Error, need FG_NUM_VAL > 1 to use speed to flag arrivals'
        stop
        endif

    !write(61,*) '++++ In frompatch, level,mx,my,xlower,ylower'
    !write(61,*) level,mx,my,xlower,ylower
    do ifg=1,FG_num_fgrids
        fg => FG_fgrids(ifg)
        !write(6,*) '++++ ifg = ',ifg
        !write(6,*) '++++ fg%xNbb = ',fg%x1bb,fg%x2bb
        !write(61,*) '++++ frompatch xNbb', fg%x1bb, fg%x2bb

        if (FG_DEBUG) then
            write(61,61) ifg,level,time
 61         format('---------- In fgmax_frompatch ----------',/, &
               'ifg = ',i2,' level = ',i1,' time = ',d16.6)
            if (time_afterstep <= minval(fg%t_last_updated)+fg%dt_check) then
                write(61,68) time, minval(fg%t_last_updated)
     68         format('++++ Skipping update at t = ', e20.11,' min t_last = ',&
                       e20.11)
            else
                write(61,67) time, minval(fg%t_last_updated)
     67         format('++++ Doing update at t = ', e20.11,' min t_last = ', &
                       e20.11)
                endif
            endif

        if ((time >= fg%tstart_max) .and. (time <= fg%tend_max) .and. &
                (level >= fg%min_level_check) .and. &
                (level >= minval(fg%levelmax)) .and. &
                (time_afterstep > minval(fg%t_last_updated)+fg%dt_check)) &
                then
            ! Otherwise this level won't update any fg%valuemax elements.
            !write(61,*) '+++ Setting fg_values'

            allocate(mask_fgrid(1:fg%npts))
            allocate(fg_values(FG_NUM_VAL, 1:fg%npts))
        
            ! Interpolate from q on patch to desired values fg_values on fgrid.
            call fgmax_interpolate(mx,my,meqn,mbc,maux,q,aux, &
                 dx,dy,xlower,ylower,ifg,level,fg_values,mask_fgrid,fg%npts)

            if (FG_DEBUG) then
                write(61,*) '+++ updating level: ',level
                write(61,*) '+++ in fgmax_frompatch, count = ', count(mask_fgrid)
                endif

        
            do k=1,fg%npts
                ! fg_values is set only at points k where the fgrid intersects the
                ! patch, indicated by mask_fgrid(k) == .true.
                ! Also: only update valuemax if the current patch is at least
                ! as high a level as the patch last used to update:
                if (mask_fgrid(k) .and. (level >= fg%levelmax(k))) then
                    fg%t_last_updated(k) = time
                    do mv=1,FG_NUM_VAL
                        !print *,'+++ updating fg%valuemax(mv,k),fg_values(mv,k):',&
                        !      fg%valuemax(mv,k),fg_values(mv,k)
                        if ((level > fg%levelmax(k)) .or. &
                              (fg_values(mv,k) > fg%valuemax(mv,k))) then
                            fg%valuemax(mv,k) = fg_values(mv,k)
                            ! also keep track of time maximum happened:
                            fg%tmax(mv,k) = time  
                            endif
                        enddo
                    fg%levelmax(k) = level
                    endif

                ! keep track of arrival time...
                ! modified to use speed rather than h or h+B
                s = fg_values(2,k)
                if (mask_fgrid(k) .and. &
                   (level >= fg%min_level_check) .and. &
                   (s > fg%arrival_tol) .and. &
                   (fg%arrival_time(k) == FG_NOTSET)) then
                        fg%arrival_time(k) = time
                    endif

                enddo
                deallocate(mask_fgrid, fg_values)
            endif
        enddo

end subroutine fgmax_frompatch

c
c --------------------------------------------------------------------
c
       subroutine icall(val,aux,nrow,ncol,nfil,nvar,naux,
     .                  ilo,ihi,jlo,jhi,klo,khi,level,
     .                  iputst,jputst,kputst)

      use amr_module
      implicit double precision (a-h, o-z)

      dimension val(nvar,nrow,ncol,nfil)
      dimension aux(naux,nrow,ncol,nfil)


       iadd   (ivar,i,j,k) = loc    +    (ivar-1)
     &                              +    (i-1)*nvar
     &                              +    (j-1)*nvar*mitot
     &                              +    (k-1)*nvar*mitot*mjtot
       iaddaux(ivar,i,j,k) = locaux +    (ivar-1)
     &                              +    (i-1)*naux
     &                              +    (j-1)*naux*mitot
     &                              +    (k-1)*naux*mitot*mjtot

c ::::::::::::::::::::::::::: ICALL :::::::::::::::::::::::::::::::
c
c    find intersecting grids at the same level. copy data from
c    intersecting grids to both val and aux arrays.
c
c    use larger definition of grids here - boundary data already in.
c    aux arrays also enlarged size.
c
c    iputst, jputst, kputst: where to copy values into. may not be in
c                            location corresponding to ilo,ihi,etc. if
c                            the patch has been periodically wrapped.

c    
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       mptr = lstart(level)

 10    if (mptr .eq. 0) go to 99
         iglo = node(ndilo,mptr) 
         ighi = node(ndihi,mptr) 
         jglo = node(ndjlo,mptr) 
         jghi = node(ndjhi,mptr) 
         kglo = node(ndklo,mptr) 
         kghi = node(ndkhi,mptr) 

c         # does it intersect?
!--         ixlo = max(iglo-nghost,ilo)
!--         ixhi = min(ighi+nghost,ihi)
!--         jxlo = max(jglo-nghost,jlo)
!--         jxhi = min(jghi+nghost,jhi)
!--         kxlo = max(kglo-nghost,klo)
!--         kxhi = min(kghi+nghost,khi)
c  how did ghost cells get in the allowable region? They are not filled
c  (since we may be interpolating from newly filled grids, not just grids
c  that have been primed with bcs to be advanced.
         ixlo = max(iglo,ilo)
         ixhi = min(ighi,ihi)
         jxlo = max(jglo,jlo)
         jxhi = min(jghi,jhi)
         kxlo = max(kglo,klo)
         kxhi = min(kghi,khi)

         if ((ixlo .le. ixhi .and. jxlo .le. jxhi) .and.
     &       (                     kxlo .le. kxhi)) then
           loc  = node(store1,mptr)
           locaux = node(storeaux,mptr)
           nx   = ighi - iglo + 1
           ny   = jghi - jglo + 1
           nz   = kghi - kglo + 1
           mitot = nx + 2*nghost
           mjtot = ny + 2*nghost
           mktot = nz + 2*nghost
           do 30 k    = kxlo, kxhi
           do 30 j    = jxlo, jxhi
           do 30 i    = ixlo, ixhi
           do 20 ivar = 1, nvar
              ialloc  =  iadd(ivar,i-iglo+nghost+1,j-jglo+nghost+1,
     &                                             k-kglo+nghost+1)
              val(ivar,i-ilo+iputst,j-jlo+jputst,
     &                              k-klo+kputst) = alloc(ialloc)
 20     continue
           do 25 iaux = 1, naux
             ialloc = iaddaux(iaux,i-iglo+nghost+1,j-jglo+nghost+1,
     &                                             k-kglo+nghost+1)
             aux(iaux,i-ilo+iputst,j-jlo+jputst,
     &                             k-klo+kputst) = alloc(ialloc)
 25        continue
 30       continue
       endif
       mptr = node(levelptr, mptr)
       go to 10

 99   return
      end

c
c -----------------------------------------------------------------
c
      subroutine setgrd (nvar,cut,naux,dtinit,start_time)
c
      use geoclaw_module
      use refinement_module, only: varRefTime
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension spoh(maxlv)

      logical  vtime
      data     vtime/.false./

c     # may as well not bother to calculate time step for error est.
c
c :::::::::::::::::::::::::::: SETGRD :::::::::::::::::::::::::::::::;
c  set up the entire tree/grid structure.  only at this time t = 0
c  can we take advantage of initialization routines.
c  remember that regridding/error estimation needs to have two
c  time steps of soln. values.
c  6/21/05: added dtinit arg. to allow for better choice of initial timestep
c   as discovered by advance/setgrd in first step.
c ::::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::::;
c
      dtinit = possk(1)
      if (mxnest .eq. 1) go to 99
c
      levnew =  2
      time   = start_time
c
 10   if (levnew .gt. mxnest) go to 30
          levold = levnew - 1
          if (lstart(levold) .eq. 0) go to 30
          lbase  = levold
          lfnew  = lbase
c
c  set up level to be flagged. need a solution t=0,and t=dt.
c  error estimation makes next one at t=2*dt for Richardson.
c
          if (flag_richardson) then
             call advanc(levold,nvar,dtlev,vtime,naux)
             evol = evol + rvol !time stepping stats for error estimation
             rvol = 0.d0        ! reset since not 'real' time stepping stats
             kfac = 1
             do i = 1, levold-1
               kfac = kfac * kratio(i)
             end do
             dtinit = min(dtinit, dtlev*kfac)
 
c            dont count it in real integration stats
             do 20 level=1,mxnest
 20             rvoll(level) = 0.d0
          endif
c
c  flag, cluster, and make new grids. grdfit set bcs, controls flagging,
c  colating and making grids. But advanc called above since if using
c  richardson, it assumes two levels of solution already exist
c
         call grdfit(lbase,levold,nvar,naux,cut,time,start_time)
         if (newstl(levnew) .ne. 0) lfnew = levnew
c
c  init new level. after each iteration. fix the data structure
c  also reinitalize coarser grids so fine grids can be advanced
c  and interpolate correctly for their bndry vals from coarser grids.
c
         call ginit(newstl(levnew),.true., nvar, naux, start_time)
         lstart(levnew) = newstl(levnew)
         lfine = lfnew
         call ginit(lstart(levold),.false., nvar, naux, start_time)
c
c count number of grids on newly created levels (needed for openmp
c parallelization). this is also  done in regridding.
c  set up numgrids now for new level, since advanc will use it for parallel execution
c 
         mptr = lstart(levnew)
         ngrids = 0
         ncells = 0
         do while (mptr .gt. 0)
            ngrids = ngrids + 1
            ncells = ncells + (node(ndihi,mptr)-node(ndilo,mptr)+1)
     .                      * (node(ndjhi,mptr)-node(ndjlo,mptr)+1)
            mptr = node(levelptr, mptr)
          end do
          numgrids(levnew) = ngrids
          numcells(levnew) = ncells
          avenumgrids(levnew) = avenumgrids(levnew) + ngrids
          iregridcount(levnew) = iregridcount(levnew) + 1
          if (ngrids .gt. 1) call arrangeGrids(levnew,ngrids)
          if (verbosity_regrid .ge. levnew) then
              write(*,100) levnew,start_time,ngrids,ncells
              write(outunit,100) levnew,start_time,ngrids,ncells
 100          format("Gridding level ",i3," at t =",e14.6, ":",i6,
     &               " grids with ",i11," cells")
          endif 
c
c     need to make gridList here before calling again to make finer grids.
c     This is because ths list if used in advanc. level 1 is called from domain
      call makeGridList(lbase)
      call makeBndryList(levnew)
c
      levnew = levnew + 1
      go to 10
 30   continue
c
c  switch location of old and new storage for soln. vals, 
c  and reset time to 0.0 (or initial time start_time)
c
c      if (mxnest .eq. 1) go to 99  shouldnt be nec. tested above.
c
      lev = 1
 40   if ((lev .eq. mxnest) .or. (lev .gt. lfine))  go to 60
        mptr = lstart(lev)
 50        itemp                = node(store1,mptr)
           node(store1,mptr)    = node(store2,mptr)
           node(store2,mptr)    = itemp
           rnode(timemult,mptr) = start_time
           mptr                 = node(levelptr,mptr)
           if (mptr .ne. 0) go to 50
       lev = lev + 1
       go to 40
 60   continue
c
c initial updating so can do conservation check. can do before
c bndry flux arrays set, since dont need them for this
c
      do 65 level = 1, lfine-1
         call update(lfine-level,nvar,naux)
 65   continue
c
c set up boundary flux conservation arrays
c
      do 70 level = 1, lfine-1
         call prepf(level+1,nvar,naux)
         call prepc(level,nvar)
 70   continue
c
      if (.not. varRefTime) go to 99   ! keep consistent with gfixup and filval

         do level = 1, lfine   ! compute max speed for all grids at each level
           spoh(level) = 0.d0 ! to keep track of max wave speed for all new grids
           mptr = lstart(level)
 75        continue
             loc    = node(store1,mptr)
             locaux = node(storeaux,mptr)
             nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
             ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
             mitot  = nx + 2*nghost
             mjtot  = ny + 2*nghost

             sp_over_h = get_max_speed(alloc(loc),mitot,mjtot,nvar,
     &                         alloc(locaux),naux,nghost,
     &                         hxposs(level),hyposs(level))
c            write(*,*)"max wave speed for level ",level," grid, ",mptr,
c    .        " is", sp_over_h
             spoh(level) = max(spoh(level),sp_over_h)
           mptr = node(levelptr,mptr)
           if (mptr .ne. 0) go to 75
         end do
c
c check that level 1 has a time step that doesnt exceed cfl based on wave speed just calculated
c
         dtc = possk(1)
         if (dtc*spoh(1) .gt. cflv1) then
              write(*,*)" coarse level time step too big: should reset"
              write(*,*) " dtc ", dtc," gives cfl = ",dtc*spoh(1)
         endif
c
c
c        # use smaller of specified dt_initial and estimate from get_max_speed
c        # (changed from 4.6 code where dt_initial was ignored)
         possk(1) = min(possk(1), cfl/(spoh(1) + tiny(1.d0)))  
         write(*,*)"  Setting initial dt to ",possk(1)

c
c  set new time step and refinement ratios in time
c  at this initial time just setting initial conditions
c  important to do this from coarser to finer levels to make sure 
c  subcycling lines up right.
c  this sets ratios, and possk array.  
c  note that code below does not change coarsest level time step,
c  this is set during timestepping or by user initially
c
      do level = 2, lfine   
         dtc = possk(level-1)
         dtf = cfl/(spoh(level) + tiny(1.d0))
         if (dtf .gt. dtc) then
            kratio(level-1) = 1  ! cant have larger timestep than parent level
            possk(level)    = dtc  ! cant have larger timestep than parent level
         else
            kratio(level-1) = ceiling(dtc/dtf)
            possk(level)    = possk(level-1)/kratio(level-1)
        endif
c       write(6,*)" setting ref. ratio in time for level ",level," to ",
c    .            kratio(level-1)
      end do
c
 99   continue
      return
      end

c
c -----------------------------------------------------
c
      subroutine valout (lst, lend, time, nvar, naux)
c
c     # Output the results for a general system of conservation laws
c     # in 3 dimensions
c
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw3.m
c
c     # set outaux = .true. to also output the aux arrays to fort.a<iframe>

      use amr_module
      implicit double precision (a-h,o-z)
      character*10  fname1, fname2, fname3, fname4, fname5

      logical outaux
      integer output_aux_num
      
      !for timing
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) cpu_start, cpu_finish


      iadd(ivar,i,j,k)   = loc     +    (ivar-1)
     &                             +    (i-1)*nvar
     &                             +    (j-1)*nvar*mitot
     &                             +    (k-1)*nvar*mitot*mjtot
      iaddaux(iaux,i,j,k) = locaux +    (iaux-1)
     &                             +    (i-1)*naux
     &                             +    (j-1)*naux*mitot
     &                             +    (k-1)*naux*mitot*mjtot
      
      !timing
      call system_clock(clock_start,clock_rate)
      call cpu_time(cpu_start)
      
      
      output_aux_num = 0
      do i = 1, naux
        output_aux_num = output_aux_num + output_aux_components(i)
      end do

c     # Currently outputs all aux components if any are requested!
      outaux = ((output_aux_num > 0) .and. 
     .         ((.not. output_aux_onlyonce) .or. (time==t0)))

c     open(unit=77,file='fort.b',status='unknown',access='stream')


c     ### Python graphics output
c
c        ###  make the file names and open output files
      fname1 = 'fort.qxxxx'
      fname2 = 'fort.txxxx'
      fname3 = 'fort.axxxx'
      fname4 = 'fort.bxxxx'
      matunit1 = 50
      matunit2 = 60
      matunit3 = 70
      matunit4 = 71
      nstp     = matlabu
      do 55 ipos = 10, 7, -1
         idigit = mod(nstp,10)
         fname1(ipos:ipos) = char(ichar('0') + idigit)
         fname2(ipos:ipos) = char(ichar('0') + idigit)
         fname3(ipos:ipos) = char(ichar('0') + idigit)
         fname4(ipos:ipos) = char(ichar('0') + idigit)
         nstp = nstp / 10
 55   continue

      open(unit=matunit1,file=fname1,status='unknown',
     .       form='formatted')

      if (output_format == 3) then
c         # binary output          
          open(unit=matunit4,file=fname4,status='unknown',
     &            access='stream')
          endif

      level = lst
      ngrids = 0
c65   if (level .gt. lfine) go to 90
 65   if (level .gt. lend) go to 90
         mptr = lstart(level)
 70      if (mptr .eq. 0) go to 80
           ngrids  = ngrids + 1
           nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
           ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
           nz      = node(ndkhi,mptr) - node(ndklo,mptr) + 1
           loc     = node(store1, mptr)
           locaux  = node(storeaux,mptr)
           mitot   = nx + 2*nghost
           mjtot   = ny + 2*nghost
           mktot   = nz + 2*nghost
           write(matunit1,1001) mptr, level, nx, ny, nz
 1001 format(i5,'                 grid_number',/,
     &       i5,'                 AMR_level',/,
     &       i5,'                 mx',/,
     &       i5,'                 my',/,
     &       i5,'                 mz')

           xlow = rnode(cornxlo,mptr)
           ylow = rnode(cornylo,mptr)
           zlow = rnode(cornzlo,mptr)
           write(matunit1,1002) xlow,ylow,zlow,hxposs(level),
     &           hyposs(level),hzposs(level)
 1002 format(e18.8,'    xlow', /,
     &       e18.8,'    ylow', /,
     &       e18.8,'    zlow', /,
     &       e18.8,'    dx', /,
     &       e18.8,'    dy', /,
     &       e18.8,'    dz',/)



         if (output_format == 1) then
            do 75 k = nghost+1, mktot-nghost
            do 76 j = nghost+1, mjtot-nghost
            do 77 i = nghost+1, mitot-nghost
            do ivar=1,nvar
               if (dabs(alloc(iadd(ivar,i,j,k))) < 1d-90) then
                  alloc(iadd(ivar,i,j,k)) = 0.d0
               endif
            enddo
            write(matunit1,109)
     &            (alloc(iadd(ivar,i,j,k)), ivar=1,nvar)
  109       format(50e26.16)
   77       continue
            write(matunit1,*) ' '
   76       continue
            write(matunit1,*) ' '
   75       continue
            write(matunit1,*) ' '
         endif

         if (output_format == 3) then
c            # binary output          
             i1 = iadd(1,1,1,1)
             i2 = iadd(nvar,mitot,mjtot,mktot)
c            # NOTE: we are writing out ghost cell data also, unlike ascii
             write(matunit4) alloc(i1:i2)
         endif


         mptr = node(levelptr, mptr)
         go to 70
   80 level = level + 1
      go to 65

   90 continue

c       -------------------
c       # output aux arrays
c       -------------------

      if (outaux) then
c        #  output aux array to fort.aXXXX

         level = lst
         ngrids = 0
 165     if (level .gt. lend) go to 190
            mptr = lstart(level)
 170        if (mptr .eq. 0) go to 180
              ngrids  = ngrids + 1
              nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
              ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
              nz      = node(ndkhi,mptr) - node(ndklo,mptr) + 1
              loc     = node(store1, mptr)
              locaux  = node(storeaux,mptr)
              mitot   = nx + 2*nghost
              mjtot   = ny + 2*nghost
              mktot   = nz + 2*nghost




             if (output_format == 1) then
                open(unit=matunit3,file=fname3,status='unknown',
     .               form='formatted')
                write(matunit3,1001) mptr,level,nx,ny,nz
                xlow = rnode(cornxlo,mptr)
                ylow = rnode(cornylo,mptr)
                zlow = rnode(cornzlo,mptr)
                write(matunit3,1002) xlow,ylow,zlow,hxposs(level),
     &                               hyposs(level),hzposs(level)

                do 175 k = nghost+1, mktot-nghost
                do 176 j = nghost+1, mjtot-nghost
                do 177 i = nghost+1, mitot-nghost
                do ivar=1,naux
                   if (dabs(alloc(iaddaux(ivar,i,j,k))) .lt. 1d-90) then
                            alloc(iaddaux(ivar,i,j,k)) = 0.d0
                   endif
                enddo
                write(matunit3,109)
     &               (alloc(iaddaux(ivar,i,j,k)), ivar=1,naux)
 177            continue
                write(matunit3,*) ' '
 176            continue
                write(matunit3,*) ' '
 175            continue
                write(matunit3,*) ' '
             endif

             if (output_format == 3) then
c            # binary output          
                open(unit=matunit3,file=fname3,status='unknown',
     &               access='stream')
                i1 = iaddaux(1,1,1,1)
                i2 = iaddaux(naux,mitot,mjtot,mktot)
c               # NOTE: we are writing out ghost cell data also, unlike ascii
                write(matunit3) alloc(i1:i2)
             endif

            mptr = node(levelptr, mptr)
            go to 170
  180 level = level + 1
      go to 165
      
  190 continue

      close(unit=matunit3)
      endif  !# end outputting aux array


c     --------------
c     # fort.t file:
c     --------------

      open(unit=matunit2,file=fname2,status='unknown',
     .       form='formatted')

      ndim = 3
c     # NOTE: we need to print out nghost too in order to strip
c     #       ghost cells from q when reading in pyclaw.io.binary
      write(matunit2,1000) time,nvar,ngrids,naux,ndim,nghost
 1000 format(e18.8,'    time', /,
     &       i5,'                 meqn'/,
     &       i5,'                 ngrids'/,
     &       i5,'                 naux'/,
     &       i5,'                 ndim'/,
     &       i5,'                 nghost'/,/)
c

      write(6,601) matlabu,time
  601 format('AMRCLAW: Frame ',i4,
     &       ' output files done at time t = ', d13.6,/)

      matlabu = matlabu + 1

      close(unit=matunit1)
      close(unit=matunit2)
      if (output_format == 3) then
          close(unit=matunit4)
          endif

      call system_clock(clock_finish,clock_rate)
      call cpu_time(cpu_finish)
      timeValout = timeValout + clock_finish - clock_start
      timeValoutCPU = timeValoutCPU + cpu_finish - cpu_start

      return
      end

! =========================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =========================================================

! solve Riemann problems for the 1D Euler equations using Roe's
! approximate Riemann solver.

! waves: 3
! equations: 3

! Conserved quantities:
!       1 density
!       2 momentum
!       3 energy

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q

! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routine step1, rp is called with ql = qr = q.


    implicit double precision (a-h,o-z)
    dimension   ql(meqn,1-mbc:maxmx+mbc)
    dimension   qr(meqn,1-mbc:maxmx+mbc)
    dimension    s(mwaves,1-mbc:maxmx+mbc)
    dimension wave(meqn, mwaves,1-mbc:maxmx+mbc)
    dimension amdq(meqn,1-mbc:maxmx+mbc)
    dimension apdq(meqn,1-mbc:maxmx+mbc)

!     # local storage
!     ---------------
    dimension delta(3)
    dimension u(1-mbc:maxmx+mbc),enth(1-mbc:maxmx+mbc)
    dimension a(1-mbc:maxmx+mbc)
    logical :: efix
    common /cparam/  gamma

    data efix /.true./    !# use entropy fix for transonic rarefactions

    gamma1 = gamma - 1.d0

!     # Compute Roe-averaged quantities:

    do 20 i=2-mbc,mx+mbc
        rhsqrtl = dsqrt(qr(1,i-1))
        rhsqrtr = dsqrt(ql(1,i))
        pl = gamma1*(qr(3,i-1) - 0.5d0*(qr(2,i-1)**2)/qr(1,i-1))
        pr = gamma1*(ql(3,i) - 0.5d0*(ql(2,i)**2)/ql(1,i))
        rhsq2 = rhsqrtl + rhsqrtr
        u(i) = (qr(2,i-1)/rhsqrtl + ql(2,i)/rhsqrtr) / rhsq2
        enth(i) = (((qr(3,i-1)+pl)/rhsqrtl &
        + (ql(3,i)+pr)/rhsqrtr)) / rhsq2
        a2 = gamma1*(enth(i) - .5d0*u(i)**2)
        a(i) = dsqrt(a2)
    20 END DO


    do 30 i=2-mbc,mx+mbc
    
    !        # find a1 thru a3, the coefficients of the 3 eigenvectors:
    
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(2,i) - qr(2,i-1)
        delta(3) = ql(3,i) - qr(3,i-1)
        a2 = gamma1/a(i)**2 * ((enth(i)-u(i)**2)*delta(1) &
        + u(i)*delta(2) - delta(3))
        a3 = (delta(2) + (a(i)-u(i))*delta(1) - a(i)*a2) / (2.d0*a(i))
        a1 = delta(1) - a2 - a3
    
    !        # Compute the waves.
    
        wave(1,1,i) = a1
        wave(2,1,i) = a1*(u(i)-a(i))
        wave(3,1,i) = a1*(enth(i) - u(i)*a(i))
        s(1,i) = u(i)-a(i)
    
        wave(1,2,i) = a2
        wave(2,2,i) = a2*u(i)
        wave(3,2,i) = a2*0.5d0*u(i)**2
        s(2,i) = u(i)
    
        wave(1,3,i) = a3
        wave(2,3,i) = a3*(u(i)+a(i))
        wave(3,3,i) = a3*(enth(i)+u(i)*a(i))
        s(3,i) = u(i)+a(i)
    30 END DO

!     # compute Godunov flux f0:
!     --------------------------


    if (efix) go to 110

!     # no entropy fix
!     ----------------

!     # amdq = SUM s*wave   over left-going waves
!     # apdq = SUM s*wave   over right-going waves

    do m=1,3
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1,mwaves
                if (s(mw,i) < 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                else
                    apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                endif
            end do
        end do
    end do
    go to 900

!-----------------------------------------------------

    110 continue

!     # With entropy fix
!     ------------------

!    # compute flux differences amdq and apdq.
!    # First compute amdq as sum of s*wave for left going waves.
!    # Incorporate entropy fix by adding a modified fraction of wave
!    # if s should change sign.

    do 200 i=2-mbc,mx+mbc
    
    !        # check 1-wave:
    !        ---------------
    
        rhoim1 = qr(1,i-1)
        pim1 = gamma1*(qr(3,i-1) - 0.5d0*qr(2,i-1)**2 / rhoim1)
        cim1 = dsqrt(gamma*pim1/rhoim1)
        s0 = qr(2,i-1)/rhoim1 - cim1     !# u-c in left state (cell i-1)

    !        # check for fully supersonic case:
        if (s0 >= 0.d0 .AND. s(1,i) > 0.d0)  then
        !            # everything is right-going
            do 60 m=1,3
                amdq(m,i) = 0.d0
            60 END DO
            go to 200
        endif
    
        rho1 = qr(1,i-1) + wave(1,1,i)
        rhou1 = qr(2,i-1) + wave(2,1,i)
        en1 = qr(3,i-1) + wave(3,1,i)
        p1 = gamma1*(en1 - 0.5d0*rhou1**2/rho1)
        c1 = dsqrt(gamma*p1/rho1)
        s1 = rhou1/rho1 - c1  !# u-c to right of 1-wave
        if (s0 < 0.d0 .AND. s1 > 0.d0) then
        !            # transonic rarefaction in the 1-wave
            sfract = s0 * (s1-s(1,i)) / (s1-s0)
        else if (s(1,i) < 0.d0) then
        !            # 1-wave is leftgoing
            sfract = s(1,i)
        else
        !            # 1-wave is rightgoing
            sfract = 0.d0   !# this shouldn't happen since s0 < 0
        endif
        do 120 m=1,3
            amdq(m,i) = sfract*wave(m,1,i)
        120 END DO
    
    !        # check 2-wave:
    !        ---------------
    
        if (s(2,i) >= 0.d0) go to 200  !# 2-wave is rightgoing
        do 140 m=1,3
            amdq(m,i) = amdq(m,i) + s(2,i)*wave(m,2,i)
        140 END DO
    
    !        # check 3-wave:
    !        ---------------
    
        rhoi = ql(1,i)
        pi = gamma1*(ql(3,i) - 0.5d0*ql(2,i)**2 / rhoi)
        ci = dsqrt(gamma*pi/rhoi)
        s3 = ql(2,i)/rhoi + ci     !# u+c in right state  (cell i)
    
        rho2 = ql(1,i) - wave(1,3,i)
        rhou2 = ql(2,i) - wave(2,3,i)
        en2 = ql(3,i) - wave(3,3,i)
        p2 = gamma1*(en2 - 0.5d0*rhou2**2/rho2)
        c2 = dsqrt(gamma*p2/rho2)
        s2 = rhou2/rho2 + c2   !# u+c to left of 3-wave
        if (s2 < 0.d0 .AND. s3 > 0.d0) then
        !            # transonic rarefaction in the 3-wave
            sfract = s2 * (s3-s(3,i)) / (s3-s2)
        else if (s(3,i) < 0.d0) then
        !            # 3-wave is leftgoing
            sfract = s(3,i)
        else
        !            # 3-wave is rightgoing
            go to 200
        endif
    
        do 160 m=1,3
            amdq(m,i) = amdq(m,i) + sfract*wave(m,3,i)
        160 END DO
    200 END DO

!     # compute the rightgoing flux differences:
!     # df = SUM s*wave   is the total flux difference and apdq = df - amdq

    do m=1,3
        do i = 2-mbc, mx+mbc
            df = 0.d0
            do mw=1,mwaves
                df = df + s(mw,i)*wave(m,mw,i)
            end do
            apdq(m,i) = df - amdq(m,i)
        end do
    end do


    900 continue
    return
    end subroutine rp1

!
!
!     =====================================================
      subroutine evec(ixy,maxm,num_eqn,num_ghost,mx,q,auxl,auxr,evl,evr)
!     =====================================================
!
!     # Calculation of left and right eigenvectors
!     # dummy file
!
      implicit double precision (a-h,o-z)
!
      write(*,*) 'Error: subroutine evec() has not been provided'
      stop
      return
      end

c     ==================
      subroutine setprob
c     ==================

      implicit double precision (a-h,o-z)
      character*12 fname
      common /cparam/  gamma, gamma1
c
c
      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)

c
       read(7,*) gamma
       read(7,*) gamma1

      return
      end

c
c -------------------------------------------------------------
c
       subroutine qad(valbig,mitot,mjtot,mktot,nvar,
     .                svdflx,qc1d,lenbc,lratiox,lratioy,lratioz,
     .                hx,hy,hz,maux,aux,auxc1d,delt,mptr)

      use amr_module
      implicit double precision (a-h, o-z)


      logical qprint

      dimension valbig(nvar,mitot,mjtot,mktot)
      dimension qc1d(nvar,lenbc)
      dimension svdflx(nvar,lenbc)
      dimension aux(maux,mitot,mjtot,mktot)
      dimension auxc1d(maux,lenbc)

c
c ::::::::::::::::::::::::::: QAD ::::::::::::::::::::::::::::::::::
c  solve RP between ghost cell value on fine grid and coarse grid
c  value that ghost cell overlaps. The resulting fluctuations
c  are added in to coarse grid value, as a conservation fixup.
c  Done each fine grid time step. If source terms are present, the
c  coarse grid value is advanced by source terms each fine time step too.

c Side 1 is the left   side of the fine grid patch.   i = min
c Side 2 is the rear   side of the fine grid patch.   j = max
c Side 3 is the right  side of the fine grid patch.   i = max
c Side 4 is the front  side of the fine grid patch.   j = min
c Side 5 is the bottom side of the fine grid patch.   k = min
c Side 6 is the top    side of the fine grid patch.   k = max
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c      # local storage
c      # note that dimension here are bigger than dimensions used
c      # in rp2, but shouldnt matter since wave is not used in qad
c      # and for other arrays it is only the last parameter that is wrong
c      #  ok as long as meqn, mwaves < maxvar

       integer max1dp1 
       dimension ql(nvar,max1d+1),    qr(nvar,max1d+1)
       dimension wave(nvar,mwaves,max1d+1), s(mwaves,max1d+1)
       dimension amdq(nvar,max1d+1),  apdq(nvar,max1d+1)
       dimension auxl(maux,max1d+1),  auxr(maux,max1d+1)

       data qprint/.false./
c
c      aux is auxiliary array with user parameters needed in Riemann solvers
c          on fine grid corresponding to valbig
c      auxc1d is coarse grid stuff from around boundary, same format as qc1d
c      auxl, auxr are work arrays needed to pass stuff to rpn2
c      maux is the number of aux variables, which may be zero.
c
c      nr, nc, nf are the number of rows, columns, files
c

       max1dp1 = max1d + 1

       if (qprint) write(dbugunit,*)" working on grid ",mptr
       tgrid = rnode(timemult, mptr)
       nf = mktot-2*nghost
       nc = mjtot-2*nghost
       nr = mitot-2*nghost

       ncrsek = (mktot-2*nghost)/lratioz
       ncrsej = (mjtot-2*nghost)/lratioy
       ncrsei = (mitot-2*nghost)/lratiox
c
c--------
c  side 1
c--------
c
      index0  = 0
      influx0 = 0
      do 199 k = nghost+1, mktot-nghost
      kc     = 1 + (k  -(nghost+1))/lratioz
      kcnext = 1 + (k+1-(nghost+1))/lratioz
      indaux = 1
      do 10 j = nghost+1, mjtot-nghost
      indaux = indaux + 1
      if (maux.gt.0) then
         do 5 ma = 1,maux
            if (auxtype(ma).eq."xleft") then
c               # Assuming velocity at left-face, this fix
c               # preserves conservation in incompressible flow:
                auxl(ma,indaux) = aux(ma,nghost+1,j,k)
            else
c               # Normal case -- we set the aux arrays
c               # from the cell corresponding  to q
                auxl(ma,indaux) = aux(ma,nghost,j,k)
            endif
    5    continue
      endif
      do 10 ivar = 1, nvar
         ql(ivar,indaux) = valbig(ivar,nghost,j,k)
   10 continue

      lind  = 0
      index = index0
      do 22 jc = 1, ncrsej
        index = index + 1
        do 23 l = 1, lratioy
          lind = lind + 1
          if (maux.gt.0) then
            do 24 ma=1,maux
              auxr(ma,lind) = auxc1d(ma,index)
   24       continue
          endif
          do 25 ivar = 1, nvar
            qr(ivar,lind) = qc1d(ivar,index)
   25     continue
   23   continue
   22 continue
      if (kcnext .ne. kc) index0 = index

       if (qprint) then
         write(dbugunit,*) 'side 1, ql and qr:'
         do i=2,nc
        write(dbugunit,4101) i,qr(1,i-1),ql(1,i),auxr(1,i-1),auxl(1,i)
          enddo
 4101      format(i3,4e16.6)
       endif

       call rpn3(1,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nc+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 1 add into sdflxm
c
      kfine   = (kc-1)*lratioz
      influx  = influx0
      do 50 j = 1, nc/lratioy
         influx  = influx + 1
         jfine   = (j-1)*lratioy
*        indexa  = (kfine+m-1)*nc + jfine + 1
         indexa  =                  jfine + 1
         do 60 ivar = 1, nvar
            do 70 l = 1, lratioy
               svdflx(ivar,influx) = svdflx(ivar,influx)
     .                       + amdq(ivar,indexa+l) * hy * hz * delt
     .                       + apdq(ivar,indexa+l) * hy * hz * delt
   70       continue
   60    continue
   50 continue
      if (kcnext .ne. kc) influx0 = influx

  199 continue

c--------
c  side 2
c--------
c
      do 299 k = nghost+1, mktot-nghost
      kc     = 1 + (k  -(nghost+1))/lratioz
      kcnext = 1 + (k+1-(nghost+1))/lratioz
      indaux = 0
      do 210 i = nghost+1, mitot-nghost
      indaux = indaux + 1
      if (maux.gt.0) then
         do 205 ma = 1,maux
            auxr(ma,indaux) = aux(ma,i,mjtot-nghost+1,k)
  205    continue
      endif
      do 210 ivar = 1, nvar
         qr(ivar,indaux) = valbig(ivar,i,mjtot-nghost+1,k)
  210 continue

      lind  = 0
      index = index0
      do 222 ic = 1, ncrsei
        index = index + 1
        do 223 l = 1, lratiox
          lind = lind + 1
          if (maux.gt.0) then
            do 224 ma=1,maux
              if (auxtype(ma).eq."yleft") then
c                 # Assuming velocity at rear-face, this fix
c                 # preserves conservation in incompressible flow:
                  kfine           = (kc-1)*lratioz + nghost + l
                  ifine           = (ic-1)*lratiox + nghost + l
                  auxl(ma,lind+1) = aux(ma,ifine,mjtot-nghost+1,kfine)
              else
                  auxl(ma,lind+1) = auxc1d(ma,index)
              endif
  224       continue
          endif
          do 225 ivar = 1, nvar
            ql(ivar,lind+1) = qc1d(ivar,index)
  225     continue
  223   continue
  222 continue
      if (kcnext .ne. kc) index0 = index

       if (qprint) then
         write(dbugunit,*) 'side 2, ql and qr:'
         do i=2,nr
      write(dbugunit,4101) i,qr(1,i-1),ql(1,i),auxr(1,i-1),auxl(1,i)
            enddo
       endif

       call rpn3(2,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 2. add into sdflxp
c
      kfine   = (kc-1)*lratioz
      influx  = influx0
      do 250 i = 1, nr/lratiox
         influx  = influx + 1
         ifine   = (i-1)*lratiox
*        indexa  = (kfine+m-1)*nc + ifine + 1
         indexa  =                  ifine + 1
         do 260 ivar = 1, nvar
            do 270 l = 1, lratiox
               svdflx(ivar,influx) = svdflx(ivar,influx)
     .                       - amdq(ivar,indexa+l) * hx * hz * delt
     .                       - apdq(ivar,indexa+l) * hx * hz * delt
  270       continue
  260    continue
  250 continue
      if (kcnext .ne. kc) influx0 = influx

  299 continue

c--------
c  side 3
c--------
c
      do 399 k = nghost+1, mktot-nghost
      kc     = 1 + (k  -(nghost+1))/lratioz
      kcnext = 1 + (k+1-(nghost+1))/lratioz
      indaux = 0
      do 310 j = nghost+1, mjtot-nghost
      indaux = indaux + 1
      if (maux.gt.0) then
         do 305 ma = 1,maux
            auxr(ma,indaux) = aux(ma,mitot-nghost+1,j,k)
  305    continue
      endif
      do 310 ivar = 1, nvar
         qr(ivar,indaux) = valbig(ivar,mitot-nghost+1,j,k)
  310 continue

      lind  = 0
      index = index0
      do 322 jc = 1, ncrsej
        index = index + 1
        do 323 l = 1, lratioy
          lind = lind + 1
          if (maux.gt.0) then
            do 324 ma=1,maux
              if (auxtype(ma).eq."xleft") then
c               # Assuming velocity at left-face, this fix
c               # preserves conservation in incompressible flow:
                kfine           = (kc-1)*lratioz + nghost + l
                jfine           = (jc-1)*lratioy + nghost + l
                auxl(ma,lind+1) = aux(ma,mitot-nghost+1,jfine,kfine)
              else
                auxl(ma,lind+1) = auxc1d(ma,index)
              endif
  324       continue
          endif
          do 325 ivar = 1, nvar
             ql(ivar,lind+1) = qc1d(ivar,index)
  325     continue
  323   continue
  322 continue
      if (kcnext .ne. kc) index0 = index

       if (qprint) then
         write(dbugunit,*) 'side 3, ql and qr:'
         do i=2,nc
      write(dbugunit,4101) i,qr(1,i-1),ql(1,i),auxr(1,i-1),auxl(1,i)
            enddo
       endif

       call rpn3(1,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .           nc+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 3 add into sdflxp
C
      kfine   = (kc-1)*lratioz
      influx = influx0
      do 350 j = 1, nc/lratioy
         influx  = influx + 1
         jfine   = (j-1)*lratioy
*        indexa  = (kfine+m-1)*nc + jfine + 1
         indexa  =                  jfine + 1
         do 360 ivar = 1, nvar
            do 370 l = 1, lratioy
               svdflx(ivar,influx) = svdflx(ivar,influx)
     .                       - amdq(ivar,indexa+l) * hy * hz * delt
     .                       - apdq(ivar,indexa+l) * hy * hz * delt
  370       continue
  360    continue
  350 continue
      if (kcnext .ne. kc) influx0 = influx

  399 continue

c--------
c  side 4
c--------
c
      do 499 k = nghost+1, mktot-nghost
      kc     = 1 + (k  -(nghost+1))/lratioz
      kcnext = 1 + (k+1-(nghost+1))/lratioz
      indaux = 1
      do 410 i = nghost+1, mitot-nghost
      indaux = indaux + 1
      if (maux.gt.0) then
         do 405 ma = 1,maux
            if (auxtype(ma).eq."yleft") then
c               # Assuming velocity at rear-face, this fix
c               # preserves conservation in incompressible flow:
                auxl(ma,indaux) = aux(ma,i,nghost+1,k)
            else
                auxl(ma,indaux) = aux(ma,i,nghost,k)
            endif
  405    continue
      endif
      do 410 ivar = 1, nvar
         ql(ivar,indaux) = valbig(ivar,i,nghost,k)
  410 continue

      lind  = 0
      index = index0
      do 422 ic = 1, ncrsei
        index = index + 1
        do 423 l = 1, lratiox
          lind = lind + 1
          if (maux.gt.0) then
            do 424 ma=1,maux
              auxr(ma,lind) = auxc1d(ma,index)
  424       continue
          endif
          do 425 ivar = 1, nvar
            qr(ivar,lind) = qc1d(ivar,index)
  425     continue
  423   continue
  422 continue
      if (kcnext .ne. kc) index0 = index

       if (qprint) then
         write(dbugunit,*) 'side 4, ql and qr:'
         do i=2,nr
      write(dbugunit,4101) i,qr(1,i-1),ql(1,i),auxr(1,i-1),auxl(1,i)
            enddo
       endif

       call rpn3(2,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .         nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 4. add into sdflxm
c
      kfine   = (kc-1)*lratioz
      influx  = influx0
      do 450 i = 1, nr/lratiox
         influx  = influx + 1
         ifine   = (i-1)*lratiox
*        indexa  = (kfine+m-1)*nc + ifine + 1
         indexa  =                  ifine + 1
         do 460 ivar = 1, nvar
            do 470 l = 1, lratiox
               svdflx(ivar,influx) = svdflx(ivar,influx)
     .                       + amdq(ivar,indexa+l) * hx * hz * delt
     .                       + apdq(ivar,indexa+l) * hx * hz * delt
  470       continue
  460    continue
  450 continue
      if (kcnext .ne. kc) influx0 = influx

  499 continue

c--------
c  side 5
c--------
c
      do 599 j = nghost+1, mjtot-nghost
      jc     = 1 + (j  -(nghost+1))/lratioy
      jcnext = 1 + (j+1-(nghost+1))/lratioy
      indaux = 1
      do 510 i = nghost+1, mitot-nghost
      indaux = indaux + 1
      if (maux.gt.0) then
         do 505 ma = 1,maux
            if (auxtype(ma).eq."zleft") then
c               # Assuming velocity at bottom-face, this fix
c               # preserves conservation in incompressible flow:
                auxl(ma,indaux) = aux(ma,i,j,nghost+1)
            else
c               # Normal case -- we set the aux arrays
c               # from the cell corresponding  to q
                auxl(ma,indaux) = aux(ma,i,j,nghost)
            endif
  505       continue
      endif
      do 510 ivar = 1, nvar
         ql(ivar,indaux) = valbig(ivar,i,j,nghost)
  510 continue

      lind  = 0
      index = index0
      do 522 ic = 1, ncrsei
        index = index + 1
        do 523 l = 1, lratiox
          lind = lind + 1
          if (maux.gt.0) then
            do 524 ma=1,maux
              auxr(ma,lind) = auxc1d(ma,index)
  524       continue
          endif
          do 525 ivar = 1, nvar
            qr(ivar,lind) = qc1d(ivar,index)
  525     continue
  523   continue
  522 continue
      if (jcnext .ne. jc) index0 = index

       if (qprint) then
         write(dbugunit,*) 'side 5, ql and qr:'
         do i=2,nc
       write(dbugunit,4101) i,qr(1,i-1),ql(1,i),auxr(1,i-1),auxl(1,i)
          enddo
       endif

       call rpn3(3,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .         nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 5 add into sdflxm
c
      jfine   = (jc-1)*lratioy
      influx  = influx0
      do 550 i = 1, nr/lratiox
         influx  = influx + 1
         ifine   = (i-1)*lratiox
*        indexa  = (jfine+m-1)*nr + ifine + 1
         indexa  =                  ifine + 1
         do 560 ivar = 1, nvar
            do 570 l = 1, lratiox
               svdflx(ivar,influx) = svdflx(ivar,influx)
     .                       + amdq(ivar,indexa+l) * hx * hy * delt
     .                       + apdq(ivar,indexa+l) * hx * hy * delt
  570       continue
  560    continue
  550 continue
      if (jcnext .ne. jc) influx0 = influx

  599 continue

c--------
c  side 6
c--------
c
      do 699 j = nghost+1, mjtot-nghost
      jc     = 1 + (j  -(nghost+1))/lratioy
      jcnext = 1 + (j+1-(nghost+1))/lratioy
      indaux = 0
      do 610 i = nghost+1, mitot-nghost
      indaux = indaux + 1
      if (maux.gt.0) then
         do 605 ma = 1,maux
            auxr(ma,indaux) = aux(ma,i,j,mktot-nghost+1)
  605    continue
      endif
      do 610 ivar = 1, nvar
         qr(ivar,indaux) = valbig(ivar,i,j,mktot-nghost+1)
  610 continue

      lind   = 0
      index = index0
      do 622 ic = 1, ncrsei
        index = index + 1
        do 623 l = 1, lratiox
          lind = lind + 1
          if (maux.gt.0) then
            do 624 ma=1,maux
              if (auxtype(ma).eq."zleft") then
c                 # Assuming velocity at bottom-face, this fix
c                 # preserves conservation in incompressible flow:
                  jfine = (jc-1)*lratioy + nghost + l
                  ifine = (ic-1)*lratiox + nghost + l
                  auxl(ma,lind+1) = aux(ma,ifine,jfine,mktot-nghost+1)
              else
                  auxl(ma,lind+1) = auxc1d(ma,index)
              endif
  624       continue
          endif
          do 625 ivar = 1, nvar
            ql(ivar,lind+1) = qc1d(ivar,index)
  625     continue
  623   continue
  622 continue
      if (jcnext .ne. jc) index0 = index

       if (qprint) then
         write(dbugunit,*) 'side 6, ql and qr:'
         do i=2,nr
       write(dbugunit,4101) i,qr(1,i-1),ql(1,i),auxr(1,i-1),auxl(1,i)
            enddo
       endif

       call rpn3(3,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .         nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 6 add into sdflxp
C
      jfine   = (jc-1)*lratioy
      influx = influx0
      do 650 i = 1, nr/lratiox
         influx  = influx + 1
         ifine   = (i-1)*lratiox
*        indexa  = (jfine+m-1)*nr + ifine + 1
         indexa  =                  ifine + 1
         do 660 ivar = 1, nvar
            do 670 l = 1, lratiox
               svdflx(ivar,influx) = svdflx(ivar,influx)
     .                       - amdq(ivar,indexa+l) * hx * hy * delt
     .                       - apdq(ivar,indexa+l) * hx * hy * delt
  670       continue
  660    continue
  650 continue
      if (jcnext .ne. jc) influx0 = influx

  699 continue

c      # for source terms:
       if (method(5) .ne. 0) then
c          call src3(qc1d,lenbc,1,nvar,auxc1d,maux,tgrid,delt)
           call src1d(nvar,nghost,lenbc,qc1d,maux,auxc1d,tgrid,delt)
       endif

       return
       end

module rp1_advection
  use iso_c_binding
  implicit none

  type :: advection_context
     real(c_double) :: u
  end type advection_context

contains

  subroutine new(u, context) bind(C, name='rp1_advection_new')
    real(c_double), intent(in)       :: u
    type(c_ptr), intent(out)         :: context

    type(advection_context), pointer :: param

    allocate(param)
    param%u = u
    context = c_loc(param)
  end subroutine new

  subroutine delete(context) bind(C, name='rp1_advection_delete')
    type(c_ptr), intent(in)          :: context

    type(advection_context), pointer :: param

    call c_f_pointer(context, param)
    deallocate(param)
  end subroutine delete

  ! only 1 wave, no need for an mwave parameter
  ! only 1 equation, no need for an meqn parameter

  subroutine advection(mx, mbc, ql, qr, s, wave, amdq, apdq, context) &
       bind(C, name='rp1_advection_c')
    ! C interfacable version of Riemann solver for advection
    !
    !
    ! inputs
    ! * ql  - data at left edge of each cell
    ! * qr  - data at right edge of each cell
    ! * mx  - number of physical grid points
    ! * mbc - number of boundary layer grid points
    ! outputs
    ! * s
    ! * wave
    ! * amdq
    ! * apdq
    ! context
    ! * u - constant advection speed
    !

    ! Solve Riemann problems for the 1D advection equation q_t + u*q_x = 0.
    ! for constant advection velocity u, passed in common block.
    !
    ! The advection speed u is passed in the derived type solver data
    ! On input, ql contains the state vector at the left edge of each cell
    !           qr contains the state vector at the right edge of each cell
    ! On output, wave contains the waves,
    !            s the speeds,
    !            amdq the  left-going flux difference  A^- \Delta q
    !            apdq the right-going flux difference  A^+ \Delta q
    !
    ! Note that the i'th Riemann problem has left state qr(i-1,:) and
    !                                    right state ql(i,:) From the
    !                                    basic clawpack routine step1, rp
    !                                    is called with ql = qr = q.

    integer(c_int), intent(in), value :: mx, mbc
    real(c_double), intent(in) :: &
         ql(1, 1-mbc:mx+mbc), &
         qr(1, 1-mbc:mx+mbc)
    type(c_ptr), intent(in), value :: context

    real(c_double), intent(out) :: &
         s(1, 1-mbc:mx+mbc), &
         wave(1, 1, 1-mbc:mx+mbc), &
         apdq(1, 1-mbc:mx+mbc), &
         amdq(1, 1-mbc:mx+mbc)

    type(advection_context), pointer :: param
    real(c_double) :: u
    integer :: i

    call c_f_pointer(context, param)
    u = param%u

    do i=2-mbc,mx+mbc
       ! Compute the wave
       wave(1,1,i) = ql(1,i) - qr(1,i-1)

       ! Speeds are all the same
       s(1,i) = u

       ! Set fluctuations
       amdq(1,i) = dmin1(u, 0.d0) * wave(1,1,i)
       apdq(1,i) = dmax1(u, 0.d0) * wave(1,1,i)
    end do

  end subroutine advection

end module rp1_advection

! ::::::::::::::::::::: flagregions ::::::::::::::::::::::::::::::::::
!
! Modify array of flagged points to respect minlevels and maxlevels
! specified by regions.
!
! Second version with outer loop on regions, should be faster.
!
! amrflags  = array to be flagged with either the value
!             DONTFLAG (no refinement needed)  or
!             DOFLAG   (refinement desired)    
!
! This routine may change flags only in cells that are (partially)
! covered by one or more regions. amrflags will be later modified
! by Richardson extrapolation and/or flag2refine routine, as requested,
! which will only add DOFLAG points to cells that are still UNSET
!
! If any part of a grid cell is covered by one or more regions, then
! refinement is *required* to at least the max of all region min_levels
! and is *allowed* to at most to the max of all region max_levels.
!
! Note that buffering is done *after* this, so additional cells may
! be refined in areas covered by regions that do not allow it!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

subroutine flagregions1(mx,mbuff,xlower,dx,level,t, &
                            amrflags)

    use regions_module
    use amr_module, only : DOFLAG, UNSET, DONTFLAG

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,level,mbuff
    real(kind=8), intent(in) :: xlower,dx,t
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbuff:mx+mbuff)
    
    ! Locals
    integer :: i,m,i1,i2
    real(kind=8) :: x_low,x_hi, xupper
    integer, allocatable :: minlevel(:), maxlevel(:)

    allocate(minlevel(mx), maxlevel(mx))
    
    minlevel = 0
    maxlevel = 0

    xupper = xlower + mx*dx

    rloop: do m=1,num_regions
        if (t < regions(m)%t_low .or. t > regions(m)%t_hi) then
            cycle rloop  ! no intersection
        endif
        
        if (xlower >= regions(m)%x_hi .or. xupper <= regions(m)%x_low) then
            cycle rloop  ! no intersection
        else
            i1 = max(floor((regions(m)%x_low - xlower) / dx) + 1, 1)
            i2 = min(floor((regions(m)%x_hi -xlower) / dx) + 1, mx)
        endif

        do i=i1,i2
            minlevel(i) = max(minlevel(i), regions(m)%min_level)
            maxlevel(i) = max(maxlevel(i), regions(m)%max_level)
        enddo
    enddo rloop

    do i=1,mx
        if (minlevel(i) > maxlevel(i)) then
            write(6,*) '*** Error: this should never happen!'
            write(6,*) '*** minlevel > maxlevel in flagregions'
            stop
        endif

        if (maxlevel(i) /= 0) then
            ! this point lies in at least one region, so may need
            ! to modify the exisiting flag at this point...
            if (level < minlevel(i)) then
                ! Require refinement of this cell:
                amrflags(i) = DOFLAG
            else if (level >= maxlevel(i)) then
                ! Do not refine of this cell:
                amrflags(i) = DONTFLAG
            ! else leave amrflags(i) alone.
            endif
        endif

    enddo

end subroutine flagregions1

module fgmax_module

    use amr_module, only: mxnest
    implicit none
    save


    type fgrid

        ! Derived data type for a single fixed grid.
        ! An array of objects of this type is used to keep track of all
        ! fixed grids in a computation.

        ! identifier number for this fixed grid:
        integer :: fgno ! now used in fgmax_grids.data
        
        integer :: point_style

        ! fixed grid points are (x(k),y(k)), for k=1:npts
        integer :: npts
        real(kind=8), allocatable, dimension(:) :: x,y

        ! arrays valuemax(mv,k), tmax(mv,k), arrival_time(k), aux(level,ma,k)
        ! where mv = 1:num_values  # number of quantities monitored
        !       ma = 1:num_aux
        !        k = 1:npts
        ! New faster version uses klist(1:npts, 0:maxthreads-1)
        !     to select which points overlap each patch, and
        !     t_last_updated(1:mxnest), by level rather than point.
        ! Allocation is done in fgmax_read.
        real(kind=8), allocatable, dimension(:,:,:) :: aux
        real(kind=8), allocatable, dimension(:,:) :: valuemax
        real(kind=8), allocatable, dimension(:,:) :: tmax
        real(kind=8), allocatable, dimension(:) :: t_last_updated
        real(kind=8), allocatable, dimension(:) :: arrival_time
        integer, allocatable, dimension(:) :: levelmax
        integer, allocatable, dimension(:,:) :: klist

        ! time range to monitor:
        real(kind=8) :: tstart_max, tend_max

        ! Desired maximum delta t between updating valuemax:
        ! Will only update at start of time step if end of timestep is
        ! to far beyond last update time
        real(kind=8) :: dt_check

        ! Mininum level to check when updating valuemax or arrival times:
        ! Coarser levels will be ignored to avoid bad data from coarse grids
        integer :: min_level_check
        
        ! Mininum value of levelmax over the grid
        ! Set once each step on each level in advanc to avoid repeated minval's
        integer :: min_levelmax_checked

        ! Tolerance for flagging point for arrival of tsunami.
        ! Flag in fgmax_frompatch if eta tilde > sea_level + arrival_tol
        real(kind=8) :: arrival_tol


        ! Coordinates of corners of bounding box.
        ! This will be useful when generalizing to fgrids not aligned with x-y.
        real(kind=8) :: x1bb,x2bb,y1bb,y2bb

        ! keep track of whether all aux arrays have been computed on a given level:
        logical, allocatable, dimension(:) :: auxdone
        
        ! indicate if it is time to update a level:
        logical, allocatable, dimension(:) :: update_now

        ! new attributes for fgmax masked grids
        real(kind=8) :: xll,yll,xhi,yhi,dx,dy
        integer :: nx,ny
        integer, allocatable, dimension(:,:) :: index
        
        ! interp_method = 0 for pw constant, 1 for bilinear:
        integer :: interp_method
        
    end type

    logical, private :: module_setup = .false.

    ! declare array fgrids of fixed grids, each of type fgrid.
    ! allow them to be targets of pointers for shorthand in code.
    integer, parameter :: FG_MAXNUM_FGRIDS = 50  ! max number of fixed grids
    type(fgrid), target :: FG_fgrids(FG_MAXNUM_FGRIDS)

    ! special value to flag unset portions of arrays:
    real(kind=8), parameter :: FG_NOTSET = -0.99999d99

    ! unit to use for reading input data and writing fgrid results:
    integer, parameter :: FG_UNIT = 45

    ! number of max vals to monitor: Set in set_fgmax
    integer :: FG_NUM_VAL   
    ! number of aux vals to monitor
    integer, parameter :: FG_NUM_AUX = 1

    ! number of fixed grids in use (set by fgmax_read):
    integer :: FG_num_fgrids

    ! turn on debugging output to fort.61:
    logical, parameter :: FG_DEBUG = .false.


contains

    subroutine set_fgmax(fname)

        use amr_module, only: parmunit

        implicit none
        
        ! Subroutine arguments
        character(len=*), intent(in), optional :: fname
        
        ! Local storage
        integer, parameter :: unit = 7
        integer :: ifg
        character(len=150) :: fname_fg
        integer :: num_fgmax_grids, num_fgmax_val

        if (.not.module_setup) then

            write(parmunit,*) ' '
            write(parmunit,*) '--------------------------------------------'
            write(parmunit,*) 'SETFGMAX:'
            write(parmunit,*) '-----------'

            ! Open data file
            if (present(fname)) then
                call opendatafile(unit, fname)
            else
                call opendatafile(unit, 'fgmax_grids.data')
            endif

            ! Read in data
            read(unit,'(i2)') num_fgmax_val   ! name used in setrun.py
            FG_NUM_VAL = num_fgmax_val        ! module variable name
            read(unit,'(i2)') num_fgmax_grids ! name used in setrun.py
            FG_num_fgrids = num_fgmax_grids   ! module variable name
            
            if (FG_num_fgrids > FG_MAXNUM_FGRIDS) then
               write(6,601) FG_num_fgrids
     601       format('*** Too many fixed grids specified: FG_num_fgrids = ',i3,/, &
                   '*** Increase FG_MAXNUM_FGRIDS in fgmax_module.f90')
               stop
               endif

            do ifg=1,FG_num_fgrids
                ! new in v5.7.0: read all data from fgmax_grids.data:
                call fgmax_read(unit, ifg)
                enddo
            write(parmunit,*) ' '
            write(parmunit,*) '--------------------------------------------'
            write(parmunit,*) 'SETFGMAX:'
            write(parmunit,*) '-----------'

            write(parmunit,*) 'FG_NUM_VAL = ', FG_NUM_VAL
            write(parmunit,*) 'FG_num_fgrids = ', FG_num_fgrids

            module_setup = .true.
        end if

    
    end subroutine set_fgmax

end module fgmax_module

       subroutine resize_bndryList()
       
          use amr_module
          implicit double precision (a-h,o-z)
          integer, allocatable, target, dimension(:,:)  :: new_bndList

          ! get new bndry space
          new_bndListSize = 1.5*bndListSize
          print *,"Expanding size of boundary list from ",bndListSize,
     .            " to ",new_bndListSize
          allocate(new_bndList(new_bndListSize,2),STAT=istatus)
          if (istatus > 0) then
             write(*,*)" could not get new bndry list space"
             stop
          endif
          new_bndList(1:bndListSize,1:2) = bndList
          call move_alloc(new_bndList,bndList)

          ! thread new bndry list space
          do i = bndListSize+1, new_bndListSize
              bndList(i,nextfree) = i+1
          end do

          bndList(new_bndListSize,nextfree) = null
          ndfree_bnd = bndListSize+1
          bndListSize = new_bndListSize

          end

c
c-----------------------------------------------------------------------
c
       subroutine estdt(val,mitot,mjtot,mktot,nvar,dx,dy,dz,dt,nghost,
     &                  aux,naux, cfl)
c
c :::::::::::::::::::::::: ESTDT :::::::::::::::::::::::::::;
c  estimate the initial time step for the given values
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

       implicit double precision (a-h, o-z)

       dimension val(nvar,mitot,mjtot,mktot)
       dimension aux(naux,mitot,mjtot,mktot)
c
c
       return
       end

subroutine rpn2(ixy, maxm, num_eqn, num_waves, num_aux, num_ghost, &
                num_cells, ql, qr, auxl, auxr, fwave, s, amdq, apdq)

! Riemann solver for the 2D shallow water equations

! (h)_t + (h*u)_x = 0
! (hu)_t + (h*u^2 + 1/2*grav*h^2)_x + (h*u*v)_y = -grav*h*(b)_x
! (hv)_t + (h*u*v)_x + (h*v^2 + 1/2*grav*h^2)_y = -grav*h*(b)_y

! using the f-wave algorithm and Roe's approximate Riemann solver.  

! waves:     3
! equations: 3

! Conserved quantities:
!       1 depth
!       2 x_momentum
!       3 y_momentum

! Auxiliary fields:
!       1 bathymetry

! The gravitational constant grav should be in the common block cparam.
!
! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

    implicit none 
    
    integer, intent(in) :: ixy, maxm, num_eqn, num_waves, num_ghost, num_aux, num_cells
    real(kind=8), intent(in) :: ql(num_eqn, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: qr(num_eqn, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: auxl(num_aux, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: auxr(num_aux, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: s(num_waves, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: fwave(num_eqn, num_waves, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: amdq(num_eqn,1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: apdq(num_eqn,1-num_ghost:maxm+num_ghost)
    
    real(kind=8) :: grav, dry_tolerance, sea_level
    common /cparam/ grav, dry_tolerance, sea_level
    
    real(kind=8) :: hl, ul, vl, bl, hr, ur, vr, br, hbar, uhat, chat
    real(kind=8) :: phil, phir, dry_state_l, dry_state_r
    real(kind=8) :: R(3,3)
    real(kind=8) :: fluxdiff(3), beta(3)
    
    integer :: i, k, normal_index, transverse_index
    
    ! Determine normal and tangential directions
    if (ixy == 1) then
        normal_index = 2
        transverse_index = 3
    else
        normal_index = 3
        transverse_index = 2
    end if

    amdq = 0.d0
    apdq = 0.d0

    ! Primary loop over each cell
    do i = 2 - num_ghost, num_cells + num_ghost
        
        ! Check for dry states - need merge here to convert to float
        dry_state_l = merge(0.d0, 1.d0, qr(1, i - 1) < dry_tolerance)
        dry_state_r = merge(0.d0, 1.d0, ql(1, i) < dry_tolerance)

        ! Note that for the states below u is always the normal velocity and
        ! v is always the tangential velocity

        ! Left states
        hl = qr(1, i - 1) * dry_state_l
        ul = qr(normal_index, i - 1) / qr(1, i - 1) * dry_state_l
        vl = qr(transverse_index, i - 1) / qr(1, i - 1) * dry_state_l
        phil = (0.5d0 * grav * hl**2 + hl * ul**2) * dry_state_l

        bl = auxr(1, i - 1)
    
        ! Right states
        hr = ql(1, i) * dry_state_r
        ur = ql(normal_index, i) / ql(1, i) * dry_state_r
        vr = ql(transverse_index, i) / ql(1, i) * dry_state_r
        phir = (0.5d0 * grav * hr**2 + hr * ur**2) * dry_state_r

        br = auxl(1, i)
    
        ! Roe average states (Roe's linearization)
        hbar = 0.5d0 * (hr + hl)
        uhat = (sqrt(hr) * ur + sqrt(hl) * ul) / (sqrt(hr) + sqrt(hl))
        chat = sqrt(grav * hbar)
    
        ! Flux differences
        fluxdiff(1) = hr * ur - hl * ul
        fluxdiff(2) = phir - phil + grav * hbar * (br - bl)
        fluxdiff(3) = hr * ur * vr - hl * ul * vl
    
        ! Wave speeds
        s(1, i) = min(uhat - chat, ul - sqrt(grav * hl))
        s(3, i) = max(uhat + chat, ur + sqrt(grav * hr))
        s(2, i) = 0.5d0 * (s(1, i) + s(3, i))
        
        ! Right eigenvectors (columns)
        ! could possibly use vhat instead of vl and vr
        R(1, 1) = 1.d0
        R(normal_index, 1) = s(1, i)
        R(transverse_index, 1) = vl
        
        R(1, 2) = 0.d0
        R(normal_index, 2) = 0.0
        R(transverse_index, 2) = 1.0
        
        R(1, 3) = 1.d0
        R(normal_index, 3) = s(3, i)
        R(transverse_index, 3) = vr
        
        ! Wave strengths
        beta(1) = (s(3, i) * fluxdiff(1) - fluxdiff(2)) / (s(3, i) - s(1, i))
        beta(3) = (fluxdiff(2) - s(1, i) * fluxdiff(1)) / (s(3, i) - s(1, i))
        beta(2) = fluxdiff(3) - beta(1) * vl - beta(3) * vr

        ! f-waves
        do k = 1, num_waves
            fwave(:, k, i) = beta(k) * R(:, k)
        enddo
    
        ! Fluctuations - could probably rewrite this to be a masking operation
        ! instead...
        do k=1, num_waves
            if (s(k, i) < 1.0e-14) then
                amdq(:, i) = amdq(:, i) + fwave(:, k, i)
            elseif (s(k, i) > 1.0e-14) then
                apdq(:, i) = apdq(:, i) + fwave(:, k, i)
            else
                amdq(:, i) = amdq(:, i) + 0.5d0 * fwave(:, k, i)
                apdq(:, i) = apdq(:, i) + 0.5d0 * fwave(:, k, i)
            endif
        enddo

    enddo ! End of main loop

end subroutine rpn2

c
c -------------------------------------------------------------
c
       subroutine drivesort(npts,badpts,level,index,mbuff)

      use amr_module
      implicit  double precision (a-h,o-z)
      dimension badpts(1,npts)
      dimension iflags(npts), ixArray(npts)
      logical db/.false./
 
      iadd(i) = (i+mbuff)
c
c  convert using one dimensional ordering of badpts array as if
c  it covered entire domain (xprob) on this level
c
      isize = iregsz(level)

      do k = 1, npts
        i = badpts(1,k)-.5  ! remember was shifted when put  into array
        intEquiv = iadd(i)
c        write(*,*)i," has equivalent integer ",intEquiv
        iflags(k) = intEquiv
      end do

      call qsorti(ixArray, npts, iflags)

c copy back to badpts, in sorted order, removing duplicates      
      k = 1
      index = 0
      do while (k .le. npts) 
         intEquiv = iflags(ixArray(k))
         index = index + 1
         badpts(1,index) = mod(intEquiv,(isize+2*mbuff)) + .5 -mbuff
        if (db) write(outunit,101) badpts(1,index)
 101    format(2f6.1)
         k = k + 1
         do while ( k.le. npts)    ! skip over duplicates
            if (iflags(ixArray(k)) .eq. iflags(ixArray(k-1))) then
c           write(*,*)" duplicate in sorted array loc ",ixarray(k)
               k = k+1
            else
               exit   ! back to outer loop
            endif
         end do
       if (k .gt. npts) exit !did we stop because we ran off end or pts not equal
      end do

      if (gprint) then
          write(outunit,929) index
 929      format(i5," flagged pts after removing duplicates and ",
     &           " non-nested flags")
      endif

      return
      end

!   ===============================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
!   ===============================================================

! Riemann solver for Burgers' equation in 2d:
!  u_t + 0.5*(u^2)_x + 0.5*(u^2)_y = 0

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
!
! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q
!
! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr

    
        implicit double precision (a-h,o-z)
        
        dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
        dimension    s(mwaves, 1-mbc:maxm+mbc)
        dimension   ql(meqn, 1-mbc:maxm+mbc)
        dimension   qr(meqn, 1-mbc:maxm+mbc)
        dimension  apdq(meqn, 1-mbc:maxm+mbc)
        dimension  amdq(meqn, 1-mbc:maxm+mbc)
        logical efix
        
!     # x- and y- Riemann problems are identical, so it doesn't matter if
!     # ixy=1 or 2.

        efix = .true.

        do 10 i = 2-mbc, mx+mbc
!        # wave is jump in q, speed comes from R-H condition:
            wave(1,1,i) = ql(1,i) - qr(1,i-1)
            s(1,i) = 0.5d0*(qr(1,i-1) + ql(1,i))
            
!        # compute left-going and right-going flux differences:

            amdq(1,i) = dmin1(s(1,i), 0.d0) * wave(1,1,i)
            apdq(1,i) = dmax1(s(1,i), 0.d0) * wave(1,1,i)

            if (efix) then
!               # entropy fix for transonic rarefactions:
                if (qr(1,i-1).lt.0.d0 .and. ql(1,i).gt.0.d0) then
                    amdq(1,i) = - 0.5d0 * qr(1,i-1)**2
                    apdq(1,i) =   0.5d0 * ql(1,i)**2
                end if
            end if
        10 continue
        
    return
    end subroutine rpn2

c
c ------------------------------------------------------------------
c
      subroutine physbd(val,aux,nrow,ncol,nvar,naux,
     1                  hx, hy, level, time,
     2                  xleft, xright, ybot, ytop,
     3                  xlower,ylower,xupper,yupper,
     4                  xperiodic,    yperiodic)

 
c
c
c :::::::::: PHYSBD ::::::::::::::::::::::::::::::::::::::::::::::;
c
!>     Take a grid patch with mesh widths hx,hy, of dimensions nrow by
!!     ncol,  and set the values of any piece of
!!     of the patch which extends outside the physical domain 
!!     using the boundary conditions. 
c
c     The corners of the grid patch are at 
c        (xleft,ybot)  --  lower left corner
c        (xright,ytop) --  upper right corner
c
c     The physical domain itself is a rectangle bounded by
c        (xlower,ylower)  -- lower left corner
c        (xupper,yupper)  -- upper right corner
c     
c     the picture is the following: 
c
c               _____________________ (xupper,yupper)
c              |                     |  
c          _________ (xright,ytop)   |
c          |   |    |                |
c          |   |    |                |
c          |   |    |                |
c          |___|____|                |
c (xleft,ybot) |                     |
c              |                     |
c              |_____________________|
c   (xlower,ylower)
c        
c
c     Any cells that lie outside the physical domain are ghost cells whose
c     values should be set in this routine.  This is tested for by comparing
c     xleft with xlower to see if values need to be set at the left, as in
c     the figure above, and similarly at the other boundaries.
c
c     Patches are guaranteed to have at least 1 row of cells filled
c     with interior values so it is possible to  extrapolate. 
c     Fix trimbd if you want more than 1 row pre-set.
c
c     Make sure the order the boundaries are specified is correct
c     so that diagonal corner cells are also properly taken care of.
c
c     Periodic boundaries are set before calling this routine, so you
c     can safely extrapolate there.  Don't overwrite them!
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module
      implicit double precision (a-h,o-z)
      logical xperiodic, yperiodic


      dimension val(nrow,ncol,nvar), aux(nrow,ncol,naux)


c     right boundary 
      if (xright .gt. xupper+hxmarg) then
        nxr  = (xright - xupper + hxmarg)/hx
        nxr  = nxr - 1
        ibeg = max0(nrow-nxr, 1)
             do 11 i    = ibeg, nrow
             do 11 j    = 1, ncol
             do 11 ivar = 1, nvar
               val(i,j,ivar) = val(2*ibeg-1-i,j,ivar) 
11           continue
      endif

c     bottom boundary - reflecting (for ramp part, else inflow
      if (ybot .lt. ylower-hymarg) then
        nyb = (ylower+hymarg-ybot)/hy
         do 12 i=1,nrow
         do 12 j=1,nyb     
            val(i,j,ivar)
  12     continue
c
      endif
 

c     top boundary - reflecting
      if (ytop .gt. yupper+hymarg) then
          nyt = (ytop - yupper + hymarg)/hy
          jbeg = max0(ncol-nyt+1, 1)
          x0      =  disp + 10.d0*time/cos(pi/6.d0)
          y0      =  ylower

           do 13 j=jbeg,ncol
             ycen   =  ybot + float(j-.5d0)*hy

              do 13 i=1,nrow
                xcen   = xleft + float(i-.5d0)*hx

                call cellave(xcen-hx/2.d0,ycen-hy/2.d0,hx,hy,wl)

                rho = (1.d0-wl)*rhoamb + wl*rhoshk
                u   = (1.d0-wl)*uamb + wl*ushk
                v   = (1.d0-wl)*vamb + wl*vshk
                p   = (1.d0-wl)*pamb + wl*pshk

                val(i,j,1) =  rho
                val(i,j,2) =  rho * u
                val(i,j,3) =  rho * v
                val(i,j,4) =  p/gamma1 + .5d0*rho*(u*u+v*v)

  13       continue

      endif

c     left boundary - inflow
      if (xleft .lt. xlower-hxmarg) then
        nxl = (xlower+hxmarg-xleft)/hx
            do 10 i = 1, nxl
            do 10 j = 1, ncol
              val(i,j,1) = rhoshk 
              val(i,j,2) = rhoshk * ushk
              val(i,j,3) = rhoshk * vshk
              val(i,j,4) = rhoshk*(eshk+.5d0*(ushk**2+vshk**2))
 10         continue
      endif

      return
      end
      return
      end

! Set auxiliary arrays
!
! Routine that sets the values found in the aux array including topography and
! other fields that are used in the source terms and other things.
!
! In the default routine sets the following fields depending on the input
! parameters present:
!  (1) topography
!  (2) capacity (set if coordinate_system == 2)
!  (3) length ratio of edge (set if coordinate_system == 2)
!  (frition_index). Location of manning's N (variable_friction)
!  (wind_index, wind_index + 1).  Location of x and y wind speeds (wind_forcing)
!  (pressure_index).  Location of pressure field (pressure_forcing)
!
! There are a couple of additional things of note:
!
!  - This routine is called anytime a grid is created during re-gridding to fill
!    in the aux arrays.
!  - Built-in to this routine is an ability to copy aux values from grids from
!    the same level.  If you do not want this behavior you will need to modify
!    this routine.
!  - If you are using periodic BCs then you must handle this here.  Look to the
!    setting of topography for an example of how this may need to be done.
!  - If your aux arrays are time dependent and set somewhere else it may be
!    prudent to set a default value here as is done with the wind and pressure.
!
subroutine setaux(mbc,mx,my,xlow,ylow,dx,dy,maux,aux)

    use amr_module, only: mcapa, xupper, yupper, xlower, ylower, NEEDS_TO_BE_SET
    use amr_module, only: xperdom, yperdom

    use geoclaw_module, only: coordinate_system, earth_radius, deg2rad
    use geoclaw_module, only: sea_level, ambient_pressure

    use storm_module, only: wind_forcing, pressure_forcing
    use storm_module, only: wind_index, pressure_index, set_storm_fields

    use friction_module, only: variable_friction, friction_index
    use friction_module, only: set_friction_field

    use topo_module

    use adjoint_module, only : adjoint_flagging,innerprod_index

    implicit none

    ! Arguments
    integer, intent(in) :: mbc,mx,my,maux
    real(kind=8), intent(in) :: xlow,ylow,dx,dy
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Locals
    integer :: ii,jj,m, iint,jint
    real(kind=8) :: x,y,xm,ym,xp,yp,topo_integral
    real(kind=8) :: xper,yper,xperm,yperm,xperp,yperp
    character(len=*), parameter :: aux_format = "(2i4,4d15.3)"
    integer :: skipcount,iaux,ilo,jlo

    ! Lat-Long coordinate system in use, check input variables
    if (coordinate_system == 2) then
        if (mcapa /= 2 .or. maux < 3) then
            print *,'ERROR in setaux:  for coordinate_system==2'
            print *,'     need mcapa == 2 and maux >= 3'
            print *,'     have mcapa = ',mcapa,'  maux = ',maux
            stop
        endif
    endif

    ! Compute integer indices based off same corner of domain to reduce round
    ! off discrepancies
    ilo = floor((xlow - xlower + .05d0*dx)/dx)
    jlo = floor((ylow - ylower + .05d0*dy)/dy)

    ! Set geometry values
    if (coordinate_system == 1) then
        if (maux == 0 .and. mcapa > 0) then
            print *, "ERROR:  Capacity array requested but number of aux"
            print *, "variables is set to 0."
            stop
        end if
    else if (coordinate_system == 2) then
        do jj = 1 - mbc, my + mbc
            do ii = 1 - mbc, mx + mbc
                ym = ylower + (jlo+jj-1.d0) * dy
                yp = ylower + (jlo+jj) * dy
                aux(2,ii,jj) = deg2rad * earth_radius**2                      &
                                * (sin(yp * deg2rad) - sin(ym * deg2rad)) / dy
                aux(3,ii,jj) = ym * deg2rad
            end do
        end do
    end if

    ! Storm fields if used
    if (wind_forcing) then
        aux(wind_index, :, :) = 0.d0
        aux(wind_index + 1, :, :) = 0.d0
    endif
    if (pressure_forcing) then
        aux(pressure_index, :, :) = ambient_pressure
    endif

    ! Innerproduct field if used
    if (adjoint_flagging) then
        do jj=1-mbc,my+mbc
            do ii=1-mbc,mx+mbc
                if (aux(1,ii,jj) .eq. NEEDS_TO_BE_SET) then
                    aux(innerprod_index,ii,jj) = 0.d0
                endif
            enddo
        enddo
    endif


    ! ==========================================================================
    !  Set Bathymetry
    ! Set analytical bathymetry here if requested
    if (test_topography > 0) then
        do jj = 1 - mbc, my + mbc
            ym = ylower + (jlo+jj-1.d0) * dy
            yp = ylower + (jlo+jj) * dy
            y = 0.5d0*(ym+yp)
            do ii = 1 - mbc, mx + mbc
                xm = xlower + (ilo+ii-1.d0) * dx
                xp = xlower + (ilo+ii) * dx
                x = 0.5d0*(xm+xp)
                aux(1,ii,jj) = test_topo(x)
            end do
        end do

    ! Set bathymetry based on input files
    else if (mtopofiles > 0) then

        do jj=1-mbc,my+mbc
            ym = ylower + (jlo+jj-1.d0) * dy
            yp = ylower + (jlo+jj) * dy
            y = 0.5d0*(ym+yp)


            do ii=1-mbc,mx+mbc
                xm = xlower + (ilo+ii-1.d0) * dx
                xp = xlower + (ilo+ii) * dx
                x = 0.5d0*(xm+xp)

                ! Parameter NEEDS_TO_BE_SET initialized in amr_module.f90
                ! saves time by otherwise copying instead of reinitializing
                if (aux(1,ii,jj) .ne. NEEDS_TO_BE_SET) then
                    cycle
                endif

                topo_integral = 0.d0
                if ((y>yupper).or.(y<ylower).or.(x>xupper).or.(x<xlower)) then
                    if (.not.(xperdom .or. yperdom)) then
                        ! Skip setting as this cell sticks out of the physical
                        ! domain and we are not setting periodic BCs
                        cycle

                    else
                        ! We evaluate the periodic BC topography by computing
                        ! the appropriate periodic grid cell coordinates and
                        ! again calling cellgridintegrate
                        call wrap_coords(x,y,xperm,xper,xperp,yperm,yper, &
                                         yperp,dx,dy)
                        call cellgridintegrate(topo_integral,  &
                                               xperm,xperp,yperm,yperp)
                    endif
                else
                    ! Cell does not extend outside of physical domain
                    call cellgridintegrate(topo_integral,xm,xp,ym,yp)
                endif

                ! Correct for geometry
                if (coordinate_system == 2) then
                    aux(1,ii,jj) = topo_integral / (dx * dy * aux(2,ii,jj))
                else
                    aux(1,ii,jj) = topo_integral / (dx * dy)
                endif
            enddo
        enddo
    else
        print *, "ERROR:  There is no way to set bathymetry!  Either "
        print *, "        provide topography files or request topography "
        print*,  "        defined by a function."
        stop
    end if

    ! Copy topo to ghost cells if outside physical domain and not periodic
    if (.not. yperdom) then
        do jj=1-mbc,my+mbc
            y = ylower + (jlo+jj-.5d0) * dy
            if ((y < ylower) .or. (y>yupper)) then
                do ii=1-mbc,mx+mbc
                    x = xlower + (ilo+ii-.5d0) * dx
                    iint = ii + max(0, ceiling((xlower-x)/dx)) &
                         - max(0, ceiling((x-xupper)/dx))
                    jint = jj + max(0, ceiling((ylower-y)/dy)) &
                         - max(0, ceiling((y-yupper)/dy))
                    aux(1,ii,jj) = aux(1,iint,jint)
                enddo
            endif
        enddo
    endif
    if (.not. xperdom) then
        do ii=1-mbc,mx+mbc
            x =  xlower + (ilo+ii-.5d0) * dx
            if ((x < xlower) .or. (x > xupper)) then
                do jj=1-mbc,my+mbc
                    y = ylower + (jlo+jj-.5d0) * dy
                    iint = ii + max(0, ceiling((xlower-x)/dx)) &
                         - max(0, ceiling((x-xupper)/dx))
                    jint = jj + max(0, ceiling((ylower-y)/dy)) &
                         - max(0, ceiling((y-yupper)/dy))
                    aux(1,ii,jj) = aux(1,iint,jint)
                enddo
            endif
        enddo
    endif

    ! If using a variable friction field initialize the coefficients to 0
    if (variable_friction) then
        call set_friction_field(mx, my, mbc, maux, xlow, ylow, dx, dy, aux)
    endif

contains

    ! Provide wrapper function for providing periodic coordinates
    subroutine wrap_coords(x,y,xperm,xper,xperp,yperm,yper,yperp,dx,dy)

        use amr_module, only: xperdom, yperdom, xupper, yupper, xlower, ylower

        implicit none

        ! Arguments
        real(kind=8), intent(in) :: x,y,dx,dy
        real(kind=8), intent(out) :: xperm,xper,xperp,yperm,yper,yperp
        real(kind=8) :: xdomain, ydomain

        ! need size of domain for wrapping
        xdomain = xupper - xlower
        ydomain = yupper - ylower
        xper = x
        yper = y

        ! test for wrapping of coordinates
        if (x > xupper .and. xperdom) xper = xper - xdomain
        if (x < xlower .and. xperdom) xper = xper + xdomain
        if (y > yupper .and. yperdom) yper = yper - ydomain
        if (y < ylower .and. yperdom) yper = yper + ydomain

        ! adjust rest of variables
        xperm = xper - 0.5d0 * dx
        xperp = xper + 0.5d0 * dx
        yperm = yper - 0.5d0 * dy
        yperp = yper + 0.5d0 * dy

    end subroutine wrap_coords

end subroutine setaux

      subroutine setprob
      implicit double precision (a-h,o-z)
      character(len=25) fname

      common /compsi/ pi
      common /comvt/ tperiod,pi2

c
c     # compute pi, used in psi.f
      pi = 4.d0 * datan(1.d0)
c
c     # save 2*pi and tperiod in common block for use in b4step2:
c
      pi2 = 2.d0*pi
c
      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)

      read(7,*) tperiod

      return
      end

c
c     ==================================================================
      subroutine chkmth(method,info)
c     ==================================================================
c
c     # Checks whether the method parameters are correct or not.
c     # Note that method(3) < 0 yields dimensional splitting.
c
      implicit double precision (a-h,o-z)
c
      dimension method(7)
c
      info = 0
c
      if(method(1) .ne. 0 .and. method(1) .ne. 1)then
         write(6,*) ' '
         write(6,*) 'CLAW3 error .... method(1) should be:'
         write(6,*) '   0 - fixed time steps'
         write(6,*) '   1 - variable time steps'
         write(6,*) ' '
         info = 6 
      endif
c
      if(method(2) .ne. 1 .and. method(2) .ne. 2)then
         write(6,*) ' '
         write(6,*) 'CLAW3 error .... method(2) should be:'
         write(6,*) '   1 - first order method'
         write(6,*) '   2 - second order method'
         write(6,*) ' '
         info = 6 
      endif
c
      if(method(2) .eq. 1 .and. method(3) .ge. 0)then
         if(method(3) .ne. 0 .and. method(3) .ne. 10 .and.
     &      method(3) .ne. 11)then
            write(6,*) ' '
            write(6,*) 'CLAW3 error .... when method(2) = 1,'
            write(6,*) 'method(3) should be:'
            write(6,*) '   0  - donor cell'
            write(6,*) '   10 - 2D wave propagation of increment waves'
            write(6,*) '   11 - corner transport upwind'
            write(6,*) ' '
            info = 6
         endif
      endif       
c
      if(method(2) .eq. 2 .and. method(3) .ge. 0)then
         if(method(3) .ne. 0  .and. method(3) .ne. 10 .and.
     &      method(3) .ne. 11 .and. method(3) .ne. 20 .and.
     &      method(3) .ne. 21 .and. method(3) .ne. 22)then
            write(6,*) ' '
            write(6,*) 'CLAW3 error .... when method(2) = 2,'
            write(6,*) 'method(3) should be:'
            write(6,*) '   0  - donor cell'
            write(6,*) '   10 - 2D wave propagation of increment waves'
            write(6,*) '        and 1D propagation of correction waves'
            write(6,*) '        UNCONDITIONALLY UNSTABLE'
            write(6,*) '   11 - corner transport upwind with 2D'
            write(6,*) '        propagation of the correction waves'
            write(6,*) '        UNCONDITIONALLY UNSTABLE'
            write(6,*) '   20 - 2D propagation of both increment and'
            write(6,*) '        correction waves.'
            write(6,*) '   21 - corner transport upwind with 2D '
            write(6,*) '        propagation of the correction waves.'
            write(6,*) '   22 - Full 3D wave propagation method.'
            write(6,*) ' '
            info = 6
         endif
      endif       
c
      return
      end

c
c
c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,xlower,ylower,
     &                   dx,dy,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c     # Sample scalar equation with data that is piecewise constant with
c     # q = 1.0  if  0.1 < x < 0.6   and   0.1 < y < 0.6
c     #     0.1  otherwise
c
       implicit double precision (a-h,o-z)
       dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
       dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
c
       do 20 i=1,mx
          xi = xlower + (i-0.5d0)*dx
          do 20 j=1,my
             yj = ylower + (j-0.5d0)*dy
             if (xi.gt.0.1d0 .and. xi.lt.0.6d0 .and.
     &           yj.gt.0.1d0 .and. yj.lt.0.6d0) then
                     q(1,i,j) = 1.d0
                   else
                     q(1,i,j) = 0.1d0
                   endif
  20         continue
       return
       end

c
c ----------------------------------------------------------
!> Reclaim list space in nodes cfluxptr and ffluxptr for all grids at level
!! **level**
c
      subroutine putsp(lbase,level,nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::::::::::::::::: PUTSP :::::::::::::::::::::::::
c
c reclaim list space in nodes cfluxptr and ffluxptr for grids at level
c
c first compute max. space allocated in node cfluxptr.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      if (level .eq. lfine) go to 30
c
      ! new way - all coarse space allocated at once so
      ! reclaim it all. 
      call reclam(listspStart(level),5*listsp(level))
      ! still need to zero out coarse flux ptrs in case no
      ! new grids at next level were created (otherwise
      ! it would be re-created and assigned in prepc)
      mptr = lstart(level)
 20      node(cfluxptr,mptr) = 0
         mptr = node(levelptr,mptr)
         if (mptr .ne. 0) go to 20
      
c
 30   if (level .eq. lbase) go to 99
      mptr = lstart(level)
 40       nx    = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny    = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          ikeep = nx/intratx(level-1)
          jkeep = ny/intraty(level-1)
          lenbc = 2*(ikeep+jkeep)
c         twice perimeter since saving plus or minus fluxes 
c         plus coarse solution storage
          call reclam(node(ffluxptr,mptr), 2*nvar*lenbc+naux*lenbc)
          mptr  = node(levelptr,mptr)
          if (mptr .ne. 0) go to 40
c
 99    return
       end

c
c ------------------------------------------------------------
c
       subroutine cstore(qc,nrow,ncol,nfil,nvar,
     &                   qc1d,lenbc,naux,auxc,auxc1d)

       implicit double precision (a-h, o-z)

       dimension qc(nvar,nrow,ncol,nfil)
       dimension qc1d(nvar,lenbc)
       dimension auxc(naux,nrow,ncol,nfil)
       dimension auxc1d(naux,lenbc)
c
c      store coarse perimeter worth of solution into 1d array.
c      go around fine grid in following order
c                2
c           __________
c        1 |          | 3
c           __________
c               4
c
c  then side 5 and then side 6.
c  In 3D, side 1 is x constant,
c              2 is y constant,
c              3 is x constant,
c              4 is y constant,
c              5 is z constant, (bottom)
c              6 is z constant. (top)
c
c  save first interior cell of enlarged grid corresponding to
c  fine grid bordering cell. note that since fine grid is smaller,
c  the cell is one in. coarse (temporary) grid has no ghost cells

c      side 1
       index = 0
       do 10 k = 2, nfil-1
       do 10 j = 2, ncol-1
         index = index + 1
         do 5 ivar = 1, nvar
 5         qc1d(ivar,index) = qc(ivar,1,j,k)
         do 6 iaux = 1, naux
 6         auxc1d(iaux,index) = auxc(iaux,1,j,k)
 10    continue

c      side 2
       do 20 k = 2, nfil-1
       do 20 i = 2, nrow-1
         index = index + 1
         do 15 ivar = 1, nvar
 15        qc1d(ivar,index) = qc(ivar,i,ncol,k)
         do 16 iaux = 1, naux
 16        auxc1d(iaux,index) = auxc(iaux,i,ncol,k)
 20    continue

c      side 3
       do 30 k = 2, nfil-1
       do 30 j = 2, ncol-1
         index = index + 1
         do 25 ivar = 1, nvar
 25        qc1d(ivar,index) = qc(ivar,nrow,j,k)
         do 26 iaux = 1, naux
 26        auxc1d(iaux,index) = auxc(iaux,nrow,j,k)
 30    continue

c      side 4
       do 40 k = 2, nfil-1
       do 40 i = 2, nrow-1
         index = index + 1
         do 35 ivar = 1, nvar
 35        qc1d(ivar,index) = qc(ivar,i,1,k)
         do 36 iaux = 1, naux
 36        auxc1d(iaux,index) = auxc(iaux,i,1,k)
 40    continue

c      side 5
       do 50 j = 2, ncol-1
       do 50 i = 2, nrow-1
         index = index + 1
         do 45 ivar = 1, nvar
 45        qc1d(ivar,index) = qc(ivar,i,j,1)
         do 46 iaux = 1, naux
 46        auxc1d(iaux,index) = auxc(iaux,i,j,1)
 50    continue

c      side 6
       do 60 j = 2, ncol-1
       do 60 i = 2, nrow-1
         index = index + 1
         do 55 ivar = 1, nvar
 55        qc1d(ivar,index) = qc(ivar,i,j,nfil)
         do 56 iaux = 1, naux
 56        auxc1d(iaux,index) = auxc(iaux,i,j,nfil)
 60    continue

       return
       end

c
c ----------------------------------------------------------------
c Modified from auxcoarse.f in amrclaw
c Only coarsens topography
c ----------------------------------------------------------------
c
       subroutine auxcoarsen(auxdub,midub,mjdub,auxbgc,
     1                       mi2tot,mj2tot,naux,auxtype)

       use amr_module, only: mcapa
       implicit double precision (a-h, o-z)

       dimension     auxdub(naux,midub, mjdub)
       dimension     auxbgc(naux,mi2tot,mj2tot)
       character*10  auxtype(naux)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
c coarsen = coarsen the fine grid auxiliary data (with double the usual
c           number of ghost cells to prepare coarsened data
c           for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       do 20 j = 1, mj2tot
         jfine = 2*(j-1) + 1
         do 20 i = 1, mi2tot
           ifine = 2*(i-1) + 1

           if (mcapa .eq. 0) then
             capac=1.0d0
           else
             capac=auxbgc(2,i,j)
           endif

           toposum = 0.d0
           do jco = 1,2
             do ico = 1,2
               if (mcapa .eq. 0) then
                 capa=1.0d0
               else
                 capa=auxdub(2,ifine+ico-1,jfine+jco-1)
               endif

               topof=auxdub(1,ifine+ico-1,jfine+jco-1)*capa

               toposum = toposum + topof
             enddo
           enddo


           auxbgc(1,i,j) = toposum/(4.d0 * capac)
20       continue


       return
       end

c
!> Check that potential grid mnew is completely contained
!! in coarser grids at level **lbase** (>1) that will
!! stay fixed during this regridding step
!! 
!! This version tries to do it without using domflags
!! slower but better if cant afford memory over entire domain
!!
!! For a grid mnew, find the smallest rectangle expressed in 
!! **lbase** index space and compare it to each grid on level **lbase**.
!! If every region in the rectangle has been overlapped during
!! the comparison, the grid mnew is properly nested and the function returns
!! true
!!
!!
c
c ----------------------------------------------------------------
c
       logical function baseCheck(mnew,lbase,ilo,ihi,jlo,jhi,
     .                            nvar,naux,thisBuff)

       use amr_module
       implicit double precision (a-h, o-z)

       logical debug/.false./
       integer ist(3),iend(3),jst(3),jend(3),ishift(3),jshift(3)
       logical borderx, bordery
       integer thisBuff

c      index into alloc from iclo:ichi and jclo:jchi, not 0..leni/j. 
       iadd(i,j) = locm + i - iclo + leni*(j-jclo) 

c ::::::::::::::::::: baseCheck :::::::::::::::::::::::::::
c
c baseCheck - check that potential grid mnew is completely contained
c             in  coarser grids at level 'lbase' (>1) that will
c             stay fixed during this regridding step
c
c   this version tries to do it without using domflags
c   slower but better if cant afford memory over entire domain
c
c   mcheck is one bigger since for proper nesting, cell must be
c   at least one away from boundary of a parent grid, unless
c   on a domain boundary
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::



       levnew = node(nestlevel,mnew)
       borderx = (ilo .eq. 0 .or. ihi .eq. iregsz(levnew)-1)
       bordery = (jlo .eq. 0 .or. jhi .eq. jregsz(levnew)-1)
       

c     if (debug) write(outunit,100) mnew,lbase,ilo,ihi,jlo,jhi,levnew
c100  format("NESTCK2 testing grid ",i5," base level ",i5,/,
c    . " new grid from ilo:hi: ",2i12," to ",2i12," at level ",i4)
c
c    on to initializing for the given grid and its nest checking
       levratx = 1
       levraty = 1
       do 5 lev = lbase, levnew-1
          levratx = levratx * intratx(lev)
          levraty = levraty * intraty(lev)
 5     continue

c widen by 1 cell (proper nesting), then project to lbase
c this might stick out of domain, fix later
c figure out size for scratch storage on base grid for testing
       iclo = ilo
       ichi = ihi
       jclo = jlo
       jchi = jhi
       do lev = levnew-1,lbase,-1
          iclo = iclo/intratx(lev)
          ichi = ichi/intratx(lev)
          jclo = jclo/intraty(lev) 
          jchi = jchi/intraty(lev)
          iclo = iclo - 1
          ichi = ichi + 1
          jclo = jclo - 1
          jchi = jchi + 1
c         if (debug) then
c            write(outunit,111) lev, iclo,ichi,jclo,jchi
c111         format(10x,"at level",i5," projected coords ilo:hi:",2i10,
c    .           " jlo:hi:",2i10)
c         endif
       end do
c      high end of integer grid index truncates during the divide
c      if it were exactly lined up with coarser grid it would
c      not be properly nested, but since we added one to the index 
c      space, we took care of that already.
c      if (debug) then
c         write(outunit,108) ilo-1,ihi+1,jlo-1,jhi+1
c         write(outunit,109) levratx,levraty
c108      format(" enlarged (by 1) fine grid from ilo:hi:",2i12,
c    .           " to jlo:hi:", 2i12)
c109      format(" refinement factors to base grid of ", 2i12)
c         write(outunit,101) iclo,ichi,jclo,jchi
c101      format("coarsened to lbase, grid from iclo:hi: ",2i12,
c    .        " to jclo:hi:",2i12)
c      endif

       if (.not. (xperdom .and. borderx) .and. 
     .     .not. (yperdom .and. bordery)) then
          iclo = max(iclo,0)  ! make sure in domain boundary when checking nesting
          jclo = max(jclo,0)  
          ichi = min(ichi,iregsz(lbase)-1) ! subtract 1 since regsz is number of cells, so -1 is highest index
          jchi = min(jchi,jregsz(lbase)-1)
       endif


       leni = ichi - iclo + 1
       lenj = jchi - jclo + 1
       lenrect = leni * lenj
       locm = igetsp(lenrect)
       alloc(locm:locm+lenrect-1) = 0.
c
c  if mnew on domain boundary fix flags so ok. 
c  fix extra border, and first/last real edge
       if (ilo .eq. 0 .and. .not. xperdom) then
         do j = jclo,jchi
            alloc(iadd(iclo,j)) = 1.
            alloc(iadd(iclo+1,j)) = 1.
         end do

       endif
       if (ihi .eq. iregsz(levnew)-1 .and. .not. xperdom) then
          do j = jclo, jchi
             alloc(iadd(ichi,j)) = 1.
             alloc(iadd(ichi-1,j)) = 1.
          end do
       endif
       if (jlo .eq. 0 .and. .not. yperdom) then
         do i = iclo,ichi
            alloc(iadd(i,jclo)) = 1.
            alloc(iadd(i,jclo+1)) = 1.
         end do
       endif
       if (jhi .eq. jregsz(levnew)-1 .and. .not. yperdom) then
          do i = iclo, ichi
             alloc(iadd(i,jchi)) = 1.
             alloc(iadd(i,jchi-1)) = 1.
          end do
       endif

       mptr = lstart(lbase)
 20       iblo = node(ndilo, mptr) - thisBuff
          ibhi = node(ndihi, mptr) + thisBuff
          jblo = node(ndjlo, mptr) - thisbuff
          jbhi = node(ndjhi, mptr) + thisBuff
c
          ! non periodic case, base level coordinates, just mark if nested.
          if ((.not. (xperdom .and. borderx)) .and. 
     .         .not. (yperdom .and. bordery)) then
              ixlo = max(iclo,iblo)
              ixhi = min(ichi,ibhi)
              jxlo = max(jclo,jblo)
              jxhi = min(jchi,jbhi)
              if (.not.((ixlo.le.ixhi) .and. (jxlo.le.jxhi))) go to 30
              do jx = jxlo, jxhi
              do ix = ixlo, ixhi
                alloc(iadd(ix,jx))=1.
              end do
              end do
              go to 30
          endif
c
c          periodic case:  initialize for potential periodicity
c             each patch divided into 9 regions (some may be empty)
c             e.g. i from (ilo,-1), (0,iregsz(level)-1),(iregsz(level),ihi)
c             except using enlarged grid (ilo-1 to ihi+1)
c
       call setIndices(ist,iend,jst,jend,iclo,ichi,jclo,jchi,
     .                 ishift,jshift,lbase)

c          compare all regions of coarsened patch with one lbase grid at a time
           do 26 i = 1, 3
              i1 = max(iclo,ist(i))
              i2 = min(ichi, iend(i))
           do 25 j = 1, 3
              j1 = max(jclo, jst(j))
              j2 = min(jchi, jend(j))

              if (.not. ((i1 .le. i2) .and. (j1 .le. j2))) go to 25
c
c           patch (possibly periodically wrapped) not empty.
c           see if intersects base grid. wrap coords for periodicity
              i1_shifted = i1 + ishift(i)
              i2_shifted = i2 + ishift(i)
              j1_shifted = j1 + jshift(j)
              j2_shifted = j2 + jshift(j)

              ixlo = max(i1_shifted,iblo)
              ixhi = min(i2_shifted,ibhi)
              jxlo = max(j1_shifted,jblo)
              jxhi = min(j2_shifted,jbhi)

              if (.not.((ixlo.le.ixhi) .and. (jxlo.le.jxhi))) go to 25
c     mark intersected regions with 1
              do jx = jxlo, jxhi
              do ix = ixlo, ixhi
c                need to mark nesting of orig coords, not coarsened shifted indices
                 ix_unshifted = (ix - ishift(i)) ! back to unshifted coords
                 jx_unshifted = (jx - jshift(j)) ! to mark base grid nesting ok
                 alloc(iadd(ix_unshifted,jx_unshifted)) = 1.
               end do
               end do

 25       continue
 26       continue

 30       mptr = node(levelptr, mptr)
          if (mptr .ne. 0) go to 20

c     output for debugging
c     if (debug) then
c         do 34 jj = jclo, jchi
c             j = jchi + jclo - jj
c             write(outunit,344)(int(alloc(iadd(i,j))), i=iclo,ichi) 
c344          format(110i1)
c34       continue
c      endif

c
c  if any zeroes left mnew not nested
c
       do j = jclo, jchi
       do i = iclo, ichi
          if (alloc(iadd(i,j)) .eq. 0) then
             baseCheck = .false.
             go to 99
          endif
       end do
       end do

c      if made it here then grid is nested
       baseCheck = .true.

 99    call reclam(locm, lenrect)

       return 
       end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================

      implicit none
!
!     # Riemann solver in the transverse direction using an einfeldt
!     Jacobian.

      double precision :: grav, g
      double precision, parameter :: tol = 1.e-14
      common /cparam/ grav

      integer ixy,maxm,meqn,maux,mwaves,mbc,mx,imp

      double precision  ql(meqn,1-mbc:maxm+mbc)
      double precision  qr(meqn,1-mbc:maxm+mbc)
      double precision  asdq(meqn,1-mbc:maxm+mbc)
      double precision  bmasdq(meqn,1-mbc:maxm+mbc)
      double precision  bpasdq(meqn,1-mbc:maxm+mbc)
      double precision  aux1(maux,1-mbc:maxm+mbc)
      double precision  aux2(maux,1-mbc:maxm+mbc)
      double precision  aux3(maux,1-mbc:maxm+mbc)

      double precision  s(3)
      double precision  r(3,3)
      double precision  beta(3)
      double precision  abs_tol
      double precision  hl,hr,hul,hur,hvl,hvr,vl,vr,ul,ur,bl,br
      double precision  uhat,vhat,hhat,roe1,roe3,s1,s2,s3,s1l,s3r
      double precision  delf1,delf2,delf3,dxdcd,dxdcu
      double precision  dxdcm,dxdcp,topo1,topo3,eta

      integer i,m,mw,mu,mv

      abs_tol=tol
      g = grav

      if (ixy.eq.1) then
        mu = 2
        mv = 3
      else
        mu = 3
        mv = 2
      endif

      do i=2-mbc,mx+mbc

         hl=qr(1,i-1) 
         hr=ql(1,i) 
         hul=qr(mu,i-1) 
         hur=ql(mu,i) 
         hvl=qr(mv,i-1) 
         hvr=ql(mv,i)

!===========determine velocity from momentum===========================
       if (hl.lt.abs_tol) then
          hl=0.d0
          ul=0.d0
          vl=0.d0
       else
          ul=hul/hl
          vl=hvl/hl
       endif

       if (hr.lt.abs_tol) then
          hr=0.d0
          ur=0.d0
          vr=0.d0
       else
          ur=hur/hr
          vr=hvr/hr
       endif

       do mw=1,mwaves
          s(mw)=0.d0
          beta(mw)=0.d0
          do m=1,meqn
             r(m,mw)=0.d0
          enddo
       enddo
      dxdcp = 1.d0
      dxdcm = 1.d0

      if (hl <= tol .and. hr <= tol) go to 90

       !check and see if cell that transverse waves are going in is high and dry
       if (imp.eq.1) then
            eta = qr(1,i-1)  + aux2(1,i-1)
            topo1 = aux1(1,i-1)
            topo3 = aux3(1,i-1)
!            s1 = vl-sqrt(g*hl)
!            s3 = vl+sqrt(g*hl)
!            s2 = 0.5d0*(s1+s3)
       else
            eta = ql(1,i) + aux2(1,i)
            topo1 = aux1(1,i)
            topo3 = aux3(1,i)
!            s1 = vr-sqrt(g*hr)
!            s3 = vr+sqrt(g*hr)
!            s2 = 0.5d0*(s1+s3)
       endif
       if (eta.lt.max(topo1,topo3)) go to 90


!=====Determine some speeds necessary for the Jacobian=================
            vhat=(vr*dsqrt(hr))/(dsqrt(hr)+dsqrt(hl)) + &
              (vl*dsqrt(hl))/(dsqrt(hr)+dsqrt(hl))

            uhat=(ur*dsqrt(hr))/(dsqrt(hr)+dsqrt(hl)) + &
              (ul*dsqrt(hl))/(dsqrt(hr)+dsqrt(hl))
            hhat=(hr+hl)/2.d0

            roe1=vhat-dsqrt(g*hhat)
            roe3=vhat+dsqrt(g*hhat)

            s1l=vl-dsqrt(g*hl)
            s3r=vr+dsqrt(g*hr)

            s1=dmin1(roe1,s1l)
            s3=dmax1(roe3,s3r)

            s2=0.5d0*(s1+s3)

           s(1)=s1
           s(2)=s2
           s(3)=s3
!=======================Determine asdq decomposition (beta)============
         delf1=asdq(1,i)
         delf2=asdq(mu,i)
         delf3=asdq(mv, i)

         beta(1) = (s3*delf1/(s3-s1))-(delf3/(s3-s1))
         beta(2) = -s2*delf1 + delf2
         beta(3) = (delf3/(s3-s1))-(s1*delf1/(s3-s1))
!======================End =================================================

!=====================Set-up eigenvectors===================================
         r(1,1) = 1.d0
         r(2,1) = s2
         r(3,1) = s1

         r(1,2) = 0.d0
         r(2,2) = 1.d0
         r(3,2) = 0.d0

         r(1,3) = 1.d0
         r(2,3) = s2
         r(3,3) = s3
!============================================================================
90      continue
!============= compute fluctuations==========================================

               bmasdq(1,i)=0.0d0
               bpasdq(1,i)=0.0d0
               bmasdq(2,i)=0.0d0
               bpasdq(2,i)=0.0d0
               bmasdq(3,i)=0.0d0
               bpasdq(3,i)=0.0d0
            do  mw=1,3
               if (s(mw).lt.0.d0) then
                 bmasdq(1,i) =bmasdq(1,i) + dxdcm*s(mw)*beta(mw)*r(1,mw)
                 bmasdq(mu,i)=bmasdq(mu,i)+ dxdcm*s(mw)*beta(mw)*r(2,mw)
                 bmasdq(mv,i)=bmasdq(mv,i)+ dxdcm*s(mw)*beta(mw)*r(3,mw)
               elseif (s(mw).gt.0.d0) then
                 bpasdq(1,i) =bpasdq(1,i) + dxdcp*s(mw)*beta(mw)*r(1,mw)
                 bpasdq(mu,i)=bpasdq(mu,i)+ dxdcp*s(mw)*beta(mw)*r(2,mw)
                 bpasdq(mv,i)=bpasdq(mv,i)+ dxdcp*s(mw)*beta(mw)*r(3,mw)
               endif
            enddo
!========================================================================
         enddo
!

!

      return
      end

!
! ----------------------------------------------------------
!
      subroutine setMatrixIndex(levelBouss)

      use amr_module
      use bouss_module
      implicit none

      integer, intent(in) :: levelBouss

      integer k,i,j,nb,nng,levSt, mptr,nx,ny 

      type(matrix_patchIndex), pointer :: mi
      type(matrix_patchIndex), pointer :: mi_nbor
      type(matrix_levInfo),  pointer :: minfo
      integer bndNum, imax,imin,jmax,jmin,icount,nextSpot,max_matrix_nelt
      integer ixlo,ixhi,jxlo,jxhi,imlo,imhi,jmlo,jmhi,mtest,nbtest

!
!     traverse grids in this exact order, after arrangeGrids has been called
!     to compute integer storage index for bouss matrix. 
!     also after makeBndryList called so can use it to find
!     neighboring grids at same level

!     Steps:
!      1. index array initialized to -1.
!      2. enumerate each grid, setting interior indices
!      3. go back and fill in overlapping ghost cell indices
!         cells at edges of grid  that still have a -1 in their stencil 
!         will be treated as SWE points.
!
      minfo => matrix_info_allLevs(levelBouss)

      k = 0  ! keep running total of number of unknowns in matrix system 
!     ## allocate array to store indices, only for levelBouss grids
      nb = 0  ! recount number of bouss grids to set pointers
      levSt = listStart(levelBouss)
      do nng = 1, numgrids(levelBouss)
         mptr = listOfGrids(levSt+nng-1)
         nb = nb + 1
         node(bpatchNum,mptr) = nb
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         mi => minfo%matrix_indices(nb)
         allocate(mi%mindex(0:nx+1,0:ny+1))
         !mi%mindex = -1  ! indicates no matrix element set
         ! initialize on previous line doesnt work for allocate, need loop
         ! would be nicer to only go order cells but reset next loop
         do j = 0, ny+1
         do i = 0, nx+1
            mi%mindex(i,j) = -1  
         end do
         end do

         ! set interior with matrix index
         do j = 1, ny
         do i = 1, nx
            k = k + 1
            mi%mindex(i,j) = k
         end do
         end do
      end do

!     save total number
      minfo%numBoussCells = k
      ! allocate overestimate since some cells will not have 5 entries at bndry
      ! remember there are twice num unknowns

      ! note do not generally need hv to left/right or hu above/below unless 
      ! introduced in place of a ghost cell, so max 14 elements per row, not 18
      if (ibouss .eq. 1) then
        max_matrix_nelt = 14 * minfo%numBoussCells 
      else ! ibouss  2 or 3
        max_matrix_nelt = 24 * minfo%numBoussCells 
      endif

      if (minfo%numBoussCells > 0) then
          if (.not. crs) then ! COO triplet format
            allocate(minfo%matrix_ia(max_matrix_nelt),     &
                     minfo%matrix_ja(max_matrix_nelt),     &
                     minfo%matrix_sa(max_matrix_nelt))
          else  ! CRS format
            allocate(minfo%cols(0:max_matrix_nelt),        &
                     minfo%vals(0:max_matrix_nelt),        &
                     minfo%rowPtr(0:2*minfo%numBoussCells))
          endif
      endif

!     loop again to set boundary values from other grids
      levSt = listStart(levelBouss)
      do nng = 1, numgrids(levelBouss)
         mptr = listOfGrids(levSt+nng-1)
!        set outer ghost cells by intersecting with other grids at this level
!        these grids only have one halo cell
         imin = node(ndilo,mptr)
         imax = node(ndihi,mptr)
         jmin = node(ndjlo,mptr)
         jmax = node(ndjhi,mptr)
         nx     = imax - imin + 1
         ny     = jmax - jmin + 1
         nb = node(bpatchNum,mptr)
         mi => minfo%matrix_indices(nb)
!        loop over this grids bndry list
         nextSpot = node(bndListSt,mptr)
         bndNum = node(bndListNum,mptr)
         do icount = 1, bndNum
           mtest = bndList(nextSpot,gridNbor)
!          check if grid mptr and mtest intersect
           imlo = node(ndilo,mtest) ! only test against INTERIOR of mtest
           imhi = node(ndihi,mtest)
           jmlo = node(ndjlo,mtest)
           jmhi = node(ndjhi,mtest)

           ixlo = max(imlo,imin-1)  ! our grid wants to fill its halo 
           ixhi = min(imhi,imax+1)  ! using other grids interior cells only
           jxlo = max(jmlo,jmin-1)
           jxhi = min(jmhi,jmax+1)

           if (ixlo > ixhi .or. jxlo > jxhi) cycle !dont intersect
!          can only be one row or col, but dont know which so double loop
           nbtest = node(bpatchNum,mtest)
           mi_nbor => minfo%matrix_indices(nbtest)
           do j = jxlo,jxhi
           do i = ixlo,ixhi
              mi%mindex(i-imin+1,j-jmin+1) = mi_nbor%mindex(i-imlo+1,j-jmlo+1) 
           end do
           end do
           nextSpot = bndList(nextSpot,nextfree)
         end do  ! end loop over bndry grids for mptr
         if (0 .eq. 1) then
            write(*,*)
            write(*,*)"grid ",mptr
            do j = ny+1,0,-1
               write(*,101)(mi%mindex(i,j),i=0,nx+1)
 101           format(300i7)
            end do
         endif
      end do  ! end loop over bouss grids

      return
      end subroutine setMatrixIndex

c
c :::::::::::::::::::::::::  GRIDDOMSHRINK ::::::::::::::::::::::::::::
c
!> Shrink domain flags one cell for allowable properly nested domain
!! This is needed even for lcheck = lbase. More shrinking needed
!! for finer levels.
!! Flags starts in iflags2, should end in iflags array
!!
!! The output **iflags** has flagged zone one cell smaller (shrinked)
!!than input **iflags2.
!! 
!! The flags and indices, **ilo**, **ihi**, **jlo** and **jhi** are all with
!! respect to level **level** index space
!!
!! **input**:
!! * iflags2
!! **output**:
!! * iflags
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c ----------------------------------------------------
c
      subroutine griddomshrink(iflags2,ilo,ihi,jlo,jhi,mbuff,iflags,
     .                         level)

      use amr_module
      implicit double precision (a-h, o-z)


      integer*1  iflags (ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)
      integer*1  iflags2(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)



      if (dprint) then
        write(outunit,*)" from griddomshrink: on entry, iflags2"
        do 10 j = jhi+mbuff,jlo-mbuff,-1
        write(outunit,100)(iflags2(i,j),i=ilo-mbuff,ihi+mbuff)
 100    format(80i1)
 10     continue
      endif

c     NB this untagging alg. includes corner cells in determining proper 
c     nesting.  not always nec., or always done
      do 41 j = jlo-mbuff+1,jhi+mbuff-1
      do 40 i = ilo-mbuff+1,ihi+mbuff-1
         iflags(i,j) = iflags2(i,j)
         if (iflags2(i  ,j  ) .le. 0 .or.
     1       iflags2(i+1,j  ) .le. 0 .or. iflags2(i-1,j  ) .le. 0 .or. 
     2       iflags2(i+1,j+1) .le. 0 .or. iflags2(i-1,j+1) .le. 0 .or. 
     3       iflags2(i  ,j-1) .le. 0 .or. iflags2(i  ,j+1) .le. 0 .or.
     4       iflags2(i+1,j-1) .le. 0 .or. iflags2(i-1,j-1) .le. 0) then
                 iflags(i,j) = 0
          endif
          iflags(ilo-mbuff,j) = 0   ! set last border to 0 instead of leaving uninitialized
          iflags(ihi+mbuff,j) = 0
 40   continue
 41   continue
      do i = ilo-mbuff,ihi+mbuff   ! finish zeroing out first and last col
         iflags(i,jlo-mbuff) = 0
         iflags(i,jhi+mbuff) = 0
      end do

c  dont need to handle periodicity here.  Setting of initial grid included enough room to shrink 1
c  for proper nesting.  If expand up then will need to add periodic domain flagging

c
c if border of domain touches a physical boundary then set domain in
c ghost cell as well
c
      call setPhysBndryFlags(iflags,ilo,ihi,jlo,jhi,mbuff,level)

 99   if (dprint) then
        write(outunit,*)" from griddomshrink: on exit, iflags"
        do 70 j = jhi+mbuff-1, jlo-mbuff+1, -1
        write(outunit,101)(iflags(i,j),i=ilo-mbuff+1,ihi+mbuff-1)
 101    format(80i1)
 70     continue
      endif

      return
      end

c
c -------------------------------------------------------------
c
       subroutine qad(valbig,mitot,nvar,
     .                svdflx,qc1d,lenbc,lratiox,hx,
     .                maux,aux,auxc1d,delt,mptr)

      use amr_module
       implicit double precision (a-h, o-z)


       logical qprint

       dimension valbig(nvar,mitot)
       dimension qc1d(nvar,lenbc)
       dimension svdflx(nvar,lenbc)
       dimension aux(maux,mitot)
       dimension auxc1d(maux,lenbc)

c
c ::::::::::::::::::::::::::: QAD ::::::::::::::::::::::::::::::::::
c  solve RP between ghost cell value on fine grid and coarse grid
c  value that ghost cell overlaps. The resulting fluctuations
c  are added in to coarse grid value, as a conservation fixup. 
c  Done each fine grid time step. If source terms are present, the
c  coarse grid value is advanced by source terms each fine time step too.

c  No change needed in this sub. for spherical mapping: correctly
c  mapped vals already in bcs on this fine grid and coarse saved
c  vals also properly prepared
c
c Side 1 is the left side of the fine grid patch.
c Side 2 is the right side of the fine grid patch.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c      # local storage
c      # note that dimension here are bigger than dimensions used
c      # in rp1, but shouldn't matter since wave is not used in qad
c      # and for other arrays it is only the last parameter that is wrong
c      #  ok as long as meqn, mwaves < maxvar

       integer  max1dp1
       dimension ql(nvar,max1d+1),    qr(nvar,max1d+1)
       dimension wave(nvar,mwaves,max1d+1), s(mwaves,max1d+1)
       dimension amdq(nvar,max1d+1),  apdq(nvar,max1d+1)
       dimension auxl(maxaux*(max1d+1)),  auxr(maxaux*(max1d+1))
c
c  WARNING: auxl,auxr dimensioned at max possible, but used as if
c  they were dimensioned as the real maux by max1dp1. Would be better
c  of course to dimension by maux by max1dp1 but this wont work if maux=0
c  So need to access using your own indexing into auxl,auxr.
       iaddaux(iaux,i) = iaux + maux*(i-1)

       data qprint/.false./
c
c      aux is auxiliary array with user parameters needed in Riemann solvers
c          on fine grid corresponding to valbig
c      auxc1d is coarse grid stuff from around boundary, same format as qc1d
c      auxl, auxr are work arrays needed to pass stuff to rp1
c      maux is the number of aux variables, which may be zero.
c
       max1dp1 = max1d + 1

       tgrid = rnode(timemult, mptr)
       if (qprint) 
     .      write(dbugunit,*)" working on grid ",mptr," time ",tgrid
       level = node(nestlevel, mptr)
       index = 0

c
c--------
c  side 1
c--------
c
       if (maux.gt.0) then
          do 5 ma = 1,maux
             if (auxtype(ma).eq."xleft") then
c                # Assuming velocity at left-face, this fix
c                # preserves conservation in incompressible flow:
                 auxl(iaddaux(ma,2)) = aux(ma,nghost+1)
               else
c                # Normal case -- we set the aux arrays 
c                # from the cell corresponding  to q
                 auxl(iaddaux(ma,2)) = aux(ma,nghost)
               endif
  5          continue
          endif
       do 10 ivar = 1, nvar
         ql(ivar,2) = valbig(ivar,nghost)
 10    continue

       index = index + 1
       lind = 1
       if (maux.gt.0) then
         do 24 ma=1,maux
            auxr(iaddaux(ma,lind)) = auxc1d(ma,index)
   24       continue
       endif
       do 25 ivar = 1, nvar
         qr(ivar,lind) = qc1d(ivar,index)
 25    continue
    
       if (qprint) then
         write(dbugunit,*) 'side 1, ql and qr:'
            write(dbugunit,4101) i,qr(1,1),ql(1,2)
 4101      format(i3,4e16.6)
         if (maux .gt. 0) then
             write(dbugunit,*) 'side 1, auxr:'
             write(dbugunit,4101) i,(auxr(iaddaux(ma,1)),ma=1,maux)
             write(dbugunit,*) 'side 1, auxl:'
             write(dbugunit,4101) i,(auxl(iaddaux(ma,2)),ma=1,maux)
         endif
       endif

       call rp1(max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              2-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)


c
c we have the wave. for side 1 add into sdflxm
c
       influx  = 1
       do 40 ivar = 1, nvar
           svdflx(ivar,influx) = svdflx(ivar,influx)
     .                     + amdq(ivar,2) * delt
     .                     + apdq(ivar,2) * delt
 40    continue

c--------
c  side 2
c--------
c
        if (maux.gt.0) then
          do 205 ma = 1,maux
             auxr(iaddaux(ma,1)) = aux(ma,mitot-nghost+1)
 205         continue
          endif
        do 210 ivar = 1, nvar
          qr(ivar,1) = valbig(ivar,mitot-nghost+1)
 210      continue

         index = index + 1
         lind = 1
         if (maux.gt.0) then
            do 224 ma=1,maux
             if (auxtype(ma).eq."xleft") then
c                # Assuming velocity at left-face, this fix
c                # preserves conservation in incompressible flow:
                 auxl(iaddaux(ma,lind+1)) = aux(ma,mitot-nghost+1)
               else
                 auxl(iaddaux(ma,lind+1)) = auxc1d(ma,index)
               endif
  224          continue
            endif
         do 225 ivar = 1, nvar
             ql(ivar,lind+1) = qc1d(ivar,index)
 225     continue

       if (qprint) then
         write(dbugunit,*) 'side 2, ql and qr:'
            write(dbugunit,4101) i,ql(1,2),qr(1,1)
       endif

       call rp1(max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              2-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)

c
c we have the wave. for side 2 add into sdflxp
C
          influx  = influx + 1
          do 340 ivar = 1, nvar
              svdflx(ivar,influx) = svdflx(ivar,influx)
     .                     - amdq(ivar,2) * delt
     .                     - apdq(ivar,2) * delt
 340       continue

c      # for source terms:
       if (method(4) .ne. 0) then   ! should I test here if index=0 and all skipped?
           call src1d(nvar,nghost,lenbc,qc1d,maux,auxc1d,tgrid,delt)
c      # how can this be right - where is the integrated src term used?
           endif

       return
       end

c
c -----------------------------------------------------------
c
      subroutine regrid  (nvar,lbase,cut,naux,start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer newnumgrids(maxlv)
      integer(kind=8) :: clock_start2, clock_finish, clock_rate
c
c :::::::::::::::::::::::::::: REGRID :::::::::::::::::::::::::::::::

!> Flag points on each grid with a level > = lbase.
!! cluster them, and fit new subgrids around the clusters.
!! the lbase grids stay fixed during regridding operation.
!! when a parent grid has its error estimated, add its kid grid
!! information to the error grid before clustering. (project)
!! order of grid examination - all grids at the same level, then
!! do the next coarser level.
c
c input parameters:
c     lbase  = highest level that stays fixed during regridding
c     cutoff = criteria for measuring goodness of rect. fit.

c local variables:
c     lcheck = the level being examined.
c     lfnew  = finest grid to be. will replace lfine.

c global
c    mstart  = start of very coarsest grids.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      lcheck    = min0(lfine,mxnest-1)
      lfnew     = lbase
      do 10 i   = 1, mxnest
        newnumgrids(i) = 0
        newstl(i) = 0
 10   continue
      time      = rnode(timemult, lstart(lbase))
c
 20   if (lcheck .lt. lbase) go to 50
          call grdfit(lbase,lcheck,nvar,naux,cut,time,start_time)
          if (newstl(lcheck+1) .eq. 0) go to 40
          lfnew = max0(lcheck + 1,lfnew)
 40       continue
          lcheck = lcheck - 1
c
      go to 20
 50   continue
c
c  end of level loop
c
c  remaining tasks left in regridding:
c  1.  count number of new grids at each level  
      maxnumnewgrids = 0   ! max over all levels. needed for dimensioning
      do lev = lbase+1,lfnew 
          ngridcount = 0
          mptr = newstl(lev)
 52       if (mptr .eq. 0) go to 55
             ngridcount = ngridcount + 1
             mptr = node(levelptr,mptr)
             go to 52

 55       newnumgrids(lev) = ngridcount
          maxnumnewgrids = max(maxnumnewgrids,ngridcount)
      end do
c
c  2. interpolate storage for the new grids.  the starting pointers
c  for each level are in newstl. also reclaim some space before new
c  allocations.
      call system_clock(clock_start2,clock_rate)
      call gfixup(lbase,lfnew,nvar,naux,newnumgrids,maxnumnewgrids)
      call system_clock(clock_finish,clock_rate)
      timeGrdfit2 = timeGrdfit2 + clock_finish - clock_start2
c
c  3. merge data structures (newstl and lstart )
c  finish storage allocation, reclaim space, etc. set up boundary
c  flux conservation arrays
c
c     do 60 level = lbase, lfine-1
c       call prepf(level+1,nvar,naux)
c       call prepc(level,nvar)
c60   continue
c
c  reset numgrids per level, needed for omp parallelization.
c  note that grids may have disappeared, so next loop resets to 0
c  if there are no grids from lfine+1 to mxnest
c
      do 72 levnew = lbase+1, mxnest
        mptr = lstart(levnew)
        ngridcount = 0
        ncells = 0
        do while (mptr .gt. 0)
           ngridcount = ngridcount + 1
           ncells = ncells + (node(ndihi,mptr)-node(ndilo,mptr)+1)
     .                     * (node(ndjhi,mptr)-node(ndjlo,mptr)+1)
           mptr = node(levelptr, mptr)
         end do
         numgrids(levnew) = ngridcount
         numcells(levnew) = ncells
         avenumgrids(levnew) = avenumgrids(levnew) + ngridcount
         iregridcount(levnew) = iregridcount(levnew) + 1
c        sort grids to first ones are the most work. this helps load
c        balancing, but doesn't help locality
         if (ngridcount .gt. 1) call arrangeGrids(levnew,ngridcount)

         if (verbosity_regrid .ge. levnew) then
           write(*,100) levnew,time,ngridcount,ncells
           write(outunit,100) levnew,time,ngridcount,ncells
 100       format("Regridding level ",i3," at t =",e14.6, ":",i6,
     &            " grids with ",i11," cells")
         endif
72     continue

      do 60 level = lbase, lfine-1
        call prepf(level+1,nvar,naux)
        call prepc(level,nvar)
 60   continue
c
c      set up array of grids instead of recomputing at each step
       call makeGridList(lbase)
       do levnew = lbase+1, lfine
          call makeBndryList(levnew)   ! does one level at a time
       end do

      return
      end
c
c -------------------------------------------------------------------
c
!> Sort all grids at level **level**. 
!! Put the most expensive grid in **lstart(level)** 
!! Cost is measured by number of cells.
!! The linked list was also sorted such that the cost of grids
!! decreases from list head to list tail

      subroutine arrangeGrids(level, numg)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer listgrids(numg), cost(numg), index(numg), prevptr
c
c   slow sort for now, putting most expensive grids first on lstart list
c   measure cost by number of cells
c
       mptr = lstart(level)
       do i = 1, numg
         listgrids(i) = mptr
         cost(i) =  (node(ndihi,mptr)-node(ndilo,mptr)+3) *
     1              (node(ndjhi,mptr)-node(ndjlo,mptr)+2)
         index(i) = i
         mptr = node(levelptr, mptr)
       end do
c
c        write(*,*)" before sorting"
c       write(*,*) index
c
       call  qsorti(index, numg, cost)

c       write(*,*)"after sorting"
c       write(*,*) index

c qsort returns in ascending order, repack in descending order
c grids can stay in place, just their levelptrs need to change
       lstart(level) = listgrids(index(numg))  ! last grid is most expensive
       prevptr = listgrids(index(numg))
       do i = 1, numg-1             
          node(levelptr, prevptr) = listgrids(index(numg-i))
          prevptr = listgrids(index(numg-i))
       end do
       node(levelptr,prevptr) = null  !signal the last grid

       return
       end

c
c --------------------------------------------------
c
      subroutine birect(mptr1)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c :::::::::::::  BIRECT :::::::::::::::::::::::::::::::::::::::
c check each grid, starting with mptr1 (either newstl or lstart)
c to see that it has no more than max1d points in either dimensions.
c needed so that scratch array space in stepgrid not exceeded.
c
c also check for too small grids - but has never happened.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      mptr  = mptr1
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
      hz    = hzposs(level)
c
10    continue
      cxlo    = rnode(cornxlo,mptr)
      cxhi    = rnode(cornxhi,mptr)
      cylo    = rnode(cornylo,mptr)
      cyhi    = rnode(cornyhi,mptr)
      czlo    = rnode(cornzlo,mptr)
      czhi    = rnode(cornzhi,mptr)

      nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      nz      = node(ndkhi,mptr) - node(ndklo,mptr) + 1
      minsize = 2*nghost
C  #      if ((nx .lt. minsize .or. ny .lt. minsize .or. nz .lt. minsize)
C  #     .                   .and. (level .lt. lfine)) then
C  #         write(6,*) " made too small a grid - found in birect"
C  #         write(6,*) " fix this problem after all"
C  #         stop
C  #      endif
c
c check number of rows first - if too many, bisect grid with constant x
c plane down the middle. make sure new grid corners are anchored
c on coarse grid point. make sure if bisecting coarse grid that
c new grids have even number of points
c
      if (nx + 2*nghost .gt. max1d) then

         nxl    = nx/2
         if (level .gt. 1) then
           lratio = intratx(level-1)
        else
           lratio = 2
        endif
        nxl = (nxl/lratio)*lratio
        nxr    = nx - nxl
        cxmid  = cxlo + nxl*hx

        mptrnx = nodget()
        node(levelptr,mptrnx) = node(levelptr,mptr)
        node(levelptr,mptr)   = mptrnx

        rnode(cornxhi,mptr) = cxmid

        node(ndihi,mptrnx)  = node(ndihi,mptr)
        node(ndihi,mptr)    = node(ndilo,mptr) + nxl - 1
        node(ndilo,mptrnx)  = node(ndihi,mptr) + 1
        node(ndjhi,mptrnx)  = node(ndjhi,mptr)
        node(ndjlo,mptrnx)  = node(ndjlo,mptr)
        node(ndkhi,mptrnx)  = node(ndkhi,mptr)
        node(ndklo,mptrnx)  = node(ndklo,mptr)

        rnode(cornxlo,mptrnx)    = cxmid
        rnode(cornylo,mptrnx)    = cylo
        rnode(cornzlo,mptrnx)    = czlo
        rnode(cornxhi,mptrnx)    = cxhi
        rnode(cornyhi,mptrnx)    = cyhi
        rnode(cornzhi,mptrnx)    = czhi
        rnode(timemult,mptrnx)   = rnode(timemult,mptr)
        node(nestlevel,mptrnx)   = node(nestlevel,mptr)

        go to 10
c
c check number of columns next - if too many, bisect grid with constant y
c plane down the middle
c
      else if (ny + 2*nghost .gt. max1d) then

         nyl    = ny/2
         if (level .gt. 1) then
            lratio = intraty(level-1)
         else
            lratio = 2
         endif
         nyl = (nyl/lratio)*lratio
         nyr    = ny - nyl
         cymid  =  cylo + nyl*hy

         mptrnx = nodget()
         node(levelptr,mptrnx) = node(levelptr,mptr)
         node(levelptr,mptr)   = mptrnx

         rnode(cornyhi,mptr)   = cymid

         node(ndjhi,mptrnx) = node(ndjhi,mptr)
         node(ndjhi,mptr)   = node(ndjlo,mptr) + nyl - 1
         node(ndjlo,mptrnx) = node(ndjhi,mptr) + 1
         node(ndkhi,mptrnx) = node(ndkhi,mptr)
         node(ndklo,mptrnx) = node(ndklo,mptr)
         node(ndihi,mptrnx) = node(ndihi,mptr)
         node(ndilo,mptrnx) = node(ndilo,mptr)

         rnode(cornxlo,mptrnx)   = cxlo
         rnode(cornylo,mptrnx)   = cymid
         rnode(cornzlo,mptrnx)   = czlo
         rnode(cornxhi,mptrnx)   = cxhi
         rnode(cornyhi,mptrnx)   = cyhi
         rnode(cornzhi,mptrnx)   = czhi
         node(nestlevel,mptrnx)  = node(nestlevel,mptr)
         rnode(timemult,mptrnx)  = rnode(timemult,mptr)
         go to 10
c
c check number of files next - if too many, bisect grid with constant z
c plane down the middle
c
      else if (nz + 2*nghost  .gt. max1d) then

        nzl    = nz/2
        if (level .gt. 1) then
           lratio = intratz(level-1)
        else
           lratio = 2
        endif
        nzl = (nzl/lratio)*lratio
        nzr    = nz - nzl
        czmid  =  czlo + nzl*hz

        mptrnx = nodget()
        node(levelptr,mptrnx) = node(levelptr,mptr)
        node(levelptr,mptr)   = mptrnx

        rnode(cornzhi,mptr)   = czmid

        node(ndkhi,mptrnx) = node(ndkhi,mptr)
        node(ndkhi,mptr)   = node(ndklo,mptr) + nzl - 1
        node(ndklo,mptrnx) = node(ndkhi,mptr) + 1
        node(ndihi,mptrnx) = node(ndihi,mptr)
        node(ndilo,mptrnx) = node(ndilo,mptr)
        node(ndjhi,mptrnx) = node(ndjhi,mptr)
        node(ndjlo,mptrnx) = node(ndjlo,mptr)

        rnode(cornxlo,mptrnx)   = cxlo
        rnode(cornylo,mptrnx)   = cylo
        rnode(cornzlo,mptrnx)   = czmid
        rnode(cornxhi,mptrnx)   = cxhi
        rnode(cornyhi,mptrnx)   = cyhi
        rnode(cornzhi,mptrnx)   = czhi
        node(nestlevel,mptrnx)  = node(nestlevel,mptr)
        rnode(timemult,mptrnx)  = rnode(timemult,mptr)
        go to 10
c
c  grid ok - check the next
c
      else
        mptr = node(levelptr,mptr)
        if (mptr.ne.0) go to 10

      endif

      return
      end

! Riemann solver for the LWR traffic model:

! q_t + (u_max q(1-q))_x = 0

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q

! The speed limit umax should be in the common block cparam.

! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

subroutine rp1(maxm,num_eqn,num_waves,num_aux,num_ghost,num_cells, &
               ql,qr,auxl,auxr,wave,s,amdq,apdq)

    implicit none

    ! Inputs
    integer, intent(in) :: maxm, num_eqn, num_waves, num_aux, num_ghost, num_cells
    double precision, intent(in), dimension(num_eqn, 1-num_ghost:maxm+num_ghost) :: ql,qr
    double precision, intent(in), dimension(num_aux, 1-num_ghost:maxm+num_ghost) :: auxl,auxr
    ! Outputs
    double precision, intent(out) :: s(num_waves,1-num_ghost:num_cells+num_ghost)
    double precision, intent(out) :: wave(num_eqn,num_waves,1-num_ghost:num_cells+num_ghost)
    double precision, intent(out), dimension(num_eqn, 1-num_ghost:maxm+num_ghost) :: amdq,apdq
    ! Locals
    double precision :: sim1, si, flux0, fluxim1, fluxi
    integer :: i

    common /cparam/ umax
    double precision :: umax

    do i=2-num_ghost,num_cells+num_ghost
        ! Compute the wave and speed

        wave(1,1,i) = ql(1,i) - qr(1,i-1)
        s(1,i) = umax * (1.d0 - (qr(1,i-1) + ql(1,i)))

        ! compute left-going and right-going flux differences:
        !------------------------------------------------------
        amdq(1,i) = dmin1(s(1,i), 0.d0) * wave(1,1,i)
        apdq(1,i) = dmax1(s(1,i), 0.d0) * wave(1,1,i)

        ! entropy fix for transonic rarefactions:
        sim1 = umax*(1.d0 - 2.d0*qr(1,i-1))
        si = umax*(1.d0 - 2.d0*ql(1,i))
        if (sim1.lt.0.d0 .and. si.gt.0.d0) then
            flux0 = 0.25d0*umax
            fluxim1 = qr(1,i-1)*umax*(1.d0 - qr(1,i-1))
            fluxi   = ql(1,i)*umax*(1.d0 - ql(1,i))
            amdq(1,i) = flux0 - fluxim1
            apdq(1,i) = fluxi - flux0
        endif
    enddo

    return
end subroutine rp1

subroutine src2(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux,t,dt)
      
    use geoclaw_module, only: g => grav, coriolis_forcing, coriolis
    use geoclaw_module, only: friction_forcing, friction_depth
    use geoclaw_module, only: manning_coefficient
    use geoclaw_module, only: manning_break, num_manning
    use geoclaw_module, only: spherical_distance, coordinate_system
    use geoclaw_module, only: RAD2DEG, pi, dry_tolerance, DEG2RAD
    use geoclaw_module, only: rho_air, rho
    use geoclaw_module, only: earth_radius, sphere_source
      
    use storm_module, only: wind_forcing, pressure_forcing, wind_drag
    use storm_module, only: wind_index, pressure_index
    use storm_module, only: storm_direction, storm_location

    use friction_module, only: variable_friction, friction_index

    implicit none
    
    ! Input parameters
    integer, intent(in) :: meqn,mbc,mx,my,maux
    double precision, intent(in) :: xlower,ylower,dx,dy,t,dt
    
    ! Output
    double precision, intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    double precision, intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Locals
    integer :: i, j, nman
    real(kind=8) :: h, hu, hv, gamma, dgamma, y, fdt, a(2,2), coeff
    real(kind=8) :: xm, xc, xp, ym, yc, yp, dx_meters, dy_meters
    real(kind=8) :: u, v, hu0, hv0
    real(kind=8) :: tau, wind_speed, theta, phi, psi, P_gradient(2), S(2)
    real(kind=8) :: Ddt, sloc(2)
    real(kind=8) :: tanyR, huv, huu, hvv

    ! Algorithm parameters

    ! Parameter controls when to zero out the momentum at a depth in the
    ! friction source term
    real(kind=8), parameter :: depth_tolerance = 1.0d-30

    ! ----------------------------------------------------------------
    ! Spherical geometry source term(s)
    !
    ! These should be included for shallow water on the sphere, 
    ! at least in the mass term, but were only added in v5.9.0 as an option.
    ! rundata.geo_data.sphere_source can now be set in setrun.py
    ! Set sphere_source = 0 to omit source terms for backward compatibility
    ! sphere_source = 1 should become the default?

    if ((coordinate_system == 2) .and. (sphere_source > 0)) then
        ! add in spherical source term in mass equation 
        ! if sphere_source in [1,2],
        ! and also in momentum equations if sphere_source == 2
        do j=1,my
            y = ylower + (j - 0.5d0) * dy
            tanyR = tan(y*DEG2RAD) / earth_radius
            do i=1,mx
                if (q(1,i,j) > dry_tolerance) then
                    ! source term in mass equation:
                    q(1,i,j) = q(1,i,j) + dt * tanyR * q(3,i,j)

                    if (sphere_source == 2) then
                        ! Momentum source terms that drop out if linearized:
                        ! These seem to have very little effect for
                        ! practical problems
                        huv = q(2,i,j)*q(3,i,j)/q(1,i,j)
                        huu = q(2,i,j)*q(2,i,j)/q(1,i,j)
                        hvv = q(3,i,j)*q(3,i,j)/q(1,i,j)
                        q(2,i,j) = q(2,i,j) + dt * tanyR * 2.d0*huv
                        q(3,i,j) = q(3,i,j) + dt * tanyR * (hvv - huu)
                    endif
                endif
            enddo
        enddo
    endif
                
    ! ----------------------------------------------------------------                
    ! Friction source term
    if (friction_forcing) then
        do j=1,my
            do i=1,mx
                ! Extract appropriate momentum
                if (q(1,i,j) < depth_tolerance) then
                    q(2:3,i,j) = 0.d0
                else
                    ! Apply friction source term only if in shallower water
                    if (q(1,i,j) <= friction_depth) then
                        if (.not.variable_friction) then
                            do nman = num_manning, 1, -1
                                if (aux(1,i,j) .lt. manning_break(nman)) then
                                    coeff = manning_coefficient(nman)
                                endif
                            enddo
                        else
                            coeff = aux(friction_index,i,j)
                        endif
                        
                        ! Calculate source term
                        gamma = sqrt(q(2,i,j)**2 + q(3,i,j)**2) * g     &   
                              * coeff**2 / (q(1,i,j)**(7.d0/3.d0))
                        dgamma = 1.d0 + dt * gamma
                        q(2, i, j) = q(2, i, j) / dgamma
                        q(3, i, j) = q(3, i, j) / dgamma
                    endif
                endif
            enddo
        enddo
    endif
    ! End of friction source term

    ! Coriolis source term
    ! TODO: May want to remove the internal calls to coriolis as this could 
    !       lead to slow downs.
    if (coriolis_forcing) then
        do j=1,my
            y = ylower + (j - 0.5d0) * dy
            fdt = coriolis(y) * dt ! Calculate f dependent on coordinate system

            ! Calculate matrix components
            a(1,1) = 1.d0 - 0.5d0 * fdt**2 + fdt**4 / 24.d0
            a(1,2) =  fdt - fdt**3 / 6.d0
            a(2,1) = -fdt + fdt**3 / 6.d0
            a(2,2) = a(1,1)

            do i=1,mx
                q(2,i,j) = q(2, i, j) * a(1,1) + q(3, i, j) * a(1,2)
                q(3,i,j) = q(2, i, j) * a(2,1) + q(3, i, j) * a(2,2)
            enddo
        enddo
    endif
    ! End of coriolis source term

    ! wind -----------------------------------------------------------
    if (wind_forcing) then
        ! Need storm location and direction for sector based wind drag
        sloc = storm_location(t)
        theta = storm_direction(t)
        do j=1,my
            yc = ylower + (j - 0.5d0) * dy
            do i=1,mx
                xc = xlower + (i - 0.5d0) * dx
                if (q(1,i,j) > dry_tolerance) then
                    psi = atan2(yc - sloc(2), xc - sloc(1))
                    if (theta > psi) then
                        phi = (2.d0 * pi - theta + psi) * RAD2DEG
                    else
                        phi = (psi - theta) * RAD2DEG 
                    endif
                    wind_speed = sqrt(aux(wind_index,i,j)**2        &
                                    + aux(wind_index+1,i,j)**2)
                    tau = wind_drag(wind_speed, phi) * rho_air * wind_speed / rho(1)
                    q(2,i,j) = q(2,i,j) + dt * tau * aux(wind_index,i,j)
                    q(3,i,j) = q(3,i,j) + dt * tau * aux(wind_index+1,i,j)
                endif
            enddo
        enddo
    endif
    ! ----------------------------------------------------------------

    ! Atmosphere Pressure --------------------------------------------
    ! Handled in Riemann solver
    ! if (pressure_forcing) then
    !     do j=1,my  
    !         ym = ylower + (j - 1.d0) * dy
    !         yc = ylower + (j - 0.5d0) * dy
    !         yp = ylower + j * dy
    !         do i=1,mx  
    !             xm = xlower + (i - 1.d0) * dx
    !             xc = xlower + (i - 0.5d0) * dx
    !             xp = xlower + i * dx
                
    !             if (coordinate_system == 2) then
    !                 ! Convert distance in lat-long to meters
    !                 dx_meters = spherical_distance(xp,yc,xm,yc)
    !                 dy_meters = spherical_distance(xc,yp,xc,ym)
    !             else
    !                 dx_meters = dx
    !                 dy_meters = dy
    !             endif

    !             ! Extract depths
    !             h = q(1,i,j)

    !             ! Calculate gradient of Pressure
    !             P_gradient(1) = (aux(pressure_index,i+1,j) &
    !                            - aux(pressure_index,i-1,j)) / (2.d0 * dx_meters)
    !             P_gradient(2) = (aux(pressure_index,i,j+1) &
    !                            - aux(pressure_index,i,j-1)) / (2.d0 * dy_meters)

    !                 ! Modify momentum in each layer
    !             if (h > dry_tolerance) then
    !                 q(2, i, j) = q(2, i, j) - dt * h * P_gradient(1) / rho(1)
    !                 q(3, i, j) = q(3, i, j) - dt * h * P_gradient(2) / rho(1)
    !             end if
    !         enddo
    !     enddo
    ! endif

end subroutine src2

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================

!     # Riemann solver in the transverse direction.
!     # This is a dummy routine that returns zeros and is only intended
!     # to illustrate the format of this routine.  See various example
!     # directories for better examples.

!     # This dummy routine can be used if transverse solves are not being
!     # used, i.e. if method(3)=0.

!     # Split asdq (= A^* \Delta q, where * = + or -)
!     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
!     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)


    implicit double precision (a-h,o-z)
    dimension     ql(meqn,1-mbc:maxm+mbc)
    dimension     qr(meqn,1-mbc:maxm+mbc)
    dimension   asdq(meqn,1-mbc:maxm+mbc)
    dimension bmasdq(meqn,1-mbc:maxm+mbc)
    dimension bpasdq(meqn,1-mbc:maxm+mbc)
    dimension   aux1(maux,1-mbc:maxm+mbc)
    dimension   aux2(maux,1-mbc:maxm+mbc)
    dimension   aux3(maux,1-mbc:maxm+mbc)
    dimension s (2,1-mbc:maxm+mbc)

    do 10 i = 2-mbc, mx+mbc
        if (imp == 1) then !left going fluctuation
            ix = i-1
        else !right going fluctuation
            ix = i
        endif

    ! material properties
        pjm=aux1(1,ix) !density at (ix, j-1) where ix=i or i-1
        pj=aux2(1,ix)
        pjp=aux3(1,ix)
        Ejm=aux1(2,ix)
        Ej=aux2(2,ix)
        Ejp=aux3(2,ix)

    ! linearity of the material
        linearity_matjm = nint(aux1(3,ix))
        linearity_matj  = nint(aux2(3,ix))
        linearity_matjp = nint(aux3(3,ix))

    ! eps (strain) at different rows
        epsjm=aux1(4,ix)
        epsj=aux2(4,ix)
        epsjp=aux3(4,ix)

    ! sigmap
        sigmapjm=sigmap(epsjm,Ejm,linearity_matjm)
        sigmapj=sigmap(epsj,Ej,linearity_matj)
        sigmapjp=sigmap(epsjp,Ejp,linearity_matjp)

    ! computation of components of eigenvectors
        r11=1/dsqrt(sigmapjm*pjm)
        r13=-1/dsqrt(sigmapjp*pjp)

    ! shock speeds (eigenvalues of A and B)
        s(1,i)=-dsqrt(sigmapjm/pjm)  !lambda_1, lambda_2=0
        s(2,i)=dsqrt(sigmapjp/pjp)     !lambda_3

        if(ixy == 1) then !x direction, use eigenvectors of matrix B
        ! or the decomposition of the fluctuations
        ! computation of coefficients of the decomposition of the fluctuations.
        ! I called them gamma since beta is used in the decomposition
        ! of the flux difference (notation used in paper for the f-wave)
            gamma1=(asdq(1,i)-r13*asdq(3,i))/(r11-r13)
            gamma3=(-asdq(1,i)+r11*asdq(3,i))/(r11-r13)
        ! computation of the fluctuations
        ! own going part of the normal fluctuation
            bmasdq(1,i)=s(1,i)*gamma1*r11
            bmasdq(2,i)=s(1,i)*gamma1*0
            bmasdq(3,i)=s(1,i)*gamma1*1
        ! p going part of the normal fluctuation
            bpasdq(1,i)=s(2,i)*gamma3*r13
            bpasdq(2,i)=s(2,i)*gamma3*0
            bpasdq(3,i)=s(2,i)*gamma3*1

        else !y direction, use eigenvectors of matrix A
        ! or the decomposition of the fluctuations
            gamma1=(asdq(1,i)-r13*asdq(2,i))/(r11-r13)
            gamma3=(-asdq(1,i)+r11*asdq(2,i))/(r11-r13)
        ! computation of fluctuations
        ! down" going part
            bmasdq(1,i)=s(1,i)*gamma1*r11
            bmasdq(2,i)=s(1,i)*gamma1*1
            bmasdq(3,i)=s(1,i)*gamma1*0
        ! up" going part
            bpasdq(1,i)=s(2,i)*gamma3*r13
            bpasdq(2,i)=s(2,i)*gamma3*1
            bpasdq(3,i)=s(2,i)*gamma3*0
        endif


    10 END DO

    return
    end subroutine rpt2

! =====================================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! =====================================================================
!
!solve Riemann problems for the 1D shallow water equations
!    with source-term resulting from variable topography b(x,t)
!    (h)_t + (u h)_x = 0
!    (uh)_t + (uuh + 0.5*gh**2)_x = -g*h*b_x
!
!
!
!     On input,
!     ql contains the state vector at the left edge of each cell
!     qr contains the state vector at the right edge of each cell
!
!     On output, wave contains the fwaves/s,
!                s the speeds,
!                amdq the  left-going flux difference  A**- \Delta q
!               apdq the right-going flux difference  A**+ \Delta q
!
!     Note that the i'th Riemann problem has left state qr(i-1,:)
!     #                                    and right state ql(i,:)
!     From the basic clawpack routine step1, rp1 is called with ql=qr=q.
!
!      This is for use with the Riemann solver(s) used in GeoClaw
!        but for 1D problems. That is, it calls the same solver for left and
!        right states that is used for 2d problems.
!
!        This routine deals with dry-state problems over topography
!        by testing a wall boundary condition, like that done in GeoClaw 2d
!
!        to call other point-wise Riemann solvers alter the call on line 177

    use geoclaw_module, only: dry_tolerance, grav, rho

    implicit none

    ! Input arguments
    integer, intent(in) :: maxmx,meqn,mwaves,mbc,mx,maux

    double precision, intent(in), dimension(meqn, 1-mbc:maxmx+mbc) :: ql,qr
    double precision, intent(in), dimension(maux, 1-mbc:maxmx+mbc) :: auxl,auxr

    ! Output arguments
    double precision, intent(out) :: s(mwaves, 1-mbc:maxmx+mbc)
    double precision, intent(out) :: fwave(meqn, mwaves, 1-mbc:maxmx+mbc)
    double precision, intent(out), dimension(meqn, 1-mbc:maxmx+mbc) :: amdq,apdq

    !Local
    integer :: m,i,mw,maxiter
    double precision :: hR,hL,huR,huL,uR,uL,hvR,hvL,vR,vL,phiR,phiL
    double precision :: bR,bL,sL,sR,sRoe1,sRoe2,sE1,sE2,uhat,chat
    double precision :: hstartest,hstarHLL,sLtest,sRtest
    double precision :: wall(2), fw(3,3), sw(3)
    double precision :: g,drytol,pL,pR

    g=grav
    drytol=dry_tolerance

    !loop through Riemann problems at each grid cell
      do i=2-mbc,mx+mbc

!-----------------------Initializing-----------------------------------
         !inform of a bad riemann problem from the start
         if((qr(1,i-1).lt.0.d0).or.(ql(1,i) .lt. 0.d0)) then
            write(*,*) 'Negative input: hl,hr,i=',qr(1,i-1),ql(1,i),i
         endif

         !Initialize Riemann problem for grid interface
         do mw=1,mwaves
              s(mw,i)=0.d0
              do m=1,meqn
                 fwave(m,mw,i)=0.d0
              enddo
         enddo


         !skip problem if in a completely dry area
         if (qr(1,i-1).le.drytol.and.ql(1,i).le.drytol) then
            go to 30
         endif

         !Riemann problem variables
         hL = qr(1,i-1)
         hR = ql(1,i)
         huL = qr(2,i-1)
         huR = ql(2,i)
         bL = auxr(1,i-1)
         bR = auxl(1,i)

         hvL=0.d0
         hvR=0.d0

         !check for wet/dry boundary
         sE1= 1.d99
         sE2=-1.d99
         wall(2) = 1.d0
         wall(1) = 1.d0
         if (hR.le.drytol) then
            sLtest=min(-sqrt(g*hL),huL/hL-sqrt(g*hL)) !what would be the Einfeldt speed of wall problem
            hstartest=hL-(huL/sLtest) !what would be middle state in approx Riemann solution
            if (hstartest+bL.lt.bR) then !right state should become ghost values that mirror left for wall problem
               wall(2)=0.d0
               hR=hL
               huR=-huL
               bR=bL
               phiR=phiL
            endif
         elseif (hL.le.drytol) then ! right surface is lower than left topo
            sRtest=max(sqrt(g*hR),huR/hR+sqrt(g*hR)) !what would be the Einfeldt speed of wall
            hstartest= hR-(huR/sRtest) !what would be middle state in approx Rimeann solution
            if (hstartest+bR.lt.bL) then  !left state should become ghost values that mirror right
               wall(1)=0.d0
               hL=hR
               huL=-huR
               bL=bR
               phiL=phiR
            endif
         endif

         if (hR.gt.drytol) then
            uR=huR/hR
            vR=hvR/hR
            phiR = 0.5d0*g*hR**2 + huR**2/hR
         else
            hR = 0.d0
            huR = 0.d0
            uR = 0.d0
            vR = 0.d0
            phiR = 0.d0
            sE2 = max(sE2,huL/hL+2.d0*sqrt(g*hL))
         endif

         if (hL.gt.drytol) then
            uL=huL/hL
            vL=hvL/hL
            phiL = 0.5d0*g*hL**2 + huL**2/hL
         else
            hL=0.d0
            huL=0.d0
            uL=0.d0
            vL=0.d0
            phiL = 0.d0
            sE1 = min(sE1,huR/hR - 2.d0*sqrt(g*hR))
         endif

         !determine wave speeds
         sL=uL-sqrt(g*hL) ! 1 wave speed of left state
         sR=uR+sqrt(g*hR) ! 2 wave speed of right state

         uhat=(sqrt(g*hL)*uL + sqrt(g*hR)*uR)/(sqrt(g*hR)+sqrt(g*hL)) ! Roe average
         chat=sqrt(g*0.5d0*(hR+hL)) ! Roe average
         sRoe1=uhat-chat ! Roe wave speed 1 wave
         sRoe2=uhat+chat ! Roe wave speed 2 wave

         sE1 = min(sE1,min(sL,sRoe1)) ! Eindfeldt speed 1 wave
         sE2 = max(sE2,max(sR,sRoe2)) ! Eindfeldt speed 2 wave

         !--------------------end initializing...finally----------
         !solve Riemann problem.

         maxiter = 1

         ! In case there is no pressure forcing
         pL = 0.d0
         pR = 0.d0

         call riemann_aug_JCP(maxiter,3,3,hL,hR,huL, &
              huR,hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR, &
              sE1,sE2,drytol,g,rho,sw,fw)

!         call riemann_ssqfwave(maxiter,meqn+1,mwaves+1,hL,hR,huL,huR, &
!         &  hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2,drytol,g,rho,sw,fw)

!         call riemann_fwave(meqn+1,mwaves+1,hL,hR,huL,huR,hvL,hvR, &
!           &   bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2,drytol,g,rho,sw,fw)

         s(1,i) = sw(1)*wall(1)
         s(2,i) = sw(3)*wall(2)

         do m=1,meqn
            fwave(m,1,i)=fw(m,1)*wall(1)
            fwave(m,2,i)=fw(m,3)*wall(2)
            if (sw(2)>0.0) then
               fwave(m,2,i) = fwave(m,2,i) + fw(m,2)*wall(2)
            else
               fwave(m,1,i) = fwave(m,1,i) + fw(m,2)*wall(1)
            endif
         enddo




 30      continue
      enddo


      do i=2-mbc,mx+mbc
         do m=1,meqn
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do  mw=1,mwaves
               if (s(mw,i).lt.0.d0) then
                  amdq(m,i) = amdq(m,i) + fwave(m,mw,i)
               elseif (s(mw,i).gt.0.d0) then
                  apdq(m,i) = apdq(m,i) + fwave(m,mw,i)
               else
                  amdq(m,i) = amdq(m,i) + .5d0*fwave(m,mw,i)
                  apdq(m,i) = apdq(m,i) + .5d0*fwave(m,mw,i)
               endif
            enddo
         enddo
      enddo

      return
      end subroutine rp1

c
c -----------------------------------------------------------
c
      subroutine regrid  (nvar,lbase,cut,naux,start_time)
c
      use amr_module
      use bouss_module
      implicit double precision (a-h,o-z)
      integer newnumgrids(maxlv)
      integer(kind=8) :: clock_start2, clock_finish, clock_rate
      type(matrix_patchIndex), pointer :: mi
      type(matrix_levInfo),  pointer :: minfo

c
c :::::::::::::::::::::::::::: REGRID :::::::::::::::::::::::::::::::

!> Flag points on each grid with a level > = lbase.
!! cluster them, and fit new subgrids around the clusters.
!! the lbase grids stay fixed during regridding operation.
!! when a parent grid has its error estimated, add its kid grid
!! information to the error grid before clustering. (project)
!! order of grid examination - all grids at the same level, then
!! do the next coarser level.
c
c input parameters:
c     lbase  = highest level that stays fixed during regridding
c     cutoff = criteria for measuring goodness of rect. fit.

c local variables:
c     lcheck = the level being examined.
c     lfnew  = finest grid to be. will replace lfine.

c global
c    mstart  = start of very coarsest grids.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      lcheck    = min0(lfine,mxnest-1)
      lfnew     = lbase
      do  i   = 1, mxnest
        newnumgrids(i) = 0
        newstl(i) = 0
      end do
      time      = rnode(timemult, lstart(lbase))
c
 20   if (lcheck .lt. lbase) go to 50
          call grdfit(lbase,lcheck,nvar,naux,cut,time,start_time)
          if (newstl(lcheck+1) .eq. 0) go to 40
          lfnew = max0(lcheck + 1,lfnew)
 40       continue
          lcheck = lcheck - 1
c
      go to 20
 50   continue
c
c  end of level loop
c
c  remaining tasks left in regridding:
c  1.  count number of new grids at each level  
      maxnumnewgrids = 0   ! max over all levels. needed for dimensioning
      do lev = lbase+1,lfnew 
          ngridcount = 0
          mptr = newstl(lev)
 52       if (mptr .eq. 0) go to 55
             ngridcount = ngridcount + 1
             mptr = node(levelptr,mptr)
             go to 52

 55       newnumgrids(lev) = ngridcount
          maxnumnewgrids = max(maxnumnewgrids,ngridcount)
      end do
c
c  2. interpolate storage for the new grids.  the starting pointers
c  for each level are in newstl. also reclaim some space before new
c  allocations.
      call system_clock(clock_start2,clock_rate)
      call gfixup(lbase,lfnew,nvar,naux,newnumgrids,maxnumnewgrids)
      call system_clock(clock_finish,clock_rate)
      timeGrdfit2 = timeGrdfit2 + clock_finish - clock_start2
c
c  3. merge data structures (newstl and lstart )
c  finish storage allocation, reclaim space, etc. set up boundary
c  flux conservation arrays
c

c     get rid of old bouss storage
      if (max(lbase+1,minLevelBouss) .le. maxLevelBouss .and.
     &     ibouss .gt. 0) then  ! need to redo bouss stuff
        do lev = max(lbase+1,minLevelBouss), maxLevelBouss
          minfo => matrix_info_allLevs(lev)
          if (minfo%numBoussGrids .gt. 0) then
            do j = 1, minfo%numBoussGrids
               mi => minfo%matrix_indices(j)
               deallocate(mi%mindex)
               deallocate(mi%isBouss)
            end do
            deallocate(minfo%matrix_indices) ! get rid of old one 
            ! also deallocate matrix since new one will have diff size
            if (.not. crs) then ! COO triplet format
             deallocate(minfo%matrix_ia,minfo%matrix_ja,minfo%matrix_sa)
            else  ! CRS format
             deallocate(minfo%rowPtr, minfo%cols, minfo%vals)
            endif
            minfo%numBoussGrids = 0  ! reset for new counting
            minfo%numBoussCells = 0  ! reset for new counting
          endif
        end do
      endif

!     also get rid of pardiso storage, new levels need to new factorizations
      if (isolver .eq. 2) then
#ifdef HAVE_PARDISO
        phase = -1  ! release internal memory
        msglvl = 0
        do lev = lbase+1,mxnest
           newGrids(lev) = .true.
           if (lev.le.maxLevelBouss .and.  lev.ge.minLevelBouss) then
               !write(*,*)"regrid is releasing pardiso for lev ",lev
               CALL pardiso(pt(1,lev),maxfct,mnum,mtype,phase,nn,ddum,
     &                    idum, idum,idum,nrhs,iparm,msglvl,
     &                    ddum,ddum,error,dparm)
           endif
         end do
#endif
      else if (isolver .eq. 3) then
         newGrids(lbase+1:maxlv) = .true.
      endif

c     set deepest bathy for each grid
      if (lbase .lt. maxLevelBouss .and. ibouss.gt.0) then ! set up new bouss stuff
        do lev = lbase+1, lfine
           minfo => matrix_info_allLevs(lev)
           mptr = lstart(lev)
   74         continue
              nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
              ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
              locaux = node(storeaux,mptr)
              !call setMaxMinDepth(alloc(locaux),mptr,naux,nx,ny,nghost)
              if (lev.le.maxLevelBouss .and. lev.ge.minLevelBouss) then
                    minfo%numBoussGrids = minfo%numBoussGrids+1
              endif
              mptr = node(levelptr, mptr)
              if (mptr .ne. 0) go to 74
           ! done with grids at this level
           if (minfo%numBoussGrids .gt. 0) then
              allocate(minfo%matrix_indices(minfo%numBoussGrids))
           endif
        end do
      endif

      ! initialize pardiso for new grids at this level
      if (isolver .eq. 2 .and. ibouss.gt.0) then
#ifdef HAVE_PARDISO
        do lev = lbase+1, mxnest
           if (lev.le.maxLevelBouss .and. lev.ge.minLevelBouss) then
                call pardisoinit(pt(1,lev),mtype,solver,iparm,dparm,
     &                           error)
                !write(*,*)"regrid initialized pardiso for lev ",lev
           endif
        end do
#endif
      endif
c
c  reset numgrids per level, needed for omp parallelization.
c  note that grids may have disappeared, so next loop resets to 0
c  if there are no grids from lfine+1 to mxnest
c
      do 72 levnew = lbase+1, mxnest
        mptr = lstart(levnew)
        ngridcount = 0
        ncells = 0
        do while (mptr .gt. 0)
           ngridcount = ngridcount + 1
           ncells = ncells + (node(ndihi,mptr)-node(ndilo,mptr)+1)
     .                     * (node(ndjhi,mptr)-node(ndjlo,mptr)+1)
           mptr = node(levelptr, mptr)
         end do
         if (ngridcount .ne. newnumgrids(levnew)) then
            write(*,*)"regrid grid count off at time",time
            stop
         endif
         numgrids(levnew) = ngridcount
         numcells(levnew) = ncells
         avenumgrids(levnew) = avenumgrids(levnew) + ngridcount
         iregridcount(levnew) = iregridcount(levnew) + 1
c        sort grids to first ones are the most work. this helps load
c        balancing, but doesn't help locality
         !commented out enxt line because now already sorted in prepnewgrids above
         ! changed 9/25/23 by mjb for better grid placement in filval par for loop 
         if (ngridcount .gt. 1) call arrangeGrids(levnew,ngridcount)

         if (verbosity_regrid .ge. levnew) then
           write(*,100) ngridcount,ncells,levnew
           write(outunit,100) ngridcount,ncells,levnew
 100       format("there are ",i6," grids with ",i10,
     &            " cells at level ", i3)
         endif
72     continue

      do 60 level = lbase, lfine-1
        call prepf(level+1,nvar,naux)
        call prepc(level,nvar)
 60   continue
c
c      set up array of grids instead of recomputing at each step
       call makeGridList(lbase)
       do levnew = lbase+1, lfine
          call makeBndryList(levnew)   ! does one level at a time
       end do
c
c     set up for Bouss matrices
      if (ibouss .gt. 0) then ! 0 is SWE, otherwise setup for bouss
         do lev = lbase+1,lfine
           if (lev.le. maxLevelBouss .and. lev .ge. minLevelBouss)then
              call setMatrixIndex(lev)
              call setBoussFlag(lev,naux)
           endif
         end do
      endif
c
      return
      end
c
c -------------------------------------------------------------------
c
!> Sort all grids at level **level**. 
!! Put the most expensive grid in **lstart(level)** 
!! Cost is measured by number of cells.
!! The linked list was also sorted such that the cost of grids
!! decreases from list head to list tail

      subroutine arrangeGrids(level, numg)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer listgrids(numg), cost(numg), index(numg), prevptr
c
c   slow sort for now, putting most expensive grids first on lstart list
c   measure cost by number of cells
c
       mptr = lstart(level)
       do i = 1, numg
         listgrids(i) = mptr
         cost(i) =  (node(ndihi,mptr)-node(ndilo,mptr)+3) *
     1              (node(ndjhi,mptr)-node(ndjlo,mptr)+2)
         index(i) = i
         mptr = node(levelptr, mptr)
       end do
c
c        write(*,*)" before sorting"
c       write(*,*) index
c
       call  qsorti(index, numg, cost)

c       write(*,*)"after sorting"
c       write(*,*) index

c qsort returns in ascending order, repack in descending order
c grids can stay in place, just their levelptrs need to change
       lstart(level) = listgrids(index(numg))  ! last grid is most expensive
       prevptr = listgrids(index(numg))
       do i = 1, numg-1             
          node(levelptr, prevptr) = listgrids(index(numg-i))
          prevptr = listgrids(index(numg-i))
       end do
       node(levelptr,prevptr) = null  !signal the last grid

       return
       end

!     =====================================================
!     # Apply a limiter to the waves.
!     # The limiter is computed by comparing the 2-norm of each wave with
!     # the projection of the wave from the interface to the left or
!     # right onto the current wave.  For a linear system this would
!     # correspond to comparing the norms of the two waves.  For a
!     # nonlinear problem the eigenvectors are not colinear and so the
!     # projection is needed to provide more limiting in the case where the
!     # neighboring wave has large norm but points in a different direction
!     # in phase space.
!
!     # The specific limiter used in each family is determined by the
!     # value of the corresponding element of the array mthlim, as used in
!     # the function philim.
!     # Note that a different limiter may be used in each wave family.
!
!     # dotl and dotr denote the inner product of wave with the wave to
!     # the left or right.  The norm of the projections onto the wave are then
!     # given by dotl/wnorm2 and dotr/wnorm2, where wnorm2 is the 2-norm
!     # of wave.
!
!     # Copied from rewritten inlinelimiter.f90

subroutine limiter(maxm,num_eqn,num_waves,num_ghost,mx,wave,s,mthlim)

    implicit none

    ! Arguments
    integer, intent(in) :: maxm, num_eqn, num_waves, num_ghost, mx
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: s(num_waves, 1-num_ghost:maxm+num_ghost)
    integer, intent(in) :: mthlim(num_waves)

    real(kind=8), external :: philim

    ! Local storage
    integer :: m, mw, i
    real(kind=8) :: r, c, wlimiter, wnorm2, dotl
    real(kind=8), dimension(num_waves) :: dotr

    dotr = 0.d0

    x_loop: do i = 0, mx+1

        wave_loop: do mw=1,num_waves
            if (mthlim(mw) == 0) then
                cycle wave_loop
            endif

            ! Construct dot products
            wnorm2 = 0.d0
            dotl = dotr(mw)
            dotr(mw) = 0.d0
            do m=1,num_eqn
                wnorm2 = wnorm2 + wave(m,mw,i)**2
                dotr(mw) = dotr(mw) + wave(m,mw,i)*wave(m,mw,i+1)
            end do

            ! Skip this loop if it's on the boundary or the size of the wave is
            ! zero (but still want dot products to be initialized above)
            if (i == 0) cycle wave_loop
            if (wnorm2 == 0.d0) cycle wave_loop
        
            ! Compute ratio of this wave's strength to upwind wave's strength
            if (s(mw,i) > 0.d0) then
                wlimiter = philim(wnorm2, dotl, mthlim(mw))
            else
                wlimiter = philim(wnorm2, dotr(mw), mthlim(mw))
            endif

            ! Apply resulting limit
            wave(:,mw,i) = wlimiter * wave(:,mw,i)
        
        end do wave_loop
    end do x_loop

end subroutine limiter

! =====================================================
subroutine rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! =====================================================

!     # Adjoint Riemann solver for the acoustics equations in 1d, with
!     #  variable coefficients (heterogeneous media)

!     # auxl(1,i) should contain the impedance Z in cell i
!     # auxl(2,i) should contain the sound speed c in cell i

    implicit double precision (a-h,o-z)

    dimension auxl(maux, 1-mbc:maxm+mbc)
    dimension auxr(maux, 1-mbc:maxm+mbc)
    dimension fwave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn, 1-mbc:maxm+mbc)
    dimension amdq(meqn, 1-mbc:maxm+mbc)

!     local arrays
!     ------------
    dimension delta(2)


!   # split the jump in f(q) at each interface into f-waves

!   # find a1 and a2, the coefficients of the 2 eigenvectors:
    do 20 i = 2-mbc, mx+mbc
!       # material properties
        zi = auxl(1,i)
        zim = auxr(1,i-1)
        ci = auxl(2,i)
        cim = auxr(2,i-1)
        rhoi = zi/ci
        rhoim = zim/cim
        bulki = rhoi*ci**2
        bulkim = rhoim*cim**2

!       # f-wave splitting
        delta(1) = -(ql(2,i)/rhoi - qr(2,i-1)/rhoim)
        delta(2) = -(bulki*ql(1,i) - bulkim*qr(1,i-1))

        beta1 = (delta(2) + zi*delta(1)) / (zim + zi)
        beta2 = (-delta(2) + zim*delta(1)) / (zim + zi)
    
!       # Compute the waves.  Eigenvectors switched for adjoint:
    
        fwave(1,1,i) = beta1
        fwave(2,1,i) = beta1*zim
        s(1,i) = -cim
    
        fwave(1,2,i) = beta2
        fwave(2,2,i) = -beta2*zi
        s(2,i) = ci
    
    20 END DO

!     # compute the leftgoing and rightgoing fluctuations:
!     # Note s(1,i) < 0   and   s(2,i) > 0.

!   # f-wave spitting, so do not multiply by wave speeds:
    do 220 m=1,meqn
        do 220 i = 2-mbc, mx+mbc
            amdq(m,i) = fwave(m,1,i)
            apdq(m,i) = fwave(m,2,i)
    220 END DO

    return
    end subroutine rp1

! =====================================================
subroutine rpn2_ptwise(ixy, num_eqn, num_aux, num_waves, q_l, q_r,            &
aux_l, aux_r, wave, s, amdq, apdq)
! =====================================================

! Riemann solver for the sample scalar equation
!  q_t + u*q_x + v*q_y = 0

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.
! On output, wave contains the waves,
!            s the speeds,
!
!            amdq = A^- Delta q,
!            apdq = A^+ Delta q,
!                   the decomposition of the flux difference
!                       f(qr(i-1)) - f(ql(i))
!                   into leftgoing and rightgoing parts respectively.
!

! maux=0 and aux arrays are unused in this example.

    implicit none

    ! Input
    integer, intent(in) :: num_eqn, num_aux, num_waves, ixy
    real(kind=8), intent(in) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in) :: aux_l(num_aux), aux_r(num_aux)

    ! Output
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Common block
    real(kind=8) :: u, v
    common /cparam/ u, v

    wave(1,1) = q_r(1) - q_l(1)
    if (ixy == 1) then
        s(1) = u
    else
        s(1) = v
    endif
    
    ! Flux differences
    amdq(1) = dmin1(s(1), 0.d0) * wave(1,1)
    apdq(1) = dmax1(s(1), 0.d0) * wave(1,1)

    end subroutine rpn2_ptwise

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::: Parameters, variables, subroutines related to gauges
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

! Contains:
!   subroutine set_gauges
!     Called initially to read from gauges.data
!   subroutine setbestsrc
!     Called each time regridding is done to determine which patch to 
!     use for interpolating to each gauge location.
!   subroutine print_gauges
!     Called each time step for each grid patch.
!     Refactored dumpgauge routine to interpolate for all gauges on patch.
!
!     Note: by default all components of q are printed at each gauge.
!     To print something different or a different precision, modify 
!     format statement 100 and/or the write statement that uses it.
!   
! Note: Updated for Clawpack 5.3.0:
!   - the dumpgauge and setbestsrc subroutines have been moved to this module 
!     and the dumpgauge subroutine has been refactored and renamed print_gauges.
!   - dumpgauge.f must be removed from Makefiles.
!   - setbestsrc uses quicksort to sort gauge numbers and
!     then figures out which gauges will be updated by grid, and stores this
!     information in new module variables mbestg1, mbestg2.
!   - print_gauges no longer uses binary search to locate first gauge handled
!     by a grid.  Instead loop over gauges specified by mbestg1, mbestg2.
!
! Note: Updated for Clawpack 5.4.0
!   - refactor so each gauge writes to its own file, and batches the writes instead of 
!     writing one at a time. This will remove the critical section and should speed up gauges a lot
!   - When array is filled, that gauge will write to file and start over. 
!   - Need to save index so know position in array where left off
!   - At checkpoint times, dump all gauges
!
! Note: Updated for Clawpack 5.4.x
!  - Add gauge formatting capabilities
!
! Changed mjb, May, 2018 hackathon, to remove need for mbestg1 and mbestg2.
! looked at since they depended on maxgr, which is now a variable, not constant.
! also, algorithms didn't scale for O(10^5) grids, and O(100) gauges..

module gauges_module

    implicit none
    save

    logical, private :: module_setup = .false.

    integer, parameter :: OUTGAUGEUNIT=89
    integer :: num_gauges

    integer, parameter :: MAX_BUFFER = 1000

    ! Gauge data types
    type gauge_type
        ! Gauge number
        integer :: gauge_num
        integer :: gdata_bytes

        character(len=24) :: file_name      ! for header (and data if 'ascii')
        character(len=24) :: file_name_bin  ! used if file_format='binary'

        ! Location in time and space
        real(kind=8) :: x, y, t_start, t_end

        ! Last time recorded
        real(kind=8) :: last_time

        ! Last time and final (x,y) written to file 
        ! (only needed for lagrangian gauges, for checkpointing)
        real(kind=8) :: t_last_written, x_last_written, y_last_written


        ! Output settings
        integer :: file_format, gtype
        real(kind=8) :: min_time_increment
        character(len=10) :: display_format
        logical, allocatable :: q_out_vars(:)
        logical, allocatable :: aux_out_vars(:)
        integer :: num_out_vars

        ! Data buffers - data holds output and time
        real(kind=8), allocatable :: data(:, :)
        integer :: level(MAX_BUFFER)

        ! Where we are in the buffer
        integer :: buffer_index
    end type gauge_type

    ! Gague array
    type(gauge_type), allocatable :: gauges(:)

    ! Gauge source info
    integer, allocatable, dimension(:) ::  mbestsrc, igauge

    logical, parameter :: INTERPOLATE = .true.

contains

    subroutine set_gauges(restart, num_eqn, num_aux, fname)

        use utility_module, only: get_value_count
        use amr_module, only: NEEDS_TO_BE_SET

        implicit none

        ! Input
        logical, intent(in) :: restart
        integer :: num_eqn, num_aux
        character(len=*), intent(in), optional :: fname

        ! Locals
        integer :: i, n, index
        integer :: num, pos, digit
        integer, parameter :: UNIT = 7
        character(len=128) :: header_1
        character(len=40) :: q_column, aux_column
        character(len=15) :: numstr

        if (.not.module_setup) then

            ! Open file
            if (present(fname)) then
                call opendatafile(UNIT,fname)
            else
                call opendatafile(UNIT,'gauges.data')
            endif

            read(UNIT,*) num_gauges
            allocate(gauges(num_gauges))
            
            ! Initialize gauge source data
            allocate(mbestsrc(num_gauges))
            mbestsrc = 0

            ! Original gauge information
            do i=1,num_gauges
                read(UNIT, *) gauges(i)%gauge_num, gauges(i)%x, gauges(i)%y, &
                              gauges(i)%t_start, gauges(i)%t_end
                ! note that for lagrangian gauges, the x,y values read here 
                ! might be overwritten if this is a restart
                gauges(i)%buffer_index = 1
                gauges(i)%last_time = gauges(i)%t_start
                ! keep track of last position for lagrangian gauges,
                ! initialize here in case checkpoint happens before 
                ! ever writing this gauge:
                gauges(i)%t_last_written = NEEDS_TO_BE_SET
                gauges(i)%x_last_written = gauges(i)%x
                gauges(i)%y_last_written = gauges(i)%y
            enddo

            ! Read in output formats
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%file_format, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%display_format, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%min_time_increment, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%gtype, i=1, num_gauges)

            ! Read in q fields
            read(UNIT, *)
            read(UNIT, *)
            do i = 1, num_gauges
                allocate(gauges(i)%q_out_vars(num_eqn))
                read(UNIT, *) gauges(i)%q_out_vars

                ! Count number of vars to be output
                gauges(i)%num_out_vars = 0
                do n = 1, size(gauges(i)%q_out_vars, 1)
                    if (gauges(i)%q_out_vars(n)) then
                        gauges(i)%num_out_vars = gauges(i)%num_out_vars + 1
                    end if
                end do
            end do

            ! Read in aux fields (num_aux > 0 for geoclaw)
            read(UNIT, *)
            read(UNIT, *)
            do i = 1, num_gauges
                allocate(gauges(i)%aux_out_vars(num_aux))
                read(UNIT, *) gauges(i)%aux_out_vars

                ! Count number of vars to be output
                do n = 1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        gauges(i)%num_out_vars = gauges(i)%num_out_vars + 1
                    end if
                end do
            end do

            ! Count eta as one of the out vars
            gauges(:)%num_out_vars = gauges(:)%num_out_vars + 1

            close(UNIT)
            ! Done reading =====================================================

            ! Allocate data buffer - Note extra var out due to eta
            do i = 1, num_gauges
                allocate(gauges(i)%data(gauges(i)%num_out_vars + 2, MAX_BUFFER))
            end do

            ! Create gauge output files
            do i = 1, num_gauges
                num = gauges(i)%gauge_num

                ! convert num to string numstr with zero padding if <5 digits
                ! since we want format gauge00012.txt or gauge1234567.txt:
                write (numstr,'(I0.5)') num
                gauges(i)%file_name = 'gauge'//trim(numstr)//'.txt'

                if (gauges(i)%file_format >= 2) then
                    gauges(i)%file_name_bin = 'gauge'//trim(numstr)//'.bin'
                endif


                ! for restart, do not need to know if gauge file already exists,
                ! so some code removed
                
                if (.not. restart) then

                    if (gauges(i)%file_format >= 2) then
                        ! remove old binary file if it exists:
                        !write(6,*) 'Removing old file ',gauges(i)%file_name_bin
                        open(unit=OUTGAUGEUNIT, file=gauges(i)%file_name_bin, &
                             status='unknown', access='stream')
                        close(unit=OUTGAUGEUNIT, status='delete')
                    endif

                    ! open and rewind old ascii file if it exists:
                    open(unit=OUTGAUGEUNIT, file=gauges(i)%file_name,   &
                         status='unknown', position='rewind', form='formatted')
                    ! will be closed after writing header below
                endif
                     

                if (.not. restart) then
                    ! Write header to .txt file:
                    header_1 = "('# gauge_id= ',i0,' " //                 &
                               "location=( ',1e17.10,' ',1e17.10,' ) " // &
                               "num_var= ',i2)"
                    write(OUTGAUGEUNIT, header_1) gauges(i)%gauge_num,    &
                                                  gauges(i)%x,            &
                                                  gauges(i)%y,            &
                                                  gauges(i)%num_out_vars

                    if (gauges(i)%gtype == 1) then
                        ! Standard gauge
                        write(OUTGAUGEUNIT, '(a)') "# Stationary gauge"
                      else if (gauges(i)%gtype == 2) then
                        ! Lagrangian gauge
                        write(OUTGAUGEUNIT, '(a)') "# Lagrangian particle,"// &
                                    " q[2,3] replaced by (x(t),y(t))"
                      endif

                    ! Construct column labels
                    index = 0
                    q_column = "["
                    do n=1, size(gauges(i)%q_out_vars, 1)
                        if (gauges(i)%q_out_vars(n)) then
                            write(q_column(3 * index + 2:4 + 3 * index), "(i3)") n
                            index = index + 1
                        end if  
                    end do
                    q_column(3 * index + 2:4 + 3 * index) = "],"

                    aux_column = "["
                    index = 0
                    do n=1, size(gauges(i)%aux_out_vars, 1)
                        if (gauges(i)%aux_out_vars(n)) then
                            write(aux_column(3 * index + 2:4 + 3 * index), "(i3)") n
                            index = index + 1
                        end if  
                    end do
                    aux_column(3 * index + 2:4 + 3 * index) = "]"

                    write(OUTGAUGEUNIT, "(a,a,a,a)") "# level, time, q",       &
                                           trim(q_column), " eta, aux",        &
                                           trim(aux_column)
                    if (gauges(i)%file_format == 1) then
                        write(OUTGAUGEUNIT, '(a)') &
                          "# file format ascii, time series follow in this file"
                    else if (gauges(i)%file_format == 2) then
                        write(OUTGAUGEUNIT, '(a)') &
                            "# file format binary64, time series in .bin file"
                    else if (gauges(i)%file_format == 3) then
                        write(OUTGAUGEUNIT, '(a)') &
                            "# file format binary32, time series in .bin file"
                    endif
                    
                   close(OUTGAUGEUNIT)

               endif  ! end of ascii header file


            end do

            module_setup = .true.
        end if

    end subroutine set_gauges


!
! --------------------------------------------------------------------
!
    subroutine setbestsrc(igauge)
!
!     Called every time grids change, to set the best source grid patch
!     for each gauge, i.e. the finest level patch that includes the gauge.
!
!     lbase is grid level that didn't change, but since fine
!     grid may have disappeared, we still have to look starting
!     at coarsest level 1.
!
        use amr_module
        implicit none

        integer, intent(in), optional :: igauge
        integer :: lev, mptr, i, i1, i2

!
! ##  set source grid for each loc from finest level to coarsest
! ##  and goes on to the next gauge once a patch is found.

! ##  This modified version allows an optional igauge argument
! ##  to only update one gauge, for Lagrangian gauges (particle tracking)

        if (present(igauge)) then
            ! only loop over one gauge
            i1 = igauge
            i2 = igauge
          else
            ! normal case of setting for all gauges
            i1 = 1
            i2 = num_gauges
          endif

        ! for debugging, initialize sources to 0 then check that all set
        mbestsrc(i1:i2) = 0

        !! reorder loop for better performance with O(10^5) grids
        !! for each gauge find best source grid for its data
        do 40 i = i1,i2

           do 30 lev = lfine, 1, -1
            mptr = lstart(lev)
 20              if ((gauges(i)%x >= rnode(cornxlo,mptr)) .and. &
                        (gauges(i)%x <= rnode(cornxhi,mptr)) .and. &  
                        (gauges(i)%y >= rnode(cornylo,mptr)) .and. &
                        (gauges(i)%y <= rnode(cornyhi,mptr)) ) then
                        mbestsrc(i) = mptr
                      !! best source found for this gauge, go to next one
                      !! we know its the best because we started at finest level
                      go to 40  ! on to next gauge 
                 else 
                mptr = node(levelptr, mptr)
                    if (mptr .ne. 0) then
                       go to 20  ! try another grid
                    else
                       go to 30  ! try next coarser level grids
            end if
                 end if
 30        continue 

          if (mbestsrc(i) .eq. 0) then
              if ((gauges(i)%x < xlower) .or. (gauges(i)%x > xupper) .or. &
                  (gauges(i)%y < ylower) .or. (gauges(i)%y > yupper)) then
                  print *, "Gauge number ",gauges(i)%gauge_num, &
                      " is outside domain"
                else
                  print *, "ERROR in setting grid src for gauge number ",&
                      gauges(i)%gauge_num
                  print *, "    x,y = ",gauges(i)%x, gauges(i)%y
                endif
              endif
 40     continue 

!!!  NO MORE qsort and mbestg arrays. 
!!! Each grid now loops over mbestsrc array to see which gauges it owns.

    end subroutine setbestsrc

!
! -------------------------------------------------------------------------
!
    subroutine update_gauges(q, aux, xlow, ylow, num_eqn, mitot, mjtot, num_aux, &
                             mptr)
!
!     This routine is called each time step for each grid patch, to output
!     gauge values for all gauges for which this patch is the best one to 
!     use (i.e. at the finest refinement level).  

!     It is called after ghost cells have been filled from adjacent grids
!     at the same level, so bilinear interpolation can be used to 
!     to compute values at any gauge location that is covered by this grid.  

!     The grid patch is designated by mptr.
!     We only want to set gauges i for which mbestsrc(i) == mptr.
!     The array mbestsrc is reset after each regridding to indicate which
!     grid patch is best to use for each gauge.

!     This is a refactoring of dumpgauge.f from Clawpack 5.2 
!     Loops over only the gauges to be handled by this grid, as specified
!     by indices from mbestg1(mptr) to mbestg2(mptr)
!     NO MORE mbestg1 and 2.  Loop through all gauges. No sorting too.

        use amr_module, only: nestlevel, nghost, timemult, rnode, node, maxvar
        use amr_module, only: maxaux, hxposs, hyposs, possk
        use geoclaw_module, only: dry_tolerance
        use geoclaw_module, only: coordinate_system, earth_radius, deg2rad
        use geoclaw_module, only: ambient_pressure
        use storm_module, only: pressure_index

        implicit none

        ! Input
        integer, intent(in) ::  num_eqn, mitot, mjtot, num_aux, mptr
        real(kind=8), intent(in) :: q(num_eqn, mitot, mjtot)
        real(kind=8), intent(in) :: aux(num_aux, mitot, mjtot)
        real(kind=8), intent(in) :: xlow, ylow

        ! Locals
        real(kind=8) :: var(maxvar + maxaux)
        real(kind=8) :: xcent, ycent, xoff, yoff, tgrid, hx, hy
        integer :: level, icell, jcell, iindex, jindex
        integer :: i, j, n, var_index, eta_index
        real(kind=8) :: h(4), mod_dry_tolerance, topo, h_interp
        real(kind=8) :: dt, xg, yg, ug, vg  ! for lagrangian gauges
        logical :: need_to_reset_patch

        ! No gauges to record, exit
        if (num_gauges == 0) then
            return
        endif

        ! Grid info
        tgrid = rnode(timemult, mptr)
        level = node(nestlevel, mptr)
        hx = hxposs(level)
        hy = hyposs(level)
        dt = possk(level)

        ! Main Gauge Loop ======================================================
        do i = 1, num_gauges
            if (mptr .ne. mbestsrc(i)) cycle 
            need_to_reset_patch = .false.  ! set to true if gauge in ghost cell
            if (tgrid < gauges(i)%t_start .or. tgrid > gauges(i)%t_end) then
               cycle
            endif
            ! Minimum increment
            ! TODO Maybe always allow last time output recording?
            if (tgrid - gauges(i)%last_time < gauges(i)%min_time_increment) then
                cycle
            end if

            ! Compute indexing and bilinear interpolant weights
            ! and check if gauge is outside patch
            iindex =  int(.5d0 + (gauges(i)%x - xlow) / hx)
            jindex =  int(.5d0 + (gauges(i)%y - ylow) / hy)
            if ((iindex < 1 .or. iindex > mitot) .or. &
                (jindex < 1 .or. jindex > mjtot)) then
                    if (gauges(i)%gtype == 2) then
                        ! Lagrangian gauge outside domain, ignore
                        ! (maybe should flag so never checked again??)
                        cycle
                    else
                        ! standard gauge so should be in domain
                        write(6,601) gauges(i)%gauge_num
601                     format("ERROR in output of Gauge Data: Gauge ", &
                             i6, " outside patch -- Skipping")
                        !write(6,*) '+++ gauges(i)%gauge_num', gauges(i)%gauge_num
                        !print *, "iindex, mitot, jindex, mjtot: ", &
                        !        iindex, mitot, jindex, mjtot
                        !print *, "gauges(i)%x = ",gauges(i)%x
                        cycle
                    endif
            else if ((iindex < nghost .or. iindex > mitot-nghost) .or. &
                (jindex < nghost .or. jindex > mjtot-nghost)) then
                    ! might want to suppress this warning...
                    if (gauges(i)%gtype == 2) then
                        write(6,602) gauges(i)%gauge_num
602                     format("WARNING in output of Gauge Data: Gauge ", &
                             i6, " in ghost cells, will reset patch")
                        ! Lagrangian gauge moved into ghost cells, 
                        ! so reset this gauge after updating
                        need_to_reset_patch = .true.
                        endif
            end if

            if (INTERPOLATE) then

                xcent  = xlow + (iindex - 0.5d0) * hx
                ycent  = ylow + (jindex - 0.5d0) * hy
                xoff   = (gauges(i)%x - xcent) / hx
                yoff   = (gauges(i)%y - ycent) / hy
    
                ! Gauge interpolation seems to work, so error test is commented out.
                ! For debugging, use the code below...
                !   Note: we expect 0 <= xoff, yoff <= 1 but if gauge is exactly 
                !   at center of cell these might be off by rounding error
    
                !if (xoff .lt. -1.d-4 .or. xoff .gt. 1.0001d0 .or. &
                !    yoff .lt. -1.d-4 .or. yoff .gt. 1.0001d0) then
                !   write(6,*) "*** print_gauges: Interpolation problem at gauge ",&
                !               igauge(i)
                !   write(6,*) "    xoff,yoff: ", xoff,yoff
                !endif
    
    
                ! Modified below from amrclaw/src/2d/gauges_module.f90 
                ! to interpolate only where all four cells are
                ! wet, otherwise just take this cell value:
    
                ! Check for dry cells by comparing h to mod_dry_tolerance, which 
                ! should be smaller than drytolerance to avoid oscillations since  
                ! when h < drytolerance the velocities are zeroed out which can then 
                ! lead to increase in h again.
    
                mod_dry_tolerance = 0.1d0 * dry_tolerance
    
                h(1) = q(1, iindex, jindex) 
                h(2) = q(1, iindex + 1, jindex) 
                h(3) = q(1, iindex, jindex + 1)
                h(4) = q(1, iindex + 1,jindex + 1)
                
                endif
        
            if ((.not. INTERPOLATE) .or.         &
                (h(1) < mod_dry_tolerance) .or.  &
                (h(2) < mod_dry_tolerance) .or.  &
                (h(3) < mod_dry_tolerance) .or.  &
                (h(4) < mod_dry_tolerance)) then

                ! If never interpolating, or if 
                ! one of the cells is dry, just use value from grid cell
                ! that contains gauge rather than interpolating
            
                icell = int(1.d0 + (gauges(i)%x - xlow) / hx)
                jcell = int(1.d0 + (gauges(i)%y - ylow) / hy)

                h_interp = q(1, icell, jcell)
                var_index = 0
                do n = 1, size(gauges(i)%q_out_vars, 1)
                    if (gauges(i)%q_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) = q(n, icell, jcell) 
                    end if
                enddo
                
                ! Note here that we skip one of the var indices to accomodate 
                ! eta here.
                var_index = var_index + 1
                eta_index = var_index

                do n=1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) = aux(n, icell , jcell)
                    end if
                end do

                ! This is the bottom layer and we should figure out the
                ! topography
                topo = aux(1, icell, jcell)

            else
                ! Linear interpolation between four cells
                ! Count for number of variables written to var    
                var_index = 0
            do n = 1, size(gauges(i)%q_out_vars, 1)
                if (gauges(i)%q_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) =                                       &
                           (1.d0 - xoff) * (1.d0 - yoff) * q(n,iindex,jindex)  &
                          + xoff*(1.d0 - yoff) * q(n,iindex+1,jindex)          &
                          + (1.d0 - xoff) * yoff * q(n,iindex,jindex+1)        &
                          + xoff * yoff * q(n,iindex+1,jindex+1)
                    end if
                end do
                
                ! Note here that we skip one of the var indices to accomodate 
                ! eta here.
                var_index = var_index + 1
                eta_index = var_index
                
                do n=1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) =                                       &
                         (1.d0 - xoff) * (1.d0 - yoff) * aux(n,iindex,jindex)  &
                        + xoff*(1.d0 - yoff) * aux(n,iindex+1,jindex)  &
                        + (1.d0 - xoff) * yoff * aux(n,iindex,jindex+1)  &
                        + xoff * yoff * aux(n,iindex+1,jindex+1)
                    end if
                end do
                topo = (1.d0 - xoff) * (1.d0 - yoff) * aux(1,iindex,jindex)  &
                        + xoff * (1.d0 - yoff) * aux(1,iindex+1,jindex)  &
                        + (1.d0 - xoff) * yoff * aux(1,iindex,jindex+1)  &
                        + xoff * yoff * aux(1,iindex+1,jindex+1)

                ! Explicitly do depth in case the depth is not computed above
                if (.not. gauges(i)%q_out_vars(1)) then
                    h_interp = (1.d0 - xoff) * (1.d0 - yoff) &
                               * q(1,iindex,jindex)  &
                         + xoff*(1.d0 - yoff) * q(1,iindex+1,jindex)  &
                         + (1.d0 - xoff) * yoff * q(1,iindex,jindex+1)  &
                         + xoff * yoff * q(1,iindex+1,jindex+1)
                else
                    h_interp = var(1)
                end if

            end if

            ! Check to make sure we grabbed all the values
            if (gauges(i)%num_out_vars /= var_index) then
                print *, gauges(i)%num_out_vars, var_index
                print *, gauges(i)%q_out_vars
                print *, gauges(i)%aux_out_vars
                stop "Somehow we did not grab all the values we wanted..."
            end if

            ! Extract surfaces
            var(eta_index) = h_interp + topo

            ! Zero out tiny values to prevent later problems reading data,
            ! as done in valout.f
            do j = 1, gauges(i)%num_out_vars
                if (abs(var(j)) < 1d-90) var(j) = 0.d0
            end do
       
            if (gauges(i)%gtype == 2) then
                ! Lagrangian gauge, update location
                if (var(1) < dry_tolerance) then
                    ug = 0.d0
                    vg = 0.d0
                  else
                    ug = var(2)/var(1)
                    vg = var(3)/var(1)
                  endif
                if (coordinate_system == 1) then
                    ! x,y in meters, ug,vg in m/s
                    xg = gauges(i)%x + dt*ug
                    yg = gauges(i)%y + dt*vg
                  else
                    ! x,y in degrees, ug,vg in m/s
                    xg = gauges(i)%x + dt*ug / (earth_radius*deg2rad &
                                             * cos(deg2rad*gauges(i)%y))
                    yg = gauges(i)%y + dt*vg / (earth_radius*deg2rad)
                  endif
                
                ! Update location and store new xg,yg in place of hu,hv 
                gauges(i)%x = xg
                gauges(i)%y = yg
                var(2) = xg
                var(3) = yg
                endif
                
            ! save info for this time 
            n = gauges(i)%buffer_index
     
            gauges(i)%level(n) = level
            gauges(i)%data(1,n) = tgrid
            do j = 1, gauges(i)%num_out_vars
                gauges(i)%data(1 + j, n) = var(j)
            end do
            
            gauges(i)%buffer_index = n + 1
            if (gauges(i)%buffer_index > MAX_BUFFER) then
                call print_gauges_and_reset_nextLoc(i)
            endif

            gauges(i)%last_time = tgrid

            if (need_to_reset_patch) then
                call setbestsrc(i)
                endif

        end do ! End of gauge loop =============================================

    end subroutine update_gauges
!
! -------------------------------------------------------------------------
! Write out gauge data for the gauge specified
!
    subroutine print_gauges_and_reset_nextLoc(gauge_num)

        implicit none

        ! Input
        integer, intent(in) :: gauge_num

        ! Locals
        integer :: j, k, myunit, nvals, ntimes
        integer :: omp_get_thread_num, mythread
        character(len=32) :: out_format
        real(kind=4), allocatable :: gdata4(:,:)
        real(kind=8), allocatable :: gdata8(:,:)

        ! Loop through gauge's buffer writing out all available data.  Also
        ! reset buffer_index back to beginning of buffer since we are emptying
        ! the buffer here

        ! Rearranged for v5.9.0 to also allow writing binary format

        j = gauges(gauge_num)%buffer_index - 1
        if (j > 0) then
            gauges(gauge_num)%t_last_written = gauges(gauge_num)%data(1, j)
            gauges(gauge_num)%x_last_written = gauges(gauge_num)%data(3, j)
            gauges(gauge_num)%y_last_written = gauges(gauge_num)%data(4, j)
        endif
        
        nvals = gauges(gauge_num)%num_out_vars + 1
        ntimes = gauges(gauge_num)%buffer_index - 1

        ! Open unit dependent on thread number
        mythread = 0
!$      mythread = omp_get_thread_num()
        myunit = OUTGAUGEUNIT + mythread

        if (gauges(gauge_num)%file_format == 1) then

            ! ascii output

            ! Construct output format based on number of output variables and
            ! request format
            write(out_format, "(A7, i2, A6, A1)") "(i5.2,",                    &
                                        gauges(gauge_num)%num_out_vars + 1,    &
                                        gauges(gauge_num)%display_format, ")"

            ! Open gauge file:
            open(unit=myunit, file=gauges(gauge_num)%file_name,       &
                 status='unknown', position='append', form='formatted')

            do j = 1, ntimes
                write(myunit, out_format) gauges(gauge_num)%level(j), &
                      (gauges(gauge_num)%data(k, j), k=1,nvals)
            end do

        else if (gauges(gauge_num)%file_format >= 2) then

            ! binary output

            open(unit=myunit, file=gauges(gauge_num)%file_name_bin, &
                 status='unknown', position='append',access='stream')
            
            if (gauges(gauge_num)%file_format == 3) then
                allocate(gdata4(nvals+1, ntimes))
                gdata4(1, 1:ntimes) = real(gauges(gauge_num)%level(1:ntimes), kind=4)
                gdata4(2:nvals+1, 1:ntimes) = &
                        real(gauges(gauge_num)%data(1:nvals,1:ntimes), kind=4)
                write(myunit) gdata4
                deallocate(gdata4)  
            else
                allocate(gdata8(nvals+1, ntimes))
                gdata8(1, 1:ntimes) = real(gauges(gauge_num)%level(1:ntimes), kind=8)
                gdata8(2:nvals+1, 1:ntimes) = &
                        real(gauges(gauge_num)%data(1:nvals,1:ntimes), kind=8)
                write(myunit) gdata8
                deallocate(gdata8)
            endif


        else
            print *, "Unhandled file format ", gauges(gauge_num)%file_format
            stop
        end if

        ! close file
        close(myunit)

        gauges(gauge_num)%buffer_index = 1                        

      end subroutine print_gauges_and_reset_nextLoc

end module gauges_module

c ::::::::::::::::::::: FLAGGER :::::::::::::::::::::::::
c
c flagger = set up for and call two routines that flag using
c    (a) spatial gradients, or other user-specified criteria
c    (b) richardson error estimates
c
c the two approaches share an array with boundary ghost values 
c
c ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
!  Below are comments for Doxygen
!> \callgraph
!! \callergraph
!! Set up for and call two routines that flag using
!!    (a) spatial gradients, or other user-specified criteria
!!    (b) richardson error estimates
!!
!! the two approaches share an array with boundary ghost values 
!! before parallel loop give grids the extra storage they need for error estimation
!!
!! **input**: AMR level on which all grids need to be flagged
!! **output**: flag arrays that are stored with each grid node,
!!             accessable through node(storeflags, mptr)
!!
!! \param nvar number of equations for the system
!! \param naux number of auxiliary variables
!! \param lcheck flag all level **lcheck** grids
!! \param[in] start_time start time of current simulation
c
c -----------------------------------------------------------
c
      subroutine flagger(nvar,naux,lcheck,start_time)

      use amr_module
      use adjoint_module,only:calculate_tol,eptr,errors,totnum_adjoints,
     1      adjoints,trange_start,trange_final,adjoint_flagging,grid_num
      implicit double precision (a-h,o-z)

      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      integer listgrids(numgrids(lcheck)), locuse
      logical keepflagging

c      call prepgrids(listgrids,numgrids(lcheck),lcheck)
      mbuff = max(nghost,ibuff+1)

      if(adjoint_flagging) then
c        allocating space for tracking error estimates
c        (used at next regridding time to determine tolerance)
         if (flag_richardson) then
           allocate(errors(numcells(lcheck)/2))
           allocate(eptr(numgrids(lcheck)))
           errors = 0
           eptr(1) = 0

         ! new version has variable node size arrays, so need to use current size
         allocate(grid_num(maxgr))
         endif
      endif

c before parallel loop give grids the extra storage they need for error estimation
         do  jg = 1, numgrids(lcheck)
c            mptr = listgrids(jg)
            levSt  = listStart(lcheck)
            mptr   = listOfgrids(levSt+jg-1)
            nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
            ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
            mitot  = nx + 2*nghost
            mjtot  = ny + 2*nghost
            if (flag_richardson) then
               locbig = igetsp(mitot*mjtot*nvar)
               node(tempptr,mptr) = locbig

               if(adjoint_flagging) then
                 grid_num(mptr) = jg
                 if (jg .ne. numgrids(lcheck)) then
                   eptr(jg+1) = eptr(jg)+(nx/2)*(ny/2)
                 endif
               endif
            else
               locbig = 0
            endif
            mibuff = nx + 2*mbuff       ! NOTE THIS NEW DIMENSIONING 
            mjbuff = ny + 2*mbuff       ! TO ALLOW ROOM FOR BUFFERING IN PLACE
            locamrflags = igetsp(mibuff*mjbuff)  
            node(storeflags,mptr) = locamrflags
          end do

!$OMP PARALLEL DO PRIVATE(jg,mptr,nx,ny,mitot,mjtot,locnew,locaux),
!$OMP&            PRIVATE(time,dx,dy,xleft,ybot,xlow,ylow,locbig),
!$OMP&            PRIVATE(locold,mbuff,mibuff,mjbuff,locamrflags,i),
!$OMP&            PRIVATE(locuse,keepflagging),
!$OMP&            SHARED(numgrids,listgrids,lcheck,nghost,nvar,naux),
!$OMP&            SHARED(levSt,listStart,listOfGrids),
!$OMP&            SHARED(tolsp,alloc,node,rnode,hxposs,hyposs,ibuff),
!$OMP&            SHARED(start_time,possk,flag_gradient,flag_richardson),
!$OMP&            SHARED(adjoint_flagging)
!$OMP&            DEFAULT(none),
!$OMP&            SCHEDULE(DYNAMIC,1)
       do  jg = 1, numgrids(lcheck)
c          mptr = listgrids(jg)
          levSt  = listStart(lcheck)
          mptr   = listOfGrids(levSt+jg-1)
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          locnew = node(store1,mptr)
          locaux = node(storeaux,mptr)
          time   = rnode(timemult,mptr)
          dx     = hxposs(lcheck)
          dy     = hyposs(lcheck)
          xleft  = rnode(cornxlo,mptr)
          ybot   = rnode(cornylo,mptr)
          xlow   = xleft - nghost*dx
          ylow   = ybot - nghost*dy

c
          locbig =  node(tempptr,mptr)
c         # straight copy into scratch array so don't mess up latest soln.

c         ## at later times want to use newest soln for spatial error flagging
c         ## at initial time want to use initial conditions (so retain symmetry for example)
         if (start_time+possk(lcheck) .ne. time) then !exact equality test-relying on ieee arith repeatability
c            do in other order in case user messes up locbig in flag2refine, already have
c            them in locnew
             call bound(time,nvar,nghost,alloc(locnew),mitot,mjtot,mptr,
     1                  alloc(locaux),naux)
             locuse = locnew ! flag based on newest vals
             if (flag_richardson) then
               do 10 i = 1, mitot*mjtot*nvar
                alloc(locbig+i-1) = alloc(locnew+i-1)
 10            continue
             endif

         else   ! boundary values already in locold
             locold = node(store2,mptr)
             locuse = locold ! flag based on old vals at initial time
             ! put back this way to agree with nosetests
             if (flag_richardson) then
               do 11 i = 1, mitot*mjtot*nvar
                 alloc(locbig+i-1) = alloc(locold+i-1)
 11            continue
             endif
         endif

!        # need at least as big as nghost to fit ghost cells. if ibuff is bigger make
!        # the flagged array bigger so can buffer in place
         mbuff = max(nghost,ibuff+1)  
         mibuff = nx + 2*mbuff       ! NOTE THIS NEW DIMENSIONING 
         mjbuff = ny + 2*mbuff       ! TO ALLOW ROOM FOR BUFFERING IN PLACE

!              ##  locamrflags used for flag storage.
!              ##  flagregions 2 flags directly into it.
!              ##  flag2refine and richardson flags added to it.
!              ##  Then colate finished the job
                locamrflags = node(storeflags,mptr)
                do 20 i = 1, mibuff*mjbuff  ! initialize
                   alloc(locamrflags+i-1) = UNSET
 20             continue

c      ##  new call to flag regions: check if cells must be refined, or exceed
c      ##  maximum refinement level for that region.  used to be included with
c      ##  burnest2. moved here to reduce flagging time
         call flagregions2(nx,ny,mbuff,rnode(cornxlo,mptr),
     1                  rnode(cornylo,mptr),dx,dy,lcheck,time,
     2                  alloc(locamrflags))

c       ##  check if any flags remain unset
        keepflagging = .false.
        do i = 1, mibuff*mjbuff
            if(alloc(locamrflags+i-1) == UNSET) then
                keepflagging = .true.
                exit
            endif
        enddo

         if (flag_gradient .and. keepflagging) then

c     # call user-supplied routine to flag any points where 
c     # refinement is desired based on user's criterion.  
c     # Default version compares spatial gradient to tolsp.

c no longer getting locbig, using "real" solution array in locnew
            call flag2refine2(nx,ny,nghost,mbuff,nvar,naux,
     &                        xleft,ybot,dx,dy,time,lcheck,
     &                        tolsp,alloc(locuse),
     &                        alloc(locaux),alloc(locamrflags))
             endif     
c

c       ##  check if any flags remain unset
        keepflagging = .false.
        do i = 1, mibuff*mjbuff
            if(alloc(locamrflags+i-1) == UNSET) then
                keepflagging = .true.
                exit
            endif
        enddo

         if (flag_richardson .and. keepflagging) then
              call errest(nvar,naux,lcheck,mptr,nx,ny)
         endif

       end do
! $OMP END PARALLEL DO

       if(adjoint_flagging)then
           if (flag_richardson) then
               call calculate_tol(lcheck)
               deallocate(errors)
               deallocate(eptr)
               deallocate(grid_num)
           endif
       endif

       return
       end

subroutine src2(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux,t,dt)

!> Called to update q by solving source term equation 
!! $q_t = \psi(q)$ over time dt starting at time t.
!!
!! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: mbc,mx,my,meqn,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,dt
    real(kind=8), intent(in) ::  aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) ::  q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)

end subroutine src2

module ClawParams
! ===================================================================
! This module holds user options and grid information that are used
! by the SharpClaw solvers in any number of dimensions.
! ===================================================================

    ! Problem setup:
    double precision, allocatable :: xlower(:), xupper(:), dx(:)
    integer :: num_dim, num_waves, index_capa

    ! Method-related parameters:
    integer :: char_decomp, lim_type, weno_order
    integer, allocatable :: mthlim(:)
    logical :: fwave, tfluct_solver

contains

    subroutine alloc_clawparams()

        allocate(xlower(num_dim))
        allocate(xupper(num_dim))
        allocate(dx(num_dim))
        allocate(mthlim(num_waves))

    end subroutine alloc_clawparams

    subroutine dealloc_clawparams()

        if (allocated(xlower)) then
            deallocate(xlower)
        endif

        if (allocated(xupper)) then
            deallocate(xupper)
        endif

        if (allocated(dx)) then
            deallocate(dx)
        endif

        if (allocated(mthlim)) then
            deallocate(mthlim)
        endif

    end subroutine dealloc_clawparams

end module

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.
    ! This default version prints an error message since it should
    ! not be used directly.  Copy this to an application directory and
    ! loop over all grid cells to set values of q(1:meqn, 1:mx).

    implicit none
    
    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    integer :: i
    real(kind=8) :: beta, xcell
    common /cqinit/ beta
 
 
      do i=1,mx
         xcell = xlower + (i-0.5d0)*dx
         q(1,i) = dexp(-beta * (xcell-0.3d0)**2)  
         q(2,i) = 0.d0
      enddo

end subroutine qinit

! ::::::::::::::::::::: flag2refine ::::::::::::::::::::::::::::::::::
!
! User routine to control flagging of points for refinement.
!
! Default version computes spatial difference dq in each direction and
! for each component of q and flags any point where this is greater than
! the tolerance tolsp.  This is consistent with what the routine errsp did in
! earlier versions of amrclaw (4.2 and before).
!
! This routine can be copied to an application directory and modified to
! implement some other desired refinement criterion.
!
! Points may also be flagged for refining based on a Richardson estimate
! of the error, obtained by comparing solutions on the current grid and a
! coarsened grid.  Points are flagged if the estimated error is larger than
! the parameter tol in amr2ez.data, provided flag_richardson is .true.,
! otherwise the coarsening and Richardson estimation is not performed!  
! Points are flagged via Richardson in a separate routine.
!
! Once points are flagged via this routine and/or Richardson, the subroutine
! flagregions is applied to check each point against the min_level and
! max_level of refinement specified in any "region" set by the user.
! So flags set here might be over-ruled by region constraints.
!
!    q   = grid values including ghost cells (bndry vals at specified
!          time have already been set, so can use ghost cell values too)
!
!  aux   = aux array on this grid patch
!
! amrflags  = array to be flagged with either the value
!             DONTFLAG (no refinement needed)  or
!             DOFLAG   (refinement desired)    
!
! tolsp = tolerance specified by user in input file amr2ez.data, used in default
!         version of this routine as a tolerance for spatial differences.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine flag2refine2(mx,my,mbc,mbuff,meqn,maux,xlower,ylower,dx,dy,t,level, &
                            tolsp,q,aux,amrflags,DONTFLAG,DOFLAG)

    use regions_module
    use amr_module, only: lfine

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,my,mbc,meqn,maux,level,mbuff
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,tolsp
    
    real(kind=8), intent(in) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbuff:mx+mbuff,1-mbuff:my+mbuff)
    real(kind=8), intent(in) :: DONTFLAG
    real(kind=8), intent(in) :: DOFLAG
    
    logical :: allowflag
    external allowflag

    ! Locals
    integer :: i,j,m
    real(kind=8) :: x_c,y_c,x_low,y_low,x_hi,y_hi
    real(kind=8) :: dqi(meqn), dqj(meqn), dq(meqn)

    ! Initialize flags
    amrflags = DONTFLAG
    
    ! Loop over interior points on this grid
    ! (i,j) grid cell is [x_low,x_hi] x [y_low,y_hi], cell center at (x_c,y_c)
    ! This information is not needed for the default flagging based on
    ! undivided differences, but might be needed in a user's version.
    ! Note that if you want to refine only in certain space-time regions,
    ! it may be easiest to use the "regions" feature.  The flags set here or
    ! in the Richardson error estimator are potentially modified by the
    ! min_level and max_level specified in any regions.

    y_loop: do j=1,my
        y_low = ylower + (j - 1) * dy
        y_c = ylower + (j - 0.5d0) * dy
        y_hi = ylower + j * dy
        
        x_loop: do i = 1,mx
            x_low = xlower + (i - 1) * dx
            x_c = xlower + (i - 0.5d0) * dx
            x_hi = xlower + i * dx

            ! -----------------------------------------------------------------
                dq = 0.d0
                dqi = abs(q(:,i+1,j) - q(:,i-1,j))
                dqj = abs(q(:,i,j+1) - q(:,i,j-1))
                dq = max(dq,dqi,dqj)

                ! default checks all components of undivided difference:
                do m=1,meqn
                    if (dq(m) > tolsp) then
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif
                enddo

        enddo x_loop
    enddo y_loop
    !amrflags(mx/2,my/2) = DOFLAG
    !if (level .eq. lfine .and. t .gt. 1.) amrflags(mx/2,my/2) = DOFLAG
   
end subroutine flag2refine2

!
!  Use adaptive mesh refinement to solve the hyperbolic 2-d equation:
!
!              u  +  f(u)    + g(u)   = 0
!               t         x        y
!
! or the more general non-conservation law form:
!              u  +  A u     + B u    = 0
!               t         x        y
!
!  using the wave propagation method as in CLAWPACK in combination
!  with the locally uniform embedded grids of AMR.
!
!  Estimate error with Richardson extrap. (in errest.f)
!  + gradient checking (in errsp.f).  Initial conditions set
!  in (qinit.f), b.c.'s in (physbd.f).
!
!  Specify rectangular domain from
!           (xlower,ylower) to (xupper,yupper).
!
!
! =========================================================================
!
!  This software is made available for research and instructional use only.
!  You may copy and use this software without charge for these non-commercial
!  purposes, provided that the copyright notice and associated text is
!  reproduced on all copies.  For all other uses (including distribution of
!  modified versions), please contact the author at the address given below.
!
!  *** This software is made available "as is" without any assurance that it
!  *** will work for your purposes.  The software may in fact have defects, so
!  *** use the software at your own risk.
!
!  --------------------------------------
!    AMRCLAW Version 5.0,  2012
!    Homepage: http://www.clawpack.org
!  --------------------------------------
!
!   Authors:
!
!             Marsha J. Berger
!             Courant Institute of Mathematical Sciences
!             New York University
!             251 Mercer St.
!             New York, NY 10012
!             berger@cims.nyu.edu
!
!             Randall J. LeVeque
!             Applied Mathematics
!             Box 352420
!             University of Washington,
!             Seattle, WA 98195-2420
!             rjl@uw.edu
!
! =========================================================================
program amr2

    use amr_module, only: dbugunit, parmunit, outunit, inunit, matunit
    use amr_module, only: mxnest, rinfinity, iinfinity
    use amr_module, only: xupper, yupper, xlower, ylower
    use amr_module, only: hxposs, hyposs, intratx, intraty, kratio
    use amr_module, only: cfl, cflv1, cflmax, evol

    use amr_module, only: checkpt_style, checkpt_interval, tchk, nchkpt
    use amr_module, only: rstfile

    use amr_module, only: max1d, maxvar, maxlv

    use amr_module, only: method, mthlim, use_fwaves, numgrids
    use amr_module, only: nghost, mwaves, mcapa, auxtype
    use amr_module, only: tol, tolsp, flag_richardson, flag_gradient

    use amr_module, only: nghost, mthbc
    use amr_module, only: xperdom, yperdom, spheredom

    use amr_module, only: nstop, nout, iout, tfinal, tout, output_style
    use amr_module, only: output_format, printout, verbosity_regrid
    use amr_module, only: output_q_components, output_aux_components
    use amr_module, only: output_aux_onlyonce, matlabu

    use amr_module, only: lfine, lentot, iregridcount, avenumgrids
    use amr_module, only: tvoll, tvollCPU, rvoll, rvol, mstart, possk, ibuff
    use amr_module, only: timeRegridding,timeUpdating, timeValout
    use amr_module, only: timeBound,timeStepgrid, timeFlagger,timeBufnst
    use amr_module, only: timeLinSolve, timeLinSolveCPU
    use amr_module, only: timePrepBuild, timePrepBuildCPU
    use amr_module, only: timeBoundCPU,timeStepGridCPU,timeRegriddingCPU
    use amr_module, only: timeValoutCPU,timeTick,timeTickCPU
    use amr_module, only: kcheck, iorder, lendim, lenmax, memsize

    use amr_module, only: dprint, eprint, edebug, gprint, nprint, pprint
    use amr_module, only: rprint, sprint, tprint, uprint

    use amr_module, only: t0, tstart_thisrun
    use amr_module, only: tick_clock_start, tick_cpu_start
    !! for pardiso initializations
#ifdef HAVE_PARDISO
    use bouss_module, only: pt,maxfct,mnum,mtype,phase,nn,ddum,idum
    use bouss_module, only: nrhs,iparm,msglvl,error,dparm
#endif
    use bouss_module, only: isolver, minLevelBouss, maxLevelBouss
    use bouss_module, only: itcount, numTimes


    ! Data modules
    use geoclaw_module, only: set_geo
    use topo_module, only: read_topo_settings, read_dtopo_settings
    use qinit_module, only: set_qinit
    use refinement_module, only: set_refinement
    use storm_module, only: set_storm
    use friction_module, only: setup_variable_friction
    use gauges_module, only: set_gauges, num_gauges
    use regions_module, only: set_regions
    use fgmax_module, only: set_fgmax, FG_num_fgrids
    use fgout_module, only: set_fgout
    use multilayer_module, only: set_multilayer
    use adjoint_module, only: read_adjoint_data
    use bouss_module, only: set_bouss

#ifdef HAVE_PETSC
    !petsc libs and include
    use petscksp
#include <petsc/finclude/petscksp.h>
#endif

    implicit none

    ! Local variables
    integer :: i, iaux, mw, level
    integer :: ierr
    integer :: ndim, nvar, naux, mcapa1, mindim, dimensional_split
    integer :: nstart, nsteps, nv1, nx, ny, lentotsave, num_gauge_SAVE
    integer :: omp_get_max_threads, maxthreads
    real(kind=8) :: time, ratmet, cut, dtinit, dt_max
    logical :: vtime, rest, output_t0    

    ! Timing variables
    integer(kind=8) :: clock_start, clock_finish, clock_rate, ttotal, count_max
    real(kind=8) :: ttotalcpu
    integer(kind=8) :: tick_clock_finish
    integer, parameter :: timing_unit = 48
    character(len=512) :: timing_line, timing_substr
    character(len=*), parameter :: timing_base_name = "timing."
    character(len=*), parameter :: timing_header_format =                      &
                                                  "(' wall time (', i2,')," // &
                                                  " CPU time (', i2,'), "   // &
                                                  "cells updated (', i2,'),')"

    ! Common block variables
    real(kind=8) :: dxmin, dymin

    common /comfine/ dxmin,dymin

    character(len=364) :: format_string
    character(len=*), parameter :: clawfile = 'claw.data'
    character(len=*), parameter :: amrfile = 'amr.data'
    character(len=*), parameter :: outfile = 'fort.amr'
    character(len=*), parameter :: dbugfile = 'fort.debug'
    character(len=*), parameter :: matfile = 'fort.nplot'
    character(len=*), parameter :: parmfile = 'fort.parameters'

#ifdef HAVE_PETSC
!   needs to be very first line in main
      call PetscInitialize(ierr)
      CHKERRA(ierr);
#endif

    ! Open parameter and debug files
    open(dbugunit,file=dbugfile,status='unknown',form='formatted')
    open(parmunit,file=parmfile,status='unknown',form='formatted')

    maxthreads = 1    !! default, if no openmp

    ! Open AMRClaw primary parameter file
    call opendatafile(inunit,clawfile)

    ! Number of space dimensions, not really a parameter but we read it in and
    ! check to make sure everyone is on the same page. 
    read(inunit,"(i1)") ndim  
    if (ndim /= 2) then
        print *,'Error ***   ndim = 2 is required,  ndim = ',ndim
        print *,'*** Are you sure input has been converted'
        print *,'*** to Clawpack 5.x form?'
        stop
    endif
          
    ! Domain variables
    read(inunit,*) xlower, ylower
    read(inunit,*) xupper, yupper
    read(inunit,*) nx, ny
    read(inunit,*) nvar    ! meqn
    read(inunit,*) mwaves
    read(inunit,*) naux
    read(inunit,*) t0

    ! ==========================================================================
    ! Output Options
    ! Output style
    read(inunit,*) output_style
    if (output_style == 1) then
        read(inunit,*) nout
        read(inunit,*) tfinal
        read(inunit,*) output_t0

        iout = 0
    else if (output_style == 2) then
        read(inunit,*) nout
        allocate(tout(nout))
        read(inunit,*) (tout(i), i=1,nout)
        output_t0 = (abs(tout(1) - t0) < 1e-15)
        ! Move output times down one index
        if (output_t0) then
            nout = nout - 1
            do i=1,nout
                tout(i) = tout(i+1)
            enddo
        endif
        iout = 0
        tfinal = tout(nout)
    else if (output_style == 3) then
        read(inunit,*) iout
        read(inunit,*) nstop
        read(inunit,*) output_t0
        nout = 0
        tfinal = rinfinity
    else
        stop "Error ***   Invalid output style."
    endif

    ! Error checking
    if ((output_style == 1) .and. (nout > 0)) then
        allocate(tout(nout))
        do i=1,nout
            tout(i) = t0 + i * (tfinal - t0) / real(nout,kind=8)
        enddo
    endif

    ! What and how to output
    read(inunit,*) output_format
    allocate(output_q_components(nvar))
    read(inunit,*) (output_q_components(i),i=1,nvar)
    if (naux > 0) then
        allocate(output_aux_components(naux))
        read(inunit,*) (output_aux_components(i),i=1,naux)
        read(inunit,*) output_aux_onlyonce
    endif
    ! ==========================================================================

    ! ==========================================================================
    !  Algorithm parameters

    read(inunit,*) possk(1)   ! dt_initial
    read(inunit,*) dt_max     ! largest allowable dt
    read(inunit,*) cflv1      ! cfl_max
    read(inunit,*) cfl        ! clf_desired
    read(inunit,*) nv1        ! steps_max
      
    if (output_style /= 3) then
        nstop = nv1
    endif

    read(inunit,*) vtime      ! dt_variable
    if (vtime) then
        method(1) = 2
    else
        method(1) = 1
    endif

    read(inunit,*) method(2)  ! order
    iorder = method(2)
    read(inunit,*) method(3)  ! order_trans

    read(inunit,*) dimensional_split
    if (dimensional_split > 0) then
        print *, '*** ERROR ***  dimensional_split = ', dimensional_split
        print *, ' dimensional splitting not supported in amrclaw'
        stop
    endif

    read(inunit,*) method(4)   ! verbosity
    read(inunit,*) method(5)   ! src_split
    read(inunit,*) mcapa1
    
    read(inunit,*) use_fwaves
    allocate(mthlim(mwaves))
    read(inunit,*) (mthlim(mw), mw=1,mwaves)

    ! Boundary conditions
    read(inunit,*) nghost
    read(inunit,*) mthbc(1),mthbc(3)
    read(inunit,*) mthbc(2),mthbc(4)

    ! 1 = left, 2 = right 3 = bottom 4 = top boundary
    xperdom = (mthbc(1) == 2 .and. mthbc(2) == 2)
    yperdom =  (mthbc(3) == 2 .and. mthbc(4) == 2)
    spheredom =  (mthbc(3) == 5 .and. mthbc(4) == 5)

    if ((mthbc(1).eq.2 .and. mthbc(2).ne.2) .or. &
        (mthbc(2).eq.2 .and. mthbc(1).ne.2)) then
        
        print *, '*** ERROR ***  periodic boundary conditions: '
        print *, '  mthbc(1) and mthbc(2) must BOTH be set to 2'
        stop
    endif

    if ((mthbc(3).eq.2 .and. mthbc(4).ne.2) .or. &
        (mthbc(4).eq.2 .and. mthbc(3).ne.2)) then

        print *, '*** ERROR ***  periodic boundary conditions: '
        print *, '  mthbc(3) and mthbc(4) must BOTH be set to 2'
        stop
    endif

    if ((mthbc(3).eq.5 .and. mthbc(4).ne.5) .or. &
        (mthbc(4).eq.5 .and. mthbc(3).ne.5)) then
    
        print *, '*** ERROR ***  sphere bcs at top and bottom: '
        print *, '  mthbc(3) and mthbc(4) must BOTH be set to 5'
        stop
    endif

    if (spheredom .and. .not. xperdom) then

        print *,'*** ERROR ***  sphere bcs at top and bottom: '
        print *,'must go with periodic bcs at left and right  '
        stop
    endif

    ! ==========================================================================
    !  Restart and Checkpointing

    read(inunit,*) rest
    read(inunit,*) rstfile

    read(inunit,*) checkpt_style

    ! default value unless set by checkpt_style==3:
    checkpt_interval = iinfinity 

    if (abs(checkpt_style) == 2) then
        read(inunit,*) nchkpt
        allocate(tchk(nchkpt))
        read(inunit,*) (tchk(i), i=1,nchkpt)

    else if (abs(checkpt_style) == 3) then
        ! Checkpoint every checkpt_interval steps on coarse grid
        read(inunit,*) checkpt_interval
    endif

    close(inunit)

    ! ==========================================================================
    !  Refinement Control
    call opendatafile(inunit, amrfile)

    read(inunit,*) memsize  ! initialsize of alloc array
    read(inunit,*) max1d  ! max size of each grid patch

    read(inunit,*) mxnest
    if (mxnest <= 0) then
        stop 'Error ***   mxnest (amrlevels_max) <= 0 not allowed'
    endif
          
    if (mxnest > maxlv) then
        stop 'Error ***   mxnest > max. allowable levels (maxlv) in common'
    endif
      
    ! Anisotropic refinement always allowed in 5.x:
    read(inunit,*) (intratx(i),i=1,max(1,mxnest-1))
    read(inunit,*) (intraty(i),i=1,max(1,mxnest-1))
    read(inunit,*) (kratio(i), i=1,max(1,mxnest-1))
    read(inunit,*)

    do i=1,mxnest-1
        if ((intratx(i) > max1d) .or. (intraty(i) > max1d)) then 
            print *, ""
            format_string = "(' *** Error: Refinement ratios must be no " // &
                            "larger than max1d = ',i5,/,'     (set max1d" // &
                            " in amr_module.f90)')"
            print format_string, max1d
            stop
        endif
    enddo

    if (naux > 0) then
        allocate(auxtype(naux))
        read(inunit,*) (auxtype(iaux), iaux=1,naux)
    endif
    read(inunit,*)
              
    read(inunit,*) flag_richardson
    read(inunit,*) tol            ! for richardson
    read(inunit,*) flag_gradient
    read(inunit,*) tolsp          ! for gradient
    read(inunit,*) kcheck
    read(inunit,*) ibuff
    read(inunit,*) cut
    read(inunit,*) verbosity_regrid

    ! read verbose/debugging flags
    read(inunit,*) dprint
    read(inunit,*) eprint
    read(inunit,*) edebug
    read(inunit,*) gprint
    read(inunit,*) nprint
    read(inunit,*) pprint
    read(inunit,*) rprint
    read(inunit,*) sprint
    read(inunit,*) tprint
    read(inunit,*) uprint

    close(inunit)
    ! Finished with reading in parameters
    ! ==========================================================================

    ! Look for capacity function via auxtypes:
    mcapa = 0
    do iaux = 1, naux
        if (auxtype(iaux) == "capacity") then
            if (mcapa /= 0) then
                print *, " only 1 capacity allowed"
                stop
            else
                mcapa = iaux
            endif
        endif

        ! Change to Version 4.1 terminology:
        if (auxtype(iaux) == "leftface") auxtype(iaux) = "xleft"
        if (auxtype(iaux) == "bottomface") auxtype(iaux) = "yleft"
        if (.not. (auxtype(iaux) .eq."xleft" .or. &
                   auxtype(iaux) .eq. "yleft".or. &
                   auxtype(iaux) .eq. "capacity".or. &
                   auxtype(iaux) .eq. "center"))  then
            print *," unknown type for auxiliary variables"
            print *," use  xleft/yleft/center/capacity"
            stop
        endif
    enddo

    ! Error checking of input data
    if (mcapa /= mcapa1) then
        stop 'Error ***  mcapa does not agree with auxtype'
    endif
    if (nvar > maxvar) then
        stop 'Error ***   nvar > maxvar in common'
    endif
    if (2*nghost > min(nx,ny) .and. ny /= 1) then
        mindim = 2 * nghost
        print *, 'Error ***   need finer domain >', mindim, ' cells'
        stop
    endif
    if (mcapa > naux) then     
        stop 'Error ***   mcapa > naux in input file'
    endif

    if (.not. vtime .and. nout /= 0) then
        print *,        ' cannot specify output times with fixed dt'
        stop
    endif


    ! Write out parameters
    write(parmunit,*) ' '
    write(parmunit,*) 'Running amrclaw with parameter values:'
    write(parmunit,*) ' '


    print *, ' '
    print *, 'Running amrclaw ...  '
    print *, ' '

    hxposs(1) = (xupper - xlower) / nx
    hyposs(1) = (yupper - ylower) / ny

    ! initialize frame number for output.  
    ! Note: might be reset in restrt if this is a restart
    if (output_t0) then
        matlabu   = 0
    else 
        matlabu = 1
    endif

        ! Call user routine to set up problem parameters:
        call setprob()

    if (rest) then

        open(outunit, file=outfile, status='unknown', position='append', &
                      form='formatted')

        ! moved upt before restrt or won't properly initialize 
        call set_fgmax()   

        ! need these before set-gauges so num_out_vars set right for gauges
        call set_geo()                    ! sets basic parameters g and coord system
        call set_multilayer()             ! Set multilayer SWE parameters

        ! Set gauge output, note that restrt might reset x,y for lagrangian:
        call set_gauges(rest, nvar, naux) ! Set gauge output

        call restrt(nsteps,time,nvar,naux)

        nstart  = nsteps
        tstart_thisrun = time
        print *, ' '
        print *, 'Restarting from previous run'
        print *, '   at time = ',time
        print *, ' '

        ! Non-user defined setup routine
        call set_refinement()             ! sets refinement control parameters
        call read_dtopo_settings()        ! specifies file with dtopo from earthquake
        call read_topo_settings(rest)     ! specifies topography (bathymetry) files
        call set_qinit()                  ! specifies file with dh if this used instead
        call set_fgout(rest,nvar)         ! Fixed grid settings
        call setup_variable_friction()    ! Variable friction parameter
        call set_storm()                  ! Set storm parameters
        call set_regions()                ! Set refinement regions
        call read_adjoint_data()          ! Read adjoint solution
        call set_bouss(rest,time,naux)    ! Set Boussinesq parameters
        ! turn off initial stuff with SWE if a restart run

    else

        ! Create new timing file
        open(unit=timing_unit, file=timing_base_name//"csv",                &
             form='formatted', status='unknown', action='write')
        ! Construct header string
        timing_line = 'output_time,total_wall_time,total_cpu_time,'
        timing_substr = ""
        do level=1, mxnest
            write(timing_substr, timing_header_format) level, level, level
            timing_line = trim(timing_line) // trim(timing_substr)
        end do
        write(timing_unit, "(a)") timing_line
        close(timing_unit)

        open(outunit, file=outfile, status='unknown', form='formatted')

        tstart_thisrun = t0


        ! Non-user defined setup routine
        call set_geo()                    ! sets basic parameters g and coord system
        call set_refinement()             ! sets refinement control parameters
        call read_dtopo_settings()        ! specifies file with dtopo from earthquake
        call read_topo_settings(rest)     ! specifies topography (bathymetry) files
        call set_qinit()                  ! specifies file with dh if this used instead

        call set_fgout(rest,nvar)         ! Fixed grid settings
        call setup_variable_friction()    ! Variable friction parameter
        call set_multilayer()             ! Set multilayer SWE parameters
        call set_storm()                  ! Set storm parameters
        call set_regions()                ! Set refinement regions
        call set_gauges(rest, nvar, naux) ! Set gauge output
        call set_fgmax()
        call read_adjoint_data()          ! Read adjoint solution
        call set_bouss(rest,time,naux)    ! Set Boussinesq parameters

        cflmax = 0.d0   ! otherwise use previously heckpointed val

        lentot = 0
        lenmax = 0
        lendim = 0
        rvol   = 0.0d0
        do i   = 1, mxnest
            rvoll(i) = 0.0d0
        enddo
        evol = 0.0d0
        call stst1()


        ! changed 4/24/09: store dxmin,dymin for setaux before
        ! grids are made, in order to average up from finest grid.
        dxmin = hxposs(mxnest)
        dymin = hyposs(mxnest)

        call domain(nvar,vtime,nx,ny,naux,t0)

        ! Hold off on gauges until grids are set. 
        ! The fake call to advance at the very first timestep 
        ! looks at the gauge array but it is not yet built
        num_gauge_SAVE = num_gauges
        num_gauges = 0
        call setgrd(nvar,cut,naux,dtinit,t0)
        num_gauges = num_gauge_SAVE

! commented out to match 4-x version
!!$        if (possk(1) .gt. dtinit*cflv1/cfl .and. vtime) then
!!$            ! initial time step was too large. reset to dt from setgrd
!!$            print *, "*** Initial time step reset for desired cfl"
!!$            possk(1) = dtinit
!!$            do i = 2, mxnest-1
!!$                possk(i) = possk(i-1)*kratio(i-1)
!!$            end do
!!$        endif

        time = t0
        nstart = 0
    endif


    write(parmunit,*) ' '
    write(parmunit,*) '--------------------------------------------'
    write(parmunit,*) ' '
    write(parmunit,*) '   rest = ', rest, '   (restart?)'
    write(parmunit,*) '   start time = ',time
    write(parmunit,*) ' '

!$   maxthreads = omp_get_max_threads() 
     write(outunit,*)" max threads set to ",maxthreads
     print *," max threads set to ",maxthreads
    
    !
    !  print out program parameters for this run
    !
    format_string = "(/' amrclaw parameters:',//," // &
                      "' error tol            ',e12.5,/," // &
                      "' spatial error tol    ',e12.5,/," // &
                      "' order of integrator     ',i9,/," // &
                      "' error checking interval ',i9,/," // &
                      "' buffer zone size        ',i9,/," // &
                      "' nghost                  ',i9,/," // &
                      "' volume ratio cutoff  ',e12.5,/," // &
                      "' max. refinement level   ',i9,/," // &
                      "' user sub. calling times ',i9,/," // &
                      "' cfl # (if var. delt) ',e12.5,/)"
    write(outunit,format_string) tol,tolsp,iorder,kcheck,ibuff,nghost,cut, &
                                 mxnest,checkpt_interval,cfl
    format_string = "(' xupper(upper corner) ',e12.5,/," // &
                     "' yupper(upper corner) ',e12.5,/," // &
                     "' xlower(lower corner) ',e12.5,/," // &
                     "' ylower(lower corner) ',e12.5,/," // &
                     "' nx = no. cells in x dir.',i9,/," // &
                     "' ny = no. cells in y dir.',i9,/," // &
                     "' refinement ratios       ',6i5,/,/)"
    write(outunit,format_string) xupper,yupper,xlower,ylower,nx,ny
    write(outunit,"(' refinement ratios:       ',6i5,/)"  ) &
                                                        (intratx(i),i=1,mxnest)
    write(outunit,"(' refinement ratios:       ',6i5,/)"  ) &
                                                        (intraty(i),i=1,mxnest)
    write(outunit,"(' no. auxiliary vars.     ',i9)") naux
    write(outunit,"('       var ',i5,' of type ', a10)") &
                                                (iaux,auxtype(iaux),iaux=1,naux)
    if (mcapa > 0) write(outunit,"(' capacity fn. is aux. var',i9)") mcapa

    print *, ' '
    print *, 'Done reading data, starting computation ...  '
    print *, ' '

    ! initialize timers before calling valout:
    call system_clock(tick_clock_start, clock_rate)
    call cpu_time(tick_cpu_start)

    !printout = .true.
    printout = .false.
    call outtre (mstart,printout,nvar,naux)
    write(outunit,*) "  original total mass ..."
    call conck(1,nvar,naux,time,rest)
    if (output_t0) then
        call valout(1,lfine,time,nvar,naux)
    endif
    close(parmunit)


 

    ! --------------------------------------------------------
    !  Tick is the main routine which drives the computation:
    ! --------------------------------------------------------
    call tick(nvar,cut,nstart,vtime,time,naux,t0,rest,dt_max)
    ! --------------------------------------------------------

    ! Done with computation, cleanup:

    ! close pardiso
    if (isolver .eq. 2) then
#ifdef HAVE_PARDISO
      phase = -1  ! release internal memory
      do level = 1, mxnest
         if (level .le. maxLevelBouss .and. level .ge. minLevelBouss)    &
         CALL pardiso (pt(1,level),maxfct,mnum,mtype,phase,nn,ddum,idum, &
                       idum,idum,nrhs,iparm,msglvl,ddum,ddum,error,dparm)
      end do
#endif
    endif


    ! Print out the fgmax files
    if (FG_num_fgrids > 0) call fgmax_finalize()
    
    write(*,"('See fort.amr for more info on this run and memory usage')")

    ! call system_clock to get clock_finish and count_max for debug output:
    call system_clock(clock_finish,clock_rate,count_max)
    
    !output timing data
    open(timing_unit, file=timing_base_name//"txt", status='unknown',       &
         form='formatted')
    write(*,*)
    write(timing_unit,*)
    format_string="('============================== Timing Data ==============================')"
    write(timing_unit,format_string)
    write(*,format_string)

    write(*,*)
    write(timing_unit,*)
    
    !Integration time
    format_string="('Integration Time (stepgrid + BC + implicit solve + overhead)')"
    write(timing_unit,format_string)
    write(*,format_string)
    
    !Advanc time
    format_string="('Level           Wall Time (seconds)    CPU Time (seconds)   Total Cell Updates')"
    write(timing_unit,format_string)
    write(*,format_string)

    ! level counters are cumulative after restart, so initialize sums to zero 
    ! even after restart to sum up time over all levels
    ttotalcpu=0.d0
    ttotal=0
      
    do level=1,mxnest
        format_string="(i3,'           ',1f15.3,'        ',1f15.3,'    ', e17.3)"
        write(timing_unit,format_string) level, &
             real(tvoll(level),kind=8) / real(clock_rate,kind=8), tvollCPU(level), rvoll(level)
        write(*,format_string) level, &
             real(tvoll(level),kind=8) / real(clock_rate,kind=8), tvollCPU(level), rvoll(level)
        ttotalcpu=ttotalcpu+tvollCPU(level)
        ttotal=ttotal+tvoll(level)
    end do
    
    format_string="('total         ',1f15.3,'        ',1f15.3,'    ', e17.3)"
    write(timing_unit,format_string) &
             real(ttotal,kind=8) / real(clock_rate,kind=8), ttotalCPU, rvol
    write(*,format_string) &
             real(ttotal,kind=8) / real(clock_rate,kind=8), ttotalCPU, rvol
    
    write(*,*)
    write(timing_unit,*)
    
    
    format_string="('All levels:')"
    write(*,format_string)
    write(timing_unit,format_string)
    
    !stepgrid
    format_string="('Stepgrid      ',1f15.3,'        ',1f15.3,'    ',e17.3)"
    write(timing_unit,format_string) &
         real(timeStepgrid,kind=8) / real(clock_rate,kind=8), timeStepgridCPU
    write(*,format_string) &
         real(timeStepgrid,kind=8) / real(clock_rate,kind=8), timeStepgridCPU

    !Linear Solve
    !format_string="('linear solve  ',1f15.3,'        ',1f15.3,'    ',e17.3)"
    format_string="('Linear solve  ',1f15.3,'        ',1f15.3)"
    write(timing_unit,format_string) &
         real(timeLinSolve,kind=8) / real(clock_rate,kind=8), timeLinSolveCPU
    write(*,format_string) &
         real(timeLinSolve,kind=8) / real(clock_rate,kind=8), timeLinSolveCPU

    !preparing/building for Linear Solver
    format_string="('Prep/Build    ',1f15.3,'        ',1f15.3)"
    write(timing_unit,format_string) &
         real(timePrepBuild,kind=8) / real(clock_rate,kind=8), timePrepBuildCPU
    write(*,format_string) &
         real(timePrepBuild,kind=8) / real(clock_rate,kind=8), timePrepBuildCPU
    
    !bound
    format_string="('BC/ghost cells',1f15.3,'        ',1f15.3)"
    write(timing_unit,format_string) &
         real(timeBound,kind=8) / real(clock_rate,kind=8), timeBoundCPU
    write(*,format_string) &
         real(timeBound,kind=8) / real(clock_rate,kind=8), timeBoundCPU
    
    !regridding time
    format_string="('Regridding    ',1f15.3,'        ',1f15.3,'  ')"
    write(timing_unit,format_string) &
            real(timeRegridding,kind=8) / real(clock_rate,kind=8), timeRegriddingCPU
    write(*,format_string) &
            real(timeRegridding,kind=8) / real(clock_rate,kind=8), timeRegriddingCPU
    
    !output time
    format_string="('Output (valout)',1f14.3,'        ',1f15.3,'  ')"
    write(timing_unit,format_string) &
            real(timeValout,kind=8) / real(clock_rate,kind=8), timeValoutCPU
    write(*,format_string) &
            real(timeValout,kind=8) / real(clock_rate,kind=8), timeValoutCPU
    
    write(*,*)
    write(timing_unit,*)
    
    !Total Time
    format_string="('Total time:   ',1f15.3,'        ',1f15.3,'  ')"

    write(*,format_string) real(timeTick,kind=8)/real(clock_rate,kind=8), &
            timeTickCPU
    write(timing_unit,format_string) real(timeTick,kind=8)/real(clock_rate,kind=8), &
            timeTickCPU

    if (isolver .eq. 3) then
       write(*,*)
       write(timing_unit,*)
       write(*,*)"PETSc was called on this level:    Num Times  Avg Num Iters" 
       write(timing_unit,*)"PETSc was called on this level:    Num Times  Avg Num Iters" 
       do level = 1, mxnest
         if (numTimes(level) .gt. 0) then
           write(*,989) level, numTimes(level), real(itcount(level))/real(numTimes(level))
           write(timing_unit,989) level, numTimes(level), real(itcount(level))/real(numTimes(level))
 989       format(18x, i10,2x,i10,3x,f10.2)
         else
           exit
         endif
       end do
    endif

    
    format_string="('OpenMP is using',i3,' thread(s)')"
    write(timing_unit,format_string) maxthreads
    write(*,format_string) maxthreads
    format_string="('MPI    is using',i3,' process(es)')"
    
    
    write(*,*)
    write(timing_unit,*)
    
    
    write(*,"('Note: The CPU times are summed over all threads.')")
    write(timing_unit,"('Note: The CPU times are summed over all threads.')")
    write(*,"('      Total time includes more than the subroutines listed above')")
    write(timing_unit,"('      Total time includes more than the subroutines listed above')")
    if (rest) then
      write(*,"('      Times for restart runs are cumulative')")
      write(timing_unit,"('      Times for restart runs are cumulative')")
    endif

    write(*, "('Note: timings are also recorded for each output step')")
    write(*, "('      in the file timing.csv.')")
    write(timing_unit, "('Note: timings are also recorded for each output step')")
    write(timing_unit, "('      in the file timing.csv.')")
    

    write(*,*)
    write(timing_unit,*)

    ! output clock_rate etc. useful in debugging or if negative time reported

    format_string="('clock_rate = ',i10, ' per second,  count_max = ',i23)"
    !write(*,format_string) clock_rate, count_max
    write(timing_unit,format_string) clock_rate, count_max

    format_string="('clock_start = ',i20, ',  clock_finish = ',i20)"
    !write(*,format_string) tick_clock_start, clock_finish
    write(timing_unit,format_string) tick_clock_start, clock_finish

    format_string="('=========================================================================')"
    write(timing_unit,format_string)
    write(*,format_string)
    write(*,*)
    write(timing_unit,*)
    close(timing_unit)

    if (isolver.eq. 2) then
!     if (countIterRef == 0) then
!         write(*,*) "No implicit solves performed"
!         write(*,*)
!     else
!         write(*,*)"avg # iterative refinements = ",avgIterRef/countIterRef
!         write(*,*)"max # iterative refinements = ",maxIterRef
!         write(*,format_string)
!         write(*,*)
!     endif
    endif

    ! Done with computation, cleanup:
    lentotsave = lentot
    call cleanup(nvar,naux)
    if (lentot /= 0) then
        write(outunit,*) lentot," words not accounted for in memory cleanup"
        print *,         lentot," words not accounted for in memory cleanup"
    endif
    
    !
    ! report on statistics
    !
    open(matunit,file=matfile,status='unknown',form='formatted')
    write(matunit,*) matlabu-1
    write(matunit,*) mxnest
    close(matunit)

    write(outunit,*)
    write(outunit,*)
    do i = 1, mxnest
      if (iregridcount(i) > 0) then
        write(outunit,801) i,avenumgrids(i)/iregridcount(i),iregridcount(i)
 801    format("for level ",i3, " average num. grids = ",f10.2," over ",i10,  &
               " regridding steps")
        write(outunit,802) i,numgrids(i)
 802    format("for level ",i3,"  current num. grids = ",i7)
      endif
    end do

    write(outunit,*)
    write(outunit,*)
    write(outunit,"('alloc array statistics:')")
    write(outunit,"('    current alloc usage = ',i12)") lentotsave
    write(outunit,"('    maximum alloc usage = ',i12)") lenmax
    write(outunit,"('required alloc memsize >= ',i12,/)") lendim

    write(outunit,"('number of cells advanced for time integration = ',f20.6)")&
                    rvol
    do level = 1,mxnest
        write(outunit,"(3x,'# cells advanced on level ',i4,' = ',f20.2)") &
                    level, rvoll(level)
    enddo

    write(outunit,"('number of cells advanced for error estimation = ',f20.6,/)") &
                     evol
    if (evol + rvol > 0.d0) then
        ratmet = rvol / (evol + rvol) * 100.0d0
    else
        ratmet = 0.0d0
    endif
    write(outunit,"(' percentage of cells advanced in time  = ', f10.2)") ratmet
    write(outunit,"(' maximum Courant number seen = ', f10.2)") cflmax

    write(outunit,"(//,' ------  end of AMRCLAW integration --------  ')")

    ! Close output and debug files.
    close(outunit)
    close(dbugunit)

#ifdef HAVE_PETSC
      call PetscFinalize(ierr)
#endif

end program amr2

c
c ----------------------------------------------------------
c
      subroutine errsp(ect,sperr,mitot,mjtot,mktot,nvar,mptr,ng,
     &                 eprint, outunit)
c
c **********************
c ****** OBSOLETE ******  No longer used in amrclaw.
c **********************
c
c ::::::::::::::::::::: ERRSP ::::::::::::::::::::::::::::::::::
c estimate spatial only component of the error
c rect   = grid values including ghost cells
c sperr  = user computed fn. (density gradient here)
c           (if sperr(i,j,k) > tolsp cell will be flagged)
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      implicit double precision (a-h, o-z)

c      include  "call.i"

      dimension   rect(mitot,mjtot,mktot,nvar)
      dimension  sperr(mitot,mjtot,mktot)

c
c     # This routine is obsolete and no longer used.
c
      write(6,*) '*** The new version of AMRCLAW requires some changes'
      write(6,*) 'to Makefile:'
      write(6,*) '   Remove errsp.f (no longer used)'
      write(6,*) '   Add the following library routines to Makefile:'
      write(6,*) '      $(CLAW)/amrclaw/3d/lib/bufnst.f'
      write(6,*) '      $(CLAW)/amrclaw/3d/lib/spest.f'
      write(6,*) '      $(CLAW)/amrclaw/3d/lib/flag2refine.f'
      write(6,*) '      $(CLAW)/amrclaw/3d/lib/allowflag.f'
      write(6,*) 'See the documentation in flag2refine.f and '
      write(6,*) '    allowflag.f for more information.'


      stop

      end

c
c
c     =================================================================
      subroutine bc1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt,mthbc)
c     =================================================================
c
c     # Standard boundary condition choices for claw2
c
c     # Modified for 1d GeoClaw to extend topo aux(1,:) to ghost cells.
c
c     # At each boundary  k = 1 (left),  2 (right):
c     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
c     #            =  1  for zero-order extrapolation
c     #            =  2  for periodic boundary coniditions
c     #            =  3  for solid walls, assuming this can be implemented
c     #                  by reflecting the data about the boundary and then
c     #                  negating the 2'nd component of q.
c     ------------------------------------------------
c
c     # Extend the data from the computational region
c     #      i = 1, 2, ..., mx2
c     # to the virtual cells outside the region, with
c     #      i = 1-ibc  and   i = mx+ibc   for ibc=1,...,mbc
c
      implicit double precision (a-h,o-z)
      dimension q(meqn,1-mbc:mx+mbc)
      dimension aux(maux,1-mbc:mx+mbc)

      dimension mthbc(2)

c
c
c-------------------------------------------------------
c     # left boundary:
c-------------------------------------------------------
      do ibc=1,mbc
         aux(1,1-ibc)=aux(1,1)
      enddo

      go to (100,110,120,130) mthbc(1)+1
c
  100 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(1)=0 and no BCs specified in bc1'
      stop
      go to 199
c
  110 continue
c     # zero-order extrapolation:
      do ibc=1,mbc
         do m=1,meqn
            q(m,1-ibc) = q(m,1)
         end do
      end do
      go to 199

  120 continue
c     # periodic:
      do ibc=1,mbc
         do m=1,meqn
            q(m,1-ibc) = q(m,mx+1-ibc)
         end do
      end do
      go to 199

  130 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do ibc=1,mbc
         do m=1,meqn
            q(m,1-ibc) = q(m,ibc)
         end do
c        # negate the normal velocity:
         q(2,1-ibc) = -q(2,ibc)
      end do
      go to 199

  199 continue

c
c-------------------------------------------------------
c     # right boundary:
c-------------------------------------------------------
      do ibc=1,mbc
         aux(1,mx+ibc)=aux(1,mx)
      enddo

      go to (200,210,220,230) mthbc(2)+1
c
  200 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(2)=0 and no BCs specified in bc2'
      stop
      go to 299

  210 continue
c     # zero-order extrapolation:
      do ibc=1,mbc
         do m=1,meqn
            q(m,mx+ibc) = q(m,mx)
         end do
      end do
      go to 299

  220 continue
c     # periodic:
      do ibc=1,mbc
         do m=1,meqn
            q(m,mx+ibc) = q(m,ibc)
         end do
      end do
      go to 299

  230 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do ibc=1,mbc
         do m=1,meqn
            q(m,mx+ibc) = q(m,mx+1-ibc)
         end do
c        # negate the normal velocity:
         q(2,mx+ibc) = -q(2,mx+1-ibc)
      end do
      go to 299

  299 continue
c
      return
      end

c
c ------------------------------------------------------------------
c
      subroutine bc2amr(val,aux,nrow,ncol,meqn,naux,
     1                  hx, hy, level, time, 
     2                  xlo_patch, xhi_patch,  
     3                  ylo_patch, yhi_patch)
 
c
c
c :::::::::: bc2amr ::::::::::::::::::::::::::::::::::::::::::::::;
c
c     Take a grid patch with mesh widths hx,hy, of dimensions nrow by
c     ncol,  and set the values of any piece of
c     of the patch which extends outside the physical domain 
c     using the boundary conditions. 
c
c     ------------------------------------------------
c     # Standard boundary condition choices for amr2ez in clawpack
c
c     # At each boundary  k = 1 (left),  2 (right),  3 (bottom), 4 (top):
c     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
c     #            =  1  for zero-order extrapolation
c     #            =  2  for periodic boundary conditions
c     #            =  3  for solid walls, assuming this can be implemented
c     #                  by reflecting the data about the boundary and then
c     #                  negating the 2'nd (for k=1,2) or 3'rd (for k=3,4)
c     #                  component of q.
c     #            =  5  sphere bcs (left half maps to right half of same 
c     #                  side, and vice versa), as if domain folded in half
c     ------------------------------------------------
c
c     The corners of the grid patch are at 
c        (xlo_patch,ylo_patch)  --  lower left corner
c        (xhi_patch,yhi_patch) --  upper right corner
c
c     The physical domain itself is a rectangle bounded by
c        (xlower,ylower)  -- lower left corner
c        (xupper,yupper)  -- upper right corner
c     
c     the picture is the following: 
c
c               _____________________ (xupper,yupper)
c              |                     |  
c          ____|____ (xhi_patch,yhi_patch)  
c          |   |    |                |
c          |   |    |                |
c          |   |    |                |
c          |___|____|                |
c (xlo_patch,ylo_patch)              |
c              |                     |
c              |_____________________|
c   (xlower,ylower)
c        
c
c     Any cells that lie outside the physical domain are ghost cells whose
c     values should be set in this routine.  This is tested for by comparing
c     xlo_patch with xlower to see if values need to be set at the left, as in
c     the figure above, and similarly at the other boundaries.
c
c     Patches are guaranteed to have at least 1 row of cells filled
c     with interior values so it is possible to  extrapolate. 
c     Fix trimbd if you want more than 1 row pre-set.
c
c     Make sure the order the boundaries are specified is correct
c     so that diagonal corner cells are also properly taken care of.
c
c     Periodic boundaries are set before calling this routine, so if the
c     domain is periodic in one direction only you
c     can safely extrapolate in the other direction. 
c
c     Don't overwrite ghost cells in periodic directions!
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module, only: mthbc,xlower,ylower,xupper,yupper
      use amr_module, only: xperdom,yperdom,spheredom

      implicit double precision (a-h,o-z)

C      common /combc2/ mthbc(4)

      dimension val(meqn,nrow,ncol), aux(naux,nrow,ncol)

      hxmarg = hx*.01
      hymarg = hy*.01

      if (xperdom .and. (yperdom .or. spheredom)) go to 499
c
c
c-------------------------------------------------------
c     # left boundary:
c-------------------------------------------------------
      if (xlo_patch .ge. xlower-hxmarg) then
c        # not a physical boundary -- no cells at this edge lies
c        # outside the physical bndry.
c        # values are set elsewhere in amr code.
         go to 199
         endif
c
c     # number of grid cells from this patch lying outside physical domain:
      nxl = (xlower+hxmarg-xlo_patch)/hx
c
      go to (100,110,120,130) mthbc(1)+1
c
  100 continue
c     Test for bc set condition
      do j=1,ncol
        y = ylo_patch + hy * (j-0.5d0)
        do i=1,nxl
          if (0.25d0 < y .and. y < 0.75d0) then
            val(1,i,j) = 1.d0
          else
            val(1,i,j) = 0.1d0
          end if
        end do
      end do
      
      go to 199
c
  110 continue
c     # zero-order extrapolation:
      do 115 j = 1,ncol
         do 115 i=1,nxl
            do 115 m=1,meqn
               val(m,i,j) = val(m,nxl+1,j)
  115       continue
      go to 199

  120 continue
c     # periodic:   handled elsewhere in amr
      go to 199

  130 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 135 j = 1,ncol
         do 135 i=1,nxl
            do 135 m=1,meqn
               val(m,i,j) = val(m,2*nxl+1-i,j)
  135       continue
c     # negate the normal velocity:
      do 136 j = 1,ncol
         do 136 i=1,nxl
            val(2,i,j) = -val(2,i,j)
  136    continue
      go to 199

  199 continue
c
c-------------------------------------------------------
c     # right boundary:
c-------------------------------------------------------
      if (xhi_patch .le. xupper+hxmarg) then
c        # not a physical boundary --  no cells at this edge lies
c        # outside the physical bndry.
c        # values are set elsewhere in amr code.
         go to 299
         endif
c
c     # number of grid cells lying outside physical domain:
      nxr = (xhi_patch - xupper + hxmarg)/hx
      ibeg = max0(nrow-nxr+1, 1)
c
      go to (200,210,220,230) mthbc(2)+1
c
  200 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) 
     &   '*** ERROR *** mthbc(2)=0 and no BCs specified in bc2amr'
      stop
      go to 299

  210 continue
c     # zero-order extrapolation:
      do 215 j = 1,ncol
         do 215 i=ibeg,nrow
            do 215 m=1,meqn
               val(m,i,j) = val(m,ibeg-1,j)
  215       continue
      go to 299
  
  220 continue
c     # periodic:   handled elsewhere in amr
      go to 299

  230 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 235 j = 1,ncol
         do 235 i=ibeg,nrow
            do 235 m=1,meqn
               val(m,i,j) = val(m,2*ibeg-1-i,j)
  235       continue
c     # negate the normal velocity:
      do 236 j = 1,ncol
         do 236 i=ibeg,nrow
            val(2,i,j) = -val(2,i,j)
  236    continue
      go to 299
   
  299 continue
c
c-------------------------------------------------------
c     # bottom boundary:
c-------------------------------------------------------
      if (ylo_patch .ge. ylower-hymarg) then
c        # not a physical boundary -- no cells at this edge lies
c        # outside the physical bndry.
c        # values are set elsewhere in amr code.
         go to 399
         endif
c
c     # number of grid cells lying outside physical domain:
      nyb = (ylower+hymarg-ylo_patch)/hy
c
      go to (300,310,320,330) mthbc(3)+1
c
  300 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) 
     &   '*** ERROR *** mthbc(3)=0 and no BCs specified in bc2amr'
      stop
      go to 399
c
  310 continue
c     # zero-order extrapolation:
      do 315 j=1,nyb
         do 315 i=1,nrow
            do 315 m=1,meqn
                val(m,i,j) = val(m,i,nyb+1)
  315       continue
      go to 399

  320 continue
c     # periodic:   handled elsewhere in amr
      go to 399

  330 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 335 j=1,nyb
         do 335 i=1,nrow
            do 335 m=1,meqn
               val(m,i,j) =  val(m,i,2*nyb+1-j)
  335       continue
c     # negate the normal velocity:
      do 336 j=1,nyb
         do 336 i=1,nrow
            val(3,i,j) = -val(3,i,j)
  336    continue
      go to 399

  399 continue
c
c-------------------------------------------------------
c     # top boundary:
c-------------------------------------------------------
      if (yhi_patch .le. yupper+hymarg) then
c        # not a physical boundary --  no cells at this edge lies
c        # outside the physical bndry.
c        # values are set elsewhere in amr code.
         go to 499
         endif
c
c     # number of grid cells lying outside physical domain:
      nyt = (yhi_patch - yupper + hymarg)/hy
      jbeg = max0(ncol-nyt+1, 1)
c
      go to (400,410,420,430) mthbc(4)+1
c
  400 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) 
     &   '*** ERROR *** mthbc(4)=0 and no BCs specified in bc2amr'
      stop
      go to 499

  410 continue
c     # zero-order extrapolation:
      do 415 j=jbeg,ncol
         do 415 i=1,nrow
            do 415 m=1,meqn
               val(m,i,j) =  val(m,i,jbeg-1)
  415       continue
      go to 499

  420 continue
c     # periodic:   handled elsewhere in amr
      go to 499

  430 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 435 j=jbeg,ncol
         do 435 i=1,nrow
            do 435 m=1,meqn
               val(m,i,j) =  val(m,i,2*jbeg-1-j)
  435       continue
c     # negate the normal velocity:
      do 436 j=jbeg,ncol
         do 436 i=1,nrow
            val(3,i,j) = -val(3,i,j)
  436    continue
      go to 499

  499 continue

      return
      end

subroutine step1(maxm,meqn,maux,mbc,mx,qold,aux,dx,dt,cflgrid,fm,fp,rp1)
!
!     clawpack routine ...  modified for AMRCLAW
!
!     Take one time step, updating q.
!     On entry, qold gives
!        initial data for this step
!        and is unchanged in this version.
!    
!     fm, fp are fluxes to left and right of single cell edge
!     See the flux1 documentation for more information.
!
!     Converted to f90 2012-1-04 (KTM)
!     Modified from step2 to work with 1d 2016-6-6 (BND)
    
    use amr_module

    implicit none
    
    external rp1
    
    ! Arguments
    integer, intent(in) :: maxm,meqn,maux,mbc,mx
    real(kind=8), intent(in) :: dx,dt
    real(kind=8), intent(inout) :: cflgrid
    real(kind=8), intent(inout) :: qold(meqn, 1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: fm(meqn, 1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: fp(meqn,1-mbc:mx+mbc)
    
    ! Local storage for flux accumulation
    real(kind=8) :: faddm(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: faddp(meqn,1-mbc:maxm+mbc)
    
    ! Scratch storage for Sweeps and Riemann problems
    real(kind=8) ::  q1d(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: aux1(maux,1-mbc:maxm+mbc)
    real(kind=8) :: dtdx1d(1-mbc:maxm+mbc)
    real(kind=8) :: dtdy1d(1-mbc:maxm+mbc)
    
    real(kind=8) ::  wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8) ::     s(mwaves, 1-mbc:maxm + mbc)
    real(kind=8) ::  amdq(meqn,1-mbc:maxm + mbc)
    real(kind=8) ::  apdq(meqn,1-mbc:maxm + mbc)
    real(kind=8) ::  cqxx(meqn,1-mbc:maxm + mbc)
    real(kind=8) :: bmadq(meqn,1-mbc:maxm + mbc)
    real(kind=8) :: bpadq(meqn,1-mbc:maxm + mbc)
    
    ! Looping scalar storage
    integer :: i,j,thread_num
    real(kind=8) :: dtdx,cfl1d
    
    ! Common block storage
    integer :: icom
    real(kind=8) :: dtcom,dxcom,tcom
    common /comxt/ dtcom,dxcom,tcom,icom
    
    ! Store mesh parameters in common block
    dxcom = dx
    dtcom = dt
    
    cflgrid = 0.d0
    dtdx = dt/dx
    
    fm = 0.d0
    fp = 0.d0
    
    ! ============================================================================
    ! Perform X-Sweep
        ! Copy old q into 1d slice
        q1d(:,1-mbc:mx+mbc) = qold(:,1-mbc:mx+mbc)
        
        ! Set dtdx slice if a capacity array exists
        if (mcapa > 0)  then
            dtdx1d(1-mbc:mx+mbc) = dtdx / aux(mcapa,1-mbc:mx+mbc)
        else
            dtdx1d = dtdx
        endif
        
        ! Copy aux array into slices
        if (maux > 0) then
            aux1(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc)
        endif

        ! Compute modification fadd to fluxes along this slice:
        call flux1(maxm,meqn,maux,mbc,mx,q1d,dtdx1d,aux1, &
                   faddm,faddp,cfl1d,wave,s, &
                   amdq,apdq,cqxx,bmadq,bpadq,rp1)
                   
        cflgrid = max(cflgrid,cfl1d)

        ! Update fluxes
        fm(:,1:mx+1) = fm(:,1:mx+1) + faddm(:,1:mx+1)
        fp(:,1:mx+1) = fp(:,1:mx+1) + faddp(:,1:mx+1)

end subroutine step1

subroutine b4step3(mbc,mx,my,mz,meqn,q,xlower,ylower,zlower, &
    dx,dy,dz,t,dt,maux,aux)

    ! Called before each call to step3.
    ! Use to set time-dependent aux arrays or perform other tasks.
    !
    ! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: mbc,mx,my,mz,meqn,maux
    real(kind=8), intent(in) :: xlower,ylower,zlower,dx,dy,dz,t,dt
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)

end subroutine b4step3

! =========================================================
subroutine tfluct1(maxnx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,amdq2)
! =========================================================
!
!	dummy tfluct function (see example euler_1d for more information)

    implicit double precision (a-h,o-z)

    write(*,*) "Error: solver.tfluct_solver=True, but you have not defined"
    write(*,*) "a tfluct solver, have you imported your solver and set solver.tfluct?"
    write(*,*) "see example/euler_1d for more information"

    stop

    return
end subroutine tfluct1


! =========================================================
subroutine tfluct2(ixyz,maxnx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,amdq2)
! =========================================================
!
!	dummy tfluct function (see example euler_1d for more information)

    implicit double precision (a-h,o-z)

    write(*,*) "Error: solver.tfluct_solver=True, but you have not defined"
    write(*,*) "a tfluct solver, have you imported your solver and set solver.tfluct?"
    write(*,*) "see example/euler_1d for more information"

    stop

    return
end subroutine tfluct2

! =========================================================
subroutine tfluct3(ixyz,maxnx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,amdq2)
! =========================================================
!
!	dummy tfluct function (see example euler_1d for more information)

    implicit double precision (a-h,o-z)

    write(*,*) "Error: solver.tfluct_solver=True, but you have not defined"
    write(*,*) "a tfluct solver, have you imported your solver and set solver.tfluct?"
    write(*,*) "see example/euler_1d for more information"

    stop

    return
end subroutine tfluct3

c
c
c     =====================================================
      subroutine limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c     =====================================================
c
c     # Apply a limiter to the waves.
c     # The limiter is computed by comparing the 2-norm of each wave with
c     # the projection of the wave from the interface to the left or
c     # right onto the current wave.  For a linear system this would
c     # correspond to comparing the norms of the two waves.  For a 
c     # nonlinear problem the eigenvectors are not colinear and so the 
c     # projection is needed to provide more limiting in the case where the
c     # neighboring wave has large norm but points in a different direction
c     # in phase space.
c
c     # The specific limiter used in each family is determined by the
c     # value of the corresponding element of the array mthlim, as used in
c     # the function philim.
c     # Note that a different limiter may be used in each wave family.
c
c     # dotl and dotr denote the inner product of wave with the wave to
c     # the left or right.  The norm of the projections onto the wave are then
c     # given by dotl/wnorm2 and dotr/wnorm2, where wnorm2 is the 2-norm
c     # of wave.
c
      implicit double precision (a-h,o-z)
      dimension mthlim(mwaves)
      dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
      dimension    s(mwaves, 1-mbc:maxm+mbc)
c
c
      do 50 mw=1,mwaves
         if (mthlim(mw) .eq. 0) go to 50
         dotr = 0.d0
         do 40 i = 0, mx+1
            wnorm2 = 0.d0
            dotl = dotr
            dotr = 0.d0
            do 20 m=1,meqn
               wnorm2 = wnorm2 + wave(m,mw,i)**2
               dotr = dotr + wave(m,mw,i)*wave(m,mw,i+1)
   20          continue
            if (i.eq.0) go to 40
            if (wnorm2.eq.0.d0) go to 40
c
            if (s(mw,i) .gt. 0.d0) then
                wlimitr = philim(wnorm2, dotl, mthlim(mw))
              else
                wlimitr = philim(wnorm2, dotr, mthlim(mw))
              endif
c
            do 30 m=1,meqn
               wave(m,mw,i) = wlimitr * wave(m,mw,i)
   30          continue
   40       continue
   50    continue
c
      return
      end

c
!> This subroutine is called by setgrd and regrid to actually fit the new grids
!! on each level. lcheck is the level being error estimated
!! so that lcheck+1 will be the level of the new grids.
!!
!! It generates all grids on level **lcheck**+1 and ensure proper
!! nesting.
!!
!! \param lbase base AMR level for current refinement, which stays
!!  fixed. Note that **lbase** is always less or equal to **lcheck**
!! \param lcheck the level being error estimated so that lcheck+1 will be the level of the new grids.
!! \param nvar number of equations for the system
!! \param naux  number of auxiliary variables
!! \param cut efficiency threshold for the clustering algorithm
!! \param time current simulation time
!! \param start_time start time of current simulation
c
c ---------------------------------------------------------
c
      subroutine grdfit (lbase,lcheck,nvar,naux,cut,time,
     1                   start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer(kind=8) :: clock_start, clock_finish, clock_rate
      integer(kind=8) :: clock_start1
c
      dimension  corner(nsize,maxcl)
      integer    numptc(maxcl), prvptr
      logical    fit,  cout
      logical    fit2, nestck2
      data       cout/.false./
c
c
#ifdef WHERE_AM_I
      write(*,*)"starting grdfit"
#endif
      call system_clock(clock_start,clock_rate)


c ### initialize region start and end indices for new level grids
      iregst(lcheck+1) = iinfinity
      jregst(lcheck+1) = iinfinity
      iregend(lcheck+1) = -1
      jregend(lcheck+1) = -1

c     ## flag all grids at given level based on error ests.
c     ## npts is number of points actually colated - some
c     ## flagged points turned off due to proper nesting requirement.
c     ## (storage based on nptmax calculation however).

      call system_clock(clock_start1,clock_rate)
      call flglvl2(nvar,naux,lcheck,nptmax,index,lbase,npts,start_time)
      call system_clock(clock_finish,clock_rate)
      timeFlglvl = timeFlglvl + clock_finish - clock_start1

      if (npts .eq. 0) go to 99
c
      levnew    = lcheck + 1
      hxfine    = hxposs(levnew)
      hyfine    = hyposs(levnew)
c
c     ## call smart_bisect grid gen. to make the clusters
c        till each cluster ok. needs scratch space.
c
       idim = iregsz(lcheck)
       jdim = jregsz(lcheck)
c       lociscr = igetsp(idim+jdim)
c       locjscr = lociscr + idim
       call smartbis(alloc(index),npts,cut,numptc,nclust,lbase,
     2               corner,idim,jdim)
c     2               corner,alloc(lociscr),alloc(locjscr),idim,jdim)
c       call reclam(lociscr,idim+jdim)

       if (gprint) then
          write(outunit,103) nclust
          write(outunit,104) (icl, numptc(icl),icl=1,nclust)
 103      format(' ',i4,' clusters after bisect')
 104      format('         cluster ',i5,' has points: ',i8)
       endif
c
c     ##  for each cluster, fit the actual grid, set up some data structures
c
 50   ibase   =  0
      icl     =  1
      prvptr  =  null
c
 70   mnew      = nodget()
c       if (lcheck .eq. 2 .and. (mnew .ne. 6 .and. mnew .ne. 7)) go to 69 
c       if (lcheck .eq. 1 .and. (mnew .ne. 3 .and. mnew .ne. 2 )) go to 69 
 75   call  moment(node(1,mnew),alloc(index+2*ibase),numptc(icl),usage)

      if (gprint) write(outunit,100) icl,mnew,usage,numptc(icl)
100   format('         cluster ',i5,' new rect.',i5,
     1       ' usage ',e12.5,' with ',i5,' pts.')

      node(ndilo,mnew) = node(ndilo,mnew)*intratx(lcheck)
      node(ndjlo,mnew) = node(ndjlo,mnew)*intraty(lcheck)
      node(ndihi,mnew) = (node(ndihi,mnew)+1)*intratx(lcheck) - 1
      node(ndjhi,mnew) = (node(ndjhi,mnew)+1)*intraty(lcheck) - 1
      rnode(cornxlo,mnew)  = node(ndilo,mnew)*hxfine + xlower
      rnode(cornylo,mnew)  = node(ndjlo,mnew)*hyfine + ylower
      rnode(cornxhi,mnew)  = (node(ndihi,mnew)+1)*hxfine + xlower
      rnode(cornyhi,mnew)  = (node(ndjhi,mnew)+1)*hyfine + ylower
      node(nestlevel,mnew)     = levnew
      rnode(timemult,mnew)   = time

      if (gprint) then
          write(outunit,101) (node(i,mnew),i=1,nsize)
          write(outunit,102) (rnode(i,mnew),i=1,rsize)
 101      format(5i15)
 102      format(5e15.7)
      endif
c
c     ##  if new grid doesn't fit in base grid, nestck bisect it
c     ##  and returns 2 clusters where there used to be 1.
c
c 2/28/02 : Added naux to argument list; needed by call to outtre in nestck

      fit2 = nestck2(mnew,lbase,alloc(index+2*ibase),numptc(icl),numptc,
     1             icl,nclust,nvar, naux)
      if (.not. fit2) go to 75
c
c     ##  grid accepted. put in list.
      if (newstl(levnew) .eq. null) then
          newstl(levnew)  = mnew
      else
          node(levelptr,prvptr) = mnew
      endif
      prvptr = mnew
c     # keep track of min and max location of grids at this level
      iregst(levnew)  = MIN(iregst(levnew), node(ndilo,mnew))
      jregst(levnew)  = MIN(jregst(levnew), node(ndjlo,mnew))
      iregend(levnew) = MAX(iregend(levnew),node(ndihi,mnew))
      jregend(levnew) = MAX(jregend(levnew),node(ndjhi,mnew))

c     ##  on to next cluster
 69     ibase  = ibase + numptc(icl)
      icl = icl + 1
      if (icl .le. nclust) go to 70
c
c    ##  clean up. for all grids check final size.
      call birect(newstl(levnew))

 99   continue
c    ## may have npts 0 but array was allocated due to initially flagged points
c    ## that were not allowed for proper nesting or other reasons. in this case
c    ## the array was still allocated, so need to test further to see if colating
c    ## array space needs to be reclaimed
      if (nptmax .gt. 0) call reclam(index, 2*nptmax) 
c
      call system_clock(clock_finish,clock_rate)
      timeGrdfitAll = timeGrdfitAll + clock_finish - clock_start

#ifdef WHERE_AM_I
      write(*,*)"ending   grdfit"
#endif

      return
      end

subroutine setprob
      implicit double precision (a-h,o-z)
      character*25 fname
      common /cparam/ ubar,vbar,wbar
!
!     # Set the velocity for scalar advection
!     # These values are passed to setaux in a common block
!

      iunit = 7
      fname = 'setprob.data'
      call opendatafile(iunit, fname)
                
      read(7,*) ubar
      read(7,*) vbar
      read(7,*) wbar

end subroutine setprob

c
c ----------------------------------------------------
c
      subroutine domshrink(iflags2,iflags,idim,jdim)

      use amr_module
      implicit double precision (a-h, o-z)


      integer(kind=1)  iflags2(0:idim+1,0:jdim+1)
      integer(kind=1)  iflags (0:idim+1,0:jdim+1)

c
c :::::::::::::::::::::::::  DOMSHRINK ::::::::::::::::::::::::::::
c
!>  shrink domain flags one cell for allowable properly nested domain
!!  This is needed even for lcheck = lbase. More shrinking needed
!!  for finer levels.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
        write(outunit,*)" from domshrink: on entry, iflags2"
        do 10 jj = 1, jdim
        j = jdim + 1 - jj
        write(outunit,100)(iflags2(i,j),i=1,idim)
 100    format(80i1)
 10     continue
      endif

      do j = 1, jdim
      do i = 1, idim
         iflags(i,j) = iflags2(i,j)
         if (iflags2(i  ,j  ) .le. 0 .or.
     1       iflags2(i+1,j  ) .le. 0 .or. iflags2(i-1,j  ) .le. 0 .or. 
     2       iflags2(i+1,j+1) .le. 0 .or. iflags2(i-1,j+1) .le. 0 .or. 
     3       iflags2(i  ,j-1) .le. 0 .or. iflags2(i  ,j+1) .le. 0 .or.
     4       iflags2(i+1,j-1) .le. 0 .or. iflags2(i-1,j-1) .le. 0) then
                 iflags(i,j) = 0
          endif
      end do
      end do
c
c if border of domain touches a physical boundary then set domain in
c ghost cell as well
c
C WHY DOESNT THIS HAVE TO HAVE PERIODIC CLAUSE(AND spheredom)
       if (.not. xperdom) then
         do 55 j = 1, jdim
           if (iflags(1,j) .eq. 1) iflags(0,j) = 1
           if (iflags(idim,j) .eq. 1) iflags(idim+1,j) = 1
 55      continue
       endif
       if (.not. yperdom) then
         do 65 i = 1, idim
           if (iflags(i,1) .eq. 1) iflags(i,0) = 1
           if (iflags(i,jdim) .eq. 1) iflags(i,jdim+1) = 1
 65      continue
       endif

      if (dprint) then
        write(outunit,*)" from domshrink: on exit, iflags"
        do 70 jj = 1, jdim
        j = jdim + 1 - jj
        write(outunit,100)(iflags(i,j),i=1,idim)
 70     continue
      endif

      return
      end

real(kind=8) pure function get_max_speed(val,mitot,mjtot,nvar,aux,naux,nghost,hx,hy)

    use geoclaw_module, only: dry_tolerance, coordinate_system
    use geoclaw_module, only: grav, earth_radius, DEG2RAD
      
    implicit none
    
    ! Arguments
    integer, intent(in) :: mitot,mjtot,nvar,naux,nghost
    real(kind=8), intent(in) :: hx,hy
    real(kind=8), intent(in) :: val(nvar,mitot,mjtot), aux(naux,mitot,mjtot)
    
    ! Locals
    integer :: i,j
    real(kind=8) :: ymetric,hyphys,xmetric,hxphys,u,v,sig,sp_over_h


    sp_over_h = 0.d0   ! compute max speed over h, since dx may not equal dy
    if (coordinate_system == 2) then
        do j = nghost+1, mjtot-nghost
            ymetric = earth_radius*deg2rad
            hyphys = ymetric*hy

            do i = nghost+1, mitot-nghost
                xmetric = cos(aux(3,i,j)) * earth_radius * DEG2RAD
                hxphys = xmetric * hx
                if (val(1,i,j) > dry_tolerance) then
                    u  = val(2,i,j) / val(1,i,j)
                    v  = val(3,i,j) / val(1,i,j)
                    sig = sqrt(grav*val(1,i,j))
                    sp_over_h = max((abs(u)+sig)/hxphys,(abs(v)+sig)/hyphys,sp_over_h)
                endif
            end do
        end do
    else  ! speeds in cartesian coords, no metrics needed
        do j = nghost+1, mjtot-nghost
            do i = nghost+1, mitot-nghost
                if (val(1,i,j) > dry_tolerance) then
                    u  = val(2,i,j) / val(1,i,j)
                    v  = val(3,i,j) / val(1,i,j)
                    sig = sqrt(grav*val(1,i,j))
                    sp_over_h = max((abs(u)+sig)/hx,(abs(v)+sig)/hy,sp_over_h)
                endif
            end do
        end do
    endif
      
    get_max_speed = sp_over_h

end function get_max_speed

c
c ------------------------------------------------------
c
      subroutine basic (time,lst,lend)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c :::::::::::::::::::::: BASIC :::::::::::::::::::::::::
c  basic = outputs basic information needed by the other graphics
c          output routines (valout,drawrg). at the given time,
c          write the entire levellist, from level 1 to lfine,
c          and the tree structure from level lst to lend.
c :::::::::::::::::::::::::::::;::::::::::::::::::::::::
c
      write(pltunit1,100) time
100   format(8h*TIME = ,f10.5)
      write(pltunit1,101) lfine, (lstart(i),i=1,lfine), nghost
101   format(10i6)
      write(pltunit1,105) xupper,yupper,zupper,xlower,ylower,zlower
105   format(4e15.8)
      write(pltunit1,102) lst, lend
102   format(2i6)
      write(pltunit1,106)(hxposs(i),i=1,lfine)
      write(pltunit1,106)(hyposs(i),i=1,lfine)
      write(pltunit1,106)(hzposs(i),i=1,lfine)
106   format(6e15.8)
c
      level = lst
 10   if (level .gt. lend) go to 99
          mptr = lstart(level)
 20       if (mptr .eq. 0) go to 30
              write(pltunit1,103) mptr, (node(i,mptr),i=1,nsize)
              write(pltunit1,104) (rnode(i,mptr),i=1,rsize)
103           format(10i7)
104           format(5e15.8)
              mptr = node(levelptr,mptr)
          go to 20
 30       level = level + 1
      go to 10
c
 99   return
      end

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! =====================================================

! Approximate Riemann solver for the nonlinear p-system in 2d
! with variable coefficients.

! waves: 2
! equations: 3

! Conserved quantities:
!       1 strain
!       2 x_momentum
!       3 y_momentum

! The variable names are based on an elasticity interpretation

! The jacobian matrix of the flux vector (in each direction)
! is approximated by the linear localized problem.
 
! There are 3 eigenvectors; however, the second eigenvalue
! is always zero and just two waves are computed.

! Solve Riemann problems along one slice of data:
!  in the x-direction if ixy=1
!  in the y-direction if ixy=2.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! f-wave approach is considered. This consists in decomposing the flux
! difference (assuming it's continuous) using the eigenvectors of the
! jacobian matrices of the flux vectors (in each spatial direction).
! This is convinient for variable coefficient PDEs.

! On output, fwave contains the f-waves,
!            s the speeds,
!            amdq the  left-going fluctuation
!            apdq the right-going fluctuation

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr

    implicit double precision (a-h,o-z)
    dimension fwave(meqn,mwaves,1-mbc:maxm+mbc)
    dimension    s(mwaves,1-mbc:maxm+mbc)
    dimension   ql(meqn,1-mbc:maxm+mbc)
    dimension   qr(meqn,1-mbc:maxm+mbc)
    dimension apdq(meqn,1-mbc:maxm+mbc)
    dimension amdq(meqn,1-mbc:maxm+mbc)
    dimension auxl(maux,1-mbc:maxm+mbc)
    dimension auxr(maux,1-mbc:maxm+mbc)
          
    do 10 i=2-mbc,mx+mbc
    ! material properties
        pim=auxr(1,i-1)
        pi=auxl(1,i)
        Eim=auxr(2,i-1)
        Ei=auxl(2,i)
    ! solution eps, urho and vrho
        epsi=ql(1,i)
        urhoi=ql(2,i)
        vrhoi=ql(3,i)
        epsim=qr(1,i-1)
        urhoim=qr(2,i-1)
        vrhoim=qr(3,i-1)
    ! linearity of material (for cell i and for cell im)
        linearity_mati = nint(auxl(3,i))
        linearity_matim = nint(auxr(3,i-1))
    ! sigma
        sigmai=sigma(epsi,Ei,linearity_mati)
        sigmaim=sigma(epsim,Eim,linearity_matim)
    ! sigmap
        sigmapi=sigmap(epsi,Ei,linearity_mati)
        sigmapim=sigmap(epsim,Eim,linearity_matim)
    ! computation of components of eigenvectors
        r11=1/dsqrt(sigmapim*pim)
        r13=-1/dsqrt(sigmapi*pi)
    ! shock speeds
        s(1,i)=-dsqrt(sigmapim/pim)  !lambda_1
        s(2,i)=dsqrt(sigmapi/pi)     !lambda_2
             
        if(ixy == 1) then      !x direction
        ! compute jump in flux
            dF1=-(urhoi/pi-urhoim/pim)
            dF2=-(sigmai-sigmaim)
        ! compute betas
            beta1=(dF1-r13*dF2)/(r11-r13)
            beta3=(-dF1+r11*dF2)/(r11-r13)
        ! compute f-waves
            fwave(1,1,i)=beta1*r11
            fwave(2,1,i)=beta1*1
            fwave(3,1,i)=beta1*0
            fwave(1,2,i)=beta3*r13
            fwave(2,2,i)=beta3*1
            fwave(3,2,i)=beta3*0
        else                   !y direction
        ! compute jump in flux
            dF1=-(vrhoi/pi-vrhoim/pim)
            dF3=-(sigmai-sigmaim)
        ! compute betas
            beta1=(dF1-r13*dF3)/(r11-r13)
            beta3=(-dF1+r11*dF3)/(r11-r13)
        ! compute f-waves
            fwave(1,1,i)=beta1*r11
            fwave(2,1,i)=beta1*0
            fwave(3,1,i)=beta1*1
            fwave(1,2,i)=beta3*r13
            fwave(2,2,i)=beta3*0
            fwave(3,2,i)=beta3*1
        endif
    ! computation of the fluctuations
        amdq(1,i)=fwave(1,1,i)
        amdq(2,i)=fwave(2,1,i)
        amdq(3,i)=fwave(3,1,i)
        apdq(1,i)=fwave(1,2,i)
        apdq(2,i)=fwave(2,2,i)
        apdq(3,i)=fwave(3,2,i)

    10 END DO
         
    return
    end subroutine rpn2

    double precision function sigma(eps,E,linearity_mat)
!     Returns the flux sigma for a given
!     eps, E and depending the linearity of the material
    implicit double precision (a-h,o-z)
    beta=5
    select case (linearity_mat)
    case (1)
    sigma=E*eps
    case (2)
    sigma=dexp(E*eps)-1
    case (3)
    sigma=0.1*E*eps+beta*eps**3*E**3
    end select
    return
    END function

    double precision function sigmap(eps,E,linearity_mat)
    implicit double precision (a-h,o-z)
! Returns the derivative of sigma wrt eps for a given
!     eps, E and depending the linearity of the material
    beta=5
    select case (linearity_mat)
    case (1)
    sigmap=E
    case (2)
    sigmap=E*dexp(E*eps)
    case (3)
    sigmap=0.1*E+3*beta*eps**2*E**3
    end select
    return
    END function

c
c ----------------------------------------------------------
c
      subroutine fluxsv(mptr,xfluxm,xfluxp,listbc,
     1                  ndimx,nvar,maxsp,dtc,hx)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension xfluxp(nvar,ndimx)
      dimension xfluxm(nvar,ndimx)
      dimension listbc(4,maxsp)
c
c :::::::::::::::::::: FLUXSV :::::::::::::::::::::::::
c
c  coarse grids should save their fluxes in cells adjacent to
c  their nested fine grids, for later conservation fixing.
c  listbc holds info for where to save which fluxes.
c  xflux holds 'f' fluxes.
c
c :::::::::::::::::::::::::::::;:::::::::::::::::::::::
 
 
      ispot   = 1
      level   = node(nestlevel,mptr)

 10      if (listbc(1,ispot).eq.0) go to 99          
c
         mkid     = listbc(3,ispot)
         intopl   = listbc(4,ispot)
         nx       = node(ndihi,mkid) - node(ndilo,mkid) + 1
         kidlst   = node(ffluxptr,mkid)
         i        = listbc(1,ispot)
         inlist   = kidlst + nvar*(intopl-1) - 1
c
c side j (listbc 2) has which side of coarse cell has interface
c so can save appropriate fluxes.  (dont know why we didnt have
c which flux to save directly (i.e. put i+1,j to save that flux
c rather than putting in cell center coords).

         if (listbc(2,ispot) .eq. 1) then
c           ::::: Cell i is on right side of a fine grid
            do 100 ivar = 1, nvar
               alloc(inlist + ivar) = -xfluxp(ivar,i)*dtc
100         continue
c         write(dbugunit,901) i,j,1,(xfluxp(ivar,i,j),ivar=1,nvar)
         endif

         if (listbc(2,ispot) .eq. 2) then
c           ::::: Cell i on left side of fine grid
            do 300 ivar = 1, nvar
               alloc(inlist + ivar) = -xfluxm(ivar,i+1)*dtc
300         continue
c         write(dbugunit,901) i,j,3,(xfluxm(ivar,i+1,j),ivar=1,nvar)
         endif

      ispot = ispot + 1
      if (ispot .gt. maxsp) go to 99
      go to 10
c
 99   return
      end

c
c -------------------------------------------------------------
c
       subroutine coarseGridFlagSet(iflags,ixlo,ixhi,
     .                              ilo_coarse,ihi_coarse,
     .                              mbuff)

                                     
       integer*1 iflags(ilo_coarse-mbuff:ihi_coarse+mbuff)

c
c whole point of this routine is to index using the integer cords, not the
c  way its dimensioned and indexed in the calling routine setdomflags
c
       do 25 i = ixlo,ixhi         
          iflags(i) = 1
 25    continue

       return
       end

c     ============================================
      subroutine setaux(mbc,mx,my,xlow,ylow,dxc,dyc,
     &                  maux,aux)
c     ============================================
c
c     # set auxiliary arrays for advection on a curvilinear grid
c
c     # on input, (xc(i),yc(j)) gives uniformly spaced computational grid.
c     # on output, 
c     #   aux(1,i,j) is edge velocity at "left" boundary of grid point (i,j)
c     #   aux(2,i,j) is edge velocity at "bottom" boundary of grid point (i,j)
c     #   aux(3,i,j) = kappa  is ratio of cell area to dxc*dyc
c     
      use amr_module, only: NEEDS_TO_BE_SET, xlower, ylower
      implicit double precision (a-h,o-z)
      double precision, intent(inout), 
     &              dimension(3, 1-mbc:mx+mbc,1-mbc:my+mbc) :: aux
      dimension xccorn(5),yccorn(5),xpcorn(5),ypcorn(5)
c
          ilo = floor((xlow - xlower + .05*dxc)/dxc)
          jlo = floor((ylow - ylower + .05*dyc)/dyc)
c
      do 20 j=1-mbc,my+mbc
         do 20 i=1-mbc,mx+mbc
c
            if (aux(1,i,j) .ne. NEEDS_TO_BE_SET) cycle
c
c           # computational points (xc,yc) are mapped to physical
c           # coordinates (xp,yp) by mapc2p:
c
c           # lower left corner:
!           xccorn(1) = xlower + (i-1)*dxc orig version, with xlower !           passed in
!           yccorn(1) = ylower + (j-1)*dyc
!           xccorn(1) = xlow + (i-1)*dxc   ! changed names of args, so !           this is equiv.
!           yccorn(1) = ylow + (j-1)*dyc   ! next should be w/o roundoff
            xccorn(1) = xlower + (ilo + i-1)*dxc
            yccorn(1) = ylower + (jlo + j-1)*dyc
            call mapc2p(xccorn(1),yccorn(1),xpcorn(1),ypcorn(1))

c           # upper left corner:
            xccorn(2) = xccorn(1)
            yccorn(2) = yccorn(1) + dyc
            call mapc2p(xccorn(2),yccorn(2),xpcorn(2),ypcorn(2))
c
c           # upper right corner:
            xccorn(3) = xccorn(1) + dxc
            yccorn(3) = yccorn(1) + dyc
            call mapc2p(xccorn(3),yccorn(3),xpcorn(3),ypcorn(3))
c
c           # lower right corner:
            xccorn(4) = xccorn(1) + dxc
            yccorn(4) = yccorn(1)
            call mapc2p(xccorn(4),yccorn(4),xpcorn(4),ypcorn(4))
c
c
c           # compute edge velocities by differencing stream function:
c
            aux(1,i,j) = (stream(xpcorn(2),ypcorn(2))
     &                    - stream(xpcorn(1),ypcorn(1)))/ dyc
c
            aux(2,i,j) = -(stream(xpcorn(4),ypcorn(4))
     &                    - stream(xpcorn(1),ypcorn(1)))/ dxc

c
c
c           # compute area of physical cell from four corners:

            xpcorn(5) = xpcorn(1)
            ypcorn(5) = ypcorn(1)
            area = 0.d0
            do ic=1,4
              area = area + 0.5d0 * (ypcorn(ic)+ypcorn(ic+1)) *
     &               (xpcorn(ic+1)-xpcorn(ic))
            enddo
            
            aux(3,i,j) = area / (dxc*dyc)
c
   20  continue
c
       return

       end

c
c     ==================================================================
      subroutine step3y(maxm,meqn,maux,mbc,mx,my,mz,
     &                 qold,aux,dy,dt,cflgrid,
     &                 gm,gp,rpn3)
c     ==================================================================

c     # clawpack routine ...  modified for AMRCLAW

c
c     # Take one time step, updating q.
c     # On entry, qold gives
c     #    initial data for this step
c     #    and is unchanged in this version.
c
c     # fm, fp are fluxes to left and right of single cell edge
c
c     # See the flux3 documentation for more information.
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3

      dimension
     & qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
      dimension q1d(meqn, 1-mbc:maxm+mbc)
c
      dimension gm(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension gp(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
c
      dimension faddm(meqn, 1-mbc:maxm+mbc)
      dimension faddp(meqn, 1-mbc:maxm+mbc)
c
      dimension
     & aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
      dimension aux2(maux, 1-mbc:maxm+mbc)
      dimension dtdy1d(1-mbc:maxm+mbc)
c
c
      cflgrid = 0.d0
      dtdy = dt/dy
c
      do 10 i=1-mbc,mx+mbc
         do 10 j=1-mbc,my+mbc
            do 10 k=1-mbc,mz+mbc
               do 10 m=1,meqn
                  gm(m,i,j,k) = 0.d0
                  gp(m,i,j,k) = 0.d0
  10            continue

c
      if (mcapa.eq.0) then
c        # no capa array:
         do 5 i=1-mbc,maxm+mbc
            dtdy1d(i) = dtdy
 5       continue
      endif
c
c
c     # perform y-sweeps (for Godunov split method, called from stepgrid_dimSplit)
    ! loop indices assume x sweep goes first, then y
c     ==================
c
      do 100 k = 1-mbc, mz+mbc
         do 100 i = 1, mx
c
            do 70 j = 1-mbc, my+mbc
               do 70 m=1,meqn
c                 # copy data along a slice into 1d array:
                  q1d(m,j) = qold(m,i,j,k)
   70          continue
c
         if (mcapa.gt.0)  then
           do 71 j = 1-mbc, my+mbc
               dtdy1d(j) = dtdy / aux(mcapa,i,j,k)
   71      continue
         endif
c
         if (maux .gt. 0)  then
            do 72 j = 1-mbc, my+mbc
               do 72 ma=1,maux
                 aux2(ma,j) = aux(ma,i,j,k) 
   72          continue
         endif
c

c           # compute modifications fadd to fluxes along this slice:
c
            call flux3_dimSplit(2,maxm,meqn,maux,mbc,my,
     &                 q1d,dtdy1d,aux2,
     &                 faddm,faddp,cfl1d,
     &                 rpn3)
c
            cflgrid = dmax1(cflgrid,cfl1d)
c
c        # update fluxes for use in AMR:
c
c           # Note that the roles of the flux updates are changed.
c           # fadd - modifies the g-fluxes
c
            do 75 j=1,my+1
               do 75 m=1,meqn
               gm(m,i,j,k) = gm(m,i,j,k) + faddm(m,j)
               gp(m,i,j,k) = gp(m,i,j,k) + faddp(m,j)
   75          continue
c
  100    continue
c
      return
      end

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.
    ! This default version simply sets eta = max(h + B, sea_level)

    ! For more specific initial conditions
    !  copy this to an application directory and
    !  loop over all grid cells to set values of q(1:meqn, 1:mx).

    use geoclaw_module, only: sea_level

    ! uncomment if any of these needed...
    !use geoclaw_module, only: dry_tolerance, grav
    !use grid_module, only: xcell,xp_edge,mx_edge
    !use topo_module, only: zcell0 ! initial topo in each cell

    implicit none

    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    !locals
    integer :: i
    real(kind=8) :: eta

    do i=1,mx
      eta = sea_level
      q(1,i) = max(0.d0, eta - aux(1,i))
      q(2,i) = 0.d0
   enddo


end subroutine qinit

c
c -------------------------------------------------------------
c
!> Take a time step on a single grid **mptr** and overwrite solution array **q**. 
!! A modified version of the clawpack routine step2 is used.
!! 
!! Return new solution **q** as well as fluxes in fm,fp and gm,gp.
!! Patch has room for ghost cells (mbc of them) around the grid.
!! Everything is the enlarged size (**mitot** by **mjtot**).
!! 
!! \param[in] mbc number of ghost cells  (= lwidth)
!! \param[in] mptr grid number (for debugging)
!! \param[in] xlow left edge of enlarged grid (including ghost cells).
!! \param[in] ylow lower edge of enlarged grid (including ghost cells).
!! \param[in] dt incoming time step
!! \param[in] dx mesh size in x direction for this grid
!! \param[in] dx mesh size in y direction for this grid
!! \param[in,out] q solution array
!! \param[out] dtnew  return suggested new time step for this grid's soln.
!! \param[out] fm fluxes on the left side of each vertical edge
!! \param[out] fp fluxes on the right side of each vertical edge
!! \param[out] gm fluxes on the lower side of each horizontal edge
!! \param[out] gp fluxes on the upper side of each horizontal edge
      subroutine stepgrid(q,fm,fp,gm,gp,mitot,mjtot,mbc,dt,dtnew,dx,dy,
     &                  nvar,xlow,ylow,time,mptr,maux,aux)
c
c          
c ::::::::::::::::::: STEPGRID ::::::::::::::::::::::::::::::::::::
c take a time step on a single grid. overwrite solution array q. 
c A modified version of the clawpack routine step2 is used.
c
c return fluxes in fm,fp and gm,gp.
c patch has room for ghost cells (mbc of them) around the grid.
c everything is the enlarged size (mitot by mjtot).
c
c mbc       = number of ghost cells  (= lwidth)
c mptr      = grid number  (for debugging)
c xlow,ylow = lower left corner of enlarged grid (including ghost cells).
c dt         = incoming time step
c dx,dy      = mesh widths for this grid
c dtnew      = return suggested new time step for this grid's soln.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      use amr_module
      implicit double precision (a-h,o-z)
      external rpn2,rpt2

      common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom


      dimension q(nvar,mitot,mjtot)
      dimension fp(nvar,mitot,mjtot),gp(nvar,mitot,mjtot)
      dimension fm(nvar,mitot,mjtot),gm(nvar,mitot,mjtot)
      dimension aux(maux,mitot,mjtot)

      logical    debug,  dump
      data       debug/.false./,  dump/.false./

c
c     # set tcom = time.  This is in the common block comxyt that could
c     # be included in the Riemann solver, for example, if t is explicitly
c     # needed there.

      tcom = time

      if (dump) then
         write(outunit,*) "dumping grid ",mptr," at time ",time
         do i = 1, mitot
         do j = 1, mjtot
            write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar) 
c    .                  ,(aux(ivar,i,j),ivar=1,maux)
 545        format(2i4,5e15.7)
         end do
         end do
      endif
c
      meqn   = nvar
      mx = mitot - 2*mbc
      my = mjtot - 2*mbc
      maxm = max(mx,my)       !# size for 1d scratch array
      mbig = maxm
      xlowmbc = xlow + mbc*dx
      ylowmbc = ylow + mbc*dy

c     # method(2:7) and mthlim
c     #    are set in the amr2ez file (read by amr)
c
      method(1) = 0
c
c
c     # fluxes initialized in step2
c
C       mwork0 = (maxm+2*mbc)*(12*meqn + mwaves + meqn*mwaves + 2) 
c
C       if (mwork .lt. mwork0) then
C          write(outunit,*) 'CLAW2 ERROR... mwork must be increased to ',
C      &               mwork0
C          write(*      ,*) 'CLAW2 ERROR... mwork must be increased to ',
C      &               mwork0
C          stop
C       endif
c  
c
c     # partition work array into pieces needed for local storage in 
c     # step2 routine. Find starting index of each piece:
c
C       i0faddm = 1
C       i0faddp = i0faddm + (maxm+2*mbc)*meqn
C       i0gaddm = i0faddp + (maxm+2*mbc)*meqn
C       i0gaddp = i0gaddm + 2*(maxm+2*mbc)*meqn
C       i0q1d   = i0gaddp + 2*(maxm+2*mbc)*meqn 
C       i0dtdx1 = i0q1d + (maxm+2*mbc)*meqn  
C       i0dtdy1 = i0dtdx1 + (maxm+2*mbc)
C       i0aux1 = i0dtdy1 + (maxm+2*mbc)
C       i0aux2 = i0aux1 + (maxm+2*mbc)*maux
C       i0aux3 = i0aux2 + (maxm+2*mbc)*maux
c
c
C       i0next = i0aux3 + (maxm+2*mbc)*maux    !# next free space
C       mused  = i0next - 1                    !# space already used
C       mwork1 = mwork - mused              !# remaining space (passed to step2)

c
c
      call b4step2(mbc,mx,my,nvar,q,
     &             xlowmbc,ylowmbc,dx,dy,time,dt,maux,aux)
c
c
c     # take one step on the conservation law:
c
      call step2(mbig,nvar,maux,
     &           mbc,mx,my,
     &              q,aux,dx,dy,dt,cflgrid,
     &              fm,fp,gm,gp,rpn2,rpt2)
c
c
c       write(outunit,1001) mptr, node(nestlevel,mptr),cflgrid
c1001   format(' Courant # of grid', i4,
c    &        ' on level', i3, ' is  ', e10.3)
c

!$OMP  CRITICAL (cflm)

        cfl_level = dmax1(cfl_level,cflgrid)

!$OMP END CRITICAL (cflm)

c
c       # update q
        dtdx = dt/dx
        dtdy = dt/dy
        do 50 j=mbc+1,mjtot-mbc
        do 51 i=mbc+1,mitot-mbc
        do 52 m=1,nvar
         if (mcapa.eq.0) then
c
c            # no capa array.  Standard flux differencing:

           q(m,i,j) = q(m,i,j) 
     &           - dtdx * (fm(m,i+1,j) - fp(m,i,j)) 
     &           - dtdy * (gm(m,i,j+1) - gp(m,i,j)) 
         else
c            # with capa array.
           q(m,i,j) = q(m,i,j) 
     &          - (dtdx * (fm(m,i+1,j) - fp(m,i,j))
     &          +  dtdy * (gm(m,i,j+1) - gp(m,i,j))) / aux(mcapa,i,j)
         endif

 52      continue
 51      continue
 50      continue
c
c
      if (method(5).eq.1) then
c        # with source term:   use Godunov splitting
         call src2(nvar,mbc,mx,my,xlowmbc,ylowmbc,dx,dy,
     &             q,maux,aux,time,dt)
         endif
c
c
c
c     # output fluxes for debugging purposes:
      if (debug) then
         write(dbugunit,*)" fluxes for grid ",mptr
c        do j = mbc+1, mjtot-1
            do i = mbc+1, mitot-1
         do j = mbc+1, mjtot-1
               write(dbugunit,831) i,j,fm(1,i,j),fp(1,i,j),
     .                             gm(1,i,j),gp(1,i,j)
               do m = 2, meqn
                  write(dbugunit,832) fm(m,i,j),fp(m,i,j),
     .            gm(m,i,j),gp(m,i,j)
  831             format(2i4,4d16.6)
  832             format(8x,4d16.6)
               end do
         end do
         end do
      endif

c
c
c For variable time stepping, use max speed seen on this grid to 
c choose the allowable new time step dtnew.  This will later be 
c compared to values seen on other grids.
c
       if (cflgrid .gt. 0.d0) then
           dtnew = dt*cfl/cflgrid
         else
c          # velocities are all zero on this grid so there's no 
c          # time step restriction coming from this grid.
            dtnew = rinfinity
          endif

c     # give a warning if Courant number too large...
c
      if (cflgrid .gt. cflv1) then
            write(*,810) cflgrid
            write(outunit,810) cflgrid, cflv1
  810       format('*** WARNING *** Courant number  =', d12.4,
     &              '  is larger than input cfl_max = ', d12.4)
            endif
c
      if (dump) then
         write(outunit,*) "dumping grid ",mptr," after stepgrid"
         do i = 1, mitot
         do j = 1, mjtot
            write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar)
         end do
         end do
      endif
      return
      end

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::: Parameters, variables, subroutines related to gauges
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

! Contains:
!   subroutine set_gauges
!     Called initially to read from gauges.data
!   subroutine setbestsrc
!     Called each time regridding is done to determine which patch to 
!     use for interpolating to each gauge location.
!   subroutine print_gauges
!     Called each time step for each grid patch.
!     Refactored dumpgauge routine to interpolate for all gauges on patch.
!
!     Note: by default all components of q are printed at each gauge.
!     To print something different or a different precision, modify 
!     format statement 100 and/or the write statement that uses it.
!   
! Note: Updated for Clawpack 5.3.0:
!   - the dumpgauge and setbestsrc subroutines have been moved to this module 
!     and the dumpgauge subroutine has been refactored and renamed print_gauges.
!   - dumpgauge.f must be removed from Makefiles.
!   - setbestsrc uses quicksort to sort gauge numbers and
!     then figures out which gauges will be updated by grid, and stores this
!     information in new module variables mbestg1, mbestg2.
!   - print_gauges no longer uses binary search to locate first gauge handled
!     by a grid.  Instead loop over gauges specified by mbestg1, mbestg2.
!
! Note: Updated for Clawpack 5.4.0
!   - refactor so each gauge writes to its own file, and batches the writes instead of 
!     writing one at a time. This will remove the critical section and should speed up gauges a lot
!   - When array is filled, that gauge will write to file and start over. 
!   - Need to save index so know position in array where left off
!   - At checkpoint times, dump all gauges
!
! Note: Updated for Clawpack 5.4.x
!  - Add gauge formatting capabilities
!
! Changed mjb, May, 2018 hackathon, to remove need for mbestg1 and mbestg2.
! looked at since they depended on maxgr, which is now a variable, not constant.
! also, algorithms didn't scale for O(10^5) grids, and O(100) gauges..

module gauges_module

    implicit none
    save

    logical, private :: module_setup = .false.

    integer, parameter :: OUTGAUGEUNIT = 89
    integer :: num_gauges

    integer, parameter :: MAX_BUFFER = 1000

    ! Gauge data types
    type gauge_type
        ! Gauge number
        integer :: gauge_num

        character(len=24) :: file_name

        ! Location in time and space
        real(kind=8) :: x, y, t_start, t_end

        ! Last time recorded
        real(kind=8) :: last_time

        ! Output settings
        integer :: file_format, gtype
        real(kind=8) :: min_time_increment
        character(len=10) :: display_format
        logical, allocatable :: q_out_vars(:)
        logical, allocatable :: aux_out_vars(:)
        integer :: num_out_vars

        ! Data buffers - data holds output and time
        real(kind=8), allocatable :: data(:, :)
        integer :: level(MAX_BUFFER)

        ! Where we are in the buffer
        integer :: buffer_index
    end type gauge_type

    ! Gague array
    type(gauge_type), allocatable :: gauges(:)

    ! Gauge source info
    integer, allocatable, dimension(:) ::  mbestsrc, igauge

contains

    subroutine set_gauges(restart, num_eqn, num_aux, fname)

        use utility_module, only: get_value_count

        implicit none

        ! Input
        logical, intent(in) :: restart
        integer :: num_eqn, num_aux
        character(len=*), intent(in), optional :: fname

        ! Locals
        integer :: i, n, index
        integer :: num, pos, digit
        integer, parameter :: UNIT = 7
        character(len=128) :: header_1
        character(len=40) :: q_column, aux_column
        character(len=15) :: numstr

        if (.not. module_setup) then

            ! Open file
            if (present(fname)) then
                call opendatafile(UNIT, fname)
            else
                call opendatafile(UNIT, 'gauges.data')
            endif

            read(UNIT, *) num_gauges
            allocate(gauges(num_gauges))
            
            ! Initialize gauge source data
            allocate(mbestsrc(num_gauges))
            mbestsrc = 0
            
            ! Original gauge information
            do i=1,num_gauges
                read(UNIT, *) gauges(i)%gauge_num, gauges(i)%x, gauges(i)%y, &
                              gauges(i)%t_start, gauges(i)%t_end
                gauges(i)%buffer_index = 1
                gauges(i)%last_time = gauges(i)%t_start
            enddo

            ! Read in output formats
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%file_format, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%display_format, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%min_time_increment, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%gtype, i=1, num_gauges)

            ! Read in q fields
            read(UNIT, *)
            read(UNIT, *)
            do i = 1, num_gauges
                if (gauges(i)%gtype .ne. 1) then
                    write(6,*) '*** Lagrangian gauges not yet supported'
                    write(6,*) '*** All gauges must have gtype==1'
                    stop
                endif
                
                allocate(gauges(i)%q_out_vars(num_eqn))
                read(UNIT, *) gauges(i)%q_out_vars

                ! Count number of vars to be output
                gauges(i)%num_out_vars = 0
                do n = 1, size(gauges(i)%q_out_vars, 1)
                    if (gauges(i)%q_out_vars(n)) then
                        gauges(i)%num_out_vars = gauges(i)%num_out_vars + 1
                    end if
                end do
            end do

            ! Read in aux fields
            if (num_aux > 0) then
                read(UNIT, *)
                read(UNIT, *)
                do i = 1, num_gauges
                    allocate(gauges(i)%aux_out_vars(num_aux))
                    read(UNIT, *) gauges(i)%aux_out_vars

                    ! Count number of vars to be output
                    do n = 1, size(gauges(i)%aux_out_vars, 1)
                        if (gauges(i)%aux_out_vars(n)) then
                            gauges(i)%num_out_vars = gauges(i)%num_out_vars + 1
                        end if
                    end do
                end do
            end if

            close(UNIT)
            ! Done reading =====================================================

            ! Allocate data buffer
            do i = 1, num_gauges
                allocate(gauges(i)%data(gauges(i)%num_out_vars + 1, MAX_BUFFER))
            end do

            ! Create gauge output files
            do i = 1, num_gauges
                num = gauges(i)%gauge_num

                ! convert num to string numstr with zero padding if <5 digits
                ! since we want format gauge00012.txt or gauge1234567.txt:
                write (numstr,'(I0.5)') num
                gauges(i)%file_name = 'gauge'//trim(numstr)//'.txt'

                ! Handle restart
                if (restart) then
                    open(unit=OUTGAUGEUNIT, file=gauges(i)%file_name,       &
                         status='old', position='append', form='formatted')
                else
                    open(unit=OUTGAUGEUNIT, file=gauges(i)%file_name,       &
                         status='unknown', position='append', form='formatted')
                    rewind OUTGAUGEUNIT

                    ! Write header
                    header_1 = "('# gauge_id= ',i0,' " //                   &
                               "location=( ',1e17.10,' ',1e17.10,' ) " //     &
                               "num_var= ',i2)"
                    write(OUTGAUGEUNIT, header_1) gauges(i)%gauge_num,      &
                                                  gauges(i)%x,              &
                                                  gauges(i)%y,              &
                                                  gauges(i)%num_out_vars

                    ! Construct column labels
                    index = 0
                    q_column = "["
                    do n=1, size(gauges(i)%q_out_vars, 1)
                        if (gauges(i)%q_out_vars(n)) then
                            write(q_column(3 * index + 2:4 + 3 * index), "(i3)") n
                            index = index + 1
                        end if  
                    end do
                    q_column(3 * index + 2:4 + 3 * index) = "]"

                    aux_column = "["
                    index = 0
                    if (allocated(gauges(i)%aux_out_vars)) then
                        do n=1, size(gauges(i)%aux_out_vars, 1)
                            if (gauges(i)%aux_out_vars(n)) then
                                write(aux_column(3 * index + 2:4 + 3 * index), "(i3)") n
                                index = index + 1
                            end if  
                        end do
                    end if
                    aux_column(3 * index + 2:4 + 3 * index) = "]"

                    write(OUTGAUGEUNIT, "(a,a,a,a)") "# level, time, q",      &
                                               trim(q_column), ", aux",       &
                                               trim(aux_column)
               endif

               close(OUTGAUGEUNIT)

            end do

            module_setup = .true.
        end if

    end subroutine set_gauges


!
! --------------------------------------------------------------------
!
    subroutine setbestsrc(igauge)
!
!     Called every time grids change, to set the best source grid patch
!     for each gauge, i.e. the finest level patch that includes the gauge.
!
!     lbase is grid level that didn't change, but since fine
!     grid may have disappeared, we still have to look starting
!     at coarsest level 1.
!
        use amr_module
        implicit none

        integer, intent(in), optional :: igauge
        integer :: lev, mptr, i, i1, i2

!
! ##  set source grid for each loc from coarsest level to finest.
! ##  that way finest src grid left and old ones overwritten
! ##  this code uses fact that grids do not overlap

! ##  This modified version allows an optional igauge argument
! ##  to only update one gauge, for Lagrangian gauges (particle tracking)
! ##  This is not yet implemented in amrclaw, but argument added for
! ##  consistency with the geoclaw version of this routine.

        if (present(igauge)) then
            ! only loop over one gauge
            i1 = igauge
            i2 = igauge
          else
            ! normal case of setting for all gauges
            i1 = 1
            i2 = num_gauges
          endif

        ! for debugging, initialize sources to 0 then check that all set
        mbestsrc(i1:i2) = 0

        !! reorder loop for better performance with O(10^5) grids
        !! for each gauge find best source grid for its data
        do 40 i = i1,i2

           do 30 lev = lfine, 1, -1
              mptr = lstart(lev)
 20              if ((gauges(i)%x >= rnode(cornxlo,mptr)) .and. &
                      (gauges(i)%x <= rnode(cornxhi,mptr)) .and. &  
                      (gauges(i)%y >= rnode(cornylo,mptr)) .and. &
                      (gauges(i)%y <= rnode(cornyhi,mptr)) ) then
                      mbestsrc(i) = mptr
                      !! best source found for this gauge, go to next one
                      !! we know its the best because we started at finest level
                      go to 40  ! on to next gauge 
                 else 
                    mptr = node(levelptr,mptr)
                    if (mptr .ne. 0) then
                       go to 20  ! try another grid
                    else
                       go to 30  ! try next coarser level grids
                    endif
                 end if
 30        continue 

          if (mbestsrc(i) .eq. 0) &
              print *, "ERROR in setting grid src for gauge data", i
 40     continue 

!!!  NO MORE qsort and mbestg arrays. 
!!! Each grid now loops over mbestsrc array to see which gauges it owns.

    end subroutine setbestsrc

!
! -------------------------------------------------------------------------
!
    subroutine update_gauges(q, aux, xlow, ylow, num_eqn, mitot, mjtot, num_aux, &
                             mptr)
        !
        ! This routine is called each time step for each grid patch, to output
        ! gauge values for all gauges for which this patch is the best one to 
        ! use (i.e. at the finest refinement level).  
        
        ! It is called after ghost cells have been filled from adjacent grids
        ! at the same level, so bilinear interpolation can be used to 
        ! to compute values at any gauge location that is covered by this grid.  
        
        ! The grid patch is designated by mptr.
        ! We only want to set gauges i for which mbestsrc(i) == mptr.
        ! The array mbestsrc is reset after each regridding to indicate which
        ! grid patch is best to use for each gauge.
        
        ! This is a refactoring of dumpgauge.f from Clawpack 5.2 
        ! Loops over only the gauges to be handled by this grid, as specified
        ! by indices from mbestg1(mptr) to mbestg2(mptr)

        use amr_module, only: nestlevel, nghost, timemult, rnode, node, maxvar
        use amr_module, only: maxaux, hxposs, hyposs

        implicit none
        
        ! Input
        integer, intent(in) ::  num_eqn, mitot, mjtot, num_aux, mptr
        real(kind=8), intent(in) :: q(num_eqn, mitot, mjtot)
        real(kind=8), intent(in) :: aux(num_aux, mitot, mjtot)
        real(kind=8), intent(in) :: xlow, ylow
        
        ! Locals
        real(kind=8) :: var(maxvar + maxaux)
        real(kind=8) :: xcent, ycent, xoff, yoff, tgrid, hx, hy
        integer :: i, j, i1, i2, iindex, jindex, n, index, level, var_index

        ! No gauges to record, exit
        if (num_gauges == 0) then
            return
        endif

        ! Grid info
        tgrid = rnode(timemult, mptr)
        level = node(nestlevel, mptr)
        hx = hxposs(level)
        hy = hyposs(level)

        ! Main Gauge Loop ======================================================
        do i = 1, num_gauges
            if (mptr .ne. mbestsrc(i)) cycle 
            if (tgrid < gauges(i)%t_start .or. tgrid > gauges(i)%t_end) then
               cycle
            endif
            ! Minimum increment
            ! TODO Maybe always allow last time output recording?
            if (tgrid - gauges(i)%last_time < gauges(i)%min_time_increment) then
                cycle
            end if

            ! Compute indexing and bilinear interpolant weights
            ! Note: changed 0.5 to  0.5d0 etc.
            iindex =  int(.5d0 + (gauges(i)%x - xlow) / hx)
            jindex =  int(.5d0 + (gauges(i)%y - ylow) / hy)
            if ((iindex < nghost .or. iindex > mitot-nghost) .or. &
                (jindex < nghost .or. jindex > mjtot-nghost)) then
                    print *, "ERROR in output of Gauge Data "
            end if
            xcent  = xlow + (iindex - 0.5d0) * hx
            ycent  = ylow + (jindex - 0.5d0) * hy
            xoff   = (gauges(i)%x - xcent) / hx
            yoff   = (gauges(i)%y - ycent) / hy

            ! Gauge interpolation seems to work, so error test is commented out.
            ! For debugging, use the code below...
            !   Note: we expect 0 <= xoff, yoff <= 1 but if gauge is exactly 
            !   at center of cell these might be off by rounding error

            !if (xoff .lt. -1.d-4 .or. xoff .gt. 1.0001d0 .or. &
            !    yoff .lt. -1.d-4 .or. yoff .gt. 1.0001d0) then
            !   write(6,*) "*** print_gauges: Interpolation problem at gauge ",&
            !               igauge(i)
            !   write(6,*) "    xoff,yoff: ", xoff,yoff
            !endif

            ! Bilinear interpolation
            var_index = 0
            do n = 1, size(gauges(i)%q_out_vars, 1)
                if (gauges(i)%q_out_vars(n)) then
                    var_index = var_index + 1
                    var(var_index) = (1.d0 - xoff) * (1.d0 - yoff) * q(n, iindex, jindex) &
                                        + xoff * (1.d0 - yoff) * q(n, iindex + 1, jindex) &
                                        + (1.d0 - xoff) * yoff * q(n, iindex, jindex + 1) &
                                        + xoff * yoff * q(n, iindex + 1, jindex + 1)
                endif
            end do

            if (allocated(gauges(i)%aux_out_vars)) then
                do n = 1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) = (1.d0 - xoff) * (1.d0 - yoff) * aux(n, iindex, jindex) &
                                            + xoff * (1.d0 - yoff) * aux(n, iindex + 1, jindex) &
                                            + (1.d0 - xoff) * yoff * aux(n, iindex, jindex + 1) &
                                            + xoff * yoff * aux(n, iindex + 1, jindex + 1)
                    endif
                end do
            end if

            ! Check to make sure we grabbed all the values
            if (gauges(i)%num_out_vars /= var_index) then
                print *, gauges(i)%num_out_vars, var_index
                print *, gauges(i)%q_out_vars
                print *, gauges(i)%aux_out_vars
                stop "Somehow we did not grab all the values we wanted..."
            end if

            ! Zero out tiny values to prevent underflow problems
            do j = 1, gauges(i)%num_out_vars
                if (abs(var(j)) < 1d-90) var(j) = 0.d0
            end do

           ! save info for this time
           index = gauges(i)%buffer_index
     
            gauges(i)%level(index) = level
            gauges(i)%data(1,index) = tgrid
            do j = 1, gauges(i)%num_out_vars
                gauges(i)%data(1 + j, index) = var(j)
            end do
            
            gauges(i)%buffer_index = index + 1
            if (gauges(i)%buffer_index > MAX_BUFFER) then
                call print_gauges_and_reset_nextLoc(i)  
            endif

            gauges(i)%last_time = tgrid

        end do ! End of gauge loop =============================================

    end subroutine update_gauges
!
! -------------------------------------------------------------------------
!
      subroutine print_gauges_and_reset_nextLoc(gauge_num)
        ! Write out gauge data for the gauge specified

        implicit none

        ! Input
        integer, intent(in) :: gauge_num

        ! Locals
        integer :: j, k, myunit
        integer :: omp_get_thread_num, mythread
        character(len=32) :: out_format

        ! Open unit dependent on thread number
        mythread = 0
!$      mythread = omp_get_thread_num()
        myunit = OUTGAUGEUNIT + mythread

        ! ASCII output
        if (gauges(gauge_num)%file_format == 1) then
            ! Construct output format based on number of output variables and
            ! request format
            write(out_format, "(A7, i2, A6, A1)") "(i5.2,",         &
               gauges(gauge_num)%num_out_vars + 1, gauges(gauge_num)%display_format, ")"

            open(unit=myunit, file=gauges(gauge_num)%file_name, status='old', &
                              position='append', form='formatted')
          
            ! Loop through gauge's buffer writing out all available data.  Also
            ! reset buffer_index back to beginning of buffer since we are emptying
            ! the buffer here
            do j = 1, gauges(gauge_num)%buffer_index - 1
                write(myunit, out_format) gauges(gauge_num)%level(j),    &
                    (gauges(gauge_num)%data(k, j), k=1, gauges(gauge_num)%num_out_vars + 1)
            end do
            gauges(gauge_num)%buffer_index = 1                        

            ! close file
            close(myunit)
        else
            print *, "Unhandled file format ", gauges(gauge_num)%file_format
            stop
        end if

    end subroutine print_gauges_and_reset_nextLoc

end module gauges_module

c     ==================================
      double precision function qtrue(x,y,z,t)
c     ==================================
      implicit double precision (a-h,o-z)
      common /cparam/ ubar,vbar,wbar
      
      x0 = x - ubar*t
      y0 = y - vbar*t
      z0 = z - wbar*t

c     # evaluate desired initial data at (x0,y0,z0):


c linear test function to see if ghost cell interpolation exact
      qtrue = 1.d0*x0 + 2.0d0*y0 + 3.d0*z0
      !qtrue = 1.d0*x0 
      !if (x0 .lt. xupper/2) then
      !    qtrue = 1.d0
      !else
      !    qtrue = 2.d0
      !endif

      return
      end

! =====================================================
      subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,
     &                ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
      use geoclaw_module, only: g => grav, tol => dry_tolerance
      use geoclaw_module, only: coordinate_system,earth_radius,deg2rad

      implicit none
!
!     # Riemann solver in the transverse direction.

!
!     Aux1 is below, aux2 is where you are, aux3 is above

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                           !
!      # This Riemann solver is for the shallow water adjoint               !
!             equations. It is modified from rpt2_geoclaw.f.                !
!                                                                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      integer ixy,maxm,meqn,maux,mwaves,mbc,mx,imp

      double precision  ql(meqn,1-mbc:maxm+mbc)
      double precision  qr(meqn,1-mbc:maxm+mbc)
      double precision  asdq(meqn,1-mbc:maxm+mbc)
      double precision  bmasdq(meqn,1-mbc:maxm+mbc)
      double precision  bpasdq(meqn,1-mbc:maxm+mbc)
      double precision  aux1(maux,1-mbc:maxm+mbc)
      double precision  aux2(maux,1-mbc:maxm+mbc)
      double precision  aux3(maux,1-mbc:maxm+mbc)

      double precision  s(3)
      double precision  r(3,3)
      double precision  a(3)
      double precision  abs_tol
      double precision  hl,hr,hul,hur,hvl,hvr,vl,vr,ul,ur,bl,br
      double precision  hLhat, hRhat, hHatm, hHatp, hHat
      double precision  uhat,vhat,roe1,roe3,sm,sp,s1l,s3r,ss
      double precision  delf1,delf2,delf3,dxdcd,dxdcu
      double precision  dxdcm,dxdcp,topo1,topo3,eta

      integer i,m,mw,mu,mv, i1

      abs_tol=tol

      if (ixy.eq.1) then
        mu = 2
        mv = 3
      else
        mu = 3
        mv = 2
      endif

      do i=2-mbc,mx+mbc-1

         hl=qr(1,i-1)
         hr=ql(1,i)

!===========determine velocity from momentum===========================
       if (imp == 1) then
!            # asdq = amdq, moving to left
           i1 = i-1
       else
!            # asdq = apdq, moving to right
           i1 = i
       endif

       do mw=1,mwaves
           s(mw)=0.d0
           a(mw)=0.d0
           do m=1,meqn
               r(m,mw)=0.d0
           enddo
       enddo

       if (aux2(1,i1) >= 0.d0) go to 90

       if (hl.lt.abs_tol) then
           hl=0.d0
           hHatm = 0.d0
       else
           hHatm = -aux2(1,i1)
       endif

       if (hr.lt.abs_tol) then
           hr=0.d0
           hHatp = 0.d0
       else
           hHatp = -aux2(1,i1)
       endif

       hHat = (hHatp + hHatm)/2

       if (hl <= tol .and. hr <= tol) go to 90

*      !check and see if cell that transverse waves are going in is high and dry
       if (imp.eq.1) then
          eta = qr(1,i-1)  + aux2(1,i-1)
          topo1 = aux1(1,i-1)
          topo3 = aux3(1,i-1)
       else
          eta = ql(1,i) + aux2(1,i)
          topo1 = aux1(1,i)
          topo3 = aux3(1,i)
       endif

       if (eta.lt.max(topo1,topo3)) go to 90


c=======================Determine asdq decomposition (beta)============

         sm=dsqrt(g*hHatm)
         sp=dsqrt(g*hHatp)
         ss=dsqrt(g*hHat)

         delf1=asdq(1,i)
         delf2=asdq(mu,i)
         delf3=asdq(mv, i)

         a(1) = (delf1 + ss*delf3)/ (ss+sm)
         a(2) = (-delf1 + ss*delf3)/(sp + ss)
c======================End =================================================

c=====================Set-up eigenvectors===================================
         r(1,1) = sm
         r(3,1) = 1.d0
         r(2,1) = 0.d0

         r(1,2) = -sp
         r(3,2) = 1.d0
         r(2,2) = 0.d0

         s(1)=-sm
         s(2)=sp
         s(3)=0.d0
c============================================================================
90      continue
c============= compute fluctuations==========================================

            dxdcm = 1.d0
            dxdcp = 1.d0

       if (coordinate_system.eq.2) then
         if (ixy.eq.2) then
           dxdcp=(earth_radius*deg2rad)
           dxdcm = dxdcp
         else
           if (imp.eq.1) then
             dxdcp = earth_radius*cos(aux3(3,i-1))*deg2rad
             dxdcm = earth_radius*cos(aux1(3,i-1))*deg2rad
           else
             dxdcp = earth_radius*cos(aux3(3,i))*deg2rad
             dxdcm = earth_radius*cos(aux1(3,i))*deg2rad
           endif
         endif
       endif

            bmasdq(1,i)=0.0d0
            bpasdq(1,i)=0.0d0
            bmasdq(2,i)=0.0d0
            bpasdq(2,i)=0.0d0
            bmasdq(3,i)=0.0d0
            bpasdq(3,i)=0.0d0
            do  mw=1,3
              if (s(mw).lt.0.d0) then
                bmasdq(1,i) =bmasdq(1,i) + dxdcm*s(mw)*a(mw)*r(1,mw)
                bmasdq(mu,i)=bmasdq(mu,i)+ dxdcm*s(mw)*a(mw)*r(2,mw)
                bmasdq(mv,i)=bmasdq(mv,i)+ dxdcm*s(mw)*a(mw)*r(3,mw)
              elseif (s(mw).gt.0.d0) then
                bpasdq(1,i) =bpasdq(1,i) + dxdcp*s(mw)*a(mw)*r(1,mw)
                bpasdq(mu,i)=bpasdq(mu,i)+ dxdcp*s(mw)*a(mw)*r(2,mw)
                bpasdq(mv,i)=bpasdq(mv,i)+ dxdcp*s(mw)*a(mw)*r(3,mw)
              endif
            enddo

c========================================================================
         enddo
      return
      end

! ============================================================================
!  Module for topography data
! ============================================================================

module topo_module

    implicit none

    logical, private :: module_setup = .false.

    real(kind=8), allocatable :: xtopo(:), ztopo(:)
    integer :: mx_topo, ntopofiles, test_topography
    real(kind=8) :: topo_missing
    
    ! for topo:
    real(kind=8), allocatable, dimension(:) :: zcell, zcell0


    ! for dtopo:
    integer :: mt_dtopo, mx_dtopo
    real(kind=8), allocatable, dimension(:)  :: x_dtopo, t_dtopo
    real(kind=8), allocatable, dimension(:,:)  :: dz_dtopo, dz_cell
    real(kind=8) :: dt_max_dtopo
    logical :: topo_finalized

contains

!   ============================================================
    subroutine read_topo_settings(file_name)

    implicit none

    character(len=*), intent(in), optional :: file_name

    ! Locals
    integer, parameter :: iunit = 7
    character (len=150) :: topofname

    if (present(file_name)) then
        call opendatafile(iunit, file_name)
    else
        call opendatafile(iunit, 'topo.data')
    endif

    ! Read in value to use in place of no_data_value in topofile
    read(iunit,*) topo_missing

    ! not used now:
    read(iunit,*) test_topography

    read(iunit,*) ntopofiles
    if (ntopofiles /= 1) then
        write(6,*) '*** Currently require exactly 1 topofile'
        stop
    endif

    read(iunit,*) topofname
    close(iunit)

    call read_topo_file(topofname)

    end subroutine read_topo_settings


!   ============================================================
    subroutine read_topo_file(fname)

    use grid_module, only: mbc,mx
    implicit none

    character(len=150), intent(in) :: fname
    integer :: i,ibc
    integer, parameter :: iunit = 7

    open(unit=iunit, file=trim(fname), status='unknown',form='formatted')

    read(iunit,*) mx_topo
    allocate(xtopo(mx_topo), ztopo(mx_topo))

    write(6,"('Reading ',i6,' topo values from ')") mx_topo
    write(6,*) '    ',trim(fname)
    
    do i=1,mx_topo
        read(iunit,*) xtopo(i), ztopo(i)
    enddo
    close(iunit)
    
    ! storage for cell averages of topo:
    allocate(zcell(1-mbc:mx+mbc), zcell0(1-mbc:mx+mbc))

    ! compute zcell by cell-averaging pw linear function
    ! defined by xtopo,ztopo:
    call cell_average(mx_topo, xtopo, ztopo, zcell(1:mx))
    
    ! extrapolate to ghost cells:
    do ibc=1,mbc
        zcell(1-ibc) = zcell(1)
        zcell(mx+ibc) = zcell(mx)
    enddo
    
    zcell0(:) = zcell(:)  ! save initial topo in case there is dtopo

    end subroutine read_topo_file


!   ============================================================
    subroutine cell_average(mx_pwlin, x_pwlin, z_pwlin, z_cell)

    ! take arrays x_pwlin and z_pwlin with mx_pwlin points that define
    ! a pw linear function, and return z_cell containing cell averages
    ! of this function, for the grid cells defined in grid_module.
    
    ! Used to compute cell averages of topo or dtopo given nodal values.

    use grid_module, only: xp_edge,mx_edge,mx
    implicit none

    integer, intent(in) :: mx_pwlin
    real(kind=8), dimension(1:mx_pwlin), intent(in) ::  x_pwlin, z_pwlin
    real(kind=8), intent(out) ::  z_cell(1:mx)

    integer :: i,i1,i2,ifull
    real(kind=8) :: x1,x2,cell_int,dx1,dx2,slope1

    do i=1,mx_edge-1
        ! edges of computational cell:
        x1 = xp_edge(i)
        x2 = xp_edge(i+1)
        
        do i1=1,mx_pwlin
            if (x_pwlin(i1) > x1) exit
        enddo
        
        ! now i1 points to first topo point in cell

        if (i1 == 1) then
            write(6,*) '*** pwlin function does not cover domain'
            write(6,*) '*** x1, x_pwlin(1): ',x1,x_pwlin(1)
            stop
        endif

        if (x_pwlin(i1) >= x2) then
            ! x_pwlin(i1-1) to left of x1, so nodal points bracket cell
            slope1 = (z_pwlin(i1) - z_pwlin(i1-1)) &
                   / (x_pwlin(i1) - x_pwlin(i1-1))
            dx1 = (x1 - x_pwlin(i1-1))
            dx2 = (x2 - x_pwlin(i1-1))
            z_cell(i) = z_pwlin(i1-1) + 0.5d0*(dx1+dx2)*slope1
            !write(6,*) '+++ i, z_cell, z_pwlin: ',i,z_cell(i),z_pwlin(i)

        else

            do i2=i1,mx_pwlin
                if (x_pwlin(i2) >= x2) exit
            enddo
            ! now i2 points to first nodal point to right of cell
            
            if (i2 > mx_pwlin) then
                write(6,*) '*** pwlin function does not cover domain'
                write(6,*) '*** x2, x_pwlin(mx_pwlin): ',x2,x_pwlin(mx_pwlin)
                stop
            endif
    
    
            ! compute integral of pw linear function
            ! start with portion between x1 and x_pwlin(i1):
            dx1 = x_pwlin(i1) - x1
            slope1 = (z_pwlin(i1) - z_pwlin(i1-1)) &
                   / (x_pwlin(i1) - x_pwlin(i1-1))
            cell_int = dx1 * (z_pwlin(i1) - 0.5d0*dx1*slope1)
    
            ! add in contributions from full intervals between x1,x2:
            do ifull=i1+1,i2-1
                dx1 = x_pwlin(ifull) - x_pwlin(ifull-1)
                cell_int = cell_int + dx1*0.5d0*(z_pwlin(ifull-1)+z_pwlin(ifull))
            enddo
    
            ! finish with portion between x_pwlin(i2-1) and x2:
            dx1 = x2 - x_pwlin(i2-1)
            slope1 = (z_pwlin(i2) - z_pwlin(i2-1)) &
                   / (x_pwlin(i2) - x_pwlin(i2-1))
            cell_int = cell_int + dx1 * (z_pwlin(i2-1) + 0.5d0*dx1*slope1)

            ! divide by width of computational cell to get cell average topo value:
            z_cell(i) = cell_int / (x2 - x1)
            !write(6,*) '+++ i, z_cell, z_pwlin: ',i,z_cell(i),z_pwlin(i)
        endif
    enddo

    end subroutine cell_average

!   ============================================================
    subroutine read_dtopo_settings(file_name)

    implicit none

    character(len=*), intent(in), optional :: file_name

    ! Locals
    integer, parameter :: iunit = 7
    character (len=150) :: dtopofname
    integer :: ndtopofiles, dtopotype

    if (present(file_name)) then
        call opendatafile(iunit, file_name)
    else
        call opendatafile(iunit, 'dtopo.data')
    endif


    read(iunit,*) ndtopofiles

    if (ndtopofiles == 0) then
        topo_finalized = .true.
        dt_max_dtopo = 999d9

    else if (ndtopofiles == 1) then
        read(iunit,*) dtopofname, dtopotype
        read(iunit,*) dt_max_dtopo
        close(iunit)
        call read_dtopo_file(dtopofname,dtopotype)
        topo_finalized = .false.

    else if (ndtopofiles > 1) then
        write(6,*) '*** Currently require at most 1 dtopofile'
        stop
        
    

    endif

    end subroutine read_dtopo_settings



!   ============================================================
    subroutine read_dtopo_file(fname,dtopotype)

    use grid_module, only: mx,mbc

    implicit none

    integer, intent(in) :: dtopotype
    character(len=150), intent(in) :: fname
    integer :: i, k, status, dtopo_size, ibc
    integer, parameter :: iunit = 7
    real(kind=8) :: t0,tf,t,x,x1,x2,dt_dtopo


    if (dtopotype == 1) then
        ! determine how many x values at each time:
        open(unit=iunit, file=trim(fname), status='unknown',form='formatted')
        read(iunit, *) t0,x1
        dtopo_size = 1
        mx_dtopo = 1
        t = t0
        status = 0
        do while (status == 0)
            read(iunit,fmt=*,iostat=status) t,x
            if (status .ne. 0) exit
            if (t == t0 ) then
                mx_dtopo = mx_dtopo + 1
            endif
            dtopo_size = dtopo_size + 1
        end do
        mt_dtopo = dtopo_size/mx_dtopo
        x2 = x
        tf = t
        if (mt_dtopo > 1) then
            dt_dtopo = (tf-t0)/(mt_dtopo-1)
        else
            dt_dtopo = 0.
        endif
        
        rewind(iunit)

        allocate(x_dtopo(mx_dtopo), dz_dtopo(mt_dtopo,mx_dtopo), &
                 t_dtopo(mt_dtopo))
        allocate(dz_cell(mt_dtopo,1-mbc:mx+mbc))

        write(6,"('Reading ',i6,' dtopo values from ')") mx_dtopo
        write(6,*) '    ',trim(fname)
        
        do k=1,mt_dtopo
            do i=1,mx_dtopo
                read(iunit,*) t_dtopo(k), x_dtopo(i), dz_dtopo(k,i)
            enddo
            
            ! x_dtopo(:), dz_dtopo(k,:) defines a pw linear function,
            ! compute cell averages based on computational cells:
            call cell_average(mx_dtopo, x_dtopo, dz_dtopo(k,:), &
                              dz_cell(k,1:mx))
                              
            ! extrapolate to ghost cells:
            do ibc=1,mbc
                dz_cell(k,1-ibc) = dz_cell(k,1)
                dz_cell(k,mx+ibc) = dz_cell(k,mx)
            enddo
    
        enddo
        close(iunit)

    else
        write(6,*) 'Unrecognized dtopotype = ',dtopotype
        stop
    endif


    end subroutine read_dtopo_file

!   ============================================================
    subroutine topo_update(t)

    !integer :: mt_dtopo, mx_dtopo
    !real(kind=8), allocatable :: x_dtopo(:),t_dtopo(:),dz_dtopo(:,:)

    ! assumes dz_cell(1:mt_dtopo, 1-mbc:mx_grid+mbc) has been set
    ! to cell average of dz_dtopo on each grid cell at each dtopo time.

    ! updates zcell to be 
    !    (original zcell0) + (dz_cell at time t)
    ! interpolated from dtopo times.
    
    ! Note this differs from 2d, since here we update aux directly
    ! rather than topo arrays.  Works ok here since no AMR.

    use grid_module, only: mx,mbc

    implicit none
    
    real(kind=8), intent(in) :: t

    integer :: i,k,kd1,kd2
    real(kind=8) :: tau,td1,td2

    if ((mt_dtopo == 0) .or. topo_finalized) return

    if (mt_dtopo == 1) then
        ! instantaneous displacement at the one time t_dtopo(1):
        if (t < t_dtopo(1)) then
            zcell(:) = zcell0(:)
        else
            zcell(:) = zcell0(:) + dz_cell(1,:)
        endif
    else if (t > t_dtopo(mt_dtopo)) then
        ! move topo for final time:
        !write(6,*) '+++ t is past end of t_dtopo array'
        zcell(:) = zcell0(:) + dz_cell(mt_dtopo,:)
        topo_finalized = .true.
    else
        ! interpolate in time:
        do kd2=1,mt_dtopo
            !write(6,*) '+++ checking kd2,t,t_dtopo(kd2) = ',kd2,t, t_dtopo(kd2)
            if (t <= t_dtopo(kd2)) then
                exit
            endif
        enddo
        
        if (kd2 > mt_dtopo) write(6,*) '*** unexpected! kd2 > mt_dtopo'
        
        kd1 = kd2-1
        !write(6,*) '+++ mt_dtopo, kd1: ',mt_dtopo, kd1

        tau = (t - t_dtopo(kd1)) / (t_dtopo(kd2) - t_dtopo(kd1))
        !write(6,*) '+++ updating topo with tau = ',tau
        zcell(:) = zcell0(:) + (1.d0-tau)*dz_cell(kd1,:) + tau*dz_cell(kd2,:)
    endif
    
    

    end subroutine topo_update

end module topo_module

module parameters_module

    implicit none
    
    ! Physics constants
    double precision, parameter :: PI = 3.141592654d0, g = 9.8d0
    double precision :: rho_air,rho(2)
    double precision :: r, one_minus_r,manning
    
    ! Algorithm settings
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix

    ! Initial condition settings
    integer :: init_type,wave_family
    double precision :: init_location,eta_left(2),eta_right(2)
    double precision :: u_left(2),u_right(2),epsilon,sigma,bathy_type
    double precision :: bathy_location,bathy_left,bathy_right
    double precision :: x0,basin_depth,x1,shelf_depth,shelf_slope
    
    ! Wind forcing settings
    integer, private :: wind_type
    double precision, private :: A,B,Pn,Pc,ramp_up_time,R_eye_init
    double precision, private :: hurricane_velocity,omega,N,t_length

contains

    ! ========================================================================
    !  Setup all parameters in the module
    ! ========================================================================
    subroutine setup_parameters(data_file)

        implicit none

        ! Input
        character(len=*), optional, intent(in) :: data_file

        ! Locals
        integer :: ios,i

        ! Open file
        if (present(data_file)) then
            call opendatafile(13,data_file)
        else
            call opendatafile(13,'problem.data')
        endif

        ! Physics constants
        read(13,*) rho_air
        read(13,*) rho
        r = rho(1) / rho(2)
        one_minus_r = 1.d0 - r
        read(13,*) manning
        read(13,*)
        
        ! Algorithm settings
        read(13,*) dry_tolerance
        read(13,*) eigen_method
        read(13,*) inundation_method
        read(13,*) entropy_fix
        read(13,*)
        
        ! Initial conditions
        read(13,*) init_type
        read(13,*) init_location
        read(13,*) wave_family
        read(13,*) eta_left
        read(13,*) eta_right
        read(13,*) u_left
        read(13,*) u_right
        read(13,*) epsilon
        read(13,*) sigma
        read(13,*)
        
        ! Bathymetry
        read(13,*) bathy_type
        if (bathy_type == 1) then
            read(13,*) bathy_location
            read(13,*) bathy_left
            read(13,*) bathy_right
        else if (bathy_type == 2) then
            read(13,*) x0
            read(13,*) basin_depth
            read(13,*) x1
            read(13,*) shelf_depth
            shelf_slope = (basin_depth - shelf_depth) / (x0 - x1)
        endif
        read(13,*)
        
        ! Wind settings
        read(13,*) wind_type
        select case(wind_type)
            case(0) ! No wind
            case(1) ! Constant wind
                read(13,*) A
            case(2) ! Hurricane wind
                read(13,*) A
                read(13,*) B
                read(13,*) Pn
                read(13,*) Pc
                read(13,*) ramp_up_time
                read(13,*) hurricane_velocity
                read(13,*) R_eye_init
            case(3) ! Oscillatory wind
                read(13,*) A
                read(13,*) N
                read(13,*) omega
                read(13,*) t_length
            case(4) ! Gaussian bump
                read(13,*) A
                read(13,*) hurricane_velocity
                read(13,*) R_eye_init
                read(13,*) sigma
            case default
                print *,"Invalid wind field type ", wind_type    
                stop
        end select
        
    end subroutine setup_parameters    
    
    ! Set wind speed based on parameters in this module
    subroutine set_wind(maxmx,mbc,mx,xlower,dx,t,wind)

        implicit none

        ! Input arguments
        integer, intent(in) :: maxmx,mbc,mx
        double precision, intent(in) :: xlower,dx,t

        ! Output
        double precision, intent(inout) :: wind(1-mbc:maxmx+mbc)
    
        ! Local variables
        integer :: i
        double precision :: x,L,time,C,R_eye,r
    
        ! Parse time input, if -99.d99 assume we are at the initial time step and
        ! use ramp_up_time as the initial time if we are trying to do a hurricane
        ! wind field and ramp up, otherwise leave t alone
        if (t == -99.d99) then
            if (wind_type == 2) then
                time = -ramp_up_time
            else
                time = 0.d0
            endif
        else
            time = t
        endif
    
        select case(wind_type)
            ! No wind
            case(0)
                wind = 0.d0
            ! Constant wind
            case(1)
                wind = A
            ! Hurricane wind
            case(2)
                ! Hurrican eye location
                R_eye = t * hurricane_velocity + R_eye_init
        
                ! Parameter constant
                C = 1.d1 * 1.d3**(B/2.d0) * sqrt(A*B*(Pn-Pc)/(rho_air))
        
                ! Set wind field
                do i=1-mbc,mx+mbc
                    ! Distance from center of storm
                    x = xlower + (i-0.5d0) * dx - R_eye
                    r = abs(x)     
                    ! If sufficiently far from eye, calculate wind velocity
                    if (r >= 1.d-3) then
                        wind(i) = sign(1.d0,x) * C * sqrt(exp(-1.d3**B*A/r**B)/r**B)
                    endif
                enddo
                
                ! Ramp up
                if (t < 0.d0) then
                    wind = wind * exp(-(t/(ramp_up_time*0.45d0))**2)
                endif
        
            ! Oscillating wind field
            case(3)
                L = xlower + mx * dx
                do i=1-mbc,mx+mbc
                    x = xlower + (i-0.5d0) * dx
                    wind(i) = A * sin(PI*n*(x)/L) * sin(2*PI*omega/t_length*t)
                enddo
            ! Moving gaussian wind field
            case(4)
                R_eye = t * hurricane_velocity + R_eye_init
                do i=1-mbc,mx+mbc
                    x = xlower + (i-0.5d0) * dx - R_eye
                    wind(i) = A * exp(-((x-R_eye_init)/sigma)**2)
                enddo
        end select
    
    end subroutine set_wind

    double precision function wind_drag(wind_speed)
    
        implicit none
        
        ! Input
        double precision, intent(in) :: wind_speed
        
        if (wind_speed <= 11.d0) then
            wind_drag = 1.2d0
        else if ((wind_speed > 11.d0).and.(wind_speed <= 25.d0)) then
            wind_drag = 0.49d0 + 0.065d0 * wind_speed
        else
            wind_drag = 0.49 + 0.065d0 * 25.d0
        endif
        
        wind_drag = wind_drag * 10.d-3
    
    end function wind_drag


end module parameters_module


subroutine setprob()

    use parameters_module

    implicit none
    
    call setup_parameters()

end subroutine setprob

c
c
c     =====================================================
      subroutine flux1(maxm,meqn,maux,mbc,mx,
     &                 q1d,dtdx1d,aux1,
     &                 faddm,faddp,cfl1d,wave,s,
     &                 amdq,apdq,cqxx,bmasdq,bpasdq,rp1)
c     =====================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c     # Compute the modification to flux f that is generated by
c     # all interfaces along a 1D slice of the grid.
c     # This value is passed into the Riemann solver. The flux modifications
c     # go into the array fadd.  The notation is written assuming
c     # we are solving along a 1D slice in the x-direction.
c
c     # fadd(*,i,.) modifies F to the left of cell i
c
c     # The method used is specified by method(2):
c
c         method(2) = 1 if only first order increment waves are to be used.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.  
c
c     Note that if mcapa>0 then the capa array comes into the second 
c     order correction terms, and is already included in dtdx1d:
c        dtdx1d(i) = dt/dx                      if mcapa= 0
c                  = dt/(dx*aux(mcapa,i,jcom))  if mcapa = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rp1 into
c            amdq =  the left-going flux difference  A^- Delta q
c            apdq = the right-going flux difference  A^+ Delta q
c
c
      use amr_module
      implicit double precision (a-h,o-z)
      external rp1
      dimension    q1d(meqn,1-mbc:maxm+mbc)
      dimension   amdq(meqn,1-mbc:maxm+mbc)
      dimension   apdq(meqn,1-mbc:maxm+mbc)
      dimension   cqxx(meqn,1-mbc:maxm+mbc)
      dimension   faddm(meqn,1-mbc:maxm+mbc)
      dimension   faddp(meqn,1-mbc:maxm+mbc)
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux1(maux,1-mbc:maxm+mbc)
c
      dimension     s(mwaves, 1-mbc:maxm+mbc)
      dimension  wave(meqn, mwaves, 1-mbc:maxm+mbc)
c
      logical limit
      common /comxt/ dtcom,dxcom,tcom,icom
c
      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
   5     continue
c
c     # initialize flux increments:
c     -----------------------------
c
       do 10 i = 1-mbc, mx+mbc
         do 20 m=1,meqn
            faddm(m,i) = 0.d0
            faddp(m,i) = 0.d0
   20    continue
   10  continue
c
c
c     # solve Riemann problem at each interface and compute Godunov updates
c     ---------------------------------------------------------------------
c
      call rp1(maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &          aux1,aux1,wave,s,amdq,apdq)
c
c     # Set fadd for the donor-cell upwind method (Godunov)
      do 40 i=1,mx+1
         do 40 m=1,meqn
            faddp(m,i) = faddp(m,i) - apdq(m,i)
            faddm(m,i) = faddm(m,i) + amdq(m,i)
   40       continue
c
c     # compute maximum wave speed for checking Courant number:
      cfl1d = 0.d0
      do 50 mw=1,mwaves
         do 50 i=1,mx+1
c          # if s>0 use dtdx1d(i) to compute CFL,
c          # if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i),
     &                          -dtdx1d(i-1)*s(mw,i))
   50       continue
c
      if (method(2).eq.1) go to 130
c
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c
c     # apply limiter to waves:
      if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c
      do 120 i = 1, mx+1
c
c        # For correction terms below, need average of dtdx in cell
c        # i-1 and i.  Compute these and overwrite dtdx1d:
c
c        # modified in Version 4.3 to use average only in cqxx, not transverse
         dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))

c
c        # second order corrections:

         do 120 m=1,meqn
            cqxx(m,i) = 0.d0
            do 119 mw=1,mwaves
c
               if (use_fwaves) then
                   abs_sign = dsign(1.d0,s(mw,i))
                 else
                   abs_sign = dabs(s(mw,i))
                 endif

               cqxx(m,i) = cqxx(m,i) + abs_sign
     &             * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
c
  119          continue
            faddm(m,i) = faddm(m,i) + 0.5d0 * cqxx(m,i)
            faddp(m,i) = faddp(m,i) + 0.5d0 * cqxx(m,i)
  120       continue
c
c
  130  continue
c
      return
      end

! =========================================================
!> Check for NANs in solution q
subroutine check4nans(meqn,mbc,mx,my,q,t,ichecknan)

    implicit none
    
    ! Input
    integer, intent(in) ::  meqn, mbc, mx, my, ichecknan
    real(kind=8), intent(in) :: t, q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Locals
    integer :: i, j, m

    ! print *,'Checking for NANs at ichecknan = ',ichecknan
    ! print *,'  mx = ',mx,'  my = ',my,'  meqn = ',meqn
      
    do i=1-mbc,mx+mbc
        do j=1-mbc,my+mbc
            do m=1,meqn
                if (.not. (q(m,i,j) == q(m,i,j))) then
                    ! true if q(i,j,m) = NAN
                    print *, 'SOLUTION ERROR --- ABORTING CALCULATION'
                    print *, 'At ichecknan = ',ichecknan
                    print *, '   mx,my,t:',mx,my,t
                    print *, '   m,i,j:',m,i,j
                    print *, '   q(m,i,j) = ',q(m,i,j)
                    stop
                endif
            enddo
        enddo
    enddo

    ! Uncomment the next line if desired when debugging:
    ! print *,'No NANs at ichecknan = ',ichecknan,' at t = ',t

end subroutine check4nans

! ==========================================================
subroutine flux2(q,dq,aux,dt,cfl,t,num_aux,num_eqn,num_ghost,maxnx,mx,my,rpn2,tfluct2)
! ==========================================================
!    Evaluate (delta t) *dq/dt
!    On entry, q should give the initial data for this step
!    See the flux1 documentation for more information.
! ==========================================================

    use ClawParams
    implicit none
    
    ! Input (dummy) variables
    external :: rpn2, tfluct2
    integer, intent(in) :: num_aux, num_eqn, num_ghost, maxnx, mx, my
    double precision, intent(in) :: dt,t
    double precision, target, intent(in) :: q(num_eqn, 1-num_ghost:mx+num_ghost, 1-num_ghost:my+num_ghost)
    double precision, target, intent(in) :: aux(num_aux, 1-num_ghost:mx+num_ghost, 1-num_ghost:my+num_ghost)
    double precision, intent(inout) :: dq(num_eqn, 1-num_ghost:mx+num_ghost, 1-num_ghost:my+num_ghost)
    double precision, intent(out) :: cfl

!f2py intent(in,out) dq  
!f2py intent(out) cfl  
!f2py optional dq

! Dummy interface just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn2(x)
!f2py x=tfluct2(x)

    ! Local variables
    integer :: i,j,m
    double precision :: cfl1d
    double precision, pointer :: aux1d(:,:),q1d(:,:)
    double precision :: dq1d(num_eqn,1-num_ghost:maxnx+num_ghost)

! ==========================================================

    cfl = 0.d0

    ! perform x-sweeps
    ! ==================

    do j = 0,my+1
        ! copy data along a slice into 1d arrays:
        q1d => q(:,:,j)
        aux1d => aux(:,:,j)

        ! compute modification dq1d along this slice:
        call flux1(q1d,dq1d,aux1d,dt,cfl1d,t,1,num_aux,num_eqn,mx,num_ghost,maxnx,rpn2,tfluct2)
        cfl = dmax1(cfl,cfl1d)

        forall(i=1:mx, m=1:num_eqn)
            dq(m,i,j) = dq(m,i,j)+dq1d(m,i)
        end forall
    enddo !end x sweeps


    ! perform y sweeps
    ! ==================

    do i = 0, mx+1
        ! copy data along a slice into 1d arrays:
        q1d => q(:,i,:)
        aux1d => aux(:,i,:)

        call flux1(q1d,dq1d,aux1d,dt,cfl1d,t,2,num_aux,num_eqn,my,num_ghost,maxnx,rpn2,tfluct2)
        cfl = dmax1(cfl,cfl1d)

        forall(j=1:my, m=1:num_eqn)
            dq(m,i,j) = dq(m,i,j)+dq1d(m,j)
        end forall
    enddo !end y sweeps

end subroutine flux2

! ============================================================================
!  Module for topography data
! ============================================================================
module topo_module

    use amr_module, only: xlower,xupper,ylower,yupper,hxposs,hyposs,nghost
    implicit none

    logical, private :: module_setup = .false.

    ! Work array for topography for all t
    real(kind=8), allocatable :: topowork(:)

    ! Topography file data
    integer :: test_topography
    character(len=150), allocatable :: topofname(:)
    integer :: mtopofiles
    integer(kind=8) :: mtoposize
    real(kind=8), allocatable :: xlowtopo(:), ylowtopo(:), tlowtopo(:)
    real(kind=8), allocatable :: xhitopo(:), yhitopo(:), thitopo(:)
    real(kind=8), allocatable :: dxtopo(:), dytopo(:)
    real(kind=8), allocatable :: topotime(:)
    integer(kind=8), allocatable :: mtopo(:), i0topo(:)

    integer, allocatable :: mxtopo(:), mytopo(:), mtopoorder(:)
    integer, allocatable :: itopotype(:)
    integer, allocatable :: topoID(:),topo0save(:)
    logical :: topo_finalized

    ! Moving topography support
    integer :: imovetopo, aux_finalized

    ! Analytic topography
    real(kind=8), private :: topo_left, topo_right, topo_location
    real(kind=8), private :: topo_x0,topo_x1,topo_x2,topo_basin_depth
    real(kind=8), private :: topo_shelf_depth,topo_shelf_slope,topo_beach_slope

    ! NetCDF4 support
    real(kind=4), parameter :: CONVENTION_REQUIREMENT = 1.0

    ! dtopo variables
    ! Work array
    real(kind=8), allocatable :: dtopowork(:)
    real(kind=8) :: dt_max_dtopo

    ! File data parameters
    character (len=150), allocatable :: dtopofname(:)
    real(kind=8), allocatable :: xlowdtopo(:),ylowdtopo(:),xhidtopo(:)
    real(kind=8), allocatable :: yhidtopo(:),t0dtopo(:),tfdtopo(:)
    real(kind=8), allocatable :: dxdtopo(:),dydtopo(:),dtdtopo(:)
    real(kind=8), allocatable :: tdtopo1(:),tdtopo2(:),taudtopo(:)

    integer, allocatable :: mxdtopo(:), mydtopo(:), mtdtopo(:)
    integer(kind=8), allocatable :: mdtopo(:), i0dtopo(:)
    integer, allocatable :: dtopotype(:), mdtopoorder(:),kdtopo1(:),kdtopo2(:)
    integer(kind=8), allocatable :: index0_dtopowork1(:),index0_dtopowork2(:)

    integer :: num_dtopo
    real(kind=8) dz
    logical, allocatable :: topoaltered(:) !don't think this is needed anymore

    ! Initial topography
    ! Work array for initial topography (only arrays where topo evolves)
    real(kind=8), allocatable :: topo0work(:)
    integer, allocatable :: topo0ID(:)
    integer(kind=8), allocatable :: i0topo0(:)
    integer(kind=8) :: mtopo0size
    integer :: mtopo0files

    real(kind=8) topo_missing

contains

    ! ========================================================================
    ! Read topography files as specified in topography.data
    !
    ! Each topography file has a type stored in topotype(i).
    !   topotype = 1:  standard GIS format: 3 columns: lon,lat,height(m)
    !   topotype = 2:  Header as in DEM file, height(m) one value per line
    !   topotype = 3:  Header as in DEM file, height(m) one row per line
    ! For other formats modify readtopo routine.
    !
    ! advancing northwest to northeast then from north to south. Values should
    ! be uniformly spaced.
    !
    ! Finest value of topography in a given region will be used for
    ! computation
    ! ========================================================================
    subroutine read_topo_settings(restart,file_name)

        use geoclaw_module

        implicit none

        ! Input arguments
        character(len=*), intent(in), optional :: file_name
        logical, intent(in) :: restart

        ! Locals
        integer, parameter :: iunit = 7
        integer :: i,j,finer_than,rank
        real(kind=8) :: area_i,area_j
        real(kind=8) :: area, area_domain
        if (.not.module_setup) then

            ! Open and begin parameter file output
            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'SETTOPO:'
            write(GEO_PARM_UNIT,*) '---------'


            if (present(file_name)) then
                call opendatafile(iunit, file_name)
            else
                call opendatafile(iunit, 'topo.data')
            endif
            ! Read in value to use in place of no_data_value in topofile
            read(iunit,*) topo_missing

            ! Read in topography specification type
            read(iunit,"(i1)") test_topography

            ! Primary topography type, read in topography files specified
            if (test_topography == 0) then
                read(iunit,*) mtopofiles

                if (mtopofiles == 0) then
                    write(GEO_PARM_UNIT,*) '   mtopofiles = 0'
                    write(GEO_PARM_UNIT,*) '   No topo files specified, '
                    write(GEO_PARM_UNIT,*) '          will set B(x,y) = 0 in setaux'
                    return
                endif

                mtopofiles = mtopofiles + num_dtopo
                write(GEO_PARM_UNIT,*) '   mtopofiles = ',mtopofiles-num_dtopo
                
                ! Read and allocate data parameters for each file
                allocate(mxtopo(mtopofiles),mytopo(mtopofiles))
                allocate(xlowtopo(mtopofiles),ylowtopo(mtopofiles))
                allocate(tlowtopo(mtopofiles),xhitopo(mtopofiles),yhitopo(mtopofiles))
                allocate(thitopo(mtopofiles),dxtopo(mtopofiles),dytopo(mtopofiles))
                allocate(topofname(mtopofiles),itopotype(mtopofiles))
                allocate(i0topo(mtopofiles),mtopo(mtopofiles),mtopoorder(mtopofiles))
                allocate(topoID(mtopofiles),topotime(mtopofiles),topo0save(mtopofiles))
                allocate(i0topo0(mtopofiles),topo0ID(mtopofiles))

                do i=1,mtopofiles - num_dtopo
                    read(iunit,*) topofname(i)
                    read(iunit,*) itopotype(i)

                    write(GEO_PARM_UNIT,*) '   '
                    write(GEO_PARM_UNIT,*) '   ',topofname(i)
                    write(GEO_PARM_UNIT,*) '  itopotype = ', itopotype(i)
                    if (abs(itopotype(i)) == 1) then
                        print *, 'converting to topotype > 1 might reduce file size'
                        print *, 'python tools for converting files are provided'
                    endif
                    call read_topo_header(topofname(i),itopotype(i),mxtopo(i), &
                        mytopo(i),xlowtopo(i),ylowtopo(i),xhitopo(i),yhitopo(i), &
                        dxtopo(i),dytopo(i))
                    topoID(i) = i
                    mtopo(i) = int(mxtopo(i), 8) * int(mytopo(i), 8)
                enddo

                ! adding extra topo arrays corresponding spatially to dtopo
                ! arrays will be part of time dependent topowork as with all others.
                ! the state of these arrays at t=0 will be stored in topo0work
                topo0save(:)= 0
                do i= mtopofiles - num_dtopo + 1, mtopofiles
                   j = i - mtopofiles + num_dtopo
                   itopotype(i) = dtopotype(j)
                   mxtopo(i) = mxdtopo(j)
                   mytopo(i) = mydtopo(j)
                   xlowtopo(i) = xlowdtopo(j)
                   ylowtopo(i) = ylowdtopo(j)
                   xhitopo(i) = xhidtopo(j)
                   yhitopo(i) = yhidtopo(j)
                   dxtopo(i) = dxdtopo(j)
                   dytopo(i) = dydtopo(j)
                   mtopo(i) = int(mxtopo(i), 8) * int(mytopo(i), 8)
                   topoID(i) = i
                   topotime(i) = -huge(1.0)
                   topo0save(i) = 1
                enddo

                ! Indexing into work array
                i0topo(1)=1
                if (mtopofiles > 1) then
                    do i=2,mtopofiles
                        i0topo(i)=i0topo(i-1) + mtopo(i-1)
                    enddo
                endif

                ! Read topography and allocate space for each file
                mtoposize = sum(mtopo)
                allocate(topowork(mtoposize))

                do i=1,mtopofiles - num_dtopo
                    topoID(i) = i
                    topotime(i) = -huge(1.0)
                    call read_topo_file(mxtopo(i),mytopo(i),itopotype(i),topofname(i), &
                        xlowtopo(i),ylowtopo(i),topowork(i0topo(i):i0topo(i)+mtopo(i)-1))
                    ! set topo0save(i) = 1 if this topo file intersects any
                    ! dtopo file.  This approach to setting topo0save is changed from 
                    ! v5.4.1, where it only checked if some dtopo point lies within the
                    ! topo grid, which might not happen for small scale topo
                    do j=mtopofiles - num_dtopo + 1, mtopofiles
                        if ((xhitopo(i)<xlowtopo(j)) .or. &
                            (xlowtopo(i)>xhitopo(j)) .or. &
                            (yhitopo(i)<ylowtopo(j)) .or. &
                            (ylowtopo(i)>yhitopo(j))) then
                              topo0save(i) = 0
                          else
                              topo0save(i) = 1
                          endif

                    enddo
                enddo

                ! topography order...This determines which order to process topography
                !
                ! The finest topography will be given priority in any region
                ! mtopoorder(rank) = i means that i'th topography file has rank rank,
                ! where the file with rank=1 is the finest and considered first.
                do i=1,mtopofiles
                    finer_than = 0
                    do j=1,mtopofiles
                        if (j /= i) then
                            area_i=dxtopo(i)*dytopo(i)
                            area_j=dxtopo(j)*dytopo(j)
                            if (area_i < area_j) finer_than = finer_than + 1
                            ! if two files have the same resolution, order is
                            ! arbitrarily chosen
                            if ((area_i == area_j).and.(j < i)) then
                                finer_than = finer_than + 1
                            endif
                        endif
                    enddo
                    ! ifinerthan tells how many other files, file i is finer than
                    rank = mtopofiles - finer_than
                    mtopoorder(rank) = i
                enddo

                write(GEO_PARM_UNIT,*) ' '
                write(GEO_PARM_UNIT,*) '  Ranking of topography files', &
                    '  finest to coarsest: ', &
                    (mtopoorder(rank),rank=1,mtopofiles)
                write(GEO_PARM_UNIT,*) ' '

                !set values in topo array for dtopo generated topo
                !this call will also determine which topo arrays to save in topo0work
                do i = mtopofiles - num_dtopo + 1, mtopofiles
                   call set_topo_for_dtopo(mxtopo(i),mytopo(i),dxtopo(i),dytopo(i), &
                        xlowtopo(i),yhitopo(i), topowork(i0topo(i):i0topo(i)+mtopo(i)-1))
                enddo

                !create topo0work array for finest arrays covering dtopo
                !arrays to be saved are indicated in topo0save
                topo_finalized = .true.
                aux_finalized = 2   !# indicates aux arrays properly set with dtopo
                if (num_dtopo>0) then
                   topo_finalized = .false.
                   if (.not. restart) then ! rest is read in
                      aux_finalized = 0  !# will be incremented each time level 1 goes
                   endif

                   i0topo0(1) = 1
                   mtopo0size = dot_product(mtopo,topo0save)
                   allocate(topo0work(mtopo0size))
                   do i = 2,mtopofiles
                      i0topo0(i)= i0topo0(i-1) + mtopo(i-1)*topo0save(i-1)
                   enddo

                   do i = 1,mtopofiles
                      if (topo0save(i)>0) then
                         topo0work(i0topo0(i):i0topo0(i)+mtopo(i)-1) = &
                            topowork(i0topo(i):i0topo(i)+mtopo(i)-1)
                      endif
                   enddo
                endif

                ! Check that topo arrays cover full domain:
                call topoarea(xlower,xupper,ylower,yupper,1,area)
                area_domain = (yupper-ylower)*(xupper-xlower)
                if (abs(area - area_domain) > 1e-2*area_domain) then
                    write(6,*) '**** topo arrays do not cover domain'
                    write(6,*) '**** area of overlap = ', area
                    write(6,*) '**** area of domain  = ', area_domain
                    stop
                else if (abs(area - area_domain) > 1e-12*area_domain) then
                    write(6,*) '**** WARNING'
                    write(6,*) '**** topo arrays do not quite cover domain'
                    write(6,*) '**** area of overlap = ', area
                    write(6,*) '**** area of domain  = ', area_domain
                    write(6,*) '**** error is less than 1% so proceeding...'
                endif

            !---------------tests for analytic bathymetry-------------------
            ! Simple jump discontinuity in bathymetry
            else if (test_topography == 1) then
                topo_finalized = .true.
                read(iunit,"(d16.8)") topo_location
                read(iunit,"(d16.8)") topo_left
                read(iunit,"(d16.8)") topo_right

            ! Idealized ocean shelf
            else if (test_topography == 2 .or. test_topography == 3) then
                topo_finalized = .true.
                read(iunit,"(d16.8)") topo_x0
                read(iunit,"(d16.8)") topo_x1
                read(iunit,"(d16.8)") topo_x2
                read(iunit,"(d16.8)") topo_basin_depth
                read(iunit,"(d16.8)") topo_shelf_depth
                read(iunit,"(d16.8)") topo_beach_slope
                topo_shelf_slope = (topo_basin_depth - topo_shelf_depth) &
                                            / (topo_x0 - topo_x1)
            else
                print *,"Error:  Unknown test topography type ",test_topography
                stop
            endif

            module_setup = .true.
        end if

    end subroutine read_topo_settings

    ! ========================================================================
    !  set_topo_for_dtopo()
    !
    !  Set topography values in new topo arrays that correspond to dtopo spatialy
    !  array values come from the finest topography already in topowork
    ! ========================================================================

    subroutine set_topo_for_dtopo(mx,my,dx,dy,xlow,yhi,newtopo)

        !arguments
        integer, intent(in) :: mx,my
        real(kind=8), intent(in) :: dx,dy,xlow,yhi
        real(kind=8), intent(inout) :: newtopo(1:int(mx, 8) * int(my, 8))

        !locals
        integer :: id,irank,itopo1,itopo2,jtopo1,jtopo2
        integer(kind=8) :: i,j,ij,ijll,ijlr,ijul,ijur
        real(kind=8) :: x,y,xl,xr,yu,yl,zll,zlr,zul,zur,z,dxdy

        do j=1,int(my, 8)
               y = yhi - (j-1)*dy
            do i=1,int(mx, 8)
               x = xlow + (i-1)*dx
               ij = (j-1)*int(mx, 8) + i
               !find intersection starting from finest topo
               !all points must lie in some topo file therefore the
               !finest topo file for all dtopo points will be saved in topo0
               do irank = 1,mtopofiles
                  id = mtopoorder(irank)
                  if (id.gt.mtopofiles-num_dtopo) then
                     !this is another dtopo ==> topo file: skip
                     cycle
                  elseif ( (x>xhitopo(id)).or.(x<xlowtopo(id)).or. &
                          (y>yhitopo(id)).or.(y<ylowtopo(id))) then
                     !no intersection
                     cycle
                  else !lies in this topofile

                     ! Old way of setting topo0save up to v5.4.1.
                     ! This assumed topo file did not
                     ! intersect dtopo file if this point was never reached.
                     ! Not true if topofile has such small extent that it lies between
                     ! dtopo points.  Now instead we set topo0save earlier.
                     !topo0save(id) = 1

                     !find indices for bilinear cell in topo
                     !arrays are in form of DEM...high y values first
                     !note for xy points lying on nodes all indices will be equal
                     itopo1 = int(floor((x-xlowtopo(id))/dxtopo(id)))+1
                     itopo2 = int(ceiling((x-xlowtopo(id))/dxtopo(id)))+1
                     jtopo1 = int(floor((yhitopo(id)-y)/dytopo(id))) + 1
                     jtopo2 = int(ceiling((yhitopo(id)-y)/dytopo(id))) + 1
                     !indices for work array
                     ijll = i0topo(id) + (jtopo2-1)*mxtopo(id) + itopo1 -1
                     ijlr = i0topo(id) + (jtopo2-1)*mxtopo(id) + itopo2 -1
                     ijul = i0topo(id) + (jtopo1-1)*mxtopo(id) + itopo1 -1
                     ijur = i0topo(id) + (jtopo1-1)*mxtopo(id) + itopo2 -1
                     !find x,y,z values for bilinear
                     !z may be from only 1 or 2 nodes for aligned grids
                     !bilinear should still evaluate correctly
                     zll = topowork(ijll)
                     zlr = topowork(ijlr)
                     zul = topowork(ijul)
                     zur = topowork(ijur)
                     xl = xlowtopo(id) + real(itopo1-1,kind=8)*dxtopo(id)
                     xr = xl + dxtopo(id)
                     yu = yhitopo(id) - real(jtopo1-1,kind=8)*dytopo(id)
                     yl = yu - dytopo(id)
                     dxdy = dxtopo(id)*dytopo(id)
                     z = zll*(xr-x)*(yu-y) + zlr*(x-xl)*(yu-y) + zul*(xr-x)*(y-yl) + zur*(x-xl)*(y-yl)
                     newtopo(ij) = z/dxdy
                     !this was the finest topo file, move to next point
                     exit
                  endif
               enddo
            enddo
        enddo

    end subroutine set_topo_for_dtopo


    ! ========================================================================
    !  read_topo_file(mx,my,topo_type,fname,xll,yll,topo)
    !
    !  Read topo file.
    ! ========================================================================

    subroutine read_topo_file(mx,my,topo_type,fname,xll,yll,topo)

#ifdef NETCDF
        use netcdf
#endif

        use geoclaw_module
        use utility_module, only: parse_values, to_lower

        implicit none

        ! Arguments
        integer, intent(in) :: mx,my,topo_type
        character(len=150), intent(in) :: fname
        real(kind=8), intent(inout) :: topo(1:int(mx, 8)*int(my, 8))
        real(kind=8), intent(in) :: xll,yll

        ! Locals
        integer, parameter :: iunit = 19, miss_unit = 17
        logical, parameter :: maketype2 = .false.
        integer :: missing,status,n
        real(kind=8) :: no_data_value,x,y,topo_temp
        real(kind=8) :: values(10)
        character(len=80) :: str
        integer(kind=8) :: i, j, mtot

        ! NetCDF Support
        character(len=64) :: direction, x_dim_name, x_var_name, y_dim_name, &
            y_var_name, z_var_name, var_name
        ! character(len=1) :: axis_string
        real(kind=8), allocatable :: nc_buffer(:, :), xlocs(:), ylocs(:)
        integer(kind=4) :: x_var_id, y_var_id, z_var_id, x_dim_id, y_dim_id
        integer(kind=4) :: xstart(1), ystart(1), mx_tot, my_tot
        integer(kind=4) :: ios, nc_file, dim_ids(2), num_dims, &
            var_type, num_vars, num_dims_tot, z_dim_ids(2)

        mtot = int(mx, 8) * int(my, 8)

        print *, ' '
        print *, 'Reading topography file  ', fname

        select case(abs(topo_type))
            ! ASCII file with x,y,z values on each line.
            ! (progressing from upper left corner across rows, then down)
            ! Assumes a uniform rectangular grid of data values.
            case(1)
                open(unit=iunit, file=fname, status='unknown',form='formatted')
                i = 0
                status = 0
                do i=1,mtot
                    read(iunit,fmt=*,iostat=status) x,y,topo_temp
                    if ((i > mtot) .and. (status == 0)) then
                        print *,'*** Error: i > mx*my = ',mtot
                        print *,'*** i, mx, my: ',i,mx,my
                        print *,'*** status = ',status
                        stop
                    endif

                    if (status /= 0) then
                        print *,"Error reading topography file, reached EOF."
                        print *,"  File = ",fname
                        stop
                    else
                        topo(i) = topo_temp
                    endif
                enddo
                
                close(unit=iunit)

            ! ================================================================
            ! ASCII file with header followed by z data
            ! (progressing from upper left corner across rows, then down)
            ! one value per line if topo_type=2 or
            ! mx values per line if topo_type=3
            ! ================================================================
            case(2:3)
                open(unit=iunit, file=fname, status='unknown',form='formatted')
                ! Read header
                do i=1,5
                    read(iunit,*)
                enddo
                
                read(iunit,'(a)') str
                call parse_values(str, n, values)
                no_data_value = values(1)

                ! Read in data
                missing = 0
                select case(abs(topo_type))
                    case(2)
                        do i=1,mtot
                            read(iunit,*) topo(i)
                            if (topo(i) == no_data_value) then
                                missing = missing + 1
                                topo(i) = topo_missing
                                ! uncomment next line to print row i
                                ! write(6,600) i
 600                            format('*** missing data, i = ',i6)
                            endif
                        enddo
                    case(3)
                        do j=1,int(my, 8)
                            read(iunit,*) (topo((j-1)*int(mx, 8) + i),i=1,mx)
                            do i=1,int(mx, 8)
                                if (topo((j-1)*int(mx, 8) + i) == no_data_value) then
                                    missing = missing + 1
                                    topo((j-1)*int(mx, 8) + i) = topo_missing
                                    ! uncomment next line to print row j
                                    ! and element i that are missing.
                                    ! write(6,601) i,j
 601                                format('*** missing data, i = ',i6, &
                                           '  j = ',i6)
                                endif
                            enddo
                        enddo
                end select

                ! Write a warning if we found and missing values
                if (missing > 0)  then
                    write(6,602) missing
 602                format('WARNING... ',i6, &
                           ' missing data values in this topofile')
                    write(6,603) topo_missing
 603                format('   These values have been set to topo_missing = ',&
                           f13.3, ' in read_topo_file')
                    if (topo_missing == 99999.d0) then
                        print *, 'ERROR... do not use this default value'
                        print *, 'Fix your topofile or set'
                        print *, '  rundata.topo_data.topo_missing in setrun.py'
                        stop
                        endif
                    print *, ' '
                endif

                close(unit=iunit)
            
            ! NetCDF
            case(4)
#ifdef NETCDF
                ! Open file    
                call check_netcdf_error(nf90_open(fname, nf90_nowrite, nc_file))
                
                ! Get number of dimensions and vars
                call check_netcdf_error(nf90_inquire(nc_file, num_dims_tot, &
                    num_vars))
                
                ! get x and y dimension info
                call get_dim_info(nc_file, num_dims_tot, x_dim_id, x_dim_name, &
                    mx_tot, y_dim_id, y_dim_name, my_tot)
                    
                allocate(xlocs(mx_tot),ylocs(my_tot))
                
                call check_netcdf_error(nf90_get_var(nc_file, x_dim_id, xlocs, start=(/ 1 /), count=(/ mx_tot /)))
                call check_netcdf_error(nf90_get_var(nc_file, y_dim_id, ylocs, start=(/ 1 /), count=(/ my_tot /)))
                xstart = minloc(xlocs, mask=(xlocs.eq.xll))
                ystart = minloc(ylocs, mask=(ylocs.eq.yll))
                deallocate(xlocs,ylocs)
                
                z_var_id = -1
                do n=1, num_vars
                    call check_netcdf_error(nf90_inquire_variable(nc_file, n, var_name, var_type, num_dims, dim_ids))
                    
                    ! Assume dim names are same as var ids
                    if (var_name == x_dim_name) then
                        x_var_name = var_name
                        call check_netcdf_error(nf90_inq_varid(nc_file, x_var_name, x_var_id))
                    else if (var_name == y_dim_name) then
                        y_var_name = var_name
                        call check_netcdf_error(nf90_inq_varid(nc_file, y_var_name, y_var_id))
                    else if (num_dims == 2) then
                        z_var_name = var_name
                        z_dim_ids = dim_ids
                        call check_netcdf_error(nf90_inq_varid(nc_file, z_var_name, z_var_id))
                    end if

                end do
                if (z_var_id == -1) then
                    stop "Unable to find topography data!"
                end if

                ! Load in data
                ! TODO: Provide striding into data if need be
                
                ! only try to access data if theres overlap with the domain
                if ((mx > 0) .and. (my > 0)) then
                    if (z_dim_ids(1) == x_dim_id) then
                        allocate(nc_buffer(mx, my))
                    else if (z_dim_ids(1) == y_dim_id) then
                        allocate(nc_buffer(my, mx))
                    else 
                        stop " NetCDF z variable has dimensions that don't align with x and y"
                    end if

                    call check_netcdf_error(nf90_get_var(nc_file, z_var_id, nc_buffer, &
                                                start = (/ xstart(1), ystart(1) /), &
                                                count = (/ mx, my /)))

                    ! check for lon/lat ordering of z variable
                    if (z_dim_ids(1) == x_dim_id) then
                        do j = 0, int(my, 8) - 1
                            topo(j * int(mx, 8) + 1:(j + 1) * int(mx, 8)) = nc_buffer(:, my - j)
                        end do
                    else if (z_dim_ids(1) == y_dim_id) then
                        do j = 0, int(my, 8) - 1
                            topo(j * int(mx, 8) + 1:(j + 1) * int(mx, 8)) = nc_buffer(my - j, :)
                        end do
                    end if
                    deallocate(nc_buffer)

                    ! do j=1, my
                    !     i = i - 1
                    !     topo((i - 1) * mx + 1:)
                    ! print *, mx, my
                    ! do j=1, my
                    !     row_index = row_index - 1
                    !     print *, row_index
                    !     print *, (row_index-1)*mx + 1, (row_index-1)*mx + mx
                    !     ! call check_netcdf_error(nf90_get_var(nc_file, z_var_id,    &
                    !             ! topo))
                    !     ! call check_netcdf_error(nf90_get_var(nc_file, z_var_id,  &
                    !     !       topo((row_index-1)*mx + 1:(row_index-1)*mx + mx),  &
                    !     !                 start = (/ 1, j /), count=(/ mx, 1 /)))
                    !     call check_netcdf_error(nf90_get_var(nc_file, z_var_id,  &
                    !           nc_buffer, start = (/ 1, j /), count=(/ mx, 1 /)))
                    !     topo((row_index - 1) * mx + 1:(row_index - 1) * mx + mx) = &
                    !             nc_buffer
                    ! end do

                    ! Check if the topography was defined positive down and flip the
                    ! sign if need be.  Just in case this is true but topo_type < 0
                    ! we do not do anything here on this to avoid doing it twice.
                    ios = nf90_get_att(nc_file, z_var_id, 'positive', direction)
                    call check_netcdf_error(nf90_close(nc_file))
                    if (ios == NF90_NOERR) then
                        if (to_lower(direction) == "down") then
                            if (topo_type < 0) then
                                topo = -topo
                            endif
                        end if
                    end if
                end if
#else
                print *, "ERROR:  NetCDF library was not included in this build"
                print *, "  of GeoClaw."
                stop
#endif
        end select

        ! Handle negative topo types
        if (topo_type < 0) then
            forall(i=1:mtot)
                topo(i) = -topo(i)
            end forall
        endif

        ! ====================================================================
        ! when topo_type=1 and data has x,y,z columns,
        ! set maketype2 to true to create a file new.topo_type2 with only z
        ! values, so next time it will take less time to read in.
        ! only works if dx = dy.
        ! Currently we don't have the right info in this routine to do this
!         if ((topo_type == 1).and.maketype2) then
!             open(unit=29,file='new.tt2',status='unknown',form='formatted')
!             write(29,*) mx, '       mx'
!             write(29,*) my, '       my'
!             write(29,*) xll, '     xllcorner'
!             write(29,*) yll, '     yllcorner'
!             write(29,*) dx, '     cellsize'
!             write(29,*) -9999, '     nodataval'
!             do i=topo_start,itopo
!                 write(29,'(d18.8)') topowork(i)
!             enddo
!             close(unit=29)
!             print *, 'New topo file new.tt2 created'
!             if (dx.ne.dy) then
!                 print *,  ' ** Warning, dx must equal dy for this'
!                 print *,  ' dx = ',dx,'  dy = ',dy
!             endif
!         endif
        ! ====================================================================

    end subroutine read_topo_file

    ! ========================================================================
    ! subroutine read_topo_header(fname,topo_type,mx,my,xll,yll,xhi,yhi,dx,dy)
    ! ========================================================================
    !  Read topo file header to determine space needed in allocatable array
    !
    !  :Input:
    !   - fname - (char) Name of file
    !   - topo_type - (int) Type of topography file (-3 < topo_type < 3)
    !
    !  :Output:
    !   - mx,my - (int) Number of grid points
    !   - xll,yll,xhi,yhi - (float) Lower and upper coordinates for grid
    !   - dx,dy - (float) Spatial resolution of grid
    ! ========================================================================
    subroutine read_topo_header(fname,topo_type,mx,my,xll,yll,xhi,yhi,dx,dy)
#ifdef NETCDF
        use netcdf
#endif

        use geoclaw_module
        use utility_module, only: parse_values, to_lower

        implicit none

        ! Input and Output
        character(len=150), intent(in) :: fname
        integer, intent(in) :: topo_type
        integer, intent(out) :: mx, my
        real(kind=8), intent(out) :: xll, yll, xhi, yhi, dx, dy

        ! Local
        integer, parameter :: iunit = 19
        integer :: topo_size, status, n
        real(kind=8) :: x,y,z,nodata_value
        logical :: found_file
        real(kind=8) :: values(10)
        character(len=80) :: str
        logical :: verbose
        logical :: xll_registered, yll_registered

        ! NetCDF Support
        ! character(len=1) :: axis_string
        ! character(len=6) :: convention_string
        ! integer(kind=4) :: convention_version
        integer(kind=4) :: nc_file
        real(kind=8), allocatable :: xlocs(:),ylocs(:)
        logical, allocatable :: x_in_dom(:),y_in_dom(:)
        integer(kind=4) :: dim_ids(2), num_dims, var_type, num_vars, num_dims_tot
        integer(kind=4), allocatable :: var_ids(:)
        character(len=64) :: var_name, x_var_name, y_var_name, z_var_name
        character(len=64) :: x_dim_name, y_dim_name
        integer(kind=4) :: x_var_id, y_var_id, z_var_id, x_dim_id, y_dim_id

        verbose = .false.

        inquire(file=fname, exist=found_file)
        if (.not. found_file) then
            print *, 'Missing topography file:'
            print *, '   ', fname
            stop
        endif

        select case(abs(topo_type))
            ! ASCII file with 3 columns
            ! determine data size
            case(1)
                open(unit=iunit, file=fname, status='unknown',form='formatted')

                ! Initial size variables
                topo_size = 0
                mx = 0

                ! Read in first values, determines xlow and yhi
                read(iunit,*) xll,yhi
                topo_size = topo_size + 1
                mx = mx + 1

                ! Go through first row figuring out mx, continue to count
                y = yhi
                do while (yhi == y)
                    read(iunit,*) x,y,z
                    topo_size = topo_size + 1
                    mx = mx + 1
                enddo
                mx = mx - 1
                ! Continue to count the rest of the lines
                do
                    read(iunit,fmt=*,iostat=status) x,y,z
                    if (status /= 0) exit
                    topo_size = topo_size + 1
                enddo
                if (status > 0) then
                    print *,"ERROR:  Error reading header of topography file ",fname
                    stop
                endif

                ! Calculate remaining values
                my = topo_size / mx
                xhi = x
                yll = y
                dx = (xhi-xll) / (mx-1)
                dy = (yhi-yll) / (my-1)

            ! ASCII file with header followed by z data
            case(2:3)
                open(unit=iunit, file=fname, status='unknown',form='formatted')
                read(iunit,'(a)') str
                call parse_values(str, n, values)
                mx = nint(values(1))

                read(iunit,'(a)') str
                call parse_values(str, n, values)
                my = nint(values(1))

                read(iunit,'(a)') str
                call parse_values(str, n, values)
                xll = values(1)
                str = to_lower(str)  ! convert to lower case
                xll_registered = (index(str, 'xllcorner') > 0)

                read(iunit,'(a)') str
                call parse_values(str, n, values)
                yll = values(1)
                str = to_lower(str)  ! convert to lower case
                yll_registered = (index(str, 'yllcorner') > 0)

                read(iunit,'(a)') str
                call parse_values(str, n, values)
                dx = values(1)
                if (n == 2) then
                    dy = values(2)
                  else
                    dy = dx
                  endif

                read(iunit,'(a)') str
                call parse_values(str, n, values)
                nodata_value = values(1)

                if (xll_registered) then
                    xll = xll + 0.5d0*dx
                    write(6,*) '*** in file: ',trim(fname)
                    write(6,*) '    Shifting xllcorner by 0.5*dx to cell center'
                    endif 

                if (yll_registered) then
                    yll = yll + 0.5d0*dy
                    write(6,*) '*** in file: ',trim(fname)
                    write(6,*) '    Shifting yllcorner by 0.5*dy to cell center'
                    endif 


                xhi = xll + (mx-1)*dx
                yhi = yll + (my-1)*dy
                
            ! NetCDF
            case(4)
#ifdef NETCDF

                ! Open file    
                call check_netcdf_error(nf90_open(fname, nf90_nowrite, nc_file))

                ! NetCDF4 GEBCO topography, should conform to CF metadata
                ! standard
                ! ios = nf90_get_att(nc_file, NF90_GLOBAL, 'Conventions', convention_string)
                ! if (verbose) then
                    ! print *, convention_string
                ! end if
                ! if (ios /= NF90_NOERR .or. convention_string(1:3) /= "CF-") then
                !     print *, "Topography file does not conform to the CF"
                !     print *, "conventions and meta-data.  Please see the"
                !     print *, "information at "
                !     print *, ""
                !     print *, "    cfconventions.org"
                !     print *, ""
                !     print *, "to find out more info."
                !     stop
                ! end if

                ! call parse_values(convention_string(4:6), num_values, convention_version)
                ! if (convention_version(1) < CONVENTION_REQUIREMENT) then
                !     print *, "Topography file conforms to a CF version that"
                !     print *, "is too old (", convention_version, ").  "
                !     print *, "Please refer to"
                !     print *, ""
                !     print *, "    cfconventions.org"
                !     print *, ""
                !     print *, "to find out more info."
                !     stop
                ! end if

                ! get x and y dimension info
                call check_netcdf_error(nf90_inquire(nc_file, num_dims_tot, &
                    num_vars))
                call get_dim_info(nc_file, num_dims_tot, x_dim_id, x_dim_name, &
                    mx, y_dim_id, y_dim_name, my)
                
                ! allocate vector to hold lon and lat vals and vector for var ids
                allocate(xlocs(mx),ylocs(my),x_in_dom(mx),y_in_dom(my),var_ids(num_vars))

                if (verbose) then
                    print *, "Names = (", x_dim_name, ", ", y_dim_name, ")"
                    print *, "Size = (", mx, ", ", my, ")"
                end if

                ! Read in variables
                call check_netcdf_error(nf90_inq_varids(nc_file, num_vars, var_ids))
                if (verbose) then
                    print *, "n, var_name, var_type, num_dims, dim_ids"
                end if

                do n=1, num_vars
                    call check_netcdf_error(nf90_inquire_variable(nc_file, n, var_name, var_type, num_dims, dim_ids))
                    if (verbose) then
                        print *, n, ": ", var_name, "|", var_type, "|", num_dims, "|", dim_ids
                    end if

                    ! Assume dim names are same as var ids
                    if (var_name == x_dim_name) then
                        x_var_name = var_name
                        call check_netcdf_error(nf90_inq_varid(nc_file, x_var_name, x_var_id))
                        ! x_var_id = n
                        ! x_var_name = var_name
                    else if (var_name == y_dim_name) then
                        y_var_name = var_name
                        call check_netcdf_error(nf90_inq_varid(nc_file, y_var_name, y_var_id))
                        ! y_var_id = n
                        ! y_var_name = var_name
                    ! Assume that this is the topography data
                    else if (num_dims == 2) then
                        z_var_name = var_name
                        call check_netcdf_error(nf90_inq_varid(nc_file, z_var_name, z_var_id))
                        ! z_var_id = n
                        ! z_var_name = var_name
                    else
                        if (verbose) then
                            print *, "Not using var_id ", n
                        end if
                    end if

                end do

                if (verbose) then
                    print *, "x_var_name, x_var_id = ", x_var_name, x_var_id
                    print *, "y_var_name, y_var_id = ", y_var_name, y_var_id
                    print *, "z_var_name, z_var_id = ", z_var_name, z_var_id
                end if

                call check_netcdf_error(nf90_get_var(nc_file, x_var_id, xlocs, start=(/ 1 /), count=(/ mx /)))
                call check_netcdf_error(nf90_get_var(nc_file, y_var_id, ylocs, start=(/ 1 /), count=(/ my /)))
                
                dx = xlocs(2) - xlocs(1)
                dy = ylocs(2) - ylocs(1)
                
                ! find which locs are within domain (with a dx/dy buffer around domain + ghost cells)
                x_in_dom = (xlocs.gt.(xlower-dx-hxposs(1)*nghost)) .and. (xlocs.lt.(xupper+dx+hxposs(1)*nghost))
                y_in_dom = (ylocs.gt.(ylower-dy-hyposs(1)*nghost)) .and. (ylocs.lt.(yupper+dy+hyposs(1)*nghost))
                
                xll = minval(xlocs, mask=x_in_dom)
                yll = minval(ylocs, mask=y_in_dom)
                xhi = maxval(xlocs, mask=x_in_dom)
                yhi = maxval(ylocs, mask=y_in_dom)
                
                ! adjust mx, my
                mx = count(x_in_dom)
                my = count(y_in_dom)

                call check_netcdf_error(nf90_close(nc_file))
                deallocate(xlocs,ylocs,x_in_dom,y_in_dom)
#else
                print *, "ERROR:  NetCDF library was not included in this build"
                print *, "  of GeoClaw."
                stop
#endif

            case default
                print *, 'ERROR:  Unrecognized topo_type'
                print *, '    topo_type = ',topo_type
                print *, '  for topography file:'
                print *, '   ', fname
                stop
        end select

        close(iunit)
        write(GEO_PARM_UNIT,*) '  mx = ',mx,'  x = (',xll,',',xhi,')'
        write(GEO_PARM_UNIT,*) '  my = ',my,'  y = (',yll,',',yhi,')'
        write(GEO_PARM_UNIT,*) '  dx, dy (meters/degrees) = ', dx,dy

    end subroutine read_topo_header

    real(kind=8) pure function test_topo(x) result(topography)

        implicit none

        ! Arguments
        real(kind=8), intent(in) :: x

        if (test_topography == 1) then
            if (x < topo_location) then
                topography = topo_left
            else
                topography = topo_right
            endif
        else if (test_topography == 2) then
            if (x < topo_x0) then
                topography = topo_basin_depth
            else if (topo_x0 <= x .and. x < topo_x1) then
                topography = topo_shelf_slope * (x-topo_x0) + topo_basin_depth
            else if (topo_x1 <= x .and. x < topo_x2) then
                topography = topo_shelf_depth
            else
                topography = topo_beach_slope * (x-topo_x2) + topo_shelf_depth
            endif
        endif

    end function test_topo


    ! ========================================================================
    !  set_dtopo(fname)
    ! ========================================================================
    ! Read moving topography info from setdtopo.data
    ! Time-dependend topography is used to initiate tsunami, for example.
    !
    ! If num_dtopo = 0, no movement of topography specified.
    !
    ! If num_dtopo = 1, the topo changes dynamically.
    ! the topofile can then be formated in the following ways
    ! dtopotype > 1: file contains a header, with a line for each record
    ! my; mx; mt; xlower; ylower; t0; dx; dy; dt;
    ! dtopotype = 1:
    ! Then the dtopofile should have 4 columns:
    ! time,longitude,latitude,vertical displacement(m) since t0
    !
    ! Longitude and latitude advance in the standard GIS way from
    ! upper left corner across in x and then down in y.
    ! Time column advances most slowly.
    ! ========================================================================
    subroutine read_dtopo_settings(file_name)

        use geoclaw_module

        implicit none

        ! Input arguments
        character (len=25), optional, intent(in) :: file_name

        ! Locals
        integer, parameter :: iunit = 79
        integer :: finer_than,rank
        real(kind=8) :: area_i,area_j
        integer :: i,j

        write(GEO_PARM_UNIT,*) ' '
        write(GEO_PARM_UNIT,*) '--------------------------------------------'
        write(GEO_PARM_UNIT,*) 'SETDTOPO:'
        write(GEO_PARM_UNIT,*) '-------------'

        if (present(file_name)) then
            call opendatafile(iunit,file_name)
        else
            call opendatafile(iunit,'dtopo.data')
        endif

        read(iunit,*) num_dtopo
        write(GEO_PARM_UNIT,*) '   num dtopo files = ',num_dtopo
        if (num_dtopo == 0) then
            return
        endif

        ! Allocate and read in dtopo info
        allocate(dtopofname(num_dtopo))
        allocate(mxdtopo(num_dtopo))
        allocate(mydtopo(num_dtopo),mtdtopo(num_dtopo),mdtopo(num_dtopo))
        allocate(xlowdtopo(num_dtopo),ylowdtopo(num_dtopo),t0dtopo(num_dtopo))
        allocate(xhidtopo(num_dtopo),yhidtopo(num_dtopo),tfdtopo(num_dtopo))
        allocate(dtopotype(num_dtopo),i0dtopo(num_dtopo))
        allocate(dxdtopo(num_dtopo),dydtopo(num_dtopo),dtdtopo(num_dtopo))
        allocate(kdtopo1(num_dtopo),kdtopo2(num_dtopo))
        allocate(index0_dtopowork1(num_dtopo),index0_dtopowork2(num_dtopo))
        allocate(tdtopo1(num_dtopo),tdtopo2(num_dtopo),taudtopo(num_dtopo))
        allocate(mdtopoorder(num_dtopo),topoaltered(num_dtopo))

        do i=1,num_dtopo
            read(iunit,*) dtopofname(i)
            read(iunit,*) dtopotype(i)
            write(GEO_PARM_UNIT,*) '   fname:',dtopofname(i)
            write(GEO_PARM_UNIT,*) '   topo type:',dtopotype(i)

            ! Read in header data
            call read_dtopo_header(dtopofname(i),dtopotype(i),mxdtopo(i), &
                mydtopo(i),mtdtopo(i),xlowdtopo(i),ylowdtopo(i),t0dtopo(i), &
                xhidtopo(i),yhidtopo(i),tfdtopo(i),dxdtopo(i),dydtopo(i), &
                dtdtopo(i))
            mdtopo(i) = mxdtopo(i) * mydtopo(i) * mtdtopo(i)
        enddo

        read(iunit,*) dt_max_dtopo  
        !  largest allowable dt while dtopo is moving


        ! Indexing into work array
        i0dtopo(1) = 1
        if (num_dtopo > 1) then
            do i=2,num_dtopo
                i0dtopo(i) = i0dtopo(i-1) + mdtopo(i-1)
            enddo
        endif

            ! dtopo order..for updating topo from finest dtopo model
            ! The finest topography will be given priority in any region
            ! mtopoorder(rank) = i means that i'th topography file has rank rank,
            ! where the file with rank=1 is the finest and considered first.
            do i=1,num_dtopo
                finer_than = 0
                do j=1,num_dtopo
                    if (j /= i) then
                        area_i=dxdtopo(i)*dydtopo(i)
                        area_j=dxdtopo(j)*dydtopo(j)
                        if (area_i < area_j) finer_than = finer_than + 1
                        ! if two files have the same resolution, order is
                        ! arbitrarily chosen
                        if ((area_i == area_j).and.(j < i)) then
                            finer_than = finer_than + 1
                        endif
                    endif
                enddo
                ! ifinerthan tells how many other files, file i is finer than
                rank = num_dtopo - finer_than
                mdtopoorder(rank) = i
            enddo

        ! Allocate and read dtopo files
        allocate(dtopowork(sum(mdtopo)))

        do i=1,num_dtopo
            call read_dtopo(mxdtopo(i),mydtopo(i),mtdtopo(i),dtopotype(i), &
                dtopofname(i),dtopowork(i0dtopo(i):i0dtopo(i)+mdtopo(i)-1))
        enddo

    end subroutine read_dtopo_settings
    ! ========================================================================

    ! ========================================================================
    !  read_dtopo(fname)
    ! ========================================================================
    subroutine read_dtopo(mx,my,mt,dtopo_type,fname,dtopo)

      implicit none

      ! Arguments
      integer, intent(in) :: mx,my,mt,dtopo_type
      character (len=150), intent(in) :: fname
      real(kind=8), intent(inout) :: dtopo(1:int(mx, 8)*int(my, 8)*int(mt, 8))

      ! Local
      integer, parameter :: iunit = 29
      integer :: status
      real(kind=8) :: t,x,y
      integer(kind=8) :: i, j, k, mtot

      mtot = int(mx, 8) * int(my, 8)

      open(unit=iunit, file=fname, status = 'unknown',form='formatted')

      select case(abs(dtopo_type))
         case(1)
            ! ASCII file with 4 columns
            do i = 1,mtot*mt
               read(iunit,fmt=*,iostat=status) t,x,y, dtopo(i)
            enddo

         case(2)
            ! read header
            do i = 1,9
               read(iunit,*)
            enddo
            ! read the data
            do i = 1,mtot*mt
               read(iunit,*) dtopo(i)
            enddo
         case(3)
            ! read header
            do i = 1,9
               read(iunit,*)
            enddo
            do k = 1,int(mt, 8)
               do j = 1,int(my, 8)
                  read(iunit,*) (dtopo((k-1)*mtot + (j-1)*int(mx, 8) + i) , i=1,int(mx, 8))
               enddo
            enddo
      end select

    end subroutine read_dtopo

    ! ========================================================================
    !  subroutine read_dtopo_header(fname,topo_type,mx,my,mt,xlow,ylow,t0,xhi,
    !                               yhi,tf,dx,dy,dt)
    ! ========================================================================

    !  Read in dtopo file header and either read or calculate the grid info
    !
    !  :Input:
    !   - fname - (char) Name of the dtopo file
    !   - topo_type - (int) Topography file type (1-3 are valid)
    !
    !  :Output:
    !   - mx,my,mt - (int) Number of grid point in space (mx,my) and time (mt)
    !   - xlow,ylow - (dp) Lower corner spatial coordinate of grid
    !   - xhi,yhi - (dp) Upper corner spatial coodinate of grid
    !   - t0,tf - (dp) Beginning and end times for the file
    !   - dx,dy,dt - (dp) Distance between space (dx,dy) and time (dt) points
    ! ========================================================================
    subroutine read_dtopo_header(fname,topo_type,mx,my,mt,xlow,ylow,t0,xhi, &
        yhi,tf,dx,dy,dt)

        implicit none

        ! Input Arguments
        character (len=150), intent(in) :: fname
        integer, intent(in) :: topo_type

        ! Output Arguments
        integer, intent(out) :: mx,my,mt
        real(kind=8), intent(out) :: xlow,ylow,t0,xhi,yhi,tf,dx,dy,dt

        ! Locals
        integer, parameter :: iunit = 7
        integer :: topo_size,status
        real(kind=8) :: x,y,t,y_old
        logical :: found_file

        ! Open file
        inquire(file=fname,exist=found_file)
        if (.not.found_file) then
            print *, 'Missing dtopo file:'
            print *, '    ', fname
            stop
        endif
        open(unit=iunit,file=fname,status='unknown',form='formatted')

        select case(topo_type)
            ! Old style ASCII dtopo files
            case(1)
                ! Initial size variables
                topo_size = 0
                my = 1
                mt = 1

                ! Read in first values, determines xlow, yhi and t0
                read(iunit,*) t0,xlow,yhi
                topo_size = topo_size + 1
                t = t0
                y_old = yhi
                ! Go through entire file figuring out my, mt and topo_size
                status = 0
                do while (status == 0.and. t.eq.t0)
                    read(iunit,fmt=*,iostat=status) t,x,y
                    topo_size = topo_size + 1
                    if (y /= y_old .and. t.eq.t0 ) then
                        my = my + 1
                        y_old = y
                    endif
                enddo
                mx = (topo_size-1)/my
                do while (status == 0)
                    read(iunit,fmt=*,iostat=status) t,x,y
                    topo_size = topo_size + 1
                enddo


                if (status > 0) then
                    print *, "IO error occured in ",fname,", aborting!"
                    stop
                endif

                ! Calculate remaining values
                mt = (topo_size-1)/ (my*mx)
                xhi = x
                ylow = y
                tf = t
                dx = (xhi-xlow) / (mx-1)
                dy = (yhi-ylow) / (my-1)
                dt = (tf - t0) / (mt-1)

            ! New ASCII headered dtopo files, similar to topography files type
            ! 2 and 3
            case(2:3)
                ! Read in header directly
                read(iunit,*) mx
                read(iunit,*) my
                read(iunit,*) mt
                read(iunit,*) xlow
                read(iunit,*) ylow
                read(iunit,*) t0
                read(iunit,*) dx
                read(iunit,*) dy
                read(iunit,*) dt

                xhi = xlow + dx*(mx-1)
                yhi = ylow + dy*(my-1)
                tf = t0 + dt*(mt-1)
            case default
                print *, 'ERROR:  Unrecognized topography type'
                print *, '    topo_type = ',topo_type
                print *, '  for dtopo file:'
                print *, '   ', fname
                stop
        end select

         close(iunit)
    end subroutine read_dtopo_header


    

recursive subroutine topoarea(x1,x2,y1,y2,m,area)

    ! Compute the area of overlap of topo with the rectangle (x1,x2) x (y1,y2)
    ! using topo arrays indexed mtopoorder(mtopofiles) through mtopoorder(m) 
    ! (coarse to fine).

    ! The main call to this subroutine has corners of a physical domain for
    ! the rectangle and m = 1 in order to compute the area of overlap of
    ! domain by all topo arrays.  Used to check inputs and insure topo
    ! covers domain.

    ! The recursive strategy is to first compute the area using only topo 
    ! arrays mtopoorder(mtopofiles) to mtopoorder(m+1), 
    ! and then apply corrections due to adding topo array mtopoorder(m).
     
    ! Corrections are needed if the new topo array intersects the grid cell.
    ! Let the intersection be (x1m,x2m) x (y1m,y2m).
    ! Two corrections are needed, first to subtract out the area over
    ! the rectangle (x1m,x2m) x (y1m,y2m) computed using
    ! topo arrays mtopoorder(mtopofiles) to mtopoorder(m+1),
    ! and then adding in the area over this same region using 
    ! topo array mtopoorder(m).

    ! Based on the recursive routine rectintegral that integrates
    ! topo over grid cells using a similar strategy.

    implicit none

    ! arguments
    real (kind=8), intent(in) :: x1,x2,y1,y2
    integer, intent(in) :: m
    real (kind=8), intent(out) :: area

    ! local
    real(kind=8) :: xmlo,xmhi,ymlo,ymhi,x1m,x2m, &
        y1m,y2m, area1,area2,area_m
    integer :: mfid, indicator
    integer(kind=8) :: i0
    real(kind=8), external :: topointegral  


    mfid = mtopoorder(m)
    i0=i0topo(mfid)

    if (m == mtopofiles) then
         ! innermost step of recursion reaches this point.
         ! only using coarsest topo grid -- compute directly...
         call intersection(indicator,area,xmlo,xmhi, &
             ymlo,ymhi, x1,x2,y1,y2, &
             xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))

    else
        ! recursive call to compute area using one fewer topo grids:
        call topoarea(x1,x2,y1,y2,m+1,area1)

        ! region of intersection of cell with new topo grid:
        call intersection(indicator,area_m,x1m,x2m, &
             y1m,y2m, x1,x2,y1,y2, &
             xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))

        
        if (area_m > 0) then
        
            ! correction to subtract out from previous set of topo grids:
            call topoarea(x1m,x2m,y1m,y2m,m+1,area2)
    
            ! adjust integral due to corrections for new topo grid:
            area = area1 - area2 + area_m
        else
            area = area1
        endif
    endif

end subroutine topoarea

    

recursive subroutine rectintegral(x1,x2,y1,y2,m,integral)

    ! Compute the integral of topo over the rectangle (x1,x2) x (y1,y2)
    ! using topo arrays indexed mtopoorder(mtopofiles) through mtopoorder(m) 
    ! (coarse to fine).

    ! The main call to this subroutine has corners of a grid cell for the 
    ! rectangle and m = 1 in order to compute the integral over the cell 
    ! using all topo arrays.

    ! The recursive strategy is to first compute the integral using only topo 
    ! arrays mtopoorder(mtopofiles) to mtopoorder(m+1), 
    ! and then apply corrections due to adding topo array mtopoorder(m).
     
    ! Corrections are needed if the new topo array intersects the grid cell.
    ! Let the intersection be (x1m,x2m) x (y1m,y2m).
    ! Two corrections are needed, first to subtract out the integral over
    ! the rectangle (x1m,x2m) x (y1m,y2m) computed using
    ! topo arrays mtopoorder(mtopofiles) to mtopoorder(m+1),
    ! and then adding in the integral over this same region using 
    ! topo array mtopoorder(m).

    ! Note that the function topointegral returns the integral over the 
    ! rectangle based on a single topo array, and that routine calls
    ! bilinearintegral.


    implicit none

    ! arguments
    real (kind=8), intent(in) :: x1,x2,y1,y2
    integer, intent(in) :: m
    real (kind=8), intent(out) :: integral

    ! local
    real(kind=8) :: xmlo,xmhi,ymlo,ymhi,area,x1m,x2m, &
        y1m,y2m, int1,int2,int3
    integer :: mfid, indicator
    integer(kind=8) :: i0
    real(kind=8), external :: topointegral  


    mfid = mtopoorder(m)
    i0=i0topo(mfid)

    if (m == mtopofiles) then
         ! innermost step of recursion reaches this point.
         ! only using coarsest topo grid -- compute directly...
         call intersection(indicator,area,xmlo,xmhi, &
             ymlo,ymhi, x1,x2,y1,y2, &
             xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))

         if (indicator.eq.1) then
            ! cell overlaps the file
            ! integrate surface over intersection of grid and cell
            integral = topointegral( xmlo,xmhi,ymlo, &
                    ymhi,xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid), &
                    dytopo(mfid),mxtopo(mfid),mytopo(mfid),topowork(i0),1)
         else
            integral = 0.d0
         endif

    else
        ! recursive call to compute area using one fewer topo grids:
        call rectintegral(x1,x2,y1,y2,m+1,int1)

        ! region of intersection of cell with new topo grid:
        call intersection(indicator,area,x1m,x2m, &
             y1m,y2m, x1,x2,y1,y2, &
             xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))

        
        if (area > 0) then
        
            ! correction to subtract out from previous set of topo grids:
            call rectintegral(x1m,x2m,y1m,y2m,m+1,int2)
    
            ! correction to add in for new topo grid:
            int3 = topointegral(x1m,x2m, y1m,y2m, &
                        xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid), &
                        dytopo(mfid),mxtopo(mfid),mytopo(mfid),topowork(i0),1)
    
            ! adjust integral due to corrections for new topo grid:
            integral = int1 - int2 + int3
        else
            integral = int1
        endif
    endif

end subroutine rectintegral

    

subroutine intersection(indicator,area,xintlo,xinthi, &
           yintlo,yinthi,x1lo,x1hi,y1lo,y1hi,x2lo,x2hi,y2lo,y2hi)

    ! find the intersection of two rectangles, return the intersection
    ! and it's area, and indicator =1
    ! if there is no intersection, indicator =0

      implicit none

      integer, intent(out) :: indicator

      real(kind=8), intent(in) ::  x1lo,x1hi,y1lo,y1hi,x2lo,x2hi,y2lo,y2hi
      real(kind=8), intent(out) :: area,xintlo,xinthi,yintlo,yinthi

      xintlo=dmax1(x1lo,x2lo)
      xinthi=dmin1(x1hi,x2hi)
      yintlo=dmax1(y1lo,y2lo)
      yinthi=dmin1(y1hi,y2hi)


      if (xinthi.gt.xintlo.and.yinthi.gt.yintlo) then
         area = (xinthi-xintlo)*(yinthi-yintlo)
         indicator = 1
      else
         area = 0.d0
         indicator = 0
      endif

end subroutine intersection

#ifdef NETCDF
    subroutine check_netcdf_error(ios)

        use netcdf

        implicit none

        integer, intent(in) :: ios

        if (ios /= NF90_NOERR) then
            print *, "NetCDF IO error: ", ios
            print *, trim(nf90_strerror(ios))
            stop
        end if

    end subroutine check_netcdf_error

    subroutine get_dim_info(nc_file, ndims, x_dim_id, x_dim_name, mx, &
        y_dim_id, y_dim_name, my)
        use netcdf
        implicit none
        integer, intent(in) :: nc_file, ndims
        integer, intent(out) :: x_dim_id, y_dim_id, mx, my
        character (len = *), intent(out) :: x_dim_name, y_dim_name
        integer :: m_tmp, n
        character(20) :: dim_name_tmp

        ! get indices to start at for reading netcdf within domain
        do n=1, ndims
            call check_netcdf_error(nf90_inquire_dimension(nc_file, &
                n, dim_name_tmp, m_tmp))
            if (ANY((/ 'LON      ','LONGITUDE','X        ' /) == Upper(dim_name_tmp))) then
                x_dim_name = dim_name_tmp
                mx = m_tmp
                x_dim_id = n
            else if (ANY((/ 'LAT     ','LATITUDE','Y       ' /) == Upper(dim_name_tmp))) then
                y_dim_name = dim_name_tmp
                my = m_tmp
                y_dim_id = n
            end if
        end do
    end subroutine get_dim_info
#endif

function Upper(s1)  RESULT (s2)
    CHARACTER(*)       :: s1
    CHARACTER(LEN(s1)) :: s2
    CHARACTER          :: ch
    INTEGER,PARAMETER  :: DUC = ICHAR('A') - ICHAR('a')
    INTEGER            :: i

    DO i = 1,LEN(s1)
       ch = s1(i:i)
       IF (ch >= 'a'.AND.ch <= 'z') ch = CHAR(ICHAR(ch)+DUC)
       s2(i:i) = ch
    END DO
END function Upper

end module topo_module

c
c
c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,mz, xlower,ylower,zlower,
     &                  dx,dy,dz,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c
       implicit double precision (a-h,o-z)
c
       dimension q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
       dimension x(1-mbc:mx+mbc)
       dimension aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc,1-mbc:mz+mbc)
c
c     # set concentration profile
c     ---------------------------
c

       q(1,:,:,:) = 0.d0

      return
      end

! ============================================================================
!  Program:     AMRClaw
!  File:        resize_nodes.f90
!  Author:      Mandli and Marsha Berger
! ============================================================================
!  Description:  Resize the node space if have run out 
! ============================================================================

subroutine resize_nodes(new_size,status)
    
    use amr_module
    implicit none
    
    integer, intent(out) :: status
    integer, intent(in) :: new_size

    integer :: i
    
    real(kind=8), allocatable, target, dimension(:,:) :: new_rnode
    integer, allocatable, target, dimension(:,:) :: new_node
    integer, allocatable, target, dimension(:) :: new_listOfGrids
    
    print *, "Expanding maximum number of grids from ", maxgr," to ", new_size

    ! first for rnode
    allocate(new_rnode(rsize,new_size),STAT=status)
    if (status > 0) then
        return
    endif
    new_rnode(1:rsize,1:maxgr) = rnode     ! new way, use allocatable, not pointer       

    call move_alloc(new_rnode,rnode)

    ! next for node
    allocate(new_node(nsize,new_size),STAT=status)
    if (status > 0) then
        return
    endif
    new_node(1:nsize,1:maxgr) = node     ! new way, use allocatable, not pointer       

    call move_alloc(new_node,node)

    !! need to rethread new space to be able to use it when new grids requested
    do i = maxgr+1, new_size
       node(nextfree,i) = i+1
    end do
    ! reset last one to null
    node(nextfree, new_size) = null

    ! next for listOfGrids
    allocate(new_listOfGrids(new_size),STAT=status)
    if (status > 0) then
        return
    endif
    new_listOfGrids(1:maxgr) = listOfGrids     ! new way, use allocatable, not pointer       

    call move_alloc(new_listOfGrids,listOfGrids)

    ! reset maxgr and next free node,  to continue
    ndfree = maxgr + 1     
    maxgr = new_size
    
    return
    
end subroutine resize_nodes

c
c  -----------------------------------------------------------
c
      subroutine reclam (index, nwords)
c
c ::::::::::::::::::::::::: RECLAM :::::::::::::::::::::::::::
c
c  return of space. add to free list.
c  iplace points to next item on free list with larger index than
c  the item reclaiming, unless said item is greater then
c  everything on the list.
c
c ::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::::
c
      use amr_module
      implicit double precision (a-h,o-z)


!$OMP CRITICAL (MemMgmt)

c
      do 20 i = 1, lenf
      iplace  = i
      if (lfree(i,1) .gt. index) go to 30
 20   continue
         write(outunit,902)
         write(*,902)
 902     format(' no insertion pointer into freelist. error stop')
         stop
c
c  check previous segment for merging
c
 30      iprev = iplace - 1
         if (lfree(iprev,1)+lfree(iprev,2) .lt. index) go to 40
         lfree(iprev,2) = lfree(iprev,2) + nwords
         go to 50
c
c  check after segment - no previous merge case
c
 40   nexti = index + nwords
      if (lfree(iplace,1).ne. nexti) go to 70
         lfree(iplace,1) = index
         lfree(iplace,2) = lfree(iplace,2) + nwords
         go to 99
c
c  check following segment - yes previous merge case
c
 50   nexti = index + nwords
      if (lfree(iplace,1) .ne. nexti) go to 99
c
c forward merge as well, bump all down 1
c
      lfree(iprev,2) = lfree(iprev,2)+lfree(iplace,2)
      ipp1           = iplace + 1
         do 60 i = ipp1, lenf
         lfree(i-1,1) = lfree(i,1)
 60      lfree(i-1,2) = lfree(i,2)
         lenf = lenf - 1
         go to 99
c
c  no merges case - insert and bump future segments up to make room
c
 70   if (lenf .eq. lfdim) go to 900
      do 80 ii = iplace, lenf
      i          = lenf + 1 - ii + iplace
      lfree(i,1) = lfree(i-1,1)
 80   lfree(i,2) = lfree(i-1,2)
      lenf            = lenf + 1
      lfree(iplace,1) = index
      lfree(iplace,2) = nwords
      go to 99
c
 900  write(outunit,901) lfdim
      write(*,901)       lfdim
 901  format('  free list full with ',i5,' items')
      stop
c
 99   lentot = lentot - nwords
      if (sprint) write(outunit,100) nwords, index, lentot
 100  format('     reclaiming ',i8,' words at loc. ',i8,' lentot ',i10)

!$OMP END CRITICAL (MemMgmt)

      return
      end

c
!> Flag a whole subregion from (ixlo,ixhi) to (jxlo, jxhi) with integer
!! 1. 
!! The subregion is inside a grid described by (ilo_coarse, jlo_coarse)
!! and (ihi_coarse, jhi_coarse)
c -------------------------------------------------------------
c
       subroutine coarseGridFlagSet(iflags,ixlo,ixhi,jxlo,jxhi,
     .                              ilo_coarse,ihi_coarse,
     .                              jlo_coarse,jhi_coarse,mbuff)

                                     
       integer*1 iflags(ilo_coarse-mbuff:ihi_coarse+mbuff,
     .                  jlo_coarse-mbuff:jhi_coarse+mbuff)

c
c whole point of this routine is to index using the integer cords, not the
c  way its dimensioned and indexed in the calling routine setdomflags
c
       do j = jxlo,jxhi         
       do i = ixlo,ixhi         
          iflags(i,j) = 1
       end do
       end do

       return
       end

c
c --------------------------------------------------------------------
c
       subroutine intcopy(val,mitot,nvar,ilo,ihi,level,iputst)

      use amr_module
       implicit double precision (a-h, o-z)

       dimension val(nvar,mitot)


c   OLD INDEXING
c      iadd(i,ivar) = loc + i - 1
c   NEW INDEXING ORDER SWITCHED
       iadd(ivar,i) = loc + ivar-1 + nvar*(i-1)

c ::::::::::::::::::::::::::: INTCOPY :::::::::::::::::::::::::::::::
c
c    find intersecting grids at the same level. copy data from
c    old grid to val. 
c    old grid has "nghost" ghost cells - passed in nodal common block.
c    new grid has no ghost cells - indices describe entire patch.
c    iputst: where to copy values into. may not be in
c                    location corresponding to ilo,ihi if
c                    the patch has been periodically wrapped.
c    
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       mptr = lstart(level)

 10    if (mptr .eq. 0) go to 99
          iglo = node(ndilo,mptr)
          ighi = node(ndihi,mptr)

c         # does it intersect?
          ixlo = max(iglo,ilo)
          ixhi = min(ighi,ihi)

          if (ixlo .le. ixhi) then
              loc  = node(store1,mptr)
              nx   = ighi - iglo + 1
              mi   = nx + 2*nghost
              do 20 ivar = 1, nvar
              do 30 i    = ixlo, ixhi
                 val(ivar,iputst+i-ilo) =
     1               alloc(iadd(ivar,i-iglo+nghost+1))
 30           continue
 20           continue
          endif
          mptr = node(levelptr, mptr)
          go to 10

 99   return
      end

! ==============================================================================
! Riemann solver for the acoustics equations in 2d.
!
! waves: 3
! equations: 3
!
! Conserved quantities:
!       1 pressure
!       2 x_velocity
!       3 y_velocity
!
! Note that although there are 3 eigenvectors, the second eigenvalue
! is always zero and so we only need to compute 2 waves.
!
! solve Riemann problems along one slice of data.

! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q
!
! ==============================================================================

subroutine rpn2_ptwise(ixy, num_eqn, num_aux, num_waves, q_l, q_r,            &
                       aux_l, aux_r, wave, s, amdq, apdq)

    implicit none

    ! Input
    integer, intent(in) :: num_eqn, num_aux, num_waves, ixy
    real(kind=8), intent(in) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in) :: aux_l(num_aux), aux_r(num_aux)

    ! Output
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Locals
    integer :: normal_index, transverse_index
    real(kind=8) :: delta(3), a(2)

    ! Common block
    real(kind=8) :: rho, bulk, cc, zz
    common /cparam/ rho, bulk, cc, zz

    if (ixy == 1) then
        normal_index = 2
        transverse_index = 3
    else
        normal_index = 3
        transverse_index = 2
    end if

    ! note that notation for u and v reflects assumption that the
    ! Riemann problems are in the x-direction with u in the normal
    ! direciton and v in the orthogonal direcion, but with the above
    ! definitions of mu and mv the routine also works with ixy=2
    ! in which case waves come from the
    ! Riemann problems u_t + g(u)_y = 0 in the y-direction.


    ! Split the jump in q at each interface into waves
    delta = q_r - q_l
    ! Find coefficients for the 2 eigenvectors:
    a(1) = (-delta(1) + zz * delta(normal_index)) / (2.d0 * zz)
    a(2) = ( delta(1) + zz * delta(normal_index)) / (2.d0 * zz)

    ! Compute waves
    wave(1, 1) = -a(1) * zz
    wave(normal_index, 1) = a(1)
    wave(transverse_index, 1) = 0.d0
    s(1) = -cc

    wave(1, 2) = a(2) * zz
    wave(normal_index, 2) = a(2)
    wave(transverse_index, 2) = 0.d0
    s(2) = cc

    ! Compute the leftgoing and rightgoing flux differences:
    ! Note s(1) < 0   and   s(2) > 0.
    amdq = s(1) * wave(:, 1)
    apdq = s(2) * wave(:, 2)

end subroutine rpn2_ptwise

!
! :::::::::::::::::::::::::: UPDATE :::::::::::::::::::::::::::::::::
! update - update all grids at level 'level'.
!          this routine assumes cell centered variables.
!          the update is done from 1 level finer meshes under it.
! input parameter:
!    level  - ptr to the only level to be updated. levels coarser than
!             this will be at a diffeent time.
! rewritten in July 2016 from the original update.f
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!

subroutine update (level, nvar, naux)

    use geoclaw_module, only: dry_tolerance
    use amr_module
    implicit none
    ! modified for shallow water on topography to use surface level eta
    ! rather than depth h = q(i,j,1) 
    ! eta - q(i,j,1) + aux(i,j,1)

    ! inputs
    integer, intent(in) :: nvar, naux, level
!     real(kind=8), intent(in) :: level

    integer :: ng, levSt, mptr, loc, locaux, nx, ny, mitot, mjtot
    integer :: ilo, jlo, ihi, jhi, mkid, iclo, jclo, ichi, jchi
    integer :: mi, mj, locf, locfaux, iplo, jplo, iphi, jphi
    integer :: iff, jff, nwet, ico, jco, i, j, ivar, loccaux
    integer :: listgrids(numgrids(level)), lget
    real(kind=8) :: dt, totrat, bc, etasum, hsum, husum, hvsum
    real(kind=8) :: hu4sum, hv5sum, hu4f, hv5f, hu4c, hv5c  ! components 4,5
    real(kind=8) :: hf, bf, huf, hvf, etaf, hav, hc, huc, hvc, capa, etaav
    real(kind=8) :: capac
    character(len=80) :: String

    lget = level

    String = "(19h    updating level ,i5)"
    
    if (uprint) then
        write(outunit, String) lget
    endif

    dt = possk(lget)

!$OMP PARALLEL DO PRIVATE(ng,mptr,loc,loccaux,nx,ny,mitot,mjtot, &
!$OMP                    ilo,jlo,ihi,jhi,mkid,iclo,ichi, &
!$OMP                    jclo,jchi,mi,mj,locf,locfaux,iplo,iphi, &
!$OMP                    jplo,jphi,iff,jff,totrat,i,j,ivar,capac, &
!$OMP                    capa,bc,etasum,hsum,husum,hvsum, &
!$OMP                    levSt,ico,jco,hf,bf,huf,hvf, &
!$OMP                    hu4sum, hv5sum, hu4f, hv5f, hu4c, hv5c, &
!$OMP                    etaf,etaav,hav,nwet,hc,huc,hvc, String), &
!$OMP             SHARED(numgrids,listOfGrids,level,intratx,intraty, &
!$OMP                   nghost,uprint,nvar,naux,mcapa,node,listsp, &
!$OMP                   alloc,lstart,dry_tolerance,listStart,lget), &
!$OMP            DEFAULT(none)

    ! need to set up data structure for parallel distribution of grids
    ! call prepgrids(listgrids, numgrids(level), level)

    do ng = 1, numgrids(lget)
        levSt   = listStart(lget)
        mptr    = listOfGrids(levSt+ng-1)
        loc     = node(store1,mptr)
        loccaux = node(storeaux,mptr)
        nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot   = nx + 2*nghost
        mjtot   = ny + 2*nghost
        ilo     = node(ndilo,mptr)
        jlo     = node(ndjlo,mptr)
        ihi     = node(ndihi,mptr)
        jhi     = node(ndjhi,mptr)

        if (node(cfluxptr, mptr) /= 0) then
            call upbnd(alloc(node(cfluxptr,mptr)),alloc(loc),nvar,naux,mitot, &
                    mjtot,listsp(lget),mptr)
        endif

        mkid = lstart(lget+1)
        do while (mkid /= 0)
            iclo   = node(ndilo,mkid)/intratx(lget)
            jclo   = node(ndjlo,mkid)/intraty(lget)
            ichi   = node(ndihi,mkid)/intratx(lget)
            jchi   = node(ndjhi,mkid)/intraty(lget)
            mi      = node(ndihi,mkid)-node(ndilo,mkid) + 1 + 2*nghost
            mj      = node(ndjhi,mkid)-node(ndjlo,mkid) + 1 + 2*nghost
            locf    = node(store1,mkid)
            locfaux = node(storeaux,mkid)

            ! calculate the starting adn ending indices for coarse grid update, if overlap
            iplo = max(ilo,iclo)
            jplo = max(jlo,jclo)
            iphi = min(ihi,ichi)
            jphi = min(jhi,jchi)        

            if (iplo <= iphi .and. jplo <= jphi) then
                !calculate the starting index for the fine grid source pts.
                iff    = iplo*intratx(lget) - node(ndilo,mkid) + nghost + 1
                jff    = jplo*intraty(lget) - node(ndjlo,mkid) + nghost + 1
                totrat = intratx(lget) * intraty(lget)

                do i = iplo-ilo+nghost+1, iphi-ilo+nghost+1
                    do j = jplo-jlo+nghost+1, jphi-jlo+nghost+1
                        if (uprint) then
                            String = "(' updating pt. ',2i4,' of grid ',i3,' using ',2i4,' of grid ',i4)"
                            write(outunit,String) i,j,mptr,iff,jff,mkid                
                            
                            String = "(' old vals: ',4e25.15)"
                            write(outunit,String)(alloc(iadd(ivar,i,j,loc,mitot)),ivar=1,nvar)
                        endif
                        
                        if (mcapa == 0) then
                            capac = 1.0d0
                        else
                            capac = alloc(iaddcaux(i,j,loccaux,mcapa,mitot))
                        endif

                        bc = alloc(iaddctopo(i,j,loccaux,mitot))

                        etasum = 0.d0
                        hsum = 0.d0
                        husum = 0.d0
                        hvsum = 0.d0
                        hu4sum = 0.d0
                        hv5sum = 0.d0

                        nwet = 0

                        do jco = 1, intraty(lget)
                            do ico = 1, intratx(lget)
                                if (mcapa == 0) then
                                    capa = 1.0d0
                                else
                                    capa = alloc(iaddfaux(iff+ico-1,jff+jco-1,locfaux,mcapa,mi))
                                endif

                                hf = alloc(iaddf(1,iff+ico-1,jff+jco-1,locf,mi))*capa 
                                bf = alloc(iaddftopo(iff+ico-1,jff+jco-1,locfaux,mi))*capa
                                huf= alloc(iaddf(2,iff+ico-1,jff+jco-1,locf,mi))*capa 
                                hvf= alloc(iaddf(3,iff+ico-1,jff+jco-1,locf,mi))*capa 

                                if (nvar .eq. 5) then
                                  hu4f= alloc(iaddf(4,iff+ico-1,jff+jco-1,locf,mi))*capa 
                                  hv5f= alloc(iaddf(5,iff+ico-1,jff+jco-1,locf,mi))*capa 
                                endif

                                if (alloc(iaddf(1,iff+ico-1,jff+jco-1,locf,mi)) > dry_tolerance) then
                                    etaf = hf + bf
                                    nwet = nwet + 1
                                else
                                    etaf = 0.d0
                                    huf=0.d0
                                    hvf=0.d0
                                endif

                                hsum   = hsum + hf
                                husum  = husum + huf
                                hvsum  = hvsum + hvf
                                etasum = etasum + etaf     
                                if (nvar .eq. 5) then
                                  hu4sum  = hu4sum + hu4f
                                  hv5sum  = hv5sum + hv5f
                                endif
                            enddo
                        enddo

                        if (nwet > 0) then
                            etaav = etasum/dble(nwet)
                            hav = hsum/dble(nwet)
                            hc = min(hav, (max(etaav-bc*capac, 0.0d0)))

                            ! now hc == min(hav, hc), so can simplify this:
                            !huc = (min(hav, hc) / hsum) * husum
                            !hvc = (min(hav, hc) / hsum) * hvsum

                            huc = (hc / hsum) * husum
                            hvc = (hc / hsum) * hvsum
                            if (nvar .eq. 5) then
                              hu4c = (hc / hsum) * hu4sum
                              hv5c = (hc / hsum) * hv5sum
                            endif
                        else
                            hc = 0.0d0
                            huc = 0.0d0
                            hvc = 0.0d0
                            if (nvar .eq. 5) then
                              hu4c = 0.d0
                              hv5c = 0.d0
                            endif
                        endif

                        alloc(iadd(1,i,j,loc,mitot)) = hc / capac 
                        alloc(iadd(2,i,j,loc,mitot)) = huc / capac 
                        alloc(iadd(3,i,j,loc,mitot)) = hvc / capac 
                        !if (nvar .eq. 5) then
                        if (.false.) then  !! never used, keep coarse for plots
                          alloc(iadd(4,i,j,loc,mitot)) = hu4c / capac 
                          alloc(iadd(5,i,j,loc,mitot)) = hv5c / capac 
                        endif

                        if (uprint) then
                            String = "(' new vals: ',4e25.15)"
                            write(outunit, String)(alloc(iadd(ivar, i, j, loc, mitot)), ivar=1, nvar)
                        endif

                        jff = jff + intraty(lget)
                    enddo

                    iff = iff + intratx(lget)
                    jff = jplo * intraty(lget) - node(ndjlo, mkid) + nghost + 1
                enddo

                
            endif
            mkid = node(levelptr, mkid)

        enddo
        continue
    enddo
!$OMP END PARALLEL DO

    return


contains

    integer pure function iadd(ivar,i,j,loc,mitot)
        integer, intent(in) :: i, j, ivar, loc, mitot
        iadd = loc + ivar-1 + nvar*((j-1)*mitot+i-1)
    end function iadd

    integer pure function iaddf(ivar,i,j,locf,mi)
        integer, intent(in) :: i, j, ivar, locf, mi
        iaddf = locf   + ivar-1 + nvar*((j-1)*mi+i-1)
    end function iaddf

    integer pure function iaddfaux(i,j,locfaux,mcapa,mi)
        integer, intent(in) :: i, j, locfaux, mcapa, mi
        iaddfaux = locfaux + mcapa-1 + naux*((j-1)*mi + (i-1))
    end function iaddfaux

    integer pure function iaddcaux(i,j,loccaux,mcapa,mitot)
        integer, intent(in) :: i, j, loccaux, mcapa, mitot
        iaddcaux = loccaux + mcapa-1 + naux*((j-1)*mitot+(i-1))
    end function iaddcaux

    integer pure function iaddftopo(i,j,locfaux,mi)
        integer, intent(in) :: i, j, locfaux, mi
        iaddftopo = locfaux + naux*((j-1)*mi + (i-1))
    end function iaddftopo

    integer pure function iaddctopo(i,j,loccaux, mitot)
        integer, intent(in) :: i, j, loccaux, mitot
        iaddctopo = loccaux + naux*((j-1)*mitot+(i-1))
    end function iaddctopo


end subroutine

c
!> For a rectangle defined on level **level** and bound by 
!! **ilo**, **ihi**, **jlo**, **jhi**, find intersecting grids at the same level
!! and copy data from intersecting grids to solution and auxiliary variables 
!! on the rectangle, stored in **val** and **aux** arrays.
c --------------------------------------------------------------------
c
       subroutine icall(val,aux,nrow,ncol,nvar,naux,
     .                  ilo,ihi,jlo,jhi,level,iputst,jputst)

       use amr_module
       implicit double precision (a-h, o-z)

       dimension val(nvar,nrow,ncol)
       dimension aux(naux,nrow,ncol)

       logical sticksout


c NEW INDEX ORDERING
       iadd   (ivar,i,j) = loc    + ivar-1 + nvar*((j-1)*mitot+i-1)
       iaddaux(ivar,i,j) = locaux + ivar-1 + naux*((j-1)*mitot+i-1)

c ::::::::::::::::::::::::::: ICALL :::::::::::::::::::::::::::::::
c
c    find intersecting grids at the same level. copy data from
c    intersecting grids to both val and aux arrays.
c
c    use larger definition of grids here - boundary data already in.
c    aux arrays also enlarged size.
c
c    iputst, jputst: where to copy values into. may not be in
c                    location corresponding to ilo,ihi,etc. if
c                    the patch has been periodically wrapped.

c    
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       mptr = lstart(level)

 10    if (mptr .eq. 0) go to 99
          iglo = node(ndilo,mptr) 
          ighi = node(ndihi,mptr) 
          jglo = node(ndjlo,mptr) 
          jghi = node(ndjhi,mptr) 

c         # does it intersect?
c$$$          ixlo = max(iglo-nghost,ilo)
c$$$          ixhi = min(ighi+nghost,ihi)
c$$$          jxlo = max(jglo-nghost,jlo)
c$$$          jxhi = min(jghi+nghost,jhi)
c  how did ghost cells get in the allowable region? They are not filled
c  (since we may be interpolating from newly filled grids, not just grids
c  that have been primed with bcs to be advanced.
          ixlo = max(iglo,ilo)
          ixhi = min(ighi,ihi)
          jxlo = max(jglo,jlo)
          jxhi = min(jghi,jhi)


          if (ixlo .le. ixhi .and. jxlo .le. jxhi) then
              loc  = node(store1,mptr)
              locaux = node(storeaux,mptr)
              nx   = ighi - iglo + 1
              ny   = jghi - jglo + 1
              mitot = nx + 2*nghost
              mjtot = ny + 2*nghost
              do 31 j    = jxlo, jxhi
              do 30 i    = ixlo, ixhi
              do 20 ivar = 1, nvar
                  ialloc  =  iadd(ivar,i-iglo+nghost+1,j-jglo+nghost+1)
                  val(ivar,i-ilo+iputst,j-jlo+jputst)  =  alloc(ialloc)
 20           continue
              do 25 iaux = 1, naux
                  ialloc = iaddaux(iaux,i-iglo+nghost+1,j-jglo+nghost+1)
                  aux(iaux,i-ilo+iputst,j-jlo+jputst)  =  alloc(ialloc)
 25           continue
 30           continue
 31           continue
          endif
          mptr = node(levelptr, mptr)
          go to 10

 99   continue

c   if cells stick out of domain but not periodic then set elsewhere 
c   either setaux  and bc2amr. (called from routine that called this, e.g.
c   saveqc or filval)

        return
        end

! =========================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =========================================================

!     # solve Riemann problems for the 1D Euler equations using Roe's
!     # approximate Riemann solver.

!     # On input, ql contains the state vector at the left edge of each cell
!     #           qr contains the state vector at the right edge of each cell
!     # On output, wave contains the waves,
!     #      the speeds,
!     #            amdq the  left-going flux difference  A^- \Delta q
!     #            apdq the right-going flux difference  A^+ \Delta q

!     # Note that the i'th Riemann problem has left state qr(i-1,:)
!     #                                    and right state ql(i,:)
!     # From the basic clawpack routine step1, rp is called with ql = qr = q.


    implicit none

    integer :: maxm, meqn, mwaves, mbc, mx, imp, ixy, maux
    double precision ::    ql(meqn,   1-mbc:maxm+mbc)
    double precision ::    qr(meqn,   1-mbc:maxm+mbc)
    double precision ::     s(mwaves, 1-mbc:maxm+mbc)
    double precision ::  wave(meqn,   mwaves, 1-mbc:maxm+mbc)
    double precision ::  asdq(meqn,   1-mbc:maxm+mbc)
    double precision ::  bmasdq(meqn, 1-mbc:maxm+mbc)
    double precision ::  bpasdq(meqn, 1-mbc:maxm+mbc)
    double precision ::  aux1(maux,      1-mbc:maxm+mbc)
    double precision ::  aux2(maux,      1-mbc:maxm+mbc)
    double precision ::  aux3(maux,      1-mbc:maxm+mbc)

!     # For Roe solver
    double precision :: rhol, ul, vl, el, cl, pl
    double precision :: rhor, ur, vr, er, cr, pr
    double precision :: u, v, enth, rho, p, e
    double precision :: rhsqrtl, rhsqrtr, rhsq2
    double precision :: uvl, uvr, uv(2)


!     # For mappings
    integer :: meqn2,mwaves2
    parameter(meqn2 = 4, mwaves2 = 3)
    double precision :: ql_state(meqn2), qr_state(meqn2)
    double precision :: q_state(meqn2)
    double precision :: wave_local(mwaves2,meqn2)
    double precision :: s_local(mwaves2), delta(meqn2)
    double precision :: speeds(2,mwaves2)
    double precision :: deltam(meqn2), deltap(meqn2)
    double precision :: area

!     # for mapping
    double precision :: rotm(4), rotp(4), uvm_rot(2),uvp_rot(2)
    integer :: locrot,mcapa,locarea

!     # Miscellaneous
    integer :: i, j, m, mw, i1, ixy1
    logical :: useroe

!     # Problem parameters
    double precision :: gamma, gamma1

    double precision :: dtcom, dxcom, dycom, tcom
    integer :: info

    logical :: in_rpt

    common /cparam/  gamma

    gamma1 = gamma - 1.d0

    useroe = .true.

    call get_aux_locations_t(ixy, mcapa, locrot,locarea)

    do i = 2-mbc,mx+mbc
        i1 = i + imp - 2

        do m = 1,meqn
            ql_state(m) = qr(m,i-1)
            qr_state(m) = ql(m,i)
        enddo

        if (useroe) then
            rhol = ql_state(1)
            rhor = qr_state(1)

            ul = ql_state(2)/rhol
            ur = qr_state(2)/rhor

            vl = ql_state(3)/rhol
            vr = qr_state(3)/rhor

            el = ql_state(4)
            er = qr_state(4)

            uvl = ul*ul + vl*vl
            uvr = ur*ur + vr*vr
            pl = gamma1*(el - 0.5d0*rhol*uvl)
            pr = gamma1*(er - 0.5d0*rhor*uvr)

        !           # Get Roe averaged values
            rhsqrtl = sqrt(rhol)
            rhsqrtr = sqrt(rhor)
            rhsq2 = rhsqrtl + rhsqrtr


            uv(1) = (ul*rhsqrtl + ur*rhsqrtr) / rhsq2
            uv(2) = (vl*rhsqrtl + vr*rhsqrtr) / rhsq2
            enth = ((el + pl)/rhsqrtl + (er + pr)/rhsqrtr)/rhsq2
        else
        !           # This takes the values needed for the Roe matrix from the
        !           # cell centers in either the  left (imp == 1) or the
        !           # right (imp == 2) cell

            do m = 1,meqn
                if (imp == 1) then
                !                 # Left (minus) cell
                    q_state(m) = ql_state(m)
                else
                !                 # Right (plus) cell
                    q_state(m) = qr_state(m)
                endif
            enddo

            rho = q_state(1)
            uv(1) = q_state(2)/rho
            uv(2) = q_state(3)/rho
            e = q_state(4)
            p = gamma1*(e - 0.5d0*rho*(uv(1)**2 + uv(2)**2))
            enth = (e + p)/rho
        endif

        do j = 1,2
            uvm_rot(j) = uv(j)
            uvp_rot(j) = uv(j)
            rotm(j) = aux2(locrot+j-1,i1)
            rotp(j) = aux3(locrot+j-1,i1)
        enddo
        call compute_tangent(rotm)
        call compute_tangent(rotp)

        call rotate2(rotm,uvm_rot)
        call rotate2(rotp,uvp_rot)

        do m = 1,meqn
            deltap(m) = asdq(m,i)
            deltam(m) = asdq(m,i)
        enddo
        call rotate2(rotm,deltam(2))
        call rotate2(rotp,deltap(2))

    !        # ------------------------------------------
    !        # Solve for minus side
    !        # ------------------------------------------
        ixy1 = 1
        call roe_solver(ixy1,uvm_rot,enth,deltam, &
        wave_local,s_local,info)

        if (info /= 0) then
            write(6,*) 'ixy = ', ixy
            write(6,*) 'imp = ', imp
            write(6,*) 'enth = ', enth
            write(6,*) 'Called from rpt2  (A-DQ)'
            write(6,*) ' '
            write(6,'(24A,24A)') '        Left State      ', &
            '       Right State      '
            write(6,'(24A,24A)') '------------------------', &
            '-----------------------'
            do m = 1,meqn
                write(6,'(2E24.16)') ql_state(m), qr_state(m)
            enddo
            write(6,*) ' '
            stop
        endif

        area = aux2(locarea,i1)
        do mw = 1,mwaves
            call rotate2_tr(rotm,wave_local(mw,2))
            speeds(1,mw) = area*min(s_local(mw),0.d0)
        enddo

        do m = 1,meqn
            bmasdq(m,i) = 0.d0
            do mw = 1,mwaves
                bmasdq(m,i) = bmasdq(m,i) + speeds(1,mw)*wave_local(mw,m)
            enddo
        enddo

    !        # ------------------------------------------
    !        # Solve for plus side
    !        # ------------------------------------------
        ixy1 = 1
        call roe_solver(ixy1,uvp_rot,enth,deltap, &
        wave_local,s_local,info)

        if (info /= 0) then
            write(6,*) 'ixy = ', ixy
            write(6,*) 'imp = ', imp
            write(6,*) 'enth = ', enth
            write(6,*) 'Called from rpt2  (A+DQ)'
            write(6,*) ' '
            write(6,'(24A,24A)') '        Left State      ', &
            '       Right State      '
            write(6,'(24A,24A)') '------------------------', &
            '-----------------------'
            do m = 1,meqn
                write(6,'(2E24.16)') ql_state(m), qr_state(m)
            enddo
            write(6,*) ' '
            stop
        endif

        area = aux3(locarea,i1)
        do mw = 1,mwaves
            call rotate2_tr(rotp,wave_local(mw,2))
            speeds(2,mw) = area*max(s_local(mw),0.d0)
        enddo

        do m = 1,meqn
            bpasdq(m,i) = 0.d0
            do mw = 1,mwaves
                bpasdq(m,i) = bpasdq(m,i) + speeds(2,mw)*wave_local(mw,m)
            enddo
        enddo

    enddo !! end of i loop

    return
    end subroutine rpt2

c
c ----------------------------------------------------
c
      subroutine griddomshrink(iflags2,ilo,ihi,mbuff,iflags,
     .                         level)

      use amr_module
      implicit double precision (a-h, o-z)


      integer*1  iflags (ilo-mbuff:ihi+mbuff)
      integer*1  iflags2(ilo-mbuff:ihi+mbuff)
c
c :::::::::::::::::::::::::  GRIDDOMSHRINK ::::::::::::::::::::::::::::
c
c  shrink domain flags one cell for allowable properly nested domain
c  This is needed even for lcheck = lbase. More shrinking needed
c  for finer levels.
c  flags starts in iflags2, should end in iflags array
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
        write(outunit,*)" from griddomshrink: on entry, iflags2"
        write(outunit,100)(iflags2(i),i=ilo-mbuff,ihi+mbuff)
 100    format(80i1)
      endif

c     NB this untagging alg. includes corner cells in determining proper 
c     nesting.  not always nec., or always done
      do 40 i = ilo-mbuff+1,ihi+mbuff-1
         iflags(i) = iflags2(i)
         if (iflags2(i  ) .le. 0 .or.
     1       iflags2(i+1) .le. 0 .or. iflags2(i-1) .le. 0) then
                 iflags(i) = 0
          endif
          iflags(ilo-mbuff) = 0   ! set last border to 0 instead of leaving uninitialized
          iflags(ihi+mbuff) = 0
 40   continue

c  dont need to handle periodicity here.  Setting of initial grid included enough room to shrink 1
c  for proper nesting.  If expand up then will need to add periodic domain flagging

c
c if border of domain touches a physical boundary then set domain in
c ghost cell as well
c
      call setPhysBndryFlags(iflags,ilo,ihi,mbuff,level)

 99   if (dprint) then
        write(outunit,*)" from griddomshrink: on exit, iflags"
        write(outunit,101)(iflags(i),i=ilo-mbuff+1,ihi+mbuff-1)
 101    format(80i1)
      endif

      return
      end

!> When a coarse grid cell is advanced, if it borders a coarse-fine
!! interface, the flux or wave that emits from the interface and goes into the coarse cell 
!! is added to the corresponding location in **node(ffluxptr, mkid)**
!! for conservative fix later, where **mkid** is grid number of the
!! nested fine grid on the other side of that interface. 
!! 
!! 
c ----------------------------------------------------------
c
      subroutine fluxsv(mptr,xfluxm,xfluxp,yfluxm,yfluxp,listbc,
     1                  ndimx,ndimy,nvar,maxsp,dtc,hx,hy)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension xfluxp(nvar,ndimx,ndimy), yfluxp(nvar,ndimx,ndimy)
      dimension xfluxm(nvar,ndimx,ndimy), yfluxm(nvar,ndimx,ndimy)
      !dimension listbc(5,maxsp)
      double precision listbc(5,maxsp)
c
c :::::::::::::::::::: FLUXSV :::::::::::::::::::::::::
c
c  coarse grids should save their fluxes in cells adjacent to
c  their nested fine grids, for later conservation fixing.
c  listbc holds info for where to save which fluxes.
c  xflux holds 'f' fluxes, yflux holds 'g' fluxes.
c
c :::::::::::::::::::::::::::::;:::::::::::::::::::::::
 
 
      ispot   = 1
      level   = node(nestlevel,mptr)

 10      if (listbc(1,ispot).eq.0) go to 99          
c
         mkid     = listbc(4,ispot)
         intopl   = listbc(5,ispot)
         nx       = node(ndihi,mkid) - node(ndilo,mkid) + 1
         ny       = node(ndjhi,mkid) - node(ndjlo,mkid) + 1
         kidlst   = node(ffluxptr,mkid)
         i        = listbc(1,ispot)
         j        = listbc(2,ispot)
         inlist   = kidlst + nvar*(intopl-1) - 1
c
c side k (listbc 3) has which side of coarse cell has interface
c so can save appropriate fluxes.  (dont know why we didnt have
c which flux to save directly (i.e. put i+1,j to save that flux
c rather than putting in cell center coords).

         if (listbc(3,ispot) .eq. 1) then
c           ::::: Cell i,j is on right side of a fine grid
            do 100 ivar = 1, nvar
               alloc(inlist + ivar) = -xfluxp(ivar,i,j)*dtc*hy
100         continue
c         write(dbugunit,901) i,j,1,(xfluxp(ivar,i,j),ivar=1,nvar)
         endif

         if (listbc(3,ispot) .eq. 2) then
c           ::::: Cell i,j on bottom side of fine grid
            do 200 ivar = 1, nvar
               alloc(inlist + ivar) = -yfluxm(ivar,i,j+1)*dtc*hx
200         continue
c         write(dbugunit,901) i,j,2,(yfluxm(ivar,i,j+1),ivar=1,nvar)
         endif

         if (listbc(3,ispot) .eq. 3) then
c           ::::: Cell i,j on left side of fine grid
            do 300 ivar = 1, nvar
               alloc(inlist + ivar) = -xfluxm(ivar,i+1,j)*dtc*hy
300         continue
c         write(dbugunit,901) i,j,3,(xfluxm(ivar,i+1,j),ivar=1,nvar)
         endif

         if (listbc(3,ispot) .eq. 4) then
c           ::::: Cell i,j on top side of fine grid
            do 400 ivar = 1, nvar
               alloc(inlist + ivar) = -yfluxp(ivar,i,j)*dtc*hx
400         continue
c         write(dbugunit,901) i,j,4,(yfluxp(ivar,i,j),ivar=1,nvar)
         endif
c
c        ### new bcs 5 and 6 come from spherical mapping. note sign change:
c        ### previous fluxes stored negative flux, fine grids always add
c        ### their flux, then the delta is either added or subtracted as
c        ### appropriate for that side.  New bc adds or subtracts BOTH fluxes.
c
         if (listbc(3,ispot) .eq. 5) then
c           ::::: Cell i,j on top side of fine grid with spherical mapped bc
            do 500 ivar = 1, nvar
               alloc(inlist + ivar) = yfluxm(ivar,i,j+1)*dtc*hx
500         continue
c         write(dbugunit,901) i,j,5,(yfluxm(ivar,i,j+1),ivar=1,nvar)
 901        format(2i4," side",i3,4e15.7)
         endif
c
         if (listbc(3,ispot) .eq. 6) then
c           ::::: Cell i,j on bottom side of fine grid with spherical mapped bc
            do 600 ivar = 1, nvar
               alloc(inlist + ivar) = yfluxp(ivar,i,j)*dtc*hx
600         continue
c         write(dbugunit,901) i,j,6,(yfluxp(ivar,i,j),ivar=1,nvar)
         endif

      ispot = ispot + 1
      if (ispot .gt. maxsp) go to 99
      go to 10
c
 99   return
      end

module amr_module

    implicit none
       
    save
       
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::   data structure info.
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    integer, parameter :: rsize = 3
    integer, parameter :: nsize = 17

    !  :::::::   integer part of node descriptor
    integer, parameter :: levelptr  = 1
    integer, parameter :: tempptr   = 2
    integer, parameter :: errptr    = 3
    integer, parameter :: nestlevel = 4
    integer, parameter :: cfluxptr  = 5
    integer, parameter :: ffluxptr  = 6
    integer, parameter :: store1    = 7
    integer, parameter :: store2    = 8
    integer, parameter :: ndilo     = 9
    integer, parameter :: ndihi     = 10
    integer, parameter :: storeaux  = 11
    integer, parameter :: storeflags  = 12
    integer, parameter :: numflags  = 13
    integer, parameter :: domflags_base  = 14
    integer, parameter :: domflags2  = 15
    integer, parameter :: bndListSt  = 16
    integer, parameter :: bndListNum = 17

    ! :::::::  real part of node descriptor
    integer, parameter :: cornxlo  = 1
    integer, parameter :: cornxhi  = 2
    integer, parameter :: timemult = 3

    ! :::::::   for linking nodes
    integer, parameter :: nextfree = 2
    integer, parameter :: null = 0
    integer, parameter :: nil  = 0

    integer, parameter :: gridNbor = 1 !use 1st col, 2nd col is nextfree - the link

    ! :::::::  for flagging points   
    real(kind=8), parameter :: UNSET = -1.0
    real(kind=8), parameter :: DONTFLAG = 0.0
    real(kind=8), parameter :: DOFLAG  = 2.0
    real(kind=8), parameter :: badpro = 3.0

    real(kind=8), parameter :: NEEDS_TO_BE_SET = 10.e33
    real(kind=8), parameter :: rinfinity = 10.e32
    integer, parameter :: iinfinity = 999999999
    integer, parameter :: horizontal = 1
    integer, parameter :: maxgr = 15000
    integer, parameter :: maxlv = 10
    integer, parameter :: maxcl = 5000

    ! The max1d parameter controls the number of grid cells in 
    ! any single grid patch before breaking up. 
    ! Might want to set smaller to break up into more patches for OpenMP
    ! max1d should now be set in setrun.py
    integer:: max1d

    integer, parameter :: maxvar = 10
    integer, parameter :: maxaux = 20
    integer, parameter :: maxwave = 10


    ! put linked list of grids into array and save.
    ! order is coarsest level to finest. is redone after regridding
    ! and on restarting.  note use of sentinel in listStart
    integer :: listOfGrids(maxgr),listStart(0:maxlv+1)
    integer,parameter :: bndListSize = 8*maxgr
    integer :: bndList(bndListSize,2)  ! guess size, average # nbors 4? manage as linked list

    real(kind=8) hxposs(maxlv),possk(maxlv),rnode(rsize, maxgr)



    real(kind=8) tol, tolsp
    integer ibuff,  mstart, ndfree, ndfree_bnd, lfine, node(nsize, maxgr), &
            icheck(maxlv),lstart(maxlv),newstl(maxlv), &
            listsp(maxlv),intratx(maxlv), &
            kratio(maxlv), iregsz(maxlv), &
            iregst(maxlv), &
            iregend(maxlv), &
            numgrids(maxlv),numcells(maxlv), &
            iorder,mxnest,kcheck

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! ::::  for alloc array/memory
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ! Static memory implementation
    ! parameter  (memsize = 10000000)
    ! common  /calloc/   alloc(memsize)

    ! Dynamic memory: 
    !real(kind=8), allocatable, target, dimension(:) :: storage
    !real(kind=8), pointer, dimension(:) :: alloc   ! old way, changed mjb Sept. 2014
    real(kind=8), allocatable, dimension(:) :: alloc    ! new way, use allocatable, not pointer
    integer memsize
       
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::\
    ! :::::   for space management of alloc array
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    integer, parameter :: lfdim=5000
    integer lfree(lfdim,2),lenf

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  domain description variables
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    logical xperdom
    real(kind=8) :: xupper, xlower
    integer :: nghost, mthbc(2)

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  collect stats
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    real(kind=8)  rvoll(maxlv),evol,rvol,avenumgrids(maxlv)
    integer ::  iregridcount(maxlv), tvoll(maxlv)
    integer :: timeRegridding, timeUpdating, timeValout
    integer :: timeFlglvl,timeGrdfit2,timeGrdfit3,timeGrdfitAll
    integer :: timeSetaux,timeFilval,timeBound,timeStepgrid,timeFilvalTot
    integer :: timeFlagger, timeBufnst, timeTick, tick_clock_start
    real(kind=8) tvollCPU(maxlv), timeTickCPU
    real(kind=8) timeBoundCPU,timeStepgridCPU,timeSetauxCPU,timeRegriddingCPU
    real(kind=8) timeValoutCPU

    integer lentot,lenmax,lendim

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  method parameters
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    character(len=10), allocatable :: auxtype(:)
    integer  method(4), mwaves, mcapa
    integer, allocatable :: mthlim(:)
    real(kind=8) cfl,cflmax,cflv1,cfl_level

    logical :: use_fwaves
    logical :: flag_richardson,flag_gradient
    integer :: verbosity_regrid

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! ::::: Parameters and variables related to I/O and checkpointing
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    logical    printout,matlabout,ncarout

    ! variables for conservation checking:
    real(kind=8) tmass0

    ! variables for specifying output format
    integer :: output_style, nstop, nout, iout
    real(kind=8), allocatable :: tout(:)
    real(kind=8) :: t0, tfinal
    real(kind=8) :: tstart_thisrun  ! /= t0 in case of restart
    integer :: nq_components, naux_components, output_format
    integer, allocatable :: output_q_components(:)
    integer, allocatable :: output_aux_components(:)
    logical :: output_aux_onlyonce

    ! checkpointing:
    integer :: checkpt_style, nchkpt, checkpt_interval
    real(kind=8), allocatable :: tchk(:)

    integer :: matlabu

    integer, parameter :: parmunit = 12
    integer, parameter :: chkunit = 10
    integer, parameter :: inunit  = 5
    integer, parameter :: outunit = 66
    integer, parameter :: pltunit1 = 3
    integer, parameter :: rstunit = 9
    integer, parameter :: dbugunit = 11
    integer, parameter :: matunit = 70

    ! ::::  Debugging flags (verbose output)
    logical &
                dprint,     & !  domain flags output
                eprint,     & !  error estimation output
                edebug,     & !  even more error estimation output
                gprint,     & !  verbose grid generation (clustering,colating...)
                nprint,     & !  nestck reporting
                pprint,     & !  projec tagged pts.
                rprint,     & !  regridding -  summary of new grids
                sprint,     & !  space (memory) output
                tprint,     & !  tick (time stepping) reporting
                uprint        !  updating/upbnding reporting


    ! Restart file name:
    character(len=200) :: rstfile
    logical :: check_a

end module amr_module

c     
c     
c     
c     =====================================================
      subroutine qinit(meqn,mbc,mx,my,mz,
     &     xlower,ylower,zlower,dx,dy,dz,q,maux,aux)
c     =====================================================
c     
c     # Set initial conditions for q.
c     
      implicit double precision (a-h,o-z)
c     
      dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc,
     &     1-mbc:mz+mbc)
      dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc,
     &     1-mbc:mz+mbc)
c     
c     # set initial data
c     ---------------------------
c     

      do k = 1,mz
         do j = 1,my
            do i = 1,mx
               q(1,i,j,k) = 0.d0
               q(2,i,j,k) = 0.d0
               q(3,i,j,k) = 0.d0
               q(4,i,j,k) = 0.d0
            enddo
         enddo
      enddo

      return
      end

c
c
c     ==================================================================
      subroutine rpt3(ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx,
     &                  ql,qr,aux1,aux2,aux3,asdq,
     &                  bmasdq,bpasdq)
c     ==================================================================
c
c     # Riemann solver in the transverse direction.
c     # This is a dummy routine that returns zeros and is only intended
c     # to illustrate the format of this routine.  See various example
c     # directories for better examples.

c     # This dummy routine can be used if transverse solves are not being
c     # used, i.e. if method(3) = 0.
c     #
c     # On input,
c
c     #    ql,qr is the data along some one-dimensional slice, as in rpn3
c     #         This slice is
c     #             in the x-direction if ixyz=1,
c     #             in the y-direction if ixyz=2, or
c     #             in the z-direction if ixyz=3.
c     #    asdq is an array of flux differences (A^*\Dq).
c     #         asdq(:,i) is the flux difference propagating away from
c     #         the interface between cells i-1 and i.
c     #    Note that asdq represents B^*\Dq if ixyz=2 or C^*\Dq if ixyz=3.
c
c     #    ixyz indicates the direction of the original Riemann solve,
c     #         called the x-like direction in the table below:
c
c     #               x-like direction   y-like direction   z-like direction
c     #      ixyz=1:        x                  y                  z         
c     #      ixyz=2:        y                  z                  x         
c     #      ixyz=3:        z                  x                  y         
c
c     #    icoor indicates direction in which the transverse solve should 
c     #         be performed.
c     #      icoor=2: split in the y-like direction.
c     #      icoor=3: split in the z-like direction.
c
c     #    For example,
c     #      ixyz=1, icoor=2 means asdq=A^*\Dq, and should be split in y into
c     #                        bmasdq = B^-A^*\Dq,
c     #                        bpasdq = B^+A^*\Dq.
c     #
c     #      ixyz=2, icoor=2 means asdq=B^*\Dq, and should be split in z into 
c     #                        bmasdq = C^-B^*\Dq,
c     #                        bpasdq = C^+B^*\Dq.
c
c     #    The parameter imp is generally needed only if aux
c     #    arrays are being used, in order to access the appropriate
c     #    variable coefficients.
c
c
c
      implicit real*8(a-h,o-z)
      dimension     ql(meqn, 1-mbc:maxm+mbc)
      dimension     qr(meqn, 1-mbc:maxm+mbc)
      dimension   asdq(meqn, 1-mbc:maxm+mbc)
      dimension bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension bpasdq(meqn, 1-mbc:maxm+mbc)
      dimension   aux1(maux, 1-mbc:maxm+mbc, 3)
      dimension   aux2(maux, 1-mbc:maxm+mbc, 3)
      dimension   aux3(maux, 1-mbc:maxm+mbc, 3)
c
      do i = 2-mbc, mx+mbc
         do m=1,meqn
            bmasdq(m,i) = 0.d0
            bpasdq(m,i) = 0.d0
         enddo
      enddo
c
c
      return
      end

c
c ------------------------------------------------------------------
c
      subroutine bc3amr(val,aux,nrow,ncol,nfil,meqn,naux,
     1                  hx, hy, hz, level, time,
     2                  xleft,  xright,  yfront, yrear,
     3                  zbot, ztop,
     4                  xlower,ylower,zlower,
     5                  xupper,yupper,zupper,
     6                  xperiodic, yperiodic,zperiodic)


c
c
c :::::::::: BC3AMR ::::::::::::::::::::::::::::::::::::::::::::::;
c
c     Take a grid patch with mesh widths hx,hy,hz, of dimensions nrow by
c     ncol by nfil,  and set the values of any piece of
c     of the patch which extends outside the physical domain
c     using the boundary conditions.
c     ------------------------------------------------
c     # Standard boundary condition choices for amr3ez in clawpack
c
c     # At each boundary  k = 1 (left),  2 (right),  3 (front), 4 (rear),
c                         5 (bottom) 6 (top)
c     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
c     #            =  1  for zero-order extrapolation
c     #            =  2  for periodic boundary coniditions
c     #            =  3  for solid walls, assuming this can be implemented
c     #                  by reflecting the data about the boundary and then
c     #                  negating the 2'nd (for k=1,2) or 3'rd (for k=3,4)
c     #                  or 4'th (for k = 5,6) component of q.
c     ------------------------------------------------
c
c     The corners of the grid patch are at
c        (xleft,yfront,zbot)  --  lower front left corner
c        (xright,yrear,ztop) --  upper rear right corner
c
c     The physical domain itself is a rectangular parallelopiped bounded by
c        (xlower,ylower,zlower)  -- lower front left corner
c        (xupper,yupper,zupper)  -- upper rear right corner
c
c     the picture is the following:
c
c                            __________________________(xupper,yupper,zupper)
c                           /                         /|
c                          /                         / |
c                         /                         /  |
c                        /_________________________/   |
c                        |                         |   |
c                        |                         |   |
c                     ___|_____(xright,yrear,ztop) |   |
c                    /___|____/|                   |   |
c                    |   |    ||                   |   |
c                    |   |    ||                   |   |
c                    |   |    ||                   |   |
c                    |___|____|/                   |   |
c  (xleft,yfront,zbot)   |                         |  /
c                        |                         | /
c                        |_________________________|/
c  (xlower,ylower,zlower)
c
c     Any cells that lie outside the physical domain are ghost cells whose
c     values should be set in this routine.  This is tested for by comparing
c     xleft with xlower to see if values need to be set at the left, as in
c     the figure above, and similarly at the other boundaries.
c
c     Patches are guaranteed to have at least 1 row of cells filled
c     with interior values so it is possible to  extrapolate.
c     Fix trimbd if you want more than 1 row pre-set.
c
c     Make sure the order the boundaries are specified is correct
c     so that diagonal corner cells are also properly taken care of.
c
c     Periodic boundaries are set before calling this routine, so if the
c     domain is periodic in one direction only you
c     can safely extrapolate in the other direction.
c
c     Don't overwrite ghost cells in periodic directions!
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module, only:  mthbc
      implicit none

      real*8  val(meqn,nrow,ncol,nfil), aux(naux,nrow,ncol,nfil)
      real*8  ubar, vbar, wbar
      logical xperiodic, yperiodic, zperiodic
      integer nrow,ncol,nfil,meqn,naux,level
      real*8  hx,hy,hz,time,qtrue
      real*8  hxmarg,hymarg,hzmarg
      real*8  xleft,xright,yfront,yrear,zbot,ztop
      real*8  xcell,ycell,zcell
      real*8  xlower,ylower,zlower
      real*8  xupper,yupper,zupper
      integer i,j,k,m,nxl,nxr,ibeg,nyf,nyr,jbeg,nzb,nzt,kbeg
      
      common /cparam/ ubar,vbar,wbar

      hxmarg = hx*.01d0
      hymarg = hy*.01d0
      hzmarg = hz*.01d0

      if (xperiodic .and. yperiodic .and. zperiodic) go to 699
c
c
c-------------------------------------------------------
c     # xlower boundary:
c-------------------------------------------------------
      if (xleft .ge. xlower-hxmarg) then
c        # not a physical boundary -- ghost cells lie within another
c        # grid and values are set elsewhere in amr code.
         go to 199
         endif
c
c     # number of ghost cells lying outside physical domain:
      nxl = (xlower+hxmarg-xleft)/hx     
c
      if (nxl > 2) then
          write(6,*) '*** unexpected value nxl = ',nxl
          stop
          endif
c
      go to (100,110,120,130) mthbc(1)+1
c
  100 continue
         do k = 1,nfil
            zcell = zbot + (k-0.5d0)*hz
            do j = 1,ncol
               ycell = yfront + (j-0.5d0)*hy
               do i=1,nxl 
                  xcell = xleft + (i-0.5d0)*hx
                  val(1,i,j,k) = qtrue(xcell,ycell,zcell,time)
               enddo
            enddo
         enddo
      go to 199
c
  110 continue
c     # zero-order extrapolation:
         do 115 k = 1,nfil
          do 115 j = 1,ncol
           do 115 i=1,nxl
            do 115 m=1,meqn
               val(m,i,j,k) = val(m,nxl+1,j,k)
  115       continue
      go to 199

  120 continue
c     # periodic:   handled elsewhere in amr
      go to 199

  130 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 135 k = 1,nfil
       do 135 j = 1,ncol
        do 135 i=1,nxl
         do 135 m=1,meqn
               val(m,i,j,k) = val(m,2*nxl+1-i,j,k)
  135    continue
c     # negate the normal velocity:
      do 136 i=1,nxl
         do 136 j = 1,ncol
            do 136 k = 1,nfil
               val(2,i,j,k) = -val(2,i,j,k)
  136       continue
      go to 199

  199 continue
c
c-------------------------------------------------------
c     # xupper boundary:
c-------------------------------------------------------
      if (xright .le. xupper+hxmarg) then
c        # not a physical boundary -- ghost cells lie within another
c        # grid and values are set elsewhere in amr code.
         go to 299
         endif
c
c     # number of ghost cells lying outside physical domain:
      nxr = (xright - xupper + hxmarg)/hx
      ibeg = max0(nrow-nxr+1, 1)
c
      go to (200,210,220,230) mthbc(2)+1
c
  200 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*)
     &   '*** ERROR *** mthbc(2)=0 and no BCs specified in bc2amr'
      stop
      go to 299

  210 continue
c     # linear-order extrapolation:
       do 215 k = 1,nfil
        do 215 j = 1,ncol
         do 215 i=ibeg,nrow
          do 215 m=1,meqn
            val(m,i,j,k) = 2.d0*val(m,ibeg-1,j,k) - val(m,ibeg-2,j,k)
  215     continue
      go to 299

  220 continue
c     # periodic:   handled elsewhere in amr
      go to 299

  230 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 235 k = 1,nfil
       do 235 j = 1,ncol
        do 235 i=ibeg,nrow
         do 235 m=1,meqn
            val(m,i,j,k) = val(m,2*ibeg-1-i,j,k)
  235    continue
c     # negate the normal velocity:
       do 236 k = 1,nfil
       do 236 j = 1,ncol
       do 236 i=ibeg,nrow
          val(2,i,j,k) = -val(2,i,j,k)
  236  continue
      go to 299

  299 continue
c
c-------------------------------------------------------
c     # ylower boundary:
c-------------------------------------------------------
      if (yfront .ge. ylower-hymarg) then
c        # not a physical boundary -- ghost cells lie within another
c        # grid and values are set elsewhere in amr code.
         go to 399
         endif
c
c     # number of ghost cells lying outside physical domain:
      nyf = (ylower+hymarg-yfront)/hy
c
      go to (300,310,320,330) mthbc(3)+1
c
  300 continue
         do k = 1,nfil
            zcell = zbot + (k-0.5d0)*hz
            do i = 1,nrow
               xcell = xleft + (i-0.5d0)*hx
               do j=1,nyf
                   ycell = yfront + (j-.5d0)*hy
                   val(1,i,j,k) = qtrue(xcell,ycell,zcell,time)
               enddo
            enddo
         enddo
      go to 399
c
  310 continue
c     # zero-order extrapolation:
      do 315 k = 1,nfil
       do 315 j=1,nyf
        do 315 i=1,nrow
         do 315 m=1,meqn
            val(m,i,j,k) = val(m,i,nyf+1,k)
  315 continue
      go to 399

  320 continue
c     # periodic:   handled elsewhere in amr
      go to 399

  330 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 335 k = 1,nfil
       do 335 j=1,nyf
        do 335 i=1,nrow
         do 335 m=1,meqn
            val(m,i,j,k) =  val(m,i,2*nyf+1-j,k)
  335    continue
c     # negate the normal velocity:
      do 336 k = 1,nfil
       do 336 j=1,nyf
        do 336 i=1,nrow
           val(3,i,j,k) = -val(3,i,j,k)
  336   continue
      go to 399

  399 continue
c
c-------------------------------------------------------
c     # yupper boundary:
c-------------------------------------------------------
      if (yrear .le. yupper+hymarg) then
c        # not a physical boundary -- ghost cells lie within another
c        # grid and values are set elsewhere in amr code.
         go to 499
         endif
c
c     # number of ghost cells lying outside physical domain:
      nyr = (yrear - yupper + hymarg)/hy
      jbeg = max0(ncol-nyr+1, 1)
c
      go to (400,410,420,430) mthbc(4)+1
c
  400 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*)
     &   '*** ERROR *** mthbc(4)=0 and no BCs specified in bc3amr'
      stop
      go to 499

  410 continue
c     # linear  extrapolation:
       do 415 k = 1,nfil
        do 415 j=jbeg,ncol
         do 415 i=1,nrow
          do 415 m=1,meqn
            val(m,i,j,k) =  2.d0*val(m,i,jbeg-1,k) - val(m,i,jbeg-2,k)
  415     continue
      go to 499

  420 continue
c     # periodic:   handled elsewhere in amr
      go to 499

  430 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 435 m=1,meqn
         do 435 j=jbeg,ncol
            do 435 i=1,nrow
               do 435 k = 1,nfil
                  val(m,i,j,k) =  val(m,i,2*jbeg-1-j,k)
  435          continue
c     # negate the normal velocity:
      do 436 j=jbeg,ncol
         do 436 i=1,nrow
            do 436 k = 1,nfil
               val(3,i,j,k) = -val(3,i,j,k)
  436       continue
      go to 499

  499 continue

c
c-------------------------------------------------------
c     # zlower boundary:
c-------------------------------------------------------
      if (zbot .ge. zlower-hzmarg) then
c        # not a physical boundary -- ghost cells lie within another
c        # grid and values are set elsewhere in amr code.
         go to 599
         endif
c
c     # number of ghost cells lying outside physical domain:
      nzb = (zlower+hzmarg-zbot)/hz
c
      go to (500,510,520,530) mthbc(5)+1
c
  500 continue
         do i = 1,nrow
            xcell = xleft + (i-0.5d0)*hx
            do j = 1,ncol
               ycell = yfront + (j-0.5d0)*hy
               do k=1,nzb
                  zcell = zbot + (k-0.5d0)*hz
                  val(1,i,j,k) = qtrue(xcell,ycell,zcell,time)
               enddo
            enddo
         enddo
      go to 599
c
  510 continue
c     # zero-order extrapolation:
      do 515 k=1,nzb
       do 515 j = 1,ncol
        do 515 i=1,nrow
         do 515 m=1,meqn
            val(m,i,j,k) = val(m,i,j,nzb+1)
  515    continue
      go to 599

  520 continue
c     # periodic:   handled elsewhere in amr
      go to 599

  530 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 535 k=1,nzb
       do 535 j = 1,ncol
        do 535 i=1,nrow
         do 535 m=1,meqn
            val(m,i,j,k) =  val(m,i,j,2*nzb+1-k)
  535    continue
c     # negate the normal velocity:
      do 536 k = 1,nzb
       do 536 j = 1,ncol
        do 536 i = 1,nrow
           val(4,i,j,k) = -val(4,i,j,k)
  536   continue
      go to 599

  599 continue
c
c-------------------------------------------------------
c     # zupper boundary:
c-------------------------------------------------------
      if (ztop .le. zupper+hzmarg) then
c        # not a physical boundary -- ghost cells lie within another
c        # grid and values are set elsewhere in amr code.
         go to 699
         endif
c
c     # number of ghost cells lying outside physical domain:
      nzt = (ztop - zupper + hzmarg)/hz
      kbeg = max0(nfil-nzt+1, 1)
c
      go to (600,610,620,630) mthbc(6)+1
c
  600 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*)
     &   '*** ERROR *** mthbc(6)=0 and no BCs specified in bc3amr'
      stop
      go to 699

  610 continue
c     # linear extrapolation:
      do 615 k = kbeg,nfil
       do 615 j = 1,ncol
        do 615 i = 1,nrow
         do 615 m = 1,meqn
           val(m,i,j,k) =  2.d0*val(m,i,j,kbeg-1) - val(m,i,j,kbeg-2)
  615    continue
      go to 699

  620 continue
c     # periodic:   handled elsewhere in amr
      go to 699

  630 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
       do 635 k = kbeg,nfil            
        do 635 j = 1,ncol
         do 635 i = 1,nrow
          do 635 m=1,meqn
             val(m,i,j,k) =  val(m,i,j,2*kbeg-1-k)
  635     continue
c     # negate the normal velocity:
      do 636 k=kbeg,nfil
       do 636 j = 1,ncol
        do 636 i=1,nrow
           val(4,i,j,k) = -val(4,i,j,k)
  636   continue
      go to 699

  699 continue

      return
      end

subroutine matvec( n, x, y, nelt, ia, ja, a, isym )

    ! matrix-vector multiply, returning y = A*x
    ! A is specified in triad form: a(k) is element at (ia(k),ja(k))
    ! for k = 1:nelt

    integer, intent(in) :: n,nelt,ia(nelt),ja(nelt),isym
    real(kind=8), intent(in) :: x(n),a(nelt)
    real(kind=8), intent(out) :: y(n)

    integer :: k

    y = 0.d0
    do k=1,nelt
        y(ia(k)) = y(ia(k)) + a(k) * x(ja(k))
    enddo

end subroutine matvec

c
c -----------------------------------------------------------
c
      subroutine colate1 (badpts, len, lcheck, nUniquePts, lbase)
c
      use amr_module
      implicit  double precision (a-h,o-z)
      dimension badpts(1,len)
      dimension ist(3), iend(3), ishift(3)
      logical db/.false./

c
c    index for flag array now based on integer index space, not 1:mibuff
c    but if grid extends outside domain, not supposed to have flagged points
      iadd(i) = locamrflags + i-(ilo-mbuff)
c
c
c *************************************************************
c
c colate1 = takes each grids flagged points at level lcheck
c          and puts their (i) cell centered
c          indices into the badpts array.
c          To insure proper nesting, must get rid of flagged points
c          that dont fit into properly nested domain. Grids
c          with flagged points include buffered region (size mbuff)now.
c          THIS NEW VERSION may have duplicate points. need to sort
c          and remove when colating.
c
c if checking flagged pt for nesting is expensive, might consider not doing it
c and revising projec2 instead. if new fine grid not nested, then go through
c flagged points and throw out. But presumably many grids will make it through
c without having to check all points.
c
c *************************************************************
c
c domain flags corresponding to each grid have already been set up.
c colate will check that flagged points nested or throw away
c


       mbuff = max(nghost,ibuff+1)  ! new way of expanding grid to do buffering in place
       index = 0  ! for putting into badpts array


      mptr = lstart(lcheck)
 10      continue

c        handle each of 2 sides (in 1D)
c        set tags to negative val. reset to positive if they have a home     
         ilo = node(ndilo,mptr)
         ihi = node(ndihi,mptr)
         nx = ihi - ilo + 1
         mibuff = nx + 2 *mbuff


         locamrflags = node(storeflags,mptr)
         if (node(numflags,mptr) .eq. 0) go to 70    !simple bypass if no tags


c
c  more conservative alg. uses entire buffer in flagging
            imin =  ilo-mbuff
            imax =  ihi+mbuff
            if (.not. xperdom) then
              imin = max(imin,0)
              imax = min(ihi+mbuff,iregsz(lcheck)-1)
            endif
c
c  but to match old alg. use only this one. (not exactly the same? since
c  old alg. used one level?)

c            imin = max(ilo-mbuff,0)
c            imax = min(ihi+mbuff,iregsz(lcheck)-1)

c do we still need setPhysBndry????
c         call setPhysBndry(alloc(locamrflags),ilo,ihi,
c     .                     mbuff,lcheck)
c     pass loop bounds to keep consistent
c     need this next subr. to do integer indexing for iflags
c

         call flagcheck(alloc(locamrflags),ilo,ihi,mbuff,
     .                  alloc(node(domflags2,mptr)),
     .                  imin,imax,mptr)


             do 60 i = imin, imax


c             neg means no home was found. throw out
             if (alloc(iadd(i)) .lt. 0) then
                  write(outunit,939) i
 939              format("NOT NESTED: ignoring point ",2i5)
                  write(*,*)" still have neg points"
                  go to 60
             endif
             if (alloc(iadd(i)) .le. DONTFLAG) go to 60
c
c    got a legit flagged point, bag it.
c
             index = index + 1
c  WARNING: to match orig program note we ADD .5, not subtract. old program used 1 based indexing
c  for grid flagging array. we are using 0 based, so need to add to match previous
c  grid fitting (dont want to change all routines downstream)
c
c  for periodic domains, if flagged pt in buffer zone outside domain
c   wrap it periodically back in before putting on list
              iwrap = i
              if (xperdom) then
                 if (i .lt. 0) iwrap = i + iregsz(lcheck)
                 if (i .ge. iregsz(lcheck)) iwrap = i - iregsz(lcheck)
              endif
c             adding .5 to make it cell centered integer coords
c             note that previous code subtracted .5 since it used 1 based indexing
              badpts(1,index) = dble(iwrap)+.5   ! in case periodic, put flagged buffer pt
             if (db) write(outunit,101) badpts(1,index)
 101          format(2f6.1)

 60        continue

c
 70     continue

c  done colating - safe to reclam
        call reclam(locamrflags,mibuff)

        ibytesPerDP = 8
        iflagsize =  (mibuff)/ibytesPerDP+1
        call reclam(node(domflags_base,mptr),iflagsize)
        call reclam(node(domflags2,mptr),iflagsize)

c
        mptr = node(levelptr, mptr)
       if (mptr .ne. 0) go to 10


      npts = index 
      if (gprint) then
        write(outunit,100) npts, lcheck,len
 100    format( i9,' flagged points initially colated on level ',i4,
     .        " badpts len = ",i10)
      endif
c
c colate flagged points into single integer array for quicksorting
c
c      call drivesort(npts,badpts,lcheck,nUniquePts,mbuff)
c  ### bug found in drivesort- integer overflow
c  ### temp bypass for rnady to run finer grids
      if (lcheck .ge. 6) then
          nUniquePts =    npts
      else
c         # assume points are unique
c         # Cannot check for more than 6 levels due to integer overflow
c         # bug that needs to be fixed!
          call drivesort(npts,badpts,lcheck,nUniquePts,mbuff)
      endif
     

 99   return
      end

!     ==================================================================
    subroutine step3ds(maxm,num_eqn,num_waves,num_ghost,mx,my, &
    mz,qold,qnew,aux,dx,dy,dz,dt,method,mthlim,cfl, &
    qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d, &
    aux1,aux2,aux3,num_aux,work,mwork,idir,use_fwave,rpn3,rpt3,rptt3)
!     ==================================================================

!     # Take one time step, updating q, to be used with
!     # dimensional splitting.
!     # On entry, qold and qnew should be identical and give the
!     #    initial data for this step.
!     # On exit, qnew returns values at the end of the time step.
!     #    qold is unchanged.

!     # This is a simplified version of the subroutine step3d
!     # Since only qadd and fadd is used in the flux updates,
!     # the solution updates below are considerably simplified
!     # compared to step3d.

!     #-----------------------------------------------------------------
!     # NOTE! Since dimensional splitting is used, it is possible
!     #       to reduce the memory requirement, i.e. the size of
!     #       the work array. It could be reduced with
!     #
!     #       (maxm + 2*num_ghost)*(37*num_eqn + 6*num_aux),
!     #
!     #       when also possible reductions in flux3 are included.
!     #       However, this term is small compared to the dominating
!     #       term (mx+2num_ghost)(my+2num_ghost)*(mz+2num_ghost).
!     #-----------------------------------------------------------------

    !$ use omp_lib

    implicit real*8(a-h,o-z)
    external rpn3,rpt3,rptt3
    dimension qold(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension qnew(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension  q1d(num_eqn,1-num_ghost:maxm+num_ghost,*)
    dimension qadd(num_eqn,1-num_ghost:maxm+num_ghost,*)
    dimension fadd(num_eqn,1-num_ghost:maxm+num_ghost,*)
    dimension gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost,*)
    dimension hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost,*)
    dimension aux(num_aux, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost,3,*)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost,3,*)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost,3,*)
    dimension dtdx1d(1-num_ghost:maxm+num_ghost,*)
    dimension dtdy1d(1-num_ghost:maxm+num_ghost,*)
    dimension dtdz1d(1-num_ghost:maxm+num_ghost,*)
    dimension method(7),mthlim(num_waves)
    dimension work(mwork)

    common /comxyzt/ dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom

!f2py intent(out) cfl
!f2py intent(in,out) qnew
!f2py optional q1d, qadd, fadd, gadd, hadd, dtdx1d, dtdy1d, dtdz1d

! Dummy interfaces just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn3(x)
!f2py x=rpt3(x)
!f2py x=rptt3(x)

!     # partition work array into pieces needed for local storage in
!     # flux2 routine.  Find starting index of each piece:

    nthreads=1    ! Serial
    !$omp parallel
    !$omp single
    !$ nthreads = omp_get_num_threads()
    !$omp end single
    !$omp end parallel

    nsiz = (maxm+2*num_ghost)*num_eqn
    nsiz_w = nsiz * num_waves
    nsiz_s = (maxm+2*num_ghost)*num_waves

    i0wave     = 1 
    i0s        = i0wave     + nsiz_w*nthreads
    i0amdq     = i0s        + nsiz_s*nthreads
    i0apdq     = i0amdq     + nsiz*nthreads
    i0cqxx     = i0apdq     + nsiz*nthreads
    i0bmamdq   = i0cqxx     + nsiz*nthreads
    i0bmapdq   = i0bmamdq   + nsiz*nthreads
    i0bpamdq   = i0bmapdq   + nsiz*nthreads
    i0bpapdq   = i0bpamdq   + nsiz*nthreads
    i0cmamdq   = i0bpapdq   + nsiz*nthreads
    i0cmapdq   = i0cmamdq   + nsiz*nthreads
    i0cpamdq   = i0cmapdq   + nsiz*nthreads
    i0cpapdq   = i0cpamdq   + nsiz*nthreads
    i0cmamdq2  = i0cpapdq   + nsiz*nthreads
    i0cmapdq2  = i0cmamdq2  + nsiz*nthreads
    i0cpamdq2  = i0cmapdq2  + nsiz*nthreads
    i0cpapdq2  = i0cpamdq2  + nsiz*nthreads
    i0bmcqxxp  = i0cpapdq2  + nsiz*nthreads
    i0bmcqxxm  = i0bmcqxxp  + nsiz*nthreads
    i0bpcqxxp  = i0bmcqxxm  + nsiz*nthreads
    i0bpcqxxm  = i0bpcqxxp  + nsiz*nthreads
    i0cmcqxxp  = i0bpcqxxm  + nsiz*nthreads
    i0cmcqxxm  = i0cmcqxxp  + nsiz*nthreads
    i0cpcqxxp  = i0cmcqxxm  + nsiz*nthreads
    i0cpcqxxm  = i0cpcqxxp  + nsiz*nthreads
    i0bmcmamdq = i0cpcqxxm  + nsiz*nthreads
    i0bmcmapdq = i0bmcmamdq + nsiz*nthreads
    i0bpcmamdq = i0bmcmapdq + nsiz*nthreads
    i0bpcmapdq = i0bpcmamdq + nsiz*nthreads
    i0bmcpamdq = i0bpcmapdq + nsiz*nthreads
    i0bmcpapdq = i0bmcpamdq + nsiz*nthreads
    i0bpcpamdq = i0bmcpapdq + nsiz*nthreads
    i0bpcpapdq = i0bpcpamdq + nsiz*nthreads
    iused      = i0bpcpapdq + nsiz*nthreads - 1

    if (iused > mwork) then
    !        # This shouldn't happen due to checks in claw3
        write(6,*) '*** not enough work space in step3ds'
        write(6,*) '*** iused = ', iused, '   mwork =',mwork
        stop
    endif

    index_capa = method(6)
!      num_aux = method(7)
    cfl = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy
    dtdz = dt/dz

    if (index_capa == 0) then
    !        # no capa array:
       !$OMP PARALLEL private(i,me,me1)  
       me = 0 
       !$ me = omp_get_thread_num()
       me1 = me + 1 
       do 5 i=1-num_ghost,maxm+num_ghost
          dtdx1d(i,me1) = dtdx
          dtdy1d(i,me1) = dtdy
          dtdz1d(i,me1) = dtdz
5      END DO
      !$omp end parallel
    endif
       
    if( idir == 1)then
    
    !     # perform x-sweeps
    !     ==================
       !$OMP PARALLEL PRIVATE(me,me1,m,i,ma,ka,cfl1d) REDUCTION(MAX:cfl)
       me = 0 
       !$ me = omp_get_thread_num()
       me1 = me + 1 
       cfl1d = 0.d0 

       ! Guided schedule seems to produce a small performance increase
       ! relative to static or dynamic for problems with uniform work
       ! per column.  For problems with very nonuniform work per
       ! column, either guided or dynamic is necessary to keep all the
       ! threads busy.

       !$OMP DO COLLAPSE(2) SCHEDULE(GUIDED)
        do 50 k = 0,mz+1
            do 50 j = 0,my+1
            
                forall (m = 1:num_eqn, i = 1-num_ghost:mx+num_ghost)
            !                 # copy data along a slice into 1d array:
                q1d(m,i,me1) = qold(m,i,j,k)
                end forall
            
                if (index_capa > 0)  then
                    do 23 i = 1-num_ghost, mx+num_ghost
                        dtdx1d(i,me1) = dtdx / aux(index_capa,i,j,k)
                    23 END DO
                endif
            
            !        # Since dimensional splitting is used, only aux2 is needed.
            
                if (num_aux > 0)  then
                    forall (ma=1:num_aux,i= 1-num_ghost:mx+num_ghost, ka = -1:1)
                    aux2(ma,i,2+ka,me1) = aux(ma,i,j,k+ka)
                    end forall
                endif
            
            !           # compute modifications qadd and fadd along this slice
            
                call flux3(1,maxm,num_eqn,num_waves,num_ghost,mx, &
                q1d(1,1-num_ghost,me1),dtdx1d(1-num_ghost,me1),dtdy,dtdz,dummy1, &
                aux2(1,1-num_ghost,1,me1),dummy3,num_aux, &
                method,mthlim,qadd(1,1-num_ghost,me1),fadd(1,1-num_ghost,me1), &
                gadd(1,1,-1,1-num_ghost,me1),hadd(1,1,-1,1-num_ghost,me1),cfl1d, &
                work(i0wave+me*nsiz_w),work(i0s+me*nsiz_s),work(i0amdq+me*nsiz), &
                work(i0apdq+me*nsiz),work(i0cqxx+me*nsiz), &
                work(i0bmamdq+me*nsiz),work(i0bmapdq+me*nsiz), &
                work(i0bpamdq+me*nsiz),work(i0bpapdq+me*nsiz), &
                work(i0cmamdq+me*nsiz),work(i0cmapdq+me*nsiz), &
                work(i0cpamdq+me*nsiz),work(i0cpapdq+me*nsiz), &
                work(i0cmamdq2+me*nsiz),work(i0cmapdq2+me*nsiz), &
                work(i0cpamdq2+me*nsiz),work(i0cpapdq2+me*nsiz), &
                work(i0bmcqxxp+me*nsiz),work(i0bpcqxxp+me*nsiz), &
                work(i0bmcqxxm+me*nsiz),work(i0bpcqxxm+me*nsiz), &
                work(i0cmcqxxp+me*nsiz),work(i0cpcqxxp+me*nsiz), &
                work(i0cmcqxxm+me*nsiz),work(i0cpcqxxm+me*nsiz), &
                work(i0bmcmamdq+me*nsiz),work(i0bmcmapdq+me*nsiz), &
                work(i0bpcmamdq+me*nsiz),work(i0bpcmapdq+me*nsiz), &
                work(i0bmcpamdq+me*nsiz),work(i0bmcpapdq+me*nsiz), &
                work(i0bpcpamdq+me*nsiz),work(i0bpcpapdq+me*nsiz), &
                rpn3,rpt3,rptt3,use_fwave)
           
                cfl = dmax1(cfl,cfl1d)
            
            !           # update qnew by flux differencing.
            !           # (rather than maintaining arrays f, g and h for the total fluxes,
            !           # the modifications are used immediately to update qnew
            !           # in order to save storage.)
            
                if(index_capa == 0)then
                !              # no capa array.  Standard flux differencing:
                    forall (m = 1:num_eqn, i = 1:mx)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i,me1) &
                    - dtdx * (fadd(m,i+1,me1) - fadd(m,i,me1))
                    end forall
                else
                !              # with capa array
                    forall (m = 1:num_eqn, i = 1:mx)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i,me1) &
                    - dtdx * (fadd(m,i+1,me1) - fadd(m,i,me1)) &
                    / aux(index_capa,i,j,k)
                    end forall
                endif
            
50           END DO
             !$omp end parallel
    
       else if( idir == 2 )then
             
          !     # perform y sweeps
          !     ==================
          !$OMP PARALLEL PRIVATE(me,me1,m,j,ma,ia,cfl1d) REDUCTION(MAX:cfl)
          me = 0 
          !$ me = omp_get_thread_num()
          me1 = me + 1 
          cfl1d = 0.d0 
          !$OMP DO COLLAPSE(2) SCHEDULE(GUIDED)
          do 100 k = 0, mz+1
             do 100 i = 0, mx+1
                
                forall (m = 1:num_eqn, j = 1-num_ghost:my+num_ghost)
                   !                 # copy data along a slice into 1d array:
                   q1d(m,j,me1) = qold(m,i,j,k)
                end forall
                
                if (index_capa > 0)  then
                   do 71 j = 1-num_ghost, my+num_ghost
                      dtdy1d(j,me1) = dtdy / aux(index_capa,i,j,k)
71                 END DO
                endif
                
                !        # Since dimensional splitting is used, only aux2 is needed.
                
                if (num_aux > 0)  then
                   ! There's a decent chance aux2 will all fit into cache,
                   ! so keep accesses to aux as contiguous as possible.
                   forall (ma=1:num_aux,ia= -1:1, j = 1-num_ghost:my+num_ghost)
                      aux2(ma, j, 2+ia,me1) = aux(ma, i+ia, j, k)
                   end forall
                endif
                
                !           # compute modifications qadd and fadd along this slice
                
                
                call flux3(2,maxm,num_eqn,num_waves,num_ghost,my, &
                     q1d(1,1-num_ghost,me1),dtdy1d(1-num_ghost,me1),dtdz,dtdx,dummy1, &
                     aux2(1,1-num_ghost,1,me1),dummy3,num_aux, &
                     method,mthlim,qadd(1,1-num_ghost,me1),fadd(1,1-num_ghost,me1), &
                     gadd(1,1,-1,1-num_ghost,me1),hadd(1,1,-1,1-num_ghost,me1),cfl1d, &
                     work(i0wave+me*nsiz_w),work(i0s+me*nsiz_s),work(i0amdq+me*nsiz), &
                     work(i0apdq+me*nsiz),work(i0cqxx+me*nsiz), &
                     work(i0bmamdq+me*nsiz),work(i0bmapdq+me*nsiz), &
                     work(i0bpamdq+me*nsiz),work(i0bpapdq+me*nsiz), &
                     work(i0cmamdq+me*nsiz),work(i0cmapdq+me*nsiz), &
                     work(i0cpamdq+me*nsiz),work(i0cpapdq+me*nsiz), &
                     work(i0cmamdq2+me*nsiz),work(i0cmapdq2+me*nsiz), &
                     work(i0cpamdq2+me*nsiz),work(i0cpapdq2+me*nsiz), &
                     work(i0bmcqxxp+me*nsiz),work(i0bpcqxxp+me*nsiz), &
                     work(i0bmcqxxm+me*nsiz),work(i0bpcqxxm+me*nsiz), &
                     work(i0cmcqxxp+me*nsiz),work(i0cpcqxxp+me*nsiz), &
                     work(i0cmcqxxm+me*nsiz),work(i0cpcqxxm+me*nsiz), &
                     work(i0bmcmamdq+me*nsiz),work(i0bmcmapdq+me*nsiz), &
                     work(i0bpcmamdq+me*nsiz),work(i0bpcmapdq+me*nsiz), &
                     work(i0bmcpamdq+me*nsiz),work(i0bmcpapdq+me*nsiz), &
                     work(i0bpcpamdq+me*nsiz),work(i0bpcpapdq+me*nsiz), &
                     rpn3,rpt3,rptt3,use_fwave)
                
                cfl = dmax1(cfl,cfl1d)
                
            !           # update qnew by flux differencing.
            !           # Note that the roles of the flux updates are changed.
            !           # fadd - modifies the g-fluxes
            
                if( index_capa == 0)then
                !               # no capa array.  Standard flux differencing:
                    forall (m = 1:num_eqn, j = 1:my)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j,me1) &
                    - dtdy * (fadd(m,j+1,me1) - fadd(m,j,me1))
                    end forall
                else
                !              #with capa array.
                    forall (m = 1:num_eqn, j = 1:my)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j,me1) &
                    - dtdy * (fadd(m,j+1,me1) - fadd(m,j,me1)) &
                    / aux(index_capa,i,j,k)
                    end forall
                endif
            
        100 END DO
             !$omp end parallel
    
    else
    
    !     # perform z sweeps
    !     ==================
       !$OMP PARALLEL PRIVATE(me,me1,m,k,ma,ja,cfl1d) REDUCTION(MAX:cfl)
       me = 0 
       !$ me = omp_get_thread_num()
       me1 = me + 1 
       cfl1d = 0.d0 
       !$OMP DO COLLAPSE(2) SCHEDULE(GUIDED)
       do 150 j = 0, my+1
          do 150 i = 0, mx+1
             
             forall (m = 1:num_eqn, k = 1-num_ghost:mz+num_ghost)
                !                 # copy data along a slice into 1d array:
                q1d(m,k,me1) = qold(m,i,j,k)
             end forall
             
             if (index_capa > 0)  then
                do 130 k = 1-num_ghost, mz+num_ghost
                   dtdz1d(k,me1) = dtdz / aux(index_capa,i,j,k)
130             END DO
             endif
             
             !        # Since dimensional splitting is used, only aux2 is needed.
             
             if (num_aux > 0)  then
                ! There's a decent chance aux2 will all fit into cache,
                ! so keep accesses to aux as contiguous as possible.
                forall (ma=1:num_aux,ja= -1:1, k = 1-num_ghost:mz+num_ghost)
                   aux2(ma, k, 2+ja,me1) = aux(ma, i, j+ja, k)
                end forall
             endif
             
             !           # compute modifications qadd and fadd along this slice
             

             call flux3(3,maxm,num_eqn,num_waves,num_ghost,mz, &
                  q1d(1,1-num_ghost,me1),dtdz1d(1-num_ghost,me1),dtdx,dtdy,dummy1, &
                  aux2(1,1-num_ghost,1,me1),dummy3,num_aux, &
                  method,mthlim,qadd(1,1-num_ghost,me1),fadd(1,1-num_ghost,me1), &
                  gadd(1,1,-1,1-num_ghost,me1),hadd(1,1,-1,1-num_ghost,me1),cfl1d, &
                  work(i0wave+me*nsiz_w),work(i0s+me*nsiz_s),work(i0amdq+me*nsiz), &
                  work(i0apdq+me*nsiz),work(i0cqxx+me*nsiz), &
                  work(i0bmamdq+me*nsiz),work(i0bmapdq+me*nsiz), &
                  work(i0bpamdq+me*nsiz),work(i0bpapdq+me*nsiz), &
                  work(i0cmamdq+me*nsiz),work(i0cmapdq+me*nsiz), &
                  work(i0cpamdq+me*nsiz),work(i0cpapdq+me*nsiz), &
                  work(i0cmamdq2+me*nsiz),work(i0cmapdq2+me*nsiz), &
                  work(i0cpamdq2+me*nsiz),work(i0cpapdq2+me*nsiz), &
                  work(i0bmcqxxp+me*nsiz),work(i0bpcqxxp+me*nsiz), &
                  work(i0bmcqxxm+me*nsiz),work(i0bpcqxxm+me*nsiz), &
                  work(i0cmcqxxp+me*nsiz),work(i0cpcqxxp+me*nsiz), &
                  work(i0cmcqxxm+me*nsiz),work(i0cpcqxxm+me*nsiz), &
                  work(i0bmcmamdq+me*nsiz),work(i0bmcmapdq+me*nsiz), &
                  work(i0bpcmamdq+me*nsiz),work(i0bpcmapdq+me*nsiz), &
                  work(i0bmcpamdq+me*nsiz),work(i0bmcpapdq+me*nsiz), &
                  work(i0bpcpamdq+me*nsiz),work(i0bpcpapdq+me*nsiz), &
                  rpn3,rpt3,rptt3,use_fwave)
             
                cfl = dmax1(cfl,cfl1d)
            
                !           # update qnew by flux differencing.
                !           # Note that the roles of the flux updates are changed.
                !           # fadd - modifies the h-fluxes
                
                if(index_capa == 0)then
                   !              #no capa array. Standard flux differencing:
                   forall (m = 1:num_eqn, k = 1:mz)
                      qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k,me1) &
                           - dtdz * (fadd(m,k+1,me1) - fadd(m,k,me1))
                   end forall
                else
                   !              # with capa array
                   forall (m = 1:num_eqn, k = 1:mz)
                      qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k,me1) &
                           - dtdz * (fadd(m,k+1,me1) - fadd(m,k,me1)) &
                           / aux(index_capa,i,j,k)
                   end forall
                endif
                
150          END DO
      !$omp end parallel
             
          endif
          
    return
    end subroutine step3ds

! ===================================================================
subroutine flux1(q1d,dq1d,aux,dt,cfl,t,ixyz,num_aux,num_eqn,mx,num_ghost,maxnx,rp,tfluct)
! ===================================================================
!
!     # Evaluate (delta t) * dq(t)/dt
!
!     The following variables, from the workspace module, are used locally:
!     amdq, apdq, amdq2, apdq2, wave, s 
!
!     amdq(num_eqn,1-num_ghost:mx+num_ghost) = left-going flux-differences
!     apdq(num_eqn,1-num_ghost:mx+num_ghost) = right-going flux-differences
!        e.g. amdq(m,i) = m'th component of A^- \Delta q from i'th Riemann
!                         problem (between cells i-1 and i).
!
!     wave(1-num_ghost:mx+num_ghost, num_eqn, num_waves) = waves from solution of
!                                           Riemann problems,
!            wave(m,mw,i) = mth component of jump in q across
!                           wave in family mw in Riemann problem between
!                           states i-1 and i.
!
!     s(num_waves,1-num_ghost:mx+num_ghost) = wave speeds,
!            s(mw,i) = speed of wave in family mw in Riemann problem between
!                      states i-1 and i.
!
!     Note that mx must be the size of the patch for the dimension corresponding
!     to the value of ixyz.
!
!     t is the time at which we want to evaluate dq/dt, which may not
!      be the current simulation time
! ===================================================================

    USE reconstruct
    USE workspace
    USE ClawParams

    implicit none

    ! Input (dummy) variables
    external :: rp, tfluct
    integer, intent(in) :: num_aux, num_eqn, num_ghost, maxnx, mx, ixyz
    double precision, intent(in) :: q1d(num_eqn,1-num_ghost:mx+num_ghost)
    double precision, intent(inout) :: dq1d(num_eqn,1-num_ghost:maxnx+num_ghost)
    double precision, target, intent(in) :: aux(num_aux,1-num_ghost:mx+num_ghost)
    double precision, intent(out) :: cfl
    double precision, intent(in) :: t, dt

!f2py intent(in,out) dq1d  
!f2py intent(out) cfl  
!f2py optional dq1d

    ! Local variables
    double precision, pointer :: auxl(:,:), auxr(:,:), qr_shift(:,:), ql_shift(:,:)
    integer :: m, mw, i

! ===================================================================

    dq1d(:,:) = 0.d0

    if (index_capa.gt.0) then
        dtdx = dt / (dx(ixyz)*aux(index_capa,:))
    else
        dtdx = dt / dx(ixyz)
    endif

    select case(lim_type)
        case(1) ! lim_type = 1: 2nd-order TVD reconstruction
        select case(char_decomp)
            case(0)
                ! TVD reconstruction w/o char. decomp.
                call tvd2(q1d,ql,qr,mthlim,num_eqn)
            case(1)
                ! wave-based second order reconstruction
                if (num_dim.eq.1) then
                    call rp(maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                            q1d,q1d,aux,aux,wave,s,amdq,apdq)
                else
                    call rp(ixyz,maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                            q1d,q1d,aux,aux,wave,s,amdq,apdq)
                endif
                ! Need to write a tvd2_fwave routine
                call tvd2_wave(q1d,ql,qr,wave,s,mthlim,num_eqn,num_ghost)
            case(2)
                ! characteristic-wise second order reconstruction
                call evec(mx,num_eqn,num_ghost,mx,q1d,aux,aux,evl,evr)
                call tvd2_char(q1d,ql,qr,mthlim,num_eqn,num_ghost,evl,evr)
        end select
        case(2) ! lim_type = 2: High-order WENO reconstruction
        select case (char_decomp)
            case (0) ! no characteristic decomposition
                call weno_comp(q1d,ql,qr,num_eqn,maxnx,num_ghost)
            case (1) ! wave-based reconstruction
                if (num_dim.eq.1) then
                    call rp(maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                            q1d,q1d,aux,aux,wave,s,amdq,apdq)
                else
                    call rp(ixyz,maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                            q1d,q1d,aux,aux,wave,s,amdq,apdq)
                endif

                if (fwave.eqv. .True.) then
                    call weno5_fwave(q1d,ql,qr,wave,s)
                else
                    call weno5_wave(q1d,ql,qr,wave)
                endif
            case (2) ! characteristic-wise reconstruction
                call evec(mx,num_eqn,num_ghost,mx,q1d,aux,aux,evl,evr)
                call weno5_char(q1d,ql,qr,maxnx,num_eqn,num_ghost,evl,evr)
            case (3) ! transmission-based reconstruction
                call evec(mx,num_eqn,num_ghost,mx,q1d,aux,aux,evl,evr)
                call weno5_trans(q1d,ql,qr,evl,evr)
            case default
                write(*,*) 'ERROR: Unrecognized characteristic decomposition option'
                write(*,*) 'You should set 0<=char_decomp<=3'
                stop
        end select
        case(3)
            call weno5(q1d,ql,qr,num_eqn,maxnx,num_ghost)
        case default
            write(*,*) 'ERROR: Unrecognized limiter type option'
            write(*,*) 'You should set 1<=lim_type<=3'
            stop
      end select


    ! solve Riemann problem at each interface 
    ! -----------------------------------------
    if (num_dim.eq.1) then
        call rp(maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                ql,qr,aux,aux,wave,s,amdq,apdq)
    else
        call rp(ixyz,maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                ql,qr,aux,aux,wave,s,amdq,apdq)
    endif

    ! compute maximum wave speed:
    cfl = 0.d0
    do mw=1,num_waves
        do i=1,mx+1
            ! if s>0 use dtdx(i) to compute CFL,
            ! if s<0 use dtdx(i-1) to compute CFL:
            cfl = dmax1(cfl, dtdx(i)*s(mw,i), -dtdx(i-1)*s(mw,i))
        enddo
    enddo

    ! Find total fluctuation within each cell
    if (tfluct_solver .eqv. .True.) then
        ! tfluct should be a special solver that uses the parameters aux(i)
        ! to solve a Riemann problem with left state ql(i)
        ! and right state qr(i), and returns a total fluctuation in amdq2
        ! NOTE that here amdq2 is really a total fluctuation (should be
        ! called adq); we do it this way just to avoid declaring more storage
        if (num_dim.eq.1) then
            call tfluct(maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                        ql,qr,aux,aux,amdq2)
        else
            call tfluct(ixyz,maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                        ql,qr,aux,aux,amdq2)
        endif

        ! Modify q using fluctuations:
        ! Note this may not correspond to a conservative flux-differencing
        ! for equations not in conservation form. It is conservative if
        ! adq = f(qr(i)) - f(ql(i)).

        forall (i=1:mx, m=1:num_eqn)
            dq1d(m,i) = dq1d(m,i) - dtdx(i)*(apdq(m,i) + &
                            amdq2(m,i) + amdq(m,i+1))
        end forall

    else
        ! Or we can just swap things around and use the usual Riemann solver
        ! This may be more convenient, but is less efficient. 
        
        qr_shift => ql(:,2-num_ghost:mx+num_ghost)
        ql_shift => qr

        auxr => aux(:,2-num_ghost:mx+num_ghost)
        auxl => aux
        
        if (num_dim.eq.1) then
            call rp(maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                    ql_shift,qr_shift,auxl,auxr,wave,s,amdq2,apdq2)
        else
            call rp(ixyz,maxnx,num_eqn,num_waves,num_aux,num_ghost,mx,&
                    ql_shift,qr_shift,auxl,auxr,wave,s,amdq2,apdq2)
        endif

        forall(i=1:mx, m=1:num_eqn)
            dq1d(m,i) = dq1d(m,i)-dtdx(i)*(amdq(m,i+1)+ &
                        apdq(m,i)+amdq2(m,i)+apdq2(m,i))
        end forall
    endif

end subroutine flux1

c
c     ==================================================================
      subroutine step3x(maxm,meqn,maux,mbc,mx,my,mz,
     &                 qold,aux,dx,dt,cflgrid,
     &                 fm,fp,rpn3)
c     ==================================================================

c     # clawpack routine ...  modified for AMRCLAW

c
c     # Take one time step, updating q.
c     # On entry, qold gives
c     #    initial data for this step
c     #    and is unchanged in this version.
c
c     # fm, fp are fluxes to left and right of single cell edge
c
c     # See the flux3 documentation for more information.
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3

      dimension
     & qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
      dimension q1d(meqn, 1-mbc:maxm+mbc)
c
      dimension fm(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension fp(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
c
      dimension faddm(meqn, 1-mbc:maxm+mbc)
      dimension faddp(meqn, 1-mbc:maxm+mbc)
c
      dimension
     &      aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
      dimension aux2(maux, 1-mbc:maxm+mbc) 

      dimension dtdx1d(1-mbc:maxm+mbc)
c
      cflgrid = 0.d0
      dtdx = dt/dx
c
      do 10 i=1-mbc,mx+mbc
         do 10 j=1-mbc,my+mbc
            do 10 k=1-mbc,mz+mbc
               do 10 m=1,meqn
                  fm(m,i,j,k) = 0.d0
                  fp(m,i,j,k) = 0.d0
  10            continue

c
      if (mcapa.eq.0) then
c        # no capa array:
         do 5 i=1-mbc,maxm+mbc
            dtdx1d(i) = dtdx
 5       continue
      endif
c
c
c     # perform x-sweeps (for Godunov split method, called from stepgrid_dimSplit)
    ! loop indices assume x sweep goes first
c     ==================
c
      do 50 k = 1-mbc,mz+mbc
         do 50 j = 1-mbc,my+mbc
c
            do 20 i = 1-mbc, mx+mbc
               do 20 m=1,meqn
c                 # copy data along a slice into 1d array:
                  q1d(m,i) = qold(m,i,j,k)
   20          continue
c
         if (mcapa.gt.0)  then
           do 23 i = 1-mbc, mx+mbc
               dtdx1d(i) = dtdx / aux(mcapa,i,j,k)
   23      continue
         endif
c
         if (maux .gt. 0)  then
            do 22 i = 1-mbc, mx+mbc
               do 22 ma=1,maux
                 aux2(ma,i) = aux(ma,i,j,k)
   22          continue
           endif
c
c
c           # compute modifications fadd to fluxes along this slice:
c
            call flux3_dimSplit(1,maxm,meqn,maux,mbc,mx,
     &                 q1d,dtdx1d,aux2,
     &                 faddm,faddp,cfl1d,
     &                 rpn3)
c
            cflgrid = dmax1(cflgrid,cfl1d)
c
c        # update fluxes for use in AMR:
c
            do 25 i=1,mx+1
               do 25 m=1,meqn
               fm(m,i,j,k) = fm(m,i,j,k) + faddm(m,i)
               fp(m,i,j,k) = fp(m,i,j,k) + faddp(m,i)
   25          continue
   50    continue
c
      return
      end

subroutine qinit(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    
    use qinit_module, only: qinit_type, add_perturbation
    use geoclaw_module, only: rho
    use multilayer_module, only: num_layers, eta_init
    
    implicit none
    
    ! Subroutine arguments
    integer, intent(in) :: meqn,mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Locals
    integer :: i,j,m,layer_index
    real(kind=8) :: eta_below
    
    ! Set flat state based on eta_init
    q = 0.d0
    do j = 1, my
        do i = 1, mx
            ! Start with bottom layer and work up, set surface below for h
            eta_below = aux(1,i,j)
            do m = num_layers, 1, -1
                layer_index = 3 * (m-1) + 1
                q(layer_index,i,j) = max(0.d0,eta_init(m) - eta_below)
                eta_below = q(layer_index,i,j) + eta_below
                q(layer_index,i,j) = q(layer_index,i,j) * rho(m)
            enddo
        enddo
    enddo
    
    ! Add perturbation to initial conditions
    if (qinit_type > 0) then
        call add_perturbation(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    endif

    if (.false.) then
        open(23, file='fort.aux', status='unknown', form='formatted')
        print *, 'Writing out aux arrays'
        print *, ' '
        do j = 1, my
            do i = 1, mx
                write(23, *) i, j, (q(m,i,j), m=1, meqn)
            enddo
        enddo
        close(23)
    endif
    
end subroutine qinit

c
c-------------------------------------------------------------------------------------
c
       subroutine prepbigstep(nvar,naux,lcheck,mptr,nx,ny,midub,mjdub,
     .                       valbgc,auxbgc,mi2tot,mj2tot)

       use amr_module
       implicit double precision (a-h,o-z)

       double precision valdub(nvar,midub,mjdub)
       double precision auxdub(naux,midub,mjdub)
       double precision valbgc(nvar,mi2tot,mj2tot)
       double precision auxbgc(naux,mi2tot,mj2tot)
       dimension fp(nvar,mi2tot,mj2tot),gp(nvar,mi2tot,mj2tot)
       dimension fm(nvar,mi2tot,mj2tot),gm(nvar,mi2tot,mj2tot)
       
          hx  = hxposs(lcheck)
          hy  = hyposs(lcheck)
          hx2 = 2.d0*hx
          hy2 = 2.d0*hy
          dt  = possk(lcheck)
          dt2 = 2. * dt
          time  = rnode(timemult,mptr)
          tpre  = time - dt

          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          ng2    = 2*nghost
          locold = node(store2,mptr)
          xlow   = rnode(cornxlo,mptr) - nghost*hx2
          ylow   = rnode(cornylo,mptr) - nghost*hy2
c

c         # transfer soln. into grid with twice the ghost cells
          call copysol(valdub,alloc(locold),nvar,mitot,mjtot,
     1              nghost,midub,mjdub,ng2)

c
          if (naux .gt. 0) then
              xl     = rnode(cornxlo, mptr)
              yb     = rnode(cornylo, mptr)
              mx = midub - 4*nghost
              my = mjdub - 4*nghost
              auxdub = NEEDS_TO_BE_SET  ! signal that needs a val
              
              call setaux(2*nghost,mx,my,xl,yb,hx,hy,
     &                    naux,auxdub)
              call auxcoarsen(auxdub,midub,mjdub,
     1                     auxbgc,mi2tot,mj2tot,naux,auxtype)
          endif

c         # fill it - use enlarged (before coarsening) aux arrays
          call bound(tpre,nvar,ng2,valdub,midub,mjdub,mptr,
     1               auxdub,naux)

c         coarsen by 2 in every direction
          call coarsen(valdub,midub,mjdub,
     1                 valbgc,mi2tot,mj2tot,nvar)

          call stepgrid(valbgc,fm,fp,gm,gp,
     1                mi2tot,mj2tot,nghost,
     2                dt2,dtnew2,hx2,hy2,nvar,
     3                xlow,ylow,tpre,mptr,naux,auxbgc)

c         update counts for error estimation work
          evol = evol + (nx/2)*(ny/2)

           return
           end

c
c ----------------------------------------------------------------------------
c
      subroutine flagcheck(rectflags,ilo,ihi,mbuff,iflags,
     .                     imin,imax,mptr)

      use amr_module
      implicit double precision (a-h, o-z)

      dimension rectflags(ilo-mbuff:ihi+mbuff)
      integer*1 iflags(ilo-mbuff:ihi+mbuff)
c
c should really only check interior border cells here
c
      level = node(nestlevel,mptr)
c
c want to check all cells for flagging, including buffer
c but wrap if periodic when put on list
c if not periodic no need to check if outside domain
c

      do 10 i = imin, imax
        if (rectflags(i) .le. DONTFLAG) go to 10
        if (iflags(i) .ne. 1) then  !point not nested. turn off
             rectflags(i) = 0.
             if (nprint) then
                write(outunit,100) i,mptr
 100            format("turning off point ",2i5," from grid ",i5)
             endif
        endif
 10   continue

      return
      end

c
c
c     =====================================================
      subroutine rpn2(ixy,maxm,meqn,mwaves,mbc,mx,ql,qr,auxl,auxr,
     &                  wave,s,amdq,apdq)
c     =====================================================
c
c     # Roe-solver for the Euler equations with a tracer variable
c     # and separate shear and entropy waves.
c
c     # solve Riemann problems along one slice of data.
c
c     # On input, ql contains the state vector at the left edge of each cell
c     #           qr contains the state vector at the right edge of each cell
c
c     # This data is along a slice in the x-direction if ixy=1 
c     #                            or the y-direction if ixy=2.
c     # On output, wave contains the waves, s the speeds, 
c     # and amdq, apdq the decomposition of the flux difference
c     #   f(qr(i-1)) - f(ql(i))  
c     # into leftgoing and rightgoing parts respectively.
c     # With the Roe solver we have   
c     #    amdq  =  A^- \Delta q    and    apdq  =  A^+ \Delta q
c     # where A is the Roe matrix.  An entropy fix can also be incorporated
c     # into the flux differences.
c
c     # Note that the i'th Riemann problem has left state qr(:,i-1)
c     #                                    and right state ql(:,i)
c     # From the basic clawpack routines, this routine is called with ql = qr
c
c
      implicit double precision (a-h,o-z)
c
      dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
      dimension    s(mwaves, 1-mbc:maxm+mbc)
      dimension   ql(meqn, 1-mbc:maxm+mbc)
      dimension   qr(meqn, 1-mbc:maxm+mbc)
      dimension  apdq(meqn, 1-mbc:maxm+mbc)
      dimension  amdq(meqn, 1-mbc:maxm+mbc)
c
c     local arrays -- common block comroe is passed to rpt2eu
c     ------------
      parameter (maxm2 = 1800)  
      dimension delta(4)
      logical efix
      common /cparam/  gamma,gamma1
c     # assumes at most maxm2 * maxm2 grid with mbc<=3
c
      data efix /.true./    !# use entropy fix for transonic rarefactions
c
c
c     # set mu to point to  the component of the system that corresponds
c     # to momentum in the direction of this slice, mv to the orthogonal
c     # momentum:
c
      if (ixy.eq.1) then
          mu = 2
          mv = 3
        else
          mu = 3
          mv = 2
        endif
c
c     # note that notation for u and v reflects assumption that the 
c     # Riemann problems are in the x-direction with u in the normal
c     # direction and v in the orthogonal direction, but with the above
c     # definitions of mu and mv the routine also works with ixy=2
c     # and returns, for example, f0 as the Godunov flux g0 for the
c     # Riemann problems u_t + g(u)_y = 0 in the y-direction.
c
c
c     # compute the Roe-averaged variables needed in the Roe solver.
c     # These are stored in the common block comroe since they are
c     # later used in routine rpt2eu to do the transverse wave splitting.
c
      do 20 i = 2-mbc, mx+mbc
         rhsqrtl = dsqrt(qr(1,i-1))
         rhsqrtr = dsqrt(ql(1,i))
         pl = gamma1*(qr(4,i-1) - 0.5d0*(qr(2,i-1)**2 +
     &        qr(3,i-1)**2)/qr(1,i-1))
         pr = gamma1*(ql(4,i) - 0.5d0*(ql(2,i)**2 +
     &        ql(3,i)**2)/ql(1,i))
         rhsq2 = rhsqrtl + rhsqrtr
         u = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
         v = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
         enth = (((qr(4,i-1)+pl)/rhsqrtl
     &             + (ql(4,i)+pr)/rhsqrtr)) / rhsq2
         u2v2 = u**2 + v**2
         a2 = gamma1*(enth - .5d0*u2v2)
         a = dsqrt(a2)
         g1a2 = gamma1 / a2
         euv = enth - u2v2 
c
c
c     # now split the jump in q at each interface into waves
c
c     # find a1 thru a4, the coefficients of the 4 eigenvectors:
         delta(1) = ql(1,i) - qr(1,i-1)
         delta(2) = ql(mu,i) - qr(mu,i-1)
         delta(3) = ql(mv,i) - qr(mv,i-1)
         delta(4) = ql(4,i) - qr(4,i-1)
         a3 = g1a2 * (euv*delta(1) 
     &      + u*delta(2) + v*delta(3) - delta(4))
         a2 = delta(3) - v*delta(1)
         a4 = (delta(2) + (a-u)*delta(1) - a*a3) / (2.d0*a)
         a1 = delta(1) - a3 - a4
c
c        # Compute the waves.
c
c        # acoustic:
         wave(1,1,i) = a1
         wave(mu,1,i) = a1*(u-a)
         wave(mv,1,i) = a1*v
         wave(4,1,i) = a1*(enth - u*a)
         wave(5,1,i) = 0.d0
         s(1,i) = u-a
c
c        # shear:
         wave(1,2,i) = 0.d0
         wave(mu,2,i) = 0.d0
         wave(mv,2,i) = a2
         wave(4,2,i) = a2*v
         wave(5,2,i) = 0.d0
         s(2,i) = u
c
c        # entropy:
         wave(1,3,i) = a3
         wave(mu,3,i) = a3*u
         wave(mv,3,i) = a3*v
         wave(4,3,i) = a3*0.5d0*u2v2
         wave(5,3,i) = 0.d0
         s(3,i) = u
c
c        # acoustic:
         wave(1,4,i) = a4
         wave(mu,4,i) = a4*(u+a)
         wave(mv,4,i) = a4*v
         wave(4,4,i) = a4*(enth+u*a)
         wave(5,4,i) = 0.d0
         s(4,i) = u+a
c
c        # Another wave added for tracer concentration:
c
c        # tracer:
         wave(1,5,i) = 0.d0
         wave(mu,5,i) = 0.d0
         wave(mv,5,i) = 0.d0
         wave(4,5,i) = 0.d0
         wave(5,5,i) = ql(5,i) - qr(5,i-1)
         s(5,i) = u
c
   20    continue
c
c
c    # compute flux differences amdq and apdq.
c    ---------------------------------------
c
      if (efix) go to 110
c
c     # no entropy fix
c     ----------------
c
c     # amdq = SUM s*wave   over left-going waves
c     # apdq = SUM s*wave   over right-going waves
c
      do 100 m=1,meqn
         do 100 i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do 90 mw=1,mwaves
               if (s(mw,i) .lt. 0.d0) then
                   amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                 else
                   apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                 endif
   90          continue
  100       continue
      go to 900     
c
c-----------------------------------------------------
c
  110 continue
c
c     # With entropy fix
c     ------------------
c
c    # compute flux differences amdq and apdq.
c    # First compute amdq as sum of s*wave for left going waves.
c    # Incorporate entropy fix by adding a modified fraction of wave
c    # if s should change sign.
c
      do 200 i = 2-mbc, mx+mbc
c
c        # check 1-wave:
c        ---------------
c
         rhoim1 = qr(1,i-1)
         pim1 = gamma1*(qr(4,i-1) - 0.5d0*(qr(mu,i-1)**2 
     &           + qr(mv,i-1)**2) / rhoim1)
         cim1 = dsqrt(gamma*pim1/rhoim1)
         s0 = qr(mu,i-1)/rhoim1 - cim1     !# u-c in left state (cell i-1)

c        # check for fully supersonic case:
         if (s0.ge.0.d0 .and. s(1,i).gt.0.d0)  then
c            # everything is right-going
             do 60 m=1,meqn
                amdq(m,i) = 0.d0
   60           continue
             go to 200 
             endif
c
         rho1 = qr(1,i-1) + wave(1,1,i)
         rhou1 = qr(mu,i-1) + wave(mu,1,i)
         rhov1 = qr(mv,i-1) + wave(mv,1,i)
         en1 = qr(4,i-1) + wave(4,1,i)
         p1 = gamma1*(en1 - 0.5d0*(rhou1**2 + rhov1**2)/rho1)
         c1 = dsqrt(gamma*p1/rho1)
         s1 = rhou1/rho1 - c1  !# u-c to right of 1-wave
         if (s0.lt.0.d0 .and. s1.gt.0.d0) then
c            # transonic rarefaction in the 1-wave
             sfract = s0 * (s1-s(1,i)) / (s1-s0)
           else if (s(1,i) .lt. 0.d0) then
c            # 1-wave is leftgoing
             sfract = s(1,i)
           else
c            # 1-wave is rightgoing
             sfract = 0.d0   !# this shouldn't happen since s0 < 0
           endif
         do 120 m=1,meqn
            amdq(m,i) = sfract*wave(m,1,i)
  120       continue
c
c        # check contact discontinuity:
c        ------------------------------
c
         if (s(2,i) .ge. 0.d0) go to 200  !# 2- 3- and 5-waves are rightgoing
         do 140 m=1,meqn
            amdq(m,i) = amdq(m,i) + s(2,i)*wave(m,2,i)
            amdq(m,i) = amdq(m,i) + s(3,i)*wave(m,3,i)
            amdq(m,i) = amdq(m,i) + s(5,i)*wave(m,5,i)
  140       continue
c
c        # check 4-wave:
c        ---------------
c
         rhoi = ql(1,i)
         pi = gamma1*(ql(4,i) - 0.5d0*(ql(mu,i)**2 
     &           + ql(mv,i)**2) / rhoi)
         ci = dsqrt(gamma*pi/rhoi)
         s3 = ql(mu,i)/rhoi + ci     !# u+c in right state  (cell i)
c
         rho2 = ql(1,i) - wave(1,4,i)
         rhou2 = ql(mu,i) - wave(mu,4,i)
         rhov2 = ql(mv,i) - wave(mv,4,i)
         en2 = ql(4,i) - wave(4,4,i)
         p2 = gamma1*(en2 - 0.5d0*(rhou2**2 + rhov2**2)/rho2)
         c2 = dsqrt(gamma*p2/rho2)
         s2 = rhou2/rho2 + c2   !# u+c to left of 4-wave
         if (s2 .lt. 0.d0 .and. s3.gt.0.d0) then
c            # transonic rarefaction in the 4-wave
             sfract = s2 * (s3-s(4,i)) / (s3-s2)
           else if (s(4,i) .lt. 0.d0) then
c            # 4-wave is leftgoing
             sfract = s(4,i)
           else 
c            # 4-wave is rightgoing
             go to 200
           endif
c
         do 160 m=1,meqn
            amdq(m,i) = amdq(m,i) + sfract*wave(m,4,i)
  160       continue
  200    continue
c
c     # compute the rightgoing flux differences:
c     # df = SUM s*wave   is the total flux difference and apdq = df - amdq
c
      do 220 m=1,meqn
         do 220 i = 2-mbc, mx+mbc
            df = 0.d0
            do 210 mw=1,mwaves
               df = df + s(mw,i)*wave(m,mw,i)
  210          continue
            apdq(m,i) = df - amdq(m,i)
  220       continue
c
  900 continue
      return
      end

c
c --------------------------------------------------------------
c
      subroutine preintcopy(val,mitot,mjtot,nvar,ilo,ihi,jlo,jhi,
     1                      level,fliparray)
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension fliparray((mitot+mjtot)*nghost*nvar)
      dimension val(nvar,mitot,mjtot)
      dimension ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)

c  NEW INDEXING ORDER SWITCHED
      iadd(ivar,i,j)  = locflip + ivar-1 + nvar*((j-1)*nr+i-1)
c
c  :::::::::::::: PREINTCOPY :::::::::::::::::::::::::::::::::::::::::::
c     For periodic boundary conditions more work needed to initialize a
c     new grid that sticks out. This routine was
c     called because the patch sticks out of the domain,
c     and has periodic bc.s preprocess the patch before calling
c     intcopy to shift the patch periodically back into the domain.
c
c     Inputs to this routine:
c     ilo,ihi,jlo,jhi = the location in index space of this patch.
c
c     Outputs from this routine:
c     The values of the grid are inserted
c     directly into the enlarged val array for this piece.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
        locflip = 1        

c
c     # will divide patch into 9 possibilities (some empty): 
c       x sticks out left, x interior, x sticks out right
c       same for y. for example, the max. would be
c       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)
        
        if (xperdom) then
           ist(1) = ilo
           ist(2) = 0
           ist(3) = iregsz(level)
           iend(1) = -1
           iend(2) = iregsz(level)-1
           iend(3) = ihi
           ishift(1) = iregsz(level)
           ishift(2) = 0
           ishift(3) = -iregsz(level)
        else    ! if not periodic, set vals to only have nonnull intersection for interior region
           ist(1)    = iregsz(level)
           ist(2)    = ilo
           ist(3)    = iregsz(level)
           iend(1)   = -1
           iend(2)   = ihi
           iend(3)   = -1
           ishift(1) = 0
           ishift(2) = 0
           ishift(3) = 0
        endif


        if (yperdom .or. spheredom) then
           jst(1) = jlo
           jst(2) = 0
           jst(3) = jregsz(level)
           jend(1) = -1
           jend(2) = jregsz(level)-1
           jend(3) = jhi
           jshift(1) = jregsz(level)
           jshift(2) = 0
           jshift(3) = -jregsz(level)
        else
           jst(1)    = jregsz(level)
           jst(2)    = jlo
           jst(3)    = jregsz(level)
           jend(1)   = -1
           jend(2)   = jhi
           jend(3)   = -1
           jshift(1) = 0
           jshift(2) = 0
           jshift(3) = 0
        endif


       do 20 i = 1, 3
          i1 = max(ilo,  ist(i))
          i2 = min(ihi, iend(i))
          if (i1 .gt. i2) go to 20
       do 10 j = 1, 3
          j1 = max(jlo,  jst(j))
          j2 = min(jhi, jend(j))


          if (j1 .le. j2) then ! part of patch in this region
c
c check if special mapping needed for spherical bc. 
c(j=2 is interior,nothing special needed)
            if (.not. spheredom .or. j .eq. 2) then
            iputst = (i1 - ilo) + 1
            jputst = (j1 - jlo) + 1
            call intcopy(val,mitot,mjtot,nvar,
     2                    i1+ishift(i),i2+ishift(i),
     3                    j1+jshift(j),j2+jshift(j),level,
     4                    iputst,jputst)
          else
              nr = i2 - i1 + 1
              nc = j2 - j1 + 1
              ng = 0    ! no ghost cells in this little patch. fill everything.

              jbump = 0
              if (j1 < 0)   jbump = abs(j1)  ! bump up so new bottom is 0
              if (j2 >= jregsz(level)) jbump = -(j2+1-jregsz(level)) ! bump down

c             next 2 lines would take care of periodicity in x
              iwrap1 = i1 + ishift(i)
              iwrap2 = i2 + ishift(i)
c             next 2 lines take care of mapped sphere bcs
              iwrap1 = iregsz(level) - iwrap1 -1
              iwrap2 = iregsz(level) - iwrap2 -1
c             swap so that smaller one is left index, etc since mapping reflects
              tmp = iwrap1
              iwrap1 = iwrap2
              iwrap2 = tmp

              jwrap1 = j1 + jbump
              xlwrap = xlower + iwrap1*hxposs(level)
              ybwrap = ylower + jwrap1*hyposs(level)
              jwrap2 = j2 + jbump

c             write(dbugunit,101) i1,i2,j1,j2
c             write(dbugunit6,102) iwrap1,iwrap2,j1+jbump,j2+jbump
 101          format(" actual patch from i:",2i5," j :",2i5)
 102          format(" intcopy called w i:",2i5," j :",2i5)
              call intcopy(fliparray,nr,nc,nvar,
     1                     iwrap1,iwrap2,jwrap1,jwrap2,level,1,1)

c             copy back using weird mapping for spherical folding
              nrowst = 1   ! start filling up val at (1,1) - no additional offset
              ncolst = 1
              do ii = i1, i2
              do jj = j1, j2
c            write(dbugunit6,100)nrowst+ii-ilo,ncolst+jj-jlo,nr-(ii-i1),
c    1                            nc-jj+j1
 100          format(" filling loc ",2i5," with ",2i5)

              do ivar = 1, nvar
                 iindex = nr-(ii-i1)
                 jindex = nc-(jj-j1)
                 index = iadd(ivar,nr-(ii-i1),nc-(jj-j1))
                 val(ivar,nrowst+(ii-ilo),ncolst+(jj-jlo)) = 
     1                  fliparray(iadd(ivar,nr-(ii-i1),nc-(jj-j1)))
              end do
              end do
              end do
             

            endif

          endif

 10    continue
 20    continue
      
     
      return
      end

subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
!
! Roe-solver for the Euler equations with a tracer variable and separate shear
! and entropy waves.

! waves: 4
! equations: 5

! Conserved quantities:
!       1 density
!       2 x_momentum
!       3 y_momentum
!       4 energy
!       5 tracer

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
!
! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.
! On output, wave contains the waves, s the speeds,
! and amdq, apdq the decomposition of the flux difference
!     f(qr(i-1)) - f(ql(i))
! into leftgoing and rightgoing parts respectively.  With the Roe solver we have
!      amdq  =  A^- \Delta q    and    apdq  =  A^+ \Delta q
! where A is the Roe matrix.  An entropy fix can also be incorporated into the 
! flux differences.

! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                   and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr
!
! This routine has been made thread safe by removing the common block storage
! of the Roe-averages.

    
    implicit none

    ! Input
    integer, intent(in) :: ixy, maxm, meqn, mwaves, mbc, mx, maux
    real(kind=8), intent(in) :: ql(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: qr(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: auxl(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: auxr(maux, 1-mbc:maxm+mbc)

    ! Output
    real(kind=8), intent(in out) :: wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: s(mwaves, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: apdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: amdq(meqn, 1-mbc:maxm+mbc)

    ! Local storage
    integer :: i, m, mw, mu, mv
    real(kind=8) :: rho_sqrtl, rho_sqrtr, rho_sq2, u, v, u2v2, pl, pr, enth, c
    real(kind=8) :: g1c2, euv
    real(kind=8) :: delta(4), a(4)

    real(kind=8) :: rhoim1, pim1, cim1, s0, rho1, rhou1, rhov1, en1, p1, c1, s1
    real(kind=8) :: sfract, rhoi, pi, ci, s3, rho2, rhou2, rhov2, en2, p2, c2
    real(kind=8) :: s2, df

    ! Use entropy fix for transonic rarefactions
    logical, parameter :: efix = .true. 

    ! Common block storage
    ! Ideal gas constant
    real(kind=8) :: gamma, gamma1
    common /cparam/  gamma

    gamma1 = gamma - 1.d0

    ! Set mu to point to  the component of the system that corresponds to 
    ! momentum in the direction of this slice, mv to the orthogonal momentum:
    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif
    ! Note that notation for u and v reflects assumption that the Riemann
    ! problems  are in the x-direction with u in the normal direciton and v in
    ! the orthogonal direcion, but with the above definitions of mu and mv the
    ! routine also works  with ixy=2 and returns, for example, f0 as the Godunov
    ! flux g0 for the Riemann problems u_t + g(u)_y = 0 in the y-direction.

    ! Initialize waves and speeds
    wave = 0.d0
    s = 0.d0

    ! Primary loop over grid cell interfaces
    do i = 2-mbc, mx+mbc
        ! Compute Roe-averaged quantities
        rho_sqrtl = sqrt(qr(1,i-1))
        rho_sqrtr = sqrt(ql(1,i))
        rho_sq2 = rho_sqrtl + rho_sqrtr

        u = (qr(mu,i-1) / rho_sqrtl + ql(mu,i) / rho_sqrtr) / rho_sq2
        v = (qr(mv,i-1) / rho_sqrtl + ql(mv,i) / rho_sqrtr) / rho_sq2
        u2v2 = u**2 + v**2

        pl = gamma1 * (qr(4,i-1) - 0.5d0 * (qr(2,i-1)**2 + qr(3,i-1)**2) / qr(1,i-1))
        pr = gamma1 * (ql(4,i)   - 0.5d0 * (ql(2,i)**2   + ql(3,i)**2) / ql(1,i))
        enth = (((qr(4,i-1) + pl) / rho_sqrtl + (ql(4,i) + pr) / rho_sqrtr)) / rho_sq2
        
        c = sqrt(gamma1 * (enth - 0.5d0 * u2v2))
        g1c2 = gamma1 / (gamma1 * (enth - 0.5d0 * u2v2))
        euv = enth - u2v2

        ! Now split the jump in q at each interface into waves and find a1 thru
        ! a4, the coefficients of the 4 eigenvectors:
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(mu,i) - qr(mu,i-1)
        delta(3) = ql(mv,i) - qr(mv,i-1)
        delta(4) = ql(4,i) - qr(4,i-1)

        a(3) = g1c2 * (euv * delta(1) + u * delta(2) + v * delta(3) - delta(4))
        a(2) = delta(3) - v * delta(1)
        a(4) = (delta(2) + (c-u) * delta(1) - c * a(3)) / (2.d0 * c)
        a(1) = delta(1) - a(3) - a(4)

        ! Compute the waves
        ! Acoustic, left-going
        wave( 1,1,i) = a(1) 
        wave(mu,1,i) = a(1) * (u - c)
        wave(mv,1,i) = a(1) * v
        wave( 4,1,i) = a(1) * (enth - u * c)
        wave( 5,1,i) = 0.d0

        s(1,i) = u - c

        ! Shear wave
        wave( 1,2,i) = 0.d0
        wave(mu,2,i) = 0.d0
        wave(mv,2,i) = a(2)
        wave( 4,2,i) = a(2) * v
        wave( 5,2,i) = 0.d0

        s(2,i) = u

        ! Entropy
        wave( 1,3,i) = a(3)
        wave(mu,3,i) = a(3) * u
        wave(mv,3,i) = a(3) * v
        wave( 4,3,i) = a(3) * 0.5d0 * u2v2
        wave( 5,3,i) = 0.d0

        s(3,i) = u
    
        ! Acoustic, right-going
        wave( 1,4,i) = a(4)
        wave(mu,4,i) = a(4) * (u + c)
        wave(mv,4,i) = a(4) * v
        wave( 4,4,i) = a(4) * (enth + u * c)
        wave( 5,4,i) = 0.d0

        s(4,i) = u + c

        ! Tracer wave - only carried in 5th component of q
        wave(5,5,i) = ql(5,i) - qr(5,i-1)

        s(5,i) = u

    end do

    if (.not.efix) then
        ! Compute flux differences amdq and apdq.
        ! No entropy fix
        !
        ! amdq = SUM s*wave   over left-going waves
        ! apdq = SUM s*wave   over right-going waves
        amdq = 0.d0
        apdq = 0.d0
        do i=2-mbc, mx+mbc
            do mw=1,mwaves
                if (s(mw,i) < 0.d0) then
                    amdq(:,i) = amdq(:,i) + s(mw,i) * wave(:,mw,i)
                else
                    apdq(:,i) = apdq(:,i) + s(mw,i) * wave(:,mw,i)
                endif
            enddo
        enddo

    else
        ! With entropy fix

        ! compute flux differences amdq and apdq.
        ! First compute amdq as sum of s*wave for left going waves.
        ! Incorporate entropy fix by adding a modified fraction of wave
        ! if s should change sign.
        amdq = 0.d0
        apdq = 0.d0
        do i = 2-mbc, mx+mbc
            ! Check 1-wave
            rhoim1 = qr(1,i-1)
            pim1 = gamma1*(qr(4,i-1) - 0.5d0*(qr(mu,i-1)**2 + qr(mv,i-1)**2) / rhoim1)
            cim1 = dsqrt(gamma*pim1/rhoim1)
            s0 = qr(mu,i-1)/rhoim1 - cim1     ! u-c in left state (cell i-1)

            ! Check for fully supersonic case:
            if (s0 >= 0.d0 .and. s(1,i) > 0.d0)  then
                ! Everything is right-going
                cycle
            endif
    
            rho1 = qr(1,i-1) + wave(1,1,i)
            rhou1 = qr(mu,i-1) + wave(mu,1,i)
            rhov1 = qr(mv,i-1) + wave(mv,1,i)
            en1 = qr(4,i-1) + wave(4,1,i)
            p1 = gamma1 * (en1 - 0.5d0 * (rhou1**2 + rhov1**2) / rho1)
            c1 = sqrt(gamma * p1 / rho1)
            s1 = rhou1 / rho1 - c1  ! u-c to right of 1-wave
            if (s0 < 0.d0 .and. s1 > 0.d0) then
                ! Transonic rarefaction in the 1-wave
                sfract = s0 * (s1-s(1,i)) / (s1-s0)
            else if (s(1,i) < 0.d0) then
                ! 1-wave is leftgoing
                sfract = s(1,i)
            else
                ! 1-wave is rightgoing
                sfract = 0.d0   ! This shouldn't happen since s0 < 0
            endif
            do m=1,meqn
                amdq(m,i) = sfract * wave(m,1,i)
            end do
        
            ! Check contact discontinuity:
            if (s(2,i) >= 0.d0) then
                !# 2- 3- and 5-waves are rightgoing
                cycle
            endif

            amdq(:,i) = amdq(:,i) + s(2,i) * wave(:,2,i)
            amdq(:,i) = amdq(:,i) + s(3,i) * wave(:,3,i)
            amdq(:,i) = amdq(:,i) + s(5,i) * wave(:,5,i)
        
            ! Check 4-wave:
            rhoi = ql(1,i)
            pi = gamma1*(ql(4,i) - 0.5d0*(ql(mu,i)**2 + ql(mv,i)**2) / rhoi)
            ci = sqrt(gamma*pi/rhoi)
            s3 = ql(mu,i)/rhoi + ci     ! u+c in right state  (cell i)
        
            rho2 = ql(1,i) - wave(1,4,i)
            rhou2 = ql(mu,i) - wave(mu,4,i)
            rhov2 = ql(mv,i) - wave(mv,4,i)
            en2 = ql(4,i) - wave(4,4,i)
            p2 = gamma1*(en2 - 0.5d0*(rhou2**2 + rhov2**2)/rho2)
            c2 = sqrt(gamma*p2/rho2)
            s2 = rhou2/rho2 + c2   ! u+c to left of 4-wave
            if (s2 < 0.d0 .and. s3 > 0.d0) then
                ! Transonic rarefaction in the 4-wave
                sfract = s2 * (s3-s(4,i)) / (s3-s2)
            else if (s(4,i) < 0.d0) then
                ! 4-wave is leftgoing
                sfract = s(4,i)
            else
                ! 4-wave is rightgoing
                cycle
            endif
            
            amdq(:,i) = amdq(:,i) + sfract * wave(:,4,i)
        enddo

        ! Compute the remaining right-going flux differences:
        ! df = SUM s*wave   is the total flux difference and apdq = df - amdq
        do m=1,meqn
            do i = 2-mbc, mx+mbc
                df = 0.d0
                do mw=1,mwaves
                    df = df + s(mw,i) * wave(m,mw,i)
                enddo
                apdq(m,i) = df - amdq(m,i)
            enddo
        enddo

        ! End of entropy corrections
    endif
end subroutine rpn2

c
c     ==================================================================
      subroutine step3(maxm,maxmx,maxmy,maxmz,meqn,maux,mbc,mx,my,mz,
     &                qold,aux,dx,dy,dz,dt,cflgrid,
     &                 fm,fp,gm,gp,hm,hp,
     &                 faddm,faddp,gadd,hadd,
     &                 q1d,dtdx1d,dtdy1d,dtdz1d,
     &                 aux1,aux2,aux3,work,mwork,rpn3,rpt3,rptt3)
c     ==================================================================

c     # clawpack routine ...  modified for AMRCLAW

c
c     # Take one time step, updating q.
c     # On entry, qold gives
c     #    initial data for this step
c     #    and is unchanged in this version.
c
c     # fm, fp are fluxes to left and right of single cell edge
c
c     # See the flux3 documentation for more information.
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3,rpt3,rptt3

      dimension
     & qold(meqn, 1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, 1-mbc:maxmz+mbc)
      dimension q1d(meqn, 1-mbc:maxm+mbc)
c
      dimension fm(meqn,1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,1-mbc:maxmz+mbc)
      dimension fp(meqn,1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,1-mbc:maxmz+mbc)
      dimension gm(meqn,1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,1-mbc:maxmz+mbc)
      dimension gp(meqn,1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,1-mbc:maxmz+mbc)
      dimension hm(meqn,1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,1-mbc:maxmz+mbc)
      dimension hp(meqn,1-mbc:maxmx+mbc,1-mbc:maxmy+mbc,1-mbc:maxmz+mbc)
c
      dimension faddm(meqn, 1-mbc:maxm+mbc)
      dimension faddp(meqn, 1-mbc:maxm+mbc)
      dimension  gadd(meqn, 1-mbc:maxm+mbc, 2, -1:1)
      dimension  hadd(meqn, 1-mbc:maxm+mbc, 2, -1:1)
c
      dimension
     & aux(maux, 1-mbc:maxmx+mbc, 1-mbc:maxmy+mbc, 1-mbc:maxmz+mbc)
      dimension aux1(maux, 1-mbc:maxm+mbc, 3)
      dimension aux2(maux, 1-mbc:maxm+mbc, 3)
      dimension aux3(maux, 1-mbc:maxm+mbc, 3)
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension dtdy1d(1-mbc:maxm+mbc)
      dimension dtdz1d(1-mbc:maxm+mbc)
      dimension work(mwork)
c$$$      common /comxyzt/ dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom
c
c     # store mesh parameters that may be needed in Riemann solver but not
c     # passed in...
c$$$      dxcom = dx
c$$$      dycom = dy
c$$$      dtcom = dt
c
c
c     # partition work array into pieces needed for local storage in
c     # flux3 routine.  Find starting index of each piece:
c
      i0wave     = 1
      i0s        = i0wave     + (maxm+2*mbc)*meqn*mwaves
      i0amdq     = i0s        + (maxm+2*mbc)*mwaves
      i0apdq     = i0amdq     + (maxm+2*mbc)*meqn
      i0cqxx     = i0apdq     + (maxm+2*mbc)*meqn
      i0bmamdq   = i0cqxx     + (maxm+2*mbc)*meqn
      i0bmapdq   = i0bmamdq   + (maxm+2*mbc)*meqn
      i0bpamdq   = i0bmapdq   + (maxm+2*mbc)*meqn
      i0bpapdq   = i0bpamdq   + (maxm+2*mbc)*meqn
      i0cmamdq   = i0bpapdq   + (maxm+2*mbc)*meqn
      i0cmapdq   = i0cmamdq   + (maxm+2*mbc)*meqn
      i0cpamdq   = i0cmapdq   + (maxm+2*mbc)*meqn
      i0cpapdq   = i0cpamdq   + (maxm+2*mbc)*meqn
      i0cmamdq2  = i0cpapdq   + (maxm+2*mbc)*meqn
      i0cmapdq2  = i0cmamdq2  + (maxm+2*mbc)*meqn
      i0cpamdq2  = i0cmapdq2  + (maxm+2*mbc)*meqn
      i0cpapdq2  = i0cpamdq2  + (maxm+2*mbc)*meqn

      i0bmcqxxm   = i0cpapdq2  + (maxm+2*mbc)*meqn
      i0bmcqxxp   = i0bmcqxxm  + (maxm+2*mbc)*meqn
      i0bpcqxxm   = i0bmcqxxp  + (maxm+2*mbc)*meqn
      i0bpcqxxp   = i0bpcqxxm  + (maxm+2*mbc)*meqn
      i0cmcqxxm   = i0bpcqxxp  + (maxm+2*mbc)*meqn
      i0cmcqxxp   = i0cmcqxxm  + (maxm+2*mbc)*meqn
      i0cpcqxxm   = i0cmcqxxp  + (maxm+2*mbc)*meqn
      i0cpcqxxp   = i0cpcqxxm  + (maxm+2*mbc)*meqn

      work(i0bmcqxxm) = i0bmcqxxm
      work(i0bmcqxxp) = i0bmcqxxp
      work(i0bpcqxxm) = i0bpcqxxm
      work(i0bpcqxxp) = i0bpcqxxp
      work(i0cmcqxxm) = i0cmcqxxm
      work(i0cmcqxxp) = i0cmcqxxp
      work(i0cpcqxxm) = i0cpcqxxm
      work(i0cpcqxxp) = i0cpcqxxp

      i0bmcmamdq = i0cpcqxxp  + (maxm+2*mbc)*meqn
      i0bmcmapdq = i0bmcmamdq + (maxm+2*mbc)*meqn
      i0bpcmamdq = i0bmcmapdq + (maxm+2*mbc)*meqn
      i0bpcmapdq = i0bpcmamdq + (maxm+2*mbc)*meqn
      i0bmcpamdq = i0bpcmapdq + (maxm+2*mbc)*meqn
      i0bmcpapdq = i0bmcpamdq + (maxm+2*mbc)*meqn
      i0bpcpamdq = i0bmcpapdq + (maxm+2*mbc)*meqn
      i0bpcpapdq = i0bpcpamdq + (maxm+2*mbc)*meqn
      iused      = i0bpcpapdq + (maxm+2*mbc)*meqn - 1
c
      if (iused.gt.mwork) then
c        # This shouldnt happen if mwork is set properly in stepgrid3
         write(6,*) '*** not enough work space in step3'
         write(6,*) '*** check parameter mwork in stepgrid3'
         write(6,*) '*** iused = ', iused, '   mwork =',mwork
         stop
      endif
c
c
      cflgrid = 0.d0
      dtdx = dt/dx
      dtdy = dt/dy
      dtdz = dt/dz
c
      do 10 i=1-mbc,mx+mbc
         do 10 j=1-mbc,my+mbc
            do 10 k=1-mbc,mz+mbc
               do 10 m=1,meqn
                  fm(m,i,j,k) = 0.d0
                  fp(m,i,j,k) = 0.d0
                  gm(m,i,j,k) = 0.d0
                  gp(m,i,j,k) = 0.d0
                  hm(m,i,j,k) = 0.d0
                  hp(m,i,j,k) = 0.d0
 10            continue

c
      if (mcapa.eq.0) then
c        # no capa array:
         do 5 i=1-mbc,maxm+mbc
            dtdx1d(i) = dtdx
            dtdy1d(i) = dtdy
            dtdz1d(i) = dtdz
    5       continue
         endif
c
c
c     # perform x-sweeps
c     ==================
c
      do 50 k = 0,mz+1
         do 50 j = 0,my+1
c
            do 20 i = 1-mbc, mx+mbc
               do 20 m=1,meqn
c                 # copy data along a slice into 1d array:
                  q1d(m,i) = qold(m,i,j,k)
   20          continue
c
         if (mcapa.gt.0)  then
           do 23 i = 1-mbc, mx+mbc
               dtdx1d(i) = dtdx / aux(mcapa,i,j,k)
   23      continue
         endif
c
         if (maux .gt. 0)  then
            do 22 i = 1-mbc, mx+mbc
               do 22 ma=1,maux
                 aux1(ma,i,1) = aux(ma,i,j-1,k-1)
                 aux1(ma,i,2) = aux(ma,i,j-1,k)
                 aux1(ma,i,3) = aux(ma,i,j-1,k+1)
                 aux2(ma,i,1) = aux(ma,i,j,k-1)
                 aux2(ma,i,2) = aux(ma,i,j,k)
                 aux2(ma,i,3) = aux(ma,i,j,k+1)
                 aux3(ma,i,1) = aux(ma,i,j+1,k-1)
                 aux3(ma,i,2) = aux(ma,i,j+1,k)
                 aux3(ma,i,3) = aux(ma,i,j+1,k+1)
   22          continue
           endif
c
c           # Store the value of j and k along this slice in the common block
c           # comxyt in case it is needed in the Riemann solver (for
c           # variable coefficient problems)
c
c$$$        jcom = j
c$$$        kcom = k
c
c           # compute modifications fadd, gadd and hadd to fluxes along
c           # this slice:
c
            call flux3(1,maxm,meqn,maux,mbc,mx,
     &                 q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3,
     &                 faddm,faddp,gadd,hadd,cfl1d,
     &                 work(i0wave),work(i0s),work(i0amdq),
     &                 work(i0apdq),work(i0cqxx),
     &                 work(i0bmamdq),work(i0bmapdq),
     &                 work(i0bpamdq),work(i0bpapdq),
     &                 work(i0cmamdq),work(i0cmapdq),
     &                 work(i0cpamdq),work(i0cpapdq),
     &                 work(i0cmamdq2),work(i0cmapdq2),
     &                 work(i0cpamdq2),work(i0cpapdq2),

     &                 work(i0bmcqxxm),work(i0bmcqxxp),
     &                 work(i0bpcqxxm),work(i0bpcqxxp),
     &                 work(i0cmcqxxm),work(i0cmcqxxp),
     &                 work(i0cpcqxxm),work(i0cpcqxxp),

     &                 work(i0bmcmamdq),work(i0bmcmapdq),
     &                 work(i0bpcmamdq),work(i0bpcmapdq),
     &                 work(i0bmcpamdq),work(i0bmcpapdq),
     &                 work(i0bpcpamdq),work(i0bpcpapdq),
     &                 rpn3,rpt3,rptt3)
c
            cflgrid = dmax1(cflgrid,cfl1d)
c
c        # update fluxes for use in AMR:
c
            do 25 i=1,mx+1
               do 25 m=1,meqn
               fm(m,i,j,k) = fm(m,i,j,k) + faddm(m,i)
               fp(m,i,j,k) = fp(m,i,j,k) + faddp(m,i)
c
               gm(m,i,j  ,k-1) = gm(m,i,j  ,k-1) + gadd(m,i,1,-1)
               gp(m,i,j  ,k-1) = gp(m,i,j  ,k-1) + gadd(m,i,1,-1)
               gm(m,i,j  ,k  ) = gm(m,i,j  ,k  ) + gadd(m,i,1, 0)
               gp(m,i,j  ,k  ) = gp(m,i,j  ,k  ) + gadd(m,i,1, 0)
               gm(m,i,j  ,k+1) = gm(m,i,j  ,k+1) + gadd(m,i,1, 1)
               gp(m,i,j  ,k+1) = gp(m,i,j  ,k+1) + gadd(m,i,1, 1)
c
               gm(m,i,j+1,k-1) = gm(m,i,j+1,k-1) + gadd(m,i,2,-1)
               gp(m,i,j+1,k-1) = gp(m,i,j+1,k-1) + gadd(m,i,2,-1)
               gm(m,i,j+1,k  ) = gm(m,i,j+1,k  ) + gadd(m,i,2, 0)
               gp(m,i,j+1,k  ) = gp(m,i,j+1,k  ) + gadd(m,i,2, 0)
               gm(m,i,j+1,k+1) = gm(m,i,j+1,k+1) + gadd(m,i,2, 1)
               gp(m,i,j+1,k+1) = gp(m,i,j+1,k+1) + gadd(m,i,2, 1)
c
               hm(m,i,j-1,k) = hm(m,i,j-1,k) + hadd(m,i,1,-1)
               hp(m,i,j-1,k) = hp(m,i,j-1,k) + hadd(m,i,1,-1)
               hm(m,i,j  ,k) = hm(m,i,j  ,k) + hadd(m,i,1, 0)
               hp(m,i,j  ,k) = hp(m,i,j  ,k) + hadd(m,i,1, 0)
               hm(m,i,j+1,k) = hm(m,i,j+1,k) + hadd(m,i,1, 1)
               hp(m,i,j+1,k) = hp(m,i,j+1,k) + hadd(m,i,1, 1)
c
               hm(m,i,j-1,k+1) = hm(m,i,j-1,k+1) + hadd(m,i,2,-1)
               hp(m,i,j-1,k+1) = hp(m,i,j-1,k+1) + hadd(m,i,2,-1)
               hm(m,i,j  ,k+1) = hm(m,i,j  ,k+1) + hadd(m,i,2, 0)
               hp(m,i,j  ,k+1) = hp(m,i,j  ,k+1) + hadd(m,i,2, 0)
               hm(m,i,j+1,k+1) = hm(m,i,j+1,k+1) + hadd(m,i,2, 1)
               hp(m,i,j+1,k+1) = hp(m,i,j+1,k+1) + hadd(m,i,2, 1)

   25          continue
   50    continue
c
c
c     # perform y sweeps
c     ==================
c
c
      do 100 k = 0, mz+1
         do 100 i = 0, mx+1
c
            do 70 j = 1-mbc, my+mbc
               do 70 m=1,meqn
c                 # copy data along a slice into 1d array:
                  q1d(m,j) = qold(m,i,j,k)
   70          continue
c
         if (mcapa.gt.0)  then
           do 71 j = 1-mbc, my+mbc
               dtdy1d(j) = dtdy / aux(mcapa,i,j,k)
   71      continue
         endif
c
         if (maux .gt. 0)  then
            do 72 j = 1-mbc, my+mbc
               do 72 ma=1,maux
                 aux1(ma,j,1) = aux(ma,i-1,j,k-1)
                 aux1(ma,j,2) = aux(ma,i,j,k-1)
                 aux1(ma,j,3) = aux(ma,i+1,j,k-1)
                 aux2(ma,j,1) = aux(ma,i-1,j,k)
                 aux2(ma,j,2) = aux(ma,i,j,k)
                 aux2(ma,j,3) = aux(ma,i+1,j,k)
                 aux3(ma,j,1) = aux(ma,i-1,j,k+1)
                 aux3(ma,j,2) = aux(ma,i,j,k+1)
                 aux3(ma,j,3) = aux(ma,i+1,j,k+1)
   72          continue
         endif
c
c           # Store the value of i and k along this slice in the common block
c           # comxyzt in case it is needed in the Riemann solver (for
c           # variable coefficient problems)
c
c$$$            icom = i
c$$$            kcom = k
c
c           # compute modifications fadd, gadd and hadd to fluxes along this
c           # slice:
c
            call flux3(2,maxm,meqn,maux,mbc,my,
     &                 q1d,dtdy1d,dtdz,dtdx,aux1,aux2,aux3,
     &                 faddm,faddp,gadd,hadd,cfl1d,
     &                 work(i0wave),work(i0s),work(i0amdq),
     &                 work(i0apdq),work(i0cqxx),
     &                 work(i0bmamdq),work(i0bmapdq),
     &                 work(i0bpamdq),work(i0bpapdq),
     &                 work(i0cmamdq),work(i0cmapdq),
     &                 work(i0cpamdq),work(i0cpapdq),
     &                 work(i0cmamdq2),work(i0cmapdq2),
     &                 work(i0cpamdq2),work(i0cpapdq2),

     &                 work(i0bmcqxxm),work(i0bmcqxxp),
     &                 work(i0bpcqxxm),work(i0bpcqxxp),
     &                 work(i0cmcqxxm),work(i0cmcqxxp),
     &                 work(i0cpcqxxm),work(i0cpcqxxp),

     &                 work(i0bmcmamdq),work(i0bmcmapdq),
     &                 work(i0bpcmamdq),work(i0bpcmapdq),
     &                 work(i0bmcpamdq),work(i0bmcpapdq),
     &                 work(i0bpcpamdq),work(i0bpcpapdq),
     &                 rpn3,rpt3,rptt3)
c
            cflgrid = dmax1(cflgrid,cfl1d)
c
c        # update fluxes for use in AMR:
c
c           # Note that the roles of the flux updates are changed.
c           # fadd - modifies the g-fluxes
c           # gadd - modifies the h-fluxes
c           # hadd - modifies the f-fluxes
c
            do 75 j=1,my+1
               do 75 m=1,meqn
               gm(m,i,j,k) = gm(m,i,j,k) + faddm(m,j)
               gp(m,i,j,k) = gp(m,i,j,k) + faddp(m,j)
c
               hm(m,i-1,j,k) = hm(m,i-1,j,k) + gadd(m,j,1,-1)
               hp(m,i-1,j,k) = hp(m,i-1,j,k) + gadd(m,j,1,-1)
               hm(m,i  ,j,k) = hm(m,i  ,j,k) + gadd(m,j,1, 0)
               hp(m,i  ,j,k) = hp(m,i  ,j,k) + gadd(m,j,1, 0)
               hm(m,i+1,j,k) = hm(m,i+1,j,k) + gadd(m,j,1, 1)
               hp(m,i+1,j,k) = hp(m,i+1,j,k) + gadd(m,j,1, 1)
c
               hm(m,i-1,j,k+1) = hm(m,i-1,j,k+1) + gadd(m,j,2,-1)
               hp(m,i-1,j,k+1) = hp(m,i-1,j,k+1) + gadd(m,j,2,-1)
               hm(m,i  ,j,k+1) = hm(m,i  ,j,k+1) + gadd(m,j,2, 0)
               hp(m,i  ,j,k+1) = hp(m,i  ,j,k+1) + gadd(m,j,2, 0)
               hm(m,i+1,j,k+1) = hm(m,i+1,j,k+1) + gadd(m,j,2, 1)
               hp(m,i+1,j,k+1) = hp(m,i+1,j,k+1) + gadd(m,j,2, 1)
c
               fm(m,i  ,j,k-1) = fm(m,i  ,j,k-1) + hadd(m,j,1,-1)
               fp(m,i  ,j,k-1) = fp(m,i  ,j,k-1) + hadd(m,j,1,-1)
               fm(m,i  ,j,k  ) = fm(m,i  ,j,k  ) + hadd(m,j,1, 0)
               fp(m,i  ,j,k  ) = fp(m,i  ,j,k  ) + hadd(m,j,1, 0)
               fm(m,i  ,j,k+1) = fm(m,i  ,j,k+1) + hadd(m,j,1, 1)
               fp(m,i  ,j,k+1) = fp(m,i  ,j,k+1) + hadd(m,j,1, 1)
c
               fm(m,i+1,j,k-1) = fm(m,i+1,j,k-1) + hadd(m,j,2,-1)
               fp(m,i+1,j,k-1) = fp(m,i+1,j,k-1) + hadd(m,j,2,-1)
               fm(m,i+1,j,k  ) = fm(m,i+1,j,k  ) + hadd(m,j,2, 0)
               fp(m,i+1,j,k  ) = fp(m,i+1,j,k  ) + hadd(m,j,2, 0)
               fm(m,i+1,j,k+1) = fm(m,i+1,j,k+1) + hadd(m,j,2, 1)
               fp(m,i+1,j,k+1) = fp(m,i+1,j,k+1) + hadd(m,j,2, 1)
c

   75          continue
c
  100    continue
c
c
c
c     # perform z sweeps
c     ==================
c
c
      do 150 j = 0, my+1
         do 150 i = 0, mx+1
c
            do 110 k = 1-mbc, mz+mbc
               do 110 m=1,meqn
c                 # copy data along a slice into 1d array:
                  q1d(m,k) = qold(m,i,j,k)
 110           continue
c
         if (mcapa.gt.0)  then
           do 130 k = 1-mbc, mz+mbc
               dtdz1d(k) = dtdz / aux(mcapa,i,j,k)
 130       continue
         endif
c
         if (maux .gt. 0)  then
            do 131 k = 1-mbc, mz+mbc
               do 131 ma=1,maux
                 aux1(ma,k,1) = aux(ma,i-1,j-1,k)
                 aux1(ma,k,2) = aux(ma,i-1,j,k)
                 aux1(ma,k,3) = aux(ma,i-1,j+1,k)
                 aux2(ma,k,1) = aux(ma,i,j-1,k)
                 aux2(ma,k,2) = aux(ma,i,j,k)
                 aux2(ma,k,3) = aux(ma,i,j+1,k)
                 aux3(ma,k,1) = aux(ma,i+1,j-1,k)
                 aux3(ma,k,2) = aux(ma,i+1,j,k)
                 aux3(ma,k,3) = aux(ma,i+1,j+1,k)
  131          continue
           endif
c
c           # Store the value of i and j along this slice in the common block
c           # comxyzt in case it is needed in the Riemann solver (for
c           # variable coefficient problems)
c
c$$$            icom = i
c$$$            jcom = j
c
c           # compute modifications fadd, gadd and hadd to fluxes along this
c           # slice:
c
            call flux3(3,maxm,meqn,maux,mbc,mz,
     &                 q1d,dtdz1d,dtdx,dtdy,aux1,aux2,aux3,
     &                 faddm,faddp,gadd,hadd,cfl1d,
     &                 work(i0wave),work(i0s),work(i0amdq),
     &                 work(i0apdq),work(i0cqxx),
     &                 work(i0bmamdq),work(i0bmapdq),
     &                 work(i0bpamdq),work(i0bpapdq),
     &                 work(i0cmamdq),work(i0cmapdq),
     &                 work(i0cpamdq),work(i0cpapdq),
     &                 work(i0cmamdq2),work(i0cmapdq2),
     &                 work(i0cpamdq2),work(i0cpapdq2),

     &                 work(i0bmcqxxm),work(i0bmcqxxp),
     &                 work(i0bpcqxxm),work(i0bpcqxxp),
     &                 work(i0cmcqxxm),work(i0cmcqxxp),
     &                 work(i0cpcqxxm),work(i0cpcqxxp),

     &                 work(i0bmcmamdq),work(i0bmcmapdq),
     &                 work(i0bpcmamdq),work(i0bpcmapdq),
     &                 work(i0bmcpamdq),work(i0bmcpapdq),
     &                 work(i0bpcpamdq),work(i0bpcpapdq),
     &                 rpn3,rpt3,rptt3)
c
            cflgrid = dmax1(cflgrid,cfl1d)
c
c
c        # update fluxes for use in AMR:
c           # Note that the roles of the flux updates are changed.
c           # fadd - modifies the h-fluxes
c           # gadd - modifies the f-fluxes
c           # hadd - modifies the g-fluxes
c
            do 125 k=1,mz+1
               do 125 m=1,meqn
               hm(m,i,j,k) = hm(m,i,j,k) + faddm(m,k)
               hp(m,i,j,k) = hp(m,i,j,k) + faddp(m,k)
c
               fm(m,i  ,j-1,k) = fm(m,i  ,j-1,k) + gadd(m,k,1,-1)
               fp(m,i  ,j-1,k) = fp(m,i  ,j-1,k) + gadd(m,k,1,-1)
               fm(m,i  ,j  ,k) = fm(m,i  ,j  ,k) + gadd(m,k,1, 0)
               fp(m,i  ,j  ,k) = fp(m,i  ,j  ,k) + gadd(m,k,1, 0)
               fm(m,i  ,j+1,k) = fm(m,i  ,j+1,k) + gadd(m,k,1, 1)
               fp(m,i  ,j+1,k) = fp(m,i  ,j+1,k) + gadd(m,k,1, 1)
c
               fm(m,i+1,j-1,k) = fm(m,i+1,j-1,k) + gadd(m,k,2,-1)
               fp(m,i+1,j-1,k) = fp(m,i+1,j-1,k) + gadd(m,k,2,-1)
               fm(m,i+1,j  ,k) = fm(m,i+1,j  ,k) + gadd(m,k,2, 0)
               fp(m,i+1,j  ,k) = fp(m,i+1,j  ,k) + gadd(m,k,2, 0)
               fm(m,i+1,j+1,k) = fm(m,i+1,j+1,k) + gadd(m,k,2, 1)
               fp(m,i+1,j+1,k) = fp(m,i+1,j+1,k) + gadd(m,k,2, 1)
c
               gm(m,i-1,j  ,k) = gm(m,i-1,j  ,k) + hadd(m,k,1,-1)
               gp(m,i-1,j  ,k) = gp(m,i-1,j  ,k) + hadd(m,k,1,-1)
               gm(m,i  ,j  ,k) = gm(m,i  ,j  ,k) + hadd(m,k,1, 0)
               gp(m,i  ,j  ,k) = gp(m,i  ,j  ,k) + hadd(m,k,1, 0)
               gm(m,i+1,j  ,k) = gm(m,i+1,j  ,k) + hadd(m,k,1, 1)
               gp(m,i+1,j  ,k) = gp(m,i+1,j  ,k) + hadd(m,k,1, 1)
c
               gm(m,i-1,j+1,k) = gm(m,i-1,j+1,k) + hadd(m,k,2,-1)
               gp(m,i-1,j+1,k) = gp(m,i-1,j+1,k) + hadd(m,k,2,-1)
               gm(m,i  ,j+1,k) = gm(m,i  ,j+1,k) + hadd(m,k,2, 0)
               gp(m,i  ,j+1,k) = gp(m,i  ,j+1,k) + hadd(m,k,2, 0)
               gm(m,i+1,j+1,k) = gm(m,i+1,j+1,k) + hadd(m,k,2, 1)
               gp(m,i+1,j+1,k) = gp(m,i+1,j+1,k) + hadd(m,k,2, 1)
c
  125          continue
  150    continue
c
c
      return
      end

c
c
c     ==========================================================
      subroutine dimsp2(maxm,meqn,mwaves,maux,mbc,mx,my,
     &                  qold,qnew,aux,dx,dy,dt,method,mthlim,cfl,
     &                  cflv,qadd,fadd,gadd,q1d,dtdx1d,dtdy1d,
     &                  aux1,aux2,aux3,work,mwork,use_fwaves,rpn2,rpt2)
c     ==========================================================
c
c     # Take one time step, updating q, using dimensional
c     # splitting. Two choices are available:
c     #
c     # method(3) = -1   gives Godunov splitting:
c     #    time step dt in x-direction
c     #    time step dt in y-direction
c
c     # method(3) = -2   gives Strang splitting
c     #    time step dt/2 in x-direction
c     #    time step dt   in y-direction
c     #    time step dt/2 in x-direction
c
c     # Godunov splitting is recommended over Strang splitting normally
c     # since it typically works as well, is faster, and boundary
c     # conditions are handled properly.
c
      implicit double precision (a-h,o-z)
      external rpn2,rpt2
      dimension qold(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension qnew(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension  q1d(meqn,1-mbc:maxm+mbc)
      dimension cflv(4)
      dimension qadd(meqn,1-mbc:maxm+mbc)
      dimension fadd(meqn,1-mbc:maxm+mbc)
      dimension gadd(meqn,1-mbc:maxm+mbc,2)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension aux1(maux,1-mbc:maxm+mbc)
      dimension aux2(maux,1-mbc:maxm+mbc)
      dimension aux3(maux,1-mbc:maxm+mbc)

      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension dtdy1d(1-mbc:maxm+mbc)
      dimension method(7),mthlim(mwaves)
      dimension work(mwork)

      logical :: use_fwaves

c
c     # If method(3) = -1, take a full time step in x.
c     # If method(3) = -2, take a half time step in x.
c
      dt2 = dt/2.d0
c
      if( method(3) .eq. -2 )then
          call step2ds(maxm,meqn,mwaves,maux,mbc,mx,my,
     &                 qold,qnew,aux,dx,dy,dt2,method,mthlim,cflx,
     &                 qadd,fadd,gadd,q1d,dtdx1d,dtdy1d,
     &                 aux1,aux2,aux3,work,mwork,1,use_fwaves,rpn2,rpt2)
      else
          call step2ds(maxm,meqn,mwaves,maux,mbc,mx,my,
     &                 qold,qnew,aux,dx,dy,dt,method,mthlim,cflx,
     &                 qadd,fadd,gadd,q1d,dtdx1d,dtdy1d,
     &                 aux1,aux2,aux3,work,mwork,1,use_fwaves,rpn2,rpt2)
      endif
c
      if (cflx .gt. cflv(1)) then
c        # Abort if the Courant number was too large in x-sweep
         cfl = cflx
         return
         endif
c
c     # Take full step in y-direction
c
      call step2ds(maxm,meqn,mwaves,maux,mbc,mx,my,
     &             qnew,qnew,aux,dx,dy,dt,method,mthlim,cfly,
     &             qadd,fadd,gadd,q1d,dtdx1d,dtdy1d,
     &             aux1,aux2,aux3,work,mwork,2,use_fwaves,rpn2,rpt2)
c
      cfl = dmax1(cflx,cfly)
c
c     # Finally, take a half time step in the x-direction
c     # if Strang splitting is used.  NOTE: boundary conditions may
c     # not be set properly for this sweep.
c
      if( method(3) .eq. -2 )then
         if (cfly .gt. cflv(1)) then
c           # Abort if the Courant number was too large in y-sweep
            cfl = cfly
            return
            endif
          call step2ds(maxm,meqn,mwaves,maux,mbc,mx,my,
     &                 qnew,qnew,aux,dx,dy,dt2,method,mthlim,cflx,
     &                 qadd,fadd,gadd,q1d,dtdx1d,dtdy1d,
     &                 aux1,aux2,aux3,work,mwork,1,use_fwaves,rpn2,rpt2)
          cfl = dmax1(cfl,cflx)
      endif
c
      return
      end

! ============================================
subroutine b4step2(mbc,mx,my,meqn,q,xlower,ylower,dx,dy,t,dt,maux,aux,actualstep)
! ============================================
!
! # called before each call to step
! # use to set time-dependent aux arrays or perform other tasks.
!
! This particular routine sets negative values of q(1,i,j) to zero,
! as well as the corresponding q(m,i,j) for m=1,meqn.
! This is for problems where q(1,i,j) is a depth.
! This should occur only because of rounding error.
!
! Also calls movetopo if topography might be moving.

    use geoclaw_module, only: dry_tolerance
    use geoclaw_module, only: g => grav
    use topo_module, only: num_dtopo,topotime
    use topo_module, only: aux_finalized
    use topo_module, only: xlowdtopo,xhidtopo,ylowdtopo,yhidtopo

    use amr_module, only: xlowdomain => xlower
    use amr_module, only: ylowdomain => ylower
    use amr_module, only: xhidomain => xupper
    use amr_module, only: yhidomain => yupper
    use amr_module, only: xperdom,yperdom,spheredom,NEEDS_TO_BE_SET

    use storm_module, only: set_storm_fields

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: meqn
    integer, intent(inout) :: mbc,mx,my,maux
    real(kind=8), intent(inout) :: xlower, ylower, dx, dy, t, dt
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    logical, intent (in) :: actualstep

    ! Local storage
    integer :: index,i,j,k,dummy
    real(kind=8) :: h,u,v

    ! Check for NaNs in the solution
    call check4nans(meqn,mbc,mx,my,q,t,1)

    ! check for h < 0 and reset to zero
    ! check for h < drytolerance
    ! set hu = hv = 0 in all these cells
    forall(i=1-mbc:mx+mbc, j=1-mbc:my+mbc,q(1,i,j) < dry_tolerance)
        q(1,i,j) = max(q(1,i,j),0.d0)
        q(2:3,i,j) = 0.d0
    end forall


    if (aux_finalized < 2 .and. actualstep) then
        ! topo arrays might have been updated by dtopo more recently than
        ! aux arrays were set unless at least 1 step taken on all levels
        aux(1,:,:) = NEEDS_TO_BE_SET ! new system checks this val before setting
        call setaux(mbc,mx,my,xlower,ylower,dx,dy,maux,aux)
    endif

    ! Set wind and pressure aux variables for this grid
    call set_storm_fields(maux,mbc,mx,my,xlower,ylower,dx,dy,t,aux)

end subroutine b4step2

subroutine setaux(mbc,mx,xlower,dx,maux,aux)

    ! Called at start of computation before calling qinit, and
    ! when AMR is used, also called every time a new grid patch is created.
    ! Use to set auxiliary arrays aux(1:maux, 1-mbc:mx+mbc, 1-mbc:my+mbc).
    ! Note that ghost cell values may need to be set if the aux arrays
    ! are used by the Riemann solver(s).
    !
    ! This version sets aux(1,:) to b(x) for shallow flow
    ! and aux(2,:) to the ratio of cell width to dxc (capacity function).

    !use geoclaw_module, only: dry_tolerance !uncomment if needed
    !use geoclaw_module, only: grav  !uncomment if needed
    use geoclaw_module, only: earth_radius, coordinate_system, DEG2RAD
    use grid_module, only: xp_edge,mx_edge
    use topo_module, only: zcell

    implicit none
    integer, intent(in) :: mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(inout) ::  aux(maux,1-mbc:mx+mbc)

    !locals
    integer :: i,i0,i1,j
    real(kind=8) :: xcell,a

    if (mx+1 .ne. mx_edge) then
        write(6,*) 'mx_edge from celledges.data must agree with mx+1'
        write(6,*) 'mx_edge = ',mx_edge
        write(6,*) 'mx = ',mx
        stop
        endif

    ! store topo values in aux(1,:):
    ! computation of cell averages is done in read_topo_file or topo_update

    !write(6,*) '+++ Before resetting aux, aux(1,200) = ',aux(1,200)
    
    do i=1,mx
        aux(1,i) = zcell(i)
        !write(6,*) '+++ i,zcell: ',i,zcell(i)
        ! capacity function for nonuniform grid:
        aux(2,i) = (xp_edge(i+1) - xp_edge(i))/dx
        if (coordinate_system == 2) then
            ! additional factor for latitude coords on sphere: 
            ! dx in meters = (dx in degrees) * (pi/180) * earth_radius
            aux(2,i) = aux(2,i)* DEG2RAD * earth_radius
        endif
        if (aux(2,i) <= 0.d0) then
            write(6,*) '+++ i,xp_edge(i),xp_edge(i+1): ',i,xp_edge(i),xp_edge(i+1)
            endif
    enddo
    

    aux(:,0) = aux(:,1)
    aux(:,-1) = aux(:,1)
    aux(:,mx+1) = aux(:,mx)
    aux(:,mx+2) = aux(:,mx)

end subroutine setaux

c
c -----------------------------------------------------------------
c
      subroutine initBndryList()

      use amr_module
      implicit none
      
      integer i
c
c  need to manage the boundary List too
c
      bndListSize = 8*maxgr   ! guess at initial size

      ! allocate the bndList
      if (.not. allocated(bndList)) then
         allocate(bndList(bndListSize,2))
         print *, "bndList allocated..."
      else
         print *, "bndList already allocated!"
      endif

      ! thread the bndry list
      do i = 1, bndListSize
         bndList(i,nextfree) = i+1
      end do

      bndList(bndListSize,nextfree) = null
      ndfree_bnd = 1

      end
c
c -----------------------------------------------------------------
c
!> Preprocess each grid on level **level** to have a linked list of 
!! other grids at the same level that supply ghost cells.
!!
!! The linked list is implemented with an array.
!! Each node in this linked list is represented by a row (with 2 elements) 
!! in the array, named **bndList**.
!!
!! bndList(pos,gridNbor) is grid number stored at node **pos**
!! bndList(pos,nextfree) is pointer to next node in the linked list
!!
!! node(bndListSt,mptr) point to the head node in this linked list.
!! Thus bndList(node(bndListSt,mptr),gridNbor) is grid number 
!! stored at first node of the linked list.
!!
!!
      subroutine makeBndryList(level)
c
      use amr_module
      implicit none

      integer level, n, levSt, k, nborCount
      integer nodget_bnd, nextSpot, prevNbor, msrc, mptr
      integer imin, imax, jmin, jmax
      integer imlo, imhi, jmlo, jmhi
      integer ixlo, ixhi, jxlo, jxhi

c :::::::::::::::::::::::::::: makeBndryList :::::::::::::::::::::::::
c     preprocess each grid to have linked list of other grids at
c     same level that supply ghost cells.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c     traverse linked list into array. list already sorted by arrangegrids
      levSt = listStart(level) 
      do n = 1, numgrids(level)
         mptr = listOfGrids(levSt+n-1)
         imin = node(ndilo,mptr) - nghost  ! ghost cells included since
         imax = node(ndihi,mptr) + nghost  ! this is what you want to fill
         jmin = node(ndjlo,mptr) - nghost  ! may also use for filval stuff,
         jmax = node(ndjhi,mptr) + nghost  ! change nghost to mbuff, etc
         nborCount = 0
         
         do k = 1, numgrids(level)  ! loop over all other grids once to find touching ones 
            if (k .eq. n) cycle     ! dont count yourself as source grid
            msrc = listOfgrids(levSt+k-1)

            ! Check if grid mptr and patch intersect
            imlo = node(ndilo, msrc)
            jmlo = node(ndjlo, msrc)
            imhi = node(ndihi, msrc)
            jmhi = node(ndjhi, msrc)

            ixlo = max(imlo,imin)
            ixhi = min(imhi,imax)
            jxlo = max(jmlo,jmin)
            jxhi = min(jmhi,jmax)

            if (ixlo .le. ixhi .and. jxlo .le. jxhi) then ! put on bnd list for mptr
               nborCount = nborCount + 1
               nextSpot = nodget_bnd()   
               bndList(nextSpot,gridNbor) = msrc
               ! get spot in bnd list. insert next grid at front to avoid traversing
               bndList(nextSpot,nextfree) =  node(bndListSt,mptr)
               node(bndListSt,mptr) = nextSpot
            endif

         end do

!        save final count
         node(bndListNum,mptr) = nborcount
      end do

      return
      end
c
c -----------------------------------------------------------------
c
!> Free the linked list of intersecting "boundary" grids for grid 'mold'
!! that is no longer active.
!! The linked list starts at node(bndListSt, mold).
      subroutine freeBndryList(mold)
c
      use amr_module
      implicit none

      integer nborCount, mold,nextSpot, i, nextnext

c :::::::::::::::::::::::::::: freeBndryList :::::::::::::::::::::::::
c     free the linked list of intersecting "boundary" grids for grid 'mold'
c     that is no longer active
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

           nborCount = node(bndListNum,mold) ! count for this grid
           nextSpot  = node(bndListSt,mold)  ! first index of this grids nbors
           do i = 1, nborCount
               nextnext = bndList(nextSpot,nextfree)
               call putnod_bnd(nextSpot)
               nextSpot = nextnext
           end do

      return
      end

! :::::::::::::::::::::::::::: FILPATCH :::::::::::::::::::::::::;
!
!  fill the portion of valbig from rows  nrowst
!                             and  cols  ncolst
!  the patch can also be described by the corners (xlp,ybp) by (xrp,ytp).
!  vals are needed at time t, and level level,
!
!  first fill with  values obtainable from the level level
!  grids. if any left unfilled, then enlarge remaining rectangle of
!  unfilled values by 1 (for later linear interp), and recusively
!  obtain the remaining values from  coarser levels.
!
! :::::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::;
!
!  Below are comments for Doxygen
!> Fill a region (patch) described by:
!! * global indices of its lower left corner: (**ilo**, **jlo**).
!! * global indices of its upper right corner: (**ihi**, **jhi**). 
!!
!! The patch is on grid **msrc** and starts from 
!! row **nrowst** and column **ncolst** of the grid.
!!
!! It first fills the patch with values obtainable from level **level**
!! grids. if any left unfilled, then enlarge remaining rectangle of
!! unfilled values by 1 (for later linear interp), and recusively
!! obtain the remaining values from  coarser levels.
!!
!! ## Algorithm
!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!!  procedure filrecur(level, patch_fine, val_fine, firstCall)
!!      fill patch_fine as much as possible by copy values from other level "level" grids     
!!      values on patch_fine is stored in array val_fine after the filling
!!      if this is first call to filrecur() (firstCall == true)
!!          don't fill cells outside the computational domain (it will be handled elsewhere)
!!      else
!!          this is a sencond or higher-level (recursive) call to filrecur()
!!          fill cells outside the computational domain by calling bc2amr since they are used for interpolation for finer cells above them
!!      end if
!!      if not all cells in patch_fine is filled (set)
!!          find the smallest rectangular patch on level "level-1", patch_coarse, that contains all unset fine cells in patch_fine
!!          filrecur(level-1, patch_coarse, val_coarse, firstCall=false)
!!          for each unset fine cells in patch_fine
!!              interpolate from val_coarse to fill all unset cells on patch_fine 
!!          end for
!!      end if
!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!!
!! \param level AMR level the patch is on
!! \param nvar number of equations for the system
!! \param valbig data array for solution \f$q \f$ (cover the whole grid **msrc**)
!! \param aux data array for auxiliary variables 
!! \param naux number of auxiliary variables
!! \param t fill the patch with value at time **t**
!! \param mitot number of cells in *i* direction on grid **msrc** 
!! \param mjtot number of cells in *j* direction on grid **msrc**
!! \param nrowst local *i* index (relative to lower-left corner of grid **msrc**) of the left-most cell of the patch to be filled
!! \param ncolst local *j* index (relative to lower-left corner of grid **msrc**) of the lower-most cell of the patch to be filled
!! \param ilo global *i* index of left-most cell of this patch
!! \param ihi global *i* index of right-most cell of this patch 
!! \param jlo global *j* index of lower-most cell of this patch 
!! \param jhi global *j* index of upper-most cell of this patch 
!! \param patchOnly This is 1) false if this is a first level call to filrecur() and won't set bounday cells outside domain; 2) true
!!if this is a second or higher level (recursive) call to filrecur() and will call bc2amr() to get values for cells outside domain
!!(these cells are only for interpolation to fill cells in first level call to filrecur()
!! \param msrc index of the grid 
!!
!! \callgraph
!! \callergraph


recursive subroutine filrecur(level,nvar,valbig,aux,naux,t,mitot,mjtot, &
     nrowst,ncolst,ilo,ihi,jlo,jhi,patchOnly,msrc,do_aux_copy)

  use amr_module, only: hxposs, hyposs, xlower, ylower, xupper, yupper
  use amr_module, only: outunit, nghost, xperdom, yperdom, spheredom
  use amr_module, only: iregsz, jregsz, intratx, intraty, NEEDS_TO_BE_SET

  implicit none

  ! Input
  integer, intent(in) :: level, nvar, naux, mitot, mjtot, nrowst, ncolst
  integer, intent(in) :: ilo,ihi,jlo,jhi, msrc
  real(kind=8), intent(in) :: t
  logical  :: patchOnly, do_aux_copy,yes_do_aux_copy

  ! Output
  real(kind=8), intent(in out) :: valbig(nvar,mitot,mjtot)
  real(kind=8), intent(in out) :: aux(naux,mitot,mjtot)

  ! Local storage
  integer :: i_fine, j_fine, i_coarse, j_coarse, n, k
  integer  :: iplo, iphi, jplo, jphi
  integer :: mitot_patch, mjtot_patch, mitot_coarse, mjtot_coarse, nghost_patch, lencrse
  integer :: refinement_ratio_x, refinement_ratio_y
  integer :: unset_indices(4)
  real(kind=8) :: dx_fine, dy_fine, dx_coarse, dy_coarse
  real(kind=8) :: xlow_coarse,ylow_coarse, xlow_fine, ylow_fine, xhi_fine,yhi_fine
  real(kind=8) :: xcent_fine, xcent_coarse, ycent_fine, ycent_coarse,ratiox,ratioy,floor    

  !for timing
  integer(kind=8) :: clock_start, clock_finish, clock_rate
  real(kind=8) :: cpu_start, cpu_finish

  ! Interpolation variables
  real(kind=8) :: eta1, eta2, valp10, valm10, valc, valp01, valm01, dupc, dumc
  real(kind=8) :: ducc, du, fu, dvpc, dvmc, dvcc, dv, fv, valint, uslope, vslope

  ! Cell set tracking
  logical :: set
  integer(kind=1) :: flaguse(ihi-ilo+1, jhi-jlo+1)

  ! Scratch storage
  !  use stack-based scratch arrays instead of alloc, since dont really
  !  need to save beyond these routines, and to allow dynamic memory resizing
  !
  !     use 1d scratch arrays that are potentially the same size as 
  !     current grid, since may not coarsen.
  !     need to make it 1d instead of 2 and do own indexing, since
  !     when pass it in to subroutines they treat it as having dierent
  !     dimensions than the max size need to allocate here

  !--      dimension valcrse((ihi-ilo+2)*(jhi-jlo+2)*nvar)  ! NB this is a 1D array 
  !--      dimension auxcrse((ihi-ilo+2)*(jhi-jlo+2)*naux)  ! the +2 is to expand on coarse grid to enclose fine
  ! ### turns out you need 3 rows, forget offset of 1 plus one on each side
  ! the +3 is to expand on coarse grid to enclose fine
  real(kind=8) :: valcrse((ihi-ilo+3) * (jhi-jlo+3) * nvar)  
  real(kind=8) :: auxcrse((ihi-ilo+3) * (jhi-jlo+3) * naux)  

  yes_do_aux_copy = .true.

  ! We begin by filling values for grids at level level. If all values can be
  ! filled in this way, we return;
  mitot_patch = ihi-ilo + 1 ! nrowp
  mjtot_patch = jhi-jlo + 1 

  dx_fine     = hxposs(level)
  dy_fine     = hyposs(level)

  ! Coordinates of edges of patch (xlp,xrp,ybp,ytp)
  xlow_fine = xlower + ilo * dx_fine
  ylow_fine = ylower + jlo * dy_fine

  ! Fill in the patch as much as possible using values at this level
  ! note that if only a patch, msrc = -1, otherwise a real grid and intfil
  ! uses its boundary list
  ! msrc either -1 (for a patch) or the real grid number
  call intfil(valbig,aux,mitot,mjtot,t,flaguse,nrowst,ncolst, ilo,  &
              ihi,jlo,jhi,level,nvar,naux,msrc,do_aux_copy)
 


  ! Trimbd returns set = true if all of the entries are filled (=1.).
  ! set = false, otherwise. If set = true, then no other levels are
  ! are required to interpolate, and we return.
  !
  ! Note that the used array is filled entirely in intfil, i.e. the
  ! marking done there also takes  into account the points filled by
  ! the boundary conditions. bc2amr will be called later, after all 4
  ! boundary pieces filled.
  call trimbd(flaguse,mitot_patch,mjtot_patch,set,unset_indices)
  ! il,ir,jb,jt = unset_indices(4)

  ! If set is .true. then all cells have been set and we can skip to setting
  ! the remaining boundary cells.  If it is .false. we need to interpolate
  ! some values from coarser levels, possibly calling this routine
  ! recursively.
  if (.not.set) then

     ! Error check 
     if (level == 1) then
        write(outunit,*)" error in filrecur - level 1 not set"
        write(outunit,'("start at row: ",i4," col ",i4)') nrowst,ncolst
        print *," error in filrecur - level 1 not set"
        print *," should not need more recursion "
        print *," to set patch boundaries"
        print '("start at row: ",i4," col ",i4)', nrowst,ncolst
        stop
     endif

     ! We begin by initializing the level level arrays, so that we can use
     ! purely recursive formulation for interpolating.
     dx_coarse  = hxposs(level - 1)
     dy_coarse  = hyposs(level - 1)

     ! Adjust unset_indices to account for the patch
     ! isl, isr, jsb, jst
     unset_indices(1) = unset_indices(1) + ilo - 1
     unset_indices(2) = unset_indices(2) + ilo - 1
     unset_indices(3) = unset_indices(3) + jlo - 1
     unset_indices(4) = unset_indices(4) + jlo - 1

     ! Coarsened geometry
     refinement_ratio_x = intratx(level - 1)
     refinement_ratio_y = intraty(level - 1)

     ! New patch rectangle (after we have partially filled it in) but in the
     ! coarse patches [iplo,iphi,jplo,jphi]

     ! islo = unset_indices(1)
     ! ishi = unset_indices(2)
     !                                islo                     ishi 
     !                     |----|----|----|----|----|----|----|----|
     ! If following operation is conducted, it will lead to: 
     !
     !         iplo                                                        iphi
     ! |-------------------|-------------------|-------------------|-------------------|
     iplo = (unset_indices(1) - refinement_ratio_x + nghost * refinement_ratio_x) &
          / refinement_ratio_x - nghost
     iphi = (unset_indices(2) + refinement_ratio_x) / refinement_ratio_x
     jplo = (unset_indices(3) - refinement_ratio_y + nghost * refinement_ratio_y) &
          / refinement_ratio_y - nghost
     jphi = (unset_indices(4) + refinement_ratio_y) / refinement_ratio_y

     xlow_coarse = xlower + iplo * dx_coarse
     ylow_coarse = ylower + jplo * dy_coarse

     ! Coarse grid number of spatial points (nrowc,ncolc)
     mitot_coarse   =  iphi - iplo + 1
     mjtot_coarse   =  jphi - jplo + 1

     ! Check to make sure we created big enough scratch arrays
     if (mitot_coarse > ihi - ilo + 3 .or. &
          mjtot_coarse > jhi - jlo + 3) then

        print *," did not make big enough work space in filrecur "
        print *," need coarse space with mitot_coarse,mjtot_coarse ",mitot_coarse,mjtot_coarse
        print *," made space for ilo,ihi,jlo,jhi ",ilo,ihi,jlo,jhi
        stop
     endif

     ! Set the aux array values for the coarse grid, this could be done 
     ! instead in intfil using possibly already available bathy data from the
     ! grids
     if (naux > 0) then
        nghost_patch = 0
        lencrse = (ihi-ilo+3)*(jhi-jlo+3)*naux ! set 1 component, not all naux
        do k = 1, lencrse, naux
           auxcrse(k) = NEEDS_TO_BE_SET ! new system checks initialization before setting aux vals
        end do
        ! commented out since now copy from coarser grids during intfil
        !call setaux(nghost_patch, mitot_coarse,mjtot_coarse,  &
        !     xlow_coarse, ylow_coarse,            &
        !     dx_coarse,dy_coarse,naux,auxcrse)
     endif

     ! Fill in the edges of the coarse grid. for recursive calls, patch indices and
     ! 'coarse grid' indices are the same (no actual coarse grid here, so cant use mptr
     ! must pass indices. patchOnly argument  is thus true
     if ((xperdom .or. (yperdom .or. spheredom)) .and. sticksout(iplo,iphi,jplo,jphi)) then
        call prefilrecur(level-1,nvar,valcrse,auxcrse,naux,t,mitot_coarse,mjtot_coarse,1,1,   &
             iplo,iphi,jplo,jphi,iplo,iphi,jplo,jphi,.true.)
     else
        call filrecur(level-1,nvar,valcrse,auxcrse,naux,t,mitot_coarse,mjtot_coarse,1,1,   &
             iplo,iphi,jplo,jphi,.true.,-1,yes_do_aux_copy)  ! when going to coarser patch, no source grid (for now at least)
     endif

     ! convert to real for use below
     ratiox = real(refinement_ratio_x,kind=8)
     ratioy = real(refinement_ratio_y,kind=8)

     ! fine below refers to level "level"
     ! coarse below refers to level "level-1"
     do j_fine  = 1,mjtot_patch
        !j_coarse = 2 + (j_fine - (unset_indices(3) - jlo) - 1) / refinement_ratio_y
        !eta2 = (-0.5d0 + real(mod(j_fine - 1, refinement_ratio_y),kind=8)) &
        !                    / real(refinement_ratio_y,kind=8)

        ! we are now processing the j_fine^{th} column of the fine patch
        ! this is contained in the j_coarse^{th} column of the coarse patch below it  
        ! note that these two are not global indices but local indices
        j_coarse =floor((j_fine+jlo-1)/ratioy) - jplo + 1
        ycent_coarse = ylow_coarse + (j_coarse-.5d0)*dy_coarse
        ycent_fine =  ylower + (j_fine-1+jlo + .5d0)*dy_fine
        eta2 = (ycent_fine-ycent_coarse)/dy_coarse
        if (abs(eta2) .gt. .5) then
           write(*,*)" filpatch y indices wrong: eta2 = ",eta2
        endif

        do i_fine = 1,mitot_patch
              !i_coarse = 2 + (i_fine - (unset_indices(1) - ilo) - 1) / refinement_ratio_x
              !eta1 = (-0.5d0 + real(mod(i_fine - 1, refinement_ratio_x),kind=8)) &
              !                    / real(refinement_ratio_x,kind=8)

              ! new coarse indexing
              !i_coarse =(i_fine+ilo-1)/refinement_ratio_x - iplo + 1
              i_coarse = floor((i_fine+ilo-1)/ratiox) - iplo + 1
              xcent_coarse = xlow_coarse + (i_coarse-.5d0)*dx_coarse
              xcent_fine =  xlower + (i_fine-1+ilo + .5d0)*dx_fine
              eta1 = (xcent_fine-xcent_coarse)/dx_coarse
              if (abs(eta1) .gt. .5) then
                 write(*,*)" filpatch x indices wrong: eta1 = ",eta1
              endif

   
           if (flaguse(i_fine,j_fine) == 0) then

              do n=1,nvar
                 ! write(*,*)n,i_coarse+1,j_coarse,coarse_index(n,i_coarse + 1,j_coarse)
                 ! QUESTION: why do we interpolate in this way?
                 valp10 = valcrse(coarse_index(n,i_coarse + 1,j_coarse))
                 valm10 = valcrse(coarse_index(n,i_coarse - 1,j_coarse))
                 valc   = valcrse(coarse_index(n,i_coarse    ,j_coarse))
                 valp01 = valcrse(coarse_index(n,i_coarse    ,j_coarse + 1))
                 valm01 = valcrse(coarse_index(n,i_coarse    ,j_coarse - 1))

                 dupc = valp10 - valc
                 dumc = valc   - valm10
                 ducc = valp10 - valm10
                 du   = min(abs(dupc), abs(dumc))
                 du   = min(2.d0 * du, 0.5d0 * abs(ducc))
                 fu = max(0.d0, sign(1.d0, dupc * dumc))
                 uslope = du*sign(1.d0,ducc)*fu ! not really - should divide by h

                 dvpc = valp01 - valc
                 dvmc = valc   - valm01
                 dvcc = valp01 - valm01
                 dv   = min(abs(dvpc), abs(dvmc))
                 dv   = min(2.d0 * dv, 0.5d0 * abs(dvcc))
                 fv = max(0.d0,sign(1.d0, dvpc * dvmc))
                 vslope = dv*sign(1.d0,dvcc)*fv ! but faster to put in eta above

                 valint = valc + eta1 * uslope + eta2 * vslope

                 valbig(n,i_fine+nrowst-1,j_fine+ncolst-1) = valint

              end do

           endif
        end do
     end do
  end if  ! end if not set

  !  set bcs, whether or not recursive calls needed. set any part of patch that stuck out
  xhi_fine = xlower + (ihi + 1) * dx_fine
  yhi_fine = ylower + (jhi + 1) * dy_fine
  ! only call if a small coarser recursive patch
  ! otherwise whole grid bcs done from bound
  if (patchOnly) then
     call bc2amr(valbig,aux,mitot,mjtot,nvar,naux,dx_fine,dy_fine,level,t,    &
                 xlow_fine,xhi_fine,ylow_fine,yhi_fine)
  endif

contains

  integer pure function coarse_index(n,i,j)
    implicit none
    integer, intent(in) :: n, i, j
    coarse_index = n + nvar*(i-1)+nvar*mitot_coarse*(j-1)
  end function coarse_index

  logical pure function sticksout(iplo,iphi,jplo,jphi)
    implicit none
    integer, intent(in) :: iplo,iphi,jplo,jphi
    sticksout = (iplo < 0 .or. jplo < 0 .or. &
         iphi >= iregsz(level - 1) .or. jphi >= jregsz(level - 1))
  end function sticksout

end subroutine filrecur

c
c ---------------------------------------------------------
c
      subroutine projec(level,numpro,iflags,isize,jsize,ksize)
c
      use amr_module
      implicit double precision (a-h,o-z)


      integer*1 iflags(0:isize+1,0:jsize+1,0:ksize+1)
c
c  ::::::::::::::::::::::: PROJEC ::::::::::::::::::::::::::::::
c  for all newly created fine grids, project area onto a coarser
c  grid 2 levels down. Used to recreate grids 1 level down, and
c  insure proper level nesting.
c
c  on entry, all coarse grids have already had error estimated, so
c  add bad flags.   count number of 'added' flags only.
c
c input parameters:
c    level = project all fine subgrids onto grids at this level.
c output parameters:
c  numpro = number of additional flagged pts. at 'level'.
c           (initialized to 0 in flglvl)
c local variables:
c     iflags  = holds coarser domain flagged points - receives projection
c     mkid    = grid doing the projecting
c  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      levpro  =  level + 2
      lrat2x   = intratx(level)*intratx(level+1)
      lrat2y   = intraty(level)*intraty(level+1)
      lrat2z   = intratz(level)*intratz(level+1)
c
      mkid = newstl(levpro)
 10   if (mkid .eq. 0) go to 90
       ilo = node(ndilo,mkid) 
       jlo = node(ndjlo,mkid)
       klo = node(ndklo,mkid)
       ihi = node(ndihi,mkid)
       jhi = node(ndjhi,mkid)
       khi = node(ndkhi,mkid)
c
c  project entire region of fine grids into iflags array.
c  possibly take care of buffering.
c  adjust since grid descriptor (integer indices)  is 0 based, 
c  iflags indexing is 1 based. 
c
      ist  = ilo/lrat2x 
      jst  = jlo/lrat2y
      kst  = klo/lrat2z
      iend = (ihi+lrat2x-1)/lrat2x 
      jend = (jhi+lrat2y-1)/lrat2y
      kend = (khi+lrat2z-1)/lrat2z
      if (ibuff .eq. 0) then
c     ## ensure proper nesting here, since buffering step won't follow
        if (ist*lrat2x .eq. ilo) ist = ist-1
        if (jst*lrat2y .eq. jlo) jst = jst-1
        if (kst*lrat2z .eq. klo) kst = kst-1
        if (iend*lrat2x .eq. ihi+1) iend = iend+1
        if (jend*lrat2y .eq. jhi+1) jend = jend+1
        if (kend*lrat2z .eq. khi+1) kend = kend+1
      endif
c
       do 60 k = kst+1, kend+1
       do 60 j = jst+1, jend+1
       do 60 i = ist+1, iend+1
           if (iflags(i,j,k) .eq. goodpt) then
               iflags(i,j,k) = badpro
               numpro        = numpro + 1
               if (pprint) write(outunit,101) i,j,k,mkid
101            format(' pt.',3i5,' of grid ',i5,' projected' )
           endif
 60    continue
c
c  done with gridpt. loop for grid mkid.
c
 80     mkid = node(levelptr, mkid)
        go to 10
c
 90   if (numpro .eq. 0) go to 95
      if (pprint) then
        write(outunit,102) numpro,level
 102    format(i7,' more pts. projected to level ',i5)
      endif
c
 95   if (pprint) then
         write(outunit,103) level
 103     format(/,'  from projec: flagged pts. at level ',i4,':')
         do 110 kk = 1, ksize
            k        = ksize + 1 - kk
            write(outunit,*) 'plane k = ',k
         do 110 jj = 1, jsize
            j        = jsize + 1 - jj
            write(outunit,104) (iflags(i,j,k),i=1,isize)
104         format(80i1)
 110     continue
      endif
c
 99   return
      end

c
c -------------------------------------------------------------
c
      subroutine ginit(msave, first, nvar, naux, start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical first
      
      !for setaux timing
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish


c ::::::::::::::::::::::::::::: GINIT ::::::::::::::::::::::::
c
c  initializes soln on all grids at 'level'  by calling qinit
c  if first = true, (first call to init), then allocate the
c  soln storage area too, else was already allocated.
c
c :::::::::::::::::::::::::::::::::::::::;::::::::::::::::::::

      if (msave .eq. 0) go to 99

      level = node(nestlevel,msave)
      hx    = hxposs(level)
      hy    = hyposs(level)
      hz    = hzposs(level)

      mptr  = msave

 10       nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      nz      = node(ndkhi,mptr) - node(ndklo,mptr) + 1
      mitot   = nx + 2*nghost
      mjtot   = ny + 2*nghost
      mktot  = nz + 2*nghost
      corn1   = rnode(cornxlo,mptr)
      corn2   = rnode(cornylo,mptr)
      corn3   = rnode(cornzlo,mptr)
      if(.not. (first)) go to 20
      loc                 = igetsp(mitot*mjtot*mktot*nvar)
      node(store1,mptr)   = loc
      if (naux .gt. 0) then
         locaux              = igetsp(mitot*mjtot*mktot*naux)
         maxmx = mitot - 2*nghost
         maxmy = mjtot - 2*nghost
         maxmz = mktot - 2*nghost
         mx = maxmx
         my = maxmy
         mz = maxmz
         call system_clocK(clock_start, clock_rate)
         call cpu_time(cpu_start)
         call setaux(nghost,mx,my,mz, corn1,corn2,corn3,
     &               hx,hy,hz,naux,alloc(locaux))
         call system_clock(clock_finish, clock_rate)
         call cpu_time(cpu_finish)

      else
         locaux = 1
      endif
      node(storeaux,mptr) = locaux
      if (level .lt. mxnest) then
         loc2              = igetsp(mitot*mjtot*mktot*nvar)
         node(store2,mptr) = loc2
      endif
      rnode(timemult, mptr) = start_time 
      go to 30
   20 continue
c
c  if 2nd time through, put initial values in store2 so finer grids
c  can be advanced with interpolation of their boundary values.
c  new time soln should still be in location store1.
c
      loc     = node(store2,mptr)
      locaux  = node(storeaux,mptr)
c
   30 continue
c      call qinit(alloc(loc),nvar,mitot,mjtot,mktot,
c     1               corn1-nghost*hx,corn2-nghost*hy,corn3-nghost*hz,
c     2               hx,hy,hz,alloc(locaux),naux)

      maxmx = mitot - 2*nghost
      maxmy = mjtot - 2*nghost
      maxmz = mktot - 2*nghost
      mx = maxmx
      my = maxmy
      mz = maxmz
      call qinit(nvar,nghost,mx,my,mz,corn1,corn2,corn3,
     &           hx,hy,hz,alloc(loc),naux,alloc(locaux))

c
      mptr  = node(levelptr, mptr)
      if (mptr .ne. 0) go to 10
c
c
   99 return
      end

c
!> For new fine grids (grids on level **level**), allocate space for 
!! saving fluxes at boundary (even if it's physical boundary) after 
!! each integration step.
!! These fluxes are for future conservative fixing of coarse grids
!! (level **level**-1 grids).
!! The address of this space is stored in node(ffluxptr, mkid) for grid
!! mkid. 
!!
!! Note that if the refinment ratio is r, fluxes from every r cells 
!! on grid **mkid** are saved to one slot in this space, since every r
!! cells on grid **mkid** border one cell on level **level**-1 grids.
!! \param[in] level boudnary lists of grids on this level get updated
!! \param[in] nvar number of equations for the system
!! \param[in] naux number of auxiliary variables for the system
c ----------------------------------------------------------
c
      subroutine prepf(level,nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::::::::::::: PREPF :::::::::::::::::::::::::::::
c
c prepare new fine grids to save fluxes after each integration step
c for future conservative fixing of coarse grids
c save all boundary fluxes of fine grid (even if phys. bndry.) -
c but only save space for every intrat. (remember - 4 fluxes).
c
c :::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::::::
c
      mkid = lstart(level)
 10   if (mkid .eq. 0) go to 99
          nx    = node(ndihi,mkid)-node(ndilo,mkid) + 1
          ny    = node(ndjhi,mkid)-node(ndjlo,mkid) + 1
          ikeep = nx/intratx(level-1)
          jkeep = ny/intraty(level-1)
          lenbc = 2*(ikeep+jkeep)
c
c         get twice the storage, one for plus or minus fluxes, the
c         other for coarse solution for wave fixing. also for aux vars.
c
          node(ffluxptr,mkid) = igetsp(2*nvar*lenbc+naux*lenbc)
          ist   = node(ffluxptr,mkid)

          do 20 i = 1, 2*nvar*lenbc + naux*lenbc
             alloc(ist+i-1) = 0.d0
 20       continue
          mkid = node(levelptr,mkid)
          go to 10

 99    return
       end

! ==================================================================
subroutine step3ds(maxm,num_eqn,num_waves,num_ghost,mx,my, &
                   mz,qold,qnew,aux,dx,dy,dz,dt,method,mthlim,cfl, &
                   qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d, &
                   aux1,aux2,aux3,num_aux,work,mwork,idir,use_fwave,rpn3,rpt3,rptt3)
! ==================================================================

!  Take one time step, updating q, to be used with
!  dimensional splitting.
!  On entry, qold and qnew should be identical and give the
!     initial data for this step.
!  On exit, qnew returns values at the end of the time step.
!     qold is unchanged.

!  This is a simplified version of the subroutine step3d
!  Since only qadd and fadd is used in the flux updates,
!  the solution updates below are considerably simplified
!  compared to step3d.

! -----------------------------------------------------------------
!  NOTE! Since dimensional splitting is used, it is possible
!        to reduce the memory requirement, i.e. the size of
!        the work array. It could be reduced with
! 
!        (maxm + 2*num_ghost)*(37*num_eqn + 6*num_aux),
! 
!        when also possible reductions in flux3 are included.
!        However, this term is small compared to the dominating
!        term (mx+2num_ghost)(my+2mb)*(mz+2num_ghost).
! -----------------------------------------------------------------

    implicit real*8(a-h,o-z)
    external rpn3,rpt3,rptt3
    dimension qold(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension qnew(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension  q1d(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension qadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension fadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension aux(num_aux, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension dtdx1d(1-num_ghost:maxm+num_ghost)
    dimension dtdy1d(1-num_ghost:maxm+num_ghost)
    dimension dtdz1d(1-num_ghost:maxm+num_ghost)
    dimension method(7),mthlim(num_waves)
    dimension work(mwork)
    logical ::          use_fwave

    common /comxyzt/ dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom

!f2py intent(out) cfl
!f2py intent(in,out) qnew
!f2py optional q1d, qadd, fadd, gadd, hadd, dtdx1d, dtdy1d, dtdz1d

! Dummy interfaces just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn3(x)
!f2py x=rpt3(x)
!f2py x=rptt3(x)

    ! partition work array into pieces needed for local storage in
    ! flux2 routine.  Find starting index of each piece:

    i0wave     = 1
    i0s        = i0wave     + (maxm+2*num_ghost)*num_eqn*num_waves
    i0amdq     = i0s        + (maxm+2*num_ghost)*num_waves
    i0apdq     = i0amdq     + (maxm+2*num_ghost)*num_eqn
    i0cqxx     = i0apdq     + (maxm+2*num_ghost)*num_eqn
    i0bmamdq   = i0cqxx     + (maxm+2*num_ghost)*num_eqn
    i0bmapdq   = i0bmamdq   + (maxm+2*num_ghost)*num_eqn
    i0bpamdq   = i0bmapdq   + (maxm+2*num_ghost)*num_eqn
    i0bpapdq   = i0bpamdq   + (maxm+2*num_ghost)*num_eqn
    i0cmamdq   = i0bpapdq   + (maxm+2*num_ghost)*num_eqn
    i0cmapdq   = i0cmamdq   + (maxm+2*num_ghost)*num_eqn
    i0cpamdq   = i0cmapdq   + (maxm+2*num_ghost)*num_eqn
    i0cpapdq   = i0cpamdq   + (maxm+2*num_ghost)*num_eqn
    i0cmamdq2  = i0cpapdq   + (maxm+2*num_ghost)*num_eqn
    i0cmapdq2  = i0cmamdq2  + (maxm+2*num_ghost)*num_eqn
    i0cpamdq2  = i0cmapdq2  + (maxm+2*num_ghost)*num_eqn
    i0cpapdq2  = i0cpamdq2  + (maxm+2*num_ghost)*num_eqn
    i0bmcqxxp  = i0cpapdq2  + (maxm+2*num_ghost)*num_eqn
    i0bmcqxxm  = i0bmcqxxp  + (maxm+2*num_ghost)*num_eqn
    i0bpcqxxp  = i0bmcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0bpcqxxm  = i0bpcqxxp   + (maxm+2*num_ghost)*num_eqn
    i0cmcqxxp  = i0bpcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0cmcqxxm  = i0cmcqxxp   + (maxm+2*num_ghost)*num_eqn
    i0cpcqxxp  = i0cmcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0cpcqxxm  = i0cpcqxxp   + (maxm+2*num_ghost)*num_eqn
    i0bmcmamdq = i0cpcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0bmcmapdq = i0bmcmamdq + (maxm+2*num_ghost)*num_eqn
    i0bpcmamdq = i0bmcmapdq + (maxm+2*num_ghost)*num_eqn
    i0bpcmapdq = i0bpcmamdq + (maxm+2*num_ghost)*num_eqn
    i0bmcpamdq = i0bpcmapdq + (maxm+2*num_ghost)*num_eqn
    i0bmcpapdq = i0bmcpamdq + (maxm+2*num_ghost)*num_eqn
    i0bpcpamdq = i0bmcpapdq + (maxm+2*num_ghost)*num_eqn
    i0bpcpapdq = i0bpcpamdq + (maxm+2*num_ghost)*num_eqn
    iused      = i0bpcpapdq + (maxm+2*num_ghost)*num_eqn - 1

    if (iused > mwork) then
        ! This shouldn't happen due to checks in claw2
        write(6,*) '*** not enough work space in step2'
        write(6,*) '*** iused = ', iused, '   mwork =',mwork
        stop
    endif

    index_capa = method(6)
    ! num_aux = method(7)
    cfl = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy
    dtdz = dt/dz

    if (index_capa == 0) then
        ! no capa array:
        do i=1-num_ghost,maxm+num_ghost
            dtdx1d(i) = dtdx
            dtdy1d(i) = dtdy
            dtdz1d(i) = dtdz
        end do
    endif


    if( idir == 1)then
    
        ! perform x-sweeps
        ! ==================
    
        do k = 0,mz+1
            do j = 0,my+1
            
                forall (m = 1:num_eqn, i = 1-num_ghost:mx+num_ghost)
                    ! copy data along a slice into 1d array:
                    q1d(m,i) = qold(m,i,j,k)
                end forall
            
                if (index_capa > 0)  then
                    do i = 1-num_ghost, mx+num_ghost
                        dtdx1d(i) = dtdx / aux(index_capa,i,j,k)
                    end do
                endif
            
                ! Since dimensional splitting is used, only aux2 is needed.
            
                if (num_aux > 0)  then
                    forall (ma=1:num_aux,i= 1-num_ghost:mx+num_ghost, ka = -1:1)
                    aux2(ma,i,2+ka) = aux(ma,i,j,k+ka)
                    end forall
                endif
            
                ! Store the value of j and k along this slice in the common block
                ! comxyt in case it is needed in the Riemann solver (for
                ! variable coefficient problems)
            
                jcom = j
                kcom = k
            
                ! compute modifications qadd and fadd along this slice
            
                call flux3(1,maxm,num_eqn,num_waves,num_ghost,mx, &
                           q1d,dtdx1d,dtdy,dtdz,dummy1,aux2,dummy3,num_aux, &
                           method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                           work(i0wave),work(i0s),work(i0amdq), &
                           work(i0apdq),work(i0cqxx), &
                           work(i0bmamdq),work(i0bmapdq), &
                           work(i0bpamdq),work(i0bpapdq), &
                           work(i0cmamdq),work(i0cmapdq), &
                           work(i0cpamdq),work(i0cpapdq), &
                           work(i0cmamdq2),work(i0cmapdq2), &
                           work(i0cpamdq2),work(i0cpapdq2), &
                           work(i0bmcqxxp),work(i0bpcqxxp), &
                           work(i0bmcqxxm),work(i0bpcqxxm), &
                           work(i0cmcqxxp),work(i0cpcqxxp), &
                           work(i0cmcqxxm),work(i0cpcqxxm), &
                           work(i0bmcmamdq),work(i0bmcmapdq), &
                           work(i0bpcmamdq),work(i0bpcmapdq), &
                           work(i0bmcpamdq),work(i0bmcpapdq), &
                           work(i0bpcpamdq),work(i0bpcpapdq), &
                           use_fwave,rpn3,rpt3,rptt3)
                        
                cfl = dmax1(cfl,cfl1d)
            
                ! update qnew by flux differencing.
                ! (rather than maintaining arrays f, g and h for the total fluxes,
                ! the modifications are used immediately to update qnew
                ! in order to save storage.)
            
                if(index_capa == 0)then
                    ! no capa array.  Standard flux differencing:
                    forall (m = 1:num_eqn, i = 1:mx)
                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i) &
                            - dtdx * (fadd(m,i+1) - fadd(m,i))
                    end forall
                else
                    ! with capa array
                    forall (m = 1:num_eqn, i = 1:mx)
                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i) &
                            - dtdx * (fadd(m,i+1) - fadd(m,i)) &
                            / aux(index_capa,i,j,k)
                    end forall
                endif
            end do
        end do
    
    else if( idir == 2 )then
    
        ! perform y sweeps
        ! ==================
    
        do k = 0, mz+1
            do i = 0, mx+1
            
                forall (m = 1:num_eqn, j = 1-num_ghost:my+num_ghost)
                    ! copy data along a slice into 1d array:
                    q1d(m,j) = qold(m,i,j,k)
                end forall
            
                if (index_capa > 0)  then
                    do j = 1-num_ghost, my+num_ghost
                        dtdy1d(j) = dtdy / aux(index_capa,i,j,k)
                    end do
                endif
            
                ! Since dimensional splitting is used, only aux2 is needed.
            
                if (num_aux > 0)  then
                    ! There's a decent chance aux2 will all fit into cache,
                    ! so keep accesses to aux as contiguous as possible.
                    forall (ma=1:num_aux,ia= -1:1, j = 1-num_ghost:my+num_ghost)
                    aux2(ma, j, 2+ia) = aux(ma, i+ia, j, k)
                    end forall
                endif
            
                ! Store the value of i and k along this slice in the common block
                ! comxyzt in case it is needed in the Riemann solver (for
                ! variable coefficient problems)
            
                icom = i
                kcom = k
            
                ! compute modifications qadd and fadd along this slice
            
                call flux3(2,maxm,num_eqn,num_waves,num_ghost,my, &
                           q1d,dtdy1d,dtdz,dtdx,dummy1,aux2,dummy3,num_aux, &
                           method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                           work(i0wave),work(i0s),work(i0amdq), &
                           work(i0apdq),work(i0cqxx), &
                           work(i0bmamdq),work(i0bmapdq), &
                           work(i0bpamdq),work(i0bpapdq), &
                           work(i0cmamdq),work(i0cmapdq), &
                           work(i0cpamdq),work(i0cpapdq), &
                           work(i0cmamdq2),work(i0cmapdq2), &
                           work(i0cpamdq2),work(i0cpapdq2), &
                           work(i0bmcqxxp),work(i0bpcqxxp), &
                           work(i0bmcqxxm),work(i0bpcqxxm), &
                           work(i0cmcqxxp),work(i0cpcqxxp), &
                           work(i0cmcqxxm),work(i0cpcqxxm), &
                           work(i0bmcmamdq),work(i0bmcmapdq), &
                           work(i0bpcmamdq),work(i0bpcmapdq), &
                           work(i0bmcpamdq),work(i0bmcpapdq), &
                           work(i0bpcpamdq),work(i0bpcpapdq), &
                           use_fwave,rpn3,rpt3,rptt3)
            
                cfl = dmax1(cfl,cfl1d)
            
                ! update qnew by flux differencing.
                ! Note that the roles of the flux updates are changed.
                ! fadd - modifies the g-fluxes
            
                if( index_capa == 0)then
                    ! no capa array.  Standard flux differencing:
                    forall (m = 1:num_eqn, j = 1:my)
                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j) &
                            - dtdy * (fadd(m,j+1) - fadd(m,j))
                    end forall
                else
                    ! with capa array.
                    forall (m = 1:num_eqn, j = 1:my)
                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j) &
                            - dtdy * (fadd(m,j+1) - fadd(m,j)) &
                            / aux(index_capa,i,j,k)
                    end forall
                endif
            end do
        end do
    
    else
    
        ! perform z sweeps
        ! ==================
    
    
        do j = 0, my+1
            do i = 0, mx+1
            
                forall (m = 1:num_eqn, k = 1-num_ghost:mz+num_ghost)
                    ! copy data along a slice into 1d array:
                    q1d(m,k) = qold(m,i,j,k)
                end forall
            
                if (index_capa > 0)  then
                    do k = 1-num_ghost, mz+num_ghost
                        dtdz1d(k) = dtdz / aux(index_capa,i,j,k)
                    end do
                endif
            
                ! Since dimensional splitting is used, only aux2 is needed.
            
                if (num_aux > 0)  then
                    ! There's a decent chance aux2 will all fit into cache,
                    ! so keep accesses to aux as contiguous as possible.
                    forall (ma=1:num_aux,ja= -1:1, k = 1-num_ghost:mz+num_ghost)
                        aux2(ma, k, 2+ja) = aux(ma, i, j+ja, k)
                    end forall
                endif
            
                ! Store the value of i and j along this slice in the common block
                ! comxyzt in case it is needed in the Riemann solver (for
                ! variable coefficient problems)
            
                icom = i
                jcom = j
            
                ! compute modifications qadd and fadd along this slice
            
                call flux3(3,maxm,num_eqn,num_waves,num_ghost,mz, &
                           q1d,dtdz1d,dtdx,dtdy,dummy1,aux2,dummy3,num_aux, &
                           method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                           work(i0wave),work(i0s),work(i0amdq), &
                           work(i0apdq),work(i0cqxx), &
                           work(i0bmamdq),work(i0bmapdq), &
                           work(i0bpamdq),work(i0bpapdq), &
                           work(i0cmamdq),work(i0cmapdq), &
                           work(i0cpamdq),work(i0cpapdq), &
                           work(i0cmamdq2),work(i0cmapdq2), &
                           work(i0cpamdq2),work(i0cpapdq2), &
                           work(i0bmcqxxp),work(i0bpcqxxp), &
                           work(i0bmcqxxm),work(i0bpcqxxm), &
                           work(i0cmcqxxp),work(i0cpcqxxp), &
                           work(i0cmcqxxm),work(i0cpcqxxm), &
                           work(i0bmcmamdq),work(i0bmcmapdq), &
                           work(i0bpcmamdq),work(i0bpcmapdq), &
                           work(i0bmcpamdq),work(i0bmcpapdq), &
                           work(i0bpcpamdq),work(i0bpcpapdq), &
                           use_fwave,rpn3,rpt3,rptt3)
            
                cfl = dmax1(cfl,cfl1d)
            
                ! update qnew by flux differencing.
                ! Note that the roles of the flux updates are changed.
                ! fadd - modifies the h-fluxes
            
                if(index_capa == 0)then
                    ! no capa array. Standard flux differencing:
                    forall (m = 1:num_eqn, k = 1:mz)
                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k) &
                            - dtdz * (fadd(m,k+1) - fadd(m,k))
                    end forall
                else
                    ! with capa array
                    forall (m = 1:num_eqn, k = 1:mz)
                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k) &
                            - dtdz * (fadd(m,k+1) - fadd(m,k)) &
                            / aux(index_capa,i,j,k)
                    end forall
                endif
            end do
        end do
    
    endif

    return
end subroutine step3ds

! =============================================================================
subroutine rp1_ptwise(num_eqn, num_aux, num_waves, q_l, q_r, aux_l, aux_r,    &
wave, s, amdq, apdq)
! =============================================================================
!
! Riemann problems for the 1D Burgers' equation with entropy fix for 
! transonic rarefaction. See "Finite Volume Method for Hyperbolic Problems",
! R. J. LeVeque.

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q
    
    implicit none

    ! Input Arguments
    integer, intent(in) :: num_eqn, num_aux, num_waves
    real(kind=8), intent(in out) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in out) :: aux_l(num_aux), aux_r(num_aux)

    ! Output arguments
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Local
    logical :: efix
 
    efix = .true.   !# Compute correct flux for transonic rarefactions

    wave(1,1) = q_r(1) - q_l(1)
    s(1) = 0.5d0 * (q_l(1) + q_r(1))

    amdq(1) = dmin1(s(1), 0.d0) * wave(1,1)
    apdq(1) = dmax1(s(1), 0.d0) * wave(1,1)

    if (efix) then
        if (q_r(1).gt.0.d0 .and. q_l(1).lt.0.d0) then
            amdq(1) = - 1.d0/2.d0 * q_l(1)**2
            apdq(1) =   1.d0/2.d0 * q_r(1)**2
        endif
    endif

    end subroutine rp1_ptwise

subroutine rp1(maxm,num_eqn,num_waves,num_aux,num_ghost,num_cells,ql,qr,auxl,auxr,fwave,s,amdq,apdq)

! Riemann solver for the 1D shallow water equations:

! (h)_t + (h*u)_x = 0
! (hu)_t + (h*u^2 + 1/2*grav*h^2)_x = -grav*h*(b)_x
!
! using the f-wave algorithm and Roe's approximate Riemann solver.

! waves:     2
! equations: 2

! Conserved quantities:
!       1 depth
!       2 momentum

! Auxiliary fields:
!       1 bathymetry

! The gravitational constant grav should be in the common block cparam.
!
! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

    implicit none 
    
    integer, intent(in) :: maxm, num_eqn, num_waves, num_ghost, num_aux, num_cells
    real(kind=8), intent(in) :: ql(num_eqn, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: qr(num_eqn, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: auxl(num_aux, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(in) :: auxr(num_aux, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: s(num_waves, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: fwave(num_eqn, num_waves, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: amdq(num_eqn, 1-num_ghost:maxm+num_ghost)
    real(kind=8), intent(out) :: apdq(num_eqn, 1-num_ghost:maxm+num_ghost)
    
    real(kind=8) :: grav, dry_tolerance, sea_level
    common /cparam/ grav, dry_tolerance, sea_level
    
    real(kind=8) :: hl, ul, hr, ur, hbar, uhat, chat, bl, br, phil, phir
    real(kind=8) :: R(2,2), fluxdiff(2), beta(2)
    
    integer :: i, k

    amdq = 0.d0
    apdq = 0.d0
    
    do i=2-num_ghost,num_cells+num_ghost
        ! # Left states
        hl = qr(1, i - 1)
        if (hl > dry_tolerance) then
            ul = qr(2, i - 1) / hl
            phil = qr(1, i - 1) * ul**2 + 0.5d0 * grav * qr(1, i - 1)**2
        else
            ul = 0.d0
            phil = 0.d0
        end if
        bl = auxr(1, i - 1)
        
        ! # Right states
        hr = ql(1, i)
        if (hr > dry_tolerance) then
            ur = ql(2, i)/hr
            phir = ql(1, i) * ur**2 + 0.5d0 * grav * ql(1, i)**2
        else
            ur = 0.d0
            phir = 0.d0
        end if
        br = auxl(1, i)
        
        ! # Roe average states
        hbar = 0.5 * (hr + hl)
        uhat = (sqrt(hl) * ul + sqrt(hr) * ur) / (sqrt(hl) + sqrt(hr))
        chat = sqrt(grav * hbar)
        
        ! # Flux differences
        fluxdiff(1) = (hr * ur) - (hl * ul)
        fluxdiff(2) = phir - phil + grav * hbar * (br - bl)
        
        ! # Wave speeds
        s(1,i) = min(ul - sqrt(grav * hl), uhat - chat)
        s(2,i) = max(ur + sqrt(grav * hr), uhat + chat)
        
        ! # Right eigenvectors (column)
        R(1,1) = 1.d0
        R(2,1) = s(1, i)
        
        R(1,2) = 1.d0
        R(2,2) = s(2, i)
    
        ! Wave strengths
        beta(1) = (s(2, i) * fluxdiff(1) - fluxdiff(2)) / (s(2, i) - s(1, i))
        beta(2) = (fluxdiff(2) - s(1, i) * fluxdiff(1)) / (s(2, i) - s(1, i))

        ! # Flux waves
        do k=1,num_waves
            fwave(:,k,i) = beta(k) * R(:,k)
        enddo
        
        ! # Fluctuations
        do k=1, num_waves
            if (s(k, i) < 0.d0) then
                amdq(:, i) = amdq(:, i) + fwave(:, k, i)
            else if (s(k, i) > 0.d0) then
                apdq(:, i) = apdq(:, i) + fwave(:, k, i)
            else
                amdq(:, i) = amdq(:, i) + 0.5d0 * fwave(:, k, i)
                apdq(:, i) = apdq(:, i) + 0.5d0 * fwave(:, k, i)
            end if
        enddo
    enddo
    
end subroutine rp1

!-----------------------------------------------------------------------------------
! Name: rpt3(ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,
!            bmasdq,bpasdq)
!
! Description: Roe f-wave solver in the transverse direction for the 
!              3D Euler equations in general geometries
!
! Inputs: 
!         ixyz <INTEGER>   : direction to take slice x-direction if ixyz=1
!                                                    y-direction if ixyz=2.
!                                                    z-direction if ixyz=3.
!         icoor <INTEGER>  : direction in which the transverse solve should be
!                            performed.  icoor=2 (split in y-like direction)
!                                        icoor=3 (split in z-like direction)
!                            ixyz=1, icoor=2 means asdq=A^*\Dq, split in y into:
!                                            bmasdq = B^-A^*\Dq,
!                                            bpasdq = B^+A^*\Dq.
!                            ixyz=2, icoor=2 means asdq=B^*\Dq, split in z into: 
!                                            bmasdq = C^-B^*\Dq,
!                                            bpasdq = C^+B^*\Dq.
!         imp <INTEGER>    : index for aux arrays
!         maxm <INTEGER>   : max number of grid cells (less the ghost cells)
!         meqn <INTEGER>   : number of equations in the system
!         mwaves <INTEGER> : nuber of waves in the system
!         maux <INTEGER>   : number of auxilary equations
!         mbc <INTEGER>    : number of ghost cells on either end
!         mx <INTEGER>     : number of elements
!         ql <REAL>        : state vector at left edge of each cell
!                            Note the i'th Riemann problem has left state qr(:,i-1)
!         qr <REAL>        : state vector at right edge of each cell
!                            Note the i'th Riemann problem has right state ql(:,i)
!         aux1 <REAL>      : 
!         aux2 <REAL>      :
!         aux3 <REAL>      :
!         asdq <REAL>      : array of flux differences (A*\Dq).  asdq(:,i) is the
!                            flux difference propagating away from the interface
!                            between cells i-1 and i.  Note: asdq represents
!                            B*\Dq if ixyz=2 or C*\Dq if ixyz=3.
!         
! Outputs: 
!          bmasdq <REAL>   : left-going flux differences
!          bpasdq <REAL>   : right-going flux differences
!
! Adapted from rpt3_euler.f90 in $CLAWHOME/riemann/src
!-----------------------------------------------------------------------------------
SUBROUTINE rpt3(ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,&
     asdq,bmasdq,bpasdq)

  IMPLICIT NONE

  ! Input
  INTEGER, INTENT(IN) :: ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx
  REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(IN) :: ql,qr,asdq
  REAL(kind=8), DIMENSION(maux,1-mbc:maxm+mbc,3), INTENT(IN) :: aux1,aux2,aux3

  ! Output
  REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(INOUT) :: bmasdq,bpasdq
  
  ! Local Storage
  REAL(kind=8), DIMENSION(meqn) :: beta
  REAL(kind=8), DIMENSION(-1:maxm+mbc) :: u2v2w2,u,v,w,enth,a,g1a2,euv
  REAL(kind=8) :: gamma1,asqrd,pl,pr,rhsq2,rhsqrtl,rhsqrtr,nx,ny,nz,vn,&
       areaRatioMinus,areaRatioPlus
  REAL(kind=8), DIMENSION(meqn,mwaves) :: waveb
  REAL(kind=8), DIMENSION(mwaves) :: sb
  INTEGER :: i,j,mu=2,mv=3,mw=4,mws,nu=1,nv=2,nw=3,iratio=4
  CHARACTER(20) :: nonsingularNormal

  ! Common block storage for ideal gas constant
  REAL(kind=8) :: gamma
  COMMON /cparam/ gamma

  ! Set (gamma-1)
  gamma1 = gamma - 1.d0

  ! Make sure the number of waves is 3 for the 3D Euler equations
  IF (mwaves /= 3) THEN
     WRITE(6,*) '*** Should have mwaves=3 for this Riemann solver'
     STOP
  ENDIF
    
  ! Set mu to point to  the component of the system that corresponds to momentum in 
  !  the direction of this slice, mv and mw to the orthogonal momentums.
  !
  !  ixyz indicates the direction of the original Riemann solve,
  !  called the x-like direction in the table below:
  ! 
  !          x-like direction   y-like direction   z-like direction
  !  ixyz=1:        x                  y                  z         
  !  ixyz=2:        y                  z                  x         
  !  ixyz=3:        z                  x                  y      
  IF(ixyz == 1)THEN ! x-like direction
     mu = 2
     mv = 3
     mw = 4
     ! Choose the coordinate direction to solve the Riemann problem
     !   Permute nu,nv,nw for the original ixyz incident direction (x-like)
     IF(icoor == 2)THEN ! y-like direction
        nu = 5
        nv = 6
        nw = 7
        iratio = 8
     ELSEIF(icoor == 3)THEN ! z-like direction
        nu = 9
        nv = 10
        nw = 11
        iratio = 12
     END IF
  ELSEIF(ixyz == 2)THEN ! y-like direction
     mu = 3
     mv = 4
     mw = 2
     ! Choose the coordinate direction to solve the Riemann problem
     !   Permute nu,nv,nw for the original ixyz incident direction (y-like)
     IF(icoor == 2)THEN ! z-like direction
        nu = 10
        nv = 11
        nw = 9
        iratio = 12
     ELSEIF(icoor == 3)THEN ! x-like direction
        nu = 2
        nv = 3
        nw = 1
        iratio = 4
     END IF
  ELSEIF(ixyz == 3)THEN ! z-like direction
     mu = 4
     mv = 2
     mw = 3
     ! Choose the coordinate direction to solve the Riemann problem
     !   Permute nu,nv,nw for the original ixyz incident direction (z-like)
     IF(icoor == 2)THEN ! x-like direction
        nu = 3
        nv = 1
        nw = 2
        iratio = 4
     ELSEIF(icoor == 3)THEN ! y-like direction
        nu = 7
        nv = 5
        nw = 6
        iratio = 8
     END IF
  ENDIF

  ! Note that notation for u,v, and w reflects assumption that the
  !   Riemann problems are in the x-direction with u in the normal
  !   direction and v and w in the orthogonal directions, but with the
  !   above definitions of mu, mv, and mw the routine also works with
  !   ixyz=2 and ixyz = 3
  !   and returns, for example, f0 as the Godunov flux g0 for the
  !   Riemann problems u_t + g(u)_y = 0 in the y-direction.
  !
  ! Compute the Roe-averaged variables needed in the Roe solver.

  ! Loop over grid cell interfaces
  DO i = 2-mbc, mx+mbc
     IF (qr(1,i-1) <= 0.d0 .OR. ql(1,i) <= 0.d0) THEN
        WRITE(*,*) i, mu, mv, mw
        WRITE(*,'(5e12.4)') (qr(j,i-1),j=1,5)
        WRITE(*,'(5e12.4)') (ql(j,i),j=1,5)
        IF (ixyz == 1) WRITE(6,*) '*** (rpt3) rho <= 0 in x-sweep at ',i
        IF (ixyz == 2) WRITE(6,*) '*** (rpt3) rho <= 0 in y-sweep at ',i
        IF (ixyz == 3) WRITE(6,*) '*** (rpt3) rho <= 0 in z-sweep at ',i
        WRITE(6,*) 'stopped with rho <= 0...'
        STOP
     ENDIF
     rhsqrtl = SQRT(qr(1,i-1))
     rhsqrtr = SQRT(ql(1,i))
     pl = gamma1*(qr(5,i-1) - 0.5d0*(qr(mu,i-1)**2 + &
          qr(mv,i-1)**2 + qr(mw,i-1)**2)/qr(1,i-1))
     pr = gamma1*(ql(5,i) - 0.5d0*(ql(mu,i)**2 + &
          ql(mv,i)**2 + ql(mw,i)**2)/ql(1,i))
     rhsq2 = rhsqrtl + rhsqrtr
     u(i) = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
     v(i) = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
     w(i) = (qr(mw,i-1)/rhsqrtl + ql(mw,i)/rhsqrtr) / rhsq2
     enth(i) = (((qr(5,i-1)+pl)/rhsqrtl &
          + (ql(5,i)+pr)/rhsqrtr)) / rhsq2
     u2v2w2(i) = u(i)**2 + v(i)**2 + w(i)**2
     asqrd = gamma1*(enth(i) - .5d0*u2v2w2(i))
     
     IF (i>=0 .AND. i<=mx .AND. asqrd <= 0.d0) THEN
        IF (ixyz == 1) WRITE(6,*) '*** (rpt3) a**2 <= 0 in x-sweep at ',i
        IF (ixyz == 2) WRITE(6,*) '*** (rpt3) a**2 <= 0 in y-sweep at ',i
        IF (ixyz == 3) WRITE(6,*) '*** (rpt3) a**2 <= 0 in z-sweep at ',i
        WRITE(6,*) 'stopped with a**2 < 0...'
        STOP
     ENDIF
     a(i) = SQRT(asqrd)
     g1a2(i) = gamma1 / asqrd
     euv(i) = enth(i) - u2v2w2(i)
  END DO

  ! Solve the Riemann Problem
  DO i = 2-mbc, mx+mbc

     nx = aux2(nu,i,2)
     ny = aux2(nv,i,2)
     nz = aux2(nw,i,2)
     vn = u(i)*nx + v(i)*ny + w(i)*nz
     IF(icoor == 2)THEN
        areaRatioMinus = aux2(iratio,i-2+imp,2)
        areaRatioPlus  = aux3(iratio,i-2+imp,2)
     ELSEIF(icoor == 3)THEN
        areaRatioMinus = aux2(iratio,i-2+imp,2)
        areaRatioPlus  = aux2(iratio,i-2+imp,3)
     ENDIF
     ! Pick the largest normal to avoid using a singular direction
     IF(ABS(nx) >= ABS(ny) .AND. ABS(nx) >= ABS(nz))THEN
        nonsingularNormal = "x"
     ELSEIF(ABS(ny) >= ABS(nx) .AND. ABS(ny) >= ABS(nz))THEN
        nonsingularNormal = "y"
     ELSEIF(ABS(nz) >= ABS(nx) .AND. ABS(nz) >= ABS(ny))THEN
        nonsingularNormal = "z"
     ELSE
        WRITE(*,*)"Invalid Normal Vector..."
        WRITE(*,*)"nx: ",nx,"ny: ",ny,"nz: ",nz
        STOP
     END IF
     
     beta(4) = g1a2(i)*(euv(i)*asdq(1,i) &
          + u(i)*asdq(mu,i) + v(i)*asdq(mv,i) + w(i)*asdq(mw,i) - asdq(5,i))
     beta(5) = ( (a(i)-vn)*asdq(1,i) - a(i)*beta(4) &
          + nx*asdq(mu,i) + ny*asdq(mv,i) + nz*asdq(mw,i) )/(2.d0*a(i))
     beta(1) = asdq(1,i) - beta(4) - beta(5)
     
     SELECT CASE(TRIM(nonsingularNormal))
     CASE("x")
        beta(2) = ( (v(i)-vn*ny)*asdq(1,i) + nx*ny*asdq(mu,i) &
             + (ny**2-1)*asdq(mv,i) + ny*nz*asdq(mw,i) )/nx
        beta(3) = (-(w(i)-vn*nz)*asdq(1,i) - nx*nz*asdq(mu,i) &
             - ny*nz*asdq(mv,i) - (nz**2-1)*asdq(mw,i) )/nx
     CASE("y")
        beta(2) = (-(u(i)-vn*nx)*asdq(1,i) - (nx**2-1)*asdq(mu,i) &
             - ny*nx*asdq(mv,i) - nx*nz*asdq(mw,i) )/ny
        beta(3) = ( (w(i)-vn*nz)*asdq(1,i) + nx*nz*asdq(mu,i) &
             + ny*nz*asdq(mv,i) + (nz**2-1)*asdq(mw,i) )/ny
     CASE("z")
        beta(2) = ( (u(i)-vn*nx)*asdq(1,i) + (nx**2-1)*asdq(mu,i) &
             + nx*ny*asdq(mv,i) + nz*nx*asdq(mw,i) )/nz
        beta(3) = (-(v(i)-vn*ny)*asdq(1,i) - nx*ny*asdq(mu,i) &
             - (ny**2-1)*asdq(mv,i) - nz*ny*asdq(mw,i) )/nz
     END SELECT
     
     waveb(1,1)  = beta(1)
     waveb(mu,1) = beta(1)*(u(i)-a(i)*nx)
     waveb(mv,1) = beta(1)*(v(i)-a(i)*ny)
     waveb(mw,1) = beta(1)*(w(i)-a(i)*nz)
     waveb(5,1)  = beta(1)*(enth(i) - vn*a(i))
     sb(1) = vn - a(i)
     
     waveb(1,2)  = beta(4)
     SELECT CASE(TRIM(nonsingularNormal))
     CASE("x")
        waveb(mu,2) = beta(4)*u(i) + beta(2)*ny - beta(3)*nz
        waveb(mv,2) = beta(4)*v(i) - beta(2)*nx
        waveb(mw,2) = beta(4)*w(i) + beta(3)*nx
        waveb(5,2)  = beta(4)*0.5d0*u2v2w2(i)  &
             + beta(2)*(u(i)*ny-v(i)*nx) + beta(3)*(w(i)*nx-u(i)*nz)
     CASE("y")
        waveb(mu,2) = beta(4)*u(i) + beta(2)*ny
        waveb(mv,2) = beta(4)*v(i) - beta(2)*nx + beta(3)*nz
        waveb(mw,2) = beta(4)*w(i) - beta(3)*ny
        waveb(5,2)  = beta(4)*0.5d0*u2v2w2(i)  &
             + beta(2)*(u(i)*ny-v(i)*nx) + beta(3)*(v(i)*nz-w(i)*ny)
     CASE("z")
        waveb(mu,2) = beta(4)*u(i) - beta(2)*nz
        waveb(mv,2) = beta(4)*v(i) + beta(3)*nz
        waveb(mw,2) = beta(4)*w(i) + beta(2)*nx - beta(3)*ny
        waveb(5,2)  = beta(4)*0.5d0*u2v2w2(i)  &
             + beta(2)*(w(i)*nx-u(i)*nz) + beta(3)*(v(i)*nz-w(i)*ny)
     END SELECT
     sb(2) = vn
     
     waveb(1,3)  = beta(5)
     waveb(mu,3) = beta(5)*(u(i) + a(i)*nx)
     waveb(mv,3) = beta(5)*(v(i) + a(i)*ny)
     waveb(mw,3) = beta(5)*(w(i) + a(i)*nz)
     waveb(5,3)  = beta(5)*(enth(i) + vn*a(i))
     sb(3) = vn + a(i)
     
     bmasdq(:,i) = 0.d0
     bpasdq(:,i) = 0.d0
     DO mws = 1,mwaves
        IF (sb(mws) < 0.d0)THEN
           waveb(:,mws) = waveb(:,mws)*areaRatioMinus
           bmasdq(:,i) = bmasdq(:,i) + sb(mws)*waveb(:,mws)
        ELSE
           waveb(:,mws) = waveb(:,mws)*areaRatioPlus
           bpasdq(:,i) = bpasdq(:,i) + sb(mws)*waveb(:,mws)
        END IF
     END DO
  END DO

END SUBROUTINE rpt3

!
!  :::::::::::::: BOUND :::::::::::::::::::::::::::::::::::::::::::
!     This routine sets the boundary values for a given grid 
!     at level level.
!     We are setting the values for a strip ng zones wide on
!     both borders.
!
!     Outputs from this routine:
!     The values around the border of the grid are inserted
!     directly into the enlarged valbig array.
!
!     This routine calls the routine filpatch
!     which for any block of mesh points on a given level,
!     intersects that block with all grids on that level and with
!     the physical boundaries, copies the values into the
!     appropriate intersecting regions, and interpolates the remaining
!     cells from coarser grids as required.
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine bound(time,nvar,ng,valbig,mitot,mptr,aux,naux)

  use amr_module, only: rnode, node, hxposs, cornxlo, cornxhi
  use amr_module, only: ndilo, ndihi
  use amr_module, only: nestlevel, xlower, xupper
  use amr_module, only: xperdom

  implicit none

  ! Input
  integer, intent(in) :: nvar, ng, mitot, mptr, naux
  real(kind=8), intent(in) :: time
  real(kind=8), intent(in out) :: valbig(nvar,mitot)
  real(kind=8), intent(in out) :: aux(naux,mitot)

  ! Locals
  integer :: ilo, ihi, level
  real(kind=8) :: xleft, xright, hx, xl, xr
  real(kind=8) :: xloWithGhost,  xhiWithGhost
  logical      :: patchOnly

  xleft  = rnode(cornxlo, mptr)
  xright = rnode(cornxhi, mptr)
  ilo    = node(ndilo, mptr)
  ihi    = node(ndihi, mptr)
  level  = node(nestlevel, mptr)
  hx     = hxposs(level)

  xloWithGhost = xleft  - ng*hx
  xhiWithGhost = xright + ng*hx
  ! used in filaptch for bc1amr: for patches it is called. for full grids called from bound below
  patchOnly = .false.

  ! left boundary
  xl = xleft - ng*hx
  xr = xleft
  if ((xl < xlower) .and. xperdom) then
     call  prefilrecur(level,nvar,valbig,aux,naux,time,mitot,1, &
          ilo-ng,ilo-1,ilo-ng,ihi+ng,patchOnly)
  else
     call filrecur(level,nvar,valbig,aux,naux,time,mitot,1,ilo-ng, &
          ilo-1,patchOnly,mptr)
  endif

  ! right boundary
  xl = xright
  xr = xright + ng*hx

  if ((xr .gt. xupper) .and. xperdom) then
     call  prefilrecur(level,nvar,valbig,aux,naux,time,mitot, &
          mitot-ng+1,ihi+1,ihi+ng,ilo-ng,ihi+ng,patchOnly)
  else
     call filrecur(level,nvar,valbig,aux,naux,time,mitot, &
          mitot-ng+1,ihi+1,ihi+ng,patchOnly,mptr)
  endif


  ! set all exterior (physical)  boundary conditions for this grid at once
  ! used to be done from filpatch, but now only for recursive calls with new patch
  ! where the info matches. more efficient to do whole grid at once, and avoid copying
  call bc1amr(valbig,aux,mitot,nvar,naux,hx,level,time,    &
              xloWithGhost,xhiWithGHost)

end subroutine bound

! :::::::::::::::::::::::::::: FILPATCH :::::::::::::::::::::::::;
!
!  fill the portion of valbig from rows  nrowst
!                             and  cols  ncolst
!  the patch can also be described by the corners (xlp,ybp) by (xrp,ytp).
!  vals are needed at time t, and level level,
!
!  first fill with  values obtainable from the level level
!  grids. if any left unfilled, then enlarge remaining rectangle of
!  unfilled values by 1 (for later linear interp), and recusively
!  obtain the remaining values from  coarser levels.
!
! :::::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::;
!
recursive subroutine filrecur(level,nvar,valbig,aux,naux,t,mx,my, &
                              nrowst,ncolst,ilo,ihi,jlo,jhi)

    use amr_module, only: hxposs, hyposs, xlower, ylower, xupper, yupper
    use amr_module, only: outunit, nghost, xperdom, yperdom, spheredom
    use amr_module, only: iregsz, jregsz, intratx, intraty, NEEDS_TO_BE_SET
    
    !for setaux timing
    use amr_module, only: timeSetaux, timeSetauxCPU

    implicit none

    ! Input
    integer, intent(in) :: level, nvar, naux, mx, my, nrowst, ncolst
    integer, intent(in) :: ilo,ihi,jlo,jhi
!   integer, intent(in) :: fill_indices(4)
    real(kind=8), intent(in) :: t

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mx,my)
    real(kind=8), intent(in out) :: aux(naux,mx,my)

    ! Local storage
    integer :: i_fine, j_fine, i_coarse, j_coarse, n, k
    integer  :: iplo, iphi, jplo, jphi
    integer :: mx_patch, my_patch, mx_coarse, my_coarse, nghost_patch, lencrse
    integer :: refinement_ratio_x, refinement_ratio_y
    integer :: unset_indices(4)
    real(kind=8) :: dx_fine, dy_fine, dx_coarse, dy_coarse
    real(kind=8) :: xlow_coarse,ylow_coarse, xlow_fine, ylow_fine, xhi_fine,yhi_fine 
    
    !for setaux timing
    integer :: clock_start, clock_finish, clock_rate
    real(kind=8) :: cpu_start, cpu_finish  

    ! Interpolation variables
    real(kind=8) :: eta1, eta2, valp10, valm10, valc, valp01, valm01, dupc, dumc
    real(kind=8) :: ducc, du, fu, dvpc, dvmc, dvcc, dv, fv, valint

    ! Cell set tracking
    logical :: set
    integer(kind=1) :: flaguse(ihi-ilo+1, jhi-jlo+1)

    ! Scratch storage
    !  use stack-based scratch arrays instead of alloc, since dont really
    !  need to save beyond these routines, and to allow dynamic memory resizing
    !
    !     use 1d scratch arrays that are potentially the same size as 
    !     current grid, since may not coarsen.
    !     need to make it 1d instead of 2 and do own indexing, since
    !     when pass it in to subroutines they treat it as having dierent
    !     dimensions than the max size need to allocate here
    
    !--      dimension valcrse((ihi-ilo+2)*(jhi-jlo+2)*nvar)  ! NB this is a 1D
    !array 
    !--      dimension auxcrse((ihi-ilo+2)*(jhi-jlo+2)*naux)  ! the +2 is to
    !expand on coarse grid to enclose fine
    ! ### turns out you need 3 rows, forget offset of 1 plus one on each side
    ! the +3 is to expand on coarse grid to enclose fine
!!$    real(kind=8) :: valcrse((fill_indices(2) - fill_indices(1) + 3) &
!!$                          * (fill_indices(4) - fill_indices(3) + 3) *nvar)
!!$    real(kind=8) :: auxcrse((fill_indices(2) - fill_indices(1) + 3) &
!!$                          * (fill_indices(4) - fill_indices(3) + 3) *naux)
    real(kind=8) :: valcrse((ihi-ilo+3) * (jhi-jlo+3) * nvar)  
    real(kind=8) :: auxcrse((ihi-ilo+3) * (jhi-jlo+3) * naux)  
    ! We begin by filling values for grids at level level. If all values can be
    ! filled in this way, we return;
!!$    mx_patch = fill_indices(2) - fill_indices(1) + 1 ! nrowp
!!$    my_patch = fill_indices(4) - fill_indices(3) + 1 ! ncolp
    mx_patch = ihi-ilo + 1 ! nrowp
    my_patch = jhi-jlo + 1 

    dx_fine     = hxposs(level)
    dy_fine     = hyposs(level)

    ! Coordinates of edges of patch (xlp,xrp,ybp,ytp)
!!$    fill_rect = [xlower + fill_indices(1) * dx_fine, &
!!$                 xlower + (fill_indices(2) + 1) * dx_fine, &
!!$                 ylower + fill_indices(3) * dy_fine, &
!!$                 ylower + (fill_indices(4) + 1) * dy_fine]
    xlow_fine = xlower + ilo * dx_fine
    ylow_fine = ylower + jlo * dy_fine

    ! Fill in the patch as much as possible using values at this level
!!$     call intfil(valbig,mx,my,t,flaguse,nrowst,ncolst,fill_indices(1), &
!!$
!fill_indices(2),fill_indices(3),fill_indices(4),level,nvar,naux)
    call intfil(valbig,mx,my,t,flaguse,nrowst,ncolst, ilo,  &
                ihi,jlo,jhi,level,nvar,naux)


    ! Trimbd returns set = true if all of the entries are filled (=1.).
    ! set = false, otherwise. If set = true, then no other levels are
    ! are required to interpolate, and we return.
    !
    ! Note that the used array is filled entirely in intfil, i.e. the
    ! marking done there also takes  into account the points filled by
    ! the boundary conditions. bc2amr will be called later, after all 4
    ! boundary pieces filled.
    call trimbd(flaguse,mx_patch,my_patch,set,unset_indices) ! il,ir,jb,jt = unset_indices(4)

    ! If set is .true. then all cells have been set and we can skip to setting
    ! the remaining boundary cells.  If it is .false. we need to interpolate
    ! some values from coarser levels, possibly calling this routine
    ! recursively.
    if (.not.set) then

        ! Error check 
        if (level == 1) then
            write(outunit,*)" error in filrecur - level 1 not set"
            write(outunit,'("start at row: ",i4," col ",i4)') nrowst,ncolst
            print *," error in filrecur - level 1 not set"
            print *," should not need more recursion "
            print *," to set patch boundaries"
            print '("start at row: ",i4," col ",i4)', nrowst,ncolst
            stop
        endif

        ! We begin by initializing the level level arrays, so that we can use
        ! purely recursive formulation for interpolating.
        dx_coarse  = hxposs(level - 1)
        dy_coarse  = hyposs(level - 1)

        ! Adjust unset_indices to account for the patch
        ! isl, isr, jsb, jst
        unset_indices(1) = unset_indices(1) + ilo - 1
        unset_indices(2) = unset_indices(2) + ilo - 1
        unset_indices(3) = unset_indices(3) + jlo - 1
        unset_indices(4) = unset_indices(4) + jlo - 1

        ! Coarsened geometry
        refinement_ratio_x = intratx(level - 1)
        refinement_ratio_y = intraty(level - 1)

        ! New patch rectangle (after we have partially filled it in) but in the
        ! coarse patches [iplo,iphi,jplo,jphi]

        iplo = (unset_indices(1) - refinement_ratio_x + nghost * refinement_ratio_x) &
                                                 / refinement_ratio_x - nghost
        iphi = (unset_indices(2) + refinement_ratio_x) / refinement_ratio_x
        jplo = (unset_indices(3) - refinement_ratio_y + nghost * refinement_ratio_y) &
                                                / refinement_ratio_y - nghost
        jphi = (unset_indices(4) + refinement_ratio_y) / refinement_ratio_y

        xlow_coarse = xlower + iplo * dx_coarse
        ylow_coarse = ylower + jplo * dy_coarse

        ! Coarse grid number of spatial points (nrowc,ncolc)
        mx_coarse   =  iphi - iplo + 1
        my_coarse   =  jphi - jplo + 1

        ! Check to make sure we created big enough scratch arrays
        if (mx_coarse > ihi - ilo + 3 .or. &
            my_coarse > jhi - jlo + 3) then

            print *," did not make big enough work space in filrecur "
            print *," need coarse space with mx_coarse,my_coarse ",mx_coarse,my_coarse
            print *," made space for ilo,ihi,jlo,jhi ",ilo,ihi,jlo,jhi
            stop
        endif

        ! Set the aux array values for the coarse grid, this could be done 
        ! instead in intfil using possibly already available bathy data from the
        ! grids
        if (naux > 0) then
            nghost_patch = 0
            lencrse = (ihi-ilo+3)*(jhi-jlo+3)*naux ! set 1 component, not all naux
            do k = 1, lencrse, naux
              auxcrse(k) = NEEDS_TO_BE_SET ! new system checks initialization before setting aux vals
            end do
            call system_clock(clock_start, clock_rate)
            call cpu_time(cpu_start)
            call setaux(nghost_patch, mx_coarse,my_coarse,  &
                       xlow_coarse, ylow_coarse,            &
                        dx_coarse,dy_coarse,naux,auxcrse)
            call system_clock(clock_finish, clock_rate)
            call cpu_time(cpu_finish)
            timeSetaux = timeSetaux + clock_finish - clock_start
            timeSetauxCPU = timeSetaux + cpu_finish - cpu_start
        endif

        ! Fill in the edges of the coarse grid
        if ((xperdom .or. (yperdom .or. spheredom)) .and.  sticksout(iplo,iphi,jplo,jphi)) then
            call prefilrecur(level-1,nvar,valcrse,auxcrse,naux,t,mx_coarse,my_coarse,1,1,iplo,iphi,jplo,jphi)
        else
            call filrecur(level-1,nvar,valcrse,auxcrse,naux,t,mx_coarse,my_coarse,1,1,iplo,iphi,jplo,jphi)
        endif

        do i_fine = 1,mx_patch
            i_coarse = 2 + (i_fine - (unset_indices(1) - ilo) - 1) / refinement_ratio_x
            eta1 = (-0.5d0 + real(mod(i_fine - 1, refinement_ratio_x),kind=8)) &
                                / real(refinement_ratio_x,kind=8)

            do j_fine  = 1,my_patch
                j_coarse = 2 + (j_fine - (unset_indices(3) - jlo) - 1) / refinement_ratio_y
                eta2 = (-0.5d0 + real(mod(j_fine - 1, refinement_ratio_y),kind=8)) &
                                    / real(refinement_ratio_y,kind=8)

                if (flaguse(i_fine,j_fine) == 0) then

                    do n=1,nvar

                        valp10 = valcrse(coarse_index(n,i_coarse + 1,j_coarse))
                        valm10 = valcrse(coarse_index(n,i_coarse - 1,j_coarse))
                        valc   = valcrse(coarse_index(n,i_coarse    ,j_coarse))
                        valp01 = valcrse(coarse_index(n,i_coarse    ,j_coarse + 1))
                        valm01 = valcrse(coarse_index(n,i_coarse    ,j_coarse - 1))
        
                        dupc = valp10 - valc
                        dumc = valc   - valm10
                        ducc = valp10 - valm10
                        du   = min(abs(dupc), abs(dumc))
                        du   = min(2.d0 * du, 0.5d0 * abs(ducc))
                        fu = max(0.d0, sign(1.d0, dupc * dumc))
        
                        dvpc = valp01 - valc
                        dvmc = valc   - valm01
                        dvcc = valp01 - valm01
                        dv   = min(abs(dvpc), abs(dvmc))
                        dv   = min(2.d0 * dv, 0.5d0 * abs(dvcc))
                        fv = max(0.d0,sign(1.d0, dvpc * dvmc))

                        valint = valc + eta1 * du * sign(1.d0, ducc) * fu &
                                      + eta2 * dv * sign(1.d0, dvcc) * fv


                        valbig(n,i_fine+nrowst-1,j_fine+ncolst-1) = valint

                    end do

                endif
            end do
        end do
    end if

    !  set bcs, whether or not recursive calls needed. set any part of patch
    !  that stuck out
    xhi_fine = xlower + (ihi + 1) * dx_fine
    yhi_fine = ylower + (jhi + 1) * dy_fine
    call bc2amr(valbig,aux,mx,my,nvar,naux,dx_fine,dy_fine,level,t,xlow_fine,xhi_fine, &
                ylow_fine,yhi_fine,xlower,ylower,xupper,yupper,xperdom,yperdom,spheredom)

contains

    integer pure function coarse_index(n,i,j)
        implicit none
        integer, intent(in) :: n, i, j
        coarse_index = n + nvar*(i-1)+nvar*mx_coarse*(j-1)
    end function coarse_index

    logical pure function sticksout(iplo,iphi,jplo,jphi)
        implicit none
        integer, intent(in) :: iplo,iphi,jplo,jphi
        sticksout = (iplo < 0 .or. jplo < 0 .or. &
                     iphi >= iregsz(level - 1) .or. jphi >= jregsz(level - 1))
    end function sticksout

end subroutine filrecur

subroutine src1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)

    ! Called to update q by solving source term equation 
    ! $q_t = \psi(q)$ over time dt starting at time t.
    !
    ! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: mbc,mx,meqn,maux
    real(kind=8), intent(in) :: xlower,dx,t,dt
    real(kind=8), intent(in) ::  aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) ::  q(meqn,1-mbc:mx+mbc)

end subroutine src1

subroutine setprob

    ! for problem specific features, copy to your directory and modify

    use grid_module, only: runup_tolerance
    implicit none
    
    runup_tolerance = 1.d-4   ! for wave tank, since dry_tolerance = 1d-6

end subroutine setprob

!     =====================================================
    double precision function philim(a,b,meth)
!     =====================================================
    implicit double precision (a-h,o-z)

!     # Compute a limiter based on wave strengths a and b.
!     # meth determines what limiter is used.
!     # a is assumed to be nonzero.

!     # NOTE: This routine is obsolete.  Instead of using limiter.f,
!     # which calls philim.f for every wave, it is more efficient to
!     # use inlinelimiter.f, which eliminates all these function calls
!     # to philim.  If you wish to change the limiter function and are
!     # using inlinelimiter.f, the formulas must be changed in that routine.

    r = b/a
    go to (10,20,30,40,50) meth


    10 continue
!     --------
!     # minmod
!     --------
    philim = dmax1(0.d0, dmin1(1.d0, r))
    return

    20 continue
!     ----------
!     # superbee
!     ----------
    philim = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))
    return

    30 continue
!     ----------
!     # van Leer
!     ----------
    philim = (r + dabs(r)) / (1.d0 + dabs(r))
    return

    40 continue
!     ------------------------------
!     # monotinized centered
!     ------------------------------
    c = (1.d0 + r)/2.d0
    philim = dmax1(0.d0, dmin1(c, 2.d0, 2.d0*r))
    return

    50 continue
!     ------------------------------
!     # Beam-Warming
!     ------------------------------
    philim = r

    return
end function philim

! ============================================================================
!      Copyright (C) 2010-10-12 Kyle Mandli <kyle.mandli@gmail.com>
!
!  Distributed under the terms of the Berkeley Software Distribution (BSD) 
!  license
!                     http://www.opensource.org/licenses/
! ============================================================================

module multilayer_module

    implicit none

    logical, private :: module_setup = .false.

    ! Storage parameters
    integer :: aux_layer_index
    
    ! Physical parameters
    integer :: num_layers
    real(kind=8), allocatable :: eta_init(:)
    real(kind=8) :: r, one_minus_r
    
    ! Algorithm parameters
    integer :: eigen_method,inundation_method
    logical :: check_richardson
    real(kind=8) :: richardson_tolerance
    real(kind=8), allocatable :: wave_tolerance(:), dry_tolerance(:)
    
    ! Output files
    integer, parameter :: KAPPA_UNIT = 42

    ! Eigenspace evaluation functions
    abstract interface
        subroutine eigen_function(h_l, h_r, u_l, u_r, v_l, v_r,                &
                                            n_index, t_index, s, eig_vec)
            implicit none
            real(kind=8), dimension(2), intent(in) :: h_l,h_r,u_l,u_r,v_l,v_r
            integer, intent(in) :: n_index,t_index
            real(kind=8), intent(inout) :: s(6),eig_vec(6,6)
        end subroutine eigen_function
    end interface

    procedure (eigen_function), pointer :: eigen_func
    procedure (eigen_function), pointer :: inundation_eigen_func
    
contains

    ! ========================================================================
    !  set_multilayer(file_name)
    ! ========================================================================
    subroutine set_multilayer(data_file)

        use geoclaw_module, only: GEO_PARM_UNIT, rho
        use geoclaw_module, only: geo_dry_tolerance => dry_tolerance
        use storm_module, only: storm_specification_type

        implicit none
        character(len=*), optional, intent(in) :: data_file
        
        integer :: ios
        integer, parameter :: IOUNIT = 41
            

        if (.not.module_setup) then
            ! Open file
            if (present(data_file)) then
                call opendatafile(IOUNIT, data_file)
            else
                call opendatafile(IOUNIT, 'multilayer.data')
            endif
            
            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'Multilayer Parameters:'
            write(GEO_PARM_UNIT,*) '----------------------'

            ! Read in parameters
            read(IOUNIT,"(i3)") num_layers
            allocate(eta_init(num_layers))
            allocate(wave_tolerance(num_layers))
            allocate(dry_tolerance(num_layers))

            ! read(IOUNIT,*) rho
            ! The densities are in the geoclaw_module, check here to make surge
            ! there are enough values
            if (size(rho, 1) /= num_layers) then
                print *, "The number of values of the water density " //       &
                          "(", size(rho, 1),") does not match the number " //  &
                          "of layers (", num_layers,")."
                stop
            end if
            if (num_layers > 1) then
                r = rho(1) / rho(2)
                one_minus_r = 1.d0 - r
            else
                r = -1.d0
                one_minus_r = 0.d0
            endif
            read(IOUNIT, *) eta_init
            read(IOUNIT, *) wave_tolerance
            read(IOUNIT, *) aux_layer_index
            read(IOUNIT, *)

            ! Algorithmic parameters
            read(IOUNIT, *) check_richardson
            read(IOUNIT, "(d16.8)") richardson_tolerance
            read(IOUNIT, "(i1)") eigen_method
            read(IOUNIT, "(i1)") inundation_method
            
            close(IOUNIT) 

            ! Currently just set dry_tolerance(:) = dry_tolerance
            dry_tolerance = geo_dry_tolerance

            ! Set eigen functions
            select case(eigen_method)
                case(1:2)
                    eigen_func => linearized_eigen
                case(3)
                    eigen_func => vel_diff_eigen
                case(4)
                    eigen_func => lapack_eigen
                case default
                    print *, "Invalid eigenspace method requested: ", eigen_method
                    stop
            end select
            select case(inundation_method)
                case(1:2)
                    inundation_eigen_func => linearized_eigen
                case(3)
                    inundation_eigen_func => vel_diff_eigen
                case(4:5)
                    inundation_eigen_func => lapack_eigen
                case default
                    print *, "Invalid eigenspace method requested: ", eigen_method
                    stop
            end select

            ! Open Kappa output file if num_layers > 1
            ! Open file for writing hyperbolicity warnings if multiple layers
            if (num_layers > 1 .and. check_richardson) then
                open(unit=KAPPA_UNIT, file='fort.kappa', iostat=ios, &
                        status="unknown", action="write")
                if ( ios /= 0 ) stop "Error opening file name fort.kappa"
            endif

            write(GEO_PARM_UNIT,*) '   check_richardson:',check_richardson
            write(GEO_PARM_UNIT,*) '   richardson_tolerance:',richardson_tolerance
            write(GEO_PARM_UNIT,*) '   eigen_method:',eigen_method
            write(GEO_PARM_UNIT,*) '   inundation_method:',inundation_method
            write(GEO_PARM_UNIT,*) '   dry_tolerance:',dry_tolerance

            module_setup = .true.
        end if
        
    end subroutine set_multilayer

    ! ==========================================================================
    !  Eigenspace Evaluation Functions, see interface defined above
    ! ==========================================================================
    subroutine linearized_eigen(h_l,h_r,u_l,u_r,v_l,v_r,n_index,t_index,s,eig_vec)

        use geoclaw_module, only: grav

        implicit none
        
        ! Input
        double precision, dimension(2), intent(in) :: h_l,h_r,u_l,u_r,v_l,v_r
        integer, intent(in) :: n_index,t_index
        
        ! Output
        double precision, intent(inout) :: s(6),eig_vec(6,6)
            
        ! Local
        double precision :: gamma_l,gamma_r,alpha(4),g
        
        g = grav
            
        ! Calculate relevant quantities
        gamma_l = h_l(2) / h_l(1)
        gamma_r = h_r(2) / h_r(1)

        alpha(1) = 0.5d0*(gamma_l-1.d0+sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
        alpha(2) = 0.5d0*(gamma_l-1.d0-sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
        alpha(3) = 0.5d0*(gamma_r-1.d0-sqrt((gamma_r-1.d0)**2+4.d0*r*gamma_r))
        alpha(4) = 0.5d0*(gamma_r-1.d0+sqrt((gamma_r-1.d0)**2+4.d0*r*gamma_r))

        s(1) = -sqrt(g*h_l(1)*(1+alpha(1)))
        s(2) = -sqrt(g*h_l(1)*(1+alpha(2)))
        s(3:4) = 0.5d0 * (u_l(:) + u_r(:))
        s(5) = sqrt(g*h_r(1)*(1+alpha(3)))
        s(6) = sqrt(g*h_r(1)*(1+alpha(4)))

        ! Compute eigenspace exactly based on eigenvalues provided
        eig_vec(1,:) = [1.d0,1.d0,0.d0,0.d0,1.d0,1.d0]
        
        eig_vec(n_index,:) = [s(1),s(2),0.d0,0.d0,s(5),s(6)]
        
        eig_vec(t_index,:) = [v_l(1),v_l(1),1.d0,0.d0,v_r(1),v_r(1)]

        eig_vec(4,1:2) = alpha(1:2)
        eig_vec(4,3:4) = 0.d0
        eig_vec(4,5:6) = alpha(3:4)
        
        eig_vec(n_index+3,:) = s * eig_vec(4,:)
        
        eig_vec(t_index+3,1:2) = v_l(2) * alpha(1:2)
        eig_vec(t_index+3,3:4) = [0.d0,1.d0]
        eig_vec(t_index+3,5:6) = v_r(2) * alpha(3:4)

    end subroutine linearized_eigen


    subroutine vel_diff_eigen(h_l,h_r,u_l,u_r,v_l,v_r,n_index,t_index,s,eig_vec)

        use geoclaw_module, only: grav

        implicit none
        
        ! Input
        double precision, dimension(2), intent(in) :: h_l,h_r,u_l,u_r,v_l,v_r
        integer, intent(in) :: n_index,t_index
        
        ! Output
        double precision, intent(inout) :: s(6),eig_vec(6,6)
            
        ! Local
        double precision :: total_depth_l,total_depth_r,mult_depth_l,mult_depth_r
        
        total_depth_l = sum(h_l)
        total_depth_r = sum(h_r)
        mult_depth_l = product(h_l)
        mult_depth_r = product(h_r)
                          
        s(1) = - sqrt(grav*total_depth_l) + 0.5d0 * mult_depth_l/ total_depth_l**(3.0/2) * one_minus_r
        s(2) = - sqrt(grav * mult_depth_l / total_depth_l * one_minus_r)
        s(3:4) = 0.5d0 * (u_l + u_r)
        s(5) = sqrt(grav * mult_depth_r / total_depth_r * one_minus_r)
        s(6) = sqrt(grav*total_depth_r) - 0.5d0 * mult_depth_r / total_depth_r**(3.0/2) * one_minus_r

        eig_vec(1,:) = [1.d0,1.d0,0.d0,0.d0,1.d0,1.d0]
        eig_vec(n_index,:) = [s(1),s(2),0.d0,0.d0,s(5),s(6)]
        eig_vec(t_index,:) = [v_l(1),v_l(1),1.d0,0.d0,v_r(1),v_r(1)]
        eig_vec(4,1:2) = ((s(1:2)-u_l(1))**2 - grav*h_l(1)) / (r*grav*h_l(1))
        eig_vec(4,3:4) = 0.d0
        eig_vec(4,5:6) = ((s(5:6)-u_r(1))**2 - grav*h_r(1)) / (r*grav*h_r(1))
        eig_vec(n_index+3,:) = s(:) * eig_vec(4,:)
        eig_vec(t_index+3,1:2) = v_l(2) * eig_vec(4,1:2)
        eig_vec(t_index+3,3:4) = [0.d0,1.d0]
        eig_vec(t_index+3,5:6) = v_r(2) * eig_vec(4,5:6)
        
    end subroutine vel_diff_eigen

#ifdef LAPACK_AVAIL
    subroutine lapack_eigen(h_l,h_r,u_l,u_r,v_l,v_r,n_index,t_index,s,eig_vec)

        use geoclaw_module, only: grav

        implicit none
        
        ! Input
        double precision, dimension(2), intent(in) :: h_l,h_r,u_l,u_r,v_l,v_r
        integer, intent(in) :: n_index,t_index
        
        ! Output
        double precision, intent(inout) :: s(6),eig_vec(6,6)
        
        ! Local
        integer, parameter :: lwork = 6*6
        integer :: i,j,m,info
        double precision :: h_ave(2),u_ave(2),v_ave(2),A(6,6),A_copy(6,6)
        double precision :: imag_evalues(6),empty,work(1,lwork)
        double precision :: g
        
        g = grav

        ! Construct flux matrix
        A = 0.d0
        h_ave(:) = 0.5d0 * (h_l(:) + h_r(:))
        u_ave(:) = 0.5d0 * (u_l(:) + u_r(:))
        v_ave(:) = 0.5d0 * (v_l(:) + v_r(:))
        ! We need to do this since one of the rows cannot be swapped
        if (n_index == 2) then
            A(t_index,1:3) = [-u_ave(1)*v_ave(1),v_ave(1),u_ave(1)]
            A(t_index+3,4:6) = [-u_ave(2)*v_ave(2),v_ave(2),u_ave(2)]
        else
            A(t_index,1:3) = [-u_ave(1)*v_ave(1),u_ave(1),v_ave(1)]
            A(t_index+3,4:6) = [-u_ave(2)*v_ave(2),u_ave(2),v_ave(2)]
        endif
            
        A(1,n_index) = 1.d0
        
        A(n_index,1) = -u_ave(1)**2 + g*h_ave(1)
        A(n_index,n_index) = 2*u_ave(1)
        A(n_index,4) = r*g*h_ave(1)
        
        A(4,n_index+3) = 1.d0
        
        A(n_index+3,1) = g*h_ave(2)
        A(n_index+3,4) = -u_ave(2)**2 + g*h_ave(2)
        A(n_index+3,n_index+3) = 2.d0 * u_ave(2)
        
        A_copy = A
        
        ! Call LAPACK
        call dgeev('N','V',6,A,6,s,imag_evalues,empty,1,eig_vec,6,work,lwork,info)
        if (info < 0) then
            info = -info
            print "(a,i1,a)","The ",info,"th argument had an illegal value."
            stop
        else if (info > 0) then
            print "(a)","The QR algorithm failed to compute all the"
            print "(a)","eigenvalues, and no eigenvectors have been"
            print "(a,i1,a)","computed; elements",i,"+1:4 of WR and WI"
            print "(a)","contain eigenvalues which have converged."
            stop
        endif
        do i=1,6
            if (eig_vec(1,i) /= 0.d0) then
                eig_vec(:,i) = eig_vec(:,i) / eig_vec(1,i)
            endif
            if (abs(imag_evalues(i)) > 0.d0) then
                print "(a,i1,a,d16.8)","Imaginary eigenvalue(",i,") > 0.0",imag_evalues(i)
                stop
            endif
        enddo

    end subroutine lapack_eigen
#else

    subroutine lapack_eigen(h_l,h_r,u_l,u_r,v_l,v_r,n_index,t_index,s,eig_vec)

        use geoclaw_module, only: grav

        implicit none
        
        ! Input
        double precision, dimension(2), intent(in) :: h_l,h_r,u_l,u_r,v_l,v_r
        integer, intent(in) :: n_index,t_index
        
        ! Output
        double precision, intent(inout) :: s(6),eig_vec(6,6)
  
        stop "LAPACK eigensolver was not available at build time."

    end subroutine lapack_eigen

#endif

    ! ==========================================================================
    !  Single layer eigensolver
    !   Note that this routine puts the result in the upper 3x3 matrix, the rest
    !   is left as zeros.
    ! ==========================================================================
    subroutine sl_eigen(h_l,h_r,u_l,u_r,v_l,v_r,n_index,t_index,s,eig_vec)

        use geoclaw_module, only: grav

        implicit none
        
        ! Input
        double precision, dimension(2), intent(in) :: h_l,h_r,u_l,u_r,v_l,v_r
        integer, intent(in) :: n_index,t_index
        
        ! Output
        double precision, intent(inout) :: s(6),eig_vec(6,6)

        s = 0.d0
        s(1) = u_l(1) - sqrt(grav*h_l(1))
        s(2) = 0.5d0 * (u_r(1) + u_l(1))
        s(3) = u_r(1) + sqrt(grav*h_r(1))
        
        eig_vec = 0.d0
        eig_vec(1,1:3) = [1.d0,0.d0,1.d0]
        eig_vec(n_index,1:3) = [s(1),0.d0,s(3)]
        eig_vec(t_index,1:3) = [v_l(1),1.d0,v_r(1)]
        
    end subroutine sl_eigen


end module multilayer_module

! ==========================================================
subroutine step2(maxm,num_eqn,num_waves,num_aux,num_ghost,mx,my, &
                 qold,qnew,aux,dx,dy,dt,method,mthlim,cfl, &
                 qadd,fadd,gadd,q1d,dtdx1d,dtdy1d, &
                 aux1,aux2,aux3,work,mwork,use_fwave,rpn2,rpt2)
! ==========================================================

! Take one time step, updating q.
! On entry, qold and qnew should be identical and give the
! initial data for this step
! On exit, qnew returns values at the end of the time step.
! qold is unchanged.

! qadd is used to return increments to q from flux2
! fadd and gadd are used to return flux increments from flux2.
! See the flux2 documentation for more information.


    implicit double precision (a-h,o-z)
    external :: rpn2,rpt2
    double precision :: qold(num_eqn,1-num_ghost:mx+num_ghost, &
                             1-num_ghost:my+num_ghost)
    double precision :: qnew(num_eqn,1-num_ghost:mx+num_ghost, &
                             1-num_ghost:my+num_ghost)
    double precision ::  q1d(num_eqn,1-num_ghost:maxm+num_ghost)
    double precision :: qadd(num_eqn,1-num_ghost:maxm+num_ghost)
    double precision :: fadd(num_eqn,1-num_ghost:maxm+num_ghost)
    double precision :: gadd(num_eqn, 2, 1-num_ghost:maxm+num_ghost)
    double precision :: aux(num_aux, 1-num_ghost:mx+num_ghost, &
                            1-num_ghost:my+num_ghost)
    double precision :: aux1(num_aux, 1-num_ghost:maxm+num_ghost)
    double precision :: aux2(num_aux, 1-num_ghost:maxm+num_ghost)
    double precision :: aux3(num_aux, 1-num_ghost:maxm+num_ghost)

    double precision :: dtdx1d(1-num_ghost:maxm+num_ghost)
    double precision :: dtdy1d(1-num_ghost:maxm+num_ghost)
    integer :: method(7),mthlim(num_waves)
    logical ::          use_fwave
    double precision :: work(mwork)

    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom

!f2py intent(out) cfl
!f2py intent(in,out) qnew
!f2py optional q1d, qadd, fadd, gadd, dtdx1d, dtdy1d

! Dummy interfaces just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn2(x)
!f2py x=rpt2(x)



    ! partition work array into pieces needed for local storage in
    ! flux2 routine.  Find starting index of each piece:

    i0wave = 1
    i0s = i0wave + (maxm+2*num_ghost)*num_eqn*num_waves
    i0amdq = i0s + (maxm+2*num_ghost)*num_waves
    i0apdq = i0amdq + (maxm+2*num_ghost)*num_eqn
    i0cqxx = i0apdq + (maxm+2*num_ghost)*num_eqn
    i0bmadq = i0cqxx + (maxm+2*num_ghost)*num_eqn
    i0bpadq = i0bmadq + (maxm+2*num_ghost)*num_eqn
    iused = i0bpadq + (maxm+2*num_ghost)*num_eqn - 1

    if (iused > mwork) then
        ! This shouldn't happen due to checks in claw2
        write(6,*) '*** not enough work space in step2'
        write(6,*) '*** iused = ', iused, '   mwork =',mwork
        stop
    endif


    index_capa = method(6)
    num_aux = method(7)
    cfl = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy

    if (index_capa == 0) then
        ! no capa array:
        do i=1-num_ghost,maxm+num_ghost
            dtdx1d(i) = dtdx
            dtdy1d(i) = dtdy
        end do
    endif


    ! perform x-sweeps
    ! ==================

    do j = 0,my+1
    
        ! copy data along a slice into 1d arrays:
        do m=1,num_eqn
            do i = 1-num_ghost, mx+num_ghost
                q1d(m,i) = qold(m,i,j)
            end do
        end do
    
        if (index_capa > 0)  then
            do i = 1-num_ghost, mx+num_ghost
                dtdx1d(i) = dtdx/aux(index_capa,i,j)
            end do
        endif
    
        if (num_aux > 0)  then
            do ma=1,num_aux
                do i = 1-num_ghost, mx+num_ghost
                    aux1(ma,i) = aux(ma,i,j-1)
                    aux2(ma,i) = aux(ma,i,j  )
                    aux3(ma,i) = aux(ma,i,j+1)
                end do
            end do
        endif
    
        ! Store the value of j along this slice in the common block
        ! comxyt in case it is needed in the Riemann solver (for
        ! variable coefficient problems)
        jcom = j
    
        ! compute modifications fadd and gadd to fluxes along this slice:
        call flux2(1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                   q1d,dtdx1d,aux1,aux2,aux3,method,mthlim, &
                   qadd,fadd,gadd,cfl1d, &
                   work(i0wave),work(i0s),work(i0amdq),work(i0apdq), &
                   work(i0cqxx),work(i0bmadq),work(i0bpadq),rpn2,rpt2, &
                   use_fwave)
        cfl = dmax1(cfl,cfl1d)
    
        ! update qnew by flux differencing.
        ! (rather than maintaining arrays f and g for the total fluxes,
        ! the modifications are used immediately to update qnew
        ! in order to save storage.)
    
        if (index_capa == 0) then
        
            ! no capa array.  Standard flux differencing:
            do m=1,num_eqn
                do i=1,mx
                    qnew(m,i,j) = qnew(m,i,j) + qadd(m,i) &
                        - dtdx * (fadd(m,i+1) - fadd(m,i)) &
                        - dtdy * (gadd(m,2,i) - gadd(m,1,i))
                    qnew(m,i,j-1) = qnew(m,i,j-1) - dtdy * gadd(m,1,i)
                    qnew(m,i,j+1) = qnew(m,i,j+1) + dtdy * gadd(m,2,i)
                end do
            end do
        
        else
        
            ! with capa array.
            do m=1,num_eqn
                do i=1,mx
                    qnew(m,i,j) = qnew(m,i,j) + qadd(m,i) &
                        - (dtdx * (fadd(m,i+1) - fadd(m,i)) &
                        +  dtdy * (gadd(m,2,i) - gadd(m,1,i))) &
                        / aux(index_capa,i,j)
                    qnew(m,i,j-1) = qnew(m,i,j-1) - dtdy * gadd(m,1,i) &
                        / aux(index_capa,i,j-1)
                    qnew(m,i,j+1) = qnew(m,i,j+1) + dtdy * gadd(m,2,i) &
                        / aux(index_capa,i,j+1)
                end do
            end do
        endif
    end do


    ! perform y sweeps
    ! ==================


    do i = 0, mx+1
    
        ! copy data along a slice into 1d arrays:
        do m=1,num_eqn
            do j = 1-num_ghost, my+num_ghost
                q1d(m,j) = qold(m,i,j)
            end do
        end do
    
        if (index_capa > 0)  then
            do j = 1-num_ghost, my+num_ghost
                dtdy1d(j) = dtdy / aux(index_capa,i,j)
            end do
        endif
    
        if (num_aux > 0)  then
            do ma=1,num_aux
                do j = 1-num_ghost, my+num_ghost
                    aux1(ma,j) = aux(ma,i-1,j)
                    aux2(ma,j) = aux(ma,i,  j)
                    aux3(ma,j) = aux(ma,i+1,j)
                end do
            end do
        endif
    
    
        ! Store the value of i along this slice in the common block
        ! comxyt in case it is needed in the Riemann solver (for
        ! variable coefficient problems)
        icom = i
    
        ! compute modifications fadd and gadd to fluxes along this slice:
        call flux2(2,maxm,num_eqn,num_waves,num_aux,num_ghost,my, &
                   q1d,dtdy1d,aux1,aux2,aux3,method,mthlim, &
                   qadd,fadd,gadd,cfl1d, &
                   work(i0wave),work(i0s),work(i0amdq),work(i0apdq), &
                   work(i0cqxx),work(i0bmadq),work(i0bpadq),rpn2,rpt2, &
                   use_fwave)
    
        cfl = dmax1(cfl,cfl1d)
    
        ! update qnew by flux differencing.
        ! Note that the roles of fadd and gadd are reversed for
        ! the y-sweeps -- fadd is the modification to g-fluxes and
        ! gadd is the modification to f-fluxes to the left and right.
    
        if (index_capa == 0) then
        
            ! no capa array.  Standard flux differencing:
            do m=1,num_eqn
                do j=1,my
                    qnew(m,i,j) = qnew(m,i,j) + (qadd(m,j) &
                        - dtdy * (fadd(m,j+1) - fadd(m,j)) &
                        - dtdx * (gadd(m,2,j) - gadd(m,1,j)))
                    qnew(m,i-1,j) = qnew(m,i-1,j) - dtdx * gadd(m,1,j)
                    qnew(m,i+1,j) = qnew(m,i+1,j) + dtdx * gadd(m,2,j)
                end do
            end do
        
        else
        
            ! with capa array.
            do m=1,num_eqn
                do j=1,my
                    qnew(m,i,j) = qnew(m,i,j) + qadd(m,j) &
                        - (dtdy * (fadd(m,j+1) - fadd(m,j)) &
                        + dtdx * (gadd(m,2,j) - gadd(m,1,j))) &
                        / aux(index_capa,i,j)
                    qnew(m,i-1,j) = qnew(m,i-1,j) - dtdx * gadd(m,1,j) &
                        / aux(index_capa,i-1,j)
                    qnew(m,i+1,j) = qnew(m,i+1,j) + dtdx * gadd(m,2,j) &
                        / aux(index_capa,i+1,j)
                end do
            end do
        endif
    end do

    return
    end subroutine step2

!> Sort 2D points (stored in badpts) based on their equivalent 
!! integer value (based on their x,y coordinates). Also remove
!! duplicate points in badpts.
c
c -------------------------------------------------------------
c
       subroutine drivesort(npts,badpts,level,index,mbuff)

      use amr_module
      implicit  double precision (a-h,o-z)
      dimension badpts(2,npts)
      dimension iflags(npts), ixArray(npts)
      logical db/.false./
 
      iadd(i,j) = (i+mbuff)  + (isize+2*mbuff)*(j+mbuff)
c
c  convert using one dimensional ordering of badpts array as if
c  it covered entire domain (xprob by yprob) on this level
c
      isize = iregsz(level)
      jsize = jregsz(level)

      do k = 1, npts
        i = badpts(1,k)-.5  ! remember was shifted when put  into array
        j = badpts(2,k)-.5  
        intEquiv = iadd(i,j)
c        write(*,*)i,j," has equivalent integer ",intEquiv
        iflags(k) = intEquiv
      end do

      call qsorti(ixArray, npts, iflags)

c copy back to badpts, in sorted order, removing duplicates      
      k = 1
      index = 0
      do while (k .le. npts) 
         intEquiv = iflags(ixArray(k))
         index = index + 1
         badpts(2,index) = intEquiv/(isize+2*mbuff) + .5 -mbuff
         badpts(1,index) = mod(intEquiv,(isize+2*mbuff)) + .5 -mbuff
        if (db) write(outunit,101) badpts(1,index),badpts(2,index)
 101    format(2f6.1)
         k = k + 1
         do while ( k.le. npts)    ! skip over duplicates
            if (iflags(ixArray(k)) .eq. iflags(ixArray(k-1))) then
c           write(*,*)" duplicate in sorted array loc ",ixarray(k)
               k = k+1
            else
               exit   ! back to outer loop
            endif
         end do
       if (k .gt. npts) exit !did we stop because we ran off end or pts not equal
      end do

      if (gprint) then
          write(outunit,929) index
 929      format(i5," flagged pts after removing duplicates and ",
     &           " non-nested flags")
      endif

      return
      end

c
c -------------------------------------------------------------
c Modified from errest.f in amrclaw to pass aux arrays into errf1.f
c -------------------------------------------------------------
c
      subroutine errest (nvar,naux,lcheck,mptr,nx,ny)
c
      use amr_module, only: node,store1,store2,storeaux,alloc
      use amr_module, only: nghost,tempptr,storeflags,ibuff
      use adjoint_module, only : adjoint_flagging
      use adjointsup_module, only: errf1a
      implicit none

      integer, intent(in) :: nvar, naux, lcheck, mptr, nx, ny

c
c   ### changed to stack based storage 2/23/13
c   ### and broken into smaller routines to minimize 
c   ### stack space

      real(kind=8) :: valbgc(nvar,nx/2+2*nghost,ny/2+2*nghost)
      real(kind=8) :: auxbgc(naux,nx/2+2*nghost,ny/2+2*nghost)

c   # Other local variables
      integer :: locamrflags,locaux,locbig,locnew,locold
      integer :: mbuff,mi2tot,mibuff,midub,mitot
      integer :: mj2tot,mjbuff,mjdub,mjtot

c :::::::::::::::::::::::::: ERREST :::::::::::::::::::::::::::::::::::
c for this grid at level lcheck:
c  estimate the error by taking a large (2h,2k) step based on the
c  values in the old storage loc., then take one regular (and for
c  now wasted) step based on the new info.   compare using an
c  error relation for a pth order  accurate integration formula.
c  flag error plane as either bad (needs refinement), or good.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
       mitot  = nx + 2*nghost
       mjtot  = ny + 2*nghost
       locnew = node(store1,mptr)
       locold = node(store2,mptr)
       locaux = node(storeaux,mptr)
       mi2tot = nx/2  + 2*nghost
       mj2tot = ny/2  + 2*nghost
c
c     prepare double the stencil size worth of boundary values,
c            then coarsen them for the giant step integration.
       midub = nx+4*nghost
       mjdub = ny+4*nghost
c
       call prepbigstep(nvar,naux,lcheck,mptr,nx,ny,midub,
     .                    mjdub,valbgc,auxbgc,mi2tot,mj2tot)

c
c  the one giant step based on old values is done. now take
c  one regular step based on new values. 
c  boundary values already in locbig, (see subr. flagger)
c
      locbig = node(tempptr,mptr)
      locaux = node(storeaux,mptr)
      call prepregstep(nvar,naux,lcheck,mptr,nx,ny,mitot,mjtot,
     .                 alloc(locbig),alloc(locaux))
c
c     ## locamrflags allocated in flagger. may previously have been used 
c     ## by flag2refine so make sure not to overwrite
      locamrflags = node(storeflags, mptr)    
      mbuff = max(nghost,ibuff+1)  
      mibuff = nx + 2*mbuff 
      mjbuff = ny + 2*mbuff
      if (adjoint_flagging) then
          call errf1a(alloc(locbig),nvar,valbgc,mptr,mi2tot,mj2tot,
     1           mitot,mjtot,alloc(locamrflags),mibuff,mjbuff,
     1           alloc(locaux),naux,auxbgc)
      else
          call errf1(alloc(locbig),nvar,valbgc,mptr,mi2tot,mj2tot,
     1           mitot,mjtot,alloc(locamrflags),mibuff,mjbuff,
     1           alloc(locaux),naux,auxbgc)
      endif

c
      return
      end

subroutine rpn2(ixy, maxm, num_eqn, num_waves, num_aux, num_ghost, &
                num_cells, ql, qr, auxl, auxr, fwave, s, amdq, apdq)

! Normal Riemann solver for the 2D SHALLOW WATER equations
!     with topography:
!     #        h_t + (hu)_x + (hv)_y = 0                           #
!     #        (hu)_t + (hu^2 + 0.5gh^2)_x + (huv)_y = -ghb_x      #
!     #        (hv)_t + (huv)_x + (hv^2 + 0.5gh^2)_y = -ghb_y      #

! This solver is based on David George's solver written for GeoClaw.
! It has been modified to be compatible with f2py (and thus PyClaw).

! waves:     3
! equations: 3

! Conserved quantities:
!       1 depth
!       2 x_momentum
!       3 y_momentum

! Auxiliary fields:
!       1 bathymetry

! The gravitational constant grav should be in the common block cparam.

! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

      implicit none

      real(kind=8) :: grav, g
      real(kind=8), parameter :: drytol = 1.e-14
      common /cparam/ grav

      integer, intent(in) :: maxm,num_eqn,num_aux,num_waves,num_ghost,num_cells,ixy

      real(kind=8), intent(inout) ::  ql(num_eqn, 1-num_ghost:maxm+num_ghost)
      real(kind=8), intent(inout) ::  qr(num_eqn, 1-num_ghost:maxm+num_ghost)
      real(kind=8), intent(in) ::  auxl(num_aux,1-num_ghost:maxm+num_ghost)
      real(kind=8), intent(in) ::  auxr(num_aux,1-num_ghost:maxm+num_ghost)

      real(kind=8), intent(out) :: fwave(num_eqn, num_waves, 1-num_ghost:maxm+num_ghost)
      real(kind=8), intent(out) ::  s(num_waves, 1-num_ghost:maxm+num_ghost)
      real(kind=8), intent(out) ::  apdq(num_eqn,1-num_ghost:maxm+num_ghost)
      real(kind=8), intent(out) ::  amdq(num_eqn,1-num_ghost:maxm+num_ghost)

      !local only
      integer m,i,mw,maxiter,mu,nv
      real(kind=8) wall(3)
      real(kind=8) fw(3,3)
      real(kind=8) sw(3)

      real(kind=8) hR,hL,huR,huL,uR,uL,hvR,hvL,vR,vL,phiR,phiL
      real(kind=8) bR,bL,sL,sR,sRoe1,sRoe2,sE1,sE2,uhat,chat
      real(kind=8) s1m,s2m
      real(kind=8) hstar,hstartest,hstarHLL,sLtest,sRtest
      real(kind=8) tw,dxdc

      logical rare1,rare2

      g = grav

      !loop through Riemann problems at each grid cell
      do i=2-num_ghost,num_cells+num_ghost

      !-----------------------Initializing------------------------------
         !inform of a bad riemann problem from the start
         if((qr(1,i-1).lt.0.d0).or.(ql(1,i) .lt. 0.d0)) then
            write(*,*) 'Negative input: hl,hr,i=',qr(1,i-1),ql(1,i),i
         endif

         !Initialize Riemann problem for grid interface
         do mw=1,num_waves
              s(mw,i)=0.d0
                 fwave(1,mw,i)=0.d0
                 fwave(2,mw,i)=0.d0
                 fwave(3,mw,i)=0.d0
         enddo

!        !set normal direction
         if (ixy.eq.1) then
            mu=2
            nv=3
         else
            mu=3
            nv=2
         endif

         !zero (small) negative values if they exist
         if (qr(1,i-1).lt.0.d0) then
               qr(1,i-1)=0.d0
               qr(2,i-1)=0.d0
               qr(3,i-1)=0.d0
         endif

         if (ql(1,i).lt.0.d0) then
               ql(1,i)=0.d0
               ql(2,i)=0.d0
               ql(3,i)=0.d0
         endif

         !skip problem if in a completely dry area
         if (qr(1,i-1) <= drytol .and. ql(1,i) <= drytol) then
            go to 30
         endif

         !Riemann problem variables
         hL = qr(1,i-1) 
         hR = ql(1,i) 
         huL = qr(mu,i-1) 
         huR = ql(mu,i) 
         bL = auxr(1,i-1)
         bR = auxl(1,i)

         hvL=qr(nv,i-1) 
         hvR=ql(nv,i)

         !check for wet/dry boundary
         if (hR.gt.drytol) then
            uR=huR/hR
            vR=hvR/hR
            phiR = 0.5d0*g*hR**2 + huR**2/hR
         else
            hR = 0.d0
            huR = 0.d0
            hvR = 0.d0
            uR = 0.d0
            vR = 0.d0
            phiR = 0.d0
         endif

         if (hL.gt.drytol) then
            uL=huL/hL
            vL=hvL/hL
            phiL = 0.5d0*g*hL**2 + huL**2/hL
         else
            hL=0.d0
            huL=0.d0
            hvL=0.d0
            uL=0.d0
            vL=0.d0
            phiL = 0.d0
         endif

         wall(1) = 1.d0
         wall(2) = 1.d0
         wall(3) = 1.d0
         if (hR.le.drytol) then
            call riemanntype(hL,hL,uL,-uL,hstar,s1m,s2m,rare1,rare2,1,drytol,g)
            hstartest=max(hL,hstar)
            if (hstartest+bL.lt.bR) then !right state should become ghost values that mirror left for wall problem
!                bR=hstartest+bL
               wall(2)=0.d0
               wall(3)=0.d0
               hR=hL
               huR=-huL
               bR=bL
               phiR=phiL
               uR=-uL
               vR=vL
            elseif (hL+bL.lt.bR) then
               bR=hL+bL
            endif
         elseif (hL.le.drytol) then ! right surface is lower than left topo
            call riemanntype(hR,hR,-uR,uR,hstar,s1m,s2m,rare1,rare2,1,drytol,g)
            hstartest=max(hR,hstar)
            if (hstartest+bR.lt.bL) then  !left state should become ghost values that mirror right
!               bL=hstartest+bR
               wall(1)=0.d0
               wall(2)=0.d0
               hL=hR
               huL=-huR
               bL=bR
               phiL=phiR
               uL=-uR
               vL=vR
            elseif (hR+bR.lt.bL) then
               bL=hR+bR
            endif
         endif

         !determine wave speeds
         sL=uL-sqrt(g*hL) ! 1 wave speed of left state
         sR=uR+sqrt(g*hR) ! 2 wave speed of right state

         uhat=(sqrt(g*hL)*uL + sqrt(g*hR)*uR)/(sqrt(g*hR)+sqrt(g*hL)) ! Roe average
         chat=sqrt(g*0.5d0*(hR+hL)) ! Roe average
         sRoe1=uhat-chat ! Roe wave speed 1 wave
         sRoe2=uhat+chat ! Roe wave speed 2 wave

         sE1 = min(sL,sRoe1) ! Eindfeldt speed 1 wave
         sE2 = max(sR,sRoe2) ! Eindfeldt speed 2 wave

         !--------------------end initializing...finally----------
         !solve Riemann problem.

         maxiter = 1

         call riemann_aug_JCP(maxiter,3,3,hL,hR,huL, &
              huR,hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2, &
                                          drytol,g,sw,fw)

!        !eliminate ghost fluxes for wall
         do mw=1,3
            sw(mw)=sw(mw)*wall(mw)

               fw(1,mw)=fw(1,mw)*wall(mw) 
               fw(2,mw)=fw(2,mw)*wall(mw)
               fw(3,mw)=fw(3,mw)*wall(mw)
         enddo

         do mw=1,num_waves
            s(mw,i)=sw(mw)
            fwave(1,mw,i)=fw(1,mw)
            fwave(mu,mw,i)=fw(2,mw)
            fwave(nv,mw,i)=fw(3,mw)
         enddo

 30      continue
      enddo



!============= compute fluctuations=============================================
         amdq(1:3,:) = 0.d0
         apdq(1:3,:) = 0.d0
         do i=2-num_ghost,num_cells+num_ghost
            do  mw=1,num_waves
               if (s(mw,i) < 0.d0) then
                     amdq(1:3,i) = amdq(1:3,i) + fwave(1:3,mw,i)
               else if (s(mw,i) > 0.d0) then
                  apdq(1:3,i)  = apdq(1:3,i) + fwave(1:3,mw,i)
               else
                 amdq(1:3,i) = amdq(1:3,i) + 0.5d0 * fwave(1:3,mw,i)
                 apdq(1:3,i) = apdq(1:3,i) + 0.5d0 * fwave(1:3,mw,i)
               endif
            enddo
         enddo

      return
      end subroutine


!-----------------------------------------------------------------------
      subroutine riemann_aug_JCP(maxiter,num_eqn,num_waves,hL,hR,huL,huR, &
        hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2,drytol,g,sw,fw)

      ! solve shallow water equations given single left and right states
      ! This solver is described in J. Comput. Phys. (6): 3089-3113, March 2008
      ! Augmented Riemann Solvers for the Shallow Equations with Steady States and Inundation

      ! To use the original solver call with maxiter=1.

      ! This solver allows iteration when maxiter > 1. The iteration seems to help with
      ! instabilities that arise (with any solver) as flow becomes transcritical over variable topo
      ! due to loss of hyperbolicity.



      implicit none

      !input
      integer num_eqn,num_waves,maxiter
      real(kind=8) fw(num_eqn,num_waves)
      real(kind=8) sw(num_waves)
      real(kind=8) hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,sE1,sE2
      real(kind=8) hvL,hvR,vL,vR
      real(kind=8) drytol,g


      !local
      integer m,mw,k,iter
      real(kind=8) A(3,3)
      real(kind=8) r(3,3)
      real(kind=8) lambda(3)
      real(kind=8) del(3)
      real(kind=8) beta(3)

      real(kind=8) delh,delhu,delphi,delb,delnorm
      real(kind=8) rare1st,rare2st,sdelta,raremin,raremax
      real(kind=8) criticaltol,convergencetol,raretol
      real(kind=8) s1s2bar,s1s2tilde,hbar,hLstar,hRstar,hustar
      real(kind=8) huRstar,huLstar,uRstar,uLstar,hstarHLL
      real(kind=8) deldelh,deldelphi
      real(kind=8) s1m,s2m,hm
      real(kind=8) det1,det2,det3,determinant

      logical rare1,rare2,rarecorrector,rarecorrectortest,sonic

      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL
      delnorm = delh**2 + delphi**2

      call riemanntype(hL,hR,uL,uR,hm,s1m,s2m,rare1,rare2,1,drytol,g)


      lambda(1)= min(sE1,s2m) !Modified Einfeldt speed
      lambda(3)= max(sE2,s1m) !Modified Eindfeldt speed
      sE1=lambda(1)
      sE2=lambda(3)
      lambda(2) = 0.d0  ! ### Fix to avoid uninitialized value in loop on mw -- Correct?? ###

      
      hstarHLL = max((huL-huR+sE2*hR-sE1*hL)/(sE2-sE1),0.d0) ! middle state in an HLL solve

!     !determine the middle entropy corrector wave------------------------
      rarecorrectortest=.false.
      rarecorrector=.false.
      if (rarecorrectortest) then
         sdelta=lambda(3)-lambda(1)
         raremin = 0.5d0
         raremax = 0.9d0
         if (rare1.and.sE1*s1m.lt.0.d0) raremin=0.2d0
         if (rare2.and.sE2*s2m.lt.0.d0) raremin=0.2d0
         if (rare1.or.rare2) then
            !see which rarefaction is larger
            rare1st=3.d0*(sqrt(g*hL)-sqrt(g*hm))
            rare2st=3.d0*(sqrt(g*hR)-sqrt(g*hm))
            if (max(rare1st,rare2st).gt.raremin*sdelta.and. & 
               max(rare1st,rare2st).lt.raremax*sdelta) then
                  rarecorrector=.true.
               if (rare1st.gt.rare2st) then
                  lambda(2)=s1m
               elseif (rare2st.gt.rare1st) then
                  lambda(2)=s2m
               else
                  lambda(2)=0.5d0*(s1m+s2m)
               endif
            endif
         endif
         if (hstarHLL.lt.min(hL,hR)/5.d0) rarecorrector=.false.
      endif

!     ## Is this correct 2-wave when rarecorrector == .true. ??
      do mw=1,num_waves
         r(1,mw)=1.d0
         r(2,mw)=lambda(mw)
         r(3,mw)=(lambda(mw))**2
      enddo
      if (.not.rarecorrector) then
         lambda(2) = 0.5d0*(lambda(1)+lambda(3))
!         lambda(2) = max(min(0.5d0*(s1m+s2m),sE2),sE1)
         r(1,2)=0.d0
         r(2,2)=0.d0
         r(3,2)=1.d0
      endif
!     !---------------------------------------------------


!     !determine the steady state wave -------------------
      criticaltol = 1.d-6
      deldelh = -delb
      deldelphi = -g*0.5d0*(hR+hL)*delb

!     !determine a few quanitites needed for steady state wave if iterated
      hLstar=hL
      hRstar=hR
      uLstar=uL
      uRstar=uR
      huLstar=uLstar*hLstar
      huRstar=uRstar*hRstar

      !iterate to better determine the steady state wave
      convergencetol=1.d-6
      do iter=1,maxiter
         !determine steady state wave (this will be subtracted from the delta vectors)
         if (min(hLstar,hRstar).lt.drytol.and.rarecorrector) then
            rarecorrector=.false.
            hLstar=hL
            hRstar=hR
            uLstar=uL
            uRstar=uR
            huLstar=uLstar*hLstar
            huRstar=uRstar*hRstar
            lambda(2) = 0.5d0*(lambda(1)+lambda(3))
!           lambda(2) = max(min(0.5d0*(s1m+s2m),sE2),sE1)
            r(1,2)=0.d0
            r(2,2)=0.d0
            r(3,2)=1.d0
         endif

         hbar =  max(0.5d0*(hLstar+hRstar),0.d0)
         s1s2bar = 0.25d0*(uLstar+uRstar)**2 - g*hbar
         s1s2tilde= max(0.d0,uLstar*uRstar) - g*hbar

!        !find if sonic problem
         sonic=.false.
         if (abs(s1s2bar).le.criticaltol) sonic=.true.
         if (s1s2bar*s1s2tilde.le.criticaltol) sonic=.true.
         if (s1s2bar*sE1*sE2.le.criticaltol) sonic = .true.
         if (min(abs(sE1),abs(sE2)).lt.criticaltol) sonic=.true.
         if (sE1.lt.0.d0.and.s1m.gt.0.d0) sonic = .true.
         if (sE2.gt.0.d0.and.s2m.lt.0.d0) sonic = .true.
         if ((uL+sqrt(g*hL))*(uR+sqrt(g*hR)).lt.0.d0) sonic=.true.
         if ((uL-sqrt(g*hL))*(uR-sqrt(g*hR)).lt.0.d0) sonic=.true.

!        !find jump in h, deldelh
         if (sonic) then
            deldelh =  -delb
         else
            deldelh = delb*g*hbar/s1s2bar
         endif
!        !find bounds in case of critical state resonance, or negative states
         if (sE1.lt.-criticaltol.and.sE2.gt.criticaltol) then
            deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE2)
            deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE1)
         elseif (sE1.ge.criticaltol) then
            deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE1)
            deldelh = max(deldelh,-hL)
         elseif (sE2.le.-criticaltol) then
            deldelh = min(deldelh,hR)
            deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE2)
         endif

!        !find jump in phi, deldelphi
         if (sonic) then
            deldelphi = -g*hbar*delb
         else
            deldelphi = -delb*g*hbar*s1s2tilde/s1s2bar
         endif
!        !find bounds in case of critical state resonance, or negative states
         deldelphi=min(deldelphi,g*max(-hLstar*delb,-hRstar*delb))
         deldelphi=max(deldelphi,g*min(-hLstar*delb,-hRstar*delb))

         del(1)=delh-deldelh
         del(2)=delhu
         del(3)=delphi-deldelphi

!        !Determine determinant of eigenvector matrix========
         det1=r(1,1)*(r(2,2)*r(3,3)-r(2,3)*r(3,2))
         det2=r(1,2)*(r(2,1)*r(3,3)-r(2,3)*r(3,1))
         det3=r(1,3)*(r(2,1)*r(3,2)-r(2,2)*r(3,1))
         determinant=det1-det2+det3

!        !solve for beta(k) using Cramers Rule=================
         do k=1,3
            do mw=1,3
                  A(1,mw)=r(1,mw)
                  A(2,mw)=r(2,mw)
                  A(3,mw)=r(3,mw)
            enddo
            A(1,k)=del(1)
            A(2,k)=del(2)
            A(3,k)=del(3)
            det1=A(1,1)*(A(2,2)*A(3,3)-A(2,3)*A(3,2))
            det2=A(1,2)*(A(2,1)*A(3,3)-A(2,3)*A(3,1))
            det3=A(1,3)*(A(2,1)*A(3,2)-A(2,2)*A(3,1))
            beta(k)=(det1-det2+det3)/determinant
         enddo

         !exit if things aren't changing
         if (abs(del(1)**2+del(3)**2-delnorm).lt.convergencetol) exit
         delnorm = del(1)**2+del(3)**2
         !find new states qLstar and qRstar on either side of interface
         hLstar=hL
         hRstar=hR
         uLstar=uL
         uRstar=uR
         huLstar=uLstar*hLstar
         huRstar=uRstar*hRstar
         do mw=1,num_waves
            if (lambda(mw).lt.0.d0) then
               hLstar= hLstar + beta(mw)*r(1,mw)
               huLstar= huLstar + beta(mw)*r(2,mw)
            endif
         enddo
         do mw=num_waves,1,-1
            if (lambda(mw).gt.0.d0) then
               hRstar= hRstar - beta(mw)*r(1,mw)
               huRstar= huRstar - beta(mw)*r(2,mw)
            endif
         enddo

         if (hLstar.gt.drytol) then
            uLstar=huLstar/hLstar
         else
            hLstar=max(hLstar,0.d0)
            uLstar=0.d0
         endif
         if (hRstar.gt.drytol) then
            uRstar=huRstar/hRstar
         else
            hRstar=max(hRstar,0.d0)
            uRstar=0.d0
         endif

      enddo ! end iteration on Riemann problem

      do mw=1,num_waves
         sw(mw)=lambda(mw)
         fw(1,mw)=beta(mw)*r(2,mw)
         fw(2,mw)=beta(mw)*r(3,mw)
         fw(3,mw)=beta(mw)*r(2,mw)
      enddo
      !find transverse components (ie huv jumps).
      fw(3,1)=fw(3,1)*vL
      fw(3,3)=fw(3,3)*vR
      fw(3,2)= hR*uR*vR - hL*uL*vL - fw(3,1)- fw(3,3)

      return

      end !subroutine riemann_aug_JCP-------------------------------------------------


!-----------------------------------------------------------------------
      subroutine riemann_ssqfwave(maxiter,num_eqn,num_waves,hL,hR,huL,huR, &
          hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2,drytol,g,sw,fw)

      ! solve shallow water equations given single left and right states
      ! steady state wave is subtracted from delta [q,f]^T before decomposition

      implicit none

      !input
      integer num_eqn,num_waves,maxiter

      real(kind=8) hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,sE1,sE2
      real(kind=8) vL,vR,hvL,hvR
      real(kind=8) drytol,g

      !local
      integer iter

      logical sonic

      real(kind=8) delh,delhu,delphi,delb,delhdecomp,delphidecomp
      real(kind=8) s1s2bar,s1s2tilde,hbar,hLstar,hRstar,hustar
      real(kind=8) uRstar,uLstar,hstarHLL
      real(kind=8) deldelh,deldelphi
      real(kind=8) alpha1,alpha2,beta1,beta2,delalpha1,delalpha2
      real(kind=8) criticaltol,convergencetol
      real(kind=8) sL,sR
      real(kind=8) uhat,chat,sRoe1,sRoe2

      real(kind=8) sw(num_waves)
      real(kind=8) fw(num_eqn,num_waves)

      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL

      convergencetol= 1.d-16
      criticaltol = 1.d-99

      deldelh = -delb
      deldelphi = -g*0.5d0*(hR+hL)*delb

!     !if no source term, skip determining steady state wave
      if (abs(delb).gt.0.d0) then
!
         !determine a few quanitites needed for steady state wave if iterated
         hLstar=hL
         hRstar=hR
         uLstar=uL
         uRstar=uR
         hstarHLL = max((huL-huR+sE2*hR-sE1*hL)/(sE2-sE1),0.d0) ! middle state in an HLL solve

         alpha1=0.d0
         alpha2=0.d0

!        !iterate to better determine Riemann problem
         do iter=1,maxiter

            !determine steady state wave (this will be subtracted from the delta vectors)
            hbar =  max(0.5d0*(hLstar+hRstar),0.d0)
            s1s2bar = 0.25d0*(uLstar+uRstar)**2 - g*hbar
            s1s2tilde= max(0.d0,uLstar*uRstar) - g*hbar


!           !find if sonic problem
            sonic=.false.
            if (abs(s1s2bar).le.criticaltol) sonic=.true.
            if (s1s2bar*s1s2tilde.le.criticaltol) sonic=.true.
            if (s1s2bar*sE1*sE2.le.criticaltol) sonic = .true.
            if (min(abs(sE1),abs(sE2)).lt.criticaltol) sonic=.true.

!           !find jump in h, deldelh
            if (sonic) then
               deldelh =  -delb
            else
               deldelh = delb*g*hbar/s1s2bar
            endif
!           !bounds in case of critical state resonance, or negative states
            if (sE1.lt.-criticaltol.and.sE2.gt.criticaltol) then
               deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE2)
               deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE1)
            elseif (sE1.ge.criticaltol) then
               deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE1)
               deldelh = max(deldelh,-hL)
            elseif (sE2.le.-criticaltol) then
               deldelh = min(deldelh,hR)
               deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE2)
            endif

!           !find jump in phi, deldelphi
            if (sonic) then
               deldelphi = -g*hbar*delb
            else
               deldelphi = -delb*g*hbar*s1s2tilde/s1s2bar
            endif
!           !bounds in case of critical state resonance, or negative states
            deldelphi=min(deldelphi,g*max(-hLstar*delb,-hRstar*delb))
            deldelphi=max(deldelphi,g*min(-hLstar*delb,-hRstar*delb))

!---------determine fwaves ------------------------------------------

!           !first decomposition
            delhdecomp = delh-deldelh
            delalpha1 = (sE2*delhdecomp - delhu)/(sE2-sE1)-alpha1
            alpha1 = alpha1 + delalpha1
            delalpha2 = (delhu - sE1*delhdecomp)/(sE2-sE1)-alpha2
            alpha2 = alpha2 + delalpha2

            !second decomposition
            delphidecomp = delphi - deldelphi
            beta1 = (sE2*delhu - delphidecomp)/(sE2-sE1)
            beta2 = (delphidecomp - sE1*delhu)/(sE2-sE1)

            if ((delalpha2**2+delalpha1**2).lt.convergencetol**2) then
               exit
            endif
!
            if (sE2.gt.0.d0.and.sE1.lt.0.d0) then
               hLstar=hL+alpha1
               hRstar=hR-alpha2
!               hustar=huL+alpha1*sE1
               hustar = huL + beta1
            elseif (sE1.ge.0.d0) then
               hLstar=hL
               hustar=huL
               hRstar=hR - alpha1 - alpha2
            elseif (sE2.le.0.d0) then
               hRstar=hR
               hustar=huR
               hLstar=hL + alpha1 + alpha2
            endif
!
            if (hLstar.gt.drytol) then
               uLstar=hustar/hLstar
            else
               hLstar=max(hLstar,0.d0)
               uLstar=0.d0
            endif
!
            if (hRstar.gt.drytol) then
               uRstar=hustar/hRstar
            else
               hRstar=max(hRstar,0.d0)
               uRstar=0.d0
            endif

         enddo
      endif

      delhdecomp = delh - deldelh
      delphidecomp = delphi - deldelphi

      !first decomposition
      alpha1 = (sE2*delhdecomp - delhu)/(sE2-sE1)
      alpha2 = (delhu - sE1*delhdecomp)/(sE2-sE1)

      !second decomposition
      beta1 = (sE2*delhu - delphidecomp)/(sE2-sE1)
      beta2 = (delphidecomp - sE1*delhu)/(sE2-sE1)

      ! 1st nonlinear wave
      fw(1,1) = alpha1*sE1
      fw(2,1) = beta1*sE1
      fw(3,1) = fw(1,1)*vL
      ! 2nd nonlinear wave
      fw(1,3) = alpha2*sE2
      fw(2,3) = beta2*sE2
      fw(3,3) = fw(1,3)*vR
      ! advection of transverse wave
      fw(1,2) = 0.d0
      fw(2,2) = 0.d0
      fw(3,2) = hR*uR*vR - hL*uL*vL -fw(3,1)-fw(3,3)
      !speeds
      sw(1)=sE1
      sw(2)=0.5d0*(sE1+sE2)
      sw(3)=sE2

      return

      end subroutine !-------------------------------------------------


!-----------------------------------------------------------------------
      subroutine riemann_fwave(num_eqn,num_waves,hL,hR,huL,huR,hvL,hvR, &
                  bL,bR,uL,uR,vL,vR,phiL,phiR,s1,s2,drytol,g,sw,fw)

      ! solve shallow water equations given single left and right states
      ! solution has two waves.
      ! flux - source is decomposed.

      implicit none

      !input
      integer num_eqn,num_waves

      real(kind=8) hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,s1,s2
      real(kind=8) hvL,hvR,vL,vR
      real(kind=8) drytol,g

      real(kind=8) sw(num_waves)
      real(kind=8) fw(num_eqn,num_waves)

      !local
      real(kind=8) delh,delhu,delphi,delb,delhdecomp,delphidecomp
      real(kind=8) deldelh,deldelphi
      real(kind=8) beta1,beta2


      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL

      deldelphi = -g*0.5d0*(hR+hL)*delb
      delphidecomp = delphi - deldelphi

      !flux decomposition
      beta1 = (s2*delhu - delphidecomp)/(s2-s1)
      beta2 = (delphidecomp - s1*delhu)/(s2-s1)

      sw(1)=s1
      sw(2)=0.5d0*(s1+s2)
      sw(3)=s2
      ! 1st nonlinear wave
      fw(1,1) = beta1
      fw(2,1) = beta1*s1
      fw(3,1) = beta1*vL
      ! 2nd nonlinear wave
      fw(1,3) = beta2
      fw(2,3) = beta2*s2
      fw(3,3) = beta2*vR
      ! advection of transverse wave
      fw(1,2) = 0.d0
      fw(2,2) = 0.d0
      fw(3,2) = hR*uR*vR - hL*uL*vL -fw(3,1)-fw(3,3)
      return

      end !subroutine -------------------------------------------------





!=============================================================================
      subroutine riemanntype(hL,hR,uL,uR,hm,s1m,s2m,rare1,rare2, &
                   maxiter,drytol,g)

      !determine the Riemann structure (wave-type in each family)


      implicit none

      !input
      real(kind=8) hL,hR,uL,uR,drytol,g
      integer maxiter

      !output
      real(kind=8) s1m,s2m
      logical rare1,rare2

      !local
      real(kind=8) hm,u1m,u2m,um,delu
      real(kind=8) h_max,h_min,h0,F_max,F_min,dfdh,F0,slope,gL,gR
      integer iter



!     !Test for Riemann structure

      h_min=min(hR,hL)
      h_max=max(hR,hL)
      delu=uR-uL

      if (h_min.le.drytol) then
         hm=0.d0
         um=0.d0
         s1m=uR+uL-2.d0*sqrt(g*hR)+2.d0*sqrt(g*hL)
         s2m=uR+uL-2.d0*sqrt(g*hR)+2.d0*sqrt(g*hL)
         if (hL.le.0.d0) then
            rare2=.true.
            rare1=.false.
         else
            rare1=.true.
            rare2=.false.
         endif

      else
         F_min= delu+2.d0*(sqrt(g*h_min)-sqrt(g*h_max))
         F_max= delu + (h_max-h_min)*(sqrt(.5d0*g*(h_max+h_min)/(h_max*h_min)))

         if (F_min.gt.0.d0) then !2-rarefactions

            hm=(1.d0/(16.d0*g))* &
                     max(0.d0,-delu+2.d0*(sqrt(g*hL)+sqrt(g*hR)))**2
            um=sign(1.d0,hm)*(uL+2.d0*(sqrt(g*hL)-sqrt(g*hm)))

            s1m=uL+2.d0*sqrt(g*hL)-3.d0*sqrt(g*hm)
            s2m=uR-2.d0*sqrt(g*hR)+3.d0*sqrt(g*hm)

            rare1=.true.
            rare2=.true.

         elseif (F_max.le.0.d0) then !2 shocks

!           !root finding using a Newton iteration on sqrt(h)===
            h0=h_max
            do iter=1,maxiter
               gL=sqrt(.5d0*g*(1/h0 + 1/hL))
               gR=sqrt(.5d0*g*(1/h0 + 1/hR))
               F0=delu+(h0-hL)*gL + (h0-hR)*gR
               dfdh=gL-g*(h0-hL)/(4.d0*(h0**2)*gL)+gR-g*(h0-hR)/(4.d0*(h0**2)*gR)
               slope=2.d0*sqrt(h0)*dfdh
               h0=(sqrt(h0)-F0/slope)**2
            enddo
               hm=h0
               u1m=uL-(hm-hL)*sqrt((.5d0*g)*(1/hm + 1/hL))
               u2m=uR+(hm-hR)*sqrt((.5d0*g)*(1/hm + 1/hR))
               um=.5d0*(u1m+u2m)

               s1m=u1m-sqrt(g*hm)
               s2m=u2m+sqrt(g*hm)
               rare1=.false.
               rare2=.false.

         else !one shock one rarefaction
            h0=h_min

            do iter=1,maxiter
               F0=delu + 2.d0*(sqrt(g*h0)-sqrt(g*h_max)) &
                       + (h0-h_min)*sqrt(.5d0*g*(1/h0+1/h_min))
               slope=(F_max-F0)/(h_max-h_min)
               h0=h0-F0/slope
            enddo

            hm=h0
            if (hL.gt.hR) then
               um=uL+2.d0*sqrt(g*hL)-2.d0*sqrt(g*hm)
               s1m=uL+2.d0*sqrt(g*hL)-3.d0*sqrt(g*hm)
               s2m=uL+2.d0*sqrt(g*hL)-sqrt(g*hm)
               rare1=.true.
               rare2=.false.
            else
               s2m=uR-2.d0*sqrt(g*hR)+3.d0*sqrt(g*hm)
               s1m=uR-2.d0*sqrt(g*hR)+sqrt(g*hm)
               um=uR-2.d0*sqrt(g*hR)+2.d0*sqrt(g*hm)
               rare2=.true.
               rare1=.false.
            endif
         endif
      endif

      return

      end ! subroutine riemanntype----------------------------------------------------------------

!  :::::::::::::: PREFILRECUR :::::::::::::::::::::::::::::::::::::::::::
!>     For periodic boundary conditions more work needed to fill the
!!     piece of the boundary. This routine was
!!     called because the patch sticks out of the domain,
!!     and has periodic bc.s preprocess the patch before calling
!!     filpatch to shift the patch periodically back into the domain.
!!
!!     Inputs to this routine:
!!     xl, xr, yb, yt = the location in physical space of
!!     corners of a patch.
!!     fill_indices = the location in index space of this patch.
!!
!!     Outputs from this routine:
!!     The values around the border of the grid are inserted
!!     directly into the enlarged valbig array for this piece.
!
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
recursive subroutine prefilrecur(level,nvar,valbig,auxbig,naux,time,mitot,mjtot,    &  
                                 nrowst,ncolst,ilo,ihi,jlo,jhi,iglo,ighi,jglo,jghi, &
                                 patchOnly)



    use amr_module, only: iregsz, jregsz, nghost, xlower, ylower, xperdom, yperdom
    use amr_module, only: spheredom, hxposs, hyposs, NEEDS_TO_BE_SET, alloc
    
    implicit none

    ! Input
    integer, intent(in) :: level, nvar, naux, mitot, mjtot
    integer, intent(in) :: ilo,ihi,jlo,jhi,iglo,ighi,jglo,jghi
    real(kind=8), intent(in) :: time
    ! false when called from bound, when valbig is whole grid but only filling patch.
    ! true for recursive coarse sub-patches - grid is patch
    logical  :: patchOnly  
    logical :: do_aux_copy

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mitot,mjtot)
    real(kind=8), intent(in out) :: auxbig(naux,mitot,mjtot)
    
    ! Local storage
    integer :: i, j, ii, jj, ivar, ng, i1, i2, j1, j2, nrowst, ncolst
    integer :: iuse1, iuse2
    integer :: iputst, jputst, mi, mj, locpatch, locpaux
    integer :: jbump, iwrap1, iwrap2, jwrap1, tmp, locflip, rect(4)
    real(kind=8) :: xlwrap, ybwrap
    integer ::  msrc    ! this signifies not a real grid, no bndry list with it
    ! it is possible to preprocess in the periodic case, just more complicated, so postponing

    integer :: ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)
    real(kind=8) :: scratch(max(mitot,mjtot)*nghost*nvar)
    real(kind=8) :: scratchaux(max(mitot,mjtot)*nghost*naux)

    ! dimension at largest possible
    !real(kind=8) :: valPatch((ihi-ilo+1) * (jhi-jlo+1) * nvar)  
    !real(kind=8) :: auxPatch((ihi-ilo+1) * (jhi-jlo+1) * naux)  
    real(kind=8) :: valPatch((ihi-ilo+2) * (jhi-jlo+2) * nvar)  
    real(kind=8) :: auxPatch((ihi-ilo+2) * (jhi-jlo+2) * naux)  
    

!     # will divide patch  (from ilo,jlo to ihi,jhi)  into 9 possibilities (some empty): 
!       x sticks out left, x interior, x sticks out right
!       same for y. for example, the max. would be
!       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)
!     # this patch lives in a grid with soln array valbig, which goes from
!       (iglo,jglo) to (ighi,jghi).

    msrc = -1   ! iitialization indicating whether real src grid so can use faster bc list
    do_aux_copy = .false.  ! too complicated in periodic case, just call setaux

    if (xperdom) then       
       ist(1)    = ilo
       ist(2)    = 0
       ist(3)    = iregsz(level)
       iend(1)   = -1
       iend(2)   = iregsz(level)-1
       iend(3)   = ihi
       ishift(1) = iregsz(level)
       ishift(2) = 0
       ishift(3) = -iregsz(level)
    else  ! if not periodic, set vals to only have nonnull intersection for interior regoin
       ist(1)    = iregsz(level)
       ist(2)    = ilo
       ist(3)    = iregsz(level)
       iend(1)   = -1
       iend(2)   = ihi
       iend(3)   = -1
       ishift(1) = 0
       ishift(2) = 0
       ishift(3) = 0
    endif

    if (yperdom .or. spheredom) then
       jst(1)  = jlo
       jst(2)  = 0
       jst(3)  = jregsz(level)
       jend(1) = -1
       jend(2) = jregsz(level)-1
       jend(3) = jhi
       jshift(1) = jregsz(level)
       jshift(2) = 0
       jshift(3) = -jregsz(level)
    else
       !jst(1)    = jregsz(level)
       !jst(2)    = jlo
       !jst(3)    = jregsz(level)
       !jend(1)   = -1
       !jend(2)   = jhi
       !jend(3)   = -1
       !jshift(1) = 0
       !jshift(2) = 0
       !jshift(3) = 0
    endif

!   ## loop over the 9 regions (in 2D) of the patch - the interior is i=j=2 plus
!   ## the ghost cell regions.  If any parts stick out of domain and are periodic
!   ## map indices periodically, but stick the values in the correct place
!   ## in the orig grid (indicated by iputst,jputst.
!   ## if a region sticks out of domain  but is not periodic, not handled in (pre)-icall 
!   ## but in setaux/bcamr (not called from here).
!!    if (.not. (xperdom .and. yperdom)) go to 66
    do 20 i = 1, 3
        i1 = max(ilo,  ist(i))
        i2 = min(ihi, iend(i))
        if (i1 .gt. i2) go to 20

    do 10 j = 1, 3
       if (yperdom) then
         j1 = max(jlo,  jst(j))
         j2 = min(jhi, jend(j))
       else ! not periodic in y
          ! initialize to skip then reset below
          j1 = jregsz(level) + nghost + 1
          j2 = -nghost-1
          jshift = 0
          if (j .eq. 1) then
             if (jlo .le. -1) then 
                 j1 = jlo  
                 j2 = 0 ! (top ghost cell + 1 for extrap bc)
             endif
          !endif
          elseif (j .eq. 2) then 
             ! interior part of patch,no need to add 1
             j1 = max(jlo,0)
             j2 = min(jhi,jregsz(level)-1)
          !endif
          elseif (j .eq. 3) then 
             if (jhi .gt. jregsz(level)) then
               j1 = jregsz(level)-1 ! includes last cell on top for extrap bc
               j2 = jhi
             endif
           endif
       endif

        ! part of patch in this region
         if (j1 <= j2) then 
             if (.not. spheredom) then
             !if (.not. spheredom .or. j .eq. 2) then
                 ! make temp patch of just the right size. 
                 mi = i2 - i1 + 1
                 mj = j2 - j1 + 1
                 !if (mi .gt. (ihi-ilo+1) .or.  mj .gt. (jhi-jlo+1))  then
                 if (mi .gt. (ihi-ilo+2) .or.  mj .gt. (jhi-jlo+2))  then
                    write(*,*)" prefilp: not big enough dimension"
                 endif
                 if (naux .gt. 0)                                                         &
                     call auxCopyIn(auxPatch,mi,mj,auxbig,mitot,mjtot,naux,i1,i2,j1,j2,   &
                                    iglo,jglo)
                                       
                 call filrecur(level,nvar,valPatch,auxPatch,naux,time,mi,mj,       &
                         1,1,i1+ishift(i),i2+ishift(i),j1+jshift(j),j2+jshift(j),  &
                               .true.,msrc,do_aux_copy)
                  ! copy it back to proper place in valbig 
                   call patchCopyOut(nvar,valPatch,mi,mj,valbig,mitot,mjtot,i1,i2,j1,j2,   &
                                     iglo,jglo)
 
             else
                mi = i2 - i1 + 1
                mj = j2 - j1 + 1
                ng = 0    ! no ghost cells in this little patch. fill everything.

                jbump = 0
                if (j1 < 0)   jbump = abs(j1)  ! bump up so new bottom is 0
                if (j2 >= jregsz(level)) jbump = -(j2+1-jregsz(level)) ! bump down

                ! next 2 lines would take care of periodicity in x
                iwrap1 = i1 + ishift(i)
                iwrap2 = i2 + ishift(i)
                ! next 2 lines take care of mapped sphere bcs
                iwrap1 = iregsz(level) - iwrap1 -1
                iwrap2 = iregsz(level) - iwrap2 -1
                ! swap so that smaller one is left index, etc since mapping reflects
                tmp = iwrap1
                iwrap1 = iwrap2
                iwrap2 = tmp

                jwrap1 = j1 + jbump
                xlwrap = xlower + iwrap1*hxposs(level)
                ybwrap = ylower + jwrap1*hyposs(level)

                if (naux>0) then
                    scratchaux = NEEDS_TO_BE_SET  !flag all cells with signal since dimensioned strangely
                    call setaux(ng,mi,mj,xlwrap,ybwrap,hxposs(level),hyposs(level),naux,scratchaux)
                endif 

                rect = [iwrap1,iwrap2,j1+jbump,j2+jbump]
                call filrecur(level,nvar,scratch,scratchaux,naux,time,mi, &
                              mj,1,1,iwrap1,iwrap2,j1+jbump,j2+jbump,.false.,msrc,  &
                              do_aux_copy)

                ! copy back using weird mapping for spherical folding (so cant call copy subr below)
                do ii = i1, i2
                do jj = j1, j2
                       ! write(dbugunit,'(" filling loc ",2i5," with ",2i5)') & 
                       ! nrowst+ii-fill_indices(1),ncolst+jj-fill_indices(3),mi-(ii-i1),mj-jj+j1

                       do ivar = 1, nvar
                           valbig(ivar,nrowst+(ii-ilo),ncolst+(jj-jlo)) = &
                               scratch(iaddscratch(ivar,mi-(ii-i1),mj-(jj-j1)))
                       end do
                       ! write(dbugunit,'(" new val is ",4e15.7)')(valbig(ivar,  &
                       ! nrowst+(ii-fill_indices(1)),ncolst+(jj-fill_indices(3))),ivar=1,nvar)
                end do
                end do 
             endif ! end if not spherical or j == 2
         endif ! end if region not empty

  10     continue
 20 continue
 
 return
           
contains

    integer pure function iadd(n,i,j)
        implicit none
        integer, intent(in) :: n, i, j
        iadd = locflip + n-1 + nvar*((j-1)*mi+i-1)
    end function iadd

    integer pure function iaddscratch(n,i,j)
        implicit none
        integer, intent(in) :: n, i, j
        iaddscratch = n + nvar*((j-1)*mi+i-1)  ! no subtract 1

    end function iaddscratch


end subroutine prefilrecur

! ============================================================================================

subroutine patchCopyOut(nvar,valpatch,mi,mj,valbig,mitot,mjtot,i1,i2,j1,j2,iglo,jglo)
 
    ! the patch was filled from a possibly periodically wrapped place.
    ! put it back where it should go in original grids solution array
          
    use amr_module
    implicit none

    ! Input
    integer :: mi, mj, nvar, mitot, mjtot, i1, i2,j1, j2, iglo, ighi, jglo, jghi

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mitot,mjtot)
    real(kind=8), intent(in out) :: valpatch(nvar,mi,mj)

    ! Local storage
    integer :: ist, jst 


    ! this ghost cell patch subset goes from (i1,j1) to (i2,j2) in integer index space
    ! the grid (including ghost cells) is from (iglo,jglo) to (ighi,jghi)
    ! figure out where to copy
    ist = i1 - iglo + 1   ! offset 1 since soln array is 1-based
    jst = j1 - jglo + 1

    valbig(:,ist:ist+mi-1, jst:jst+mj-1) = valpatch

end subroutine patchCopyOut

! ============================================================================================

subroutine auxCopyIn(auxPatch,mi,mj,auxbig,mitot,mjtot,naux,i1,i2,j1,j2,iglo,jglo)

    ! set the aux array for the patch  to go with the soln vals to  be filled in filpatch,
    ! by copying from valbig's auxbig array

    use amr_module
    implicit none

    ! Input
    integer :: mi, mj, naux, mitot, mjtot, i1, i2,j1, j2, iglo, ighi, jglo, jghi

    ! Output
    real(kind=8), intent(in out) :: auxbig(naux,mitot,mjtot)
    real(kind=8), intent(in out) :: auxPatch(naux,mi,mj)

    ! Local storage
    integer :: ist, jst 


    ! this ghost cell patch subset goes from (i1,j1) to (i2,j2) in integer index space
    ! the grid (including ghost cells) is from (iglo,jglo) to (ighi,jghi)
    ! figure out where to copy
    ist = i1 - iglo + 1   ! offset 1 since aux arrays are 1-based
    jst = j1 - jglo + 1

    auxPatch(:,1:mi,1:mj) = auxbig(:,ist:ist+mi-1, jst:jst+mj-1)

end subroutine auxCopyIn

! :::::::::::::::::::::::::::: FILPATCH :::::::::::::::::::::::::;
!
!  fill the portion of valbig from rows  nrowst
!                             and  cols  ncolst
!  the patch can also be described by the corners (xlp,ybp) by (xrp,ytp).
!  vals are needed at time t, and level level,
!
!  first fill with  values obtainable from the level level
!  grids. if any left unfilled, then enlarge remaining rectangle of
!  unfilled values by 1 (for later linear interp), and recusively
!  obtain the remaining values from  coarser levels.
!
! :::::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::;
recursive subroutine filrecur(level,nvar,valbig,aux,naux,t,mx,my, &
                              nrowst,ncolst,ilo,ihi,jlo,jhi,patchOnly,msrc,  &
                              do_aux_copy)

    use amr_module, only: nghost, xlower, ylower, xupper, yupper, outunit
    use amr_module, only: xperdom, yperdom, spheredom, hxposs, hyposs
    use amr_module, only: intratx, intraty, iregsz, jregsz
    use amr_module, only: NEEDS_TO_BE_SET

    use geoclaw_module, only: sea_level, dry_tolerance
    use topo_module, only: topo_finalized
    use qinit_module, only: variable_eta_init
    use qinit_module, only: force_dry,use_force_dry,mx_fdry, my_fdry
    use qinit_module, only: xlow_fdry, ylow_fdry, xhi_fdry, yhi_fdry
    use qinit_module, only: dx_fdry, dy_fdry
    use qinit_module, only: tend_force_dry

    implicit none

    ! Input
    integer, intent(in) :: level, nvar, naux, mx, my, nrowst, ncolst
    integer, intent(in) :: ilo,ihi,jlo,jhi,msrc
    real(kind=8), intent(in) :: t
    logical  :: patchOnly, do_aux_copy, yes_do_aux_copy

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mx,my)
    real(kind=8), intent(in out) :: aux(naux,mx,my)

    ! Local storage
    integer  :: iplo, iphi, jplo, jphi

    ! Flagging of set cells
    logical :: set
    integer :: i, i_coarse, j_coarse, i_fine, j_fine, n, k
    integer :: mx_coarse, my_coarse, mx_patch, my_patch
    integer :: unset_indices(4), coarse_indices(4)
    integer :: refinement_ratio_x, refinement_ratio_y
    real(kind=8) :: dx_fine, dy_fine, dx_coarse, dy_coarse
    real(kind=8) :: xlow_coarse,ylow_coarse, xlow_fine, ylow_fine, xhi_fine,yhi_fine   
    real(kind=8) :: h, b, eta_fine, eta1, eta2, up_slope, down_slope
    real(kind=8) :: hv_fine, v_fine, v_new, divide_mass
    real(kind=8) :: h_fine_average, h_fine, h_count, h_coarse
    real(kind=8)::  xcent_fine,xcent_coarse,ycent_fine,ycent_coarse,ratio_x,ratio_y
    integer(kind=1) :: flaguse(ihi-ilo+1, jhi-jlo+1)

    real(kind=8) :: eta1old, eta2old
    real(kind=8) :: veta_init_c
    integer :: ii,jj

    ! Scratch arrays for interpolation
    logical :: fine_flag(nvar, ihi-ilo+2,jhi-jlo + 2)

    logical :: reloop


    ! these are dimensioned at fine size since coarse grid size cant be larger (incl. the +3 that is )
    real(kind=8) ::  fine_mass(ihi-ilo + 3, jhi-jlo + 3)
    real(kind=8) :: eta_coarse(ihi-ilo + 3, jhi-jlo + 3)
    real(kind=8) ::    vel_max(ihi-ilo + 3, jhi-jlo + 3)
    real(kind=8) ::    vel_min(ihi-ilo + 3, jhi-jlo + 3)
    real(kind=8) ::   slope(2, ihi-ilo + 3, jhi-jlo + 3)
    integer ::   fine_cell_count(ihi-ilo+3, jhi-jlo + 3)

    integer :: nghost_patch, lencrse
    logical :: use_force_dry_this_level
    real(kind=8) :: ddxy

    ! Stack storage
    !  use stack-based scratch arrays instead of alloc, since dont really
    !  need to save beyond these routines, and to allow dynami_coarse memory resizing
    !  use 1d scratch arrays that are potentially the same size as
    !  current grid, since may not coarsen.
    !  need to make it 1d instead of 2 and do own indexing, since
    !  when pass it in to subroutines they treat it as having di_fineerent
    !  dimensions than the max size need to allocate here
    ! the +2 is to expand on coarse grid to enclose fine
    real(kind=8) :: valcrse((ihi-ilo+3) * (jhi-jlo+3) * nvar)   ! NB this is a 1D array 
    real(kind=8) :: auxcrse((ihi-ilo+3) * (jhi-jlo+3) * naux)  
    real(kind=8) :: vetac((ihi-ilo+3) * (jhi-jlo+3))
 
    yes_do_aux_copy = .true.

    mx_patch = ihi-ilo + 1 ! nrowp
    my_patch = jhi-jlo + 1 

    dx_fine     = hxposs(level)
    dy_fine     = hyposs(level)
    
    use_force_dry_this_level = use_force_dry
    if (use_force_dry) then
        ! check if force_dry resolution the same as this level:
        ddxy = max(abs(dx_fine-dx_fdry), abs(dy_fine-dy_fdry))
        use_force_dry_this_level = (ddxy < 0.01d0*min(dx_fdry,dy_fdry))
        endif

    !if (use_force_dry_this_level .and. (t <= tend_force_dry)) then
    !    write(6,*) '+++ using force_dry in filval, t = ',t
    !    endif
            
    ! Coordinates of edges of patch (xlp,xrp,ybp,ytp)
    xlow_fine = xlower + ilo * dx_fine
    ylow_fine = ylower + jlo * dy_fine
    xhi_fine = xlower + (ihi + 1) * dx_fine
    yhi_fine = ylower + (jhi + 1) * dy_fine

    ! Fill in the patch as much as possible using values at this level
    ! note that if only a patch, msrc = -1, otherwise a real grid and intfil
    ! uses its boundary list
    ! msrc either -1 (for a patch) or the real grid number
    call intfil(valbig,aux,mx,my,t,flaguse,nrowst,ncolst, ilo,  &
                ihi,jlo,jhi,level,nvar,naux,msrc,do_aux_copy)

    ! Trimbd returns set = true if all of the entries are filled (=1.).
    ! set = false, otherwise. If set = true, then no other levels are
    ! are required to interpolate, and we return.
    !
    ! Note that the used array is filled entirely in intfil, i.e. the
    ! marking done there also takes  into account the points filled by
    ! the boundary conditions. bc2amr will be called later, after all 4
    ! boundary pieces filled.
    call trimbd(flaguse,mx_patch,my_patch,set,unset_indices)
    ! il,ir,jb,jt = unset_indices(4)

    ! If set is .true. then all cells have been set and we can skip to setting
    ! the remaining boundary cells.  If it is .false. we need to interpolate
    ! some values from coarser levels, possibly calling this routine
    ! recursively.
    if (.not.set) then

        ! Error check
        if (level == 1) then
            write(outunit,*)" error in filrecur - level 1 not set"
            write(outunit,'("start at row: ",i4," col ",i4)') nrowst,ncolst
            print *," error in filrecur - level 1 not set"
            print *," should not need more recursion "
            print *," to set patch boundaries"
            print '("start at row: ",i4," col ",i4)', nrowst,ncolst
            stop
        endif

        ! We begin by initializing the level level arrays, so that we can use
        ! purely recursive formulation for interpolating.
        dx_coarse  = hxposs(level - 1)
        dy_coarse  = hyposs(level - 1)

        ! Adjust unset_indices to account for the patch
        ! isl, isr, jsb, jst
        unset_indices(1) = unset_indices(1) + ilo - 1
        unset_indices(2) = unset_indices(2) + ilo - 1
        unset_indices(3) = unset_indices(3) + jlo - 1
        unset_indices(4) = unset_indices(4) + jlo - 1

        ! Coarsened geometry
        refinement_ratio_x = intratx(level - 1)
        refinement_ratio_y = intraty(level - 1)

        ! New patch rectangle (after we have partially filled it in) but in the
        ! coarse patches [iplo,iphi,jplo,jphi]

        iplo = (unset_indices(1) - refinement_ratio_x + nghost * refinement_ratio_x) &
                                                / refinement_ratio_x - nghost
        iphi = (unset_indices(2) + refinement_ratio_x) / refinement_ratio_x
        jplo = (unset_indices(3) - refinement_ratio_y + nghost * refinement_ratio_y) &
                                                / refinement_ratio_y - nghost
        jphi = (unset_indices(4) + refinement_ratio_y) / refinement_ratio_y
                                                

        xlow_coarse = xlower + iplo * dx_coarse
        ylow_coarse = ylower + jplo * dy_coarse


        ! Coarse grid number of spatial points (nrowc,ncolc)
        mx_coarse   =  iphi - iplo  + 1
        my_coarse   =  jphi - jplo  + 1

        ! Check to make sure we created big enough scratch arrays
        if (mx_coarse > ihi - ilo + 3 .or. &
            my_coarse > jhi - jlo + 3) then

            print *," did not make big enough work space in filrecur "
            print *," need coarse space with mx_coarse,my_coarse ",mx_coarse,my_coarse
            print *," made space for ilo,ihi,jlo,jhi ",ilo,ihi,jlo,jhi
            stop
        endif

        ! Set the aux array values for the coarse grid, this could be done
        ! instead in intfil using possibly already available bathy data from the
        ! grids
        
        if (naux > 0) then
            nghost_patch = 0
            lencrse = (ihi-ilo+3)*(jhi-jlo+3)*naux ! set 1 component, not all naux
            ! new system checks initialization before setting aux vals
            ! set here and check later if not all set by copying in intfil
            ! after some more testing shoudl move thiese auxcrse initialization
            ! into the branches that need it (topo_finalized dand periodic
            ! but out of the most used filrecur pathway
            do k = 1, lencrse, naux
              auxcrse(k) = NEEDS_TO_BE_SET  
            end do
  
            ! update topography if needed
            !if ((num_dtopo>0).and.(topo_finalized.eqv..false.)) then
            !   if ((minval(topotime)<maxval(tfdtopo)).and.(t>=minval(t0dtopo))) then
            if (.not. topo_finalized) then
                call topo_update(t)
                call setaux(nghost_patch, mx_coarse, my_coarse,       &
                            xlow_coarse, ylow_coarse,                 &
                            dx_coarse,dy_coarse,naux,auxcrse)
                yes_do_aux_copy = .false. !grids may not have latest topo
            endif
        endif

        ! Fill in the edges of the coarse grid
        if ((xperdom .or. (yperdom .or. spheredom)) .and. sticksout(iplo,iphi,jplo,jphi)) then
            call setaux(nghost_patch, mx_coarse, my_coarse,       &
                        xlow_coarse, ylow_coarse,                 &
                        dx_coarse,dy_coarse,naux,auxcrse)
            call prefilrecur(level-1,nvar,valcrse,auxcrse,naux,t, &
                             mx_coarse,my_coarse,1,1,iplo,iphi,jplo,jphi,iplo,iphi,jplo,jphi,.true.)
        else ! when going to coarser patch, no source grid (for now at least) hence -1
            call filrecur(level-1,nvar,valcrse,auxcrse,naux,t,  &
                          mx_coarse,my_coarse,1,1,iplo,iphi,jplo,jphi,.true.,-1,    &
                          yes_do_aux_copy)
            !call setaux(nghost_patch, mx_coarse, my_coarse,       &
            !            xlow_coarse, ylow_coarse,                 &
            !            dx_coarse,dy_coarse,naux,auxcrse)
        endif

        ! loop through coarse cells determining intepolation slopes
        ! these will be saved for fine grid loop
        ! prevents finding the same slope possibly lratiox*lratioy times
        ! all fine gid depths will be found before any momentum
        reloop = .false.
        fine_cell_count = 0
        fine_flag = .false.
        fine_mass = 0.d0
        slope = 0.d0

        if (variable_eta_init) then
            call set_eta_init(nghost_patch, mx_coarse, my_coarse,  &
                 xlow_coarse, ylow_coarse,dx_coarse,dy_coarse,t,vetac)
          endif
          
        ! Calculate surface elevation eta using dry limiting
        veta_init_c = sea_level  ! if not variable_eta_init
        do j_coarse = 1, my_coarse
            do i_coarse = 1, mx_coarse
                h = valcrse(ivalc(1,i_coarse,j_coarse))
                b = auxcrse(iauxc(i_coarse,j_coarse))

                if (h < dry_tolerance) then
                    if (variable_eta_init) &
                        veta_init_c = vetac(ivetac(i_coarse,j_coarse))
                    eta_coarse(i_coarse,j_coarse) = veta_init_c
                else
                    eta_coarse(i_coarse,j_coarse) = h + b
                endif
            enddo
        enddo

        ! Calculate limited gradients of coarse grid eta
        do j_coarse = 2, my_coarse - 1
           do i_coarse = 2, mx_coarse - 1

                ! X-Direction
                down_slope = eta_coarse(i_coarse,j_coarse) - eta_coarse(i_coarse-1,j_coarse)
                up_slope = eta_coarse(i_coarse+1,j_coarse) - eta_coarse(i_coarse,j_coarse)
                if (up_slope * down_slope > 0.d0) then
                    slope(1,i_coarse,j_coarse) = min(abs(up_slope), abs(down_slope)) &
                        * sign(1.d0,eta_coarse(i_coarse+1,j_coarse) - eta_coarse(i_coarse-1,j_coarse))
                endif

                ! Y-Direction
                down_slope = eta_coarse(i_coarse,j_coarse) - eta_coarse(i_coarse,j_coarse-1)
                up_slope = eta_coarse(i_coarse,j_coarse+1) - eta_coarse(i_coarse,j_coarse)
                if (up_slope * down_slope > 0.d0) then
                    slope(2,i_coarse,j_coarse) = min(abs(up_slope), abs(down_slope)) &
                        * sign(1.d0,eta_coarse(i_coarse,j_coarse+1) - eta_coarse(i_coarse,j_coarse-1))
                endif
            enddo
        enddo

        ratio_y = real(refinement_ratio_y,kind=8)  ! needs to be real for "floor" call below
        ratio_x = real(refinement_ratio_x,kind=8)
        ! Loop through patch to be filled, includes multiple coarse cells
        do j_fine = 1, my_patch
            j_coarse     = floor((j_fine + jlo - 1) / ratio_y) - jplo + 1
            ycent_coarse = ylow_coarse + (j_coarse-.5d0)*dy_coarse
            ycent_fine   = ylower + (j_fine-1+jlo + .5d0)*dy_fine
            eta2         = (ycent_fine-ycent_coarse)/dy_coarse
            if (abs(eta2) .gt. .5d0) then
                write(*,*)" filpatch y indexing error: eta2 = ",eta2
            endif
            !eta2old = (-0.5d0 + real(mod(j_fine - 1, refinement_ratio_y),kind=8)) &
            !                        / real(refinement_ratio_y,kind=8)
            do i_fine = 1, mx_patch
                i_coarse     = floor((i_fine+ilo-1) / ratio_x) - iplo + 1
                xcent_coarse = xlow_coarse + (i_coarse-.5d0)*dx_coarse
                xcent_fine   =  xlower + (i_fine-1+ilo + .5d0)*dx_fine
                eta1         = (xcent_fine-xcent_coarse)/dx_coarse
                if (abs(eta1) .gt. .5d0) then
                   write(*,*)" filpatch x indexing error: eta1 = ",eta1
                endif
                !eta1old = (-0.5d0 + real(mod(i_fine - 1, refinement_ratio_x),kind=8)) &
                !                / real(refinement_ratio_x,kind=8)

                if (flaguse(i_fine,j_fine) == 0) then
                    ! Interpolate from coarse cells to fine grid for surface
                    fine_cell_count(i_coarse,j_coarse) = fine_cell_count(i_coarse,j_coarse) + 1
                    eta_fine = eta_coarse(i_coarse,j_coarse) + eta1 * slope(1,i_coarse,j_coarse) &
                                                             + eta2 * slope(2,i_coarse,j_coarse)
                    h_fine = max(eta_fine - aux(1,i_fine + nrowst - 1, j_fine + ncolst - 1), 0.d0)

                    if (variable_eta_init) then
                        veta_init_c = vetac(ivetac(i_coarse,j_coarse))
                        ! else it has been set to the constant sea_level
                    endif

                    if (use_force_dry_this_level &
                            .and. (h_fine > 0) &
                            .and. (t <= tend_force_dry)) then
                        ! check if in force_dry region
                        ii = int((xcent_fine - xlow_fdry + 1d-7) / dx_fdry) + 1
                        jj = int((ycent_fine - ylow_fdry + 1d-7) / dy_fdry) + 1
                        jj = my_fdry - jj  ! since index 1 corresponds to north edge
                        if ((ii>=1) .and. (ii<=mx_fdry) .and. &
                            (jj>=1) .and. (jj<=my_fdry)) then
                            ! grid cell lies in region covered by force_dry,
                            ! check if this cell is forced to be dry      
                            ! Otherwise don't change value set above:
                            if (force_dry(ii,jj) == 1) then
                                h_fine = 0.d0
                                endif
                            endif

                        endif


                    valbig(1,i_fine+nrowst-1, j_fine+ncolst-1) = h_fine
                    fine_mass(i_coarse,j_coarse) = fine_mass(i_coarse,j_coarse) + h_fine

                    ! Flag the corresponding coarse cell as needing relimiting
                    ! if one of the fine cells ends up being dry
                    if (h_fine < dry_tolerance) then
                        fine_flag(1,i_coarse,j_coarse) = .true.
                        reloop = .true.
                    endif
                endif
            enddo
        enddo

        ! Momentum Interpolation
        do n = 2, nvar
            slope = 0.d0  ! reinitialize for each var
            do j_coarse = 2, my_coarse - 1
                do i_coarse = 2, mx_coarse - 1

                    ! Determine slopes for interpolation
                    down_slope = (valcrse(ivalc(n,i_coarse,j_coarse)) - valcrse(ivalc(n,i_coarse-1,j_coarse)))
                    up_slope   = (valcrse(ivalc(n,i_coarse+1,j_coarse)) - valcrse(ivalc(n,i_coarse,j_coarse)))
                    if (up_slope * down_slope > 0.d0) then
                        slope(1,i_coarse,j_coarse) = min(abs(up_slope), abs(down_slope)) *    &
                                          sign(1.d0, valcrse(ivalc(n,i_coarse+1,j_coarse))    &
                                           - valcrse(ivalc(n,i_coarse-1,j_coarse)))
                    endif

                    down_slope = (valcrse(ivalc(n,i_coarse,j_coarse)) - valcrse(ivalc(n,i_coarse,j_coarse-1)))
                    up_slope   = (valcrse(ivalc(n,i_coarse,j_coarse+1)) - valcrse(ivalc(n,i_coarse,j_coarse)))
                    if (up_slope * down_slope > 0.d0) then
                        slope(2,i_coarse,j_coarse) = min(abs(up_slope), abs(down_slope))       &
                                         * sign(1.d0, valcrse(ivalc(n,i_coarse,j_coarse+1))    &
                                          - valcrse(ivalc(n,i_coarse,j_coarse-1)))
                    endif

                    ! Set initial values for max/min of current field
                    if (valcrse(ivalc(1,i_coarse,j_coarse)) > dry_tolerance) then
                        vel_max(i_coarse,j_coarse) = valcrse(ivalc(n,i_coarse,j_coarse)) /    &
                                                     valcrse(ivalc(1,i_coarse,j_coarse))
                        vel_min(i_coarse,j_coarse) = valcrse(ivalc(n,i_coarse,j_coarse)) /    &
                                                     valcrse(ivalc(1,i_coarse,j_coarse))
                    else
                        vel_min(i_coarse,j_coarse) = 0.d0
                        vel_max(i_coarse,j_coarse) = 0.d0
                    endif

                    ! Look for bounds on velocity around each cell
                    ! Necessary since we are interpolating momentum linearly
                    ! but not interpolating depth linearly
                    do i =-1,1,2
                        if (valcrse(ivalc(1,i_coarse + i,j_coarse)) > dry_tolerance) then
                            vel_max(i_coarse,j_coarse) =  max(vel_max(i_coarse,j_coarse),      &
                                                valcrse(ivalc(n,i_coarse + i,j_coarse)) /      &
                                                valcrse(ivalc(1,i_coarse + i,j_coarse)))
                            vel_min(i_coarse,j_coarse) = min(vel_min(i_coarse,j_coarse),       &
                                                valcrse(ivalc(n,i_coarse + i,j_coarse)) /      &
                                                valcrse(ivalc(1,i_coarse + i,j_coarse)))
                        endif

                        if (valcrse(ivalc(1,i_coarse,j_coarse + i)) > dry_tolerance) then
                            vel_max(i_coarse,j_coarse) = max(vel_max(i_coarse,j_coarse),       &
                                                  valcrse(ivalc(n,i_coarse,j_coarse + i)) /    &
                                                  valcrse(ivalc(1,i_coarse,j_coarse + i)))
                            vel_min(i_coarse,j_coarse) = min(vel_min(i_coarse,j_coarse),       &
                                                  valcrse(ivalc(n,i_coarse,j_coarse + i)) /    &
                                                  valcrse(ivalc(1,i_coarse,j_coarse + i)))

                        endif
                    enddo
                enddo
            enddo

            ! Determine momentum in fine cells
            do j_fine = 1, my_patch
                j_coarse     = floor((j_fine + jlo - 1) / ratio_y) - jplo + 1
                ycent_coarse = ylow_coarse + (j_coarse-.5d0)*dy_coarse
                ycent_fine   =  ylower + (j_fine-1+jlo + .5d0)*dy_fine
                eta2         = (ycent_fine-ycent_coarse)/dy_coarse

                do i_fine = 1, mx_patch
                    i_coarse     = floor((i_fine+ilo-1) / ratio_x) - iplo + 1
                    xcent_coarse = xlow_coarse + (i_coarse-.5d0)*dx_coarse
                    xcent_fine   =  xlower + (i_fine-1+ilo + .5d0)*dx_fine
                    eta1         = (xcent_fine-xcent_coarse)/dx_coarse

                    if (flaguse(i_fine,j_fine) == 0) then
                        ! Cell not already set

                        if (.not.(fine_flag(1,i_coarse,j_coarse))) then
                            ! This cell has no coarse cells that are dry
                            hv_fine = valcrse(ivalc(n,i_coarse,j_coarse))         &
                                            + eta1 * slope(1,i_coarse,j_coarse)   &
                                            + eta2 * slope(2,i_coarse,j_coarse)
                            v_fine = hv_fine  / valbig(1,i_fine+nrowst-1, j_fine+ncolst-1)
                            if (v_fine<vel_min(i_coarse,j_coarse) .or.  v_fine>vel_max(i_coarse,j_coarse)) then
                                fine_flag(n,i_coarse,j_coarse) = .true.
                                reloop = .true.
                            else
                                valbig(n,i_fine+nrowst-1,j_fine+ncolst-1) = hv_fine
                            endif
                        endif
                    endif
                enddo
            enddo

            ! Reset momentum to conserve momentum in the cases where we may have
            ! gained momentum or if velocity bounds were violated
            if (reloop) then
              
                do j_fine  = 1, my_patch
                  j_coarse     = floor((j_fine + jlo - 1) / ratio_y) - jplo + 1
                  ycent_coarse = ylow_coarse + (j_coarse-.5d0)*dy_coarse
                  ycent_fine   =  ylower + (j_fine-1+jlo + .5d0)*dy_fine
                  eta2         = (ycent_fine-ycent_coarse)/dy_coarse
 
                    do i_fine = 1, mx_patch
                       i_coarse     = floor((i_fine+ilo-1) / ratio_x) - iplo + 1
                       xcent_coarse = xlow_coarse + (i_coarse-.5d0)*dx_coarse
                       xcent_fine   =  xlower + (i_fine-1+ilo + .5d0)*dx_fine
                       eta1         = (xcent_fine-xcent_coarse)/dx_coarse

                        if (flaguse(i_fine,j_fine) == 0) then
                            if (fine_flag(1,i_coarse,j_coarse) .or. fine_flag(n,i_coarse,j_coarse)) then
                                if (fine_mass(i_coarse,j_coarse) > dry_tolerance) then
                                    h_coarse = valcrse(ivalc(1,i_coarse,j_coarse))
                                    h_count = real(fine_cell_count(i_coarse,j_coarse),kind=8)
                                    h_fine_average = fine_mass(i_coarse,j_coarse) / h_count
                                    divide_mass = max(h_coarse, h_fine_average)
                                    h_fine = valbig(1, i_fine + nrowst - 1, j_fine + ncolst - 1)
                                    v_new = valcrse(ivalc(n,i_coarse,j_coarse)) / (divide_mass)

                                    valbig(n,i_fine+nrowst-1,j_fine+ncolst-1) = &
                                        v_new * valbig(1,i_fine+nrowst-1,j_fine+ncolst-1)
                                else
                                    valbig(n,i_fine+nrowst-1,j_fine+ncolst-1) = 0.d0
                                endif
                            endif
                        endif
                    enddo
                enddo
            endif ! end if reloop
        enddo  ! end loop over nvar
    endif   ! end if patch not set

    ! set bcs, whether or not recursive calls needed. set any part of patch that stuck out
    xhi_fine = xlower + (ihi + 1) * dx_fine
    yhi_fine = ylower + (jhi + 1) * dy_fine
    if (patchOnly) then
       call bc2amr(valbig,aux,mx,my,nvar,naux,dx_fine,dy_fine,level,t,   &
                   xlow_fine,xhi_fine,ylow_fine,yhi_fine)
    endif

contains

    integer pure function ivalc(n,i,j)
        implicit none
        integer, intent(in) :: n,i,j
        ivalc = n + nvar*(i-1) + nvar*mx_coarse*(j-1)
    end function ivalc

    ! Index into first component of aux = topo:
    integer pure function iauxc(i,j)
        implicit none
        integer, intent(in) :: i,j
        iauxc = 1 + naux*(i-1) + naux*mx_coarse*(j-1)
    end function iauxc

    ! Index into vetac:
    integer pure function ivetac(i,j)
        implicit none
        integer, intent(in) :: i,j
        ivetac = 1 + (i-1) + mx_coarse*(j-1)
    end function ivetac

    ! logical for checking if this patch sticks outside of the domain
    logical pure function sticksout(iplo,iphi,jplo,jphi)
        implicit none
        integer, intent(in) :: iplo,iphi,jplo,jphi
        sticksout = (iplo < 0 .or. jplo < 0 .or. &
                     iphi >= iregsz(level - 1) .or. jphi >= jregsz(level - 1))
    end function sticksout

end subroutine filrecur

subroutine rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! Riemann-solver for the 3d Burgers' equation

!    q_t  +  u*(.5*q^2)_x + v*(.5*q^2)_y + w*(.5*q^2)_z = 0

! where u,v,w are a given scalars, stored in the common block cparam.
!
! waves: 1
! equations: 1
!
! Conserved quantities:
!       1 q
!
! Solve Riemann problems along one slice of data.
! This data is along a slice in the x-direction if ixyz=1
!                               the y-direction if ixyz=2.
!                               the z-direction if ixyz=3.
!
! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
!
! On output, wave contains the waves, s the speeds,
! and amdq, apdq the left-going and right-going flux differences,
! respectively.  
!
! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr

    implicit none

    integer, intent(in) :: ixyz, maxm, meqn, mwaves, mbc, mx, maux

    double precision, intent(in)  :: ql, qr, auxl, auxr
    double precision, intent(out) :: wave, s, amdq, apdq
    dimension wave(meqn,mwaves,1-mbc:maxm+mbc)
    dimension    s(mwaves,1-mbc:maxm+mbc)
    dimension   ql(meqn,1-mbc:maxm+mbc)
    dimension   qr(meqn,1-mbc:maxm+mbc)
    dimension amdq(meqn,1-mbc:maxm+mbc)
    dimension apdq(meqn,1-mbc:maxm+mbc)
    logical, parameter :: efix = .true.

    double precision :: coeff
    common /cparam/ coeff(3)

    integer :: i

    ! Set wave, speed, and flux differences:
    do i = 2-mbc, mx+mbc
        wave(1,1,i) = ql(1,i) - qr(1,i-1)
        s(1,i) = coeff(ixyz) * 0.5d0*(qr(1,i-1) + ql(1,i))

        ! The flux difference df = s*wave all goes in the downwind direction:
        amdq(1,i) = dmin1(s(1,i), 0.d0) * wave(1,1,i)
        apdq(1,i) = dmax1(s(1,i), 0.d0) * wave(1,1,i)

        if (efix) then
            ! entropy fix for transonic rarefactions:
            if (qr(1,i-1).lt.0.d0 .and. ql(1,i).gt.0.d0) then
                amdq(1,i) = - coeff(ixyz) * 0.5d0*qr(1,i-1)**2
                apdq(1,i) =   coeff(ixyz) * 0.5d0*ql(1,i)**2
            endif
        endif
    end do

    return

end subroutine rpn3

c
c --------------------------------------------------------------
c Modified from errf1.f in amrclaw to use aux arrays
c and correctly account for wet/dry cells.
c --------------------------------------------------------------
c
      subroutine errf1(rctfine,nvar,rctcrse,mptr,mi2tot,mj2tot,
     2                 mitot,mjtot,rctflg,mibuff,mjbuff,auxfine,
     2                 naux,auxcrse)

      use amr_module, only: rnode,node,hxposs,hyposs,possk,tol,nghost
      use amr_module, only: iorder,cornylo,cornxlo,edebug,eprint
      use amr_module, only: outunit,timemult,nestlevel,mcapa
      use amr_module, only: DONTFLAG,DOFLAG,UNSET
      use refinement_module, only: wave_tolerance
      use geoclaw_module, only:dry_tolerance, sea_level
      implicit none

      integer, intent(in) :: nvar, mptr, mi2tot, mj2tot
      integer, intent(in) :: mitot, mjtot,mibuff,mjbuff, naux
      real(kind=8), intent(in) :: rctfine(nvar,mitot,mjtot)
      real(kind=8), intent(inout) :: rctcrse(nvar,mi2tot,mj2tot)
      real(kind=8), intent(inout) :: auxfine(naux,mitot,mjtot)
      real(kind=8), intent(in) :: auxcrse(naux,mi2tot,mj2tot)
      real(kind=8), intent(inout) :: rctflg(mibuff,mjbuff)


c     Local variables
      integer :: i, j, ifine, jfine, jj, ii, levm, m
      integer :: ico, jco, nwet
      real(kind=8) :: errmax, err2, order
      real(kind=8) :: hx, hy, dt, rflag, time
      real(kind=8) :: xofi, ybot, xleft, yofj, capa, capacrse
      real(kind=8) :: hcrse, hucrse, hvcrse, etacrse, bcrse
      real(kind=8) :: hf, huf, hvf, etaf, bf, etac1
      real(kind=8) :: hc, huc, hvc, etac, hav, etaav, bav
      real(kind=8) :: etasum, hsum, husum, hvsum, bsum
      real(kind=8) :: etaerr, herr, huerr, hverr
c
c
c ::::::::::::::::::::::::::::: ERRF1 ::::::::::::::::::::::::::::::::
c
c  Richardson error estimator:  Used when flag_richardson is .true.
c  Compare error estimates in rctfine, rctcrse, 
c  A point is flagged if the error estimate is greater than tol
c  later we check if its in a region where its allowed to be flagged
c  or alternatively required.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

c
c     Local variables
c
      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      ybot  = rnode(cornylo,mptr)
      hy    = hyposs(levm)
      dt    = possk(levm)
 
      errmax = 0.0d0
      err2   = 0.0d0
      order  = dble(2**(iorder+1) - 2)

c
c     Print values for debugging
c
      if (.not. (edebug)) go to 20
         write(outunit,107) mptr
 107     format(//,' coarsened grid values for grid ',i4)
         do 10 jj = nghost+1, mj2tot-nghost
            j = mj2tot + 1 - jj
            write(outunit,101) (rctcrse(1,i,j),
     .                          i = nghost+1, mi2tot-nghost)
10       continue
         write(outunit,108) mptr
 108     format(//, ' fine grid values for grid ',i4)
         do 15 jj = nghost+1, mjtot-nghost
            j = mjtot + 1 - jj
            write(outunit,101) (rctfine(1,i,j),i=nghost+1,mitot-nghost)
15       continue
101      format(' ',10e15.7)

c
c Main loop: flag points and set extra aux values
c
 20   continue
      jfine = nghost+1
      do 35  j = nghost+1, mj2tot-nghost
          yofj  = ybot + (dble(jfine) - .5d0)*hy
          ifine = nghost+1
c
          do 30  i  = nghost+1, mi2tot-nghost
              rflag = DONTFLAG

! Only check errors if flag hasn't been set yet.
! If flag == DONTFLAG then refinement is forbidden by a region,
! if flag == DOFLAG checking is not needed

c Note: here rctcrse is being used as a temporary flag
c the fine grid amrflags array is stored in rctflg, and will be
c updated based on rctcrse at the end of this routine
           if(rctflg(ifine,jfine) == UNSET 
     .        .or. rctflg(ifine+1,jfine) == UNSET 
     .        .or. rctflg(ifine,jfine+1) == UNSET 
     .        .or. rctflg(ifine+1,jfine+1) == UNSET) then

              xofi  = xleft + (dble(ifine) - .5d0)*hx

              herr  = 0.d0
              huerr = 0.d0
              hverr = 0.d0
              etaerr= 0.d0
c
c             Calculate error for each value of q and eta
c             if course grid is in wet state
c
              if (mcapa .eq. 0) then
                  capacrse=1.0d0
              else
                  capacrse=auxcrse(2,i,j)
              endif

              hcrse = rctcrse(1,i,j)
              hucrse= rctcrse(2,i,j)
              hvcrse= rctcrse(3,i,j)
              bcrse = auxcrse(1,i,j)
              etacrse = hcrse+bcrse

              if (hcrse > dry_tolerance) then

c               # Calculating which values to use for error
                etasum= 0.d0
                hsum  = 0.d0
                husum = 0.d0
                hvsum = 0.d0
                bsum = 0.d0

                nwet=0

                do jco = 1,2
                  do ico = 1,2
                    if (mcapa .eq. 0) then
                      capa=1.0d0
                    else
                      capa=auxfine(2,ifine+ico-1,jfine+jco-1)
                    endif

                    hf =rctfine(1,ifine+ico-1,jfine+jco-1)*capa
                    huf=rctfine(2,ifine+ico-1,jfine+jco-1)*capa
                    hvf=rctfine(3,ifine+ico-1,jfine+jco-1)*capa

                    bf =auxfine(1,ifine+ico-1,jfine+jco-1)*capa

                    if (hf > dry_tolerance) then
                        etaf = hf+bf
                        nwet=nwet+1
                    else
                        etaf = 0.d0
                        huf=0.d0
                        hvf=0.d0
                        bf = 0.d0
                    endif

                    hsum   = hsum + hf
                    husum  = husum + huf
                    hvsum  = hvsum + hvf
                    etasum = etasum + etaf
                    bsum = bsum + bf
                  enddo
                enddo

c               # Finding coarsened values
                if (nwet .gt. 0) then
                    hav  = hsum/dble(nwet)
                    etaav = etasum/dble(nwet)
                    bav = bsum/dble(nwet)

c                    hc=max(etaav-bcrse*capacrse,0.d0) !tsunamiclaw method
                    hc = min(hav,(max(etaav-bcrse*capacrse,0.d0)))
                    if (hsum .ne. 0) then
                        huc = (min(hav,hc)/hsum)*husum
                        hvc = (min(hav,hc)/hsum)*hvsum
                    else
                        huc = 0.d0
                        hvc = 0.d0
                    endif

                else
                    hc  = 0.d0
                    huc = 0.d0
                    hvc = 0.d0
                endif

                hc = hc / capacrse
                huc = huc / capacrse
                hvc = hvc / capacrse
                etac = hc + bcrse

c               # Finding errors
                herr  = dabs((hc-hcrse)/ order)
                huerr = dabs((huc-hucrse)/ order)
                hverr = dabs((hvc-hvcrse)/ order)
                etaerr= dabs((etac-etacrse)/ order)
              endif

c             Flag point if error is large enough
              if (etaerr .ge. tol) then
                  rflag  = DOFLAG
              endif

            endif

            rctcrse(1,i,j) = rflag

            ifine = ifine + 2
 30       continue

          jfine = jfine + 2
 35    continue

c
c  print out intermediate flagged rctcrse (for debugging)
c
      if (eprint) then
         err2 = dsqrt(err2/dble((mi2tot-2*nghost)*(mj2tot-2*nghost)))
         write(outunit,103) mptr, levm, errmax, err2
 103     format(' grid ',i4,' level ',i4,
     .          ' max. error = ',e15.7,' err2 = ',e15.7)
         if (edebug) then
           write(outunit,*) ' flagged points on coarsened grid ',
     .                      '(no ghost cells) for grid ',mptr
           do 45 jj = nghost+1, mj2tot-nghost
              j = mj2tot + 1 - jj
              write(outunit,106) (nint(rctcrse(1,i,j)),
     .                            i=nghost+1,mi2tot-nghost)
106           format(1h ,80i1)
45         continue
         endif
      endif

c
c     If coarse point is flagged, set point in flag array
c
      jfine   = nghost+1
      do 70 j = nghost+1, mj2tot-nghost
          ifine   = nghost+1
          do 60 i = nghost+1, mi2tot-nghost
             if (rctcrse(1,i,j) .eq. DOFLAG) then
c                ## never set rctflg to DONTFLAG, since flag2refine or
c                ## flag2refine may have previously set it to DOFLAG
c                ## can only add DOFLAG pts in this routine
                 rctflg(ifine,jfine)    = DOFLAG
                 rctflg(ifine+1,jfine)  = DOFLAG
                 rctflg(ifine,jfine+1)  = DOFLAG
                 rctflg(ifine+1,jfine+1)= DOFLAG
             endif

             ifine   = ifine + 2
 60        continue

           jfine   = jfine + 2
 70    continue

c
c     Print out values for debugging
c
      if (eprint) then
         write(outunit,118)
 118     format(' on fine grid (no ghost cells) flagged points are')
         if (edebug) then
          do 56 jj = nghost+1, mjtot-nghost
           j = mjtot + 1 - jj
           write(outunit,106)
     &      (nint(rctflg(i,j)),i=nghost+1,mitot-nghost)
 56       continue
        endif
      endif

      return
      end

c
!> Check that the potential grid mnew is completely
!! contained in the (coarser) finest grid which stays
!! fixed, at level lbase. projec algo. Will guarantee
!! containment in all finer grids twixt them.
!!
!! If grid not contained in some coarse grid, then
!! bisect in long direction and add the two new grids
!! to the cluster (grid) list and return false.
!! EVENTUALLY this has to work, since flagged pts were
!! checked for proper nesting.
!!
!! For grid mnew (on level **lev**), check if it's properly nested in
!! - fixed base level (**lbase**) grids for current regridding
!! - level **lev**-2 grids
!! 
!! If grid mnew is properly nested, return true.
!!
!! Need to check base level grids since they are fixed during 
!! currign regridding.
!!
!! TODO: check these
!!
!! Need to check **lev**-2 grids since the **lev**-1 grids to be 
!! generated at next step is in the range of level **lev**-2 grids.
!! If level **lev**-2 grids do not properly contain mnew, there is 
!! no way the **lev**-1 grids to be generated at next step can 
!! contain grid mnew.
!! Grid mnew will be projected to level **lev**-2 grids so level 
!! **lev**-1 grids are guaranteed to contain grid mnew after they
!! are re-generated.
!!
!!
c
c ---------------------------------------------------------
c
      logical function nestck2(mnew,lbase,badpts,npts,numptc,icl,
     1                        nclust, nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)
      dimension  badpts(2,npts)
      logical baseCheck, isNested1, isNested2
      logical projecCheck

      integer   numptc(maxcl), zeroBuff
c
c ::::::::::::::::::::::: NESTCK :::::::::::::::::::::::::::::::::::

c nestck - check that the potential grid mnew is completely
c          contained in the (coarser) finest grid which stays
c          fixed, at level lbase. projec algo. will guarantee
c          containment in all finer grids twixt them.
c          if grid not contained in some coarse grid,  then
c          bisect in long direction.
c          EVENTUALLY this has to work, since flagged pts were
c          checked for proper nesting.
c
c input parameter:
c   mnew    - grid descriptor of potential grid
c   lbase   - level which stays fixed during regridding
c   badpts  - only the flagged pts. in this cluster (# icl)
c :::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::::::::
c
       nestck2 = .true.
       levnew  = node(nestlevel,mnew)
       lratiox = intratx(levnew-1)
       lratioy = intraty(levnew-1)
c
!--c      # for CONVEX coarsest grid at level 1, nothing to check
       if (lbase .eq. 1)  then
            isNested1 = .true.

c POTENTIAL BUG FIX
c  need to also check that new grid can be projected to level-2 grids so is
c  properly nested.  might be an accident of grid gen that makes it stick out
c  for now check using same call for both purposes
       else

         zeroBuff = 0   ! dont count buffer zone around grid in checking
         isNested1 = baseCheck(mnew,lbase,node(ndilo,mnew),
     .                         node(ndihi,mnew),node(ndjlo,mnew),
     .                         node(ndjhi,mnew),nvar,naux,zeroBuff)
       endif

c again using new second definition of proper nesting (must have existing grid to project to
c to insure new lev-2 grid generated containing levnew grids
       levToCheck = levnew - 2
       if (levToCheck .le. 1) then 
         isNested2 = .true.   ! base grid convex, no L shaped domains
       else if (levToCheck .le. lbase) then
         isNested2 = isNested1
       else
         mbuff = max(nghost,ibuff+1) ! you can use buffer zone in checking, since is only to flag points
         isNested2 = baseCheck(mnew,levToCheck,node(ndilo,mnew),
     .                         node(ndihi,mnew),node(ndjlo,mnew),
     .                         node(ndjhi,mnew),nvar,naux,mbuff)

       endif

       if (isNested1 .and. isNested2) then
           nestck2 = .true.
           go to 99
       endif
c
c  ### use grid indices coarsened by 1 level in checking
c  ### remember to offset by 1 since 1st grid cell is 0,0

c  ### grid not properly nested. bisect in long direction, and return
c  ### two clusters instead of 1.
c
 50    if (npts .gt. 1) go to 55
           write(outunit,101) levnew
           write(*,101)       levnew
 101       format(' nestck2: 1 pt. cluster at level ',i5,' still not',
     1       ' nested',/,'          pt. too close to boundary')
           write(outunit,104) badpts(1,npts),badpts(2,npts)
           write(*,104)       badpts(1,npts),badpts(2,npts)
 104       format(' non-nested flagged pt. at: ',2e15.7)
           call outtre(mstart, .false.,nvar,naux)
           call outmsh(mnew, .false.,nvar,naux)
           stop

 55    if (nclust .lt. maxcl) go to 60
           write(outunit,102) maxcl
           write(*,102)       maxcl
 102       format(' too many clusters: > ',i5,' (from nestck2) ')
           stop

 60   if (nprint) write(outunit,103) icl, npts
 103  format(' bisecting cluster ',i5,' with ',i5,' pts. in nestck2')
      if (rnode(cornxhi,mnew)-rnode(cornxlo,mnew) .gt.
     1    rnode(cornyhi,mnew) - rnode(cornylo,mnew)) then
           rmid  = (rnode(cornxhi,mnew) + rnode(cornxlo,mnew) ) / 2.
           rmid  = (node(ndihi,mnew) + node(ndilo,mnew) + 1 ) / 2.
           rmid  = rmid / lratiox
           idir = 1
       else
           rmid  = (rnode(cornyhi,mnew) + rnode(cornylo,mnew) ) / 2.
           rmid  = (node(ndjhi,mnew) + node(ndjlo,mnew) + 1) / 2.
           rmid  = rmid / lratioy
           idir = 2
       endif
c
       ipt  = 1
       ntop = npts

 90    if (badpts(idir,ipt) .lt. rmid) go to 100
c
c  ### swap with a point in top half not yet tested. keep smaller
c  ### half of rect. in bottom half
c
       temp           = badpts(1,ipt)
       badpts(1,ipt)  = badpts(1,ntop)
       badpts(1,ntop) = temp
       temp           = badpts(2,ipt)
       badpts(2,ipt)  = badpts(2,ntop)
       badpts(2,ntop) = temp
       ntop           = ntop - 1
       if (ipt .le. ntop) go to 90
       go to 110
 100   ipt = ipt +1
       if (ipt .le. ntop) go to 90
c
c  ### ntop points to top of 1st cluster (= no. of points in 1st cluster)
c
 110   numptc(icl)     = npts - ntop
       do 120 i        = icl, nclust
          nmove           = nclust + icl - i
          numptc(nmove+1) = numptc(nmove)
 120   continue
       numptc(icl)     = ntop
       nclust          = nclust + 1
       nestck2         = .false.
c
 99    return
       end

c
c  -------------------------------------------------------------
c
      subroutine tick(nvar,cut,nstart,vtime,time,naux,start_time,
     &                rest,dt_max)
c
      use geoclaw_module
      use refinement_module, only: varRefTime
      use amr_module
      use topo_module, only: dt_max_dtopo, num_dtopo, topo_finalized,
     &                       aux_finalized, topo0work
      use gauges_module, only: setbestsrc, num_gauges
      use gauges_module, only: print_gauges_and_reset_nextLoc

      use storm_module, only: landfall, display_landfall_time
      use fgmax_module, only: FG_num_fgrids, FG_fgrids, fgrid
      use fgout_module, only: FGOUT_num_grids, FGOUT_fgrids,
     &                         fgout_write,fgout_grid, FGOUT_ttol

      implicit double precision (a-h,o-z)

      logical vtime,dumpout/.false./,dumpchk/.false./,rest,dump_final
      logical stopFound
      dimension dtnew(maxlv), ntogo(maxlv), tlevel(maxlv)
      integer(kind=8) :: clock_start, clock_finish, clock_rate
      integer(kind=8) :: tick_clock_finish, tick_clock_rate
      integer ifg
      character(len=128) :: time_format
      real(kind=8) cpu_start,cpu_finish
      type(fgrid), pointer :: fg
      type(fgout_grid), pointer :: fgout
      logical :: debug

c
c :::::::::::::::::::::::::::: TICK :::::::::::::::::::::::::::::
c  main driver routine.  controls:
c        integration  of all grids.
c        error estimation / regridding
c        output counting
c        updating of fine to coarse grids

c  parameters:
c     nstop   = # of coarse grid time steps to be taken
c     iout    = output interval every 'iout' coarse time steps
c               (if 0, not used - set to inf.)
c     vtime   = true for variable timestep, calculated each coarse step
c
c  integration strategy is to advance a fine grid until it catches
c  up to the coarse grid. this strategy is applied recursively.
c  coarse grid goes first.
c
c  nsteps: used to count how number steps left for a level to be
c          integrated before it catches up with the next coarser level.
c  ncycle: counts number of coarse grid steps = # cycles.
c
c  icheck: counts the number of steps (incrementing by 1
c          each step) to keep track of when that level should
c          have its error estimated and finer levels should be regridded.
c ::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::
c


      ncycle         = nstart
      call setbestsrc()     ! need at very start of run, including restart
      if (iout .eq. 0) then
c        # output_style 1 or 2
         iout  = iinfinity
         nextout = 0
         if (nout .gt. 0) then
            nextout = 1
            if (nstart .gt. 0) then
c              # restart: make sure output times start after restart time
               do ii = 1, nout
                 if (tout(ii) .gt. time) then
                   nextout = ii
                   go to 2
                 endif
               end do
  2         continue
            endif
         endif
      endif

      nextchk = 1
      if ((nstart .gt. 0) .and. (abs(checkpt_style).eq.2)) then
c        if this is a restart, make sure chkpt times start after restart time
         do ii = 1, nchkpt
           if (tchk(ii) .gt. time) then
              nextchk = ii
              go to 3
              endif
           enddo
  3      continue
         endif

      tlevel(1)      = time

      do 5 i       = 2, mxnest
       tlevel(i) = tlevel(1)
 5     continue

c
c  ------ start of coarse grid integration loop. ------------------
c
 20   if (ncycle .ge. nstop .or. time .ge. tfinal) goto 999

      if (nout .gt. 0) then
          if (nextout  .le. nout) then
             outtime       = tout(nextout)
          else
             outtime       = rinfinity
          endif
      else
          outtime = tfinal
      endif

      if (nextchk  .le. nchkpt) then
         chktime       = tchk(nextchk)
      else
         chktime       = rinfinity
      endif

      dumpout = .false.  !# may be reset below

      if (time.lt.outtime .and. time+1.001*possk(1) .ge. outtime) then
c        ## adjust time step  to hit outtime exactly, and make output
c        #  apr 2010 mjb: modified so allow slightly larger timestep to
c        #  hit output time exactly, instead of taking minuscule timestep
c        #  should still be stable since increase dt in only 3rd digit.
         oldposs = possk(1)
         possk(1) = outtime - time
c        write(*,*)" old possk is ", possk(1)
         diffdt = oldposs - possk(1)  ! if positive new step is smaller


         if (.false.) then  
            write(*,122) diffdt,outtime  ! notify of change
 122        format(" Adjusting timestep by ",e10.3,
     .             " to hit output time of ",e13.6)
c           write(*,*)" new possk is ", possk(1)
            if (diffdt .lt. 0.) then ! new step is slightly larger
              pctIncrease = -100.*diffdt/oldposs   ! minus sign to make whole expr. positive
              write(*,123) pctIncrease
 123          format(" New step is ",e9.2," % larger.",
     .               "  Should still be stable")
              endif
            endif


         do i = 2, mxnest
            possk(i) = possk(i-1) / kratio(i-1)
            enddo
         if (nout .gt. 0) then
            nextout = nextout + 1
            dumpout = .true.
            endif
      endif


      if (time.lt.chktime .and. time + possk(1) .ge. chktime) then
c        ## adjust time step  to hit chktime exactly, and do checkpointing
         possk(1) = chktime - time
         do 13 i = 2, mxnest
 13         possk(i) = possk(i-1) / kratio(i-1)
         nextchk = nextchk + 1
        dumpchk = .true.
      else
        dumpchk = .false.
      endif

c
      level        = 1
      ntogo(level) = 1
      dtnew(1:maxlv) = rinfinity
C       do i = 1, maxlv
C          dtnew(i)  = rinfinity
C       enddo

c     We should take at least one step on all levels after any
c     moving topography (dtopo) has been finalized to insure that
c     all aux arrays are consistent with the final topography.
c     The variable aux_finalized is incremented so that we can check
c     if this is true by checking if aux_finalized == 2 elsewhere in code.

      if (aux_finalized .eq. 1 .and. num_dtopo > 0) then
c         # this is only true once, and only if there was moving topo
          deallocate(topo0work)
          endif 
      if (topo_finalized .and. (aux_finalized .lt. 2)) then
          aux_finalized = aux_finalized + 1
          endif

    
c
c     ------------- regridding  time?  ---------
c
c check if either
c   (i)  this level should have its error estimated before being advanced
c   (ii) this level needs to provide boundary values for either of
c        next 2 finer levels to have their error estimated.
c        this only affects two grid levels higher, occurs because
c        previous time step needs boundary vals for giant step.
c  no error estimation on finest possible grid level
c
 60       continue
          if (icheck(level) .ge. kcheck) then
               lbase = level
          else if (level+1 .ge. mxnest) then
               go to 90
          else if (icheck(level+1) .ge. kcheck) then
               lbase = level+1
          else if (level+2 .ge. mxnest) then
               go to 90
          else if (icheck(level+2) .ge. kcheck) then
               lbase = level+2
          else
               go to 90
          endif
          if (lbase .eq. mxnest .or. lbase .gt. lfine) go to 70
c
c regrid level 'lbase+1' up to finest level.
c level 'lbase' stays fixed.
c
          if (rprint) write(outunit,101) lbase
101       format(8h  level ,i5,32h  stays fixed during regridding )

          call system_clock(clock_start,clock_rate)
          call cpu_time(cpu_start)
          debug = .false.
          if (debug) then
              write(*,*)" before regrid lbase ",lbase," time ",
     &                    tlevel(lbase)
              !call valout(lbase+1,lfine,time,nvar,naux)
              call valout(lbase,lfine,time,nvar,naux)
          endif
          call regrid(nvar,lbase,cut,naux,start_time)

          ! output new grids for debugging:
          if (debug)
     .    call valout(lbase+1,lfine,tlevel(lbase+1),nvar,naux)

          if (debug) then
              write(*,*)" after regrid at time ",tlevel(lbase)
              !call valout(lbase+1,lfine,time,nvar,naux)
              call valout(lbase,lfine,time,nvar,naux)
          endif
          call system_clock(clock_finish,clock_rate)
          call cpu_time(cpu_finish)
          timeRegridding = timeRegridding + clock_finish - clock_start
          timeRegriddingCPU=timeRegriddingCPU+cpu_finish-cpu_start

          call setbestsrc()     ! need at every grid change
c         call conck(1,nvar,naux,time,rest)
c         call outtre(lstart(lbase+1),.true.,nvar,naux)
c note negative time to signal regridding output in plots
c         call valout(lbase,lfine,-tlevel(lbase),nvar,naux)
c
c  maybe finest level in existence has changed. reset counters.
c
          if (rprint .and. lbase .lt. lfine) then
             call outtre(lstart(lbase+1),printout,nvar,naux)
          endif
 70       continue
          do 80  i  = lbase, lfine
 80          icheck(i) = 0
          do 81  i  = lbase+1, lfine
 81          tlevel(i) = tlevel(lbase)
c
c          MJB: modified to check level where new grids start, which is lbase+1
          !if (verbosity_regrid.ge.lbase+1) then
          if (.false.) then  ! don't need to print these every time
                 do levnew = lbase+1,lfine
                     write(6,1006) intratx(levnew-1),intraty(levnew-1),
     &                             kratio(levnew-1),levnew
 1006                format('   Refinement ratios...  in x:', i3, 
     &                 '  in y:',i3,'  in t:',i3,' for level ',i4)
                 end do

              endif

c  ------- done regridding --------------------
c
c integrate all grids at level 'level'.
c
 90       continue

          ! Only compute the mininum of fg%levelmax if necessary,
          ! and only once per time step on each level, not on each patch:
          do ifg=1,FG_num_fgrids
              fg => FG_fgrids(ifg)
              if (fg%min_level_check == mxnest) then
                  fg%min_levelmax_checked = mxnest
                else
                  fg%min_levelmax_checked = minval(fg%levelmax)
                endif
                enddo
c 
c         ! time after step:
          timenew = tlevel(level)+possk(level)

          ! is it time to update fgmax grids on any level?
          ! if so, set fg%update_now(level) to .true.
          do ifg=1,FG_num_fgrids
              fg => FG_fgrids(ifg)
              if ((timenew >= fg%tstart_max) .and. 
     &            (timenew <= fg%tend_max) .and.
     &            (timenew >= fg%t_last_updated(level)  
     &                         + fg%dt_check) .and.
     &            (level >= fg%min_level_check) .and.
     &            (level >= fg%min_levelmax_checked)) then 

                      fg%update_now(level) = .true.
                      fg%t_last_updated(level) = timenew
                      !write(6,660) level, timenew
 660                  format('+++ update fgmax on level ',i1,
     &                       ' at t = ',f12.2)
              else
                      fg%update_now(level) = .false.
                      endif
              enddo


          call advanc(level,nvar,dtlevnew,vtime,naux)


c Output time info
          timenew = tlevel(level)+possk(level)
          time_format = "(' AMRCLAW: level ',i2,'  CFL = ',e8.3," //
     &                  "'  dt = ',e10.4,  '  final t = ',e12.6)"
          if (display_landfall_time) then
c           Convert time to days            
            timenew = timenew / (3.6d3 * 24d0)
            time_format = "(' AMRCLAW: level ',i2,'  CFL = ',e8.3," //
     &                  "'  dt = ',e10.4,  '  final t = ', f5.2)"
          end if
          if (tprint) then
              write(outunit, time_format) level, cfl_level, 
     &                                    possk(level), timenew
          endif
          if (method(4).ge.level) then
              print time_format, level, cfl_level, possk(level), timenew
          endif

c        # to debug individual grid updates...
c        call valout(level,level,time,nvar,naux)
c
c done with a level of integration. update counts, decide who next.
c
          ntogo(level)  = ntogo(level) - 1
          dtnew(level)  = dmin1(dtnew(level),dtlevnew)
          tlevel(level) = tlevel(level) + possk(level)
          icheck(level) = icheck(level) + 1
c
          if (level .lt. lfine) then
             level = level + 1
c            #  check if should adjust finer grid time step to start wtih
             if (((possk(level-1) - dtnew(level-1))/dtnew(level-1)) .gt.
     .            .05) then
                dttemp = dtnew(level-1)/kratio(level-1)
                ntogo(level) = (tlevel(level-1)-tlevel(level))/dttemp+.9
              else
                ntogo(level) = kratio(level-1)
              endif
             possk(level) = possk(level-1)/ntogo(level)
             go to 60
          endif

c         write(6,*) '+++ in tick, done with level',level,
c    &               ' tlevel = ',tlevel(1:level)

c         When we reach here, we are done with grid patches at 
c         the finest level with grids present at this time

c     ---- fgout output ----
c     This used to be done in stepgrid.f, but only needs to be done
c     after all patches at finest level have been advanced.

      tc0 = tlevel(level)  ! current time on finest level present
      !write(6,*) '+++ tick: tc0 = ',tc0
      
      do ng=1,FGOUT_num_grids
        fgout => FGOUT_fgrids(ng)
        
        do ioutfg=1,fgout%num_output
            if (fgout%output_frames(ioutfg) == -1) then
                ! this time not yet written out
                if (fgout%output_times(ioutfg) < 
     &                 tc0+FGOUT_ttol) then
                     toutfg = fgout%output_times(ioutfg)
c                     write(6,*) '+++ tick call fgrid_out, frame, t: ',
c     &                          ioutfg,toutfg
                     call fgout_write(fgout,toutfg,ioutfg)
                     fgout%output_frames(ioutfg) = ioutfg
                     fgout%next_output_index = ioutfg+1
                endif
            endif
        enddo
      enddo
c     ---- end fgout output ----
c
 105      if (level .eq. 1) go to 110
              if (ntogo(level) .gt. 0) then
c                same level goes again. check for ok time step
 106             if ((possk(level)-dtnew(level))/dtnew(level)
     .                .gt. .05)  then

                    write(6,601) level, time
 601                format(" ***adjusting timestep for level ", i3,
     &                     " at t = ",d16.6)
                    print *,"    old ntogo dt",ntogo(level),possk(level)

c                   adjust time steps for this and finer levels

                    ! try computing ntogo properly (worked better in BoussDev)
                    ! (old way was to repeatedly increment by 1)
                    new_ntogo = ceiling(((tlevel(level-1)
     &                              -tlevel(level)) / dtnew(level)))
                    new_ntogo = min(new_ntogo, ntogo(level)+10)
                    ntogo(level) = new_ntogo
                    possk(level) = (tlevel(level-1)-tlevel(level))
     &                             / ntogo(level)
                    write(*,*) "    NEW ntogo dt ",ntogo(level),
     &                         possk(level)
                    if (varRefTime) then
                      kratio(level-1) = ceiling(possk(level-1)
     &                                  / possk(level))
                    endif

                    go to 106
                 endif

                 if (ntogo(level) .gt. 100) then
                     write(6,*) "**** Too many dt reductions ****"
                     write(6,*) "**** Stopping calculation   ****"
                     write(6,*) "**** ntogo = ",ntogo(level)
                     write(6,1006) intratx(level-1),intraty(level-1),
     &                             kratio(level-1),level
 603                 format("**** Writing extra output frames for ",
     &                      "debugging at level-1 =",i3,
     &                      " and level =",i3)
                     write(6,603) level-1, level
                     if (num_gauges .gt. 0) then
                        do ii = 1, num_gauges
                           call print_gauges_and_reset_nextLoc(ii)
                        end do
                     endif
                     call valout(level-1,level-1,tlevel(level-1),
     &                           nvar,naux)                       
                     call valout(level,level,tlevel(level),nvar,naux)
                     !call outtre(lstart(level),.true.,nvar,naux)
                     stop
                 endif

                 go to 60
              else
                 level = level - 1
                 call system_clock(clock_start,clock_rate)
                 call update(level,nvar,naux)
                 call system_clock(clock_finish,clock_rate)
                 timeUpdating=timeUpdating+clock_finish-clock_start
              endif
          go to 105
c
c  --------------one complete coarse grid integration cycle done. -----
c
c      time for output?  done with the whole thing?
c
 110      continue
          time    = time   + possk(1)
          ncycle  = ncycle + 1
          call conck(1,nvar,naux,time,rest)


      if ( .not.vtime) goto 201

        ! Adjust time steps if variable time step and/or variable
        ! refinement ratios in time
        if (.not. varRefTime) then
          ! find new dt for next cycle (passed back from integration routine).
           do 115 i = 2, lfine
             ii = lfine+1-i
             dtnew(ii) = min(dtnew(ii),dtnew(ii+1)*kratio(ii))
 115       continue
           possk(1) = dtnew(1)
           do 120 i = 2, mxnest
 120         possk(i) = possk(i-1) / kratio(i-1)
        else  ! since refinement ratio in time can change need to set new timesteps in different order
c             ! use same alg. as when setting refinement when first make new fine grids
          dtnew(1) = min(dtnew(1),dt_max)
          if ((num_dtopo>0).and.(topo_finalized.eqv..false.)) then
              dtnew(1) = min(dtnew(1),dt_max_dtopo)
          endif

          possk(1) = dtnew(1)
          do 125 i = 2, lfine
             if (dtnew(i)  .gt. possk(i-1)) then
               kratio(i-1) = 1  ! cant have larger timestep than parent level
               possk(i)    = possk(i-1)
            else
               kratio(i-1) = ceiling(possk(i-1)/dtnew(i))  ! round up for stable integer ratio
               possk(i)    = possk(i-1)/kratio(i-1)        ! set exact timestep on this level
           endif
 125    continue


      endif

 201  if ((abs(checkpt_style).eq.3 .and. 
     &      mod(ncycle,checkpt_interval).eq.0) .or. dumpchk) then
               if (num_gauges .gt. 0) then
                  do ii = 1, num_gauges
                     call print_gauges_and_reset_nextLoc(ii)
                  end do
               endif
               call check(ncycle,time,nvar,naux)
               dumpchk = .true.
       endif

       if ((mod(ncycle,iout).eq.0) .or. dumpout) then
         call valout(1,lfine,time,nvar,naux)
         if (abs(checkpt_style).eq.4) then
            call check(ncycle,time,nvar,naux)
            dumpchk = .true.
         endif
         if (printout) call outtre(mstart,.true.,nvar,naux)
         if (num_gauges .gt. 0) then
            do ii = 1, num_gauges
               call print_gauges_and_reset_nextLoc(ii)
            end do
         endif
       endif

       ! new STOP feature to do immediate checkpt and exit
       inquire(FILE="STOP",exist=stopFound) 
          if (stopFound) then
          write(*,*)"STOP file found. Checkpointing and Stopping"
          write(*,*)"REMEMBER to remove file before restarting"
          write(outunit,*)"STOP file found. Checkpointing and Stopping"
          write(outunit,*)"REMEMBER to remove file before restarting"
          call check(ncycle,time,nvar,naux)
          stop
       endif

      go to 20
c
999   continue

c
c  # computation is complete to final time or requested number of steps
c
       if (ncycle .ge. nstop .and. tfinal .lt. rinfinity) then
c         # warn the user that calculation finished prematurely
          write(outunit,102) nstop
          write(6,102) nstop
  102     format('*** Computation halted after nv(1) = ',i8,
     &           '  steps on coarse grid')
          endif
c
c  # final output (unless we just did it above)
c
      dump_final = ((iout.lt.iinfinity) .and. (mod(ncycle,iout).ne.0))
      if (.not. dumpout) then
          if (nout > 0) then
              dump_final = (tout(nout).eq.tfinal)
              endif
          endif
      
      if (dump_final) then
           call valout(1,lfine,time,nvar,naux)
           if (printout) call outtre(mstart,.true.,nvar,naux)
           if (num_gauges .gt. 0) then
              do ii = 1, num_gauges
                 call print_gauges_and_reset_nextLoc(ii)
              end do
           endif
           dumpout = .true.
      endif

c  # checkpoint everything for possible future restart
c  # (unless we just did it based on dumpchk)
c
      call system_clock(tick_clock_finish,tick_clock_rate)
      call cpu_time(tick_cpu_finish)
      timeTick = timeTick + tick_clock_finish - tick_clock_start 
      timeTickCPU = timeTickCPU + tick_cpu_finish - tick_cpu_start 


c  # checkpoint everything for possible future restart
c  # (unless we just did it based on dumpchk)
c
      ! write gauges first in case lagrangian gauge x,y needed by check         
      if (num_gauges .gt. 0) then
         if (.not. dumpout) then
             ! normally this was done already, unless nout = 0
             do ii = 1, num_gauges
                call print_gauges_and_reset_nextLoc(ii)
             end do
         endif
      endif
      
      if (checkpt_style .ne. 0) then  ! want a chckpt
         ! check if just did it so dont do it twice
         if (.not. dumpchk) call check(ncycle,time,nvar,naux)
      endif

      write(6,*) "Done integrating to time ",time
      return
      end

c
c  ----------------------------------------------------------
c
      subroutine domain (nvar,vtime,nx,naux,start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      logical    vtime

c
c  allocate initial coarse grid domain. set node info & initialize grid
c  initial space and time step set here too
c
      mstart = nodget()
c
c code assumes in many places that lower left corner at (0)
c this initial code sets the domain
c if it is too large, birect will chop it up into several pieces
c
      rnode(cornxlo,mstart)   = xlower
      rnode(cornxhi,mstart)   = xupper
      node(nestlevel,mstart) = 1
      node(levelptr,mstart)  = 0
      lstart(1) = mstart

      if (flag_richardson) then
      if (((nx/2)*2 .ne. nx)) then
         write(outunit,*)" must have even number of cells"
         write(*,*)      " must have even number of cells"
         stop
      endif
      endif

      node(ndilo,mstart) = 0
      node(ndihi,mstart) = nx-1

      lfine = 1
      call  birect(mstart)
      call  ginit (mstart, .true., nvar, naux, start_time)
c
c  compute number of grids at level 1 (may have been bi-rected above)
c  needs to be done here since this is used when calling advanc for
c  parallelization
      ngrids = 0
      ncells = 0
       mptr = lstart(1)
       do while (mptr .gt. 0)
          ngrids = ngrids + 1
          ncells = ncells + (node(ndihi,mptr)-node(ndilo,mptr)+1)
          mptr = node(levelptr, mptr)
       end do
       numgrids(1) = ngrids
       numcells(1) = ncells
       avenumgrids(1) = avenumgrids(1) + ngrids
       iregridcount(1) = 1
       if (ngrids .gt. 1) call arrangeGrids(1,ngrids)

       write(*,100) ngrids,ncells
 100   format("there are ",i4," grids with ",i8," cells at level   1")

c      set lbase to 1 here, to put domain 1 grids in lsit
c      once and for all.  Only here, this once, (and if restarting)
c      does listStart have to be set outside of makeGridList
c      but call it with lbase 0 to make grid 1
       listStart(1) = 1
       call makeGridList(0)
       call makeBndryList(1)  ! 1 means level 1
c
c  set stable initial time step using coarse grid data
c
      if (vtime) then
         mptr = lstart(1)
         dx   = hxposs(1)
         dt   = possk(1)
         dtgrid = dt
 60           mitot = node(ndihi,mptr)-node(ndilo,mptr) + 1 + 2*nghost
              locaux = node(storeaux,mptr)
c             # added cfl to call to estdt so call.i isnt needed in estdt:
              call estdt(alloc(node(store1,mptr)),mitot,nvar,
     1                   dx,dtgrid,nghost,alloc(locaux),naux,cfl)
              dt = dmin1(dt,dtgrid)
              mptr   = node(levelptr,mptr)
            if (mptr .ne. 0) go to 60
         possk(1) = dt
      endif
c
c set rest of possk array for refined timesteps
c
      iregsz(1) = nx
      iregst(1) = 0
      iregend(1) = nx-1
      do 70 level = 2, mxnest
         iregsz(level) = iregsz(level-1) * intratx(level-1)
         possk(level)  = possk(level-1)/dble(kratio(level-1))
 70   continue
c
      return
      end

subroutine DMPFOR(a, nx, ny, nz)

    implicit none
    integer, intent(in) :: nx, ny, nz
    double precision, intent(in) :: a(1:nx,1:ny ,1:nz)
    
    integer :: i,j,k
    print *, "Dump from inside fortran routine. Following fortran memory layout"
    do k = 1,nz
        print *, "k=", k
        do j = 1,ny
            print *, "    j=", j
            
            print *, a(:,j,k)
        
        
        enddo
    enddo

end subroutine DMPFOR

program dmpfor_test
    print *, "inside main"

end program dmpfor_test

! ==============================================================
subroutine evec(maxnx,num_eqn,num_ghost,mx,q,auxl,auxr,evl,evr)
! ==============================================================
!
!	Calculation of left and right eigenvectors
!
!   On input, q contains the cell average state vector
!             maxnx contains the number of physical points 
!               (without ghost cells)
!             num_ghost is the number of ghost cells
!             num_eqn the number of equations 
!
!   On output, evl(i) and evr(i) contain left/right eigenvectors
!   at interface i-1/2


    implicit double precision (a-h,o-z)
    integer,          intent(in) :: maxnx, num_eqn, num_ghost, mx
    double precision, intent(in) :: q(num_eqn,maxnx+2*num_ghost)
    double precision, intent(out) :: evl(num_eqn,num_eqn,maxnx+2*num_ghost)
    double precision, intent(out) :: evr(num_eqn,num_eqn,maxnx+2*num_ghost)

!   local storage
!   ---------------
    common /cparam/ gamma
    integer :: mx2

    mx2 = size(q,2)

    gamma1 = gamma - 1.d0

    do i=2,mx2
        ! Compute velocity, speed and enthalpy
        rhsqrtl = dsqrt(q(1,i-1))
        rhsqrtr = dsqrt(q(1,i  ))
        pl = gamma1*(q(3,i-1) - 0.5d0*(q(2,i-1)**2)/q(1,i-1))
        pr = gamma1*(q(3,i  ) - 0.5d0*(q(2,i  )**2)/q(1,i  ))
        rhsq2 = rhsqrtl + rhsqrtr
        u = (q(2,i-1)/rhsqrtl + q(2,i)/rhsqrtr) / rhsq2
        enth = (((q(3,i-1)+pl)/rhsqrtl + (q(3,i)+pr)/rhsqrtr)) / rhsq2
        c2 = gamma1*(enth - 0.5d0*u**2)
        c = dsqrt(c2)

        ! Construct matrix of right eigenvectors
        !      _                     _ 
        !     |                       |
        !     |   1      1       1    |
        !     |                       |
        ! R = |  u-c     u      u+c   |
        !     |                       |
        !     |  H-uc   u^2/2   H+uc  |
        !     |_                     _|

        evr(1,1,i) = 1.d0 
        evr(2,1,i) = u - c
        evr(3,1,i) = enth - u*c

        evr(1,2,i) = 1.d0 
        evr(2,2,i) = u 
        evr(3,2,i) = 0.5d0*u**2

        evr(1,3,i) = 1.d0 
        evr(2,3,i) = u + c
        evr(3,3,i) = enth + u*c

        ! Construct matrix of left eigenvectors
        !
        ! gamma1 = gamma - 1
        !                          _                                       _ 
        !                         |                                         |
        !                         |  uc/gamma1+u^2/2    -c/gamma1-u     1   |
        !                         |                                         |
        ! R^{-1} =  gamma1/(2c^2) |  2(H-u^2)           2u             -2   |
        !                         |                                         |
        !                         |  -uc/gamma1+u^2/2   c/gamma1-u      1   |
        !                         |_                                       _|

        alpha = 0.5d0 * gamma1 / c**2

        evl(1,1,i) = (c*u/gamma1 + 0.5d0*u**2) * alpha
        evl(2,1,i) = 2.d0*(enth-u**2) * alpha
        evl(3,1,i) = (-c*u/gamma1 + 0.5d0*u**2) * alpha

        evl(1,2,i) = -(c/gamma1 + u) * alpha
        evl(2,2,i) = 2.d0*u * alpha
        evl(3,2,i) = (c/gamma1 - u) * alpha

        evl(1,3,i) = alpha
        evl(2,3,i) = -2.d0 * alpha
        evl(3,3,i) = alpha

    enddo

    return
end subroutine evec

c
c ---------------------------------------------------
c
       subroutine coarsen(valdub,midub,mjdub,valbgc,mi2tot,mj2tot,nvar)
      
       implicit double precision (a-h, o-z)

       dimension  valdub(nvar,midub, mjdub)
       dimension  valbgc(nvar,mi2tot,mj2tot)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
!> coarsen the fine grid data (with double the usual
!! number of ghost cells to prepare coarsened
!! grid for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       do j = 1, mj2tot

         jfine = 2*(j-1) + 1

         do i = 1, mi2tot
            ifine = 2*(i-1) + 1

           do ivar = 1, nvar
  
             valbgc(ivar,i,j) = (valdub(ivar,ifine,jfine) +
     &                           valdub(ivar,ifine+1,jfine)+
     &                           valdub(ivar,ifine,jfine+1) +
     &                           valdub(ivar,ifine+1,jfine+1))/4.d0
           end do
         end do
       end do

       return
       end

program test_rp1

    use rp1_driver, only: call_rp1

    implicit none

    integer, parameter :: meqn = 2
    integer, parameter :: mwaves = 2
    real(kind=8) ::   q_left(meqn)
    real(kind=8) ::   q_right(meqn)
    real(kind=8) ::    s(mwaves)
    real(kind=8) :: wave(meqn,   mwaves)
    real(kind=8) ::  apdq(meqn)
    real(kind=8) ::  amdq(meqn)
    integer :: i, m, mw

    real(kind=8) :: rho,bulk,cc,zz
    common /cparam/ rho,bulk,cc,zz
    rho = 1.d0
    bulk = 1.d0
    cc = sqrt(bulk/rho)
    zz = rho*cc


    write(6,61) meqn
 61 format('Need to input meqn = ',i3,'  values for each state')
    write(6,*) 'input q_left:'
    read(5,*) (q_left(i), i=1,meqn)
    write(6,*) 'input q_right:'
    read(5,*) (q_right(i), i=1,meqn)

    call call_rp1(meqn,mwaves,q_left,q_right,wave,s,amdq,apdq)



    print *, 'speeds:'
    write(6,60) (s(mw), mw=1,mwaves)
60  format(6d16.6)

    print *, 'waves:'
    do m=1,meqn
        write(6,60) (wave(m,mw), mw=1,mwaves)
        enddo

    print *, 'amdq and apdq:'
    do m=1,meqn
        write(6,60) amdq(m), apdq(m)
        enddo


end program test_rp1

! ===================================================================
subroutine step1(num_eqn,num_waves,num_ghost,num_aux,mx,q,aux,dx,dt, &
                method,mthlim,cfl,f,wave,s,amdq,apdq,dtdx,use_fwave,rp1)
! ===================================================================

! Take one time step, updating q.

! method(1) = 1   ==>  Godunov method
! method(1) = 2   ==>  Slope limiter method
! mthlim(p)  controls what limiter is used in the pth family

! amdq, apdq, wave, s, and f are used locally:

! amdq(1-num_ghost:mx+num_ghost, num_eqn) = left-going flux-differences
! apdq(1-num_ghost:mx+num_ghost, num_eqn) = right-going flux-differences
!        e.g. amdq(m,i) = m'th component of A^- \Delta q from i'th Riemann
!                         problem (between cells i-1 and i).

! wave(1-num_ghost:mx+num_ghost, num_eqn, num_waves) = waves from solution of
!                                           Riemann problems,
! wave(m,mw,i) = mth component of jump in q across wave in family mw in Riemann
!                   problem between states i-1 and i.

! s(1-num_ghost:mx+num_ghost, num_waves) = wave speeds,
! s(m,iw) = speed of wave in family mw in Riemann problem between states i-1 and i.

! f(1-num_ghost:mx+num_ghost, num_eqn) = correction fluxes for second order method
! f(m,i) = mth component of flux at left edge of ith cell
! --------------------------------------------------------------------

    implicit double precision (a-h,o-z)
    double precision :: q(num_eqn,1-num_ghost:mx+num_ghost)
    double precision :: aux(num_aux,1-num_ghost:mx+num_ghost)
    double precision :: f(num_eqn,1-num_ghost:mx+num_ghost)
    double precision :: s(num_waves,1-num_ghost:mx+num_ghost)
    double precision :: wave(num_eqn, num_waves,1-num_ghost:mx+num_ghost)
    double precision :: amdq(num_eqn,1-num_ghost:mx+num_ghost)
    double precision :: apdq(num_eqn,1-num_ghost:mx+num_ghost)
    double precision :: dtdx(1-num_ghost:mx+num_ghost)
    integer ::          method(7),mthlim(num_waves)
    logical ::          use_fwave
    logical :: limit
    external :: rp1

!f2py intent(in,out) q
!f2py intent(out) cfl
!f2py intent(in) num_eqn
!f2py intent(in) num_ghost
!f2py intent(in) mx
!f2py optional f, amdq, apdq, dtdx, s, wave


    ! check if any limiters are used:
    limit = .false.
    do mw=1,num_waves
        if (mthlim(mw) > 0) limit = .TRUE. 
    end do

    index_capa = method(6)
    do i=1-num_ghost,mx+num_ghost
        if (index_capa > 0) then
            if (aux(index_capa,i) <= 0.d0) then
                write(6,*) 'Error -- capa must be positive'
                stop
            endif
            dtdx(i) = dt / (dx*aux(index_capa,i))
        else
            dtdx(i) = dt/dx
        endif
    end do



    ! solve Riemann problem at each interface
    ! -----------------------------------------

    call rp1(mx,num_eqn,num_waves,num_aux,num_ghost,mx,q,q,aux,aux,wave, &
    s,amdq,apdq)

    ! Modify q for Godunov update:
    ! Note this may not correspond to a conservative flux-differencing
    ! for equations not in conservation form.  It is conservative if
    ! amdq + apdq = f(q(i)) - f(q(i-1)).

    forall(i=1:mx+1, m=1:num_eqn)
        q(m,i) = q(m,i) - dtdx(i)*apdq(m,i)
        q(m,i-1) = q(m,i-1) - dtdx(i-1)*amdq(m,i)
    end forall


    ! compute maximum wave speed:
    cfl = 0.d0
    do mw=1,num_waves
        do i=1,mx+1
        ! if s>0 use dtdx(i) to compute CFL,
        ! if s<0 use dtdx(i-1) to compute CFL:
            cfl = dmax1(cfl, dtdx(i)*s(mw,i), -dtdx(i-1)*s(mw,i))
        end do
    end do

    if (method(2) == 1) go to 900

    ! compute correction fluxes for second order q_{xx} terms:
    ! ----------------------------------------------------------

    forall(i=1-num_ghost:mx+num_ghost, m=1:num_eqn)
        f(m,i) = 0.d0
    end forall

    ! apply limiter to waves:
    if (limit) call limiter(mx,num_eqn,num_waves,num_ghost,mx, &
    wave,s,mthlim)

    if (use_fwave.eqv. .FALSE. ) then
        do i=1,mx+1
            do m=1,num_eqn
                do mw=1,num_waves
                    dtdxave = 0.5d0 * (dtdx(i-1) + dtdx(i))
                    f(m,i) = f(m,i) + 0.5d0 * dabs(s(mw,i)) &
                    * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                end do
            end do
        end do
    else
        do i=1,mx+1
            do m=1,num_eqn
                do mw=1,num_waves
                    dtdxave = 0.5d0 * (dtdx(i-1) + dtdx(i))
                    f(m,i) = f(m,i) + 0.5d0 * dsign(1.d0,s(mw,i)) &
                    * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                end do
            end do
        end do
    endif


    ! update q by differencing correction fluxes
    ! ============================================

    ! (Note:  Godunov update has already been performed above)

    forall(i=1:mx+1, m=1:num_eqn)
        q(m,i) = q(m,i) - dtdx(i) * (f(m,i+1) - f(m,i))
    end forall

    900 continue
    return
end subroutine step1

! ==============================================================================
! model_storm_module
!
! Module contains routines for constructing a wind and pressure field based on
! the a parameterized model of the wind and pressure fields.
!
! ==============================================================================
!                   Copyright (C) Clawpack Developers 2017
!  Distributed under the terms of the Berkeley Software Distribution (BSD)
!  license
!                     http://www.opensource.org/licenses/
! ==============================================================================
module model_storm_module

    implicit none
    save

    logical, private :: module_setup = .false.
    logical, private :: DEBUG = .false.

    ! Model storm type definition
    type model_storm_type
        ! Fore/hindcast size and current position
        integer :: num_casts

        ! Landfall - This is not used explicitly (t0 = landfall ideally)
        character(len=10) :: landfall

        ! These parameters are located at time points but are interpolated in
        ! time and space when the relevant fields are requested.

        ! Location of storm
        ! Track is a triplet with (time,longitude,latitude)
        real(kind=8), allocatable :: track(:,:)

        ! Storm parameterization
        real(kind=8), allocatable :: max_wind_radius(:)
        real(kind=8), allocatable :: max_wind_speed(:)
        real(kind=8), allocatable :: central_pressure(:)

        ! This is not always provided and is often determined by the last
        ! closed iso-bar of the storm
        real(kind=8), allocatable :: radius(:)

        ! Approximate velocity of storm, approximated via the track points
        ! using a first order difference on the sphere
        real(kind=8), allocatable :: velocity(:, :)

        ! Approximate pressure change of storm, approximated using first order differences
        real(kind=8), allocatable :: central_pressure_change(:)

    end type model_storm_type

    ! How to deterimine which way a storm should be made to spin
    ! The default defers simply to assuming y is a latitude
    ! Here either an integer or bool can be returned but as implemented 1
    ! refers to the Northern Hemisphere and therefore causes the storm to spin
    ! in a counter-clockwise direction.
    abstract interface
        logical pure function rotation_def(x, y)
            implicit none
            real(kind=8), intent(in) :: x, y
        end function rotation_def
    end interface
    procedure(rotation_def), pointer :: rotation

    ! Interal tracking variables for storm
    integer, private :: last_storm_index

    ! Atmospheric boundary layer, input variable in ADCIRC but always is
    ! set to the following value
    real(kind=8), parameter :: atmos_boundary_layer = 0.9d0

    ! Sampling adjustment from 1 min to 10 min winds
    real(kind=8), parameter :: sampling_time = 0.88d0

    ! Storm field ramping width - Represents crudely the ramping radial area
    real(kind=8), parameter :: RAMP_WIDTH = 100.0d3

    ! Time tracking tolerance allowance - allows for the beginning of the storm
    ! track to be close to but not equal the start time of the simulation
    real(kind=8), parameter :: TRACKING_TOLERANCE = 1d-10

contains


    ! Setup routine for model storms
    subroutine set_storm(storm_data_path, storm, storm_spec_type, log_unit)

        use geoclaw_module, only: deg2rad, spherical_distance, coordinate_system
        use amr_module, only: t0, rinfinity

        implicit none

        ! Subroutine I/O
        character(len=*), optional :: storm_data_path
        type(model_storm_type), intent(inout) :: storm
        integer, intent(in) :: storm_spec_type, log_unit

        ! Local storage
        integer, parameter :: data_file = 701
        integer :: i, k, io_status
        real(kind=8) :: x(2), y(2), ds, dt

        if (.not. module_setup) then

            ! Open data file
            print *,'Reading storm date file ', storm_data_path
            open(unit=data_file, file=storm_data_path, status='old',        &
                 action='read', iostat=io_status)
            if (io_status /= 0) then
                print *, "Error opening storm data file. status = ", io_status
                stop
            endif

            read(data_file, "(i4)") storm%num_casts
            read(data_file, "(a)") storm%landfall
            read(data_file, *)

            write(log_unit, "('Data length = ',i3)") storm%num_casts

            ! Allocate storm parameter file variables
            allocate(storm%track(3, storm%num_casts))
            allocate(storm%max_wind_speed(storm%num_casts))
            allocate(storm%max_wind_radius(storm%num_casts))
            allocate(storm%central_pressure(storm%num_casts))
            allocate(storm%radius(storm%num_casts))

            ! Now read in the storm data - note that the units are expected to
            ! be consistent with:
            ! max_wind_speed = m/s
            ! max_wind_radius = m
            ! central_pressure = Pa
            ! radius = m
            do i=1, storm%num_casts
                read(data_file, *) storm%track(:, i), &
                                   storm%max_wind_speed(i), &
                                   storm%max_wind_radius(i), &
                                   storm%central_pressure(i), &
                                   storm%radius(i)
            enddo

            ! Calculate storm speed
            allocate(storm%velocity(2, storm%num_casts))
            do i=1,storm%num_casts - 1
                ! Calculate velocity based on great circle distance between

                ! locations of storm
                x = storm%track(2:3,i)
                y = storm%track(2:3,i+1)

                dt = storm%track(1,i + 1) - storm%track(1,i)

                if (coordinate_system == 2) then
                    ds = spherical_distance(x(1), 0.5d0 * (x(2) + y(2)), &
                                            y(1), 0.5d0 * (x(2) + y(2)))
                    storm%velocity(1,i) = sign(ds / dt, y(1) - x(1))

                    ds = spherical_distance(0.5d0 * (x(1) + y(1)), x(2), &
                                            0.5d0 * (x(1) + y(1)), y(2))
                    storm%velocity(2, i) = sign(ds / dt, y(2) - x(2))
                else
                    storm%velocity(1, i) = (y(1) - x(1)) / dt
                    storm%velocity(2, i) = (y(2) - x(2)) / dt
                end if
            end do

            ! Use last approximation for velocity point going forward
            storm%velocity(:, storm%num_casts) = storm%velocity(:,  &
                                                            storm%num_casts - 1)

            ! Calculate central pressure change
            allocate(storm%central_pressure_change(storm%num_casts))
            do i=1,storm%num_casts - 1
                ds = storm%central_pressure(i + 1) - storm%central_pressure(i)
                dt = storm%track(1,i + 1) - storm%track(1,i)
                storm%central_pressure_change(i) = ds / dt
            end do
            storm%central_pressure_change(storm%num_casts) = &
                storm%central_pressure_change(storm%num_casts - 1)

            if (t0 - storm%tracK(1, 1) < -TRACKING_TOLERANCE) then
                print *, "Start time", t0, " is outside of the tracking"
                print *, "tolerance range with the track start"
                print *, storm%track(1, 1), "."
                stop
            endif

            ! This is used to speed up searching for correct storm data
            last_storm_index = 2
            last_storm_index = storm_index(t0, storm)
            if (last_storm_index == -1) then
                print *,"Forecast not found for time ",t0,'.'
                stop
            endif

            ! Log everything to the surge log file
            write(log_unit,*) ""
            write(log_unit,*) "Storm Track and Strength"
            write(log_unit,*) ""
            do i=1, storm%num_casts
                write(log_unit,"(8e26.16)") (storm%track(k,i),k=1,3),  &
                                            (storm%velocity(k,i),k=1,2), &
                                             storm%max_wind_radius(i), &
                                             storm%max_wind_speed(i),  &
                                             storm%central_pressure(i)
            enddo

            module_setup = .true.
        end if

    end subroutine set_storm

    ! ==========================================================================
    !  storm_location(t,storm)
    !    Interpolate location of hurricane in the current time interval
    ! ==========================================================================
    function storm_location(t, storm) result(location)

        implicit none

        ! Input
        real(kind=8), intent(in) :: t
        type(model_storm_type), intent(in out) :: storm

        ! Output
        real(kind=8) :: location(2)

        ! Junk storage
        real(kind=8) :: junk(7)

        call get_storm_data(t, storm, location,                 &
                            junk(1:2), junk(3), junk(4), junk(5), junk(6), junk(7))

    end function storm_location

    ! ==========================================================================
    !  storm_direction
    !   Angle off of due north that the storm is traveling
    ! ==========================================================================
    real(kind=8) function storm_direction(t, storm) result(theta)

        implicit none

        ! Input
        real(kind=8), intent(in) :: t
        type(model_storm_type), intent(in) :: storm

        ! Locals
        real(kind=8) :: junk(7), velocity(2)

        ! Fetch velocity of storm which has direction encoded in it
        call get_storm_data(t, storm, junk(1:2), velocity, junk(3), junk(4),   &
                            junk(5), junk(6), junk(7))

        ! Unit directional vector
        theta = atan2(velocity(2),velocity(1))

    end function storm_direction

    ! ==========================================================================
    ! set_pressure
    !   Set pressure at a radius r
    ! ==========================================================================
    real(kind=8) pure function set_pressure(Pc, r, dp, mwr, B) result(pres)
        implicit none

        real(kind=8), intent(in) :: Pc, r, dp, mwr, B

        ! for any situation that could raise an underflow error, we set the
        ! second term to 0
        if ((mwr / r)**B > 100) then
            pres = Pc
        else
            pres = Pc + dp * exp(-(mwr / r)**B)
        endif

    end function set_pressure

    ! ==========================================================================
    !  storm_index(t,storm)
    !    Finds the index of the next storm data point
    ! ==========================================================================
    integer pure function storm_index(t, storm) result(index)

        implicit none

        ! Input
        real(kind=8), intent(in) :: t
        type(model_storm_type), intent(in) :: storm

        ! Locals
        real(kind=8) :: t0,t1
        logical :: found

        ! Figure out where we are relative to the last time we checked for the
        ! index (stored in last_storm_index)

        ! Check if we are already beyond the end of the last forecast time
        if (last_storm_index == storm%num_casts + 1) then
            index = storm%num_casts + 1
        else
            t0 = storm%track(1,last_storm_index - 1)
            t1 = storm%track(1,last_storm_index)

            ! Check to see if we are close enough to the current index to just
            ! use that, tolerance is based on TRACKING_TOLERANCE
            if ((abs(t0 - t) < TRACKING_TOLERANCE) .or.   &
                (abs(t1 - t) < TRACKING_TOLERANCE) .or.   &
                (t0 < t .and. t < t1)) then

                index = last_storm_index
            else if ( t1 < t ) then
                found = .false.
                do index=last_storm_index+1,storm%num_casts
                    if (t < storm%track(1,index)) then
                        found = .true.
                        exit
                    endif
                enddo
                ! Assume we have gone past last forecast time
                if (.not. found) then
                    index = storm%num_casts + 1
                endif
            else
                ! Fail gracefully
                if (last_storm_index == 2) then
                    index = -1
                else
                    do index=last_storm_index-1,2,-1
                        if (storm%track(1,index-1) < t) exit
                    enddo
                endif
            endif
        endif

    end function storm_index


    ! ==========================================================================
    !  get_storm_data()
    !    Interpolates in time and returns storm data.
    ! ==========================================================================
    subroutine get_storm_data(t, storm, location, velocity, max_wind_radius,  &
                              max_wind_speed, central_pressure,               &
                              radius, central_pressure_change)

        use geoclaw_module, only: deg2rad, latlon2xy, xy2latlon, coordinate_system

        implicit none

        ! Input
        real(kind=8), intent(in) :: t                 ! Current time
        type(model_storm_type), intent(in) :: storm   ! Storm

        ! Output
        real(kind=8), intent(out) :: location(2), velocity(2)
        real(kind=8), intent(out) :: max_wind_radius, max_wind_speed
        real(kind=8), intent(out) :: central_pressure, radius, central_pressure_change

        ! Local
        real(kind=8) :: fn(9), fnm(9), weight, tn, tnm, x(2)
        integer :: i

        ! Increment storm data index if needed and not at end of forecast
        i = storm_index(t,storm)
        last_storm_index = i

        ! List of possible error conditions
        if (i <= 1) then
            if (i == 0) then
                print *,"Invalid storm forecast requested for t = ",t
                print *,"Time requested is before any forecast data."
                print *,"    first time = ",storm%track(1,1)
                print *,"   ERROR = ",i
                stop
            else if (i > storm%num_casts + 2) then
                print *,"Invalid storm indexing, i > num_casts + 2..."
                print *,"This really should not happen, what have you done?"
                stop
            endif
        endif

        ! Interpolate in time for all parameters
        if (i == storm%num_casts + 1) then
            i = i - 1
            ! At last forecast, use last data for storm strength parameters and
            ! velocity, location uses last velocity and constant motion forward

            ! Convert coordinates temporarily to meters so that we can use
            ! the pre-calculated m/s velocities from before
            if (coordinate_system == 2) then
                x = latlon2xy(storm%track(2:3,i),storm%track(2:3,i))
                x = x + (t - storm%track(1,i)) * storm%velocity(:,i)
                fn = [xy2latlon(x,storm%track(2:3,i)), &
                      storm%velocity(:,i), storm%max_wind_radius(i), &
                      storm%max_wind_speed(i), storm%central_pressure(i), &
                      storm%radius(i), storm%central_pressure_change(i)]
            else
                x = x + (t - storm%track(1,i)) * storm%velocity(:,i)
                fn = [x, &
                      storm%velocity(:,i), storm%max_wind_radius(i), &
                      storm%max_wind_speed(i), storm%central_pressure(i), &
                      storm%radius(i), storm%central_pressure_change(i)]
            end if
        else
            ! Inbetween two forecast time points (the function storm_index
            ! ensures that we are not before the first data point, i.e. i > 1)
            tn = storm%track(1,i)
            tnm = storm%track(1,i-1)
            weight = (t - tnm) / (tn - tnm)
            fn = [storm%track(2:3,i),storm%velocity(:,i), &
                  storm%max_wind_radius(i),storm%max_wind_speed(i), &
                  storm%central_pressure(i), storm%radius(i), &
                  storm%central_pressure_change(i)]
            fnm = [storm%track(2:3,i - 1),storm%velocity(:,i - 1), &
                   storm%max_wind_radius(i - 1),storm%max_wind_speed(i - 1), &
                   storm%central_pressure(i - 1), storm%radius(i - 1), &
                   storm%central_pressure_change(i - 1)]
            fn = weight * (fn - fnm) + fnm
        endif

        ! Set output variables
        location = fn(1:2)
        velocity = fn(3:4)
        max_wind_radius = fn(5)
        max_wind_speed = fn(6)
        central_pressure = fn(7)
        radius = fn(8)
        central_pressure_change = fn(9)

    end subroutine get_storm_data


    ! ==========================================================================
    ! A set of common functions applied before calculating the circular component of
    ! wind speed using a particular wind model.

    ! 1. Adjust max wind speed by removing translational speed (bounding at 0).

    ! 2. If specified, convert surface winds to PBL winds
    ! ==========================================================================

    pure subroutine adjust_max_wind(tv, mws, mod_mws, convert_height)

        real (kind=8), intent(inout) :: tv(2)
        real (kind=8), intent(in) :: mws
        logical, intent(in) :: convert_height
        real (kind=8), intent(out) :: mod_mws

        real (kind=8) :: trans_speed, trans_mod

        trans_speed = sqrt(tv(1)**2 + tv(2)**2)
        mod_mws = mws - trans_speed

        ! Bound this at 0
        if (mod_mws < 0) then
            trans_mod = mws / trans_speed
            tv = tv * trans_mod
            mod_mws = 0
        end if

        ! Convert wind speed (10 m) to top of atmospheric boundary layer
        if (convert_height) mod_mws = mod_mws / atmos_boundary_layer

    end subroutine adjust_max_wind


    ! ==========================================================================
    ! A set of common functions applied after the circular component of wind speed
    ! has been calculated given a particular wind model:

    ! 1. Determine translation speed that should be added to final storm wind speed.
    !    This is tapered to zero as the storm wind tapers to zero toward the eye of the
    !    storm and at long distances from the storm. Avoid divide-by-0 error

    ! 2. If specified, convert wind velocity from top of atmospheric boundary layer to
    !    wind velocity at 10 m above the earth's surface.

    ! 3. Convert from 1 minute averaged winds to 10 minute averaged winds

    ! 4. Add back in translational velocity

    ! 5. Apply distance ramp to limit scope
    ! ==========================================================================
    pure subroutine post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
        wind_index, pressure_index, r, radius, tv, mod_mws, theta, convert_height, &
        n_hemisphere)

        use geoclaw_module, only: Pa => ambient_pressure

        integer, intent(in) :: maux, mbc, mx, my, i, j
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc), wind

        real (kind=8), intent(in) :: tv(2), mod_mws, theta, r, radius
        integer, intent(in) :: wind_index, pressure_index

        logical, intent(in) :: convert_height, n_hemisphere

        real (kind=8) :: trans_speed_x, trans_speed_y, ramp

        if (mod_mws > 0) then
            trans_speed_x = (abs(wind) / mod_mws) * tv(1)
            trans_speed_y = (abs(wind) / mod_mws) * tv(2)
        else
            trans_speed_x = 0
            trans_speed_y = 0
        end if

        if (convert_height) wind = wind * atmos_boundary_layer

        wind = wind * sampling_time

        ! Velocity components of storm (assumes perfect vortex shape)
        ! including addition of translation speed, and adjustment of orientation
        ! according to hemisphere (counter-clockwise on northern hemisphere).
        aux(wind_index,i,j)   = wind * merge(-1, 1, n_hemisphere) * sin(theta) + trans_speed_x
        aux(wind_index+1,i,j) = wind * merge(1, -1, n_hemisphere) * cos(theta) + trans_speed_y

        ! Apply distance ramp down(up) to fields to limit scope
        ramp = 0.5d0 * (1.d0 - tanh((r - radius) / RAMP_WIDTH))
        aux(pressure_index,i,j) = Pa + (aux(pressure_index,i,j) - Pa) &
                                * ramp
        aux(wind_index:wind_index+1,i,j) =                        &
                                aux(wind_index:wind_index+1,i,j)  &
                                * ramp

    end subroutine post_process_wind_estimate

    ! ==========================================================================
    ! Calculate storm centric polar coordinate location of grid cell center
    ! ==========================================================================
    pure subroutine calculate_polar_coordinate(x, y, sloc, r, theta)

        use geoclaw_module, only: deg2rad, coordinate_system
        use geoclaw_module, only: spherical_distance

        real(kind=8), intent(in) :: x, y, sloc(2)
        real(kind=8), intent(out) :: r, theta

        if (coordinate_system == 2) then
            ! lat-long coordinates, uses Haversine formula
            r = spherical_distance(x, y, sloc(1), sloc(2))
            theta = atan2((y - sloc(2)),(x - sloc(1)))
        else
            ! Strictly cartesian
            r = sqrt( (x - sloc(1))**2 + (y - sloc(2))**2)
            theta = atan2((y - sloc(2)), (x - sloc(1)))
        end if

    end subroutine calculate_polar_coordinate

    ! ==========================================================================
    ! Calculate central pressure difference
    ! ==========================================================================
    pure function get_pressure_diff(Pc) result(dp)
        use geoclaw_module, only: rho_air, ambient_pressure

        real (kind=8), intent(in) :: Pc
        real (kind=8) :: dp


        dp = ambient_pressure - Pc

        ! Limit central pressure deficit due to bad ambient pressure,
        ! really should have better ambient pressure...
        if (dp < 100.d0) dp = 100.d0

    end function get_pressure_diff

    ! ==========================================================================
    ! Calculate Holland parameters and limit the result
    ! ==========================================================================
    pure function get_holland_b(mod_mws, dp) result(B)
        use geoclaw_module, only: rho_air

        real (kind=8), intent(in) :: mod_mws, dp
        real (kind=8) :: B

        B = rho_air * exp(1.d0) * (mod_mws**2) / dp
        if (B <  1.d0) B = 1.d0
        if (B > 2.5d0) B = 2.5d0

    end function get_holland_b

    ! ==========================================================================
    ! Calculate B parameter according to Holland 2008 and limit the result
    ! ==========================================================================
    pure function get_holland_b_2008(dp, dpdt, slat, tv) result(B)
        real (kind=8), intent(in) :: dp, dpdt, slat, tv(2)
        real (kind=8) :: B, x, trans_speed

        trans_speed = sqrt(tv(1)**2 + tv(2)**2)
        x = 0.6d0 * (1.d0 - dp / 215.d0)
        B = -4.4d-5 * dp**2 + 0.01d0 * dp + 0.03d0 * dpdt &
            - 0.014d0 * abs(slat) + 0.15d0 * trans_speed**x + 1.d0
        if (B <  1.d0) B = 1.d0
        if (B > 2.5d0) B = 2.5d0

    end function get_holland_b_2008

    ! ==========================================================================
    !  Use the 1980 Holland model to set the storm fields
    ! ==========================================================================
    subroutine set_holland_1980_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: unsigned_coriolis

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: f, mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        integer :: i,j

        ! Holland 1980 requires converting surface to gradient winds
        logical :: convert_height=.true.

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! remove translational component
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        dp = get_pressure_diff(Pc)
        B = get_holland_b(mod_mws, dp)

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            f = unsigned_coriolis(y)
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Set speed of wind at this point, handling case of grid cell centroid
                ! at eye of storm
                if ((mwr / r)**B > 100) then
                    wind = 0
                else
                    wind = sqrt((mwr / r)**B &
                        * exp(1.d0 - (mwr / r)**B) * mod_mws**2.d0 &
                        + (r * f)**2.d0 / 4.d0) - r * f / 2.d0
                endif

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                    wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                    convert_height, rotation(x, y))

            enddo
        enddo

    end subroutine set_holland_1980_fields

    ! ==========================================================================
    !  Use the 2008 Holland model to set the storm fields
    ! ==========================================================================
    subroutine set_holland_2008_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: coriolis

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: f, mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        integer :: i,j

        ! Holland 2008 uses surface winds exclusively
        logical :: convert_height=.false.

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        dp = get_pressure_diff(Pc)
        B = get_holland_b_2008(dp, dPc_dt, sloc(2), tv)

        ! Use estimated mws instead of recorded mws
        mod_mws = sqrt(B / (rho_air * exp(1.d0)) * dp)

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            f = coriolis(y)
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Set speed of wind at this point, handling case of grid cell centroid
                ! at eye of storm
                if ((mwr / r)**B > 100) then
                    wind = 0
                else
                    wind = sqrt((mwr / r)**B &
                        * exp(1.d0 - (mwr / r)**B) * mod_mws**2.d0 &
                        + (r * f)**2.d0 / 4.d0) - r * f / 2.d0
                endif

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                    wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                    convert_height, rotation(x, y))

            enddo
        enddo

    end subroutine set_holland_2008_fields

    ! ==========================================================================
    !  Use the 2010 Holland model to set the storm fields
    !
    !  As in the original publication, this implementation computes
    !  cyclostrophic winds, i.e., it does not include the Coriolis force.
    ! ==========================================================================
    subroutine set_holland_2010_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)


        use geoclaw_module, only: rho_air
        use geoclaw_module, only: deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        real(kind=8) :: rn, vn, xn, xx
        real(kind=8) :: dg, rg
        integer :: i,j

        ! Holland 2010 does not require converting surface to gradient winds
        logical :: convert_height=.false.

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        dp = get_pressure_diff(Pc)
        B = get_holland_b_2008(dp, dPc_dt, sloc(2), tv)

        ! Use estimated mws instead of recorded mws
        mod_mws = sqrt(B / (rho_air * exp(1.d0)) * dp)

        ! Additional Holland parameters needed
        ! Since we don't have a second wind speed measurement, we assume that the
        ! wind speed is 10 m/s at a radius of 500 km. For comparison: The original
        ! publication assumed 17 m/s at a radius of 300 km.
        vn = 10
        rn = 500000
        dg = (mwr/rn)**B
        rg = dg * exp(1.d0-dg)
        xn = log(vn/mws)/log(rg)

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Set speed of wind at this point, handling case of grid cell centroid
                ! at eye of storm
                if ((mwr / r)**B > 100) then
                    wind = 0
                else
                    ! # HOLLAND 2010 WIND SPEED CALCULATION
                    if (r <= mwr) then
                        xx = 0.5
                    else
                        xx = 0.5 + (r - mwr) * (xn - 0.5) / (rn - mwr)
                    endif
                    wind = mod_mws * ((mwr / r)**B * exp(1.d0 - (mwr / r)**B))**xx
                endif

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                    wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                    convert_height, rotation(x, y))
            enddo
        enddo

    end subroutine set_holland_2010_fields


    ! ==========================================================================
    !  Use the Chavas, Lin, and Emmanuel 2016 model
    ! ==========================================================================
    subroutine set_CLE_fields(maux, mbc, mx, my, xlower, ylower,    &
                              dx, dy, t, aux, wind_index,           &
                              pressure_index, storm)

        use geoclaw_module, only: rho_air, Pa => ambient_pressure
        use geoclaw_module, only: unsigned_coriolis, deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(in out) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2)
        real(kind=8) :: f, mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius
        real(kind=8) :: mod_mws, trans_speed, ramp, trans_mod
        integer :: i,j

        ! Variables for CLE model calculations
        integer, PARAMETER :: res=2000
        real(kind=8), save :: v_vec(1:res), p_vec(1:res)
        real(kind=8), save :: m_out_vec(1:res)
        real(kind=8), save :: last_time=-1
        real(kind=8), save :: dr, r_a, r_0
        integer :: io_status
        integer, save :: in_res, out_res


        ! Additional local storage for CLE Model
        real(kind=8) :: v, next_loc(2)
        integer :: r_index
        real(kind=8) :: r_factor, t_factor

        ! CLE does not require surface wind to be converted to gradient wind (?)
        logical :: convert_height=.false.

        ! Output the pressure and velocity fields.
        ! Determines the radial wind ONLY IF called at a new time.

        !First, interpolate all of the relevant tracked storm parameters.
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! pre-process max wind speed and translational velocity
        ! (It appears the azimuthal winds are not used in the algorithm)
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        ! Fill array with CLE model parameters
        if (last_time /= t) then

            f = unsigned_coriolis(sloc(2))

            ! Determine the wind profile, but only if the profile isn't already
            ! saved. In v_vec and p_vec.
            last_time = t
            call solve_hurricane_wind_parameters(f,mwr,mws,res,r_0,r_a)
            dr = real(r_0) / (res - 1)
            !out_res = number of points in outer model/in_res = points in inner model
            out_res = ceiling(real((res - 1) * (r_0 - r_a)) / r_0)
            in_res = res - out_res
            !Determine angular momentum profile for outer model
            call integrate_m_out(f,r_0,r_0 - out_res*dr,out_res,m_out_vec)
            do j= 1, out_res
               !convert angular momentum to azimuthal velocity.
               r = r_0 - (j-1)*r_0/res
               m_out_vec(out_res + 1 - j) = (m_out_vec(out_res + 1 - j)- .5*f*r**2)/r
            end do

            p_vec(1) = 0
            v_vec(1) = 0

            do j=2, res
                ! Combine inner and outer model into single radial wind profile.
                if(j <= in_res) then
                   r = (j - 1)*dr
                   v_vec(j) = evaluate_v_a(f, mwr, mws, r)
                else
                   v_vec(j) = m_out_vec(j - in_res)
                end if
                ! Pressure is determined using the gradient wind equation.
                p_vec(j) = p_vec(j - 1) + (v_vec(j)**2)/r + f*v_vec(j)
            end do

            do j=1, res
                ! Normalize pressure to match measurements.
                p_vec(j) = (Pa - Pc)*p_vec(j)/p_vec(res) + Pc
            end do

            open(unit=4242, file='test.txt',status='replace', &
                 action='write',iostat=io_status)
            write(4242,*) v_vec
        end if

        ! Set fields
        do j=1-mbc,my+mbc
           ! Assign a clockwise, radially symmetric wind field by piece-wise linear
           ! interpolation of v_vec.  Likewise with p_vec.
            y = ylower + (j-0.5d0) * dy ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)
                r_index = floor(r/dr)
                r_factor = (r - r_index * dr) / dr
                r_index = r_index + 1

                if (r_index < res) then
                    aux(pressure_index, i, j) = (1 - r_factor) * p_vec(r_index) &
                                        + r_factor * p_vec(r_index + 1)
                    aux(wind_index, i, j) = -0.9 * ((1 - r_factor) * v_vec(r_index) &
                                        + r_factor * v_vec(r_index + 1)) * sin(theta)
                    aux(wind_index+1, i, j) = 0.9 * ((1 - r_factor) * v_vec(r_index) &
                                        + r_factor * v_vec(r_index + 1)) * cos(theta)
                else
                    aux(pressure_index,i,j) = Pa
                    aux(wind_index,i,j) = 0
                    aux(wind_index+1,i,j) = 0
                end if
            end do
        end do

    end subroutine set_CLE_fields

    ! ==========================================================================
    !  inner_derivative(f,r_m,v_m,r_a)
    !   Evaluate the derivative of the inner model with respect to the
    !   merge point radius. Fortran can not handle the computation of the
    !   derivative in one line, thus it is calculated by breaking it up.
    !   The analytical solution of the derivative is very messy, but possible
    !   to solve.
    ! ==========================================================================
    real(kind=8) function evaluate_inner_derivative(f,r_m,v_m,r_a,v_a) result(dMa)

        ! Input
        real(kind=8), intent(in) :: f, r_m, v_m, r_a, v_a

        ! Variables
        real(kind=8) :: denominator, M_a
        real(kind=8), parameter :: alpha=1.0

        ! Calculate necessary components of the derivative to make
        ! calculations easier
        denominator = 2 - alpha + alpha * (r_a / r_m)**2
        M_a = 0.5 * f * r_a**2 + r_a * v_a
        dMa = (2 * M_a / r_a) * (1/denominator)

    end function evaluate_inner_derivative

    ! ==========================================================================
    !  evaluate_v_a(f,r_m,v_m,r_a)
    !    Evaluates the inner velocity at the merge point that allows the inner
    !    and outer model to be continuous.
    ! ==========================================================================
    real(kind=8) function evaluate_v_a(f,r_m,v_m,r_a) result(v_a)

        ! Input
        real(kind=8), intent(in) :: f, r_m, v_m, r_a
        real(kind=8), parameter :: alpha=1.0

        v_a = ((2.0*(r_a/r_m)**2)/(2.0-alpha+alpha*(r_a/r_m)**2))**(1.0/(2.0-alpha))
        v_a = v_a*(0.5*f*r_m**2 + r_m*v_m)
        v_a = v_a - 0.5*f*r_a**2
        v_a = v_a/r_a

    end function evaluate_v_a


    ! ==========================================================================
    !  solve_r_0(f,r_a,v_a,res,r_0, r_guess, m_out)
    !    Determines the wind profile for a hurricane using
    !    the inner and outer model for the Chavas model.
    ! ==========================================================================
    subroutine solve_r_0(f, r_a, v_a, res, r_0, r_guess)

        ! Input
        real(kind=8), intent(in) :: f, r_a, v_a
        integer, intent(in) :: res

        ! Variables with less strict i/o
        real(kind=8) :: r_0, r_guess, m_diff, r_step, dr,r_m
        real(kind=8) :: m_out(1:res)
        integer :: i

        ! Parameters
        real(kind=8), PARAMETER :: R_TOL=0.1
        integer :: STEP_FLAG=1

        ! Intialize the guess
        r_0 = r_guess
        r_step = r_guess

        ! Golden section method to determine r_0, the radius
        ! at which the wind's speed drops to zero.
        do
            call integrate_m_out(f, r_0, r_a, res, m_out)
            if (m_out(1) - 0.5*f*r_a**2 - r_a*v_a < 0) then
                r_step = r_step/STEP_FLAG
                r_0 = r_0 + r_step
            else
                r_step = r_step/2.0
                r_0 = r_0 - r_step
                STEP_FLAG = 2
            end if

            ! Check the tolerance value
            if (r_step < R_TOL) then
                r_guess = r_0
                exit
            end if
        end do

    end subroutine solve_r_0

    ! ==========================================================================
    !  integrate_m_out(f, r_0, r_a, res, m_out)
    !   Integrates from r_0 to r_a to determine the outer wind profile.
    ! ==========================================================================
    subroutine integrate_m_out(f,r_0,r_a,res,m_out)

        ! Input variables
        real(kind=8), intent(in) :: f, r_0, r_a
        integer, intent(in) :: res
        real(kind=8), dimension(1:res) :: m_out

        ! Parameters and Other variables
        real(kind=8) :: V_m, dr, r_guess, r_p
        integer :: i
        real(kind=8), parameter :: chi=1.0

        ! Intialize
        m_out(res) = 0.5*f*r_0**2
        dr = (r_0 - r_a)/res
        r_p = r_0 - dr
        m_out(res-1) = 0.5*f*r_p**2 + r_p*f*(r_0-r_p)

        ! Integrates the outer model equation from r_0 to r_a
        do i = res-2, 1, -1
            r_guess = r_p
            r_p = r_guess - dr
            V_m = (m_out(i+1) - 0.5*f*r_p**2)/r_p
            m_out(i) = m_out(i+1) - chi*dr*((r_p*V_m)**2)/(r_0**2 - r_p**2)
        end do

    end subroutine integrate_m_out


    ! ==========================================================================
    !  solve_hurricane_wind_parameters(f, r_m, v_m, res, r_0, r_a)
    !   Determine r_0, r_a, and v_a.
    !   Determine the merge point when given the f value. At this current
    !   moment we are using values of chi = 1.0 and alpha = 1.0.
    ! ==========================================================================
    subroutine solve_hurricane_wind_parameters(f, r_m, v_m, res, r_0, r_a)

        ! Input
        real(kind=8), intent(in) :: f, r_m, v_m
        integer, intent(in) :: res

        ! Variables
        real(kind=8) :: r_0, r_0_guess, r_a, r_step, v_a
        real(kind=8) :: slope_difference
        real(kind=8) :: m_out(1:res)

        ! Parameters
        real(kind=8), parameter :: r_tol = 0.1
        integer :: step_flag = 1, i

        ! Parameters
        real(kind=8) :: dr, r
        real(kind=8) :: inner_res, outer_res
        real(kind=8), dimension(1:res) :: v_out, v_in
        real(kind=8), parameter :: chi=1.0
        real(kind=8), parameter :: alpha=1.0

        ! Initialize guesses for merge and r_0
        r_a = 2.0*r_m
        r_0_guess = 5.0*r_m
        r_step = r_a

        do
            v_a = evaluate_v_a(f,r_m,v_m,r_a)
            !print *, "v_a: ", v_a
            if (v_a < 0) then
                r_step = r_step/2
                r_a = r_a - r_step
                cycle
            end if

            call solve_r_0(f,r_a,v_a,res,r_0,r_0_guess)

            slope_difference = evaluate_inner_derivative(f,r_m,v_m,r_a,v_a) - &
                                chi*((r_a*v_a)**2)/(r_0**2 - r_a**2)
            if (slope_difference < 0) then
                r_step = r_step/2.0
                r_a = r_a - r_step
                step_flag = 1
            else
                r_step = r_step/step_flag
                r_a = r_a + r_step
            end if

            if (r_step < r_tol) then
                exit
            end if
        end do

    end subroutine solve_hurricane_wind_parameters

    ! ==========================================================================
    !  solve_wind_profile(f, r_m, v_m, res)
    ! ==========================================================================
    subroutine solve_wind_profile(f, r_m, v_m, res)

        ! Input
        real(kind=8), intent(in) :: f, r_m, v_m
        integer, intent(in) :: res
        real(kind=8), save :: r_0, r_a, v_a

        ! Parameters
        real(kind=8) :: dr, r
        real(kind=8) :: inner_res, outer_res
        real(kind=8), dimension(1:res) :: v_out, v_in, m_out
        integer :: i

        call solve_hurricane_wind_parameters(f, r_m, v_m, res, r_0, r_a)

        ! Determine the inner model velocity vector
        dr = (r_a/res)
        r = dr
        v_in(1) = 0


        do i = 2, res, 1
            v_in(i) = evaluate_v_a(f, r_m, v_m, r)
            r = r + dr
        end do

        ! Determine the outer model velocity vector
        dr = (r_0 - r_a)/res
        r = r_0 - dr
        v_out(res) = 0

        call integrate_m_out(f, r_0, r_a, res, m_out)

        do i = res-1, 1, -1
            v_out = (m_out(i) - 0.5*f*r**2)/r
            r = r - dr
        end do

    end subroutine solve_wind_profile

    ! ==========================================================================
    !  Use the SLOSH model to set the storm fields
    !  based on info from: https://www.mdpi.com/2073-4433/10/4/193/pdf
    !  and https://www.hsdl.org/?abstract&did=779560
    ! ==========================================================================
    subroutine set_SLOSH_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius
        real(kind=8) :: mod_mws, trans_speed_x, trans_speed_y
        integer :: i,j

        ! SLOSH model requires converting surface to gradient winds (for calculating
        ! Holland B)
        logical :: convert_height=.true.

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! pre-process max wind speed and translational velocity
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        dp = get_pressure_diff(Pc)
        B = get_holland_b(mod_mws, dp)

        ! slosh winds use a 10-min wind speed so we apply correction factor upstream
        mod_mws = mod_mws * sampling_time

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Speed of wind at this point
                ! Note that in reality SLOSH does not directly input mws but instead
                ! estimates it from central pressure and mwr using a lookup table and
                ! iterative procedure (see p. 14 of Jelesnianski et al. 1992)
                ! It's assumed to be equal to 10-min winds, so we apply the correction
                ! upstream
                wind = (2.d0 * mws * mwr * r) / (mwr**2.d0 + r**2.d0)

                !! SLOSH has custom addition of translational velocity
                ! so we do not use `post_process_wind_estimate` function
                trans_speed_x = tv(1) * mwr * r / (mwr**2.d0 + r**2.d0)
                trans_speed_y = tv(2) * mwr * r / (mwr**2.d0 + r**2.d0)
                
                aux(wind_index,i,j)   = wind * merge(-1, 1, rotation(x, y)) * sin(theta) + trans_speed_x
                aux(wind_index+1,i,j) = wind * merge(1, -1, rotation(x, y)) * cos(theta) + trans_speed_y
            enddo
        enddo

    end subroutine set_SLOSH_fields


    ! ==========================================================================
    !  Use the Rankine model to set the wind field and H80 for pressure
    ! ==========================================================================
    subroutine set_rankine_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        integer :: i,j

        ! Rankine requires converting surface to gradient winds
        logical :: convert_height=.true.

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! pre-process max wind speed and translational velocity
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        dp = get_pressure_diff(Pc)
        B = get_holland_b(mod_mws, dp)

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Set speed of wind at this point, handling case of grid cell centroid
                ! at eye of storm
                if ((mwr / r)**B > 100) then
                    wind = 0
                else
                    ! Speed of wind at this point
                    if (r < mwr) then
                        wind = mws * (r / mwr)
                    else
                        wind = mws * (mwr / r)
                    endif
                endif

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                convert_height, rotation(x, y))

            enddo
        enddo

    end subroutine set_rankine_fields


    ! ==========================================================================
    !  Use the Modified Rankine model to set the wind field and H80 for pressure
    ! ==========================================================================
    subroutine set_modified_rankine_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        integer :: i,j

        ! Rankine requires converting surface to gradient winds
        logical :: convert_height=.true.

        ! additional decay parameter
        real(kind=8) :: alpha

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! pre-process max wind speed and translational velocity
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        dp = get_pressure_diff(Pc)
        B = get_holland_b(mod_mws, dp)

        ! set modified rankine decay param (from Mallen, Montgomery and Wang 2005)
        if ((mws) < 30.d0) then
            alpha = 0.31d0
        else if (mws > 50.d0) then
            alpha = 0.48d0
        else
            alpha = 0.35d0
        end if

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Set speed of wind at this point, handling case of grid cell centroid
                ! at eye of storm
                if ((mwr / r)**B > 100) then
                    wind = 0
                else
                    ! Speed of wind at this point
                    if (r < mwr) then
                        wind = mws * (r / mwr)
                    else
                        wind = mws * (mwr / r)**alpha
                    endif
                endif

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                convert_height, rotation(x, y))

            enddo
        enddo

    end subroutine set_modified_rankine_fields


    ! ==========================================================================
    !  Use the DeMaria model to set the wind fields, using Holland 1980 for
    !  pressures.
    !  original paper: deMaria 1987, Monthly Weather Review
    ! ==========================================================================
    subroutine set_deMaria_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        integer :: i,j

        ! deMaria requires converting surface to gradient winds (just for Holland B)
        logical :: convert_height=.true.

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! pre-process max wind speed and translational velocity
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        dp = get_pressure_diff(Pc)
        B = get_holland_b(mod_mws, dp)

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Speed of wind at this point
                ! Commented out version has 2 more free parameters that we would need
                ! to set (chosen to be equal to 1 for the time being)
                !wind = (r * mws / mwr) &
                !        * exp((1.d0 - (r / mwr)**b) * (1.d0/d))
                wind = mod_mws * (r / mwr) &
                        * exp(1.d0 - (r / mwr))

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                    wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                    convert_height, rotation(x, y))

            enddo
        enddo

    end subroutine set_deMaria_fields


    ! ==========================================================================
    !  Use the Willoughby 2006 model to set the wind field, using H80 for pressure
    !  Original paper https://journals.ametsoc.org/mwr/article/134/4/1102/67551
    ! ==========================================================================
    subroutine set_willoughby_fields(maux, mbc, mx, my, xlower, ylower,    &
                                       dx, dy, t, aux, wind_index,           &
                                       pressure_index, storm)

        use geoclaw_module, only: rho_air
        use geoclaw_module, only: deg2rad
        use geoclaw_module, only: spherical_distance

        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(model_storm_type), intent(inout) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        ! Local storage
        real(kind=8) :: x, y, r, theta, sloc(2), B
        real(kind=8) :: mwr, mws, Pc, dPc_dt, dp, wind, tv(2), radius, mod_mws
        integer :: i,j

        ! Willoughby requires converting surface to gradient winds
        logical :: convert_height=.true.

        ! other Willoughby params
        real(kind=8) :: n, X1, X2, A, xi, W

        ! Get interpolated storm data
        call get_storm_data(t, storm, sloc, tv, mwr, mws, Pc, radius, dPc_dt)

        ! pre-process max wind speed and translational velocity
        call adjust_max_wind(tv, mws, mod_mws, convert_height)

        dp = get_pressure_diff(Pc)
        B = get_holland_b(mod_mws, dp)

        ! Get willoughby coeffs
        ! (See Section 4)
        n = 2.134d0 + 0.0077d0*mod_mws - 0.4522d0*log(mwr) - 0.0038*abs(sloc(2))
        X1 = (317.1d0 - 2.026d0*mod_mws + 1.915d0*abs(sloc(2))) * 1.d3
        X2 = 25.d3
        A = max(0.5913d0 + 0.0029d0*mod_mws - 0.1361*log(mwr) - 0.0042d0*abs(sloc(2)), &
                0.d0)

        ! Set fields
        do j=1-mbc,my+mbc
            y = ylower + (j-0.5d0) * dy     ! Degrees latitude
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0) * dx   ! Degrees longitude

                call calculate_polar_coordinate(x, y, sloc, r, theta)

                ! Set pressure field
                aux(pressure_index,i,j) = set_pressure(Pc, r, dp, mwr, B)

                ! Speed of wind at this point
                ! (.9 and 1.1 are chosen as R1 and R2 rather than fit )
                ! Note this may mess up the location of Vmax slightly since it does not
                ! have to lie at xi=0.5 (see Section 2 of paper)
                if (r < 0.9d0 * mwr) then
                    wind = mod_mws * (r / mwr)**n
                else if (r > 1.1d0 * mwr) then
                    wind = mod_mws * ( (1-A) * exp(-(r-mwr)/X1) + A * exp(-(r-mwr)/X2) )
                else
                    xi = (r - 0.9d0*mwr)/(0.2d0*mwr)
                    W = 126.d0*xi**5 + 420.d0*xi**6 + 540.d0*xi**7 - 315.d0*xi**8 + &
                        70.d0*xi**9
                    wind = mod_mws * (r / mwr)**n * (1-W) + &
                            mod_mws * &
                                ( (1-A) * exp(-(r-mwr)/X1) + A * exp(-(r-mwr)/X2) ) * W
                end if

                call post_process_wind_estimate(maux, mbc, mx, my, i, j, wind, aux, &
                    wind_index, pressure_index, r, radius, tv, mod_mws, theta, &
                    convert_height, rotation(x, y))

            enddo
        enddo

    end subroutine set_willoughby_fields
end module model_storm_module

subroutine src1(maxmx,meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)

    use parameters_module, only: manning,g,rho

    implicit none

    ! Input parameters
    integer, intent(in) :: maxmx,meqn,mbc,mx,maux
    double precision, intent(in) :: xlower,dx,t,dt
    
    ! Output
    double precision, intent(inout) :: q(1-mbc:maxmx+mbc, meqn)
    double precision, intent(inout) :: aux(1-mbc:maxmx+mbc, maux)
    
    ! Locals
    integer :: i
    double precision, parameter :: TOLERANCE = 1d-30
    double precision :: gamma,dgamma,h,u
    
    ! Friction
    if (manning > TOLERANCE) then
        do i=1,mx
            h = q(i,3) / rho(2)
            u = q(i,4) / rho(2)
    
            if (h > TOLERANCE) then
                q(i,3) = 0.d0
                q(i,4) = 0.d0
            else
                gamma = u * g * manning**2 / h**(4/3)
                dgamma = 1.d0 + dt * gamma
                q(i,4) = q(i,4) / dgamma * rho(2)
            endif
        enddo
    endif
    
end subroutine src1

c
c ---------------------------------------------------
c Modified from coarsen.f in amrclaw
c Uses code taken from update.f to take into account
c wet and dry cells.
c ---------------------------------------------------
c
       subroutine coarsen(valdub,midub,mjdub,auxdub,
     &                    valbgc,mi2tot,mj2tot,auxbgc,nvar,naux)


       use geoclaw_module, only: dry_tolerance
c
       use amr_module, only: mcapa,nghost
       implicit none

       integer, intent(in) :: midub,mjdub,mi2tot,mj2tot,nvar,naux
       real(kind=8), intent(in) :: valdub(nvar,midub, mjdub)
       real(kind=8), intent(in) :: auxdub(naux,midub, mjdub)
       real(kind=8), intent(inout) :: valbgc(nvar,mi2tot,mj2tot)
       real(kind=8), intent(inout) :: auxbgc(naux,mi2tot,mj2tot)

c      # Local variables
       integer :: j,jfine,i,ifine,jco,ico,nwet
       real(kind=8) :: capac,bc,etasum,hsum,husum,hvsum,capa
       real(kind=8) :: hf,huf,hvf,bf,etaf,etaav,hav,hc,huc,hvc

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
c coarsen = coarsen the fine grid data (with double the usual
c           number of ghost cells to prepare coarsened
c           grid for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       do j = 1, mj2tot

         jfine = 2*(j-1) + 1

         do i = 1, mi2tot
           ifine = 2*(i-1) + 1

c          # Getting coarse capacity function and bathymetry
           if (mcapa .eq. 0) then
               capac=1.0d0
           else
               capac=auxbgc(2,i,j)
           endif

           bc = auxbgc(1,i,j)

c          # Calculating which values to use for coarsen
           etasum = 0.d0
           hsum = 0.d0
           husum = 0.d0
           hvsum = 0.d0

           nwet=0

           do jco = 1, 2
            do ico = 1, 2
               if (mcapa .eq. 0) then
                   capa=1.0d0
               else
                   capa=auxdub(2,ifine+ico-1,jfine+jco-1)
               endif

               hf =valdub(1,ifine+ico-1,jfine+jco-1)*capa
               huf=valdub(2,ifine+ico-1,jfine+jco-1)*capa
               hvf=valdub(3,ifine+ico-1,jfine+jco-1)*capa

               bf =auxdub(1,ifine+ico-1,jfine+jco-1)*capa

               if (hf > dry_tolerance) then
                   etaf = hf+bf
                   nwet=nwet+1
               else
                   etaf = 0.d0
                   huf=0.d0
                   hvf=0.d0
                   bf = 0.d0
               endif

               hsum   = hsum + hf
               husum  = husum + huf
               hvsum  = hvsum + hvf
               etasum = etasum + etaf
             enddo
           enddo

c          # Getting coarse averages
           if (nwet.gt.0) then
               etaav=etasum/dble(nwet)
               hav= hsum/dble(nwet)

c              hc=max(etaav-bc*capac,0.d0) !tsunamiclaw method
               hc=min(hav,(max(etaav-bc*capac,0.d0)))
               if (hsum.ne.0) then
                   huc=(min(hav,hc)/hsum)*husum
                   hvc=(min(hav,hc)/hsum)*hvsum
               else
                   huc= 0.d0
                   hvc= 0.d0
               endif
           else
               hc=0.d0
               huc=0.d0
               hvc=0.d0
           endif

c          # set h on coarse grid based on surface, not conservative near shoreline
           valbgc(1,i,j) = hc / capac
           valbgc(2,i,j) = huc / capac
           valbgc(3,i,j) = hvc / capac

         enddo
       enddo

       return
       end

! =============================================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =============================================================================
!
! Riemann problems for the 1D Burgers' equation with entropy fix for 
! transonic rarefaction. See "Finite Volume Method for Hyperbolic Problems",
! R. J. LeVeque.

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q
    
    implicit double precision (a-h,o-z)

    integer :: maxmx, meqn, mwaves, mbc, mx
        
    double precision :: ql(meqn,1-mbc:maxmx+mbc)
    double precision :: qr(meqn,1-mbc:maxmx+mbc)
    double precision :: s(mwaves, 1-mbc:maxmx+mbc)
    double precision :: wave(meqn, mwaves, 1-mbc:maxmx+mbc)
    double precision :: amdq(meqn, 1-mbc:maxmx+mbc)
    double precision :: apdq(meqn, 1-mbc:maxmx+mbc)
    integer :: i
    logical :: efix
 
    efix = .true.   !# Compute correct flux for transonic rarefactions
 

    do i=2-mbc,mx+mbc
        wave(1,1,i) = ql(1,i) - qr(1,i-1)
        s(1,i) = 0.5d0 * (qr(1,i-1) + ql(1,i))

        amdq(1,i) = dmin1(s(1,i), 0.d0) * wave(1,1,i)
        apdq(1,i) = dmax1(s(1,i), 0.d0) * wave(1,1,i)

        if (efix) then
            if (ql(1,i).gt.0.d0 .and. qr(1,i-1).lt.0.d0) then
                amdq(1,i) = - 1.d0/2.d0 * qr(1,i-1)**2
                apdq(1,i) =   1.d0/2.d0 * ql(1,i)**2
            endif
        endif
    enddo

    return
    end subroutine

! This routine should be a simplified version of src2
! which applies source terms for a 1-d slice of data along the
! edge of a grid.  This is called only from qad where the conservative
! fix-up is applied and is used to apply source terms over partial
! time steps to the coarse grid cell values used in solving Riemann
! problems at the interface between coarse and fine grids.
subroutine src1d(meqn,mbc,mx1d,q1d,maux,aux1d,t,dt)
      
    use geoclaw_module, only: g => grav, coriolis_forcing, coriolis
    use geoclaw_module, only: friction_forcing, friction_depth, friction_index
    use geoclaw_module, only: num_layers, rho, omega, coordinate_system

    implicit none

    ! Input
    integer, intent(in) :: meqn, mbc, mx1d, maux
    real(kind=8), intent(in) :: t, dt
    real(kind=8), intent(inout) :: q1d(meqn, mx1d), aux1d(maux, mx1d)

    ! Local storage
    integer :: i, m, bottom_index, bottom_layer, layer_index
    logical :: found
    real(kind=8) :: h(num_layers), hu, hv, gamma, dgamma, y, fdt, a(2,2)

    ! Algorithm parameters
    ! Parameter controls when to zero out the momentum at a depth in the
    ! friction source term
    real(kind=8), parameter :: depth_tolerance = 1.0d-30
    
    ! Pressure forcing
    ! Handled in Riemann solver
    

    ! Friction forcing
    if (friction_forcing) then

        do i=1,mx1d

            ! Extract depths
            forall (m=1:num_layers)
                h(m) = q1d(3 * (m-1) + 1,i) / rho(m)
            end forall

            ! Extract appropriate momentum, also zero momentum in dry layers
            m = num_layers
            found = .false.
            do while(.not.found .and. m > 0)
                if (h(m) > depth_tolerance) then
                    ! Extract momentum components and exit loop
                    bottom_layer = m
                    bottom_index = 3 * (m - 1)
                    hu = q1d(bottom_index + 2, i) / rho(m)
                    hv = q1d(bottom_index + 3, i) / rho(m)
                    found = .true.
                else
                    ! Set almost dry layers momentum to zero
                    q1d(3 * (m - 1) + 2, i) = 0.d0
                    q1d(3 * (m - 1) + 3, i) = 0.d0
                endif
                m = m - 1
            end do

            if (.not.found) then
                cycle
            endif

            ! Apply friction source term only if in shallower water
            if (sum(h) <= friction_depth) then
                ! Calculate source term
                gamma = sqrt(hu**2 + hv**2) * (g * aux1d(friction_index,i)**2) &
                                            / (h(bottom_layer)**(7/3))
                dgamma = 1.d0 + dt * gamma
                q1d(bottom_index + 2, i) = q1d(bottom_index + 2, i) / dgamma
                q1d(bottom_index + 3, i) = q1d(bottom_index + 3, i) / dgamma
            endif
        enddo
    endif
    
    ! Only lat-long coordinate system supported here right now
    if (coriolis_forcing .and. coordinate_system == 2) then

        do i=1,mx1d
            ! aux(3,:,:) stores the y coordinates multiplied by deg2rad
            fdt = 2.d0 * omega * sin(aux1d(3,i)) * dt

            ! Calculate matrix components
            a(1,1) = 1.d0 - 0.5d0 * fdt**2 + fdt**4 / 24.d0
            a(1,2) =  fdt - fdt**3 / 6.d0
            a(2,1) = -fdt + fdt**3 / 6.d0
            a(2,2) = a(1,1)
    
            do m=1,num_layers
                q1d(layer_index + 2,i) = q1d(layer_index + 2,i) * a(1,1) &
                                       + q1d(layer_index + 3,i) * a(1,2)
                q1d(layer_index + 3,i) = q1d(layer_index + 2,i) * a(2,1) &
                                       + q1d(layer_index + 3,i) * a(2,2)
            enddo
        enddo
        
    endif

end subroutine src1d

c
c
c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,xlower,ylower,
     &                   dx,dy,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c     # Acoustics with smooth radially symmetric profile to test accuracy
c
       implicit double precision (a-h,o-z)
       dimension q(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
       dimension aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc)
c
       pi = 4.d0*datan(1.d0)
       width = 0.2d0

       do 20 i=1,mx
          xcell = xlower + (i-0.5d0)*dx
          do 20 j=1,my
             ycell = ylower + (j-0.5d0)*dy
             r = dsqrt(xcell**2 + ycell**2)

             if (dabs(r-0.5d0) .le. width) then
                 pressure = 1.d0 + dcos(pi*(r - 0.5d0)/width)
               else
                 pressure = 0.d0
               endif
             q(1,i,j) = pressure
             q(2,i,j) = 0.d0
             q(3,i,j) = 0.d0
  20         continue

       return
       end

c
c ------------------------------------------------------------
c
      integer function nodget()
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::: NODGET ::::::::::::::::::::::::::::::::::::;
c nodget =  get first free node of the linked list kept in node
c            array. adjust pointers accordingly.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      if (ndfree .ne. null) go to 10
          write(outunit,100) maxgr
          write(*,100)       maxgr
100       format(' out of nodal space - allowed ',i8,' grids')
          do level = 1, lfine
             write(*,101) level,numgrids(level)
 101         format("    level ",i4," has ",i6,'grids')
          end do
          write(*,*)" Could need twice as many grids as on any given"
          write(*,*)" level if regridding/birecting"
          stop
c
c  update pointers
c
 10     nodget         = ndfree
        ndfree         = node(nextfree,ndfree)
c
c  initialize new  block
c
        do 20 i        = 1, nsize
           node(i,nodget) = 0
 20     continue
c
        do 30 i         = 1, rsize
           rnode(i,nodget) = 0.0d0
 30     continue
c
      return
      end
c
c ------------------------------------------------------------
c
      integer function nodget_bnd()
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::: NODGET_BND ::::::::::::::::::::::::::::::::::::;
c nodget_bnd =  same as above but for bndry list
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      if (ndfree_bnd .ne. null) go to 10
          write(outunit,100) bndListSize
          write(*,100)       bndListSize
100       format(' out of bndry space - allowed ',i5,' bndry grids')
          ! calc average number of bndry nbors per grid
          nborTotal = 0
          numGridsTotal = 0
          do lev = 1, lfine
            numGridsTotal = numGridsTotal + numgrids(lev)
            do mptr = 1, numgrids(lev)
               nborTotal = nborTotal + node(bndListNum,mptr)  
            end do
          end do
          avgNbors = float(nborTotal)/numgridsTotal
          write(*,101) numGridsTotal,nborTotal,avgNbors
 101      format(" There are ",i8," total grids", i10," bndry nbors",
     .           " average num/grid ",f10.3)

          stop
c
c     ## adjust pointers
c
 10   nodget_bnd      = ndfree_bnd
      ndfree_bnd      = bndList(ndfree_bnd,nextfree)
c
c     ##  initialize to 0
c
      bndList(nodget_bnd,1) = 0
      bndList(nodget_bnd,2) = 0
c
      return
      end
c
c -----------------------------------------------------------------
c
      subroutine makeGridList(lbase)
c
      use amr_module
      implicit none

      integer lbase, levSt, lev, mptr, n

c :::::::::::::::::::::::::::: make_gridList :::::::::::::::::::::::::
c     make array of grid numbers (after sorting them so in decreasing
c     order of workload, done in arrangeGrid and put back into linked 
c     list. Done every time there is regridding, initial gridding,
c     or restarting.  Most often finest level is regridded, so
c     put it last in array. lbase is the level that didnt change, so 
c     only redo from lbase+1 to lfine.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      !write(*,*)"mgl: lbase,lfine",lbase,lfine
      do lev = lbase+1, lfine
         levSt = listStart(lev) 
         !write(*,*)"mgl: level ",lev," starts at ",levSt
         mptr = lstart(lev)
c        traverse linked list into array. list already sorted by arrangegrids
         do n = 1, numgrids(lev)
            listOfGrids(levSt+n-1) = mptr
            mptr = node(levelptr,mptr)
         end do
c
c        next level starts one after where this one ends.
c        Using a sentinel in dimension of
c        listStart so no need to test if level = mxnest
c
         listStart(lev+1) = levSt + numgrids(lev)
      end do

      return
      end
c
c -----------------------------------------------------------------
c
      subroutine initBndryList()

      use amr_module
      implicit none
      
      integer i
c
c  need to manage the boundary List too
c
      do i = 1, bndListSize
         bndList(i,nextfree) = i+1
      end do

      bndList(bndListSize,nextfree) = null
      ndfree_bnd = 1

      end
c
c -----------------------------------------------------------------
c
      subroutine makeBndryList(level)
c
      use amr_module
      implicit none

      integer level, n, levSt, k, nborCount
      integer nodget_bnd, nextSpot, prevNbor, msrc, mptr
      integer imin, imax
      integer imlo, imhi
      integer ixlo, ixhi

c :::::::::::::::::::::::::::: makeBndryList :::::::::::::::::::::::::
c     preprocess each grid to have linked list of other grids at
c     same level that supply ghost cells.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c     traverse linked list into array. list already sorted by arrangegrids
      levSt = listStart(level) 
      do n = 1, numgrids(level)
         mptr = listOfGrids(levSt+n-1)
         imin = node(ndilo,mptr) - nghost  ! ghost cells included since
         imax = node(ndihi,mptr) + nghost  ! this is what you want to fill
                                           ! may also use for filval stuff,
                                           ! change nghost to mbuff, etc
         nborCount = 0
         
         do k = 1, numgrids(level)  ! loop over all other grids once to find touching ones 
            if (k .eq. n) cycle     ! dont count yourself as source grid
            msrc = listOfgrids(levSt+k-1)

            ! Check if grid mptr and patch intersect
            imlo = node(ndilo, msrc)
            imhi = node(ndihi, msrc)

            ixlo = max(imlo,imin)
            ixhi = min(imhi,imax)

            if (ixlo .le. ixhi) then ! put on bnd list for mptr
               nborCount = nborCount + 1
               nextSpot = nodget_bnd()   
               bndList(nextSpot,gridNbor) = msrc
               ! get spot in bnd list. insert next grid at front to avoid traversing
               bndList(nextSpot,nextfree) =  node(bndListSt,mptr)
               node(bndListSt,mptr) = nextSpot
            endif

         end do

!        save final count
         node(bndListNum,mptr) = nborcount
      end do

      return
      end
c
c -----------------------------------------------------------------
c
      subroutine freeBndryList(mold)
c
      use amr_module
      implicit none

      integer nborCount, mold,nextSpot, i, nextnext

c :::::::::::::::::::::::::::: freeBndryList :::::::::::::::::::::::::
c     free the linked list of intersecting "boundary" grids for grid 'mold'
c     that is no longer active
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

           nborCount = node(bndListNum,mold) ! count for this grid
           nextSpot  = node(bndListSt,mold)  ! first index of this grids nbors
           do i = 1, nborCount
               nextnext = bndList(nextSpot,nextfree)
               call putnod_bnd(nextSpot)
               nextSpot = nextnext
           end do

      return
      end

module workspace
! ===================================================================
! This module holds arrays used as work space to hold intermediate
! values in the SharpClaw solvers.
! ===================================================================

    double precision, allocatable  :: dtdx(:)
    double precision, target, allocatable  :: ql(:,:), qr(:,:)
    double precision, allocatable  :: evl(:,:,:), evr(:,:,:)
    double precision, allocatable  :: amdq(:,:), apdq(:,:), amdq2(:,:), apdq2(:,:)
    double precision, allocatable  :: wave(:,:,:), s(:,:)
    logical :: work_alloc = .False.

contains

    subroutine alloc_workspace(maxnx,num_ghost,num_eqn,num_waves,char_decomp)
        integer,intent(in) :: maxnx,num_ghost,num_eqn,num_waves,char_decomp

        allocate(ql(num_eqn,1-num_ghost:maxnx+num_ghost))
        allocate(qr(num_eqn,1-num_ghost:maxnx+num_ghost))
        allocate(amdq(num_eqn,1-num_ghost:maxnx+num_ghost))
        allocate(apdq(num_eqn,1-num_ghost:maxnx+num_ghost))
        allocate(amdq2(num_eqn,1-num_ghost:maxnx+num_ghost))
        allocate(apdq2(num_eqn,1-num_ghost:maxnx+num_ghost))
        allocate(wave(num_eqn,num_waves,1-num_ghost:maxnx+num_ghost))
        allocate(s(num_waves,1-num_ghost:maxnx+num_ghost))
        allocate(dtdx(1-num_ghost:maxnx+num_ghost))

        if (char_decomp>1) then
            allocate(evl(num_eqn,num_eqn,1-num_ghost:maxnx+num_ghost))
            allocate(evr(num_eqn,num_eqn,1-num_ghost:maxnx+num_ghost))
        endif

        work_alloc = .True.

    end subroutine alloc_workspace

    subroutine dealloc_workspace(char_decomp)

        integer :: char_decomp

        if (allocated(ql)) then
            deallocate(ql)
            deallocate(qr)
            deallocate(amdq)
            deallocate(apdq)
            deallocate(amdq2)
            deallocate(apdq2)
            deallocate(wave)
            deallocate(s)
            deallocate(dtdx)

            if (char_decomp>1) then
                deallocate(evl)
                deallocate(evr)
            endif
        endif

        work_alloc = .False.

    end subroutine dealloc_workspace


end module workspace

c
c --------------------------------------------------------------
c
      subroutine preintcopy(val,mitot,nvar,ilo,ihi,
     1                      level,fliparray)
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension fliparray((mitot)*nghost*nvar)
      dimension val(nvar,mitot)
      dimension ist(3), iend(3), ishift(3)

c  NEW INDEXING ORDER SWITCHED
      iadd(ivar,i)  = locflip + ivar-1 + nvar*(i-1)
c
c  :::::::::::::: PREINTCOPY :::::::::::::::::::::::::::::::::::::::::::
c     For periodic boundary conditions more work needed to initialize a
c     new grid that sticks out. This routine was
c     called because the patch sticks out of the domain,
c     and has periodic bc.s preprocess the patch before calling
c     intcopy to shift the patch periodically back into the domain.
c
c     Inputs to this routine:
c     ilo,ihi = the location in index space of this patch.
c
c     Outputs from this routine:
c     The values of the grid are inserted
c     directly into the enlarged val array for this piece.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
        locflip = 1        

c
c     # will divide patch into 3 possibilities (some empty):
c       x sticks out left, x interior, x sticks out right
c       for example, the max. would be
c       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)
        
        if (xperdom) then
           ist(1) = ilo
           ist(2) = 0
           ist(3) = iregsz(level)
           iend(1) = -1
           iend(2) = iregsz(level)-1
           iend(3) = ihi
           ishift(1) = iregsz(level)
           ishift(2) = 0
           ishift(3) = -iregsz(level)
        else    ! if not periodic, set vals to only have nonnull intersection for interior region
           ist(1)    = iregsz(level)
           ist(2)    = ilo
           ist(3)    = iregsz(level)
           iend(1)   = -1
           iend(2)   = ihi
           iend(3)   = -1
           ishift(1) = 0
           ishift(2) = 0
           ishift(3) = 0
        endif


       do 20 i = 1, 3
          i1 = max(ilo,  ist(i))
          i2 = min(ihi, iend(i))
          if (i1 .le. i2) then ! part of patch in this region
c
            iputst = (i1 - ilo) + 1
            call intcopy(val,mitot,nvar,
     2                    i1+ishift(i),i2+ishift(i),
     3                    level,iputst)

          endif

 20    continue
      
     
      return
      end

!
! -------------------------------------------------------------
!
subroutine step2x(maxm,meqn,maux,mbc,mx,my,qold,aux,dx,dt,cflgrid,fm,fp,rpn2)
!
!     clawpack routine ...  modified for AMRCLAW
!
!     Take one time step, updating q.
!     On entry, qold gives
!        initial data for this step
!        and is unchanged in this version.
!    
!     fm, fp are fluxes to left and right of single cell edge
!     See the flux2 documentation for more information.
!
!     Converted to f90 2012-1-04 (KTM)
!
    
    use amr_module

    implicit none
    
    external rpn2
    
    ! Arguments
    integer, intent(in) :: maxm,meqn,maux,mbc,mx,my
    real(kind=8), intent(in) :: dx,dt
    real(kind=8), intent(inout) :: cflgrid
    real(kind=8), intent(inout) :: qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: fm(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: fp(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)

   
    ! Local storage for flux accumulation
    real(kind=8) :: faddm(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: faddp(meqn,1-mbc:maxm+mbc)
 

    ! Scratch storage for Sweeps and Riemann problems
    real(kind=8) ::  q1d(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: aux2(maux,1-mbc:maxm+mbc)
    real(kind=8) :: dtdx1d(1-mbc:maxm+mbc)

    
    real(kind=8) ::  wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8) ::     s(mwaves, 1-mbc:maxm + mbc)
    real(kind=8) ::  cqxx(meqn,1-mbc:maxm + mbc)
   
    
    ! Looping scalar storage
    integer :: j
    real(kind=8) :: dtdx,cfl1d
    
    
    cflgrid = 0.d0
    dtdx = dt/dx
   
    fm = 0.d0
    fp = 0.d0
    
    ! ============================================================================
    ! Perform X-Sweeps (for Godunov split method, called from stepgrid_dimSplit)
    ! loop indices assume x sweep goes first
    do j = 1-mbc,my+mbc   

        ! Copy old q into 1d slice
        q1d(:,1-mbc:mx+mbc) = qold(:,1-mbc:mx+mbc,j)
        
        ! Set dtdx slice if a capacity array exists
        if (mcapa > 0)  then
            dtdx1d(1-mbc:mx+mbc) = dtdx / aux(mcapa,1-mbc:mx+mbc,j)
        else
            dtdx1d = dtdx
        endif
        
        ! Copy aux array into slices
        if (maux > 0) then

            aux2(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j  )

        endif
        
        ! Compute modifications fadd and gadd to fluxes along this slice:
!!!     ::: dont need aux1 and aux3 for dimensionally split method
!!!     ::: but flux2 needs 3 aux arrays, so passing in aux2 3 times
        call flux2_dimSplit(1,maxm,meqn,maux,mbc,mx,q1d,dtdx1d,aux2, &
                   faddm,faddp,cfl1d,wave,s,cqxx,rpn2)       
                   
        cflgrid = max(cflgrid,cfl1d)

        ! Update fluxes
        fm(:,1:mx+1,j) = fm(:,1:mx+1,j) + faddm(:,1:mx+1)
        fp(:,1:mx+1,j) = fp(:,1:mx+1,j) + faddp(:,1:mx+1)
         
    enddo


end subroutine step2x

c====================================================================
      subroutine cellgridintegrate(topoint,xim,xip,yjm,yjp)
c=====================================================================

c *** Note topo_module variables are no longer in the calling sequence 

      use topo_module, only: rectintegral,intersection, topowork
      use topo_module, only: xlowtopo,xhitopo,ylowtopo,yhitopo           
      use topo_module, only: dxtopo,dytopo
      use topo_module, only: mxtopo,mytopo,mtopoorder,i0topo,mtopofiles
      
      implicit double precision (a-h,o-z)

      integer(kind=8) :: i0

c     ##############################################################################
c     cellgridintegrate integrates a unique surface, over a rectangular cell
c     defined from data from multiple regular Cartesian grids
c     (using the finest data available in any region)
c
c     The rectangle has coords:
c     xim <= x <= xip, yjm <= y <= yjp
c
c     The intersection (with one particular grid has coords:
c     xintlo <= x <= xinthi, yintlo <= y <= yinthi

c     The _set_ version uses a recursive strategy using the formulas for
c     intersections of sets.

c     # initialize the integral of the surface
      topoint=0.d0

*     !determine the type of integration
      im = 1

c     # first see if the grid cell is entirely in a fine topofile
      do m = 1,mtopofiles
c        !look at topofiles, from fine to coarse
         mfid = mtopoorder(m)
         i0=i0topo(mfid)
c        !check for intersection of grid cell and this topofile
         cellarea = (xip-xim)*(yjp-yjm)
         call intersection(indicator,area,xmlo,xmhi,
     &       ymlo,ymhi,xim,xip,yjm,yjp,
     &       xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))
         if (indicator.eq.1) then !cell overlaps grid
            if (area.eq.cellarea) then !cell is entirely in grid
               ! (should we check if they agree to some tolerance??)
c              !integrate surface and get out of here
                topoint = topoint + topointegral(xmlo,xmhi,ymlo,
     &              ymhi,xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid),
     &              dytopo(mfid),mxtopo(mfid),mytopo(mfid),
     &              topowork(i0),im)
               return
            else
               go to 222
            endif
         endif
      enddo

      write(6,601) xim,xip,yjm,yjp
 601  format('*** Error, grid cell does not overlap any topo grid',/,
     &     '  xim = ',e24.14,'  xip = ',e24.14,      
     &   /,'  yjm = ',e24.14,'  yjp = ',e24.14)
      stop

 222  continue

      ! this grid cell intersects only topo grid m and perhaps coarser:
      call rectintegral(xim,xip,yjm,yjp,m,topoint)

      return
      end

c ## moved subroutine intersection to topo_module.f90

subroutine rpt3(ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
    ! Riemann solver in the transverse direction for the
    ! advection equations.
    !
    ! On input,
    !
    !    ql,qr is the data along some one-dimensional slice, as in rpn3
    !         This slice is
    !             in the x-direction if ixyz=1,
    !             in the y-direction if ixyz=2, or
    !             in the z-direction if ixyz=3.
    !    asdq is an array of flux differences (A^*\Dq).
    !         asdq(i,:) is the flux difference propagating away from
    !         the interface between cells i-1 and i.
    !    Note that asdq represents B^*\Dq if ixyz=2 or C^*\Dq if ixyz=3.
    !
    !    ixyz indicates the direction of the original Riemann solve,
    !         called the x-like direction in the table below:
    !
    !               x-like direction   y-like direction   z-like direction
    !      ixyz=1:        x                  y                  z
    !      ixyz=2:        y                  z                  x
    !      ixyz=3:        z                  x                  y
    !
    !    icoor indicates direction in which the transverse solve should
    !         be performed.
    !      icoor=2: split in the y-like direction.
    !      icoor=3: split in the z-like direction.
    !
    !    For example,
    !      ixyz=1, icoor=2 means asdq=A^*\Dq, and should be split in y into
    !                        bmasdq = B^-A^*\Dq,
    !                        bpasdq = B^+A^*\Dq.
    !
    !      ixyz=2, icoor=2 means asdq=B^*\Dq, and should be split in z into
    !                        bmasdq = C^-B^*\Dq,
    !                        bpasdq = C^+B^*\Dq.
    !
    !    The parameter imp is generally needed only if aux
    !    arrays are being used, in order to access the appropriate
    !    variable coefficients:
    !
    !    imp = 1 if asdq = A^- \Dq,  the left-going flux difference
    !          2 if asdq = A^+ \Dq, the right-going flux difference
    !
    !    aux2(:,:,2) is a 1d slice of the aux array along the row
    !                 where the data ql, qr lie.   
    !    aux1(:,:,2) and aux3(:,:,2) are neighboring rows in the 
    !                 y-like direction
    !    aux2(:,:,1) and aux2(:,:,3) are neighboring rows in the 
    !                z-like direction

    implicit none

    integer, intent(in) :: ixyz, icoor, maxm, meqn, mwaves, mbc, mx, maux, imp
    double precision, intent(in) :: ql, qr, asdq, aux1, aux2, aux3
    double precision, intent(out) :: bmasdq, bpasdq

    dimension     ql(meqn,1-mbc:maxm+mbc)
    dimension     qr(meqn,1-mbc:maxm+mbc)
    dimension   asdq(meqn,1-mbc:maxm+mbc)
    dimension bmasdq(meqn,1-mbc:maxm+mbc)
    dimension bpasdq(meqn,1-mbc:maxm+mbc)
    dimension   aux1(maux,1-mbc:maxm+mbc,3)
    dimension   aux2(maux,1-mbc:maxm+mbc,3)
    dimension   aux3(maux,1-mbc:maxm+mbc,3)

    integer :: iuvw, i, i1

    ! set iuvw = 1 for u, 2 for v, 3 for w component of velocity
    ! depending on transverse direction:
    iuvw = ixyz + icoor - 1
    if (iuvw.gt.3) iuvw = iuvw-3

    do i=2-mbc,mx+mbc
        i1 = i-2+imp    !#  =  i-1 for amdq,  i for apdq
        if (icoor == 2) then  !! transverse dir. is y-like direction
            bmasdq(1,i) = dmin1(aux2(iuvw,i1,2), 0.d0)*asdq(1,i)
            bpasdq(1,i) = dmax1(aux3(iuvw,i1,2), 0.d0)*asdq(1,i)
        else !! icoor == 3  !! transverse dir. is z-like direction
            !! quanities split into cmasdq and cpasdq
            bmasdq(1,i) = dmin1(aux2(iuvw,i1,2),0.d0)*asdq(1,i)
            bpasdq(1,i) = dmax1(aux2(iuvw,i1,3),0.d0)*asdq(1,i)
        endif
    end do

    return
end subroutine rpt3

!> Called before each call to step2.
!! Use to set time-dependent aux arrays or perform other tasks.
!!
!! This default version does nothing. 
subroutine b4step2(mbc,mx,my,meqn,q,xlower,ylower,dx,dy,t,dt,maux,aux)

 
    implicit none
    integer, intent(in) :: mbc,mx,my,meqn,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,dt
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

end subroutine b4step2

      subroutine setprob
      implicit double precision (a-h,o-z)
      common /comaux/ z1,c1,z2,c2
c
c     # Set the material parameters for the acoustic equations
c
      !open(unit=7,file='setprob.data',status='old',form='formatted')
      call opendatafile(7, 'setprob.data')
c
c     # Piecewise constant medium with single interface as specified
c     # in setaux.f

c     # Impedance and sound speed in the two materials:

      read(7,*) z1
      read(7,*) c1
      read(7,*) z2
      read(7,*) c2

      return
      end

c
c
c     =====================================================
      subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,
     &                  wave,s,amdq,apdq)
c     =====================================================
c
c     # Solve Riemann problems for the 2D hyperbolic problem.
c     # This is a dummy routine and is only intended
c     # to illustrate the format of this routine.  
c     # See various example directories for better examples.
c     
c     # On input, ql contains the state vector at the left edge of each cell
c     #           qr contains the state vector at the right edge of each cell
c
c     # This data is along a slice in the x-direction if ixy=1 
c     #                            or the y-direction if ixy=2.
c     # On output, wave contains the waves, 
c     #            s the speeds, 
c     #
c     #            amdq = A^- Delta q, 
c     #            apdq = A^+ Delta q, 
c     #                   the decomposition of the flux difference
c     #                       f(qr(i-1)) - f(ql(i))
c     #                   into leftgoing and rightgoing parts respectively.
c     #               
c
c     # Note that the i'th Riemann problem has left state qr(:,i-1)
c     #                                    and right state ql(:,i)
c     # From the basic clawpack routines, this routine is called with ql = qr
c     # maux=0 and aux arrays are unused in this example.
c
c
      implicit double precision (a-h,o-z)
c
      dimension wave(meqn,mwaves,1-mbc:maxm+mbc)
      dimension    s(mwaves,1-mbc:maxm+mbc)
      dimension   ql(meqn,1-mbc:maxm+mbc)
      dimension   qr(meqn,1-mbc:maxm+mbc)
      dimension apdq(meqn,1-mbc:maxm+mbc)
      dimension amdq(meqn,1-mbc:maxm+mbc)
      dimension auxl(maux,1-mbc:maxm+mbc)
      dimension auxr(maux,1-mbc:maxm+mbc)
c
      write(6,*) 'You must provide a valid Riemann solver'
      stop

      return
      end

c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,xlower,ylower,
     &                   dx,dy,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c
       implicit double precision (a-h,o-z)
       dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)

       do 20 i=1,mx
          xcell = xlower + (i-0.5d0)*dx

          do 20 j=1,my
             ycell = ylower + (j-0.5d0)*dy

             if (dabs(xcell-3.5d0) .le. dx
     &            .and. dabs(ycell-0.5d0) .le. dy) then
                 pressure = 2.d0
             else
                 pressure = 0.d0
             endif
             q(1,i,j) = pressure
             q(2,i,j) = 0.d0
             q(3,i,j) = 0.d0
  20         continue
       return
       end

! ==============================================================================
!  Regions Module
!   Module containing data structures and setup routines for region refinement.
!
! ==============================================================================
module regions_module

    implicit none
    save

    ! Region type definition
    type region_type
        integer :: min_level,max_level
        real(kind=8) :: x_low,x_hi,t_low,t_hi
    end type region_type

    logical, private :: module_setup

    integer :: num_regions
    type(region_type), allocatable :: regions(:)
      
contains

    subroutine set_regions(fname)

        use amr_module
      
        implicit none
      
        ! Function Arguments
        character(len=*), optional, intent(in) :: fname
      
        ! Locals
        integer, parameter :: unit = 7
        integer :: i

        if (.not. module_setup) then

            write(parmunit,*) ' '
            write(parmunit,*) '--------------------------------------------'
            write(parmunit,*) 'REGIONS:'
            write(parmunit,*) '-----------'

            if (present(fname)) then
                call opendatafile(unit,fname)
            else
                call opendatafile(unit,'regions.data')
            endif

            read(unit,"(i2)") num_regions
            if (num_regions == 0) then
                write(parmunit,*) '  No regions specified for refinement'
                
            else
                ! Refinement region data
                allocate(regions(num_regions))
                do i=1,num_regions
                    read(unit,*) regions(i)%min_level, regions(i)%max_level, &
                                 regions(i)%t_low, regions(i)%t_hi, &
                                 regions(i)%x_low, regions(i)%x_hi
                enddo
            endif
            close(unit)

            module_setup = .true.
        end if

    end subroutine set_regions

end module regions_module

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! Riemann solver for the sample scalar equation
!  q_t + u*q_x + v*q_y = 0

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.
! On output, wave contains the waves,
!            s the speeds,
!
!            amdq = A^- Delta q,
!            apdq = A^+ Delta q,
!                   the decomposition of the flux difference
!                       f(qr(i-1)) - f(ql(i))
!                   into leftgoing and rightgoing parts respectively.
!

! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr
! maux=0 and aux arrays are unused in this example.


    implicit double precision (a-h,o-z)
    common /cparam/ u,v

    dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension  apdq(meqn, 1-mbc:maxm+mbc)
    dimension  amdq(meqn, 1-mbc:maxm+mbc)


!$$$      do 30 i = 2-mbc, mx+mbc-1
    do 30 i = 2-mbc, mx+mbc
        wave(1,1,i) = ql(1,i) - qr(1,i-1)
        if (ixy == 1) then
            s(1,i) = u
        else
            s(1,i) = v
        endif
    
    !        # flux differences:
        amdq(1,i) = dmin1(s(1,i), 0.d0) * wave(1,1,i)
        apdq(1,i) = dmax1(s(1,i), 0.d0) * wave(1,1,i)
    
    30 END DO

    return
    end subroutine rpn2

c
c -----------------------------------------------------------------------------------
c
      subroutine setdomflags(mptr,igridflags,ilo,ihi,
     .                       mbuff,lbase,lcheck,mibuff)

      use amr_module

      integer*1 igridflags(ilo-mbuff:ihi+mbuff)
c icopy is dimensioned large enough, but will be used at several sizes
c and accessed using loi-mbuff:hi_i+mbuff, etc.      
      integer*1 icopy(mibuff)
      dimension ist(3), iend(3), ishift(3)
      dimension igridst(lcheck)
      dimension igridend(lcheck)

c
c set domain flags for this grid only, enlarged by buffer zone. check if any other base grids
c are in exterior or first interior border cell and mark ok.
c note that interior of base grids 1 away from edge are automatically ok for proper nesting
c  will shrink gridflags after setting to get proper nesting region
c
c  1. initialize this grids domain flags to 0, at lcheck
        do i = ilo-mbuff, ihi+mbuff
           igridflags(i) = 0
        end do
 
c
c
c    ... if lbase coarse than lcheck, set initial indices, before upscaling, for base transfer
c        so that dont have entire base grid upscaled
         igridst(lcheck)  = ilo
         igridend(lcheck) = ihi
         do lc = lcheck-1,lbase,-1  !NB: may be a 0 trip do loop, not old fortran
            ilo_coarse = floor(dfloat(igridst(lc+1))/intratx(lc))
            ihi_coarse = ceiling(dfloat(igridend(lc+1))/intratx(lc)) - 1
            if (ihi_coarse*intratx(lc) .lt. igridend(lc+1)) 
     .           ihi_coarse = ihi_coarse+1
            igridend(lc) = ihi_coarse
            igridst(lc) = ilo_coarse
         end do
         ilo_coarse = igridst(lbase)
         ihi_coarse = igridend(lbase)

      if (xperdom) then   ! set here once and for all, use coarsened "base" coords to set
         call setIndices(ist,iend,
     .              ilo_coarse-mbuff,ihi_coarse+mbuff,
     .              ishift,lbase)
       endif 

c  3.  loop over all other intersecting grids at base level staying fixed
c      set the buffer zone in igridflags to 1 if nested 
c      this is so when shrink by one you dont lose too much area.
        mbase = lstart(lbase)
 20     continue        
           iblo = node(ndilo,mbase)   ! if base grid coarser, need to scale up
           ibhi = node(ndihi,mbase)   ! if same grid will just mark interior cells as 1
c
c  3.5 if periodic bcs, then if grids buffer sticks out, will have to wrap the
c      coordinates and flag any intersecting base grids for wrapped  buffer.
c      do here instead of above since cant coarsen mbuff same way you can for regular grid
c      also grid itself (without enlarged mbuff zone) doesnt stick out
       if (xperdom) then
           do 25 i = 1, 3
c              i1 = max(ist(i)  + ishift(i)
c              i2 = iend(i) + ishift(i)
               i1 = max(ilo_coarse-mbuff,ist(i))
               i2 = min(ihi_coarse+mbuff,iend(i))

               if (.not. (i1 .le. i2)) go to 25 ! part of patch in this region
c
c              part of patch is in this region [i]
c              periodically wrap and fill if it intersects with grid mbase
c              note: this is done in two steps in hopes of greater clarity
               

c usual check would be ->  if (i1 .gt. i2) go to 25  ! no patch
c cant do that since have not yet included buffer zone - which is the part that would get wrapped

c             patch exist. does it intersect with mbase grid?
c             use wrapped coords of this grid to test if intersects with base grid
              ixlo = max(iblo,i1+ishift(i)) 
              ixhi = min(ibhi,i2+ishift(i))
c
              if (ixlo .gt. ixhi) go to 25  !this grid doesnt intersect
c
c             if wrapped region does intersect, be careful to set the INTERSECTED part of
c             the UNWRAPPED region  of original enlarged grid
              ixlo_unwrapped = ixlo - ishift(i)   
              ixhi_unwrapped = ixhi - ishift(i)
              call coarseGridFlagSet(igridflags,
     .                               ixlo_unwrapped,ixhi_unwrapped,
     .                               ilo_coarse,ihi_coarse,mbuff)

 25        continue

       else       
           ixlo = max(iblo,ilo_coarse-mbuff)
           ixhi = min(ibhi,ihi_coarse+mbuff)
c
c         does this patch intersect mbase grid?
           if (.not.(ixlo .le. ixhi)) go to 30  !this grid doesnt intersect
c
           call coarseGridFlagSet(igridflags,ixlo,ixhi,
     .                           ilo_coarse,ihi_coarse,
     .                           mbuff)
       endif

 30     mbase = node(levelptr,mbase)
        if (mbase .ne. 0) go to 20
c
c 3.5 set any part of grid buffer zone to 1 that is at physical boundary 
        call setPhysBndryFlags(igridflags,ilo_coarse,ihi_coarse,
     .                         mbuff,lbase)

c  4.  done setting flags. upscale to level needed then
c      shrink by 1 for actual nested region
c      shrink once - works if lcheck same as lbase
c      if going up 1 level each one needs to be nested, so still shrink first before upsizing
c
c  after loop above, dom flags in igridflags, copy to icopy
      call griddomcopy(icopy,igridflags,ilo_coarse,ihi_coarse,
     .                 mbuff)
c
c     shrink from icopy to dom2 flag array
      call griddomshrink(icopy,ilo_coarse,ihi_coarse,
     .                     mbuff,
     .                     alloc(node(domflags2,mptr)),lbase)

      do 40 lev = lbase+1, lcheck
c         ### for each level that upsize, calculate new coords starting from
c         ### actual fine grid and recoarsening down to needed level
c         ### cant take previous coarse coords and refine, since may be
c         ### too large. grid prob. not anchored at base grid corner.
         ilofine = igridst(lev)
         ihifine = igridend(lev)
c
c       flags in dom2, upsize to icopy array with finer dimensions
        call griddomup(alloc(node(domflags2,mptr)),icopy,
     .                 ilo_coarse,ihi_coarse,
     .                 mbuff,lev-1,
     .                 ilofine,ihifine)
c       flags in icopy, shrink one  back to dom2
        call griddomshrink(icopy,ilofine,ihifine,
     .                     mbuff,alloc(node(domflags2,mptr)),lev)
        ilo_coarse = ilofine
        ihi_coarse = ihifine
40    continue
c 
        return
        end

c
!> For a rectangle that is on level **level**, described by
!! **ilo**, **ihi**, **jlo**, **jhi** and made up by 
!! **mitot** \f$ \times\f$ **mjtot** cells, copy solution from 
!! all (OLD) grids on level **level** to **val**, which stores
!! solution on this rectangle.
!! Some portions of the rectangle may not be filled since they do not
!! overlap with any level **level** grids.
!!  
c --------------------------------------------------------------------
c
       subroutine intcopy(val,mitot,mjtot,nvar,ilo,ihi,jlo,jhi,level,
     &                    iputst,jputst)

      use amr_module
       implicit double precision (a-h, o-z)

       dimension val(nvar,mitot,mjtot)


c   OLD INDEXING
c      iadd(i,j,ivar) = loc + i - 1 + mi*((ivar-1)*mj+j-1)
c   NEW INDEXING ORDER SWITCHED
       iadd(ivar,i,j) = loc + ivar-1 + nvar*((j-1)*mi+i-1)

c ::::::::::::::::::::::::::: INTCOPY :::::::::::::::::::::::::::::::
c
c    find intersecting grids at the same level. copy data from
c    old grid to val. 
c    old grid has "nghost" ghost cells - passed in nodal common block.
c    new grid has no ghost cells - indices describe entire patch.
c    iputst, jputst: where to copy values into. may not be in
c                    location corresponding to ilo,ihi,etc. if
c                    the patch has been periodically wrapped.
c    
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       mptr = lstart(level)

 10    if (mptr .eq. 0) go to 99
          iglo = node(ndilo,mptr)
          ighi = node(ndihi,mptr)
          jglo = node(ndjlo,mptr)
          jghi = node(ndjhi,mptr)

c         # does it intersect?
          ixlo = max(iglo,ilo)
          ixhi = min(ighi,ihi)
          jxlo = max(jglo,jlo)
          jxhi = min(jghi,jhi)

          if (ixlo .le. ixhi .and. jxlo .le. jxhi) then
              loc  = node(store1,mptr)
              nx   = ighi - iglo + 1
              ny   = jghi - jglo + 1
              mi   = nx + 2*nghost
              mj   = ny + 2*nghost
              do 20 j    = jxlo, jxhi
              do 21 ivar = 1, nvar
              do 30 i    = ixlo, ixhi
                 val(ivar,iputst+i-ilo,jputst+j-jlo) =
     1               alloc(iadd(ivar,i-iglo+nghost+1,j-jglo+nghost+1))
 30           continue
 21           continue
 20           continue
          endif
          mptr = node(levelptr, mptr)
          go to 10

 99   return
      end

c
c --------------------------------------------------------------
c
      subroutine setflags(iflags,isize,jsize,ksize,
     1                    rctold,idim3,mitot,mjtot,mktot,mptr)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension rctold(idim3,mitot,mjtot,mktot)
      integer*1 iflags(0:isize+1,0:jsize+1,0:ksize+1)

c :::::::::::::::::::::: SETFLAGS ::::::::::::::::::::::::::::::::::
c transfer flagged arrays into 1 large array of entire domain
c makes buffering, projecting, etc. easier without searching 
c through all kinds of grids
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

      ibeg = node(ndilo,mptr) - nghost
      jbeg = node(ndjlo,mptr) - nghost
      kbeg = node(ndklo,mptr) - nghost

      do 10 k = nghost+1, mktot-nghost
      do 10 j = nghost+1, mjtot-nghost
      do 10 i = nghost+1, mitot-nghost
         iflags(ibeg+i,jbeg+j,kbeg+k) =  iflags(ibeg+i,jbeg+j,kbeg+k)
     .                                   + rctold(1,i,j,k)
 10   continue
c
 99   return
      end

c
c
c
c     ==================================================================
      subroutine rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,
     &			auxl,auxr,wave,s,amdq,apdq)
c     ==================================================================
c
c     # Solve Riemann problems for the 3D hyperbolic problem.
c     # This is a dummy routine and is only intended
c     # to illustrate the format of this routine.  
c     # See various example directories for better examples.
c
c       -----------------------------------------------------------
c
c     # solve Riemann problems along one slice of data.
c     # This data is along a slice in the x-direction if ixyz=1
c     #                               the y-direction if ixyz=2.
c     #                               the z-direction if ixyz=3.
c
c     # On input, ql contains the state vector at the left edge of each cell
c     #           qr contains the state vector at the right edge of each cell
c
c     # On output, wave contains the waves, s the speeds,
c     # and amdq, apdq the left-going and right-going flux differences,
c     # respectively.  
c
c     # Note that the i'th Riemann problem has left state qr(:,i-1)
c     #                                    and right state ql(:,i)
c     # From the basic clawpack routines, this routine is called with ql = qr
c
      implicit real*8(a-h,o-z)
c
      dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
      dimension    s(mwaves, 1-mbc:maxm+mbc)
      dimension   ql(meqn, 1-mbc:maxm+mbc)
      dimension   qr(meqn, 1-mbc:maxm+mbc)
      dimension amdq(meqn, 1-mbc:maxm+mbc)
      dimension apdq(meqn, 1-mbc:maxm+mbc)
      dimension auxl(maux, 1-mbc:maxm+mbc)
      dimension auxr(maux, 1-mbc:maxm+mbc)

      write(6,*) 'You must provide a valid Riemann solver'
      stop
c
      return
      end

c
c -------------------------------------------------------------
c
      subroutine outvar(rect,mitot,mjtot,mktot,nvar,mptr,ng)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension rect(nvar,mitot,mjtot,mktot)

c ::::::::::::::: OUTVAR ::::::::::::::::::::::::::::::::::
c
c  dump soln for graphics 
c
c  only output max - 1 rows and cols, since with cell centered
c  variables there is one extra cell outside the grid.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      write(pltunit1,100) mptr
 100  format('*SOLN     ',i10,' is the grid - all variables')
c
      do 20 ivar = 1, nvar
         write(pltunit1,101) (((rect(ivar,i,j,k),i=ng+1,mitot-ng),
     .                                           j=ng+1,mjtot-ng),
     .                                           k=ng+1,mktot-ng)
 101     format(5e13.6)
 20   continue
c
      return
      end

!  :::::::::::::: PREFILRECUR :::::::::::::::::::::::::::::::::::::::::::
!     For periodic boundary conditions more work needed to fill the
!     piece of the boundary. This routine was
!     called because the patch sticks out of the domain,
!     and has periodic bc.s preprocess the patch before calling
!     filpatch to shift the patch periodically back into the domain.
!
!     Inputs to this routine:
!     xl, xr, yb, yt = the location in physical space of
!     corners of a patch.
!     fill_indices = the location in index space of this patch.
!
!     Outputs from this routine:
!     The values around the border of the grid are inserted
!     directly into the enlarged valbig array for this piece.
!
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
recursive subroutine prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,nrowst,ncolst,  &  
                                  ilo,ihi,jlo,jhi,fullGrid)



    use amr_module, only: iregsz, jregsz, nghost, xlower, ylower, xperdom, yperdom
    use amr_module, only: spheredom, hxposs, hyposs, NEEDS_TO_BE_SET
    
    !for setaux timing
    use amr_module, only: timeSetaux, timeSetauxCPU
    
    implicit none

    ! Input
    integer, intent(in) :: level, nvar, naux, mitot, mjtot, nrowst, ncolst
    integer, intent(in) :: ilo,ihi,jlo,jhi
    real(kind=8), intent(in) :: time
    logical  :: fullGrid  ! true first time called, false for recursive coarse sub-patches

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mitot,mjtot)
    real(kind=8), intent(in out) :: aux(naux,mitot,mjtot)
    
    ! Local storage
    integer :: i, j, ii, jj, ivar, nr, nc, ng, i1, i2, j1, j2, iputst, jputst
    integer :: jbump, iwrap1, iwrap2, jwrap1, tmp, locflip, rect(4)
    real(kind=8) :: xlwrap, ybwrap

    integer :: ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)
    real(kind=8) :: scratch(max(mitot,mjtot)*nghost*nvar)
    real(kind=8) :: scratchaux(max(mitot,mjtot)*nghost*naux)
    
    !for timings
    integer :: clock_start, clock_finish, clock_rate
    real(kind=8) :: cpu_start, cpu_finish

!     # will divide patch into 9 possibilities (some empty): 
!       x sticks out left, x interior, x sticks out right
!       same for y. for example, the max. would be
!       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)

    if (xperdom) then       
       ist(1)    = ilo
       ist(2)    = 0
       ist(3)    = iregsz(level)
       iend(1)   = -1
       iend(2)   = iregsz(level)-1
       iend(3)   = ihi
       ishift(1) = iregsz(level)
       ishift(2) = 0
       ishift(3) = -iregsz(level)
    else  ! if not periodic, set vals to only have nonnull intersection for interior regoin
       ist(1)    = iregsz(level)
       ist(2)    = ilo
       ist(3)    = iregsz(level)
       iend(1)   = -1
       iend(2)   = ihi
       iend(3)   = -1
       ishift(1) = 0
       ishift(2) = 0
       ishift(3) = 0
    endif

    if (yperdom .or. spheredom) then
       jst(1)  = jlo
       jst(2)  = 0
       jst(3)  = jregsz(level)
       jend(1) = -1
       jend(2) = jregsz(level)-1
       jend(3) = jhi
       jshift(1) = jregsz(level)
       jshift(2) = 0
       jshift(3) = -jregsz(level)
    else
       jst(1)    = jregsz(level)
       jst(2)    = jlo
       jst(3)    = jregsz(level)
       jend(1)   = -1
       jend(2)   = jhi
       jend(3)   = -1
       jshift(1) = 0
       jshift(2) = 0
       jshift(3) = 0
    endif

!   ## loop over the 9 regions (in 2D) of the patch - the interior is i=j=2 plus
!   ## the ghost cell regions.  If any parts stick out of domain and are periodic
!   ## map indices periodically, but stick the values in the correct place
!   ## in the orig grid (indicated by iputst,jputst.
!   ## if a region sticks out of domain  but is not periodic, not handled in (pre)-icall 
!   ## but in setaux/bcamr (not called from here).
    do 20 i = 1, 3
        i1 = max(ilo,  ist(i))
        i2 = min(ihi, iend(i))
        if (i1 .gt. i2) go to 20
        do 10 j = 1, 3
            j1 = max(jlo,  jst(j))
            j2 = min(jhi, jend(j))

            ! part of patch in this region
            if (j1 <= j2) then 

                ! there is something to fill. j=2 case is interior, no special
                ! mapping needed even if spherical bc
                if (.not. spheredom .or. j == 2 ) then
                    iputst = (i1 - ilo) + nrowst
                    jputst = (j1 - jlo) + ncolst

                    call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
                                  iputst,jputst,i1+ishift(i),i2+ishift(i),j1+jshift(j),j2+jshift(j),.false.)
                else
                    nr = i2 - i1 + 1
                    nc = j2 - j1 + 1
                    ng = 0    ! no ghost cells in this little patch. fill everything.

                    jbump = 0
                    if (j1 < 0)   jbump = abs(j1)  ! bump up so new bottom is 0
                    if (j2 >= jregsz(level)) jbump = -(j2+1-jregsz(level)) ! bump down

                    ! next 2 lines would take care of periodicity in x
                    iwrap1 = i1 + ishift(i)
                    iwrap2 = i2 + ishift(i)
                    ! next 2 lines take care of mapped sphere bcs
                    iwrap1 = iregsz(level) - iwrap1 -1
                    iwrap2 = iregsz(level) - iwrap2 -1
                    ! swap so that smaller one is left index, etc since mapping reflects
                    tmp = iwrap1
                    iwrap1 = iwrap2
                    iwrap2 = tmp

                    jwrap1 = j1 + jbump
                    xlwrap = xlower + iwrap1*hxposs(level)
                    ybwrap = ylower + jwrap1*hyposs(level)
              
                    if (naux>0) then
                        scratchaux = NEEDS_TO_BE_SET  !flag all cells with signal since dimensioned strangely
                        
                        call system_clock(clock_start,clock_rate)
                        call cpu_time(cpu_start)
                        call setaux(ng,nr,nc,xlwrap,ybwrap,hxposs(level),hyposs(level),naux,scratchaux)
                        call system_clock(clock_finish,clock_rate)
                        call cpu_time(cpu_finish)
                        timeSetaux = timeSetaux + clock_finish - clock_start
                        timeSetauxCPU = timeSetauxCPU + cpu_finish - cpu_start
                    endif 

                    rect = [iwrap1,iwrap2,j1+jbump,j2+jbump]
                    call filrecur(level,nvar,scratch,scratchaux,naux,time,nr, &
                                  nc,1,1,iwrap1,iwrap2,j1+jbump,j2+jbump,.false.)

                    ! copy back using weird mapping for spherical folding
                    do ii = i1, i2
                        do jj = j1, j2
                            ! write(dbugunit,'(" filling loc ",2i5," with ",2i5)') nrowst+ii-fill_indices(1),ncolst+jj-fill_indices(3),nr-(ii-i1),nc-jj+j1

                            do ivar = 1, nvar
                                valbig(ivar,nrowst+(ii-ilo),ncolst+(jj-jlo)) = &
                                    scratch(iaddscratch(ivar,nr-(ii-i1),nc-(jj-j1)))
                            end do
                            ! write(dbugunit,'(" new val is ",4e15.7)')(valbig(ivar,nrowst+(ii-fill_indices(1)),ncolst+(jj-fill_indices(3))),ivar=1,nvar)
                        end do
                    end do 
                endif
            endif
 10     continue
 20   continue

contains

    integer pure function iadd(n,i,j)
        implicit none
        integer, intent(in) :: n, i, j
        iadd = locflip + n-1 + nvar*((j-1)*nr+i-1)
    end function iadd

    integer pure function iaddscratch(n,i,j)
        implicit none
        integer, intent(in) :: n, i, j
        iaddscratch = n + nvar*((j-1)*nr+i-1)  ! no subtract 1
    end function iaddscratch

end subroutine prefilrecur

      program driver
c
c  Generic driver routine for claw1
c
c  Author: Randall J. LeVeque
c  Version of March, 1999 --  CLAWPACK Version 4.0
c
c
      implicit double precision (a-h,o-z)

c     # set parameters for maximum array sizes used in declarations
c     # these must be increased for larger problems.
c
c
      parameter (maxmx = 51200)
      parameter (mwork = 1945752)

      parameter (mbc = 2)
      parameter (meqn = 4)
      parameter (mwaves = 4)
      parameter (maux = 5)
c       # NOTE: if maux>0 you must declare aux properly below!
c
      dimension q(1-mbc:maxmx+mbc, meqn)

C       dimension  aux(1)   !# dummy variable since no aux arrays used
      dimension  aux(1-mbc:maxmx+mbc, maux)

      dimension work(mwork)
      dimension mthlim(mwaves)

      call claw1ez(maxmx,meqn,mwaves,mbc,maux,mwork,mthlim,
     &           q,work,aux)

      stop 
      end

!
! ----------------------------------------------------------------
!
subroutine simpleBound(time,nvar,val,mitot,mjtot,mptr,aux,naux)

       use amr_module
       implicit none

       !input
       integer, intent(in) :: nvar, naux, mitot, mjtot, mptr
       real(kind=8), intent(in) :: time
       real(kind=8), intent(inout) :: val(nvar,mitot,mjtot)
       real(kind=8), intent(inout) :: aux(naux,mitot,mjtot)

       !locals
       integer :: ilo,ihi,jlo,jhi,iloadj,ihiadj,jloadj,jhiadj,i,j
       integer :: imlo,jmlo,imhi,jmhi,mgridmitot,locnew,ialloc,level
       integer :: ixlo,ixhi,jxlo,jxhi,bndLoc,bndNum,nextSpot,numg,icount,mgrid
       real(kind=8) :: hx,hy,xloWithGhost,xhiwithGhost,yloWithGhost,yhiWithGhost
       integer :: ist, iend, ivar, jst, jend

!      replace fine grid ghost cells with interior vals from other
!      grids at same level.  
!      ghost cells will already have been filled by coarser grids, 
!      so overwrite now if something better is available.

       level = node(nestlevel,mptr)
       hx = hxposs(level)
       hy = hyposs(level)
       xloWithGhost = rnode(cornxlo,mptr) - nghost*hx
       xhiWithGhost = rnode(cornxhi,mptr) + nghost*hx
       yloWithGhost = rnode(cornylo,mptr) - nghost*hy
       yhiWithGhost = rnode(cornyhi,mptr) + nghost*hy

       ! since filling ghost cells, adjust the integer indices to include them
       ilo = node(ndilo, mptr) 
       jlo = node(ndjlo, mptr) 
       ihi = node(ndihi, mptr) 
       jhi = node(ndjhi, mptr)

       iloadj = ilo - nghost
       jloadj = jlo - nghost
       ihiadj = ihi + nghost
       jhiadj = jhi + nghost

       !loop over bndry list to set ghost cells from grids at this level only
       ! then finish by calling bc2amr for domain bndry patches
       !
       ! NB this routine should overwrite and replace  the coarse interpolated 
       ! fine ghost cells from fillFine, called earlier,
       ! if there are neighboring fine grids 

       ! get list info of adjacent grids
       bndLoc = node(bndListSt, mptr)
       bndNum = node(bndListNum, mptr)
       nextSpot = node(bndListSt,mptr)
       numg = bndNum

       do icount = 1, numg
          mgrid = bndlist(nextspot, gridNbor)
          ! but use regular indices of neighboring grids as sources to fill
          imlo = node(ndilo, mgrid)
          jmlo = node(ndjlo, mgrid)
          imhi = node(ndihi, mgrid)
          jmhi = node(ndjhi, mgrid)
          mgridmitot = imhi - imlo + 1 + 2*nghost
          locnew = node(store1, mgrid)

          ixlo = max(imlo,iloadj)
          ixhi = min(imhi,ihiadj)
          jxlo = max(jmlo,jloadj)
          jxhi = min(jmhi,jhiadj)

          if (ixlo > ixhi  .or. jxlo > jxhi) go to 10

          ! only ghost cells should intersect, but do double loop since dont know which side
          do j = jxlo, jxhi
          do i = ixlo, ixhi
             ialloc = iadd(2, i-imlo+nghost+1, j-jmlo+nghost+1)
             val(2,i-ilo+nghost+1,j-jlo+nghost+1) = alloc(ialloc)
             val(3,i-ilo+nghost+1,j-jlo+nghost+1) = alloc(ialloc+1)
             if (nvar .eq. 5) then ! use fact that variables are consecutive in memory
                 val(4,i-ilo+nghost+1,j-jlo+nghost+1) = alloc(ialloc+2)
                 val(5,i-ilo+nghost+1,j-jlo+nghost+1) = alloc(ialloc+3)
             endif
          end do
          end do

 10       nextSpot = bndList(nextSpot,nextfree) ! get next grid

       end do

!  finish by calling bc2amr in case there are domain bndry touching patches
      call bc2amr(val,aux,mitot,mjtot,nvar,naux,hx,hy,level,time,                &
                  xloWithGhost,xhiWithGhost,yloWithGhost,yhiWithGhost)
contains

    integer pure function iadd(ivar,i,j)
        implicit none
        integer, intent(in) :: ivar,i,j
        iadd = locnew + ivar-1 + nvar*((j-1)*mgridmitot+i-1)
     end function iadd

end subroutine simpleBound

c
c ----------------------------------------------------
c
      subroutine domprep(domflags,lbase,ibase,jbase,kbase)

      use amr_module
      implicit double precision (a-h, o-z)


      integer*1 domflags(0:ibase+1,0:jbase+1,0:kbase+1)

c
c ::::::::::::::::::::::::::: PREPDOM :::::::::::::::::::::
c 
c  prepare 3 dimensional array of domain for proper nesting
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::


      do 10 k = 0, kbase+1
      do 10 j = 0, jbase+1
      do 10 i = 0, ibase+1
        domflags(i,j,k) = 0
 10   continue

      mptr = lstart(lbase)
 15   continue
      do 20 k = node(ndklo,mptr) + 1, node(ndkhi,mptr) + 1
      do 20 j = node(ndjlo,mptr) + 1, node(ndjhi,mptr) + 1
      do 20 i = node(ndilo,mptr) + 1, node(ndihi,mptr) + 1
        domflags(i,j,k) = 1
 20   continue
      mptr = node(levelptr, mptr)
      if (mptr .ne. 0) go to 15

c
c take care of periodic domains or if border of domain touches a 
c  physical boundary then set domain in ghost cell as well
c
      if (xperdom) then
         do 25 k = 0, kbase+1
         do 25 j = 0, jbase+1
          domflags(      0,j,k) = domflags(ibase,j,k)
          domflags(ibase+1,j,k) = domflags(    1,j,k)
 25      continue
       else
         do 65 k = 1, kbase
         do 65 j = 1, jbase
           if (domflags(    1,j,k) .eq. 1) domflags(      0,j,k) = 1
           if (domflags(ibase,j,k) .eq. 1) domflags(ibase+1,j,k) = 1
 65      continue
      endif
      if (yperdom) then
         do 35 k = 0, kbase+1
         do 35 i = 0, ibase+1
           domflags(i,      0,k) = domflags(i,jbase,k)
           domflags(i,jbase+1,k) = domflags(i,    1,k)
 35      continue
       else
         do 55 k = 1, kbase
         do 55 i = 1, ibase
            if (domflags(i,    1,k) .eq. 1) domflags(i,      0,k) = 1
            if (domflags(i,jbase,k) .eq. 1) domflags(i,jbase+1,k) = 1
 55      continue
      endif
      if (zperdom) then
         do 45 j = 0, jbase+1
         do 45 i = 0, ibase+1
           domflags(i,j,      0) = domflags(i,j,kbase)
           domflags(i,j,kbase+1) = domflags(i,j,    1)
 45      continue
      else
         do 75 j = 1, jbase
         do 75 i = 1, ibase
           if (domflags(i,j,    1) .eq. 1) domflags(i,j,      0) = 1
           if (domflags(i,j,kbase) .eq. 1) domflags(i,j,kbase+1) = 1
 75       continue
      endif
c
c     corner stuff
c
      do k = 1, kbase
        if (domflags(0,1,k)+domflags(1,0,k).eq.2)  domflags(0,0,k) = 1
        if (domflags(0,jbase,k)+domflags(1,jbase+1,k).eq.2)
     .                                       domflags(0,jbase+1,k) = 1
        if (domflags(ibase,0,k)+domflags(ibase+1,1,k).eq.2)
     .                                       domflags(ibase+1,0,k) = 1
        if (domflags(ibase,jbase+1,k)+domflags(ibase+1,jbase,k).eq.2)
     .                                 domflags(ibase+1,jbase+1,k) = 1
      end do
      do i = 1, ibase
        if (domflags(i,0,1)+domflags(i,1,0).eq.2)  domflags(i,0,0) = 1
        if (domflags(i,jbase,0)+domflags(i,jbase+1,1).eq.2)
     .                                       domflags(i,jbase+1,0) = 1
        if (domflags(i,0,kbase)+domflags(i,1,kbase+1).eq.2)
     .                                       domflags(i,0,kbase+1) = 1
        if (domflags(i,jbase+1,kbase)+domflags(i,jbase,kbase+1).eq.2)
     .                                 domflags(i,jbase+1,kbase+1) = 1
      end do
      do j = 1, jbase
        if (domflags(0,j,1)+domflags(1,j,0).eq.2)  domflags(0,j,0) = 1
        if (domflags(ibase,j,0)+domflags(ibase+1,j,1).eq.2)
     .                                       domflags(ibase+1,j,0) = 1
        if (domflags(0,j,kbase)+domflags(1,j,kbase+1).eq.2)
     .                                       domflags(0,j,kbase+1) = 1
        if (domflags(ibase+1,j,kbase)+domflags(ibase,j,kbase+1).eq.2)
     .                                 domflags(ibase+1,j,kbase+1) = 1
      end do
c
c     The neigbors of a corner are the three locations each having an
c     address which differs from that of the corner by 1 in just one of
c     the three indexes. If a corner index is 0, the corresponding neighbor
c     index may be 0 or 1. If a corner index is base+1, the corresponding
c     neighbor index may be base+1 or base (where base => [i,j,k]base).
c
      if (( domflags(      0,      0,      1)
     &     +domflags(      0,      1,      0)
     &     +domflags(      1,      0,      0)) .eq. 3)
     .      domflags(      0,      0,      0)   =   1
 
      if (( domflags(ibase+1,      0,      1)
     &     +domflags(ibase+1,      1,      0)
     &     +domflags(ibase  ,      0,      0)) .eq. 3)
     .      domflags(ibase+1,      0,      0)   =   1
 
      if (( domflags(      0,jbase+1,      1)
     &     +domflags(      0,jbase  ,      0)
     &     +domflags(      1,jbase+1,      0)) .eq. 3)
     .      domflags(      0,jbase+1,      0)   =   1
 
      if (( domflags(ibase+1,jbase+1,      1)
     &     +domflags(ibase+1,jbase  ,      0)
     &     +domflags(ibase  ,jbase+1,      0)) .eq. 3)
     .      domflags(ibase+1,jbase+1,      0)   =   1
 
      if (( domflags(      0,      0,kbase  )
     &     +domflags(      0,      1,kbase+1)
     &     +domflags(      1,      0,kbase+1)) .eq. 3)
     .      domflags(      0,      0,kbase+1)   =   1
 
      if (( domflags(ibase+1,      0,kbase  )
     &     +domflags(ibase+1,      1,kbase+1)
     &     +domflags(ibase  ,      0,kbase+1)) .eq. 3)
     .      domflags(ibase+1,      0,kbase+1)   =   1
 
      if (( domflags(      0,jbase+1,kbase  )
     &     +domflags(      0,jbase  ,kbase+1)
     &     +domflags(      1,jbase+1,kbase+1)) .eq. 3)
     .      domflags(      0,jbase+1,kbase+1)   =   1
 
      if (( domflags(ibase+1,jbase+1,kbase  )
     &     +domflags(ibase+1,jbase  ,kbase+1)
     &     +domflags(ibase  ,jbase+1,kbase+1)) .eq. 3)
     .      domflags(ibase+1,jbase+1,kbase+1)   =   1

      if (dprint) then
         write(outunit,*)" from domprep: domflags at level  ", lbase
         do 40 kk = 1, kbase
         k = kbase + 1 - kk
         write(outunit,*) 'plane k = ',k
         do 40 jj = 1, jbase
         j = jbase + 1 - jj
         write(outunit,100)(domflags(i,j,k),i=1,ibase)
 100     format(80i1)
 40      continue
      endif

      return
      end

c
c ---------------------------------------------------------------
c
        subroutine trimbd(used,set,il ,ir ,jl ,jr ,kl ,kr ,
     &                             ilo,ihi,jlo,jhi,klo,khi)
c
c ::::::::::::::::::::: TRIMBD :::::::::::::::::::::::::::::::::::
c  if used array is completely set (=1.) then return set=true, 
c  otherwise return false, and the dimensions of the smallest rectangular
c  parallelopiped containing all unset points in il,ir,jl,jr,kl,kr.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
        implicit double precision (a-h,o-z)
        dimension  used(ilo:ihi,jlo:jhi,klo:khi)
        logical   set

        utot = 0.
        nrow = ihi - ilo + 1
        ncol = jhi - jlo + 1
        nfil = khi - klo + 1

        do 100 k = klo, khi
        do 100 j = jlo, jhi
        do 100 i = ilo, ihi
100        utot = utot + used(i,j,k)

        if (utot .ge. dble(nrow*ncol*nfil)) then
                set = .true.
                return
        endif
 
c some unset cells were found

        set = .false.
 
        uleft = 1.
        do 200 i = ilo, ihi
           do 220 k = klo, khi
           do 220 j = jlo, jhi
              uleft = dmin1(uleft,used(i,j,k))
220        continue
           il = i 
           if (uleft .eq. 0.) go to 230
200     continue

230     uright = 1.
        do 300 i = ihi, ilo, -1
           do 320 k = klo, khi
           do 320 j = jlo, jhi
              uright = dmin1(uright,used(i,j,k))
320        continue
           ir = i 
           if (uright .eq. 0.) go to 330
300     continue

330     ufront = 1.
        do 400 j = jlo, jhi
           do 420 k = klo, khi
           do 420 i = ilo, ihi
              ufront = dmin1(ufront,used(i,j,k))
420        continue
           jl = j 
           if (ufront .eq. 0.) go to 430
400        continue
 
430     urear = 1.
        do 500 j = jhi, jlo, -1
           do 520 k = klo, khi
           do 520 i = ilo, ihi
              urear = dmin1(urear,used(i,j,k))
520        continue
           jr = j 
           if (urear .eq. 0.) go to 530
500     continue
 
530     ubot = 1.
        do 600 k = klo, khi
           do 620 j = jlo, jhi
           do 620 i = ilo, ihi
              ubot = dmin1(ubot,used(i,j,k))
620        continue
           kl = k
           if (ubot .eq. 0.) go to 630
600     continue
 
630     utop = 1.
        do 700 k = khi, klo, -1
           do 720 j = jlo, jhi
           do 720 i = ilo, ihi
              utop = dmin1(utop,used(i,j,k))
720        continue
           kr = k 
           if (utop .eq. 0.) go to 730
700     continue

730     continue

        return
        end

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! HLLE solver for the 2D shallow water equations.

! waves: 2
! equations: 3

! Conserved quantities:
!       1 depth
!       2 x-momentum
!       3 y-momentum

    implicit none

    integer, intent(in) :: ixy, maxm, meqn, mwaves, maux, mbc, mx
    double precision, dimension(meqn,1-mbc:maxm+mbc), intent(in) :: ql, qr
    double precision, dimension(maux,1-mbc:maxm+mbc), intent(in) :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxm+mbc), intent(out) :: wave
    double precision, dimension(mwaves, 1-mbc:maxm+mbc), intent(out) :: s
    double precision, dimension(meqn, 1-mbc:maxm+mbc), intent(out) :: amdq, apdq

    double precision :: u_l, u_r, c_l, c_r, u_hat, c_hat, v_l, v_r, v_hat, h_hat
    double precision :: h_l, h_r, hsqrt_l, hsqrt_r, hsq2
    double precision :: grav
    double precision :: h_m, hu_m, hv_m, s1, s2
    integer :: depth, mu, mv
    integer :: i, m, mw

    common /cparam/  grav

!     # set mu to point to  the component of the system that corresponds
!     # to momentum in the direction of this slice, mv to the orthogonal
!     # momentum:
!

    depth = 1
    if (ixy.eq.1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    do i=2-mbc,mx+mbc
        h_l = qr(depth,i-1)
        h_r = ql(depth,i)
        ! Velocity
        u_l = qr(mu,i-1) / qr(depth,i-1)
        u_r = ql(mu,i  ) / ql(depth,i  )
        v_l = qr(mv,i-1) / qr(depth,i-1)
        v_r = ql(mv,i  ) / ql(depth,i  )
        ! Sound speed
        c_l = dsqrt(grav*h_l)
        c_r = dsqrt(grav*h_r)

        hsqrt_l = dsqrt(qr(depth,i-1))
        hsqrt_r = dsqrt(ql(depth,i))
        hsq2 = hsqrt_l + hsqrt_r
        h_hat = 0.5*(h_l + h_r)
        u_hat = (u_l*hsqrt_l + u_r*hsqrt_r) / hsq2
        v_hat = (v_l*hsqrt_l + v_r*hsqrt_r) / hsq2
        c_hat = dsqrt(grav*h_hat)

        ! Speeds of non-shear waves
        s1 = min(u_l - c_l, u_hat - c_hat)
        s2 = max(u_r + c_r, u_hat + c_hat)

        ! middle" state
        h_m = (ql(mu,i) - qr(mu,i-1) - s2*ql(depth,i) + s1*qr(depth,i-1))/(s1-s2)
        hu_m = (ql(mu,i)*(u_r-s2) - qr(mu,i-1)*(u_l-s1) + 0.5*grav*(h_r**2 - h_l**2) ) / (s1-s2)
        hv_m = (ql(mv,i)*u_r - qr(mv,i-1)*u_l - s2*ql(mv,i) + s1*qr(mv,i-1))/(s1-s2)

        wave(depth,1,i) = h_m - h_l
        wave(mu,1,i) = hu_m - qr(mu,i-1)
        wave(mv,1,i) = hv_m - qr(mv,i-1)
        s(1,i) = s1

        wave(depth,2,i) = h_r - h_m
        wave(mu,2,i) = ql(mu,i) - hu_m
        wave(mv,2,i) = ql(mv,i) - hv_m
        s(2,i) = s2
    end do


    do m=1, meqn
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1, mwaves
                if (s(mw,i) .lt. 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                 else
                   apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                 endif
            end do
        end do
    end do

end subroutine rpn2

! ==============================================================================
!  This Riemann solver provides a harness for the point-wise evaluation of 
!  Riemann solutions and requires a point-wise definition of the Riemann solver
!  in a subroutine of the form "rpt2_ptwise".
! ==============================================================================

subroutine rpt2(ixy, imp, maxm, meqn, mwaves, maux, mbc, mx, ql, qr,          &
                aux1, aux2, aux3, asdq, bmasdq, bpasdq)

    implicit none

    ! Input
    integer, intent(in) :: ixy, imp, maxm, meqn, mwaves, maux, mbc, mx
    real(kind=8), intent(in out) :: ql(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: qr(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: aux1(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: aux2(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: aux3(maux, 1-mbc:maxm+mbc)

    ! Output
    real(kind=8), intent(in out) :: asdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: bmasdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: bpasdq(meqn, 1-mbc:maxm+mbc)

    ! Locals
    integer :: i
    real(kind=8) :: aux_r(maux, 3)
    real(kind=8) :: aux_l(maux, 3)

    do i = 2 - mbc, mx + mbc

        aux_r(:, 1) = aux1(:, i)
        aux_r(:, 2) = aux2(:, i)
        aux_r(:, 3) = aux3(:, i)
        aux_l(:, 1) = aux1(:, i - 1)
        aux_l(:, 2) = aux2(:, i - 1)
        aux_l(:, 3) = aux3(:, i - 1)
        call rpt2_ptwise(ixy, imp, meqn, maux, mwaves, qr(:, i - 1),    &
                                                       ql(:, i),        &
                                                       aux_l,           &
                                                       aux_r,           &
                                                       asdq(:, i),      &
                                                       bmasdq(:, i),    &
                                                       bpasdq(:, i))

    end do

end subroutine rpt2

subroutine fgmax_finalize()

    ! Print out the maxval and aux arrays and de-allocate storage.
    
    ! New style introduced in v5.7.0:
    !   fgmax0001.txt, etc. instead of fort.FG1.valuemax, fort.FG1.aux
    !   aux(1,:,:) value (topography) on proper level included with values,
    !       instead of separate file giving aux values on all levels.

    use fgmax_module
    use amr_module, only: mxnest

    implicit none
    character(30) :: fname
    character(1) :: cma
    character(4) :: cfgno
    integer :: k,ifg,level,mv,ma,ipos,idigit,ifg1
    type(fgrid), pointer :: fg
    real(kind=8) :: topo

    if (FG_NUM_AUX .ne. 1) then
        write(6,*) '*** Unexpected FG_NUM_AUX = ',FG_NUM_AUX
        write(6,*) '*** Including only aux(1) in fort.FG file'
        endif
        
    cfgno = '0000'
    do ifg=1,FG_num_fgrids

        fg => FG_fgrids(ifg)   

        ifg1 = fg%fgno  ! use the fgno specified for filename, not ifg
        do ipos=4,1,-1
            idigit = mod(ifg1,10)
            cfgno(ipos:ipos) = char(ichar('0') + idigit)
            ifg1 = ifg1/10
            enddo

        !fname = 'fort.FG' // cfgno
        fname = 'fgmax' // cfgno // '.txt'
        print *, 'Writing to file ', fname
        open(unit=FG_UNIT,file=trim(fname),status='unknown',form='formatted')

        do k=1,fg%npts
            do mv=1,FG_NUM_VAL
                if (abs(fg%valuemax(mv,k)) .lt. 1.d-90) then
                    fg%valuemax(mv,k) = 0.d0
                    endif
                enddo
            ! Modified to print topo value after levelmax and before valuemax:
            if (fg%levelmax(k) > 0) then    
                topo = fg%aux(fg%levelmax(k),1,k)
            else
                topo = FG_NOTSET
            endif
            write(FG_UNIT,111) fg%x(k),fg%y(k), fg%levelmax(k), &
                  topo, &
                  (fg%valuemax(mv,k), mv=1,FG_NUM_VAL), &
                  (fg%tmax(mv,k), mv=1,FG_NUM_VAL), fg%arrival_time(k)
 111        format(2e20.11,i4,21e17.8)
            enddo

        close(FG_UNIT)


        ! deallocate(fg%valuemax,fg%levelmax,fg%aux,fg%x,fg%y)
        enddo
    if (FG_DEBUG) then
        write(6,*) '+++ Fixed grid debugging written to fort.61 and fort.65'   
        endif

end subroutine fgmax_finalize

    subroutine get_aux_locations_n(ixy,mcapa,locrot,locarea)
    implicit double precision (a-h,o-z)

!     # Get aux locations for normal solve
    mcapa = 7
    locrot = (ixy-1)*3 + 1
    locarea = locrot + 2
    end subroutine get_aux_locations_n

    subroutine get_aux_locations_t(ixy,mcapa, locrot,locarea)
    implicit double precision (a-h,o-z)

!     # Get aux locations for transverse solves.

!     # Get transverse direction
    icoor = 3 - ixy

    call get_aux_locations_n(icoor,mcapa,locrot,locarea)

    end subroutine get_aux_locations_t

    subroutine compute_tangent(rot)
    implicit none

    double precision :: rot(4)

    rot(3) = -rot(2)
    rot(4) = rot(1)

    end subroutine compute_tangent

    subroutine rotate2(rot,velcomps)
    implicit none

    double precision :: rot(4), velcomps(2), v1, v2

    v1 = velcomps(1)
    v2 = velcomps(2)

    velcomps(1) = rot(1)*v1 + rot(2)*v2
    velcomps(2) = rot(3)*v1 + rot(4)*v2

    end subroutine rotate2

    subroutine rotate2_tr(rot,velcomps)
    implicit none

    double precision :: velcomps(2), rot(4), v1, v2

    v1 = velcomps(1)
    v2 = velcomps(2)

    velcomps(1) = rot(1)*v1 + rot(3)*v2
    velcomps(2) = rot(2)*v1 + rot(4)*v2

    end subroutine rotate2_tr

program test_parse_values

    ! To test: select a test below and then:
    !    gfortran utility_module.f90 test_parse_values.f90 
    !    ./a.out

    use utility_module, only: parse_values
    use topo_module, only: read_topo_header

    implicit none
    character(len=150) str,fname
    integer :: n,i,topo_type,mx,my
    real(kind=8) :: values(10), xll,yll,xhi,yhi,dx,dy

    if (.true.) then
        write(6,*) 'input line with mix of character strings and numbers...'
        read(5,'(a)') str
        write(6,*) 'read in str  = ',str

        call parse_values(trim(str), n, values)
        write(6,*) 'n = ',n
        write(6,*) 'values = ',(values(i), i=1,n)
        write(6,*) 'integer values = ',(nint(values(i)), i=1,n)
        endif

    if (.false.) then
        ! requires also compiling amr_module, topo_module, and setting path:
        fname = '/Users/rjl/topo/etopo/etopo4min100E69W70S70N.asc'
        !fname = '/Users/rjl/topo/etopo/etopo4min180E65W65S0N.asc'
        topo_type = 3
        call read_topo_header(fname,topo_type,mx,my,xll,yll,xhi,yhi,dx,dy)
        write(6,*) 'mx = ',mx
        write(6,*) 'my = ',my
        write(6,*) 'xll = ',xll
        write(6,*) 'yll = ',yll
        write(6,*) 'dx = ',dx
        write(6,*) 'dy = ',dy
        endif

end program test_parse_values

      subroutine setprob

      implicit none

      common /cqinit/ beta,ic
      integer ic
      double precision beta

      common /comaux/ Zl, cl, Zr, cr
      double precision rhol, Zl, cl, rhor, Zr, cr
c
c     # Set the material parameters for the acoustic equations
c
      character*25 fname
      character*7 adjointFolder

      fname = 'setprob.data'
      call opendatafile(7, fname)

c     # beta for initial conditions:
      read(7,*) beta
c
c     # Piecewise constant medium with single interface at x=0
c     # Density and sound speed to left and right:
      read(7,*) rhol
      read(7,*) cl
      Zl = rhol*cl

      read(7,*) rhor
      read(7,*) cr
      Zr = rhor*cr

      return
      end

c
c ---------------------------------------------------
c
       subroutine coarsen(valdub,midub,mjdub,mkdub,
     &                    valbgc,mi2tot,mj2tot,mk2tot,nvar)
      
       implicit double precision (a-h, o-z)

       dimension valdub(nvar,midub ,mjdub ,mkdub )
       dimension valbgc(nvar,mi2tot,mj2tot,mk2tot)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
c coarsen = coarsen the fine grid data (with double the usual
c           number of ghost cells to prepare coarsened
c           grid for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       do 10 ivar = 1, nvar
       do 10 k = 1, mk2tot
       kfine = 2*(k-1) + 1
       do 10 j = 1, mj2tot
       jfine = 2*(j-1) + 1
       do 10 i = 1, mi2tot
       ifine = 2*(i-1) + 1
       valbgc(ivar,i,j,k) = (valdub(ivar,ifine  ,jfine  ,kfine  )
     &                      +valdub(ivar,ifine+1,jfine  ,kfine  )
     &                      +valdub(ivar,ifine  ,jfine+1,kfine  )
     &                      +valdub(ivar,ifine+1,jfine+1,kfine  )
     &                      +valdub(ivar,ifine  ,jfine  ,kfine+1)
     &                      +valdub(ivar,ifine+1,jfine  ,kfine+1)
     &                      +valdub(ivar,ifine  ,jfine+1,kfine+1)
     &                      +valdub(ivar,ifine+1,jfine+1,kfine+1))/8.d0
10     continue

       return
       end

c
c
c
c     =================================================
      function fdisc(x,y)
c     =================================================
      implicit double precision (a-h,o-z)
      common/cdisc/ x0,y0,alf,beta,r0,idisc
c
c     # for computing cell averages for initial data that has a
c     # discontinuity along some curve.  fdisc should be negative to the 
c     # left of the curve and positive to the right
c     # idisc specifies the nature of the discontinuity for two
c     # particular cases (a straight line and circle) but this routine
c     # can be modified for any other curve.
c
      go to (10,20) idisc
c
   10 continue
c     # straight line through (x0,y0) with normal (alf,beta) pointing 
c     # into right state
c
      fdisc = (x-x0)*alf + (y-y0)*beta
      return
c
   20 continue
c     # circle of radius r0:
      fdisc = (x-x0)**2 + (y-y0)**2 - r0**2
c
      return
      end

subroutine buildSparseMatrixSGNcrs(q,qold,aux,soln,rhs,rowPtr,cols,vals,   &
                                     numBoussCells,levelBouss,                        &
                                     mptr,nx,ny,nvar,naux)

    
    use amr_module
    use geoclaw_module, only: earth_radius, deg2rad, coordinate_system, grav
    use geoclaw_module, only: sea_level, dry_tolerance
    use bouss_module
        
    implicit none
    
    integer, intent(in) :: nvar, naux, levelBouss, numBoussCells
    integer, intent(inout) :: rowPtr(0:2*numBoussCells)
    real(kind=8), intent(inout) :: vals(0:24*numBoussCells)
    integer, intent(inout) :: cols(0:24*numBoussCells)
    
    !! pass in numBoussCells for this level so can dimension these arrays
    real(kind=8) :: soln(0:2*numBoussCells), rhs(0:2*numBoussCells) 
    
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: kc,i,j,nng,nb,levSt,nx,ny,loc,locaux,mptr
    integer :: mitot, mjtot
    integer :: jst, jend, ivar
    integer :: colPtr
    
    real(kind=8) :: q(nvar,1-nghost:nx+nghost,1-nghost:ny+nghost)
    real(kind=8) :: qold(nvar,1-nghost:nx+nghost,1-nghost:ny+nghost)
    real(kind=8) :: aux(naux,1-nghost:nx+nghost,1-nghost:ny+nghost)

    real(kind=8), dimension(0:nx+1,0:ny+1) :: Bxx, Byy, Bx, By, Bxy
    real(kind=8), dimension(0:nx+1,0:ny+1) :: phi, eta, w
    real(kind=8) :: etax, etay, hx,hy, wx,wy

    integer :: nD
    integer :: k, k_ij, k_imj, k_ipj, k_ijm, k_ijp 
    integer :: m,n
    integer :: k_imjp, k_imjm, k_ipjm, k_ipjp
    integer :: kh_ij, kh_imj, kh_ipj, kh_ijm, kh_ijp
    integer :: kh_imjp, kh_imjm, kh_ipjm, kh_ipjp, khu_ij, khv_ij

    real(kind=8) :: h_ij
    real(kind=8) :: dx, dy, dxm, dym, dxdx, dydy, dxdy4
    
    real(kind=8) :: sa, huc, hvc
    integer :: ja, bc, c, indexSt
    real(kind=8) :: b_min, b_max
    real(kind=8) :: u(1-nghost:nx+nghost,1-nghost:ny+nghost), v(1-nghost:nx+nghost,1-nghost:ny+nghost) 
    real(kind=8) :: phix, phiy

    logical :: debug
    logical :: yhi_db, ylo_db, xlo_db, xhi_db
    logical :: allzero, IS_GHOST

    
    ! bc_xlo, bc_ylo, bc_xhi, bc_yhi are set in bouss_module.
    !     0 means Dirchlet value 0 (no correction at each of union of patches)
    !     1 means Neumann (correction in first interior cell = in ghost cell)
    !     2 means use ghost cell values in q(4:5,:,:) as Dirichlet BCs
    !             Multiply by matrix element and move to RHS
    !             Requires nvar==5.

    ! for CRS format, order of unknowns for each row is 
    ! 12 for u equations, 12 for v equation
    ! the unknown are still order in 0 based order: cell k_ij is u eq<> 2*(kij-1) v<>2*k_ij-1
    ! to get columns to be sorted, indices assigned as follows interior
    ! cell puts columns in order that comes out right. This doesnot hold
    ! for ghost cells, so those 12 entires need to be sorted.
    ! The order for u starting from rowPtr index:
    !   0         1          2         3        4        5     6       7 
    ! u_i-1,j-1  v_i,j-1  v_i+1,j-1  u_i-1,j  v_i-1,j  u_ij  v_ij   u_i+1,j
    !  8          9         10          11
    ! v_i+1,j  v_i-1,j+1, v_i,j+1, v_i+1,j+1
    ! The order for v starting from rowPtr+12 index:
    !   12        13         14        15      16        17    18      19
    ! u_i-1,j-1  u_i,j-1  v_i,j-1  u_i+1,j-1  u_i-1,j  v_ij   u_i+1,j
    !  20         21        22          23
    ! u_i-1,j+1  u_i,j+1, v_i,j+1, u_i+1,j+1


   IS_GHOST(i,j) = (i.eq.1 .or. i.eq.nx .or. j.eq.1 .or. j.eq.ny) 

#ifdef WHERE_AM_I
  write(*,*) "starting buildSparseMatrixSGNcrs"
#endif
    
    debug = .false.
    !debug = .true.
    
    minfo => matrix_info_allLevs(levelBouss)

    mitot = nx + 2*nghost
    mjtot = ny + 2*nghost


!
! ================== Step 2  set up for matrix elements  ======================
    
    ! Set up matrix A and RHS by looping over all Bouss patches:

       if (debug) then
         write(19,*)"Level ",levelBouss," grid ",mptr," at start of cleanBuild"
         do j = 1-nghost, ny+nghost
         do i = 1-nghost, nx+nghost
           write(19,900)i,j,(q(m,i,j),m=1,nvar)
 900       format(2i5,5e15.7)
         end do
         end do
       endif
    
    dx = hxposs(levelBouss)
    dy = hyposs(levelBouss)
    
     
    if (coordinate_system .eq. 2) then
      ! convert from dy in degrees to meters:
      dym = dy * earth_radius * deg2rad
      ! dxm depends on latitude, done in loops below instead of here
    else
      dym = dy
    endif
    
    dydy = dym**2
    nD = numBoussCells   ! shorthand for size of matrix blocks D1 to D4
              
    !REORG to put u and v together in blocks

        ! set booleans indicating whether each patch edge is a Domain Boundary:
        !call setDomainBndries(mptr,yhi_db,ylo_db,xlo_db,xhi_db)
        xlo_db = (node(ndilo,mptr) .eq. 0)
        xhi_db = (node(ndihi,mptr) .eq. (iregsz(levelBouss)-1))
        ylo_db = (node(ndjlo,mptr) .eq. 0)
        yhi_db = (node(ndjhi,mptr) .eq. (jregsz(levelBouss)-1))
    

        
        ! Get integer array providing matrix indices mapping 
        ! cell coordinates i,j to location k in vector of all unknowns: 
           
        nb = node(bpatchNum,mptr)
        mi => minfo%matrix_indices(nb)  ! integer array for this patch

        ! temp arrays needed for this patch:
        ! provide one layer of ghost cells needed when computing
        ! second differences of these quantities, but values in ghost
        ! cells are never actually needed since second diff's won't be
        ! needed in first row of interior cells
        
        ! First loop over all cells (i,j), one row of ghost cells,
        ! computing s1, s2, h0etax, h0etay,
        ! quantities that involve first derivatives.  In the second loop
        ! over all cells below we will compute matrix_rhs using second
        ! differences of these quantities.
        
        ! compute eta used below in update
        ! Remember that ETA not same size as Q
         eta(:,:) = q(1,0:nx+1,0:ny+1) +   &
                  aux(1,0:nx+1,0:ny+1)

         ! will have to FIX for h = 0? Hopefully not that close to 0
         !u(:,:) = q(2,:,:) / q(1,:,:)
         !v(:,:) = q(3,:,:) / q(1,:,:)
         !where (q(1,:,:) /= 0.d0)
         where (abs(q(1,:,:)) > dry_tolerance)
           u(:,:) = q(2,:,:) / q(1,:,:)
           v(:,:) = q(3,:,:) / q(1,:,:)
         elsewhere
           u(:,:) = 0.d0
           v(:,:) = 0.d0
         end where


         do j=0,ny+1 
            if (coordinate_system .eq. 2) then
              ! aux(3,i,j) is latitude, doesn't depend on i so use i=1
              dxm = dx * earth_radius * deg2rad * cos(aux(3,1,j))
            else
              dxm = dx
            endif
            dxdx = dxm**2
            dxdy4 = 4.d0*dxm*dym
            
            ! compute phi. rest will now be computed ! in second loop
            do i=0,nx+1
              
               phi(i,j) = ((v(i+1,j)-v(i-1,j))*(u(i,j+1)-u(i,j-1)) -      &
                          (u(i+1,j)-u(i-1,j))*(v(i,j+1)-v(i,j-1)))/dxdy4  &
                          + ((u(i+1,j)-u(i-1,j))/(2.d0*dxm)               &
                          +  (v(i,j+1)-v(i,j-1))/(2.d0*dym))**2
               Bx(i,j) = (aux(1,i+1,j) - aux(1,i-1,j))/(2.d0*dxm) 
               By(i,j) = (aux(1,i,j+1) - aux(1,i,j-1))/(2.d0*dym)
               Bxy(i,j) = (aux(1,i+1,j+1)-aux(1,i+1,j-1) &
                          -aux(1,i-1,j+1)+aux(1,i-1,j-1))/dxdy4
               Bxx(i,j) = (aux(1,i+1,j)-2.d0*aux(1,i,j)+aux(1,i-1,j))/dxm**2
               Byy(i,j) = (aux(1,i,j+1)-2.d0*aux(1,i,j)+aux(1,i,j-1))/dym**2                          
               w(i,j) = u(i,j)**2 * Bxx(i,j) + 2.d0*u(i,j)*v(i,j)*Bxy(i,j) &
                       +v(i,j)**2 * Byy(i,j)
              
            enddo
        enddo

! ================== build matrix and rhs
        ! Second loop over all cells.  ONLY INTERIOR OK NOW
        
        do j=1,ny 
            if (coordinate_system .eq. 2) then
              ! aux(3,i,j) is latitude, doesn't depend on i so use i=1
              dxm = dx * earth_radius * deg2rad *              &
                    cos(aux(3,1,j))
            else
              dxm = dx
            endif
            dxdx = dxm**2
            dxdy4 = 4.d0*dxm*dym
            
            
            do i=1,nx

                ! sparse matrix row indices for cell (i,j) are:
                !    k_ij for the row of I-D11 and -D12 in block matrix,
                !    k_ij + nD for the row of -D21 and I-D22
                
                ! in this inner loop we set all nonzero matrix elements
                ! in these two rows of the matrix (and rhs) corresponding
                ! to momenumtum updates to hu and hv in the (i,j) cell
                
                ! sparse matrix column indices for neighboring cells
                ! are the values k computed next (for I-D1 and -D3)
                ! and the corresponding k + nD for the corresponding column
                ! of the -D2 and I-D4.  These indices are needed to
                ! set matrix elements in these columns, corresponding to
                ! momentum components hu and hv in the neighboring cells
                
                k_imj = mi%mindex(i-1,j)
                k_ipj = mi%mindex(i+1,j)
                k_ijm = mi%mindex(i,j-1)
                k_ijp = mi%mindex(i,j+1)
                k_imjm = mi%mindex(i-1,j-1)
                k_imjp = mi%mindex(i-1,j+1)
                k_ipjm = mi%mindex(i+1,j-1)
                k_ipjp = mi%mindex(i+1,j+1)
                
                ! use the fact that h,hu,hv are contiguous in alloc:
                h_ij = q(1,i,j)  ! to save typing keep this one
                
                k_ij = mi%mindex(i,j)
                if (k_ij == -1) then
                    write(6,*) '+++ unexpected k_ij=-1 at i,j: ',i,j
                endif
                ! for CRS set row using 24 entries per cell i,j: 12 for u and 12 for v.
                rowPtr(2*(k_ij-1)) = 12*2*(k_ij-1)        ! start of u_ij eq
                rowPtr(2*k_ij-1) = rowPtr(2*(k_ij-1))+12  ! start of v_ij eq
                colPtr = rowPtr(2*(k_ij-1))

                ! initialize all cols for these equations to start, even if it's col*unknown = 0
                
                !b_min = min(aux(1,i,j), aux(1,i-1,j),aux(1,i+1,j),     &
                !            aux(1,i,j-1),aux(1,i,j+1),                 &
                !            aux(1,i-1,j-1),aux(1,i-1,j+1),             &
                !            aux(1,i+1,j-1),aux(1,i+1,j+1))
                !b_max = max(aux(1,i,j), aux(1,i-1,j),aux(1,i+1,j),     &
                !            aux(1,i,j-1),aux(1,i,j+1),                 &
                !            aux(1,i-1,j-1),aux(1,i-1,j+1),             &
                !            aux(1,i+1,j-1),aux(1,i+1,j+1))


                if (.not. mi%isBouss(i,j)) then
                        
                    ! The deepest water in block of 9 cells is shallower 
                    ! than boussMinDepth, or else one of the cells is onshore.

                    ! Revert to SWE in this cell, i.e. two rows
                    ! of matrix should be rows of identity with rhs = 0,
                    ! so correction terms huc,hvc calculated will be 0.
                    
                    !QUESTION: I should be h_ij*I. FIXED
                    ! BUT: then discovered the leading h in matrix is a typo
                    ! fixed for now by multiplying rhs by h_ij too.
                    
                    ! Replace diagonal block I-D11 by I matrix:
                    cols(colPtr+5) = 2*(k_ij-1)

                    ! changed to +1*max on sept 2 2022 to test gamg
                    vals(colPtr+5) = vals(colPtr+5)+1.d0*max(abs(h_ij),1000.d0)
                    
                    ! Replace diagonal block I-D22 by I matrix:
                    cols(colPtr+18) = 2*k_ij-1

                    ! changed to +1*max on sept 2 2022 to test gamg
                    vals(colPtr+18) = vals(colPtr+18)+1.d0*max(abs(h_ij),1000.d0)
                    
                    ! -D12 and -D21 are the 0 matrix in this case (no nozeros)

                    cycle ! go on to next i
                endif

                
                ! If we get here, we are dealing with interior point
                ! Add rows k_ij and (k_ij + nD) to matrix:
                ! Row k_ij    corresponds to correction to hu in cell (i,j)
                ! Row k_ij+nD corresponds to correction to hv in cell (i,j)
                ! The nonzero matrix elements will be in the same columns
                ! and also in columns 
                !     k_ipj, k_ipj+nD for the coeff of the (i+1,j) stencil pt
                !     k_imjp, k_imjp+nD for the coeff of (i-1,j+1) point,
                !     etc.
                ! Note that if e.g. k_ipj = -1 then cell (i+1,j) is not in the
                ! union of patches at this level and so there is no 
                ! corresponding column.  
                ! In this case:
                ! For Dirichlet BC with value 0, the stencil value is discarded,
                ! For Neumann BC, the stencil coefficient is instead applied
                ! to the neighboring cell that is in the patch, 
                ! assuming constant extrapolation at each edge.
                
                hx = (q(1,i+1,j) - q(1,i-1,j))/(2.d0*dxm)
                hy = (q(1,i,j+1) - q(1,i,j-1))/(2.d0*dym)
                etax = (eta(i+1,j) - eta(i-1,j))/(2.d0*dxm)
                etay = (eta(i,j+1) - eta(i,j-1))/(2.d0*dym)

                !-----------------------------------------------
                ! I-D11 block (x and xx derivatives of hu components):
                
                ! Matrix element row U(i,j) column U(i,j):
                sa = (1.d0 + alpha*(2.d0*h_ij**2/(3.d0*dxdx) &
                     + 0.5d0*h_ij*Bxx(i,j) + Bx(i,j)*etax))
                cols(colPtr+5) = 2*(k_ij-1)
                vals(colPtr+5) = vals(colPtr+5)+sa
                
                
                
                ! Matrix element row U(i,j) column U(i+1,j):
                sa = alpha*(-h_ij*hx/(2.d0*dxm) - h_ij**2/(3.d0*dxdx))
                
                if (k_ipj > -1) then
                    ! adjacent cell is interior pt, set matrix element to sa:
                    cols(colPtr+7) = 2*(k_ipj-1)
                    vals(colPtr+7) = vals(colPtr+7)+sa
                else
                    ! right boundary of patch
                    if (.not. xhi_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        huc = q(4,i+1,j)
                        rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*huc
                    else if (bc_xhi==1) then 
                        ! For Neumann BC add sa to diagonal matrix element:
                        vals(colPtr+5) = vals(colPtr+5) + sa
                    else if (bc_xhi==3) then
                        ! For wall, negate u: add -sa to diagonal matrix element:
                        vals(colPtr+5) = vals(colPtr+5) - sa
                    endif                    
                endif
                
                
                ! Matrix element row U(i,j) column U(i-1,j):
                sa = alpha*(h_ij*hx/(2.d0*dxm) - h_ij**2/(3.d0*dxdx))
                if (k_imj > -1) then
                    ! adjacent cell is interior pt, set matrix element to sa:
                    cols(colPtr+3) = 2*(k_imj-1)
                    vals(colPtr+3) = vals(colPtr+3)+sa
                else
                    ! left boundary of patch
                    if (.not. xlo_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        huc = q(4,i-1,j)
                        rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*huc
                    else if (bc_xlo==1) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        vals(colPtr+5) = vals(colPtr+5) + sa
                    else if (bc_xlo==3) then
                        ! For wall, negate u: add -sa to diagonal matrix element:
                        vals(colPtr+5) = vals(colPtr+5) - sa
                    endif
                endif


                !-----------------------------------------------
                ! I-D22 block (yy derivatives of hv components):
                
                ! Matrix element row V(i,j) column V(i,j):
                sa = (1.d0 + alpha*(2.d0*h_ij**2/(3.d0*dydy) &
                     + 0.5d0*h_ij*Byy(i,j) + By(i,j)*etay))
                cols(colPtr+18) = 2*k_ij-1
                vals(colPtr+18) = vals(colPtr+18)+sa
                
                ! Matrix element row V(i,j) column V(i,j+1):
                sa = alpha*(-h_ij*hy/(2.d0*dym) - h_ij**2/(3.d0*dydy))
                if (k_ijp > -1) then
                    cols(colPtr+22) = 2*k_ijp-1
                    vals(colPtr+22) = vals(colPtr+22)+sa
                else
                    ! top boundary of patch
                    if (.not. yhi_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        hvc = q(5,i,j+1)
                        !rhs(k_ij+nD) = rhs(k_ij+nD) - sa*hvc
                        !rhs(2*k_ij) = rhs(2*k_ij) - sa*hvc
                        rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*hvc
                    else if (bc_yhi==1) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        vals(colPtr+18) = vals(colPtr+18) + sa
                    else if (bc_yhi==3) then
                        ! For wall BC add -sa to diagonal matrix element:
                        vals(colPtr+18) = vals(colPtr+18) - sa
                    endif
                endif
                
                ! Matrix element row V(i,j) column V(i,j-1):
                sa = alpha*(h_ij*hy/(2.d0*dym) - h_ij**2/(3.d0*dydy))
                if (k_ijm > -1) then
                    cols(colPtr+14) = 2*k_ijm-1
                    vals(colPtr+14) = vals(colPtr+14)+sa
                else
                    ! bottom boundary of patch
                    if (.not. ylo_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        hvc = q(5,i,j-1)
                        !rhs(k_ij+nD) = rhs(k_ij+nD) - sa*hvc
                        !rhs(2*k_ij) = rhs(2*k_ij) - sa*hvc
                        rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*hvc
                    else if (bc_ylo==1) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        vals(colPtr+18) = vals(colPtr+18) + sa
                    else if (bc_ylo==3) then
                        ! For wall BC add -sa to diagonal matrix element:
                        vals(colPtr+18) = vals(colPtr+18) - sa
                    endif   
                endif                                        

            
                !-----------------------------------------------
                ! -D12 block (cross derivatives):
                ! row ia = k_ij for hu corrections in cell (i,j)
                ! columns k_ipjp + nD and other neighbors for hv corrections                

                ! Matrix element row U(i,j) column V(i,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH VARYING TOPO
                sa = alpha*(0.5d0*h_ij*Bxy(i,j) + etax*By(i,j))
                cols(colPtr+6) = 2*k_ij-1 
                vals(colPtr+6) = vals(colPtr+6)+sa
                    
            
                ! Matrix element row U(i,j) column V(i,j+1):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = -alpha*h_ij*(hx + 0.5d0*Bx(i,j))/(2.d0*dym)
                ja = -1
                if (k_ijp > -1) then
                    !ja = k_ijp + nD
                    !ja = 2*k_ijp
                    ja = 2*k_ijp-1
                    cols(colPtr+10) = ja
                    vals(colPtr+10) = vals(colPtr+10) + sa
                else if (.not. yhi_db) then
                    hvc = q(5,i,j+1)
                    !rhs(k_ij) = rhs(k_ij) - sa*hvc
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else
                    ! at top boundary, use cell ij instead,
                    !ja = k_ij + nD
                    !ja = 2*k_ij 
                    ja = 2*k_ij-1 
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i,j-1):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = alpha*(h_ij*(hx + 0.5d0*Bx(i,j))/(2.d0*dym))
                ja = -1
                if (k_ijm > -1) then
                    ja = 2*k_ijm-1
                    cols(colPtr+1) = ja
                    vals(colPtr+1) = vals(colPtr+1) + sa
                else if (.not. ylo_db) then
                    hvc = q(5,i,j-1)
                    !rhs(k_ij) = rhs(k_ij) - sa*hvc
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else
                    ! at bottom boundary, use cell ij instead,
                    ja = 2*k_ij-1
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i+1,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = alpha*0.5d0*h_ij*By(i,j) / (2.d0*dxm)
                ja = -1
                if (k_ipj > -1) then
                    !ja = k_ipj + nD
                    !ja = 2*k_ipj
                    ja = 2*k_ipj-1
                    cols(colPtr+8) = ja
                    vals(colPtr+8) = vals(colPtr+8) + sa
                else if (.not. xhi_db) then
                    hvc = q(5,i+1,j) 
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else
                    ! at right boundary, use cell ij instead,
                    !ja = k_ij + nD
                    !ja = 2*k_ij
                    ja = 2*k_ij-1
                    ! no reflection of V at right wall
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i-1,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = -alpha*0.5d0*h_ij*By(i,j) / (2.d0*dxm)
                ja = -1
                if (k_imj > -1) then
                    !ja = k_imj + nD
                    !ja = 2*k_imj
                    ja = 2*k_imj-1
                    cols(colPtr+4) = ja
                    vals(colPtr+4) = vals(colPtr+4) + sa
                else if (.not. xlo_db) then
                    hvc = q(5,i-1,j)
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else
                    ! at left boundary, use cell ij instead,
                    !ja = k_ij + nD
                    !ja = 2*k_ij
                    ja = 2*k_ij-1
                    ! no reflection of V at left wall
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i+1,j+1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjp > -1) then
                    !ja = k_ipjp + nD
                    !ja = 2*k_ipjp 
                    ja = 2*k_ipjp-1 
                    cols(colPtr+11) = ja
                    vals(colPtr+11) = vals(colPtr+11) + sa
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    hvc = q(5,i+1,j+1)
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else if (k_ijp > -1) then
                    ! at right boundary, use cell above instead
                    !ja = k_ijp + nD
                    !ja = 2*k_ijp 
                    ja = 2*k_ijp-1 
                    vals(colPtr+10) = vals(colPtr+10) + sa
                else if (k_ipj > -1) then
                    ! at top boundary, use cell to right instead, 
                    !ja = k_ipj + nD
                    !ja = 2*k_ipj
                    ja = 2*k_ipj-1
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                    vals(colPtr+8) = vals(colPtr+8) + sa
                else
                    ! top-right corner
                    !ja = k_ij + nD
                    ja = 2*k_ij-1
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                    
                ! Matrix element row U(i,j) column V(i+1,j-1):
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjm > -1) then
                    !ja = k_ipjm + nD  
                    !ja = 2*k_ipjm 
                    ja = 2*k_ipjm-1 
                    cols(colPtr+2) = ja
                    vals(colPtr+2) = vals(colPtr+2) + sa
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    hvc = q(5,i+1,j-1)
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc   
                else if (k_ijm > -1) then
                    ! at right boundary, use cell below instead
                    !ja = k_ijm + nD
                    !ja = 2*k_ijm 
                    ja = 2*k_ijm-1 
                    vals(colPtr+1) = vals(colPtr+1) + sa
                else if (k_ipj > -1) then
                    ! at bottom boundary, use cell to right instead,
                    !ja = k_ipj + nD
                    !ja = 2*k_ipj
                    ja = 2*k_ipj-1
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                    vals(colPtr+8) = vals(colPtr+8) + sa
                else
                    ! bottom-right corner
                    !ja = k_ij + nD
                    !ja = 2*k_ij 
                    ja = 2*k_ij-1 
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i-1,j+1):    
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_imjp > -1) then
                    !ja = k_imjp + nD
                    !ja = 2*k_imjp 
                    ja = 2*k_imjp-1 
                    cols(colPtr+9) = ja
                    vals(colPtr+9) = vals(colPtr+9) + sa
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    hvc = q(5,i-1,j+1)
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else if (k_ijp > -1) then
                    ! at left domain boundary, use cell above instead
                    !ja = k_ijp + nD
                    !ja = 2*k_ijp 
                    ja = 2*k_ijp-1 
                    vals(colPtr+10) = vals(colPtr+10) + sa
                else if (k_imj > -1) then
                    ! at top domain boundary, use cell to left instead,
                    !ja = k_imj + nD
                    !ja = 2*k_imj 
                    ja = 2*k_imj-1 
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                    vals(colPtr+4) = vals(colPtr+4) + sa
                else
                    ! top-left corner
                    !ja = k_ij + nD
                    !ja = 2*k_ij 
                    ja = 2*k_ij-1 
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i-1,j-1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_imjm > -1) then
                    !ja = k_imjm + nD
                    !ja = 2*k_imjm 
                    ja = 2*k_imjm-1 
                    cols(colPtr+0) = ja
                    vals(colPtr+0) = vals(colPtr+0) + sa
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    hvc = q(5,i-1,j-1)
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*hvc
                else if (k_ijm > -1) then
                    ! at left boundary, use cell below instead
                   !ja = k_ijm + nD
                   !ja = 2*k_ijm
                   ja = 2*k_ijm-1
                   vals(colPtr+1) = vals(colPtr+1) + sa
                else if (k_imj > -1) then
                    ! at bottom boundary, use cell to left instead,
                    !ja = k_imj + nD
                    !ja = 2*k_imj 
                    ja = 2*k_imj-1 
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                    vals(colPtr+4) = vals(colPtr+4) + sa
                else
                    ! bottom-left corner
                    !ja = k_ij + nD
                    !ja = 2*k_ij
                    ja = 2*k_ij-1
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                    vals(colPtr+6) = vals(colPtr+6) + sa
                endif
                

                !-----------------------------------------------
                ! -D21 block (cross derivatives
                ! row ia = k_ij + nD  for hv corrections in cell (i,j)
                ! columns k_ipjp and other neighbors for hu corrections

                ! Matrix element row V(i,j) column U(i,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH VARYING TOPO
                sa = alpha*(0.5d0*h_ij*Bxy(i,j) + etay*Bx(i,j))
                cols(colPtr+17) = 2*(k_ij-1)
                vals(colPtr+17) = vals(colPtr+17)+sa
                
                ! Matrix element row V(i,j) column U(i+1,j):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = -alpha*h_ij*(hy + 0.5d0*By(i,j))/(2.d0*dxm)
                ja = -1
                if (k_ipj > -1) then
                    !ja = k_ipj
                    !ja = 2*k_ipj-1
                    ja = 2*(k_ipj-1)
                    cols(colPtr+19) = ja
                    vals(colPtr+19) = vals(colPtr+19) + sa
                else if (.not. xhi_db) then
                    huc = q(4,i+1,j)
                    !rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                    !rhs(2*k_ij) = rhs(2*k_ij) - sa*huc
                    rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*huc
                else
                    ! at right boundary, use cell ij instead,
                    !ja = k_ij
                    !ja = 2*k_ij-1
                    ja = 2*(k_ij-1)
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i-1,j):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = alpha*h_ij*(hy + 0.5d0*By(i,j))/(2.d0*dxm)
                ja = -1
                if (k_imj > -1) then
                    !ja = k_imj
                    !ja = 2*k_imj-1
                    ja = 2*(k_imj-1)
                    cols(colPtr+16) = ja
                    vals(colPtr+16) = vals(colPtr+16) + sa
                else if (.not. xlo_db) then
                    huc = q(4,i-1,j)
                    !rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                    !rhs(2*k_ij) = rhs(2*k_ij) - sa*huc
                    rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*huc
                else
                    ! at left boundary, use cell ij instead,
                    !ja = k_ij
                    !ja = 2*k_ij-1
                    ja = 2*(k_ij-1)
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i,j+1):
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = alpha*0.5d0*h_ij*Bx(i,j) / (2.d0*dym)
                ja = -1
                if (k_ijp > -1) then
                    !ja = k_ijp ! FIXED BUG2
                    !ja = 2*k_ijp-1 ! FIXED BUG2
                    ja = 2*(k_ijp-1) ! FIXED BUG2
                    cols(colPtr+21) = ja
                    vals(colPtr+21) = vals(colPtr+21) + sa
                else if (.not. yhi_db) then
                    huc = q(4,i,j+1)
                    !rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*huc
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*huc
                else
                    ! at top boundary, use cell ij instead,
                    !ja = k_ij
                    !ja = 2*k_ij-1
                    ja = 2*(k_ij-1)
                    ! no reflection of U at top wall
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
                ! Matrix element row V(i,j) column U(i,j-1): ! FIXED BUG2
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = -alpha*0.5d0*h_ij*Bx(i,j) / (2.d0*dym)
                ja = -1
                if (k_ijm > -1) then
                    !ja = k_ijm ! FIXED BUG2
                    !ja = 2*k_ijm-1 ! FIXED BUG2
                    ja = 2*(k_ijm-1) ! FIXED BUG2
                    cols(colPtr+13) = ja
                    vals(colPtr+13) = vals(colPtr+13) + sa
                else if (.not. ylo_db) then
                    huc = q(4,i,j-1)
                    !rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*huc
                    rhs(2*(k_ij-1)) = rhs(2*(k_ij-1)) - sa*huc
                else
                    ! at bottom boundary, use cell ij instead,
                    !ja = k_ij ! FIXED BUG2
                    !ja = 2*k_ij-1 ! FIXED BUG2
                    ja = 2*(k_ij-1) ! FIXED BUG2
                    ! no reflection of U at bottom wall
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i+1,j+1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjp > -1) then
                    !ja = k_ipjp
                    !ja = 2*k_ipjp-1
                    ja = 2*(k_ipjp-1)
                    cols(colPtr+23) = ja
                    vals(colPtr+23) = vals(colPtr+23) + sa
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    huc = q(4,i+1,j+1)
                    !rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                    !rhs(2*k_ij) = rhs(2*k_ij) - sa*huc
                    rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*huc
                else if (k_ijp > -1) then
                    ! at right boundary, use cell above instead,
                    !ja = k_ijp
                    !ja = 2*k_ijp-1
                    ja = 2*(k_ijp-1)
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                    vals(colPtr+21) = vals(colPtr+21) + sa
                else if (k_ipj > -1) then
                    ! at top boundary, use cell to right instead,
                    !ja = k_ipj
                    !ja = 2*k_ipj-1
                    ja = 2*(k_ipj-1)
                    vals(colPtr+19) = vals(colPtr+19) + sa
                else
                    ! top-right corner
                    !ja = k_ij ! FIXED BUG
                    !ja = 2*k_ij-1 ! FIXED BUG
                    ja = 2*(k_ij-1) ! FIXED BUG
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i+1,j-1):
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjm > -1) then
                    !ja = k_ipjm
                    !ja = 2*k_ipjm-1
                    ja = 2*(k_ipjm-1)
                    cols(colPtr+15) = ja
                    vals(colPtr+15) = vals(colPtr+15) + sa
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    huc = q(4,i+1,j-1)
                    !rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                    !rhs(2*k_ij) = rhs(2*k_ij) - sa*huc
                    rhs(2*k_ij-1) = rhs(2*k_ij-1) - sa*huc
                else if (k_ijm > -1) then
                    ! at right boundary, use cell below instead,
                    !ja = k_ijm
                    !ja = 2*k_ijm-1
                    ja = 2*(k_ijm-1)
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                    vals(colPtr+13) = vals(colPtr+13) + sa
                else if (k_ipj > -1) then
                    ! at bottom boundary, use cell to right instead,
                    !ja = k_ipj
                    !ja = 2*k_ipj-1
                    ja = 2*(k_ipj-1)
                    vals(colPtr+19) = vals(colPtr+19) + sa
                else
                    ! bottom-right corner
                    !ja = k_ij ! FIXED BUG
                    !ja = 2*k_ij-1 ! FIXED BUG
                    ja = 2*(k_ij-1) ! FIXED BUG
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i-1,j+1):
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_imjp > -1) then
                    !ja = k_imjp
                    !ja = 2*k_imjp-1
                    ja = 2*(k_imjp-1)
                    cols(colPtr+20) = ja
                    vals(colPtr+20) = vals(colPtr+20) + sa
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    huc = q(4,i-1,j+1)
                    !rhs(k_ij+nD) = rhs(k_ij+nD)  - sa*huc
                    !rhs(2*k_ij) = rhs(2*k_ij)  - sa*huc
                    rhs(2*k_ij-1) = rhs(2*k_ij-1)  - sa*huc
                else if (k_ijp > -1) then
                    ! at left boundary, use cell above instead,
                    !ja = k_ijp
                    !ja = 2*k_ijp-1
                    ja = 2*(k_ijp-1)
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                    vals(colPtr+21) = vals(colPtr+21) + sa
                else if (k_imj > -1) then
                    ! at top boundary, use cell to left instead,
                    !ja = k_imj
                    !ja = 2*k_imj-1
                    ja = 2*(k_imj-1)
                    vals(colPtr+16) = vals(colPtr+16) + sa
                else
                    ! top-left corner
                    !ja = k_ij !FIXED BUG
                    !ja = 2*k_ij-1 !FIXED BUG
                    ja = 2*(k_ij-1) !FIXED BUG
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                

                ! Matrix element row V(i,j) column U(i-1,j-1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)  
                ja = -1
                if (k_imjm > -1) then
                    !ja = k_imjm
                    !ja = 2*k_imjm-1
                    ja = 2*(k_imjm-1)
                    cols(colPtr+12) = ja
                    vals(colPtr+12) = vals(colPtr+12) + sa
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    huc = q(4,i-1,j-1)
                    !rhs(k_ij+nD) = rhs(k_ij+nD)  - sa*huc
                    !rhs(2*k_ij) = rhs(2*k_ij)  - sa*huc
                    rhs(2*k_ij-1) = rhs(2*k_ij-1)  - sa*huc
                else if (k_ijm > -1) then
                    ! at left boundary, use cell below instead,
                    !ja = k_ijm
                    !ja = 2*k_ijm-1
                    ja = 2*(k_ijm-1)
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                    vals(colPtr+13) = vals(colPtr+13) + sa
                else if (k_imj > -1) then
                    ! at bottom boundary, use cell to left instead,
                    !ja = k_imj
                    !ja = 2*k_imj-1
                    ja = 2*(k_imj-1)
                    vals(colPtr+16) = vals(colPtr+16) + sa
                else
                    ! bottom-left corner
                    !ja = k_ij !FIXED BUG
                    !ja = 2*k_ij-1 !FIXED BUG
                    ja = 2*(k_ij-1) !FIXED BUG
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                    vals(colPtr+17) = vals(colPtr+17) + sa
                endif
                
 
                !-------------------------------------------------------
                ! Right hand sides for vector elements k_ij and k_ij+nD
                ! Need to add comments on SGN RHS.
                
              !RHS for SGN 
              phix = (phi(i+1,j) - phi(i-1,j))/(2.d0*dxm)
              phiy = (phi(i,j+1) - phi(i,j-1))/(2.d0*dym)
                            
              wx = (w(i+1,j) - w(i-1,j))/(2.d0*dxm)
              wy = (w(i,j+1) - w(i,j-1))/(2.d0*dym)
              
              etax = (eta(i+1,j) - eta(i-1,j))/(2.d0*dxm)
              etay = (eta(i,j+1) - eta(i,j-1))/(2.d0*dym)
                                 
              rhs(2*(k_ij-1)) = rhs(2*(k_ij-1))  +  (grav/alpha * etax      &
                    + 2.d0*h_ij*(h_ij/3.d0 * phix &
                    + phi(i,j) * (hx + 0.5d0*Bx(i,j)))   &
                    + 0.5d0*h_ij*wx + w(i,j)*etax)

              rhs(2*k_ij-1) = rhs(2*k_ij-1) +  (grav/alpha * etay &
                    + 2.d0*h_ij*(h_ij/3.d0 * phiy &
                    + phi(i,j) * (hy + 0.5d0*By(i,j)))   &
                    + 0.5d0*h_ij*wy + w(i,j)*etay)
                    
              ! if ghost cells in stencil might not be sorted so fix
              ! interior cells numbered so CSR entries are sorted
              ! this row's entries start at rowPtr(colPtr+0) to colPtr+11
              ! for u, and colPtr+12 to colPtr+23 for v
              if (IS_GHOST(i,j)) then 
                 indexSt = rowPtr(2*(k_ij-1))
                 call insertionSort(cols(indexSt),vals(indexSt))
                 indexSt = rowPtr(2*k_ij-1)
                 call insertionSort(cols(indexSt),vals(indexSt))
              endif


              if (0 .eq. 1 .or. debug) then
                 allzero = .true.
                 do n = 0, 23
                    if (vals(colPtr+n) .ne. 0.d0) then
                       allzero = .false.
                       exit
                    endif
                 end do
                 if (allzero) then
                    write(*,505) i,j,k_ij
 505                format(" u,v, rows for cell ",2i5," index ",i5," all zeroes")
                 endif

              endif
                     
              ! put initial guess for k_ij and k_ij+nD respective in soln array
             !if (levelBouss .lt. mxnest) then
             !  ! initial guess when doUpdate is true is previous soln
             !  ! when doUpdate was false, but values needed for finer
             !  ! grid interface conditions
             !  soln(k_ij) = qold(4,i,j) 
             !  soln(k_ij+nD) = qold(5,i,j)
             !else
             !  soln(k_ij) = 0.d0
             !  soln(k_ij+nD) = 0.d0 
             !endif

            enddo
        enddo

        if (debug) then ! dump matrix to look for singularity 
           write(89,*)" level ",levelBouss
           do k = 1,2*numBoussCells
              write(89,104) k,rhs(k)
 104          format(i5,e16.7)
           end do
           !close(89)
           !stop
        endif
        
    
#ifdef WHERE_AM_I
  write(*,*) "ending   buildSparseMatrixSGNcrs"
#endif


    return
end subroutine buildSparseMatrixSGNcrs

subroutine insertionSort(cols,vals)

    integer, intent(inout) :: cols(0:11)
    real(kind=8), intent(inout) :: vals(0:11)

    integer :: i,j, colSave
    real(kind=8) :: valSave

! in place insertion sort for 12 element, starting index is indexSt
    do i = 1, 11
      colSave = cols(i)
      valSave = vals(i)

      do j = i-1, 0, -1
        if (colSave < cols(j)) then
           cols(j+1) = cols(j)
           vals(j+1) = vals(j)
        else
            exit
        endif
      end do
      cols(j+1) = colSave 
      vals(j+1) = valSave
    end do

   return
end subroutine insertionSort
subroutine insertionSortOrig(cols,vals,indexSt,numBoussCells)

    integer, intent(inout) :: indexSt 
    integer, intent(inout) :: cols(0:24*numBoussCells)
    real(kind=8), intent(inout) :: vals(0:24*numBoussCells)

    integer :: i,j, colSave
    real(kind=8) :: valSave

! in place insertion sort for 12 element, starting index is indexSt
    do i = indexSt+1, indexSt+11
      colSave = cols(i)
      valSave = vals(i)

      do j = i-1, 0, -1
        if (colSave < cols(j)) then
           cols(j+1) = cols(j)
           vals(j+1) = vals(j)
        else
            exit
        endif
      end do
      cols(j+1) = colSave 
      vals(j+1) = valSave
    end do

   return
end subroutine insertionSortOrig

! ==============================================================================
!  Variable friction module
!
!    This module contains storage and routines for dealing with variable 
!    friction fields in GeoClaw.
!
!    If variable_friction > 0 then the data located here will override the basic
!    friction coefficient data in GeoClaw and will be ignored.
!
!    Precidence of specification:
!      file based
!      region based
!      depth based
!      constant value from geoclaw_module
!    
! ==============================================================================

module friction_module

    implicit none
    save

    logical, private :: module_setup = .false.

    ! Parameters
    integer, public :: friction_index

    ! Whether to use variable friction and what type to specify
    logical, public :: variable_friction

    ! Support for region based specification
    type friction_region_type
        ! Bounds of region
        real(kind=8) :: lower(2), upper(2)

        ! Coefficients in the region based on depths
        real(kind=8), pointer :: depths(:)
        real(kind=8), pointer :: manning_coefficients(:)

    end type friction_region_type
    integer, private :: num_friction_regions = 0
    type(friction_region_type), pointer, private :: friction_regions(:)

    ! Support for file based specification
    type friction_file_type
        ! Domain specification
        integer :: num_cells(2)
        real(kind=8) :: lower(2), upper(2), dx(2)

        ! Field information
        real(kind=8) :: no_data_value

        ! Array containing coefficients
        real(kind=8), pointer :: data(:,:)
    end type friction_file_type

    integer, private :: num_friction_files = 0
    type(friction_file_type), pointer, private :: friction_files(:)

contains

    subroutine setup_variable_friction(path)

        use utility_module, only: get_value_count

        implicit none

        ! Input
        character(len=*), optional, intent(in) :: path

        ! Locals
        integer, parameter :: unit = 54
        integer :: m, file_type
        character(len=128) :: line

        if (.not.module_setup) then

            ! Open data file
            if (present(path)) then
                call opendatafile(unit,path)
            else
                call opendatafile(unit,'friction.data')
            endif

            ! Basic switch to turn on variable friction
            read(unit, *) variable_friction
            read(unit, *) friction_index
            read(unit,'(a)')

            if (variable_friction) then
                ! Region based friction
                read(unit,'(i2)') num_friction_regions
                allocate(friction_regions(num_friction_regions))
                read(unit,*)
                do m=1,num_friction_regions
                    read(unit,*) friction_regions(m)%lower
                    read(unit,*) friction_regions(m)%upper
                    read(unit,'(a)') line
                    allocate(friction_regions(m)%depths(get_value_count(line)))
                    read(line,*) friction_regions(m)%depths
                    read(unit,'(a)') line
                    allocate(friction_regions(m)%manning_coefficients(get_value_count(line)))
                    read(line,*) friction_regions(m)%manning_coefficients
                    read(unit,*)
                enddo

                ! File based friction
                read(unit,"(i2)") num_friction_files
                allocate(friction_files(num_friction_files))
                do m=1,num_friction_files
                    read(unit,"(a,i1)") line, file_type

                    ! Open and read in friction file
                    print *,"*** WARNING *** File based friction specification unimplemented."
                    friction_files = read_friction_file(line, file_type)
                enddo
            endif

            close(unit)

            module_setup = .true.
        end if

    end subroutine setup_variable_friction

    ! ==========================================================================
    !  set_friction_field - 
    ! ==========================================================================
    subroutine set_friction_field(mx, my, num_ghost, num_aux, xlower, ylower, &
                                  dx, dy, aux)

        use geoclaw_module, only: sea_level

        implicit none

        ! Input
        integer, intent(in) :: mx, my, num_ghost, num_aux
        real(kind=8), intent(in) :: xlower, ylower, dx, dy
        real(kind=8), intent(in out) :: aux(num_aux,                           &
                                            1-num_ghost:mx+num_ghost,&
                                            1-num_ghost:my+num_ghost)

        ! Locals
        integer :: m,i,j,k
        real(kind=8) :: x, y

        if (variable_friction) then
            ! Set region based coefficients
            do m=1, num_friction_regions
                do i=1 - num_ghost, mx + num_ghost
                    do j=1 - num_ghost, my + num_ghost                        
                        x = xlower + (i-0.5d0) * dx
                        y = ylower + (j-0.5d0) * dy
                        if (friction_regions(m)%lower(1) < x .and.   &
                            friction_regions(m)%lower(2) < y .and.   &
                            friction_regions(m)%upper(1) >= x .and.  &
                            friction_regions(m)%upper(2) >= y) then

                            ! sea_level is not set properly here, just a test case 
                            
                            do k=1,size(friction_regions(m)%depths) - 1
                                if (friction_regions(m)%depths(k+1) <= aux(1,i,j) - sea_level &
                                    .and. friction_regions(m)%depths(k) > aux(1,i,j) - sea_level) then

                                    aux(friction_index,i,j) = &
                                     friction_regions(m)%manning_coefficients(k)
                                endif
                            enddo
                        endif
                    enddo
                enddo
            enddo

            if (num_friction_files > 0) then
                stop "*** ERROR *** File based friction specification not implemented."
            endif
        end if

    end subroutine set_friction_field


    ! ==========================================================================
    !  read_friction_file - Reads an input file containing info on friction
    !    coefficients.
    ! ==========================================================================
    type(friction_file_type) function read_friction_file(path, file_type) result(file)
        
        implicit none

        ! Path to file to be read in
        character(len=*), intent(in) :: path
        integer, intent(in) :: file_type

        ! Locals
        integer, parameter :: unit = 24
!         real(kind=8), parameter :: missing_value = huge(1.d0)
        integer :: ios, missing
        
        ! Open file for reading
        open(unit=unit, file=path, iostat=ios, status="unknown",   &
                action="read", form='formatted')
        if ( ios /= 0 ) then 
            print *,"*** Error *** Could not open friction file ",path
            stop
        endif

        select case(abs(file_type))
            ! ASCII file with x,y,z values on each line.
            ! (progressing from upper left corner across rows, then down)
            ! Assumes a uniform rectangular grid of data values.
            case(1)
                stop "Unimplemented file type for friction files."
            
            ! ================================================================
            ! ASCII file with header followed by z data
            ! (progressing from upper left corner across rows, then down)
            ! one value per line if filetype=2 or
            ! mx values per line if filetype=3
            ! ================================================================
            case(2:3)
                ! Read header
                read(unit,*) file%num_cells(1)
                read(unit,*) file%num_cells(2)
                read(unit,*) file%lower(1)
                read(unit,*) file%lower(2)
                read(unit,*) file%dx(1)
                read(unit,*) file%no_data_value

                ! Calculate upper corner
                file%dx(2) = file%dx(1)
                file%upper(1) = file%lower(1) + file%dx(1) * (file%num_cells(1) - 1)
                file%upper(2) = file%lower(2) + file%dx(2) * (file%num_cells(2) - 1)

                ! Allocate data array
                allocate(file%data(file%num_cells(1),file%num_cells(2)))

                ! Read in data
                missing = 0
                select case(abs(file_type))
                    case(2)
                        stop "Unhandled file type"
!                         do i=1,product(num_cells)
!                             read(iunit,*) field%data(i,)
!                             if (auxinit(i) == no_data_value) then
!                                 missing = missing + 1
!                                 field%data(i) = missing_value
!                             endif
!                         enddo
                    case(3)
                        stop "Unhandled file type"
!                         do j=1,my
!                             read(iunit,*) (auxinit((j-1)*mx + i),i=1,mx)
!                             do i=1,mx
!                                 if (auxinit((j-1)*mx + i) == no_data_value) then
!                                     missing = missing + 1
!                                     auxinit((j-1)*mx + i) = missing_value
!                                 endif
!                             enddo
!                         enddo
                end select
            
            case default
                stop "Unimplemented file type for friction files."
        end select
        
    end function read_friction_file

end module friction_module

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
    implicit double precision(a-h,o-z)

!     # Riemann solver in the transverse direction for the advection equation.

    dimension     ql(meqn, 1-mbc:maxm+mbc)
    dimension     qr(meqn, 1-mbc:maxm+mbc)
    dimension   asdq(meqn, 1-mbc:maxm+mbc)
    dimension bmasdq(meqn, 1-mbc:maxm+mbc)
    dimension bpasdq(meqn, 1-mbc:maxm+mbc)
    dimension   aux1(maux, 1-mbc:maxm+mbc)
    dimension   aux2(maux, 1-mbc:maxm+mbc)
    dimension   aux3(maux, 1-mbc:maxm+mbc)

    kv = 3-ixy  !#  = 1 if ixy=2  or  = 2 if ixy=1
    do 10 i=2-mbc,mx+mbc
        i1 = i-2+imp    !#  =  i-1 for amdq,  i for apdq
        bmasdq(1,i) = dmin1(aux2(kv,i1), 0.d0) * asdq(1,i)
        bpasdq(1,i) = dmax1(aux3(kv,i1), 0.d0) * asdq(1,i)
    10 END DO

    return
    end subroutine rpt2

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::: Parameters, variables, subroutines related to gauges
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

! Modified for geoclaw_1d/src/1d_nonuniform code based on $CLAW/classic

! Contains:
!   subroutine set_gauges
!     Called initially to read from gauges.data
!   subroutine print_gauges
!     Called each time step 
!
!     Note: by default all components of q are printed at each gauge.
!     To print something different or a different precision, modify 
!     format statement 100 and/or the write statement that uses it.
!   

module gauges_module

    implicit none
    save

    logical, private :: module_setup = .false.

    integer, parameter :: OUTGAUGEUNIT=89
    integer :: num_gauges, inum
    real(kind=8), allocatable :: xgauge(:), t1gauge(:), t2gauge(:)
    integer, allocatable, dimension(:) ::  igauge, nextLoc
    
    integer, parameter :: MAXDATA=1000
    real(kind=8), pointer :: gaugeArray(:,:,:)

contains

    subroutine set_gauges(restart, nvar, fname)

        implicit none

        ! Input
        character(len=*), intent(in), optional :: fname
        logical, intent(in) :: restart
        integer, intent(in) :: nvar

        ! Locals
        integer :: i, ipos, idigit
        integer, parameter :: iunit = 7
        character*14 ::  fileName

        if (.not. module_setup) then

            ! Open file
            if (present(fname)) then
                call opendatafile(iunit,fname)
            else
                call opendatafile(iunit,'gauges.data')
            endif

            read(iunit,*) num_gauges

            allocate(xgauge(num_gauges))
            allocate(t1gauge(num_gauges), t2gauge(num_gauges))
            allocate(igauge(num_gauges))

            allocate(nextLoc(num_gauges))
            allocate(gaugeArray(nvar+2,MAXDATA,num_gauges)) !+2 for time,eta
            
            do i=1,num_gauges
                read(iunit,*) igauge(i),xgauge(i),t1gauge(i),t2gauge(i)
            enddo

            close(iunit)
            
            ! initialize for starters
            nextLoc  = 1  ! next location to be filled with gauge info

            do i = 1, num_gauges
               fileName = 'gaugexxxxx.txt'    ! NB different name convention too
               inum = igauge(i)
               do ipos = 10,6,-1              ! do this to replace the xxxxx in the name
                  idigit = mod(inum,10)
                  fileName(ipos:ipos) = char(ichar('0') + idigit)
                  inum = inum / 10
               end do

    !          status unknown since might be a restart run. might need to rewind
               if (restart) then
                  open(unit=OUTGAUGEUNIT, file=fileName, status='old',        &
                       position='append', form='formatted')
               else
                  open(unit=OUTGAUGEUNIT, file=fileName, status='unknown',        &
                       position='append', form='formatted')
                  rewind OUTGAUGEUNIT
                  ! write out nvar+1 variables h, hu, eta=h+B
                  write(OUTGAUGEUNIT,100) igauge(i), xgauge(i), nvar+1
  100             format("# gauge_id= ",i5," location=( ",1e15.7," ) num_eqn= ",i2)
                  write(OUTGAUGEUNIT,101)
  101             format("# Columns: level time h hu eta")
               endif

               close(OUTGAUGEUNIT)

            end do

            module_setup = .true.
        end if

    end subroutine set_gauges


!
! -------------------------------------------------------------------------
!
      subroutine update_gauges(q,aux,xlow,nvar,mx,mbc,naux,dx,tgrid)
!
!     This routine is called each time step.

      implicit none

      real(kind=8), intent(in) ::  xlow,dx,tgrid
      integer, intent(in) ::  nvar,mx,mbc,naux
      real(kind=8), intent(in) ::  q(nvar,1-mbc:mx+mbc)
      real(kind=8), intent(in) ::  aux(naux,1-mbc:mx+mbc)

      ! local variables:
      real(kind=8) :: var(nvar)
      real(kind=8) :: xcent,xoff,topo
      integer :: i,iindex,ivar, ii,i1,i2
      integer :: nindex

!     write(*,*) '+++ in print_gauges with num_gauges = ',num_gauges

      if (num_gauges == 0) then
         return
      endif

!     write(*,*) 'tgrid = ',tgrid

      do 10 ii=1,num_gauges
!       write(6,*) '+++ interploting for gauge ', ii
        iindex =  int(.5d0 + (xgauge(ii)-xlow)/dx)
        if (iindex .lt. 1-mbc .or. iindex .gt. mx+mbc-1) &
          write(*,*)"ERROR in output of Gauge Data "
        xcent  = xlow + (iindex-.5d0)*dx
        xoff   = (xgauge(ii)-xcent)/dx
!   IF WANT TO INCLUDE THIS TEST< MODIFY FOR ROUNDOFF LEVEL DIFF
!       if (xoff .lt. 0.d0 .or. xoff .gt. 1.d0) then
!          write(6,*)" BIG PROBLEM in DUMPGAUGE", i
!       endif

!       ## linear interpolation
        do ivar = 1, nvar
           var(ivar) = (1.d0-xoff)*q(ivar,iindex) &
                   + xoff*q(ivar,iindex+1)
!          # for printing without underflow of exponent:
           if (abs(var(ivar)) .lt. 1.d-90) var(ivar) = 0.d0
        end do


       ! save info for this time
        nindex = nextLoc(ii)
 
        gaugeArray(1,nindex,ii) = tgrid
        do ivar = 1, nvar
           gaugeArray(1+ivar,nindex,ii) = var(ivar)
        end do

!       # also store surface eta computed using interpolated topography:
        topo = (1.d0-xoff)*aux(1,iindex) + xoff*aux(1,iindex+1)
        gaugeArray(nvar+2,nindex,ii) = var(1) + topo
        
        nextLoc(ii) = nextLoc(ii) + 1
        if (nextLoc(ii) .gt. MAXDATA) then
          call print_gauges_and_reset_nextLoc(ii,nvar)  
        endif
 10     continue  ! end of loop over all gauges
 
      end subroutine update_gauges
!
! -------------------------------------------------------------------------
!
      subroutine print_gauges_and_reset_nextLoc(gaugeNum,nvar)
!
!    Array of gauge data for this gauge reached max capacity
!    print to file.

      implicit none
      integer :: gaugeNum,nvar,j,inum,k,idigit,ipos,myunit
      integer :: omp_get_thread_num, mythread
      character*14 :: fileName

      ! open file for gauge gaugeNum, figure out name
      ! not writing gauge number since it is in file name now
      ! status is old, since file name and info written for
      ! each file in in set_gauges.
      !
      ! NB: output written in different order, losing backward compatibility


      fileName = 'gaugexxxxx.txt'    ! NB different name convention too
      inum = igauge(gaugeNum)
      do ipos = 10,6,-1              ! do this to replace the xxxxx in the name
         idigit = mod(inum,10)
         fileName(ipos:ipos) = char(ichar('0') + idigit)
         inum = inum / 10
      end do


      open(unit=OUTGAUGEUNIT, file=fileName, status='old',    &
           position='append', form='formatted')
      
      ! called either because array is full (write MAXDATA amount of gauge data)
      ! or checkpoint time, so write whatever is in array and reset.
      ! nextLoc has already been increment before this subr. called
      do j = 1, nextLoc(gaugeNum)-1
        write(OUTGAUGEUNIT,100) 1, (gaugeArray(k,j,gaugeNum),k=1,nvar+2) 
            ! writes 1 for level and gaugeArray includes time in first col
      end do
      nextLoc(gaugeNum) = 1                        

      ! if you want to modify number of digits printed, modify this...
100     format(i5.2, 10e15.7)

      ! close file
      close(OUTGAUGEUNIT)

      end subroutine print_gauges_and_reset_nextLoc

end module gauges_module

c
c
c
c
c     =================================================
      subroutine cellave(xlow,ylow,dx,dy,wl)
c     =================================================
      implicit double precision (a-h,o-z)
      external fss
      logical fl(5),alll,allr
      dimension x(10),y(10),xx(5),yy(5)
      common/fsscorn/ xc0,yc0,xc1,yc1
c   
c     # compute wl, fraction of cell that lies in left state.
c     # For initial data with two states ql and qr separated by a 
c     # discontinuity. The curve along which the discontinuity lies is
c     # specified by the function fdisc, which should return a value that
c     # is negative on the side where ql lies and positive on the qr side.
c
c     # xlow,ylow is the coordinate of the lower left corner of the cell.
c     # dx, dy are grid spacing in x and y.
c
      xx(1) = xlow
      xx(2) = xlow
      xx(3) = xlow+dx
      xx(4) = xlow+dx
      xx(5) = xx(1)
      yy(1) = ylow
      yy(2) = ylow+dy
      yy(3) = ylow+dy
      yy(4) = ylow
      yy(5) = yy(1)
      alll = .true.
      allr = .true.
c
      do 20 i=1,4
         fl(i) = fdisc(xx(i),yy(i)) .lt. 0.d0
         alll = alll .and. fl(i)
         allr = allr .and. (.not. fl(i))
   20    continue
      fl(5) = fl(1)
c
      if (alll) then
         wl = 1.d0
         return
         endif
      if (allr) then
         wl = 0.d0
         return
         endif
c
      iv = 0
      do 40 i=1,4
          if (fl(i)) then
               iv = iv+1
               x(iv) = xx(i)
               y(iv) = yy(i)
               endif
          if (fl(i).neqv.fl(i+1)) then
               iv = iv+1
               xc0 = xx(i)
               yc0 = yy(i)
               xc1 = xx(i+1)
               yc1 = yy(i+1)
               ss = zeroin(0.d0, 1.d0, fss, 1d-8)
c              write(27,*) 'xc,yc,ss:',xc0,yc0,xc1,yc1,ss
               x(iv) = xx(i) + ss*(xx(i+1)-xx(i))
               y(iv) = yy(i) + ss*(yy(i+1)-yy(i))
               endif
   40     continue
c
c     # compute area:
c
      if (iv.eq.0) then
         wl = 0.d0
         return
         endif
c
      x(iv+1) = x(1)
      y(iv+1) = y(1)
      area = 0.d0
      do 50 i=1,iv
         area = area + .5d0*(y(i)+y(i+1))*(x(i+1)-x(i))
c        write(27,*) '  x,y:',x(i),y(i)
   50    continue
c
      wl = area / (dx*dy)
c     write(27,*) 'area,wl:',area,wl
c
      return
      end

subroutine prepBuildSparseMatrixSGNcrs(soln,rhs,nvar,naux,levelBouss,numBoussCells)

    
    use amr_module
    use bouss_module
    use geoclaw_module, only: earth_radius, deg2rad, coordinate_system, grav
    use geoclaw_module, only: sea_level
        
    implicit none
    
    integer, intent(in) :: nvar, naux, levelBouss, numBoussCells
    
    !! pass in numBoussCells for this level so can dimension this array
    real(kind=8) :: soln(0:2*numBoussCells), rhs(0:2*numBoussCells) 
    
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: i,j,nng,levSt,nx,ny,mitot,mjtot,loc,locold,locaux,mptr
    integer :: numColsTot

    integer(kind=8) :: clock_start, clock_finish, clock_rate
    real(kind=8) :: cpu_start, cpu_finish
    
    real(kind=8), allocatable, dimension(:) :: uv,Auv,rowsum
    real(kind=8), allocatable, dimension(:,:) :: hx, hy, phi
    real(kind=8), allocatable, dimension(:,:) :: Bx, By, Bxy, Bxx, Byy
    real(kind=8), allocatable, dimension(:,:) :: etax, etay
    
    integer :: nD, k

    external :: MATVEC
    logical :: yhi_db, ylo_db, xlo_db, xhi_db

    
    ! bc_xlo, bc_ylo, bc_xhi, bc_yhi are set in bouss_module.
    !     0 means Dirchlet value 0 (no correction at each of union of patches)
    !     1 means Neumann (correction in first interior cell = in ghost cell)
    !     2 means use ghost cell values in q(4:5,:,:) as Dirichlet BCs
    !             Multiply by matrix element and move to RHS
    !             Requires nvar==5.
    
#ifdef WHERE_AM_I
  write(*,*) "starting buildSparseMatrixSGNcrs"
#endif

    call system_clock(clock_start,clock_rate)
    call cpu_time(cpu_start)
    
    minfo => matrix_info_allLevs(levelBouss)

!
! ================== Step 2  set up for matrix elements  ======================
    

    nD = numBoussCells   ! shorthand for size of matrix blocks D1 to D4
    
    !allocate(uv(2*nD), Auv(2*nD)) ! for testing matvec
    
    ! For Boussinesq, matrix is 2*nD by 2*nD,
    !     A = [I - D1   -D2  ]
    !         [ -D3    I - D4]
    ! and the solution vector consists of 
    !     updates to hu in all Bouss cells, followed by
    !     updates to hv in all Bouss cells
    
    ! Set up matrix A in sparse triad form: 
    !    matrix_sa(k) is the nonzero element if A in 
    !    row matrix_ia(k), and column matrix_ja(a)
    
    rhs(:) = 0.d0
    
    ! loop over Bouss patches, must be done sequentially:
    
    levSt  = listStart(levelBouss)
    
!$OMP PARALLEL DO PRIVATE(mptr,nx,ny,mitot,mjtot,loc,locold,locaux),   &
!$OMP             SHARED(levelBouss,numgrids,levSt,alloc,node,nghost,  &
!$OMP                    numBoussCells,nvar,naux,minfo,listOfGrids,    &
!$OMP                    soln,rhs),    &
!$OMP             SCHEDULE(dynamic,1),                                 &
!$OMP             DEFAULT(none)
    nng_loop: do  nng = 1, numgrids(levelBouss)
    
        mptr   = listOfGrids(levSt+nng-1)
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost
        loc = node(store1,mptr)  ! needed for iadd
        locold = node(store2,mptr)  ! needed for iadd
        if (locold .eq. 0) locold = loc  ! finest level has no old time soln
        locaux = node(storeaux,mptr)  ! needed for iaddaux

        call buildSparseMatrixSGNcrs(alloc(loc),alloc(locold),         &
                     alloc(locaux),soln,rhs,minfo%rowPtr,minfo%cols,   &
                     minfo%vals, numBoussCells,levelBouss,mptr,nx,ny,nvar,naux)
            
    
    enddo  nng_loop

    ! put last line in CRS row pointers to signify end
    minfo%rowPtr(2*numBoussCells) = minfo%rowPtr(2*numBoussCells-1)+12

    call compressOut(minfo%vals,minfo%rowPtr,minfo%cols,numBoussCells,numColsTot)
    minfo%numColsTot = numColsTot
    minfo%rowPtr(2*numBoussCells) = numColsTot

    ! =============

    call system_clock(clock_finish,clock_rate)
    call cpu_time(cpu_finish)
    timePrepBuild = timePrepBuild + clock_finish-clock_start
    timePrepBuildCPU = timePrepBuildCPU + cpu_finish-cpu_start
        
#ifdef WHERE_AM_I
  write(*,*) "ending   prepBuildSparseMatrixSGNcrs"
#endif

end subroutine prepBuildSparseMatrixSGNcrs

c     ============================================
      subroutine setaux(mbc,mx,xlower,dx,maux,aux)
c     ============================================
c     
c     # set auxiliary arrays 
c     # variable coefficient acoustics
c     #  aux(i,1) = impedance Z in i'th cell
c     #  aux(i,2) = sound speed c in i'th cell
c     
c     # Piecewise constant medium with single interface at x=0
c     # Density and sound speed to left and right are set in setprob.f
c

      use amr_module, only : NEEDS_TO_BE_SET
      use adjoint_module, only: innerprod_index
      implicit none

      integer, intent(in) :: mbc, mx, maux
      double precision, intent(in) :: xlower, dx
      double precision, intent(out) :: aux(maux, 1-mbc:mx+mbc)

      common /comaux/ Zl, cl, Zr, cr
      double precision Zl, cl, Zr, cr

      integer i
      double precision xcell

      do i=1-mbc,mx+mbc

         if (aux(1,i) .eq. NEEDS_TO_BE_SET) then
            aux(innerprod_index,i) = 0.d0
         endif

         xcell = xlower + (i-0.5d0)*dx
         if (xcell .lt. 0.0d0) then
            aux(1,i) = Zl
            aux(2,i) = cl
         else
            aux(1,i) = Zr
            aux(2,i) = cr
         endif
      enddo

      return
      end

c
c -------------------------------------------------------------
c
       subroutine qad(valbig,mitot,mjtot,nvar,
     .                svdflx,qc1d,lenbc,lratiox,lratioy,hx,hy,
     .                maux,aux,auxc1d,delt,mptr)

       use amr_module
       implicit double precision (a-h, o-z)


       logical qprint

       dimension valbig(nvar,mitot,mjtot)
       dimension qc1d(nvar,lenbc)
       dimension svdflx(nvar,lenbc)
       dimension aux(maux,mitot,mjtot)
       dimension auxc1d(maux,lenbc)

c
c ::::::::::::::::::::::::::: QAD ::::::::::::::::::::::::::::::::::
c  solve RP between ghost cell value on fine grid and coarse grid
c  value that ghost cell overlaps. The resulting fluctuations
c  are added in to coarse grid value, as a conservation fixup. 
c  Done each fine grid time step. If source terms are present, the
c  coarse grid value is advanced by source terms each fine time step too.

c  No change needed in this sub. for spherical mapping: correctly
c  mapped vals already in bcs on this fine grid and coarse saved
c  vals also properly prepared
c
c Side 1 is the left side of the fine grid patch.  Then go around clockwise.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c      # local storage
c      # note that dimension here are bigger than dimensions used
c      # in rp2, but shouldn't matter since wave is not used in qad
c      # and for other arrays it is only the last parameter that is wrong
c      #  ok as long as meqn, mwaves < maxvar

       integer max1dp1
       dimension ql(nvar,max1d+1),    qr(nvar,max1d+1)
       dimension wave(nvar,mwaves,max1d+1), s(mwaves,max1d+1)
       dimension amdq(nvar,max1d+1),  apdq(nvar,max1d+1)
       dimension auxl(maxaux*(max1d+1)),  auxr(maxaux*(max1d+1))
c
c  WARNING: auxl,auxr dimensioned at max possible, but used as if
c  they were dimensioned as the real maux by max1d+1. Would be better
c  of course to dimension by maux by max1d+1 but this wont work if maux=0
c  So need to access using your own indexing into auxl,auxr.
       iaddaux(iaux,i) = iaux + maux*(i-1)

       data qprint/.false./
c
c      aux is auxiliary array with user parameters needed in Riemann solvers
c          on fine grid corresponding to valbig
c      auxc1d is coarse grid stuff from around boundary, same format as qc1d
c      auxl, auxr are work arrays needed to pass stuff to rpn2
c      maux is the number of aux variables, which may be zero.


c  ---------------------------------------------------------------
c      # for GeoClaw we skip this routine --- need to fix someday:

c      # Is this routine properly implemented with dry states and
c      # interpolation based on surface eta?

c       return

c  ---------------------------------------------------------------

       max1dp1 = max1d + 1

       if (qprint) write(dbugunit,*)" working on grid ",mptr
       tgrid = rnode(timemult, mptr)
       nc = mjtot-2*nghost
       nr = mitot-2*nghost
       level = node(nestlevel, mptr)
       index = 0
c
c--------
c  side 1
c--------
c
       do 10 j = nghost+1, mjtot-nghost
       if (maux.gt.0) then
          do 5 ma = 1,maux
             if (auxtype(ma).eq."xleft") then
c                # Assuming velocity at left-face, this fix
c                # preserves conservation in incompressible flow:
                 auxl(iaddaux(ma,j-nghost+1)) = aux(ma,nghost+1,j)
               else
c                # Normal case -- we set the aux arrays 
c                # from the cell corresponding  to q
                 auxl(iaddaux(ma,j-nghost+1)) = aux(ma,nghost,j)
               endif
  5          continue
          endif
       do 10 ivar = 1, nvar
         ql(ivar,j-nghost+1) = valbig(ivar,nghost,j)
 10    continue

       lind = 0
       ncrse = (mjtot-2*nghost)/lratioy
       do 20 jc = 1, ncrse
         index = index + 1
         do 25 l = 1, lratioy
         lind = lind + 1
         if (maux.gt.0) then
            do 24 ma=1,maux
               auxr(iaddaux(ma,lind)) = auxc1d(ma,index)
   24          continue
            endif
         do 25 ivar = 1, nvar
 25         qr(ivar,lind) = qc1d(ivar,index)
 20    continue
       index = ncrse

       if (qprint) then
         write(dbugunit,*) 'side 1, ql and qr:'
         do i=2,nc
            write(dbugunit,4101) i,qr(1,i-1),ql(1,i)
          enddo
 4101      format(i3,4e16.6)
         if (maux .gt. 0) then
             write(dbugunit,*) 'side 1, auxr:'
             do i=2,nc
                write(dbugunit,4101) i,(auxr(iaddaux(ma,i-1)),ma=1,maux)
                enddo
             write(dbugunit,*) 'side 1, auxl:'
             do i=2,nc
                write(dbugunit,4101) i,(auxl(iaddaux(ma,i)),ma=1,maux)
                enddo
         endif
       endif
 
       call rpn2(1,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .           nc+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 1 add into sdflxm
c
       influx = 0
       do 30 j = 1, nc/lratioy
          influx  = influx + 1
          jfine = (j-1)*lratioy
          do 40 ivar = 1, nvar
            do 50 l = 1, lratioy
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     + amdq(ivar,jfine+l+1) * hy * delt
     .                     + apdq(ivar,jfine+l+1) * hy * delt
 50         continue
 40       continue
 30    continue

c--------
c  side 2
c--------
c
       if (mjtot .eq. 2*nghost+1) then
c          # a single row of interior cells only happens when using the
c          # 2d amrclaw code to do a 1d problem with refinement.
c          # (feature added in Version 4.3)
c          # skip over sides 2 and 4 in this case
           go to 299
           endif

       do 210 i = nghost+1, mitot-nghost
        if (maux.gt.0) then
          do 205 ma = 1,maux
             auxr(iaddaux(ma,i-nghost)) = aux(ma,i,mjtot-nghost+1)
 205         continue
          endif
        do 210 ivar = 1, nvar
            qr(ivar,i-nghost) = valbig(ivar,i,mjtot-nghost+1)
 210    continue

       lind = 0
       ncrse = (mitot-2*nghost)/lratiox
       do 220 ic = 1, ncrse
         index = index + 1
         do 225 l = 1, lratiox
         lind = lind + 1
         if (maux.gt.0) then
            do 224 ma=1,maux
             if (auxtype(ma).eq."yleft") then
c                # Assuming velocity at bottom-face, this fix
c                # preserves conservation in incompressible flow:
                 ifine = (ic-1)*lratiox + nghost + l
                 auxl(iaddaux(ma,lind+1)) = aux(ma,ifine,mjtot-nghost+1)
               else
                 auxl(iaddaux(ma,lind+1)) = auxc1d(ma,index)
               endif
  224          continue
            endif
         do 225 ivar = 1, nvar
 225         ql(ivar,lind+1) = qc1d(ivar,index)
 220    continue
    
       if (qprint) then
         write(dbugunit,*) 'side 2, ql and qr:'
         do i=1,nr
            write(dbugunit,4101) i,ql(1,i+1),qr(1,i)
            enddo
         if (maux .gt. 0) then
             write(dbugunit,*) 'side 2, auxr:'
             do i = 1, nr
                write(dbugunit,4101) i, (auxr(iaddaux(ma,i)),ma=1,maux)
                enddo
             write(dbugunit,*) 'side 2, auxl:'
             do i = 1, nr
                write(dbugunit,4101) i, (auxl(iaddaux(ma,i)),ma=1,maux)
                enddo
         endif
       endif
       call rpn2(2,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 2. add into sdflxp
c
       do 230 i = 1, nr/lratiox
          influx  = influx + 1
          ifine = (i-1)*lratiox
          do 240 ivar = 1, nvar
            do 250 l = 1, lratiox
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     - amdq(ivar,ifine+l+1) * hx * delt
     .                     - apdq(ivar,ifine+l+1) * hx * delt
 250         continue
 240       continue
 230    continue

 299  continue

c--------
c  side 3
c--------
c
       do 310 j = nghost+1, mjtot-nghost
        if (maux.gt.0) then
          do 305 ma = 1,maux
             auxr(iaddaux(ma,j-nghost)) = aux(ma,mitot-nghost+1,j)
 305         continue
          endif
        do 310 ivar = 1, nvar
          qr(ivar,j-nghost) = valbig(ivar,mitot-nghost+1,j)
 310      continue

       lind = 0
       ncrse = (mjtot-2*nghost)/lratioy
       do 320 jc = 1, ncrse
         index = index + 1
         do 325 l = 1, lratioy
         lind = lind + 1
         if (maux.gt.0) then
            do 324 ma=1,maux
             if (auxtype(ma).eq."xleft") then
c                # Assuming velocity at left-face, this fix
c                # preserves conservation in incompressible flow:
                 jfine = (jc-1)*lratioy + nghost + l
                 auxl(iaddaux(ma,lind+1)) = aux(ma,mitot-nghost+1,jfine)
               else
                 auxl(iaddaux(ma,lind+1)) = auxc1d(ma,index)
               endif
  324          continue
            endif
         do 325 ivar = 1, nvar
 325         ql(ivar,lind+1) = qc1d(ivar,index)
 320    continue
    
       if (qprint) then
         write(dbugunit,*) 'side 3, ql and qr:'
         do i=1,nc
            write(dbugunit,4101) i,ql(1,i),qr(1,i)
            enddo
       endif
       call rpn2(1,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nc+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 3 add into sdflxp
C
       do 330 j = 1, nc/lratioy
          influx  = influx + 1
          jfine = (j-1)*lratioy
          do 340 ivar = 1, nvar
            do 350 l = 1, lratioy
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     - amdq(ivar,jfine+l+1) * hy * delt
     .                     - apdq(ivar,jfine+l+1) * hy * delt
 350         continue
 340       continue
 330    continue

c--------
c  side 4
c--------
c
       if (mjtot .eq. 2*nghost+1) then
c          # a single row of interior cells only happens when using the
c          # 2d amrclaw code to do a 1d problem with refinement.
c          # (feature added in Version 4.3)
c          # skip over sides 2 and 4 in this case
           go to 499
           endif
c
       do 410 i = nghost+1, mitot-nghost
        if (maux.gt.0) then
          do 405 ma = 1,maux
             if (auxtype(ma).eq."yleft") then
c                # Assuming velocity at bottom-face, this fix
c                # preserves conservation in incompressible flow:
                 auxl(iaddaux(ma,i-nghost+1)) = aux(ma,i,nghost+1)
               else
                 auxl(iaddaux(ma,i-nghost+1)) = aux(ma,i,nghost)
               endif
 405         continue
          endif
        do 410 ivar = 1, nvar
          ql(ivar,i-nghost+1) = valbig(ivar,i,nghost)
 410      continue

       lind = 0
       ncrse = (mitot-2*nghost)/lratiox
       do 420 ic = 1, ncrse
         index = index + 1
         do 425 l = 1, lratiox
         lind = lind + 1
         if (maux.gt.0) then
            do 424 ma=1,maux
               auxr(iaddaux(ma,lind)) = auxc1d(ma,index)
  424          continue
            endif
         do 425 ivar = 1, nvar
 425         qr(ivar,lind) = qc1d(ivar,index)
 420    continue
    
       if (qprint) then
         write(dbugunit,*) 'side 4, ql and qr:'
         do i=1,nr
            write(dbugunit,4101) i, ql(1,i),qr(1,i)
            enddo
       endif
       call rpn2(2,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 4. add into sdflxm
c
       do 430 i = 1, nr/lratiox
          influx  = influx + 1
          ifine = (i-1)*lratiox
          do 440 ivar = 1, nvar
            do 450 l = 1, lratiox
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     + amdq(ivar,ifine+l+1) * hx * delt
     .                     + apdq(ivar,ifine+l+1) * hx * delt
 450         continue
 440       continue
 430    continue

 499   continue

c      # for source terms:
c      # This is commented out for now --- updating the momenumtum due
c      # to friction/Coriolis source terms affects the resulting mass flux
c      # and leads to loss of conservation when src1d is used.
c      # It would be better to incorporate these source terms into the
c      # the f-wave formulation?
c      if (method(5) .ne. 0) then
c          call src1d(nvar,nghost,lenbc,qc1d,maux,auxc1d,tgrid,delt)
c          endif

       return
       end

c  DEPRECATED, NOT UPDATED TO NEW ORDER OF INDICES, ETC. 
c  Functionality with fwaves merged into flux3.f
c
c     ==================================================================
      subroutine flux3(ixyz,maxm,meqn,maux,       mbc,mx,
     &                 q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3,
     &                 faddm,faddp,gadd,hadd,cfl1d,
     &                 fwave,s,amdq,apdq,cqxx,
     &                 bmamdq,bmapdq,bpamdq,bpapdq,
     &                 cmamdq,cmapdq,cpamdq,cpapdq,
     &                 cmamdq2,cmapdq2,cpamdq2,cpapdq2,
     &                 bmcqxxm,bmcqxxp,bpcqxxm,bpcqxxp,
     &                 cmcqxxm,cmcqxxp,cpcqxxm,cpcqxxp,
     &                 bmcmamdq,bmcmapdq,bpcmamdq,bpcmapdq,
     &                 bmcpamdq,bmcpapdq,bpcpamdq,bpcpapdq,
     &                 rpn3,rpt3, rptt3)
c     ==================================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c--------------------------------------------------------------------
c     # flux3fw is a modified version of flux3 to use fwave instead of wave.
c     # A modified Riemann solver rp3n must be used in conjunction with this
c     # routine, which returns fwave's instead of wave's.
c     # See http://amath.washington.edu/~claw/fwave.html
c
c     # Limiters are applied to the fwave's, and the only significant
c     # modification of this code is in the "do 119" loop, for the
c     # second order corrections.
c
c--------------------------------------------------------------------

c
c     # Compute the modification to fluxes f, g and h that are generated by
c     # all interfaces along a 1D slice of the 3D grid.
c     #    ixyz = 1  if it is a slice in x
c     #           2  if it is a slice in y
c     #           3  if it is a slice in z
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd, gadd and hadd.  The notation is written
c     # assuming we are solving along a 1D slice in the x-direction.
c
c     # fadd(i,.) modifies F to the left of cell i
c     # gadd(i,.,1,slice) modifies G below cell i (in the z-direction)
c     # gadd(i,.,2,slice) modifies G above cell i
c     #                   The G flux in the surrounding slices may
c     #                   also be updated.
c     #                   slice  =  -1     The slice below in y-direction
c     #                   slice  =   0     The slice used in the 2D method
c     #                   slice  =   1     The slice above in y-direction
c     # hadd(i,.,1,slice) modifies H below cell i (in the y-direction)
c     # hadd(i,.,2,slice) modifies H above cell i
c     #                   The H flux in the surrounding slices may
c     #                   also be updated.
c     #                   slice  =  -1     The slice below in z-direction
c     #                   slice  =   0     The slice used in the 2D method
c     #                   slice  =   1     The slice above in z-direction
c     #
c     # The method used is specified by method(2) and method(3):
c
c        method(2) = 1 No correction waves
c                  = 2 if second order correction terms are to be added, with
c                      a flux limiter as specified by mthlim.  No transverse
c                      propagation of these waves.
c
c         method(3) specify how the transverse wave propagation
c         of the increment wave and the correction wave are performed.
c         Note that method(3) is given by a two digit number, in
c         contrast to what is the case for claw2. It is convenient
c         to define the scheme using the pair (method(2),method(3)).
c
c         method(3) <  0 Gives dimensional splitting using Godunov
c                        splitting, i.e. formally first order
c                        accurate.
c                      0 Gives the Donor cell method. No transverse
c                        propagation of neither the increment wave
c                        nor the correction wave.
c                   = 10 Transverse propagation of the increment wave
c                        as in 2D. Note that method (2,10) is
c                        unconditionally unstable.
c                   = 11 Corner transport upwind of the increment
c                        wave. Note that method (2,11) also is
c                        unconditionally unstable.
c                   = 20 Both the increment wave and the correction
c                        wave propagate as in the 2D case. Only to
c                        be used with method(2) = 2.
c                   = 21 Corner transport upwind of the increment wave,
c                        and the correction wave propagates as in 2D.
c                        Only to be used with method(2) = 2.
c                   = 22 3D propagation of both the increment wave and
c                        the correction wave. Only to be used with
c                        method(2) = 2.
c
c         Recommended settings:   First order schemes:
c                                       (1,10) Stable for CFL < 1/2
c                                       (1,11) Stable for CFL < 1
c                                 Second order schemes:
c                                        (2,20) Stable for CFL < 1/2
c                                        (2,22) Stable for CFL < 1
c
c         WARNING! The schemes (2,10), (2,11) are unconditionally
c                  unstable.
c
c                       ----------------------------------
c
c     Note that if method(6)=1 then the capa array comes into the second
c     order correction terms, and is already included in dtdx1d:
c     If ixyz = 1 then
c        dtdx1d(i) = dt/dx                      if method(6) = 0
c                  = dt/(dx*capa(i,jcom,kcom))  if method(6) = 1
c     If ixyz = 2 then
c        dtdx1d(j) = dt/dy                      if method(6) = 0
c                  = dt/(dy*capa(icom,j,kcom))  if method(6) = 1
c     If ixyz = 3 then
c        dtdx1d(k) = dt/dz                      if method(6) = 0
c                  = dt/(dz*capa(icom,jcom,k))  if method(6) = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn3 into
c            amdq =  the left-going flux difference  A^- Delta q
c            apdq = the right-going flux difference  A^+ Delta q
c        Each of these is split by rpt3 into
c            bmasdq = the down-going transverse flux difference B^- A^* Delta q
c            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
c        where A^* represents either A^- or A^+.
c
c        Finally, each bsasdq is split by rptt3 into :
c            cmbsasdq = C^- B^* A^* Dq
c            cpbsasdq = C^+ B^* A^* Dq
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3,rpt3, rptt3

      dimension     q1d(1-mbc:maxm+mbc, meqn)
      dimension    amdq(1-mbc:maxm+mbc, meqn)
      dimension    apdq(1-mbc:maxm+mbc, meqn)
      dimension  bmamdq(1-mbc:maxm+mbc, meqn)
      dimension  bmapdq(1-mbc:maxm+mbc, meqn)
      dimension  bpamdq(1-mbc:maxm+mbc, meqn)
      dimension  bpapdq(1-mbc:maxm+mbc, meqn)
      dimension   cqxx(1-mbc:maxm+mbc, meqn)
      dimension   faddm(1-mbc:maxm+mbc, meqn)
      dimension   faddp(1-mbc:maxm+mbc, meqn)
      dimension   gadd(1-mbc:maxm+mbc, meqn, 2, -1:1)
      dimension   hadd(1-mbc:maxm+mbc, meqn, 2, -1:1)
c
      dimension  cmamdq(1-mbc:maxm+mbc, meqn)
      dimension  cmapdq(1-mbc:maxm+mbc, meqn)
      dimension  cpamdq(1-mbc:maxm+mbc, meqn)
      dimension  cpapdq(1-mbc:maxm+mbc, meqn)
c
      dimension  cmamdq2(1-mbc:maxm+mbc, meqn)
      dimension  cmapdq2(1-mbc:maxm+mbc, meqn)
      dimension  cpamdq2(1-mbc:maxm+mbc, meqn)
      dimension  cpapdq2(1-mbc:maxm+mbc, meqn)
c
      dimension  bmcqxxm(1-mbc:maxm+mbc, meqn)
      dimension  bpcqxxm(1-mbc:maxm+mbc, meqn)
      dimension  bmcqxxp(1-mbc:maxm+mbc, meqn)
      dimension  bpcqxxp(1-mbc:maxm+mbc, meqn)
c
      dimension  cmcqxxm(1-mbc:maxm+mbc, meqn)
      dimension  cpcqxxm(1-mbc:maxm+mbc, meqn)
      dimension  cmcqxxp(1-mbc:maxm+mbc, meqn)
      dimension  cpcqxxp(1-mbc:maxm+mbc, meqn)

      dimension  bpcmamdq(1-mbc:maxm+mbc, meqn)
      dimension  bpcmapdq(1-mbc:maxm+mbc, meqn)
      dimension  bpcpamdq(1-mbc:maxm+mbc, meqn)
      dimension  bpcpapdq(1-mbc:maxm+mbc, meqn)
      dimension  bmcmamdq(1-mbc:maxm+mbc, meqn)
      dimension  bmcmapdq(1-mbc:maxm+mbc, meqn)
      dimension  bmcpamdq(1-mbc:maxm+mbc, meqn)
      dimension  bmcpapdq(1-mbc:maxm+mbc, meqn)
c
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux1(1-mbc:maxm+mbc, maux, 3)
      dimension aux2(1-mbc:maxm+mbc, maux, 3)
      dimension aux3(1-mbc:maxm+mbc, maux, 3)
c
      dimension    s(1-mbc:maxm+mbc, mwaves)
      dimension  fwave(1-mbc:maxm+mbc, meqn, mwaves)
c
      logical limit
      common/comxyzt/dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom



      limit = .false.
      do 5 mw=1,mwaves
	 if (mthlim(mw) .gt. 0) limit = .true.
   5     continue
c
c     # initialize flux increments:
c     -----------------------------
c
      do 10 m=1,meqn
	 do 10 i = 1-mbc, mx+mbc
	    faddm(i,m) = 0.d0
	    faddp(i,m) = 0.d0
	    gadd(i,m,1,-1) = 0.d0
            gadd(i,m,1, 0) = 0.d0
	    gadd(i,m,1, 1) = 0.d0
	    hadd(i,m,1,-1) = 0.d0
	    hadd(i,m,1, 0) = 0.d0
	    hadd(i,m,1, 1) = 0.d0
            gadd(i,m,2,-1) = 0.d0
	    gadd(i,m,2, 0) = 0.d0
	    gadd(i,m,2, 1) = 0.d0
	    hadd(i,m,2,-1) = 0.d0
	    hadd(i,m,2, 0) = 0.d0
	    hadd(i,m,2, 1) = 0.d0
   10    continue
c
c     # local method parameters
      if (method(3) .lt. 0) then
         m3 = -1
         m4 = 0
      else
         m3 = method(3)/10
         m4 = method(3) - 10*m3
      endif
c
c     -----------------------------------------------------------
c     # solve normal Riemann problem and compute Godunov updates
c     -----------------------------------------------------------
c
c     # aux2(1-mbc,1,2) is the start of a 1d array now used by rpn3
c
      call rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &      aux2(1-mbc,1,2),aux2(1-mbc,1,2),
     &      fwave,s,amdq,apdq)
c
c     # Set fadd for the donor-cell upwind method (Godunov)
      do 40 i=1,mx+1
         do 40 m=1,meqn
            faddp(i,m) = faddp(i,m) - apdq(i,m)
            faddm(i,m) = faddm(i,m) + amdq(i,m)
   40    continue
c
c     # compute maximum wave speed for checking Courant number:
      cfl1d = 0.d0
      do 50 mw=1,mwaves
	 do 50 i=1,mx+1
	    cfl1d = dmax1(cfl1d,dtdx1d(i)*dabs(s(i,mw)))
   50       continue
c
      if (method(2).eq.1) go to 130
c
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c
c     # apply limiter to fwaves:
      if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,fwave,s,mthlim)
c
      do 120 i = 1, mx+1
c
c        # For correction terms below, need average of dtdx in cell
c        # i-1 and i.  Compute these and overwrite dtdx1d:
c
 	 dtdx1d(i-1) = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
c
	 do 120 m=1,meqn
	    cqxx(i,m) = 0.d0
	    do 119 mw=1,mwaves
	       cqxx(i,m) = cqxx(i,m) + 0.5d0 * dsign(1.d0,s(i,mw))
     &	         * (1.d0 - dabs(s(i,mw))*dtdx1d(i-1)) * fwave(i,m,mw)
  119          continue
            faddm(i,m) = faddm(i,m) + cqxx(i,m)
            faddp(i,m) = faddp(i,m) + cqxx(i,m)
  120       continue
c
  130 continue
c
      if( m3 .le. 0) return
c
c     --------------------------------------------
c     # TRANSVERSE PROPAGATION
c     --------------------------------------------
c
c     # split the left-going flux difference into down-going and up-going
c     # flux differences (in the y-direction).
c
      call rpt3(ixyz,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,amdq,bmamdq,bpamdq)
c
c     # split the right-going flux difference into down-going and up-going
c     # flux differences (in the y-direction).
c
      call rpt3(ixyz,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,apdq,bmapdq,bpapdq)
c
c     # split the left-going flux difference into down-going and up-going
c     # flux differences (in the z-direction).
c
      call rpt3(ixyz,3,1,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,amdq,cmamdq,cpamdq)
c
c     # split the right-going flux difference into down-going and up-going
c     # flux differences (in the y-direction).
c
      call rpt3(ixyz,3,2,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,apdq,cmapdq,cpapdq)
c
c     # Split the correction wave into transverse propagating waves
c     # in the y-direction and z-direction.
c
      if (m3.eq.2) then
         if (maux .gt. 0) then
c            # The corrections cqxx affect both cell i-1 to left and cell i
c            # to right of interface.  Transverse splitting will affect
c            # fluxes on both sides.
c            # If there are aux arrays, then we must split cqxx twice in
c            # each transverse direction, once with imp=1 and once with imp=2:

c            # imp = 1 or 2 is used to indicate whether we are propagating
c            # amdq or apdq, i.e. cqxxm or cqxxp


c            # in the y-like direction with imp=1
             call rpt3(ixyz,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &                 q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

c            # in the y-like direction with imp=2
              call rpt3(ixyz,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &                  q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxp,bpcqxxp)

c            # in the z-like direction with imp=1
              call rpt3(ixyz,3,1,axm,meqn,mwaves,maux,mbc,mx,
     &                  q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxm,cpcqxxm)

c            # in the z-like direction with imp=2
              call rpt3(ixyz,3,2,axm,meqn,mwaves,maux,mbc,mx,
     &                  q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxp,cpcqxxp)
           else
c            # aux arrays aren't being used, so we only need to split
c            # cqxx once in each transverse direction and the same result can
c            # presumably be used to left and right.
c            # Set imp = 0 since this shouldn't be needed in rpt3 in this case.

c            # in the y-like direction
              call rpt3(ixyz,2,0,maxm,meqn,mwaves,maux,mbc,mx,
     &              q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

c            # in the z-like direction
              call rpt3(ixyz,3,0,maxm,meqn,mwaves,maux,mbc,mx,
     &              q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxm,cpcqxxm)

c             # use the same splitting to left and right:
              do m = 1,meqn
                 do i = 0,mx+2
                    bmcqxxp(i,m) = bmcqxxm(i,m)
                    bpcqxxp(i,m) = bpcqxxm(i,m)
                    cmcqxxp(i,m) = cmcqxxm(i,m)
                    cpcqxxp(i,m) = cpcqxxm(i,m)
                 enddo
              enddo
           endif
        endif

c      --------------------------------------------
c      # modify G fluxes in the y-like direction
c      --------------------------------------------
c
c     # If the correction wave also propagates in a 3D sense, incorporate
c     # cpcqxx,... into cmamdq, cpamdq, ... so that it is split also.
c
      if(m4 .eq. 1)then
         do 145 m = 1, meqn
            do 145 i = 0, mx+2
               cpapdq2(i,m) = cpapdq(i,m)
               cpamdq2(i,m) = cpamdq(i,m)
               cmapdq2(i,m) = cmapdq(i,m)
               cmamdq2(i,m) = cmamdq(i,m)
 145         continue
      else if(m4 .eq. 2)then
         do 146 m = 1, meqn
            do 146 i = 0, mx+2
               cpapdq2(i,m) = cpapdq(i,m) - 3.d0*cpcqxxp(i,m)
               cpamdq2(i,m) = cpamdq(i,m) + 3.d0*cpcqxxm(i,m)
               cmapdq2(i,m) = cmapdq(i,m) - 3.d0*cmcqxxp(i,m)
               cmamdq2(i,m) = cmamdq(i,m) + 3.d0*cmcqxxm(i,m)
 146        continue
      endif
c
c     # The transverse flux differences in the z-direction are split
c     # into waves propagating in the y-direction. If m4 = 2,
c     # then the transverse propagating correction waves in the z-direction
c     # are also split. This yields terms of the form BCAu_{xzy} and
c     # BCAAu_{xxzy}.
c
      if( m4.gt.0 )then
          call rptt3(ixyz,2,2,2,maxm,meqn,mwaves,mwaves,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cpapdq2,bmcpapdq,bpcpapdq)
          call rptt3(ixyz,2,1,2,maxm,meqn,mwaves,mwaves,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cpamdq2,bmcpamdq,bpcpamdq)
          call rptt3(ixyz,2,2,1,maxm,meqn,mwaves,mwaves,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cmapdq2,bmcmapdq,bpcmapdq)
          call rptt3(ixyz,2,1,1,maxm,meqn,mwaves,mwaves,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cmamdq2,bmcmamdq,bpcmamdq)
      endif
c
c     -----------------------------
c     # The updates for G fluxes :
c     -----------------------------
c
      do 180 m=1,meqn
         do 180 i = 1, mx+1
c
c           # Transverse propagation of the increment waves
c           # between cells sharing interfaces, i.e. the 2D approach.
c           # Yields BAu_{xy}.
c
            gadd(i-1,m,1,0) = gadd(i-1,m,1,0)
     &		            - 0.5d0*dtdx1d(i-1)*bmamdq(i,m)
            gadd(i-1,m,2,0) = gadd(i-1,m,2,0)
     &		            - 0.5d0*dtdx1d(i-1)*bpamdq(i,m)
            gadd(i,m,1,0)   = gadd(i,m,1,0)
     &		            - 0.5d0*dtdx1d(i-1)*bmapdq(i,m)
            gadd(i,m,2,0)   = gadd(i,m,2,0)
     &		            - 0.5d0*dtdx1d(i-1)*bpapdq(i,m)
c
c           # Transverse propagation of the increment wave (and the
c           # correction wave if m4=2) between cells
c           # only having a corner or edge in common. Yields terms of the
c           # BCAu_{xzy} and BCAAu_{xxzy}.
c
            if( m4.gt.0 )then
c
                gadd(i,m,2,0) = gadd(i,m,2,0)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * (bpcpapdq(i,m) - bpcmapdq(i,m))
                gadd(i,m,1,0) = gadd(i,m,1,0)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * (bmcpapdq(i,m) - bmcmapdq(i,m))
                gadd(i,m,2,1) = gadd(i,m,2,1)
     &                          - (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bpcpapdq(i,m)
                gadd(i,m,1,1) = gadd(i,m,1,1)
     &                          - (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bmcpapdq(i,m)
                gadd(i,m,2,-1) = gadd(i,m,2,-1)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bpcmapdq(i,m)
                gadd(i,m,1,-1) = gadd(i,m,1,-1)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bmcmapdq(i,m)
c
                gadd(i-1,m,2,0) = gadd(i-1,m,2,0)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * (bpcpamdq(i,m) - bpcmamdq(i,m))
                gadd(i-1,m,1,0) = gadd(i-1,m,1,0)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * (bmcpamdq(i,m) - bmcmamdq(i,m))
                gadd(i-1,m,2,1) = gadd(i-1,m,2,1)
     &                          - (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bpcpamdq(i,m)
                gadd(i-1,m,1,1) = gadd(i-1,m,1,1)
     &                          - (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bmcpamdq(i,m)
                gadd(i-1,m,2,-1) = gadd(i-1,m,2,-1)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bpcmamdq(i,m)
                gadd(i-1,m,1,-1) = gadd(i-1,m,1,-1)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * bmcmamdq(i,m)
c
            endif
c
c           # Transverse propagation of the correction wave between
c           # cells sharing faces. This gives BAAu_{xxy}.
c
            if(m3.lt.2) go to 180
               gadd(i,m,2,0)   = gadd(i,m,2,0)
     &                         + dtdx1d(i-1)*bpcqxxp(i,m)
               gadd(i,m,1,0)   = gadd(i,m,1,0)
     &                         + dtdx1d(i-1)*bmcqxxp(i,m)
               gadd(i-1,m,2,0) = gadd(i-1,m,2,0)
     &                         - dtdx1d(i-1)*bpcqxxm(i,m)
               gadd(i-1,m,1,0) = gadd(i-1,m,1,0)
     &                         - dtdx1d(i-1)*bmcqxxm(i,m)
c
  180       continue
c
c
c      --------------------------------------------
c      # modify H fluxes in the z-like direction
c      --------------------------------------------
c
c     # If the correction wave also propagates in a 3D sense, incorporate
c     # cqxx into bmamdq, bpamdq, ... so that is is split also.
c
      if(m4 .eq. 2)then
         do 155 m = 1, meqn
            do 155 i = 0, mx+2
               bpapdq(i,m) = bpapdq(i,m) - 3.d0*bpcqxxp(i,m)
               bpamdq(i,m) = bpamdq(i,m) + 3.d0*bpcqxxm(i,m)
               bmapdq(i,m) = bmapdq(i,m) - 3.d0*bmcqxxp(i,m)
               bmamdq(i,m) = bmamdq(i,m) + 3.d0*bmcqxxm(i,m)
155         continue
      endif
c
c     # The transverse flux differences in the y-direction are split
c     # into waves propagating in the z-direction. If m4 = 2,
c     # then the transverse propagating correction waves in the y-direction
c     # are also split. This yields terms of the form BCAu_{xzy} and
c     # BCAAu_{xxzy}.
c
c     # Note that the output to rptt3 below should logically be named
c     # cmbsasdq and cpbsasdq rather than bmcsasdq and bpcsasdq, but
c     # we are re-using the previous storage rather than requiring new arrays.
c
      if( m4.gt.0 )then
          call rptt3(ixyz,3,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,bpapdq,bmcpapdq,bpcpapdq)
          call rptt3(ixyz,3,1,2,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,bpamdq,bmcpamdq,bpcpamdq)
          call rptt3(ixyz,3,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,bmapdq,bmcmapdq,bpcmapdq)
          call rptt3(ixyz,3,1,1,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,bmamdq,bmcmamdq,bpcmamdq)
      endif
c
c     -----------------------------
c     # The updates for H fluxes :
c     -----------------------------
c
      do 200 m=1,meqn
         do 200 i = 1, mx+1
c
c           # Transverse propagation of the increment waves
c           # between cells sharing interfaces, i.e. the 2D approach.
c           # Yields CAu_{xy}.
c
            hadd(i-1,m,1,0) = hadd(i-1,m,1,0)
     &		            - 0.5d0*dtdx1d(i-1)*cmamdq(i,m)
            hadd(i-1,m,2,0) = hadd(i-1,m,2,0)
     &		            - 0.5d0*dtdx1d(i-1)*cpamdq(i,m)
            hadd(i,m,1,0)   = hadd(i,m,1,0)
     &		            - 0.5d0*dtdx1d(i-1)*cmapdq(i,m)
            hadd(i,m,2,0)   = hadd(i,m,2,0)
     &		            - 0.5d0*dtdx1d(i-1)*cpapdq(i,m)
c
c           # Transverse propagation of the increment wave (and the
c           # correction wave if m4=2) between cells
c           # only having a corner or edge in common. Yields terms of the
c           # CBAu_{xzy} and CBAAu_{xxzy}.
c
            if( m4.gt.0 )then
c
                hadd(i,m,2,0)  = hadd(i,m,2,0)
     &                         + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                         * (bpcpapdq(i,m) - bpcmapdq(i,m))
                hadd(i,m,1,0)  = hadd(i,m,1,0)
     &                         + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                         * (bmcpapdq(i,m) - bmcmapdq(i,m))
                hadd(i,m,2,1)  = hadd(i,m,2,1)
     &                         - (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                         * bpcpapdq(i,m)
                hadd(i,m,1,1)  = hadd(i,m,1,1)
     &                         - (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                         * bmcpapdq(i,m)
                hadd(i,m,2,-1) = hadd(i,m,2,-1)
     &                         + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                         * bpcmapdq(i,m)
                hadd(i,m,1,-1) = hadd(i,m,1,-1)
     &                         + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                         * bmcmapdq(i,m)
c
                hadd(i-1,m,2,0)  = hadd(i-1,m,2,0)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                           * (bpcpamdq(i,m) - bpcmamdq(i,m))
                hadd(i-1,m,1,0)  = hadd(i-1,m,1,0)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                           * (bmcpamdq(i,m) - bmcmamdq(i,m))
                hadd(i-1,m,2,1)  = hadd(i-1,m,2,1)
     &                           - (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                           * bpcpamdq(i,m)
                hadd(i-1,m,1,1)  = hadd(i-1,m,1,1)
     &                           - (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                           * bmcpamdq(i,m)
                hadd(i-1,m,2,-1) = hadd(i-1,m,2,-1)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                           * bpcmamdq(i,m)
                hadd(i-1,m,1,-1) = hadd(i-1,m,1,-1)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                           * bmcmamdq(i,m)
c
            endif
c
c           # Transverse propagation of the correction wave between
c           # cells sharing faces. This gives CAAu_{xxy}.
c
            if(m3.lt.2) go to 200
               hadd(i,m,2,0)   = hadd(i,m,2,0)
     &                         + dtdx1d(i-1)*cpcqxxp(i,m)
               hadd(i,m,1,0)   = hadd(i,m,1,0)
     &                         + dtdx1d(i-1)*cmcqxxp(i,m)
               hadd(i-1,m,2,0) = hadd(i-1,m,2,0)
     &                         - dtdx1d(i-1)*cpcqxxm(i,m)
               hadd(i-1,m,1,0) = hadd(i-1,m,1,0)
     &                         - dtdx1d(i-1)*cmcqxxm(i,m)
c
  200    continue
c
      return
      end

!
! ----------------------------------------------------------
!
      subroutine setBoussFlag(levelBouss,maux)

      use amr_module
      use bouss_module
      implicit none

      integer, intent(in) :: levelBouss

      integer k,m,nb,i,j,nng,levSt, mptr,nx,ny,mitot 

      type(matrix_patchIndex), pointer :: mi
      type(matrix_patchIndex), pointer :: mi_nbor
      type(matrix_levInfo),  pointer :: minfo
      integer :: locaux, iaddaux,maux
      integer :: trueCount
      real(kind=8) :: b_min,b_max,time
      logical :: debug
      integer :: ioff, joff
      real(kind=8) :: x,y,xlow,ylow,dx,dy

      iaddaux(m,i,j) = locaux +  maux*(i+nghost-1)   &
                     + maux*mitot*(j+nghost-1)

!
!     mark each cell in a bouss grid as to whether its deep enough
!     to use boussinesq and not SWE.

      minfo => matrix_info_allLevs(levelBouss)
      !debug = .true.
      debug = .false.

      k = 0  ! keep running total of number of unknowns in matrix system 
      levSt = listStart(levelBouss)
      do nng = 1, numgrids(levelBouss)
         mptr = listOfGrids(levSt+nng-1)
         time = rnode(timemult,mptr)
         nb = node(bpatchNum,mptr)
         mi => minfo%matrix_indices(nb)
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         if (.not. allocated(mi%isBouss)) then
            allocate(mi%isBouss(0:nx+1,0:ny+1))
         endif
         mitot = nx + 2*nghost
         locaux = node(storeaux,mptr)
         trueCount = 0

         ! indexing to add ghost cells is in iaddaux
         do j = 0, ny+1
         do i = 0, nx+1
             b_max = max(alloc(iaddaux(1,i,j)),                                 &
                         alloc(iaddaux(1,i-1,j)),alloc(iaddaux(1,i+1,j)),       &
                         alloc(iaddaux(1,i,j-1)),alloc(iaddaux(1,i,j+1)),       &
                         alloc(iaddaux(1,i-1,j-1)),alloc(iaddaux(1,i-1,j+1)),   &
                         alloc(iaddaux(1,i+1,j-1)),alloc(iaddaux(1,i+1,j+1)))
             if (-boussMinDepth < b_max) then
               mi%isBouss(i,j) = .false.
             else
               mi%isBouss(i,j) = .true.
               trueCount = trueCount + 1
            endif
         end do
         end do

         if (debug) then
            write(55,*)
            write(55,108) mptr, levelBouss, trueCount, (nx+2)*(ny+2)
 108        format("grid ",i5," level ",i5," has ",i5," of ",i5," bouss cells")
            xlow = rnode(cornxlo,mptr)
            ylow = rnode(cornylo,mptr)
            dx = hxposs(levelBouss)
            dy = hyposs(levelBouss)
            do j = ny+1,0,-1
               y = ylow + (dfloat(j)-.5)*dy
               joff = j + node(ndjlo,mptr)-1
            do i = 0, nx+1 
               x = xlow + (dfloat(i)-.5)*dx
               ioff = i + node(ndilo,mptr)-1
               write(55,104)ioff,joff,x,y,mi%isBouss(i,j)
 101           format(300l1)
 104           format(2i6,2e12.4,l4)
            end do
            end do
            flush(55)
            if (1 .eq. 1) then
            write(56,*)
            write(56,*)"grid ",mptr
            !do j = ny+2,-1,-1
            do j = -1, ny+2
            do i = -1, nx+2
               !write(56,102)(alloc(iaddaux(1,i,j)),i=-1,nx+2)
               write(56,103)i+nghost,j+nghost,alloc(iaddaux(1,i,j))
 102           format(300e11.4)
 103           format(2i5,e12.4)
            end do
            end do
            endif
         endif
      end do  ! end loop over bouss grids

      return
      end subroutine setBoussFlag

      subroutine opendatafile(iunit, fname)
c     #
!> Open the file fname and determine how many leading lines are
!! comments.  Then rewind and skip over the comment lines so that the
!! file is ready for reading data from.
!!
!! All comment lines must start with # in the first column.

      integer iunit, line, commentlines


c     This allows for a variable name length and obsolves (I think) the
c     length problem that appeared for some compilers (notably ifort)
      character(len=*) :: fname
c     character*25 fname
c     character*12 fname12

      character*1 firstchar
      logical foundFile
      
c     # Debug statement to test fname:
c     write(6,*) '+++ fname = XXX',fname,'XXX'

      inquire(file=fname,exist=foundFile)
      if (.not. foundFile) then
c         # for backward compatability: maybe fname is declared character*12
c         # in calling routine...
c         fname12 = fname(1:12)
c         #write(6,*) 'truncated fname12 = XXX',fname12,'XXX'
c         inquire(file=fname12,exist=foundFile)
          if (.not. foundFile) then
            print "(2a)",'*** in opendatafile, file not found:', fname 
            stop
          endif
c         open(unit=iunit,file=fname12,status='old',form='formatted')
c         write(6,*) 'Reading data file: ', fname12
      else
          open(unit=iunit,file=fname,status='old',form='formatted')
          print "(2a)",'Reading data file: ', fname
      endif

c     # this version may not work in f77
c     firstchar = '#'
c     commentlines = -1
c     do while (firstchar == '#')
c        read(iunit,*) firstchar
c        commentlines = commentlines + 1
c        enddo

      firstchar = '#'
      commentlines = -1
      do commentlines=-1,1000
          if (firstchar .eq. '#') then
              read(iunit,"(a1)") firstchar
          else
              exit
          endif
      enddo
      
      write(6,602) commentlines
  602 format('         first',i2,
     &       ' lines are comments and will be skipped')
     
c     Rewind file and go back to data line
C       print *,firstchar
C       rewind(iunit)
C       do line=1,commentlines
C          read(iunit,*) firstchar
C          print *,firstchar
C          enddo
C       
      return
      end

!> Find best place to split the 2D array of flagged points.
!! Either split at a hole, or use signatures to find
!! zero crossing of laplacian.
c
c -----------------------------------------------------------
c
      subroutine findcut(icl,iscr,jscr,idim,jdim,index,iside,
     1                   ilo,ihi,jlo,jhi)
c
c ::::::::::::::::::::: FINDCUT ::::::::::::::::::::::::::::;
c   find best place to split the 2D array of flagged points
c   either split at a hole, or use signatures to find
c   zero crossing of laplacian.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      use amr_module
      implicit double precision (a-h,o-z)


      ! TODO: not necessarily use array of size idim?
      ! For higher level AMR grids, most elements in isrc will be zero?
      dimension iscr(idim), jscr(jdim)

c Modified 6/02:
c Include call.i to get def's of horizontal/vertical.
c      integer   horizontal, vertical
c      parameter(horizontal = 1)
c      parameter(vertical = 2)

      parameter(ithres = 2)
      parameter(minoff = 2)
c
c  look for holes first in horizontal then vertical direction
c
       do 10 i = ilo, ihi
          if (iscr(i) .eq. 0) then
             index = i
             iside = horizontal
             return
          endif
 10    continue

       do 20 j = jlo, jhi
          if (jscr(j) .eq. 0) then
              index = j
              iside = vertical
              return
          endif
 20    continue

c
c  no holes - find 2nd derivative of signatures for best cut.
c  overwrite signature arrays. don't make cuts less than minoff
c  from boundary
c
      ipre = iscr(ilo)
      do 50 i = ilo+1, ihi-1
         icur = iscr(i)
         iscr(i) = iscr(i+1)-2*icur+ipre
         ipre = icur
 50   continue

      locmaxi = 0
      indexi  = 0
      imid    = (ilo + ihi) / 2
      do 60 i = ilo+minoff, ihi-minoff+1
           itemp1 = iscr(i-1)
           itemp2 = iscr(i)
           locdif = iabs(itemp1-itemp2)
           if (itemp1*itemp2.lt.0) then
                if (locdif .gt. locmaxi) then
                 locmaxi = locdif
                 indexi = i
                else if (locdif .eq. locmaxi) then
                    if (iabs(i-imid).lt.iabs(indexi-imid)) indexi = i
                endif
           endif
 60   continue


       jpre   = jscr(jlo)
       do 130 j = jlo+1, jhi-1
           jcur = jscr(j)
           jscr(j) = jscr(j+1)-2*jcur+jpre
           jpre = jcur
 130   continue

       locmaxj = 0
       indexj  = 0
       jmid    = (jlo + jhi) / 2
       do 160 j = jlo+minoff, jhi-minoff+1
           jtemp1 = jscr(j-1)
           jtemp2 = jscr(j)
           locdif = iabs(jtemp1-jtemp2)
           if (jtemp1*jtemp2.lt.0) then
               if (locdif .gt. locmaxj) then
                  locmaxj = locdif
                  indexj = j
                else if (locdif .eq. locmaxj) then
                       if (iabs(j-jmid).lt.iabs(indexj-jmid)) indexj = j
               endif
           endif
 160   continue
c
c      ::::: choose max dif for splitting
c
 220   if (locmaxi .gt. locmaxj) then
            index  = indexi
            iside  = horizontal
            locmax = locmaxi
       else if (locmaxi .lt. locmaxj) then
            index  = indexj
            iside  = vertical
            locmax = locmaxj
        else if (iabs(indexi-imid).lt.iabs(indexj-jmid)) then
                 index  = indexi
                 iside  = horizontal
                 locmax = locmaxi
             else
               index  = indexj
               iside  = vertical
               locmax = locmaxj
       endif

c      ::::: if inflection pt. not over the threshold, signal
c      ::::: with index 0 (out of range)
       if (locmax .lt. ithres) index = 0

       return
       end

c======================================================================
       subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,
     &                 ql,qr,auxl,auxr,fwave,s,amdq,apdq)
c======================================================================
c
c Solves normal Riemann problems for the 2D SHALLOW WATER equations
c     with topography:
c     #        h_t + (hu)_x + (hv)_y = 0                           #
c     #        (hu)_t + (hu^2 + 0.5gh^2)_x + (huv)_y = -ghb_x      #
c     #        (hv)_t + (huv)_x + (hv^2 + 0.5gh^2)_y = -ghb_y      #

c On input, ql contains the state vector at the left edge of each cell
c     qr contains the state vector at the right edge of each cell
c
c This data is along a slice in the x-direction if ixy=1
c     or the y-direction if ixy=2.

c  Note that the i'th Riemann problem has left state qr(i-1,:)
c     and right state ql(i,:)
c  From the basic clawpack routines, this routine is called with
c     ql = qr
c
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                           !
!      # This Riemann solver is for the shallow water adjoint               !
!             equations. It is modified from rpn2_geoclaw.f.                !
!                                                                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      use geoclaw_module, only: g => grav, drytol => dry_tolerance
      use geoclaw_module, only: earth_radius, deg2rad
      use amr_module, only: mcapa

      implicit none

      !input
      integer maxm,meqn,maux,mwaves,mbc,mx,ixy

      double precision  fwave(meqn, mwaves, 1-mbc:maxm+mbc)
      double precision  s(mwaves, 1-mbc:maxm+mbc)
      double precision  ql(meqn, 1-mbc:maxm+mbc)
      double precision  qr(meqn, 1-mbc:maxm+mbc)
      double precision  apdq(meqn,1-mbc:maxm+mbc)
      double precision  amdq(meqn,1-mbc:maxm+mbc)
      double precision  auxl(maux,1-mbc:maxm+mbc)
      double precision  auxr(maux,1-mbc:maxm+mbc)

      !local only
      integer m,i,mw,maxiter,mu,nv
      double precision wall(3)
      double precision fw(3,3)
      double precision sw(3)
      double precision delta(3)

      double precision hR,hL,huR,huL,uR,uL,hvR,hvL,vR,vL,phiR,phiL
      double precision bR,bL,cL,cR,sRoe1,sRoe2,sE1,sE2,uhat,chat
      double precision s1m,s2m
      double precision hstar,hstartest,hstarHLL,sLtest,sRtest
      double precision tw,dxdc
      double precision beta1, beta2, beta3, hRhat, hLhat

      logical rare1,rare2

      !loop through Riemann problems at each grid cell
      do i=2-mbc,mx+mbc

!-----------------------Initializing-----------------------------------
         !inform of a bad riemann problem from the start
         if((qr(1,i-1).lt.0.d0).or.(ql(1,i) .lt. 0.d0)) then
            write(*,*) 'Negative input: hl,hr,i=',qr(1,i-1),ql(1,i),i
         endif

        !Initialize Riemann problem for grid interface
        do mw=1,mwaves
            s(mw,i)=0.d0
            fwave(1,mw,i)=0.d0
            fwave(2,mw,i)=0.d0
            fwave(3,mw,i)=0.d0

            fw(1,mw)=0.d0
            fw(2,mw)=0.d0
            fw(3,mw)=0.d0
        enddo

         !set normal direction
         if (ixy.eq.1) then
            mu=2
            nv=3
         else
            mu=3
            nv=2
         endif

         !zero (small) negative values if they exist
         if (qr(1,i-1).lt.0.d0) then
           qr(1,i-1)=0.d0
           qr(2,i-1)=0.d0
           qr(3,i-1)=0.d0
         endif

        if (ql(1,i).lt.0.d0) then
          ql(1,i)=0.d0
          ql(2,i)=0.d0
          ql(3,i)=0.d0
        endif

         !skip problem if in a completely dry area
         if (qr(1,i-1) <= drytol .and. ql(1,i) <= drytol) then
             go to 30
         endif

        !Riemann problem variables
        hL = qr(1,i-1)
        hR = ql(1,i)
        bL = auxr(1,i-1)
        bR = auxl(1,i)

        huL = qr(mu,i-1)
        huR = ql(mu,i)
        hvL=qr(nv,i-1)
        hvR=ql(nv,i)

        ! Linearizing
        hLhat = -bL
        hRhat = -bR

c       ! Check for wet/dry boundary
        if (hR <= drytol) then
            hR = 0.d0
            huR = 0.d0
            hvR = 0.d0
            uR = 0.d0
            vR = 0.d0
            hRhat = 0.d0
        else
            uR = huR/hR
            vR = hvR/hR
        endif
        if (hL <= drytol) then
            hL = 0.d0
            huL = 0.d0
            hvL = 0.d0
            uL = 0.d0
            vL = 0.d0
            hLhat = 0.d0
        else
            uL = huL/hL
            vL = hvL/hL
        endif

        wall(1) = 1.d0
        wall(2) = 1.d0
        wall(3) = 1.d0

        if (hR.le.drytol) then
            call riemanntype(hL,hL,uL,-uL,hstar,s1m,s2m,
     &                                  rare1,rare2,1,drytol,g)
            hstartest=max(hL,hstar)
            if (hstartest+bL.lt.bR) then !right state should become ghost values
c                that mirror left for wall problem
                wall(2)=0.d0
                wall(3)=0.d0
                hR=hL
                huR=-huL
                bR=bL
                uR=-uL
                vR=vL
                hRhat = hLhat  ! added since this is a linear problem
             elseif (hL+bL.lt.bR) then
                bR=hL+bL
            endif
        elseif (hL.le.drytol) then ! right surface is lower than left topo
            call riemanntype(hR,hR,-uR,uR,hstar,s1m,s2m,
     &                                  rare1,rare2,1,drytol,g)
            hstartest=max(hR,hstar)
            if (hstartest+bR.lt.bL) then  !left state should become ghost values
c               that mirror right
                wall(1)=0.d0
                wall(2)=0.d0
                hL=hR
                huL=-huR
                bL=bR
                uL=-uR
                vL=vR
                hLhat = hRhat  ! added since this is a linear problem
            elseif (hR+bR.lt.bL) then
                bL=hR+bR
            endif
        endif

         !determine wave speeds
         cL=sqrt(g*hLhat) ! 1 wave speed of left state
         cR=sqrt(g*hRhat) ! 2 wave speed of right state

         !--------------------end initializing----------
         !solve Riemann problem.

c       # f-wave splitting
        delta(1) = -huR*cR**2 + huL*cL**2
        delta(2) = -(hR+bR) + (hL+bL)
        delta(3) = 0

        beta1 = (delta(1) + cR*delta(2))/(cL + cR)
        beta2 = (-delta(1) + cL*delta(2))/(cL + cR)
        beta3 = delta(3)

        if (cL + cR == 0.d0) then
            beta1 = (delta(1) + cR*delta(2))
            beta2 = (-delta(1) + cL*delta(2))
        endif

c       # Compute the waves.
        fw(1,1) = cL*beta1
        fw(mu,1) = beta1
        fw(nv,1) = 0.d0
        sw(1) = -cL

        fw(1,2) = -cR*beta2
        fw(mu,2) = beta2
        fw(nv,2) = 0.d0
        sw(2) = cR

c        !eliminate ghost fluxes for wall
         do mw=1,3
            sw(mw)=sw(mw)*wall(mw)

            fw(1,mw)=fw(1,mw)*wall(mw)
            fw(2,mw)=fw(2,mw)*wall(mw)
            fw(3,mw)=fw(3,mw)*wall(mw)
         enddo

         do mw=1,mwaves
            s(mw,i)=sw(mw)
            fwave(1,mw,i)=fw(1,mw)
            fwave(mu,mw,i)=fw(mu,mw)
            fwave(nv,mw,i)=fw(nv,mw)
         enddo

 30      continue
      enddo

c==========Capacity for mapping from latitude longitude to physical space====
        if (mcapa.gt.0) then
          do i=2-mbc,mx+mbc
            if (ixy.eq.1) then
              dxdc=(earth_radius*deg2rad)
            else
              dxdc=earth_radius*cos(auxl(3,i))*deg2rad
            endif

            do mw=1,mwaves
              s(mw,i)=dxdc*s(mw,i)
              fwave(1,mw,i)=dxdc*fwave(1,mw,i)
              fwave(2,mw,i)=dxdc*fwave(2,mw,i)
              fwave(3,mw,i)=dxdc*fwave(3,mw,i)
            enddo
          enddo
        endif

c============= compute fluctuations=============================================
         amdq(1:3,:) = 0.d0
         apdq(1:3,:) = 0.d0
         do i=2-mbc,mx+mbc
             do  mw=1,mwaves
               if (s(mw,i) < 0.d0) then
                 amdq(1:3,i) = amdq(1:3,i) + fwave(1:3,mw,i)
               else if (s(mw,i) > 0.d0) then
                 apdq(1:3,i)  = apdq(1:3,i) + fwave(1:3,mw,i)
               else
                 amdq(1:3,i) = amdq(1:3,i) + 0.5d0 * fwave(1:3,mw,i)
                 apdq(1:3,i) = apdq(1:3,i) + 0.5d0 * fwave(1:3,mw,i)
               endif
             enddo
         enddo

         do i=2-mbc, mx+mbc
             amdq(1:meqn,i) = fwave(1:meqn,1,i)
             apdq(1:meqn,i) = fwave(1:meqn,2,i)
         enddo

      return
      end subroutine

c
c  -----------------------------------------------------------
c
      subroutine reclam (index, nwords)
c
c ::::::::::::::::::::::::: RECLAM :::::::::::::::::::::::::::
c
!>  return of space. add to free list.
!!
!!  iplace points to next item on free list with larger index than
!!  the item reclaiming, unless said item is greater then
!!  everything on the list.
c
c ::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::::
c
      use amr_module
      implicit double precision (a-h,o-z)


!$OMP CRITICAL (MemMgmt)

c
      do 20 i = 1, lenf
      iplace  = i
      if (lfree(i,1) .gt. index) go to 30
 20   continue
         write(outunit,902)
         write(*,902)
 902     format(' no insertion pointer into freelist. error stop')
         stop
c
c  check previous segment for merging
c
 30      iprev = iplace - 1
         if (lfree(iprev,1)+lfree(iprev,2) .lt. index) go to 40
         lfree(iprev,2) = lfree(iprev,2) + nwords
         go to 50
c
c  check after segment - no previous merge case
c
 40   nexti = index + nwords
      if (lfree(iplace,1).ne. nexti) go to 70
         lfree(iplace,1) = index
         lfree(iplace,2) = lfree(iplace,2) + nwords
         go to 99
c
c  check following segment - yes previous merge case
c
 50   nexti = index + nwords
      if (lfree(iplace,1) .ne. nexti) go to 99
c
c forward merge as well, bump all down 1
c
      lfree(iprev,2) = lfree(iprev,2)+lfree(iplace,2)
      ipp1           = iplace + 1
      do 60 i = ipp1, lenf
         lfree(i-1,1) = lfree(i,1)
         lfree(i-1,2) = lfree(i,2)
 60   continue
      lenf = lenf - 1
      go to 99
c
c  no merges case - insert and bump future segments up to make room
c
 70   if (lenf .eq. lfdim) go to 900
      do 80 ii = iplace, lenf
      i          = lenf + 1 - ii + iplace
      lfree(i,1) = lfree(i-1,1)
      lfree(i,2) = lfree(i-1,2)
 80   continue
      lenf            = lenf + 1
      lfree(iplace,1) = index
      lfree(iplace,2) = nwords
      go to 99
c
 900  write(outunit,901) lfdim
      write(*,901)       lfdim
 901  format('  free list full with ',i5,' items')
      stop
c
 99   lentot = lentot - nwords
      if (sprint) write(outunit,100) nwords, index, lentot
 100  format('     reclaiming ',i8,' words at loc. ',i8,' lentot ',i10)

!$OMP END CRITICAL (MemMgmt)

      return
      end

c
c ---------------------------------------------------------
c
      subroutine outmsh(mptr,outgrd,nvar,naux)
      use amr_module
      implicit double precision (a-h,o-z)
      logical  outgrd


c
c ::::::::::::::::::::: OUTMSH :::::::::::::::::::::::::::::::::::::
c
c outmsh - output the grid descriptor and optionally the values on
c          the grid (for a single grid - see "outtre" for outputing
c          a subtree)
c input parameters:
c    mptr   - ptr to grid descriptor
c    outgrd - if true, output value on grid
c special case
c     if grid has level < 1, nothing is printed. (forest pointer
c has level = 0).  this simplifies logic of outtre; also, any grid
c with level <= 0 is not properly set (the forest pointer
c is used only to provide pointers into the tree of coarsest grids)
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
100   format(1x,47h+----------------------------------------------,
     *30h-----------------------------+)
c
      lev = node(nestlevel,mptr)
c
      write(outunit,100)
      write(outunit,101) mptr
101   format(1x,10h! grid no:,i6,60x,1h!)
      write(outunit,102) node(nestlevel,mptr),rnode(timemult,mptr),
     .             node(levelptr,mptr)
102   format(1x,1h!,11h nestlevel=,i3,12h, time mult=,e25.15,
     1       13h, level ptr =,i6,5x,1h!)
      write(outunit,103) node(store1,mptr),node(store2,mptr),
     1                   node(cfluxptr,mptr),node(ffluxptr,mptr)
 103  format(1x,'! storage locs =',2i11,'  bndry locs =',2i11,2x,1h!)
      write(outunit,104)
      write(outunit,111) rnode(cornxlo,mptr),rnode(cornxhi,mptr)
      write(outunit,112)
      write(outunit,113) node(ndilo,mptr),node(ndihi,mptr)
112   format(1x,23h! integer index space :,53x,1h!)
113   format(1x,2h! ,18x,1h(,i8,2h, ,i8,1h),16x,1h!)
104   format(1x,16h! edges of line:,53x,1h!)
111   format(1x,2h! ,10x,1h(,f12.7,2h, ,f12.7,1h),8x,1h!)

c     This is a replacement for line 45-46 format that used to be format 111
c111   format(1x,2h! ,18x,2(1h(,d10.3,2h, ,d10.3,1h)),8x,1h!)

      write(outunit,105) hxposs(lev),possk(lev)
 105  format(1x,7h! hrow=,f19.11,7h, hcol=,f19.11,8h, ktime=,f16.9,1h!) 
c105   format(1x,7h! hrow=,D16.8,7h, hcol=,D16.8,30x,1h!)
c114   format(1x,8h! ktime=,D16.8,52x,1h!)

      write(outunit,100)
c
      if (.not. outgrd) go to 99
c output the grid
      mitot   = node(ndihi,mptr) - node(ndilo,mptr) + 1 + 2*nghost
      loc     = node(store1,mptr)
      locaux  = node(storeaux,mptr)
      call outval(alloc(loc),nvar,mitot,mptr,outgrd,
     1            naux,alloc(locaux))
 99   return
      end

c
        subroutine fixcapaq(val ,aux ,mitot,mjtot,mktot,
     &                      valc,auxc,mic  ,mjc  ,mkc  ,
     &                      nvar,naux,levc)

      use amr_module
      implicit double precision (a-h,o-z)

c
c :::::::::::::::::::::::  FIXCAPAQ ::::::::::::::::::::::::::::::
c  new fine grid solution q was linearly interpolated. but want
c  to conserve kappa*q, not q. calculate the discrepancy
c  in kappa*q using this q, and modify q to account for it.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      dimension   val(nvar,mitot,mjtot,mktot), valc(nvar,mic,mjc,mkc)
      dimension   aux(naux,mitot,mjtot,mktot), auxc(naux,mic,mjc,mkc)

      dcapamax = 0.d0
      lratiox  = intratx(levc)
      lratioy  = intraty(levc)
      lratioz  = intratz(levc)

      do 10 kc = 2, mkc-1
      do 10 jc = 2, mjc-1
      do 10 ic = 2, mic-1


       do 15 ivar = 1, nvar

       capaqfine = 0.d0

       do 20 kco = 1, lratioz
         kfine = (kc-2)*lratioz + nghost + kco
         do 20 jco = 1, lratioy
           jfine = (jc-2)*lratioy + nghost + jco
           do 20 ico = 1, lratiox
             ifine = (ic-2)*lratiox + nghost + ico
             capaqfine = capaqfine + aux(mcapa,ifine,jfine,kfine)
     &                             * val(ivar,ifine,jfine,kfine)
20     continue

       dcapaq = auxc(mcapa,ic,jc,kc)*valc(ivar,ic,jc,kc)-
     &          capaqfine/(lratiox*lratioy*lratioz)
       dcapamax = dmax1(dcapamax,dabs(dcapaq))
      
       do 30 kco = 1, lratioz
         kfine = (kc-2)*lratioz + nghost + kco
         do 30 jco = 1, lratioy
           jfine = (jc-2)*lratioy + nghost + jco
           do 30 ico = 1, lratiox
             ifine = (ic-2)*lratiox + nghost + ico
             val(ivar,ifine,jfine,kfine)  = val(ivar,ifine,jfine,kfine)
     &                             + dcapaq/aux(mcapa,ifine,jfine,kfine)
30     continue

15     continue

10     continue

c      write(6,*)" max discrepancy ", dcapamax

       return
       end

c
c -----------------------------------------------------------
c
      subroutine conck(level, nvar, naux, time, rest)
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical  rest


!--      iadd(i,j,k,ivar)   = loc    +    (i-1)
!--     &                            +    (j-1)*mitot
!--     &                            +    (k-1)*mitot*mjtot
!--     &                            + (ivar-1)*mitot*mjtot*mktot
!--      iaddaux(i,j,k)     = locaux +    (i-1)
!--     &                            +    (j-1)*mitot
!--     &                            +    (k-1)*mitot*mjtot
!--     &                            +(mcapa-1)*mitot*mjtot*mktot
       iadd(ivar,i,j,k) = loc  + (ivar-1)
     &                         + (i-1)*nvar
     &                         + (j-1)*nvar*mitot
     &                         + (k-1)*nvar*mitot*mjtot
       iaddaux(i,j,k) = locaux + (mcapa-1)
     &                         + (i-1)*naux
     &                         + (j-1)*naux*mitot
     &                         + (k-1)*naux*mitot*mjtot
         
c
c ******************************************************************
c conck - conservation check  for specified level
c         mostly a debugging tool
c         this assumes grids don't overlap
c ******************************************************************
c
c
c  grid loop for given level
c
      hx      = hxposs(level)
      hy      = hyposs(level)
      hz      = hzposs(level)
      dt      = possk(level)
      totmass = 0.d0

      mptr = lstart(level)
 20   if (mptr .eq. 0) go to 85
        loc    = node(store1,mptr)
        locaux = node(storeaux,mptr)
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost
        mktot  = nz + 2*nghost
c
        if (mcapa .eq. 0) then
           do 50 k  = nghost+1, mktot-nghost
           do 50 j  = nghost+1, mjtot-nghost
           do 50 i  = nghost+1, mitot-nghost
              totmass = totmass + alloc(iadd(1,i,j,k)) 
c             write(66,999) i,j,k,alloc(iadd(1,i,j,k))
c999          format(3i5,e30.20)
 50           continue
         else
c          # with capa array:
           do 60 k  = nghost+1, mktot-nghost
           do 60 j  = nghost+1, mjtot-nghost
           do 60 i  = nghost+1, mitot-nghost
              totmass = totmass + alloc(iadd(1,i,j,k))
     &                          * alloc(iaddaux(i,j,k)) 
 60           continue
         endif
c
       mptr = node(levelptr,mptr)
       go to 20
c
 85    totmass = totmass * hx * hy * hz
       if (time.eq.t0 .and. (level.eq.1) .and. .not. rest) then
           tmass0 = totmass
           write(6,*) 'Total mass at initial time: ',tmass0
           endif
       write(outunit,777) time, totmass, totmass-tmass0
 777   format('time t = ',e12.5,',  total mass = ',e22.15, '  diff = ',
     &         e11.4)
c
 99   return
      end

subroutine petsc_driver(soln,rhs_geo,levelBouss,numBoussCells,time,topo_finalized)

    ! use petsc to solve sparse linear system
    ! called this way so can allocate storage of correct size
    
    use bouss_module
#ifdef HAVE_PETSC
#include <petsc/finclude/petscksp.h>
!!#include "petscmat.h"
    use petscksp
    implicit none
    
    integer, intent(in) :: levelBouss, numBoussCells
    real(kind=8), intent(inout) :: rhs_geo(0:2*numBoussCells)
    real(kind=8), intent(in) :: time
    logical, intent(in) :: topo_finalized
    
    !! pass in numBoussCells for this level so can dimension this array
    real(kind=8), intent(out) :: soln(0:2*numBoussCells)
    
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: numCores, omp_get_max_threads,i,nelt
    integer :: j

    ! petsc declaration
    integer :: n, nn, ierr
    logical :: flg
    integer*8 :: nz


    !! These PETSC declarations are needed  
    Vec rhs,solution
    PetscInt itnum
    KSPConvergedReason reason
    !! (moved the following to amr_module)
    !Mat J
    !KSP ksp  ! linear solver ojbect


    minfo => matrix_info_allLevs(levelBouss)

    !================   Step 4 Solve matrix system =======================
            
       nn = 2*numBoussCells    ! number of rows and cols
       n = nn  ! petsc notation below
       nelt = minfo%matrix_nelt
       nz = nelt
       !write(17,*)" level ",levelBouss
       !write(17,777)(j+1,minfo%matrix_ia(j)+1,minfo%matrix_ja(j)+1,minfo%matrix_sa(j),j=0,nelt-1)
 777   format(3i8,e15.6)

       if (newGrids(levelBouss) .or. .not. topo_finalized) then
          ! destroy old solver objects to recreate for new grid setup. No need 
          ! to check if init or restart because petsc checks if null
            call KSPDestroy(ksp(levelBouss),ierr)
            CHKERRA(ierr)
            call MatDestroy(Jr(levelBouss),ierr)
            CHKERRA(ierr)

          newGrids(levelBouss) = .false.

          ! these lines are if reusing matrix with different entries but same structure
          if (.not. crs) then
            ! Using COO triplet sparse matrix storage: 
            call MatCreate(PETSC_COMM_SELF,Jr(levelBouss),ierr)
            CHKERRA(ierr)
            call MatSetSizes(Jr(levelBouss),n,n,n,n,ierr)
            CHKERRA(ierr)
            call MatSetType(Jr(levelBouss),MATSEQAIJ,ierr)
            CHKERRA(ierr)

            ! decrement indices since Petsc zero-based indexing
            ! and COO format is 1-based
            do i = 1, nz
               minfo%matrix_ia(i) = minfo%matrix_ia(i) - 1
               minfo%matrix_ja(i) = minfo%matrix_ja(i) - 1
            end do

            call MatSetPreallocationCOO(Jr(levelBouss), nz, &
                                minfo%matrix_ia, minfo%matrix_ja,ierr)
            CHKERRA(ierr)
            ! put 1 indexing back in  
            do i = 1, nz
               minfo%matrix_ia(i) = minfo%matrix_ia(i) + 1
               minfo%matrix_ja(i) = minfo%matrix_ja(i) + 1
            end do
          else 
            ! using CRS sparse matrix format
            call MatCreateSeqAijWithArrays(PETSC_COMM_SELF,2*numBoussCells,  & 
                       2*numBoussCells,minfo%rowPtr,minfo%cols,  &
                       minfo%vals,Jr(levelBouss),ierr)
            CHKERRA(ierr)
            ! per Barry, tell petsc you have blocks of size 2
            call MatSetBlockSize(Jr(levelBouss),2,ierr)
            CHKERRA(ierr)
          endif

          ! both sparse matrix formats create solver object
          call KSPCreate(PETSC_COMM_SELF,ksp(levelBouss),ierr)
          CHKERRA(ierr)
          call KSPSetErrorIfNotConverged(ksp(levelBouss),PETSC_TRUE,ierr)
          CHKERRA(ierr)
          ! Next call sets options from environment vars
          call KSPSetFromOptions(ksp(levelBouss),ierr)
          CHKERRA(ierr)

          ! now TURN off any for level 1 you dont want, such as level 1 saving
          ! preconditioner: since it never regrids would never change
          call KSPSetReusePreconditioner(ksp(1),PETSC_FALSE,ierr)
          CHKERRA(ierr)

          ! if want to try initiializing with previous solution this sets it up
          ! if have previous solution tell PETSC about it
          !call KSPSetInitialGuessNonzero(ksp(levelBouss),PETSC_TRUE,ierr)

          call KSPSetOperators(ksp(levelBouss),Jr(levelBouss),Jr(levelBouss),ierr)
          CHKERRA(ierr)
      else ! when (.not. newGrids(levelBouss)) .and. topo_finalized
         ! just put in new values, reuse same sparse matrix structure
         ! next line notifies matrix has new vals
         ! and has saved pointer to vals in between calls
         ! not needed for COO format
         if (crs) then
             call PetscObjectStateIncrease(Jr(levelBouss),ierr)
         endif
      endif

      if (.not. crs) then ! only for COO triplet format
         ! this call reuses the matrix values instead of creating new ones
         ! (for CRS, PetscObjectStsateIncrease is called instead above)
         call MatSetValuesCOO(Jr(levelBouss),minfo%matrix_sa,INSERT_VALUES,ierr)
         CHKERRA(ierr)
      endif

      ! if you want to use previous soln as initial guess,
      ! set soln to old soln here

      if (.not. crs) then
        ! switch to 0-based indexing for COO triplet format
        ! (already 0-based for CRS)
        do i = 1, 2*numBousscells
           rhs_geo(i-1) = rhs_geo(i) 
        end do
      endif 
      
      call VecCreateSeqWithArray(PETSC_COMM_SELF,1,n,rhs_geo,rhs,ierr)
      CHKERRA(ierr)
      call VecCreateSeqWithArray(PETSC_COMM_SELF,1,n,soln,solution,ierr)
      CHKERRA(ierr)

      ! save matrices for debugging. comment out to turn off
      !call MatView(Jr(levelBouss),PETSC_VIEWER_BINARY_SELF,ierr)


      call KSPSolve(ksp(levelBouss),rhs,solution,ierr)
      call KSPGetIterationNumber(ksp(levelBouss), itnum,ierr)
      CHKERRA(ierr)
      itcount(levelBouss) = itcount(levelBouss)+ itnum
      numTimes(levelBouss) = numTimes(levelBouss) + 1

      ! still working on this aspect. 
      !call KSPGetConvergedReason(ksp(levelBouss),reason,ierr)
      ! negative reason is bad, leave 
      !if (reason < 0) then
      !write(*,*) 'level ',levelBouss,' reason ',reason
      !endif

      ! check if need to adjust soln back to 1 indexing
      if (.not. crs) then ! bump both  back up
        do i = 1, 2*numBoussCells
          soln(2*numBoussCells-i+1) = soln(2*numBoussCells-i)
          rhs_geo(2*numBoussCells-i+1) = rhs_geo(2*numBoussCells-i) 
        end do
      endif
      
      !! if itnum > itmax then
      !! call KSPGetResidualNorm(ksp(levelBouss),resmax,ierr)
      CHKERRA(ierr)
      ! petsc already puts solution into my array soln so just return

       ! create and destroy each step since fast
       call VecDestroy(rhs,ierr)
       CHKERRA(ierr)
       call VecDestroy(solution,ierr)
       CHKERRA(ierr)
#endif

end subroutine petsc_driver

c
c --------------------------------------------------
c
      subroutine birect(mptr1)
c
      use amr_module
      implicit double precision (a-h,o-z)


c
c :::::::::::::  BIRECT :::::::::::::::::::::::::::::::::::::::
c check each grid, starting with mptr1 (either newstl or lstart)
c to see that it has no more than max1d points in either dimensions.
c needed so that scratch array space in stepgrid not exceeded.
c
c also check for too small grids - but has never happened.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      mptr  = mptr1
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
c
10    continue
      cxlo    = rnode(cornxlo,mptr)
      cxhi    = rnode(cornxhi,mptr)
      nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
      minsize = 2*nghost
c
c check number of rows - if too many, bisect grid with vertical
c line down the middle. make sure new grid corners are anchored
c on coarse grid point. make sure if bisecting coarse grid that
c new grids have even number of points
c
      if (nx + 2*nghost .gt. max1d) then
 
        nxl    = nx/2
        if (level .gt. 1) then 
           lratio = intratx(level-1)
        else
           lratio = 2
        endif
        nxl = (nxl/lratio)*lratio 
        nxr    = nx - nxl 
        cxmid  = cxlo + nxl*hx
 
        mptrnx = nodget()
        node(levelptr,mptrnx) = node(levelptr,mptr)
        node(levelptr,mptr)   = mptrnx
 
        rnode(cornxhi,mptr) = cxmid
        node(ndihi,mptrnx)  = node(ndihi,mptr)
        node(ndihi,mptr)    = node(ndilo,mptr) + nxl - 1
        node(ndilo,mptrnx)  = node(ndihi,mptr) + 1

        rnode(cornxlo,mptrnx)    = cxmid
        rnode(cornxhi,mptrnx)    = cxhi
        rnode(timemult,mptrnx)   = rnode(timemult,mptr)
        node(nestlevel,mptrnx)   = node(nestlevel,mptr)

        go to 10
c
c  grid ok - check the next
c
      else
        mptr = node(levelptr,mptr)
        if (mptr.ne.0) go to 10
 
      endif
 
      return
      end

! =====================================================
subroutine rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! =====================================================

! This version uses interleaved arrays.
! This version outputs f-waves.

! Riemann solver for the nonlinear elastic equations in 1d,
!  variable coefficients
!   eps_t - (m/rho(x))_x = 0
!   m_t - sigma(eps,x)_x =0
! where eps=strain, m=rho*u=momentum

! waves: 2
! equations: 2
! aux fields: 2

! Conserved quantities:
!       1 strain
!       2 momentum

! Auxiliary variables:
!       1 density
!       2 bulk_modulus

! function sigma(eps,i) gives stress-strain relation in ith cell
! function sigmap(eps,i) gives d/(d eps) of sigma
!    For linear:   sigma(eps,i) = K_i * eps, and sigmap(eps,i) = K_i

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! On output, fwave contains the waves as jumps in f,
!            s the speeds,
!            amdq = A^- Delta q,
!            apdq = A^+ Delta q,
!                   the decomposition of the flux difference
!                       f(qr(i-1)) - f(ql(i))
!                   into leftgoing and rightgoing parts respectively.
! 

! Note that the ith Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit double precision (a-h,o-z)

    dimension auxl(maux,1-mbc:maxm+mbc)
    dimension auxr(maux,1-mbc:maxm+mbc)
    dimension fwave(meqn,mwaves,1-mbc:maxm+mbc)
    dimension    s(mwaves,1-mbc:maxm+mbc)
    dimension   ql(meqn,1-mbc:maxm+mbc)
    dimension   qr(meqn,1-mbc:maxm+mbc)
    dimension apdq(meqn,1-mbc:maxm+mbc)
    dimension amdq(meqn,1-mbc:maxm+mbc)


!     # split the jump in q at each interface into waves

    do i = 2-mbc, mx+mbc
        rhoi = auxl(1,i)
        rhoim = auxr(1,i-1)
        epsi = ql(1,i)
        epsim = qr(1,i-1)
        urhoi = ql(2,i)
        urhoim = qr(2,i-1)

    !        #linearize on each side:

        bulki = sigmap(epsi,i,auxl(2,i),auxl(3,i))
        bulkim = sigmap(epsim,i-1,auxr(2,i-1),auxr(3,i-1))
        ci = dsqrt(bulki / rhoi)
        cim = dsqrt(bulkim / rhoim)
        zi = ci*rhoi
        zim = cim*rhoim

        du = urhoi/rhoi - urhoim/rhoim
        dsig = sigma(epsi,i,auxl(2,i),auxl(3,i)) &
        - sigma(epsim,i-1,auxr(2,i-1),auxr(3,i-1))
        b1 = -(zi*du + dsig) / (zim + zi)
        b2 = -(zim*du - dsig) / (zim + zi)
    !         a1 = b1 / (-cim)
    !         a2 = b2 / ci

    !         estarim = epsim + a1
    !         estari = epsi - a2

    !         ui = urhoi / rhoi
    !         uim = urhoim / rhoim

    !         ustar = urhoim/rhoim + (estarim - epsim) * cim
    !               = urhoi/rhoi - (estari - epsi) * ci
    !               = uim - b1
                
    
    !        # Compute the waves.
    
        fwave(1,1,i) = b1
        fwave(2,1,i) = b1 * zim
        s(1,i) = -cim
    
        fwave(1,2,i) = b2
        fwave(2,2,i) = b2*(-zi)
        s(2,i) = ci

    end do


!     # compute the leftgoing and rightgoing fluctuations:
!     # Note s(1,i) < 0   and   s(2,i) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = fwave(m,1,i)
            apdq(m,i) = fwave(m,2,i)
        end do
    end do

    return
    end subroutine rp1


!     --------------------------------------------
    double precision function sigma(eps,i,coefA,coefB)
!     --------------------------------------------
    implicit double precision (a-h,o-z)

!     # stress-strain relation in ith cell


!     # nonlinear in both layers:
!     sigma = (coefB + coefA)*(dexp(eps) - 1.d0)

!     # nonlinear layer 0:
!     sigma = coefB*eps + coefA*(dexp(eps) - 1.d0)

!     # nonlinear layer 1:
!     sigma = coefB*(dexp(eps) - 1.d0) + coefA*eps

    if (coefA > 0.d0) then
    !         # layer A:
    !         sigma = coefA*eps
        sigma = dexp(coefA*eps) - 1.d0
    !          sigma = coefA*eps + 0.5d0*eps**2
    else
    !         # layer B:
        sigma = coefB*eps
    !         sigma = dexp(coefB*eps) - 1.d0
    endif

    return
    END function


!     --------------------------------------------
    double precision function sigmap(eps,i,coefA,coefB)
!     --------------------------------------------
    implicit double precision (a-h,o-z)

!     # derivative of stress-strain relation in ith cell

!     # nonlinear in both layers:
!     sigmap = (coefB + coefA)*dexp(eps)

!     # nonlinear layer 0:
!     sigmap = coefB + coefA*dexp(eps)

!     # nonlinear layer 1:
!     sigmap = coefB*dexp(eps) + coefA

    if (coefA > 0.d0) then
    !         # layer A:
    !         sigmap = coefA
        sigmap = coefA*dexp(coefA*eps)
    !         sigmap = coefA + eps
    else
    !         # layer B:
        sigmap = coefB
    !         sigmap = coefB*dexp(coefB*eps)
    endif


    return
    END function

c
c
c     =====================================================
      subroutine flux2_dimSplit(ixy,maxm,meqn,maux,mbc,mx,
     &                 q1d,dtdx1d,aux2,
     &                 faddm,faddp,cfl1d,wave,s,
     &                 cqxx,rpn2)
c     =====================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c     # Compute the modification to fluxes f and g that are generated by
c     # all interfaces along a 1D slice of the 2D grid. 
c     #    ixy = 1  if it is a slice in x
c     #          2  if it is a slice in y
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd and gadd.  The notation is written assuming
c     # we are solving along a 1D slice in the x-direction.
c
c     # fadd(*,i,.) modifies F to the left of cell i
c     # gadd(*,i,.,1) modifies G below cell i
c     # gadd(*,i,.,2) modifies G above cell i
c
c     # The method used is specified by method(2:3):
c
c         method(2) = 1 if only first order increment waves are to be used.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.  
c
c         method(3) = 0 if no transverse propagation is to be applied.
c                       Increment and perhaps correction waves are propagated
c                       normal to the interface.
c                   = 1 if transverse propagation of increment waves 
c                       (but not correction waves, if any) is to be applied.
c                   = 2 if transverse propagation of correction waves is also
c                       to be included.  
c
c     Note that if mcapa>0 then the capa array comes into the second 
c     order correction terms, and is already included in dtdx1d:
c     If ixy = 1 then
c        dtdx1d(i) = dt/dx                      if mcapa= 0
c                  = dt/(dx*aux(mcapa,i,jcom))  if mcapa = 1
c     If ixy = 2 then
c        dtdx1d(j) = dt/dy                      if mcapa = 0
c                  = dt/(dy*aux(mcapa,icom,j))  if mcapa = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn2 into
c            amdq =  the left-going flux difference  A^- Delta q  
c            apdq = the right-going flux difference  A^+ Delta q  
c      In dimensionally split version no need for extra arrays amdq,apdq
c      Use faddm and faddp instead. BUT REMEMBER to negate apdq
c      since it was previously SUBTRACTED from fadpp.
c
c
      use amr_module
      implicit double precision (a-h,o-z)
      external rpn2
      dimension    q1d(meqn,1-mbc:maxm+mbc)
      dimension   cqxx(meqn,1-mbc:maxm+mbc)
      dimension   faddm(meqn,1-mbc:maxm+mbc)
      dimension   faddp(meqn,1-mbc:maxm+mbc)
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux2(maux,1-mbc:maxm+mbc)
c
      dimension     s(mwaves, 1-mbc:maxm+mbc)
      dimension  wave(meqn, mwaves, 1-mbc:maxm+mbc)
c
      logical limit
c
      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
   5     continue
c
c     # initialize flux increments:
c     -----------------------------
c
       do 10 i = 1-mbc, mx+mbc
         do 20 m=1,meqn
            faddm(m,i) = 0.d0
            faddp(m,i) = 0.d0
   20    continue
   10  continue
c
c
c     # solve Riemann problem at each interface and compute Godunov updates
c     ---------------------------------------------------------------------
c
      call rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &          aux2,aux2,wave,s,faddm,faddp)
c
      faddp = -faddp  !! NEGATED, replaces faddp(m,i) = faddp(m,i) - apdq(m,i) in original flux2.
c
c     # dont delete this code yet, in case there is an issue with loop indices
!     # Set fadd for the donor-cell upwind method (Godunov)
!--      do 40 i=1,mx+1
!--         do 40 m=1,meqn
!--            faddp(m,i) = faddp(m,i) - apdq(m,i)
!--            faddm(m,i) = faddm(m,i) + amdq(m,i)
!--   40       continue
c
c     # compute maximum wave speed for checking Courant number:
      cfl1d = 0.d0
      do 51 mw=1,mwaves
         do 50 i=1,mx+1
c          # if s>0 use dtdx1d(i) to compute CFL,
c          # if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i),
     &                          -dtdx1d(i-1)*s(mw,i))
   50       continue
   51       continue
c
      if (method(2).eq.1) go to 130
c
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c
c     # apply limiter to waves:
      if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c
      do 121 i = 1, mx+1
c
c        # For correction terms below, need average of dtdx in cell
c        # i-1 and i.  Compute these and overwrite dtdx1d:
c
c        # modified in Version 4.3 to use average only in cqxx, not transverse
         dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))

c
c        # second order corrections:

         do 120 m=1,meqn
            cqxx(m,i) = 0.d0
            do 119 mw=1,mwaves
c
               if (use_fwaves) then
                   abs_sign = dsign(1.d0,s(mw,i))
                 else
                   abs_sign = dabs(s(mw,i))
                 endif

               cqxx(m,i) = cqxx(m,i) + abs_sign
     &             * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
c
  119          continue
            faddm(m,i) = faddm(m,i) + 0.5d0 * cqxx(m,i)
            faddp(m,i) = faddp(m,i) + 0.5d0 * cqxx(m,i)
  120       continue
  121       continue
c
c
  130  continue
c

      return
      end

c
c
c
c
c
c     =================================================
      function fss(s)
c     =================================================
      implicit double precision (a-h,o-z)
      common/fsscorn/ xc0,yc0,xc1,yc1
c   
c     # compute fdisc at distance s between corners (xc0,yc0) and (xc1,yc1)
c
      x = xc0 + s*(xc1-xc0)
      y = yc0 + s*(yc1-yc0)
      fss = fdisc(x,y)
      return
      end

c
c
c     =====================================================
      subroutine rpt2(ixy,maxm,meqn,mwaves,mbc,mx,
     &                  ql,qr,aux1,aux2,aux3,
     &                  ilr,asdq,bmasdq,bpasdq)
c     =====================================================
      implicit double precision (a-h,o-z)
c
c     # Riemann solver in the transverse direction for the Euler equations
c     #  with a tracer variable.
c     # Split asdq (= A^* \Delta q, where * = + or -)
c     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
c     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)
c
c     # Uses Roe averages and other quantities which were 
c     # computed in rpn2eu and stored in the common block comroe.
c
      dimension     ql(meqn, 1-mbc:maxm+mbc)
      dimension     qr(meqn, 1-mbc:maxm+mbc)
      dimension   asdq(meqn, 1-mbc:maxm+mbc)
      dimension bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension bpasdq(meqn, 1-mbc:maxm+mbc)
c
      common /cparam/  gamma,gamma1
      dimension waveb(5,4),sb(4)
      parameter (maxm2 = 1800)  
c     # assumes at most maxm2 * maxm2 grid with mbc<=3
      common /comroe/ u2v2(-2:maxm2+3),
     &       u(-2:maxm2+3),v(-2:maxm2+3),
     &       enth(-2:maxm2+3),a(-2:maxm2+3),
     &       g1a2(-2:maxm2+3),euv(-2:maxm2+3) 
c
      if (mbc.gt.3 .or. maxm2 .lt. maxm) then
         write(6,*) 'need to increase maxm2 or 3 in rpt'
         stop
         endif
c
      if (ixy.eq.1) then
          mu = 2
          mv = 3
        else
          mu = 3
          mv = 2
        endif
c
         do 20 i = 2-mbc, mx+mbc
            a3 = g1a2(i) * (euv(i)*asdq(1,i) 
     &             + u(i)*asdq(mu,i) + v(i)*asdq(mv,i) - asdq(4,i))
            a2 = asdq(mu,i) - u(i)*asdq(1,i)
            a4 = (asdq(mv,i) + (a(i)-v(i))*asdq(1,i) - a(i)*a3)
     &              / (2.d0*a(i))
            a1 = asdq(1,i) - a3 - a4
c
            waveb(1,1) = a1
            waveb(mu,1) = a1*u(i)
            waveb(mv,1) = a1*(v(i)-a(i))
            waveb(4,1) = a1*(enth(i) - v(i)*a(i))
            waveb(5,1) = 0.d0
            sb(1) = v(i) - a(i)
c
            waveb(1,2) = a3
            waveb(mu,2) = a3*u(i) + a2
            waveb(mv,2) = a3*v(i)
            waveb(4,2) = a3*0.5d0*u2v2(i) + a2*u(i)
            waveb(5,2) = 0.d0
            sb(2) = v(i)
c
            waveb(1,3) = a4
            waveb(mu,3) = a4*u(i)
            waveb(mv,3) = a4*(v(i)+a(i))
            waveb(4,3) = a4*(enth(i)+v(i)*a(i))
            waveb(5,3) = 0.d0
            sb(3) = v(i) + a(i)
c
            waveb(1,4) = 0.d0
            waveb(mu,4) = 0.d0
            waveb(mv,4) = 0.d0
            waveb(4,4) = 0.d0
            waveb(5,4) = asdq(5,i)
            sb(4) = v(i)
c
c           # compute the flux differences bmasdq and bpasdq
c
            do 10 m=1,meqn
               bmasdq(m,i) = 0.d0
               bpasdq(m,i) = 0.d0
               do 10 mw=1,4
                  bmasdq(m,i) = bmasdq(m,i) 
     &                         + dmin1(sb(mw), 0.d0) * waveb(m,mw)
                  bpasdq(m,i) = bpasdq(m,i)
     &                         + dmax1(sb(mw), 0.d0) * waveb(m,mw)
   10             continue
c                 
   20       continue
c
      return
      end

c
c ------------------------------------------------------------
c
!> Get first free node of the linked list kept in node
!! array. adjust pointers accordingly.
!!
!! This function is used to create a new grid descriptor, like
!! mptr = new grid_class in c++.
!!
      integer function nodget()
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer maxgrIncrement/10000/

c
c ::::::::::::::::: NODGET ::::::::::::::::::::::::::::::::::::;
c nodget =  get first free node of the linked list kept in node
c            array. adjust pointers accordingly.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      if (ndfree .ne. null) go to 10
          write(outunit,100) maxgr
          write(*,100)       maxgr
100       format(' out of nodal space - allowed ',i8,' grids')
          do level = 1, lfine
             write(*,101) level,numgrids(level)
 101         format("    level ",i4," has ",i7,' grids')
          end do
          write(*,*)" Could need twice as many grids as on any given"
          write(*,*)" level if regridding/birecting"
!          stop
!         new way gets more storage and continues
          istatus = 1
          call resize_nodes(maxgr + maxgrIncrement, istatus)
          if (istatus > 0) then
             write(*,102) maxgr,maxgrIncrement
102          format(' unable to increase nodal space by ',i8,' grids',/,
     .              'resize failed')
             stop
          endif
c
c  allocate next node, update pointers
c
 10     nodget         = ndfree
        ndfree         = node(nextfree,ndfree)
c
c  initialize new  block
c
        do 20 i        = 1, nsize
           node(i,nodget) = 0
 20     continue
c
        do 30 i         = 1, rsize
           rnode(i,nodget) = 0.0d0
 30     continue
c
      return
      end
c
c ------------------------------------------------------------
c
      integer function nodget_bnd()
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::: NODGET_BND ::::::::::::::::::::::::::::::::::::;
c nodget_bnd =  same as above but for bndry list
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      if (ndfree_bnd .ne. null) go to 10
          write(outunit,100) bndListSize
          write(*,100)       bndListSize
100       format(' out of bndry space - allowed ',i5,' bndry grids')
          ! calc average number of bndry nbors per grid
          nborTotal = 0
          numGridsTotal = 0
          do lev = 1, lfine
            numGridsTotal = numGridsTotal + numgrids(lev)
            do mptr = 1, numgrids(lev)
               nborTotal = nborTotal + node(bndListNum,mptr)  
            end do
          end do
          avgNbors = float(nborTotal)/numgridsTotal
          write(*,101) numGridsTotal,nborTotal,avgNbors
 101      format(" There are ",i8," total grids", i10," bndry nbors",
     .           " average num/grid ",f10.3)

          !stop
          call resize_bndryList()
c
c     ## adjust pointers for next bndry entry
c
 10   nodget_bnd      = ndfree_bnd
      ndfree_bnd      = bndList(ndfree_bnd,nextfree)
c
c     ##  initialize to 0
c
      bndList(nodget_bnd,1) = 0
      bndList(nodget_bnd,2) = 0
c
      return
      end
c
c -----------------------------------------------------------------
c
!> Make (modify) array of grid numbers, listOfGrids, (after sorting them 
!! in the linked list so they are in decreasing order of workload, 
!! done in arrangeGrid()).
!!
!! This is done every time there is regridding, initial gridding,
!! or restarting.  Most often finest level is regridded, so
!! put it last in array. **lbase** is the level that didnt change, so 
!! only redo from lbase+1 to lfine.
!! \param[in] lbase all levels from **lbase**+1 to the finest get
!! modifed in the array, listOfGrids
      subroutine makeGridList(lbase)
c
      use amr_module
      implicit none

      integer lbase, levSt, lev, mptr, n

c :::::::::::::::::::::::::::: make_gridList :::::::::::::::::::::::::
c     make array of grid numbers (after sorting them so in decreasing
c     order of workload, done in arrangeGrid and put back into linked 
c     list. Done every time there is regridding, initial gridding,
c     or restarting.  Most often finest level is regridded, so
c     put it last in array. lbase is the level that didnt change, so 
c     only redo from lbase+1 to lfine.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      !write(*,*)"mgl: lbase,lfine",lbase,lfine
      do lev = lbase+1, lfine
         levSt = listStart(lev) 
         !write(*,*)"mgl: level ",lev," starts at ",levSt
         mptr = lstart(lev)
c        traverse linked list into array. list already sorted by arrangegrids
         do n = 1, numgrids(lev)
            listOfGrids(levSt+n-1) = mptr
            mptr = node(levelptr,mptr)
         end do
c
c        next level starts one after where this one ends.
c        Using a sentinel in dimension of
c        listStart so no need to test if level = mxnest
c
         listStart(lev+1) = levSt + numgrids(lev)
      end do

      return
      end

c
!> print solution and aux. variables to output. 
c =======================================================================
      subroutine outval(val,nvar,mitot,mjtot,mptr,outgrd,naux,aux)
c =======================================================================
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension  val(nvar,mitot,mjtot)
      dimension  aux(naux,mitot,mjtot)
      logical    outgrd


c ::::::::::::::::::::::OUTVAL :::::::::::::::::::::::::::::::
c print solution and aux. variables to output. 
c if cell outside domain, don't print soln. value - nothing
c currently in ghost cells.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      if (.not. outgrd) go to 99
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
      cornx = rnode(cornxlo,mptr) -  nghost*hx
      corny = rnode(cornylo,mptr) -  nghost*hy
c
      do 25 j=nghost+1,mjtot-nghost
      do 20 i=nghost+1,mitot-nghost

          x  = cornx + hx*(dble(i)-.5d0)
          y  = corny + hy*(dble(j)-.5d0)
          write(outunit,107) x,y,i,j,(val(ivar,i,j),ivar=1,nvar)
c107      format(2hx=,e9.3,2hy=,e9.3,3h,i=,i3,3h,j=,i3,' a=',
 107      format(e9.3,2x,e9.3,i5,2x,i5,5(e14.7,1x))
c         if (naux.gt.0) write(outunit,108) (aux(iaux,i,j),iaux=1,naux)
 108      format(1x,'aux = ',7(e10.3,1x))

 20   continue
 25   continue

 99   return
      end

c     
c     
c=========================================================
      subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)
c=========================================================
c     
c     # Set initial conditions for q.
c     # Pulse in pressure, zero velocity
c     
c     
      implicit none

      integer, intent(in) :: meqn, mbc, mx, maux
      double precision, intent(in) :: xlower, dx, aux
      double precision, intent(out) :: q
      dimension q(meqn, 1-mbc:mx+mbc)
      dimension aux(maux, 1-mbc:mx+mbc)

      common /cqinit/ beta,ic
      double precision beta
      integer ic

      integer i
      double precision xcell
c     
c     
      do 150 i=1,mx
         xcell = xlower + (i-0.5d0)*dx

         go to (10,20,30) ic

 10      continue
c     # half ellipse:
         if (xcell.gt.-4d0 .and. xcell.lt.-2d0) then
            q(1,i) = dsqrt(1.d0 - (xcell+3.d0)**2)
         else
            q(1,i) = 0.d0
         endif
         q(2,i) = q(1,i)
         go to 150

 20      continue
c     # single discontinuity:
         if (xcell .lt. -2.d0) then
            q(1,i) = 1.d0
         else
            q(1,i) = 0.d0
         endif
         q(2,i) = q(1,i)
         go to 150

 30      continue
c     # Gaussian and square pulse:
         q(1,i) = dexp(-beta*(xcell+2.0d0)**2)  
         if (dabs(q(1,i)) .lt. 1d-30) q(1,i) = 0.d0
         if (xcell.gt.-4.d0 .and. xcell.lt.-3.d0) then
            q(1,i) = q(1,i) + 0.5d0
         endif
         q(2,i) = q(1,i)
         go to 150

 150  continue
c     
      return
      end

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! Riemann solver for the acoustics equations in 2d, with varying
! material properties rho and kappa

! waves: 2
! equations: 3
! aux fields: 2

! Conserved quantities:
!       1 pressure
!       2 x_momentum
!       3 y_momentum

! Auxiliary variables:
!         1  density
!         2  sound_speed

! Note that although there are 3 eigenvectors, the second eigenvalue
! is always zero and so we only need to compute 2 waves.
!
! solve Riemann problems along one slice of data.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! Here it is assumed that auxl=auxr gives the cell values.

! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q

! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.

! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit double precision (a-h,o-z)

    dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn, 1-mbc:maxm+mbc)
    dimension amdq(meqn, 1-mbc:maxm+mbc)
    dimension auxl(maux, 1-mbc:maxm+mbc)
    dimension auxr(maux, 1-mbc:maxm+mbc)

!     local arrays
!     ------------
    dimension delta(3)

!     # set mu to point to  the component of the system that corresponds
!     # to velocity in the direction of this slice, mv to the orthogonal
!     # velocity.


    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

!     # note that notation for u and v reflects assumption that the
!     # Riemann problems are in the x-direction with u in the normal
!     # direciton and v in the orthogonal direcion, but with the above
!     # definitions of mu and mv the routine also works with ixy=2


!     # split the jump in q at each interface into waves
!     # The jump is split into a leftgoing wave traveling at speed -c
!     # relative to the material properties to the left of the interface,
!     # and a rightgoing wave traveling at speed +c
!     # relative to the material properties to the right of the interface,

!     # find a1 and a2, the coefficients of the 2 eigenvectors:
    do 20 i = 2-mbc, mx+mbc
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(mu,i) - qr(mu,i-1)
    !        # impedances:
        zi = auxl(1,i)*auxl(2,i)
        zim = auxr(1,i-1)*auxr(2,i-1)

        a1 = (-delta(1) + zi*delta(2)) / (zim + zi)
        a2 =  (delta(1) + zim*delta(2)) / (zim + zi)

    
    !        # Compute the waves.
    
        wave(1,1,i) = -a1*zim
        wave(mu,1,i) = a1
        wave(mv,1,i) = 0.d0
        s(1,i) = -auxr(2,i-1)
    
        wave(1,2,i) = a2*zi
        wave(mu,2,i) = a2
        wave(mv,2,i) = 0.d0
        s(2,i) = auxl(2,i)
    
    20 END DO



!     # compute the leftgoing and rightgoing flux differences:
!     # Note s(1,i) < 0   and   s(2,i) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = s(1,i)*wave(m,1,i)
            apdq(m,i) = s(2,i)*wave(m,2,i)
        end do
    end do

    return
    end subroutine rpn2

c
c -------------------------------------------------------
c
      subroutine fluxad(xfluxm,xfluxp,
     1                  svdflx,mptr,mitot,
     2                   nvar,lenbc,lratiox,ng,dtf,dx)
c

      use amr_module
      implicit double precision (a-h,o-z)


c :::::::::::::::::::: FLUXAD ::::::::::::::::::::::::::::::::::
c  save fine grid fluxes  at the border of the grid, for fixing
c  up the adjacent coarse cells. at each edge of the grid, only
c  save the plus or minus fluxes, as necessary. For ex., on
c  left edge of fine grid, it is the minus xfluxes that modify the
c  coarse cell.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      dimension xfluxm(nvar,mitot)
      dimension xfluxp(nvar,mitot)
      dimension svdflx(nvar,lenbc)
 
c ::::: left side saved first
      lind = 0

      lind = lind + 1
      do 110 ivar = 1, nvar
            svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                             xfluxm(ivar,ng+1)*dtf
c           write(dbugunit,900)lind,xfluxm(ivar,1),
c     .                           xfluxp(ivar,1)
 900        format(' lind ', i4,' m & p ',2e15.7,' svd ',e15.7)
110    continue
 
c ::::: right side
       lind = lind + 1
       do 310 ivar = 1, nvar
           svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                    xfluxp(ivar,mitot-ng+1)*dtf
c          write(dbugunit,900)lind,xfluxm(ivar,mitot-ng+1
c                                 ),xfluxp(ivar,mitot-ng+1)
310    continue
 
      return
      end

! =====================================================
subroutine rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! =====================================================
!     # Adjoint Riemann solver for the acoustics equations in 1d.

! waves:     2
! equations: 2

! Conserved quantities:
!       1 pressure
!       2 velocity

!     # On input, ql contains the state vector at the left edge of each cell
!     #           qr contains the state vector at the right edge of each cell

!     # On output, wave contains the waves,
!     #            s the speeds,
!     #            amdq the  left-going flux difference  A^- \Delta q
!     #            apdq the right-going flux difference  A^+ \Delta q


!     # Note that the i'th Riemann problem has left state qr(i-1,:)
!     #                                    and right state ql(i,:)
!     # From the basic clawpack routines, this routine is called with ql = qr

!     # aux arrays not used in this solver.

    implicit double precision (a-h,o-z)

    dimension fwave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn, 1-mbc:maxm+mbc)
    dimension amdq(meqn, 1-mbc:maxm+mbc)
    dimension auxl(maux, 1-mbc:maxm+mbc)
    dimension auxr(maux, 1-mbc:maxm+mbc)

!     local arrays
!     ------------
    dimension delta(2)

!     # density, bulk modulus, and sound speed, and impedence of medium:
!     # (should be set in setprob.f)
    common /cparam/ rho,bulk,cc,zz

!     # split the jump in f(q) at each interface into waves

!     # find b1 and b2, the coefficients of the 2 eigenvectors:
    do 20 i = 2-mbc, mx+mbc
!       # material properties
        rhoi = zz/cc
        bulki = rhoi*cc**2

!       # f-wave splitting
        delta(1) = -(ql(2,i)/rhoi - qr(2,i-1)/rhoi)
        delta(2) = -(bulki*ql(1,i) - bulki*qr(1,i-1))

        beta1 = (zz*delta(1) + delta(2)) / (2.d0*zz)
        beta2 = (zz*delta(1) - delta(2)) / (2.d0*zz)
    
!       # Compute the waves. Eigenvectors switched for adjoint:
!       # (speeds negative of eigenvalues because we are going backward in time)

        fwave(1,1,i) = beta1
        fwave(2,1,i) = beta1*zz
        s(1,i) = -cc
    
        fwave(1,2,i) = beta2
        fwave(2,2,i) = -beta2*zz
        s(2,i) = cc
    
    20 END DO


!     # compute the leftgoing and rightgoing flux differences:
!     # Note s(i,1) < 0   and   s(i,2) > 0.

!   # f-wave splitting, so do not multiply by wave speeds:
    forall (m=1:meqn,  i=2-mbc: mx+mbc)
    amdq(m,i) = fwave(m,1,i)
    apdq(m,i) = fwave(m,2,i)
    end forall

    return
    end subroutine rp1

! ============================================================================
!  Program:     /Users/mandli/Documents/Research/notes/point_wise_rs/src
!  File:        main
!  Created:     2010-04-20
!  Author:      Kyle Mandli
! ============================================================================
!      Copyright (C) 2010-04-20 Kyle Mandli <mandli@amath.washington.edu>
!
!  Distributed under the terms of the Berkeley Software Distribution (BSD) 
!  license
!                     http://www.opensource.org/licenses/
! ============================================================================
!  Stencils:                                   
!                         |          |          | 
!           ghost cells   |          |          | 
!    ----------+----------+----------+----------+-
!        1          2          3          4         cell centers  q,aux
!           1          2          3          4      rp locations  waves,s
! 
!      |          |          |          
!      |          |          |    ghost cells
!    --+----------+----------+----------+----------
!          mx-3      mx-2       mx-1        mx      cell centers  q,aux
!    mx-3       mx-2      mx-1        mx            rp locations  waves,s
!
!  First row are grid cell center indices
!  Second row are riemann problem indices
!  Riemann problems are solved in the indices at grid cell edges
!
module mod_rand

    implicit none
    
contains

    subroutine init_random_seed()
        integer :: i, n, clock
        integer, dimension(:), allocatable :: seed

        call random_seed(size = n)
        allocate(seed(n))

        call system_clock(count=clock)

        seed = clock + 37 * (/ (i - 1, i = 1, n) /)
        call random_seed(put = seed)

        deallocate(seed)
    end subroutine

end module mod_rand

subroutine pw_rp(meqn,maux,mwaves,q_l,q_r,aux_l,aux_r,wave,s)

    implicit none
    integer, intent(in) :: meqn,maux,mwaves
    double precision, intent(in) :: q_l(1:meqn), q_r(1:meqn)
    double precision, intent(in) :: aux_l(1:maux), aux_r(1:maux)
    double precision, intent(out) :: wave(1:meqn,1:mwaves),s(1:mwaves)
    
    integer :: p
    
    do p=1,mwaves
        wave(:,p) = q_l(:) + q_r(:)
        s(p) = (aux_l(p) + aux_r(p)) / 2.d0
    enddo

end subroutine pw_rp

subroutine vec_rp(mx,meqn,maux,mwaves,q_l,q_r,aux_l,aux_r,wave,s)

    implicit none
    
    integer, intent(in) :: mx,meqn,maux,mwaves
    double precision, intent(in) :: q_l(1:meqn,1:mx-1), q_r(1:meqn,1:mx-1)
    double precision, intent(in) :: aux_l(1:maux,1:mx-1), aux_r(1:maux,1:mx-1)
    double precision, intent(out) :: wave(1:meqn,1:mwaves,1:mx),s(1:mwaves,1:mx)

    integer :: i,p
    
    do i=2,mx-1
        do p=1,mwaves
            wave(:,p,i) = q_l(:,i) + q_r(:,i)
            s(p,i) = (aux_l(p,i) + aux_r(p,i)) / 2.d0
        enddo
    enddo
            

end subroutine vec_rp

program clawpack_rs_test
    
    implicit none
    
    ! Parameters
    integer, parameter :: mx = 2**15, meqn = 2, maux = 2, mwaves = 2
    
    ! Arrays
    double precision, allocatable :: q(:,:), aux(:,:), wave(:,:,:), s(:,:)
    
    ! Locals
    integer :: i,n,m,count_rate,start,finish
    double precision :: pw_time, vec_time
    
    ! Allocate all arrays
    allocate(q(1:meqn,1:mx))
    allocate(aux(1:maux,1:mx))
    allocate(wave(1:meqn,1:mwaves,1:mx))
    allocate(s(1:mwaves,1:mx))
    
    ! Initialize arrays
    call random_number(q)
    call random_number(aux)
    wave = 0.d0
    s = 0.d0
    
    ! Point-wise test
    print *,"Point-wise test..."
    call system_clock(start,count_rate)
    do n=1,2**15
        !$OMP parallel do
        do i=2,mx-1
            call pw_rp(meqn,maux,mwaves,q(:,i-1),q(:,i),aux(:,i-1), &
                aux(:,i),wave(:,:,i),s(:,i))
        enddo
        !$OMP end parallel do
    enddo
    call system_clock(finish,count_rate)
    pw_time = float(finish - start) / float(count_rate)
    print *,"test done."
    
    ! Vectorized version
    print *,"Vectorized test..."
    wave = 0.d0
    s = 0.d0
    call system_clock(start,count_rate)
    do n=1,2**15
        call vec_rp(mx,meqn,maux,mwaves,q(:,1:mx-1),q(:,2:mx),aux(:,1:mx-1), &
            aux(:,2:mx),wave,s)
    enddo
    call system_clock(finish,count_rate)
    vec_time = float(finish - start) / float(count_rate)
    print *,"test done."

    print *, "Point-wise: ", pw_time
    print *, "Vectorized: ", vec_time
    print *, "Percent difference: ",100.d0 * abs(vec_time - pw_time) / vec_time,"%"
end program clawpack_rs_test

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::: Parameters, variables, subroutines related to gauges
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

! Contains:
!   subroutine set_gauges
!     Called initially to read from gauges.data
!   subroutine setbestsrc
!     Called each time regridding is done to determine which patch to 
!     use for interpolating to each gauge location.
!   subroutine print_gauges
!     Called each time step for each grid patch.
!     Refactored dumpgauge routine to interpolate for all gauges on patch.
!
!     Note: by default all components of q are printed at each gauge.
!     To print something different or a different precision, modify 
!     format statement 100 and/or the write statement that uses it.
!   
! Note: Updated for Clawpack 5.3.0:
!   - the dumpgauge and setbestsrc subroutines have been moved to this module 
!     and the dumpgauge subroutine has been refactored and renamed print_gauges.
!   - dumpgauge.f must be removed from Makefiles.
!   - setbestsrc uses quicksort to sort gauge numbers and
!     then figures out which gauges will be updated by grid, and stores this
!     information in new module variables mbestg1, mbestg2.
!   - print_gauges no longer uses binary search to locate first gauge handled
!     by a grid.  Instead loop over gauges specified by mbestg1, mbestg2.
!
! Note: Updated for Clawpack 5.4.0
!   - refactor so each gauge writes to its own file, and batches the writes instead of 
!     writing one at a time. This will remove the critical section and should speed up gauges a lot
!   - When array is filled, that gauge will write to file and start over. 
!   - Need to save index so know position in array where left off
!   - At checkpoint times, dump all gauges

module gauges_module

    implicit none
    save

    logical, private :: module_setup = .false.

    integer, parameter :: OUTGAUGEUNIT=89
    integer :: num_gauges, inum
    real(kind=8), allocatable :: xgauge(:), t1gauge(:), t2gauge(:)
    integer, allocatable, dimension(:) ::  mbestsrc, mbestorder, &
                          igauge, mbestg1, mbestg2, nextLoc
    
!    integer, parameter :: MAXDATA=1
    integer, parameter :: MAXDATA=1000
    real(kind=8), pointer :: gaugeArray(:,:,:)
    integer, pointer :: levelArray(:,:)

contains

    subroutine set_gauges(restart, nvar, fname)

        use amr_module

        implicit none

        ! Input
        character(len=*), intent(in), optional :: fname
        logical, intent(in) :: restart
        integer, intent(in) :: nvar

        ! Locals
        integer :: i, ipos, idigit
        integer, parameter :: iunit = 7
        character(len=24) :: fileName
        character(len=15) :: numstr

        if (.not. module_setup) then

            ! Open file
            if (present(fname)) then
                call opendatafile(iunit,fname)
            else
                call opendatafile(iunit,'gauges.data')
            endif

            read(iunit,*) num_gauges

            allocate(xgauge(num_gauges))
            allocate(t1gauge(num_gauges), t2gauge(num_gauges))
            allocate(mbestsrc(num_gauges), mbestorder(num_gauges))
            allocate(igauge(num_gauges))
            allocate(mbestg1(maxgr), mbestg2(maxgr))

            allocate(nextLoc(num_gauges))
            allocate(gaugeArray(nvar+1,MAXDATA,num_gauges))  ! +1 for time
            allocate(levelArray(MAXDATA,num_gauges))
            
            do i=1,num_gauges
                read(iunit,*) igauge(i),xgauge(i),t1gauge(i),t2gauge(i)
            enddo

            close(iunit)
            
            ! initialize for starters
            mbestsrc = 0
            nextLoc  = 1  ! next location to be filled with gauge info

            do i = 1, num_gauges

               inum = igauge(i)

               ! convert inum to string numstr with zero padding if <5 digits
               ! since we want format gauge00012.txt or gauge1234567.txt:
               write (numstr,'(I0.5)') inum
               fileName = 'gauge'//trim(numstr)//'.txt'

    !          status unknown since might be a restart run. might need to rewind
               if (restart) then
                  open(unit=OUTGAUGEUNIT, file=fileName, status='old',        &
                       position='append', form='formatted')
               else
                  open(unit=OUTGAUGEUNIT, file=fileName, status='unknown',        &
                       position='append', form='formatted')
                  rewind OUTGAUGEUNIT
                  write(OUTGAUGEUNIT,100) igauge(i), xgauge(i), nvar
  100             format("# gauge_id= ",i0," location=( ",1e15.7," ) num_eqn= ",i2)
                  write(OUTGAUGEUNIT,101)
  101             format("# Columns: level time q(1 ... num_eqn)")
               endif

               close(OUTGAUGEUNIT)

            end do

            module_setup = .true.
        end if

    end subroutine set_gauges


!
! --------------------------------------------------------------------
!
      subroutine setbestsrc()
!
!     Called every time grids change, to set the best source grid patch
!     for each gauge, i.e. the finest level patch that includes the gauge.
!
!     lbase is grid level that didn't change, but since fine
!     grid may have disappeared, we still have to look starting
!     at coarsest level 1.
!
      use amr_module
      implicit none

      integer :: lev, mptr, i, k1, ki

!
! ##  set source grid for each loc from coarsest level to finest.
! ##  that way finest src grid left and old ones overwritten
! ##  this code uses fact that grids do not overlap

! # for debugging, initialize sources to 0 then check that all set
      do i = 1, num_gauges
         mbestsrc(i) = 0
      end do

 
      do 20 lev = 1, lfine  
          mptr = lstart(lev)
 5        do 10 i = 1, num_gauges
            if ((xgauge(i) .ge. rnode(cornxlo,mptr)) .and. &
                (xgauge(i) .le. rnode(cornxhi,mptr)) ) then
               mbestsrc(i) = mptr
            endif
 10       continue

          mptr = node(levelptr, mptr)
          if (mptr .ne. 0) go to 5
 20   continue


      do i = 1, num_gauges
        if (mbestsrc(i) .eq. 0) &
            write(6,*)"ERROR in setting grid src for gauge data",i
      end do

!     Sort the source arrays for easy testing during integration
      call qsorti(mbestorder,num_gauges,mbestsrc)

!     After sorting,  
!           mbestsrc(mbestorder(i)) = grid index to be used for gauge i
!     and mbestsrc(mbestorder(i)) is non-decreasing as i=1,2,..., num_gauges

!     write(6,*) '+++ mbestorder: ',mbestorder
!     write(6,*) '+++ mbestsrc: ',mbestsrc

!     Figure out the set of gauges that should be handled on each grid:  
!     after loop below, grid k should handle gauges numbered
!          mbestorder(i) for i = mbestg1(k), mbestg1(k)+1, ..., mbestg2(k)
!     This will be used for looping in print_gauges subroutine.

      ! initialize arrays to default indicating grids that contain no gauges:
      mbestg1 = 0
      mbestg2 = 0

      k1 = 0
      do i=1,num_gauges
          ki = mbestsrc(mbestorder(i))
          if (ki > k1) then
              ! new grid number seen for first time in list
              if (k1 > 0) then
                  ! mark end of gauges seen by previous grid
                  mbestg2(k1) = i-1
!                 write(6,*) '+++ k1, mbestg2(k1): ',k1,mbestg2(k1)
                  endif
              mbestg1(ki) = i
!             write(6,*) '+++ ki, mbestg1(ki): ',ki,mbestg1(ki)
              endif
          k1 = ki
          enddo
      if (num_gauges > 0) then
          ! finalize 
          mbestg2(ki) = num_gauges
!         write(6,*) '+++ ki, mbestg2(ki): ',ki,mbestg2(ki)
          endif


      end subroutine setbestsrc

!
! -------------------------------------------------------------------------
!
      subroutine update_gauges(q,aux,xlow,nvar,mitot,naux,mptr)
!
!     This routine is called each time step for each grid patch, to output
!     gauge values for all gauges for which this patch is the best one to 
!     use (i.e. at the finest refinement level).  

!     It is called after ghost cells have been filled from adjacent grids
!     at the same level, so bilinear interpolation can be used to 
!     to compute values at any gauge location that is covered by this grid.  

!     The grid patch is designated by mptr.
!     We only want to set gauges i for which mbestsrc(i) == mptr.
!     The array mbestsrc is reset after each regridding to indicate which
!     grid patch is best to use for each gauge.

!     This is a refactoring of dumpgauge.f from Clawpack 5.2 
!     Loops over only the gauges to be handled by this grid, as specified
!     by indices from mbestg1(mptr) to mbestg2(mptr)

      use amr_module

      implicit none

      real(kind=8), intent(in) ::  xlow
      integer, intent(in) ::  nvar,mitot,naux,mptr
      real(kind=8), intent(in) ::  q(nvar,mitot)
      real(kind=8), intent(in) ::  aux(naux,mitot)

      ! local variables:
      real(kind=8) :: var(maxvar)
      real(kind=8) :: xcent,xoff,tgrid,hx
      integer :: level,i,iindex,ivar, ii,i1,i2
      integer :: nindex

!     write(*,*) '+++ in print_gauges with num_gauges, mptr = ',num_gauges,mptr

      if (num_gauges == 0) then
         return
      endif

      i1 = mbestg1(mptr)
      i2 = mbestg2(mptr)

      if (i1 == 0) then
         ! no gauges to be handled by this grid
         return
      endif

!     write(6,*) '+++ mbestg1(mptr) = ',mbestg1(mptr)
!     write(6,*) '+++ mbestg2(mptr) = ',mbestg2(mptr)

!     # this stuff the same for all gauges on this grid
      tgrid = rnode(timemult,mptr)
      level = node(nestlevel,mptr)
      hx    =  hxposs(level)

!     write(*,*) 'tgrid = ',tgrid

      do 10 i = i1,i2
        ii = mbestorder(i)
!       write(6,*) '+++ gauge ', ii
        if (mptr .ne. mbestsrc(ii)) then !!! go to 10  ! this patch not used
            write(6,*) '*** should not happen... i, ii, mbestsrc(ii), mptr:'
            write(6,*) i, ii, mbestsrc(ii), mptr
            stop
            endif
        if (tgrid.lt.t1gauge(ii) .or. tgrid.gt.t2gauge(ii)) then
!          # don't output at this time for gauge i
           go to 10
           endif
!
!    ## if we did not skip to line 10, we need to output gauge i:
!    ## prepare to do bilinear interp at gauge location to get vars
!
!    *** Note: changed 0.5 to  0.5d0 etc. ****************************
!
!       write(6,*) '+++ interploting for gauge ', ii
        iindex =  int(.5d0 + (xgauge(ii)-xlow)/hx)
        if (iindex .lt. nghost .or. iindex .gt. mitot-nghost) &
          write(*,*)"ERROR in output of Gauge Data "
        xcent  = xlow + (iindex-.5d0)*hx
        xoff   = (xgauge(ii)-xcent)/hx
!   IF WANT TO INCLUDE THIS TEST< MODIFY FOR ROUNDOFF LEVEL DIFF
!       if (xoff .lt. 0.d0 .or. xoff .gt. 1.d0) then
!          write(6,*)" BIG PROBLEM in DUMPGAUGE", i
!       endif

!       ## linear interpolation
        do ivar = 1, nvar
           var(ivar) = (1.d0-xoff)*q(ivar,iindex) &
                   + xoff*q(ivar,iindex+1)
!          # for printing without underflow of exponent:
           if (abs(var(ivar)) .lt. 1.d-90) var(ivar) = 0.d0
        end do

       ! save info for this time
        nindex = nextLoc(ii)
 
        levelArray(nindex,ii) = level
        gaugeArray(1,nindex,ii) = tgrid
        do ivar = 1, nvar
           gaugeArray(1+ivar,nindex,ii) = var(ivar)
        end do
        
        nextLoc(ii) = nextLoc(ii) + 1
        if (nextLoc(ii) .gt. MAXDATA) then
          call print_gauges_and_reset_nextLoc(ii,nvar)  
        endif
 10     continue  ! end of loop over all gauges
 
      end subroutine update_gauges
!
! -------------------------------------------------------------------------
!
      subroutine print_gauges_and_reset_nextLoc(gaugeNum,nvar)
!
!    Array of gauge data for this gauge reached max capacity
!    print to file.

      implicit none
      integer :: gaugeNum,nvar,j,inum,k,idigit,ipos,myunit
      integer :: omp_get_thread_num, mythread
      character(len=24) :: fileName
      character(len=15) :: numstr

      ! open file for gauge gaugeNum, figure out name
      ! not writing gauge number since it is in file name now
      ! status is old, since file name and info written for
      ! each file in in set_gauges.
      !
      ! NB: output written in different order, losing backward compatibility


      inum = igauge(gaugeNum)
      ! convert inum to string numstr with zero padding if <5 digits
      ! since we want format gauge00012.txt or gauge1234567.txt:
      write (numstr,'(I0.5)') inum
      fileName = 'gauge'//trim(numstr)//'.txt'


      mythread = 0
!$    mythread = omp_get_thread_num()
      myunit = OUTGAUGEUNIT+mythread

!     add thread number of outgaugeunit to make a unique unit number.
!     ok since writing to a unique file. in serial, still using only IOUTGAUGEUNIT
      open(unit=myunit, file=fileName, status='old',    &
           position='append', form='formatted')
      
      ! called either because array is full (write MAXDATA amount of gauge data)
      ! or checkpoint time, so write whatever is in array and reset.
      ! nextLoc has already been increment before this subr. called
      do j = 1, nextLoc(gaugeNum)-1
        write(myunit,100) levelArray(j,gaugeNum),      &
                          (gaugeArray(k,j,gaugeNum),k=1,nvar+1) ! includes time
      end do
      nextLoc(gaugeNum) = 1                        

      ! if you want to modify number of digits printed, modify this...
100     format(i5.2, 10e15.7)

      ! close file
      close(myunit)

      end subroutine print_gauges_and_reset_nextLoc

end module gauges_module

!     ==========================================================
    subroutine step2ds(maxm,num_eqn,num_waves,num_aux,num_ghost,mx,my, &
                        qold,qnew,aux,dx,dy,dt,method,mthlim,cfl, &
                        qadd,fadd,gadd,q1d,dtdx1d,dtdy1d, &
                        aux1,aux2,aux3,work,mwork,ids,use_fwave,rpn2,rpt2)
!     ==========================================================

!     # Take one time step, updating q.
!     # On entry, qold and qnew should be identical and give the
!     #    initial data for this step
!     # On exit, qnew returns values at the end of the time step.
!     #    qold is unchanged.

!     # qadd is used to return increments to q from flux2
!     # fadd and gadd are used to return flux increments from flux2.
!     # See the flux2 documentation for more information.


    implicit double precision (a-h,o-z)
    double precision :: qold(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost)
    double precision :: qnew(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost)
    double precision ::  q1d(num_eqn, 1-num_ghost:maxm+num_ghost)
    double precision :: qadd(num_eqn, 1-num_ghost:maxm+num_ghost)
    double precision :: fadd(num_eqn, 1-num_ghost:maxm+num_ghost)
    double precision :: gadd(num_eqn, 2, 1-num_ghost:maxm+num_ghost)
    double precision :: aux(num_aux, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost)
    double precision :: aux1(num_aux, 1-num_ghost:maxm+num_ghost)
    double precision :: aux2(num_aux, 1-num_ghost:maxm+num_ghost)
    double precision :: aux3(num_aux, 1-num_ghost:maxm+num_ghost)

    double precision :: dtdx1d(1-num_ghost:maxm+num_ghost)
    double precision :: dtdy1d(1-num_ghost:maxm+num_ghost)
    integer :: method(7),mthlim(num_waves)
    logical ::          use_fwave
    double precision :: work(mwork)
    external :: rpn2,rpt2

    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom

!f2py intent(out) cfl
!f2py intent(in,out) qnew
!f2py optional q1d, qadd, fadd, gadd, dtdx1d, dtdy1d

! Dummy interfaces just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn2(x)
!f2py x=rpt2(x)

!     # partition work array into pieces needed for local storage in
!     # flux2 routine.  Find starting index of each piece:

    i0wave = 1
    i0s = i0wave + (maxm+2*num_ghost)*num_eqn*num_waves
    i0amdq = i0s + (maxm+2*num_ghost)*num_waves
    i0apdq = i0amdq + (maxm+2*num_ghost)*num_eqn
    i0cqxx = i0apdq + (maxm+2*num_ghost)*num_eqn
    i0bmadq = i0cqxx + (maxm+2*num_ghost)*num_eqn
    i0bpadq = i0bmadq + (maxm+2*num_ghost)*num_eqn
    iused = i0bpadq + (maxm+2*num_ghost)*num_eqn - 1

    if (iused > mwork) then
    !        # This shouldn't happen due to checks in claw2
        write(6,*) '*** not enough work space in step2'
        write(6,*) '*** iused = ', iused, '   mwork =',mwork
        stop
    endif


    index_capa = method(6)
    num_aux = method(7)
    cfl = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy

    if (index_capa == 0) then
    !        # no capa array:
        do i=1-num_ghost,maxm+num_ghost
            dtdx1d(i) = dtdx
            dtdy1d(i) = dtdy
        end do
    endif

    if( ids == 1 )then
    
    !     # perform x-sweeps
    !     ==================
    
    !     # note that for dimensional splitting we sweep over the rows of
    !     # ghosts cells as well as the interior.  This updates the ghost
    !     # cell values to the intermediate state as needed in the following
    !     # sweep in the y-direction.
    
        do j = 1-num_ghost,my+num_ghost
        
        !        # copy data along a slice into 1d arrays:
            do i = 1 - num_ghost, mx+num_ghost
                do m = 1, num_eqn
                    q1d(m,i) = qold(m,i,j)
                end do
            end do
        
            if (index_capa > 0)  then
                do i = 1-num_ghost, mx+num_ghost
                    dtdx1d(i) = dtdx / aux(index_capa,i,j)
                end do
            endif
        
            if (num_aux > 0)  then
                do i = 1-num_ghost, mx+num_ghost
                    do ma=1,num_aux
                        aux2(ma,i) = aux(ma,i,j)
                    end do
                end do
            
                if(j /= 1-num_ghost)then
                    do i = 1-num_ghost, mx+num_ghost
                        do ma=1,num_aux
                            aux1(ma,i) = aux(ma,i,j-1)
                        end do
                    end do
                endif
            
                if(j /= my+num_ghost)then
                    do i = 1-num_ghost, mx+num_ghost
                        do ma=1,num_aux
                            aux3(ma,i) = aux(ma,i,j+1)
                        end do
                    end do
                endif
            
            endif
        
        !        # Store the value of j along this slice in the common block
        !        # comxyt in case it is needed in the Riemann solver (for
        !        # variable coefficient problems)
            jcom = j
        
        !        # compute modifications fadd and gadd to fluxes along this slice:
            call flux2(1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
            q1d,dtdx1d,aux1,aux2,aux3,method,mthlim, &
            qadd,fadd,gadd,cfl1d, &
            work(i0wave),work(i0s),work(i0amdq),work(i0apdq), &
            work(i0cqxx),work(i0bmadq),work(i0bpadq),rpn2,rpt2, &
            use_fwave)
            cfl = dmax1(cfl,cfl1d)
        
        !        # update qnew by flux differencing.
        !        # (rather than maintaining arrays f and g for the total fluxes,
        !        # the modifications are used immediately to update qnew
        !        # in order to save storage.)
        
            if (index_capa == 0) then
            
            !            # no capa array.  Standard flux differencing:
                do i = 1, mx
                    do m = 1, num_eqn
                        qnew(m,i,j) = qnew(m,i,j) + qadd(m,i) &
                            - dtdx * (fadd(m,i+1) - fadd(m,i))
                    end do
                end do
            
            else
            
            !            # with capa array.
                do i = 1, mx
                    do m = 1, num_eqn
                        qnew(m,i,j) = qnew(m,i,j) + qadd(m,i) &
                            - dtdx * (fadd(m,i+1) - fadd(m,i)) &
                            / aux(index_capa,i,j)
                    end do
                end do
            endif
        end do    ! End x sweeps
    
    endif

    if( ids == 2 )then
    
    !     # perform y sweeps
    !     ==================
    
    
        do i = 1-num_ghost, mx+num_ghost
        
        !        # copy data along a slice into 1d arrays:
            do j = 1-num_ghost, my+num_ghost
                do m = 1, num_eqn
                    q1d(m,j) = qold(m,i,j)
                end do
            end do
        
            if (index_capa > 0)  then
                do j = 1-num_ghost, my+num_ghost
                    dtdy1d(j) = dtdy / aux(index_capa,i,j)
                end do
            endif
        
            if (num_aux > 0)  then
            
                do j = 1-num_ghost, my+num_ghost
                    do ma=1,num_aux
                        aux2(ma,j) = aux(ma,i,j)
                    end do
                end do
            
                if(i /= 1-num_ghost)then
                    do j = 1-num_ghost, my+num_ghost
                        do ma=1,num_aux
                            aux1(ma,j) = aux(ma,i-1,j)
                        end do
                    end do
                endif
            
                if(i /= mx+num_ghost)then
                    do j = 1-num_ghost, my+num_ghost
                        do ma=1,num_aux
                            aux3(ma,j) = aux(ma,i+1,j)
                        end do
                    end do
                endif
            
            endif
        
        !     # Store the value of i along this slice in the common block
        !        # comxyt in case it is needed in the Riemann solver (for
        !        # variable coefficient problems)
            icom = i
        
        !        # compute modifications fadd and gadd to fluxes along this slice:
            call flux2(2,maxm,num_eqn,num_waves,num_aux,num_ghost,my, &
            q1d,dtdy1d,aux1,aux2,aux3,method,mthlim, &
            qadd,fadd,gadd,cfl1d, &
            work(i0wave),work(i0s),work(i0amdq),work(i0apdq), &
            work(i0cqxx),work(i0bmadq),work(i0bpadq),rpn2,rpt2, &
            use_fwave)
        
            cfl = dmax1(cfl,cfl1d)
        
        !        # update qnew by flux differencing.
        !        # Note that the roles of fadd and gadd are reversed for
        !        # the y-sweeps -- fadd is the modification to g-fluxes and
        !        # gadd is the modification to f-fluxes to the left and right.
        
            if (index_capa == 0) then
            
            !            # no capa array.  Standard flux differencing:
                do j = 1, my
                    do m = 1, num_eqn
                        qnew(m,i,j) = qnew(m,i,j) + qadd(m,j) &
                            - dtdy * (fadd(m,j+1) - fadd(m,j))
                    end do
                end do

            else
            
            !            # with capa array.
                do j = 1, my
                    do m = 1, num_eqn
                        qnew(m,i,j) = qnew(m,i,j) + qadd(m,j) &
                            - dtdy * (fadd(m,j+1) - fadd(m,j)) &
                            / aux(index_capa,i,j)
                    end do
                end do

            endif
        end do    ! End y sweeps
    
    endif


    return
    end subroutine step2ds

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
    implicit double precision (a-h,o-z)

!     # Dummy transverse Riemann solver, for use in dimensionally-split algorithm.

    write(*,*) 'Error: Dummy transverse Riemann solver called!'
    return
    end subroutine rpt2

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! Roe-solver for the 2D shallow water equations
!  on the sphere, using 3d Cartesian representation of velocities

! waves: 3
! equations: 4
! aux fields: 16

! Conserved quantities:
!       1 depth
!       2 x_momentum
!       3 y_momentum
!       4 z_momentum

! Auxiliary variables:
!         1  kappa
!         2  enx
!         3  eny
!         4  enz
!         5  etx
!         6  ety
!         7  etz
!         8  enx
!         9  eny
!        10  enz
!        11  etx
!        12  ety
!        13  etz
!        14  erx
!        15  ery
!        16  erz

! solve Riemann problems along one slice of data.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.
! On output, wave contains the waves, s the speeds,
! and amdq, apdq the decomposition of the flux difference
!   f(qr(i-1)) - f(ql(i))
! into leftgoing and rightgoing parts respectively.
! With the Roe solver we have
!    amdq  =  A^- \Delta q    and    apdq  =  A^+ \Delta q
! where A is the Roe matrix.  An entropy fix can also be incorporated
! into the flux differences.

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit double precision (a-h,o-z)

    dimension wave(meqn, mwaves,1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension  apdq(meqn, 1-mbc:maxm+mbc)
    dimension  amdq(meqn, 1-mbc:maxm+mbc)
    dimension auxl(maux, 1-mbc:maxm+mbc)
    dimension auxr(maux, 1-mbc:maxm+mbc)

!     local arrays
!     ------------
    dimension delta(3)
    logical :: efix

    parameter (maxm2 = 1800)
    common /sw/  g
    dimension u(1-mbc:maxm+mbc),v(1-mbc:maxm+mbc),a(1-mbc:maxm+mbc), &
    h(1-mbc:maxm+mbc)
    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom

    data efix /.true./    !# use entropy fix for transonic rarefactions

    if(ixy == 1) then
        dy = dycom
    else
        dy = dxcom
    endif

!     The aux array has the following elements:
!         1  kappa = ratio of cell area to dxc*dyc
!         2  enx = x-component of normal vector to left edge in tangent plane
!         3  eny = y-component of normal vector to left edge in tangent plane
!         4  enz = z-component of normal vector to left edge in tangent plane
!         5  etx = x-component of tangent vector to left edge in tangent plane
!         6  ety = y-component of tangent vector to left edge in tangent plane
!         7  etz = z-component of tangent vector to left edge in tangent plane
!         8  enx = x-component of normal vector to bottom edge in tangent plane
!         9  eny = y-component of normal vector to bottom edge in tangent plane
!        10  enz = z-component of normal vector to bottom edge in tangent plane
!        11  etx = x-component of tangent vector to bottom edge in tangent plane
!        12  ety = y-component of tangent vector to bottom edge in tangent plane
!        13  etz = z-component of tangent vector to bottom edge in tangent plane
!        14  erx = x-component of unit vector in radial direction at cell ctr
!        15  ery = y-component of unit vector in radial direction at cell ctr
!        16  erz = z-component of unit vector in radial direction at cell ctr

!     # offset to index into aux array for enx, eny, etx, ety, gamma
!     #    depends on whether ixy=1 (left edge) or ixy=2 (bottom edge).
    ioff = 6*(ixy-1) + 1


!     # find a1 thru a3, the coefficients of the 3 eigenvectors:

    do 20 i = 2-mbc, mx+mbc

        enx =   auxl(ioff+1,i)
        eny =   auxl(ioff+2,i)
        enz =   auxl(ioff+3,i)
        etx =   auxl(ioff+4,i)
        ety =   auxl(ioff+5,i)
        etz =   auxl(ioff+6,i)
        gamma = dsqrt(etx**2 + ety**2 + etz**2)
        etx =   etx / gamma
        ety =   ety / gamma
        etz =   etz / gamma


    !        # compute normal and tangential momentum at cell edge:
        hunl = enx*ql(2,i) + eny*ql(3,i) + enz*ql(4,i)
        hunr = enx*qr(2,i-1) + eny*qr(3,i-1) + enz*qr(4,i-1)

        hutl = etx*ql(2,i) + ety*ql(3,i) + etz*ql(4,i)
        hutr = etx*qr(2,i-1) + ety*qr(3,i-1) + etz*qr(4,i-1)

    !        # compute the Roe-averaged variables needed in the Roe solver.
    !        # These are stored in the common block comroe since they are
    !        # later used in routine rpt2 to do the transverse wave splitting.
    
        hl = ql(1,i)
        hr = qr(1,i-1)
        h(i) = (hl+hr)*0.50d0
        hsqr = dsqrt(hr)
        hsql = dsqrt(hl)
        hsq = hsqr + hsql
        u(i) = (hunr/hsqr + hunl/hsql) / hsq
        v(i) = (hutr/hsqr + hutl/hsql) / hsq
        a(i) = dsqrt(g*h(i))

    !        # Split the jump in q at each interface into waves
        delta(1) = hl - hr
        delta(2) = hunl - hunr
        delta(3) = hutl - hutr

        a1 = ((u(i)+a(i))*delta(1) - delta(2))*(0.50d0/a(i))
        a2 = -v(i)*delta(1) + delta(3)
        a3 = (-(u(i)-a(i))*delta(1) + delta(2))*(0.50d0/a(i))

    
    !        # Compute the waves.
    
        wave(1,1,i) = a1
        wave(2,1,i) = a1*(u(i)-a(i))*enx + a1*v(i)*etx
        wave(3,1,i) = a1*(u(i)-a(i))*eny + a1*v(i)*ety
        wave(4,1,i) = a1*(u(i)-a(i))*enz + a1*v(i)*etz
        s(1,i) = (u(i)-a(i)) * gamma/dy
    
        wave(1,2,i) = 0.0d0
        wave(2,2,i) = a2*etx
        wave(3,2,i) = a2*ety
        wave(4,2,i) = a2*etz
        s(2,i) = u(i) * gamma/dy
    
        wave(1,3,i) = a3
        wave(2,3,i) = a3*(u(i)+a(i))*enx + a3*v(i)*etx
        wave(3,3,i) = a3*(u(i)+a(i))*eny + a3*v(i)*ety
        wave(4,3,i) = a3*(u(i)+a(i))*enz + a3*v(i)*etz
        s(3,i) = (u(i)+a(i)) * gamma/dy
        281 format(2i4,5d12.4)
        283 format(8x,5d12.4)
    20 END DO


!    # compute flux differences amdq and apdq.
!    ---------------------------------------

    if (efix) go to 110

!     # no entropy fix
!     ----------------

!     # amdq = SUM s*wave   over left-going waves
!     # apdq = SUM s*wave   over right-going waves

    do m=1,meqn
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1,mwaves
                if (s(mw,i) < 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                else
                    apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                endif
            end do
        end do
    end do

!     # project momentum components of amdq and apdq onto tangent plane:

    do i=2-mbc,mx+mbc
        erx = auxr(14,i-1)
        ery = auxr(15,i-1)
        erz = auxr(16,i-1)
        amn = erx*amdq(2,i) + ery*amdq(3,i) + erz*amdq(4,i)
        amdq(2,i) = amdq(2,i) - amn*erx
        amdq(3,i) = amdq(3,i) - amn*ery
        amdq(4,i) = amdq(4,i) - amn*erz

        erx = auxl(14,i)
        ery = auxl(15,i)
        erz = auxl(16,i)
        apn = erx*apdq(2,i) + ery*apdq(3,i) + erz*apdq(4,i)
        apdq(2,i) = apdq(2,i) - apn*erx
        apdq(3,i) = apdq(3,i) - apn*ery
        apdq(4,i) = apdq(4,i) - apn*erz
    enddo
    go to 900

!-----------------------------------------------------

    110 continue

!     # With entropy fix
!     ------------------

!    # compute flux differences amdq and apdq.
!    # First compute amdq as sum of s*wave for left going waves.
!    # Incorporate entropy fix by adding a modified fraction of wave
!    # if s should change sign.

    do 200 i=2-mbc,mx+mbc
        do m=1, meqn
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
        enddo
        enx =   auxl(ioff+1,i)
        eny =   auxl(ioff+2,i)
        enz =   auxl(ioff+3,i)
        etx =   auxl(ioff+4,i)
        ety =   auxl(ioff+5,i)
        etz =   auxl(ioff+6,i)
        gamma = dsqrt(etx**2 + ety**2 + etz**2)
        etx =   etx / gamma
        ety =   ety / gamma
        etz =   etz / gamma
    !           # compute normal and tangential momentum at cell edge:
        hunl = enx*ql(2,i) + eny*ql(3,i) + enz*ql(4,i)
        hunr = enx*qr(2,i-1) + eny*qr(3,i-1) + enz*qr(4,i-1)

    !           check 1-wave
        him1 = qr(1,i-1)
        s0 =  (hunr/him1 - dsqrt(g*him1)) * gamma / dy
    !           check for fully supersonic case :
        if (s0 > 0.0d0 .AND. s(1,i) > 0.0d0) then
            do 60 m=1,4
                amdq(m,i)=0.0d0
            60 END DO
            goto 200
        endif
    
        h1 = qr(1,i-1)+wave(1,1,i)
        hu1= hunr + enx*wave(2,1,i) + eny*wave(3,1,i) &
        + enz*wave(4,1,i)
        s1 = (hu1/h1 - dsqrt(g*h1))*gamma/dy  !speed just to right of 1-wave
        if (s0 < 0.0d0 .AND. s1 > 0.0d0) then
        !              transonic rarefaction in 1-wave
            sfract = s0*((s1-s(1,i))/(s1-s0))
        else if (s(1,i) < 0.0d0) then
        !              1-wave is leftgoing
            sfract = s(1,i)
        else
        !              1-wave is rightgoing
            sfract = 0.0d0
        endif
        do 120 m=1,4
            amdq(m,i) = sfract*wave(m,1,i)
        120 END DO
    !           check 2-wave
        if (s(2,i) > 0.0d0) then
        !	       #2 and 3 waves are right-going
            go to 200
        endif

        do 140 m=1,4
            amdq(m,i) = amdq(m,i) + s(2,i)*wave(m,2,i)
        140 END DO
    
    !           check 3-wave
    
        hi = ql(1,i)
        s03 = (hunl/hi + dsqrt(g*hi)) * gamma/dy
        h3=ql(1,i)-wave(1,3,i)
        hu3=hunl-(enx*wave(2,3,i)+eny*wave(3,3,i)+enz*wave(4,3,i))
        s3=(hu3/h3 + dsqrt(g*h3)) * gamma/dy
        if (s3 < 0.0d0 .AND. s03 > 0.0d0) then
        !              transonic rarefaction in 3-wave
            sfract = s3*((s03-s(3,i))/(s03-s3))
        else if (s(3,i) < 0.0d0) then
        !              3-wave is leftgoing
            sfract = s(3,i)
        else
        !              3-wave is rightgoing
            goto 200
        endif
        do 160 m=1,4
            amdq(m,i) = amdq(m,i) + sfract*wave(m,3,i)
        160 END DO
    200 END DO

!           compute rightgoing flux differences :

    do 220 i = 2-mbc,mx+mbc
        do 222 m=1,4
            df = 0.0d0
            do 210 mw=1,mwaves
                df = df + s(mw,i)*wave(m,mw,i)
            210 END DO
            apdq(m,i)=df - amdq(m,i)
        222 END DO
    
    !                 project momentum components onto tangent plane
    
        erx = auxr(14,i-1)
        ery = auxr(15,i-1)
        erz = auxr(16,i-1)
        amn = erx*amdq(2,i)+ery*amdq(3,i)+erz*amdq(4,i)
        amdq(2,i) = amdq(2,i) - amn*erx
        amdq(3,i) = amdq(3,i) - amn*ery
        amdq(4,i) = amdq(4,i) - amn*erz

        erx = auxl(14,i)
        ery = auxl(15,i)
        erz = auxl(16,i)
        apn = erx*apdq(2,i)+ery*apdq(3,i)+erz*apdq(4,i)
        apdq(2,i) = apdq(2,i) - apn*erx
        apdq(3,i) = apdq(3,i) - apn*ery
        apdq(4,i) = apdq(4,i) - apn*erz

    220 END DO


    900 continue
    return
    end subroutine rpn2

!     # Riemann solver in the transverse direction for the advection equation.

! =====================================================
subroutine rpt2_ptwise(ixy, imp, num_eqn, num_aux, num_waves, q_l, q_r,      &
aux_l, aux_r, asdq, bmasdq, bpasdq)
! =====================================================

    implicit none

    ! Input
    integer, intent(in) :: num_eqn, num_aux, num_waves, ixy, imp
    real(kind=8), intent(in) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in) :: aux_l(num_aux, 3), aux_r(num_aux, 3)
    real(kind=8), intent(in out) :: asdq(num_eqn)

    ! Output
    real(kind=8), intent(in out) :: bmasdq(num_eqn), bpasdq(num_eqn)

    ! Local
    real(kind=8) :: aux(num_aux, 3)
    integer :: kv

    kv = 3-ixy  !#  = 1 if ixy=2  or  = 2 if ixy=1

    !#  =  i-1 for amdq,  i for apdq
    if (ixy == 1) then
        aux = aux_l
    else
        aux = aux_r
    endif

    bmasdq(1) = dmin1(aux(kv,2), 0.d0) * asdq(1)
    bpasdq(1) = dmax1(aux(kv,3), 0.d0) * asdq(1)

    return
    end subroutine rpt2_ptwise

! ============================================================================
!  Program:     AMRClaw
!  File:        init_alloc.f90
!  Created:     2009-01-21
!  Author:      Kyle Mandli and Marsha Berger
! ============================================================================
!  Description:  Initialization of alloc storage
! ============================================================================


subroutine init_alloc()

    ! new way, use allocatable arrays, not pointers
    
    use amr_module
    implicit none
    
    if (.not.allocated(alloc)) then
        !memsize = 1000000  # Now read in from amr.data by amr1.f90
        allocate(alloc(memsize))
        print *, "Storage allocated..."
    else
        print *, "Storage already allocated!"
    endif
    
end subroutine init_alloc

! ============================================================================
!  Program:     AMRClaw
!  File:        restrt_alloc.f90
!  Created:     2009-10-22
!  Author:      Marsha Berger and Randy LeVeque
! ============================================================================
!  Description:  Initialization of alloc storage for restart
! ============================================================================


       subroutine restrt_alloc(isize)
   
       use amr_module
       implicit none
       integer :: isize
   
!      if (.not.allocated(storage)) then  !old way, changed mjb Jan.  !      2015
       if (.not.allocated(alloc)) then    ! new way uses allocatable,  not pointer, arrays
           write(6,*)"allocating ",isize," -sized alloc array"
           memsize = isize
!          allocate(storage(memsize))
           allocate(alloc(memsize))
!          alloc => storage
           print *, "Storage allocated of size ",memsize," at restart"
       else
           print *, "Storage already allocated!"
       endif
   
       end subroutine restrt_alloc

subroutine buildSparseMatrixSGNcoo(q,qold,aux,soln,rhs,                    &
                                     minfo_matrix_ia,minfo_matrix_ja,minfo_matrix_sa, &
                                     numBoussCells,levelBouss,                        &
                                     mptr,nx,ny,nvar,naux,                    &
                                     matrix_rhs1_max,matrix_rhs2_max)

    
    use amr_module
    use geoclaw_module, only: earth_radius, deg2rad, coordinate_system, grav
    use geoclaw_module, only: sea_level, dry_tolerance
    use bouss_module
        
    implicit none
    
    integer, intent(in) :: nvar, naux, levelBouss, numBoussCells
    
    !! pass in numBoussCells for this level so can dimension these arrays
    real(kind=8) :: soln(0:2*numBoussCells), rhs(0:2*numBoussCells) 
    
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: i,j,nng,nb,nelt,levSt,nx,ny,loc,locaux,mptr
    integer :: mitot, mjtot, neltSt, neltBegin
    integer :: jst, jend, ivar
    
    real(kind=8) :: q(nvar,1-nghost:nx+nghost,1-nghost:ny+nghost)
    real(kind=8) :: qold(nvar,1-nghost:nx+nghost,1-nghost:ny+nghost)
    real(kind=8) :: aux(naux,1-nghost:nx+nghost,1-nghost:ny+nghost)

    real(kind=8), dimension(0:nx+1,0:ny+1) :: Bxx, Byy, Bx, By, Bxy
    real(kind=8), dimension(0:nx+1,0:ny+1) :: phi, eta, w
    real(kind=8) :: etax, etay, hx,hy, wx,wy

    integer :: nD
    integer :: k, k_ij, k_imj, k_ipj, k_ijm, k_ijp 
    integer :: m,n
    integer :: k_imjp, k_imjm, k_ipjm, k_ipjp
    integer :: kh_ij, kh_imj, kh_ipj, kh_ijm, kh_ijp
    integer :: kh_imjp, kh_imjm, kh_ipjm, kh_ipjp, khu_ij, khv_ij

    real(kind=8) :: h_ij
    real(kind=8) :: dx, dy, dxm, dym, dxdx, dydy, dxdy4
    
    integer :: nelt_ij, nelt_ij_nD
    real(kind=8) :: sa, huc, hvc, matrix_rhs1_max, matrix_rhs2_max
    integer :: ja, bc, c
    real(kind=8) :: b_min, b_max
    integer :: minfo_matrix_ia(24*numBoussCells)
    integer :: minfo_matrix_ja(24*numBoussCells)
    real(kind=8) :: minfo_matrix_sa(24*numBoussCells)
    real(kind=8) :: u(1-nghost:nx+nghost,1-nghost:ny+nghost), v(1-nghost:nx+nghost,1-nghost:ny+nghost) 
    real(kind=8) :: phix, phiy

    logical :: debug
    logical :: yhi_db, ylo_db, xlo_db, xhi_db
    logical :: allzero

    
    ! bc_xlo, bc_ylo, bc_xhi, bc_yhi are set in bouss_module.
    !     0 means Dirchlet value 0 (no correction at each of union of patches)
    !     1 means Neumann (correction in first interior cell = in ghost cell)
    !     2 means use ghost cell values in q(4:5,:,:) as Dirichlet BCs
    !             Multiply by matrix element and move to RHS
    !             Requires nvar==5.
    

#ifdef WHERE_AM_I
  write(*,*) "starting buildSparseMatrixSGNcoo"
#endif
    
    debug = .false.
    !debug = .true.
    
    minfo => matrix_info_allLevs(levelBouss)

    !write(31,*)"Start of buildSparseMatrixSGNcoo for grid ",mptr
    !write(*,*)"Start of buildSparseMatrixSGNcoo for grid ",mptr
    mitot = nx + 2*nghost
    mjtot = ny + 2*nghost
    !call symcheck2(q,mitot,mjtot)


!
! ================== Step 2  set up for matrix elements  ======================
    
    ! Set up matrix A and RHS by looping over all Bouss patches:

       if (debug) then
         write(19,*)"Level ",levelBouss," grid ",mptr," at start of buildSparseMatrixSGNcoo"
         do j = 1-nghost, ny+nghost
         do i = 1-nghost, nx+nghost
           write(19,900)i,j,(q(m,i,j),m=1,nvar)
 900       format(2i5,5e15.7)
         end do
         end do
       endif
    
    dx = hxposs(levelBouss)
    dy = hyposs(levelBouss)
    
     
    if (coordinate_system .eq. 2) then
      ! convert from dy in degrees to meters:
      dym = dy * earth_radius * deg2rad
      ! dxm depends on latitude, done in loops below instead of here
    else
      dym = dy
    endif
    
    dydy = dym**2
    nD = numBoussCells   ! shorthand for size of matrix blocks D1 to D4
    nelt = minfo%matrix_nelt  ! some number of matrix elements already added, 
    neltBegin = nelt  ! this is where this grid started
              
        
        ! set booleans indicating whether each patch edge is a Domain Boundary:
        !call setDomainBndries(mptr,yhi_db,ylo_db,xlo_db,xhi_db)
        xlo_db = (node(ndilo,mptr) .eq. 0)
        xhi_db = (node(ndihi,mptr) .eq. (iregsz(levelBouss)-1))
        ylo_db = (node(ndjlo,mptr) .eq. 0)
        yhi_db = (node(ndjhi,mptr) .eq. (jregsz(levelBouss)-1))
    

        
        ! Get integer array providing matrix indices mapping 
        ! cell coordinates i,j to location k in vector of all unknowns: 
           
        nb = node(bpatchNum,mptr)
        mi => minfo%matrix_indices(nb)  ! integer array for this patch

        ! temp arrays needed for this patch:
        ! provide one layer of ghost cells needed when computing
        ! second differences of these quantities, but values in ghost
        ! cells are never actually needed since second diff's won't be
        ! needed in first row of interior cells
        
        ! First loop over all cells (i,j), one row of ghost cells,
        ! computing s1, s2, h0etax, h0etay,
        ! quantities that involve first derivatives.  In the second loop
        ! over all cells below we will compute matrix_rhs using second
        ! differences of these quantities.
        
        ! compute eta used below in update
        ! Remember that ETA not same size as Q
         eta(:,:) = q(1,0:nx+1,0:ny+1) +   &
                  aux(1,0:nx+1,0:ny+1)

         ! will have to FIX for h = 0? Hopefully not that close to 0
         !u(:,:) = q(2,:,:) / q(1,:,:)
         !v(:,:) = q(3,:,:) / q(1,:,:)
         !where (q(1,:,:) /= 0.d0)
         where (abs(q(1,:,:)) > dry_tolerance)
           u(:,:) = q(2,:,:) / q(1,:,:)
           v(:,:) = q(3,:,:) / q(1,:,:)
         elsewhere
           u(:,:) = 0.d0
           v(:,:) = 0.d0
         end where


         do j=0,ny+1 
            if (coordinate_system .eq. 2) then
              ! aux(3,i,j) is latitude, doesn't depend on i so use i=1
              dxm = dx * earth_radius * deg2rad * cos(aux(3,1,j))
            else
              dxm = dx
            endif
            dxdx = dxm**2
            dxdy4 = 4.d0*dxm*dym
            
            ! compute phi. rest will now be computed ! in second loop
            do i=0,nx+1
              
               phi(i,j) = ((v(i+1,j)-v(i-1,j))*(u(i,j+1)-u(i,j-1)) -      &
                          (u(i+1,j)-u(i-1,j))*(v(i,j+1)-v(i,j-1)))/dxdy4  &
                          + ((u(i+1,j)-u(i-1,j))/(2.d0*dxm)               &
                          +  (v(i,j+1)-v(i,j-1))/(2.d0*dym))**2
               Bx(i,j) = (aux(1,i+1,j) - aux(1,i-1,j))/(2.d0*dxm) 
               By(i,j) = (aux(1,i,j+1) - aux(1,i,j-1))/(2.d0*dym)
               Bxy(i,j) = (aux(1,i+1,j+1)-aux(1,i+1,j-1) &
                          -aux(1,i-1,j+1)+aux(1,i-1,j-1))/dxdy4
               Bxx(i,j) = (aux(1,i+1,j)-2.d0*aux(1,i,j)+aux(1,i-1,j))/dxm**2
               Byy(i,j) = (aux(1,i,j+1)-2.d0*aux(1,i,j)+aux(1,i,j-1))/dym**2                          
               w(i,j) = u(i,j)**2 * Bxx(i,j) + 2.d0*u(i,j)*v(i,j)*Bxy(i,j) &
                       +v(i,j)**2 * Byy(i,j)
              
            enddo
        enddo

! ================== build matrix and rhs
        ! Second loop over all cells.  ONLY INTERIOR OK NOW
        
        do j=1,ny 
            if (coordinate_system .eq. 2) then
              ! aux(3,i,j) is latitude, doesn't depend on i so use i=1
              dxm = dx * earth_radius * deg2rad *              &
                    cos(aux(3,1,j))
            else
              dxm = dx
            endif
            dxdx = dxm**2
            dxdy4 = 4.d0*dxm*dym
            
            
            do i=1,nx

                ! sparse matrix row indices for cell (i,j) are:
                !    k_ij for the row of I-D11 and -D12 in block matrix,
                !    k_ij + nD for the row of -D21 and I-D22
                
                ! in this inner loop we set all nonzero matrix elements
                ! in these two rows of the matrix (and rhs) corresponding
                ! to momenumtum updates to hu and hv in the (i,j) cell
                
                ! sparse matrix column indices for neighboring cells
                ! are the values k computed next (for I-D1 and -D3)
                ! and the corresponding k + nD for the corresponding column
                ! of the -D2 and I-D4.  These indices are needed to
                ! set matrix elements in these columns, corresponding to
                ! momentum components hu and hv in the neighboring cells
                
                k_imj = mi%mindex(i-1,j)
                k_ipj = mi%mindex(i+1,j)
                k_ijm = mi%mindex(i,j-1)
                k_ijp = mi%mindex(i,j+1)
                k_imjm = mi%mindex(i-1,j-1)
                k_imjp = mi%mindex(i-1,j+1)
                k_ipjm = mi%mindex(i+1,j-1)
                k_ipjp = mi%mindex(i+1,j+1)
                
                ! use the fact that h,hu,hv are contiguous in alloc:
                h_ij = q(1,i,j)  ! to save typing keep this one
                
                k_ij = mi%mindex(i,j)
                if (k_ij == -1) then
                    write(6,*) '+++ unexpected k_ij=-1 at i,j: ',i,j
                endif
                neltSt = nelt
                if (debug) then
                  write(44,999)i,j,k_ij,k_ij,nelt
 999              format("cell ",2i4," k_ij = ",i5," before shift was ",i5,"   starting with nelt ",i6)
                endif
                
                !b_min = min(aux(1,i,j), aux(1,i-1,j),aux(1,i+1,j),     &
                !            aux(1,i,j-1),aux(1,i,j+1),                 &
                !            aux(1,i-1,j-1),aux(1,i-1,j+1),             &
                !            aux(1,i+1,j-1),aux(1,i+1,j+1))
                !b_max = max(aux(1,i,j), aux(1,i-1,j),aux(1,i+1,j),     &
                !            aux(1,i,j-1),aux(1,i,j+1),                 &
                !            aux(1,i-1,j-1),aux(1,i-1,j+1),             &
                !            aux(1,i+1,j-1),aux(1,i+1,j+1))
                if (.not. mi%isBouss(i,j)) then
                        
                    ! The deepest water in block of 9 cells is shallower 
                    ! than boussMinDepth, or else one of the cells is onshore.

                    ! Revert to SWE in this cell, i.e. two rows
                    ! of matrix should be rows of identity with rhs = 0,
                    ! so correction terms huc,hvc calculated will be 0.
                    
                    !QUESTION: I should be h_ij*I. FIXED
                    ! BUT: then discovered the leading h in matrix is a typo
                    ! fixed for now by multiplying rhs by h_ij too.
                    
                    ! Replace diagonal block I-D11 by I matrix:
                    nelt = nelt + 1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = k_ij

                    ! changed to +1*max on sept 2 2022 to test gamg
                    minfo_matrix_sa(nelt) =  1.d0*max(abs(h_ij),1000.d0)
                    
                    ! Replace diagonal block I-D22 by I matrix:
                    nelt = nelt + 1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = k_ij + nD

                    ! changed to +1*max on sept 2 2022 to test gamg
                    minfo_matrix_sa(nelt) =  1.d0*max(abs(h_ij),1000.d0)
                    
                    ! -D12 and -D21 are the 0 matrix in this case (no nozeros)

                    cycle ! go on to next i
                endif

                
                ! If we get here, we are dealing with interior point
                ! Add rows k_ij and (k_ij + nD) to matrix:
                ! Row k_ij    corresponds to correction to hu in cell (i,j)
                ! Row k_ij+nD corresponds to correction to hv in cell (i,j)
                ! The nonzero matrix elements will be in the same columns
                ! and also in columns 
                !     k_ipj, k_ipj+nD for the coeff of the (i+1,j) stencil pt
                !     k_imjp, k_imjp+nD for the coeff of (i-1,j+1) point,
                !     etc.
                ! Note that if e.g. k_ipj = -1 then cell (i+1,j) is not in the
                ! union of patches at this level and so there is no 
                ! corresponding column.  
                ! In this case:
                ! For Dirichlet BC with value 0, the stencil value is discarded,
                ! For Neumann BC, the stencil coefficient is instead applied
                ! to the neighboring cell that is in the patch, 
                ! assuming constant extrapolation at each edge.
                
                ! Increment nelt each time we add another nonzero matrix
                ! element.  
                ! Store index nelt_ij for index to diagonal element in row k_ij
                ! Store index nelt_ij_nD for diagonal element in row k_ij+nD

                ! initialize to -1 for debugging in case not set properly:
                nelt_ij = -1
                nelt_ij_nD = -1
                
                hx = (q(1,i+1,j) - q(1,i-1,j))/(2.d0*dxm)
                hy = (q(1,i,j+1) - q(1,i,j-1))/(2.d0*dym)
                etax = (eta(i+1,j) - eta(i-1,j))/(2.d0*dxm)
                etay = (eta(i,j+1) - eta(i,j-1))/(2.d0*dym)

                !-----------------------------------------------
                ! I-D11 block (x and xx derivatives of hu components):
                
                ! Matrix element row U(i,j) column U(i,j):
                sa = (1.d0 + alpha*(2.d0*h_ij**2/(3.d0*dxdx) &
                     + 0.5d0*h_ij*Bxx(i,j) + Bx(i,j)*etax))
                nelt = nelt+1
                minfo_matrix_ia(nelt) = k_ij
                minfo_matrix_ja(nelt) = k_ij
                minfo_matrix_sa(nelt) = sa
                
                nelt_ij = nelt  ! index of diagonal matrix element
                
                
                ! Matrix element row U(i,j) column U(i+1,j):
                sa = alpha*(-h_ij*hx/(2.d0*dxm) - h_ij**2/(3.d0*dxdx))
                
                if (k_ipj > -1) then
                    ! adjacent cell is interior pt, set matrix element to sa:
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = k_ipj
                    minfo_matrix_sa(nelt) = sa
                else
                    ! right boundary of patch
                    if (.not. xhi_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        huc = q(4,i+1,j)
                        rhs(k_ij) = rhs(k_ij) - sa*huc
                    else if (bc_xhi==1) then 
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij) = minfo_matrix_sa(nelt_ij) + sa
                    else if (bc_xhi==3) then
                        ! For wall, negate u: add -sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij) = minfo_matrix_sa(nelt_ij) - sa
                    endif                    
                endif
                
                
                ! Matrix element row U(i,j) column U(i-1,j):
                sa = alpha*(h_ij*hx/(2.d0*dxm) - h_ij**2/(3.d0*dxdx))
                if (k_imj > -1) then
                    ! adjacent cell is interior pt, set matrix element to sa:
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = k_imj
                    minfo_matrix_sa(nelt) = sa
                else
                    ! left boundary of patch
                    if (.not. xlo_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        huc = q(4,i-1,j)
                        rhs(k_ij) = rhs(k_ij) - sa*huc
                    else if (bc_xlo==1) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij) = minfo_matrix_sa(nelt_ij) + sa
                    else if (bc_xlo==3) then
                        ! For wall, negate u: add -sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij) = minfo_matrix_sa(nelt_ij) - sa
                    endif
                endif


                !-----------------------------------------------
                ! I-D22 block (yy derivatives of hv components):
                
                ! Matrix element row V(i,j) column V(i,j):
                sa = (1.d0 + alpha*(2.d0*h_ij**2/(3.d0*dydy) &
                     + 0.5d0*h_ij*Byy(i,j) + By(i,j)*etay))
                nelt = nelt+1
                minfo_matrix_ia(nelt) = k_ij + nD
                minfo_matrix_ja(nelt) = k_ij + nD
                minfo_matrix_sa(nelt) = sa
                
                nelt_ij_nD = nelt  ! index of diagonal matrix element


                ! Matrix element row V(i,j) column V(i,j+1):
                sa = alpha*(-h_ij*hy/(2.d0*dym) - h_ij**2/(3.d0*dydy))
                if (k_ijp > -1) then
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = k_ijp + nD
                    minfo_matrix_sa(nelt) = sa
                else
                    ! top boundary of patch
                    if (.not. yhi_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        hvc = q(5,i,j+1)
                        rhs(k_ij+nD) = rhs(k_ij+nD) - sa*hvc
                    else if (bc_yhi==1) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij_nD) = &
                                minfo_matrix_sa(nelt_ij_nD) + sa
                    else if (bc_yhi==3) then
                        ! For wall BC add -sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij_nD) = &
                                minfo_matrix_sa(nelt_ij_nD) - sa
                    endif
                endif
                
                ! Matrix element row V(i,j) column V(i,j-1):
                sa = alpha*(h_ij*hy/(2.d0*dym) - h_ij**2/(3.d0*dydy))
                if (k_ijm > -1) then
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = k_ijm + nD
                    minfo_matrix_sa(nelt) = sa
                else
                    ! bottom boundary of patch
                    if (.not. ylo_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        hvc = q(5,i,j-1)
                        rhs(k_ij+nD) = rhs(k_ij+nD) - sa*hvc
                    else if (bc_ylo==1) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij_nD) = &
                                minfo_matrix_sa(nelt_ij_nD) + sa
                    else if (bc_ylo==3) then
                        ! For wall BC add -sa to diagonal matrix element:
                        minfo_matrix_sa(nelt_ij_nD) = &
                                minfo_matrix_sa(nelt_ij_nD) - sa
                    endif   
                endif                                        

            
                !-----------------------------------------------
                ! -D12 block (cross derivatives):
                ! row ia = k_ij for hu corrections in cell (i,j)
                ! columns k_ipjp + nD and other neighbors for hv corrections                

                ! Matrix element row U(i,j) column V(i,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH VARYING TOPO
                sa = alpha*(0.5d0*h_ij*Bxy(i,j) + etax*By(i,j))
                nelt = nelt+1
                minfo_matrix_ia(nelt) = k_ij
                minfo_matrix_ja(nelt) = k_ij + nD
                minfo_matrix_sa(nelt) = sa
                    
            
                ! Matrix element row U(i,j) column V(i,j+1):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = -alpha*h_ij*(hx + 0.5d0*Bx(i,j))/(2.d0*dym)
                ja = -1
                if (k_ijp > -1) then
                    ja = k_ijp + nD
                else if (.not. yhi_db) then
                    hvc = q(5,i,j+1)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else
                    ! at top boundary, use cell ij instead,
                    ja = k_ij + nD
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i,j-1):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = alpha*(h_ij*(hx + 0.5d0*Bx(i,j))/(2.d0*dym))
                ja = -1
                if (k_ijm > -1) then
                    ja = k_ijm + nD
                else if (.not. ylo_db) then
                    hvc = q(5,i,j-1)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else
                    ! at bottom boundary, use cell ij instead,
                    ja = k_ij + nD
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif

                
                ! Matrix element row U(i,j) column V(i+1,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = alpha*0.5d0*h_ij*By(i,j) / (2.d0*dxm)
                ja = -1
                if (k_ipj > -1) then
                    ja = k_ipj + nD
                else if (.not. xhi_db) then
                    hvc = q(5,i+1,j) 
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else
                    ! at right boundary, use cell ij instead,
                    ja = k_ij + nD
                    ! no reflection of V at right wall
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif

                
                ! Matrix element row U(i,j) column V(i-1,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = -alpha*0.5d0*h_ij*By(i,j) / (2.d0*dxm)
                ja = -1
                if (k_imj > -1) then
                    ja = k_imj + nD
                else if (.not. xlo_db) then
                    hvc = q(5,i-1,j)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else
                    ! at left boundary, use cell ij instead,
                    ja = k_ij + nD
                    ! no reflection of V at left wall
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                                                
                
                ! Matrix element row U(i,j) column V(i+1,j+1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjp > -1) then
                    ja = k_ipjp + nD
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    hvc = q(5,i+1,j+1)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else if (k_ijp > -1) then
                    ! at right boundary, use cell above instead
                    ja = k_ijp + nD
                else if (k_ipj > -1) then
                    ! at top boundary, use cell to right instead, 
                    ja = k_ipj + nD
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                else
                    ! top-right corner
                    ja = k_ij + nD
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
                    
                ! Matrix element row U(i,j) column V(i+1,j-1):
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjm > -1) then
                    ja = k_ipjm + nD            
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    hvc = q(5,i+1,j-1)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc   
                else if (k_ijm > -1) then
                    ! at right boundary, use cell below instead
                    ja = k_ijm + nD
                else if (k_ipj > -1) then
                    ! at bottom boundary, use cell to right instead,
                    ja = k_ipj + nD
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                else
                    ! bottom-right corner
                    ja = k_ij + nD
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif

                
                ! Matrix element row U(i,j) column V(i-1,j+1):    
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_imjp > -1) then
                    ja = k_imjp + nD
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    hvc = q(5,i-1,j+1)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else if (k_ijp > -1) then
                    ! at left domain boundary, use cell above instead
                    ja = k_ijp + nD
                else if (k_imj > -1) then
                    ! at top domain boundary, use cell to left instead,
                    ja = k_imj + nD
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                else
                    ! top-left corner
                    ja = k_ij + nD
                    if (bc_yhi==3) sa = -sa  ! reflect V in y
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
                
                ! Matrix element row U(i,j) column V(i-1,j-1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_imjm > -1) then
                    ja = k_imjm + nD
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    hvc = q(5,i-1,j-1)
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                else if (k_ijm > -1) then
                    ! at left boundary, use cell below instead
                   ja = k_ijm + nD
                else if (k_imj > -1) then
                    ! at bottom boundary, use cell to left instead,
                    ja = k_imj + nD
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                else
                    ! bottom-left corner
                    ja = k_ij + nD
                    if (bc_ylo==3) sa = -sa  ! reflect V in y
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif


                !-----------------------------------------------
                ! -D21 block (cross derivatives
                ! row ia = k_ij + nD  for hv corrections in cell (i,j)
                ! columns k_ipjp and other neighbors for hu corrections

                ! Matrix element row V(i,j) column U(i,j):
                ! NEW MATRIX ELEMENT FOR SGN WITH VARYING TOPO
                sa = alpha*(0.5d0*h_ij*Bxy(i,j) + etay*Bx(i,j))
                nelt = nelt+1
                minfo_matrix_ia(nelt) = k_ij + nD
                minfo_matrix_ja(nelt) = k_ij
                minfo_matrix_sa(nelt) = sa
                
                ! Matrix element row V(i,j) column U(i+1,j):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = -alpha*h_ij*(hy + 0.5d0*By(i,j))/(2.d0*dxm)
                ja = -1
                if (k_ipj > -1) then
                    ja = k_ipj
                else if (.not. xhi_db) then
                    huc = q(4,i+1,j)
                    rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                else
                    ! at right boundary, use cell ij instead,
                    ja = k_ij
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i-1,j):
                ! NEW MATRIX ELEMENT FOR SGN
                sa = alpha*h_ij*(hy + 0.5d0*By(i,j))/(2.d0*dxm)
                ja = -1
                if (k_imj > -1) then
                    ja = k_imj
                else if (.not. xlo_db) then
                    huc = q(4,i-1,j)
                    rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                else
                    ! at left boundary, use cell ij instead,
                    ja = k_ij
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i,j+1):
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = alpha*0.5d0*h_ij*Bx(i,j) / (2.d0*dym)
                ja = -1
                if (k_ijp > -1) then
                    ja = k_ijp ! FIXED BUG2
                else if (.not. yhi_db) then
                    huc = q(4,i,j+1)
                    rhs(k_ij) = rhs(k_ij) - sa*huc
                else
                    ! at top boundary, use cell ij instead,
                    ja = k_ij
                    ! no reflection of U at top wall
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif

                ! Matrix element row V(i,j) column U(i,j-1): ! FIXED BUG2
                ! NEW MATRIX ELEMENT FOR SGN WITH TOPO
                sa = -alpha*0.5d0*h_ij*Bx(i,j) / (2.d0*dym)
                ja = -1
                if (k_ijm > -1) then
                    ja = k_ijm ! FIXED BUG2
                else if (.not. ylo_db) then
                    huc = q(4,i,j-1)
                    rhs(k_ij) = rhs(k_ij) - sa*huc
                else
                    ! at bottom boundary, use cell ij instead,
                    ja = k_ij ! FIXED BUG2
                    ! no reflection of U at bottom wall
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif

                
                ! Matrix element row V(i,j) column U(i+1,j+1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjp > -1) then
                    ja = k_ipjp
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    huc = q(4,i+1,j+1)
                    rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                else if (k_ijp > -1) then
                    ! at right boundary, use cell above instead,
                    ja = k_ijp
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                else if (k_ipj > -1) then
                    ! at top boundary, use cell to right instead,
                    ja = k_ipj
                else
                    ! top-right corner
                    ja = k_ij ! FIXED BUG
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i+1,j-1):
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_ipjm > -1) then
                    ja = k_ipjm
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_ipj == -1) .and. (.not. xhi_db))) then
                    huc = q(4,i+1,j-1)
                    rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                else if (k_ijm > -1) then
                    ! at right boundary, use cell below instead,
                    ja = k_ijm
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                else if (k_ipj > -1) then
                    ! at bottom boundary, use cell to right instead,
                    ja = k_ipj
                else
                    ! bottom-right corner
                    ja = k_ij ! FIXED BUG
                    if (bc_xhi==3) sa = -sa  ! reflect U in x
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                    if (debug) write(67,*) i,j,i+1,j-1,c,nelt,sa
                endif
                
                
                ! Matrix element row V(i,j) column U(i-1,j+1):
                sa = alpha*h_ij**2 / (3.d0*dxdy4)
                ja = -1
                if (k_imjp > -1) then
                    ja = k_imjp
                else if (((k_ijp == -1) .and. (.not. yhi_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    huc = q(4,i-1,j+1)
                    rhs(k_ij+nD) = rhs(k_ij+nD)  - sa*huc
                else if (k_ijp > -1) then
                    ! at left boundary, use cell above instead,
                    ja = k_ijp
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                else if (k_imj > -1) then
                    ! at top boundary, use cell to left instead,
                    ja = k_imj
                else
                    ! top-left corner
                    ja = k_ij !FIXED BUG
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif


                ! Matrix element row V(i,j) column U(i-1,j-1):
                sa = -alpha*h_ij**2 / (3.d0*dxdy4)  
                ja = -1
                if (k_imjm > -1) then
                    ja = k_imjm
                else if (((k_ijm == -1) .and. (.not. ylo_db)) .or. &
                         ((k_imj == -1) .and. (.not. xlo_db))) then
                    huc = q(4,i-1,j-1)
                    rhs(k_ij+nD) = rhs(k_ij+nD)  - sa*huc
                else if (k_ijm > -1) then
                    ! at left boundary, use cell below instead,
                    ja = k_ijm
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                else if (k_imj > -1) then
                    ! at bottom boundary, use cell to left instead,
                    ja = k_imj
                else
                    ! bottom-left corner
                    ja = k_ij !FIXED BUG
                    if (bc_xlo==3) sa = -sa  ! reflect U in x
                endif
                
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo_matrix_ia(nelt) = k_ij + nD
                    minfo_matrix_ja(nelt) = ja
                    minfo_matrix_sa(nelt) = sa
                endif
                
 
                !-------------------------------------------------------
                ! Right hand sides for vector elements k_ij and k_ij+nD
                ! Need to add comments on SGN RHS.
                
              if (debug) then
                  write(67,*) '++b i,j,rhs = ',i,j,rhs(k_ij),rhs(k_ij + nD)
              endif 
              
              !RHS for SGN 
              phix = (phi(i+1,j) - phi(i-1,j))/(2.d0*dxm)
              phiy = (phi(i,j+1) - phi(i,j-1))/(2.d0*dym)
                            
              wx = (w(i+1,j) - w(i-1,j))/(2.d0*dxm)
              wy = (w(i,j+1) - w(i,j-1))/(2.d0*dym)
              
              etax = (eta(i+1,j) - eta(i-1,j))/(2.d0*dxm)
              etay = (eta(i,j+1) - eta(i,j-1))/(2.d0*dym)
                                 
              rhs(k_ij) = rhs(k_ij)  +  (grav/alpha * etax      &
                    + 2.d0*h_ij*(h_ij/3.d0 * phix &
                    + phi(i,j) * (hx + 0.5d0*Bx(i,j)))   &
                    + 0.5d0*h_ij*wx + w(i,j)*etax)

              rhs(k_ij+nD) = rhs(k_ij+nD) +  (grav/alpha * etay &
                    + 2.d0*h_ij*(h_ij/3.d0 * phiy &
                    + phi(i,j) * (hy + 0.5d0*By(i,j)))   &
                    + 0.5d0*h_ij*wy + w(i,j)*etay)


              if (debug) then
                write(44,998) nelt,nelt-neltSt
 998                format("                               ending with nelt ",i6,"   used ",i5)
              endif


              if (0 .eq. 1 .or. debug) then
                 allzero = .true.
                 do n = nelt_ij, nelt
                    if (minfo_matrix_sa(n) .ne. 0.d0) then
                       allzero = .false.
                       exit
                    endif
                 end do
                 if (allzero) then
                    write(*,*)" row ",k_ij," all zeroes"
                 endif

              endif
                     
              ! put initial guess for k_ij and k_ij+nD respective in soln array
             !if (levelBouss .lt. mxnest) then
             !  ! initial guess when doUpdate is true is previous soln
             !  ! when doUpdate was false, but values needed for finer
             !  ! grid interface conditions
             !  soln(k_ij) = qold(4,i,j) 
             !  soln(k_ij+nD) = qold(5,i,j)
             !else
             !  soln(k_ij) = 0.d0
             !  soln(k_ij+nD) = 0.d0 
             !endif

             !matrix_rhs1_max = max(matrix_rhs1_max, abs(rhs(k_ij)))
             !matrix_rhs2_max = max(matrix_rhs2_max, abs(rhs(k_ij+nD)))

            enddo
        enddo

        if (debug) then ! dump matrix to look for singularity 
           write(88,*)" level ",levelBouss
           do k = neltBegin+1, nelt
              write(88,103) minfo_matrix_ia(k),minfo_matrix_ja(k),minfo_matrix_sa(k)
 103          format(2i8,e16.7)
           end do
           !close(88)
           write(89,*)" level ",levelBouss
           do k = 1,2*numBoussCells
              write(89,104) k,rhs(k)
 104          format(i5,e16.7)
           end do
           !close(89)
           !stop
        endif
        
    
    ! put back in struct. May have more grids following    
    minfo%matrix_nelt = nelt
    
#ifdef WHERE_AM_I
  write(*,*) "ending   buildSparseMatrixSGNcoo"
#endif


    return
end subroutine buildSparseMatrixSGNcoo

!   =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
!   =====================================================
    implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for the acoustics equations.

!     # Split asdq into down-going flux bmasdq and up-going flux bpasdq.

    dimension     ql(meqn, 1-mbc:maxm+mbc)
    dimension     qr(meqn, 1-mbc:maxm+mbc)
    dimension   asdq(meqn, 1-mbc:maxm+mbc)
    dimension bmasdq(meqn, 1-mbc:maxm+mbc)
    dimension bpasdq(meqn, 1-mbc:maxm+mbc)

!     # density, bulk modulus, and sound speed, and impedence of medium:
!     # (should be set in setprob.f)
    common /cparam/ rho,bulk,cc,zz


    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    do 20 i = 2-mbc, mx+mbc
        a1 = (asdq(1,i)*zz - asdq(mv,i)) / (2.d0*zz)
        a2 = (zz*asdq(1,i) + asdq(mv,i)) / (2.d0*zz)
    
    !        # The down-going flux difference bmasdq is the product  -c * wave
    
        bmasdq(1,i) = -cc * a2
        bmasdq(mu,i) = 0.d0
        bmasdq(mv,i) = -cc * a2 * zz
    
    !        # The up-going flux difference bpasdq is the product  c * wave
    
        bpasdq(1,i) = cc * a1
        bpasdq(mu,i) = 0.d0
        bpasdq(mv,i) = -cc * a1 * zz
    
    20 END DO

    return
    end subroutine rpt2

c
c -----------------------------------------------------------
c
       subroutine setPhysBndry(rectflags,ilo,ihi,jlo,jhi,mbuff,level)

       use amr_module
       implicit double precision (a-h, o-z)

       dimension rectflags(ilo-mbuff:ihi+mbuff, jlo-mbuff:jhi+mbuff)

c ****************************************************************
!> If grid borders the physical domain then
!! turn off any flagged points in buffer zone = those points
!! are not properly nested (and it doesnt matter).
!! But last row/col interior to grid if flagged is ok
!! 
!! if periodic, then have to look elsewhere to see if
!! last interior row/col that is flagged is ok.
!! (done in rest of colate2)
c ****************************************************************

       if (ilo .eq. 0 .and. .not. xperdom) then
c       set left flagged points to be ok
          do j = jlo-mbuff, jhi+mbuff
            do i = ilo-mbuff, ilo-1
             rectflags(i,j) = DONTFLAG
            end do
c           1st interior cell ok if on bndry. set back to pos if flagged
            rectflags(0,j) = abs(rectflags(0,j))
          end do
       endif

       if (ihi .eq. iregsz(level)-1 .and. .not. xperdom) then
c       set right flagged points to be ok
          do j = jlo-mbuff, jhi+mbuff
            do i = ihi+1, ihi+mbuff
             rectflags(i,j) = DONTFLAG
            end do
            rectflags(ihi,j) = abs(rectflags(ihi,j))
          end do
       endif

 
       if (jlo .eq. 0 .and. .not. yperdom) then
c       set bottom flagged points to be ok
          do i = ilo-mbuff, ihi+mbuff
            do j = jlo-mbuff, jlo-1    
             rectflags(i,j) = DONTFLAG
            end do
            rectflags(i,0) = abs(rectflags(i,0))
          end do
       endif

       if (jhi .eq. jregsz(level)-1 .and. .not. yperdom) then
c       set top flagged points to be ok
          do i = ilo-mbuff, ihi+mbuff
            do j = jhi+1, jhi+mbuff
             rectflags(i,j) = DONTFLAG
            end do
            rectflags(i,jhi) = abs(rectflags(i,jhi))
          end do
       endif

       return
       end

module amr_module

    implicit none
       
    save
       
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::   data structure info.
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    integer, parameter :: rsize = 7
    integer, parameter :: nsize = 21

    !  :::::::   integer part of node descriptor
    integer, parameter :: levelptr  = 1
    integer, parameter :: tempptr   = 2
    integer, parameter :: errptr    = 3
    integer, parameter :: nestlevel = 4
    integer, parameter :: cfluxptr  = 5
    integer, parameter :: ffluxptr  = 6
    integer, parameter :: store1    = 7
    integer, parameter :: store2    = 8
    integer, parameter :: ndilo     = 9
    integer, parameter :: ndihi     = 10
    integer, parameter :: ndjlo     = 11
    integer, parameter :: ndjhi     = 12
    integer, parameter :: ndklo     = 13
    integer, parameter :: ndkhi     = 14
    integer, parameter :: storeaux  = 15
    integer, parameter :: storeflags  = 16
    integer, parameter :: numflags  = 17
    integer, parameter :: domflags_base  = 18
    integer, parameter :: domflags2  = 19
    integer, parameter :: bndListSt  = 20
    integer, parameter :: bndListNum = 21

    ! :::::::  real part of node descriptor
    integer, parameter :: cornxlo  = 1
    integer, parameter :: cornylo  = 2
    integer, parameter :: cornzlo  = 3
    integer, parameter :: cornxhi  = 4
    integer, parameter :: cornyhi  = 5
    integer, parameter :: cornzhi  = 6
    integer, parameter :: timemult = 7

    ! :::::::   for linking nodes
    integer, parameter :: nextfree = 2
    integer, parameter :: null = 0
    integer, parameter :: nil  = 0

    integer, parameter :: gridNbor = 1  ! use first col, 2nd col is nextfee - the link

    ! :::::::  for flagging points   
    real(kind=8), parameter :: goodpt = 0.0
    real(kind=8), parameter :: badpt  = 2.0
    real(kind=8), parameter :: badpro = 3.0

    real(kind=8), parameter :: rinfinity = 10.e32
    integer, parameter :: iinfinity = 999999999
    integer, parameter :: iplane = 1
    integer, parameter :: jplane = 2
    integer, parameter :: kplane = 3
    !! integer, parameter :: maxgr = 5000 ! No longer fixed
    integer, parameter :: maxlv = 10
    integer, parameter :: maxcl = 5000

    ! The max1d parameter should be changed if using OpenMP grid based 
    ! looping, suggest setting max1d = 32 for 3d 
    ! max1d should now be set in setrun.py
    integer:: max1d
    !integer, parameter :: max1d = 28 

    integer, parameter :: maxvar = 10
    integer, parameter :: maxaux = 20
    integer, parameter :: maxwave = 10
    integer, parameter :: maxout = 50  !until change amr to f90 and allocate

    ! put linked list of grids into array and save.
    ! order is coarsest level to finest. is redone after regridding
    ! and on restarting.  note use of sentinel in listStart

    !! CHANGED mjb 6/15/18 to make maxgr a variable
    !!integer :: listOfGrids(maxgr),listStart(0:maxlv+1)
    integer :: listStart(0:maxlv+1)
    !integer, parameter :: bndListSize = 8*maxgr
    !integer :: bndList(bndListSize,2) ! guess size, average # nbors 6? manage as linked list
    integer :: bndListSize
    integer,allocatable, dimension(:,:) :: bndList  ! new way is allocatable 


    !real(kind=8) hxposs(maxlv),hyposs(maxlv),hzposs(maxlv), &
    !             possk(maxlv),rnode(rsize, maxgr) 
    real(kind=8) hxposs(maxlv),hyposs(maxlv),hzposs(maxlv),possk(maxlv) 

    ! start of dynamic allocation for maxgr and associated arrays
    integer maxgr
    real(kind=8), allocatable, dimension(:,:) :: rnode    
    ! new way, use allocatable, not pointer
    integer, allocatable, dimension(:,:) :: node
    integer, allocatable, dimension(:) :: listOfGrids


    real(kind=8) tol, tolsp
    !integer ibuff, mstart,ndfree,ndfree_bnd,lfine,node(nsize, maxgr), &
    integer ibuff, mstart,ndfree,ndfree_bnd,lfine, &
            icheck(maxlv),lstart(maxlv),newstl(maxlv), &
            listsp(maxlv),intratx(maxlv),intraty(maxlv), &
            intratz(maxlv),kratio(maxlv), &
            iregsz(maxlv),jregsz(maxlv),kregsz(maxlv), &
            iregst(maxlv),jregst(maxlv),kregst(maxlv), &
            iregend(maxlv),jregend(maxlv),kregend(maxlv), &
            numgrids(maxlv),numcells(maxlv), &
            iorder,mxnest,kcheck

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! ::::  for alloc array/memory
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ! Static memory implementation
    ! parameter  (memsize = 10000000)
    ! common  /calloc/   alloc(memsize)

    ! Dynamic memory: 
    !real(kind=8), allocatable, target, dimension(:) :: storage
    !real(kind=8), pointer, dimension(:) :: alloc
    real(kind=8), allocatable, dimension(:) :: alloc  ! new way, use alloctable, not pointer
    integer memsize
       
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::\
    ! :::::   for space management of alloc array
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    integer, parameter :: lfdim=5000
    integer lfree(lfdim,2),lenf

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  domain description variables
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    logical xperdom, yperdom ,zperdom
    real(kind=8) :: xupper,yupper,zupper,xlower,ylower,zlower
    integer :: nghost, mthbc(6)

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  collect stats
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    real(kind=8)  rvoll(maxlv),evol,rvol,avenumgrids(maxlv)
    integer iregridcount(maxlv), tvoll(maxlv)
    integer lentot,lenmax,lendim
    integer timeRegridding, timeValout
    integer timeBound, timeStepgrid
    integer :: timeTick, tick_clock_start
    real(kind=8) tvollCPU(maxlv)
    real(kind=8) timeBoundCPU,timeStepgridCPU,timeRegriddingCPU
    real(kind=8) timeValoutCPU

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  method parameters
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    character(len=10), allocatable :: auxtype(:)
    integer  method(7), mwaves, mcapa, dimensional_split
    integer, allocatable :: mthlim(:)
    real(kind=8) cfl,cflmax,cflv1,cfl_level

    logical :: use_fwaves
    logical :: flag_richardson,flag_gradient
    integer :: verbosity_regrid

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! ::::: Parameters and variables related to I/O and checkpointing
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    logical    printout,matlabout,ncarout

    ! variables for conservation checking:
    real(kind=8) tstart,tmass0

    ! variables for specifying output format
    integer :: output_style, nstop, nout, iout
    real(kind=8), allocatable :: tout(:)
    real(kind=8) :: t0, tfinal
    real(kind=8) :: tstart_thisrun  ! /= t0 in case of restart
    integer :: nq_components, naux_components, output_format
    integer, allocatable :: output_q_components(:)
    integer, allocatable :: output_aux_components(:)
    logical :: output_aux_onlyonce

    ! checkpointing:
    integer :: checkpt_style, nchkpt, checkpt_interval
    real(kind=8), allocatable :: tchk(:)

    integer :: matlabu

    !  USE UNITS NUMBERS < 89.
    ! 89 and + numthreads taken by gauge output
    integer, parameter :: parmunit = 12
    integer, parameter :: chkunit = 10
    integer, parameter :: inunit  = 5
    integer, parameter :: outunit = 66
    integer, parameter :: pltunit1 = 3
    integer, parameter :: rstunit = 9
    integer, parameter :: dbugunit = 11
    integer, parameter :: matunit = 70

    ! ::::  Debugging flags (verbose output)
    logical &
                dprint,     & !  domain flags output
                eprint,     & !  error estimation output
                edebug,     & !  even more error estimation output
                gprint,     & !  verbose grid generation (clustering,colating...)
                nprint,     & !  nestck reporting
                pprint,     & !  projec tagged pts.
                rprint,     & !  regridding -  summary of new grids
                sprint,     & !  space (memory) output
                tprint,     & !  tick (time stepping) reporting
                uprint        !  updating/upbnding reporting


    ! Restart file name:
    character(len=200) :: rstfile
    logical :: check_a

end module amr_module

subroutine src1d(meqn,mbc,mx1d,q1d,maux,aux1d,t,dt)

    ! This routine should be a simplified version of src3 
    ! which applies source terms for a 1-d slice of data along the
    ! edge of a grid.  This is called only from qad where the conservative
    ! fix-up is applied and is used to apply source terms over partial
    ! time steps to the coarse grid cell values used in solving Riemann 
    ! problems at the interface between coarse and fine grids.
 
    ! If the source terms depend only on q, it should be easy to 
    ! adapt src3 to create this routine, just loop over 1:mx1d.
    ! If the source terms are more complicated, it may not be easy.
 
    ! The code may work fine without applying source terms in this
    ! context, so using this dummy routine might be successful even when
    ! source terms are present. 
 
    ! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: meqn,mbc,mx1d,maux
    real(kind=8), intent(in) :: t, dt
    real(kind=8), intent(in) ::  aux1d(maux,mx1d)
    real(kind=8), intent(inout) ::  q1d(meqn,mx1d)

end subroutine src1d

! ============================================================================
!  Program:     AMRClaw
!  File:        resize_storage.f90
!  Created:     2009-01-21
!  Author:      Kyle Mandli and Marsha Berger
! ============================================================================
!  Description:  Resize the alloc array for AMR storage
! ============================================================================


! NOTE:  Older f90 compilers (e.g. gfortran prior to 4.2?)
! may not implement move_alloc.  If this fails, you may need to use
! resize_storage_static.f90 instead of this routine and set the
! allocation large enough in init_alloc.f90 to avoid running out of space.


       subroutine resize_storage(new_size,status)
    
      use amr_module
    implicit none
    
      integer, intent(out) :: status
      integer, intent(in) :: new_size

    real(kind=8), allocatable, target, dimension(:) :: new_storage
  

       if (memsize < new_size) then
           print *, "Expanding storage from ", memsize," to ", new_size
           allocate(new_storage(new_size),STAT=status)
           if (status > 0) then
               return
           endif
!           new_storage(1:memsize) = storage  ! old way, changed mjb Jan. 2015
            new_storage(1:memsize) = alloc    ! new way, use allocatable, not pointer

!           call move_alloc(new_storage,storage)
            call move_alloc(new_storage,alloc)

!          alloc => storage
           memsize = new_size
       else
           print *,'new_size < memsize,'
           print *,'new_size = ',new_size
           print *,'memsize = ',memsize
           stop
       endif
    
      return
    
      end subroutine resize_storage

c
c
!> Solve Riemann problems based on 1D slice of the 2D grid.
!! Return fluxes contributed by this slice.
!!
!! If **ixy** = 1, it's a slice in x. 
!! If **ixy** = 2, it's a slice in y. 
!!
!! Suppose it's a slice in x, the subroutine call normal Riemann 
!! solver to get fluctuations at edges(i-1/2,j)
!! and store the fluctuations in flux form: **faddm**, **faddp**.
!! It also call transverse Riemann soler to get up-goning and down-going
!! transverse waves and store them in **gaddm** and **gaddp**.
!!
!! **gaddm** is value to be added to gm, which is g flux on the lower side
!! of a cell edge. 
!! **gaddp** is value to be added to gp, which is g flux on the upper side
!! of a cell edge. 
!! Here **gaddm** and **gaddp** have the same value since g flux
!! on upper side and lower side of a cell edge should be the same (it's not 
!! like apdq and amdq at the edge).
!! **gaddm(*,i,.,1)** or **gaddp(*,i,.,1)** modifies G below cell i;
!! **gaddm(*,i,.,2)** or **gaddp(*,i,.,2)** modifies G above cell i;
c     =====================================================
      subroutine flux2(ixy,maxm,meqn,maux,mbc,mx,
     &                 q1d,dtdx1d,aux1,aux2,aux3,
     &                 faddm,faddp,gaddm,gaddp,cfl1d,wave,s,
     &                 amdq,apdq,cqxx,bmasdq,bpasdq,rpn2,rpt2)
c     =====================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c     # Compute the modification to fluxes f and g that are generated by
c     # all interfaces along a 1D slice of the 2D grid. 
c     #    ixy = 1  if it is a slice in x
c     #          2  if it is a slice in y
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd and gadd.  The notation is written assuming
c     # we are solving along a 1D slice in the x-direction.
c
c     # fadd(*,i,.) modifies F to the left of cell i
c     # gadd(*,i,.,1) modifies G below cell i
c     # gadd(*,i,.,2) modifies G above cell i
c
c     # The method used is specified by method(2:3):
c
c         method(2) = 1 if only first order increment waves are to be used.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.  
c
c         method(3) = 0 if no transverse propagation is to be applied.
c                       Increment and perhaps correction waves are propagated
c                       normal to the interface.
c                   = 1 if transverse propagation of increment waves 
c                       (but not correction waves, if any) is to be applied.
c                   = 2 if transverse propagation of correction waves is also
c                       to be included.  
c
c     Note that if mcapa>0 then the capa array comes into the second 
c     order correction terms, and is already included in dtdx1d:
c     If ixy = 1 then
c        dtdx1d(i) = dt/dx                      if mcapa= 0
c                  = dt/(dx*aux(mcapa,i,jcom))  if mcapa = 1
c     If ixy = 2 then
c        dtdx1d(j) = dt/dy                      if mcapa = 0
c                  = dt/(dy*aux(mcapa,icom,j))  if mcapa = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn2 into
c            amdq =  the left-going flux difference  A^- Delta q  
c            apdq = the right-going flux difference  A^+ Delta q  
c        Each of these is split by rpt2 into 
c            bmasdq = the down-going transverse flux difference B^- A^* Delta q
c            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
c        where A^* represents either A^- or A^+.
c
c
      use amr_module
      implicit double precision (a-h,o-z)
      external rpn2, rpt2
      dimension    q1d(meqn,1-mbc:maxm+mbc)
      dimension   amdq(meqn,1-mbc:maxm+mbc)
      dimension   apdq(meqn,1-mbc:maxm+mbc)
      dimension bmasdq(meqn,1-mbc:maxm+mbc)
      dimension bpasdq(meqn,1-mbc:maxm+mbc)
      dimension   cqxx(meqn,1-mbc:maxm+mbc)
      dimension   faddm(meqn,1-mbc:maxm+mbc)
      dimension   faddp(meqn,1-mbc:maxm+mbc)
      dimension   gaddm(meqn,1-mbc:maxm+mbc, 2)
      dimension   gaddp(meqn,1-mbc:maxm+mbc, 2)
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux1(maux,1-mbc:maxm+mbc)
      dimension aux2(maux,1-mbc:maxm+mbc)
      dimension aux3(maux,1-mbc:maxm+mbc)
c
      dimension     s(mwaves, 1-mbc:maxm+mbc)
      dimension  wave(meqn, mwaves, 1-mbc:maxm+mbc)
c
      logical limit
      common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom
c
      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
   5     continue
c
c     # initialize flux increments:
c     -----------------------------
c
       do 10 i = 1-mbc, mx+mbc
         do 20 m=1,meqn
            faddm(m,i) = 0.d0
            faddp(m,i) = 0.d0
            gaddm(m,i,1) = 0.d0
            gaddp(m,i,1) = 0.d0
            gaddm(m,i,2) = 0.d0
            gaddp(m,i,2) = 0.d0
   20    continue
   10  continue
c
c
c     # solve Riemann problem at each interface and compute Godunov updates
c     ---------------------------------------------------------------------
c
      call rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &          aux2,aux2,wave,s,amdq,apdq)
c
c     # Set fadd for the donor-cell upwind method (Godunov)
      do 41 i=1,mx+1
         do 40 m=1,meqn
            faddp(m,i) = faddp(m,i) - apdq(m,i)
            faddm(m,i) = faddm(m,i) + amdq(m,i)
   40    continue
   41 continue
c
c     # compute maximum wave speed for checking Courant number:
      cfl1d = 0.d0
      do 51 mw=1,mwaves
         do 50 i=1,mx+1
c          # if s>0 use dtdx1d(i) to compute CFL,
c          # if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i),
     &                          -dtdx1d(i-1)*s(mw,i))
   50     continue
   51 continue
c
      if (method(2).eq.1) go to 130
c
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c
c     # apply limiter to waves:
      if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c
      do 121 i = 1, mx+1
c
c        # For correction terms below, need average of dtdx in cell
c        # i-1 and i.  Compute these and overwrite dtdx1d:
c
c        # modified in Version 4.3 to use average only in cqxx, not transverse
         dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))

c
c        # second order corrections:

         do 120 m=1,meqn
            cqxx(m,i) = 0.d0
            do 119 mw=1,mwaves
c
               if (use_fwaves) then
                   abs_sign = dsign(1.d0,s(mw,i))
                 else
                   abs_sign = dabs(s(mw,i))
                 endif

               cqxx(m,i) = cqxx(m,i) + abs_sign
     &             * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
c
  119          continue
            faddm(m,i) = faddm(m,i) + 0.5d0 * cqxx(m,i)
            faddp(m,i) = faddp(m,i) + 0.5d0 * cqxx(m,i)
  120     continue
  121  continue
c
c
  130  continue
c
       if (method(3).eq.0) go to 999   !# no transverse propagation
c
       if (method(2).gt.1 .and. method(3).eq.2) then
c         # incorporate cqxx into amdq and apdq so that it is split also.
          do 151 i = 1, mx+1
             do 150 m=1,meqn
                amdq(m,i) = amdq(m,i) + cqxx(m,i)
                apdq(m,i) = apdq(m,i) - cqxx(m,i)
  150        continue
  151     continue
         endif
c
c
c      # modify G fluxes for transverse propagation
c      --------------------------------------------
c
c
c     # split the left-going flux difference into down-going and up-going:
      call rpt2(ixy,1,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,
     &          amdq,bmasdq,bpasdq)
c
c     # modify flux below and above by B^- A^- Delta q and  B^+ A^- Delta q:
       do 161 i = 1, mx+1
         do 160 m=1,meqn
               gupdate = 0.5d0*dtdx1d(i-1) * bmasdq(m,i)
               gaddm(m,i-1,1) = gaddm(m,i-1,1) - gupdate
               gaddp(m,i-1,1) = gaddp(m,i-1,1) - gupdate
c
               gupdate = 0.5d0*dtdx1d(i-1) * bpasdq(m,i)
               gaddm(m,i-1,2) = gaddm(m,i-1,2) - gupdate
               gaddp(m,i-1,2) = gaddp(m,i-1,2) - gupdate
  160          continue
  161          continue
c
c     # split the right-going flux difference into down-going and up-going:
      call rpt2(ixy,2,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,
     &          apdq,bmasdq,bpasdq)
c
c     # modify flux below and above by B^- A^+ Delta q and  B^+ A^+ Delta q:
       do 181 i = 1, mx+1
          do 180 m=1,meqn
               gupdate = 0.5d0*dtdx1d(i) * bmasdq(m,i)
               gaddm(m,i,1) = gaddm(m,i,1) - gupdate
               gaddp(m,i,1) = gaddp(m,i,1) - gupdate
c
               gupdate = 0.5d0*dtdx1d(i) * bpasdq(m,i)
               gaddm(m,i,2) = gaddm(m,i,2) - gupdate
               gaddp(m,i,2) = gaddp(m,i,2) - gupdate
  180     continue
  181     continue
c
  999 continue
      return
      end

c
!> Add intersection information between grid **mptr** and a finer grid
!! **mkid** to the boundary list, **listbc**, of grid **mptr**, to be used by fluxsv. 
!!
!! ### About **listbc**
!! **listbc** for grid **mptr** is a 5 by maxsp array and is saved at  
!! address point to by alloc(node(cfluxptr, mptr)). It stores information 
!! about interface between grid **mptr** and all grids one
!! level finer if they intersect. 
!! These interfaces consist of multiple cell edges (or segments,
!! whose length = cell size on grid **mptr**).
!! Each column in **listbc** has five entries and stores information 
!! associated with one segment. 
!! A global index for all these segments is represented by **ispot**.
!! The five entries for the \f$ ispot^{th}\f$ segment are explained as below: 
!! 
!! - listbc(1,ispot) stores LOCAL (RELATIVE to left boundary of grid
!! **mptr**) *i* index of the cell on grid **mptr** that border this 
!! segment. 
!! - listbc(2,ispot) stores LOCAL (RELATIVE to left boundary of grid
!! **mptr**) *j* index of the cell on grid **mptr** that border this 
!! segment. 
!! - listbc(3,ispot) stores side number, which indicates which side 
!! of this segment is a cell of grid **mptr** (coarse cell).
!! If this segment is the left edge of a cell on grid **mptr**, this 
!! number is 1. The number increases (2, 3, 4) as it goes around a coarse cell
!! clockwise (top edge, right edge, bottom edge).
!! - listbc(4,ispot) stores grid number of the finer grid that borders
!! this segment
!! - listbc(5,ispot) stores the position of this segment with respect to 
!! the perimeter of this finer grid (grid listbc(4,ispot)). 
!! The fine grid will save all its fluxes all around its
!! perimeter. This entry tells where the coarse grid should
!! take them from. Note that number of fluxes saved here is equal 
!! to number of such segments (length = coarse cell size) needed to make
!! up the perimeter.
!!
!! \param[in,out] listbc the array that stores boundary information 
!! for grid **mptr**
!! \param[in] maxsp maximum number of segments **lisbc** can describe
!! \param[in,out] ispot global index of a segment among all segments
!! that make up the interface between grid **mptr** and ANY finer grids
!! \param[in] mkid the finer grid that may intersect with grid **mptr**
!! \param[in] ilo global *i* index of left border of grid **mptr**
!! \param[in] ihi global *i* index of right border of grid **mptr**
!! \param[in] jlo global *j* index of lower border of grid **mptr**
!! \param[in] jhi global *j* index of upper border of grid **mptr**
!! \param[in] iclo global *i* index of left border of grid **mkid**, 
!! in level of grid **mptr** index space
!! \param[in] ichi global *i* index of right border of grid **mptr**,
!! in level of grid **mptr** index space
!! \param[in] jclo global *j* index of lower border of grid **mptr**,
!! in level of grid **mptr** index space
!! \param[in] jchi global *j* index of upper border of grid **mptr**,
!! in level of grid **mptr** index space
!! \param[in] kflag indicate what type of domain is being used, regular 
!! cartesian or spherical domain

c ----------------------------------------------------------------
c
       subroutine setuse(listbc,maxsp,ispot,mkid,
     1                   ilo, ihi, jlo, jhi,
     2                   iclo,ichi,jclo,jchi,kflag)
c
c :::::::::::::::::::::::: SETUSE ::::::::::::::::::::::::::::::::
c
c set up boundary list for coarse grid, to be used by fluxsv. 
c loop around boundary of fine grids to do this.  each entry has
c     i, j, side #, fine grid #, loc in fine grid list for fluxes.
c  for example, side 1 of fine grid fixes side 3 of coarse grid,
c  so coarse grid list will store the # 3.
c  wrt coarse grid, the sides are:
c              2
c           1     3       that is, right edge of a coarse cell = 3
c              4                    top  edge of a coarse cell = 2
c
c  # lkid is the index into the fine grid's saved fluxes.
c  # the fine grid will save all its fluxes all around its
c  # perimeter. lkid tells where the coarse grid should
c  # taking them from. (no ghost cells in this index, but 
c  # it is 1-based for indexing array, not - based for
c  # integer index of grid location).
c
c  changed 11/11/08: spheredom for periodically mapped spherical
c      grids. could affect top and bottom if fine grid touches
c      edge of domain in y direction. if calling with spheredom
c      (and not yperdom) then grid is NOT periodically mapped.
c  need kflag to indicate spherically mapped now - otherwise
c  cant tell the difference, dont skip appropropriate loops
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      use amr_module
      implicit double precision (a-h,o-z)
      !dimension listbc(5,maxsp)
      double precision listbc(5,maxsp)


      ist  = iclo - 1
      iend = ichi + 1
      jst  = jclo - 1
      jend = jchi + 1
c
c  left side (of fine grid, right side of coarse cell)
c
      if (ist .lt. ilo .or. kflag .ne. 1) go to 20
         lkid     = max(jlo,jclo) - jclo + 1
         do 10 j  = max(jlo,jclo), min(jhi,jchi)
            ispot              = ispot + 1
            listbc(1,ispot)    = ist-ilo+nghost+1
            listbc(2,ispot)    = j-jlo+nghost+1
            listbc(3,ispot)    = 3
            listbc(4,ispot)    = mkid
            listbc(5,ispot)    = lkid
            lkid               = lkid + 1
 10      continue
c
c   top side (of fine grid, bottom of coarse cell)
c
 20    if (kflag .eq. 1) then  ! regular interior case
         if (jend .gt. jhi) go to 40
         lkid       = (jchi-jclo+1) + max(ilo,iclo)-iclo + 1
         do 30 i    = max(ilo,iclo), min(ihi,ichi)
            ispot              = ispot + 1
            listbc(1,ispot)    = i-ilo+nghost+1
            listbc(2,ispot)    = jend-jlo+nghost+1
            listbc(3,ispot)    = 4
            listbc(4,ispot)    = mkid
            listbc(5,ispot)    = lkid
c	    write(outunit,595)ispot,(listbc(ipl,ispot),ipl=1,5)
 595        format("   entry ",i5," has ", 5i5)
            lkid               = lkid + 1
 30      continue
       else  if (kflag .eq. 2) then !spherical
c top side of a fine grid is also top side of a coarse cell due to mapping
c        write(outunit,*)":fixing top cells with fine grid ",mkid
c        original code was insanely complicated. look at all indices and decide.
         level  = node(nestlevel,mkid) - 1
         lkid   = (jchi-jclo+1)+ 1  ! starts here wrt fine grid. may not use on coarse grid
         do 31 i    = iclo, ichi  
            iwrap = iregsz(level) - i -1
            if (iwrap .ge. ilo .and. iwrap .le. ihi) then
               ispot              = ispot + 1
               listbc(1,ispot)    = iwrap - ilo + nghost + 1
               listbc(2,ispot)    = jend  - jlo + nghost   ! note adjustment of j (one less)
               listbc(3,ispot)    = 5 ! affects TOP of mapped coarse cell in diff. way
               listbc(4,ispot)    = mkid
               listbc(5,ispot)    = lkid
c	    write(outunit,595)ispot,(listbc(ipl,ispot),ipl=1,5)
          endif
            lkid               = lkid + 1  ! increment fine list loc even if not used
 31      continue

       endif
c
c  right side (of fine grid, left of coarse cell)
c (numbered from bottom to top, so not continuous in lkid numbering)
c
 40    if (iend .gt. ihi .or. kflag .ne. 1) go to 60
       lkid     = (ichi-iclo+1)+(jchi-jclo+1)
     .               + max(jlo,jclo) - jclo + 1
       do 50 j  = max(jlo,jclo), min(jhi,jchi)
          ispot              = ispot + 1
          listbc(1,ispot)    = iend-ilo+nghost+1
          listbc(2,ispot)    = j-jlo+nghost+1
          listbc(3,ispot)    = 1
          listbc(4,ispot)    = mkid
          listbc(5,ispot)    = lkid
          lkid   = lkid + 1
 50    continue
c
c  bottom side (of fine grid, top of coarse cell, unless spheredom)
c (numbered left to right, so not continuous in lkid numbering)
c
 60    if (kflag .eq. 1) then
          if (jst .lt. jlo) go to 80
          lkid =  2*(jchi-jclo+1)+(ichi-iclo+1) + max(ilo,iclo)-iclo + 1
          do 70 i      = max(ilo,iclo), min(ihi,ichi)
             ispot              = ispot + 1
             listbc(1,ispot)    = i-ilo+nghost+1
             listbc(2,ispot)    = jst-jlo+nghost+1
             listbc(3,ispot)    = 2
             listbc(4,ispot)    = mkid
             listbc(5,ispot)    = lkid
             lkid   = lkid + 1
 70      continue
       else  ! spherical
c bottom side of fine grid affects bottom of coarse cell 
c         fine grids saves fluxes in usual way
c         coarse grid only needs to change where to use them
          if (kflag .ne. 3) go to 80
c          write(outunit,*)":fixing bottom cells with fine grid ",mkid
          level  = node(nestlevel,mkid)-1
          lkid   = 2*(jchi-jclo+1) + (ichi-iclo+1) + 1
          do 71 i      = iclo, ichi
             iwrap = iregsz(level) - i - 1
             if (iwrap .ge. ilo .and. iwrap .le. ihi) then
                ispot              = ispot + 1
                listbc(1,ispot)    = iwrap - ilo + nghost + 1
                listbc(2,ispot)    = nghost+1   ! grid bottom is at zero index
                listbc(3,ispot)    = 6   ! affects BOTTOM of mapped coarse cell in diff. way
                listbc(4,ispot)    = mkid
                listbc(5,ispot)    = lkid 
c 	    write(outunit,595)ispot,(listbc(ipl,ispot),ipl=1,5)
             endif
             lkid   = lkid + 1
 71      continue       

       endif
c
 80    continue 


       return
       end

      subroutine cellave3(xlow,ylow,zlow,dx,dy,dz,w)
      implicit none

      external fs
      double precision  xlow,ylow,zlow,dx,dy,dz, w

c     # cellave3.f
c
c     # This computes the volume fraction of a 3d mesh cell that lies
c     # on the negative side of a surface
c
c     # This is the main routine which the user calls
c     # It is assumed that the user has defined a level set function
c     # 'fdisc', which implicitly describes the surface which cuts the
c     # mesh.  'fdisc' should have the following form :
c
c         double precision function fdisc(x,y,z)
c
c     # fdisc >= 0 is the positive side of the surface; fdisc < 0
c     # is the negative side.
c
c     # This is the only routine in which 'fs' (and therefore 'fdisc')
c     # is called.   If the user has direct access to 'cube' (values of
c     # the level set at 8 corners of mesh cube) and 'edges', the
c     # connectivity matrix describing surface/edge intersections (see below),
C     # then then the user can call 'cellave3_main' directly.  Doing so
c     # should significantly reduce computational time for situations
c     # in which cell averages are computed more than once.
c
c     # As a pre-processing step (for initialization purposes, for example)
c     # calling 'cellave3' for each mesh cell should be okay.

      integer icube(0:7)
      double precision edges(0:7,0:7)

      integer ipt, ipt_cnt, iedge, ipt1, ipt2, i,j
      double precision xl,xh,yl,yh,zl,zh, tol, s
      double precision corners(0:7,3)

      logical all_in, all_out

c     # functions
      double precision zeroin_cellave, fs

c     # For function fs
      common /comfs/ xl,xh,yl,yh,zl,zh

c     # Evaluate function at all 8 corners of cube.
      all_in = .true.
      all_out = .true.
      do ipt = 0,7
c        # xl,yl,zl,xh,yh,zh are corners that are passed in common
c        # block to function fs.
         xl = xlow + ibits(ipt,0,1)*dx
         yl = ylow + ibits(ipt,1,1)*dy
         zl = zlow + ibits(ipt,2,1)*dz
         xh = xl
         yh = yl
         zh = zl
         corners(ipt,1) = xl
         corners(ipt,2) = yl
         corners(ipt,3) = zl
         icube(ipt) = sign(1.0d0,fs(0.d0))
         all_in = all_in .and. icube(ipt) .lt. 0
         all_out = all_out .and. icube(ipt) .ge. 0
c         icube(ipt) = sign(1,fs(0.d0))   !! sign(1,0) = 1
c         all_in = all_in .and. icube(ipt) .gt. 0
c         all_out = all_out .and. icube(ipt) .lt. 0
      enddo

c     # Immediately eliminate those cubes which are not cut by the surface
      if (all_in) then
         w = 1.d0
         return
      elseif (all_out) then
         w = 0.d0
         return
      endif

c     # Determine intersections at cube edges.
      do i = 0,7
         do j = 0,7
            edges(i,j) = -1.d0
         enddo
      enddo

      tol = 1.0e-8
      ipt_cnt = 0
      do iedge = 0,11
         call get_endpoints(iedge,ipt1,ipt2)
         if (icube(ipt1)*icube(ipt2) .lt. 0) then
            xl = corners(ipt1,1)
            yl = corners(ipt1,2)
            zl = corners(ipt1,3)
            xh = corners(ipt2,1)
            yh = corners(ipt2,2)
            zh = corners(ipt2,3)
            s = zeroin_cellave(0.d0,1.d0,fs,tol)
            edges(ipt1,ipt2) = s
            edges(ipt2,ipt1) = 1.d0-s
         endif
      enddo

      call cellave3_main(icube, edges, w)

      end

c     # -----------------------------------------------------------
c     # cellave_main.f
c     #
c     # Main routine which computes the volume fraction, using only
c     # data in arrays 'cube' and 'edges'.
c     # Functions 'fs' (and 'fdisc') are not called from this routine
      subroutine cellave3_main(icube,edges,w)
      implicit none

      double precision  w

c     # Main info stored here
      integer icube(0:7)
      integer icorners(0:7,3)
      integer faces(0:5,0:5)
      double precision edges(0:7,0:7)

c     # intersection point list and adjacent faces list
c     # isect_cnt is length of list
c     # isect_list and face_list are not in any particular order
c     # But surf_list is an order list of points describing the
c     # surface
      integer isect_cnt, surf_cnt, poly_cnt
      integer surf_list(10)
      integer edge_list(10)
      integer face_list(10,2)

c     # Computing area of polygon at x = 1
      double precision isect_list(10,3)
      double precision ypoly(10), zpoly(10), area
      integer iv_list(5)

      integer ipt, iedge, ipt1, ipt2, i, j, k
      double precision s, v(3)

c     # For face matrix
      integer if1, if2
      integer if1_start, if1_new,if2_start,if2_new
      integer d1, d2
      logical done

c     # For triangulation of surface
      double precision p0(3), p1(3), p2(3)
      double precision dw, tri_normal(3), v1(3), v2(3)
      integer sgn, idir

c     # Get corner locations
      do ipt = 0,7
         icorners(ipt,1) = ibits(ipt,0,1)
         icorners(ipt,2) = ibits(ipt,1,1)
         icorners(ipt,3) = ibits(ipt,2,1)
      enddo

c     # Construct list of intersection points and adjacent faces
      isect_cnt = 0
      do iedge = 0,11
         call get_endpoints(iedge,ipt1,ipt2)
         s = edges(ipt1,ipt2)
         if (s .ge. 0.d0) then
            isect_cnt = isect_cnt + 1  !! This number shouldn't exceed 10

            do j = 1,3
               v(j) = icorners(ipt2,j) - icorners(ipt1,j)
               isect_list(isect_cnt,j) = icorners(ipt1,j) + s*v(j)
            enddo
            call get_faces(iedge,if1,if2)
            edge_list(isect_cnt) = iedge
            face_list(isect_cnt,1) = if1
            face_list(isect_cnt,2) = if2
         endif
      enddo

c     # Find area of intersection of surface with x = 1 face.
c     # plist returns four corners of face at x = 1
      call get_face_vertices(1,iv_list)
      iv_list(5) = iv_list(1)

c     # Traverse points on face
      ipt1 = iv_list(1)
      if (icube(ipt1) .lt. 0) then
c        # Add first corner to list of polygon points
         ypoly(1) = icorners(ipt1,2)
         zpoly(1) = icorners(ipt1,3)
         poly_cnt = 1
      else
         poly_cnt = 0
      endif

      do i = 2,5
         ipt2 = iv_list(i)

c        # First check edge between ipt1 and ipt2
c        # An intersection point will always be added to the list
         s = edges(ipt1,ipt2)
         if (s .ge. 0.d0) then
            poly_cnt = poly_cnt + 1
            v(2) = icorners(ipt2,2) - icorners(ipt1,2)
            v(3) = icorners(ipt2,3) - icorners(ipt1,3)
            ypoly(poly_cnt) = icorners(ipt1,2) + s*v(2)
            zpoly(poly_cnt) = icorners(ipt1,3) + s*v(3)
         endif

c        # Now check if corner point should be added to list
         if (icube(ipt2) .lt. 0) then
            poly_cnt = poly_cnt + 1
            ypoly(poly_cnt) = icorners(ipt2,2)
            zpoly(poly_cnt) = icorners(ipt2,3)
         endif
         ipt1 = ipt2
      enddo                             !! end loop over corners of face

      area = 0.d0
      if (poly_cnt .gt. 2) then
c        # Compute area of polygon on x = xlow+ival*dx face.
         ypoly(poly_cnt+1) = ypoly(1)
         zpoly(poly_cnt+1) = zpoly(1)
         do  i = 1,poly_cnt
            area = area +
     &            0.5d0*(zpoly(i)+zpoly(i+1))*(ypoly(i+1)-ypoly(i))
         enddo
      endif

c     # First contribution to volume fraction
      w = abs(area)

c     # ------------------------------------------------------
c     # Get the integral (x*nx) for each triangle that
c     # makes up irregular cut surface

c     # Reorder points on isect_list so that we traverse the surface
c     # in the proper order

c     # Connectivity matrix for faces.  Two faces are connected
c     # if there is a surface intersection point between them
      do i = 0,5
         do j = 0,5
            faces(i,j) = 0
         enddo
      enddo

      do k = 1,isect_cnt
        if1 = face_list(k,1)
        if2 = face_list(k,2)
        faces(if1,if2) = k
        faces(if2,if1) = k
      enddo

c     # Faces adjacent to starting edge value
      if1_start = face_list(1,1)
      if2_start = face_list(1,2)
      if1_new = if1_start
      if2_new = if2_start

c     # Traverse edges by successively checking rows and columns
c     # of the connectivity matrix for positive entries
      d1 = 1  !! search directions.
      d2 = 0
      surf_cnt = 0
      done = .false.
      do while (.not. done)
c        # loop over row (if1; d1 == 1) or column (if2; d2 = 1)
         do i = 1,5
            if1 = mod(if1_new+i*mod(d1,2),6)
            if2 = mod(if2_new+i*mod(d2,2),6)
c           # k will be index into isect_list, the list of
c           # intersection points
            k = faces(if1,if2)
            if (k .gt. 0) then
               surf_cnt = surf_cnt + 1
               surf_list(surf_cnt) = k
               if1_new = if1
               if2_new = if2
c              # Portland compiler doesn't like 'exit'
c               exit
               goto 10
            endif
         enddo
   10    continue
c        # if dN is even, it becomes odd, and vice. versa.
         d1 = d1 + 1
         d2 = d2 + 1
         done = ((if1 .eq. if1_start .and. if2 .eq. if2_start) .or.
     &           (if2 .eq. if1_start .and. if1 .eq. if2_start))
      enddo

c     #  Compute integral (x*nx) over each triangle

c     # p0 is root vertex for surface triangulation
      do j = 1,3
         p0(j) = isect_list(surf_list(1),j)
      enddo

c     # Form triangles successively : (p0,p1,p2), where p1, p2 are
c     # incremented at each cycle through loop
      do i = 2,surf_cnt - 1
         do j = 1,3
            p1(j) = isect_list(surf_list(i),j)
            p2(j) = isect_list(surf_list(i+1),j)
            v1(j) = p1(j) - p0(j)
            v2(j) = p2(j) - p0(j)
         enddo
         tri_normal(1) =   v1(2)*v2(3) - v1(3)*v2(2)
         tri_normal(2) = -(v1(1)*v2(3) - v1(3)*v2(1))
         tri_normal(3) =   v1(1)*v2(2) - v1(2)*v2(1)
         dw = (p0(1) + p1(1) + p2(1))/6.d0

c        # 'get_updir' returns a vector dir = sgn*(1,0,0), sgn*(0,1,0) or
c        # sgn*(0,0,1).  'idir' indicates where the '1' is.
c        # Dot product of dir with tri_normal should give us
c        # the orientation of the surface.  Furthermore, because
c        # current triangle (p0,p1,p2) has one vertex at edge 'iedge'
c        # tri_normal(idir+1) is non-zero. If 'iedge' were to lie exactly
c        # on the surface,  then both endpoints of edge 'iedge' are on
c        # same side of surface, (the '+' side), and there would
c        # be no intersection at that edge.

         call get_updir(icube,edge_list(i),idir,sgn)
         w = w + sgn*sign(1.0d0,tri_normal(idir+1))
     &         *tri_normal(1)*dw
      enddo

      end

      integer function get_edge_dir(iedge)
      implicit none

      integer iedge
      get_edge_dir = iedge/4
      end

      subroutine get_endpoints(iedge,ipt1,ipt2)
      implicit none

      integer get_edge_dir
      integer iedge, ipt1, ipt2, idir, n
      integer kvec(0:1,0:2), k, i

      data kvec /1, 2, 0, 2, 0, 1/

      idir = get_edge_dir(iedge)
      n = iedge - 4*idir

      ipt1 = 0
      ipt2 = 0
      ipt2 = ibset(ipt2,idir)
      do i = 0,1
         if (ibits(n,i,1) .eq. 1) then
            k = kvec(i,idir)
            ipt1 = ibset(ipt1,k)
            ipt2 = ibset(ipt2,k)
         endif
      enddo
      end


      subroutine get_faces(iedge, if1,if2)
      implicit none

      integer iedge, if1, if2, ipt1,ipt2, icnt
      integer b1, b2,ifaces(2), idir

      call get_endpoints(iedge,ipt1,ipt2)

      icnt = 0
      do idir = 0,2
         b1 = ibits(ipt1,idir,1)
         b2 = ibits(ipt2,idir,1)
         if (b1 .eq. b2) then
            icnt = icnt + 1
            ifaces(icnt) = 2*idir + b1
         endif
      enddo
      if1 = ifaces(1)
      if2 = ifaces(2)

      end

      subroutine get_face_vertices(iface,plist)
      implicit none

      integer idir,ival, plist(5), iface
      integer ip, ipt, b, ptmp

      idir = iface/2
      ival = iface - 2*idir

      ip = 0
      do ipt = 0,7
         b = ibits(ipt,idir,1)
         if (b .eq. ival) then
            ip = ip + 1
            plist(ip) = ipt
         endif
      enddo

c     # Swap last two elements so that points traverse face, rather
c     # than criss-cross it.
      ptmp = plist(3)
      plist(3) = plist(4)
      plist(4) = ptmp

      end

      subroutine get_updir(icube,iedge,idir,sgn)
      implicit none

      integer get_edge_dir
      integer ipt1, ipt2, iedge,j,idir, diff
      integer icube(0:7), sgn

      call get_endpoints(iedge,ipt1,ipt2)

      sgn = sign(1,icube(ipt2) - icube(ipt1))
      idir = get_edge_dir(iedge)

      end

      double precision function fs(s)
      implicit none

      double precision x,y,z, fdisc
      double precision xl,xh,yl,yh,zl,zh,s

      common /comfs/ xl,xh,yl,yh,zl,zh

      x = xl + s*(xh - xl)
      y = yl + s*(yh - yl)
      z = zl + s*(zh - zl)

      fs = fdisc(x,y,z)

      end



c     =================================================
      double precision function zeroin_cellave(ax,bx,f,tol)
c     =================================================
      implicit none
      external f
c
c      a zero of the function  f(x)  is computed in the interval ax,bx .
c      (Standard routine from netlib)
c
c  input..
c
c  ax     left endpoint of initial interval
c  bx     right endpoint of initial interval
c  f      function subprogram which evaluates f(x) for any x in
c         the interval  ax,bx
c  tol    desired length of the interval of uncertainty of the
c         final result ( .ge. 0.0)
c
c
c  output..
c
c  zeroin abcissa approximating a zero of  f  in the interval ax,bx
c
c
c      it is assumed  that   f(ax)   and   f(bx)   have  opposite  signs
c  without  a  check.  zeroin  returns a zero  x  in the given interval
c  ax,bx  to within a tolerance  4*macheps*dabs(x) + tol, where macheps
c  is the relative machine precision.
c      this function subprogram is a slightly  modified  translation  of
c  the algol 60 procedure  zero  given in  richard brent, algorithms for
c  minimization without derivatives, prentice - hall, inc. (1973).
c
c
c
c  compute eps, the relative machine precision
c

      double precision ax,bx,tol, f, eps, tol1, a,b,c,d,e
      double precision fa,fb,fc, xm, p, q, r, s

      eps = 1.0
   10 eps = eps/2.0
      tol1 = 1.0 + eps
      if (tol1 .gt. 1.0) go to 10
c
c initialization
c
      a = ax
      b = bx
      fa = f(a)
      fb = f(b)
c
c begin step
c
   20 c = a
      fc = fa
      d = b - a
      e = d
   30 if (dabs(fc) .ge. dabs(fb)) go to 40
      a = b
      b = c
      c = a
      fa = fb
      fb = fc
      fc = fa
c
c convergence test
c
   40 tol1 = 2.0*eps*dabs(b) + 0.5*tol
      xm = .5*(c - b)
      if (dabs(xm) .le. tol1) go to 90
      if (fb .eq. 0.0) go to 90
c
c is bisection necessary
c
      if (dabs(e) .lt. tol1) go to 70
      if (dabs(fa) .le. dabs(fb)) go to 70
c
c is quadratic interpolation possible
c
      if (a .ne. c) go to 50
c
c linear interpolation
c
      s = fb/fa
      p = 2.0*xm*s
      q = 1.0 - s
      go to 60
c
c inverse quadratic interpolation
c
   50 q = fa/fc
      r = fb/fc
      s = fb/fa
      p = s*(2.0*xm*q*(q - r) - (b - a)*(r - 1.0))
      q = (q - 1.0)*(r - 1.0)*(s - 1.0)
c
c adjust signs
c
   60 if (p .gt. 0.0) q = -q
      p = dabs(p)
c
c is interpolation acceptable
c
      if ((2.0*p) .ge. (3.0*xm*q - dabs(tol1*q))) go to 70
      if (p .ge. dabs(0.5*e*q)) go to 70
      e = d
      d = p/q
      go to 80
c
c bisection
c
   70 d = xm
      e = d
c
c complete step
c
   80 a = b
      fa = fb
      if (dabs(d) .gt. tol1) b = b + d
      if (dabs(d) .le. tol1) b = b + dsign(tol1, xm)
      fb = f(b)
      if ((fb*(fc/dabs(fc))) .gt. 0.0) go to 20
      go to 30
c
c done
c
   90 zeroin_cellave = b
      return
      end

subroutine rpt2(ixy, imp, maxm, num_eqn, num_waves, num_aux, num_ghost,   &
                num_cells, ql, qr, aux1, aux2, aux3, asdq, bmasdq, bpasdq)
! Transverse solver for shallow water with bathymetry using an fwave solver
! Note that this solver does NOT handle dry-states
!
! (h)_t + (h*u)_x = 0
! (hu)_t + (h*u^2 + 1/2*grav*h^2)_x + (h*u*v)_y = -grav*h*(b)_x
! (hv)_t + (h*u*v)_x + (h*v^2 + 1/2*grav*h^2)_y = -grav*h*(b)_y
!
! using the f-wave algorithm and Roe's approximate Riemann solver.  
!
! waves:     3
! equations: 3
!
! Conserved quantities:
!       1 depth
!       2 x_momentum
!       3 y_momentum
!
! Auxiliary fields:
!       1 bathymetry
!
! The gravitational constant grav should be in the common block cparam.
!
! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

    implicit none

    ! Input
    integer, intent(in) :: ixy, imp, maxm, num_eqn, num_waves, num_aux
    integer, intent(in) :: num_ghost, num_cells
    real(kind=8), intent(in) :: ql(num_eqn, 1 - num_ghost:maxm + num_ghost)
    real(kind=8), intent(in) :: qr(num_eqn, 1 - num_ghost:maxm + num_ghost)
    real(kind=8), intent(in) :: aux1(num_aux, 1 - num_ghost:maxm + num_ghost)
    real(kind=8), intent(in) :: aux2(num_aux, 1 - num_ghost:maxm + num_ghost)
    real(kind=8), intent(in) :: aux3(num_aux, 1 - num_ghost:maxm + num_ghost)
    real(kind=8), intent(in) :: asdq(num_eqn, 1 - num_ghost:maxm + num_ghost)

    ! Output
    real(kind=8), intent(out) :: bmasdq(num_eqn, 1 - num_ghost:maxm + num_ghost)
    real(kind=8), intent(out) :: bpasdq(num_eqn, 1 - num_ghost:maxm + num_ghost)

    ! Local
    integer :: i, k, normal_index, transverse_index
    real(kind=8) :: h_l, h_r, u_l, u_r, v_l, v_r, h_bar, h_root, u_hat, v_hat
    real(kind=8) :: dry_state_l, dry_state_r, s(3), beta(3), R(3, 3)

    ! Parameters
    real(kind=8) :: grav, dry_tolerance, sea_level
    common /cparam/ grav, dry_tolerance, sea_level

    ! Deterimine direction of solve
    if (ixy == 1) then
        normal_index = 2
        transverse_index = 3
    else
        normal_index = 3
        transverse_index = 2
    end if

    ! Primary loop over cell edges
    do i = 2 - num_ghost, num_cells + num_ghost
        
        ! Check for dry states - need merge here to convert to float
        dry_state_l = merge(0.d0, 1.d0, qr(1, i - 1) < dry_tolerance)
        dry_state_r = merge(0.d0, 1.d0, ql(1, i) < dry_tolerance)

        ! Extract state variables
        h_l = qr(1, i - 1) * dry_state_l
        u_l = qr(normal_index, i - 1) / qr(1, i - 1) * dry_state_l
        v_l = qr(transverse_index, i - 1) / qr(1, i - 1) * dry_state_l

        h_r = ql(1, i) * dry_state_r
        u_r = ql(normal_index, i) / ql(1, i) * dry_state_r
        v_r = ql(transverse_index, i) / ql(1, i) * dry_state_r

        ! Determine speeds for the Jacobian
        h_bar = 0.5d0 * (h_r + h_l)
        h_root = sqrt(h_r) + sqrt(h_l)
        v_hat = (v_r * sqrt(h_r)) / h_root + (v_l * sqrt(h_l)) / h_root
        u_hat = (u_r * sqrt(h_r)) / h_root + (u_l * sqrt(h_l)) / h_root

        s(1) = min(v_hat - sqrt(grav * h_bar), v_l - sqrt(grav * h_l))
        s(3) = max(v_hat + sqrt(grav * h_bar), v_r + sqrt(grav * h_r))
        s(2) = 0.5d0 * (s(1) + s(2))

        ! Determine asdq decompisition
        beta(1) = s(3) * asdq(1, i) / (s(3) - s(1))                 &
                                - asdq(transverse_index, i) / (s(3) - s(1))
        beta(2) = -s(2) * asdq(1, i) + asdq(normal_index, i)
        beta(3) = asdq(transverse_index, i) / (s(3) - s(1))         &
                                - (s(1) * asdq(1, i) / (s(3) - s(1)))

        ! Eigenvectors
        R(1, :) = [1.d0, 0.d0, 1.d0]
        R(2, :) = [s(2), 1.d0, s(2)]
        R(3, :) = [s(1), 0.d0, s(3)]

        ! Compute fluctuations
        do k = 1, num_waves
            if (s(k) < 0.d0) then
                bmasdq(1, i) = bmasdq(1, i) + s(k) * beta(k) * R(1, k)
                bmasdq(normal_index, i) = bmasdq(normal_index, i)              &
                                                + s(k) * beta(k) * R(2, k)
                bmasdq(transverse_index, i) = bmasdq(transverse_index, i)      &
                                                + s(k) * beta(k) * R(3, k)
            else
                bpasdq(1, i) = bpasdq(1, i) + s(k) * beta(k) * R(1, k)
                bpasdq(normal_index, i) = bpasdq(normal_index, i)              &
                                                + s(k) * beta(k) * R(2, k)
                bpasdq(transverse_index, i) = bpasdq(transverse_index, i)      &
                                                + s(k) * beta(k) * R(3, k)
            end if
        end do

    end do  ! End of primary loop

end subroutine rpt2

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.

    use geoclaw_module, only: sea_level
    use grid_module, only: xcell

    ! uncomment if any of these needed...
    !use geoclaw_module, only: dry_tolerance, grav

    implicit none

    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    !locals
    integer :: i

    real(kind=8) :: eta, width, x0, ampl, wavelength, pi, freq

    width = 100.    ! controls width of Gaussian
    x0 = 0.d0   ! initial location of Gaussian
    ampl = 5.0d0  ! amplitude
    !wavelength = 10d3
    !freq = 0.d0  !1.d0/wavelength
    pi = acos(-1d0)

    do i=1,mx
      !eta = ampl * exp(-((xcell(i)-x0)/width)**2) * cos(2*pi*xcell(i)*freq)
      eta = ampl * exp(-((xcell(i)-x0)/width)**2)
      q(1,i) = max(sea_level, eta - aux(1,i))
      q(2,i) = 0.d0  !eta*sqrt(grav*q(1,i))  ! right-going

   enddo


end subroutine qinit

c
c ----------------------------------------------------------
c
      subroutine fluxsv(mptr,xfluxm,xfluxp,yfluxm,yfluxp,zfluxm,zfluxp,
     1                  listbc,
     2                  ndimx,ndimy,ndimz,nvar,maxsp,dtc,hx,hy,hz)
c
      use amr_module
      implicit double precision (a-h,o-z)

      parameter(numbcs=6)

      dimension xfluxm(nvar,ndimx,ndimy,ndimz)
      dimension xfluxp(nvar,ndimx,ndimy,ndimz)
      dimension yfluxm(nvar,ndimx,ndimy,ndimz)
      dimension yfluxp(nvar,ndimx,ndimy,ndimz)
      dimension zfluxm(nvar,ndimx,ndimy,ndimz)
      dimension zfluxp(nvar,ndimx,ndimy,ndimz)
      dimension listbc(numbcs,maxsp)
c
c :::::::::::::::::::: FLUXSV :::::::::::::::::::::::::
c
c  coarse grids should save their fluxes in cells adjacent to
c  their nested fine grids, for later conservation fixing.
c  listbc holds info for where to save which fluxes.
c  xflux holds 'f' fluxes, yflux holds 'g' fluxes, zflux holds 'h' fluxes.
c
c :::::::::::::::::::::::::::::;:::::::::::::::::::::::
 
 
      ispot   = 1
      level   = node(nestlevel,mptr)

 10      if (listbc(1,ispot).eq.0) go to 99          
c
         mkid     = listbc(5,ispot)
         intopl   = listbc(6,ispot)
         nx       = node(ndihi,mkid) - node(ndilo,mkid) + 1
         ny       = node(ndjhi,mkid) - node(ndjlo,mkid) + 1
         nz       = node(ndkhi,mkid) - node(ndklo,mkid) + 1
         kidlst   = node(ffluxptr,mkid)
         i        = listbc(1,ispot)
         j        = listbc(2,ispot)
         k        = listbc(3,ispot)
         inlist   = kidlst + nvar*(intopl-1) - 1

         if (listbc(4,ispot) .eq. 1) then
c           ::::: Cell i,j,k is on right side of a fine grid
            do 100 ivar = 1, nvar
              alloc(inlist + ivar) = -xfluxp(ivar,i  ,j  ,k  )*dtc*hy*hz
100         continue
         endif

         if (listbc(4,ispot) .eq. 2) then
c           ::::: Cell i,j,k is on front side of fine grid
            do 200 ivar = 1, nvar
              alloc(inlist + ivar) = -yfluxm(ivar,i  ,j+1,k  )*dtc*hx*hz
200         continue
         endif

         if (listbc(4,ispot) .eq. 3) then
c           ::::: Cell i,j,k is on left side of fine grid
            do 300 ivar = 1, nvar
              alloc(inlist + ivar) = -xfluxm(ivar,i+1,j  ,k  )*dtc*hy*hz
300         continue
         endif

         if (listbc(4,ispot) .eq. 4) then
c           ::::: Cell i,j,k is on rear side of fine grid
            do 400 ivar = 1, nvar
              alloc(inlist + ivar) = -yfluxp(ivar,i  ,j  ,k  )*dtc*hx*hz
400         continue
         endif

         if (listbc(4,ispot) .eq. 5) then
c           ::::: Cell i,j,k is on top side of fine grid
            do 500 ivar = 1, nvar
              alloc(inlist + ivar) = -zfluxp(ivar,i  ,j  ,k  )*dtc*hx*hy
500         continue
         endif

         if (listbc(4,ispot) .eq. 6) then
c           ::::: Cell i,j,k is on bottom side of fine grid
            do 600 ivar = 1, nvar
              alloc(inlist + ivar) = -zfluxm(ivar,i  ,j  ,k+1)*dtc*hx*hy
600         continue
         endif
c
      ispot = ispot + 1
      if (ispot .gt. maxsp) go to 99
      go to 10
c
 99   return
      end

c
c ------------------------------------------------------------------
c
       subroutine setuse(listbc,maxsp,ispot,mkid,
     1                   ilo,ihi,jlo,jhi,klo,khi,
     2                   iclo,ichi,jclo,jchi,kclo,kchi,nghost)
c
c ::::::::::::::::::::::::: SETUSE ::::::::::::::::::::::::::::::::
c
c set up boundary list for coarse grid, to be used by fluxsv. 
c loop around boundary of c fine grids to do this.  each entry has
c     i, j, k, side #, fine grid #, loc in fine grid list for fluxes.
c  for example, side 1 of fine grid fixes side 3 of coarse grid,
c  so coarse grid list will store the # 3.
c  wrt coarse grid, in the xy plane, the sides are:
c              2
c           1     3            that is, right edge of a coarse cell = 3
c              4                         rear edge of a coarse cell = 2
c  and in the xz plane the sides are:
c              6
c           1     3            that is, right face of a coarse cell = 3
c              5                       bottom face of a coarse cell = 5
c
c  # lkid is the index into the fine grid's saved fluxes.
c  # the fine grid will save all its fluxes all around its
c  # perimeter. lkid tells where the coarse grid should
c  # taking them from.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      implicit double precision (a-h,o-z)
      parameter(numbcs=6)
      dimension listbc(numbcs,maxsp)

      ibc = ispot
      ist  = iclo - 1
      iend = ichi + 1
      jst  = jclo - 1
      jend = jchi + 1
      kst  = kclo - 1
      kend = kchi + 1
c
c  left side
c
       if (ist .lt. ilo) go to 20
c2D    lkid     = max(jlo,jclo) - jclo + 1
       do 15 k  = max(klo,kclo), min(khi,kchi)
       lkid     = (k-kclo)*(jchi-jclo+1) +
     1            max(jlo,jclo) - jclo + 1
       do 10 j  = max(jlo,jclo), min(jhi,jchi)
          ispot              = ispot + 1
          listbc(1,ispot)    = ist-ilo+nghost+1
          listbc(2,ispot)    = j-jlo+nghost+1
          listbc(3,ispot)    = k-klo+nghost+1
          listbc(4,ispot)    = 3
          listbc(5,ispot)    = mkid
          listbc(6,ispot)    = lkid
          lkid               = lkid + 1
 10    continue
 15    continue
c
c   rear side
c
 20    if (jend .gt. jhi) go to 40
c2D    lkid       = (jchi-jclo+1) + max(ilo,iclo)-iclo + 1
       do 35 k  = max(klo,kclo), min(khi,kchi)
       lkid     = (kchi-kclo+1)*(jchi-jclo+1) +
     1            (k-kclo)*(ichi-iclo+1) +
     2            max(ilo,iclo)-iclo + 1
       do 30 i    = max(ilo,iclo), min(ihi,ichi)
          ispot              = ispot + 1
          listbc(1,ispot)    = i-ilo+nghost+1
          listbc(2,ispot)    = jend-jlo+nghost+1
          listbc(3,ispot)    = k-klo+nghost+1
          listbc(4,ispot)    = 4
          listbc(5,ispot)    = mkid
          listbc(6,ispot)    = lkid
          lkid               = lkid + 1
 30    continue
 35    continue
c
c  right side (numbered from bottom to top, so not continuous)
c
 40    if (iend .gt. ihi) go to 60
c2D    lkid     = (ichi-iclo+1)+(jchi-jclo+1)
c2D  .               + max(jlo,jclo) - jclo + 1
       do 55 k  = max(klo,kclo), min(khi,kchi)
       lkid     = (kchi-kclo+1)*(jchi-jclo+1) +
     1            (kchi-kclo+1)*(ichi-iclo+1) +
     2            (k-kclo)*(jchi-jclo+1) +
     3            max(jlo,jclo) - jclo + 1
       do 50 j  = max(jlo,jclo), min(jhi,jchi)
          ispot              = ispot + 1
          listbc(1,ispot)    = iend-ilo+nghost+1
          listbc(2,ispot)    = j-jlo+nghost+1
          listbc(3,ispot)    = k-klo+nghost+1
          listbc(4,ispot)    = 1
          listbc(5,ispot)    = mkid
          listbc(6,ispot)    = lkid
          lkid   = lkid + 1
 50    continue
 55    continue
c
c  front  side (numbered left to right, so not continuous)
c
 60    if (jst .lt. jlo) go to 80
c2D    lkid   =  2*(jchi-jclo+1) + (ichi-iclo+1) + max(ilo,iclo)-iclo+1
       do 75 k  = max(klo,kclo), min(khi,kchi)
       lkid     = (kchi-kclo+1)*(jchi-jclo+1) +
     1            (kchi-kclo+1)*(ichi-iclo+1) +
     2            (kchi-kclo+1)*(jchi-jclo+1) +
     3            (k-kclo)*(ichi-iclo+1) +
     4            max(ilo,iclo)-iclo + 1
       do 70 i  = max(ilo,iclo), min(ihi,ichi)
          ispot              = ispot + 1
          listbc(1,ispot)    = i-ilo+nghost+1
          listbc(2,ispot)    = jst-jlo+nghost+1
          listbc(3,ispot)    = k-klo+nghost+1
          listbc(4,ispot)    = 2
          listbc(5,ispot)    = mkid
          listbc(6,ispot)    = lkid
          lkid   = lkid + 1
 70    continue
 75    continue
c
c  bottom side
c
 80    if (kst .lt. klo) go to 100
       do 95 j  = max(jlo,jclo), min(jhi,jchi)
       lkid     = (kchi-kclo+1)*(jchi-jclo+1) +
     1            (kchi-kclo+1)*(ichi-iclo+1) +
     2            (kchi-kclo+1)*(jchi-jclo+1) +
     3            (kchi-kclo+1)*(ichi-iclo+1) +
     4            (j-jclo)*(ichi-iclo+1) +
     5            max(ilo,iclo)-iclo + 1
       do 90 i  = max(ilo,iclo), min(ihi,ichi)
          ispot              = ispot + 1
          listbc(1,ispot)    = i-ilo+nghost+1
          listbc(2,ispot)    = j-jlo+nghost+1
          listbc(3,ispot)    = kst-klo+nghost+1
          listbc(4,ispot)    = 6
          listbc(5,ispot)    = mkid
          listbc(6,ispot)    = lkid
          lkid   = lkid + 1
 90    continue
 95    continue
c
c   top side
c
100    if (kend .gt. khi) go to 120
       do 115 j = max(jlo,jclo), min(jhi,jchi)
       lkid     = (kchi-kclo+1)*(jchi-jclo+1) +
     1            (kchi-kclo+1)*(ichi-iclo+1) +
     2            (kchi-kclo+1)*(jchi-jclo+1) +
     3            (kchi-kclo+1)*(ichi-iclo+1) +
     4            (jchi-jclo+1)*(ichi-iclo+1) +
     5            (j-jclo)*(ichi-iclo+1) +
     6            max(ilo,iclo)-iclo + 1
       do 110 i = max(ilo,iclo), min(ihi,ichi)
          ispot              = ispot + 1
          listbc(1,ispot)    = i-ilo+nghost+1
          listbc(2,ispot)    = j-jlo+nghost+1
          listbc(3,ispot)    = kend-klo+nghost+1
          listbc(4,ispot)    = 5
          listbc(5,ispot)    = mkid
          listbc(6,ispot)    = lkid
          lkid               = lkid + 1
 110   continue
 115   continue
c
 120   continue
       return
       end

    ! This code has been adapted for vectorization. 
! For more details on how to use it, see the Makefile of the chile2010 example.

!-----------------------------------------------------------------------
      subroutine riemann_aug_JCP(maxiter,meqn,mwaves,hL,hR,huL,huR, &
        hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,rho, &
        sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33)
      !dir$ attributes forceinline :: riemann_aug_JCP
      !dir$ attributes vector: uniform(maxiter,meqn,mwaves,drytol,g,rho) :: riemann_aug_JCP

      ! solve shallow water equations given single left and right states
      ! This solver is described in J. Comput. Phys. (6): 3089-3113, March 2008
      ! Augmented Riemann Solvers for the Shallow Equations with Steady States and Inundation

      ! To use the original solver call with maxiter=1.

      ! This solver allows iteration when maxiter > 1. The iteration seems to help with
      ! instabilities that arise (with any solver) as flow becomes transcritical over variable topo
      ! due to loss of hyperbolicity.

      implicit none

      !input
      integer meqn,mwaves,maxiter
      
      !  Due to what seems to be a bug with the Intel Compilers (versions 16, 17 and 18 at least),
      !  these arrays declared as PRIVATE in a !$OMP SIMD loop (in rpn2_geoclaw_vec.f90) had 
      !  to be decomposed into scalars.
      !  This may not be necessary for future versions of the Intel Compilers.
      
      !real(kind=8) fw(meqn,mwaves)
      !real(kind=8) sw(mwaves)
      real(kind=8) sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33
      real(kind=8) hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,sE1,sE2
      real(kind=8) hvL,hvR,vL,vR,pL,pR
      real(kind=8) drytol,g,rho


      !local
      integer m,mw,k,iter
      real(kind=8) A(3,3)
      real(kind=8) r(3,3)
      real(kind=8) lambda(3)
      real(kind=8) del(3)
      real(kind=8) beta(3)

      real(kind=8) delh,delhu,delphi,delb,delnorm
      real(kind=8) rare1st,rare2st,sdelta,raremin,raremax
      real(kind=8) criticaltol,convergencetol,raretol
      real(kind=8) criticaltol_2, hustar_interface
      real(kind=8) s1s2bar,s1s2tilde,hbar,hLstar,hRstar,hustar
      real(kind=8) huRstar,huLstar,uRstar,uLstar,hstarHLL
      real(kind=8) deldelh,deldelphi,delP
      real(kind=8) s1m,s2m,hm
      real(kind=8) det1,det2,det3,determinant

      logical rare1,rare2,rarecorrector,rarecorrectortest,sonic
      
      ! used to pre-compute square roots
      real(kind=8) sqrt_ghL, sqrt_ghR, sqrt_ghm

      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL
      delP = pR - pL
      delnorm = delh**2 + delphi**2

      !DIR$ FORCEINLINE
      call riemanntype(hL,hR,uL,uR,hm,s1m,s2m,rare1,rare2, &
                                               1,drytol,g)

      ! pre-compute square roots:
      sqrt_ghL = sqrt(g*hL)
      sqrt_ghR = sqrt(g*hR)
      sqrt_ghm = sqrt(g*hm)

      lambda(1)= min(sE1,s2m) !Modified Einfeldt speed
      lambda(3)= max(sE2,s1m) !Modified Eindfeldt speed
      sE1=lambda(1)
      sE2=lambda(3)
      lambda(2) = 0.d0  ! ### Fix to avoid uninitialized value in loop on mw -- Correct?? ###

      
      hstarHLL = max((huL-huR+sE2*hR-sE1*hL)/(sE2-sE1),0.d0) ! middle state in an HLL solve

      !determine the middle entropy corrector wave------------------------
      rarecorrectortest=.false.
      rarecorrector=.false.
      if (rarecorrectortest) then
         sdelta=lambda(3)-lambda(1)
         raremin = 0.5d0
         raremax = 0.9d0
         if (rare1.and.sE1*s1m.lt.0.d0) raremin=0.2d0
         if (rare2.and.sE2*s2m.lt.0.d0) raremin=0.2d0
         if (rare1.or.rare2) then
            !see which rarefaction is larger
            rare1st=3.d0*(sqrt_ghL-sqrt_ghm)
            rare2st=3.d0*(sqrt_ghR-sqrt_ghm)
            if (max(rare1st,rare2st).gt.raremin*sdelta.and. &
              max(rare1st,rare2st).lt.raremax*sdelta) then
                  rarecorrector=.true.
               if (rare1st.gt.rare2st) then
                  lambda(2)=s1m
               elseif (rare2st.gt.rare1st) then
                  lambda(2)=s2m
               else
                  lambda(2)=0.5d0*(s1m+s2m)
               endif
            endif
         endif
         if (hstarHLL.lt.min(hL,hR)/5.d0) rarecorrector=.false.
      endif

!     ## Is this correct 2-wave when rarecorrector == .true. ??
      do mw=1,mwaves
         r(1,mw)=1.d0
         r(2,mw)=lambda(mw)
         r(3,mw)=(lambda(mw))**2
      enddo
      if (.not.rarecorrector) then
         lambda(2) = 0.5d0*(lambda(1)+lambda(3))
         !lambda(2) = max(min(0.5d0*(s1m+s2m),sE2),sE1)
         r(1,2)=0.d0
         r(2,2)=0.d0
         r(3,2)=1.d0
      endif
      !---------------------------------------------------


      !determine the steady state wave -------------------
      !criticaltol = 1.d-6
      ! MODIFIED:
      criticaltol = max(drytol*g, 1d-6)
      criticaltol_2 = sqrt(criticaltol)
      deldelh = -delb
      deldelphi = -0.5d0 * (hR + hL) * (g * delb + delp / rho)

      !determine a few quanitites needed for steady state wave if iterated
      hLstar=hL
      hRstar=hR
      uLstar=uL
      uRstar=uR
      huLstar=uLstar*hLstar
      huRstar=uRstar*hRstar

      !iterate to better determine the steady state wave
      convergencetol=1.d-6
!      do iter=1,maxiter  ! since maxiter=1, no loop needed!
         !determine steady state wave (this will be subtracted from the delta vectors)
         if (min(hLstar,hRstar).lt.drytol.and.rarecorrector) then
            rarecorrector=.false.
            hLstar=hL
            hRstar=hR
            uLstar=uL
            uRstar=uR
            huLstar=uLstar*hLstar
            huRstar=uRstar*hRstar
            lambda(2) = 0.5d0*(lambda(1)+lambda(3))
            !lambda(2) = max(min(0.5d0*(s1m+s2m),sE2),sE1)
            r(1,2)=0.d0
            r(2,2)=0.d0
            r(3,2)=1.d0
         endif

         hbar =  max(0.5d0*(hLstar+hRstar),0.d0)
         s1s2bar = 0.25d0*(uLstar+uRstar)**2 - g*hbar
         s1s2tilde= max(0.d0,uLstar*uRstar) - g*hbar

         !find if sonic problem
         ! MODIFIED from 5.3.1 version
         sonic = .false.
         if (abs(s1s2bar) <= criticaltol) then
            sonic = .true.
         else if (s1s2bar*s1s2tilde <= criticaltol**2) then
            sonic = .true.
         else if (s1s2bar*sE1*sE2 <= criticaltol**2) then
            sonic = .true.
         else if (min(abs(sE1),abs(sE2)) < criticaltol_2) then
            sonic = .true.
         else if (sE1 <  criticaltol_2 .and. s1m > -criticaltol_2) then
            sonic = .true.
         else if (sE2 > -criticaltol_2 .and. s2m <  criticaltol_2) then
            sonic = .true.
         else if ((uL+sqrt_ghL)*(uR+sqrt_ghR) < 0.d0) then
            sonic = .true.
         else if ((uL- sqrt_ghL)*(uR- sqrt_ghR) < 0.d0) then
            sonic = .true.
         end if

         !find jump in h, deldelh
         if (sonic) then
            deldelh =  -delb
         else
            deldelh = delb*g*hbar/s1s2bar
         endif
         !find bounds in case of critical state resonance, or negative states
         if (sE1.lt.-criticaltol.and.sE2.gt.criticaltol) then
            deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE2)
            deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE1)
         elseif (sE1.ge.criticaltol) then
            deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE1)
            deldelh = max(deldelh,-hL)
         elseif (sE2.le.-criticaltol) then
            deldelh = min(deldelh,hR)
            deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE2)
         endif

         !find jump in phi, deldelphi
         if (sonic) then
            deldelphi = -g*hbar*delb
         else
            deldelphi = -delb*g*hbar*s1s2tilde/s1s2bar
         endif
         !find bounds in case of critical state resonance, or negative states
         deldelphi=min(deldelphi,g*max(-hLstar*delb,-hRstar*delb))
         deldelphi=max(deldelphi,g*min(-hLstar*delb,-hRstar*delb))
         deldelphi = deldelphi - hbar * delp / rho

         del(1)=delh-deldelh
         del(2)=delhu
         del(3)=delphi-deldelphi

         !Determine determinant of eigenvector matrix========
         det1=r(1,1)*(r(2,2)*r(3,3)-r(2,3)*r(3,2))
         det2=r(1,2)*(r(2,1)*r(3,3)-r(2,3)*r(3,1))
         det3=r(1,3)*(r(2,1)*r(3,2)-r(2,2)*r(3,1))
         determinant=det1-det2+det3

         !solve for beta(k) using Cramers Rule=================
         do k=1,3
            do mw=1,3
                  A(1,mw)=r(1,mw)
                  A(2,mw)=r(2,mw)
                  A(3,mw)=r(3,mw)
            enddo
            A(1,k)=del(1)
            A(2,k)=del(2)
            A(3,k)=del(3)
            det1=A(1,1)*(A(2,2)*A(3,3)-A(2,3)*A(3,2))
            det2=A(1,2)*(A(2,1)*A(3,3)-A(2,3)*A(3,1))
            det3=A(1,3)*(A(2,1)*A(3,2)-A(2,2)*A(3,1))
            beta(k)=(det1-det2+det3)/determinant
         enddo

         !exit if things aren't changing -> removed to allow vectorization!
         !if (abs(del(1)**2+del(3)**2-delnorm).lt.convergencetol) exit
         delnorm = del(1)**2+del(3)**2
         !find new states qLstar and qRstar on either side of interface
         hLstar=hL
         hRstar=hR
         uLstar=uL
         uRstar=uR
         huLstar=uLstar*hLstar
         huRstar=uRstar*hRstar
         do mw=1,mwaves
            if (lambda(mw).lt.0.d0) then
               hLstar= hLstar + beta(mw)*r(1,mw)
               huLstar= huLstar + beta(mw)*r(2,mw)
            endif
         enddo
         do mw=mwaves,1,-1
            if (lambda(mw).gt.0.d0) then
               hRstar= hRstar - beta(mw)*r(1,mw)
               huRstar= huRstar - beta(mw)*r(2,mw)
            endif
         enddo

         if (hLstar.gt.drytol) then
            uLstar=huLstar/hLstar
         else
            hLstar=max(hLstar,0.d0)
            uLstar=0.d0
         endif
         if (hRstar.gt.drytol) then
            uRstar=huRstar/hRstar
         else
            hRstar=max(hRstar,0.d0)
            uRstar=0.d0
         endif

  !    enddo ! end iteration on Riemann problem  ! since maxiter=1, no loop needed!

!       do mw=1,mwaves
!          sw(mw)=lambda(mw)
!          fw(1,mw)=beta(mw)*r(2,mw)
!          fw(2,mw)=beta(mw)*r(3,mw)
!          fw(3,mw)=beta(mw)*r(2,mw)
!       enddo
      sw1 = lambda(1)
      sw2 = lambda(2)
      sw3 = lambda(3)
      !mw=1
      fw11 = beta(1)*r(2,1)
      fw21 = beta(1)*r(3,1)
      fw31 = beta(1)*r(2,1)
      !mw=2
      fw12 = beta(2)*r(2,2)
      fw22 = beta(2)*r(3,2)
      fw32 = beta(2)*r(2,2)
      !mw=3
      fw13 = beta(3)*r(2,3)
      fw23 = beta(3)*r(3,3)
      fw33 = beta(3)*r(2,3)

      !find transverse components (ie huv jumps).
      ! MODIFIED from 5.3.1 version
!       fw(3,1)=fw(3,1)*vL
!       fw(3,3)=fw(3,3)*vR
!       fw(3,2)= 0.d0
      fw31=fw31*vL
      fw33=fw33*vR
      fw32=0.d0
 
!       hustar_interface = huL + fw(1,1)   ! = huR - fw(1,3)
!       if (hustar_interface <= 0.0d0) then
!           fw(3,1) = fw(3,1) + (hR*uR*vR - hL*uL*vL - fw(3,1)- fw(3,3))
!         else
!           fw(3,3) = fw(3,3) + (hR*uR*vR - hL*uL*vL - fw(3,1)- fw(3,3))
!       end if
      hustar_interface = huL + fw11   ! = huR - fw(1,3)
      if (hustar_interface <= 0.0d0) then
          fw31 = fw31 + (hR*uR*vR - hL*uL*vL - fw31- fw33)
        else
          fw33 = fw33 + (hR*uR*vR - hL*uL*vL - fw31- fw33)
      end if


      return

      end !subroutine riemann_aug_JCP-------------------------------------------------


!=============================================================================
      subroutine riemanntype(hL,hR,uL,uR,hm,s1m,s2m,rare1,rare2, &
                  maxiter,drytol,g)

      !determine the Riemann structure (wave-type in each family)


      implicit none

      !input
      real(kind=8) hL,hR,uL,uR,drytol,g
      integer maxiter

      !output
      real(kind=8) s1m,s2m
      logical rare1,rare2

      !local
      real(kind=8) hm,u1m,u2m,um,delu
      real(kind=8) h_max,h_min,h0,F_max,F_min,dfdh,F0,slope,gL,gR
      integer iter
      real(kind=8) sqrt_ghL, sqrt_ghR



      !Test for Riemann structure

      h_min=min(hR,hL)
      h_max=max(hR,hL)
      delu=uR-uL
      
      ! pre-compute square roots:
      sqrt_ghL = sqrt(g*hL)
      sqrt_ghR = sqrt(g*hR)

      if (h_min.le.drytol) then
         hm=0.d0
         um=0.d0
         s1m=uR+uL-2.d0*sqrt_ghR+2.d0*sqrt_ghL
         s2m=uR+uL-2.d0*sqrt_ghR+2.d0*sqrt_ghL
         if (hL.le.0.d0) then
            rare2=.true.
            rare1=.false.
         else
            rare1=.true.
            rare2=.false.
         endif

      else
         F_min= delu+2.d0*(sqrt(g*h_min)-sqrt(g*h_max))
         F_max= delu + &
              (h_max-h_min)*(sqrt(.5d0*g*(h_max+h_min)/(h_max*h_min))) 

         if (F_min.gt.0.d0) then !2-rarefactions

            hm=(1.d0/(16.d0*g))* &
                    max(0.d0,-delu+2.d0*(sqrt_ghL+sqrt_ghR))**2
            um=sign(1.d0,hm)*(uL+2.d0*(sqrt_ghL-sqrt(g*hm)))

            s1m=uL+2.d0*sqrt_ghL-3.d0*sqrt(g*hm)
            s2m=uR-2.d0*sqrt_ghR+3.d0*sqrt(g*hm)

            rare1=.true.
            rare2=.true.

         elseif (F_max.le.0.d0) then !2 shocks

            !root finding using a Newton iteration on sqrt(h)===
            h0=h_max
            do iter=1,maxiter
               gL=sqrt(.5d0*g*(1/h0 + 1/hL))
               gR=sqrt(.5d0*g*(1/h0 + 1/hR))
               F0=delu+(h0-hL)*gL + (h0-hR)*gR
               dfdh=gL-g*(h0-hL)/(4.d0*(h0**2)*gL)+ &
                        gR-g*(h0-hR)/(4.d0*(h0**2)*gR)
               slope=2.d0*sqrt(h0)*dfdh
               h0=(sqrt(h0)-F0/slope)**2
            enddo
               hm=h0
               u1m=uL-(hm-hL)*sqrt((.5d0*g)*(1/hm + 1/hL))
               u2m=uR+(hm-hR)*sqrt((.5d0*g)*(1/hm + 1/hR))
               um=.5d0*(u1m+u2m)

               s1m=u1m-sqrt(g*hm)
               s2m=u2m+sqrt(g*hm)
               rare1=.false.
               rare2=.false.

         else !one shock one rarefaction
            h0=h_min

            do iter=1,maxiter
               F0=delu + 2.d0*(sqrt(g*h0)-sqrt(g*h_max)) &
                       + (h0-h_min)*sqrt(.5d0*g*(1/h0+1/h_min))
               slope=(F_max-F0)/(h_max-h_min)
               h0=h0-F0/slope
            enddo

            hm=h0
            if (hL.gt.hR) then
               um=uL+2.d0*sqrt_ghL-2.d0*sqrt(g*hm)
               s1m=uL+2.d0*sqrt_ghL-3.d0*sqrt(g*hm)
               s2m=uL+2.d0*sqrt_ghL-sqrt(g*hm)
               rare1=.true.
               rare2=.false.
            else
               s2m=uR-2.d0*sqrt_ghR+3.d0*sqrt(g*hm)
               s1m=uR-2.d0*sqrt_ghR+sqrt(g*hm)
               um=uR-2.d0*sqrt_ghR+2.d0*sqrt(g*hm)
               rare2=.true.
               rare1=.false.
            endif
         endif
      endif

      return

      end ! subroutine riemanntype----------------------------------------------------------------

c
c ----------------------------------------------------------
c
       subroutine shiftset(rectflags,ilo,ihi,mbuff)

       use amr_module
       implicit double precision (a-h, o-z)
       dimension rectflags(ilo-mbuff:ihi+mbuff)
       dimension copyflags(ilo-mbuff:ihi+mbuff)


c :::::::::::::::::::::: CSHIFT :::::::::::::::::::::::::::::::
c shift by + or - 1 in either direction to do 
c  bitwise calculus for proper nesting, buffering, etc.
c similar to cshift on CM machine.
c includes periodic buffering as well.
c
c NEWER VERSION: DOES ALL DIRS AT SAME TIME
c rectflags array has been augmented by enough border
c           cells to do buffering in place in the grid
c later will look to see if flagged pts are properly nested
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       do i = ilo-mbuff, ihi+mbuff
          copyflags(i) = 0
       end do

c  note: not looking at ghost cells, only real cells should be flagged
c  but can buffer the flags into the ghost zone
       do i = ilo, ihi
          rflag = rectflags(i)
          if (rflag .gt. 0)  then
c            cell is flagged, buffer in all dirs by ibuff
c            (note this is not nec same as mbuff)
c            use second array to avoid propagation
             mlo = i - ibuff
             mhi = i + ibuff
             do m = mlo, mhi
                copyflags(m) = rflag  ! copy the flag (doesnt distinguish buffer flag from orig flag)
             end do
          endif

       end do


c   copy back. need flags in original array, not temp scratch array

       do 60 i = ilo-mbuff, ihi+mbuff
         rectflags(i) = copyflags(i)
 60    continue


       return
       end

c
c ------------------------------------------------------------------
c
      subroutine filval(val,mitot,mjtot,mktot,hx,hy,hz,lev,time,
     1                  valc,auxc,mic,mjc,mkc,
     2                  xleft,xright,yfront,yrear,zbot,ztop,nvar,
     3                  mptr,ilo,ihi,jlo,jhi,klo,khi,aux,naux)

      use amr_module
      implicit double precision (a-h,o-z)


      dimension   val(nvar,mitot,mjtot,mktot), valc(nvar,mic,mjc,mkc)
      dimension   aux(nvar,mitot,mjtot,mktot), auxc(nvar,mic,mjc,mkc)
      dimension   dudx(max1d), dudy(max1d), dudz(max1d)
c
c :::::::::::::::::::::::::::::: FILVAL ::::::::::::::::::::::::::
c
c create and fill coarser (lev-1) patch with one extra coarse cell all
c around, plus the ghost cells . will interpolate from this patch to grid mptr
c without needing special boundary code.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      levc    = lev - 1
      lratiox = intratx(levc)
      lratioy = intraty(levc)
      lratioz = intratz(levc)
      hxcrse  = hx*lratiox
      hycrse  = hy*lratioy
      hzcrse  = hz*lratioz
      xl      = xleft  - hxcrse
      xr      = xright + hxcrse
      yf      = yfront - hycrse
      yr      = yrear  + hycrse
      zb      = zbot   - hzcrse
      zt      = ztop   + hzcrse
c
c     set integer indices for coarser patch enlarged by 1 cell
c     (can stick out of domain). proper nesting will insure this one
c     call is sufficient.
      iclo   = ilo/lratiox - 1
      jclo   = jlo/lratioy - 1
      kclo   = klo/lratioz - 1
      ichi   = (ihi+1)/lratiox - 1 + 1
      jchi   = (jhi+1)/lratioy - 1 + 1
      kchi   = (khi+1)/lratioz - 1 + 1
      ng     = 0

c    :::  mcapa  is the capacity function index

      if (mcapa .eq. 0) then
        if (xperdom .or. yperdom .or. zperdom) then
          call preintcopy(valc,mic,mjc,mkc,nvar,iclo,ichi,jclo,jchi,
     &                                          kclo,kchi,levc)
        else
          call intcopy(valc,mic,mjc,mkc,nvar,iclo,ichi,jclo,jchi,
     &                                        kclo,kchi,levc,1,1,1)
        endif
      else
        if (xperdom .or. yperdom .or. zperdom) then
          call preicall(valc,auxc,mic,mjc,mkc,nvar,naux,iclo,ichi,jclo,
     &                  jchi,kclo,kchi,levc)
        else
          call icall(valc,auxc,mic,mjc,mkc,nvar,naux,iclo,ichi,jclo,
     &               jchi,kclo,kchi,levc,1,1,1)
        endif
      endif
c      call physbd(valc,auxc,mic,mjc,mkc,nvar,naux,
c     1            hxcrse,hycrse,hzcrse,levc,time,
c     2            xl,xr,yf,yr,zb,zt,
c     3            xlower,ylower,zlower,xupper,yupper,zupper,
c     4            xperdom,yperdom,zperdom)

c 2/28/02 : new call to bc3amr
      call bc3amr(valc,auxc,mic,mjc,mkc,nvar,naux,
     1            hxcrse,hycrse,hzcrse,levc,time,
     2            xl,xr,yf,yr,zb,zt)


c
c     prepare slopes - use min-mod limiters
c
      do 30 k    = 2, mkc-1
      do 30 j    = 2, mjc-1
      do 30 ivar = 1, nvar
      do 10 i    = 2, mic-1

         slp = valc(ivar,i+1,j,k) - valc(ivar,i  ,j,k)
         slm = valc(ivar,i  ,j,k) - valc(ivar,i-1,j,k)
         slopex = dmin1(dabs(slp),dabs(slm))*
     .            dsign(1.0d0,valc(ivar,i+1,j,k) - valc(ivar,i-1,j,k))
c        # if theres a sign change, set slope to 0.
         if ( slm*slp .gt. 0.d0) then
           dudx(i) = slopex
         else
           dudx(i) = 0.d0
         endif

         slp = valc(ivar,i,j+1,k) - valc(ivar,i,j  ,k)
         slm = valc(ivar,i,j  ,k) - valc(ivar,i,j-1,k)
         slopey = dmin1(dabs(slp),dabs(slm))*
     .            dsign(1.0d0,valc(ivar,i,j+1,k) - valc(ivar,i,j-1,k))
         if ( slm*slp .gt. 0.d0) then
           dudy(i) = slopey
         else
           dudy(i) = 0.d0
         endif

         slp = valc(ivar,i,j,k+1) - valc(ivar,i,j,k  )
         slm = valc(ivar,i,j,k  ) - valc(ivar,i,j,k-1)
         slopez = dmin1(dabs(slp),dabs(slm))*
     .            dsign(1.0d0,valc(ivar,i,j,k+1) - valc(ivar,i,j,k-1))
         if ( slm*slp .gt. 0.d0) then
           dudz(i) = slopez
         else
           dudz(i) = 0.d0
         endif

 10   continue
c
c     interp. from coarse cells to fine grid
c
      do 20 kco = 1,lratioz
      kfine = (k-2)*lratioz + nghost + kco
      zoff  = (dble(kco) - .5d0)/lratioz - .5d0
         do 20 jco = 1,lratioy
         jfine = (j-2)*lratioy + nghost + jco
         yoff  = (dble(jco) - .5d0)/lratioy - .5d0
            do 20 ico = 1,lratiox
            xoff = (dble(ico) - .5d0)/lratiox - .5d0
               do 20 i = 2, mic-1
               ifine   = (i-2)*lratiox + nghost + ico
               val(ivar,ifine,jfine,kfine) = valc(ivar,i,j,k)
     1                                   + xoff*dudx(i) + yoff*dudy(i)
     2                                                  + zoff*dudz(i)
 20   continue
c
 30   continue

      if (mcapa .ne. 0) then
        call fixcapaq(val,aux,mitot,mjtot,mktot,valc,auxc,mic,mjc,mkc,
     &                nvar,naux,levc)
      endif
c
c  overwrite interpolated values with fine grid values, if available.
c
      call intcopy(val,mitot,mjtot,mktot,nvar,ilo-nghost,ihi+nghost,
     &             jlo-nghost,jhi+nghost,klo-nghost,khi+nghost,
     &             lev,1,1,1)

      return
      end

      subroutine setprob
      implicit double precision (a-h,o-z)
      character*25 fname
      common /cparam/ rho,bulk,cc,zz

c
c     # Set the material parameters for the acoustic equations
c
c
      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)
                
c
c     # Density and bulk modulus:

      read(7,*) rho
      read(7,*) bulk
c
c     # Compute sound speed and impendance:

      cc = dsqrt(bulk/rho)
      zz = rho*cc

      return
      end

c
c  ================================================================
      subroutine saveqc(level,nvar,naux)
c  ================================================================
c
      use amr_module
      implicit double precision (a-h,o-z)
      
      !for setaux timing
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish
      

      logical sticksout, found
!     make fliparray largest possible grid size
      dimension fliparray(2*max1d*nghost*(nvar+naux))
c
c ::::::::::::::::::::::::: SAVEQC :::::::::::::::::::::::::::::::::
c  prepare new fine grids to save fluxes after each integration step
c  for future conservative fix-up on coarse grids.
c  save all boundary fluxes of fine grid (even if on a  phys. bndry.) -
c  but only save space for every intrat of them. 
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      levc = level - 1
      hxc  = hxposs(levc)
      ng   = 0  ! no ghost cells on coarsened enlarged patch

      mkid = lstart(level)
 10   if (mkid .eq. 0) go to 99
          nx    = node(ndihi,mkid)-node(ndilo,mkid) + 1
          lenbc = 2
          ist   = node(ffluxptr,mkid)
          time = rnode(timemult,mkid)

c         make coarsened enlarged patch for conservative fixup
          ilo = node(ndilo,mkid)
          ihi = node(ndihi,mkid)
          iclo = ilo/intratx(level-1) - 1
          ichi = (ihi+1)/intratx(level-1)
          nrow = ichi-iclo+1
          xl   = rnode(cornxlo,mkid) - hxc
          xr   = rnode(cornxhi,mkid) + hxc

          loctmp = igetsp(nrow*(nvar+naux))
          loctx  = loctmp + nrow*nvar
          do i = 1, nrow*naux
             alloc(loctx+i-1) = NEEDS_TO_BE_SET
          end do
          locaux = node(storeaux,mkid)

          if (iclo .lt. 0 .or. ichi .eq. iregsz(levc)) then
            sticksout = .true.
          else
            sticksout = .false.
          endif

          if (sticksout .and. xperdom) then
             !iperim = nrow
             !locflip = igetsp(iperim*nghost*(nvar+naux))

             call preicall(alloc(loctmp),alloc(loctx),nrow,nvar,
     .                     naux,iclo,ichi,level-1,
     .                     fliparray)
!     .                     alloc(locflip))
!             call reclam(locflip,iperim*nghost*(nvar+naux))
          else
             call icall(alloc(loctmp),alloc(loctx),nrow,nvar,naux,
     .                   iclo,ichi,level-1,1)
          endif
!         in case any part sticks out of domain still need to set remaining aux
!         cells
          if (naux .gt. 0 .and. sticksout) then  
             call system_clock(clock_start,clock_rate)
             call cpu_time(cpu_start)
             call setaux(ng,nrow,xl,hxc,naux,alloc(loctx))
             call system_clock(clock_finish,clock_rate)
             call cpu_time(cpu_finish)
             timeSetaux = timeSetaux + clock_finish - clock_start
             timeSetauxCPU = timeSetauxCPU + cpu_finish - cpu_start
          endif
!--          found = .false.
!--          do i = 1, naux*nrow, naux
!--             if (alloc(loctx+i-1) .eq. NEEDS_TO_BE_SET) then
!--                 found = .true.
!--             endif
!--          end do
!--          if (found)  write(*,*) "still have unset aux vals in qad"
          call bc1amr(alloc(loctmp),alloc(loctx),nrow,nvar,naux,
     .                hxc,level,time,
     .                xl,xr)
          call cstore(alloc(loctmp),nrow,nvar,
     .                alloc(ist+nvar*lenbc),lenbc,naux,alloc(loctx),
     .                alloc(ist+2*nvar*lenbc))
          call reclam(loctmp,nrow*(nvar+naux))

          mkid = node(levelptr,mkid)
          go to 10
 99    return
       end

module bouss_module

    use amr_module, only: t0, maxlv

#ifdef HAVE_PETSC
#include <petsc/finclude/petscksp.h>
    use petscksp
#endif

    implicit none
    save


    integer :: bc_xlo, bc_xhi, bc_ylo, bc_yhi

    real(kind=8) :: Bparam
    real(kind=8) :: alpha

    logical :: startWithBouss

    logical :: crs  

    real(kind=8) :: startBoussTime

    !
!   Added for Boussinesq hybrid solver
! ================================
!
    type matrix_patchIndex
       integer, allocatable, dimension(:,:) :: mindex
       logical*1, allocatable, dimension(:,:) :: isBouss
       integer, allocatable, dimension(:,:) :: mindexSolo
       !!! TEST FOR 2 LEVEL CODE, REALLY WANT LISTS
       integer, allocatable, dimension(:,:) :: mfine
       integer, allocatable, dimension(:,:) :: ifine
       integer, allocatable, dimension(:,:) :: jfine
       integer, allocatable, dimension(:,:) :: mcoarse
       integer, allocatable, dimension(:,:) :: icoarse
       integer, allocatable, dimension(:,:) :: jcoarse
    end type

    type matrix_levInfo
    !! matrix_indices is indexed into by patch number, only Bouss Grids at that level
       type (matrix_patchIndex), allocatable, dimension(:) :: matrix_indices
       integer, allocatable, dimension(:) :: matrix_ia, matrix_ja
       real(kind=8), allocatable, dimension(:) :: matrix_sa
       integer :: numBoussGrids, numBoussCells, numBoussCellsSolo, numGhostCount, numUnset
       integer :: numColsTot

       ! for CRS format
       integer, allocatable, dimension(:) :: rowPtr, cols
       real(kind=8), allocatable, dimension(:) :: vals 

       ! intfCountc are the # equations (cells)  added for you as a coarse grid
       ! these are the equations under a fine grid on the first interior cells
       ! that say the coarse cell is the conservative average of the refined cells

       ! intfCountf are the # equations (cells)  if you are the fine grid
       ! these are the equations to interpolate a ghost cell from the
       ! coarser patch
       integer :: intfCount
       integer :: matrix_nelt
    end type

    double precision :: boussMinDepth
    integer :: minLevelBouss, maxLevelBouss
    integer :: isolver
    integer :: ibouss

    type (matrix_levInfo), target :: matrix_info_allLevs(maxlv)

#ifdef HAVE_PARDISO
    ! vars for pardiso solver
    integer :: mtype,solver,maxfct,mnum,phase,nn,nrhs,error,msglvl
    integer iparm(64), idum
    real*8 dparm(64),ddum
    integer*8 pt(64,maxlv)
#endif

    ! if new grids have to redo factorization
    ! either first time in setgrd of in regrid
    logical newGrids(maxlv), newGridsTower(maxlv)
    integer*8  itcount(maxlv), numTimes(maxlv)

#ifdef HAVE_PETSC
    Mat Jr(maxlv)
    KSP ksp(maxlv)
    Mat JrTower(maxlv)
    KSP kspTower(maxlv)
#endif

    ! for restarts:
    integer :: minLevelBouss_orig,maxLevelBouss_orig
    real(kind=8) :: boussMinDepth_orig,startBoussTime_orig

contains

    subroutine set_bouss(rest,time,naux)

    ! Set Bparam and bc choices for Boussinesq implicit solver

    ! Eventually allow more things to be specified in setrun.py
    ! and read them in here.

    use amr_module, only: mthbc, outunit
    implicit none
    logical, intent(in) :: rest
    real(kind=8), intent(in) :: time
    integer, intent(in) :: naux
    
    integer iunit,i
    character(len=25) fname
    real(kind=8) :: eps

#ifdef WHERE_AM_I
    write(*,*) 'starting set_bouss'
#endif

    iunit = 7
    fname = 'bouss.data'
!   # open the unit with new routine from Clawpack 4.4 to skip over
!   # comment lines starting with #:
    call opendatafile(iunit, fname)

    ! set constants for whichever bouss solver being used
    ! MS equation parameter B:
    Bparam = 1.d0/15.d0  

    ! SGN equation parameter alpha
    !alpha = 1.d0
    alpha = 1.153d0


    ! modify write statements to say what value of Bparam or alpha is used:

    read(7,*) ibouss
    if (ibouss .eq. 0) then
       write(*,*)" Using Shallow Water equations"
       write(outunit,*)" Using Shallow Water equations"
    else if (ibouss .eq. 1) then
       write(*,*)" Using Madsen Sorensen equations"
       write(outunit,*)" Using Madsen Sorensen equations"
    else if (ibouss .eq. 2) then
       write(*,*)" Using SGN equations"
       write(outunit,*)" Using SGN equations"
    else
       write(*,*)" Unrecognized option for equation set"
       write(outunit,*)" Unrecognized option for equation set"
       stop
    endif
    
    read(7,*) minLevelBouss
    read(7,*) maxLevelBouss
    read(7,*) boussMinDepth
    read(7,*) isolver
    read(7,*) startBoussTime

    if (ibouss == 1) then
        ! Madsen-Sorensen equations only implemented with COO triplet storage
        ! format (i,j,value) for sparse matrix:
        crs = .false.
    else
        ! SGN implemented for both sparse storage formats, but runs faster
        ! using compressed row storage (CRS, also known as CSR or Yale) format:
        crs = .true.
    endif

    ! crs = .false.  ! uncomment this line to force CRS with SGN for testing

    !------------------------------------------
    if (rest) then
        ! for restart, parameters should not have changed from original run:
        if ((minLevelBouss .ne. minLevelBouss_orig) .or. &
            (maxLevelBouss .ne. maxLevelBouss_orig) .or. &
            (boussMinDepth .ne. boussMinDepth_orig)) then
          write(*,*)"*** Cannot change these bouss params on restart:"
          write(*,*)"*** Old params:"
          write(*,922) minLevelBouss_orig,maxLevelBouss_orig,boussMinDepth_orig
          write(*,*)"*** New params:"
          write(*,922) minLevelBouss,maxLevelBouss,boussMinDepth
  922     format("min/max Bousslevel "2i5," boussMinDepth ",f10.2)
          stop
        endif

        ! check if later startBoussTime than orig, only allowed if not yet using Bouss
        eps = 1.d-13
        ! allowing for roundoff between different compilers in testing
        ! if starting time has  changed
        if (abs(startBoussTime-startBoussTime_orig) .gt. eps)  then
            if (startBoussTime .ge. startBoussTime_orig) then
                if (startBoussTime_orig .lt. time) then
                    write(*,904)
                    write(outunit,904)
  904               format("Cannot postpone Bouss solves if already using it")
                    stop
                else
                    write(*,905) startBoussTime
                    write(outunit,905) startBoussTime
  905               format("Changing Bouss solves to start at time ", e15.7)
                endif
            else 
                write(*,906) time,startBoussTime_orig, startBoussTime
                write(outunit,906) time,startBoussTime_orig,startBoussTime
  906           format(" Already using Bouss at time",d15.7,/, &
                   " new start time ",d15.7," orig start time ",d15.7)
            endif
        endif
        ! allocate the data structures for the bouss info
        call resetBoussStuff(naux)

    endif  ! end checking parameters on restart
    !------------------------------------------

 99   write(*,900) minLevelBouss, maxLevelBouss
      write(outunit,900) minLevelBouss, maxLevelBouss
 900  format("==> Applying Bouss equations to selected grids between levels ",i3," and ",i3)

      write(*,*)"==> Use Bouss. in water deeper than ",boussMinDepth
      write(outunit,*)"==> Use Bouss. in water deeper than ",boussMinDepth

      if (isolver .eq. 1) then
         write(*,*)" No longer supporting GMRES solver"
         stop
      else if (isolver .eq. 2) then
#ifdef HAVE_PARDISO
         !write(*,*)" Using Pardiso solver"
         !write(outunit,*)" Using Pardiso solver"
         write(*,*)"Cannot use expired Pardiso solver"
         write(outunit,*)"Cannot use expired Pardiso solver"
         !stop
#else
         write(*,*)"need to install Pardiso for this option"
         stop
#endif
        else if (isolver .eq. 3) then
#ifdef HAVE_PETSC
         write(*,*)"Using a PETSc solver"
         write(outunit,*)"Using PETSc solver"
#else
         write(*,*)"need to install PETSc for this option"
         stop
#endif
      else
         write(*,*)"Unknown solver",isolver," choose 1,2 or 3"
         write(outunit,*)"Unknown solver",isolver," choose 1,2 or 3"
         stop
      endif

      if (startBoussTime .le. t0) then
         write(*,*)"Using Bouss equations from the start"
         write(outunit,*)"Using Bouss equations from the start"
         startWithBouss = .true.
      else
         write(*,*)"==> Wait until time ",startBoussTime," for before starting Bouss"
         write(*,*)"==> Using SWE until then."
         startWithBouss = .false.
      endif

    close(unit=iunit)



    ! Boundary conditions to impose in computing Boussinesq update:
    if ((mthbc(1)==2) .or. (mthbc(2)==2) &
        .or. (mthbc(3)==2) .or. (mthbc(4)==2)) then
        write(6,*) '*** Periodic BCs not supported in bouss_module'
        stop
    endif

    if ((mthbc(1)==4) .or. (mthbc(2)==4) &
        .or. (mthbc(3)==4) .or. (mthbc(4)==4)) then
        write(6,*) '*** Sphere BCs not supported in bouss_module'
        stop
    endif
    
    ! Dirichlet BCs using ghost cell values saved from coarser level:
    ! Requires num_eqn == 5.
    ! This is used in buildSparseMatrix at patch boundaries that are not
    ! domain boundaries, so the values of bc_xlo etc. only affect domain bdries
    ! Default (only if mthbc=0?) unless set otherwise by mthbc tests below

    bc_xlo = 2
    bc_xhi = 2
    bc_ylo = 2
    bc_yhi = 2
    

    ! For extrapolation in x:
    if (mthbc(1)==1) bc_xlo = 1
    if (mthbc(2)==1) bc_xhi = 1

    ! For extrapolation in y:
    if (mthbc(3)==1) bc_ylo = 1
    if (mthbc(4)==1) bc_yhi = 1


    ! For solid wall in x:
    if (mthbc(1)==3) bc_xlo = 3
    if (mthbc(2)==3) bc_xhi = 3

    ! For solid wall in y:
    if (mthbc(3)==3) bc_ylo = 3
    if (mthbc(4)==3) bc_yhi = 3
    
    
    ! FOR A PLANE WAVE CASE, SOLID WALL SHOULD WORK - Don't need what's below
    
    ! For plane wave in x-direction, should instead use Neumann conditions in y:
    ! Can use wall BC in SWE step so assume 
    !  clawdata.bc_lower[1] = clawdata.bc_upper[1] = 3
    !if (mthbc(3)==3) bc_ylo = 1
    !if (mthbc(4)==3) bc_yhi = 1
    !write(6,*) 'For plane wave in x-direction, using Neumann at top,bottom'


    ! For plane wave in y-direction, should instead use Neumann conditions in x:
    !if (mthbc(1)==3) bc_xlo = 1
    !if (mthbc(2)==3) bc_xhi = 1
    !write(6,*) 'For plane wave in y-direction, using Neumann at left,right'

#ifdef WHERE_AM_I
    write(*,*) 'ending   set_bouss'
#endif

    end subroutine set_bouss

end module bouss_module

subroutine pardiso_driver(soln,rhs,levelBouss,numBoussCells,nst,ncc,topo_finalized)

    ! use pardiso to solve sparse linear system
    ! called this way so can allocate storage of correct size
    
    use bouss_module
    implicit none
    
    integer, intent(in) :: levelBouss, numBoussCells, nst, ncc
    real(kind=8), intent(in) :: rhs(2*numBoussCells)
    logical, intent(in) :: topo_finalized
    
    !! pass in numBoussCells for this level so can dimension this array
    real(kind=8), intent(out) :: soln(2*numBoussCells)
    
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: k,i,j,mptr
    integer :: numCores, omp_get_max_threads

    integer :: icc(2*numBoussCells+1), ccc(ncc), sys
    integer*8 numeric, symbolic
    real(kind=8) :: acc(ncc), info(90)

    !! paridso vars
    !integer :: mtype,solver,maxfct,mnum,phase,nn,nrhs,error,msglvl
    !real*8 dparm(64)
    !integer*8 pt(64,maxlv)

#ifdef HAVE_PARDISO
    nrhs = 1
    iparm(1) = 0 ! use all default values, except for iparm(3) = # cores?

    numCores = 1 ! initialized to 1 in case not openmp 
!$  numCores = omp_get_max_threads() 
    iparm(3) = numCores

    maxfct = 1
    mnum = 1
    
    mtype = 11
    solver = 0
    
    minfo => matrix_info_allLevs(levelBouss)

    !!write(*,*)"second time"
    !! dump matrix_ia
    !!do k = 1, 10
    !!  write(*,901) k,minfo%matrix_ia(k)
 901  format(2i8)
    !!end do

    !================   Step 4 Solve matrix system =======================
            
    !   call timestamp()

        !! moved to setgrd call pardisoinit(pt(1,levelBouss), mtype, solver, iparm, dparm, error)
        !!if (error .ne. 0) then
         !! if (error.EQ.-10 ) WRITE(*,*) 'No license file found'
         !! if (error.EQ.-11 ) WRITE(*,*) 'License is expired'
         !! if (error.EQ.-12 ) WRITE(*,*) 'Wrong username or hostname'
         !! STOP
        !!else
        !!   write(*,*)"license check successful"
        !!endif

        !! convert to compressed format. next call done in implicit_bouss
        ! call st_to_cc_size (nst,minfo%matrix_ia,minfo%matrix_ja,ncc)

        nn = 2*numBoussCells    ! number of rows and cols
        !!! for compressed row, reverse ia and ja, and output arrays too
        !!!call st_to_cc_index (nst,minfo%matrix_ia,minfo%matrix_ja,ncc,nn,icc,ccc)
        call st_to_cc_index (nst,minfo%matrix_ja,minfo%matrix_ia,ncc,nn,ccc,icc)
        !!!call st_to_cc_values(nst,minfo%matrix_ia,minfo%matrix_ja, minfo%matrix_sa,ncc,nn,icc,ccc,acc)
        call st_to_cc_values(nst,minfo%matrix_ja,minfo%matrix_ia, minfo%matrix_sa,ncc,nn,ccc,icc,acc)


        call pardiso_chkmatrix (mtype, nn, acc, icc,ccc, error)
        if (error .ne. 0) then
           write(*,*)"the following error in chk_matrix was found ",error
           stop
        endif

        ! ..  pardiso_printstats(...)
        !     prints information on the matrix to STDOUT.
        !     Use this functionality only for debugging purposes
       !CALL pardiso_printstats (mtype, nn, acc, icc, ccc, nrhs, rhs, error);
       !if (error .NE. 0) then
       !   write(*,*) 'The following ERROR was detected: ', error
       !  stop
       ! endif

        !! reordering and symbolic factorization. Also
        !! allocates all memory needed for factorization
        if (newGrids(levelBouss) .or. .not. topo_finalized) then
           newGrids(levelBouss) = .false.
           phase = 11
           msglvl = 0
           !write(*,*)"before phase 11 call"
           !!call timestamp()
           call pardiso(pt(1,levelBouss), maxfct, mnum, mtype, phase,nn,acc,icc,ccc,  &
                        idum, nrhs, iparm, msglvl, rhs, soln, error, dparm)
                     !  idum, nrhs, iparm, msglvl, ddum, ddum, error, dparm)

           IF (error .NE. 0) THEN
              WRITE(*,*) 'The following ERROR was detected: ', error
              STOP
            END IF


           !WRITE(*,*) 'Number of nonzeros in factors   = ',iparm(18)
           !WRITE(*,*) 'Number of factorization MFLOPS  = ',iparm(19)

           !  factorization
           phase     = 22  ! only factorization
           !write(*,*)"before phase 22 call"
           !!call timestamp()
           CALL pardiso (pt(1,levelBouss), maxfct, mnum, mtype, phase, nn, acc, icc, ccc,      &
                       idum, nrhs, iparm, msglvl, rhs, soln, error,dparm)
                    !  idum, nrhs, iparm, msglvl, ddum, ddum, error,dparm)

           !WRITE(*,*) 'Factorization completed ...  '
           IF (error .NE. 0) THEN
              WRITE(*,*) 'The following ERROR was detected: ', error
             STOP
           ENDIF 

       endif

 !.. Back substitution and iterative refinement
      phase     = 33  ! only solve
      iparm(8)  = 5   ! max numbers of iterative refinement steps

      !write(*,*)"before phase 33 call"
      !!call timestamp()
      CALL pardiso (pt(1,levelBouss), maxfct, mnum, mtype, phase, nn, acc, icc, ccc,    &
                    idum, nrhs, iparm, msglvl, rhs, soln, error, dparm) 
      !write(*,*)"after phase 33 call"
      !!call timestamp()
      !WRITE(*,*) 'Solve completed ... '
      !write(*,*) "num iterative refinements = iparm(7) =  ", iparm(7)
      avgIterRef = avgIterRef + iparm(7)
      countIterRef = countIterRef + 1
      maxIterRef = max(maxIterRef, iparm(7))
     
!      WRITE(*,*) 'The solution of the system is '
!      DO i = 1, n
!        WRITE(*,*) ' x(',i,') = ', soln(i)
!      END DO

      ! Termination and release of memory
      !phase     = -1           ! release internal memory
      ! moved to amr2 after tick for final release
      !!CALL pardiso (pt(1,levelBouss), maxfct, mnum, mtype, phase, nn, ddum, idum, idum,    &
      !!              idum, nrhs, iparm, msglvl, ddum, ddum, error, dparm)
#endif

! if no pardiso this is dummy routine that just returns
    return
end subroutine pardiso_driver

c
c ------------------------------------------------------------
c
       subroutine upbnd(listbc,val,nvar,naux,mitot,
     1                  maxsp,mptr)
c     1                  maxsp,iused,mptr)
 
      use amr_module
      implicit double precision (a-h,o-z)

 
       dimension val(nvar,mitot),listbc(4,maxsp),
     1           iused(mitot)

c  OLD INDEXING
c      iaddaux(i,j) = locaux + i-1 +  mitot*(j-1) 
c    1                 + mitot*mjtot*(mcapa-1)
c  NEW INDEXING - SWITCHED ORDERING
       iaddaux(i) = locaux + mcapa-1 +  naux*(i-1)
 
c
c :::::::::::::::::::::::::::: UPBND :::::::::::::::::::::::::::::
c We now correct the coarse grid with the flux differences stored
c with each of the fine grids. We use an array   iused
c to indicate whether the flux has been updated or not for that zone.
c iused(i) = sum from (l=1,2) i(l)*2**(l-1), where i(l) = 1 if the
c flux for the  l-th side of the (i)-th cell has already been
c updated, and i(l) = 0 if not.
 
c if there is a capacity fn. it needs to be included in update formula
c indicated by mcapa not zero (is index of capacity fn.)
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

      do 10 i=1,mitot
         iused(i) = 0.
 10   continue
 
      locaux = node(storeaux,mptr)
      levc   = node(nestlevel,mptr)
      area   = hxposs(levc)


      if (uprint) write(outunit,*)" upbnding grid ",mptr

      do 40 ispot = 1,maxsp
         icrse = listbc(1,ispot)
         if (icrse.eq.0) go to 99

         iside = listbc(2,ispot)
c        continue to use iside1/norm for debugging, but should soon delete         
c        this if/then/else block needed due to new categories corresponding
c        to mapped bcs. should still only have one update per side of coarse cell though
         if (iside .lt. 3) then
           iside1 = iside
         else  ! should not happen
           write(*,*) "*** Error in upbud.f ***"
         endif
         norm = 2**(iside1-1)
         iflag =iused(icrse)/norm
         if (mod(iflag,2).eq.1) then
            write(6,*)" ***  double flux update CAN happen in upbnd ***"
            go to 40
         endif
         mkid = listbc(3,ispot)
         kidlst = node(ffluxptr,mkid)
         lkid = listbc(4,ispot)
c         modified to include other side options
          if (iside .eq. 2) then
c           (iside .eq. 2)
            sgnm = -1.
         else
c           (iside .eq. 1)
            sgnm = 1.
         endif

c        ## debugging output
         if (uprint) then
           write(outunit,101) icrse,
     .         (val(ivar,icrse),ivar=1,nvar)
 101       format(" old ",1x,i4,4e15.7)
         endif

         if (mcapa .gt. 0) then
c            # capacity array:  need to divide by capa in each cell.
c            # modify sgnm which is reset for each grid cell.
c            # Note capa is stored in aux(icrse,mcapa)
             sgnm = sgnm / alloc(iaddaux(icrse))
         endif

         do 20 ivar = 1,nvar
            val(ivar,icrse) = val(ivar,icrse) +
     1       sgnm*alloc(kidlst+nvar*(lkid-1)+ivar-1)/area
 20      continue
         iused(icrse) = iused(icrse) + norm

c        ## debugging output
         if (uprint) then
           write(outunit,102) mkid,
     .         (val(ivar,icrse),ivar=1,nvar)
 102       format(" new ","(grid",i3,")",4e15.7)
         endif

 40   continue
c
 99   return
      end

c
c  -----------------------------------------------------------
c
      subroutine gfixup(lbase, lfnew, nvar, naux, newnumgrids,
     .                  maxnumnewgrids)
c
      use geoclaw_module
      use refinement_module, only: varRefTime
      use amr_module
      use topo_module, only: topo_finalized,aux_finalized
      implicit double precision (a-h,o-z)

      dimension spoh(maxlv)
      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      integer newnumgrids(maxlv),listnewgrids(maxnumnewgrids)

      integer(kind=8) :: clock_start, clock_finish, clock_rate
      integer mbad
c
c ::::::::::::::::::::::::: GFIXUP ::::::::::::::::::::::::::::::::;
c        interpolate initial values for the newly created grids.
c        the start of each level is located in newstl array.
c        since only levels greater than lbase were examined, start
c        looking there.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
c   reclaim old storage (position 8) and list space 15 and 16
c   before allocating new storage. remember, finest level grids
c  (if level = mxnest so that error never estimated) don't have
c  2 copies of solution values at old and new times.
c
c
      call putsp(lbase,lbase,nvar,naux)
      level = lbase + 1
 1    if (level .gt. lfine) go to 4
      call putsp(lbase,level,nvar,naux)
          mptr = lstart(level)
 2        if (mptr .eq. 0) go to 3
              nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
              ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
              mitot = nx + 2*nghost
              mjtot = ny + 2*nghost
              nwords        = mitot*mjtot*nvar
              if (level .lt. mxnest) 
     .           call reclam(node(store2, mptr), nwords)
              node(store2, mptr) = 0
              mptr          = node(levelptr, mptr)
          go to 2
 3        level   = level + 1
          go to 1
c
 4    lcheck = lbase + 1

c
c update topo to current time, before setting all new grids at new levels
c
      time = rnode(timemult, lstart(lbase))
      if (.not. topo_finalized) then
          call topo_update(time)
      endif

 5    if (lcheck .gt. mxnest) go to 89
          hx = hxposs(lcheck)
          hy = hyposs(lcheck)
          spoh(lcheck) = 0.d0 ! to keep track of max wave speed for all new grids
c
c prepare for doing next loop over grids at a given level in parallel
c unlike other level loops, these are newly created grids, not yet merged in
c so take grids from newstl (NEWSTartOfLevel), not lstart. Dont yet know
c how many either.
       call prepnewgrids(listnewgrids,newnumgrids(lcheck),lcheck)
c
c  interpolate level lcheck
c   first get space, since cant do that part in parallel
       do  j = 1, newnumgrids(lcheck)
          mptr = listnewgrids(j)
            nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
            ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
            mitot = nx + 2*nghost
            mjtot = ny + 2*nghost
            loc    = igetsp(mitot * mjtot * nvar)
            node(store1, mptr)  = loc
            if (naux .gt. 0) then
              locaux = igetsp(mitot * mjtot * naux)
             else
              locaux = 1
            endif
            node(storeaux, mptr)  = locaux
       end do

c   
c                 other reduction variables initialized in stst1
       this_spoh = 0.d0

!$OMP PARALLEL DO 
!$OMP&            PRIVATE(clock_start,clock_finish,clock_rate)
!$OMP&            PRIVATE(j,mptr,nx,ny,mitot,mjtot,corn1,corn2,loc)
!$OMP&            PRIVATE(locaux,time,mic,mjc,xl,xr,yb,yt,ilo,ihi)
!$OMP&            PRIVATE(jlo,jhi,sp_over_h)
!$OMP&            SHARED(newnumgrids,listnewgrids,nghost,node,hx,hy)
!$OMP&            SHARED(rnode,intratx,intraty,lcheck,nvar,alloc,naux)
!$OMP&            REDUCTION(MAX:this_spoh)
!$OMP&            SCHEDULE(dynamic,1)
!$OMP&            DEFAULT(none)

      do  j = 1, newnumgrids(lcheck)
          mptr = listnewgrids(j)

c  changed to move setaux out of this loop. instead, copy aux in filval 
c  along with soln.involves changing intcopy to icall and making flag array
c  can only do this after topo stops moving
              nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
              ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
              mitot = nx + 2*nghost
              mjtot = ny + 2*nghost
              corn1 = rnode(cornxlo,mptr)
              corn2 = rnode(cornylo,mptr)
              loc   =  node(store1, mptr)
              if (naux .gt. 0) then
                locaux =  node(storeaux, mptr)
              else
                locaux = 1
              endif

c
c      We now fill in the values for grid mptr using filval. It uses
c      piecewise linear interpolation to obtain values from the
c      (lcheck - 1) grid, then overwrites those with whatever (lcheck)
c      grids are available. We take advantage of the fact that the
c      (lcheck - 1) grids have already been set, and that the distance
c      between any point in mptr and a (lcheck - 1) and (lcheck - 2)
c      interface is at least one (lcheck - 1) cell wide.
c
 
c          # make a coarsened patch with ghost cells so can use
c          # grid interpolation routines, but only set "interior".
c          # extra 2 cells so that can use linear interp. on
c          # "interior" of coarser patch to fill fine grid.
           mic = nx/intratx(lcheck-1) + 2
           mjc = ny/intraty(lcheck-1) + 2
           xl  = rnode(cornxlo,mptr)
           xr  = rnode(cornxhi,mptr)
           yb  = rnode(cornylo,mptr)
           yt  = rnode(cornyhi,mptr)
           time  = rnode(timemult, mptr)
           ilo   = node(ndilo, mptr)
           ihi   = node(ndihi, mptr)
           jlo   = node(ndjlo, mptr)
           jhi   = node(ndjhi, mptr)
 
           call filval(alloc(loc),mitot,mjtot,hx,hy,lcheck,time,
     1                 mic,mjc,
     2                 xl,xr,yb,yt,nvar,
     3                 mptr,ilo,ihi,jlo,jhi,
     4                 alloc(locaux),naux,
     5                 sp_over_h)
           this_spoh = max(this_spoh, sp_over_h)
         end do
!$OMP END PARALLEL DO

       spoh(lcheck) = this_spoh
 
 
c
c  done filling new grids at level. move them into lstart from newstl
c  (so can use as source grids for filling next level). can also
c  get rid of loc. 7 storage for old level.
c
 80   mptr = lstart(lcheck)
 85   if (mptr .eq. 0) go to 90
          nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot = nx + 2*nghost
          mjtot = ny + 2*nghost
          call reclam(node(store1,mptr),mitot*mjtot*nvar)
          if (naux .gt. 0) then
            call reclam(node(storeaux,mptr),mitot*mjtot*naux)
          endif
          mold   = mptr
          mptr   = node(levelptr,mptr)
          call putnod(mold)
          call freeBndryList(mold)
          go to 85
 90   lstart(lcheck) = newstl(lcheck)
      lcheck = lcheck + 1
      go to 5
c
 89   lfine = lfnew
c
c     initialize 2nd (old time) storage block for new grids not at top level
c
      levend = min(lfine,mxnest-1)
      do 110 level = lbase+1, levend
         mptr = lstart(level)
 105     if (mptr .eq. 0) go to 110
            nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
            ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
            mitot = nx + 2*nghost
            mjtot = ny + 2*nghost
            nwords = mitot*mjtot*nvar
            node(store2,mptr) = igetsp(nwords)
         mptr = node(levelptr,mptr)
         go to 105
 110   continue

c
c -------------
c  grid structure now complete again. safe to print, etc. assuming
c  things initialized to zero in nodget.
c -------------
c
       if (.not. varRefTime) go to 99
c
c  set new time step and refinement ratios in time
c  important to do this from coarser to finer levels to make sure 
c  subcycling lines up right.
c  this sets ratios, and possk array.  
c  note that code below does not change coarsest level time step,
c  this is set during timestepping
c
      do level = lbase+1, lfine   
         dtc = possk(level-1)
C        Need this check in order to account for completely dry grids
         if (abs(spoh(level)) < tiny(1.d0)) then
           dtf = huge(1.d0)
         else
           dtf = cfl/(spoh(level))
         endif
         if (dtf .gt. dtc) then
            kratio(level-1) = 1  ! cant have larger timestep than parent level
            possk(level)    = dtc  ! cant have larger timestep than parent level
         else
            kratio(level-1) = ceiling(dtc/dtf)
            possk(level)    = possk(level-1)/kratio(level-1)
        endif
c       write(6,*)" setting ref. ratio in time for level ",level," to ",
c    .            kratio(level-1)
      end do

 99   return
      end
c
c -----------------------------------------------------------------------------------------
c
c  use different routine since need to scan new grid list (newstl) not lstart
c  to make grids.  
c  could make one routine by passing in source of list, but this changed 4 other routines
c  so I didnt want to have to deal with it

       subroutine prepnewgrids(listnewgrids,num,level)

       use amr_module
       implicit double precision (a-h,o-z)
       integer listnewgrids(num)

       mptr = newstl(level)
       do j = 1, num
          listnewgrids(j) = mptr
          mptr = node(levelptr, mptr)
       end do

       if (mptr .ne. 0) then
         write(*,*)" Error in routine setting up grid array "
         stop
       endif

       return
       end

c
c -------------------------------------------------------------
c
      subroutine bufnst1(nvar,naux,numbad,lcheck,lbase)
c
      use amr_module
      implicit double precision (a-h,o-z)


      logical    vtime
      integer listgrids(numgrids(lcheck))
      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      data       vtime/.false./

c     this indexing is for amrflags array, in flag2refine from 1-mbuff:mx+mbuff
c     but here is from 1:mibuff
      iadd(i) = locamrflags + i-1
c
 
c :::::::::::::::::::::::::: BUFNST :::::::::::::::::::::::::::::::::::
c  after error estimation, need to tag the cell for refinement,
c  buffer the tags, take care of level nesting, etc.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c
c
!$    maxthreads = omp_get_max_threads()
c     call prepgrids(listgrids,numgrids(lcheck),lcheck)

      numpro = 0 
      numbad = 0 
      time = rnode(timemult,lstart(lcheck))
      dx = hxposs(lcheck)

c      mptr = lstart(lcheck)
       levSt = listStart(lcheck)
c41   continue
!$OMP PARALLEL DO REDUCTION(+:numbad)
!$OMP&            PRIVATE(jg,mptr,ilo,ihi,nx,mitot),
!$OMP&            PRIVATE(mibuff,locamrflags,mbuff,ibytesPerDP),
!$OMP&            PRIVATE(loctmp,locbig,i,numpro2,numflagged),
!$OMP&            PRIVATE(locdomflags,locdom2),
!$OMP&            SHARED(numgrids, listgrids,nghost,flag_richardson),
!$OMP&            SHARED(nvar,eprint,maxthreads,node,rnode,lbase,ibuff),
!$OMP&            SHARED(alloc,lcheck,numpro,mxnest,dx,time),
!$OMP&            SHARED(levSt,listOfGrids),
!$OMP&            DEFAULT(none),      
!$OMP&            SCHEDULE (DYNAMIC,1)
      do  jg = 1, numgrids(lcheck)
c        mptr = listgrids(jg)
         mptr = listOfGrids(levSt+jg-1)
         ilo    = node(ndilo,mptr)
         ihi    = node(ndihi,mptr)
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         mitot  = nx + 2*nghost
         mbuff = max(nghost,ibuff+1)
         mibuff = nx + 2*mbuff
         locamrflags = node(storeflags,mptr)

c        ### is richardson used, add those flags to flags computed by spatial gradients
c        ### (or whatever user-defined criteria used). Even if nothing else used,
c        ### put flags into locamrflag array.
!--         if (flag_richardson) then   
!--            loctmp = node(store2, mptr)
!--            call addflags(alloc(locamrflags),mibuff,mjbuff,
!--     .           alloc(loctmp),nvar,mitot,mjtot,mptr)
!--         endif 

c     still need to reclaim error est space from spest.f 
c     which was saved for possible errest reuse
         if (flag_richardson) then
         locbig = node(tempptr,mptr)
         call reclam(locbig,mitot*nvar)
         endif
c     
         if (eprint .and. maxthreads .eq. 1) then ! otherwise race for printing
            write(outunit,*)" flagged points before projec2", 
     .           lcheck," grid ",mptr, " (no buff cells)"
               write(outunit,100)(int(alloc(iadd(i))),
     &              i=mbuff+1,mibuff-mbuff)
         endif

c     for this version project to each grid separately, no giant iflags
         if (lcheck+2 .le. mxnest) then
            numpro2 = 0
            call projec1(lcheck,numpro2,alloc(locamrflags),
     .           ilo,ihi,mbuff)
c            numpro = numpro + numpro2  not used for now. would need critical section for numpro
         endif      

         if (eprint .and. maxthreads .eq. 1) then
            write(outunit,*)" flagged points before buffering on level", 
     .           lcheck," grid ",mptr, " (no buff cells)"
               write(outunit,100)(int(alloc(iadd(i))),
     &              i=mbuff+1,mibuff-mbuff)
 100           format(80i1)
         endif
c     
         if (eprint .and. maxthreads .eq. 1) then
            write(outunit,*)" flagged points after projecting to level", 
     .           lcheck, " grid ",mptr,
     .           "(withOUT buff cells)"
c     .                    "(with buff cells)"
c     buffer zone (wider ghost cell region) now set after buffering
c     so loop over larger span of indices
               write(outunit,100)(int(alloc(iadd(i))),
     .              i=mbuff+1,mibuff-mbuff)
         endif

c
c  diffuse flagged points in all 4 directions to make buffer zones 
c  note that this code flags with a same value as true flagged
c  points, not a different number.
      call shiftset(alloc(locamrflags),ilo,ihi,mbuff)

      if (eprint .and. maxthreads .eq. 1) then
         write(outunit,*)" flagged points after buffering on level", 
     .                    lcheck," grid ",mptr," (WITHOUT buff cells))"
           write(outunit,100)(int(alloc(iadd(i))),
     .                           i=mbuff+1, mibuff-mbuff)
      endif
c   
c   count up
c
      numflagged = 0
      do 82 i = 1, mibuff
          if (alloc(iadd(i)) .gt. DONTFLAG) then
              numflagged=numflagged + 1
          endif
 82   continue
c     write(outunit,116) numflagged, mptr
 116     format(i5,' points flagged on level ',i4,' grid ',i4)
         node(numflags,mptr) = numflagged
!$OMP CRITICAL(nb)
         numbad = numbad + numflagged   
!$OMP END CRITICAL(nb)

c ADD WORK THAT USED TO BE IN FLGLVL2 FOR MORE PARALLEL WORK WITHOUT JOINING AND SPAWNING AGAIN
c in effect this is domgrid, but since variables already defined just need half of it, inserted here
      ibytesPerDP = 8      
c     bad names, for historical reasons. they are both smae size now
      locdomflags = igetsp( (mibuff)/ibytesPerDP+1)
      locdom2 = igetsp( (mibuff)/ibytesPerDP+1)

      node(domflags_base,mptr) = locdomflags
      node(domflags2,mptr) = locdom2

      call setdomflags(mptr,alloc(locdomflags),ilo,ihi,
     .                 mbuff,lbase,lcheck,mibuff)


      end do
!$OMP END PARALLEL DO
c     mptr = node(levelptr,mptr)
c     if (mptr .ne. 0) go to 41

      if (verbosity_regrid .ge. lcheck) then
        write(outunit,*)" total flagged points counted on level ",
     .                  lcheck," is ",numbad
        write(outunit,*)"this may include double counting buffer cells",
     &                  " on  multiple grids"
      endif

      return
      end

c
c
c =========================================================
      subroutine copyq2(meqn,mbc,mx,my,q1,q2)
c =========================================================
c
c     # copy the contents of q1 into q2
c
      implicit double precision (a-h,o-z)
      dimension q1(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension q2(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
c
c
      do 10 j = 1-mbc, my+mbc
        do 10 i = 1-mbc, mx+mbc
          do 10 m=1,meqn
             q2(m,i,j) = q1(m,i,j)
   10        continue
      return
      end

! ==================================================================
subroutine flux3(ixyz,maxm,num_eqn,num_waves,num_ghost,mx, &
                 q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3,num_aux, &
                 method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                 wave,s,amdq,apdq,cqxx, &
                 bmamdq,bmapdq,bpamdq,bpapdq, &
                 cmamdq,cmapdq,cpamdq,cpapdq, &
                 cmamdq2,cmapdq2,cpamdq2,cpapdq2, &
                 bmcqxxp,bpcqxxp,bmcqxxm,bpcqxxm, &
                 cmcqxxp,cpcqxxp,cmcqxxm,cpcqxxm, &
                 bmcmamdq,bmcmapdq,bpcmamdq,bpcmapdq, &
                 bmcpamdq,bmcpapdq,bpcpamdq,bpcpapdq, &
                 use_fwave,rpn3,rpt3,rptt3)
! ==================================================================

! Compute the modification to fluxes f, g and h that are generated by
! all interfaces along a 1D slice of the 3D patch.
! ixyz = 1  if it is a slice in x
! 2  if it is a slice in y
! 3  if it is a slice in z
! This value is passed into the Riemann solvers. The flux modifications
! go into the arrays fadd, gadd and hadd.  The notation is written
! assuming we are solving along a 1D slice in the x-direction.

! fadd(i,.) modifies F to the left of cell i
! gadd(i,.,1,slice) modifies G below cell i (in the z-direction)
! gadd(i,.,2,slice) modifies G above cell i
!                     The G flux in the surrounding slices may
!                     also be updated.
!                     slice  =  -1     The slice below in y-direction
!                     slice  =   0     The slice used in the 2D method
!                     slice  =   1     The slice above in y-direction
!     hadd(i,.,1,slice) modifies H below cell i (in the y-direction)
!     hadd(i,.,2,slice) modifies H above cell i
!                     The H flux in the surrounding slices may
!                     also be updated.
!                     slice  =  -1     The slice below in z-direction
!                     slice  =   0     The slice used in the 2D method
!                     slice  =   1     The slice above in z-direction

! The method used is specified by method(2) and method(3):

! method(2) = 1 No correction waves
!           = 2 if second order correction terms are to be added, with
!                  a flux limiter as specified by mthlim.  No transverse
!                  propagation of these waves.

!         method(3) specifies how the transverse wave propagation
!         of the increment wave and the correction wave are performed.
!         Note that method(3) is given by a two digit number, in
!         contrast to what is the case for claw2. It is convenient
!         to define the scheme using the pair (method(2),method(3)).

! method(3) <  0 Gives dimensional splitting using Godunov
!                splitting, i.e. formally first order
!                accurate.
!              0 Gives the Donor cell method. No transverse
!                propagation of neither the increment wave
!                nor the correction wave.
!           = 10 Transverse propagation of the increment wave
!                as in 2D. Note that method (2,10) is
!                unconditionally unstable.
!           = 11 Corner transport upwind of the increment
!                wave. Note that method (2,11) also is
!                unconditionally unstable.
!           = 20 Both the increment wave and the correction
!                wave propagate as in the 2D case. Only to
!                be used with method(2) = 2.
!           = 21 Corner transport upwind of the increment wave,
!                and the correction wave propagates as in 2D.
!                Only to be used with method(2) = 2.
!           = 22 3D propagation of both the increment wave and
!                the correction wave. Only to be used with
!                method(2) = 2.

! Recommended settings:   First order schemes:
!                               (1,10) Stable for CFL < 1/2
!                               (1,11) Stable for CFL < 1
!                         Second order schemes:
!                                (2,20) Stable for CFL < 1/2
!                                (2,22) Stable for CFL < 1

! WARNING! The schemes (2,10), (2,11) are unconditionally unstable.

! ----------------------------------

! Note that if method(6)=1 then the capa array comes into the second
! order correction terms, and is already included in dtdx1d:
! If ixyz = 1 then
!    dtdx1d(i) = dt/dx                      if method(6) = 0
!              = dt/(dx*capa(i,jcom,kcom))  if method(6) = 1
! If ixyz = 2 then
!    dtdx1d(j) = dt/dy                      if method(6) = 0
!              = dt/(dy*capa(icom,j,kcom))  if method(6) = 1
! If ixyz = 3 then
!    dtdx1d(k) = dt/dz                      if method(6) = 0
!              = dt/(dz*capa(icom,jcom,k))  if method(6) = 1

! Notation:
!    The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn3 into
!        amdq =  the left-going flux difference  A^- Delta q
!        apdq = the right-going flux difference  A^+ Delta q
!    Each of these is split by rpt3 into
!        bmasdq = the down-going transverse flux difference B^- A^* Delta q
!        bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
!    where A^* represents either A^- or A^+.


    implicit real*8(a-h,o-z)
    external rpn3,rpt3, rptt3
    dimension     q1d(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension    amdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension    apdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   cqxx(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   qadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   fadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension   hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)

    dimension  cmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpapdq(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  cmamdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmapdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpamdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpapdq2(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bmcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bmcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bpcmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcpapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcpapdq(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension dtdx1d(1-num_ghost:maxm+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost,3)

    dimension    s(num_waves,1-num_ghost:maxm+num_ghost)
    dimension  wave(num_eqn,num_waves,1-num_ghost:maxm+num_ghost)

    dimension method(7),mthlim(num_waves)
    logical :: limit, use_fwave
    common/comxyt/dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom

!f2py external rpn3, rpt3, rptt3
!f2py intent(callback) rpn3,rpt3, rptt3

    limit = .false.
    do mw=1,num_waves
        if (mthlim(mw) > 0) limit = .TRUE. 
    end do

    ! initialize flux increments:
    ! -----------------------------

    forall (m = 1:num_eqn, i = 1-num_ghost:mx+num_ghost)
        qadd(m,i) = 0.d0
        fadd(m,i) = 0.d0
    end forall
    forall (m=1:num_eqn,k=1:2, j = -1:1, i = 1-num_ghost:mx+num_ghost)
        gadd(m, k, j, i) = 0.d0
        hadd(m, k, j, i) = 0.d0
    end forall

    ! local method parameters
    if (method(3) < 0) then
        ! dimensional splitting
        m3 = -1
        m4 = 0
    else
        ! unsplit method
        m3 = method(3)/10
        m4 = method(3) - 10*m3
    endif

    ! -----------------------------------------------------------
    ! solve normal Riemann problem and compute Godunov updates
    ! -----------------------------------------------------------

    ! aux2(1-num_ghost,1,2) is the start of a 1d array now used by rpn3
    call rpn3(ixyz,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux2(1,1-num_ghost,2),aux2(1,1-num_ghost,2),wave,s,amdq,apdq)

    ! Set qadd for the donor-cell upwind method (Godunov)
    forall (m = 1:num_eqn, i = 1:mx+1)
        qadd(m,i) = qadd(m,i) - dtdx1d(i)*apdq(m,i)
        qadd(m,i-1) = qadd(m,i-1) - dtdx1d(i-1)*amdq(m,i)
    end forall

    ! compute maximum wave speed for checking Courant number:
    cfl1d = 0.d0
    do i=1,mx+1
        do mw=1,num_waves
            ! if s>0 use dtdx1d(i) to compute CFL,
            ! if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i),-dtdx1d(i-1)*s(mw,i))
        end do
    end do

    if (method(2) == 1) go to 130

    ! -----------------------------------------------------------
    ! modify F fluxes for second order q_{xx} correction terms:
    ! F fluxes are in normal, or x-like, direction
    ! -----------------------------------------------------------

    ! apply limiter to waves:
    if (limit) call limiter(maxm,num_eqn,num_waves,num_ghost,mx,wave, &
                            s,mthlim)

    do i = 2-num_ghost,mx+num_ghost
    
        ! For correction terms below, need average of dtdx in cell
        ! i-1 and i.  Compute these and overwrite dtdx1d:
    
        dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
    
        forall (m = 1:num_eqn)
            cqxx(m,i) = 0.d0
        end forall
        if (use_fwave.eqv. .FALSE. ) then
            do mw = 1,num_waves
                do m = 1,num_eqn
                    cqxx(m,i) = cqxx(m,i) + 0.5d0 * dabs(s(mw,i)) &
                    * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                end do
            end do
        else
            do mw = 1,num_waves
                do m = 1,num_eqn
                    cqxx(m,i) = cqxx(m,i) + 0.5d0 * dsign(1.d0,s(mw,i)) &
                    * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                end do
            end do
        endif 
        do m = 1,num_eqn
            fadd(m,i) = fadd(m,i) + cqxx(m,i)
        end do
    end do

    130 continue

    if (m3 <= 0) return !! no transverse propagation

    ! --------------------------------------------
    ! TRANSVERSE PROPAGATION
    ! --------------------------------------------

    ! split the left-going flux difference into down-going and up-going
    ! flux differences (in the y-direction).

    call rpt3(ixyz,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1, &
              aux2,aux3,amdq,bmamdq,bpamdq)

    ! split the right-going flux difference into down-going and up-going
    ! flux differences (in the y-direction).

    call rpt3(ixyz,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1, &
              aux2,aux3,apdq,bmapdq,bpapdq)

    ! split the left-going flux difference into down-going and up-going
    ! flux differences (in the z-direction).

    call rpt3(ixyz,3,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1, &
              aux2,aux3,amdq,cmamdq,cpamdq)

    ! split the right-going flux difference into down-going and up-going
    ! flux differences (in the y-direction).

    call rpt3(ixyz,3,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1, &
              aux2,aux3,apdq,cmapdq,cpapdq)

    ! Split the correction wave into transverse propagating waves
    ! in the y-direction and z-direction.

    if (m3 == 2) then
        if (num_aux > 0) then
            ! The corrections cqxx affect both cell i-1 to left and cell i
            ! to right of interface.  Transverse splitting will affect
            ! fluxes on both sides.
            ! If there are aux arrays, then we must split cqxx twice in
            ! each transverse direction, once with imp=1 and once with imp=2:

            ! imp = 1 or 2 is used to indicate whether we are propagating
            ! amdq or apdq, i.e. cqxxm or cqxxp

            ! in the y-like direction with imp=1
            call rpt3(ixyz,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d, &
                      q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

            ! in the y-like direction with imp=2
                      call rpt3(ixyz,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d, &
            q1d,aux1,aux2,aux3,cqxx,bmcqxxp,bpcqxxp)

            ! in the z-like direction with imp=1
            call rpt3(ixyz,3,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d, &
                      q1d,aux1,aux2, aux3,cqxx,cmcqxxm,cpcqxxm)

            ! in the z-like direction with imp=2
            call rpt3(ixyz,3,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d, &
                      q1d,aux1,aux2,aux3,cqxx,cmcqxxp,cpcqxxp)
        else
            ! aux arrays aren't being used, so we only need to split
            ! cqxx once in each transverse direction and the same result can
            ! presumably be used to left and right.
            ! Set imp = 0 since this shouldn't be needed in rpt3 in this case.

            ! in the y-like direction
            call rpt3(ixyz,2,0,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d, &
                      q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

            ! in the z-like direction
            call rpt3(ixyz,3,0,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d, &
                      q1d,aux1,aux2,aux3,cqxx,cmcqxxm,cpcqxxm)

            ! use the same splitting to left and right:
            forall (m = 1:num_eqn, i = 0:mx+2)
                bmcqxxp(m,i) = bmcqxxm(m,i)
                bpcqxxp(m,i) = bpcqxxm(m,i)
                cmcqxxp(m,i) = cmcqxxm(m,i)
                cpcqxxp(m,i) = cpcqxxm(m,i)
            end forall
        endif
    endif

    ! --------------------------------------------
    ! modify G fluxes in the y-like direction
    ! --------------------------------------------

    ! If the correction wave also propagates in a 3D sense, incorporate
    ! cpcqxx,... into cmamdq, cpamdq, ... so that it is split also.

    if(m4 == 1)then
        forall (m = 1:num_eqn, i = 0:mx+2)
            cpapdq2(m,i) = cpapdq(m,i)
            cpamdq2(m,i) = cpamdq(m,i)
            cmapdq2(m,i) = cmapdq(m,i)
            cmamdq2(m,i) = cmamdq(m,i)
        end forall
    else if(m4 == 2)then
        forall (m = 1:num_eqn, i = 0:mx+2)
            cpapdq2(m,i) = cpapdq(m,i) - 3.d0*cpcqxxp(m,i)
            cpamdq2(m,i) = cpamdq(m,i) + 3.d0*cpcqxxm(m,i)
            cmapdq2(m,i) = cmapdq(m,i) - 3.d0*cmcqxxp(m,i)
            cmamdq2(m,i) = cmamdq(m,i) + 3.d0*cmcqxxm(m,i)
        end forall
    endif

    ! The transverse flux differences in the z-direction are split
    ! into waves propagating in the y-direction. If m4 = 2,
    ! then the transverse propagating correction waves in the z-direction
    ! are also split. This yields terms of the form BCAu_{xzy} and
    ! BCAAu_{xxzy}.

    if( m4 > 0 )then
        call rptt3(ixyz,2,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,cpapdq2,bmcpapdq,bpcpapdq)
        call rptt3(ixyz,2,1,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,cpamdq2,bmcpamdq,bpcpamdq)
        call rptt3(ixyz,2,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,cmapdq2,bmcmapdq,bpcmapdq)
        call rptt3(ixyz,2,1,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,cmamdq2,bmcmamdq,bpcmamdq)
    endif

    ! -----------------------------
    ! The updates for G fluxes :
    ! -----------------------------

    do i = 1, mx+1
        do m=1,num_eqn
        
            ! Transverse propagation of the increment waves
            ! between cells sharing interfaces, i.e. the 2D approach.
            ! Yields BAu_{xy}.
        
            gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                - 0.5d0*dtdx1d(i-1)*bmamdq(m,i)
            gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                - 0.5d0*dtdx1d(i-1)*bpamdq(m,i)
            gadd(m,1,0,i) = gadd(m,1,0,i) - 0.5d0*dtdx1d(i)*bmapdq(m,i)
            gadd(m,2,0,i) = gadd(m,2,0,i) - 0.5d0*dtdx1d(i)*bpapdq(m,i)
        
            ! Transverse propagation of the increment wave (and the
            ! correction wave if m4=2) between cells
            ! only having a corner or edge in common. Yields terms of the
            ! BCAu_{xzy} and BCAAu_{xxzy}.
        
            if ( m4 > 0 )then

                gadd(m,2,0,i) = gadd(m,2,0,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                    * (bpcpapdq(m,i) - bpcmapdq(m,i))
                gadd(m,1,0,i) = gadd(m,1,0,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                    * (bmcpapdq(m,i) - bmcmapdq(m,i))


                gadd(m,2,1,i) = gadd(m,2,1,i) &
                    - (1.d0/6.d0)*dtdx1d(i)*dtdz &
                    * bpcpapdq(m,i)
                gadd(m,1,1,i) = gadd(m,1,1,i) &
                    - (1.d0/6.d0)*dtdx1d(i)*dtdz &
                    * bmcpapdq(m,i)
                gadd(m,2,-1,i) = gadd(m,2,-1,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                    * bpcmapdq(m,i)
                gadd(m,1,-1,i) = gadd(m,1,-1,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                    * bmcmapdq(m,i)
            
                gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                    * (bpcpamdq(m,i) - bpcmamdq(m,i))
                gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                    * (bmcpamdq(m,i) - bmcmamdq(m,i))


                gadd(m,2,1,i-1) = gadd(m,2,1,i-1) &
                    - (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                    * bpcpamdq(m,i)
                gadd(m,1,1,i-1) = gadd(m,1,1,i-1) &
                    - (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                    * bmcpamdq(m,i)
                gadd(m,2,-1,i-1) = gadd(m,2,-1,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                    * bpcmamdq(m,i)
                gadd(m,1,-1,i-1) = gadd(m,1,-1,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                    * bmcmamdq(m,i)
            
            endif
        
            ! Transverse propagation of the correction wave between
            ! cells sharing faces. This gives BAAu_{xxy}.
        
            if (m3 .ge. 2) then
                gadd(m,2,0,i)   = gadd(m,2,0,i) &
                    + dtdx1d(i)*bpcqxxp(m,i)
                gadd(m,1,0,i)   = gadd(m,1,0,i) &
                    + dtdx1d(i)*bmcqxxp(m,i)
                gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                    - dtdx1d(i-1)*bpcqxxm(m,i)
                gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                    - dtdx1d(i-1)*bmcqxxm(m,i)
            endif
        end do
    end do


    ! --------------------------------------------
    ! modify H fluxes in the z-like direction
    ! --------------------------------------------

    ! If the correction wave also propagates in a 3D sense, incorporate
    ! cqxx into bmamdq, bpamdq, ... so that is is split also.

    if(m4 == 2)then
        forall (m = 1:num_eqn, i = 0:mx+2)
            bpapdq(m,i) = bpapdq(m,i) - 3.d0*bpcqxxp(m,i)
            bpamdq(m,i) = bpamdq(m,i) + 3.d0*bpcqxxm(m,i)
            bmapdq(m,i) = bmapdq(m,i) - 3.d0*bmcqxxp(m,i)
            bmamdq(m,i) = bmamdq(m,i) + 3.d0*bmcqxxm(m,i)
        end forall
    endif

    ! The transverse flux differences in the y-direction are split
    ! into waves propagating in the z-direction. If m4 = 2,
    ! then the transverse propagating correction waves in the y-direction
    ! are also split. This yields terms of the form BCAu_{xzy} and
    ! BCAAu_{xxzy}.

    ! note that the output to rptt3 below should logically be named
    ! cmbsasdq and cpbsasdq rather than bmcsasdq and bpcsasdq, but
    ! we are re-using the previous storage rather than requiring new arrays.

    if( m4 > 0 )then
        call rptt3(ixyz,3,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,bpapdq,bmcpapdq,bpcpapdq)
        call rptt3(ixyz,3,1,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,bpamdq,bmcpamdq,bpcpamdq)
        call rptt3(ixyz,3,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,bmapdq,bmcmapdq,bpcmapdq)
        call rptt3(ixyz,3,1,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                   aux1,aux2,aux3,bmamdq,bmcmamdq,bpcmamdq)
    endif

    ! -----------------------------
    ! The updates for H fluxes :
    ! -----------------------------

    do i = 1, mx+1
        do m=1,num_eqn
        
            ! Transverse propagation of the increment waves
            ! between cells sharing interfaces, i.e. the 2D approach.
            ! Yields CAu_{xy}.
        
            hadd(m,1,0,i-1) = hadd(m,1,0,i-1) &
                - 0.5d0*dtdx1d(i-1)*cmamdq(m,i)
            hadd(m,2,0,i-1) = hadd(m,2,0,i-1) &
                - 0.5d0*dtdx1d(i-1)*cpamdq(m,i)
            hadd(m,1,0,i)   = hadd(m,1,0,i) &
                - 0.5d0*dtdx1d(i)*cmapdq(m,i)
            hadd(m,2,0,i)   = hadd(m,2,0,i) &
                - 0.5d0*dtdx1d(i)*cpapdq(m,i)
        
            ! Transverse propagation of the increment wave (and the
            ! correction wave if m4=2) between cells
            ! only having a corner or edge in common. Yields terms of the
            ! CBAu_{xzy} and CBAAu_{xxzy}.
        
            if( m4 > 0 )then
            
                hadd(m,2,0,i)  = hadd(m,2,0,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                    * (bpcpapdq(m,i) - bpcmapdq(m,i))
                hadd(m,1,0,i)  = hadd(m,1,0,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                    * (bmcpapdq(m,i) - bmcmapdq(m,i))


                hadd(m,2,1,i)  = hadd(m,2,1,i) &
                    - (1.d0/6.d0)*dtdx1d(i)*dtdy &
                    * bpcpapdq(m,i)
                hadd(m,1,1,i)  = hadd(m,1,1,i) &
                    - (1.d0/6.d0)*dtdx1d(i)*dtdy &
                    * bmcpapdq(m,i)
                hadd(m,2,-1,i) = hadd(m,2,-1,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                    * bpcmapdq(m,i)
                hadd(m,1,-1,i) = hadd(m,1,-1,i) &
                    + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                    * bmcmapdq(m,i)
            
                hadd(m,2,0,i-1)  = hadd(m,2,0,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                    * (bpcpamdq(m,i) - bpcmamdq(m,i))
                hadd(m,1,0,i-1)  = hadd(m,1,0,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                    * (bmcpamdq(m,i) - bmcmamdq(m,i))


                hadd(m,2,1,i-1)  = hadd(m,2,1,i-1) &
                    - (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                    * bpcpamdq(m,i)
                hadd(m,1,1,i-1)  = hadd(m,1,1,i-1) &
                    - (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                    * bmcpamdq(m,i)
                hadd(m,2,-1,i-1) = hadd(m,2,-1,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                    * bpcmamdq(m,i)
                hadd(m,1,-1,i-1) = hadd(m,1,-1,i-1) &
                    + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                    * bmcmamdq(m,i)
            
            endif
        
            ! Transverse propagation of the correction wave between
            ! cells sharing faces. This gives CAAu_{xxy}.
        
            if (m3 .ge. 2) then
                hadd(m,2,0,i)   = hadd(m,2,0,i) &
                    + dtdx1d(i)*cpcqxxp(m,i)
                hadd(m,1,0,i)   = hadd(m,1,0,i) &
                    + dtdx1d(i)*cmcqxxp(m,i)
                hadd(m,2,0,i-1) = hadd(m,2,0,i-1) &
                    - dtdx1d(i-1)*cpcqxxm(m,i)
                hadd(m,1,0,i-1) = hadd(m,1,0,i-1) &
                    - dtdx1d(i-1)*cmcqxxm(m,i)
            endif
        end do
    end do

    return
end subroutine flux3

!     ==========================================
    subroutine mapc2p(x1,y1,xp,yp,zp,Rsphere)
!     ==========================================

!     Map computational point (x1,y1) to the point (xp,yp,zp)
!     on the sphere.

!     Points in [-1,1]x[-1,1]  are mapped to the upper hemisphere
!     Points in [-3,-1]x[-1,1] are mapped to the lower hemisphere

    implicit real*8(a-h,o-z)
!f2py  double precision intent(in) x1
!f2py  double precision intent(in) y1
!f2py  double precision intent(in) xp
!f2py  double precision intent(in) yp
!f2py  double precision intent(in) zp
!f2py  double precision intent(in) Rsphere


    r1 = Rsphere
    xc = x1
    yc = y1
    pi = 4.d0*datan(1.d0)

!     # ghost cell values outside of [-3,1]x[-1,1] get mapped to other
!     # hemisphere:
    if (xc >= 1.d0) xc = xc-4.d0
    if (xc < -3.d0) xc = xc+4.d0

    if (yc >= 1.d0) then
        yc = 2.d0 - yc
        xc = -2.d0 - xc
    endif
          
    if (yc < -1.d0) then
        yc = -2.d0 - yc
        xc = -2.d0 - xc
    endif

    if (xc < -1.d0) then
    !         # points in [-3,-1] map to lower hemisphere - reflect about x=-1
    !         # to compute x,y mapping and set sgnz appropriately:
        xc = -2.d0 - xc
        sgnz = -1.d0
    else
        sgnz = 1.d0
    endif
          
    sgnxc = dsign(1.d0,xc)
    sgnyc = dsign(1.d0,yc)

    xc1 = dabs(xc)
    yc1 = dabs(yc)
    d = dmax1(dmax1(xc1,yc1), 1.d-10)

    DD = r1*d*(2.d0 - d) / dsqrt(2.d0)
    R = r1

    centers = DD - dsqrt(dmax1(R**2 - DD**2, 0.d0))
    xp = DD/d * xc1
    yp = DD/d * yc1

    if (yc1 > xc1) then
        yp = centers + dsqrt(dmax1(R**2 - xp**2, 0.d0))
    else
        xp = centers + dsqrt(dmax1(R**2 - yp**2, 0.d0))
    endif

    zp = dsqrt(dmax1(r1**2 - (xp**2 + yp**2), 0.d0))
    xp = xp*sgnxc
    yp = yp*sgnyc
    zp = zp*sgnz

    return
    end subroutine mapc2p

c
c ----------------------------------------------------------------
c
       subroutine auxcoarsen(auxdub,midub,mjdub,mkdub,auxbgc,
     1                       mi2tot,mj2tot,mk2tot,naux,auxtype)

       implicit double precision (a-h, o-z)

       dimension     auxdub(naux, midub, mjdub, mkdub)
       dimension     auxbgc(naux, mi2tot,mj2tot,mk2tot)
       character*10  auxtype(naux)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
c coarsen = coarsen the fine grid auxiliary data (with double the usual
c           number of ghost cells to prepare coarsened data
c           for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       do 50 iaux = 1, naux

       if (auxtype(iaux) .eq. "center" .or.
     .     auxtype(iaux) .eq. "capacity") then
         do 20 k = 1, mk2tot
            kfine = 2*(k-1) + 1
            do 20 j = 1, mj2tot
               jfine = 2*(j-1) + 1
               do 20 i = 1, mi2tot
                  ifine = 2*(i-1) + 1
                  auxbgc(iaux,i,j,k) =
     &                      ( auxdub(iaux,ifine  ,jfine  ,kfine  )
     &                       +auxdub(iaux,ifine+1,jfine  ,kfine  )
     &                       +auxdub(iaux,ifine  ,jfine+1,kfine  )
     &                       +auxdub(iaux,ifine+1,jfine+1,kfine  )
     &                       +auxdub(iaux,ifine  ,jfine  ,kfine+1)
     &                       +auxdub(iaux,ifine+1,jfine  ,kfine+1)
     &                       +auxdub(iaux,ifine  ,jfine+1,kfine+1)
     &                       +auxdub(iaux,ifine+1,jfine+1,kfine+1))/8.d0
20       continue

       elseif (auxtype(iaux) .eq. "xleft") then
         do 10 k = 1, mk2tot
            kfine = 2*(k-1) + 1
            do 10 j = 1, mj2tot
               jfine = 2*(j-1) + 1
               do 10 i = 1, mi2tot
                  ifine = 2*(i-1) + 1
                  auxbgc(iaux,i,j,k) =
     &                        ( auxdub(iaux,ifine,jfine  ,kfine  )
     &                         +auxdub(iaux,ifine,jfine+1,kfine  )
     &                         +auxdub(iaux,ifine,jfine  ,kfine+1)
     &                         +auxdub(iaux,ifine,jfine+1,kfine+1))/4.d0
10       continue

       elseif (auxtype(iaux) .eq. "yleft") then
         do 15 k = 1, mk2tot
            kfine = 2*(k-1) + 1
            do 15 j = 1, mj2tot
               jfine = 2*(j-1) + 1
               do 15 i = 1, mi2tot
                  ifine = 2*(i-1) + 1
                  auxbgc(iaux,i,j,k) =
     &                         (auxdub(iaux,ifine  ,jfine,kfine  )
     &                         +auxdub(iaux,ifine+1,jfine,kfine  )
     &                         +auxdub(iaux,ifine  ,jfine,kfine+1)
     &                         +auxdub(iaux,ifine+1,jfine,kfine+1))/4.d0
15       continue

       elseif (auxtype(iaux) .eq. "zleft") then
         do 19 k = 1, mk2tot
            kfine = 2*(k-1) + 1
            do 19 j = 1, mj2tot
               jfine = 2*(j-1) + 1
               do 19 i = 1, mi2tot
                  ifine = 2*(i-1) + 1
                  auxbgc(iaux,i,j,k) =
     &                         (auxdub(iaux,ifine  ,jfine  ,kfine)
     &                         +auxdub(iaux,ifine+1,jfine  ,kfine)
     &                         +auxdub(iaux,ifine  ,jfine+1,kfine)
     &                         +auxdub(iaux,ifine+1,jfine+1,kfine))/4.d0
19       continue

       endif

50     continue

       return
       end

        Subroutine Rescale(a,b,n)
        Implicit none
        Integer n,i,j
        Real*8 a(n,n), b
Cf2py intent(in,out,overwrite) a
        do i = 1,n
           do j=1,n
             a(i,j)=b*a(i,j)
           end do
        end do
        end

! Default qinit file
subroutine qinit(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)

    !> Set initial conditions for the q array.
    ! This default version prints an error message since it should
    ! not be used directly.  Copy this to an application directory and
    ! loop over all grid cells to set values of q(1:meqn, 1:mx, 1:my).

    implicit none
    
    integer, intent(in) :: meqn,mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)

    write(6,*) '*** Error -- you must set initial conditions'
    stop

end subroutine qinit

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::: Parameters, variables, subroutines related to gauges
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

! Contains:
!   subroutine set_gauges
!     Called initially to read from gauges.data
!   subroutine setbestsrc
!     Called each time regridding is done to determine which patch to 
!     use for interpolating to each gauge location.
!   subroutine print_gauges
!     Called each time step for each grid patch.
!     Refactored dumpgauge routine to interpolate for all gauges on patch.
!
!     Note: by default all components of q are printed at each gauge.
!     To print something different or a different precision, modify 
!     format statement 100 and/or the write statement that uses it.
!   
! Note: Updated for Clawpack 5.3.0:
!   - the dumpgauge and setbestsrc subroutines have been moved to this module 
!     and the dumpgauge subroutine has been refactored and renamed print_gauges.
!   - dumpgauge.f must be removed from Makefiles.
!   - setbestsrc uses quicksort to sort gauge numbers and
!     then figures out which gauges will be updated by grid, and stores this
!     information in new module variables mbestg1, mbestg2.
!   - print_gauges no longer uses binary search to locate first gauge handled
!     by a grid.  Instead loop over gauges specified by mbestg1, mbestg2.
!
! Note: Updated for Clawpack 5.4.0
!   - refactor so each gauge writes to its own file, and batches the writes instead of 
!     writing one at a time. This will remove the critical section and should speed up gauges a lot
!   - When array is filled, that gauge will write to file and start over. 
!   - Need to save index so know position in array where left off
!   - At checkpoint times, dump all gauges
!
! Note: Updated for Clawpack 5.4.x
!  - Add gauge formatting capabilities
!
! Changed mjb, May, 2018 hackathon, to remove need for mbestg1 and mbestg2.
! looked at since they depended on maxgr, which is now a variable, not constant.
! also, algorithms didn't scale for O(10^5) grids, and O(100) gauges..

module gauges_module

    implicit none
    save

    logical, private :: module_setup = .false.

    integer, parameter :: OUTGAUGEUNIT=89
    integer :: num_gauges

    integer, parameter :: MAX_BUFFER = 1000

    ! Gauge data types
    type gauge_type
        ! Gauge number
        integer :: gauge_num

        character(len=14) :: file_name

        ! Location in time and space
        real(kind=8) :: x, y, t_start, t_end

        ! Last time recorded
        real(kind=8) :: last_time

        ! Last time and final (x,y) written to file 
        ! (only needed for lagrangian gauges, for checkpointing)
        ! lagrangian gauges not yet supported in multilayer,
        ! but these variables still needed for checkpt, restart
        real(kind=8) :: t_last_written, x_last_written, y_last_written


        ! Output settings
        integer :: file_format, gtype
        real(kind=8) :: min_time_increment
        character(len=10) :: display_format
        logical, allocatable :: q_out_vars(:)
        logical, allocatable :: aux_out_vars(:)
        integer :: num_out_vars

        ! Data buffers - data holds output and time
        real(kind=8), allocatable :: data(:, :)
        integer :: level(MAX_BUFFER)

        ! Where we are in the buffer
        integer :: buffer_index
    end type gauge_type

    ! Gague array
    type(gauge_type), allocatable :: gauges(:)

    ! Gauge source info
    integer, allocatable, dimension(:) ::  mbestsrc, igauge

contains

    subroutine set_gauges(restart, num_eqn, num_aux, fname)

        use utility_module, only: get_value_count

        use amr_module, only: NEEDS_TO_BE_SET
        use multilayer_module, only: num_layers

        implicit none

        ! Input
        logical, intent(in) :: restart
        integer :: num_eqn, num_aux
        character(len=*), intent(in), optional :: fname

        ! Locals
        integer :: i, n, index
        integer :: num, pos, digit
        integer, parameter :: UNIT = 7
        character(len=128) :: header_1
        character(len=32) :: q_column, aux_column, eta_column

        if (.not.module_setup) then

            ! Open file
            if (present(fname)) then
                call opendatafile(UNIT,fname)
            else
                call opendatafile(UNIT,'gauges.data')
            endif

            read(UNIT,*) num_gauges
            allocate(gauges(num_gauges))
            
            ! Initialize gauge source data
            allocate(mbestsrc(num_gauges))
            mbestsrc = 0

            ! Original gauge information
            do i=1,num_gauges
                read(UNIT, *) gauges(i)%gauge_num, gauges(i)%x, gauges(i)%y, &
                              gauges(i)%t_start, gauges(i)%t_end
                ! note that for lagrangian gauges, the x,y values read here 
                ! might be overwritten if this is a restart
                gauges(i)%buffer_index = 1
                gauges(i)%last_time = gauges(i)%t_start
                ! keep track of last position for lagrangian gauges,
                ! initialize here in case checkpoint happens before 
                ! ever writing this gauge:
                gauges(i)%t_last_written = NEEDS_TO_BE_SET
                gauges(i)%x_last_written = gauges(i)%x
                gauges(i)%y_last_written = gauges(i)%y
            enddo

            ! Read in output formats
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%file_format, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%display_format, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%min_time_increment, i=1, num_gauges)
            read(UNIT, *)
            read(UNIT, *)
            read(UNIT, *) (gauges(i)%gtype, i=1, num_gauges)

            do i=1,num_gauges
                if (gauges(i)%gtype == 2) then
                    write(6,*) "*** ERROR: Lagrangian gauges not supported"
                    write(6,*) "***        in multilayer code"
                    stop
                end if
            end do

            ! Read in q fields
            read(UNIT, *)
            read(UNIT, *)
            do i = 1, num_gauges
                allocate(gauges(i)%q_out_vars(num_eqn))
                read(UNIT, *) gauges(i)%q_out_vars

                ! Count number of vars to be output
                gauges(i)%num_out_vars = 0
                do n = 1, size(gauges(i)%q_out_vars, 1)
                    if (gauges(i)%q_out_vars(n)) then
                        gauges(i)%num_out_vars = gauges(i)%num_out_vars + 1
                    end if
                end do
            end do

            ! Read in aux fields (num_aux > 0 for geoclaw)
            read(UNIT, *)
            read(UNIT, *)
            do i = 1, num_gauges
                allocate(gauges(i)%aux_out_vars(num_aux))
                read(UNIT, *) gauges(i)%aux_out_vars

                ! Count number of vars to be output
                do n = 1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        gauges(i)%num_out_vars = gauges(i)%num_out_vars + 1
                    end if
                end do
            end do

            ! Count eta as one of the out vars
            gauges(:)%num_out_vars = gauges(:)%num_out_vars + num_layers

            close(UNIT)
            ! Done reading =====================================================

            ! Allocate data buffer - Note extra var out due to eta
            do i = 1, num_gauges
                allocate(gauges(i)%data(gauges(i)%num_out_vars + 2, MAX_BUFFER))
            end do

            ! Create gauge output files
            do i = 1, num_gauges
                gauges(i)%file_name = 'gaugexxxxx.txt'
                num = gauges(i)%gauge_num
                do pos = 10, 6, -1
                    digit = mod(num,10)
                    gauges(i)%file_name(pos:pos) = char(ichar('0') + digit)
                    num = num / 10
                end do

                ! Handle restart
                if (restart) then
                    open(unit=OUTGAUGEUNIT, file=gauges(i)%file_name,       &
                         status='old', position='append', form='formatted')
                else
                    open(unit=OUTGAUGEUNIT, file=gauges(i)%file_name,       &
                         status='unknown', position='append', form='formatted')
                    rewind OUTGAUGEUNIT

                    ! Write header
                    header_1 = "('# gauge_id= ',i5,' " //                   &
                               "location=( ',1e15.7,' ',1e15.7,' ) " //     &
                               "num_var= ',i2)"
                    write(OUTGAUGEUNIT, header_1) gauges(i)%gauge_num,      &
                                                  gauges(i)%x,              &
                                                  gauges(i)%y,              &
                                                  gauges(i)%num_out_vars

                    ! Construct column labels
                    index = 0
                    q_column = "["
                    do n=1, size(gauges(i)%q_out_vars, 1)
                        if (gauges(i)%q_out_vars(n)) then
                            write(q_column(3 * index + 2:4 + 3 * index), "(i3)") n
                            index = index + 1
                        end if
                    end do
                    q_column(3 * index + 2:4 + 3 * index) = "],"

                    ! Add eta
                    index = 0
                    eta_column = "["
                    do n=1, num_layers
                        write(eta_column(3 * index + 2:4 + 3 * index), "(i3)") n
                        index = index + 1
                    end do
                    eta_column(3 * index + 2:4 + 3 * index) = "],"

                    aux_column = "["
                    index = 0
                    do n=1, size(gauges(i)%aux_out_vars, 1)
                        if (gauges(i)%aux_out_vars(n)) then
                            write(aux_column(3 * index + 2:4 + 3 * index), "(i3)") n
                            index = index + 1
                        end if  
                    end do
                    aux_column(3 * index + 2:4 + 3 * index) = "]"

                    write(OUTGAUGEUNIT, *) "# level, time, q", trim(q_column), &
                                                      " eta", trim(eta_column),&
                                                      " aux", trim(aux_column)
               endif

               close(OUTGAUGEUNIT)

            end do

            module_setup = .true.
        end if

    end subroutine set_gauges


!
! --------------------------------------------------------------------
!
    subroutine setbestsrc()
!
!     Called every time grids change, to set the best source grid patch
!     for each gauge, i.e. the finest level patch that includes the gauge.
!
!     lbase is grid level that didn't change, but since fine
!     grid may have disappeared, we still have to look starting
!     at coarsest level 1.
!
        use amr_module
        implicit none

        integer :: lev, mptr, i, k1, ki

!
! ##  set source grid for each loc from coarsest level to finest.
! ##  that way finest src grid left and old ones overwritten
! ##  this code uses fact that grids do not overlap

! # for debugging, initialize sources to 0 then check that all set
        mbestsrc = 0

        !! reorder loop for better performance with O(10^5) grids
        !! for each gauge find best source grid for its data
        do 40 i = 1, num_gauges

           do 30 lev = lfine, 1, -1
            mptr = lstart(lev)
 20              if ((gauges(i)%x >= rnode(cornxlo,mptr)) .and. &
                        (gauges(i)%x <= rnode(cornxhi,mptr)) .and. &  
                        (gauges(i)%y >= rnode(cornylo,mptr)) .and. &
                        (gauges(i)%y <= rnode(cornyhi,mptr)) ) then
                        mbestsrc(i) = mptr
                      !! best source found for this gauge, go to next one
                      !! we know its the best because we started at finest level
                      go to 40  ! on to next gauge 
                 else 
                mptr = node(levelptr, mptr)
                    if (mptr .ne. 0) then
                       go to 20  ! try another grid
                    else
                       go to 30  ! try next coarser level grids
            end if
                 end if
 30        continue 

          if (mbestsrc(i) .eq. 0) &
              print *, "ERROR in setting grid src for gauge data", i
 40     continue 

!!!  NO MORE qsort and mbestg arrays. 
!!! Each grid now loops over mbestsrc array to see which gauges it owns.

    end subroutine setbestsrc


    ! ==========================================================================

    subroutine update_gauges(q, aux, xlow, ylow, num_eqn, mitot, mjtot, num_aux, &
                             mptr)
!
!     This routine is called each time step for each grid patch, to output
!     gauge values for all gauges for which this patch is the best one to 
!     use (i.e. at the finest refinement level).  

!     It is called after ghost cells have been filled from adjacent grids
!     at the same level, so bilinear interpolation can be used to 
!     to compute values at any gauge location that is covered by this grid.  

!     The grid patch is designated by mptr.
!     We only want to set gauges i for which mbestsrc(i) == mptr.
!     The array mbestsrc is reset after each regridding to indicate which
!     grid patch is best to use for each gauge.

!     This is a refactoring of dumpgauge.f from Clawpack 5.2 
!     Loops over only the gauges to be handled by this grid, as specified
!     by indices from mbestg1(mptr) to mbestg2(mptr)
!     NO MORE mbestg1 and 2.  Loop through all gauges. No sorting too.

        use amr_module, only: nestlevel, nghost, timemult, rnode, node, maxvar
        use amr_module, only: hxposs, hyposs

        use geoclaw_module, only: rho

        use multilayer_module, only: num_layers, dry_tolerance, eta_init

        implicit none

        ! Input
        integer, intent(in) ::  num_eqn, mitot, mjtot, num_aux, mptr
        real(kind=8), intent(in) :: q(num_eqn, mitot, mjtot)
        real(kind=8), intent(in) :: aux(num_aux, mitot, mjtot)
        real(kind=8), intent(in) :: xlow, ylow

        ! Locals
        real(kind=8) :: var(maxvar * 2)
        real(kind=8) :: xcent, ycent, xoff, yoff, tgrid, hx, hy
        integer :: level, i1, i2, icell, jcell, iindex, jindex
        integer :: i, j, n, m, k, var_index, layer_index, eta_index
        real(kind=8) :: h(4), mod_dry_tolerance, topo
        real(kind=8) :: h_interp(num_layers), eta(num_layers)
        logical :: dry_state

        ! No gauges to record, exit
        if (num_gauges == 0) then
            return
        endif

        ! Grid info
        tgrid = rnode(timemult, mptr)
        level = node(nestlevel, mptr)
        hx = hxposs(level)
        hy = hyposs(level)

        ! Main Gauge Loop ======================================================
        do i = 1, num_gauges
            if (mptr .ne. mbestsrc(i)) cycle 
            if (tgrid < gauges(i)%t_start .or. tgrid > gauges(i)%t_end) then
               cycle
            endif
            ! Minimum increment
            ! TODO Maybe always allow last time output recording?
            if (tgrid - gauges(i)%last_time < gauges(i)%min_time_increment) then
                cycle
            end if

            ! Compute indexing and bilinear interpolant weights
            ! Note: changed 0.5 to  0.5d0 etc.
                iindex =  int(.5d0 + (gauges(i)%x - xlow) / hx)
                jindex =  int(.5d0 + (gauges(i)%y - ylow) / hy)
            if ((iindex < nghost .or. iindex > mitot-nghost) .or. &
                (jindex < nghost .or. jindex > mjtot-nghost)) then
                    print *, "ERROR in output of Gauge Data "
            end if
            xcent  = xlow + (iindex - 0.5d0) * hx
            ycent  = ylow + (jindex - 0.5d0) * hy
                xoff   = (gauges(i)%x - xcent) / hx
                yoff   = (gauges(i)%y - ycent) / hy

            ! Gauge interpolation seems to work, so error test is commented out.
            ! For debugging, use the code below...
            !   Note: we expect 0 <= xoff, yoff <= 1 but if gauge is exactly 
            !   at center of cell these might be off by rounding error

            !if (xoff .lt. -1.d-4 .or. xoff .gt. 1.0001d0 .or. &
            !    yoff .lt. -1.d-4 .or. yoff .gt. 1.0001d0) then
            !   write(6,*) "*** print_gauges: Interpolation problem at gauge ",&
                !               igauge(i)
            !   write(6,*) "    xoff,yoff: ", xoff,yoff
            !endif


            ! Modified below from amrclaw/src/2d/gauges_module.f90 
            ! to interpolate only where all four cells are
            ! wet, otherwise just take this cell value:

            ! Check for dry cells by comparing h to mod_dry_tolerance, which 
            ! should be smaller than drytolerance to avoid oscillations since  
            ! when h < drytolerance the velocities are zeroed out which can then 
            ! lead to increase in h again.

            ! Layer Loop =======================================================
            dry_state = .false.
            
            ! Count for number of variables written to var
            var_index = 0

            do m = 1, num_layers
                layer_index = 3 * (m - 1)
                mod_dry_tolerance = 0.1d0 * dry_tolerance(m)

                h(1) = q(layer_index + 1, iindex, jindex) / rho(m)
                h(2) = q(layer_index + 1, iindex + 1, jindex) / rho(m)
                h(3) = q(layer_index + 1, iindex, jindex + 1) / rho(m)
                h(4) = q(layer_index + 1, iindex + 1, jindex + 1) / rho(m)
            

                if ((h(1) < mod_dry_tolerance) .or.  &
                    (h(2) < mod_dry_tolerance) .or.  &
                    (h(3) < mod_dry_tolerance) .or.  &
                    (h(4) < mod_dry_tolerance)) then

                    ! One of the cells is dry, so just use value from grid cell
                    ! that contains gauge rather than interpolating
                    
                    dry_state = .true.

                    icell = int(1.d0 + (gauges(i)%x - xlow) / hx)
                    jcell = int(1.d0 + (gauges(i)%y - ylow) / hy)

                    ! Note here that we are directly assuming the number of
                    ! layer variables, handle other q variables below outside of
                    ! the layer loop
                    do n = layer_index + 1, layer_index + 3
                        if (gauges(i)%q_out_vars(n)) then
                            var_index = var_index + 1
                            var(var_index) = q(n, icell, jcell) / rho(m)
                        end if
                    end do

                    h_interp(m) = q(layer_index + 1, icell, jcell)
                else
                    ! Linear interpolation between four cells
                    do n = layer_index + 1, layer_index + 3
                        if (gauges(i)%q_out_vars(n)) then
                            var_index = var_index + 1
                            var(var_index) = &
                                    (1.d0 - xoff) * (1.d0 - yoff) * q(n,     iindex,     jindex) / rho(m)  &
                                  + (       xoff) * (1.d0 - yoff) * q(n, 1 + iindex,     jindex) / rho(m)  &
                                  + (1.d0 - xoff) * (       yoff) * q(n,     iindex, 1 + jindex) / rho(m)  &
                                  + (       xoff) * (       yoff) * q(n, 1 + iindex, 1 + jindex) / rho(m)
                        end if
                    enddo
                    
                    ! Explicitly do depth in case the depth is not computed above
                    ! Here we depart from the single-layer case as we would
                    ! otherwise need to compute exactly where the h might have 
                    ! been stored
                    h_interp(m) = &
                                (1.d0 - xoff) * (1.d0 - yoff) * q(layer_index + 1,     iindex,     jindex) / rho(m)  &
                              + (       xoff) * (1.d0 - yoff) * q(layer_index + 1, 1 + iindex,     jindex) / rho(m)  &
                              + (1.d0 - xoff) * (       yoff) * q(layer_index + 1,     iindex, 1 + jindex) / rho(m)  &
                              + (       xoff) * (       yoff) * q(layer_index + 1, 1 + iindex, 1 + jindex) / rho(m)
                endif
            end do  ! End of layer loop ========================================

            ! Handle the rest of the fields
            if (dry_state) then

                ! Compute rest of q fields
                do n = 3 * num_layers + 1, size(gauges(i)%q_out_vars, 1)
                    if (gauges(i)%q_out_vars(n)) then
                        var(var_index) = 0.0
                    end if
                end do

                ! Skip over eta spots
                eta_index = var_index
                var_index = var_index + num_layers

                ! Compute aux fields
                do n=1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) = aux(n, icell , jcell)
                    end if
                end do
                
                ! Topography
                topo = aux(1, icell, jcell)

            else

                ! Compute rest of q fields
                do n = 3 * num_layers + 1, size(gauges(i)%q_out_vars, 1)
                    if (gauges(i)%q_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) = &
                                (1.d0 - xoff) * (1.d0 - yoff) * q(n,     iindex,     jindex)  &
                              + (       xoff) * (1.d0 - yoff) * q(n, 1 + iindex,     jindex)  &
                              + (1.d0 - xoff) * (       yoff) * q(n,     iindex, 1 + jindex)  &
                              + (       xoff) * (       yoff) * q(n, 1 + iindex, 1 + jindex)
                    end if
                end do

                ! Skip eta spots
                eta_index = var_index
                var_index = var_index + num_layers

                do n = 1, size(gauges(i)%aux_out_vars, 1)
                    if (gauges(i)%aux_out_vars(n)) then
                        var_index = var_index + 1
                        var(var_index) = &
                                (1.d0 - xoff) * (1.d0 - yoff) * aux(n,     iindex,     jindex)  &
                              + (       xoff) * (1.d0 - yoff) * aux(n, 1 + iindex,     jindex)  &
                              + (1.d0 - xoff) * (       yoff) * aux(n,     iindex, 1 + jindex)  &
                              + (       xoff) * (       yoff) * aux(n, 1 + iindex, 1 + jindex)
                    end if
                enddo
                    
                topo = (1.d0 - xoff) * (1.d0 - yoff) * aux(1,     iindex,     jindex)  &
                     + (       xoff) * (1.d0 - yoff) * aux(1, 1 + iindex,     jindex)  &
                     + (1.d0 - xoff) * (       yoff) * aux(1,     iindex, 1 + jindex)  &
                     + (       xoff) * (       yoff) * aux(1, 1 + iindex, 1 + jindex)

            end if

            ! Check to make sure we grabbed all the values
            if (gauges(i)%num_out_vars /= var_index) then
                print *, gauges(i)%num_out_vars, var_index
                print *, gauges(i)%q_out_vars
                print *, gauges(i)%aux_out_vars
                stop "Somehow we did not grab all the values we wanted..."
            end if

            ! Zero out tiny values to prevent later problems reading data,
            ! as done in valout.f
            do j = 1, gauges(i)%num_out_vars
               if (abs(var(j)) < 1d-90) var(j) = 0.d0
            end do
    
            ! Extract surfaces - Note that we do this after the zeroing to
            ! preserve etas that are non-zero
            eta(num_layers) = h_interp(num_layers) + topo
            if (abs(eta(num_layers) - eta_init(num_layers)) < 1d-90) then
                eta(num_layers) = eta_init(num_layers)
            end if
            var(eta_index + num_layers) = eta(num_layers)
            do k = num_layers - 1, 1, -1
                eta(k) = h_interp(k) + eta(k + 1)
                if (abs(eta(k) - eta_init(k)) < 1d-90) eta(k) = eta_init(k)
                var(eta_index + k) = eta(k)
            end do

            ! save info for this time 
            n = gauges(i)%buffer_index
     
            gauges(i)%level(n) = level
            gauges(i)%data(1,n) = tgrid
            do j = 1, gauges(i)%num_out_vars
                gauges(i)%data(1 + j, n) = var(j)
            end do
            
            gauges(i)%buffer_index = n + 1
            if (gauges(i)%buffer_index > MAX_BUFFER) then
                call print_gauges_and_reset_nextLoc(i)
            endif

            gauges(i)%last_time = tgrid

        end do ! End of gauge loop =============================================
 
    end subroutine update_gauges
!
! -------------------------------------------------------------------------
! Write out gauge data for the gauge specified
!
    subroutine print_gauges_and_reset_nextLoc(gauge_num)

        implicit none

        ! Input
        integer, intent(in) :: gauge_num

        ! Locals
        integer :: j, k, myunit
        integer :: omp_get_thread_num, mythread
        character(len=32) :: out_format

        ! Open unit dependent on thread number
        mythread = 0
!$      mythread = omp_get_thread_num()
        myunit = OUTGAUGEUNIT + mythread

        ! ASCII output
        if (gauges(gauge_num)%file_format == 1) then
            ! Construct output format based on number of output variables and
            ! request format
            write(out_format, "(A7, i2, A6, A1)") "(i5.2,",                    &
                                        gauges(gauge_num)%num_out_vars + 1,    &
                                        gauges(gauge_num)%display_format, ")"

            open(unit=myunit, file=gauges(gauge_num)%file_name, status='old', &
                              position='append', form='formatted')
          
            !if (gauges(gauge_num)%gtype == 2) then
                ! keep track of last x,y location written to gauge file
                ! in case we are at a checkpoint time
            j = gauges(gauge_num)%buffer_index - 1
            if (j > 0) then
                gauges(gauge_num)%t_last_written = gauges(gauge_num)%data(1, j)
                gauges(gauge_num)%x_last_written = gauges(gauge_num)%data(3, j)
                gauges(gauge_num)%y_last_written = gauges(gauge_num)%data(4, j)
            endif

            ! Loop through gauge's buffer writing out all available data.  Also
            ! reset buffer_index back to beginning of buffer since we are emptying
            ! the buffer here
            do j = 1, gauges(gauge_num)%buffer_index - 1
                write(myunit, out_format) gauges(gauge_num)%level(j),    &
                    (gauges(gauge_num)%data(k, j), k=1,                  &
                                             gauges(gauge_num)%num_out_vars + 1)
            end do
            gauges(gauge_num)%buffer_index = 1                        

            ! close file
            close(myunit)
        else
            print *, "Unhandled file format ", gauges(gauge_num)%file_format
            stop
        end if

      end subroutine print_gauges_and_reset_nextLoc
  
end module gauges_module

c
c -----------------------------------------------------------------
c
      subroutine setgrd (nvar,cut,naux,dtinit,start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical  vtime
      data     vtime/.false./

c     # may as well not bother to calculate time step for error est.
c
c :::::::::::::::::::::::::::: SETGRD :::::::::::::::::::::::::::::::;
c  set up the entire tree/grid structure.  only at this time t = 0
c  can we take advantage of initialization routines.
c  remember that regridding/error estimation needs to have two
c  time steps of soln. values.
c  6/21/05: added dtinit arg. to allow for better choice of initial timestep
c   as discovered by advance/setgrd in first step.
c ::::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::::;
c
      dtinit = possk(1)
      if (mxnest .eq. 1) go to 99
c
      levnew =  2
      time   = start_time
      verbosity_regrid = method(3)
c
 10   if (levnew .gt. mxnest) go to 30
          levold = levnew - 1
          if (lstart(levold) .eq. 0) go to 30
          lbase  = levold
          lfnew  = lbase
c
c  set up level to be flagged. need a solution t=0,and if
c  using richardson  error estimation then one at dt too.
c  then richardson makes one at 2*dt.  for just flag2refine 
c  only need to set boundary conditions, done from grdfit->flagger.
c
          if (flag_richardson) then
             call advanc(levold,nvar,dtlev,vtime,naux)
             evol = evol + rvol !time stepping stats for error estimation
             rvol = 0.d0        ! reset since not 'real' time stepping stats
             kfac = 1
             do i = 1, levold-1
                kfac = kfac * kratio(i)
             end do
             dtinit = min(dtinit, dtlev*kfac)
             
c            dont count it in real integration stats
             do 20 level=1,mxnest
 20             rvoll(level) = 0.d0
          endif
c
c  flag, cluster, and make new grids. grdfit set bcs, controls flagging,
c  colating and making grids. But advanc called above since if using
c  richardson, it assumes two levels of solution already exist
c
         call grdfit(lbase,levold,nvar,naux,cut,time,start_time)
         if (newstl(levnew) .ne. 0) lfnew = levnew
c
c  init new level. after each iteration. fix the data structure
c  also reinitalize coarser grids so fine grids can be advanced
c  and interpolate correctly for their bndry vals from coarser grids.
c
         call ginit(newstl(levnew),.true., nvar, naux,start_time)
         lstart(levnew) = newstl(levnew)
         lfine = lfnew
         call ginit(lstart(levold),.false., nvar, naux,start_time)
c
c count number of grids on newly created levels (needed for openmp
c parallelization). this is also  done in regridding.
c  set up numgrids now for new level, since advanc will use it for parallel execution
c 
         mptr = lstart(levnew)
         ngrids = 0
         ncells = 0
         do while (mptr .gt. 0)
            ngrids = ngrids + 1
            ncells = ncells + (node(ndihi,mptr)-node(ndilo,mptr)+1)
            mptr = node(levelptr, mptr)
          end do
          numgrids(levnew) = ngrids
          numcells(levnew) = ncells
          avenumgrids(levnew) = avenumgrids(levnew) + ngrids
          iregridcount(levnew) = iregridcount(levnew) + 1
          if (ngrids .gt. 1) call arrangeGrids(levnew,ngrids)
          if (verbosity_regrid .ge. levnew) then
             write(*,100) ngrids,ncells,levnew
 100         format("there are ",i6," grids with ",i10,
     &               " cells at level ", i3)
          endif 
c
c     need to make gridList here before calling again to make finer grids.
c     This is because ths list if used in advanc. level 1 is called from domain
      call makeGridList(lbase)
      call makeBndryList(levnew)
c
      levnew = levnew + 1
      go to 10
 30   continue
c
c  switch location of old and new storage for soln. vals, 
c  and reset time to 0.0 (or initial time start_time)
c
c      if (mxnest .eq. 1) go to 99  shouldnt be nec. tested above.
c
      lev = 1
 40   if ((lev .eq. mxnest) .or. (lev .gt. lfine))  go to 60
        mptr = lstart(lev)
 50        itemp                = node(store1,mptr)
           node(store1,mptr)    = node(store2,mptr)
           node(store2,mptr)    = itemp
           rnode(timemult,mptr) = start_time
           mptr                 = node(levelptr,mptr)
           if (mptr .ne. 0) go to 50
       lev = lev + 1
       go to 40
 60   continue
c
c initial updating so can do conservation check. can do before
c bndry flux arrays set, since dont need them for this
c
      do 65 level = 1, lfine-1
         call update(lfine-level,nvar,naux)
 65   continue
c
c set up boundary flux conservation arrays
c
      do 70 level = 1, lfine-1
         call prepf(level+1,nvar,naux)
         call prepc(level,nvar)
 70   continue
c
c
c
c
 99   continue
      return
      end

c
!> Prepare new fine grids to save fluxes after each integration step
!! for future conservative fix-up on coarse grids.
!! For each grid mkid on level **level**, first allocate temporary space
!! for storing solution on a rectangle on level **level**-1, which is 
!! enlarged from grid mkid by one level **level**-1 cell on each 
!! side. 
!! Then copy solution from overlapping level **level**-1 grids to this
!! rectangle. 
!! Finally, fill node(ffluxptr, mkid) with solutions in cells that 
!! are on the rectangle and border the boundary of grid mkid. 
c  ================================================================
      subroutine saveqc(level,nvar,naux)
c  ================================================================
c
      use amr_module
      implicit double precision (a-h,o-z)
      
      logical sticksout, found
!     make fliparray largest possible grid size
      dimension fliparray(2*max1d*nghost*(nvar+naux))
c
c ::::::::::::::::::::::::: SAVEQC :::::::::::::::::::::::::::::::::
c  prepare new fine grids to save fluxes after each integration step
c  for future conservative fix-up on coarse grids.
c  save all boundary fluxes of fine grid (even if on a  phys. bndry.) -
c  but only save space for every intrat of them. 
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      levc = level - 1
      hxc  = hxposs(levc)
      hyc  = hyposs(levc)
      ng   = 0  ! no ghost cells on coarsened enlarged patch

      mkid = lstart(level)
 10   if (mkid .eq. 0) go to 99
          nx    = node(ndihi,mkid)-node(ndilo,mkid) + 1
          ny    = node(ndjhi,mkid)-node(ndjlo,mkid) + 1
          ikeep = nx/intratx(level-1)
          jkeep = ny/intraty(level-1)
          lenbc = 2*(ikeep+jkeep)
          ist   = node(ffluxptr,mkid)
          time = rnode(timemult,mkid)

c         make coarsened enlarged patch for conservative fixup
          ilo = node(ndilo,mkid)
          jlo = node(ndjlo,mkid)
          ihi = node(ndihi,mkid)
          jhi = node(ndjhi,mkid)
          iclo = ilo/intratx(level-1) - 1
          jclo = jlo/intraty(level-1) - 1
          ichi = (ihi+1)/intratx(level-1)
          jchi = (jhi+1)/intraty(level-1)
          nrow = ichi-iclo+1
          ncol = jchi-jclo+1
          xl   = rnode(cornxlo,mkid) - hxc
          yb   = rnode(cornylo,mkid) - hyc
          xr   = rnode(cornxhi,mkid) + hxc
          yt   = rnode(cornyhi,mkid) + hyc
          loctmp = igetsp(nrow*ncol*(nvar+naux))
          loctx  = loctmp + nrow*ncol*nvar
          do i = 1, nrow*ncol*naux
             alloc(loctx+i-1) = NEEDS_TO_BE_SET
          end do
          locaux = node(storeaux,mkid)

          if (iclo .lt. 0 .or. ichi .eq. iregsz(levc) .or.
     &        jclo .lt. 0 .or. jchi .eq. jregsz(levc)) then
            sticksout = .true.
          else
            sticksout = .false.
          endif

          if (sticksout .and. (xperdom.or.yperdom.or.spheredom)) then
             !iperim = nrow+ncol 
             !locflip = igetsp(iperim*nghost*(nvar+naux))
             call preicall(alloc(loctmp),alloc(loctx),nrow,ncol,nvar,
     .                     naux,iclo,ichi,jclo,jchi,level-1,
     .                     fliparray)
!     .                     alloc(locflip))
!             call reclam(locflip,iperim*nghost*(nvar+naux))
          else 
             call icall(alloc(loctmp),alloc(loctx),nrow,ncol,nvar,naux,
     .                   iclo,ichi,jclo,jchi,level-1,1,1)
          endif
!         in case any part sticks out of domain still need to set remaining aux
!         cells
          if (naux .gt. 0 .and. sticksout) then  
             call setaux(ng,nrow,ncol,xl,yb,hxc,hyc,naux,alloc(loctx))
          endif
!--          found = .false.
!--          do i = 1, naux*nrow*ncol, naux
!--             if (alloc(loctx+i-1) .eq. NEEDS_TO_BE_SET) then
!--                 found = .true.
!--             endif
!--          end do
!--          if (found)  write(*,*) "still have unset aux vals in qad"
          call bc2amr(alloc(loctmp),alloc(loctx),nrow,ncol,nvar,naux,
     .                hxc,hyc,level,time,
     .                xl,xr,yb,yt)
          call cstore(alloc(loctmp),nrow,ncol,nvar,
     .                alloc(ist+nvar*lenbc),lenbc,naux,alloc(loctx),
     .                alloc(ist+2*nvar*lenbc))
          call reclam(loctmp,nrow*ncol*(nvar+naux))

          mkid = node(levelptr,mkid)
          go to 10
 99    return
       end

c=========================================================================
      subroutine setgauges
c=========================================================================

      use amr_module
	  use gauges_module
      implicit double precision (a-h,o-z)
      character*25 fname
      logical foundFile


      fname  = 'gauges.data'
      inquire(file=fname,exist=foundFile)
      if (.not. foundFile) then
        write(*,*) 'You must provide a file ', fname 
        stop
      endif

      iunit = 7
      call opendatafile(iunit,fname)

      read(iunit,*) mgauges
      write(6,*) '+++ in setgauges: mgauges = ',mgauges
      if (mgauges.gt.maxgauges) then
            write(*,*) 'ERROR in setgauges'
            write(*,*) 'mgauges = ',mgauges,'   maxgauges = ',maxgauges
            write(*,*) 'increase maxgauges in amr_module.f90'
            stop
            endif

      do i=1,mgauges
          read(iunit,*) igauge(i),xgauge(i),ygauge(i),
     &                  t1gauge(i),t2gauge(i)
          mbestsrc(i) = 0   ! initialize for starters
          enddo
      close(iunit)

c     # open file for output of gauge data
c     # all data is output in one binary file with format
c     #   gauge number, level, time, depth
c     # by dumpgauge.

      open(unit=OUTGAUGEUNIT,file='fort.gauge',status='unknown',
     .           form='formatted')

      return
      end

! ============================================================================
!  Sets aux arrays
!    aux(:,1) = Bathymetry
!    aux(:,2) = Wind field
!    aux(:,3) = Initial steady state, top layer depth, h_1 = eta_1 - eta_2
!    aux(:,4) = Initial steady state, bottom layer depth, h_2 = eta_2 - b
! ============================================================================
subroutine setaux(maxmx,mbc,mx,xlower,dx,maux,aux)
    
    use parameters_module
    
    implicit none
    
    ! Input parameters
    integer, intent(in) :: maxmx,mbc,mx,maux
    double precision, intent(in) :: xlower,dx
    
    ! Auxillary array  
    double precision, intent(inout) :: aux(1-mbc:maxmx+mbc, maux)
     
    ! Local
    integer, parameter :: out_unit = 13
    integer :: i, ios
    double precision :: x
    
    do i=1-mbc,mx+mbc
        x = xlower+(i-0.5)*dx
        ! Jump in bathymetry
        if (bathy_type == 1) then
            if (x < bathy_location) then
                aux(i,1) = bathy_left
            else
                aux(i,1) = bathy_right
            endif
        ! Simple shelf
        else if (bathy_type == 2) then
            if (x < x0) then
                aux(i,1) = basin_depth
            else if (x0 <= x .and. x < x1) then
                aux(i,1) = shelf_slope * (x-x0) + basin_depth
            else if (x1 <= x) then
                aux(i,1) = shelf_depth
            endif
        endif
        
        ! Set initial states
        if (x < init_location) then
            if (eta_left(2) > aux(i,1)) then
                aux(i,3) = eta_left(1) - eta_left(2)
                aux(i,4) = eta_left(2) - aux(i,1)
            else
                aux(i,3) = eta_left(1) - aux(i,1)
            endif
        else
            if (eta_right(2) > aux(i,1)) then
                aux(i,3) = eta_right(1) - eta_right(2)
                aux(i,4) = eta_right(2) - aux(i,1)
            else
                aux(i,3) = eta_right(1) - aux(i,1)
            endif
        endif
    enddo
    
    
    
    ! Calculate initial wind field
    call set_wind(maxmx,mbc,mx,xlower,dx,0.d0,aux(:,2))
    
    ! Write out auxillary array
    print *,"Outputting bathymetry to 'fort.aux' file."
    open(unit=out_unit, file='fort.aux', iostat=ios, action="write")
    if ( ios /= 0 ) stop "Error opening file name"
    
    do i=1,mx
        write(unit=out_unit, fmt="(d16.8)") aux(i,1)
    enddo
    
    close(out_unit)
    
end subroutine setaux

c     =====================================================
      subroutine qinit(meqn,mbc,mx,my,xlower,ylower,
     &     dx,dy,q,maux,aux)
c     =====================================================
c
c
      implicit double precision (a-h,o-z)
      dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
      dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
      common /cqinit/ A1,beta1,x1,y1, A2,beta2,x2,y2

      do i=1,mx
        xc = xlower + (i-0.5d0)*dx
        do j=1,my
            yc = ylower + (j-0.5d0)*dy
            call mapc2p(xc,yc,xp,yp)
            q(1,i,j) = A1*exp(-beta1*((xp - x1)**2 + (yp - y1)**2)) 
     &                  +A2*exp(-beta2*((xp - x2)**2 + (yp - y2)**2))
        enddo
      enddo

      return
      end

! ==================================================================
subroutine step3(maxm,num_eqn,num_waves,num_ghost,mx,my, &
                 mz,qold,qnew,aux,dx,dy,dz,dt,method,mthlim,cfl, &
                 qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d, &
                 aux1,aux2,aux3,num_aux,work,mwork,use_fwave,rpn3,rpt3,rptt3)
! ==================================================================

! Take one time step, updating q.
! On entry, qold and qnew should be identical and give the
!    initial data for this step
! On exit, qnew returns values at the end of the time step.
!    qold is unchanged.

! qadd is used to return increments to q from flux3.
! fadd, gadd and hadd are used to return flux increments from flux3.
! See the flux3 documentation for more information.


    implicit real*8(a-h,o-z)
    external rpn3,rpt3,rptt3
    dimension qold(num_eqn, 1-num_ghost:mx+num_ghost, &
                   1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension qnew(num_eqn, 1-num_ghost:mx+num_ghost, &
                   1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension  q1d(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension qadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension fadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension aux(num_aux, 1-num_ghost:mx+num_ghost, &
                  1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension dtdx1d(1-num_ghost:maxm+num_ghost)
    dimension dtdy1d(1-num_ghost:maxm+num_ghost)
    dimension dtdz1d(1-num_ghost:maxm+num_ghost)
    dimension method(7),mthlim(num_waves)
    dimension work(mwork)
    logical ::          use_fwave

!f2py intent(out) cfl
!f2py intent(in,out) qnew
!f2py optional q1d, qadd, fadd, gadd, hadd, dtdx1d, dtdy1d, dtdz1d

! Dummy interfaces just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn3(x)
!f2py x=rpt3(x)
!f2py x=rptt3(x)

    common /comxyzt/ dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom



    ! partition work array into pieces needed for local storage in
    ! flux3 routine.  Find starting index of each piece:

    i0wave     = 1
    i0s        = i0wave     + (maxm+2*num_ghost)*num_eqn*num_waves
    i0amdq     = i0s        + (maxm+2*num_ghost)*num_waves
    i0apdq     = i0amdq     + (maxm+2*num_ghost)*num_eqn
    i0cqxx     = i0apdq     + (maxm+2*num_ghost)*num_eqn
    i0bmamdq   = i0cqxx     + (maxm+2*num_ghost)*num_eqn
    i0bmapdq   = i0bmamdq   + (maxm+2*num_ghost)*num_eqn
    i0bpamdq   = i0bmapdq   + (maxm+2*num_ghost)*num_eqn
    i0bpapdq   = i0bpamdq   + (maxm+2*num_ghost)*num_eqn
    i0cmamdq   = i0bpapdq   + (maxm+2*num_ghost)*num_eqn
    i0cmapdq   = i0cmamdq   + (maxm+2*num_ghost)*num_eqn
    i0cpamdq   = i0cmapdq   + (maxm+2*num_ghost)*num_eqn
    i0cpapdq   = i0cpamdq   + (maxm+2*num_ghost)*num_eqn
    i0cmamdq2  = i0cpapdq   + (maxm+2*num_ghost)*num_eqn
    i0cmapdq2  = i0cmamdq2  + (maxm+2*num_ghost)*num_eqn
    i0cpamdq2  = i0cmapdq2  + (maxm+2*num_ghost)*num_eqn
    i0cpapdq2  = i0cpamdq2  + (maxm+2*num_ghost)*num_eqn
    i0bmcqxxp  = i0cpapdq2  + (maxm+2*num_ghost)*num_eqn
    i0bmcqxxm  = i0bmcqxxp  + (maxm+2*num_ghost)*num_eqn
    i0bpcqxxp  = i0bmcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0bpcqxxm  = i0bpcqxxp   + (maxm+2*num_ghost)*num_eqn
    i0cmcqxxp  = i0bpcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0cmcqxxm  = i0cmcqxxp   + (maxm+2*num_ghost)*num_eqn
    i0cpcqxxp  = i0cmcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0cpcqxxm  = i0cpcqxxp   + (maxm+2*num_ghost)*num_eqn
    i0bmcmamdq = i0cpcqxxm   + (maxm+2*num_ghost)*num_eqn
    i0bmcmapdq = i0bmcmamdq + (maxm+2*num_ghost)*num_eqn
    i0bpcmamdq = i0bmcmapdq + (maxm+2*num_ghost)*num_eqn
    i0bpcmapdq = i0bpcmamdq + (maxm+2*num_ghost)*num_eqn
    i0bmcpamdq = i0bpcmapdq + (maxm+2*num_ghost)*num_eqn
    i0bmcpapdq = i0bmcpamdq + (maxm+2*num_ghost)*num_eqn
    i0bpcpamdq = i0bmcpapdq + (maxm+2*num_ghost)*num_eqn
    i0bpcpapdq = i0bpcpamdq + (maxm+2*num_ghost)*num_eqn
    iused      = i0bpcpapdq + (maxm+2*num_ghost)*num_eqn - 1

    if (iused > mwork) then
        ! This shouldn't happen due to checks in claw3
        write(6,*) '*** not enough work space in step3'
        write(6,*) '*** iused = ', iused, '   mwork =',mwork
        stop
    endif



    index_capa = method(6)
    ! num_aux = method(7)
    cfl = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy
    dtdz = dt/dz

    if (index_capa == 0) then
        ! no capa array:
        do i=1-num_ghost,maxm+num_ghost
            dtdx1d(i) = dtdx
            dtdy1d(i) = dtdy
            dtdz1d(i) = dtdz
        end do
    endif


!     # perform x-sweeps
!     ==================


    do k = 0,mz+1
        do j = 0,my+1

            forall (m = 1:num_eqn, i = 1-num_ghost:mx+num_ghost)
                ! copy data along a slice into 1d array:
                q1d(m,i) = qold(m,i,j,k)
            end forall
        
            if (index_capa > 0)  then
                do i = 1-num_ghost, mx+num_ghost
                    dtdx1d(i) = dtdx / aux(index_capa,i,j,k)
                end do
            endif
        
            if (num_aux > 0)  then
                ! This odd construct may help improve cache locality.
                ! (The F95 standard says each statement in the FORALL
                ! must be executed for all indices before the next
                ! statement is started, so this is different semantically
                ! from putting all three indices in the same FORALL.)
                forall (ka = -1:1)
                    forall (ma = 1:num_aux, i = 1-num_ghost:mx+num_ghost)
                        aux1(ma, i, 2+ka) = aux(ma, i, j-1, k+ka)
                        aux2(ma, i, 2+ka) = aux(ma, i,   j, k+ka)
                        aux3(ma, i, 2+ka) = aux(ma, i, j+1, k+ka)
                    end forall
                end forall
            endif
        
            ! Store the value of j and k along this slice in the common block
            ! comxyt in case it is needed in the Riemann solver (for
            ! variable coefficient problems)
        
            jcom = j
            kcom = k
        
            ! compute modifications fadd, gadd and hadd to fluxes along
            ! this slice:
        
            call flux3(1,maxm,num_eqn,num_waves,num_ghost,mx, &
                       q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3,num_aux, &
                       method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                       work(i0wave),work(i0s),work(i0amdq), &
                       work(i0apdq),work(i0cqxx), &
                       work(i0bmamdq),work(i0bmapdq), &
                       work(i0bpamdq),work(i0bpapdq), &
                       work(i0cmamdq),work(i0cmapdq), &
                       work(i0cpamdq),work(i0cpapdq), &
                       work(i0cmamdq2),work(i0cmapdq2), &
                       work(i0cpamdq2),work(i0cpapdq2), &
                       work(i0bmcqxxp),work(i0bpcqxxp), &
                       work(i0bmcqxxm),work(i0bpcqxxm), &
                       work(i0cmcqxxp),work(i0cpcqxxp), &
                       work(i0cmcqxxm),work(i0cpcqxxm), &
                       work(i0bmcmamdq),work(i0bmcmapdq), &
                       work(i0bpcmamdq),work(i0bpcmapdq), &
                       work(i0bmcpamdq),work(i0bmcpapdq), &
                       work(i0bpcpamdq),work(i0bpcpapdq), &
                       use_fwave,rpn3,rpt3,rptt3)
        
            cfl = dmax1(cfl,cfl1d)
        
            ! update qnew by flux differencing.
            ! (rather than maintaining arrays f, g and h for the total fluxes,
            ! the modifications are used immediately to update qnew
            ! in order to save storage.)
        
            if(index_capa == 0)then
            
                forall (m = 1:num_eqn, i = 1:mx)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i) &
                        - dtdx * (fadd(m,i+1) - fadd(m,i)) &
                        - dtdy * (gadd(m,2,0,i) - gadd(m,1,0,i)) &
                        - dtdz * (hadd(m,2,0,i) - hadd(m,1,0,i))
                    qnew(m,i,j-1,k)   = qnew(m,i,j-1,k) &
                        - dtdy * gadd(m,1,0,i) &
                        - dtdz * ( hadd(m,2,-1,i) &
                        -   hadd(m,1,-1,i) )
                    qnew(m,i,j-1,k-1) = qnew(m,i,j-1,k-1) &
                        - dtdy * gadd(m,1,-1,i) &
                        - dtdz * hadd(m,1,-1,i)
                    qnew(m,i,j,k-1)   = qnew(m,i,j,k-1) &
                        - dtdy * ( gadd(m,2,-1,i) &
                        -   gadd(m,1,-1,i) ) &
                        - dtdz * hadd(m,1,0,i)
                    qnew(m,i,j+1,k-1) = qnew(m,i,j+1,k-1) &
                        + dtdy * gadd(m,2,-1,i) &
                        - dtdz * hadd(m,1,1,i)
                    qnew(m,i,j+1,k)   = qnew(m,i,j+1,k) &
                        + dtdy * gadd(m,2,0,i) &
                        - dtdz * ( hadd(m,2,1,i) &
                        -   hadd(m,1,1,i) )
                    qnew(m,i,j+1,k+1) = qnew(m,i,j+1,k+1) &
                        + dtdy * gadd(m,2,1,i) &
                        + dtdz * hadd(m,2,1,i)
                    qnew(m,i,j,k+1)   = qnew(m,i,j,k+1) &
                        - dtdy * ( gadd(m,2,1,i) &
                        -   gadd(m,1,1,i) ) &
                        + dtdz * hadd(m,2,0,i)
                    qnew(m,i,j-1,k+1) = qnew(m,i,j-1,k+1) &
                        - dtdy * gadd(m,1,1,i) &
                        + dtdz * hadd(m,2,-1,i)
                end forall
            
            else
                ! with capa array
                forall (m = 1:num_eqn, i = 1:mx)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i) &
                        - (dtdx * (fadd(m,i+1) - fadd(m,i)) &
                        +  dtdy * (gadd(m,2,0,i) - gadd(m,1,0,i)) &
                        +  dtdz * (hadd(m,2,0,i) - hadd(m,1,0,i))) &
                        / aux(index_capa,i,j,k)

                    qnew(m,i,j-1,k)   = qnew(m,i,j-1,k) &
                        - (dtdy * gadd(m,1,0,i) &
                        +  dtdz * ( hadd(m,2,-1,i) &
                        -   hadd(m,1,-1,i) )) &
                        / aux(index_capa,i,j-1,k)
                    qnew(m,i,j-1,k-1) = qnew(m,i,j-1,k-1) &
                        - (dtdy * gadd(m,1,-1,i) &
                        +  dtdz * hadd(m,1,-1,i)) &
                        / aux(index_capa,i,j-1,k-1)
                    qnew(m,i,j,k-1)   = qnew(m,i,j,k-1) &
                        - (dtdy * ( gadd(m,2,-1,i) &
                        -   gadd(m,1,-1,i) ) &
                        +  dtdz * hadd(m,1,0,i)) &
                        / aux(index_capa,i,j,k-1)
                    qnew(m,i,j+1,k-1) = qnew(m,i,j+1,k-1) &
                        + (dtdy * gadd(m,2,-1,i) &
                        -  dtdz * hadd(m,1,1,i)) &
                        / aux(index_capa,i,j+1,k-1)
                    qnew(m,i,j+1,k)   = qnew(m,i,j+1,k) &
                        + (dtdy * gadd(m,2,0,i) &
                        - dtdz * ( hadd(m,2,1,i) &
                        -   hadd(m,1,1,i) )) &
                        / aux(index_capa,i,j+1,k)
                    qnew(m,i,j+1,k+1) = qnew(m,i,j+1,k+1) &
                        + (dtdy * gadd(m,2,1,i) &
                        +  dtdz * hadd(m,2,1,i)) &
                        / aux(index_capa,i,j+1,k+1)
                    qnew(m,i,j,k+1)   = qnew(m,i,j,k+1) &
                        - (dtdy * ( gadd(m,2,1,i) &
                        -   gadd(m,1,1,i) ) &
                        -  dtdz * hadd(m,2,0,i)) &
                        / aux(index_capa,i,j,k+1)
                    qnew(m,i,j-1,k+1) = qnew(m,i,j-1,k+1) &
                        - (dtdy * gadd(m,1,1,i) &
                        -  dtdz * hadd(m,2,-1,i)) &
                        / aux(index_capa,i,j-1,k+1)
                end forall
            endif
        end do
    end do


    ! perform y sweeps
    ! ==================


    do k = 0, mz+1
        do i = 0, mx+1
        
            forall (m = 1:num_eqn, j = 1-num_ghost:my+num_ghost)
                ! copy data along a slice into 1d array:
                q1d(m,j) = qold(m,i,j,k)
            end forall
        
            if (index_capa > 0)  then
                do j = 1-num_ghost, my+num_ghost
                    dtdy1d(j) = dtdy / aux(index_capa,i,j,k)
                end do
            endif
        
            if (num_aux > 0)  then
                ! aux1, aux2, aux3 probably fit in cache, so optimize
                ! access to aux
                forall (ma=1:num_aux,ia= -1:1, j = 1-num_ghost:my+num_ghost)
                    aux1(ma, j, 2+ia) = aux(ma, i+ia, j, k-1)
                    aux2(ma, j, 2+ia) = aux(ma, i+ia, j,   k)
                    aux3(ma, j, 2+ia) = aux(ma, i+ia, j, k+1)
                end forall
            endif
        
            ! Store the value of i and k along this slice in the common block
            ! comxyzt in case it is needed in the Riemann solver (for
            ! variable coefficient problems)
        
            icom = i
            kcom = k
        
            ! compute modifications fadd, gadd and hadd to fluxes along this
            ! slice:
        
            call flux3(2,maxm,num_eqn,num_waves,num_ghost,my, &
                       q1d,dtdy1d,dtdz,dtdx,aux1,aux2,aux3,num_aux, &
                       method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                       work(i0wave),work(i0s),work(i0amdq), &
                       work(i0apdq),work(i0cqxx), &
                       work(i0bmamdq),work(i0bmapdq), &
                       work(i0bpamdq),work(i0bpapdq), &
                       work(i0cmamdq),work(i0cmapdq), &
                       work(i0cpamdq),work(i0cpapdq), &
                       work(i0cmamdq2),work(i0cmapdq2), &
                       work(i0cpamdq2),work(i0cpapdq2), &
                       work(i0bmcqxxp),work(i0bpcqxxp), &
                       work(i0bmcqxxm),work(i0bpcqxxm), &
                       work(i0cmcqxxp),work(i0cpcqxxp), &
                       work(i0cmcqxxm),work(i0cpcqxxm), &
                       work(i0bmcmamdq),work(i0bmcmapdq), &
                       work(i0bpcmamdq),work(i0bpcmapdq), &
                       work(i0bmcpamdq),work(i0bmcpapdq), &
                       work(i0bpcpamdq),work(i0bpcpapdq), &
                       use_fwave,rpn3,rpt3,rptt3)
        
            cfl = dmax1(cfl,cfl1d)
        
            ! update qnew by flux differencing.
            ! Note that the roles of the flux updates are changed.
            ! fadd - modifies the g-fluxes
            ! gadd - modifies the h-fluxes
            ! hadd - modifies the f-fluxes
        
            if( index_capa == 0)then
                ! no capa array.  Standard flux differencing:
                forall (m = 1:num_eqn, j = 1:my)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j) &
                        - dtdy * (fadd(m,j+1) - fadd(m,j)) &
                        - dtdz * (gadd(m,2,0,j) - gadd(m,1,0,j)) &
                        - dtdx * (hadd(m,2,0,j) - hadd(m,1,0,j))
                    qnew(m,i,j,k+1)   = qnew(m,i,j,k+1) &
                        + dtdz * gadd(m,2,0,j) &
                        - dtdx * ( hadd(m,2,1,j) &
                        -   hadd(m,1,1,j) )
                    qnew(m,i+1,j,k+1) = qnew(m,i+1,j,k+1) &
                        + dtdz * gadd(m,2,1,j) &
                        +  dtdx * hadd(m,2,1,j)
                    qnew(m,i+1,j,k)   = qnew(m,i+1,j,k) &
                        - dtdz * ( gadd(m,2,1,j) &
                        -   gadd(m,1,1,j) ) &
                        + dtdx * hadd(m,2,0,j)
                    qnew(m,i+1,j,k-1) = qnew(m,i+1,j,k-1) &
                        - dtdz * gadd(m,1,1,j) &
                        + dtdx * hadd(m,2,-1,j)
                    qnew(m,i,j,k-1)   = qnew(m,i,j,k-1) &
                        - dtdz * gadd(m,1,0,j) &
                        - dtdx * ( hadd(m,2,-1,j) &
                        -   hadd(m,1,-1,j) )
                    qnew(m,i-1,j,k-1) = qnew(m,i-1,j,k-1) &
                        - dtdz * gadd(m,1,-1,j) &
                        - dtdx * hadd(m,1,-1,j)
                    qnew(m,i-1,j,k)   = qnew(m,i-1,j,k) &
                        - dtdz * ( gadd(m,2,-1,j) &
                        -   gadd(m,1,-1,j) ) &
                        - dtdx * hadd(m,1,0,j)
                    qnew(m,i-1,j,k+1) = qnew(m,i-1,j,k+1) &
                        + dtdz * gadd(m,2,-1,j) &
                        -  dtdx*hadd(m,1,1,j)
                end forall
            else
            
                ! with capa array.
            
                forall (m = 1:num_eqn, j = 1:my)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j) &
                        - (dtdy * (fadd(m,j+1) - fadd(m,j)) &
                        +  dtdz * (gadd(m,2,0,j) - gadd(m,1,0,j)) &
                        +  dtdx * (hadd(m,2,0,j) - hadd(m,1,0,j))) &
                        / aux(index_capa,i,j,k)
                    qnew(m,i,j,k+1)   = qnew(m,i,j,k+1) &
                        + (dtdz * gadd(m,2,0,j) &
                        -  dtdx * ( hadd(m,2,1,j) &
                        -   hadd(m,1,1,j) )) &
                        / aux(index_capa,i,j,k+1)
                    qnew(m,i+1,j,k+1) = qnew(m,i+1,j,k+1) &
                        + (dtdz * gadd(m,2,1,j) &
                        +  dtdx * hadd(m,2,1,j)) &
                        / aux(index_capa,i+1,j,k+1)
                    qnew(m,i+1,j,k)   = qnew(m,i+1,j,k) &
                        - (dtdz * ( gadd(m,2,1,j) &
                        -   gadd(m,1,1,j) ) &
                        -  dtdx * hadd(m,2,0,j) ) &
                        / aux(index_capa,i+1,j,k)
                    qnew(m,i+1,j,k-1) = qnew(m,i+1,j,k-1) &
                        - (dtdz * gadd(m,1,1,j) &
                        -  dtdx * hadd(m,2,-1,j)) &
                        / aux(index_capa,i+1,j,k-1)
                    qnew(m,i,j,k-1)   = qnew(m,i,j,k-1) &
                        - (dtdz * gadd(m,1,0,j) &
                        +  dtdx * ( hadd(m,2,-1,j) &
                        -   hadd(m,1,-1,j) )) &
                        / aux(index_capa,i,j,k-1)
                    qnew(m,i-1,j,k-1) = qnew(m,i-1,j,k-1) &
                        - (dtdz * gadd(m,1,-1,j) &
                        +  dtdx * hadd(m,1,-1,j)) &
                        / aux(index_capa,i-1,j,k-1)
                    qnew(m,i-1,j,k)   = qnew(m,i-1,j,k) &
                        - (dtdz * ( gadd(m,2,-1,j) &
                        -   gadd(m,1,-1,j) ) &
                        +  dtdx * hadd(m,1,0,j)) &
                        / aux(index_capa,i-1,j,k)
                    qnew(m,i-1,j,k+1) = qnew(m,i-1,j,k+1) &
                        + (dtdz * gadd(m,2,-1,j) &
                        -  dtdx*hadd(m,1,1,j)) &
                        / aux(index_capa,i-1,j,k+1)
                end forall
            endif
        end do
    end do



    ! perform z sweeps
    ! ==================


    do j = 0, my+1
        do i = 0, mx+1
        
            forall (m = 1:num_eqn, k = 1-num_ghost:mz+num_ghost)
                ! copy data along a slice into 1d array:
                q1d(m,k) = qold(m,i,j,k)
            end forall
        
            if (index_capa > 0)  then
                do k = 1-num_ghost, mz+num_ghost
                    dtdz1d(k) = dtdz / aux(index_capa,i,j,k)
                end do
            endif
        
            if (num_aux > 0)  then
                ! See the comment on the X sweeps.  This is semantically
                ! slightly different than putting all the indices in the
                ! same forall, and hopefully better for optimizing access
                ! to aux.
                forall (ja = -1:1, k = 1-num_ghost:mz+num_ghost)
                    forall (ma = 1:num_aux)
                        aux1(ma, k, 2+ja) = aux(ma, i-1, j+ja, k)
                        aux2(ma, k, 2+ja) = aux(ma,   i, j+ja, k)
                        aux3(ma, k, 2+ja) = aux(ma, i+1, j+ja, k)
                    end forall
                end forall
            endif
        
            ! Store the value of i and j along this slice in the common block
            ! comxyzt in case it is needed in the Riemann solver (for
            ! variable coefficient problems)
        
            icom = i
            jcom = j
        
            ! compute modifications fadd, gadd and hadd to fluxes along this
            ! slice:
        
            call flux3(3,maxm,num_eqn,num_waves,num_ghost,mz, &
                       q1d,dtdz1d,dtdx,dtdy,aux1,aux2,aux3,num_aux, &
                       method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                       work(i0wave),work(i0s),work(i0amdq), &
                       work(i0apdq),work(i0cqxx), &
                       work(i0bmamdq),work(i0bmapdq), &
                       work(i0bpamdq),work(i0bpapdq), &
                       work(i0cmamdq),work(i0cmapdq), &
                       work(i0cpamdq),work(i0cpapdq), &
                       work(i0cmamdq2),work(i0cmapdq2), &
                       work(i0cpamdq2),work(i0cpapdq2), &
                       work(i0bmcqxxp),work(i0bpcqxxp), &
                       work(i0bmcqxxm),work(i0bpcqxxm), &
                       work(i0cmcqxxp),work(i0cpcqxxp), &
                       work(i0cmcqxxm),work(i0cpcqxxm), &
                       work(i0bmcmamdq),work(i0bmcmapdq), &
                       work(i0bpcmamdq),work(i0bpcmapdq), &
                       work(i0bmcpamdq),work(i0bmcpapdq), &
                       work(i0bpcpamdq),work(i0bpcpapdq), &
                       use_fwave,rpn3,rpt3,rptt3)
        
            cfl = dmax1(cfl,cfl1d)
        
            ! update qnew by flux differencing.
            ! Note that the roles of the flux updates are changed.
            ! fadd - modifies the h-fluxes
            ! gadd - modifies the f-fluxes
            ! hadd - modifies the g-fluxes
        
            if(index_capa == 0)then
            
                ! no capa array. Standard flux differencing:
            
                forall (m = 1:num_eqn, k = 1:mz)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k) &
                        - dtdz * (fadd(m,k+1) - fadd(m,k)) &
                        - dtdx * (gadd(m,2,0,k) - gadd(m,1,0,k)) &
                        - dtdy * (hadd(m,2,0,k) - hadd(m,1,0,k))
                    qnew(m,i,j+1,k)   = qnew(m,i,j+1,k) &
                        - dtdx * ( gadd(m,2,1,k) &
                        -   gadd(m,1,1,k) ) &
                        + dtdy * hadd(m,2,0,k)
                    qnew(m,i+1,j+1,k) = qnew(m,i+1,j+1,k) &
                        + dtdx * gadd(m,2,1,k) &
                        + dtdy * hadd(m,2,1,k)
                    qnew(m,i+1,j,k)   = qnew(m,i+1,j,k) &
                        + dtdx * gadd(m,2,0,k) &
                        - dtdy * ( hadd(m,2,1,k) &
                        -   hadd(m,1,1,k) )
                    qnew(m,i+1,j-1,k) = qnew(m,i+1,j-1,k) &
                        + dtdx * gadd(m,2,-1,k) &
                        - dtdy * hadd(m,1,1,k)
                    qnew(m,i,j-1,k)   = qnew(m,i,j-1,k) &
                        - dtdx * ( gadd(m,2,-1,k) &
                        -   gadd(m,1,-1,k) ) &
                        - dtdy * hadd(m,1,0,k)
                    qnew(m,i-1,j-1,k) = qnew(m,i-1,j-1,k) &
                        - dtdx * gadd(m,1,-1,k) &
                        - dtdy * hadd(m,1,-1,k)
                    qnew(m,i-1,j,k)   = qnew(m,i-1,j,k) &
                        - dtdx * gadd(m,1,0,k) &
                        - dtdy * ( hadd(m,2,-1,k) &
                        -   hadd(m,1,-1,k) )
                    qnew(m,i-1,j+1,k) = qnew(m,i-1,j+1,k) &
                        - dtdx * gadd(m,1,1,k) &
                        + dtdy * hadd(m,2,-1,k)
                end forall
            else
            
            ! with capa array
            
                forall (m = 1:num_eqn, k = 1:mz)
                    qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k) &
                        - (dtdz * (fadd(m,k+1) - fadd(m,k)) &
                        +  dtdx * (gadd(m,2,0,k) - gadd(m,1,0,k)) &
                        +  dtdy * (hadd(m,2,0,k) - hadd(m,1,0,k))) &
                        / aux(index_capa,i,j,k)
                    qnew(m,i,j+1,k) = qnew(m,i,j+1,k) &
                        - (dtdx * ( gadd(m,2,1,k) &
                        -   gadd(m,1,1,k) ) &
                        -  dtdy * hadd(m,2,0,k)) &
                        / aux(index_capa,i,j+1,k)
                    qnew(m,i+1,j+1,k) = qnew(m,i+1,j+1,k) &
                        + (dtdx * gadd(m,2,1,k) &
                        +  dtdy * hadd(m,2,1,k)) &
                        / aux(index_capa,i+1,j+1,k)
                    qnew(m,i+1,j,k)   = qnew(m,i+1,j,k) &
                        + (dtdx * gadd(m,2,0,k) &
                        - dtdy * ( hadd(m,2,1,k) &
                        -   hadd(m,1,1,k) )) &
                        / aux(index_capa,i+1,j,k)
                    qnew(m,i+1,j-1,k) = qnew(m,i+1,j-1,k) &
                        + (dtdx * gadd(m,2,-1,k) &
                        -  dtdy * hadd(m,1,1,k)) &
                        / aux(index_capa,i+1,j-1,k)
                    qnew(m,i,j-1,k)   = qnew(m,i,j-1,k) &
                        - (dtdx * ( gadd(m,2,-1,k) &
                        -   gadd(m,1,-1,k) ) &
                        +  dtdy * hadd(m,1,0,k)) &
                        / aux(index_capa,i,j-1,k)
                    qnew(m,i-1,j-1,k) = qnew(m,i-1,j-1,k) &
                        - (dtdx * gadd(m,1,-1,k) &
                        +  dtdy * hadd(m,1,-1,k)) &
                        / aux(index_capa,i-1,j-1,k)
                    qnew(m,i-1,j,k)   = qnew(m,i-1,j,k) &
                        - (dtdx * gadd(m,1,0,k) &
                        + dtdy * ( hadd(m,2,-1,k) &
                        -   hadd(m,1,-1,k) )) &
                        / aux(index_capa,i-1,j,k)
                    qnew(m,i-1,j+1,k) = qnew(m,i-1,j+1,k) &
                        - (dtdx * gadd(m,1,1,k) &
                        -  dtdy * hadd(m,2,-1,k)) &
                        / aux(index_capa,i-1,j+1,k)
                end forall
            endif
        end do
    end do


    return
    end subroutine step3

c
c ----------------------------------------------------------
c
      subroutine copysol(valbig,val,nvar,mitot,mjtot,nghost,
     1                   midub,mjdub,ngbig)
c
      implicit double precision (a-h,o-z)

      dimension  valbig(nvar,midub,mjdub), val(nvar,mitot,mjtot)
c
c copy solution into grid with different number ghsot cells
c
       do j = nghost+1, mjtot-nghost
       do i = nghost+1, mitot-nghost
       do ivar = 1, nvar
          valbig(ivar,i-nghost+ngbig,j-nghost+ngbig) = val(ivar,i,j)
       end do
       end do
       end do
c
       return
       end

subroutine fgmax_values(mx,my,meqn,mbc,maux,q,aux,dx,dy, &
                   xlower,ylower,i1,i2,j1,j2,values)

    ! Given a grid q (and aux if needed), set the elements of 
    !   values(mv,i,j)  for mv=1:FG_NUM_VAL
    ! to the desired values that will be output and/or monitored on
    ! the fixed grid(s).
    !
    ! Only the elements with indices in [i1,i2,j1,j2] need be set.

    ! This library routine expects FG_NUM_VAL to be 1, 2, or 5 and sets:
    !   values(1,i,j) = h              (if FG_NUM_VAL >= 1)
    !   values(2,i,j) = speed          (if FG_NUM_VAL >= 2)
    !   values(1,i,j) = momentum       (if FG_NUM_VAL == 5)
    !   values(1,i,j) = momentum flux  (if FG_NUM_VAL == 5)
    !   values(1,i,j) = -depth         (if FG_NUM_VAL == 5)
    ! The max of -depth can be used to determin the minimum depth of water
    ! at a point over the computation, useful in harbors where ships may be
    ! grounded if the depth goes too low.


    use fgmax_module
    use geoclaw_module, only: sea_level, dry_tolerance

    implicit none
    integer, intent(in) :: mx,my,meqn,mbc,maux
    real(kind=8), intent(in) :: q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: dx,dy,xlower,ylower
    integer, intent(in) :: i1,i2,j1,j2
    real(kind=8), intent(inout) :: values(FG_NUM_VAL, 1-mbc:mx+mbc, 1-mbc:my+mbc)

    real(kind=8) :: s_dry_tol
    integer :: i,j

    if ((FG_NUM_VAL.ne.1) .and. (FG_NUM_VAL.ne.2) .and. (FG_NUM_VAL.ne.5)) then
        write(6,*) '*** Error -- expecting FG_NUM_VAL = 1, 2, or 5'
        write(6,*) '***   in fgmax_values, found FG_NUM_VAL = ',FG_NUM_VAL
        stop
        endif
        
    s_dry_tol = dry_tolerance
    
    do i=i1,i2
        do j=j1,j2
            values(1,i,j) = q(1,i,j)
            if (FG_NUM_VAL > 1) then
                if (q(1,i,j) > s_dry_tol) then
                    values(2,i,j) = sqrt(q(2,i,j)**2+q(3,i,j)**2) / q(1,i,j)
                  else
                    values(2,i,j) = 0.d0
                  endif
                endif
            if (FG_NUM_VAL > 2) then
                values(3,i,j) = q(1,i,j)*values(2,i,j)       ! hs,   momentum
                values(4,i,j) = values(3,i,j)*values(2,i,j)  ! hs^2, mom flux
                values(5,i,j) = -q(1,i,j)                    ! for min h
                endif
            enddo
        enddo

end subroutine fgmax_values

c
c ---------------------------------------------------------
c
      subroutine smartbis(badpts,npts,cutoff,numptc,nclust,
     1                    lbase,intcorn,idim)
c
c  iscr now stackbased, no need for use of alloc
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension     badpts(1,npts),intcorn(nsize,maxcl)
c
c  iscr now stackbased, no need for use of alloc
      dimension     iscr(idim)
      integer       nclust, numptc(maxcl)
      parameter     (usemin=.4)
c
c :::::::::::::::::::::::::::: SMARTBIS :::::::::::::::::::::::::;
c smart bisect lines until cutoff reached for each.
c replaced old bisection routine that cut all grids in half.
c now look for good place to do the cut, based on holes or signatures.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
c     ## initially all points in 1 cluster
      nclust      = 1
      numptc(1)   = npts

      if (gprint) write(outunit,100) nclust
 100  format(' starting smart bisection with ',i5,' clusters')
c
      icl         = 1
      ist         = 1
      iend        = numptc(icl)
c
 10   call moment(intcorn(1,icl),badpts(1,ist),numptc(icl),usenew)
      if (gprint) write(outunit,101) icl,numptc(icl),usenew
 101  format('   testing cluster ',i8,' with ',i9,' pts. use ',e12.4)
c
      if (usenew .lt. cutoff) go to 20
c
c  this cluster ok - on to next
c
      if (.not. gprint) go to 15
         write(outunit,102) icl,numptc(icl),usenew
 102     format('     accepting smart bisected cluster',i4,' with ',i5,
     1          ' pts. use = ',e10.3)
 15   icl   = icl + 1
      if (icl .gt. nclust) go to 200
      ist   = iend + 1
      iend  = ist + numptc(icl) - 1
      go to 10
c
c  smart bisect rectangle (and its cluster) in best location
c
 20   if (nclust .lt. maxcl) go to 25
          write(outunit,900) maxcl
          write(*      ,900) maxcl
 900      format('  too many clusters:  > ',i5)
          stop
 25   continue
c
c smart bisection computes signatures, finds best cut and splits there
c
      call signs(badpts,npts,iscr,idim,
     &           ist,iend,ilo,ihi)
      call findcut(icl,iscr,idim,index,iside,
     &             ilo,ihi)
      if (index .eq. 0) then

c         if (usenew .gt. usemin) then
c           icl = icl + 1
c           if (icl .gt. nclust) go to 200
c           ist = iend + 1
c           iend = ist + numptc(icl) - 1
c           go to 10
c         else
c c         bisect in long direction
c           if (ihi-ilo .gt. jhi-jlo) then
c              iside = horizontal
c              index = (ilo + ihi)/2
c           else
c              iside = vertical
c              index = (jlo + jhi)/2
c           endif
c          endif

c 2/28/02 : 3d version uses this branch only;  no 'if' statement.
         icl = icl + 1
         if (icl .gt. nclust) go to 200
         ist = iend + 1
         iend = ist + numptc(icl) - 1
         go to 10
      endif
c
      fmid = (index-.5)
      idir = 1
c
      itop = ist - 1
      ibot = iend + 1
      i    = ist
 50   if (badpts(idir,i) .lt. fmid) go to 60
c
c  point in top half. let it stay, increment counter
c
        itop = itop + 1
        if (itop+1 .ge. ibot) go to 80
             i = i + 1
             go to 50
c
c  point in bottom half. switch with a bottom point that's not yet
c  checked, and increment bot. pointer
c
 60    ibot           = ibot - 1
       temp           = badpts(1,ibot)
       badpts(1,ibot) = badpts(1,i)
       badpts(1,i)    = temp
       if (itop+1 .lt. ibot) go to 50
c
c done smartbisecting icl'th clusters. adjust counts, repeat bisect stage .
c
 80   numptc(icl) = itop - ist + 1
      ibump       = icl + 1
c
c  bump down remaining clusters to make room for the new half of one.
c
      if (ibump .gt. nclust) go to 120
      do 90 ico         = ibump, nclust
      nmove             = nclust - ico + ibump
 90   numptc(nmove + 1) = numptc(nmove)

 120  numptc(ibump)     = iend - ibot + 1
      nclust            = nclust + 1
      iend              = itop
c
c     other half of the cluster has been inserted into cluster list.
c     icl remains the same - need to redo it.
      go to 10
c
c  done: there are nclust clusters.
c
 200  continue
c
      return
      end

c
c ----------------------------------------------------------------
c
       subroutine auxcoarsen(auxdub,midub,mjdub,auxbgc,
     1                       mi2tot,mj2tot,naux,auxtype)
      
       implicit double precision (a-h, o-z)

       dimension     auxdub(naux,midub, mjdub)
       dimension     auxbgc(naux,mi2tot,mj2tot)
       character*10  auxtype(naux)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
!> Coarsen the fine grid auxiliary data (with double the usual
!! number of ghost cells to prepare coarsened data
!! for error estimation).
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       do iaux = 1, naux

       if (auxtype(iaux) .eq. "center" .or. 
     .     auxtype(iaux) .eq. "capacity") then
         do j = 1, mj2tot
            jfine = 2*(j-1) + 1
            do i = 1, mi2tot
               ifine = 2*(i-1) + 1
               auxbgc(iaux,i,j) = (auxdub(iaux,ifine,jfine) +
     &                             auxdub(iaux,ifine+1,jfine)+
     &                             auxdub(iaux,ifine,jfine+1) +
     &                             auxdub(iaux,ifine+1,jfine+1))/4.d0
            end do
         end do

       elseif (auxtype(iaux) .eq. "xleft") then 
         do j = 1, mj2tot
            jfine = 2*(j-1) + 1
            do i = 1, mi2tot
               ifine = 2*(i-1) + 1
               auxbgc(iaux,i,j) = (auxdub(iaux,ifine,jfine) +
     &                             auxdub(iaux,ifine,jfine+1)) /2.d0 
            end do
         end do

       elseif (auxtype(iaux) .eq. "yleft") then 
         do j = 1, mj2tot
            jfine = 2*(j-1) + 1
            do i = 1, mi2tot
               ifine = 2*(i-1) + 1
               auxbgc(iaux,i,j) = (auxdub(iaux,ifine,jfine) +
     &                             auxdub(iaux,ifine+1,jfine))/2.d0
            end do
         end do

       endif

       end do

       return
       end

! :::::::::::::::::::::::::::: FILPATCH :::::::::::::::::::::::::;
!
!  fill the portion of valbig from rows  nrowst
!  the patch is described by the corners (xlp) by (xrp).
!  vals are needed at time t, and level level,
!
!  first fill with  values obtainable from the level level
!  grids. if any left unfilled, then enlarge remaining strip of
!  unfilled values by 1 (for later linear interp), and recusively
!  obtain the remaining values from  coarser levels.
!
! :::::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::;
!
recursive subroutine filrecur(level,nvar,valbig,aux,naux,t,mitot, &
     nrowst,ilo,ihi,patchOnly,msrc)

  use amr_module, only: hxposs, xlower, xupper
  use amr_module, only: outunit, nghost, xperdom
  use amr_module, only: iregsz, intratx, NEEDS_TO_BE_SET

  !for setaux timing
  use amr_module, only: timeSetaux, timeSetauxCPU

  implicit none

  ! Input
  integer, intent(in) :: level, nvar, naux, mitot, nrowst
  integer, intent(in) :: ilo,ihi, msrc
  real(kind=8), intent(in) :: t
  logical  :: patchOnly

  ! Output
  real(kind=8), intent(in out) :: valbig(nvar,mitot)
  real(kind=8), intent(in out) :: aux(naux,mitot)

  ! Local storage
  integer :: i_fine, i_coarse, n, k
  integer  :: iplo, iphi
  integer :: mitot_patch, mitot_coarse, nghost_patch, lencrse
  integer :: refinement_ratio_x
  integer :: unset_indices(2)
  real(kind=8) :: dx_fine, dx_coarse
  real(kind=8) :: xlow_coarse, xlow_fine, xhi_fine
  real(kind=8) :: xcent_fine, xcent_coarse,ratiox,floor

  !for timing
  integer :: clock_start, clock_finish, clock_rate
  real(kind=8) :: cpu_start, cpu_finish

  ! Interpolation variables
  real(kind=8) :: eta1, eta2, valp, valm, valc, dupc, dumc
  real(kind=8) :: ducc, du, fu, valint, uslope

  ! Cell set tracking
  logical :: set
  integer(kind=1) :: flaguse(ihi-ilo+1)

  ! Scratch storage
  !  use stack-based scratch arrays instead of alloc, since dont really
  !  need to save beyond these routines, and to allow dynamic memory resizing
  !
  !     use 1d scratch arrays that are potentially the same size as 
  !     current grid, since may not coarsen.
  !     need to make it 1d and do own indexing, since
  !     when pass it in to subroutines they treat it as having dierent
  !     dimensions than the max size need to allocate here

  !--      dimension valcrse((ihi-ilo+2)*nvar)  ! NB this is a 1D array
  !--      dimension auxcrse((ihi-ilo+2)*naux)  ! the +2 is to expand on coarse grid to enclose fine
  ! ### turns out you need 3 rows, forget offset of 1 plus one on each side
  ! the +3 is to expand on coarse grid to enclose fine
  real(kind=8) :: valcrse((ihi-ilo+3)* nvar)
  real(kind=8) :: auxcrse((ihi-ilo+3) * naux)

  ! We begin by filling values for grids at level level. If all values can be
  ! filled in this way, we return;
  mitot_patch = ihi-ilo + 1 ! nrowp

  dx_fine     = hxposs(level)

  ! Coordinates of edges of patch (xlp,xrp)
  xlow_fine = xlower + ilo * dx_fine

  ! Fill in the patch as much as possible using values at this level
  ! note that if only a patch, msrc = -1, otherwise a real grid and intfil
  ! uses its boundary list
  ! msrc either -1 (for a patch) or the real grid number
  call intfil(valbig,mitot,t,flaguse,nrowst,ilo,  &
              ihi,level,nvar,naux,msrc)


  ! Trimbd returns set = true if all of the entries are filled (=1.).
  ! set = false, otherwise. If set = true, then no other levels are
  ! are required to interpolate, and we return.
  !
  ! Note that the used array is filled entirely in intfil, i.e. the
  ! marking done there also takes  into account the points filled by
  ! the boundary conditions. bc2amr will be called later, after all 4
  ! boundary pieces filled.
  call trimbd(flaguse,mitot_patch,set,unset_indices)
  ! il,ir= unset_indices(2)


  ! If set is .true. then all cells have been set and we can skip to setting
  ! the remaining boundary cells.  If it is .false. we need to interpolate
  ! some values from coarser levels, possibly calling this routine
  ! recursively.
  if (.not.set) then

     ! Error check 
     if (level == 1) then
        write(outunit,*)" error in filrecur - level 1 not set"
        write(outunit,'("start at row: ",i4)') nrowst
        print *," error in filrecur - level 1 not set"
        print *," should not need more recursion "
        print *," to set patch boundaries"
        print '("start at row: ",i4)', nrowst
        stop
     endif

     ! We begin by initializing the level level arrays, so that we can use
     ! purely recursive formulation for interpolating.
     dx_coarse  = hxposs(level - 1)

     ! Adjust unset_indices to account for the patch
     ! isl, isr
     unset_indices(1) = unset_indices(1) + ilo - 1
     unset_indices(2) = unset_indices(2) + ilo - 1

     ! Coarsened geometry
     refinement_ratio_x = intratx(level - 1)

     ! New patch rectangle (after we have partially filled it in) but in the
     ! coarse patches [iplo,iphi]

     iplo = (unset_indices(1) - refinement_ratio_x + nghost * refinement_ratio_x) &
          / refinement_ratio_x - nghost
     iphi = (unset_indices(2) + refinement_ratio_x) / refinement_ratio_x

     xlow_coarse = xlower + iplo * dx_coarse

     ! Coarse grid number of spatial points (nrowc)
     mitot_coarse   =  iphi - iplo + 1

     ! Check to make sure we created big enough scratch arrays
     if (mitot_coarse > ihi - ilo + 3) then

        print *," did not make big enough work space in filrecur "
        print *," need coarse space with mitot_coarse,mjtot_coarse ",mitot_coarse
        print *," made space for ilo,ihi ",ilo,ihi
        stop
     endif

     ! Set the aux array values for the coarse grid, this could be done 
     ! instead in intfil using possibly already available bathy data from the
     ! grids
     if (naux > 0) then
        nghost_patch = 0
        lencrse = (ihi-ilo+3)*naux ! set 1 component, not all naux
        do k = 1, lencrse, naux
           auxcrse(k) = NEEDS_TO_BE_SET ! new system checks initialization before setting aux vals
        end do
        call system_clock(clock_start,clock_rate)
        call cpu_time(cpu_start)
        call setaux(nghost_patch, mitot_coarse,  &
             xlow_coarse,            &
             dx_coarse,naux,auxcrse)
        call system_clock(clock_finish,clock_rate)
        call cpu_time(cpu_finish)
        timeSetaux = timeSetaux + clock_finish - clock_start
        timeSetauxCPU = timeSetauxCPU + cpu_finish - cpu_start
     endif

     ! Fill in the edges of the coarse grid. for recursive calls, patch indices and
     ! 'coarse grid' indices are the same (no actual coarse grid here, so cant use mptr
     ! must pass indices. patchOnly argument  is thus true

     if ((xperdom) .and. sticksout(iplo,iphi)) then
        call prefilrecur(level-1,nvar,valcrse,auxcrse,naux,t,mitot_coarse,1,   &
             iplo,iphi,iplo,iphi,.true.)
     else
        call filrecur(level-1,nvar,valcrse,auxcrse,naux,t,mitot_coarse,1,   &
             iplo,iphi,.true.,-1)  ! when going to coarser patch, no source grid (for now at least)
     endif

     ! convert to real for use below
     ratiox = real(refinement_ratio_x,kind=8)

    do i_fine = 1,mitot_patch
        !i_coarse = 2 + (i_fine - (unset_indices(1) - ilo) - 1) / refinement_ratio_x
        !eta1 = (-0.5d0 + real(mod(i_fine - 1, refinement_ratio_x),kind=8)) &
        !                    / real(refinement_ratio_x,kind=8)

        ! new coarse indexing
        !i_coarse =(i_fine+ilo-1)/refinement_ratio_x - iplo + 1

        i_coarse = floor((i_fine+ilo-1)/ratiox) - iplo + 1
        xcent_coarse = xlow_coarse + (i_coarse-.5d0)*dx_coarse
        xcent_fine =  xlower + (i_fine-1+ilo + .5d0)*dx_fine
        eta1 = (xcent_fine-xcent_coarse)/dx_coarse
        if (abs(eta1) .gt. .5) then
            write(*,*)" filpatch x indices wrong: eta1 = ",eta1
        endif

   
        if (flaguse(i_fine) == 0) then

            do n=1,nvar
                ! write(*,*)n,i_coarse+1,coarse_index(n,i_coarse + 1)
                valp = valcrse(coarse_index(n,i_coarse + 1))
                valm = valcrse(coarse_index(n,i_coarse - 1))
                valc   = valcrse(coarse_index(n,i_coarse  ))

                dupc = valp - valc
                dumc = valc   - valm
                ducc = valp - valm
                du   = min(abs(dupc), abs(dumc))
                du   = min(2.d0 * du, 0.5d0 * abs(ducc))
                fu = max(0.d0, sign(1.d0, dupc * dumc))
                uslope = du*sign(1.d0,ducc)*fu ! not really - should divide by h

                valint = valc + eta1 * uslope

                valbig(n,i_fine+nrowst-1) = valint

            end do

        endif
    end do
  end if

  !  set bcs, whether or not recursive calls needed. set any part of patch that stuck out
  xhi_fine = xlower + (ihi + 1) * dx_fine
  ! only call if a small coarser recursive patch
  ! otherwise whole grid bcs done from bound
  if (patchOnly) then
     call bc1amr(valbig,aux,mitot,nvar,naux,dx_fine,level,t,    &
                 xlow_fine,xhi_fine)
  endif

contains

  integer pure function coarse_index(n,i)
    implicit none
    integer, intent(in) :: n, i
    coarse_index = n + nvar*(i-1)
  end function coarse_index

  logical pure function sticksout(iplo,iphi)
    implicit none
    integer, intent(in) :: iplo,iphi
    sticksout = (iplo < 0 .or. iphi >= iregsz(level - 1))
  end function sticksout

end subroutine filrecur

! ::::::::::::::::::::: flag2refine ::::::::::::::::::::::::::::::::::
!
!> \callgraph
!! \callergraph
!! User routine to control flagging of points for refinement.
!!
!! Default version computes spatial difference dq in each direction and
!! for each component of q and flags any point where this is greater than
!! the tolerance tolsp.  
!! This is consistent with what the routine errsp did in
!!  earlier versions of amrclaw (4.2 and before).
!!
!! This routine can be copied to an application directory and modified to
!! implement some other desired refinement criterion.
!!
!! Points may also be flagged for refining based on a Richardson estimate
!! of the error, obtained by comparing solutions on the current grid and a
!! coarsened grid.  Points are flagged if the estimated error is larger than
!! the parameter tol in amr2ez.data, provided flag_richardson is .true.,
!! otherwise the coarsening and Richardson estimation is not performed!  
!! Points are flagged via Richardson in a separate routine.
!!
!! Once points are flagged via this routine and/or Richardson, the subroutine
!! flagregions is applied to check each point against the min_level and
!! max_level of refinement specified in any "region" set by the user.
!! So flags set here might be over-ruled by region constraints.
!!
!! **output**: amrflags
!!
!! \param mx number of cells in *i* direction
!! \param my number of cells in *j* direction
!! \param mbc width of ghost cell region
!! \param mbuff width of buffer region
!! \param meqn number of equations for the system
!! \param maux number of auxiliary variables
!! \param xlower x-coordinate of left physical boundary
!! \param ylower y-coordinate of lower physical boundary
!! \param dx spacing in *i* direction
!! \param dy spacing in *j* direction
!! \param t simulation time on this grid
!! \param level AMR level of this grid
!! \param tolsp tolerance specified by user in input file amr.data, used in default
!!         version of this routine as a tolerance for spatial differences
!! \param q grid values including ghost cells (bndry vals at specified
!!          time have already been set, so can use ghost cell values too)
!! \param aux auxiliary array on this grid patch
!! \param amrflags array to be flagged with either the value **DONTFLAG** or **DOFLAG** for each cell. 
!!        It is enlarged from grid size to include buffer regions around the grid. 
!! \param DONTFLAG value to be assigned to amrflags for cells that need no refinement
!! \param DOFLAG value to be assigned to amrflags for cells that do need refinement
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine flag2refine2(mx,my,mbc,mbuff,meqn,maux,xlower,ylower,dx,dy,t,level, &
                            tolsp,q,aux,amrflags)

    use regions_module
    use adjoint_module, only: totnum_adjoints,innerprod_index, &
                              adjoint_flagging,select_snapshots
    use adjointsup_module, only: calculate_innerproduct
    use amr_module, only : DOFLAG, UNSET

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,my,mbc,meqn,maux,level,mbuff
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,tolsp
    
    real(kind=8), intent(in) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbuff:mx+mbuff,1-mbuff:my+mbuff)
    
    ! Locals
    integer :: i,j,m,r
    real(kind=8) :: x_c,y_c,x_low,y_low,x_hi,y_hi
    real(kind=8) :: dqi(meqn), dqj(meqn), dq(meqn)

    ! Adjoint method specific variables
    logical mask_selecta(totnum_adjoints)

    ! Don't initialize flags, since they were already 
    ! flagged by flagregions2
    ! amrflags = DONTFLAG

    if(adjoint_flagging) then
        aux(innerprod_index,:,:) = 0.0
        call select_snapshots(t,mask_selecta)

        ! Loop over adjoint snapshots
        aloop: do r=1,totnum_adjoints

            ! Consider only snapshots that are within the desired time range
            if (mask_selecta(r)) then
                ! Calculate inner product with current snapshot
                call calculate_innerproduct(q,r,mx,my,xlower,   &
                        ylower,dx,dy,meqn,mbc,maux,aux)
            endif

        enddo aloop
    endif
    
    ! Loop over interior points on this grid
    ! (i,j) grid cell is [x_low,x_hi] x [y_low,y_hi], cell center at (x_c,y_c)
    ! This information is not needed for the default flagging based on
    ! undivided differences, but might be needed in a user's version.
    ! Note that if you want to refine only in certain space-time regions,
    ! it may be easiest to use the "regions" feature. The flags set here or
    ! in the Richardson error estimator are modifing the flags set by
    ! min_level and max_level specified in any regions.

    y_loop: do j=1,my
        !y_low = ylower + (j - 1) * dy
        !y_c = ylower + (j - 0.5d0) * dy
        !y_hi = ylower + j * dy
        
        x_loop: do i = 1,mx
            !x_low = xlower + (i - 1) * dx
            !x_c = xlower + (i - 0.5d0) * dx
            !x_hi = xlower + i * dx

            ! -----------------------------------------------------------------
            ! Only check undivided differences if flag hasn't been set yet. 
            ! If flag == DONTFLAG then refinement is forbidden by a region, 
            ! if flag == DOFLAG checking is not needed
            if(amrflags(i,j) == UNSET) then

                if(adjoint_flagging) then
                    if (aux(innerprod_index,i,j) > tolsp) then
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif
                else
                    dq = 0.d0
                    dqi = abs(q(:,i+1,j) - q(:,i-1,j))
                    dqj = abs(q(:,i,j+1) - q(:,i,j-1))
                    dq = max(dq,dqi,dqj)

                    ! default checks all components of undivided difference:
                    do m=1,meqn
                        if (dq(m) > tolsp) then
                            amrflags(i,j) = DOFLAG
                            cycle x_loop
                        endif
                    enddo
                endif

            endif

        enddo x_loop
    enddo y_loop
   
end subroutine flag2refine2

c
c ---------------------------------------------------
c
       subroutine resetBoussStuff(naux)

       use amr_module
       use bouss_module
       implicit double precision (a-h,o-z)
       type(matrix_levInfo),  pointer :: minfo

       do lev = max(1,minLevelBouss), min(maxLevelBouss,lfine)
          numBoussGrids = 0
          minfo => matrix_info_allLevs(lev)
          do ng = 1, numgrids(lev)
             levSt = listStart(lev)
             mptr  = listOfGrids(levSt+ng-1)
             nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
             ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
             nb = node(bpatchNum,mptr)
             numBoussGrids = numBoussGrids + 1
          end do
          if (numBoussGrids .gt. 0) then
             allocate(minfo%matrix_indices(numBoussGrids))
             minfo%numBoussGrids = numBoussGrids
             call setMatrixIndex(lev)
             call setBoussFlag(lev,naux)
          endif
       end do

!      initialize for solver
      if (isolver .eq. 2) then
        newGrids = .true.
#ifdef HAVE_PARDISO
        do lev = 1, mxnest
           if (lev.le.maxLevelBouss .and. lev.ge.minLevelBouss) then
                call pardisoinit(pt(1,lev),mtype,solver,iparm,dparm,
     &                           error)
                write(*,*)"restrt initialized pardiso for lev ",lev
           endif
        end do
#endif
      endif

      if (isolver .eq. 3) then
         newGrids = .true.
      endif

      return
      end

c
!> Apply a limiter to the waves.
!! The limiter is computed by comparing the 2-norm of each wave with
!! the projection of the wave from the interface to the left or
!! right onto the current wave.  For a linear system this would
!! correspond to comparing the norms of the two waves.  For a 
!! nonlinear problem the eigenvectors are not colinear and so the 
!! projection is needed to provide more limiting in the case where the
!! neighboring wave has large norm but points in a different direction
!! in phase space.
!! 
!! The specific limiter used in each family is determined by the
!! value of the corresponding element of the array mthlim, as used in
!! the function philim.
!! Note that a different limiter may be used in each wave family.
!! 
!! dotl and dotr denote the inner product of wave with the wave to
!! the left or right.  The norm of the projections onto the wave are then
!! given by dotl/wnorm2 and dotr/wnorm2, where wnorm2 is the 2-norm
!! of wave.
c
c     =====================================================
      subroutine limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c     =====================================================
c
c
      implicit double precision (a-h,o-z)
      dimension mthlim(mwaves)
      dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
      dimension    s(mwaves, 1-mbc:maxm+mbc)
c
c
      do 50 mw=1,mwaves
         if (mthlim(mw) .eq. 0) go to 50
         dotr = 0.d0
         do 40 i = 0, mx+1
            wnorm2 = 0.d0
            dotl = dotr
            dotr = 0.d0
            do 20 m=1,meqn
               wnorm2 = wnorm2 + wave(m,mw,i)**2
               dotr = dotr + wave(m,mw,i)*wave(m,mw,i+1)
   20          continue
            if (i.eq.0) go to 40
            if (wnorm2.eq.0.d0) go to 40
c
            if (s(mw,i) .gt. 0.d0) then
                wlimitr = philim(wnorm2, dotl, mthlim(mw))
              else
                wlimitr = philim(wnorm2, dotr, mthlim(mw))
              endif
c
            do 30 m=1,meqn
               wave(m,mw,i) = wlimitr * wave(m,mw,i)
   30          continue
   40       continue
   50    continue
c
      return
      end

c
c
c
c     ==================================================================
      subroutine dimsp3(maxm,meqn,mwaves,mbc,mx,my,
     &                  mz,qold,qnew,aux,dx,dy,dz,dt,method,mthlim,cfl,
     &                  cflv,qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,
     &                  dtdz1d,aux1,aux2,aux3,maux,work,mwork,
     &                  use_fwave,rpn3,rpt3,rptt3)
c     ==================================================================
c
c     # Take one time step, updating q, using dimensional
c     # splitting. Only first order Godunov splitting is
c     # included. The main reason why not also Strang splitting 
c     # is included, is that it is not clear how to include
c     # boundary conditions in this case.
c
      implicit real*8(a-h,o-z)
      external rpn3,rpt3,rptt3
      dimension qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 
     &          1-mbc:mz+mbc)
      dimension qnew(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 
     &          1-mbc:mz+mbc)
      dimension  q1d(meqn,1-mbc:maxm+mbc)
      dimension cflv(4)
      dimension qadd(meqn,1-mbc:maxm+mbc)
      dimension fadd(meqn,1-mbc:maxm+mbc)
      dimension gadd(meqn,2,-1:1,1-mbc:maxm+mbc)
      dimension hadd(meqn,2,-1:1,1-mbc:maxm+mbc)
      dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 
     &              1-mbc:mz+mbc)
      dimension aux1(maux,1-mbc:maxm+mbc,3)
      dimension aux2(maux,1-mbc:maxm+mbc,3)
      dimension aux3(maux,1-mbc:maxm+mbc,3)
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension dtdy1d(1-mbc:maxm+mbc)
      dimension dtdz1d(1-mbc:maxm+mbc)
      dimension method(7),mthlim(mwaves)
      dimension work(mwork)
      logical use_fwave
c
c     # Take one full time step in the x-direction
c
      idir = 1
      call step3ds(maxm,meqn,mwaves,mbc,mx,my,
     &             mz,qold,qnew,aux,dx,dy,dz,dt,method,mthlim,cflx,
     &             qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d,
     &             aux1,aux2,aux3,maux,work,mwork,
     &             idir,use_fwave,rpn3,rpt3,rptt3)
c
      if (cflx .gt. cflv(1)) then
c        # Abort if the Courant number was too large in x-sweep
         cfl = cflx
         return
         endif
c
c     # Take one full time step in the y-direction
c
      idir = 2
c
      call step3ds(maxm,meqn,mwaves,mbc,mx,my,
     &             mz,qnew,qnew,aux,dx,dy,dz,dt,method,mthlim,cfly,
     &             qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d,
     &             aux1,aux2,aux3,maux,work,mwork,
     &             idir,use_fwave,rpn3,rpt3,rptt3)
c
      if (cfly .gt. cflv(1)) then
c        # Abort if the Courant number was too large in y-sweep
         cfl = cfly
         return
         endif
c
c     # Take one full time step in the z-direction
c
      idir = 3
      call step3ds(maxm,meqn,mwaves,mbc,mx,my,
     &             mz,qnew,qnew,aux,dx,dy,dz,dt,method,mthlim,cflz,
     &             qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d,
     &             aux1,aux2,aux3,maux,work,mwork,
     &             idir,use_fwave,rpn3,rpt3,rptt3)
c
      cfl = dmax1(cflx,cfly,cflz)
c
      return
      end

subroutine setprob

    use adjoint_module, only: read_adjoint_data
    implicit none

    character*25 :: fname
    integer :: iunit
    
    real(kind=8) :: rho,bulk,cc,zz
    common /cparam/ rho,bulk,cc,zz

    ! Set the material parameters for the acoustic equations
 
    iunit = 7
    fname = 'setprob.data'
    call opendatafile(iunit, fname)
              
    ! Density and bulk modulus:

    read(7,*) rho
    read(7,*) bulk

    ! Compute sound speed and impendance:

    cc = dsqrt(bulk/rho)
    zz = rho*cc

end subroutine setprob

subroutine rpn2(ixy,maxm, meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)

! Roe-solver for the Euler equations with mapped grids

! waves: 3
! equations: 4

! Conserved quantities:
!       1 density
!       2 x_momentum
!       3 y_momentum
!       4 energy

! Need to fill in the auxiliary variables

! Solve Riemann problems along one slice of data.

    implicit none

    integer :: ixy, maxm, meqn, mwaves, mbc, mx, my, maux
    double precision ::    ql(meqn,   1-mbc:maxm+mbc)
    double precision ::    qr(meqn,   1-mbc:maxm+mbc)
    double precision ::     s(mwaves, 1-mbc:maxm+mbc)
    double precision ::  wave(meqn,   mwaves, 1-mbc:maxm+mbc)
    double precision ::  amdq(meqn,   1-mbc:maxm+mbc)
    double precision ::  apdq(meqn,   1-mbc:maxm+mbc)
    double precision ::  auxl(maux,      1-mbc:maxm+mbc)
    double precision ::  auxr(maux,      1-mbc:maxm+mbc)

    double precision :: gamma, gamma1
    double precision :: ql_state(4), qr_state(4)
    double precision :: rhol, ul, el, cl, pl, vl
    double precision :: rhor, ur, er, cr, pr, vr
    double precision :: rhsqrtl, rhsqrtr, rhsq2
    double precision :: u, enth, delta(4), rho, v
    double precision :: wave_local(3,4), s_local(3),uv(2)
    double precision :: speeds(2,3), u2v2l, u2v2r
    integer :: i, m, mw, mu, mv, ixy1, info
    logical :: efix

    integer :: mcapa,locrot, locarea
    double precision :: rot(4), area

    common /cparam/  gamma

    data efix /.true./

    gamma1 = gamma - 1.d0

    call get_aux_locations_n(ixy,mcapa,locrot,locarea)

    do i = 2-mbc,mx+mbc

        rot(1) = auxl(locrot,i)
        rot(2) = auxl(locrot+1,i)
        call compute_tangent(rot)

        do m = 1,meqn
            ql_state(m) = qr(m,i-1)
            qr_state(m) = ql(m,i)
        enddo
        call rotate2(rot,ql_state(2))
        call rotate2(rot,qr_state(2))

        rhol = ql_state(1)
        rhor = qr_state(1)

        ul = ql_state(2)/rhol
        ur = qr_state(2)/rhor

        vl = ql_state(3)/rhol
        vr = qr_state(3)/rhor

        el = ql_state(4)
        er = qr_state(4)

        u2v2l = ul*ul + vl*vl
        u2v2r = ur*ur + vr*vr
        pl = gamma1*(el - 0.5d0*rhol*u2v2l)
        pr = gamma1*(er - 0.5d0*rhor*u2v2r)

    !        # Get Roe averaged values
        rhsqrtl = sqrt(rhol)
        rhsqrtr = sqrt(rhor)
        rhsq2 = rhsqrtl + rhsqrtr

        uv(1) = (ul*rhsqrtl + ur*rhsqrtr) / rhsq2
        uv(2) = (vl*rhsqrtl + vr*rhsqrtr) / rhsq2
        enth = ((el + pl)/rhsqrtl + (er + pr)/rhsqrtr)/rhsq2

        do m = 1,meqn
            delta(m) = qr_state(m) - ql_state(m)
        enddo

        ixy1 = 1
        call roe_solver(ixy1,uv,enth,delta,wave_local,s_local,info)

        if (info /= 0) then
            write(6,*) 'ixy = ', ixy
            write(6,*) 'enth = ', enth
            write(6,*) 'Called from rpn2 '
            write(6,*) ' '
            do m = 1,meqn
                write(6,'(2E24.16)') ql_state(m), qr_state(m)
            enddo
            write(6,*) ' '
            stop
        endif

        do mw = 1,mwaves
            speeds(1,mw) = min(s_local(mw),0.d0)
            speeds(2,mw) = max(s_local(mw),0.d0)
        enddo

        if (efix) then
        !           # This modifies the speeds, but we will still have
        !           # s(mw) = speeds(mw,1) + speeds(mw,2)
            cl = sqrt(gamma*pl/rhol)
            cr = sqrt(gamma*pr/rhor)
            call apply_entropy_fix(ql_state,qr_state,cl,cr, &
            wave_local, speeds)
        endif

        area = auxl(locarea,i)
        do mw = 1,mwaves
            call rotate2_tr(rot,wave_local(mw,2))
            speeds(1,mw) = area*speeds(1,mw)
            speeds(2,mw) = area*speeds(2,mw)
        enddo

        do m = 1,meqn
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw = 1,mwaves
                wave(m,mw,i) = wave_local(mw,m)
                s(mw,i) = speeds(1,mw) + speeds(2,mw)
                amdq(m,i) = amdq(m,i) + speeds(1,mw)*wave(m,mw,i)
                apdq(m,i) = apdq(m,i) + speeds(2,mw)*wave(m,mw,i)
            enddo
        enddo
    enddo


    return
    end subroutine rpn2

    subroutine apply_entropy_fix(ql,qr,cl, cr,wave_local,speeds)
    implicit none

    double precision :: ql(4), qr(4),wave_local(3,4)
    double precision :: speeds(2,3), s1, s2, s3, s4
    double precision :: sl, sml, smr, sr, qml(4),qmr(4)
    double precision :: ul, cl, ur, cr, pml, pmr, cml,cmr
    double precision :: sfract
    double precision :: gamma, gamma1
    logical :: trans1, trans3

    integer :: m

    common /cparam/ gamma

    gamma1 = gamma - 1.d0

    s1 = speeds(1,1) + speeds(2,1)
    s2 = speeds(1,2) + speeds(2,2)
    s3 = speeds(1,3) + speeds(2,3)

    do m = 1,4
        qml(m) = ql(m) + wave_local(1,m)
    enddo
    sl = ql(2)/ql(1) - cl
    pml = gamma1*(qml(4) - 0.5d0*(qml(2)**2/qml(1) + &
    qml(3)**2/qml(1)))
    sml = qml(2)/qml(1) - sqrt(gamma*pml/qml(1))

!     # Check the 1-wave
    trans1 = .false.
    if (sl < 0 .AND. sml > 0) then
    !        # apply transonic entropy fix
        trans1 = .true.
        sfract = (sml - s1)/(sml - sl)
        speeds(1,1) = sfract*sl
        speeds(2,1) = (1-sfract)*sml
    endif

!     # If the 1-wave is transonic,then we are done...
!     # Otherwise, we have to check the 3-wave
    if ( .NOT. trans1) then
        do m = 1,4
            qmr(m) = qr(m) - wave_local(3,m)
        enddo
        sr = qr(2)/qr(1) + cr
        pmr = gamma1*(qmr(4) - 0.5d0*(qmr(2)**2/qmr(1) + &
        qmr(3)**2/qmr(1)))
        smr = qmr(2)/qmr(1) + sqrt(gamma*pmr/qmr(1))
        trans3 = .false.
        if (smr < 0 .AND. sr > 0) then
        !           # apply transonic entropy fix
            trans3 = .true.
            sfract = (sr - s3)/(sr - smr)
            speeds(1,3) = sfract*smr
            speeds(2,3) = (1-sfract)*sr
        endif
    endif

    if (trans1) then
        write(6,*) '1-wave is transonic'
    elseif (trans3) then
        write(6,*) '3-wave is transonic'
    endif

    end subroutine apply_entropy_fix

c====================================================================
      subroutine cellgridintegrate(topoint,xim,xcell,xip,yjm,ycell,
     &           yjp,xlowtopo,ylowtopo,xhitopo,yhitopo,dxtopo,dytopo,
     &           mxtopo,mytopo,mtopo,i0topo,mtopoorder,
     &           mtopofiles,mtoposize,topo)
c=====================================================================


      implicit double precision (a-h,o-z)

      dimension topo(mtoposize)

      dimension xlowtopo(mtopofiles)
      dimension ylowtopo(mtopofiles)
      dimension xhitopo(mtopofiles)
      dimension yhitopo(mtopofiles)
      dimension dxtopo(mtopofiles)
      dimension dytopo(mtopofiles)

      dimension mxtopo(mtopofiles)
      dimension mytopo(mtopofiles)

      dimension mtopoorder(mtopofiles)
      dimension i0topo(mtopofiles)
      dimension mtopo(mtopofiles)


c     ##############################################################################
c     cellgridintegrate integrates a unique surface, over a rectangular cell
c     defined from data from multiple regular Cartesian grids
c     (using the finest data available in any region)
c
c     The rectangle has coords:
c     xim <= x <= xip, yjm <= y <= yjp, with center (x,y) = (xcell, ycell)
c
c     The intersection (with one particular grid has coords:
c     xintlo <= x <= xinthi, yintlo <= y <= yinthi, with center (x,y) = (xintc, yintc)

c     The _set_ version uses a recursive strategy using the formulas for
c     intersections of sets.

c     # initialize the integral of the surface
      topoint=0.d0

*     !determine the type of integration
      im = 1

c     # first see if the grid cell is entirely in a fine topofile
      do m = 1,mtopofiles
c        !look at topofiles, from fine to coarse
         mfid = mtopoorder(m)
         i0=i0topo(mfid)
c        !check for intersection of grid cell and this topofile
         cellarea = (xip-xim)*(yjp-yjm)
         call intersection(indicator,area,xmlo,xmc,xmhi,
     &       ymlo,ymc,ymhi,xim,xip,yjm,yjp,
     &       xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))
         if (indicator.eq.1) then !cell overlaps grid
            if (area.eq.cellarea) then !cell is entirely in grid
c              !integrate surface and get out of here
                topoint = topoint + topointegral(
     &              xmlo,xmc,xmhi,ymlo,ymc,
     &              ymhi,xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid),
     &              dytopo(mfid),mxtopo(mfid),mytopo(mfid),
     &              topo(i0),im)
               return
            else
               go to 222
            endif
         endif
      enddo

 222  continue

c     ! grid cell integral must come from more than one topofile
      do m = mtopofiles,1,-1
c        ! look for topo files overlapping this grid cell.
c        ! By decending mtopoorder from mtopoorder(mtopofiles) to
c        ! mtopoorder(1) we are decending from the coarsest to the finest topofile.
c        ! by the end of the nested loops, the integral of this topofile
c        ! will be taken over regions not covered by finer topofiles
c        ! nested loops only account for a maximum of 4 intersecting topo files
c        ! if 5 topofiles intersect, then an error is sent.

         mfid = mtopoorder(m)

c        ! note that mfid indicates the topofile number or id for the "m'th" coarsest topofile
         ! within this do loop, we are always integrating mfid
c        ! the nested do loops find intersections with other topofiles
c        ! to determin the areas, but for integration of mfid only!

c        !check for intersection of grid cell and this topofile
         call intersection(indicator,area,xmlo,xmc,xmhi,
     &       ymlo,ymc,ymhi,xim,xip,yjm,yjp,
     &       xlowtopo(mfid),xhitopo(mfid),ylowtopo(mfid),yhitopo(mfid))

         if (indicator.eq.1) then
c           ! cell overlaps the file
            i0=i0topo(mfid)
c           ! integrate surface over intersection of grid and cell
            topoint = topoint + topointegral(
     &              xmlo,xmc,xmhi,ymlo,ymc,
     &              ymhi,xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid),
     &              dytopo(mfid),mxtopo(mfid),mytopo(mfid),
     &              topo(i0),im)

c           ! loop through grids finer than this one and subtract any
c           ! integrals over intersections
            do mm = m-1,1,-1
               mfidint = mtopoorder(mm)
c              ! check for 2nd intersection
               call intersection(indicator,area,xmmlo,xmmc,xmmhi,
     &                 ymmlo,ymmc,ymmhi,xmlo,xmhi,ymlo,ymhi,
     &                 xlowtopo(mfidint),xhitopo(mfidint),
     &                 ylowtopo(mfidint),yhitopo(mfidint))

               if (indicator.eq.1) then
c                 ! get rid of coarser integral
                  topoint = topoint - topointegral(
     &              xmmlo,xmmc,xmmhi,ymmlo,ymmc,
     &              ymmhi,xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid),
     &              dytopo(mfid),mxtopo(mfid),mytopo(mfid),
     &              topo(i0),im)
c                  -----------------------------------------------------
c                 ------------------------------------------------------------
c                 ! loop through grids finer than this one and add back any
c                 ! integrals over intersections that will later get subtracted again
                  do mmm = mm-1,1,-1
                     mfidint = mtopoorder(mmm)
c                    ! check for 3rd intersection
                   call intersection(indicator,area,xmmmlo,xmmmc,xmmmhi,
     &                 ymmmlo,ymmmc,ymmmhi,xmmlo,xmmhi,ymmlo,ymmhi,
     &                 xlowtopo(mfidint),xhitopo(mfidint),
     &                 ylowtopo(mfidint),yhitopo(mfidint))

                     if (indicator.eq.1) then
c                       ! add back
                        topoint = topoint + topointegral(
     &                  xmmmlo,xmmmc,xmmmhi,ymmmlo,ymmmc,ymmmhi,
     &                  xlowtopo(mfid),ylowtopo(mfid),dxtopo(mfid),
     &                  dytopo(mfid),mxtopo(mfid),mytopo(mfid),
     &                                             topo(i0),im)

                        do m4 = mmm-1,1,-1
                           mfidint = mtopoorder(m4)
c                          ! check for 4th intersection
                           call intersection(indicator,area,xm4lo,
     &                        xm4c,xm4hi,ym4lo,ym4c,ym4hi,xmmmlo,
     &                        xmmmhi,ymmmlo,ymmmhi,
     &                        xlowtopo(mfidint),xhitopo(mfidint),
     &                        ylowtopo(mfidint),yhitopo(mfidint))

                           if (indicator.eq.1) then
c                          ! add back
                              topoint = topoint - topointegral(
     &                        xm4lo,xm4c,xm4hi,ym4lo,ym4c,ym4hi,
     &                        xlowtopo(mfid),ylowtopo(mfid),
     &                        dxtopo(mfid),dytopo(mfid),mxtopo(mfid),
     &                        mytopo(mfid),topo(i0),im)

                                 do m5 = m4-1,1,-1
                                    mfidint = mtopoorder(m5)
c                                   ! check for 5th intersection
                                    call intersection(indicator,area,
     &                                 xm5lo,xm5c,xm5hi,ym5lo,ym5c,
     &                                 ym5hi,xm4lo,xm4hi,ym4lo,
     &                                 ym4hi,xlowtopo(mfidint),
     &                                 xhitopo(mfidint),
     &                                 ylowtopo(mfidint),
     &                                 yhitopo(mfidint))

                                    if (indicator.eq.1) then
                                       write(*,*) 'CELLGRIDINTEGRATE:'
            write(*,*) 'ERROR: 5 NESTED TOPOGRIDS. MAXIMUM OF 4 ALLOWED'
                                    endif
                                 enddo
                           endif
                        enddo
                     endif
                  enddo

               endif
            enddo
c           ------------------------------------------------------------
         endif

      enddo

      return
      end

c=======================================================================
      subroutine intersection(indicator,area,xintlo,xintc,xinthi,
     &      yintlo,yintc,yinthi,x1lo,x1hi,y1lo,y1hi,x2lo,x2hi,y2lo,y2hi)

c     find the intersection of two rectangles, return the intersection
c     and it's area, and indicator =1
c     if there is no intersection, indicator =0

      implicit none

c     !i/o integer
      integer indicator

c     !i/o doubles
      double precision area,xintlo,xintc,xinthi,yintlo,yintc,yinthi,
     &                 x1lo,x1hi,y1lo,y1hi,x2lo,x2hi,y2lo,y2hi


      xintlo=dmax1(x1lo,x2lo)
      xinthi=dmin1(x1hi,x2hi)
      yintlo=dmax1(y1lo,y2lo)
      yinthi=dmin1(y1hi,y2hi)

      xintc = 0.5d0*(xintlo+xinthi)
      yintc = 0.5d0*(yintlo+yinthi)

      if (xinthi.gt.xintlo.and.yinthi.gt.yintlo) then
         area = (xinthi-xintlo)*(yinthi-yintlo)
         indicator = 1
      else
         area = 0.d0
         indicator = 0
      endif

      return
      end

c
c -------------------------------------------------------------
c
      subroutine errest (nvar,naux,lcheck)
c
      use amr_module
      implicit double precision (a-h,o-z)
      
      !for timing setaux
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish

c
c     #   no sense computing new time step if just for error estimation,
c     #   vtime removed from arg list to stepgrid, but new dt not used


c :::::::::::::::::::::::::: ERREST :::::::::::::::::::::::::::::::::::
c for all grids at level lcheck:
c  estimate the error by taking a large (2h,2k) step based on the
c  values in the old storage loc., then take one regular (and for
c  now wasted) step based on the new info.   compare using an
c  error relation for a pth order  accurate integration formula.
c  flag error plane as either bad (needs refinement), or good.
c
c  call the regular integrator on a grid twice as coarse.
c  initialize such a grid directly, instead of trick dimensioning.
c  this is to make other l1 type estimates easier to program.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c
       hx   = hxposs(lcheck)
       hy   = hyposs(lcheck)
       hz   = hzposs(lcheck)
       hx2  = 2.d0*hx
       hy2  = 2.d0*hy
       hz2  = 2.d0*hz
       mptr = lstart(lcheck)
 5     continue
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          mktot  = nz + 2*nghost
          locnew = node(store1,mptr)
          locold = node(store2,mptr)
          locaux = node(storeaux,mptr)
          mi2tot = nx/2  + 2*nghost
          mj2tot = ny/2  + 2*nghost
          mk2tot = nz/2  + 2*nghost
          time   = rnode(timemult,mptr)
          dt     = possk(lcheck)
          tpre   = time - dt
c
c     prepare double the stencil size worth of boundary values,
c            then coarsen them for the giant step integration.
c
          midub = nx+4*nghost
          mjdub = ny+4*nghost
          mkdub = nz+4*nghost
          locdub = igetsp(midub *mjdub *mkdub *(nvar+naux))
          locbgc = igetsp(mi2tot*mj2tot*mk2tot*(nvar+naux))
          node(errptr,mptr) = locbgc
          ngbig = 2*nghost

c         # transfer soln. into grid with twice the ghost cells
          call copysol(alloc(locdub),alloc(locold),nvar,
     &                 mitot,mjtot,mktot,
     1                 nghost,midub,mjdub,mkdub,ngbig)

c
          if (naux .gt. 0) then
              locaxb = locdub + midub *mjdub *mkdub *nvar
              locaxc = locbgc + mi2tot*mj2tot*mk2tot*nvar
              xlowmbc = rnode(cornxlo, mptr)
              ylowmbc = rnode(cornylo, mptr)
              zlowmbc = rnode(cornzlo, mptr)
              xl = xlowmbc - 2*nghost*hx
              yf = ylowmbc - 2*nghost*hy
              zb = zlowmbc - 2*nghost*hz

c	      xl     = rnode(cornxlo, mptr)-2*nghost*hx
c	      yf     = rnode(cornylo, mptr)-2*nghost*hy
c	      zb     = rnode(cornzlo, mptr)-2*nghost*hz
              call system_clock(clock_start, clock_rate)
              call cpu_time(cpu_start)
              call setaux(2*nghost,nx,ny,nz,
     &              xlowmbc,ylowmbc,zlowmbc ,hx,hy,hz,
     &              naux,alloc(locaxb))
              call system_clock(clock_finish, clock_rate)
              call cpu_time(cpu_finish)

              call auxcoarsen(alloc(locaxb),midub ,mjdub ,mkdub ,
     1                        alloc(locaxc),mi2tot,mj2tot,mk2tot,
     2                       naux,auxtype)
          else
              locaxb = 1
          endif

c         # fill it - use enlarged (before coarsening) aux arrays
          call bound(tpre,nvar,
     1               ngbig,alloc(locdub),midub,mjdub,mkdub,mptr,
     2               alloc(locaxb),naux)

c         coarsen by 2 in every direction
          call coarsen(alloc(locdub),midub ,mjdub ,mkdub ,
     1                 alloc(locbgc),mi2tot,mj2tot,mk2tot,nvar)
          call reclam(locdub,midub*mjdub*mkdub*(nvar+naux))
c
c ****************************************************************
c      changed. now locbig filled from spest, always, even if no
c      user estimation routine. reclaim space later tho.
c
c We now fill bndry values at time t = time, in preparation
c for calculating the solution on the grid mptr for error estimation.
c
c          locbig = igetsp(mitot*mjtot*mktot*nvar)
c	        node(tempptr,mptr) = locbig
c         # straight copy into scratch array so don't mess up latest soln.
c          do 10 i = 1, mitot*mjtot*mktot*nvar
c 10          alloc(locbig+i-1) = alloc(locnew+i-1)
c
c          call bound(time,nvar,
c     1               nghost,alloc(locbig),mitot,mjtot,mktot,mptr,
c     1               alloc(locaux),naux)

c ******************************************************************
c
       mptr = node(levelptr,mptr)
       if (mptr .ne. 0) go to 5
c
       hx   = hxposs(lcheck)
       hy   = hyposs(lcheck)
       hz   = hzposs(lcheck)
       hx2  = 2.d0*hx
       hy2  = 2.d0*hy
       hz2  = 2.d0*hz
       dt   = possk(lcheck)
       dt2    = 2. * dt

       mptr = lstart(lcheck)
 25    continue
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
          mitot  = nx+ 2*nghost
          mjtot  = ny+ 2*nghost
          mktot  = nz+ 2*nghost
          mi2tot = nx/2 + 2*nghost
          mj2tot = ny/2 + 2*nghost
          mk2tot = nz/2 + 2*nghost
c
c         # this scratch storage will be used both for regular and half
c         # sized grid. different dimensions in stepgrid - do not reuse.
          locfp = igetsp(mitot*mjtot*mktot*nvar)
          locfm = igetsp(mitot*mjtot*mktot*nvar)
          locgp = igetsp(mitot*mjtot*mktot*nvar)
          locgm = igetsp(mitot*mjtot*mktot*nvar)
          lochp = igetsp(mitot*mjtot*mktot*nvar)
          lochm = igetsp(mitot*mjtot*mktot*nvar)
          locaux = node(storeaux,mptr)
c
          locbgc = node(errptr,mptr)
c
          locaxc = locbgc+nvar*mi2tot*mj2tot*mk2tot
c should we set to 1 if naux=0?
c
          evol = evol + (nx/2)*(ny/2)*(nz/2)
          xlow = rnode(cornxlo,mptr) - nghost*hx2
          ylow = rnode(cornylo,mptr) - nghost*hy2
          zlow = rnode(cornzlo,mptr) - nghost*hz2
          call stepgrid(alloc(locbgc),alloc(locfm),alloc(locfp),
     1                alloc(locgm),alloc(locgp),
     &                alloc(lochm),alloc(lochp),
     2                mi2tot,mj2tot,mk2tot,nghost,
     3                dt2,dtnew2,hx2,hy2,hz2,nvar,
     4                xlow,ylow,zlow,tpre,mptr,naux,alloc(locaxc))
c
c  the one giant step based on old values is done. now take
c  one regular step based on new values.
c
          evol   = evol + nx * ny * nz
          xlow   = rnode(cornxlo,mptr) - nghost*hx
          ylow   = rnode(cornylo,mptr) - nghost*hy
          zlow   = rnode(cornzlo,mptr) - nghost*hz
          locbig = node(tempptr,mptr)
          loctmp = node(store2,mptr)
c
c **********************************************************
c *****  changed. spatial error now done from separate routine spest *****
c
c estimate spatial component of error - use old values before
c integration to get accurate boundary gradients
c
c      locerrsp = igetsp(mitot*mjtot*mktot)
c      call errsp(alloc(locbig), alloc(locerrsp), mitot,mjtot,mktot,
c     &           nvar, mptr,nghost, eprint, outunit)
c
c ******************************************************************

      call stepgrid(alloc(locbig),alloc(locfm),alloc(locfp),
     1            alloc(locgm),alloc(locgp),
     &            alloc(lochm),alloc(lochp),
     2            mitot,mjtot,mktot,nghost,
     3            dt,dtnew,hx,hy,hz,nvar,
     4            xlow,ylow,zlow,time,mptr,naux,alloc(locaux))
c
      call reclam(locfp, mitot*mjtot*mktot*nvar)
      call reclam(locfm, mitot*mjtot*mktot*nvar)
      call reclam(locgp, mitot*mjtot*mktot*nvar)
      call reclam(locgm, mitot*mjtot*mktot*nvar)
      call reclam(lochp, mitot*mjtot*mktot*nvar)
      call reclam(lochm, mitot*mjtot*mktot*nvar)
c
      call errf1(alloc(locbig),nvar,
     1          alloc(locbgc),mptr,mi2tot,mj2tot,mk2tot,
     2          mitot,mjtot,mktot,alloc(loctmp))
      call reclam(locbgc  , mi2tot*mj2tot*mk2tot*(nvar+naux))

c      call reclam(locerrsp, mitot *mjtot *mktot)
c reclaiming of locbig now done frombufnst, since this routine will not
c be called if tol<0
c      call reclam(locbig  , mitot *mjtot *mktot *nvar)
c
      mptr = node(levelptr, mptr)
      if (mptr .ne. 0) go to 25

      return
      end

c
c ----------------------------------------------------------
c
      subroutine prepc(level,nvar)
c
      use amr_module
      implicit double precision (a-h,o-z)

      parameter(numbcs=6)
c
c :::::::::::::::::::: PREPC ::::::::::::::::::::::::::::::::::::::
c
c this routine called because regridding just changed the fine grids.
c modify coarse grid boundary lists to store fluxes in appropriate
c fine grids lists.
c assume new fine grids have node(cfluxptr) initialized to point to null
c
c  first compute max. possible number of list cells. allocate
c  initially so that one pass through is enough.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      maxsp  = 0
      mkid   = lstart(level+1)
 10   if (mkid .eq. 0) go to 20
         ikeep  = (node(ndihi,mkid)-node(ndilo,mkid)+1)/intratx(level)
         jkeep  = (node(ndjhi,mkid)-node(ndjlo,mkid)+1)/intraty(level)
         kkeep  = (node(ndkhi,mkid)-node(ndklo,mkid)+1)/intratz(level)
         maxsp  = maxsp + 2*(ikeep*jkeep + jkeep*kkeep + kkeep*ikeep)
      mkid = node(levelptr,mkid)
      go to 10
 20   listsp(level) = maxsp
      if (maxsp .eq. 0) go to 99
c
      hxpar   = hxposs(level)
      hypar   = hyposs(level)
      hzpar   = hzposs(level)
      hxkid   = hxposs(level+1)
      hykid   = hyposs(level+1)
      hzkid   = hzposs(level+1)
      imax    = iregsz(level) - 1
      jmax    = jregsz(level) - 1
      kmax    = kregsz(level) - 1

      mpar = lstart(level)
 30   if (mpar .eq. 0) go to 99
c
       ispot   = 0
       ilo     = node(ndilo,mpar)
       jlo     = node(ndjlo,mpar)
       klo     = node(ndklo,mpar)
       ihi     = node(ndihi,mpar)
       jhi     = node(ndjhi,mpar)
       khi     = node(ndkhi,mpar)
       locbc   = igetsp(numbcs*maxsp)
c      #  initialize list space to 0 (0 terminator indicates end of bc list)
       do 35 i = 1,numbcs*maxsp
 35      alloc(locbc+i-1) = 0.d0
       node(cfluxptr,mpar) = locbc
c
       mkid = lstart(level+1)
 40    if (mkid .eq. 0) go to 60

          iclo = node(ndilo,mkid)/intratx(level)
          jclo = node(ndjlo,mkid)/intraty(level)
          kclo = node(ndklo,mkid)/intratz(level)
          ichi = node(ndihi,mkid)/intratx(level)
          jchi = node(ndjhi,mkid)/intraty(level)
          kchi = node(ndkhi,mkid)/intratz(level)

          iplo = max(ilo,iclo)
          jplo = max(jlo,jclo)
          kplo = max(klo,kclo)
          iphi = min(ihi,ichi)
          jphi = min(jhi,jchi)
          kphi = min(khi,kchi)

c   regular intersections
          if ((iplo .le. iphi+1 .and. jplo .le. jphi+1) .and.
     &                               (kplo .le. kphi+1))
     1          call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,iclo,ichi,jclo,jchi,kclo,kchi,
     3          nghost)
 
c   for fine grids touching periodic boundary on right
          if  (xperdom .and. ilo .eq. 0 .and. ichi .eq. imax)
     1        call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,
     &          iclo-iregsz(level),ichi-iregsz(level),
     3          jclo,jchi,kclo,kchi,nghost)
 
c   for fine grids touching periodic boundary on left
          if  (xperdom .and. iclo .eq. 0 .and. ihi .eq. imax)
     1        call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,
     &          iclo+iregsz(level),ichi+iregsz(level),
     3          jclo,jchi,kclo,kchi,nghost)
 
c   for fine grids touching periodic boundary on rear
          if  (yperdom .and. jlo .eq. 0 .and. jchi .eq. jmax)
     1          call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,iclo,ichi,
     3          jclo-jregsz(level),jchi-jregsz(level),kclo,kchi,nghost)
 
c   for fine grids touching periodic boundary on front
          if  (yperdom .and. jclo .eq. 0 .and. jhi .eq. jmax)
     1        call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,iclo,ichi,
     3          jclo+jregsz(level),jchi+jregsz(level),kclo,kchi,nghost)
 
c   for fine grids touching periodic boundary on top
          if  (zperdom .and. klo .eq. 0 .and. kchi .eq. kmax)
     1          call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,iclo,ichi,
     3          jclo,jchi,kclo-kregsz(level),kchi-kregsz(level),nghost)

c   for fine grids touching periodic boundary on bottom
          if  (zperdom .and. kclo .eq. 0 .and. khi .eq. kmax)
     1        call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,klo,khi,iclo,ichi,
     3          jclo,jchi,kclo+kregsz(level),kchi+kregsz(level),nghost)

 50     mkid = node(levelptr,mkid)
        go to 40
c
c  done with subgrid cycle. if no cells would need fixing, all done
c  else cycle through again to set up list with info. for bc processing
c
 60     continue
c
c  for now, leave unused space allocated to the grid. alternative is
c  to return (maxsp-ispot) amount starting at loc. node(cfluxptr,mpar)+ispot.
c
       mpar = node(levelptr,mpar)
       go to 30
c
 99    return
       end

c
c
c =========================================================
      subroutine src1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)
c =========================================================
      implicit real*8(a-h,o-z)
      dimension q(meqn, 1-mbc:mx+mbc)
c
      common /cparam/ rho,bulk,cc,zz   
      common /comsrc/ ndim
c
c     # source terms for radial symmetry
c
c     # ndim should be set in setprob.f
c     # ndim = 2  for cylindrical symmetry
c     # ndim = 3  for spherical symmetry
c
      do 10 i=1,mx+mbc
         xcell = xlower + (i-0.5d0)*dx
         q(1,i) = q(1,i) - dt*(ndim-1)*bulk/xcell * q(2,i)
   10    continue
c
      return
      end

! =============================================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =============================================================================
!
! Riemann problems for the 1D cubic equation q_t + (q^3)_x = 0.
!
! waves:     1
! equations: 1
!
! Conserved quantities:
!       1 q
!
! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
!
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q
!            (where the flux difference is f(qr(i-1)) - f(ql(i)))
!
! Note that the i'th Riemann problem has left state qr(:, i-1)
!                                    and right state ql(:, i)
! From the basic clawpack routine step1, rp is called with ql = qr = q.

    implicit none

    integer, intent(in) :: maxmx, meqn, mwaves, maux, mbc, mx
    double precision, dimension(meqn, 1-mbc:maxmx+mbc),         intent(in)  :: ql, qr
    double precision, dimension(maux, 1-mbc:maxmx+mbc),         intent(in)  :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxmx+mbc), intent(out) :: wave
    double precision, dimension(meqn, 1-mbc:maxmx+mbc),         intent(out) :: amdq, apdq
    double precision, dimension(mwaves, 1-mbc:maxmx+mbc),       intent(out) :: s

    integer :: i


    do i = 2-mbc, mx+mbc

        wave(1, 1, i) = ql(1, i) - qr(1, i-1)
        ! (ul^3 - ur^3) / (ul - ur) == ul^2 + ul*ur + ur^2
        s(1, i) = ql(1, i)*ql(1, i) + ql(1, i)*qr(1, i-1) + qr(1, i-1)*qr(1, i-1)

        amdq(1,i) = 0.d0
        apdq(1,i) = ql(1, i)*ql(1, i)*ql(1, i) - qr(1, i-1)*qr(1, i-1)*qr(1, i-1)

    enddo

    return
end

c
c
c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,xlower,ylower,
     &                   dx,dy,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c
c      # Data is piecewise constant with 4 values in 4 quadrants
c      # 2D Riemann problem from Figure 4 of
c        @article{csr-col-glaz,
c          author="C. W. Schulz-Rinne and J. P. Collins and H. M. Glaz",
c          title="Numerical Solution of the {R}iemann Problem for 
c                 Two-Dimensional Gas Dynamics",
c          journal="SIAM J. Sci. Comput.",
c          volume="14",
c          year="1993",
c          pages="1394-1414" }

c
       implicit double precision (a-h,o-z)
       dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
       dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
       dimension rpp(4),rpr(4),rpu(4),rpv(4)
       common /cparam/  gamma
c
       gamma1 = gamma - 1.d0
c
c      # First quadrant:
       rpp(1) = 1.5d0
       rpr(1) = 1.5d0
       rpu(1) = 0.d0
       rpv(1) = 0.d0
c
c      # Second quadrant:
       rpp(2) = 0.3d0
       rpr(2) = 0.532258064516129d0
       rpu(2) = 1.206045378311055d0
       rpv(2) = 0.0d0
c
c      # Third quadrant:
       rpp(3) = 0.029032258064516d0
       rpr(3) = 0.137992831541219d0
       rpu(3) = 1.206045378311055d0
       rpv(3) = 1.206045378311055d0
c
c      # Fourth quadrant:
       rpp(4) = 0.3d0
       rpr(4) = 0.532258064516129d0
       rpu(4) = 0.0d0
       rpv(4) = 1.206045378311055d0
c
c      # location of four corners:
       xs = .8d0
       ys = .8d0
c
       do 15 i=1,mx
          xcell = xlower + (i-0.5d0)*dx
          do 15 j=1,my
             ycell = ylower + (j-0.5d0)*dy
             if (xcell.ge.xs .and. ycell.ge.ys) iq = 1
             if (xcell.lt.xs .and. ycell.ge.ys) iq = 2
             if (xcell.lt.xs .and. ycell.lt.ys) iq = 3
             if (xcell.ge.xs .and. ycell.lt.ys) iq = 4
             q(1,i,j) = rpr(iq)
             q(2,i,j) = rpr(iq)*rpu(iq)
             q(3,i,j) = rpr(iq)*rpv(iq)
             q(4,i,j) = rpp(iq)/gamma1 + 0.5d0*rpr(iq)*(rpu(iq)**2 + 
     &                                  rpv(iq)**2)
   15        continue
       return
       end

c=========================================================================
      subroutine readqinit(mx,my,dx,dy,xlow,xhi,ylow,yhi,fname)
c=========================================================================

      use amr_module
      use qinit_module
      implicit double precision (a-h,o-z)

      character*150 fname

      logical foundFile


      inquire(file=fname,exist=foundFile)
      if (.not. foundFile) then
        write(*,*) 'You must provide a file ', fname
        stop
      endif

      write(6,*) '  '
      write(6,*) 'Reading qinit data from file  ', fname
      write(6,*) '  '

      write(parmunit,*) '  '
      write(parmunit,*) 'Reading qinit data from'
      write(parmunit,*) fname
      write(parmunit,*) '  '

      mpoints=0
      mx=0
      open(unit=19,
     &     file=fname,
     &     status='unknown',form='formatted')

c
c     # currently only supports one file type:
c     # x,y,z values, one per line in standard order from NW corner to SE
c     # z is perturbation from standard depth h,hu,hv set in qinit_geo,
c     # if iqinit = 1,2, or 3 respectively.
c     # if iqinit = 4, the z column corresponds to the definition of the 
c     # surface elevation eta. The depth is then set as q(i,j,1)=max(eta-b,0)

      read(19,end=20,fmt=*) x0,y0,z0
      mpoints=mpoints+1
      mx=mx+1
      qinitwork(mpoints)=z0
      x=x0

      do while (.true.)
           read(19,end=20,fmt=*) xnew,ynew,znew
           mpoints=mpoints+1
           qinitwork(mpoints)=znew
           if (xnew.gt.x) then
              mx=mx + 1
           else
              mx=1
           endif
        x=xnew
        y=ynew
        enddo

 20   continue


      close(unit=19)


      if (mpoints.gt.maxqinitsize) then
          write(*,*) 'SETQINIT: not enough workspace'
          write(*,*) 'Increase maxqinitsize to', mpoints
          write(*,*) 'in qinit.i, then recompile'
          Stop
      endif

      my= mpoints/mx
      xf=x
      yf=y
      dx=(xf-x0)/(mx-1)
      dy=-(yf-y0)/(my-1)

c      !Changes with new bilinear interp DLG 10/08:
c       below changed for new bilinear interpolation of auxiliary data
c       values are now noded based, no longer considered cell-centered
c      xlow = x0-.5d0*dx
c      yhi = y0+.5d0*dy
c      xhi = xf+.5d0*dx
c      ylow = yf-.5d0*dy

      xlow = x0
      yhi = y0
      xhi = xf
      ylow = yf

      return
      end

c
c
c     =====================================================
      subroutine flux2(ixy,maxm,meqn,maux,mbc,mx,
     &                 q1d,dtdx1d,aux1,aux2,aux3,
     &                 faddm,faddp,gaddm,gaddp,cfl1d,
     &                 rpn2,rpt2)
!!     &                 fwave,s,amdq,apdq,rpn2,rpt2)
c     =====================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c--------------------------------------------------------------------
c     # flux2fw is a modified version of flux2 to use fwave instead of wave.
c     # A modified Riemann solver rp2n must be used in conjunction with this
c     # routine, which returns fwave's instead of wave's.
c     # See http://amath.washington.edu/~claw/fwave.html
c
c     # Limiters are applied to the fwave's, and the only significant
c     # modification of this code is in the "do 119" loop, for the
c     # second order corrections.
c
c--------------------------------------------------------------------
c
c
c     # Compute the modification to fluxes f and g that are generated by
c     # all interfaces along a 1D slice of the 2D grid.
c     #    ixy = 1  if it is a slice in x
c     #          2  if it is a slice in y
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd and gadd.  The notation is written assuming
c     # we are solving along a 1D slice in the x-direction.
c
c     # fadd(i,.) modifies F to the left of cell i
c     # gadd(i,.,1) modifies G below cell i
c     # gadd(i,.,2) modifies G above cell i
c
c     # The method used is specified by method(2:3):
c
c         method(2) = 1 if only first order increment waves are to be used.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.
c
c         method(3) = 0 if no transverse propagation is to be applied.
c                       Increment and perhaps correction waves are propagated
c                       normal to the interface.
c                   = 1 if transverse propagation of increment waves
c                       (but not correction waves, if any) is to be applied.
c                   = 2 if transverse propagation of correction waves is also
c                       to be included.
c
c     Note that if mcapa>0 then the capa array comes into the second
c     order correction terms, and is already included in dtdx1d:
c     If ixy = 1 then
c        dtdx1d(i) = dt/dx                      if mcapa= 0
c                  = dt/(dx*aux(i,jcom,mcapa))  if mcapa = 1
c     If ixy = 2 then
c        dtdx1d(j) = dt/dy                      if mcapa = 0
c                  = dt/(dy*aux(icom,j,mcapa))  if mcapa = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn2 into
c            amdq =  the left-going flux difference  A^- Delta q
c            apdq = the right-going flux difference  A^+ Delta q
c        Each of these is split by rpt2 into
c            bmasdq = the down-going transverse flux difference B^- A^* Delta q
c            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
c        where A^* represents either A^- or A^+.
c

c      #  modifications for GeoClaw

c--------------------------flux2fw_geo.f--------------------------
c     This version of flux2fw.f is modified slightly to be used with
c     step2_geo.f  The only modification is for the first-order
c     mass fluxes, faddm(i,j,1) and faddp(i,j,1), so that those terms are true
c     interface fluxes.
c
c     The only change is in loop 40
c     to revert to the original version, set relimit = .false.
c---------------------last modified 1/04/05-----------------------------

      use amr_module, only: use_fwaves, mwaves, method
      use amr_module, only: mthlim
      use geoclaw_module, only: coordinate_system, earth_radius, deg2rad

      implicit double precision (a-h,o-z)

      external rpn2, rpt2
      dimension  q1d(meqn, 1-mbc:maxm+mbc)

      dimension  bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension  bpasdq(meqn, 1-mbc:maxm+mbc)
      dimension  cqxx(meqn, 1-mbc:maxm+mbc)
      dimension  faddm(meqn,1-mbc:maxm+mbc)
      dimension  faddp(meqn,1-mbc:maxm+mbc)
      dimension  gaddm(meqn,1-mbc:maxm+mbc, 2)
      dimension  gaddp(meqn,1-mbc:maxm+mbc, 2)
      dimension  dtdx1d(1-mbc:maxm+mbc)
      dimension  aux1(maux, 1-mbc:maxm+mbc)
      dimension  aux2(maux, 1-mbc:maxm+mbc)
      dimension  aux3(maux, 1-mbc:maxm+mbc)
c
      dimension  s(mwaves, 1-mbc:maxm+mbc)
      dimension  fwave(meqn, mwaves, 1-mbc:maxm+mbc)
      dimension  amdq(meqn, 1-mbc:maxm+mbc)
      dimension  apdq(meqn, 1-mbc:maxm+mbc)
c
      logical limit, relimit

      relimit = .false.
c
      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
   5     continue
c
c     # initialize flux increments:
c     -----------------------------
c

      do 30 jside=1,2
        do 20 i = 1-mbc, mx+mbc
          do 10 m=1,meqn
               faddm(m,i) = 0.d0
               faddp(m,i) = 0.d0
               gaddm(m,i,jside) = 0.d0
               gaddp(m,i,jside) = 0.d0
   10          continue
   20       continue
   30    continue

c
c
c     # solve Riemann problem at each interface and compute Godunov updates
c     ---------------------------------------------------------------------
c
      call rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &          aux2,aux2,fwave,s,amdq,apdq)

c
c   # Set fadd for the donor-cell upwind method (Godunov)
      if (ixy.eq.1) mu=2
      if (ixy.eq.2) mu=3
      do 40 i=1-mbc+1,mx+mbc-1
         if (coordinate_system.eq.2) then
              if (ixy.eq.1) then
                   dxdc=earth_radius*deg2rad
              else  
                  dxdc=earth_radius*cos(aux2(3,i))*deg2rad
!                  if (ixy.eq.2) dxdc=earth_radius*cos(aux2(3,i))*deg2rad  !why test again
              endif
         else
            dxdc=1.d0
         endif

          do m=1,meqn
            faddp(m,i) = faddp(m,i) - apdq(m,i)
            faddm(m,i) = faddm(m,i) + amdq(m,i)
          enddo
          if (relimit) then
            faddp(1,i) = faddp(1,i) + dxdc*q1d(mu,i)
            faddm(1,i) = faddp(1,i)
          endif
   40       continue
c
c     # compute maximum wave speed for checking Courant number:
      cfl1d = 0.d0
      do 50 mw=1,mwaves
         do 50 i=1,mx+1
c          # if s>0 use dtdx1d(i) to compute CFL,
c          # if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i),
     &                          -dtdx1d(i-1)*s(mw,i))

   50       continue
c
      if (method(2).eq.1) go to 130
c
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c
c     # apply limiter to fwaves:
      if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,fwave,s,mthlim)
c
      do 120 i = 1, mx+1
c
c        # For correction terms below, need average of dtdx in cell
c        # i-1 and i.  Compute these and overwrite dtdx1d:
c
         dtdx1d(i-1) = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
c
         do 120 m=1,meqn
            cqxx(m,i) = 0.d0
            do 119 mw=1,mwaves
c
c              # second order corrections:
               cqxx(m,i) = cqxx(m,i) + dsign(1.d0,s(mw,i))
     &            * (1.d0 - dabs(s(mw,i))*dtdx1d(i-1)) * fwave(m,mw,i)
c
  119          continue
            faddm(m,i) = faddm(m,i) + 0.5d0 * cqxx(m,i)
            faddp(m,i) = faddp(m,i) + 0.5d0 * cqxx(m,i)
  120       continue
c
c
  130  continue
c
       if (method(3).eq.0) go to 999   !# no transverse propagation
c
       if (method(2).gt.1 .and. method(3).eq.2) then
c         # incorporate cqxx into amdq and apdq so that it is split also.
          do 150 i = 1, mx+1
             do 150 m=1,meqn
                amdq(m,i) = amdq(m,i) + cqxx(m,i)
                apdq(m,i) = apdq(m,i) - cqxx(m,i)
  150           continue
          endif
c
c
c      # modify G fluxes for transverse propagation
c      --------------------------------------------
c
c
c     # split the left-going flux difference into down-going and up-going:
      call rpt2(ixy,1,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,
     &          amdq,bmasdq,bpasdq)
c
c     # modify flux below and above by B^- A^- Delta q and  B^+ A^- Delta q:
      do 160 i = 1, mx+1
         do 160 m=1,meqn
               gupdate = 0.5d0*dtdx1d(i-1) * bmasdq(m,i)
               gaddm(m,i-1,1) = gaddm(m,i-1,1) - gupdate
               gaddp(m,i-1,1) = gaddp(m,i-1,1) - gupdate
c
               gupdate = 0.5d0*dtdx1d(i-1) * bpasdq(m,i)
               gaddm(m,i-1,2) = gaddm(m,i-1,2) - gupdate
               gaddp(m,i-1,2) = gaddp(m,i-1,2) - gupdate
  160          continue
c
c     # split the right-going flux difference into down-going and up-going:
      call rpt2(ixy,2,maxm,meqn,mwaves,maux,mbc,mx,
     &          q1d,q1d,aux1,aux2,aux3,
     &          apdq,bmasdq,bpasdq)
c
c     # modify flux below and above by B^- A^+ Delta q and  B^+ A^+ Delta q:
      do 180 i = 1, mx+1
          do 180 m=1,meqn
               gupdate = 0.5d0*dtdx1d(i-1) * bmasdq(m,i)
               gaddm(m,i,1) = gaddm(m,i,1) - gupdate
               gaddp(m,i,1) = gaddp(m,i,1) - gupdate
c
               gupdate = 0.5d0*dtdx1d(i-1) * bpasdq(m,i)
               gaddm(m,i,2) = gaddm(m,i,2) - gupdate
               gaddp(m,i,2) = gaddp(m,i,2) - gupdate
  180          continue
c
  999 continue
      return
      end

! ==============================================================================
!  Regions Module
!   Module containing data structures and setup routines for region refinement.
!
! ==============================================================================
module regions_module

    implicit none
    save

    ! Region type definition (old style rectangles still supported for now)
    type region_type
        integer :: min_level,max_level
        real(kind=8) :: x_low,y_low,x_hi,y_hi,t_low,t_hi
    end type region_type

    ! New flag regions specified as Ruled Rectangles
    type ruled_region_type
        integer :: min_level,max_level, ixy, method, nrules
        real(kind=8) :: t_low,t_hi,ds
        real(kind=8) :: x1bb,x2bb,y1bb,y2bb  ! bounding box
        real(kind=8), allocatable, dimension(:) :: s, lower, upper
        character(len=200) :: file_name, name
    end type ruled_region_type

    logical, private :: module_setup

    ! old style regions:
    integer :: num_regions
    type(region_type), allocatable  :: regions(:)
      
    ! new style flagregions
    integer :: num_rregions
    type(ruled_region_type), target, allocatable :: rregions(:)
      
contains

    subroutine set_regions(fname)

        ! Read old-style rectangular regions from regions.data
        
        use amr_module
      
        implicit none
      
        ! Function Arguments
        character(len=*), optional, intent(in) :: fname
      
        ! Locals
        integer, parameter :: unit = 7
        integer :: i

        if (.not. module_setup) then

            write(parmunit,*) ' '
            write(parmunit,*) '--------------------------------------------'
            write(parmunit,*) 'REGIONS:'
            write(parmunit,*) '-----------'

            if (present(fname)) then
                call opendatafile(unit,fname)
            else
                call opendatafile(unit,'regions.data')
            endif

            read(unit,"(i2)") num_regions
            if (num_regions == 0) then
                write(parmunit,*) '  No regions specified for refinement'
                
            else
                ! Refinement region data
                allocate(regions(num_regions))
                do i=1,num_regions
                    read(unit,*) regions(i)%min_level, regions(i)%max_level, &
                                 regions(i)%t_low, regions(i)%t_hi, &
                                 regions(i)%x_low, regions(i)%x_hi, &
                                 regions(i)%y_low, regions(i)%y_hi
                enddo
            endif
            close(unit)

            call set_rregions()

            module_setup = .true.
        end if

    end subroutine set_regions


    subroutine set_rregions(fname)

        ! Read new-style Ruled Rectangles from flagregions.data
        
        use amr_module
      
        implicit none
      
        ! Function Arguments
        character(len=*), optional, intent(in) :: fname
      
        ! Locals
        integer, parameter :: unit = 7
        integer, parameter :: unit2 = 45
        integer :: i,j,nrules1, spatial_region_type
        logical :: foundFile
        type(ruled_region_type), pointer :: rr
        real(kind=8) :: rr_x1,rr_x2,rr_y1,rr_y2


        write(parmunit,*) ' '
        write(parmunit,*) '--------------------------------------------'
        write(parmunit,*) 'RULED REGIONS:'
        write(parmunit,*) '-----------'

        if (present(fname)) then
            call opendatafile(unit,fname)
        else
            call opendatafile(unit,'flagregions.data')
        endif

        read(unit,"(i2)") num_rregions
        if (num_rregions == 0) then
            write(parmunit,*) '  No ruled regions specified for refinement'
            
        else
            ! Refinement region data
            allocate(rregions(num_rregions))
            do i=1,num_rregions
                rr => rregions(i)
                read(unit,*) rr%name
                rr%name = trim(rr%name)
                read(unit,*) rr%min_level
                read(unit,*) rr%max_level
                read(unit,*) rr%t_low
                read(unit,*) rr%t_hi
                read(unit,*) spatial_region_type

                if (spatial_region_type == 1) then
                    ! read rectangle extent:
                    read(unit,*) rr_x1,rr_x2,rr_y1,rr_y2
                    ! turn into ruled rectangle:
                    rr%ixy = 1
                    rr%method = 0
                    rr%nrules = 2
                    allocate(rr%s(rr%nrules), rr%lower(rr%nrules), & 
                             rr%upper(rr%nrules))
                    rr%s(1) = rr_x1
                    rr%s(2) = rr_x2
                    rr%ds = rr_x2 - rr_x1
                    rr%lower(1) = rr_y1
                    rr%upper(1) = rr_y2
                    rr%lower(2) = rr_y1
                    rr%upper(2) = rr_y2
                
                else if (spatial_region_type == 2) then    
                    read(unit,*) rr%file_name
                    write(6,*) '+++ Ruled region name: ', rr%name
                    write(6,*) '+++ Ruled region file_name: ', rr%file_name
                    inquire(file=trim(rr%file_name),exist=foundFile)
                    if (.not. foundFile) then
                      write(*,*) 'Missing rregions file...'
                      write(*,*) 'Looking for: ',trim(rr%file_name)
                      stop
                      endif

                    open(unit=unit2,file=trim(rr%file_name),status='old')
                    read(unit2,*) rr%ixy
                    read(unit2,*) rr%method
                    read(unit2,*) rr%ds
                    read(unit2,*) rr%nrules
                    allocate(rr%s(rr%nrules), rr%lower(rr%nrules), & 
                             rr%upper(rr%nrules))
                    do j=1,rr%nrules
                        read(unit2,*) rr%s(j), rr%lower(j), rr%upper(j)
                        enddo
                        
                else
                    write(6,*) '*** Error: unexpected spatial_region_type'
                endif
                    
                ! compute bounding box:
                
                if (rr%method == 0) then
                    nrules1 = rr%nrules - 1
                else
                    nrules1 = rr%nrules
                    endif
                    
                if (rr%ixy == 1) then
                    rr%x1bb = rr%s(1)
                    rr%x2bb = rr%s(rr%nrules)
                    rr%y1bb = minval(rr%lower(1:nrules1))
                    rr%y2bb = maxval(rr%upper(1:nrules1))
                else
                    rr%y1bb = rr%s(1)
                    rr%y2bb = rr%s(rr%nrules)
                    rr%x1bb = minval(rr%lower(1:nrules1))
                    rr%x2bb = maxval(rr%upper(1:nrules1))
                    endif
                    
                write(6,*) '+++ rregion bounding box: '
                write(6,*) rr%x1bb,rr%x2bb,rr%y1bb,rr%y2bb
                
                write(6,*) '+++ i, rr%s(1), rr%ds: ',i, rr%s(1), rr%ds
                enddo
                
            endif
            close(unit)


    end subroutine set_rregions

end module regions_module

c
c
c     ==================================================================
      subroutine flux3(ixyz,maxm,meqn,maux,       mbc,mx,
     &                 q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3,
     &                 faddm,faddp,gadd,hadd,cfl1d,
     &                 wave,s,amdq,apdq,cqxx,
     &                 bmamdq,bmapdq,bpamdq,bpapdq,
     &                 cmamdq,cmapdq,cpamdq,cpapdq,
     &                 cmamdq2,cmapdq2,cpamdq2,cpapdq2,
     &                 bmcqxxm,bmcqxxp,bpcqxxm,bpcqxxp,
     &                 cmcqxxm,cmcqxxp,cpcqxxm,cpcqxxp,
     &                 bmcmamdq,bmcmapdq,bpcmamdq,bpcmapdq,
     &                 bmcpamdq,bmcpapdq,bpcpamdq,bpcpapdq,
     &                 rpn3,rpt3, rptt3)
c     ==================================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c     # Compute the modification to fluxes f, g and h that are generated by
c     # all interfaces along a 1D slice of the 3D grid.
c     #    ixyz = 1  if it is a slice in x
c     #           2  if it is a slice in y
c     #           3  if it is a slice in z
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd, gadd and hadd.  The notation is written
c     # assuming we are solving along a 1D slice in the x-direction.
c
c     # fadd(i,.) modifies F to the left of cell i
c     # gadd(i,.,1,slice) modifies G below cell i (in the z-direction)
c     # gadd(i,.,2,slice) modifies G above cell i
c     #                   The G flux in the surrounding slices may
c     #                   also be updated.
c     #                   slice  =  -1     The slice below in y-direction
c     #                   slice  =   0     The slice used in the 2D method
c     #                   slice  =   1     The slice above in y-direction
c     # hadd(i,.,1,slice) modifies H below cell i (in the y-direction)
c     # hadd(i,.,2,slice) modifies H above cell i
c     #                   The H flux in the surrounding slices may
c     #                   also be updated.
c     #                   slice  =  -1     The slice below in z-direction
c     #                   slice  =   0     The slice used in the 2D method
c     #                   slice  =   1     The slice above in z-direction
c     #
c     # The method used is specified by method(2) and method(3):
c
c        method(2) = 1 No correction waves
c                  = 2 if second order correction terms are to be added, with
c                      a flux limiter as specified by mthlim.  No transverse
c                      propagation of these waves.
c
c         method(3) specify how the transverse wave propagation
c         of the increment wave and the correction wave are performed.
c         Note that method(3) is given by a two digit number, in
c         contrast to what is the case for claw2. It is convenient
c         to define the scheme using the pair (method(2),method(3)).
c
c         method(3) <  0 Gives dimensional splitting using Godunov
c                        splitting, i.e. formally first order
c                        accurate.
c                      0 Gives the Donor cell method. No transverse
c                        propagation of neither the increment wave
c                        nor the correction wave.
c                   = 10 Transverse propagation of the increment wave
c                        as in 2D. Note that method (2,10) is
c                        unconditionally unstable.
c                   = 11 Corner transport upwind of the increment
c                        wave. Note that method (2,11) also is
c                        unconditionally unstable.
c                   = 20 Both the increment wave and the correction
c                        wave propagate as in the 2D case. Only to
c                        be used with method(2) = 2.
c                   = 21 Corner transport upwind of the increment wave,
c                        and the correction wave propagates as in 2D.
c                        Only to be used with method(2) = 2.
c                   = 22 3D propagation of both the increment wave and
c                        the correction wave. Only to be used with
c                        method(2) = 2.
c
c         Recommended settings:   First order schemes:
c                                       (1,10) Stable for CFL < 1/2
c                                       (1,11) Stable for CFL < 1
c                                 Second order schemes:
c                                        (2,20) Stable for CFL < 1/2
c                                        (2,22) Stable for CFL < 1
c
c         WARNING! The schemes (2,10), (2,11) are unconditionally
c                  unstable.
c
c                       ----------------------------------
c
c     Note that if method(6)=1 then the capa array comes into the second
c     order correction terms, and is already included in dtdx1d:
c     If ixyz = 1 then
c        dtdx1d(i) = dt/dx                      if method(6) = 0
c                  = dt/(dx*capa(i,jcom,kcom))  if method(6) = 1
c     If ixyz = 2 then
c        dtdx1d(j) = dt/dy                      if method(6) = 0
c                  = dt/(dy*capa(icom,j,kcom))  if method(6) = 1
c     If ixyz = 3 then
c        dtdx1d(k) = dt/dz                      if method(6) = 0
c                  = dt/(dz*capa(icom,jcom,k))  if method(6) = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn3 into
c            amdq =  the left-going flux difference  A^- Delta q
c            apdq = the right-going flux difference  A^+ Delta q
c        Each of these is split by rpt3 into
c            bmasdq = the down-going transverse flux difference B^- A^* Delta q
c            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
c        where A^* represents either A^- or A^+.
c
c        Finally, each bsasdq is split by rptt3 into :
c            cmbsasdq = C^- B^* A^* Dq
c            cpbsasdq = C^+ B^* A^* Dq
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3,rpt3, rptt3


      dimension     q1d(meqn,1-mbc:maxm+mbc)
      dimension    amdq(meqn,1-mbc:maxm+mbc)
      dimension    apdq(meqn,1-mbc:maxm+mbc)
      dimension  bmamdq(meqn,1-mbc:maxm+mbc)
      dimension  bmapdq(meqn,1-mbc:maxm+mbc)
      dimension  bpamdq(meqn,1-mbc:maxm+mbc)
      dimension  bpapdq(meqn,1-mbc:maxm+mbc)
      dimension    cqxx(meqn,1-mbc:maxm+mbc)
      dimension   faddm(meqn,1-mbc:maxm+mbc)
      dimension   faddp(meqn,1-mbc:maxm+mbc)
      dimension    gadd(meqn,1-mbc:maxm+mbc, 2, -1:1)
      dimension    hadd(meqn,1-mbc:maxm+mbc, 2, -1:1)
c
      dimension  cmamdq(meqn,1-mbc:maxm+mbc)
      dimension  cmapdq(meqn,1-mbc:maxm+mbc)
      dimension  cpamdq(meqn,1-mbc:maxm+mbc)
      dimension  cpapdq(meqn,1-mbc:maxm+mbc)
c
      dimension  cmamdq2(meqn,1-mbc:maxm+mbc)
      dimension  cmapdq2(meqn,1-mbc:maxm+mbc)
      dimension  cpamdq2(meqn,1-mbc:maxm+mbc)
      dimension  cpapdq2(meqn,1-mbc:maxm+mbc)
c
      dimension  bmcqxxm(meqn,1-mbc:maxm+mbc)
      dimension  bpcqxxm(meqn,1-mbc:maxm+mbc)
      dimension  bmcqxxp(meqn,1-mbc:maxm+mbc)
      dimension  bpcqxxp(meqn,1-mbc:maxm+mbc)
c
      dimension  cmcqxxm(meqn,1-mbc:maxm+mbc)
      dimension  cpcqxxm(meqn,1-mbc:maxm+mbc)
      dimension  cmcqxxp(meqn,1-mbc:maxm+mbc)
      dimension  cpcqxxp(meqn,1-mbc:maxm+mbc)

      dimension  bpcmamdq(meqn,1-mbc:maxm+mbc)
      dimension  bpcmapdq(meqn,1-mbc:maxm+mbc)
      dimension  bpcpamdq(meqn,1-mbc:maxm+mbc)
      dimension  bpcpapdq(meqn,1-mbc:maxm+mbc)
      dimension  bmcmamdq(meqn,1-mbc:maxm+mbc)
      dimension  bmcmapdq(meqn,1-mbc:maxm+mbc)
      dimension  bmcpamdq(meqn,1-mbc:maxm+mbc)
      dimension  bmcpapdq(meqn,1-mbc:maxm+mbc)
c
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux1(maux,1-mbc:maxm+mbc, 3)
      dimension aux2(maux,1-mbc:maxm+mbc, 3)
      dimension aux3(maux,1-mbc:maxm+mbc, 3)
c
      dimension    s(mwaves,1-mbc:maxm+mbc)
      dimension  wave(meqn,mwaves,1-mbc:maxm+mbc)
c
      logical limit
c#### common/comxyzt/dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom


      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
 5    continue
c     
c     # initialize flux increments:
c     -----------------------------
c     
      do 10 m=1,meqn
         do 10 i = 1-mbc, mx+mbc
            faddm(m,i) = 0.d0
            faddp(m,i) = 0.d0
            gadd(m,i,1,-1) = 0.d0
            gadd(m,i,1, 0) = 0.d0
            gadd(m,i,1, 1) = 0.d0
            hadd(m,i,1,-1) = 0.d0
            hadd(m,i,1, 0) = 0.d0
            hadd(m,i,1, 1) = 0.d0
            gadd(m,i,2,-1) = 0.d0
            gadd(m,i,2, 0) = 0.d0
            gadd(m,i,2, 1) = 0.d0
            hadd(m,i,2,-1) = 0.d0
            hadd(m,i,2, 0) = 0.d0
            hadd(m,i,2, 1) = 0.d0
 10      continue
c     
c     # local method parameters
         if (method(3) .lt. 0) then
            m3 = -1
            m4 = 0
         else
            m3 = method(3)/10
            m4 = method(3) - 10*m3
         endif
c     
c     -----------------------------------------------------------
c     # solve normal Riemann problem and compute Godunov updates
c     -----------------------------------------------------------
c     
c     # aux2(1-mbc,1,2) is the start of a 1d array now used by rpn3
c     
         if (maux > 0) then
            call rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &           aux2(1,1-mbc,2),aux2(1,1-mbc,2),
     &           wave,s,amdq,apdq)
         else
            call rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &           aux2,aux2,
     &           wave,s,amdq,apdq)
         endif
c     
c     # Set fadd for the donor-cell upwind method (Godunov)
         do 40 i=1,mx+1
         do 40 m=1,meqn
            faddp(m,i) = faddp(m,i) - apdq(m,i)
            faddm(m,i) = faddm(m,i) + amdq(m,i)
 40      continue
c     
c     # compute maximum wave speed for checking Courant number:
         cfl1d = 0.d0
         do 50 mw=1,mwaves
         do 50 i=1,mx+1
          !  cfl1d = dmax1(cfl1d,dtdx1d(i)*dabs(s(mw,i))) OLD WAY
 !          # if s>0 use dtdx1d(i) to compute CFL,
 !          # if s<0 use dtdx1d(i-1) to compute CFL:
           cfl1d = dmax1(cfl1d,  dtdx1d(i)*s(mw,i),
     .                          -dtdx1d(i-1)*s(mw,i))

 50      continue
c     
         if (method(2).eq.1) go to 130
c    
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c     
c     # apply limiter to waves:
         if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c     
         if (.not. use_fwaves) then

         do 120 i = 1, mx+1
c     
c     # For correction terms below, need average of dtdx in cell
c     # i-1 and i.  (overwriting dtdx1d(i-1) removed, and code below modified to agree 
c     # with classic flux3 by mjb, 12/16/2014.
            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
c     
            do 120 m=1,meqn
               cqxx(m,i) = 0.d0
               do 119 mw=1,mwaves
                  cqxx(m,i) = cqxx(m,i) + 0.5d0 * dabs(s(mw,i)) *
     &                 (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
 119           continue
               faddm(m,i) = faddm(m,i) + cqxx(m,i)
               faddp(m,i) = faddp(m,i) + cqxx(m,i)
 120        continue

         else
            do 122 i = 1, mx+1

            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i)) 
c
            do 122 m=1,meqn
               cqxx(m,i) = 0.d0
               do 121 mw=1,mwaves
                  cqxx(m,i) = cqxx(m,i) + 0.5d0 * dsign(1.d0, s(mw,i)) *
     &                 (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
 121           continue
               faddm(m,i) = faddm(m,i) + cqxx(m,i)
               faddp(m,i) = faddp(m,i) + cqxx(m,i)
 122        continue
         endif
c     
 130     continue
c     
         if( m3 .le. 0) return
c     
c     --------------------------------------------
c     # TRANSVERSE PROPAGATION
c     --------------------------------------------
c     
c     # split the left-going flux difference into down-going and up-going
c     # flux differences (in the y-direction).
c     
         call rpt3(ixyz,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &             q1d,q1d,aux1,aux2,aux3,amdq,bmamdq,bpamdq)
c     
c     # split the right-going flux difference into down-going and up-going
c     # flux differences (in the y-direction).
c     
         call rpt3(ixyz,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &             q1d,q1d,aux1,aux2,aux3,apdq,bmapdq,bpapdq)
c     
c     # split the left-going flux difference into down-going and up-going
c     # flux differences (in the z-direction).
c     
         call rpt3(ixyz,3,1,maxm,meqn,mwaves,maux,mbc,mx,
     &             q1d,q1d,aux1,aux2,aux3,amdq,cmamdq,cpamdq)
c     
c     # split the right-going flux difference into down-going and up-going
c     # flux differences (in the y-direction).
c     
         call rpt3(ixyz,3,2,maxm,meqn,mwaves,maux,mbc,mx,
     &             q1d,q1d,aux1,aux2,aux3,apdq,cmapdq,cpapdq)
c     
c     # Split the correction wave into transverse propagating waves
c     # in the y-direction and z-direction.
c     
          if (m3.eq.2) then
             if (maux .gt. 0) then
c     # The corrections cqxx affect both cell i-1 to left and cell i
c     # to right of interface.  Transverse splitting will affect
c     # fluxes on both sides.
c     # If there are aux arrays, then we must split cqxx twice in
c     # each transverse direction, once with imp=1 and once with imp=2:

c     # imp = 1 or 2 is used to indicate whether we are propagating
c     # amdq or apdq, i.e. cqxxm or cqxxp


c     # in the y-like direction with imp=1
               call rpt3(ixyz,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

c     # in the y-like direction with imp=2
               call rpt3(ixyz,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxp,bpcqxxp)

c     # in the z-like direction with imp=1
               call rpt3(ixyz,3,1,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxm,cpcqxxm)

c     # in the z-like direction with imp=2
               call rpt3(ixyz,3,2,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxp,cpcqxxp)
            else
c     # aux arrays aren't being used, so we only need to split
c     # cqxx once in each transverse direction and the same result can
c     # presumably be used to left and right.
c     # Set imp = 0 since this shouldn't be needed in rpt3 in this case.

c     # in the y-like direction
               call rpt3(ixyz,2,0,maxm,meqn,mwaves,maux,mbc,mx,
     &               q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

c     # in the z-like direction
               call rpt3(ixyz,3,0,maxm,meqn,mwaves,maux,mbc,mx,
     &                   q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxm,cpcqxxm)

c     # use the same splitting to left and right:
               do i = 0,mx+2
               do m = 1,meqn
                   bmcqxxp(m,i) = bmcqxxm(m,i)
                   bpcqxxp(m,i) = bpcqxxm(m,i)
                   cmcqxxp(m,i) = cmcqxxm(m,i)
                   cpcqxxp(m,i) = cpcqxxm(m,i)
               enddo
               enddo
             endif
          endif

c     --------------------------------------------
c     # modify G fluxes in the y-like direction
c     --------------------------------------------
c     
c     # If the correction wave also propagates in a 3D sense, incorporate
c     # cpcqxx,... into cmamdq, cpamdq, ... so that it is split also.
c     
          if(m4 .eq. 1)then
             do 145 i = 0, mx+2
             do 145 m = 1, meqn
                cpapdq2(m,i) = cpapdq(m,i)
                cpamdq2(m,i) = cpamdq(m,i)
                cmapdq2(m,i) = cmapdq(m,i)
                cmamdq2(m,i) = cmamdq(m,i)
 145         continue
          else if(m4 .eq. 2)then
             do 146 i = 0, mx+2
             do 146 m = 1, meqn
                cpapdq2(m,i) = cpapdq(m,i) - 3.d0*cpcqxxp(m,i)
                cpamdq2(m,i) = cpamdq(m,i) + 3.d0*cpcqxxm(m,i)
                cmapdq2(m,i) = cmapdq(m,i) - 3.d0*cmcqxxp(m,i)
                cmamdq2(m,i) = cmamdq(m,i) + 3.d0*cmcqxxm(m,i)
 146         continue
          endif
c     
c     # The transverse flux differences in the z-direction are split
c     # into waves propagating in the y-direction. If m4 = 2,
c     # then the transverse propagating correction waves in the z-direction
c     # are also split. This yields terms of the form BCAu_{xzy} and
c     # BCAAu_{xxzy}.
c     
         if( m4.gt.0 )then
           call rptt3(ixyz,2,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,cpapdq2,
     &                bmcpapdq,bpcpapdq)
           call rptt3(ixyz,2,1,2,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,cpamdq2,
     &                bmcpamdq,bpcpamdq)
           call rptt3(ixyz,2,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,cmapdq2,
     &                bmcmapdq,bpcmapdq)
           call rptt3(ixyz,2,1,1,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,cmamdq2,
     &                bmcmamdq,bpcmamdq)
         endif
c     
c     -----------------------------
c     # The updates for G fluxes :
c     -----------------------------
c     
         do 180 i = 1, mx+1
         do 180 m=1,meqn
c     
c     # Transverse propagation of the increment waves
c     # between cells sharing interfaces, i.e. the 2D approach.
c     # Yields BAu_{xy}.
c     
            gadd(m,i-1,1,0) = gadd(m,i-1,1,0)
     &                       - 0.5d0*dtdx1d(i-1)*bmamdq(m,i)
            gadd(m,i-1,2,0) = gadd(m,i-1,2,0)
     &                       - 0.5d0*dtdx1d(i-1)*bpamdq(m,i)
            gadd(m,i,1,0)   = gadd(m,i,1,0)
     &                       - 0.5d0*dtdx1d(i)*bmapdq(m,i)
            gadd(m,i,2,0)   = gadd(m,i,2,0)
     &                       - 0.5d0*dtdx1d(i)*bpapdq(m,i)
c     
c     # Transverse propagation of the increment wave (and the
c     # correction wave if m4=2) between cells
c     # only having a corner or edge in common. Yields terms of the
c     # BCAu_{xzy} and BCAAu_{xxzy}.
c     
             if( m4.gt.0 )then
c     
                gadd(m,i,2,0) = gadd(m,i,2,0)
     &                          + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                          * (bpcpapdq(m,i) - bpcmapdq(m,i))
                gadd(m,i,1,0) = gadd(m,i,1,0)
     &                          + (1.d0/6.d0)*dtdx1d(i)*dtdz
     &                          * (bmcpapdq(m,i) - bmcmapdq(m,i))

                gadd(m,i,2,1) = gadd(m,i,2,1)
     &                          - (1.d0/6.d0)*dtdx1d(i)*dtdz
     &                          * bpcpapdq(m,i)
                gadd(m,i,1,1) = gadd(m,i,1,1)
     &                           - (1.d0/6.d0)*dtdx1d(i)*dtdz
     &                           * bmcpapdq(m,i)
                gadd(m,i,2,-1) = gadd(m,i,2,-1)
     &                           + (1.d0/6.d0)*dtdx1d(i)*dtdz
     &                           * bpcmapdq(m,i)
                gadd(m,i,1,-1) = gadd(m,i,1,-1)
     &                           + (1.d0/6.d0)*dtdx1d(i)*dtdz
     &                           * bmcmapdq(m,i)
c     
                gadd(m,i-1,2,0) = gadd(m,i-1,2,0)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                           * (bpcpamdq(m,i) - bpcmamdq(m,i))
                gadd(m,i-1,1,0) = gadd(m,i-1,1,0)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                           * (bmcpamdq(m,i) - bmcmamdq(m,i))

                gadd(m,i-1,2,1) = gadd(m,i-1,2,1)
     &                           - (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                           * bpcpamdq(m,i)
                gadd(m,i-1,1,1) = gadd(m,i-1,1,1)
     &                           - (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                           * bmcpamdq(m,i)
                gadd(m,i-1,2,-1) = gadd(m,i-1,2,-1)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                           * bpcmamdq(m,i)
                gadd(m,i-1,1,-1) = gadd(m,i-1,1,-1)
     &                           + (1.d0/6.d0)*dtdx1d(i-1)*dtdz
     &                           * bmcmamdq(m,i)
c     
             endif
c     
c     # Transverse propagation of the correction wave between
c     # cells sharing faces. This gives BAAu_{xxy}.
c     
             if(m3.lt.2) go to 180
                 gadd(m,i,2,0)   = gadd(m,i,2,0)
     &                             + dtdx1d(i)*bpcqxxp(m,i)
                 gadd(m,i,1,0)   = gadd(m,i,1,0)
     &                             + dtdx1d(i)*bmcqxxp(m,i)
                 gadd(m,i-1,2,0) = gadd(m,i-1,2,0)
     &                             - dtdx1d(i-1)*bpcqxxm(m,i)
                 gadd(m,i-1,1,0) = gadd(m,i-1,1,0)
     &                             - dtdx1d(i-1)*bmcqxxm(m,i)
c     
 180                       continue
c     
c     
c     --------------------------------------------
c     # modify H fluxes in the z-like direction
c     --------------------------------------------
c     
c     # If the correction wave also propagates in a 3D sense, incorporate
c     # cqxx into bmamdq, bpamdq, ... so that is is split also.
c     
             if (m4 .eq. 2) then
                do 155 i = 0, mx+2
                do 155 m = 1, meqn
                  bpapdq(m,i) = bpapdq(m,i) - 3.d0*bpcqxxp(m,i)
                  bpamdq(m,i) = bpamdq(m,i) + 3.d0*bpcqxxm(m,i)
                  bmapdq(m,i) = bmapdq(m,i) - 3.d0*bmcqxxp(m,i)
                  bmamdq(m,i) = bmamdq(m,i) + 3.d0*bmcqxxm(m,i)
 155            continue
              endif
c     
c     # The transverse flux differences in the y-direction are split
c     # into waves propagating in the z-direction. If m4 = 2,
c     # then the transverse propagating correction waves in the y-direction
c     # are also split. This yields terms of the form BCAu_{xzy} and
c     # BCAAu_{xxzy}.
c     
c     # Note that the output to rptt3 below should logically be named
c     # cmbsasdq and cpbsasdq rather than bmcsasdq and bpcsasdq, but
c     # we are re-using the previous storage rather than requiring new arrays.
c     
          if (m4.gt.0) then
           call rptt3(ixyz,3,2,2,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,bpapdq,bmcpapdq,bpcpapdq)
           call rptt3(ixyz,3,1,2,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,bpamdq,bmcpamdq,bpcpamdq)
           call rptt3(ixyz,3,2,1,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,bmapdq,bmcmapdq,bpcmapdq)
           call rptt3(ixyz,3,1,1,maxm,meqn,mwaves,maux,mbc,mx,
     &                q1d,q1d,aux1,aux2,aux3,bmamdq,bmcmamdq,bpcmamdq)
          endif
c     
c     -----------------------------
c     # The updates for H fluxes :
c     -----------------------------
c     
        do 200 i = 1, mx+1
        do 200 m = 1,meqn
c     
c     # Transverse propagation of the increment waves
c     # between cells sharing interfaces, i.e. the 2D approach.
c     # Yields CAu_{xy}.
c     
           hadd(m,i-1,1,0) = hadd(m,i-1,1,0)
     &                      - 0.5d0*dtdx1d(i-1)*cmamdq(m,i)
           hadd(m,i-1,2,0) = hadd(m,i-1,2,0)
     &                      - 0.5d0*dtdx1d(i-1)*cpamdq(m,i)
           hadd(m,i,1,0)   = hadd(m,i,1,0)
     &                      - 0.5d0*dtdx1d(i)*cmapdq(m,i)
           hadd(m,i,2,0)   = hadd(m,i,2,0)
     &                      - 0.5d0*dtdx1d(i)*cpapdq(m,i)
c     
c     # Transverse propagation of the increment wave (and the
c     # correction wave if m4=2) between cells
c     # only having a corner or edge in common. Yields terms of the
c     # CBAu_{xzy} and CBAAu_{xxzy}.
c     
          if( m4.gt.0 )then
c     
             hadd(m,i,2,0)  = hadd(m,i,2,0)
     &                            + (1.d0/6.d0)*dtdx1d(i)*dtdy
     &                            * (bpcpapdq(m,i) - bpcmapdq(m,i))
             hadd(m,i,1,0)  = hadd(m,i,1,0)
     &                            + (1.d0/6.d0)*dtdx1d(i)*dtdy
     &                            * (bmcpapdq(m,i) - bmcmapdq(m,i))

             hadd(m,i,2,1)  = hadd(m,i,2,1)
     &                            - (1.d0/6.d0)*dtdx1d(i)*dtdy
     &                            * bpcpapdq(m,i)
             hadd(m,i,1,1)  = hadd(m,i,1,1)
     &                            - (1.d0/6.d0)*dtdx1d(i)*dtdy
     &                            * bmcpapdq(m,i)
             hadd(m,i,2,-1) = hadd(m,i,2,-1)
     &                            + (1.d0/6.d0)*dtdx1d(i)*dtdy
     &                            * bpcmapdq(m,i)
             hadd(m,i,1,-1) = hadd(m,i,1,-1)
     &                            + (1.d0/6.d0)*dtdx1d(i)*dtdy
     &                            * bmcmapdq(m,i)
c     
             hadd(m,i-1,2,0)  = hadd(m,i-1,2,0)
     &                            + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                            * (bpcpamdq(m,i) - bpcmamdq(m,i))
             hadd(m,i-1,1,0)  = hadd(m,i-1,1,0)
     &                            + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                            * (bmcpamdq(m,i) - bmcmamdq(m,i))

             hadd(m,i-1,2,1)  = hadd(m,i-1,2,1)
     &                            - (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                            * bpcpamdq(m,i)
             hadd(m,i-1,1,1)  = hadd(m,i-1,1,1)
     &                            - (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                            * bmcpamdq(m,i)
             hadd(m,i-1,2,-1) = hadd(m,i-1,2,-1)
     &                            + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                            * bpcmamdq(m,i)
             hadd(m,i-1,1,-1) = hadd(m,i-1,1,-1)
     &                            + (1.d0/6.d0)*dtdx1d(i-1)*dtdy
     &                            * bmcmamdq(m,i)
c     
           endif
c     
c     # Transverse propagation of the correction wave between
c     # cells sharing faces. This gives CAAu_{xxy}.
c     
           if(m3.lt.2) go to 200
           hadd(m,i,2,0)   = hadd(m,i,2,0)
     &                        + dtdx1d(i)*cpcqxxp(m,i)
           hadd(m,i,1,0)   = hadd(m,i,1,0)
     &                        + dtdx1d(i)*cmcqxxp(m,i)
           hadd(m,i-1,2,0) = hadd(m,i-1,2,0)
     &                        - dtdx1d(i-1)*cpcqxxm(m,i)
           hadd(m,i-1,1,0) = hadd(m,i-1,1,0)
     &                        - dtdx1d(i-1)*cmcqxxm(m,i)
c     
 200    continue
c     
       return
       end

! ============================================
subroutine setaux(maxmx,maxmy,num_ghost,mx,my,xlower,ylower,dxc,dyc, &
                  num_aux,aux,Rsphere)
! ============================================

! Set auxiliary arrays for shallow water equations on the sphere.

! On input: (xc(i),yc(j)) gives uniformly spaced computational grid.
! On output: he aux array has the following elements:
!         1  kappa = ratio of cell area to dxc*dyc
!         2  enx = x-component of normal vector to left edges in tangent plane
!         3  eny = y-component of normal vector to left edges in tangent plane
!         4  enz = z-component of normal vector to left edges in tangent plane
!         5  etx = x-component of tangent vector to left edges in tangent plane
!         6  ety = y-component of tangent vector to left edges in tangent plane
!         7  etz = z-component of tangent vector to left edges in tangent plane
!         8  enx = x-component of normal vector to bottom edges in tangent plane
!         9  eny = y-component of normal vector to bottom edges in tangent plane
!        10  enz = z-component of normal vector to bottom edges in tangent plane
!        11  etx = x-component of tangent vector to bottom edges in tangent plane
!        12  ety = y-component of tangent vector to bottom edges in tangent plane
!        13  etz = z-component of tangent vector to bottom edges in tangent plane
!        14  erx = x-component of unit vector in radial direction at cell ctr
!        15  ery = y-component of unit vector in radial direction at cell ctr
!        16  erz = z-component of unit vector in radial direction at cell ctr


    implicit double precision (a-h,o-z)
    !parameter (maxm3 = 1005)
    dimension xc(-num_ghost:maxmx+num_ghost), yc(-num_ghost:maxmx+num_ghost)
    dimension xp(-num_ghost:maxmx+num_ghost,-num_ghost:maxmx+num_ghost)
    dimension yp(-num_ghost:maxmx+num_ghost,-num_ghost:maxmx+num_ghost)
    dimension zp(-num_ghost:maxmx+num_ghost,-num_ghost:maxmx+num_ghost)
    dimension theta(-num_ghost:maxmx+num_ghost,-num_ghost:maxmx+num_ghost)
    dimension phi(-num_ghost:maxmx+num_ghost,-num_ghost:maxmx+num_ghost)
    dimension aux(num_aux,1-num_ghost:maxmx+num_ghost,1-num_ghost:maxmy+num_ghost)

!f2py integer intent(in) maxmx
!f2py integer intent(in) maxmy
!f2py integer intent(in) num_ghost
!f2py integer intent(in) mx
!f2py integer intent(in) my
!f2py double precision intent(in) xlower
!f2py double precision intent(in) ylower
!f2py double precision intent(in) dx
!f2py double precision intent(in) dy
!f2py integer optional, intent(in)  num_aux
!f2py intent(in,out) aux
!f2py double precision intent(in) Rsphere

    pi = 4.d0*datan(1.d0)

    ! Set xc and yc so that (xc(i),yc(j)) is the
    ! lower left corner of (i,j) cell in computational space:

    do i=1-num_ghost,mx+num_ghost+1
        xc(i) = xlower + (i-1.d0) * dxc
    end do

    do j=1-num_ghost,my+num_ghost+1
        yc(j) = ylower + (j-1.d0) * dyc
    end do

    ! compute cell corners on sphere and angles phi, theta
    ! related to latitude and longitude

    do j=1-num_ghost,my+num_ghost+1
        do i=1-num_ghost,mx+num_ghost+1

            ! map computational point to (xp,yp,zp) on sphere:
            call mapc2p(xc(i),yc(j),xp(i,j),yp(i,j),zp(i,j),Rsphere)

            ! compute longitude theta from positive x axis:
            r = dsqrt(xp(i,j)**2 + yp(i,j)**2)

            ! theta(i,j) = atan2(xp(i,j),yp(i,j))

            if (r > 1.d-4) then
                theta(i,j) = dacos(xp(i,j)/r)
            elseif (yp(i,j) > 0.d0) then
                theta(i,j) = 0.d0
            endif
            if (yp(i,j) < 0.d0) then
                theta(i,j) = -theta(i,j)
            endif
            ! compute phi, angle down from north pole:
            if (zp(i,j) > 0.d0) then
                phi(i,j) = pi/2.d0 - dacos(r/Rsphere)
            else
                phi(i,j) = pi/2.d0 + dacos(r/Rsphere)
            endif
        end do
    end do


    do j=1-num_ghost,my+num_ghost
        do i=1-num_ghost,mx+num_ghost
        
            ! compute normal and tangent vectors to left edges (in tangent plane)
        
            ! tangent vector is edges vector:
            etx = xp(i,j+1) - xp(i,j)
            ety = yp(i,j+1) - yp(i,j)
            etz = zp(i,j+1) - zp(i,j)
            aux(5,i,j) = etx
            aux(6,i,j) = ety
            aux(7,i,j) = etz

            ! normal to sphere in radial direction at midpoint of edges:
            erx = 0.5d0*(xp(i,j) + xp(i,j+1))
            ery = 0.5d0*(yp(i,j) + yp(i,j+1))
            erz = 0.5d0*(zp(i,j) + zp(i,j+1))
        
            ! normal to edges in tangent plane is cross product of et and er:
            enx = ety*erz - etz*ery
            eny = etz*erx - etx*erz
            enz = etx*ery - ety*erx
            ennorm = dsqrt(enx**2 + eny**2 + enz**2)
            aux(2,i,j) = enx/ennorm
            aux(3,i,j) = eny/ennorm
            aux(4,i,j) = enz/ennorm


            ! compute normal and tangent vectors to bottom edges (in tang. pl.)
        
            ! tangent vector is edges vector:
            etx = xp(i+1,j) - xp(i,j)
            ety = yp(i+1,j) - yp(i,j)
            etz = zp(i+1,j) - zp(i,j)
            aux(11,i,j) = etx
            aux(12,i,j) = ety
            aux(13,i,j) = etz

            ! normal to sphere in radial direction at midpoint of edges:
            erx = 0.5d0*(xp(i,j) + xp(i+1,j))
            ery = 0.5d0*(yp(i,j) + yp(i+1,j))
            erz = 0.5d0*(zp(i,j) + zp(i+1,j))
        
            ! normal to edges in tangent plane is cross product of er and et:
            enx = ery*etz - erz*ety
            eny = erz*etx - erx*etz
            enz = erx*ety - ery*etx
            ennorm = dsqrt(enx**2 + eny**2 + enz**2)
            aux(8,i,j) = enx/ennorm
            aux(9,i,j) = eny/ennorm
            aux(10,i,j) = enz/ennorm

            ! normal to sphere in radial direction at cell centers:
            xcm = xlower+(i-0.5)*dxc
            ycm = ylower+(j-0.5)*dyc
            call mapc2p(xcm,ycm,xpm,ypm,zpm,Rsphere)

            aux(14,i,j) = xpm
            aux(15,i,j) = ypm
            aux(16,i,j) = zpm

            ! compute area of physical cell from four corners:
            ! find area on the sphere of two spherical triangles obtained
            ! by subdividing rectangle.  See
            !    http://mathforum.org/library/drmath/view/65316.html

            ! corners are labeled
            !      1: (i,j)      2: (i+1,j)    3: (i,j+1)    4: (i+1,j+1)

            beta12 = dsin(phi(i,j))*dsin(phi(i+1,j))* &
                dcos(theta(i,j) - theta(i+1,j)) &
                + dcos(phi(i,j))*dcos(phi(i+1,j))
            beta23 = dsin(phi(i,j+1))*dsin(phi(i+1,j))* &
                dcos(theta(i,j+1) - theta(i+1,j)) &
                + dcos(phi(i,j+1))*dcos(phi(i+1,j))
            beta13 = dsin(phi(i,j+1))*dsin(phi(i,j))* &
                dcos(theta(i,j+1) - theta(i,j)) &
                + dcos(phi(i,j+1))*dcos(phi(i,j))
            beta24 = dsin(phi(i+1,j+1))*dsin(phi(i+1,j))* &
                dcos(theta(i+1,j+1) - theta(i+1,j)) &
                + dcos(phi(i+1,j+1))*dcos(phi(i+1,j))
            beta34 = dsin(phi(i+1,j+1))*dsin(phi(i,j+1))* &
                dcos(theta(i+1,j+1) - theta(i,j+1)) &
                + dcos(phi(i+1,j+1))*dcos(phi(i,j+1))

            ! great circles distances between corners:
            d12 = Rsphere * dacos(beta12)
            d23 = Rsphere * dacos(beta23)
            d13 = Rsphere * dacos(beta13)
            d24 = Rsphere * dacos(beta24)
            d34 = Rsphere * dacos(beta34)

            s123 = 0.5d0 * (d12 + d23 + d13)
            s234 = 0.5d0 * (d23 + d34 + d24)

            ! spherical excess for each triangle:
            t123 = dtan(s123/2.d0)*dtan((s123-d12)/2.d0) &
                *dtan((s123-d23)/2.d0)*dtan((s123-d13)/2.d0)
            t123 = dmax1(t123,0.d0)
            E123 = 4.d0*datan(sqrt(t123))

            t234 = dtan(s234/2.d0)*dtan((s234-d23)/2.d0) &
                *dtan((s234-d34)/2.d0)*dtan((s234-d24)/2.d0)
            t234 = dmax1(t234,0.d0)
            E234 = 4.d0*datan(sqrt(t234))

            ! = Rsphere**2 * (E123 + E234)
            area = (E123 + E234)
        
            ! capacity kappa:
            aux(1,i,j) = area / (dxc*dyc)
                       
        end do
    end do

    return
end subroutine setaux

!=========================================================
subroutine rp1(maxmx, meqn, mwaves, maux, mbc, mx, ql, qr, auxl, auxr, wave, s, amdq, apdq)
!=========================================================
!
! Roe-solver for the 1D ideal MHD equations
!
! waves:     7
! equations: 8
!
! Conserved quantities:
!       1 density
!       2 momentum, x
!       3 momentum, y
!       4 momentum, z
!       5 energy
!       6 magnetic field, x
!       7 magnetic field, y
!       8 magnetic field, z
!
! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
!
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q
!            (where the flux difference is f(qr(i-1)) - f(ql(i)))
!
! With the Roe solver we have
!   amdq  =  A^- \Delta q    and    apdq  =  A^+ \Delta q
! where A is the Roe matrix.
! An entropy fix can also be incorporated into the flux differences.
!
! Note that the i'th Riemann problem has left state qr(:, i-1)
!                                    and right state ql(:, i)
! From the basic clawpack routine step1, rp is called with ql = qr = q.


    implicit none

    integer, intent(in) :: maxmx, meqn, mwaves, maux, mbc, mx
    double precision, dimension(meqn, 1-mbc:maxmx+mbc),         intent(in)  :: ql, qr
    double precision, dimension(maux, 1-mbc:maxmx+mbc),         intent(in)  :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxmx+mbc), intent(out) :: wave
    double precision, dimension(meqn, 1-mbc:maxmx+mbc),         intent(out) :: amdq, apdq
    double precision, dimension(mwaves, 1-mbc:maxmx+mbc),       intent(out) :: s

    ! meqn == 8, mwaves == 7
    double precision, dimension(meqn)        :: fl, fr, df
    double precision, dimension(4)           :: eigl, eigr
    double precision, dimension(mwaves)      :: stmp
    double precision, dimension(meqn,mwaves) :: rr
    double precision, dimension(mwaves,meqn) :: rl
    double precision, dimension(mwaves)      :: alpha, beta

    integer ixy, i, mu1, mu2, mb1, mb2, m1, m2, mm, mflag
    double precision gamma, gamma1
    double precision rho, rhol, rhor, u1, u1l, u1r, u2, u2l, u2r, u3, u3l, u3r, El, Er, p, pl, pr
    double precision B1, B1l, B1r, B2, B2l, B2r, B3, B3l, B3r
    double precision sl, sr, qs


    logical efix

    common /cparam/ gamma, gamma1


    ! use entropy fix for transonic rarefactions
    data efix /.true./

    ixy = 1
    if (ixy == 1) then
        mu1 = 2
        mu2 = 3
        mb1 = 6
        mb2 = 7
    elseif (ixy == 2) then
        mu1 = 3
        mu2 = 2
        mb1 = 7
        mb2 = 6
    endif

    do i = 2-mbc, mx+mbc
        ! Left and right states
        rhol = qr(1, i-1)
        rhor = ql(1, i  )

        ! There is an issue with uninitialized states at the far left and right ghost cells for sharpclaw.
        ! David Ketcheson will open an issue in pyclaw
        if (i > 3-mbc .and. i < mx+mbc-1 .and. (rhol <= 1.d-15 .or. isnan(rhol) .or. rhor <= 1.d-15 .or. isnan(rhor))) then
            print*, ' '
            print*, ' ERROR in RPN:  rhol = ', rhol
            print*, ' ERROR in RPN:  rhor = ', rhor
            print*, '                Cell = ', i
            print*, '             maxmx   = ', maxmx
            print*, '             meqn    = ', meqn
            print*, '             mwaves  = ', mwaves
            print*, '             maux    = ', maux
            print*, '             mbc     = ', mbc
            print*, '             mx      = ', mx
            print*, ' '
            stop
        endif

        u1l = qr(mu1, i-1) / rhol
        u2l = qr(mu2, i-1) / rhol
        u3l = qr(4,   i-1) / rhol
        El  = qr(5,   i-1)
        B1l = qr(mb1, i-1)
        B2l = qr(mb2, i-1)
        B3l = qr(8,   i-1)
        pl  = gamma1 * (El - 0.5d0 * rhol * (u1l**2 + u2l**2 + u3l**2) - 0.5d0 * (B1l**2 + B2l**2 + B3l**2))

        u1r = ql(mu1, i  ) / rhor
        u2r = ql(mu2, i  ) / rhor
        u3r = ql(4,   i  ) / rhor
        Er  = ql(5,   i  )
        B1r = ql(mb1, i  )
        B2r = ql(mb2, i  )
        B3r = ql(8,   i  )
        pr  = gamma1 * (Er - 0.5d0 * rhor * (u1r**2 + u2r**2 + u3r**2) - 0.5d0 * (B1r**2 + B2r**2 + B3r**2))

        if (i > 3-mbc .and. i < mx+mbc-1 .and. (pl <= 1.d-15 .or. isnan(pl) .or. pr <= 1.d-15 .or. isnan(pr))) then
            print*, ' '
            print*, ' ERROR in RPN:  pl = ', pl
            print*, ' ERROR in RPN:  pr = ', pr
            print*, '                Cell = ', i
            print*, '             maxmx   = ', maxmx
            print*, '             meqn    = ', meqn
            print*, '             mwaves  = ', mwaves
            print*, '             maux    = ', maux
            print*, '             mbc     = ', mbc
            print*, '             mx      = ', mx
            print*, ' '
            stop
        endif

        ! Average states
        rho = 0.5d0 * (rhol + rhor)
        u1  = 0.5d0 * (u1l + u1r)
        u2  = 0.5d0 * (u2l + u2r)
        u3  = 0.5d0 * (u3l + u3r)
        p   = 0.5d0 * (pl + pr)
        B1  = 0.5d0 * (B1l + B1r)
        B2  = 0.5d0 * (B2l + B2r)
        B3  = 0.5d0 * (B3l + B3r)

        ! Delta f
        call set_flux_fun(mu1, mu2, mb1, mb2, rhol, u1l, u2l, u3l, pl, B1l, B2l, B3l, El, fl)
        call set_flux_fun(mu1, mu2, mb1, mb2, rhor, u1r, u2r, u3r, pr, B1r, B2r, B3r, Er, fr)
        do m1 = 1, meqn
            df(m1) = fr(m1) - fl(m1)
        enddo

        ! Wave Speeds
        do mm = 1, mwaves
            stmp(mm) = 0.d0
        enddo
        call set_wave_spd(rhol, u1l, u2l, u3l, pl, B1l, B2l, B3l, gamma, stmp)
        eigl(1) = stmp(1)
        eigl(2) = stmp(3)
        eigl(3) = stmp(5)
        eigl(4) = stmp(7)
        call set_wave_spd(rhor, u1r, u2r, u3r, pr, B1r, B2r, B3r, gamma, stmp)
        eigr(1) = stmp(1)
        eigr(2) = stmp(3)
        eigr(3) = stmp(5)
        eigr(4) = stmp(7)
        call set_wave_spd(rho, u1, u2, u3, p, B1, B2, B3, gamma, stmp)
        do m1 = 1, mwaves
          s(m1, i) = stmp(m1)
        enddo

        ! Right Eigenvectors (row,column)
        call set_rght_eig(mu1, mu2, mb1, mb2, rho, u1, u2, u3, p, B1, B2, B3, gamma, rr)

        ! Left Eigenvectors (row,column)
        call set_left_eig(mu1, mu2, mb1, mb2, rho, u1, u2, u3, p, B1, B2, B3, gamma, rl)

        ! Betas and Alphas
        do m1 = 1, mwaves
            beta(m1) = 0.d0
            do m2 = 1, meqn
                beta(m1) = beta(m1) + rl(m1, m2) * df(m2)
            enddo

            if (dabs(s(m1, i)) > 1.d-15) then
                alpha(m1) = beta(m1) / s(m1, i)
            else
                s(m1, i)  = 0.d0
                alpha(m1) = 0.d0
            endif
        enddo

        ! Waves
        do m1 = 1, mwaves
            do m2 = 1, meqn
                wave(m2, m1, i) = alpha(m1) * rr(m2, m1)
            enddo
        enddo


        ! compute left-going and right-going flux differences:
        !------------------------------------------------------
        !
        ! amdq = SUM s*wave   over left-going waves
        ! apdq = SUM s*wave   over right-going waves

        mflag = 0
        if (efix) then
            ! check if entropy fix is needed
            do mm = 1, 4
                if (eigl(mm) * eigr(mm) < 0.d0) then
                    mflag = 1
                endif
            enddo
        endif

        ! Solution update
        if (mflag == 0) then ! # WAVE PROPAGATION METHOD

            do m1 = 1, meqn
                amdq(m1, i) = 0.d0
                apdq(m1, i) = 0.d0

                do m2 = 1, mwaves
                    if (s(m2, i) < -1.d-15) then
                        amdq(m1, i) = amdq(m1, i) + s(m2, i) * wave(m1, m2, i)
                    elseif (s(m2, i) > 1.d-15) then
                        apdq(m1, i) = apdq(m1, i) + s(m2, i) * wave(m1, m2, i)
                    else
                        if (dabs(beta(m2)) > 1.d-15) then
                            print*, ' '
                            print*, ' In RPN: Conservation fix '
                            print*, ' '
                            print*, ' beta(m2) = ', beta(m2)
                            read*
                        endif
                        amdq(m1, i) = amdq(m1, i) + 0.5d0*beta(m2)*rr(m1,m2)
                        apdq(m1, i) = apdq(m1, i) + 0.5d0*beta(m2)*rr(m1,m2)
                    endif
                enddo
            enddo

        else !# HLL ENTROPY FIX

            sl = eigl(1)
            sr = eigr(4)

            do m1 = 1, meqn
                if (dabs(sl-sr) < 1.d-15) then
                    amdq(m1, i) = 0.d0
                    apdq(m1, i) = 0.d0
                else
                    qs = (df(m1) + sl * qr(m1, i-1) - sr * ql(m1, i)) / (sl - sr)

                    amdq(m1, i) = sl * (qs - qr(m1, i-1))
                    apdq(m1, i) = sr * (ql(m1, i) - qs)
                endif

                do m2 = 1, mwaves
                    wave(m1, m2, i) = 0.d0
                enddo
            enddo

        endif

    enddo


    return
end


!=========================================================
subroutine set_flux_fun(mu1, mu2, mb1, mb2, rho, u1, u2, u3, p, B1, B2, B3, E, f)
!=========================================================

    implicit double precision (a-h,o-z)
    double precision, dimension(8), intent(out) :: f

    Bm = 0.5d0 * (B1**2 + B2**2 + B3**2)
    Bu = u1 * B1 + u2 * B2 + u3 * B3

    f(1)   = rho * u1
    f(mu1) = rho * u1**2 + p + Bm - B1**2
    f(mu2) = rho * u1*u2 - B1*B2
    f(4)   = rho * u1*u3 - B1*B3
    f(5)   = u1 * (E + p + Bm) - B1 * Bu
    f(mb1) = 0.d0
    f(mb2) = u1*B2 - u2*B1
    f(8)   = u1*B3 - u3*B1

    return
end


!=========================================================
subroutine set_left_eig(mu1, mu2, mb1, mb2, rho, u1, u2, u3, p, B1, B2, B3, gamma, rl)
!=========================================================

    implicit none
    integer, intent(in) :: mu1, mu2, mb1, mb2
    double precision, intent(in) :: rho, u1, u2, u3, p, B1, B2, B3, gamma
    double precision, dimension(7,8), intent(out) :: rl
    double precision a2, a, d, ca, cf, cs, beta1, beta2, beta3, alphaf, alphas, g1, g2, um2, th1, th2

    a2 = gamma * p / rho
    a = dsqrt(a2)
    d = a2 + (B1**2 + B2**2 + B3**2) / rho

    ca = dsqrt(B1**2 / rho)
    cf = dsqrt(0.5d0 * ( d + dsqrt(d**2 - 4.d0 * a2 * B1 * B1 / rho)))
    cs = dsqrt(0.5d0 * ( d - dsqrt(d**2 - 4.d0 * a2 * B1 * B1 / rho)))

    beta1 = dsign(1.d0, B1)
    if ( (dabs(B2) + dabs(B3)) <= 1.d-15 ) then
        beta2 = 1.d0 / dsqrt(2.d0)
        beta3 = 1.d0 / dsqrt(2.d0)
    else
        beta2 = B2 / dsqrt(B2*B2 + B3*B3)
        beta3 = B3 / dsqrt(B2*B2 + B3*B3)
    endif

    if ( (dabs(B2) + dabs(B3)) <= 1.d-15 .and. dabs(a2 - B1*B1/rho) <= 1.d-15 ) then
        alphaf = 1.d0
        alphas = 1.d0
    else
        alphaf = dsqrt(dabs(cf * cf - ca*ca)) / dsqrt(dabs(cf * cf - cs * cs))
        alphas = dsqrt(dabs(cf * cf - a2   )) / dsqrt(dabs(cf * cf - cs * cs))
    endif

    g1 = gamma - 1.d0
    g2 = gamma - 2.d0

    um2 = u1**2 + u2**2 + u3**2
    th1 = alphaf*alphaf*a2*(cf*cf - (g2/g1)*a2) + alphas*alphas*cf*cf*(cs*cs - (g2/g1)*a2)
    th1 = 1.d0 / th1
    th2 = alphaf*alphaf*cf*a*beta1 + alphas*alphas*cs*ca*beta1
    th2 = 1.d0 / th2

    ! 1 - left eigenvector
    rl(1,1)   = th1*(alphaf/4.d0)*a2*um2 + 0.5d0*th2*(alphaf*a*u1*beta1 - alphas*cs*(beta2*u2 + beta3*u3))
    rl(1,mu1) = -0.5d0*th1*alphaf*a2*u1 - 0.5d0*th2*alphaf*a*beta1
    rl(1,mu2) = -0.5d0*th1*alphaf*a2*u2 + 0.5d0*th2*alphas*cs*beta2
    rl(1,4)   = -0.5d0*th1*alphaf*a2*u3 + 0.5d0*th2*alphas*cs*beta3
    rl(1,5)   = 0.5d0*th1*alphaf*a2
    rl(1,mb1) = 0.d0
    rl(1,mb2) = 0.5d0*th1*alphas*beta2*cf*(cs*cs - (g2/g1)*a2)*dsqrt(rho)
    rl(1,8)   = 0.5d0*th1*alphas*beta3*cf*(cs*cs - (g2/g1)*a2)*dsqrt(rho)

    ! 2 - left eigenvector
    rl(2,1)   = -0.5d0*(beta3*u2-beta2*u3)*beta1
    rl(2,mu1) = 0.d0
    rl(2,mu2) = 0.5d0*beta3*beta1
    rl(2,4)   = -0.5d0*beta2*beta1
    rl(2,5)   = 0.d0
    rl(2,mb1) = 0.d0
    rl(2,mb2) = 0.5d0*beta3*dsqrt(rho)
    rl(2,8)   = -0.5d0*beta2*dsqrt(rho)

    ! 3 - left eigenvector
    rl(3,1)   = th1*(alphas/4.d0)*cf*cf*um2 + 0.5d0*th2*(alphas*ca*u1*beta1 + alphaf*cf*(beta2*u2 + beta3*u3))
    rl(3,mu1) = -0.5d0*th1*alphas*cf*cf*u1 - 0.5d0*th2*alphas*ca*beta1
    rl(3,mu2) = -0.5d0*th1*alphas*cf*cf*u2 - 0.5d0*th2*alphaf*cf*beta2
    rl(3,4)   = -0.5d0*th1*alphas*cf*cf*u3 - 0.5d0*th2*alphaf*cf*beta3
    rl(3,5)   = 0.5d0*th1*alphas*cf*cf
    rl(3,mb1) = 0.d0
    rl(3,mb2) = -0.5d0*th1*alphaf*beta2*cf*(cf*cf - (g2/g1)*a2)*dsqrt(rho)
    rl(3,8)   = -0.5d0*th1*alphaf*beta3*cf*(cf*cf - (g2/g1)*a2)*dsqrt(rho)

    ! 4 - left eigenvector
    rl(4,1)   = 1.d0 - 0.5d0*th1*(alphaf*alphaf*a2 + alphas*alphas*cf*cf)*um2
    rl(4,mu1) = th1*(alphaf*alphaf*a2 + alphas*alphas*cf*cf)*u1
    rl(4,mu2) = th1*(alphaf*alphaf*a2 + alphas*alphas*cf*cf)*u2
    rl(4,4)   = th1*(alphaf*alphaf*a2 + alphas*alphas*cf*cf)*u3
    rl(4,5)   = -th1*(alphaf*alphaf*a2 + alphas*alphas*cf*cf)
    rl(4,mb1) = 0.d0
    rl(4,mb2) = th1*alphaf*alphas*beta2*cf*(cf*cf-cs*cs)*dsqrt(rho)
    rl(4,8)   = th1*alphaf*alphas*beta3*cf*(cf*cf-cs*cs)*dsqrt(rho)

    ! 5 - left eigenvector
    rl(5,1)   = th1*(alphas/4.d0)*cf*cf*um2 - 0.5d0*th2*(alphas*ca*u1*beta1 + alphaf*cf*(beta2*u2 + beta3*u3))
    rl(5,mu1) = -0.5d0*th1*alphas*cf*cf*u1 + 0.5d0*th2*alphas*ca*beta1
    rl(5,mu2) = -0.5d0*th1*alphas*cf*cf*u2 + 0.5d0*th2*alphaf*cf*beta2
    rl(5,4)   = -0.5d0*th1*alphas*cf*cf*u3 + 0.5d0*th2*alphaf*cf*beta3
    rl(5,5)   = 0.5d0*th1*alphas*cf*cf
    rl(5,mb1) = 0.d0
    rl(5,mb2) = -0.5d0*th1*alphaf*beta2*cf*(cf*cf - (g2/g1)*a2)*dsqrt(rho)
    rl(5,8)   = -0.5d0*th1*alphaf*beta3*cf*(cf*cf - (g2/g1)*a2)*dsqrt(rho)

    ! 6 - left eigenvector
    rl(6,1)   = 0.5d0*(beta3*u2-beta2*u3)*beta1
    rl(6,mu1) = 0.d0
    rl(6,mu2) = -0.5d0*beta3*beta1
    rl(6,4)   = 0.5d0*beta2*beta1
    rl(6,5)   = 0.d0
    rl(6,mb1) = 0.d0
    rl(6,mb2) = 0.5d0*beta3*dsqrt(rho)
    rl(6,8)   = -0.5d0*beta2*dsqrt(rho)

    ! 7 - left eigenvector
    rl(7,1)   = th1*(alphaf/4.d0)*a2*um2 - 0.5d0*th2*(alphaf*a*u1*beta1 - alphas*cs*(beta2*u2 + beta3*u3))
    rl(7,mu1) = -0.5d0*th1*alphaf*a2*u1 + 0.5d0*th2*alphaf*a*beta1
    rl(7,mu2) = -0.5d0*th1*alphaf*a2*u2 - 0.5d0*th2*alphas*cs*beta2
    rl(7,4)   = -0.5d0*th1*alphaf*a2*u3 - 0.5d0*th2*alphas*cs*beta3
    rl(7,5)   = 0.5d0*th1*alphaf*a2
    rl(7,mb1) = 0.d0
    rl(7,mb2) = 0.5d0*th1*alphas*beta2*cf*(cs*cs - (g2/g1)*a2)*dsqrt(rho)
    rl(7,8)   = 0.5d0*th1*alphas*beta3*cf*(cs*cs - (g2/g1)*a2)*dsqrt(rho)

    return
end


!=========================================================
subroutine set_rght_eig(mu1, mu2, mb1, mb2, rho, u1, u2, u3, p, B1, B2, B3, gamma, rr)
!=========================================================

    implicit none
    integer, intent(in) :: mu1, mu2, mb1, mb2
    double precision, intent(in) :: rho, u1, u2, u3, p, B1, B2, B3, gamma
    double precision, dimension(8,7), intent(out) :: rr
    double precision a2, a, d, ca, cf, cs, beta1, beta2, beta3, alphaf, alphas, g1, g2, hmf, hpf, hms, hps

    a2 = gamma * p / rho
    a = dsqrt(a2)
    d = a2 + (B1**2 + B2**2 + B3**2) / rho

    ca = dsqrt(B1**2 / rho)
    cf = dsqrt(0.5d0 * ( d + dsqrt(d**2 - 4.d0*a2*B1*B1/rho)))
    cs = dsqrt(0.5d0 * ( d - dsqrt(d**2 - 4.d0*a2*B1*B1/rho)))

    beta1 = dsign(1.d0, B1)
    if ( (dabs(B2) + dabs(B3)) <= 1.d-15 ) then
        beta2 = 1.d0 / dsqrt(2.d0)
        beta3 = 1.d0 / dsqrt(2.d0)
    else
        beta2 = B2 / dsqrt(B2*B2 + B3*B3)
        beta3 = B3 / dsqrt(B2*B2 + B3*B3)
    endif

    if ( (dabs(B2) + dabs(B3)) <= 1.d-15 .and. dabs(a2 - B1*B1/rho) < 1.d-15 ) then
        alphaf = 1.d0
        alphas = 1.d0
    else
        alphaf = dsqrt(dabs(cf*cf - ca*ca)) / dsqrt(dabs(cf*cf-cs*cs))
        alphas = dsqrt(dabs(cf*cf - a2)) / dsqrt(dabs(cf*cf-cs*cs))
    endif

    g1 = gamma - 1.d0
    g2 = gamma - 2.d0
    hmf = (alphaf*cf*cf/g1) - alphaf*cf*u1 + alphas*ca*beta1*(beta2*u2 + beta3*u3) + (g2/g1)*alphaf*(cf*cf-a2)
    hpf = (alphaf*cf*cf/g1) + alphaf*cf*u1 - alphas*ca*beta1*(beta2*u2 + beta3*u3) + (g2/g1)*alphaf*(cf*cf-a2)
    hms = (alphas*cs*cs/g1) - alphas*cs*u1 - alphaf*a*beta1*(beta2*u2 + beta3*u3) + (g2/g1)*alphas*(cs*cs-a2)
    hps = (alphas*cs*cs/g1) + alphas*cs*u1 + alphaf*a*beta1*(beta2*u2 + beta3*u3) + (g2/g1)*alphas*(cs*cs-a2)

    ! 1 - right eigenvector
    rr(1,1)   = alphaf
    rr(mu1,1) = alphaf*(u1-cf)
    rr(mu2,1) = alphaf*u2 + alphas*beta2*ca*beta1
    rr(4,1)   = alphaf*u3 + alphas*beta3*ca*beta1
    rr(5,1)   = 0.5d0*alphaf*(u1**2 + u2**2 + u3**2) + hmf
    rr(mb1,1) = 0.d0
    rr(mb2,1) = alphas*beta2*cf/dsqrt(rho)
    rr(8,1)   = alphas*beta3*cf/dsqrt(rho)

    ! 2 - right eigenvector
    rr(1,2)   = 0.d0
    rr(mu1,2) = 0.d0
    rr(mu2,2) = beta3*beta1
    rr(4,2)   = -beta2*beta1
    rr(5,2)   = (beta3*u2 - beta2*u3)*beta1
    rr(mb1,2) = 0.d0
    rr(mb2,2) = beta3/dsqrt(rho)
    rr(8,2)   = -beta2/dsqrt(rho)

    ! 3 - right eigenvector
    rr(1,3)   = alphas
    rr(mu1,3) = alphas*(u1-cs)
    rr(mu2,3) = alphas*u2 - alphaf*beta2*a*beta1
    rr(4,3)   = alphas*u3 - alphaf*beta3*a*beta1
    rr(5,3)   = 0.5d0*alphas*(u1**2 + u2**2 + u3**2) + hms
    rr(mb1,3) = 0.d0
    rr(mb2,3) = -alphaf*beta2*a2/(cf*dsqrt(rho))
    rr(8,3)   = -alphaf*beta3*a2/(cf*dsqrt(rho))

    ! 4 - right eigenvector
    rr(1,4)   = 1.d0
    rr(mu1,4) = u1
    rr(mu2,4) = u2
    rr(4,4)   = u3
    rr(5,4)   = 0.5d0*(u1**2 + u2**2 + u3**2)
    rr(mb1,4) = 0.d0
    rr(mb2,4) = 0.d0
    rr(8,4)   = 0.d0

    ! 5 - right eigenvector
    rr(1,5)   = alphas
    rr(mu1,5) = alphas*(u1+cs)
    rr(mu2,5) = alphas*u2 + alphaf*beta2*a*beta1
    rr(4,5)   = alphas*u3 + alphaf*beta3*a*beta1
    rr(5,5)   = 0.5d0*alphas*(u1**2 + u2**2 + u3**2) + hps
    rr(mb1,5) = 0.d0
    rr(mb2,5) = -alphaf*beta2*a2/(cf*dsqrt(rho))
    rr(8,5)   = -alphaf*beta3*a2/(cf*dsqrt(rho))

    ! 6 - right eigenvector
    rr(1,6)   = 0.d0
    rr(mu1,6) = 0.d0
    rr(mu2,6) = -beta3*beta1
    rr(4,6)   = beta2*beta1
    rr(5,6)   = -(beta3*u2 - beta2*u3)*beta1
    rr(mb1,6) = 0.d0
    rr(mb2,6) = beta3/dsqrt(rho)
    rr(8,6)   = -beta2/dsqrt(rho)

    ! 7 - right eigenvector
    rr(1,7)   = alphaf
    rr(mu1,7) = alphaf*(u1+cf)
    rr(mu2,7) = alphaf*u2 - alphas*beta2*ca*beta1
    rr(4,7)   = alphaf*u3 - alphas*beta3*ca*beta1
    rr(5,7)   = 0.5d0*alphaf*(u1**2 + u2**2 + u3**2) + hpf
    rr(mb1,7) = 0.d0
    rr(mb2,7) = alphas*beta2*cf/dsqrt(rho)
    rr(8,7)   = alphas*beta3*cf/dsqrt(rho)

    return
end


!=========================================================
subroutine set_wave_spd(rho, u1, u2, u3, p, B1, B2, B3, gamma, s)
!=========================================================

    implicit none
    double precision, intent(in) :: rho, u1, u2, u3, p, B1, B2, B3, gamma
    double precision, dimension(7), intent(out) :: s
    double precision  a2, d, ca, cf, cs

    a2 = gamma * p / rho
    d = a2 + (B1**2 + B2**2 + B3**2) / rho

    ca = dsqrt(B1**2/rho)
    cf = dsqrt(0.5d0 * ( d + dsqrt(d**2 - 4.d0*a2*B1*B1/rho)))
    cs = dsqrt(0.5d0 * ( d - dsqrt(d**2 - 4.d0*a2*B1*B1/rho)))

    s(1) = u1 - cf
    s(2) = u1 - ca
    s(3) = u1 - cs
    s(4) = u1
    s(5) = u1 + cs
    s(6) = u1 + ca
    s(7) = u1 + cf

    return
end

c
c ---------------------------------------------------------
c
      subroutine check(nsteps,time,nvar,naux)
c
c :::::::::::::::::::::: CHECK ::::::::::::::::::::::::::::::::;
c   check point routine - can only call at end of coarse grid cycle
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module
      implicit double precision (a-h,o-z)

      character*16  chkname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id
c
c     # HDF: Arrays which will hold output arrays.
      dimension  iqout(14), qout(4)
c
c     # HDF: Declare external HDF functions
c
      integer  sfstart, sfend
      external sfstart, sfend
c
c     # HDF: Set up HDF constants
c
      integer 	DFACC_CREATE
      parameter(DFACC_CREATE = 4)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     ###  make the file name showing the time step
c
      chkname = 'fort.chk'
     &     // char(ichar('0') + mod(nsteps/1000,10)) 
     &     // char(ichar('0') + mod(nsteps/100,10)) 
     &     // char(ichar('0') + mod(nsteps/10,10)) 
     &     // char(ichar('0') + mod(nsteps,10))
     &     // '.hdf'
c     
c     # HDF: create hdf file.
c     
      sd_id = sfstart(chkname, DFACC_CREATE)
      if (sd_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to create HDF file (call to sfstart)'
         STOP
      end if
c     
c     # HDF: create array of integers for storage.
c     
c     # HDF: DFNT_INT32
      iqout(1) = lenmax
      iqout(2) = lendim
      iqout(3) = memsize
      iqout(4) = lenf
      iqout(5) = ibuff
      iqout(6) = mstart
      iqout(7) = ndfree
      iqout(8) = lfine
      iqout(9) = iorder
      iqout(10) = mxnest
      iqout(11) = kcheck
      iqout(12) = nsteps
      iqout(13) = matlabu
      iqout(14) = lentot
      iqout(15) = ndfree_bnd
      call dump_integer_vector(sd_id,15,'iqout ',iqout)
      call dump_integer_vector(sd_id,maxlv,'icheck',icheck)
      call dump_integer_vector(sd_id,maxlv,'lstart',lstart)
      call dump_integer_vector(sd_id,maxlv,'newstl',newstl)
      call dump_integer_vector(sd_id,maxlv,'listsp',listsp)
      call dump_integer_vector(sd_id,maxlv,'intratx',intratx)
      call dump_integer_vector(sd_id,maxlv,'intraty',intraty)
      call dump_integer_vector(sd_id,maxlv,'intratz',intratz)
      call dump_integer_vector(sd_id,maxlv,'kratio',kratio)
      call dump_integer_vector(sd_id,maxlv,'iregsz',iregsz)
      call dump_integer_vector(sd_id,maxlv,'jregsz',jregsz)
      call dump_integer_vector(sd_id,maxlv,'kregsz',kregsz)

      call dump_integer_array(sd_id,lfdim,2,'lfree ',lfree)
      call dump_integer_array(sd_id,rsize,maxgr,'node  ',node)

c     # HDF: DFNT_FLOAT64

      qout(1) = tol
      qout(2) = time
      qout(3) = evol
      qout(4) = rvol
      call dump_double_vector(sd_id,4,'qout  ',qout)
      call dump_double_vector(sd_id,maxlv,'hxposs',hxposs)
      call dump_double_vector(sd_id,maxlv,'hyposs',hyposs)
      call dump_double_vector(sd_id,maxlv,'hzposs',hzposs)
      call dump_double_vector(sd_id,maxlv,'possk ',possk)
      call dump_double_vector(sd_id,10,'rvoll ',rvoll)
      call dump_double_vector(sd_id,lendim,'alloc ',alloc)
      
      call dump_double_array(sd_id,rsize,maxgr,'rnode ',rnode)
c
c     # HDF: Close HDF file.
c
      istat = sfend(sd_id)
      if (istat.eq.FAIL) then
         WRITE(*,*) 'Failed to close SDS (call to sfend)'
         STOP
      end if

      return
      end

c=================================================================
c     # HDF: NOTE THAT ALL DOUBLE PRECISION HDF CHECKPOINTING ROUTINES
c     #      FOR BOTH WRITING AND READING ARE INCLUDED HERE, ALTHOUGH
c     #      THE DOUBLE PRECISION READING ROUTINES ARE CALLED IN 
c     #      restrt_hdf.f.  THIS IS DONE TO PREVENT COMPILER ERRORS 
c     #      SINCE THE SAME HDF ROUTINES ARE USED TO READ BOTH INTEGER
c     #      AND DOUBLE PRECISION ARRAYS.
c=================================================================
      subroutine dump_double_vector(sd_id,idims,qname,out)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  out(idims), istart(1), istride(1), iedges(1), idim(1)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfwdata, sfscompress, sfendacc
      external sfcreate, sfwdata, sfscompress, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   DFNT_FLOAT64, DFNT_INT32
      parameter(DFNT_FLOAT64 = 6, DFNT_INT32 = 24)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Set up compression constants for HDF file.
c
      integer   COMP_CODE_DEFLATE, DEFLATE_LEVEL
      parameter (COMP_CODE_DEFLATE = 4, DEFLATE_LEVEL = 6)
c
c     # HDF: Create double vector in HDF file.
c     #      NOTE THAT THE RANK MUST BE ONE.
c
      irank = 1
      idim(1) = idims
      sds_id = sfcreate(sd_id,qname,DFNT_FLOAT64,irank,idim)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to create variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfcreate in check_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for double vector.
c
      istart(1) = 0
      iedges(1) = idims
      istride(1) = 1
c
c     # HDF: set compression mode and write data to hdf file.
c
      istat=sfscompress(sds_id,COMP_CODE_DEFLATE,DEFLATE_LEVEL)
      istat = sfwdata(sds_id,istart,istride,iedges,out)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to write variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfwdata in check_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to double vector in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in check_hdf.f)'
         STOP
      end if

      return
      end

c==========================================================
      subroutine dump_double_array(sd_id,idim1,idim2,qname,out)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  idims(2), istart(2), istride(2), iedges(2)
      dimension  out(idim1,idim2)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfwdata, sfscompress, sfendacc
      external sfcreate, sfwdata, sfscompress, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   DFNT_FLOAT64, DFNT_INT32
      parameter(DFNT_FLOAT64 = 6, DFNT_INT32 = 24)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Set up compression constants for HDF file.
c
      integer   COMP_CODE_DEFLATE, DEFLATE_LEVEL
      parameter (COMP_CODE_DEFLATE = 4, DEFLATE_LEVEL = 6)
c
c     # HDF: Create double array in HDF file.
c     #      NOTE THAT THE RANK MUST BE TWO.
c
      irank = 2
      idims(1) = idim1
      idims(2) = idim2
      sds_id = sfcreate(sd_id,qname,DFNT_FLOAT64,irank,idims)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to create variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfcreate in check_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for double array.
c
      istart(1) = 0
      istart(2) = 0
      iedges(1) = idims(1)
      iedges(2) = idims(2)
      istride(1) = 1
      istride(2) = 1
c
c     # HDF: set compression mode and write data to hdf file.
c
      istat=sfscompress(sds_id,COMP_CODE_DEFLATE,DEFLATE_LEVEL)
      istat = sfwdata(sds_id,istart,istride,iedges,out)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to write variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfwdata in check_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to double array in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in check_hdf.f)'
         STOP
      end if

      return
      end


c==========================================================
      subroutine read_double_vector(sd_id,idims,index,qname,out)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  out(idims), istart(1), istride(1), iedges(1)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfrdata, sfselect, sfendacc
      external sfcreate, sfrdata, sfselect, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Select dataset in HDF file.
c
      sds_id = sfselect(sd_id,index)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to select data set for  variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfselect in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for double vector.
c
      istart(1) = 0
      iedges(1) = idims
      istride(1) = 1
c
c     # HDF: read double vector from hdf file.
c
      istat = sfrdata(sds_id,istart,istride,iedges,out)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to read variable ', qname,
     &        ' from restart HDF file'
         WRITE(*,*) '(call to sfrdata in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to double vector in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in restrt_hdf.f)'
         STOP
      end if

      return
      end

c==========================================================
      subroutine read_double_array(sd_id,idim1,idim2,index,qname,out)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  istart(2), istride(2), iedges(2)
      dimension  out(idim1,idim2)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfrdata, sfselect, sfendacc
      external sfcreate, sfrdata, sfselect, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Select dataset in HDF file.
c
      sds_id = sfselect(sd_id,index)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to select data set for  variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfselect in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for double array.
c
      istart(1) = 0
      istart(2) = 0
      iedges(1) = idim1
      iedges(2) = idim2
      istride(1) = 1
      istride(2) = 1
c
c     # HDF: read double array from hdf file.
c
      istat = sfrdata(sds_id,istart,istride,iedges,out)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to read variable ', qname,
     &        ' from restart HDF file'
         WRITE(*,*) '(call to sfrdata in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to double array in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in restrt_hdf.f)'
         STOP
      end if

      return
      end

! ==================================================================
subroutine rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! ==================================================================

! Riemann solver for the acoustics equations in 3d, with varying
! material properties.
!
! waves: 2
! equations: 4
! aux fields: 2
!
! Conserved quantities:
!       1 pressure
!       2 x_velocity
!       3 y_velocity
!       4 z_velocity
!
! Auxiliary variables:
!       1 impedance
!       2 sound_speed

! Note that although there are 4 eigenvectors, two eigenvalues are
! always zero and so we only need to compute 2 waves.

! Solve Riemann problems along one slice of data.
! This data is along a slice in the x-direction if ixyz=1
!                               the y-direction if ixyz=2.
!                               the z-direction if ixyz=3.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit none
    double precision :: wave(meqn,mwaves,1-mbc:maxm+mbc)
    double precision ::    s(mwaves,1-mbc:maxm+mbc)
    double precision ::   ql(meqn,1-mbc:maxm+mbc)
    double precision ::   qr(meqn,1-mbc:maxm+mbc)
    double precision :: amdq(meqn,1-mbc:maxm+mbc)
    double precision :: apdq(meqn,1-mbc:maxm+mbc)
    double precision :: auxl(maux,1-mbc:maxm+mbc)
    double precision :: auxr(maux,1-mbc:maxm+mbc)
    double precision :: delta(3), zi, zim, a1, a2 
    integer :: ixyz, mu, mv, mw, maxm,meqn,mwaves,mbc,mx, maux
    integer :: i,m



!     # set mu to point to  the component of the system that corresponds
!     # to velocity in the direction of this slice, mv to the orthogonal
!     # velocity.


    if (ixyz == 1) then
        mu = 2
        mv = 3
        mw = 4
    else if (ixyz == 2) then
        mu = 3
        mv = 4
        mw = 2
    else if (ixyz == 3) then
        mu = 4
        mv = 2
        mw = 3
    endif


!     # split the jump in q at each interface into waves
!     # The jump is split into a leftgoing wave traveling at speed -c
!     # relative to the material properties to the left of the interface,
!     # and a rightgoing wave traveling at speed +c
!     # relative to the material properties to the right of the interface,

!     # find a1 and a2, the coefficients of the 2 eigenvectors:
    do 20 i = 2-mbc, mx+mbc
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(mu,i) - qr(mu,i-1)
    !        # impedances:
        zi = auxl(1,i)
        zim = auxr(1,i-1)

        a1 = (-delta(1) + zi*delta(2)) / (zim + zi)
        a2 =  (delta(1) + zim*delta(2)) / (zim + zi)


    
    !        # Compute the waves.
    
        wave(1,1,i) = -a1*zim
        wave(mu,1,i) = a1
        wave(mv,1,i) = 0.d0
        wave(mw,1,i) = 0.d0
        s(1,i) = -auxr(2,i-1)
    
        wave(1,2,i) = a2*zi
        wave(mu,2,i) = a2
        wave(mv,2,i) = 0.d0
        wave(mw,2,i) = 0.d0
        s(2,i) = auxl(2,i)
    
    20 END DO


!     # compute the leftgoing and rightgoing flux differences:
!     # Note s(i,1) < 0   and   s(i,2) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = s(1,i)*wave(m,1,i)
            apdq(m,i) = s(2,i)*wave(m,2,i)
        end do
    end do


    return
    end subroutine rpn3

c
c
c
c     ===============================================================
      subroutine claw1ez    ! No arguments
c     ===============================================================
c
c     An easy-to-use clawpack driver routine for simple applications
c     Documentation is available at
c                 http://www.amath.washington.edu/~claw/doc.html
c
c     Authors: Randall J. LeVeque, Grady I. Lemoine
c
      implicit double precision (a-h,o-z)
      external bc1,rp1,src1,b4step1

      double precision, dimension(:,:), allocatable :: q, aux
      double precision, dimension(:), allocatable :: work, tout
      integer, dimension(:), allocatable :: mthlim, iout_q, iout_aux

c
      dimension method(7),dtv(5),cflv(4),nv(2),mthbc(2)
      integer :: allocate_status, outstyle
      logical :: outaux_init_only, use_fwaves, output_t0
      logical :: outaux_always, dt_variable
      character*12 fname
c
      open(10,file='fort.info',status='unknown',form='formatted')

c
c     # Read the input in standard form from claw.data:
c     # For a description of input parameters see the documentation at
c                 http://www.amath.washington.edu/~claw

c     ## New in 4.4:   Input file name changed from claw1ez.data
c     ## Open file and skip over leading lines with # comments:
      fname = 'claw.data'
      call opendatafile(55,fname)

c
c     # Read the input in standard form from claw.data:
c

      read(55,*) ndim

      read(55,*) xlower
      read(55,*) xupper
      read(55,*) mx
      read(55,*) meqn
      read(55,*) mwaves
      read(55,*) maux
      read(55,*) t0

      read(55,*) outstyle
      if (outstyle == 1) then
         read(55,*) nout
         read(55,*) tfinal
         read(55,*) output_t0    ! Not currently used
         nstepout = 1
      else if (outstyle == 2) then
         read(55,*) nout
         allocate(tout(nout), stat=allocate_status)
         if (allocate_status .ne. 0) then
            print *, '*** Error allocating tout array; exiting claw1ez'
            go to 900
         end if
         read(55,*) (tout(i), i=1,nout)
         nstepout = 1
      else if (outstyle == 3) then
         read(55,*) nstepout
         read(55,*) nstop
         read(55,*) output_t0
         nout = nstop
      else
         print *, '*** Unrecognized output style ', outstyle
         print *, '*** Exiting claw1ez'
         go to 900
      end if

      read(55,*) output_format    ! Not used yet
      ! These iout variables are not currently used, but hang onto them
      ! anyway in case somebody wants to use them at a future date.  The
      ! same goes for outaux_init_only.
      allocate(iout_q(meqn), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating iout_q array; exiting claw1ez'
         go to 900    ! Exception handling, old school style
      end if
      read(55,*) (iout_q(i), i = 1, meqn)
      if (maux > 0) then
         allocate(iout_aux(maux), stat=allocate_status)
         if (allocate_status .ne. 0) then
            print *, '*** Error allocating iout_aux array;',
     &               ' exiting claw1ez'
            go to 900
         end if
         read(55,*) (iout_aux(i), i = 1, maux)
         read(55,*) outaux_init_only
         ! Not implementing selective output of aux fields yet
         if (any(iout_aux .ne. 0)) then
            outaux_always = .not. outaux_init_only
         else
            outaux_always = .false.
            outaux_init_only = .false.
         end if
      else
         outaux_always = .false.
         outaux_init_only = .false.    ! Just to initialize
      end if

      read(55,*) dtv(1)     ! Initial dt
      read(55,*) dtv(2)     ! Max dt
      read(55,*) cflv(1)    ! Max CFL number
      read(55,*) cflv(2)    ! Desired CFL number
      read(55,*) nv(1)      ! Maximum number of steps

      read(55,*) dt_variable    ! Variable or fixed dt
      if (dt_variable) then
         method(1) = 1
      else
         method(1) = 0
      end if
      read(55,*) method(2)    ! Order
      ! method(3) (transverse order) not used in 1D
      ! No dimensional splitting in 1D
      read(55,*) method(4)    ! Verbosity
      read(55,*) method(5)    ! Source term splitting style
      read(55,*) method(6)    ! Index into aux of capacity function
      method(7) = maux        ! Number of aux variables

      read(55,*) use_fwaves

      allocate(mthlim(mwaves), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating mthlim array; exiting claw1ez'
         go to 900
      end if
      read(55,*) (mthlim(i), i = 1, mwaves)

      read(55,*) mbc
      read(55,*) mthbc(1)
      read(55,*) mthbc(2)

      ! No restart in 1D, and there's nothing after the restart info, so
      ! just close the file now.
      close(unit=55)


      ! Check consistency for periodic BCs
      if ((mthbc(1).eq.2 .and. mthbc(2).ne.2) .or.
     &    (mthbc(2).eq.2 .and. mthbc(1).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions'
         write(6,*) ' require mthbc(1) and mthbc(2) BOTH be set to 2'
         stop 
      endif


      ! Figure out size of work array needed
      mwork = (mx + 2*mbc) * (2 + 4*meqn + mwaves + meqn*mwaves)

c
c
      write(6,*) 'running...'
      write(6,*) ' '
c
c     # grid spacing
      dx = (xupper - xlower) / float(mx)
c

c     # time increments between outputing solution:
      if (outstyle .eq. 1) then
         dtout = (tfinal - t0)/float(nout)
         endif
c
c
c     # call user's routine setprob to set any specific parameters
c     # or other initialization required.
c
      call setprob

      ! Allocate aux
      if (maux > 0) then
         allocate(aux(maux, 1-mbc:mx+mbc), stat=allocate_status)
      else
         ! Allocate dummy array to prevent segfaults if it's
         ! dereferenced.  May be unnecessary.
         allocate(aux(1,1), stat=allocate_status)
      end if
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating aux array; exiting claw1ez'
         go to 900
      end if

c        
c     # set aux array:
c
      if (maux .gt. 0)  then
         call setaux(mbc,mx,xlower,dx,maux,aux)
      endif

      ! Allocate q
      allocate(q(meqn, 1-mbc:mx+mbc), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating q array; exiting claw1ez'
         go to 900
      end if

c
c     # set initial conditions:
c
      call qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)
c
c        # output initial data
      call out1(meqn,mbc,mx,xlower,dx,q,t0,0,aux,maux,
     &          outaux_init_only .or. outaux_always)

      ! Allocate work array
      allocate(work(mwork), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating work array; exiting claw1ez'
         go to 900
      end if
c
c     ----------
c     Main loop:
c     ----------
c
      tend = t0
      do n=1,nout
         tstart = tend
         if (outstyle .eq. 1)  tend = tstart + dtout
         if (outstyle .eq. 2)  tend = tout(n)
         if (outstyle .eq. 3)  tend = tstart - 1.d0  !# single-step mode
c
         call claw1(meqn,mwaves,maux,mbc,mx,
     &           q,aux,xlower,dx,tstart,tend,dtv,cflv,nv,method,mthlim,
     &           mthbc,work,mwork,use_fwaves,info,bc1,rp1,src1,b4step1)
c
c        # check to see if an error occured:
         if (info .ne. 0) then
            write(6,*) '*** ERROR in claw1 ***  info =',info
            if (info.eq.1) then
               write(6,*) '***   either mx > maxmx or mbc < 2'
               endif
            if (info.eq.2) then
               write(6,*) '***   dt does not divide (tend - tstart)'
               write(6,*) '***   and dt is fixed since method(1)=0'
               endif
            if (info.eq.3) then
               write(6,*) '***   method(1)=1 and cflv(2) > cflv(1)'
               endif
            if (info.eq.4) then
               write(6,*) '***   mwork is too small'
               endif
            if (info.eq.11) then
               write(6,*) '***   Too many times steps, n > nv(1)'
               endif
            if (info.eq.12) then
               write(6,*) 
     &          '***   The Courant number is greater than cflv(1)'
               write(6,*) '***   and dt is fixed since method(1)=0'
               endif

            go to 900
            endif
c
         dtv(1) = dtv(5)  !# use final dt as starting value on next call
c
c        # output solution at this time
c        ------------------------------
c
c        # if outstyle=1 or 2, then nstepout=1 and we output every time
c        # we reach this point, since claw1 was called for the entire time
c        # increment between outputs.
c
c        # if outstyle=3 then we only output if we have taken nstepout
c        # time steps since the last output.

c        # iframe is the frame number used to form file names in out1
         iframe = n/nstepout
         if (iframe*nstepout .eq. n) then
            call out1(meqn,mbc,mx,xlower,dx,q,tend,iframe,
     &                aux,maux,outaux_always)
            write(6,601) iframe,tend
            write(10,1010) tend,info,dtv(3),dtv(4),dtv(5),
     &           cflv(3),cflv(4),nv(2)
         endif
c
c        # formats for writing out information about this call to claw:
c
  601    format('CLAW1EZ: Frame ',i4,
     &           ' output files done at time t =',
     &           d12.4,/)
c
 1010    format('tend =',d15.4,/,
     &       'info =',i5,/,'smallest dt =',d15.4,/,'largest dt =',
     &       d15.4,/,'last dt =',d15.4,/,'largest cfl =',
     &         d15.4,/,'last cfl =',d15.4,/,'steps taken =',i4,/)
c
      end do
c
  900 continue
      if (allocated(q))        deallocate(q)
      if (allocated(aux))      deallocate(aux)
      if (allocated(work))     deallocate(work)
      if (allocated(mthlim))   deallocate(mthlim)
      if (allocated(tout))     deallocate(tout)
      if (allocated(iout_q))   deallocate(iout_q)
      if (allocated(iout_aux)) deallocate(iout_aux)

c
      return 
      end

c
c --------------------------------------------------------------
c
      subroutine bound(time,nvar,ng,valbig,mitot,mjtot,mktot,mptr,
     1                 aux,naux)

c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension valbig(nvar,mitot,mjtot,mktot)
      dimension aux   (naux,mitot,mjtot,mktot)
      logical   xsticksout, ysticksout, patchOnly
c
c  :::::::::::::: BOUND :::::::::::::::::::::::::::::::::::::::::::
c     This routine sets the boundary values for a given grid
c     at level level.
c     We are setting the values for a strip ng zones wide all
c     the way around the border, in 4 rectangular strips.
c
c     Outputs from this routine:
c     The values around the border of the grid are inserted
c     directly into the enlarged valbig array.
c
c     This routine calls the routine filpatch
c     which for any block of mesh points on a given level,
c     intersects that block with all grids on that level and with
c     the physical boundaries, copies the values into the
c     appropriate intersecting regions, and interpolates the remaining
c     cells from coarser grids as required.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      xlo    = rnode(cornxlo, mptr)
      xhi    = rnode(cornxhi, mptr)
      ylo    = rnode(cornylo, mptr)
      yhi    = rnode(cornyhi, mptr)
      zlo    = rnode(cornzlo, mptr)
      zhi    = rnode(cornzhi, mptr)
      ilo    = node(ndilo, mptr)
      ihi    = node(ndihi, mptr)
      jlo    = node(ndjlo, mptr)
      jhi    = node(ndjhi, mptr)
      klo    = node(ndklo, mptr)
      khi    = node(ndkhi, mptr)
      level  = node(nestlevel, mptr)
      hx     = hxposs(level)
      hy     = hyposs(level)
      hz     = hzposs(level)

      xloWithGhost = xlo  - ng*hx
      xhiWithGhost = xhi  + ng*hx
      yloWithGhost = ylo  - ng*hy
      yhiWithGhost = yhi  + ng*hy
      zloWithGhost = zlo  - ng*hz
      zhiWithGhost = zhi  + ng*hz
      ! used in filaptch for bc2amr: for patches it is called. for full grids called from bound below
      patchOnly = .false.  

c     left boundary

      xl = xlo - ng*hx
      xr = xlo
      yf = ylo - ng*hy
      yr = yhi + ng*hy
      zb = zlo
      zt = zhi
      ysticksout =  ((yf .lt. ylower) .or. (yr .gt. yupper))

      if ((xperdom .and. xl .lt. xlower) .or. 
     1    (yperdom .and. ysticksout)) then
        call  prefilrecur(level,nvar,valbig,aux,naux,time,
     1                    mitot,mjtot,mktot,
     2                    1,1,ng+1,
     3                    ilo-ng,ilo-1,jlo-ng,jhi+ng,klo,khi,
     4                    ilo-ng,ilo+ng,jlo-ng,jhi+ng,klo-ng,khi+ng,
     5                    patchOnly)
      else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,mktot,
     1                1,1,ng+1,ilo-ng,ilo-1,
     2                jlo-ng,jhi+ng,klo,khi,patchOnly,mptr)
      endif


c     right boundary

      xl = xhi
      xr = xhi + ng*hx
      yf = ylo - ng*hy
      yr = yhi + ng*hy
      zb = zlo
      zt = zhi
      ysticksout =  ((yf .lt. ylower) .or. (yr .gt. yupper))

      if ((xperdom .and. xr .gt. xupper) .or. 
     1    (yperdom .and. ysticksout)) then
        call  prefilrecur(level,nvar,valbig,aux,naux,time,
     1                    mitot,mjtot,mktot,
     2                    mitot-ng+1,1,ng+1,
     3                    ihi+1,ihi+ng,jlo-ng,jhi+ng,klo,khi,
     4                    ilo-ng,ilo+ng,jlo-ng,jhi+ng,klo-ng,khi+ng,
     5                    patchOnly)
      else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,mktot,
     1                mitot-ng+1,1,ng+1,ihi+1,ihi+ng,
     2                jlo-ng,jhi+ng,klo,khi,patchOnly,mptr)
      endif


c     front boundary
      xl = xlo
      xr = xhi
      yf = ylo - ng*hy
      yr = ylo
      zb = zlo
      zt = zhi
      if (yperdom .and. yf .lt. ylower) then
        call prefilrecur(level,nvar,valbig,aux,naux,time,
     1                   mitot,mjtot,mktot,
     2                   ng+1,1,ng+1,
     3                   ilo,ihi,jlo-ng,jlo-1,klo,khi,
     4                   ilo-ng,ilo+ng,jlo-ng,jhi+ng,klo-ng,khi+ng,
     5                    patchOnly)
      else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,mktot,
     1                ng+1,1,ng+1,ilo,ihi,
     2                jlo-ng,jlo-1,klo,khi,patchOnly,mptr)
      endif

c     rear boundary
      xl = xlo
      xr = xhi
      yf = yhi
      yr = yhi + ng*hy
      zb = zlo
      zt = zhi
      if (yperdom .and. yr .gt. yupper) then
        call prefilrecur(level,nvar,valbig,aux,naux,time,
     1                   mitot,mjtot,mktot,
     2                   ng+1,mjtot-ng+1,ng+1,
     3                   ilo,ihi,jhi+1,jhi+ng,klo,khi,
     4                   ilo-ng,ilo+ng,jlo-ng,jhi+ng,klo-ng,khi+ng,
     5                   patchOnly)
      else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,mktot,
     1                ng+1,mjtot-ng+1,ng+1,ilo,ihi,
     2                jhi+1,jhi+ng,klo,khi,patchOnly,mptr)
      endif

c     bottom boundary
      xl = xlo - ng*hx
      xr = xhi + ng*hx
      yf = ylo - ng*hy
      yr = yhi + ng*hy
      zb = zlo - ng*hz
      zt = zlo
      xsticksout = (xl .lt. xlower) .or. (xr .gt. xupper)
      ysticksout = (yf .lt. ylower) .or. (yr .gt. yupper)

      if ((zperdom .and. zb .lt. zlower) .or. 
     1    (xperdom .and. xsticksout) .or.
     2    (yperdom .and. ysticksout)) then
        call prefilrecur(level,nvar,valbig,aux,naux,time,
     1                   mitot,mjtot,mktot,
     2                   1,1,1,
     3                   ilo-ng,ihi+ng,jlo-ng,jhi+ng,klo-ng,klo-1,
     4                   ilo-ng,ilo+ng,jlo-ng,jhi+ng,klo-ng,khi+ng,
     5                   patchOnly)
      else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,mktot,
     1                1,1,1,ilo-ng,ihi+ng,
     2                jlo-ng,jhi+ng,klo-ng,klo-1,patchOnly,mptr)
      end if

c     top boundary
      xl = xlo - ng*hx
      xr = xhi + ng*hx
      yf = ylo - ng*hy
      yr = yhi + ng*hy
      zb = zhi
      zt = zhi + ng*hz
      xsticksout = (xl .lt. xlower) .or. (xr .gt. xupper)
      ysticksout = (yf .lt. ylower) .or. (yr .gt. yupper)

      if ((zperdom .and. zt .gt. zupper) .or.
     1    (xperdom .and. xsticksout) .or.
     2    (yperdom .and. ysticksout)) then
        call prefilrecur(level,nvar,valbig,aux,naux,time,
     1                   mitot,mjtot,mktot,
     2                   1,1,mktot-ng+1,
     3                   ilo-ng,ihi+ng,jlo-ng,jhi+ng,khi+1,khi+ng,
     4                   ilo-ng,ilo+ng,jlo-ng,jhi+ng,klo-ng,khi+ng,
     5                   patchOnly)
      else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,mktot,
     1                1,1,mktot-ng+1,ilo-ng,ihi+ng,
     2                jlo-ng,jhi+ng,khi+1,khi+ng,patchOnly,mptr)
      end if

c
       ! set all exterior (physical)  boundary conditions for this grid at once
       ! used to be done from filpatch, but now only for recursive calls with new patch
       ! where the info matches. more efficient to do whole grid at once, and avoid copying
      call bc3amr(valbig,aux,mitot,mjtot,mktot,nvar,naux,hx,hy,hz,
     1            level,time,
     2            xloWithGhost,xhiWithGHost,
     3            yloWithGhost,yhiWithGhost,
     4            zloWithGhost,zhiWithGhost)
c
      return
      end

!-----------------------------------------------------------------------------------
! Name: rptt3(ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,
!             aux1,aux2,aux3,bsasdq,cmbsasdq,cpbsasdq)
!
! Description: Roe solver in the transverse direction for the 3D Euler Equations
!
! Inputs: 
!         ixyz <INTEGER>   : direction to take slice x-direction if ixyz=1
!                                                    y-direction if ixyz=2.
!                                                    z-direction if ixyz=3.
!         icoor <INTEGER>  : direction in which the transverse solve should be
!                            performed.  icoor=2 (split in y-like direction)
!                                        icoor=3 (split in z-like direction)
!                            ixyz=1, icoor=3 means bsasdq=B^*A^*\Dq, split in z:
!                                            cmbsasdq = C^-B^*A^*\Dq,
!                                            cpbsasdq = C^+B^*A^*\Dq.
!                            ixyz=2, icoor=3 means bsasdq=C^*B^*\Dq, split in x: 
!                                            cmbsasdq = A^-C*B*\Dq,
!                                            cpbsasdq = A^+C*B*\Dq.
!         imp <INTEGER>    : index for aux arrays
!         impt <INTEGER>   : index for aux arrays
!         maxm <INTEGER>   : max number of grid cells (less the ghost cells)
!         meqn <INTEGER>   : number of equations in the system
!         mwaves <INTEGER> : nuber of waves in the system
!         maux <INTEGER>   : number of auxilary equations
!         mbc <INTEGER>    : number of ghost cells on either end
!         mx <INTEGER>     : number of elements
!         ql <REAL>        : state vector at left edge of each cell
!                            Note the i'th Riemann problem has left state qr(:,i-1)
!         qr <REAL>        : state vector at right edge of each cell
!                            Note the i'th Riemann problem has right state ql(:,i)
!         aux1 <REAL>      : 
!         aux2 <REAL>      :
!         aux3 <REAL>      :
!         bsasdq <REAL>    :  array of flux differences that result from a
!                             transverse splitting (a previous call to rpt3).  
!                             This stands for B^* A^* \Dq but could represent 
!                             any of 6 possibilities, e.g.  C^* B^* \Dq, as 
!                             specified by ixyz and icoor (see below).
!                             Moreover, each * represents either + or -, as 
!                             specified by imp and impt.
!         
! Outputs: 
!         cmbsasdq <REAL>  : left-going flux differences
!         cpbsasdq <REAL>  : right-going flux differences
!
! Adapted from rpt3_euler.f90 in $CLAWHOME/riemann/src
!-----------------------------------------------------------------------------------
SUBROUTINE rptt3(ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,&
     aux1,aux2,aux3,bsasdq,cmbsasdq,cpbsasdq)

    IMPLICIT NONE

    ! Input
    INTEGER, INTENT(IN) :: ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx
    REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(IN) :: ql,qr,bsasdq
    REAL(kind=8), DIMENSION(maux,1-mbc:maxm+mbc,3), INTENT(IN) :: aux1,aux2,aux3
  
    ! Output
    REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(INOUT) :: cmbsasdq,cpbsasdq
  
    ! Local Storage
    INTEGER, PARAMETER :: maxmrp = 1002
    REAL(kind=8), DIMENSION(5) :: alpha
    REAL(kind=8), DIMENSION(-1:maxmrp) :: u2v2w2,u,v,w,enth,a,g1a2,euv
    REAL(kind=8) :: asqrd,pl,pr,rhsq2,rhsqrtl,rhsqrtr
    REAL(kind=8), DIMENSION(5,3) :: waveb
    REAL(kind=8), DIMENSION(3) :: sb
    INTEGER :: i,j,mu,mv,mw,mws
  
    ! Common block storage for ideal gas constant
    REAL(kind=8) :: gamma,gamma1
    COMMON /cparam/ gamma

    ! Set (gamma-1)
    gamma1 = gamma - 1.d0

    IF (maxmrp < maxm+mbc)THEN
       WRITE(6,*) 'need to increase maxmrp in rpn3_neutral_qwave.f90'
       WRITE(6,*) 'maxmrp: ',maxmrp,' maxm: ',maxm,' mbc: ',mbc
       WRITE(6,*) 'maxm+mbc=',maxm+mbc
       STOP
    ENDIF

    IF (mwaves /= 3) THEN
       WRITE(6,*) '*** Should have mwaves=3 for this Riemann solver'
       STOP
    ENDIF
    
    ! Set mu to point to  the component of the system that corresponds to momentum 
    ! in the direction of this slice, mv and mw to the orthogonal momentums.
    !
    ! ixyz indicates the direction of the original Riemann solve,
    ! called the x-like direction in the table below:
    ! 
    !         x-like direction   y-like direction   z-like direction
    ! ixyz=1:        x                  y                  z         
    ! ixyz=2:        y                  z                  x         
    ! ixyz=3:        z                  x                  y      
    IF(ixyz == 1)THEN
       mu = 2
       mv = 3
       mw = 4
    ELSE IF(ixyz == 2)THEN
       mu = 3
       mv = 4
       mw = 2
    ELSE
       mu = 4
       mv = 2
       mw = 3
    ENDIF

    ! Note that notation for u,v, and w reflects assumption that the
    !   Riemann problems are in the x-direction with u in the normal
    !   direction and v and w in the orthogonal directions, but with the
    !   above definitions of mu, mv, and mw the routine also works with
    !   ixyz=2 and ixyz = 3
    !   and returns, for example, f0 as the Godunov flux g0 for the
    !   Riemann problems u_t + g(u)_y = 0 in the y-direction.
    !
    ! Compute the Roe-averaged variables needed in the Roe solver.
    
    ! Loop over grid cell interfaces
    DO i = 2-mbc, mx+mbc
       IF (qr(1,i-1) <= 0.d0 .OR. ql(1,i) <= 0.d0) THEN
          WRITE(*,*) i, mu, mv, mw
          WRITE(*,'(5e12.4)') (qr(j,i-1),j=1,5)
          WRITE(*,'(5e12.4)') (ql(j,i),j=1,5)
          IF (ixyz == 1) WRITE(6,*) '*** rho <= 0 in x-sweep at ',i
          IF (ixyz == 2) WRITE(6,*) '*** rho <= 0 in y-sweep at ',i
          IF (ixyz == 3) WRITE(6,*) '*** rho <= 0 in z-sweep at ',i
          WRITE(6,*) 'stopped with rho <= 0...'
          STOP
       ENDIF
       rhsqrtl = SQRT(qr(1,i-1))
       rhsqrtr = SQRT(ql(1,i))
       pl = gamma1*(qr(5,i-1) - 0.5d0*(qr(mu,i-1)**2 + &
            qr(mv,i-1)**2 + qr(mw,i-1)**2)/qr(1,i-1))
       pr = gamma1*(ql(5,i) - 0.5d0*(ql(mu,i)**2 + &
            ql(mv,i)**2 + ql(mw,i)**2)/ql(1,i))
       rhsq2 = rhsqrtl + rhsqrtr
       u(i) = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
       v(i) = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
       w(i) = (qr(mw,i-1)/rhsqrtl + ql(mw,i)/rhsqrtr) / rhsq2
       enth(i) = (((qr(5,i-1)+pl)/rhsqrtl &
            + (ql(5,i)+pr)/rhsqrtr)) / rhsq2
       u2v2w2(i) = u(i)**2 + v(i)**2 + w(i)**2
       asqrd = gamma1*(enth(i) - .5d0*u2v2w2(i))
       
       IF (i>=0 .AND. i<=mx .AND. asqrd <= 0.d0) THEN
          IF (ixyz == 1) WRITE(6,*) '*** a**2 <= 0 in x-sweep at ',i
          IF (ixyz == 2) WRITE(6,*) '*** a**2 <= 0 in y-sweep at ',i
          IF (ixyz == 3) WRITE(6,*) '*** a**2 <= 0 in z-sweep at ',i
          WRITE(6,*) 'stopped with a**2 < 0...'
          STOP
       ENDIF
       a(i) = SQRT(asqrd)
       g1a2(i) = gamma1 / asqrd
       euv(i) = enth(i) - u2v2w2(i)
    END DO

    ! Solve Riemann problem in the second coordinate direction
    IF(icoor == 2)THEN
       DO i = 2-mbc, mx+mbc
          alpha(4) = g1a2(i) * (euv(i)*bsasdq(1,i) + u(i)*bsasdq(mu,i) &
               + v(i)*bsasdq(mv,i) + w(i)*bsasdq(mw,i) - bsasdq(5,i))
          alpha(2) = bsasdq(mu,i) - u(i)*bsasdq(1,i)
          alpha(3) = bsasdq(mw,i) - w(i)*bsasdq(1,i)
          alpha(5) = (bsasdq(mv,i) &
               + (a(i)-v(i))*bsasdq(1,i) - a(i)*alpha(4))/(2.d0*a(i))
          alpha(1) = bsasdq(1,i) - alpha(4) - alpha(5)
          
          waveb(1,1)  = alpha(1)
          waveb(mu,1) = alpha(1)*u(i)
          waveb(mv,1) = alpha(1)*(v(i)-a(i))
          waveb(mw,1) = alpha(1)*w(i)
          waveb(5,1)  = alpha(1)*(enth(i) - v(i)*a(i))
          sb(1) = v(i) - a(i)
          
          waveb(1,2)  = alpha(4)
          waveb(mu,2) = alpha(2) + u(i)*alpha(4)
          waveb(mv,2) = alpha(4)*v(i)
          waveb(mw,2) = alpha(3) + alpha(4)*w(i)
          waveb(5,2)  = alpha(4)*0.5d0*u2v2w2(i) + alpha(2)*u(i) + alpha(3)*w(i)
          sb(2) = v(i)
          
          waveb(1,3)  = alpha(5)
          waveb(mu,3) = alpha(5)*u(i)
          waveb(mv,3) = alpha(5)*(v(i) + a(i))
          waveb(mw,3) = alpha(5)*w(i)
          waveb(5,3)  = alpha(5)*(enth(i) + v(i)*a(i))
          sb(3) = v(i) + a(i)
          
          cmbsasdq(:,i) = 0.d0
          cpbsasdq(:,i) = 0.d0
          DO mws = 1,mwaves
             cmbsasdq(:,i) = cmbsasdq(:,i) + MIN(sb(mws), 0.d0)*waveb(:,mws)
             cpbsasdq(:,i) = cpbsasdq(:,i) + MAX(sb(mws), 0.d0)*waveb(:,mws)
          END DO

       END DO

    ! Solve Riemann problem in the third coordinate direction
    ELSEIF(icoor == 3)THEN
       DO i = 2-mbc, mx+mbc
          alpha(4) = g1a2(i) * (euv(i)*bsasdq(1,i) + u(i)*bsasdq(mu,i) &
               + v(i)*bsasdq(mv,i) + w(i)*bsasdq(mw,i) - bsasdq(5,i))
          alpha(2) = bsasdq(mu,i) - u(i)*bsasdq(1,i)
          alpha(3) = bsasdq(mv,i) - v(i)*bsasdq(1,i)
          alpha(5) = (bsasdq(mw,i) &
               + (a(i)-w(i))*bsasdq(1,i) - a(i)*alpha(4))/(2.d0*a(i))
          alpha(1) = bsasdq(1,i) - alpha(4) - alpha(5)
          
          waveb(1,1)  = alpha(1)
          waveb(mu,1) = alpha(1)*u(i)
          waveb(mv,1) = alpha(1)*v(i)
          waveb(mw,1) = alpha(1)*(w(i) - a(i))
          waveb(5,1)  = alpha(1)*(enth(i) - w(i)*a(i))
          sb(1) = w(i) - a(i)
          
          waveb(1,2)  = alpha(4)
          waveb(mu,2) = alpha(2) + alpha(4)*u(i)
          waveb(mv,2) = alpha(3) + alpha(4)*v(i)
          waveb(mw,2) = alpha(4)*w(i)
          waveb(5,2)  = alpha(4)*0.5d0*u2v2w2(i) + alpha(2)*u(i) + alpha(3)*v(i)
          sb(2) = w(i)
          
          waveb(1,3)  = alpha(5)
          waveb(mu,3) = alpha(5)*u(i)
          waveb(mv,3) = alpha(5)*v(i)
          waveb(mw,3) = alpha(5)*(w(i) + a(i))
          waveb(5,3)  = alpha(5)*(enth(i) + w(i)*a(i))
          sb(3) = w(i) + a(i)
          
          cmbsasdq(:,i) = 0.d0
          cpbsasdq(:,i) = 0.d0
          DO mws = 1,mwaves
             cmbsasdq(:,i) = cmbsasdq(:,i) + MIN(sb(mws), 0.d0)*waveb(:,mws)
             cpbsasdq(:,i) = cpbsasdq(:,i) + MAX(sb(mws), 0.d0)*waveb(:,mws)
          END DO
          
       END DO
    END IF

END SUBROUTINE rptt3

subroutine rp1(maxmx,num_eqn,num_waves,num_aux,num_ghost,num_cells, &
               ql,qr,auxl,auxr,wave,s,amdq,apdq)

! Solve Riemann problems for the 1D shallow water equations
! with an additional passively advected tracer:
!    (h)_t + (u h)_x = 0
!    (uh)_t + ( uuh + .5*gh^2 )_x = 0
!    c_t + uc_x = 0
! using Roe's approximate Riemann solver with entropy fix for
! transonic rarefractions.

! waves: 3
! equations: 3

! Conserved quantities:
!       1 depth
!       2 momentum
!       3 tracer

! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

    implicit none

    integer, intent(in) :: maxmx, num_eqn, num_waves, num_aux, num_ghost, &
                            num_cells
    real(kind=8), intent(in), dimension(num_eqn,1-num_ghost:maxmx+num_ghost) :: ql, qr
    real(kind=8), intent(in), dimension(num_aux,1-num_ghost:maxmx+num_ghost) :: auxl, auxr
    real(kind=8), intent(out) :: s(num_waves, 1-num_ghost:maxmx+num_ghost)
    real(kind=8), intent(out) :: wave(num_eqn, num_waves, 1-num_ghost:maxmx+num_ghost)
    real(kind=8), intent(out), dimension(num_eqn,1-num_ghost:maxmx+num_ghost) :: amdq,apdq

    ! local variables:
    real(kind=8) :: a1,a2,ubar,cbar,s0,s1,s2,s3,hr1,uhr1,hl2,uhl2,sfract,df
    real(kind=8) :: delta(2)
    integer :: i,m,mw
    logical :: efix

    data efix /.true./    ! Use entropy fix for transonic rarefactions

    ! Gravity constant set in setprob.f or the shallow1D.py file
    real(kind=8) :: grav
    common /cparam/ grav

    ! Main loop of the Riemann solver.
    do 30 i=2-num_ghost,num_cells+num_ghost
    
        ! compute  Roe-averaged quantities:
        ubar = (qr(2,i-1)/dsqrt(qr(1,i-1)) + ql(2,i)/dsqrt(ql(1,i)))/ &
               ( dsqrt(qr(1,i-1)) + dsqrt(ql(1,i)) )
        cbar=dsqrt(0.5d0*grav*(qr(1,i-1) + ql(1,i)))
                 
        ! delta(1)=h(i)-h(i-1) and  delta(2)=hu(i)-hu(i-1)
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(2,i) - qr(2,i-1)

        ! Compute coeffs in the evector expansion of delta(1),delta(2)
        a1 = 0.5d0*(-delta(2) + (ubar + cbar) * delta(1))/cbar
        a2 = 0.5d0*( delta(2) - (ubar - cbar) * delta(1))/cbar

        ! Finally, compute the waves.
        wave(1,1,i) = a1
        wave(2,1,i) = a1*(ubar - cbar)
        wave(3,1,i) = 0.d0
        s(1,i) = ubar - cbar
                 
        wave(1,2,i) = a2
        wave(2,2,i) = a2*(ubar + cbar)
        wave(3,2,i) = 0.d0
        s(2,i) = ubar + cbar

        wave(1,3,i) = 0.d0
        wave(2,3,i) = 0.d0
        wave(3,3,i) = ql(3,i) - qr(3,i-1)
        s(3,i) = ubar
                 
    30 enddo

    ! Compute fluctuations amdq and apdq
    ! ------------------------------------

    if (efix) go to 110

    ! No entropy fix
    ! ----------------------------------------------
    ! amdq = SUM s*wave   over left-going waves
    ! apdq = SUM s*wave   over right-going waves

    do m=1,num_waves
        do i=2-num_ghost, num_cells+num_ghost
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1,num_waves
                if (s(mw,i) < 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                else
                    apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                endif
            enddo
        enddo
    enddo
    
    ! with no entropy fix we are done...
    return


    ! -----------------------------------------------

    110 continue

    ! With entropy fix
    ! ------------------

    ! compute flux differences amdq and apdq.
    ! First compute amdq as sum of s*wave for left going waves.
    ! Incorporate entropy fix by adding a modified fraction of wave
    ! if s should change sign.

    do 200 i=2-num_ghost,num_cells+num_ghost
              
        ! ------------------------------------------------------
        ! check 1-wave:
        ! ---------------
    
        ! u-c in left state (cell i-1)
        s0 = qr(2,i-1)/qr(1,i-1) - dsqrt(grav*qr(1,i-1))
                 
        ! check for fully supersonic case:
        if (s0 >= 0.d0 .and. s(1,i) > 0.d0)  then
            ! everything is right-going
            do m=1,num_eqn
                amdq(m,i) = 0.d0
                enddo
            go to 200
        endif
    
        ! u-c to right of 1-wave
        hr1  = qr(1,i-1) + wave(1,1,i)
        uhr1 = qr(2,i-1) + wave(2,1,i)
        s1 =  uhr1/hr1 - dsqrt(grav*hr1)
                         
        if (s0 < 0.d0 .and. s1 > 0.d0) then
            ! transonic rarefaction in the 1-wave
            sfract = s0 * (s1-s(1,i)) / (s1-s0)
        else if (s(1,i) < 0.d0) then
            ! 1-wave is leftgoing
            sfract = s(1,i)
        else
            ! 1-wave is rightgoing
            sfract = 0.d0   !# this shouldn't happen since s0 < 0
        endif

        do m=1,num_eqn
            amdq(m,i) = sfract*wave(m,1,i)
            enddo
          
        ! -------------------------------------------------------
        ! check 2-wave (second nonlinear wave, note tracer contact is 3-wave):
        ! ---------------
        ! u+c in right state  (cell i)
        s3 = ql(2,i)/ql(1,i) + dsqrt(grav*ql(1,i))
                      
        ! u+c to left of 2-wave
        hl2  = ql(1,i) - wave(1,2,i)
        uhl2 = ql(2,i) - wave(2,2,i)
        s2 = uhl2/hl2 + dsqrt(grav*hl2)
                          
        if (s2 < 0.d0 .and. s3 > 0.d0) then
            ! transonic rarefaction in the 2-wave
            sfract = s2 * (s3-s(2,i)) / (s3-s2)
        else if (s(2,i) < 0.d0) then
            ! 2-wave is leftgoing
            sfract = s(2,i)
        else
            ! 2-wave is rightgoing
            go to 200
        endif
    
        do m=1,num_eqn
            amdq(m,i) = amdq(m,i) + sfract*wave(m,2,i)
            enddo

    200 enddo


    ! compute the rightgoing flux differences:
    ! df = SUM s*wave   is the total flux difference and apdq = df - amdq

    do i = 2-num_ghost, num_cells+num_ghost
        do m=1,2
            df = 0.d0
            do mw=1,2
                df = df + s(mw,i)*wave(m,mw,i)
                enddo
            apdq(m,i) = df - amdq(m,i)
            enddo
            
        ! tracer (which is in non-conservation form)
        if (s(3,i) < 0) then
            amdq(m,i) = amdq(m,i) + s(3,i)*wave(m,3,i)
          else
            apdq(m,i) = apdq(m,i) + s(3,i)*wave(m,3,i)
          endif
          
        enddo

    return

end subroutine rp1

c
c --------------------------------------------------------------
c
      recursive subroutine prefilrecur(level,nvar,
     1                                 valbig,auxbig,naux,time,
     2                                 mitot,mjtot,mktot,
     3                                 nrowst,ncolst,nfilst,
     4                                 ilo,ihi,jlo,jhi,klo,khi,
     5                                 iglo,ighi,jglo,jghi,kglo,kghi,
     6                                 patchOnly)

      use amr_module
      implicit double precision (a-h,o-z)


      dimension valbig(nvar,mitot,mjtot,mktot)
      dimension auxbig(naux,mitot,mjtot,mktot)
      dimension ist(3), iend(3), ishift(3)
      dimension jst(3), jend(3), jshift(3)
      dimension kst(3), kend(3), kshift(3)
      logical   patchOnly

    ! dimension scratch patches at largest possible
      dimension  valPatch((ihi-ilo+1)*(jhi-jlo+1)*(khi-klo+1)*nvar)  
      dimension  auxPatch((ihi-ilo+1)*(jhi-jlo+1)*(khi-klo+1)*naux)    
      integer    msrc/ -1/  ! indicates not a real grid calling filpatch

c
c  :::::::::::::: PREFILRECUR :::::::::::::::::::::::::::::::::::::::::::
c     For periodic boundary conditions more work needed to fill the
c     piece of the boundary. This routine was
c     called because the patch sticks out of the domain,
c     and has periodic bc.s preprocess the patch before calling
c     filrecur to shift the patch periodically back into the domain.
c
c     Inputs to this routine:
c     xl, xr, yb, yt, zf, zr = the location in physical space of
c     corners of a patch.
c     ilo,ihi,jlo,jhi,klo,khi = the location in index space of this patch.
c     iglo,ighi,jglo,jghi,kglo,kghi = the location in index space of the grid
c                          containing the patch, used to compute where to copy and fill
c     NB: the patch may actually be the whole grid (if called from filpatch for coarser lev)
c
c     Outputs from this routine:
c     The values around the border of the grid are inserted
c     directly into the enlarged valbig array for this piece, if called from bound
c     or entire patch filled if called from filpatch
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c     # will divide patch into 27 possibilities (some empty): 
c       x sticks out left, x interior, x sticks out right
c       same for y and z. for example, the max. would be
c       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)

      if (xperdom) then
         ist(1)  = ilo
         ist(2)  = 0
         ist(3)  = iregsz(level)
         iend(1) = -1
         iend(2) = iregsz(level)-1
         iend(3) = ihi
         ishift(1) = iregsz(level)
         ishift(2) = 0
         ishift(3) = -iregsz(level)
      else
         ist(1)    = iregsz(level)
         ist(2)    = ilo
         ist(3)    = iregsz(level)
         iend(1)   = -1
         iend(2)   = ihi
         iend(3)   = -1
         ishift(1) = 0
         ishift(2) = 0
         ishift(3) = 0
      endif

      if (yperdom) then
         jst(1)  = jlo
         jst(2)  = 0
         jst(3)  = jregsz(level)
         jend(1) = -1
         jend(2) = jregsz(level)-1
         jend(3) = jhi
         jshift(1) = jregsz(level)
         jshift(2) = 0
         jshift(3) = -jregsz(level)
      else
         jst(1)    = jregsz(level)
         jst(2)    = jlo
         jst(3)    = jregsz(level)
         jend(1)   = -1
         jend(2)   = jhi
         jend(3)   = -1
         jshift(1) = 0
         jshift(2) = 0
         jshift(3) = 0
      endif

      if (zperdom) then
         kst(1)  = klo
         kst(2)  = 0
         kst(3)  = kregsz(level)
         kend(1) = -1
         kend(2) = kregsz(level)-1
         kend(3) = khi
         kshift(1) = kregsz(level)
         kshift(2) = 0
         kshift(3) = -kregsz(level)
      else
         kst(1)    = kregsz(level)
         kst(2)    = klo
         kst(3)    = kregsz(level)
         kend(1)   = -1
         kend(2)   = khi
         kend(3)   = -1
         kshift(1) = 0
         kshift(2) = 0
         kshift(3) = 0
      endif

!   ## loop over the 27 regions (in 3D) of the patch - the interior is i=j=k=2 plus
!   ## the ghost cell regions.  If any parts stick out of domain and are periodic
!   ## map indices periodically.  use scratch patch storage of exact size to get rid
!   ## of the iputst, stuff that broke the variable coefficient boundry condition routines.

!   ## if a region sticks out of domain  but is not periodic, not handled in pre-filrecir
!   ## but in bc3amr, now called from bound

        do 30 i = 1, 3
         i1 = max(ilo,  ist(i))
         i2 = min(ihi, iend(i))
         if (i1 .gt. i2) go to 30

         do 20 j = 1, 3
           j1 = max(jlo,  jst(j))
           j2 = min(jhi, jend(j))
           if (j1 .gt. j2) go to 20

           do 10 k = 1, 3
             k1 = max(klo,  kst(k))
             k2 = min(khi, kend(k))

           if (k1 <= k2) then ! part of patch in this region
              iputst = (i1 - ilo) + nrowst
              jputst = (j1 - jlo) + ncolst
              kputst = (k1 - klo) + nfilst

              mi = i2 - i1 + 1
              mj = j2 - j1 + 1
              mk = k2 - k1 + 1

              if (naux .gt. 0)   
     1            call auxCopyIn(auxPatch,mi,mj,mk,auxbig,
     2                           mitot,mjtot,mktot,naux,
     3                           i1,i2,j1,j2,k1,k2,iglo,jglo,kglo)

              call filrecur(level,nvar,valPatch,auxPatch,naux,time,
     1                      mi,mj,mk,
     2                      1,1,1,                      
     3                      i1+ishift(i), i2+ishift(i),
     4                      j1+jshift(j), j2+jshift(j),
     5                      k1+kshift(k), k2+kshift(k),.true.,msrc)      

                    ! copy it back to proper place in valbig 
                    call patchCopyOut(nvar,valPatch,mi,mj,mk,valbig,
     1                                mitot,mjtot,mktot,
     2                                i1,i2,j1,j2,k1,k2,
     3                                iglo,jglo,kglo)         

           end if

 10      end do
 20     end do
 30    end do

       return
       end
! ============================================================================================

       subroutine patchCopyOut(nvar,valpatch,mi,mj,mk,valbig,
     1                         mitot,mjtot,mktot,
     2                         i1,i2,j1,j2,k1,k2,iglo,jglo,kglo)
 
      ! the patch was filled from a possibly periodically wrapped place.
      ! put it back where it should go in original grids solution array
          
      use amr_module
      implicit none

!     Input
      integer  mi,mj,mk,nvar,mitot,mjtot,mktot
      integer  i1,i2,j1,j2,k1,k2,iglo,jglo,kglo

!     Output
      real*8    valbig(nvar,mitot,mjtot,mktot)
      real*8  valpatch(nvar,mi,mj,mk)

!      Local storage
      integer ist, jst, kst, ivar, i, j, k


      ! this ghost cell patch subset goes from (i1,j1,k1) to (i2,j2,k2) in integer index space
      ! the grid (including ghost cells) is from (iglo,jglo,kglo) to (ighi,jghi,kghi)
      ! figure out where to copy
      ist = i1 - iglo    ! offset by 1 below when coyp, since soln array is 1-based
      jst = j1 - jglo 
      kst = k1 - kglo 

      do k = 1, mk 
      do j = 1, mj 
      do i = 1, mi 
      do ivar = 1, nvar
         valbig(ivar,ist+i,jst+j,kst+k) = valpatch(ivar,i,j,k)
      end do
      end do
      end do
      end do

      return
      end

! ============================================================================================

      subroutine auxCopyIn(auxPatch,mi,mj,mk,auxbig,mitot,mjtot,mktot,
     1                     naux,i1,i2,j1,j2,k1,k2,iglo,jglo,kglo)

      ! set the aux array for the patch  to go with the soln vals to  be filled in filpatch,
      ! by copying from valbig's auxbig array

      use amr_module
      implicit none

!     Input
      integer mi, mj, mk, naux, mitot, mjtot, mktot
      integer i1, i2, j1, j2, k1, k2, iglo, jglo, kglo

!     Output
      real*8  auxbig(naux,mitot,mjtot,mktot)
      real*8  auxPatch(naux,mi,mj,mk)
 
!     Local storage
      integer  ist, jst, kst, iaux , i, j, k


       ! this ghost cell patch subset goes from (i1,j1,k1) to (i2,j2,k2) in integer index space
       ! the grid (including ghost cells) is from (iglo,jglo,kglo) to (ighi,jghi,kghi)
       ! figure out where to copy
       ist = i1 - iglo    ! offset by 1 below  since aux arrays are 1-based
       jst = j1 - jglo 
       kst = k1 - kglo 

      do k = 1, mk 
      do j = 1, mj 
      do i = 1, mi 
      do iaux = 1, naux

       auxPatch(iaux,ist+i,jst+j,kst+k) = auxbig(iaux,i,j,k)
 
      end do
      end do
      end do
      end do

      return
      end

c
c
c =========================================================
       subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)
c =========================================================
c
c     # Set initial conditions for q.
c     # Pulse in pressure, zero velocity
c
c
      implicit double precision (a-h,o-z)
      dimension q(meqn, 1-mbc:mx+mbc)
      dimension aux(maux, 1-mbc:mx+mbc)
c
      pi = 4.d0*datan(1.d0)
      width = 0.2d0
c
      do 150 i=1,mx
         xcell = xlower + (i-0.5d0)*dx
         if (dabs(xcell-0.5d0) .le. width) then
             pressure = 1.d0 + dcos(pi*(xcell - 0.5d0)/width)
           else
             pressure = 0.d0
           endif
         q(1,i) = pressure
         q(2,i) = 0.d0
  150    continue
c
      return
      end

subroutine rptt3(ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,bsasdq,cmbsasdq,cpbsasdq)
    ! Riemann solver in the transverse direction for the
    ! advection equations.
    !
    ! On input,
    !
    !    ql,qr is the data along some one-dimensional slice, as in rpn3
    !         This slice is
    !             in the x-direction if ixyz=1,
    !             in the y-direction if ixyz=2, or
    !             in the z-direction if ixyz=3.
    !
    !    bsasdq is an array of flux differences that result from a
    !         transverse splitting (a previous call to rpt3).  
    !         This stands for B^* A^* \Dq but could represent any of 
    !         6 possibilities, e.g.  C^* B^* \Dq, as specified by ixyz
    !         and icoor (see below).
    !         Moreover, each * represents either + or -, as specified by
    !         imp and impt.
    !
    !    ixyz indicates the direction of the original Riemann solve,
    !         called the x-like direction in the table below:
    !
    !               x-like direction   y-like direction   z-like direction
    !      ixyz=1:        x                  y                  z
    !      ixyz=2:        y                  z                  x
    !      ixyz=3:        z                  x                  y
    !
    !    icoor indicates direction in which the transverse solve should
    !         be performed.
    !      icoor=2: split in the y-like direction.
    !      icoor=3: split in the z-like direction.
    !
    !    For example,
    !        ixyz=1, icoor=3 means bsasdq=B^*A^*\Dq, and should be
    !                        split in z into
    !                           cmbsasdq = C^-B^*A^*\Dq,
    !                           cpbsasdq = C^+B^*A^*\Dq.
    !
    !        ixyz=2, icoor=3 means bsasdq=C^*B^*\Dq, and should be
    !                        split in x into
    !                           cmbsasdq = A^-C^*B^*\Dq,
    !                           cpbsasdq = A^+C^*B^*\Dq.
    !
    !    The parameters imp and impt are generally needed only if aux
    !    arrays are being used, in order to access the appropriate
    !    variable coefficients:
    !
    !    imp =  1 if bsasdq = B^*A^- \Dq, a left-going flux difference
    !           2 if bsasdq = B^*A^+ \Dq, a right-going flux difference
    !    impt = 1 if bsasdq = B^-A^* \Dq, a down-going flux difference
    !           2 if bsasdq = B^+A^* \Dq, an up-going flux difference
    !
    !    aux2(:,:,2) is a 1d slice of the aux array along the row
    !                 where the data ql, qr lie.   
    !    aux1(:,:,2) and aux3(:,:,2) are neighboring rows in the 
    !                 y-like direction
    !    aux2(:,:,1) and aux2(:,:,3) are neighboring rows in the 
    !                z-like direction

    implicit none

    integer, intent(in) :: ixyz, icoor, maxm, meqn, mwaves, mbc, mx, maux, imp, impt
    double precision, intent(in) :: ql, qr, bsasdq, aux1, aux2, aux3
    double precision, intent(out) :: cmbsasdq, cpbsasdq

    dimension       ql(meqn,1-mbc:maxm+mbc)
    dimension       qr(meqn,1-mbc:maxm+mbc)
    dimension   bsasdq(meqn,1-mbc:maxm+mbc)
    dimension cmbsasdq(meqn,1-mbc:maxm+mbc)
    dimension cpbsasdq(meqn,1-mbc:maxm+mbc)
    dimension     aux1(maux,1-mbc:maxm+mbc,3)
    dimension     aux2(maux,1-mbc:maxm+mbc,3)
    dimension     aux3(maux,1-mbc:maxm+mbc,3)

    integer :: i, i1, iuvw

    ! set iuvw = 1 for u, 2 for v, 3 for w component of velocity
    ! depending on transverse direction:
    iuvw = ixyz + icoor - 1
    if (iuvw.gt.3) iuvw = iuvw-3

    do i=2-mbc,mx+mbc
        i1 = i-2+imp    !#  =  i-1 for amdq,  i for apdq
        if (icoor == 2) then
            !! double-transverse dir. is the y-like direction
            if (impt == 1) then
                cmbsasdq(1,i) = dmin1(aux2(iuvw,i1,1),0.d0)*bsasdq(1,i)
                cpbsasdq(1,i) = dmax1(aux3(iuvw,i1,1),0.d0)*bsasdq(1,i)
            elseif (impt == 2) then
                cmbsasdq(1,i) = dmin1(aux2(iuvw,i1,3),0.d0)*bsasdq(1,i)
                cpbsasdq(1,i) = dmax1(aux3(iuvw,i1,3),0.d0)*bsasdq(1,i)
            endif
        else
            !! double-transverse dir. is the z-like direction
            if (impt == 1) then
                !! bmasdq is split into cmbmasdq and cpbmasdq
                cmbsasdq(1,i) = dmin1(aux1(iuvw,i1,2),0.d0)*bsasdq(1,i)
                cpbsasdq(1,i) = dmax1(aux1(iuvw,i1,3),0.d0)*bsasdq(1,i)
            elseif (impt == 2) then
                !! bpasdq is split into cmbpasdq and cpbpasdq
                cmbsasdq(1,i) = dmin1(aux3(iuvw,i1,2),0.d0)*bsasdq(1,i)
                cpbsasdq(1,i) = dmax1(aux3(iuvw,i1,3),0.d0)*bsasdq(1,i)
            endif
        endif
    end do

    return
end subroutine rptt3

! ::::::::::::::::::::: flag2refine ::::::::::::::::::::::::::::::::::
!
! User routine to control flagging of points for refinement.
!
! Default version computes spatial difference dq in each direction and
! for each component of q and flags any point where this is greater than
! the tolerance tolsp.  This is consistent with what the routine errsp did in
! earlier versions of amrclaw (4.2 and before).
!
! This routine can be copied to an application directory and modified to
! implement some other desired refinement criterion.
!
! Points may also be flagged for refining based on a Richardson estimate
! of the error, obtained by comparing solutions on the current grid and a
! coarsened grid.  Points are flagged if the estimated error is larger than
! the parameter tol in amr2ez.data, provided flag_richardson is .true.,
! otherwise the coarsening and Richardson estimation is not performed!  
! Points are flagged via Richardson in a separate routine.
!
! Once points are flagged via this routine and/or Richardson, the subroutine
! flagregions is applied to check each point against the min_level and
! max_level of refinement specified in any "region" set by the user.
! So flags set here might be over-ruled by region constraints.
!
!    q   = grid values including ghost cells (bndry vals at specified
!          time have already been set, so can use ghost cell values too)
!
!  aux   = aux array on this grid patch
!
! amrflags  = array to be flagged with either the value
!             DONTFLAG (no refinement needed)  or
!             DOFLAG   (refinement desired)    
!
! tolsp = tolerance specified by user in input file amr1ez.data, used in default
!         version of this routine as a tolerance for spatial differences.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine flag2refine1(mx,mbc,mbuff,meqn,maux,xlower,dx,t,level, &
                            tolsp,q,aux,amrflags)

    use regions_module
    use adjoint_module, only: totnum_adjoints, innerprod_index, &
                              adjoint_flagging,select_snapshots, &
                              calculate_innerproduct
    use amr_module, only : DOFLAG, UNSET

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,mbc,meqn,maux,level,mbuff
    real(kind=8), intent(in) :: xlower,dx,t,tolsp
    
    real(kind=8), intent(in) :: q(meqn,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc)
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbuff:mx+mbuff)
    
    ! Locals
    integer :: i,m,r
    real(kind=8) :: x_c,x_low,x_hi
    real(kind=8) :: dqi(meqn), dq(meqn)

    ! Don't initialize flags, since they were already 
    ! flagged by flagregions2
    ! amrflags = DONTFLAG

    ! Adjoint method specific variables
    logical mask_selecta(totnum_adjoints)

    if(adjoint_flagging) then
        aux(innerprod_index,:) = 0.0
        call select_snapshots(t,mask_selecta)

        ! Loop over adjoint snapshots
        aloop: do r=1,totnum_adjoints

            ! Consider only snapshots that are within the desired time range
            if (mask_selecta(r)) then
                ! Calculate inner product with current snapshot
                call calculate_innerproduct(q,r,mx,xlower,dx,meqn,mbc, &
                                           aux(innerprod_index,:))
            endif

        enddo aloop
    endif
    
    ! Loop over interior points on this grid
    ! (i) grid cell is [x_low,x_hi], cell center at (x_c)
    ! This information is not needed for the default flagging based on
    ! undivided differences, but might be needed in a user's version.
    ! Note that if you want to refine only in certain space-time regions,
    ! it may be easiest to use the "regions" feature.  The flags set here or
    ! in the Richardson error estimator are potentially modified by the
    ! min_level and max_level specified in any regions.
        
    x_loop: do i = 1,mx
        !x_low = xlower + (i - 1) * dx
        !x_c = xlower + (i - 0.5d0) * dx
        !x_hi = xlower + i * dx

        ! -----------------------------------------------------------------
            ! Only check undivided differences if flag hasn't been set yet. 
            ! If flag == DONTFLAG then refinement is forbidden by a region, 
            ! if flag == DOFLAG checking is not needed
            if(amrflags(i) == UNSET) then

                if(adjoint_flagging) then
                    if (aux(innerprod_index,i) > tolsp) then
                        amrflags(i) = DOFLAG
                        cycle x_loop
                    endif
                else
                    dq = 0.d0
                    dqi = abs(q(:,i+1) - q(:,i-1))
                    dq = max(dq,dqi)
                    ! default checks all components of undivided difference:
                    do m=1,meqn
                        if (dq(m) > tolsp) then
                           amrflags(i) = DOFLAG
                           cycle x_loop
                        endif
                    enddo
                endif

            endif

    enddo x_loop
   
end subroutine flag2refine1

c
c ----------------------------------------------------
c
      subroutine domup(iflags2,iflags,ibase,jbase,kbase,
     1                                isize,jsize,ksize,lev)

      use amr_module
      implicit double precision (a-h, o-z)

      integer*1  iflags2(0:isize+1,0:jsize+1,0:ksize+1)
      integer*1  iflags (0:ibase+1,0:jbase+1,0:kbase+1)

c
c ::::::::::::::::::::::::::: DOMUP :::::::::::::::::::::
c 
c  domain flags are in iflags. copy into iflags2, allowing
c  for change of level and dimension
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
         write(outunit,*)" from domup: domflags (before expansion)"
         do 5 kk = 1, kbase
         k = kbase + 1 - kk
         write(outunit,*) 'plane k = ',k
         do 5 jj = 1, jbase
         j = jbase + 1 - jj
         write(outunit,100)(iflags(i,j,k),i=1,ibase)
 5       continue
      endif

      do 10 k = 0, ksize+1
      do 10 j = 0, jsize+1
      do 10 i = 0, isize+1
         iflags2(i,j,k) = 0
 10   continue

      do 20 k = 1, kbase
         kfine = (k-1) * intratz(lev)
      do 20 j = 1, jbase
         jfine = (j-1) * intraty(lev)
      do 20 i = 1, ibase
         ifine = (i-1) * intratx(lev)
         do 25 mk = 1, intratz(lev)
         do 25 mj = 1, intraty(lev)
         do 25 mi = 1, intratx(lev)
            iflags2(ifine+mi,jfine+mj,kfine+mk) = iflags(i,j,k)  
 25      continue
 20   continue
c
c  take care of periodicity again or if border of domain touches a 
c  physical boundary then set domain in ghost cell as well
c
      if (xperdom) then
         do 35 k = 0, ksize+1
         do 35 j = 0, jsize+1
           iflags2(      0,j,k) = iflags2(isize,j,k)
           iflags2(isize+1,j,k) = iflags2(    1,j,k)
 35      continue
       else
         do 65 k = 1, ksize
         do 65 j = 1, jsize
           if (iflags2(    1,j,k) .eq. 1) iflags2(      0,j,k) = 1
           if (iflags2(isize,j,k) .eq. 1) iflags2(isize+1,j,k) = 1
 65    continue
      endif
      if (yperdom) then
         do 45 k = 0, ksize+1
         do 45 i = 0, isize+1
           iflags2(i,      0,k) = iflags2(i,jsize,k)
           iflags2(i,jsize+1,k) = iflags2(i,    1,k)
 45      continue
       else
         do 55 k = 1, ksize
         do 55 i = 1, isize
           if (iflags2(i,    1,k) .eq. 1) iflags2(i,      0,k) = 1
           if (iflags2(i,jsize,k) .eq. 1) iflags2(i,jsize+1,k) = 1
 55      continue
      endif
      if (zperdom) then
         do 75 j = 0, jsize+1
         do 75 i = 0, isize+1
           iflags2(i,j,      0) = iflags2(i,j,ksize)
           iflags2(i,j,ksize+1) = iflags2(i,j,    1)
 75      continue
      else
         do 85 j = 1, jsize
         do 85 i = 1, isize
           if (iflags2(i,j,    1) .eq. 1) iflags2(i,j,      0) = 1
           if (iflags2(i,j,ksize) .eq. 1) iflags2(i,j,ksize+1) = 1
 85      continue
      endif
c
c     corner stuff
c
      do k = 1, ksize
        if (iflags2(0,1,k)+iflags2(1,0,k).eq.2)  iflags2(0,0,k) = 1
        if (iflags2(0,jsize,k)+iflags2(1,jsize+1,k).eq.2)
     .                                       iflags2(0,jsize+1,k) = 1
        if (iflags2(isize,0,k)+iflags2(isize+1,1,k).eq.2)
     .                                       iflags2(isize+1,0,k) = 1
        if (iflags2(isize,jsize+1,k)+iflags2(isize+1,jsize,k).eq.2)
     .                                 iflags2(isize+1,jsize+1,k) = 1
      end do
      do i = 1, isize
        if (iflags2(i,0,1)+iflags2(i,1,0).eq.2)  iflags2(i,0,0) = 1
        if (iflags2(i,jsize,0)+iflags2(i,jsize+1,0).eq.2)
     .                                       iflags2(i,jsize+1,0) = 1
        if (iflags2(i,0,ksize)+iflags2(i,1,ksize+1).eq.2)
     .                                       iflags2(i,0,ksize+1) = 1
        if (iflags2(i,jsize+1,ksize)+iflags2(i,jsize,ksize+1).eq.2)
     .                                 iflags2(i,jsize+1,ksize+1) = 1
      end do
      do j = 1, jsize
        if (iflags2(0,j,1)+iflags2(1,j,0).eq.2)  iflags2(0,j,0) = 1
        if (iflags2(isize,j,0)+iflags2(isize+1,j,1).eq.2)
     .                                       iflags2(isize+1,j,0) = 1
        if (iflags2(0,j,ksize)+iflags2(1,j,ksize+1).eq.2)
     .                                       iflags2(0,j,ksize+1) = 1
        if (iflags2(isize+1,j,ksize)+iflags2(isize,j,ksize+1).eq.2)
     .                                 iflags2(isize+1,j,ksize+1) = 1
      end do

c
c     The neigbors of a corner are the three locations each having an
c     address which differs from that of the corner by 1 in just one of
c     the three indexes. If a corner index is 0, the corresponding neighbor
c     index may be 0 or 1. If a corner index is size+1, the corresponding
c     neighbor index may be size+1 or size (where size => [i,j,k]size).
c
      if (( iflags2(      0,      0,      1)
     &     +iflags2(      0,      1,      0)
     &     +iflags2(      1,      0,      0)) .eq. 3)
     .      iflags2(      0,      0,      0)   =   1
 
      if (( iflags2(isize+1,      0,      1)
     &     +iflags2(isize+1,      1,      0)
     &     +iflags2(isize  ,      0,      0)) .eq. 3)
     .      iflags2(isize+1,      0,      0)   =   1
 
      if (( iflags2(      0,jsize+1,      1)
     &     +iflags2(      0,jsize  ,      0)
     &     +iflags2(      1,jsize+1,      0)) .eq. 3)
     .      iflags2(      0,jsize+1,      0)   =   1
 
      if (( iflags2(isize+1,jsize+1,      1)
     &     +iflags2(isize+1,jsize  ,      0)
     &     +iflags2(isize  ,jsize+1,      0)) .eq. 3)
     .      iflags2(isize+1,jsize+1,      0)   =   1
 
      if (( iflags2(      0,      0,ksize  )
     &     +iflags2(      0,      1,ksize+1)
     &     +iflags2(      1,      0,ksize+1)) .eq. 3)
     .      iflags2(      0,      0,ksize+1)   =   1
 
      if (( iflags2(isize+1,      0,ksize  )
     &     +iflags2(isize+1,      1,ksize+1)
     &     +iflags2(isize  ,      0,ksize+1)) .eq. 3)
     .      iflags2(isize+1,      0,ksize+1)   =   1
 
      if (( iflags2(      0,jsize+1,ksize  )
     &     +iflags2(      0,jsize  ,ksize+1)
     &     +iflags2(      1,jsize+1,ksize+1)) .eq. 3)
     .      iflags2(      0,jsize+1,ksize+1)   =   1
 
      if (( iflags2(isize+1,jsize+1,ksize  )
     &     +iflags2(isize+1,jsize  ,ksize+1)
     &     +iflags2(isize  ,jsize+1,ksize+1)) .eq. 3)
     .      iflags2(isize+1,jsize+1,ksize+1)   =   1


      if (dprint) then
         write(outunit,*)" from domup: domflags (after expansion)"
         do 70 kk = 1, ksize
         k = ksize + 1 - kk
         write(outunit,*) 'plane k = ',k
         do 70 jj = 1, jsize
         j = jsize + 1 - jj
         write(outunit,100)(iflags2(i,j,k),i=1,isize)
 100     format(80i1)
 70      continue
      endif

      return
      end

c
c -----------------------------------------------------------
c
      subroutine findcut(icl,iscr,jscr,kscr,idim,jdim,kdim,index,iside,
     1                   ilo,ihi,jlo,jhi,klo,khi)
c
c ::::::::::::::::::::: FINDCUT ::::::::::::::::::::::::::::;
c   find best place to split the 3D array of flagged points
c   either split at a hole, or use signatures to find
c   zero crossing of laplacian.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      use amr_module
      implicit double precision (a-h,o-z)


      parameter(ithres = 2)
      parameter(minoff = 2)

      dimension iscr(idim), jscr(jdim), kscr(kdim)
      dimension locval(4,3)

c
c  look for holes first in horizontal then vertical then transverse direction
c
       do 10 i = ilo, ihi
          if (iscr(i) .eq. 0) then
             index = i
             iside = iplane
             return
          endif
 10    continue

       do 20 j = jlo, jhi
          if (jscr(j) .eq. 0) then
              index = j
              iside = jplane
              return
          endif
 20    continue

       do 30 k = klo, khi
          if (kscr(k) .eq. 0) then
              index = k
              iside = kplane
              return
          endif
 30    continue

c
c  no holes - find 2nd derivative of signatures for best cut.
c  overwrite signature arrays. don't make cuts less than minoff
c  from boundary
c
      ipre = iscr(ilo)
      do 50 i = ilo+1, ihi-1
         icur = iscr(i)
         iscr(i) = iscr(i+1)-2*icur+ipre
         ipre = icur
 50   continue

      locmaxi = 0
      indexi  = 0
      imid    = (ilo + ihi) / 2
      do 60 i = ilo+minoff, ihi-minoff+1
           itemp1 = iscr(i-1)
           itemp2 = iscr(i)
           locdif = iabs(itemp1-itemp2)
           if (itemp1*itemp2.lt.0) then
                if (locdif .gt. locmaxi) then
                 locmaxi = locdif
                 indexi = i
                else if (locdif .eq. locmaxi) then 
                    if (iabs(i-imid).lt.iabs(indexi-imid)) indexi = i
                endif
           endif
 60   continue              


       jpre   = jscr(jlo)
       do 130 j = jlo+1, jhi-1
           jcur = jscr(j)
           jscr(j) = jscr(j+1)-2*jcur+jpre
           jpre = jcur
 130   continue

       locmaxj = 0
       indexj  = 0
       jmid    = (jlo + jhi) / 2
       do 160 j = jlo+minoff, jhi-minoff+1
           jtemp1 = jscr(j-1)
           jtemp2 = jscr(j)
           locdif = iabs(jtemp1-jtemp2)
           if (jtemp1*jtemp2.lt.0) then
               if (locdif .gt. locmaxj) then
                  locmaxj = locdif
                  indexj = j
                else if (locdif .eq. locmaxj) then
                       if (iabs(j-jmid).lt.iabs(indexj-jmid)) indexj = j
               endif
           endif
 160   continue

       kpre   = kscr(klo)
       do 170 k = klo+1, khi-1
           kcur = kscr(k)
           kscr(k) = kscr(k+1)-2*kcur+kpre
           kpre = kcur
 170   continue
 
       locmaxk = 0
       indexk  = 0
       kmid    = (klo + khi) / 2
       do 180 k = klo+minoff, khi-minoff+1
           ktemp1 = kscr(k-1)
           ktemp2 = kscr(k)
           locdif = iabs(ktemp1-ktemp2)
           if (ktemp1*ktemp2.lt.0) then
               if (locdif .gt. locmaxk) then
                  locmaxk = locdif
                  indexk = k
                else if (locdif .eq. locmaxk) then
                       if (iabs(k-kmid).lt.iabs(indexk-kmid)) indexk = k
               endif
           endif
 180   continue
c
c      ::::: choose max dif for splitting
c      Select the side with the largest locmax.
c      If two are equal and greater than the third,
c      or if all are equal, among the greatest select
c      the one whose locmax is closest to its mid.
c      If two are equal and greater than the third,
c      or if all are equal, among the greatest select
c      the first one arbitrarily.
c
       locval(1,1) = locmaxi
       locval(2,1) = iplane
       locval(3,1) = indexi
       locval(4,1) = imid
       locval(1,2) = locmaxj
       locval(2,2) = jplane
       locval(3,2) = indexj
       locval(4,2) = jmid
       locval(1,3) = locmaxk
       locval(2,3) = kplane
       locval(3,3) = indexk
       locval(4,3) = kmid
 
c      sort in descending order on the value of locmax [locval(1, )]
       do 195 ione=1,2
       do 195 itwo=ione+1,3
          if (locval(1,ione) .lt. locval(1,itwo)) then
             do 190 ii=1,4
                loctmp          = locval(ii,ione)
                locval(ii,ione) = locval(ii,itwo)
                locval(ii,itwo) = loctmp
 190         continue
          end if
 195   continue
       if     (locval(1,1) .gt. locval(1,2)) then
c        locval(1,1) is uniquely greatest
         icount = 1
       elseif (locval(1,2) .gt. locval(1,3)) then
c        locval(1,1) = locval(1,2) but > locval(1,3)
         icount = 2
       else
c        locval(1,1) = locval(1,2) = locval(1,3)
         icount = 3
       end if
 
       if (icount .ne. 1) then
c         sort the first icount entries in ascending order on the abs.val. of
c         the difference between index and mid [locval(3, ) and locval(4, )]
          do 205 ione=1,icount-1
          do 205 itwo=ione+1,icount
             if ((iabs(locval(3,ione)-locval(4,ione))) .gt.
     &           (iabs(locval(3,itwo)-locval(4,itwo)))) then
                do 200 ii=1,4
                   loctmp          = locval(ii,ione)
                   locval(ii,ione) = locval(ii,itwo)
                   locval(ii,itwo) = loctmp
 200            continue
             end if
 205      continue
       end if
 
c      select the first entry
       index  = locval(3,1)
       iside  = locval(2,1)
       locmax = locval(1,1)
 
c      ::::: if inflection pt. not over the threshold, signal
c      ::::: with index 0 (out of range)
       if (locmax .lt. ithres) index = 0
 
       return
       end

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.

    use geoclaw_module, only: sea_level
    use grid_module, only: xcell

    ! uncomment if any of these needed...
    use geoclaw_module, only: dry_tolerance, grav

    implicit none

    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    !locals
    integer :: i
    real(kind=8) :: x0,width,eta

    x0 = -60.d3   ! initial location of step
    width = 30.e3

    do i=1,mx
      !if (xcell(i) > x0) then 
      if ((xcell(i) < x0-width) .or. (xcell(i) > x0)) then 
          eta = 0.d0
        else
          eta = 1.d0
        endif
      q(1,i) = max(0.0, eta - aux(1,i))
      q(2,i) = eta*sqrt(grav*q(1,i))  ! right-going

   enddo


end subroutine qinit

c
c -----------------------------------------------------------
c
      subroutine conck(level, nvar, naux, time, rest)
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical  rest

c      iadd(i,j,ivar)  = loc + i - 1 + mitot*((ivar-1)*mjtot+j-1) OLD INDEXING
c      iaddaux(i,j) = locaux + i - 1 + mitot*(j-1) +
c     .                        mitot*mjtot*(mcapa-1)

c ## indexing into mcapa assumes cell volume is in mcapa location
      iadd(ivar,i)  = loc + ivar - 1 + nvar*(i-1)
      iaddaux(i) = locaux + mcapa - 1 + naux*(i-1)
c
c
c ******************************************************************
c conck - conservation check  for specified level
c         mostly a debugging tool
c         this assumes grids don't overlap
c
c ******************************************************************
c
c
c  grid loop for given level
c
      hx      = hxposs(level)
      dt      = possk(level)
      totmass = 0.d0

      mptr = lstart(level)
 20   if (mptr .eq. 0) go to 85
         loc    = node(store1,mptr)
         locaux = node(storeaux,mptr)
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         mitot  = nx + 2*nghost
c
         if (mcapa .eq. 0) then
           do 50 i  = nghost+1, mitot-nghost
              totmass = totmass + alloc(iadd(1,i))
 50           continue
          else
c          # with capa array:
           do 60 i  = nghost+1, mitot-nghost
              totmass = totmass + alloc(iadd(1,i))*alloc(iaddaux(i))
 60           continue
          endif
c
       mptr = node(levelptr,mptr)
       go to 20
c
 85    totmass = totmass * hx
       if (time.eq. t0 .and. (level.eq.1) .and. .not. rest) then
           tmass0 = totmass
           write(6,*) 'Total mass at initial time: ',tmass0
           endif
       write(outunit,777) time, totmass, totmass-tmass0
 777   format('time t = ',e12.5,',  total mass = ',e22.15, '  diff = ',
     &         e11.4)
c
 99   return
      end

! ============================================================================
!  File:        geoclaw_mod
! ============================================================================
!    Copyright (C) 2010-04-21 Clawpack Developers http://www.clawpack.org
!
!  Distributed under the terms of the Berkeley Software Distribution (BSD)
!  license
!                     http://www.opensource.org/licenses/
! ============================================================================

! Adapted from 2d GeoClaw by deleting some thing that are unused in 1d.
! Other things still remain that are note used in 1d, but they are written to
! data files by default and so still read in here.

module geoclaw_module

    implicit none
    save

    logical, private :: module_setup = .false.
    
    ! ========================================================================
    !  Constants
    ! ========================================================================
    integer, parameter :: GEO_PARM_UNIT = 78
    integer, parameter :: KAPPA_UNIT = 42
    real(kind=8), parameter :: pi = 4.d0*datan(1.d0)
    real(kind=8), parameter :: DEG2RAD = pi / 180.d0
    real(kind=8), parameter :: RAD2DEG = 180.d0 / pi
    
    ! ========================================================================
    !  Physics
    ! ========================================================================
    real(kind=8) :: grav, rho_air, ambient_pressure, earth_radius, sea_level
    ! Water density can be an array to handle multiple layers
    real(kind=8), allocatable :: rho(:)
    integer :: coordinate_system, sphere_source

    ! Rotational velocity of Earth
    real(kind=8), parameter :: omega = 2.0d0 * pi / 86164.2d0
    
    ! Forcing
    logical :: coriolis_forcing ! True then coriolis terms included in src
    real(kind=8) :: theta_0 ! Used if using the beta-plane approximation
    logical :: friction_forcing ! Friction forcing will be applied
    real(kind=8), dimension(:),allocatable :: manning_coefficient, manning_break
    integer :: num_manning
    real(kind=8) :: friction_depth
    real(kind=8) :: friction_coefficient ! used in src2 rather than manning
    
    ! Method parameters    
    real(kind=8) :: dry_tolerance

contains

    ! ========================================================================
    !  set_geo(fname)
    ! ========================================================================
    !  Reads in user parameters from the given file name if provided
    ! ========================================================================
    subroutine set_geo(file_name)

        use utility_module, only: get_value_count
        
        !use amr_module, only: mcapa, rinfinity

        implicit none

        ! Input
        character(len=*), intent(in), optional :: file_name

        ! Locals
        integer, parameter :: unit = 127

        integer :: i
        character(len=128) :: line

        real(kind=8), parameter :: rinfinity = 10.e32

        if (.not.module_setup) then
            open(unit=GEO_PARM_UNIT,file='fort.geo',status="unknown",action="write")

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'Physics Parameters:'
            write(GEO_PARM_UNIT,*) '-------------------'

            ! Read user parameters from setgeo.data
            if (present(file_name)) then
                call opendatafile(unit, file_name)
            else
                call opendatafile(unit, 'geoclaw.data')
            endif

            read(unit,*) grav
            read(unit,'(a)') line
            allocate(rho(get_value_count(line)))
            read(line,*) (rho(i), i=1, size(rho, 1))
            read(unit,*) rho_air
            read(unit,*) ambient_pressure
            read(unit,*) earth_radius
            read(unit,*) coordinate_system
            read(unit,*) sphere_source
            read(unit,*) sea_level
            read(unit,*)
            read(unit,*) coriolis_forcing
            if (coordinate_system == 1 .and. coriolis_forcing) then
                read(unit,*) theta_0
            else
                theta_0 = 0.d0
            endif
            read(unit,*) friction_forcing
            if (friction_forcing) then
                read(unit,*) num_manning
                if (num_manning > 1) then
                    write(6,*) '*** num_manning > 1 not yet implemented'
                    stop
                    endif
                allocate(manning_coefficient(num_manning))
                allocate(manning_break(num_manning))
                manning_break(num_manning) = rinfinity
                read(unit,*) manning_coefficient(:)
                read(unit,*) manning_break(1:num_manning-1)
                read(unit,*) friction_depth
                friction_coefficient = manning_coefficient(1) ! used in src2
            else
                friction_depth = rinfinity
            endif
            read(unit,*)
            read(unit,*) dry_tolerance
            
            close(unit)


            write(GEO_PARM_UNIT,*) '   gravity:',grav
            write(GEO_PARM_UNIT,*) '   density water:',rho
            write(GEO_PARM_UNIT,*) '   density air:',rho_air
            write(GEO_PARM_UNIT,*) '   ambient pressure:',ambient_pressure
            write(GEO_PARM_UNIT,*) '   earth_radius:',earth_radius
            write(GEO_PARM_UNIT,*) '   coordinate_system:',coordinate_system
            write(GEO_PARM_UNIT,*) '   sea_level:',sea_level
            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '   coriolis_forcing:',coriolis_forcing
            write(GEO_PARM_UNIT,*) '   theta_0:',theta_0
            write(GEO_PARM_UNIT,*) '   friction_forcing:',friction_forcing
            if (friction_forcing) then
                write(GEO_PARM_UNIT,*) '   manning_coefficient:', manning_coefficient
                write(GEO_PARM_UNIT,*) '   friction_depth:',friction_depth
            else
                write(GEO_PARM_UNIT,*) '   manning_coefficient: not used'
                write(GEO_PARM_UNIT,*) '   friction_depth: not used'
            end if

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '   dry_tolerance:', dry_tolerance

            module_setup = .true.
        end if

    end subroutine set_geo

end module geoclaw_module

c
c -----------------------------------------------------------
c
      subroutine flglvl(nvar,naux,lcheck,nxypts,index,lbase,
     1                  i1flags,npts,t0,isize,jsize,ksize)
c
      use amr_module
      implicit double precision (a-h,o-z)

      integer*1 i1flags(isize+2,jsize+2,ksize+2)
      integer*1 dom1flags(isize+2,jsize+2,ksize+2)
c
c :::::::::::::::::::: FLGLVL :::::::::::::::::::::::::::::::::
c
c flglvl = controls the error estimation/flagging bad pts. for
c          an entire level of grids.  returns pointer into alloc
c          where the (x,y,z) coordinations of the flagged pts. are.
c input parameters:
c           lcheck = level to be flagged
c output parameters:
c           nxypts = no. of flagged pts. total
c           index  = starting index in alloc of the flagged pts.
c                    (which occupy numdim*nxypts locations).
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c
      nxypts = 0
c
c   reserve space for entire domain worth of flagged points at
c   level lcheck. bits would be better, but integer will do
c   dom2 - holds domain flags
c   dom  - holds flagged pts.
c   dom3 - scratch
c
      isize = iregsz(lcheck)
      jsize = jregsz(lcheck)
      ksize = kregsz(lcheck)
c    ldom  = igetsp((isize+2)*(jsize+2)*(ksize+2))

c    
c   prepare domain in ldom2 (so can use ldom as scratch array before 
c   putting in the flags)
c
      idim = iregsz(lbase)
      jdim = jregsz(lbase)
      kdim = kregsz(lbase)
      call domprep(i1flags,lbase,idim,jdim,kdim)
      call domshrink(i1flags,dom1flags,idim,jdim,kdim)

      do 6 lev = lbase+1, lcheck
         call domup(i1flags,dom1flags,idim,jdim,kdim,
     1              intratx(lev-1)*idim,intraty(lev-1)*jdim,
     2              intratz(lev-1)*kdim,lev-1)
        idim = intratx(lev-1)*idim
        jdim = intraty(lev-1)*jdim
        kdim = intratz(lev-1)*kdim
         call domshrink(i1flags,dom1flags,idim,jdim,kdim)
 6    continue
c     # finish by transferring from iflags to iflags2
      call domcopy(i1flags,dom1flags,isize,jsize,ksize)
c
      numbad = 0
c     always call spest to set up stuff (initialize iflags, fill locbig)
      call spest(nvar,naux,lcheck,dom1flags,isize,jsize,ksize,
     1           tstart_thisrun)
      if (flag_richardson) call errest(nvar,naux,lcheck)

      call bufnst(nvar,naux,numbad,lcheck,dom1flags,isize,jsize,ksize)
      nxypts = nxypts + numbad
c
c  colate flagged pts into flagged points array
c
      if (nxypts .gt. 0) then
          index = igetsp(3*nxypts)
          call colate(alloc(index),nxypts,lcheck,
     1                dom1flags,i1flags,isize,jsize,ksize,npts)
      else 
          npts = nxypts
      endif
c
c      call reclam(ldom,  (isize+2)*(jsize+2)*(ksize+2))

      return
      end

c
c ----------------------------------------------------
c
      subroutine domcopy(iflags2,iflags,isize,jsize)

      use amr_module
      implicit double precision (a-h, o-z)


      integer(kind=1)  iflags2(0:isize+1,0:jsize+1)
      integer(kind=1)  iflags (0:isize+1,0:jsize+1)

c
c ::::::::::::::::::::::::::: DOMCOPY :::::::::::::::::::::
c 
!>  domain flags are in iflags. copy into iflags2.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::


      do j = 0, jsize+1
      do i = 0, isize+1
         iflags2(i,j) = iflags(i,j)
      end do
      end do
c
c  take care of periodicity again
c
      if (xperdom) then
         do 35 j = 0, jsize+1
           iflags2(0,j)       = iflags2(isize,j)
           iflags2(isize+1,j) = iflags2(1,j)
 35      continue
       else
         do 55 j = 1, jsize
           if (iflags2(1,j) .eq. 1) iflags2(0,j) = 1
           if (iflags2(isize,j) .eq. 1) iflags2(isize+1,j) = 1
 55      continue
      endif
      if (yperdom) then
         do 45 i = 0, isize+1
           iflags2(i,0)       = iflags2(i,jsize)
           iflags2(i,jsize+1) = iflags2(i,1)
 45      continue
       else if (spheredom) then
         do 46 i = 0, isize+1
         iflags2(i,0)       = iflags2(isize+1-i,1)
         iflags2(i,jsize+1) = iflags2(isize+1-i,jsize)
 46      continue
       else
         do 65 i = 1, isize
           if (iflags2(i,1) .eq. 1) iflags2(i,0) = 1
           if (iflags2(i,jsize) .eq. 1) iflags2(i,jsize+1) = 1
 65      continue
      endif

      if (dprint) then
         write(outunit,*)" from domcopy: domflags "
         do 40 jj = 1, jsize
         j = jsize + 1 - jj
         write(outunit,100)(iflags2(i,j),i=1,isize)
 100     format(80i1)
 40      continue
      endif

 
      return
      end

!-----------------------------------------------------------------------------------
! Name: rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
!
! Description: Roe f-wave solver for the 3D Euler equations in general geometries
!
! Waves: 3
! Equations: 5
!
! Conserved Quantities:
!       1 density
!       2 x_momentum
!       3 y_momentum
!       4 z_momentum
!       5 energy
!
! Auxilliary Quantities:
!       1  nx xface (i-1/2,j,k)
!       2  ny xface (i-1/2,j,k)
!       3  nz xface (i-1/2,j,k)
!       4  gamma_x (area/(dyc*dzc))
!       5  nx yface (i,j-1/2,k)
!       6  ny yface (i,j-1/2,k)
!       7  nz yface (i,j-1/2,k)
!       8  gamma_x (area/(dxc*dzc))
!       9  nx zface (i,j,k-1/2)
!       10 ny zface (i,j,k-1/2)
!       11 nz zface (i,j,k-1/2)
!       12 gamma_z (area/(dxc*dyc))
!       13 kappa(i,j,k) volumeOfHex/(dxc*dyc*dzc)
!       14 dz (Cartesian), dr (Spherical)
!       15 z (Cartesian), r (Spherical)
!
! Inputs: 
!         ixyz <INTEGER>   : direction to take slice x-direction if ixyz=1
!                                                    y-direction if ixyz=2.
!                                                    z-direction if ixyz=3.
!         maxm <INTEGER>   : max number of grid cells (less the ghost cells)
!         meqn <INTEGER>   : number of equations in the system (=5)
!         mwaves <INTEGER> : nuber of waves in the system (=3)
!         maux <INTEGER>   : number of auxilary variables (=15)
!         mbc <INTEGER>    : number of ghost cells on either end
!         mx <INTEGER>     : number of elements
!         ql <REAL>        : state vector at left edge of each cell
!                            Note the i'th Riemann problem has left state qr(:,i-1)
!         qr <REAL>        : state vector at right edge of each cell
!                            Note the i'th Riemann problem has right state ql(:,i)
!         auxl <REAL>      : state of auxilary variable on left egde of cell 
!         auxr <REAL>      : state of auxilary variable on right egde of cell 
!         
! Outputs: 
!          fwave <REAL>    : f-wave vectors (eigenvectors of Roe matrix)
!          s <REAL>        : eigenvalues (eigenvalues of Roe matrix)
!          amdq <REAL>     : left-going fluctuations
!          apdq <REAL>     : right-going fluctuations
!
! Adapted from rpn3_euler.f90 in $CLAWHOME/riemann/src
!-----------------------------------------------------------------------------------
SUBROUTINE rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)

  IMPLICIT NONE

  ! Input
  INTEGER, INTENT(IN) :: ixyz,maxm,meqn,mwaves,maux,mbc,mx
  REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(IN) :: ql,qr
  REAL(kind=8), DIMENSION(maux,1-mbc:maxm+mbc), INTENT(IN) :: auxl,auxr

  ! Output
  REAL(kind=8), DIMENSION(meqn,mwaves,1-mbc:maxm+mbc), INTENT(INOUT) :: fwave
  REAL(kind=8), DIMENSION(mwaves,1-mbc:maxm+mbc), INTENT(INOUT) :: s
  REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(INOUT) :: amdq,apdq
  
  ! Local Storage
  REAL(kind=8), DIMENSION(meqn) :: delta,beta
  REAL(kind=8), DIMENSION(-1:maxm+mbc) :: u,v,w,enth,ek,a,a2g1,psi
  REAL(kind=8) :: gamma1,asqrd,pl,pr,vnl,vnr,rhsq2,rhsqrtl,rhsqrtr,nx,ny,nz,vn,&
       areaRatio,dr,finterp,qinterp,quinterp,qvinterp,qwinterp
  INTEGER :: i,j,mu=2,mv=3,mw=4,mws,nu,nv,nw,iratio=4,gFlux=0
  CHARACTER(20) :: nonsingularNormal

  ! Common block storage for ideal gas constant and gravity term
  REAL(kind=8) :: gamma ! Ideal gas constant
  REAL(kind=8) :: g_r  ! Gravitational Constant Magnitude
  LOGICAL :: gravity,gravityflux ! Turn Gravity Source Term On/Off
  COMMON /cparam/ gamma,g_r,gravity,gravityflux

  ! Set (gamma-1)
  gamma1 = gamma - 1.d0

  ! Gravity in Energy Flux On/Off
  gFlux = 0
  IF(gravityflux)gFlux=1

  ! Make sure the number of waves is 3 for this solver
  IF (mwaves /= 3) THEN
     WRITE(6,*) '*** Must set mwaves=3 for this Riemann solver'
     STOP
  ENDIF
    
  ! Set mu to point to  the component of the system that corresponds to momentum in 
  !  the direction of this slice, mv and mw to the orthogonal momentums.  Set the
  !  nu,nv,and nw indices for the normal vectors in a similar way.  The iratio is
  !  the aux array index for the gamma area scaling for mapped grids.
  IF(ixyz == 1)THEN
     mu = 2
     mv = 3
     mw = 4
     iratio = 4
  ELSE IF(ixyz == 2)THEN
     mu = 3
     mv = 4
     mw = 2
     iratio = 8
  ELSE IF (ixyz == 3)THEN
     mu = 4
     mv = 2
     mw = 3
     iratio = 12
  ELSE
     WRITE(*,*)"Something is wrong with ixyz..."
     STOP
  ENDIF
  nu = (ixyz-1)*4 + mu - 1
  nv = (ixyz-1)*4 + mv - 1
  nw = (ixyz-1)*4 + mw - 1

  ! Note that notation for u,v, and w reflects assumption that the
  !   Riemann problems are in the x-direction with u in the normal
  !   direction and v and w in the orthogonal directions, but with the
  !   above definitions of mu, mv, and mw the routine also works with
  !   ixyz=2 and ixyz = 3
  !   and returns, for example, f0 as the Godunov flux g0 for the
  !   Riemann problems u_t + g(u)_y = 0 in the y-direction.
  
  ! Initialize fwaves and speeds
  fwave = 0.d0
  s = 0.d0

  ! Loop over grid cell interfaces
  DO i = 2-mbc, mx+mbc
     IF (qr(1,i-1) <= 0.d0 .OR. ql(1,i) <= 0.d0) THEN
        WRITE(*,*) i, mu, mv, mw
        WRITE(*,'(5e12.4)') (qr(j,i-1),j=1,5)
        WRITE(*,'(5e12.4)') (ql(j,i),j=1,5)
        IF (ixyz == 1) WRITE(6,*) '*** (rpn3) rho <= 0 in x-sweep at ',i
        IF (ixyz == 2) WRITE(6,*) '*** (rpn3) rho <= 0 in y-sweep at ',i
        IF (ixyz == 3) WRITE(6,*) '*** (rpn3) rho <= 0 in z-sweep at ',i
        WRITE(6,*) 'stopped with rho <= 0...'
        STOP
     ENDIF
     rhsqrtl = SQRT(qr(1,i-1))
     rhsqrtr = SQRT(ql(1,i))
     pl = gamma1*(qr(5,i-1) - 0.5d0*(qr(mu,i-1)**2 + &
          qr(mv,i-1)**2 + qr(mw,i-1)**2)/qr(1,i-1) &
          - qr(1,i-1)*(g_r)*auxr(15,i-1)*gFlux )
     pr = gamma1*(ql(5,i) - 0.5d0*(ql(mu,i)**2 + &
          ql(mv,i)**2 + ql(mw,i)**2)/ql(1,i) &
          - ql(1,i)*(g_r)*auxl(15,i)*gFlux )
     rhsq2 = rhsqrtl + rhsqrtr
     u(i) = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
     v(i) = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
     w(i) = (qr(mw,i-1)/rhsqrtl + ql(mw,i)/rhsqrtr) / rhsq2
     enth(i) = ((qr(5,i-1)+pl)/rhsqrtl + (ql(5,i)+pr)/rhsqrtr) / rhsq2
     psi(i) = (qr(1,i-1)*(g_r)*auxr(15,i-1)/rhsqrtl &
          + ql(1,i)*(g_r)*auxl(15,i)/rhsqrtr)/rhsq2*gFlux
     ek(i) = 0.5d0*(u(i)**2 + v(i)**2 + w(i)**2)
     asqrd = gamma1*(enth(i) - ek(i))
     IF (i>=0 .AND. i<=mx .AND. asqrd <= 0.d0) THEN
        IF (ixyz == 1) WRITE(6,*) '*** (rpn3) a**2 <= 0 in x-sweep at ',i
        IF (ixyz == 2) WRITE(6,*) '*** (rpn3) a**2 <= 0 in y-sweep at ',i
        IF (ixyz == 3) WRITE(6,*) '*** (rpn3) a**2 <= 0 in z-sweep at ',i
        WRITE(6,*) 'stopped with a**2 < 0...'
        STOP
     ENDIF
     a(i) = SQRT(asqrd)
     a2g1(i)  = asqrd/gamma1
  END DO

  ! Now split the jump in q1d at each interface into f-waves
  !   find alpha(1) thru alpha(5), the coefficients of the 5 eigenvectors:
  DO i = 2-mbc, mx+mbc
     
     ! Normal Vectors, Normal Velocity, and Area Ratio
     nx = auxl(nu,i)
     ny = auxl(nv,i)
     nz = auxl(nw,i)
     vn = u(i)*nx + v(i)*ny + w(i)*nz
     areaRatio = auxl(iratio,i)

     ! Compute the jumps (delta F) in the flux functions
     pl = gamma1*(ql(5,i) &
          - 0.5d0*(ql(mu,i)**2+ql(mv,i)**2+ql(mw,i)**2)/ql(1,i) &
          - ql(1,i)*(g_r)*auxl(15,i)*gFlux)
     pr = gamma1*(qr(5,i-1) &
          - 0.5d0*(qr(mu,i-1)**2+qr(mv,i-1)**2+qr(mw,i-1)**2)/qr(1,i-1) &
          - qr(1,i-1)*(g_r)*auxr(15,i-1)*gFlux)
     vnl = (ql(mu,i)*nx + ql(mv,i)*ny + ql(mw,i)*nz)/ql(1,i)
     vnr = (qr(mu,i-1)*nx + qr(mv,i-1)*ny + qr(mw,i-1)*nz)/qr(1,i-1)
     delta(1) = ql(1,i)*vnl - qr(1,i-1)*vnr
     delta(2) = (vnl*ql(mu,i) + pl*nx) - (vnr*qr(mu,i-1) + pr*nx)
     delta(3) = (vnl*ql(mv,i) + pl*ny) - (vnr*qr(mv,i-1) + pr*ny)
     delta(4) = (vnl*ql(mw,i) + pl*nz) - (vnr*qr(mw,i-1) + pr*nz)
     delta(5) = ((ql(5,i) + pl)*vnl) - ((qr(5,i-1) + pr)*vnr)
     
     ! Modify delta(2/3/4/5) to account for gravitational term
     IF(gravity .AND. ixyz==3)THEN
        dr = (auxl(14,i) + auxl(14,i-1))*0.5d0
        finterp = auxl(14,i-1)/(auxl(14,i)+auxl(14,i-1))
        qinterp = ql(1,i)*finterp + qr(1,i-1)*(1.d0-finterp)
        quinterp = ql(mu,i)*finterp + qr(mu,i-1)*(1.d0-finterp)
        qvinterp = ql(mv,i)*finterp + qr(mv,i-1)*(1.d0-finterp)
        qwinterp = ql(mw,i)*finterp + qr(mw,i-1)*(1.d0-finterp)
        delta(2) = delta(2) + dr*g_r*nx*qinterp
        delta(3) = delta(3) + dr*g_r*ny*qinterp
        delta(4) = delta(4) + dr*g_r*nz*qinterp
        IF(.NOT.gravityflux)&
             delta(5) = delta(5) + dr*g_r*(quinterp*nx + qvinterp*ny + qwinterp*nz)
     END IF

     ! Pick the largest normal to avoid using a singular direction
     IF(ABS(nx) >= ABS(ny) .AND. ABS(nx) >= ABS(nz))THEN
        nonsingularNormal = "x"
     ELSEIF(ABS(ny) >= ABS(nx) .AND. ABS(ny) >= ABS(nz))THEN
        nonsingularNormal = "y"
     ELSEIF(ABS(nz) >= ABS(nx) .AND. ABS(nz) >= ABS(ny))THEN
        nonsingularNormal = "z"
     ELSE
        WRITE(*,*)"Invalid Normal Vector..."
        WRITE(*,*)"nx: ",nx,"ny: ",ny,"nz: ",nz
        STOP
     END IF

     beta(4) = ((enth(i) + psi(i) - 2.d0*ek(i))*delta(1) &
          + u(i)*delta(2) + v(i)*delta(3) + w(i)*delta(4) - delta(5))/a2g1(i)
     beta(5) = ( (a(i)-vn)*delta(1) - a(i)*beta(4) &
          + nx*delta(2) + ny*delta(3) + nz*delta(4) )/(2.d0*a(i))
     beta(1) = delta(1) - beta(4) - beta(5)

     SELECT CASE(TRIM(nonsingularNormal))
     CASE("x")
        beta(2) = ( (v(i)-vn*ny)*delta(1) + nx*ny*delta(2) &
             + (ny**2-1.d0)*delta(3) + ny*nz*delta(4) )/nx
        beta(3) = (-(w(i)-vn*nz)*delta(1) - nx*nz*delta(2) &
             - ny*nz*delta(3) - (nz**2-1.d0)*delta(4) )/nx
     CASE("y")
        beta(2) = (-(u(i)-vn*nx)*delta(1) - (nx**2-1.d0)*delta(2) &
             - ny*nx*delta(3) - nx*nz*delta(4) )/ny
        beta(3) = ( (w(i)-vn*nz)*delta(1) + nx*nz*delta(2) &
             + ny*nz*delta(3) + (nz**2-1.d0)*delta(4) )/ny
     CASE("z")
        beta(2) = ( (u(i)-vn*nx)*delta(1) + (nx**2-1.d0)*delta(2) &
             + nx*ny*delta(3) + nz*nx*delta(4) )/nz
        beta(3) = (-(v(i)-vn*ny)*delta(1) - nx*ny*delta(2) &
             - (ny**2-1.d0)*delta(3) - nz*ny*delta(4) )/nz
     END SELECT
     
     ! Compute the f-waves.
     !   Note that the 2-wave, 3-wave and 4-wave travel at the same speed
     !   and are lumped together in fwave(.,2,.).  The 5-wave is then stored
     !   in fwave(.,3,.).
     fwave(1,1,i)  = beta(1)
     fwave(mu,1,i) = beta(1)*(u(i)-a(i)*nx)
     fwave(mv,1,i) = beta(1)*(v(i)-a(i)*ny)
     fwave(mw,1,i) = beta(1)*(w(i)-a(i)*nz)
     fwave(5,1,i)  = beta(1)*(enth(i) + psi(i) - a(i)*vn)
     s(1,i) = (vn-a(i))*areaRatio
     
     fwave(1,2,i)  = beta(4)
     SELECT CASE(TRIM(nonsingularNormal))
     CASE("x")
        fwave(mu,2,i) = beta(4)*u(i) + beta(2)*ny - beta(3)*nz
        fwave(mv,2,i) = beta(4)*v(i) - beta(2)*nx
        fwave(mw,2,i) = beta(4)*w(i) + beta(3)*nx
        fwave(5,2,i)  = beta(4)*(ek(i) + psi(i))  &
             + beta(2)*(u(i)*ny-v(i)*nx) + beta(3)*(w(i)*nx-u(i)*nz)
     CASE("y")
        fwave(mu,2,i) = beta(4)*u(i) + beta(2)*ny
        fwave(mv,2,i) = beta(4)*v(i) - beta(2)*nx + beta(3)*nz
        fwave(mw,2,i) = beta(4)*w(i) - beta(3)*ny
        fwave(5,2,i)  = beta(4)*(ek(i) + psi(i))  &
             + beta(2)*(u(i)*ny-v(i)*nx) + beta(3)*(v(i)*nz-w(i)*ny)
     CASE("z")
        fwave(mu,2,i) = beta(4)*u(i) - beta(2)*nz
        fwave(mv,2,i) = beta(4)*v(i) + beta(3)*nz
        fwave(mw,2,i) = beta(4)*w(i) + beta(2)*nx - beta(3)*ny
        fwave(5,2,i)  = beta(4)*(ek(i) + psi(i))  &
             + beta(2)*(w(i)*nx-u(i)*nz) + beta(3)*(v(i)*nz-w(i)*ny)
     END SELECT
     s(2,i) = vn*areaRatio
     
     fwave(1,3,i)  = beta(5)
     fwave(mu,3,i) = beta(5)*(u(i)+a(i)*nx)
     fwave(mv,3,i) = beta(5)*(v(i)+a(i)*ny)
     fwave(mw,3,i) = beta(5)*(w(i)+a(i)*nz)
     fwave(5,3,i)  = beta(5)*(enth(i) + psi(i) + a(i)*vn)
     s(3,i) = (vn+a(i))*areaRatio

     ! Compute fluctuations amdq and apdq
     !  amdq = SUM s*fwave   over left-going waves
     !  apdq = SUM s*fwave   over right-going waves
     amdq(:,i) = 0.d0
     apdq(:,i) = 0.d0
     DO mws=1,mwaves
        fwave(:,mws,i) = fwave(:,mws,i)*areaRatio
        IF (s(mws,i) < 0.d0) THEN
           amdq(:,i) = amdq(:,i) + fwave(:,mws,i)
        ELSE
           apdq(:,i) = apdq(:,i) + fwave(:,mws,i)
        ENDIF
     END DO

  END DO
END SUBROUTINE rpn3

c     
c     
c=========================================================
      subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)
c=========================================================
c     
c     # Set initial conditions for q.
c     # Pulse in pressure, zero velocity
c     
c     
      implicit none

      integer, intent(in) :: meqn, mbc, mx, maux
      double precision, intent(in) :: xlower, dx, aux
      double precision, intent(out) :: q
      dimension q(meqn, 1-mbc:mx+mbc)
      dimension aux(maux, 1-mbc:mx+mbc)

      common /cqinit/ beta
      double precision beta

      integer i
      double precision xcell
c     
c     
      do 150 i=1,mx
         xcell = xlower + (i-0.5d0)*dx

         q(1,i) = dexp(-beta*(xcell-1.5d0)**2)
         q(2,i) = 0.d0
 150  continue
c
      return
      end

!==================================================================
subroutine step3(maxm,num_eqn,num_waves,num_ghost,mx,my, &
    mz,qold,qnew,aux,dx,dy,dz,dt,method,mthlim,cfl, &
    qadd,fadd,gadd,hadd,q1d,dtdx1d,dtdy1d,dtdz1d, &
    aux1,aux2,aux3,num_aux,work,mwork,use_fwave,rpn3,rpt3,rptt3)
!==================================================================

!     # Take one time step, updating q.
!     # On entry, qold and qnew should be identical and give the
!     #    initial data for this step
!     # On exit, qnew returns values at the end of the time step.
!     #    qold is unchanged.

!     # qadd is used to return increments to q from flux3.
!     # fadd, gadd and hadd are used to return flux increments from flux3.
!     # See the flux3 documentation for more information.

    !$ use omp_lib

    implicit real*8(a-h,o-z)
    external rpn3,rpt3,rptt3
    dimension qold(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension qnew(num_eqn, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension  q1d(num_eqn,1-num_ghost:maxm+num_ghost,*)
    dimension qadd(num_eqn,1-num_ghost:maxm+num_ghost,*)
    dimension fadd(num_eqn,1-num_ghost:maxm+num_ghost,*)
    dimension gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost,*)
    dimension hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost,*)
    dimension aux(num_aux, 1-num_ghost:mx+num_ghost, &
    1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost,3,*)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost,3,*)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost,3,*)
    dimension dtdx1d(1-num_ghost:maxm+num_ghost,*)
    dimension dtdy1d(1-num_ghost:maxm+num_ghost,*)
    dimension dtdz1d(1-num_ghost:maxm+num_ghost,*)
    dimension method(7),mthlim(num_waves)
    dimension work(mwork)

    logical :: use_fwave

    ! These block sizes must be at least 2 to avoid multiple threads
    ! trying to update the same grid cell
    integer, parameter :: blksiz_i = 2, blksiz_j = 2, blksiz_k = 2

!f2py intent(out) cfl
!f2py intent(in,out) qnew
!f2py optional q1d, qadd, fadd, gadd, hadd, dtdx1d, dtdy1d, dtdz1d

! Dummy interfaces just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn3(x)
!f2py x=rpt3(x)
!f2py x=rptt3(x)

    common /comxyzt/ dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom

!     # partition work array into pieces needed for local storage in
!     # flux3 routine.  Find starting index of each piece:

    nthreads=1    ! Serial
    !$omp parallel
    !$omp single
    !$ nthreads = omp_get_num_threads()
    !$omp end single
    !$omp end parallel

    nsiz = (maxm+2*num_ghost)*num_eqn
    nsiz_w = nsiz * num_waves
    nsiz_s = (maxm+2*num_ghost)*num_waves

    i0wave     = 1 
    i0s        = i0wave     + nsiz_w*nthreads
    i0amdq     = i0s        + nsiz_s*nthreads
    i0apdq     = i0amdq     + nsiz*nthreads
    i0cqxx     = i0apdq     + nsiz*nthreads
    i0bmamdq   = i0cqxx     + nsiz*nthreads
    i0bmapdq   = i0bmamdq   + nsiz*nthreads
    i0bpamdq   = i0bmapdq   + nsiz*nthreads
    i0bpapdq   = i0bpamdq   + nsiz*nthreads
    i0cmamdq   = i0bpapdq   + nsiz*nthreads
    i0cmapdq   = i0cmamdq   + nsiz*nthreads
    i0cpamdq   = i0cmapdq   + nsiz*nthreads
    i0cpapdq   = i0cpamdq   + nsiz*nthreads
    i0cmamdq2  = i0cpapdq   + nsiz*nthreads
    i0cmapdq2  = i0cmamdq2  + nsiz*nthreads
    i0cpamdq2  = i0cmapdq2  + nsiz*nthreads
    i0cpapdq2  = i0cpamdq2  + nsiz*nthreads
    i0bmcqxxp  = i0cpapdq2  + nsiz*nthreads
    i0bmcqxxm  = i0bmcqxxp  + nsiz*nthreads
    i0bpcqxxp  = i0bmcqxxm  + nsiz*nthreads
    i0bpcqxxm  = i0bpcqxxp  + nsiz*nthreads
    i0cmcqxxp  = i0bpcqxxm  + nsiz*nthreads
    i0cmcqxxm  = i0cmcqxxp  + nsiz*nthreads
    i0cpcqxxp  = i0cmcqxxm  + nsiz*nthreads
    i0cpcqxxm  = i0cpcqxxp  + nsiz*nthreads
    i0bmcmamdq = i0cpcqxxm  + nsiz*nthreads
    i0bmcmapdq = i0bmcmamdq + nsiz*nthreads
    i0bpcmamdq = i0bmcmapdq + nsiz*nthreads
    i0bpcmapdq = i0bpcmamdq + nsiz*nthreads
    i0bmcpamdq = i0bpcmapdq + nsiz*nthreads
    i0bmcpapdq = i0bmcpamdq + nsiz*nthreads
    i0bpcpamdq = i0bmcpapdq + nsiz*nthreads
    i0bpcpapdq = i0bpcpamdq + nsiz*nthreads
    iused      = i0bpcpapdq + nsiz*nthreads - 1

    if (iused > mwork) then
    !        # This shouldn't happen due to checks in claw3
        write(6,*) '*** not enough work space in step3'
        write(6,*) '*** iused = ', iused, '   mwork =',mwork
        stop
    endif



    index_capa = method(6)
!      num_aux = method(7)
    cfl = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy
    dtdz = dt/dz

    ! Calculate the number of blocks to use in each grid direction
    ! (integer division, rounding up)
    nblk_i = (mx + blksiz_i + 1)/blksiz_i
    nblk_j = (my + blksiz_j + 1)/blksiz_j
    nblk_k = (mz + blksiz_k + 1)/blksiz_k

    !$omp parallel private(me,me1,m,i,j,k,ma,ia,ja,ka,cfl1d,ioffset,joffset,koffset, &
    !$omp                  iblk,jblk,kblk) reduction(max:cfl)

    me = 0
    !$ me = omp_get_thread_num()
    me1 = me + 1

    if (index_capa == 0) then
        ! no capa array:
        do i=1-num_ghost,maxm+num_ghost
            dtdx1d(i,me1) = dtdx
            dtdy1d(i,me1) = dtdy
            dtdz1d(i,me1) = dtdz
        end do
    endif

    ! perform x-sweeps
    !==================

    ! This block-based approach keeps race conditions from happening
    ! with OpenMP parallelization.  Because the results of the flux3
    ! call affect the column flux3 was called on and all adjacent
    ! columns, an easy way to keep threads from interfering with each
    ! other is to make sure that every thread takes a column that is
    ! at least three cells away from all the other threads in each
    ! direction.  The code here accomplishes this by breaking the
    ! columns into blocks; for a block size of 2 in all directions,
    ! the breakdown looks like:
    !
    ! xx..xx..
    ! xx..xx..
    ! **++**++
    ! **++**++
    ! xx..xx..
    ! xx..xx..
    ! **++**++
    ! **++**++
    !
    ! All the blocks of columns labeled with the same symbol (e.g. x)
    ! are done in parallel in one pass; within each block, the work is
    ! all done by one thread, avoiding race conditions.  Then the code
    ! flushes memory and synchronizes, and starts the next set of
    ! blocks (e.g. *).
    !
    ! Breaking up into blocks in this fashion helps provide a large
    ! number of small, independent work items, which helps with
    ! parallel performance.
    do koffset=0,1
        do joffset=0,1

            ! Guided or dynamic scheduling is necessary to keep all the
            ! threads busy if the work per column is very nonuniform.  With
            ! many blocks to process, guided is probably the best choice.

            !$omp do collapse(2) schedule(guided)
            do kblk = koffset, nblk_k-1, 2
                do jblk = joffset, nblk_j-1, 2

                    do k = kblk*blksiz_k, min((kblk+1)*blksiz_k-1, mz+1)
                        do j = jblk*blksiz_j, min((jblk+1)*blksiz_j-1, my+1)

                            ! copy data along a slice into 1d array:
                            do i = 1-num_ghost, mx+num_ghost
                                do m = 1, num_eqn
                                    q1d(m,i,me1) = qold(m,i,j,k)
                                end do
                            end do

                            if (index_capa > 0)  then
                                do i = 1-num_ghost, mx+num_ghost
                                    dtdx1d(i,me1) = dtdx / aux(index_capa,i,j,k)
                                end do
                            endif

                            if (num_aux > 0)  then
                                do ka = -1, 1
                                    do i = 1-num_ghost, mx+num_ghost
                                        do ma = 1, num_aux
                                            aux1(ma, i, 2+ka, me1) = aux(ma, i, j-1, k+ka)
                                        end do
                                    end do
                                end do
                                do ka = -1, 1
                                    do i = 1-num_ghost, mx+num_ghost
                                        do ma = 1, num_aux
                                            aux2(ma, i, 2+ka, me1) = aux(ma, i,   j, k+ka)
                                        end do
                                    end do
                                end do
                                do ka = -1, 1
                                    do i = 1-num_ghost, mx+num_ghost
                                        do ma = 1, num_aux
                                            aux3(ma, i, 2+ka, me1) = aux(ma, i, j+1, k+ka)
                                        end do
                                    end do
                                end do
                            endif

                            ! compute modifications fadd, gadd and hadd to fluxes along
                            ! this slice:

                            call flux3(1,maxm,num_eqn,num_waves,num_ghost,mx, &
                                q1d(1,1-num_ghost,me1),dtdx1d(1-num_ghost,me1),dtdy,dtdz, &
                                aux1(1,1-num_ghost,1,me1),aux2(1,1-num_ghost,1,me1), &
                                aux3(1,1-num_ghost,1,me1),num_aux, &
                                method,mthlim,qadd(1,1-num_ghost,me1),fadd(1,1-num_ghost,me1), &
                                gadd(1,1,-1,1-num_ghost,me1),hadd(1,1,-1,1-num_ghost,me1),cfl1d, &
                                work(i0wave+me*nsiz_w),work(i0s+me*nsiz_s),work(i0amdq+me*nsiz), &
                                work(i0apdq+me*nsiz),work(i0cqxx+me*nsiz), &
                                work(i0bmamdq+me*nsiz),work(i0bmapdq+me*nsiz), &
                                work(i0bpamdq+me*nsiz),work(i0bpapdq+me*nsiz), &
                                work(i0cmamdq+me*nsiz),work(i0cmapdq+me*nsiz), &
                                work(i0cpamdq+me*nsiz),work(i0cpapdq+me*nsiz), &
                                work(i0cmamdq2+me*nsiz),work(i0cmapdq2+me*nsiz), &
                                work(i0cpamdq2+me*nsiz),work(i0cpapdq2+me*nsiz), &
                                work(i0bmcqxxp+me*nsiz),work(i0bpcqxxp+me*nsiz), &
                                work(i0bmcqxxm+me*nsiz),work(i0bpcqxxm+me*nsiz), &
                                work(i0cmcqxxp+me*nsiz),work(i0cpcqxxp+me*nsiz), &
                                work(i0cmcqxxm+me*nsiz),work(i0cpcqxxm+me*nsiz), &
                                work(i0bmcmamdq+me*nsiz),work(i0bmcmapdq+me*nsiz), &
                                work(i0bpcmamdq+me*nsiz),work(i0bpcmapdq+me*nsiz), &
                                work(i0bmcpamdq+me*nsiz),work(i0bmcpapdq+me*nsiz), &
                                work(i0bpcpamdq+me*nsiz),work(i0bpcpapdq+me*nsiz), &
                                rpn3,rpt3,rptt3,use_fwave)

                            cfl = dmax1(cfl,cfl1d)

                            ! update qnew by flux differencing.
                            ! (rather than maintaining arrays f, g and h for the total fluxes,
                            ! the modifications are used immediately to update qnew
                            ! in order to save storage.)

                            if(index_capa == 0)then
                                ! Order so that access to qnew is in memory-contiguous
                                ! order as much as possible
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k-1) = qnew(m,i,j-1,k-1) &
                                            - dtdy * gadd(m,1,-1,i,me1) &
                                            - dtdz * hadd(m,1,-1,i,me1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k-1) = qnew(m,i,j,k-1) &
                                            - dtdy * ( gadd(m,2,-1,i,me1) &
                                            -   gadd(m,1,-1,i,me1) ) &
                                            - dtdz * hadd(m,1,0,i,me1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k-1) = qnew(m,i,j+1,k-1) &
                                            + dtdy * gadd(m,2,-1,i,me1) &
                                            - dtdz * hadd(m,1,1,i,me1)
                                    end do
                                end do

                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k) = qnew(m,i,j-1,k) &
                                            - dtdy * gadd(m,1,0,i,me1) &
                                            - dtdz * ( hadd(m,2,-1,i,me1) &
                                            -   hadd(m,1,-1,i,me1) )
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i,me1) &
                                            - dtdx * (fadd(m,i+1,me1) - fadd(m,i,me1)) &
                                            - dtdy * (gadd(m,2,0,i,me1) - gadd(m,1,0,i,me1)) &
                                            - dtdz * (hadd(m,2,0,i,me1) - hadd(m,1,0,i,me1))
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k) = qnew(m,i,j+1,k) &
                                            + dtdy * gadd(m,2,0,i,me1) &
                                            - dtdz * ( hadd(m,2,1,i,me1) &
                                            -   hadd(m,1,1,i,me1) )
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k+1) = qnew(m,i,j-1,k+1) &
                                            - dtdy * gadd(m,1,1,i,me1) &
                                            + dtdz * hadd(m,2,-1,i,me1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k+1) = qnew(m,i,j,k+1) &
                                            - dtdy * ( gadd(m,2,1,i,me1) &
                                            -   gadd(m,1,1,i,me1) ) &
                                            + dtdz * hadd(m,2,0,i,me1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k+1) = qnew(m,i,j+1,k+1) &
                                            + dtdy * gadd(m,2,1,i,me1) &
                                            + dtdz * hadd(m,2,1,i,me1)
                                    end do
                                end do
                            else
                                ! with capa array
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k-1) = qnew(m,i,j-1,k-1) &
                                            - (dtdy * gadd(m,1,-1,i,me1) &
                                            +  dtdz * hadd(m,1,-1,i,me1)) &
                                            / aux(index_capa,i,j-1,k-1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k-1) = qnew(m,i,j,k-1) &
                                            - (dtdy * ( gadd(m,2,-1,i,me1) &
                                            -   gadd(m,1,-1,i,me1) ) &
                                            +  dtdz * hadd(m,1,0,i,me1)) &
                                            / aux(index_capa,i,j,k-1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k-1) = qnew(m,i,j+1,k-1) &
                                            + (dtdy * gadd(m,2,-1,i,me1) &
                                            -  dtdz * hadd(m,1,1,i,me1)) &
                                            / aux(index_capa,i,j+1,k-1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k) = qnew(m,i,j-1,k) &
                                            - (dtdy * gadd(m,1,0,i,me1) &
                                            +  dtdz * ( hadd(m,2,-1,i,me1) &
                                            -   hadd(m,1,-1,i,me1) )) &
                                            / aux(index_capa,i,j-1,k)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,i,me1) &
                                            - (dtdx * (fadd(m,i+1,me1) - fadd(m,i,me1)) &
                                            +  dtdy * (gadd(m,2,0,i,me1) - gadd(m,1,0,i,me1)) &
                                            +  dtdz * (hadd(m,2,0,i,me1) - hadd(m,1,0,i,me1))) &
                                            / aux(index_capa,i,j,k)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k)   = qnew(m,i,j+1,k) &
                                            + (dtdy * gadd(m,2,0,i,me1) &
                                            - dtdz * ( hadd(m,2,1,i,me1) &
                                            -   hadd(m,1,1,i,me1) )) &
                                            / aux(index_capa,i,j+1,k)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k+1) = qnew(m,i,j-1,k+1) &
                                            - (dtdy * gadd(m,1,1,i,me1) &
                                            -  dtdz * hadd(m,2,-1,i,me1)) &
                                            / aux(index_capa,i,j-1,k+1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k+1)   = qnew(m,i,j,k+1) &
                                            - (dtdy * ( gadd(m,2,1,i,me1) &
                                            -   gadd(m,1,1,i,me1) ) &
                                            -  dtdz * hadd(m,2,0,i,me1)) &
                                            / aux(index_capa,i,j,k+1)
                                    end do
                                end do
                                do i = 1, mx
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k+1) = qnew(m,i,j+1,k+1) &
                                            + (dtdy * gadd(m,2,1,i,me1) &
                                            +  dtdz * hadd(m,2,1,i,me1)) &
                                            / aux(index_capa,i,j+1,k+1)
                                    end do
                                end do
                            endif

                        end do
                    end do    ! End loops within block

                end do
            end do    ! End loops over blocks

            ! Flush memory (may not be necessary), then make sure everybody
            ! synchronizes before the next offset

            !$omp flush
            !$omp barrier
        end do
    end do    ! End loops over offsets


    ! perform y sweeps
    !==================

    do koffset=0,1
        do ioffset=0,1

            !$omp do collapse(2) schedule(guided)
            do kblk = koffset, nblk_k-1, 2
                do iblk = ioffset, nblk_i-1, 2

                    do k = kblk*blksiz_k, min((kblk+1)*blksiz_k-1, mz+1)
                        do i = iblk*blksiz_i, min((iblk+1)*blksiz_i-1, mx+1)

                            ! copy data along a slice into 1d array:
                            do j = 1-num_ghost, my+num_ghost
                                do m = 1, num_eqn
                                    q1d(m,j,me1) = qold(m,i,j,k)
                                end do
                            end do

                            if (index_capa > 0)  then
                                do j = 1-num_ghost, my+num_ghost
                                    dtdy1d(j,me1) = dtdy / aux(index_capa,i,j,k)
                                end do
                            endif

                            if (num_aux > 0)  then
                                ! aux1, aux2, aux3 probably fit in cache, so optimize
                                ! access to aux
                                do j = 1-num_ghost, my+num_ghost
                                    do ia = -1, 1
                                        do ma = 1, num_aux
                                            aux1(ma, j, 2+ia, me1) = aux(ma, i+ia, j, k-1)
                                        end do
                                    end do
                                end do
                                do j = 1-num_ghost, my+num_ghost
                                    do ia = -1, 1
                                        do ma = 1, num_aux
                                            aux2(ma, j, 2+ia, me1) = aux(ma, i+ia, j,   k)
                                        end do
                                    end do
                                end do
                                do j = 1-num_ghost, my+num_ghost
                                    do ia = -1, 1
                                        do ma = 1, num_aux
                                            aux3(ma, j, 2+ia, me1) = aux(ma, i+ia, j, k+1)
                                        end do
                                    end do
                                end do
                            endif

                            ! compute modifications fadd, gadd and hadd to fluxes along this
                            ! slice:

                            call flux3(2,maxm,num_eqn,num_waves,num_ghost,my, &
                                q1d(1,1-num_ghost,me1),dtdy1d(1-num_ghost,me1),dtdz,dtdx, &
                                aux1(1,1-num_ghost,1,me1),aux2(1,1-num_ghost,1,me1), &
                                aux3(1,1-num_ghost,1,me1),num_aux, &
                                method,mthlim,qadd(1,1-num_ghost,me1),fadd(1,1-num_ghost,me1), &
                                gadd(1,1,-1,1-num_ghost,me1),hadd(1,1,-1,1-num_ghost,me1),cfl1d, &
                                work(i0wave+me*nsiz_w),work(i0s+me*nsiz_s),work(i0amdq+me*nsiz), &
                                work(i0apdq+me*nsiz),work(i0cqxx+me*nsiz), &
                                work(i0bmamdq+me*nsiz),work(i0bmapdq+me*nsiz), &
                                work(i0bpamdq+me*nsiz),work(i0bpapdq+me*nsiz), &
                                work(i0cmamdq+me*nsiz),work(i0cmapdq+me*nsiz), &
                                work(i0cpamdq+me*nsiz),work(i0cpapdq+me*nsiz), &
                                work(i0cmamdq2+me*nsiz),work(i0cmapdq2+me*nsiz), &
                                work(i0cpamdq2+me*nsiz),work(i0cpapdq2+me*nsiz), &
                                work(i0bmcqxxp+me*nsiz),work(i0bpcqxxp+me*nsiz), &
                                work(i0bmcqxxm+me*nsiz),work(i0bpcqxxm+me*nsiz), &
                                work(i0cmcqxxp+me*nsiz),work(i0cpcqxxp+me*nsiz), &
                                work(i0cmcqxxm+me*nsiz),work(i0cpcqxxm+me*nsiz), &
                                work(i0bmcmamdq+me*nsiz),work(i0bmcmapdq+me*nsiz), &
                                work(i0bpcmamdq+me*nsiz),work(i0bpcmapdq+me*nsiz), &
                                work(i0bmcpamdq+me*nsiz),work(i0bmcpapdq+me*nsiz), &
                                work(i0bpcpamdq+me*nsiz),work(i0bpcpapdq+me*nsiz), &
                                rpn3,rpt3,rptt3,use_fwave)

                            cfl = dmax1(cfl,cfl1d)

                            ! update qnew by flux differencing.
                            ! Note that the roles of the flux updates are changed.
                            ! fadd - modifies the g-fluxes
                            ! gadd - modifies the h-fluxes
                            ! hadd - modifies the f-fluxes

                            if( index_capa == 0)then
                                ! no capa array.  Standard flux differencing:
                                do j = 1, my
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k-1) = qnew(m,i-1,j,k-1) &
                                            - dtdz * gadd(m,1,-1,j,me1) &
                                            - dtdx * hadd(m,1,-1,j,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k-1) = qnew(m,i,j,k-1) &
                                            - dtdz * gadd(m,1,0,j,me1) &
                                            - dtdx * ( hadd(m,2,-1,j,me1) &
                                            -   hadd(m,1,-1,j,me1) )
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k-1) = qnew(m,i+1,j,k-1) &
                                            - dtdz * gadd(m,1,1,j,me1) &
                                            + dtdx * hadd(m,2,-1,j,me1)
                                    end do
                                end do
                                do j = 1, my
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k) = qnew(m,i-1,j,k) &
                                            - dtdz * ( gadd(m,2,-1,j,me1) &
                                            -   gadd(m,1,-1,j,me1) ) &
                                            - dtdx * hadd(m,1,0,j,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j,me1) &
                                            - dtdy * (fadd(m,j+1,me1) - fadd(m,j,me1)) &
                                            - dtdz * (gadd(m,2,0,j,me1) - gadd(m,1,0,j,me1)) &
                                            - dtdx * (hadd(m,2,0,j,me1) - hadd(m,1,0,j,me1))
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k) = qnew(m,i+1,j,k) &
                                            - dtdz * ( gadd(m,2,1,j,me1) &
                                            -   gadd(m,1,1,j,me1) ) &
                                            + dtdx * hadd(m,2,0,j,me1)
                                    end do
                                end do
                                do j = 1, my
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k+1) = qnew(m,i-1,j,k+1) &
                                            + dtdz * gadd(m,2,-1,j,me1) &
                                            -  dtdx*hadd(m,1,1,j,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k+1) = qnew(m,i,j,k+1) &
                                            + dtdz * gadd(m,2,0,j,me1) &
                                            - dtdx * ( hadd(m,2,1,j,me1) &
                                            -   hadd(m,1,1,j,me1) )
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k+1) = qnew(m,i+1,j,k+1) &
                                            + dtdz * gadd(m,2,1,j,me1) &
                                            +  dtdx * hadd(m,2,1,j,me1)
                                    end do
                                end do
                            else
                                ! with capa array.
                                do j = 1, my
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k-1) = qnew(m,i-1,j,k-1) &
                                            - (dtdz * gadd(m,1,-1,j,me1) &
                                            +  dtdx * hadd(m,1,-1,j,me1)) &
                                            / aux(index_capa,i-1,j,k-1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k-1) = qnew(m,i,j,k-1) &
                                            - (dtdz * gadd(m,1,0,j,me1) &
                                            +  dtdx * ( hadd(m,2,-1,j,me1) &
                                            -   hadd(m,1,-1,j,me1) )) &
                                            / aux(index_capa,i,j,k-1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k-1) = qnew(m,i+1,j,k-1) &
                                            - (dtdz * gadd(m,1,1,j,me1) &
                                            -  dtdx * hadd(m,2,-1,j,me1)) &
                                            / aux(index_capa,i+1,j,k-1)
                                    end do
                                end do
                                do j = 1, my
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k) = qnew(m,i-1,j,k) &
                                            - (dtdz * ( gadd(m,2,-1,j,me1) &
                                            -   gadd(m,1,-1,j,me1) ) &
                                            +  dtdx * hadd(m,1,0,j,me1)) &
                                            / aux(index_capa,i-1,j,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,j,me1) &
                                            - (dtdy * (fadd(m,j+1,me1) - fadd(m,j,me1)) &
                                            +  dtdz * (gadd(m,2,0,j,me1) - gadd(m,1,0,j,me1)) &
                                            +  dtdx * (hadd(m,2,0,j,me1) - hadd(m,1,0,j,me1))) &
                                            / aux(index_capa,i,j,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k) = qnew(m,i+1,j,k) &
                                            - (dtdz * ( gadd(m,2,1,j,me1) &
                                            -   gadd(m,1,1,j,me1) ) &
                                            -  dtdx * hadd(m,2,0,j,me1) ) &
                                            / aux(index_capa,i+1,j,k)
                                    end do
                                end do
                                do j = 1, my
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k+1) = qnew(m,i-1,j,k+1) &
                                            + (dtdz * gadd(m,2,-1,j,me1) &
                                            -  dtdx*hadd(m,1,1,j,me1)) &
                                            / aux(index_capa,i-1,j,k+1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k+1) = qnew(m,i,j,k+1) &
                                            + (dtdz * gadd(m,2,0,j,me1) &
                                            -  dtdx * ( hadd(m,2,1,j,me1) &
                                            -   hadd(m,1,1,j,me1) )) &
                                            / aux(index_capa,i,j,k+1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k+1) = qnew(m,i+1,j,k+1) &
                                            + (dtdz * gadd(m,2,1,j,me1) &
                                            +  dtdx * hadd(m,2,1,j,me1)) &
                                            / aux(index_capa,i+1,j,k+1)
                                    end do
                                end do
                            endif

                        end do
                    end do    ! End loops within blocks

                end do
            end do    ! End loops over blocks

            !$omp flush
            !$omp barrier
        end do
    end do    ! End loops over offsets


    ! perform z sweeps
    !==================

    do joffset=0,1
        do ioffset=0,1

            !$omp do collapse(2) schedule(guided)
            do jblk = joffset, nblk_j-1, 2
                do iblk = ioffset, nblk_i-1, 2

                    do j = jblk*blksiz_j, min((jblk+1)*blksiz_j-1, my+1)
                        do i = iblk*blksiz_i, min((iblk+1)*blksiz_i-1, mx+1)

                            do k = 1-num_ghost, mz+num_ghost
                                do m = 1, num_eqn
                                    q1d(m,k,me1) = qold(m,i,j,k)
                                end do
                            end do

                            if (index_capa > 0)  then
                                do k = 1-num_ghost, mz+num_ghost
                                    dtdz1d(k,me1) = dtdz / aux(index_capa,i,j,k)
                                end do
                            endif

                            if (num_aux > 0)  then
                                do k = 1-num_ghost, mz+num_ghost
                                    do ja = -1, 1
                                        do ma = 1, num_aux
                                            aux1(ma, k, 2+ja, me1) = aux(ma, i-1, j+ja, k)
                                        end do
                                        do ma = 1, num_aux
                                            aux2(ma, k, 2+ja, me1) = aux(ma,   i, j+ja, k)
                                        end do
                                        do ma = 1, num_aux
                                            aux3(ma, k, 2+ja, me1) = aux(ma, i+1, j+ja, k)
                                        end do
                                    end do
                                end do
                            endif

                            ! compute modifications fadd, gadd and hadd to fluxes along this
                            ! slice:

                            call flux3(3,maxm,num_eqn,num_waves,num_ghost,mz, &
                                q1d(1,1-num_ghost,me1),dtdz1d(1-num_ghost,me1),dtdx,dtdy, &
                                aux1(1,1-num_ghost,1,me1),aux2(1,1-num_ghost,1,me1), &
                                aux3(1,1-num_ghost,1,me1),num_aux, &
                                method,mthlim,qadd(1,1-num_ghost,me1),fadd(1,1-num_ghost,me1), &
                                gadd(1,1,-1,1-num_ghost,me1),hadd(1,1,-1,1-num_ghost,me1),cfl1d, &
                                work(i0wave+me*nsiz_w),work(i0s+me*nsiz_s),work(i0amdq+me*nsiz), &
                                work(i0apdq+me*nsiz),work(i0cqxx+me*nsiz), &
                                work(i0bmamdq+me*nsiz),work(i0bmapdq+me*nsiz), &
                                work(i0bpamdq+me*nsiz),work(i0bpapdq+me*nsiz), &
                                work(i0cmamdq+me*nsiz),work(i0cmapdq+me*nsiz), &
                                work(i0cpamdq+me*nsiz),work(i0cpapdq+me*nsiz), &
                                work(i0cmamdq2+me*nsiz),work(i0cmapdq2+me*nsiz), &
                                work(i0cpamdq2+me*nsiz),work(i0cpapdq2+me*nsiz), &
                                work(i0bmcqxxp+me*nsiz),work(i0bpcqxxp+me*nsiz), &
                                work(i0bmcqxxm+me*nsiz),work(i0bpcqxxm+me*nsiz), &
                                work(i0cmcqxxp+me*nsiz),work(i0cpcqxxp+me*nsiz), &
                                work(i0cmcqxxm+me*nsiz),work(i0cpcqxxm+me*nsiz), &
                                work(i0bmcmamdq+me*nsiz),work(i0bmcmapdq+me*nsiz), &
                                work(i0bpcmamdq+me*nsiz),work(i0bpcmapdq+me*nsiz), &
                                work(i0bmcpamdq+me*nsiz),work(i0bmcpapdq+me*nsiz), &
                                work(i0bpcpamdq+me*nsiz),work(i0bpcpapdq+me*nsiz), &
                                rpn3,rpt3,rptt3,use_fwave)

                            cfl = dmax1(cfl,cfl1d)

                            ! update qnew by flux differencing.
                            ! Note that the roles of the flux updates are changed.
                            ! fadd - modifies the h-fluxes
                            ! gadd - modifies the f-fluxes
                            ! hadd - modifies the g-fluxes

                            if(index_capa == 0)then

                                ! no capa array. Standard flux differencing:
                                do k = 1, mz
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j-1,k) = qnew(m,i-1,j-1,k) &
                                            - dtdx * gadd(m,1,-1,k,me1) &
                                            - dtdy * hadd(m,1,-1,k,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k) = qnew(m,i,j-1,k) &
                                            - dtdx * ( gadd(m,2,-1,k,me1) &
                                            -   gadd(m,1,-1,k,me1) ) &
                                            - dtdy * hadd(m,1,0,k,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j-1,k) = qnew(m,i+1,j-1,k) &
                                            + dtdx * gadd(m,2,-1,k,me1) &
                                            - dtdy * hadd(m,1,1,k,me1)
                                    end do

                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k) = qnew(m,i-1,j,k) &
                                            - dtdx * gadd(m,1,0,k,me1) &
                                            - dtdy * ( hadd(m,2,-1,k,me1) &
                                            -   hadd(m,1,-1,k,me1) )
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k,me1) &
                                            - dtdz * (fadd(m,k+1,me1) - fadd(m,k,me1)) &
                                            - dtdx * (gadd(m,2,0,k,me1) - gadd(m,1,0,k,me1)) &
                                            - dtdy * (hadd(m,2,0,k,me1) - hadd(m,1,0,k,me1))
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k) = qnew(m,i+1,j,k) &
                                            + dtdx * gadd(m,2,0,k,me1) &
                                            - dtdy * ( hadd(m,2,1,k,me1) &
                                            -   hadd(m,1,1,k,me1) )
                                    end do

                                    do m = 1, num_eqn
                                        qnew(m,i-1,j+1,k) = qnew(m,i-1,j+1,k) &
                                            - dtdx * gadd(m,1,1,k,me1) &
                                            + dtdy * hadd(m,2,-1,k,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k) = qnew(m,i,j+1,k) &
                                            - dtdx * ( gadd(m,2,1,k,me1) &
                                            -   gadd(m,1,1,k,me1) ) &
                                            + dtdy * hadd(m,2,0,k,me1)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j+1,k) = qnew(m,i+1,j+1,k) &
                                            + dtdx * gadd(m,2,1,k,me1) &
                                            + dtdy * hadd(m,2,1,k,me1)
                                    end do
                                end do
                            else

                                ! with capa array
                                do k = 1, mz
                                    do m = 1, num_eqn
                                        qnew(m,i-1,j-1,k) = qnew(m,i-1,j-1,k) &
                                            - (dtdx * gadd(m,1,-1,k,me1) &
                                            +  dtdy * hadd(m,1,-1,k,me1)) &
                                            / aux(index_capa,i-1,j-1,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j-1,k) = qnew(m,i,j-1,k) &
                                            - (dtdx * ( gadd(m,2,-1,k,me1) &
                                            -   gadd(m,1,-1,k,me1) ) &
                                            +  dtdy * hadd(m,1,0,k,me1)) &
                                            / aux(index_capa,i,j-1,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j-1,k) = qnew(m,i+1,j-1,k) &
                                            + (dtdx * gadd(m,2,-1,k,me1) &
                                            -  dtdy * hadd(m,1,1,k,me1)) &
                                            / aux(index_capa,i+1,j-1,k)
                                    end do

                                    do m = 1, num_eqn
                                        qnew(m,i-1,j,k)   = qnew(m,i-1,j,k) &
                                            - (dtdx * gadd(m,1,0,k,me1) &
                                            + dtdy * ( hadd(m,2,-1,k,me1) &
                                            -   hadd(m,1,-1,k,me1) )) &
                                            / aux(index_capa,i-1,j,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j,k) = qnew(m,i,j,k) + qadd(m,k,me1) &
                                            - (dtdz * (fadd(m,k+1,me1) - fadd(m,k,me1)) &
                                            +  dtdx * (gadd(m,2,0,k,me1) - gadd(m,1,0,k,me1)) &
                                            +  dtdy * (hadd(m,2,0,k,me1) - hadd(m,1,0,k,me1))) &
                                            / aux(index_capa,i,j,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j,k) = qnew(m,i+1,j,k) &
                                            + (dtdx * gadd(m,2,0,k,me1) &
                                            - dtdy * ( hadd(m,2,1,k,me1) &
                                            -   hadd(m,1,1,k,me1) )) &
                                            / aux(index_capa,i+1,j,k)
                                    end do

                                    do m = 1, num_eqn
                                        qnew(m,i-1,j+1,k) = qnew(m,i-1,j+1,k) &
                                            - (dtdx * gadd(m,1,1,k,me1) &
                                            -  dtdy * hadd(m,2,-1,k,me1)) &
                                            / aux(index_capa,i-1,j+1,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i,j+1,k) = qnew(m,i,j+1,k) &
                                            - (dtdx * ( gadd(m,2,1,k,me1) &
                                            -   gadd(m,1,1,k,me1) ) &
                                            -  dtdy * hadd(m,2,0,k,me1)) &
                                            / aux(index_capa,i,j+1,k)
                                    end do
                                    do m = 1, num_eqn
                                        qnew(m,i+1,j+1,k) = qnew(m,i+1,j+1,k) &
                                            + (dtdx * gadd(m,2,1,k,me1) &
                                            +  dtdy * hadd(m,2,1,k,me1)) &
                                            / aux(index_capa,i+1,j+1,k)
                                    end do
                                end do
                            endif

                        end do
                    end do

                end do
            end do

            !$omp flush
            !$omp barrier
        end do
    end do
    !$omp end parallel

    return

end subroutine step3

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================
! Riemann solver for the acoustics equations in 2d 
! on general quadrilateral grid, with variable coefficients

! waves: 2
! equations: 3

! Conserved quantities:
!       1 pressure
!       2 x_velocity
!       3 y_velocity

! Auxiliary quantities:
!       1 a_x
!       2 a_y   where (a_x,a_y) is unit normal to left face
!       3 length_ratio_left ratio of length of left face to dyc
!       4 b_x
!       5 b_y   where (b_x,b_y) is unit normal to bottom face
!       6 length_ratio_bottom   ratio of length of bottom face to dxc
!       7 cell_area   ratio of cell area to dxc*dyc
!         (approximately Jacobian of mapping function)
!       8 Z (impedance)
!       9 c (sound speed)
!
! Rotate velocity and then call standard Riemann solver.
! The resulting waves and flux differences are then rotated
! back to x-y.

! solve Riemann problems along one slice of data.
!
! On input, ql contains the state vector at the left edge of each cell
! qr contains the state vector at the right edge of each cell
!
! This data is along a slice in the x-direction if ixy=1 
! or the y-direction if ixy=2.
! On output, wave contains the waves, s the speeds, 
! and amdq, apdq the decomposition of the flux difference
! f(qr(i-1)) - f(ql(i))  
! into leftgoing and rightgoing parts respectively.
! With the Roe solver we have   
!     amdq  =  A^- \Delta q    and    apdq  =  A^+ \Delta q
! where A is the Roe matrix.  An entropy fix can also be incorporated
! into the flux differences.
!
! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                   and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr.

    implicit none
!
    integer, intent(in) :: maxm, meqn, mwaves, mbc, mx, maux
    double precision, intent(out) :: wave(meqn, mwaves, 1-mbc:maxm+mbc)
    double precision, intent(out) :: s(mwaves,  1-mbc:maxm+mbc)
    double precision, intent(in)  ::   ql(meqn, 1-mbc:maxm+mbc)
    double precision, intent(in)  ::   qr(meqn, 1-mbc:maxm+mbc)
    double precision, intent(out) :: apdq(meqn, 1-mbc:maxm+mbc)
    double precision, intent(out) :: amdq(meqn, 1-mbc:maxm+mbc)
    double precision, intent(in)  :: auxl(maux, 1-mbc:maxm+mbc)
    double precision, intent(in)  :: auxr(maux, 1-mbc:maxm+mbc)
!
!   ------------
    double precision :: delta(3)
    double precision :: unorl, unorr, a1, a2
    double precision :: alpha, beta, zi, zim, ci, cim
    integer :: ixy, inx, iny, ilenrat, i, m
!
! Rotate the velocity vector (q(2), q(3)) so that it is aligned with the face
! normal.  The normal vector for the face at the i'th Riemann problem
! is stored in the aux array
! in locations (1,2) if ixy=1 or (4,5) if ixy=2.  The ratio of the
! length of the cell side to the length of the computational cell
! is stored in aux(3) or aux(6), respectively.

    if (ixy.eq.1) then
        inx = 1
        iny = 2
        ilenrat = 3
    else
        inx = 4
        iny = 5
        ilenrat = 6
    endif

! Determine rotation matrix:
!               [ alpha  beta ]
!               [-beta  alpha ]
! Note that this reduces to the identity on a standard cartesian grid.

! Determine normal velocity components at this edge:
    do i=2-mbc,mx+mbc
        alpha = auxl(inx,i)
        beta  = auxl(iny,i)
        unorl = alpha*ql(2,i) + beta*ql(3,i)
        unorr = alpha*qr(2,i-1) + beta*qr(3,i-1)

        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = unorl - unorr

        zi  = auxl(8,i)
        zim = auxl(8,i-1)
        ci  = auxl(9,i)
        cim = auxl(9,i-1)

        a1 = (-delta(1) + zi*delta(2)) / (zim + zi)
        a2 =  (delta(1) + zim*delta(2)) / (zim + zi)

!       Scale the velocities by the length ratios on each side.

        wave(1,1,i) = -a1*zim
        wave(2,1,i) = a1 * alpha
        wave(3,1,i) = a1 * beta
        s(1,i) = -cim * auxl(ilenrat,i)

        wave(1,2,i) = a2*zi
        wave(2,2,i) = a2 * alpha
        wave(3,2,i) = a2 * beta
        s(2,i) = ci * auxl(ilenrat,i)
    enddo

!   Compute the left-going and right-going fluctuations.
!   Note that s(1,i) < 0   and   s(2,i) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = s(1,i)*wave(m,1,i)
            apdq(m,i) = s(2,i)*wave(m,2,i)
        enddo
    enddo

    return
    end subroutine rpn2

c
c
c =========================================================
      subroutine out2(meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,t,iframe,aux,maux,outaux)
c =========================================================
c
c     # Output the results for a general system of conservation laws
c     # in 2 dimensions
c
c     # Write the results to the file fort.q<iframe>.nc
c     # Use format required by matlab script  plotclaw2.m
c     # The same format is used by the amrclaw package.
c     # Here it's adapted to output just the single grid.
c     # set outaux = .true. to also output the aux arrays to fort.a<iframe>
c

c
c -----------------------------------------------------
c     Routine to write netcdf files in the classic format
!        #jj-2011.03.29
!        # Each file written by the fortran code has 
!        # Dimensions:
!        #           timedimension : UNLIMITED
!        #           meqn          : The number of equations
!        #           dimx_<gridno> : X dimension for grid number <gridno>
!        #           dimy_<gridno> : Y dimension for grid number <gridno>
!        # Variables:
!        #           timedimension : Stores the time of the frame
!        #           ngrids        : Number of grids in this frame
!        #           naux          : Number of Auxilary Variables
!        #           ndim          : Number of Dimensions in the frame
!        #           grid_<gridno> : A grid of (dimx,dimy,meqn)
!        # Attributes:
!        # (grid_<no>) gridno      : The number of this grid <grid_no>
!        #           level         : The AMR level
!        #           dim_names     : a list of dimensions [dimx,dimy]
!        #           dim<x,y>.low  : The lowest dimension value 
!        #           dim<x,y>.d    : The distance between grid points 
!
!     Cleaned up by Grady Lemoine, 2013-08-01
c -----------------------------------------------------

c
      implicit double precision (a-h,o-z)
      include 'netcdf.inc'
      
      dimension   q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      logical, intent(in) :: outaux
      character*10 fname1, fname2, fname3
      logical do_ascii
            
      real(kind=8) time
      integer ncid,rcode
      integer timeid,tVarID,meqnID,ngridsVarID,nauxVarID,ndimVarID
      integer dimxid,dimyid
      integer gridid
      integer ntimes
      character*2 gridstr
      character*40 dim_names
      REAL(kind=8), ALLOCATABLE  ::grid(:,:,:)
      integer nx, ny
      

      nx=mx
      ny=my
      do_ascii = .false.
c
c     # first create the file name and open file
c
         fname1 = 'fort.qxxxx'
         fname2 = 'fort.txxxx'
         fname3 = 'fort.axxxx'
         nstp = iframe
         do 55 ipos = 10, 7, -1
            idigit = mod(nstp,10)
            fname1(ipos:ipos) = char(ichar('0') + idigit)
            fname2(ipos:ipos) = char(ichar('0') + idigit)
            fname3(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp / 10
 55      continue

         if (do_ascii) open(unit=50,file=fname1,status='unknown',
     &                      form='formatted')
         if (do_ascii) open(unit=60,file=fname2,status='unknown',
     &                      form='formatted')

c
c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr = 1
      level = 1

      ntimes=1
c        write(50,1001) mptr,level,mx,my
c        write(50,1002) xlower,ylower,dx,dy
        !!!!Define netcdf file
         rcode=NF_CREATE(fname1//'.nc',NF_NOCLOBBER,ncid)
         if(rcode.ne.NF_NOERR) print *,'ERROR OPENING NETCDF FILE'
         rcode=NF_DEF_DIM(ncid,'timedimension',NF_UNLIMITED,timeid)
         rcode=NF_DEF_VAR(ncid,'timedimension',NF_DOUBLE,1,timeid,
     &   tVarID)
         rcode=NF_DEF_DIM(ncid,'meqn',meqn,meqnid)
         rcode=NF_DEF_VAR(ncid,'ngrids',NF_INT,0,0,ngridsVarID)
         rcode=NF_DEF_VAR(ncid,'naux',NF_INT,0,0,nauxVarID)
         rcode=NF_DEF_VAR(ncid,'ndim',NF_INT,0,0,ndimVarID)
        write(gridstr,67) mptr
              
67            format(I2.2)              
              rcode=NF_DEF_DIM(ncid,'dimx_'//trim(gridstr),nx,dimxid)
              if(rcode.ne.NF_NOERR) print *,'ERROR  DEFINE DIMS'
              rcode=NF_DEF_DIM(ncid,'dimy_'//trim(gridstr),ny,dimyid)
              if(rcode.ne.NF_NOERR) print *,'ERROR  DEFINE DIMS'
              

              rcode=NF_DEF_Var(ncid,'grid_'//trim(gridstr),NF_DOUBLE,4,
     &              (/dimxid,dimyid,meqnid,timeid/),gridid)
               if(rcode.ne.NF_NOERR) print *,'ERROR  DEFINE VAR'
               
              rcode=NF_PUT_ATT_INT(ncid,gridid,'gridno',NF_INT,1,
     &              mptr)
     
              rcode=NF_PUT_ATT_INT(ncid,gridid,'level',NF_INT,1,level)
              
              dim_names="['dimx','dimy']"
              rcode=NF_PUT_ATT_TEXT(ncid,gridid,'dim_names',
     &         LEN_TRIM(dim_names),TRIM(dim_names))
     
              rcode=NF_PUT_ATT_DOUBLE(ncid,gridid,'dimx.lower',NF_FLOAT,
     &              1,xlower)     
              rcode=NF_PUT_ATT_DOUBLE(ncid,gridid,'dimy.lower',NF_FLOAT,
     &              1,ylower)
     
              rcode=NF_PUT_ATT_DOUBLE(ncid,gridid,'dimx.d',NF_FLOAT,1,
     &          dx)
              rcode=NF_PUT_ATT_DOUBLE(ncid,gridid,'dimy.d',NF_FLOAT,1,
     &          dy) 
     
              rcode=NF_ENDDEF(ncid)
            write(0,*) "xlower, ylower:",xlower,ylower,sizeof(xlower)        
      allocate(grid(nx,ny,meqn))
      time=t      
c
      do j=1,my
        do i=1,mx
          do m=1,meqn
c            # exponents with more than 2 digits cause problems reading
c            # into matlab... reset tiny values to zero:
             if (dabs(q(m,i,j)) .lt. 1d-99) q(m,i,j) = 0.d0
             grid(i,j,m)=q(m,i,j)
             enddo
              if (do_ascii) write(50,1005) (grid(i,j,m), m=1,meqn)
         enddo
         if (do_ascii) write(50,*) ' '
      enddo
      if (do_ascii) write(50,*) ' '
      
      rcode=NF_PUT_VARA_DOUBLE(ncid,gridid,(/1,1,1,1/),
     & (/nx,ny,meqn,1/),grid)
     
      deallocate(grid)
      
      rcode=NF_PUT_VAR_DOUBLE(ncid,tVarID,t)
      if(rcode.ne.NF_NOERR) print *,'ERROR  Write Time'
      rcode=NF_PUT_VAR_INT(ncid,ngridsVarID,int(ngrids))
      if(rcode.ne.NF_NOERR) print *,'ERROR  Write GridNo'
      rcode=NF_PUT_VAR_INT(ncid,nauxVarID,maux)
      rcode=NF_PUT_VAR_INT(ncid,ndimVarID,2)
      rcode=NF_CLOSE(ncid)

 1001 format(i5,'                 grid_number',/,
     &       i5,'                 AMR_level',/,
     &       i5,'                 mx',/,
     &       i5,'                 my')

 1002 format(e26.16,'    xlow', /,
     &       e26.16,'    ylow', /,
     &       e26.16,'    dx', /,
     &       e26.16,'    dy',/)
 1005     format(50e26.16)

            
      if (outaux) then 
c     # also output the aux arrays:
      open(unit=70,file=fname3,status='unknown',form='formatted')
      write(70,1001) mptr,level,mx,my
      write(70,1002) xlower,ylower,dx,dy
      do 120 j=1,my
         do 110 i=1,mx
            do m=1,maux
c              # exponents with more than 2 digits cause problems reading
c              # into matlab... reset tiny values to zero:
               if (dabs(aux(m,i,j)) .lt. 1d-99) aux(m,i,j) = 0.d0
            enddo
c
            write(70,1005) (aux(m,i,j), m=1,maux)
c
  110       continue
         write(70,*) ' '
  120    continue
      write(70,*) ' '
      close(unit=70)
      endif

      if (do_ascii) write(60,1000) t,meqn,ngrids,maux,2

 1000 format(e26.16,'    time', /,
     &       i5,'                 meqn'/,
     &       i5,'                 ngrids'/,
     &       i5,'                 maux'/,
     &       i5,'                 ndim'/,/)
!c
      if (do_ascii) close(unit=50)
      if (do_ascii) close(unit=60)

      return
      end

! ::::::::::::::::::::: flag2refine ::::::::::::::::::::::::::::::::::
!
! User routine to control flagging of points for refinement.
!
! Specific for GeoClaw for tsunami applications and related problems
!
!
!    q   = grid values including ghost cells (bndry vals at specified
!          time have already been set, so can use ghost cell values too)
!
!  aux   = aux array on this grid patch
!
! amrflags  = array to be flagged with either the value
!             DONTFLAG (no refinement needed)  or
!             DOFLAG   (refinement desired)
!
! This routine only checks cells in which amrflags(i,j) = UNSET,
! If the value is already DONTFLAG or DOFLAG then this we determined by
! flagregions or other criteria and is not modified by this routine.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine flag2refine2(mx,my,mbc,mbuff,meqn,maux,xlower,ylower,dx,dy,t,level, &
                       tolsp,q,aux,amrflags)

    use amr_module, only: mxnest, t0, DOFLAG, UNSET
    use geoclaw_module, only:dry_tolerance, sea_level
    use geoclaw_module, only: spherical_distance, coordinate_system


    use storm_module, only: storm_specification_type, wind_refine, R_refine
    use storm_module, only: storm_location, wind_forcing, wind_index, wind_refine

    use regions_module, only: num_regions, regions
    use refinement_module, only: wave_tolerance, speed_tolerance

    use adjoint_module, only: totnum_adjoints,innerprod_index, &
                              adjoint_flagging,select_snapshots
    use adjointsup_module, only: calculate_innerproduct

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,my,mbc,meqn,maux,level,mbuff
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,tolsp

    real(kind=8), intent(in) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Flagging
    real(kind=8), intent(in out) :: amrflags(1-mbuff:mx+mbuff,1-mbuff:my+mbuff)

    ! Generic locals
    integer :: i,j,m,r
    real(kind=8) :: x_c,y_c,x_low,y_low,x_hi,y_hi
    real(kind=8) :: speed, eta, ds

    ! Storm specific variables
    real(kind=8) :: R_eye(2), wind_speed

    ! Adjoint method specific variables
    logical mask_selecta(totnum_adjoints)


    if(adjoint_flagging) then
        aux(innerprod_index,:,:) = 0.0
        call select_snapshots(t,mask_selecta)

        ! Loop over adjoint snapshots
        aloop: do r=1,totnum_adjoints

            ! Consider only snapshots that are within the desired time range
            if (mask_selecta(r)) then
                ! Calculate inner product with current snapshot
                call calculate_innerproduct(q,r,mx,my,xlower,   &
                        ylower,dx,dy,meqn,mbc,maux,aux)
            endif

        enddo aloop
    endif

    ! Loop over interior points on this grid
    ! (i,j) grid cell is [x_low,x_hi] x [y_low,y_hi], cell center at (x_c,y_c)
    y_loop: do j=1,my
        y_low = ylower + (j - 1) * dy
        y_c = ylower + (j - 0.5d0) * dy
        y_hi = ylower + j * dy

        x_loop: do i = 1,mx
            x_low = xlower + (i - 1) * dx
            x_c = xlower + (i - 0.5d0) * dx
            x_hi = xlower + i * dx
            
            if (amrflags(i,j) .ne. UNSET) then
                ! do not consider this cell further
                cycle x_loop
            endif

            ! ************* Storm Based Refinement ****************
            ! Check to see if we are some specified distance from the eye of
            ! the storm and refine if we are
            if (storm_specification_type /= 0) then
                R_eye = storm_location(t)
                do m=1,size(R_refine,1)
                    if (coordinate_system == 2) then
                        ds = spherical_distance(x_c, y_c, R_eye(1), R_eye(2))
                    else
                        ds = sqrt((x_c - R_eye(1))**2 + (y_c - R_eye(2))**2)
                    end if
                    
                    if (ds < R_refine(m) .and. level <= m) then
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif
                enddo
                
                ! Refine based on wind speed
                if (wind_forcing) then
                    wind_speed = sqrt(aux(wind_index,i,j)**2 + aux(wind_index+1,i,j)**2)
                    do m=1,size(wind_refine,1)
                        if ((wind_speed > wind_refine(m)) .and. (level <= m)) then
                            amrflags(i,j) = DOFLAG
                            cycle x_loop
                        endif
                    enddo
                endif
            endif

            ! ********* criteria applied only to wet cells:

            if (q(1,i,j) > dry_tolerance) then

                if(adjoint_flagging) then
                    if(aux(innerprod_index,i,j) > tolsp) then
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif
                else
                
                    ! Check wave criteria
                    eta = q(1,i,j) + aux(1,i,j)
                    if (abs(eta - sea_level) > wave_tolerance) then
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif

                    ! Check speed criteria, note that it might be useful to
                    ! also have a per layer criteria since this is not
                    ! gradient based
                    speed = sqrt(q(2,i,j)**2 + q(3,i,j)**2) / q(1,i,j)
                    do m=1,min(size(speed_tolerance),mxnest)
                        if (speed > speed_tolerance(m) .and. level <= m) then
                            amrflags(i,j) = DOFLAG
                            cycle x_loop
                        endif
                    enddo
                endif
            endif


        enddo x_loop
    enddo y_loop
end subroutine flag2refine2

c
c ----------------------------------------------------------
c
      function igetsp (nwords)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::::::::::::: IGETSP ::::::::::::::::::::::::::::
c
c  allocate contiguous space of length nword in main storage array
c  alloc. user code (or pointer to the owner of this storage)
c  is  mptr.  lenf = current length of lfree list.
c
c ::::::::::::::::::::::::::: IGETSP ::::::::::::::::::::::::::::
c

!$OMP CRITICAL (MemMgmt)

c  find first fit from free space list
c
 10   continue
      itake = 0
      do 20 i = 1, lenf
         if (lfree(i,2) .lt. nwords) go to 20
         itake = i
         go to 25
 20   continue
      go to 900
c
c  anything left?
c
 25   left = lfree(itake,2) - nwords
      igetsp = lfree(itake,1)
      iendtake = lfree(itake,1) + nwords
      if (lendim .lt. iendtake) lendim = iendtake
c
c  the following code which is ignored for now adds the new
      if (left .le. 0) go to 30
      lfree(itake,2) = left
      lfree(itake,1) = iendtake
      go to 99
c
c  item is totally removed.  move next items in list up one.
c
 30   lenf = lenf - 1
      do 40 i = itake, lenf
      lfree(i,1) = lfree(i+1,1)
 40   lfree(i,2) = lfree(i+1,2)
      go to 99
c
 900  write(outunit,901) nwords
      write(*,901)       nwords
 901  format('  require ',i10,' words - either none left or not big',
     1         '  enough space')
      write(outunit,902) ((lfree(i,j),j=1,2),i=1,lenf)
      write(*,902)       ((lfree(i,j),j=1,2),i=1,lenf)
 902  format(' free list: ',//,2x,50(i10,4x,i10,/,2x))
      
      ! Dynamic memory adjustment
c     print *, lenf
c     write(*,902)       ((lfree(i,j),j=1,2),i=1,lenf)
      ! Attempt to allocate new memory
      factor = 2.0d0
      istatus = 1
      old_memsize = memsize
      do while (istatus > 0)
          factor = 0.5d0 * factor
          if (factor < 0.1d0) then
              print *, 'Allocation failed, not enough memory'
      stop
          endif
          new_size = ceiling((1.d0+factor) * memsize)
          iadd_size = ceiling(factor * memsize)
          call resize_storage(new_size,istatus)
      enddo
          
      if (lfree(lenf-1,1) + lfree(lenf-1,2) - 1 .eq. old_memsize) then
          ! Merge new block with last free block on list, adjust sentinel to
          ! reflect new memory size
          lfree(lenf-1,2) = iadd_size + lfree(lenf-1,2)
          lfree(lenf,1) = new_size + 2
      else
          ! New free block added to end, make new sentinel 
          lfree(lenf,1) = old_memsize+1
          lfree(lenf,2) = iadd_size
          lfree(lenf+1,1) = new_size+2
          lfree(lenf+1,2) = 0
          lenf = lenf + 1
      endif
      go to 10

 99   lentot = lentot + nwords
      if (lenmax .lt. lentot) lenmax = lentot
      if (sprint) write(outunit,100) nwords, igetsp, lentot, lenmax
 100  format('  allocating ',i8,' words in location ',i8,
     1       ' lentot, lenmax ', 2i10)

!$OMP END CRITICAL (MemMgmt)

      return
      end

!
! -------------------------------------------------------------
!
subroutine lookAtGrid(val,valOther,dx,dy,xlowWithGhost,ylowWithGhost,nvar,mitot,mjtot,  &
                      ng,iu,doUpdate,lev)

   implicit none
   real(kind=8), intent(in) :: val(nvar,mitot,mjtot)
   real(kind=8), intent(in) :: valOther(nvar,mitot,mjtot)
   real(kind=8), intent(in) :: dx,dy,xlowWithGhost,ylowWithGhost
   integer, intent(in) :: nvar,mitot,mjtot,ng,iu,lev
   logical, intent(in) :: doUpdate
   real(kind=8) :: speed(mitot,mjtot),speedmax
   integer :: imax,jmax

   integer :: i,j,ivar
   real(kind=8) :: x,y

   speedmax = 0.d0
   imax = -1
   jmax = -1
   ! if ng=0 look at ghost cells. If ng = 2 are not looking at ghost cells.
   do i = ng+1, mitot-ng
      x = xlowWithGhost + (i-0.5d0)*dx
   do j = ng+1, mjtot-ng
      y = ylowWithGhost + (j-0.5d0)*dy
      if (val(1,i,j) .eq. 0.d0) cycle
      speed(i,j) = sqrt(val(2,i,j)**2+val(3,i,j)**2)/val(1,i,j)
      if (speed(i,j) .gt. speedmax) then
         speedmax = speed(i,j)
         imax = i
         jmax = j
      endif
      if (doUpdate) then
        write(iu,101)x,y,i,j,(val(ivar,i,j),ivar=1,3),  &
                         (valOther(ivar,i,j),ivar=4,5),speed(i,j)
      else
        write(iu,101)x,y,i,j,(val(ivar,i,j),ivar=1,nvar),speed(i,j)
      endif
 101  format(2e14.7,2i5,6e14.6)
   end do
   end do

   !write(*,102) lev,speedmax,imax,jmax
 102  format("from lookAtGrid level ",i3," speedmax = ",e15.7," at cell ",2i5)


end subroutine lookAtGrid

c
c --------------------------------------------------------------
c
      subroutine stst1
c
      use amr_module
      implicit double precision (a-h,o-z)


c
c :::::::::::::::::::::::::::::: STST1 ::::::::::::::::::::::::::::::::
c    intialize a few variables needed before calling user set up
c    routine domain.
c    the spatial and temporal stepsizes are set. the node array
c    is kept as a linked list of free nodes.  "ndfree" points to the
c    head of the list, i.e. first free node.  use first row of each
c    col to hold this pointer, set by the macro "nextfree".
c    the free space list, managed in lfree, will have first and
c    last positions filled with an allocation of zero words,
c    to avoid boundary cases.
c ::::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::::::
c
      ndfree = 1

      !! now rnode and node are allocatable to allow resizing
      call init_nodes()

      ! node space allocated, now thread it
      do 10 i   = 1, maxgr
         node(nextfree,i) = i+1
 10   continue
c
c the last free node will have a null pointer
 
      node(nextfree, maxgr) = null
c

c     Initialize dynamic memory
      call init_alloc()

      lfine = 1
C       do 20 i  = 1, memsize
C         alloc(i) = WEIRD
C  20   continue
c
c  initialize linked list of alloc storage as well.
c  first and last locations are dummy placeholders of zero words
c  of allocation each, to avoid boundary cases.
c
      do  40 i  = 1, lfdim
        lfree(i,1) = 0
        lfree(i,2) = 0
 40   continue
      lfree(3,1) =memsize + 2
      lfree(2,1) = 1
      lfree(2,2) =memsize
      lenf       = 3


c  need to manage the boundary List too
c     do i = 1, bndListSize
c        bndList(i,nextfree) = i+1
c     end do
c     bndList(bndListSize,nextfree) = null
c     ndfree_bnd = 1
      call initBndryList()
c
c after kcheck integrations of parent grid, move its refinements.
c finest level grid never needs to have its finer subgrids moved.
c
      call initTimers()   ! used to be done here, but needs to be called from restarting too when stst1 not called

      do 60 i   = 1, maxlv
         tvoll(i) = 0.d0
         iregridcount(i) = 0
         avenumgrids(i) = 0
         numgrids(i) = 0
         numcells(i) = 0
         lstart(i) = 0
 60      icheck(i) = 0
c
c finish initializing spatial and counting arrays
c
      level      = 2
 70   if (level .gt. mxnest) go to 80
          hxposs(level) = hxposs(level-1) / dble(intratx(level-1))
          hyposs(level) = hyposs(level-1) / dble(intraty(level-1))
          level         = level + 1
      go to 70
 80   continue


      return
      end
c
c -------------------------------------------------------------------------
c
      subroutine initTimers()

      use amr_module
      !implicit double precision (a-h,o-z)

      timeBufnst         = 0
      timeStepgrid       = 0
      timeStepgridCPU    = 0.d0
      timeBound          = 0
      timeBoundCPU       = 0.d0
      timeGrdfitAll      = 0
      timeFlagger        = 0
      timeFlglvl         = 0
      timeFlglvlTot      = 0
      timeGrdfit2        = 0
      timeLinSolve       = 0
      timeLinSolveCPU    = 0.d0
      timePrepBuild      = 0
      timePrepBuildCPU    = 0.d0
      timeRegridding     = 0
      timeRegriddingCPU  = 0.d0
      timeTick           = 0
      timeTickCPU        = 0.d0
      timeUpdating       = 0
      timeValout         = 0
      timeValoutCPU      = 0.d0
      avgIterRef         = 0.d0
      maxIterRef         = 0.d0

      return
      end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
      implicit double precision (a-h,o-z)
!
!     # Riemann solver in the transverse direction for the elastic equations
!     # with varying material properties 
!
!
!     # Contents of ql and qr:
!     # 
!     # q(1,:) = sigma^{11} if ixy=1   or   sigma^{22} if ixy=2
!     # q(2,:) = sigma^{22} if ixy=1   or   sigma^{11} if ixy=2
!     # q(3,:) = sigma^{12} = sigma^{21}
!     # q(4,:) = u          if ixy=1   or   v          if ixy=2
!     # q(5,:) = v          if ixy=1   or   u          if ixy=2
!     # 
!     # auxN holds corresponding slices of the aux array:
!     #  N = 1 for row below
!     #      2 for this row
!     #      3 for row above
!     # 
!     #  auxN(1,i) = rho 
!     #  auxN(2,i) = lambda 
!     #  auxN(3,i) = mu
!     #  auxN(4,i) = cp 
!     #  auxN(5,i) = cs
!
!
!
!     # Split asdq into down-going flux bmasdq and up-going flux bpasdq.
!
!     # imp=1  means  asdq=amdq,    imp=2 means asdq=apdq
!
      dimension     ql(meqn, 1-mbc:maxm+mbc)
      dimension     qr(meqn, 1-mbc:maxm+mbc)
      dimension   asdq(meqn, 1-mbc:maxm+mbc)
      dimension bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension bpasdq(meqn, 1-mbc:maxm+mbc)
      dimension   aux1(maux, 1-mbc:maxm+mbc)
      dimension   aux2(maux, 1-mbc:maxm+mbc)
      dimension   aux3(maux, 1-mbc:maxm+mbc)
!
!
!
!     # set ku to point to  the component of the system that corresponds
!     # to velocity in the direction of this slice, kv to the orthogonal
!     # velocity.  Similarly ksig11 and ksig22 point to normal stresses.
!     # 3rd component is always shear stress sig12.
!
!
      if (ixy.eq.1) then
         ksig11 = 1
         ksig22 = 2
         ku = 4
         kv = 5
      else
         ksig11 = 2
         ksig22 = 1
         ku = 5
         kv = 4
      endif
!
!
      do i = 2-mbc, mx+mbc
!
!        # imp is used to flag whether wave is going to left or right,
!        # since material properties are different on the two sides
!
         if (imp.eq.1) then 
!            # asdq = amdq, moving to left
             i1 = i-1
         else
!            # asdq = apdq, moving to right
             i1 = i
         endif
!
!        # The flux difference asdq is split into downward moving parts
!        # traveling at speeds -cp and -cs relative to the medium below and
!        # upward moving parts traveling
!        # at speeds +cp and +cs relative to the medium above.
!
!        # Note that the sum of these parts does not give all of asdq
!        # since there is also reflection at the interfaces which decreases
!        # the flux.
!
!        # jumps in asdq:
         dsig11 = asdq(ksig11,i)
         dsig22 = asdq(ksig22,i)
         dsig12 = asdq(3,i)
         du     = asdq(ku,i)
         dv     = asdq(kv,i)
!
!
!        # Material parameters in each row of cells:
         alamm = aux1(2,i1)
         alam  = aux2(2,i1)
         alamp = aux3(2,i1)
         amum  = aux1(3,i1)
         amu   = aux2(3,i1)
         amup  = aux3(3,i1)
         bulkm = alamm + 2.d0*amum
         bulk  = alam  + 2.d0*amu 
         bulkp = alamp + 2.d0*amup
     
!        # P-wave and S-wave speeds in each row of cells:
         cpm = aux1(4,i1)
         cp  = aux2(4,i1)
         cpp = aux3(4,i1)
         csm = aux1(5,i1)
         cs  = aux2(5,i1)
         csp = aux3(5,i1)
!

!        # transmitted part of down-going P-wave:
         det = bulkm*cp + bulk*cpm
         if (det .eq. 0.d0) then
            write(6,*) 'det1 = 0 in rpt2'
            stop
            endif
         a1 = (cp*dsig22 + bulk*dv) / det

!        # transmitted part of up-going P-wave:
         det = bulk*cpp + bulkp*cp
         if (det .eq. 0.d0) then
            write(6,*) 'det2 = 0 in rpt2'
            stop
            endif
         a2 = (cp*dsig22 - bulk*dv) / det
!
!        # transmitted part of down-going S-wave:
         det = -(amum*cs + amu*csm)
         if (det .eq. 0.d0) then
             a3 = 0.d0
         else
             a3 = (cs*dsig12 + amu*du) / det
         endif

!        # transmitted part of up-going S-wave:
         det = -(amu*csp + amup*cs)
         if (det .eq. 0.d0) then
             a4 = 0.d0
         else
             a4 = (cs*dsig12 - amu*du) / det
         endif
!
!        # The down-going flux difference bmasdq is the product  -c * wave
!        # summed over down-going P-wave and S-wave:
!
         bmasdq(ksig11,i) = -cpm*a1*alamm
         bmasdq(ksig22,i) = -cpm*a1*bulkm
         bmasdq(3,i) =      -csm*a3*(-amum)
         bmasdq(ku,i) =     -csm*a3*(-csm)
         bmasdq(kv,i) =     -cpm*a1*(cpm)
!
!        # The up-going flux difference bpasdq is the product  c * wave
!        # summed over up-going P-wave and S-wave:
!
         bpasdq(ksig11,i) =  cpp*a2*alamp
         bpasdq(ksig22,i) =  cpp*a2*bulkp
         bpasdq(3,i) =       csp*a4*(-amup)
         bpasdq(ku,i) =      csp*a4*(csp)
         bpasdq(kv,i) =      cpp*a2*(-cpp)
!
      enddo
!
      return
      end

! =====================================================
subroutine rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

!     # Riemann solver for the acoustics equations in 1d, with
!     #  variable coefficients (heterogeneous media)

! waves:     2
! equations: 2
! aux fields: 2

! Conserved quantities:
!       1 pressure
!       2 velocity

! Auxiliary variables:
!       1 impedance
!       2 sound_speed

! auxl(1,i) should contain the impedance Z in cell i
! auxl(2,i) should contain the sound speed c in cell i

! On input, ql contains the state vector at the left edge of each cell
! qr contains the state vector at the right edge of each cell

! On output, wave contains the waves,
! s the speeds,
! 
! amdq = A^- Delta q,
! apdq = A^+ Delta q,
! the decomposition of the flux difference
! f(qr(i-1)) - f(ql(i))
! into leftgoing and rightgoing parts respectively.

! Note that the i'th Riemann problem has left state qr(:,i-1) and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit double precision (a-h,o-z)

    dimension auxl(maux, 1-mbc:maxm+mbc)
    dimension auxr(maux, 1-mbc:maxm+mbc)
    dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn, 1-mbc:maxm+mbc)
    dimension amdq(meqn, 1-mbc:maxm+mbc)

!    local arrays
!    ------------
    dimension delta(2)


    ! split the jump in q at each interface into waves

    ! find a1 and a2, the coefficients of the 2 eigenvectors:
    do i = 2-mbc, mx+mbc
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(2,i) - qr(2,i-1)

        ! impedances:
        zi = auxl(1,i)
        zim = auxr(1,i-1)

        a1 = (-delta(1) + zi*delta(2)) / (zim + zi)
        a2 =  (delta(1) + zim*delta(2)) / (zim + zi)
    
        ! Compute the waves.
    
        wave(1,1,i) = -a1*zim
        wave(2,1,i) = a1
        s(1,i) = -auxr(2,i-1)
    
        wave(1,2,i) = a2*zi
        wave(2,2,i) = a2
        s(2,i) = auxl(2,i)
    
    end do

    ! compute the leftgoing and rightgoing fluctuations:
    ! Note that s(1,i) < 0   and   s(2,i) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = s(1,i)*wave(m,1,i)
            apdq(m,i) = s(2,i)*wave(m,2,i)
        end do
    end do

    return
    end subroutine rp1

c
c ---------------------------------------------------------
c
      subroutine outmsh(mptr,outgrd,nvar,naux)

      use amr_module
      implicit double precision (a-h,o-z)

      logical  outgrd
c
c ::::::::::::::::::::: OUTMSH :::::::::::::::::::::::::::::::::::::
c
c outmsh - output the grid descriptor and optionally the values on
c          the grid (for a single grid - see "outtre" for outputing
c          a subtree)
c input parameters:
c    mptr   - ptr to grid descriptor
c    outgrd - if true, output value on grid
c special case
c     if grid has level < 1, nothing is printed. (forest pointer
c has level = 0).  this simplifies logic of outtre; also, any grid
c with level <= 0 is not properly set (the forest pointer
c is used only to provide pointers into the tree of coarsest grids)
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
 
100   format(1x,47h+----------------------------------------------,
     *30h-----------------------------+)
c
      lev = node(nestlevel,mptr)
c
      write(outunit,100)
      write(outunit,101) mptr
101   format(1x,10h! grid no:,i6,60x,1h!)
      write(outunit,102) node(nestlevel,mptr),rnode(timemult,mptr),
     .             node(levelptr,mptr)
102   format(1x,1h!,11h nestlevel=,i3,12h, time mult=,f8.5,
     1       13h, level ptr =,i6,22x,1h!)
      write(outunit,103) node(store1,mptr),node(store2,mptr),
     1                   node(cfluxptr,mptr),node(ffluxptr,mptr)
 103  format(1x,'! storage locs =',2i12,'  bndry locs =',2i11,1h!)
      write(outunit,104)
      write(outunit,111) rnode(cornxhi,mptr),
     2                   rnode(cornyhi,mptr),
     3                   rnode(cornzhi,mptr)
      write(outunit,111) rnode(cornxlo,mptr),
     2                   rnode(cornylo,mptr),
     3                   rnode(cornzlo,mptr)
      write(outunit,112)
      write(outunit,113) node(ndihi,mptr),
     2                   node(ndjhi,mptr),
     3                   node(ndkhi,mptr)
      write(outunit,113) node(ndilo,mptr),
     2                   node(ndjlo,mptr),
     3                   node(ndklo,mptr)
112   format(1x,23h! integer index space :,53x,1h!)
113   format(1x,2h! ,18x,1h(,i8,2h, ,i8,2h, ,i8,1h),26x,1h!)
104   format(1x,40h! corners of rectangular parallelopiped:,36x,1h!)
111   format(1x,2h! ,18x,1h(,f8.5,2h, ,f8.5,2h, ,f8.5,1h),26x,1h!)
      write(outunit,105) hxposs(lev),hyposs(lev),hzposs(lev),possk(lev)
105   format(1x,7h! hrow=,f9.6,7h, hcol=,f9.6,7h, hfil=,f9.6,
     .          8h, ktime=,f9.6,11x,1h!)
      write(outunit,100)
c
      if (.not. outgrd) go to 99
c output the grid
      mitot   = node(ndihi,mptr) - node(ndilo,mptr) + 1 + 2*nghost
      mjtot   = node(ndjhi,mptr) - node(ndjlo,mptr) + 1 + 2*nghost
      mktot   = node(ndkhi,mptr) - node(ndklo,mptr) + 1 + 2*nghost
      loc     = node(store1,mptr)
      locaux  = node(storeaux,mptr)
      call outval(alloc(loc),nvar,mitot,mjtot,mktot,mptr,outgrd,
     1            naux,alloc(locaux))
 99   return
      end

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::::     Support module for the adjoint_module.
! :::::: This module contains subroutines that are specific 
! :::::: to AMRClaw, and is mirrored by a similar module that
! :::::: is specific to GeoClaw.
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

module adjointsup_module

contains

! ========================================================================
!  Routine to calculate inner product
! ========================================================================

    subroutine calculate_innerproduct(q,k,mx_f,my_f,xlower_f, &
               ylower_f,dx_f,dy_f,meqn_f,mbc_f,maux_f,aux)

        use adjoint_module

        implicit none

        real(kind=8), intent(in) :: xlower_f,ylower_f,dx_f,dy_f
        integer :: k,mx_f,my_f,meqn_f,mbc_f,maux_f
        real(kind=8), intent(in) :: q(meqn_f,1-mbc_f:mx_f+mbc_f,1-mbc_f:my_f+mbc_f)

        integer :: mx_a, my_a, mptr_a, mbc_a
        integer :: i, j, i1, i2, j1, j2, level, loc, z
        real(kind=8) :: dx_a, xlower_a, xupper_a, xupper_f
        real(kind=8) :: dy_a, ylower_a, yupper_a, yupper_f
        real(kind=8) :: x1, x2, y1, y2

        real(kind=8) :: q_innerprod(mx_f,my_f)
        logical :: mask_forward(mx_f,my_f)
        real(kind=8) :: q_interp(meqn_f,mx_f,my_f)
        real(kind=8), intent(inout) :: aux(maux_f,1-mbc_f:mx_f+mbc_f,1-mbc_f:my_f+mbc_f)

        logical, allocatable :: mask_adjoint(:,:)

        xupper_f = xlower_f + mx_f*dx_f
        yupper_f = ylower_f + my_f*dy_f

        ! Loop over patches in adjoint solution
        do z = 1, adjoints(k)%ngrids
            mptr_a = adjoints(k)%gridpointer(z)
            level = adjoints(k)%gridlevel(mptr_a)

            ! Number of points in x and y
            mx_a = adjoints(k)%ncellsx(mptr_a)
            my_a = adjoints(k)%ncellsy(mptr_a)

            ! Finding extreem values for grid
            xlower_a = adjoints(k)%xlowvals(mptr_a)
            dx_a = adjoints(k)%hxposs(level)
            xupper_a = xlower_a + mx_a*dx_a
            ylower_a = adjoints(k)%ylowvals(mptr_a)
            dy_a = adjoints(k)%hyposs(level)
            yupper_a = ylower_a + my_a*dy_a

            loc = adjoints(k)%loc(mptr_a)

            ! Check if adjoint patch overlaps with forward patch
            x1 = max(xlower_f,xlower_a)
            x2 = min(xupper_f,xupper_a)
            y1 = max(ylower_f,ylower_a)
            y2 = min(yupper_f,yupper_a)

            if ((x1 > x2) .or. (y1 > y2)) then
                ! Skipping interpolation if grids don't overlap
                mask_forward = .false.
                continue
            else
                mbc_a = adjoints(k)%nghost
                allocate(mask_adjoint(1-mbc_a:mx_a+mbc_a, 1-mbc_a:my_a+mbc_a))

                ! Create a mask that is .true. only in part of patch intersecting forward patch:
                i1 = max(int((x1 - xlower_a + 0.5d0*dx_a) / dx_a), 0)
                i2 = min(int((x2 - xlower_a + 0.5d0*dx_a) / dx_a) + 1, mx_a+1)
                j1 = max(int((y1 - ylower_a + 0.5d0*dy_a) / dy_a), 0)
                j2 = min(int((y2 - ylower_a + 0.5d0*dy_a) / dy_a) + 1, my_a+1)

                forall (i=1-mbc_a:mx_a+mbc_a, j=1-mbc_a:my_a+mbc_a)
                    mask_adjoint(i,j) = ((i >= i1) .and. (i <= i2) .and. &
                                       (j >= j1) .and. (j <= j2))
                end forall

                ! Create a mask that is .true. only in part of forward patch intersecting patch:

                i1 = max(int((x1 - xlower_f + 0.5d0*dx_f) / dx_f)+1, 0)
                i2 = min(int((x2 - xlower_f + 0.5d0*dx_f) / dx_f), mx_f)
                j1 = max(int((y1 - ylower_f + 0.5d0*dy_f) / dy_f)+1, 0)
                j2 = min(int((y2 - ylower_f + 0.5d0*dy_f) / dy_f), my_f)

                forall (i=1:mx_f, j=1:my_f)
                    mask_forward(i,j) = ((i >= i1) .and. (i <= i2) .and. &
                                       (j >= j1) .and. (j <= j2))
                end forall

                ! Interpolate adjoint values to q_interp
                ! Note that values in q_interp will only be set properly where
                ! mask_adjoint == .true.
                call interp_adjoint( &
                        adjoints(k)%meqn, k, q_interp, xlower_a, ylower_a, &
                        dx_a, dy_a, mx_a, my_a, xlower_f, ylower_f, &
                        dx_f, dy_f, mx_f, my_f, &
                        mask_adjoint, mptr_a, mask_forward)

                q_innerprod = 0.d0

                ! For each overlapping point, calculate inner product
                ! When using richardson error, q contains the error 
                ! in each term.
                forall(i = 1:mx_f, j = 1:my_f, mask_forward(i,j))
                    q_innerprod(i,j) = abs(dot_product(q(:,i,j),q_interp(:,i,j)))
                end forall

                do i=1,mx_f
                    do j=1,my_f
                        if (q_innerprod(i,j) > aux(innerprod_index,i,j)) then
                            aux(innerprod_index,i,j) = q_innerprod(i,j)
                        endif
                    enddo
                enddo

                deallocate(mask_adjoint)
            endif
        enddo

    end subroutine calculate_innerproduct

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! :::::     Routine to interpolate adjoint to given x,y point
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    subroutine interp_adjoint(nvar, r, q_interp, xlower_a, ylower_a, &
              dx_a, dy_a, mx_a, my_a, xlower_f, ylower_f, dx_f, &
              dy_f, mx_f, my_f, mask_adjoint, mptr_a, mask_forward)

        use adjoint_module, only : adjoints
        implicit none

        ! Function arguments
        integer, intent(in) :: nvar, r, mx_a, my_a
        logical, intent(in) :: mask_adjoint( &
                          1-adjoints(r)%nghost:mx_a+adjoints(r)%nghost, &
                          1-adjoints(r)%nghost:my_a+adjoints(r)%nghost)
        real(kind=8), intent(in) :: xlower_a, xlower_f, ylower_a, ylower_f
        integer, intent(in) :: mx_f, my_f, mptr_a
        real(kind=8), intent(in) :: dx_f, dx_a, dy_f, dy_a

        integer :: z, k, iz, jk, mitot
        integer :: ivar, i, j, iadd, loc
        real(kind=8) :: q_interp(nvar,mx_f,my_f), denom
        real(kind=8) :: x, xhigh_a, y, yhigh_a
        real(kind=8) :: dxz, dyk, a, b, c
        logical :: mask_forward(mx_f,my_f)

        iadd(ivar,i,j)  = loc + ivar - 1 + adjoints(r)%meqn*((j-1)*mitot+i-1)

        q_interp = 0.0
        xhigh_a  = xlower_a + mx_a*dx_a
        yhigh_a = ylower_a + my_a*dx_a
        loc    = adjoints(r)%loc(mptr_a)
        mitot = adjoints(r)%ncellsx(mptr_a) + 2*adjoints(r)%nghost

        do z = 1,mx_f
            do k = 1,my_f
                if (mask_forward(z,k)) then
                    x = xlower_f + (z - 0.5d0)*dx_f
                    y = ylower_f + (k - 0.5d0)*dy_f

                    iz = int((x - xlower_a + 0.5d0*dx_a) / dx_a) + 1
                    dxz = x - (xlower_a + (iz-0.5d0)*dx_a)
                    jk = int((y - ylower_a + 0.5d0*dy_a) / dy_a) + 1
                    dyk = y - (ylower_a + (jk-0.5d0)*dy_a)

                    ! Interpolate only if this cell is overlapping with grid
                    if (mask_adjoint(iz,jk)) then
                        do ivar=1,nvar

                        a = (adjoints(r)%alloc(iadd(ivar,iz+1,jk)) &
                              - adjoints(r)%alloc(iadd(ivar,iz,jk))) / dx_a
                        b = (adjoints(r)%alloc(iadd(ivar,iz,jk+1)) &
                              - adjoints(r)%alloc(iadd(ivar,iz,jk))) / dy_a
                        c = (adjoints(r)%alloc(iadd(ivar,iz+1,jk+1)) &
                              + adjoints(r)%alloc(iadd(ivar,iz,jk)) &
                              - adjoints(r)%alloc(iadd(ivar,iz+1,jk)) &
                              - adjoints(r)%alloc(iadd(ivar,iz,jk+1))) / (dx_a*dy_a)

                        q_interp(ivar,z,k) = &
                              adjoints(r)%alloc(iadd(ivar,iz,jk)) &
                              + a*dxz + b*dyk + c*dxz*dyk

                        enddo
                    endif
                endif
            enddo
        enddo

    end subroutine interp_adjoint

! ========================================================================
!  Routine to compute error in forward solution for the adjoint method
!  Adapted from errf1.f
!  Differences: 
!   (i) Computes error for all of the terms in q
!   (ii) Needs the aux array passed in, because the inner product is saved 
!        to the aux array (note, this changes the call sequence, which is 
!        why this is not included into the AMRClaw errf1.f file. If plotting 
!        of the inner product is never wanted, this could be simplified 
!        and included into the AMRClaw errf1.f file.
! ========================================================================

    subroutine errf1a(rctfine,nvar,rctcrse,mptr,mi2tot,mj2tot, &
                      mitot,mjtot,rctflg,mibuff,mjbuff,auxfine, &
                      naux,auxcrse)
      use amr_module
      use adjoint_module, only: innerprod_index, &
             totnum_adjoints, adjoints, trange_start, trange_final, &
             levtol, eptr, errors, grid_num, select_snapshots
      implicit double precision (a-h,o-z)

      dimension  rctfine(nvar,mitot,mjtot)
      dimension  rctcrse(nvar,mi2tot,mj2tot)
      dimension  rctflg(mibuff,mjbuff)
      dimension  err_crse(nvar,mi2tot,mj2tot)
      dimension  bcrse(mitot,mjtot)
      dimension  auxfine(naux,mitot,mjtot)
      dimension  auxcrse(naux,mi2tot,mj2tot)

      logical mask_selecta(totnum_adjoints)
!
!
! :::::::::::::::::::::: Modified from ERRF1 :::::::::::::::::::::::::
!
!  Richardson error estimator:  Used when flag_richardson is .true.
!  Compare error estimates in rctfine, rctcrse,
!  A point is flagged if the inner product between the
!  error estimate and the adjoint solution is greater than tol
!  later we check if its in a region where its allowed to be flagged
!  or alternatively required.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!

      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      ybot  = rnode(cornylo,mptr)
      hy    = hyposs(levm)
      dt    = possk(levm)

      jg = grid_num(mptr)
      nx = mitot - 2*nghost
      ny = mjtot - 2*nghost

      call select_snapshots(time,mask_selecta)

      errmax = 0.0d0
      err2   = 0.0d0
      auxfine(innerprod_index,:,:) = 0.0d0
      auxcrse(innerprod_index,:,:) = 0.0d0

      order  = dble(2**(iorder+1) - 2)
!
!     Calculating correct tol for this level
!     nxnest is the maximum number of refinement levels, from amr_module
!     --------------------
!     Total error allowed in this time step
      tol_exact = tol*dt/(tfinal-t0)
!     Error allowed at this level
      tol_exact = tol_exact/mxnest
!     Error allowed per cell at this level
      tol_exact = tol_exact/(numcells(levm)*hx*hy)

      if (t0+possk(levm) .eq. time) levtol(levm) = tol_exact

!
! Main loop: calculate errors in forward problem
!
      jfine = nghost+1
      do j = nghost+1, mj2tot-nghost
        yofj  = ybot + (dble(jfine) - .5d0)*hy
        ifine = nghost+1

        do i  = nghost+1, mi2tot-nghost

! Only check errors if flag hasn't been set yet.
! If flag == DONTFLAG then refinement is forbidden by a region,
! if flag == DOFLAG checking is not needed

! Note: here rctcrse is being used as a temporary flag
! the fine grid amrflags array is stored in rctflg, and will be
! updated based on rctcrse at the end of this routine
           if(rctflg(ifine,jfine) == UNSET &
              .or. rctflg(ifine+1,jfine) == UNSET &
              .or. rctflg(ifine,jfine+1) == UNSET &
              .or. rctflg(ifine+1,jfine+1) == UNSET) then

              xofi  = xleft + (dble(ifine) - .5d0)*hx

!             Calculate error for each value of q

              do k = 1, nvar
                term1 = rctfine(k,ifine,jfine)
                term2 = rctfine(k,ifine+1,jfine)
                term3 = rctfine(k,ifine+1,jfine+1)
                term4 = rctfine(k,ifine,jfine+1)
!               # divide by (aval*order) for relative error
                aval  = (term1+term2+term3+term4)/4.d0
                est   =  dabs((aval-rctcrse(k,i,j))/ order)
                if (est .gt. errmax) errmax = est
                  err2 = err2 + est*est

                  err_crse(k,i,j) = est
!                 retaining directionality of the wave
                  err_crse(k,i,j) = sign(est,rctcrse(k,i,j))
              enddo
            else
                err_crse(:,i,j) = 0.d0
            endif

          ifine = ifine + 2
        enddo

        jfine = jfine + 2
      enddo

!     Loop over adjoint snapshots

! Note: here the coarse version of the inner product values in auxcrse are set.
! The fine grid inner product values will be stored in 
! auxfine(inneprod_index,:,:) which will be updated based 
! on rctcrse at the end of this routine. 

      do k = 1,totnum_adjoints
!         Consider only snapshots that are within the desired time range
          if (mask_selecta(k)) then
!             set innerproduct
              call calculate_innerproduct(err_crse,k,nx/2, &
                    ny/2,xleft,ybot,hx*2,hy*2,nvar,nghost,naux,auxcrse)
          endif
      enddo

      do i  = nghost+1, mi2tot-nghost
        do j = nghost+1, mj2tot-nghost
          i_val = i-nghost
          j_val = j-nghost

!         Saving calculated errors to adjoint_module to be used 
!         for calculating tolerance in subsequent time steps
          errors(eptr(jg)+(i_val-1)*ny/2+j_val) = auxcrse(innerprod_index,i,j)

          if (auxcrse(innerprod_index,i,j) .ge. levtol(levm)) then
              rctcrse(1,i,j)  = DOFLAG
          else
              rctcrse(1,i,j)  = DONTFLAG
          endif

        enddo
      enddo

!     Updating fine grid inner product and flag values from coarse 
!     temporary vectors
      jfine   = nghost+1
      do j = nghost+1, mj2tot-nghost
        ifine   = nghost+1

        do i = nghost+1, mi2tot-nghost
          auxfine(innerprod_index,ifine,jfine) = auxcrse(innerprod_index,i,j)
          auxfine(innerprod_index,ifine+1,jfine) = auxcrse(innerprod_index,i,j)
          auxfine(innerprod_index,ifine,jfine+1) = auxcrse(innerprod_index,i,j)
          auxfine(innerprod_index,ifine+1,jfine+1) = auxcrse(innerprod_index,i,j)

          if (rctcrse(1,i,j) .eq. DOFLAG) then
!           ## never set rctflg to DONTFLAG, since flag2refine or
!           ## flagregions2 may have previously set it to DOFLAG
!           ## can only add DOFLAG pts in this routine
            rctflg(ifine,jfine)    = DOFLAG
            rctflg(ifine+1,jfine)  = DOFLAG
            rctflg(ifine,jfine+1)  = DOFLAG
            rctflg(ifine+1,jfine+1)= DOFLAG
          endif
          ifine   = ifine + 2
        enddo

        jfine   = jfine + 2
      enddo

    end subroutine errf1a

end module adjointsup_module

c
c -----------------------------------------------------------
c
      subroutine flglvl1(nvar,naux,lcheck,nxpts,index,lbase,npts,
     &                   start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer clock_start, clock_finish, clock_rate
c
c :::::::::::::::::::: FLGLVL :::::::::::::::::::::::::::::::::
c
c flglvl = controls the error estimation/flagging bad pts. for
c          an entire level of grids.  returns pointer into alloc
c          where the (x) coordinations of the flagged pts. are.
c input parameters:
c           lcheck = level to be flagged
c output parameters:
c           nxpts = no. of flagged pts. total
c           index  = starting index in alloc of the flagged pts.
c                    (which occupy 1*nxpts locations).
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c
      nxpts = 0
      numbad = 0


c     flag arrays- based on either spatial gradients (and/or user defined
c                  criteria),  or Richardson error estimation,
c                  or user-defined regions
    
      call system_clock(clock_start,clock_rate)
      call flagger(nvar,naux,lcheck,start_time)
      call system_clock(clock_finish,clock_rate)
      timeFlagger = timeFlagger + clock_finish - clock_start


c     buffer the flagged cells (done for each grid patch of flags)
c     also project flags from finer levels onto this level to ensure
c     proper nesting. Finally compute proper domain for each patch
      call system_clock(clock_start,clock_rate)
      call bufnst1(nvar,naux,numbad,lcheck,lbase)
      call system_clock(clock_finish,clock_rate)
      timeBufnst = timeBufnst + clock_finish - clock_start


      nxpts = nxpts + numbad
c
c  colate flagged pts into flagged points array
c  new version needs to check for proper nesting at this point
c  also needs to sort,  so can remove duplicates.
c
      if (nxpts .gt. 0) then
c        build domain flags for each grid at level lcheck, instead of
c        previous approach using domain flags over entire  domain
c         call domgrid(lbase,lcheck)   ! will need since there are flagged pts  NOW IN BUFNST2
c
c in new version, there are bad cells but nxpts isnt true count any longer
c since there are duplicates, and proper nesting not yet checked
           index = igetsp(nxpts)
           call colate1(alloc(index),nxpts,lcheck,npts,lbase)
      else
         npts = 0  !npts is number of unique flagged points after removing duplicates
         call freeFlags(lcheck)   ! otherwise storage freed in colate1. perhaps always do it here
      endif

      return
      end
c
c ---------------------------------------------------------------------------------
c
       subroutine freeFlags(lcheck)

       use amr_module
       implicit double precision (a-h, o-z)

       mptr = lstart(lcheck)
 10          continue
             locamrflags = node(storeflags,mptr)
             locdomflags = node(domflags_base,mptr)
             locdom2 = node(domflags2,mptr)

             nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
             mbuff = max(nghost,ibuff+1)
             mibuff = nx + 2*mbuff

             ibytesPerDP = 8
             nwords = (mibuff)/ibytesPerDP+1
             call reclam(locdomflags, nwords)
             call reclam(locdom2, nwords)
             call reclam(locamrflags,mibuff)

        mptr = node(levelptr, mptr)
        if (mptr .ne. 0) go to 10

       return
       end

!      =======================================================
    subroutine src2(maxmx,maxmy,num_eqn,num_ghost,mx,my,xlower,ylower, &
    dx,dy,q,num_aux,aux,t,dt,Rsphere)
!      =======================================================


!     # Compute source term for Rossby-Haurwitz wave.
!     # The source term models the Coriolis force using a 4-stage RK method
!     # and the projection of the velocity components to the tangent plane.


    implicit double precision (a-h,o-z)
    dimension    q(num_eqn, 1:mx, 1:my)
    dimension aux(num_aux,  1:mx, 1:my)
    double precision :: RK(4,3)

!f2py integer intent(in) maxmx
!f2py integer intent(in) maxmy
!f2py integer optional, intent(in) num_eqn
!f2py integer intent(in) num_ghost
!f2py integer intent(in) mx
!f2py integer intent(in) my
!f2py double precision intent(in) xlower
!f2py double precision intent(in) ylower
!f2py double precision intent(in) dx
!f2py double precision intent(in) dy
!f2py intent(in,out) q
!f2py integer optional, intent(in)  num_aux
!f2py intent(in) aux
!f2py double precision intent(in) t
!f2py double precision intent(in) dt
!f2py double precision intent(in) Rsphere


!     # Parameters
    a = 6.37122d6
    Omega = 7.292d-5
    df=12.600576e0

!     # project momentum components of q onto tangent plane:

    do i=1,mx
        do j=1, my
            erx = aux(14,i,j)
            ery = aux(15,i,j)
            erz = aux(16,i,j)
            qn = erx*q(2,i,j) + ery*q(3,i,j) + erz*q(4,i,j)

            q(2,i,j) = q(2,i,j) - qn*erx
            q(3,i,j) = q(3,i,j) - qn*ery
            q(4,i,j) = q(4,i,j) - qn*erz

        enddo
    enddo

!     # calculate Coriolis term
    do i=1, mx
        xc = xlower + (i-0.5d0)*dx
        do j=1, my
            yc = ylower + (j-0.5d0)*dy
        
            call mapc2p(xc,yc,xp,yp,zp,Rsphere)
            erx = xp
            ery = yp
            erz = zp
        
            rad = dsqrt(xp**2. + yp**2.)
            if (rad > 1.d-4) then
                theta = dacos(xp/rad)
            elseif (yp > 0.d0) then
                theta = 0.d0
            endif
            if (yp < 0.d0) then
                theta = -theta
            endif

        !           # compute phi, at north pole: pi/2 at south pool: -pi/2
            if (zp > 0.d0) then
                phi =   dacos(rad/Rsphere)
            else
                phi = - dacos(rad/Rsphere)
            endif
        
            fcor = df*erz

        !           stage 1
            hu = q(2,i,j)
            hv = q(3,i,j)
            hw = q(4,i,j)
                                          
            RK(1,1) = fcor*dt*(erz*hv-ery*hw)
            RK(1,2) = dt*fcor*(erx*hw-erz*hu)
            RK(1,3) = dt*fcor*(ery*hu-erx*hv)

        !           stage 2
            hu = q(2,i,j) + 0.5d0*RK(1,1)
            hv = q(3,i,j) + 0.5d0*RK(1,2)
            hw = q(4,i,j) + 0.5d0*RK(1,3)

            RK(2,1) = fcor*dt*(erz*hv-ery*hw)
            RK(2,2) = dt*fcor*(erx*hw-erz*hu)
            RK(2,3) = dt*fcor*(ery*hu-erx*hv)

        !           stage 3
            hu = q(2,i,j) + 0.5d0*RK(2,1)
            hv = q(3,i,j) + 0.5d0*RK(2,2)
            hw = q(4,i,j) + 0.5d0*RK(2,3)

            RK(3,1) = fcor*dt*(erz*hv-ery*hw)
            RK(3,2) = dt*fcor*(erx*hw-erz*hu)
            RK(3,3) = dt*fcor*(ery*hu-erx*hv)

        !           stage 4
            hu = q(2,i,j) + 0.5d0*RK(3,1)
            hv = q(3,i,j) + 0.5d0*RK(3,2)
            hw = q(4,i,j) + 0.5d0*RK(3,3)

            RK(4,1) = fcor*dt*(erz*hv-ery*hw)
            RK(4,2) = dt*fcor*(erx*hw-erz*hu)
            RK(4,3) = dt*fcor*(ery*hu-erx*hv)
                        
            do m=2,num_eqn
                q(m,i,j) = q(m,i,j) &
                + (RK(1,m-1) + 2.d0*RK(2,m-1)+ &
                2.d0*RK(3,m-1) + RK(4,m-1))/6.d0
            enddo

        enddo
    enddo
     
!     # project momentum components of q onto tangent plane:

    do i=1,mx
        do j=1, my
            erx = aux(14,i,j)
            ery = aux(15,i,j)
            erz = aux(16,i,j)
            qn = erx*q(2,i,j) + ery*q(3,i,j) + erz*q(4,i,j)
            q(2,i,j) = q(2,i,j) - qn*erx
            q(3,i,j) = q(3,i,j) - qn*ery
            q(4,i,j) = q(4,i,j) - qn*erz

        enddo
    enddo

    return
    end subroutine src2

! ==============================================================================
! model_storm_module 
!
! Module contains routines for constructing a wind and pressure field based on a
! provided set of data files.
!
! ==============================================================================
!                   Copyright (C) Clawpack Developers 2017
!  Distributed under the terms of the Berkeley Software Distribution (BSD) 
!  license
!                     http://www.opensource.org/licenses/
! ==============================================================================
module data_storm_module

    implicit none
    save

    logical, private :: module_setup = .false.
    logical, private :: DEBUG = .false.

    ! Model storm type definition
    type data_storm_type

        ! Dummy variable
        integer :: mine

    end type data_storm_type

contains

    ! Setup routine for model storms
    subroutine set_storm(storm_data_path, storm, model_type, log_unit)

        implicit none

        ! Subroutine I/O
        character(len=*), optional :: storm_data_path
        type(data_storm_type), intent(in out) :: storm
        integer, intent(in) :: model_type, log_unit

        stop "Data-derived storm are not yet implemented!"

        if (.not. module_setup) then

            module_setup = .true.
        end if

    end subroutine set_storm


    ! ==========================================================================
    !  storm_location(t,storm)
    !    Interpolate location of hurricane in the current time interval
    ! ==========================================================================
    function storm_location(t,storm) result(location)

        implicit none

        ! Input
        real(kind=8), intent(in) :: t
        type(data_storm_type), intent(in out) :: storm

        ! Output
        real(kind=8) :: location(2)

        stop "Data-derived storm are not yet implemented!"

    end function storm_location

    ! ==========================================================================
    !  storm_direction
    !   Angle off of due north that the storm is traveling
    ! ==========================================================================
    real(kind=8) function storm_direction(t, storm) result(theta)

        implicit none

        ! Input
        real(kind=8), intent(in) :: t
        type(data_storm_type), intent(in) :: storm

        stop "Data-derived storm are not yet implemented!"

    end function storm_direction


    ! ==========================================================================
    !  Use the 1980 Holland model to set the storm fields
    ! ==========================================================================
    subroutine set_HWRF_fields(maux, mbc, mx, my, xlower, ylower,    &
                          dx, dy, t, aux, wind_index,           &
                          pressure_index, storm)

  
        implicit none

        ! Time of the wind field requested
        integer, intent(in) :: maux,mbc,mx,my
        real(kind=8), intent(in) :: xlower,ylower,dx,dy,t

        ! Storm description, need in out here since we may update the storm
        ! if at next time point
        type(data_storm_type), intent(in out) :: storm

        ! Array storing wind and presure field
        integer, intent(in) :: wind_index, pressure_index
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        stop "HWRF data input is not yet implemented!"

    end subroutine set_HWRF_fields

end module data_storm_module

c
c
c     =====================================================
      subroutine bc2(meqn,mbc,mx,my,xlower,ylower,
     &               dx,dy,q,maux,aux,t,dt,mthbc)
c     =====================================================
c
c     # Standard boundary condition choices for claw2
c
c     # At each boundary  k = 1 (left),  2 (right),  3 (top), 4 (bottom):
c     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
c     #            =  1  for zero-order extrapolation
c     #            =  2  for periodic boundary coniditions
c     #            =  3  for solid walls, assuming this can be implemented
c     #                  by reflecting the data about the boundary and then
c     #                  negating the 2'nd (for k=1,2) or 3'rd (for k=3,4)
c     #                  component of q.
c     ------------------------------------------------
c
c     # Extend the data from the interior cells (1:mx, 1:my)
c     # to the ghost cells outside the region:
c     #   (i, 1-jbc)   for jbc = 1,mbc,  i = 1-mbc, mx+mbc
c     #   (i, my+jbc)  for jbc = 1,mbc,  i = 1-mbc, mx+mbc
c     #   (1-ibc, j)   for ibc = 1,mbc,  j = 1-mbc, my+mbc
c     #   (mx+ibc, j)  for ibc = 1,mbc,  j = 1-mbc, my+mbc
c
      implicit double precision (a-h,o-z)
      dimension q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension mthbc(4)

c
c
c-------------------------------------------------------
c     # left boundary:
c-------------------------------------------------------
      go to (100,110,120,130) mthbc(1)+1
c
  100 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(1)=0 and no BCs specified in bc2'
      stop
      go to 199
c
  110 continue
c     # zero-order extrapolation:
      do 115 j = 1-mbc, my+mbc
         do 115 ibc=1,mbc
            do 115 m=1,meqn
               q(m,1-ibc,j) = q(m,1,j)
  115       continue
      go to 199

  120 continue
c     # periodic:  
      do 125 j = 1-mbc, my+mbc
         do 125 ibc=1,mbc
            do 125 m=1,meqn
               q(m,1-ibc,j) = q(m,mx+1-ibc,j)
  125       continue
      go to 199

  130 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 135 j = 1-mbc, my+mbc
         do 135 ibc=1,mbc
            do 135 m=1,meqn
               q(m,1-ibc,j) = q(m,ibc,j)
  135       continue
c     # negate the normal velocity:
      do 136 j = 1-mbc, my+mbc
         do 136 ibc=1,mbc
            q(2,1-ibc,j) = -q(2,ibc,j)
  136    continue
      go to 199

  199 continue
c
c-------------------------------------------------------
c     # right boundary:
c-------------------------------------------------------
      go to (200,210,220,230) mthbc(2)+1
c
  200 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(2)=0 and no BCs specified in bc2'
      stop
      go to 299

  210 continue
c     # zero-order extrapolation:
      do 215 j = 1-mbc, my+mbc
         do 215 ibc=1,mbc
            do 215 m=1,meqn
               q(m,mx+ibc,j) = q(m,mx,j)
  215       continue
      go to 299

  220 continue
c     # periodic:  
      do 225 j = 1-mbc, my+mbc
         do 225 ibc=1,mbc
            do 225 m=1,meqn
               q(m,mx+ibc,j) = q(m,ibc,j)
  225       continue
      go to 299

  230 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 235 j = 1-mbc, my+mbc
         do 235 ibc=1,mbc
            do 235 m=1,meqn
               q(m,mx+ibc,j) = q(m,mx+1-ibc,j)
  235       continue
c     # negate the normal velocity:
      do 236 j = 1-mbc, my+mbc
         do 236 ibc=1,mbc
            q(2,mx+ibc,j) = -q(2,mx+1-ibc,j)
  236    continue
      go to 299

  299 continue
c
c-------------------------------------------------------
c     # bottom boundary:
c-------------------------------------------------------
      go to (300,310,320,330) mthbc(3)+1
c
  300 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(3)=0 and no BCs specified in bc2'
      stop
      go to 399
c
  310 continue
c     # zero-order extrapolation:
      do 315 jbc=1,mbc
         do 315 i = 1-mbc, mx+mbc
            do 315 m=1,meqn
               q(m,i,1-jbc) = q(m,i,1)
  315       continue
      go to 399

  320 continue
c     # periodic:  
      do 325 jbc=1,mbc
         do 325 i = 1-mbc, mx+mbc
            do 325 m=1,meqn
               q(m,i,1-jbc) = q(m,i,my+1-jbc)
  325       continue
      go to 399

  330 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 335 jbc=1,mbc
         do 335 i = 1-mbc, mx+mbc
            do 335 m=1,meqn
               q(m,i,1-jbc) = q(m,i,jbc)
  335       continue
c     # negate the normal velocity:
      do 336 jbc=1,mbc
         do 336 i = 1-mbc, mx+mbc
            q(3,i,1-jbc) = -q(3,i,jbc)
  336    continue
      go to 399

  399 continue
c
c-------------------------------------------------------
c     # top boundary:
c-------------------------------------------------------
      go to (400,410,420,430) mthbc(4)+1
c
  400 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(4)=0 and no BCs specified in bc2'
      stop
      go to 499

  410 continue
c     # zero-order extrapolation:
      do 415 jbc=1,mbc
         do 415 i = 1-mbc, mx+mbc
            do 415 m=1,meqn
               q(m,i,my+jbc) = q(m,i,my)
  415       continue
      go to 499

  420 continue
c     # periodic:  
      do 425 jbc=1,mbc
         do 425 i = 1-mbc, mx+mbc
            do 425 m=1,meqn
               q(m,i,my+jbc) = q(m,i,jbc)
  425       continue
      go to 499

  430 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 435 jbc=1,mbc
         do 435 i = 1-mbc, mx+mbc
            do 435 m=1,meqn
               q(m,i,my+jbc) = q(m,i,my+1-jbc)
  435       continue
c     # negate the normal velocity:
      do 436 jbc=1,mbc
         do 436 i = 1-mbc, mx+mbc
            q(3,i,my+jbc) = -q(3,i,my+1-jbc)
  436    continue
      go to 499

  499 continue

      return
      end

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! Aproximate Riemann solver for the nonlinear KPP system:

! q_t + sin(q)_x + cos(q)_y = 0

! waves: 1
! equations: 1

! Conserved quantities:
!       1 q

! Solve Riemann problems along one slice of data:
!  in the x-direction if ixy=1
!  in the y-direction if ixy=2.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going fluctuation
!            apdq the right-going fluctuation

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr

!      implicit none

    double precision :: ul, ur, fl, fr, fedge, pi, reml, remr
    integer :: i, ixy, maxm, meqn, mwaves, mbc, mx

    double precision :: wave(meqn,mwaves,1-mbc:maxm+mbc)
    double precision ::    s(mwaves,     1-mbc:maxm+mbc)
    double precision ::   ql(meqn,       1-mbc:maxm+mbc)
    double precision ::   qr(meqn,       1-mbc:maxm+mbc)
    double precision :: apdq(meqn,       1-mbc:maxm+mbc)
    double precision :: amdq(meqn,       1-mbc:maxm+mbc)


    pi=4.d0*datan(1.d0)

    do i=2-mbc,mx+mbc

        ul = qr(1,i-1)
        ur = ql(1,i  )

        if (ixy == 1) then
            fl = dsin(ul)
            fr = dsin(ur)

        ! The flux fedge at the cell interface is obtained by
        ! minimizing or maximizing the function sin(q) over the
        ! interval between the left and right states.

            if (ul < ur) then
            ! inimum
                fedge = dmin1(fl,fr)
                if (ur-ul > 2.d0*pi) then
                    fedge=-1.d0
                else
                    reml = dmod(ul,2.d0*pi)
                    remr = dmod(ur,2.d0*pi)
                    if (remr > 1.5d0*pi .AND. reml < 1.5d0*pi) then
                        fedge=-1.d0
                    elseif (ur-ul > remr+0.5d0*pi) then
                        fedge=-1.d0
                    endif
                endif
            else
            ! aximum
                fedge = dmax1(fl,fr)
                if (ul-ur > 2.d0*pi) then
                    fedge=1.d0
                else
                    reml = dmod(ul,2.d0*pi)
                    remr = dmod(ur,2.d0*pi)
                    if (reml > 0.5d0*pi .AND. remr < 0.5d0*pi) then
                        fedge=1.d0
                    elseif (ul-ur > reml+1.5d0*pi) then
                        fedge=1.d0
                    endif
                endif
            endif
        else ! ixy == 2
            fl = dcos(ul)
            fr = dcos(ur)

        ! The flux fedge at the cell interface is obtained by
        ! minimizing or maximizing the function cos(q) over the
        ! interval between the left and right states.

            if (ul < ur) then
            ! inimum
                fedge = dmin1(fl,fr)
                if (ur-ul > 2.d0*pi) then
                    fedge=-1.d0
                else
                    reml = dmod(ul,2.d0*pi)
                    remr = dmod(ur,2.d0*pi)
                    if (remr > 1.d0*pi .AND. reml < 1.d0*pi) then
                        fedge=-1.d0
                    elseif (ur-ul > remr+1.d0*pi) then
                        fedge=-1.d0
                    endif
                endif
            else
            ! aximum
                fedge = dmax1(fl,fr)
                if (ul-ur > 2.d0*pi) then
                    fedge=1.d0
                else
                    reml = dmod(ul,2.d0*pi)
                    remr = dmod(ur,2.d0*pi)
                    if (reml < remr) then
                        fedge=1.d0
                    endif
                endif
            endif
        endif


        if (ul /= ur) then
        ! ecant approximation
            s(1,i) = (fr-fl)/(ur-ul)
        else
            s(1,i) = 0.d0
        endif

        wave(1,1,i) = ur-ul

        amdq(1,i)= fedge - fl
        apdq(1,i)= fr - fedge

    enddo
         
    return
    end subroutine rpn2

!     =====================================================
    subroutine limiter(maxm,num_eqn,num_waves,num_ghost,mx,wave,s, &
    mthlim)
!     =====================================================

!     # Apply a limiter to the waves.
!     # The limiter is computed by comparing the 2-norm of each wave with
!     # the projection of the wave from the interface to the left or
!     # right onto the current wave.  For a linear system this would
!     # correspond to comparing the norms of the two waves.  For a
!     # nonlinear problem the eigenvectors are not colinear and so the
!     # projection is needed to provide more limiting in the case where the
!     # neighboring wave has large norm but points in a different direction
!     # in phase space.

!     # The specific limiter used in each family is determined by the
!     # value of the corresponding element of the array mthlim, as used in
!     # the function philim.
!     # Note that a different limiter may be used in each wave family.

!     # dotl and dotr denote the inner product of wave with the wave to
!     # the left or right.  The norm of the projections onto the wave are then
!     # given by dotl/wnorm2 and dotr/wnorm2, where wnorm2 is the 2-norm
!     # of wave.

    implicit double precision (a-h,o-z)
    dimension mthlim(num_waves)
    dimension wave(num_eqn, num_waves,1-num_ghost:maxm+num_ghost)
    dimension    s(num_waves,1-num_ghost:maxm+num_ghost)


    do 50 mw=1,num_waves
        if (mthlim(mw) == 0) go to 50
        dotr = 0.d0
        do 40 i = 0, mx+1
            wnorm2 = 0.d0
            dotl = dotr
            dotr = 0.d0
            do 20 m=1,num_eqn
                wnorm2 = wnorm2 + wave(m,mw,i)**2
                dotr = dotr + wave(m,mw,i)*wave(m,mw,i+1)
            20 END DO
            if (i == 0) go to 40
            if (wnorm2 == 0.d0) go to 40
        
            if (s(mw,i) > 0.d0) then
                wlimitr = philim(wnorm2, dotl, mthlim(mw))
            else
                wlimitr = philim(wnorm2, dotr, mthlim(mw))
            endif
        
            do 30 m=1,num_eqn
                wave(m,mw,i) = wlimitr * wave(m,mw,i)
            30 END DO
        40 END DO
    50 END DO

    return
    end subroutine limiter

c ------------------------------------------------------------------

        subroutine fixcapaq(val,aux,mitot,valc,auxc,mic,
     &                      nvar,naux,levc,setflags)

      use amr_module
      implicit double precision (a-h,o-z)

c
c :::::::::::::::::::::::  FIXCAPAQ ::::::::::::::::::::::::::::::
c  new fine grid solution q was linearly interpolated. but want
c  to conserve kappa*q, not q. calculate the discrepancy
c  in kappa*q using this q, and modify q to account for it.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      dimension   val(nvar,mitot), valc(nvar,mic)
      dimension   aux(naux,mitot), auxc(naux,mic)
      dimension   setflags(mitot)

      dcapamax = 0.d0
      lratiox  = intratx(levc)

      do 10 ic = 2, mic-1

       do 15 ivar = 1, nvar

       capaqfine = 0.d0

       do 20 ico = 1, lratiox
         ifine = (ic-2)*lratiox + nghost + ico
         capaqfine = capaqfine + aux(mcapa,ifine)*
     &                           val(ivar,ifine)
20     continue

       dcapaq = auxc(mcapa,ic)*valc(ivar,ic)-
     &          capaqfine/(lratiox)
       dcapamax = dmax1(dcapamax,dabs(dcapaq))
      
       do 30 ico = 1, lratiox
         ifine = (ic-2)*lratiox + nghost + ico

         if (setflags(ifine) .eq. NEEDS_TO_BE_SET) then
         ! was set by coarsegrid, need to check for adjustment
           val(ivar,ifine) = val(ivar,ifine) +
     &                             dcapaq/aux(mcapa,ifine)
         endif
30     continue

15     continue

10     continue

c      write(6,*)" max discrepancy ", dcapamax

       return
       end

! =====================================================
subroutine qcor(ixy,i,m,aux,q,maxm,num_eqn,num_ghost,qc)
! =====================================================

    ! Compute the correction term to add to the solution for maintaining
    ! the conservation on sphere.

    implicit double precision (a-h,o-z)

    dimension aux(16, 1-num_ghost:maxm+num_ghost)
    dimension q(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension qc(4)

    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom
    common /sw/  g


    if(ixy == 1) then
        in = 2
        dy = dycom
    else
        in = 8
        dy = dxcom
    endif

    ! left interface
    etxl = aux(in+3,i)
    etyl = aux(in+4,i)
    etzl = aux(in+5,i)
    gammal = dsqrt(etxl**2.d0 + etyl**2.d0 + etzl**2.d0) / dy
    enxl = aux(in,i) * gammal
    enyl = aux(in+1,i) * gammal
    enzl = aux(in+2,i) * gammal

    ! right interface
    etxr = aux(in+3,i+1)
    etyr = aux(in+4,i+1)
    etzr = aux(in+5,i+1)
    gammar = dsqrt(etxr**2.d0 + etyr**2.d0 + etzr**2.d0) / dy
    enxr = aux(in,i+1) * gammar
    enyr = aux(in+1,i+1) * gammar
    enzr = aux(in+2,i+1)  * gammar

    qc(1) = (enxr-enxl)*q(2,i) + (enyr-enyl)*q(3,i) +(enzr-enzl)*q(4,i)

    qc(2) = (enxr-enxl)*(q(2,i)**2.d0/q(1,i)+0.5d0*g*q(1,i)**2.d0) &
        +(enyr-enyl)*(q(2,i)*q(3,i)/q(1,i)) &
        +(enzr-enzl)*(q(2,i)*q(4,i)/q(1,i))
        
    qc(3) = (enxr-enxl)*(q(2,i)*q(3,i)/q(1,i)) &
        +(enyr-enyl)*(q(3,i)**2.d0/q(1,i)+0.5d0*g*q(1,i)**2.d0) &
        +(enzr-enzl)*(q(3,i)*q(4,i)/q(1,i))
       
    qc(4) = (enxr-enxl)*(q(2,i)*q(4,i)/q(1,i)) &
        +(enyr-enyl)*(q(3,i)*q(4,i)/q(1,i)) &
        +(enzr-enzl)*(q(4,i)**2.d0/q(1,i)+0.5d0*g*q(1,i)**2.d0)

    ! project qc to tangent plane:
    erx = aux(14,i)
    ery = aux(15,i)
    erz = aux(16,i)

    qcn = erx*qc(2) + ery*qc(3) + erz*qc(4)
          
    qc(2) = qc(2) - qcn*erx
    qc(3) = qc(3) - qcn*ery
    qc(4) = qc(4) - qcn*erz

    return
end subroutine qcor

c
c -------------------------------------------------------------
c
      subroutine stepgrid_dimSplit(q,fm,fp,gm,gp,mitot,mjtot,mbc,
     &                             dt,dtnew,dx,dy,
     &                             nvar,xlow,ylow,time,mptr,maux,aux)
c
c          
c ::::::::::::::::::: STEPGRID_DIMSPLIT ::::::::::::::::::::::::::::::::::::
c                 dimensionally split version of stepgrid
c    take a step in x, then y. for now only godunov splitting
c    not strang splitting. 
c
c take a time step on a single grid. overwrite solution array q. 
c A modified version of the clawpack routine step2 is used.
c
c return fluxes in fm,fp and gm,gp.
c patch has room for ghost cells (mbc of them) around the grid.
c everything is the enlarged size (mitot by mjtot).
c
c mbc       = number of ghost cells  (= lwidth)
c mptr      = grid number  (for debugging)
c xlow,ylow = lower left corner of enlarged grid (including ghost cells).
c dt         = incoming time step
c dx,dy      = mesh widths for this grid
c dtnew      = return suggested new time step for this grid's soln.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      use amr_module
      implicit double precision (a-h,o-z)
      external rpn2


      dimension q(nvar,mitot,mjtot)
      dimension fp(nvar,mitot,mjtot),gp(nvar,mitot,mjtot)
      dimension fm(nvar,mitot,mjtot),gm(nvar,mitot,mjtot)
      dimension aux(maux,mitot,mjtot)

      logical    debug,  dump
      data       debug/.false./,  dump/.false./

c
      if (dump) then
         write(outunit,*) "dumping grid ",mptr," at time ",time
         do i = 1, mitot
         do j = 1, mjtot
            write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar),
     .                  (aux(ivar,i,j),ivar=1,maux)
 545        format(2i4,4e15.7)
         end do
         end do
      endif
c
      meqn   = nvar
      mx = mitot - 2*mbc
      my = mjtot - 2*mbc
      maxm = max(mx,my)       !# size for 1d scratch array
      mbig = maxm
      xlowmbc = xlow + mbc*dx
      ylowmbc = ylow + mbc*dy

c
c    old work array code now removed.
c
c
      call b4step2(mbc,mx,my,nvar,q,
     &             xlowmbc,ylowmbc,dx,dy,time,dt,maux,aux)
c
c
c     # take one step on the conservation law:  Godunov splitting
c
c                                   1.  First step in x direction:

      call step2x(mbig,nvar,maux, mbc,mx,my,q,aux,dx,dt,cflgrid,
     &              fm,fp,rpn2)
c
!$OMP  CRITICAL (cflm)

        cfl_level = dmax1(cfl_level,cflgrid)

!$OMP END CRITICAL (cflm)

c       # update q with x fluxes first. all rows in y  get updated
        dtdx = dt/dx
        do j=1,mjtot
        do i=mbc+1,mitot-mbc
        do m=1,nvar
         if (mcapa.eq.0) then
c
c            # no capa array.  Standard flux differencing:

           q(m,i,j) = q(m,i,j)  - dtdx * (fm(m,i+1,j) - fp(m,i,j)) 

         else
c            # with capa array.
           q(m,i,j) = q(m,i,j) 
     &          - dtdx * (fm(m,i+1,j) - fp(m,i,j)) / aux(mcapa,i,j)
         endif

        end do
        end do
        end do

c                                 2.  Second step in x direction:

      call step2y(mbig,nvar,maux, mbc,mx,my,q,aux,dy,dt,cflgrid,
     &              gm,gp,rpn2)
c
!$OMP  CRITICAL (cflm)

        cfl_level = dmax1(cfl_level,cflgrid)

!$OMP END CRITICAL (cflm)
c
c       # update q
        dtdy = dt/dy
        do j=mbc+1,mjtot-mbc
        do i=mbc+1,mitot-mbc
        do m=1,nvar
         if (mcapa.eq.0) then
c
c            # no capa array.  Standard flux differencing:

           q(m,i,j) = q(m,i,j) - dtdy * (gm(m,i,j+1) - gp(m,i,j)) 
         else
c            # with capa array.
           q(m,i,j) = q(m,i,j) 
     &          - dtdy * (gm(m,i,j+1) - gp(m,i,j)) / aux(mcapa,i,j)
         endif

         end do
         end do
         end do
c
!--        write(outunit,1001) mptr, node(nestlevel,mptr),cflgrid
!-- 1001   format(' Courant # of grid', i4,
!--     &        ' on level', i3, ' is  ', e10.3)

c
      if (method(5).eq.1) then
c        # with source term:   use Godunov splitting for this too
         call src2(nvar,mbc,mx,my,xlowmbc,ylowmbc,dx,dy,
     &             q,maux,aux,time,dt)
         endif
c
c
c
c     # output fluxes for debugging purposes:
      if (debug) then
         write(dbugunit,*)" fluxes for grid ",mptr
c        do j = mbc+1, mjtot-1
            do i = mbc+1, mitot-1
         do j = mbc+1, mjtot-1
               write(dbugunit,831) i,j,fm(1,i,j),fp(1,i,j),
     .                             gm(1,i,j),gp(1,i,j)
               do m = 2, meqn
                  write(dbugunit,832) fm(m,i,j),fp(m,i,j),
     .            gm(m,i,j),gp(m,i,j)
  831          format(2i4,4d16.6)
  832          format(8x,4d16.6)
         end do
         end do
         end do
      endif

c
c
c For variable time stepping, use max speed seen on this grid to 
c choose the allowable new time step dtnew.  This will later be 
c compared to values seen on other grids.
c  NB: orig code tested cflgrid, but with dimensional splitting
c  there are 2 - one for each x and y steps, so changed 12/23/14 (mjb)
c  to use level
c
       if (cfl_level .gt. 0.d0) then
           dtnew = dt*cfl/cfl_level
         else
c          # velocities are all zero on this grid so there's no 
c          # time step restriction coming from this grid.
            dtnew = rinfinity
          endif

c     # give a warning if Courant number too large...
c
      if (cflgrid .gt. cflv1) then
            write(*,810) cflgrid
            write(outunit,810) cflgrid, cflv1
  810       format('*** WARNING *** Courant number  =', d12.4,
     &              '  is larger than input cfl_max = ', d12.4)
            endif
c
      if (dump) then
         write(outunit,*) "dumping grid ",mptr," after stepgrid"
         do i = 1, mitot
         do j = 1, mjtot
            write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar)
         end do
         end do
      endif
      return
      end

!> Output the results for a general system of conservation laws
!! in 2 dimensions
!!
!! Write the results to the file fort.q<iframe>
!! Use format required by matlab script  plotclaw2.m or Python tools
!!
!! set outaux = .true. to also output the aux arrays to fort.a<iframe>
subroutine valout(level_begin, level_end, time, num_eqn, num_aux)

    use amr_module, only: alloc, t0, output_aux_onlyonce, output_aux_components
    use amr_module, only: frame => matlabu, num_ghost => nghost, lstart
    use amr_module, only: hxposs, output_format, store1, storeaux
    use amr_module, only: node, rnode, ndilo, ndihi, cornxlo, mxnest, levelptr
    use amr_module, only: timeValout, timeValoutCPU, tvoll, tvollCPU, rvoll
    use amr_module, only: timeTick, tick_clock_start, t0

#ifdef HDF5
    use hdf5
#endif

    implicit none

    ! Input
    integer, intent(in) :: level_begin, level_end, num_eqn, num_aux
    real(kind=8), intent(in) :: time

    ! Locals
    logical :: timing_file_exists
    integer, parameter :: out_unit = 50
    integer :: i, j, m, level, output_aux_num, num_stop, digit
    integer :: grid_ptr, num_cells, num_grids, q_loc, aux_loc
    real(kind=8) :: lower_corner, delta
    logical :: out_aux
    character(len=10) :: file_name(5)
    character(len=8) :: file_format
    real(kind=4), allocatable :: q4(:), aux4(:)
    integer :: lenaux4

    ! Timing
    integer :: clock_start, clock_finish, clock_rate
    integer    tick_clock_finish, tick_clock_rate, timeTick_int
    real(kind=8) :: cpu_start, cpu_finish, t_CPU_overall, timeTick_overall
    character(len=512) :: timing_line, timing_substr
    character(len=*), parameter :: timing_file_name = "timing.csv"

    character(len=*), parameter :: header_format =                             &
                                    "(i6,'                 grid_number',/," // &
                                     "i6,'                 AMR_level',/,"   // &
                                     "i6,'                 mx',/,"          // &
                                     "e26.16,'    xlow', /, "               // &
                                     "e26.16,'    dx', /)"
    character(len=*), parameter :: t_file_format = "(e18.8,'    time', /,"  // &
                                           "i6,'                 meqn'/,"   // &
                                           "i6,'                 ngrids'/," // &
                                           "i6,'                 naux'/,"   // &
                                           "i6,'                 ndim'/,"   // &
                                           "i6,'                 nghost'/," // &
                                           "a10,'             format'/,/)"
                                           
    character(len=*), parameter :: timing_header_format =                      &
                                                  "(' wall time (', i2,')," // &
                                                  " CPU time (', i2,'), "   // &
                                                  "cells updated (', i2,'),')"
    character(len=*), parameter :: console_format = &
             "('AMRCLAW: Frame ',i4,' output files done at time t = ', d13.6,/)"

    ! Output timing
    call system_clock(clock_start,clock_rate)
    call cpu_time(cpu_start)

    ! Count how many aux components requested
    output_aux_num = 0
    do i=1, num_aux
        output_aux_num = output_aux_num + output_aux_components(i)
    end do

    ! Note:  Currently outputs all aux components if any are requested
    out_aux = ((output_aux_num > 0) .and.               &
              ((.not. output_aux_onlyonce) .or. (abs(time - t0) < 1d-90)))
                
    ! Construct file names
    file_name(1) = 'fort.qxxxx'
    file_name(2) = 'fort.txxxx'
    file_name(3) = 'fort.axxxx'
    file_name(4) = 'fort.bxxxx'
    num_stop = frame
    do i = 10, 7, -1
        digit = mod(num_stop, 10)
        do j = 1, 4
            file_name(j)(i:i) = char(ichar('0') + digit)
        end do
        num_stop = num_stop / 10
    end do

    ! ==========================================================================
    ! Write out fort.q file (and fort.bXXXX or fort.bXXXX.nc files if necessary)
    ! Here we let fort.q be out_unit and the the other two be out_unit + 1
    open(unit=out_unit, file=file_name(1), status='unknown', form='formatted')
    if (output_format == 2 .or. output_format == 3) then
        open(unit=out_unit + 1, file=file_name(4), status="unknown",    &
             access='stream')
    else if (output_format == 4) then
        stop
        ! open(unit=out_unit + 1, file=file_name(4) // ".nc", status="unknown",  &
        !      access='stream')
    end if
    num_grids = 0

    ! Loop over levels
    do level = level_begin, level_end
        grid_ptr = lstart(level)
        delta = hxposs(level)

        ! Loop over grids on each level
        do while (grid_ptr /= 0)
            ! Extract grid data
            num_grids = num_grids + 1
            num_cells = node(ndihi, grid_ptr) - node(ndilo, grid_ptr) + 1
            q_loc = node(store1, grid_ptr)
            lower_corner = rnode(cornxlo, grid_ptr)

            ! Write out header data                 
            write(out_unit, header_format) grid_ptr, level, num_cells,         &
                                           lower_corner, delta
            ! Output grids

            
            ! Round off if nearly zero 
            ! (Do this for all output_format's)
            forall (m = 1:num_eqn,                              &
                    i=num_ghost + 1:num_cells + num_ghost,   &
                    abs(alloc(iadd(m, i))) < 1d-90)

                alloc(iadd(m, i)) = 0.d0
            end forall

            if (output_format == 1) then
                    ! ascii output

                    do i = num_ghost + 1, num_cells + num_ghost
                        write(out_unit, "(50e26.16)")                      &
                                            (alloc(iadd(m, i)), m=1, num_eqn)
                    end do
                    write(out_unit, *) ' '

            else if (output_format==2 .or. output_format==3) then
                ! binary32 or binary64
                                
                ! Note: We are writing out ghost cell data also
                ! do we need to call bound to update ghost cells??

                i = iadd(num_eqn, num_cells + 2 * num_ghost)

                if (output_format == 2) then
                    ! binary32 (shorten to 4-byte)
                    allocate(q4(num_eqn * (num_cells + 2 * num_ghost)))
                    q4 = real(alloc(iadd(1, 1):i), kind=4)
                    write(out_unit + 1) q4
                    deallocate(q4)

                else if (output_format==3) then
                    ! binary64 (full 8-byte)
                    write(out_unit + 1) alloc(iadd(1, 1):i)
                endif
                
                
            else if (output_format == 4) then
#ifdef HDF5
                ! HDF5 output
                stop "HDF5 output not yet implemented!"
#else
                print *, "ERROR:  HDF5 library is not available."
                print *, "  Check the documentation as to how to include"
                print *, "  the ability to output in HDF5 formats."
                stop
#endif
            else
                print *, "Unsupported output format", output_format,"."
                stop 
            endif

            grid_ptr = node(levelptr, grid_ptr)
        end do
    end do

    close(out_unit)
    if (output_format==2 .or. output_format==3) then
        close(unit=out_unit + 1)
    end if


    ! ==========================================================================
    ! Write out fort.a file
    if (out_aux) then
        if (output_format == 1) then
            open(unit=out_unit, file=file_name(3), status='unknown',        &
                 form='formatted')
        else if (output_format==2 .or. output_format==3) then
            open(unit=out_unit, file=file_name(3), status='unknown',        &
                 access='stream')
        else if (output_format == 4) then
            stop
            ! open(unit=out_unit, file=file_name(3) // ".nc", status='unknown',  &
            !      access='stream')
        end if

        do level = level_begin, level_end
            grid_ptr = lstart(level)
            delta = hxposs(level)

            ! Loop over grids on each level
            do while (grid_ptr /= 0)
                ! Extract grid data
                num_cells = node(ndihi, grid_ptr) - node(ndilo, grid_ptr) + 1
                aux_loc = node(storeaux, grid_ptr)
                lower_corner = rnode(cornxlo, grid_ptr)

                ! Output grids
                select case(output_format)
                    ! ASCII output
                    case(1)

                        ! We only output header info for aux data if writing 
                        ! ASCII data
                        write(out_unit, header_format) grid_ptr, level,     &
                                                       num_cells,           &
                                                       lower_corner,        &
                                                       delta

                        ! Round off if nearly zero
                        forall (m = 1:num_aux,                              &
                                i=num_ghost + 1:num_cells + num_ghost,      &
                                abs(alloc(iaddaux(m, i))) < 1d-90)

                            alloc(iaddaux(m, i)) = 0.d0
                        end forall

                        do i = num_ghost + 1, num_cells + num_ghost
                            write(out_unit, "(50e26.16)")                   &
                                         (alloc(iaddaux(m, i)), m=1, num_aux)
                        end do
                        write(out_unit, *) ' '

                    case(2)
                        ! binary32
                        ! Note: We are writing out ghost cell data also
                        i = iaddaux(num_aux, num_cells + 2 * num_ghost)
                        lenaux4 = i - iaddaux(1, 1) + 1
                        allocate(aux4(lenaux4))
                        aux4 = real(alloc(iaddaux(1, 1):i), kind=4)
                        write(out_unit) aux4
                        deallocate(aux4)
                        
                    case(3)
                        ! binary64
                        ! Note: We are writing out ghost cell data also
                        i = iaddaux(num_aux, num_cells + 2 * num_ghost)
                        write(out_unit) alloc(iaddaux(1, 1):i)

                    ! NetCDF output
                    case(4)
#ifdef NETCDF
                        stop "NetCDF output not yet implemented!"
#else
                        print *, "ERROR:  NetCDF library is not available."
                        print *, "  Check the documentation as to how to include"
                        print *, "  the ability to output in NetCDF formats."
                        stop
#endif
                    case default
                        print *, "Unsupported output format", output_format,"."
                        stop 

                end select
                grid_ptr = node(levelptr, grid_ptr)
            end do
        end do
            
        if ((output_format == 1) .or. (output_format == 2) .or. &
            (output_format == 3)) then
            close(out_unit)
        end if
        
    end if

    ! ==========================================================================
    ! Write fort.t file
    open(unit=out_unit, file=file_name(2), status='unknown', form='formatted')

    ! Note:  We need to print out num_ghost too in order to strip ghost cells
    !        from q array when reading in pyclaw.io.binary
    
   
    if (output_format == 1) then
        file_format = 'ascii'
    else if (output_format == 2) then
        file_format = 'binary32'
    else if (output_format == 3) then
        file_format = 'binary64'
    else if (output_format == 4) then
        file_format = 'hdf'
    endif
    
    write(out_unit, t_file_format) time, num_eqn, num_grids, num_aux, 1,    &
                                   num_ghost, file_format
    close(out_unit)

    ! ==========================================================================
    ! Write out timing stats
    ! Assume that this has been started some where
    open(unit=out_unit, file=timing_file_name, form='formatted',         &
         status='old', action='write', position='append')
    
    timing_line = "(e16.6, ', ', e16.6, ', ', e16.6,"
    do level=1, mxnest
        timing_substr = "', ', e16.6, ', ', e16.6, ', ', e16.6"
        timing_line = trim(timing_line) // timing_substr
    end do
    timing_line = trim(timing_line) // ")"

    if (abs(time - t0) < 1d-15) then
        t_CPU_overall = 0.d0
        timeTick_overall = 0.d0
      else
        call cpu_time(t_CPU_overall)
        call system_clock(tick_clock_finish,tick_clock_rate)
        ! not including timeTick since not yet set up for restarting
        timeTick_int = tick_clock_finish - tick_clock_start
        timeTick_overall = real(timeTick_int, kind=8)/real(tick_clock_rate,kind=8)
      endif

    write(out_unit, timing_line) time, timeTick_overall, t_CPU_overall, &
        (real(tvoll(i), kind=8) / real(clock_rate, kind=8), &
         tvollCPU(i), rvoll(i), i=1,mxnest)
    
    close(out_unit)

    ! ==========================================================================
    ! Print output info
    print console_format, frame, time

    ! Increment frame counter
    frame = frame + 1

    ! Ouptut timing
    call system_clock(clock_finish,clock_rate)
    call cpu_time(cpu_finish)
    timeValout = timeValout + clock_finish - clock_start
    timeValoutCPU = timeValoutCPU + cpu_finish - cpu_start

contains

    ! Index into q array
    pure integer function iadd(m, i)
        implicit none
        integer, intent(in) :: m, i
        iadd = q_loc + m - 1 + num_eqn * (i - 1)
    end function iadd

    ! Index into aux array
    pure integer function iaddaux(m, i)
        implicit none
        integer, intent(in) :: m, i
        iaddaux = aux_loc + m - 1 + num_aux * (i - 1)
    end function iaddaux

end subroutine valout

module reconstruct
! ===================================================================
! This module contains the spatial reconstruction routines that are
! the heart of the SharpClaw solvers 
! ===================================================================

    double precision, allocatable  :: dq1m(:)
    double precision, allocatable, private :: uu(:,:),dq(:,:)
    double precision, allocatable, private :: uh(:,:,:),gg(:,:),hh(:,:),u(:,:,:)
    double precision, allocatable, private :: evl(:,:,:),evr(:,:,:)
    double precision, private  :: epweno = 1.e-36
    logical :: recon_alloc = .False.

! ===================================================================
! Array allocation
contains

    subroutine alloc_recon_workspace(maxnx,num_ghost,num_eqn,num_waves,lim_type,char_decomp)
        integer,intent(in) :: maxnx,num_ghost,num_eqn,num_waves,char_decomp,lim_type

        select case(lim_type)
            case(1)
            select case(char_decomp)
                case(1) ! Storage for tvd2_wave()
                    allocate(uu(num_waves,1-num_ghost:maxnx+num_ghost))
                case(2) ! Storage for tvd2_char()
                    ! Do the array bounds here cause a bug?
                    allocate(dq(num_eqn,1-num_ghost:maxnx+num_ghost))
                    allocate( u(num_eqn,2,1-num_ghost:maxnx+num_ghost))
                    allocate(hh(-1:1,1-num_ghost:maxnx+num_ghost))
            end select
            case(2)
            select case(char_decomp)
                case(0)
                    allocate(uu(2,maxnx+2*num_ghost))
                    allocate( dq1m(maxnx+2*num_ghost))
                case(2) ! Storage for weno5_char
                    allocate(dq(num_eqn,maxnx+2*num_ghost))
                    allocate(uu(2,maxnx+2*num_ghost))
                    allocate(hh(-2:2,maxnx+2*num_ghost))
                case(3) ! Storage for weno5_trans
                    allocate(dq(num_eqn,maxnx+2*num_ghost))
                    allocate(gg(num_eqn,maxnx+2*num_ghost))
                    allocate( u(num_eqn,2,maxnx+2*num_ghost))
                    allocate(hh(-2:2,maxnx+2*num_ghost))
                    allocate(uh(num_eqn,2,maxnx+2*num_ghost))
            end select
            case(3)
                allocate(uu(2,maxnx+2*num_ghost))
                allocate( dq1m(maxnx+2*num_ghost))
        end select
        recon_alloc = .True.

    end subroutine alloc_recon_workspace


    subroutine dealloc_recon_workspace(lim_type,char_decomp)
        integer,intent(in) :: lim_type,char_decomp

        select case(lim_type)
            case(1)
            select case(char_decomp)
                case(1) ! Storage for tvd2_wave()
                    deallocate(uu)
                case(2) ! Storage for tvd2_char()
                    deallocate(dq)
                    deallocate( u)
                    deallocate(hh)
            end select
            case(2)
             select case(char_decomp)
                case(0)
                    deallocate(uu)
                    deallocate(dq1m)
                case(2) ! Storage for weno5_char
                    deallocate(dq)
                    deallocate(uu)
                    deallocate(hh)
                case(3) ! Storage for weno5_trans
                    deallocate(dq)
                    deallocate(gg)
                    deallocate( u)
                    deallocate(hh)
                    deallocate(uh)
            end select
            recon_alloc = .False.
        end select
    end subroutine dealloc_recon_workspace

! ===================================================================
! Reconstruction routines

    ! ===================================================================
    subroutine weno_comp(q,ql,qr,num_eqn,maxnx,num_ghost)
    ! ===================================================================
    !   This is the main routine, which uses PyWENO-generated code
    !   It does no characteristic decomposition

        use weno
        use clawparams, only: weno_order
        implicit none

        integer,          intent(in) :: num_eqn, maxnx, num_ghost
        double precision, intent(in) :: q(num_eqn,maxnx+2*num_ghost)
        double precision, intent(out) :: ql(num_eqn,maxnx+2*num_ghost),qr(num_eqn,maxnx+2*num_ghost)

        select case(weno_order)
        case (5)
           call weno5(q,ql,qr,num_eqn,maxnx,num_ghost)
        case (7)
           call weno7(q,ql,qr,num_eqn,maxnx,num_ghost)           
        case (9)
           call weno9(q,ql,qr,num_eqn,maxnx,num_ghost)           
        case (11)
           call weno11(q,ql,qr,num_eqn,maxnx,num_ghost)           
        case (13)
           call weno13(q,ql,qr,num_eqn,maxnx,num_ghost)           
        case (15)
           call weno15(q,ql,qr,num_eqn,maxnx,num_ghost)           
        case (17)
           call weno17(q,ql,qr,num_eqn,maxnx,num_ghost)           
        case default
           print *, 'ERROR: weno_order must be an odd number between 5 and 17 (inclusive).'
           stop
        end select

    end subroutine weno_comp


    ! ===================================================================
    subroutine weno5(q,ql,qr,num_eqn,maxnx,num_ghost)
    ! ===================================================================
    !   This is an old routine based on Chi-Wang Shu's code

        implicit double precision (a-h,o-z)

        double precision, intent(in) :: q(num_eqn,maxnx+2*num_ghost)
        double precision, intent(out) :: ql(num_eqn,maxnx+2*num_ghost),qr(num_eqn,maxnx+2*num_ghost)

        integer :: num_eqn, mx2

        mx2  = size(q,2); num_eqn = size(q,1)

        !loop over all equations (all components).  
        !the reconstruction is performed component-wise;
        !no characteristic decomposition is used here

        do m=1,num_eqn

            forall (i=2:mx2)
                ! compute and store the differences of the cell averages
                dq1m(i)=q(m,i)-q(m,i-1)
            end forall

            ! the reconstruction

            do m1=1,2

                ! m1=1: construct ql
                ! m1=2: construct qr

                im=(-1)**(m1+1)
                ione=im; inone=-im; intwo=-2*im
  
                do i=num_ghost,mx2-num_ghost+1
  
                    t1=im*(dq1m(i+intwo)-dq1m(i+inone))
                    t2=im*(dq1m(i+inone)-dq1m(i      ))
                    t3=im*(dq1m(i      )-dq1m(i+ione ))
  
                    tt1=13.*t1**2+3.*(   dq1m(i+intwo)-3.*dq1m(i+inone))**2
                    tt2=13.*t2**2+3.*(   dq1m(i+inone)+   dq1m(i      ))**2
                    tt3=13.*t3**2+3.*(3.*dq1m(i      )-   dq1m(i+ione ))**2
       
                    tt1=(epweno+tt1)**2
                    tt2=(epweno+tt2)**2
                    tt3=(epweno+tt3)**2
                    s1 =tt2*tt3
                    s2 =6.*tt1*tt3
                    s3 =3.*tt1*tt2
                    t0 =1./(s1+s2+s3)
                    s1 =s1*t0
                    s3 =s3*t0
  
                    uu(m1,i) = (s1*(t2-t1)+(0.5*s3-0.25)*(t3-t2))/3. &
                             +(-q(m,i-2)+7.*(q(m,i-1)+q(m,i))-q(m,i+1))/12.

                end do
            end do

           qr(m,num_ghost-1:mx2-num_ghost  )=uu(1,num_ghost:mx2-num_ghost+1)
           ql(m,num_ghost  :mx2-num_ghost+1)=uu(2,num_ghost:mx2-num_ghost+1)

        end do

      return
      end subroutine weno5


    ! ===================================================================
    subroutine weno5_char(q,ql,qr,maxnx,num_eqn,num_ghost,evl,evr)
    ! ===================================================================
    !   This is an old routine based on Chi-Wang Shu's code

        ! This one uses characteristic decomposition
        !  evl, evr are left and right eigenvectors at each interface

        implicit double precision (a-h,o-z)

        integer,          intent(in) :: maxnx, num_eqn, num_ghost
        double precision, intent(in) :: q(num_eqn,maxnx+2*num_ghost)
        double precision, intent(out) :: ql(num_eqn,maxnx+2*num_ghost)
        double precision, intent(out) :: qr(num_eqn,maxnx+2*num_ghost)
        double precision, intent(in) :: evl(num_eqn,num_eqn,maxnx+2*num_ghost)
        double precision, intent(in) :: evr(num_eqn,num_eqn,maxnx+2*num_ghost)

        integer :: mx2

        mx2  = size(q,2)

        ! loop over all equations (all components).  
        ! the reconstruction is performed using characteristic decomposition

        forall(m=1:num_eqn,i=2:mx2)
            ! compute and store the differences of the cell averages
            dq(m,i)=q(m,i)-q(m,i-1)
        end forall

        forall(m=1:num_eqn,i=num_ghost:mx2-num_ghost+1)
            ! Compute the part of the reconstruction that is
            ! stencil-independent
            qr(m,i-1) = (-q(m,i-2)+7.*(q(m,i-1)+q(m,i))-q(m,i+1))/12.
            ql(m,i)   = qr(m,i-1)
        end forall

        do ip=1,num_eqn

            ! Project the difference of the cell averages to the
            ! 'm'th characteristic field

        
            do m2 = -2,2
               do  i = num_ghost+1,mx2-2
                  hh(m2,i) = 0.d0
                  do m=1,num_eqn 
                    hh(m2,i) = hh(m2,i) + evl(ip,m,i)*dq(m,i+m2)
                  enddo
               enddo
            enddo


            ! the reconstruction

            do m1=1,2

                ! m1=1: construct ql
                ! m1=2: construct qr

                im=(-1)**(m1+1)
                ione=im
                inone=-im
                intwo=-2*im
  
                do i=num_ghost,mx2-num_ghost+1
      
                    t1=im*(hh(intwo,i)-hh(inone,i))
                    t2=im*(hh(inone,i)-hh(0,i    ))
                    t3=im*(hh(0,i    )-hh(ione,i ))
      
                    tt1=13.*t1**2+3.*(   hh(intwo,i)-3.*hh(inone,i))**2
                    tt2=13.*t2**2+3.*(   hh(inone,i)+   hh(0,i    ))**2
                    tt3=13.*t3**2+3.*(3.*hh(0,i    )-   hh(ione,i ))**2

                    tt1=(epweno+tt1)**2
                    tt2=(epweno+tt2)**2
                    tt3=(epweno+tt3)**2
                    s1 =tt2*tt3
                    s2 =6.*tt1*tt3
                    s3 =3.*tt1*tt2
                    t0 =1./(s1+s2+s3)
                    s1 =s1*t0
                    s3 =s3*t0
      
                    uu(m1,i) = ( s1*(t2-t1) + (0.5*s3-0.25)*(t3-t2) )/3.

                end do !end loop over interfaces
            end do !end loop over which side of interface

                ! Project to the physical space:
            do m = 1,num_eqn
                do i=num_ghost,mx2-num_ghost+1
                    qr(m,i-1) = qr(m,i-1) + evr(m,ip,i)*uu(1,i)
                    ql(m,i  ) = ql(m,i  ) + evr(m,ip,i)*uu(2,i)
                enddo
            enddo
        enddo !end loop over waves

      return
      end subroutine weno5_char

    ! ===================================================================
    subroutine weno5_trans(q,ql,qr,evl,evr)
    ! ===================================================================
    !   This is an old routine based on Chi-Wang Shu's code

        ! Transmission-based WENO reconstruction

        implicit double precision (a-h,o-z)

        double precision, intent(in) :: q(:,:)
        double precision, intent(out) :: ql(:,:),qr(:,:)
        double precision, intent(in) :: evl(:,:,:),evr(:,:,:)

        integer, parameter :: num_ghost=3
        integer :: num_eqn, mx2

        mx2  = size(q,2); num_eqn = size(q,1)


        ! the reconstruction is performed using characteristic decomposition

        do m=1,num_eqn
            ! compute and store the differences of the cell averages
            forall (i=2:mx2)
                dq(m,i)=q(m,i)-q(m,i-1)
            end forall
        enddo

        ! Find wave strengths at each interface
        ! 'm'th characteristic field
        do mw=1,num_eqn
            do i = 2,mx2
                gg(mw,i) = 0.d0
                do m=1,num_eqn
                    gg(mw,i) = gg(mw,i) + evl(mw,m,i)*dq(m,i)
                enddo
            enddo
        enddo

        do mw=1,num_eqn
            ! Project the waves to the
            ! 'm'th characteristic field

            do m1 = -2,2
                do  i = num_ghost+1,mx2-2
                    hh(m1,i) = 0.d0
                    do m=1,num_eqn 
                        hh(m1,i) = hh(m1,i)+evl(mw,m,i)* &
                                    gg(mw,i+m1)*evr(mw,m,i+m1)
                    enddo
                enddo
            enddo

            ! the reconstruction

            do m1=1,2
                ! m1=1: construct ql
                ! m1=2: construct qr
                im=(-1)**(m1+1)
                ione=im; inone=-im; intwo=-2*im
  
                do i=num_ghost,mx2-num_ghost+1
  
                    t1=im*(hh(intwo,i)-hh(inone,i))
                    t2=im*(hh(inone,i)-hh(0,i    ))
                    t3=im*(hh(0,i    )-hh(ione,i ))
  
                    tt1=13.*t1**2+3.*(   hh(intwo,i)-3.*hh(inone,i))**2
                    tt2=13.*t2**2+3.*(   hh(inone,i)+   hh(0,i    ))**2
                    tt3=13.*t3**2+3.*(3.*hh(0,i    )-   hh(ione,i ))**2
       
                    tt1=(epweno+tt1)**2
                    tt2=(epweno+tt2)**2
                    tt3=(epweno+tt3)**2
                    s1 =tt2*tt3
                    s2 =6.*tt1*tt3
                    s3 =3.*tt1*tt2
                    t0 =1./(s1+s2+s3)
                    s1 =s1*t0
                    s3 =s3*t0
  
                    u(mw,m1,i) = ( s1*(t2-t1) + (0.5*s3-0.25)*(t3-t2) ) /3.

                enddo
            enddo
        enddo

        ! Project to the physical space:

        do m1 =  1,2
            do m =  1, num_eqn
                do i = num_ghost,mx2-num_ghost+1
                    uh(m,m1,i) =( -q(m,i-2) + 7*( q(m,i-1)+q(m,i) ) &
                                         - q(m,i+1) )/12.
                    do mw=1,num_eqn 
                        uh(m,m1,i) = uh(m,m1,i) + evr(m,mw,i)*u(mw,m1,i)
                    enddo
                enddo
            enddo
        enddo

        qr(1:num_eqn,num_ghost-1:mx2-num_ghost) = uh(1:num_eqn,1,num_ghost:mx2-num_ghost+1)
        ql(1:num_eqn,num_ghost:mx2-num_ghost+1) = uh(1:num_eqn,2,num_ghost:mx2-num_ghost+1)

        return
    end subroutine weno5_trans

    ! ===================================================================
    subroutine weno5_wave(q,ql,qr,wave)
    ! ===================================================================
    !   This is an old routine based on Chi-Wang Shu's code

        !  Fifth order WENO reconstruction, based on waves
        !  which are later interpreted as slopes.

        implicit double precision (a-h,o-z)

        double precision, intent(in) :: q(:,:)
        double precision, intent(out) :: ql(:,:),qr(:,:)
        double precision, intent(in) :: wave(:,:,:)
        double precision u(2)

        integer, parameter :: num_ghost=3
        integer :: num_eqn, mx2

        mx2  = size(q,2); num_eqn = size(q,1); num_waves=size(wave,2)

        ! loop over interfaces (i-1/2)
        do i=2,mx2
            ! Compute the part of the reconstruction that is stencil-independent
            do m=1,num_eqn
                qr(m,i-1) = (-q(m,i-2)+7.*(q(m,i-1)+q(m,i))-q(m,i+1))/12.
                ql(m,i)   = qr(m,i-1)
            enddo
            ! the reconstruction is performed in terms of waves
            do mw=1,num_waves
                ! loop over which side of x_i-1/2 we're on
                do m1=1,2
                    ! m1=1: construct q^-_{i-1/2}
                    ! m1=2: construct q^+_{i-1/2}
                    im=(-1)**(m1+1)
                    ione=im; inone=-im; intwo=-2*im
  
                    wnorm2 = wave(1,mw,i      )*wave(1,mw,i)
                    theta1 = wave(1,mw,i+intwo)*wave(1,mw,i)
                    theta2 = wave(1,mw,i+inone)*wave(1,mw,i)
                    theta3 = wave(1,mw,i+ione )*wave(1,mw,i)
                    do m=2,num_eqn
                        wnorm2 = wnorm2 + wave(m,mw,i      )*wave(m,mw,i)
                        theta1 = theta1 + wave(m,mw,i+intwo)*wave(m,mw,i)
                        theta2 = theta2 + wave(m,mw,i+inone)*wave(m,mw,i)
                        theta3 = theta3 + wave(m,mw,i+ione )*wave(m,mw,i)
                    enddo

                    t1=im*(theta1-theta2)
                    t2=im*(theta2-wnorm2)
                    t3=im*(wnorm2-theta3)
  
                    tt1=13.*t1**2+3.*(theta1   -3.*theta2)**2
                    tt2=13.*t2**2+3.*(theta2   +   wnorm2)**2
                    tt3=13.*t3**2+3.*(3.*wnorm2-   theta3)**2
       
                    tt1=(epweno+tt1)**2
                    tt2=(epweno+tt2)**2
                    tt3=(epweno+tt3)**2
                    s1 =tt2*tt3
                    s2 =6.*tt1*tt3
                    s3 =3.*tt1*tt2
                    t0 =1./(s1+s2+s3)
                    s1 =s1*t0
                    s3 =s3*t0
  
                    if(wnorm2.gt.1.e-14) then
                        u(m1) = ( s1*(t2-t1) + (0.5*s3-0.25)*(t3-t2) ) /3.
                        wnorm2=1.d0/wnorm2
                    else
                        u(m1) = 0.d0
                        wnorm2=0.d0
                    endif
                enddo !end loop over which side of interface
                do m=1,num_eqn
                    qr(m,i-1) = qr(m,i-1) +  u(1)*wave(m,mw,i)*wnorm2
                    ql(m,i  ) = ql(m,i  ) +  u(2)*wave(m,mw,i)*wnorm2
                enddo
            enddo !loop over waves
        enddo !loop over interfaces

    end subroutine weno5_wave

    ! ===================================================================
    subroutine weno5_fwave(q,ql,qr,fwave,s)
    ! ===================================================================
    !
    !  Fifth order WENO reconstruction, based on f-waves
    !  that are interpreted as slopes.
!

      implicit double precision (a-h,o-z)

      double precision, intent(in) :: q(:,:)
      double precision, intent(inout) :: fwave(:,:,:), s(:,:)
      double precision, intent(out) :: ql(:,:), qr(:,:)
      double precision  u(20,2)

      integer, parameter :: num_ghost=3
      integer :: num_eqn, mx2

      mx2= size(q,2); num_eqn = size(q,1); num_waves=size(fwave,2)

      ! convert fwaves to waves by dividing by the sound speed
      ! We do this in place to save memory
      ! and get away with it because the waves are never used again
      forall(i=1:mx2,mw=1:num_waves,m=1:num_eqn)
          fwave(m,mw,i)=fwave(m,mw,i)/s(mw,i)
      end forall

      ! loop over interfaces (i-1/2)
      do i=2,mx2+2
        ! Compute the part of the reconstruction that is
        !  stencil-independent
        do m=1,num_eqn
          qr(m,i-1) = q(m,i-1)
          ql(m,i  ) = q(m,i)
        enddo
        ! the reconstruction is performed in terms of waves
        do mw=1,num_waves
         ! loop over which side of x_i-1/2 we're on
          do m1=1,2
            ! m1=1: construct q^-_{i-1/2}
            ! m1=2: construct q^+_{i-1/2}

            im=(-1)**(m1+1)
            ione=im; inone=-im; intwo=-2*im
  
            ! compute projections of waves in each family
            ! onto the corresponding wave at the current interface
            wnorm2 = fwave(1,mw,i      )*fwave(1,mw,i)
            theta1 = fwave(1,mw,i+intwo)*fwave(1,mw,i)
            theta2 = fwave(1,mw,i+inone)*fwave(1,mw,i)
            theta3 = fwave(1,mw,i+ione )*fwave(1,mw,i)
            do m=2,num_eqn
              wnorm2 = wnorm2 + fwave(m,mw,i      )*fwave(m,mw,i)
              theta1 = theta1 + fwave(m,mw,i+intwo)*fwave(m,mw,i)
              theta2 = theta2 + fwave(m,mw,i+inone)*fwave(m,mw,i)
              theta3 = theta3 + fwave(m,mw,i+ione )*fwave(m,mw,i)
            enddo
!
             t1=im*(theta1-theta2)
             t2=im*(theta2-wnorm2)
             t3=im*(wnorm2-theta3)
  
             tt1=13.*t1**2+3.*(theta1   -3.*theta2)**2
             tt2=13.*t2**2+3.*(theta2   +   wnorm2)**2
             tt3=13.*t3**2+3.*(3.*wnorm2-   theta3)**2
       
             tt1=(epweno+tt1)**2
             tt2=(epweno+tt2)**2
             tt3=(epweno+tt3)**2
             s1 =tt2*tt3
             s2 =6.*tt1*tt3
             s3 =3.*tt1*tt2
             t0 =1./(s1+s2+s3)
             s1 =s1*t0
             s3 =s3*t0
  
           if(wnorm2.gt.1.e-14) then
             u(mw,m1) = ( (s1*(t2-t1)+(0.5*s3-0.25)*(t3-t2))/3. &
                       + im*(theta2+6.d0*wnorm2-theta3)/12.d0)
             wnorm2=1.d0/wnorm2
           else
             u(mw,m1) = 0.d0
             wnorm2=0.d0
           endif
          enddo !end loop over which side of interface
          do m=1,num_eqn
            qr(m,i-1) = qr(m,i-1) +  u(mw,1)*fwave(m,mw,i)*wnorm2
            ql(m,i  ) = ql(m,i  ) +  u(mw,2)*fwave(m,mw,i)*wnorm2
          enddo
        enddo !loop over fwaves
      enddo !loop over interfaces

    end subroutine weno5_fwave

    ! ===================================================================
    subroutine tvd2(q,ql,qr,mthlim,num_eqn)
    ! ===================================================================
    ! Second order TVD reconstruction

        implicit double precision (a-h,o-z)

        integer,          intent(in) :: num_eqn 
        double precision, intent(in) :: q(:,:)
        integer, intent(in) :: mthlim(:)
        double precision, intent(out) :: ql(:,:),qr(:,:)
        integer :: mx2

        mx2  = size(q,2)

        ! loop over all equations (all components).  
        ! the reconstruction is performed component-wise

        do m=1,num_eqn

            ! compute and store the differences of the cell averages

            do i=1,mx2-1
                dqm=dqp
                dqp=q(m,i+1)-q(m,i)
                r=dqp/dqm

                select case(mthlim(m))
                case(1)
                    ! minmod
                    qlimitr = dmax1(0.d0, dmin1(1.d0, r))
                case(2)
                    ! superbee
                    qlimitr = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))
                case(3)
                    ! van Leer
                    qlimitr = (r + dabs(r)) / (1.d0 + dabs(r))
                case(4)
                    ! monotonized centered
                    c = (1.d0 + r)/2.d0
                    qlimitr = dmax1(0.d0, dmin1(c, 2.d0, 2.d0*r))
                case(5)
                    ! Cada & Torrilhon simple
                    beta=2.d0
                    xgamma=2.d0
                    alpha=1.d0/3.d0
                    pp=(2.d0+r)/3.d0
                    amax = dmax1(-alpha*r,0.d0,dmin1(beta*r,pp,xgamma))
                    qlimitr = dmax1(0.d0, dmin1(pp,amax))
                end select

           qr(m,i) = q(m,i) + 0.5d0*qlimitr*dqm
           ql(m,i) = q(m,i) - 0.5d0*qlimitr*dqm

         enddo
      enddo

      return
      end subroutine tvd2


    ! ===================================================================
    subroutine tvd2_char(q,ql,qr,mthlim,num_eqn,num_ghost,evl,evr)
    ! ===================================================================

        ! Second order TVD reconstruction for WENOCLAW
        ! This one uses characteristic decomposition

        !  evl, evr are left and right eigenvectors at each interface
        implicit double precision (a-h,o-z)

        integer,          intent(in) :: num_eqn, num_ghost        
        double precision, intent(in) :: q(:,:)
        integer, intent(in) :: mthlim(:)
        double precision, intent(out) :: ql(:,:),qr(:,:)
        double precision, intent(in) :: evl(:,:,:),evr(:,:,:)
        integer :: mx2

        mx2  = size(q,2)

        ! loop over all equations (all components).  
        ! the reconstruction is performed using characteristic decomposition

        ! compute and store the differences of the cell averages
        forall(m=1:num_eqn,i=2:mx2)
            dq(m,i)=q(m,i)-q(m,i-1)
        end forall

        do m=1,num_eqn

            ! Project the difference of the cell averages to the
            ! 'm'th characteristic field
            do m1 = -1,1
                do  i = num_ghost+1,mx2-1
                    hh(m1,i) = 0.d0
                    do mm=1,num_eqn
                        hh(m1,i) = hh(m1,i)+ evl(m,mm,i)*dq(mm,i+m1)
                    enddo
                enddo
            enddo


            ! the reconstruction
            do m1=1,2
                im=(-1)**(m1+1)
                ! m1=1: construct qr_i-1
                ! m1=2: construct ql_i

                do i=num_ghost+1,mx2-1
                    ! dqp=hh(m1-1,i)
                    ! dqm=hh(m1-2,i)
                    if (dabs(hh(m1-2,i)).gt.1.e-14) then
                        r=hh(m1-1,i)/hh(m1-2,i)
                    else
                        r=0.d0
                    endif
               
                    select case(mthlim(m))
                    case(1)
                        ! minmod
                        slimitr = dmax1(0.d0, dmin1(1.d0, r))
                    case(2)
                        ! superbee
                        slimitr = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))
                    case(3)
                        ! van Leer
                        slimitr = (r + dabs(r)) / (1.d0 + dabs(r))
                    case(4)
                        ! monotonized centered
                        c = (1.d0 + r)/2.d0
                        slimitr = dmax1(0.d0, dmin1(c, 2.d0, 2.d0*r))
                    case(5)
                        ! Cada & Torrilhon simple
                        beta=2.d0
                        xgamma=2.d0
                        alpha=1.d0/3.d0
                        pp=(2.d0+r)/3.d0
                        amax = dmax1(-alpha*r,0.d0,dmin1(beta*r,pp,xgamma))
                        slimitr = dmax1(0.d0, dmin1(pp,amax))
                    end select
    
                     u(m,m1,i) = im*0.5d0*slimitr*hh(m1-2,i)

                enddo
            enddo
        enddo

        ! Project to the physical space:
        do m =  1, num_eqn
            do i = num_ghost+1,mx2-1
                qr(m,i-1)=q(m,i-1)
                ql(m,i  )=q(m,i  )
                do mm=1,num_eqn 
                    qr(m,i-1) = qr(m,i-1) + evr(m,mm,i)*u(mm,1,i)
                    ql(m,i  ) = ql(m,i  ) + evr(m,mm,i)*u(mm,2,i)
                enddo
            enddo
        enddo
    end subroutine tvd2_char

    ! ===================================================================
    subroutine tvd2_wave(q,ql,qr,wave,s,mthlim,num_eqn,num_ghost)
    ! ===================================================================
        ! Second order TVD reconstruction for WENOCLAW
        ! This one uses projected waves

        implicit double precision (a-h,o-z)
        integer,          intent(in) :: num_eqn, num_ghost        
        double precision, intent(in) :: q(:,:)
        integer, intent(in) :: mthlim(:)
        double precision, intent(out) :: ql(:,:),qr(:,:)
        double precision, intent(in) :: wave(:,:,:), s(:,:)
        integer :: mx2, num_waves

        mx2  = size(q,2); num_waves=size(wave,2)

        forall(i=2:mx2,m=1:num_eqn)
            qr(m,i-1) = q(m,i-1)
            ql(m,i  ) = q(m,i  )
        end forall

        ! loop over all equations (all components).  
        ! the reconstruction is performed using characteristic decomposition

        do mw=1,num_waves
            dotr = 0.d0
            do i=num_ghost,mx2-num_ghost
                wnorm2=0.d0
                dotl=dotr
                dotr=0.d0
                do m=1,num_eqn
                    wnorm2 = wnorm2 + wave(m,mw,i)**2
                    dotr = dotr + wave(m,mw,i)*wave(m,mw,i+1)
                enddo
                if (i.eq.0) cycle
                if (wnorm2.eq.0.d0) cycle
                
                if (s(mw,i).gt.0.d0) then
                    r = dotl / wnorm2
                else
                    r = dotr / wnorm2
                endif

                select case(mthlim(mw))
                    case(1)
                        ! minmod
                        wlimitr = dmax1(0.d0, dmin1(1.d0, r))
                    case(2)
                        ! superbee
                        wlimitr = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))
                    case(3)
                        ! van Leer
                        wlimitr = (r + dabs(r)) / (1.d0 + dabs(r))
                    case(4)
                        ! monotonized centered
                        c = (1.d0 + r)/2.d0
                        wlimitr = dmax1(0.d0, dmin1(c, 2.d0, 2.d0*r))
                    case(5)
                        ! Cada & Torrilhon simple
                        beta=2.d0
                        xgamma=2.d0
                        alpha=1.d0/3.d0
                        pp=(2.d0+r)/3.d0
                        amax = dmax1(-alpha*r,0.d0,dmin1(beta*r,pp,xgamma))
                        wlimitr = dmax1(0.d0, dmin1(pp,amax))
                end select

                uu(mw,i) = 0.5d0*wlimitr

                do m =  1, num_eqn
                    qr(m,i-1) = qr(m,i-1) + wave(m,mw,i)*uu(mw,i)
                    ql(m,i  ) = ql(m,i  ) - wave(m,mw,i)*uu(mw,i)
                enddo ! end loop over equations

            enddo
        enddo !end loop over waves

      return
      end subroutine tvd2_wave

end module reconstruct

      subroutine setprob
      implicit double precision (a-h,o-z)
      character*25 fname
      common /cparam/ rho,bulk,cc,zz   
      common /cqinit/ beta
      common /comsrc/ ndim
c
c     # Set the material parameters for the acoustic equations
c     # Passed to the Riemann solver rp1.f in a common block
c
c
      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)
                

c     # ndim = space dimensions (2 = cylindrical symmetry, 3 = spherical)
      read(7,*) ndim

c     # density:
      read(7,*) rho

c     # bulk modulus:
      read(7,*) bulk

c     # sound speed:
      cc = dsqrt(bulk/rho)

c     # impedance:
      zz = cc*rho


      return
      end

! ==================================================================
subroutine rptt3(ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,bsasdq,cmbsasdq,cpbsasdq)
! ==================================================================

!     # Double transverse Riemann solver for the acoustics equations
!     # with varying material properties.

!     # auxN(i,1,:) holds impedance Z
!     # auxN(i,2,:) holds sound speed c
!     #
!     # On input,

!     #    ql,qr is the data along some one-dimensional slice, as in rpn3
!     #         This slice is
!     #             in the x-direction if ixyz=1,
!     #             in the y-direction if ixyz=2, or
!     #             in the z-direction if ixyz=3.

!     #    bsasdq is an array of flux differences that result from a
!     #         transverse splitting (a previous call to rpt3).
!     #         This stands for B^* A^* \Dq but could represent any of
!     #         6 possibilities, e.g.  C^* B^* \Dq, as specified by ixyz
!     #         and icoor (see below).
!     #         Moreover, each * represents either + or -, as specified by
!     #         imp and impt.

!     #    ixyz indicates the direction of the original Riemann solve,
!     #         called the x-like direction in the table below:

!     #               x-like direction   y-like direction   z-like direction
!     #      ixyz=1:        x                  y                  z
!     #      ixyz=2:        y                  z                  x
!     #      ixyz=3:        z                  x                  y

!     #    icoor indicates direction in which the transverse solve should
!     #         be performed.
!     #      icoor=2: split in the y-like direction.
!     #      icoor=3: split in the z-like direction.

!     #    For example,
!     #        ixyz=1, icoor=3 means bsasdq=B^*A^*\Dq, and should be
!     #                        split in z into
!     #                           cmbsasdq = C^-B^*A^*\Dq,
!     #                           cpbsasdq = C^+B^*A^*\Dq.
!     #
!     #        ixyz=2, icoor=3 means bsasdq=C^*B^*\Dq, and should be
!     #                        split in x into
!     #                           cmbsasdq = A^-C^*B^*\Dq,
!     #                           cpbsasdq = A^+C^*B^*\Dq.

!     #    The parameters imp and impt are generally needed only if aux
!     #    arrays are being used, in order to access the appropriate
!     #    variable coefficients:

!     #    imp =  1 if bsasdq = B^*A^- \Dq, a left-going flux difference
!     #           2 if bsasdq = B^*A^+ \Dq, a right-going flux difference
!     #    impt = 1 if bsasdq = B^-A^* \Dq, a down-going flux difference
!     #           2 if bsasdq = B^+A^* \Dq, an up-going flux difference

!     #    aux2(:,:,2) is a 1d slice of the aux array along the row
!     #                 where the data ql, qr lie.
!     #    aux1(:,:,2) and aux3(:,:,2) are neighboring rows in the
!     #                 y-like direction
!     #    aux2(:,:,1) and aux2(:,:,3) are neighboring rows in the
!     #                z-like direction


    implicit real*8(a-h,o-z)
    dimension       ql(meqn,1-mbc:maxm+mbc)
    dimension       qr(meqn,1-mbc:maxm+mbc)
    dimension   bsasdq(meqn,1-mbc:maxm+mbc)
    dimension cmbsasdq(meqn,1-mbc:maxm+mbc)
    dimension cpbsasdq(meqn,1-mbc:maxm+mbc)
    dimension     aux1(maux,1-mbc:maxm+mbc,3)
    dimension     aux2(maux,1-mbc:maxm+mbc,3)
    dimension     aux3(maux,1-mbc:maxm+mbc,3)


!     # set iuvw = 2,3,4, depending on which component of q represents
!     # velocity in the transverse direction in which splitting is to
!     # be performed:
    iuvw = ixyz + icoor
    if (iuvw > 4) iuvw = iuvw-3


    do 10 i=2-mbc,mx+mbc

    !        # The flux difference bsasdq is split into downward moving part
    !        # traveling at speed -c relative to the medium below and
    !        # an upward moving part traveling at speed +c relative to
    !        # the medium above, in the double-transverse direction specified
    !        # by icoor.
    
    !        # Note that the sum of these parts does not give all of bsasdq
    !        # since there is also reflection at the interfaces which decreases
    !        # the flux.
    
    
    !        # set impendance and sound speed in each row of cells,
    !        # by selecting appropriate values from aux arrays depending on
    !        # values of icoor, imp, impt:
    
        i1 = i-2+imp    !#  =  i-1 for amdq,  i for apdq
    
        if (impt == 1) then
        !           # bsasdq propagates to "left" in transverse direction used in rpt3
        !           # so we either use auxN(:,:,1) or aux1(:,:,N) for N=1,2,3
        !           # depending on icoor:

            if (icoor == 2) then
            !           # new double-transverse direction is y-like direction
                zm = aux1(1,i1,1)
                zz = aux2(1,i1,1)
                zp = aux3(1,i1,1)
                cm = aux1(2,i1,1)
                c =  aux2(2,i1,1)
                cp = aux3(2,i1,1)
            else !! (icoor .eq. 3)
            !           # new double-transverse direction is z-like direction
                zm = aux1(1,i1,1)
                zz = aux1(1,i1,2)
                zp = aux1(1,i1,3)
                cm = aux1(2,i1,1)
                c =  aux1(2,i1,2)
                cp = aux1(2,i1,3)
            endif
        else
        !           # bsasdq propagates to "right" in transverse direction used in rpt3
        !           # so we either use auxN(:,:,3) or aux3(:,:,N) for N=1,2,3
        !           # depending on icoor:
            if (icoor == 2) then
            !           # new double-transverse direction is y-like direction
                zm = aux1(1,i1,3)
                zz = aux2(1,i1,3)
                zp = aux3(1,i1,3)
                cm = aux1(2,i1,3)
                c =  aux2(2,i1,3)
                cp = aux3(2,i1,3)
            else !! (icoor .eq. 3)
            !           # new double-transverse direction is z-like direction
                zm = aux3(1,i1,1)
                zz = aux3(1,i1,2)
                zp = aux3(1,i1,3)
                cm = aux3(2,i1,1)
                c =  aux3(2,i1,2)
                cp = aux3(2,i1,3)
            endif
        endif
    

    !        # transmitted part of down-going wave:
        a1 = (-bsasdq(1,i) + bsasdq(iuvw,i)*zz) / &
        (zm + zz)

    !        # transmitted part of up-going wave:
        a2 = (bsasdq(1,i) + bsasdq(iuvw,i)*zz) / &
        (zz + zp)
    
    !        # The down-going flux difference cmbsasdq is the product  -c * wave
    
        cmbsasdq(1,i) = cm * a1*zm
        cmbsasdq(2,i) = 0.d0
        cmbsasdq(3,i) = 0.d0
        cmbsasdq(4,i) = 0.d0
        cmbsasdq(iuvw,i) = -cm * a1
    
    !        # The up-going flux difference cpbsasdq is the product  c * wave
    
        cpbsasdq(1,i) = cp * a2*zp
        cpbsasdq(2,i) = 0.d0
        cpbsasdq(3,i) = 0.d0
        cpbsasdq(4,i) = 0.d0
        cpbsasdq(iuvw,i) = cp * a2
    
    10 END DO


    return
    end subroutine rptt3

c
c     ==============================================================
      subroutine claw1(meqn,mwaves,maux,mbc,mx,
     &           q,aux,xlower,dx,tstart,tend,dtv,cflv,nv,method,mthlim,
     &           mthbc,work,mwork,use_fwave,info,bc1,rp1,src1,b4step1)
c     ==============================================================
c
c  Solves a hyperbolic system of conservation laws in one space dimension
c  of the general form 
c
c     capa * q_t + A q_x = psi
c
c  The "capacity function" capa(x) and source term psi are optional
c  (see below).
c
c  For a more complete description see the documentation at
c      http://www.amath.washington.edu/~claw
c
c  Sample driver programs and user-supplied subroutines are available.
c  See the the directories claw/clawpack/1d/example* for some examples, and
c  codes in claw/applications for more extensive examples.
c
c  --------------------------------------------------------
c
c  The user must supply the following subroutines:
c
c    bc1, rp1        subroutines specifying the boundary conditions and 
c                    Riemann solver.
c                    These are described in greater detail below.
c
c    b4step1            The routine b4step1 is called each time step and
c                       can be supplied by the user in order to perform
c                       other operations that are necessary every time
c                       step.  For example, if the variables stored in
c                       the aux arrays are time-dependent then these
c                       values can be set.
c
c  In addition, if the equation contains source terms psi, then the user
c  must provide:
c
c    src1               subroutine that solves capa * q_t = psi
c                       over a single time step.
c
c  These routines must be declared EXTERNAL in the main program.
c  For description of the calling sequences, see below.
c
c  Dummy routines b4step1.f and src1.f are available in 
c       claw/clawpack/1d/lib
c
c
c
c  Description of parameters...
c  ----------------------------
c
c
c    meqn is the number of equations in the system of
c         conservation laws.
c
c    mwaves is the number of waves that result from the
c           solution of each Riemann problem.  Often mwaves = meqn but
c           for some problems these may be different.
c
c    mbc is the number of "ghost cells" that must be added on to each
c       side of the domain to handle boundary conditions.  The cells
c       actually in the physical domain are labelled from 1 to mx in x.
c       The arrays are dimensioned actually indexed from 1-mbc to mx+mbc.
c       For the methods currently implemented, mbc = 2 should be used.
c       If the user implements another method that has a larger stencil and
c       hence requires more ghost cells, a larger value of mbc could be used.
c       q is extended from the physical domain to the ghost cells by the
c       user-supplied routine bc1.
c
c    mx is the number of grid cells in the x-direction, in the
c       physical domain.  In addition there are mbc grid cells
c       along each edge of the grid that are used for boundary
c       conditions.
c 
c    q(meqn, 1-mbc:mx+mbc) 
c        On input:  initial data at time tstart.
c        On output: final solution at time tend.
c        q(m,i) = value of mth component in the i'th cell.
c        Values within the physical domain are in q(m,i) 
c                for i = 1,2,...,mx
c        mbc extra cells on each end are needed for boundary conditions
c        as specified in the routine bc1.
c
c    aux(maux, 1-mbc:mx+mbc)
c        Array of auxiliary variables that are used in specifying the problem.
c        If method(7) = 0 then there are no auxiliary variables and aux
c                         can be a dummy variable.
c        If method(7) = maux > 0 then there are maux auxiliary variables
c                         and aux must be dimensioned as above.
c
c        Capacity functions are one particular form of auxiliary variable.
c        These arise in some applications, e.g. variable coefficients in
c        advection or acoustics problems.
c        See Clawpack Note # 5 for examples.
c
c        If method(6) = 0 then there is no capacity function.
c        If method(6) = mcapa > 0  then there is a capacity function and
c            capa(i), the "capacity" of the i'th cell, is assumed to be
c            stored in aux(mcapa,i).
c            In this case we require method(7).ge.mcapa.
c
c    dx = grid spacing in x.  
c         (for a computation in ax <= x <= bx,  set dx = (bx-ax)/mx.)
c
c    tstart = initial time.
c
c    tend = Desired final time (on input).
c              If tend<tstart, then claw1 returns after a single successful
c                 time step has been taken (single-step mode).
c              Otherwise, as many steps are taken as needed to reach tend, 
c                 up to a maximum of nv(1).
c         = Actual time reached (on output).
c
c    dtv(1:5) = array of values related to the time step:
c               (Note: method(1)=1 indicates variable size time steps)
c         dtv(1) = value of dt to be used in all steps if method(1) = 0
c                = value of dt to use in first step if method(1) = 1
c         dtv(2) = unused if method(1) = 0.
c                = maximum dt allowed if method(1) = 1.
c         dtv(3) = smallest dt used (on output)
c         dtv(4) = largest dt used (on output)
c         dtv(5) = dt used in last step (on output)
c
c    cflv(1:4) = array of values related to Courant number:
c         cflv(1) = maximum Courant number to be allowed.  With variable
c                   time steps the step is repeated if the Courant
c                   number is larger than this value.  With fixed time
c                   steps the routine aborts.  Usually cflv(1)=1.0
c                   should work.
c         cflv(2) = unused if method(1) = 0.
c                 = desired Courant number if method(1) = 1.
c                   Should be somewhat less than cflv(1), e.g. 0.9
c         cflv(3) = largest Courant number observed (on output).
c         cflv(4) = Courant number in last step (on output).
c
c    nv(1:2) = array of values related to the number of time steps:
c         nv(1) = unused if method(1) = 0
c               = maximum number of time steps allowed if method(1) = 1
c         nv(2) = number of time steps taken (on output).
c
c    method(1:7) = array of values specifying the numerical method to use
c         method(1) = 0 if fixed size time steps are to be taken.
c                       In this case, dt = dtv(1) in all steps.
c                   = 1 if variable time steps are to be used.
c                       In this case, dt = dtv(1) in the first step and
c                       thereafter the value cflv(2) is used to choose the
c                       next time step based on the maximum wave speed seen
c                       in the previous step.  Note that since this value
c                       comes from the previous step, the Courant number will
c                       not in general be exactly equal to the desired value
c                       If the actual Courant number in the next step is
c                       greater than 1, then this step is redone with a 
c                       smaller dt.
c
c         method(2) = 1 if Godunov's method is to be used, with no 2nd order
c                       corrections.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.  
c
c         method(3)  is not used in one-dimension.
c
c         method(4) = 0 to suppress printing
c                   = 1 to print dt and Courant number every time step
c
c         method(5) = 0 if there is no source term psi.  In this case
c                       the subroutine src1 is never called so a dummy
c                       parameter can be given.
c                   = 1 if there is a source term.  In this case
c                       the subroutine src1 must be provided and a
c                       fractional step method is used.
c                       In each time step the following sequence is followed:
c                            call bc to extend data to ghost cells
c                            call step1 to advance hyperbolic eqn by dt
c                            call src1 to advance source terms by dt
c                   = 2 if there is a source term and Strang splitting is to
c                       be used instead of the Godunov splitting above.
c                       In each time step the following sequence is followed:
c                            call bc to extend data to ghost cells
c                            call src1 to advance source terms by dt/2
c                            call step1 to advance hyperbolic equation by dt
c                            call src1 to advance source terms by dt/2
c                       For most problems 1 is recommended rather than 2
c                       since it is less expensive and works essentially as
c                       well on most problems.

c
c         method(6) = 0 if there is no capacity function capa.
c                   = mcapa > 0 if there is a capacity function.  In this case
c                       aux(i,mcapa) is the capacity of the i'th cell and you
c                       must also specify method(7) .ge. mcapa and set aux.
c
c         method(7) = 0 if there is no aux array used.
c                   = maux > 0  if there are maux auxiliary variables.
c
c
c         The recommended choice of methods for most problems is
c            method(1) = 1,  method(2) = 2.
c
c    mthlim(1:mwaves) = array of values specifying the flux limiter to be used
c                     in each wave family mw.  Often the same value will be used
c                     for each value of mw, but in some cases it may be
c                     desirable to use different limiters.  For example,
c                     for the Euler equations the superbee limiter might be
c                     used for the contact discontinuity (mw=2) while another
c                     limiter is used for the nonlinear waves.  Several limiters
c                     are built in and others can be added by modifying the
c                     subroutine philim.
c
c        mthlim(mw) = 0 for no limiter
c                   = 1 for minmod
c                   = 2 for superbee
c                   = 3 for van Leer
c                   = 4 for monotonized centered
c
c
c    work(mwork) = double precision work array of length at least mwork
c
c    mwork = length of work array.  Must be at least
c               (mx + 2*mbc) * (2 + 4*meqn + mwaves + meqn*mwaves)
c            If mwork is too small then the program returns with info = 4
c            and prints the necessary value of mwork to unit 6.
c
c            
c    info = output value yielding error information:
c         = 0 if normal return.
c         = 1 if mbc.lt.2
c         = 2 if method(1)=0 and dt doesn't divide (tend - tstart).
c         = 3 if method(1)=1 and cflv(2) > cflv(1).
c         = 4 if mwork is too small.
c         = 11 if the code attempted to take too many time steps, n > nv(1).
c              This could only happen if method(1) = 1 (variable time steps).
c         = 12 if the method(1)=0 and the Courant number is greater than 1
c              in some time step.
c
c           Note: if info.ne.0, then tend is reset to the value of t actually
c           reached and q contains the value of the solution at this time.
c
c    User-supplied subroutines
c    -------------------------
c
c    bc1 = subroutine that specifies the boundary conditions.  
c         This subroutine should extend the values of q from cells
c         1:mx to the mbc ghost cells along each edge of the domain.
c
c          The form of this subroutine is
c  -------------------------------------------------
c     subroutine bc1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt,mthbc)
c     implicit double precision (a-h,o-z)
c     dimension   q(meqn, 1-mbc:mx+mbc)
c     dimension aux(maux, 1-mbc:mx+mbc)
c     dimension mthbc(2)
c  -------------------------------------------------
c
c    The routine claw/clawpack/1d/lib/bc1.f can be used to specify
c    various standard boundary conditions.
c
c
c    rp1 = user-supplied subroutine that implements the Riemann solver
c
c          The form of this subroutine is
c  -------------------------------------------------
c     subroutine rp1(meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c     implicit double precision (a-h,o-z)
c     dimension   ql(meqn, 1-mbc:mx+mbc)
c     dimension   qr(meqn, 1-mbc:mx+mbc)
c     dimension auxl(maux, 1-mbc:mx+mbc)
c     dimension auxr(maux, 1-mbc:mx+mbc)
c     dimension wave(meqn, mwaves, 1-mbc:mx+mbc)
c     dimension    s(mwaves, 1-mbc:mx+mbc)
c     dimension amdq(meqn, 1-mbc:mx+mbc)
c     dimension apdq(meqn, 1-mbc:mx+mbc)
c  -------------------------------------------------
c
c         On input, ql contains the state vector at the left edge of each cell
c                   qr contains the state vector at the right edge of each cell
c                 auxl contains auxiliary values at the left edge of each cell
c                 auxr contains auxiliary values at the right edge of each cell
c
c         Note that the i'th Riemann problem has left state qr(:,i-1)
c                                            and right state ql(:,i)
c         In the standard clawpack routines, this Riemann solver is
c         called with ql=qr=q along this slice.  More flexibility is allowed
c         in case the user wishes to implement another solution method
c         that requires left and rate states at each interface.

c         If method(7)=maux > 0 then the auxiliary variables along this slice
c         are passed in using auxl and auxr.  Again, in the standard routines
c         auxl=auxr=aux in the call to rp1.
c
c          On output, 
c              wave(m,mw,i) is the m'th component of the jump across
c                              wave number mw in the ith Riemann problem.
c              s(mw,i) is the wave speed of wave number mw in the
c                              ith Riemann problem.
c              amdq(m,i) = m'th component of A^- Delta q,
c              apdq(m,i) = m'th component of A^+ Delta q,
c                     the decomposition of the flux difference
c                         f(qr(i-1)) - f(ql(i))
c                     into leftgoing and rightgoing parts respectively.
c
c           It is assumed that each wave consists of a jump discontinuity
c           propagating at a single speed, as results, for example, from a
c           Roe approximate Riemann solver.  An entropy fix can be included
c           into the specification of amdq and apdq.
c
c    src1 = subroutine for the source terms that solves the equation
c               capa * q_t = psi 
c           over time dt.
c
c           If method(5)=0 then the equation does not contain a source
c           term and this routine is never called.  A dummy argument can
c           be used with many compilers, or provide a dummy subroutine that
c           does nothing (such a subroutine can be found in
c           claw/clawpack/1d/lib/src1.f)
c
c          The form of this subroutine is
c  -------------------------------------------------
c     subroutine src1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)
c     implicit double precision (a-h,o-z)
c     dimension   q(meqn, 1-mbc:mx+mbc)
c     dimension aux(maux, 1-mbc:mx+mbc)
c  -------------------------------------------------
c      If method(7)=0  or the auxiliary variables are not needed in this solver,
c      then the latter dimension statement can be omitted, but aux should
c      still appear in the argument list.
c
c      On input, q(m,i) contains the data for solving the
c                source term equation.
c      On output, q(m,i) should have been replaced by the solution to
c                 the source term equation after a step of length dt.
c
c
c      b4step1 = subroutine that is called from claw1 before each call to
c                step1.  Use to set time-dependent aux arrays or perform
c                other tasks which must be done every time step.
c
c          The form of this subroutine is
c      
c  -------------------------------------------------
c      subroutine b4step1(mbc,mx,meqn,q,xlower,dx,time,dt,maux,aux)
c      implicit double precision (a-h,o-z)
c      dimension   q(meqn, 1-mbc:mx+mbc)
c      dimension aux(maux, 1-mbc:mx+mbc)
c  -------------------------------------------------
c
c
c
c
c =========================================================================
c
c  Copyright 1994 -- 2002 R. J. LeVeque
c
c  This software is made available for research and instructional use only. 
c  You may copy and use this software without charge for these non-commercial
c  purposes, provided that the copyright notice and associated text is
c  reproduced on all copies.  For all other uses (including distribution of
c  modified versions), please contact the author at the address given below. 
c  
c  *** This software is made available "as is" without any assurance that it
c  *** will work for your purposes.  The software may in fact have defects, so
c  *** use the software at your own risk.
c
c  --------------------------------------
c    CLAWPACK Version 4.1,  August, 2002
c    Webpage: http://www.amath.washington.edu/~claw
c  --------------------------------------
c    Author:  Randall J. LeVeque
c             Applied Mathematics
c             Box 352420
c             University of Washington, 
c             Seattle, WA 98195-2420
c             rjl@amath.washington.edu
c =========================================================================
c
c
c
c            
c    ======================================================================
c    Beginning of claw1 code
c    ======================================================================
c 
      implicit double precision (a-h,o-z)
      external bc1,rp1,src1,b4step1
      dimension q(meqn,1-mbc:mx+mbc)
      dimension aux(maux,1-mbc:mx+mbc)
      dimension work(mwork)
      dimension mthlim(mwaves),method(7),dtv(5),cflv(4),nv(2)
      dimension mthbc(2)
      common /comxt/ dtcom,dxcom,tcom
c
c
      info = 0
      t = tstart
      maxn = nv(1)
      dt = dtv(1)   !# initial dt
      cflmax = 0.d0
      dtmin = dt
      dtmax = dt
      nv(2) = 0
c
c     # check for errors in data:
c
c
      if (method(1) .eq. 0) then
c        # fixed size time steps.  Compute the number of steps:
         if (tend .lt. tstart) then
c             # single step mode
              maxn = 1
           else
              maxn = nint((tend - tstart)/dt)    ! Round to nearest int
              if (dabs(maxn*dt - (tend-tstart)) .gt.
     &                          1d-5*(tend-tstart)) then
c                # dt doesn't divide time interval integer number of times
                 info = 2
                 go to 900
                 endif
           endif
         endif
c
      if (method(1).eq.1 .and. cflv(2).gt.cflv(1)) then
         info = 3
         go to 900
         endif
c
c     # partition work array into pieces for passing into step1:
      i0f = 1
      i0wave = i0f + (mx + 2*mbc) * meqn
      i0s = i0wave + (mx + 2*mbc) * meqn * mwaves
      i0dtdx = i0s + (mx + 2*mbc) * mwaves
      i0qwork = i0dtdx + (mx + 2*mbc) 
      i0amdq = i0qwork + (mx + 2*mbc) * meqn
      i0apdq = i0amdq + (mx + 2*mbc) * meqn
      i0dtdx = i0apdq + (mx + 2*mbc) * meqn
      i0end = i0dtdx + (mx + 2*mbc) - 1
c
      if (mwork .lt. i0end) then
         write(6,*) 'mwork must be increased to ',i0end
         info = 4
         go to 900
         endif
c
c     -----------
c     # main loop
c     -----------
c
      if (maxn.eq.0) go to 900
      do 100 n=1,maxn
         told = t   !# time at beginning of time step.

c        # adjust dt to hit tend exactly if we're near end of computation
c        #  (unless tend < tstart, which is a flag to take only a single step)
         if (told+dt.gt.tend .and. tstart.lt.tend) dt = tend - told

         if (method(1).eq.1) then
c           # save old q in case we need to retake step with smaller dt:
            call copyq1(meqn,mbc,mx,q,work(i0qwork))
            endif
c           
   40    continue
         dt2 = dt / 2.d0
         thalf = t + dt2  !# midpoint in time for Strang splitting
         t = told + dt    !# time at end of step

c        # store dt and t in the common block comxt in case they are needed
c        # in the Riemann solvers (for variable coefficients)
         tcom = told
         dtcom = dt
         dxcom = dx
c
c        ------------------------------------------------------------------
c        # main steps in algorithm:
c        ------------------------------------------------------------------
c
c        # extend data from grid to bordering boundary cells:
         call bc1(meqn,mbc,mx,xlower,dx,q,maux,aux,told,dt,mthbc)
c
c
c        # call user-supplied routine which might set aux arrays
c        # for this time step, for example.

         call b4step1(mbc,mx,meqn,q,
     &                xlower,dx,told,dt,maux,aux)
c
c
         if (method(5).eq.2) then
c            # with Strang splitting for source term:
             call src1(meqn,mbc,mx,xlower,dx,q,maux,aux,told,dt2)
             endif
c
c        # take a step on the homogeneous conservation law:
         call step1(meqn,mwaves,mbc,maux,mx,q,aux,dx,dt,
     &             method,mthlim,cfl,work(i0f),work(i0wave),
     &             work(i0s),work(i0amdq),work(i0apdq),work(i0dtdx),
     &             use_fwave,rp1)
c
         if (method(5).eq.2) then
c            # source terms over a second half time step for Strang splitting:
c            # Note it is not so clear what time t should be used here if
c            # the source terms are time-dependent!
             call src1(meqn,mbc,mx,xlower,dx,q,maux,aux,thalf,dt2)
             endif

         if (method(5).eq.1) then
c            # source terms over a full time step:
             call src1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)
             endif
c

c
c        ------------------------------------------------------------------
c
         if (method(4) .eq. 1) write(6,601) n,cfl,dt,t
  601    format('CLAW1... Step',i4,
     &                   '   Courant number =',f6.3,'  dt =',d12.4,
     &                   '  t =',d12.4)
c
         if (method(1) .eq. 1) then
c           # choose new time step if variable time step
            if (cfl .gt. 0.d0) then
                dt = dmin1(dtv(2), dt * cflv(2)/cfl)
                dtmin = dmin1(dt,dtmin)
                dtmax = dmax1(dt,dtmax)
              else
                dt = dtv(2)
              endif
            endif
c
c        # check to see if the Courant number was too large:
c
         if (cfl .le. cflv(1)) then
c               # accept this step
                cflmax = dmax1(cfl,cflmax)
              else
c               # reject this step
                t = told
                call copyq1(meqn,mbc,mx,work(i0qwork),q)
c
                if (method(4) .eq. 1) then
                   write(6,602) 
  602              format('CLAW1 rejecting step... ',
     &                         'Courant number too large')
                   endif
                if (method(1).eq.1) then
c                   # if variable dt, go back and take a smaller step
                    go to 40
                  else
c                   # if fixed dt, give up and return
                    cflmax = dmax1(cfl,cflmax)
                    go to 900
                  endif
               endif
c
c        # see if we are done:
         nv(2) = nv(2) + 1
         if (t .ge. tend) go to 900
c
  100    continue
c
  900  continue
c 
c      # return information
c
       if (method(1).eq.1 .and. t.lt.tend .and. nv(2) .eq. maxn) then
c         # too many timesteps
          info = 11
          endif
c
       if (method(1).eq.0 .and. cflmax .gt. cflv(1)) then
c         # Courant number too large with fixed dt
          info = 12
          endif
       tend = t
       cflv(3) = cflmax
       cflv(4) = cfl
       dtv(3) = dtmin
       dtv(4) = dtmax
       dtv(5) = dt
       return 
       end

! ============================================================================
subroutine tfluct1(maxnx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,adq)
! ============================================================================
!   "Internal" Riemann solver for the euler equations in 1D.
!   The riemann problem is solved by assuming a discontinuity at the
!   center of the i'th cell.
!
!   On input, ql contains the state vector at the left edge of each cell
!             qr contains the state vector at the right edge of each cell
!             auxl contains the auxiliary vector at the left edge of each cell
!             auxr contains the state vector at the right edge of each cell
!             maxnx is the number of physical points (without ghost cells)
!             mbc is the number of ghost cells
!             meqn is the number of equations
!             ixyz is the dimension index
!             mx is the size of the patch for the dimension corresponding
!               to the value of ixyz
!
!   On output, adq contains the decomposition of the flux difference
!              f(qr(i)) - f(ql(i)).
!
!   For the Euler equations q = (q1, q2, q3)^T, 
!   where q1 = rho, q2 = rho*u, q3 = E and
!              _                                              _  
!             |                       q2                       |
!   f(q) =    |        0.5(3-gamma)q2^2/q1 + (gamma-1)q3       |
!             |_  ( gamma*q3 - 0.5(gamma-1)q2^2/q1 ) * q2/g1  _|


    implicit none
    integer,          intent(in)  :: maxnx, mx, meqn, mwaves, maux, mbc
    double precision, intent(in)  :: auxl(maux,1-mbc:maxnx+mbc)
    double precision, intent(in)  :: auxr(maux,1-mbc:maxnx+mbc)
    double precision, intent(in)  ::   ql(meqn,1-mbc:maxnx+mbc)
    double precision, intent(in)  ::   qr(meqn,1-mbc:maxnx+mbc)

    double precision, intent(out) :: adq(meqn,1-mbc:maxnx+mbc)

    integer :: i
    double precision :: gamma, gamma1

!   local storage
!   ---------------
    common /cparam/  gamma

    gamma1 = gamma - 1.d0

    do i = 1,mx
        adq(1,i) = qr(2,i) - ql(2,i)
        adq(2,i) = 0.5d0*(3.d0-gamma)*(qr(2,i)**2/qr(1,i) - ql(2,i)**2/ql(1,i)) &
                    + gamma1*(qr(3,i) - ql(3,i))
        adq(3,i) = (gamma*qr(3,i)-0.5d0*gamma1*qr(2,i)**2/qr(1,i))*qr(2,i)/qr(1,i) & 
                    - (gamma*ql(3,i)-0.5d0*gamma1*ql(2,i)**2/ql(1,i))*ql(2,i)/ql(1,i)
    enddo

    return
end subroutine tfluct1

! =====================================================
      subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,
     &                ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
!
!     Riemann solver in the transverse direction using 
!     Jacobian matrix from left cell (if imp==1) or right cell (if imp==2).
!
!     Note this has been modified from the version used in v5.7.x and
!     earlier, where Roe averages based on ql and qr were used, which
!     is not correct.  In addition:
!      - a bug in the second component of the eigenvectors was fixed.
!      - when s(2) is close to zero this component of flux difference
!        is split equally between bmasdq and bpasdq to improve symmetry.
!   
!     Further modified to clean up and avoid a lot of work in dry cells.

!-----------------------last modified October 2020 ----------------------

      use geoclaw_module, only: g => grav, tol => dry_tolerance
      use geoclaw_module, only: coordinate_system,earth_radius,deg2rad

      implicit none

      integer, intent(in) :: ixy,maxm,meqn,maux,mwaves,mbc,mx,imp

      real(kind=8), intent(in) ::  ql(meqn,1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  qr(meqn,1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  asdq(meqn,1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  aux1(maux,1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  aux2(maux,1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  aux3(maux,1-mbc:maxm+mbc)

      real(kind=8), intent(out) ::  bmasdq(meqn,1-mbc:maxm+mbc)
      real(kind=8), intent(out) ::  bpasdq(meqn,1-mbc:maxm+mbc)

      ! local:
      real(kind=8) ::  s(mwaves), r(meqn,mwaves), beta(mwaves)
      real(kind=8) ::  h,u,v
      real(kind=8) ::  delf1,delf2,delf3
      real(kind=8) ::  dxdcm,dxdcp,topo1,topo3,eta

      integer :: i,mw,mu,mv
      

      if (ixy == 1) then
         ! normal solve was in x-direction
         mu = 2
         mv = 3
      else
         ! normal solve was in y-direction
         mu = 3
         mv = 2
      endif

      ! initialize all components of result to 0:
      bmasdq(:,:) = 0.d0
      bpasdq(:,:) = 0.d0


      do i=2-mbc,mx+mbc

         if (imp==1) then
            h = qr(1,i-1)
         else
            h = ql(1,i)
         endif

         if (h <= tol) then
             ! fluctuation going into a dry cell, don't know how to split,
             ! so leave bmadsq(:,i)=bpasdq(:,i)=0 and go on to next i:
             cycle  
         endif

         ! compute velocities in relevant cell, and other quantities:

         if (imp==1) then
              ! fluctuation being split is left-going
              u = qr(mu,i-1)/h
              v = qr(mv,i-1)/h
              eta = h + aux2(1,i-1)
              topo1 = aux1(1,i-1)
              topo3 = aux3(1,i-1)
         else
              ! fluctuation being split is right-going
              u = ql(mu,i)/h
              v = ql(mv,i)/h
              eta = h + aux2(1,i)
              topo1 = aux1(1,i)
              topo3 = aux3(1,i)
         endif

         ! check if cell that transverse waves go into are both too high:
         ! Note: prior to v5.8.0 this checked against max rather than min
         if (eta < min(topo1,topo3)) cycle  ! go to next i

         ! if we get here, we want to do the splitting (no dry cells),
         ! so compute the necessary quantities:

         if (coordinate_system == 2) then
            ! on the sphere:
            if (ixy == 2) then
               dxdcp=(earth_radius*deg2rad)
               dxdcm = dxdcp
            else
               if (imp == 1) then
                  dxdcp = earth_radius*cos(aux3(3,i-1))*deg2rad
                  dxdcm = earth_radius*cos(aux1(3,i-1))*deg2rad
               else
                  dxdcp = earth_radius*cos(aux3(3,i))*deg2rad
                  dxdcm = earth_radius*cos(aux1(3,i))*deg2rad
               endif
            endif
         else
            ! coordinate_system == 1 means Cartesian:
            dxdcp = 1.d0
            dxdcm = 1.d0
         endif

c        Determine some speeds necessary for the Jacobian
            
         ! In v5.7.x and prior versions,
         ! we used left right states to define Roe averages,
         ! which is consistent with those used in rpn2.
         ! But now we are computing upgoing, downgoing waves either in
         ! cell on left (if imp==1) or on right (if imp==2) so we
         ! should possibly use q values in cells above/below,
         ! but these aren't available (only aux values).
         ! At any rate, there is no clear justification for using cells
         ! on the other side of the normal-solve interface.

         ! v5.8.0: modified to use left or right state alone in defining
         ! Jacobian, based on imp:

         s(1) = v - dsqrt(g*h)
         s(2) = v
         s(3) = v + dsqrt(g*h)

c        Determine asdq decomposition (beta)

         delf1 = asdq(1,i)
         delf2 = asdq(mu,i)
         delf3 = asdq(mv, i)

         ! v5.8.0: fixed bug in beta(2): u in place of s(2)=v
         beta(1) = (s(3)*delf1 - delf3) / (s(3) - s(1))
         beta(2) = -u*delf1 + delf2
         beta(3) = (delf3 - s(1)*delf1) / (s(3) - s(1))

c        Set-up eigenvectors
         r(1,1) = 1.d0
         r(2,1) = u    ! v5.8.0: fixed bug, u not s(2)=v
         r(3,1) = s(1)

         r(1,2) = 0.d0
         r(2,2) = 1.d0
         r(3,2) = 0.d0

         r(1,3) = 1.d0
         r(2,3) = u    ! v5.8.0: fixed bug, u not s(2)=v
         r(3,3) = s(3)


         ! compute fluctuations

         do  mw=1,3
            if ((s(mw) < 0.d0) .and. (eta >= topo1)) then
                 bmasdq(1,i) =bmasdq(1,i) + dxdcm*s(mw)*beta(mw)*r(1,mw)
                 bmasdq(mu,i)=bmasdq(mu,i)+ dxdcm*s(mw)*beta(mw)*r(2,mw)
                 bmasdq(mv,i)=bmasdq(mv,i)+ dxdcm*s(mw)*beta(mw)*r(3,mw)
            elseif ((s(mw) > 0.d0) .and. (eta >= topo3)) then
                 bpasdq(1,i) =bpasdq(1,i) + dxdcp*s(mw)*beta(mw)*r(1,mw)
                 bpasdq(mu,i)=bpasdq(mu,i)+ dxdcp*s(mw)*beta(mw)*r(2,mw)
                 bpasdq(mv,i)=bpasdq(mv,i)+ dxdcp*s(mw)*beta(mw)*r(3,mw)
            endif
         enddo  ! loop on mw


      enddo  ! loop on i

      return
      end

subroutine rpt3(ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
    ! Riemann solver in the transverse direction for the 3d Burgers' equation
    !    q_t  +  u*(.5*q^2)_x + v*(.5*q^2)_y + w*(.5*q^2)_z = 0
    ! where u,v,w are a given scalars, stored in the vector coeff
    ! that is set in setprob.f and passed in the common block comrp.
    !
    ! On input,
    !
    !    ql,qr is the data along some one-dimensional slice, as in rpn3
    !         This slice is
    !             in the x-direction if ixyz=1,
    !             in the y-direction if ixyz=2, or
    !             in the z-direction if ixyz=3.
    !    asdq is an array of flux differences (A^*\Dq).
    !         asdq(i,:) is the flux difference propagating away from
    !         the interface between cells i-1 and i.
    !    Note that asdq represents B^*\Dq if ixyz=2 or C^*\Dq if ixyz=3.
    !
    !    ixyz indicates the direction of the original Riemann solve,
    !         called the x-like direction in the table below:
    !
    !               x-like direction   y-like direction   z-like direction
    !      ixyz=1:        x                  y                  z         
    !      ixyz=2:        y                  z                  x         
    !      ixyz=3:        z                  x                  y         
    !
    !    icoor indicates direction in which the transverse solve should 
    !         be performed.
    !      icoor=2: split in the y-like direction.
    !      icoor=3: split in the z-like direction.
    !
    !    For example,
    !      ixyz=1, icoor=2 means asdq=A^*\Dq, and should be split in y into
    !                        bmasdq = B^-A^*\Dq,
    !                        bpasdq = B^+A^*\Dq.
    !
    !      ixyz=2, icoor=2 means asdq=B^*\Dq, and should be split in z into 
    !                        bmasdq = C^-B^*\Dq,
    !                        bpasdq = C^+B^*\Dq.
    !
    !    The parameter imp is generally needed only if aux
    !    arrays are being used, in order to access the appropriate
    !    variable coefficients.

    implicit none

    integer, intent(in) :: ixyz, icoor, maxm, meqn, mwaves, mbc, mx, maux, imp

    double precision, intent(in)  :: ql, qr, asdq, aux1, aux2, aux3
    double precision, intent(out) :: bmasdq, bpasdq
    dimension     ql(meqn,1-mbc:maxm+mbc)
    dimension     qr(meqn,1-mbc:maxm+mbc)
    dimension   asdq(meqn,1-mbc:maxm+mbc)
    dimension bmasdq(meqn,1-mbc:maxm+mbc)
    dimension bpasdq(meqn,1-mbc:maxm+mbc)
    dimension   aux1(maux,1-mbc:maxm+mbc,3)
    dimension   aux2(maux,1-mbc:maxm+mbc,3)
    dimension   aux3(maux,1-mbc:maxm+mbc,3)

    double precision :: coeff
    common /cparam/ coeff(3)

    integer :: i, iuvw
    double precision :: sb

    ! set iuvw = 1 for u, 2 for v, 3 for w component of velocity
    ! depending on transverse direction:
    iuvw = ixyz + icoor - 1
    if (iuvw.gt.3) iuvw = iuvw-3

    ! transverse wave goes up or down with speed based on data for
    ! original normal Riemann problem.  

    do i=2-mbc,mx+mbc
        sb = coeff(iuvw) * 0.5d0*(qr(1,i-1) + ql(1,i))
        bmasdq(1,i) = dmin1(sb, 0.d0) * asdq(1,i)
        bpasdq(1,i) = dmax1(sb, 0.d0) * asdq(1,i)
    end do

    return
end subroutine rpt3

! =====================================================
subroutine rpt2_ptwise(ixy, imp, num_eqn, num_aux, num_waves, q_l, q_r,      &
aux_l, aux_r, asdq, bmasdq, bpasdq)
! =====================================================

!     # Riemann solver in the transverse direction for the scalar equation

!     # Split asdq (= A^* \Delta q, where * = + or -)
!     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
!     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)

    implicit none

    ! Input
    integer, intent(in) :: num_eqn, num_aux, num_waves, ixy, imp
    real(kind=8), intent(in) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in) :: aux_l(num_aux), aux_r(num_aux)
    real(kind=8), intent(in out) :: asdq(num_eqn)

    ! Output
    real(kind=8), intent(in out) :: bmasdq(num_eqn), bpasdq(num_eqn)

    ! Local
    real(kind=8) :: stran

    ! Common block
    real(kind=8) :: u, v
    common /cparam/ u, v

!    # transverse wave speeds have been computed in rpn2
!    # maux=0 and aux arrays are unused in this example.

    if (ixy == 1) then
        stran = v
    else
        stran = u
    endif

    bmasdq(1) = dmin1(stran, 0.d0) * asdq(1)
    bpasdq(1) = dmax1(stran, 0.d0) * asdq(1)

    end subroutine rpt2_ptwise

c
c ---------------------------------------------------------------------------------
c
      subroutine domgrid(lbase,lcheck)
c
      use amr_module
      implicit double precision (a-h,o-z)

      mbuff = max(nghost,ibuff+1)
c
!>  loop over base grids to get proper nesting domain for grids at level lcheck
!!  but only upsize to the lcheck grids dimensions
c

      mptr = lstart(lcheck)
 10   continue
      ilo    = node(ndilo,mptr)
      ihi    = node(ndihi,mptr)
      jlo    = node(ndjlo,mptr)
      jhi    = node(ndjhi,mptr)
      nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
c     up to mbuff cells on each side might be flagged and
c     buffered, so to allow shrinkage, need yet one additional
c     cell on each side to be set from base grids
      mibuff = nx + 2*mbuff
      mjbuff = ny + 2*mbuff
      ibytesPerDP = 8

c   bad names, for historical reasons. they are both smae size now
      locdomflags = igetsp( (mibuff*mjbuff)/ibytesPerDP+1)
      locdom2 = igetsp( (mibuff*mjbuff)/ibytesPerDP+1)


      node(domflags_base,mptr) = locdomflags
      node(domflags2,mptr) = locdom2
      call setdomflags(mptr,alloc(locdomflags),ilo,ihi,jlo,jhi,
     .                 mbuff,lbase,lcheck,mibuff,mjbuff)

      mptr = node(levelptr, mptr)
      if (mptr .ne. 0) go to 10

      return
      end

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.

    use geoclaw_module, only: sea_level
    use grid_module, only: xcell

    ! uncomment if any of these needed...
    !use geoclaw_module, only: dry_tolerance, grav

    implicit none

    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    !locals
    integer :: i

    real(kind=8) :: h0, eta, eta_star, x0, ampl, u, u_star, c, kappa, a

    x0 = -9.14d0   ! initial location of wave
    a = 0.259d0  ! dimensionless amplitude
    h0 = 0.218d0  ! depth for scaling
    ampl = a*h0  ! amplitude

    kappa = sqrt(3.d0*a / (4.d0*(a+1.d0)))
    c = sqrt(1.d0 + a)

    do i=1,mx
        eta = ampl / cosh(kappa*(xcell(i) - x0)/h0)**2
        eta_star = eta/h0
        u_star = c * eta_star/(1.d0 + eta_star)
        u = u_star * sqrt(9.81d0*h0)
        q(1,i) = max(sea_level, eta - aux(1,i))
        q(2,i) = q(1,i)*u

   enddo


end subroutine qinit

! =====================================================
subroutine rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! =====================================================

! f-wave Riemann solver for the p-system of Lagrangian compressible gas dynamics in 1d
! Here we assume that the entropy may be spatially varying but constant in time.
! The approach taken is essentially identical to that described in
!
! R. J. LeVeque, 2002, Finite-volume methods for non-linear elasticity in heterogeneous media
!
! The system here is essentially a special case of the one discussed there, with
! \rho(x)=1 and a different equation of state.

!   v_t - u_x = 0
!   u_t + p(v,s(x))_x =0
! where v = specific volume, u = velocity, p=pressure, s=entropy

! waves: 2
! equations: 2
! aux fields: 1

! Conserved quantities:
!       1 specific volume
!       2 velocity

! Auxiliary variables:
!       1 entropy

! function p(v,i) gives pressure in ith cell
! function pp(v,i) gives d/(d v) of pressur

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! On output, fwave contains the waves as jumps in f,
!            s the speeds,
!            amdq = A^- Delta q,
!            apdq = A^+ Delta q,
!                   the decomposition of the flux difference
!                       f(qr(i-1)) - f(ql(i))
!                   into leftgoing and rightgoing parts respectively.
! 

! Note that the ith Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit none

    integer, intent(in) :: maxm, meqn, mwaves, mbc, mx, maux
    double precision, dimension(meqn,1-mbc:maxm+mbc), intent(in) :: ql, qr
    double precision, dimension(maux,1-mbc:maxm+mbc), intent(in) :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxm+mbc), intent(out) :: fwave
    double precision, dimension(meqn, 1-mbc:maxm+mbc), intent(out) :: amdq, apdq
    double precision, dimension(mwaves, 1-mbc:maxm+mbc), intent(out) :: s

    double precision :: enti, entim, Vi, Vim, ui, uim, pi, pim, ci, cim, zi, zim
    double precision :: dp, du, b1, b2
    double precision :: pstar, vstar, gamma
    double precision :: dpdVi, dpdVim
    integer i, m

    common /cparam/  pstar, vstar, gamma

!     # split the jump in q at each interface into waves

    do i = 2-mbc, mx+mbc
        enti = auxl(1,i)
        entim = auxr(1,i-1)
        Vi = ql(1,i)
        Vim = qr(1,i-1)
        ui = ql(2,i)
        uim = qr(2,i-1)

    !        #linearize on each side:

        dpdVi  = -gamma*pstar*vstar*dexp(enti)/(Vi**(gamma+1))
        dpdVim = -gamma*pstar*vstar*dexp(entim)/(Vim**(gamma+1))

        ci = dsqrt(-dpdVi)
        cim = dsqrt(-dpdVim)
        zi = ci
        zim = cim

        du = ui - uim
        pi = pstar*dexp(enti) * (vstar/Vi)**gamma 
        pim = pstar*dexp(entim) * (vstar/Vim)**gamma 
        dp = pi - pim
        b1 = ( dp-zi*du ) / (zim + zi)
        b2 = -(zim*du + dp) / (zim + zi)
    
        fwave(1,1,i) = b1
        fwave(2,1,i) = b1 * zim
        s(1,i) = -cim
    
        fwave(1,2,i) = b2
        fwave(2,2,i) = b2*(-zi)
        s(2,i) = ci

    end do


!     # compute the leftgoing and rightgoing fluctuations:
!     # Note s(1,i) < 0   and   s(2,i) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = fwave(m,1,i)
            apdq(m,i) = fwave(m,2,i)
        end do
    end do

    return
    end subroutine rp1

c
c -------------------------------------------------------------
c
      subroutine stepgrid(q,fm,fp,gm,gp,mitot,mjtot,mbc,dt,dtnew,dx,dy,
     &                  nvar,xlow,ylow,time,mptr,maux,aux,actualstep)
c
c
c ::::::::::::::::::: STEPGRID ::::::::::::::::::::::::::::::::::::
c take a time step on a single grid. overwrite solution array q.
c A modified version of the clawpack routine step2 is used.
c
c return fluxes in fm,fp and gm,gp.
c patch has room for ghost cells (mbc of them) around the grid.
c everything is the enlarged size (mitot by mjtot).
c
c mbc       = number of ghost cells  (= lwidth)
c mptr      = grid number  (for debugging)
c xlow,ylow = lower left corner of enlarged grid (including ghost cells).
c dt         = incoming time step
c dx,dy      = mesh widths for this grid
c dtnew      = return suggested new time step for this grid's soln.
c
c
c
c      This version of stepgrid, stepgrid_geo.f allows output on
c      fgout grids specified in fgout_grids.data
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      use geoclaw_module
      use amr_module
      use fgout_module, only: FGOUT_num_grids, FGOUT_fgrids, 
     &                        FGOUT_tcfmax, fgout_interp, fgout_grid,
     &                        FGOUT_ttol
      implicit double precision (a-h,o-z)

      external rpn2,rpt2



      dimension q(nvar,mitot,mjtot)
      dimension fp(nvar,mitot,mjtot),gp(nvar,mitot,mjtot)
      dimension fm(nvar,mitot,mjtot),gm(nvar,mitot,mjtot)
      dimension aux(maux,mitot,mjtot)
      dimension eta(mitot,mjtot)
c      dimension work(mwork)

      logical :: debug = .false.
      logical :: dump = .false.
      !logical :: dump = .true.
      logical, intent (in) :: actualstep
      type(fgout_grid), pointer :: fgout
      !logical, allocatable :: fgout_interp_needed(:)
      logical :: fgout_interp_needed(FGOUT_num_grids)
      real(kind=8) :: fgout_tnext
c
#ifdef WHERE_AM_I
      write(*,*) "     starting stepgrid grid ",mptr 
#endif
      FGOUT_tcfmax = -rinfinity
      level = node(nestlevel,mptr)


      if (dump) then
         eta = q(1,:,:) + aux(1,:,:)
         write(outunit,*)" at start of stepgrid: dumping grid ",mptr,
     &        "at time ",time
         do i = 1, mitot
         do j = 1, mjtot
!           write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar),
!    .                         (aux(iaux,i,j),iaux=1,maux)
            write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar),eta(i,j)
 545        format(2i4,6e15.7,/,8x,4e15.7)
         end do
         end do
      endif
c
      meqn   = nvar
      mx = mitot - 2*mbc
      my = mjtot - 2*mbc
      maxm = max(mx,my)       !# size for 1d scratch array
      mbig = maxm
      xlowmbc = xlow + mbc*dx
      ylowmbc = ylow + mbc*dy

c     # method(2:7) and mthlim
c     #    are set in the amr2ez file (read by amr)
c
      method(1) = 0
c
c
c     # fluxes initialized in step2
c
C       mwork0 = (maxm+2*mbc)*(12*meqn + mwaves + meqn*mwaves + 2)
C c
C       if (mwork .lt. mwork0) then
C          write(outunit,*) 'CLAW2 ERROR... mwork must be increased to ',
C      &               mwork0
C          write(*      ,*) 'CLAW2 ERROR... mwork must be increased to ',
C      &               mwork0
C          stop
C       endif
c
c     # partition work array into pieces needed for local storage in
c     # step2 routine. Find starting index of each piece:
c
C       i0faddm = 1
C       i0faddp = i0faddm + (maxm+2*mbc)*meqn
C       i0gaddm = i0faddp + (maxm+2*mbc)*meqn
C       i0gaddp = i0gaddm + 2*(maxm+2*mbc)*meqn
C       i0q1d   = i0gaddp + 2*(maxm+2*mbc)*meqn
C       i0dtdx1 = i0q1d + (maxm+2*mbc)*meqn
C       i0dtdy1 = i0dtdx1 + (maxm+2*mbc)
C       i0aux1 = i0dtdy1 + (maxm+2*mbc)
C       i0aux2 = i0aux1 + (maxm+2*mbc)*maux
C       i0aux3 = i0aux2 + (maxm+2*mbc)*maux
C c
C c
C       i0next = i0aux3 + (maxm+2*mbc)*maux    !# next free space
C       mused  = i0next - 1                    !# space already used
C       mwork1 = mwork - mused              !# remaining space (passed to step2)

c
      tc0=time !# start of computational step
      tcf=tc0+dt !# end of computational step

c     Check if fgout interpolation needed before and after step:

      !allocate(fgout_interp_needed(FGOUT_num_grids))

!    !$OMP CRITICAL (FixedGrids)

      do ng=1,FGOUT_num_grids
          fgout => FGOUT_fgrids(ng)
          if (fgout%next_output_index > fgout%num_output) then
              fgout_interp_needed(ng) = .false.
          else
              fgout_tnext = fgout%output_times(fgout%next_output_index)
              fgout_interp_needed(ng) =  
     &          ((fgout%x_low < xlowmbc + mx * dx) .and.
     &           (fgout%x_hi  > xlowmbc) .and.
     &           (fgout%y_low < ylowmbc + my * dy) .and.
     &           (fgout%y_hi  > ylowmbc) .and.
     &           (fgout_tnext >= tc0 - FGOUT_ttol) .and.
     &           (fgout_tnext <= tcf + FGOUT_ttol))
          endif
c         write(6,*) '+++ level, before- tc0,tcf,needed: ',
c    &                level,tc0,tcf,fgout_interp_needed(ng)
c         write(6,*) '+++ next index: ',fgout%next_output_index
c         write(6,*) '+++ fgout_tnext, tcf + FGOUT_ttol: ',
c    &                fgout_tnext, tcf + FGOUT_ttol
      enddo
!      !$OMP END CRITICAL (FixedGrids)


c::::::::::::::::::::::::fgout Output:::::::::::::::::::::::::::::::::
c     This has been moved to tick.f, after advancing all patches on 
c     finest level.  No need to check on each patch separately.
c::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       call b4step2(mbc,mx,my,nvar,q,
     &             xlowmbc,ylowmbc,dx,dy,time,dt,maux,aux,actualstep)
      
c::::::::::::::::::::::::FGOUT DATA before step:::::::::::::::::::::::
c     # fill in values at fgout points affected at time tc0
      do ng=1,FGOUT_num_grids
          if (fgout_interp_needed(ng)) then
c            # fgout grid ng has an output time within [tc0,tcf] interval
c        # and it overlaps this computational grid spatially
             fgout => FGOUT_fgrids(ng)
!$OMP        CRITICAL (FixedGrids)
c            write(6,*) '+++ fout_interp(1), tc0, level: ',tc0,level
             call fgout_interp(1,fgout,tc0,q,nvar,mx,my,mbc,
     &                         dx,dy,xlowmbc,ylowmbc,maux,aux)

!$OMP       END CRITICAL (FixedGrids)
      endif
      enddo
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c     New fixed grid stuff: Update fixed grid info from this patch...

      call fgmax_frompatch(mx,my,nvar,mbc,maux,q,aux,
     &     dx,dy,xlowmbc,ylowmbc,level,time,time+dt)
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c     # take one step on the conservation law:
c
      call step2(mbig,nvar,maux,
     &           mbc,mx,my,
     &              q,aux,dx,dy,dt,cflgrid,
     &              fm,fp,gm,gp,rpn2,rpt2)
c
c            
        mptr_level = node(nestlevel,mptr)

c       write(outunit,811) mptr, mptr_level, cflgrid
c811    format(" Courant # of grid ",i5," level",i3," is ",d12.4)
c

!$OMP  CRITICAL (cflm)

        cflmax = dmax1(cflmax,cflgrid)
        cfl_level = dmax1(cfl_level,cflgrid)

!$OMP END CRITICAL (cflm)

c
!        write(outunit,*)" updating grid ", mptr
c       # update q
        dtdx = dt/dx
        dtdy = dt/dy
         if (mcapa.eq.0) then
          do 50 j=mbc+1,mjtot-mbc
          do 50 i=mbc+1,mitot-mbc
          do 50 m=1,nvar
c
c            # no capa array.  Standard flux differencing:

           q(m,i,j) = q(m,i,j)
     &           - dtdx*(fm(m,i+1,j) - fp(m,i,j))
     &           - dtdy*(gm(m,i,j+1) - gp(m,i,j))
 50       continue
         else
          do 51 j=mbc+1,mjtot-mbc
          do 51 i=mbc+1,mitot-mbc
          do 51 m=1,nvar
c            # with capa array.
           q(m,i,j) = q(m,i,j)
     &           - (dtdx * (fm(m,i+1,j) - fp(m,i,j))
     &           +  dtdy * (gm(m,i,j+1) - gp(m,i,j))) / aux(mcapa,i,j)
 51       continue
!           write(outunit,543) m,i,j,q(m,i,j),fm(m,i+1,j),fp(m,i,j),
!     .        gm(m,i,j+1), gp(m,i,j)
543       format(3i4,5e25.16)

         endif

c 50      continue
c
c     # Copied here from b4step2 since need to do before saving to qc1d:
      forall(i=1:mitot, j=1:mjtot, q(1,i,j) < dry_tolerance)
        q(1,i,j) = max(q(1,i,j),0.d0)
        q(2:meqn,i,j) = 0.d0
      end forall
c
      if (method(5).eq.1) then
c        # with source term:   use Godunov splitting
         call src2(nvar,mbc,mx,my,xlowmbc,ylowmbc,dx,dy,
     &             q,maux,aux,time,dt)
         endif

c     ::::::::::::::::::::::::fgout data afterstep:::::::::::::::::::::::
c     # fill in values at fgout points affected at time tcf
      do ng=1,FGOUT_num_grids
          if (fgout_interp_needed(ng)) then
c            # fgout grid ng has an output time within [tc0,tcf] interval
c        # and it overlaps this computational grid spatially
!$OMP        CRITICAL (FixedGrids)
             fgout => FGOUT_fgrids(ng)
c            write(6,*) '+++ fout_interp(2), tcf, level: ',tcf,level
             call fgout_interp(2,fgout,tcf,q,nvar,mx,my,mbc,
     &                         dx,dy,xlowmbc,ylowmbc,maux,aux)

!$OMP       END CRITICAL (FixedGrids)
      endif
c        write(6,*) '+++ level,after- tc0,tcf,needed: ',
c    &                level,tc0,tcf,fgout_interp_needed(ng)
c        write(6,*) '+++ next index: ',fgout%next_output_index
c        write(6,*) '+++ fgout_tnext: ',fgout_tnext
      enddo
c     :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


c     # output fluxes for debugging purposes:
      if (debug) then
         write(dbugunit,*)" fluxes for grid ",mptr
         do 830 i = mbc+1, mitot-1
            do 830 j = mbc+1, mjtot-1
               write(dbugunit,831) i,j,fm(1,i,j),fp(1,i,j),
     .                                 gm(1,i,j),gp(1,i,j)
               do 830 m = 2, meqn
                  write(dbugunit,832) fm(m,i,j),fp(m,i,j),
     .            gm(m,i,j),gp(m,i,j)
  831          format(2i4,4d16.6)
  832          format(8x,4d16.6)
  830    continue
      endif

c
c
c For variable time stepping, use max speed seen on this grid to
c choose the allowable new time step dtnew.  This will later be
c compared to values seen on other grids.
c
       if (cflgrid .gt. 0.d0) then
           dtnew = dt*cfl/cflgrid
         else
c          # velocities are all zero on this grid so there's no
c          # time step restriction coming from this grid.
            dtnew = rinfinity
          endif

c     # give a warning if Courant number too large...
c
      if (cflgrid .gt. cflv1) then
            write(*,810) cflgrid,cflv1,mptr,mptr_level
            write(outunit,810) cflgrid, cflv1,mptr,mptr_level
  810       format('*** WARNING *** Courant number  =', d12.4,
     &              '  is larger than input cfl_max = ', d12.4,
     &              '  on grid ',i3, ' level ',i3)
            endif
c
      if (dump) then
         eta = q(1,:,:) + aux(1,:,:)
         write(outunit,*)" at end of stepgrid: dumping grid ",mptr,
     &        "at time ",time
         do i = mbc+1, mitot-mbc
         do j = mbc+1, mjtot-mbc
            write(outunit,545) i,j,(q(ivar,i,j),ivar=1,nvar),eta(i,j)
c            write(*,545) i,j,(q(i,j,ivar),ivar=1,nvar)
         end do
         end do
      endif

#ifdef WHERE_AM_I
      write(*,*) "     ending   stepgrid grid ",mptr 
#endif
      return
      end

c
!> Takes flagged points on all grids on level lcheck
!! and pack their (i,j) cell centered
!! indices into the badpts array.
!! Points in the badpts array are unique and sorted based on
!! one dimensional packing of their 2D indices.
c
c -----------------------------------------------------------
c
      subroutine colate2 (badpts, len, lcheck, nUniquePts, lbase)
c
      use amr_module
      implicit  double precision (a-h,o-z)
      dimension badpts(2,len)
      dimension ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)
      logical db/.false./
      integer*8 largestIntEquiv,ifac1,ifac2
      integer   largestIntEquiv_default

c
c    index for flag array now based on integer index space, not 1:mibuff,1:mjbuff
c    but if grid extends outside domain, not supposed to have flagged points
      iadd(i,j) = locamrflags + i-(ilo-mbuff) + mibuff*(j-(jlo-mbuff))
c
c
c *************************************************************
c
c colate2 = takes each grids flagged points at level lcheck
c          and puts their (i,j) cell centered
c          indices into the badpts array.
c          To insure proper nesting, must get rid of flagged points
c          that dont fit into properly nested domain. Grids
c          with flagged points include buffered region (size mbuff)now.
c          THIS NEW VERSION may have duplicate points. need to sort
c          and remove when colating.
c
c if checking flagged pt for nesting is expensive, might consider not doing it
c and revising projec2 instead. if new fine grid not nested, then go through
c flagged points and throw out. But presumably many grids will make it through
c without having to check all points.
c
c *************************************************************
c
c domain flags corresponding to each grid have already been set up.
c colate will check that flagged points nested or throw away
c
       mbuff = max(nghost,ibuff+1)  ! new way of expanding grid to do buffering in place
       index = 0  ! for putting into badpts array


      mptr = lstart(lcheck)
 10      continue
c        write(outunit,*)" colating flags on grid ",mptr

c        handle each of 4 sides (in 2D)
c        set tags to negative val. reset to positive if they have a home
         ilo = node(ndilo,mptr)
         ihi = node(ndihi,mptr)
         jlo = node(ndjlo,mptr)
         jhi = node(ndjhi,mptr)
         nx = ihi - ilo + 1
         ny = jhi - jlo + 1
         mibuff = nx + 2 *mbuff
         mjbuff = ny + 2 *mbuff


         locamrflags = node(storeflags,mptr)
         if (node(numflags,mptr) .eq. 0) go to 70    !simple bypass if no tags


c
c  more conservative alg. uses entire buffer in flagging
            jmin =  jlo-mbuff
            jmax =  jhi+mbuff
            imin =  ilo-mbuff
            imax =  ihi+mbuff
            if (.not. xperdom) then
              imin = max(imin,0)
              imax = min(ihi+mbuff,iregsz(lcheck)-1)
            endif
            if (.not. yperdom) then
              jmin = max(jmin,0)
              jmax = min(jhi+mbuff,jregsz(lcheck)-1)
            endif
c
c  but to match old alg. use only this one. (not exactly the same? since
c  old alg. used one level?)

c            jmin = max(jlo-mbuff,0)
c            jmax = min(jhi+mbuff,jregsz(lcheck)-1)
c            imin = max(ilo-mbuff,0)
c            imax = min(ihi+mbuff,iregsz(lcheck)-1)

c do we still need setPhysBndry????
c         call setPhysBndry(alloc(locamrflags),ilo,ihi,jlo,jhi,
c     .                     mbuff,lcheck)
c     pass loop bounds to keep consistent
c     need this next subr. to do integer indexing for iflags
c
         call flagcheck(alloc(locamrflags),ilo,ihi,jlo,jhi,mbuff,
     .                  alloc(node(domflags2,mptr)),
     .                  imin,imax,jmin,jmax,mptr)


             do 61 j = jmin, jmax
             do 60 i = imin, imax

c             neg means no home was found. throw out
             if (alloc(iadd(i,j)) .lt. 0) then
                  write(outunit,939) i,j
 939              format("NOT NESTED: ignoring point ",2i5)
                  write(*,*)" still have neg points"
                  go to 60
             endif
             if (alloc(iadd(i,j)) .le. DONTFLAG) go to 60
c
c    got a legit flagged point, bag it.
c
             index = index + 1
c  WARNING: to match orig program note we ADD .5, not subtract. old program used 1 based indexing
c  for grid flagging array. we are using 0 based, so need to add to match previous
c  grid fitting (dont want to change all routines downstream)
c
c  for periodic domains, if flagged pt in buffer zone outside domain
c   wrap it periodically back in before putting on list
              iwrap = i
              if (xperdom) then
                 if (i .lt. 0) iwrap = i + iregsz(lcheck)
                 if (i .ge. iregsz(lcheck)) iwrap = i - iregsz(lcheck)
              endif
              jwrap = j
              if (yperdom) then
                 if (j .lt. 0) jwrap = j + jregsz(lcheck)
                 if (j .ge. jregsz(lcheck)) jwrap = j - jregsz(lcheck)
              endif
c             adding .5 to make it cell centered integer coords
c             note that previous code subtracted .5 since it used 1 based indexing
              badpts(1,index) = dble(iwrap)+.5   ! in case periodic, put flagged buffer pt
              badpts(2,index) = dble(jwrap)+.5   ! in badpts in wrapped coords
             if (db) write(outunit,101) badpts(1,index), badpts(2,index)
 101          format(2f6.1)

 60        continue
 61        continue

 65         continue
 66         continue

c
 70     continue

c  done colating - safe to reclam
        call reclam(locamrflags,mibuff*mjbuff)

        ibytesPerDP = 8
        iflagsize =  (mibuff*mjbuff)/ibytesPerDP+1
        call reclam(node(domflags_base,mptr),iflagsize)
        call reclam(node(domflags2,mptr),iflagsize)

c
        mptr = node(levelptr, mptr)
       if (mptr .ne. 0) go to 10


      npts = index
      if (gprint) then
        write(outunit,100) npts, lcheck,len
 100    format( i9,' flagged points initially colated on level ',i4,
     .        " badpts len = ",i10)
      endif
c
c colate flagged points into single integer array for quicksorting
c
c     sorting uses one dimensional packing of 2D indices
c     check if domain will fit  in integer*4.  (largestSingle approx 2**30)
c     if not, just leave the duplicate, but rememer that efficiency
c     of grids won't be correct (since divide by number of flaged pts in grid)
c     If necessary, do whole process in integer*8 - then will have enough
c     room, but will have to convert quicksort routine and drivesort
c     the variable largestIntEquiv already declared integer*8 above.
      ifac1 = iregsz(lcheck)
      ifac2 = jregsz(lcheck)
      largestIntEquiv =  ifac1+mbuff +
     .             (ifac1+2*mbuff)*(ifac2+mbuff)
      largestIntEquiv_default =  iregsz(lcheck)+mbuff +
     .             (iregsz(lcheck)+2*mbuff)*(jregsz(lcheck)+mbuff)

c     ! if get different answer with extra precision then bypass sorting alg.
      if (largestIntEquiv .ne. largestIntEquiv_default) then
c       ## sorting alg will have integer overflow
c       ## just use all flagged points in making grids
c       ## this means "efficiency" count will be incorrect for
c       ## this and higher levels
          nUniquePts =  npts  ! bad name - they are not unique
      else
          call drivesort(npts,badpts,lcheck,nUniquePts,mbuff)
      endif


 99   return
      end

c
c
c     =====================================================
      subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,
     &                  wave,s,amdq,apdq)
c     =====================================================
c
c     # Solve Riemann problems for the 2D hyperbolic problem.
c
c     # This is a wrapper for a 1d Riemann solver rp1 so that it
c     # can be used with AMR by using the 2d amrclaw routines with my=1.
c
      implicit double precision (a-h,o-z)
c
      dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
      dimension    s(mwaves, 1-mbc:maxm+mbc)
      dimension   ql(meqn, 1-mbc:maxm+mbc)
      dimension   qr(meqn, 1-mbc:maxm+mbc)
      dimension  apdq(meqn, 1-mbc:maxm+mbc)
      dimension  amdq(meqn, 1-mbc:maxm+mbc)
c
      if (ixy.eq.2) then
c        write(6,*) '*** Error, this Riemann solver should only be used'
c        write(6,*) '*** for a 1d problem with my=1'
c        write(6,*) '*** ixy=2 and my = ',mx
c        stop
         endif

      call rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,
     &                  wave,s,amdq,apdq)

      return
      end

c
c -------------------------------------------------------------------
      subroutine flag2refine(mx,my,mz,mbc,meqn,maux,xlower,ylower,
     &      zlower,dx,dy,dz,t,
     &      level,tolsp,q,aux,amrflags,DONTFLAG,DOFLAG)
c     ------------------------------------------------------------------
c     -

c
c     ::::::::::::::::::::: flag2refine
c     ::::::::::::::::::::::::::::::::::
c
c     User routine to control flagging of points for refinement.
c
c     Default version computes spatial difference dq in each direction
c     and
c     for each component of q and flags any point where this is greater
c     than
c     the tolerance tolsp.  This is consistent with what the routine
c     errsp did in
c     earlier versions of amrclaw (4.2 and before).
c
c     This routine can be copied to an application directory and
c     modified to
c     implement some other desired refinement criterion.
c
c     The logical function allowflag(x,y,t,level) is called to check
c     whether
c     further refinement at this level is allowed at this particular
c     location
c     and time.  The default library version of this routine returns
c     .true.
c     for all arguments.  Copy that routine to the application directory
c     and
c     modify it if needed to restrict the region where refinement is
c     allowed.
c
c     Points may also be flagged for refining based on a Richardson
c     estimate
c     of the error, obtained by comparing solutions on the current grid
c     and a
c     coarsened grid.  Points are flagged if the estimated error is
c     larger than
c     the parameter tol in amr2ez.data, provided tol>0.  If tol<=0 then
c     the coarsening and Richardson estimation is not performed!
c     This is a change from previous versions (4.2 and before) of
c     amrclaw.
c     Note: in previous versions, the routine errf1 used a function
c     allowed(x,y,level) that has been replaced by the allowflag.  This
c     new
c     function is also used in Richardson estimation if that is invoked.
c
c
c     q   = grid values including ghost cells (bndry vals at specified
c     time have already been set, so can use ghost cell values too)
c
c     aux   = aux array on this grid patch
c
c     amrflags  = array to be flagged with either the value
c     DONTFLAG (no refinement needed)  or
c     DOFLAG   (refinement desired)
c
c     tolsp = tolerance specified by user in input file amr2ez.data,
c     used in default
c     version of this routine as a tolerance for spatial differences.

c     ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      implicit none

      integer mx,my,mz,mbc,meqn,maux
      double precision xlower, ylower, zlower, dx,dy,dz,t, tolsp
      double precision DONTFLAG, DOFLAG
      integer level
      double precision q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      double precision aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      double precision amrflags(1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      logical  allowflag
      external allowflag

      integer m,i,j,k
      double precision x,y,z
      double precision dp(3), dpi, dpj, dpk, pf,dpmax


c     # loop over interior points on this grid:
      do 30 k = 1,mz
         z = zlower + (k-0.5d0)*dz

         do 20 j = 1,my
            y = ylower + (j-0.5d0)*dy
            do 10 i = 1,mx
               x = xlower + (i-0.5d0)*dx

               amrflags(i,j,k) = DONTFLAG

c               if (allowflag(x,y,z,t,level)) then

c                 # check to see if we should flag this point for
c                 refinement.
c                 # Here the default test is taken from errsp.f in
c                 previous
c                 # versions of amrclaw -- flag this point if dq >
c                 tolsp:

                 dp(1) = pf(q(1,i+1,j,k)) - pf(q(1,i-1,j,k))
                 dp(2) = pf(q(1,i,j+1,k)) - pf(q(1,i,j-1,k))
                 dp(3) = pf(q(1,i,j,k+1)) - pf(q(1,i,j,k-1))

                 dpmax = 0.0
                 do m = 1,3
                    dpmax  = max(abs(dp(m)), dpmax)
                 enddo

                 if (abs(dpmax) .gt. tolsp) then
                    amrflags(i,j,k) = DOFLAG
                 endif

c               endif

   10          continue
   20       continue
   30    continue

         return
         end


      double precision function pf(q)
      implicit none

      double precision q(5)
      double precision press, mom2, e, rho

      double precision gamma, gamma1
      common /cparam/  gamma, gamma1

      rho = q(1)
      mom2 = q(2)**2  + q(3)**2 + q(4)**2
      pf = gamma1*(q(5) - 0.5d0*mom2/rho)


      end

!
! :::::::::::::::::::::::::: UPDATE :::::::::::::::::::::::::::::::::
! update - update all grids at level 'level'.
!          this routine assumes cell centered variables.
!          the update is done from 1 level finer meshes under it.
! input parameter:
!    level  - ptr to the only level to be updated. levels coarser than
!             this will be at a diffeent time.
! rewritten in July 2016 from the original update.f
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!

subroutine update (level, nvar, naux)

    use geoclaw_module, only: sea_level, rho
    use amr_module

    use multilayer_module, only: num_layers, dry_tolerance, eta_init

    implicit none
    ! modified for shallow water on topography to use surface level eta
    ! rather than depth h = q(i,j,1) 
    ! eta - q(i,j,1) + aux(i,j,1)

    ! inputs
    integer, intent(in) :: nvar, naux, level

    integer :: ng, levSt, mptr, loc, locaux, nx, ny, mitot, mjtot
    integer :: ilo, jlo, ihi, jhi, mkid, iclo, jclo, ichi, jchi
    integer :: mi, mj, locf, locfaux, iplo, jplo, iphi, jphi
    integer :: iff, jff, nwet(num_layers), ico, jco, i, j, ivar, loccaux, lget
    integer :: listgrids(numgrids(level)), layer, i_layer
    real(kind=8) :: dt, totrat, bc, etasum(num_layers), hsum(num_layers)
    real(kind=8) :: husum(num_layers), hvsum(num_layers)
    real(kind=8) :: hf, bf, huf, hvf, etaf, hav(num_layers), hc(num_layers)
    real(kind=8) :: huc(num_layers), hvc(num_layers), capa, etaav(num_layers)
    real(kind=8) :: capac
    character(len=80) :: String

    lget = level

    String = "(19h    updating level ,i5)"
    
    if (uprint) then
        write(outunit, String) lget
    endif

    dt = possk(lget)

    ! need to set up data structure for parallel distribution of grids
!     call prepgrids(listgrids, numgrids(level), level)


!$OMP PARALLEL DO PRIVATE(ng,mptr,loc,loccaux,nx,ny,mitot,mjtot, &
!$OMP                    ilo,jlo,ihi,jhi,mkid,iclo,ichi, &
!$OMP                    jclo,jchi,mi,mj,locf,locfaux,iplo,iphi, &
!$OMP                    jplo,jphi,iff,jff,totrat,i,j,ivar,capac, &
!$OMP                    capa,bc,etasum,hsum,husum,hvsum, &
!$OMP                    levSt,ico,jco,hf,bf,huf,hvf, &
!$OMP                    etaf,etaav,hav,nwet,hc,huc,hvc, String), &
!$OMP             SHARED(numgrids,listOfGrids,level,intratx,intraty, &
!$OMP                   nghost,uprint,nvar,naux,mcapa,node,listsp, &
!$OMP                   alloc,lstart,dry_tolerance,listStart,lget, &
!$OMP                   num_layers, rho, eta_init), &
!$OMP            DEFAULT(none)


    do ng = 1, numgrids(lget)
        levSt   = listStart(lget)
        mptr    = listOfGrids(levSt+ng-1)
        loc     = node(store1,mptr)
        loccaux = node(storeaux,mptr)
        nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot   = nx + 2*nghost
        mjtot   = ny + 2*nghost
        ilo     = node(ndilo,mptr)
        jlo     = node(ndjlo,mptr)
        ihi     = node(ndihi,mptr)
        jhi     = node(ndjhi,mptr)

        if (node(cfluxptr, mptr) /= 0) then
            call upbnd(alloc(node(cfluxptr,mptr)),alloc(loc),nvar,naux,mitot, &
                    mjtot,listsp(lget),mptr)
        endif

        mkid = lstart(lget+1)
        do while (mkid /= 0)
            iclo   = node(ndilo,mkid)/intratx(lget)
            jclo   = node(ndjlo,mkid)/intraty(lget)
            ichi   = node(ndihi,mkid)/intratx(lget)
            jchi   = node(ndjhi,mkid)/intraty(lget)
            mi      = node(ndihi,mkid)-node(ndilo,mkid) + 1 + 2*nghost
            mj      = node(ndjhi,mkid)-node(ndjlo,mkid) + 1 + 2*nghost
            locf    = node(store1,mkid)
            locfaux = node(storeaux,mkid)

            ! calculate the starting adn ending indices for coarse grid update, if overlap
            iplo = max(ilo,iclo)
            jplo = max(jlo,jclo)
            iphi = min(ihi,ichi)
            jphi = min(jhi,jchi)        

            if (iplo <= iphi .and. jplo <= jphi) then
                !calculate the starting index for the fine grid source pts.
                iff    = iplo*intratx(lget) - node(ndilo,mkid) + nghost + 1
                jff    = jplo*intraty(lget) - node(ndjlo,mkid) + nghost + 1
                totrat = intratx(lget) * intraty(lget)

                do i = iplo-ilo+nghost+1, iphi-ilo+nghost+1
                    do j = jplo-jlo+nghost+1, jphi-jlo+nghost+1
                        if (uprint) then
                            String = "(' updating pt. ',2i4,' of grid ',i3,' using ',2i4,' of grid ',i4)"
                            write(outunit,String) i,j,mptr,iff,jff,mkid                
                            
                            String = "(' old vals: ',4e25.15)"
                            write(outunit,String)(alloc(iadd(ivar,i,j,loc,mitot)),ivar=1,nvar)
                        endif
                        
                        if (mcapa == 0) then
                            capac = 1.0d0
                        else
                            capac = alloc(iaddcaux(i,j,loccaux,mcapa,mitot))
                        endif

                        bc = alloc(iaddctopo(i,j,loccaux,mitot))

                        etasum = 0.d0
                        hsum = 0.d0
                        husum = 0.d0
                        hvsum = 0.d0

                        nwet = 0

                        do jco = 1, intraty(lget)
                            do ico = 1, intratx(lget)
                                    
                                if (mcapa == 0) then
                                    capa = 1.0d0
                                else
                                    capa = alloc(iaddfaux(iff+ico-1,jff+jco-1,locfaux,mcapa,mi))
                                endif
                                
                                bf = alloc(iaddftopo(iff+ico-1,jff+jco-1,locfaux,mi))*capa
                                
                                do layer = num_layers, 1, -1

                                    hf = alloc(iaddf(3*layer-2,iff+ico-1,jff+jco-1,locf,mi))*capa / rho(layer)
                                    huf= alloc(iaddf(3*layer-1,iff+ico-1,jff+jco-1,locf,mi))*capa 
                                    hvf= alloc(iaddf(3*layer,iff+ico-1,jff+jco-1,locf,mi))*capa 

                                    if ( alloc(iaddf(3*layer-2,iff+ico-1,jff+jco-1,locf,mi))/rho(layer) &
                                        > dry_tolerance(layer)) then
                                        etaf = hf + bf
                                        nwet(layer) = nwet(layer) + 1
                                    else
                                        ! Set to zero for correct averages below.
                                        etaf = 0.d0
                                        huf=0.d0
                                        hvf=0.d0
                                    endif

                                    hsum(layer)   = hsum(layer) + hf
                                    husum(layer)  = husum(layer) + huf
                                    hvsum(layer)  = hvsum(layer) + hvf
                                    etasum(layer) = etasum(layer) + etaf  

                                    bf = bf + hf   
                                enddo
                            enddo
                        enddo

                        do layer = num_layers, 1, -1
                            if (nwet(layer) > 0) then
                                etaav(layer) = etasum(layer)/dble(nwet(layer))
                                hav(layer) = hsum(layer)/dble(nwet(layer))
                                hc(layer) = min(hav(layer), (max(etaav(layer)-bc*capac, 0.0d0)))
                                huc(layer) = (min(hav(layer), hc(layer)) / hsum(layer) * husum(layer))
                                hvc(layer) = (min(hav(layer), hc(layer)) / hsum(layer) * hvsum(layer))
                            else
                                hc(layer) = 0.0d0
                                huc(layer) = 0.0d0
                                hvc(layer) = 0.0d0
                            endif

                            alloc(iadd(3*layer-2,i,j,loc,mitot)) = hc(layer) / capac * rho(layer)
                            alloc(iadd(3*layer-1,i,j,loc,mitot)) = huc(layer) / capac 
                            alloc(iadd(3*layer,i,j,loc,mitot)) = hvc(layer) / capac 

                            bc = bc + hc(layer)
                        enddo

                        if (uprint) then
                            String = "(' new vals: ',4e25.15)"
                            write(outunit, String)(alloc(iadd(ivar, i, j,loc,mitot)), ivar=1, nvar)
                        endif

                        jff = jff + intraty(lget)
                    enddo

                    iff = iff + intratx(lget)
                    jff = jplo * intraty(lget) - node(ndjlo, mkid) + nghost + 1
                enddo

                
            endif
            mkid = node(levelptr, mkid)

        enddo
    enddo
!$OMP END PARALLEL DO
    return


contains

    integer pure function iadd(ivar,i,j,loc,mitot)
        integer, intent(in) :: i, j, ivar, loc, mitot
        iadd = loc + ivar-1 + nvar*((j-1)*mitot+i-1)
    end function iadd

    integer pure function iaddf(ivar,i,j,locf,mi)
        integer, intent(in) :: i, j, ivar, locf, mi
        iaddf = locf   + ivar-1 + nvar*((j-1)*mi+i-1)
    end function iaddf

    integer pure function iaddfaux(i,j,locfaux,mcapa,mi)
        integer, intent(in) :: i, j, locfaux, mcapa, mi
        iaddfaux = locfaux + mcapa-1 + naux*((j-1)*mi + (i-1))
    end function iaddfaux

    integer pure function iaddcaux(i,j,loccaux,mcapa,mitot)
        integer, intent(in) :: i, j, loccaux, mcapa, mitot
        iaddcaux = loccaux + mcapa-1 + naux*((j-1)*mitot+(i-1))
    end function iaddcaux

    integer pure function iaddftopo(i,j,locfaux,mi)
        integer, intent(in) :: i, j, locfaux, mi
        iaddftopo = locfaux + naux*((j-1)*mi + (i-1))
    end function iaddftopo

    integer pure function iaddctopo(i,j,loccaux, mitot)
        integer, intent(in) :: i, j, loccaux, mitot
        iaddctopo = loccaux + naux*((j-1)*mitot+(i-1))
    end function iaddctopo

end subroutine

real(kind=8) pure function qtrue(x, y, t)

    implicit none

    ! Input
    real(kind=8), intent(in) :: x, y, t

    ! Locals
    real(kind=8) :: x0, y0, r

    ! Common block
    real(kind=8) :: ubar, vbar
    common /cparam/ ubar,vbar
      
    x0 = x - ubar * t
    y0 = y - vbar * t

    ! evaluate desired initial data at (x0,y0):
    r = sqrt((x0 + 0.2d0)**2 + (y0 - 0.4d0)**2)
    if (r <= 0.3d0) then
        qtrue = 1.d0
    else
        qtrue = 0.d0
    endif

    r = sqrt((x0 - 0.3d0)**2 + (y0 - 0.1d0)**2)
    qtrue = qtrue - exp(-15.d0 * r**2)

end function qtrue

c     ============================================
      subroutine setaux(mbc,mx,my,xlower,ylower,dx,dy,
     &                  maux,aux)
c     ============================================
c
c     # set auxiliary arrays 

c     #   aux(1,i,j) is edge velocity at "left" boundary of grid point (i,j)
c     #   aux(2,i,j) is edge velocity at "bottom" boundary of grid point (i,j)
c     #   aux(3,i,j) is kappa if a mapped grid is used.

c
c     
      implicit double precision (a-h,o-z)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
c
c     # constant velocities which are used if tperiod=0 is specified
c     # in setprob.data

      do 20 i=1-mbc,mx+mbc
         do 20 j=1-mbc,my+mbc

c           # coordinates of lower left corner of grid cell:
            xll = xlower + (i-1)*dx
            yll = ylower + (j-1)*dy

c           # difference stream function psi to get normal velocities:
            aux(1,i,j) = -(psi(xll, yll+dy) - psi(xll,yll)) / dy
            aux(2,i,j) =  (psi(xll+dx, yll) - psi(xll,yll)) / dx
   20       continue

c
       return
       end

! ============================================================================
!  Program:     AMRClaw
!  File:        restrt_nodes.f90
!  Created:     2018-06-15
!  Author:      Marsha Berger
! ============================================================================
!  Description:  Initialization of nodal storage for restart
! ============================================================================


subroutine restrt_nodes(isize)

    use amr_module
    implicit none
    integer :: isize

    maxgr = isize

    if (.not.allocated(rnode)) then     ! allocatable nodal arrays now 
        write(6,*)"allocating ",maxgr," -sized rnode array"
        allocate(rnode(rsize,maxgr))
        print *, "rnode storage allocated of size ",maxgr," at restart"
    else
        print *, "rnode storage already allocated!"
    endif

    if (.not.allocated(node)) then     ! allocatable nodal arrays now 
        write(6,*)"allocating ",maxgr," -sized node array"
        allocate(node(nsize,maxgr))
        print *, "node storage allocated of size ",maxgr," at restart"
    else
        print *, "node storage already allocated!"
    endif

    if (.not.allocated(listOfGrids)) then     ! allocatable nodal arrays now 
        write(6,*)"allocating ",maxgr," -sized listOfGrids "
        allocate(listOfGrids(maxgr))
        print *, "listOfGrids allocated of size ",maxgr," at restart"
    else
        print *, "listOfGrids already allocated!"
    endif

end subroutine restrt_nodes

c
c ------------------------------------------------------------
c
       subroutine cstore(qc,nrow,nvar,qc1d,lenbc,naux,auxc,auxc1d)

       implicit double precision (a-h, o-z)

       dimension qc(nvar,nrow)
       dimension qc1d(nvar,lenbc)
       dimension auxc(naux,nrow)
       dimension auxc1d(naux,lenbc)
c
c      store coarse perimeter worth of solution into 1d array.
c      go around fine grid in following order
c        1 |          | 2
c
c  save first interior cell of enlarged grid corresponding to
c  fine grid bordering cell. note that since fine grid is smaller,
c  the cell is one in. coarse (temporary) grid has no ghost cells

c      side 1
       index = 0

        index = index + 1
        do 5 ivar = 1, nvar
 5         qc1d(ivar,index) = qc(ivar,1)
        do 6 iaux = 1, naux
 6         auxc1d(iaux,index) = auxc(iaux,1)

c      side 2
        index = index + 1
        do 25 ivar = 1, nvar
 25        qc1d(ivar,index) = qc(ivar,nrow)
        do 26 iaux = 1, naux
 26        auxc1d(iaux,index) = auxc(iaux,nrow)

       return
       end

subroutine b4step1(maxmx,mbc,mx,meqn,q,xlower,dx,t,dt,maux,aux)

    use parameters_module

    implicit none
    
    ! Arguments
    integer, intent(in) :: maxmx,mbc,mx,meqn,maux
    double precision, intent(in) :: xlower,dx,t,dt
    double precision, intent(inout) :: q(1-mbc:maxmx+mbc,meqn)
    double precision, intent(inout) :: aux(1-mbc:maxmx+mbc,maux)
    
    ! Locals
    integer :: i,m,layer_index
    double precision :: h(2),u(2)
    double precision, parameter :: RICH_TOLERANCE = 0.95d0
    
    ! negative values to 0
    do m=1,4,2
        do i=1,mx
            if (q(i,m) < 0.d0) then
                q(i,m) = 0.d0
            endif
        enddo
    enddo
    
    ! Calculate wind field
    call set_wind(maxmx,mbc,mx,xlower,dx,t,aux(:,2))
    
    ! Calculate kappa
    do i=1,mx
        do m=1,2
            layer_index = 2*(m-1)
            h(m) = q(i,layer_index+1) / rho(m)
            if (h(m) < dry_tolerance) then
                u(m) = 0.d0
            else
                u(m) = q(i,layer_index+2) / q(i,layer_index+1)
            endif
        enddo
        aux(i,5) = (u(1)-u(2))**2 / (g*one_minus_r*sum(h))
        if ((aux(i,5) > RICH_TOLERANCE).and.(.not.h(2) < dry_tolerance)) then
            print "(a,i4,a,d16.8)","Hyperbolicity may have failed, kappa(",i,") = ",aux(i,5)
        endif
    enddo
    
end subroutine b4step1

c
c -----------------------------------------------------
c
       subroutine compressOut(vals,rowPtr,cols,numBoussCells,numColsTot)

       use bouss_module

       implicit none
       integer numBoussCells, numColsTot
       integer rowPtr(0:2*numBoussCells), cols(0:24*numBoussCells)
       real*8  vals(0:24*numBoussCells)
       integer isrc,idest,icount12

c  compress out the -1 indices in cols, which indicates no entries
c  vals follow cols. Adjust rowPtr as needed along the way. 

        idest = 0
        icount12 = 0
        do isrc = 0, 24*numBoussCells-1
           if (icount12 .eq. 0) rowPtr(isrc/12) = idest
           if (cols(isrc) .ne. -1) then
              cols(idest) = cols(isrc)
              vals(idest) = vals(isrc)
              idest = idest + 1
           endif
           icount12 = icount12 + 1
           if (icount12 .eq. 12) icount12 = 0
        end do

        numColsTot = idest
        ! last entry for rowPtr set on return

        return
        end

!
! :::::::::::::::::::::::: TRIMBD :::::::::::::::::::::::::::;
!  if used array is completely set (=1.) then return set=true, 
!  otherwise return false, along with the dimensions of the smallest 
!  rectangle containing all unset points in il,ir.
! ::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::;
!
subroutine trimbd(used,nrow,set,unset_rect)

    implicit none

    ! Input
    integer, intent(in) :: nrow
    integer(kind=1), intent(in) :: used(nrow)

    ! Output
    logical, intent(out) :: set
    integer, intent(out) :: unset_rect(2)

    ! Locals
    integer :: i, utot
    integer(kind=1) :: check

       utot = 0
        do 100 i = 1,nrow
100        utot = utot + used(i)

    if (utot .eq. nrow ) then
        set = .true.
    else
        set = .false.
 
        check = 1
        do i = 1,nrow
            check = min(check,used(i))
            unset_rect(1) = i
            if (check == 0) exit
        enddo

        check = 1
        do i = 1,nrow
            check = min(check,used(nrow - i + 1))
            unset_rect(2) = nrow - i + 1
            if (check == 0) exit
        enddo

    endif

end subroutine trimbd

c
c
c
c     ==============================================================
      subroutine claw2(meqn,mwaves,maux,mbc,mx,my,
     &           q,aux,xlower,ylower,dx,dy,tstart,tend,dtv,
     &           cflv,nv,method,mthlim,mthbc,
     &           work,mwork,use_fwaves,info,bc2,rpn2,rpt2,src2,b4step2)
c     ==============================================================
c
c
c
c  Solves a hyperbolic system of conservation laws in two space dimensions
c  of the general form
c  
c     capa * q_t + A q_x + B q_y = psi
c
c  The "capacity function" capa(x,y) and source term psi are optional 
c  (see below).
c
c  For a more complete description see the documentation at
c      http://www.amath.washington.edu/~claw
c
c  Sample driver programs and user-supplied subroutines are available.
c  See the the directories claw/clawpack/2d/example* for some examples, and
c  codes in claw/applications for more extensive examples.
c
c  --------------------------------------------------------
c
c  The user must supply the following subroutines:
c
c    bc2, rpn2, rpt2,        subroutines specifying the boundary conditions
c                            and Riemann solvers.
c
c    b4step2            The routine b4step2 is called each time step and
c                       can be supplied by the user in order to perform
c                       other operations that are necessary every time
c                       step.  For example, if the variables stored in
c                       the aux arrays are time-dependent then these
c                       values can be set.   
c
c  In addition, if the equation contains source terms psi, then the user
c  must provide:
c
c    src2               subroutine that solves capa * q_t = psi
c                       over a single time step.
c
c  These routines must be declared EXTERNAL in the main program.
c  For description of the calling sequences, see below.
c
c  Dummy routines b4step1.f and src1.f are available in
c       claw/clawpack/1d/lib
c
c  A subroutine implementing many standard boundary conditions is
c  available in claw/clawpack/2d/lib/bc2.f.
c
c
c
c  Description of parameters...
c  ----------------------------
c
c    meqn is the number of equations in the system of
c         conservation laws.
c
c    mwaves is the number of waves that result from the
c           solution of each Riemann problem.  Often mwaves = meqn but
c           for some problems these may be different, e.g. for the Euler
c           equations meqn = 4 but mwaves = 3 since there are only 3
c           distinct wave speeds.
c
c    mbc is the number of "ghost cells" that must be added on to each
c       side of the domain to handle boundary conditions.  The cells
c       actually in the physical domain are labelled from 1 to mx in x and
c       from 1 to my in y.  The arrays are dimensioned actually indexed
c       from 1-mbc to mx+mbc and from 1-mbc to my+mbc.
c       For the methods currently implemented, mbc = 2 should be used.
c       If the user implements another method that has a larger stencil and
c       hence requires more ghost cells, a larger value of mbc could be used.
c       q is extended from the physical domain to the ghost cells by the
c       user-supplied routine bc2.
c
c    mx is the number of grid cells in the x-direction, in the
c       physical domain.  In addition there are mbc grid cells
c       along each edge of the grid that are used for boundary
c       conditions.
c 
c    my is the number of grid cells in the y-direction, in the
c       physical domain.  In addition there are mbc grid cells
c       along each edge of the grid that are used for boundary
c       conditions.
c 
c    q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc) 
c        On input:  initial data at time tstart.
c        On output: final solution at time tend.
c        q(m,i,j) = value of mth component in the (i,j) cell.
c        Values within the physical domain are in q(m,i,j) 
c                for i = 1,2,...,mx   and j = 1,2,...,my.
c        mbc extra cells on each end are needed for boundary conditions
c        as specified in the routine bc2.
c
c    aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
c        Array of auxiliary variables that are used in specifying the problem.
c        If method(7) = 0 then there are no auxiliary variables and aux
c                         can be a dummy variable.
c        If method(7) = maux > 0 then there are maux auxiliary variables
c                         and aux must be dimensioned as above.
c
c        Capacity functions are one particular form of auxiliary variable.
c        These arise in some applications, e.g. the
c        determinant of the Jacobian if a mapped grid is used, or a density
c        or porosity function in some advection problems.  
c        See Clawpack Note # 5 for examples.
c
c        If method(6) = 0 then there is no capacity function.
c        If method(6) = mcapa > 0  then there is a capacity function and 
c            capa(i,j), the "capacity" of the (i,j) cell, is assumed to be 
c            stored in aux(mcapa,i,j).
c            In this case we require method(7).ge.mcapa.
c
c    dx = grid spacing in x.  
c         (for a computation in ax <= x <= bx,  set dx = (bx-ax)/mx.)
c
c    dy = grid spacing in y.  
c         (for a computation in ay <= y <= by,  set dy = (by-ay)/my.)
c
c    tstart = initial time.
c
c    tend = Desired final time (on input).
c              If tend<tstart, then claw2 returns after a single successful
c                 time step has been taken (single-step mode).  
c              Otherwise, as many steps are taken as needed to reach tend, 
c                 up to a maximum of nv(1).
c         = Actual time reached (on output).
c
c    dtv(1:5) = array of values related to the time step:
c               (Note: method(1)=1 indicates variable size time steps)
c         dtv(1) = value of dt to be used in all steps if method(1) = 0
c                = value of dt to use in first step if method(1) = 1
c         dtv(2) = unused if method(1) = 0.
c                = maximum dt allowed if method(1) = 1.
c         dtv(3) = smallest dt used (on output)
c         dtv(4) = largest dt used (on output)
c         dtv(5) = dt used in last step (on output)
c
c    cflv(1:4) = array of values related to Courant number:
c         cflv(1) = maximum Courant number to be allowed.  
c                   With variable time steps the step is retracted and a 
c                   smaller step taken if the Courant
c                   number is larger than this value.  
c                   With fixed time steps the routine aborts.
c                   Usually cflv(1)=1.0 should work 
c                   (or cflv(1)=0.5 if method(3)=0).
c         cflv(2) = unused if method(1) = 0.
c                 = desired Courant number if method(1) = 1.
c                   Should be somewhat less than cflv(1), e.g. 0.9
c         cflv(3) = largest Courant number observed (on output).
c         cflv(4) = Courant number in last step (on output).
c
c    nv(1:2) = array of values related to the number of time steps:
c         nv(1) = unused if method(1) = 0
c               = maximum number of time steps allowed if method(1) = 1
c         nv(2) = number of time steps taken (on output).
c
c    method(1:7) = array of values specifying the numerical method to use
c                  and also indicating whether source terms, capacity
c                  function, auxiliary variables are present in the equation.
c
c         method(1) = 0 if fixed size time steps are to be taken.
c                       In this case, dt = dtv(1) in all steps.
c                   = 1 if variable time steps are to be used.
c                       In this case, dt = dtv(1) in the first step and
c                       thereafter the value cflv(2) is used to choose the
c                       next time step based on the maximum wave speed seen
c                       in the previous step.  Note that since this value
c                       comes from the previous step, the Courant number will
c                       not in general be exactly equal to the desired value
c                       If the actual Courant number in the next step is
c                       greater than cflv(1), then this step is redone with a 
c                       smaller dt.
c
c         method(2) = 1 if only first order increment waves are to be used.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.  
c
c
c         method(3) = 0 if no transverse propagation is to be applied.
c                       Increment and perhaps correction waves are propagated
c                       normal to the interface.
c                   = 1 if transverse propagation of increment waves 
c                       (but not correction waves, if any) is to be applied.
c                   = 2 if transverse propagation of correction waves is also
c                       to be included.  
c
c                   = -1 if dimensional splitting is to be used instead
c                        of the multi-dimensional wave-propagation.  The
c                        Godunov splitting is used which consists of
c                        sweeping first in x and then in y, with a step of
c                        length dt in each.  The routine bc2 is called
c                        before either sweep to set boundary data, and in
c                        the x-sweep goes over the rows of ghost cells too
c                        so that proper boundary conditions should be set
c                        for the y-sweeps by this process.  Dimensional
c                        splitting is somewhat faster than the unsplit
c                        method and works as well for many (though not all)
c                        problems.
c
c                   = -2 if dimensional splitting is to be used with the
c                        Strang splitting, consisting of 
c                           sweep in x over time dt/2
c                           sweep in y over time dt
c                           sweep in x over time dt/2
c                        This is not recommended because it is slower than
c                        the Godunov splitting and does not appear to be
c                        appreciably better.  Moreover, the boundary
c                        conditions will not be properly set for the final
c                        x-sweep.  (The code could be modified to achieve
c                        this by sweeping over more ghost cells.)
c
c         method(4) = 0 to suppress printing
c                   = 1 to print dt and Courant number every time step
c
c         method(5) = 0 if there is no source term psi.  In this case
c                       the subroutine src2 is never called so a dummy
c                       parameter can be given.
c                   = 1 if there is a source term.  In this case 
c                       the subroutine src2 must be provided and a 
c                       fractional step method is used.
c                       In each time step the following sequence is followed:
c                            call bc to extend data to ghost cells
c                            call step2 to advance hyperbolic eqn by dt
c                            call src2 to advance source terms by dt
c                   = 2 if there is a source term and Strang splitting is to
c                       be used instead of the Godunov splitting above.
c                       In each time step the following sequence is followed:
c                            call bc to extend data to ghost cells
c                            call src2 to advance source terms by dt/2
c                            call step2 to advance hyperbolic equation by dt
c                            call src2 to advance source terms by dt/2
c                       For most problems 1 is recommended rather than 2
c                       since it is less expensive and works essentially as 
c                       well on most problems.  
c                           
c
c         method(6) = 0 if there is no capacity function capa.  
c                   = mcapa > 0 if there is a capacity function.  In this case 
c                       aux(mcapa,i,j) is the capacity of cell (i,j) and you
c                       must also specify method(7) .ge. mcapa and set aux.
c
c         method(7) = 0 if there is no aux array used.
c                   = maux > 0  if there are maux auxiliary variables.
c
c         The recommended choice of methods for most problems is 
c            method(1) = 1,  method(2) = 2,  method(3) = 2.
c
c
c    mthlim(1:mwaves) = array of values specifying the flux limiter to be used
c                     in each wave family mw.  Often the same value will be used
c                     for each value of mw, but in some cases it may be
c                     desirable to use different limiters.  For example,
c                     for the Euler equations the superbee limiter might be
c                     used for the contact discontinuity (mw=2) while another
c                     limiter is used for the nonlinear waves.  Several limiters
c                     are built in and others can be added by modifying the
c                     subroutine philim.
c
c        mthlim(mw) = 0 for no limiter
c                   = 1 for minmod
c                   = 2 for superbee
c                   = 3 for van Leer
c                   = 4 for monotonized centered
c
c    mthbc(1:4) = array of values specifying what boundary conditions should
c                 be used at each edge of the domain, if the standard
c                 bc2.f routine is used.  Passed to bc2.
c
c    work(mwork) = double precision work array of length at least mwork
c
c    mwork = length of work array.  Must be at least
c               N * (mx + 2*mbc) * (my + 2*mbc) * meqn   
c               + (max(mx,my) + 2*mbc) * (10*meqn + mwaves + meqn*mwaves 
c                                          + 3*maux + 2) 
c            where N = 1 if method(5)<2  (no source term or Godunov splitting)
c                  N = 2 if method(5)=2  (source term with Strang splitting)
c            If mwork is too small then the program returns with info = 4
c            and also prints the required value of mwork to unit 6.
c
c            
c    info = output value yielding error information:
c         = 0 if normal return.
c         = 1 if mbc.lt.2
c         = 2 if method(1)=0 and dt doesn't divide (tend - tstart).
c         = 3 if method(1)=1 and cflv(2) > cflv(1).
c         = 4 if mwork is too small.
c         = 5 if method(6) > method(7)
c         = 6 if method(3) > method(2)
c         = 11 if the code attempted to take too many time steps, n > nv(1).
c              This could only happen if method(1) = 1 (variable time steps).
c         = 12 if the method(1)=0 and the Courant number is greater than 1
c              in some time step.
c
c           Note: if info.ne.0, then tend is reset to the value of t actually
c           reached and q contains the value of the solution at this time.
c
c    User-supplied subroutines
c    -------------------------
c
c    bc2 = subroutine that specifies the boundary conditions.  
c         This subroutine should extend the values of q from cells
c         (1:mx, 1:my) to the mbc ghost cells along each edge of the domain.
c
c
c    rpn2 = user-supplied subroutine that implements the Riemann solver
c           along a one-dimensional slice of data.
c
c          The form of this subroutine is
c  -------------------------------------------------
c     subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,
c    &                  auxl,auxr,wave,s,amdq,apdq)
c
c     implicit double precision (a-h,o-z)
c     dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
c     dimension    s(mwaves, 1-mbc:maxm+mbc)
c     dimension   ql(meqn, 1-mbc:maxm+mbc)
c     dimension   qr(meqn, 1-mbc:maxm+mbc)
c     dimension auxl(maux, 1-mbc:maxm+mbc)
c     dimension auxr(maux, 1-mbc:maxm+mbc)
c     dimension amdq(meqn, 1-mbc:maxm+mbc)
c     dimension apdq(meqn, 1-mbc:maxm+mbc)
c  -------------------------------------------------
c
c         On input, ql contains the state vector at the left edge of each cell
c                   qr contains the state vector at the right edge of each cell
c                 auxl contains auxiliary values at the left edge of each cell
c                 auxr contains auxiliary values at the right edge of each cell
c
c         This data is along a slice in the x-direction if ixy=1
c                                    or the y-direction if ixy=2.
c
c         Note that the i'th Riemann problem has left state qr(:,i-1)
c                                            and right state ql(:,i)
c         In the standard clawpack routines, this Riemann solver is 
c         called with ql=qr=q along this slice.  More flexibility is allowed
c         in case the user wishes to implement another solution method
c         that requires left and rate states at each interface.

c         If method(7)=maux > 0 then the auxiliary variables along this slice
c         are passed in using auxl and auxr.  Again, in the standard routines
c         auxl=auxr is just the values of aux along this slice.

c          On output, 
c             wave(m,mw,i) is the mth component of the jump across
c                              wave number mw in the ith Riemann problem.
c             s(mw,i) is the wave speed of wave number mw in the
c                              ith Riemann problem.
c             amdq(m,i) is the m'th component of the left-going flux difference.
c             apdq(m,i) is the m'th component of the right-going flux difference.
c           It is assumed that each wave consists of a jump discontinuity
c           propagating at a single speed, as results, for example, from a
c           Roe approximate Riemann solver.  An entropy fix can be included
c           into the specification of amdq and apdq.
c
c
c    rpt2 = user-supplied subroutine that implements the splitting of
c           a flux difference asdq into waves in the transverse direction.
c           The form of this subroutine is
c  -------------------------------------------------
c     subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,
c                     asdq,bmasdq,bpasdq)
c
c     implicit double precision (a-h,o-z)
c     dimension     ql(meqn, 1-mbc:maxm+mbc)
c     dimension     qr(meqn, 1-mbc:maxm+mbc)
c     dimension   aux1(maux, 1-mbc:maxm+mbc)
c     dimension   aux2(maux, 1-mbc:maxm+mbc)
c     dimension   aux3(maux, 1-mbc:maxm+mbc)
c     dimension   asdq(meqn, 1-mbc:maxm+mbc)
c     dimension bmasdq(meqn, 1-mbc:maxm+mbc)
c     dimension bpasdq(meqn, 1-mbc:maxm+mbc)
c  -------------------------------------------------
c          On input, 
c              ql,qr is the data along some one-dimensional slice, as in rpn2
c                   This slice is in the x-direction
c                   if ixy=1, or in the y-direction if ixy=2.  
c              aux2 is the auxiliary array (if method(6)=maux>0) along
c                   this slice, say at j=J if ixy=1.
c              aux1 is the auxiliary array along the adjacent slice J-1
c              aux3 is the auxiliary array along the adjacent slice J+1
c          
c              asdq is an array of flux differences (A^* \Delta q).  
c                   asdq(i,:) is the flux difference propagating away from
c                   the interface between cells i-1 and i.
c              imp = 1 if asdq = A^- \Delta q,  the left-going flux difference
c                    2 if asdq = A^+ \Delta q, the right-going flux difference
c          On output, 
c              bmasdq is the down-going portion of the flux difference
c                   determined by solving a Riemann problem in the transverse
c                   direction using asdq as data.  
c              bpasdq is the up-going portion of the flux difference.
c           For example, for a linear system q_t + Aq_x + Bq_y = 0,  
c                   asdq = A^+ dq  or  A^- dq
c                   and this is then split into
c                       bmasdq = B^- asdq   and   bpasdq = B^+ asdq
c
c
c    src2 = user-supplied subroutine that takes one time step on the 
c           source terms alone, solving
c               capa * q_t = psi
c           over time dt.
c
c           If method(5)=0 then the equation does not contain a source
c           term and this routine is never called.  A dummy argument can
c           be used with many compilers, or provide a dummy subroutine that
c           does nothing (such a subroutine can be found in 
c           clawpack/2d/lib/src2.f)
c
c           The form of this subroutine is
c  -------------------------------------------------
c      subroutine src2(meqn,mbc,mx,my,xlower,ylower,
c    &                 dx,dy,q,maux,aux,told,dt2)
c      implicit double precision (a-h,o-z)
c      dimension   q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
c      dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
c  -------------------------------------------------
c      If method(7)=0  or the auxiliary variables are not needed in this solver,
c      then the latter dimension statement can be omitted, but aux should
c      still appear in the argument list.
c
c      On input, q(m,i,j) contains the data for solving the 
c                source term equation.
c      On output, q(m,i,j) should have been replaced by the solution to
c                 the source term equation after a step of length dt.
c
c
c
c      b4step2 = subroutine that is called from claw2 before each call to
c                step2.  Use to set time-dependent aux arrays or perform
c                other tasks which must be done every time step.
c
c          The form of this subroutine is
c
c  -------------------------------------------------
c      subroutine b4step2(mbc,mx,my,meqn,q,
c    &            xlower,ylower,dx,dy,time,dt,maux,aux)
c      implicit double precision (a-h,o-z)
c      dimension   q(meqn, 1-mbc:mx+mbc)
c      dimension aux(maux, 1-mbc:mx+mbc)
c  -------------------------------------------------
c
c  
c
c =========================================================================
c
c  Copyright 1994 -- 1999 R. J. LeVeque
c
c  This software is made available for research and instructional use only. 
c  You may copy and use this software without charge for these non-commercial
c  purposes, provided that the copyright notice and associated text is
c  reproduced on all copies.  For all other uses (including distribution of
c  modified versions), please contact the author at the address given below. 
c  
c  *** This software is made available "as is" without any assurance that it
c  *** will work for your purposes.  The software may in fact have defects, so
c  *** use the software at your own risk.
c
c  --------------------------------------
c    CLAWPACK Version 4.1,  August, 2002
c    Webpage: http://www.amath.washington.edu/~claw
c  --------------------------------------
c
c    Author:  Randall J. LeVeque
c             Applied Mathematics
c             Box 352420
c             University of Washington, 
c             Seattle, WA 98195-2420
c             rjl@amath.washington.edu
c =========================================================================
c
c
c
c            
c    ======================================================================
c    Beginning of claw2 code
c    ======================================================================
c 
      implicit double precision (a-h,o-z)
      external bc2,rpn2,rpt2,src2,b4step2
      dimension    q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension  aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension work(mwork)
      dimension mthlim(mwaves),method(7),dtv(5),cflv(4),nv(2),mthbc(4)
      logical :: use_fwaves
      common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom
c
      maxm = max0(mx, my)
      info = 0
      t = tstart
      maxn = nv(1)
      dt = dtv(1)   !# initial dt
      cflmax = 0.d0
      dtmin = dt
      dtmax = dt
      nv(2) = 0
      !maux = method(7)    ! Now brought in from arg list
c
c     # check for errors in data:
c     ---------------------------
c
      if (method(1) .eq. 0) then
c        # fixed size time steps.  Compute the number of steps:
         if (tend .lt. tstart) then
c             # single step mode 
              maxn = 1
           else
              maxn = nint((tend - tstart)/dt)    ! Round to nearest int
              if (dabs(maxn*dt - (tend-tstart)) .gt.
     &                          1d-5*(tend-tstart)) then
c                # dt doesn't divide time interval integer number of times
                 info = 2
                 write(6,*) 
     &               'CLAW2 ERROR... dt does not divide (tend-tstart)'
                 go to 900
                 endif
           endif
         endif

c
      if (method(1).eq.1 .and. cflv(2).gt.cflv(1)) then
         info = 3
         write(6,*) 'CLAW2 ERROR...  cflv(2) > cflv(1)'
         go to 900
         endif
c
      if (method(6).gt.method(7)) then
         info = 5
         write(6,*) 'CLAW2 ERROR...  method(6) > method(7)'
         go to 900
         endif
c
      if (method(2) .lt. method(3)) then
         info = 6
         write(6,*) 'CLAW2 ERROR...  method(3) > method(2)'
         go to 900
         endif
c
      if (method(5).lt.2) then
          narray = 1   !# only need one qwork array
        else
          narray = 2   !# need two qwork arrays for Strang splitting
        endif
c
      mwork0 = (maxm+2*mbc)*(10*meqn + mwaves + meqn*mwaves 
     &                      + 3*maux + 2) 
     &          + narray * (mx + 2*mbc) * (my + 2*mbc) * meqn   
c
      if (mwork .lt. mwork0) then
         info = 4
         write(6,*) 'CLAW2 ERROR... mwork should be increased to ',
     &               mwork0
         go to 900
         endif
c
c     # partition work array into pieces needed for local storage in 
c     # step2 routine. Find starting index of each piece:
c
      i0qadd = 1
      i0fadd = i0qadd + (maxm+2*mbc)*meqn
      i0gadd = i0fadd + (maxm+2*mbc)*meqn
      i0q1d = i0gadd + 2*(maxm+2*mbc)*meqn 
      i0dtdx1 = i0q1d + (maxm+2*mbc)*meqn  
      i0dtdy1 = i0dtdx1 + (maxm+2*mbc)
      i0qwrk1 = i0dtdy1 + (maxm+2*mbc)
c
      nqwork = (mx + 2*mbc) * (my + 2*mbc) * meqn  !# size of q array
      if (method(5).lt.2) then
          i0qwrk2 = i0qwrk1  !# qwrk2 points to same storage as qwrk1
        else
          i0qwrk2 = i0qwrk1 + nqwork  !# second qwork array is needed for
                                      !# Strang spliting
        endif
c
      i0aux1 = i0qwrk2 + nqwork
      i0aux2 = i0aux1 + (maxm+2*mbc)*maux
      i0aux3 = i0aux2 + (maxm+2*mbc)*maux
c
      i0next = i0aux3 + (maxm+2*mbc)*maux  !# next free space
      mused = i0next - 1                  !# space already used
      mwork1 = mwork - mused              !# remaining space (passed to step2)
c
c
c
c     -----------
c     # main loop
c     -----------
c
      if (maxn.eq.0) go to 900
      do 100 n=1,maxn
         told = t   !# time at beginning of time step.

c        # adjust dt to hit tend exactly if we're near end of computation
c        #  (unless tend < tstart, which is a flag to take only a single step)
         if (told+dt.gt.tend .and. tstart.lt.tend) dt = tend - told

c
   40    continue
c
c        # store dt and t in the common block comxyt in case they are needed
c        # in the Riemann solvers (for variable coefficients)
         tcom = told
         dtcom = dt
         dxcom = dx
         dycom = dy
c
c
c
c        ================================================================
c
c        -------------------------
c        # main steps in algorithm
c        -------------------------
c
c        # extend data from grid to bordering boundary cells:
         call bc2(meqn,mbc,mx,my,xlower,ylower,
     &               dx,dy,q,maux,aux,told,dt,mthbc)
c
c
c
c        # call user-supplied routine which might set aux arrays
c        # for this time step, for example.

         call b4step2(mbc,mx,my,meqn,q,
     &                xlower,ylower,dx,dy,told,dt,maux,aux)
c
c
c
         if (method(5).eq.2) then
c            # with Strang splitting for source term:
c            # First need to store solution before taking
c            # step on source terms in case we need to redo everything with
c            # a smaller time step if the Courant number is too large in 
c            # subroutine step2.
             call copyq2(meqn,mbc,mx,my,q,work(i0qwrk2))
c
c            # source terms over a half time step:
             dt2 = dt / 2.d0
             call src2(meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,maux,aux,told,dt2)
             endif
c
c        # copy q into qwork1.  q is updated in step2 and qwork1 is
c        # preserved to provide data for Riemann problems.
c        # qwork1 can also be used to restart if the Courant number is 
c        # too large, unless Strang splitting is used in which case we
c        # must used the values already stored above before
c        # taking the source term step.
         call copyq2(meqn,mbc,mx,my,q,work(i0qwrk1))
c
c        # take one step on the conservation law:
c
         if( method(3) .ge. 0 )then
c            # unsplit version
c             
             call step2(maxm,meqn,mwaves,maux,mbc,mx,my,
     &                  work(i0qwrk1),q,aux,
     &                  dx,dy,dt,method,mthlim,cfl,
     &                  work(i0qadd),work(i0fadd),work(i0gadd),
     &                  work(i0q1d),work(i0dtdx1),work(i0dtdy1),
     &                  work(i0aux1),work(i0aux2),work(i0aux3),
     &                  work(i0next),mwork1,use_fwaves,rpn2,rpt2)
c
         else
c           # dimensional splitting (fractional steps)
c
            call dimsp2(maxm,meqn,mwaves,maux,mbc,mx,my,
     &                  work(i0qwrk1),q,aux,
     &                  dx,dy,dt,method,mthlim,cfl,cflv,
     &                  work(i0qadd),work(i0fadd),work(i0gadd),
     &                  work(i0q1d),work(i0dtdx1),work(i0dtdy1),
     &                  work(i0aux1),work(i0aux2),work(i0aux3),
     &                  work(i0next),mwork1,use_fwaves,rpn2,rpt2)
c
         endif
c
         t = told + dt
c
         if (method(4).eq.1) then
c            # verbose mode
             write(6,601) n,cfl,dt,t
  601        format('CLAW2... Step',i6,
     &                   '   Courant number =',f6.3,'  dt =',d12.4,
     &                   '  t =',d12.4)
             endif
c
c
c        # check to see if the Courant number was too large:
         if (cfl .le. cflv(1)) then
c             # accept this step
              cflmax = dmax1(cfl,cflmax)
            else
c             # Reject this step.  Reset q to qwork from previous time:
c             # Note that i0qwrk2 points to work space where previous
c             # solution is stored in all cases method(5) = 0,1, or 2. 
              t = told
              call copyq2(meqn,mbc,mx,my,work(i0qwrk2),q)
c
              if (method(4).eq.1) then
c                # verbose mode
                 write(6,602)
                 endif
  602         format('CLAW2 rejecting step... Courant number too large')
c
              if (method(1).eq.1) then
c                 # if variable dt, go back and take a smaller step.
                  dt = dmin1(dtv(2), dt * cflv(2)/cfl)
                  go to 40
                else
c                 # if fixed dt, give up and return
                  cflmax = dmax1(cfl,cflmax)
                  go to 900
                endif
            endif
c
c
c        # claw2 step is accepted
c        # now apply source terms:
c
         if (method(5).eq.2) then
c            # source terms over a second half time step for Strang splitting:
c            # Note it is not so clear what time t should be used here if
c            # the source terms are time-dependent!
             call src2(meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,maux,aux,t,dt2)
             endif
c
         if (method(5).eq.1) then
c            # source terms over a full time step:
             call src2(meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,maux,aux,t,dt)
             endif
c
c        ================================================================
c
c
c
         if (method(1) .eq. 1) then
c           # choose new time step if variable time step
            if (cfl.eq.0.d0) then 
                dt = dtv(2)
              else
                dt = dmin1(dtv(2), dt * cflv(2)/cfl)
              endif
            dtmin = dmin1(dt,dtmin)
            dtmax = dmax1(dt,dtmax)
            endif
c
c
c        # see if we are done:
c
         nv(2) = nv(2) + 1
         if (t .ge. tend) go to 900
  100    continue
c
  900  continue
c 
c      # return information
c
       if (method(1).eq.1 .and. t.lt.tend .and. nv(2) .eq. maxn) then
c         # too many timesteps
          write(6,*) 'CLAW2 ERROR...  too many timesteps'
          info = 11
          endif
       if (method(1).eq.0 .and. cflmax .gt. cflv(1)) then
c         # Courant number too large with fixed dt
          write(6,*) 'CLAW2 ERROR...  Courant number too large'
          info = 12
          endif
       tend = t
       cflv(3) = cflmax
       cflv(4) = cfl
       dtv(3) = dtmin
       dtv(4) = dtmax
       dtv(5) = dt
c
       return 
       end

c
c
c     =====================================================
      subroutine rpt2(ixy,maxm,meqn,mwaves,mbc,mx,
     &                  ql,qr,aux1,aux2,aux3,
     &                  ilr,asdq,bmasdq,bpasdq)
c     =====================================================
      implicit double precision (a-h,o-z)
c
c     # Riemann solver in the transverse direction for the Euler equations
c     #  with a tracer variable.
c     # Split asdq (= A^* \Delta q, where * = + or -)
c     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
c     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)
c
c     # Uses Roe averages and other quantities which were 
c     # computed in rpn2eu and stored in the common block comroe.
c
      dimension     ql(meqn, 1-mbc:maxm+mbc)
      dimension     qr(meqn, 1-mbc:maxm+mbc)
      dimension   asdq(meqn, 1-mbc:maxm+mbc)
      dimension bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension bpasdq(meqn, 1-mbc:maxm+mbc)
      dimension aux2(8, 1-mbc:maxm+mbc)
c
      common /cparam/  gamma,gamma1
      dimension waveb(5,4),sb(4)
      parameter (maxm2 = 1800)  
c
      if (ixy.eq.1) then
          mu = 2
          mv = 3
        else
          mu = 3
          mv = 2
        endif


c     # compute the Roe-averaged variables needed in the Roe solver.
c
      do 10 i = 2-mbc, mx+mbc
         rhsqrtl = dsqrt(qr(1,i-1))
         rhsqrtr = dsqrt(ql(1,i))
         pl = gamma1*(qr(4,i-1) - 0.5d0*(qr(2,i-1)**2 +
     &        qr(3,i-1)**2)/qr(1,i-1))
         pr = gamma1*(ql(4,i) - 0.5d0*(ql(2,i)**2 +
     &        ql(3,i)**2)/ql(1,i))
         rhsq2 = rhsqrtl + rhsqrtr
         aux2(8,i) = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
         aux2(2,i) = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
         aux2(3,i) = (((qr(4,i-1)+pl)/rhsqrtl
     &             + (ql(4,i)+pr)/rhsqrtr)) / rhsq2
         aux2(6,i) = aux2(8,i)**2 + aux2(2,i)**2
         a2 = gamma1*(aux2(3,i) - .5d0*aux2(6,i))
         aux2(4,i) = dsqrt(a2)
         aux2(5,i) = gamma1 / a2
         aux2(7,i) = aux2(3,i) - aux2(6,i) 
   10    continue
c
c
         do 20 i = 2-mbc, mx+mbc
            a3 = aux2(5,i) * (aux2(7,i)*asdq(1,i) 
     &        + aux2(8,i)*asdq(mu,i) + aux2(2,i)*asdq(mv,i) - asdq(4,i))
            a2 = asdq(mu,i) - aux2(8,i)*asdq(1,i)
      a4 = (asdq(mv,i) + (aux2(4,i)-aux2(2,i))*asdq(1,i) - aux2(4,i)*a3)
     &              / (2.d0*aux2(4,i))
            a1 = asdq(1,i) - a3 - a4
c
            waveb(1,1) = a1
            waveb(mu,1) = a1*aux2(8,i)
            waveb(mv,1) = a1*(aux2(2,i)-aux2(4,i))
            waveb(4,1) = a1*(aux2(3,i) - aux2(2,i)*aux2(4,i))
            waveb(5,1) = 0.d0
            sb(1) = aux2(2,i) - aux2(4,i)
c
            waveb(1,2) = a3
            waveb(mu,2) = a3*aux2(8,i) + a2
            waveb(mv,2) = a3*aux2(2,i)
            waveb(4,2) = a3*0.5d0*aux2(6,i) + a2*aux2(8,i)
            waveb(5,2) = 0.d0
            sb(2) = aux2(2,i)
c
            waveb(1,3) = a4
            waveb(mu,3) = a4*aux2(8,i)
            waveb(mv,3) = a4*(aux2(2,i)+aux2(4,i))
            waveb(4,3) = a4*(aux2(3,i)+aux2(2,i)*aux2(4,i))
            waveb(5,3) = 0.d0
            sb(3) = aux2(2,i) + aux2(4,i)
c
            waveb(1,4) = 0.d0
            waveb(mu,4) = 0.d0
            waveb(mv,4) = 0.d0
            waveb(4,4) = 0.d0
            waveb(5,4) = asdq(5,i)
            sb(4) = aux2(2,i)
c
c           # compute the flux differences bmasdq and bpasdq
c
            do 30 m=1,meqn
               bmasdq(m,i) = 0.d0
               bpasdq(m,i) = 0.d0
               do 30 mw=1,4
                  bmasdq(m,i) = bmasdq(m,i) 
     &                         + dmin1(sb(mw), 0.d0) * waveb(m,mw)
                  bpasdq(m,i) = bpasdq(m,i)
     &                         + dmax1(sb(mw), 0.d0) * waveb(m,mw)
   30             continue
c                 
   20       continue
c
      return
      end

! This code has been adapted for vectorization. 
! For more details on how to use it, see the Makefile of the chile2010 example.

!======================================================================
       subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx, &
                      ql,qr,auxl,auxr,fwave,s,amdq,apdq)
!======================================================================
!
! Solves normal Riemann problems for the 2D SHALLOW WATER equations
!     with topography:
!     #        h_t + (hu)_x + (hv)_y = 0                           #
!     #        (hu)_t + (hu^2 + 0.5gh^2)_x + (huv)_y = -ghb_x      #
!     #        (hv)_t + (huv)_x + (hv^2 + 0.5gh^2)_y = -ghb_y      #

! On input, ql contains the state vector at the left edge of each cell
!     qr contains the state vector at the right edge of each cell
!
! This data is along a slice in the x-direction if ixy=1
!     or the y-direction if ixy=2.

!  Note that the i'th Riemann problem has left state qr(i-1,:)
!     and right state ql(i,:)
!  From the basic clawpack routines, this routine is called with
!     ql = qr
!
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                           !
!      # This Riemann solver is for the shallow water equations.            !
!                                                                           !
!       It allows the user to easily select a Riemann solver in             !
!       riemannsolvers_geo.f. this routine initializes all the variables    !
!       for the shallow water equations, accounting for wet dry boundary    !
!       dry cells, wave speeds etc.                                         !
!                                                                           !
!           David George, Vancouver WA, Feb. 2009                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      use geoclaw_module, only: g => grav, drytol => dry_tolerance, rho
      use geoclaw_module, only: earth_radius, deg2rad
      use amr_module, only: mcapa

      use storm_module, only: pressure_forcing, pressure_index

      implicit none

      !input
      integer maxm,meqn,maux,mwaves,mbc,mx,ixy

      real(kind=8)  fwave(1-mbc:maxm+mbc, meqn, mwaves)
      real(kind=8)  s(1-mbc:maxm+mbc, mwaves)
      real(kind=8)  ql(1-mbc:maxm+mbc, meqn)
      real(kind=8)  qr(1-mbc:maxm+mbc, meqn)
      real(kind=8)  apdq(1-mbc:maxm+mbc,meqn)
      real(kind=8)  amdq(1-mbc:maxm+mbc,meqn)
      real(kind=8)  auxl(1-mbc:maxm+mbc,maux)
      real(kind=8)  auxr(1-mbc:maxm+mbc,maux)

      !local only
      integer m,i,mw,maxiter,mu,nv
      real(kind=8) wall(3)
      
      !  Due to what seems to be a bug with the Intel Compilers (versions 16, 17 and 18 at least),
      !  these arrays declared as PRIVATE in a !$OMP SIMD loop had to be decomposed into scalars.
      !  This may not be necessary for future versions of the Intel Compilers.
      !real(kind=8) fw(3,3)
      !real(kind=8) sw(3)
      real(kind=8) fw11, fw12, fw13, fw21, fw22, fw23, fw31, fw32, fw33
      real(kind=8) sw1, sw2, sw3
! 
      real(kind=8) hR,hL,huR,huL,hvR,hvL,pL,pR
      real(kind=8) bR,bL

      real(kind=8) tw,dxdc
      
      real(kind=8) sqrt_ghL, sqrt_ghR

      logical rare1,rare2
      
      interface
        subroutine solve_rpn2(hL, hR, huL, huR, hvL, hvR, bL, bR, pL, pR,sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33) 
            real(kind=8), intent(inout) :: sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33
            real(kind=8), intent(inout) :: hL, hR, huL, huR, hvL, hvR, bL, bR, pL, pR
        end subroutine
      end interface

      ! In case there is no pressure forcing
      pL = 0.d0
      pR = 0.d0
      
      !set normal direction
      if (ixy.eq.1) then
         mu=2
         nv=3
      else
         mu=3
         nv=2
      endif

      !loop through Riemann problems at each grid cell
      !$OMP SIMD PRIVATE(hL,hR,huL,huR,hvL,hvR,bL,bR,pL,pR, &
      !$OMP& fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33,sw1,sw2,sw3)
      do i=2-mbc,mx+mbc

         !Riemann problem variables
         hL = qr(i-1,1) 
         hR = ql(i,1) 
         huL = qr(i-1,mu) 
         huR = ql(i,mu) 
         bL = auxr(i-1,1)
         bR = auxl(i,1)
         pL = 0.d0
         pR = 0.d0
         if (pressure_forcing) then
             pL = auxr(i-1,pressure_index)
             pR = auxl(i, pressure_index)
         end if

         hvL=qr(i-1,nv) 
         hvR=ql(i,nv)
         
         sw1 = 0.0d0
         sw2 = 0.0d0
         sw3 = 0.0d0
         fw11 = 0.0d0
         fw21 = 0.0d0
         fw31 = 0.0d0
         fw12 = 0.0d0
         fw22 = 0.0d0
         fw32 = 0.0d0
         fw13 = 0.0d0
         fw23 = 0.0d0
         fw33 = 0.0d0   
         
         !DIR$ FORCEINLINE
         call solve_rpn(hL, hR, huL, huR, hvL, hvR, bL, bR, pL, pR, sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33) 
        

         s(i,1) = sw1
         s(i,2) = sw2
         s(i,3) = sw3
         ! mw=1
         fwave(i, 1,1) = fw11
         fwave(i,mu,1) = fw21
         fwave(i,nv,1) = fw31
         ! mw=2
         fwave(i,1, 2) = fw12
         fwave(i,mu,2) = fw22
         fwave(i,nv,2) = fw32
         ! mw=3
         fwave(i,1, 3) = fw13
         fwave(i,mu,3) = fw23
         fwave(i,nv,3) = fw33
         
      enddo


!==========Capacity for mapping from latitude longitude to physical space====
      if (mcapa > 0) then
          if (ixy == 1) then
              dxdc = earth_radius*deg2rad
              !$OMP SIMD
              do i=2-mbc,mx+mbc
                  do mw=1,3
                      s(i,mw) = dxdc * s(i,mw)
                      fwave(i,1,mw) = dxdc*fwave(i,1,mw)
                      fwave(i,2,mw) = dxdc*fwave(i,2,mw)
                      fwave(i,3,mw) = dxdc*fwave(i,3,mw)
                  enddo
              enddo
          else
              !$OMP SIMD
              do i=2-mbc,mx+mbc
                  dxdc=earth_radius*cos(auxl(i,3))*deg2rad
                  do mw=1,3
                      s(i,mw) = dxdc * s(i,mw)
                      fwave(i,1,mw)=dxdc*fwave(i,1,mw)
                      fwave(i,2,mw)=dxdc*fwave(i,2,mw)
                      fwave(i,3,mw)=dxdc*fwave(i,3,mw)
                  enddo
              enddo
          endif
      endif

!===============================================================================

      do i=1-mbc,mx+mbc
          do m=1,3
              amdq(i,m) = 0.d0
          enddo
      enddo


      do i=1-mbc,mx+mbc
          do m=1,3
              apdq(i,m) = 0.d0
         enddo
      enddo 

      !============= compute fluctuations=============================================

      !$OMP SIMD
      do i=2-mbc,mx+mbc
           do  mw=1,3
              if (s(i,mw) < 0.d0) then
                  amdq(i,1:3) = amdq(i,1:3) + fwave(i,1:3,mw)
              else if (s(i,mw) > 0.d0) then
                  apdq(i,1:3)  = apdq(i,1:3) + fwave(i,1:3,mw)
              else
                  amdq(i,1:3) = amdq(i,1:3) + 0.5d0 * fwave(i,1:3,mw)
                  apdq(i,1:3) = apdq(i,1:3) + 0.5d0 * fwave(i,1:3,mw)
              endif
          enddo
      enddo

      return
      end subroutine
      
      
      
subroutine solve_rpn(hL, hR, huL, huR, hvL, hvR, bL, bR, pL, pR, sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33)      
      use geoclaw_module, only: g => grav, drytol => dry_tolerance, rho
      use geoclaw_module, only: earth_radius, deg2rad
      use amr_module, only: mcapa

      use storm_module, only: pressure_forcing, pressure_index

      implicit none

      !input
      real(kind=8) hL, hR, huL, huR, hvL, hvR, bL, bR, pL, pR
      
      !output
      !real(kind=8) sw(3), fw(3,3)
      real(kind=8) sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33

      !local only
      integer m,i,mw,maxiter
      real(kind=8) wall1, wall2, wall3
      real(kind=8) uR,uL,vR,vL,phiR,phiL
      real(kind=8) sL,sR,sRoe1,sRoe2,sE1,sE2,uhat,chat
      real(kind=8) s1m,s2m
      real(kind=8) hstar,hstartest,hstarHLL,sLtest,sRtest
      real(kind=8) tw,dxdc      
      real(kind=8) sqrt_ghL, sqrt_ghR
      logical rare1,rare2
         
         ! For completely dry states, do not skip problem (hinders
         ! vectorization), but rather solve artificial 0-valued problem.
         if (hL < drytol .and. hR < drytol) then
            hL = 0
            hR = 0
         endif

         !check for wet/dry boundary
         if (hR.gt.drytol) then
            uR=huR/hR
            vR=hvR/hR
            phiR = 0.5d0*g*hR**2 + huR**2/hR
         else
            hR = 0.d0
            huR = 0.d0
            hvR = 0.d0
            uR = 0.d0
            vR = 0.d0
            phiR = 0.d0
         endif

         if (hL.gt.drytol) then
            uL=huL/hL
            vL=hvL/hL
            phiL = 0.5d0*g*hL**2 + huL**2/hL
         else
            hL=0.d0
            huL=0.d0
            hvL=0.d0
            uL=0.d0
            vL=0.d0
            phiL = 0.d0
         endif

         wall1 = 1.d0
         wall2 = 1.d0
         wall3 = 1.d0
         if (hR.le.drytol) then
            !DIR$ FORCEINLINE
            call riemanntype(hL,hL,uL,-uL,hstar,s1m,s2m, &
                                       rare1,rare2,1,drytol,g)
            hstartest=max(hL,hstar)
            if (hstartest+bL.lt.bR) then !right state should become ghost values that mirror left for wall problem
               !bR=hstartest+bL
               wall2=0.d0
               wall3=0.d0
               hR=hL
               huR=-huL
               bR=bL
               phiR=phiL
               uR=-uL
               vR=vL
            elseif (hL+bL.lt.bR) then
               bR=hL+bL
            endif
         elseif (hL.le.drytol) then ! right surface is lower than left topo
            !DIR$ FORCEINLINE
            call riemanntype(hR,hR,-uR,uR,hstar,s1m,s2m, &
                                       rare1,rare2,1,drytol,g)
            hstartest=max(hR,hstar)
            if (hstartest+bR.lt.bL) then  !left state should become ghost values that mirror right
              !bL=hstartest+bR
               wall1=0.d0
               wall2=0.d0
               hL=hR
               huL=-huR
               bL=bR
               phiL=phiR
               uL=-uR
               vL=vR
            elseif (hR+bR.lt.bL) then
               bL=hR+bR
            endif
         endif
         
         ! pre-compute square roots
         sqrt_ghL = sqrt(g*hL)
         sqrt_ghR = sqrt(g*hR)

         !determine wave speeds
         sL=uL-sqrt_ghL ! 1 wave speed of left state
         sR=uR+sqrt_ghR ! 2 wave speed of right state

         uhat=(sqrt_ghL*uL + sqrt_ghR*uR)/(sqrt_ghR+sqrt_ghL) ! Roe average
         chat=sqrt(g*0.5d0*(hR+hL)) ! Roe average
         sRoe1=uhat-chat ! Roe wave speed 1 wave
         sRoe2=uhat+chat ! Roe wave speed 2 wave

         sE1 = min(sL,sRoe1) ! Eindfeldt speed 1 wave
         sE2 = max(sR,sRoe2) ! Eindfeldt speed 2 wave

         !--------------------end initializing...finally----------
         !solve Riemann problem.

         maxiter = 1

         !DIR$ FORCEINLINE
         call riemann_aug_JCP(maxiter,3,3,hL,hR,huL, &
             huR,hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2, &
             drytol,g,rho,sw1,sw2,sw3,fw11,fw12,fw13,fw21,fw22,fw23,fw31,fw32,fw33)

!          call riemann_ssqfwave(maxiter,meqn,mwaves,hL,hR,huL,huR,
!      &     hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,
!      &     rho,sw,fw)

!          call riemann_fwave(meqn,mwaves,hL,hR,huL,huR,hvL,hvR,
!      &      bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,rho,sw,
!      &      fw)



          ! For completely dry states, waves should be always zero!
          ! (these problems could have been skipped, but to allow 
          ! vectorization they weren't)
          if (hL < drytol .and. hR < drytol) then
             sw1 = 0.0d0
             sw2 = 0.0d0
             sw3 = 0.0d0
             fw11 = 0.0d0
             fw21 = 0.0d0
             fw31 = 0.0d0
             fw12 = 0.0d0
             fw22 = 0.0d0
             fw32 = 0.0d0
             fw13 = 0.0d0
             fw23 = 0.0d0
             fw33 = 0.0d0            
          endif


          !eliminate ghost fluxes for wall
!           do mw=1,3
!              sw(mw)=sw(mw)*wall(mw)
!  
!                 fw(1,mw)=fw(1,mw)*wall(mw) 
!                 fw(2,mw)=fw(2,mw)*wall(mw)
!                 fw(3,mw)=fw(3,mw)*wall(mw)
!           enddo

            sw1 = sw1 * wall1
            sw2 = sw2 * wall2
            sw3 = sw3 * wall3
            !mw=1
            fw11 = fw11 * wall1
            fw21 = fw21 * wall1
            fw31 = fw31 * wall1
            !mw=2
            fw12 = fw12 * wall2
            fw22 = fw22 * wall2
            fw32 = fw32 * wall2
            !mw=3
            fw13 = fw13 * wall3
            fw23 = fw23 * wall3
            fw33 = fw33 * wall3

end subroutine

!
! ::::::::::::::::::::::: INTFIL ::::::::::::::::::::::::::::::::;
!  INTFIL: interpolates values for a patch at the specified level and
!  location, using values from grids at LEVEL and coarser, if nec.
!
!  take the intersection of a grid patch with corners at ilo,ihi,jlo,jhi
!  and all grids mptr at LEVEL.  If there is a non-null intersection
!  copy the solution vaues from mptr (at TIME) into VAL array.
!  assumes patch at same levels do straight copy, not skipping
!  every intrat or doing any interpolation here,
!  assume called in correct order of levels, so that when copying
!  is ok to overwrite.
!
!  N.B.: there are no dummy points around patch, since
!        this is not an official "grid" but a "patch".
!
!  used array marks when point filled. filpatch checks if points left over
!  after intersections at specified level.
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
!
!
!> Fill values for a patch at the specified level and
!! location, using values from grids at level **level** ONLY!
!! Leave cells that are not filled unchanged.
!!
!! Search the intersection of a grid patch with corners at **ilo**,**ihi**,
!! **jlo**,**jhi** and all grids **mptr** on level **level**.  
!! If there is a non-null intersection,
!! copy the solution \f$q\f$ and auxiliary values from grid **mptr** into **val** array.
!!
!! Assume called in correct order of levels, so that when copying
!! is ok to overwrite.
!! 
!! It uses array, **flaguse**, to indicate whether each cell is filled. 
!! All cells outside computational domain will be marked as "used" as well
!! and will be processed later by [bc2amr()](@ref bc2amr) in [filrecur()](@ref filrecur).
!!
!! **Input**: 
!! * a patch that needs to be filled
!! * global indices that describe the patch to be filled
!! * the grid **msrc** that might contain with the patch
!! * relative position of the patch to grid **msrc** (nrowst, ncolst)
!!
!! **Output**:
!! * data array **val** that stores the new values 
!! * flagging array, **flaguse** that indicates whether a cell is filled
!! 
!! ## Algorithm
!!
!! If **msrc** \f$ = -1 \f$, this patch is not associated with any grid.
!! So the ''group of grids'', **S**, below contains all level **level** grids.
!!
!! If **msrc** \f$ \neq -1 \f$, this patch is contained in grid **msrc**.
!! So the ''group of grids'', **S**, below only contains 
!! level **level** grids that intersect with grid **msrc**. 
!! Size of **S** is smaller in this case.
!!
!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!!  procedure intfil()
!!      for each grid mptr in a group of grids, S, do
!!          if grid mptr intersect with the patch
!!              if grid mptr has values at the time needed
!!                  copy values inside the intersection from grid mptr to val      
!!                  mark cells in this intersection as "used"
!!              else
!!                  interpolate from values on grid mptr at two different time
!!                  fill the intersection with interpolated values              
!!                  mark cells in this intersection as "used"
!!              end if
!!          end if
!!      end for            
!!      mark any portion of the patch that is out of whole computational domain as "used", 
!!      which will be processed by bc2amr elsewhere later
!!~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
!!
!!
!! \param val array where values are copied to. The array covers the whole grid **msrc**
!! \param mi size of **val** array in *i* direction
!! \param mj size of **val** array in *j* direction
!! \param time simulation time of the values in **val** array
!! \param flaguse marks indicating whether a position in **val** is filled
!! \param nrowst local *i* index (relative to lower-left corner of grid **msrc**) of the left-most cell of the patch to be filled
!! \param ncolst local *j* index (relative to lower-left corner of grid **msrc**) of the lower-most cell of the patch to be filled
!! \param ilo global *i* index of left-most cell  of the patch to be filled
!! \param ihi global *i* index of right-most cell of the patch to be filled
!! \param jlo global *j* index of lower-most cell of the patch to be filled
!! \param jhi global *j* index of upper-most cell of the patch to be filled
!! \param level This patch is on level **level**
!! \param nvar number of equations for the system
!! \param naux number of auxiliary variables
!! \param msrc index of the grid that contains this patch
!!
!! \callgraph
!! \callergraph



subroutine intfil(val,aux,mi,mj,time,flaguse,nrowst,ncolst,ilo,ihi,jlo,jhi,   &
     level,nvar,naux,msrc,do_aux_copy)

  use amr_module, only: possk, mxnest, iregsz, jregsz, nghost, outunit, alloc
  use amr_module, only: node, lstart, store1, store2, storeaux, levelptr, timemult,gridNbor
  use amr_module, only: rnode, ndilo, ndihi, ndjlo, ndjhi, nextfree
  use amr_module, only: bndListNum, bndListSt, mstart
  use amr_module, only: listStart, listOfGrids, bndList, numgrids

  implicit none

  ! Input
  integer, intent(in) :: mi, mj, nrowst, ncolst, ilo, ihi, jlo, jhi, level, nvar, naux,msrc
  real(kind=8), intent(in) :: time

  ! In/Out
  integer(kind=1), intent(in out) :: flaguse(ilo:ihi, jlo:jhi)
  real(kind=8), intent(in out) :: val(nvar,mi,mj),aux(naux,mi,mj)

  ! Locals
  integer :: imlo, jmlo, imhi, jmhi, nx, ny, mitot, mjtot
  integer :: ixlo, ixhi, jxlo, jxhi, locold, locnew, nextSpot
  integer :: icount, bndNum, bndLoc, levSt, locaux, iaux, ialloc
  integer :: ivar, i, j, mptr, loc, numg
  real(kind=8) :: dt, alphac, alphai
  logical :: t_interpolate,do_aux_copy

  integer :: patch_rect(4)

  real(kind=8), parameter :: t_epsilon = 1.0d-4

  ! Formats for error statements
  character(len=*), parameter :: missing_error = &
       "(' time wanted ',e15.7,' not available from grid ',i4,'level',i4)"
  character(len=*), parameter :: time_error = &
       "(' trying to interpolate from previous time values ',/," // &
       "' for a patch with corners ilo,ihi,jlo,jhi:'" // &
       ",/,2x,4i10,/," // &
       "' from source grid ',i4,' at level ',i4,/," // &
       "' time wanted ',e24.16,' source time is ',e24.16,/," // &
       "' alphai, t_epsilon ',2e24.16)"

  patch_rect = [ilo,ihi,jlo,jhi]

  ! Note that we need a non-dimensionalized t epspatch_rect(1)n as it was a problem
  ! in tsunami tests ( instead of t_epsilon   = dt / 10.d0 )

  ! Time step at this level
  dt = possk(level)

  ! Initialize the flagging where we set things
  flaguse = 0

  ! Loop through all grids at this level, initialize to first
  !    mptr = lstart(level)
  !    do while (mptr /= 0)
  if (msrc .eq. -1) then
     numg = numgrids(level)
     levSt = listStart(level)
  else
     bndLoc = node(bndListSt,msrc)  ! index of first grid in bndList
     bndNum = node(bndListNum,msrc)
     nextSpot = node(bndListSt, msrc) ! initialize
     numg = bndNum
  endif

  do icount = 1, numg

     if (msrc .eq. -1) then
        mptr = listOfGrids(levSt+icount-1)
     else
        mptr = bndList(nextSpot,gridNbor)
     endif

     ! Check if grid mptr and patch intersect
     imlo = node(ndilo, mptr)
     jmlo = node(ndjlo, mptr)
     imhi = node(ndihi, mptr)
     jmhi = node(ndjhi, mptr)

     nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
     ny = node(ndjhi,mptr) - node(ndjlo,mptr) + 1

     mitot = nx + 2 * nghost
     mjtot = ny + 2 * nghost

     ixlo = max(imlo,patch_rect(1))
     ixhi = min(imhi,patch_rect(2))
     jxlo = max(jmlo,patch_rect(3))
     jxhi = min(jmhi,patch_rect(4))

     ! Check to see if grid and patch interesect, if not continue to next
     ! grid in the list
     if (ixlo <= ixhi .and. jxlo <= jxhi) then

        locaux = node(storeaux,mptr)  ! for copying aux arrays too

        ! grids intersect. figure out what time to use.
        ! alphai = 1 for new time; 0 for old time
        alphac = (rnode(timemult,mptr) - time)/dt
        alphai = 1.d0 - alphac

        if ((alphai < -t_epsilon) .or. (alphai > 1.d0 + t_epsilon)) then
           write(outunit,missing_error) time, mptr, level
           print missing_error, time, mptr, level
           write(outunit,'(A,E24.16)') 'Line 80', dt
           write(outunit,time_error) patch_rect,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
           print time_error, patch_rect,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
           call outtre(mstart,.false.,nvar,naux)
           stop
        endif

        ! Check if we should interpolate in time
        t_interpolate = .false.
        if (abs(alphai - 1.d0) < t_epsilon) then
           ! need no interpolation
           loc = node(store1,mptr)
        else if (dabs(alphai) .lt. t_epsilon) then
           loc = node(store2,mptr)
           if (level == mxnest) then
              write(outunit,'(A,E24.16)') 'Line 95', dt
              write(outunit,time_error) patch_rect,mptr,level,time, &
                   rnode(timemult,mptr),alphai,t_epsilon
              write(*,time_error) patch_rect,mptr,level,time, &
                   rnode(timemult,mptr),alphai,t_epsilon
              stop
           endif
        else
           locold  = node(store2,mptr)
           locnew  = node(store1,mptr)
           t_interpolate = .true.

           ! If we are at the maximum level nesting, abort
           if (level == mxnest) then
              write(outunit,'(A,E24.16)') 'Line 107',dt
              write(outunit,time_error) patch_rect,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
              print time_error, patch_rect,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
              stop
           endif
        endif

        ! Actual interpolation
        if (.not. t_interpolate) then
           ! No time interp. copy the solution values
           do ivar = 1, nvar
              do j = jxlo, jxhi
                 do i = ixlo, ixhi
                    ialloc = iadd(ivar,i-imlo+nghost+1,j-jmlo+nghost+1)
                    val(ivar,i-patch_rect(1)+nrowst,j-jlo+ncolst) = alloc(ialloc)
                    flaguse(i,j) = 1
                 end do
              end do
           end do
        else
           ! Linear interpolation in time
           do ivar = 1, nvar
              do j = jxlo, jxhi
                 do i = ixlo, ixhi
                    val(ivar,i-patch_rect(1)+nrowst,j-jlo+ncolst) = &
                         alloc(iadnew(ivar,i-imlo+nghost+1,j-jmlo+nghost+1))*alphai + &
                         alloc(iadold(ivar,i-imlo+nghost+1,j-jmlo+nghost+1))*alphac
                    flaguse(i,j) = 1
                 end do
              end do
           end do
        endif



        !if there are aux arrays set those too. only works if aux not time dependent
        if (do_aux_copy .and. naux .gt. 0) then        
           do j = jxlo, jxhi
              do i = ixlo, ixhi
                 do iaux = 1, naux
                    ialloc = iaddaux(iaux,i-imlo+nghost+1,j-jmlo+nghost+1)
                    aux(iaux,i-patch_rect(1)+nrowst,j-jlo+ncolst) = alloc(ialloc)
                 end do
              end do
           end do
        endif  ! should copy aux arrays

     endif ! this grid intersects

     ! Get next grid
     !        mptr = node(levelptr, mptr)
     if (msrc .ne. -1) then
        nextSpot = bndList(nextSpot,nextfree)
     endif

  end do

  ! Set used array points which intersect domain boundary to be equal to 1, 
  ! they will be set elsewhere, namely boundary conditions and periodic
  ! domains
  if (jhi >= jregsz(level)) then
     flaguse(patch_rect(1):ihi, max(jregsz(level),jlo):jhi) = 1
  endif

  if (jlo < 0) then
     flaguse(patch_rect(1):ihi, jlo:min(-1,ncolst + jhi - jlo )) = 1
  endif

  if (patch_rect(1) < 0) then
     flaguse(patch_rect(1):min(-1,nrowst + ihi - patch_rect(1)), jlo:jhi) = 1
  endif

  if (ihi >= iregsz(level)) then
     flaguse(max(iregsz(level),patch_rect(1)):ihi, jlo:jhi) = 1
  endif

contains

  integer pure function iadd(ivar,i,j)
    implicit none
    integer, intent(in) :: ivar, i, j
    iadd = loc + ivar-1 + nvar*((j-1)*mitot+i-1)
  end function iadd

  integer pure function iaddaux(iaux,i,j)
    implicit none
    integer, intent(in) :: iaux, i, j
    iaddaux = locaux + iaux-1 + naux*((j-1)*mitot+i-1)
  end function iaddaux



  integer pure function iadnew(ivar,i,j)
    implicit none
    integer, intent(in) :: ivar, i, j
    iadnew = locnew + ivar-1 + nvar*((j-1)*mitot+i-1)
  end function iadnew

  integer pure function iadold(ivar,i,j)
    implicit none
    integer, intent(in) :: ivar, i, j
    iadold = locold + ivar-1 + nvar*((j-1)*mitot+i-1)
  end function iadold

end subroutine intfil

c
c ----------------------------------------------------
c
      subroutine griddomcopy(i1, i2, ilo,ihi,jlo,jhi,mbuff)

      use amr_module
      implicit double precision (a-h, o-z)


      integer*1  i2(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)
      integer*1  i1(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)

c
c ::::::::::::::::::::::::::: GRIDDOMCOPY :::::::::::::::::::::
c 
c  griddomain flags need to be in different place
c  (can f90 do this in one statement, without sub call?)
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::


      do j = jlo-mbuff,jhi+mbuff
      do i = ilo-mbuff,ihi+mbuff
         i1(i,j) = i2(i,j)
      end do
      end do
c
      return
      end

c
!> Initializes solution on all grids at level of grid **msave**, 
!! by calling qinit().
!! If **first** = true, (first call to init), then allocate the
!! soln storage area too, else was already allocated.
!!
!! \param msave First grid in the grid list that stores all grids at
!! this level
!! \param first Is this the first call to init?
!! \param nvar number of equations for the system
!! \param naux  number of auxiliary variables
!! \param start_time start time of current simulation
!!
c
c -------------------------------------------------------------
c
      subroutine ginit(msave, first, nvar, naux, start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      logical first
      

c ::::::::::::::::::::::::::::: GINIT ::::::::::::::::::::::::
c
c  initializes soln on all grids at 'level'  by calling qinit
c  if first = true, (first call to init), then allocate the
c  soln storage area too, else was already allocated.
c
c :::::::::::::::::::::::::::::::::::::::;::::::::::::::::::::

      if (msave .eq. 0) go to 99

      level = node(nestlevel,msave)
      hx    = hxposs(level)
      hy    = hyposs(level)
      mptr  = msave
 
 10       nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot   = nx + 2*nghost
          mjtot   = ny + 2*nghost
          corn1   = rnode(cornxlo,mptr)
          corn2   = rnode(cornylo,mptr)
          if(.not. (first)) go to 20
              loc                 = igetsp(mitot*mjtot*nvar)
              node(store1,mptr)   = loc
              if (naux .gt. 0) then
                locaux              = igetsp(mitot*mjtot*naux)
                do k = 1, mitot*mjtot*naux,naux  ! set first component of aux to signal that it
                   alloc(locaux+k-1) = NEEDS_TO_BE_SET ! needs val, wasnt copied from other grids
                end do
                
                call setaux(nghost,nx,ny,corn1,corn2,hx,hy,
     &                    naux,alloc(locaux))
              else 
                locaux = 1
              endif
              node(storeaux,mptr) = locaux
              if (level .lt. mxnest) then
                loc2              = igetsp(mitot*mjtot*nvar)
                node(store2,mptr) = loc2
              endif
              rnode(timemult, mptr) = start_time
              go to 30
 20       continue
c
c  if 2nd time through, put initial values in store2 so finer grids
c  can be advanced with interpolation of their boundary values.
c  new time soln should still be in location store1.
c
          loc     = node(store2,mptr)
          locaux  = node(storeaux,mptr)
c
   30     continue
          call qinit(nvar,nghost,nx,ny,corn1,corn2,hx,hy,
     &               alloc(loc),naux,alloc(locaux))

c
          mptr  = node(levelptr, mptr)
      if (mptr .ne. 0) go to 10
c
c
 99   continue
      return
      end

c
c -----------------------------------------------------------
c
      subroutine colate (badpts, len, lcheck, 
     1                   iflags,domflags,isize,jsize,ksize,npts)
c
      use amr_module
      implicit  double precision (a-h,o-z)


      dimension badpts(3,len)
      integer*1 iflags  (0:isize+1,0:jsize+1,0:ksize+1)
      integer*1 domflags(0:isize+1,0:jsize+1,0:ksize+1)
c
c
c *************************************************************
c
c colate = takes the error plane with flagged pts at level lcheck
c          and puts their (i,j,k) cell centered
c          indices into the badpts array.
c          To insure proper nesting,  get rid of flagged point
c          that dont fit into properly nested domain (in iflags2)
c
c *************************************************************
c
c     # if pt. flagged but domain not flagged, turn it off
c     # note that this results in flags of 1,  not 2 of 3.


      if (dprint) then
         write(outunit,*)" from colate: iflags"
         do 48 kk = 1, ksize
           k = ksize + 1 - kk
           write(outunit,*) 'plane k = ',k
         do 48 jj = 1, jsize
           j = jsize + 1 - jj
           write(outunit,101)(iflags(i,j,k),i=1,isize)
 48      continue
         write(outunit,*)" from colate: domflags"
         do 49 kk = 1, ksize
           k = ksize + 1 - kk
           write(outunit,*) 'plane k = ',k
         do 49 jj = 1, jsize
           j = jsize + 1 - jj
           write(outunit,101)(domflags(i,j,k),i=1,isize)
 101       format(80i1)
 49      continue
      endif

      do 10 k = 1, ksize
      do 10 j = 1, jsize 
      do 10 i = 1, isize 
        iflags(i,j,k) = min(iflags(i,j,k),domflags(i,j,k))
 10   continue


c
c     give points the indices from integer region space.
      index  = 0
      do 20 k   = 1, ksize
      do 20 j   = 1, jsize
      do 20 i   = 1, isize
        if (iflags(i,j,k) .ne. goodpt) then
          index = index + 1
          badpts(1,index) = dble(i)-.5
          badpts(2,index) = dble(j)-.5
          badpts(3,index) = dble(k)-.5
        endif
 20   continue
c
 99   npts = index 
      if (gprint) then
        write(outunit,100) npts, lcheck
 100    format( i9,' flagged points colated on level ',i4)
      endif

      return
      end

c======================================================================
       subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,
     &                 ql,qr,auxl,auxr,fwave,s,amdq,apdq)
c======================================================================
c
c Solves normal Riemann problems for the 2D SHALLOW WATER equations
c     with topography:
c     #        h_t + (hu)_x + (hv)_y = 0                           #
c     #        (hu)_t + (hu^2 + 0.5gh^2)_x + (huv)_y = -ghb_x      #
c     #        (hv)_t + (huv)_x + (hv^2 + 0.5gh^2)_y = -ghb_y      #

c Modified in v5.10.1 to also work for Boussinesq equations in which q has
c two additional components. They are used to store momentum corrections
c that come from solving an elliptic system, for ease of interpolation to
c ghost cells to provide BCs on finer levels.  These components q(4:5,:)
c are not modified in the shallow water step and so the waves and
c fluctuations are initialized to have zeros in these components.

c On input, ql contains the state vector at the left edge of each cell
c     qr contains the state vector at the right edge of each cell
c
c This data is along a slice in the x-direction if ixy=1
c     or the y-direction if ixy=2.

c  Note that the i'th Riemann problem has left state qr(i-1,:)
c     and right state ql(i,:)
c  From the basic clawpack routines, this routine is called with
c     ql = qr
c
c
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                           !
!      # This Riemann solver is for the shallow water equations.            !
!                                                                           !
!       It allows the user to easily select a Riemann solver in             !
!       riemannsolvers_geo.f. this routine initializes all the variables    !
!       for the shallow water equations, accounting for wet dry boundary    !
!       dry cells, wave speeds etc.                                         !
!                                                                           !
!           David George, Vancouver WA, Feb. 2009                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      use geoclaw_module, only: g => grav, drytol => dry_tolerance, rho
      use geoclaw_module, only: earth_radius, deg2rad
      use amr_module, only: mcapa

      use storm_module, only: pressure_forcing, pressure_index

      implicit none

      !input
      integer maxm,meqn,maux,mwaves,mbc,mx,ixy

      double precision  fwave(meqn, mwaves, 1-mbc:maxm+mbc)
      double precision  s(mwaves, 1-mbc:maxm+mbc)
      double precision  ql(meqn, 1-mbc:maxm+mbc)
      double precision  qr(meqn, 1-mbc:maxm+mbc)
      double precision  apdq(meqn,1-mbc:maxm+mbc)
      double precision  amdq(meqn,1-mbc:maxm+mbc)
      double precision  auxl(maux,1-mbc:maxm+mbc)
      double precision  auxr(maux,1-mbc:maxm+mbc)

      !local only
      integer m,i,mw,maxiter,mu,nv
      double precision wall(3)
      double precision fw(meqn,3)
      double precision sw(3)

      double precision hR,hL,huR,huL,uR,uL,hvR,hvL,vR,vL,phiR,phiL,pL,pR
      double precision bR,bL,sL,sR,sRoe1,sRoe2,sE1,sE2,uhat,chat
      double precision s1m,s2m
      double precision hstar,hstartest,hstarHLL,sLtest,sRtest
      double precision tw,dxdc

      logical rare1,rare2

      ! In case there is no pressure forcing
      pL = 0.d0
      pR = 0.d0
      
      ! initialize all components to 0
      fw(:,:) = 0.d0
      fwave(:,:,:) = 0.d0
      s(:,:) = 0.d0
      amdq(:,:) = 0.d0
      apdq(:,:) = 0.d0

      !loop through Riemann problems at each grid cell
      do i=2-mbc,mx+mbc

!-----------------------Initializing-----------------------------------
         !inform of a bad riemann problem from the start
         if((qr(1,i-1).lt.0.d0).or.(ql(1,i) .lt. 0.d0)) then
            write(*,*) 'Negative input: hl,hr,i=',qr(1,i-1),ql(1,i),i
         endif


c        !set normal direction
         if (ixy.eq.1) then
            mu=2
            nv=3
         else
            mu=3
            nv=2
         endif

         !zero (small) negative values if they exist
         if (qr(1,i-1).lt.0.d0) then
               qr(1,i-1)=0.d0
               qr(2,i-1)=0.d0
               qr(3,i-1)=0.d0
         endif

         if (ql(1,i).lt.0.d0) then
               ql(1,i)=0.d0
               ql(2,i)=0.d0
               ql(3,i)=0.d0
         endif

         !skip problem if in a completely dry area
         if (qr(1,i-1) <= drytol .and. ql(1,i) <= drytol) then
            go to 30
         endif

         !Riemann problem variables
         hL = qr(1,i-1) 
         hR = ql(1,i) 
         huL = qr(mu,i-1) 
         huR = ql(mu,i) 
         bL = auxr(1,i-1)
         bR = auxl(1,i)
         if (pressure_forcing) then
             pL = auxr(pressure_index, i-1)
             pR = auxl(pressure_index, i)
         end if

         hvL=qr(nv,i-1) 
         hvR=ql(nv,i)

         !check for wet/dry boundary
         if (hR.gt.drytol) then
            uR=huR/hR
            vR=hvR/hR
            phiR = 0.5d0*g*hR**2 + huR**2/hR
         else
            hR = 0.d0
            huR = 0.d0
            hvR = 0.d0
            uR = 0.d0
            vR = 0.d0
            phiR = 0.d0
         endif

         if (hL.gt.drytol) then
            uL=huL/hL
            vL=hvL/hL
            phiL = 0.5d0*g*hL**2 + huL**2/hL
         else
            hL=0.d0
            huL=0.d0
            hvL=0.d0
            uL=0.d0
            vL=0.d0
            phiL = 0.d0
         endif

         wall(1) = 1.d0
         wall(2) = 1.d0
         wall(3) = 1.d0
         if (hR.le.drytol) then
            call riemanntype(hL,hL,uL,-uL,hstar,s1m,s2m,
     &                                  rare1,rare2,1,drytol,g)
            hstartest=max(hL,hstar)
            if (hstartest+bL.lt.bR) then !right state should become ghost values that mirror left for wall problem
c                bR=hstartest+bL
               wall(2)=0.d0
               wall(3)=0.d0
               hR=hL
               huR=-huL
               bR=bL
               phiR=phiL
               uR=-uL
               vR=vL
            elseif (hL+bL.lt.bR) then
               bR=hL+bL
            endif
         elseif (hL.le.drytol) then ! right surface is lower than left topo
            call riemanntype(hR,hR,-uR,uR,hstar,s1m,s2m,
     &                                  rare1,rare2,1,drytol,g)
            hstartest=max(hR,hstar)
            if (hstartest+bR.lt.bL) then  !left state should become ghost values that mirror right
c               bL=hstartest+bR
               wall(1)=0.d0
               wall(2)=0.d0
               hL=hR
               huL=-huR
               bL=bR
               phiL=phiR
               uL=-uR
               vL=vR
            elseif (hR+bR.lt.bL) then
               bL=hR+bR
            endif
         endif

         !determine wave speeds
         sL=uL-sqrt(g*hL) ! 1 wave speed of left state
         sR=uR+sqrt(g*hR) ! 2 wave speed of right state

         uhat=(sqrt(g*hL)*uL + sqrt(g*hR)*uR)/(sqrt(g*hR)+sqrt(g*hL)) ! Roe average
         chat=sqrt(g*0.5d0*(hR+hL)) ! Roe average
         sRoe1=uhat-chat ! Roe wave speed 1 wave
         sRoe2=uhat+chat ! Roe wave speed 2 wave

         sE1 = min(sL,sRoe1) ! Eindfeldt speed 1 wave
         sE2 = max(sR,sRoe2) ! Eindfeldt speed 2 wave

         !--------------------end initializing...finally----------
         !solve Riemann problem.

         maxiter = 1

         call riemann_aug_JCP(maxiter,meqn,mwaves,hL,hR,huL,
     &        huR,hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,
     &                                    drytol,g,rho,sw,fw)

C          call riemann_ssqfwave(maxiter,meqn,mwaves,hL,hR,huL,huR,
C      &     hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,
C      &     rho,sw,fw)

C          call riemann_fwave(meqn,mwaves,hL,hR,huL,huR,hvL,hvR,
C      &      bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,rho,sw,
C      &      fw)

c        !eliminate ghost fluxes for wall
         do mw=1,3
            sw(mw)=sw(mw)*wall(mw)

               fw(1,mw)=fw(1,mw)*wall(mw) 
               fw(2,mw)=fw(2,mw)*wall(mw)
               fw(3,mw)=fw(3,mw)*wall(mw)
         enddo

         do mw=1,mwaves
            s(mw,i)=sw(mw)
            fwave(1,mw,i)=fw(1,mw)
            fwave(mu,mw,i)=fw(2,mw)
            fwave(nv,mw,i)=fw(3,mw)
!            write(51,515) sw(mw),fw(1,mw),fw(2,mw),fw(3,mw)
!515         format("++sw",4e25.16)
         enddo

 30      continue
      enddo


c==========Capacity for mapping from latitude longitude to physical space====
        if (mcapa.gt.0) then
         do i=2-mbc,mx+mbc
          if (ixy.eq.1) then
             dxdc=(earth_radius*deg2rad)
          else
             dxdc=earth_radius*cos(auxl(3,i))*deg2rad
          endif

          do mw=1,mwaves
c             if (s(mw,i) .gt. 316.d0) then
c               # shouldn't happen unless h > 10 km!
c                write(6,*) 'speed > 316: i,mw,s(mw,i): ',i,mw,s(mw,i)
c                endif
               s(mw,i)=dxdc*s(mw,i)
               fwave(1,mw,i)=dxdc*fwave(1,mw,i)
               fwave(2,mw,i)=dxdc*fwave(2,mw,i)
               fwave(3,mw,i)=dxdc*fwave(3,mw,i)
          enddo
         enddo
        endif

c===============================================================================


c============= compute fluctuations=============================================

         do i=2-mbc,mx+mbc
            do  mw=1,mwaves
               if (s(mw,i) < 0.d0) then
                     amdq(1:3,i) = amdq(1:3,i) + fwave(1:3,mw,i)
               else if (s(mw,i) > 0.d0) then
                  apdq(1:3,i)  = apdq(1:3,i) + fwave(1:3,mw,i)
               else
                 amdq(1:3,i) = amdq(1:3,i) + 0.5d0 * fwave(1:3,mw,i)
                 apdq(1:3,i) = apdq(1:3,i) + 0.5d0 * fwave(1:3,mw,i)
               endif
            enddo
         enddo

      return
      end subroutine

c
c ---------------------------------------------------------
c
      subroutine grdfit (lbase,lcheck,nvar,naux,cut,time,start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
      dimension  corner(nsize,maxcl)
      integer    numptc(maxcl), prvptr
      logical    fit, nestck, cout
      data       cout/.false./
      integer*1  i1flags(iregsz(lcheck)+2,jregsz(lcheck)+2,
     .                                    kregsz(lcheck)+2)
c
c ::::::::::::::::::::: GRDFIT :::::::::::::::::::::::::::::::::;
c  grdfit called by setgrd and regrid to actually fit the new grids
c         on each level. lcheck is the level being error estimated
c         so that lcheck+1 will be the level of the new grids.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      isize = iregsz(lcheck)
      jsize = jregsz(lcheck)
      ksize = kregsz(lcheck)
c      ldom2 = igetsp((isize+2)*(jsize+2)*(ksize+2))

c ### initialize region start and end indices for new level grids
      iregst(lcheck+1) = iinfinity
      jregst(lcheck+1) = iinfinity
      kregst(lcheck+1) = iinfinity
      iregend(lcheck+1) = -1
      jregend(lcheck+1) = -1
      kregend(lcheck+1) = -1

c     ## flag all grids at given level based on error ests.
c     ## npts is number of points actually colated - some
c     ## flagged points turned off due to proper nesting requirement.
c     ## (storage based on nptmax calculation however).

      call flglvl (nvar, naux, lcheck, nptmax, index, lbase, 
     .             i1flags,npts,start_time,isize,jsize,ksize)
      if (npts .eq. 0) go to 99
c
      levnew    = lcheck + 1
      hxfine    = hxposs(levnew)
      hyfine    = hyposs(levnew)
      hzfine    = hzposs(levnew)
c
c     ## call smart_bisect grid gen. to make the clusters
c        till each cluster ok. needs scratch space.
c
       idim = iregsz(lcheck)
       jdim = jregsz(lcheck)
       kdim = kregsz(lcheck)
       call smartbis(alloc(index),npts,cut,numptc,nclust,lbase,corner,
     2               idim,jdim,kdim)

       if (gprint) then
          write(outunit,103) nclust
          write(outunit,104) (icl, numptc(icl),icl=1,nclust)
 103      format(' ',i4,' clusters after bisect')
 104      format('         cluster ',i5,' has points: ',i6)
       endif
c
c     ##  for each cluster, fit the actual grid, set up some data structures
c
 50   ibase   =  0
      icl     =  1
      prvptr  =  null
c
 70   mnew      = nodget()
 75   call  moment(node(1,mnew),alloc(index+3*ibase),numptc(icl),
     1             usage)

      if (gprint) write(outunit,100) icl,mnew,usage,numptc(icl)
100   format('         cluster ',i5,' new rect.',i5,
     1       ' usage ',e12.5,' with ',i5,' pts.')

      node(ndilo,mnew)     =  node(ndilo,mnew)*intratx(lcheck)
      node(ndjlo,mnew)     =  node(ndjlo,mnew)*intraty(lcheck)
      node(ndklo,mnew)     =  node(ndklo,mnew)*intratz(lcheck)
      node(ndihi,mnew)     = (node(ndihi,mnew)+1)*intratx(lcheck) - 1
      node(ndjhi,mnew)     = (node(ndjhi,mnew)+1)*intraty(lcheck) - 1
      node(ndkhi,mnew)     = (node(ndkhi,mnew)+1)*intratz(lcheck) - 1
      rnode(cornxlo,mnew)  =  node(ndilo,mnew)*hxfine + xlower
      rnode(cornylo,mnew)  =  node(ndjlo,mnew)*hyfine + ylower
      rnode(cornzlo,mnew)  =  node(ndklo,mnew)*hzfine + zlower
      rnode(cornxhi,mnew)  = (node(ndihi,mnew)+1)*hxfine + xlower
      rnode(cornyhi,mnew)  = (node(ndjhi,mnew)+1)*hyfine + ylower
      rnode(cornzhi,mnew)  = (node(ndkhi,mnew)+1)*hzfine + zlower
      node(nestlevel,mnew) = levnew
      rnode(timemult,mnew) = time
c
c     ##  if new grid doesn't fit in base grid, nestck bisect it
c     ##  and returns 2 clusters where there used to be 1.
c
c 2/28/02 : Add naux to argument list; needed by call to outtre in nestck.
      fit = nestck(mnew,lbase,alloc(index+3*ibase),numptc(icl),
     1            numptc,icl,nclust,i1flags,isize,jsize,ksize,nvar,naux)
      if (.not. fit) go to 75
c
c     ##  grid accepted. put in list.
      if (newstl(levnew) .eq. null) then
         newstl(levnew)  = mnew
      else
         node(levelptr,prvptr) = mnew
      endif
      prvptr = mnew
c     # keep track of min and max location of grids at this level
      iregst(levnew)  = MIN(iregst(levnew), node(ndilo,mnew))
      jregst(levnew)  = MIN(jregst(levnew), node(ndjlo,mnew))
      kregst(levnew)  = MIN(kregst(levnew), node(ndklo,mnew))
      iregend(levnew) = MAX(iregend(levnew),node(ndihi,mnew))
      jregend(levnew) = MAX(jregend(levnew),node(ndjhi,mnew))
      kregend(levnew) = MAX(kregend(levnew),node(ndkhi,mnew))

c     ##  on to next cluster
      ibase  = ibase + numptc(icl)
      icl = icl + 1
      if (icl .le. nclust) go to 70

c
c    ##  clean up. for all grids check final size.

      call birect(newstl(levnew))
 99   continue

c    ## may have npts 0 but array was allocated due to initially flagged points
c    ## that were not allowed for proper nesting or other reasons. in this case
c    ## the array was still allocated, so need to test further to see if colating
c    ## array space needs to be reclaimed
      if (nptmax .gt. 0)  call reclam(index, 3*nptmax)
c
c 99   call reclam(ldom2, (isize+2)*(jsize+2)*(ksize+2))

      return
      end

subroutine setprob

    !> Copy this file to your directory and modify to set up problem
    !! parameters or read other data.
    !!
    !! This default version does nothing.

    implicit none

end subroutine setprob

c
c ----------------------------------------------------------------
c
       logical function baseCheck(mnew,lbase,ilo,ihi,
     .                            nvar,naux,thisBuff)

       use amr_module
       implicit double precision (a-h, o-z)

       logical debug/.true./
       integer ist(3),iend(3),ishift(3)
       logical borderx
       integer thisBuff

c      index into alloc from iclo:ichi and jclo:jchi, not 0..leni/j. 
       iadd(i) = locm + i - iclo

c ::::::::::::::::::: baseCheck :::::::::::::::::::::::::::
c
c baseCheck - check that potential grid mnew is completely contained
c             in  coarser grids at level 'lbase' (>1) that will
c             stay fixed during this regridding step
c
c   this version tries to do it without using domflags
c   slower but better if cant afford memory over entire domain
c
c   mcheck is one bigger since for proper nesting, cell must be
c   at least one away from boundary of a parent grid, unless
c   on a domain boundary
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::



       levnew = node(nestlevel,mnew)
       borderx = (ilo .eq. 0 .or. ihi .eq. iregsz(levnew)-1)
       

      if (debug) write(outunit,100) mnew,lbase,ilo,ihi,levnew
 100  format("NESTCK1 testing grid ",i5," base level ",i5,/,
     . " new grid from ilo:hi: (",i12," to ",i12,") at level ",i4)
c
c    on to initializing for the given grid and its nest checking
       levratx = 1
       do 5 lev = lbase, levnew-1
          levratx = levratx * intratx(lev)
 5     continue

c widen by 1 cell (proper nesting), then project to lbase
c this might stick out of domain, fix later
c figure out size for scratch storage on base grid for testing
       iclo = ilo
       ichi = ihi
       do lev = levnew-1,lbase,-1
          iclo = iclo/intratx(lev)
          ichi = ichi/intratx(lev)
          iclo = iclo - 1
          ichi = ichi + 1
          if (debug) then
             write(outunit,111) lev, iclo,ichi
111          format(10x,"at level",i5," projected coords ilo:hi:(",
     &              2i10,")")
          endif
       end do
c      high end of integer grid index truncates during the divide
c      if it were exactly lined up with coarser grid it would
c      not be properly nested, but since we added one to the index 
c      space, we took care of that already.
       if (debug) then
          write(outunit,108) ilo-1,ihi+1
          write(outunit,109) levratx
 108      format(" enlarged (by 1) fine grid from ilo:hi:",2i12)
 109      format(" refinement factors to base grid of ", 2i12)
          write(outunit,101) iclo,ichi
 101      format("coarsened to lbase, grid from iclo:hi: ",2i12)
       endif

       if (.not. (xperdom .and. borderx)) then
          iclo = max(iclo,0)  ! make sure in domain boundary when checking nesting
          ichi = min(ichi,iregsz(lbase)-1) ! subtract 1 since regsz is number of cells, so -1 is highest index
       endif


       leni = ichi - iclo + 1
       lenrect = leni
       locm = igetsp(lenrect)
       alloc(locm:locm+lenrect-1) = 0.
c
c  if mnew on domain boundary fix flags so ok. 
c  fix extra border, and first/last real edge
       if (ilo .eq. 0 .and. .not. xperdom) then
            alloc(iadd(iclo)) = 1.
            alloc(iadd(iclo+1)) = 1.
       endif
       if (ihi .eq. iregsz(levnew)-1 .and. .not. xperdom) then
             alloc(iadd(ichi)) = 1.
             alloc(iadd(ichi-1)) = 1.
       endif

       mptr = lstart(lbase)
 20       iblo = node(ndilo, mptr) - thisBuff
          ibhi = node(ndihi, mptr) + thisBuff
c
          ! non periodic case, base level coordinates, just mark if nested.
          if (.not. (xperdom .and. borderx)) then
              ixlo = max(iclo,iblo)
              ixhi = min(ichi,ibhi)
              if (.not.(ixlo.le.ixhi)) go to 30
              if (debug) write(outunit,105) ixlo,ixhi
105           format("marking nested region from: ",2i10)
              do ix = ixlo, ixhi
                alloc(iadd(ix))=1.
              end do
              go to 30
          endif
c
c          periodic case:  initialize for potential periodicity
c             each patch divided into 9 regions (some may be empty)
c             e.g. i from (ilo,-1), (0,iregsz(level)-1),(iregsz(level),ihi)
c             except using enlarged grid (ilo-1 to ihi+1)
c
       call setIndices(ist,iend,iclo,ichi,
     .                 ishift,lbase)

c          compare all regions of coarsened patch with one lbase grid at a time
           do 25 i = 1, 3
              i1 = max(iclo,ist(i))
              i2 = min(ichi, iend(i))

              if (.not. (i1 .le. i2)) go to 25
c
c           patch (possibly periodically wrapped) not empty.
c           see if intersects base grid. wrap coords for periodicity
              i1_shifted = i1 + ishift(i)
              i2_shifted = i2 + ishift(i)

              ixlo = max(i1_shifted,iblo)
              ixhi = min(i2_shifted,ibhi)

              if (.not.(ixlo.le.ixhi)) go to 25
c     mark intersected regions with 1
              do ix = ixlo, ixhi
c                need to mark nesting of orig coords, not coarsened shifted indices
                 ix_unshifted = (ix - ishift(i)) ! back to unshifted coords
                                                 ! to mark base grid nesting ok
                 alloc(iadd(ix_unshifted)) = 1.
               end do

 25       continue

 30       mptr = node(levelptr, mptr)
          if (mptr .ne. 0) go to 20

c     output for debugging
      if (debug) then
              write(outunit,344)(int(alloc(iadd(i))), i=iclo,ichi)
 344          format(110i1)
       endif

c
c  if any zeroes left mnew not nested
c
       do 40 i = iclo, ichi
          if (alloc(iadd(i)) .eq. 0) then
             baseCheck = .false.
             go to 99
          endif
 40    continue

c      if made it here then grid is nested
       baseCheck = .true.

 99    call reclam(locm, lenrect)

       return 
       end

! =====================================================
subroutine qinit(maxmx,maxmy,num_eqn,num_ghost,mx,my,xlower,ylower, &
                 dx,dy,q,num_aux,aux,Rsphere)
! =====================================================

! Set initial conditions for q.

! -------4-Rossby-Haurwitz wave-----------------------

    implicit double precision (a-h,o-z)
    dimension q(num_eqn, 1-num_ghost:maxmx+num_ghost, 1-num_ghost:maxmy+num_ghost)
    dimension aux(num_aux, 1-num_ghost:maxmx+num_ghost, 1-num_ghost:maxmy+num_ghost)
    double precision :: Uin(3),Uout(3)
    double precision :: K

!f2py integer intent(in) maxmx
!f2py integer intent(in) maxmy
!f2py integer optional,intent(in) num_eqn
!f2py integer intent(in) num_ghost
!f2py integer intent(in) mx
!f2py integer intent(in) my
!f2py double precision intent(in) xlower
!f2py double precision intent(in) ylower
!f2py double precision intent(in) dx
!f2py double precision intent(in) dy
!f2py intent(in,out) q
!f2py integer optional, intent(in)  num_aux
!f2py intent(in) aux
!f2py double precision intent(in) Rsphere

    pi = 4.d0*datan(1.d0)

    ! Parameters
    a = 6.37122d6
    K = 7.848d-6
    Omega = 7.292d-5
    G = 9.80616d0
    t0 = 86400.d0
    h0 = 8.d3
    R = 4.d0
          
    do i=1,mx
        xc = xlower + (i-0.5d0)*dx
        do j=1,my
            yc = ylower + (j-0.5d0)*dy
            call mapc2p(xc,yc,xp,yp,zp,Rsphere)
            ! compute longitude theta from positive x axis:
            rad = dmax1(dsqrt(xp**2 + yp**2),1.d-6)

            if(xp > 0.d0 .AND. yp > 0.d0) then
                theta = dasin(yp/rad)
            elseif(xp < 0.d0 .AND. yp > 0.d0) then
                theta = pi - dasin(yp/rad)
            elseif(xp < 0.d0 .AND. yp < 0.d0) then
                theta = -pi+dasin(-yp/rad)
            elseif(xp > 0.d0 .AND. yp < 0.d0) then
                theta = -dasin(-yp/rad)
            endif

            ! compute phi, at north pole: pi/2 at south pool: -pi/2
            if (zp > 0.d0) then
                phi =  dasin(zp/Rsphere)
            else
                phi = -dasin(-zp/Rsphere)
            endif
        
            xp = theta
            yp = phi
        
            bigA = 0.5d0*K*(2.d0*Omega+K)*dcos(yp)**2.d0 + &
                0.25d0*K*K*dcos(yp)**(2.d0*R)*( &
                (1.d0*R+1.d0)*dcos(yp)**2.d0 &
                +(2.d0*R*R - 1.d0*R - 2.d0) &
                - 2.d0*R*R*(dcos(yp))**(-2.d0))
            bigB = (2.d0*(Omega+K)*K)/((1.d0*R+1.d0)*(1.d0*R+2.d0)) &
                *dcos(yp)**R*( (1.d0*R*R + 2.d0*R + 2.d0) &
                - (1.d0*R+1.d0)**(2)*dcos(yp)**2 )
            bigC = 0.25d0*K*K*dcos(yp)**(2*R)*( (1.d0*R + 1.d0)* &
                dcos(yp)**2 - (1.d0*R + 2.d0))
                         
            ! longitude (angular) velocity component
            Uin(1) = (K*dcos(yp)+K*dcos(yp)**(R-1.)*( R*dsin(yp)**2. &
                - dcos(yp)**2. )*dcos(R*xp))*t0

            ! latitude (angular) velocity component
            Uin(2) = (-K*R*dcos(yp)**(R-1.)*dsin(yp)*dsin(R*xp))*t0

            ! radial velocity component
            Uin(3) = 0.d0
        

            ! calculate velocity vector in cartesian coordinates
            Uout(1) = (-dsin(xp)*Uin(1)-dsin(yp)*dcos(xp)*Uin(2))
            Uout(2) = (dcos(xp)*Uin(1)-dsin(yp)*dsin(xp)*Uin(2))
            Uout(3) = dcos(yp)*Uin(2)
        
            ! set the clawpack initial values:
            q(1,i,j) =  h0/a + (a/G)*( bigA + bigB*dcos(R*xp) &
                + bigC*dcos(2.d0*R*xp))
            q(2,i,j) = q(1,i,j)*Uout(1)
            q(3,i,j) = q(1,i,j)*Uout(2)
            q(4,i,j) = q(1,i,j)*Uout(3)

        end do                        
    end do

    return
end subroutine qinit

! TODO: Need to calculate this for shallow water speeds of each layer
real(kind=8) pure function get_max_speed(val,mitot,mjtot,nvar,aux,naux,nghost,hx,hy)
    
    use geoclaw_module, only: grav,earth_radius,DEG2RAD,coordinate_system,rho
    use multilayer_module, only: dry_tolerance, num_layers
      
    implicit none
    
    ! Arguments
    integer, intent(in) :: mitot,mjtot,nvar,naux,nghost
    real(kind=8), intent(in) :: hx,hy
    real(kind=8), intent(in) :: val(nvar,mitot,mjtot), aux(naux,mitot,mjtot)
    
    ! Locals
    integer :: i,j,k
    real(kind=8) :: ymetric,hyphys,xmetric,hxphys,h,u,v,sig,sp_over_h


    sp_over_h = 0.d0   ! compute max speed over h, since dx may not equal dy
    if (coordinate_system .eq. 2) then
        do j = nghost+1, mjtot-nghost
            ymetric = earth_radius*deg2rad
            hyphys = ymetric*hy

            do i = nghost+1, mitot-nghost
                do k=1,num_layers
                    xmetric = cos(aux(3,i,j)) * earth_radius * DEG2RAD
                    hxphys = xmetric * hx
                    h  = val(3*(k-1)+1,i,j) / rho(k)
                    if (h > dry_tolerance(k)) then
                        u  = val(3*(k-1)+2,i,j) / val(3*(k-1)+1,i,j)
                        v  = val(3*(k-1)+3,i,j) / val(3*(k-1)+1,i,j)
                    else
                        u = 0.d0
                        v = 0.d0
                    endif
                    sig = sqrt(grav*h)
                    sp_over_h = max((abs(u)+sig)/hxphys,(abs(v)+sig)/hyphys,sp_over_h)
                end do
            end do
        end do
    else  ! speeds in cartesian coords, no metrics needed
        do j = nghost+1, mjtot-nghost
            do i = nghost+1, mitot-nghost
                do k=1,num_layers
                    h  = val(3*(k-1)+1,i,j) / rho(k)
                    if (h > dry_tolerance(k)) then
                        u  = val(3*(k-1)+2,i,j)/val(3*(k-1)+1,i,j)
                        v  = val(3*(k-1)+3,i,j)/val(3*(k-1)+1,i,j)
                    else
                        u = 0.d0
                        v = 0.d0
                    endif
                    sig = sqrt(grav*h)
                    sp_over_h = max((abs(u)+sig)/hx,(abs(v)+sig)/hy,sp_over_h)
                end do
            end do
        end do
    endif
      
    get_max_speed = sp_over_h

end function get_max_speed

! ==============================================================================
!  Point-wise version of the acoustics problem
! ==============================================================================

subroutine rp1_ptwise(num_eqn, num_aux, num_waves, q_l, q_r, aux_l, aux_r,    &
                      wave, s, amdq, apdq)

    implicit none

    ! Input Arguments
    integer, intent(in) :: num_eqn, num_aux, num_waves
    real(kind=8), intent(in out) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in out) :: aux_l(num_aux), aux_r(num_aux)

    ! Output arguments
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Locals
    real(kind=8) :: delta(2), a(2)

    ! Common block
    real(kind=8) :: rho, bulk, cc, zz

    common /cparam/ rho, bulk, cc, zz

    delta = q_r - q_l

    a(1) = (-delta(1) + zz * delta(2)) / (2.d0 * zz)
    a(2) = ( delta(1) + zz * delta(2)) / (2.d0 * zz)

    wave(1, 1) = -a(1) * zz
    wave(2, 1) =  a(1)
    s(1) = -cc

    wave(1, 2) = a(2) * zz
    wave(2, 2) = a(2)
    s(2) = cc

    amdq = s(1) * wave(:, 1)
    apdq = s(2) * wave(:, 2)

end subroutine rp1_ptwise

      subroutine setprob
      implicit double precision (a-h,o-z)
      character*25 fname
      common /cqinit/ A1,beta1,x1,y1, A2,beta2,x2,y2
c
c     # read data values for this problem
c
c
      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)
                

c     # These parameters are used in qinit.f
      read(7,*) A1
      read(7,*) beta1
      read(7,*) x1
      read(7,*) y1
      read(7,*) A2
      read(7,*) beta2
      read(7,*) x2
      read(7,*) y2

      close(unit=7)

      return
      end

subroutine setprob

    ! Copy this file to your directory and modify to set up problem
    ! parameters or read other data.
    !
    ! This default version does nothing.

    implicit none

end subroutine setprob

c
c
c     ==================================================================
      subroutine rptt3(ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx,
     &                  ql,qr,aux1,aux2,aux3,bsasdq,
     &                  cmbsasdq,cpbsasdq)
c     ==================================================================
c
c     # Double transverse Riemann solver.
c     # This is a dummy routine that returns zeros and is only intended
c     # to illustrate the format of this routine.  See various example
c     # directories for better examples.

c     # This dummy routine can be used if double transverse solves are not being
c     # used, i.e. if method(3) = 0, 10, or 20.
c     #
c     # On input,
c
c     #    ql,qr is the data along some one-dimensional slice, as in rpn3
c     #         This slice is
c     #             in the x-direction if ixyz=1,
c     #             in the y-direction if ixyz=2, or
c     #             in the z-direction if ixyz=3.
c
c     #    bsasdq is an array of flux differences that result from a
c     #         transverse splitting (a previous call to rpt3).  
c     #         This stands for B^* A^* \Dq but could represent any of 
c     #         6 possibilities, e.g.  C^* B^* \Dq, as specified by ixyz
c     #         and icoor (see below).
c     #         Moreover, each * represents either + or -, as specified by
c     #         imp and impt.
c
c     #    ixyz indicates the direction of the original Riemann solve,
c     #         called the x-like direction in the table below:
c
c     #               x-like direction   y-like direction   z-like direction
c     #      ixyz=1:        x                  y                  z         
c     #      ixyz=2:        y                  z                  x         
c     #      ixyz=3:        z                  x                  y         
c
c     #    icoor indicates direction in which the transverse solve should 
c     #         be performed.
c     #      icoor=2: split in the y-like direction.
c     #      icoor=3: split in the z-like direction.
c
c     #    For example,
c     #        ixyz=1, icoor=3 means bsasdq=B^*A^*\Dq, and should be 
c     #                        split in z into 
c     #                           cmbsasdq = C^-B^*A^*\Dq,
c     #                           cpbsasdq = C^+B^*A^*\Dq.
c     #
c     #        ixyz=2, icoor=3 means bsasdq=C^*B^*\Dq, and should be
c     #                        split in x into 
c     #                           cmbsasdq = A^-C^*B^*\Dq,
c     #                           cpbsasdq = A^+C^*B^*\Dq.
c
c     #    The parameters imp and impt are generally needed only if aux
c     #    arrays are being used, in order to access the appropriate
c     #    variable coefficients.

c
      implicit real*8(a-h,o-z)
      dimension       ql(meqn, 1-mbc:maxm+mbc)
      dimension       qr(meqn, 1-mbc:maxm+mbc)
      dimension   bsasdq(meqn, 1-mbc:maxm+mbc)
      dimension cmbsasdq(meqn, 1-mbc:maxm+mbc)
      dimension cpbsasdq(meqn, 1-mbc:maxm+mbc)
      dimension     aux1(maux, 1-mbc:maxm+mbc, 3)
      dimension     aux2(maux, 1-mbc:maxm+mbc, 3)
      dimension     aux3(maux, 1-mbc:maxm+mbc, 3)

      do i = 2-mbc, mx+mbc
         do m=1,meqn
            cmbsasdq(m,i) = 0.d0
            cpbsasdq(m,i) = 0.d0
         enddo
      enddo
c
      return
      end

!======================================================================
subroutine topo_update(t)
!======================================================================
!
!  called to update topography grids to the current time t
!  topo arrays are modified directly from topo0 and dtopo
!
!  this routine replaces the old method implemented in movetopo
!  where dtopo modified aux arrays directly. Now aux values are
!  always determined from topography grids.
!
!                   David George, dgeorge@usgs.gov, December 20 2013


   use topo_module

   implicit none

   !arguments
   real(kind=8), intent(in) ::t

   !locals
   integer :: m,mt
   integer :: irank,idtopo1,idtopo2,jdtopo1,jdtopo2
   integer(kind=8) :: ij,ij0,i,j,ijll,ijlr,ijul,ijur
   real(kind=8) :: x,y,xl,xr,yu,yl,zll,zlr,zul,zur,dz12,dz1,dz2,dztotal

   if (t<minval(t0dtopo).or.topo_finalized.eqv..true.) then
      return
   endif

   if (minval(topotime)>=maxval(tfdtopo)) then
      topo_finalized = .true.
      return
   endif

   !first find t related values to avoid calculation for every i,j
   do m=1,num_dtopo
      ! Find indices and times of dtopo arrays bracketing time t, and
      ! also taudtopo, the fraction of step between, used for interpolation.
      ! Note that if t < t0dtopo(m) then index is set to 1 but later 
      ! this dtopo array is skipped altogether in this case and doesn't
      ! affect topography at time t.
      if (mtdtopo(m) == 1) then
          ! Special case: instantaneous displacement at one instant in time
          kdtopo1(m) = 1
          kdtopo2(m) = 1
          tdtopo1(m) = t
          tdtopo2(m) = t
          taudtopo(m) = 0.d0
        else
          kdtopo1(m) = int(floor((t-t0dtopo(m))/dtdtopo(m)))+1
          kdtopo2(m) = int(ceiling((t-t0dtopo(m))/dtdtopo(m)))+1
          kdtopo1(m) = min(kdtopo1(m),mtdtopo(m))
          kdtopo2(m) = min(kdtopo2(m),mtdtopo(m))
          kdtopo1(m) = max(kdtopo1(m),1)
          kdtopo2(m) = max(kdtopo2(m),1)
          tdtopo1(m) = t0dtopo(m)+ dtdtopo(m)*real(kdtopo1(m)-1,kind=8) ! <= t
          tdtopo2(m) = t0dtopo(m)+ dtdtopo(m)*real(kdtopo2(m)-1,kind=8) ! >= t
          taudtopo(m) = 1.d0-max(0.d0,((t-tdtopo1(m))/dtdtopo(m)))
          taudtopo(m) = max(taudtopo(m),0.d0)
        endif
      index0_dtopowork1(m) = i0dtopo(m) + (int(kdtopo1(m), 8)-1)*int(mxdtopo(m), 8)*int(mydtopo(m), 8)
      index0_dtopowork2(m) = i0dtopo(m) + (int(kdtopo2(m), 8)-1)*int(mxdtopo(m), 8)*int(mydtopo(m), 8)
   enddo


   !first set topofiles aligned exactly with corresponding dtopo
   !do i= mtopofiles - num_dtopo + 1, mtopofiles !topofile
   !   m = i - mtopofiles + num_dtopo !corresponding dtopofile
      !interpolate in time directly for matching nodes
   !   if (t<t0dtopo(m).or.topotime(i)>tfdtopo(m)) then
         !dtopo has not started or topo has already been set from final dz
   !      cycle
   !   endif
   !   topowork(i0topo(i):i0topo(i) + mtopo(i)-1) = &
   !            topo0work(i0topo0(i):i0topo0(i) + mtopo(i)-1) &!initial topo
   !            + taudtopo(m)*dtopowork(index0_dtopowork1(m):index0_dtopowork1(m) + mtopo(i)-1) &
   !            + (1.0-taudtopo(m))*dtopowork(index0_dtopowork2(m):index0_dtopowork2(m) + mtopo(i)-1)
      !set time-stamp
   !   topotime(i) = t
   !enddo


   !set non-dtopo associated topofiles
   !rather, set all topofiles
   do mt=1,mtopofiles
      if (topo0save(mt)<=0) then
         !no intersection or dtopo area already covered by finer topo files
         !shouldn't ever need to alter this topofile
         topotime(mt)=t
         cycle
      endif
      if (topotime(mt)==t) then
         !topofile is already at correct time
         !this should catch the files set in the first loop above for topo/dtopo files
         cycle
      endif

      do j=1,int(mytopo(mt), 8)
         y = yhitopo(mt) - real(j-1,kind=8)*dytopo(mt)
         do i=1,int(mxtopo(mt), 8)
            ij = i0topo(mt) + (j-1)*int(mxtopo(mt), 8) + i -1
            ij0 = i0topo0(mt) + (j-1)*int(mxtopo(mt), 8) + i -1
            x = xlowtopo(mt) +  real(i-1,kind=8)*dxtopo(mt)
            dztotal = 0.0
            do irank = 1,num_dtopo
               m = mdtopoorder(irank)
               if ( (x>xhidtopo(m)).or.(x<xlowdtopo(m)).or. &
                          (y>yhidtopo(m)).or.(y<ylowdtopo(m))) then
                     !no intersection of point with this dtopo
                     cycle
               endif

               !if (t<t0dtopo(m).or.topotime(mt)>tfdtopo(m)) then
               if (t<t0dtopo(m)) then
                  !this dtopo does not take place yet or topo has already been set for final dz from this dtopo
                  !this is important to skip, because of limits set above that would use the initial dz even when t<t0dtopo. this should be revisited
                  !intersection might be with another dtopo with different time bands
                  cycle
               endif
               !find indices for bilinear dtopo
               !dtopo arrays are in form of DEM...high y values first
               !note for xy points lying on nodes all indices will be equal

               ! rewritten to avoid roundoff pushing outside of proper range:
               ! note above is no longer true but interp should be fine
               idtopo1 = int(floor((x-xlowdtopo(m))/dxdtopo(m)))+1
               idtopo1 = max(1, min(mxdtopo(m)-1, idtopo1))
               idtopo2 = idtopo1+1
               jdtopo1 = int(floor((yhidtopo(m)-y)/dydtopo(m))) + 1
               jdtopo1 = max(1, min(mydtopo(m)-1, jdtopo1))
               jdtopo2 = jdtopo1+1

               !indices for dtopo work array
               ijll = index0_dtopowork1(m) + int(jdtopo2-1, 8)*int(mxdtopo(m), 8) + int(idtopo1, 8) -1
               ijlr = index0_dtopowork1(m) + int(jdtopo2-1, 8)*int(mxdtopo(m), 8) + int(idtopo2, 8) -1
               ijul = index0_dtopowork1(m) + int(jdtopo1-1, 8)*int(mxdtopo(m), 8) + int(idtopo1, 8) -1
               ijur = index0_dtopowork1(m) + int(jdtopo1-1, 8)*int(mxdtopo(m), 8) + int(idtopo2, 8) -1

               !find x,y,z values for bilinear
               !z may be from only 1 or 2 nodes for coincidently aligned grids
               !bilinear should still evaluate correctly
               zll = dtopowork(ijll)
               zlr = dtopowork(ijlr)
               zul = dtopowork(ijul)
               zur = dtopowork(ijur)
               xl = xlowdtopo(m) + real(idtopo1-1,kind=8)*dxdtopo(m)
               xr = xl + dxdtopo(m)
               yu = yhidtopo(m) - real(jdtopo1-1,kind=8)*dydtopo(m)
               yl = yu - dydtopo(m)

               !bilinear value at (x,y) of dtopo cell at t=tdtopo1
               dz1 = zll*(xr-x)*(yu-y) + zlr*(x-xl)*(yu-y) + zul*(xr-x)*(y-yl) + zur*(x-xl)*(y-yl)

               !indices for work array at later time
               ijll = index0_dtopowork2(m) + int(jdtopo2-1, 8)*int(mxdtopo(m), 8) + int(idtopo1, 8) -1
               ijlr = index0_dtopowork2(m) + int(jdtopo2-1, 8)*int(mxdtopo(m), 8) + int(idtopo2, 8) -1
               ijul = index0_dtopowork2(m) + int(jdtopo1-1, 8)*int(mxdtopo(m), 8) + int(idtopo1, 8) -1
               ijur = index0_dtopowork2(m) + int(jdtopo1-1, 8)*int(mxdtopo(m), 8) + int(idtopo2, 8) -1
               zll = dtopowork(ijll)
               zlr = dtopowork(ijlr)
               zul = dtopowork(ijul)
               zur = dtopowork(ijur)
               !bilinear value of at (x,y) of dtopo cell at t=tdtopo2
               dz2 = zll*(xr-x)*(yu-y) + zlr*(x-xl)*(yu-y) + zul*(xr-x)*(y-yl) + zur*(x-xl)*(y-yl)
               dz12 = taudtopo(m)*dz1 + (1.0-taudtopo(m))*dz2
               dz12 = dz12/(dxdtopo(m)*dydtopo(m))
               !found value from finest dtopo, move to next point
               !exit
               !rather, don't exit, add dtopo
               dztotal = dztotal + dz12
            enddo
            !set topo value from ALL dtopo
            topowork(ij) = topo0work(ij0) + dztotal
         enddo
      enddo
      topotime(mt) = t
   enddo


end subroutine topo_update

!
! :::::::::::::::::::::::: TRIMBD :::::::::::::::::::::::::::;
!  if used array is completely set (=1.) then return set=true, 
!  otherwise return false, along with the dimensions of the smallest 
!  rectangle containing all unset points in il,ir,jb,jt.
! ::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::;
!
!> Examine the setting status of a patch.
!!
!! If used array is completely set (=1.) then return set=true, 
!! otherwise return false, along with the dimensions of the smallest 
!! rectangle containing all unset points in unset_rect(4)
!!
!! **Input**: 
!! * an array of flags for the patch
!! * size of the patch
!!
!! **Output**:
!! * examine results
!! * which region is not set
!! 
!! \param used flags for the whole patch
!! \param nrow size of the patch in *i* direction
!! \param ncol size of the patch in *j* direction
!! \param set output whether the patch is completely set
!! \param unset_rect the smallest rectangle that contains all unset points. 
!! The rectangle is described by its lower left corner, (unset_rect(1), unset_rect(3)), 
!! and its upper right corner, (unset_rect(2), unset_rect(4)).
!!
!! \callgraph
!! \callergraph
subroutine trimbd(used,nrow,ncol,set,unset_rect)

    implicit none

    ! Input
    integer, intent(in) :: nrow, ncol
    integer(kind=1), intent(in) :: used(nrow,ncol)

    ! Output
    logical, intent(out) :: set
!     integer, intent(out) :: il, ir, jb, jt
    integer, intent(out) :: unset_rect(4)

    ! Locals
    integer :: i, j, utot
    integer(kind=1) :: check

       utot = 0
        do j = 1,ncol
        do i = 1,nrow
           utot = utot + used(i,j)
        end do
        end do

    if (utot .eq. nrow * ncol ) then
        set = .true.
    else
        set = .false.
 
        check = 1
        do i = 1,nrow
             do j = 1,ncol
                check = min(check,used(i,j))
            enddo
            unset_rect(1) = i
            if (check == 0) exit
        enddo

        check = 1
        do i = 1,nrow
            do j = 1,ncol
                check = min(check,used(nrow - i + 1,j))
            enddo
            unset_rect(2) = nrow - i + 1
            if (check == 0) exit
        enddo

        check = 1
        do j = 1,ncol
            do i = 1,nrow
                check = min(check,used(i,j))
            enddo
           unset_rect(3) = j
           if (check == 0) exit
        enddo
     
       check = 1
        do j = 1,ncol
            do i = 1,nrow
                check = min(check,used(i,ncol - j + 1))
            enddo
            unset_rect(4) = ncol - j + 1
            if (check == 0) exit
        enddo

    endif

end subroutine trimbd

c-----------------------------------------------------------------------
      subroutine riemann_aug_JCP(maxiter,meqn,mwaves,hL,hR,huL,huR,
     &   hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,rho,
     &   sw,fw)

      ! solve shallow water equations given single left and right states
      ! This solver is described in J. Comput. Phys. (6): 3089-3113, March 2008
      ! Augmented Riemann Solvers for the Shallow Equations with Steady States and Inundation

      ! To use the original solver call with maxiter=1.

      ! This solver allows iteration when maxiter > 1. The iteration seems to help with
      ! instabilities that arise (with any solver) as flow becomes transcritical over variable topo
      ! due to loss of hyperbolicity.

      implicit none

      !input
      integer meqn,mwaves,maxiter
      double precision fw(meqn,mwaves)
      double precision sw(mwaves)
      double precision hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,sE1,sE2
      double precision hvL,hvR,vL,vR,pL,pR
      double precision drytol,g,rho


      !local
      integer m,mw,k,iter
      double precision A(3,3)
      double precision r(3,3)
      double precision lambda(3)
      double precision del(3)
      double precision beta(3)

      double precision delh,delhu,delphi,delb,delnorm
      double precision rare1st,rare2st,sdelta,raremin,raremax
      double precision criticaltol,convergencetol,raretol
      double precision criticaltol_2, hustar_interface
      double precision s1s2bar,s1s2tilde,hbar,hLstar,hRstar,hustar
      double precision huRstar,huLstar,uRstar,uLstar,hstarHLL
      double precision deldelh,deldelphi,delP
      double precision s1m,s2m,hm
      double precision det1,det2,det3,determinant

      logical rare1,rare2,rarecorrector,rarecorrectortest,sonic

      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL
      delP = pR - pL
      delnorm = delh**2 + delphi**2

      call riemanntype(hL,hR,uL,uR,hm,s1m,s2m,rare1,rare2,
     &                                          1,drytol,g)


      lambda(1)= min(sE1,s2m) !Modified Einfeldt speed
      lambda(3)= max(sE2,s1m) !Modified Eindfeldt speed
      sE1=lambda(1)
      sE2=lambda(3)
      lambda(2) = 0.d0  ! ### Fix to avoid uninitialized value in loop on mw -- Correct?? ###

      
      hstarHLL = max((huL-huR+sE2*hR-sE1*hL)/(sE2-sE1),0.d0) ! middle state in an HLL solve

c     !determine the middle entropy corrector wave------------------------
      rarecorrectortest=.false.
      rarecorrector=.false.
      if (rarecorrectortest) then
         sdelta=lambda(3)-lambda(1)
         raremin = 0.5d0
         raremax = 0.9d0
         if (rare1.and.sE1*s1m.lt.0.d0) raremin=0.2d0
         if (rare2.and.sE2*s2m.lt.0.d0) raremin=0.2d0
         if (rare1.or.rare2) then
            !see which rarefaction is larger
            rare1st=3.d0*(sqrt(g*hL)-sqrt(g*hm))
            rare2st=3.d0*(sqrt(g*hR)-sqrt(g*hm))
            if (max(rare1st,rare2st).gt.raremin*sdelta.and.
     &         max(rare1st,rare2st).lt.raremax*sdelta) then
                  rarecorrector=.true.
               if (rare1st.gt.rare2st) then
                  lambda(2)=s1m
               elseif (rare2st.gt.rare1st) then
                  lambda(2)=s2m
               else
                  lambda(2)=0.5d0*(s1m+s2m)
               endif
            endif
         endif
         if (hstarHLL.lt.min(hL,hR)/5.d0) rarecorrector=.false.
      endif

c     ## Is this correct 2-wave when rarecorrector == .true. ??
      do mw=1,mwaves
         r(1,mw)=1.d0
         r(2,mw)=lambda(mw)
         r(3,mw)=(lambda(mw))**2
      enddo
      if (.not.rarecorrector) then
         lambda(2) = 0.5d0*(lambda(1)+lambda(3))
c         lambda(2) = max(min(0.5d0*(s1m+s2m),sE2),sE1)
         r(1,2)=0.d0
         r(2,2)=0.d0
         r(3,2)=1.d0
      endif
c     !---------------------------------------------------


c     !determine the steady state wave -------------------
      !criticaltol = 1.d-6
      ! MODIFIED:
      criticaltol = max(drytol*g, 1d-6)
      criticaltol_2 = sqrt(criticaltol)
      deldelh = -delb
      deldelphi = -0.5d0 * (hR + hL) * (g * delb + delp / rho)

c     !determine a few quanitites needed for steady state wave if iterated
      hLstar=hL
      hRstar=hR
      uLstar=uL
      uRstar=uR
      huLstar=uLstar*hLstar
      huRstar=uRstar*hRstar

      !iterate to better determine the steady state wave
      convergencetol=1.d-6
      do iter=1,maxiter
         !determine steady state wave (this will be subtracted from the delta vectors)
         if (min(hLstar,hRstar).lt.drytol.and.rarecorrector) then
            rarecorrector=.false.
            hLstar=hL
            hRstar=hR
            uLstar=uL
            uRstar=uR
            huLstar=uLstar*hLstar
            huRstar=uRstar*hRstar
            lambda(2) = 0.5d0*(lambda(1)+lambda(3))
c           lambda(2) = max(min(0.5d0*(s1m+s2m),sE2),sE1)
            r(1,2)=0.d0
            r(2,2)=0.d0
            r(3,2)=1.d0
         endif

         hbar =  max(0.5d0*(hLstar+hRstar),0.d0)
         s1s2bar = 0.25d0*(uLstar+uRstar)**2 - g*hbar
         s1s2tilde= max(0.d0,uLstar*uRstar) - g*hbar

c        !find if sonic problem
         ! MODIFIED from 5.3.1 version
         sonic = .false.
         if (abs(s1s2bar) <= criticaltol) then
            sonic = .true.
         else if (s1s2bar*s1s2tilde <= criticaltol**2) then
            sonic = .true.
         else if (s1s2bar*sE1*sE2 <= criticaltol**2) then
            sonic = .true.
         else if (min(abs(sE1),abs(sE2)) < criticaltol_2) then
            sonic = .true.
         else if (sE1 <  criticaltol_2 .and. s1m > -criticaltol_2) then
            sonic = .true.
         else if (sE2 > -criticaltol_2 .and. s2m <  criticaltol_2) then
            sonic = .true.
         else if ((uL+dsqrt(g*hL))*(uR+dsqrt(g*hR)) < 0.d0) then
            sonic = .true.
         else if ((uL- dsqrt(g*hL))*(uR- dsqrt(g*hR)) < 0.d0) then
            sonic = .true.
         end if

c        !find jump in h, deldelh
         if (sonic) then
            deldelh =  -delb
         else
            deldelh = delb*g*hbar/s1s2bar
         endif
c        !find bounds in case of critical state resonance, or negative states
         if (sE1.lt.-criticaltol.and.sE2.gt.criticaltol) then
            deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE2)
            deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE1)
         elseif (sE1.ge.criticaltol) then
            deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE1)
            deldelh = max(deldelh,-hL)
         elseif (sE2.le.-criticaltol) then
            deldelh = min(deldelh,hR)
            deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE2)
         endif

c        ! adjust deldelh for well-balancing of atmospheric pressure difference 
         deldelh = deldelh - delP/(rho*g)

c        !find jump in phi, deldelphi
         if (sonic) then
            deldelphi = -g*hbar*delb
         else
            deldelphi = -delb*g*hbar*s1s2tilde/s1s2bar
         endif
c        !find bounds in case of critical state resonance, or negative states
         deldelphi=min(deldelphi,g*max(-hLstar*delb,-hRstar*delb))
         deldelphi=max(deldelphi,g*min(-hLstar*delb,-hRstar*delb))
         deldelphi = deldelphi - hbar * delp / rho

         del(1)=delh-deldelh
         del(2)=delhu
         del(3)=delphi-deldelphi

c        !Determine determinant of eigenvector matrix========
         det1=r(1,1)*(r(2,2)*r(3,3)-r(2,3)*r(3,2))
         det2=r(1,2)*(r(2,1)*r(3,3)-r(2,3)*r(3,1))
         det3=r(1,3)*(r(2,1)*r(3,2)-r(2,2)*r(3,1))
         determinant=det1-det2+det3

c        !solve for beta(k) using Cramers Rule=================
         do k=1,3
            do mw=1,3
                  A(1,mw)=r(1,mw)
                  A(2,mw)=r(2,mw)
                  A(3,mw)=r(3,mw)
            enddo
            A(1,k)=del(1)
            A(2,k)=del(2)
            A(3,k)=del(3)
            det1=A(1,1)*(A(2,2)*A(3,3)-A(2,3)*A(3,2))
            det2=A(1,2)*(A(2,1)*A(3,3)-A(2,3)*A(3,1))
            det3=A(1,3)*(A(2,1)*A(3,2)-A(2,2)*A(3,1))
            beta(k)=(det1-det2+det3)/determinant
         enddo

         !exit if things aren't changing
         if (abs(del(1)**2+del(3)**2-delnorm).lt.convergencetol) exit
         delnorm = del(1)**2+del(3)**2
         !find new states qLstar and qRstar on either side of interface
         hLstar=hL
         hRstar=hR
         uLstar=uL
         uRstar=uR
         huLstar=uLstar*hLstar
         huRstar=uRstar*hRstar
         do mw=1,mwaves
            if (lambda(mw).lt.0.d0) then
               hLstar= hLstar + beta(mw)*r(1,mw)
               huLstar= huLstar + beta(mw)*r(2,mw)
            endif
         enddo
         do mw=mwaves,1,-1
            if (lambda(mw).gt.0.d0) then
               hRstar= hRstar - beta(mw)*r(1,mw)
               huRstar= huRstar - beta(mw)*r(2,mw)
            endif
         enddo

         if (hLstar.gt.drytol) then
            uLstar=huLstar/hLstar
         else
            hLstar=max(hLstar,0.d0)
            uLstar=0.d0
         endif
         if (hRstar.gt.drytol) then
            uRstar=huRstar/hRstar
         else
            hRstar=max(hRstar,0.d0)
            uRstar=0.d0
         endif

      enddo ! end iteration on Riemann problem

      fw(:,:) = 0.d0  ! initialize before setting some waves

      do mw=1,mwaves
         sw(mw)=lambda(mw)
         fw(1,mw)=beta(mw)*r(2,mw)
         fw(2,mw)=beta(mw)*r(3,mw)
         fw(3,mw)=beta(mw)*r(2,mw)
      enddo
      !find transverse components (ie huv jumps).
      ! MODIFIED from 5.3.1 version
      fw(3,1)=fw(3,1)*vL
      fw(3,3)=fw(3,3)*vR
      fw(3,2)= 0.d0
 
      hustar_interface = huL + fw(1,1)   ! = huR - fw(1,3)
      if (hustar_interface <= 0.0d0) then
          fw(3,1) = fw(3,1) + (hR*uR*vR - hL*uL*vL - fw(3,1)- fw(3,3))
        else
          fw(3,3) = fw(3,3) + (hR*uR*vR - hL*uL*vL - fw(3,1)- fw(3,3))
        end if


      return

      end !subroutine riemann_aug_JCP-------------------------------------------------


c-----------------------------------------------------------------------
      subroutine riemann_ssqfwave(maxiter,meqn,mwaves,hL,hR,huL,huR,
     &    hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,sE1,sE2,drytol,g,
     &    rho,sw,fw)

      ! solve shallow water equations given single left and right states
      ! steady state wave is subtracted from delta [q,f]^T before decomposition

      implicit none

      !input
      integer meqn,mwaves,maxiter

      double precision hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,sE1,sE2
      double precision vL,vR,hvL,hvR,pL,pR
      double precision drytol,g,rho

      !local
      integer iter

      logical sonic

      double precision delh,delhu,delphi,delb,delhdecomp,delphidecomp
      double precision s1s2bar,s1s2tilde,hbar,hLstar,hRstar,hustar
      double precision uRstar,uLstar,hstarHLL
      double precision deldelh,deldelphi,delP
      double precision alpha1,alpha2,beta1,beta2,delalpha1,delalpha2
      double precision criticaltol,convergencetol
      double precision sL,sR
      double precision uhat,chat,sRoe1,sRoe2

      double precision sw(mwaves)
      double precision fw(meqn,mwaves)

      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL
      delP = pR - pL

      convergencetol= 1.d-16
      criticaltol = 1.d-99

      deldelh = -delb
      deldelphi = -0.5d0 * (hR + hL) * (g * delb + delP / rho)

!     !if no source term, skip determining steady state wave
      if (abs(delb).gt.0.d0) then
!
         !determine a few quanitites needed for steady state wave if iterated
         hLstar=hL
         hRstar=hR
         uLstar=uL
         uRstar=uR
         hstarHLL = max((huL-huR+sE2*hR-sE1*hL)/(sE2-sE1),0.d0) ! middle state in an HLL solve

         alpha1=0.d0
         alpha2=0.d0

!        !iterate to better determine Riemann problem
         do iter=1,maxiter

            !determine steady state wave (this will be subtracted from the delta vectors)
            hbar =  max(0.5d0*(hLstar+hRstar),0.d0)
            s1s2bar = 0.25d0*(uLstar+uRstar)**2 - g*hbar
            s1s2tilde= max(0.d0,uLstar*uRstar) - g*hbar


c           !find if sonic problem
            sonic=.false.
            if (abs(s1s2bar).le.criticaltol) sonic=.true.
            if (s1s2bar*s1s2tilde.le.criticaltol) sonic=.true.
            if (s1s2bar*sE1*sE2.le.criticaltol) sonic = .true.
            if (min(abs(sE1),abs(sE2)).lt.criticaltol) sonic=.true.

c           !find jump in h, deldelh
            if (sonic) then
               deldelh =  -delb
            else
               deldelh = delb*g*hbar/s1s2bar
            endif
!           !bounds in case of critical state resonance, or negative states
            if (sE1.lt.-criticaltol.and.sE2.gt.criticaltol) then
               deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE2)
               deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE1)
            elseif (sE1.ge.criticaltol) then
               deldelh = min(deldelh,hstarHLL*(sE2-sE1)/sE1)
               deldelh = max(deldelh,-hL)
            elseif (sE2.le.-criticaltol) then
               deldelh = min(deldelh,hR)
               deldelh = max(deldelh,hstarHLL*(sE2-sE1)/sE2)
            endif

c           !find jump in phi, deldelphi
            if (sonic) then
               deldelphi = -g*hbar*delb
            else
               deldelphi = -delb*g*hbar*s1s2tilde/s1s2bar
            endif
!           !bounds in case of critical state resonance, or negative states
            deldelphi=min(deldelphi,g*max(-hLstar*delb,-hRstar*delb))
            deldelphi=max(deldelphi,g*min(-hLstar*delb,-hRstar*delb))

!---------determine fwaves ------------------------------------------

!           !first decomposition
            delhdecomp = delh-deldelh
            delalpha1 = (sE2*delhdecomp - delhu)/(sE2-sE1)-alpha1
            alpha1 = alpha1 + delalpha1
            delalpha2 = (delhu - sE1*delhdecomp)/(sE2-sE1)-alpha2
            alpha2 = alpha2 + delalpha2

            !second decomposition
            delphidecomp = delphi - deldelphi
            beta1 = (sE2*delhu - delphidecomp)/(sE2-sE1)
            beta2 = (delphidecomp - sE1*delhu)/(sE2-sE1)

            if ((delalpha2**2+delalpha1**2).lt.convergencetol**2) then
               exit
            endif
!
            if (sE2.gt.0.d0.and.sE1.lt.0.d0) then
               hLstar=hL+alpha1
               hRstar=hR-alpha2
c               hustar=huL+alpha1*sE1
               hustar = huL + beta1
            elseif (sE1.ge.0.d0) then
               hLstar=hL
               hustar=huL
               hRstar=hR - alpha1 - alpha2
            elseif (sE2.le.0.d0) then
               hRstar=hR
               hustar=huR
               hLstar=hL + alpha1 + alpha2
            endif
!
            if (hLstar.gt.drytol) then
               uLstar=hustar/hLstar
            else
               hLstar=max(hLstar,0.d0)
               uLstar=0.d0
            endif
!
            if (hRstar.gt.drytol) then
               uRstar=hustar/hRstar
            else
               hRstar=max(hRstar,0.d0)
               uRstar=0.d0
            endif

         enddo
      endif

      delhdecomp = delh - deldelh
      delphidecomp = delphi - deldelphi

      !first decomposition
      alpha1 = (sE2*delhdecomp - delhu)/(sE2-sE1)
      alpha2 = (delhu - sE1*delhdecomp)/(sE2-sE1)

      !second decomposition
      beta1 = (sE2*delhu - delphidecomp)/(sE2-sE1)
      beta2 = (delphidecomp - sE1*delhu)/(sE2-sE1)

      ! 1st nonlinear wave
      fw(1,1) = alpha1*sE1
      fw(2,1) = beta1*sE1
      fw(3,1) = fw(1,1)*vL
      ! 2nd nonlinear wave
      fw(1,3) = alpha2*sE2
      fw(2,3) = beta2*sE2
      fw(3,3) = fw(1,3)*vR
      ! advection of transverse wave
      fw(1,2) = 0.d0
      fw(2,2) = 0.d0
      fw(3,2) = hR*uR*vR - hL*uL*vL -fw(3,1)-fw(3,3)
      !speeds
      sw(1)=sE1
      sw(2)=0.5d0*(sE1+sE2)
      sw(3)=sE2

      return

      end subroutine !-------------------------------------------------


c-----------------------------------------------------------------------
      subroutine riemann_fwave(meqn,mwaves,hL,hR,huL,huR,hvL,hvR,
     &            bL,bR,uL,uR,vL,vR,phiL,phiR,pL,pR,s1,s2,drytol,g,rho,
     &            sw,fw)

      ! solve shallow water equations given single left and right states
      ! solution has two waves.
      ! flux - source is decomposed.

      implicit none

      !input
      integer meqn,mwaves

      double precision hL,hR,huL,huR,bL,bR,uL,uR,phiL,phiR,s1,s2
      double precision hvL,hvR,vL,vR,pL,pR
      double precision drytol,g,rho

      double precision sw(mwaves)
      double precision fw(meqn,mwaves)

      !local
      double precision delh,delhu,delphi,delb,delhdecomp,delphidecomp
      double precision deldelh,deldelphi,delP
      double precision beta1,beta2


      !determine del vectors
      delh = hR-hL
      delhu = huR-huL
      delphi = phiR-phiL
      delb = bR-bL
      delP = pR - pL

      deldelphi = -0.5d0 * (hR + hL) * (g * delb + delP / rho)
      delphidecomp = delphi - deldelphi

      !flux decomposition
      beta1 = (s2*delhu - delphidecomp)/(s2-s1)
      beta2 = (delphidecomp - s1*delhu)/(s2-s1)

      sw(1)=s1
      sw(2)=0.5d0*(s1+s2)
      sw(3)=s2
      ! 1st nonlinear wave
      fw(1,1) = beta1
      fw(2,1) = beta1*s1
      fw(3,1) = beta1*vL
      ! 2nd nonlinear wave
      fw(1,3) = beta2
      fw(2,3) = beta2*s2
      fw(3,3) = beta2*vR
      ! advection of transverse wave
      fw(1,2) = 0.d0
      fw(2,2) = 0.d0
      fw(3,2) = hR*uR*vR - hL*uL*vL -fw(3,1)-fw(3,3)
      return

      end !subroutine -------------------------------------------------





c=============================================================================
      subroutine riemanntype(hL,hR,uL,uR,hm,s1m,s2m,rare1,rare2,
     &             maxiter,drytol,g)

      !determine the Riemann structure (wave-type in each family)


      implicit none

      !input
      double precision hL,hR,uL,uR,drytol,g
      integer maxiter

      !output
      double precision s1m,s2m
      logical rare1,rare2

      !local
      double precision hm,u1m,u2m,um,delu
      double precision h_max,h_min,h0,F_max,F_min,dfdh,F0,slope,gL,gR
      integer iter



c     !Test for Riemann structure

      h_min=min(hR,hL)
      h_max=max(hR,hL)
      delu=uR-uL

      if (h_min.le.drytol) then
         hm=0.d0
         um=0.d0
         s1m=uR+uL-2.d0*sqrt(g*hR)+2.d0*sqrt(g*hL)
         s2m=uR+uL-2.d0*sqrt(g*hR)+2.d0*sqrt(g*hL)
         if (hL.le.0.d0) then
            rare2=.true.
            rare1=.false.
         else
            rare1=.true.
            rare2=.false.
         endif

      else
         F_min= delu+2.d0*(sqrt(g*h_min)-sqrt(g*h_max))
         F_max= delu +
     &         (h_max-h_min)*(sqrt(.5d0*g*(h_max+h_min)/(h_max*h_min)))

         if (F_min.gt.0.d0) then !2-rarefactions

            hm=(1.d0/(16.d0*g))*
     &               max(0.d0,-delu+2.d0*(sqrt(g*hL)+sqrt(g*hR)))**2
            um=sign(1.d0,hm)*(uL+2.d0*(sqrt(g*hL)-sqrt(g*hm)))

            s1m=uL+2.d0*sqrt(g*hL)-3.d0*sqrt(g*hm)
            s2m=uR-2.d0*sqrt(g*hR)+3.d0*sqrt(g*hm)

            rare1=.true.
            rare2=.true.

         elseif (F_max.le.0.d0) then !2 shocks

c           !root finding using a Newton iteration on sqrt(h)===
            h0=h_max
            do iter=1,maxiter
               gL=sqrt(.5d0*g*(1/h0 + 1/hL))
               gR=sqrt(.5d0*g*(1/h0 + 1/hR))
               F0=delu+(h0-hL)*gL + (h0-hR)*gR
               dfdh=gL-g*(h0-hL)/(4.d0*(h0**2)*gL)+
     &                   gR-g*(h0-hR)/(4.d0*(h0**2)*gR)
               slope=2.d0*sqrt(h0)*dfdh
               h0=(sqrt(h0)-F0/slope)**2
            enddo
               hm=h0
               u1m=uL-(hm-hL)*sqrt((.5d0*g)*(1/hm + 1/hL))
               u2m=uR+(hm-hR)*sqrt((.5d0*g)*(1/hm + 1/hR))
               um=.5d0*(u1m+u2m)

               s1m=u1m-sqrt(g*hm)
               s2m=u2m+sqrt(g*hm)
               rare1=.false.
               rare2=.false.

         else !one shock one rarefaction
            h0=h_min

            do iter=1,maxiter
               F0=delu + 2.d0*(sqrt(g*h0)-sqrt(g*h_max))
     &                  + (h0-h_min)*sqrt(.5d0*g*(1/h0+1/h_min))
               slope=(F_max-F0)/(h_max-h_min)
               h0=h0-F0/slope
            enddo

            hm=h0
            if (hL.gt.hR) then
               um=uL+2.d0*sqrt(g*hL)-2.d0*sqrt(g*hm)
               s1m=uL+2.d0*sqrt(g*hL)-3.d0*sqrt(g*hm)
               s2m=uL+2.d0*sqrt(g*hL)-sqrt(g*hm)
               rare1=.true.
               rare2=.false.
            else
               s2m=uR-2.d0*sqrt(g*hR)+3.d0*sqrt(g*hm)
               s1m=uR-2.d0*sqrt(g*hR)+sqrt(g*hm)
               um=uR-2.d0*sqrt(g*hR)+2.d0*sqrt(g*hm)
               rare2=.true.
               rare1=.false.
            endif
         endif
      endif

      return

      end ! subroutine riemanntype----------------------------------------------------------------

c
c ----------------------------------------------------
c
      subroutine griddomup(iflags,iflags2,ilo,ihi,
     .                     mbuff,lev,ilofine,ihifine)

      use amr_module
      implicit double precision (a-h, o-z)

      integer*1  iflags (ilo-mbuff:ihi+mbuff)
      integer*1  iflags2(ilofine-mbuff:ihifine+mbuff)

c
c ::::::::::::::::::::::::::: DOMUP :::::::::::::::::::::
c 
c  domain flags for THIS GRID  are in iflags. copy into iflags2, which is
c  at a different level, dimensions differently
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
         write(outunit,*)" from griddomup: flags (before expansion,",
     .                   " with buff cells)"
         write(outunit,100)(iflags(i),i=ilo-mbuff,ihi+mbuff)
      endif
c
      lratiox = intratx(lev)

      do 10 i = ilofine-mbuff,ihifine+mbuff
         iflags2(i) = 0
 10   continue

c
c careful with buffer - cant just take coarse grid buffer and refine it
c since have same size buffer on finer grid
      do 20 i = ilo,ihi
          ifine = i * lratiox - 1  ! subtract 1 so can add in next loop
          do 15 mi = 1, lratiox
            iset = min(ifine+mi,ihifine+mbuff)  ! might as well include buffer, though done later
            iset = max(iset,ilofine-mbuff)      ! but so expensive
            iflags2(iset) = iflags(i)
 15       continue
 20       continue
c
c need to be careful due to possibly odd buffer size
c cant just take coarse cell and do all fine fine cells within, as above loop
c  
c    handle left and right buffer zones
      do 23 i = ihifine+1, ihifine+mbuff
c       get coarse indices for fine pt. i (in buffer zone)
        ic = i/lratiox
        iflags2(i) = iflags(ic)
 23   continue
      do 24 i = ilofine-mbuff, ilofine-1
c       get coarse indices for fine pt. i (in buffer zone)
        ic = i/lratiox
        iflags2(i) = iflags(ic)
 24   continue
c
c do not need to do something special for periodicity. already taken into account when
c setting enlarged grid with buffer zone at level lbase
c
 90   continue
      if (dprint) then
         write(outunit,*)"from griddomup: flags (after ref 1 level up,",
     .                   "with buff cells)"
         write(outunit,100)(iflags2(i),i=ilofine-mbuff,ihifine+mbuff)
 100     format(80i1)
      endif

      return
      end

! =========================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =========================================================

! solve Riemann problems for the 1D advection equation q_t + u*q_x = 0.
! For constant advection velocity u, passed in common block.

! waves:     1
! equations: 1

! Conserved quantities:
!       1 q

! The advection speed u is passed in the common block cparam
! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routine step1, rp is called with ql = qr = q.


    implicit double precision (a-h,o-z)
    double precision ::   ql( meqn,1-mbc:maxmx+mbc)
    double precision ::   qr( meqn,1-mbc:maxmx+mbc)
    double precision ::   amdq( meqn,1-mbc:maxmx+mbc)
    double precision ::   apdq( meqn,1-mbc:maxmx+mbc)
    double precision ::    s(mwaves,1-mbc:maxmx+mbc)
    double precision :: wave(meqn, mwaves,1-mbc:maxmx+mbc)
    common /cparam/ u

    do 30 i=2-mbc,mx+mbc
    
    !        # Compute the wave and speed
    
        wave(1,1,i) = ql(1,i) - qr(1,i-1)
        s(1,i) = u
        amdq(1,i) = dmin1(u, 0.d0) * wave(1,1,i)
        apdq(1,i) = dmax1(u, 0.d0) * wave(1,1,i)
    30 END DO

    return
    end subroutine rp1

c
c
c     ==================================================================
      subroutine flux3_dimSplit(ixyz,maxm,meqn,maux, mbc,mx,
     &                 q1d,dtdx1d,aux2,
     &                 faddm,faddp,cfl1d,
     &                 rpn3)
c     ==================================================================
c
c     # clawpack routine ...  modified for AMRCLAW
c
c     # Compute the modification to fluxes f, g and h that are generated by
c     # all interfaces along a 1D slice of the 3D grid.
c     #    ixyz = 1  if it is a slice in x
c     #           2  if it is a slice in y
c     #           3  if it is a slice in z
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd, gadd and hadd.  The notation is written
c     # assuming we are solving along a 1D slice in the x-direction.
c
c     # fadd(i,.) modifies F to the left of cell i
c     # gadd(i,.,1,slice) modifies G below cell i (in the z-direction)
c     # gadd(i,.,2,slice) modifies G above cell i
c     #                   The G flux in the surrounding slices may
c     #                   also be updated.
c     #                   slice  =  -1     The slice below in y-direction
c     #                   slice  =   0     The slice used in the 2D method
c     #                   slice  =   1     The slice above in y-direction
c     # hadd(i,.,1,slice) modifies H below cell i (in the y-direction)
c     # hadd(i,.,2,slice) modifies H above cell i
c     #                   The H flux in the surrounding slices may
c     #                   also be updated.
c     #                   slice  =  -1     The slice below in z-direction
c     #                   slice  =   0     The slice used in the 2D method
c     #                   slice  =   1     The slice above in z-direction
c     #
c     # The method used is specified by method(2) and method(3):
c
c        method(2) = 1 No correction waves
c                  = 2 if second order correction terms are to be added, with
c                      a flux limiter as specified by mthlim.  No transverse
c                      propagation of these waves.
c
c         method(3) specify how the transverse wave propagation
c         of the increment wave and the correction wave are performed.
c         Note that method(3) is given by a two digit number, in
c         contrast to what is the case for claw2. It is convenient
c         to define the scheme using the pair (method(2),method(3)).
c
c         method(3) <  0 Gives dimensional splitting using Godunov
c                        splitting, i.e. formally first order
c                        accurate.
c                      0 Gives the Donor cell method. No transverse
c                        propagation of neither the increment wave
c                        nor the correction wave.
c                   = 10 Transverse propagation of the increment wave
c                        as in 2D. Note that method (2,10) is
c                        unconditionally unstable.
c                   = 11 Corner transport upwind of the increment
c                        wave. Note that method (2,11) also is
c                        unconditionally unstable.
c                   = 20 Both the increment wave and the correction
c                        wave propagate as in the 2D case. Only to
c                        be used with method(2) = 2.
c                   = 21 Corner transport upwind of the increment wave,
c                        and the correction wave propagates as in 2D.
c                        Only to be used with method(2) = 2.
c                   = 22 3D propagation of both the increment wave and
c                        the correction wave. Only to be used with
c                        method(2) = 2.
c
c         Recommended settings:   First order schemes:
c                                       (1,10) Stable for CFL < 1/2
c                                       (1,11) Stable for CFL < 1
c                                 Second order schemes:
c                                        (2,20) Stable for CFL < 1/2
c                                        (2,22) Stable for CFL < 1
c
c         WARNING! The schemes (2,10), (2,11) are unconditionally
c                  unstable.
c
c                       ----------------------------------
c
c     Note that if method(6)=1 then the capa array comes into the second
c     order correction terms, and is already included in dtdx1d:
c     If ixyz = 1 then
c        dtdx1d(i) = dt/dx                      if method(6) = 0
c                  = dt/(dx*capa(i,jcom,kcom))  if method(6) = 1
c     If ixyz = 2 then
c        dtdx1d(j) = dt/dy                      if method(6) = 0
c                  = dt/(dy*capa(icom,j,kcom))  if method(6) = 1
c     If ixyz = 3 then
c        dtdx1d(k) = dt/dz                      if method(6) = 0
c                  = dt/(dz*capa(icom,jcom,k))  if method(6) = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn3 into
c            amdq =  the left-going flux difference  A^- Delta q
c            apdq = the right-going flux difference  A^+ Delta q
c        Each of these is split by rpt3 into
c            bmasdq = the down-going transverse flux difference B^- A^* Delta q
c            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
c        where A^* represents either A^- or A^+.
c
c        Finally, each bsasdq is split by rptt3 into :
c            cmbsasdq = C^- B^* A^* Dq
c            cpbsasdq = C^+ B^* A^* Dq
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3

      dimension     q1d(meqn,1-mbc:maxm+mbc)
 
      dimension    cqxx(meqn,1-mbc:maxm+mbc)
      dimension   faddm(meqn,1-mbc:maxm+mbc)
      dimension   faddp(meqn,1-mbc:maxm+mbc)
 
c
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux2(maux,1-mbc:maxm+mbc)
c
      dimension    s(mwaves,1-mbc:maxm+mbc)
      dimension  wave(meqn,mwaves,1-mbc:maxm+mbc)
c
      logical limit

      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
 5    continue
c     
c     # initialize flux increments:
c     -----------------------------
c     
      do 10 m=1,meqn
         do 10 i = 1-mbc, mx+mbc
            faddm(m,i) = 0.d0
            faddp(m,i) = 0.d0
 10      continue
c     
c     # local method parameters
         if (method(3) .lt. 0) then
            m3 = -1
            m4 = 0
         else
            m3 = method(3)/10
            m4 = method(3) - 10*m3
         endif
c     
c     -----------------------------------------------------------
c     # solve normal Riemann problem and compute Godunov updates
c     -----------------------------------------------------------
c     
c     # aux2(1-mbc,1,2) is the start of a 1d array now used by rpn3
c     
         if (maux > 0) then
            call rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &           aux2(1,1-mbc),aux2(1,1-mbc),
     &           wave,s,faddm,faddp)
!     &           wave,s,amdq,apdq)
         else
            call rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,q1d,q1d,
     &           aux2,aux2,
     &           wave,s,faddm,faddp)
!     &           wave,s,amdq,apdq)
         endif
c     
c     # Set fadd for the donor-cell upwind method (Godunov)
         do 40 i=1,mx+1
         do 40 m=1,meqn
!--            faddp(m,i) = faddp(m,i) - apdq(m,i)
!--            faddm(m,i) = faddm(m,i) + amdq(m,i)
               faddp(m,i) = -faddp(m,i)   ! leave in old code to double check
 40      continue
c     
c     # compute maximum wave speed for checking Courant number:
         cfl1d = 0.d0
         do 50 mw=1,mwaves
         do 50 i=1,mx+1
          !  cfl1d = dmax1(cfl1d,dtdx1d(i)*dabs(s(mw,i))) OLD WAY
 !          # if s>0 use dtdx1d(i) to compute CFL,
 !          # if s<0 use dtdx1d(i-1) to compute CFL:
           cfl1d = dmax1(cfl1d,  dtdx1d(i)*s(mw,i),
     .                          -dtdx1d(i-1)*s(mw,i))

 50      continue
c     
         if (method(2).eq.1) go to 130
c    
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c     
c     # apply limiter to waves:
         if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c     
         if (.not. use_fwaves) then

         do 120 i = 1, mx+1
c     
c     # For correction terms below, need average of dtdx in cell
c     # i-1 and i.  (overwriting dtdx1d(i-1) removed, and code below modified to agree 
c     # with classic flux3 by mjb, 12/16/2014.
            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
c     
            do 120 m=1,meqn
               cqxx(m,i) = 0.d0
               do 119 mw=1,mwaves
                  cqxx(m,i) = cqxx(m,i) + 0.5d0 * dabs(s(mw,i)) *
     &                 (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
 119           continue
               faddm(m,i) = faddm(m,i) + cqxx(m,i)
               faddp(m,i) = faddp(m,i) + cqxx(m,i)
 120        continue

         else
            do 122 i = 1, mx+1

            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i)) 
c
            do 122 m=1,meqn
               cqxx(m,i) = 0.d0
               do 121 mw=1,mwaves
                  cqxx(m,i) = cqxx(m,i) + 0.5d0 * dsign(1.d0, s(mw,i)) *
     &                 (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
 121           continue
               faddm(m,i) = faddm(m,i) + cqxx(m,i)
               faddp(m,i) = faddp(m,i) + cqxx(m,i)
 122        continue
         endif
c     
 130     continue
c     
       !  if( m3 .le. 0) return !left in to double check what this is, but no longer needed.
c     
c     
       return
       end

! f-wave Riemann solver for the variable speed limit LWR traffic model

! q_t + (u_max(x,t) q(1-q))_x = 0

! Here the speed limit u_max (stored in aux(1,i) may vary with x and t.

! This solver seems to be less accurate that rp1_traffic_vc.f90, which does
! not use f-waves.  This solver also exhibits a one-cell entropy glitch
! for transonic rarefaction.  The other solver is the preferred default;
! this f-wave solver is left here mainly for educational purposes.

! waves: 1
! equations: 1
! aux fields: 1

! Conserved quantities:
!       1 q

! Auxiliary variables:
!       1 u_max

! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

subroutine rp1(maxm,num_eqn,num_waves,num_aux,num_ghost,num_cells, &
               ql,qr,auxl,auxr,fwave,s,amdq,apdq)
    implicit none
    ! Inputs
    integer, intent(in) :: maxm, num_eqn, num_waves, num_aux, num_ghost, num_cells
    double precision, intent(in), dimension(num_eqn, 1-num_ghost:maxm+num_ghost) :: ql,qr
    double precision, intent(in), dimension(num_aux, 1-num_ghost:maxm+num_ghost) :: auxl,auxr
    ! Outputs
    double precision, intent(out) :: s(num_waves,1-num_ghost:num_cells+num_ghost)
    double precision, intent(out) :: fwave(num_eqn,num_waves,1-num_ghost:num_cells+num_ghost)
    double precision, intent(out), dimension(num_eqn, 1-num_ghost:maxm+num_ghost) :: amdq,apdq
    ! Locals
    double precision :: fim1, fi, sim1, si, f0
    integer :: i

    do i = 2-num_ghost, num_cells+num_ghost
        ! Compute the wave, speeds, and flux difference

        ! compute characteristic speed in each cell:
        sim1 = auxr(1,i-1)*(1.d0 - 2.d0*qr(1,i-1))
        si   = auxl(1,i  )*(1.d0 - 2.d0*ql(1,i  ))

        ! compute flux in each cell and flux difference:
        fim1 = auxr(1,i-1)*qr(1,i-1)*(1.d0 - qr(1,i-1))
        fi   = auxl(1,i  )*ql(1,i  )*(1.d0 - ql(1,i  ))

        fwave(1,1,i) = fi - fim1

        if (sim1 .lt. 0.d0 .and. si .le. 0.d0) then
            ! left-going
            s(1,i) = sim1
            amdq(1,i) = fwave(1,1,i)
            apdq(1,i) = 0.d0
        else if (sim1 .ge. 0.d0 .and. si .gt. 0.d0) then
            ! right-going
            s(1,i) = si
            amdq(1,i) = 0.d0
            apdq(1,i) = fwave(1,1,i)
        else if (sim1 .lt. 0.d0 .and. si .gt. 0.d0) then
            ! transonic rarefaction
            s(1,i) = 0.5d0*(sim1 + si)

            ! entropy fix:  (perhaps doesn't work for all cases!!!)
            ! This assumes the flux in the transonic case should
            ! correspond to q=0.5 on the side with the smaller umax value.
            f0 = dmin1(auxr(1,i-1),auxl(1,i))*0.25d0
            ! split fwave between amdq and apdq:
            amdq(1,i) = f0 - fim1
            apdq(1,i) = fi - f0

        else
            ! transonic shock
            s(1,i) = 0.5d0*(sim1 + si)
            if (fi-fim1 .lt. 0.d0) then
                amdq(1,i) = fwave(1,1,i)
                apdq(1,i) = 0.d0
            else if (fi-fim1 .gt. 0.d0) then
                amdq(1,i) = 0.d0
                apdq(1,i) = fwave(1,1,i)
            else
                amdq(1,i) = 0.5d0 * fwave(1,1,i)
                apdq(1,i) = 0.5d0 * fwave(1,1,i)
            endif
        endif

    enddo
    return
end subroutine rp1

! =====================================================
subroutine rp1(maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! Riemann solver for the acoustics equations in 1D.

! waves:     2
! equations: 2

! Conserved quantities:
!       1 pressure
!       2 velocity

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! On output, wave contains the waves,
!            s the speeds,
! 
!            amdq = A^- Delta q,
!            apdq = A^+ Delta q,
!                   the decomposition of the flux difference
!                       f(qr(i-1)) - f(ql(i))
!                   into leftgoing and rightgoing parts respectively.
! 

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr


    implicit double precision (a-h,o-z)

    dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves,1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn, 1-mbc:maxm+mbc)
    dimension amdq(meqn, 1-mbc:maxm+mbc)

!     local arrays
!     ------------
    dimension delta(2)

!     # density, bulk modulus, and sound speed, and impedence of medium:
!     # (should be set in setprob.f)
    common /cparam/ rho,bulk,cc,zz


!     # split the jump in q at each interface into waves

!     # find a1 and a2, the coefficients of the 2 eigenvectors:
    do 20 i = 2-mbc, mx+mbc
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(2,i) - qr(2,i-1)
        a1 = (-delta(1) + zz*delta(2)) / (2.d0*zz)
        a2 =  (delta(1) + zz*delta(2)) / (2.d0*zz)
    
    !        # Compute the waves.
    
        wave(1,1,i) = -a1*zz
        wave(2,1,i) = a1
        s(1,i) = -cc
    
        wave(1,2,i) = a2*zz
        wave(2,2,i) = a2
        s(2,i) = cc
    
    20 END DO


!     # compute the leftgoing and rightgoing flux differences:
!     # Note s(1,i) < 0   and   s(2,i) > 0.

    do m=1,meqn
        do i = 2-mbc, mx+mbc
            amdq(m,i) = s(1,i)*wave(m,1,i)
            apdq(m,i) = s(2,i)*wave(m,2,i)
        end do
    end do

    return
    end subroutine rp1

subroutine rptt3(ixyz,icoor,imp,impt,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,bsasdq,cmbsasdq,cpbsasdq)
    ! Riemann solver in the transverse direction for the 3d Burgers' equation
    !    q_t  +  u*(.5*q^2)_x + v*(.5*q^2)_y + w*(.5*q^2)_z = 0
    ! where u,v,w are a given scalars, stored in the vector coeff
    ! that is set in setprob.f and passed in the common block comrp.
    !
    ! On input,
    !
    !    ql,qr is the data along some one-dimensional slice, as in rpn3
    !         This slice is
    !             in the x-direction if ixyz=1,
    !             in the y-direction if ixyz=2, or
    !             in the z-direction if ixyz=3.
    !
    !    bsasdq is an array of flux differences that result from a
    !         transverse splitting (a previous call to rpt3).  
    !         This stands for B^* A^* \Dq but could represent any of 
    !         6 possibilities, e.g.  C^* B^* \Dq, as specified by ixyz
    !         and icoor (see below).
    !         Moreover, each * represents either + or -, as specified by
    !         imp and impt.
    !
    !    ixyz indicates the direction of the original Riemann solve,
    !         called the x-like direction in the table below:
    !
    !               x-like direction   y-like direction   z-like direction
    !      ixyz=1:        x                  y                  z         
    !      ixyz=2:        y                  z                  x         
    !      ixyz=3:        z                  x                  y         
    !
    !    icoor indicates direction in which the transverse solve should 
    !         be performed.
    !      icoor=2: split in the y-like direction.
    !      icoor=3: split in the z-like direction.
    !
    !    For example,
    !        ixyz=1, icoor=3 means bsasdq=B^*A^*\Dq, and should be 
    !                        split in z into 
    !                           cmbsasdq = C^-B^*A^*\Dq,
    !                           cpbsasdq = C^+B^*A^*\Dq.
    !
    !        ixyz=2, icoor=3 means bsasdq=C^*B^*\Dq, and should be
    !                        split in x into 
    !                           cmbsasdq = A^-C^*B^*\Dq,
    !                           cpbsasdq = A^+C^*B^*\Dq.
    !
    !    The parameters imp and impt are generally needed only if aux
    !    arrays are being used, in order to access the appropriate
    !    variable coefficients.
    
    implicit none

    integer, intent(in) :: ixyz, icoor, maxm, meqn, mwaves, mbc, mx, maux, imp, impt

    double precision, intent(in)  :: ql, qr, bsasdq, aux1, aux2, aux3
    double precision, intent(out) :: cmbsasdq, cpbsasdq
    dimension       ql(meqn,1-mbc:maxm+mbc)
    dimension       qr(meqn,1-mbc:maxm+mbc)
    dimension   bsasdq(meqn,1-mbc:maxm+mbc)
    dimension cmbsasdq(meqn,1-mbc:maxm+mbc)
    dimension cpbsasdq(meqn,1-mbc:maxm+mbc)
    dimension     aux1(maux,1-mbc:maxm+mbc,3)
    dimension     aux2(maux,1-mbc:maxm+mbc,3)
    dimension     aux3(maux,1-mbc:maxm+mbc,3)

    double precision :: coeff
    common /cparam/ coeff(3)

    integer :: iuvw, i
    double precision :: sc

    ! set iuvw = 1 for u, 2 for v, 3 for w component of velocity
    ! depending on transverse direction:
    iuvw = ixyz + icoor - 1
    if (iuvw.gt.3) iuvw = iuvw-3

    ! transverse wave goes up or down with speed based on data for
    ! original normal Riemann problem.  

    do i=2-mbc,mx+mbc
        sc = coeff(iuvw) * 0.5d0*(qr(1,i-1) + ql(1,i))
        cmbsasdq(1,i) = dmin1(sc, 0.d0) * bsasdq(1,i)
        cpbsasdq(1,i) = dmax1(sc, 0.d0) * bsasdq(1,i)
    end do

    return
end subroutine rptt3

! ::::::::::::::::::::: flag2refine ::::::::::::::::::::::::::::::::::
!
! User routine to control flagging of points for refinement.
!
! Specific for GeoClaw for tsunami applications and related problems
!
!
! The logical function allowflag(x,y,t) is called to
! check whether further refinement at this level is allowed in this cell
! at this time.
!
!    q   = grid values including ghost cells (bndry vals at specified
!          time have already been set, so can use ghost cell values too)
!
!  aux   = aux array on this grid patch
!
! amrflags  = array to be flagged with either the value
!             DONTFLAG (no refinement needed)  or
!             DOFLAG   (refinement desired)
!
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine flag2refine(mx,my,mbc,meqn,maux,xlower,ylower,dx,dy,t,level,tolsp, &
                       q,aux,amrflags,DONTFLAG,DOFLAG)

    use amr_module, only: mxnest, t0
    use geoclaw_module, only:dry_tolerance,rho,eta_init,num_layers
    
    use topo_module, only: tlowtopo,thitopo,xlowtopo,xhitopo,ylowtopo,yhitopo
    use topo_module, only: minleveltopo,mtopofiles
    
    use dtopo_module, only: tfdtopo,xlowdtopo,xhidtopo,ylowdtopo,yhidtopo
    use dtopo_module, only: minleveldtopo,num_dtopo
    
    use qinit_module, only: x_low_qinit,x_hi_qinit,y_low_qinit,y_hi_qinit
    use qinit_module, only: min_level_qinit,qinit_type
    
    use regions_module, only: num_regions, regions
    use refinement_module
 
    implicit none
    
    ! Subroutine arguments
    integer, intent(in) :: mx,my,mbc,meqn,maux,level
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,tolsp
    
    real(kind=8), intent(in) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(in) :: DONTFLAG
    real(kind=8), intent(in) :: DOFLAG
    
    logical :: allowflag
    external allowflag
    
    ! Generic locals
    integer :: i,j,m,k,layer_index
    real(kind=8) :: x_c,y_c,x_low,y_low,x_hi,y_hi
    real(kind=8) :: h(num_layers), total_depth, speed, eta, eta_below, ds

    ! Initialize flags
    amrflags = DONTFLAG

    ! Loop over interior points on this grid
    ! (i,j) grid cell is [x_low,x_hi] x [y_low,y_hi], cell center at (x_c,y_c)
    y_loop: do j=1,my
        y_low = ylower + (j - 1) * dy
        y_c = ylower + (j - 0.5d0) * dy
        y_hi = ylower + j * dy
        
        x_loop: do i = 1,mx
            x_low = xlower + (i - 1) * dx
            x_c = xlower + (i - 0.5d0) * dx
            x_hi = xlower + i * dx

            ! The following conditions are only checked in the horizontal and
            ! override the allowflag routine

            ! Check to see if refinement is forced in any topography file region:
            do m=1,mtopofiles
                if (level < minleveltopo(m) .and. t >= tlowtopo(m) .and. t <= thitopo(m)) then
                    if (  x_hi > xlowtopo(m) .and. x_low < xhitopo(m) .and. &
                          y_hi > ylowtopo(m) .and. y_low < yhitopo(m) ) then
                        
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif
                endif
            enddo

            ! Check to see if refinement is forced in any other region:
            do m=1,num_regions
                if (level < regions(m)%min_level .and. &
                    t >= regions(m)%t_low .and. t <= regions(m)%t_hi) then
                    if (x_hi > regions(m)%x_low .and. x_low < regions(m)%x_hi .and. &
                        y_hi > regions(m)%y_low .and. y_low < regions(m)%y_hi ) then
                    
                        amrflags(i,j) = DOFLAG
                        cycle x_loop
                    endif
                endif
            enddo

            ! Check if we're in the dtopo region and need to refine:
            ! force refinement to level minleveldtopo
            do m = 1,num_dtopo
                if (level < minleveldtopo(m).and. &
                    t <= tfdtopo(m) .and. & !t.ge.t0dtopo(m).and.
                    x_hi > xlowdtopo(m) .and. x_low < xhidtopo(m).and. &
                    y_hi > ylowdtopo(m) .and. y_low < yhidtopo(m)) then
                    
                    amrflags(i,j) = DOFLAG    
                    cycle x_loop
                endif
            enddo

            ! Check if we're in the region where initial perturbation is
            ! specified and need to force refinement:
            ! This assumes that t0 = 0.d0, should really be t0 but we do
            ! not have access to that parameter in this routine
            if (qinit_type > t0 .and. t == 0.d0) then 
                if (level < min_level_qinit .and. & 
                    x_hi > x_low_qinit .and. x_low < x_hi_qinit .and. &
                    y_hi > y_low_qinit .and. y_low < y_hi_qinit) then
                    
                    amrflags(i,j) = DOFLAG
                    cycle x_loop
                endif
            endif

            ! -----------------------------------------------------------------
            ! Refinement not forced, so check if it is allowed and if so,
            ! check if there is a reason to flag this point:
            if (allowflag(x_c,y_c,t,level)) then
                ! These refinement criteria are checked per layer going backwards
                ! The bottom layer is checked first and eta_below is set to the 
                ! bathymetry
                eta_below = aux(1,i,j)
                
                forall(k=1:num_layers)
                    h(k) = q(3 * (k - 1) + 1,i,j) / rho(k)
                end forall
                total_depth = sum(h)

                do k=num_layers,1,-1
                    layer_index = 3 * (k - 1)
                    
                    ! Extract state
                    if (h(k) > dry_tolerance(k)) then
                        eta = h(k) + eta_below
                    
                        ! Check wave criteria
                        if (abs(eta - eta_init(k)) > wave_tolerance(k)) then
                            ! Check to see if we are near shore
                            if (total_depth < deep_depth) then
                                amrflags(i,j) = DOFLAG
                                cycle x_loop
                            ! Check if we are allowed to flag in deep water
                            ! anyway
                            else if (level < max_level_deep) then
                                amrflags(i,j) = DOFLAG
                                cycle x_loop
                            endif
                        endif
                        eta_below = eta
                    
                        ! Check speed criteria, note that it might be useful to 
                        ! also have a per layer criteria since this is not 
                        ! gradient based
                        speed = sqrt(q(layer_index+2,i,j)**2 &
                                   + q(layer_index+3,i,j)**2) &
                                   / q(layer_index+1,i,j)
                        do m=1,min(size(speed_tolerance),mxnest)
                            if (speed > speed_tolerance(m) .and. level <= m) then
                                amrflags(i,j) = DOFLAG
                                cycle x_loop
                            endif
                        enddo
                    endif
                enddo
            endif
            
        enddo x_loop
    enddo y_loop
end subroutine flag2refine

! ::::::::::::::::::::: flagregions ::::::::::::::::::::::::::::::::::
!
!> Modify array of flagged points to respect minlevels and maxlevels
!! specified by regions. This subroutine processes ONE grid associated with this amrflags
!!
!! Second version with outer loop on regions, should be faster.
!!
!! This routine may change flags only in cells that are (partially)
!! covered by one or more regions. amrflags will be later modified 
!! by Richardson extrapolation and/or flag2refine routine, as requested,
!! which will only add DOFLAG points to cells that are still UNSET
!!
!! If any part of a grid cell is covered by one or more regions, then
!! refinement is *required* to at least the max of all region min_levels
!! and is *allowed* to at most to the max of all region max_levels.
!!
!! Note that buffering is done *after* this, so additional cells may
!! be refined in areas covered by regions that do not allow it!

!! amrflags  = array to be flagged with either the value
!!             DONTFLAG (no refinement needed)  or
!!             DOFLAG   (refinement desired)    
!!
!! \param mx number of cells in *i* direction
!! \param my number of cells in *j* direction
!! \param mbuff width of buffer region
!! \param maux number of auxiliary variables
!! \param xlower x-coordinate of left physical boundary
!! \param ylower y-coordinate of lower physical boundary
!! \param dx spacing in *i* direction
!! \param dy spacing in *j* direction
!! \param level AMR level of this grid
!! \param t simulation time on this grid
!! \param amrflags array to be flagged with either the value **DONTFLAG** or **DOFLAG** for each cell. 
!!        It is enlarged from grid size to include buffer regions around the grid. 
!! \param DONTFLAG value to be assigned to amrflags for cells that need no refinement
!! \param DOFLAG value to be assigned to amrflags for cells that do need refinement
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

subroutine flagregions2(mx,my,mbuff,xlower,ylower,dx,dy,level,t, &
                            amrflags)

    use regions_module
    use amr_module, only : DOFLAG, UNSET, DONTFLAG

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: mx,my,level,mbuff
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t
    
    ! Flagging
    real(kind=8),intent(inout) :: amrflags(1-mbuff:mx+mbuff,1-mbuff:my+mbuff)
    
    type(ruled_region_type), pointer :: rr

    ! Locals
    integer :: i,j,m,i1,i2,j1,j2, k,k1,k2
    real(kind=8) :: x_low,y_low,x_hi,y_hi, xupper,yupper
    integer, allocatable :: minlevel(:,:), maxlevel(:,:)
    integer :: min_current_minlevel, min_current_maxlevel
    
    real(kind=8) :: x_lower_y_low, x_lower_y_hi, x_upper_y_low, x_upper_y_hi, &
                    x_lower_s, x_upper_s, alpha_y_low, alpha_y_hi, &
                    y_lower_x_low, y_lower_x_hi, y_upper_x_low, y_upper_x_hi, &
                    y_lower_s, y_upper_s, alpha_x_low, alpha_x_hi

    !write(58,*) 'level, lower: ',level,xlower,ylower  ! +++
    allocate(minlevel(mx,my), maxlevel(mx,my))
    
    minlevel = 0
    maxlevel = 0

    xupper = xlower + mx*dx
    yupper = ylower + my*dy

    ! mark ghost cells with DONTFLAG, in case they were UNSET:
    do i=1-mbuff,mx+mbuff
        do j=1-mbuff,0
            amrflags(i,j) = DONTFLAG
            enddo
        do j=my+1,my+mbuff
            amrflags(i,j) = DONTFLAG
            enddo
        enddo

    do j=1-mbuff,my+mbuff
        do i=1-mbuff,0
            amrflags(i,j) = DONTFLAG
            enddo
        do i=mx+1,mx+mbuff
            amrflags(i,j) = DONTFLAG
            enddo
        enddo

    ! loop on old-style regions, still supported for now:
    
    rloop: do m=1,num_regions
        if (t < regions(m)%t_low .or. t > regions(m)%t_hi) then
            cycle rloop  ! no intersection
        endif
        
        if (xlower >= regions(m)%x_hi .or. xupper <= regions(m)%x_low) then
            cycle rloop  ! no intersection
        else
            i1 = max(floor((regions(m)%x_low - xlower) / dx) + 1, 1)
            i2 = min(floor((regions(m)%x_hi -xlower) / dx) + 1, mx)
        endif

        if (ylower >= regions(m)%y_hi .or. yupper <= regions(m)%y_low) then
            cycle rloop  ! no intersection
        else
            j1 = max(floor((regions(m)%y_low - ylower) / dy) + 1, 1)
            j2 = min(floor((regions(m)%y_hi - ylower) / dy) + 1, my)
        endif

        do j=j1,j2
            do i=i1,i2
                minlevel(i,j) = max(minlevel(i,j), regions(m)%min_level)
                maxlevel(i,j) = max(maxlevel(i,j), regions(m)%max_level)
            enddo
         enddo
    enddo rloop


    ! Loop on new "ruled rectangle" flagregions:
    
    rrloop: do m=1,num_rregions
    
        rr => rregions(m)

        if (t < rr%t_low .or. t > rr%t_hi) then
            cycle rrloop  ! no intersection
        endif
        
        ! compute intersection of patch with rr bounding box:
        if (xlower >= rr%x2bb .or. xupper <= rr%x1bb) then
            cycle rrloop  ! no intersection
        else
            i1 = max(floor((rr%x1bb - xlower) / dx) + 1, 1)
            i2 = min(floor((rr%x2bb -xlower) / dx) + 1, mx)
        endif

        if (ylower >= rr%y2bb .or. yupper <= rr%y1bb) then
            cycle rrloop  ! no intersection
        else
            j1 = max(floor((rr%y1bb - ylower) / dy) + 1, 1)
            j2 = min(floor((rr%y2bb - ylower) / dy) + 1, my)
        endif

        !write(58,*) 'ixy, ds: ',rr%ixy, rr%ds  ! +++
        ! patch overlaps bounding box, so need to check:
        
        ! first check if this rregion could affect anything already set:    
!        min_current_minlevel = minval(minlevel(i1:i2,j1:j2))
!        min_current_maxlevel = minval(maxlevel(i1:i2,j1:j2))
!        if ((min_current_minlevel >= rr%minlevel) .and. &
!            (min_current_maxlevel >= rr%maxlevel)) then
!                cycle rrloop ! this rregion won't change anything
!                endif

        !write(82,*) '+++ t = ',t, ' level =', level
        
        if (rr%ixy == 1) then
            ! rr%s corresponds to x, while lower,upper are in y
            ! outer loop on x, compute k1,k2 once for each col of cells
            iloop1: do i=i1,i2
                x_low = xlower + (i - 1) * dx
                x_hi = xlower + i * dx
                if (rr%ds > 0) then
                    k1 = floor((x_low-rr%s(1) + 1d-6) / rr%ds) + 1
                    k1 = max(k1, 1)
                    k2 = floor((x_hi-rr%s(1) + 1d-6) / rr%ds) + 1
                    k2 = min(k2, rr%nrules-1)
                else
                    ! rr%ds <= 0 means s point are not equally spaced
                    do k=1,rr%nrules
                        if (x_low < rr%s(k)) exit
                        enddo
                    k1 = max(k-1, 1)
                    do k=1,rr%nrules
                        if (x_hi < rr%s(k)) exit
                        enddo
                    k2 = min(k-1, rr%nrules-1)
                    endif ! rr%ds <= 0
                !write(58,*) '+++ ds = ',rr%ds,rr%nrules,k1,k2
                    
                    
                jloop1: do j=j1,j2
                    y_low = ylower + (j - 1) * dy
                    y_hi = ylower + j * dy
                    
                    if (rr%method == 0) then
                        ! pw constant interpolation (rectangles):
                        do k=k1,k2
                            if ((y_hi > rr%lower(k)) .and. &
                                (y_low < rr%upper(k))) then
                                minlevel(i,j) = max(minlevel(i,j), &
                                                    rr%min_level)
                                maxlevel(i,j) = max(maxlevel(i,j), &
                                                    rr%max_level)
                                cycle jloop1
                                endif
                            enddo
                    else 
                        ! rr%method == 1, linear interpolation (trapezoids):
                        do k=k1,k2
                            alpha_x_low = (x_low - rr%s(k)) &
                                        / (rr%s(k+1) - rr%s(k))
                            alpha_x_hi = (x_hi - rr%s(k)) &
                                        / (rr%s(k+1) - rr%s(k))
                            y_lower_x_low = (1-alpha_x_low) * rr%lower(k) &
                                         + alpha_x_low * rr%lower(k+1)
                            y_upper_x_low = (1-alpha_x_low) * rr%upper(k) &
                                          + alpha_x_low * rr%upper(k+1)
                            y_lower_x_hi = (1-alpha_x_hi) * rr%lower(k) &
                                         + alpha_x_hi * rr%lower(k+1)
                            y_upper_x_hi = (1-alpha_x_hi) * rr%upper(k) &
                                          + alpha_x_hi * rr%upper(k+1)
                            y_lower_s = min(y_lower_x_low, y_lower_x_hi)
                            y_upper_s = max(y_upper_x_low, y_upper_x_hi)
                            if ((y_hi > y_lower_s) .and. &
                                (y_low < y_upper_s)) then
                                  minlevel(i,j) = max(minlevel(i,j), &
                                                      rr%min_level)
                                  maxlevel(i,j) = max(maxlevel(i,j), &
                                                      rr%max_level)
                                  cycle jloop1
                                  endif
                             enddo  ! k                                  
                        endif ! rr%method
                    enddo jloop1
                enddo iloop1
                
            else ! rr%ixy = 2
                ! rr%s corresponds to y, while lower,upper are in x
                ! outer loop on y, compute k1,k2 once for each row of cells
                jloop2: do j=j1,j2
                    y_low = ylower + (j - 1) * dy
                    y_hi = ylower + j * dy
                    if (rr%ds > 0) then
                        k1 = floor((y_low-rr%s(1) + 1d-6) / rr%ds) + 1
                        k1 = max(k1, 1)
                        k2 = floor((y_hi-rr%s(1) + 1d-6) / rr%ds) + 1
                        k2 = min(k2, rr%nrules-1)
                    else
                        ! rr%ds <= 0 means s point are not equally spaced
                        do k=1,rr%nrules
                            if (y_low < rr%s(k)) exit
                            enddo
                        k1 = max(k-1, 1)
                        do k=1,rr%nrules
                            if (y_hi < rr%s(k)) exit
                            enddo
                        k2 = min(k-1, rr%nrules-1)
                        endif ! rr%ds <= 0
                    !write(58,*) '+++ ds = ',rr%ds,rr%nrules,k1,k2

                        
                    iloop2: do i=i1,i2
                        x_low = xlower + (i - 1) * dx
                        x_hi = xlower + i * dx
                        
                        if (rr%method == 0) then
                            ! pw constant interpolation (rectangles):
                            do k=k1,k2
                                if ((x_hi > rr%lower(k)) .and. &
                                    (x_low < rr%upper(k))) then
                                    minlevel(i,j) = max(minlevel(i,j), &
                                                        rr%min_level)
                                    maxlevel(i,j) = max(maxlevel(i,j), &
                                                        rr%max_level)
                                    cycle iloop2
                                    endif
                                enddo
                        else 
                            ! rr%method == 1, linear interpolation (trapezoids):
                            do k=k1,k2
                                alpha_y_low = (y_low - rr%s(k)) &
                                            / (rr%s(k+1) - rr%s(k))
                                alpha_y_hi = (y_hi - rr%s(k)) &
                                            / (rr%s(k+1) - rr%s(k))
                                x_lower_y_low = (1-alpha_y_low) * rr%lower(k) &
                                             + alpha_y_low * rr%lower(k+1)
                                x_upper_y_low = (1-alpha_y_low) * rr%upper(k) &
                                              + alpha_y_low * rr%upper(k+1)
                                x_lower_y_hi = (1-alpha_y_hi) * rr%lower(k) &
                                             + alpha_y_hi * rr%lower(k+1)
                                x_upper_y_hi = (1-alpha_y_hi) * rr%upper(k) &
                                              + alpha_y_hi * rr%upper(k+1)
                                x_lower_s = min(x_lower_y_low, x_lower_y_hi)
                                x_upper_s = max(x_upper_y_low, x_upper_y_hi)
                                if ((x_hi > x_lower_s) .and. &
                                    (x_low < x_upper_s)) then
                                      minlevel(i,j) = max(minlevel(i,j), &
                                                          rr%min_level)
                                      maxlevel(i,j) = max(maxlevel(i,j), &
                                                          rr%max_level)
                                      cycle iloop2
                                      endif
                              enddo  ! k                                  
                            endif ! rr%method
                        enddo iloop2
                    enddo jloop2
                endif ! rr%ixy == 2
        enddo rrloop
    
    
    do j=1,my
        do i=1,mx
         if (minlevel(i,j) > maxlevel(i,j)) then
              write(6,*) '*** Error: this should never happen!'
              write(6,*) '*** minlevel > maxlevel in flagregions'
              stop
         endif

         if (maxlevel(i,j) /= 0) then
             ! this point lies in at least one region, so may need
             ! to modify the exisiting flag at this point...
             if (level < minlevel(i,j)) then
                 ! Require refinement of this cell:
                 amrflags(i,j) = DOFLAG
             else if (level >= maxlevel(i,j)) then
                 ! Do not refine of this cell:
                 amrflags(i,j) = DONTFLAG
             ! else leave amrflags(i,j) alone.
             endif
         endif

        enddo 
    enddo 

end subroutine flagregions2

c
c --------------------------------------------------------------
c
      subroutine errf1(rctfine,nvar,
     1                 rctcrse,mptr,mi2tot,mj2tot,mk2tot,
     2                 mitot,mjtot,mktot,rctflg)

      use amr_module
      implicit double precision (a-h,o-z)

 
      dimension  rctfine(nvar, mitot ,mjtot ,mktot )
      dimension  rctcrse(nvar, mi2tot,mj2tot,mk2tot)
      dimension  rctflg( nvar, mitot ,mjtot ,mktot )
      logical    allowflag
      external   allowflag
c
c :::::::::::::::::::: ERRF1 :::::::::::::::::::::::::::::::::::::
c
c  Richardson error estimator: used when tol>0 in user input.
c  Compare error estimates in rctfine, rctcrse.
c  A point is flagged if the error estimate is greater than tol
c  and is allowflag(x,y,t,level) = .true. at this point.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      yfront= rnode(cornylo,mptr)
      hy    = hyposs(levm)
      zbot  = rnode(cornzlo,mptr)
      hz    = hzposs(levm)
      dt    = possk(levm)
      numsp = 0
 
      errmax = 0.0d0
      err2   = 0.0d0
c     order  = dt*dble(2**(iorder+1) - 2)
      order  = dble(2**(iorder+1) - 2)
c
      if (.not. (edebug)) go to 20
         write(outunit,107) mptr
 107     format(//,' coarsened grid values for grid ',i4)
         do 10 kk = nghost+1, mk2tot-nghost
            k = mk2tot + 1 - kk
         do 10 jj = nghost+1, mj2tot-nghost
            j = mj2tot + 1 - jj
            write(outunit,101) (rctcrse(1,i,j,k),
     .                          i = nghost+1, mi2tot-nghost)
10       continue
         write(outunit,108) mptr
 108     format(//, ' fine grid values for grid ',i4)
         do 15 kk = nghost+1, mktot-nghost
            k = mktot + 1 - kk
         do 15 jj = nghost+1, mjtot-nghost
            j = mjtot + 1 - jj
            write(outunit,101) (rctfine(1,i,j,k),
     .                          i = nghost+1, mitot-nghost)
15       continue
101      format(' ',13f6.3)
c
c zero out the exterior locations so they dont affect err.est.
c
 20   continue
      kfine = nghost+1
      do 39  k = nghost+1, mk2tot-nghost
      zofk  = zbot   + (dble(kfine) - .5d0)*hz
      jfine = nghost+1
      do 35  j = nghost+1, mj2tot-nghost
      yofj  = yfront + (dble(jfine) - .5d0)*hy
      ifine = nghost+1
c
      do 30  i  = nghost+1, mi2tot-nghost
          rflag = goodpt
          xofi  = xleft + (dble(ifine) - .5d0)*hx
          term1 = rctfine(1,ifine  ,jfine  ,kfine  )
          term2 = rctfine(1,ifine+1,jfine  ,kfine  )
          term3 = rctfine(1,ifine+1,jfine+1,kfine  )
          term4 = rctfine(1,ifine  ,jfine+1,kfine  )
          term5 = rctfine(1,ifine  ,jfine  ,kfine+1)
          term6 = rctfine(1,ifine+1,jfine  ,kfine+1)
          term7 = rctfine(1,ifine+1,jfine+1,kfine+1)
          term8 = rctfine(1,ifine  ,jfine+1,kfine+1)
c         # divide by (aval*order) for relative error
          aval  = (term1+term2+term3+term4
     &            +term5+term6+term7+term8)/8.d0
          est   =  dabs((aval-rctcrse(1,i,j,k))/ order)
          if (est .gt. errmax) errmax = est
            err2 = err2 + est*est
c         write(outunit,102) i,j,est
 102      format(' i,j,k,est ',3i5,e12.5)
c         rctcrse(2,i,j,k) = est
c
          if (est.ge.tol .and. allowflag(xofi,yofj,zofk,time,levm)) then
             rflag  = badpt
          endif 
      rctcrse(1,i,j,k) = rflag
      ifine = ifine + 2
 30   continue
      jfine = jfine + 2
 35   continue
      kfine = kfine + 2
 39   continue
c
c  transfer flagged points on cell centered coarse grid
c  to cell centered fine grid. count flagged points.
c
c  initialize rctflg to 0.0 (no flags)  before flagging
c
      do 40 k = 1, mktot
      do 40 j = 1, mjtot
      do 40 i = 1, mitot
 40      rctflg(1,i,j,k) = goodpt
c
c  print out intermediate flagged rctcrse (for debugging)
c
      if (eprint) then
         err2 = dsqrt(err2/dble((mi2tot-2*nghost)*(mj2tot-2*nghost)
     &                                           *(mk2tot-2*nghost)))
         write(outunit,103) mptr, levm, errmax, err2
 103     format(' grid ',i4,' level ',i4,
     .          ' max. error = ',e15.7,' err2 = ',e15.7)
         if (edebug) then
           write(outunit,*) ' flagged points on coarsened grid ',
     .                  'for grid ',mptr
           do 45 kk = nghost+1, mk2tot-nghost
              k = mk2tot + 1 - kk
           do 45 jj = nghost+1, mj2tot-nghost
              j = mj2tot + 1 - jj
              write(outunit,106) (nint(rctcrse(1,i,j,k)),
     .                            i=nghost+1,mi2tot-nghost)
106           format(1h ,80i1)
45         continue
         endif
      endif
c
      kfine   = nghost+1
      do 74 k = nghost+1, mk2tot-nghost
      jfine   = nghost+1
      do 70 j = nghost+1, mj2tot-nghost
      ifine   = nghost+1
      do 60 i = nghost+1, mi2tot-nghost
          if (rctcrse(1,i,j,k) .eq. goodpt) go to 55
            rctflg(1,ifine  ,jfine  ,kfine  ) = badpt
            rctflg(1,ifine+1,jfine  ,kfine  ) = badpt
            rctflg(1,ifine  ,jfine+1,kfine  ) = badpt
            rctflg(1,ifine+1,jfine+1,kfine  ) = badpt
            rctflg(1,ifine  ,jfine  ,kfine+1) = badpt
            rctflg(1,ifine+1,jfine  ,kfine+1) = badpt
            rctflg(1,ifine  ,jfine+1,kfine+1) = badpt
            rctflg(1,ifine+1,jfine+1,kfine+1) = badpt
 55   ifine   = ifine + 2
 60   continue
      jfine   = jfine + 2
 70   continue
      kfine   = kfine + 2
 74   continue
c
      return
      end

module rp1_driver

contains

    subroutine call_rp1(meqn,mwaves,q_left,q_right,wave,s,amdq,apdq)
    ! wrapper to call a 1d Riemann solver
    ! still need to add auxl and auxr

    implicit none

    ! Input:
    integer, intent(in) :: meqn, mwaves
    real(kind=8), intent(in) ::   q_left(meqn)
    real(kind=8), intent(in) ::   q_right(meqn)

    ! Output:
    real(kind=8), intent(out) ::    s(mwaves)
    real(kind=8), intent(out) :: wave(meqn, mwaves)
    real(kind=8), intent(out) ::  apdq(meqn)
    real(kind=8), intent(out) ::  amdq(meqn)

    ! local variables:
    integer, parameter :: mbc = 0
    integer, parameter :: maux = 0    ! NEED TO ADD aux arrays
    real(kind=8) ::   ql(meqn, 1-mbc:2+mbc)
    real(kind=8) ::   qr(meqn, 1-mbc:2+mbc)
    real(kind=8) ::   auxl(maux, 1-mbc:2+mbc)
    real(kind=8) ::   auxr(maux, 1-mbc:2+mbc)
    real(kind=8) ::    s_vec(mwaves,         1-mbc:2+mbc)
    real(kind=8) :: wave_vec(meqn,   mwaves, 1-mbc:2+mbc)
    real(kind=8) ::  apdq_vec(meqn,          1-mbc:2+mbc)
    real(kind=8) ::  amdq_vec(meqn,          1-mbc:2+mbc)
    integer :: i, m, mw, mx
    logical, parameter :: debug = .false.

    do i=1,meqn
        qr(i,1) = q_left(i)
        ql(i,2) = q_right(i)
        enddo

    mx = 2

    if (debug) then
        print *, 'qr(:,1):'
        do m=1,meqn
            write(6,60) qr(m,1)
            enddo
        print *, 'ql(i,2):'
        do m=1,meqn
            write(6,60) ql(m,2)
            enddo
        endif

    call rp1(mx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave_vec,s_vec,amdq_vec,apdq_vec)

    ! left and right states in cells 1 and 2, so Riemann solution
    ! is in i=2 element of output vectors:

    do mw=1,mwaves
        s(mw) = s_vec(mw,2)
        do m=1,meqn
            wave(m,mw) = wave_vec(m,mw,2)
            enddo
        enddo
    do m=1,meqn
        amdq(m) = amdq_vec(m,2)
        apdq(m) = apdq_vec(m,2)
        enddo

    if (debug) then
        do i=1-mbc,mx+mbc
            print *, '==> i = ',i
            print *, 's_vec:'
            write(6,60) (s_vec(mw,i), mw=1,mwaves)
60          format(6d16.6)

            print *, 'wave_vec:'
            do m=1,meqn
                write(6,60) (wave_vec(m,mw,i), mw=1,mwaves)
                enddo

            print *, 'amdq:'
            do m=1,meqn
                write(6,60) amdq_vec(m,i)
                enddo
            print *, 'apdq:'
            do m=1,meqn
                write(6,60) apdq_vec(m,i)
                enddo
            enddo
            print *, '==='
        endif

    end subroutine call_rp1
    

end module rp1_driver

c
c ----------------------------------------------------
c
      subroutine domcopy(iflags2,iflags,isize,jsize,ksize)

      use amr_module
      implicit double precision (a-h, o-z)

      integer*1  iflags2(0:isize+1,0:jsize+1,0:ksize+1)
      integer*1  iflags (0:isize+1,0:jsize+1,0:ksize+1)

c
c ::::::::::::::::::::::::::: DOMCOPY :::::::::::::::::::::
c 
c  domain flags are in iflags. copy into iflags2.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::


      do 10 k = 0, ksize+1
      do 10 j = 0, jsize+1
      do 10 i = 0, isize+1
        iflags2(i,j,k) = iflags(i,j,k)
 10   continue
c
c  take care of periodicity again
c
      if (xperdom) then
         do 35 k = 0, ksize+1
         do 35 j = 0, jsize+1
           iflags2(      0,j,k) = iflags2(isize,j,k)
           iflags2(isize+1,j,k) = iflags2(    1,j,k)
 35      continue
       else
         do 65 k = 1, ksize
         do 65 j = 1, jsize
           if (iflags2(    1,j,k) .eq. 1) iflags2(      0,j,k) = 1
           if (iflags2(isize,j,k) .eq. 1) iflags2(isize+1,j,k) = 1
 65      continue
      endif
      if (yperdom) then
         do 45 k = 0, ksize+1
         do 45 i = 0, isize+1
           iflags2(i,      0,k) = iflags2(i,jsize,k)
           iflags2(i,jsize+1,k) = iflags2(i,    1,k)
 45      continue
       else
         do 55 k = 1, ksize
         do 55 i = 1, isize
           if (iflags2(i,    1,k) .eq. 1) iflags2(i,      0,k) = 1
           if (iflags2(i,jsize,k) .eq. 1) iflags2(i,jsize+1,k) = 1
 55      continue
      endif
      if (zperdom) then
         do 75 j = 0, jsize+1
         do 75 i = 0, isize+1
           iflags2(i,j,      0) = iflags2(i,j,ksize)
           iflags2(i,j,ksize+1) = iflags2(i,j,    1)
 75      continue
       else
         do 85 j = 1, jsize
         do 85 i = 1, isize
           if (iflags2(i,j,    1) .eq. 1) iflags2(i,j,      0) = 1
           if (iflags2(i,j,ksize) .eq. 1) iflags2(i,j,ksize+1) = 1
 85      continue
       end if

      if (dprint) then
         write(outunit,*)" from domcopy: domflags "
         do 40 kk = 1, ksize
         k = ksize + 1 - kk
         write(outunit,*) 'plane k = ',k
         do 40 jj = 1, jsize
         j = jsize + 1 - jj
         write(outunit,100)(iflags2(i,j,k),i=1,isize)
 100     format(80i1)
 40      continue
      endif

 
      return
      end

c
c --------------------------------------------------------------------------
c
       subroutine init_iflags(iflags,isize,jsize)
c
c      # Need this routine to initialize since iflags is part of double 
c      # precision alloc array but is used as an integer(kind=1) to save storage.

       implicit double precision (a-h,o-z)

       integer(kind=1)  iflags (0:isize+1,0:jsize+1)

         do j = 1, jsize
         do i = 1, isize
           iflags(i,j) = 0
           enddo
         enddo

       return
       end

c
c ----------------------------------------------------------
c
       subroutine shiftset(intarray,isize,jsize,ksize)

      use amr_module
      implicit double precision (a-h, o-z)

      integer*1 intarray (0:isize+1,0:jsize+1,0:ksize+1)
      integer*1 intarray2(0:isize+1,0:jsize+1,0:ksize+1)

c :::::::::::::::::::::: CSHIFT :::::::::::::::::::::::::::::::
c shift by + or - 1 in either direction (but only 1 at a time)
c used for bit calculus for proper nesting, buffering, etc.
c similar to cshift on CM machine.
c includes periodic buffering as well.
c
c NEWER VERSION: DO ALL DIRS AT SAME TIME
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       if (xperdom) then
          do 10 k = 0, ksize+1
          do 10 j = 0, jsize+1
            intarray(      0,j,k) = intarray(isize,j,k)
            intarray(isize+1,j,k) = intarray(    1,j,k)
 10       continue
       else
          do 11 k = 0, ksize+1
          do 11 j = 0, jsize+1
            intarray(      0,j,k) = 0
            intarray(isize+1,j,k) = 0
 11       continue
       endif
       if (yperdom) then
         do 12 k = 0, ksize+1
         do 12 i = 0, isize+1
            intarray(i,      0,k) = intarray(i,jsize,k)
            intarray(i,jsize+1,k) = intarray(i,    1,k)
 12       continue
       else
         do 13 k = 0, ksize+1
         do 13 i = 0, isize+1
            intarray(i,      0,k) = 0
            intarray(i,jsize+1,k) = 0
 13       continue
       endif
       if (zperdom) then
          do 14 j = 0, jsize+1
          do 14 i = 0, isize+1
             intarray(i,j,      0) = intarray(i,j,ksize)
             intarray(i,j,ksize+1) = intarray(i,j,    1)
 14       continue
       else
          do 15 j = 0, jsize+1
          do 15 i = 0, isize+1
             intarray(i,j,      0) = 0
             intarray(i,j,ksize+1) = 0
 15       continue
       endif

       do k = 1, ksize
       do j = 1, jsize
       do i = 1, isize
          intarray2(i,j,k) = 0
       end do
       end do
       end do

       do k = 1, ksize
       do j = 1, jsize
       do i = 1, isize

          intflag = intarray(i,j,k)
          if (intflag .gt. 0)  then
c            cell is flagged, buffer in all dirs by one cell
c            use second array to avoid propagation
             iilo = max(i - ibuff, 0)
             iihi = min(i + ibuff, isize+1)
             jjlo = max(j - ibuff, 0)
             jjhi = min(j + ibuff, jsize+1)
             kklo = max(k - ibuff, 0)
             kkhi = min(k + ibuff, ksize+1)
             do kk = kklo, kkhi 
             do jj = jjlo, jjhi
             do ii = iilo, iihi
                intarray2(ii,jj,kk) = intflag  ! copy the flag (may not be = 1?)
             end do
             end do
             end do
          endif

       end do
       end do
       end do

c   copy back. need flags in original array

       do 60 k = 1, ksize
       do 60 j = 1, jsize
       do 60 i = 1, isize
c         intarray(i,j,k) = max(intarray(i,j,k),intarray2(i,j,k))
         intarray(i,j,k) = intarray(i,j,k) + intarray2(i,j,k)
 60    continue


       return
       end

!> The module contains the definition of a "node descriptor" 
!! as well as other global variables used during the whole run.
!! 
!! The "node descriptor" is a tree data structure we use to keep track of 
!! all AMR grids.
!! Each grid in the grid hierarchy corresponds to a node in the tree. 
!! When a fine grid is nested in a coarse grid, its corresponding node in the tree 
!! is an offspring of the parent node corresponding to the coarse grid.
!! ![Tree data structure for grid management](./images/AMR_tree.png "amr_tree")
!!
!! Each node has a fixed number of items of information describing the grid,
!! stored and accessable as **node(property number, node number)** (which returns
!! a integer type as either data itself or a pointer to a memory location)
!! and **rnode(property number, node number)** (which returns a real type).
!! E.g. **node(nestlevel, 5)** stores AMR level of grid 5.
!! **rnode(cornxlo, 3)** stores x-coordinate of left border of grid 3.
!!
!! See explanation to each data members in this module 
!! for details of all properties of a node.
!!
module amr_module

    implicit none
       
    save
       
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::   data structure info.
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    integer, parameter :: rsize = 5
    integer, parameter :: nsize = 19

    !  :::::::   integer part of node descriptor
    !> node number (index) of next grid on the same level
    integer, parameter :: levelptr  = 1 

    !> temporary pointer
    integer, parameter :: tempptr   = 2

    ! TODO
    integer, parameter :: errptr    = 3

    !> AMR level of the grid
    integer, parameter :: nestlevel = 4

    !> Pointer to an 5 by **maxsp** array, which has boundary information 
    !! for this grid.
    !!
    !! ### About the Array
    !! The array is generally referred to as **listbc**. It stores information 
    !! about interface between grid **mptr** and all grids one
    !! level finer if they intersect. 
    !! These interfaces consist of multiple cell edges (or segments,
    !! whose length = cell size on grid **mptr**).
    !! Each column in **listbc** has five entries and stores information 
    !! associated with one segment. 
    !! If a global index for all these segments is denoted by **ispot**,
    !! the five entries for the \f$ ispot^{th}\f$ segment can be explained as below: 
    !! 
    !! - listbc(1,ispot) stores LOCAL (RALATIVE to left boundary of grid
    !! **mptr**) *i* index of the cell on grid **mptr** that border this 
    !! segment. 
    !! - listbc(2,ispot) stores LOCAL (RALATIVE to left boundary of grid
    !! **mptr**) *j* index of the cell on grid **mptr** that border this 
    !! segment. 
    !! - listbc(3,ispot) stores side number, which indicates which side 
    !! of this segment is a cell of grid **mptr** (coarse cell).
    !! If this segment is the left edge of a cell on grid **mptr**, this 
    !! number is 1. The number increases (2, 3, 4) as it goes around a coarse cell
    !! clockwise (top edge, right edge, bottom edge).
    !! - listbc(4,ispot) stores grid number of the finer grid that borders
    !! this segment
    !! - listbc(5,ispot) stores the position of this segment with respect to 
    !! the perimeter of this finer grid (grid listbc(4,ispot)). 
    !! The fine grid will save all its fluxes all around its
    !! perimeter. This entry tells where the coarse grid should
    !! take them from. Note that number of fluxes saved here is equal 
    !! to number of such segments (length = coarse cell size) needed to make
    !! up the perimeter.
    integer, parameter :: cfluxptr  = 5

    !> pointer to the address of memory storing fluxes in a layer around the grid, 
    !! to be used in conservation fixup near coarse-fine grid intersections.
    !! The memory allocated is 
    !! \f$ 2 \times nvar \times lenbc + naux \times lenbc \f$, 
    !! where \f$lenbc\f$ is 
    !! the number of its parent grid cells adjacent to (around) their boundary interfaces. 
    !! The coefficient 2 is for two spaces. 
    !! One is for plus or minus fluxes, and the other is for the coarse solution for wave fixing.
    !!
    !! From node(ffluxptr,mptr) to node(ffluxptr,mptr)+lenbc-1, 
    !! it stores value that should be added to the adjacent coarse cell
    !! during the synchronization for conservation fixup
    !!
    !! From node(ffluxptr,mptr)+lenbc to node(ffluxptr,mptr)+2*lenbc-1,
    !! it stores solution q on the adjacent coarse cell
    integer, parameter :: ffluxptr  = 6

    !> pointer to the address of memory storing the first copy of solution data on this grid,
    !! usually for storing new solution
    integer, parameter :: store1    = 7

    !> pointer to the address of memory storing the second copy of solution data on this grid, 
    !! usually for storing old solution
    integer, parameter :: store2    = 8

    !> global *i* index of left border of this grid
    integer, parameter :: ndilo     = 9

    !> global *i* index of right border of this grid
    integer, parameter :: ndihi     = 10

    !> global *j* index of lower border of this grid
    integer, parameter :: ndjlo     = 11

    !> global *j* index of upper border of this grid
    integer, parameter :: ndjhi     = 12

    !> pointer to the address of memory storing auxiliary data on this grid
    integer, parameter :: storeaux  = 13

    !> pointer to the address of memory storing flags for refinement on this grid
    integer, parameter :: storeflags  = 14

    !> number of flagged cells on this grid
    integer, parameter :: numflags  = 15

    !> domain flags, indexed within base level (lbase) index space
    integer, parameter :: domflags_base  = 16

    !> domain flags, indexed within level-of-this-grid level index space
    integer, parameter :: domflags2  = 17

    !> pointer (actually it's an index in the bndList array) to the first node 
    !! of a linked list, which stores all grids (on the same level) that border this grid
    integer, parameter :: bndListSt  = 18

    !> number of grids (on the same level) that border this grid
    integer, parameter :: bndListNum = 19

    ! :::::::  real part of node descriptor
    !> x-coordinate of the left border of this grid
    integer, parameter :: cornxlo  = 1
    !> y-coordinate of the lower border of this grid
    integer, parameter :: cornylo  = 2
    !> x-coordinate of the right border of this grid
    integer, parameter :: cornxhi  = 3
    !> y-coordinate of the upper border of this grid
    integer, parameter :: cornyhi  = 4
    !> current simulation time on this grid
    integer, parameter :: timemult = 5

    ! :::::::   for linking nodes
    integer, parameter :: nextfree = 2
    integer, parameter :: null = 0
    integer, parameter :: nil  = 0

    integer, parameter :: gridNbor = 1 !use 1st col, 2nd col is nextfree - the link

    ! :::::::  for flagging points   
    ! TODO: can use one bit for this instead of real?
    ! needs to be set
    real(kind=8), parameter :: UNSET = -1.0
    ! needs no refine
    real(kind=8), parameter :: DONTFLAG = 0.0
    ! needs refine
    real(kind=8), parameter :: DOFLAG  = 2.0
    real(kind=8), parameter :: badpro = 3.0

    real(kind=8), parameter :: NEEDS_TO_BE_SET = 10.e33
    real(kind=8), parameter :: rinfinity = 10.e32
    integer, parameter :: iinfinity = 999999999
    integer, parameter :: horizontal = 1
    integer, parameter :: vertical = 2
    integer, parameter :: maxlv = 10

    !> maximum number of clusters (grids) on each grid level
    integer, parameter :: maxcl = 5000

    ! The max1d parameter should be changed if using OpenMP grid based 
    ! looping, usually set to max1d = 60
    ! max1d should now be set in setrun.py
    integer :: max1d

    integer, parameter :: maxvar = 10
    integer, parameter :: maxaux = 20
    integer, parameter :: maxwave = 10


    ! note use of sentinel in listStart
    !integer :: listOfGrids(maxgr),listStart(0:maxlv+1)
    integer :: listStart(0:maxlv+1)
    !integer,parameter :: bndListSize = 8*maxgr ! old way
    !integer :: bndList(bndListSize,2)  ! guess size, average # nbors 4? manage as linked list
    integer :: bndListSize
    integer,allocatable, dimension(:,:) :: bndList  ! new way is allocatable 

    !real(kind=8) hxposs(maxlv), hyposs(maxlv),possk(maxlv),rnode(rsize, maxgr) 
    real(kind=8) hxposs(maxlv), hyposs(maxlv),possk(maxlv)

    ! start of dynamic allocation for maxgr and associated arrays
    integer   maxgr 
    real(kind=8), allocatable, dimension(:,:) :: rnode    ! new way, use allocatable, not pointer
    integer, allocatable, dimension(:,:) :: node
    integer, allocatable, dimension(:) :: listOfGrids


    real(kind=8) tol, tolsp
    !integer ibuff,  mstart, ndfree, ndfree_bnd, lfine, node(nsize, maxgr), &
    integer ibuff,  mstart, ndfree, ndfree_bnd, lfine,  &
            icheck(maxlv),lstart(maxlv),newstl(maxlv), &
            listspStart(maxlv),listsp(maxlv),intratx(maxlv),intraty(maxlv), &
            kratio(maxlv), iregsz(maxlv),jregsz(maxlv), &
            iregst(maxlv),jregst(maxlv), &
            iregend(maxlv),jregend(maxlv), &
            numgrids(maxlv),numcells(maxlv), &
            iorder,mxnest,kcheck

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! ::::  for alloc array/memory
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    ! Static memory implementation
    ! parameter  (memsize = 10000000)
    ! common  /calloc/   alloc(memsize)

    ! Dynamic memory: 
    !real(kind=8), allocatable, target, dimension(:) :: storage
    !real(kind=8), pointer, dimension(:) :: alloc   ! old way, changed mjb Sept. 2014
    real(kind=8), allocatable, dimension(:) :: alloc    ! new way, use allocatable, not pointer
    integer memsize
       
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::\
    ! :::::   for space management of alloc array
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    integer, parameter :: lfdim=5000
    integer lfree(lfdim,2),lenf

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  domain description variables
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    logical xperdom, yperdom, spheredom
    real(kind=8) :: xupper, yupper, xlower, ylower
    integer :: nghost, mthbc(4)

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  collect stats
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    real(kind=8)  rvoll(maxlv),evol,rvol,avenumgrids(maxlv)
    integer ::  iregridcount(maxlv)
    integer(kind=8) ::  tvoll(maxlv)
    integer(kind=8) :: timeRegridding, timeUpdating, timeValout
    integer(kind=8) :: timeFlglvl,timeGrdfit2,timeGrdfit3,timeGrdfitAll
    integer(kind=8) :: timeBound,timeStepgrid
    integer(kind=8) :: timeFlagger, timeBufnst,timeTick, tick_clock_start
    real(kind=8) tvollCPU(maxlv), timeTickCPU, tick_cpu_start
    real(kind=8) timeBoundCPU,timeStepgridCPU,timeRegriddingCPU
    real(kind=8) timeValoutCPU

    integer lentot,lenmax,lendim

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! :::::  method parameters
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    character(len=10), allocatable :: auxtype(:)
    integer  method(7), mwaves, mcapa, dimensional_split
    integer, allocatable :: mthlim(:)
    real(kind=8) cfl,cflmax,cflv1,cfl_level

    logical :: use_fwaves
    logical :: flag_richardson,flag_gradient
    integer :: verbosity_regrid

    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    ! ::::: Parameters and variables related to I/O and checkpointing
    ! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
    logical    printout,matlabout,ncarout

    ! variables for conservation checking:
    real(kind=8) tmass0

    ! variables for specifying output format
    integer :: output_style, nstop, nout, iout
    real(kind=8), allocatable :: tout(:)
    real(kind=8) :: t0, tfinal
    real(kind=8) :: tstart_thisrun  ! /= t0 in case of restart
    integer :: nq_components, naux_components, output_format
    integer, allocatable :: output_q_components(:)
    integer, allocatable :: output_aux_components(:)
    logical :: output_aux_onlyonce

    ! checkpointing:
    integer :: checkpt_style, nchkpt, checkpt_interval
    real(kind=8), allocatable :: tchk(:)

    integer :: matlabu

    !  USE UNITS NUMBERS < 89.
    ! 89 and + numthreads taken by gauge output
    integer, parameter :: parmunit = 12
    integer, parameter :: chkunit = 10
    integer, parameter :: inunit  = 5
    integer, parameter :: outunit = 66
    integer, parameter :: pltunit1 = 3
    integer, parameter :: rstunit = 9
    integer, parameter :: dbugunit = 11
    integer, parameter :: matunit = 70

    ! ::::  Debugging flags (verbose output)
    logical &
                dprint,     & !  domain flags output
                eprint,     & !  error estimation output
                edebug,     & !  even more error estimation output
                gprint,     & !  verbose grid generation (clustering,colating...)
                nprint,     & !  nestck reporting
                pprint,     & !  projec tagged pts.
                rprint,     & !  regridding -  summary of new grids
                sprint,     & !  space (memory) output
                tprint,     & !  tick (time stepping) reporting
                uprint        !  updating/upbnding reporting


    ! Restart file name:
    character(len=200) :: rstfile
    logical :: check_a

end module amr_module

      subroutine opendatafile(iunit, fname)
c     #
c     # Open the file fname and determine how many leading lines are
c     # comments.  Then rewind and skip over the comment lines so that the
c     # file is ready for reading data from.
c     #
c     # All comment lines must start with # in the first column.

      integer iunit, line, commentlines


c     This allows for a variable name length and obsolves (I think) the
c     length problem that appeared for some compilers (notably ifort)
      character(len=*) :: fname
c     character*25 fname
c     character*12 fname12

      character*1 firstchar
      logical foundFile
      
c     # Debug statement to test fname:
c     write(6,*) '+++ fname = XXX',fname,'XXX'

      inquire(file=fname,exist=foundFile)
      if (.not. foundFile) then
c         # for backward compatability: maybe fname is declared character*12
c         # in calling routine...
c         fname12 = fname(1:12)
c         #write(6,*) 'truncated fname12 = XXX',fname12,'XXX'
c         inquire(file=fname12,exist=foundFile)
          if (.not. foundFile) then
            print "(2a)",'*** in opendatafile, file not found:', fname 
            stop
          endif
c         open(unit=iunit,file=fname12,status='old',form='formatted')
c         write(6,*) 'Reading data file: ', fname12
      else
          open(unit=iunit,file=fname,status='old',form='formatted')
          print "(2a)",'Reading data file: ', fname
      endif

c     # this version may not work in f77
c     firstchar = '#'
c     commentlines = -1
c     do while (firstchar == '#')
c        read(iunit,*) firstchar
c        commentlines = commentlines + 1
c        enddo

      firstchar = '#'
      commentlines = -1
      do commentlines=-1,1000
          if (firstchar .eq. '#') then
              read(iunit,"(a1)") firstchar
          else
              exit
          endif
      enddo
      
      write(6,602) commentlines
  602 format('         first',i2,
     &       ' lines are comments and will be skipped')
     
c     Rewind file and go back to data line
C       print *,firstchar
C       rewind(iunit)
C       do line=1,commentlines
C          read(iunit,*) firstchar
C          print *,firstchar
C          enddo
C       
      return
      end

c
c
c
c
c =========================================================
      subroutine dump2(meqn,mwaves,mbc,mx,my,
     &           q,t,dx,dy,dtv,cflv,nv,method,mthlim,info)
c =========================================================
c
c     # Dump the data needed for a possible restart
c
      implicit double precision (a-h,o-z)
      dimension q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension dtv(5),cflv(4),nv(2),method(7),mthlim(mwaves)
c
      write(99,*) mx,my
      write(99,*) dx,dy
      write(99,*) t
      write(99,*) dtv
      write(99,*) cflv
      write(99,*) nv
      write(99,*) method
      write(99,*) mthlim
      write(99,*) info
c
      do 12 m=1,meqn
         do 11 j=1,my
            do 10 i=1,mx
               write(99,*) q(m,i,j)
   10       continue
   11    continue
   12 continue
      return
      end

c
c ----------------------------------------------------------
c
      subroutine prepf(level,nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c ::::::::::::::::::::::::::: PREPF :::::::::::::::::::::::::::::
c
c prepare new fine grids to save fluxes after each integration step
c for future conservative fixing of coarse grids
c save all boundary fluxes of fine grid (even if phys. bndry.) -
c but only save space for every intrat. (remember - 4 fluxes).
c
c :::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::::::
c
      mkid = lstart(level)
 10   if (mkid .eq. 0) go to 99
          nx    = node(ndihi,mkid)-node(ndilo,mkid) + 1
          lenbc = 2
c
c         get twice the storage, one for plus or minus fluxes, the
c         other for coarse solution for wave fixing. also for aux vars.
c
          node(ffluxptr,mkid) = igetsp(2*nvar*lenbc+naux*lenbc)
          ist   = node(ffluxptr,mkid)

          do 20 i = 1, 2*nvar*lenbc + naux*lenbc
 20          alloc(ist+i-1) = 0.d0
          mkid = node(levelptr,mkid)
          go to 10

 99    return
       end

c
!> Check each grid, starting with **mptr1** (either newstl or lstart)
!! to see that it has no more than max1d points in either dimensions.
!! needed so that scratch array space in stepgrid not exceeded.
!!
!! Also check for too small grids - but has never happened.
c
c --------------------------------------------------
c
      subroutine birect(mptr1)
c
      use amr_module
      implicit double precision (a-h,o-z)


c
c :::::::::::::  BIRECT :::::::::::::::::::::::::::::::::::::::
c check each grid, starting with mptr1 (either newstl or lstart)
c to see that it has no more than max1d points in either dimensions.
c needed so that scratch array space in stepgrid not exceeded.
c
c also check for too small grids - but has never happened.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      mptr  = mptr1
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
c
10    continue
      cxlo    = rnode(cornxlo,mptr)
      cxhi    = rnode(cornxhi,mptr)
      cylo    = rnode(cornylo,mptr)
      cyhi    = rnode(cornyhi,mptr)
      nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      minsize = 2*nghost
c
c check number of rows first - if too many, bisect grid with vertical
c line down the middle. make sure new grid corners are anchored
c on coarse grid point. make sure if bisecting coarse grid that
c new grids have even number of points
c
      if (nx + 2*nghost .gt. max1d) then
 
        nxl    = nx/2
        if (level .gt. 1) then 
           lratio = intratx(level-1)
        else
           lratio = 2
        endif
        nxl = (nxl/lratio)*lratio 
        nxr    = nx - nxl 
        cxmid  = cxlo + nxl*hx
 
        mptrnx = nodget()
        node(levelptr,mptrnx) = node(levelptr,mptr)
        node(levelptr,mptr)   = mptrnx
 
        rnode(cornxhi,mptr) = cxmid
        node(ndihi,mptrnx)  = node(ndihi,mptr)
        node(ndihi,mptr)    = node(ndilo,mptr) + nxl - 1
        node(ndilo,mptrnx)  = node(ndihi,mptr) + 1
        node(ndjhi,mptrnx)  = node(ndjhi,mptr)
        node(ndjlo,mptrnx)  = node(ndjlo,mptr)

        rnode(cornxlo,mptrnx)    = cxmid
        rnode(cornylo,mptrnx)    = cylo
        rnode(cornyhi,mptrnx)    = cyhi
        rnode(cornxhi,mptrnx)    = cxhi
        rnode(timemult,mptrnx)   = rnode(timemult,mptr)
        node(nestlevel,mptrnx)   = node(nestlevel,mptr)

        go to 10
c
c check number of columns next - if too many, bisect grid with horizontal
c line down the middle
c
      else if (ny + 2*nghost .gt. max1d) then
 
        nyl    = ny/2
        if (level .gt. 1) then 
           lratio = intraty(level-1)
        else
           lratio = 2
        endif
        nyl = (nyl/lratio)*lratio
        nyr    = ny - nyl 
        cymid  =  cylo + nyl*hy
 
        mptrnx = nodget()
        node(levelptr,mptrnx) = node(levelptr,mptr)
        node(levelptr,mptr)   = mptrnx
 
        rnode(cornyhi,mptr)   = cymid

        node(ndjhi,mptrnx) = node(ndjhi,mptr)
        node(ndjhi,mptr)   = node(ndjlo,mptr) + nyl - 1
        node(ndjlo,mptrnx) = node(ndjhi,mptr) + 1
        node(ndihi,mptrnx) = node(ndihi,mptr)
        node(ndilo,mptrnx) = node(ndilo,mptr)

        rnode(cornxlo,mptrnx)   = cxlo
        rnode(cornylo,mptrnx)   = cymid
        rnode(cornyhi,mptrnx)   = cyhi
        rnode(cornxhi,mptrnx)   = cxhi
        node(nestlevel,mptrnx)  = node(nestlevel,mptr)
        rnode(timemult,mptrnx)  = rnode(timemult,mptr)
        go to 10
c
c  grid ok - check the next
c
      else
        mptr = node(levelptr,mptr)
        if (mptr.ne.0) go to 10
 
      endif
 
      return
      end

! =========================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =========================================================

! solve Riemann problem for the 1D shallow water equations using the HLLE
! approximate Riemann solver.

! waves: 2
! equations: 2

! Conserved quantities:
!       1 depth (h)
!       2 momentum (hu)

    implicit none

    integer, intent(in) :: maxmx, meqn, mwaves, mbc, mx, maux
    double precision, dimension(meqn,1-mbc:maxmx+mbc), intent(in) :: ql, qr
    double precision, dimension(maux,1-mbc:maxmx+mbc), intent(in) :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxmx+mbc), intent(out) :: wave
    double precision, dimension(meqn, 1-mbc:maxmx+mbc), intent(out) :: amdq, apdq
    double precision, dimension(mwaves, 1-mbc:maxmx+mbc), intent(out) :: s

    double precision :: u_l, u_r, h_l, h_r, c_l, c_r
    double precision :: hsqrt_l, hsqrt_r, u_hat, h_hat, c_hat, grav
    double precision :: h_m, hu_m
    double precision :: rho_m, rhou_m, E_m, s1, s2
    integer :: m, i, mw

    common /cparam/  grav

    do i=2-mbc,mx+mbc
        h_l = qr(1,i-1)
        h_r = ql(1,i)
        u_l = qr(2,i-1) / qr(1,i-1)
        u_r = ql(2,i  ) / ql(1,i  )
        c_l = dsqrt(grav*h_l)
        c_r = dsqrt(grav*h_r)
            
        if (h_l<1.e-14 .AND. h_r<1.e-14) then
            wave(1,1,i) =0.
            wave(2,1,i) =0.
            s(1,i) = 0.
    
            wave(1,2,i) = 0.
            wave(2,2,i) = 0.
            s(2,i) = 0.
            
        else
            ! Roe averages
            hsqrt_l = dsqrt(qr(1,i-1))
            hsqrt_r = dsqrt(ql(1,i))
            h_hat = 0.5*(h_l + h_r)
            u_hat = (hsqrt_l*u_l + hsqrt_r*u_r) / (hsqrt_l + hsqrt_r)
            c_hat = dsqrt(grav*h_hat)

            s1 = min(u_l - c_l, u_hat - c_hat)
            s2 = max(u_r + c_r, u_hat + c_hat)

            ! Middle state
            h_m = (ql(2,i) - qr(2,i-1) - s2*h_r + s1*h_l) / (s1-s2)
            hu_m = (ql(2,i)*(u_r-s2) - qr(2,i-1)*(u_l-s1) + 0.5*grav*(h_r**2-h_l**2)) / (s1-s2)
               
            wave(1,1,i) = h_m - h_l
            wave(2,1,i) = hu_m - qr(2,i-1)
            s(1,i) = s1
    
            wave(1,2,i) = h_r - h_m
            wave(2,2,i) = ql(2,i) - hu_m
            s(2,i) = s2
        end if

    end do 

    do m=1, meqn
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1, mwaves
                if (s(mw,i) < 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                else
                    apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                endif
            end do
        end do
    end do

end subroutine rp1

c
c
c     =====================================================
      subroutine rpt2(ixy,imp,maxm,meqn,mwaves,num_aux,mbc,mx,
     &                  ql,qr,aux1,aux2,aux3,
     &                  asdq,bmasdq,bpasdq)
c     =====================================================
c
c     # Riemann solver in the transverse direction.
c     # This is a dummy routine that returns zeros and is only intended
c     # to illustrate the format of this routine.  See various example
c     # directories for better examples.

c     # This dummy routine can be used if transverse solves are not being
c     # used, i.e. if method(3)=0.
c
c     # Split asdq (= A^* \Delta q, where * = + or -)
c     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
c     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)
c
c
      implicit double precision (a-h,o-z)
      dimension     ql(meqn,1-mbc:maxm+mbc)
      dimension     qr(meqn,1-mbc:maxm+mbc)
      dimension   asdq(meqn,1-mbc:maxm+mbc)
      dimension bmasdq(meqn,1-mbc:maxm+mbc)
      dimension bpasdq(meqn,1-mbc:maxm+mbc)
      dimension   aux1(num_aux,1-mbc:maxm+mbc)
      dimension   aux2(num_aux,1-mbc:maxm+mbc)
      dimension   aux3(num_aux,1-mbc:maxm+mbc)
c
      do i = 2-mbc, mx+mbc
         do m=1,meqn
            bmasdq(m,i) = 0.d0
            bpasdq(m,i) = 0.d0
            enddo
         enddo
c
      return
      end

      subroutine setprob
      implicit double precision (a-h,o-z)
      character*25 fname
      common /cparam/ ubar,vbar
c
c     # Set the velocity for scalar advection
c     # These values are passed to the Riemann solvers rpn2.f and rpt2.f
c     # in a common block
c

c
      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)
                
      read(7,*) ubar
      read(7,*) vbar

      return
      end

c
c ---------------------------------------------------------
c
      subroutine restrt(nsteps,time,nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)
      logical   ee
 
 
      logical foundFile
      dimension intrtx(maxlv),intrtt(maxlv)
c
c :::::::::::::::::::::::::::: RESTRT ::::::::::::::::::::::::::::::::
c read back in the check point files written by subr. check.
c
c some input variables might have changed, and also the
c alloc array could have been written with a smaller size at checkpoint
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c     !! Now allow user-specified file name !!
c     rstfile  = 'restart.data'

      ! If checkpt_style < 0 then alternating between two checkpoint files.
      ! Set which one to use for the first checkpoint after this restart.
      ! Set check_a to .true. unless fort.chkaaaaa is the file being read.
      ! When alternating checkpoint files used, this keeps proper sequence going
      ! otherwise (checkpt_style > 0) check_a is not used elsewhere.
      check_a = .not. (rstfile == 'fort.chkaaaaa')

      write(6,*) 'Attempting to restart computation using '
      write(6,*) '  checkpoint file: ',trim(rstfile)
      inquire(file=trim(rstfile),exist=foundFile)
      if (.not. foundFile) then
        write(*,*)" Did not find checkpoint file!"
        stop
      endif
      open(rstunit,file=trim(rstfile),status='old',form='unformatted')
      rewind rstunit

      read(rstunit) lenmax,lendim,isize

c     # need to allocate for dynamic memory:
      call restrt_alloc(isize)

      read(rstunit) (alloc(i),i=1,lendim)
      read(rstunit) hxposs,possk,icheck
      read(rstunit) lfree,lenf
      read(rstunit) rnode,node,lstart,newstl,listsp,tl,
     1       ibuf,mstart,ndfree,ndfree_bnd,lfine,iorder,mxnold,
     2       intrtx,intrtt,iregsz,
     2       iregst,iregend,
     3       numgrids,kcheck1,nsteps,time,
     3       matlabu
      read(rstunit) avenumgrids, iregridcount,
     1              evol,rvol,rvoll,lentot,tmass0,cflmax

      close(rstunit) 

      write(outunit,100) nsteps,time
      write(6,100) nsteps,time
 100  format(/,' RESTARTING the calculation after ',i5,' steps',
     1        /,'  (time = ',e15.7,')')
c
c     error checking that refinement ratios have not changed
c     ### new feature: when using variable refinement in time
c     ### (varRefTime = T) the time ratios are allowed to be different
c     ###  (since they are ignored and calc. on the fly)
c     ### This is not checked for here, since the same amr1.f is now
c         used for geoclaw too, and varRefTime is only available in geoclaw.
c
      do i = 1, min(mxnold-1,mxnest-1)
        if ( (intratx(i) .ne. intrtx(i)) ) then
c    .       (kratio(i) .ne.  intrtt(i) .and. .not. varRefTime) ) then
        write(outunit,*) 
     .  " not allowed to change existing refinement ratios on Restart"
        write(outunit,*)" Old ratios:"
        write(*,*)      " Old ratios:"
        write(outunit,903)(intrtx(j),j=1,mxnold-1)
        write(*,903)      (intrtx(j),j=1,mxnold-1)
c       write(outunit,903)(intrtt(j),j=1,mxnold-1)
c       write(*,903)      (intrtt(j),j=1,mxnold-1)
 903    format(6i3)
        stop
       endif
      end do

c     if (varRefTime) then  ! reset intrat to previously saved ratios, not input ratios
      if (.true.) then  ! reset intrat to previously saved ratios, not input ratios
        do i = 1, mxnold-1
            kratio(i) = intrtt(i)
        end do
      endif

c
c adjust free list of storage in case size has changed.
c
      idif = memsize - isize
      if (idif .gt. 0) then
          lfree(lenf,1) = isize + 2
          call reclam(isize+1,idif)
      else if (idif .lt. 0) then
            write(outunit,900) isize, memsize
            write(*,900)       isize, memsize
 900        format(' size of alloc not allowed to shrink with ',/,
     .             ' restart old size ',i7,' current size  ',i7)
            stop
      endif
c
c adjust storage in case mxnest has changed - only allow it to increase,
c
       if (mxnest .eq. mxnold) go to 99

       if (mxnest .lt. mxnold) then
         if (lfine .lt. mxnest) then
             go to 99
         else
             write(outunit,901) mxnold, mxnest
             write(*,      901) mxnold, mxnest
901          format('  mxnest reduced on restart: ',/,
     &            '  old mxnest ',i4, ' new mxnest ',i4)
             write(outunit,*)" reclaiming finer levels from",
     .                mxnest+1," to ",mxnold
             do 95 lev = mxnest,mxnold
                mptr = lstart(lev)
                if (lev .gt. mxnest) lstart(lev) = 0   
 85             if (mptr .eq. 0) go to 95
                   if (lev .lt. mxnold) then
                    call reclam(node(cfluxptr,mptr), 5*listsp(lev))
                    node(cfluxptr,mptr) = 0
                   endif
                   nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
                   lenbc = 2
                   if (lev .gt. mxnest) then
                       call reclam
     .                  (node(ffluxptr,mptr),2*nvar*lenbc+naux*lenbc)
                       node(ffluxptr,mptr) = 0
                   endif
                   mitot = nx + 2*nghost
                   if (lev .gt. mxnest) then ! if level going away take away first storage
                      call reclam(node(store1,mptr),mitot*nvar)
                      node(store1,mptr) = 0
                      if (naux .gt. 0) then ! and aux arrays
                       call reclam(node(storeaux,mptr),mitot*naux)
                       node(storeaux,mptr) = 0
                      endif
                   endif
                   if (lev .ge. mxnest .and. lev .lt. mxnold) then  !reclam 2nd level storage too
                      call reclam(node(store2, mptr), mitot*nvar)
                      node(store2,mptr) = 0
                   endif
                mold   = mptr
                mptr   = node(levelptr,mptr)
                if (lev .gt. mxnest) call putnod(mold)
                go to 85
 95        end do
c              stop
c  reset lfine to new finest level
             do lev = mxnest,1,-1
                if (lstart(lev) .gt. 0) then
                  lfine = lev
                  write(*,*)" resetting finest level to ",lfine
                  go to 199
                endif 
             end do
         endif
       endif

c if mxnest has increased, add second storage loc to grids at previous mxnest 
        ee = .false.
        do 10 level = 1, mxnold
           if (icheck(level) .ge. kcheck) then
              ee = .true.
           endif
10      continue

           write(*,*)" increasing max num levels from ",mxnold,
     .                 ' to',mxnest
           write(outunit,*)" increasing max num levels from ",mxnold,
     .                 ' to',mxnest

        if (ee .and. flag_richardson) then
c           ## if Richardson used, will delay error est. 1 step til have old soln. vals
             write(*,*)" first Richardson error estimation step"
             write(*,*)" will estimate mostly spatial error "
             write(outunit,*)" first Richardson error estimation step"
             write(outunit,*)" will estimate mostly spatial error  "
         endif

c          #  add second storage location to previous mxnest level
         mptr = lstart(mxnold)
15       if (mptr .eq. 0) go to 25
            mitot = node(ndihi,mptr)-node(ndilo,mptr)+1+2*nghost
            node(store2,mptr) = igetsp(mitot*nvar)
            mptr = node(levelptr,mptr)
            go to 15
25       continue
c
c          # add new info. to spatial and counting arrays
 99        level = lfine + 1
           rrk = dble(kratio(lfine))
35         if (level .gt. mxnest) go to 45
             hxposs(level) = hxposs(level-1) / dble(intratx(level-1))
             possk (level) = possk (level-1) / rrk
             iregsz(level) = iregsz(level-1) * intratx(level-1)
             rrk           = kratio(level)
             level         = level + 1
             go to 35
45         continue
c
c
 199   continue

c
c     save array of grids to avoid copying each advanc or update step
c     lbase is 1 here, to start building from level 1
c     only for level 1 is listStart set outside of makeGridList
c     call with lbase 0 to make level 1
      listStart(1) = 1
      call makeGridList(0)
c
c     bndry list for faster ghost cell filling
      call initBndryList()
      do level = 1, lfine
         call makeBndryList(level)
      end do
c
      return
      end

c
c ---------------------------------------------------------
c
      subroutine check(nsteps,time,nvar,naux)
c
c :::::::::::::::::::::: CHECK ::::::::::::::::::::::::::::::::;
c   check point routine - can only call at end of coarse grid cycle
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module
      use bouss_module
c     !use gauges_module, only: OUTGAUGEUNIT, num_gauges
      use gauges_module, only: num_gauges, gauges
      use gauges_module, only: print_gauges_and_reset_nextLoc
      use fgmax_module, only: FG_fgrids, FG_num_fgrids, fgrid
      use topo_module, only: aux_finalized

      implicit double precision (a-h,o-z)
      integer tchkunit, ifg, ii
      parameter (tchkunit = 13)
      character  chkname*13
      character  tchkname*13
      type(fgrid), pointer :: fg

      write(6,601) time,nsteps
 601  format('Creating checkpoint file at t = ',e16.9,'  nsteps = ',i5)
c
      if (checkpt_style < 0) then

c         #  Alternate between two sets of files, overwriting the oldest
c         #  one, so that files do not accumulate with frequent checkpoints.
c
c         # Note that logical check_a is stored in amr_module, initialized
c         # in amr2 and perhaps reset properly in restrt.

          if (check_a) then
              chkname = 'fort.chkaaaaa'
              tchkname = 'fort.tckaaaaa'
            else
              chkname = 'fort.chkbbbbb'
              tchkname = 'fort.tckbbbbb'
            endif
          check_a = .not. check_a   ! to use other file next time

      else

c         # make a new checkpoint file for this time
c         ###  make the file name showing the time step
c
          chkname = 'fort.chkxxxxx'
          tchkname = 'fort.tckxxxxx'
          nstp = nsteps
          do 20 ipos = 13, 9, -1
             idigit = mod(nstp,10)
             chkname(ipos:ipos) = char(ichar('0') + idigit)
             tchkname(ipos:ipos) = char(ichar('0') + idigit)
             nstp = nstp / 10
 20       continue
      endif

      open(unit=tchkunit,file=tchkname,status='unknown',
     .     form='formatted')
      open(unit=chkunit,file=chkname,status='unknown',
     .     form='unformatted')
c
c     ###  dump the data
c
      !write(chkunit) lenmax,lendim,memsize
      !new version has variable node size arrays, so need to output
      ! current size to read back in on restart
      write(chkunit) lenmax,lendim,memsize,maxgr
      write(chkunit) (alloc(i),i=1,lendim)
      write(chkunit) hxposs,hyposs,possk,icheck
      write(chkunit) lfree,lenf
      write(chkunit) rnode,node,lstart,newstl,listspStart,listsp,tol,
     1          ibuff,mstart,ndfree,ndfree_bnd,lfine,iorder,mxnest,
     2          intratx,intraty,kratio,iregsz,jregsz,
     2          iregst,jregst,iregend,jregend, 
     3          numgrids,kcheck,nsteps,
     3          time,matlabu,aux_finalized,
     4          minLevelBouss,maxLevelBouss,boussMinDepth,
     5          startBoussTime
      write(chkunit) avenumgrids, iregridcount,
     1               evol,rvol,rvoll,lentot,tmass0,cflmax,
     2               tvoll,tvollCPU,timeTick,timeTickCPU,
     3               timeStepgrid,timeStepgridCPU,
     3               timeLinSolve,timeLinSolveCPU,
     3               timePrepBuild,timePrepBuildCPU,
     4               timeBound,timeBoundCPU,
     5               timeRegridding,timeRegriddingCPU,
     6               timeValout,timeValoutCPU

c
c     ### new capability to dump the fgmax data, if exists
c     ### fortran requires specifying each component, if
c     ### they contain allocatable arrays
      do ifg = 1, FG_num_fgrids
        fg => FG_fgrids(ifg)
          write(chkunit) fg%levelmax
          write(chkunit) fg%auxdone(1:mxnest)
          write(chkunit) fg%x,fg%y,fg%valuemax,fg%tmax,
     &          fg%arrival_time,fg%aux,fg%t_last_updated
      end do
c

c     # flush open running output files fort.amr, fort.gauge, fort.debug
c     # so if code dies it will at least have output up to this checkpoint time

      flush(outunit)        ! defined in amr_module.f90
      flush(dbugunit)       ! defined in amr_module.f90

c     now that gauge data is batched, need to write the last batch to file
c    ! flush(OUTGAUGEUNIT)   ! defined in gauges_module.f90 


      write(chkunit) num_gauges
      ! write out last recorded x,y position,
      ! needed on restart only for lagrangian gauges, but write them all
      do ii = 1, num_gauges
         write(chkunit) gauges(ii)%gauge_num,
     &                      gauges(ii)%t_last_written,
     &                      gauges(ii)%x_last_written,
     &                      gauges(ii)%y_last_written
      end do

      close(chkunit)

c     # write the time stamp file last so it's not updated until data is
c     # all dumped, in case of crash mid-dump.
      write(tchkunit,*) 'Checkpoint file at time t = ',time
      write(tchkunit,*) 'alloc size memsize = ',memsize
      write(tchkunit,*) 'Number of steps taken = ',nsteps
      close(tchkunit)
c
      return
      end

!> Compute signatures of a rectangle
!! Signature is defined as number of flagged cells in each row/column.
!! Also return first and last nonzero row/column (in **ilo**, **ihi**, 
!! **jlo**, **jhi**), so don't have to waste time over entire region.
!!
!! \param[out] ilo first nonzero row
!! \param[out] ihi last nonzero row
!! \param[out] jlo first nonzero column
!! \param[out] jhi last nonzero column
!! \param[out] iscr horizontal signature, as a function of i
!! \param[out] jscr vertical signature, as a function of j
!!
c
c --------------------------------------------------------------------
c
       subroutine signs(badpts,npts,iscr,jscr,idim,jdim,ist,iend,
     &                  ilo,ihi,jlo,jhi)
c
       implicit double precision (a-h,o-z)
       dimension badpts(2,npts)
       ! TODO: can iscr use an array, say ihi-ilo?
       dimension iscr(idim), jscr(jdim)
c
c
       ilo= 1
       ihi= idim
       jlo= 1
       jhi= jdim
       do 10 i = 1, idim
          iscr(i) = 0
 10    continue
       do 15 j = 1, jdim
          jscr(j) = 0
 15    continue
c
c count all flagged points in a given row/column in one pass through
c the points, i.e. a bin count
c
       do 20 ipt = ist, iend
          iloc  =  badpts(1,ipt)+1.1
          jloc  =  badpts(2,ipt)+1.1
          iscr(iloc) = iscr(iloc)+1
          jscr(jloc) = jscr(jloc)+1
 20    continue
c
       do 30 ipt = 1, idim
         if (iscr(ipt) .ne. 0) then
            ilo = ipt
            go to 40
         endif
 30    continue
 40    do 50 ipt = 1, idim
          if (iscr(idim+1-ipt) .ne. 0) then
             ihi = idim+1-ipt
             go to 60
          endif
 50    continue

 60    do 70 ipt = 1, jdim
          if (jscr(ipt) .ne. 0) then
             jlo = ipt
             go to 80
          endif
 70    continue
 80    do 90 ipt = 1, jdim
          if (jscr(jdim+1-ipt) .ne. 0) then
             jhi = jdim+1-ipt
             go to 99
          endif
 90    continue

 99    return
       end

!! Output the results for a general system of conservation laws
!! in 2 dimensions
!!
!! Write the results to the file fort.q<iframe>
!! Use format required by matlab script  plotclaw2.m or Python tools
!!
!! set outaux = .true. to also output the aux arrays to fort.a<iframe>
subroutine valout(level_begin, level_end, time, num_eqn, num_aux)

    use amr_module, only: alloc, t0, output_aux_onlyonce, output_aux_components
    use amr_module, only: frame => matlabu, num_ghost => nghost, lstart
    use amr_module, only: hxposs, hyposs, output_format, store1, storeaux
    use amr_module, only: node, rnode, ndilo, ndihi, ndjlo, ndjhi
    use amr_module, only: cornxlo, cornylo, levelptr, mxnest
    use amr_module, only: timeValout, timeValoutCPU, tvoll, tvollCPU, rvoll
    use amr_module, only: timeTick, tick_clock_start, t0, timeTickCPU

#ifdef HDF5
    use hdf5
#endif

    implicit none

    ! Input
    integer, intent(in) :: level_begin, level_end, num_eqn, num_aux
    real(kind=8), intent(in) :: time

    ! Locals
    logical :: timing_file_exists
    integer, parameter :: out_unit = 50
    integer :: i, j, m, level, output_aux_num, num_stop, digit
    integer :: grid_ptr, num_cells(2), num_grids, q_loc, aux_loc
    real(kind=8) :: lower_corner(2), delta(2)
    logical :: out_aux
    character(len=11) :: file_name(5)
    character(len=8) :: file_format
    real(kind=4), allocatable :: q4(:), aux4(:)
    integer :: lenaux4

#ifdef HDF5
    ! HDF writing
    integer :: hdf_error
    integer(hid_t) :: hdf_file, data_space, data_set
    integer(hsize_t) :: dims(2)
#endif

    ! Timing
    integer(kind=8) :: clock_start, clock_finish, clock_rate
    integer(kind=8) ::    tick_clock_finish, tick_clock_rate, timeTick_int
    real(kind=8) :: cpu_start, cpu_finish, t_CPU_overall, timeTick_overall
    character(len=512) :: timing_line, timing_substr
    character(len=*), parameter :: timing_file_name = "timing.csv"

    character(len=*), parameter :: header_format_2d =                          &
                                    "(i6,'                 grid_number',/," // &
                                     "i6,'                 AMR_level',/,"   // &
                                     "i6,'                 mx',/,"          // &
                                     "i6,'                 my',/"           // &
                                     "e26.16,'    xlow', /, "               // &
                                     "e26.16,'    ylow', /,"                // &
                                     "e26.16,'    dx', /,"                  // &
                                     "e26.16,'    dy',/)"
    character(len=*), parameter :: t_file_format = "(e18.8,'    time', /,"  // &
                                           "i6,'                 meqn'/,"   // &
                                           "i6,'                 ngrids'/," // &
                                           "i6,'                 naux'/,"   // &
                                           "i6,'                 ndim'/,"   // &
                                           "i6,'                 nghost'/," // &
                                           "a10,'             format'/,/)"
                                           
    character(len=*), parameter :: console_format = &
             "('AMRCLAW: Frame ',i4,' output files done at time t = ', d13.6,/)"

    ! Output timing
    call system_clock(clock_start,clock_rate)
    call cpu_time(cpu_start)

    ! Count how many aux components requested
    output_aux_num = 0
    do i=1, num_aux
        output_aux_num = output_aux_num + output_aux_components(i)
    end do

    ! Note:  Currently outputs all aux components if any are requested
    out_aux = ((output_aux_num > 0) .and.               &
              ((.not. output_aux_onlyonce) .or. (abs(time - t0) < 1d-90)))
                
    ! Construct file names
    file_name(1) = 'fort.qxxxx'
    file_name(2) = 'fort.txxxx'
    file_name(3) = 'fort.axxxx'
    file_name(4) = 'fort.bxxxx'
    num_stop = frame
    do i = 10, 7, -1
        digit = mod(num_stop, 10)
        do j = 1, 4
            file_name(j)(i:i) = char(ichar('0') + digit)
        end do
        num_stop = num_stop / 10
    end do
    ! Slightly modified for HDF file output
    file_name(5) = 'clawxxxx.h5'
    num_stop = frame
    do i = 8, 5, -1
        digit = mod(num_stop, 10)
        file_name(5)(i:i) = char(ichar('0') + digit)
        num_stop = num_stop / 10
    end do

    ! ==========================================================================
    ! Write out fort.q file (and fort.bXXXX and clawxxxx.h5 files if necessary)
    ! Here we let fort.q be out_unit and the the other two be out_unit + 1
    open(unit=out_unit, file=file_name(1), status='unknown', form='formatted')
    if (output_format == 2 .or. output_format == 3) then
        open(unit=out_unit + 1, file=file_name(4), status="unknown",    &
             access='stream')
    else if (output_format == 4) then
#ifdef HDF5
        ! Note that we will use this file for both q and aux data
        call h5create_f(file_name(5), H5F_ACC_TRUNC_F, hdf_file, hdf_error)

        ! Create group for q
        call h5gcreate_f(hdf_file, "/q", q_group, hdf_error)
#endif
    end if
    num_grids = 0

    ! Loop over levels
    do level = level_begin, level_end
        grid_ptr = lstart(level)
        delta = [hxposs(level), hyposs(level)]

        ! Loop over grids on each level
        do while (grid_ptr /= 0)
            ! Extract grid data
            num_grids = num_grids + 1
            num_cells(1) = node(ndihi, grid_ptr) - node(ndilo, grid_ptr) + 1
            num_cells(2) = node(ndjhi, grid_ptr) - node(ndjlo, grid_ptr) + 1
            q_loc = node(store1, grid_ptr)
            lower_corner = [rnode(cornxlo, grid_ptr), rnode(cornylo, grid_ptr)]

            ! Write out header data                 
            
            write(out_unit, header_format_2d) grid_ptr, level,             &
                                              num_cells(1),                &
                                              num_cells(2),                &
                                              lower_corner(1),             &
                                              lower_corner(2),             &
                                              delta(1), delta(2)

            ! Output grids
            
            ! Round off if nearly zero 
            ! (Do this for all output_format's)
            forall (m = 1:num_eqn,                              &
                    i=num_ghost + 1:num_cells(1) + num_ghost,   &
                    j=num_ghost + 1:num_cells(2) + num_ghost,   &
                    abs(alloc(iadd(m, i, j))) < 1d-90)

                alloc(iadd(m, i, j)) = 0.d0
            end forall

            if (output_format == 1) then
                    ! ascii output
                    
                    do j = num_ghost + 1, num_cells(2) + num_ghost
                        do i = num_ghost + 1, num_cells(1) + num_ghost
                            write(out_unit, "(50e26.16)")                      &
                                            (alloc(iadd(m, i, j)), m=1, num_eqn)
                        end do
                        write(out_unit, *) ' '
                    end do

            else if (output_format==2 .or. output_format==3) then
                ! binary32 or binary64
                                
                ! Note: We are writing out ghost cell data also,
                ! so need to update this
                call bound(time,num_eqn,num_ghost,alloc(q_loc),     &
                             num_cells(1) + 2*num_ghost,            &
                             num_cells(2) + 2*num_ghost,            &
                             grid_ptr,alloc(aux_loc),num_aux)

                i = (iadd(num_eqn, num_cells(1) + 2 * num_ghost, &
                                   num_cells(2) + 2 * num_ghost))
                                   
                if (output_format == 2) then
                    ! binary32 (shorten to 4-byte)
                    allocate(q4(num_eqn * (num_cells(1) + 2 * num_ghost)   &
                                        * (num_cells(2) + 2 * num_ghost)))
                    q4 = real(alloc(iadd(1, 1, 1):i), kind=4)
                    write(out_unit + 1) q4
                    deallocate(q4)

                else if (output_format==3) then
                    ! binary64 (full 8-byte)
                    write(out_unit + 1) alloc(iadd(1, 1, 1):i)
                endif
                
                
            else if (output_format == 4) then
#ifdef HDF5
                ! Create data space - handles dimensions of the corresponding 
                ! data set - annoyingling need to stick grid size into other
                ! data type
                dims = (/ num_eqn, num_cells(1) + 2 * num_ghost,               &
                                   num_cells(2) + 2 * num_ghost /)
                call h5screate_simple_f(2, dims, data_space, hdf_error)

                ! Create new dataset for this grid
                call h5dcreate_f(hdf_file, data_set, H5T_IEEE_F64LE,           &
                                 data_space, data_set, hdf_error)

                ! Write q into file
                i = (iadd(num_eqn, num_cells(1) + 2 * num_ghost,               &
                                   num_cells(2) + 2 * num_ghost))
                call h5dwrite_f(data_set, H5T_NATIVE_DOUBLE,                   &
                                alloc(iadd(1, 1, 1):i), hdf_error)
                call h5dclose_f(data_set, hdf_error)
                call h5sclose_f(data_space, hdf_error)
#endif
            else
                print *, "Unsupported output format", output_format,"."
                stop 
            endif

            grid_ptr = node(levelptr, grid_ptr)
        end do
    end do

    close(out_unit)
    
    if (output_format==2 .or. output_format==3) then
        close(unit=out_unit + 1)
    end if

#ifdef HDF5
    if (output_format == 4) then
        call h5gclose_f(q_group, hdf_error)
    end if
#endif

    ! ==========================================================================
    ! Write out fort.a file
    if (out_aux) then
        if (output_format == 1) then
            open(unit=out_unit, file=file_name(3), status='unknown',        &
                 form='formatted')
        else if (output_format==2 .or. output_format==3) then
            open(unit=out_unit, file=file_name(3), status='unknown',        &
                 access='stream')
        else if (output_format == 4) then
#ifdef HDF5
        ! Create group for aux
        call h5gcreate_f(hdf_file, "/aux", aux_group, hdf_error)
#endif            
        end if

        do level = level_begin, level_end
            grid_ptr = lstart(level)
            delta = [hxposs(level), hyposs(level)]

            ! Loop over grids on each level
            do while (grid_ptr /= 0)
                ! Extract grid data
                num_cells(1) = node(ndihi, grid_ptr) - node(ndilo, grid_ptr) + 1
                num_cells(2) = node(ndjhi, grid_ptr) - node(ndjlo, grid_ptr) + 1
                aux_loc = node(storeaux, grid_ptr)
                lower_corner = [rnode(cornxlo, grid_ptr),           &
                                rnode(cornylo, grid_ptr)]

                ! Output grids
                select case(output_format)
                    ! ASCII output
                    case(1)

                        ! We only output header info for aux data if writing 
                        ! ASCII data
                        write(out_unit, header_format_2d) grid_ptr, level,    &
                                                          num_cells(1),       &
                                                          num_cells(2),       &
                                                          lower_corner(1),    &
                                                          lower_corner(2),    &
                                                          delta(1), delta(2)

                        ! Round off if nearly zero
                        forall (m = 1:num_aux,                              &
                                i=num_ghost + 1:num_cells(1) + num_ghost,   &
                                j=num_ghost + 1:num_cells(2) + num_ghost,   &
                                abs(alloc(iaddaux(m, i, j))) < 1d-90)

                            alloc(iaddaux(m, i, j)) = 0.d0
                        end forall

                        do j = num_ghost + 1, num_cells(2) + num_ghost
                            do i = num_ghost + 1, num_cells(1) + num_ghost
                                write(out_unit, "(50e26.16)")                   &
                                         (alloc(iaddaux(m, i, j)), m=1, num_aux)
                            end do
                            write(out_unit, *) ' '
                        end do
                        
                    case(2)
                        ! binary32
                        ! Note: We are writing out ghost cell data also
                        i = (iaddaux(num_aux, num_cells(1) + 2 * num_ghost, &
                                              num_cells(2) + 2 * num_ghost))
                        lenaux4 = i - iaddaux(1, 1, 1) + 1
                        allocate(aux4(lenaux4))
                        aux4 = real(alloc(iaddaux(1, 1, 1):i), kind=4)
                        write(out_unit) aux4
                        deallocate(aux4)
                        
                    case(3)
                        ! binary64
                        ! Note: We are writing out ghost cell data also
                        i = (iaddaux(num_aux, num_cells(1) + 2 * num_ghost, &
                                              num_cells(2) + 2 * num_ghost))
                        write(out_unit) alloc(iaddaux(1, 1, 1):i)
                        

                    ! HDF5 output
                    case(4)
#ifdef HDF5
                ! Create data space - handles dimensions of the corresponding 
                ! data set - annoyingling need to stick grid size into other
                ! data type
                dims = (/ num_aux, num_cells(1) + 2 * num_ghost,               &
                                   num_cells(2) + 2 * num_ghost /)
                call h5screate_simple_f(2, dims, data_space, hdf_error)

                ! Create new dataset for this grid
                call h5dcreate_f(hdf_file, data_set, H5T_IEEE_F64LE,           &
                                 data_space, data_set, hdf_error)

                call h5dcreate_f(hdf_file, data_set, H5T_IEEE_F64LE,           &
                                 data_space, data_set, hdf_error)

                ! Write q into file
                i = (iadd_aux(num_aux, num_cells(1) + 2 * num_ghost,           &
                                       num_cells(2) + 2 * num_ghost))
                call h5dwrite_f(data_set, H5T_NATIVE_DOUBLE,                   &
                                alloc(iadd_aux(1, 1, 1):i), hdf_error)
                call h5dclose_f(data_set, hdf_error)
                call h5sclose_f(data_space, hdf_error)
#endif
                    case default
                        print *, "Unsupported output format", output_format,"."
                        stop 

                end select
                grid_ptr = node(levelptr, grid_ptr)
            end do
        end do
        
        if ((output_format == 1) .or. (output_format == 2) .or. &
            (output_format == 3)) then
            close(out_unit)
        end if
        
    end if

#ifdef HDF5
    if (out_aux) then
        call h5gclose_f(aux_group, hdf_error)
    end if
    call h5fclose_f(hdf_file, hdf_error)
#endif


    ! ==========================================================================
    ! Write fort.t file
    open(unit=out_unit, file=file_name(2), status='unknown', form='formatted')

    ! Note:  We need to print out num_ghost too in order to strip ghost cells
    !        from q array when reading in pyclaw.io.binary

    
    if (output_format == 1) then
        file_format = 'ascii'
    else if (output_format == 2) then
        file_format = 'binary32'
    else if (output_format == 3) then
        file_format = 'binary64'
    else if (output_format == 4) then
        file_format = 'hdf'
    endif
    
    write(out_unit, t_file_format) time, num_eqn, num_grids, num_aux, 2, &
                                   num_ghost, file_format
    close(out_unit)

    ! ==========================================================================
    ! Write out timing stats
    open(unit=out_unit, file=timing_file_name, form='formatted',         &
             status='unknown', action='write', position='append')
             !status='old', action='write', position='append')
    
    timing_line = "(e16.6, ', ', e16.6, ', ', e16.6,"
    do level=1, mxnest
        timing_substr = "', ', e16.6, ', ', e16.6, ', ', e16.6"
        timing_line = trim(timing_line) // timing_substr
    end do
    timing_line = trim(timing_line) // ")"

    if (abs(time - t0) < 1d-15) then
        t_CPU_overall = 0.d0
        timeTick_overall = 0.d0
    else
        call cpu_time(t_CPU_overall)
        ! if this is a restart, need to adjust add in time from previous run:
        t_CPU_overall = t_CPU_overall + timeTickCPU

        call system_clock(tick_clock_finish,tick_clock_rate)
        timeTick_int = timeTick + tick_clock_finish - tick_clock_start
        timeTick_overall = real(timeTick_int, kind=8)/real(clock_rate,kind=8)
    endif

    write(out_unit, timing_line) time, timeTick_overall, t_CPU_overall, &
        (real(tvoll(i), kind=8) / real(clock_rate, kind=8), &
         tvollCPU(i), rvoll(i), i=1,mxnest)
    
    close(out_unit)

    ! ==========================================================================
    ! Print output info
    print console_format, frame, time

    ! Increment frame counter
    frame = frame + 1

    ! Ouptut timing
    call system_clock(clock_finish,clock_rate)
    call cpu_time(cpu_finish)
    timeValout = timeValout + clock_finish - clock_start
    timeValoutCPU = timeValoutCPU + cpu_finish - cpu_start

contains

    ! Index into q array
    pure integer function iadd(m, i, j)
        implicit none
        integer, intent(in) :: m, i, j
        iadd = q_loc + m - 1 + num_eqn * ((j - 1) * (num_cells(1) + 2 * num_ghost) + i - 1)
    end function iadd

    ! Index into aux array
    pure integer function iaddaux(m, i, j)
        implicit none
        integer, intent(in) :: m, i, j
        iaddaux = aux_loc + m - 1 + num_aux * (i - 1) + num_aux * (num_cells(1) + 2 * num_ghost) * (j - 1)
    end function iaddaux

end subroutine valout

c
!> Smart bisect rectangles until cutoff reached for each.
!! replaced old bisection routine that cut all grids in half.
!! now look for good place to do the cut, based on holes or signatures.
!!
!! Reference: Berger, M.J., Rigoutsos, I., 1991. An Algorithm for Point Clustering and Grid Generation. IEEE Trans. Syst. Man Cybern. 21, 1278–1286
!!
!! \param[in,out] badpts x,y centered coordinate of all flagged cells.
!! At output, cells for each cluster are stored consecutively in this
!! array.
!! \param[in] npts number of flagged cells
!! \param[in] cutoff required minimum efficiency of each cluster grid
!! \param[out] numptc number of cells in each cluster (grid)
!! \param[out] nclust number of clusters
!! \param[in] lbase base level of current refinement
!! \param[out] intcorn Some information of each generated cluster (grid)
!! \param[in] idim region size (in number of cells) for current AMR level in *i* direction
!! \param[out] idim region size (in number of cells) for current AMR level in *i* direction
!!
!!
!!
c
c ---------------------------------------------------------
c
      subroutine smartbis(badpts,npts,cutoff,numptc,nclust,
     1                    lbase,intcorn,idim,jdim)
c     1                    lbase,intcorn,iscr,jscr,idim,jdim)
c
c  iscr, jscr now stackbased, no need for use of alloc
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension     badpts(2,npts),intcorn(nsize,maxcl)
c
c  iscr, jscr now stackbased, no need for use of alloc
      dimension     iscr(idim), jscr(jdim)
      integer       nclust, numptc(maxcl)
      parameter     (usemin=.4)
c
c :::::::::::::::::::::::::::: SMARTBIS :::::::::::::::::::::::::;
c smart bisect rectangles until cutoff reached for each.
c replaced old bisection routine that cut all grids in half.
c now look for good place to do the cut, based on holes or signatures.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
c     ## initially all points in 1 cluster
      nclust      = 1
      numptc(1)   = npts

      if (gprint) write(outunit,100) nclust
 100  format(' starting smart bisection with ',i5,' clusters')
c
      icl         = 1 ! cluster iterator 
      ist         = 1 ! pt iterator in badpts
      iend        = numptc(icl) ! pt iterator in badpts
c
 10   call moment(intcorn(1,icl),badpts(1,ist),numptc(icl),usenew)
      if (gprint) write(outunit,101) icl,numptc(icl),usenew
 101  format('   testing cluster ',i8,' with ',i9,' pts. use ',e12.4)
c
      if (usenew .lt. cutoff) go to 20
c
c  this cluster ok - on to next
c
      if (.not. gprint) go to 15
         write(outunit,102) icl,numptc(icl),usenew
 102     format('     accepting smart bisected cluster',i4,' with ',i5,
     1          ' pts. use = ',e10.3)
 15   icl   = icl + 1
      if (icl .gt. nclust) go to 200
      ist   = iend + 1
      iend  = ist + numptc(icl) - 1
      go to 10
c
c  smart bisect rectangle (and its cluster) in best location
c
 20   if (nclust .lt. maxcl) go to 25
          write(outunit,900) maxcl
          write(*      ,900) maxcl
 900      format('  too many clusters:  > ',i5)
          stop
 25   continue
c
c smart bisection computes signatures, finds best cut and splits there
c
      call signs(badpts,npts,iscr,jscr,idim,jdim,
     &           ist,iend,ilo,ihi,jlo,jhi)
      call findcut(icl,iscr,jscr,idim,jdim,index,iside,
     &             ilo,ihi,jlo,jhi)
      if (index .eq. 0) then

c         if (usenew .gt. usemin) then
c           icl = icl + 1
c           if (icl .gt. nclust) go to 200
c           ist = iend + 1
c           iend = ist + numptc(icl) - 1
c           go to 10
c         else
c c         bisect in long direction
c           if (ihi-ilo .gt. jhi-jlo) then
c              iside = horizontal
c              index = (ilo + ihi)/2
c           else
c              iside = vertical
c              index = (jlo + jhi)/2
c           endif
c          endif

c 2/28/02 : 3d version uses this branch only;  no 'if' statement.
         icl = icl + 1
         if (icl .gt. nclust) go to 200
         ist = iend + 1
         iend = ist + numptc(icl) - 1
         go to 10
      endif
c
      if (iside .eq. vertical) then
c        fmid = (index-.5)*hy
         fmid = (index-.5)
         idir = 2
      else
         fmid = (index-.5)
         idir = 1
      endif
c
      itop = ist - 1
      ibot = iend + 1
      i    = ist
 50   if (badpts(idir,i) .lt. fmid) go to 60
c
c  point in top half. let it stay, increment counter
c
        itop = itop + 1
        if (itop+1 .ge. ibot) go to 80
             i = i + 1
             go to 50
c
c  point in bottom half. switch with a bottom point that's not yet
c  checked, and increment bot. pointer
c
 60    ibot           = ibot - 1
       temp           = badpts(1,ibot)
       badpts(1,ibot) = badpts(1,i)
       badpts(1,i)    = temp
       temp           = badpts(2,ibot)
       badpts(2,ibot) = badpts(2,i)
       badpts(2,i)    = temp
       if (itop+1 .lt. ibot) go to 50
c
c done smartbisecting icl'th clusters. adjust counts, repeat bisect stage .
c
 80   numptc(icl) = itop - ist + 1
      ibump       = icl + 1
c
c  bump down remaining clusters to make room for the new half of one.
c
      if (ibump .gt. nclust) go to 120
      do 90 ico         = ibump, nclust
       nmove             = nclust - ico + ibump
       numptc(nmove + 1) = numptc(nmove)
 90   continue

 120  numptc(ibump)     = iend - ibot + 1
      nclust            = nclust + 1
      iend              = itop
c
c     other half of the cluster has been inserted into cluster list.
c     icl remains the same - need to redo it.
      go to 10
c
c  done: there are nclust clusters.
c
 200  continue
c
      return
      end

c
!> This routine is called because regridding just changed the fine grids.
!! It modifies boundary list of each level **level** grid 
!! such that each grid knows along its boundary, what fine cells 
!! its cell borders and where to get saved flux for conservation fix-up
!! 
!! \param[in] level boudnary lists of grids on this level get updated
!! \param[in] nvar number of equations for the system
c ----------------------------------------------------------
c
      subroutine prepc(level,nvar)
c
      use amr_module
      implicit double precision (a-h,o-z)

c
c :::::::::::::::::::: PREPC ::::::::::::::::::::::::::::::::::::::
c
c this routine called because regridding just changed the fine grids.
c modify coarse grid boundary lists to store fluxes in appropriate
c fine grids lists.
c assume new fine grids have node(cfluxptr) initialized to null
c
c  first compute max. possible number of list cells. allocate
c  initially so that one pass through is enough.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      ! initialize to 0 in case no fine grids
      listspStart(level) = 0
      maxsp  = 0
      listsp(level) = maxsp
      mkid   = lstart(level+1)
 10   if (mkid .eq. 0) go to 20
         ikeep  = (node(ndihi,mkid)-node(ndilo,mkid)+1)/intratx(level)
         jkeep  = (node(ndjhi,mkid)-node(ndjlo,mkid)+1)/intraty(level)
         maxsp  = maxsp + 2*(ikeep+jkeep)
      mkid = node(levelptr,mkid)
      go to 10
 20   continue
 
      !!! maxsp is enough storage for every coarse grid to have an adjustment by
      !!! a corresponding fine grid flux sum. But not all will.
      if (maxsp .eq. 0) go to 99  ! no fine grids, so no space needed. 
c
      !space istarts here, will be shared by all coarse grids
      ! will need to save to be able to reclam storage later
      ! each grid only stores its own starting cfluxptr
      ! add space for each coarse grid to make end of list
      maxsp = maxsp + numgrids(level)
      itotspace = igetsp(5*maxsp) 
      listspStart(level) = itotspace
      listsp(level) = maxsp
      do 35 i = 1, 5*maxsp
         alloc(itotspace+i-1) = 0.d0
 35   continue
c
      hxpar   = hxposs(level)
      hypar   = hyposs(level)
      hxkid   = hxposs(level+1)
      hykid   = hyposs(level+1)
      imax    = iregsz(level) - 1
      jmax    = jregsz(level) - 1

      mpar = lstart(level)
      ispotSum  = 0
 30   if (mpar .eq. 0) go to 99
c
       ilo     = node(ndilo,mpar)
       jlo     = node(ndjlo,mpar)
       ihi     = node(ndihi,mpar)
       jhi     = node(ndjhi,mpar)
       locbc   = itotspace + 5*ispotSum    ! grid mpar start stheir cflux storage here
       ispot   = 0   ! then each grid starts counting from 0, only cflux is advanced.
c      #  initialize list to 0 (0 terminator indicates end of bc list)
       node(cfluxptr,mpar) = locbc
c
       mkid = lstart(level+1)
 40    if (mkid .eq. 0) go to 60

          iclo = node(ndilo,mkid)/intratx(level)
          jclo = node(ndjlo,mkid)/intraty(level)
          ichi = node(ndihi,mkid)/intratx(level)
          jchi = node(ndjhi,mkid)/intraty(level)

          iplo = max(ilo,iclo)
          jplo = max(jlo,jclo)
          iphi = min(ihi,ichi)
          jphi = min(jhi,jchi)

c   regular intersections (will check in setuse that no duplication)
c   this first call is only interior interfaces. 

          if (iplo .le. iphi+1 .and. jplo .le. jphi+1) then
               kflag = 1 ! interior stuff, no mappings
                call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,iclo,ichi,jclo,jchi,kflag)
          endif

c   for fine grids touching periodic boundary on right
          if  (xperdom .and. ilo .eq. 0 .and. ichi .eq. imax) then
              kflag = 1 ! periodic in x
              call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,iclo-iregsz(level),ichi-iregsz(level),
     3          jclo,jchi,kflag)
           endif

c   for fine grids touching periodic boundary on left
          if  (xperdom .and. iclo .eq. 0 .and. ihi .eq. imax) then
              kflag = 1
              call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,iclo+iregsz(level),ichi+iregsz(level),
     3          jclo,jchi,kflag)
          endif

c   for fine grids touching periodic boundary on top
          if  (yperdom .and. jlo .eq. 0 .and. jchi .eq. jmax) then
                kflag = 1
                call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,iclo,ichi,
     3          jclo-jregsz(level),jchi-jregsz(level),kflag)
          endif

c   for fine grids touching periodic boundary on bottom
          if  (yperdom .and. jclo .eq. 0 .and. jhi .eq. jmax)  then
              kflag = 1
              call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,jlo,jhi,iclo,ichi,
     3          jclo+jregsz(level),jchi+jregsz(level),kflag)
          endif

c   for fine grids touching boundary on top in spherically mapped case
c   and coarse grid touches top too. see if (mapped) x extent overlap.
          if  (spheredom .and. jhi .eq. jmax .and. jchi .eq. jmax) then
               kflag = 2
c              write(dbugunit,*)" for coarse grid ",mpar
               iwrap2 = iregsz(level) - iclo - 1  !higher mapped index
               iwrap1 = iregsz(level) - ichi - 1  !lower mapped index
               if (max(ilo,iwrap1) .le. min(ihi,iwrap2)) then
                  call setuse(alloc(locbc),maxsp,ispot,mkid,
     1                        ilo,ihi,jlo,jhi,iclo,ichi,
     2                        jclo,jchi,kflag)
               endif
          endif

c   fine grids touching boundary on bottom for spherically mapped case
c   coarse grid touches bottom too. see if (mapped) x extents overlap
          if  (spheredom .and. jclo .eq. 0 .and. jlo .eq. 0) then
               kflag = 3
               iwrap2 = iregsz(level) - iclo - 1  !higher mapped index
               iwrap1 = iregsz(level) - ichi - 1  !lower mapped index
               if (max(ilo,iwrap1) .le. min(ihi,iwrap2)) then
                  call setuse(alloc(locbc),maxsp,ispot,mkid,
     1                        ilo,ihi,jlo,jhi,iclo,ichi,
     2                        jclo,jchi,kflag)
               endif
          endif

 50     mkid = node(levelptr,mkid)
        go to 40
c
c  done with subgrid cycle. if no cells would need fixing, all done
c  else cycle through again to set up list with info. for bc processing
c
 60     continue
c
c  for now, leave unused space allocated to the grid. alternative is to
c  return (maxsp-ispot) amt starting at loc node(cfluxptr,mpar)+ispot.
c
       !before leaving this grid, add signal that end of cflux
       ! signal is 0 in 1st position.  Already initialized to 0
       ! so just increment ispot
       ispot = ispot + 1
       ispotSum  = ispotSum  + ispot
       mpar = node(levelptr,mpar)
       go to 30
c
 99   continue

       ! DOUBLE check dimensions, even tho is after the fact
       ! and array already filled
       if (ispotSum .gt. maxsp) then
         write(*,*) "ERROR:  Should not happen that use more cflux",
     &              "space than ",maxsp
         write(outunit,*) "ERROR:  Should not happen that use more ",
     &              "cflux space than ",maxsp
         stop
       endif

       return
       end

! ============================================================================
!  Program:     AMRClaw
!  File:        resize_storage.f90
!  Created:     2009-01-21
!  Author:      Kyle Mandli and Marsha Berger
! ============================================================================
!  Description:  Resize the alloc array for AMR storage
! ============================================================================


! NOTE:  Older f90 compilers (e.g. gfortran prior to 4.2?)
! may not implement move_alloc.  If this fails, you may need to use
! resize_storage_static.f90 instead of this routine and set the
! allocation large enough in init_alloc.f90 to avoid running out of space.


subroutine resize_storage(new_size,status)
    
    use amr_module
    implicit none
    
    integer, intent(out) :: status
    integer, intent(in) :: new_size
    
    real(kind=8), allocatable, target, dimension(:) :: new_storage
    

    print *, "Expanding storage from ", memsize," to ", new_size
    allocate(new_storage(new_size),STAT=status)
    if (status > 0) then
        return
    endif
    new_storage(1:memsize) = alloc     ! new way, use allocatable, not pointer       

    call move_alloc(new_storage,alloc)

    memsize = new_size
    
    return
    
end subroutine resize_storage

!> Compute enclosing line around flagged points.
!! save some info., even tho. usage might be low and rect. scrapped.
!! 
!! \param[in] badpts  x coords of cells around which a rectangle 
!! is to be made and compute efficiency on
!! \param[in] npt     num. of badpts. in the cluster.
!! \param[out] usage   ratio of flagged to unflagged badpts. in new grid
!!                measures goodness of fit and clustering
!! \param[out] intrect stores some info. for grid created herein.
!!                sometimes rect = rnode, sometimes = temp. array.
!!                sometimes intrect = node.
!!                depending on calling prog. (grdfit or expand)


subroutine moment(intrect, badpts, npt, usage)
    !
    ! :::::::::::::::::::::::: MOMENT ::::::::::::::::::::::::::::::::::
    !  moment = compute enclosing rectangle around flagged points.
    !  save some info., even tho. usage might be low and rect. scrapped.
    !
    ! input parameters:
    !     badpts      = x,y coords of flagged badpts grouped into clusters
    !                   are in the first two rows
    !     npt         = num. of badpts. in the cluster.
    !
    ! output parameters:
    !     usage       = ratio of flagged to unflagged badpts. in new grid
    !                   measures goodness of fit and clustering
    !    intrect( )    = stores some info. for grid created herein.
    !                   sometimes rect = rnode, sometimes = temp. array.
    !                   sometimes intrect = node.
    !                   depending on calling prog. (grdfit or expand)
    !
    !
    ! :::::::::::::::::::::::: MOMENT ::::::::::::::::::::::::::::::::::
    !

    use amr_module, only: ndilo, ndihi, nsize

    ! Input
    integer, intent(in) :: npt
    real(kind=8), intent(in) :: badpts(1, npt)
    integer, intent(in out) ::  intrect(nsize)
    real(kind=8), intent(out) :: usage

    ! Locals
    real(kind=8) :: e_min, e_max, side

    ! Compute length of enclosing lines to include all flagged badpts
    e_min = minval(badpts(1, :))
    e_max = maxval(badpts(1, :))

    ! From length of the sides determine rect corners
    ! transform to cell numebrs (subtract 0.5)
    intrect(ndilo) = nint(e_min - 0.5d0)
    intrect(ndihi) = nint(e_max - 0.5d0)

    ! Compute usage
    side = real(intrect(ndihi) - intrect(ndilo) + 1, kind=8)
    usage = real(npt, kind=8) / side

end subroutine moment

c
c ----------------------------------------------------
c
      subroutine domup(iflags2,iflags,ibase,jbase,isize,jsize,lev)

      use amr_module
      implicit double precision (a-h, o-z)


      integer(kind=1)  iflags2(0:isize+1,0:jsize+1)
      integer(kind=1)  iflags (0:ibase+1,0:jbase+1)

c
c ::::::::::::::::::::::::::: DOMUP :::::::::::::::::::::
c 
!>  domain flags are in iflags. copy into iflags2, allowing
!!  for change of level and dimension
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
         write(outunit,*)" from domup: domflags (before expansion)"
         do 5 jj = 1, jbase
         j = jbase + 1 - jj
         write(outunit,100)(iflags(i,j),i=1,ibase)
 5       continue
      endif

      do j = 0, jsize+1
      do i = 0, isize+1
         iflags2(i,j) = 0
      end do
      end do

      do j = 1, jbase
      do i = 1, ibase
          ifine = (i-1) * intratx(lev)
          jfine = (j-1) * intraty(lev)
          do mj = 1, intraty(lev)
          do mi = 1, intratx(lev)
            iflags2(ifine+mi,jfine+mj) = iflags(i,j)  
          end do
          end do
      end do
      end do
c
c  take care of periodicity again or if border of domain touches a 
c  physical boundary then set domain in ghost cell as well
c
      if (xperdom) then
         do 35 j = 0, jsize+1
           iflags2(0,j)       = iflags2(isize,j)
           iflags2(isize+1,j) = iflags2(1,j)
 35      continue
       else
       do 55 j = 1, jsize
         if (iflags2(1,j) .eq. 1) iflags2(0,j) = 1
         if (iflags2(isize,j) .eq. 1) iflags2(isize+1,j) = 1
 55    continue
      endif
      if (yperdom) then
         do 45 i = 0, isize+1
           iflags2(i,0)       = iflags2(i,jsize)
           iflags2(i,jsize+1) = iflags2(i,1)
 45      continue
       else if (spheredom) then
         do 46 i = 0, isize+1
           iflags2(i,0)       = iflags2(isize+1-i,1)
           iflags2(i,jsize+1) = iflags2(isize+1-i,jsize)
 46      continue

       else
         do 65 i = 1, isize
           if (iflags2(i,1) .eq. 1) iflags2(i,0) = 1
           if (iflags2(i,jsize) .eq. 1) iflags2(i,jsize+1) = 1
 65      continue
      endif

c
c the 4 corners
c
        if (iflags2(0,1)+iflags2(1,0) .eq. 2) iflags2(0,0)=1
        if (iflags2(isize,0)+iflags2(isize+1,1) .eq. 2)
     .          iflags2(isize+1,0)=1
        if (iflags2(isize,jsize+1)+iflags2(isize+1,jsize) .eq. 2)
     .          iflags2(isize+1,jsize+1)=1
        if (iflags2(0,jsize)+iflags2(1,jsize+1) .eq. 2)
     .          iflags2(0,jsize+1)=1


      if (dprint) then
         write(outunit,*)" from domup: domflags (after expansion)"
         do 70 jj = 1, jsize
         j = jsize + 1 - jj
         write(outunit,100)(iflags2(i,j),i=1,isize)
 100     format(80i1)
 70      continue
      endif

      return
      end

! ==============================================================================
! Riemann solver in the transverse direction for the acoustics equations.
! Split asdq into down-going flux bmasdq and up-going flux bpasdq.
! ==============================================================================

subroutine rpt2_ptwise(ixy, imp, num_eqn, num_aux, num_waves, q_l, q_r,      &
                       aux_l, aux_r, asdq, bmasdq, bpasdq)

    implicit none

    ! Input
    integer, intent(in) :: num_eqn, num_aux, num_waves, ixy, imp
    real(kind=8), intent(in) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in) :: aux_l(num_aux, 3), aux_r(num_aux, 3)
    real(kind=8), intent(in out) :: asdq(num_eqn)

    ! Output
    real(kind=8), intent(in out) :: bmasdq(num_eqn), bpasdq(num_eqn)

    ! Locals
    integer :: normal_index, transverse_index
    real(kind=8) :: a(2)

    ! Common block
    ! density, bulk modulus, and sound speed, and impedence of medium:
    real(kind=8) :: rho, bulk, cc, zz
    common /cparam/ rho, bulk, cc, zz
    
    if (ixy == 1) then
        normal_index = 2
        transverse_index = 3
    else
        normal_index = 3
        transverse_index = 2
    endif

    a(1) = (-asdq(1) + zz * asdq(transverse_index)) / (2.d0 * zz)
    a(2) = ( asdq(1) + zz * asdq(transverse_index)) / (2.d0 * zz)

    ! Down-going flux difference bmasdq is the product of -c * wave
    bmasdq(1) = cc * a(1) * zz
    bmasdq(normal_index) = 0.d0
    bmasdq(transverse_index) = -cc * a(1)

    ! Up-going flux difference bpasdq is the product of c * wave
    bpasdq(1) = cc * a(2) * zz
    bpasdq(normal_index) = 0.d0
    bpasdq(transverse_index) = cc * a(2)
    
end subroutine rpt2_ptwise

subroutine src3(meqn,mbc,mx,my,mz,xlower,ylower,zlower,dx,dy,dz,q,maux,aux,t,dt)

    ! Called to update q by solving source term equation 
    ! $q_t = \psi(q)$ over time dt starting at time t.
    !
    ! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: meqn,mbc,mx,my,mz,maux
    real(kind=8), intent(in) :: xlower,ylower,zlower,dx,dy,dz,t,dt
    double precision, intent(in) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    double precision, intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)

end subroutine src3

c
c -----------------------------------------------------------
c
      subroutine update (level, nvar, maux)
c
      use amr_module
      implicit double precision (a-h,o-z)


      integer listgrids(numgrids(level))

      iadd(ivar,i,j,k)   = loc     +     (ivar-1)
     &                             +     (i-1)*nvar
     &                             +     (j-1)*nvar*mitot
     &                             +     (k-1)*nvar*mitot*mjtot
      iaddf(ivar,i,j,k)  = locf    +     (ivar-1)
     &                             +     (i-1)*nvar
     &                             +     (j-1)*nvar*mi
     &                             +     (k-1)*nvar*mi*mj
      iaddfaux(i,j,k)    = locfaux +     (mcapa-1)
     &                             +     (i-1)*maux
     &                             +     (j-1)*maux*mi
     &                             +     (k-1)*maux*mi*mj
      iaddcaux(i,j,k)    = loccaux +     (mcapa-1)
     &                             +     (i-1)*maux
     &                             +     (j-1)*maux*mitot
     &                             +     (k-1)*maux*mitot*mjtot
c
c :::::::::::::::::::::::::: UPDATE :::::::::::::::::::::::::::::::::
c update - update all grids at level 'level'.
c          this routine assumes cell centered variables.
c          the update is done from 1 level finer meshes under it.
c input parameter:
c    level  - ptr to the only level to be updated. levels coarser than
c             this will be at a diffeent time.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      lget = level
      if (uprint) write(outunit,100) lget
100   format(19h    updating level ,i5)
c     call prepgrids(listgrids,numgrids(level),level)
c
c  grid loop for each level
c
      dt     = possk(lget)

c old loop was over linked list. now put in array for parallel do
c      mptr = lstart(lget)
c 20   if (mptr .eq. 0) go to 85

!$OMP PARALLEL DO PRIVATE(ng,mptr,loc,loccaux,nx,ny,nz,mitot,mjtot,
!$OMP&                    mktot,ilo,jlo,klo,ihi,jhi,khi,mkid,iclo,
!$OMP&                    jclo,kclo,ichi,jchi,kchi,mi,mj,mk,locf,
!$OMP&                    locfaux,iplo,jplo,kplo,iphi,jphi,kphi,
!$OMP&                    iff,jff,kff,totrat,i,j,k,ivar,
!$OMP&                    ico,jco,kco,capa,levSt),
!$OMP&         SHARED(lget,numgrids,listgrids,listsp,alloc,nvar,maux,
!$OMP&                   intratx,intraty,intratz,nghost,uprint,mcapa,
!$OMP&                   node,lstart,level,listOfGrids,listStart),
!$OMP&         SCHEDULE(dynamic,1),
!$OMP&         DEFAULT(none)
       do ng = 1, numgrids(lget)
         !mptr    = listgrids(ng)
         levSt   = listStart(lget)
         mptr    = listOfGrids(levSt + ng - 1)
         loc     = node(store1,mptr)
         loccaux = node(storeaux,mptr)
         nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         nz      = node(ndkhi,mptr) - node(ndklo,mptr) + 1
         mitot   = nx + 2*nghost
         mjtot   = ny + 2*nghost
         mktot   = nz + 2*nghost
         ilo     = node(ndilo,mptr)
         jlo     = node(ndjlo,mptr)
         klo     = node(ndklo,mptr)
         ihi     = node(ndihi,mptr)
         jhi     = node(ndjhi,mptr)
         khi     = node(ndkhi,mptr)
c
         if (node(cfluxptr,mptr) .eq. 0) go to 25
c         locuse = igetsp(mitot*mjtot*mktot)
         call upbnd(alloc(node(cfluxptr,mptr)),alloc(loc),nvar,
     1              maux,mitot,mjtot,mktot,listsp(lget),mptr)
c         call reclam(locuse,mitot*mjtot*mktot)
c
c  loop through all intersecting fine grids as source updaters.
c
 25      mkid = lstart(lget+1)
 30        if (mkid .eq. 0) go to 80
           iclo   = node(ndilo,mkid)/intratx(lget)
           jclo   = node(ndjlo,mkid)/intraty(lget)
           kclo   = node(ndklo,mkid)/intratz(lget)
           ichi   = node(ndihi,mkid)/intratx(lget)
           jchi   = node(ndjhi,mkid)/intraty(lget)
           kchi   = node(ndkhi,mkid)/intratz(lget)

           mi      = node(ndihi,mkid)-node(ndilo,mkid) + 1 + 2*nghost
           mj      = node(ndjhi,mkid)-node(ndjlo,mkid) + 1 + 2*nghost
           mk      = node(ndkhi,mkid)-node(ndklo,mkid) + 1 + 2*nghost
           locf    = node(store1,mkid)
           locfaux = node(storeaux,mkid)
c
c  calculate starting and ending indices for coarse grid update, if overlap
c
         iplo = max(ilo,iclo)
         jplo = max(jlo,jclo)
         kplo = max(klo,kclo)
         iphi = min(ihi,ichi)
         jphi = min(jhi,jchi)
         kphi = min(khi,kchi)

        if (iplo .gt. iphi .or. jplo .gt. jphi
     1                     .or. kplo .gt. kphi) go to 75
c
c  calculate starting index for fine grid source pts.
c
         totrat = intratx(lget) * intraty(lget) * intratz(lget)
 
         iff     = iplo*intratx(lget) - node(ndilo,mkid) + nghost + 1
         do 72 i = iplo-ilo+nghost+1, iphi-ilo+nghost+1
         jff     = jplo*intraty(lget) - node(ndjlo,mkid) + nghost + 1
         do 71 j = jplo-jlo+nghost+1, jphi-jlo+nghost+1
         kff     = kplo*intratz(lget) - node(ndklo,mkid) + nghost + 1
         do 70 k = kplo-klo+nghost+1, kphi-klo+nghost+1
           if (uprint) then
              write(outunit,101) i,j,k,mptr,iff,jff,kff,mkid
 101          format(' updating pt. ',3i4,' of grid ',i3,' using ',3i4,
     1               ' of grid ',i4)
              write(outunit,102)(alloc(iadd(ivar,i,j,k)),ivar=1,nvar)
 102          format(' old vals: ',5e30.20)
           endif
c
c
c  update using intrat fine points in each direction
c
           do 40 ivar = 1, nvar
 40           alloc(iadd(ivar,i,j,k)) = 0.d0
c
           if (mcapa .eq. 0) then

               do 50 kco  = 1, intratz(lget)
               do 50 jco  = 1, intraty(lget)
               do 50 ico  = 1, intratx(lget)
               do 45 ivar = 1, nvar
                 alloc(iadd(ivar,i,j,k))= alloc(iadd(ivar,i,j,k)) + 
     1                  alloc(iaddf(ivar,iff+ico-1,jff+jco-1,kff+kco-1))
 45              continue
 50            continue
               do 65 ivar = 1, nvar
 65             alloc(iadd(ivar,i,j,k)) = alloc(iadd(ivar,i,j,k))/totrat
             
         else

              do 51 kco  = 1, intratz(lget)
              do 51 jco  = 1, intraty(lget)
              do 51 ico  = 1, intratx(lget)
                capa = alloc(iaddfaux(iff+ico-1,jff+jco-1,kff+kco-1))
                do 46 ivar = 1, nvar
                 alloc(iadd(ivar,i,j,k))= alloc(iadd(ivar,i,j,k)) + 
     1            alloc(iaddf(ivar,iff+ico-1,jff+jco-1,kff+kco-1))*capa
 46             continue
 51           continue
              do 66 ivar = 1, nvar
 66             alloc(iadd(ivar,i,j,k)) = alloc(iadd(ivar,i,j,k))/
     1                                 (totrat*alloc(iaddcaux(i,j,k)))
         endif
c
         if (uprint) write(outunit,103)(alloc(iadd(ivar,i,j,k)),
     .                                  ivar=1,nvar)
 103     format(' new vals: ',5e12.4)
c
           kff = kff + intratz(lget)
 70        continue
           jff = jff + intraty(lget)
 71        continue
           iff = iff + intratx(lget)
 72        continue
c
 75        mkid = node(levelptr,mkid)
           go to 30
c
c 80        mptr = node(levelptr, mptr)
c            go to 20
 80        continue
           end do
!$OMP END PARALLEL DO
c
c85       continue
c
 99   return
      end

c
!> Integrate all grids at the input **level** by one step of its delta(t)
!!
!! this includes:  
!! - setting the ghost cells 
!! - advancing the solution on the grid
!! - adjusting fluxes for flux conservation step later
c --------------------------------------------------------------
c
      subroutine advanc (level,nvar,dtlevnew,vtime,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)


      logical    vtime
      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      integer listgrids(numgrids(level))
      integer(kind=8) :: clock_start, clock_finish, clock_rate
      integer(kind=8) :: clock_startStepgrid,clock_startBound,
     &                   clock_finishBound
      real(kind=8) cpu_start, cpu_finish
      real(kind=8) cpu_startBound, cpu_finishBound
      real(kind=8) cpu_startStepgrid, cpu_finishStepgrid

c     maxgr is maximum number of grids  many things are
c     dimensioned at, so this is overall. only 1d array
c     though so should suffice. problem is
c     not being able to dimension at maxthreads


c
c  ::::::::::::::; ADVANC :::::::::::::::::::::::::::::::::::::::::::
c  integrate all grids at the input  'level' by one step of its delta(t)
c  this includes:  setting the ghost cells 
c                  advancing the solution on the grid
c                  adjusting fluxes for flux conservation step later
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c get start time for more detailed timing by level
      call system_clock(clock_start,clock_rate)
      call cpu_time(cpu_start)


      hx   = hxposs(level)
      hy   = hyposs(level)
      delt = possk(level)
c     this is linear alg.
c     call prepgrids(listgrids,numgrids(level),level)
c

      call system_clock(clock_startBound,clock_rate)
      call cpu_time(cpu_startBound)


c     maxthreads initialized to 1 above in case no openmp
!$    maxthreads = omp_get_max_threads()

c We want to do this regardless of the threading type
!$OMP PARALLEL DO PRIVATE(j,locnew, locaux, mptr,nx,ny,mitot,
!$OMP&                    mjtot,time,levSt),
!$OMP&            SHARED(level, nvar, naux, alloc, intrat, delt,
!$OMP&                   listOfGrids,listStart,nghost,
!$OMP&                   node,rnode,numgrids,listgrids),
!$OMP&            SCHEDULE (dynamic,1)
!$OMP&            DEFAULT(none)
      do j = 1, numgrids(level)
         !mptr   = listgrids(j)
         levSt = listStart(level)
         mptr   = listOfGrids(levSt+j-1)
         !write(*,*)"old ",listgrids(j)," new",mptr
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         mitot  = nx + 2*nghost
         mjtot  = ny + 2*nghost
         locnew = node(store1,mptr)
         locaux = node(storeaux,mptr)
         time   = rnode(timemult,mptr)
c     
          call bound(time,nvar,nghost,alloc(locnew),mitot,mjtot,mptr,
     1               alloc(locaux),naux)

       end do
!$OMP END PARALLEL DO
      call system_clock(clock_finishBound,clock_rate)
      call cpu_time(cpu_finishBound)
      timeBound = timeBound + clock_finishBound - clock_startBound
      timeBoundCPU=timeBoundCPU+cpu_finishBound-cpu_startBound
      
c
c save coarse level values if there is a finer level for wave fixup
      if (level+1 .le. mxnest) then
         if (lstart(level+1) .ne. null) then
            call saveqc(level+1,nvar,naux)
         endif
      endif
c
      dtlevnew = rinfinity
      cfl_level = 0.d0    !# to keep track of max cfl seen on each level

c 
      call system_clock(clock_startStepgrid,clock_rate)
      call cpu_time(cpu_startStepgrid)


!$OMP PARALLEL DO PRIVATE(j,mptr,nx,ny,mitot,mjtot)  
!$OMP&            PRIVATE(mythread,dtnew)
!$OMP&            SHARED(rvol,rvoll,level,nvar,mxnest,alloc,intrat)
!$OMP&            SHARED(nghost,intratx,intraty,hx,hy,naux,listsp)
!$OMP&            SHARED(node,rnode,dtlevnew,numgrids,listgrids)
!$OMP&            SHARED(listOfGrids,listStart,levSt)
!$OMP&            SCHEDULE (DYNAMIC,1)
!$OMP&            DEFAULT(none)
      do j = 1, numgrids(level)
         !mptr   = listgrids(j)
         levSt = listStart(level)
         mptr = listOfGrids(levSt+j-1)
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         mitot  = nx + 2*nghost
         mjtot  = ny + 2*nghost
c
          call par_advanc(mptr,mitot,mjtot,nvar,naux,dtnew)
!$OMP CRITICAL (newdt)
          dtlevnew = dmin1(dtlevnew,dtnew)
!$OMP END CRITICAL (newdt)    

      end do
!$OMP END PARALLEL DO
c
      call system_clock(clock_finish,clock_rate)
      call cpu_time(cpu_finish)
      tvoll(level) = tvoll(level) + clock_finish - clock_start
      tvollCPU(level) = tvollCPU(level) + cpu_finish - cpu_start
      timeStepgrid = timeStepgrid +clock_finish-clock_startStepgrid
      timeStepgridCPU=timeStepgridCPU+cpu_finish-cpu_startStepgrid      
      
      cflmax = dmax1(cflmax, cfl_level)

c
      return
      end
c
c -------------------------------------------------------------
c
       subroutine prepgrids(listgrids, num, level)

       use amr_module
       implicit double precision (a-h,o-z)
       integer listgrids(num)

       mptr = lstart(level)
       do j = 1, num
          listgrids(j) = mptr
          mptr = node(levelptr, mptr)
       end do

      if (mptr .ne. 0) then
         write(*,*)" Error in routine setting up grid array "
         stop
      endif

      return
      end

c
c --------------------------------------------------------------
c
!> Integrate grid **mptr**. grids are done in parallel.
      subroutine par_advanc (mptr,mitot,mjtot,nvar,naux,dtnew)
c
      use amr_module
      use gauges_module, only: update_gauges, num_gauges
      implicit double precision (a-h,o-z)


      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/

      double precision fp(nvar,mitot,mjtot),fm(nvar,mitot,mjtot)
      double precision gp(nvar,mitot,mjtot),gm(nvar,mitot,mjtot)


c
c  :::::::::::::: PAR_ADVANC :::::::::::::::::::::::::::::::::::::::::::
c  integrate this grid. grids are done in parallel.
c  extra subr. used to allow for stack based allocation of
c  flux arrays. They are only needed temporarily. If used alloc
c  array for them it has too long a lendim, makes too big
c  a checkpoint file, and is a big critical section.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
      delt  = possk(level)
      nx    = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny    = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      time  = rnode(timemult,mptr)

!$    mythread = omp_get_thread_num()

      locold = node(store2, mptr)
      locnew = node(store1, mptr)

c
c  copy old soln. values into  next time step's soln. values
c  since integrator will overwrite it. only for grids not at
c  the finest level. finest level grids do not maintain copies
c  of old and new time solution values.
c
         if (level .lt. mxnest) then
             ntot   = mitot * mjtot * nvar
cdir$ ivdep
             do  i = 1, ntot
               alloc(locold + i - 1) = alloc(locnew + i - 1)
             end do
         endif
c
         xlow = rnode(cornxlo,mptr) - nghost*hx
         ylow = rnode(cornylo,mptr) - nghost*hy

!$OMP CRITICAL(rv)
      rvol = rvol + nx * ny
      rvoll(level) = rvoll(level) + nx * ny
!$OMP END CRITICAL(rv)


         locaux = node(storeaux,mptr)
c
         if (node(ffluxptr,mptr) .ne. 0) then
            lenbc  = 2*(nx/intratx(level-1)+ny/intraty(level-1))
            locsvf = node(ffluxptr,mptr)
            locsvq = locsvf + nvar*lenbc
            locx1d = locsvq + nvar*lenbc
            call qad(alloc(locnew),mitot,mjtot,nvar,
     1               alloc(locsvf),alloc(locsvq),lenbc,
     2               intratx(level-1),intraty(level-1),hx,hy,
     3               naux,alloc(locaux),alloc(locx1d),delt,mptr)
         endif

c        # See if the grid about to be advanced has gauge data to output.
c        # This corresponds to previous time step, but output done
c        # now to make linear interpolation easier, since grid
c        # now has boundary conditions filled in.

c     should change the way print_gauges does io - right now is critical section
c     no more,  each gauge has own array.

      if (num_gauges > 0) then
           call update_gauges(alloc(locnew:locnew+nvar*mitot*mjtot),
     .                       alloc(locaux:locaux+naux*mitot*mjtot),
     .                       xlow,ylow,nvar,mitot,mjtot,naux,mptr)
         endif

c
         if (dimensional_split .eq. 0) then
c           # Unsplit method
         call stepgrid(alloc(locnew),fm,fp,gm,gp,
     2                  mitot,mjtot,nghost,
     3                  delt,dtnew,hx,hy,nvar,
     4                  xlow,ylow,time,mptr,naux,alloc(locaux))
         else if (dimensional_split .eq. 1) then
c           # Godunov splitting
         call stepgrid_dimSplit(alloc(locnew),fm,fp,gm,gp,
     2               mitot,mjtot,nghost,
     3               delt,dtnew,hx,hy,nvar,
     4               xlow,ylow,time,mptr,naux,alloc(locaux))
         else 
c           # should never get here due to check in amr2
            write(6,*) '*** Strang splitting not supported'
            stop
         endif

      if (node(cfluxptr,mptr) .ne. 0)
     2   call fluxsv(mptr,fm,fp,gm,gp,
     3               alloc(node(cfluxptr,mptr)),mitot,mjtot,
     4               nvar,listsp(level),delt,hx,hy)
         if (node(ffluxptr,mptr) .ne. 0) then
         lenbc = 2*(nx/intratx(level-1)+ny/intraty(level-1))
            locsvf = node(ffluxptr,mptr)
         call fluxad(fm,fp,gm,gp,
     2               alloc(locsvf),mptr,mitot,mjtot,nvar,
     4                  lenbc,intratx(level-1),intraty(level-1),
     5               nghost,delt,hx,hy)
         endif
c
c        write(outunit,969) mythread,delt, dtnew
c969     format(" thread ",i4," updated by ",e15.7, " new dt ",e15.7)
         rnode(timemult,mptr)  = rnode(timemult,mptr)+delt
c
      return
      end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
    implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for the acoustics equations
!     # with varying material properties rho and kappa

!     # auxN(1,i) holds rho
!     # auxN(2,i) holds c
!     #  N = 1 for row below
!     #      2 for this row
!     #      3 for row above

!     # Split asdq into down-going flux bmasdq and up-going flux bpasdq.

!     # imp=1  means  asdq=amdq,    imp=2 means asdq=apdq

    dimension    ql(meqn, 1-mbc:maxm+mbc)
    dimension    qr(meqn, 1-mbc:maxm+mbc)
    dimension    asdq(meqn, 1-mbc:maxm+mbc)
    dimension bmasdq(meqn, 1-mbc:maxm+mbc)
    dimension bpasdq(meqn, 1-mbc:maxm+mbc)
    dimension   aux1(maux, 1-mbc:maxm+mbc)
    dimension   aux2(maux, 1-mbc:maxm+mbc)
    dimension   aux3(maux, 1-mbc:maxm+mbc)



    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif


    do 20 i = 2-mbc, mx+mbc
    
    !        # imp is used to flag whether wave is going to left or right,
    !        # since material properties are different on the two sides
    
        if (imp == 1) then
        !            # asdq = amdq, moving to left
            i1 = i-1
        else
        !            # asdq = apdq, moving to right
            i1 = i
        endif
    
    !        # The flux difference asdq is split into downward moving part
    !        # traveling at speed -c relative to the medium below and
    !        # an upward moving part traveling
    !        # at speed +c relative to the medium above.
    
    !        # Note that the sum of these parts does not give all of asdq
    !        # since there is also reflection at the interfaces which decreases
    !        # the flux.
    
    !        # sound speed in each row of cells:
        cm = aux1(2,i1)
        c = aux2(2,i1)
        cp = aux3(2,i1)
    
    !        # impedances:
        zm = aux1(1,i1)*aux1(2,i1)
        zz = aux2(1,i1)*aux2(2,i1)
        zp = aux3(1,i1)*aux3(2,i1)

    !        # transmitted part of down-going wave:
        a1 = (-asdq(1,i) + asdq(mv,i)*zz) / &
        (zm + zz)

    !        # transmitted part of up-going wave:
        a2 = (asdq(1,i) + asdq(mv,i)*zz) / &
        (zz + zp)
    
    !        # The down-going flux difference bmasdq is the product  -c * wave
    
        bmasdq(1,i) = cm * a1*zm
        bmasdq(mu,i) = 0.d0
        bmasdq(mv,i) = -cm * a1
    
    !        # The up-going flux difference bpasdq is the product  c * wave
    
        bpasdq(1,i) = cp * a2*zp
        bpasdq(mu,i) = 0.d0
        bpasdq(mv,i) = cp * a2
    
    20 END DO

    return
    end subroutine rpt2

c
c -------------------------------------------------------------
c
      subroutine stepgrid_dimSplit(q,fm,fp,gm,gp,hm,hp,mitot,mjtot,
     &                  mktot,mbc,dt,dtnew,dx,dy,dz,
     &                  nvar,xlow,ylow,zlow,time,mptr,maux,aux)
c
c
c ::::::::::::::::::: STEPGRID ::::::::::::::::::::::::::::::::::::
c                 dimensionally split version of stepgrid
c    take a step in x, then y, then z. for now only godunov splitting
c    not strang splitting. 
c
c take a time step on a single grid. overwrite solution array q.
c A modified version of the clawpack routine step3 is used.
c
c return fluxes in fm,fp and gm,gp and hm,hp.
c patch has room for ghost cells (mbc of them) around the grid.
c everything is the enlarged size (mitot by mjtot by mktot).

c even though dimensionally split, need to save all 3 fluxes for
c flux conservation on the outside.

c
c mbc       = number of ghost cells  (= lwidth)
c mptr      = grid number  (for debugging)
c xlow,ylow,zlow = lower left corner of enlarged grid (including ghost cells).
c dt         = incoming time step
c dx,dy,dz   = mesh widths for this grid
c dtnew      = return suggested new time step for this grids soln.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      use amr_module
      implicit double precision (a-h,o-z)

      external rpn3

      dimension q(nvar,mitot,mjtot,mktot)
      dimension fm(nvar,mitot,mjtot,mktot),fp(nvar,mitot,mjtot,mktot)
      dimension gm(nvar,mitot,mjtot,mktot),gp(nvar,mitot,mjtot,mktot)
      dimension hm(nvar,mitot,mjtot,mktot),hp(nvar,mitot,mjtot,mktot)
      dimension aux(maux,mitot,mjtot,mktot)

      logical    debug,  dump
      data       debug/.false./,  dump/.false./

c
c
!--        if (dump .and. mptr .ne. 1) 
!--     1       call prettyprint(q,nvar,mitot,mjtot,mktot,outunit)
      if (dump) then
         write(outunit,*)" grid ", mptr
         do k = 1, mktot
         do j = 1, mjtot
         do i = 1, mitot
           write(outunit,545) i,j,k,(q(ivar,i,j,k),ivar=1,nvar)
 545       format(3i3,3x,5e30.20)
         end do
         end do
         end do
      endif
c
      meqn   = nvar
      mx = mitot - 2*mbc
      my = mjtot - 2*mbc
      mz = mktot - 2*mbc
      maxm = max(mx,my,mz)       !# size for 1d scratch array
      mbig = maxm
      xlowmbc = xlow + mbc*dx
      ylowmbc = ylow + mbc*dy
      zlowmbc = zlow + mbc*dz

      if (maxm+2*mbc > max1d + 4) then
         write(6,*) 'Increase size of max1d; ', maxm+2*mbc
         stop
      endif


c
c 2/28/02 : Added call to b4step3.
      call b4step3(mbc,mx,my,mz,nvar,q,
     &             xlowmbc,ylowmbc,zlowmbc,dx,dy,dz,time,dt,maux,aux)

c
c
c
c
c    :::  # take one step on the conservation law: Godunov splitting :::
c
      call step3x(mbig,nvar,maux,mbc,mx,my,mz,
     &           q,aux,dx,dt,cflgrid,
     &           fm,fp,rpn3)
c
!$OMP CRITICAL (setcfl)
      cfl_level = dmax1(cfl_level,cflgrid)
!$OMP END CRITICAL (setcfl)
c
c       # update q with x fluxes first.
      dtdx = dt/dx
        if (mcapa.eq.0) then
         do 50 k=1,mktot
         do 50 j=1,mjtot
         do 50 i=mbc+1,mitot-mbc
         do 50 m=1,nvar
c
c            # no capa array.  Standard flux differencing:

            q(m,i,j,k) = q(m,i,j,k) - dtdx*(fm(m,i+1,j,k)-fp(m,i,j,k))
     
 50       continue
       else
         do 51 k=1,mktot
         do 51 j=1,mjtot
         do 51 i=mbc+1,mitot-mbc
         do 51 m=1,nvar

c            # with capa array.

          q(m,i,j,k) = q(m,i,j,k)
     &              - dtdx * (fm(m,i+1,j,k) - fp(m,i,j,k))
     &              / aux(mcapa,i,j,k)
 51       continue
       endif
c
c  second step: update in y
      call step3y(mbig,nvar,maux,mbc,mx,my,mz,
     &           q,aux,dy,dt,cflgrid,
     &           gm,gp,rpn3)
c
!$OMP CRITICAL (setcfl)
      cfl_level = dmax1(cfl_level,cflgrid)
!$OMP END CRITICAL (setcfl)
c
c       # update q with y fluxes next
      dtdy = dt/dy
        if (mcapa.eq.0) then
         do 52 k=1,mktot
         do 52 j=mbc+1,mjtot-mbc
         do 52 i=mbc+1,mitot-mbc
         do 52 m=1,nvar
c
c            # no capa array.  Standard flux differencing:

            q(m,i,j,k) = q(m,i,j,k) - dtdy*(gm(m,i,j+1,k)-gp(m,i,j,k))
     
 52       continue
       else
         do 53 k=1,mktot
         do 53 j=mbc+1,mjtot-mbc
         do 53 i=mbc+1,mitot-mbc
         do 53 m=1,nvar

c            # with capa array.

          q(m,i,j,k) = q(m,i,j,k)
     &              - dtdy * (gm(m,i,j+1,k) - gp(m,i,j,k))
     &              / aux(mcapa,i,j,k)
 53       continue
       endif
c
c  third step: update in z
      call step3z(mbig,nvar,maux,mbc,mx,my,mz,
     &           q,aux,dz,dt,cflgrid,
     &           hm,hp,rpn3)
c
!$OMP CRITICAL (setcfl)
      cfl_level = dmax1(cfl_level,cflgrid)
!$OMP END CRITICAL (setcfl)
c
c       # update q with z fluxes last
      dtdz = dt/dz
        if (mcapa.eq.0) then
         do 54 k=mbc+1,mktot-mbc
         do 54 j=mbc+1,mjtot-mbc
         do 54 i=mbc+1,mitot-mbc
         do 54 m=1,nvar
c
c            # no capa array.  Standard flux differencing:

            q(m,i,j,k) = q(m,i,j,k) - dtdz*(hm(m,i,j,k+1)-hp(m,i,j,k))
     
 54       continue
       else
         do 55 k=mbc+1,mktot-mbc
         do 55 j=mbc+1,mjtot-mbc
         do 55 i=mbc+1,mitot-mbc
         do 55 m=1,nvar

c            # with capa array.

          q(m,i,j,k) = q(m,i,j,k)
     &              - dtdz * (hm(m,i,j,k+1) - hp(m,i,j,k))
     &              / aux(mcapa,i,j,k)
 55       continue
       endif
c
c     ::: end of Godunov dimensional splitting :::
c
      if (method(5).eq.1) then
c        # with source term:   use Godunov splitting
c         call src3(q,mitot,mjtot,mktot,nvar,aux,maux,time,dt)
         call src3(nvar,mbc,mx,my,mz,xlowmbc,ylowmbc,
     &             zlowmbc,dx,dy,dz,q,maux,aux,time,dt)
       endif
c
c
c
c     # output fluxes for debugging purposes:
      if (debug) then
       write(dbugunit,*)" fluxes for grid ",mptr
         do 830 i = mbc+1, mitot-1
            do 830 j = mbc+1, mjtot-1
            do 830 k = mbc+1, mktot-1
               write(dbugunit,831) i,j,k,fm(1,i,j,k),fp(1,i,j,k),
     .                           gm(1,i,j,k),gp(1,i,j,k),
     .                           hm(1,i,j,k),hp(1,i,j,k)
             do 830 m = 2, meqn
              write(dbugunit,832) fm(m,i,j,k),fp(m,i,j,k),
     .              gm(m,i,j,k),gp(m,i,j,k),
     .              hm(m,i,j,k),hp(m,i,j,k)
  831          format(3i4,6d16.6)
  832          format(8x,6d16.6)
  830    continue
      endif

c
c
c For variable time stepping, use max speed seen on this grid to
c choose the allowable new time step dtnew.  This will later be
c compared to values seen on other grids.
c
        if (cfl_level .gt. 0.d0) then
            dtnew = dt*cfl/cfl_level
          else
c            # velocities are all zero on this grid so there's no
c            # time step restriction coming from this grid.
            dtnew = rinfinity
          endif
c

      if (cfl_level .gt. cflv1) then
            write(*,810) cfl_level
            write(outunit,810) cfl_level
  810       format('*** WARNING *** Courant number  =', d12.4,
     &              '  is larger than cflv(1) ')
            endif

!--        if (dump .and. mptr .ne. 1) 
!--     1     call prettyprint(q,nvar,mitot,mjtot,mktot,outunit)
      if (dump) then
         write(outunit,*)" after time step on grid ", mptr
         do k = 1, mktot
         do j = 1, mjtot
         do i = 1, mitot
           write(outunit,545) i,j,k,(q(ivar,i,j,k),ivar=1,nvar)
         end do
         end do
         end do
      endif

      return
      end

c======================================================================
      function bilinearintegral(xim,xip,yjm,yjp,x1,x2,y1,y2,dxx,dyy,
     &                                              z11,z12,z21,z22)
c======================================================================

      implicit none

*     !i/o
      double precision xim,xip,yjm,yjp,x1,x2,y1,y2,dxx,dyy,
     &                                                z11,z12,z21,z22
      double precision bilinearintegral

*     !local
      double precision xlow,ylow,xhi,yhi,area,sumxi,sumeta,a,b,c,d

c#######################################################################
c
c         bilinearintegral integrates the bilinear with values z##
c         over the rectangular region xim <= x <= xip, and
c                                     yjm <= y <= yjp

c                                          written by David L George
c                                          Vancouver, WA April 2010
c#######################################################################



*     !integrate the portion of the bilinear intersected with the
c     !rectangular cell analytically.

c     !find limits of integral (this should already be true?)
      xlow = max(xim,x1)
      ylow = max(yjm,y1)
      xhi  = min(xip,x2)
      yhi =  min(yjp,y2)

*     !find the area of integration
      area = (yhi-ylow)*(xhi-xlow)
      sumxi = (xhi + xlow - 2.d0*x1)/dxx
      sumeta = (yhi + ylow - 2.d0*y1)/dyy

*     !find coefficients of bilinear a*xi + b*eta + c*xi*eta + d
      a = z21-z11
      b = z12-z11
      c = z22-z21-z12+z11
      d = z11

      bilinearintegral = (0.5d0*(a*sumxi + b*sumeta)
     &                     + 0.25d0*c*sumxi*sumeta + d)*area

      return

      end function


c======================================================================
      function bilinearintegral_s(xim,xip,yjm,yjp,x1,x2,y1,y2,dxx,dyy,
     &                                      z11,z12,z21,z22)
c======================================================================

      use geoclaw_module, only: r2d => rad2deg, d2r => deg2rad
      use geoclaw_module, only: Rearth => earth_radius

      implicit none

*     !i/o
      double precision xim,xip,yjm,yjp,x1,x2,y1,y2,dxx,dyy,
     &                                 z11,z12,z21,z22
      double precision bilinearintegral_s

*     !local
      double precision xlo,ylo,xhi,yhi,delx,dely,a,b,c,d
      double precision xdiffhi,xdifflo,ydiffhi,ydifflo,xdiff2
      double precision adsinint,cbsinint

c#######################################################################
c
c         bilinearintegral integrates the bilinear with values z##
c         over the rectangular region xim <= x <= xip, and
c                                     yjm <= y <= yjp
c         integration is actually done on the surface of a sphere

c                                          written by David L George
c                                          Vancouver, WA April 2010
c#######################################################################



*     !integrate the portion of the bilinear intersected with the
c     !rectangular cell analytically.
c     !find limits of integral (this should already be true?)
      xlo = max(xim,x1)
      ylo = max(yjm,y1)
      xhi  = min(xip,x2)
      yhi =  min(yjp,y2)
      delx = xhi - xlo
      dely = yhi - ylo

*     !find terms for the integration
      xdiffhi = xhi - x1
      xdifflo = xlo - x1
      ydiffhi = yhi - y1
      ydifflo = ylo - y1
      xdiff2 = 0.5d0*(xdiffhi**2 - xdifflo**2)

      cbsinint = (r2d*cos(d2r*yhi) + ydiffhi*sin(d2r*yhi))
     &            -(r2d*cos(d2r*ylo) + ydifflo*sin(d2r*ylo))

      adsinint = r2d*(sin(d2r*yhi) - sin(d2r*ylo))


*     !find coefficients of bilinear a*xi + b*eta + c*xi*eta + d
      a = (z21-z11)/dxx
      b = (z12-z11)/dyy
      c = (z22-z21-z12+z11)/(dxx*dyy)
      d = z11

      bilinearintegral_s = ((a*xdiff2 + d*delx)*adsinint
     &            + r2d*(c*xdiff2 + b*delx)*cbsinint)*(Rearth*d2r)**2

      return

      end function

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! Roe-solver for the 2D shallow water equations
! solve Riemann problems along one slice of data.

! waves: 3
! equations: 3

! Conserved quantities:
!       1 depth
!       2 x_momentum
!       3 y_momentum

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.

! On output, wave contains the waves, s the speeds,
! and amdq, apdq the decomposition of the flux difference
!   f(qr(i-1)) - f(ql(i))
! into leftgoing and rightgoing parts respectively.
! With the Roe solver we have
!    amdq  =  A^- \Delta q    and    apdq  =  A^+ \Delta q
! where A is the Roe matrix.  An entropy fix can also be incorporated
! into the flux differences.

! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr


! This Riemann solver differs from the original clawpack Riemann solver
! for the interleaved indices

    implicit double precision (a-h,o-z)

    dimension   ql(meqn,           1-mbc:maxm+mbc)
    dimension   qr(meqn,           1-mbc:maxm+mbc)
    dimension    s(mwaves,         1-mbc:maxm+mbc)
    dimension wave(meqn,   mwaves, 1-mbc:maxm+mbc)
    dimension  apdq(meqn,          1-mbc:maxm+mbc)
    dimension  amdq(meqn,          1-mbc:maxm+mbc)

!   # Gravity constant set in the shallow1D.py or setprob.f90 file
    common /cparam/ grav

!   # Roe averages quantities of each interface
    parameter (maxm2 = 1800)
    double precision u(-6:maxm2+7),v(-6:maxm2+7),a(-6:maxm2+7), &
                     h(-6:maxm2+7)


!   local arrays
!   ------------
    dimension delta(3)
    logical :: efix

    data efix /.true./    !# Use entropy fix for transonic rarefactions

!   # Set mu to point to  the component of the system that corresponds
!   # to momentum in the direction of this slice, mv to the orthogonal
!   # momentum:

    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif


!   # Note that notation for u and v reflects assumption that the
!   # Riemann problems are in the x-direction with u in the normal
!   # direciton and v in the orthogonal direcion, but with the above
!   # definitions of mu and mv the routine also works with ixy=2
!   # and returns, for example, f0 as the Godunov flux g0 for the
!   # Riemann problems u_t + g(u)_y = 0 in the y-direction.


!   # Compute the Roe-averaged variables needed in the Roe solver.

    do 10 i = 2-mbc, mx+mbc
        h(i) = (qr(1,i-1)+ql(1,i))*0.50d0
        hsqrtl = dsqrt(qr(1,i-1))
        hsqrtr = dsqrt(ql(1,i))
        hsq2 = hsqrtl + hsqrtr
        u(i) = (qr(mu,i-1)/hsqrtl + ql(mu,i)/hsqrtr) / hsq2
        v(i) = (qr(mv,i-1)/hsqrtl + ql(mv,i)/hsqrtr) / hsq2
        a(i) = dsqrt(grav*h(i))
    10 END DO


!   # now split the jump in q at each interface into waves

!   # find a1 thru a3, the coefficients of the 3 eigenvectors:
    do 20 i = 2-mbc, mx+mbc
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(mu,i) - qr(mu,i-1)
        delta(3) = ql(mv,i) - qr(mv,i-1)
        a1 = ((u(i)+a(i))*delta(1) - delta(2))*(0.50d0/a(i))
        a2 = -v(i)*delta(1) + delta(3)
        a3 = (-(u(i)-a(i))*delta(1) + delta(2))*(0.50d0/a(i))
    
!      # Compute the waves.
    
        wave(1,1,i) = a1
        wave(mu,1,i) = a1*(u(i)-a(i))
        wave(mv,1,i) = a1*v(i)
        s(1,i) = u(i)-a(i)
    
        wave(1,2,i) = 0.0d0
        wave(mu,2,i) = 0.0d0
        wave(mv,2,i) = a2
        s(2,i) = u(i)
    
        wave(1,3,i) = a3
        wave(mu,3,i) = a3*(u(i)+a(i))
        wave(mv,3,i) = a3*v(i)
        s(3,i) = u(i)+a(i)
    20 END DO


!    # compute flux differences amdq and apdq.
!    ---------------------------------------

    if (efix) go to 110

!     # no entropy fix
!     ----------------

!     # amdq = SUM s*wave   over left-going waves
!     # apdq = SUM s*wave   over right-going waves

    do m=1,3
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1,mwaves
                if (s(mw,i) < 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                else
                    apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                endif
            end do
        end do
    end do
    go to 900

!-----------------------------------------------------

    110 continue

!     # With entropy fix
!     ------------------

!    # compute flux differences amdq and apdq.
!    # First compute amdq as sum of s*wave for left going waves.
!    # Incorporate entropy fix by adding a modified fraction of wave
!    # if s should change sign.

    do 200 i=2-mbc,mx+mbc
!       # check 1-wave
        him1 = qr(1,i-1)
        s0 =  qr(mu,i-1)/him1 - dsqrt(grav*him1)
!       # check for fully supersonic case :
        if (s0 > 0.0d0 .AND. s(1,i) > 0.0d0) then
            do 60 m=1,3
                amdq(m,i)=0.0d0
            60 END DO
            goto 200
        endif
    
        h1 = qr(1,i-1)+wave(1,1,i)
        hu1= qr(mu,i-1)+wave(mu,1,i)
        s1 = hu1/h1 - dsqrt(grav*h1) !speed just to right of 1-wave
        if (s0 < 0.0d0 .AND. s1 > 0.0d0) then
!           # transonic rarefaction in 1-wave
            sfract = s0*((s1-s(1,i))/(s1-s0))
        else if (s(1,i) < 0.0d0) then
!           # 1-wave is leftgoing
            sfract = s(1,i)
        else
!           # 1-wave is rightgoing
            sfract = 0.0d0
        endif
        do 120 m=1,3
            amdq(m,i) = sfract*wave(m,1,i)
        120 END DO

!       # check 2-wave
        if (s(2,i) > 0.0d0) then
!           # 2 and 3 waves are right-going
            go to 200
        endif

        do 140 m=1,3
            amdq(m,i) = amdq(m,i) + s(2,i)*wave(m,2,i)
        140 END DO
    
!       check 3-wave
    
        hi = ql(1,i)
        s03 = ql(mu,i)/hi + dsqrt(grav*hi)
        h3=ql(1,i)-wave(1,3,i)
        hu3=ql(mu,i)-wave(mu,3,i)
        s3=hu3/h3 + dsqrt(grav*h3)
        if (s3 < 0.0d0 .AND. s03 > 0.0d0) then
!           # transonic rarefaction in 3-wave
            sfract = s3*((s03-s(3,i))/(s03-s3))
        else if (s(3,i) < 0.0d0) then
!           # 3-wave is leftgoing
            sfract = s(3,i)
        else
!           # 3-wave is rightgoing
            goto 200
        endif
        do 160 m=1,3
            amdq(m,i) = amdq(m,i) + sfract*wave(m,3,i)
        160 END DO
    200 END DO

!   compute rightgoing flux differences :

    do m=1,3
        do i = 2-mbc,mx+mbc
            df = 0.0d0
            do mw=1,mwaves
                df = df + s(mw,i)*wave(m,mw,i)
            end do
            apdq(m,i)=df-amdq(m,i)
        end do
    end do


    900 continue
    return
    end subroutine rpn2

c
c-------------------------------------------------------------------------------------
c
       subroutine prepregstep(nvar,naux,lcheck,mptr,nx,ny,mitot,mjtot,
     .                        valbig,auxbig)

       use amr_module
       implicit double precision (a-h,o-z)

       dimension fp(nvar,mitot,mjtot),gp(nvar,mitot,mjtot)
       dimension fm(nvar,mitot,mjtot),gm(nvar,mitot,mjtot)


       hx   = hxposs(lcheck)
       hy   = hyposs(lcheck)
       dt     = possk(lcheck)
       time   = rnode(timemult,mptr)

       xlow   = rnode(cornxlo,mptr) - nghost*hx
       ylow   = rnode(cornylo,mptr) - nghost*hy

c
       call stepgrid(valbig,fm,fp,gm,gp,
     1               mitot,mjtot,nghost,
     2               dt,dtnew,hx,hy,nvar,
     3               xlow,ylow,time,mptr,naux,auxbig)
c
c     update counts for error estimation step
       evol   = evol + nx * ny

       return
       end

! ============================================================================
!  Reimann Solver for the two-layer shallow water equations
! ============================================================================
!
! Parameter Specification
! waves:     4
! equations: 4

! Conserved quantities:
!       1 depth_1
!       2 momentum_1
!       3 depth_2
!       4 momentum_2

! Auxiliary variables:
!       1 bathymetry
!       2 wind
!       3 h_hat_1
!       4 h_hat_2
!       5 kappa


subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)

    implicit none
    
    ! Input arguments
    integer, intent(in) :: maxmx,meqn,mwaves,mbc,mx,maux
    
    double precision, intent(in), dimension(meqn, 1-mbc:maxmx+mbc) :: ql,qr
    double precision, intent(in), dimension(maux, 1-mbc:maxmx+mbc) :: auxl,auxr
    
    ! Output arguments
    double precision, intent(out) :: s(mwaves, 1-mbc:maxmx+mbc)
    double precision, intent(out) :: fwave(meqn, mwaves, 1-mbc:maxmx+mbc)
    double precision, intent(out), dimension(meqn, 1-mbc:maxmx+mbc) :: amdq,apdq
    
    ! Local storage
    integer :: i,j,m,mw
    double precision :: eig_vec(4,4),delta(4),alpha(4),beta(4)
    double precision, dimension(4) :: flux_l,flux_r
    double precision, dimension(2) :: h_l,u_l,hu_l,h_r,u_r,hu_r,h_ave,u_ave
    double precision :: b_l,b_r,gamma_l,gamma_r,tau,w_l,w_r
    double precision :: wind_speed,lambda(4),eta_l(2),eta_r(2),h_hat_l(2),h_hat_r(2)
    logical :: dry_state_l(2), dry_state_r(2), inundation
    
    integer :: layer_index
    double precision :: momentum_transfer(2),flux_transfer_r,flux_transfer_l
    double precision :: inundation_height(2),lambda_l,lambda_r,lambda_hat

    integer :: trans_wave(2-mbc:mx+mbc)
    double precision :: wave_correction(2-mbc:mx+mbc)
    
    logical :: stop_computation

    ! Function interfaces
    interface
        function eval_lapack_solve(eig_vec,delta) result(beta)
            implicit none
            double precision, intent(in) :: eig_vec(4,4), delta(4)
            double precision :: beta(4)
        end function eval_lapack_solve
    end interface
    interface
        double precision function wind_drag(wind_speed)
            implicit none
            double precision, intent(in) :: wind_speed
        end function wind_drag
    end interface
    

    ! Common blocks
    double precision :: rho(2),rho_air,g,r,one_minus_r
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix
    
    common /cparam/ rho,rho_air,g,r,one_minus_r, &
                    dry_tolerance,eigen_method,inundation_method,entropy_fix

    ! Initialize return variables
    amdq = 0.d0
    apdq = 0.d0

    !          |          |          
    !          |          |          
    !          |          |          
    !----------|----------|----------
    !    i-1         i         i+1
    !  qr(i-1)  ql(i)
    !     Riemann problem at i-1/2 is between qr(i-1) (left state) and ql(i) 
    !     (right state)
    do i=2-mbc,mx+mbc
        inundation = .false.
        dry_state_l = .false.
        dry_state_r = .false.
        
        ! These state variables are the actual depth and momenta
        do j=1,2
            layer_index = 2*(j-1)
            h_l(j) = qr(layer_index+1,i-1) / rho(j)
            h_r(j) = ql(layer_index+1,i) / rho(j)
            hu_l(j) = qr(layer_index+2,i-1) / rho(j)
            hu_r(j) = ql(layer_index+2,i) / rho(j)
            
            h_hat_l(j) = auxr(j+2,i-1)
            h_hat_r(j) = auxl(j+2,i)
            
            ! Check for dry states in this layer
            if (h_l(j) < dry_tolerance) then
                dry_state_l(j) = .true.
                h_l(j) = 0.d0
                u_l(j) = 0.d0
            else
                u_l(j) = qr(layer_index+2,i-1) / qr(layer_index+1,i-1)
            endif
            if (h_r(j) < dry_tolerance) then
                dry_state_r(j) = .true.
                h_r(j) = 0.d0
                u_r(j) = 0.d0
            else
                u_r(j) = ql(layer_index+2,i) / ql(layer_index+1,i)
            endif
        enddo
        
        h_ave = 0.5d0 * (h_l(:) + h_r(:))
        
        b_l = auxr(1,i-1)
        b_r = auxl(1,i)
        w_l = auxr(2,i-1)
        w_r = auxl(2,i)      
            
        ! ====================================================================
        ! Solve Single layer problem seperately
        if (dry_state_r(2).and.dry_state_l(2)) then
            call single_layer_eigen(h_l,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
            s(:,i) = lambda
            
            delta(1) = rho(1) * (hu_r(1) - hu_l(1))
            flux_r(2) = rho(1) * (h_r(1) * u_r(1)**2 + 0.5d0 * g * h_r(1)**2)
            flux_l(2) = rho(1) * (h_l(1) * u_l(1)**2 + 0.5d0 * g * h_l(1)**2)
            delta(2) = flux_r(2) - flux_l(2) + g * rho(1) * h_ave(1) * (b_r - b_l)
            
            beta(1) = (delta(1)*s(4,i)-delta(2)) / (s(4,i)-s(1,i))
            beta(2) = 0.d0
            beta(3) = 0.d0
            beta(4) = (delta(2) - s(1,i)*beta(1)) / s(4,i)
            
            ! Calculate waves
            forall(mw=1:4)
                fwave(:,mw,i) = eig_vec(:,mw) * beta(mw)
            end forall
            cycle
        endif
        
        ! ====================================================================
        ! Calculate eigen-space values
        ! ====================================================================
        
        ! ====================================================================
        ! Inundation cases
        if (dry_state_r(2).and.(.not.dry_state_l(2)).and.(h_l(2) + b_l > b_r)) then
            ! print *,"Right inundation problem at i=",i
            inundation = .true.
            if (inundation_method == 0) then
                stop "Inundation not allowed."
            else if (inundation_method == 1) then
                ! Linear eigensystem
                inundation_height = [h_r(1),0.d0]
                call linear_eigen(h_l,inundation_height,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
                
                ! Corrective wave
                s(3,i) = u_l(2) + 2.d0 * sqrt(g*(1.d0-r)*h_l(2))
                s(4,i) = u_r(1) + sqrt(g*h_r(1))
                alpha(3) = r * g * h_l(2) / ((s(3,i) - u_l(2))**2 - g * h_l(2))
                alpha(4) = 0.d0

                eig_vec(1,3:4) = 1.d0
                eig_vec(2,3:4) = s(3:4,i)
                eig_vec(3,3:4) = alpha(3:4)
                eig_vec(4,3:4) = s(3:4,i)*alpha(3:4)
            else if (inundation_method == 2) then
                inundation_height = [h_r(1),dry_tolerance]
                h_r(2) = dry_tolerance
                call linear_eigen(h_l,inundation_height,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
                
!                 s(4,i) = u_r(1) + sqrt(g*h_r(1))
!                 eig_vec(:,4) = [1.d0,s(4,i),0.d0,0.d0]
            else if (inundation_method == 3) then
                inundation_height = [h_r(1),dry_tolerance]
                call velocity_eigen(h_l,inundation_height,u_l,u_r,b_l,b_r,lambda,eig_vec)
                s(:,i) = lambda
                
                ! Correction for fast wave
                s(4,i) = u_r(1) + sqrt(g*h_r(1))
                eig_vec(:,4) = [1.d0,s(4,i),0.d0,0.d0]
            else if (inundation_method == 4) then
                inundation_height = [h_r(1),dry_tolerance]
                call lapack_eigen(h_l,inundation_height,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
                
                ! Correction for the fast waves
                s(2,i) = u_r(1) + sqrt(g*h_r(1))
                eig_vec(:,2) = [1.d0,s(2,i),0.d0,0.d0]
            else if (inundation_method == 5) then
                inundation_height = [h_r(1),0.d0]
                call lapack_eigen(h_l,inundation_height,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda                
            endif   
        else if (dry_state_l(2).and.(.not.dry_state_r(2)).and.(h_r(2) + b_r > b_l)) then
            ! print *,"Left inundation problem at i=",i
            inundation = .true.
            ! Inundation problem eigen
            if (inundation_method == 0) then
                stop "Inundation not allowed."
            else if (inundation_method == 1) then
                ! Linear eigensystem
                inundation_height = [h_l(1),dry_tolerance]
                call linear_eigen(inundation_height,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda

                ! Corrections to internal wave
                s(2,i) = u_r(2) - 2.d0 * sqrt(g*(1.d0-r)*h_r(2))
                alpha(2) = r * g * h_r(2) / ((s(2,i) - u_r(2))**2 - g * h_r(2))
                eig_vec(:,2) = [1.d0,s(2,i),alpha(2),alpha(2)*s(2,i)]
                
                ! Correction for the fast waves
                s(1,i) = u_l(1) - sqrt(g*h_l(1))
                eig_vec(:,1) = [1.d0,s(1,i),0.d0,0.d0]
            else if (inundation_method == 2) then
                ! Use linearized eigensystem
                inundation_height = [h_l(1),dry_tolerance]
                call linear_eigen(inundation_height,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
                            
                ! Correction for the fast waves
                s(1,i) = u_l(1) - sqrt(g*h_l(1))
                eig_vec(:,1) = [1.d0,s(1,i),0.d0,0.d0]
            else if (inundation_method == 3) then
                ! Use velocity difference expansion eigensystems
                inundation_height = [h_l(1),dry_tolerance]
                call velocity_eigen(inundation_height,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda                
        
                ! Correction for the fast waves
                s(1,i) = u_r(1) - sqrt(g*h_r(1))
                eig_vec(:,1) = [1.d0,s(1,i),0.d0,0.d0]
            else if (inundation_method == 4) then
                ! LAPACK solver with corrective wave and small wet layer
                inundation_height = [h_r(1),dry_tolerance]
                call lapack_eigen(h_l,inundation_height,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
                            
                ! Correction for the fast waves
                s(1,i) = u_l(1) - sqrt(g*h_l(1))
                eig_vec(:,1) = [1.d0,s(1,i),0.d0,0.d0]
            else if (inundation_method == 5) then
                ! Use the LAPACK solver with no correction
                inundation_height = [h_l(1),0.d0]
                call lapack_eigen(inundation_height,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
            endif        
          
        ! ====================================================================  
        !  Wall or wet case       
        else
            ! Wall dry state or completely wet case
            if (eigen_method == 1) then
                call linear_eigen(h_hat_l,h_hat_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
            else if (eigen_method == 2) then
                call linear_eigen(h_l,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
            else if (eigen_method == 3) then 
                call velocity_eigen(h_l,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                s(:,i) = lambda
            else if (eigen_method == 4) then
                if (dry_state_r(2).and.(.not.dry_state_l(2)).or. &
                        dry_state_l(2).and.(.not.dry_state_r(2))) then
                    call linear_eigen(h_l,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                    s(:,i) = lambda
                else
                    call lapack_eigen(h_l,h_r,u_l,u_r,b_l,b_r, &
                              &     trans_wave(i),wave_correction(i),lambda,eig_vec)
                    s(:,i) = lambda
                endif
            else
                stop "Invalid eigensystem method requested, method = (1,4)."
            endif
        endif
        
        !  end of eigenspace calculation
        ! ====================================================================
        
        ! ====================================================================
        ! Calculate flux vector to be projected onto e-space
        ! Calculate jumps in fluxes
        if (dry_state_r(2).and.(.not.dry_state_l(2)).and.(.not.inundation)) then
            ! Wall boundary conditions
            h_r(2) = h_l(2)
            hu_r(2) = -hu_l(2)
            u_r(2) = -u_l(2)
            
            ! Top layer eta(2) = b_r - h_l(2) - b_l
            momentum_transfer(1) = g * rho(1) * h_ave(1) * (b_r - h_l(2) - b_l)
            
            momentum_transfer(2) = 0.d0
            flux_transfer_r = 0.d0
            flux_transfer_l = 0.d0
        ! Left state dry, right wet
        else if (dry_state_l(2).and.(.not.dry_state_r(2)).and.(.not.inundation)) then
            ! Wall boundary conditions
            h_l(2) = h_r(2)
            hu_l(2) = -hu_r(2)
            u_l(2) = -u_r(2)
            
            ! Top layer eta(2) = h_r(2) + b_r - b_l
            momentum_transfer(1) = g * rho(1) * h_ave(1) * (b_r + h_r(2) - b_l)
            
            momentum_transfer(2) = 0.d0
            flux_transfer_r = 0.d0
            flux_transfer_l = 0.d0
        ! Fully wet bottom layer or inundation
        else
            momentum_transfer(1) =   g * rho(1) * h_ave(1) * (h_r(2) - h_l(2) + b_r - b_l)
            momentum_transfer(2) = - g * rho(1) * h_ave(1) * (h_r(2) - h_l(2)) + g * rho(2) * h_ave(2) * (b_r - b_l)
            ! Bottom layer momentum transfer flux
            flux_transfer_r = g * rho(1) * product(h_r)
            flux_transfer_l = g * rho(1) * product(h_l)
        endif
        
        ! Flux jumps
        do j=1,2
            layer_index = 2*(j-1)
            flux_r(layer_index+1) = rho(j) * hu_r(j)
            flux_r(layer_index+2) = rho(j) * (h_r(j) * u_r(j)**2 + 0.5d0 * g * h_r(j)**2)
            
            flux_l(layer_index+1) = rho(j) * hu_l(j)
            flux_l(layer_index+2) = rho(j) * (h_l(j) * u_l(j)**2 + 0.5d0 * g * h_l(j)**2)
        enddo
        
        delta = flux_r - flux_l

        ! Bottom layer additional flux
        delta(4) = delta(4) + flux_transfer_r - flux_transfer_l

        ! Momentum source term from layers
        delta(2) = delta(2) + momentum_transfer(1)
        delta(4) = delta(4) + momentum_transfer(2)
        
        ! Wind forcing
        wind_speed = 0.5d0 * (w_l + w_r)
        tau = wind_drag(wind_speed) * rho_air * wind_speed
        delta(2) = delta(2) - tau * wind_speed

        ! ====================================================================
        ! Solve system, solution is stored in delta
        beta = eval_lapack_solve(eig_vec,delta)
        
        ! Calculate waves
        forall(mw=1:4)
            fwave(:,mw,i) = eig_vec(:,mw) * beta(mw)
        end forall
    enddo
    
    ! Calculate amdq and apdq
    ! No entropy fix requested
    if (.not.entropy_fix) then
        stop_computation = .false.
        do i=2-mbc,mx+mbc
            do mw=1,mwaves
                if (s(mw,i) > 0.d0) then
                    apdq(:,i) = apdq(:,i) + fwave(:,mw,i)
                else                                     
                    amdq(:,i) = amdq(:,i) + fwave(:,mw,i)
                endif
            enddo
        enddo
    else
        do i=2-mbc,mx+mbc
            ! Check to see if an entropy fix is necessary
            if (trans_wave(i) /= 0) then
                print *,"Entropy fix needed: i=",i
                print *,"  s(:,i)=",(s(m,i),m=1,4)
                print *,"  trans_wave=",trans_wave(i)
                print *,"  beta =",wave_correction(i)
                do mw=1,trans_wave(i)-1
                    amdq(:,i) = amdq(:,i) + fwave(:,mw,i)
                enddo
                amdq(:,i) = amdq(:,i) + wave_correction(i) * fwave(:,trans_wave(i),i)
                apdq(:,i) = apdq(:,i) + (1.d0 - wave_correction(i)) * fwave(:,trans_wave(i),i)
                do mw=trans_wave(i)+1,mwaves
                    apdq(:,i) = apdq(:,i) + fwave(:,mw,i)
                enddo
            else
                ! No entropy fix needed                
                do mw=1,mwaves
                    if (s(mw,i) > 0.d0) then
                        apdq(:,i) = apdq(:,i) + fwave(:,mw,i)
                    else                                     
                        amdq(:,i) = amdq(:,i) + fwave(:,mw,i)
                    endif
                enddo
            endif
        enddo
    endif
end subroutine rp1
! ============================================================================



! ============================================================================
!  Eigenvalue routines
! ============================================================================

! ============================================================================
!  Eigenspace reconstruction using linear approximation
subroutine linear_eigen(h_l,h_r,u_l,u_r,b_l,b_r,            &
                         &  transonic_wave,wave_correction,s,eig_vec)

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    
    integer, intent(inout) :: transonic_wave
    double precision, intent(inout) :: wave_correction
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    
    ! Locals
    integer :: mw
    double precision :: alpha(4),speeds(4,2),gamma_l,gamma_r
    double precision :: h_ave(2),u_ave(2)
    double precision :: s_l(4),s_r(4),s_ave(4),work_vec(4,4)

    ! Common blocks
    double precision :: rho(2),rho_air,g,r,one_minus_r
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix
    
    common /cparam/ rho,rho_air,g,r,one_minus_r, &
                    dry_tolerance,eigen_method,inundation_method,entropy_fix
        
    gamma_l = h_l(2) / h_l(1)
    gamma_r = h_r(2) / h_r(1)

    ! Left state alphas
    alpha(1) = 0.5d0*(gamma_l-1.d0+sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
    alpha(2) = 0.5d0*(gamma_l-1.d0-sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
    ! Right state alphas
    alpha(3) = 0.5d0*(gamma_r-1.d0-sqrt((gamma_r-1.d0)**2+4.d0*r*gamma_r))
    alpha(4) = 0.5d0*(gamma_r-1.d0+sqrt((gamma_r-1.d0)**2+4.d0*r*gamma_r))

    ! These are calculated seperately due to entropy corrections
    ! Left state speeds
    speeds(1,1) = u_l(1) - sqrt(g*h_l(1)*(1+alpha(1)))
    speeds(2,1) = u_l(2) - sqrt(g*h_l(1)*(1+alpha(2)))
    speeds(3,1) = u_l(2) + sqrt(g*h_l(1)*(1+alpha(2)))
    speeds(4,1) = u_l(1) + sqrt(g*h_l(1)*(1+alpha(1)))

    ! Right state speeds
    speeds(1,2) = u_r(1) - sqrt(g*h_r(1)*(1+alpha(4)))
    speeds(2,2) = u_r(2) - sqrt(g*h_r(1)*(1+alpha(3)))
    speeds(3,2) = u_r(2) + sqrt(g*h_r(1)*(1+alpha(3)))
    speeds(4,2) = u_r(1) + sqrt(g*h_r(1)*(1+alpha(4)))

    ! Determine wave speeds
    transonic_wave = 0
    wave_correction = 0.d0
    if (entropy_fix) then
        transonic_wave = 0
        wave_correction = 0.d0
        do mw=1,4
            ! Both speeds right going
            if (speeds(mw,1) > 0.d0) then
                s(mw) = speeds(mw,2)
            ! Transonic rarefaction
            ! s_l < 0.0 < s_r
            else if (speeds(mw,2) > 0.d0) then
                ! Assign base speed for rarefaction, should approximate true speed
                s(mw) = 0.5d0 * sum(speeds(mw,:))
                transonic_wave = mw
                wave_correction = abs(speeds(mw,1)) / (abs(speeds(mw,1)) + abs(speeds(mw,2)))
            else
                s(mw) = speeds(mw,1)
            endif
        enddo
    else
        s(:) = [speeds(1,1),speeds(2,1),speeds(3,2),speeds(4,2)]
    endif

    eig_vec(1,:) = 1.d0
    eig_vec(2,:) = s(:)
    eig_vec(3,:) = alpha
    eig_vec(4,:) = s(:)*alpha(:)

end subroutine linear_eigen
! ============================================================================


! ============================================================================
!  Eigenspace reconstruction using the velocity difference expansion
subroutine velocity_eigen(h_l,h_r,u_l,u_r,b_l,b_r,            &
                         &  transonic_wave,wave_correction,s,eig_vec)

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    
    integer, intent(inout) :: transonic_wave
    double precision, intent(inout) :: wave_correction
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    ! Locals
    double precision :: total_depth_l,total_depth_r,mult_depth_l,mult_depth_r
    double precision :: alpha(4)

    ! Common blocks
    double precision :: rho(2),rho_air,g,r,one_minus_r
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix
    
    common /cparam/ rho,rho_air,g,r,one_minus_r, &
                    dry_tolerance,eigen_method,inundation_method,entropy_fix
    
    total_depth_l = sum(h_l)
    total_depth_r = sum(h_r)
    mult_depth_l = product(h_l)
    mult_depth_r = product(h_r)

    s(1) = (h_l(1)*u_l(1)+h_l(2)*u_l(2)) / total_depth_l &
          - sqrt(g*total_depth_l)
    s(2) = (h_l(2)*u_l(1)+h_l(1)*u_l(2)) / total_depth_l &
          - sqrt(g*one_minus_r*mult_depth_l/total_depth_l &
          * (1-(u_l(1)-u_l(2))**2/(g*one_minus_r*total_depth_l)))
    s(3) = (h_r(2)*u_r(1)+h_r(1)*u_r(2)) / total_depth_r &
          + sqrt(g*one_minus_r*mult_depth_r/total_depth_r &
          * (1-(u_r(1)-u_r(2))**2/(g*one_minus_r*total_depth_r)))
    s(4) = (h_r(1)*u_r(1)+h_r(2)*u_r(2)) / total_depth_r &
            + sqrt(g*total_depth_r)

    ! Determine wave speeds
    transonic_wave = 0
    wave_correction = 0.d0

    alpha(1:2) = ((s(1:2) - u_l(1))**2 - g * h_l(1)) / (g*h_l(1))
    alpha(3:4) = ((s(3:4) - u_r(1))**2 - g * h_r(1)) / (g*h_r(1))

    eig_vec(1,:) = 1.d0
    eig_vec(2,:) = s(:)
    eig_vec(3,:) = alpha
    eig_vec(4,:) = s(:)*alpha(:)

end subroutine velocity_eigen
! ============================================================================


! ============================================================================
!  Eigenspace reconstruction using LAPACK
subroutine lapack_eigen(h_l,h_r,u_l,u_r,b_l,b_r,            &
                         &  transonic_wave,wave_correction,s,eig_vec)

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    
    integer, intent(inout) :: transonic_wave
    double precision, intent(inout) :: wave_correction
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    
    ! Local
    integer :: j
    double precision :: h_ave(2),u_ave(2)
    double precision :: s_l(4),s_r(4),vec_work(4,4)

    ! Common blocks
    double precision :: rho(2),rho_air,g,r,one_minus_r
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix
    
    common /cparam/ rho,rho_air,g,r,one_minus_r, &
                    dry_tolerance,eigen_method,inundation_method,entropy_fix
    
    ! Solve eigenvalue problem
    h_ave(:) = 0.5d0 * (h_l(:) + h_r(:))
    u_ave(:) = 0.5d0 * (u_l(:) + u_r(:))
    call eval_lapack_eigen(h_ave,u_ave,s,eig_vec)
    
    transonic_wave = 0
    wave_correction = 0.d0
    
    if (entropy_fix) then
        ! Check to see if we may be at a transonic rarefaction
        call eval_lapack_eigen(h_l,u_l,s_l,vec_work)        
        call eval_lapack_eigen(h_r,u_r,s_r,vec_work)
        
        ! Check each wave for a transonic problem
        do j=1,4
            if (s_l(j) < 0.d0 .and. 0.d0 < s_r(j)) then
                print *,"Transonic wave detected in wave family ",j,"."
                transonic_wave = j
                wave_correction = (s_l(j) - s(j)) / (s_l(j) - s_r(j))
            endif
        enddo
    endif
    
end subroutine lapack_eigen
! ============================================================================


! ============================================================================
! Single layer eigenspace reconstruction
subroutine single_layer_eigen(h_l,h_r,u_l,u_r,b_l,b_r,            &
                         &  transonic_wave,wave_correction,s,eig_vec)

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    
    integer, intent(inout) :: transonic_wave
    double precision, intent(inout) :: wave_correction
    double precision, intent(inout) :: s(4),eig_vec(4,4)

    ! Common blocks
    double precision :: rho(2),rho_air,g,r,one_minus_r
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix
    
    common /cparam/ rho,rho_air,g,r,one_minus_r, &
                    dry_tolerance,eigen_method,inundation_method,entropy_fix
    
    transonic_wave = 0
    wave_correction = 0.d0
    
    s(1) = u_l(1) - sqrt(g*h_l(1))
    s(2) = 0.d0
    s(3) = 0.d0
    s(4) = u_r(1) + sqrt(g*h_r(1))
    
    eig_vec(1,:) = 1.d0
    eig_vec(2,:) = s(:)
    eig_vec(3,:) = 0.d0
    eig_vec(4,:) = 0.d0

end subroutine single_layer_eigen
! ============================================================================




! ============================================================================
!  Helper routines
! ============================================================================

! ============================================================================
!  Evaluate eigenvalues using LAPACK's DGEEV function
subroutine eval_lapack_eigen(h,u,lambda,vec)

    implicit none
    double precision, intent(in) :: h(2),u(2)
    double precision, intent(inout) :: lambda(4),vec(4,4)
    
    integer, parameter :: lwork = 16
    integer :: info
    double precision :: A(4,4),real_lambda(4),imaginary_lambda(4)
    double precision :: empty,work(1,lwork)

    ! Common blocks
    double precision :: rho(2),rho_air,g,r,one_minus_r
    double precision :: dry_tolerance
    integer :: eigen_method,inundation_method
    logical :: entropy_fix
    
    common /cparam/ rho,rho_air,g,r,one_minus_r, &
                    dry_tolerance,eigen_method,inundation_method,entropy_fix

    ! Quasi-linear matrix
    A(1,:) = [0.d0,1.d0,0.d0,0.d0]
    A(2,:) = [-u(1)**2 + g*h(1),2.d0*u(1),g*h(1),0.d0]
    A(3,:) = [0.d0,0.d0,0.d0,1.d0]
    A(4,:) = [g*r*h(2),0.d0,-u(2)**2 + g*h(2),2.d0*u(2)]
    
    ! Call LAPACK eigen solver
    call dgeev('N','V',4,A,4,lambda,imaginary_lambda,empty,1,vec,4,work,lwork,info)
    if (info < 0) then
        info = -info
        print "(a,i1,a)","The ",info,"th argument had an illegal value."
        stop
    else if (info > 0) then
        print "(a)","The QR algorithm failed to compute all the"
        print "(a)","eigenvalues, and no eigenvectors have been"
        print "(a,i1,a)","computed; elements",info,"+1:4 of WR and WI"
        print "(a)","contain eigenvalues which have converged."
        stop
    endif
    ! Only need to check if there is a positive imaginary eigenvalue as they 
    ! should come in pairs
    if (any(imaginary_lambda > 0.d0)) then
        print "(a,4d16.8)","Imaginary eigenvalues computed: ",imaginary_lambda
        stop
    endif

end subroutine eval_lapack_eigen
! ============================================================================

! ============================================================================
!  Solve R beta = delta using LAPACK's DGESV function
function eval_lapack_solve(eig_vec,delta) result(beta)

    implicit none

    ! Matrix and RHS
    double precision, intent(in) :: eig_vec(4,4), delta(4)
    
    ! Output
    double precision :: beta(4)
    
    ! Local storage
    double precision :: R(4,4)
    integer :: ipiv(4),info,i,m

    ! Move input data into work arrays
    R = eig_vec
    beta = delta

    ! Call LAPACK dense linear solver
    call dgesv(4,1,R,4,ipiv,beta,4,info)
    if (.not.(info == 0)) then 
        print *, "Error solving R beta = delta, ",info
        print *, "  R=",(eig_vec(1,m),m=1,4)
        do i=2,4
            print *, "    ",(eig_vec(i,m),m=1,4)
        enddo
        print *, "  delta=",(delta(m),m=1,4)
        stop
    endif

end function eval_lapack_solve
! ============================================================================

! ============================================================================
!  Calculate wind drag coefficient
double precision function wind_drag(wind_speed)
    
    implicit none
        
    ! Input
    double precision, intent(in) :: wind_speed
        
    if (wind_speed <= 11.d0) then
        wind_drag = 1.2d0
    else if ((wind_speed > 11.d0).and.(wind_speed <= 25.d0)) then
        wind_drag = 0.49d0 + 0.065d0 * wind_speed
    else
        wind_drag = 0.49 + 0.065d0 * 25.d0
    endif
        
    wind_drag = wind_drag * 10.d-3
    
end function wind_drag

c
c =======================================================================
      subroutine outval(val,nvar,mitot,mptr,outgrd,naux,aux)
c =======================================================================
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension  val(nvar,mitot)
      dimension  aux(naux,mitot)
      logical    outgrd


c ::::::::::::::::::::::OUTVAL :::::::::::::::::::::::::::::::
c print solution and aux. variables to output. 
c if cell outside domain, don't print soln. value - nothing
c currently in ghost cells.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      if (.not. outgrd) go to 99
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      cornx = rnode(cornxlo,mptr) -  nghost*hx
c
      do 20 i=nghost+1,mitot-nghost

          x  = cornx + hx*(dble(i)-.5d0)
          write(outunit,107) x,i,(val(ivar,i),ivar=1,nvar)
 107      format(2hx=,f6.3,3h,i=,i3,' a=',e25.15)
c    *           5(e9.3,1x))
          if (naux.gt.0) write(outunit,108) (aux(iaux,i),iaux=1,naux)
 108      format(1x,'aux = ',7(e9.3,1x))

 20   continue

 99   return
      end

      subroutine i4vec_copy ( n, a1, a2 )

c*********************************************************************72
c
cc I4VEC_COPY copies an I4VEC.
c
c  Discussion:
c
c    An I4VEC is a vector of I4's.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    02 January 2007
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the length of the vectors.
c
c    Input, integer A1(N), the vector to be copied.
c
c    Output, integer A2(N), a copy of A1.
c
      implicit none

      integer n

      integer a1(n)
      integer a2(n)
      integer i

      do i = 1, n
        a2(i) = a1(i)
      end do

      return
      end
      subroutine i4vec_dec ( n, x )

c*********************************************************************72
c
cc I4VEC_DEC decrements an I4VEC.
c
c  Discussion:
c
c    An I4VEC is a vector of I4's.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    18 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the size of the array.
c
c    Input/output, integer X(N), the array to be decremented.
c
      implicit none

      integer n

      integer i
      integer x(n)

      do i = 1, n
        x(i) = x(i) - 1
      end do

      return
      end
      subroutine i4vec_inc ( n, x )

c*********************************************************************72
c
cc I4VEC_INC increments an I4VEC.
c
c  Discussion:
c
c    An I4VEC is a vector of I4's.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    18 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the size of the array.
c
c    Input/output, integer X(N), the array to be incremented.
c
      implicit none

      integer n

      integer i
      integer x(n)

      do i = 1, n
        x(i) = x(i) + 1
      end do

      return
      end
      subroutine i4vec2_compare ( n, a1, a2, i, j, isgn )

c*********************************************************************72
c
cc I4VEC2_COMPARE compares pairs of integers stored in two vectors.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    03 June 2009
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of data items.
c
c    Input, integer A1(N), A2(N), contain the two components
c    of each item.
c
c    Input, integer I, J, the items to be compared.
c
c    Output, integer ISGN, the results of the comparison:
c    -1, item I .lt. item J,
c     0, item I = item J,
c    +1, item J .lt. item I.
c
      implicit none

      integer n

      integer a1(n)
      integer a2(n)
      integer i
      integer isgn
      integer j

      isgn = 0

           if ( a1(i) .lt. a1(j) ) then

        isgn = -1

      else if ( a1(i) .eq. a1(j) ) then

             if ( a2(i) .lt. a2(j) ) then
          isgn = -1
        else if ( a2(i) .lt. a2(j) ) then
          isgn = 0
        else if ( a2(j) .lt. a2(i) ) then
          isgn = +1
        end if

      else if ( a1(j) .lt. a1(i) ) then

        isgn = +1

      end if

      return
      end
      subroutine i4vec2_sort_a ( n, a1, a2 )

c*********************************************************************72
c
cc I4VEC2_SORT_A ascending sorts a vector of pairs of integers.
c
c  Discussion:
c
c    Each item to be sorted is a pair of integers (I,J), with the I
c    and J values stored in separate vectors A1 and A2.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    03 June 2009
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of items of data.
c
c    Input/output, integer A1(N), A2(N), the data to be sorted.
c
      implicit none

      integer n

      integer a1(n)
      integer a2(n)
      integer i
      integer indx
      integer isgn
      integer j
      integer temp

      if ( n .le. 1 ) then
        return
      end if
c
c  Initialize.
c
      i = 0
      indx = 0
      isgn = 0
      j = 0
c
c  Call the external heap sorter.
c
10    continue

        call sort_heap_external ( n, indx, i, j, isgn )
c
c  Interchange the I and J objects.
c
        if ( 0 .lt. indx ) then

          temp  = a1(i)
          a1(i) = a1(j)
          a1(j) = temp

          temp  = a2(i)
          a2(i) = a2(j)
          a2(j) = temp
c
c  Compare the I and J objects.
c
        else if ( indx .lt. 0 ) then

          call i4vec2_compare ( n, a1, a2, i, j, isgn )

        else if ( indx .eq. 0 ) then

          go to 20

        end if

      go to 10

20    continue

      return
      end
      subroutine i4vec2_sorted_unique_count ( n, a1, a2, unique_num )

c*********************************************************************72
c
cc I4VEC2_SORTED_UNIQUE_COUNT counts unique elements in a sorted I4VEC2.
c
c  Discussion:
c
c    Item I is stored as the pair A1(I), A2(I).
c
c    The items must have been sorted, or at least it must be the
c    case that equal items are stored in adjacent vector locations.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    14 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of items.
c
c    Input, integer A1(N), A2(N), the items.
c
c    Output, integer UNIQUE_NUM, the number of unique items.
c
      implicit none

      integer n

      integer a1(n)
      integer a2(n)
      integer i
      integer iu
      integer unique_num

      unique_num = 0

      if ( n .le. 0 ) then
        return
      end if

      iu = 1
      unique_num = 1

      do i = 2, n

        if ( a1(i) .ne. a1(iu) .or.
     &       a2(i) .ne. a2(iu) ) then
          iu = i
          unique_num = unique_num + 1
        end if

      end do

      return
      end
      subroutine i4vec2_sorted_uniquely ( n1, a1, b1, n2, a2, b2 )

c*********************************************************************72
c
cc I4VEC2_SORTED_UNIQUELY copies unique elements from a sorted I4VEC2.
c
c  Discussion:
c
c    An I4VEC2 is a pair of I4VEC's.
c
c    An I4VEC is a vector of I4's.
c
c    Entry K of an I4VEC2 is the pair of values located
c    at the K-th entries of the two I4VEC's.
c
c    Item I is stored as the pair A1(I), A2(I).
c
c    The items must have been sorted, or at least it must be the
c    case that equal items are stored in adjacent vector locations.
c
c    If the items were not sorted, then this routine will only
c    replace a string of equal values by a single representative.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    12 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N1, the number of items.
c
c    Input, integer A1(N1), B1(N1), the array of items.
c
c    Input, integer N2, the number of unique items.
c
c    Output, integer A2(N2), B2(N2), the array of unique items.
c
      implicit none

      integer n1
      integer n2

      integer a1(n1)
      integer a2(n2)
      integer b1(n1)
      integer b2(n2)
      integer i1
      integer i2

      i1 = 1
      i2 = 1
      a2(i2) = a1(i1)
      b2(i2) = b1(i1)

      do i1 = 2, n1

        if ( a1(i1) .ne. a2(i2) .or. b1(i1) .ne. b2(i2) ) then

          i2 = i2 + 1

          a2(i2) = a1(i1)
          b2(i2) = b1(i1)

        end if

      end do

      return
      end
      function r8_uniform_01 ( seed )

c*********************************************************************72
c
cc R8_UNIFORM_01 returns a pseudorandom R8 scaled to [0,1].
c
c  Discussion:
c
c    This routine implements the recursion
c
c      seed = 16807 * seed mod ( 2^31 - 1 )
c      r8_uniform_01 = seed / ( 2^31 - 1 )
c
c    The integer arithmetic never requires more than 32 bits,
c    including a sign bit.
c
c    If the initial seed is 12345, then the first three computations are
c
c      Input     Output      R8_UNIFORM_01
c      SEED      SEED
c
c         12345   207482415  0.096616
c     207482415  1790989824  0.833995
c    1790989824  2035175616  0.947702
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    11 August 2004
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Paul Bratley, Bennett Fox, Linus Schrage,
c    A Guide to Simulation,
c    Springer Verlag, pages 201-202, 1983.
c
c    Pierre L'Ecuyer,
c    Random Number Generation,
c    in Handbook of Simulation,
c    edited by Jerry Banks,
c    Wiley Interscience, page 95, 1998.
c
c    Bennett Fox,
c    Algorithm 647:
c    Implementation and Relative Efficiency of Quasirandom
c    Sequence Generators,
c    ACM Transactions on Mathematical Software,
c    Volume 12, Number 4, pages 362-376, 1986.
c
c    Peter Lewis, Allen Goodman, James Miller,
c    A Pseudo-Random Number Generator for the System/360,
c    IBM Systems Journal,
c    Volume 8, pages 136-143, 1969.
c
c  Parameters:
c
c    Input/output, integer SEED, the "seed" value, which should NOT be 0.
c    On output, SEED has been updated.
c
c    Output, double precision R8_UNIFORM_01, a new pseudorandom variate,
c    strictly between 0 and 1.
c
      implicit none

      double precision r8_uniform_01
      integer k
      integer seed

      if ( seed .eq. 0 ) then
        write ( *, '(a)' ) ' '
        write ( *, '(a)' ) 'R8_UNIFORM_01 - Fatal error!'
        write ( *, '(a)' ) '  Input value of SEED = 0.'
        stop 1
      end if

      k = seed / 127773

      seed = 16807 * ( seed - k * 127773 ) - k * 2836

      if ( seed .lt. 0 ) then
        seed = seed + 2147483647
      end if

      r8_uniform_01 = dble ( seed ) * 4.656612875D-10

      return
      end
      function r8vec_diff_norm ( n, a, b )

c*********************************************************************72
c
cc R8VEC_DIFF_NORM returns the L2 norm of the difference of R8VEC's.
c
c  Discussion:
c
c    An R8VEC is a vector of R8 values.
c
c    The vector L2 norm is defined as:
c
c      R8VEC_NORM_L2 = sqrt ( sum ( 1 <= I <= N ) A(I)^2 ).
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    24 June 2010
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer N, the number of entries in A.
c
c    Input, double precision A(N), B(N), the vectors.
c
c    Output, double precision R8VEC_DIFF_NORM, the L2 norm of A - B.
c
      implicit none

      integer n

      double precision a(n)
      double precision b(n)
      integer i
      double precision r8vec_diff_norm
      double precision value

      value = 0.0D+00
      do i = 1, n
        value = value + ( a(i) - b(i) )**2
      end do
      value = sqrt ( value )

      r8vec_diff_norm = value

      return
      end
      subroutine r8vec_uniform_01 ( n, seed, r )

c*********************************************************************72
c
cc R8VEC_UNIFORM_01 returns a unit pseudorandom R8VEC.
c
c  Discussion:
c
c    An R8VEC is a vector of R8's.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    17 July 2006
c
c  Author:
c
c    John Burkardt
c
c  Reference:
c
c    Paul Bratley, Bennett Fox, Linus Schrage,
c    A Guide to Simulation,
c    Springer Verlag, pages 201-202, 1983.
c
c    Bennett Fox,
c    Algorithm 647:
c    Implementation and Relative Efficiency of Quasirandom
c    Sequence Generators,
c    ACM Transactions on Mathematical Software,
c    Volume 12, Number 4, pages 362-376, 1986.
c
c    Peter Lewis, Allen Goodman, James Miller,
c    A Pseudo-Random Number Generator for the System/360,
c    IBM Systems Journal,
c    Volume 8, pages 136-143, 1969.
c
c  Parameters:
c
c    Input, integer N, the number of entries in the vector.
c
c    Input/output, integer SEED, the "seed" value, which should NOT be 0.
c    On output, SEED has been updated.
c
c    Output, double precision R(N), the vector of pseudorandom values.
c
      implicit none

      integer n

      integer i
      integer k
      integer seed
      double precision r(n)

      do i = 1, n

        k = seed / 127773

        seed = 16807 * ( seed - k * 127773 ) - k * 2836

        if ( seed .lt. 0 ) then
          seed = seed + 2147483647
        end if

        r(i) = dble ( seed ) * 4.656612875D-10

      end do

      return
      end
      subroutine sort_heap_external ( n, indx, i, j, isgn )

c*********************************************************************72
c
cc SORT_HEAP_EXTERNAL externally sorts a list of items into ascending order.
c
c  Discussion:
c
c    The actual list of data is not passed to the routine.  Hence this
c    routine may be used to sort integers, reals, numbers, names,
c    dates, shoe sizes, and so on.  After each call, the routine asks
c    the user to compare or interchange two items, until a special
c    return value signals that the sorting is completed.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    25 January 2007
c
c  Author:
c
c    Original FORTRAN77 version by Albert Nijenhuis, Herbert Wilf.
c    This FORTRAN77 version by John Burkardt.
c
c  Reference:
c
c    Albert Nijenhuis, Herbert Wilf,
c    Combinatorial Algorithms for Computers and Calculators,
c    Academic Press, 1978,
c    ISBN: 0-12-519260-6,
c    LC: QA164.N54.
c
c  Parameters:
c
c    Input, integer N, the number of items to be sorted.
c
c    Input/output, integer INDX, the main communication signal.
c
c    The user must set INDX to 0 before the first call.
c    Thereafter, the user should not change the value of INDX until
c    the sorting is done.
c
c    On return, if INDX is
c
c      greater than 0,
c      * interchange items I and J;
c      * call again.
c
c      less than 0,
c      * compare items I and J;
c      * set ISGN = -1 if I .lt. J, ISGN = +1 if J .lt. I;
c      * call again.
c
c      equal to 0, the sorting is done.
c
c    Output, integer I, J, the indices of two items.
c    On return with INDX positive, elements I and J should be interchanged.
c    On return with INDX negative, elements I and J should be compared, and
c    the result reported in ISGN on the next call.
c
c    Input, integer ISGN, results of comparison of elements I and J.
c    (Used only when the previous call returned INDX less than 0).
c    ISGN .le. 0 means I is less than or equal to J;
c    0 .le. ISGN means I is greater than or equal to J.
c
      implicit none

      integer i
      integer i_save
      integer indx
      integer isgn
      integer j
      integer j_save
      integer k
      integer k1
      integer n
      integer n1

      save i_save
      save j_save
      save k
      save k1
      save n1

      data i_save / 0 /
      data j_save / 0 /
      data k / 0 /
      data k1 / 0 /
      data n1 / 0 /
c
c  INDX = 0: This is the first call.
c
      if ( indx .eq. 0 ) then

        i_save = 0
        j_save = 0
        k = n / 2
        k1 = k
        n1 = n
c
c  INDX .lt. 0: The user is returning the results of a comparison.
c
      else if ( indx .lt. 0 ) then

        if ( indx .eq. -2 ) then

          if ( isgn .lt. 0 ) then
            i_save = i_save + 1
          end if

          j_save = k1
          k1 = i_save
          indx = -1
          i = i_save
          j = j_save
          return

        end if

        if ( 0 .lt. isgn ) then
          indx = 2
          i = i_save
          j = j_save
          return
        end if

        if ( k .le. 1 ) then

          if ( n1 .eq. 1 ) then
            i_save = 0
            j_save = 0
            indx = 0
          else
            i_save = n1
            n1 = n1 - 1
            j_save = 1
            indx = 1
          end if

          i = i_save
          j = j_save
          return

        end if

        k = k - 1
        k1 = k
c
c  0 .lt. INDX, the user was asked to make an interchange.
c
      else if ( indx .eq. 1 ) then

        k1 = k

      end if

10    continue

        i_save = 2 * k1

        if ( i_save .eq. n1 ) then
          j_save = k1
          k1 = i_save
          indx = -1
          i = i_save
          j = j_save
          return
        else if ( i_save .le. n1 ) then
          j_save = i_save + 1
          indx = -2
          i = i_save
          j = j_save
          return
        end if

        if ( k .le. 1 ) then
          go to 20
        end if

        k = k - 1
        k1 = k

      go to 10

20    continue

      if ( n1 .eq. 1 ) then
        i_save = 0
        j_save = 0
        indx = 0
        i = i_save
        j = j_save
      else
        i_save = n1
        n1 = n1 - 1
        j_save = 1
        indx = 1
        i = i_save
        j = j_save
      end if

      return
      end
      subroutine st_mv ( m, n, nst, ist, jst, ast, x, b )

c*********************************************************************72
c
cc ST_MV multiplies an R8SP matrix by an R8VEC.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    13 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer M, N, the number of rows and columns of
c    the matrix.
c
c    Input, integer NST, the number of nonzero elements in
c    the matrix.
c
c    Input, integer IST(NST), JST(NST), the row and
c    column indices of the nonzero elements.
c
c    Input, double precision AST(NST), the nonzero elements of the matrix.
c
c    Input, double precision X(N), the vector to be multiplied by A.
c
c    Output, double precision B(M), the product vector A*X.
c
      implicit none

      integer m
      integer n
      integer nst

      double precision ast(nst)
      double precision b(m)
      integer i
      integer ist(nst)
      integer j
      integer jst(nst)
      integer k
      double precision x(n)

      do i = 1, m
        b(i) = 0.0D+00
      end do

      do k = 1, nst
        i = ist(k)
        j = jst(k)
        b(i) = b(i) + ast(k) * x(j)
      end do

      return
      end
      subroutine st_to_cc_index ( nst, ist, jst, ncc, n, icc, ccc )

c*********************************************************************72
c
cc ST_TO_CC_INDEX creates CC indices from ST data.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    12 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer NST, the number of ST elements.
c
c    Input, integer IST(NST), JST(NST), the ST rows and columns.
c
c    Input, integer NCC, the number of CC elements.
c
c    Input, integer N, the number of columns in the matrix.
c
c    Output, integer ICC(NCC), the CC rows.
c
c    Output, integer CCC(N+1), the compressed CC columns.
c
      implicit none

      integer n
      integer ncc
      integer nst

      integer ccc(n+1)
      integer i
      integer icc(ncc)
      integer ist(nst)
      integer ist2(nst)
      integer j
      integer jhi
      integer jlo
      integer jcc(ncc)
      integer jst(nst)
      integer jst2(nst)
c
c  Make copies so the sorting doesn't confuse the user.
c
      call i4vec_copy ( nst, ist, ist2 )
      call i4vec_copy ( nst, jst, jst2 )
c
c  Sort the elements.
c
      call i4vec2_sort_a ( nst, jst2, ist2 )
c
c  Get the unique elements.
c
      call i4vec2_sorted_uniquely ( nst, jst2, ist2, ncc, jcc, icc )
c
c  Compress the column index.
c
      ccc(1) = 1
      jlo = 1
      do i = 1, ncc
        jhi = jcc(i)
        if ( jhi .ne. jlo ) then
          do j = jlo + 1, jhi
            ccc(j) = i
          end do
          jlo = jhi
        end if
      end do
      jhi = n + 1
      do j = jlo + 1, jhi
        ccc(j) = ncc + 1
      end do

      return
      end
      subroutine st_to_cc_size ( nst, ist, jst, ncc )

c*********************************************************************72
c
cc ST_TO_CC_SIZE sizes CC indexes based on ST data.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    12 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer NST, the number of ST elements.
c
c    Input, integer IST(NST), JST(NST), the ST rows and columns.
c
c    Output, integer NCC, the number of CC elements.
c
      implicit none

      integer nst

      integer ist(nst)
      integer ist2(nst)
      integer jst2(nst)
      integer jst(nst)
      integer ncc
c
c  Make copies so the sorting doesn't confuse the user.
c
      call i4vec_copy ( nst, ist, ist2 )
      call i4vec_copy ( nst, jst, jst2 )
c
c  Sort by column first, then row.
c
      call i4vec2_sort_a ( nst, jst2, ist2 )
c
c  Count the unique pairs.
c
      call i4vec2_sorted_unique_count ( nst, jst2, ist2, ncc )

      return
      end
      subroutine st_to_cc_values ( nst, ist, jst, ast, ncc, n, icc, 
     &  ccc, acc )

c*********************************************************************72
c
cc ST_TO_CC_VALUES creates CC values from ST data.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    12 July 2014
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    Input, integer NST, the number of ST elements.
c
c    Input, integer IST(NST), JST(NST), the ST rows and columns.
c
c    Input, double precision AST(NST), the ST values.
c
c    Input, integer NCC, the number of CC elements.
c
c    Input, integer N, the number of columns.
c
c    Input, integer ICC(NCC), the CC rows.
c
c    Input, integer CCC(N+1), the CC compressed columns.
c
c    Output, double precision ACC(NCC), the CC values.
c
      implicit none

      integer n
      integer ncc
      integer nst

      double precision ast(nst)
      double precision acc(ncc)
      integer ccc(n+1)
      integer chi
      integer clo
      logical fail
      integer i
      integer icc(ncc)
      integer ist(nst)
      integer j
      integer jst(nst)
      integer kcc
      integer kst

      do kcc = 1, ncc
        acc(kcc) = 0.0D+00
      end do

      do kst = 1, nst

        i = ist(kst)
        j = jst(kst)

        clo = ccc(j)
        chi = ccc(j+1)

        fail = .true.

        do kcc = clo, chi - 1
          if ( icc(kcc) .eq. i ) then
            acc(kcc) = acc(kcc) + ast(kst)
            fail = .false.
            exit
          end if
        end do

        if ( fail ) then
          write ( *, '(a)' ) ''
          write ( *, '(a)' ) 'ST_TO_CC_VALUES - Fatal error!'
          write ( *, '(a)' ) '  ST entry cannot be located in CC array.'
          write ( *, '(a,i4)' ) '  ST index KST    = ', kst
          write ( *, '(a,i4)' ) '  ST row IST(KST) = ', ist(kst)
          write ( *, '(a,i4)' ) '  ST col JST(KST) = ', jst(kst)
          write ( *, '(a,g14.6)' ) '  ST val AST(KST) = ', ast(kst)
          stop 1
        end if

      end do

      return
      end
c
c
c
      subroutine timestamp ( )

c*********************************************************************72
c
cc TIMESTAMP prints out the current YMDHMS date as a timestamp.
c
c  Licensing:
c
c    This code is distributed under the GNU LGPL license.
c
c  Modified:
c
c    12 January 2007
c
c  Author:
c
c    John Burkardt
c
c  Parameters:
c
c    None
c
      implicit none

      character * ( 8 ) ampm
      integer d
      character * ( 8 ) date
      integer h
      integer m
      integer mm
      character * ( 9 ) month(12)
      integer n
      integer s
      character * ( 10 ) time
      integer y

      save month

      data month /
     &  'January  ', 'February ', 'March    ', 'April    ',
     &  'May      ', 'June     ', 'July     ', 'August   ',
     &  'September', 'October  ', 'November ', 'December ' /

      call date_and_time ( date, time )

      read ( date, '(i4,i2,i2)' ) y, m, d
      read ( time, '(i2,i2,i2,1x,i3)' ) h, n, s, mm

      if ( h .lt. 12 ) then
        ampm = 'AM'
      else if ( h .eq. 12 ) then
        if ( n .eq. 0 .and. s .eq. 0 ) then
          ampm = 'Noon'
        else
          ampm = 'PM'
        end if
      else
        h = h - 12
        if ( h .lt. 12 ) then
          ampm = 'PM'
        else if ( h .eq. 12 ) then
          if ( n .eq. 0 .and. s .eq. 0 ) then
            ampm = 'Midnight'
          else
            ampm = 'AM'
          end if
        end if
      end if

      write ( *,
     &  '(i2,1x,a,1x,i4,2x,i2,a1,i2.2,a1,i2.2,a1,i3.3,1x,a)' )
     &  d, month(m), y, h, ':', n, ':', s, '.', mm, ampm

      return
      end

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.
    ! This default version prints an error message since it should
    ! not be used directly.  Copy this to an application directory and
    ! loop over all grid cells to set values of q(1:meqn, 1:mx).

    implicit none
    
    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    write(6,*) '*** Error -- you must set initial conditions'
    stop

end subroutine qinit

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::::     Module to define and work with adjoint type
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

module adjoint_module
    use amr_module

    type adjointData_type

        real(kind=8), allocatable, dimension(:) :: alloc

        real(kind=8) hxposs(maxlv)

        integer meqn, ngrids, naux, ndim, nghost, lfine
        real(kind=8) time
        real(kind=8),allocatable,dimension(:) :: xlowvals
        integer, allocatable, dimension(:) :: ncellsx,loc, &
                gridlevel,gridpointer

        ! variable for conservation checking
        real(kind=8) tmass0

    end type adjointData_type

    type(adjointData_type), allocatable :: adjoints(:)
    integer :: totnum_adjoints, &
               counter, innerprod_index
    real(kind=8) :: trange_start, trange_final, levtol(maxlv)
    character(len=365), allocatable :: adj_files(:)
    logical :: adjoint_flagging
    real(kind=8), allocatable, dimension(:) :: errors
    integer, allocatable, dimension(:) :: eptr
    integer, allocatable, dimension(:) :: grid_num

contains

! ========================================================================
!  read_adjoint_data()
! ========================================================================
    subroutine read_adjoint_data()

        implicit none

        ! Function Arguments
        character(len=*), parameter :: adjointfile = 'adjoint.data'
        character(len=400) :: adjoint_output
        logical :: fileExists
        integer :: iunit, k
        real(kind=8) :: t1,t2

        levtol = 0.0d0

        inquire(file=adjointfile, exist=fileExists)
        if (fileExists) then

            !adjoint_flagging = .true.
            iunit = 16
            call opendatafile(iunit,adjointfile)
            
            read(iunit,*) adjoint_flagging
            if (.not. adjoint_flagging) return
            
            read(iunit,*) adjoint_output

            ! time period of interest:
            read(iunit,*) t1
            read(iunit,*) t2

            call set_time_window(t1, t2)

            read(iunit,*) innerprod_index
            
            read(iunit,*) totnum_adjoints
            allocate(adj_files(totnum_adjoints))

            do 20 k = 1, totnum_adjoints
                read(iunit,*) adj_files(totnum_adjoints + 1 - k)
            20  continue
            close(iunit)

            if (adjoint_flagging .and. (size(adj_files) <= 0)) then
                print *, 'Error: no adjoint output files found.'
                stop
            endif

            ! Allocate space for the number of needed binary output files
            allocate(adjoints(totnum_adjoints))

            do 50 k = 1, totnum_adjoints
                ! Load binary output files
                call reload(adj_files(k),k)
            50 continue

        else
            adjoint_flagging = .false.
        endif

    end subroutine read_adjoint_data

! ========================================================================
!  set_time_window(t1,t2)
! ========================================================================
    subroutine set_time_window(t1, t2)

        implicit none

        ! Function Arguments
        real(kind=8), intent(in) :: t1, t2

        trange_final = t2
        trange_start = t1

    end subroutine set_time_window

! ========================================================================
!  calculate_tol(lcheck)
! ========================================================================
    subroutine calculate_tol(lcheck)

       use amr_module
       implicit none

       ! Function Arguments
       integer, intent(in) :: lcheck
       real(kind=8) :: errtotal, cutoff
       real(kind=8) :: dt, hx
       integer :: celln, sorted(numcells(lcheck)/2)

       dt = possk(lcheck)
       hx = hxposs(lcheck)

       ! Setting our goal for the maximum amount of error
       ! for this level
       cutoff = tol*(dt/hx)/(tfinal-t0)
       cutoff = cutoff/mxnest

       ! Sorting errors
       call qsortr(sorted, numcells(lcheck)/2, errors)

       errtotal = 0
       do celln = 1, numcells(lcheck)/2
           errtotal = errtotal + errors(sorted(celln))
           if (errtotal .ge. cutoff) then
               levtol(lcheck) = errors(sorted(celln))
               EXIT
           endif
       end do

    end subroutine calculate_tol

! ========================================================================
!  reload(adjfile, k)
!  Note: This assumes that the binary output format was used
! ========================================================================
    subroutine reload(adjfile, k)

      implicit double precision (a-h,o-z)

      integer, intent(in) :: k
      integer :: mptr, level, ladjfile, mptr_notused
      integer :: mitot, mjtot, i1, i2
      integer :: i, ivar, z, loc
      integer :: allocsize, new_size
      character(len=*):: adjfile
      logical foundFile, initial

      real(kind=8), allocatable, target, dimension(:) :: new_storage
      iadd(ivar,i)  = adjoints(k)%loc(mptr) &
             + ivar - 1 + adjoints(k)%meqn*(i-1)

      ! Checking to see if fort.t file exists
      ladjfile = len(trim(adjfile))
      adjfile(ladjfile-4:ladjfile-4) = 't'
      !write(6,*) 'Attempting to load adjoint data '
      !write(6,*) '  fort.t* file: ',trim(adjfile)
      inquire(file=trim(adjfile),exist=foundFile)
      if (.not. foundFile) then
          write(*,*)" Did not find fort.t* file!"
          write(*,*)"   ", trim(adjfile)
          stop
      endif
      open(9,file=trim(adjfile),status='old',form='formatted')
      rewind 9

      ! Reading from fort.t file
      read(9, "(e18.8)") adjoints(k)%time
      read(9, "(i6)") adjoints(k)%meqn
      read(9, "(i6)") adjoints(k)%ngrids
      read(9, "(i6)") adjoints(k)%naux
      read(9, "(i6)") adjoints(k)%ndim
      read(9, "(i6)") adjoints(k)%nghost

      close(9)
      write(*,*) 'Loading adjoint data at time t = ', adjoints(k)%time

      ! Allocating memory for alloc array
      allocsize = 4000000
      allocate(adjoints(k)%alloc(allocsize))

      ! Checking to see if fort.q file exists
      adjfile(ladjfile-4:ladjfile-4) = 'q'
      !write(6,*) 'Attempting to reload data '
      !write(6,*) '  fort.q* file: ',trim(adjfile)
      inquire(file=trim(adjfile),exist=foundFile)
      if (.not. foundFile) then
          write(*,*)" Did not find fort.q* file!"
          stop
      endif
      open(10,file=trim(adjfile),status='old',form='formatted')
      rewind 10

      ! Checking to see if fort.b file exists
      adjfile(ladjfile-4:ladjfile-4) = 'b'
      !write(6,*) 'Attempting to reload data '
      !write(6,*) '  fort.b* file: ',trim(adjfile)
      inquire(file=trim(adjfile),exist=foundFile)
      if (.not. foundFile) then
          write(*,*)" Did not find fort.b* file!"
          stop
      endif
      write(*,*) '   from file ', trim(adjfile)
      write(*,*) ' '
      open(20,file=trim(adjfile),status='unknown',access='stream')
      rewind 20

       ! Allocating size for grid information arrays
       allocate(adjoints(k)%xlowvals(adjoints(k)%ngrids))
       allocate(adjoints(k)%ncellsx(adjoints(k)%ngrids))
       allocate(adjoints(k)%loc(adjoints(k)%ngrids))
       allocate(adjoints(k)%gridlevel(adjoints(k)%ngrids))
       allocate(adjoints(k)%gridpointer(adjoints(k)%ngrids))

       !Initializing all levels to zero
       adjoints(k)%gridlevel(:) = 0

      ! Reading from fort.q* file and fort.b* files
      loc = 1
      do z = 1, adjoints(k)%ngrids
          read(10,"(i6)") mptr_notused
          adjoints(k)%gridpointer(z) = z
          mptr = z

          read(10,"(i6)") level
          adjoints(k)%gridlevel(mptr) = level

          read(10,"(i6)") adjoints(k)%ncellsx(mptr)
          read(10,"(e26.16)") adjoints(k)%xlowvals(mptr)
          read(10,"(e26.16)") adjoints(k)%hxposs(level)
          read(10,*)

          mitot = adjoints(k)%ncellsx(mptr) + 2*adjoints(k)%nghost

          adjoints(k)%loc(mptr) = loc
          loc = loc + mitot*adjoints(k)%meqn

          ! Checking to see if the alloc array is large enough
          ! to hold the new grid
          ! If not, making the alloc array larger
          if (allocsize .lt. loc) then
              new_size = 2*allocsize
              allocate(new_storage(new_size))

              new_storage(1:allocsize) = adjoints(k)%alloc
              call move_alloc(new_storage,adjoints(k)%alloc)
              allocsize = new_size
          endif

          ! This is the bulk of the reading
          i1 = iadd(1,1)
          i2 = iadd(adjoints(k)%meqn,mitot)
          read(20) adjoints(k)%alloc(i1:i2)

      enddo

      close(10)
      close(20)

      adjoints(k)%lfine = maxval(adjoints(k)%gridlevel)

    end subroutine reload

! ========================================================================
!  select_snapshots(time,mask_selecta)
! ========================================================================
    subroutine select_snapshots(time,mask_selecta)

       implicit none

       logical, intent(inout) :: mask_selecta(totnum_adjoints)
       real(kind=8), intent(in) :: time

!      Local variables
       logical :: adjoints_found
       integer :: r

!       Pick adjoint snapshots to consider when flagging
        mask_selecta = .false.
        adjoints_found = .false.

        do r=1,totnum_adjoints
            if ((time+adjoints(r)%time) >= trange_start .and. &
              (time+adjoints(r)%time) <= trange_final) then
                mask_selecta(r) = .true.
                adjoints_found = .true.
            endif
        enddo

        if(.not. adjoints_found) then
            write(*,*) "Error: no adjoint snapshots ", &
                "found in time range."
            write(*,*) "Consider increasing time rage of interest, ", &
                "or adding more snapshots."
        endif

        do r=1,totnum_adjoints-1
            if((.not. mask_selecta(r)) .and. &
              (mask_selecta(r+1))) then
                mask_selecta(r) = .true.
                exit
            endif
        enddo

        do r=totnum_adjoints,2,-1
            if((.not. mask_selecta(r)) .and. &
              (mask_selecta(r-1))) then
                mask_selecta(r) = .true.
                exit
            endif
        enddo

    end subroutine select_snapshots

! ========================================================================
!  Routine to calculate inner product
! ========================================================================

    subroutine calculate_innerproduct(q,r,mx_f,xlower_f, &
                dx_f,meqn_f,mbc_f,innerprod)

        implicit none

        real(kind=8), intent(in) :: xlower_f, dx_f
        integer, intent(in) :: r, mx_f, meqn_f, mbc_f
        real(kind=8), intent(in) :: q(meqn_f,1-mbc_f:mx_f+mbc_f)

        integer :: mx_a, mptr_a
        integer :: i, i1, i2, level, loc, z
        real(kind=8) :: dx_a, xlower_a, xupper_a, xupper_f, x1, x2

        real(kind=8), intent(inout) :: innerprod(1-mbc_f:mx_f+mbc_f)
        real(kind=8) :: q_innerprod(1-mbc_f:mx_f+mbc_f)
        logical :: mask_forward(1-mbc_f:mx_f+mbc_f)
        real(kind=8) :: q_interp(adjoints(r)%meqn,1-mbc_f:mx_f+mbc_f)

        logical, allocatable :: mask_adjoint(:)


        xupper_f = xlower_f + mx_f*dx_f

        ! Loop over patches in adjoint solution
        do z = 1, adjoints(r)%ngrids
            mptr_a = adjoints(r)%gridpointer(z)
            level = adjoints(r)%gridlevel(mptr_a)

            ! Number of points in x (nx)
            mx_a = adjoints(r)%ncellsx(mptr_a)

            ! Finding x extreem values for grid
            xlower_a = adjoints(r)%xlowvals(mptr_a)
            dx_a = adjoints(r)%hxposs(level)
            xupper_a = xlower_a + mx_a*dx_a

            loc = adjoints(r)%loc(mptr_a)

            ! Check if adjoint patch overlaps with forward patch
            x1 = max(xlower_f,xlower_a)
            x2 = min(xupper_f,xupper_a)

            if (x1 > x2) then
                ! Skipping interpolation if grids don't overlap
                mask_forward = .false.
                continue
            else

                allocate(mask_adjoint(1-adjoints(r)%nghost:mx_a+adjoints(r)%nghost))

                ! Create a mask that is .true. only in part of patch intersecting forward patch:
                i1 = max(int((x1 - xlower_a + 0.5d0*dx_a) / dx_a), 0)
                i2 = min(int((x2 - xlower_a + 0.5d0*dx_a) / dx_a) + 1, mx_a+1)

                forall (i=1-adjoints(r)%nghost:mx_a+adjoints(r)%nghost)
                    mask_adjoint(i) = ((i >= i1) .and. (i <= i2))
                end forall

                ! Create a mask that is .true. only in part of forward patch intersecting patch:

                i1 = max(int((x1 - xlower_f + 0.5d0*dx_f) / dx_f)+1, 0)
                i2 = min(int((x2 - xlower_f + 0.5d0*dx_f) / dx_f), mx_f)

                do i=1-mbc_f,mx_f+mbc_f
                    mask_forward(i) = ((i >= i1) .and. (i <= i2))
                enddo

                ! Interpolate adjoint values to q_interp
                ! Note that values in q_interp will only be set properly where 
                ! mask_adjoint == .true.
                call interp_adjoint( &
                        adjoints(r)%meqn, r, q_interp, &
                        xlower_a, dx_a, mx_a, xlower_f, dx_f, mx_f, &
                        mask_adjoint, mptr_a, mask_forward, mbc_f)

                q_innerprod = 0.d0
                ! For each overlapping point, calculate inner product
                forall(i = 1-mbc_f:mx_f+mbc_f, mask_forward(i))
                    q_innerprod(i) = abs(dot_product(q(:,i),q_interp(:,i)))
                end forall

                do i=1-mbc_f,mx_f+mbc_f
                    if (q_innerprod(i) > innerprod(i)) then
                        innerprod(i) = q_innerprod(i)
                    endif
                enddo

                deallocate(mask_adjoint)
            endif
        enddo

    end subroutine calculate_innerproduct

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! :::::     Routine to interpolate adjoint to given an x point
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    subroutine interp_adjoint(nvar, r, q_interp, xlower_a, dx_a, &
            mx_a, xlower_f, dx_f, mx_f, mask_adjoint, mptr_a, &
            mask_forward, mbc_f)

        implicit none

        ! Function arguments
        integer, intent(in) :: r, nvar, mx_a
        logical, intent(in) :: mask_adjoint(1-adjoints(r)%nghost:mx_a+adjoints(r)%nghost)
        real(kind=8), intent(in) :: xlower_a, xlower_f
        integer, intent(in) :: mx_f, mptr_a, mbc_f
        real(kind=8), intent(in) :: dx_f, dx_a
        logical, intent(in) :: mask_forward(1-mbc_f:mx_f+mbc_f)

        integer :: z,level, iz(1-mbc_f:mx_f+mbc_f), &
                      ivar,i, iadd, iaddaux, loc
        real(kind=8) :: q_interp(nvar,1-mbc_f:mx_f+mbc_f), denom
        real(kind=8) :: x, xhigh_a,x_f
        real(kind=8) :: dxz(1-mbc_f:mx_f+mbc_f), a

        iadd(ivar,i)  = loc + ivar - 1 + adjoints(r)%meqn*(i-1)

        q_interp = 0.0
        xhigh_a  = xlower_a + mx_a*dx_a
        loc    = adjoints(r)%loc(mptr_a)

        do z=1-mbc_f,mx_f+mbc_f
            x = xlower_f + (z - 0.5d0)*dx_f

            iz(z) = int((x - xlower_a + 0.5d0*dx_a) / dx_a) + 1
            dxz(z) = x - (xlower_a + (iz(z)-0.5d0)*dx_a)
        enddo

        do z = 1-mbc_f, mx_f+mbc_f
            x = xlower_f + (z - 0.5d0)*dx_f

            if (mask_forward(z)) then
            ! Interpolate only if this cell is overlapping with grid
                if (mask_adjoint(iz(z))) then

                    do ivar=1,nvar
                        a = (adjoints(r)%alloc(iadd(ivar,iz(z)+1)) &
                            - adjoints(r)%alloc(iadd(ivar,iz(z)))) / dx_a
                        q_interp(ivar,z) = &
                            adjoints(r)%alloc(iadd(ivar,iz(z))) + a*dxz(z)
                    enddo
                endif
            endif
        enddo

    end subroutine interp_adjoint

! ========================================================================
!  Routine to compute error in forward solution for the adjoint method
!  Editted from errf1.f
!  Differences:
!   (i) Computes error for all of the terms in q
!   (ii) Needs the aux array passed in, because the inner product is saved
!        to the aux array (note, this changes the call sequence, which is
!        why this is not included into the AMRClaw errf1.f file. If plotting
!        of the inner product is never wanted, this could be simplified
!        and included into the AMRClaw errf1.f file.
! ========================================================================
   subroutine errf1a(rctfine,nvar,rctcrse,mptr,mi2tot, &
                      mitot,rctflg,mibuff,auxfine,naux)

      implicit double precision (a-h,o-z)
 
      dimension  rctfine(nvar,mitot)
      dimension  rctcrse(nvar,mi2tot)
      dimension  rctflg(mibuff)
      dimension  aux_crse(mi2tot)
      dimension  err_crse(nvar,mi2tot)
      dimension  auxfine(naux,mitot)
      logical mask_selecta(totnum_adjoints)

!
!
! :::::::::::::::::::::: Modified from ERRF1 :::::::::::::::::::::::::
!
!  Richardson error estimator:  Used when flag_richardson is .true.
!  Compare error estimates in rctfine, rctcrse,
!  A point is flagged if the inner product between the
!  error estimate and the adjoint solution is greater than tol
!  later we check if its in a region where its allowed to be flagged
!  or alternatively required.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!

      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      dt    = possk(levm)
      numsp = 0
      jg = grid_num(mptr)
      nx = mitot - 2*nghost

      call select_snapshots(time,mask_selecta)

      errmax = 0.0d0
      err2   = 0.0d0
      err_crse = 0.0d0
      auxfine(innerprod_index,:) = 0.0d0
      aux_crse = 0.0d0

      order  = dble(2**(iorder+1) - 2)
!
!     Calculating correct tol for this level
!     nxnest is the maximum number of refinement levels, from amr_module
!     --------------------
      tol_exact = tol*dt/(tfinal-t0)
      tol_exact = tol_exact/mxnest
      tol_exact = tol_exact/(numcells(levm)*hx)

      if (t0+possk(levm) .eq. time) levtol(levm) = tol_exact

!
! zero out the exterior locations so they don't affect err.est.
!
      ifine = nghost+1
      do i  = nghost+1, mi2tot-nghost

! Only check errors if flag hasn't been set yet.
! If flag == DONTFLAG then refinement is forbidden by a region,
! if flag == DOFLAG checking is not needed

! Note: here rctcrse is being used as a temporary flag
! the fine grid amrflags array is stored in rctflg, and will be
! updated based on rctcrse at the end of this routine
        if(rctflg(ifine) == UNSET &
              .or. rctflg(ifine+1) == UNSET) then
          do k = 1,nvar
              xofi  = xleft + (dble(ifine) - .5d0)*hx
              term1 = rctfine(k,ifine)
              term2 = rctfine(k,ifine+1)
!             # divide by (aval*order) for relative error
              aval  = (term1+term2)/2.d0
              est   =  dabs((aval-rctcrse(k,i))/ order)
              if (est .gt. errmax) errmax = est
              err2 = err2 + est*est

              err_crse(k,i) = est
!             retaining directionality of the wave
              err_crse(k,i) = sign(est,rctcrse(k,i))
          enddo
        else
            err_crse(:,i) = 0.d0
        endif

        ifine = ifine + 2
      enddo

      do 12 k = 1,totnum_adjoints
!         ! Consider only snapshots that are within the desired time range
          if (mask_selecta(k)) then

!             set innerproduct
              call calculate_innerproduct(err_crse,k,nx/2, &
                   xleft,hx*2,nvar,nghost,aux_crse)
          endif
 12   continue

      do i  = nghost+1, mi2tot-nghost
          errors(eptr(jg)+i-nghost) = aux_crse(i)

          rctcrse(1,i)  = DONTFLAG
          if (aux_crse(i) .ge. levtol(levm)) then
!                    ## never set rctflg to good, since flag2refine or
!                    ## flagregions may have previously set it to bad
!                    ## can only add bad pts in this routine
              rctcrse(1,i)  = DOFLAG
          endif

      enddo

      ifine   = nghost+1
      do i = nghost+1, mi2tot-nghost
         auxfine(innerprod_index,ifine) = aux_crse(i)
         auxfine(innerprod_index,ifine+1) = aux_crse(i)
         if (rctcrse(1,i) .eq. DOFLAG) then
!           ## never set rctflg to good, since flag2refine may
!           ## have previously set it to bad
!           ## can only add bad pts in this routine
            rctflg(ifine)    = DOFLAG
            rctflg(ifine+1)  = DOFLAG
        endif
        ifine   = ifine + 2
      enddo

    end subroutine errf1a


end module adjoint_module

subroutine qinit(meqn,mbc,mx,xlower,dx,q,maux,aux)

    ! Set initial conditions for the q array.

    implicit none
    
    integer, intent(in) :: meqn,mbc,mx,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)

    integer :: i
    real(kind=8) :: xcell, gamma1
 
    real(kind=8) :: gamma
    common /cparam/  gamma
 
    gamma1 = gamma - 1.d0

    do i=1,mx
        xcell = xlower + (i-0.5d0)*dx
        q(1,i) = 1.d0
        q(2,i) = 0.d0
        if (xcell .lt. 0.1d0) then
            q(3,i) = 1.d3/gamma1
          else if (xcell .lt. 0.9d0) then
            q(3,i) = 1.d-2/gamma1
          else
            q(3,i) = 1.d2/gamma1
          endif
    enddo

end subroutine qinit

c
c -----------------------------------------------------------
c
!> Conservation check for specified level.
!! This is mostly a debugging tool and assumes grids don't overlap
      subroutine conck(level, nvar, naux, time, rest)
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical  rest

c      iadd(i,j,ivar)  = loc + i - 1 + mitot*((ivar-1)*mjtot+j-1) OLD INDEXING
c      iaddaux(i,j) = locaux + i - 1 + mitot*(j-1) +
c     .                        mitot*mjtot*(mcapa-1)

c ## indexing into mcapa assumes cell volume is in mcapa location
      iadd(ivar,i,j)  = loc + ivar - 1 + nvar*((j-1)*mitot+i-1)
      iaddaux(i,j) = locaux + mcapa - 1 + naux*(i-1) +
     .                                    naux*mitot*(j-1)
c
c
c ******************************************************************
c conck - conservation check  for specified level
c         mostly a debugging tool
c         this assumes grids don't overlap
c
c ******************************************************************
c
c
c  grid loop for given level
c
      hx      = hxposs(level)
      hy      = hyposs(level)
      dt      = possk(level)
      totmass = 0.d0

      mptr = lstart(level)
 20   if (mptr .eq. 0) go to 85
         loc    = node(store1,mptr)
         locaux = node(storeaux,mptr)
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         mitot  = nx + 2*nghost
         mjtot  = ny + 2*nghost
c
         if (mcapa .eq. 0) then
           do j  = nghost+1, mjtot-nghost
           do i  = nghost+1, mitot-nghost
              totmass = totmass + alloc(iadd(1,i,j)) 
           end do
           end do
          else
c          # with capa array:
           do j  = nghost+1, mjtot-nghost
           do i  = nghost+1, mitot-nghost
              totmass = totmass + alloc(iadd(1,i,j))*alloc(iaddaux(i,j)) 
           end do
           end do
          endif
c
       mptr = node(levelptr,mptr)
       go to 20
c
 85    totmass = totmass * hx * hy
       if (time.eq. t0 .and. (level.eq.1) .and. .not. rest) then
           tmass0 = totmass
           write(6,*) 'Total mass at initial time: ',tmass0
           endif
       write(outunit,777) time, totmass, totmass-tmass0
 777   format('time t = ',e12.5,',  total mass = ',e22.15, '  diff = ',
     &         e11.4)
c
 99   return
      end

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::::     Module to define and work with adjoint type
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

module adjoint_module
    use amr_module

    type adjointData_type

        real(kind=8), allocatable, dimension(:) :: alloc

        real(kind=8) hxposs(maxlv),hyposs(maxlv)

        integer meqn, ngrids, naux, ndim, nghost, lfine
        real(kind=8) time
        real(kind=8),allocatable,dimension(:) :: xlowvals,ylowvals
        integer, allocatable, dimension(:) :: ncellsx,ncellsy,loc, &
                gridlevel,gridpointer

    end type adjointData_type

    type(adjointData_type), allocatable :: adjoints(:)
    integer :: totnum_adjoints, &
               counter, innerprod_index
    real(kind=8) :: trange_start, trange_final, levtol(maxlv)
    character(len=365), allocatable :: adj_files(:)
    logical :: adjoint_flagging
    real(kind=8), allocatable, dimension(:) :: errors
    integer, allocatable, dimension(:) :: eptr
    integer, allocatable, dimension(:) :: grid_num

contains

! ========================================================================
!  read_adjoint_data()
! ========================================================================
    subroutine read_adjoint_data()

        implicit none

        ! Function Arguments
        character(len=*), parameter :: adjointfile = 'adjoint.data'
        character(len=400) :: adjoint_output
        logical :: fileExists
        integer :: iunit, k
        real(kind=8) :: t1,t2

        ! Read adjoint specific information
        
        levtol = 0.0d0

        inquire(file=adjointfile, exist=fileExists)
        if (fileExists) then

            iunit = 16
            call opendatafile(iunit,adjointfile)
            
            read(iunit,*) adjoint_flagging
            if (.not. adjoint_flagging) return
            
            read(iunit,*) adjoint_output

            ! time period of interest:
            read(iunit,*) t1
            read(iunit,*) t2

            call set_time_window(t1, t2)

            read(iunit,*) innerprod_index
            
            read(iunit,*) totnum_adjoints
            allocate(adj_files(totnum_adjoints))

            do 20 k = 1, totnum_adjoints
                read(iunit,*) adj_files(totnum_adjoints + 1 - k)
            20  continue
            close(iunit)

            if (adjoint_flagging .and. (size(adj_files) <= 0)) then
                print *, 'Error: no adjoint output files found.'
                stop
            endif

            ! Allocate space for the number of needed binary output files
            allocate(adjoints(totnum_adjoints))

            do 50 k = 1, totnum_adjoints
                ! Load binary output files
                call reload(adj_files(k),k)

            50 continue

        else
            adjoint_flagging = .false.
        endif

    end subroutine read_adjoint_data

! ========================================================================
!  set_time_window(t1,t2)
! ========================================================================
    subroutine set_time_window(t1, t2)

        implicit none

        ! Function Arguments
        real(kind=8), intent(in) :: t1, t2

        trange_final = t2
        trange_start = t1

    end subroutine set_time_window

! ========================================================================
!  calculate_tol(lcheck)
! ========================================================================
    subroutine calculate_tol(lcheck)

        use amr_module
        implicit none

        ! Function Arguments
        integer, intent(in) :: lcheck
        real(kind=8) :: errtotal, cutoff
        real(kind=8) :: dt,hx,hy
        integer :: celln, sorted(numcells(lcheck)/2)

        levtol(lcheck) = NEEDS_TO_BE_SET

        dt = possk(lcheck)
        hx = hxposs(lcheck)
        hy = hyposs(lcheck)

        ! Setting our goal for the maximum amount of error
        ! for this level
        cutoff = tol*(dt/(hx*hy))/(tfinal-t0)
        cutoff = cutoff/mxnest

        ! Sorting errors
        call qsortr(sorted, numcells(lcheck)/2, errors)

        errtotal = 0
        do celln = 1, numcells(lcheck)/2
            errtotal = errtotal + errors(sorted(celln))
            if (errtotal .ge. cutoff) then
                levtol(lcheck) = errors(sorted(celln-1))
                EXIT
            endif
        end do

    end subroutine calculate_tol

! ========================================================================
!  reload(adjfile, k)
!  Note: This assumes that the binary output format was used
! ========================================================================

    subroutine reload(adjfile, k)

        implicit double precision (a-h,o-z)

        integer, intent(in) :: k
        integer :: mptr, level, ladjfile, mptr_notused
        integer :: mitot, mjtot, i1, i2
        integer :: i,j, ivar, z, loc
        integer :: allocsize, new_size
        character(len=*) :: adjfile
        logical foundFile, initial

        real(kind=8), allocatable, target, dimension(:) :: new_storage

        iadd(ivar,i,j)  = adjoints(k)%loc(mptr) &
            + ivar - 1 + adjoints(k)%meqn*((j-1)*mitot+i-1)

       ! Checking to see if fort.t file exists
        ladjfile = len(trim(adjfile))
        adjfile(ladjfile-4:ladjfile-4) = 't'
        !write(6,*) 'Attempting to reload data '
        !write(6,*) '  fort.t* file: ',trim(adjfile)
        inquire(file=trim(adjfile),exist=foundFile)
        if (.not. foundFile) then
            write(*,*)" Did not find fort.t* file!"
            stop
        endif
        open(9,file=trim(adjfile),status='old',form='formatted')
        rewind 9

        ! Reading from fort.t file
        read(9, *) adjoints(k)%time
        read(9, *) adjoints(k)%meqn
        read(9, *) adjoints(k)%ngrids
        read(9, *) adjoints(k)%naux
        read(9, *) adjoints(k)%ndim
        read(9, *) adjoints(k)%nghost

        close(9)
        write(*,*) 'Loading adjoint data at time t = ', adjoints(k)%time

       ! Allocating memory for alloc array
        allocsize = 4000000
        allocate(adjoints(k)%alloc(allocsize))

      ! Checking to see if fort.q file exists
        adjfile(ladjfile-4:ladjfile-4) = 'q'
        !write(6,*) 'Attempting to reload data '
        !write(6,*) '  fort.q* file: ',trim(adjfile)
        inquire(file=trim(adjfile),exist=foundFile)
        if (.not. foundFile) then
            write(*,*)" Did not find fort.q* file!"
            stop
        endif
        open(10,file=trim(adjfile),status='old',form='formatted')
        rewind 10

       ! Checking to see if fort.b file exists
        adjfile(ladjfile-4:ladjfile-4) = 'b'
        !write(6,*) 'Attempting to reload data '
        !write(6,*) '  fort.b* file: ',trim(adjfile)
        inquire(file=trim(adjfile),exist=foundFile)
        if (.not. foundFile) then
            write(*,*)" Did not find fort.b* file!"
            stop
        endif
        write(*,*) '   from file ', trim(adjfile)
        write(*,*) ' '
        open(20,file=trim(adjfile),status='unknown',access='stream')
        rewind 20

       ! Allocating size for grid information arrays
       allocate(adjoints(k)%xlowvals(adjoints(k)%ngrids))
       allocate(adjoints(k)%ylowvals(adjoints(k)%ngrids))
       allocate(adjoints(k)%ncellsx(adjoints(k)%ngrids))
       allocate(adjoints(k)%ncellsy(adjoints(k)%ngrids))
       allocate(adjoints(k)%loc(adjoints(k)%ngrids))
       allocate(adjoints(k)%gridlevel(adjoints(k)%ngrids))
       allocate(adjoints(k)%gridpointer(adjoints(k)%ngrids))

       ! Initializing all levels to zero
       adjoints(k)%gridlevel(:) = 0

       ! Reading from fort.q* file and fort.b* files
        loc = 1
        do z = 1, adjoints(k)%ngrids
            read(10,*) mptr_notused
            adjoints(k)%gridpointer(z) = z
            mptr = z

            read(10,*) level
            adjoints(k)%gridlevel(mptr) = level

            read(10,*) adjoints(k)%ncellsx(mptr)
            read(10,*) adjoints(k)%ncellsy(mptr)
            read(10,*) adjoints(k)%xlowvals(mptr)
            read(10,*) adjoints(k)%ylowvals(mptr)
            read(10,*) adjoints(k)%hxposs(level)
            read(10,*) adjoints(k)%hyposs(level)
            read(10,*)

            mitot = adjoints(k)%ncellsx(mptr) + 2*adjoints(k)%nghost
            mjtot = adjoints(k)%ncellsy(mptr) + 2*adjoints(k)%nghost

            adjoints(k)%loc(mptr) = loc
            loc = loc + mitot*mjtot*adjoints(k)%meqn

            ! Checking to see if the alloc array is large enough
            ! to hold the new grid
            ! If not, making the alloc array larger
            if (allocsize .lt. loc) then
                new_size = 2*allocsize
                allocate(new_storage(new_size))

                new_storage(1:allocsize) = adjoints(k)%alloc
                call move_alloc(new_storage,adjoints(k)%alloc)
                allocsize = new_size
            endif

            ! This is the bulk of the reading
            i1 = iadd(1,1,1)
            i2 = iadd(adjoints(k)%meqn,mitot,mjtot)
            read(20) adjoints(k)%alloc(i1:i2)

        enddo

        close(10)
        close(20)

        adjoints(k)%lfine = maxval(adjoints(k)%gridlevel)

    end subroutine reload

! ========================================================================
!  select_snapshots(time,mask_selecta)
! ========================================================================
    subroutine select_snapshots(time,mask_selecta)

       implicit none

       logical, intent(inout) :: mask_selecta(totnum_adjoints)
       real(kind=8), intent(in) :: time

!      Local variables
       logical :: adjoints_found
       integer :: r

!       Pick adjoint snapshots to consider when flagging
        mask_selecta = .false.
        adjoints_found = .false.

        do r=1,totnum_adjoints
            if ((time+adjoints(r)%time) >= trange_start .and. &
              (time+adjoints(r)%time) <= trange_final) then
                mask_selecta(r) = .true.
                adjoints_found = .true.
            endif
        enddo

        if(.not. adjoints_found) then
            write(*,*) "Error: no adjoint snapshots ", &
                "found in time range."
            write(*,*) "Consider increasing time rage of interest, ", &
                "or adding more snapshots."
        endif

        do r=1,totnum_adjoints-1
            if((.not. mask_selecta(r)) .and. &
              (mask_selecta(r+1))) then
                mask_selecta(r) = .true.
                exit
            endif
        enddo

        do r=totnum_adjoints,2,-1
            if((.not. mask_selecta(r)) .and. &
              (mask_selecta(r-1))) then
                mask_selecta(r) = .true.
                exit
            endif
        enddo

    end subroutine select_snapshots

end module adjoint_module

c
c
c     =====================================================
      double precision function philim(a,b,meth)
c     =====================================================
      implicit double precision (a-h,o-z)
c
c     # Compute a limiter based on wave strengths a and b.
c     # meth determines what limiter is used.
c     # a is assumed to be nonzero.
c
c     # NOTE: This routine is obsolete.  Instead of using limiter.f,
c     # which calls philim.f for every wave, it is more efficient to 
c     # use inlinelimiter.f, which eliminates all these function calls
c     # to philim.  If you wish to change the limiter function and are
c     # using inlinelimiter.f, the formulas must be changed in that routine.
c
      r = b/a
      go to (10,20,30,40,50) meth

c
   10 continue
c     --------
c     # minmod
c     --------
      philim = dmax1(0.d0, dmin1(1.d0, r))
      return
c
   20 continue
c     ----------
c     # superbee
c     ----------
      philim = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))
      return
c
   30 continue
c     ----------
c     # van Leer
c     ----------
      philim = (r + dabs(r)) / (1.d0 + dabs(r))
      return
c
   40 continue
c     ------------------------------
c     # monotinized centered 
c     ------------------------------
      c = (1.d0 + r)/2.d0
      philim = dmax1(0.d0, dmin1(c, 2.d0, 2.d0*r))
      return
c
   50 continue
c     ------------------------------
c     # Beam-Warming
c     ------------------------------
      philim = r

      return
      end

c
c --------------------------------------------------------------
c
      subroutine preicall(val,aux,nrow,nvar,naux,
     1                    ilo,ihi,level,fliparray)
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension fliparray((nrow)*nghost*(nvar+naux))
      dimension val(nvar,nrow)
      dimension aux(naux,nrow)

      dimension ist(3), iend(3), ishift(3)
      logical   xint
      
      !for setaux timing
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish
c
c NEW INDEXING - ORDER SWITCHED
      iadd   (ivar,i)  = locflip    + ivar-1 + nvar*(i-1)
      iaddaux(iaux,i)  = locflipaux + iaux-1 + naux*(i-1)

c
c  :::::::::::::: PREICALL :::::::::::::::::::::::::::::::::::::::::::
c     For periodic boundary conditions more work needed to initialize a
c     new grid that sticks out. This routine was
c     called because the patch sticks out of the domain,
c     and has periodic bc.s preprocess the patch before calling
c     icall to shift the patch periodically back into the domain.
c
c     Inputs to this routine:
c     ilo,ihi = the location in index space of this patch.
c
c     Outputs from this routine:
c     The values of the grid are inserted
c     directly into the enlarged val array for this piece.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
!     ## fliparray now passed in; index into it below
        locflip = 1
        locflipaux = 1 + nvar*(nrow)
c
c     ## will divide patch into 3 possibilities (some empty):
c     ## x sticks out left, x interior, x sticks out right
c     ## for example, the max. would be
c     ## i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)

        if (xperdom) then
           ist(1)    = ilo
           ist(2)    = 0
           ist(3)    = iregsz(level)
           iend(1)   = -1
           iend(2)   = iregsz(level)-1
           iend(3)   = ihi
           ishift(1) = iregsz(level)
           ishift(2) = 0
           ishift(3) = -iregsz(level)
        else   ! if not periodic, set vals to only have nonnull intersection for interior regoin
           ist(1)    = iregsz(level)
           ist(2)    = ilo
           ist(3)    = iregsz(level)
           iend(1)   = -nghost
           iend(2)   = ihi
           iend(3)   = -nghost
           ishift(1) = 0
           ishift(2) = 0
           ishift(3) = 0
        endif

c      ## loop over the 3 regions (in 1D) of the patch - the interior is i=2 plus
c      ## the ghost cell regions.  If any parts stick out of domain and are periodic
c      ## map indices periodically, but stick the values in the correct place
c      ## in the orig grid (indicated by iputst,jputst.
c      ## if a region sticks out of domain  but is not periodic, not handled in (pre)-icall 
c      ## but in setaux/bcamr (not called from here).
       do 20 i = 1, 3
          i1 = max(ilo,  ist(i))
          i2 = min(ihi, iend(i))
          if (i1 .le. i2) then ! part of patch in this region
c
               iputst = i1 - ilo + 1
               call icall(val,aux,nrow,nvar,naux,
     1                       i1+ishift(i),i2+ishift(i),level,
     2                       iputst)

          endif


 20    continue


      return
      end

subroutine rp1(maxmx,meqn,mwaves,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
!
!   Riemann solver for linearized multilayer shallow water equations
!

    use parameters_module

    implicit none
    
    ! Input arguments
    integer, intent(in) :: maxmx,meqn,mwaves,mbc,mx
    
    double precision, intent(in), dimension(1-mbc:maxmx+mbc, meqn) :: ql,qr
    double precision, intent(inout), dimension(1-mbc:maxmx+mbc, *) :: auxl,auxr
    
    ! Output arguments
    double precision, intent(out) :: s(1-mbc:maxmx+mbc, mwaves)
    double precision, intent(out) :: fwave(1-mbc:maxmx+mbc, meqn, mwaves)
    double precision, intent(out), dimension(1-mbc:maxmx+mbc, meqn) :: amdq,apdq
    
    ! Locals
    integer :: i,j,m,mw,ipiv(4),info,rare
    double precision :: eig_vec(4,4),A(4,4),delta(4),alpha(4),beta(4)
    double precision, dimension(4) :: flux_l,flux_r
    double precision, dimension(2) :: h_l,u_l,hu_l,h_r,u_r,hu_r,h_ave,u_ave
    double precision :: b_l,b_r,gamma_l,gamma_r,tau,w_l,w_r
    double precision :: wind_speed,lambda(4),eta_l(2),eta_r(2),h_hat_l(2),h_hat_r(2)
    logical :: dry_state_l(2), dry_state_r(2)
    
    integer :: layer_index
    double precision :: momentum_transfer(2),flux_transfer_r,flux_transfer_l

    ! Common block
    double precision :: dt,dx,t
    common /comxt/ dt,dx,t

    ! Initialize return variables
    amdq = 0.d0
    apdq = 0.d0

    !          |          |          
    !          |          |          
    !          |          |          
    !----------|----------|----------
    !    i-1         i         i+1
    !  qr(i-1)  ql(i)
    !     Riemann problem at i-1/2 is between qr(i-1) (left state) and ql(i) 
    !     (right state)
    do i=2-mbc,mx+mbc
        dry_state_l = .false.
        dry_state_r = .false.
        
        ! These state variables are the actual depth and momenta
        do j=1,2
            layer_index = 2*(j-1)
            h_l(j) = qr(i-1,layer_index+1) / rho(j)
            h_r(j) = ql(i,layer_index+1) / rho(j)
            hu_l(j) = qr(i-1,layer_index+2) / rho(j)
            hu_r(j) = ql(i,layer_index+2) / rho(j)
            
            h_hat_l(j) = auxr(i-1,j+2)
            h_hat_r(j) = auxl(i,j+2)
            
            ! Check for dry states in this layer
            if (h_l(j) < dry_tolerance) then
                dry_state_l(j) = .true.
                h_l(j) = 0.d0
                u_l(j) = 0.d0
            else
                u_l(j) = qr(i-1,layer_index+2) / qr(i-1,layer_index+1)
            endif
            if (h_r(j) < dry_tolerance) then
                dry_state_r(j) = .true.
                h_r(j) = 0.d0
                u_r(j) = 0.d0
            else
                u_r(j) = ql(i,layer_index+2) / ql(i,layer_index+1)
            endif
        enddo
        
        h_ave = 0.5d0 * (h_l(:) + h_r(:))
        
        b_l = auxr(i-1,1)
        b_r = auxl(i,1)
        w_l = auxr(i-1,2)
        w_r = auxl(i,2)
        
        ! Inundation test
        if (dry_state_r(2).and.(.not.dry_state_l(2)).and. &
                h_l(2) + b_l > b_r) then
            rare = 1
            stop "Right inundation problem not handled"
        else if (dry_state_l(2).and.(.not.dry_state_r(2)).and. &
                h_r(2) + b_r > b_l) then
            rare = 2
            stop "Left inundation problem not handled"
        else
            rare = 0
        endif
        
        ! Solve Single layer problem seperately
        if (dry_state_r(2).and.dry_state_l(2)) then
            call single_layer_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,lambda,eig_vec)
            s(i,:) = lambda
            
            delta(1) = rho(1) * (hu_r(1) - hu_l(1))
            flux_r(2) = rho(1) * (h_r(1) * u_r(1)**2 + 0.5d0 * g * h_r(1)**2)
            flux_l(2) = rho(1) * (h_l(1) * u_l(1)**2 + 0.5d0 * g * h_l(1)**2)
            delta(2) = flux_r(2) - flux_l(2) + g * rho(1) * h_ave(1) * (b_r - b_l)
            
            beta(1) = (delta(1)*s(i,4)-delta(2)) / (s(i,4)-s(i,1))
            beta(2) = 0.d0
            beta(3) = 0.d0
            beta(4) = (delta(2) - s(i,1)*beta(1)) / s(i,4)
            
            ! Calculate waves
            forall(mw=1:4)
                fwave(i,:,mw) = eig_vec(:,mw) * beta(mw)
            end forall
            cycle
        endif
        
        ! ====================================================================
        ! Calculate eigen-space values
        if (eigen_method == 1) then
            call linear_eigen(h_hat_l,h_hat_r,u_l,u_r,b_l,b_r,rare,lambda,eig_vec)
            s(i,:) = lambda
        else if (eigen_method == 2) then
            call linear_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,lambda,eig_vec)
            s(i,:) = lambda
        else if (eigen_method == 3) then 
            call velocity_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,lambda,eig_vec)
            s(i,:) = lambda
        else if (eigen_method == 4) then
            if (dry_state_r(2).and.(.not.dry_state_l(2)).or. &
                    dry_state_l(2).and.(.not.dry_state_r(2))) then
                call linear_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,lambda,eig_vec)
                s(i,:) = lambda
            else
                call exact_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,lambda,eig_vec)
                s(i,:) = lambda
            endif
        else
            stop "Invalid eigensystem method requested, method = (1,4)."
        endif
        
        ! ====================================================================
        ! Calculate flux vector to be projected onto e-space
        ! Right state dry, left wet
        if (dry_state_r(2).and.(.not.dry_state_l(2))) then
            ! Inundation
            if (rare == 1) then
                stop "Inundation of right state not implemented."
            else
                h_r(2) = h_l(2)
                hu_r(2) = -hu_l(2)
                u_r(2) = -u_l(2)
                
                flux_transfer_r = 0.d0
                flux_transfer_l = 0.d0
                momentum_transfer(1) = g * rho(1) * h_ave(1) * (b_r - h_l(2) - b_l)
                momentum_transfer(2) = 0.d0
            endif
        ! Left state dry, right wet
        else if (dry_state_l(2).and.(.not.dry_state_r(2))) then
            ! Inundation
            if (rare == 2) then
                stop "Inundation of left state not implemented."
            else
                h_l(2) = h_r(2)
                hu_l(2) = -hu_r(2)
                u_l(2) = -u_r(2)
            
                flux_transfer_r = 0.d0
                flux_transfer_l = 0.d0
                momentum_transfer(1) = g * rho(1) * h_ave(1) * (b_r + h_r(2) - b_l)
                momentum_transfer(2) = 0.d0
            endif
        ! Fully wet bottom layer
        else
            momentum_transfer(1) =  g * rho(1) * h_ave(1) * (h_r(2) - h_l(2) + b_r - b_l)
            momentum_transfer(2) = -g * rho(1) * h_ave(1) * (h_r(2) - h_l(2)) + g * rho(2) * h_ave(2) * (b_r - b_l)
            flux_transfer_r = g * rho(1) * h_r(1) * h_r(2)
            flux_transfer_l = g * rho(1) * h_l(1) * h_l(2)
        endif
        
        do j=1,2
            layer_index = 2*(j-1)
            flux_r(layer_index+1) = rho(j) * hu_r(j)
            flux_r(layer_index+2) = rho(j) * (h_r(j) * u_r(j)**2 + 0.5d0 * g * h_r(j)**2)
            
            flux_l(layer_index+1) = rho(j) * hu_l(j)
            flux_l(layer_index+2) = rho(j) * (h_l(j) * u_l(j)**2 + 0.5d0 * g * h_l(j)**2)
        enddo
        
        ! Add extra flux terms
        flux_r(4) = flux_r(4) + flux_transfer_r
        flux_l(4) = flux_l(4) + flux_transfer_l
        
        delta = flux_r - flux_l
        
        ! Momentum transfer and bathy terms
        delta(2) = delta(2) + momentum_transfer(1)
        delta(4) = delta(4) + momentum_transfer(2)
        
        ! Wind forcing
        wind_speed = 0.5d0 * (w_l + w_r)
        tau = wind_drag(wind_speed) * rho_air * wind_speed
        delta(2) = delta(2) - tau * wind_speed


        ! ====================================================================
        ! Solve system, solution is stored in delta
        A = eig_vec
        call dgesv(4,1,A,4,ipiv,delta,4,info)
        if (.not.(info == 0)) then 
            print *, "Location (i) = (",i,")"
            print *, "Dry states, L=",dry_state_l(2)," R=",dry_state_r(2)
            print *, "h_l(2) = ",h_l(2)," h_r(2) = ",h_r(2)
            print *, "Error solving R beta = delta, ",info
            print *, "Eigen-speeds:",(s(i,mw),mw=1,mwaves)
            print *, "Eigen-vectors:"
            do j=1,4
                print "(4d16.8)",(eig_vec(j,m),m=1,meqn)
            enddo
            stop
        endif
        beta = delta
        
        ! Calculate waves
        forall(mw=1:4)
            fwave(i,:,mw) = eig_vec(:,mw) * beta(mw)
        end forall
    enddo
    
    ! Calculate amdq and apdq
    do i=2-mbc,mx+mbc
        do mw=1,mwaves
            if (s(i,mw) > 0.d0) then
                apdq(i,:) = apdq(i,:) + fwave(i,:,mw)
            else                                     
                amdq(i,:) = amdq(i,:) + fwave(i,:,mw)
            endif
        enddo
    enddo

end subroutine rp1

subroutine linear_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,s,eig_vec)

    use parameters_module, only: r,g

    implicit none
    
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    logical, intent(in) :: rare
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    
    ! Locals
    double precision :: alpha(4),gamma_l,gamma_r

    if (rare == 1) then
        gamma_l = h_l(2) / h_l(1)

        alpha(1) = 0.5d0*(gamma_l-1.d0+sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
        alpha(2) = 0.5d0*(gamma_l-1.d0-sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))

        s(1) = -sqrt(g*h_l(1)*(1+alpha(1)))
        s(2) = -sqrt(g*h_l(1)*(1+alpha(2)))
        s(3) = u_l(2) + 2.d0 * sqrt(g*h_l(2))
        s(4) = u_r(1) + sqrt(g*h_r(1))
        
        eig_vec(1,1:2) = 1.d0
        eig_vec(2,1:2) = s(1:2)
        eig_vec(3,1:2) = alpha(1:2)
        eig_vec(4,1:2) = s(1:2)*alpha(1:2)
        
        eig_vec(:,3) = [0.d0,0.d0,1.d0,s(3)]
        eig_vec(:,4) = [1.d0,s(4),0.d0,0.d0]
        
    else if (rare == 2) then
        stop
    else
        gamma_l = h_l(2) / h_l(1)
        gamma_r = h_r(2) / h_r(1)

        alpha(1) = 0.5d0*(gamma_l-1.d0+sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
        alpha(2) = 0.5d0*(gamma_l-1.d0-sqrt((gamma_l-1.d0)**2+4.d0*r*gamma_l))
        alpha(3) = 0.5d0*(gamma_r-1.d0-sqrt((gamma_r-1.d0)**2+4.d0*r*gamma_r))
        alpha(4) = 0.5d0*(gamma_r-1.d0+sqrt((gamma_r-1.d0)**2+4.d0*r*gamma_r))

        s(1) = -sqrt(g*h_l(1)*(1+alpha(1)))
        s(2) = -sqrt(g*h_l(1)*(1+alpha(2)))
        s(3) = sqrt(g*h_r(1)*(1+alpha(3)))
        s(4) = sqrt(g*h_r(1)*(1+alpha(4)))
        
        eig_vec(1,:) = 1.d0
        eig_vec(2,:) = s(:)
        eig_vec(3,:) = alpha
        eig_vec(4,:) = s(:)*alpha(:)
    endif
    
end subroutine linear_eigen

subroutine velocity_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,s,eig_vec)

    use parameters_module, only: r,g,one_minus_r

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    logical, intent(in) :: rare
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    
    ! Locals
    double precision :: total_depth_l,total_depth_r,mult_depth_l,mult_depth_r
    double precision :: alpha(4)
    
    total_depth_l = sum(h_l)
    total_depth_r = sum(h_r)
    mult_depth_l = product(h_l)
    mult_depth_r = product(h_r)

    s(1) = (h_l(1)*u_l(1)+h_l(2)*u_l(2)) / total_depth_l &
          - sqrt(g*total_depth_l)
    s(2) = (h_l(2)*u_l(1)+h_l(1)*u_l(2)) / total_depth_l &
          - sqrt(g*one_minus_r*mult_depth_l/total_depth_l &
          * (1-(u_l(1)-u_l(2))**2/(g*one_minus_r*total_depth_l)))
    s(3) = (h_r(2)*u_r(1)+h_r(1)*u_r(2)) / total_depth_r &
          + sqrt(g*one_minus_r*mult_depth_r/total_depth_r &
          * (1-(u_r(1)-u_r(2))**2/(g*one_minus_r*total_depth_r)))
    s(4) = (h_r(1)*u_r(1)+h_r(2)*u_r(2)) / total_depth_r &
            + sqrt(g*total_depth_r)

    alpha(1:2) = ((s(1:2) - u_l(1))**2 - g * h_l(1)) / (g*h_l(1))
    alpha(3:4) = ((s(3:4) - u_r(1))**2 - g * h_r(1)) / (g*h_r(1))

    eig_vec(1,:) = 1.d0
    eig_vec(2,:) = s(:)
    eig_vec(3,:) = alpha
    eig_vec(4,:) = s(:)*alpha(:)

end subroutine velocity_eigen

subroutine exact_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,s,eig_vec)

    use parameters_module, only: r,g

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    logical, intent(in) :: rare
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    
    ! Local
    integer, parameter :: lwork = 4*4
    integer :: j,info
    double precision :: A(4,4),h_ave(2),u_ave(2)
    double precision :: real_evalues(4),imag_evalues(4)
    double precision :: empty,work(1,lwork)
    
    
    ! Solve eigenvalue problem
    h_ave(:) = 0.5d0 * (h_l(:) + h_r(:))
    u_ave(:) = 0.5d0 * (u_l(:) + u_r(:))
    A(1,:) = [0.d0,1.d0,0.d0,0.d0]
    A(2,:) = [-u_ave(1)**2 + g*h_ave(1),2.d0*u_ave(1),g*h_ave(1),0.d0]
    A(3,:) = [0.d0,0.d0,0.d0,1.d0]
    A(4,:) = [g*r*h_ave(2),0.d0,-u_ave(2)**2 + g*h_ave(2),2.d0*u_ave(2)]
    call dgeev('N','V',4,A,4,real_evalues,imag_evalues,empty,1,eig_vec,4,work,lwork,info)
    if (info < 0) then
        info = -info
        print "(a,i1,a)","The ",info,"th argument had an illegal value."
        stop
    else if (info > 0) then
        print "(a)","The QR algorithm failed to compute all the"
        print "(a)","eigenvalues, and no eigenvectors have been"
        print "(a,i1,a)","computed; elements",info,"+1:4 of WR and WI"
        print "(a)","contain eigenvalues which have converged."
        stop
    endif
    do j=1,4
!         if (eig_vec(1,j) /= 0.d0) then
!             eig_vec(:,j) = eig_vec(:,j) / eig_vec(1,j)
!         endif
        if (imag_evalues(j) > 0.d0) then
            print "(a,i1,a,d16.8)","Imaginary eigenvalue(",j,") > 0.0",imag_evalues(j)
            stop
        endif
        s(j) = real_evalues(j)
    enddo
end subroutine exact_eigen

subroutine single_layer_eigen(h_l,h_r,u_l,u_r,b_l,b_r,rare,s,eig_vec)

    use parameters_module, only: g

    implicit none
    
    ! I/O
    double precision, intent(in) :: h_l(2),h_r(2),u_l(2),u_r(2),b_l,b_r
    logical, intent(in) :: rare
    double precision, intent(inout) :: s(4),eig_vec(4,4)
    
    s(1) = u_l(1) - sqrt(g*h_l(1))
    s(2) = 0.d0
    s(3) = 0.d0
    s(4) = u_r(1) + sqrt(g*h_r(1))
    
    eig_vec(1,:) = 1.d0
    eig_vec(2,:) = s(:)
    eig_vec(3,:) = 0.d0
    eig_vec(4,:) = 0.d0

end subroutine single_layer_eigen

    subroutine roe_solver(ixy,uv,enth,delta,wave_local,s_local,info)
    implicit none

    double precision :: uv(2),enth, delta(4)
    double precision :: wave_local(3,4), s_local(3)
    double precision :: euv, c2, c, u2v2, u,v
    double precision :: a1, a2, a3, a4, a5
    double precision :: gamma, gamma1
    integer :: m, p, mu, mv, ixy, i, j, k, info

    common /cparam/ gamma, gamma1


    info = 0

    gamma1 = gamma - 1.d0

!     # These are used even in the mapped case, but ixy is
!     # always set to 1;  rotation matrix rot does switches
!     # coordinates for us.
    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    u = uv(mu-1)
    v = uv(mv-1)

    u2v2 = u*u + v*v
    c2 = gamma1*(enth - 0.5d0*u2v2)
    if (c2 < 1e-13) then
        info = 1
        write(6,*) 'Roe solver : '
        write(6,'(A,E16.8, E16.8)') 'c2 .lt. 0; ', c2
        return
    !         stop
    endif
    c = sqrt(c2) !! sound speed
    euv = enth - u2v2

    a2 = (gamma1/c2) * (euv*delta(1) + u*delta(mu) + v*delta(mv) &
    - delta(4))
    a3 = delta(mv) - v*delta(1)
    a4 = (delta(mu) + (c-u)*delta(1) - c*a2) / (2.d0*c)
    a1 = delta(1) - a2 - a4

!     # 1-wave (rarefaction or shock)
    wave_local(1,1)  = a1
    wave_local(1,mu) = a1*(u-c)
    wave_local(1,mv) = a1*v
    wave_local(1,4)  = a1*(enth - u*c)
    s_local(1) = u - c

!     # contact discontinuity
    wave_local(2,1)  = a2
    wave_local(2,mu) = a2*u
    wave_local(2,mv) = a2*v  + a3
    wave_local(2,4)  = a2*0.5d0*u2v2 + a3*v
    s_local(2) = u

!     # 3-wave (rarefaction or shock)
    wave_local(3,1)  = a4
    wave_local(3,mu) = a4*(u+c)
    wave_local(3,mv) = a4*v
    wave_local(3,4)  = a4*(enth + u*c)
    s_local(3) = u + c

    end subroutine roe_solver

c ------------------------------------------------------------------

        subroutine fixcapaq(val,aux,mitot,mjtot,valc,auxc,mic,mjc,
     &                      nvar,naux,levc,setflags)

      use amr_module
      implicit double precision (a-h,o-z)

c
c :::::::::::::::::::::::  FIXCAPAQ ::::::::::::::::::::::::::::::
c  new fine grid solution q was linearly interpolated. but want
c  to conserve kappa*q, not q. calculate the discrepancy
c  in kappa*q using this q, and modify q to account for it.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      dimension   val(nvar,mitot,mjtot), valc(nvar,mic,mjc)
      dimension   aux(naux,mitot,mjtot), auxc(naux,mic,mjc)
      dimension   setflags(mitot,mjtot)

      dcapamax = 0.d0
      lratiox  = intratx(levc)
      lratioy  = intraty(levc)

      do ic = 2, mic-1
      do jc = 2, mjc-1


       do 15 ivar = 1, nvar

       capaqfine = 0.d0

       do ico = 1, lratiox
       ifine = (ic-2)*lratiox + nghost + ico
       do jco = 1, lratioy
         jfine = (jc-2)*lratioy + nghost + jco
         capaqfine = capaqfine + aux(mcapa,ifine,jfine)*
     &                           val(ivar,ifine,jfine)
       end do
       end do

       dcapaq = auxc(mcapa,ic,jc)*valc(ivar,ic,jc)-
     &          capaqfine/(lratiox*lratioy)
       dcapamax = dmax1(dcapamax,dabs(dcapaq))
      
       do ico = 1, lratiox
       ifine = (ic-2)*lratiox + nghost + ico
       do jco = 1, lratioy
         jfine = (jc-2)*lratioy + nghost + jco

         if (setflags(ifine,jfine) .eq. NEEDS_TO_BE_SET) then 
         ! was set by coarsegrid, need to check for adjustment
           val(ivar,ifine,jfine) = val(ivar,ifine,jfine) +
     &                             dcapaq/aux(mcapa,ifine,jfine)
         endif
       end do
       end do

15     continue

       end do
       end do

c      write(6,*)" max discrepancy ", dcapamax

       return
       end

c
c -----------------------------------------------------------
c
!> Synchronize between all grids on level **level** and grids on
!! level **level**+1.
!! The synchronization includes averaging solution from 
!! level **level**+1 down to level **level** and conservation
!! fix-up near the fine-coarse interface between level **level**
!! grids and level **level**+1 grids.
!!
!! This routine assumes cell centered variables.
!! \param[in] level the only level to be updated (synchronized on). levels coarser than
!! this will be at a diffeent time.
!! \param[in] nvar number of equations for the system
!! \param[in] naux number of auxiliary variables
      subroutine update (level, nvar, naux)
c
          use amr_module
          implicit double precision (a-h,o-z)


          integer listgrids(numgrids(level))

c$$$  OLD INDEXING
c$$$      iadd(i,j,ivar)  = loc     + i - 1 + mitot*((ivar-1)*mjtot+j-1)
c$$$      iaddf(i,j,ivar) = locf    + i - 1 + mi*((ivar-1)*mj  +j-1)
c$$$      iaddfaux(i,j)   = locfaux + i - 1 + mi*((mcapa-1)*mj + (j-1))
c$$$      iaddcaux(i,j)   = loccaux + i - 1 + mitot*((mcapa-1)*mjtot+(j-1))

c   NEW INDEXING, ORDER SWITCHED
          iadd(ivar,i,j)  = loc    + ivar-1 + nvar*((j-1)*mitot+i-1)
          iaddf(ivar,i,j) = locf   + ivar-1 + nvar*((j-1)*mi+i-1)
          iaddfaux(i,j)   = locfaux + mcapa-1 + naux*((j-1)*mi + (i-1))
          iaddcaux(i,j)   = loccaux + mcapa-1 + naux*((j-1)*mitot+(i-1))
c
c
c :::::::::::::::::::::::::: UPDATE :::::::::::::::::::::::::::::::::
c update - update all grids at level 'level'.
c          this routine assumes cell centered variables.
c          the update is done from 1 level finer meshes under it.
c input parameter:
c    level  - ptr to the only level to be updated. levels coarser than
c             this will be at a diffeent time.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      lget = level
      if (uprint) write(outunit,100) lget
100   format(19h    updating level ,i5)
c     need to set up data structure for parallel distrib of grids
c     call prepgrids(listgrids,numgrids(level),level)

c
c  grid loop for each level
c
      dt     = possk(lget)

c      mptr = lstart(lget)
c 20   if (mptr .eq. 0) go to 85


!$OMP PARALLEL DO PRIVATE(ng,mptr,loc,loccaux,nx,ny,mitot,mjtot,
!$OMP&                    ilo,jlo,ihi,jhi,mkid,iclo,jclo,
!$OMP&                    ichi,jchi,mi,mj,locf,locfaux,
!$OMP&                    iplo,jplo,iphi,jphi,iff,jff,totrat,i,j,
!$OMP&                    ivar,ico,jco,capa,levSt),
!$OMP&         SHARED(lget,numgrids,listgrids,listsp,alloc,nvar,naux,
!$OMP&                   intratx,intraty,nghost,uprint,mcapa,node,
!$OMP&   listOfGrids,listStart,lstart,level),
!$OMP&         DEFAULT(none)

       do ng = 1, numgrids(lget)
         !mptr    = listgrids(ng)
         levSt   = listStart(lget)
         mptr    = listOfGrids(levSt + ng - 1)
         loc     = node(store1,mptr)
         loccaux = node(storeaux,mptr)
         nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         mitot   = nx + 2*nghost
         mjtot   = ny + 2*nghost
         ilo     = node(ndilo,mptr)
         jlo     = node(ndjlo,mptr)
         ihi     = node(ndihi,mptr)
         jhi     = node(ndjhi,mptr)
c
         if (node(cfluxptr,mptr) .eq. 0) go to 25
c         locuse = igetsp(mitot*mjtot)
         call upbnd(alloc(node(cfluxptr,mptr)),alloc(loc),nvar,
     1              naux,mitot,mjtot,listsp(lget),mptr)
c     1              mitot,mjtot,listsp(lget),alloc(locuse),mptr)
c         call reclam(locuse,mitot*mjtot)
c
c  loop through all intersecting fine grids as source updaters.
c
 25      mkid = lstart(lget+1)
 30        if (mkid .eq. 0) go to 80
           iclo   = node(ndilo,mkid)/intratx(lget)
           jclo   = node(ndjlo,mkid)/intraty(lget)
           ichi   = node(ndihi,mkid)/intratx(lget)
           jchi   = node(ndjhi,mkid)/intraty(lget)

           mi      = node(ndihi,mkid)-node(ndilo,mkid) + 1 + 2*nghost
           mj      = node(ndjhi,mkid)-node(ndjlo,mkid) + 1 + 2*nghost
           locf    = node(store1,mkid)
           locfaux = node(storeaux,mkid)
c
c  calculate starting and ending indices for coarse grid update, if overlap
c
         iplo = max(ilo,iclo)
         jplo = max(jlo,jclo)
         iphi = min(ihi,ichi)
         jphi = min(jhi,jchi)

         if (iplo .gt. iphi .or. jplo .gt. jphi) go to 75
c
c  calculate starting index for fine grid source pts.
c
         iff    = iplo*intratx(lget) - node(ndilo,mkid) + nghost + 1
         jff    = jplo*intraty(lget) - node(ndjlo,mkid) + nghost + 1
         totrat = intratx(lget) * intraty(lget)
 
         do 71 i = iplo-ilo+nghost+1, iphi-ilo+nghost+1
         do 70 j = jplo-jlo+nghost+1, jphi-jlo+nghost+1
           if (uprint) then
              write(outunit,101) i,j,mptr,iff,jff,mkid
 101          format(' updating pt. ',2i4,' of grid ',i3,' using ',2i4,
     1               ' of grid ',i4)
              write(outunit,102)(alloc(iadd(ivar,i,j)),ivar=1,nvar)
 102          format(' old vals: ',4e12.4)
           endif
c
c
c  update using intrat fine points in each direction
c
           do 35 ivar = 1, nvar
              alloc(iadd(ivar,i,j)) = 0.d0
 35        continue
c
           if (mcapa .eq. 0) then
               do 51 jco  = 1, intraty(lget)
               do 50 ico  = 1, intratx(lget)
               do 40 ivar = 1, nvar
                 alloc(iadd(ivar,i,j))= alloc(iadd(ivar,i,j)) + 
     1                        alloc(iaddf(ivar,iff+ico-1,jff+jco-1))
 40              continue
 50            continue
 51            continue
            do 60 ivar = 1, nvar
             alloc(iadd(ivar,i,j)) = alloc(iadd(ivar,i,j))/totrat
 60         continue
               
           else

               do 53 jco  = 1, intraty(lget)
               do 52 ico  = 1, intratx(lget)
               capa = alloc(iaddfaux(iff+ico-1,jff+jco-1))
               do 41 ivar = 1, nvar
                 alloc(iadd(ivar,i,j))= alloc(iadd(ivar,i,j)) + 
     1                  alloc(iaddf(ivar,iff+ico-1,jff+jco-1))*capa
 41              continue
 52            continue
 53            continue
            do 61 ivar = 1, nvar
             alloc(iadd(ivar,i,j)) = alloc(iadd(ivar,i,j))/
     1                               (totrat*alloc(iaddcaux(i,j)))
 61         continue
           endif
c
            if (uprint) write(outunit,103)(alloc(iadd(ivar,i,j)),
     .                                     ivar=1,nvar)
 103        format(' new vals: ',4e12.4)
c
           jff = jff + intraty(lget)
 70        continue
           iff = iff + intratx(lget)
           jff    = jplo*intraty(lget) - node(ndjlo,mkid) + nghost + 1
 71        continue
c
 75         mkid = node(levelptr,mkid)
            go to 30
c
 80         continue
            end do

!$OMP END PARALLEL DO

c
c 80         mptr = node(levelptr, mptr)
c            go to 20
c
c 85       continue
c
 99   return
      end

c===========================================================================
       function topointegral(xim,xip,yjm,yjp,
     &                   xxlow,yylow,dxx,dyy,mxx,myy,zz,intmethod)
c===========================================================================

c###########################################################################
c     topointegral integrates a surface over a rectangular region
c     that is the intersection with a Cartesion grid (of topography data)
c     the surface integrated is defined by a piecewise bilinear through the
c     nodes of the Cartesian grid.

c      The rectangular intersection has coords:
c      xim <= x <= xip, yjm <= y <= yjp
c
c      The Cartesian grid has coords:
c      xxlow <= x <= xxhi, yylow <= y <= yyhi, with grid cell size dxx by dyy
c      and mxx by myy cells.
c
c                                                written by David L. George
c                                                Seattle, WA 7/16/08
c###########################################################################

      use geoclaw_module

      implicit double precision (a-h,o-z)
      double precision zz(1:mxx,1:myy)

c     # initialize:
      theintegral = 0.d0

      xxhi=xxlow+(mxx-1)*dxx
      yyhi=yylow+(myy-1)*dyy

c========TEST FOR SMALL ROUNDING ERROR==========
      if ((xim-xxlow).lt.0.d0.or.(xip-xxhi).gt.0.d0) then
         xim=dmax1(xxlow,xim)
         xip=dmin1(xxhi,xip)
         endif

      if ((yjm-yylow).lt.0.d0.or.(yjp-yyhi).gt.0.d0) then
         yjm=dmax1(yylow,yjm)
         yjp=dmin1(yyhi,yjp)
         endif
c=========================================

      dx=xip-xim
      dy=yjp-yjm

c=============INTEGRATE PIECEWISE BILINEAR OVER RECTANGULAR REGION====
      if (intmethod.eq.1) then !use bilinear method

c         don't waste time looping through the entire grid
c         just find indices that include the rectangular region

         djjstart=(yjm-yylow)/dyy
         jjstart=idint(djjstart)+1

         diistart=(xim-xxlow)/dxx
         iistart=idint(diistart)+1

         diiend=(xip-xxlow)/dxx
         iiend=ceiling(diiend) + 1

         djjend=(yjp-yylow)/dyy
         jjend=ceiling(djjend)+1

         iistart=max(iistart,1)
         jjstart=max(jjstart,1)
         iiend=min(mxx,iiend)
         jjend=min(myy,jjend)


         do jj=jjstart,jjend-1
            y1=yylow + (jj-1.d0)*dyy
            y2=yylow + (jj)*dyy
c           # the array zz is indexed from north to south: jjz is the actual index
c           # of interest in the array zz
            jjz1= myy-jj+1
            jjz2= jjz1-1

            do ii=iistart,iiend-1
               x1=xxlow + (ii-1.d0)*dxx
               x2=xxlow + (ii)*dxx

               z11 = zz(ii,jjz1)
               z12 = zz(ii,jjz2)
               z21 = zz(ii+1,jjz1)
               z22 = zz(ii+1,jjz2)

               if (coordinate_system.eq.1) then !cartesian rectangle
                  theintegral = theintegral + bilinearintegral(
     &                                         xim,xip,yjm,yjp,
     &                                         x1,x2,y1,y2,
     &                                         dxx,dyy,
     &                                         z11,z12,z21,z22)
                elseif (coordinate_system.eq.2) then !integrate on surface of sphere
                  theintegral = theintegral + bilinearintegral_s(
     &                                         xim,xip,yjm,yjp,
     &                                         x1,x2,y1,y2,
     &                                         dxx,dyy,
     &                                         z11,z12,z21,z22)
                else
                  write(*,*)  'TOPOINTEGRAL: coordinate_system error'
                  endif
               enddo
            enddo

      else
         write(*,*) 'TOPOINTEGRAL: only intmethod = 1,2 is supported'
         endif

      topointegral= theintegral
      return
      end function

!   =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
!   =====================================================

        implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for 2D Burgers' equation
!
!     # Split asdq into eigenvectors of Roe matrix B.
!     # For the scalar equation, this simply amounts to computing the
!     # transverse wave speed from the opposite Riemann problem.

        dimension    ql(meqn, 1-mbc:maxm+mbc)
        dimension    qr(meqn, 1-mbc:maxm+mbc)
        dimension   asdq(meqn, 1-mbc:maxm+mbc)
        dimension bmasdq(meqn, 1-mbc:maxm+mbc)
        dimension bpasdq(meqn, 1-mbc:maxm+mbc)
        
!     # x- and y- Riemann problems are identical, so it doesn't matter if
!     # ixy=1 or 2.

        do 10 i = 2-mbc, mx+mbc
            sb = 0.5d0*(qr(1,i-1) + ql(1,i))
            bmasdq(1,i) = dmin1(sb, 0.d0) * asdq(1,i)
            bpasdq(1,i) = dmax1(sb, 0.d0) * asdq(1,i)
        10 continue
        
    return
    end subroutine rpt2

!  Generic driver routine for 3D Clawpack 5.0, using claw3ez
!  Allocation has been moved int claw3ez; this file essentially
!  does nothing, but is being retained because it gives the
!  codebase more flexibility.
program driver
    implicit none

    call claw3ez

    stop
end program driver

c
c     =====================================================
      subroutine mapc2p(xc,yc,xp,yp)
c     =====================================================
c
c     # on input,  (xc,yc) is a computational grid point
c     # on output, (xp,yp) is corresponding point in physical space
c
      implicit double precision (a-h,o-z)
c
c     # Polar coordinates, xc = r,  yc = theta
      xp = xc * dcos(yc) 
      yp = xc * dsin(yc)
      return
      end

c     ============================================
      subroutine b4step2(mbc,mx,my,meqn,q,
     &            xlower,ylower,dx,dy,time,dt,maux,aux)
c     ============================================
c
c     # called before each call to step
c     # use to set time-dependent aux arrays or perform other tasks.
c
c     # make velocity time dependent, reversing flow.
c
c     
      implicit double precision (a-h,o-z)
      dimension q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      common /comvt/ tperiod,pi2
c
      if (tperiod .eq. 0.d0) then
c        # special case --- indication that velocities specified in 
c        # setaux should be used for all time.
         return
         endif

       vt = dcos(pi2*(time+dt/2.d0)/tperiod)
c
       do 200 i=1-mbc,mx+mbc
          do 100 j=1-mbc,my+mbc
c           # coordinates of lower left corner of grid cell:
            xll = xlower + (i-1)*dx
            yll = ylower + (j-1)*dy

c           # difference stream function psi to get normal velocities:
            aux(1,i,j) = -(psi(xll, yll+dy) - psi(xll,yll)) / dy
            aux(2,i,j) =  (psi(xll+dx, yll) - psi(xll,yll)) / dx
c
c           # multiply by time-factor:
            aux(1,i,j) = vt * aux(1,i,j)
            aux(2,i,j) = vt * aux(2,i,j)
  100        continue
  200     continue
       return
       end

!-----------------------------------------------------------------------------------
! Name: rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
!
! Description: Roe-solver for the 3D Euler Equations
!
! waves: 3
! equations: 5
!
! Conserved quantities:
!       1 density
!       2 x_momentum
!       3 y_momentum
!       4 z_momentum
!       5 energy
!
! Inputs: 
!         ixyz <INTEGER>   : input values are a slice along: x-direction if ixyz=1;
!                                                            y-direction if ixyz=2;
!                                                            z-direction if ixyz=3.
!         maxm <INTEGER>   : max number of grid cells (excluding ghost cells)
!         meqn <INTEGER>   : number of equations in the system (=5)
!         mwaves <INTEGER> : number of waves in approximate Riemann solution (=3)
!                            This solver ignores the zero-velocity shear waves
!                            since they don't affect the cell updates
!         maux <INTEGER>   : number of auxilary variables (not used)
!         mbc <INTEGER>    : number of ghost cells at each boundary
!         mx <INTEGER>     : number of elements in slice
!         ql <REAL>        : state vector at left edge of each cell
!                            Note that the i'th Riemann problem has left state qr(:,i-1)
!         qr <REAL>        : state vector at right edge of each cell
!                            Note that the i'th Riemann problem has right state ql(:,i)
!         auxl <REAL>      : state of auxiliary variable on left edge of cell 
!         auxr <REAL>      : state of auxiliary variable on right egde of cell 
!         
! Outputs: 
!          wave <REAL>     : q-wave vectors (eigenvectors of Roe matrix)
!          s <REAL>        : wave speeds (eigenvalues of Roe matrix)
!          amdq <REAL>     : left-going fluctuations
!          apdq <REAL>     : right-going fluctuations
!
! Adapted from rpn3_euler.f90 in $CLAWHOME/riemann/src
!-----------------------------------------------------------------------------------
SUBROUTINE rpn3(ixyz,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)

    IMPLICIT NONE

    ! Input
    INTEGER, INTENT(IN) :: ixyz,maxm,meqn,mwaves,maux,mbc,mx
    REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(IN) :: ql,qr
    REAL(kind=8), DIMENSION(maux,1-mbc:maxm+mbc), INTENT(IN) :: auxl,auxr

    ! Output
    REAL(kind=8), DIMENSION(meqn,mwaves,1-mbc:maxm+mbc), INTENT(INOUT) :: wave
    REAL(kind=8), DIMENSION(mwaves,1-mbc:maxm+mbc), INTENT(INOUT) :: s
    REAL(kind=8), DIMENSION(meqn,1-mbc:maxm+mbc), INTENT(INOUT) :: amdq,apdq
  
    ! Local Storage
    INTEGER, PARAMETER :: maxmrp = 1002
    REAL(kind=8), DIMENSION(5) :: delta,alpha
    REAL(kind=8), DIMENSION(-1:maxmrp) :: u2v2w2,u,v,w,enth,a,g1a2,euv
    REAL(kind=8) :: asqrd,c1,c2,ci,cim1,en1,en2,p1,p2,pi,pim1,pl,pr,&
                    rho1,rho2,rhoi,rhoim1,rhou1,rhou2,rhov1,rhov2,rhow1,rhow2,&
                    rhsq2,rhsqrtl,rhsqrtr,s0,s1,s2,s3,sfract,df
    INTEGER :: i,j,m,mu,mv,mw,mws

    ! Use entropy fix for transonic rarefactions
    LOGICAL, PARAMETER :: efix = .TRUE.
  
    REAL(kind=8) :: gamma,gamma1
    COMMON /cparam/ gamma         ! ideal gas constant

    gamma1 = gamma - 1.d0


    IF (maxmrp < maxm+2*mbc)THEN
        WRITE(6,*) 'need to increase maxmrp in rpn3_euler.f90'
        WRITE(6,*) 'maxmrp: ',maxmrp,' maxm: ',maxm,' mbc: ',mbc
        WRITE(6,*) 'maxm+mbc=',maxm+mbc
        STOP
    ENDIF

    IF (mwaves /= 3) THEN
        WRITE(6,*) '*** Must set mwaves=3 for this Riemann solver'
        STOP
    ENDIF
    
    ! Set mu to point to  the component of the system that corresponds to momentum in 
    !  the direction of this slice, mv and mw to the orthogonal momentum components:
    IF(ixyz == 1)THEN
        mu = 2
        mv = 3
        mw = 4
    ELSE IF(ixyz == 2)THEN
        mu = 3
        mv = 4
        mw = 2
    ELSE
        mu = 4
        mv = 2
        mw = 3
    ENDIF

    ! Note that notation for u,v, and w reflects assumption that the
    !   Riemann problems are in the x-direction with u in the normal
    !   direction and v and w in the orthogonal directions, but with the
    !   above definitions of mu, mv, and mw the routine also works with
    !   ixyz = 2 and ixyz = 3
    !   and returns, for example, f0 as the Godunov flux g0 for the
    !   Riemann problems u_t + g(u)_y = 0 in the y-direction.

    ! Initialize waves and speeds
    wave = 0.d0
    s = 0.d0

    ! Compute the Roe-averaged variables needed in the Roe solver.

    ! Loop over grid cell interfaces
    DO i = 2-mbc, mx+mbc
        IF (qr(1,i-1) <= 0.d0 .OR. ql(1,i) <= 0.d0) THEN
            WRITE(*,*) i, mu, mv, mw
            WRITE(*,'(5e12.4)') (qr(j,i-1),j=1,5)
            WRITE(*,'(5e12.4)') (ql(j,i),j=1,5)
            IF (ixyz == 1) &
                WRITE(6,*) '*** rho <= 0 in x-sweep at ',i
            IF (ixyz == 2) &
                WRITE(6,*) '*** rho <= 0 in y-sweep at ',i
            IF (ixyz == 3) &
                WRITE(6,*) '*** rho <= 0 in z-sweep at ',i
            WRITE(6,*) 'stopped with rho <= 0...'
            STOP
        ENDIF
        rhsqrtl = SQRT(qr(1,i-1))
        rhsqrtr = SQRT(ql(1,i))
        pl = gamma1*(qr(5,i-1) - 0.5d0*(qr(mu,i-1)**2 &
             + qr(mv,i-1)**2 + qr(mw,i-1)**2)/qr(1,i-1))
        pr = gamma1*(ql(5,i) - 0.5d0*(ql(mu,i)**2 &
             + ql(mv,i)**2 + ql(mw,i)**2)/ql(1,i))
        rhsq2 = rhsqrtl + rhsqrtr
        u(i) = (qr(mu,i-1)/rhsqrtl + ql(mu,i)/rhsqrtr) / rhsq2
        v(i) = (qr(mv,i-1)/rhsqrtl + ql(mv,i)/rhsqrtr) / rhsq2
        w(i) = (qr(mw,i-1)/rhsqrtl + ql(mw,i)/rhsqrtr) / rhsq2
        enth(i) = (((qr(5,i-1)+pl)/rhsqrtl &
                  + (ql(5,i)+pr)/rhsqrtr)) / rhsq2
        u2v2w2(i) = u(i)**2 + v(i)**2 + w(i)**2
        asqrd = gamma1*(enth(i) - .5d0*u2v2w2(i))
     
        IF (i>=0 .AND. i<=mx .AND. asqrd <= 0.d0) THEN
            IF (ixyz == 1) &
                WRITE(6,*) '*** a**2 <= 0 in x-sweep at ',i
            IF (ixyz == 2) &
                WRITE(6,*) '*** a**2 <= 0 in y-sweep at ',i
            IF (ixyz == 3) &
                WRITE(6,*) '*** a**2 <= 0 in z-sweep at ',i
            WRITE(6,*) 'stopped with a**2 < 0...'
            STOP
        ENDIF
        a(i) = SQRT(asqrd)
        g1a2(i) = gamma1 / asqrd
        euv(i) = enth(i) - u2v2w2(i)
    END DO

    ! Now split the jump in q1d at each interface into waves

    ! Find alpha(1) thru alpha(5), the coefficients of the 5 eigenvectors:
    DO i = 2-mbc, mx+mbc
        delta(1) = ql(1,i) - qr(1,i-1)
        delta(2) = ql(mu,i) - qr(mu,i-1)
        delta(3) = ql(mv,i) - qr(mv,i-1)
        delta(4) = ql(mw,i) - qr(mw,i-1)
        delta(5) = ql(5,i) - qr(5,i-1)
        alpha(4) = g1a2(i) * (euv(i)*delta(1) &
                  + u(i)*delta(2) + v(i)*delta(3) + w(i)*delta(4) - delta(5))
        alpha(2) = delta(3) - v(i)*delta(1)
        alpha(3) = delta(4) - w(i)*delta(1)
        alpha(5) = (delta(2) + (a(i)-u(i))*delta(1) - a(i)*alpha(4)) / (2.d0*a(i))
        alpha(1) = delta(1) - alpha(4) - alpha(5)
     
        ! Compute the waves.
        !   Note that the 2-wave, 3-wave and 4-wave travel at the same speed
        !   and are lumped together in wave(.,2,.).  The 5-wave is then stored
        !   in wave(.,3,.).
        wave(1,1,i)  = alpha(1)
        wave(mu,1,i) = alpha(1)*(u(i)-a(i))
        wave(mv,1,i) = alpha(1)*v(i)
        wave(mw,1,i) = alpha(1)*w(i)
        wave(5,1,i)  = alpha(1)*(enth(i) - u(i)*a(i))
        s(1,i) = u(i)-a(i)
     
        wave(1,2,i)  = alpha(4)
        wave(mu,2,i) = alpha(4)*u(i)
        wave(mv,2,i) = alpha(4)*v(i) + alpha(2)
        wave(mw,2,i) = alpha(4)*w(i) + alpha(3)
        wave(5,2,i)  = alpha(4)*0.5d0*u2v2w2(i)  + alpha(2)*v(i) + alpha(3)*w(i)
        s(2,i) = u(i)
     
        wave(1,3,i)  = alpha(5)
        wave(mu,3,i) = alpha(5)*(u(i)+a(i))
        wave(mv,3,i) = alpha(5)*v(i)
        wave(mw,3,i) = alpha(5)*w(i)
        wave(5,3,i)  = alpha(5)*(enth(i)+u(i)*a(i))
        s(3,i) = u(i)+a(i)
    END DO

    amdq = 0.d0
    apdq = 0.d0

    IF (.NOT.efix) THEN
        !  No entropy fix

        ! compute fluctuations amdq and apdq
        !  amdq = SUM s*wave   over left-going waves
        !  apdq = SUM s*wave   over right-going waves

        DO i=2-mbc, mx+mbc
            DO mws=1,mwaves
                IF (s(mws,i) < 0.d0) THEN
                    amdq(:,i) = amdq(:,i) + s(mws,i)*wave(:,mws,i)
                ELSE
                    apdq(:,i) = apdq(:,i) + s(mws,i)*wave(:,mws,i)
                ENDIF
            END DO
        END DO

    ELSE
    ! With entropy fix

    ! Compute flux differences amdq and apdq.
    !   First compute amdq as sum of s*wave for left going waves.
    !   Incorporate entropy fix by adding a modified fraction of 
    !   transonic wave if s should change sign.

    DO i = 2-mbc, mx+mbc

        ! Check if 1-wave is transonic
        rhoim1 = qr(1,i-1)
        pim1 = gamma1*(qr(5,i-1) - 0.5d0*(qr(mu,i-1)**2 &
               + qr(mv,i-1)**2 + qr(mw,i-1)**2) / rhoim1)
        cim1 = SQRT(gamma*pim1/rhoim1)
        s0 = qr(mu,i-1)/rhoim1 - cim1  ! u-c in left state (cell i-1)

        ! Check for fully supersonic case:
        IF (s0 >= 0.d0 .AND. s(1,i) > 0.d0) CYCLE ! everything is right-going

        rho1 = qr(1,i-1) + wave(1,1,i)
        rhou1 = qr(mu,i-1) + wave(mu,1,i)
        rhov1 = qr(mv,i-1) + wave(mv,1,i)
        rhow1 = qr(mw,i-1) + wave(mw,1,i)
        en1 = qr(5,i-1) + wave(5,1,i)
        p1 = gamma1*(en1 - 0.5d0*(rhou1**2 + rhov1**2 + rhow1**2)/rho1)
        c1 = SQRT(gamma*p1/rho1)
        s1 = rhou1/rho1 - c1  ! u-c to right of 1-wave
        IF (s0 < 0.d0 .AND. s1 > 0.d0) THEN
            ! transonic rarefaction in the 1-wave
            sfract = s0 * (s1-s(1,i)) / (s1-s0)
        ELSE IF (s(1,i) < 0.d0) THEN
            ! 1-wave is leftgoing
            sfract = s(1,i)
        ELSE
            ! 1-wave is rightgoing
            sfract = 0.d0   ! this shouldn't happen since s0 < 0
        ENDIF
        amdq(:,i) = sfract*wave(:,1,i)
           
        ! Check if 2-wave is transonic
        IF (s(2,i) >= 0.d0) CYCLE ! 2- and 3-waves are right-going
        amdq(:,i) = amdq(:,i) + s(2,i)*wave(:,2,i)
        
        ! Check if 3-wave is transonic
        rhoi = ql(1,i)
        pi = gamma1*(ql(5,i) - 0.5d0*(ql(mu,i)**2+ql(mv,i)**2+ql(mw,i)**2)/rhoi)
        ci = SQRT(gamma*pi/rhoi)
        s3 = ql(mu,i)/rhoi + ci     ! u+c in right state  (cell i)
        
        rho2 = ql(1,i) - wave(1,3,i)
        rhou2 = ql(mu,i) - wave(mu,3,i)
        rhov2 = ql(mv,i) - wave(mv,3,i)
        rhow2 = ql(mw,i) - wave(mw,3,i)
        en2 = ql(5,i) - wave(5,3,i)
        p2 = gamma1*(en2 - 0.5d0*(rhou2**2 + rhov2**2 + rhow2**2)/rho2)
        c2 = SQRT(gamma*p2/rho2)
        s2 = rhou2/rho2 + c2   !# u+c to left of 3-wave
        IF (s2 < 0.d0 .AND. s3 > 0.d0 ) THEN
            ! transonic rarefaction in the 3-wave
            sfract = s2 * (s3-s(3,i)) / (s3-s2)
        ELSE IF (s(3,i) < 0.d0) THEN
            ! 3-wave is left-going
            sfract = s(3,i)
        ELSE
            ! 3-wave is right-going
           CYCLE
        ENDIF
        
        amdq(:,i) = amdq(:,i) + sfract*wave(:,3,i)
    END DO
     
    ! Compute the remaining right-going fluctuations:
    ! df = SUM s*wave   is the total flux difference and apdq = df - amdq
    DO m=1,meqn
        DO i = 2-mbc, mx+mbc
            df = 0.d0
            DO mws=1,mwaves
                df = df + s(mws,i)*wave(m,mws,i)
            END DO
            apdq(m,i) = df - amdq(m,i)
        END DO
    END DO

    END IF ! Entropy fix

END SUBROUTINE rpn3

c
c
c
c     =====================================================
      subroutine flux2(ixy,maxm,meqn,mwaves,maux,mbc,mx,
     &                 q1d,dtdx1d,aux1,aux2,aux3,method,mthlim,
     &               qadd,fadd,gadd,cfl1d,wave,s,
     &                 amdq,apdq,cqxx,bmasdq,bpasdq)
c     =====================================================
c
c     # Compute the modification to fluxes f and g that are generated by
c     # all interfaces along a 1D slice of the 2D grid. 
c     #    ixy = 1  if it is a slice in x
c     #          2  if it is a slice in y
c     # This value is passed into the Riemann solvers. The flux modifications
c     # go into the arrays fadd and gadd.  The notation is written assuming
c     # we are solving along a 1D slice in the x-direction.
c
c     # fadd(i,.) modifies F to the left of cell i
c     # gadd(i,.,1) modifies G below cell i
c     # gadd(i,.,2) modifies G above cell i
c
c     # The method used is specified by method(2:3):
c
c         method(2) = 1 if only first order increment waves are to be used.
c                   = 2 if second order correction terms are to be added, with
c                       a flux limiter as specified by mthlim.  
c
c         method(3) = 0 if no transverse propagation is to be applied.
c                       Increment and perhaps correction waves are propagated
c                       normal to the interface.
c                   = 1 if transverse propagation of increment waves 
c                       (but not correction waves, if any) is to be applied.
c                   = 2 if transverse propagation of correction waves is also
c                       to be included.  
c
c     Note that if method(6)=1 then the capa array comes into the second 
c     order correction terms, and is already included in dtdx1d:
c     If ixy = 1 then
c        dtdx1d(i) = dt/dx                 if method(6) = 0
c                  = dt/(dx*capa(i,jcom))  if method(6) = 1
c     If ixy = 2 then
c        dtdx1d(j) = dt/dy                 if method(6) = 0
c                  = dt/(dy*capa(icom,j))  if method(6) = 1
c
c     Notation:
c        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn2 into
c            amdq =  the left-going flux difference  A^- Delta q  
c            apdq = the right-going flux difference  A^+ Delta q  
c        Each of these is split by rpt2 into 
c            bmasdq = the down-going transverse flux difference B^- A^* Delta q
c            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
c        where A^* represents either A^- or A^+.
c
c
      USE rp2

      implicit double precision (a-h,o-z)
      dimension    q1d(meqn, 1-mbc:maxm+mbc)
      dimension   amdq(meqn, 1-mbc:maxm+mbc)
      dimension   apdq(meqn, 1-mbc:maxm+mbc)
      dimension bmasdq(meqn, 1-mbc:maxm+mbc)
      dimension bpasdq(meqn, 1-mbc:maxm+mbc)
      dimension   cqxx(meqn, 1-mbc:maxm+mbc)
      dimension   qadd(meqn, 1-mbc:maxm+mbc)
      dimension   fadd(meqn, 1-mbc:maxm+mbc)
      dimension   gadd(meqn, 2, 1-mbc:maxm+mbc)
c
      dimension dtdx1d(1-mbc:maxm+mbc)
      dimension aux1(maux,1-mbc:maxm+mbc)
      dimension aux2(maux,1-mbc:maxm+mbc)
      dimension aux3(maux,1-mbc:maxm+mbc)
c
      dimension     s(mwaves,1-mbc:maxm+mbc)
      dimension  wave(meqn, mwaves, 1-mbc:maxm+mbc)
c
      dimension method(7),mthlim(mwaves)
      logical limit
      common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom
c
      limit = .false.
      do 5 mw=1,mwaves
         if (mthlim(mw) .gt. 0) limit = .true.
   5  continue
c
c     # initialize flux increments:
c     -----------------------------
c
      forall (m=1:meqn, i = 1-mbc: mx+mbc)
	     qadd(m,i) = 0.d0
	     fadd(m,i) = 0.d0
	     gadd(m,1,i) = 0.d0
	     gadd(m,2,i) = 0.d0
      end forall
  
c
c     # solve Riemann problem at each interface and compute Godunov updates
c     ---------------------------------------------------------------------
c
      call rpn2(ixy,maxm,meqn,mwaves,mbc,mx,q1d,q1d,aux2,aux2,
     &        wave,s,amdq,apdq)
c
c     # Set qadd for the donor-cell upwind method (Godunov)
      forall(m=1:meqn, i=1:mx+1)
            qadd(m,i) = qadd(m,i) - dtdx1d(i)*apdq(m,i)
            qadd(m,i-1) = qadd(m,i-1) - dtdx1d(i-1)*amdq(m,i)
      end forall
c
c     # compute maximum wave speed for checking Courant number:
      cfl1d = 0.d0
      do 51 mw=1,mwaves
         do 50 i=1,mx+1
c          # if s>0 use dtdx1d(i) to compute CFL,
c          # if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i), 
     &                          -dtdx1d(i-1)*s(mw,i))
   50    continue
   51 continue
c
      if (method(2).eq.1) go to 130
c
c     # modify F fluxes for second order q_{xx} correction terms:
c     -----------------------------------------------------------
c
c     # apply limiter to waves:
      if (limit) call limiter(maxm,meqn,mwaves,mbc,mx,wave,s,mthlim)
c
      do 121 i = 2-mbc, mx+mbc
c
c     # For correction terms below, need average of dtdx in cell
c     # i-1 and i.  Compute these and overwrite dtdx1d:
c
c        # modified in Version 4.3 to use average only in cqxx, not transverse
         dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
c
         do 120 m=1,meqn
            cqxx(m,i) = 0.d0
            do 119 mw=1,mwaves
c
c              # second order corrections:
               cqxx(m,i) = cqxx(m,i) + dabs(s(mw,i))
     &            * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
c
  119       continue
            fadd(m,i) = fadd(m,i) + 0.5d0 * cqxx(m,i)
  120    continue
  121 continue
c
c
  130  continue
c
      if (method(3).le.0) go to 999   !# no transverse propagation
c
      if (method(2).gt.1 .and. method(3).eq.2) then
c        # incorporate cqxx into amdq and apdq so that it is split also.
         forall (m=1:meqn, i = 1: mx+1)
               amdq(m,i) = amdq(m,i) + cqxx(m,i)
               apdq(m,i) = apdq(m,i) - cqxx(m,i)
         end forall
      endif
c
c
c      # modify G fluxes for transverse propagation
c      --------------------------------------------
c
c
c     # split the left-going flux difference into down-going and up-going:
      call rpt2(ixy,maxm,meqn,mwaves,mbc,mx,q1d,q1d,aux1,aux2,aux3,
     &        1,amdq,bmasdq,bpasdq)
c
c     # modify flux below and above by B^- A^- Delta q and  B^+ A^- Delta q:
      forall ( m=1:meqn , i = 1:mx+1)
	     gadd(m,1,i-1) = gadd(m,1,i-1) - 
     &                 0.5d0*dtdx1d(i-1) * bmasdq(m,i)
	     gadd(m,2,i-1) = gadd(m,2,i-1) -
     &                 0.5d0*dtdx1d(i-1) * bpasdq(m,i)
	  end forall
 
c
c     # split the right-going flux difference into down-going and up-going:
      call rpt2(ixy,maxm,meqn,mwaves,mbc,mx,q1d,q1d,aux1,aux2,aux3,
     &        2,apdq,bmasdq,bpasdq)
c
c     # modify flux below and above by B^- A^+ Delta q and  B^+ A^+ Delta q:
      forall ( m=1:meqn , i = 1: mx+1)
            gadd(m,1,i) = gadd(m,1,i) - 
     &                0.5d0*dtdx1d(i) * bmasdq(m,i)
            gadd(m,2,i) = gadd(m,2,i) - 
     &                0.5d0*dtdx1d(i) * bpasdq(m,i)
      end forall
c
  999 continue
      return
      end

c
c ------------------------------------------------------
c
       subroutine intfil(val,mi,mj,mk,time,flaguse,nrowst,ncolst,nfilst,
     2                   ilo,ihi,jlo,jhi,klo,khi,level,nvar,naux,msrc)
c
c ::::::::::::::::::::::: INTFIL ::::::::::::::::::::::::::::::::;
c  INTFIL: interpolates values for a patch at the specified level and
c  location, using values from grids at LEVEL and coarser, if nec.
c
c  take the intersection of a grid patch with corners at
c  ilo,ihi,jlo,jhi,klo,khi
c  and all grids mptr at LEVEL.  If there is a non-null intersection
c  copy the solution vaues from mptr (at TIME) into VAL array.
c  assumes patch at same level so do straight copy, not skipping
c  every intrat or doing any interpolation here,
c  assume called in correct order of levels, so that when copying
c  is ok to overwrite.
c
c  N.B.: there are no dummy points around patch, since
c        this is not an official "grid" but a "patch".
c
c  used array marks when point filled. filpatch checks if points left over 
c  after intersections at specified level.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      use amr_module
      implicit double precision (a-h,o-z)

c
      dimension   val(nvar,mi,mj,mk)
      logical     tinterp
c
      iadd(ivar,i,j,k)   = loc    +    (ivar-1)
     &                            +    (i-1)*nvar
     &                            +    (j-1)*nvar*mitot
     &                            +    (k-1)*nvar*mitot*mjtot
      iadnew(ivar,i,j,k) = locnew +    (ivar-1)
     &                            +    (i-1)*nvar
     &                            +    (j-1)*nvar*mitot
     &                            +    (k-1)*nvar*mitot*mjtot
      iadold(ivar,i,j,k) = locold +    (ivar-1)
     &                            +    (i-1)*nvar
     &                            +    (j-1)*nvar*mitot
     &                            +    (k-1)*nvar*mitot*mjtot
      dimension flaguse(ilo:ihi, jlo:jhi, klo:khi)
c
      dt     = possk(level)
      teps   = dt / 10.

      nrow = ihi - ilo + 1
      ncol = jhi - jlo + 1
      nfil = khi - klo + 1
      do k = klo, khi
         do j = jlo, jhi
            do i = ilo, ihi
               flaguse(i,j,k) = 0.0
            end do
         end do
      end do

!      mptr   = lstart(level)
! 10   if (mptr .eq. 0) go to 105
       
      if (msrc .eq. -1) then ! use array of all grids at this level
         numg = numgrids(level)
         levSt = listStart(level)
      else  ! use new bndry list for each grid if at same level
         bndLoc = node(bndListSt,msrc)  ! index of first grid in bndList
         bndNum = node(bndListNum,msrc)
         nextSpot = node(bndListSt, msrc) ! initialize
         numg = bndNum
      endif

      do icount = 1, numg   ! combining old and new way to loop over grids
      
         if (msrc .eq. -1) then
            mptr = listOfGrids(levSt+icount-1)
         else
            mptr = bndList(nextSpot,gridNbor)
         endif
c
c     :::  check if grid mptr and patch intersect
c
      imlo = node(ndilo, mptr)
      jmlo = node(ndjlo, mptr)
      kmlo = node(ndklo, mptr)
      imhi = node(ndihi, mptr)
      jmhi = node(ndjhi, mptr)
      kmhi = node(ndkhi, mptr)

      nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
      mitot = nx + 2*nghost
      mjtot = ny + 2*nghost
      mktot = nz + 2*nghost

      ixlo = max(imlo,ilo)
      ixhi = min(imhi,ihi)
      jxlo = max(jmlo,jlo)
      jxhi = min(jmhi,jhi)
      kxlo = max(kmlo,klo)
      kxhi = min(kmhi,khi)
c
      if (.not.((ixlo .le. ixhi .and. jxlo .le. jxhi) .and.
     &          (kxlo .le. kxhi))) go to 90
c
c  :::  grids intersect. figure out what time to use.
c  :::  alphai = 1 for new time; 0 for old time
c
c     alphai = (time+dt - rnode(timemult,mptr)) / dt
c     alphac = 1.d0-alphai

      alphac = (rnode(timemult,mptr)-time)/dt
      alphai = 1.d0-alphac

      if ((alphai .lt. -teps) .or. (alphai .gt. 1.d0+teps)) then
          write(outunit,900) time, mptr, level
          write(*,900) time, mptr, level
 900      format(' time wanted ',e15.7,' not available from grid ',i4,
     1           'level',i4)
          write(outunit,901) ilo,ihi,jlo,jhi,klo,khi,mptr,level,time,
     .                 rnode(timemult,mptr),alphai,teps
          write(*,901) ilo,ihi,jlo,jhi,klo,khi,mptr,level,time,
     .                 rnode(timemult,mptr),alphai,teps
          call outtre(mstart,.false.,nvar,naux)
          stop
      endif
c
      tinterp = .false.
      if (dabs(alphai - 1.d0) .lt. teps) then
          loc = node(store1,mptr)
      else if (dabs(alphai) .lt. teps) then
          loc = node(store2,mptr)
          if (level .eq. mxnest) then
             write(outunit,901) ilo,ihi,jlo,jhi,klo,khi,mptr,level,time,
     .                          rnode(timemult,mptr),alphai,teps
             write(*,901) ilo,ihi,jlo,jhi,klo,khi,mptr,level,time,
     .                          rnode(timemult,mptr),alphai,teps
             stop
           endif
      else
          locold  = node(store2,mptr)
          locnew  = node(store1,mptr)
          tinterp = .true.
          if (level .eq. mxnest) then
             write(outunit,901) ilo,ihi,jlo,jhi,klo,khi,mptr,level,time,
     .                    rnode(timemult,mptr),alphai,teps
             write(*,901) ilo,ihi,jlo,jhi,klo,khi,mptr,level,time,
     .                    rnode(timemult,mptr),alphai,teps
             stop
          endif
      endif
 901  format(' trying to interpolate from previous time values ',/,
     .       ' for a patch with corners ilo,ihi,jlo,jhi,klo,khi:'
     .       ,/,2x,6i10,/,
     .       ' from source grid ',i4,' at level ',i4,/,
     .       ' time wanted ',e15.7,' source time is ',e15.7,/,
     .       ' alphai, teps ',2e15.7)
c
      if (.not. tinterp) then
c     ::: no time interp. copy the solution values
         do 35 k = kxlo, kxhi
         do 25 j = jxlo, jxhi
         do 15 i = ixlo, ixhi
         do 45 ivar = 1, nvar
             val(ivar,i-ilo+nrowst,j-jlo+ncolst,k-klo+nfilst) =
     1            alloc(iadd(ivar,i-imlo+nghost+1,
     2                       j-jmlo+nghost+1,
     3                       k-kmlo+nghost+1))
 45          continue
             flaguse(i,j,k) = 1.d0
 15      continue
 25      continue
 35      continue
      else
c     ::: linear interpolation in time 
         do 75 k = kxlo, kxhi
         do 65 j = jxlo, jxhi
         do 55 i = ixlo, ixhi
         do 85 ivar = 1, nvar
             val(ivar,i-ilo+nrowst,j-jlo+ncolst,k-klo+nfilst) =
     1            alloc(iadnew(ivar,i-imlo+nghost+1,
     2                         j-jmlo+nghost+1,
     3                         k-kmlo+nghost+1))*alphai +
     1            alloc(iadold(ivar,i-imlo+nghost+1,
     2                         j-jmlo+nghost+1,
     3                         k-kmlo+nghost+1))*alphac
 85         continue
            flaguse(i,j,k) = 1.d0
 55      continue
 65      continue
 75      continue
      endif
c
!90   mptr = node(levelptr, mptr)
 90      continue

         if (msrc .ne. -1) then
            nextSpot = bndList(nextSpot,nextfree)
         endif
      end do
!      go to 10
c
 105  continue
 
c  set used array points which intersect boundary to be equal to 1;
c  they will be set elsewhere
 
      if (khi .ge. kregsz(level)) then
        do 1100 k = max(kregsz(level),klo), khi
        do 1100 j = jlo, jhi
        do 1100 i = ilo, ihi
           flaguse(i,j,k) = 1.d0
1100    continue
      endif
 
      if (klo .lt. 0) then
        nfilend = nfilst + nfil - 1
        do 1200 k = klo, min(-1,nfilend)
        do 1200 j = jlo, jhi
        do 1200 i = ilo, ihi
            flaguse(i,j,k) = 1.d0
1200    continue
      endif

      if (jhi .ge. jregsz(level)) then
        do 1300 k = klo, khi
        do 1300 j = max(jregsz(level),jlo), jhi
        do 1300 i = ilo, ihi
           flaguse(i,j,k) = 1.d0
1300    continue
      endif
 
      if (jlo .lt. 0) then
        ncolend = ncolst + ncol - 1
        do 1400 k = klo, khi
        do 1400 j = jlo, min(-1,ncolend)
        do 1400 i = ilo, ihi
           flaguse(i,j,k) = 1.d0
1400    continue
      endif
 
      if (ilo .lt. 0) then
        nrowend = nrowst + nrow - 1
        do 1500 k = klo, khi
        do 1500 j = jlo, jhi
        do 1500 i = ilo, min(-1,nrowend)
           flaguse(i,j,k) = 1.d0
1500    continue
      endif
 
      if (ihi .ge. iregsz(level)) then
        do 1600 k = klo, khi
        do 1600 j = jlo, jhi
        do 1600 i = max(iregsz(level),ilo), ihi
           flaguse(i,j,k) = 1.d0
1600    continue
      endif
c
      return
      end

module fgout_module

    implicit none
    save

    ! Container for fixed grid data, geometry and output settings
    type fgout_grid
        ! Grid data
        real(kind=8), pointer :: early(:,:,:)
        real(kind=8), pointer :: late(:,:,:)

        ! Geometry
        integer :: mx,my,point_style,fgno,output_format,output_style
        real(kind=8) :: dx,dy,x_low,x_hi,y_low,y_hi

        ! Time Tracking and output types
        integer :: num_output,next_output_index
        real(kind=8) :: start_time,end_time,dt

        integer, allocatable :: output_frames(:)
        real(kind=8), allocatable :: output_times(:)

        integer :: num_vars ! number of variables to interpolate (num_eqn+3)
        integer :: nqout ! number of q components to output (+1 for eta)
        logical, allocatable :: q_out_vars(:) ! which components to print

        !logical, allocatable :: iqout(:)  ! which components to output
        integer :: bathy_index,eta_index,time_index

    end type fgout_grid


    logical, private :: module_setup = .false.

    ! Fixed grid arrays and sizes
    integer :: FGOUT_num_grids
    type(fgout_grid), target, allocatable :: FGOUT_fgrids(:)
    real(kind=8) :: FGOUT_tcfmax
    real(kind=8), parameter :: FGOUT_ttol = 1.d-6 ! tolerance for times


contains


    ! Setup routine that reads in the fixed grids data file and sets up the
    ! appropriate data structures

    subroutine set_fgout(rest,num_eqn,fname)

        use amr_module, only: parmunit, tstart_thisrun
        use utility_module, only: parse_values

        implicit none

        ! Subroutine arguments
        logical, intent(in) :: rest  ! restart?
        integer, intent(in) :: num_eqn
        character(len=*), optional, intent(in) :: fname

        ! Local storage
        integer, parameter :: unit = 7
        integer :: i,k
        type(fgout_grid), pointer :: fg
        real(kind=8) :: ts

        integer :: n, iq
        real(kind=8) :: values(num_eqn+2)
        character(len=80) :: str

        if (.not.module_setup) then

            write(parmunit,*) ' '
            write(parmunit,*) '--------------------------------------------'
            write(parmunit,*) 'SETFGOUT:'
            write(parmunit,*) '-----------'

            ! Open data file
            if (present(fname)) then
                call opendatafile(unit,fname)
            else
                call opendatafile(unit,'fgout_grids.data')
            endif

            ! Read in data
            read(unit,'(i2)') FGOUT_num_grids
            write(parmunit,*) '  mfgrids = ',FGOUT_num_grids
            if (FGOUT_num_grids == 0) then
                write(parmunit,*) '  No fixed grids specified for output'
                return
            endif

            ! Allocate fixed grids (not the data yet though)
            allocate(FGOUT_fgrids(FGOUT_num_grids))

            ! Read in data for each fixed grid
            do i=1,FGOUT_num_grids
                fg => FGOUT_fgrids(i)
                ! Read in this grid's data
                read(unit,*) fg%fgno
                read(unit,*) fg%output_style
                read(unit,*) fg%num_output
                allocate(fg%output_times(fg%num_output))
                allocate(fg%output_frames(fg%num_output))

                if (fg%output_style == 1) then
                    read(unit,*) fg%start_time
                    read(unit,*) fg%end_time
                else if (fg%output_style == 2) then
                    read(unit,*) (fg%output_times(k), k=1,fg%num_output)
                    fg%start_time = fg%output_times(1)
                    fg%end_time = fg%output_times(fg%num_output)
                endif

                read(unit,*) fg%point_style
                read(unit,*) fg%output_format
                read(unit,*) fg%mx, fg%my
                read(unit,*) fg%x_low, fg%y_low
                read(unit,*) fg%x_hi, fg%y_hi

                allocate(fg%q_out_vars(num_eqn+2))  ! for q + eta, topo
                do iq=1,num_eqn+2
                    fg%q_out_vars(iq) = .false.
                enddo
                read(unit,'(a)') str
                call parse_values(str, n, values)
                do k=1,n
                    iq = nint(values(k))
                    fg%q_out_vars(iq) = .true.
                enddo
                write(6,*) '+++ q_out_vars:', fg%q_out_vars

                fg%num_vars = num_eqn + 3  ! also interp topo,eta,time
                fg%nqout = 0  ! count how many are to be output
                do k=1,num_eqn+2
                    if (fg%q_out_vars(k)) fg%nqout = fg%nqout + 1
                enddo
                !fg%nqout = fg%nqout + 1  ! for eta


                ! Initialize next_output_index
                ! (might be reset below in case of a restart)
                fg%next_output_index = 1

                if (fg%point_style .ne. 2) then
                    print *, 'set_fgout: ERROR, unrecognized point_style = ',\
                          fg%point_style
                endif

               if (fg%output_style == 1) then
                   ! Setup data for this grid
                   ! Set fg%dt (the timestep length between outputs)
                   if (fg%end_time <= fg%start_time) then
                       if (fg%num_output > 1) then
                          print *,'set_fgout: ERROR for fixed grid', i
                          print *,'start_time <= end_time yet num_output > 1'
                          print *,'set end_time > start_time or set num_output = 1'
                          stop
                       else
                           ! only a single fgout time:
                           fg%dt = 0.d0
                       endif
                   else
                       if (fg%num_output < 2) then
                           print *,'set_fgout: ERROR for fixed grid', i
                           print *,'end_time > start_time, yet num_output = 1'
                           print *,'set num_output > 2'
                           stop
                       else
                           fg%dt = (fg%end_time  - fg%start_time) &
                                               / (fg%num_output - 1)
                           do k=1,fg%num_output
                               fg%output_times(k) = fg%start_time + (k-1)*fg%dt
                           enddo
                       endif
                    endif
                endif

               do k=1,fg%num_output
                   if (rest) then
                       ! don't write initial time or earlier
                       ts = tstart_thisrun+FGOUT_ttol
                   else
                       ! do write initial time
                       ts = tstart_thisrun-FGOUT_ttol
                   endif

                   if (fg%output_times(k) < ts) then
                        ! will not output this time in this run
                        ! (might have already be done when restarting)
                        fg%output_frames(k) = -2
                        fg%next_output_index = k+1
                   else
                        ! will be reset to frameno when this is written
                        fg%output_frames(k) = -1
                   endif
               enddo



                ! Set spatial intervals dx and dy on each grid
                if (fg%mx > 1) then
                   !fg%dx = (fg%x_hi - fg%x_low) / (fg%mx - 1) ! points
                   fg%dx = (fg%x_hi - fg%x_low) / fg%mx   ! cells
                else if (fg%mx == 1) then
                   fg%dx = 0.d0
                else
                     print *,'set_fgout: ERROR for fixed grid', i
                     print *,'x grid points mx <= 0, set mx >= 1'
                endif

                if (fg%my > 1) then
                    !fg%dy = (fg%y_hi - fg%y_low) / (fg%my - 1) ! points
                    fg%dy = (fg%y_hi - fg%y_low) / fg%my  ! cells
                else if (fg%my == 1) then
                    fg%dy = 0.d0
                else
                    print *,'set_fgout: ERROR for fixed grid', i
                    print *,'y grid points my <= 0, set my >= 1'
                endif

                fg%bathy_index = num_eqn + 2
                fg%eta_index = num_eqn + 1
                fg%time_index = num_eqn + 3

                write(6,*) '+++ nqout = ',fg%nqout

                ! Allocate new fixed grid data arrays at early, late time:
                ! dimension (10,:,:) to work for either GeoClaw or D-Claw

                allocate(fg%early(10, fg%mx,fg%my))
                fg%early = nan()

                allocate(fg%late(10, fg%mx,fg%my))
                fg%late = nan()

           enddo
           close(unit)

           FGOUT_tcfmax=-1.d16

           module_setup = .true.
        end if

    end subroutine set_fgout


    !=====================FGOUT_INTERP=======================================
    ! This routine interpolates q and aux on a computational grid
    ! to an fgout grid not necessarily aligned with the computational grid
    ! using bilinear interpolation defined on computational grid
    !=======================================================================
    subroutine fgout_interp(fgrid_type,fgrid, &
                            t,q,meqn,mxc,myc,mbc,dxc,dyc,xlowc,ylowc, &
                            maux,aux)

        use geoclaw_module, only: dry_tolerance
        implicit none

        ! Subroutine arguments
        integer, intent(in) :: fgrid_type
        type(fgout_grid), intent(inout) :: fgrid
        integer, intent(in) :: meqn,mxc,myc,mbc,maux
        real(kind=8), intent(in) :: t,dxc,dyc,xlowc,ylowc
        real(kind=8), intent(in) :: q(meqn,1-mbc:mxc+mbc,1-mbc:myc+mbc)
        real(kind=8), intent(in) :: aux(maux,1-mbc:mxc+mbc,1-mbc:myc+mbc)

        integer, parameter :: method = 0 ! interpolate in space?

        ! Indices
        integer :: ifg,jfg,m,ic1,ic2,jc1,jc2

        ! Tolerances
        real(kind=8) :: total_depth,depth_indicator,nan_check

        ! Geometry
        real(kind=8) :: xfg,yfg,xc1,xc2,yc1,yc2,xhic,yhic
        real(kind=8) :: geometry(4)

        real(kind=8) :: points(2,2), eta_tmp

        ! Work arrays for eta interpolation
        real(kind=8) :: eta(2,2),h(2,2)


        ! Alias to data in fixed grid
        integer :: num_vars
        real(kind=8), pointer :: fg_data(:,:,:)


        ! Setup aliases for specific fixed grid
        if (fgrid_type == 1) then
            num_vars = fgrid%num_vars
            fg_data => fgrid%early
        else if (fgrid_type == 2) then
            num_vars = fgrid%num_vars
            fg_data => fgrid%late
        else
            write(6,*) '*** Unexpected fgrid_type = ', fgrid_type
            stop
            ! fgrid_type==3 is deprecated, use fgmax grids instead
        endif

        xhic = xlowc + dxc*mxc
        yhic = ylowc + dyc*myc


        !write(59,*) '+++ ifg,jfg,eta,geometry at t = ',t

        ! Primary interpolation loops
        do ifg=1,fgrid%mx
            xfg=fgrid%x_low + (ifg-0.5d0)*fgrid%dx   ! cell centers
            do jfg=1,fgrid%my
                yfg=fgrid%y_low + (jfg-0.5d0)*fgrid%dy   ! cell centers

                ! Check to see if this coordinate is inside of this grid
                if (.not.((xfg < xlowc.or.xfg > xhic) &
                    .or.(yfg < ylowc.or.yfg > yhic))) then

                    ! find where xfg,yfg is in the computational grid and
                    ! compute the indices
                    !   (Note: may be subject to rounding error if fgout point
                    !    is right on a cell edge!)
                    ic1 = int((xfg - xlowc + dxc)/dxc)
                    jc1 = int((yfg - ylowc + dyc)/dyc)

                    if (method == 0) then

                        ! piecewise constant: take values from cell (ic1,jc1):

                        forall (m=1:meqn)
                            fg_data(m,ifg,jfg) = q(m,ic1,jc1)
                        end forall

                        fg_data(fgrid%bathy_index,ifg,jfg) = aux(1,ic1,jc1)

                        ! for pw constant we take B, h, eta from same cell,
                        ! so setting eta = h+B should be fine even near shore:
                        fg_data(fgrid%eta_index,ifg,jfg) = fg_data(1,ifg,jfg) &
                                + fg_data(fgrid%bathy_index,ifg,jfg)


                    else if (method == 1) then

                        ! bilinear used to interpolate to xfg,yfg
                        ! (not recommended)

                        ! define constant parts of bilinear
                        if (ic1.eq.mxc) ic1=mxc-1
                        if (jc1.eq.myc) jc1=myc-1
                        ic2 = ic1 + 1
                        jc2 = jc1 + 1

                        xc1 = xlowc + dxc * (ic1 - 0.5d0)
                        yc1 = ylowc + dyc * (jc1 - 0.5d0)
                        xc2 = xlowc + dxc * (ic2 - 0.5d0)
                        yc2 = ylowc + dyc * (jc2 - 0.5d0)

                        geometry = [(xfg - xc1) / dxc, &
                                    (yfg - yc1) / dyc, &
                                    (xfg - xc1) * (yfg - yc1) / (dxc*dyc), &
                                    1.d0]


                        ! Interpolate all conserved quantities and bathymetry
                        forall (m=1:meqn)
                            fg_data(m,ifg,jfg) = &
                                interpolate(q(m,ic1:ic2,jc1:jc2), geometry)
                        end forall

                        fg_data(fgrid%bathy_index,ifg,jfg) = &
                                interpolate(aux(1,ic1:ic2,jc1:jc2),geometry)


                        ! surface eta = h + B:

                        ! Note that for pw bilinear interp there may
                        ! be a problem interpolating each separately since
                        ! interpolated h + interpolated B may be much larger
                        ! than eta should be offshore.
                        eta = q(1,ic1:ic2,jc1:jc2) + aux(1,ic1:ic2,jc1:jc2)
                        fg_data(fgrid%eta_index,ifg,jfg) = interpolate(eta,geometry)
                        ! NEED TO FIX
                    endif


                    ! save the time this fgout point was computed:
                    fg_data(fgrid%time_index,ifg,jfg) = t


                endif ! if fgout point is on this grid
            enddo ! fgout y-coordinate loop
        enddo ! fgout x-coordinte loop

    end subroutine fgout_interp


    !================ fgout_write ==========================================
    ! This routine interpolates in time and then outputs a grid at
    ! time=out_time
    !
    ! files now have the same format as frames produced by outval
    !=======================================================================
    subroutine fgout_write(fgrid,out_time,out_index)

        use geoclaw_module, only: dry_tolerance
        implicit none

        ! Subroutine arguments
        type(fgout_grid), intent(inout) :: fgrid
        real(kind=8), intent(in) :: out_time
        integer, intent(in) :: out_index

        ! I/O
        integer, parameter :: unit = 87
        character(len=15) :: fg_filename
        character(len=8) :: cfgno, cframeno
        character(len=8) :: file_format
        integer :: grid_number,ipos,idigit,out_number,columns
        integer :: ifg,ifg1, iframe,iframe1

        integer, parameter :: method = 0  ! interpolate in time?

        ! Output format strings
        ! These are now the same as in outval for frame data, for compatibility
        ! For fgout grids there is only a single grid (ngrids=1)
        ! and we set AMR_level=0, naux=0, nghost=0 (so no extra cells in binary)

        character(len=*), parameter :: header_format =                         &
                                    "(i6,'                 grid_number',/," // &
                                     "i6,'                 AMR_level',/,"   // &
                                     "i6,'                 mx',/,"          // &
                                     "i6,'                 my',/"           // &
                                     "e26.16,'    xlow', /, "               // &
                                     "e26.16,'    ylow', /,"                // &
                                     "e26.16,'    dx', /,"                  // &
                                     "e26.16,'    dy',/)"

        character(len=*), parameter :: t_file_format = "(e18.8,'    time', /," // &
                                           "i6,'                 meqn'/,"   // &
                                           "i6,'                 ngrids'/," // &
                                           "i6,'                 naux'/,"   // &
                                           "i6,'                 ndim'/,"   // &
                                           "i6,'                 nghost'/," // &
                                           "a10,'             format'/,/)"

        ! Other locals
        integer :: i,j,m,iq,k,jq,num_eqn
        real(kind=8) :: t0,tf,tau, qaug(10)
        real(kind=8), allocatable :: qeta(:,:,:)
        real(kind=4), allocatable :: qeta4(:,:,:)
        real(kind=8) :: h_early,h_late,topo_early,topo_late

        allocate(qeta(fgrid%nqout, fgrid%mx, fgrid%my))  ! to store h,hu,hv,eta
                                                         ! or subset

        ! Interpolate the grid in time, to the output time, using
        ! the solution in fgrid1 and fgrid2, which represent the
        ! solution on the fixed grid at the two nearest computational times
        do j=1,fgrid%my
            do i=1,fgrid%mx

                ! Check for small numbers
                forall(m=1:fgrid%num_vars-1,abs(fgrid%early(m,i,j)) < 1d-90)
                    fgrid%early(m,i,j) = 0.d0
                end forall

                if (method == 0) then

                    ! no interpolation in time, use solution from full step:
                    qaug = fgrid%early(:,i,j)

                    ! note that CFL condition ==> waves can't move more than 1
                    ! cell per time step on each level, so solution from nearest
                    ! full step should be correct to within a cell width
                    ! Better to use early than late since for refinement tracking
                    ! wave moving out into still water.

                else if (method == 1) then

                    ! interpolate in time. May have problems near shore?

                    ! Fetch times for interpolation, this is done per grid point
                    ! since each grid point may come from a different source
                    t0 = fgrid%early(fgrid%num_vars,i,j)
                    tf = fgrid%late(fgrid%num_vars,i,j)
                    tau = (out_time - t0) / (tf - t0)

                    ! check for small values:
                    forall(m=1:fgrid%num_vars-1,abs(fgrid%late(m,i,j)) < 1d-90)
                        fgrid%late(m,i,j) = 0.d0
                    end forall

                    ! linear interpolation:
                    qaug = (1.d0-tau)*fgrid%early(:,i,j) + tau*fgrid%late(:,i,j)

                    ! If resolution changed between early and late time, may be
                    ! problems near shore when interpolating B, h, eta
                    ! separately (at least in case when B changed and point
                    ! was dry at one time and wet the other).
                    ! Switch back to fgrid%early values, only in this case.
                    ! This is implemented below but not extensively tested.

                    if (qaug(1) > 0.d0) then
                        topo_early = fgrid%early(4,i,j)
                        topo_late = fgrid%late(4,i,j)
                        if (topo_early .ne. topo_late) then
                            ! AMR resolution changed between times
                            h_early = fgrid%early(1,i,j)
                            h_late = fgrid%late(1,i,j)
                            if (((h_early < dry_tolerance) &
                                    .and. (h_late >= dry_tolerance)) &
                                .or. ((h_late < dry_tolerance) &
                                    .and. (h_early >= dry_tolerance))) then
                                ! point changed between wet and dry
                                qaug = fgrid%early(:,i,j) ! don't interpolate
                            endif
                        endif
                    endif
                endif

                ! Output the requested quantities and eta value:

                iq = 1
                num_eqn = size(fgrid%q_out_vars) - 2  ! last components eta,B
                do jq=1,num_eqn+2
                    if (fgrid%q_out_vars(jq)) then
                        qeta(iq,i,j) = qaug(jq)
                        iq = iq+1
                    endif
                enddo

                ! now append eta value: (this is now included in loop above)
                !qeta(iq,i,j) = qaug(fgrid%eta_index)
                ! NOTE: qaug(fgrid%bathy_index) contains topo B value

            enddo
        enddo


        ! convert fgrid%fgno to a string of length at least 4 with leading 0's
        ! e.g. '0001' or '12345':
        write(cfgno, '(I0.4)') fgrid%fgno

        ! convert out_index to a string of length at least 4 with leading 0's
        write(cframeno, '(I0.4)') out_index


        fg_filename = 'fgout' // trim(cfgno) // '.q' // trim(cframeno)

        open(unit,file=fg_filename,status='unknown',form='formatted')


        write(unit,header_format) fgrid%fgno, 0, fgrid%mx,fgrid%my, &
            fgrid%x_low,fgrid%y_low, fgrid%dx, fgrid%dy

        if (fgrid%output_format == 1) then
            ! ascii output added to .q file:
            do j=1,fgrid%my
                do i=1,fgrid%mx
                    write(unit, "(50e26.16)") (qeta(k,i,j), k=1,fgrid%nqout)
                enddo
                write(unit,*) ' '  ! blank line required between rows
            enddo
        endif

        close(unit)

        if (fgrid%output_format == 3) then
            ! binary output goes in .b file as full 8-byte (float64):
            fg_filename = 'fgout' // trim(cfgno) // '.b' // trim(cframeno)
            open(unit=unit, file=fg_filename, status="unknown",    &
                 access='stream')
            write(unit) qeta
            close(unit)
        else if (fgrid%output_format == 2) then
            ! binary output goes in .b file as 4-byte (float32):
            fg_filename = 'fgout' // trim(cfgno) // '.b' // trim(cframeno)
            open(unit=unit, file=fg_filename, status="unknown",    &
                 access='stream')
            allocate(qeta4(fgrid%nqout, fgrid%mx, fgrid%my))
            qeta4 = real(qeta, kind=4)
            write(unit) qeta4
            deallocate(qeta4)
            close(unit)
        endif

        deallocate(qeta)

        ! time info .t file:


        if (fgrid%output_format == 1) then
            file_format = 'ascii'
        else if (fgrid%output_format == 2) then
            file_format = 'binary32'
        else if (fgrid%output_format == 3) then
            file_format = 'binary64'
        else
            write(6,*) '*** unrecognized fgrid%output_format = ', &
                        fgrid%output_format
            write(6,*) '*** should be ascii, binary32, or binary64'
        endif

        fg_filename = 'fgout' // trim(cfgno) // '.t' // trim(cframeno)
        open(unit=unit, file=fg_filename, status='unknown', form='formatted')
        ! time, num_eqn+1, num_grids, num_aux, num_dim, num_ghost:
        write(unit, t_file_format) out_time, fgrid%nqout, 1, 0, 2, 0,file_format
        close(unit)

        print "(a,i4,a,i4,a,e18.8)",'Writing fgout grid #',fgrid%fgno, &
              '  frame ',out_index,' at time =',out_time

    end subroutine fgout_write


    ! =========================================================================
    ! Utility functions for this module
    ! Returns back a NaN

    real(kind=8) function nan()
        real(kind=8) dnan
        integer inan(2)
        equivalence (dnan,inan)
        inan(1)=2147483647
        inan(2)=2147483647
        nan=dnan
    end function nan

    ! Interpolation function (in space)
    ! Given 4 points (points) and geometry from x,y,and cross terms

    real(kind=8) pure function interpolate(points,geometry) result(interpolant)

        implicit none

        ! Function signature
        real(kind=8), intent(in) :: points(2,2)
        real(kind=8), intent(in) :: geometry(4)
        integer :: icell, jcell

        ! pw bilinear
        ! This is set up as a dot product between the approrpriate terms in
        ! the input data.  This routine could be vectorized or a BLAS routine
        ! used instead of the intrinsics to ensure that the fastest routine
        ! possible is being used
        interpolant = sum([points(2,1)-points(1,1), &
                       points(1,2)-points(1,1), &
                       points(1,1) + points(2,2) - (points(2,1) + points(1,2)), &
                       points(1,1)] * geometry)

    end function interpolate


end module fgout_module

subroutine b4step1(mbc,mx,meqn,q,xlower,dx,t,dt,maux,aux)

    ! Called before each call to step1.
    ! Use to set time-dependent aux arrays or perform other tasks.
    !
    ! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: mbc,mx,meqn,maux
    real(kind=8), intent(in) :: xlower,dx,t,dt
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc)

end subroutine b4step1

c
c --------------------------------------------------------------
c
      subroutine errf1(rctfine,nvar,rctcrse,mptr,mi2tot,
     2                 mitot,rctflg,mibuff)
      use amr_module
      implicit double precision (a-h,o-z)

 
      dimension  rctfine(nvar,mitot)
      dimension  rctcrse(nvar,mi2tot)
      dimension  rctflg(mibuff)
c
c
c ::::::::::::::::::::::::::::: ERRF1 ::::::::::::::::::::::::::::::::
c
c  Richardson error estimator:  Used when flag_richardson is .true.
c  Compare error estimates in rctfine, rctcrse, 
c  A point is flagged if the error estimate is greater than tol
c  later we check if its in a region where its allowed to be flagged
c  or alternatively required.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

c
      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      dt    = possk(levm)
      numsp = 0
 
      errmax = 0.0d0
      err2   = 0.0d0
c     order  = dt*dble(2**(iorder+1) - 2)
      order  = dble(2**(iorder+1) - 2)
c
      if (.not. (edebug)) go to 20
         write(outunit,107) mptr
 107     format(//,' coarsened grid values for grid ',i4)
         write(outunit,101) (rctcrse(1,i),
     .                          i = nghost+1, mi2tot-nghost)
         write(outunit,108) mptr
 108     format(//, ' fine grid values for grid ',i4)
         write(outunit,101) (rctfine(1,i),i=nghost+1,mitot-nghost)
101      format(' ',40e11.3)
c
c zero out the exterior locations so they don't affect err.est.
c
 20   continue
      ifine = nghost+1
c
      do 30  i  = nghost+1, mi2tot-nghost
        rflag = UNSET
c Only check errors if flag hasn't been set yet.
c If flag == DONTFLAG then refinement is forbidden by a region,
c if flag == DOFLAG checking is not needed
        if(rctflg(ifine) == UNSET
     .         .or. rctflg(ifine+1) == UNSET) then
          xofi  = xleft + (dble(ifine) - .5d0)*hx
          term1 = rctfine(1,ifine)
          term2 = rctfine(1,ifine+1)
c         # divide by (aval*order) for relative error
          aval  = (term1+term2)/2.d0
          est   =  dabs((aval-rctcrse(1,i))/ order)
          if (est .gt. errmax) errmax = est
          err2 = err2 + est*est
c         write(outunit,102) i,j,est,rctcrse(1,i,j)
 102      format(' i,est ',2i5,2e15.7)
c          write(outunit,104) term1,term2,term3,term4
 104      format('   ',4e15.7)
c         rctcrse(2,i,j) = est
c
          if (est .ge. tol) then
             rflag  = DOFLAG
          endif
        endif
      rctcrse(1,i) = rflag
      ifine = ifine + 2
 30   continue
c
c  print out intermediate flagged rctcrse (for debugging)
c
      if (eprint) then
         err2 = dsqrt(err2/dble((mi2tot-2*nghost)))
         write(outunit,103) mptr, levm, time,errmax, err2
 103     format(' grid ',i4,' level ',i4,' time ',e12.5,
     .          ' max. error = ',e15.7,' err2 = ',e15.7)
         if (edebug) then
           write(outunit,*) ' flagged points on coarsened grid ',
     .                      '(no ghost cells) for grid ',mptr
           write(outunit,106) (nint(rctcrse(1,i)),
     .                            i=nghost+1,mi2tot-nghost)
106           format(1h ,80i1)
         endif
      endif
c
      ifine   = nghost+1
      do 60 i = nghost+1, mi2tot-nghost
         if (rctcrse(1,i) .eq. DOFLAG) then
c           ## never set rctflg to DONTFLAG,
c           ## since flagregions or flag2refine may
c           ## have previously set it to DOFLAG
c           ## can only add DOFLAG pts in this routine
            rctflg(ifine)    = DOFLAG
            rctflg(ifine+1)  = DOFLAG
          endif
        ifine   = ifine + 2
 60     continue
c

      if (eprint) then
         write(outunit,118)
 118     format(' on fine grid (no ghost cells) flagged points are')
         if (edebug) then
           write(outunit,106)
     &      (nint(rctflg(i)),i=nghost+1,mitot-nghost)
        endif
      endif

      return
      end

!======================================================================
       subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx, &
                       ql,qr,auxl,auxr,wave,s,amdq,apdq)
!======================================================================
!
! Solves normal Riemann problems for the adjoint of the linearized
! 2D shallow water equations with topography.
! Uses q-waves, not f-waves, since the forward solve is in conservation
! form using f-waves.
!
! The full nonlinear forward problem in the x-direction is:
!     h_t + (hu)_x = 0
!     (hu)_t + (h*u^2 + 0.5*g*h^2)_x = -g*h*B_x(x)
! where h is the depth, hu the momentum, and B(x) the topography/bathymetry.
!
! The linearized forward problem is:
!     eta_t + mom_x = 0
!     mom_t + [g*h0(x) * eta]_x = 0
! where (eta, mom) are the surface displacement eta and linearized momentum,
! and h0(x) is the background depth (ocean at rest), so h0(x) = max(-B(x), 0).
!
! Note the forward problem is in conservation form q_t + (A(x)q)_x = 0, 
! so the adjoint equation is non-conservative and has the form
!     q_hat_t + A(x)^T q_hat_x = 0
! with coefficient matrix is
!     A(x)^T = [0  g*h0(x)]
!              [1     0   ]
!
! We need to solve the adjoint backwards in time, but we convert this into
! a problem going forward in time in order to apply GeoClaw, by solving
!     q_hat_t - A(x)^T q_hat_x = 0.
!
! Hence the Riemann solver uses the eigenvalues/vectors of -A(x)^T, which are:
!     lambda_1 = -c0,  r_1 = [+c0, 1]^T,
!     lambda_2 = +c0,  r_2 = [-c0, 1]^T.
!
! If h0 < drytol on one side of the interface, then "solid wall" BCs
! are used to find the single wave propagating into the ocean with mom=0 behind.
!
! On input, ql contains the state vector at the left edge of each cell
!     qr contains the state vector at the right edge of each cell
!
! This data is along a slice in the x-direction if ixy=1
!     or the y-direction if ixy=2.

!  Note that the i'th Riemann problem has left state qr(i-1,:)
!     and right state ql(i,:)
!  From the basic clawpack routines, this routine is called with
!     ql = qr
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                           !
!      # This Riemann solver is for the shallow water adjoint               !
!             equations. It is modified from rpn2_geoclaw.f.                !
!                                                                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      use geoclaw_module, only: g => grav, drytol => dry_tolerance
      use geoclaw_module, only: earth_radius, deg2rad
      use amr_module, only: mcapa, use_fwaves

      implicit none

      !input
      integer, intent(in) :: maxm,meqn,maux,mwaves,mbc,mx,ixy

      real(kind=8), intent(in) ::  ql(meqn, 1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  qr(meqn, 1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  auxl(maux,1-mbc:maxm+mbc)
      real(kind=8), intent(in) ::  auxr(maux,1-mbc:maxm+mbc)
      real(kind=8), intent(out) ::  wave(meqn, mwaves, 1-mbc:maxm+mbc)
      real(kind=8), intent(out) ::  s(mwaves, 1-mbc:maxm+mbc)
      real(kind=8), intent(out) ::  apdq(meqn,1-mbc:maxm+mbc)
      real(kind=8), intent(out) ::  amdq(meqn,1-mbc:maxm+mbc)

      ! local 
      integer :: m,i,mu,nv
      real(kind=8) :: delta(2)
      real(kind=8) :: h0R,h0L,huR,huL,etaR,etaL
      real(kind=8) :: hR,hL,bR,bL,cL,cR,alf1,alf2,dxdc
      logical dryL,dryR

      if (mwaves .ne. 2) then
         write(6,*) '*** Adjoint solver requires num_waves = 2'
         stop
         endif

      if (use_fwaves) then
         write(6,*) '*** Adjoint solver requires use_fwaves=False'
         stop
         endif

      ! initialize for dry areas:
      wave(:,:,:) = 0.d0
      s(:,:) = 1.d0
      amdq(:,:) = 0.d0
      apdq(:,:) = 0.d0

      !loop through Riemann problems at each grid cell
      do i=2-mbc,mx+mbc

         ! background depth based on topography:
         bL = auxr(1,i-1)
         bR = auxl(1,i)
         h0L = max(-bL, 0.d0)
         h0R = max(-bR, 0.d0)

         !skip problem if in a completely dry area
         if (h0L <= drytol .and. h0R <= drytol) then
             cycle ! go to next i
         endif
         
         !set normal direction
         if (ixy.eq.1) then
            mu=2
            nv=3
         else
            mu=3
            nv=2
         endif

        ! linearized eta:
        hL = qr(1,i-1)
        hR = ql(1,i)
        etaL = hL + bL
        etaR = hR + bR

        ! linearized momenta:
        huL = qr(mu,i-1)
        huR = ql(mu,i)

        ! wave speeds
        cL = sqrt(g*h0L) ! 1 wave speed is -cL
        cR = sqrt(g*h0R) ! 2 wave speed is +cR


        ! Check for wet/dry boundary
        if (hR <= drytol) then
            ! set "ghost cell" values for zero momentum BC:
            etaR = etaL
            huR = -huL
            dryR = .true.
            cR = cL
        else
            dryR = .false.
        endif

        if (hL <= drytol) then
            ! set "ghost cell" values for zero momentum BC:
            etaL = etaR
            huL = -huR
            dryL = .true.
            cL = cR
        else
            dryL = .false.
        endif

        
        ! Roe average speeds 
        ! More consistent with forward solver, but doesn't make much difference
        !cL = sqrt(g*0.5d0*(h0L+h0R)) ! 1 wave speed is -cL
        !cR = sqrt(g*0.5d0*(h0L+h0R)) ! 2 wave speed is +cR
        
        if ((cL<drytol) .and. (cR<drytol)) then
            ! should not happen
            write(6,*) '*** g,h0L,h0r: ',g,h0L,h0r
            endif

        !--------------------end initializing----------
        ! solve Riemann problem.

        ! q-wave splitting
        delta(1) = etaR - etaL
        delta(2) = huR - huL

        alf1 = (delta(1) + cR*delta(2))/(cL + cR)
        alf2 = (-delta(1) + cL*delta(2))/(cL + cR)

        ! eliminate one wave if dry to either side:
        if (dryL) alf1 = 0.d0
        if (dryR) alf2 = 0.d0

        ! Compute the waves.
        wave(1,1,i) = cL*alf1
        wave(mu,1,i) = alf1
        wave(nv,1,i) = 0.d0
        s(1,i) = -cL

        wave(1,2,i) = -cR*alf2
        wave(mu,2,i) = alf2
        wave(nv,2,i) = 0.d0
        s(2,i) = cR
        
!====== Adjust for mapping from latitude longitude to physical space====
        if (mcapa.gt.0) then
            if (ixy.eq.1) then
               dxdc=(earth_radius*deg2rad)
            else
               dxdc=earth_radius*cos(auxl(3,i))*deg2rad
            endif
            s(1,i) = dxdc * s(1,i)
            s(2,i) = dxdc * s(2,i)
        endif

        ! Fluctuations: 
        ! 1-wave is always left-going, 2-wave is right-going
        amdq(1:meqn,i) = s(1,i) * wave(1:meqn,1,i)
        apdq(1:meqn,i) = s(2,i) * wave(1:meqn,2,i)

      enddo

      return
      end subroutine rpn2

c
c-------------------------------------------------------------------------------------
c  Modified from prepbigstep.f in amrclaw to pass aux array into coarsen.f
c  and to properly account set variables in coarse aux array
c-------------------------------------------------------------------------------------
c
       subroutine prepbigstep(nvar,naux,lcheck,mptr,nx,ny,midub,mjdub,
     .                       valbgc,auxbgc,mi2tot,mj2tot)

       use amr_module, only: rnode,cornylo,cornxlo,evol,hxposs,hyposs
       use amr_module, only: NEEDS_TO_BE_SET,nghost,store2,timemult
       use amr_module, only: possk,alloc,node
       use amr_module, only: auxtype
       use topo_module, only: aux_finalized
       implicit none

       integer, intent(in) :: nvar, naux, lcheck, mptr, nx, ny
       integer, intent(in) :: midub, mjdub, mi2tot, mj2tot
       real(kind=8), intent(inout) :: valbgc(nvar,mi2tot,mj2tot)
       real(kind=8), intent(inout) :: auxbgc(naux,mi2tot,mj2tot)

c      # Local variables
       real(kind=8) :: valdub(nvar,midub,mjdub)
       real(kind=8) :: auxdub(naux,midub,mjdub)
       real(kind=8) :: fp(nvar,mi2tot,mj2tot),gp(nvar,mi2tot,mj2tot)
       real(kind=8) :: fm(nvar,mi2tot,mj2tot),gm(nvar,mi2tot,mj2tot)
       real(kind=8) :: hx,hy,hx2,hy2,dt,dt2,dtnew2,time,tpre
       integer :: mitot,mjtot,ng2,locold,mx,my,aux_finalized_temp
       real(kind=8) :: xlow,ylow,xl,yb

       !for setaux timing
       integer :: clock_start, clock_finish, clock_rate
       real(kind=8) :: cpu_start, cpu_finish
c
          hx  = hxposs(lcheck)
          hy  = hyposs(lcheck)
          hx2 = 2.d0*hx
          hy2 = 2.d0*hy
          dt  = possk(lcheck)
          dt2 = 2. * dt
          time  = rnode(timemult,mptr)
          tpre  = time - dt
c
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          ng2    = 2*nghost
          locold = node(store2,mptr)
          xlow   = rnode(cornxlo,mptr) - nghost*hx2
          ylow   = rnode(cornylo,mptr) - nghost*hy2
c
c         # transfer soln. into grid with twice the ghost cells
          call copysol(valdub,alloc(locold),nvar,mitot,mjtot,
     1              nghost,midub,mjdub,ng2)

c
          if (naux .gt. 0) then
              xl     = rnode(cornxlo, mptr)
              yb     = rnode(cornylo, mptr)
              mx = midub - 4*nghost
              my = mjdub - 4*nghost
              auxdub(1,:,:) = NEEDS_TO_BE_SET  ! signal that needs a val (modified from amrclaw)
c
c             # Generate aux for fine grid
              call system_clock(clock_start, clock_rate)
              call cpu_time(cpu_start)
              call setaux(2*nghost,mx,my,xl,yb,hx,hy,
     &                    naux,auxdub)
              call system_clock(clock_finish, clock_rate)
              call cpu_time(cpu_finish)
c
c             # Generate aux for coarse grid
c             # Call setaux first to set capacity functions
              call setaux(nghost,nx/2,ny/2,xl,yb,hx2,hy2,
     1                    naux,auxbgc)
              call auxcoarsen(auxdub,midub,mjdub,
     1                     auxbgc,mi2tot,mj2tot,naux,auxtype)
          endif
c
c         # fill it - use enlarged (before coarsening) aux arrays
          call bound(tpre,nvar,ng2,valdub,midub,mjdub,mptr,
     1               auxdub,naux)
c
c         coarsen by 2 in every direction
          call coarsen(valdub,midub,mjdub,auxdub,
     1                 valbgc,mi2tot,mj2tot,auxbgc,nvar,naux)

          call stepgrid(valbgc,fm,fp,gm,gp,
     1                mi2tot,mj2tot,nghost,
     2                dt2,dtnew2,hx2,hy2,nvar,
     3                xlow,ylow,tpre,mptr,naux,auxbgc,.false.)
c
c         update counts for error estimation work
          evol = evol + (nx/2)*(ny/2)
c
           return
           end

c
c
c =========================================================
      subroutine out2(meqn,mbc,mx,my,xlower,ylower,
     &                 dx,dy,q,t,iframe,aux,maux,outaux)
c =========================================================
c
c     # Output the results for a general system of conservation laws
c     # in 2 dimensions
c
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw2.m
c     # The same format is used by the amrclaw package.
c     # Here it's adapted to output just the single grid.
c
c     # set outaux = .true. to also output the aux arrays to fort.a<iframe>
c
c
      implicit double precision (a-h,o-z)
      dimension   q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      logical, intent(in) :: outaux

      character*10 fname1, fname2, fname3
      character(len=8) :: file_format

      file_format = 'ascii'  ! only format currently supported
c
c     # first create the file name and open file
c
         fname1 = 'fort.qxxxx'
         fname2 = 'fort.txxxx'
         fname3 = 'fort.axxxx'
         nstp = iframe
         do 55 ipos = 10, 7, -1
            idigit = mod(nstp,10)
            fname1(ipos:ipos) = char(ichar('0') + idigit)
            fname2(ipos:ipos) = char(ichar('0') + idigit)
            fname3(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp / 10
 55      continue

         open(unit=50,file=fname1,status='unknown',form='formatted')
         open(unit=60,file=fname2,status='unknown',form='formatted')

c
c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr = 1
      level = 1

      write(50,1001) mptr,level,mx,my
 1001 format(i5,'                 grid_number',/,
     &       i5,'                 AMR_level',/,
     &       i5,'                 mx',/,
     &       i5,'                 my')

      write(50,1002) xlower,ylower,dx,dy
 1002 format(e26.16,'    xlow', /,
     &       e26.16,'    ylow', /,
     &       e26.16,'    dx', /,
     &       e26.16,'    dy',/)
c
      do 20 j=1,my
        do 10 i=1,mx
          do m=1,meqn
c            # exponents with more than 2 digits cause problems reading
c            # into matlab... reset tiny values to zero:
             if (dabs(q(m,i,j)) .lt. 1d-99) q(m,i,j) = 0.d0
             enddo
c
          write(50,1005) (q(m,i,j), m=1,meqn)
 1005     format(50e26.16)
c
 10       continue
        write(50,*) ' '
 20     continue
      write(50,*) ' '

      if (outaux) then 
c     # also output the aux arrays:
      open(unit=70,file=fname3,status='unknown',form='formatted')
      write(70,1001) mptr,level,mx,my
      write(70,1002) xlower,ylower,dx,dy
      do 120 j=1,my
         do 110 i=1,mx
            do m=1,maux
c              # exponents with more than 2 digits cause problems reading
c              # into matlab... reset tiny values to zero:
               if (dabs(aux(m,i,j)) .lt. 1d-99) aux(m,i,j) = 0.d0
            enddo
c
            write(70,1005) (aux(m,i,j), m=1,maux)
c
  110       continue
         write(70,*) ' '
  120    continue
      write(70,*) ' '
      close(unit=70)
      endif

      write(60,1000) t,meqn,ngrids,maux,2,mbc,file_format

 1000 format(e26.16,'    time', /,
     &       i5,'                 meqn'/,
     &       i5,'                 ngrids'/,
     &       i5,'                 maux'/,
     &       i5,'                 ndim'/,
     &       i5,'                 nghost'/,
     &       a10,'                 format'/,/)
c
      close(unit=50)
      close(unit=60)

      return
      end

subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,fwave,s,amdq,apdq)
! ============================================================================
!  Solves normal Riemann problem for the multilayer shallow water equations in
!  2D with topography:
!    (rho_1 h_1)_t + (rho_1 h_1 u_1)_x + (rho_1 h_1 v_1)_y = 0
!    (rho_1 h_1 u_1)_t + (rho_1 h_1 u_1^2 + 1/2 g rho_1 h_1^2)_x + (rho_1 h_1 u_1 v_1)_y = -g rho_1 h_1(r(h_2)_x + B_x)
!    (rho_1 h_1 v_1)_t + (rho_1 h_1 u_1 v_1)_x + (rho_1 h_1 v_1^2 + 1/2 g rho_1 h_1^2)_y = -g rho_1 h_1(r(h_2)_y + B_y)
!    (rho_2 h_2)_t + (rho_2 h_2 u_2)_x + (rho_2 h_2 v_2)_y = 0
!    (rho_2 h_2 u_2)_t + (rho_2 h_2 u_2^2 + 1/2 g rho_2 h_2^2)_x + (rho_2 h_2 u_2 v_2)_y = -g rho_2 h_2(h_1 + B)_x
!    (rho_2 h_2 v_2)_t + (rho_2 h_2 u_2 v_2)_x + (rho_2 h_2 v_2^2 + 1/2 g rho_2 h_2^2)_y = -g rho_2 h_2(h_1 + B)_y
!
!  On input, ql contains the state vector at the left edge of each cell and qr
!  contains the state vector at the right edge of each cell
!
!           |            |          
!    qr(i-1)|ql(i)  qr(i)|ql(i+1)   
! ----------|------------|----------
!    i-1          i         i+1
!
!  The i-1/2 Riemann problem has left state qr(i-1) and right state ql(i)
!
!  If ixy == 1 then the sweep direction is x, ixy == 2 implies the y direction
! 
!  Wet-Dry Interface Cases handled
!    Dry State Table    #  Handled?    Line #     Comment
!  L(1) L(2) R(1) R(2)
!   F    F    F    F    4  [X]        XXX        Full two-layer case
!
!   T    F    F    F    1  [ ]                   Dry state top layer
!   F    T    F    F    1  [X]        XXX        Lower left dry state
!   F    F    T    F    1  [ ]                   Dry state top layer
!   F    F    F    T    1  [X]        XXX        Lower right dry state
!
!   T    T    F    F    2  [X]        XXX        Left state completely dry
!   F    T    T    F    2  [ ]
!   F    F    T    T    2  [X]        240        Right state completely dry
!   T    F    F    T    2  [ ]
!
!   T    F    T    F    2  [X]        182        Single layer all-wet bottom
!   F    T    F    T    2  [X]        182        Single layer all-wet top
!
!   T    T    T    F    3  [X]        195        Single layer dry-state
!   F    T    T    T    3  [X]        195        Single layer dry-state
!   T    F    T    T    3  [X]        195        Single layer dry-state
!   T    T    F    T    3  [X]        195        Single layer dry-state
!
!   T    T    T    T    4  [X]        173        All dry
! ============================================================================

    use amr_module, only: mcapa

    use geoclaw_module, only: g => grav, rho, pi, earth_radius

    use multilayer_module, only: num_layers, eigen_func
    use multilayer_module, only: dry_tolerance, aux_layer_index, r
    use multilayer_module, only: eigen_method, inundation_method
    use multilayer_module, only: eigen_func, inundation_eigen_func

    implicit none

    ! Input arguments
    integer, intent(in) :: ixy,maxm,meqn,mwaves,mbc,mx,maux
    real(kind=8), dimension(meqn,1-mbc:maxm+mbc), intent(in) :: ql, qr
    real(kind=8), dimension(maux,1-mbc:maxm+mbc), intent(in) :: auxl, auxr

    ! Output arguments
    real(kind=8), dimension(meqn, mwaves, 1-mbc:maxm+mbc), intent(out) :: fwave
    real(kind=8), dimension(mwaves, 1-mbc:maxm+mbc), intent(out) :: s
    real(kind=8), dimension(meqn, 1-mbc:maxm+mbc), intent(out) :: apdq, amdq

    ! Counters
    integer :: i, j, mw, info
    integer :: n_index, t_index, layer_index
    
    ! Physics
    real(kind=8) :: dxdc
    
    ! State variables
    real(kind=8), dimension(num_layers) :: h_l, h_r, hu_l, hu_r, hv_l, hv_r
    real(kind=8), dimension(num_layers) :: u_l, u_r, v_l, v_r
    real(kind=8), dimension(num_layers) :: h_ave, momentum_transfer
    real(kind=8), dimension(num_layers) :: h_hat_l, h_hat_r
    real(kind=8) :: b_l, b_r, flux_transfer_l, flux_transfer_r, lambda(6)

    ! real(kind=8) :: advected_speed, eta_l, eta_r, gamma_l, gamma_r, kappa_l, kappa_r, w_normal, w_transverse

    ! Solver variables
    integer :: num_dry_states
    real(kind=8), dimension(num_layers) :: eigen_h_l, eigen_h_r
    real(kind=8), dimension(num_layers) :: eigen_u_l, eigen_u_r
    real(kind=8), dimension(num_layers) :: eigen_v_l, eigen_v_r
    real(kind=8), dimension(num_layers) :: flux_h_l, flux_h_r
    real(kind=8), dimension(num_layers) :: flux_hu_l, flux_hu_r
    real(kind=8), dimension(num_layers) :: flux_hv_l, flux_hv_r
    real(kind=8), dimension(num_layers) :: flux_u_l, flux_u_r
    real(kind=8), dimension(num_layers) :: flux_v_l, flux_v_r
    real(kind=8), dimension(6) :: delta, flux_r, flux_l, pivot
    real(kind=8), dimension(6,6) :: eig_vec, A
    real(kind=8) :: beta(6), alpha(4), fw(3, 3), sw(3)
    logical, dimension(num_layers) :: dry_state_l, dry_state_r
    logical :: inundation

    external dgesv

    interface
        subroutine solve_single_layer_rp(layer_index, h_l, h_r, hu_l, hu_r, hv_l, hv_r, b_l, b_r, fw, sw)
            use geoclaw_module, only: g => grav
            use multilayer_module, only: dry_tolerance
            implicit none
            ! Input
            integer, intent(in) :: layer_index
            real(kind=8), intent(in), dimension(2) :: h_l, h_r, hu_l, hu_r, hv_l, hv_r
            real(kind=8), intent(in) :: b_l, b_r
            ! Output
            real(kind=8), intent(in out) :: fw(3, 3), sw(3)
        end subroutine solve_single_layer_rp
    end interface
    
    ! Initialize output variables
    amdq = 0.d0
    apdq = 0.d0
    
    ! Set normal direction
    if (ixy == 1) then
        n_index = 2
        t_index = 3
    else
        n_index = 3
        t_index = 2
    endif

    ! ========================================================================
    ! Loop through Riemann problems
    ! ========================================================================
    do i=2-mbc,mx+mbc
        dry_state_l = .false.
        dry_state_r = .false.
        inundation = .false.
        
        ! Parse states and set appropriate zeros
        ! Note that the "u-direction" is the direction of sweeping which 
        ! could actually be the x or y-directions depending on ixy
        
        do j=1,2
            layer_index = 3*(j-1)
            h_l(j) = qr(layer_index+1,i-1) / rho(j)
            hu_l(j) = qr(layer_index+n_index,i-1) / rho(j)
            hv_l(j) = qr(layer_index+t_index,i-1) / rho(j)
            
            h_r(j) = ql(layer_index+1,i) / rho(j)
            hu_r(j) = ql(layer_index+n_index,i) / rho(j)
            hv_r(j) = ql(layer_index+t_index,i) / rho(j)
            
            h_hat_l(j) = auxr(j+aux_layer_index-1,i-1)
            h_hat_r(j) = auxl(j+aux_layer_index-1,i)
            
            h_ave(:) = 0.5d0 * (h_l(:) + h_r(:))

            ! Check for dry states
            if (h_l(j) < dry_tolerance(j)) then
                dry_state_l(j) = .true.
                hu_l(j) = 0.d0
                hv_l(j) = 0.d0
                u_l(j) = 0.d0
                v_l(j) = 0.d0
            else
                u_l(j) = hu_l(j) / h_l(j)
                v_l(j) = hv_l(j) / h_l(j)
            endif
            if (h_r(j) < dry_tolerance(j)) then
                dry_state_r(j) = .true.
                hu_r(j) = 0.d0
                hv_r(j) = 0.d0
                u_r(j) = 0.d0
                v_r(j) = 0.d0
            else
                u_r(j) = hu_r(j) / h_r(j)
                v_r(j) = hv_r(j) / h_r(j)
            endif
        enddo
        
        b_l = auxr(1,i-1)
        b_r = auxl(1,i)

        ! For ease of checking below, count up number of dry states
        num_dry_states = 0
        do mw=1,2
            if (dry_state_l(mw)) then
                num_dry_states = num_dry_states + 1
            end if
            if (dry_state_r(mw)) then
                num_dry_states = num_dry_states + 1
            end if
        end do

        ! ===============================
        !  Completely dry cell - (T T T T)
        ! ===============================
        if (num_dry_states == 4) then
            s(:,i) = 0.d0
            fwave(:,:,i) = 0.d0

        ! ===============================================
        !  Single-layer problem - 
        !   (T F T F) or (F T F T) or (F T T T) or
        !   (T F T T) or (T T F T) or (T T T F)
        ! ===============================================
        !  Here check explicitly for the completely wet single-layer cases and 
        !  rely on the count to determine the other cases
        else if ((      dry_state_l(1) .and. .not. dry_state_l(2) .and.        &  ! T F T F
                        dry_state_r(1) .and. .not. dry_state_r(2))       .or.  &
                 (.not. dry_state_l(1) .and.       dry_state_l(2) .and.        &  ! F T F T
                  .not. dry_state_r(1) .and.       dry_state_r(2))       .or.  &
                 num_dry_states == 3) then

            ! Set wet layer index so that we can handle both the bottom and top
            ! layers being dry while the other is wet
            if (.not.dry_state_l(1) .or. .not.dry_state_r(1)) then
                layer_index = 1
            else if (.not.dry_state_l(2) .or. .not. dry_state_r(2)) then
                layer_index = 2
            else
                print *, "Invalid dry layer state reached."
                print *, "dry states: ", dry_state_l, dry_state_r
                print *, "        left            |             right"
                print *, "====================================================="
                print "(2d16.8)", h_l(1), h_r(1)
                print "(2d16.8)", hu_l(1), hu_r(1)
                print "(2d16.8)", hv_l(1), hv_r(1)
                print "(2d16.8)", h_l(2), h_r(2)
                print "(2d16.8)", hu_l(2), hu_r(2)
                print "(2d16.8)", hv_l(2), hv_r(2)
                print "(2d16.8)", b_l, b_r
                stop
            end if

            call solve_single_layer_rp(layer_index, h_l, h_r, hu_l, hu_r,      &
                                                    hv_l, hv_r, b_l, b_r,      &
                                                    fw, sw)

            ! Update speeds and waves
            ! Note that we represent all the waves in the first three arrays
            ! so it does not directly correspond to the two-layer case's wave
            ! structure
            s(:, i) = 0.d0
            fwave(:, :, i) = 0.d0
            
            if (layer_index == 1) then
                s(1:3, i) = sw(:)
                fwave(1, 1:3, i) = fw(1, :) * rho(layer_index)
                fwave(n_index, 1:3, i) = fw(2, :) * rho(layer_index)
                fwave(t_index, 1:3, i) = fw(3, :) * rho(layer_index)
            else
                s(4:6, i) = sw(:)
                fwave(1, 4:6, i) = fw(1, :) * rho(layer_index)
                fwave(n_index, 4:6, i) = fw(2, :) * rho(layer_index)
                fwave(t_index, 4:6, i) = fw(3, :) * rho(layer_index)
            end if

            ! Go on to next cell, lat-long and fluctuation calculations are 
            ! outside of this loop

        ! ======================================================================
        !  Multi-layer system must be solved
        !   In each case a special eigen system is solved and then the flux
        !     difference is evaluated.
        !   Note that the parameter *eigen_method* controls the method being 
        !     used if the cells are completely wet or there exists a wall 
        !     boundary problem in the bottom layer.  Otherwise the parameter 
        !     *inundation_method* is used.
        ! ======================================================================
        else
            ! By default fill in the eigen and flux evaluation states with their
            ! side values
            if (eigen_method == 1) then
                eigen_h_l = h_hat_l
                eigen_h_r = h_hat_r
            else
                eigen_h_l = h_l
                eigen_h_r = h_r
            end if
            eigen_u_l = u_l
            eigen_u_r = u_r
            eigen_v_l = v_l
            eigen_v_r = v_r

            flux_h_l = h_l
            flux_h_r = h_r
            flux_hu_l = hu_l
            flux_hu_r = hu_r
            flux_hv_l = hv_l
            flux_hv_r = hv_r
            flux_u_l = u_l
            flux_u_r = u_r
            flux_v_l = v_l
            flux_v_r = v_r

            ! Also intialize other flux evaluation stuff
            flux_transfer_r = 0.d0
            flux_transfer_l = 0.d0
            momentum_transfer = 0.d0

            ! ==================================================================
            !  Right state is completely dry - (F F T T)
            if (.not. dry_state_l(1) .and. .not. dry_state_l(2) .and.          &
                      dry_state_r(1) .and.       dry_state_r(2)) then
    
                ! Inundation occurs
                inundation = sum(h_l) + b_l > b_r
                if (inundation) then
                    print *, "Inundation in this case not yet handled."
                    print *, "  dry_state = ", dry_state_l, dry_state_r
                    stop 

                ! Wall boundary
                else
                    ! Wall state - Mirror left state onto right
                    if (eigen_method /= 1) eigen_h_r = h_l
                    eigen_u_r = -u_l
                    eigen_v_r =  v_r

                    ! Flux evaluation
                    flux_h_r = h_l
                    flux_hu_r = -hu_l
                    flux_u_r = -u_l
                    flux_hv_r = hv_l
                    flux_v_r = v_l

                    flux_transfer_r = 0.d0
                    flux_transfer_l = 0.d0
                    momentum_transfer(1) = 0.d0
                    momentum_transfer(2) = 0.d0
                endif

            ! ==================================================================
            !  Left state is completely dry - (T T F F)
            else if (      dry_state_l(1) .and.       dry_state_l(2) .and.     &
                     .not. dry_state_r(1) .and. .not. dry_state_r(2)) then

                ! Inundation
                inundation = sum(h_r) + b_r > b_l
                if (inundation) then
                    print *, "Inundation in this case not yet handled."
                    print *, "  dry_state = ", dry_state_l, dry_state_r
                    stop 

                ! Wall
                else
                    if (eigen_method /= 1) eigen_h_l = h_r
                    eigen_u_l = -u_r
                    eigen_v_l = v_l
                
                    ! Flux evaluation
                    flux_h_l = h_r
                    flux_hu_l = -hu_r
                    flux_u_l = -u_r
                    flux_hv_l = hv_r
                    flux_v_l = v_r

                    flux_transfer_r = 0.d0
                    flux_transfer_l = 0.d0
                    momentum_transfer(1) = 0.d0
                    momentum_transfer(2) = 0.d0

                end if

            ! ==================================================================
            !  Right bottom state is dry - (F F F T)
            else if (.not. dry_state_l(1) .and. .not. dry_state_l(2) .and.     &
                     .not. dry_state_r(1) .and.       dry_state_r(2)) then

                ! Inundation
                inundation = h_l(2) + b_l > b_r
                if (inundation) then
                    if (inundation_method == 1 .or.                            &
                        inundation_method == 4) then
                        eigen_h_r = [h_r(1), 0.d0]
                    else if (inundation_method == 2 .or.                       &
                             inundation_method == 3 .or.                       &
                             inundation_method == 5) then
                        eigen_h_r = [h_r(1), 0.d0]
                    end if
    
                    ! Flux evaluation
                    momentum_transfer(1) =  g * rho(1) * h_ave(1) * (h_r(2) - h_l(2) + b_r - b_l)
                    momentum_transfer(2) = -g * rho(1) * h_ave(1) * (h_r(2) - h_l(2)) + g * rho(2) * h_ave(2) * (b_r - b_l)
                    flux_transfer_r = g * rho(1) * h_r(1) * h_r(2)
                    flux_transfer_l = g * rho(1) * h_l(1) * h_l(2)

                ! Wall
                else
                    if (eigen_method /= 1) eigen_h_r = [h_r(1), 0.d0]
                    eigen_u_r = [u_r(1), -u_l(2)]
                    eigen_v_r = [v_r(1),  v_l(2)]

                    ! Flux evaluation
                    flux_h_r(2) = h_l(2)
                    flux_hu_r(2) = -hu_l(2)
                    flux_u_r(2) = -u_l(2)
                    flux_hv_r(2) = hv_l(2)
                    flux_v_r(2) = v_l(2)
                
                    flux_transfer_r = 0.d0
                    flux_transfer_l = 0.d0
                    momentum_transfer(1) = g * rho(1) * h_ave(1) * (b_r - flux_h_l(2) - b_l)
                    momentum_transfer(2) = 0.d0

                end if

            ! ==================================================================
            !  Left bottom state is dry - (F T F F)
            else if (.not. dry_state_l(1) .and.       dry_state_l(2) .and.     &
                     .not. dry_state_r(1) .and. .not. dry_state_r(2)) then

                ! Inundation
                inundation = (h_r(2) + b_r > b_l)
                if (inundation) then
                    if (inundation_method == 1 .or. inundation_method == 5) then
                        eigen_h_l = [h_l(1), 0.d0]
                    else if (inundation_method == 2 .or.                       &
                             inundation_method == 3 .or.                       &
                             inundation_method == 4) then
                        eigen_h_l = [h_l(1), dry_tolerance(1)]
                    end if
    
                    ! Flux evaluation
                    momentum_transfer(1) =  g * rho(1) * h_ave(1) * (h_r(2) - h_l(2) + b_r - b_l)
                    momentum_transfer(2) = -g * rho(1) * h_ave(1) * (h_r(2) - h_l(2)) + g * rho(2) * h_ave(2) * (b_r - b_l)
                    flux_transfer_r = g * rho(1) * h_r(1) * h_r(2)
                    flux_transfer_l = g * rho(1) * h_l(1) * h_l(2)

                ! Wall
                else
                    if (eigen_method /= 1) eigen_h_l = [h_l(1), 0.d0]
                    eigen_u_l = [u_l(1), -u_r(2)]
                    eigen_v_l = [v_l(1),  v_r(2)]
    
                    ! Flux evaluation
                    flux_h_l(2) = h_r(2)
                    flux_hu_l(2) = -hu_r(2)
                    flux_u_l(2) = -u_r(2)
                    flux_hv_l(2) = hv_r(2)
                    flux_v_l(2) = v_r(2)
                
                    flux_transfer_r = 0.d0
                    flux_transfer_l = 0.d0
                    momentum_transfer(1) = g * rho(1) * h_ave(1) * (b_r + flux_h_r(2) - b_l)
                    momentum_transfer(2) = 0.d0

                end if

            ! ==================================================================
            !  All-states are wet - (F F F F)
!             else if (.not. dry_state_l(1) .and. .not. dry_state_l(2) .and.     &
!                      .not. dry_state_r(1) .and. .not. dry_state_r(2)) then
            else if (num_dry_states == 0) then

                ! Nothing to do for eigenspace evaluation

                ! Flux evaulation
                momentum_transfer(1) =  g * rho(1) * h_ave(1) * (h_r(2) - h_l(2) + b_r - b_l)
                momentum_transfer(2) = -g * rho(1) * h_ave(1) * (h_r(2) - h_l(2)) + g * rho(2) * h_ave(2) * (b_r - b_l)
                flux_transfer_r = g * rho(1) * h_r(1) * h_r(2)
                flux_transfer_l = g * rho(1) * h_l(1) * h_l(2)

            ! ==================================================================
            !  We do not yet handle this case - F F F F and F F F F 
            else
                print *, "Unhandled dry-state condition reached."
                print *, "dry states: ", dry_state_l, dry_state_r
                print *, "        left            |             right"
                print *, "====================================================="
                print "(2d16.8)", h_l(1), h_r(1)
                print "(2d16.8)", hu_l(1), hu_r(1)
                print "(2d16.8)", hv_l(1), hv_r(1)
                print "(2d16.8)", h_l(2), h_r(2)
                print "(2d16.8)", hu_l(2), hu_r(2)
                print "(2d16.8)", hv_l(2), hv_r(2)
                print "(2d16.8)", b_l, b_r
                stop
            end if

            ! ==================================================================
            !  Compute eigen space
            ! ==================================================================
            if (inundation) then
                call inundation_eigen_func(eigen_h_l, eigen_h_r,               &
                                           eigen_u_l, eigen_u_r,               &
                                           eigen_v_l, eigen_v_r,               &
                                           n_index, t_index,                   &
                                           lambda, eig_vec)
                                
                ! Internal wave corrections
                if (inundation_method == 1) then
                    ! Left bottom state dry
                    if (.not. dry_state_l(1) .and.       dry_state_l(2) .and.  &
                        .not. dry_state_r(1) .and. .not. dry_state_r(2)) then

                        s(2,i) = u_r(2) - 2.d0 * sqrt(g*(1.d0-r)*h_r(2))
                        alpha(2) = r * g * h_r(2) / ((s(2,i) - u_r(2))**2 - g*h_r(2))
                        eig_vec(1,2) = 1.d0
                        eig_vec(n_index,2) = s(2,i) 
                        eig_vec(t_index,2) = v_l(1)
                        eig_vec(4,2) = alpha(2)
                        eig_vec(n_index,2) = alpha(2)*s(2,i)
                        eig_vec(t_index,2) = alpha(2)*v_l(2)
                    ! Right bottom state dry
                    else if (.not. dry_state_l(1) .and. .not. dry_state_l(2) .and. &
                             .not. dry_state_r(1) .and.       dry_state_r(2)) then

                        s(5,i) = u_l(2) + 2.d0 * sqrt(g*(1.d0-r)*h_l(2))
                        alpha(3) = r * g * h_l(2) / ((s(5,i) - u_l(2))**2 - g * h_l(2))
                        
                        eig_vec(1,5) = 1.d0
                        eig_vec(n_index,5) = s(5,i)
                        eig_vec(t_index,5) = v_r(1)
                        eig_vec(4,5) = alpha(3)
                        eig_vec(n_index,5) = s(5,i) * alpha(3)
                        eig_vec(t_index,6) = v_r(2) * alpha(3)
                    end if
                end if
                if (inundation_method /= 5) then
                    ! Left bottom state dry
                    if (.not. dry_state_l(1) .and.       dry_state_l(2) .and.  &
                        .not. dry_state_r(1) .and. .not. dry_state_r(2)) then

                        s(1,i) = u_l(1) - sqrt(g*h_l(1))
                        eig_vec(1,1) = 1.d0
                        eig_vec(n_index,1) = s(1,i)
                        eig_vec(t_index,1) = v_l(1)
                        eig_vec(4:6,1) = 0.d0

                    ! Right bottom state dry
                    else if (.not. dry_state_l(1) .and. .not. dry_state_l(2) .and. &
                             .not. dry_state_r(1) .and.       dry_state_r(2)) then

                        s(6,i) = u_r(1) + sqrt(g*h_r(1))
                        eig_vec(1,6) = 1.d0
                        eig_vec(n_index,6) = s(6,i)
                        eig_vec(t_index,6) = v_r(1)
                        eig_vec(4:6,6) = 0.d0

                    end if

                end if
            else
                call eigen_func(eigen_h_l, eigen_h_r,                    &
                                eigen_u_l, eigen_u_r,                    &
                                eigen_v_l, eigen_v_r,                    &
                                n_index, t_index,                        &
                                lambda, eig_vec)

            end if

            s(:,i) = lambda

            ! ======================================================================
            !  Compute flux differences
            ! ======================================================================
            do j=1,2
                layer_index = 3*(j-1)
                flux_r(layer_index+1) = rho(j) * flux_hu_r(j)
                flux_r(layer_index+n_index) = rho(j) * (flux_h_r(j) * flux_u_r(j)**2 + 0.5d0 * g * flux_h_r(j)**2)
                flux_r(layer_index+t_index) = rho(j) * flux_h_r(j) * flux_u_r(j) * flux_v_r(j)
                
                flux_l(layer_index+1) = rho(j) * flux_hu_l(j)
                flux_l(layer_index+n_index) = rho(j) * (flux_h_l(j) * flux_u_l(j)**2 + 0.5d0 * g * flux_h_l(j)**2)
                flux_l(layer_index+t_index) = rho(j) * flux_h_l(j) * flux_u_l(j) * flux_v_l(j)
            enddo
            ! Add extra flux terms
            flux_r(3 + n_index) = flux_r(3 + n_index) + flux_transfer_r
            flux_l(3 + n_index) = flux_l(3 + n_index) + flux_transfer_l
            
            delta = flux_r - flux_l
                
            ! Momentum transfer and bathy terms
            delta(n_index) = delta(n_index) + momentum_transfer(1)
            delta(n_index+3) = delta(n_index+3) + momentum_transfer(2)

            ! ======================================================================
            ! Project jump in fluxes - Use LAPACK's dgesv routine
            !    N - (int) - Number of linear equations (6)
            !    NRHS - (int) - Number of right hand sides (1)
            !    A - (dp(6,6)) - Coefficient matrix, in this case eig_vec
            !    LDA - (int) - Leading dimension of A (6)
            !    IPIV - (int(N)) - Pivot indices
            !    B - (dp(LDB,NRHS)) - RHS of equations (delta)
            !    LDB - (int) - Leading dimension of B (6)
            !    INFO - (int) - Status of result
            !  Note that the solution (betas) are in delta after the call
            ! ======================================================================
            A = eig_vec ! We need to do this as the return matrix is modified and
                        ! we have to use eig_vec again to compute fwaves
            info = 0       
            call dgesv(6,1,A,6,pivot,delta,6,info)
            if (.not.(info == 0)) then
                print *, "dry states: ", dry_state_l, dry_state_r
                print *, "        left            |             right"
                print *, "====================================================="
                print "(2d16.8)", h_l(1), h_r(1)
                print "(2d16.8)", hu_l(1), hu_r(1)
                print "(2d16.8)", hv_l(1), hv_r(1)
                print "(2d16.8)", h_l(2), h_r(2)
                print "(2d16.8)", hu_l(2), hu_r(2)
                print "(2d16.8)", hv_l(2), hv_r(2)
                print "(2d16.8)", b_l, b_r
                print *,""
                print "(a,i2)","In normal solver: ixy=",ixy
                print "(a,i3)","  Error solving R beta = delta,",info
                print "(a,6d16.8)","  Eigenspeeds: ",s(:,i)
                print "(a)","  Eigenvectors:"
                do j=1,6
                    print "(a,6d16.8)","  ",(eig_vec(j,mw),mw=1,6)
                enddo
                stop
            endif
            beta = delta

            ! ======================================================================
            ! Compute fwaves
            forall(mw=1:mwaves)
                fwave(:,mw,i) = eig_vec(:,mw) * beta(mw)
            end forall
        end if

    end do
    ! == End of Riemann Solver Loop per grid cell ==============================

    ! ==========================================================================
    ! Capacity for mapping from latitude longitude to physical space
    if (mcapa > 0) then
        do i=2-mbc,mx+mbc
            if (ixy == 1) then
                dxdc=(earth_radius*pi/180.d0)
            else
                dxdc=earth_radius*cos(auxl(3,i))*pi/180.d0
            endif

            do mw=1,mwaves
                s(mw,i)=dxdc*s(mw,i)
                fwave(:,mw,i)=dxdc*fwave(:,mw,i)
            enddo
        enddo
    endif

    ! ==========================================================================
    !  Compute fluctuations 
    do i=2-mbc,mx+mbc
        do mw=1,mwaves
            if (s(mw,i) > 0.d0) then
                apdq(:,i) = apdq(:,i) + fwave(:,mw,i)
            else
                amdq(:,i) = amdq(:,i) + fwave(:,mw,i)
            endif
            !h_r(1) = ql(1,i) / rho(1)
            !h_l(1) = qr(1,i-1) / rho(1)
            !h_r(2) = ql(4,i) / rho(2)
            !h_l(2) = qr(4,i-1) / rho(2)
            !dry_state_r(2) = h_r(2) < dry_tolerance(2)
            !dry_state_l(2) = h_l(2) < dry_tolerance(2)
            !rare(1) = h_l(2) + b_l > b_r
            !rare(2) = h_r(2) + b_r > b_l
            !if (dry_state_r(2).and.(.not.dry_state_l(2)).and.(.not.rare(1)) &
            ! .or.(dry_state_l(2).and.(.not.dry_state_r(2)).and.(.not.rare(2)))) then
            !    do m=4,6
            !        if (abs(apdq(m,i)) <= 1.d-8) then
            !            print *,"========================"
            !            print *,"Wave ",mw," equation ",m
            !            print *,"s = ",s(mw,i)
            !            print *,"f = ",fwave(m,mw,i)
            !            print *,"amdq = ",(amdq(m,i))
            !            print *,"apdq = ",(apdq(m,i))
            !            stop "Fluctuation apdq non-zero going into a wall, aborting calculation."
            !        endif
            !    enddo
            !    apdq(4:6,i) = 0.d0
            !endif
        enddo
    enddo

end subroutine rpn2


! ==================================
!  Solve the single-layer equations
! ==================================
! subroutine solve_sinlge_layer_rp(layer_index, h_l, h_r,                        &
!                                               hu_l, hu_r,                      &
!                                               hv_l, hv_r,                      &
!                                               u_l, u_r,                        &
!                                               v_l, v_r,                        &
!                                               b_l, b_r,                        &
!                                               fw, sw)

!     use geoclaw_module, only: g => grav
!     use multilayer_module, only: dry_tolerance

!     implicit none

!     ! Input
!     integer, intent(in) :: layer_index
!     real(kind=8), intent(in out), dimension(2) :: h_l, h_r
!     real(kind=8), intent(in out), dimension(2) :: hu_l, hu_r
!     real(kind=8), intent(in out), dimension(2) :: hv_l, hv_r
!     real(kind=8), intent(in out), dimension(2) :: u_r, u_l
!     real(kind=8), intent(in out), dimension(2) :: v_r, v_l
!     real(kind=8), intent(in out) :: b_l, b_r

!     ! Output
!     real(kind=8), intent(out) :: fw(3, 3), sw(3)

!     ! Local storage
!     integer :: m, mw
!     logical :: rare(2)
!     real(kind=8) :: wall(3), h_star, h_star_test, sm(2)
!     real(kind=8) :: phi_l, phi_r, s_l, s_r, u_hat, c_hat, s_roe(2), s_E(2)

!     ! Algorithm parameters
!     integer, parameter :: MAX_ITERATIONS = 1

!     wall = 1.d0
    
!     ! Calculate momentum fluxes
!     phi_l = 0.5d0 * g * h_l(layer_index)**2      &
!                         + h_l(layer_index) * u_l(layer_index)**2
!     phi_r = 0.5d0 * g * h_r(layer_index)**2      &
!                         + h_r(layer_index) * u_r(layer_index)**2
     
!     ! Check for dry state to right
!     if (h_r(layer_index) < dry_tolerance(layer_index)) then
!         call riemanntype(h_l(layer_index), h_l(layer_index),   &
!                          u_l(layer_index),-u_l(layer_index),   &
!                          h_star, sm(1), sm(2), rare(1), rare(2), 1,    &
!                          dry_tolerance(layer_index), g)
!         h_star_test = max(h_l(layer_index), h_star)
!         ! Right state should become ghost values that mirror left for wall problem
!         if (h_star_test + b_l < b_r) then 
!             wall(2:3) = 0.d0
!             h_r(layer_index) = h_l(layer_index)
!             hu_r(layer_index) = -hu_l(layer_index)
!             b_r = b_l
!             phi_r = phi_l
!             u_r(layer_index) = -u_l(layer_index)
!             v_r(layer_index) = v_l(layer_index)
!         else if (h_l(layer_index) + b_l < b_r) then
!             b_r = h_l(layer_index) + b_l
!         endif
!     ! Check for drystate to left, i.e right surface is lower than left topo
!     else if (h_l(layer_index) < dry_tolerance(layer_index)) then 
!         call riemanntype(h_r(layer_index), h_r(layer_index),   &
!                         -u_r(layer_index), u_r(layer_index),   &
!                          h_star, sm(1), sm(2), rare(1), rare(2), 1,    &
!                          dry_tolerance(layer_index), g)
!         h_star_test = max(h_r(layer_index), h_star)
!         ! Left state should become ghost values that mirror right
!         if (h_star_test + b_r < b_l) then  
!            wall(1:2) = 0.d0
!            h_l(layer_index) = h_r(layer_index)
!            hu_l(layer_index) = -hu_r(layer_index)
!            b_l = b_r
!            phi_l = phi_r
!            u_l(layer_index) = -u_r(layer_index)
!            v_l(layer_index) = v_r(layer_index)
!         else if (h_r(layer_index) + b_r < b_l) then
!            b_l = h_r(layer_index) + b_r
!         endif
!     endif

!     ! Determine wave speeds
!     ! 1 wave speed of left state
!     s_l = u_l(layer_index) - sqrt(g * h_l(layer_index))
!     ! 2 wave speed of right state
!     s_r = u_r(layer_index) + sqrt(g * h_r(layer_index))
    
!     ! Roe average
!     u_hat = (sqrt(g * h_l(layer_index)) * u_l(layer_index)     &
!            + sqrt(g * h_r(layer_index)) * u_r(layer_index))    &
!            / (sqrt(g * h_r(layer_index)) + sqrt(g * h_l(layer_index))) 
!     c_hat = sqrt(g * 0.5d0 * (h_r(layer_index) + h_l(layer_index))) 
!     s_roe(1) = u_hat - c_hat ! Roe wave speed 1 wave
!     s_roe(2) = u_hat + c_hat ! Roe wave speed 2 wave
!     s_E(1) = min(s_l, s_roe(1)) ! Eindfeldt speed 1 wave
!     s_E(2) = max(s_r, s_roe(2)) ! Eindfeldt speed 2 wave
    
!     ! Solve Riemann problem
!     call riemann_aug_JCP(MAX_ITERATIONS, 3, 3,                         &
!                          h_l(layer_index), h_r(layer_index),   &
!                          hu_l(layer_index), hu_r(layer_index), &
!                          hv_l(layer_index), hv_r(layer_index), &
!                          b_l, b_r,                                     &
!                          u_l(layer_index), u_r(layer_index),   &
!                          v_l(layer_index), v_r(layer_index),   &
!                          phi_l, phi_r, s_E(1), s_E(2),           &
!                          dry_tolerance(layer_index), g, sw, fw)
    
!     ! Eliminate ghost fluxes for wall
!     do mw=1,3
!         sw(mw) = sw(mw) * wall(mw)
!         do m=1,3
!            fw(m, mw) = fw(m, mw) * wall(mw)
!         enddo
!     enddo

! end subroutine solve_sinlge_layer_rp

subroutine solve_single_layer_rp(layer_index, h_l, h_r, hu_l, hu_r, hv_l, hv_r, b_l, b_r, fw, sw)

    use geoclaw_module, only: g => grav
    use multilayer_module, only: dry_tolerance

    implicit none

    ! Input
    integer, intent(in) :: layer_index
    real(kind=8), intent(in), dimension(2) :: h_l, h_r, hu_l, hu_r, hv_l, hv_r
    real(kind=8), intent(in) :: b_l, b_r

    ! Output
    real(kind=8), intent(in out) :: fw(3, 3), sw(3)

    ! Locals
    integer :: mw
    real(kind=8) :: hL, hR, huL, huR, hvL, hvR, uL, uR, vL, vR, bL, bR, pL, pR
    real(kind=8) :: phiL, phiR, wall(3), drytol
    real(kind=8) :: hstar, hstartest, s1m, s2m, rare1, rare2, sL, sR, uhat, chat, sRoe1, sRoe2, sE1, sE2

    ! Parameters (should be anyway)
    integer :: maxiter

    ! Density used in pressure gradient calculation
    ! This needs to be realistic here as compared to air density so we cannot
    ! use what is stored in the multilayer_module unless real densities are 
    ! being used
    ! TODO - fix this limitation 
    real(kind=8), parameter :: rho = 1025.d0

    drytol = dry_tolerance(layer_index)

    hL = h_l(layer_index)
    hR = h_r(layer_index)
    huL = hu_l(layer_index)
    huR = hu_r(layer_index)
    hvL = hv_l(layer_index)
    hvR = hv_r(layer_index)
    bL = b_l
    bR = b_r
    pL = 0.d0
    pR = 0.d0

    ! ========================================
    !  Begin Snipped Code From rpn2_geoclaw.f
    ! ========================================
    !check for wet/dry boundary
         if (hR.gt.drytol) then
            uR=huR/hR
            vR=hvR/hR
            phiR = 0.5d0*g*hR**2 + huR**2/hR
         else
            hR = 0.d0
            huR = 0.d0
            hvR = 0.d0
            uR = 0.d0
            vR = 0.d0
            phiR = 0.d0
         endif

         if (hL.gt.drytol) then
            uL=huL/hL
            vL=hvL/hL
            phiL = 0.5d0*g*hL**2 + huL**2/hL
         else
            hL=0.d0
            huL=0.d0
            hvL=0.d0
            uL=0.d0
            vL=0.d0
            phiL = 0.d0
         endif

         wall(1) = 1.d0
         wall(2) = 1.d0
         wall(3) = 1.d0
         if (hR.le.drytol) then
            call riemanntype(hL,hL,uL,-uL,hstar,s1m,s2m,rare1,rare2,1,drytol,g)
            hstartest=max(hL,hstar)
            if (hstartest+bL.lt.bR) then !right state should become ghost values that mirror left for wall problem
!                bR=hstartest+bL
               wall(2)=0.d0
               wall(3)=0.d0
               hR=hL
               huR=-huL
               bR=bL
               phiR=phiL
               uR=-uL
               vR=vL
            elseif (hL+bL.lt.bR) then
               bR=hL+bL
            endif
         elseif (hL.le.drytol) then ! right surface is lower than left topo
            call riemanntype(hR,hR,-uR,uR,hstar,s1m,s2m,rare1,rare2,1,drytol,g)
            hstartest=max(hR,hstar)
            if (hstartest+bR.lt.bL) then  !left state should become ghost values that mirror right
!               bL=hstartest+bR
               wall(1)=0.d0
               wall(2)=0.d0
               hL=hR
               huL=-huR
               bL=bR
               phiL=phiR
               uL=-uR
               vL=vR
            elseif (hR+bR.lt.bL) then
               bL=hR+bR
            endif
         endif

         !determine wave speeds
         sL=uL-sqrt(g*hL) ! 1 wave speed of left state
         sR=uR+sqrt(g*hR) ! 2 wave speed of right state

         uhat=(sqrt(g*hL)*uL + sqrt(g*hR)*uR)/(sqrt(g*hR)+sqrt(g*hL)) ! Roe average
         chat=sqrt(g*0.5d0*(hR+hL)) ! Roe average
         sRoe1=uhat-chat ! Roe wave speed 1 wave
         sRoe2=uhat+chat ! Roe wave speed 2 wave

         sE1 = min(sL,sRoe1) ! Eindfeldt speed 1 wave
         sE2 = max(sR,sRoe2) ! Eindfeldt speed 2 wave

         !--------------------end initializing...finally----------
         !solve Riemann problem.

         maxiter = 1

         call riemann_aug_JCP(maxiter,3,3,hL,hR,huL,huR,hvL,hvR,bL,bR,uL,uR, &
                                          vL,vR,phiL,phiR,pL,pR,sE1,sE2,     &
                                          drytol,g,rho,sw,fw)

!         call riemann_ssqfwave(maxiter,meqn,mwaves,hL,hR,huL,huR,
!     &     hvL,hvR,bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2,drytol,g,sw,fw)

!          call riemann_fwave(meqn,mwaves,hL,hR,huL,huR,hvL,hvR,
!     &      bL,bR,uL,uR,vL,vR,phiL,phiR,sE1,sE2,drytol,g,sw,fw)

!        !eliminate ghost fluxes for wall
         do mw=1,3
            sw(mw)=sw(mw)*wall(mw)

               fw(1,mw)=fw(1,mw)*wall(mw) 
               fw(2,mw)=fw(2,mw)*wall(mw)
               fw(3,mw)=fw(3,mw)*wall(mw)
         enddo

end subroutine solve_single_layer_rp

!
!  :::::::::::::: BOUND :::::::::::::::::::::::::::::::::::::::::::
!     This routine sets the boundary values for a given grid 
!     at level level.
!     We are setting the values for a strip ng zones wide all
!     the way around the border, in 4 rectangular strips.
!
!     Outputs from this routine:
!     The values around the border of the grid are inserted
!     directly into the enlarged valbig array.
!
!     This routine calls the routine filpatch
!     which for any block of mesh points on a given level,
!     intersects that block with all grids on that level and with
!     the physical boundaries, copies the values into the
!     appropriate intersecting regions, and interpolates the remaining
!     cells from coarser grids as required.
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!
!  Below are comments for Doxygen
!>
!! \callgraph
!! \callergraph
!! This routine sets the boundary values for a given grid 
!! at level level. It sets the values for a strip ng zones wide all
!! the way around the border, in 4 rectangular strips.
!!
!!
!! This routine calls the routine filpatch()
!! which for any block of mesh points on a given level,
!! intersects that block with all grids on that level,
!! copies the values into the appropriate intersecting regions, 
!! and interpolates the remaining cells from coarser grids as required.
!! After calling filpatch for four regions around the border, call bc2amr()
!! to set any regions that are outside physical boundary.
!!
!! **Output**:
!!
!! The values around the border of the grid are inserted directly into the enlarged valbig array.
!!
!! \param time the grid **mptr** needs ghost cell values at time **t**
!! \param nvar number of equations for the system
!! \param ng width of ghost regions on each side
!! \param valbig data array for solution \f$q \f$ (cover the whole grid **msrc**)
!! \param mitot number of cells in *i* direction on grid **mptr** 
!! \param mjtot number of cells in *j* direction on grid **mptr**
!! \param mptr index of the grid to be processed
!! \param aux data array for auxiliary variables 
!! \param naux number of auxiliary variables
!!
subroutine bound(time,nvar,ng,valbig,mitot,mjtot,mptr,aux,naux)

  use amr_module, only: rnode, node, hxposs, hyposs, cornxlo, cornxhi
  use amr_module, only: cornylo, cornyhi, ndilo, ndihi, ndjlo, ndjhi
  use amr_module, only: nestlevel, xlower, xupper, ylower, yupper
  use amr_module, only: xperdom, yperdom, spheredom

  implicit none

  ! Input
  integer, intent(in) :: nvar, ng, mitot, mjtot, mptr, naux
  real(kind=8), intent(in) :: time
  real(kind=8), intent(in out) :: valbig(nvar,mitot,mjtot)
  real(kind=8), intent(in out) :: aux(naux,mitot,mjtot)

  ! Locals
  integer :: ilo, ihi, jlo, jhi, level  ! rect(4)
  real(kind=8) :: xleft, xright, ybot, ytop, hx, hy, xl, xr, yb, yt
  real(kind=8) :: xloWithGhost,  xhiWithGhost,  yloWithGhost, yhiWithGhost
  logical      :: patchOnly
  logical      :: do_aux_copy

#ifdef WHERE_AM_I
      write(*,*)"starting bound"
#endif

  xleft  = rnode(cornxlo, mptr)
  xright = rnode(cornxhi, mptr)
  ybot   = rnode(cornylo, mptr)
  ytop   = rnode(cornyhi, mptr)
  ilo    = node(ndilo, mptr)
  ihi    = node(ndihi, mptr)
  jlo    = node(ndjlo, mptr)
  jhi    = node(ndjhi, mptr)
  level  = node(nestlevel, mptr)
  hx     = hxposs(level)
  hy     = hyposs(level)

  ! when grid copies from same level aux already set so
  ! no need to copy from neighboring grids
  ! this variable will be changed inside filpatch
  ! for recursive call to coarser levels
  do_aux_copy = .false.

  xloWithGhost = xleft  - ng*hx
  xhiWithGhost = xright + ng*hx
  yloWithGhost =  ybot  - ng*hy
  yhiWithGhost =  ytop  + ng*hy
  ! used in filaptch for bc2amr: for patches it is called. for full grids called from bound below
  patchOnly = .false.  




  ! left boundary
  xl = xleft - ng*hx
  xr = xleft
  yb = ybot 
  yt = ytop
  if ((xl < xlower) .and. xperdom) then
     call  prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,ng+1, &
          ilo-ng,ilo-1,jlo,jhi,ilo-ng,ihi+ng,jlo-ng,jhi+ng,patchOnly)
  else
     call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,ng+1,ilo-ng,ilo-1,jlo,jhi,patchOnly,mptr,do_aux_copy)
  endif

  ! right boundary
  xl = xright
  xr = xright + ng*hx
  yb = ybot
  yt = ytop

  if ((xr .gt. xupper) .and. xperdom) then
     call  prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
          mitot-ng+1,ng+1,ihi+1,ihi+ng,jlo,jhi,ilo-ng,ihi+ng,jlo-ng,jhi+ng,patchOnly)
  else
     call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
          mitot-ng+1,ng+1,ihi+1,ihi+ng,jlo,jhi,patchOnly,mptr,do_aux_copy)
  endif

  ! bottom boundary
  xl = xleft  - ng*hx
  xr = xright + ng*hx
  yb = ybot - ng*hy
  yt = ybot

  if ( ((yb < ylower) .and. (yperdom .or. spheredom)) .or. &
       ( ((xl < xlower) .or. (xr > xupper)) .and. xperdom) ) then
     call prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,   &
                      1,1,ilo-ng,ihi+ng,jlo-ng,jlo-1,                &
                      ilo-ng,ihi+ng,jlo-ng,jhi+ng,patchOnly)
  else
     call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,1,ilo-ng,ihi+ng,jlo-ng,jlo-1,patchOnly,mptr,do_aux_copy)
  endif


  ! top boundary
  xl = xleft - ng*hx
  xr = xright + ng*hx
  yb = ytop
  yt = ytop + ng*hy

  if ( ((yt .gt. yupper) .and. (yperdom .or. spheredom)) .or. &
       (((xl .lt. xlower) .or. (xr .gt. xupper)) .and. xperdom) ) then
     call prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
          1,mjtot-ng+1,ilo-ng,ihi+ng,jhi+1,jhi+ng,ilo-ng,ihi+ng,jlo-ng,jhi+ng,patchOnly)
  else
     call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
          1,mjtot-ng+1,ilo-ng,ihi+ng,jhi+1,jhi+ng,patchOnly,mptr,do_aux_copy)
  endif


  ! set all exterior (physical)  boundary conditions for this grid at once
  ! used to be done from filpatch, but now only for recursive calls with new patch
  ! where the info matches. more efficient to do whole grid at once, and avoid copying
  call bc2amr(valbig,aux,mitot,mjtot,nvar,naux,hx,hy,level,time,    &
              xloWithGhost,xhiWithGHost,yloWithGhost,yhiWithGhost)

#ifdef WHERE_AM_I
      write(*,*)"ending   bound"
#endif

end subroutine bound

!  :::::::::::::: PREFILRECUR :::::::::::::::::::::::::::::::::::::::::::
!     For periodic boundary conditions more work needed to fill the
!     piece of the boundary. This routine was
!     called because the patch sticks out of the domain,
!     and has periodic bc.s preprocess the patch before calling
!     filpatch to shift the patch periodically back into the domain.
!
!     Inputs to this routine:
!     xl, xr, yb, yt = the location in physical space of
!     corners of a patch.
!     fill_indices = the location in index space of this patch.
!
!     Outputs from this routine:
!     The values around the border of the grid are inserted
!     directly into the enlarged valbig array for this piece.
!
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
recursive subroutine prefilrecur(level,nvar,valbig,auxbig,naux,time,mitot,  &
                                 nrowst,ilo,ihi,iglo,ighi,patchOnly)



    use amr_module, only: iregsz, nghost, xlower, xperdom
    use amr_module, only: hxposs, NEEDS_TO_BE_SET, alloc
    
    !for setaux timing
    use amr_module, only: timeSetaux, timeSetauxCPU
    
    implicit none

    ! Input
    integer, intent(in) :: level, nvar, naux, mitot
    integer, intent(in) :: ilo,ihi,iglo,ighi
    real(kind=8), intent(in) :: time
    ! false when called from bound, when valbig is whole grid but only filling patch.
    ! true for recursive coarse sub-patches - grid is patch
    logical  :: patchOnly  

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mitot)
    real(kind=8), intent(in out) :: auxbig(naux,mitot)
    
    ! Local storage

    ! Various of these are extra. Remove once you know which.
    integer :: i, ii, ivar, ng, i1, i2, nrowst
    integer :: iputst, mi, locpatch, locpaux
    integer :: iwrap1, iwrap2, tmp, locflip, rect(2)
    real(kind=8) :: xlwrap
    integer ::  msrc    ! this signifies not a real grid, no bndry list with it
    ! it is possible to preprocess in the periodic case, just more complicated, so postponing

    integer :: ist(3), iend(3), ishift(3)
    real(kind=8) :: scratch(mitot*nghost*nvar)
    real(kind=8) :: scratchaux(mitot*nghost*naux)

    ! dimension at largest possible
    real(kind=8) :: valPatch((ihi-ilo+1) * nvar)
    real(kind=8) :: auxPatch((ihi-ilo+1) * naux)
    
    !for timing setaux
    integer :: clock_start, clock_finish, clock_rate
    real(kind=8) :: cpu_start, cpu_finish

!     # will divide patch  (from ilo to ihi)  into 3 possibilities (some empty):
!       x sticks out left, x interior, x sticks out right
!       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)
!     # this patch lives in a grid with soln array valbig, which goes from
!       (iglo) to (ighi).

    msrc = -1   ! iitialization indicating whether real src grid so can use faster bc list

    if (xperdom) then       
       ist(1)    = ilo
       ist(2)    = 0
       ist(3)    = iregsz(level)
       iend(1)   = -1
       iend(2)   = iregsz(level)-1
       iend(3)   = ihi
       ishift(1) = iregsz(level)
       ishift(2) = 0
       ishift(3) = -iregsz(level)
    else  ! if not periodic, set vals to only have nonnull intersection for interior regoin
       ist(1)    = iregsz(level)
       ist(2)    = ilo
       ist(3)    = iregsz(level)
       iend(1)   = -1
       iend(2)   = ihi
       iend(3)   = -1
       ishift(1) = 0
       ishift(2) = 0
       ishift(3) = 0
    endif

!   ## loop over the 3 regions (in 1D) of the patch - the interior is i=2 plus
!   ## the ghost cell regions.  If any parts stick out of domain and are periodic
!   ## map indices periodically, but stick the values in the correct place
!   ## in the orig grid (indicated by iputst.
!   ## if a region sticks out of domain  but is not periodic, not handled in (pre)-icall 
!   ## but in setaux/bcamr (not called from here).
    do 20 i = 1, 3
        i1 = max(ilo,  ist(i))
        i2 = min(ihi, iend(i))
        if (i1 .gt. i2) go to 20
            ! make temp patch of just the right size.
            mi = i2 - i1 + 1
            if (mi .gt. (ihi-ilo+1))  then
                write(*,*)" prefilp: not big enough dimension"
            endif
            if (naux .gt. 0)                                                         &
                call auxCopyIn(auxPatch,mi,auxbig,mitot,naux,i1,i2,iglo)

            call filrecur(level,nvar,valPatch,auxPatch,naux,time,mi,1,       &
                    i1+ishift(i),i2+ishift(i),.true.,msrc)

            ! copy it back to proper place in valbig
            call patchCopyOut(nvar,valPatch,mi,valbig,mitot,i1,i2,iglo)

 20 continue

contains

    integer pure function iadd(n,i)
        implicit none
        integer, intent(in) :: n, i
        iadd = locflip + n-1 + nvar*(i-1)
    end function iadd

    integer pure function iaddscratch(n,i)
        implicit none
        integer, intent(in) :: n, i
        iaddscratch = n + nvar*(i-1)  ! no subtract 1

    end function iaddscratch


end subroutine prefilrecur

! ============================================================================================

subroutine patchCopyOut(nvar,valpatch,mi,valbig,mitot,i1,i2,iglo)
 
    ! the patch was filled from a possibly periodically wrapped place.
    ! put it back where it should go in original grids solution array
          
    use amr_module
    implicit none

    ! Input
    integer :: mi, nvar, mitot, i1, i2, iglo, ighi

    ! Output
    real(kind=8), intent(in out) :: valbig(nvar,mitot)
    real(kind=8), intent(in out) :: valpatch(nvar,mi)

    ! Local storage
    integer :: ist


    ! this ghost cell patch subset goes from (i1) to (i2) in integer index space
    ! the grid (including ghost cells) is from (iglo) to (ighi)
    ! figure out where to copy
    ist = i1 - iglo + 1   ! offset 1 since soln array is 1-based

    valbig(:,ist:ist+mi-1) = valpatch

end subroutine patchCopyOut

! ============================================================================================

subroutine auxCopyIn(auxPatch,mi,auxbig,mitot,naux,i1,i2,iglo)

    ! set the aux array for the patch  to go with the soln vals to  be filled in filpatch,
    ! by copying from valbig's auxbig array

    use amr_module
    implicit none

    ! Input
    integer :: mi, naux, mitot, i1, i2, iglo, ighi

    ! Output
    real(kind=8), intent(in out) :: auxbig(naux,mitot)
    real(kind=8), intent(in out) :: auxPatch(naux,mi)

    ! Local storage
    integer :: ist


    ! this ghost cell patch subset goes from (i1,j1) to (i2,j2) in integer index space
    ! the grid (including ghost cells) is from (iglo,jglo) to (ighi,jghi)
    ! figure out where to copy
    ist = i1 - iglo + 1   ! offset 1 since aux arrays are 1-based

    auxPatch(:,1:mi) = auxbig(:,ist:ist+mi-1)

end subroutine auxCopyIn

module grid_module

    implicit none
    save

    integer :: mx, mbc, grid_type
    real(kind=8) :: xlower, xupper
    logical :: mapped_grid

    real(kind=8), allocatable, dimension(:) :: xcell, xc_edge, xp_edge

    integer :: mx_edge

    ! to keep track of max depth, speed, etc. over all time:
    real(kind=8), allocatable, dimension(:) ::  hmax, smax, hssmax, \
                                                arrival_time
    real(kind=8) :: fgmax_arrival_tol, fgmax_tstart
    integer, parameter :: iunit_fgmax = 70 ! open/close in claw1ez
    logical :: monitor_fgmax
    real(kind=8), parameter :: NOTSET = -0.99999d99

    ! to print out runup each step:
    integer, parameter :: iunit_runup = 71
    real(kind=8) :: runup_tolerance
    logical :: monitor_runup

    ! to print out total zeta mass each step:
    integer, parameter :: iunit_total_zeta_mass = 72
    logical :: monitor_total_zeta
    real(kind=8) :: total_zeta_mass_t0  ! store at initial time

contains

subroutine set_grid(mx,dx)

    use geoclaw_module, only: earth_radius, coordinate_system
    use geoclaw_module, only: dry_tolerance

    implicit none

    integer, intent(in) :: mx
    real(kind=8), intent(in) :: dx

    character(len=9) :: fname_grid
    character(len=150) :: fname_celledges
    integer, parameter :: iunit = 7
    integer :: i,j,mb
    real(kind=8) :: rim,rip,ric,c0i,cmi,cpi,r

    fname_grid = 'grid.data'
    call opendatafile(iunit,fname_grid)
    
    read(iunit,*) grid_type
        ! grid_type == 0: uniform grid
        ! grid_type == 1: mapc2p.f90 used for mapping
        ! grid_type == 2: celledges file gives x at edges

    if (grid_type == 2) then
        read(iunit,*) fname_celledges
    endif

    read(iunit,*) monitor_fgmax
    read(iunit,*) monitor_runup
    read(iunit,*) monitor_total_zeta
    close(unit=iunit)

    if (monitor_fgmax) then
        
        ! These are not set in setrun.py at the momemnt
        !fname_grid = 'fgmax.data'
        !call opendatafile(iunit,fname_grid)
        !read(iunit,*) fgmax_tstart
        !read(iunit,*) fgmax_arrival_tol
        !close(unit=iunit)

        ! values are hardwired, but could be changed in a setprob function:
        fgmax_tstart = -1e9  ! by default collect over entire simulation
        fgmax_arrival_tol = 0.01d0 ! by default, mark arrival if eta > 1 cm 

    endif


    if (grid_type == 0) then
        ! uniform grid with mx cells and mx+1 edges:
        if (dx /= (xupper - xlower) / mx) then
            write(6,*) '*** dx has unexpected value'
            stop
        endif

        mx_edge = mx+1
        allocate(xp_edge(1-mbc:mx_edge+mbc))
        allocate(xcell(1-mbc:mx+mbc))


        do i=1,mx_edge
            xp_edge(i) = xlower + (i-1)*dx
        enddo

    else if (grid_type == 1) then
        write(6,*) '*** grid_type == 1 not implemented yet'

    else if (grid_type == 2) then
    
        write(6,*) 'Reading cell edges from ',trim(fname_celledges)

        open(unit=iunit, file=trim(fname_celledges), status='old', &
             form='formatted')

        read(iunit,*) mx_edge

        if (mx_edge /= mx+1) then
            write(6,*) '*** expect mx_edge in grid.txt to equal mx+1'
            write(6,*) '*** mx_edge, mx:  ', mx_edge,mx
            stop
        endif 

    
        allocate(xc_edge(1-mbc:mx_edge+mbc))
        allocate(xp_edge(1-mbc:mx_edge+mbc))
        allocate(xcell(1-mbc:mx+mbc))
    
        write(6,*) 'Reading grid with mx = ',mx
        ! read in xc values and corresponding xp and z values
        do i=1,mx_edge
            read(iunit,*) xp_edge(i)
        enddo
    endif

    close(unit=iunit)

    if ((coordinate_system == -1) .and. (xp_edge(1) < 0.d0)) then
        write(6,*) 'coordinate_system == -1, radial requires x >= 0'
        stop
    endif


    ! extend to ghost cells, to have same width as first interior cell:

    do mb=1,mbc
        xp_edge(1-mb) = 2.d0*xp_edge(2-mb) - xp_edge(3-mb)
        xp_edge(mx_edge+mb) = 2.d0*xp_edge(mx_edge+mb-1) - xp_edge(mx_edge+mb-2)
    enddo


    do i=1-mbc,mx+mbc
        ! cell centers based on grid edges:
        xcell(i) = 0.5d0*(xp_edge(i) + xp_edge(i+1))
    enddo

    ! monitor_fgmax = has been added to setrun
    if (monitor_fgmax) then
        ! for keeping track of max depth, speed over all time:
        ! initialize here and update in b4step1
        allocate(hmax(mx), smax(mx), hssmax(mx), arrival_time(mx))
        hmax(:) = 0.d0
        smax(:) = 0.d0
        hssmax(:) = 0.d0
        arrival_time(:) = NOTSET   ! to flag no arrival yet
    endif

    ! monitor_total_zeta has been added to setrun
    total_zeta_mass_t0 = NOTSET   ! to indicate not yet set
    if (monitor_total_zeta) then
        ! to write total_zeta_mass every time step from b4step1:
        open(unit=iunit_total_zeta_mass, file='total_zeta_mass.txt', &
             status='unknown',form='formatted')
  600   format('t, total_zeta, change in total_zeta')
        !write(unit=iunit_total_zeta_mass,600) 
    endif
    
    ! monitor_runup has been added to setrun
    if (monitor_runup) then
        ! to write x,z from first/last wet cell 
        ! every time step from b4step1:
        open(unit=iunit_runup, file='runup.txt', &
             status='unknown',form='formatted')
        write(iunit_runup,*) '#  t,           x_first_wet,    ' &
                // 'eta_first_wet,  x_last_wet,   eta_last_wet'
        ! This is hardwired, but could be changed in a setprob function:
        runup_tolerance = 2.d0*dry_tolerance  ! when to view cell as wet
    endif
    
end subroutine set_grid

end module grid_module

subroutine step2(maxm,meqn,maux,mbc,mx,my, &
                 qold,aux,dx,dy,dt,cflgrid, &
                 fm,fp,gm,gp,rpn2,rpt2)
!     ==========================================================
!
!     # clawpack routine ...  modified for AMRCLAW
!
!     # Take one time step, updating q.
!     # On entry, qold gives
!     #    initial data for this step
!     #    and is unchanged in this version.
!
!     # fm, fp are fluxes to left and right of single cell edge
!     # See the flux2 documentation for more information.
!
!     # modified again for GeoClaw
!------------------step2_geo.f-----------------------
!     This version of step2 relimits the fluxes in order to
!     maintain positivity.
!     to do so set relimit=.true.
!     The only modification is the 101 loop
!------------last modified 12/30/04--------------------------
!

    use geoclaw_module, only: dry_tolerance
    use amr_module, only: mwaves, mcapa

    implicit none
    
    external rpn2, rpt2
    
    ! Arguments
    integer, intent(in) :: maxm,meqn,maux,mbc,mx,my
    real(kind=8), intent(in) :: dx,dy,dt
    real(kind=8), intent(inout) :: cflgrid
    real(kind=8), intent(inout) :: qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: fm(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: fp(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: gm(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: gp(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)

    ! Local storage for flux accumulation
    real(kind=8) :: faddm(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: faddp(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: gaddm(meqn,1-mbc:maxm+mbc,2)
    real(kind=8) :: gaddp(meqn,1-mbc:maxm+mbc,2)
    
    ! Scratch storage for Sweeps and Riemann problems
    real(kind=8) ::  q1d(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: aux1(maux,1-mbc:maxm+mbc)
    real(kind=8) :: aux2(maux,1-mbc:maxm+mbc)
    real(kind=8) :: aux3(maux,1-mbc:maxm+mbc)
    real(kind=8) :: dtdx1d(1-mbc:maxm+mbc)
    real(kind=8) :: dtdy1d(1-mbc:maxm+mbc)
    
 !   real(kind=8) ::  wave(meqn, mwaves, 1-mbc:maxm+mbc)
 !   real(kind=8) ::     s(mwaves, 1-mbc:maxm + mbc)
 !   real(kind=8) ::  amdq(meqn,1-mbc:maxm + mbc)
 !   real(kind=8) ::  apdq(meqn,1-mbc:maxm + mbc)
!     real(kind=8) ::  cqxx(meqn,1-mbc:maxm + mbc)
!     real(kind=8) :: bmadq(meqn,1-mbc:maxm + mbc)
!     real(kind=8) :: bpadq(meqn,1-mbc:maxm + mbc)
    
    ! Looping scalar storage
    integer :: i,j,m,thread_num
    real(kind=8) :: dtdx,dtdy,cfl1d,p,phi,cm,dtdxij,dtdyij
    
    ! Common block storage
    integer :: icom,jcom

    ! Parameters
    ! Relimit fluxes to maintain positivity
    logical, parameter :: relimit = .false.

    cflgrid = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy
    
    fm = 0.d0
    fp = 0.d0
    gm = 0.d0
    gp = 0.d0

    ! ==========================================================================
    ! Perform X-Sweeps
    do j = 0,my+1

        ! Copy old q into 1d slice
        q1d(:,1-mbc:mx+mbc) = qold(:,1-mbc:mx+mbc,j)
        
        ! Set dtdx slice if a capacity array exists
        if (mcapa > 0)  then
            dtdx1d(1-mbc:mx+mbc) = dtdx / aux(mcapa,1-mbc:mx+mbc,j)
        else
            dtdx1d = dtdx
        endif
        
        ! Copy aux array into slices
        if (maux > 0) then
            aux1(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j-1)
            aux2(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j  )
            aux3(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j+1)
        endif
        
        ! Store value of j along the slice into common block
        ! *** WARNING *** This may not working with threading
        jcom = j

        ! Compute modifications fadd and gadd to fluxes along this slice:
        call flux2(1,maxm,meqn,maux,mbc,mx,q1d,dtdx1d,aux1,aux2,aux3, &
                   faddm,faddp,gaddm,gaddp,cfl1d,rpn2,rpt2) 

        cflgrid = max(cflgrid,cfl1d)
        ! write(53,*) 'x-sweep: ',cfl1d,cflgrid

        ! Update fluxes
        fm(:,1:mx+1,j) = fm(:,1:mx+1,j) + faddm(:,1:mx+1)
        fp(:,1:mx+1,j) = fp(:,1:mx+1,j) + faddp(:,1:mx+1)
        gm(:,1:mx+1,j) = gm(:,1:mx+1,j) + gaddm(:,1:mx+1,1)
        gp(:,1:mx+1,j) = gp(:,1:mx+1,j) + gaddp(:,1:mx+1,1)
        gm(:,1:mx+1,j+1) = gm(:,1:mx+1,j+1) + gaddm(:,1:mx+1,2)
        gp(:,1:mx+1,j+1) = gp(:,1:mx+1,j+1) + gaddp(:,1:mx+1,2)

    enddo

    ! ============================================================================
    !  y-sweeps    
    !
    do i = 0, mx+1
        
        ! Copy data along a slice into 1d arrays:
        q1d(:,1-mbc:my+mbc) = qold(:,i,1-mbc:my+mbc)

        ! Set dt/dy ratio in slice
        if (mcapa > 0) then
            dtdy1d(1-mbc:my+mbc) = dtdy / aux(mcapa,i,1-mbc:my+mbc)
        else
            dtdy1d = dtdy
        endif

        ! Copy aux slices
        if (maux .gt. 0)  then
            aux1(:,1-mbc:my+mbc) = aux(:,i-1,1-mbc:my+mbc)
            aux2(:,1-mbc:my+mbc) = aux(:,i,1-mbc:my+mbc)
            aux3(:,1-mbc:my+mbc) = aux(:,i+1,1-mbc:my+mbc)
        endif
        
        ! Store the value of i along this slice in the common block
        ! *** WARNING *** This may not working with threading
        icom = i
        
        ! Compute modifications fadd and gadd to fluxes along this slice
        call flux2(2,maxm,meqn,maux,mbc,my,q1d,dtdy1d,aux1,aux2,aux3, &
                   faddm,faddp,gaddm,gaddp,cfl1d,rpn2,rpt2)

        cflgrid = max(cflgrid,cfl1d)
        ! write(53,*) 'y-sweep: ',cfl1d,cflgrid

        ! Update fluxes
        gm(:,i,1:my+1) = gm(:,i,1:my+1) + faddm(:,1:my+1)
        gp(:,i,1:my+1) = gp(:,i,1:my+1) + faddp(:,1:my+1)
        fm(:,i,1:my+1) = fm(:,i,1:my+1) + gaddm(:,1:my+1,1)
        fp(:,i,1:my+1) = fp(:,i,1:my+1) + gaddp(:,1:my+1,1)
        fm(:,i+1,1:my+1) = fm(:,i+1,1:my+1) + gaddm(:,1:my+1,2)
        fp(:,i+1,1:my+1) = fp(:,i+1,1:my+1) + gaddp(:,1:my+1,2)

    end do

    ! Relimit correction fluxes if they drive a cell negative
    if (relimit) then
        dtdxij = dtdx
        dtdyij = dtdy
        do i=1,mx
            do j=1,my
                if (mcapa > 0) then
                    dtdxij = dtdx / aux(mcapa,i,j)
                    dtdyij = dtdy / aux(mcapa,i,j)
                endif
                p = max(0.d0,dtdxij*fm(1,i+1,j)) + max(0.d0,dtdyij*gm(1,i,j+1)) &
                  - min(0.d0,dtdxij*fp(1,i,j)) - min(0.d0,dtdyij*gp(1,i,j))
                phi = min(1.d0,abs(qold(1,i,j) / (p+dry_tolerance)))

                if (phi < 1.d0) then
                    do m=1,meqn
                        if (fp(1,i,j) < 0.d0) then
                            cm = fp(m,i,j) - fm(m,i,j)
                            fm(m,i,j) = phi * fm(m,i,j)
                            fp(m,i,j) = fm(m,i,j) + cm
                        endif
                        if (gp(1,i,j) < 0.d0) then
                            cm = gp(m,i,j) - gm(m,i,j)
                            gm(m,i,j) = phi * gm(m,i,j)
                            gp(m,i,j) = gm(m,i,j) + cm
                        endif
                        if (fm(1,i+1,j) > 0.d0) then
                            cm = fp(m,i+1,j) - fm(m,i+1,j)
                            fp(m,i+1,j) = phi * fp(m,i+1,j)
                            fm(m,i+1,j) = fp(m,i+1,j) - cm
                        endif
                        if (gm(1,i,j+1) > 0.d0) then
                            cm = gp(m,i,j+1) - gm(m,i,j+1)
                            gp(m,i,j+1) = phi * gp(m,i,j+1)
                            gm(m,i,j+1) = gp(m,i,j+1) - cm
                        endif
                    end do
                endif
            enddo
        enddo
    endif

end subroutine step2

c     ==================
      subroutine setprob
c     ==================

      implicit double precision (a-h,o-z)
      character*12 fname
      common /cparam/ coeff(3)
c
c     # for 3d Burgers' equation
c     #    q_t  +  u*(.5*q^2)_x + v*(.5*q^2)_y + w*(.5*q^2)_z = 0
c     # where u,v,w are a given scalars, stored in the vector coeff

      iunit = 7
      fname = 'setprob.data'
c     # open the unit with new routine from Clawpack 4.4 to skip over
c     # comment lines starting with #:
      call opendatafile(iunit, fname)

      read(7,*) coeff(1)
      read(7,*) coeff(2)
      read(7,*) coeff(3)

      return
      end

c
c ---------------------------------------------------
c
       subroutine coarsen(valdub,midub,valbgc,mi2tot,nvar)
      
       implicit double precision (a-h, o-z)

       dimension  valdub(nvar,midub)
       dimension  valbgc(nvar,mi2tot)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
c coarsen = coarsen the fine grid data (with double the usual
c           number of ghost cells to prepare coarsened
c           grid for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
          do 10 i = 1, mi2tot
            ifine = 2*(i-1) + 1

            do 10 ivar = 1, nvar
  
             valbgc(ivar,i) = (valdub(ivar,ifine) +
     &                           valdub(ivar,ifine+1))/2.d0
10     continue

       return
       end

! ==============================================================================
!  Point-wise version of a simple scalar advection problem
! ==============================================================================

subroutine rp1_ptwise(num_eqn, num_aux, num_waves, q_l, q_r, aux_l, aux_r,    &
                      wave, s, amdq, apdq)

    implicit none

    ! Input Arguments
    integer, intent(in) :: num_eqn, num_aux, num_waves
    real(kind=8), intent(in out) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in out) :: aux_l(num_aux), aux_r(num_aux)

    ! Output arguments
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Common block
    real(kind=8) :: u

    common /cparam/ u

    s = u
    wave(1, 1) = q_r(1) - q_l(1)

    amdq = min(u, 0.0) * wave(1, 1)
    apdq = max(u, 0.0) * wave(1, 1)

end subroutine rp1_ptwise

!> Fill grid **mptr** on level **level** by copying values from OLD level **level**
!! grids if available, otherwise by interpolating values from coarser grids.
subroutine filval(val, mitot, mjtot, dx, dy, level, time,  mic,          &
                  mjc, xleft, xright, ybot, ytop, nvar, mptr, ilo, ihi,  &
                  jlo, jhi, aux, naux)

    use amr_module, only: xlower, ylower, intratx, intraty, nghost, xperdom
    use amr_module, only: yperdom, spheredom, xupper, yupper, alloc
    use amr_module, only: outunit, NEEDS_TO_BE_SET, mcapa
    use amr_module, only: newstl, iregsz, jregsz
    
    implicit none

    ! Input
    integer, intent(in) :: mitot, mjtot, level, mic, mjc, nvar, mptr, ilo, ihi
    integer, intent(in) :: jlo, jhi, naux
    real(kind=8), intent(in) :: dx, dy, time, xleft, xright, ybot, ytop

    ! Output
    real(kind=8), intent(in out) :: val(nvar,mitot,mjtot), aux(naux,mitot,mjtot)

    ! Local storage
    integer :: refinement_ratio_x, refinement_ratio_y, iclo, jclo, ichi, jchi, ng
    integer :: ivar, i, j, ico, jco, ifine, jfine, nx, ny
    real(kind=8) :: valc(nvar,mic,mjc), auxc(naux,mic,mjc)
    real(kind=8) :: dx_coarse, dy_coarse, xl, xr, yb, yt, area
    real(kind=8) :: s1m, s1p, slopex, slopey, xoff, yoff
    real(kind=8) :: fliparray((mitot+mjtot)*nghost*(nvar+naux))
    real(kind=8) :: setflags(mitot,mjtot),maxauxdif,aux2(naux,mitot,mjtot)
    integer :: mjb
    integer :: jm, im, nm 
    logical :: sticksoutxfine, sticksoutyfine,sticksoutxcrse,sticksoutycrse
    
    !for setaux timing
    integer(kind=8) :: clock_start, clock_finish, clock_rate
    real(kind=8) :: cpu_start, cpu_finish


    ! External function definitions
    real(kind=8) :: get_max_speed


    refinement_ratio_x = intratx(level-1)
    refinement_ratio_y = intraty(level-1)
    dx_coarse  = dx * refinement_ratio_x
    dy_coarse  = dy * refinement_ratio_y
    xl      = xleft  - dx_coarse
    xr      = xright + dx_coarse
    yb      = ybot   - dy_coarse
    yt      = ytop   + dy_coarse

    ! if topo not yet final then aux is set outside filval (in gfixup)
    ! and so aux has real data already, (ie dont overwrite here)

    ! set integer indices for coarser patch enlarged by 1 cell
    ! (can stick out of domain). proper nesting will insure this one
    ! call is sufficient.
    iclo   = ilo / refinement_ratio_x - 1
    jclo   = jlo / refinement_ratio_y - 1
    ichi   = (ihi + 1) / refinement_ratio_x - 1 + 1
    jchi   = (jhi + 1) / refinement_ratio_y - 1 + 1
    ng     = 0

    sticksoutxfine = ( (ilo .lt. 0) .or. (ihi .ge. iregsz(level)))
    sticksoutyfine = ( (jlo .lt. 0) .or. (jhi .ge. jregsz(level)))
    sticksoutxcrse = ((iclo .lt. 0) .or. (ichi .ge. iregsz(level-1)))
    sticksoutycrse = ((jclo .lt. 0) .or. (jchi .ge. jregsz(level-1)))

    if (naux == 0) then
        if ((xperdom .and. sticksoutxcrse).or. (yperdom.and.sticksoutycrse)  .or. spheredom) then
            call preintcopy(valc,mic,mjc,nvar,iclo,ichi,jclo,jchi,level-1,fliparray)
        else
            call intcopy(valc,mic,mjc,nvar,iclo,ichi,jclo,jchi,level-1,1,1)
        endif
    else  
        ! intersect grids and copy all (soln and aux)
        auxc(1,:,:) = NEEDS_TO_BE_SET
        if ((xperdom .and.sticksoutxcrse) .or. (yperdom.and.sticksoutycrse) .or. spheredom) then
            call preicall(valc,auxc,mic,mjc,nvar,naux,iclo,ichi,jclo,jchi, &
                          level-1,fliparray)
        else
            call icall(valc,auxc,mic,mjc,nvar,naux,iclo,ichi,jclo,jchi,level-1,1,1)
        endif
!!$        do i = 1, mic
!!$        do j = 1, mjc
!!$          if (auxc(1,:,:) == NEEDS_TO_BE_SET) then
!!$             write(*,*)" *** coarsenened new fine grid not completely set from previously"  &
!!$                       "existing coarse grids ***"
!!$             stop
!!$          endif
!!$        end do
!!$        end do
           ! no ghost cells on coarse enlarged patch. set any remaining
           ! vals. should only be bcs that stick out of domain.
           call setaux(ng,mic,mjc,xl,yb,dx_coarse,dy_coarse,naux,auxc)
    endif

    call bc2amr(valc,auxc,mic,mjc,nvar,naux,dx_coarse,dy_coarse,level-1,time,xl,xr,yb, &
                yt,xlower,ylower,xupper,yupper,xperdom,yperdom,spheredom)



!  NOTE change in order of code.  Since the interp from coarse to fine needs the aux
!       arrays set already, the fine copy is done first, to set up the aux arrays.
!       we can do this since we have the flag array to test where to overwrite.

!  SO this is no longer overwriting but setting for the first time.
! overwrite interpolated values with fine grid values, if available.
    nx = mitot - 2*nghost
    ny = mjtot - 2*nghost

    if (naux .gt. 0) then 
!       ## NEEDS_TO_BE_SET is signal that aux array not set.
!       ## after calling icall to copy aux from other grids
!       ## any remaining NEEDS_TO_BE_SET signals will be set in setaux.
!       ## it also signals where soln was copied, so it wont be
!       ## overwritten with coarse grid interpolation
        aux(1,:,:) = NEEDS_TO_BE_SET  ! indicates fine cells not yet set. 

        if ((xperdom.and.sticksoutxfine) .or. (yperdom.and.sticksoutyfine) .or. spheredom) then
            call preicall(val,aux,mitot,mjtot,nvar,naux,ilo-nghost,ihi+nghost, & 
                          jlo-nghost,jhi+nghost,level,fliparray)
        else
            call icall(val,aux,mitot,mjtot,nvar,naux,ilo-nghost,ihi+nghost,  &
                      jlo-nghost,jhi+nghost,level,1,1)   
        endif
        setflags = aux(1,:,:)   ! save since will overwrite in setaux when setting all aux vals
           ! need this so we know where to use coarse grid to set fine solution w/o overwriting
           ! set remaining aux vals not set by copying from prev existing grids
        call setaux(nghost,nx,ny,xleft,ybot,dx,dy,naux,aux)
    else ! either no aux exists, or cant reuse yet  
         ! so only call intcopy (which copies soln) and not icall.
         ! in this case flag q(1,:) to NEEDS_TO_BE_SET flag so wont be overwritten
         ! by coarse grid interp.  this is needed due to reversing order of
         ! work - first copy from fine grids, then interpolate from coarse grids
        val(1,:,:) = NEEDS_TO_BE_SET
        if ((xperdom.and.sticksoutxfine) .or. (yperdom.and.sticksoutyfine) .or. spheredom) then
            call preintcopy(val,mitot,mjtot,nvar,ilo-nghost,ihi+nghost,     &
                            jlo-nghost,jhi+nghost,level,fliparray)
        else
            call intcopy(val,mitot,mjtot,nvar,ilo-nghost,ihi+nghost,  &
                         jlo-nghost,jhi+nghost,level,1,1)   
        endif
        setflags = val(1,:,:)  ! remaining flags signals need to set
    endif

   
    ! Prepare slopes - use min-mod limiters

    do j=2, mjc-1
     do i=2, mic-1
       do ivar = 1, nvar
 
            s1p = valc(ivar,i+1,j) - valc(ivar,i,j)
            s1m = valc(ivar,i,j)   - valc(ivar,i-1,j)
            slopex = min(abs(s1p), abs(s1m)) &
                         * sign(1.d0,valc(ivar,i+1,j) - valc(ivar,i-1,j))
            ! if there's a sign change, set slope to 0.
            if ( s1m*s1p <=  0.d0) slopex = 0.d0

            s1p = valc(ivar,i,j+1) - valc(ivar,i,j)
            s1m = valc(ivar,i,j)   - valc(ivar,i,j-1)
            slopey = min(abs(s1p), abs(s1m))  &
                         * sign(1.0d0, valc(ivar,i,j+1) - valc(ivar,i,j-1))
            if ( s1m*s1p <= 0.d0)  slopey = 0.d0

            ! Interpolate from coarse cells to fine grid to find depth
             do jco = 1,refinement_ratio_y
               yoff = (real(jco,kind=8) - 0.5d0) / refinement_ratio_y - 0.5d0
               jfine = (j-2) * refinement_ratio_y + nghost + jco

               do ico = 1,refinement_ratio_x
                 xoff = (real(ico,kind=8) - 0.5d0) / refinement_ratio_x - 0.5d0
                 ifine = (i-2) * refinement_ratio_x + nghost + ico

                 if (setflags(ifine,jfine) .eq. NEEDS_TO_BE_SET) then
                    val(ivar,ifine,jfine) = valc(ivar,i,j) + xoff*slopex + yoff*slopey
                 endif

               end do
            end do

       enddo !end of ivar loop
     enddo !end of coarse i loop
    enddo !end of coarse j loop

    ! adjust to conserve kappa*q, but only where coarse grid was interpolated
    ! so now need to pass setflags to this subr.
    if (mcapa .ne. 0) then  
        call fixcapaq(val,aux,mitot,mjtot,valc,auxc,mic,mjc,nvar,naux,level-1,setflags)
    endif
 
!!$! CHECK BY CALLING SETAUX AND SETTING ALL, THEN DIFFING
!!$   mjb = 0
!!$   if (naux .gt. 0  .and. mjb .eq. 1) then
!!$      aux2(1,:,:) = NEEDS_TO_BE_SET   ! indicates fine cells not yet set
!!$      call setaux(nghost,nx,ny,xleft,ybot,dx,dy,naux,aux2)
!!$      maxauxdif = 1.d-13
!!$      do i = 1, mitot
!!$      do j = 1, mjtot
!!$         if (abs(aux(1,i,j)-aux2(1,i,j)) .gt. maxauxdif) then
!!$            maxauxdif = abs(aux(1,i,j)-aux2(1,i,j))
!!$            write(*,444)i,j,aux(1,i,j),aux2(1,i,j),maxauxdif
!!$444         format("i,j = ",2i4," auxs ",2e15.7," maxauxdif ",e12.5)
!!$         endif
!!$      end do
!!$      end do
!!$      if (maxauxdif .gt. 2.d-13) then
!!$         write(*,*)" maxauxdif = ",maxauxdif," with mitot,mjtot ",mitot,mjtot, &
!!$              " on grid ",mptr," level ",level
!!$      endif
!!$   endif

end subroutine filval

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

subroutine dumpaux(aux,naux,mitot,mjtot)
   implicit none
   real(kind=8) :: aux(naux,mitot,mjtot)
   integer :: naux,mitot,mjtot,i,j,iaux

   do j = 1, mjtot 
   do i = 1, mitot 
      write(*,444) i,j,(aux(iaux,i,j),iaux=1,naux)
 444  format(2i4,5e12.5)
   end do
   end do

end subroutine dumpaux

c
c --------------------------------------------------------------
c
      subroutine preicall(val,aux,nrow,ncol,nfil,nvar,naux,
     1                    ilo,ihi,jlo,jhi,klo,khi,level)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension val(nvar,nrow,ncol,nfil)
      dimension aux(naux,nrow,ncol,nfil)

      dimension ist(3), iend(3), ishift(3)
      dimension jst(3), jend(3), jshift(3)
      dimension kst(3), kend(3), kshift(3)

c
c  :::::::::::::: PREICALL :::::::::::::::::::::::::::::::::::::::::::
c     For periodic boundary conditions more work needed to initialize a
c     new grid that sticks out. This routine was
c     called because the patch sticks out of the domain,
c     and has periodic bc.s preprocess the patch before calling
c     icall to shift the patch periodically back into the domain.
c
c     Inputs to this routine:
c     ilo,ihi,jlo,jhi,klo,khi = the location in index space of this patch.
c
c     Outputs from this routine:
c     The values of the grid are inserted
c     directly into the enlarged val array for this piece.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

c
c     # will divide patch into 9 possibilities (some empty): 
c       x sticks out left, x interior, x sticks out right
c       same for y. for example, the max. would be
c       i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)
        
      if (xperdom) then
         ist(1)  = ilo
         ist(2)  = 0
         ist(3)  = iregsz(level)
         iend(1) = -1
         iend(2) = iregsz(level)-1
         iend(3) = ihi
         ishift(1) = iregsz(level)
         ishift(2) = 0
         ishift(3) = -iregsz(level)
      else
         ist(1)    = iregsz(level)
         ist(2)    = ilo
         ist(3)    = iregsz(level)
         iend(1)   = -1
         iend(2)   = ihi
         iend(3)   = -1
         ishift(1) = 0
         ishift(2) = 0
         ishift(3) = 0
      endif

      if (yperdom) then
         jst(1)  = jlo
         jst(2)  = 0
         jst(3)  = jregsz(level)
         jend(1) = -1
         jend(2) = jregsz(level)-1
         jend(3) = jhi
         jshift(1) = jregsz(level)
         jshift(2) = 0
         jshift(3) = -jregsz(level)
      else
         jst(1)    = jregsz(level)
         jst(2)    = jlo
         jst(3)    = jregsz(level)
         jend(1)   = -1
         jend(2)   = jhi
         jend(3)   = -1
         jshift(1) = 0
         jshift(2) = 0
         jshift(3) = 0
      endif

      if (zperdom) then
         kst(1)  = klo
         kst(2)  = 0
         kst(3)  = kregsz(level)
         kend(1) = -1
         kend(2) = kregsz(level)-1
         kend(3) = khi
         kshift(1) = kregsz(level)
         kshift(2) = 0
         kshift(3) = -kregsz(level)
      else
         kst(1)    = kregsz(level)
         kst(2)    = klo
         kst(3)    = kregsz(level)
         kend(1)   = -1
         kend(2)   = khi
         kend(3)   = -1
         kshift(1) = 0
         kshift(2) = 0
         kshift(3) = 0
      endif

       do 30 i = 1, 3
          i1 = max(ilo,  ist(i))
          i2 = min(ihi, iend(i))
          if (i1 .gt. i2) go to 30

       do 20 j = 1, 3
          j1 = max(jlo,  jst(j))
          j2 = min(jhi, jend(j))
          if (j1 .gt. j2) go to 20

       do 10 k = 1, 3
          k1 = max(klo,  kst(k))
          k2 = min(khi, kend(k))


          if (k1 .le. k2) then
            iputst = i1 - ilo + 1
            jputst = j1 - jlo + 1
            kputst = k1 - klo + 1
            call icall(val,aux,nrow,ncol,nfil,nvar,naux,
     1                    i1+ishift(i),i2+ishift(i),
     2                    j1+jshift(j),j2+jshift(j),
     3                    k1+kshift(k),k2+kshift(k),level,
     4                    iputst,jputst,kputst)
          endif

 10    continue
 20    continue
 30    continue
      
     


      return
      end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
    implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for the shallow water
!     # equations  on a quadrilateral grid.

!     # Split asdq (= A^* \Delta q, where * = + or -)
!     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
!     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)

    dimension     ql(meqn, 1-mbc:maxm+mbc)
    dimension     qr(meqn, 1-mbc:maxm+mbc)
    dimension   asdq(meqn, 1-mbc:maxm+mbc)
    dimension bmasdq(meqn, 1-mbc:maxm+mbc)
    dimension bpasdq(meqn, 1-mbc:maxm+mbc)
    dimension   aux1(maux, 1-mbc:maxm+mbc)
    dimension   aux2(maux, 1-mbc:maxm+mbc)
    dimension   aux3(maux, 1-mbc:maxm+mbc)

!      parameter (maxm2 = 1002)  !# assumes at most 1000x1000 grid with mbc=2
    dimension u(1-mbc:maxm+mbc),v(1-mbc:maxm+mbc),a(1-mbc:maxm+mbc), &
    h(1-mbc:maxm+mbc)
    dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(3, 1-mbc:maxm+mbc)
    dimension enx(1-mbc:maxm+mbc), eny(1-mbc:maxm+mbc), &
    enz(1-mbc:maxm+mbc)
    dimension etx(1-mbc:maxm+mbc), ety(1-mbc:maxm+mbc), &
    etz(1-mbc:maxm+mbc)
    dimension gamma(1-mbc:maxm+mbc)
         
    dimension delta(4)
    common /sw/  g
    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom


!      if (-1.gt.1-mbc .or. maxm2 .lt. maxm+mbc) then
!	 write(6,*) 'need to increase maxm2 in rpB'
!	 stop
!      endif

    if(ixy == 1) then
        dx = dxcom
    else
        dx = dycom
    endif


    if(ixy == 1) then
        ioff = 7
    else
        ioff = 1
    endif


!        # imp is used to flag whether wave is going to left or right,
!        # since states and grid are different on each side

    if (imp == 1) then
    !            # asdq = amdq, moving to left
        ix1 = 2-mbc
        ixm1 = mx+mbc
    else
    !            # asdq = apdq, moving to right
        ix1 = 1-mbc
        ixm1 = mx+mbc
    endif

!        --------------
!        # up-going:
!        --------------


!       # determine rotation matrix for interface above cell, using aux3
!               [ alf  beta ]
!               [-beta  alf ]

    do i=ix1,ixm1
    
        if (imp == 1) then
            i1 = i-1
        else
            i1 = i
        endif
    
        enx(i) =   aux3(ioff+1,i1)
        eny(i) =   aux3(ioff+2,i1)
        enz(i) =   aux3(ioff+3,i1)
        etx(i) =   aux3(ioff+4,i1)
        ety(i) =   aux3(ioff+5,i1)
        etz(i) =   aux3(ioff+6,i1)
        gamma(i) = dsqrt(etx(i)**2 + ety(i)**2 + etz(i)**2)
        etx(i) =   etx(i) / gamma(i)
        ety(i) =   ety(i) / gamma(i)
        etz(i) =   etz(i) / gamma(i)

        h(i) = ql(1,i1)
        u(i) = (enx(i)*ql(2,i1)+eny(i)*ql(3,i1)+enz(i)*ql(4,i1)) &
        / h(i)
        v(i) = (etx(i)*ql(2,i1)+ety(i)*ql(3,i1)+etz(i)*ql(4,i1)) &
        / h(i)
        a(i) = dsqrt(g*h(i))
    enddo



!     # now split asdq into waves:

!     # find a1 thru a3, the coefficients of the 3 eigenvectors:
    do 20 i = ix1,ixm1
        delta(1) = asdq(1,i)
        delta(2) = enx(i)*asdq(2,i)+eny(i)*asdq(3,i)+enz(i)*asdq(4,i)
        delta(3) = etx(i)*asdq(2,i)+ety(i)*asdq(3,i)+etz(i)*asdq(4,i)
        a1 = ((u(i)+a(i))*delta(1) - delta(2))*(0.50d0/a(i))
        a2 = -v(i)*delta(1) + delta(3)
        a3 = (-(u(i)-a(i))*delta(1) + delta(2))*(0.50d0/a(i))
    
    !        # Compute the waves.
    
        wave(1,1,i) = a1
        wave(2,1,i) = enx(i)*a1*(u(i)-a(i)) + etx(i)*a1*v(i)
        wave(3,1,i) = eny(i)*a1*(u(i)-a(i)) + ety(i)*a1*v(i)
        wave(4,1,i) = enz(i)*a1*(u(i)-a(i)) + etz(i)*a1*v(i)
        s(1,i) = (u(i)-a(i))*gamma(i)/dx
    
        wave(1,2,i) = 0.0d0
        wave(2,2,i) = etx(i)*a2
        wave(3,2,i) = ety(i)*a2
        wave(4,2,i) = etz(i)*a2
        s(2,i) = u(i) * gamma(i)/dx
    
        wave(1,3,i) = a3
        wave(2,3,i) = enx(i)*a3*(u(i)+a(i)) + etx(i)*a3*v(i)
        wave(3,3,i) = eny(i)*a3*(u(i)+a(i)) + ety(i)*a3*v(i)
        wave(4,3,i) = enz(i)*a3*(u(i)+a(i)) + etz(i)*a3*v(i)
        s(3,i) = (u(i)+a(i)) * gamma(i)/dx
    20 END DO


!    # compute flux difference bpasdq
!    --------------------------------

    do m=1,meqn
        do i=ix1,ixm1
            bpasdq(m,i) = 0.d0
            do mw=1,mwaves
                bpasdq(m,i) = bpasdq(m,i) &
                + dmax1(s(mw,i),0.d0)*wave(m,mw,i)
            end do
        end do
    end do

!     # project momentum component of bpasdq to tangent plane:
    do i=ix1, ixm1
        if (imp == 1) then
            i1 = i-1
        else
            i1 = i
        endif
        erx = aux3(14,i1)
        ery = aux3(15,i1)
        erz = aux3(16,i1)
        bn = erx*bpasdq(2,i)+ery*bpasdq(3,i)+erz*bpasdq(4,i)
        bpasdq(2,i) = bpasdq(2,i) - bn*erx
        bpasdq(3,i) = bpasdq(3,i) - bn*ery
        bpasdq(4,i) = bpasdq(4,i) - bn*erz

    enddo
     


!        --------------
!        # down-going:
!        --------------


!       # determine rotation matrix for interface below cell, using aux2
!               [ alf  beta ]
!               [-beta  alf ]

    do i=ix1,ixm1
    
        if (imp == 1) then
            i1 = i-1
        else
            i1 = i
        endif
    
        enx(i) =   aux2(ioff+1,i1)
        eny(i) =   aux2(ioff+2,i1)
        enz(i) =   aux2(ioff+3,i1)
        etx(i) =   aux2(ioff+4,i1)
        ety(i) =   aux2(ioff+5,i1)
        etz(i) =   aux2(ioff+6,i1)
        gamma(i) = dsqrt(etx(i)**2 + ety(i)**2 + etz(i)**2)
        etx(i) =   etx(i) / gamma(i)
        ety(i) =   ety(i) / gamma(i)
        etz(i) =   etz(i) / gamma(i)
        u(i) = (enx(i)*ql(2,i1)+eny(i)*ql(3,i1)+enz(i)*ql(4,i1)) &
        / h(i)
        v(i) = (etx(i)*ql(2,i1)+ety(i)*ql(3,i1)+etz(i)*ql(4,i1)) &
        / h(i)
    enddo



!     # now split asdq into waves:

!     # find a1 thru a3, the coefficients of the 3 eigenvectors:
    do 80 i = ix1,ixm1
        delta(1) = asdq(1,i)
        delta(2) = enx(i)*asdq(2,i)+eny(i)*asdq(3,i)+enz(i)*asdq(4,i)
        delta(3) = etx(i)*asdq(2,i)+ety(i)*asdq(3,i)+etz(i)*asdq(4,i)

        a1 = ((u(i)+a(i))*delta(1) - delta(2))*(0.50d0/a(i))
        a2 = -v(i)*delta(1) + delta(3)
        a3 = (-(u(i)-a(i))*delta(1) + delta(2))*(0.50d0/a(i))
    
    !        # Compute the waves.
    
        wave(1,1,i) = a1
        wave(2,1,i) = enx(i)*a1*(u(i)-a(i)) + etx(i)*a1*v(i)
        wave(3,1,i) = eny(i)*a1*(u(i)-a(i)) + ety(i)*a1*v(i)
        wave(4,1,i) = enz(i)*a1*(u(i)-a(i)) + etz(i)*a1*v(i)
        s(1,i) = (u(i)-a(i)) * gamma(i)/dx
    
        wave(1,2,i) = 0.0d0
        wave(2,2,i) = etx(i)*a2
        wave(3,2,i) = ety(i)*a2
        wave(4,2,i) = etz(i)*a2
        s(2,i) = u(i) * gamma(i)/dx
    
        wave(1,3,i) = a3
        wave(2,3,i) = enx(i)*a3*(u(i)+a(i)) + etx(i)*a3*v(i)
        wave(3,3,i) = eny(i)*a3*(u(i)+a(i)) + ety(i)*a3*v(i)
        wave(4,3,i) = enz(i)*a3*(u(i)+a(i)) + etz(i)*a3*v(i)
        s(3,i) = (u(i)+a(i)) * gamma(i)/dx
    80 END DO


!    # compute flux difference bmasdq
!    --------------------------------

    do m=1,meqn
        do i=ix1,ixm1
            bmasdq(m,i) = 0.d0
            do mw=1,mwaves
                bmasdq(m,i) = bmasdq(m,i) &
                + dmin1(s(mw,i), 0.d0)*wave(m,mw,i)
            end do
        end do
    end do
!     # project momentum component of bmasdq to tangent plane:
    do i=ix1, ixm1
        if (imp == 1) then
            i1 = i-1
        else
            i1 = i
        endif
        erx = aux1(14,i1)
        ery = aux1(15,i1)
        erz = aux1(16,i1)
        bn = erx*bmasdq(2,i)+ery*bmasdq(3,i)+erz*bmasdq(4,i)
        bmasdq(2,i) = bmasdq(2,i) - bn*erx
        bmasdq(3,i) = bmasdq(3,i) - bn*ery
        bmasdq(4,i) = bmasdq(4,i) - bn*erz

    enddo


        
    return
    end subroutine rpt2

c
c  -------------------------------------------------------------
c
      subroutine tick(nvar,cut,nstart,vtime,time,naux,start_time,
     &                rest,dt_max)
c
      use amr_module
      use gauges_module, only: setbestsrc, num_gauges
      use gauges_module, only: print_gauges_and_reset_nextLoc 

      implicit double precision (a-h,o-z)
c     include  "call.i"

      logical    vtime, dumpout/.false./, dumpchk/.false./
      logical    rest, dump_final, stopFound
      dimension dtnew(maxlv), ntogo(maxlv), tlevel(maxlv)
      integer(kind=8) ::   clock_start, clock_finish, clock_rate
      integer(kind=8) ::   tick_clock_finish, tick_clock_rate  
      real(kind=8) :: cpu_start,cpu_finish

c
c :::::::::::::::::::::::::::: TICK :::::::::::::::::::::::::::::
!> main driver routine.  controls:
!!       integration  of all grids.
!!       error estimation / regridding
!!       output counting
!!       updating of fine to coarse grids

c  parameters:
c     nstop   = # of coarse grid time steps to be taken
c     iout    = output interval every 'iout' coarse time steps
c               (if 0, not used - set to inf.)
c     vtime   = true for variable timestep, calculated each coarse step
c
c  integration strategy is to advance a fine grid until it catches
c  up to the coarse grid. this strategy is applied recursively.
c  coarse grid goes first.
c
c  nsteps: used to count how number steps left for a level to be
c          integrated before it catches up with the next coarser level.
c  ncycle: counts number of coarse grid steps = # cycles.
c
c  icheck: counts the number of steps (incrementing by 1
c          each step) to keep track of when that level should
c          have its error estimated and finer levels should be regridded.
c ::::::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::
c


      ncycle         = nstart
      call setbestsrc()     ! need at very start of run, including restart
      if (iout .eq. 0) then
c        # output_style 1 or 2
         iout  = iinfinity
         nextout = 0
         if (nout .gt. 0) then
            nextout = 1
            if (nstart .gt. 0) then
c              # restart: make sure output times start after restart time
               do ii = 1, nout
                 if (tout(ii) .gt. time) then
                   nextout = ii
                   go to 2
                 endif
               end do
  2         continue
            endif
         endif
      endif

      nextchk = 1
      if ((nstart .gt. 0) .and. (abs(checkpt_style).eq.2)) then
c        if this is a restart, make sure chkpt times start after restart time
         do ii = 1, nchkpt
           if (tchk(ii) .gt. time) then
              nextchk = ii
              go to 3
              endif
           enddo
  3      continue
         endif

      tlevel(1)      = time

      do 5 i       = 2, mxnest
       tlevel(i) = tlevel(1)
 5     continue
c
c  ------ start of coarse grid integration loop. ------------------
c
 20   if (ncycle .ge. nstop .or. time .ge. tfinal) goto 999

      if (nout .gt. 0) then
          if (nextout  .le. nout) then
             outtime       = tout(nextout)
          else
             outtime       = rinfinity
          endif
      else
          outtime = tfinal
      endif

      if (nextchk  .le. nchkpt) then
         chktime       = tchk(nextchk)
      else
         chktime       = rinfinity
      endif

      dumpout = .false.  !# may be reset below

      if (time.lt.outtime .and. time+1.001*possk(1) .ge. outtime) then
c        ## adjust time step  to hit outtime exactly, and make output
c        #  apr 2010 mjb: modified so allow slightly larger timestep to
c        #  hit output time exactly, instead of taking minuscule timestep
c        #  should still be stable since increase dt in only 3rd digit.
         oldposs = possk(1)
         possk(1) = outtime - time
c        write(*,*)" old possk is ", possk(1)
         diffdt = oldposs - possk(1)  ! if positive new step is smaller


         if (.false.) then  
            write(*,122) diffdt,outtime  ! notify of change
 122        format(" Adjusting timestep by ",e10.3,
     .             " to hit output time of ",e13.6)
c           write(*,*)" new possk is ", possk(1)
            if (diffdt .lt. 0.) then ! new step is slightly larger
              pctIncrease = -100.*diffdt/oldposs   ! minus sign to make whole expr. positive
              write(*,123) pctIncrease
 123          format(" New step is ",f8.2," % larger.",
     .               "  Should still be stable")
              endif
            endif


         do i = 2, mxnest
            possk(i) = possk(i-1) / kratio(i-1)
            enddo
         if (nout .gt. 0) then
            nextout = nextout + 1
            dumpout = .true.
            endif
      endif


      if (time.lt.chktime .and. time + possk(1) .ge. chktime) then
c        ## adjust time step  to hit chktime exactly, and do checkpointing
         possk(1) = chktime - time
         do 13 i = 2, mxnest
            possk(i) = possk(i-1) / kratio(i-1)
 13      continue
         nextchk = nextchk + 1
        dumpchk = .true.
      else
        dumpchk = .false.
      endif

c
      level        = 1
      ntogo(level) = 1
      do i = 1, maxlv
         dtnew(i)  = rinfinity
      enddo
c
c     ------------- regridding  time?  ---------
c
c check if either
c   (i)  this level should have its error estimated before being advanced
c   (ii) this level needs to provide boundary values for either of
c        next 2 finer levels to have their error estimated.
c        this only affects two grid levels higher, occurs because
c        previous time step needs boundary vals for giant step.
c  no error estimation on finest possible grid level
c
 60       continue
          if (icheck(level) .ge. kcheck) then
               lbase = level
          else if (level+1 .ge. mxnest) then
               go to 90
          else if (icheck(level+1) .ge. kcheck) then
               lbase = level+1
          else if (level+2 .ge. mxnest) then
               go to 90
          else if (icheck(level+2) .ge. kcheck) then
               lbase = level+2
          else
               go to 90
          endif
          if (lbase .eq. mxnest .or. lbase .gt. lfine) go to 70
c
c regrid level 'lbase+1' up to finest level.
c level 'lbase' stays fixed.
c
          if (rprint) write(outunit,101) lbase
101       format(8h  level ,i5,32h  stays fixed during regridding )

          call system_clock(clock_start,clock_rate)
          call cpu_time(cpu_start)
          call regrid(nvar,lbase,cut,naux,start_time)
          call system_clock(clock_finish,clock_rate)
          call cpu_time(cpu_finish)
          timeRegridding = timeRegridding + clock_finish - clock_start
          timeRegriddingCPU=timeRegriddingCPU+cpu_finish-cpu_start

          call setbestsrc()     ! need at every grid change
c         call outtre(lstart(lbase+1),.false.,nvar,naux)
c note negative time to signal regridding output in plots
c         call valout(lbase,lfine,-tlevel(lbase),nvar,naux)
c
c  maybe finest level in existence has changed. reset counters.
c
          if (rprint .and. lbase .lt. lfine) then
             call outtre(lstart(lbase+1),.false.,nvar,naux)
          endif
 70       continue
          do 80  i  = lbase, lfine
             icheck(i) = 0
 80       continue
          do 81  i  = lbase+1, lfine
             tlevel(i) = tlevel(lbase)
 81       continue
c
c          MJB: modified to check level where new grids start, which is lbase+1
          !if (verbosity_regrid.ge.lbase+1) then
          if (.false.) then  ! don't need to print these every time:
                 do levnew = lbase+1,lfine
                     write(6,1006) intratx(levnew-1),intraty(levnew-1),
     &                             kratio(levnew-1),levnew
 1006                format('   Refinement ratios...  in x:', i3, 
     &                 '  in y:',i3,'  in t:',i3,' for level ',i4)
                 end do

              endif

c  ------- done regridding --------------------
c
c integrate all grids at level 'level'.
c
 90       continue


          call advanc(level,nvar,dtlevnew,vtime,naux)

c         # rjl modified 6/17/05 to print out *after* advanc and print cfl
c         # rjl & mjb changed to cfl_level, 3/17/10

          timenew = tlevel(level)+possk(level)
          if (tprint) then
              write(outunit,100)level,cfl_level,possk(level),timenew
              endif
          if (method(4).ge.level) then
              write(6,100)level,cfl_level,possk(level),timenew
              endif
100       format(' AMRCLAW: level ',i2,'  CFL = ',e10.3,
     &           '  dt = ',e11.4,  '  final t = ',e13.6)


c        # to debug individual grid updates...
c        call valout(level,level,time,nvar,naux)
c
c done with a level of integration. update counts, decide who next.
c
          ntogo(level)  = ntogo(level) - 1
          dtnew(level)  = dmin1(dtnew(level),dtlevnew)
          tlevel(level) = tlevel(level) + possk(level)
          icheck(level) = icheck(level) + 1
c
          if (level .lt. lfine) then
             level = level + 1
c            #  check if should adjust finer grid time step to start wtih
             if (((possk(level-1) - dtnew(level-1))/dtnew(level-1)) .gt.
     .            .05) then
                dttemp = dtnew(level-1)/kratio(level-1)
                ntogo(level) = (tlevel(level-1)-tlevel(level))/dttemp+.9
              else
                ntogo(level) = kratio(level-1)
              endif
             possk(level) = possk(level-1)/ntogo(level)
             go to 60
          endif
c
 105      if (level .eq. 1) go to 110
              if (ntogo(level) .gt. 0) then
c                same level goes again. check for ok time step
 106             if ((possk(level)-dtnew(level))/dtnew(level)
     .                .gt. .05)  then
c                   adjust time steps for this and finer levels
                    ntogo(level) = ntogo(level) + 1
                    possk(level) = (tlevel(level-1)-tlevel(level))/
     .                             ntogo(level)
                    go to 106
                 endif
                 go to 60
              else
                 level = level - 1
                 call system_clock(clock_start,clock_rate)
                 call update(level,nvar,naux)
                 call system_clock(clock_finish,clock_rate)
                 timeUpdating=timeUpdating+clock_finish-clock_start
              endif
          go to 105
c
c  --------------one complete coarse grid integration cycle done. -----
c
c      time for output?  done with the whole thing?
c
 110      continue
          time    = time   + possk(1)
          ncycle  = ncycle + 1
          call conck(1,nvar,naux,time,rest)

      if ( vtime) then
c
c         find new dt for next cycle (passed back from integration routine).
           do 115 i = 2, lfine
             ii = lfine+1-i
             dtnew(ii) = min(dtnew(ii),dtnew(ii+1)*kratio(ii))
 115       continue
c          make sure not to exceed largest permissible dt
           dtnew(1) = min(dtnew(1),dt_max)  
           possk(1) = dtnew(1)    ! propagate new timestep to hierarchy
           do 120 i = 2, mxnest
             possk(i) = possk(i-1) / kratio(i-1)
 120       continue

      endif

       if ((abs(checkpt_style).eq.3 .and. 
     &      mod(ncycle,checkpt_interval).eq.0) .or. dumpchk) then
                call check(ncycle,time,nvar,naux)
                dumpchk = .true.
       endif

       if ((mod(ncycle,iout).eq.0) .or. dumpout) then
         call valout(1,lfine,time,nvar,naux)
         if (abs(checkpt_style).eq.4) then
            call check(ncycle,time,nvar,naux)
            dumpchk = .true.
         endif
         if (printout) call outtre(mstart,.true.,nvar,naux)
       endif

       ! new STOP feature to do immediate checkpt and exit
       inquire(FILE="STOP.txt",exist=stopFound) 
          if (stopFound) then      
          write(*,*)"STOP file found. Checkpointing and Stopping"
          write(*,*)"REMEMBER to remove file before restarting"
          write(outunit,*)"STOP file found. Checkpointing and Stopping"
          write(outunit,*)"REMEMBER to remove file before restarting"
          call check(ncycle,time,nvar,naux)
          stop
       endif

      go to 20
c
999   continue

c
c  # computation is complete to final time or requested number of steps
c
       if (ncycle .ge. nstop .and. tfinal .lt. rinfinity) then
c         # warn the user that calculation finished prematurely
          write(outunit,102) nstop
          write(6,102) nstop
  102     format('*** Computation halted after nv(1) = ',i8,
     &           '  steps on coarse grid')
          endif
c
c  # final output (unless we just did it above)
c
      dump_final = ((iout.lt.iinfinity) .and. (mod(ncycle,iout).ne.0))
      if (.not. dumpout) then
          if (nout > 0) then
              dump_final = (tout(nout).eq.tfinal)
              endif
          endif
      
      if (dump_final) then
           call valout(1,lfine,time,nvar,naux)
           if (printout) call outtre(mstart,.true.,nvar,naux)
      endif

c ## tick timing moved here so can be saved in checkpoint file 
c
      call system_clock(tick_clock_finish,tick_clock_rate)
      call cpu_time(tick_cpu_finish)
      timeTick = timeTick + tick_clock_finish - tick_clock_start 
      timeTickCPU = timeTickCPU + tick_cpu_finish - tick_cpu_start 
 

c  # checkpoint everything for possible future restart
c  # (unless we just did it based on dumpchk)
c
      if (checkpt_style .ne. 0) then  ! want a chckpt
         ! check if just did it so dont do it twice
         if (.not. dumpchk) call check(ncycle,time,nvar,naux)
      else  ! no chkpt wanted, so need to print gauges separately
         if (num_gauges .gt. 0) then
            do ii = 1, num_gauges
               call print_gauges_and_reset_nextLoc(ii)
            end do
         endif
      endif
             
   

      write(6,*) "Done integrating to time ",time
      return
      end

* This file contains subroutines DGTTRF and DGTTRS to factor and solve
* a tridiagonal matrix, along with their dependencies, including XERBLA
* Downloaded August 31, 2023, from 
*    https://netlib.org/lapack/explore-html/index.html
* for use with GeoClaw 1D Boussinesq solvers as an alternative to linking
* in lapack and blas, on computers where these are not installed.
*======================================================================

*> \brief \b DGTTRS
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DGTTRS + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dgttrs.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dgttrs.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dgttrs.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,
*                          INFO )
*
*       .. Scalar Arguments ..
*       CHARACTER          TRANS
*       INTEGER            INFO, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DGTTRS solves one of the systems of equations
*>    A*X = B  or  A**T*X = B,
*> with a tridiagonal matrix A using the LU factorization computed
*> by DGTTRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] TRANS
*> \verbatim
*>          TRANS is CHARACTER*1
*>          Specifies the form of the system of equations.
*>          = 'N':  A * X = B  (No transpose)
*>          = 'T':  A**T* X = B  (Transpose)
*>          = 'C':  A**T* X = B  (Conjugate transpose = Transpose)
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in] DL
*> \verbatim
*>          DL is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) multipliers that define the matrix L from the
*>          LU factorization of A.
*> \endverbatim
*>
*> \param[in] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          The n diagonal elements of the upper triangular matrix U from
*>          the LU factorization of A.
*> \endverbatim
*>
*> \param[in] DU
*> \verbatim
*>          DU is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) elements of the first super-diagonal of U.
*> \endverbatim
*>
*> \param[in] DU2
*> \verbatim
*>          DU2 is DOUBLE PRECISION array, dimension (N-2)
*>          The (n-2) elements of the second super-diagonal of U.
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (N)
*>          The pivot indices; for 1 <= i <= n, row i of the matrix was
*>          interchanged with row IPIV(i).  IPIV(i) will always be either
*>          i or i+1; IPIV(i) = i indicates a row interchange was not
*>          required.
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,NRHS)
*>          On entry, the matrix of right hand side vectors B.
*>          On exit, B is overwritten by the solution vectors X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -i, the i-th argument had an illegal value
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup doubleGTcomputational
*
*  =====================================================================
      SUBROUTINE DGTTRS( TRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB,
     $                   INFO )
*
*  -- LAPACK computational routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      CHARACTER          TRANS
      INTEGER            INFO, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      LOGICAL            NOTRAN
      INTEGER            ITRANS, J, JB, NB
*     ..
*     .. External Functions ..
      INTEGER            ILAENV
      EXTERNAL           ILAENV
*     ..
*     .. External Subroutines ..
      EXTERNAL           DGTTS2, XERBLA
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          MAX, MIN
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      NOTRAN = ( TRANS.EQ.'N' .OR. TRANS.EQ.'n' )
      IF( .NOT.NOTRAN .AND. .NOT.( TRANS.EQ.'T' .OR. TRANS.EQ.
     $    't' ) .AND. .NOT.( TRANS.EQ.'C' .OR. TRANS.EQ.'c' ) ) THEN
         INFO = -1
      ELSE IF( N.LT.0 ) THEN
         INFO = -2
      ELSE IF( NRHS.LT.0 ) THEN
         INFO = -3
      ELSE IF( LDB.LT.MAX( N, 1 ) ) THEN
         INFO = -10
      END IF
      IF( INFO.NE.0 ) THEN
         CALL XERBLA( 'DGTTRS', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
*     Decode TRANS
*
      IF( NOTRAN ) THEN
         ITRANS = 0
      ELSE
         ITRANS = 1
      END IF
*
*     Determine the number of right-hand sides to solve at a time.
*
      IF( NRHS.EQ.1 ) THEN
         NB = 1
      ELSE
         NB = MAX( 1, ILAENV( 1, 'DGTTRS', TRANS, N, NRHS, -1, -1 ) )
      END IF
*
      IF( NB.GE.NRHS ) THEN
         CALL DGTTS2( ITRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB )
      ELSE
         DO 10 J = 1, NRHS, NB
            JB = MIN( NRHS-J+1, NB )
            CALL DGTTS2( ITRANS, N, JB, DL, D, DU, DU2, IPIV, B( 1, J ),
     $                   LDB )
   10    CONTINUE
      END IF
*
*     End of DGTTRS
*
      END
*> \brief \b DGTTS2 solves a system of linear equations with a tridiagonal matrix using the LU factorization computed by sgttrf.
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DGTTS2 + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dgtts2.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dgtts2.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dgtts2.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DGTTS2( ITRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB )
*
*       .. Scalar Arguments ..
*       INTEGER            ITRANS, LDB, N, NRHS
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DGTTS2 solves one of the systems of equations
*>    A*X = B  or  A**T*X = B,
*> with a tridiagonal matrix A using the LU factorization computed
*> by DGTTRF.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ITRANS
*> \verbatim
*>          ITRANS is INTEGER
*>          Specifies the form of the system of equations.
*>          = 0:  A * X = B  (No transpose)
*>          = 1:  A**T* X = B  (Transpose)
*>          = 2:  A**T* X = B  (Conjugate transpose = Transpose)
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.
*> \endverbatim
*>
*> \param[in] NRHS
*> \verbatim
*>          NRHS is INTEGER
*>          The number of right hand sides, i.e., the number of columns
*>          of the matrix B.  NRHS >= 0.
*> \endverbatim
*>
*> \param[in] DL
*> \verbatim
*>          DL is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) multipliers that define the matrix L from the
*>          LU factorization of A.
*> \endverbatim
*>
*> \param[in] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          The n diagonal elements of the upper triangular matrix U from
*>          the LU factorization of A.
*> \endverbatim
*>
*> \param[in] DU
*> \verbatim
*>          DU is DOUBLE PRECISION array, dimension (N-1)
*>          The (n-1) elements of the first super-diagonal of U.
*> \endverbatim
*>
*> \param[in] DU2
*> \verbatim
*>          DU2 is DOUBLE PRECISION array, dimension (N-2)
*>          The (n-2) elements of the second super-diagonal of U.
*> \endverbatim
*>
*> \param[in] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (N)
*>          The pivot indices; for 1 <= i <= n, row i of the matrix was
*>          interchanged with row IPIV(i).  IPIV(i) will always be either
*>          i or i+1; IPIV(i) = i indicates a row interchange was not
*>          required.
*> \endverbatim
*>
*> \param[in,out] B
*> \verbatim
*>          B is DOUBLE PRECISION array, dimension (LDB,NRHS)
*>          On entry, the matrix of right hand side vectors B.
*>          On exit, B is overwritten by the solution vectors X.
*> \endverbatim
*>
*> \param[in] LDB
*> \verbatim
*>          LDB is INTEGER
*>          The leading dimension of the array B.  LDB >= max(1,N).
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup doubleGTcomputational
*
*  =====================================================================
      SUBROUTINE DGTTS2( ITRANS, N, NRHS, DL, D, DU, DU2, IPIV, B, LDB )
*
*  -- LAPACK computational routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      INTEGER            ITRANS, LDB, N, NRHS
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   B( LDB, * ), D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IP, J
      DOUBLE PRECISION   TEMP
*     ..
*     .. Executable Statements ..
*
*     Quick return if possible
*
      IF( N.EQ.0 .OR. NRHS.EQ.0 )
     $   RETURN
*
      IF( ITRANS.EQ.0 ) THEN
*
*        Solve A*X = B using the LU factorization of A,
*        overwriting each right hand side vector with its solution.
*
         IF( NRHS.LE.1 ) THEN
            J = 1
   10       CONTINUE
*
*           Solve L*x = b.
*
            DO 20 I = 1, N - 1
               IP = IPIV( I )
               TEMP = B( I+1-IP+I, J ) - DL( I )*B( IP, J )
               B( I, J ) = B( IP, J )
               B( I+1, J ) = TEMP
   20       CONTINUE
*
*           Solve U*x = b.
*
            B( N, J ) = B( N, J ) / D( N )
            IF( N.GT.1 )
     $         B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) /
     $                       D( N-1 )
            DO 30 I = N - 2, 1, -1
               B( I, J ) = ( B( I, J )-DU( I )*B( I+1, J )-DU2( I )*
     $                     B( I+2, J ) ) / D( I )
   30       CONTINUE
            IF( J.LT.NRHS ) THEN
               J = J + 1
               GO TO 10
            END IF
         ELSE
            DO 60 J = 1, NRHS
*
*              Solve L*x = b.
*
               DO 40 I = 1, N - 1
                  IF( IPIV( I ).EQ.I ) THEN
                     B( I+1, J ) = B( I+1, J ) - DL( I )*B( I, J )
                  ELSE
                     TEMP = B( I, J )
                     B( I, J ) = B( I+1, J )
                     B( I+1, J ) = TEMP - DL( I )*B( I, J )
                  END IF
   40          CONTINUE
*
*              Solve U*x = b.
*
               B( N, J ) = B( N, J ) / D( N )
               IF( N.GT.1 )
     $            B( N-1, J ) = ( B( N-1, J )-DU( N-1 )*B( N, J ) ) /
     $                          D( N-1 )
               DO 50 I = N - 2, 1, -1
                  B( I, J ) = ( B( I, J )-DU( I )*B( I+1, J )-DU2( I )*
     $                        B( I+2, J ) ) / D( I )
   50          CONTINUE
   60       CONTINUE
         END IF
      ELSE
*
*        Solve A**T * X = B.
*
         IF( NRHS.LE.1 ) THEN
*
*           Solve U**T*x = b.
*
            J = 1
   70       CONTINUE
            B( 1, J ) = B( 1, J ) / D( 1 )
            IF( N.GT.1 )
     $         B( 2, J ) = ( B( 2, J )-DU( 1 )*B( 1, J ) ) / D( 2 )
            DO 80 I = 3, N
               B( I, J ) = ( B( I, J )-DU( I-1 )*B( I-1, J )-DU2( I-2 )*
     $                     B( I-2, J ) ) / D( I )
   80       CONTINUE
*
*           Solve L**T*x = b.
*
            DO 90 I = N - 1, 1, -1
               IP = IPIV( I )
               TEMP = B( I, J ) - DL( I )*B( I+1, J )
               B( I, J ) = B( IP, J )
               B( IP, J ) = TEMP
   90       CONTINUE
            IF( J.LT.NRHS ) THEN
               J = J + 1
               GO TO 70
            END IF
*
         ELSE
            DO 120 J = 1, NRHS
*
*              Solve U**T*x = b.
*
               B( 1, J ) = B( 1, J ) / D( 1 )
               IF( N.GT.1 )
     $            B( 2, J ) = ( B( 2, J )-DU( 1 )*B( 1, J ) ) / D( 2 )
               DO 100 I = 3, N
                  B( I, J ) = ( B( I, J )-DU( I-1 )*B( I-1, J )-
     $                        DU2( I-2 )*B( I-2, J ) ) / D( I )
  100          CONTINUE
               DO 110 I = N - 1, 1, -1
                  IF( IPIV( I ).EQ.I ) THEN
                     B( I, J ) = B( I, J ) - DL( I )*B( I+1, J )
                  ELSE
                     TEMP = B( I+1, J )
                     B( I+1, J ) = B( I, J ) - DL( I )*TEMP
                     B( I, J ) = TEMP
                  END IF
  110          CONTINUE
  120       CONTINUE
         END IF
      END IF
*
*     End of DGTTS2
*
      END
*> \brief \b IEEECK
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download IEEECK + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/ieeeck.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/ieeeck.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/ieeeck.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       INTEGER          FUNCTION IEEECK( ISPEC, ZERO, ONE )
*
*       .. Scalar Arguments ..
*       INTEGER            ISPEC
*       REAL               ONE, ZERO
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> IEEECK is called from the ILAENV to verify that Infinity and
*> possibly NaN arithmetic is safe (i.e. will not trap).
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ISPEC
*> \verbatim
*>          ISPEC is INTEGER
*>          Specifies whether to test just for infinity arithmetic
*>          or whether to test for infinity and NaN arithmetic.
*>          = 0: Verify infinity arithmetic only.
*>          = 1: Verify infinity and NaN arithmetic.
*> \endverbatim
*>
*> \param[in] ZERO
*> \verbatim
*>          ZERO is REAL
*>          Must contain the value 0.0
*>          This is passed to prevent the compiler from optimizing
*>          away this code.
*> \endverbatim
*>
*> \param[in] ONE
*> \verbatim
*>          ONE is REAL
*>          Must contain the value 1.0
*>          This is passed to prevent the compiler from optimizing
*>          away this code.
*>
*>  RETURN VALUE:  INTEGER
*>          = 0:  Arithmetic failed to produce the correct answers
*>          = 1:  Arithmetic produced the correct answers
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup OTHERauxiliary
*
*  =====================================================================
      INTEGER          FUNCTION IEEECK( ISPEC, ZERO, ONE )
*
*  -- LAPACK auxiliary routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      INTEGER            ISPEC
      REAL               ONE, ZERO
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      REAL               NAN1, NAN2, NAN3, NAN4, NAN5, NAN6, NEGINF,
     $                   NEGZRO, NEWZRO, POSINF
*     ..
*     .. Executable Statements ..
      IEEECK = 1
*
      POSINF = ONE / ZERO
      IF( POSINF.LE.ONE ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      NEGINF = -ONE / ZERO
      IF( NEGINF.GE.ZERO ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      NEGZRO = ONE / ( NEGINF+ONE )
      IF( NEGZRO.NE.ZERO ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      NEGINF = ONE / NEGZRO
      IF( NEGINF.GE.ZERO ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      NEWZRO = NEGZRO + ZERO
      IF( NEWZRO.NE.ZERO ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      POSINF = ONE / NEWZRO
      IF( POSINF.LE.ONE ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      NEGINF = NEGINF*POSINF
      IF( NEGINF.GE.ZERO ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      POSINF = POSINF*POSINF
      IF( POSINF.LE.ONE ) THEN
         IEEECK = 0
         RETURN
      END IF
*
*
*
*
*     Return if we were only asked to check infinity arithmetic
*
      IF( ISPEC.EQ.0 )
     $   RETURN
*
      NAN1 = POSINF + NEGINF
*
      NAN2 = POSINF / NEGINF
*
      NAN3 = POSINF / POSINF
*
      NAN4 = POSINF*ZERO
*
      NAN5 = NEGINF*NEGZRO
*
      NAN6 = NAN5*ZERO
*
      IF( NAN1.EQ.NAN1 ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      IF( NAN2.EQ.NAN2 ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      IF( NAN3.EQ.NAN3 ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      IF( NAN4.EQ.NAN4 ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      IF( NAN5.EQ.NAN5 ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      IF( NAN6.EQ.NAN6 ) THEN
         IEEECK = 0
         RETURN
      END IF
*
      RETURN
      END
*> \brief \b ILAENV
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download ILAENV + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/ilaenv.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/ilaenv.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/ilaenv.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       INTEGER FUNCTION ILAENV( ISPEC, NAME, OPTS, N1, N2, N3, N4 )
*
*       .. Scalar Arguments ..
*       CHARACTER*( * )    NAME, OPTS
*       INTEGER            ISPEC, N1, N2, N3, N4
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> ILAENV is called from the LAPACK routines to choose problem-dependent
*> parameters for the local environment.  See ISPEC for a description of
*> the parameters.
*>
*> ILAENV returns an INTEGER
*> if ILAENV >= 0: ILAENV returns the value of the parameter specified by ISPEC
*> if ILAENV < 0:  if ILAENV = -k, the k-th argument had an illegal value.
*>
*> This version provides a set of parameters which should give good,
*> but not optimal, performance on many of the currently available
*> computers.  Users are encouraged to modify this subroutine to set
*> the tuning parameters for their particular machine using the option
*> and problem size information in the arguments.
*>
*> This routine will not function correctly if it is converted to all
*> lower case.  Converting it to all upper case is allowed.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ISPEC
*> \verbatim
*>          ISPEC is INTEGER
*>          Specifies the parameter to be returned as the value of
*>          ILAENV.
*>          = 1: the optimal blocksize; if this value is 1, an unblocked
*>               algorithm will give the best performance.
*>          = 2: the minimum block size for which the block routine
*>               should be used; if the usable block size is less than
*>               this value, an unblocked routine should be used.
*>          = 3: the crossover point (in a block routine, for N less
*>               than this value, an unblocked routine should be used)
*>          = 4: the number of shifts, used in the nonsymmetric
*>               eigenvalue routines (DEPRECATED)
*>          = 5: the minimum column dimension for blocking to be used;
*>               rectangular blocks must have dimension at least k by m,
*>               where k is given by ILAENV(2,...) and m by ILAENV(5,...)
*>          = 6: the crossover point for the SVD (when reducing an m by n
*>               matrix to bidiagonal form, if max(m,n)/min(m,n) exceeds
*>               this value, a QR factorization is used first to reduce
*>               the matrix to a triangular form.)
*>          = 7: the number of processors
*>          = 8: the crossover point for the multishift QR method
*>               for nonsymmetric eigenvalue problems (DEPRECATED)
*>          = 9: maximum size of the subproblems at the bottom of the
*>               computation tree in the divide-and-conquer algorithm
*>               (used by xGELSD and xGESDD)
*>          =10: ieee infinity and NaN arithmetic can be trusted not to trap
*>          =11: infinity arithmetic can be trusted not to trap
*>          12 <= ISPEC <= 17:
*>               xHSEQR or related subroutines,
*>               see IPARMQ for detailed explanation
*> \endverbatim
*>
*> \param[in] NAME
*> \verbatim
*>          NAME is CHARACTER*(*)
*>          The name of the calling subroutine, in either upper case or
*>          lower case.
*> \endverbatim
*>
*> \param[in] OPTS
*> \verbatim
*>          OPTS is CHARACTER*(*)
*>          The character options to the subroutine NAME, concatenated
*>          into a single character string.  For example, UPLO = 'U',
*>          TRANS = 'T', and DIAG = 'N' for a triangular routine would
*>          be specified as OPTS = 'UTN'.
*> \endverbatim
*>
*> \param[in] N1
*> \verbatim
*>          N1 is INTEGER
*> \endverbatim
*>
*> \param[in] N2
*> \verbatim
*>          N2 is INTEGER
*> \endverbatim
*>
*> \param[in] N3
*> \verbatim
*>          N3 is INTEGER
*> \endverbatim
*>
*> \param[in] N4
*> \verbatim
*>          N4 is INTEGER
*>          Problem dimensions for the subroutine NAME; these may not all
*>          be required.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup OTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>  The following conventions have been used when calling ILAENV from the
*>  LAPACK routines:
*>  1)  OPTS is a concatenation of all of the character options to
*>      subroutine NAME, in the same order that they appear in the
*>      argument list for NAME, even if they are not used in determining
*>      the value of the parameter specified by ISPEC.
*>  2)  The problem dimensions N1, N2, N3, N4 are specified in the order
*>      that they appear in the argument list for NAME.  N1 is used
*>      first, N2 second, and so on, and unused problem dimensions are
*>      passed a value of -1.
*>  3)  The parameter value returned by ILAENV is checked for validity in
*>      the calling subroutine.  For example, ILAENV is used to retrieve
*>      the optimal blocksize for STRTRI as follows:
*>
*>      NB = ILAENV( 1, 'STRTRI', UPLO // DIAG, N, -1, -1, -1 )
*>      IF( NB.LE.1 ) NB = MAX( 1, N )
*> \endverbatim
*>
*  =====================================================================
      INTEGER FUNCTION ILAENV( ISPEC, NAME, OPTS, N1, N2, N3, N4 )
*
*  -- LAPACK auxiliary routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      CHARACTER*( * )    NAME, OPTS
      INTEGER            ISPEC, N1, N2, N3, N4
*     ..
*
*  =====================================================================
*
*     .. Local Scalars ..
      INTEGER            I, IC, IZ, NB, NBMIN, NX
      LOGICAL            CNAME, SNAME, TWOSTAGE
      CHARACTER          C1*1, C2*2, C4*2, C3*3, SUBNAM*16
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          CHAR, ICHAR, INT, MIN, REAL
*     ..
*     .. External Functions ..
      INTEGER            IEEECK, IPARMQ, IPARAM2STAGE
      EXTERNAL           IEEECK, IPARMQ, IPARAM2STAGE
*     ..
*     .. Executable Statements ..
*
      GO TO ( 10, 10, 10, 80, 90, 100, 110, 120,
     $        130, 140, 150, 160, 160, 160, 160, 160, 160)ISPEC
*
*     Invalid value for ISPEC
*
      ILAENV = -1
      RETURN
*
   10 CONTINUE
*
*     Convert NAME to upper case if the first character is lower case.
*
      ILAENV = 1
      SUBNAM = NAME
      IC = ICHAR( SUBNAM( 1: 1 ) )
      IZ = ICHAR( 'Z' )
      IF( IZ.EQ.90 .OR. IZ.EQ.122 ) THEN
*
*        ASCII character set
*
         IF( IC.GE.97 .AND. IC.LE.122 ) THEN
            SUBNAM( 1: 1 ) = CHAR( IC-32 )
            DO 20 I = 2, 6
               IC = ICHAR( SUBNAM( I: I ) )
               IF( IC.GE.97 .AND. IC.LE.122 )
     $            SUBNAM( I: I ) = CHAR( IC-32 )
   20       CONTINUE
         END IF
*
      ELSE IF( IZ.EQ.233 .OR. IZ.EQ.169 ) THEN
*
*        EBCDIC character set
*
         IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $       ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $       ( IC.GE.162 .AND. IC.LE.169 ) ) THEN
            SUBNAM( 1: 1 ) = CHAR( IC+64 )
            DO 30 I = 2, 6
               IC = ICHAR( SUBNAM( I: I ) )
               IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $             ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $             ( IC.GE.162 .AND. IC.LE.169 ) )SUBNAM( I:
     $             I ) = CHAR( IC+64 )
   30       CONTINUE
         END IF
*
      ELSE IF( IZ.EQ.218 .OR. IZ.EQ.250 ) THEN
*
*        Prime machines:  ASCII+128
*
         IF( IC.GE.225 .AND. IC.LE.250 ) THEN
            SUBNAM( 1: 1 ) = CHAR( IC-32 )
            DO 40 I = 2, 6
               IC = ICHAR( SUBNAM( I: I ) )
               IF( IC.GE.225 .AND. IC.LE.250 )
     $            SUBNAM( I: I ) = CHAR( IC-32 )
   40       CONTINUE
         END IF
      END IF
*
      C1 = SUBNAM( 1: 1 )
      SNAME = C1.EQ.'S' .OR. C1.EQ.'D'
      CNAME = C1.EQ.'C' .OR. C1.EQ.'Z'
      IF( .NOT.( CNAME .OR. SNAME ) )
     $   RETURN
      C2 = SUBNAM( 2: 3 )
      C3 = SUBNAM( 4: 6 )
      C4 = C3( 2: 3 )
      TWOSTAGE = LEN( SUBNAM ).GE.11
     $           .AND. SUBNAM( 11: 11 ).EQ.'2'
*
      GO TO ( 50, 60, 70 )ISPEC
*
   50 CONTINUE
*
*     ISPEC = 1:  block size
*
*     In these examples, separate code is provided for setting NB for
*     real and complex.  We assume that NB will take the same value in
*     single or double precision.
*
      NB = 1
*
      IF( SUBNAM(2:6).EQ.'LAORH' ) THEN
*
*        This is for *LAORHR_GETRFNP routine
*
         IF( SNAME ) THEN
             NB = 32
         ELSE
             NB = 32
         END IF
      ELSE IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR.
     $            C3.EQ.'QLF' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'QR ') THEN
            IF( N3 .EQ. 1) THEN
               IF( SNAME ) THEN
*     M*N
                  IF ((N1*N2.LE.131072).OR.(N1.LE.8192)) THEN
                     NB = N1
                  ELSE
                     NB = 32768/N2
                  END IF
               ELSE
                  IF ((N1*N2.LE.131072).OR.(N1.LE.8192)) THEN
                     NB = N1
                  ELSE
                     NB = 32768/N2
                  END IF
               END IF
            ELSE
               IF( SNAME ) THEN
                  NB = 1
               ELSE
                  NB = 1
               END IF
            END IF
         ELSE IF( C3.EQ.'LQ ') THEN
            IF( N3 .EQ. 2) THEN
               IF( SNAME ) THEN
*     M*N
                  IF ((N1*N2.LE.131072).OR.(N1.LE.8192)) THEN
                     NB = N1
                  ELSE
                     NB = 32768/N2
                  END IF
               ELSE
                  IF ((N1*N2.LE.131072).OR.(N1.LE.8192)) THEN
                     NB = N1
                  ELSE
                     NB = 32768/N2
                  END IF
               END IF
            ELSE
               IF( SNAME ) THEN
                  NB = 1
               ELSE
                  NB = 1
               END IF
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         ELSE IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'PO' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( TWOSTAGE ) THEN
                  NB = 192
               ELSE
                  NB = 64
               END IF
            ELSE
               IF( TWOSTAGE ) THEN
                  NB = 192
               ELSE
                  NB = 64
               END IF
            END IF
         ELSE IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NB = 32
         ELSE IF( SNAME .AND. C3.EQ.'GST' ) THEN
            NB = 64
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( TWOSTAGE ) THEN
               NB = 192
            ELSE
               NB = 64
            END IF
         ELSE IF( C3.EQ.'TRD' ) THEN
            NB = 32
         ELSE IF( C3.EQ.'GST' ) THEN
            NB = 64
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1: 1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NB = 32
            END IF
         ELSE IF( C3( 1: 1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NB = 32
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1: 1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NB = 32
            END IF
         ELSE IF( C3( 1: 1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NB = 32
            END IF
         END IF
      ELSE IF( C2.EQ.'GB' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( N4.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            ELSE
               IF( N4.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            END IF
         END IF
      ELSE IF( C2.EQ.'PB' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               IF( N2.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            ELSE
               IF( N2.LE.64 ) THEN
                  NB = 1
               ELSE
                  NB = 32
               END IF
            END IF
         END IF
      ELSE IF( C2.EQ.'TR' ) THEN
         IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF ( C3.EQ.'EVC' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( C3.EQ.'SYL' ) THEN
*           The upper bound is to prevent overly aggressive scaling.
            IF( SNAME ) THEN
               NB = MIN( MAX( 48, INT( ( MIN( N1, N2 ) * 16 ) / 100) ),
     $                   240 )
            ELSE
               NB = MIN( MAX( 24, INT( ( MIN( N1, N2 ) * 8 ) / 100) ),
     $                   80 )
            END IF
         END IF
      ELSE IF( C2.EQ.'LA' ) THEN
         IF( C3.EQ.'UUM' ) THEN
            IF( SNAME ) THEN
               NB = 64
            ELSE
               NB = 64
            END IF
         ELSE IF( C3.EQ.'TRS' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'ST' ) THEN
         IF( C3.EQ.'EBZ' ) THEN
            NB = 1
         END IF
      ELSE IF( C2.EQ.'GG' ) THEN
         NB = 32
         IF( C3.EQ.'HD3' ) THEN
            IF( SNAME ) THEN
               NB = 32
            ELSE
               NB = 32
            END IF
         END IF
      END IF
      ILAENV = NB
      RETURN
*
   60 CONTINUE
*
*     ISPEC = 2:  minimum block size
*
      NBMIN = 2
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR. C3.EQ.
     $       'QLF' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         ELSE IF( C3.EQ.'TRI' ) THEN
            IF( SNAME ) THEN
               NBMIN = 2
            ELSE
               NBMIN = 2
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( C3.EQ.'TRF' ) THEN
            IF( SNAME ) THEN
               NBMIN = 8
            ELSE
               NBMIN = 8
            END IF
         ELSE IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NBMIN = 2
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRD' ) THEN
            NBMIN = 2
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1: 1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NBMIN = 2
            END IF
         ELSE IF( C3( 1: 1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NBMIN = 2
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1: 1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NBMIN = 2
            END IF
         ELSE IF( C3( 1: 1 ).EQ.'M' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NBMIN = 2
            END IF
         END IF
      ELSE IF( C2.EQ.'GG' ) THEN
         NBMIN = 2
         IF( C3.EQ.'HD3' ) THEN
            NBMIN = 2
         END IF
      END IF
      ILAENV = NBMIN
      RETURN
*
   70 CONTINUE
*
*     ISPEC = 3:  crossover point
*
      NX = 0
      IF( C2.EQ.'GE' ) THEN
         IF( C3.EQ.'QRF' .OR. C3.EQ.'RQF' .OR. C3.EQ.'LQF' .OR. C3.EQ.
     $       'QLF' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         ELSE IF( C3.EQ.'HRD' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         ELSE IF( C3.EQ.'BRD' ) THEN
            IF( SNAME ) THEN
               NX = 128
            ELSE
               NX = 128
            END IF
         END IF
      ELSE IF( C2.EQ.'SY' ) THEN
         IF( SNAME .AND. C3.EQ.'TRD' ) THEN
            NX = 32
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'HE' ) THEN
         IF( C3.EQ.'TRD' ) THEN
            NX = 32
         END IF
      ELSE IF( SNAME .AND. C2.EQ.'OR' ) THEN
         IF( C3( 1: 1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NX = 128
            END IF
         END IF
      ELSE IF( CNAME .AND. C2.EQ.'UN' ) THEN
         IF( C3( 1: 1 ).EQ.'G' ) THEN
            IF( C4.EQ.'QR' .OR. C4.EQ.'RQ' .OR. C4.EQ.'LQ' .OR. C4.EQ.
     $          'QL' .OR. C4.EQ.'HR' .OR. C4.EQ.'TR' .OR. C4.EQ.'BR' )
     $           THEN
               NX = 128
            END IF
         END IF
      ELSE IF( C2.EQ.'GG' ) THEN
         NX = 128
         IF( C3.EQ.'HD3' ) THEN
            NX = 128
         END IF
      END IF
      ILAENV = NX
      RETURN
*
   80 CONTINUE
*
*     ISPEC = 4:  number of shifts (used by xHSEQR)
*
      ILAENV = 6
      RETURN
*
   90 CONTINUE
*
*     ISPEC = 5:  minimum column dimension (not used)
*
      ILAENV = 2
      RETURN
*
  100 CONTINUE
*
*     ISPEC = 6:  crossover point for SVD (used by xGELSS and xGESVD)
*
      ILAENV = INT( REAL( MIN( N1, N2 ) )*1.6E0 )
      RETURN
*
  110 CONTINUE
*
*     ISPEC = 7:  number of processors (not used)
*
      ILAENV = 1
      RETURN
*
  120 CONTINUE
*
*     ISPEC = 8:  crossover point for multishift (used by xHSEQR)
*
      ILAENV = 50
      RETURN
*
  130 CONTINUE
*
*     ISPEC = 9:  maximum size of the subproblems at the bottom of the
*                 computation tree in the divide-and-conquer algorithm
*                 (used by xGELSD and xGESDD)
*
      ILAENV = 25
      RETURN
*
  140 CONTINUE
*
*     ISPEC = 10: ieee and infinity NaN arithmetic can be trusted not to trap
*
*     ILAENV = 0
      ILAENV = 1
      IF( ILAENV.EQ.1 ) THEN
         ILAENV = IEEECK( 1, 0.0, 1.0 )
      END IF
      RETURN
*
  150 CONTINUE
*
*     ISPEC = 11: ieee infinity arithmetic can be trusted not to trap
*
*     ILAENV = 0
      ILAENV = 1
      IF( ILAENV.EQ.1 ) THEN
         ILAENV = IEEECK( 0, 0.0, 1.0 )
      END IF
      RETURN
*
  160 CONTINUE
*
*     12 <= ISPEC <= 17: xHSEQR or related subroutines.
*
      ILAENV = IPARMQ( ISPEC, NAME, OPTS, N1, N2, N3, N4 )
      RETURN
*
*     End of ILAENV
*
      END
*> \brief \b IPARMQ
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download IPARMQ + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/iparmq.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/iparmq.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/iparmq.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       INTEGER FUNCTION IPARMQ( ISPEC, NAME, OPTS, N, ILO, IHI, LWORK )
*
*       .. Scalar Arguments ..
*       INTEGER            IHI, ILO, ISPEC, LWORK, N
*       CHARACTER          NAME*( * ), OPTS*( * )
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*>      This program sets problem and machine dependent parameters
*>      useful for xHSEQR and related subroutines for eigenvalue
*>      problems. It is called whenever
*>      IPARMQ is called with 12 <= ISPEC <= 16
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] ISPEC
*> \verbatim
*>          ISPEC is INTEGER
*>              ISPEC specifies which tunable parameter IPARMQ should
*>              return.
*>
*>              ISPEC=12: (INMIN)  Matrices of order nmin or less
*>                        are sent directly to xLAHQR, the implicit
*>                        double shift QR algorithm.  NMIN must be
*>                        at least 11.
*>
*>              ISPEC=13: (INWIN)  Size of the deflation window.
*>                        This is best set greater than or equal to
*>                        the number of simultaneous shifts NS.
*>                        Larger matrices benefit from larger deflation
*>                        windows.
*>
*>              ISPEC=14: (INIBL) Determines when to stop nibbling and
*>                        invest in an (expensive) multi-shift QR sweep.
*>                        If the aggressive early deflation subroutine
*>                        finds LD converged eigenvalues from an order
*>                        NW deflation window and LD > (NW*NIBBLE)/100,
*>                        then the next QR sweep is skipped and early
*>                        deflation is applied immediately to the
*>                        remaining active diagonal block.  Setting
*>                        IPARMQ(ISPEC=14) = 0 causes TTQRE to skip a
*>                        multi-shift QR sweep whenever early deflation
*>                        finds a converged eigenvalue.  Setting
*>                        IPARMQ(ISPEC=14) greater than or equal to 100
*>                        prevents TTQRE from skipping a multi-shift
*>                        QR sweep.
*>
*>              ISPEC=15: (NSHFTS) The number of simultaneous shifts in
*>                        a multi-shift QR iteration.
*>
*>              ISPEC=16: (IACC22) IPARMQ is set to 0, 1 or 2 with the
*>                        following meanings.
*>                        0:  During the multi-shift QR/QZ sweep,
*>                            blocked eigenvalue reordering, blocked
*>                            Hessenberg-triangular reduction,
*>                            reflections and/or rotations are not
*>                            accumulated when updating the
*>                            far-from-diagonal matrix entries.
*>                        1:  During the multi-shift QR/QZ sweep,
*>                            blocked eigenvalue reordering, blocked
*>                            Hessenberg-triangular reduction,
*>                            reflections and/or rotations are
*>                            accumulated, and matrix-matrix
*>                            multiplication is used to update the
*>                            far-from-diagonal matrix entries.
*>                        2:  During the multi-shift QR/QZ sweep,
*>                            blocked eigenvalue reordering, blocked
*>                            Hessenberg-triangular reduction,
*>                            reflections and/or rotations are
*>                            accumulated, and 2-by-2 block structure
*>                            is exploited during matrix-matrix
*>                            multiplies.
*>                        (If xTRMM is slower than xGEMM, then
*>                        IPARMQ(ISPEC=16)=1 may be more efficient than
*>                        IPARMQ(ISPEC=16)=2 despite the greater level of
*>                        arithmetic work implied by the latter choice.)
*>
*>              ISPEC=17: (ICOST) An estimate of the relative cost of flops
*>                        within the near-the-diagonal shift chase compared
*>                        to flops within the BLAS calls of a QZ sweep.
*> \endverbatim
*>
*> \param[in] NAME
*> \verbatim
*>          NAME is CHARACTER string
*>               Name of the calling subroutine
*> \endverbatim
*>
*> \param[in] OPTS
*> \verbatim
*>          OPTS is CHARACTER string
*>               This is a concatenation of the string arguments to
*>               TTQRE.
*> \endverbatim
*>
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>               N is the order of the Hessenberg matrix H.
*> \endverbatim
*>
*> \param[in] ILO
*> \verbatim
*>          ILO is INTEGER
*> \endverbatim
*>
*> \param[in] IHI
*> \verbatim
*>          IHI is INTEGER
*>               It is assumed that H is already upper triangular
*>               in rows and columns 1:ILO-1 and IHI+1:N.
*> \endverbatim
*>
*> \param[in] LWORK
*> \verbatim
*>          LWORK is INTEGER
*>               The amount of workspace available.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup OTHERauxiliary
*
*> \par Further Details:
*  =====================
*>
*> \verbatim
*>
*>       Little is known about how best to choose these parameters.
*>       It is possible to use different values of the parameters
*>       for each of CHSEQR, DHSEQR, SHSEQR and ZHSEQR.
*>
*>       It is probably best to choose different parameters for
*>       different matrices and different parameters at different
*>       times during the iteration, but this has not been
*>       implemented --- yet.
*>
*>
*>       The best choices of most of the parameters depend
*>       in an ill-understood way on the relative execution
*>       rate of xLAQR3 and xLAQR5 and on the nature of each
*>       particular eigenvalue problem.  Experiment may be the
*>       only practical way to determine which choices are most
*>       effective.
*>
*>       Following is a list of default values supplied by IPARMQ.
*>       These defaults may be adjusted in order to attain better
*>       performance in any particular computational environment.
*>
*>       IPARMQ(ISPEC=12) The xLAHQR vs xLAQR0 crossover point.
*>                        Default: 75. (Must be at least 11.)
*>
*>       IPARMQ(ISPEC=13) Recommended deflation window size.
*>                        This depends on ILO, IHI and NS, the
*>                        number of simultaneous shifts returned
*>                        by IPARMQ(ISPEC=15).  The default for
*>                        (IHI-ILO+1) <= 500 is NS.  The default
*>                        for (IHI-ILO+1) > 500 is 3*NS/2.
*>
*>       IPARMQ(ISPEC=14) Nibble crossover point.  Default: 14.
*>
*>       IPARMQ(ISPEC=15) Number of simultaneous shifts, NS.
*>                        a multi-shift QR iteration.
*>
*>                        If IHI-ILO+1 is ...
*>
*>                        greater than      ...but less    ... the
*>                        or equal to ...      than        default is
*>
*>                                0               30       NS =   2+
*>                               30               60       NS =   4+
*>                               60              150       NS =  10
*>                              150              590       NS =  **
*>                              590             3000       NS =  64
*>                             3000             6000       NS = 128
*>                             6000             infinity   NS = 256
*>
*>                    (+)  By default matrices of this order are
*>                         passed to the implicit double shift routine
*>                         xLAHQR.  See IPARMQ(ISPEC=12) above.   These
*>                         values of NS are used only in case of a rare
*>                         xLAHQR failure.
*>
*>                    (**) The asterisks (**) indicate an ad-hoc
*>                         function increasing from 10 to 64.
*>
*>       IPARMQ(ISPEC=16) Select structured matrix multiply.
*>                        (See ISPEC=16 above for details.)
*>                        Default: 3.
*>
*>       IPARMQ(ISPEC=17) Relative cost heuristic for blocksize selection.
*>                        Expressed as a percentage.
*>                        Default: 10.
*> \endverbatim
*>
*  =====================================================================
      INTEGER FUNCTION IPARMQ( ISPEC, NAME, OPTS, N, ILO, IHI, LWORK )
*
*  -- LAPACK auxiliary routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      INTEGER            IHI, ILO, ISPEC, LWORK, N
      CHARACTER          NAME*( * ), OPTS*( * )
*
*  ================================================================
*     .. Parameters ..
      INTEGER            INMIN, INWIN, INIBL, ISHFTS, IACC22, ICOST
      PARAMETER          ( INMIN = 12, INWIN = 13, INIBL = 14,
     $                   ISHFTS = 15, IACC22 = 16, ICOST = 17 )
      INTEGER            NMIN, K22MIN, KACMIN, NIBBLE, KNWSWP, RCOST
      PARAMETER          ( NMIN = 75, K22MIN = 14, KACMIN = 14,
     $                   NIBBLE = 14, KNWSWP = 500, RCOST = 10 )
      REAL               TWO
      PARAMETER          ( TWO = 2.0 )
*     ..
*     .. Local Scalars ..
      INTEGER            NH, NS
      INTEGER            I, IC, IZ
      CHARACTER          SUBNAM*6
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          LOG, MAX, MOD, NINT, REAL
*     ..
*     .. Executable Statements ..
      IF( ( ISPEC.EQ.ISHFTS ) .OR. ( ISPEC.EQ.INWIN ) .OR.
     $    ( ISPEC.EQ.IACC22 ) ) THEN
*
*        ==== Set the number simultaneous shifts ====
*
         NH = IHI - ILO + 1
         NS = 2
         IF( NH.GE.30 )
     $      NS = 4
         IF( NH.GE.60 )
     $      NS = 10
         IF( NH.GE.150 )
     $      NS = MAX( 10, NH / NINT( LOG( REAL( NH ) ) / LOG( TWO ) ) )
         IF( NH.GE.590 )
     $      NS = 64
         IF( NH.GE.3000 )
     $      NS = 128
         IF( NH.GE.6000 )
     $      NS = 256
         NS = MAX( 2, NS-MOD( NS, 2 ) )
      END IF
*
      IF( ISPEC.EQ.INMIN ) THEN
*
*
*        ===== Matrices of order smaller than NMIN get sent
*        .     to xLAHQR, the classic double shift algorithm.
*        .     This must be at least 11. ====
*
         IPARMQ = NMIN
*
      ELSE IF( ISPEC.EQ.INIBL ) THEN
*
*        ==== INIBL: skip a multi-shift qr iteration and
*        .    whenever aggressive early deflation finds
*        .    at least (NIBBLE*(window size)/100) deflations. ====
*
         IPARMQ = NIBBLE
*
      ELSE IF( ISPEC.EQ.ISHFTS ) THEN
*
*        ==== NSHFTS: The number of simultaneous shifts =====
*
         IPARMQ = NS
*
      ELSE IF( ISPEC.EQ.INWIN ) THEN
*
*        ==== NW: deflation window size.  ====
*
         IF( NH.LE.KNWSWP ) THEN
            IPARMQ = NS
         ELSE
            IPARMQ = 3*NS / 2
         END IF
*
      ELSE IF( ISPEC.EQ.IACC22 ) THEN
*
*        ==== IACC22: Whether to accumulate reflections
*        .     before updating the far-from-diagonal elements
*        .     and whether to use 2-by-2 block structure while
*        .     doing it.  A small amount of work could be saved
*        .     by making this choice dependent also upon the
*        .     NH=IHI-ILO+1.
*
*
*        Convert NAME to upper case if the first character is lower case.
*
         IPARMQ = 0
         SUBNAM = NAME
         IC = ICHAR( SUBNAM( 1: 1 ) )
         IZ = ICHAR( 'Z' )
         IF( IZ.EQ.90 .OR. IZ.EQ.122 ) THEN
*
*           ASCII character set
*
            IF( IC.GE.97 .AND. IC.LE.122 ) THEN
               SUBNAM( 1: 1 ) = CHAR( IC-32 )
               DO I = 2, 6
                  IC = ICHAR( SUBNAM( I: I ) )
                  IF( IC.GE.97 .AND. IC.LE.122 )
     $               SUBNAM( I: I ) = CHAR( IC-32 )
               END DO
            END IF
*
         ELSE IF( IZ.EQ.233 .OR. IZ.EQ.169 ) THEN
*
*           EBCDIC character set
*
            IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $          ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $          ( IC.GE.162 .AND. IC.LE.169 ) ) THEN
               SUBNAM( 1: 1 ) = CHAR( IC+64 )
               DO I = 2, 6
                  IC = ICHAR( SUBNAM( I: I ) )
                  IF( ( IC.GE.129 .AND. IC.LE.137 ) .OR.
     $                ( IC.GE.145 .AND. IC.LE.153 ) .OR.
     $                ( IC.GE.162 .AND. IC.LE.169 ) )SUBNAM( I:
     $                I ) = CHAR( IC+64 )
               END DO
            END IF
*
         ELSE IF( IZ.EQ.218 .OR. IZ.EQ.250 ) THEN
*
*           Prime machines:  ASCII+128
*
            IF( IC.GE.225 .AND. IC.LE.250 ) THEN
               SUBNAM( 1: 1 ) = CHAR( IC-32 )
               DO I = 2, 6
                  IC = ICHAR( SUBNAM( I: I ) )
                  IF( IC.GE.225 .AND. IC.LE.250 )
     $               SUBNAM( I: I ) = CHAR( IC-32 )
               END DO
            END IF
         END IF
*
         IF( SUBNAM( 2:6 ).EQ.'GGHRD' .OR.
     $       SUBNAM( 2:6 ).EQ.'GGHD3' ) THEN
            IPARMQ = 1
            IF( NH.GE.K22MIN )
     $         IPARMQ = 2
         ELSE IF ( SUBNAM( 4:6 ).EQ.'EXC' ) THEN
            IF( NH.GE.KACMIN )
     $         IPARMQ = 1
            IF( NH.GE.K22MIN )
     $         IPARMQ = 2
         ELSE IF ( SUBNAM( 2:6 ).EQ.'HSEQR' .OR.
     $             SUBNAM( 2:5 ).EQ.'LAQR' ) THEN
            IF( NS.GE.KACMIN )
     $         IPARMQ = 1
            IF( NS.GE.K22MIN )
     $         IPARMQ = 2
         END IF
*
      ELSE IF( ISPEC.EQ.ICOST ) THEN
*
*        === Relative cost of near-the-diagonal chase vs
*            BLAS updates ===
*
         IPARMQ = RCOST
      ELSE
*        ===== invalid value of ispec =====
         IPARMQ = -1
*
      END IF
*
*     ==== End of IPARMQ ====
*
      END
*> \brief \b XERBLA
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*  Definition:
*  ===========
*
*       SUBROUTINE XERBLA( SRNAME, INFO )
*
*       .. Scalar Arguments ..
*       CHARACTER*(*)      SRNAME
*       INTEGER            INFO
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> XERBLA  is an error handler for the LAPACK routines.
*> It is called by an LAPACK routine if an input parameter has an
*> invalid value.  A message is printed and execution stops.
*>
*> Installers may consider modifying the STOP statement in order to
*> call system-specific exception-handling facilities.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] SRNAME
*> \verbatim
*>          SRNAME is CHARACTER*(*)
*>          The name of the routine which called XERBLA.
*> \endverbatim
*>
*> \param[in] INFO
*> \verbatim
*>          INFO is INTEGER
*>          The position of the invalid parameter in the parameter list
*>          of the calling routine.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup aux_blas
*
*  =====================================================================
      SUBROUTINE XERBLA( SRNAME, INFO )
*
*  -- Reference BLAS level1 routine --
*  -- Reference BLAS is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      CHARACTER*(*)      SRNAME
      INTEGER            INFO
*     ..
*
* =====================================================================
*
*     .. Intrinsic Functions ..
      INTRINSIC          LEN_TRIM
*     ..
*     .. Executable Statements ..
*
      WRITE( *, FMT = 9999 )SRNAME( 1:LEN_TRIM( SRNAME ) ), INFO
*
      STOP
*
 9999 FORMAT( ' ** On entry to ', A, ' parameter number ', I2, ' had ',
     $      'an illegal value' )
*
*     End of XERBLA
*
      END


*> \brief \b DGTTRF
*
*  =========== DOCUMENTATION ===========
*
* Online html documentation available at
*            http://www.netlib.org/lapack/explore-html/
*
*> \htmlonly
*> Download DGTTRF + dependencies
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.tgz?format=tgz&filename=/lapack/lapack_routine/dgttrf.f">
*> [TGZ]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.zip?format=zip&filename=/lapack/lapack_routine/dgttrf.f">
*> [ZIP]</a>
*> <a href="http://www.netlib.org/cgi-bin/netlibfiles.txt?format=txt&filename=/lapack/lapack_routine/dgttrf.f">
*> [TXT]</a>
*> \endhtmlonly
*
*  Definition:
*  ===========
*
*       SUBROUTINE DGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
*
*       .. Scalar Arguments ..
*       INTEGER            INFO, N
*       ..
*       .. Array Arguments ..
*       INTEGER            IPIV( * )
*       DOUBLE PRECISION   D( * ), DL( * ), DU( * ), DU2( * )
*       ..
*
*
*> \par Purpose:
*  =============
*>
*> \verbatim
*>
*> DGTTRF computes an LU factorization of a real tridiagonal matrix A
*> using elimination with partial pivoting and row interchanges.
*>
*> The factorization has the form
*>    A = L * U
*> where L is a product of permutation and unit lower bidiagonal
*> matrices and U is upper triangular with nonzeros in only the main
*> diagonal and first two superdiagonals.
*> \endverbatim
*
*  Arguments:
*  ==========
*
*> \param[in] N
*> \verbatim
*>          N is INTEGER
*>          The order of the matrix A.
*> \endverbatim
*>
*> \param[in,out] DL
*> \verbatim
*>          DL is DOUBLE PRECISION array, dimension (N-1)
*>          On entry, DL must contain the (n-1) sub-diagonal elements of
*>          A.
*>
*>          On exit, DL is overwritten by the (n-1) multipliers that
*>          define the matrix L from the LU factorization of A.
*> \endverbatim
*>
*> \param[in,out] D
*> \verbatim
*>          D is DOUBLE PRECISION array, dimension (N)
*>          On entry, D must contain the diagonal elements of A.
*>
*>          On exit, D is overwritten by the n diagonal elements of the
*>          upper triangular matrix U from the LU factorization of A.
*> \endverbatim
*>
*> \param[in,out] DU
*> \verbatim
*>          DU is DOUBLE PRECISION array, dimension (N-1)
*>          On entry, DU must contain the (n-1) super-diagonal elements
*>          of A.
*>
*>          On exit, DU is overwritten by the (n-1) elements of the first
*>          super-diagonal of U.
*> \endverbatim
*>
*> \param[out] DU2
*> \verbatim
*>          DU2 is DOUBLE PRECISION array, dimension (N-2)
*>          On exit, DU2 is overwritten by the (n-2) elements of the
*>          second super-diagonal of U.
*> \endverbatim
*>
*> \param[out] IPIV
*> \verbatim
*>          IPIV is INTEGER array, dimension (N)
*>          The pivot indices; for 1 <= i <= n, row i of the matrix was
*>          interchanged with row IPIV(i).  IPIV(i) will always be either
*>          i or i+1; IPIV(i) = i indicates a row interchange was not
*>          required.
*> \endverbatim
*>
*> \param[out] INFO
*> \verbatim
*>          INFO is INTEGER
*>          = 0:  successful exit
*>          < 0:  if INFO = -k, the k-th argument had an illegal value
*>          > 0:  if INFO = k, U(k,k) is exactly zero. The factorization
*>                has been completed, but the factor U is exactly
*>                singular, and division by zero will occur if it is used
*>                to solve a system of equations.
*> \endverbatim
*
*  Authors:
*  ========
*
*> \author Univ. of Tennessee
*> \author Univ. of California Berkeley
*> \author Univ. of Colorado Denver
*> \author NAG Ltd.
*
*> \ingroup doubleGTcomputational
*
*  =====================================================================
      SUBROUTINE DGTTRF( N, DL, D, DU, DU2, IPIV, INFO )
*
*  -- LAPACK computational routine --
*  -- LAPACK is a software package provided by Univ. of Tennessee,    --
*  -- Univ. of California Berkeley, Univ. of Colorado Denver and NAG Ltd..--
*
*     .. Scalar Arguments ..
      INTEGER            INFO, N
*     ..
*     .. Array Arguments ..
      INTEGER            IPIV( * )
      DOUBLE PRECISION   D( * ), DL( * ), DU( * ), DU2( * )
*     ..
*
*  =====================================================================
*
*     .. Parameters ..
      DOUBLE PRECISION   ZERO
      PARAMETER          ( ZERO = 0.0D+0 )
*     ..
*     .. Local Scalars ..
      INTEGER            I
      DOUBLE PRECISION   FACT, TEMP
*     ..
*     .. Intrinsic Functions ..
      INTRINSIC          ABS
*     ..
*     .. External Subroutines ..
      EXTERNAL           XERBLA
*     ..
*     .. Executable Statements ..
*
      INFO = 0
      IF( N.LT.0 ) THEN
         INFO = -1
         CALL XERBLA( 'DGTTRF', -INFO )
         RETURN
      END IF
*
*     Quick return if possible
*
      IF( N.EQ.0 )
     $   RETURN
*
*     Initialize IPIV(i) = i and DU2(I) = 0
*
      DO 10 I = 1, N
         IPIV( I ) = I
   10 CONTINUE
      DO 20 I = 1, N - 2
         DU2( I ) = ZERO
   20 CONTINUE
*
      DO 30 I = 1, N - 2
         IF( ABS( D( I ) ).GE.ABS( DL( I ) ) ) THEN
*
*           No row interchange required, eliminate DL(I)
*
            IF( D( I ).NE.ZERO ) THEN
               FACT = DL( I ) / D( I )
               DL( I ) = FACT
               D( I+1 ) = D( I+1 ) - FACT*DU( I )
            END IF
         ELSE
*
*           Interchange rows I and I+1, eliminate DL(I)
*
            FACT = D( I ) / DL( I )
            D( I ) = DL( I )
            DL( I ) = FACT
            TEMP = DU( I )
            DU( I ) = D( I+1 )
            D( I+1 ) = TEMP - FACT*D( I+1 )
            DU2( I ) = DU( I+1 )
            DU( I+1 ) = -FACT*DU( I+1 )
            IPIV( I ) = I + 1
         END IF
   30 CONTINUE
      IF( N.GT.1 ) THEN
         I = N - 1
         IF( ABS( D( I ) ).GE.ABS( DL( I ) ) ) THEN
            IF( D( I ).NE.ZERO ) THEN
               FACT = DL( I ) / D( I )
               DL( I ) = FACT
               D( I+1 ) = D( I+1 ) - FACT*DU( I )
            END IF
         ELSE
            FACT = D( I ) / DL( I )
            D( I ) = DL( I )
            DL( I ) = FACT
            TEMP = DU( I )
            DU( I ) = D( I+1 )
            D( I+1 ) = TEMP - FACT*D( I+1 )
            IPIV( I ) = I + 1
         END IF
      END IF
*
*     Check for a zero on the diagonal of U.
*
      DO 40 I = 1, N
         IF( D( I ).EQ.ZERO ) THEN
            INFO = I
            GO TO 50
         END IF
   40 CONTINUE
   50 CONTINUE
*
      RETURN
*
*     End of DGTTRF
*
      END

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
    implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for the scalar equation

!     # Split asdq (= A^* \Delta q, where * = + or -)
!     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
!     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)


    dimension     ql(meqn,1-mbc:maxm+mbc)
    dimension     qr(meqn,1-mbc:maxm+mbc)
    dimension   asdq(meqn,1-mbc:maxm+mbc)
    dimension bmasdq(meqn,1-mbc:maxm+mbc)
    dimension bpasdq(meqn,1-mbc:maxm+mbc)
    common /cparam/ u,v

!     # transverse wave speeds have been computed in rpn2
!     # maux=0 and aux arrays are unused in this example.

    if (ixy == 1) then
        stran = v
    else
        stran = u
    endif

    stranm = dmin1(stran, 0.d0)
    stranp = dmax1(stran, 0.d0)
          
    do 10 i = 2-mbc, mx+mbc
        bmasdq(1,i) = stranm * asdq(1,i)
        bpasdq(1,i) = stranp * asdq(1,i)
    10 END DO

    return
    end subroutine rpt2

!
!  :::::::::::::: BOUND :::::::::::::::::::::::::::::::::::::::::::
!     This routine sets the boundary values for a given grid 
!     at level level.
!     We are setting the values for a strip ng zones wide all
!     the way around the border, in 4 rectangular strips.
!
!     Outputs from this routine:
!     The values around the border of the grid are inserted
!     directly into the enlarged valbig array.
!
!     This routine calls the routine filpatch
!     which for any block of mesh points on a given level,
!     intersects that block with all grids on that level and with
!     the physical boundaries, copies the values into the
!     appropriate intersecting regions, and interpolates the remaining
!     cells from coarser grids as required.
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
subroutine bound(time,nvar,ng,valbig,mitot,mjtot,mptr,aux,naux)

    use amr_module, only: rnode, node, hxposs, hyposs, cornxlo, cornxhi
    use amr_module, only: cornylo, cornyhi, ndilo, ndihi, ndjlo, ndjhi
    use amr_module, only: nestlevel, xlower, xupper, ylower, yupper
    use amr_module, only: xperdom, yperdom, spheredom
    
    implicit none

    ! Input
    integer, intent(in) :: nvar, ng, mitot, mjtot, mptr, naux
    real(kind=8), intent(in) :: time
    real(kind=8), intent(in out) :: valbig(nvar,mitot,mjtot)
    real(kind=8), intent(in out) :: aux(naux,mitot,mjtot)

    ! Locals
    integer :: ilo, ihi, jlo, jhi, level,i,j  ! rect(4)
    real(kind=8) :: xleft, xright, ybot, ytop, hx, hy, xl, xr, yb, yt

    xleft  = rnode(cornxlo, mptr)
    xright = rnode(cornxhi, mptr)
    ybot   = rnode(cornylo, mptr)
    ytop   = rnode(cornyhi, mptr)
    ilo    = node(ndilo, mptr)
    ihi    = node(ndihi, mptr)
    jlo    = node(ndjlo, mptr)
    jhi    = node(ndjhi, mptr)
    level  = node(nestlevel, mptr)
    hx     = hxposs(level)
    hy     = hyposs(level)


    ! left boundary
    xl = xleft - ng*hx
    xr = xleft
    yb = ybot 
    yt = ytop

    !rect = [ilo-ng,ilo-1,jlo,jhi]
    if ((xl < xlower) .and. xperdom) then
        call  prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,ng+1, &
                          ilo-ng,ilo-1,jlo,jhi)
    else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,ng+1,ilo-ng,ilo-1,jlo,jhi)
    endif

    ! right boundary
    xl = xright
    xr = xright + ng*hx
    yb = ybot
    yt = ytop

    !rect = [ihi+1,ihi+ng,jlo,jhi]
    if ((xr .gt. xupper) .and. xperdom) then
        call  prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
                          mitot-ng+1,ng+1,ihi+1,ihi+ng,jlo,jhi)
    else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
                      mitot-ng+1,ng+1,ihi+1,ihi+ng,jlo,jhi)
    endif


    ! bottom boundary
    xl = xleft  - ng*hx
    xr = xright + ng*hx
    yb = ybot - ng*hy
    yt = ybot
    
    !rect = [ilo-ng,ihi+ng,jlo-ng,jlo-1]
    if ( ((yb < ylower) .and. (yperdom .or. spheredom)) .or. &
        ( ((xl < xlower) .or. (xr > xupper)) .and. xperdom) ) then
       call prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,1,ilo-ng,ihi+ng,jlo-ng,jlo-1)
    else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot,1,1,ilo-ng,ihi+ng,jlo-ng,jlo-1)
    endif

    ! top boundary
    xl = xleft - ng*hx
    xr = xright + ng*hx
    yb = ytop
    yt = ytop + ng*hy

    !rect = [ilo-ng,ihi+ng,jhi+1,jhi+ng]
    if ( ((yt .gt. yupper) .and. (yperdom .or. spheredom)) .or. &
         (((xl .lt. xlower) .or. (xr .gt. xupper)) .and. xperdom) ) then
        call prefilrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
                         1,mjtot-ng+1,ilo-ng,ihi+ng,jhi+1,jhi+ng)
    else
        call filrecur(level,nvar,valbig,aux,naux,time,mitot,mjtot, &
                      1,mjtot-ng+1,ilo-ng,ihi+ng,jhi+1,jhi+ng)
    endif

! external boundary conditions   THIS IS NOW DONE IN THE FILPATCHES 
! (in the recursive filrecur.f, since filpatches had to call bc2amr, have them 
! all do it).

end subroutine bound

c
c ----------------------------------------------------------------
c
       program amr3ez
c
c  Use adaptive mesh refinement to solve the hyperbolic 3-d equation:
c
c              u  +  f(u)    + g(u)   + h(u)   = 0
c               t         x        y        z
c
c or the more general non-conservation law form:
c              u  +  A u     + B u    + C u    = 0
c               t         x        y       z
c
c  using the wave propagation method as in CLAWPACK in combination
c  with the locally uniform embedded grids of AMR.

c  Estimate error with Richardson extrap. (in errest.f)
c  + gradient checking (in errsp.f).  Initial conditions set
c  in (qinit.f), b.c.'s in (bc3amr.f).

c  Specify rectangular domain from
c           (xlower,ylower,zlower) to (xupper,yupper,zupper)
c
c  No rotated rectangles are used in this version.
c  Periodic b.c.'s finally implemented.
c
c =========================================================================
c  Copyright 2001,  Marsha J. Berger and Randall J. LeVeque
c
c  This software is made available for research and instructional use only.
c  You may copy and use this software without charge for these non-commercial
c  purposes, provided that the copyright notice and associated text is
c  reproduced on all copies.  For all other uses (including distribution of
c  modified versions), please contact the author at the address given below.
c
c  *** This software is made available "as is" without any assurance that it
c  *** will work for your purposes.  The software may in fact have defects, so
c  *** use the software at your own risk.
c
c  --------------------------------------
c    AMRCLAW Version 0.4,  February, 2001
c     compatible with CLAWPACK Version 4.0
c    Homepage: http://www.amath.washington.edu/~claw/
c  --------------------------------------
c
c   Authors:
c
c             Marsha J. Berger
c             Courant Institute of Mathematical Sciences
c             New York University
c             251 Mercer St.
c             New York, NY 10012
c             berger@cims.nyu.edu
c
c             Randall J. LeVeque
c             Applied Mathematics
c             Box 352420
c             University of Washington,
c             Seattle, WA 98195-2420
c             rjl@amath.washington.edu
c
c =========================================================================
c


c
c ----------------------------------------------------------------
c
      use amr_module
      implicit double precision (a-h,o-z)

      common /combc3/ mthbc(6)

      character * 12     pltfile,infile,outfile,dbugfile,matfile
      character*10       matname2
      logical            vtime,rest
      dimension          tout(maxout)

      integer oldmode,omp_get_max_threads
      integer clock_start, clock_finish, clock_rate
      
c
c
c  you may want to turn this on for SUN workstation, or replace
c  set to signal on overflow, divide by zero, and illegal operation
c
c       oldmode = ieee_handler("set","common",SIGFPE_ABORT)
c       if (oldmode .ne. 0) then
c           write(outunit,*)' could not set ieee trapper '
c           write(*,*)      ' could not set ieee trapper '
c           stop
c        endif
c
      infile   = 'amr3ez.data'
      outfile  = 'fort.amr'
      pltfile  = 'fort.ncar'
      dbugfile = 'fort.debug'
      matfile  = 'fort.nplot'

      open(inunit,  file=infile,status='old',form='formatted')
      open(outunit, file=outfile,status='unknown',form='formatted')
      open(dbugunit,file=dbugfile,status='unknown',form='formatted')
c
c     domain variables
      read(inunit,*) nx
      read(inunit,*) ny
      read(inunit,*) nz
      read(inunit,*) mxnest
      if (abs(mxnest) .gt. maxlv) then
         write(outunit,*)
     &    'Error ***   mxnest > max. allowable levels (maxlv) in common'
         write(*,*)
     &    'Error ***   mxnest > max. allowable levels (maxlv) in common'
         stop
      endif
      if (mxnest .lt. 0) then
c         # mxnext<0 flags anisotropic refinement - read in refinement
c         # ratios in x,y,t from next three lines:
          mxnest = -mxnest
          read(inunit,*) (intratx(i),i=1,max(1,mxnest-1))
          read(inunit,*) (intraty(i),i=1,max(1,mxnest-1))
          read(inunit,*) (intratz(i),i=1,max(1,mxnest-1))
          read(inunit,*) (kratio(i), i=1,max(1,mxnest-1))
      else
          read(inunit,*) (intratx(i),i=1,max(1,mxnest-1))
          do i=1,max(1,mxnest-1)
             intraty(i) = intratx(i)
             intratz(i) = intratx(i)
             kratio(i)  = intratx(i)
          enddo
      endif


      read(inunit,*) nout
      if (nout .gt. maxout) then
         write(6,*) 'Error *** need to increase maxout in call.i'
         stop
      endif
      read(inunit,*) outstyle
      if (outstyle.eq.1) then
         read(inunit,*) tfinal
         iout = 0
c        # array tout is set below after reading t0
      endif
      if (outstyle.eq.2) then
         read(inunit,*) (tout(i), i=1,nout)
         iout = 0
      endif
      if (outstyle.eq.3) then
         read(inunit,*) iout,nstop
         nout = 0
      endif
      read(inunit,*) possk(1)
      read(inunit,*) dt_max
      read(inunit,*) cflv1
      read(inunit,*) cfl
      read(inunit,*) nv1
      if (outstyle.eq.1 .or. outstyle.eq.2) then
         nstop = nv1
      endif

      read(inunit,*) method(1)
      vtime = (method(1) .eq. 1)
      read(inunit,*) method(2)
      iorder = method(2)
      read(inunit,*) method(3)
      if (method(3) .lt. 0) then
         write(6,*) '*** ERROR ***  method(3) < 0'
         write(6,*) '    dimensional splitting not supported in amrclaw'
         stop
      endif

      read(inunit,*) method(4)
      read(inunit,*) method(5)
      read(inunit,*) mcapa1
      read(inunit,*) naux
      if (naux .gt. maxaux) then
         write(outunit,*) 'Error ***   naux > maxaux in common'
         write(*,*)       'Error ***   naux > maxaux in common'
         stop
      endif
      do iaux = 1, naux
        read(inunit,*) auxtype(iaux)
      end do


      read(inunit,*) nvar
      read(inunit,*) mwaves
      if (mwaves .gt. maxwave) then
         write(outunit,*) 'Error ***   mwaves > maxwave in common'
         write(*,*)       'Error ***   mwaves > maxwave in common'
         stop
      endif
      read(inunit,*) (mthlim(mw), mw=1,mwaves)


      read(inunit,*) t0
      tstart = t0                 ! for common block
      read(inunit,*) xlower
      read(inunit,*) xupper
      read(inunit,*) ylower
      read(inunit,*) yupper
      read(inunit,*) zlower
      read(inunit,*) zupper

      read(inunit,*) nghost
      read(inunit,*) mthbc(1)
      read(inunit,*) mthbc(2)
      read(inunit,*) mthbc(3)
      read(inunit,*) mthbc(4)
      read(inunit,*) mthbc(5)
      read(inunit,*) mthbc(6)

      xperdom = (mthbc(1).eq.2 .and. mthbc(2).eq.2)
      yperdom =  (mthbc(3).eq.2 .and. mthbc(4).eq.2)
      zperdom =  (mthbc(5).eq.2 .and. mthbc(6).eq.2)

      if ((mthbc(1).eq.2 .and. mthbc(2).ne.2) .or.
     &    (mthbc(2).eq.2 .and. mthbc(1).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions: '
         write(6,*) '  mthbc(1) and mthbc(2) must BOTH be set to 2'
         stop
      endif

      if ((mthbc(3).eq.2 .and. mthbc(4).ne.2) .or.
     &    (mthbc(4).eq.2 .and. mthbc(3).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions: '
         write(6,*) '  mthbc(3) and mthbc(4) must BOTH be set to 2'
         stop
      endif

      if ((mthbc(5).eq.2 .and. mthbc(6).ne.2) .or.
     &    (mthbc(6).eq.2 .and. mthbc(5).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions: '
         write(6,*) '  mthbc(5) and mthbc(6) must BOTH be set to 2'
         stop
      endif

      if (outstyle.eq.1) then
	   do i=1,nout
	      tout(i) = t0 + i*(tfinal-t0)/float(nout)
	      enddo
           endif

c     restart and checkpointing
      read(inunit,*) rest
      read(inunit,*) ichkpt
c
c     refinement variables
      read(inunit,*) tol
      read(inunit,*) tolsp
      read(inunit,*) kcheck
      read(inunit,*) ibuff
      read(inunit,*) cut
c
c     style of output
c
      read(inunit,*) printout
      read(inunit,*) ncarout
      read(inunit,*) matlabout
c
c
c     # read verbose/debugging flags
      read(inunit,*) dprint
      read(inunit,*) eprint
      read(inunit,*) edebug
      read(inunit,*) gprint
      read(inunit,*) nprint
      read(inunit,*) pprint
      read(inunit,*) rprint
      read(inunit,*) sprint
      read(inunit,*) tprint
      read(inunit,*) uprint
c
c     # close input file
      close(inunit)

c     # look for capacity function via auxtypes:
      mcapa = 0
      do 20 iaux = 1, naux
        if (auxtype(iaux) .eq. "capacity") then
          if (mcapa .ne. 0) then
            write(*,*)" only 1 capacity allowed"
            stop
          else
            mcapa = iaux
          endif
        endif

c       # change to Version 4.1 terminology:
        if (auxtype(iaux) .eq. "leftface") auxtype(iaux) = "xleft"
        if (auxtype(iaux) .eq. "frontface") auxtype(iaux) = "yleft"
        if (auxtype(iaux) .eq. "bottomface") auxtype(iaux) = "zleft"

        if (.not. (auxtype(iaux) .eq."xleft" .or.
     .             auxtype(iaux) .eq. "yleft".or.
     .             auxtype(iaux) .eq. "zleft".or.
     .             auxtype(iaux) .eq. "capacity".or.
     .             auxtype(iaux) .eq. "center"))  then
                  write(*,*)" unknown type for auxiliary variables"
                  write(6,*) auxtype(iaux)
                  write(*,*)" use  xleft/yleft/zleft/center/capacity"
                  stop
        endif
   20   continue

c     ::: error checking of input data :::::::::::::::::::::::

      if (mcapa .ne. mcapa1) then
         write(outunit,*) 'Error ***  mcapa does not agree with auxtype'
         write(*,*) 'Error ***  mcapa does not agree with auxtype'
         stop
         endif


      if (nvar .gt. maxvar) then
         write(outunit,*) 'Error ***   nvar > maxvar in common'
         write(*,*)       'Error ***   nvar > maxvar in common'
         stop
         endif
      if (2*nghost .gt. min(nx,ny,nz)) then
         mindim = 2*nghost
         write(outunit,*) 'Error ***   need finer domain >',
     .         mindim, ' cells'
         write(*,*)       'Error ***   need finer domain >',
     .         mindim, ' cells'
         stop
         endif
      if (mcapa .gt. naux) then
         write(outunit,*) 'Error ***   mcapa > naux in input file'
         write(*,*)       'Error ***   mcapa > naux in input file'
         stop
         endif
      if (.not. vtime .and. nout .ne. 0) then
         write(outunit,*)' cannot specify output times with fixed dt'
         write(*,*)      ' cannot specify output times with fixed dt'
         stop
         endif
c
c
      if (ncarout)
     .   open(pltunit1,file=pltfile,status='unknown',form='formatted')
c

c     # call user routine to set up problem parameters:

      call setprob()
c
      matlabu   = 0
      hxposs(1) = (xupper - xlower) / nx
      hyposs(1) = (yupper - ylower) / ny
      hzposs(1) = (zupper - zlower) / nz
      cflmax = 0.d0
c
c
c
      if (rest) then
         call restrt(nsteps,time,nvar)
         nstart  = nsteps
         write(6,*) ' '
         write(6,*) 'Restarting from previous run'
         write(6,*) '   at time = ',time
         write(6,*) ' '
      else
         lentot = 0
         lenmax = 0
         lendim = 0
         rvol   = 0.0d0
         do 8 i   = 1, mxnest
 8         rvoll(i) = 0.0d0
         evol   = 0.0d0
         call   stst1
         call   domain (nvar,vtime,nx,ny,nz,naux,t0)
         call   setgrd (nvar,cut,naux,dtinit,t0)       
         if (possk(1) .gt. dtinit*cflv1/cfl .and. vtime) then
c        ## initial time step was too large. reset to dt from setgrd
              write(6,*) "*** Initial time step reset for desired cfl"
              possk(1) = dtinit
              do i = 2, mxnest-1
                 possk(i) = possk(i-1)*kratio(i-1)
              end do
         endif

         time = t0
         nstart = 0
      endif

!$    write(outunit,*)" max threads set to ",omp_get_max_threads()
!$    write(*,*)" max threads set to ",omp_get_max_threads()
c
c  print out program parameters for this run
c
      write(outunit,107)tol,tolsp,iorder,kcheck,ibuff,nghost,cut,
     1            mxnest,ichkpt,cfl
      write(outunit,109) xupper,yupper,zupper,
     &      xlower,ylower,zlower,nx,ny, nz
      write(outunit,139)(intratx(i),i=1,mxnest)
      write(outunit,139)(intraty(i),i=1,mxnest)
      write(outunit,139)(intratz(i),i=1,mxnest)
      write(outunit,119) naux
      write(outunit,129) (iaux,auxtype(iaux),iaux=1,naux)
      if (mcapa .gt. 0) write(outunit,149) mcapa
107   format(/
     *       ' amrclaw parameters:',//,
     *       ' error tol            ',e12.5,/,
     *       ' spatial error tol    ',e12.5,/,
     *       ' order of integrator     ',i9,/,
     *       ' error checking interval ',i9,/,
     *       ' buffer zone size        ',i9,/,
     *       ' nghost                  ',i9,/,
     *       ' volume ratio cutoff  ',e12.5,/,
     *       ' max. refinement level   ',i9,/,
     *       ' user sub. calling times ',i9,/,
     *       ' cfl # (if var. delt) ',e12.5,/)
109   format(' xupper(upper corner) ',e12.5,/,
     *       ' yupper(upper corner) ',e12.5,/,
     *       ' zupper(upper corner) ',e12.5,/,
     *       ' xlower(lower corner) ',e12.5,/,
     *       ' ylower(lower corner) ',e12.5,/,
     *       ' zlower(lower corner) ',e12.5,/,
     *       ' nx = no. cells in x dir.',i9,/,
     *       ' ny = no. cells in y dir.',i9,/,
     *       ' nz = no. cells in z dir.',i9,/,/)
139   format(' refinement ratios:      ',6i5,/)
119   format(' no. auxiliary vars.     ',i9)
129   format('       var ',i5,' of type ', a10)
149   format(' capacity fn. is aux. var',i9)
c
      write(6,*) ' '
      write(6,*) 'running amr3ez...  '
      write(6,*) ' '

      call outtre (mstart,printout,nvar,naux)
      write(outunit,*) "  original total mass ..."
      call conck(1,nvar,naux,time,rest)
      call valout(1,lfine,time,nvar,naux)

      ! Timing 
      call system_clock(clock_start,clock_rate)
c
c     --------------------------------------------------------
c     # tick is the main routine which drives the computation:
c     --------------------------------------------------------
      call tick(nvar,iout,nstart,nstop,cut,vtime,time,ichkpt,naux,
     &          nout,tout,rest,dt_max)
c     --------------------------------------------------------

      call system_clock(clock_finish,clock_rate)
      write(outunit,800) dble(clock_finish-clock_start)
     &                  /dble(clock_rate)
 800  format("Total time to solution = ",f16.8," s")

      do level = 1, mxnest
         write(outunit,801) level,tvoll(level)/clock_rate
         write(*,801) level,tvoll(level)/clock_rate
 801     format("Total advanc time on level ",i3," = ",f16.8," s")
      end do

c     # Done with computation, cleanup:

      lentotsave = lentot
      call cleanup(nvar,naux)
      if (lentot .ne. 0) then
        write(outunit,*) lentot," words not accounted for ",
     &                   "in memory cleanup"
        write(*,*)        lentot," words not accounted for ",
     &                   "in memory cleanup"
      endif
c
c report on statistics
c
      open(matunit,file=matfile,status='unknown',form='formatted')
      write(matunit,*) matlabu-1
      write(matunit,*) mxnest
      close(matunit)

      write(outunit,*)
      write(outunit,*)
      do i = 1, mxnest
        if (iregridcount(i) > 0) then
          write(outunit,802) i,avenumgrids(i)/iregridcount(i),
     1                       iregridcount(i)
 802      format("for level ",i3, " average num. grids = ",f10.2,
     1           " over ",i10," steps")
        endif
      end do

      write(outunit,*)
      write(outunit,*)
      write(outunit,901) lentotsave
      write(outunit,902) lenmax
      write(outunit,903) lendim

      write(outunit,904) rvol
      do 60 level = 1,mxnest
 60     write(outunit,905) level, rvoll(level)

      write(outunit,906) evol
      if (evol+rvol .gt. 0.) then
         ratmet = rvol / (evol+rvol) * 100.0d0
      else
         ratmet = 0.0d0
      endif
      write(outunit,907) ratmet
      write(outunit,908) cflmax

 901  format('current  space usage = ',i12)
 902  format('maximum  space usage = ',i12)
 903  format('need space dimension = ',i12,/)
 904  format('number of cells advanced for time integration = ',f20.6)
 905  format(3x,'# cells advanced on level ',i4,' = ',f20.2)
 906  format('number of cells advanced for error estimation = ',f20.6,/)
 907  format(' percentage of cells advanced in time  = ', f10.2)
 908  format(' maximum Courant number seen = ', f10.2)
c
      write(outunit,909)
 909  format(//,' ------  end of AMRCLAW integration --------  ')
c
c     # Close output and debug files.
      close(outunit)
      close(dbugunit)
c
      stop
      end

c :::::::::::::::::::::: CSHIFT :::::::::::::::::::::::::::::::
!> For an input grid, flag cells near the previously flagged cells for
!! creating buffer zone.
!!
!! Shift by + or - 1 in either direction to do 
!! bitwise calculus for proper nesting, buffering, etc.
!! similar to cshift on CM machine.
!! includes periodic buffering as well.
!!
!! NEWER VERSION: DOES ALL DIRS AT SAME TIME
!! rectflags array has been augmented by enough border
!!           cells to do buffering in place in the grid
!! later will look to see if flagged pts are properly nested
!!
!! \param rectflags array to be flagged 
!! \param ilo global *i* index of the left border of the grid being projected to (being flagged) 
!! \param ihi global *i* index of the right border of the grid being projected to (being flagged) 
!! \param jlo global *j* index of the lower border of the grid being projected to (being flagged) 
!! \param jhi global *i* index of the upper border of the grid being projected to (being flagged) 
!! \param mbuff width of the buffer zone
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c ----------------------------------------------------------
c
       subroutine shiftset2(rectflags,ilo,ihi,jlo,jhi,mbuff)

       use amr_module
       implicit double precision (a-h, o-z)
       dimension rectflags(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)
       dimension copyflags(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)

       do j = jlo-mbuff, jhi+mbuff
       do i = ilo-mbuff, ihi+mbuff
          copyflags(i,j) = 0
       end do
       end do

c  note: not looking at ghost cells, only real cells should be flagged
c  but can buffer the flags into the ghost zone
       do j = jlo, jhi
       do i = ilo, ihi
          rflag = rectflags(i,j)
          if (rflag .gt. 0)  then
c            cell is flagged, buffer in all dirs by ibuff
c            (note this is not nec same as mbuff)
c            use second array to avoid propagation
             mlo = i - ibuff
             mhi = i + ibuff
             klo = j - ibuff
             khi = j + ibuff
             do k = klo, khi 
             do m = mlo, mhi
                copyflags(m,k) = rflag  ! copy the flag (doesnt distinguish buffer flag from orig flag)
             end do
             end do
          endif

       end do
       end do


c   copy back. need flags in original array, not temp scratch array

       do j = jlo-mbuff, jhi+mbuff
       do i = ilo-mbuff, ihi+mbuff
         rectflags(i,j) = copyflags(i,j)
       end do
       end do


       return
       end

c
!> set domain flags (not AMR flags) for grid **mptr** (only), enlarged by buffer zone. 
!!
!! \param mptr number (index) of the grid being processed
!! \param igridflags pointer to memory address storing domain flags (not
!! AMR flags)
!! \param ilo global *i* index of left-most cell of this grid
!! \param ihi global *i* index of right-most cell of this grid 
!! \param jlo global *j* index of lower-most cell of this grid 
!! \param jhi global *j* index of upper-most cell of this grid 
!! \param mbuff width of buffer zone
!! \param lbase base AMR level for current refinement, which stays
!!  fixed. Note that **lbase** is always less or equal to **lcheck**
!! \param lcheck AMR level of grid **mptr**
!! \param mibuff number of cells (including buffer zone) on grid
!! **mptr** in *i* direction 
!! \param mjbuff number of cells (including buffer zone) on grid
!! **mptr** in *j* direction 

c -----------------------------------------------------------------------------------
c
      subroutine setdomflags(mptr,igridflags,ilo,ihi,jlo,jhi,
     .                       mbuff,lbase,lcheck,mibuff,mjbuff)

      use amr_module

      integer*1 igridflags(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)
c icopy is dimensioned large enough, but will be used at several sizes
c and accessed using lo_i-mbuff:hi_i+mbuff, etc.      
c
      integer*1 icopy(mibuff,mjbuff) 
      dimension ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)
      dimension igridst(lcheck), igridend(lcheck)
      dimension jgridst(lcheck), jgridend(lcheck)
      logical borderx, bordery

c
c set domain flags for this grid only, enlarged by buffer zone. check if any other base grids
c are in exterior or first interior border cell and mark ok.
c note that interior of base grids 1 away from edge are automatically ok for proper nesting
c  will shrink gridflags after setting to get proper nesting region
c
c  1. initialize this grids domain flags to 0, at lcheck
        igridflags = 0
c
c    ... if lbase coarse than lcheck, set initial indices, before upscaling, for base transfer
c        so that dont have entire base grid upscaled
         igridst(lcheck)  = ilo
         igridend(lcheck) = ihi
         jgridst(lcheck)  = jlo
         jgridend(lcheck) = jhi
         do lc = lcheck-1,lbase,-1  !NB: may be a 0 trip do loop, not old fortran
            ilo_coarse = floor(dfloat(igridst(lc+1))/intratx(lc))
            jlo_coarse = floor(dfloat(jgridst(lc+1))/intraty(lc))
            ihi_coarse = ceiling(dfloat(igridend(lc+1))/intratx(lc)) - 1
            jhi_coarse = ceiling(dfloat(jgridend(lc+1))/intraty(lc)) - 1
            if (ihi_coarse*intratx(lc) .lt. igridend(lc+1)) 
     .           ihi_coarse = ihi_coarse+1
            if (jhi_coarse*intraty(lc) .lt. jgridend(lc+1)) 
     .           jhi_coarse = jhi_coarse+1
            igridend(lc) = ihi_coarse
            jgridend(lc) = jhi_coarse
            igridst(lc) = ilo_coarse
            jgridst(lc) = jlo_coarse
         end do
!       get out coarsened indices in case level lbase == lcheck (zero trip loop)
         ilo_coarse = igridst(lbase)
         ihi_coarse = igridend(lbase)
         jlo_coarse = jgridst(lbase)
         jhi_coarse = jgridend(lbase)
    ! If we project grid mptr to level "lbase" to get a grid on that
    ! level, ilo_coarse is global index of its left border and similarly
    ! for other three

c
c  3.  loop over all intersecting grids at base level staying fixed
c      to make the proper nesting dodmain.
c      set the buffer zone in igridflags to 1 if nested 
c      this is so when shrink by one you dont lose too much area.
c
        mbase = lstart(lbase)
 20     continue        
        
           iblo = node(ndilo,mbase)   ! if base grid coarser, need to scale up
           ibhi = node(ndihi,mbase)   ! if same grid will just mark interior cells as 1
           jblo = node(ndjlo,mbase)
           jbhi = node(ndjhi,mbase)
c
c  3.5 if periodic bcs, then if grids buffer sticks out, will have to wrap the
c      coordinates and flag any intersecting base grids for wrapped  buffer.
c      do here instead of above since cant coarsen mbuff same way you can for regular grid
c      also grid itself (without enlarged mbuff zone) doesnt stick out

        borderx = (ilo_coarse.le. 0 .or. ihi_coarse.ge.iregsz(lbase)-1)
        bordery = (jlo_coarse.le. 0 .or. jhi_coarse.ge.jregsz(lbase)-1)
        if ((xperdom .and. borderx) .or. (yperdom .and. bordery)) then   
           call setIndices(ist,iend,jst,jend,
     .                     ilo_coarse-mbuff,ihi_coarse+mbuff,
     .                     jlo_coarse-mbuff,jhi_coarse+mbuff,
     .                     ishift,jshift,lbase)
 
           do 25 i = 1, 3
               i1 = max(ilo_coarse-mbuff,ist(i))
               i2 = min(ihi_coarse+mbuff,iend(i))
           do 24 j = 1, 3
               j1 = max(jlo_coarse-mbuff,jst(j))
               j2 = min(jhi_coarse+mbuff, jend(j))

               if (.not. ((i1 .le. i2) .and. (j1 .le. j2))) go to 24 ! part of patch in this region
c
c              part of patch is in this region [i,j]
c              periodically wrap and fill if it intersects with grid mbase
c              note: this is done in two steps in hopes of greater clarity
               

c usual check would be ->  if ((i1 .gt. i2) .or. (j1 .gt. j2)) go to 24  ! no patch
c cant do that since have not yet included buffer zone - which is the part that would get wrapped

c             patch exist. does it intersect with mbase grid?
c             use wrapped coords of this grid to test if intersects with base grid
              ixlo = max(iblo,i1+ishift(i)) 
              ixhi = min(ibhi,i2+ishift(i))
              jxlo = max(jblo,j1+jshift(j))
              jxhi = min(jbhi,j2+jshift(j))
c
              if ((ixlo .gt. ixhi) .or. (jxlo .gt. jxhi)) go to 24  !this grid doesnt intersect
c
c             if wrapped region does intersect, be careful to set the INTERSECTED part of
c             the UNWRAPPED region  of original enlarged grid
              ixlo_unwrapped = ixlo - ishift(i)   
              ixhi_unwrapped = ixhi - ishift(i)
              jxlo_unwrapped = jxlo - jshift(j)
              jxhi_unwrapped = jxhi - jshift(j)
              call coarseGridFlagSet(igridflags,
     .                               ixlo_unwrapped,ixhi_unwrapped,
     .                               jxlo_unwrapped,jxhi_unwrapped,
     .                               ilo_coarse,ihi_coarse,
     .                               jlo_coarse,jhi_coarse,mbuff)

 24        continue
 25        continue

       else       
           ixlo = max(iblo,ilo_coarse-mbuff)
           ixhi = min(ibhi,ihi_coarse+mbuff)
           jxlo = max(jblo,jlo_coarse-mbuff)
           jxhi = min(jbhi,jhi_coarse+mbuff)
c
c         does this patch intersect mbase grid?
           if (.not.((ixlo .le. ixhi) .and. (jxlo .le. jxhi))) go to 30  !this grid doesnt intersect
c
c          use subroutine call since dimension of igridflags not same as above declaration
c          when on coarser grids
           call coarseGridFlagSet(igridflags,ixlo,ixhi,jxlo,jxhi,
     .                           ilo_coarse,ihi_coarse,
     .                           jlo_coarse,jhi_coarse,mbuff)
       endif

 30     mbase = node(levelptr,mbase)
        if (mbase .ne. 0) go to 20
c
c 3.5 set any part of grid buffer zone to 1 that is at physical boundary 
        call setPhysBndryFlags(igridflags,ilo_coarse,ihi_coarse,
     .                         jlo_coarse,jhi_coarse,mbuff,lbase)

c  4.  done setting flags on base level. next step is to transfer the
c      properly nested domain flags to lcheck - i.e. upscale to level needed 
c      first shrink by 1 for actual nested region.
c      always shrink once - so works if lcheck same as lbase
c      if going up 1 level each one needs to be nested, so still shrink first before upsizing
c
c      after loop above, dom flags in igridflags, copy to icopy (in subr for dimensioning reasons)
      call griddomcopy(icopy,igridflags,ilo_coarse,ihi_coarse,
     .                 jlo_coarse,jhi_coarse,mbuff)
c
c     shrink from icopy to dom2 flag array. This is where shrinking occurs if
c     lbase = lcheck, for proper nesting
      call griddomshrink(icopy,ilo_coarse,ihi_coarse,jlo_coarse,
     .                     jhi_coarse,mbuff,
     .                     alloc(node(domflags2,mptr)),lbase)

      do 40 lev = lbase+1, lcheck
c         ### for each level that upsize, calculate new coords starting from
c         ### actual fine grid and recoarsening down to needed level
c         ### cant take previous coarse coords and refine, since may be
c         ### too large. grid prob. not anchored at base grid corner.
         ilo_fine = igridst(lev)
         ihi_fine = igridend(lev)
         jlo_fine = jgridst(lev)
         jhi_fine = jgridend(lev)
c
c       flags in dom2, upsize to icopy array with finer dimensions
        call griddomup(alloc(node(domflags2,mptr)),icopy,
     .                 ilo_coarse,ihi_coarse,jlo_coarse,jhi_coarse,
     .                 mbuff,lev-1,
     .                 ilo_fine,ihi_fine,jlo_fine,jhi_fine)
c       flags in icopy, shrink one  back to dom2
        call griddomshrink(icopy,ilo_fine,ihi_fine,jlo_fine,jhi_fine,
     .                     mbuff,alloc(node(domflags2,mptr)),lev)
        ilo_coarse = ilo_fine
        ihi_coarse = ihi_fine
        jlo_coarse = jlo_fine
        jhi_coarse = jhi_fine
40    continue
c 
        return
        end

c
c
c
c     =================================================
      function zeroin(ax,bx,f,tol)        
c     =================================================
      implicit double precision (a-h,o-z)
      external f
c  
c      a zero of the function  f(x)  is computed in the interval ax,bx .
c      (Standard routine from netlib)
c  
c  input..    
c  
c  ax     left endpoint of initial interval    
c  bx     right endpoint of initial interval   
c  f      function subprogram which evaluates f(x) for any x in      
c         the interval  ax,bx       
c  tol    desired length of the interval of uncertainty of the       
c         final result ( .ge. 0.d0)  
c  
c  
c  output..   
c  
c  zeroin abcissa approximating a zero of  f  in the interval ax,bx  
c  
c  
c      it is assumed  that   f(ax)   and   f(bx)   have  opposite  signs
c  without  a  check.  zeroin  returns a zero  x  in the given interval 
c  ax,bx  to within a tolerance  4*macheps*dabs(x) + tol, where macheps 
c  is the relative machine precision.          
c
c      this function subprogram is a slightly  modified  translation  of
c  the algol 60 procedure  zero  given in  richard brent, algorithms for
c  minimization without derivatives, prentice - hall, inc. (1973).   
c  
c  
c  
c  compute eps, the relative machine precision 
c  
      eps = 1.d0          
   10 eps = eps/2.d0      
      tol1 = 1.d0 + eps   
      if (tol1 .gt. 1.d0) go to 10   
c  
c initialization         
c  
      a = ax  
      b = bx  
      fa = f(a)          
      fb = f(b)          
c  
c begin step  
c  
   20 c = a   
      fc = fa 
      d = b - a          
      e = d   
   30 if (dabs(fc) .ge. dabs(fb)) go to 40       
      a = b   
      b = c   
      c = a   
      fa = fb 
      fb = fc 
      fc = fa 
c  
c convergence test       
c  
   40 tol1 = 2.d0*eps*dabs(b) + 0.5*tol          
      xm = .5*(c - b)    
      if (dabs(xm) .le. tol1) go to 90          
      if (fb .eq. 0.d0) go to 90     
c  
c is bisection necessary 
c  
      if (dabs(e) .lt. tol1) go to 70
      if (dabs(fa) .le. dabs(fb)) go to 70       
c  
c is quadratic interpolation possible          
c  
      if (a .ne. c) go to 50        
c  
c linear interpolation   
c  
      s = fb/fa          
      p = 2.d0*xm*s       
      q = 1.d0 - s        
      go to 60
c  
c inverse quadratic interpolation   
c  
   50 q = fa/fc          
      r = fb/fc          
      s = fb/fa          
      p = s*(2.d0*xm*q*(q - r) - (b - a)*(r - 1.d0))        
      q = (q - 1.d0)*(r - 1.d0)*(s - 1.d0)        
c  
c adjust signs
c  
   60 if (p .gt. 0.d0) q = -q        
      p = dabs(p)         
c  
c is interpolation acceptable       
c  
      if ((2.d0*p) .ge. (3.d0*xm*q - dabs(tol1*q))) go to 70 
      if (p .ge. dabs(0.5*e*q)) go to 70        
      e = d   
      d = p/q 
      go to 80
c  
c bisection   
c  
   70 d = xm  
      e = d   
c  
c complete step          
c  
   80 a = b   
      fa = fb 
      if (dabs(d) .gt. tol1) b = b + d          
      if (dabs(d) .le. tol1) b = b + dsign(tol1, xm)        
      fb = f(b)          
      if ((fb*(fc/dabs(fc))) .gt. 0.d0) go to 20 
      go to 30
c  
c done        
c  
   90 zeroin = b         
      return  
      end     

c
c --------------------------------------------------------------
c
      subroutine advanc (level,nvar,dtlevnew,vtime,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)


      logical    vtime
      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      integer listgrids(numgrids(level))
      integer clock_start, clock_finish, clock_rate
      integer clock_startStepgrid,clock_startBound,clock_finishBound
      real(kind=8) cpu_start,cpu_finish,cpu_startBound
      real(kind=8) cpu_startStepgrid,cpu_finishBound

c     maxgr is maximum number of grids  many things are
c     dimensioned at, so this is overall. only 1d array
c     though so should suffice. problem is
c     not being able to dimension at maxthreads


c
c  ::::::::::::::; ADVANC :::::::::::::::::::::::::::::::::::::::::::
c  integrate all grids at the input  'level' by one step of its delta(t)
c  this includes:  setting the ghost cells 
c                  advancing the solution on the grid
c                  adjusting fluxes for flux conservation step later
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c get start time for more detailed timing by level
      call system_clock(clock_start,clock_rate)
      call cpu_time(cpu_start)
       
      hx   = hxposs(level)
      hy   = hyposs(level)
      hz   = hzposs(level)
      delt = possk(level)
c     Lay out linked list into array for easier parallelization
c     call prepgrids(listgrids,numgrids(level),level)
c

      call system_clock(clock_startBound,clock_rate)
      call cpu_time(cpu_startBound)
      
c     maxthreads initialized to 1 above in case no openmp
!$    maxthreads = omp_get_max_threads()

c     New code based on 2D
!$OMP PARALLEL DO PRIVATE(j, locnew, locaux, mptr, nx, ny, nz, 
!$OMP&                    mitot, mjtot, mktot,time,levSt),
!$OMP&            SHARED(level, nvar, naux, alloc, intrat, delt,
!$OMP& listOfGrids,listStart,nghost, node, rnode, numgrids, listgrids)
!$OMP&            SCHEDULE(dynamic,1),
!$OMP&            DEFAULT(none)
      do j = 1, numgrids(level)
         !mptr   = listgrids(j)
         levSt = listStart(level)
         mptr   = listOfGrids(levSt+j-1)
         !write(*,*)"old ",listgrids(j)," new",mptr
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
         mitot  = nx + 2*nghost
         mjtot  = ny + 2*nghost
         mktot  = nz + 2*nghost
         locnew = node(store1,mptr)
         locaux = node(storeaux,mptr)
         time   = rnode(timemult,mptr)
c     
         call bound(time,nvar,nghost,alloc(locnew),mitot,mjtot,mktot,
     1              mptr,alloc(locaux),naux)

       end do
!$OMP END PARALLEL DO
      call system_clock(clock_finishBound,clock_rate)
      call cpu_time(cpu_finishBound)
      timeBound=timeBound+clock_finishBound-clock_startBound
      timeBoundCPU=timeBoundCPU+cpu_finishBound-cpu_startBound
      
c
c save coarse level values if there is a finer level for wave fixup
      if (level+1 .le. mxnest) then
         if (lstart(level+1) .ne. null) then
            call saveqc(level+1,nvar,naux)
         endif
      endif
c
      dtlevnew = rinfinity
      cfl_level = 0.d0    !# to keep track of max cfl seen on each level
      cflmax = 0.d0    !# added by rjl 6/17/05 to keep track of cfl on level
c

      call system_clock(clock_startStepgrid,clock_rate)
      call cpu_time(cpu_startStepgrid)

!$OMP PARALLEL DO PRIVATE(j,mptr,nx,ny,nz,mitot,mjtot,mktot,
!$OMP&                    dtnew, mythread,maxthreads,levSt),
!$OMP&            SHARED(rvol,rvoll,level,nvar,mxnest,alloc,intrat)
!$OMP&            SHARED(nghost,intratx,intraty,intratz,hx,hy,hz)
!$OMP&            SHARED(naux,listsp,node,rnode,dtlevnew)
!$OMP&            SHARED(numgrids,listgrids,listStart,listOfGrids)
!$OMP&            SCHEDULE (dynamic,1)
!$OMP&            DEFAULT(none)
      do j = 1, numgrids(level)
         !mptr   = listgrids(j)
         levSt = listStart(level)
         mptr = listOfGrids(levSt+j-1)
         nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
c
         mitot  = nx + 2*nghost
         mjtot  = ny + 2*nghost
         mktot  = nz + 2*nghost
c
          call par_advanc(mptr,mitot,mjtot,mktot,nvar,naux,dtnew)
!$OMP CRITICAL (newdt)
          dtlevnew = dmin1(dtlevnew,dtnew)
!$OMP END CRITICAL (newdt)    

      end do
!$OMP END PARALLEL DO
c
      call system_clock(clock_finish,clock_rate)
      call cpu_time(cpu_finish)
      tvoll(level) = tvoll(level) + clock_finish - clock_start
      tvollCPU(level)=tvollCPU(level)+cpu_finish-cpu_start
      timeStepgrid=timeStepgrid+clock_finish-clock_startStepgrid
      timeStepgridCPU=timeStepgridCPU+cpu_finish-cpu_startStepgrid
      
      
      cflmax = dmax1(cflmax,cfl_level)

c
      return
      end
c
c -------------------------------------------------------------
c
       subroutine prepgrids(listgrids, num, level)

       use amr_module
       implicit double precision (a-h,o-z)
       integer listgrids(num)

       mptr = lstart(level)
       do j = 1, num
          listgrids(j) = mptr
          mptr = node(levelptr, mptr)
       end do

      if (mptr .ne. 0) then
         write(*,*)" Error in routine setting up grid array "
         stop
      endif

      return
      end

c
c --------------------------------------------------------------
c
      subroutine par_advanc (mptr,mitot,mjtot,mktot,nvar,naux,dtnew)
c
      use amr_module
      use gauges_module, only: update_gauges, num_gauges
      implicit double precision (a-h,o-z)


      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/

      double precision fp(nvar,mitot,mjtot,mktot),
     &                 fm(nvar,mitot,mjtot,mktot),
     &                 gp(nvar,mitot,mjtot,mktot),
     &                 gm(nvar,mitot,mjtot,mktot),
     &                 hp(nvar,mitot,mjtot,mktot),
     &                 hm(nvar,mitot,mjtot,mktot)


c
c  :::::::::::::: PAR_ADVANC :::::::::::::::::::::::::::::::::::::::::::
c  integrate this grid. grids are done in parallel.
c  extra subr. used to allow for stack based allocation of
c  flux arrays. They are only needed temporarily. If used alloc
c  array for them it has too long a lendim, makes too big
c  a checkpoint file, and is a big critical section.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
      hz    = hzposs(level)
      delt  = possk(level)
      nx    = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny    = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      nz    = node(ndkhi,mptr) - node(ndklo,mptr) + 1
      time  = rnode(timemult,mptr)


      locold = node(store2, mptr)
      locnew = node(store1, mptr)

c
c  copy old soln. values into  next time step's soln. values
c  since integrator will overwrite it. only for grids not at
c  the finest level. finest level grids do not maintain copies
c  of old and new time solution values.
c
         if (level .lt. mxnest) then
            ntot = mitot * mjtot * mktot * nvar
cdir$ ivdep
            do i = 1, ntot
               alloc(locold + i - 1) = alloc(locnew + i - 1)
            end do
         endif
c
         xlow = rnode(cornxlo,mptr) - nghost*hx
         ylow = rnode(cornylo,mptr) - nghost*hy
         zlow = rnode(cornzlo,mptr) - nghost*hz

!$OMP CRITICAL(rv)
         rvol = rvol + nx * ny * nz
         rvoll(level) = rvoll(level) + nx * ny * nz
!$OMP END CRITICAL(rv)


         locaux = node(storeaux,mptr)
c
         if (node(ffluxptr,mptr) .ne. 0) then
            lenbc  = 2*( (nx/intratx(level-1))*(nz/intratz(level-1))
     &                +(ny/intraty(level-1))*(nz/intratz(level-1))
     &                +(nx/intratx(level-1))*(ny/intraty(level-1)))

            locsvf = node(ffluxptr,mptr)
            locsvq = locsvf + nvar*lenbc
            locx1d = locsvq + nvar*lenbc
            call qad(alloc(locnew),mitot,mjtot,mktot,nvar,
     1             alloc(locsvf),alloc(locsvq),lenbc,
     2             intratx(level-1),intraty(level-1),intratz(level-1),
     3             hx,hy,hz,naux,alloc(locaux),alloc(locx1d),delt,mptr)
         endif

c        # See if the grid about to be advanced has gauge data to output.
c        # This corresponds to previous time step, but output done
c        # now to make linear interpolation easier, since grid
c        # now has boundary conditions filled in.

c     should change the way print_gauges does io - right now is critical section

      if (num_gauges > 0) then
         call update_gauges(alloc(locnew:locnew+nvar*mitot*mjtot*mktot),
     .                     alloc(locaux:locaux+naux*mitot*mjtot*mktot),
     .                     xlow,ylow,zlow,nvar,mitot,mjtot,mktot,
     .                     naux,mptr)
         endif

         if (dimensional_split .eq. 0) then
c           # Unsplit method
            call stepgrid(alloc(locnew),
     1                   fm,fp,gm,gp,hm,hp,
     4                   mitot,mjtot,mktot,nghost,
     5                   delt,dtnew,hx,hy,hz,nvar,
     6                   xlow,ylow,zlow,time,mptr,naux,alloc(locaux))
 
         else if (dimensional_split .eq. 1) then
c           # Godunov splitting
            call stepgrid_dimSplit(alloc(locnew),
     1                   fm,fp,gm,gp,hm,hp,
     4                   mitot,mjtot,mktot,nghost,
     5                   delt,dtnew,hx,hy,hz,nvar,
     6                   xlow,ylow,zlow,time,mptr,naux,alloc(locaux))
         else 
c           # should never get here due to check in amr2
            write(6,*) '*** Strang splitting not supported'
            stop
         endif


         if (node(cfluxptr,mptr) .ne. 0) then
            call fluxsv(mptr,fm,fp,gm,gp,hm,hp,
     2                  alloc(node(cfluxptr,mptr)),mitot,mjtot,mktot,
     6                  nvar,listsp(level),delt,hx,hy,hz)
         endif
 
         if (node(ffluxptr,mptr) .ne. 0) then
            lenbc = 2*( (nx/intratx(level-1))*(nz/intratz(level-1))
     &                 +(ny/intraty(level-1))*(nz/intratz(level-1))
     &                 +(nx/intratx(level-1))*(ny/intraty(level-1)))
            locsvf = node(ffluxptr,mptr)
            call fluxad(fm,fp,gm,gp,hm,hp,
     3                  alloc(locsvf),mptr,mitot,mjtot,mktot,nvar,
     4                  lenbc,intratx(level-1),intraty(level-1),
     5                  intratz(level-1),nghost,delt,hx,hy,hz)
         endif

         rnode(timemult,mptr)  = rnode(timemult,mptr)+delt
c
      return
      end

!> Compute enclosing rectangle around flagged points.
!! save some info., even tho. usage might be low and rect. scrapped.
!! 
!! \param[in] badpts  x,y coords of cells around which a rectangle 
!! is to be made and compute efficiency on
!! \param[in] npt     num. of badpts. in the cluster.
!! \param[out] usage   ratio of flagged to unflagged badpts. in new grid
!!                measures goodness of fit and clustering
!! \param[out] intrect stores some info. for grid created herein.
!!                sometimes rect = rnode, sometimes = temp. array.
!!                sometimes intrect = node.
!!                depending on calling prog. (grdfit or expand)

subroutine moment(intrect, badpts, npt, usage)
    !
    ! :::::::::::::::::::::::: MOMENT ::::::::::::::::::::::::::::::::::
    !  moment = compute enclosing rectangle around flagged points.
    !  save some info., even tho. usage might be low and rect. scrapped.
    !
    ! input parameters:
    !     badpts      = x,y coords of flagged badpts grouped into clusters
    !                   are in the first two rows
    !     npt         = num. of badpts. in the cluster.
    !
    ! output parameters:
    !     usage       = ratio of flagged to unflagged badpts. in new grid
    !                   measures goodness of fit and clustering
    !    intrect( )    = stores some info. for grid created herein.
    !                   sometimes rect = rnode, sometimes = temp. array.
    !                   sometimes intrect = node.
    !                   depending on calling prog. (grdfit or expand)
    !
    !
    ! :::::::::::::::::::::::: MOMENT ::::::::::::::::::::::::::::::::::
    !

    use amr_module, only: ndilo, ndjlo, ndihi, ndjhi, nsize

    ! Input
    integer, intent(in) :: npt
    real(kind=8), intent(in) :: badpts(2, npt)
    integer, intent(in out) ::  intrect(nsize)
    real(kind=8), intent(out) :: usage

    ! Locals
    real(kind=8) :: e_min(2), e_max(2), side(2)

    ! Compute length of enclosing rectangles to include all flagged badpts
    do i = 1, 2
        e_min(i) = minval(badpts(i, :))
        e_max(i) = maxval(badpts(i, :))
    end do

    ! From length of the sides determine rect corners
    ! transform to cell numebrs (subtract 0.5)
    intrect(ndilo) = nint(e_min(1) - 0.5d0)
    intrect(ndjlo) = nint(e_min(2) - 0.5d0)
    intrect(ndihi) = nint(e_max(1) - 0.5d0)
    intrect(ndjhi) = nint(e_max(2) - 0.5d0)

    ! Compute usage
    side(1) = real(intrect(ndihi) - intrect(ndilo) + 1, kind=8)
    side(2) = real(intrect(ndjhi) - intrect(ndjlo) + 1, kind=8)
    usage = real(npt, kind=8) / (side(1) * side(2))

end subroutine moment

! ==============================================================================
!  This Riemann solver provides a harness for the point-wise evaluation of 
!  Riemann solutions and requires a point-wise definition of the Riemann solver
!  in a subroutine of the form "rp1_ptwise".
! ==============================================================================

subroutine rp1(maxm, meqn, mwaves, maux, mbc, mx, ql, qr, auxl, auxr, wave, s, amdq, apdq)

    implicit none

    ! Input
    integer, intent(in) :: maxm, meqn, mwaves, maux, mbc, mx
    real(kind=8), intent(in out) :: ql(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: qr(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: auxl(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: auxr(meqn, 1-mbc:maxm+mbc)

    ! Output
    real(kind=8), intent(in out) :: wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: s(mwaves,1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: apdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: amdq(meqn, 1-mbc:maxm+mbc)

    ! Locals
    integer :: i

    do i = 2 - mbc, mx + mbc

        call rp1_ptwise(meqn, maux, mwaves, qr(:, i - 1),       &
                                            ql(:, i),           &
                                            auxr(:, i - 1),         &
                                            auxl(:, i),     &
                                            wave(:, :, i),      &
                                            s(:, i),            &
                                            amdq(:, i),         &
                                            apdq(:, i))

    end do

end subroutine rp1

! =====================================================
subroutine flux2(ixy,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                 q1d,dtdx1d,aux1,aux2,aux3,method,mthlim, &
                 qadd,fadd,gadd,cfl1d,wave,s, &
                 amdq,apdq,cqxx,bmasdq,bpasdq,rpn2,rpt2,use_fwave)
! =====================================================

! Compute the modification to fluxes f and g that are generated by
! all interfaces along a 1D slice of the 2D patch.
! ixy = 1  if it is a slice in x
! 2  if it is a slice in y
! This value is passed into the Riemann solvers. The flux modifications
! go into the arrays fadd and gadd.  The notation is written assuming
! we are solving along a 1D slice in the x-direction.

! fadd(i,.) modifies F to the left of cell i
! gadd(i,.,1) modifies G below cell i
! gadd(i,.,2) modifies G above cell i

! The method used is specified by method(2:3):

! method(2) = 1 if only first order increment waves are to be used.
!           = 2 if second order correction terms are to be added, with
!                       a flux limiter as specified by mthlim.

! method(3) = 0 if no transverse propagation is to be applied.
!                       Increment and perhaps correction waves are propagated
!                       normal to the interface.
!           = 1 if transverse propagation of increment waves
!                       (but not correction waves, if any) is to be applied.
!           = 2 if transverse propagation of correction waves is also
!                       to be included.

! Note that if method(6)=1 then the capa array comes into the second
! order correction terms, and is already included in dtdx1d:
!     If ixy = 1 then
!        dtdx1d(i) = dt/dx                 if method(6) = 0
!                  = dt/(dx*capa(i,jcom))  if method(6) = 1
!     If ixy = 2 then
!        dtdx1d(j) = dt/dy                 if method(6) = 0
!                  = dt/(dy*capa(icom,j))  if method(6) = 1

! Notation:
!        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn2 into
!            amdq =  the left-going flux difference  A^- Delta q
!            apdq = the right-going flux difference  A^+ Delta q
!        Each of these is split by rpt2 into
!            bmasdq = the down-going transverse flux difference B^- A^* Delta q
!            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
!        where A^* represents either A^- or A^+.


!cf2py intent(in) num_aux
!f2py external rpn2, rpt2
!f2py intent(callback) rpn2,rpt2

    implicit double precision (a-h,o-z)
    integer num_aux
    external rpn2,rpt2
    dimension    q1d(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension   amdq(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension   apdq(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension bmasdq(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension bpasdq(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension   cqxx(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension   qadd(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension   fadd(num_eqn, 1-num_ghost:maxm+num_ghost)
    dimension   gadd(num_eqn, 2, 1-num_ghost:maxm+num_ghost)

    dimension dtdx1d(1-num_ghost:maxm+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost)

    dimension     s(num_waves,1-num_ghost:maxm+num_ghost)
    dimension  wave(num_eqn, num_waves, 1-num_ghost:maxm+num_ghost)

    dimension method(7),mthlim(num_waves)
    logical :: limit, use_fwave
    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom

    limit = .false.
    do mw=1,num_waves
        if (mthlim(mw) > 0) limit = .TRUE. 
    end do

    ! initialize flux increments:
    ! -----------------------------

    forall (m=1:num_eqn, i = 1-num_ghost: mx+num_ghost)
        qadd(m,i) = 0.d0
        fadd(m,i) = 0.d0
        gadd(m,1,i) = 0.d0
        gadd(m,2,i) = 0.d0
    end forall
      

    ! solve Riemann problem at each interface and compute Godunov updates
    ! ---------------------------------------------------------------------

    call rpn2(ixy,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux2,aux2,wave,s,amdq,apdq)

    ! Set qadd for the donor-cell upwind method (Godunov)
    forall(m=1:num_eqn, i=1:mx+1)
        qadd(m,i) = qadd(m,i) - dtdx1d(i)*apdq(m,i)
        qadd(m,i-1) = qadd(m,i-1) - dtdx1d(i-1)*amdq(m,i)
    end forall

    ! compute maximum wave speed for checking Courant number:
    cfl1d = 0.d0
    do mw=1,num_waves
        do i=1,mx+1
            ! if s>0 use dtdx1d(i) to compute CFL,
            ! if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i), &
            -dtdx1d(i-1)*s(mw,i))
        end do
    end do

    if (method(2) == 1) go to 130

    ! modify F fluxes for second order q_{xx} correction terms:
    ! -----------------------------------------------------------

    ! apply limiter to waves:
    if (limit) call limiter(maxm,num_eqn,num_waves,num_ghost,mx, &
                            wave,s,mthlim)

    ! For correction terms below, need average of dtdx in cell
    ! i-1 and i.  We compute these and overwrite dtdx1d.

    ! Second order corrections:
    if (use_fwave.eqv. .FALSE. ) then
        do i = 2-num_ghost, mx+num_ghost
            ! modified in Version 4.3 to use average only in cqxx, not transverse
            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
            do m=1,num_eqn
                cqxx(m,i) = 0.d0
                do mw=1,num_waves
                    cqxx(m,i) = cqxx(m,i) + dabs(s(mw,i)) &
                    * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                enddo
                fadd(m,i) = fadd(m,i) + 0.5d0 * cqxx(m,i)
            enddo
        enddo
    else
        do i = 2-num_ghost, mx+num_ghost
            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
            do m=1,num_eqn
                cqxx(m,i) = 0.d0
                do mw=1,num_waves
                !                 # second order corrections:
                    cqxx(m,i) = cqxx(m,i) + dsign(1.d0,s(mw,i)) &
                    * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                enddo
                fadd(m,i) = fadd(m,i) + 0.5d0 * cqxx(m,i)
            enddo
        enddo
    endif


    130 continue

    if (method(3) <= 0) go to 999   !# no transverse propagation

    if (method(2) > 1 .AND. method(3) == 2) then
        ! incorporate cqxx into amdq and apdq so that it is split also.
        forall (m=1:num_eqn, i = 1: mx+1)
            amdq(m,i) = amdq(m,i) + cqxx(m,i)
            apdq(m,i) = apdq(m,i) - cqxx(m,i)
        end forall
    endif


    ! modify G fluxes for transverse propagation
    ! --------------------------------------------


    ! split the left-going flux difference into down-going and up-going:
    call rpt2(ixy,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux1,aux2,aux3,amdq,bmasdq,bpasdq)

    ! modify flux below and above by B^- A^- Delta q and  B^+ A^- Delta q:
    forall ( m=1:num_eqn , i = 1:mx+1)
        gadd(m,1,i-1) = gadd(m,1,i-1) - &
        0.5d0*dtdx1d(i-1) * bmasdq(m,i)
        gadd(m,2,i-1) = gadd(m,2,i-1) - &
        0.5d0*dtdx1d(i-1) * bpasdq(m,i)
    end forall
     

    ! split the right-going flux difference into down-going and up-going:
    call rpt2(ixy,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux1,aux2,aux3,apdq,bmasdq,bpasdq)

    ! modify flux below and above by B^- A^+ Delta q and  B^+ A^+ Delta q:
    forall ( m=1:num_eqn , i = 1: mx+1)
        gadd(m,1,i) = gadd(m,1,i) - &
        0.5d0*dtdx1d(i) * bmasdq(m,i)
        gadd(m,2,i) = gadd(m,2,i) - &
        0.5d0*dtdx1d(i) * bpasdq(m,i)
    end forall

    999 continue
    return
end subroutine flux2

c
c
c
c     =================================================================
      subroutine claw3ez    ! No arguments
c     =================================================================
c
c     An easy-to-use clawpack driver routine for simple applications
c     Documentation is available at
c                 http://www.amath.washington.edu/~claw/doc.html
c
c     Author: Randall J. LeVeque, Grady I. Lemoine
c
c     Modified July 2013 to use dynamic allocation, new input file
c     format.  Allocation of all the large arrays (aux, q, work) is
c     delayed until the last possible moment in case any of the user
c     code called before them is a memory hog.
c

      implicit double precision (a-h,o-z)

c     F77 way to get OpenMP function declarations
c$    include 'omp_lib.h'

      external bc3,rpn3,rpt3,rptt3,src3,b4step3

      double precision, dimension(:,:,:,:), allocatable :: q, aux
      double precision, dimension(:), allocatable :: work

c
      dimension method(7),dtv(5),cflv(4),nv(2),mthbc(6)
      double precision, dimension(:), allocatable :: tout
      logical rest
c
      common /restrt_block/ tinitial, iframe
c
      integer, dimension(:), allocatable :: mthlim

      logical :: outaux_init_only, output_t0, use_fwaves
      logical :: outaux_always, dt_variable
      integer :: output_format, dimensional_split, outstyle
      integer, dimension(:), allocatable :: iout_q, iout_aux
      integer :: allocate_status

      call opendatafile(55, 'claw.data')
      open(10,file='fort.info',status='unknown',form='formatted')
c
c
c     # Read the input in standard form from claw2ez.data:

      read(55,*) ndim    ! Not actually used, but the modern Python setup writes it
      read(55,*) xlower, ylower, zlower
      read(55,*) xupper, yupper, zupper
      read(55,*) mx, my, mz
      read(55,*) meqn
      read(55,*) mwaves
      read(55,*) maux
      read(55,*) t0

      read(55,*) outstyle
      if (outstyle.eq.1) then
         read(55,*) nout
         read(55,*) tfinal
         read(55,*) output_t0    ! Not currently used
         nstepout = 1
      else if (outstyle.eq.2) then
         read(55,*) nout
         allocate(tout(nout), stat=allocate_status)
         if (allocate_status .ne. 0) then
            print *, '*** Error allocating tout array; exiting claw3ez'
            go to 900
         end if
         read(55,*) (tout(i), i=1,nout)
         nstepout = 1
      else if (outstyle.eq.3) then
         read(55,*) nstepout
         read(55,*) nstop
         read(55,*) output_t0
         nout = nstop
      else
         print *, '*** Unrecognized output style ', outstyle
         print *, '*** Exiting claw3ez'
         go to 900
      end if

      read(55,*) output_format    ! Not used yet
      ! These iout variables are not currently used, but hang onto them
      ! anyway in case somebody wants to use them at a future date.  The
      ! same goes for outaux_init_only.
      allocate(iout_q(meqn), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating iout_q array; exiting claw3ez'
         go to 900    ! Exception handling, old school style
      end if
      read(55,*) (iout_q(i), i = 1, meqn)
      if (maux > 0) then
         allocate(iout_aux(maux), stat=allocate_status)
         if (allocate_status .ne. 0) then
            print *, '*** Error allocating iout_aux array;',
     &               ' exiting claw3ez'
            go to 900
         end if
         read(55,*) (iout_aux(i), i = 1, maux)
         read(55,*) outaux_init_only
         ! Not implementing selective output of aux fields yet
         if (any(iout_aux .ne. 0)) then
            outaux_always = .not. outaux_init_only
         else
            outaux_always = .false.
            outaux_init_only = .false.
         end if
      else
         outaux_always = .false.
         outaux_init_only = .false.    ! Just for the sake of initialization
      end if

      read(55,*) dtv(1)     ! Initial dt
      read(55,*) dtv(2)     ! Max dt
      read(55,*) cflv(1)    ! Max CFL number
      read(55,*) cflv(2)    ! Desired CFL number
      read(55,*) nv(1)      ! Maximum number of steps

      read(55,*) dt_variable  ! Variable or fixed dt
      if (dt_variable) then
         method(1) = 1
      else
         method(1) = 0
      end if
      read(55,*) method(2)    ! Order
      read(55,*) method(3)    ! Transverse propagation style
      read(55,*) dimensional_split    ! Whether to use dimensional splitting

      ! Translate new-style Python specification of transverse
      ! order/dimensional splitting into something the older code
      ! understands.
      if (dimensional_split > 0) method(3) = -1

      read(55,*) method(4)    ! Verbosity
      read(55,*) method(5)    ! Source term splitting style
      read(55,*) method(6)    ! Index into aux for capacity function
      method(7) = maux    ! Number of aux variables

      read(55,*) use_fwaves

      allocate(mthlim(mwaves), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating mthlim array; exiting claw3ez'
         go to 900
      end if
      read(55,*) (mthlim(i), i = 1, mwaves)

      read(55,*) mbc
      read(55,*) mthbc(1), mthbc(3), mthbc(5)
      read(55,*) mthbc(2), mthbc(4), mthbc(6)

      rest = .false.
      read(55, *, err=199, end=199) rest
      if (rest) then
         print *, 'Doing a restart run'
         print *, 'Attempting to read restart frame number'
         print *, 'You may need to hand-edit claw.data'
         read(55,*) iframe      ! restart from data in fort.qN file, N=iframe
         print *, 'Planning restart from frame ', iframe
      end if
 199  continue

      close(unit=55)


      if ((mthbc(1).eq.2 .and. mthbc(2).ne.2) .or.
     &    (mthbc(2).eq.2 .and. mthbc(1).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions'
         write(6,*) 'require mthbc(1) and mthbc(2) BOTH be set to 2'
         go to 900
         endif

      if ((mthbc(3).eq.2 .and. mthbc(4).ne.2) .or.
     &    (mthbc(4).eq.2 .and. mthbc(3).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions'
         write(6,*) 'require mthbc(3) and mthbc(4) BOTH be set to 2'
         go to 900
         endif

      if ((mthbc(5).eq.2 .and. mthbc(6).ne.2) .or.
     &    (mthbc(6).eq.2 .and. mthbc(5).ne.2)) then
         write(6,*) '*** ERROR ***  periodic boundary conditions'
         write(6,*) 'require mthbc(5) and mthbc(6) BOTH be set to 2'
         go to 900
         endif

c
c     # Figure out how much work space is necessary
c
      if (method(5).lt.2) then
          narray = 1   !# only need one qwork array
        else
          narray = 2   !# need two qwork arrays for Strang splitting
        endif

      maxm = max0(mx, my, mz)
      nthreads=1    ! Serial
c$omp parallel
c$omp single
c$    nthreads = omp_get_num_threads()
c$    maxthreads = omp_get_max_threads()
c$omp end single
c$omp end parallel
      mwork = (maxm+2*mbc)*(46*meqn + mwaves + meqn*mwaves
     &                     + 9*maux + 3)*nthreads
     &         + narray * (mx + 2*mbc) * (my + 2*mbc)
     &                  * (mz + 2*mbc) * meqn

c
c

      call chkmth(method,info)
      if( info .eq. 6) then
         print *, '*** Error in method data; exiting claw3ez'
         go to 900
      end if
c
c
      write(6,*) 'running...'
      write(6,*) ' '
c
c     # grid spacing
      dx = (xupper - xlower) / float(mx)
      dy = (yupper - ylower) / float(my)
      dz = (zupper - zlower) / float(mz)
c


c     # time increments between outputing solution:
      if (outstyle .eq. 1) then
         dtout = (tfinal - t0)/float(nout)
      endif
c
c
c     # call user's routine setprob to set any specific parameters
c     # or other initialization required.
c
      call setprob

c     # Allocate aux
      if (maux > 0) then
         allocate(aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc),
     &            stat=allocate_status)
      else
         ! Allocate a dummy array so that dereferencing it doesn't cause
         ! a segfault.  This may not be necessary.
         allocate(aux(1,1,1,1), stat=allocate_status)
      end if
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating aux array; exiting claw3ez'
         go to 900
      end if
c
c     # set aux array:
c
      if (maux .gt. 0)  then
         call setaux(mbc,mx,my,mz,xlower,ylower,
     &               zlower,dx,dy,dz,maux,aux)
         endif

c     # Allocate q
      allocate(q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc),
     &         stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error allocating q array; exiting claw3ez'
         go to 900
      end if

c
c     # set initial conditions:

      if (rest) then
          call restart(meqn,mbc,mx,my,mz,
     &          xlower,ylower,zlower,dx,dy,dz,q)
          t0 = tinitial
        else
          call qinit(meqn,mbc,mx,my,mz,xlower,
     &           ylower,zlower,dx,dy,dz,q,maux,aux)
          iframe = 0
        endif
c
c
c
      if (.not. rest) then
c        # output initial data
         call out3(meqn,mbc,mx,my,mz,xlower,ylower,
     &          zlower,dx,dy,dz,q,t0,iframe,aux,maux,
     &          outaux_init_only .or. outaux_always)
         write(6,601) iframe, t0
         endif

      ! Allocate work array
      allocate(work(mwork), stat=allocate_status)
      if (allocate_status .ne. 0) then
         print *, '*** Error (nthreads=',nthreads,
     &        ') allocating work array; exiting claw3ez'
         go to 900
      end if

c
c     ----------
c     Main loop:
c     ----------
c
      tend = t0
      n0   = iframe*nstepout + 1

      do 100 n=n0,nout
         tstart = tend
         if (outstyle .eq. 1)  tend = tstart + dtout
         if (outstyle .eq. 2)  tend = tout(n)
         if (outstyle .eq. 3)  tend = tstart - 1.d0  !# single-step mode
c
         call claw3(meqn,mwaves,mbc,mx,my,mz,maux,
     &           q,aux,xlower,ylower,zlower,dx,dy,dz,tstart,tend,dtv,
     &           cflv,nv,method,mthlim,mthbc,
     &           work,mwork,use_fwaves,info,bc3,rpn3,rpt3,rptt3,src3,
     &           b4step3)
c
c        # check to see if an error occured:
         if (info .ne. 0) then
            write(6,*) 'claw3ez aborting: Error return from claw3',
     &                 ' with info =',info
            go to 900
            endif
c
         dtv(1) = dtv(5)  !# use final dt as starting value on next call
c
c        # output solution at this time
c        ------------------------------
c
c        # if outstyle=1 or 2, then nstepout=1 and we output every time
c        # we reach this point, since claw1 was called for the entire time
c        # increment between outputs.
c
c        # if outstyle=3 then we only output if we have taken nstepout
c        # time steps since the last output.

c        # iframe is the frame number used to form file names in out3
         if (mod(n,nstepout) .eq. 0) then
            iframe = iframe + 1
            call out3(meqn,mbc,mx,my,mz,xlower,ylower,
     &            zlower,dx,dy,dz,q,tend,iframe,aux,maux,
     &            outaux_always)
            write(6,601) iframe,tend
            write(10,1010) tend,info,dtv(3),dtv(4),dtv(5),
     &           cflv(3),cflv(4),nv(2)
            endif

c
c        # formats for writing out information about this call to claw:

  601    format('CLAW3EZ: Frame ',i4,
     &         ' matlab plot files done at time t =',
     &         d12.4,/)
c
 1010    format('tend =',d15.4,/,
     &       'info =',i5,/,'smallest dt =',d15.4,/,'largest dt =',
     &       d15.4,/,'last dt =',d15.4,/,'largest cfl =',
     &         d15.4,/,'last cfl =',d15.4,/,'steps taken =',i4,/)
c
  100    continue
c
 900  continue
c
      ! Destructor, old school style
      if (allocated(work))     deallocate(work)
      if (allocated(q))        deallocate(q)
      if (allocated(aux))      deallocate(aux)
      if (allocated(mthlim))   deallocate(mthlim)
      if (allocated(iout_aux)) deallocate(iout_aux)
      if (allocated(iout_q))   deallocate(iout_q)
      if (allocated(tout))     deallocate(tout)

      return
      end

c
c --------------------------------------------------------------
c
      subroutine preicall(val,aux,nrow,ncol,nvar,naux,
     1                    ilo,ihi,jlo,jhi,level,fliparray)
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension fliparray((nrow+ncol)*nghost*(nvar+naux))
      dimension val(nvar,nrow,ncol)
      dimension aux(naux,nrow,ncol)

      dimension ist(3), iend(3), jst(3), jend(3), ishift(3), jshift(3)
      logical   xint, yint
      
c
c NEW INDEXING - ORDER SWITCHED
      iadd   (ivar,i,j)  = locflip    + ivar-1 + nvar*((j-1)*nc+i-1)
      iaddaux(iaux,i,j)  = locflipaux + iaux-1 + naux*((j-1)*nc+i-1)

c
c  :::::::::::::: PREICALL :::::::::::::::::::::::::::::::::::::::::::
c     For periodic boundary conditions more work needed to initialize a
c     new grid that sticks out. This routine was
c     called because the patch sticks out of the domain,
c     and has periodic bc.s preprocess the patch before calling
c     icall to shift the patch periodically back into the domain.
c
c     Inputs to this routine:
c     ilo,ihi,jlo,jhi = the location in index space of this patch.
c
c     Outputs from this routine:
c     The values of the grid are inserted
c     directly into the enlarged val array for this piece.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
!     ## fliparray now passed in; index into it below
        locflip = 1
        locflipaux = 1 + nvar*(ncol+nrow)
c
c     ## will divide patch into 9 possibilities (some empty):
c     ## x sticks out left, x interior, x sticks out right
c     ## same for y. for example, the max. would be
c     ## i from (ilo,-1), (0,iregsz(level)-1), (iregsz(level),ihi)

        if (xperdom) then
           ist(1)    = ilo
           ist(2)    = 0
           ist(3)    = iregsz(level)
           iend(1)   = -1
           iend(2)   = iregsz(level)-1
           iend(3)   = ihi
           ishift(1) = iregsz(level)
           ishift(2) = 0
           ishift(3) = -iregsz(level)
        else   ! if not periodic, set vals to only have nonnull intersection for interior regoin
           ist(1)    = iregsz(level)
           ist(2)    = ilo
           ist(3)    = iregsz(level)
           iend(1)   = -nghost
           iend(2)   = ihi
           iend(3)   = -nghost
           ishift(1) = 0
           ishift(2) = 0
           ishift(3) = 0
        endif


        if (yperdom .or. spheredom) then
           jst(1)    = jlo
           jst(2)    = 0
           jst(3)    = jregsz(level)
           jend(1)   = -1
           jend(2)   = jregsz(level)-1
           jend(3)   = jhi
           jshift(1) = jregsz(level)
           jshift(2) = 0
           jshift(3) = -jregsz(level)
        else
           jst(1)    = jregsz(level)
           jst(2)    = jlo
           jst(3)    = jregsz(level)
           jend(1)   = -nghost
           jend(2)   = jhi
           jend(3)   = -nghost
           jshift(1) = 0
           jshift(2) = 0
           jshift(3) = 0
        endif

c      ## loop over the 9 regions (in 2D) of the patch - the interior is i=j=2 plus
c      ## the ghost cell regions.  If any parts stick out of domain and are periodic
c      ## map indices periodically, but stick the values in the correct place
c      ## in the orig grid (indicated by iputst,jputst.
c      ## if a region sticks out of domain  but is not periodic, not handled in (pre)-icall 
c      ## but in setaux/bcamr (not called from here).
       do 20 i = 1, 3
          i1 = max(ilo,  ist(i))
          i2 = min(ihi, iend(i))
          if (i1 .gt. i2) go to 20 ! non-empty intersection not possible
       do 10 j = 1, 3
          j1 = max(jlo,  jst(j))
          j2 = min(jhi, jend(j))
 
          if (j1 .le. j2) then ! part of patch in this region
c
c check if special mapping needed for spherical bc. 
c (j=2 is interior,nothing special needed)
            if (.not. spheredom .or. j .eq. 2) then
               iputst = i1 - ilo + 1
               jputst = j1 - jlo + 1
               call icall(val,aux,nrow,ncol,nvar,naux,
     1                       i1+ishift(i),i2+ishift(i),
     2                       j1+jshift(j),j2+jshift(j),level,
     3                       iputst,jputst)
            else
              nr = i2 - i1 + 1
              nc = j2 - j1 + 1
              ng = 0    ! no ghost cells in this little patch. fill everything.

              jbump = 0
              if (j1 < 0)   jbump = abs(j1)  ! bump up so new bottom is 0
              if (j2 >= jregsz(level)) jbump = -(j2+1-jregsz(level)) ! bump down

c             next 2 lines would take care of periodicity in x
              iwrap1 = i1 + ishift(i)
              iwrap2 = i2 + ishift(i)
c             next 2 lines take care of mapped sphere bcs
              iwrap1 = iregsz(level) - iwrap1 -1
              iwrap2 = iregsz(level) - iwrap2 -1
c             swap so that smaller one is left index, etc since mapping reflects
              tmp = iwrap1
              iwrap1 = iwrap2
              iwrap2 = tmp

              jwrap1 = j1 + jbump
              xlwrap = xlower + iwrap1*hxposs(level)
              ybwrap = ylower + jwrap1*hyposs(level)
              jwrap2 = j2 + jbump

              if (naux>0) then
!               fliparray(locflipaux:locflipaux+naux*(ncol+nrow)-1) =  
               iflipChunkSize  = naux*nc*nr - 1 + nvar*(ncol+nrow)
               idimen = (nrow+ncol)*nghost*(nvar+naux)
               if (iflipChunkSize .gt. idimen) then
                  write(*,*) "Error in fliparray size: asking for ",
     .                       iflipChunkSize," but dimension is",idimen
                   stop
                  endif
                  fliparray(locflipaux:locflipaux+naux*nc*nr - 1) =
     1                     NEEDS_TO_BE_SET
                 call setaux(ng,nr,nc,xlwrap,ybwrap,
     1                    hxposs(level),hyposs(level),naux,
     2                    fliparray(locflipaux))
              endif 

c             write(dbugunit,101) i1,i2,j1,j2
c             write(dbugunit6,102) iwrap1,iwrap2,j1+jbump,j2+jbump
 101          format(" actual patch from i:",2i5," j :",2i5)
 102          format(" icall called w i:",2i5," j :",2i5)
              call icall(fliparray(locflip),fliparray(locflipaux),
     1                   nr,nc,nvar, naux,iwrap1,iwrap2,jwrap1,jwrap2,
     2                   level,1,1)

c             copy back using weird mapping for spherical folding
              nrowst = 1   ! start filling up val at (1,1) - no additional offset
              ncolst = 1
              do 14 ii = i1, i2
              do 15 jj = j1, j2
c            write(dbugunit6,100)nrowst+ii-ilo,ncolst+jj-jlo,nr-(ii-i1),
c    1                            nc-jj+j1
 100          format(" filling loc ",2i5," with ",2i5)

                do 17 ivar = 1, nvar
                   val(ivar,nrowst+(ii-ilo),ncolst+(jj-jlo)) = 
     1                    fliparray(iadd(ivar,nr-(ii-i1),nc-(jj-j1)))
 17             continue

                do 16 iaux = 1, naux
                   aux(iaux,nrowst+(ii-ilo),ncolst+(jj-jlo)) = 
     1                    fliparray(iaddaux(iaux,nr-(ii-i1),nc-(jj-j1)))
 16             continue
 15           continue
 14           continue
             
            endif

          endif


 10    continue
 20    continue


      return
      end

c
c ----------------------------------------------------
c
      subroutine domshrink(iflags2,iflags,idim,jdim,kdim)

      use amr_module
      implicit double precision (a-h, o-z)

      integer*1  iflags2(0:idim+1,0:jdim+1,0:kdim+1)
      integer*1  iflags (0:idim+1,0:jdim+1,0:kdim+1)

c
c :::::::::::::::::::::::::  DOMSHRINK ::::::::::::::::::::::::::::
c
c  shrink domain flags one cell for allowable properly nested domain
c  This is needed even for lcheck = lbase. More shrinking needed
c  for finer levels.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
         write(outunit,*)" from domshrink: on entry, iflags2"
         do 10 kk = 1, kdim
            k = kdim + 1 - kk
            write(outunit,*) 'plane k = ',k
            do 10 jj = 1, jdim
               j = jdim + 1 - jj
               write(outunit,100)(iflags2(i,j,k),i=1,idim)
 100        format(80i1)
 10      continue
      endif

      do 40 k = 1, kdim
      do 40 j = 1, jdim
      do 40 i = 1, idim
      iflags(i,j,k) = iflags2(i,j,k)
      if (iflags2(i  ,j  ,k  ).le.0 .or.
     1    iflags2(i+1,j  ,k  ).le.0 .or. iflags2(i-1,j  ,k  ).le.0 .or.
     2    iflags2(i+1,j+1,k  ).le.0 .or. iflags2(i-1,j+1,k  ).le.0 .or.
     3    iflags2(i  ,j-1,k  ).le.0 .or. iflags2(i  ,j+1,k  ).le.0 .or.
     4    iflags2(i+1,j-1,k  ).le.0 .or. iflags2(i-1,j-1,k  ).le.0 .or.
     .    iflags2(i  ,j  ,k-1).le.0 .or.
     1    iflags2(i+1,j  ,k-1).le.0 .or. iflags2(i-1,j  ,k-1).le.0 .or.
     2    iflags2(i+1,j+1,k-1).le.0 .or. iflags2(i-1,j+1,k-1).le.0 .or.
     3    iflags2(i  ,j-1,k-1).le.0 .or. iflags2(i  ,j+1,k-1).le.0 .or.
     4    iflags2(i+1,j-1,k-1).le.0 .or. iflags2(i-1,j-1,k-1).le.0 .or.
     .    iflags2(i  ,j  ,k+1).le.0 .or.
     1    iflags2(i+1,j  ,k+1).le.0 .or. iflags2(i-1,j  ,k+1).le.0 .or.
     2    iflags2(i+1,j+1,k+1).le.0 .or. iflags2(i-1,j+1,k+1).le.0 .or.
     3    iflags2(i  ,j-1,k+1).le.0 .or. iflags2(i  ,j+1,k+1).le.0 .or.
     4    iflags2(i+1,j-1,k+1).le.0 .or. iflags2(i-1,j-1,k+1).le.0) then
        iflags(i,j,k) = 0
      endif
 40   continue
c
c if border of domain touches a physical boundary then set domain in
c ghost cell as well
c
       if (.not. xperdom) then
         do 55 k = 1, kdim
         do 55 j = 1, jdim
           if (iflags(   1,j,k) .eq. 1) iflags(     0,j,k) = 1
           if (iflags(idim,j,k) .eq. 1) iflags(idim+1,j,k) = 1
 55      continue
       endif
       if (.not. yperdom) then
         do 65 k = 1, kdim
         do 65 i = 1, idim
           if (iflags(i,   1,k) .eq. 1) iflags(i,     0,k) = 1
           if (iflags(i,jdim,k) .eq. 1) iflags(i,jdim+1,k) = 1
 65      continue
       endif
       if (.not. zperdom) then
         do 75 j = 1, jdim
         do 75 i = 1, idim
           if (iflags(i,j,   1) .eq. 1) iflags(i,j,     0) = 1
           if (iflags(i,j,kdim) .eq. 1) iflags(i,j,kdim+1) = 1
 75      continue
       endif

      if (dprint) then
         write(outunit,*)" from domshrink: on exit, iflags"
         do 80 kk = 1, kdim
            k = kdim + 1 - kk
            write(outunit,*) 'plane k = ',k
            do 80 jj = 1, jdim
               j = jdim + 1 - jj
               write(outunit,100)(iflags(i,j,k),i=1,idim)
 80      continue
      endif

      return
      end

c
c ----------------------------------------------------
c
      subroutine domprep(domflags,lbase,ibase,jbase)

      use amr_module
      implicit double precision (a-h, o-z)


      integer(kind=1)  domflags(0:ibase+1,0:jbase+1)

c
c ::::::::::::::::::::::::::: PREPDOM :::::::::::::::::::::
c 
!>  prepare 2 dimensional array of domain for proper nesting
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::


      do j = 0, jbase+1
      do i = 0, ibase+1
         domflags(i,j) = 0
      end do
      end do

      mptr = lstart(lbase)
 15   continue
c     domain flags appears to be 1 based indexing, so 0 a ghost cell.
c     should change it to be 0 based, like grids, so border is at -1.
      do j = node(ndjlo,mptr) + 1, node(ndjhi,mptr) + 1
      do i = node(ndilo,mptr) + 1, node(ndihi,mptr) + 1
         domflags(i,j) = 1
      end do
      end do
      mptr = node(levelptr, mptr)
      if (mptr .ne. 0) go to 15

c
c take care of periodic domains or if border of domain touches a 
c  physical boundary then set domain in ghost cell as well
c
      if (xperdom) then
         do 25 j = 0, jbase+1
           domflags(0,j)       = domflags(ibase,j)
           domflags(ibase+1,j) = domflags(1,j)
 25      continue
       else
         do 65 j = 1, jbase
           domflags(0,j)       = domflags(1,j)
           domflags(ibase+1,j) = domflags(ibase,j)
 65      continue
      endif
      if (yperdom) then
         do 35 i = 0, ibase+1
           domflags(i,0)       = domflags(i,jbase)
           domflags(i,jbase+1) = domflags(i,1)
 35      continue
       else if (spheredom) then
         do 36 i = 0, ibase+1
           domflags(i,0)       = domflags(ibase+1-i,1)
           domflags(i,jbase+1) = domflags(ibase+1-i,jbase)
 36     continue
       else
         do 55 i = 1, ibase
           domflags(i,0)       = domflags(i,1)
           domflags(i,jbase+1) = domflags(i,jbase)
 55      continue
      endif
c
c the 4 corners
c
        if (domflags(0,1)+domflags(1,0) .eq. 2) domflags(0,0)=1
        if (domflags(ibase,0)+domflags(ibase+1,1) .eq. 2) 
     .          domflags(ibase+1,0)=1
        if (domflags(ibase,jbase+1)+domflags(ibase+1,jbase) .eq. 2) 
     .          domflags(ibase+1,jbase+1)=1
        if (domflags(0,jbase)+domflags(1,jbase+1) .eq. 2) 
     .          domflags(0,jbase+1)=1

      if (dprint) then
         write(outunit,*)" from domprep: domflags at level  ", lbase
         do 40 jj = 1, jbase
         j = jbase + 1 - jj
         write(outunit,100)(domflags(i,j),i=1,ibase)
 100     format(80i1)
 40      continue
      endif

      return
      end

c
c -----------------------------------------------------------
c
      subroutine findcut(icl,iscr,idim,index,iside,
     1                   ilo,ihi)
c
c ::::::::::::::::::::: FINDCUT ::::::::::::::::::::::::::::;
c   find best place to split the 1D array of flagged points
c   either split at a hole, or use signatures to find
c   zero crossing of laplacian.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension iscr(idim)

c Modified 6/02:
c Include call.i to get def's of horizontal.
c      integer   horizontal
c      parameter(horizontal = 1)

      parameter(ithres = 2)
      parameter(minoff = 2)
c
c  look for holes in horizontal direction
c
       do 10 i = ilo, ihi
          if (iscr(i) .eq. 0) then
             index = i
             iside = horizontal
             return
          endif
 10    continue

c
c  no holes - find 2nd derivative of signatures for best cut.
c  overwrite signature arrays. don't make cuts less than minoff
c  from boundary
c
      ipre = iscr(ilo)
      do 50 i = ilo+1, ihi-1
         icur = iscr(i)
         iscr(i) = iscr(i+1)-2*icur+ipre
         ipre = icur
 50   continue

      locmaxi = 0
      indexi  = 0
      imid    = (ilo + ihi) / 2
      do 60 i = ilo+minoff, ihi-minoff+1
           itemp1 = iscr(i-1)
           itemp2 = iscr(i)
           locdif = iabs(itemp1-itemp2)
           if (itemp1*itemp2.lt.0) then
                if (locdif .gt. locmaxi) then
                 locmaxi = locdif
                 indexi = i
                else if (locdif .eq. locmaxi) then
                    if (iabs(i-imid).lt.iabs(indexi-imid)) indexi = i
                endif
           endif
 60   continue
c
c      ::::: set index for splitting
c
       index  = indexi
       iside  = horizontal
       locmax = locmaxi


c      ::::: if inflection pt. not over the threshold, signal
c      ::::: with index 0 (out of range)
       if (locmax .lt. ithres) index = 0

       return
       end

module step1m
implicit none

interface
   subroutine rp(mx, mbc, ql, qr, s, wave, amdq, apdq, context)
     use iso_c_binding
     integer(c_int), intent(in), value :: mx, mbc
     real(c_double), intent(in) :: &
          ql(1, 1-mbc:mx+mbc), &
          qr(1, 1-mbc:mx+mbc)
     type(c_ptr), intent(in), value :: context

     real(c_double), intent(out) :: &
          s(1, 1-mbc:mx+mbc), &
          wave(1, 1, 1-mbc:mx+mbc), &
          apdq(1, 1-mbc:mx+mbc), &
          amdq(1, 1-mbc:mx+mbc)
   end subroutine rp
end interface

contains

  ! ===================================================================
  subroutine step1(num_eqn,num_waves,num_ghost,num_aux,mx,q,aux,dx, &
       dt,method,mthlim,cfl,f,wave,s,amdq,apdq,dtdx,use_fwave,c_rp1,context) &
       bind(C, name='step1_c')
    ! ===================================================================

    !     # Take one time step, updating q.

    !     method(1) = 1   ==>  Godunov method
    !     method(1) = 2   ==>  Slope limiter method
    !     mthlim(p)  controls what limiter is used in the pth family


    !     amdq, apdq, wave, s, and f are used locally:

    !     amdq(1-num_ghost:mx+num_ghost, num_eqn) = left-going flux-differences
    !     apdq(1-num_ghost:mx+num_ghost, num_eqn) = right-going flux-differences
    !        e.g. amdq(m,i) = m'th component of A^- \Delta q from i'th Riemann
    !                         problem (between cells i-1 and i).

    !     wave(1-num_ghost:mx+num_ghost, num_eqn, num_waves) = waves from solution of
    !                                           Riemann problems,
    !            wave(m,mw,i) = mth component of jump in q across
    !                           wave in family mw in Riemann problem between
    !                           states i-1 and i.

    !     s(1-num_ghost:mx+num_ghost, num_waves) = wave speeds,
    !            s(m,iw) = speed of wave in family mw in Riemann problem between
    !                      states i-1 and i.

    !     f(1-num_ghost:mx+num_ghost, num_eqn) = correction fluxes for second order method
    !            f(m,i) = mth component of flux at left edge of ith cell
    !     --------------------------------------------------------------------

  use iso_c_binding

    logical(c_bool), intent(in) :: use_fwave
    integer(c_int), intent(in) :: &
         num_eqn, num_waves, num_ghost, num_aux, mx, &
         method(7), mthlim(num_waves)

    real(c_double), intent(in) :: &
         aux(num_aux,1-num_ghost:mx+num_ghost)

    real(c_double), intent(inout) :: &
         q(num_eqn,1-num_ghost:mx+num_ghost)

    type(c_funptr), intent(in)     :: c_rp1
    type(c_ptr), intent(in)        :: context

    real(c_double), intent(out) :: &
         cfl, &
         s(num_waves,1-num_ghost:mx+num_ghost), &
         wave(num_eqn, num_waves,1-num_ghost:mx+num_ghost), &
         amdq(num_eqn,1-num_ghost:mx+num_ghost), &
         apdq(num_eqn,1-num_ghost:mx+num_ghost), &
         dtdx(1-num_ghost:mx+num_ghost), &
         f(num_eqn,1-num_ghost:mx+num_ghost), &
         dx, &
         dt

    logical :: limit
    procedure(rp), pointer :: rp1
    real(c_double) :: dtdxave
    integer(c_int) :: i, m, mw, index_capa

    call c_f_procpointer(c_rp1, rp1)

!     # check if any limiters are used:
    limit = .false.
    do mw=1,num_waves
       if (mthlim(mw) > 0) limit = .TRUE.
    end do

    index_capa = method(6)
    do i=1-num_ghost,mx+num_ghost
        if (index_capa > 0) then
            if (aux(index_capa,i) <= 0.d0) then
                write(6,*) 'Error -- capa must be positive'
                stop
            endif
            dtdx(i) = dt / (dx*aux(index_capa,i))
        else
            dtdx(i) = dt/dx
        endif
    end do

!     # solve Riemann problem at each interface
!     -----------------------------------------

    call rp1(mx,num_ghost,q,q,s,wave,amdq,apdq,context)

!     # Modify q for Godunov update:
!     # Note this may not correspond to a conservative flux-differencing
!     # for equations not in conservation form.  It is conservative if
!     # amdq + apdq = f(q(i)) - f(q(i-1)).

    forall(i=1:mx+1, m=1:num_eqn)
       q(m,i) = q(m,i) - dtdx(i)*apdq(m,i)
       q(m,i-1) = q(m,i-1) - dtdx(i-1)*amdq(m,i)
    end forall


!     # compute maximum wave speed:
    cfl = 0.d0
    do mw=1,num_waves
        do i=1,mx+1
        !          # if s>0 use dtdx(i) to compute CFL,
        !          # if s<0 use dtdx(i-1) to compute CFL:
            cfl = dmax1(cfl, dtdx(i)*s(mw,i), -dtdx(i-1)*s(mw,i))
        end do
    end do

    if (method(2) == 1) then
       return
    endif
!     # compute correction fluxes for second order q_{xx} terms:
!     ----------------------------------------------------------

    forall(i=1-num_ghost:mx+num_ghost, m=1:num_eqn)
       f(m,i) = 0.d0
    end forall

!      # apply limiter to waves:
    if (limit) call limiter(mx,num_eqn,num_waves,num_ghost,mx, &
         wave,s,mthlim)

    if (use_fwave.eqv. .FALSE. ) then
       do i=1,mx+1
          do m=1,num_eqn
             do mw=1,num_waves
                dtdxave = 0.5d0 * (dtdx(i-1) + dtdx(i))
                f(m,i) = f(m,i) + 0.5d0 * dabs(s(mw,i)) &
                     * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
             end do
          end do
       end do
    else
        do i=1,mx+1
           do m=1,num_eqn
              do mw=1,num_waves
                 dtdxave = 0.5d0 * (dtdx(i-1) + dtdx(i))
                 f(m,i) = f(m,i) + 0.5d0 * dsign(1.d0,s(mw,i)) &
                      * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
              end do
           end do
        end do
     endif



     ! update q by differencing correction fluxes
     ! ============================================

     ! (Note:  Godunov update has already been performed above)

    forall(i=1:mx+1, m=1:num_eqn)
       q(m,i) = q(m,i) - dtdx(i) * (f(m,i+1) - f(m,i))
    end forall

  end subroutine step1
end module step1m

c
c ----------------------------------------------------------------
c
       subroutine auxcoarsen(auxdub,midub,auxbgc,
     1                       mi2tot,naux,auxtype)
      
       implicit double precision (a-h, o-z)

       dimension     auxdub(naux,midub)
       dimension     auxbgc(naux,mi2tot)
       character*10  auxtype(naux)

c :::::::::::::::::::::::: COARSEN ::::::::::::::::::::::::::::::::
c coarsen = coarsen the fine grid auxiliary data (with double the usual
c           number of ghost cells to prepare coarsened data
c           for error estimation.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
       do 50 iaux = 1, naux

       if (auxtype(iaux) .eq. "center" .or. 
     .     auxtype(iaux) .eq. "capacity") then
            do 20 i = 1, mi2tot
               ifine = 2*(i-1) + 1
               auxbgc(iaux,i) = (auxdub(iaux,ifine) +
     &                             auxdub(iaux,ifine+1))/2.d0
20       continue

       elseif (auxtype(iaux) .eq. "xleft") then
            do 10 i = 1, mi2tot
               ifine = 2*(i-1) + 1
               auxbgc(iaux,i) = auxdub(iaux,ifine)
10       continue

       endif

50     continue

       return
       end

! ============================================================================
!  Program:     AMRClaw
!  File:        resize_storage_static.f90
!  Created:     2009-10-20
!  Author:      Marsha Berger and Randy LeVeque
! ============================================================================
!  Description: For use with compilers that don't support move_alloc.
!  Halts with an error message.
! ============================================================================

! NOTE:  Older f90 compilers (e.g. gfortran prior to 4.2?)
! may not implement move_alloc and you will need to use this routine
! instead of resize_storage.f90 and set the
! allocation large enough in init_alloc.f90 to avoid running out of space.


subroutine resize_storage(new_size,status)
    
    use amr_module
    implicit none
    
    integer, intent(out) :: status
    integer, intent(in) :: new_size
    
    status = 1

    write(6,*) '*** Ran out of storage for AMR.  '
    write(6,*) '*** Increase memsize in init_alloc_static.f'
    write(6,*) '*** or switch to dynamic memory using init_alloc.f90'
    write(6,*) '*** Current memsize = ',memsize
    write(6,*) '*** Requested new_size = ',new_size
    stop
    
    return
    
end subroutine resize_storage

c
c
c     ==================================================================
      subroutine copyq3(meqn,mbc,mx,my,mz,q1,q2)
c     ==================================================================
c
c     # copy the contents of q1 into q2
c
      implicit real*8(a-h,o-z)
      dimension q1(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 
     &             1-mbc:mz+mbc)
      dimension q2(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 
     &             1-mbc:mz+mbc)
c
c
      !$OMP parallel do collapse(4)
      do 10 k = 1-mbc, mz+mbc
         do 10 j = 1-mbc, my+mbc
            do 10 i = 1-mbc, mx+mbc
               do 10 m=1,meqn
                  q2(m,i,j,k) = q1(m,i,j,k)
 10            continue
c
      return
      end

c
c ---------------------------------------------------------
c
      logical function nestck(mnew,lbase,badpts,npts,numptc,icl,
     1                        nclust,domflags,isize,jsize,ksize,
     &                        nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension  badpts(3,npts)
      integer*1  domflags(0:isize+1,0:jsize+1,0:ksize+1)
      integer   numptc(maxcl)
c
c ::::::::::::::::::::::: NESTCK :::::::::::::::::::::::::::::::::::
c
c nestck - check that the potential grid mnew is completely
c          contained in the (coarser) finest grid which stays
c          fixed, at level lbase. projec algo. will guarantee
c          containment in all finer grids twixt them.
c          if grid not contained in some coarse grid,  then
c          bisect in long direction.
c          EVENTUALLY this has to work.
c
c input parameter:
c   mnew    - grid descriptor of potential grid
c   lbase   - level which stays fixed during regridding
c   badpts  - only the flagged pts. in this cluster (# icl)
c   domflags - the lbase domain (expanded up to level lcheck
c              which new grid must fit into
c :::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::::::::
c
       nestck = .true.
c
c      # for convex coarsest grid at level 1, nothing to check
       if (lbase .eq. 1)  go to 99

       levnew = node(nestlevel,mnew)
       lratiox  = intratx(levnew-1)
       lratioy  = intraty(levnew-1)
       lratioz  = intratz(levnew-1)
c
c  ### use grid indices coarsened by 1 level in checking
c  ### remember to offset by 1 since 1st grid cell is 0,0
c
       do 10 k = node(ndklo,mnew)/lratioz+1, node(ndkhi,mnew)/lratioz+1
       do 10 j = node(ndjlo,mnew)/lratioy+1, node(ndjhi,mnew)/lratioy+1
       do 10 i = node(ndilo,mnew)/lratiox+1, node(ndihi,mnew)/lratiox+1
          if (domflags(i,j,k) .eq. 0) go to 50
 10    continue
c
c      if made it here, then mnew is properly nested
       go to 99
c
c  ### grid not properly nested. bisect in long direction, and return
c  ### two clusters instead of 1.
c
 50    if (npts .gt. 1) go to 55
         write(outunit,101) levnew
         write(*,101)       levnew
 101     format(' nestck: 1 pt. cluster at level ',i5,' still not',
     1     ' nested',/,'          pt. too close to boundary')
         write(outunit,104) badpts(1,npts),badpts(2,npts),badpts(3,npts)
         write(*,104)       badpts(1,npts),badpts(2,npts),badpts(3,npts)
 104     format(' non-nested flagged pt. at: ',2e15.7)
         call outtre(mstart, .false.,nvar,naux)
         call outmsh(mnew, .false.,nvar,naux)
         stop

 55    if (nclust .lt. maxcl) go to 60
           write(outunit,102) maxcl
           write(*,102)       maxcl
 102       format(' too many clusters: > ',i5,' (from nestck) ')
           stop

 60   if (nprint) write(outunit,103) icl, npts
 103  format(' bisecting cluster ',i5,' with ',i5,' pts. in nestck')

      sidemx = dmax1(       rnode(cornxhi,mnew)-rnode(cornxlo,mnew),
     1                      rnode(cornyhi,mnew)-rnode(cornylo,mnew))
      sidemx = dmax1(sidemx,rnode(cornzhi,mnew)-rnode(cornzlo,mnew))
      if     (rnode(cornxhi,mnew)-rnode(cornxlo,mnew) .ge. sidemx) then
           rmid  = (rnode(cornxhi,mnew) + rnode(cornxlo,mnew) ) / 2.
           rmid  = (node(ndihi,mnew) + node(ndilo,mnew) + 1 ) / 2.
           rmid  = rmid / lratiox
           idir  = 1
      elseif (rnode(cornyhi,mnew)-rnode(cornylo,mnew) .ge. sidemx) then
           rmid  = (rnode(cornyhi,mnew) + rnode(cornylo,mnew) ) / 2.
           rmid  = (node(ndjhi,mnew) + node(ndjlo,mnew) + 1) / 2.
           rmid  = rmid / lratioy
           idir  = 2
      else
           rmid  = (rnode(cornzhi,mnew) + rnode(cornzlo,mnew) ) / 2.
           rmid  = (node(ndkhi,mnew) + node(ndklo,mnew) + 1) / 2.
           rmid  = rmid / lratioz
           idir  = 3
      endif
c
       ipt  = 1
       ntop = npts

 90    if (badpts(idir,ipt) .lt. rmid) go to 100
c
c  ### swap with a point in top half not yet tested. keep smaller
c  ### half of rect. in bottom half
c
c      do the switch in each coordinate direction
       do 91 ndim=1,3
       temp              = badpts(ndim,ipt)
       badpts(ndim,ipt)  = badpts(ndim,ntop)
       badpts(ndim,ntop) = temp
 91    continue
       ntop           = ntop - 1
       if (ipt .le. ntop) go to 90
       go to 110
 100   ipt = ipt +1
       if (ipt .le. ntop) go to 90
c
c  ### ntop points to top of 1st cluster (= no. of points in 1st cluster)
c
 110   numptc(icl)     = npts - ntop
       do 120 i        = icl, nclust
          nmove           = nclust + icl - i
 120      numptc(nmove+1) = numptc(nmove)
       numptc(icl)     = ntop
       nclust          = nclust + 1
       nestck          = .false.
c
 99    return
       end

! :::::::::: bc2amr ::::::::::::::::::::::::::::::::::::::::::::::;
!> \callgraph
!! \callergraph
!!  Take a grid patch with mesh widths **hx**,**hy**, of dimensions **nrow** by
!!  **ncol**,  and set the values of any piece of
!!  of the patch which extends outside the physical domain 
!!  using the boundary conditions. 
!!
!!  ### Standard boundary condition choices for amr2ez in clawpack
!!
!!  At each boundary  k = 1 (left),  2 (right),  3 (bottom), 4 (top):
!!
!!  mthbc(k) =  
!!  * 0  for user-supplied BC's (must be inserted!)
!!  * 1  for zero-order extrapolation
!!  * 2  for periodic boundary conditions
!!  * 3  for solid walls, assuming this can be implemented
!!                   by reflecting the data about the boundary and then
!!                   negating the 2'nd (for k=1,2) or 3'rd (for k=3,4)
!!                   component of q.
!!  * 4  for sphere bcs (left half maps to right half of same side, and vice versa), as if domain folded in half
!!
!!  The corners of the grid patch are at 
!!     (xlo_patch,ylo_patch)  --  lower left corner
!!     (xhi_patch,yhi_patch) --  upper right corner
!!
!!  The physical domain itself is a rectangle bounded by
!!     (xlower,ylower)  -- lower left corner
!!     (xupper,yupper)  -- upper right corner
!!  
!   This figure below does not work with doxygen
!   the picture is the following: 
!  ____________________________________________________
! 
!                _____________________ (xupper,yupper)
!               |                     |  
!           ____|____ (xhi_patch,yhi_patch)   
!           |   |    |                |
!           |   |    |                |
!           |   |    |                |
!           |___|____|                |
!  (xlo_patch,ylo_patch) |            |
!               |                     |
!               |_____________________|   
!    (xlower,ylower)
!  ____________________________________________________
!!
!!
!>  Any cells that lie outside the physical domain are ghost cells whose
!!  values should be set in this routine.  This is tested for by comparing
!!  xlo_patch with xlower to see if values need to be set at the left
!   as in the figure above, 
!
!>  and similarly at the other boundaries.
!!  Patches are guaranteed to have at least 1 row of cells filled
!!  with interior values so it is possible to extrapolate. 
!!  Fix [trimbd()](@ref trimbd) if you want more than 1 row pre-set.
!!
!!  Make sure the order the boundaries are specified is correct
!!  so that diagonal corner cells are also properly taken care of.
!!
!!  Periodic boundaries are set before calling this routine, so if the
!!  domain is periodic in one direction only you
!!  can safely extrapolate in the other direction. 
!!
!!  Don't overwrite ghost cells in periodic directions!
!!
!! \param val data array for solution \f$q \f$ (cover the whole grid **msrc**)
!! \param aux data array for auxiliary variables 
!! \param nrow number of cells in *i* direction on this grid
!! \param ncol number of cells in *j* direction on this grid
!! \param meqn number of equations for the system
!! \param naux number of auxiliary variables
!! \param hx spacing (mesh size) in *i* direction
!! \param hy spacing (mesh size) in *j* direction
!! \param level AMR level of this grid
!! \param time setting ghost cell values at time **time**
!! \param xlo_patch left bound of the input grid
!! \param xhi_patch right bound of the input grid 
!! \param ylo_patch lower bound of the input grid 
!! \param yhi_patch upper bound of the input grid 
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

subroutine bc2amr(val,aux,nrow,ncol,meqn,naux, hx, hy, level, time,   &
                  xlo_patch, xhi_patch, ylo_patch, yhi_patch) 

    use amr_module, only: mthbc, xlower, ylower, xupper, yupper
    use amr_module, only: xperdom,yperdom,spheredom

    implicit none

    ! Input/Output
    integer, intent(in) :: nrow, ncol, meqn, naux, level
    real(kind=8), intent(in) :: hx, hy, time
    real(kind=8), intent(in) :: xlo_patch, xhi_patch
    real(kind=8), intent(in) :: ylo_patch, yhi_patch
    real(kind=8), intent(in out) :: val(meqn, nrow, ncol)
    real(kind=8), intent(in out) :: aux(naux, nrow, ncol)
    
    ! Local storage
    integer :: i, j, ibeg, jbeg, nxl, nxr, nyb, nyt
    real(kind=8) :: hxmarg, hymarg

    hxmarg = hx * .01d0
    hymarg = hy * .01d0

    ! Use periodic boundary condition specialized code only, if only one 
    ! boundary is periodic we still proceed below
    if (xperdom .and. (yperdom .or. spheredom)) then
        return
    end if

    ! Each check has an initial check to ensure that the boundary is a real
    ! boundary condition and otherwise skips the code.  Otherwise 
    !-------------------------------------------------------
    ! Left boundary:
    !-------------------------------------------------------
    if (xlo_patch < xlower-hxmarg) then
        ! number of grid cells from this patch lying outside physical domain:
        nxl = int((xlower + hxmarg - xlo_patch) / hx)

        select case(mthbc(1))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."
            case(1) ! Zero-order extrapolation
                do j = 1, ncol
                    do i=1, nxl
                        val(:, i, j) = val(:, nxl + 1, j)
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do j = 1, ncol
                    do i=1, nxl
                        val(:, i, j) = val(:, 2 * nxl + 1 - i, j)
                    end do
                end do
                ! negate the normal velocity:
                do j = 1, ncol
                    do i=1, nxl
                        val(2, i, j) = -val(2, i, j)
                    end do
                end do

            case(4) ! Spherical domain
                continue

            case default
                print *, "Invalid boundary condition requested."
                stop
        end select
    end if

    !-------------------------------------------------------
    ! Right boundary:
    !-------------------------------------------------------
    if (xhi_patch > xupper+hxmarg) then

        ! number of grid cells lying outside physical domain:
        nxr = int((xhi_patch - xupper + hxmarg) / hx)
        ibeg = max(nrow - nxr + 1, 1)

        select case(mthbc(2))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."
            case(1) ! Zero-order extrapolation
                do i = ibeg, nrow
                    do j = 1, ncol
                        val(:, i, j) = val(:, ibeg - 1, j)
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do i=ibeg, nrow
                    do j = 1, ncol
                        val(:, i, j) = val(:, 2 * ibeg - 1 - i, j)
                    end do
                end do
                ! negate the normal velocity:
                do i = ibeg, nrow
                    do j = 1, ncol
                        val(2, i, j) = -val(2, i, j)
                    end do
                end do

            case(4) ! Spherical domain
                continue

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

    !-------------------------------------------------------
    ! Bottom boundary:
    !-------------------------------------------------------
    if (ylo_patch < ylower - hymarg) then

        ! number of grid cells lying outside physical domain:
        nyb = int((ylower + hymarg - ylo_patch) / hy)

        select case(mthbc(3))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."
            
            case(1) ! Zero-order extrapolation
                do j = 1, nyb
                    do i = 1, nrow
                        val(:,i,j) = val(:, i, nyb + 1)
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do j = 1, nyb
                    do i = 1, nrow
                        val(:,i,j) = val(:, i, 2 * nyb + 1 - j)
                    end do
                end do
                ! negate the normal velocity:
                do j = 1, nyb
                    do i = 1, nrow
                        val(3,i,j) = -val(3, i, j)
                    end do
                end do

            case(4) ! Spherical domain
                continue

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

    !-------------------------------------------------------
    ! Top boundary:
    !-------------------------------------------------------
    if (yhi_patch > yupper + hymarg) then

        ! number of grid cells lying outside physical domain:
        nyt = int((yhi_patch - yupper + hymarg) / hy)
        jbeg = max(ncol - nyt + 1, 1)

        select case(mthbc(4))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."

            case(1) ! Zero-order extrapolation
                do j = jbeg, ncol
                    do i = 1, nrow
                        val(:, i, j) = val(:, i, jbeg - 1)
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do j = jbeg, ncol 
                    do i = 1, nrow
                        val(:, i, j) = val(:, i, 2 * jbeg - 1 - j)
                    end do
                end do
                ! negate the normal velocity:
                do j = jbeg, ncol
                    do i = 1, nrow
                        val(3, i, j) = -val(3, i, j)
                    end do
                end do

            case(4) ! Spherical domain
                continue

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

end subroutine bc2amr

subroutine fgmax_read(fgmax_unit,ifg)

    ! Read in data file describing any fixed grids.
    ! Modified for v5.7.0 to read all data from fgmax_grids.data
    ! This code now looks for the data for fgmax grid number ifg.
    
    ! The information is assumed to have the form:
    ! 
    ! tstart_max  # start time for monitoring this fgrid.
    ! tend_max    # end time for monitoring this fgrid.
    ! dt_check    # desired maximum time increment between updating max values.
    ! min_level_check # minimum level to check for monitoring values/arrivals
    ! arrival_tol           # tolerance for identifying arrival. 
    ! point_style   # indicating how fgmax points are specified on this grid
    
    ! if point_style==0 this is followed by:
    !   npts        # number of grid points
    !   x(1), y(1)  # first grid point
    !   ...
    !   x(npts), y(npts)  # last grid point
    
    ! OR if npts==0, instead of the list the next line after npts should be
    !   xy_fname  # path to file containing npts followed by list of points.

    ! if point_style==1:
    !   npts       # desired number of points on transect
    !   x1, y1     # first point
    !   x2, y2     # last point
    ! if point_style==2:
    !   nx, ny     # desired number of points in x and y
    !   x1, y1     # lower left corner of cartesian grid
    !   x2, y2     # upper right corner of cartesian grid
    ! if point_style==3:
    !   n12, n23   # number of points on sides 1-2 (also 3-4) and 2-3 (also 4-1)
    !   x1, y1     # first corner of quadrilateral
    !   x2, y2     # second corner
    !   x3, y3     # third corner
    !   x4, y4     # fourth corner
    ! if point_style==4:
    !   xy_fname   # a file with topo_type==3 format specifying Z = 0 or 1,
    !              # with 1 at fgmax points

    use fgmax_module
    use amr_module, only: mxnest
    use topo_module, only: read_topo_header

    implicit none
    integer, intent(in) :: ifg, fgmax_unit
    
    ! local
    character(150) :: fname
    integer :: k,i,j,point_style,n12,n23
    real(kind=8) :: x1,x2,y1,y2,yj
    real(kind=8) :: x3,x4,y3,y4,x14,y14,x23,y23,xi,eta
    type(fgrid), pointer :: fg
    logical :: foundFile
    character(len=150) :: fname2
    integer omp_get_max_threads, maxthreads
    integer :: clock_start, clock_finish, clock_rate
    real(kind=8), allocatable :: fg_row(:)
    real(kind=8) :: fg_y
    integer :: fg_npts_max, jj

    
    fg => FG_fgrids(ifg)   ! point to next element of array of fgrids
    read(fgmax_unit,*) fg%fgno
    read(fgmax_unit,*) fg%tstart_max
    read(fgmax_unit,*) fg%tend_max
    read(fgmax_unit,*) fg%dt_check  
    read(fgmax_unit,*) fg%min_level_check
    read(fgmax_unit,*) fg%arrival_tol
    read(fgmax_unit,*) fg%interp_method
    read(fgmax_unit,*) point_style
    fg%point_style = point_style
    
    if (point_style == 0) then
        read(fgmax_unit,*) fg%npts
        
        if (fg%npts .ne. 0) then
            ! points are also in fgmax_grids.data file:
            allocate(fg%x(1:fg%npts), fg%y(1:fg%npts))
            do k=1,fg%npts
                read(fgmax_unit,*) fg%x(k), fg%y(k)
                enddo
        else
            ! in this case fname2 is read, separate file containing x,y values:
            read(fgmax_unit,*) fname2
            write(6,*) 'Reading fgmax points from '
            write(6,*) '    ',trim(fname2)
            open(unit=FG_UNIT,file=trim(fname2),status='old')
            read(FG_UNIT,*) fg%npts
            write(6,*) 'npts = ',fg%npts

            allocate(fg%x(1:fg%npts), fg%y(1:fg%npts))
            do k=1,fg%npts
                read(FG_UNIT,*) fg%x(k), fg%y(k)
                enddo
            close(FG_UNIT)
        endif

    else if (point_style == 1) then
        read(fgmax_unit,*) fg%npts
        read(fgmax_unit,*) x1,y1
        read(fgmax_unit,*) x2,y2
        allocate(fg%x(1:fg%npts), fg%y(1:fg%npts))
        do k=1,fg%npts
            fg%x(k) = x1 + (k-1)*(x2-x1)/(fg%npts - 1)
            fg%y(k) = y1 + (k-1)*(y2-y1)/(fg%npts - 1)
            enddo
    else if (point_style == 2) then
        read(fgmax_unit,*) fg%nx, fg%ny
        read(fgmax_unit,*) x1,y1
        read(fgmax_unit,*) x2,y2
        fg%xll = x1
        fg%yll = y1
        fg%dx = (x2-x1)/(fg%nx - 1)
        fg%dy = (y2-y1)/(fg%ny - 1)
        fg%npts = fg%nx*fg%ny
        allocate(fg%x(1:fg%npts), fg%y(1:fg%npts))
        allocate(fg%index(fg%nx, fg%ny)) ! to store index into list of pts
        k = 0
        do j=1,fg%ny
            yj = y1 + (j-1)*(y2-y1)/(fg%ny - 1)
            do i=1,fg%nx
                k = k+1
                fg%x(k) = x1 + (i-1)*(x2-x1)/(fg%nx - 1)
                fg%y(k) = yj
                fg%index(i,j) = k
                enddo
            enddo
    else if (point_style == 3) then
        read(fgmax_unit,*) n12, n23
        read(fgmax_unit,*) x1,y1
        read(fgmax_unit,*) x2,y2
        read(fgmax_unit,*) x3,y3
        read(fgmax_unit,*) x4,y4
        fg%npts = n12*n23
        allocate(fg%x(1:fg%npts), fg%y(1:fg%npts))
        
        k = 0
        do j=1,n23
            eta = (j-1)/(n23-1.d0)
            x14 = x1 + eta*(x4-x1)
            y14 = y1 + eta*(y4-y1)
            x23 = x2 + eta*(x3-x2)
            y23 = y2 + eta*(y3-y2)
            do i=1,n12
                k = k+1
                xi = (i-1)/(n12-1.d0)
                fg%x(k) = x14 + xi*(x23 - x14)
                fg%y(k) = y14 + xi*(y23 - y14)
                enddo
            enddo
    else if (point_style == 4) then
        ! in this case read in a file name for a file in 
        ! topotype=3 format that contains 0 at points not to be used,
        ! and 1 (or maybe an index > 0) at the desired fgmax points
        read(fgmax_unit,*) fname2
        !close(unit=FG_UNIT)
        write(6,*) 'Reading fgmax points from '
        write(6,*) '    ',trim(fname2)
        
        call read_topo_header(fname2,3,fg%nx,fg%ny,fg%xll,fg%yll, &
                         fg%xhi,fg%yhi,fg%dx,fg%dy)

        open(unit=FG_UNIT,file=trim(fname2),status='old')
        ! Skip over header lines read above:
        do i=1,6
            read(FG_UNIT,*)
            enddo
        
        allocate(fg%index(fg%nx, fg%ny)) ! to store index into list of pts
        allocate(fg_row(fg%nx))          ! temporary for one row
        fg_npts_max = fg%nx * fg%ny
        allocate(fg%x(1:fg_npts_max), fg%y(1:fg_npts_max))  ! list of pts
        
        k = 0
        fg%index = 0
        do j=1,fg%ny
            jj = fg%ny - j + 1  ! since topo-style file goes from N to S
            read(FG_UNIT,*) (fg_row(i), i=1,fg%nx)
            fg_y = fg%yll + (jj-1)*fg%dy
            !write(6,*) '+++ fg_y = ',fg_y
            do i=1,fg%nx
                if (fg_row(i) > 0) then
                    k = k+1
                    fg%index(i,jj) = k
                    fg%x(k) = fg%xll + (i-1)*fg%dx
                    fg%y(k) = fg_y
                    if ((fg_row(i)>1) .and. (fg_row(i) /= k)) then
                        write(6,*) '*** fg index mismatch, ',fg_row(i),k
                        endif
                    endif
                enddo
            enddo
        fg%npts = k
        write(6,*) 'npts = ',fg%npts
            
    else
        write(6,*) '*** Unexpected value of point_style in fgmax_read: ',point_style
        write(6,*) '*** Note that format of fgmax file has changed, see documentation'
        stop
        endif


    ! needed to allocate fg%klist array for use on each patch by all threads:
    maxthreads = 1  ! if not using OpenMP
!$  maxthreads = omp_get_max_threads()

    ! needed for timing if printing at end of this routine:
    !call system_clock(clock_start,clock_rate)

    ! allocate and initialize arrays
    allocate(fg%valuemax(1:FG_NUM_VAL, 1:fg%npts))
    allocate(fg%levelmax(1:fg%npts))
    allocate(fg%aux(1:mxnest, 1:FG_NUM_AUX, 1:fg%npts))
    allocate(fg%auxdone(1:mxnest))
    allocate(fg%update_now(1:mxnest))
    allocate(fg%tmax(1:FG_NUM_VAL, 1:fg%npts))
    allocate(fg%t_last_updated(1:mxnest))
    allocate(fg%arrival_time(1:fg%npts))
    allocate(fg%klist(1:fg%npts, 0:maxthreads-1))

    fg%valuemax = FG_NOTSET
    fg%levelmax = 0
    fg%aux = FG_NOTSET
    fg%auxdone = .false.
    fg%update_now = .false.
    fg%tmax = FG_NOTSET
    fg%t_last_updated = fg%tstart_max - fg%dt_check - 1.d0
    fg%arrival_time = FG_NOTSET

    ! Set corners of bounding box.
    ! note that when point_style==4 these arrays are longer than fg%npts
    fg%x1bb = minval(fg%x(1:fg%npts))
    fg%x2bb = maxval(fg%x(1:fg%npts))
    fg%y1bb = minval(fg%y(1:fg%npts))
    fg%y2bb = maxval(fg%y(1:fg%npts))

    write(6,*) '+++ fgbb: ', fg%x1bb,fg%x2bb,fg%y1bb,fg%y2bb
    write(6,*) '+++ fgll: ', fg%xll, fg%yll, fg%nx, fg%ny
    write(6,*) '+++ fg%x(npts), fg%y(1): ',fg%x(fg%npts), fg%y(1)

    close(FG_UNIT)

    !call system_clock(clock_finish,clock_rate)
    !write(6,*) '+++ Done with fgmax_read, cpu time, clock_rate: ', &
    !        (clock_finish - clock_start), clock_rate
    !write(6,*) '+++ maxthreads, fg%npts, fg%klist_last: ', maxthreads, &
    !        fg%npts, fg%klist(fg%npts, maxthreads-1)

end subroutine fgmax_read

c     ==================================================================
      subroutine setaux(mbc,mx,my,mz,xlower,ylower,
     &                  zlower,dx,dy,dz,maux,aux,t0)
c     ==================================================================
c
c     # set auxiliary arrays
c
c     # acoustics in a heterogeneous medium:
c     #  aux(i,j,k,1) = impedance Z in (i,j) cell
c     #  aux(i,j,k,2) = sound speed c in (i,j) cell
c
c
      implicit double precision (a-h,o-z)
      double precision aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc,
     &               1-mbc:mz+mbc)
      common /comaux/ z1,c1,z2,c2


      do k = 1-mbc,mz+mbc
      do j = 1-mbc,my+mbc
      do i = 1-mbc,mx+mbc
               zcell = zlower + (k-0.5d0)*dz
               if (zcell .lt. 0.d0) then
                  aux(1,i,j,k) = z1
                  aux(2,i,j,k) = c1
                else
                  aux(1,i,j,k) = z2
                  aux(2,i,j,k) = c2
                endif
            enddo
         enddo
      enddo

      return
      end

c
c --------------------------------------------------------------------
c
       subroutine icall(val,aux,nrow,nvar,naux,
     .                  ilo,ihi,level,iputst)

       use amr_module
       implicit double precision (a-h, o-z)

       dimension val(nvar,nrow)
       dimension aux(naux,nrow)


c NEW INDEX ORDERING
       iadd   (ivar,i) = loc    + ivar-1 + nvar*(i-1)
       iaddaux(ivar,i) = locaux + ivar-1 + naux*(i-1)

c ::::::::::::::::::::::::::: ICALL :::::::::::::::::::::::::::::::
c
c    find intersecting grids at the same level. copy data from
c    intersecting grids to both val and aux arrays.
c
c    use larger definition of grids here - boundary data already in.
c    aux arrays also enlarged size.
c
c    iputst: where to copy values into. may not be in
c            location corresponding to ilo,ihi if
c            the patch has been periodically wrapped.

c    
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       mptr = lstart(level)

 10    if (mptr .eq. 0) go to 99
          iglo = node(ndilo,mptr) 
          ighi = node(ndihi,mptr)

c         # does it intersect?
c$$$          ixlo = max(iglo-nghost,ilo)
c$$$          ixhi = min(ighi+nghost,ihi)
c  how did ghost cells get in the allowable region? They are not filled
c  (since we may be interpolating from newly filled grids, not just grids
c  that have been primed with bcs to be advanced.
          ixlo = max(iglo,ilo)
          ixhi = min(ighi,ihi)


          if (ixlo .le. ixhi) then
              loc  = node(store1,mptr)
              locaux = node(storeaux,mptr)
              nx   = ighi - iglo + 1
              mitot = nx + 2*nghost
              do 30 i    = ixlo, ixhi
              do 20 ivar = 1, nvar
                  ialloc  =  iadd(ivar,i-iglo+nghost+1)
                  val(ivar,i-ilo+iputst)  =  alloc(ialloc)
 20           continue
              do 25 iaux = 1, naux
                  ialloc = iaddaux(iaux,i-iglo+nghost+1)
                  aux(iaux,i-ilo+iputst)  =  alloc(ialloc)
 25           continue
 30           continue
          endif
          mptr = node(levelptr, mptr)
          go to 10

 99   continue

c   if cells stick out of domain but not periodic then set elsewhere 
c   either setaux  and bc1amr. (called from routine that called this, e.g.
c   saveqc or filval)

        return
        end

!   =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
!   =====================================================
    implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for the acoustics equations.

!     # auxN(1,i) holds rho
!     # auxN(2,i) holds c
!     #  N = 1 for row below
!     #      2 for this row
!     #      3 for row above

!     # Split asdq into down-going flux bmasdq and up-going flux bpasdq.

    dimension     ql(meqn, 1-mbc:maxm+mbc)
    dimension     qr(meqn, 1-mbc:maxm+mbc)
    dimension   asdq(meqn, 1-mbc:maxm+mbc)
    dimension bmasdq(meqn, 1-mbc:maxm+mbc)
    dimension bpasdq(meqn, 1-mbc:maxm+mbc)
    dimension   aux1(maux, 1-mbc:maxm+mbc)
    dimension   aux2(maux, 1-mbc:maxm+mbc)
    dimension   aux3(maux, 1-mbc:maxm+mbc)


    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    do 20 i = 2-mbc, mx+mbc

!        # imp is used to flag whether wave is going to left or right,
!        # since material properties are different on the two sides

        if (imp == 1) then
!            # asdq = amdq, moving to left
            i1 = i-1
        else
!            # asdq = apdq, moving to right
            i1 = i
        endif

!        # The flux difference asdq is split into downward moving part
!        # traveling at speed -c relative to the medium below and
!        # an upward moving part traveling
!        # at speed +c relative to the medium above.

!        # Note that the sum of these parts does not give all of asdq
!        # since there is also reflection at the interfaces which decreases
!        # the flux.

!        # sound speed in each row of cells:
        cm = aux1(2,i1)
        c = aux2(2,i1)
        cp = aux3(2,i1)

!        # impedances:
        zm = aux1(1,i1)*aux1(2,i1)
        zz = aux2(1,i1)*aux2(2,i1)
        zp = aux3(1,i1)*aux3(2,i1)

    !        # transmitted part of down-going wave:
        a1 = (zz*asdq(1,i) + asdq(mv,i)) / (zz + zm)

!        # transmitted part of up-going wave:
        a2 = (asdq(1,i)*zz - asdq(mv,i)) / (zp + zz)

    !        # The down-going flux difference bmasdq is the product  -c * wave
    
        bmasdq(1,i) = -cm * a1
        bmasdq(mu,i) = 0.d0
        bmasdq(mv,i) = -cm * a1 * zm
    
    !        # The up-going flux difference bpasdq is the product  c * wave
    
        bpasdq(1,i) = cp * a2
        bpasdq(mu,i) = 0.d0
        bpasdq(mv,i) = -cp * a2 * zp
    
    20 END DO

    return
    end subroutine rpt2

subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! ============================================================================
!  Solves transverse Riemann problem for the multilayer shallow water 
!  equations in 2D with topography and wind forcing:
!    (rho_1 h_1)_t + (rho_1 h_1 u_1)_x + (rho_1 h_1 v_1)_y = 0
!    (rho_1 h_1 u_1)_t + (rho_1 h_1 u_1^2 + 1/2 g rho_1 h_1^2)_x + (rho_1 h_1 u_1 v_1)_y = -g rho_1 h_1(r(h_2)_x + B_x)
!    (rho_1 h_1 v_1)_t + (rho_1 h_1 u_1 v_1)_x + (rho_1 h_1 v_1^2 + 1/2 g rho_1 h_1^2)_y = -g rho_1 h_1(r(h_2)_y + B_y)
!    (rho_2 h_2)_t + (rho_2 h_2 u_2)_x + (rho_2 h_2 v_2)_y = 0
!    (rho_2 h_2 u_2)_t + (rho_2 h_2 u_2^2 + 1/2 g rho_2 h_2^2)_x + (rho_2 h_2 u_2 v_2)_y = -g rho_2 h_2(h_1 + B)_x
!    (rho_2 h_2 v_2)_t + (rho_2 h_2 u_2 v_2)_x + (rho_2 h_2 v_2^2 + 1/2 g rho_2 h_2^2)_y = -g rho_2 h_2(h_1 + B)_y
!
!  On input, ql contains the state vector at the left edge of each cell and qr
!  contains the state vector at the right edge of each cell
!
!           |            |          
!    qr(i-1)|ql(i)  qr(i)|ql(i+1)   
! ----------|------------|----------
!    i-1          i         i+1
!
!  The i-1/2 Riemann problem has left state qr(i-1) and right state ql(i)
!
!  If ixy == 1 then the sweep direction is x, ixy == 2 implies the y direction
!  if imp == 1 then the split is in the negative direction, imp == 2 positive
!
!  Kyle T. Mandli (10-13-2010)
! ==============================================================================
!  Note that this version does not work with PyClaw due to missing parameters
!   from the modules.
! ==============================================================================

    use amr_module, only: mcapa
    
    use geoclaw_module, only: g => grav, rho, earth_radius, pi
    use geoclaw_module, only: coordinate_system

    use multilayer_module, only: num_layers, eigen_method, inundation_method
    use multilayer_module, only: eigen_func, inundation_eigen_func
    use multilayer_module, only: dry_tolerance, aux_layer_index

    implicit none

    ! Input arguments
    integer, intent(in) :: ixy,maxm,meqn,mwaves,mbc,mx,imp,maux
    double precision, dimension(meqn,1-mbc:maxm+mbc), intent(in) :: ql,qr
    double precision, dimension(meqn,1-mbc:maxm+mbc), intent(inout) :: asdq
    double precision, dimension(maux,1-mbc:maxm+mbc), intent(in) :: aux1,aux2,aux3
    
    ! Ouput
    double precision, dimension(meqn,1-mbc:maxm+mbc), intent(out) :: bmasdq,bpasdq
    
    ! Local storage
    integer :: i,j,m,mw,n_index,t_index,info
    double precision :: dxdcm,dxdcp
    double precision, dimension(3) :: b
    double precision, dimension(6) :: s,delta,pivot
    double precision, dimension(6,6) :: eig_vec,A
    
    ! Single layer solver storage
    double precision :: ql_sl(3),qr_sl(3)
    double precision :: aux1_sl(3,2),aux2_sl(3,2),aux3_sl(3,2)
    double precision :: asdq_sl(3),bmasdq_sl(3),bpasdq_sl(3)
    
    double precision :: ts(6),teig_vec(6,6)
    
    integer :: layer_index
    logical :: dry_state_l(2),dry_state_r(2)
    double precision :: h(2),hu(2),hv(2),u(2),v(2),h_hat(2),gamma
    double precision :: alpha(4)
    
    ! Output array intializations
    bmasdq = 0.d0
    bpasdq = 0.d0

    ! Normal and transverse sweep directions
    if (ixy == 1) then
        n_index = 2
        t_index = 3
    else
        n_index = 3
        t_index = 2
    endif
    
    ! ========================================================================
    ! Loop over each cell and decompose fluctuations into transverse waves 
    !  if ixy == 1, and imp == 1 splitting amdq into up and down going
    !  if ixy == 1, and imp == 2 splitting apdq into up and down going
    !  if ixy == 2, and imp == 1 splitting bmdq into left and right going
    !  if ixy == 2, and imp == 2 splitting bpdq into left and right going
    ! ========================================================================
    do i=2-mbc,mx+mbc        
        ! Parse states and pick out important states
        do j=1,2
            layer_index = 3*(j-1)
            ! Solving in the left grid cell (A^-\Delta Q)
            if (imp == 1) then
                h(j) = qr(layer_index + 1,i-1) / rho(j)
                hu(j) = qr(layer_index + n_index,i-1) / rho(j)
                hv(j) = qr(layer_index + t_index,i-1) / rho(j)
                
                b(3) = aux3(1,i-1)
                b(2) = aux2(1,i-1)
                b(1) = aux1(1,i-1)
                
                h_hat(1) = aux2(aux_layer_index,i-1)
                h_hat(2) = aux2(aux_layer_index+1,i-1)
            ! Solving in the right grid cell (A^+ \Delta Q)
            else
                h(j) = ql(layer_index + 1,i) / rho(j)
                hu(j) = ql(layer_index + n_index,i) / rho(j)
                hv(j) = ql(layer_index + t_index,i) / rho(j)
                
                b(3) = aux3(1,i)
                b(2) = aux2(1,i)
                b(1) = aux1(1,i)
                
                h_hat = aux2(aux_layer_index:aux_layer_index+1,i)
            endif
                
            if (h(j) < dry_tolerance(j)) then
                u(j) = 0.d0
                v(j) = 0.d0
            else
                u(j) = hu(j) / h(j)
                v(j) = hv(j) / h(j)
            endif
        enddo
        
        ! ====================================================================
        !  Check for dry states in the bottom layer, 
        !  This is if we are right next to a wall, use single layer solver
        if (h(1) < dry_tolerance(1) .or. h(2) < dry_tolerance(2)) then
            ! Storage for single layer rpt2
            if (h(1) < dry_tolerance(1)) then
                ql_sl = ql(1:3,i) / rho(1)
                qr_sl = qr(1:3,i-1) / rho(1)
                asdq_sl = asdq(1:3,i) / rho(1)
            else if (h(2) < dry_tolerance(2)) then
                ql_sl = ql(4:6,i) / rho(2)
                qr_sl = qr(4:6,i-1) / rho(2)
                asdq_sl = asdq(4:6,i) / rho(2)
            else
                print *, "Invalid dry-state found."
                print *, "  h = ", h
                stop
            end if

            aux1_sl = aux1(1:3,i-1:i)
            aux2_sl = aux2(1:3,i-1:i)
            aux3_sl = aux3(1:3,i-1:i)
            
            ! Call solve
            call rpt2_single_layer(ixy,imp,ql_sl,qr_sl,aux1_sl,aux2_sl, &
                                   aux3_sl,asdq_sl,bmasdq_sl,bpasdq_sl)
            
            if (h(1) < dry_tolerance(1)) then
                bmasdq(1:3,i) = bmasdq_sl * rho(1)
                bpasdq(1:3,i) = bpasdq_sl * rho(1)
            else if (h(2) < dry_tolerance(2)) then
                bmasdq(4:6,i) = bmasdq_sl * rho(2)
                bpasdq(4:6,i) = bpasdq_sl * rho(2)
            end if
            cycle
        endif
        
        ! ====================================================================
        ! Two-layers with no dry states in the vicinity
        ! Compute eigenvector matrix - Linearized system
        if (eigen_method == 1) then
            call eigen_func(h_hat,h_hat,v,v,u,u,t_index,n_index,s,eig_vec)
        else
            call eigen_func(h,h,v,v,u,u,t_index,n_index,s,eig_vec)
        endif

        ! ====================================================================
        !  Solve projection onto eigenvectors - Use LAPACK's dgesv routine
        !    N - (int) - Number of linear equations (6)
        !    NRHS - (int) - Number of right hand sides (1)
        !    A - (dp(6,6)) - Coefficient matrix, in this case eig_vec
        !    LDA - (int) - Leading dimension of A (6)
        !    IPIV - (int(N)) - Pivot indices
        !    B - (dp(LDB,NRHS)) - RHS of equations (delta)
        !    LDB - (int) - Leading dimension of B (6)
        !    INFO - (int) - Status of result
        !  Note that the solution (betas) are in delta after the call
        delta = asdq(:,i) ! This is what we are splitting up
        A = eig_vec ! We need to do this as the return matrix is modified and
                    ! we have to use eig_vec again to compute fwaves
        call dgesv(6,1,A,6,pivot,delta,6,info)
        if (.not.(info == 0)) then
            print "(a,i2,a,i2)","In transverse solver:  ixy=",ixy," imp=",imp
            print "(a,i3)","  Error solving R beta = delta,",info
            print "(a,i3)","  Location: ",i
            print "(a,6d16.8)","  Eigenspeeds: ",s(:)
            print "(a)","  Eigenvectors:"
            do j=1,6
                print "(a,6d16.8)","  ",(eig_vec(j,mw),mw=1,6)
            enddo
            print "(6d16.8)",h,hu,hv
            stop
        endif

        ! Handle lat-long coordinate systems
        if (coordinate_system == 2) then
            if (ixy == 2) then
                dxdcp=(earth_radius*pi/180.d0)
                dxdcm = dxdcp
            else
                if (imp == 1) then
                    dxdcp = earth_radius*pi*cos(aux3(3,i-1))/180.d0
                    dxdcm = earth_radius*pi*cos(aux1(3,i-1))/180.d0
                else
                    dxdcp = earth_radius*pi*cos(aux3(3,i))/180.d0
                    dxdcm = earth_radius*pi*cos(aux1(3,i))/180.d0
                endif
            endif
        else
            dxdcp = 1.d0
            dxdcm = 1.d0
        endif
        
        ! ====================================================================
        !  Determine transverse fluctuations
        !  We also check to see if the fluctuation would enter a dry cell and
        !  skip that split if this is true
        do mw=1,mwaves
            if (s(mw) > 0.d0) then
                if (h(2) + b(2) < b(3)) then
                    bpasdq(1:3,i) = bpasdq(1:3,i) + dxdcp * s(mw) * delta(mw) * eig_vec(1:3,mw)
                else
                    bpasdq(:,i) = bpasdq(:,i) + dxdcp * s(mw) * delta(mw) * eig_vec(:,mw)
                endif
            else if (s(mw) < 0.d0) then
                if (h(2) + b(2) < b(1)) then
                    bmasdq(1:3,i) = bmasdq(1:3,i) + dxdcm * s(mw) * delta(mw) * eig_vec(1:3,mw)
                else
                    bmasdq(:,i) = bmasdq(:,i) + dxdcm * s(mw) * delta(mw) * eig_vec(:,mw)
                endif
            endif
        enddo
    enddo

end subroutine rpt2


subroutine rpt2_single_layer(ixy,imp,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! Single layer point-wise transverse Riemann solver using an einfeldt Jacobian
! Note that there have been some changes to variable definitions in this
! routine from the original vectorized one. 
!
! Adapted from geoclaw 4-23-2011

    use amr_module, only: mcapa

    use geoclaw_module, only: g => grav, earth_radius, pi, coordinate_system
    use multilayer_module, only: num_layers, eigen_method, inundation_method
    use multilayer_module, only: dry_tolerance

    implicit none

    integer, parameter :: meqn = 3
    integer, parameter :: mwaves = 3

    integer, intent(in) :: ixy,imp

    real(kind=8), intent(in) :: ql(meqn) ! = ql(i,meqn)
    real(kind=8), intent(in) :: qr(meqn) ! = qr(i-1,meqn)
    real(kind=8), intent(in out) :: asdq(meqn)
    real(kind=8), intent(in out) :: bmasdq(meqn)
    real(kind=8), intent(in out) :: bpasdq(meqn)
    ! Since we need two values of aux, 1 = i-1 and 2 = i
    real(kind=8), intent(in) :: aux1(3,2)
    real(kind=8), intent(in) :: aux2(3,2)
    real(kind=8), intent(in) :: aux3(3,2)

    real(kind=8) :: s(3)
    real(kind=8) :: r(3,3)
    real(kind=8) :: beta(3)
    real(kind=8) :: abs_tol
    real(kind=8) :: hl,hr,hul,hur,hvl,hvr,vl,vr,ul,ur,bl,br
    real(kind=8) :: uhat,vhat,hhat,roe1,roe3,s1,s2,s3,s1l,s3r
    real(kind=8) :: delf1,delf2,delf3,dxdcd,dxdcu
    real(kind=8) :: dxdcm,dxdcp,topo1,topo3,eta,tol

    integer ::  m,mw,mu,mv
    
    tol = dry_tolerance(1)
    abs_tol = tol

    if (ixy.eq.1) then
     mu = 2
     mv = 3
    else
     mu = 3
     mv = 2
    endif


       hl=qr(1)
       hr=ql(1)
       hul=qr(mu)
       hur=ql(mu)
       hvl=qr(mv)
       hvr=ql(mv)

!===========determine velocity from momentum===========================
       if (hl.lt.abs_tol) then
          hl=0.d0
          ul=0.d0
          vl=0.d0
       else
          ul=hul/hl
          vl=hvl/hl
       endif

       if (hr.lt.abs_tol) then
          hr=0.d0
          ur=0.d0
          vr=0.d0
       else
          ur=hur/hr
          vr=hvr/hr
       endif

       do mw=1,mwaves
          s(mw)=0.d0
          beta(mw)=0.d0
          do m=1,meqn
             r(m,mw)=0.d0
          enddo
       enddo
      dxdcp = 1.d0
      dxdcm = 1.d0

       if (hl.le.dry_tolerance(1).and.hr.le.dry_tolerance(1)) go to 90

       !check and see if cell that transverse waves are going in is high and dry
       if (imp.eq.1) then
            eta = qr(1) + aux2(1,1)
            topo1 = aux1(1,1)
            topo3 = aux3(1,1)
       else
            eta = ql(1) + aux2(1,2)
            topo1 = aux1(1,2)
            topo3 = aux3(1,2)
       endif
       if (eta.lt.max(topo1,topo3)) go to 90

      if (coordinate_system == 2) then
         if (ixy.eq.2) then
            dxdcp=(earth_radius*pi/180.d0)
            dxdcm = dxdcp
         else
            if (imp.eq.1) then
               dxdcp = earth_radius*pi*cos(aux3(3,1))/180.d0
               dxdcm = earth_radius*pi*cos(aux1(3,1))/180.d0
            else
               dxdcp = earth_radius*pi*cos(aux3(3,2))/180.d0
               dxdcm = earth_radius*pi*cos(aux1(3,2))/180.d0
            endif
         endif
      endif


!=====Determine some speeds necessary for the Jacobian=================
            vhat=(vr*dsqrt(hr))/(dsqrt(hr)+dsqrt(hl)) + &
             (vl*dsqrt(hl))/(dsqrt(hr)+dsqrt(hl))

            uhat=(ur*dsqrt(hr))/(dsqrt(hr)+dsqrt(hl)) + &
             (ul*dsqrt(hl))/(dsqrt(hr)+dsqrt(hl))
            hhat=(hr+hl)/2.d0

            roe1=vhat-dsqrt(g*hhat)
            roe3=vhat+dsqrt(g*hhat)

            s1l=vl-dsqrt(g*hl)
            s3r=vr+dsqrt(g*hr)

            s1=dmin1(roe1,s1l)
            s3=dmax1(roe3,s3r)

            s2=0.5d0*(s1+s3)

           s(1)=s1
           s(2)=s2
           s(3)=s3
!=======================Determine asdq decomposition (beta)============
         delf1=asdq(1)
         delf2=asdq(mu)
         delf3=asdq(mv)

         beta(1) = (s3*delf1/(s3-s1))-(delf3/(s3-s1))
         beta(2) = -s2*delf1 + delf2
         beta(3) = (delf3/(s3-s1))-(s1*delf1/(s3-s1))
!======================End =================================================

!=====================Set-up eigenvectors===================================
         r(1,1) = 1.d0
         r(2,1) = s2
         r(3,1) = s1

         r(1,2) = 0.d0
         r(2,2) = 1.d0
         r(3,2) = 0.d0

         r(1,3) = 1.d0
         r(2,3) = s2
         r(3,3) = s3
!============================================================================
90      continue
!============= compute fluctuations==========================================

            do  m=1,meqn
               bmasdq(m)=0.0d0
               bpasdq(m)=0.0d0
            enddo
            do  mw=1,3
               if (s(mw).lt.0.d0) then
                 bmasdq(1) =bmasdq(1) + dxdcm*s(mw)*beta(mw)*r(1,mw)
                 bmasdq(mu)=bmasdq(mu)+ dxdcm*s(mw)*beta(mw)*r(2,mw)
                 bmasdq(mv)=bmasdq(mv)+ dxdcm*s(mw)*beta(mw)*r(3,mw)
               elseif (s(mw).gt.0.d0) then
                 bpasdq(1) =bpasdq(1) + dxdcp*s(mw)*beta(mw)*r(1,mw)
                 bpasdq(mu)=bpasdq(mu)+ dxdcp*s(mw)*beta(mw)*r(2,mw)
                 bpasdq(mv)=bpasdq(mv)+ dxdcp*s(mw)*beta(mw)*r(3,mw)
               endif
            enddo


end subroutine rpt2_single_layer

! This code has been adapted for vectorization. 
! For more details on how to use it, see the Makefile of the chile2010 example.

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx, &
        ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
    ! =====================================================
    use geoclaw_module, only: g => grav, tol => dry_tolerance
    use geoclaw_module, only: coordinate_system,earth_radius,deg2rad

    implicit none
    !
    !     # Riemann solver in the transverse direction using an einfeldt
    !     Jacobian.

    !-----------------------last modified 1/10/05----------------------

    integer, parameter :: DP = kind(1.d0)

    real(kind=DP) :: ql(1-mbc:maxm+mbc, meqn)
    real(kind=DP) :: qr(1-mbc:maxm+mbc, meqn)
    real(kind=DP) :: asdq(1-mbc:maxm+mbc,meqn)
    real(kind=DP) :: bmasdq(1-mbc:maxm+mbc,meqn)
    real(kind=DP) :: bpasdq(1-mbc:maxm+mbc,meqn)
    real(kind=DP) :: aux1(1-mbc:maxm+mbc,maux)
    real(kind=DP) :: aux2(1-mbc:maxm+mbc,maux)
    real(kind=DP) :: aux3(1-mbc:maxm+mbc,maux)
    real(kind=DP) :: s(3)
    real(kind=DP) :: r(3,3)
    real(kind=DP) :: beta(3)
    real(kind=DP) :: abs_tol
    real(kind=DP) :: hl,hr,hul,hur,hvl,hvr,vl,vr,ul,ur,bl,br
    real(kind=DP) :: uhat,vhat,hhat,roe1,roe3,s1,s2,s3,s1l,s3r
    real(kind=DP) :: delf1,delf2,delf3
    real(kind=DP) :: dxdcm,dxdcp,topo1,topo3,eta

    integer :: ixy,maxm,meqn,maux,mwaves,mbc,mx,imp
    integer :: i,m,mw,mu,mv
  

    abs_tol=tol

    if (ixy.eq.1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

#if defined(_OPENMP)
    !$OMP SIMD PRIVATE(hl,hr,hul,hur,hvl,hvr,s1,s2,s3, &
    !$OMP& dxdcm,dxdcp,delf1,delf2,delf3,topo1,topo3,beta,s,r)
#endif
    do i=2-mbc,mx+mbc
        hl=qr(i-1,1) 
        hr=ql(i,1) 
        hul=qr(i-1,mu) 
        hur=ql(i,mu) 
        hvl=qr(i-1,mv) 
        hvr=ql(i,mv)

        do mw=1,mwaves
            s(mw)=0.d0
            beta(mw)=0.d0
            do m=1,meqn
                r(mw,m)=0.d0
            enddo
        enddo
        
        ! check and see if cell that transverse waves are going in is high and dry
        if (imp.eq.1) then
            eta = qr(i-1,1)  + aux2(i-1,1)
            topo1 = aux1(i-1,1)
            topo3 = aux3(i-1,1)
        else
            eta = ql(i,1) + aux2(i,1)
            topo1 = aux1(i,1)
            topo3 = aux3(i,1)
        endif

        if (eta<max(topo1,topo3)) then
            hl = 0.d0
            hr = 0.d0
        endif 

        call solve_single_rpt(g, tol, hl, hul, hvl, hr, hur, hvr, s1, s2, s3)

        s(1)=s1
        s(2)=s2
        s(3)=s3
        !=======================Determine asdq decomposition (beta)============
        delf1=asdq(i,1)
        delf2=asdq(i,mu)
        delf3=asdq(i,mv)

        beta(1) = (s3*delf1/(s3-s1))-(delf3/(s3-s1))
        beta(2) = -s2*delf1 + delf2
        beta(3) = (delf3/(s3-s1))-(s1*delf1/(s3-s1))
        !======================End =================================================

        !=====================Set-up eigenvectors===================================
        r(1,1) = 1.d0
        r(1,2) = s2
        r(1,3) = s1

        r(2,1) = 0.d0
        r(2,2) = 1.d0
        r(2,3) = 0.d0

        r(3,1) = 1.d0
        r(3,2) = s2
        r(3,3) = s3
        !============================================================================
        90      continue
        !============= compute fluctuations==========================================

        dxdcp = 1.d0
        dxdcm = 1.d0

        if (coordinate_system.eq.2) then
            if (ixy.eq.2) then
                dxdcp=(earth_radius*deg2rad)
                dxdcm = dxdcp
            else
                if (imp.eq.1) then
                    dxdcp = earth_radius*cos(aux3(i-1,3))*deg2rad
                    dxdcm = earth_radius*cos(aux1(i-1,3))*deg2rad
                else
                    dxdcp = earth_radius*cos(aux3(i,3))*deg2rad
                    dxdcm = earth_radius*cos(aux1(i,3))*deg2rad
                endif
            endif
        endif

        bmasdq(i,:)=0.0d0
        bpasdq(i,:)=0.0d0
        do mw=1,3
            if (s(mw)<0.d0) then
                bmasdq(i,1) =bmasdq(i,1) + dxdcm*s(mw)*beta(mw)*r(mw,1)
                bmasdq(i,mu)=bmasdq(i,mu)+ dxdcm*s(mw)*beta(mw)*r(mw,2)
                bmasdq(i,mv)=bmasdq(i,mv)+ dxdcm*s(mw)*beta(mw)*r(mw,3)
            elseif (s(mw)>0.d0) then
                bpasdq(i,1) =bpasdq(i,1) + dxdcp*s(mw)*beta(mw)*r(mw,1)
                bpasdq(i,mu)=bpasdq(i,mu)+ dxdcp*s(mw)*beta(mw)*r(mw,2)
                bpasdq(i,mv)=bpasdq(i,mv)+ dxdcp*s(mw)*beta(mw)*r(mw,3)
            endif
        enddo
        !========================================================================
    enddo
    
    return
end subroutine 


subroutine solve_single_rpt(g, tol, hl, hul, hvl, hr, hur, hvr, &
        s1, s2, s3)
    implicit none
    integer, parameter :: DP = kind(1.d0)

    !real(kind=DP), intent(inout) :: dxdcm, dxdcp
    real(kind=DP), intent(in) :: g, tol, hul, hvl, hur, hvr
    real(kind=DP), intent(out) :: s1, s2, s3
    real(kind=DP), intent(inout) :: hl, hr 
    real(kind=DP) :: ul, vl, ur, vr, roe1, roe3, s1l, s3r,uhat,vhat,hhat, &
        sqhl, sqhr
    !===========determine velocity from momentum===========================
    if (hl<tol) then
        hl=0.d0
        ul=0.d0
        vl=0.d0
    else
        ul=hul/hl
        vl=hvl/hl
    endif

    if (hr<tol) then
        hr=0.d0
        ur=0.d0
        vr=0.d0
    else
        ur=hur/hr
        vr=hvr/hr
    endif


    if (hl <= tol .and. hr <= tol) then
        s1 = 0.d0
        s2 = 0.d0
        s3 = 0.d0
    else
        !=====Determine some speeds necessary for the Jacobian=================
        sqhr = sqrt(hr)
        sqhl = sqrt(hl)
    !---------------------------------------
        vhat=(vr*sqhr)/(sqhr+sqhl) + (vl*sqhl)/(sqhr+sqhl)
        uhat=(ur*sqhr)/(sqhr+sqhl) + (ul*sqhl)/(sqhr+sqhl)
    !---------------------------------------
        hhat=(hr+hl)*0.5d0
    !---------------------------------------
        roe1=vhat-sqrt(g*hhat)
        roe3=vhat+sqrt(g*hhat)
    !---------------------------------------
        s1l=vl-sqrt(g*hl)
        s3r=vr+sqrt(g*hr)

        s1=min(roe1,s1l)
        s3=max(roe3,s3r)
        s2=0.5d0*(s1+s3)
    endif
end subroutine

c
c ----------------------------------------------------------
c
      subroutine copysol(valbig,val,nvar,mitot,nghost,
     1                   midub,ngbig)
c
      implicit double precision (a-h,o-z)

      dimension  valbig(nvar,midub), val(nvar,mitot)
c
c copy solution into grid with different number ghost cells
c
       do 10 i = nghost+1, mitot-nghost
       do 10 ivar = 1, nvar
          valbig(ivar,i-nghost+ngbig) = val(ivar,i)
 10    continue
c
       return
       end

c
c -------------------------------------------------------------
c
      subroutine bufnst (nvar,naux,numbad,lcheck,iflags,
     .                   isize,jsize,ksize)
c
      use amr_module
      implicit double precision (a-h,o-z)


      integer*1  iflags (0:isize+1,0:jsize+1,0:ksize+1)
      logical    vtime
      data       vtime/.false./
c
 
c :::::::::::::::::::::::::: BUFNST :::::::::::::::::::::::::::::::::::
c  after error estimation, need to tag the cell for refinement,
c  buffer the tags, take care of level nesting, etc.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c
c copy flagged arrays in individual grids (now stored in loctmp)
c into 1 big iflag array (iflags). only do if tol>0, since otherwise no
c richardson error estimation took place
c
      mptr = lstart(lcheck)
 41   continue
      nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
      ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
      nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
      mitot  = nx + 2*nghost
      mjtot  = ny + 2*nghost
      mktot  = nz + 2*nghost
c     negative tol means richardson not done      
      if (tol .gt. 0) then    
         loctmp = node(store2, mptr)
         call setflags(iflags,isize,jsize,ksize,
     .                 alloc(loctmp),nvar,mitot,mjtot,mktot,mptr)
      endif 
c     still need to reclaim error est space from spest.f which was saved for possible errest reuse
      locbig = node(tempptr,mptr)
      call reclam(locbig,mitot*mjtot*mktot*nvar)
      mptr = node(levelptr,mptr)
      if (mptr .ne. 0) go to 41


      if (eprint) then
         write(outunit,*)" flagged points before buffering on level", 
     .                   lcheck
         do 47 kk = 1, ksize
           k = ksize + 1 - kk
         do 47 jj = 1, jsize
           j = jsize + 1 - jj
           write(outunit,100)(iflags(i,j,k),i=1,isize)
 100       format(80i1)
 47      continue
      endif
c
c  project finer grids to insure level nesting
      numpro = 0
      if (lcheck+2 .le. mxnest) then
         call projec(lcheck,numpro,iflags,isize,jsize,ksize)
      endif

      if (eprint) then
         write(outunit,*)" flagged points after projecting to level", 
     .                    lcheck
         write(outunit,*) " with ",numpro," additional points projected"
         do 49 kk = 1, ksize
           k = ksize + 1 - kk
         do 49 jj = 1, jsize
           j = jsize + 1 - jj
           write(outunit,100)(iflags(i,j,k),i=1,isize)
 49      continue
      endif

c
c  diffuse flagged points in all 4 directions to make buffer zones 
c  note that this code flags with a same value as true flagged
c  points, not a different number.
c
c    # first get scratch work space (not that other scratch
c    # arrays above have been reclaimed. 
c
c      ldom3 = igetsp((isize+2)*(jsize+2)*(ksize+2))
c
!--      do 55 inum = 1, ibuff
!--
!--          call shiftset(iflags,alloc(ldom3),+1, 0, 0,isize,jsize,ksize)
!--          call shiftset(iflags,alloc(ldom3),-1, 0, 0,isize,jsize,ksize)
!--          call shiftset(iflags,alloc(ldom3), 0,+1, 0,isize,jsize,ksize)
!--          call shiftset(iflags,alloc(ldom3), 0,-1, 0,isize,jsize,ksize)
!--          call shiftset(iflags,alloc(ldom3), 0, 0,+1,isize,jsize,ksize)
!--          call shiftset(iflags,alloc(ldom3), 0, 0,-1,isize,jsize,ksize)
!--
!-- 55   continue
      call shiftset(iflags, isize,jsize,ksize)

      if (eprint) then
         write(outunit,*)" flagged points after buffering on level", 
     .                    lcheck
         do 48 kk = 1, ksize
           k = ksize + 1 - kk
         do 48 jj = 1, jsize
           j = jsize + 1 - jj
           write(outunit,100)(iflags(i,j,k),i=1,isize)
 48      continue
      endif
c   
c   count up
c
       numbad = 0 
       do 82 i = 1, isize
       do 82 j = 1, jsize
       do 82 k = 1, ksize
         if (iflags(i,j,k) .ne. goodpt) numbad = numbad + 1
 82    continue
       if (eprint) write(outunit,116) numbad, lcheck
 116   format(i9,' points flagged on level ',i4)

c      call reclam(ldom3,(isize+2)*(jsize+2)*(ksize+2))

      return
      end

c
c
c
c     =====================================================
      subroutine qinit(meqn,mbc,mx,my,mz,xlower,ylower,zlower,
     &                 dx,dy,dz,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c
      implicit double precision (a-h,o-z)
c
      dimension   q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
c
c     # set initial data
c     ---------------------------
c
      q = 0.d0

c     # jump discontinuity aligned with jump in z,c:

      do  k = 1-mbc,mz+mbc
	    do j = 1-mbc,my+mbc
	       do i = 1-mbc,mx+mbc
               zcell = zlower + (k-0.5d0)*dz
               if (zcell .lt. 0.d0) then
                  q(1,i,j,k) = 1.d0
                else
                  q(1,i,j,k) = 0.d0
                endif
           enddo
        enddo
      enddo


      return
      end

c
c ---------------------------------------------------------
c
      subroutine restrt(nsteps,time,nvar)
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical   ee


      dimension intrtx(maxlv),intrty(maxlv),intrtz(maxlv),
     &          intrtt(maxlv)
      character*16  chkname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id
c
c     # HDF: Arrays which will hold output arrays.
c
      dimension  iqout(15), qout(4)
c
c     # HDF: Declare external HDF functions
c
      integer  sfstart, sfend
      external sfstart, sfend
c
c     # HDF: Set up HDF constants
c
      integer 	DFACC_READ, DFACC_WRITE, DFACC_CREATE 
      parameter(DFACC_READ = 1, DFACC_WRITE = 2, DFACC_CREATE = 4)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c :::::::::::::::::::::::::::: RESTRT ::::::::::::::::::::::::::::::::
c read back in the check point files written by subr. check.
c
c some input variables might have changed, and also the
c alloc array could have been written with a smaller size at checkpoint
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c     ###  make the file name showing the time step
c
      chkname = 'restart.data.hdf'
c     
c     # HDF: open hdf restart file.
c     
      sd_id = sfstart(chkname,DFACC_READ)
      if (sd_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to open HDF file',
     &        ' (call to sfstart in restrt_hdf.f)'
         STOP
      end if

      index = 0
      call read_integer_vector(sd_id,15,index,'iqout ',iqout)
      lenmax  = iqout(1)
      lendim  = iqout(2)
      isize   = iqout(3)
      lenf    = iqout(4)
      ibuf    = iqout(5)
      mstart  = iqout(6)
      ndfree  = iqout(7)
      lfine   = iqout(8)
      iorder  = iqout(9)
      mxnold  = iqout(10)
      kcheck1 = iqout(11)
      nsteps  = iqout(12)
      matlabu = iqout(13)
      lentot  = iqout(14)
      ndfree_bnd  = iqout(15)

      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'icheck',icheck)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'lstart',lstart)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'newstl',newstl)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'listsp',listsp)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'intratx',intrtx)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'intraty',intrty)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'intratz',intrtz)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'intratt',intrtt)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'iregsz',iregsz)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'jregsz',jregsz)
      index = index + 1
      call read_integer_vector(sd_id,maxlv,index,'kregsz',kregsz)
      index = index + 1
      call read_integer_array(sd_id,lfdim,2,index,'lfree ',lfree)
      index = index + 1
      call read_integer_array(sd_id,rsize,maxgr,index,'node  ',node)

c     # HDF: DFNT_FLOAT64

      index = index + 1
      call read_double_vector(sd_id,4,index,'qout  ',qout)
      tl  = qout(1)
      time = qout(2)
      evol = qout(3)
      rvol = qout(4)

      index = index + 1
      call read_double_vector(sd_id,maxlv,index,'hxposs',hxposs)
      index = index + 1
      call read_double_vector(sd_id,maxlv,index,'hyposs',hyposs)
      index = index + 1
      call read_double_vector(sd_id,maxlv,index,'hzposs',hzposs)
      index = index + 1
      call read_double_vector(sd_id,maxlv,index,'possk ',possk)
      index = index + 1
      call read_double_vector(sd_id,10,index,'rvoll ',rvoll)
      index = index + 1
      call read_double_vector(sd_id,lendim,index,'alloc ',alloc)
      
      index = index + 1
      call read_double_array(sd_id,rsize,maxgr,index,'rnode ',rnode)
c
c     # HDF: Close HDF file.
c
      istat = sfend(sd_id)
      if (istat.eq.FAIL) then
         WRITE(*,*) 'Failed to close SDS',
     &        ' (call to sfend in restrt_hdf.f)'
         STOP
      end if

      write(outunit,100) nsteps,time
      write(6,100) nsteps,time
  100 format(/,' RESTARTING the calculation after ',i5,' steps',
     1      /,'  (time = ',e15.7,')')
c
c     error checking that refinement ratios have not changed
c
      do i = 1, mxnold-1
        if ( (intratx(i) .ne. intrtx(i)) .or.
     .       (intraty(i) .ne. intrty(i)) .or.
     .       (intratz(i) .ne. intrtz(i)) .or.
     .       (kratio(i) .ne.  intrtt(i)) ) then
        write(outunit,*) 
     .  " not allowed to change existing refinement ratios on Restart"
        write(*,*)
     .  " not allowed to change existing refinement ratios on Restart"
        write(outunit,*)" Old ratios:"
        write(*,*)      " Old ratios:"
        write(outunit,903)(intrtx(j),j=1,mxnold-1)
        write(*,903)      (intrtx(j),j=1,mxnold-1)
        write(outunit,903)(intrty(j),j=1,mxnold-1)
        write(*,903)      (intrty(j),j=1,mxnold-1)
        write(outunit,903)(intrtz(j),j=1,mxnold-1)
        write(*,903)      (intrtz(j),j=1,mxnold-1)
        write(outunit,903)(intrtt(j),j=1,mxnold-1)
        write(*,903)      (intrtt(j),j=1,mxnold-1)
 903    format(6i3)
        stop
       endif
      end do
c
c     adjust free list of storage in case size has changed.
c
      idif = memsize - isize
      if (idif .gt. 0) then
         lfree(lenf,1) = isize + 2
         call reclam(isize+1,idif)
      else if (idif .lt. 0) then
         write(outunit,900) isize, memsize
         write(*,900)       isize, memsize
  900    format(' size of alloc not allowed to shrink with restart ',/,
     .         ' old size ',i7,' current size  ',i7)
         stop
      endif
c
c     adjust storage in case mxnest has changed - only allow it to increase,
c     and only at non-multiples of error estimation on old mxnest.
c
      if (mxnest .eq. mxnold) go to 99

      if (mxnest .lt. mxnold) then
         if (lfine .lt. mxnest) then
            go to 99
         else
            write(outunit,901) mxnold, mxnest
            write(*,      901) mxnold, mxnest
  901       format(' only allow mxnest to increase: ',/,
     &            '  old mxnest ',i4, ' new mxnest ',i4)
            stop
         endif
      endif

c     see if simple enough situation to allow changing mxnest
      ee = .false.
      do 10 level = 1, mxnold
         if (icheck(level) .ge. kcheck) then
            ee = .true.
            kmust = icheck(level)
         endif
   10 continue
      if (ee) then
         write(outunit,902) mxnold, mxnest, kmust
         write(*      ,902) mxnold, mxnest, kmust
  902    format(/,' only allow changes in mxnest (from ',
     &         i4,' to ',i4,')',/,
     &         ' when not time to error estimate: ',/,
     &         ' please run a few more steps before changing ',/,
     &         ' so that # of steps not greater then kcheck',/,
     &         ' or make kcheck > ',i4 )
         stop
      else
c        #  add second storage location to previous mxnest level
         mptr = lstart(mxnold)
   15    if (mptr .eq. 0) go to 25
         mitot = node(ndihi,mptr)-node(ndilo,mptr)+1+2*nghost
         mjtot = node(ndjhi,mptr)-node(ndjlo,mptr)+1+2*nghost
         mktot = node(ndkhi,mptr)-node(ndklo,mptr)+1+2*nghost
         node(store2,mptr) = igetsp(mitot*mjtot*mktot*nvar)
         mptr = node(levelptr,mptr)
         go to 15
   25    continue
      endif
c
c     # add new info. to spatial and counting arrays
   99 level = lfine + 1
   35 if (level .gt. mxnest) go to 45
      hxposs(level) = hxposs(level-1) / dble(intratx(level-1))
      hyposs(level) = hyposs(level-1) / dble(intraty(level-1))
      hzposs(level) = hzposs(level-1) / dble(intratz(level-1))
      possk (level) = possk (level-1) / dble(kratio(level-1))
      iregsz(level) = iregsz(level-1) * dble(intratx(level-1))
      jregsz(level) = jregsz(level-1) * dble(intraty(level-1))
      kregsz(level) = kregsz(level-1) * dble(intratz(level-1))
      level         = level + 1
      go to 35
   45 continue
c
c
      return
      end
c=================================================================
c     # HDF: NOTE THAT ALL INTEGER HDF CHECKPOINTING ROUTINES FOR
c     #      BOTH WRITING AND READING ARE INCLUDED HERE, ALTHOUGH
c     #      THE INTEGER WRITING ROUTINES ARE CALLED IN check_hdf.f.
c     #      THIS IS DONE TO PREVENT COMPILER ERRORS SINCE THE SAME
c     #      HDF ROUTINES ARE USED TO READ BOTH INTEGER AND DOUBLE
c     #      PRECISION ARRAYS.
c=================================================================
      subroutine read_integer_vector(sd_id,idims,index,qname,iout)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  iout(idims), istart(1), istride(1), iedges(1)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfrdata, sfselect, sfendacc
      external sfcreate, sfrdata, sfselect, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Select dataset in HDF file.
c
      sds_id = sfselect(sd_id,index)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to select data set for  variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfselect in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for integer vector.
c
      istart(1) = 0
      iedges(1) = idims
      istride(1) = 1
c
c     # HDF: read integer vector from hdf file.
c
      istat = sfrdata(sds_id,istart,istride,iedges,iout)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to read variable ', qname,
     &        ' from restart HDF file'
         WRITE(*,*) '(call to sfrdata in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to integer vector in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in restrt_hdf.f)'
         STOP
      end if

      return
      end

c==========================================================
      subroutine read_integer_array(sd_id,idim1,idim2,index,qname,iout)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  istart(2), istride(2), iedges(2)
      dimension  iout(idim1,idim2)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfrdata, sfselect, sfendacc
      external sfcreate, sfrdata, sfselect, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Select dataset in HDF file.
c
      sds_id = sfselect(sd_id,index)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to select data set for  variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfselect in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for integer array.
c
      istart(1) = 0
      istart(2) = 0
      iedges(1) = idim1
      iedges(2) = idim2
      istride(1) = 1
      istride(2) = 1
c
c     # HDF: read integer array from hdf file.
c
      istat = sfrdata(sds_id,istart,istride,iedges,iout)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to read variable ', qname,
     &        ' from restart HDF file'
         WRITE(*,*) '(call to sfrdata in restrt_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to integer array in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in restrt_hdf.f)'
         STOP
      end if

      return
      end

c==========================================================
      subroutine dump_integer_vector(sd_id,idims,qname,iout)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  iout(idims), istart(1), istride(1), iedges(1), idim(1)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfwdata, sfscompress, sfendacc
      external sfcreate, sfwdata, sfscompress, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   DFNT_FLOAT64, DFNT_INT32
      parameter(DFNT_FLOAT64 = 6, DFNT_INT32 = 24)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Set up compression constants for HDF file.
c
      integer   COMP_CODE_DEFLATE, DEFLATE_LEVEL
      parameter (COMP_CODE_DEFLATE = 4, DEFLATE_LEVEL = 6)
c
c     # HDF: Create integer vector in HDF file.
c     #      NOTE THAT THE RANK MUST BE ONE.
c
      irank = 1 
      idim(1) = idims
      sds_id = sfcreate(sd_id,qname,DFNT_INT32,irank,idim)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to create variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfcreate in check_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for integer vector.
c
      istart(1) = 0
      iedges(1) = idims
      istride(1) = 1
c
c     # HDF: set compression mode and write data to hdf file.
c
      istat=sfscompress(sds_id,COMP_CODE_DEFLATE,DEFLATE_LEVEL)
      istat = sfwdata(sds_id,istart,istride,iedges,iout)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to write variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfwdata in check_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to integer vector in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in check_hdf.f)'
         STOP
      end if

      return
      end

c==========================================================
      subroutine dump_integer_array(sd_id,idim1,idim2,qname,iout)
      implicit double precision (a-h,o-z)
      character*6  qname
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id
      dimension  idims(2), istart(2), istride(2), iedges(2)
      dimension  iout(idim1,idim2)
c
c     # HDF: Declare external HDF functions
c
      integer  sfcreate, sfwdata, sfscompress, sfendacc
      external sfcreate, sfwdata, sfscompress, sfendacc
c
c     # HDF: Set up HDF constants
c
      integer   DFNT_FLOAT64, DFNT_INT32
      parameter(DFNT_FLOAT64 = 6, DFNT_INT32 = 24)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Set up compression constants for HDF file.
c
      integer   COMP_CODE_DEFLATE, DEFLATE_LEVEL
      parameter (COMP_CODE_DEFLATE = 4, DEFLATE_LEVEL = 6)
c
c     # HDF: Create integer array in HDF file.
c     #      NOTE THAT THE RANK MUST BE TWO.
c
      irank = 2
      idims(1) = idim1
      idims(2) = idim2
      sds_id = sfcreate(sd_id,qname,DFNT_INT32,irank,idims)
      if (sds_id.eq.FAIL) THEN
         WRITE(*,*) 'Failed to create variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfcreate in check_hdf.f)'
         STOP
      end if
c
c     # HDF: Set up dimensions for integer array.
c
      istart(1) = 0
      istart(2) = 0
      iedges(1) = idims(1)
      iedges(2) = idims(2)
      istride(1) = 1
      istride(2) = 1
c
c     # HDF: set compression mode and write data to hdf file.
c
      istat=sfscompress(sds_id,COMP_CODE_DEFLATE,DEFLATE_LEVEL)
      istat = sfwdata(sds_id,istart,istride,iedges,iout)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to write variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfwdata in check_hdf.f)'
         STOP
      end if
c
c     # HDF: End access to integer array in HDF file.
c
      istat = sfendacc(sds_id)  
      if (istat.eq.FAIL) THEN
         WRITE(*,*) 'Failed to end access to variable ', qname,
     &        ' in restart HDF file'
         WRITE(*,*) '(call to sfendacc in check_hdf.f)'
         STOP
      end if

      return
      end

c
c -----------------------------------------------------------
c
       subroutine setPhysBndryFlags(iflags,ilo,ihi,mbuff,level)

       use amr_module
       implicit double precision (a-h, o-z)

       integer*1  iflags(ilo-mbuff:ihi+mbuff)

c ****************************************************************
c  setPhysBndryFlags = if grid borders the physical domain then
c                 set domain flags to 1 in buffer zone. That way when shrink
c                 by 1 to get proper nested domain, you wont lose the first
c                 border cell of a grid
c
c                 flag array uses 0-based indexing
c              
c                 if periodic, then have to look elsewhere to see if
c                 last interior row/col that is flagged is ok.
c                 this is done in the calling routine that
c                 transfers flagged points to base grdis
c ****************************************************************

       if (ilo-mbuff .lt. 0 .and. .not. xperdom) then  ! grid extends out of left side of domain
c       set left flagged points to be ok
            do i = ilo-mbuff, -1
c             iflags(i) = iflags(0)   ! extend using whatever 1st col inside is
             iflags(i) = 1     ! set to 1 for bndry buffers that touch exterior domain
            end do
       endif

       if (ihi+mbuff .ge. iregsz(level) .and. .not. xperdom) then
c       set right flagged points to be ok
            do i = iregsz(level), ihi+mbuff
c             iflags(i) = iflags(iregsz(level)-1)
             iflags(i) = 1
            end do
       endif

       return
       end

! ==============================================================================
!  Storm Surge Module - Contains generic routines for dealing with storm surge
!    including AMR parameters and storm fields.  This module includes modules
!    for specific implementations of storms such as the Holland model.
! ==============================================================================
!                   Copyright (C) Clawpack Developers 2017
!  Distributed under the terms of the Berkeley Software Distribution (BSD)
!  license
!                     http://www.opensource.org/licenses/
! ==============================================================================

module storm_module

    use model_storm_module, only: model_storm_type, rotation
    use data_storm_module, only: data_storm_type

    implicit none

    logical, private :: module_setup = .false.

    ! Log file IO unit
    integer, parameter :: log_unit = 423

    ! Track file IO unit
    integer, parameter :: track_unit = 424

    ! Locations of wind and pressure fields
    integer :: wind_index, pressure_index

    ! Source term control and parameters
    logical :: wind_forcing, pressure_forcing

    ! Wind drag law support
    abstract interface
        real(kind=8) pure function drag_function(speed, theta)
            implicit none
            real(kind=8), intent(in) :: speed, theta
        end function drag_function
    end interface

    ! Function pointer to wind drag requested
    procedure (drag_function), pointer :: wind_drag

    ! AMR Parameters
    real(kind=8), allocatable :: R_refine(:), wind_refine(:)

    ! Storm object
    integer :: storm_specification_type
    real(kind=8) :: landfall = 0.d0
    type(model_storm_type), save :: model_storm
    type(data_storm_type), save :: data_storm

    ! Wind drag limit
    real(kind=8) :: WIND_DRAG_LIMIT = 3.5d-3

    ! Interface to each of the parameterized models
    abstract interface
        subroutine set_model_fields_def(maux, mbc, mx, my, xlower, ylower, &
                                      dx, dy, t, aux, wind_index,              &
                                      pressure_index, storm)

            use model_storm_module, only: model_storm_type

            implicit none
            integer, intent(in) :: maux,mbc,mx,my
            real(kind=8), intent(in) :: xlower,ylower,dx,dy,t
            type(model_storm_type), intent(inout) :: storm
            integer, intent(in) :: wind_index, pressure_index
            real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
        end subroutine set_model_fields_def
    end interface

    abstract interface
        subroutine set_data_fields_def(maux, mbc, mx, my, xlower, ylower,    &
                                      dx, dy, t, aux, wind_index,           &
                                      pressure_index, storm)

            use data_storm_module, only: data_storm_type

            implicit none
            integer, intent(in) :: maux, mbc, mx, my
            real(kind=8), intent(in) :: xlower, ylower, dx, dy, t
            type(data_storm_type), intent(in out) :: storm
            integer, intent(in) :: wind_index, pressure_index
            real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
        end subroutine set_data_fields_def
    end interface

    procedure(set_model_fields_def), pointer :: set_model_fields
    procedure(set_data_fields_def), pointer :: set_data_fields

    ! Display times in days relative to landfall
    logical :: display_landfall_time = .false.

contains
    ! ========================================================================
    !   subroutine set_storm(data_file)
    ! ========================================================================
    ! Reads in the data file at the path data_file.
    !
    ! Input:
    !     data_file = Path to data file
    !
    ! ========================================================================
    subroutine set_storm(data_file)

        use model_storm_module, only: set_model_storm => set_storm
        use model_storm_module, only: set_holland_1980_fields
        use model_storm_module, only: set_holland_2008_fields
        use model_storm_module, only: set_holland_2010_fields
        use model_storm_module, only: set_CLE_fields
        use model_storm_module, only: set_SLOSH_fields
        use model_storm_module, only: set_rankine_fields
        use model_storm_module, only: set_modified_rankine_fields
        use model_storm_module, only: set_deMaria_fields

        ! use data_storm_module, only: set_data_storm => set_storm
        use data_storm_module, only: set_HWRF_fields

        use utility_module, only: get_value_count

        implicit none

        ! Input arguments
        character(len=*), optional, intent(in) :: data_file

        ! Locals
        integer, parameter :: unit = 13
        integer :: i, drag_law, rotation_override
        character(len=200) :: storm_file_path, line

        if (.not.module_setup) then

            ! Open file
            if (present(data_file)) then
                call opendatafile(unit,data_file)
            else
                call opendatafile(unit,'surge.data')
            endif

            ! Forcing terms
            read(unit,*) wind_forcing
            read(unit,*) drag_law
            if (.not.wind_forcing) drag_law = 0
            select case(drag_law)
                case(0)
                    wind_drag => no_wind_drag
                case(1)
                    wind_drag => garratt_wind_drag
                case(2)
                    wind_drag => powell_wind_drag
                case default
                    stop "*** ERROR *** Invalid wind drag law."
            end select
            read(unit,*) pressure_forcing
            read(unit,*) rotation_override
            select case(rotation_override)
                case(0)
                    rotation => hemisphere_rotation
                case(1)
                    rotation => N_rotation
                case(2)
                    rotation => S_rotation
                case default
                    stop " *** ERROR *** Roation override invalid."
            end select
            read(unit,*)

            ! Set some parameters
            read(unit, '(i2)') wind_index
            read(unit, '(i2)') pressure_index
            read(unit, *) display_landfall_time
            read(unit, *)

            ! AMR parameters
            read(unit,'(a)') line
            if (line(1:1) == "F") then
                allocate(wind_refine(1))
                wind_refine(1) = huge(1.d0)
            else
                allocate(wind_refine(get_value_count(line)))
                read(line,*) (wind_refine(i),i=1,size(wind_refine,1))
            end if
            read(unit,'(a)') line
            if (line(1:1) == "F") then
                allocate(R_refine(1))
                R_refine(1) = -huge(1.d0)
            else
                allocate(R_refine(get_value_count(line)))
                read(line,*) (R_refine(i),i=1,size(R_refine,1))
            end if
            read(unit,*)

            ! Storm Setup
            read(unit, "(i1)") storm_specification_type
            read(unit, *) storm_file_path

            close(unit)

            ! Print log messages
            open(unit=log_unit, file="fort.surge", status="unknown", action="write")

            write(log_unit, *) "Wind Nesting = ", (wind_refine(i),i=1,size(wind_refine,1))
            write(log_unit, *) "R Nesting = ", (R_refine(i),i=1,size(R_refine,1))
            write(log_unit, *) ""

            write(log_unit, *) "Storm specification = ", storm_specification_type
            write(log_unit, *) "  file = ", storm_file_path

            ! Use parameterized storm model
            if (0 < storm_specification_type .and.              &
                    storm_specification_type <= 3               &
                .or. storm_specification_type == 8) then
                select case(storm_specification_type)
                    case(1) ! Holland 1980 model
                        set_model_fields => set_holland_1980_fields
                    case(8) ! Holland 2008 model
                        set_model_fields => set_holland_2008_fields
                    case(2) ! Holland 2010 model
                        set_model_fields => set_holland_2010_fields
                    case(3) ! Chavas, Lin, Emanuel model
                        set_model_fields => set_CLE_fields
                    case(4) ! SLOSH model
                        set_model_fields => set_SLOSH_fields
                    case(5) ! rankine model
                        set_model_fields => set_rankine_fields
                    case(6) ! modified_ankine model
                        set_model_fields => set_modified_rankine_fields
                    case(7) ! deMaria model
                        set_model_fields => set_deMaria_fields
                end select
                call set_model_storm(storm_file_path, model_storm,         &
                                     storm_specification_type, log_unit)
            else if (storm_specification_type > 0) then
                print *, "Storm specification model type ",                &
                            storm_specification_type, "not available."
                stop
            end if

            ! Storm will be set based on a gridded set of data
            if (-1 <= storm_specification_type .and.                    &
                      storm_specification_type < 0) then
                select case(storm_specification_type)
                    case(1) ! HWRF Data
                        set_data_fields => set_HWRF_fields
                end select
            else if (storm_specification_type < 0) then
                print *, "Storm specification data type ",               &
                            storm_specification_type, "not available."
                stop
            end if

            close(log_unit)

            module_setup = .true.
        end if

    end subroutine set_storm

    ! ========================================================================
    !   real(kind=8) function *_wind_drag(wind_speed)
    ! ========================================================================
    !  Calculates the drag coefficient for wind given the given wind speed.
    !
    !  Input:
    !      wind_speed = Magnitude of the wind in the cell
    !      theta = Angle with primary hurricane direciton
    !
    !  Output:
    !      wind_drag = Coefficient of drag
    ! ==========================================================================
    !  Powell Wind Drag - Sector based wind drag coefficients due to primary
    !    wave direction interaction with wind.  This implementation is based on
    !    the parameterization used in ADCIRC.  For more information see
    !
    !    M.D. Powell (2006). “Final Report to the National Oceanic and
    !      Atmospheric Administration (NOAA) Joint Hurricane Testbed (JHT)
    !      Program.” 26 pp.
    !
    real(kind=8) pure function powell_wind_drag(wind_speed, theta)     &
                                         result(wind_drag)

        implicit none

        ! Input
        real(kind=8), intent(in) :: wind_speed, theta

        ! Locals
        real(kind=8) :: weight(3), drag(3)

        weight = 0.d0

        ! Calculate Garratt speeds for use in sector- and speed-specific Cd
        ! calculation. Note that WIND_DRAG_LIMIT is not binding in this case
        ! because there are stricter upper bounds imposed in the
        ! sector-specfic drag below
        drag = garratt_wind_drag_limit(wind_speed, WIND_DRAG_LIMIT)

        ! Calculate sector weights
        if (0.d0 <= theta .and. theta <= 40.d0) then
            ! Transition from left (3) to right (1)
            weight(3) = 1.d0 - theta / 40.d0
            weight(1) = theta / 40.d0
        else if (40.d0 <= theta .and. theta <= 130.d0) then
            ! Right (1)
            weight(1) = 1.d0
        else if (130.d0 <= theta .and. theta <= 170.d0) then
            ! Transition from right (1) to rear (2)
            weight(1) = 1.d0 - (theta - 130.d0) / 40.d0
            weight(2) = (theta - 130.d0) / 40.d0
        else if (170.d0 <= theta .and. theta <= 220.d0) then
            ! Rear (2)
            weight(2) = 1.d0
        else if (220.d0 <= theta .and. theta <= 260.d0) then
            ! Transition from rear (2) to left (3)
            weight(2) = 1.d0 - (theta - 220.d0) / 40.d0
            weight(3) = (theta - 220.d0) / 40.d0
        else if (260.d0 <= theta .and. theta <= 360.d0) then
            ! Left (3)
            weight(3) = 1.d0
        endif

        ! Calculate wind drag for sector 1 (right)
        if (wind_speed <= 35.d0) then
            drag(1) = min(2.d-3, drag(1))
        else if (35.d0 <= wind_speed .and. wind_speed <= 45.d0) then
            drag(1) = 2.d-3 + 1.d-3 * (wind_speed - 35.d0) / 10.d0
        else if (45.d0 <= wind_speed) then
            drag(1) = 3.d-3
        endif

        ! Calculate wind drag for sector 2 (rear)
        if (wind_speed <= 35.d0) then
            drag(2) = min(2.d-3, drag(2))
        else if (35.d0 <= wind_speed .and. wind_speed <= 45.d0) then
            drag(2) = 2.d-3 - 1.d-3 * (wind_speed - 35.d0) / 10.d0
        else if (45.d0 <= wind_speed) then
            drag(2) = 1.d-3
        endif

        ! Calculate wind drag for sector 3 (left)
        if (drag(3) > 1.8d-3) then
            if (wind_speed <= 25.d0) then
                drag(3) = 1.8d-3
            else if (25.d0 <= wind_speed .and. wind_speed <= 30.d0) then
                drag(3) = 1.8d-3 + 2.7d-3 * (wind_speed - 25.d0) / 5.d0
            else if (30.d0 <= wind_speed .and. wind_speed <= 45.d0) then
                drag(3) = 4.5d-3 - 3.5d-3 * (wind_speed - 30.d0) / 15.d0
            else if (45.d0 <= wind_speed) then
                drag(3) = 1.d-3
            endif
        endif

        ! Use weighted average
        wind_drag = dot_product(weight, drag)

    end function powell_wind_drag


    ! ========================
    !  Garratt Based Wind Drag
    ! ========================
    !  This version is a simple limited version of the wind drag
    real(kind=8) pure function garratt_wind_drag(wind_speed, theta) result(wind_drag)

        implicit none

        ! Input
        real(kind=8), intent(in) :: wind_speed, theta

        wind_drag = garratt_wind_drag_limit(wind_speed, WIND_DRAG_LIMIT)

    end function garratt_wind_drag


    ! ===================================
    !  Helper for Garratt==================
    real(kind=8) pure function garratt_wind_drag_limit(wind_speed,      &
                                                      wind_drag_limit) &
                                               result(wind_drag)

        implicit none

        ! Input
        real(kind=8), intent(in) :: wind_speed, wind_drag_limit

        wind_drag = min(wind_drag_limit,                               &
                        1.d-3 * (0.75d0 + 0.067d0 * wind_speed))

    end function garratt_wind_drag_limit


    ! ==================================================================
    !  No Wind Drag - Dummy function used to turn off wind drag forcing
    ! ==================================================================
    real(kind=8) pure function no_wind_drag(wind_speed, theta) result(wind_drag)
        implicit none
        real(kind=8), intent(in) :: wind_speed, theta
        wind_drag = 0.d0
    end function no_wind_drag



    ! ==========================================================================
    ! Wrapper functions for all storm types
    function storm_location(t) result(location)

        use amr_module, only: rinfinity

        use model_storm_module, only: model_location => storm_location
        use data_storm_module, only: data_location => storm_location

        implicit none

        ! Input
        real(kind=8), intent(in) :: t

        ! Output
        real(kind=8) :: location(2)

        if (storm_specification_type == 0) then
            location = [rinfinity,rinfinity]
        else if (storm_specification_type > 0) then
            location = model_location(t, model_storm)
        else if (storm_specification_type < 0) then
            location = data_location(t, data_storm)
        else
            stop "Something may be wrong."
        end if

    end function storm_location

    real(kind=8) function storm_direction(t) result(theta)

        use amr_module, only: rinfinity
        use model_storm_module, only: model_direction => storm_direction
        use data_storm_module, only: data_direction => storm_direction

        implicit none

        ! Input
        real(kind=8), intent(in) :: t

        if (storm_specification_type > 0) then
            theta = model_direction(t, model_storm)
        else if (storm_specification_type < 0) then
            theta = data_direction(t, data_storm)
        else
            theta = rinfinity
        end if

    end function storm_direction


    subroutine set_storm_fields(maux, mbc, mx, my, xlower, ylower, dx, dy,&
                                t, aux)

        implicit none

        ! Input arguments
        integer, intent(in) :: maux, mbc, mx, my
        real(kind=8), intent(in) :: xlower, ylower, dx, dy, t
        real(kind=8), intent(in out) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

        if (storm_specification_type > 0) then
            call set_model_fields(maux,mbc,mx,my, &
                                  xlower,ylower,dx,dy,t,aux, wind_index, &
                                  pressure_index, model_storm)
        end if
        if (storm_specification_type < 0) then
            call set_data_fields(maux,mbc,mx,my, &
                                 xlower,ylower,dx,dy,t,aux, wind_index, &
                                 pressure_index, data_storm)
        end if

    end subroutine set_storm_fields


    subroutine output_storm_location(t)

        implicit none

        real(kind=8), intent(in) :: t

        ! We open this here so that the file flushes and writes to disk
        open(unit=track_unit,file="fort.track",action="write",position='append')

        write(track_unit,"(4e26.16)") t, storm_location(t), storm_direction(t)

        close(track_unit)

    end subroutine output_storm_location

    ! ==========================================================================
    ! Default to assuming y is a latitude and if y >= 0 we are want to spin
    ! counter-clockwise
    ! ==========================================================================
    logical pure function hemisphere_rotation(x, y) result(rotation)
        implicit none
        real(kind=8), intent(in) :: x, y
        rotation = (y >= 0.d0)
    end function hemisphere_rotation
    ! This version just returns the user defined direction
    logical pure function N_rotation(x, y) result(rotation)
        implicit none
        real(kind=8), intent(in) :: x, y
        rotation = .true.
    end function N_rotation
    ! This version just returns the user defined direction
    logical pure function S_rotation(x, y) result(rotation)
        implicit none
        real(kind=8), intent(in) :: x, y
        rotation = .false.
    end function S_rotation
    
end module storm_module

c
c --------------------------------------------------------------
c
      subroutine errf1(rctfine,nvar,rctcrse,mptr,mi2tot,mj2tot,
     2                 mitot,mjtot,rctflg,mibuff,mjbuff)
      use amr_module
      implicit double precision (a-h,o-z)

 
      dimension  rctfine(nvar,mitot,mjtot)
      dimension  rctcrse(nvar,mi2tot,mj2tot)
      dimension  rctflg(mibuff,mjbuff)
c
c
c ::::::::::::::::::::::::::::: ERRF1 ::::::::::::::::::::::::::::::::
c
c  Richardson error estimator:  Used when flag_richardson is .true.
c  Compare error estimates in rctfine, rctcrse, 
c  A point is flagged if the error estimate is greater than tol
c  later we check if its in a region where its allowed to be flagged
c  or alternatively required.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

c
      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      ybot  = rnode(cornylo,mptr)
      hy    = hyposs(levm)
      dt    = possk(levm)
      numsp = 0
 
      errmax = 0.0d0
      err2   = 0.0d0
c     order  = dt*dble(2**(iorder+1) - 2)
      order  = dble(2**(iorder+1) - 2)
c
      if (.not. (edebug)) go to 20
         write(outunit,107) mptr
 107     format(//,' coarsened grid values for grid ',i4)
         do jj = nghost+1, mj2tot-nghost
            j = mj2tot + 1 - jj
            write(outunit,101) (rctcrse(1,i,j),
     .                          i = nghost+1, mi2tot-nghost)
         end do
         write(outunit,108) mptr
 108     format(//, ' fine grid values for grid ',i4)
         do jj = nghost+1, mjtot-nghost
            j = mjtot + 1 - jj
            write(outunit,101) (rctfine(1,i,j),i=nghost+1,mitot-nghost)
         end do 
101      format(' ',40e11.3)
c
c zero out the exterior locations so they don't affect err.est.
c
 20   continue
      jfine = nghost+1
      do j = nghost+1, mj2tot-nghost
      yofj  = ybot + (dble(jfine) - .5d0)*hy
      ifine = nghost+1
c
      do i  = nghost+1, mi2tot-nghost
          rflag = UNSET
c Only check errors if flag hasn't been set yet.
c If flag == DONTFLAG then refinement is forbidden by a region,
c if flag == DOFLAG checking is not needed

c Note: here rctcrse is being used as a temporary flag
c the fine grid amrflags array is stored in rctflg, and will be
c updated based on rctcrse at the end of this routine
          if(rctflg(ifine,jfine) == UNSET
     .         .or. rctflg(ifine+1,jfine) == UNSET
     .         .or. rctflg(ifine,jfine+1) == UNSET
     .         .or. rctflg(ifine+1,jfine+1) == UNSET) then
              xofi  = xleft + (dble(ifine) - .5d0)*hx
              term1 = rctfine(1,ifine,jfine)
              term2 = rctfine(1,ifine+1,jfine)
              term3 = rctfine(1,ifine+1,jfine+1)
              term4 = rctfine(1,ifine,jfine+1)
c             # divide by (aval*order) for relative error
              aval  = (term1+term2+term3+term4)/4.d0
              est   =  dabs((aval-rctcrse(1,i,j))/ order)
              if (est .gt. errmax) errmax = est
              err2 = err2 + est*est
c             write(outunit,102) i,j,est,rctcrse(1,i,j)
 102          format(' i,j,est ',2i5,2e15.7)
c              write(outunit,104) term1,term2,term3,term4
 104          format('   ',4e15.7)
c             rctcrse(2,i,j) = est
c
              if (est .ge. tol) then
                 rflag  = DOFLAG
              endif
          endif
      rctcrse(1,i,j) = rflag
      ifine = ifine + 2
 30   end do
      jfine = jfine + 2
 35   end do
c
c  print out intermediate flagged rctcrse (for debugging)
c
      if (eprint) then
         err2 = dsqrt(err2/dble((mi2tot-2*nghost)*(mj2tot-2*nghost)))
         write(outunit,103) mptr, levm, time,errmax, err2
 103     format(' grid ',i4,' level ',i4,' time ',e12.5,
     .          ' max. error = ',e15.7,' err2 = ',e15.7)
         if (edebug) then
           write(outunit,*) ' flagged points on coarsened grid ',
     .                      '(no ghost cells) for grid ',mptr
           do jj = nghost+1, mj2tot-nghost
              j = mj2tot + 1 - jj
              write(outunit,106) (nint(rctcrse(1,i,j)),
     .                            i=nghost+1,mi2tot-nghost)
106           format(1h ,80i1)
           end do
         endif
      endif
c
      jfine   = nghost+1
      do j = nghost+1, mj2tot-nghost
      ifine   = nghost+1
      do i = nghost+1, mi2tot-nghost
         if (rctcrse(1,i,j) .eq. DOFLAG) then
c           ## never set rctflg to DONTFLAG, since flagregions2 or
c           ## flag2refine may have previously set it to DOFLAG
c           ## can only add DOFLAG pts in this routine
            rctflg(ifine,jfine)    = DOFLAG
            rctflg(ifine+1,jfine)  = DOFLAG
            rctflg(ifine,jfine+1)  = DOFLAG
            rctflg(ifine+1,jfine+1)= DOFLAG
          endif
          ifine   = ifine + 2
       end do
        jfine   = jfine + 2
       end do
c

      if (eprint) then
         write(outunit,118)
 118     format(' on fine grid (no ghost cells) flagged points are')
         if (edebug) then
          do 56 jj = nghost+1, mjtot-nghost
           j = mjtot + 1 - jj
           write(outunit,106)
     &      (nint(rctflg(i,j)),i=nghost+1,mitot-nghost)
 56       continue
        endif
      endif

      return
      end

c ****************************************************************
!> If grid borders the physical domain then
!! set domain flags to 1 in buffer zone (which is outside the physical
!! domain). 
!! That way when shrink
!! by 1 to get proper nested domain, you wont lose the first
!! border cell of a grid
!!
!! flag array uses 0-based index space
!! 
!! if periodic, then have to look elsewhere to see if
!! last interior row/col that is flagged is ok.
!! this is done in the calling routine that
!! transfers flagged points to base grids
!!
!! \param iflags array that stores the flags for this grid
!! \param ilo global *i* index of left border of the grid
!! \param ihi global *i* index of right border of the grid
!! \param jlo global *j* index of lower border of the grid
!! \param jhi global *j* index of upper border of the grid
!! \param mbuff width of buffer zone
!! \param level AMR level of the grid being flagged
c ****************************************************************

c
c -----------------------------------------------------------
c
       subroutine setPhysBndryFlags(iflags,ilo,ihi,jlo,jhi,mbuff,level)

       use amr_module
       implicit double precision (a-h, o-z)

       integer*1  iflags(ilo-mbuff:ihi+mbuff, jlo-mbuff:jhi+mbuff)

       if (ilo-mbuff .lt. 0 .and. .not. xperdom) then  ! grid extends out of left side of domain
c       set left flagged points to be ok
          do j = jlo-mbuff, jhi+mbuff
            do i = ilo-mbuff, -1
c             iflags(i,j) = iflags(0,j)   ! extend using whatever 1st col inside is 
             iflags(i,j) = 1     ! set to 1 for bndry buffers that touch exterior domain
            end do
          end do
       endif

       if (ihi+mbuff .ge. iregsz(level) .and. .not. xperdom) then
c       set right flagged points to be ok
          do j = jlo-mbuff, jhi+mbuff
            do i = iregsz(level), ihi+mbuff
c             iflags(i,j) = iflags(iregsz(level)-1,j)
             iflags(i,j) = 1
            end do
          end do
       endif

 
       if (jlo-mbuff .lt. 0 .and. .not. yperdom) then
c       set bottom flagged points to be ok
         do j = jlo-mbuff, -1    
           do i = ilo-mbuff, ihi+mbuff
c             iflags(i,j) = iflags(i,0)
             iflags(i,j) = 1
            end do
          end do
       endif

       if (jhi+mbuff .ge. jregsz(level) .and. .not. yperdom) then
c       set top flagged points to be ok
         do j = jregsz(level), jhi+mbuff
           do i = ilo-mbuff, ihi+mbuff
c             iflags(i,j) = iflags(i,jregsz(level)-1) ! extend using  last flag in domain 
             iflags(i,j) = 1
            end do
          end do
       endif


       return
       end

c
!> Do conservation fix-up for cells on grid **mptr** that border 
!! finer grids.
!! Do this by adding flux differences stored
!! with each of the fine grids to these cells on grid **mptr**. 
!! 
!! \param[in,out] listbc an array that stores information of all cells that
!! border a finer grids in grid **mptr**. 
!! \param[in] val pointer to the solution on grid **mptr**
!! \param[in] nvar number of equations for the system
!! \param[in] naux number of auxiliary variables
!! \param[in] mitot total number of cells in *i* direction on grid **mptr**
!! \param[in] mjtot total number of cells in *j* direction on grid **mptr**
!! \param[in] maxsp maximum number of segments **lisbc** can describe
!! \param[in] mptr the grid being processed
c ------------------------------------------------------------
c
       subroutine upbnd(listbc,val,nvar,naux,mitot,mjtot,
     1                  maxsp,mptr)
c     1                  maxsp,iused,mptr)
 
      use amr_module
      implicit double precision (a-h,o-z)

 
       dimension val(nvar,mitot,mjtot), iused(mitot,mjtot)
       double precision listbc(5,maxsp)

c  OLD INDEXING
c      iaddaux(i,j) = locaux + i-1 +  mitot*(j-1) 
c    1                 + mitot*mjtot*(mcapa-1)
c  NEW INDEXING - SWITCHED ORDERING
       iaddaux(i,j) = locaux + mcapa-1 +  naux*(i-1) 
     1                 + mitot*naux*(j-1)
 
c
c :::::::::::::::::::::::::::: UPBND :::::::::::::::::::::::::::::
c We now correct the coarse grid with the flux differences stored
c with each of the fine grids. We use an array   iused
c to indicate whether the flux has been updated or not for that zone.
c iused(i,j) = sum from (l=1,4) i(l)*2**(l-1), where i(l) = 1 if the
c flux for the  l-th side of the (i,j)-th cell has already been
c updated, and i(l) = 0 if not.
 
c if there is a capacity fn. it needs to be included in update formula
c indicated by mcapa not zero (is index of capacity fn.)
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
 
      do j=1,mjtot
      do i=1,mitot
         iused(i,j) = 0.
      end do
      end do
 
      locaux = node(storeaux,mptr)
      levc   = node(nestlevel,mptr)
      area   = hxposs(levc)*hyposs(levc)


      if (uprint) write(outunit,*)" upbnding grid ",mptr

      do 40 ispot = 1,maxsp
         icrse = listbc(1,ispot)
         if (icrse.eq.0) go to 99
 
         jcrse = listbc(2,ispot)
         iside = listbc(3,ispot)
c        continue to use iside1/norm for debugging, but should soon delete         
c        this if/then/else block needed due to new categories corresponding
c        to mapped bcs. should still only have one update per side of coarse cell though
         if (iside .lt. 5) then   
           iside1 = iside
         elseif (iside .eq. 5) then
           iside1 = 2
         else  ! iside is 6
           iside1 = 4
         endif
         norm = 2**(iside1-1)
         iflag =iused(icrse,jcrse)/norm
         if (mod(iflag,2).eq.1) then
            write(6,*)" ***  double flux update CAN happen in upbnd ***"
            go to 40
         endif
         mkid = listbc(4,ispot)
         kidlst = node(ffluxptr,mkid)
         lkid = listbc(5,ispot)
c         if (mod(iside,4).gt.1) then
c         modified to include other side options
          if (iside .eq. 2 .or. iside .eq. 3 .or. iside .eq. 6) then
c           (iside .eq. 2 .or. iside .eq. 3)
            sgnm = -1.
         else
c           (iside .eq. 4 .or. iside .eq. 1)
            sgnm = 1.
         endif

c        ## debugging output
         if (uprint) then
           write(outunit,101) icrse,jcrse,
     .         (val(ivar,icrse,jcrse),ivar=1,nvar)
 101       format(" old ",1x,2i4,4e15.7)
         endif

         if (mcapa .gt. 0) then
c            # capacity array:  need to divide by capa in each cell.
c            # modify sgnm which is reset for each grid cell.
c            # Note capa is stored in aux(icrse,jcrse,mcapa)
             sgnm = sgnm / alloc(iaddaux(icrse,jcrse))
         endif

         do 20 ivar = 1,nvar
            val(ivar,icrse,jcrse) = val(ivar,icrse,jcrse) +
     1      sgnm*alloc(kidlst+nvar*(lkid-1)+ivar-1)/area
 20      continue
         iused(icrse,jcrse) = iused(icrse,jcrse) + norm

c        ## debugging output
         if (uprint) then
           write(outunit,102) mkid,
     .         (val(ivar,icrse,jcrse),ivar=1,nvar)
 102       format(" new ","(grid",i3,")",4e15.7)
         endif

 40   continue
c
 99   return
      end

c
c -------------------------------------------------------------
c
      subroutine stepgrid(q,fm,fp,mitot,mbc,dt,dtnew,dx,
     &                  nvar,xlow,time,mptr,maux,aux)
c
c          
c ::::::::::::::::::: STEPGRID ::::::::::::::::::::::::::::::::::::
c take a time step on a single grid. overwrite solution array q. 
c A modified version of the clawpack routine step is used.
c
c return fluxes in fm and fp.
c patch has room for ghost cells (mbc of them) around the grid.
c everything is the enlarged size (mitot by mjtot).
c
c mbc       = number of ghost cells  (= lwidth)
c mptr      = grid number  (for debugging)
c xlow      =  left corner of enlarged grid (including ghost cells).
c dt        = incoming time step
c dx        = mesh width for this grid
c dtnew     = return suggested new time step for this grid's soln.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      use amr_module
      implicit double precision (a-h,o-z)
      external rp1

      common /comxyt/ dtcom,dxcom,tcom,icom

      dimension q(nvar,mitot)
      dimension fp(nvar,mitot)
      dimension fm(nvar,mitot)
      dimension aux(maux,mitot)

      logical    debug,  dump
      data       debug/.false./,  dump/.false./

c
c     # set tcom = time.  This is in the common block comxyt that could
c     # be included in the Riemann solver, for example, if t is explicitly
c     # needed there.

      tcom = time

      if (dump) then
         write(outunit,*) "dumping grid ",mptr," at time ",time
         do i = 1, mitot
            write(outunit,545) i,(q(ivar,i),ivar=1,nvar)
c    .                  ,(aux(ivar,i),ivar=1,maux)
 545        format(2i4,5e15.7)
         end do
      endif
c
      meqn   = nvar
      mx = mitot - 2*mbc
      mbig = mx       !# size for 1d scratch array
      xlowmbc = xlow + mbc*dx

c     # method(2:7) and mthlim
c     #    are set in the amr2ez file (read by amr)
c
      method(1) = 0
c
c
      call b4step1(mbc,mx,nvar,q,
     &             xlowmbc,dx,time,dt,maux,aux)
c
c
c     # take one step on the conservation law:
c
      call step1(mbig,nvar,maux,
     &           mbc,mx,
     &              q,aux,dx,dt,cflgrid,
     &              fm,fp,rp1)
c
c
        write(outunit,1001) mptr, node(nestlevel,mptr),cflgrid
 1001   format(' Courant # of grid', i4,
     &        ' on level', i3, ' is  ', e10.3)
c

!$OMP  CRITICAL (cflm)

        cfl_level = dmax1(cfl_level,cflgrid)

!$OMP END CRITICAL (cflm)

c
c       # update q
        dtdx = dt/dx
        do 50 i=mbc+1,mitot-mbc
        do 50 m=1,nvar
         if (mcapa.eq.0) then
c
c            # no capa array.  Standard flux differencing:

           q(m,i) = q(m,i)
     &           - dtdx * (fm(m,i+1) - fp(m,i))
         else
c            # with capa array.
           q(m,i) = q(m,i)
     &          - (dtdx * (fm(m,i+1) - fp(m,i))) / aux(mcapa,i)
         endif

 50      continue
c
c
      if (method(4).eq.1) then
c        # with source term:   use Godunov splitting
         call src1(nvar,mbc,mx,xlowmbc,dx,
     &             q,maux,aux,time,dt)
         endif
c
c
c
c     # output fluxes for debugging purposes:
      if (debug) then
         write(dbugunit,*)" fluxes for grid ",mptr
c        do 830 j = mbc+1, mjtot-1
            do 830 i = mbc+1, mitot-1
               write(dbugunit,831) i,fm(1,i),fp(1,i)
               do 830 m = 2, meqn
                  write(dbugunit,832) fm(m,i),fp(m,i)
  831          format(2i4,4d16.6)
  832          format(8x,4d16.6)
  830    continue
      endif

c
c
c For variable time stepping, use max speed seen on this grid to 
c choose the allowable new time step dtnew.  This will later be 
c compared to values seen on other grids.
c
       if (cflgrid .gt. 0.d0) then
           dtnew = dt*cfl/cflgrid
         else
c          # velocities are all zero on this grid so there's no 
c          # time step restriction coming from this grid.
            dtnew = rinfinity
          endif

c     # give a warning if Courant number too large...
c
      if (cflgrid .gt. cflv1) then
            write(*,810) cflgrid
            write(outunit,810) cflgrid, cflv1
  810       format('*** WARNING *** Courant number  =', d12.4,
     &              '  is larger than input cfl_max = ', d12.4)
            endif
c
      if (dump) then
         write(outunit,*) "dumping grid ",mptr," after stepgrid"
         do i = 1, mitot
            write(outunit,545) i,(q(ivar,i),ivar=1,nvar)
         end do
      endif
      return
      end

c
!> For each coarse-fine interface, a Riemann problem between an inner
!! ghost cell value on the fine grid and cell value in the adjacent coarse
!! cell must be solved and added to corresponding location in
!! **node(ffluxptr, mptr)** for conservative fix later
!!
c -------------------------------------------------------------
c
       subroutine qad(valbig,mitot,mjtot,nvar,
     .                svdflx,qc1d,lenbc,lratiox,lratioy,hx,hy,
     .                maux,aux,auxc1d,delt,mptr)

      use amr_module
       implicit double precision (a-h, o-z)


       logical qprint

       dimension valbig(nvar,mitot,mjtot)
       dimension qc1d(nvar,lenbc)
       dimension svdflx(nvar,lenbc)
       dimension aux(maux,mitot,mjtot)
       dimension auxc1d(maux,lenbc)

c
c ::::::::::::::::::::::::::: QAD ::::::::::::::::::::::::::::::::::
c  are added in to coarse grid value, as a conservation fixup. 
c  Done each fine grid time step. If source terms are present, the
c  coarse grid value is advanced by source terms each fine time step too.

c  No change needed in this sub. for spherical mapping: correctly
c  mapped vals already in bcs on this fine grid and coarse saved
c  vals also properly prepared
c
c Side 1 is the left side of the fine grid patch.  Then go around clockwise.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c      # local storage
c      # note that dimension here are bigger than dimensions used
c      # in rp2, but shouldn't matter since wave is not used in qad
c      # and for other arrays it is only the last parameter that is wrong
c      #  ok as long as meqn, mwaves < maxvar

       integer max1dp1
       dimension ql(nvar,max1d+1),    qr(nvar,max1d+1)
       dimension wave(nvar,mwaves,max1d+1), s(mwaves,max1d+1)
       dimension amdq(nvar,max1d+1),  apdq(nvar,max1d+1)
       dimension auxl(maxaux*(max1d+1)),  auxr(maxaux*(max1d+1))
c
c  WARNING: auxl,auxr dimensioned at max possible, but used as if
c  they were dimensioned as the real maux by max1d+1. Would be better
c  of course to dimension by maux by max1d+1 but this wont work if maux=0
c  So need to access using your own indexing into auxl,auxr.
       iaddaux(iaux,i) = iaux + maux*(i-1)

       data qprint/.false./
c
c      aux is auxiliary array with user parameters needed in Riemann solvers
c          on fine grid corresponding to valbig
c      auxc1d is coarse grid stuff from around boundary, same format as qc1d
c      auxl, auxr are work arrays needed to pass stuff to rpn2
c      maux is the number of aux variables, which may be zero.
c

       max1dp1 = max1d+1

       tgrid = rnode(timemult, mptr)
       if (qprint) 
     .      write(dbugunit,*)" working on grid ",mptr," time ",tgrid
       nc = mjtot-2*nghost
       nr = mitot-2*nghost
       level = node(nestlevel, mptr)
       index = 0

c
c--------
c  side 1
c--------
c
       do j = nghost+1, mjtot-nghost
        if (maux.gt.0) then
          do ma = 1,maux
             if (auxtype(ma).eq."xleft") then
c                # Assuming velocity at left-face, this fix
c                # preserves conservation in incompressible flow:
                 auxl(iaddaux(ma,j-nghost+1)) = aux(ma,nghost+1,j)
               else
c                # Normal case -- we set the aux arrays 
c                # from the cell corresponding  to q
                 auxl(iaddaux(ma,j-nghost+1)) = aux(ma,nghost,j)
               endif
          end do
        endif
        do ivar = 1, nvar
          ql(ivar,j-nghost+1) = valbig(ivar,nghost,j)
        end do
       end do

       lind = 0
       ncrse = (mjtot-2*nghost)/lratioy
       do jc = 1, ncrse
         index = index + 1
         do l = 1, lratioy
         lind = lind + 1
         if (maux.gt.0) then
            do ma=1,maux
               auxr(iaddaux(ma,lind)) = auxc1d(ma,index)
            end do
         endif
         do ivar = 1, nvar
            qr(ivar,lind) = qc1d(ivar,index)
         end do
        end do
       end do
    
       if (qprint) then
         write(dbugunit,*) 'side 1, ql and qr:'
         do i=2,nc
            write(dbugunit,4101) i,qr(1,i-1),ql(1,i)
          enddo
 4101      format(i3,4e16.6)
         if (maux .gt. 0) then
             write(dbugunit,*) 'side 1, auxr:'
             do i=2,nc
                write(dbugunit,4101) i,(auxr(iaddaux(ma,i-1)),ma=1,maux)
                enddo
             write(dbugunit,*) 'side 1, auxl:'
             do i=2,nc
                write(dbugunit,4101) i,(auxl(iaddaux(ma,i)),ma=1,maux)
                enddo
         endif
       endif
 
       call rpn2(1,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nc+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 1 add into sdflxm
c
       influx = 0
       do j = 1, nc/lratioy
          influx  = influx + 1
          jfine = (j-1)*lratioy
          do ivar = 1, nvar
            do l = 1, lratioy
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     + amdq(ivar,jfine+l+1) * hy * delt
     .                     + apdq(ivar,jfine+l+1) * hy * delt
            end do
          end do
       end do

c--------
c  side 2
c--------
c
       if (mjtot .eq. 2*nghost+1) then
c          # a single row of interior cells only happens when using the
c          # 2d amrclaw code to do a 1d problem with refinement.
c          # (feature added in Version 4.3)
c          # skip over sides 2 and 4 in this case
           go to 299
           endif

       do i = nghost+1, mitot-nghost
        if (maux.gt.0) then
          do ma = 1,maux
             auxr(iaddaux(ma,i-nghost)) = aux(ma,i,mjtot-nghost+1)
          end do 
        endif
        do ivar = 1, nvar
            qr(ivar,i-nghost) = valbig(ivar,i,mjtot-nghost+1)
        end do
       end do  

       lind = 0
       ncrse = (mitot-2*nghost)/lratiox
       do ic = 1, ncrse
         index = index + 1
         do l = 1, lratiox
          lind = lind + 1
          if (maux.gt.0) then
            do ma=1,maux
             if (auxtype(ma).eq."yleft") then
c                # Assuming velocity at bottom-face, this fix
c                # preserves conservation in incompressible flow:
                 ifine = (ic-1)*lratiox + nghost + l
                 auxl(iaddaux(ma,lind+1)) = aux(ma,ifine,mjtot-nghost+1)
              else
                 auxl(iaddaux(ma,lind+1)) = auxc1d(ma,index)
              endif
            end do
          endif
          do ivar = 1, nvar
             ql(ivar,lind+1) = qc1d(ivar,index)
          end do
         end do
       end do
    
       if (qprint) then
         write(dbugunit,*) 'side 2, ql and qr:'
         do i=1,nr
            write(dbugunit,4101) i,ql(1,i+1),qr(1,i)
            enddo
         if (maux .gt. 0) then
             write(dbugunit,*) 'side 2, auxr:'
             do i = 1, nr
                write(dbugunit,4101) i, (auxr(iaddaux(ma,i)),ma=1,maux)
                enddo
             write(dbugunit,*) 'side 2, auxl:'
             do i = 1, nr
                write(dbugunit,4101) i, (auxl(iaddaux(ma,i)),ma=1,maux)
                enddo
         endif
       endif
       call rpn2(2,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 2. add into sdflxp
c
       do i = 1, nr/lratiox
          influx  = influx + 1
          ifine = (i-1)*lratiox
          do ivar = 1, nvar
            do l = 1, lratiox
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     - amdq(ivar,ifine+l+1) * hx * delt
     .                     - apdq(ivar,ifine+l+1) * hx * delt
            end do
          end do 
       end do

 299  continue

c--------
c  side 3
c--------
c
       do j = nghost+1, mjtot-nghost
        if (maux.gt.0) then
          do ma = 1,maux
             auxr(iaddaux(ma,j-nghost)) = aux(ma,mitot-nghost+1,j)
          end do
        endif
        do ivar = 1, nvar
           qr(ivar,j-nghost) = valbig(ivar,mitot-nghost+1,j)
        end do
       end do 

       lind = 0
       ncrse = (mjtot-2*nghost)/lratioy
       do jc = 1, ncrse
         index = index + 1
         do l = 1, lratioy
          lind = lind + 1
          if (maux.gt.0) then
            do ma=1,maux
               if (auxtype(ma).eq."xleft") then
c                # Assuming velocity at left-face, this fix
c                # preserves conservation in incompressible flow:
                 jfine = (jc-1)*lratioy + nghost + l
                 auxl(iaddaux(ma,lind+1)) = aux(ma,mitot-nghost+1,jfine)
               else
                 auxl(iaddaux(ma,lind+1)) = auxc1d(ma,index)
               endif
             end do
          endif
          do ivar = 1, nvar
              ql(ivar,lind+1) = qc1d(ivar,index)
          end do
         end do
       end do
    
       if (qprint) then
         write(dbugunit,*) 'side 3, ql and qr:'
         do i=1,nc
            write(dbugunit,4101) i,ql(1,i),qr(1,i)
            enddo
       endif
       call rpn2(1,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nc+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 3 add into sdflxp
C
       do j = 1, nc/lratioy
          influx  = influx + 1
          jfine = (j-1)*lratioy
          do ivar = 1, nvar
            do l = 1, lratioy
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     - amdq(ivar,jfine+l+1) * hy * delt
     .                     - apdq(ivar,jfine+l+1) * hy * delt
             end do
           end do
        end do

c--------
c  side 4
c--------
c
       if (mjtot .eq. 2*nghost+1) then
c          # a single row of interior cells only happens when using the
c          # 2d amrclaw code to do a 1d problem with refinement.
c          # (feature added in Version 4.3)
c          # skip over sides 2 and 4 in this case
           go to 499
           endif
c
       do i = nghost+1, mitot-nghost
        if (maux.gt.0) then
          do ma = 1,maux
             if (auxtype(ma).eq."yleft") then
c                # Assuming velocity at bottom-face, this fix
c                # preserves conservation in incompressible flow:
                 auxl(iaddaux(ma,i-nghost+1)) = aux(ma,i,nghost+1)
              else
                 auxl(iaddaux(ma,i-nghost+1)) = aux(ma,i,nghost)
              endif
           end do
        endif
        do ivar = 1, nvar
          ql(ivar,i-nghost+1) = valbig(ivar,i,nghost)
        end do
       end do

       lind = 0
       ncrse = (mitot-2*nghost)/lratiox
       do ic = 1, ncrse
         index = index + 1
         do l = 1, lratiox
          lind = lind + 1
          if (maux.gt.0) then
             do ma=1,maux
                auxr(iaddaux(ma,lind)) = auxc1d(ma,index)
             end do
          endif
          do ivar = 1, nvar
              qr(ivar,lind) = qc1d(ivar,index)
          end do
         end do
       end do
    
       if (qprint) then
         write(dbugunit,*) 'side 4, ql and qr:'
         do i=1,nr
            write(dbugunit,4101) i, ql(1,i),qr(1,i)
            enddo
       endif
       call rpn2(2,max1dp1-2*nghost,nvar,mwaves,maux,nghost,
     .              nr+1-2*nghost,ql,qr,auxl,auxr,wave,s,amdq,apdq)
c
c we have the wave. for side 4. add into sdflxm
c
       do i = 1, nr/lratiox
          influx  = influx + 1
          ifine = (i-1)*lratiox
          do ivar = 1, nvar
            do l = 1, lratiox
              svdflx(ivar,influx) = svdflx(ivar,influx) 
     .                     + amdq(ivar,ifine+l+1) * hx * delt
     .                     + apdq(ivar,ifine+l+1) * hx * delt
             end do
           end do
        end do

 499   continue

c      # for source terms:
       if (method(5) .ne. 0) then   ! should I test here if index=0 and all skipped?
           call src1d(nvar,nghost,lenbc,qc1d,maux,auxc1d,tgrid,delt)
c      # how can this be right - where is the integrated src term used?
           endif
           
       return
       end

c
c ---------------------------------------------------------------
c
        recursive subroutine filrecur(level,nvar,valbig,aux,naux,
     1                                time,mitot,mjtot,mktot,
     2                                nrowst,ncolst,nfilst,ilo,ihi,
     3                                jlo,jhi,klo,khi,patchOnly,msrc)

c :::::::::::::::::::::::::::: FILPATCH ::::::::::::::::::::::::::
c
c  fill the portion of valbig from rows  nrowst
c                             and  cols  ncolst
c                             and  fils  nfilst
c  the patch can also be described by the corners
c  (xlp,yfp,zbp) by (xrp,yrp,ztp).
c  vals are needed at time time, and level level,
c
c  first fill with  values obtainable from the level level
c  grids. if any left unfilled, then enlarge remaining rectangle of
c  unfilled values by 1 (for later linear interp), and recusively
c  obtain the remaining values from  coarser levels.
c
c  Adapted from 2D recursive routine, 10/22/2012.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      use amr_module
      implicit double precision (a-h,o-z)


      logical   set, sticksout, patchOnly
      dimension valbig(nvar,mitot,mjtot,mktot)
      dimension    aux(naux,mitot,mjtot,mktot)
      
      !for setaux timing
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish


c     Use stack-based scratch arrays instead of alloc for better
c     OpenMP-friendliness and dynamic memory resizing.  These scratch
c     arrays are 1D instead of 3D because when we pass them to subroutines
c     they treat it as having different dimensions than the max size
c     that we need to allocate here.  The +3 is to expand the coarse
c     grid to enclose the fine, including an offset of 1.

      dimension valcrse((ihi-ilo+3)*(jhi-jlo+3)*(khi-klo+3)*nvar)
      dimension auxcrse((ihi-ilo+3)*(jhi-jlo+3)*(khi-klo+3)*naux)

      dimension flaguse(ihi-ilo+1, jhi-jlo+1, khi-klo+1)

c     Some helper functions
      ivalc(ivar, i, j, k) = ivar + nvar*(i-1) + nvar*nrowc*(j-1)
     &                            + nvar*nrowc*ncolc*(k-1)

      sticksout(iplo, iphi, jplo, jphi, kplo, kphi) =
     &     (iplo < 0 .or. jplo < 0 .or. kplo < 0 .or.
     &      iphi >= iregsz(levc) .or. jphi >= jregsz(levc)
     &      .or. kphi >= kregsz(levc))
      ! *** NOTE *** levc needs to be defined later as level-1

c     Begin by filling values for grids at level "level".  If all values
c     can be filled this way, return.

      hxf     = hxposs(level)
      hyf     = hyposs(level)
      hzf     = hzposs(level)
      xlp     = xlower + dble(ilo  )*hxf
      xrp     = xlower + dble(ihi+1)*hxf
      ybp     = ylower + dble(jlo  )*hyf
      ytp     = ylower + dble(jhi+1)*hyf
      zfp     = zlower + dble(klo  )*hzf
      zrp     = zlower + dble(khi+1)*hzf
      nrowp   = ihi - ilo + 1
      ncolp   = jhi - jlo + 1
      nfilp   = khi - klo + 1

      call intfil
     & (valbig, mitot, mjtot, mktot, time, flaguse,
     &  nrowst, ncolst, nfilst, ilo, ihi, jlo, jhi, klo, khi,
     &  level, nvar, naux,msrc)

c Trimbd returns set = true if all of the entries are filled (=1.).
c set = false, otherwise. If set = true, then no other levels are
c are required to interpolate, and we return. If false, the minimum
c enclosing rectangle is returned in (il,jl,kl) x (ir,jr,kr)
c
c Note that the used array is filled entirely in intfil, i.e. the
c marking done there also takes into account the points filled by
c the boundary conditions. physbd will be called later (from bound), after
c all 4 boundary pieces filled.

      call trimbd(flaguse, set, il, ir, jl, jr, kl, kr,
     &            ilo, ihi, jlo, jhi, klo, khi)

      if (set) go to 90    ! All done except for BCs

c
c otherwise make recursive calls to coarser levels to fill remaining unset points
c
      if (level == 1) then
           write(outunit,*)" error in filrecur - level 1 not set"
           write(outunit,900) nrowst,ncolst,nfilst
           write(*,*)" error in filrecur - level 1 not set"
           write(*,*)" should not need more recursion "
           write(*,*)" to set patch boundaries"
           write(*,900) nrowst,ncolst,nfilst
900        format("start at row: ",i4," col ",i4," file ",i4)
           stop
      end if

c set = false. we will have to interpolate some values from coarser
c levels. We begin by initializing the level level arrays, so that we can use
c purely recursive formulation for interpolating.

      levc = level - 1
      hxc  = hxposs(levc)
      hyc  = hyposs(levc)
      hzc  = hzposs(levc)

c
c     coarsen
      lratiox = intratx(levc)
      lratioy = intraty(levc)
      lratioz = intratz(levc)
      iplo   = (il-lratiox+nghost*lratiox)/lratiox - nghost
      jplo   = (jl-lratioy+nghost*lratioy)/lratioy - nghost
      kplo   = (kl-lratioz+nghost*lratioz)/lratioz - nghost
      iphi   = (ir+lratiox)/lratiox
      jphi   = (jr+lratioy)/lratioy
      kphi   = (kr+lratioz)/lratioz

      xlc  =  xlower + iplo*hxc
      ybc  =  ylower + jplo*hyc
      zfc  =  zlower + kplo*hzc

      nrowc = iphi - iplo + 1
      ncolc = jphi - jplo + 1
      nfilc = kphi - kplo + 1
      ntot  = nrowc*ncolc*nfilc*(nvar+naux)

      if (nrowc > ihi-ilo+3 .or. ncolc > jhi-jlo+3
     &    .or. nfilc > khi-klo+3) then
         write(*,*)" did not make big enough work space in filrecur "
         write(*,*)" need coarse space with nrowc,ncolc,nfilc ",
     &             nrowc,ncolc,nfilc
         write(6,*)" made space for ilo,ihi,jlo,jhi,klo,khi ",
     &             ilo,ihi,jlo,jhi,klo,khi
         stop
      endif

      if (naux > 0) then
         mx = nrowc - 2*nghost
         my = ncolc - 2*nghost
         mz = nfilc - 2*nghost
         xl = xlc + nghost*hxc
         yb = ybc + nghost*hyc
         zf = zfc + nghost*hzc
         
         call system_clock(clock_start, clock_rate)
         call cpu_time(cpu_start)
         call setaux(nghost,mx,my,mz,xl,yb,zf,
     &               hxc,hyc,hzc,naux,auxcrse)
         call system_clock(clock_finish, clock_rate)
         call cpu_time(cpu_finish)
      endif

      if ((xperdom .or. yperdom .or. zperdom) .and.
     &     sticksout(iplo,iphi,jplo,jphi,kplo,kphi)) then
         call prefilrecur(levc,nvar,valcrse,auxcrse,
     1                    naux,time,nrowc,ncolc,nfilc,1,1,1,
     2                    iplo,iphi,jplo,jphi,kplo,kphi,
     3                    iplo,iphi,jplo,jphi,kplo,kphi,
     4                    .true.)
      else  !-1 indicates not a real grid in this next call to filpatch
         call filrecur(levc,nvar,valcrse,auxcrse,naux,
     1                 time,nrowc,ncolc,nfilc,1,1,1,
     2                 iplo,iphi,jplo,jphi,kplo,kphi,.true.,-1)
      endif

      ! convert to real for use in floor function below
      ratiox = float(lratiox)
      ratioy = float(lratioy)
      ratioz = float(lratioz)

      do 100 iff = 1,nrowp
         !ic = 2 + (iff-(il-ilo)-1)/lratiox
         ic =floor((iff+ilo-1)/ratiox) - iplo + 1
         !eta1 = (-0.5d0+dble(mod(iff-1,lratiox)))/dble(lratiox)
         xcent_coarse = xlc + (ic-.5d0)*hxc
         xcent_fine =  xlower + (iff-1+ilo + .5d0)*hxf
         eta1 = (xcent_fine-xcent_coarse)/hxc
         if (abs(eta1) .gt. .5) then
            write(*,*)" filpatch x indices wrong: eta1 = ",eta1
         endif


         do 100 jf  = 1,ncolp
          !jc = 2 + (jf -(jl-jlo)-1)/lratioy
          jc =floor((jf+jlo-1)/ratioy) - jplo + 1
          !eta2 = (-0.5d0+dble(mod(jf -1,lratioy)))/dble(lratioy)
          ycent_coarse = ybc + (jc-.5d0)*hyc
          ycent_fine =  ylower + (jf-1+jlo + .5d0)*hyf
          eta2 = (ycent_fine-ycent_coarse)/hyc
         if (abs(eta2) .gt. .5) then
            write(*,*)" filpatch y indices wrong: eta2 = ",eta2
         endif

          do 100 kf = 1,nfilp
           !kc = 2 + (kf - (kl-klo)-1)/lratioz
           kc =floor((kf+klo-1)/ratioz) - kplo + 1
           !eta3 = (-0.5d0+dble(mod(kf-1, lratioz)))/dble(lratioz)
           zcent_coarse = zfc + (kc-.5d0)*hzc
           zcent_fine =  zlower + (kf-1+klo + .5d0)*hzf
           eta3 = (zcent_fine-zcent_coarse)/hzc
           if (abs(eta3) .gt. .5) then
              write(*,*)" filpatch z indices wrong: eta3 = ",eta3
           endif

           flag = flaguse(iff,jf,kf)
           if (flag .eq. 0.0) then

            do 101 ivar = 1,nvar

               valp100 = valcrse(ivalc(ivar,ic+1,jc  ,kc   ))
               valm100 = valcrse(ivalc(ivar,ic-1,jc  ,kc   ))
               valc    = valcrse(ivalc(ivar,ic  ,jc  ,kc   ))
               valp010 = valcrse(ivalc(ivar,ic  ,jc+1,kc   ))
               valm010 = valcrse(ivalc(ivar,ic  ,jc-1,kc   ))
               valp001 = valcrse(ivalc(ivar,ic  ,jc  ,kc+1 ))
               valm001 = valcrse(ivalc(ivar,ic  ,jc  ,kc-1 ))

               ! Use monotonized centered limiter to reconstruct in all axes
               dupc = valp100 - valc
               dumc = valc    - valm100
               ducc = valp100 - valm100
               du   = dmin1(dabs(dupc),dabs(dumc))
               du   = dmin1(2.d0*du,.5d0*dabs(ducc))
               fu   = dmax1(0.d0,dsign(1.d0,dupc*dumc))
               uslope = du*sign(1.d0,ducc)*fu ! not really-should divide by h

               dvpc = valp010 - valc
               dvmc = valc    - valm010
               dvcc = valp010 - valm010
               dv   = dmin1(dabs(dvpc),dabs(dvmc))
               dv   = dmin1(2.d0*dv,.5d0*dabs(dvcc))
               fv   = dmax1(0.d0,dsign(1.d0,dvpc*dvmc))
               vslope = dv*sign(1.d0,dvcc)*fv  ! but faster to put with eta above

               dwpc = valp001 - valc
               dwmc = valc    - valm001
               dwcc = valp001 - valm001
               dw   = dmin1(dabs(dwpc),dabs(dwmc))
               dw   = dmin1(2.d0*dw,.5d0*dabs(dwcc))
               fw   = dmax1(0.d0,dsign(1.d0,dwpc*dwmc))
               wslope = dw*sign(1.d0,dwcc)*fw ! instead of recomputing

               valint = valc + eta1*uslope
     &                       + eta2*vslope
     &                       + eta3*wslope

               valbig(ivar,iff+nrowst-1,jf+ncolst-1,kf+nfilst-1)
     &                = valint

 101        continue

         endif

 100  continue

 90   continue
c     
c    ## only call if a small coarser recursive patch
c    ## otherwise whole grid bcs done from bound
      if (patchOnly) then
         call bc3amr(valbig,aux,mitot,mjtot,mktot,nvar,naux,
     1               hxf,hyf,hzf,level,time,
     2               xlp,xrp,ybp,ytp,zfp,zrp)
      endif

      return
      end

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================
    implicit double precision (a-h,o-z)

!     # Riemann solver in the transverse direction for the shallow water
!     equations .
!     # Split asdq (= A^* \Delta q, where * = + or -)
!     # into down-going flux difference bmasdq (= B^- A^* \Delta q)
!     #    and up-going flux difference bpasdq (= B^+ A^* \Delta q)

    dimension     ql(meqn, 1-mbc:maxm+mbc)
    dimension     qr(meqn, 1-mbc:maxm+mbc)
    dimension   asdq(meqn, 1-mbc:maxm+mbc)
    dimension bmasdq(meqn, 1-mbc:maxm+mbc)
    dimension bpasdq(meqn, 1-mbc:maxm+mbc)

    dimension waveb(3,3),sb(3)

!   # grav must be set elsewhere
    common /cparam/ grav

!   # Roe averages quantities of each interface
    parameter (maxm2 = 1800)
    double precision u(-6:maxm2+7),v(-6:maxm2+7),a(-6:maxm2+7), &
                     h(-6:maxm2+7)

    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif
            
    do 10 i = 2-mbc, mx+mbc
        h(i) = (qr(1,i-1)+ql(1,i))*0.50d0
        hsqrtl = dsqrt(qr(1,i-1))
        hsqrtr = dsqrt(ql(1,i))
        hsq2 = hsqrtl + hsqrtr
        u(i) = (qr(mu,i-1)/hsqrtl + ql(mu,i)/hsqrtr) / hsq2
        v(i) = (qr(mv,i-1)/hsqrtl + ql(mv,i)/hsqrtr) / hsq2
        a(i) = dsqrt(grav*h(i))
    10 END DO


    do 20 i = 2-mbc, mx+mbc
        a1 = (0.50d0/a(i))*((v(i)+a(i))*asdq(1,i)-asdq(mv,i))
        a2 = asdq(mu,i) - u(i)*asdq(1,i)
        a3 = (0.50d0/a(i))*(-(v(i)-a(i))*asdq(1,i)+asdq(mv,i))
    
        waveb(1,1) = a1
        waveb(mu,1) = a1*u(i)
        waveb(mv,1) = a1*(v(i)-a(i))
        sb(1) = v(i) - a(i)
    
        waveb(1,2) = 0.0d0
        waveb(mu,2) = a2
        waveb(mv,2) = 0.0d0
        sb(2) = v(i)
    
        waveb(1,3) = a3
        waveb(mu,3) = a3*u(i)
        waveb(mv,3) = a3*(v(i)+a(i))
        sb(3) = v(i) + a(i)
    
!       # compute the flux differences bmasdq and bpasdq
    
        do m=1,meqn
            bmasdq(m,i) = 0.d0
            bpasdq(m,i) = 0.d0
            do mw=1,mwaves
                bmasdq(m,i) = bmasdq(m,i) &
                + dmin1(sb(mw), 0.d0) * waveb(m,mw)
                bpasdq(m,i) = bpasdq(m,i) &
                + dmax1(sb(mw), 0.d0) * waveb(m,mw)
            end do
        end do
    
    20 END DO

    return
    end subroutine rpt2

!
! ::::::::::::::::::::::: INTFIL ::::::::::::::::::::::::::::::::;
!  INTFIL: interpolates values for a patch at the specified level and
!  location, using values from grids at LEVEL and coarser, if nec.
!
!  take the intersection of a grid patch with corners at ilo,ihi
!  and all grids mptr at LEVEL.  If there is a non-null intersection
!  copy the solution vaues from mptr (at TIME) into VAL array.
!  assumes patch at same levels do straight copy, not skipping
!  every intrat or doing any interpolation here,
!  assume called in correct order of levels, so that when copying
!  is ok to overwrite.
!
!  N.B.: there are no dummy points around patch, since
!        this is not an official "grid" but a "patch".
!
!  used array marks when point filled. filpatch checks if points left over
!  after intersections at specified level.
! :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
!
subroutine intfil(val,mi,time,flaguse,nrowst,ilo,ihi,level,nvar,naux,msrc)

    use amr_module, only: possk, mxnest, iregsz, nghost, outunit, alloc
    use amr_module, only: node, lstart, store1, store2, levelptr, timemult,gridNbor
    use amr_module, only: rnode, ndilo, ndihi, nextfree
    use amr_module, only: bndListNum, bndListSt, mstart
    use amr_module, only: listStart, listOfGrids, bndList, numgrids

    implicit none

    ! Input
    integer, intent(in) :: mi, nrowst, ilo, ihi, level, nvar, naux,msrc
    real(kind=8), intent(in) :: time

    ! In/Out
    integer(kind=1), intent(in out) :: flaguse(ilo:ihi)
    real(kind=8), intent(in out) :: val(nvar,mi)

    ! Locals
    integer :: imlo, imhi, nx, mitot
    integer :: ixlo, ixhi, locold, locnew, nextSpot
    integer :: icount, bndNum, bndLoc, levSt
    integer :: ivar, i, mptr, loc, numg
    real(kind=8) :: dt, alphac, alphai
    logical :: t_interpolate

    integer :: patch_line(2)

    real(kind=8), parameter :: t_epsilon = 1.0d-4

    ! Formats for error statements
    character(len=*), parameter :: missing_error = &
            "(' time wanted ',e15.7,' not available from grid ',i4,'level',i4)"
    character(len=*), parameter :: time_error = &
            "(' trying to interpolate from previous time values ',/," // &
            "' for a patch with corners ilo,ihi,jlo,jhi:'" // &
            ",/,2x,4i10,/," // &
            "' from source grid ',i4,' at level ',i4,/," // &
            "' time wanted ',e24.16,' source time is ',e24.16,/," // &
            "' alphai, t_epsilon ',2e24.16)"

    patch_line = [ilo,ihi]

    ! Note that we need a non-dimensionalized t epspatch_line(1)n as it was a problem
    ! in tsunami tests ( instead of t_epsilon   = dt / 10.d0 )
    
    ! Time step at this level
    dt = possk(level)
      
    ! Initialize the flagging where we set things
    flaguse = 0

    ! Loop through all grids at this level, initialize to first
!    mptr = lstart(level)
!    do while (mptr /= 0)
     if (msrc .eq. -1) then
         numg = numgrids(level)
         levSt = listStart(level)
     else
         bndLoc = node(bndListSt,msrc)  ! index of first grid in bndList
         bndNum = node(bndListNum,msrc)
         nextSpot = node(bndListSt, msrc) ! initialize
         numg = bndNum
     endif

     do icount = 1, numg

         if (msrc .eq. -1) then
            mptr = listOfGrids(levSt+icount-1)
         else
            mptr = bndList(nextSpot,gridNbor)
         endif

        ! Check if grid mptr and patch intersect
        imlo = node(ndilo, mptr)
        imhi = node(ndihi, mptr)

        nx = node(ndihi,mptr) - node(ndilo,mptr) + 1
        
        mitot = nx + 2 * nghost

        ixlo = max(imlo,patch_line(1))
        ixhi = min(imhi,patch_line(2))

        ! Check to see if grid and patch interesect, if not continue to next
        ! grid in the list
        if (ixlo <= ixhi) then

            ! grids intersect. figure out what time to use.
            ! alphai = 1 for new time; 0 for old time
            alphac = (rnode(timemult,mptr) - time)/dt
            alphai = 1.d0 - alphac

            if ((alphai < -t_epsilon) .or. (alphai > 1.d0 + t_epsilon)) then
                write(outunit,missing_error) time, mptr, level
                print missing_error, time, mptr, level
                write(outunit,'(A,E24.16)') 'Line 80', dt
                write(outunit,time_error) patch_line,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
                print time_error, patch_line,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
                call outtre(mstart,.false.,nvar,naux)
                stop
            endif

            ! Check if we should interpolate in time
            t_interpolate = .false.
            if (abs(alphai - 1.d0) < t_epsilon) then
                loc = node(store1,mptr)
            else if (dabs(alphai) .lt. t_epsilon) then
                loc = node(store2,mptr)
                if (level == mxnest) then
                    write(outunit,'(A,E24.16)') 'Line 95', dt
                    write(outunit,time_error) patch_line,mptr,level,time, &
                                              rnode(timemult,mptr),alphai,t_epsilon
                    write(*,time_error) patch_line,mptr,level,time, &
                                        rnode(timemult,mptr),alphai,t_epsilon
                    stop
                endif
            else
                locold  = node(store2,mptr)
                locnew  = node(store1,mptr)
                t_interpolate = .true.

                ! If we are at the maximum level nesting, abort
                if (level == mxnest) then
                    write(outunit,'(A,E24.16)') 'Line 107',dt
                    write(outunit,time_error) patch_line,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
                    print time_error, patch_line,mptr,level,time,rnode(timemult,mptr),alphai,t_epsilon
                    stop
                endif
            endif

            ! Actual interpolation
            if (.not. t_interpolate) then
                ! No time interp. copy the solution values
                do ivar = 1, nvar
                    do i = ixlo, ixhi
                        val(ivar,i-patch_line(1)+nrowst) = &
                            alloc(iadd(ivar,i-imlo+nghost+1))
                        flaguse(i) = 1
                    end do
                end do
            else
                ! Linear interpolation in time
                do ivar = 1, nvar
                    do i = ixlo, ixhi
                        val(ivar,i-patch_line(1)+nrowst) = &
                            alloc(iadnew(ivar,i-imlo+nghost+1))*alphai + &
                            alloc(iadold(ivar,i-imlo+nghost+1))*alphac
                        flaguse(i) = 1
                    end do
                end do
            endif

        endif

        ! Get next grid
!        mptr = node(levelptr, mptr)
         if (msrc .ne. -1) then
            nextSpot = bndList(nextSpot,nextfree)
         endif

    end do

    ! Set used array points which intersect domain boundary to be equal to 1, 
    ! they will be set elsewhere, namely boundary conditions and periodic
    ! domains

    if (patch_line(1) < 0) then
        flaguse(patch_line(1):min(-1,nrowst + ihi - patch_line(1))) = 1
    endif

    if (ihi >= iregsz(level)) then
        flaguse(max(iregsz(level),patch_line(1)):ihi) = 1
    endif

contains

    integer pure function iadd(ivar,i)
        implicit none
        integer, intent(in) :: ivar, i
        iadd = loc + ivar-1 + nvar*(i-1)
    end function iadd

    integer pure function iadnew(ivar,i)
        implicit none
        integer, intent(in) :: ivar, i
        iadnew = locnew + ivar-1 + nvar*(i-1)
    end function iadnew

    integer pure function iadold(ivar,i)
        implicit none
        integer, intent(in) :: ivar, i
        iadold = locold + ivar-1 + nvar*(i-1)
    end function iadold

end subroutine intfil

c
c ---------------------------------------------------------
c
      subroutine check(nsteps,time,nvar,naux)
c
c :::::::::::::::::::::: CHECK ::::::::::::::::::::::::::::::::;
c   check point routine - can only call at end of coarse grid cycle
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module
      use gauges_module, only:  num_gauges
      use gauges_module, only: print_gauges_and_reset_nextLoc

      implicit double precision (a-h,o-z)
      integer tchkunit
      parameter (tchkunit = 13)
      character  chkname*13
      character  tchkname*13

      write(6,601) time,nsteps
 601  format('Creating checkpoint file at t = ',e16.9,'  nsteps = ',i5)
c
      if (checkpt_style < 0) then

c         #  Alternate between two sets of files, overwriting the oldest
c         #  one, so that files do not accumulate with frequent checkpoints.
c
c         # Note that logical check_a is stored in amr_module, initialized
c         # in amr2 and perhaps reset properly in restrt.

          if (check_a) then
              chkname = 'fort.chkaaaaa'
              tchkname = 'fort.tckaaaaa'
            else
              chkname = 'fort.chkbbbbb'
              tchkname = 'fort.tckbbbbb'
            endif
          check_a = .not. check_a   ! to use other file next time

      else

c         # make a new checkpoint file for this time
c         ###  make the file name showing the time step
c
          chkname = 'fort.chkxxxxx'
          tchkname = 'fort.tckxxxxx'
          nstp = nsteps
          do 20 ipos = 13, 9, -1
             idigit = mod(nstp,10)
             chkname(ipos:ipos) = char(ichar('0') + idigit)
             tchkname(ipos:ipos) = char(ichar('0') + idigit)
             nstp = nstp / 10
 20       continue
      endif

      open(unit=tchkunit,file=tchkname,status='unknown',
     .     form='formatted')
      open(unit=chkunit,file=chkname,status='unknown',
     .     form='unformatted')
c
c     ###  dump the data
c
      ! new version has variable node size arrays, so need to output
      ! current size to read back in on restart
      write(chkunit) lenmax,lendim,memsize,maxgr
      write(chkunit) (alloc(i),i=1,lendim)
      write(chkunit) hxposs,hyposs,hzposs,possk,icheck
      write(chkunit) lfree,lenf
      write(chkunit) rnode,node,lstart,newstl,listsp,tol,
     1          ibuff,mstart,ndfree,ndfree_bnd,lfine,iorder,mxnest,
     2          intratx,intraty,intratz,kratio,iregsz,jregsz,kregsz,
     3          iregst,jregst,kregst,iregend,jregend,kregend,
     4          numgrids,kcheck,nsteps,time,matlabu
      write(chkunit) avenumgrids, iregridcount,
     1               evol, rvol, rvoll, lentot, tmass0,cflmax
c
      close(chkunit)

c     # flush open running output files fort.amr, fort.gauge, fort.debug
c     # if code dies it will at least have output up to this checkpoint time

      flush(outunit)        ! defined in amr_module.f90
      flush(dbugunit)       ! defined in amr_module.f90
c      flush(OUTGAUGEUNIT)   ! defined in gauges_module.f90
      do ii = 1, num_gauges
        call print_gauges_and_reset_nextLoc(ii)
      end do

c     # write the time stamp file last so it's not updated until data is
c     # all dumped, in case of crash mid-dump.
      write(tchkunit,*) 'Checkpoint file at time t = ',time
      write(tchkunit,*) 'alloc size memsize = ',memsize
      write(tchkunit,*) 'Number of steps taken = ',nsteps
      close(tchkunit)
c
      return
      end

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================
! Riemann solver for the non-conservative transport equation
!    q_t  +  u(x,y,t)*q_x + v(x,y,t)*q_y = 0
! where u and v are a given velocity field and q has multiple components.
! The velocities are specified at cell edges, so that 

!       u(i,j) = u(x_(i-1/2), y_j)
!       v(i,j) = v(x_i, y_(j-1/2))

! The size of q should be given by meqn.

! waves: 1
! equations: meqn
! aux fields: 2

! Conserved quantities: meqn

! Auxiliary variables:
!         1  x_velocity (u)
!         2  y_velocity (v)

! solve Riemann problems along one slice of data.
! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! On output, wave contains the waves, s the speeds,
! and amdq, apdq the left-going and right-going flux differences,
! respectively.  Note that in this advective form, the sum of
! amdq and apdq is not equal to a difference of fluxes except in the
! case of constant velocities.

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routines, this routine is called with ql = qr

    implicit real*8(a-h,o-z)

    dimension wave(meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn,1-mbc:maxm+mbc)
    dimension amdq(meqn,1-mbc:maxm+mbc)
    dimension auxl(maux,1-mbc:maxm+mbc)
    dimension auxr(maux,1-mbc:maxm+mbc)


    do i = 2-mbc, mx+mbc
        wave(:,1,i) = ql(:,i) - qr(:,i-1)
        s(1,i) = auxl(ixy,i)
        ! The flux difference df = s*wave  all goes in the downwind direction:
        amdq(:,i) = dmin1(auxl(ixy,i), 0.d0) * wave(:,1,i)
        apdq(:,i) = dmax1(auxl(ixy,i), 0.d0) * wave(:,1,i)
    end do

    return
    end subroutine rpn2

c
c -------------------------------------------------------------
c
      subroutine spest (nvar,naux,lcheck,dom1flags,isize,jsize,ksize,t0)
c
      use amr_module
      implicit double precision (a-h,o-z)

      integer*1  dom1flags (0:isize+1,0:jsize+1,0:ksize+1)

 
c :::::::::::::::::::::::::: SPEST :::::::::::::::::::::::::::::::::::
c for all grids at level lcheck:
c   Call user-supplied routine flag2refine to flag any points where
c   refinement is desired based on user's criterion.  
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c   initialize iflags here, so can put user flags right into it.
c
       do 4 i = 1, isize
       do 4 j = 1, jsize
       do 4 k = 1, ksize
 4        dom1flags(i,j,k) = 0
c
       mptr = lstart(lcheck)
 5     continue
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          nz     = node(ndkhi,mptr) - node(ndklo,mptr) + 1
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          mktot  = nz + 2*nghost
          locnew = node(store1,mptr)
          locaux = node(storeaux,mptr)
          time   = rnode(timemult,mptr)
          dx     = hxposs(lcheck)
          dy     = hyposs(lcheck)
          dz     = hzposs(lcheck)
          xleft  = rnode(cornxlo,mptr)
          ybot   = rnode(cornylo,mptr)
          zbot   = rnode(cornzlo,mptr)
          xlow   = xleft - nghost*dx
          ylow   = ybot - nghost*dy
          zlow   = zbot - nghost*dz

c
          locbig = igetsp(mitot*mjtot*mktot*nvar)
          node(tempptr,mptr) = locbig
c         # straight copy into scratch array so don't mess up latest soln.
c  ## at later times want to use newest soln for spatial error flagging
c  ## at initial time want to use initial conditions (so retain symmetry for example)
!         if (t0+possk(lcheck) .ne. time) then  ! exact equality test here. counting on ieee arith.
            do 10 i = 1, mitot*mjtot*mktot*nvar
 10            alloc(locbig+i-1) = alloc(locnew+i-1)

            call bound(time,nvar,nghost,alloc(locbig),mitot,mjtot,mktot,
     1               mptr,alloc(locaux),naux)
!         else   ! boundary values already in locold
!             locold = node(store2,mptr)
!             do 11 i = 1, mitot*mjtot*nvar
! 11             alloc(locbig+i-1) = alloc(locold+i-1)
!         endif
c
c get user flags for refinement, which might be based on spatial gradient, 
c for example.  Use old values of soln at time t  before
c integration to get accurate boundary gradients
c
          if (flag_gradient) then
             locamrflags = igetsp(mitot*mjtot*mktot)
             do 20 i = 1, mitot*mjtot*mktot
 20             alloc(locamrflags+i-1) = goodpt
c
c        # call user-supplied routine to flag any points where 
c        # refinement is desired based on user's criterion.  
c        # Default version compares spatial gradient to tolsp.

         
         call flag2refine(nx,ny,nz,nghost,nvar,naux,xlow,ylow,zlow,
     &              dx,dy,dz,time,lcheck,tolsp,alloc(locbig),
     &              alloc(locaux),alloc(locamrflags), goodpt, badpt )
c

c        Put flags in iflags array now, so can reclaim space.
c        Note change of dimension of amrflags array:
c        3rd dim = 1 here, elsewhere flag array has idim3 = nvar
c
         idim3 = 1   ! 3rd dim = 1 here, elsewhere is nvar
         call setflags (dom1flags,isize,jsize,ksize,
     1                  alloc(locamrflags),idim3,mitot,mjtot,mktot,mptr)
         call reclam(locamrflags, mitot*mjtot*mktot)
      endif

c   previously used to reclam locbig space here. now save to reuse in errest
c   reclam locbig space afterwards.
c     call reclam(locbig,mitot*mjtot*nvar)

      mptr = node(levelptr,mptr)
      if (mptr .ne. 0) go to 5
c
      return
      end

subroutine qinit(maxmx,meqn,mbc,mx,xlower,dx,q,maux,aux)

    use parameters_module

    implicit none
    
    ! Input arguments
    integer, intent(in) :: maxmx,meqn,mbc,mx,maux
    double precision, intent(in) :: xlower,dx
    
    double precision, intent(inout) :: q(1-mbc:maxmx+mbc,meqn)
    double precision, intent(inout) :: aux(1-mbc:maxmx+mbc,maux)

    ! Locals
    integer :: i
    double precision :: x,xmid,eigen_vector(4),gamma,lambda,alpha,h_1,h_2,deta

    if (.not.((0 <= init_type).and.(init_type <= 5))) then
        print "(a,i2)","Invalid initialization type requested, init_type = ",init_type
    endif
    
    do i=1,mx
        x = xlower+(i-0.5)*dx

        ! Set initial perturbation to zero and constant depths
        q(i,1) = aux(i,3) * rho(1)
        q(i,3) = aux(i,4) * rho(2)
        q(i,2) = 0.d0
        q(i,4) = 0.d0
        
        ! Simple Riemann problem specification
        if (init_type == 0) then
            ! Depth is already set above appropriately
            ! Need to set momentum though
            if (x < init_location) then
                q(i,2) = u_left(1) * q(i,1)
                q(i,4) = u_left(2) * q(i,3)
            else
                q(i,2) = u_right(1) * q(i,1)
                q(i,4) = u_right(2) * q(i,3)
            endif

        ! Riemann problem in one wave family
        else if (init_type == 1) then
            ! Calculate wave family for perturbation
            gamma = aux(i,4) / aux(i,3)
            select case(wave_family)
                case(1) ! Shallow water, left-going
                    alpha = 0.5d0 * (gamma - 1.d0 + sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                    lambda = -sqrt(g*aux(i,3)*(1.d0+alpha))
                case(2) ! Internal wave, left-going
                    alpha = 0.5d0 * (gamma - 1.d0 - sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                    lambda = -sqrt(g*aux(i,3)*(1.d0+alpha))
                case(3) ! Internal wave, right-going
                    alpha = 0.5d0 * (gamma - 1.d0 - sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                    lambda = sqrt(g*aux(i,3)*(1.d0+alpha))
                case(4) ! Shallow water, right-going
                    alpha = 0.5d0 * (gamma - 1.d0 + sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                    lambda = sqrt(g*aux(i,3)*(1.d0+alpha))
            end select
            eigen_vector = [1.d0,lambda,alpha,lambda*alpha]
            
            ! Add perturbation
            if ((x < init_location).and.(wave_family >= 3)) then
                q(i,1:2) = q(i,1:2) + rho(1) * epsilon * eigen_vector(1:2)
                q(i,3:4) = q(i,3:4) + rho(2) * epsilon * eigen_vector(3:4)
            else if ((x > init_location).and.(wave_family < 3)) then
                q(i,1:2) = q(i,1:2) + rho(1) * epsilon * eigen_vector(1:2)
                q(i,3:4) = q(i,3:4) + rho(2) * epsilon * eigen_vector(3:4)
            endif
        ! Gaussian hump of water, shallow water style
        else if (init_type == 2) then
            gamma = aux(i,4) / aux(i,3)
            alpha = 0.5d0 * (gamma - 1.d0 + sqrt((gamma-1.d0)**2+4.d0*r*gamma))
            deta = epsilon * exp(-((x-init_location)/sigma)**2)
            q(i,1) = q(i,1) + rho(1) * deta
            q(i,3) = q(i,3) + rho(2) * alpha * deta
        ! Gaussian on internal layer only
        else if (init_type == 3) then
            deta = epsilon * exp(-((x-init_location)/sigma)**2)
            q(i,1) = q(i,1) - rho(1) * deta
            q(i,3) = q(i,3) + rho(2) * deta
        ! Shelf initial condition from AN paper
        else if (init_type == 4) then
            gamma = aux(i,4) / aux(i,3)
!             alpha = 0.5d0 * (gamma - 1.d0 + sqrt((gamma-1.d0)**2+4.d0*r*gamma))
            alpha = 0.d0
            xmid = 0.5d0*(-180.e3-80.e3)
            if ((x > -130.e3).and.(x < -80.e3)) then
                deta = epsilon * sin((x-xmid)*PI/(-80.e3-xmid))
                q(i,3) = q(i,3) + rho(2) * alpha * deta
                q(i,1) = q(i,1) + rho(1) * deta * (1.d0 - alpha)
            endif
        endif
    enddo
    
end subroutine qinit

! ==================================================================
subroutine flux3(ixyz,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                 q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3, &
                 method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
                 fwave,s,amdq,apdq,cqxx, &
                 bmamdq,bmapdq,bpamdq,bpapdq, &
                 cmamdq,cmapdq,cpamdq,cpapdq, &
                 cmamdq2,cmapdq2,cpamdq2,cpapdq2, &
                 bmcqxxp,bpcqxxp,bmcqxxm,bpcqxxm, &
                 cmcqxxp,cpcqxxp,cmcqxxm,cpcqxxm, &
                 bmcmamdq,bmcmapdq,bpcmamdq,bpcmapdq, &
                 bmcpamdq,bmcpapdq,bpcpamdq,bpcpapdq, &
                 rpn3,rpt3,rptt3)
! ==================================================================

! flux3fw is a modified version of flux3 to use fwave instead of wave.
! A modified Riemann solver rp3n must be used in conjunction with this
! routine, which returns fwave's instead of wave's.
! See http://amath.washington.edu/~claw/fwave.html

! Limiters are applied to the fwaves, and the only significant
! modification of this code is in the loop for the
! second order corrections.


! Compute the modification to fluxes f, g and h that are generated by
! all interfaces along a 1D slice of the 3D patch.
!    ixyz = 1  if it is a slice in x
!           2  if it is a slice in y
!           3  if it is a slice in z
! This value is passed into the Riemann solvers. The flux modifications
! go into the arrays fadd, gadd and hadd.  The notation is written
! assuming we are solving along a 1D slice in the x-direction.

! fadd(i,.) modifies F to the left of cell i
! gadd(i,.,1,slice) modifies G below cell i (in the z-direction)
! gadd(i,.,2,slice) modifies G above cell i
!                   The G flux in the surrounding slices may
!                   also be updated.
!                   slice  =  -1     The slice below in y-direction
!                   slice  =   0     The slice used in the 2D method
!                   slice  =   1     The slice above in y-direction
! hadd(i,.,1,slice) modifies H below cell i (in the y-direction)
! hadd(i,.,2,slice) modifies H above cell i
!                   The H flux in the surrounding slices may
!                   also be updated.
!                   slice  =  -1     The slice below in z-direction
!                   slice  =   0     The slice used in the 2D method
!                   slice  =   1     The slice above in z-direction
! 
! The method used is specified by method(2) and method(3):

!  method(2) = 1 No correction waves
!            = 2 if second order correction terms are to be added, with
!                a flux limiter as specified by mthlim.  No transverse
!                propagation of these waves.

!   method(3) specify how the transverse wave propagation
!   of the increment wave and the correction wave are performed.
!   Note that method(3) is given by a two digit number, in
!   contrast to what is the case for claw2. It is convenient
!   to define the scheme using the pair (method(2),method(3)).

!   method(3) <  0 Gives dimensional splitting using Godunov
!                  splitting, i.e. formally first order
!                  accurate.
!                0 Gives the Donor cell method. No transverse
!                  propagation of neither the increment wave
!                  nor the correction wave.
!             = 10 Transverse propagation of the increment wave
!                  as in 2D. Note that method (2,10) is
!                  unconditionally unstable.
!             = 11 Corner transport upwind of the increment
!                  wave. Note that method (2,11) also is
!                  unconditionally unstable.
!             = 20 Both the increment wave and the correction
!                  wave propagate as in the 2D case. Only to
!                  be used with method(2) = 2.
!             = 21 Corner transport upwind of the increment wave,
!                  and the correction wave propagates as in 2D.
!                  Only to be used with method(2) = 2.
!             = 22 3D propagation of both the increment wave and
!                  the correction wave. Only to be used with
!                  method(2) = 2.

!   Recommended settings:   First order schemes:
!                                 (1,10) Stable for CFL < 1/2
!                                 (1,11) Stable for CFL < 1
!                           Second order schemes:
!                                  (2,20) Stable for CFL < 1/2
!                                  (2,22) Stable for CFL < 1

!   WARNING! The schemes (2,10), (2,11) are unconditionally
!            unstable.

! ----------------------------------

! Note that if method(6)=1 then the capa array comes into the second
! order correction terms, and is already included in dtdx1d:
! If ixyz = 1 then
!    dtdx1d(i) = dt/dx                      if method(6) = 0
!              = dt/(dx*capa(i,jcom,kcom))  if method(6) = 1
! If ixyz = 2 then
!    dtdx1d(j) = dt/dy                      if method(6) = 0
!              = dt/(dy*capa(icom,j,kcom))  if method(6) = 1
! If ixyz = 3 then
!    dtdx1d(k) = dt/dz                      if method(6) = 0
!              = dt/(dz*capa(icom,jcom,k))  if method(6) = 1

! Notation:
!    The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn3 into
!        amdq =  the left-going flux difference  A^- Delta q
!        apdq = the right-going flux difference  A^+ Delta q
!    Each of these is split by rpt3 into
!        bmasdq = the down-going transverse flux difference B^- A^* Delta q
!        bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
!    where A^* represents either A^- or A^+.


    implicit real*8(a-h,o-z)
    external rpn3,rpt3, rptt3
    dimension     q1d(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension    amdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension    apdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   cqxx(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   qadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   fadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension   hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)

    dimension  cmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpapdq(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  cmamdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmapdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpamdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpapdq2(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bmcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bmcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bpcmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcpapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcpapdq(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension dtdx1d(1-num_ghost:maxm+num_ghost)
    dimension aux1(1-num_ghost:maxm+num_ghost,3)
    dimension aux2(1-num_ghost:maxm+num_ghost,3)
    dimension aux3(1-num_ghost:maxm+num_ghost,3)

    dimension    s(num_waves,1-num_ghost:maxm+num_ghost)
    dimension  fwave(num_eqn,num_waves,1-num_ghost:maxm+num_ghost)

    dimension method(7),mthlim(num_waves)
    logical :: limit
    common/comxyt/dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom


    limit = .false.
    do mw=1,num_waves
        if (mthlim(mw) > 0) limit = .TRUE. 
    end do

    ! initialize flux increments:
    ! -----------------------------

    forall (m = 1:num_eqn, i = 1-num_ghost:mx+num_ghost)
        qadd(m,i) = 0.d0
        fadd(m,i) = 0.d0
    end forall
    forall (m = 1:num_eqn, k = 1:2, j = -1:1, i = 1-num_ghost:mx+num_ghost)
        gadd(m, k, j, i) = 0.d0
        hadd(m, k, j, i) = 0.d0
    end forall

    ! local method parameters
    if (method(3) < 0) then
    ! dimensional splitting
        m3 = -1
        m4 = 0
    else
    ! unsplit method
        m3 = method(3)/10
        m4 = method(3) - 10*m3
    endif

    ! -----------------------------------------------------------
    ! solve normal Riemann problem and compute Godunov updates
    ! -----------------------------------------------------------

    ! aux2(1-num_ghost,1,2) is the start of a 1d array now used by rpn3

    call rpn3(ixyz,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux2(1,1-num_ghost,2),aux2(1,1-num_ghost,2),fwave,s,amdq,apdq)


    ! Set qadd for the donor-cell upwind method (Godunov)
    forall (m = 1:num_eqn, i = 1:mx+1)
        qadd(m,i) = qadd(m,i) - dtdx1d(i)*apdq(m,i)
        qadd(m,i-1) = qadd(m,i-1) - dtdx1d(i-1)*amdq(m,i)
    end forall

    ! compute maximum wave speed for checking Courant number:
    cfl1d = 0.d0
    do i=1,mx+1
        do mw=1,num_waves
            ! if s>0 use dtdx1d(i) to compute CFL,
            ! if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i), &
            -dtdx1d(i-1)*s(mw,i))
        end do
    end do

    if (method(2) == 1) go to 130

    ! -----------------------------------------------------------
    ! modify F fluxes for second order q_{xx} correction terms:
    ! F fluxes are in normal, or x-like, direction
    ! -----------------------------------------------------------

    ! apply limiter to waves:
    if (limit) call limiter(maxm,num_eqn,num_waves,num_aux,num_ghost,mx,fwave,s,mthlim)

    do i = 2-num_ghost,mx+num_ghost
    
        ! For correction terms below, need average of dtdx in cell
        ! i-1 and i.  Compute these and overwrite dtdx1d:
    
        dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))
    
        forall (m = 1:num_eqn)
            cqxx(m,i) = 0.d0
        end forall
        do mw = 1,num_waves
            do m = 1,num_eqn
                cqxx(m,i) = cqxx(m,i) + 0.5d0 * dsign(s(mw,i)) &
                * (1.d0 - dabs(s(mw,i))*dtdxave) * fwave(m,mw,i)
            end do
        end do
        do m = 1,num_eqn
            fadd(m,i) = fadd(m,i) + cqxx(m,i)
        end do
    
        130 continue
    
        if (m3 <= 0) return !! no transverse propagation
    
        ! --------------------------------------------
        ! TRANSVERSE PROPAGATION
        ! --------------------------------------------
        
        ! split the left-going flux difference into down-going and up-going
        ! flux differences (in the y-direction).
        
        call rpt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                  aux3,1,amdq,bmamdq,bpamdq)
    
        ! split the right-going flux difference into down-going and up-going
        ! flux differences (in the y-direction).
    
        call rpt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                  aux3,2,apdq,bmapdq,bpapdq)
    
        ! split the left-going flux difference into down-going and up-going
        ! flux differences (in the z-direction).
    
        call rpt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                  aux3,1,amdq,cmamdq,cpamdq)
    
        ! split the right-going flux difference into down-going and up-going
        ! flux differences (in the y-direction).
    
        call rpt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                  aux3,2,apdq,cmapdq,cpapdq)
    
        ! Split the correction wave into transverse propagating waves
        ! in the y-direction and z-direction.
    
        if (m3 == 2) then
            if (num_aux > 0) then
                ! The corrections cqxx affect both cell i-1 to left and cell i
                ! to right of interface.  Transverse splitting will affect
                ! fluxes on both sides.
                ! If there are aux arrays, then we must split cqxx twice in
                ! each transverse direction, once with imp=1 and once with imp=2:

                ! imp = 1 or 2 is used to indicate whether we are propagating
                ! amdq or apdq, i.e. cqxxm or cqxxp

                ! in the y-like direction with imp=1
                call rpt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                          aux1,aux2,aux3,1,cqxx,bmcqxxm,bpcqxxm)

                ! in the y-like direction with imp=2
                call rpt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                          aux1,aux2,aux3,2,cqxx,bmcqxxp,bpcqxxp)

                ! in the z-like direction with imp=1
                call rpt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                          aux1,aux2, aux3,1,cqxx,cmcqxxm,cpcqxxm)

                ! in the z-like direction with imp=2
                call rpt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                          aux1,aux2,aux3,2,cqxx,cmcqxxp,cpcqxxp)
            else
                !  aux arrays aren't being used, so we only need to split
                !  cqxx once in each transverse direction and the same result can
                !  presumably be used to left and right.
                !  Set imp = 0 since this shouldn't be needed in rpt3 in this case.

                !  in the y-like direction
                call rpt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                          aux1,aux2,aux3,0,cqxx,bmcqxxm,bpcqxxm)

                ! in the z-like direction
                call rpt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
                          aux1,aux2,aux3,0,cqxx,cmcqxxm,cpcqxxm)

                ! use the same splitting to left and right:
                forall (m = 1:num_eqn, i = 0:mx+2)
                    bmcqxxp(m,i) = bmcqxxm(m,i)
                    bpcqxxp(m,i) = bpcqxxm(m,i)
                    cmcqxxp(m,i) = cmcqxxm(m,i)
                    cpcqxxp(m,i) = cpcqxxm(m,i)
                end forall
            endif
        endif
    
        ! --------------------------------------------
        ! modify G fluxes in the y-like direction
        ! --------------------------------------------
        
        ! If the correction wave also propagates in a 3D sense, incorporate
        ! cpcqxx,... into cmamdq, cpamdq, ... so that it is split also.
    
        if(m4 == 1)then
            forall (m = 1:num_eqn, i = 0:mx+2)
                cpapdq2(m,i) = cpapdq(m,i)
                cpamdq2(m,i) = cpamdq(m,i)
                cmapdq2(m,i) = cmapdq(m,i)
                cmamdq2(m,i) = cmamdq(m,i)
            end forall
        else if(m4 == 2)then
            forall (m = 1:num_eqn, i = 0:mx+2)
                cpapdq2(m,i) = cpapdq(m,i) - 3.d0*cpcqxxp(m,i)
                cpamdq2(m,i) = cpamdq(m,i) + 3.d0*cpcqxxm(m,i)
                cmapdq2(m,i) = cmapdq(m,i) - 3.d0*cmcqxxp(m,i)
                cmamdq2(m,i) = cmamdq(m,i) + 3.d0*cmcqxxm(m,i)
            end forall
        endif
    
        ! The transverse flux differences in the z-direction are split
        ! into waves propagating in the y-direction. If m4 = 2,
        ! then the transverse propagating correction waves in the z-direction
        ! are also split. This yields terms of the form BCAu_{xzy} and
        ! BCAAu_{xxzy}.
    
        if( m4 > 0 )then
            call rptt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,2,2,cpapdq2,bmcpapdq,bpcpapdq)
            call rptt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,1,2,cpamdq2,bmcpamdq,bpcpamdq)
            call rptt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,2,1,cmapdq2,bmcmapdq,bpcmapdq)
            call rptt3(ixyz,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,1,1,cmamdq2,bmcmamdq,bpcmamdq)
        endif
    
        ! -----------------------------
        ! The updates for G fluxes :
        ! -----------------------------
    
        do i = 1, mx+1
            do m=1,num_eqn
            
                ! Transverse propagation of the increment waves
                ! between cells sharing interfaces, i.e. the 2D approach.
                ! Yields BAu_{xy}.
            
                gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                    - 0.5d0*dtdx1d(i-1)*bmamdq(m,i)
                gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                    - 0.5d0*dtdx1d(i-1)*bpamdq(m,i)
                gadd(m,1,0,i)   = gadd(m,1,0,i) &
                    - 0.5d0*dtdx1d(i)*bmapdq(m,i)
                gadd(m,2,0,i)   = gadd(m,2,0,i) &
                    - 0.5d0*dtdx1d(i)*bpapdq(m,i)
            
                ! Transverse propagation of the increment wave (and the
                ! correction wave if m4=2) between cells
                ! only having a corner or edge in common. Yields terms of the
                ! BCAu_{xzy} and BCAAu_{xxzy}.
            
                if( m4 > 0 )then

                    gadd(m,2,0,i) = gadd(m,2,0,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                        * (bpcpapdq(m,i) - bpcmapdq(m,i))
                    gadd(m,1,0,i) = gadd(m,1,0,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                        * (bmcpapdq(m,i) - bmcmapdq(m,i))

                    gadd(m,2,1,i) = gadd(m,2,1,i) &
                        - (1.d0/6.d0)*dtdx1d(i)*dtdz &
                        * bpcpapdq(m,i)
                    gadd(m,1,1,i) = gadd(m,1,1,i) &
                        - (1.d0/6.d0)*dtdx1d(i)*dtdz &
                        * bmcpapdq(m,i)
                    gadd(m,2,-1,i) = gadd(m,2,-1,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                        * bpcmapdq(m,i)
                    gadd(m,1,-1,i) = gadd(m,1,-1,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                        * bmcmapdq(m,i)
                
                    gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                        * (bpcpamdq(m,i) - bpcmamdq(m,i))
                    gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                        * (bmcpamdq(m,i) - bmcmamdq(m,i))


                    gadd(m,2,1,i-1) = gadd(m,2,1,i-1) &
                        - (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                        * bpcpamdq(m,i)
                    gadd(m,1,1,i-1) = gadd(m,1,1,i-1) &
                        - (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                        * bmcpamdq(m,i)
                    gadd(m,2,-1,i-1) = gadd(m,2,-1,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                        * bpcmamdq(m,i)
                    gadd(m,1,-1,i-1) = gadd(m,1,-1,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                        * bmcmamdq(m,i)
                
                endif
            
                ! Transverse propagation of the correction wave between
                ! cells sharing faces. This gives BAAu_{xxy}.
            
                if (m3 .ge. 2) then
                    gadd(m,2,0,i)   = gadd(m,2,0,i) &
                        + dtdx1d(i)*bpcqxxp(m,i)
                    gadd(m,1,0,i)   = gadd(m,1,0,i) &
                        + dtdx1d(i)*bmcqxxp(m,i)
                    gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                        - dtdx1d(i-1)*bpcqxxm(m,i)
                    gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                        - dtdx1d(i-1)*bmcqxxm(m,i)
                endif
            end do
        end do
    
    
        ! --------------------------------------------
        ! modify H fluxes in the z-like direction
        ! --------------------------------------------
        
        ! If the correction wave also propagates in a 3D sense, incorporate
        ! cqxx into bmamdq, bpamdq, ... so that is is split also.
    
        if(m4 == 2)then
            forall (m = 1:num_eqn, i = 0:mx+2)
                bpapdq(m,i) = bpapdq(m,i) - 3.d0*bpcqxxp(m,i)
                bpamdq(m,i) = bpamdq(m,i) + 3.d0*bpcqxxm(m,i)
                bmapdq(m,i) = bmapdq(m,i) - 3.d0*bmcqxxp(m,i)
                bmamdq(m,i) = bmamdq(m,i) + 3.d0*bmcqxxm(m,i)
            end forall
        endif
    
        ! The transverse flux differences in the y-direction are split
        ! into waves propagating in the z-direction. If m4 = 2,
        ! then the transverse propagating correction waves in the y-direction
        ! are also split. This yields terms of the form BCAu_{xzy} and
        ! BCAAu_{xxzy}.
        
        ! note that the output to rptt3 below should logically be named
        ! cmbsasdq and cpbsasdq rather than bmcsasdq and bpcsasdq, but
        ! we are re-using the previous storage rather than requiring new arrays.
    
        if( m4 > 0 )then
            call rptt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,2,2,bpapdq,bmcpapdq,bpcpapdq)
            call rptt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,1,2,bpamdq,bmcpamdq,bpcpamdq)
            call rptt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,2,1,bmapdq,bmcmapdq,bpcmapdq)
            call rptt3(ixyz,3,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d,aux1,aux2, &
                       aux3,1,1,bmamdq,bmcmamdq,bpcmamdq)
        endif
    
        ! -----------------------------
        ! The updates for H fluxes :
        ! -----------------------------
    
        do i = 1, mx+1
            do m=1,num_eqn
            
                ! Transverse propagation of the increment waves
                ! between cells sharing interfaces, i.e. the 2D approach.
                ! Yields CAu_{xy}.
            
                hadd(m,1,0,i-1) = hadd(m,1,0,i-1) &
                    - 0.5d0*dtdx1d(i-1)*cmamdq(m,i)
                hadd(m,2,0,i-1) = hadd(m,2,0,i-1) &
                    - 0.5d0*dtdx1d(i-1)*cpamdq(m,i)
                hadd(m,1,0,i)   = hadd(m,1,0,i) &
                    - 0.5d0*dtdx1d(i)*cmapdq(m,i)
                hadd(m,2,0,i)   = hadd(m,2,0,i) &
                    - 0.5d0*dtdx1d(i)*cpapdq(m,i)
            
                ! Transverse propagation of the increment wave (and the
                ! correction wave if m4=2) between cells
                ! only having a corner or edge in common. Yields terms of the
                ! CBAu_{xzy} and CBAAu_{xxzy}.
            
                if( m4 > 0 )then
                
                    hadd(m,2,0,i)  = hadd(m,2,0,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                        * (bpcpapdq(m,i) - bpcmapdq(m,i))
                    hadd(m,1,0,i)  = hadd(m,1,0,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                        * (bmcpapdq(m,i) - bmcmapdq(m,i))


                    hadd(m,2,1,i)  = hadd(m,2,1,i) &
                        - (1.d0/6.d0)*dtdx1d(i)*dtdy &
                        * bpcpapdq(m,i)
                    hadd(m,1,1,i)  = hadd(m,1,1,i) &
                        - (1.d0/6.d0)*dtdx1d(i)*dtdy &
                        * bmcpapdq(m,i)
                    hadd(m,2,-1,i) = hadd(m,2,-1,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                        * bpcmapdq(m,i)
                    hadd(m,1,-1,i) = hadd(m,1,-1,i) &
                        + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                        * bmcmapdq(m,i)
                
                    hadd(m,2,0,i-1)  = hadd(m,2,0,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                        * (bpcpamdq(m,i) - bpcmamdq(m,i))
                    hadd(m,1,0,i-1)  = hadd(m,1,0,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                        * (bmcpamdq(m,i) - bmcmamdq(m,i))


                    hadd(m,2,1,i-1)  = hadd(m,2,1,i-1) &
                        - (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                        * bpcpamdq(m,i)
                    hadd(m,1,1,i-1)  = hadd(m,1,1,i-1) &
                        - (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                        * bmcpamdq(m,i)
                    hadd(m,2,-1,i-1) = hadd(m,2,-1,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                        * bpcmamdq(m,i)
                    hadd(m,1,-1,i-1) = hadd(m,1,-1,i-1) &
                        + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                        * bmcmamdq(m,i)
                endif
            
                ! Transverse propagation of the correction wave between
                ! cells sharing faces. This gives CAAu_{xxy}.
            
                if (m3 .ge. 2) then
                    hadd(m,2,0,i)   = hadd(m,2,0,i) &
                        + dtdx1d(i)*cpcqxxp(m,i)
                    hadd(m,1,0,i)   = hadd(m,1,0,i) &
                        + dtdx1d(i)*cmcqxxp(m,i)
                    hadd(m,2,0,i-1) = hadd(m,2,0,i-1) &
                        - dtdx1d(i-1)*cpcqxxm(m,i)
                    hadd(m,1,0,i-1) = hadd(m,1,0,i-1) &
                        - dtdx1d(i-1)*cmcqxxm(m,i)
                end if
            end do
        end do
    
    return
end subroutine flux3

!
! -------------------------------------------------------------
!
subroutine step2y(maxm,meqn,maux,mbc,mx,my,qold,aux,dy,dt,cflgrid,gm,gp,rpn2)
!
!     clawpack routine ...  modified for AMRCLAW
!
!     Take one time step, updating q.
!     On entry, qold gives
!        initial data for this step
!        and is unchanged in this version.
!    
!     fm, fp are fluxes to left and right of single cell edge
!     See the flux2 documentation for more information.
!
!     Converted to f90 2012-1-04 (KTM)
!
    
    use amr_module

    implicit none
    
    external rpn2
    
    ! Arguments
    integer, intent(in) :: maxm,meqn,maux,mbc,mx,my
    real(kind=8), intent(in) :: dy,dt
    real(kind=8), intent(inout) :: cflgrid
    real(kind=8), intent(inout) :: qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: gm(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: gp(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    
    ! Local storage for flux accumulation (these help compute normal g flux, based on step2 usage)
    real(kind=8) :: faddm(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: faddp(meqn,1-mbc:maxm+mbc)

    
    ! Scratch storage for Sweeps and Riemann problems
    real(kind=8) ::  q1d(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: aux2(maux,1-mbc:maxm+mbc)
    real(kind=8) :: dtdy1d(1-mbc:maxm+mbc)
    
    real(kind=8) ::  wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8) ::     s(mwaves, 1-mbc:maxm + mbc)
    real(kind=8) ::  cqxx(meqn,1-mbc:maxm + mbc)
    
    ! Looping scalar storage
    integer :: i
    real(kind=8) :: dtdy,cfl1d
    
    
    cflgrid = 0.d0
    dtdy = dt/dy
    
    gm = 0.d0
    gp = 0.d0


    ! ============================================================================
    !  y-sweeps   (for Godunov split method, called from stepgrid_dimSplit)
    !  loop indices assume that x sweep has gone first, this is second sweep.
    do i = 1,mx
        
        ! Copy data along a slice into 1d arrays:
        q1d(:,1-mbc:my+mbc) = qold(:,i,1-mbc:my+mbc)

        ! Set dt/dy ratio in slice
        if (mcapa > 0) then
            dtdy1d(1-mbc:my+mbc) = dtdy / aux(mcapa,i,1-mbc:my+mbc)
        else
            dtdy1d = dtdy
        endif

        ! Copy aux slices
        if (maux .gt. 0)  then

            aux2(:,1-mbc:my+mbc) = aux(:,i,1-mbc:my+mbc)

        endif
        
        ! Compute modifications fadd and gadd to fluxes along this slice
!!!     ::: dont need aux1 and aux3 for dimensionally split method
!!!     ::: but flux2 needs 3 aux arrays, so passing in aux2 3 times
        call flux2_dimSplit(2,maxm,meqn,maux,mbc,my,q1d,dtdy1d,aux2, &
                   faddm,faddp,cfl1d,wave,s,cqxx,rpn2)

        cflgrid = max(cflgrid,cfl1d)

        ! Update fluxes
        gm(:,i,1:my+1) = gm(:,i,1:my+1) + faddm(:,1:my+1)
        gp(:,i,1:my+1) = gp(:,i,1:my+1) + faddp(:,1:my+1)

    enddo


end subroutine step2y

! qinit routine for parabolic bowl problem, only single layer
subroutine qinit(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)

    use geoclaw_module, only: grav

    implicit none

    ! Subroutine arguments
    integer, intent(in) :: meqn,mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Parameters for problem
    real(kind=8), parameter :: a = 1.d0
    real(kind=8), parameter :: sigma = 0.5d0
    real(kind=8), parameter :: h0 = 0.1d0

    ! Other storage
    integer :: i,j
    real(kind=8) :: omega,x,y,eta
    
    omega = sqrt(2.d0 * grav * h0) / a
    
    do i=1-mbc,mx+mbc
        x = xlower + (i - 0.5d0)*dx
        do j=1-mbc,my+mbc
            y = ylower + (j - 0.5d0) * dy
            eta = sigma * h0 / a**2 * (2.d0 * x - sigma)
            
            q(1,i,j) = max(0.d0,eta - aux(1,i,j))
            q(2,i,j) = 0.d0
            q(3,i,j) = sigma * omega * q(1,i,j)
        enddo
    enddo
    
end subroutine qinit

c     ============================================
      subroutine setaux(mbc,mx,my,xlower,ylower,dxc,dyc,
     &                  maux,aux)
c     ============================================
c
c     # set auxiliary arrays for advection on a curvilinear grid
c
c     # on input, (xc(i),yc(j)) gives uniformly spaced computational grid.
c     # on output, 
c     #   aux(1,i,j) is edge velocity at "left" boundary of grid point (i,j)
c     #   aux(2,i,j) is edge velocity at "bottom" boundary of grid point (i,j)
c     #   aux(3,i,j) = kappa  is ratio of cell area to dxc*dyc
c     
      implicit double precision (a-h,o-z)
      double precision, intent(inout), 
     &              dimension(3, 1-mbc:mx+mbc,1-mbc:my+mbc) :: aux
      dimension xccorn(5),yccorn(5),xpcorn(5),ypcorn(5)
c
c
      do 20 j=1-mbc,my+mbc
         do 20 i=1-mbc,mx+mbc
c
c           # computational points (xc,yc) are mapped to physical
c           # coordinates (xp,yp) by mapc2p:
c
c           # lower left corner:
        xccorn(1) = xlower + (i-1)*dxc
        yccorn(1) = ylower + (j-1)*dyc
        call mapc2p(xccorn(1),yccorn(1),xpcorn(1),ypcorn(1))

c           # upper left corner:
        xccorn(2) = xccorn(1)
        yccorn(2) = yccorn(1) + dyc
        call mapc2p(xccorn(2),yccorn(2),xpcorn(2),ypcorn(2))
c
c           # upper right corner:
        xccorn(3) = xccorn(1) + dxc
        yccorn(3) = yccorn(1) + dyc
        call mapc2p(xccorn(3),yccorn(3),xpcorn(3),ypcorn(3))
c
c           # lower right corner:
        xccorn(4) = xccorn(1) + dxc
        yccorn(4) = yccorn(1)
        call mapc2p(xccorn(4),yccorn(4),xpcorn(4),ypcorn(4))
c
c
c           # compute edge velocities by differencing stream function:
c
        aux(1,i,j) = (stream(xpcorn(2),ypcorn(2))
     &            - stream(xpcorn(1),ypcorn(1)))/ dyc
c
        aux(2,i,j) = -(stream(xpcorn(4),ypcorn(4))
     &            - stream(xpcorn(1),ypcorn(1)))/ dxc

c
c
c           # compute area of physical cell from four corners:

        xpcorn(5) = xpcorn(1)
        ypcorn(5) = ypcorn(1)
        area = 0.d0
        do ic=1,4
          area = area + 0.5d0 * (ypcorn(ic)+ypcorn(ic+1)) *
     &               (xpcorn(ic+1)-xpcorn(ic))
        enddo
        
        aux(3,i,j) = area / (dxc*dyc)
c
   20  continue
c
       return

       end

subroutine b4step2(mbc,mx,my,meqn,q,xlower,ylower,dx,dy,t,dt,maux,aux)
! ============================================
! 
! # called before each call to step
! # use to set time-dependent aux arrays or perform other tasks.
! 
! This particular routine sets negative values of q(1,i,j) to zero,
! as well as the corresponding q(m,i,j) for m=1,meqn.
! This is for problems where q(1,i,j) is a depth.
! This should occur only because of rounding error.
! 
! Also calls movetopo if topography might be moving.

    use amr_module, only: xlowdomain => xlower
    use amr_module, only: ylowdomain => ylower
    use amr_module, only: xhidomain => xupper
    use amr_module, only: yhidomain => yupper
    use amr_module, only: xperdom, yperdom, spheredom

    use geoclaw_module, only: g => grav, rho

    use topo_module, only: num_dtopo, topotime
    use topo_module, only: aux_finalized
    use topo_module, only: xlowdtopo,xhidtopo,ylowdtopo,yhidtopo

    use storm_module, only: set_storm_fields

    use multilayer_module, only: num_layers, KAPPA_UNIT, dry_tolerance
    use multilayer_module, only: check_richardson, richardson_tolerance
    
    implicit none
    
    ! Subroutine arguments
    integer, intent(in) :: mbc,mx,my,meqn,maux
    real(kind=8), intent(in) :: xlower, ylower, dx, dy, t, dt
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Local storage
    integer :: index,i,j,k
    real(kind=8) :: h(num_layers),u(num_layers),v(num_layers)
    real(kind=8) :: kappa,one_minus_r
    logical :: dry_state(num_layers)

    ! Format strings
    character(len=*), parameter :: hyp_warning = '("Hyperbolicity may have failed at index (",i4,",",i4,")")'
    character(len=*), parameter :: hyp_info = '("  layer = ",i2,"  kappa = ",d16.8)'

    ! Check for NaNs in the solution
    call check4nans(meqn,mbc,mx,my,q,t,1)

    ! check for h < 0 and reset to zero
    ! check for h < drytolerance
    ! set hu = hv = 0 in all these cells
    forall(i=1-mbc:mx+mbc, j=1-mbc:my+mbc, k=1:num_layers, &
           q(3*(k-1)+1,i,j) / rho(k) < dry_tolerance(k))
        q(3*(k-1)+2:3*(k-1)+3,i,j) = 0.d0
    end forall

    ! Move the topography if needed
    if (aux_finalized < 2) then
        call setaux(mbc, mx, my, xlower, ylower, dx, dy, maux, aux)
    endif 

    call set_storm_fields(maux,mbc,mx,my,xlower,ylower,dx,dy,t,aux)

    ! Check Richardson number -- Only implemented for 2 layers
    if (num_layers == 2 .and. check_richardson) then
        do i=1,mx
            do j=1,my
                dry_state = .false.
                do k=1,num_layers
                    index = 3*(k-1)
                    h(k) = q(index+1,i,j) / rho(k)
                    if (h(k) > dry_tolerance(k)) then
                        u(k) = q(index+2,i,j) / q(index+1,i,j)
                        v(k) = q(index+3,i,j) / q(index+1,i,j)
                    else
                        dry_state(k) = .true.
                        u(k) = 0.d0
                        v(k) = 0.d0
                    endif
                enddo
                ! Calculate for each layer pairing
                do k=1,num_layers-1
                    one_minus_r = 1.d0 - rho(k) / rho(k+1)
                    if (sum(h(k:k+1)) > dry_tolerance(k)) then
                        kappa = (u(k) - u(k+1))**2 / (g*one_minus_r*sum(h(k:k+1)))
                        if (kappa > richardson_tolerance) then
                            write(KAPPA_UNIT,hyp_warning) i,j
                            write(KAPPA_UNIT,hyp_info) k,kappa
                            print hyp_warning, i,j
                            print hyp_info, k,kappa
                        endif
                        kappa = (v(k) - v(k+1))**2 / (g*one_minus_r*sum(h(k:k+1)))
                        if (kappa > richardson_tolerance) then
                            write(KAPPA_UNIT,hyp_warning) i,j
                            write(KAPPA_UNIT,hyp_info) k,kappa
                            print hyp_warning, i,j
                            print hyp_info, k,kappa
                        endif
                    endif
                enddo
            enddo
        enddo
    endif

end subroutine b4step2

! =====================================================
subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =====================================================

! HLLE solver for the Euler equations.

! waves: 2
! equations: 4

! Conserved quantities:
!       1 density
!       2 x-momentum
!       3 y-momentum
!       4 energy

    implicit none

    integer, intent(in) :: ixy, maxm, meqn, mwaves, maux, mbc, mx
    double precision, dimension(meqn,1-mbc:maxm+mbc), intent(in) :: ql, qr
    double precision, dimension(maux,1-mbc:maxm+mbc), intent(in) :: auxl, auxr
    double precision, dimension(meqn, mwaves, 1-mbc:maxm+mbc), intent(out) :: wave
    double precision, dimension(mwaves, 1-mbc:maxm+mbc), intent(out) :: s
    double precision, dimension(meqn, 1-mbc:maxm+mbc), intent(out) :: amdq, apdq

    double precision :: u_l, u_r, c_l, c_r, u_hat, c_hat, v_l, v_r, v_hat
    double precision :: p_l, p_r, H_l, H_r, rhsqrt_l, rhsqrt_r
    double precision :: rhsq2, H_hat, gamma, gamma1, E_l, E_r
    double precision :: rho_m, rhou_m, rhov_m, E_m, s1, s2
    integer :: rho, mu, mv, E
    integer :: i, m, mw

    common /cparam/  gamma

    gamma1 = gamma - 1.d0

!     # set mu to point to  the component of the system that corresponds
!     # to momentum in the direction of this slice, mv to the orthogonal
!     # momentum:
!

    rho = 1
    E = 4
    if (ixy.eq.1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    do i=2-mbc,mx+mbc
        ! Velocity
        u_l = qr(mu,i-1) / qr(rho,i-1)
        u_r = ql(mu,i  ) / ql(rho,i  )
        v_l = qr(mv,i-1) / qr(rho,i-1)
        v_r = ql(mv,i  ) / ql(rho,i  )
        ! Pressure
        p_l = gamma1 * (qr(E,i-1) - qr(rho,i-1)*(u_l**2+v_l**2)/2.d0)
        p_r = gamma1 * (ql(E,i  ) - ql(rho,i  )*(u_r**2+v_r**2)/2.d0)
        ! Enthalpy
        H_l = (qr(E,i-1) + p_l) / qr(rho,i-1)
        H_r = (ql(E,i  ) + p_l) / ql(rho,i  )
        ! Sound speed
        c_l = dsqrt(gamma1*H_l-u_l**2/2.)
        c_r = dsqrt(gamma1*H_r-u_r**2/2.)

        E_l = qr(E,i-1)
        E_r = ql(E,i  )

        rhsqrt_l = dsqrt(qr(rho,i-1))
        rhsqrt_r = dsqrt(ql(rho,i))
        rhsq2 = rhsqrt_l + rhsqrt_r
        u_hat = (qr(mu,i-1)/rhsqrt_l + ql(mu,i)/rhsqrt_r) / rhsq2
        v_hat = (qr(mv,i-1)/rhsqrt_l + ql(mv,i)/rhsqrt_r) / rhsq2
        H_hat = (((qr(E,i-1)+p_l)/rhsqrt_l + (ql(E,i)+p_r)/rhsqrt_r)) / rhsq2
        c_hat = dsqrt(gamma1*(H_hat - 0.5d0*(u_hat**2+v_hat**2)))

        ! Speeds of non-shear waves
        s1 = min(u_l - c_l, u_hat - c_hat)
        s2 = max(u_r + c_r, u_hat + c_hat)

        ! "middle" state
        rho_m = (ql(mu,i) - qr(mu,i-1) - s2*ql(rho,i) + s1*qr(rho,i-1))/(s1-s2)
        rhou_m = (ql(rho,i)*u_r**2 - qr(rho,i-1)*u_l**2 + p_r - p_l - s2*ql(mu,i) + s1*qr(mu,i-1))/(s1-s2)
        rhov_m = (ql(mv,i)*u_r - qr(mv,i-1)*u_l - s2*ql(mv,i) + s1*qr(mv,i-1))/(s1-s2)
        E_m = ( u_r*(E_r+p_r) - u_l*(E_l+p_l) -s2*E_r + s1*E_l)/(s1-s2)

        wave(rho,1,i) = rho_m - qr(rho,i-1)
        wave(mu,1,i) = rhou_m - qr(mu,i-1)
        wave(mv,1,i) = rhov_m - qr(mv,i-1)
        wave(E,1,i) = E_m - qr(E,i-1)
        s(1,i) = s1
    
        wave(rho,2,i) = ql(rho,i) - rho_m
        wave(mu,2,i) = ql(mu,i) - rhou_m
        wave(mv,2,i) = ql(mv,i) - rhov_m
        wave(E,2,i) = ql(E,i) - E_m
        s(2,i) = s2
    end do


    do m=1,meqn
        do i=2-mbc, mx+mbc
            amdq(m,i) = 0.d0
            apdq(m,i) = 0.d0
            do mw=1,mwaves
                if (s(mw,i) .lt. 0.d0) then
                    amdq(m,i) = amdq(m,i) + s(mw,i)*wave(m,mw,i)
                 else
                   apdq(m,i) = apdq(m,i) + s(mw,i)*wave(m,mw,i)
                 endif
            end do
        end do
    end do

end subroutine rpn2

c
c ----------------------------------------------------------
c
      subroutine copysol(valbig,val,nvar,mitot,mjtot,mktot,nghost,
     1                                   midub,mjdub,mkdub,ngbig)
c
      implicit double precision (a-h,o-z)

      dimension  valbig(nvar,midub,mjdub,mkdub)
      dimension  val   (nvar,mitot,mjtot,mktot)
c
c copy solution into grid with different number of ghost cells
c
       do 10 k = nghost+1, mktot-nghost
       do 10 j = nghost+1, mjtot-nghost
       do 10 i = nghost+1, mitot-nghost
       do 10 ivar = 1, nvar
          valbig(ivar,i-nghost+ngbig,j-nghost+ngbig,k-nghost+ngbig) =
     &                                                val(ivar,i,j,k)
 10    continue
c
       return
       end

! Set initial conditions for q.
subroutine qinit(meqn, mbc, mx, my, mz, xlower, ylower, zlower, dx, dy, dz, q, maux, aux)

    implicit none

    ! Input/Output
    integer, intent(in) :: meqn, mbc, mx, my, mz, maux
    real(kind=8), intent(in) :: xlower, ylower, zlower, dx, dy, dz
    real(kind=8), intent(inout) :: q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
    real(kind=8), intent(in) :: aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)

    ! Local storage
    integer :: i, j, k
    real(kind=8) :: x, y, z, r, rho

    do i = 1, mx
        x = xlower + (i - 0.5d0) * dx
        do j = 1, my
            y = ylower + (j - 0.5d0) * dy
            do k = 1, mz
                z = zlower + (k - 0.5d0) * dz
                r = sqrt(x**2 + y**2 + z**2)
                rho = 1.d0 + 10.d0 * exp(-20.d0 * (r - 0.d0)**2)
                q(1, i, j, k) = rho
                q(2, i, j, k) = 0.d0
                q(3, i, j, k) = 0.d0
                q(4, i, j, k) = 0.d0
                q(5, i, j, k) = rho
            end do
        end do
    end do
end subroutine qinit

c
c -------------------------------------------------------------
c
      subroutine ginit(msave, first, nvar, naux, start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      logical first


c ::::::::::::::::::::::::::::: GINIT ::::::::::::::::::::::::
c
c  initializes soln on all grids at 'level'  by calling qinit
c  if first = true, (first call to init), then allocate the
c  soln storage area too, else was already allocated.
c
c :::::::::::::::::::::::::::::::::::::::;::::::::::::::::::::

      if (msave .eq. 0) go to 99

      level = node(nestlevel,msave)
      hx    = hxposs(level)
      hy    = hyposs(level)
      mptr  = msave
 
 10       nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot   = nx + 2*nghost
          mjtot   = ny + 2*nghost
          corn1   = rnode(cornxlo,mptr)
          corn2   = rnode(cornylo,mptr)
          if(.not. (first)) go to 20
              loc                 = igetsp(mitot*mjtot*nvar)
              node(store1,mptr)   = loc
              if (naux .gt. 0) then
                locaux              = igetsp(mitot*mjtot*naux)
                do k = 1, mitot*mjtot*naux, naux  ! only set first component of aux to signal
                   alloc(locaux+k-1) = NEEDS_TO_BE_SET ! new system checks this val before setting
                end do
                
                call setaux(nghost,nx,ny,corn1,corn2,hx,hy,
     &                    naux,alloc(locaux))
              else 
                locaux = 1
              endif
              node(storeaux,mptr) = locaux
              if (level .lt. mxnest) then
                loc2              = igetsp(mitot*mjtot*nvar)
                node(store2,mptr) = loc2
              endif
              rnode(timemult, mptr) = start_time
              go to 30
 20       continue
c
c  if 2nd time through, put initial values in store2 so finer grids
c  can be advanced with interpolation of their boundary values.
c  new time soln should still be in location store1.
c
          loc     = node(store2,mptr)
          locaux  = node(storeaux,mptr)
c
   30     continue
          call qinit(nvar,nghost,nx,ny,corn1,corn2,hx,hy,
     &               alloc(loc),naux,alloc(locaux))

c
          mptr  = node(levelptr, mptr)
      if (mptr .ne. 0) go to 10
c
c
 99   continue
      return
      end

subroutine conck(level, nvar, naux, time, rest)
    !> Conservation check for specified level.
    !! This is mostly a debugging tool and assumes grids don't overlap
    !! Modified for GeoClaw:  sum up zeta = h or h+B
 
    use amr_module, only: node,store1,storeaux,ndilo,ndjlo,ndihi,ndjhi
    use amr_module, only: lstart,nghost,levelptr,outunit,mcapa
    use amr_module, only: alloc,t0,hxposs,hyposs,possk,tmass0
    implicit none
    real(kind=8), intent(in) :: time
    integer, intent(in) :: level,nvar,naux
    logical, intent(in) :: rest

    real(kind=8) :: hx,hy,dt,totmass,zeta
    integer :: mptr,loc,locaux,nx,ny,mitot,mjtot,i,j

    ! grid loop for given level
 
    hx      = hxposs(level)
    hy      = hyposs(level)
    dt      = possk(level)
    totmass = 0.d0

    mptr = lstart(level)
    
    do while (mptr > 0)
        
        loc    = node(store1,mptr)
        locaux = node(storeaux,mptr)
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost

        do j  = nghost+1, mjtot-nghost
            do i  = nghost+1, mitot-nghost
                if (alloc(iaddaux(1,i,j,locaux,mitot)) < 0.d0) then
                    ! B<0, zeta = h+B
                    zeta = alloc(iadd(1,i,j,loc,mitot)) &
                           + alloc(iaddaux(1,i,j,locaux,mitot))
                else
                    ! B>0, zeta = h
                    zeta = alloc(iadd(1,i,j,loc,mitot))
                endif
                if (mcapa > 0) then
                    zeta = zeta * alloc(iaddaux(mcapa,i,j,locaux,mitot)) 
                endif
                totmass = totmass + zeta
            enddo
        enddo           
        
        mptr = node(levelptr,mptr)  ! next patch
    enddo
 
    totmass = totmass * hx * hy
    if (time.eq. t0 .and. (level.eq.1) .and. .not. rest) then
        tmass0 = totmass
        write(6,*) 'Total zeta at initial time: ',tmass0
    endif
    write(outunit,77) time, totmass, totmass-tmass0
 77 format('time t = ',e12.5,',  total zeta = ',e22.15, '  diff = ', e11.4)
 
contains

    integer pure function iadd(ivar,i,j,loc,mitot)
        integer, intent(in) :: i, j, ivar, loc, mitot
        iadd = loc + ivar-1 + nvar*((j-1)*mitot+i-1)
    end function iadd

    integer pure function iaddaux(ivar,i,j,locaux,mitot)
        integer, intent(in) :: i, j, ivar, locaux, mitot
        iaddaux = locaux + ivar-1 + naux*((j-1)*mitot+i-1)
    end function iaddaux

end subroutine conck

subroutine fgmax_interpolate(mx,my,meqn,mbc,maux,q,aux,dx,dy, &
           xlower,ylower,ifg,level,fg_values,i1,i2,j1,j2, &
           fg_klist,fg_klist_length,fg_npts)

    ! Given a grid patch, return fg_values containing values interpolated
    ! to the fixed grid fg => FG_fgrids(ifg).
    ! If there are aux arrays, also set fg%aux at any points where it has
    ! not yet been set on this level.

    ! This version uses either piecewise constant or bilinear interpolation 
    ! between neighboring cells, depending on fg%interp_method.

    use fgmax_module

    implicit none
    integer, intent(in) :: mx,my,meqn,mbc,maux,ifg,level,fg_npts
    integer, intent(in) :: fg_klist(fg_npts), fg_klist_length
    real(kind=8), intent(in) :: q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: dx,dy,xlower,ylower
    !real(kind=8), dimension(:,:), allocatable, intent(inout) :: fg_values
    !logical, dimension(:), allocatable, intent(inout) :: mask_fgrid
    real(kind=8), intent(inout) :: fg_values(FG_NUM_VAL,fg_klist_length)
    integer, intent(in) :: i1,i2,j1,j2

    type(fgrid), pointer :: fg
    integer :: i,j,k,mv,ma
    integer :: indexk
    real(kind=8), allocatable, dimension(:,:,:) :: values
    real(kind=8) :: x,y, ax,ay,aij,aipj,aijp,aipjp
    logical :: debug

    debug = FG_DEBUG
    if (debug) then
        write(61,*) '========================================'
        write(61,*) 'In fgmax_interpolate, Level = ',level
        endif

    fg => FG_fgrids(ifg)
    !fg_npts = fg%npts  ! now an input parameter
    !write(61,*) '++++ interpolate xNbb', fg%x1bb, fg%x2bb
    
    !write(6,61) fg%fgno, fg%npts
 61 format('Updating fgrid number ',i2,' with',i7,' points')

    ! array values with same size as patch:
    allocate(values(FG_NUM_VAL, 1-mbc:mx+mbc, 1-mbc:my+mbc))


    if (mbc < 1) then
        write(6,*) '*** mbc >= 1 required by fgmax_interpolate'
        stop
        endif


    ! Set the array values to be the values that we want to update:
    ! Note that values will be set properly only where i,j in [i1,i2,j1,j2]
    values = FG_NOTSET
    call fgmax_values(mx,my,meqn,mbc,maux,q,aux,dx,dy, &
                   xlower,ylower,i1,i2,j1,j2,values)
    if (debug) then
        write(65,*) '+++ i,j,x,y,values(1,i,j) '
        write(65,*) '    at points where i,j in [i1,i2,j1,j2]'
        do i=i1,i2
            x = xlower + (i-0.5d0)*dx
            do j=j1,j2
                y = ylower + (j-0.5d0)*dy
                write(65,65) i,j,x,y,values(1,i,j)
 65             format(2i4,2d16.6,d20.9)
                enddo
            enddo
        endif
        

    ! Determine indices of cell containing fixed grid point (x(k),y(k))

    !do i=1,fg_klist_length 
    !    k = fg_klist(i)
    !    ik(k) = int((fg%x(k) - xlower + dx) / dx)
    !    jk(k) = int((fg%y(k) - ylower + dy) / dy)
    !    enddo

    ! fix this loop?
    if (debug) then
        write(61,*) '+++ fg_klist: k,x,y,ik,jk: '
        endif


    ! reordered loops, now outer loop is over fgmax points on this patch
    do indexk=1,fg_klist_length 
    
        k = fg_klist(indexk)
        
        ! compute i,j directly without storing in ik,jk, since now only
        ! need to be computed once with new loop order  
        
        if (fg%interp_method == 0) then
            ! For piecewise constant interpolation,
            ! determine cell (i,j) to take value from:
            i = int((fg%x(k) - xlower + dx) / dx)
            j = int((fg%y(k) - ylower + dy) / dy)
        else
            ! For bilinear interpolation i or j may be 1 less than index
            ! of cell containing fgmax point, if it is to the left of cell
            ! center, since we interpolate between cells i and i+1,  j and j+1.
            ! So round instead of taking floor:
            i = nint((fg%x(k) - xlower) / dx)
            j = nint((fg%y(k) - ylower) / dy)
        endif
            
        
        if (debug) then
            write(61,62) k,fg%x(k),fg%y(k), i,j
62          format(i4,2d16.6,2i6,2d16.6)
            endif
            
        if (fg%interp_method == 1) then
            ! compute bilinear interpolation weights:
            x = xlower + (i-0.5d0)*dx  ! grid cell center on patch
            ax = (fg%x(k) - x) / dx    ! fraction of cell offset in x
            y = ylower + (j-0.5d0)*dy  ! grid cell center on patch
            ay = (fg%y(k) - y) / dy    ! fraction of cell offset in y
            
            ! weights:
            aij = (1.d0 - ax)*(1.d0 - ay)
            aipj = ax*(1.d0 - ay)
            aijp = (1.d0 - ax)*ay
            aipjp = ax*ay
            endif 

        do mv=1,FG_NUM_VAL
            ! loop over the different values we want to monitor
                
            ! Do not print the warning message below
            ! It is possible that i==0 or mx+1, or j==0 or my+1
            ! if the fg%x(k) or fg%y(k) was approx on the boundary of
            ! the patch, but in this case it should be ok to use the
            ! the ghost cell value. 
            !if ((i==mx+1) .or. (j==my+1)) then
            !    write(6,*) '**** Warning from fgmax_interpolate:'
            !    write(6,*) '**** Expected i <= mx, j<= my'
            !    write(6,*) 'i,j,mx,my: ',i,j,mx,my
            !    endif

            if (fg%interp_method == 0) then
                ! for pw constant
                fg_values(mv,indexk) = values(mv,i,j)
              else
                ! bilinear:
                fg_values(mv,indexk) =   aij*values(mv,i,j) &
                                       + aipj*values(mv,i+1,j) &
                                       + aijp*values(mv,i,j+1) &
                                       + aipjp*values(mv,i+1,j+1)
              endif
            enddo

        ! Set the fg%aux(level,:,:) if this hasn't yet been set.
        if ((maux > 0) .and. (.not. fg%auxdone(level))) then
            ! at least some points do not yet have fg%aux set on this level

            do ma=1,FG_NUM_AUX
                if ((fg%aux(level,ma,k) == FG_NOTSET)) then
                
                    if (fg%interp_method == 0) then
                        ! pw constant:
                        fg%aux(level,ma,k) = aux(ma,i,j)
                      else
                        ! bilinear:
                        fg%aux(level,ma,k) =   aij*aux(ma,i,j) &
                                             + aipj*aux(ma,i+1,j) &
                                             + aijp*aux(ma,i,j+1) &
                                             + aipjp*aux(ma,i+1,j+1)
                      endif
                    endif
                enddo
            endif

        enddo ! loop on indexk

    ! note computing minval checks all fg%npts points, better way?
    if (minval(fg%aux(level,1,:)) > FG_NOTSET) then
        ! Done with aux arrays at all fgrid points on this level
        !print *, '+++ level,fg%aux:',level,fg%aux(level,1,1)
        fg%auxdone(level) = .true.
        endif
        
    !deallocate(ik,jk,mask_patch)

end subroutine fgmax_interpolate

c
c
c =========================================================
      subroutine out1(maxmx,meqn,mbc,mx,xlower,dx,q,t,iframe,aux,maux)
c =========================================================
c
c     # Output the results for a general system of conservation laws
c     # in 1 dimension
c
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw1.m
c     # The same format is used by the amrclaw package.
c     # Here it's adapted to output just the single grid.
c
c     # set outaux = .true. to also output the aux arrays to fort.a<iframe>
c
c
      use parameters_module

      implicit double precision (a-h,o-z)
      dimension q(1-mbc:maxmx+mbc, meqn)
      dimension aux(1-mbc:maxmx+mbc, maux)
      character*10 fname1, fname2, fname3
      logical outaux

      double precision :: h_1,h_2

      outaux = .false.
c
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw1.m
c     # The same format is used by the amrclaw package.  
c     # Here it's adapted to output just the single grid.
c
c     # first create the file name and open file
c
         fname1 = 'fort.qxxxx'
         fname2 = 'fort.txxxx'
         fname3 = 'fort.axxxx'
         nstp = iframe
         do 55 ipos = 10, 7, -1
            idigit = mod(nstp,10)
            fname1(ipos:ipos) = char(ichar('0') + idigit)
            fname2(ipos:ipos) = char(ichar('0') + idigit)
            fname3(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp / 10
 55      continue

         open(unit=50,file=fname1,status='unknown',form='formatted')
         open(unit=60,file=fname2,status='unknown',form='formatted')

c
c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr = 1
      level = 1

      write(50,1001) mptr,level,mx
 1001 format(i5,'                 grid_number',/,
     &       i5,'                 AMR_level',/,
     &       i5,'                 mx')

      write(50,1002) xlower,dx
 1002 format(e18.8,'    xlow', /,
     &       e18.8,'    dx', /)
c
        do 10 i=1,mx
            do j=1,maux
                if (abs(aux(i,j)) < 1d-99) aux(i,j) = 0.d0
            enddo
C           Since we do this on the calculated output, we should not do it here            
C           do m=1,meqn
C c            # exponents with more than 2 digits cause problems reading
C c            # into matlab... reset tiny values to zero:
C              if (dabs(q(i,m)) .lt. 1d-99) q(i,m) = 0.d0
C              enddo
c
          h_1 = q(i,1) / rho(1)
          hu_1 = q(i,2) / rho(1)
          h_2 = q(i,3) / rho(2)
          hu_2 = q(i,4) / rho(2)
          if (abs(h_1) < 1d-99) h_1 = 0.d0
          if (abs(hu_1) < 1d-99) hu_1 = 0.d0
          if (abs(h_2) < 1d-99) h_2 = 0.d0
          if (abs(hu_2) < 1d-99) hu_2 = 0.d0
          write(50,1005) h_1,hu_1,h_2,hu_2,aux(i,2),aux(i,5)
 1005     format(4e16.8)
c
 10       continue
        write(50,*) ' '
 20     continue
      write(50,*) ' '


      if (outaux) then 
c        # also output the aux arrays:
         open(unit=70,file=fname3,status='unknown',form='formatted')
         write(70,1001) mptr,level,mx
         write(70,1002) xlower,dx
         do 110 i=1,mx
            do m=1,maux
c              # exponents with more than 2 digits cause problems reading
c              # into matlab... reset tiny values to zero:
               if (dabs(aux(i,m)) .lt. 1d-99) aux(i,m) = 0.d0
            enddo
c
            write(70,1005) (aux(i,m), m=1,maux)
c
  110       continue
         write(70,*) ' '
         close(unit=70)
         endif

      write(60,1000) t,meqn+2,ngrids,maux,1

 1000 format(e26.16,'    time', /,
     &       i5,'                 meqn'/,
     &       i5,'                 ngrids'/,
     &       i5,'                 maux'/,
     &       i5,'                 ndim'/,/)
c

      close(unit=50)
      close(unit=60)

      return
      end

! Module containing refinement flagging criteria
module refinement_module

    use geoclaw_module, only: GEO_PARM_UNIT

    implicit none
    save

    logical, private :: module_setup = .false.

    ! ========================================================================
    !  Refinement Criteria
    ! ========================================================================
    real(kind=8) :: wave_tolerance
    real(kind=8), allocatable :: speed_tolerance(:)
    logical :: varRefTime = .FALSE. ! Choose dt refinement automatically
    
    ! ========================================================================
    !  Flowgrades - Not updated yet, use at your own risk
    ! ========================================================================
    integer :: num_flowgrades
    real(kind=8), allocatable :: flowgradevalue(:)
    integer, allocatable :: iflowgradevariable(:), iflowgradetype(:)
    integer, allocatable :: iflowgrademinlevel(:)

contains
    
    ! =========================================================================
    !  Reads in the refinement control parameters
    ! =========================================================================
    subroutine set_refinement(file_name)
        
        use amr_module, only: mxnest
        use utility_module, only: get_value_count
        
        implicit none
        
        ! Arguments
        character(len=*), optional, intent(in) :: file_name
        
        ! Locals
        integer, parameter :: unit = 127
        integer :: i
        character(len=128) :: line

        if (.not.module_setup) then

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'Refinement Control Parameters:'
            write(GEO_PARM_UNIT,*) '------------------------------'

            if (present(file_name)) then
                call opendatafile(unit, file_name)
            else
                call opendatafile(unit, 'refinement.data')
            endif

            ! Basic criteria
            read(unit,*) wave_tolerance
            read(unit,'(a)') line
            allocate(speed_tolerance(get_value_count(line)))
            read(line,*) speed_tolerance
            read(unit,*)
            read(unit,*) varRefTime
            close(unit)
            
            ! Write out data to parameter file
            write(GEO_PARM_UNIT,*) '   wave_tolerance:',wave_tolerance
            write(GEO_PARM_UNIT,*) '   speed_tolerance:',speed_tolerance
            write(GEO_PARM_UNIT,*) '   Variable dt Refinement Ratios:',varRefTime
            write(GEO_PARM_UNIT,*) ''
            
            module_setup = .true.
        end if

    end subroutine set_refinement
    
    
    ! =========================================================================
    ! TODO: This needs to be updated for the new module
    ! =========================================================================
    subroutine set_flow_grades(file_name)

        implicit none

        ! Input arguments
        character(len=*), optional, intent(in) :: file_name

        ! Locals
        integer, parameter :: iunit = 127
        integer :: i

        write(GEO_PARM_UNIT,*) ' '
        write(GEO_PARM_UNIT,*) '--------------------------------------------'
        write(GEO_PARM_UNIT,*) 'SET FLOW GRADES:'
        write(GEO_PARM_UNIT,*) '------------'

        ! Read user parameters from setflowgrades.data
        if (present(file_name)) then
            call opendatafile(iunit, file_name)
        else
            call opendatafile(iunit, 'setflowgrades.data')
        endif
        
        read(iunit,*) num_flowgrades

        if (num_flowgrades == 0) then
            write(GEO_PARM_UNIT,*) '  No flow grades specified'
            return
        endif

        ! Allocate arrays
        allocate(flowgradevalue(num_flowgrades),iflowgradevariable(num_flowgrades))
        allocate(iflowgradetype(num_flowgrades),iflowgrademinlevel(num_flowgrades))

        do i=1,num_flowgrades
            read(iunit,*) flowgradevalue(i),iflowgradevariable(i), &
                iflowgradetype(i),iflowgrademinlevel(i)
        enddo

        close(iunit)

        write(GEO_PARM_UNIT,*) '   mflowgrades:',  num_flowgrades

        do i=1,num_flowgrades
            write(GEO_PARM_UNIT,"(d12.3,3i4)") flowgradevalue(i), &
                iflowgradevariable(i),iflowgradetype(i),iflowgrademinlevel(i)

        enddo

    end subroutine set_flow_grades
    
end module refinement_module

subroutine buildSparseMatrixMScoo(rhs,nvar,naux,levelBouss,numBoussCells)

    
    use amr_module
    use geoclaw_module, only: earth_radius, deg2rad, coordinate_system, grav
    use geoclaw_module, only: sea_level
    use bouss_module
        
    implicit none
    
    integer, intent(in) :: nvar, naux, levelBouss, numBoussCells
    
    !! pass in numBoussCells for this level so can dimension this array
    real(kind=8) :: rhs(0:2*numBoussCells) 
    
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: i,j,nng,nb,nelt,levSt,nx,ny,mitot,mjtot,loc,locaux,mptr
    
    real(kind=8), allocatable, dimension(:,:) :: s1, s2, h0etax, h0etay
    real(kind=8), allocatable, dimension(:) :: uv,Auv,rowsum
    
    integer :: nD
    integer :: k, k_ij, k_imj, k_ipj, k_ijm, k_ijp 
    integer :: k_imjp, k_imjm, k_ipjm, k_ipjp
    integer :: kh_ij, kh_imj, kh_ipj, kh_ijm, kh_ijp
    integer :: kh_imjp, kh_imjm, kh_ipjm, kh_ipjp, khu_ij, khv_ij
    integer(kind=8) :: clock_start, clock_finish, clock_rate
    real(kind=8) cpu_start,cpu_finish, time 

    real(kind=8) :: h_ij, h_imj, h_ipj, h_ijm, h_ijp, h2_ij, h3_ij
    real(kind=8) :: h_imjm, h_imjp, h_ipjm, h_ipjp
    real(kind=8) :: hu_ij, hu_imj, hu_ipj, hu_ijm, hu_ijp
    real(kind=8) :: hu_imjm, hu_ipjm, hu_imjp, hu_ipjp
    real(kind=8) :: hv_imjm, hv_ipjm, hv_imjp, hv_ipjp
    real(kind=8) :: b_ij, b_imj, b_ipj, b_ijm, b_ijp
    real(kind=8) :: b_imjm, b_imjp, b_ipjm, b_ipjp
    real(kind=8) :: h0_ij, h0_imj, h0_ipj, h0_ijm, h0_ijp
    real(kind=8) :: h0_imjm, h0_imjp, h0_ipjm, h0_ipjp

    real(kind=8) :: hv_ij, hv_imj, hv_ipj, hv_ijm, hv_ijp
    real(kind=8) :: eta_ij, eta_imj, eta_ipj, eta_ijm, eta_ijp
    real(kind=8) :: dx, dy, dxm, dym, dxdx, dydy, dxdy4
    
    integer :: nelt_ij, nelt_ij_nD, nelt_imj, nelt_ipj, nelt_ijm_nD, nelt_ijp_nD
    real(kind=8) :: sa, huc, hvc, matrix_rhs1_max, matrix_rhs2_max
    integer :: ja, bc, c
    real(kind=8) :: b_min, b_max

    external :: MATVEC
    logical :: debug, noxycorner, noxy
    logical :: yhi_db, ylo_db, xlo_db, xhi_db

    
    ! bc_xlo, bc_ylo, bc_xhi, bc_yhi are set in bouss_module.
    !     0 means Dirchlet value 0 (no correction at each of union of patches)
    !     1 means Neumann (correction in first interior cell = in ghost cell)
    !     2 means use ghost cell values in q(4:5,:,:) as Dirichlet BCs
    !             Multiply by matrix element and move to RHS
    !             Requires nvar==5.

#ifdef WHERE_AM_I
  write(*,*) "starting buildSparseMatrixMScoo"
#endif
    
    call system_clock(clock_start,clock_rate)
    call cpu_time(cpu_start)

    debug = .false.
    !debug = .true.
    
    noxy = .false.  ! omit all cross derivative terms (test stability)
    noxycorner = .false.  ! omit cross derivative terms only at patch corners
    
    minfo => matrix_info_allLevs(levelBouss)

!
! ================== Step 2  set up for matrix elements  ======================

    ! Set up matrix A and RHS by looping over all Bouss patches:
    
    dx = hxposs(levelBouss)
    dy = hyposs(levelBouss)
    
     
    if (coordinate_system .eq. 2) then
      ! convert from dy in degrees to meters:
      dym = dy * earth_radius * deg2rad
      ! dxm depends on latitude, done in loops below instead of here
    else
      dym = dy
    endif
    
    dydy = dym**2
    

    nD = numBoussCells   ! shorthand for size of matrix blocks D1 to D4
    
    !allocate(uv(2*nD), Auv(2*nD)) ! for testing matvec
    
    ! For Boussinesq, matrix is 2*nD by 2*nD,
    !     A = [I - D1   -D2  ]
    !         [ -D3    I - D4]
    ! and the solution vector consists of 
    !     updates to hu in all Bouss cells, followed by
    !     updates to hv in all Bouss cells
    
    ! Set up matrix A in sparse triad form: 
    !    matrix_sa(k) is the nonzero element if A in 
    !    row matrix_ia(k), and column matrix_ja(a)
    
    nelt = 0  ! count number of matrix elements as added, 
              ! should be less than 9*(2*nD)**2

    rhs(:) = 0.d0
    
    matrix_rhs1_max = 0.d0
    matrix_rhs2_max = 0.d0
    
    ! loop over Bouss patches, must be done sequentially:
    
    levSt  = listStart(levelBouss)
    
    nng_loop: do  nng = 1, numgrids(levelBouss)
        mptr   = listOfGrids(levSt+nng-1)
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost
        loc = node(store1,mptr)  ! needed for iadd
        locaux = node(storeaux,mptr)  ! needed for iaddaux
        
        ! set booleans indicating whether each patch edge is a Domain Boundary:
        !call setDomainBndries(mptr,yhi_db,ylo_db,xlo_db,xhi_db)
        xlo_db = (node(ndilo,mptr) .eq. 0)
        xhi_db = (node(ndihi,mptr) .eq. (iregsz(levelBouss)-1))
        ylo_db = (node(ndjlo,mptr) .eq. 0)
        yhi_db = (node(ndjhi,mptr) .eq. (jregsz(levelBouss)-1))
    
        nb = node(bpatchNum, mptr)
        
        ! Get integer array providing matrix indices mapping 
        ! cell coordinates i,j to location k in vector of all unknowns: 
           
        mi => minfo%matrix_indices(nb)  ! integer array for this patch

        ! allocate temp arrays needed for this patch:
        ! provide one layer of ghost cells needed when computing
        ! second differences of these quantities, but values in ghost
        ! cells are never actually needed since second diff's won't be
        ! needed in first row of interior cells
        
         allocate(s1(0:nx+1,0:ny+1), s2(0:nx+1,0:ny+1), &
                  h0etax(0:nx+1,0:ny+1), h0etay(0:nx+1,0:ny+1))


        s1(0:nx+1,0:ny+1) = 0
        s2(0:nx+1,0:ny+1) = 0
                                  
        ! First loop over all cells (i,j), one row of ghost cells,
        ! computing s1, s2, h0etax, h0etay,
        ! quantities that involve first derivatives.  In the second loop
        ! over all cells below we will compute matrix_rhs using second
        ! differences of these quantities.
        
        if (debug) then
            !write(*,*) "in buildsparsematrix: calling uvsym for grid ",mptr
            !call uvsymcheck5(alloc(loc),0,mitot,mjtot,nvar)
            do j=-1,ny+2
                do i=-1,nx+2
                    kh_ij = iadd(1,i,j)
                    write(*,900) i,j,alloc(kh_ij),          &
                           alloc(kh_ij+1),alloc(kh_ij+2),   &
                           alloc(kh_ij+3),alloc(kh_ij+4)
 900   format('+++ i,j,h,hu,hv,huc,hvc: ',2i4,5e20.12)
                    enddo
                enddo
        endif
            
         do j=0,ny+1 
            if (coordinate_system .eq. 2) then
              ! aux(3,i,j) is latitude, doesn't depend on i so use i=1
              dxm = dx * earth_radius * deg2rad *              &
                    cos(alloc(iaddaux(3,1,j)))
            else
              dxm = dx
            endif
            
            do i=0,nx+1
                ! alloc indices for h component q(1,i,j) and neighbors:
                kh_ij = iadd(1,i,j)
                kh_imj = iadd(1,i-1,j)
                kh_ipj = iadd(1,i+1,j)
                kh_ijm = iadd(1,i,j-1)
                kh_ijp = iadd(1,i,j+1)
                
                ! use the fact that h,hu,hv are contiguous in alloc, and
                ! also compute eta = h + topo where topo is in aux(1,i,j)

                h_ij = alloc(kh_ij)
                hu_ij = alloc(kh_ij+1)
                hv_ij = alloc(kh_ij+2)
                b_ij = alloc(iaddaux(1,i,j))
                if (b_ij < sea_level) then
                    eta_ij = h_ij + b_ij
                    h0_ij = sea_level - b_ij
                else
                    eta_ij = 0.d0
                    h0_ij = 0.d0
                endif
                
                h_ipj = alloc(kh_ipj)
                hu_ipj = alloc(kh_ipj+1)
                hv_ipj = alloc(kh_ipj+2)
                b_ipj = alloc(iaddaux(1,i+1,j))
                if (b_ipj < sea_level) then
                    eta_ipj = h_ipj + b_ipj
                    h0_ipj = sea_level - b_ipj
                else
                    eta_ipj = 0.d0
                    h0_ipj = 0.d0
                endif

                h_imj = alloc(kh_imj)
                hu_imj = alloc(kh_imj+1)
                hv_imj = alloc(kh_imj+2)
                b_imj = alloc(iaddaux(1,i-1,j))
                if (b_imj < sea_level) then
                    eta_imj = h_imj + b_imj
                    h0_imj = sea_level - b_imj
                else
                    eta_imj = 0.d0
                    h0_imj = 0.d0
                endif

                h_ijp = alloc(kh_ijp)
                hu_ijp = alloc(kh_ijp+1)
                hv_ijp = alloc(kh_ijp+2)
                b_ijp = alloc(iaddaux(1,i,j+1))
                if (b_ijp < sea_level) then
                    eta_ijp = h_ijp + b_ijp
                    h0_ijp = sea_level - b_ijp
                else
                    eta_ijp = 0.d0
                    h0_ijp = 0.d0
                endif
                
                h_ijm = alloc(kh_ijm)
                hu_ijm = alloc(kh_ijm+1)
                hv_ijm = alloc(kh_ijm+2)
                b_ijm = alloc(iaddaux(1,i,j-1))
                if (b_ijm < sea_level) then
                    eta_ijm = h_ijm + b_ijm
                    h0_ijm = sea_level - b_ijm
                else
                    eta_ijm = 0.d0
                    h0_ijm = 0.d0
                endif

               ! only modify s1,s2 from initialized values of 0 if cell i,j
               ! and all four neighbors are wet:
                                                            
                if (.not.(h_ij  .eq. 0. .or.                                  &
                          h_ipj .eq. 0. .or. h_ijm .eq. 0.d0 .or.             &
                          h_ijp .eq. 0. .or. h_imj .eq. 0.d0))     then
                
                   s1(i,j) = (hu_ipj**2/h_ipj - hu_imj**2/h_imj        &
                         + grav*h_ij*(eta_ipj - eta_imj)) / (2.d0*dxm) &
                         + (hu_ijp*hv_ijp/h_ijp - hu_ijm*hv_ijm/h_ijm) &
                           / (2.d0*dym)
                           
                   ! Debug: remove nonlinear terms:
                   !s1(i,j) = grav*h_ij*(eta_ipj - eta_imj) / (2.d0*dxm)
                   !s1(i,j) = (hu_ipj**2/h_ipj - hu_imj**2/h_imj) / (2.d0*dxm)
                           
                   s2(i,j) = (hv_ijp**2/h_ijp - hv_ijm**2/h_ijm        &
                         + grav*h_ij*(eta_ijp - eta_ijm)) / (2.d0*dym) &
                         + (hu_ipj*hv_ipj/h_ipj - hu_imj*hv_imj/h_imj) &
                           / (2.d0*dxm)
                           
                   ! Debug: remove nonlinear terms:
                   !s2(i,j) = 0.d0 !grav*h_ij*(eta_ijp - eta_ijm) / (2.d0*dym)
                   
                   !write(67,*) '+++ i,j,s1,s2: ',i,j,s1(i,j),s2(i,j)
                           
                endif
                           
                h0etax(i,j) = h0_ij * (eta_ipj - eta_imj) / (2.d0*dxm)
                h0etay(i,j) = h0_ij * (eta_ijp - eta_ijm) / (2.d0*dym)
                !write(67,*) '+++ i,j,h0etax,h0etay: ',i,j,h0etax(i,j),h0etay(i,j)
                
                if (debug) then
                    write(67,*) '  h_ij, eta_ij: ',  h_ij,eta_ij
                    write(67,*) '  h0etax:       ',  h0etax(i,j)
                endif
                
            enddo
        enddo

! ================== build matrix and rhs
        ! Second loop over all cells.  ONLY INTERIOR OK NOW
        
        do j=1,ny 
            if (coordinate_system .eq. 2) then
              ! aux(3,i,j) is latitude, doesn't depend on i so use i=1
              dxm = dx * earth_radius * deg2rad *              &
                    cos(alloc(iaddaux(3,1,j)))
            else
              dxm = dx
            endif
            
            dxdx = dxm**2
            dxdy4 = 4.d0*dxm*dym
            
            do i=1,nx

                ! sparse matrix row indices for cell (i,j) are:
                !    k_ij for the row of I-D11 and -D12 in block matrix,
                !    k_ij + nD for the row of -D21 and I-D22
                k_ij = mi%mindex(i,j)
                
                ! in this inner loop we set all nonzero matrix elements
                ! in these two rows of the matrix (and rhs) corresponding
                ! to momenumtum updates to hu and hv in the (i,j) cell
                
                ! sparse matrix column indices for neighboring cells
                ! are the values k computed next (for I-D1 and -D3)
                ! and the corresponding k + nD for the corresponding column
                ! of the -D2 and I-D4.  These indices are needed to
                ! set matrix elements in these columns, corresponding to
                ! momentum components hu and hv in the neighboring cells
                
                k_imj = mi%mindex(i-1,j)
                k_ipj = mi%mindex(i+1,j)
                k_ijm = mi%mindex(i,j-1)
                k_ijp = mi%mindex(i,j+1)
                k_imjm = mi%mindex(i-1,j-1)
                k_imjp = mi%mindex(i-1,j+1)
                k_ipjm = mi%mindex(i+1,j-1)
                k_ipjp = mi%mindex(i+1,j+1)
                
                ! alloc indices for h component q(1,i,j) and neighbors:
                kh_ij = iadd(1,i,j)
                kh_imj = iadd(1,i-1,j)
                kh_ipj = iadd(1,i+1,j)
                kh_ijm = iadd(1,i,j-1)
                kh_ijp = iadd(1,i,j+1)
                kh_imjm = iadd(1,i-1,j-1)
                kh_imjp = iadd(1,i-1,j+1)
                kh_ipjm = iadd(1,i+1,j-1)
                kh_ipjp = iadd(1,i+1,j+1)
                
                ! use the fact that h,hu,hv are contiguous in alloc:
                h_ij = alloc(kh_ij)
                hu_ij = alloc(kh_ij+1)
                hv_ij = alloc(kh_ij+2)
                b_ij = alloc(iaddaux(1,i,j))
                h0_ij = sea_level - b_ij
                
                h_ipj = alloc(kh_ipj)
                hu_ipj = alloc(kh_ipj+1)
                hv_ipj = alloc(kh_ipj+2)
                b_ipj = alloc(iaddaux(1,i+1,j))
                h0_ipj = sea_level - b_ipj

                h_imj = alloc(kh_imj)
                hu_imj = alloc(kh_imj+1)
                hv_imj = alloc(kh_imj+2)
                b_imj = alloc(iaddaux(1,i-1,j))
                h0_imj = sea_level - b_imj

                h_ijp = alloc(kh_ijp)
                hu_ijp = alloc(kh_ijp+1)
                hv_ijp = alloc(kh_ijp+2)
                b_ijp = alloc(iaddaux(1,i,j+1))
                h0_ijp = sea_level - b_ijp
                
                h_ijm = alloc(kh_ijm)
                hu_ijm = alloc(kh_ijm+1)
                hv_ijm = alloc(kh_ijm+2)
                b_ijm = alloc(iaddaux(1,i,j-1))
                h0_ijm = sea_level - b_ijm

                h_ipjp = alloc(kh_ipjp)
                hu_ipjp = alloc(kh_ipjp+1)
                hv_ipjp = alloc(kh_ipjp+2)
                b_ipjp = alloc(iaddaux(1,i+1,j+1))
                h0_ipjp = sea_level - b_ipjp
                
                h_ipjm = alloc(kh_ipjm)
                hu_ipjm = alloc(kh_ipjm+1)
                hv_ipjm = alloc(kh_ipjm+2)
                b_ipjm = alloc(iaddaux(1,i+1,j-1))
                h0_ipjm = sea_level - b_ipjm
                
                h_imjp = alloc(kh_imjp)
                hu_imjp = alloc(kh_imjp+1)
                hv_imjp = alloc(kh_imjp+2)
                b_imjp = alloc(iaddaux(1,i-1,j+1))
                h0_imjp = sea_level - b_imjp
                
                h_imjm = alloc(kh_imjm)
                hu_imjm = alloc(kh_imjm+1)
                hv_imjm = alloc(kh_imjm+2)
                b_imjm = alloc(iaddaux(1,i-1,j-1))
                h0_imjm = sea_level - b_imjm

                ! quantities repeatedly used:
                h2_ij = h0_ij**2 * (Bparam + 0.5d0)
                h3_ij = h0_ij**3 / 6.d0
                
                
                if (k_ij == -1) then
                    write(6,*) '+++ unexpected k_ij=-1 at i,j: ',i,j
                endif
                
                b_min = min(b_ij,b_imj,b_ipj,b_ijm,b_ijp,              &
                        b_imjm, b_imjp, b_ipjm, b_ipjp)
                b_max = max(b_ij,b_imj,b_ipj,b_ijm,b_ijp,              &
                        b_imjm, b_imjp, b_ipjm, b_ipjp)                        
                if ((-b_min < boussMinDepth) .or. (b_max >= 0.d0)) then
                        
                    ! The deepest water in block of 9 cells is shallower 
                    ! than boussMinDepth, or else one of the cells is onshore.

                    ! Revert to SWE in this cell, i.e. two rows
                    ! of matrix should be rows of identity with rhs = 0,
                    ! so correction terms huc,hvc calculated will be 0.
                    
                    ! Replace diagonal block I-D11 by I matrix:
                    nelt = nelt + 1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = k_ij
                    minfo%matrix_sa(nelt) = 1.d0
                    !rhs(k_ij) = 0.d0  ! Not needed due to initialization
                    
                    ! Replace diagonal block I-D22 by I matrix:
                    nelt = nelt + 1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = k_ij + nD
                    minfo%matrix_sa(nelt) = 1.d0
                    !rhs(k_ij + nD) = 0.d0  ! Not needed due to initialization
                    
                    ! -D12 and -D21 are the 0 matrix in this case (no nozeros)
                    
                    cycle ! go on to next i
                endif

                
                ! If we get here, we are dealing with interior point
                ! Add rows k_ij and (k_ij + nD) to matrix:
                ! Row k_ij    corresponds to correction to hu in cell (i,j)
                ! Row k_ij+nD corresponds to correction to hv in cell (i,j)
                ! The nonzero matrix elements will be in the same columns
                ! and also in columns 
                !     k_ipj, k_ipj+nD for the coeff of the (i+1,j) stencil pt
                !     k_imjp, k_imjp+nD for the coeff of (i-1,j+1) point,
                !     etc.
                ! Note that if e.g. k_ipj = -1 then cell (i+1,j) is not in the
                ! union of patches at this level and so there is no 
                ! corresponding column.  
                ! In this case:
                ! For Dirichlet BC with value 0, the stencil value is discarded,
                ! For Neumann BC, the stencil coefficient is instead applied
                ! to the neighboring cell that is in the patch, 
                ! assuming constant extrapolation at each edge.
                
                ! Increment nelt each time we add another nonzero matrix
                ! element.  
                ! Store index nelt_ij for index to diagonal element in row k_ij
                ! Store index nelt_ij_nD for diagonal element in row k_ij+nD

                ! initialize to -1 for debugging in case not set properly:
                nelt_ij = -1
                nelt_imj = -1
                nelt_ipj = -1
                nelt_ij_nD = -1
                nelt_ijm_nD = -1
                nelt_ijp_nD = -1
                
  601           format('U(',i2,',',i2,') --> U(',i2,',',i2,') c=',i1,' nelt=',i8,' sa = ',e25.15)
  602           format('U(',i2,',',i2,') --> V(',i2,',',i2,') c=',i1,' nelt=',i8,' sa = ',e25.15)
  603           format('V(',i2,',',i2,') --> U(',i2,',',i2,') c=',i1,' nelt=',i8,' sa = ',e25.15)
  604           format('V(',i2,',',i2,') --> V(',i2,',',i2,') c=',i1,' nelt=',i8,' sa = ',e25.15)
    
                !-----------------------------------------------
                ! I-D11 block (xx derivatives of hu components):
                
                ! Matrix element row U(i,j) column U(i,j):
                sa = 1.d0 + 2.d0*(h2_ij - h3_ij/h0_ij) / dxdx
                nelt = nelt+1
                minfo%matrix_ia(nelt) = k_ij
                minfo%matrix_ja(nelt) = k_ij
                minfo%matrix_sa(nelt) = sa
                if (debug) write(67,601) i,j,i,j,1,nelt,minfo%matrix_sa(nelt)
                
                nelt_ij = nelt  ! index of diagonal matrix element
                    
                ! Matrix element row U(i,j) column U(i+1,j):
                sa = -(h2_ij - h3_ij/h0_ipj) / dxdx
                if (k_ipj > -1) then
                    ! adjacent cell is interior pt, set matrix element to sa:
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = k_ipj
                    minfo%matrix_sa(nelt) = sa
                    nelt_ipj = nelt
                    if (debug) write(67,601) i,j,i+1,j,1,nelt,sa
                else
                    ! right boundary of patch
                    if (bc_xhi==0) then
                        ! for 0 Dirchlet BC don't any element
                    else if (bc_xhi==1 .and. xhi_db) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij) = minfo%matrix_sa(nelt_ij) + sa
                        if (debug) write(67,601) i,j,i+1,j,2,nelt_ij,sa
                    else if (bc_xhi==3 .and. xhi_db) then
                        ! For wall, negate u: add -sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij) = minfo%matrix_sa(nelt_ij) - sa
                        if (debug) write(67,601) i,j,i+1,j,2,nelt_ij,-sa
                    else if (bc_xhi==2 .or. .not. xhi_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        huc = alloc(iadd(4,i+1,j))
                        rhs(k_ij) = rhs(k_ij) - sa*huc
                        if (debug) write(67,601) i,j,i+1,j,5,-1,sa*huc
                    endif
                    
                    
                endif
                
                ! Matrix element row U(i,j) column U(i-1,j):
                sa = -(h2_ij - h3_ij/h0_imj) / dxdx
                if (k_imj > -1) then
                    ! adjacent cell is interior pt, set matrix element to sa:
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = k_imj
                    minfo%matrix_sa(nelt) = sa
                    nelt_imj = nelt
                    if (debug) write(67,601) i,j,i-1,j,1,nelt,sa
                else
                    ! left boundary of patch
                    if (bc_xlo==0) then
                        ! for 0 Dirchlet BC don't add any element
                    else if (bc_xlo==1 .and. xlo_db) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij) = minfo%matrix_sa(nelt_ij) + sa
                        if (debug) write(67,601) i,j,i-1,j,2,nelt_ij,sa
                    else if (bc_xlo==3 .and. xlo_db) then
                        ! For wall, negate u: add -sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij) = minfo%matrix_sa(nelt_ij) - sa
                        if (debug) write(67,601) i,j,i-1,j,2,nelt_ij,-sa
                    else if (bc_xlo==2 .or. .not. xlo_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        huc = alloc(iadd(4,i-1,j))
                        rhs(k_ij) = rhs(k_ij) - sa*huc
                        if (debug) write(67,601) i,j,i-1,j,5,-1,sa*huc
                    endif
                endif

                !-----------------------------------------------
                ! I-D22 block (yy derivatives of hv components):
                
                ! Matrix element row V(i,j) column V(i,j):
                sa = 1.d0 + 2.d0*(h2_ij - h3_ij/h0_ij) / dydy
                nelt = nelt+1
                minfo%matrix_ia(nelt) = k_ij + nD
                minfo%matrix_ja(nelt) = k_ij + nD
                minfo%matrix_sa(nelt) = sa
                if (debug) write(67,604) i,j,i,j,1,nelt,minfo%matrix_sa(nelt)
                
                nelt_ij_nD = nelt  ! index of diagonal matrix element
                    
                ! Matrix element row V(i,j) column V(i,j+1):
                sa = -(h2_ij - h3_ij/h0_ijp) / dydy
                if (k_ijp > -1) then
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = k_ijp + nD
                    minfo%matrix_sa(nelt) = sa
                    nelt_ijp_nD = nelt
                    if (debug) write(67,604) i,j,i,j+1,1,nelt,sa
                else
                    ! top boundary of patch
                    if (bc_yhi==0) then
                        ! for 0 Dirchlet BC don't add any element
                    else if (bc_yhi==1 .and. yhi_db) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij_nD) = &
                                minfo%matrix_sa(nelt_ij_nD) + sa
                        if (debug) write(67,604) i,j,i,j+1,2,nelt_ij_nD,sa
                    else if (bc_yhi==3 .and. yhi_db) then
                        ! For wall BC add -sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij_nD) = &
                                minfo%matrix_sa(nelt_ij_nD) - sa
                        if (debug) write(67,604) i,j,i,j+1,2,nelt_ij_nD,-sa
                    else if (bc_yhi==2 .or. .not. yhi_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        hvc = alloc(iadd(5,i,j+1))
                        rhs(k_ij+nD) = rhs(k_ij+nD) - sa*hvc
                        if (debug) write(67,604) i,j,i,j+1,5,-1,sa*hvc
                    endif
                endif
                
                ! Matrix element row V(i,j) column V(i,j-1):
                sa = -(h2_ij - h3_ij/h0_ijm) / dydy
                if (k_ijm > -1) then
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = k_ijm + nD
                    minfo%matrix_sa(nelt) = sa
                    nelt_ijm_nD = nelt
                    if (debug) write(67,604) i,j,i,j-1,1,nelt,sa
                else
                    ! bottom boundary of patch
                    if (bc_ylo==0) then
                        ! for 0 Dirchlet BC don't add any element
                    else if (bc_ylo==1 .and. ylo_db) then
                        ! For Neumann BC add sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij_nD) = &
                                minfo%matrix_sa(nelt_ij_nD) + sa
                        if (debug) write(67,604) i,j,i,j-1,2,nelt_ij_nD,sa
                    else if (bc_ylo==3 .and. ylo_db) then
                        ! For wall BC add -sa to diagonal matrix element:
                        minfo%matrix_sa(nelt_ij_nD) = &
                                minfo%matrix_sa(nelt_ij_nD) - sa
                        if (debug) write(67,604) i,j,i,j-1,2,nelt_ij_nD,-sa
                    else if (bc_ylo==2 .or. .not. ylo_db) then
                        ! Dirichlet BC using Bouss correction from ghost cell
                        hvc = alloc(iadd(5,i,j-1))
                        rhs(k_ij+nD) = rhs(k_ij+nD) - sa*hvc
                        if (debug) write(67,604) i,j,i,j-1,5,-1,sa*hvc
                    endif   
                endif                                        

                if (noxy) go to 111  ! omit all cross derivatives
            
                !-----------------------------------------------
                ! -D12 block (cross derivatives):
                ! row ia = k_ij for hu corrections in cell (i,j)
                ! columns k_ipjp + nD and other neighbors for hv corrections                
                
                ! Matrix element row U(i,j) column V(i+1,j+1):
                sa = -(h2_ij - h3_ij/h0_ipjp) / dxdy4
                ja = -1
                c = 0
                if (k_ipjp > -1) then
                    ja = k_ipjp + nD
                    c = 1
                else if (noxycorner .and. (k_ijp == -1) .and. (k_ipj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijp == -1) .and. ((bc_yhi==2).or. .not. yhi_db)) .or. &
                         ((k_ipj == -1) .and. ((bc_xhi==2).or. .not. xhi_db))) then
                    hvc = alloc(iadd(5,i+1,j+1))
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                    if (debug) write(67,602) i,j,i+1,j+1,5,-1,sa*hvc
                else if (k_ijp > -1) then
                    ! at right boundary, use cell above instead
                    if (bc_xhi /= 2) ja = k_ijp + nD
                else if (k_ipj > -1) then
                    ! at top boundary, use cell to right instead,
                    ja = k_ipj + nD
                    if (bc_yhi==3) sa = -sa
                else
                    ! top-right corner
                    ja = k_ij + nD
                    if (bc_yhi==3) sa = -sa  ! v negated at wall
                endif

                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,602) i,j,i+1,j+1,c,nelt,sa
                endif
                
                    
                ! Matrix element row U(i,j) column V(i+1,j-1):
                sa = (h2_ij - h3_ij/h0_ipjm) / dxdy4
                ja = -1
                c = 0
                if (k_ipjm > -1) then
                    ja = k_ipjm + nD
                    c = 1
                else if (noxycorner .and. (k_ijm == -1) .and. (k_ipj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs                
                else if (((k_ijm == -1) .and. ((bc_ylo==2).or. .not. ylo_db)) .or. &
                         ((k_ipj == -1) .and. ((bc_xhi==2).or. .not. xhi_db))) then
                    hvc = alloc(iadd(5,i+1,j-1))
                    rhs(k_ij) = rhs(k_ij) - sa*hvc   
                    if (debug) write(67,602) i,j,i+1,j-1,5,-1,sa*hvc             
                else if (k_ijm > -1) then
                    ! at right boundary, use cell below instead
                    if (bc_xhi /= 2) ja = k_ijm + nD
                else if (k_ipj > -1) then
                    ! at bottom boundary, use cell to right instead,
                    ja = k_ipj + nD
                    if (bc_ylo==3) sa = -sa
                else
                    ! bottom-right corner
                    ja = k_ij + nD
                    if (bc_ylo==3) sa = -sa  ! v negated at wall
                endif   
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,602) i,j,i+1,j-1,c,nelt,sa
                endif
                
                ! Matrix element row U(i,j) column V(i-1,j+1):    
                sa = (h2_ij - h3_ij/h0_imjp) / dxdy4
                ja = -1
                c = 0
                if (k_imjp > -1) then
                    ja = k_imjp + nD
                    c = 1
                else if (noxycorner .and. (k_ijp == -1) .and. (k_imj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijp == -1) .and. ((bc_yhi==2).or. .not. yhi_db)) .or. &
                         ((k_imj == -1) .and. ((bc_xlo==2).or. .not. xlo_db))) then
                    hvc = alloc(iadd(5,i-1,j+1))
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                    if (debug) write(67,602) i,j,i-1,j+1,5,-1,sa*hvc
                else if (k_ijp > -1) then
                    ! at left boundary, use cell above instead
                    if (bc_xlo /= 2) ja = k_ijp + nD
                else if (k_imj > -1) then
                    ! at top boundary, use cell to left instead,
                    ja = k_imj + nD
                    if (bc_yhi==3) sa = -sa
                else
                    ! top-left corner
                    ja = k_ij + nD
                    if (bc_yhi==3) sa = -sa  ! v negated at wall
                endif
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,602) i,j,i-1,j+1,c,nelt,sa
                endif
                
                ! Matrix element row U(i,j) column V(i-1,j-1):
                sa = -(h2_ij - h3_ij/h0_imjm) / dxdy4
                ja = -1
                c = 0
                if (k_imjm > -1) then
                    ja = k_imjm + nD
                    c = 1
                else if (noxycorner .and. (k_ijm == -1) .and. (k_imj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijm == -1) .and. ((bc_ylo==2).or. .not. ylo_db)) .or. &
                         ((k_imj == -1) .and. ((bc_xlo==2).or. .not. xlo_db))) then
                    hvc = alloc(iadd(5,i-1,j-1))
                    rhs(k_ij) = rhs(k_ij) - sa*hvc
                    if (debug) write(67,602) i,j,i-1,j-1,5,-1,sa*hvc
                else if (k_ijm > -1) then
                    ! at left boundary, use cell below instead
                    if (bc_xlo /= 2) ja = k_ijm + nD
                else if (k_imj > -1) then
                    ! at bottom boundary, use cell to left instead,
                    ja = k_imj + nD
                    if (bc_ylo==3) sa = -sa
                else
                    ! bottom-left corner
                    ja = k_ij + nD
                    if (bc_ylo==3) sa = -sa  ! v negated at wall
                endif   
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,602) i,j,i-1,j-1,c,nelt,sa
                endif


                !-----------------------------------------------
                ! -D21 block (cross derivatives):
                ! row ia = k_ij + nD  for hv corrections in cell (i,j)
                ! columns k_ipjp and other neighbors for hu corrections
                
                ! Matrix element row V(i,j) column U(i+1,j+1):
                sa = -(h2_ij - h3_ij/h0_ipjp) / dxdy4
                ja = -1
                c = 0
                if (k_ipjp > -1) then
                    ja = k_ipjp
                    c = 1
                else if (noxycorner .and. (k_ijp == -1) .and. (k_ipj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijp == -1) .and. ((bc_yhi==2).or. .not. yhi_db)) .or. &
                         ((k_ipj == -1) .and. ((bc_xhi==2).or. .not. xhi_db))) then
                    huc = alloc(iadd(4,i+1,j+1))
                    rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                    if (debug) write(67,603) i,j,i+1,j+1,5,-1,sa*huc
                else if (k_ijp > -1) then
                    ! at right boundary, use cell above instead,
                    ja = k_ijp
                    if (bc_xhi==3) sa = -sa
                else if (k_ipj > -1) then
                    ! at top boundary, use cell to right instead,
                    if (bc_yhi /= 2) ja = k_ipj
                else
                    ! top-right corner
                    ja = k_ij ! FIXED BUG
                    if (bc_xhi==3) sa = -sa  ! u negated at wall
                endif
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,603) i,j,i+1,j+1,c,nelt,sa
                endif
                
                ! Matrix element row V(i,j) column U(i+1,j-1):
                sa = (h2_ij - h3_ij/h0_ipjm) / dxdy4
                ja = -1
                c = 0
                if (k_ipjm > -1) then
                    ja = k_ipjm
                    c = 1
                else if (noxycorner .and. (k_ijm == -1) .and. (k_ipj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijm == -1) .and. ((bc_ylo==2).or. .not. ylo_db)) .or. &
                         ((k_ipj == -1) .and. ((bc_xhi==2).or. .not. xhi_db))) then
                    huc = alloc(iadd(4,i+1,j-1))
                    rhs(k_ij+nD) = rhs(k_ij+nD) - sa*huc
                    if (debug) write(67,603) i,j,i+1,j-1,5,-1,sa*huc
                else if (k_ijm > -1) then
                    ! at right boundary, use cell below instead,
                    ja = k_ijm
                    if (bc_xhi==3) sa = -sa
                else if (k_ipj > -1) then
                    ! at bottom boundary, use cell to right instead,
                    if (bc_ylo /= 2) ja = k_ipj
                else
                    ! bottom-right corner
                    ja = k_ij ! FIXED BUG
                    if (bc_xhi==3) sa = -sa  ! u negated at wall
                endif
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,603) i,j,i+1,j-1,c,nelt,sa
                endif
                
                ! Matrix element row V(i,j) column U(i-1,j+1):
                sa = (h2_ij - h3_ij/h0_imjp) / dxdy4
                ja = -1
                c = 0
                if (k_imjp > -1) then
                    ja = k_imjp
                    c = 1
                else if (noxycorner .and. (k_ijp == -1) .and. (k_imj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijp == -1) .and. ((bc_yhi==2).or. .not. yhi_db)) .or. &
                         ((k_imj == -1) .and. ((bc_xlo==2).or. .not. xlo_db))) then
                    huc = alloc(iadd(4,i-1,j+1))
                    rhs(k_ij+nD) = rhs(k_ij+nD)  - sa*huc
                    if (debug) write(67,603) i,j,i-1,j+1,5,-1,sa*huc
                else if (k_ijp > -1) then
                    ! at left boundary, use cell above instead,
                    ja = k_ijp
                    if (bc_xlo==3) sa = -sa
                else if (k_imj > -1) then
                    ! at top boundary, use cell to left instead,
                    if (bc_yhi /= 2) ja = k_imj
                else
                    ! top-left corner
                    ja = k_ij ! FIXED BUG
                    if (bc_xlo==3) sa = -sa  ! u negated at wall
                endif
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,603) i,j,i-1,j+1,c,nelt,sa
                endif

                ! Matrix element row V(i,j) column U(i-1,j-1):
                sa = -(h2_ij - h3_ij/h0_imjm) / dxdy4
                ja = -1
                c = 0
                if (k_imjm > -1) then
                    ja = k_imjm
                    c = 1
                else if (noxycorner .and. (k_ijm == -1) .and. (k_imj == -1)) then
                    ! test omitting corner cross derivatives for stability?
                    ! in this case don't add sa to matrix or rhs
                else if (((k_ijm == -1) .and. ((bc_ylo==2).or. .not. ylo_db)) .or. &
                         ((k_imj == -1) .and. ((bc_xlo==2).or. .not. xlo_db))) then
                    huc = alloc(iadd(4,i-1,j-1))
                    rhs(k_ij+nD) = rhs(k_ij+nD)  - sa*huc
                    if (debug) write(67,603) i,j,i-1,j-1,5,-1,sa*huc
                else if (k_ijm > -1) then
                    ! at left boundary, use cell below instead,
                    ja = k_ijm
                    if (bc_xlo==3) sa = -sa
                else if (k_imj > -1) then
                    ! at bottom boundary, use cell to left instead,
                    ja = k_imj
                else
                    ! bottom-left corner
                    ja = k_ij ! FIXED BUG
                    if (bc_xlo==3) sa = -sa  ! u negated at wall
                endif
                if (ja > -1) then
                    ! add a new matrix element for interior, wall, Neumann case
                    nelt = nelt+1
                    minfo%matrix_ia(nelt) = k_ij + nD
                    minfo%matrix_ja(nelt) = ja
                    minfo%matrix_sa(nelt) = sa
                    if (debug) write(67,603) i,j,i-1,j-1,c,nelt,sa
                endif
                
 111            continue
 
                !-------------------------------------------------------
                ! Right hand sides for vector elements k_ij and k_ij+nD
                ! corresponding to b1 and b2 in notes, where
                !    b = -D*s + g*B1*h0**2 * \grad(\grad\cdot(h0*\grad\eta))
                ! with
                !    s = z + g*h*\grad\eta
                !    z = u\grad\cdot(h*u) + (h*u\cdot\grad)u
                !        are the nonlinear terms of SWE
                ! Recall that:
                !    h2_ij = h0_ij**2 * (Bparam + 0.5d0)
                !    h3_ij = h0_ij**3 / 6.d0
                !
                ! s1,s2 are components of   s = z + g*h*\grad\eta
                ! h0etax, h0etay approximate (h0 * eta)_x, (h0 * eta)_y
                !
                ! s1,s2,h0etax,h0etay were all computed in previous loop
                ! over i,j, so we can use neighboring values to now compute
                ! second differences of these.
                
                ! DEBUG:
                !if (abs(rhs(k_ij)) > 0.d0) then
                !    write(6,*) '+++ rhs huc nonzero: ',i,j,rhs(k_ij)
                !endif
                !
                !if (abs(rhs(k_ij+nD)) > 0.d0) then
                !    write(6,*) '+++ rhs hvc nonzero: ',i,j,rhs(k_ij+nD)
                !endif
                

                
              
              if (noxy) then
                ! leave out cross derivative terms
                ! b1, rhs for hu updates:
                rhs(k_ij) = rhs(k_ij) &
                  - h2_ij * (s1(i-1,j) - 2.d0*s1(i,j) + s1(i+1,j)) / dxdx &
                  + h3_ij * (s1(i-1,j)/h0_imj - 2.d0*s1(i,j)/h0_ij &
                          + s1(i+1,j)/h0_ipj) / dxdx &
                  + Bparam * grav * h0_ij**2 &
                      * (h0etax(i-1,j) - 2.d0*h0etax(i,j) + h0etax(i+1,j)) / dxdx 
                          
                ! b2, rhs for hv updates:      
                rhs(k_ij+nD) = rhs(k_ij+nD) &
                  - h2_ij * (s2(i,j-1) - 2.d0*s2(i,j) + s2(i,j+1)) / dydy &
                  + h3_ij * (s2(i,j-1)/h0_ijm - 2.d0*s2(i,j)/h0_ij &
                          + s2(i,j+1)/h0_ijp) / dydy &
                  + Bparam * grav * h0_ij**2 &
                      * (h0etay(i,j-1) - 2.d0*h0etay(i,j) + h0etay(i,j+1)) / dydy
                      
              else
                ! full thing with cross derivatives:             
                ! b1, rhs for hu updates:
                rhs(k_ij) = rhs(k_ij) &
                    -h2_ij * ((s1(i-1,j) - 2.d0*s1(i,j) + s1(i+1,j)) / dxdx &
                          + (s2(i+1,j+1) - s2(i-1,j+1) &
                           - s2(i+1,j-1) + s2(i-1,j-1)) / dxdy4) &
                  + h3_ij * ((s1(i-1,j)/h0_imj - 2.d0*s1(i,j)/h0_ij &
                          + s1(i+1,j)/h0_ipj) / dxdx &
                          + (s2(i+1,j+1)/h0_ipjp - s2(i-1,j+1)/h0_imjp &
                            -s2(i+1,j-1)/h0_ipjm + s2(i-1,j-1)/h0_imjm) / dxdy4) &
                  + Bparam * grav * h0_ij**2 &
                      * ((h0etax(i-1,j) - 2.d0*h0etax(i,j) + h0etax(i+1,j)) / dxdx &
                        + (h0etay(i+1,j+1) - h0etay(i-1,j+1) &
                          -h0etay(i+1,j-1) + h0etay(i-1,j-1)) / dxdy4)
                          
                            
                ! b2, rhs for hv updates:      
                rhs(k_ij+nD) = rhs(k_ij+nD) &
                    -h2_ij * ((s2(i,j-1) - 2.d0*s2(i,j) + s2(i,j+1)) / dydy &
                          + (s1(i+1,j+1) - s1(i-1,j+1) &
                           - s1(i+1,j-1) + s1(i-1,j-1)) / dxdy4) &
                  + h3_ij * ((s2(i,j-1)/h0_ijm - 2.d0*s2(i,j)/h0_ij &
                          + s2(i,j+1)/h0_ijp) / dydy &
                          + (s1(i+1,j+1)/h0_ipjp - s1(i-1,j+1)/h0_imjp &
                            -s1(i+1,j-1)/h0_ipjm + s1(i-1,j-1)/h0_imjm) / dxdy4) &
                  + Bparam * grav * h0_ij**2 &
                      * ((h0etay(i,j-1) - 2.d0*h0etay(i,j) + h0etay(i,j+1)) / dydy &
                        + (h0etax(i+1,j+1) - h0etax(i-1,j+1) &
                          -h0etax(i+1,j-1) + h0etax(i-1,j-1)) / dxdy4)
                
                endif  ! with cross derivatives

                matrix_rhs1_max = max(matrix_rhs1_max, abs(rhs(k_ij)))
                matrix_rhs2_max = max(matrix_rhs2_max, abs(rhs(k_ij+nD)))

              if (debug) then
                  write(67,*) '++b i,j,rhs = ',i,j,rhs(k_ij),rhs(k_ij + nD)
              endif 
                                
                  
                !if (j==3) then ! DEBUG
                if (.false.) then
                    write(67,*) '+++ i,j,rhs = ',i,j,rhs(k_ij),rhs(k_ij + nD)
                    write(67,*) h0_ij
                    write(67,*) h2_ij, ((s1(i-1,j) - 2.d0*s1(i,j) + s1(i+1,j)) / dxdx)
                    write(67,*) h3_ij, ((s1(i-1,j)/h0_imj - 2.d0*s1(i,j)/h0_ij &
                            + s1(i+1,j)/h0_ipj) / dxdx )
                    write(67,*) Bparam * grav * h0_ij**2 &
                        * ((h0etax(i-1,j) - 2.d0*h0etax(i,j) + h0etax(i+1,j)) / dxdx)
                    write(67,*) Bparam, grav, h0_ij**2, &
                      ((h0etax(i-1,j) - 2.d0*h0etax(i,j) + h0etax(i+1,j)) / dxdx)
                    write(67,*) ((h0etax(i-1,j) - 2.d0*h0etax(i,j) + h0etax(i+1,j)) / dxdx)
                    write(67,*) s1(i,j)
                    write(67,*) h0etax(i,j)
                    write(67,*) h_ij + b_ij
                endif

            enddo
        enddo
        
    deallocate(s1, s2, h0etax, h0etay)
    
    if (debug) then
        write(6,*) '+++ levelBouss = ',levelBouss,'  nng = ',nng
        write(6,*) '+++ matrix_rhs_max = ',matrix_rhs1_max, matrix_rhs2_max
    endif
    
    enddo  nng_loop

        
    minfo%matrix_nelt = nelt
    
    !============ Debug:
            
    if (.false.) then
        ! check row sums of matrix
        allocate(rowsum(2*nD))
        rowsum = 0.d0
        do k=1,nelt
            i = minfo%matrix_ia(k)
            if (minfo%matrix_ja(k) <= nD) then
                ! sums over left half of matrix:
                rowsum(i) = rowsum(i) + minfo%matrix_sa(k)
            endif
            if ((minfo%matrix_ia(k) <= nD) .and. (minfo%matrix_ja(k) > nD)) then
                write(6,*) '+++ k,ia,ja,sa: ',k,minfo%matrix_ia(k),minfo%matrix_ja(k),minfo%matrix_sa(k)
            endif
        enddo
        do i=1,2*nD
            write(6,*) '+++ row ',i,'  rowsum = ',rowsum(i)
        enddo
        
        ! test multiplication:
        ! construct uv vector that varies only in x, uniform in y
        do k = 1,nD
            uv(k) = mod(k,nx)
            uv(k+nD) = 2.d0*mod(k,nx)
            write(6,*) '+++ k,uv(k),uv(k+nD): ',k,uv(k),uv(k+nD)
            enddo
            
        call MATVEC(2*nD, uv, Auv, nelt, minfo%matrix_ia, minfo%matrix_ja, minfo%matrix_sa, 0)

        do k=1,nD
            write(6,*) '+++ k,Auv(k),Auv(k+nD): ',k,Auv(k),Auv(k+nD)
            enddo
                
        write(6,*) '+++ Set up matrix of dimension ',2*nD
        write(6,*) '+++ Number of nonzeros: ', nelt
        write(6,*) '+++ Size of minfo%matrix_sa: ', size(minfo%matrix_sa)
    endif
    
    ! =============

    if (.false.) then
        allocate(uv(2*nD), Auv(2*nD)) ! for testing matvec

        ! right hand side:
        write(63,*) '========= rhs:'
        do j=1,nD
            write(63,630) j,rhs(j),j+nD,rhs(j+nD)
        enddo
        
 630    format(i6,d26.16, i6,d26.16)
 631    format(4d26.16)
 632    format('Column',i3,'   Row',i3, d26.16, '   Row',i3,d26.16)
        
        ! print columns of matrix:
        do j=1,2*nD
            uv(1:2*nD) = 0.d0
            uv(j) = 1.d0
            
            call MATVEC(2*nD, uv, Auv, nelt, minfo%matrix_ia, &
                        minfo%matrix_ja, minfo%matrix_sa, 0)
            !write(63,*) 'Column ',j
            !write(63,631) (Auv(k), k=1,nD)
            !write(63,*) ' '
            !write(63,631) (Auv(k), k=nD+1,2*nD)
            k = 11
            write(63,632) j,k,Auv(k),k+nD,Auv(k+nD)
        enddo
        deallocate(uv,Auv)
    endif
    

    ! =============
    
    
    if (nelt > size(minfo%matrix_sa)) then
        write(6,*) '*** Error nelt > size(minfo%matrix_sa), need to allocate larger'
        stop
    endif

    call system_clock(clock_finish,clock_rate)
    call cpu_time(cpu_finish)
    timePrepBuild = timePrepBuild + clock_finish-clock_start
    timePrepBuildCPU = timePrepBuildCPU + cpu_finish-cpu_start

#ifdef WHERE_AM_I
  write(*,*) "ending   buildSparseMatrixMScoo"
#endif
        

contains

    ! Index into q array
    integer pure function iadd(ivar,i,j)
        integer, intent(in) :: i, j, ivar
        !! ghost cells added to iadd definition, NOT to call
        iadd = loc + ivar-1 + nvar*((j-1+nghost)*mitot+i+nghost-1)
    end function iadd

    ! Index into aux array
    integer pure function iaddaux(iaux,i,j)
        integer, intent(in) :: i, j, iaux  
        !! ghost cells added to iaddaux definition, NOT to call
        iaddaux = locaux + iaux-1 + naux*((j-1+nghost)*mitot+i+nghost-1)
    end function iaddaux

end subroutine buildSparseMatrixMScoo

c
c ---------------------------------------------------------
c
      subroutine projec1(level,numpro,rectflags,ilo,ihi,mbuff)
c
      use amr_module
      implicit double precision (a-h,o-z)
      dimension rectflags(ilo-mbuff:ihi+mbuff)
c
c  ::::::::::::::::::::::: PROJEC2 ::::::::::::::::::::::::::::::
c  for all newly created fine grids, project area onto a coarser
c  grid 2 levels down. Used to recreate grids 1 level down, and
c  insure proper level nesting.
c
c  on entry, all coarse grids have already had error estimated, so
c  add bad flags.   count number of 'added' flags only.
c
c input parameters:
c    level = project all fine subgrids onto grids at this level.
c output parameters:
c  numpro = number of additional flagged pts. at 'level'.
c           (initialized to 0 in flglvl)
c local variables:
c     iflags  = holds coarser domain flagged points - receives projection
c     mkid    = grid doing the projecting
c  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      levpro  =  level + 2
      lrat2x  = intratx(level)*intratx(level+1)
c
      mkid = newstl(levpro)
 10   if (mkid .eq. 0) go to 90
       ikidlo = node(ndilo,mkid)
       ikidhi = node(ndihi,mkid)
c
c  project entire region of fine grids onto rectflag array if intersects
c  possibly take care of buffering.
c  adjust since grid descriptor (integer indices)  is 0 based, 
c  iflags indexing is 1 based. 
c  do not projec the buffer region, only interior needs it
c  since buffering will take care of rest (unless ibuff=0-see below)
c
      ist  = floor(ikidlo/real(lrat2x))
!--      iend = ikidhi/lrat2x
      iend = ceiling((ikidhi+1.d0)/lrat2x) -1

      if (ibuff .eq. 0) then
c     ## ensure proper nesting here, since buffering step won't follow when ibuff 0
        if (ist*lrat2x .eq. ikidlo) ist = ist-1
        if ((iend+1)*lrat2x .eq. ikidhi+1) iend = iend+1
      endif

      ixlo = max(ist, ilo-mbuff)
      ixhi = min(iend,ihi+mbuff)
      if (.not.(ixlo .le. ixhi)) go to 80 ! grid mkid doesnt intersect with rectflags
c
c       !old code, shift indices by 1
c       do 60 i = ist+1, iend+1   ! since iflags used 1-based indexing
c       do 60 i = ist, iend        ! new code into rectflags is 0 based
        do 60 i = ixlo, ixhi
           if (rectflags(i) .le. DONTFLAG) then
               rectflags(i) = badpro
               numpro      = numpro + 1
               if (pprint) write(outunit,101) i,mkid
101            format(' pt.',2i5,' of grid ',i5,' projected' )
           endif
 60    continue
c
c  done with gridpt. loop for grid mkid.
c
 80     mkid = node(levelptr, mkid)
        go to 10
c
 90   if (pprint) then
         write(outunit,102) numpro,level
 102     format(i9,' more pts. projected to level ',i5)

         write(outunit,103) level
 103     format(/,'  from projec: flagged pts. (incl. buffer zone)',
     &           ' at level ',i4,':')

           write(outunit,104)(int(rectflags(i)),i=ilo-mbuff,ihi+mbuff)
104        format(80i1)
      endif
c
 99   return
      end

! ==========================================================
subroutine flux3(q,dq,aux,dt,cfl,t,num_aux,num_eqn,num_ghost,maxnx,mx,my,mz,rpn3,tfluct3)
! ==========================================================

    ! Evaluate (delta t) *dq/dt
    ! On entry, q should give the initial data for this step
    ! dimension-by-dimension version
    ! (No genuinely multi-d terms)

    ! dq1d is used to return increments to q from flux1
    ! See the flux1 documentation for more information.

    use ClawParams
    implicit none

    external :: rpn3, tfluct3
    integer, intent(in) :: num_aux,num_eqn,num_ghost,maxnx,mx,my,mz
    double precision, intent(in) :: dt,t
    double precision, target, intent(in) :: q(num_eqn,1-num_ghost:mx+num_ghost,1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    double precision, target, intent(in) :: aux(num_aux,1-num_ghost:mx+num_ghost,1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    double precision, intent(inout) :: dq(num_eqn,1-num_ghost:mx+num_ghost,1-num_ghost:my+num_ghost,1-num_ghost:mz+num_ghost)
    double precision, intent(out) :: cfl

!f2py intent(in,out) dq  
!f2py intent(out) cfl  
!f2py optional dq

! Dummy interface just so f2py doesn't complain:
!f2py real(DP) x
!f2py x=rpn3(x)
!f2py x=tfluct3(x)
    
    !local variables
    integer :: i,j,k,m
    double precision :: cfl1d
    double precision, pointer :: aux1d(:,:),q1d(:,:)
    double precision :: dq1d(num_eqn,1-num_ghost:maxnx+num_ghost)
    
    cfl = 0.d0

    ! perform x-sweeps
    ! ==================

   
    do j = 0,my+1
        do k = 0,mz+1
            ! copy data along a slice into 1d arrays:
            q1d => q(:,:,j,k)
            aux1d => aux(:,:,j,k)

            ! compute modification dq1d along this slice:
            call flux1(q1d,dq1d,aux1d,dt,cfl1d,t,1,num_aux,num_eqn,mx,num_ghost,maxnx,rpn3,tfluct3)
            cfl = dmax1(cfl,cfl1d)

            forall(i=1:mx, m=1:num_eqn)
                dq(m,i,j,k) = dq(m,i,j,k)+dq1d(m,i)
            end forall
        enddo
    enddo !end x sweeps


    ! perform y sweeps
    ! ==================

    do i = 0, mx+1
        do k = 0, mz+1
            ! copy data along a slice into 1d arrays:
            q1d => q(:,i,:,k)
            aux1d => aux(:,i,:,k)

            call flux1(q1d,dq1d,aux1d,dt,cfl1d,t,2,num_aux,num_eqn,my,num_ghost,maxnx,rpn3,tfluct3)
            cfl = dmax1(cfl,cfl1d)

            forall(j=1:my,m=1:num_eqn)
                dq(m,i,j,k) = dq(m,i,j,k)+dq1d(m,j)
            end forall
        enddo
    enddo !end y sweeps

    ! perform z sweeps
    ! ==================

    do i = 0, mx+1
        do j = 0, my+1
            ! copy data along a slice into 1d arrays:
            q1d => q(:,i,j,:)
            aux1d => aux(:,i,j,:)

            call flux1(q1d,dq1d,aux1d,dt,cfl1d,t,3,num_aux,num_eqn,mz,num_ghost,maxnx,rpn3,tfluct3)
            cfl = dmax1(cfl,cfl1d)

            forall(k=1:mz,m=1:num_eqn)
                dq(m,i,j,k) = dq(m,i,j,k)+dq1d(m,k)
            end forall
        enddo
    enddo !end z sweeps

end subroutine flux3

!> Compute all fluxes at cell edges 
!! \param qold[in] solution array for computing fluxes. It is not changed in this subroutine
!! \param fm[out] fluxes on the left side of each vertical edge
!! \param fp[out] fluxes on the right side of each vertical edge
!! \param gm[out] fluxes on the lower side of each horizontal edge
!! \param gp[out] fluxes on the upper side of each horizontal edge
subroutine step2(maxm,meqn,maux,mbc,mx,my,qold,aux,dx,dy,dt,cflgrid,fm,fp,gm,gp,rpn2,rpt2)
!
!     clawpack routine ...  modified for AMRCLAW
!
!     Take one time step, updating q.
!     On entry, qold gives
!        initial data for this step
!        and is unchanged in this version.
!    
!     fm, fp are fluxes to left and right of single cell edge
!     See the flux2 documentation for more information.
!
!     Converted to f90 2012-1-04 (KTM)
!
    
    use amr_module

    implicit none
    
    external rpn2, rpt2
    
    ! Arguments
    integer, intent(in) :: maxm,meqn,maux,mbc,mx,my
    real(kind=8), intent(in) :: dx,dy,dt
    real(kind=8), intent(inout) :: cflgrid
    real(kind=8), intent(inout) :: qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: fm(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: fp(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: gm(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(inout) :: gp(meqn,1-mbc:mx+mbc, 1-mbc:my+mbc)
    
    ! Local storage for flux accumulation
    real(kind=8) :: faddm(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: faddp(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: gaddm(meqn,1-mbc:maxm+mbc,2)
    real(kind=8) :: gaddp(meqn,1-mbc:maxm+mbc,2)
    
    ! Scratch storage for Sweeps and Riemann problems
    real(kind=8) ::  q1d(meqn,1-mbc:maxm+mbc)
    real(kind=8) :: aux1(maux,1-mbc:maxm+mbc)
    real(kind=8) :: aux2(maux,1-mbc:maxm+mbc)
    real(kind=8) :: aux3(maux,1-mbc:maxm+mbc)
    real(kind=8) :: dtdx1d(1-mbc:maxm+mbc)
    real(kind=8) :: dtdy1d(1-mbc:maxm+mbc)
    
    real(kind=8) ::  wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8) ::     s(mwaves, 1-mbc:maxm + mbc)
    real(kind=8) ::  amdq(meqn,1-mbc:maxm + mbc)
    real(kind=8) ::  apdq(meqn,1-mbc:maxm + mbc)
    real(kind=8) ::  cqxx(meqn,1-mbc:maxm + mbc)
    real(kind=8) :: bmadq(meqn,1-mbc:maxm + mbc)
    real(kind=8) :: bpadq(meqn,1-mbc:maxm + mbc)
    
    ! Looping scalar storage
    integer :: i,j,thread_num
    real(kind=8) :: dtdx,dtdy,cfl1d
    
    ! Common block storage
    integer :: icom,jcom
    real(kind=8) :: dtcom,dxcom,dycom,tcom
    common /comxyt/ dtcom,dxcom,dycom,tcom,icom,jcom
    
    ! Store mesh parameters in common block
    dxcom = dx
    dycom = dy
    dtcom = dt
    
    cflgrid = 0.d0
    dtdx = dt/dx
    dtdy = dt/dy
    
    fm = 0.d0
    fp = 0.d0
    gm = 0.d0
    gp = 0.d0
    
    ! ============================================================================
    ! Perform X-Sweeps
    do j = 0,my+1
        ! Copy old q into 1d slice
        q1d(:,1-mbc:mx+mbc) = qold(:,1-mbc:mx+mbc,j)
        
        ! Set dtdx slice if a capacity array exists
        if (mcapa > 0)  then
            dtdx1d(1-mbc:mx+mbc) = dtdx / aux(mcapa,1-mbc:mx+mbc,j)
        else
            dtdx1d = dtdx
        endif
        
        ! Copy aux array into slices
        if (maux > 0) then
            aux1(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j-1)
            aux2(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j  )
            aux3(:,1-mbc:mx+mbc) = aux(:,1-mbc:mx+mbc,j+1)
        endif
        
        ! Store value of j along the slice into common block
        jcom = j

        ! Compute modifications fadd and gadd to fluxes along this slice:
        call flux2(1,maxm,meqn,maux,mbc,mx,q1d,dtdx1d,aux1,aux2,aux3, &
                   faddm,faddp,gaddm,gaddp,cfl1d,wave,s, &
                   amdq,apdq,cqxx,bmadq,bpadq,rpn2,rpt2)       
                   
        cflgrid = max(cflgrid,cfl1d)

        ! Update fluxes
        ! here gm(:,i,j) and gp(:,i,j) are the same since
        ! they are both \tilde{G}_{i-1/2,j} in the textbook
        fm(:,1:mx+1,j) = fm(:,1:mx+1,j) + faddm(:,1:mx+1)
        fp(:,1:mx+1,j) = fp(:,1:mx+1,j) + faddp(:,1:mx+1)
        gm(:,1:mx+1,j) = gm(:,1:mx+1,j) + gaddm(:,1:mx+1,1)
        gp(:,1:mx+1,j) = gp(:,1:mx+1,j) + gaddp(:,1:mx+1,1)
        gm(:,1:mx+1,j+1) = gm(:,1:mx+1,j+1) + gaddm(:,1:mx+1,2)
        gp(:,1:mx+1,j+1) = gp(:,1:mx+1,j+1) + gaddp(:,1:mx+1,2)
        
    enddo

    ! ============================================================================
    !  y-sweeps    
    !
    do i = 0,mx+1
        
        ! Copy data along a slice into 1d arrays:
        q1d(:,1-mbc:my+mbc) = qold(:,i,1-mbc:my+mbc)

        ! Set dt/dy ratio in slice
        if (mcapa > 0) then
            dtdy1d(1-mbc:my+mbc) = dtdy / aux(mcapa,i,1-mbc:my+mbc)
        else
            dtdy1d = dtdy
        endif

        ! Copy aux slices
        if (maux .gt. 0)  then
            aux1(:,1-mbc:my+mbc) = aux(:,i-1,1-mbc:my+mbc)
            aux2(:,1-mbc:my+mbc) = aux(:,i,1-mbc:my+mbc)
            aux3(:,1-mbc:my+mbc) = aux(:,i+1,1-mbc:my+mbc)
        endif
        
        ! Store the value of i along this slice in the common block
        icom = i
        
        ! Compute modifications fadd and gadd to fluxes along this slice
        call flux2(2,maxm,meqn,maux,mbc,my,q1d,dtdy1d,aux1,aux2,aux3, &
                   faddm,faddp,gaddm,gaddp,cfl1d,wave,s,amdq,apdq,cqxx, &
                   bmadq,bpadq,rpn2,rpt2)

        cflgrid = max(cflgrid,cfl1d)

        ! Update fluxes
        gm(:,i,1:my+1) = gm(:,i,1:my+1) + faddm(:,1:my+1)
        gp(:,i,1:my+1) = gp(:,i,1:my+1) + faddp(:,1:my+1)
        fm(:,i,1:my+1) = fm(:,i,1:my+1) + gaddm(:,1:my+1,1)
        fp(:,i,1:my+1) = fp(:,i,1:my+1) + gaddp(:,1:my+1,1)
        fm(:,i+1,1:my+1) = fm(:,i+1,1:my+1) + gaddm(:,1:my+1,2)
        fp(:,i+1,1:my+1) = fp(:,i+1,1:my+1) + gaddp(:,1:my+1,2)

    enddo


end subroutine step2

! ==================================================================
subroutine rpt3(ixyz,icoor,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! ==================================================================

!     # Riemann solver in the transverse direction for the acoustics equations
!     # with varying material properties

!     # auxN(i,1,:) holds impedance Z
!     # auxN(i,2,:) holds sound speed c
!     #
!     # On input,

!     #    ql,qr is the data along some one-dimensional slice, as in rpn3
!     #         This slice is
!     #             in the x-direction if ixyz=1,
!     #             in the y-direction if ixyz=2, or
!     #             in the z-direction if ixyz=3.
!     #    asdq is an array of flux differences (A^*\Dq).
!     #         asdq(i,:) is the flux difference propagating away from
!     #         the interface between cells i-1 and i.
!     #    Note that asdq represents B^*\Dq if ixyz=2 or C^*\Dq if ixyz=3.

!     #    ixyz indicates the direction of the original Riemann solve,
!     #         called the x-like direction in the table below:

!     #               x-like direction   y-like direction   z-like direction
!     #      ixyz=1:        x                  y                  z
!     #      ixyz=2:        y                  z                  x
!     #      ixyz=3:        z                  x                  y

!     #    icoor indicates direction in which the transverse solve should
!     #         be performed.
!     #      icoor=2: split in the y-like direction.
!     #      icoor=3: split in the z-like direction.

!     #    For example,
!     #      ixyz=1, icoor=2 means asdq=A^*\Dq, and should be split in y into
!     #                        bmasdq = B^-A^*\Dq,
!     #                        bpasdq = B^+A^*\Dq.
!     #
!     #      ixyz=2, icoor=2 means asdq=B^*\Dq, and should be split in z into
!     #                        bmasdq = C^-B^*\Dq,
!     #                        bpasdq = C^+B^*\Dq.

!     #    The parameter imp is generally needed only if aux
!     #    arrays are being used, in order to access the appropriate
!     #    variable coefficients:

!     #    imp = 1 if asdq = A^- \Dq,  the left-going flux difference
!     #          2 if asdq = A^+ \Dq, the right-going flux difference

!     #    aux2(:,:,2) is a 1d slice of the aux array along the row
!     #                 where the data ql, qr lie.
!     #    aux1(:,:,2) and aux3(:,:,2) are neighboring rows in the
!     #                 y-like direction
!     #    aux2(:,:,1) and aux2(:,:,3) are neighboring rows in the
!     #                z-like direction


    implicit real*8(a-h,o-z)
    dimension     ql(meqn,1-mbc:maxm+mbc)
    dimension     qr(meqn,1-mbc:maxm+mbc)
    dimension   asdq(meqn,1-mbc:maxm+mbc)
    dimension bmasdq(meqn,1-mbc:maxm+mbc)
    dimension bpasdq(meqn,1-mbc:maxm+mbc)
    dimension   aux1(maux,1-mbc:maxm+mbc,3)
    dimension   aux2(maux,1-mbc:maxm+mbc,3)
    dimension   aux3(maux,1-mbc:maxm+mbc,3)


!     # set iuvw = 2,3,4, depending on which component of q represents
!     # velocity in the transverse direction in which splitting is to
!     # be performed:
    iuvw = ixyz + icoor
    if (iuvw > 4) iuvw = iuvw-3


    do 10 i=2-mbc,mx+mbc

    !        # The flux difference asdq is split into downward moving part
    !        # traveling at speed -c relative to the medium below and
    !        # an upward moving part traveling
    !        # at speed +c relative to the medium above.
    
    !        # Note that the sum of these parts does not give all of asdq
    !        # since there is also reflection at the interfaces which decreases
    !        # the flux.
    
    !        # set impendance and sound speed in each row of cells,
    !        # by selecting appropriate values from aux arrays depending on
    !        # values of icoor, imp:

    !        # imp is used to flag whether wave is going to left or right.
        i1 = i-2+imp    !#  =  i-1 for amdq,  i for apdq
    
        if (icoor == 2) then
        !           # transverse direction is y-like direction so
        !           # auxN(:,:,2) holds data in appropriate plane and N=(1,2,3)
        !           # for row (below,at,above) the slice of q data
            zm = aux1(1,i1,2)
            zz = aux2(1,i1,2)
            zp = aux3(1,i1,2)
            cm = aux1(2,i1,2)
            c  = aux2(2,i1,2)
            cp = aux3(2,i1,2)
        else !! (icoor .eq. 3)
        !           # transverse direction is z-like direction so
        !           # aux2(:,:,N) holds data in appropriate plane and N=(1,2,3)
        !           # for row (below,at,above) the slice of q data
            zm = aux2(1,i1,1)
            zz = aux2(1,i1,2)
            zp = aux2(1,i1,3)
            cm = aux2(2,i1,1)
            c  = aux2(2,i1,2)
            cp = aux2(2,i1,3)
        endif
    

    !        # transmitted part of down-going wave:
        a1 = (-asdq(1,i) + asdq(iuvw,i)*zz) / &
        (zm + zz)

    !        # transmitted part of up-going wave:
        a2 = (asdq(1,i) + asdq(iuvw,i)*zz) / &
        (zz + zp)
    
    !        # The down-going flux difference bmasdq is the product  -c * wave
    
        bmasdq(1,i) = cm * a1*zm
        bmasdq(2,i) = 0.d0
        bmasdq(3,i) = 0.d0
        bmasdq(4,i) = 0.d0
        bmasdq(iuvw,i) = -cm * a1
    
    !        # The up-going flux difference bpasdq is the product  c * wave
    
        bpasdq(1,i) = cp * a2*zp
        bpasdq(2,i) = 0.d0
        bpasdq(3,i) = 0.d0
        bpasdq(4,i) = 0.d0
        bpasdq(iuvw,i) = cp * a2
    
    10 END DO


    return
    end subroutine rpt3

c
c --------------------------------------------------------------
c
      subroutine setflags(iflags,isize,jsize,
     1                    rctold,idim3,mitot,mjtot,mptr)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension rctold(idim3,mitot,mjtot)
      integer(kind=1) iflags(0:isize+1,0:jsize+1)

c :::::::::::::::::::::: SETFLAGS ::::::::::::::::::::::::::::::::::
!> transfer flagged arrays into 1 large array of entire domain
!! makes buffering, projecting, etc. easier without searching 
!! through all kinds of grids
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

      ibeg = node(ndilo,mptr) - nghost
      jbeg = node(ndjlo,mptr) - nghost

      do j = nghost+1, mjtot-nghost
      do i = nghost+1, mitot-nghost
        iflags(ibeg+i,jbeg+j) = iflags(ibeg+i,jbeg+j) + rctold(1,i,j)
      end do
      end do
c
 99   return
      end

c
c ------------------------------------------------------------
c
       subroutine cstore(qc,nrow,ncol,nvar,qc1d,lenbc,naux,auxc,auxc1d)

       implicit double precision (a-h, o-z)

       dimension qc(nvar,nrow,ncol)
       dimension qc1d(nvar,lenbc)
       dimension auxc(naux,nrow,ncol)
       dimension auxc1d(naux,lenbc)
c
!>      store coarse perimeter worth of solution into 1d array.
c      go around fine grid in following order
c                2
c           __________
c        1 |          | 3
c           __________
c               4
c
c  save first interior cell of enlarged grid corresponding to
c  fine grid bordering cell. note that since fine grid is smaller,
c  the cell is one in. coarse (temporary) grid has no ghost cells

c      side 1
       index = 0
       do 10 j = 2, ncol-1
         index = index + 1
         do 5 ivar = 1, nvar
           qc1d(ivar,index) = qc(ivar,1,j)
 5       end do
         do 6 iaux = 1, naux
           auxc1d(iaux,index) = auxc(iaux,1,j)
 6       end do
 10    continue

c      side 2
       do 20 i = 2, nrow-1
         index = index + 1
         do 15 ivar = 1, nvar
           qc1d(ivar,index) = qc(ivar,i,ncol)
 15      end do
         do 16 iaux = 1, naux
           auxc1d(iaux,index) = auxc(iaux,i,ncol)
 16      end do
 20    continue

c      side 3
       do 30 j = 2, ncol-1
         index = index + 1
         do 25 ivar = 1, nvar
           qc1d(ivar,index) = qc(ivar,nrow,j)
 25      end do
         do 26 iaux = 1, naux
           auxc1d(iaux,index) = auxc(iaux,nrow,j)
 26      end do
 30    continue

c      side 4
       do 40 i = 2, nrow-1
         index = index + 1
         do 35 ivar = 1, nvar
           qc1d(ivar,index) = qc(ivar,i,1)
 35        end do 
         do 36 iaux = 1, naux
           auxc1d(iaux,index) = auxc(iaux,i,1)
 36      end do
 40    continue

       return
       end

subroutine implicit_update(nvar,naux,levelBouss,numBoussCells,doUpdate,time)

    ! For source terms that require an implicit solve, in the case when there
    ! is a single levelBouss at which the source terms should be applied.
    
    ! Set up and solve the linear system using sparse matrix and gmres.
    ! Then use the resulting soln to update q by looping over all 
    ! Bouss level patches.
    
    ! Boussinesq version.
    
    use amr_module
    use topo_module, only: topo_finalized
    use bouss_module
        
    implicit none
    
    integer, intent(in) :: nvar, naux, levelBouss, numBoussCells
    logical, intent(in) :: doUpdate
    
    !! pass in numBoussCells for this level so can dimension this array
    real(kind=8) :: soln(0:2*numBoussCells)
    real(kind=8) :: rhs(0:2*numBoussCells)
    
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: i,j,nb,nn,levSt,nx,ny,mitot,mjtot,loc,locaux,mptr
    integer :: locnew, locold, locOther
    real(kind=8) :: dt
    
    integer :: nD, nst, ncc, k
    integer(kind=8) :: clock_startBound,clock_finishBound,clock_rate
    integer(kind=8) :: clock_startLinSolve,clock_finishLinSolve
    real(kind=8) cpu_startBound,cpu_finishBound, time 
    real(kind=8) cpu_startLinSolve,cpu_finishLinSolve

#ifdef WHERE_AM_I
    write(*,*) "starting implicit_update for level ",levelBouss
#endif
    dt = possk(levelBouss)
    nD = numBoussCells ! shorthand for size of matrix blocks D1 to D4
    
    ! bc_xlo, bc_ylo, bc_xhi, bc_yhi are set in bouss_module.
    !     0 means Dirchlet value 0 (no correction at each of union of patches)
    !     1 means Neumann (correction in first interior cell = in ghost cell)
    !     2 means use ghost cell values in q(4:5,:,:) as Dirichlet BCs
    !             Multiply by matrix element and move to RHS
    !             Requires nvar==5.
    
    minfo => matrix_info_allLevs(levelBouss)

    
! =======================  step 1: fill ghost cells ==============================

! need ghost cells after finite vol update, before next phase of differencingc 
! get start time for more detailed timing by level
       call system_clock(clock_startBound,clock_rate)
       call cpu_time(cpu_startBound)

    !!write(*,*) "before bound loop"
    !!call timestamp()
    !! reset isBouss flag array if topo still moving
    !if (.not. topo_finalized) then
      call setBoussFlag(levelBouss,naux)
    !endif
!$OMP PARALLEL DO PRIVATE(j,locnew,locaux,mptr,nx,ny,mitot,                   &
!$OMP                     mjtot,levSt),                                       &
!$OMP             SHARED(levelBouss,nvar,naux,alloc,nghost,time,              &
!$OMP                    node,rnode,numgrids,listStart,listOfGrids),          &
!$OMP             SCHEDULE (dynamic,1)                                        &
!$OMP             DEFAULT(none)
      
      do  nn = 1, numgrids(levelBouss)
          levSt  = listStart(levelBouss)
          mptr   = listOfGrids(levSt+nn-1)
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
          mitot  = nx + 2*nghost
          mjtot  = ny + 2*nghost
          locnew = node(store1,mptr)
          locaux = node(storeaux,mptr)
 
          call bound(time,nvar,nghost,alloc(locnew),mitot,mjtot,mptr,     &
                     alloc(locaux),naux)
        end do
!$OMP END PARALLEL DO

      call system_clock(clock_finishBound,clock_rate)
      call cpu_time(cpu_finishBound)
      timeBound = timeBound + clock_finishBound - clock_startBound
      timeBoundCPU=timeBoundCPU+cpu_finishBound-cpu_startBound

    ! ================  Step 2: build matrix and rhs  ======================

    if (ibouss .eq. 1) then
      ! Madsen-Sorensen, always uses COO format:
      call buildSparseMatrixMScoo(rhs,nvar,naux,levelBouss,numBoussCells)
    else ! ibouss 2 means SGN
      if (.not. crs) then ! COO triplet format
        call prepBuildSparseMatrixSGNcoo(soln,rhs,nvar,naux,levelBouss,numBoussCells)
      else ! CRS format
         minfo%vals = 0
         minfo%cols = -1  ! to recognize if not overwritten with real col indices
        call prepBuildSparseMatrixSGNcrs(soln,rhs,nvar,naux,levelBouss,numBoussCells)
      endif
    endif
    
    !================   Step 4 Solve matrix system =======================

    if (isolver .eq.1) then  ! use gmres
       write(*,*)" No longer supporting gmres option"
       write(outunit,*)" No longer supporting gmres option"
       stop
            
    else if (isolver .eq.2) then  ! use pardiso
    
#ifdef HAVE_PARDISO
       write(*,*)" No longer supporting pardiso option"
       write(outunit,*)" No longer supporting pardiso option"
       stop
       !if (minfo%matrix_nelt .gt. 0) then
       !  call system_clock(clock_startLinSolve,clock_rate)
       !  call cpu_time(cpu_startLinSolve)
       !  ! convert to compressed row format
       !  nst = minfo%matrix_nelt
       !  call st_to_cc_size(nst,minfo%matrix_ia,minfo%matrix_ja,ncc)
       !  call pardiso_driver(soln,rhs,levelBouss,numBoussCells,nst,ncc,topo_finalized)
       !  call system_clock(clock_finishLinSolve,clock_rate)
       !  call cpu_time(cpu_finishLinSolve)
       !  timeLinSolve = timeLinSolve + clock_finishLinSolve - clock_startLinSolve
       !else
       !  go to 99
       !endif
#endif

    else if (isolver .eq.3) then  ! use petsc
#ifdef HAVE_PETSC
       ! now add Petsc. Not all levels are bouss grids so test first
       ! for now test for either CRS or COO option for now
       if (minfo%numColsTot .gt. 0 .or. minfo%matrix_nelt .gt. 0) then
          call system_clock(clock_startLinSolve,clock_rate)
          call cpu_time(cpu_startLinSolve)
          call petsc_driver(soln,rhs,levelBouss,numBoussCells,time,topo_finalized)
          call system_clock(clock_finishLinSolve,clock_rate)
          call cpu_time(cpu_finishLinSolve)
          !write(89,*)" level ",levelBouss,"  rhs   soln"
          !do k = 1, 2*numBoussCells
          !   write(89,899) k,rhs(k), soln(k)
  899         format(i5,2e15.7)
          !end do
          timeLinSolve = timeLinSolve + clock_finishLinSolve - clock_startLinSolve
          timeLinSolveCPU = timeLinSolveCPU+cpu_finishLinSolve - cpu_startLinSolve
       else
         go to 99 ! IS THERE ANYTHING TO UPDATE
       endif
#endif
    
    endif

    !================   Step 5  Update solution  =======================
            
    ! Use solution as updated q by looping over grids at levelBouss
    ! This can be done in parallel on patches
    
    ! using forward Euler at this stage to update momenta
    ! we are solving P_t = -S  where S is the solution of the linear system
    ! so update P to P - dt*S

!$OMP  PARALLEL DO PRIVATE(mptr,locnew,locOther,locaux,nx,ny,mitot,mjtot,nb,i,j,levSt),     &
!$OMP  SHARED(listOfGrids,listStart,alloc,soln,levelBouss,ibouss,crs,         &
!$OMP         doUpdate,nvar,naux,numgrids,node,dt,possk,nghost,nD,rhs,mxnest),    &  
!$OMP              SCHEDULE (dynamic,1),                                          &  
!$OMP              DEFAULT(none)
    do  nn = 1, numgrids(levelBouss)
        levSt  = listStart(levelBouss)
        mptr   = listOfGrids(levSt+nn-1)
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost
        locnew = node(store1,mptr)  
        locaux = node(storeaux,mptr)  
        if (levelBouss .lt. mxnest) then
           ! old storage location exists
           locOther = node(store2,mptr)  
        else
           ! want to save in same place, beware
           locOther = locnew
        endif
    
        nb = node(bpatchNum, mptr)
        !if (nb > 0) then  ! is a bouss patch
           if (ibouss .eq. 1) then
              call solnUpdate(alloc(locnew),alloc(locOther),nb,mitot,mjtot,nghost,nvar, &
                           dt,soln,nD,mptr,levelBouss,rhs,doUpdate)
           else ! ibouss 2 SGN, saving different stuff, different update
                call solnUpdateSGN(alloc(locnew),alloc(locOther),nb,mitot,mjtot,nghost,nvar, &
                     dt,soln,nD,mptr,levelBouss,rhs,doUpdate,alloc(locaux),naux)
           endif
        !endif
    end do        
!$OMP END PARALLEL DO

    !! next loop to copy from either other grids at same level and to
    !! update ghost cell momenta with newly copied psi
!$OMP PARALLEL DO PRIVATE(mptr,locnew,locaux,locold,nx,ny,mitot,mjtot,nb, &
!$OMP                      i,j,levSt),   &
!$OMP              SHARED(possk,listOfGrids,listStart,alloc,soln,levelBouss, &
!$OMP                     nvar,naux,numgrids,node,dt,nghost,nD,rhs,time),   &  
!$OMP              SCHEDULE (dynamic,1),                                               &  
!$OMP              DEFAULT(none)
    do  nn = 1, numgrids(levelBouss)
        levSt  = listStart(levelBouss)
        mptr   = listOfGrids(levSt+nn-1)
        dt     = possk(levelBouss)
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost
        locnew = node(store1,mptr)
        locaux = node(storeaux,mptr)
        nb = node(bpatchNum, mptr)
        !if (nb > 0) then  ! is a bouss patch
             ! might want to add this to previous boussUpdate routine and     
             ! and check for ghost cell overlap on fine patch at same
             ! time as update fine -> coarse
             ! still need ghost cell filling. simpleBound only does
             ! nboring grid filling at same level
             call simpleBound(time,nvar,alloc(locnew),mitot,mjtot,mptr,alloc(locaux),naux)
        !endif
    end do      
!$OMP END PARALLEL DO

 99     continue

#ifdef WHERE_AM_I
    write(*,*) "ending   implicit_update for level ",levelBouss
#endif
        

contains

    ! Index into q array
    integer pure function iadd(ivar,i,j)
        integer, intent(in) :: i, j, ivar
        !! ghost cells added to iadd definition, NOT to call
        iadd = loc + ivar-1 + nvar*((j-1+nghost)*mitot+i+nghost-1)
    end function iadd

    ! Index into aux array
    integer pure function iaddaux(iaux,i,j)
        integer, intent(in) :: i, j, iaux  
        !! ghost cells added to iaddaux definition, NOT to call
        iaddaux = locaux + iaux-1 + naux*((j-1+nghost)*mitot+i+nghost-1)
    end function iaddaux



end subroutine implicit_update

subroutine solnUpdate(valnew,valOther,nb,mitot,mjtot,nghost,nvar,dt, &
                      soln,nD,mptr,levelBouss,rhs,doUpdate)

    ! if doing the momentum update, put it in valnew.
    ! but save  psi in valold, since goes with previous
    ! momenta and h (in new bc approach)

    ! if not doing the update, then is the new solve added for
    ! a level AFTER the SWE update, for use in interpolating for
    ! fine psi.  So it goes in the valnew storage.
    
    ! Currently only doing first-order forward Euler update.
    
    use amr_module, only: outunit,mxnest
    use bouss_module, only: matrix_info_allLevs
    use bouss_module, only: matrix_levInfo, matrix_patchIndex
    implicit none

    integer, intent(in) :: nvar,nghost,mitot,mjtot,nD,mptr,nb,levelBouss
    logical, intent(in) :: doUpdate
    real(kind=8), intent(in) :: soln(0:2*nD), dt, rhs(0:2*nD)

    real(kind=8), intent(inout) :: valnew(nvar,mitot,mjtot)
    real(kind=8), intent(inout) :: valOther(nvar,mitot,mjtot)
    ! local variable
    integer :: i,j,k_ij
    integer :: imax1,jmax1,imax2,jmax2
    logical :: debug
    real(kind=8) :: solmax1,solmax2
    real(kind=8) :: valset

    !type(matrix_index), pointer :: mi
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo

    minfo =>matrix_info_allLevs(levelBouss)
    mi => minfo%matrix_indices(nb)

    debug = .false.
    solmax1 = 0.d0
    solmax2 = 0.d0
    imax1 = -1
    jmax1 = -1
    imax2 = -1
    jmax2 = -1

    !! if not updating momentum, just save psi, translating from
    !! soln vector back to patch variables
    !!if (.not. doUpdate .and. nvar .eq. 3) then
    !!    write(*,*) " this option doesn't make sense"
    !!    stop
    !!endif

    !! if finest level grid, dont have 2 levels of storage
    !! no need to save in old since wont need for interpolation

    if (doUpdate) then
       do j=nghost+1, mjtot-nghost
       do i=nghost+1, mitot-nghost
            k_ij = mi%mindex(i-nghost,j-nghost)  ! hu element index for (i,j)
            valnew(2,i,j) = valnew(2,i,j) + dt * soln(k_ij)
            valnew(3,i,j) = valnew(3,i,j) + dt * soln(k_ij + nD)
            if (.false.) write(67,*) '+++ i,j,soln: ', &
                        i-nghost,j-nghost,soln(k_ij),soln(k_ij + nD)
            if (abs(soln(k_ij)) .gt. solmax1) then
               solmax1 = abs(soln(k_ij))
               imax1 = i
               jmax1 = j
            endif
            if (abs(soln(k_ij+nD)) .gt. solmax2) then
               solmax2 = abs(soln(k_ij+nD))
               imax2 = i
               jmax2 = j
            endif

            if (nvar == 5) then
                ! save update in components 4,5 for Dirichlet BC next iteration
                ! for coarser levels, valOther is valOld
                ! on the finest grid we only have one storage loc
                ! and valOther is valNew, since dont need to save old
                ! and new for interpolation
                    valOther(4,i,j) = soln(k_ij)
                    valOther(5,i,j) = soln(k_ij+nD)
            endif
       enddo
       enddo

       ! next update momenta in ghost cells with interpolated psi. Will
       ! be overwritten with neighboring grids at same level in
       ! simpleBound so just do all ghost cells now
       valnew(2:3,1:mitot,1:nghost) = valnew(2:3,1:mitot,1:nghost) +  &
                                  dt* valnew(4:5,1:mitot,1:nghost)
       valnew(2:3,1:mitot,mjtot-nghost+1:mjtot) = valnew(2:3,1:mitot,mjtot-nghost+1:mjtot) + &
                                              dt* valnew(4:5,1:mitot,mjtot-nghost+1:mjtot)
       valnew(2:3,1:nghost,nghost+1:mjtot-nghost) = valnew(2:3,1:nghost,nghost+1:mjtot-nghost) +  &
                                                 dt* valnew(4:5,1:nghost,nghost+1:mjtot-nghost)
       valnew(2:3,mitot-nghost+1:mitot,nghost+1:mjtot-nghost) =                &
                      valnew(2:3,mitot-nghost+1:mitot,nghost+1:mjtot-nghost) +  &
                  dt* valnew(4:5,mitot-nghost+1:mitot,nghost+1:mjtot-nghost)

    else !! just save psi
       do j=nghost+1, mjtot-nghost
       do i=nghost+1, mitot-nghost
            k_ij = mi%mindex(i-nghost,j-nghost)  ! hu element index for (i,j)
            valnew(4,i,j) = soln(k_ij)
            valnew(5,i,j) = soln(k_ij+nD)
            if (abs(soln(k_ij)) .gt. solmax1) then
               solmax1 = abs(soln(k_ij))
               imax1 = i
               jmax1 = j
            endif
            if (abs(soln(k_ij+nD)) .gt. solmax2) then
               solmax2 = abs(soln(k_ij+nD))
               imax2 = i
               jmax2 = j
            endif
        end do
        end do
    endif

    if (debug) then
       write(*,*)"When doUpate = ",doUpdate,":"
       write(*,100) solmax1,imax1,jmax1
 100   format("max soln update for hu ",e15.7, " at ",i5,i5)
       write(*,101) solmax2,imax2,jmax2
 101   format("max soln update for hv ",e15.7, " at ",i5,i5)
    endif


end subroutine solnUpdate

! =========================================================
subroutine solnUpdateSGN(valnew,valOther,nb,mitot,mjtot,nghost,nvar,dt, &
                      soln,nD,mptr,levelBouss,rhs,doUpdate,aux,naux)

    ! if doing the momentum update, put it in valnew.
    ! but save  D from SGN solve  in valold, since goes with previous
    ! momenta and h (in new bc approach)

    ! if not doing the update, then is the new solve added for
    ! a level AFTER the SWE update, for use in interpolating for
    ! fine psi.  So it goes in the valnew storage.
    
    ! Currently only doing first-order forward Euler update.
    
    use amr_module, only: outunit,mxnest
    use bouss_module, only: matrix_info_allLevs,boussMindepth,crs
    use bouss_module, only: matrix_levInfo, matrix_patchIndex
    use amr_module, only: rnode,cornxlo,cornylo,hxposs,hyposs
    use geoclaw_module, only: earth_radius, deg2rad, coordinate_system, grav
    use geoclaw_module, only: dry_tolerance
    use bouss_module, only: alpha
    implicit none

    integer, intent(in) :: nvar,naux,nghost,mitot,mjtot,nD,mptr,nb,levelBouss
    logical, intent(in) :: doUpdate
    real(kind=8), intent(in) :: soln(0:2*nD), dt, rhs(0:2*nD)

    real(kind=8), intent(inout) :: valnew(nvar,mitot,mjtot)
    real(kind=8), intent(inout) :: valOther(nvar,mitot,mjtot)
    real(kind=8), intent(in) :: aux(naux,mitot,mjtot)
    ! local variable
    integer :: ng,i,j,k_ij,ivar,iunit,k,imax,jmax
    integer :: ist,iend,jst,jend
    logical :: debug
    real(kind=8) :: eta(mitot,mjtot)
    real(kind=8) :: etax(mitot,mjtot), etay(mitot,mjtot)
    real(kind=8) :: speed(mitot,mjtot), speedmax 
    real(kind=8) :: dx,dy,dxm,dym
    real(kind=8) :: xlowWithGhost,ylowWithGhost,x,y

    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo

    logical IS_INNER_GHOST

    IS_INNER_GHOST(i,j) = (i .le. nghost .or. i .gt. mitot-nghost .or.   &
                     j .le. nghost .or. j .gt. mjtot-nghost)

    if (nvar .ne. 5) then
      write(*,*)" this SGN routine assumes 5 equations"
      stop
    endif

    minfo =>matrix_info_allLevs(levelBouss)
    mi => minfo%matrix_indices(nb)

    dy = hyposs(levelBouss)
    dx = hxposs(levelBouss)

    if (coordinate_system .eq. 2) then
      dym = dy *earth_radius*deg2rad
    else
      dym = dy
    endif

    !debug = .true.
    debug = .false.


    !! if not updating momentum, just save psi, translating from
    !! soln vector back to patch variables

    !! if finest level grid, dont have 2 levels of storage
    !! no need to save in old since wont need for interpolation

    ! compute eta used below in update
    eta(:,:) = valnew(1,:,:) + aux(1,:,:)
       
    ! grad eta needed for updates. do one-sided at cell edges
    do j = 1, mjtot
         if (coordinate_system .eq. 2) then
            dxm = dx*earth_radius*deg2rad * cos(aux(3,1,j))
         else
            dxm = dx
         endif
       etax(1,j) = (eta(2,j) - eta(1,j))/dxm
       etax(mitot,j) = (eta(mitot,j) - eta(mitot-1,j))/dxm
    do i = 2, mitot-1
       etax(i,j) = (eta(i+1,j) - eta(i-1,j))/(2.d0*dxm)
    end do
    end do

    do i = 1, mitot
       etay(i,1) = (eta(i,2) - eta(i,1))/dym
       etay(i,mjtot) = (eta(i,mjtot) - eta(i,mjtot-1))/dym
    do j = 2, mjtot-1
       etay(i,j) = (eta(i,j+1) - eta(i,j-1))/(2.d0*dym)
    end do
    end do

    if (doUpdate) then
       do j=nghost+1, mjtot-nghost
       do i=nghost+1, mitot-nghost
            k_ij = mi%mindex(i-nghost,j-nghost)  ! hu element index for (i,j)
            if (mi%isBouss(i-nghost,j-nghost)) then
              ! check if soln == 0 as proxy if cell is more shallow than deep bouss
              ! and no update
                 if (.not. crs) then
                  ! COO triplet format
                  valnew(2,i,j) = valnew(2,i,j) + dt * valnew(1,i,j)*     &
                         (grav/alpha * etax(i,j) - soln(k_ij))
                  valnew(3,i,j) = valnew(3,i,j) + dt * valnew(1,i,j)*     &
                         (grav/alpha * etay(i,j) - soln(k_ij+nD))
                 else  ! CRS format,  different mapping
                  valnew(2,i,j) = valnew(2,i,j) + dt * valnew(1,i,j)*     &
                         (grav/alpha * etax(i,j) - soln(2*(k_ij-1)))
                  valnew(3,i,j) = valnew(3,i,j) + dt * valnew(1,i,j)*     &
                         (grav/alpha * etay(i,j) - soln(2*k_ij-1))
                 endif

                ! save update in components 4,5 for Dirichlet BC next iteration
                ! for coarser levels, valOther is valOld
                ! on the finest grid we only have one storage loc
                ! and valOther is valNew, since dont need to save old
                ! and new for interpolation
                if (.not. crs) then
                    valOther(4,i,j) = soln(k_ij)
                    valOther(5,i,j) = soln(k_ij+nD)
                else
                    !valOther(4,i,j) = soln(2*k_ij-1)
                    !valOther(5,i,j) = soln(2*k_ij)
                    valOther(4,i,j) = soln(2*(k_ij-1))
                    valOther(5,i,j) = soln(2*k_ij-1)
                 endif
            else  ! not a bouss cell. set to zero
               valOther(4,i,j) = 0.d0
               valOther(5,i,j) = 0.d0
            endif
       enddo
       enddo

       ! next update momenta in ghost cells with interpolated psi. Will
       ! be overwritten with neighboring grids at same level in
       ! simpleBound so just do all ghost cells now
       ! bottom bndry. Use first interior cell to determine if
       ! ghost cells should be updated. CORNERS?

       ! remember mindex only from 1:nx, 1:ny so subtract nghost as needed
       go to 444
       ! left side
       do j = nghost+1, mjtot-nghost
          !k_ij = mi%mindex(1,j-nghost)  ! 1st interior cell for row i
          !if (doBouss(k_ij)) then
          !if (mi%isBouss(1,j-nghost)) then
          do k = 1, nghost
          !if (aux(1,k,j) .lt. 0.d0) then  ! water, maybe check depth for bouss
          if (-aux(1,k,j) .gt. boussMinDepth) then  ! water, maybe check depth for bouss
             valnew(2,k,j) = valnew(2,k,j) + dt*valnew(1,k,j)   &
                          * (grav/alpha*etax(k,j) - valnew(4,k,j))
             valnew(3,k,j) = valnew(3,k,j) + dt*valnew(1,k,j)   &
                          * (grav/alpha*etay(k,j) - valnew(5,k,j))
          endif
          end do
        end do
       ! right side
       do j = nghost+1, mjtot-nghost
          !k_ij = mi%mindex(mitot-2*nghost,j-nghost)  ! last interior cell row i
          !if (doBouss(k_ij)) then
          !if (mi%isBouss(mitot-2*nghost,j-nghost)) then
          do k = mitot-nghost+1, mitot
          !if (aux(1,k,j) .lt. 0.d0) then
          if (-aux(1,k,j) .gt. boussMinDepth) then
             valnew(2,k,j) = valnew(2,k,j) + dt*valnew(1,k,j)         &
                          * (grav/alpha*etax(k,j) - valnew(4,k,j))
             valnew(3,k,j) = valnew(3,k,j) + dt*valnew(1,k,j)         &
                          * (grav/alpha*etay(k,j) - valnew(5,k,j))
          endif
          end do
        end do
       ! bottom side
       do i = nghost+1, mitot-nghost
          !k_ij = mi%mindex(i-nghost,1)  ! 1st interior cell for row i
          !if (doBouss(k_ij)) then
          !if (mi%isBouss(i-nghost,1)) then
          do k = 1, nghost
          !if (aux(1,i,k) .lt. 0.d0) then
          if (-aux(1,i,k) .gt. boussMinDepth) then
             valnew(2,i,k) = valnew(2,i,k) + dt*valnew(1,i,k)   &
                          * (grav/alpha*etax(i,k) - valnew(4,i,k))
             valnew(3,i,k) = valnew(3,i,k) + dt*valnew(1,i,k)   &
                          * (grav/alpha*etay(i,k) - valnew(5,i,k))
          endif
          end do
        end do
       ! top side
       do i = nghost+1, mitot-nghost
          !k_ij = mi%mindex(i-nghost,mjtot-2*nghost)  ! last interior cell row i
          !if (doBouss(k_ij)) then
          !if (mi%isBouss(i-nghost,mjtot-2*nghost)) then
          do k = mjtot-nghost+1,mjtot
          !if (aux(1,i,k) .lt. 0.d0) then
          if (-aux(1,i,k) .gt. boussMinDepth) then
             valnew(2,i,k) = valnew(2,i,k) + dt*valnew(1,i,k)         &
                          * (grav/alpha*etax(i,k) - valnew(4,i,k))
             valnew(3,i,k) = valnew(3,i,k) + dt*valnew(1,i,k)         &
                          * (grav/alpha*etay(i,k) - valnew(5,i,k))
          endif
          end do
        end do
   444 continue

    else !! just save psi. TEST FOR doBOUSS - SET TO 0?
       do j=nghost+1, mjtot-nghost
       do i=nghost+1, mitot-nghost
            k_ij = mi%mindex(i-nghost,j-nghost)  ! hu element index for (i,j)
            if (mi%isBouss(i-nghost,j-nghost)) then
              if (.not. crs) then
                valnew(4,i,j) = soln(k_ij)
                valnew(5,i,j) = soln(k_ij+nD)
              else
                valnew(4,i,j) = soln(2*(k_ij-1))
                valnew(5,i,j) = soln(2*k_ij-1)
              endif
            else
              valnew(4,i,j) = 0.d0
              valnew(5,i,j) = 0.d0
            endif
        end do
        end do
    endif

    if (debug .or.  0 .eq. 1) then
       xlowWithGhost = rnode(cornxlo,mptr) - nghost*dx
       ylowWithGhost = rnode(cornylo,mptr) - nghost*dy
       write(34,*)" end of solnUpdateSGN for grid ",mptr," with doUpdate ",doUpdate
       ng = 2 ! indicates to print ghost cells too
       iunit = 34
       call lookAtGrid(valnew,valOther,dx,dy,xlowWithGhost,ylowWithGhost,nvar,   &
                       mitot,mjtot,ng,iunit,doUpdate,levelBouss)
    endif

    if (.true. .and. debug) then
    imax = -1
    jmax = -1
    speedmax = -1.d0
    do j = nghost+1, mjtot-nghost
    do i = nghost+1, mitot-nghost
       if (valnew(1,i,j) .gt. dry_tolerance) then
         speed(i,j) = sqrt((valnew(2,i,j)**2+valnew(3,i,j)**2))/valnew(1,i,j)
         if (speed(i,j) .gt. speedmax) then
            speedmax = speed(i,j)
            imax = i
            jmax = j
         endif
       else
          speed(i,j) = 0.d0
       endif
    end do
    end do
    write(*,333) mptr,mitot,mjtot,speedmax,imax,jmax,    &
           (valnew(ivar,imax,jmax),ivar=1,nvar)
 333 format("grid ",i4," dims ",i4,i4," speed",f9.2," max index at ",2i4,5e12.4)
    endif

end subroutine solnUpdateSGN

subroutine symcheck(val,mitot,mjtot)

    ! only test for vertical symmetry here.

    real(kind=8), intent(in) :: val(5,mitot,mjtot)
    integer mitot, mjtot, i,j
    double precision eps,hucDif,hvcDif

    eps = 1.d-10
    do i = 1, mitot
    do j = 1, mjtot/2
       hucDif =  abs(val(4,i,j) - val(4,i,mjtot+1-j))
       hvcDif =  abs(val(5,i,j) + val(5,i,mjtot+1-j))
       if (hucDif .gt. eps .or. hvcDif .gt. eps) then
          write(31,100) i,j,hucDif,hvcDif
 100      format("Cell ",2i5," difs 4/5 = ",2e12.7)
       endif
    end do
    end do

    return
end subroutine symcheck

! =========================================================

      subroutine symcheck2(val,mitot,mjtot)

      ! only test for vertical symmetry here.

      real(kind=8), intent(in) :: val(5,mitot,mjtot)
      integer mitot, mjtot, i,j
      double precision eps,hucDif,hvcDif

      eps = 1.d-10

      hDifmax = 0.d0
      huDifmax = 0.d0
      hvDifmax = 0.d0
      hucDifmax = 0.d0
      hvcDifmax = 0.d0

      write(31,*)"checking vertical symmetry"
      do i = 1, mitot
      do j = 1, mjtot/2
         hDif =  abs(val(1,i,j) - val(1,i,mjtot+1-j))
         huDif =  abs(val(2,i,j) - val(2,i,mjtot+1-j))
         hvDif =  abs(val(3,i,j) + val(3,i,mjtot+1-j))
         hucDif =  abs(val(4,i,j) - val(4,i,mjtot+1-j))
         hvcDif =  abs(val(5,i,j) + val(5,i,mjtot+1-j))
         if (hucDif .gt. eps .or. hvcDif .gt. eps .or. hDif .gt. eps   &
            .or. huDif .gt. eps .or. hvDif .gt. eps) then
            write(31,100) i,j,hDif,huDif,hvDif,hucDif,hvcDif
         endif
         hDifmax = max(hDifmax,hDif)
         huDifmax = max(huDifmax,huDif)
         hvDifmax = max(hvDifmax,hvDif)
         hucDifmax = max(hucDifmax,hucDif)
         hvcDifmax = max(hvcDifmax,hvcDif)
      end do
      end do

      write(31,101)hDifmax,huDifmax,hvDifmax,hucDifmax,hvcDifmax  
      write(*,101)hDifmax,huDifmax,hvDifmax,hucDifmax,hvcDifmax  
 101  format("max vertical diff found: ",5e13.6)
  
      hDifmax = 0.d0
      huDifmax = 0.d0
      hvDifmax = 0.d0
      hucDifmax = 0.d0
      hvcDifmax = 0.d0

      write(31,*)"checking horizntl symmetry"
      do j = 1, mjtot
      do i = 1, mitot/2
         hDif =  abs(val(1,i,j) - val(1,mitot+1-i,j))
         huDif =  abs(val(2,i,j) + val(2,mitot+1-i,j))
         hvDif =  abs(val(3,i,j) - val(3,mitot+1-i,j))
         hucDif =  abs(val(4,i,j) + val(4,mitot+1-i,j))
         hvcDif =  abs(val(5,i,j) - val(5,mitot+1-i,j))
         if (hucDif .gt. eps .or. hvcDif .gt. eps .or. hDif .gt. eps   &
            .or. huDif .gt. eps .or. hvDif .gt. eps) then
            write(31,100) i,j,hDif,huDif,hvDif,hucDif,hvcDif
 100        format("Cell ",2i5," difs = ",5e13.6)
         endif
         hDifmax = max(hDifmax,hDif)
         huDifmax = max(huDifmax,huDif)
         hvDifmax = max(hvDifmax,hvDif)
         hucDifmax = max(hucDifmax,hucDif)
         hvcDifmax = max(hvcDifmax,hvcDif)
      end do
      end do

      write(31,102)hDifmax,huDifmax,hvDifmax,hucDifmax,hvcDifmax  
      write(*,102)hDifmax,huDifmax,hvDifmax,hucDifmax,hvcDifmax  
 102  format("max horizntl diff found: ",5e13.6)
  
      return
      end subroutine symcheck2

c     =====================================================
      subroutine qinit(meqn,mbc,mx,my,mz,xlower,ylower,zlower,
     &     dx,dy,dz,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c     # Sample scalar equation with linear data to test
c     # that second order method stays exact.
c
      implicit double precision (a-h,o-z)
      dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc,1-mbc:mz+mbc)

c     # set concentration profile
c     ---------------------------
      do 20 k=1,mz
         zk = zlower + (k-0.5d0)*dz
         do 20 j=1,my
            yj = ylower + (j-0.5d0)*dy
            do 20 i=1,mx
               xi = xlower + (i-0.5d0)*dx
               q(1,i,j,k) = qtrue(xi,yj,zk,0.d0)
   20    continue

      return
      end

! This routine should be a simplified version of src2
! which applies source terms for a 1-d slice of data along the
! edge of a grid.  This is called only from qad where the conservative
! fix-up is applied and is used to apply source terms over partial
! time steps to the coarse grid cell values used in solving Riemann
! problems at the interface between coarse and fine grids.
subroutine src1d(meqn,mbc,mx1d,q1d,maux,aux1d,t,dt)
      
    use geoclaw_module, only: g => grav, rho, coriolis_forcing, coriolis
    use geoclaw_module, only: friction_forcing, friction_depth
    use geoclaw_module, only: omega, coordinate_system, manning_coefficient
    use geoclaw_module, only: manning_break, num_manning, dry_tolerance, rho_air
    
    use storm_module, only: wind_forcing, pressure_forcing, wind_drag
    use storm_module, only: wind_index, pressure_index
    use storm_module, only: storm_direction, storm_location

    use friction_module, only: variable_friction, friction_index

    implicit none

    ! Input
    integer, intent(in) :: meqn, mbc, mx1d, maux
    real(kind=8), intent(in) :: t, dt
    real(kind=8), intent(inout) :: q1d(meqn, mx1d), aux1d(maux, mx1d)

    ! Local storage
    integer :: i, nman
    logical :: found
    real(kind=8) :: h, hu, hv, gamma, dgamma, y, fdt, a(2,2), coeff, tau
    real(kind=8) :: wind_speed, theta, P_atmos_x, P_atmos_y

    ! Algorithm parameters
    ! Parameter controls when to zero out the momentum at a depth in the
    ! friction source term
    real(kind=8), parameter :: depth_tolerance = 1.0d-30
    
    ! Friction forcing
    if (friction_forcing) then

        do i=1,mx1d

            ! Extract depths
            h = q1d(1,i)
            hu = q1d(2,i)
            hv = q1d(3,i)

            ! If depth is near-zero, set momentum to zero
            if (h < depth_tolerance) then
                q1d(2:3,i) = 0.d0
                cycle 
            endif
            
            ! Apply friction source term only if in shallower water
            if (h <= friction_depth) then
                if (.not.variable_friction) then
                    do nman = num_manning, 1, -1
                        if (aux1d(1,i) .lt. manning_break(nman)) then
                            coeff = manning_coefficient(nman)
                        endif
                    enddo
                else
                    coeff = aux1d(friction_index, i)
                end if

                ! Calculate source term
                gamma = sqrt(hu**2 + hv**2) * (g * coeff**2) / h**(7.d0/3.d0)
                dgamma = 1.d0 + dt * gamma
                q1d(2, i) = q1d(2, i) / dgamma
                q1d(3, i) = q1d(3, i) / dgamma
            endif
        enddo
    endif
    
    ! Only lat-long coordinate system supported here right now
    if (coriolis_forcing .and. coordinate_system == 2) then

        do i=1,mx1d
            ! aux(3,:,:) stores the y coordinates multiplied by deg2rad
            fdt = 2.d0 * omega * sin(aux1d(3,i)) * dt

            ! Calculate matrix components
            a(1,1) = 1.d0 - 0.5d0 * fdt**2 + fdt**4 / 24.d0
            a(1,2) =  fdt - fdt**3 / 6.d0
            a(2,1) = -fdt + fdt**3 / 6.d0
            a(2,2) = a(1,1)
    
            q1d(2,i) = q1d(2,i) * a(1,1) + q1d(3,i) * a(1,2)
            q1d(3,i) = q1d(2,i) * a(2,1) + q1d(3,i) * a(2,2)
        enddo
    endif

    ! = Wind Forcing =========================================================
    if (wind_forcing) then
        ! Cannot use sector based wind mappings here due to lack of information
        ! sloc = storm_location(t)
        ! theta = storm_direction(t)
        do i=1,mx1d
            if (q1d(1,i) > dry_tolerance) then
                wind_speed = sqrt(aux1d(wind_index,i)**2 &
                                + aux1d(wind_index+1,i)**2)
                tau = wind_drag(wind_speed,theta) * rho_air * wind_speed / rho(1)
                q1d(2,i) = q1d(2,i) + dt * tau * aux1d(wind_index,i)
                q1d(3,i) = q1d(3,i) + dt * tau * aux1d(wind_index+1,i)
            endif
        enddo
    endif
    ! ========================================================================
    
    ! == Pressure Forcing ====================================================
    ! Handled in Riemann solver

    ! Need to add dx and dy to calling signature from qad in order for this to 
    ! work, can probably get it from amr_module but need to know which grid we
    ! are working on
    ! if (.false.) then
    !     stop "Not sure how to proceed, need direction and the right dx or dy."
    ! endif

end subroutine src1d

c
c
c     =====================================================
      subroutine bc3(meqn,mbc,mx,my,mz,xlower,
     &               ylower,zlower,dx,dy,dz,q,maux,aux,t,dt,mthbc)
c     =====================================================
c
c     # Standard boundary condition choices for claw3
c
c     # At each boundary  k = 1 (xlower),  2 (xupper), 
c     #                       3 (ylower),  4 (yupper),
c     #                       5 (zlower),  6 (zupper):
c     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
c     #            =  1  for zero-order extrapolation
c     #            =  2  for periodic boundary coniditions
c     #            =  3  for solid walls, assuming this can be implemented
c     #                  by reflecting the data about the boundary and then
c     #                  negating the 2'nd (for k=1,2) or 3'rd (for k=3,4)
c     #                  or 4'th (for k=5,6) component of q.
c     ------------------------------------------------
c
c     # Extend the data from the interior cells (1:mx, 1:my, 1:mz)
c     # to a layer of mbc ghost cells outside the region.
c
      implicit double precision (a-h,o-z)
      dimension    q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension  aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension mthbc(6)

c
c
c-------------------------------------------------------
c     # left boundary (xlower):
c-------------------------------------------------------
      go to (100,110,120,130) mthbc(1)+1
c
  100 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(1)=0 and no BCs specified in bc3'
      stop
      go to 199
c
  110 continue
c     # zero-order extrapolation:
      do 115 m=1,meqn
         do 115 ibc=1,mbc
            do 115 j = 1-mbc, my+mbc
               do 115 k = 1-mbc, mz+mbc
                  q(m,1-ibc,j,k) = q(m,1,j,k)
  115       continue
      go to 199

  120 continue
c     # periodic:  
      do 125 m=1,meqn
         do 125 ibc=1,mbc
            do 125 j = 1-mbc, my+mbc
               do 125 k = 1-mbc, mz+mbc
                  q(m,1-ibc,j,k) = q(m,mx+1-ibc,j,k)
  125       continue
      go to 199

  130 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 135 m=1,meqn
         do 135 ibc=1,mbc
            do 135 j = 1-mbc, my+mbc
               do 135 k = 1-mbc, mz+mbc
                  q(m,1-ibc,j,k) = q(m,ibc,j,k)
  135       continue
c     # negate the normal velocity:
      do 136 ibc=1,mbc
         do 136 j = 1-mbc, my+mbc
            do 136 k = 1-mbc, mz+mbc
               q(2,1-ibc,j,k) = -q(2,ibc,j,k)
  136    continue
      go to 199

  199 continue
c
c-------------------------------------------------------
c     # right boundary (xupper):
c-------------------------------------------------------
      go to (200,210,220,230) mthbc(2)+1
c
  200 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(2)=0 and no BCs specified in bc3'
      stop
      go to 299

  210 continue
c     # zero-order extrapolation:
      do 215 m=1,meqn
         do 215 ibc=1,mbc
            do 215 j = 1-mbc, my+mbc
               do 215 k = 1-mbc, mz+mbc
                  q(m,mx+ibc,j,k) = q(m,mx,j,k)
  215       continue
      go to 299

  220 continue
c     # periodic:  
      do 225 m=1,meqn
         do 225 ibc=1,mbc
            do 225 j = 1-mbc, my+mbc
               do 225 k = 1-mbc, mz+mbc
                  q(m,mx+ibc,j,k) = q(m,ibc,j,k)
  225       continue
      go to 299

  230 continue
c     # solid wall (assumes 2'nd component is velocity or momentum in x):
      do 235 m=1,meqn
         do 235 ibc=1,mbc
            do 235 j = 1-mbc, my+mbc
               do 235 k = 1-mbc, mz+mbc
                  q(m,mx+ibc,j,k) = q(m,mx+1-ibc,j,k)
  235       continue
c     # negate the normal velocity:
      do 236 ibc=1,mbc
         do 236 j = 1-mbc, my+mbc
            do 236 k = 1-mbc, mz+mbc
               q(2,mx+ibc,j,k) = -q(2,mx+1-ibc,j,k)
  236    continue
      go to 299

  299 continue
c
c-------------------------------------------------------
c     # bottom boundary (ylower):
c-------------------------------------------------------
      go to (300,310,320,330) mthbc(3)+1
c
  300 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(3)=0 and no BCs specified in bc3'
      stop
      go to 399
c
  310 continue
c     # zero-order extrapolation:
      do 315 m=1,meqn
         do 315 jbc=1,mbc
            do 315 i = 1-mbc, mx+mbc
               do 315 k = 1-mbc, mz+mbc
                  q(m,i,1-jbc,k) = q(m,i,1,k)
  315       continue
      go to 399

  320 continue
c     # periodic:  
      do 325 m=1,meqn
         do 325 jbc=1,mbc
            do 325 i = 1-mbc, mx+mbc
               do 325 k = 1-mbc, mz+mbc
                  q(m,i,1-jbc,k) = q(m,i,my+1-jbc,k)
  325       continue
      go to 399

  330 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 335 m=1,meqn
         do 335 jbc=1,mbc
            do 335 i = 1-mbc, mx+mbc
               do 335 k = 1-mbc, mz+mbc
                  q(m,i,1-jbc,k) = q(m,i,jbc,k)
  335       continue
c     # negate the normal velocity:
      do 336 jbc=1,mbc
         do 336 i = 1-mbc, mx+mbc
            do 336 k = 1-mbc, mz+mbc
               q(3,i,1-jbc,k) = -q(3,i,jbc,k)
  336    continue
      go to 399

  399 continue
c
c-------------------------------------------------------
c     # top boundary (yupper):
c-------------------------------------------------------
      go to (400,410,420,430) mthbc(4)+1
c
  400 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(4)=0 and no BCs specified in bc3'
      stop
      go to 499

  410 continue
c     # zero-order extrapolation:
      do 415 m=1,meqn
         do 415 jbc=1,mbc
            do 415 i = 1-mbc, mx+mbc
               do 415 k = 1-mbc, mz+mbc
                  q(m,i,my+jbc,k) = q(m,i,my,k)
  415       continue
      go to 499

  420 continue
c     # periodic:  
      do 425 m=1,meqn
         do 425 jbc=1,mbc
            do 425 i = 1-mbc, mx+mbc
               do 425 k = 1-mbc, mz+mbc
                  q(m,i,my+jbc,k) = q(m,i,jbc,k)
  425       continue
      go to 499

  430 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 435 m=1,meqn
         do 435 jbc=1,mbc
            do 435 i = 1-mbc, mx+mbc
               do 435 k = 1-mbc, mz+mbc
                  q(m,i,my+jbc,k) = q(m,i,my+1-jbc,k)
  435       continue
c     # negate the normal velocity:
      do 436 jbc=1,mbc
         do 436 i = 1-mbc, mx+mbc
            do 436 k = 1-mbc, mz+mbc
               q(3,i,my+jbc,k) = -q(3,i,my+1-jbc,k)
  436    continue
      go to 499

  499 continue

c
c-------------------------------------------------------
c     # boundary (zlower):
c-------------------------------------------------------
      go to (500,510,520,530) mthbc(5)+1
c
  500 continue
c     # user-specified boundary conditions go here in place of error output
      write(6,*) '*** ERROR *** mthbc(5)=0 and no BCs specified in bc3'
      stop
      go to 599
c
  510 continue
c     # zero-order extrapolation:
      do 515 m=1,meqn
         do 515 kbc=1,mbc
            do 515 i = 1-mbc, mx+mbc
               do 515 j = 1-mbc, my+mbc
                  q(m,i,j,1-kbc) = q(m,i,j,1)
  515       continue
      go to 599

  520 continue
c     # periodic:  
      do 525 m=1,meqn
         do 525 kbc=1,mbc
            do 525 i = 1-mbc, mx+mbc
               do 525 j = 1-mbc, my+mbc
                  q(m,i,j,1-kbc) = q(m,i,j,mz+1-kbc)
  525       continue
      go to 599

  530 continue
c     # solid wall (assumes 4'rd component is velocity or momentum in y):
      do 535 m=1,meqn
         do 535 kbc=1,mbc
            do 535 i = 1-mbc, mx+mbc
               do 535 j = 1-mbc, my+mbc
                  q(m,i,j,1-kbc) = q(m,i,j,kbc)
  535       continue
c     # negate the normal velocity:
      do 536 kbc=1,mbc
         do 536 i = 1-mbc, mx+mbc
            do 536 j = 1-mbc, my+mbc
               q(4,i,j,1-kbc) = -q(4,i,j,kbc)
  536    continue
      go to 599

  599 continue
c
c-------------------------------------------------------
c     # boundary (zupper):
c-------------------------------------------------------
      go to (600,610,620,630) mthbc(6)+1
c
  600 continue
c     # user-specified boundary conditions go here in place of error output
c     write(6,*) '*** ERROR *** mthbc(6)=0 and no BCs specified in bc3'
c     stop
c     # solid wall with piston in center
      do 605 m=1,meqn
         do 605 kbc=1,mbc
            do 605 i = 1-mbc, mx+mbc
               do 605 j = 1-mbc, my+mbc
                  q(m,i,j,mz+kbc) = q(m,i,j,mz+1-kbc)
  605       continue
c     # negate the normal velocity:
      do 606 kbc=1,mbc
         do 606 i = 1-mbc, mx+mbc
            do 606 j = 1-mbc, my+mbc
               if (t .lt. 0.1d0) then
            	   xi = xlower + (i-0.5d0)*dx
            	   yj = ylower + (j-0.5d0)*dy
                   r2 = (xi**2 + yj**2)
            	   s = -dexp(-500.d0*r2)*dexp(-500*t**2)
c                  write(27,271) t,i,j,r2,s
c 271              format(d16.6,2i5,2d16.6)
            	   if (dabs(s).lt.1d-6) s = 0.d0
            	 else
            	   s = 0.d0
            	 endif
               q(4,i,j,mz+kbc) = 2.d0*s - q(4,i,j,mz+1-kbc)
  606    continue
      go to 699

  610 continue
c     # zero-order extrapolation:
      do 615 m=1,meqn
         do 615 kbc=1,mbc
            do 615 i = 1-mbc, mx+mbc
               do 615 j = 1-mbc, my+mbc
                  q(m,i,j,mz+kbc) = q(m,i,j,mz)
  615       continue
      go to 699

  620 continue
c     # periodic:  
      do 625 m=1,meqn
         do 625 kbc=1,mbc
            do 625 i = 1-mbc, mx+mbc
               do 625 j = 1-mbc, my+mbc
                  q(m,i,j,mz+kbc) = q(m,i,j,kbc)
  625       continue
      go to 699

  630 continue
c     # solid wall (assumes 3'rd component is velocity or momentum in y):
      do 635 m=1,meqn
         do 635 kbc=1,mbc
            do 635 i = 1-mbc, mx+mbc
               do 635 j = 1-mbc, my+mbc
                  q(m,i,j,mz+kbc) = q(m,i,j,mz+1-kbc)
  635       continue
c     # negate the normal velocity:
      do 636 kbc=1,mbc
         do 636 i = 1-mbc, mx+mbc
            do 636 j = 1-mbc, my+mbc
               q(4,i,j,mz+kbc) = -q(4,i,j,mz+1-kbc)
  636    continue
      go to 699

  699 continue

      return
      end

! =====================================================
double precision function philim(a,b,meth)
! =====================================================
    implicit double precision (a-h,o-z)

! Compute a limiter based on wave strengths a and b.
! meth determines what limiter is used.
! a is assumed to be nonzero.

! NOTE: This routine is obsolete.  Instead of using limiter.f,
! which calls philim.f for every wave, it is more efficient to
! use inlinelimiter.f, which eliminates all these function calls
! to philim.  If you wish to change the limiter function and are
! using inlinelimiter.f, the formulas must be changed in that routine.

    r = b/a
    select case (meth)

    case (1) ! minmod
        philim = dmax1(0.d0, dmin1(1.d0, r))

    case (2) ! superbee
        philim = dmax1(0.d0, dmin1(1.d0, 2.d0*r), dmin1(2.d0, r))

    case (3) ! van Leer
        philim = (r + dabs(r)) / (1.d0 + dabs(r))

    case (4) ! monotonized centered
        c = (1.d0 + r)/2.d0
        philim = dmax1(0.d0, dmin1(c, 2.d0, 2.d0*r))

    case (5) ! Beam-Warming
        philim = r

    end select
    return
end function

! :::::::::: bc1amr ::::::::::::::::::::::::::::::::::::::::::::::;
!
!     Take a grid patch with mesh width hx of dimensions nrow
!     and set the values of any piece of
!     of the patch which extends outside the physical domain 
!     using the boundary conditions. 
!
!     ------------------------------------------------
!     # Standard boundary condition choices for amr in clawpack
!
!     # At each boundary  k = 1 (left),  2 (right):
!     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
!     #            =  1  for zero-order extrapolation
!     #            =  2  for periodic boundary conditions
!     #            =  3  for solid walls, assuming this can be implemented
!     #                  by reflecting the data about the boundary and then
!     #                  negating the 2'nd (for k=1,2) component of q.
!     #            =  5  sphere bcs (left half maps to right half of same 
!     #                  side, and vice versa), as if domain folded in half
!     ------------------------------------------------
!
!     The edges of the grid patch are at
!        xlo_patch  -- left edge
!        xhi_patch --  right edge
!
!     The physical domain itself is a rectangle bounded by
!        xlower  -- left edge
!        xupper  -- right edge
!     
!     the picture is the following: 
!            (xlower)                    (xupper)
!        |______|_________|_________________|
!        |      |         |                 |
!   (xlo_patch)       (xhi_patch)
!        
!
!     Any cells that lie outside the physical domain are ghost cells whose
!     values should be set in this routine.  This is tested for by comparing
!     xlo_patch with xlower to see if values need to be set at the left, as in
!     the figure above, and similarly at the other boundary.
!
!     Patches are guaranteed to have at least 1 row of cells filled
!     with interior values so it is possible to  extrapolate. 
!     Fix trimbd if you want more than 1 row pre-set.
!
!     Make sure the order the boundaries are specified is correct
!     so that diagonal corner cells are also properly taken care of.
!
!     Periodic boundaries are set before calling this routine, so if the
!     domain is periodic in one direction only you
!     can safely extrapolate in the other direction. 
!
!     Don't overwrite ghost cells in periodic directions!
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

subroutine bc1amr(val, aux, nrow, meqn,naux, hx, level, time,           &
                  xlo_patch, xhi_patch) 

    use amr_module, only: mthbc, xlower, xupper
    use amr_module, only: xperdom

    implicit none

    ! Input/Output
    integer, intent(in) :: nrow, meqn, naux, level
    real(kind=8), intent(in) :: hx, time
    real(kind=8), intent(in) :: xlo_patch, xhi_patch
    real(kind=8), intent(in out) :: val(meqn, nrow)
    real(kind=8), intent(in out) :: aux(naux, nrow)
    
    ! Local storage
    integer :: i, ibeg, nxl, nxr
    real(kind=8) :: hxmarg

    hxmarg = hx * .01d0

    ! Use periodic boundary condition specialized code only, if only one 
    ! boundary is periodic we still proceed below
    if (xperdom) then
        return
    end if

    ! Each check has an initial check to ensure that the boundary is a real
    ! boundary condition and otherwise skips the code.  Otherwise 
    !-------------------------------------------------------
    ! Left boundary:
    !-------------------------------------------------------
    if (xlo_patch < xlower-hxmarg) then
        ! number of grid cells from this patch lying outside physical domain:
        nxl = int((xlower + hxmarg - xlo_patch) / hx)

        select case(mthbc(1))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."
            case(1) ! Zero-order extrapolation
                do i=1, nxl
                    val(:, i) = val(:, nxl + 1)
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do i=1, nxl
                    aux(:, i) = aux(:, 2 * nxl + 1 - i)
                    val(:, i) = val(:, 2 * nxl + 1 - i)
                end do
                ! negate the normal velocity:
                do i=1, nxl
                    val(2, i) = -val(2, i)
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop
        end select
    end if

    !-------------------------------------------------------
    ! Right boundary:
    !-------------------------------------------------------
    if (xhi_patch > xupper+hxmarg) then

        ! number of grid cells lying outside physical domain:
        nxr = int((xhi_patch - xupper + hxmarg) / hx)
        ibeg = max(nrow - nxr + 1, 1)

        select case(mthbc(2))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."
            case(1) ! Zero-order extrapolation
                do i = ibeg, nrow
                    val(:, i) = val(:, ibeg - 1)
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do i=ibeg, nrow
                    val(:, i) = val(:, 2 * ibeg - 1 - i)
                end do
                ! negate the normal velocity:
                do i = ibeg, nrow
                    val(2, i) = -val(2, i)
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

end subroutine bc1amr

subroutine setaux(mbc,mx,my,mz,xlower,ylower,zlower,dx,dy,dz,maux,aux)

    ! Called at start of computation before calling qinit, and
    ! when AMR is used, also called every time a new grid patch is created.
    ! Use to set auxiliary arrays 
    !   aux(1:maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc).
    ! Note that ghost cell values may need to be set if the aux arrays
    ! are used by the Riemann solver(s).
    !
    ! This default version does nothing. 
 
    implicit none
    integer, intent(in) :: mbc,mx,my,mz,maux
    real(kind=8), intent(in) :: xlower,ylower,zlower,dx,dy,dz
    real(kind=8), intent(out) ::  aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

end subroutine setaux

c
c =======================================================================
      subroutine outval(val,nvar,mitot,mjtot,mktot,mptr,outgrd,naux,aux)
c =======================================================================
c
      use amr_module
      implicit double precision (a-h,o-z)

      dimension  val(nvar,mitot,mjtot,mktot)
      dimension  aux(naux,mitot,mjtot,mktot)
      logical    outgrd


c ::::::::::::::::::::::OUTVAL :::::::::::::::::::::::::::::::
c print solution and aux. variables to output. 
c if cell outside domain, don't print soln. value - nothing
c currently in ghost cells.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      if (.not. outgrd) go to 99
      level = node(nestlevel,mptr)
      hx    = hxposs(level)
      hy    = hyposs(level)
      hz    = hzposs(level)
      cornx = rnode(cornxlo,mptr) - nghost*hx
      corny = rnode(cornylo,mptr) - nghost*hy
      cornz = rnode(cornzlo,mptr) - nghost*hz
c
      do 30 k=nghost+1,mktot-nghost
      do 25 j=nghost+1,mjtot-nghost
      do 20 i=nghost+1,mitot-nghost

         x  = cornx + hx*(dble(i)-.5d0)
         y  = corny + hy*(dble(j)-.5d0)
         z  = cornz + hz*(dble(k)-.5d0)
         write(outunit,107) x,y,z,i,j,k,(val(ivar,i,j,k),ivar=1,nvar)
 107     format(2hx=,f7.3,3h y=,f7.3,3h z=,f7.3,
     *          4h, i=,i3,4h, j=,i3 ,4h, k=,i3 ,
     *          ' a= ',5(e11.4,1x))
         if (naux.gt.0) write(outunit,108) (aux(iaux,i,j,k),iaux=1,naux)
 108     format(1x,'aux = ',7(e10.3,1x))

 20   continue
 25   continue
 30   continue

 99   return
      end

c     ==================================================================
      subroutine setaux(mbc,mx,my,mz,xlower,ylower,zlower,
     &                  dx,dy,dz,maux,aux)
c     ==================================================================
c
c     # set auxiliary arrays
c
c     # advection
c     #    aux(i,j,k,1) is u velocity on left face of cell
c     #    aux(i,j,k,2) is v velocity on bottom face of cell
c     #    aux(i,j,k,3) is w velocity on back face of cell
c
c
      implicit none

      integer  mx, my, mz, mbc, maux, i,j,k
      double precision xlower, ylower, zlower, dx, dy, dz
      double precision aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      double precision ubar, vbar, wbar

      common /cparam/ ubar,vbar,wbar

c

      do  k = 1-mbc,mz+mbc
         do j = 1-mbc,my+mbc
            do i = 1-mbc,mx+mbc
               aux(1,i,j,k) = ubar
               aux(2,i,j,k) = vbar
               aux(3,i,j,k) = wbar
            enddo
         enddo
      enddo

      return
      end

c
c --------------------------------------------------------------------
c
       subroutine signs(badpts,npts,iscr,idim,ist,iend,
     &                  ilo,ihi)
c
       implicit double precision (a-h,o-z)
       dimension badpts(1,npts)
       dimension iscr(idim)
c
c :::::::::::::::::::::::::::: SIGNS ::::::::::::::::::::::::::::::
c  compute signatures = number of flagged cells in each row/column.
c  also return first and last nonzero row/column, so don't have
c  to waste time over entire region.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
       ilo= 1
       ihi= idim
       do 10 i = 1, idim
 10       iscr(i) = 0
c
c count all flagged points in a given row in one pass through
c the points, i.e. a bin count
c
       do 20 ipt = ist, iend
          iloc  =  badpts(1,ipt)+1.1
          iscr(iloc) = iscr(iloc)+1
 20    continue
c
       do 30 ipt = 1, idim
         if (iscr(ipt) .ne. 0) then
            ilo = ipt
            go to 40
         endif
 30    continue
 40    do 50 ipt = 1, idim
          if (iscr(idim+1-ipt) .ne. 0) then
             ihi = idim+1-ipt
             go to 99
          endif
 50    continue

 99    return
       end

c
c -----------------------------------------------------------------------
c
       subroutine setIndices(ist,iend,ilo,ihi,
     &                       ishift,level)

       use amr_module
       implicit double precision (a-h,o-z)

       dimension ist(3), iend(3), ishift(3)

c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c  setIndices:  for periodicity a region that sticks out is wrapped into
c               another region.
c
c  this is just annoying code this is needed in several places so it became a routine
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::


       ist(1) = ilo
       ist(2) = 0
       ist(3) = iregsz(level)

       iend(1) = -1
       iend(2) = iregsz(level)-1
       iend(3) = ihi

       if (xperdom) then ! regions that stick out of domain get periodically wrapped indices
          ishift(1) = iregsz(level)
          ishift(2) = 0
          ishift(3) = -iregsz(level)
       else   ! no shifting of indices
          ishift(1) = 0
          ishift(2) = 0
          ishift(3) = 0
       endif


       return
       end

c
c
c
c
c     =================================================
      subroutine cellave(xlow,ylow,dx,dy,wl)
c     =================================================
      implicit double precision (a-h,o-z)
      external fss
      logical fl(5),alll,allr
      dimension x(10),y(10),xx(5),yy(5)
      common/fsscorn/ xc0,yc0,xc1,yc1
c   
c     # compute wl, fraction of cell that lies in left state.
c     # For initial data with two states ql and qr separated by a 
c     # discontinuity. The curve along which the discontinuity lies is
c     # specified by the function fdisc, which should return a value that
c     # is negative on the side where ql lies and positive on the qr side.
c
c     # xlow,ylow is the coordinate of the lower left corner of the cell.
c     # dx, dy are grid spacing in x and y.
c
      xx(1) = xlow
      xx(2) = xlow
      xx(3) = xlow+dx
      xx(4) = xlow+dx
      xx(5) = xx(1)
      yy(1) = ylow
      yy(2) = ylow+dy
      yy(3) = ylow+dy
      yy(4) = ylow
      yy(5) = yy(1)
      alll = .true.
      allr = .true.
c
      do 20 i=1,4
         fl(i) = fdisc(xx(i),yy(i)) .lt. 0.d0
         alll = alll .and. fl(i)
         allr = allr .and. (.not. fl(i))
   20    continue
      fl(5) = fl(1)
c
      if (alll) then
         wl = 1.d0
         return
         endif
      if (allr) then
         wl = 0.d0
         return
         endif
c
      iv = 0
      do 40 i=1,4
          if (fl(i)) then
               iv = iv+1
               x(iv) = xx(i)
               y(iv) = yy(i)
               endif
          if (fl(i).neqv.fl(i+1)) then
               iv = iv+1
               xc0 = xx(i)
               yc0 = yy(i)
               xc1 = xx(i+1)
               yc1 = yy(i+1)
               ss = zeroin(0.d0, 1.d0, fss, 1d-8)
c              write(27,*) 'xc,yc,ss:',xc0,yc0,xc1,yc1,ss
               x(iv) = xx(i) + ss*(xx(i+1)-xx(i))
               y(iv) = yy(i) + ss*(yy(i+1)-yy(i))
               endif
   40     continue
c
c     # compute area:
c
      if (iv.eq.0) then
         wl = 0.d0
         return
         endif
c
      x(iv+1) = x(1)
      y(iv+1) = y(1)
      area = 0.d0
      do 50 i=1,iv
         area = area + .5d0*(y(i)+y(i+1))*(x(i+1)-x(i))
c        write(27,*) '  x,y:',x(i),y(i)
   50    continue
c
      wl = area / (dx*dy)
c     write(27,*) 'area,wl:',area,wl
c
      return
      end
c
c
c
c
c
c     =================================================
      function fss(s)
c     =================================================
      implicit double precision (a-h,o-z)
      common/fsscorn/ xc0,yc0,xc1,yc1
c   
c     # compute fdisc at distance s between corners (xc0,yc0) and (xc1,yc1)
c
      x = xc0 + s*(xc1-xc0)
      y = yc0 + s*(yc1-yc0)
      fss = fdisc(x,y)
      return
      end
c
c
c
c     =================================================
      function zeroin(ax,bx,f,tol)                                         
c     =================================================
      implicit double precision (a-h,o-z)
      external f
c         
c      a zero of the function  f(x)  is computed in the interval ax,bx .        
c      (Standard routine from netlib)
c         
c  input..
c         
c  ax     left endpoint of initial interval       
c  bx     right endpoint of initial interval      
c  f      function subprogram which evaluates f(x) for any x in       
c         the interval  ax,bx 
c  tol    desired length of the interval of uncertainty of the        
c         final result ( .ge. 0.d0)      
c         
c         
c  output..         
c         
c  zeroin abcissa approximating a zero of  f  in the interval ax,bx   
c         
c         
c      it is assumed  that   f(ax)   and   f(bx)   have  opposite  signs
c  without  a  check.  zeroin  returns a zero  x  in the given interval 
c  ax,bx  to within a tolerance  4*macheps*dabs(x) + tol, where macheps
c  is the relative machine precision.   
c
c      this function subprogram is a slightly  modified  translation  of
c  the algol 60 procedure  zero  given in  richard brent, algorithms for
c  minimization without derivatives, prentice - hall, inc. (1973).    
c         
c         
c         
c  compute eps, the relative machine precision    
c         
      eps = 1.d0     
   10 eps = eps/2.d0 
      tol1 = 1.d0 + eps        
      if (tol1 .gt. 1.d0) go to 10       
c         
c initialization    
c         
      a = ax        
      b = bx        
      fa = f(a)     
      fb = f(b)     
c         
c begin step        
c         
   20 c = a         
      fc = fa       
      d = b - a     
      e = d         
   30 if (dabs(fc) .ge. dabs(fb)) go to 40
      a = b         
      b = c         
      c = a         
      fa = fb       
      fb = fc       
      fc = fa       
c         
c convergence test  
c         
   40 tol1 = 2.d0*eps*dabs(b) + 0.5*tol   
      xm = .5*(c - b)         
      if (dabs(xm) .le. tol1) go to 90   
      if (fb .eq. 0.d0) go to 90         
c         
c is bisection necessary      
c         
      if (dabs(e) .lt. tol1) go to 70    
      if (dabs(fa) .le. dabs(fb)) go to 70
c         
c is quadratic interpolation possible   
c         
      if (a .ne. c) go to 50  
c         
c linear interpolation        
c         
      s = fb/fa     
      p = 2.d0*xm*s  
      q = 1.d0 - s   
      go to 60      
c         
c inverse quadratic interpolation       
c         
   50 q = fa/fc     
      r = fb/fc     
      s = fb/fa     
      p = s*(2.d0*xm*q*(q - r) - (b - a)*(r - 1.d0))
      q = (q - 1.d0)*(r - 1.d0)*(s - 1.d0) 
c         
c adjust signs      
c         
   60 if (p .gt. 0.d0) q = -q  
      p = dabs(p)    
c         
c is interpolation acceptable 
c         
      if ((2.d0*p) .ge. (3.d0*xm*q - dabs(tol1*q))) go to 70   
      if (p .ge. dabs(0.5*e*q)) go to 70 
      e = d         
      d = p/q       
      go to 80      
c         
c bisection         
c         
   70 d = xm        
      e = d         
c         
c complete step     
c         
   80 a = b         
      fa = fb       
      if (dabs(d) .gt. tol1) b = b + d   
      if (dabs(d) .le. tol1) b = b + dsign(tol1, xm)
      fb = f(b)     
      if ((fb*(fc/dabs(fc))) .gt. 0.d0) go to 20    
      go to 30      
c         
c done    
c         
   90 zeroin = b    
      return        
      end 

c
c --------------------------------------------------------------------
c
       subroutine signs(badpts,npts,iscr,jscr,kscr,idim,jdim,kdim,
     &                  ist,iend,ilo,ihi,jlo,jhi,klo,khi)
c
      use amr_module
      implicit double precision (a-h,o-z)

 
      dimension badpts(3,npts)
      dimension iscr(idim), jscr(jdim), kscr(kdim)
c
c :::::::::::::::::::::::::::: SIGNS ::::::::::::::::::::::::::::::
c  compute signatures = number of flagged cells in each row/column.
c  also return first and last nonzero row/column, so dont have
c  to waste time over entire region.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
       ilo  =  1
       ihi  =  idim
       jlo  =  1
       jhi  =  jdim
       klo  =  1
       khi  =  kdim
c
       do  5 i = 1, idim
  5       iscr(i) = 0
       do 10 j = 1, jdim
 10       jscr(j) = 0
       do 15 k = 1, kdim
 15       kscr(k) = 0
c
c count all flagged points in a given row/column/file in one pass through
c the points, i.e. a bin count
c
       do 20 ipt = ist, iend
          iloc  =  badpts(1,ipt)+1.1
          jloc  =  badpts(2,ipt)+1.1
          kloc  =  badpts(3,ipt)+1.1
          iscr(iloc) = iscr(iloc)+1
          jscr(jloc) = jscr(jloc)+1
          kscr(kloc) = kscr(kloc)+1
 20    continue
c
       do 30 ipt = 1, idim
         if (iscr(ipt) .ne. 0) then
            ilo = ipt
            go to 40
         endif
 30    continue
 40    do 50 ipt = 1, idim
          if (iscr(idim+1-ipt) .ne. 0) then
             ihi = idim+1-ipt
             go to 60
          endif
 50    continue

 60    do 70 ipt = 1, jdim
          if (jscr(ipt) .ne. 0) then
             jlo = ipt
             go to 80
          endif
 70    continue
 80    do 90 ipt = 1, jdim
          if (jscr(jdim+1-ipt) .ne. 0) then
             jhi = jdim+1-ipt
             go to 100
          endif
 90    continue

100    do 110 ipt = 1, kdim
          if (kscr(ipt) .ne. 0) then
             klo = ipt
             go to 120
          endif
110    continue
120    do 130 ipt = 1, kdim
          if (kscr(kdim+1-ipt) .ne. 0) then
             khi = kdim+1-ipt
             go to 199
          endif
130    continue

199    return
       end

! =====================================================
subroutine limiter(maxm,num_eqn,num_waves,num_ghost,mx,wave,s,mthlim)
! =====================================================

! Apply a limiter to the waves.
! The limiter is computed by comparing the 2-norm of each wave with
! the projection of the wave from the interface to the left or
! right onto the current wave.  For a linear system this would
! correspond to comparing the norms of the two waves.  For a
! nonlinear problem the eigenvectors are not colinear and so the
! projection is needed to provide more limiting in the case where the
! neighboring wave has large norm but points in a different direction
! in phase space.

! The specific limiter used in each family is determined by the
! value of the corresponding element of the array mthlim, as used in
! the function philim.
! Note that a different limiter may be used in each wave family.

! dotl and dotr denote the inner product of wave with the wave to
! the left or right.  The norm of the projections onto the wave are then
! given by dotl/wnorm2 and dotr/wnorm2, where wnorm2 is the 2-norm
! of wave.

    implicit double precision (a-h,o-z)
    dimension mthlim(num_waves)
    dimension wave(num_eqn, num_waves,1-num_ghost:maxm+num_ghost)
    dimension    s(num_waves,1-num_ghost:maxm+num_ghost)

    do mw=1,num_waves
        if (mthlim(mw) == 0) cycle
        dotr = 0.d0
        do i = 0, mx+1
            wnorm2 = 0.d0
            dotl = dotr
            dotr = 0.d0
            do m=1,num_eqn
                wnorm2 = wnorm2 + wave(m,mw,i)**2
                dotr = dotr + wave(m,mw,i)*wave(m,mw,i+1)
            end do
            if (i == 0) cycle
            if (wnorm2 == 0.d0) cycle
        
            if (s(mw,i) > 0.d0) then
                wlimitr = philim(wnorm2, dotl, mthlim(mw))
            else
                wlimitr = philim(wnorm2, dotr, mthlim(mw))
            endif
        
            do m=1,num_eqn
                wave(m,mw,i) = wlimitr * wave(m,mw,i)
            end do
        end do
    end do

    return
end subroutine limiter

module qinit_module

    implicit none
    save

    logical, private :: module_setup = .false.
    
    ! Type of q initialization
    integer, public :: qinit_type

    integer, public :: min_level_qinit
    integer, public :: max_level_qinit

    ! Geometry
    real(kind=8), public :: x_low_qinit
    real(kind=8), public :: y_low_qinit
    real(kind=8), public :: t_low_qinit
    real(kind=8), public :: x_hi_qinit
    real(kind=8), public :: y_hi_qinit
    real(kind=8), public :: t_hi_qinit
    real(kind=8), public :: dx_qinit
    real(kind=8), public :: dy_qinit
    
    ! Work array
    real(kind=8), private, allocatable :: qinit(:)

    integer, private :: mx_qinit
    integer, private :: my_qinit

    ! Specifc types of intialization    
    ! Type of perturbation to add
    integer, private :: wave_family
    real(kind=8), private :: init_location(2), epsilon
    real(kind=8), private :: angle, sigma

contains

    subroutine set_qinit(fname)
    
        use geoclaw_module, only: GEO_PARM_UNIT
    
        implicit none
        
        ! Subroutine arguments
        character(len=*), optional, intent(in) :: fname
        
        ! File handling
        character(len=150) :: qinit_fname
        integer, parameter :: unit = 7
        character(len=150) :: x
        
        if (.not.module_setup) then

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'SETQINIT:'
            write(GEO_PARM_UNIT,*) '-------------'
            
            ! Open the data file
            if (present(fname)) then
                call opendatafile(unit,fname)
            else
                call opendatafile(unit,"qinit.data")
            endif
            
            read(unit,"(i1)") qinit_type
            if (qinit_type == 0) then
                ! No perturbation specified
                write(GEO_PARM_UNIT,*)  '  qinit_type = 0, no perturbation'
                print *,'  qinit_type = 0, no perturbation'
                return
            else if (qinit_type > 0 .and. qinit_type < 5) then
                read(unit,*) qinit_fname
                read(unit,"(2i2)") min_level_qinit, max_level_qinit

                write(GEO_PARM_UNIT,*) '   min_level, max_level, qinit_fname:'
                write(GEO_PARM_UNIT,*)  min_level_qinit, max_level_qinit, qinit_fname
                
                call read_qinit(qinit_fname)
            else if (qinit_type >= 5) then
                read(unit,*) epsilon
                read(unit,*) init_location
                read(unit,*) wave_family
                read(unit,*) angle
                read(unit,*) sigma

                write(GEO_PARM_UNIT,*) " epsilon = ",  epsilon
                write(GEO_PARM_UNIT,*) " init_location = ",  init_location
                write(GEO_PARM_UNIT,*) " wave_family = ",  wave_family
                write(GEO_PARM_UNIT,*) " angle = ",  angle
                write(GEO_PARM_UNIT,*) " sigma = ",  sigma
            endif

            close(unit)

            module_setup = .true.
        end if

    end subroutine set_qinit



    subroutine add_perturbation(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    
        use geoclaw_module, only: sea_level, pi, g => grav, rho
        use multilayer_module, only: aux_layer_index, r, eta_init
    
        implicit none
    
        ! Subroutine arguments
        integer, intent(in) :: meqn,mbc,mx,my,maux
        real(kind=8), intent(in) :: xlower,ylower,dx,dy
        real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
        
        ! Local
        integer :: i,j
        real(kind=8) :: ximc,xim,x,xc,xip,xipc,yjmc,yjm,y,yc,yjp,yjpc,dq

        real(kind=8) :: xmid,m,x_c,y_c, effective_b
        real(kind=8) :: eigen_vector(6),gamma,lambda,alpha,h_1,h_2,deta
        
        ! Topography integral function
        real(kind=8) :: topointegral

        if (qinit_type == 4) then
            do i = 1-mbc, mx+mbc
                x = xlower + (i - 0.5d0)*dx
                xim = x - 0.5d0 * dx
                xip = x + 0.5d0 * dx
                do j = 1-mbc, my+mbc
                    y = ylower + (j - 0.5d0) * dy
                    yjm = y - 0.5d0 * dy
                    yjp = y + 0.5d0 * dy

                    ! Check to see if we are in the qinit region at this grid point
                    if ((xip > x_low_qinit).and.(xim < x_hi_qinit).and.  &
                        (yjp > y_low_qinit).and.(yjm < y_hi_qinit)) then

                        xipc = min(xip, x_hi_qinit)
                        ximc = max(xim, x_low_qinit)

                        yjpc=min(yjp,y_hi_qinit)
                        yjmc=max(yjm,y_low_qinit)

                        dq = topointegral(ximc,xipc,yjmc,yjpc,x_low_qinit, &
                                          y_low_qinit,dx_qinit,dy_qinit,mx_qinit, &
                                          my_qinit,qinit,1)
                        dq = dq / ((xipc-ximc)*(yjpc-yjmc))

                        effective_b = max(aux(1,i,j), eta_init(2))
                        q(1,i,j) = max((dq-effective_b) * rho(1),0.d0)
                    endif
                enddo
            enddo

        else if (qinit_type > 4) then
            do i=1,mx
                x = xlower + (i - 0.5d0) * dx
                do j=1,my
                    y = ylower + (j - 0.5d0) * dy
                    
                    ! Test perturbations - these only work in the x-direction
                    if (qinit_type == 5 .or. qinit_type == 6) then
                        ! Calculate wave family for perturbation
                        gamma = aux(aux_layer_index+1,i,j) / aux(aux_layer_index,i,j)
                        select case(wave_family)
                            case(1) ! Shallow water, left-going
                                alpha = 0.5d0 * (gamma - 1.d0 + sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                                lambda = -sqrt(g*aux(aux_layer_index,i,j)*(1.d0+alpha))
                            case(2) ! Internal wave, left-going
                                alpha = 0.5d0 * (gamma - 1.d0 - sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                                lambda = -sqrt(g*aux(aux_layer_index,i,j)*(1.d0+alpha))
                            case(3) ! Internal wave, right-going
                                alpha = 0.5d0 * (gamma - 1.d0 - sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                                lambda = sqrt(g*aux(aux_layer_index,i,j)*(1.d0+alpha))
                            case(4) ! Shallow water, right-going
                                alpha = 0.5d0 * (gamma - 1.d0 + sqrt((gamma-1.d0)**2+4.d0*r*gamma))
                                lambda = sqrt(g*aux(aux_layer_index,i,j)*(1.d0+alpha))
                        end select
                        eigen_vector = [1.d0,lambda,0.d0,alpha,lambda*alpha,0.d0]

                        if (qinit_type == 5) then
                            ! Add perturbation
                            if ((x < init_location(1)).and.(wave_family >= 3)) then
                                q(1:3,i,j) = q(1:3,i,j) + rho(1) * epsilon * eigen_vector(1:3)
                                q(4:6,i,j) = q(4:6,i,j) + rho(2) * epsilon * eigen_vector(4:6)
                            else if ((x > init_location(1)).and.(wave_family < 3)) then
                                q(1:2,i,j) = q(1:2,i,j) + rho(1) * epsilon * eigen_vector(1:2)
                                q(4:5,i,j) = q(4:5,i,j) + rho(2) * epsilon * eigen_vector(4:5)
                            endif
                        ! Gaussian wave along a direction on requested wave family
                        else if (qinit_type == 6) then
                            ! Transform back to computational coordinates
                            x_c = x * cos(angle) + y * sin(angle) - init_location(1)
                            deta = epsilon * exp(-(x_c/sigma)**2)
                            q(1,i,j) = q(1,i,j) + rho(1) * deta
                            q(4,i,j) = q(4,i,j) + rho(2) * alpha * deta
                        endif
                    ! Symmetric gaussian hump
                    else if (qinit_type == 7) then
                        deta = epsilon * exp(-((x-init_location(1))/sigma)**2)  &
                                       * exp(-((y-init_location(2))/sigma)**2)
                        q(1,i,j) = q(1,i,j) + rho(1) * deta
                    ! Shelf conditions from AN paper
                    else if (qinit_type == 8) then
                        alpha = 0.d0
                        xmid = 0.5d0*(-180.e3 - 80.e3)
                        if ((x > -130.e3).and.(x < -80.e3)) then
                            deta = epsilon * sin((x-xmid)*pi/(-80.e3-xmid))
                            q(4,i,j) = q(4,i,j) + rho(2) * alpha * deta
                            q(1,i,j) = q(1,i,j) + rho(1) * deta * (1.d0 - alpha)
                        endif
                    ! Inundation test
                    else if (qinit_type == 9) then
                        x_c = (x - init_location(1)) * cos(angle) &
                            + (y - init_location(2)) * sin(angle)
                        deta = epsilon * exp(-(x_c/sigma)**2)
                        q(1,i,j) = q(1,i,j) + rho(1) * deta
                    endif
                enddo
            enddo

        endif
        
    end subroutine add_perturbation

        
    ! currently only supports one file type:
    ! x,y,z values, one per line in standard order from NW corner to SE
    ! z is perturbation from standard depth h,hu,hv set in qinit_geo,
    ! if iqinit = 1,2, or 3 respectively.
    ! if iqinit = 4, the z column corresponds to the definition of the 
    ! surface elevation eta. The depth is then set as q(i,j,1)=max(eta-b,0)
    subroutine read_qinit(fname)
    
        use geoclaw_module, only: GEO_PARM_UNIT
        
        implicit none
        
        ! Subroutine arguments
        character(len=150) :: fname
        
        ! Data file opening
        integer, parameter :: unit = 19
        integer :: i,num_points,status
        double precision :: x,y
        
        print *,'  '
        print *,'Reading qinit data from file  ', fname
        print *,'  '

        write(GEO_PARM_UNIT,*) '  '
        write(GEO_PARM_UNIT,*) 'Reading qinit data from'
        write(GEO_PARM_UNIT,*) fname
        write(GEO_PARM_UNIT,*) '  '
        
        open(unit=unit, file=fname, iostat=status, status="unknown", &
             form='formatted',action="read")
        if ( status /= 0 ) then
            print *,"Error opening file", fname
            stop
        endif
        
        ! Initialize counters
        num_points = 0
        mx_qinit = 0
        
        ! Read in first values, determines x_low and y_hi
        read(unit,*) x_low_qinit,y_hi_qinit
        num_points = num_points + 1
        mx_qinit = mx_qinit + 1
        
        ! Sweep through first row figuring out mx
        y = y_hi_qinit
        do while (y_hi_qinit == y)
            read(unit,*) x,y
            num_points = num_points + 1
            mx_qinit = mx_qinit + 1
        enddo
        ! We over count by one in the above loop
        mx_qinit = mx_qinit - 1
        
        ! Continue to count the rest of the lines
        do
            read(unit,*,iostat=status) x,y
            if (status /= 0) exit
            num_points = num_points + 1
        enddo
        if (status > 0) then
            print *,"ERROR:  Error reading qinit file ",fname
            stop
        endif
        
        ! Extract rest of geometry
        x_hi_qinit = x
        y_low_qinit = y
        my_qinit = num_points / mx_qinit
        dx_qinit = (x_hi_qinit - x_low_qinit) / (mx_qinit-1)
        dy_qinit = (y_hi_qinit - y_low_qinit) / (my_qinit-1)
        
        rewind(unit)
        allocate(qinit(num_points))
        
        ! Read and store the data this time
        do i=1,num_points
            read(unit,*) x,y,qinit(i)
        enddo
        close(unit)
        
    end subroutine read_qinit

end module qinit_module

c     ==================================
      double precision function qtrue(x,y,t)
c     ==================================
      implicit double precision (a-h,o-z)
      common /cparam/ ubar,vbar
      
      x0 = x - ubar*t
      y0 = y - vbar*t

c     # evaluate desired initial data at (x0,y0):

!--      r = dsqrt((x0+0.2d0)**2 + (y0-0.4d0)**2)
!--      if (r <= 0.3d0) then
!--          qtrue = 1.d0
!--        else
!--          qtrue = 0.d0
!--        endif
!--
!--      r = dsqrt((x0-0.3d0)**2 + (y0-0.1d0)**2)
!--      qtrue = qtrue - dexp(-15.d0*r**2)


c linear test function to see if ghost cell interpolation exact
      qtrue = 2.d0*x0 + 1.0d0*y0
      !qtrue = 1.d0*x0 + 1.0d0*y0

      return
      end

c
c ------------------------------------------------------------
c
       subroutine upbnd(listbc,val,nvar,maux,mitot,mjtot,mktot,
     1                  maxsp,mptr)

      use amr_module
      implicit double precision (a-h,o-z)

      parameter(numbcs=6)

       dimension val(nvar,mitot,mjtot,mktot),listbc(numbcs,maxsp),
     1           iused(mitot,mjtot,mktot)
       dimension chsign(numbcs)
       data      chsign/ 1.,-1.,-1., 1., 1.,-1./

       iaddaux(i,j,k) = locaux +     (mcapa-1)
     &                         +     (i-1)*maux
     &                         +     (j-1)*maux*mitot
     &                         +     (k-1)*maux*mitot*mjtot

c
c :::::::::::::::::::::::::::: UPBND :::::::::::::::::::::::::::::
c We now correct the coarse grid with the flux differences stored
c with each of the fine grids. We use an array   iused
c to indicate whether the flux has been updated or not for that zone.
c iused(i,j) = sum from (l=1,4) i(l)*2**(l-1), where i(l) = 1 if the
c flux for the  l-th side of the (i,j)-th cell has already been
c updated, and i(l) = 0 if not.

c if there is a capacity fn. it needs to be included in update formula
c indicated by mcapa not zero (is index of capacity fn.)
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

      do 10 k=1,mktot
      do 10 j=1,mjtot
      do 10 i=1,mitot
         iused(i,j,k) = 0.
 10   continue

      locaux = node(storeaux,mptr)
      levc   = node(nestlevel,mptr)
      volume = hxposs(levc)*hyposs(levc)*hzposs(levc)
      if (uprint) write(outunit,*)" upbounding grid ",mptr

      do 40 ispot = 1,maxsp
         icrse = listbc(1,ispot)
         if (icrse.eq.0) go to 99

         jcrse = listbc(2,ispot)
         kcrse = listbc(3,ispot)
         iside = listbc(4,ispot)
         norm = 2**(iside-1)
         iflag =iused(icrse,jcrse,kcrse)/norm
         if (mod(iflag,2).eq.1) then
           go to 40
         endif
         mkid = listbc(5,ispot)
         lkid = listbc(6,ispot)
         sgnm = chsign(iside)
         kidlst = node(ffluxptr,mkid)

c        ## debugging output
         if (uprint) then
           write(outunit,101) icrse,jcrse,kcrse,
     .            (val(ivar,icrse,jcrse,kcrse),ivar=1,nvar)
 101       format(" old ",1x,3i4,5e15.7)
         endif

         if (mcapa .gt. 0) then
c            # capacity array:  need to divide by capa in each cell.
c            # modify sgnm which is reset for each grid cell.
c            # Note capa is stored in aux(icrse,jcrse,kcrse,mcapa)
             sgnm = sgnm / alloc(iaddaux(icrse,jcrse,kcrse))
         endif

         do 20 ivar = 1,nvar
            val(ivar,icrse,jcrse,kcrse) = val(ivar,icrse,jcrse,kcrse) +
     1      sgnm*alloc(kidlst+nvar*(lkid-1)+ivar-1)/volume
 20      continue
         iused(icrse,jcrse,kcrse) = iused(icrse,jcrse,kcrse) + norm

c        ## debugging output
         if (uprint) then
           write(outunit,102) mkid,
     .         (val(ivar,icrse,jcrse,kcrse),ivar=1,nvar)
 102       format(" new ","(grid",i3,")",5e15.7)
         endif

 40   continue
c
 99   return
      end

c
!> **iflags** described flagged cells in a rectangular region
!! described by **ilo**, **ihi**, **jlo**, **jhi** in level **lev**
!! index space
!! This subroutine projects **iflags** to **iflag**, which has flagging
!! information in a rectangular region described by **ilofine**,
!! **ihifine**, **jlofine**, **jhifine** in level **lev**+1 index space
!!
!!
!! **input**:
!! * iflags
!! **output**:
!! * iflags2
c ----------------------------------------------------
c
      subroutine griddomup(iflags,iflags2,ilo,ihi,jlo,jhi,
     .                     mbuff,lev,ilofine,ihifine,jlofine,jhifine)

      use amr_module
      implicit double precision (a-h, o-z)

      integer*1  iflags (ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)
      integer*1  iflags2(ilofine-mbuff:ihifine+mbuff,
     .                   jlofine-mbuff:jhifine+mbuff)

c
c ::::::::::::::::::::::::::: DOMUP :::::::::::::::::::::
c 
c  domain flags for THIS GRID  are in iflags. copy into iflags2, which is
c  at a different level, dimensions differently
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::

      if (dprint) then
         write(outunit,*)" from griddomup: flags (before expansion,",
     .                   " with buff cells)"
         do 5 j=jhi+mbuff,jlo-mbuff,-1
         write(outunit,100)(iflags(i,j),i=ilo-mbuff,ihi+mbuff)
 5       continue
      endif
c
      lratiox = intratx(lev)
      lratioy = intraty(lev)

      do j = jlofine-mbuff,jhifine+mbuff
      do i = ilofine-mbuff,ihifine+mbuff
         iflags2(i,j) = 0
      end do
      end do

c
c careful with buffer - cant just take coarse grid buffer and refine it
c since have same size buffer on finer grid
      do 21 j = jlo,jhi
      do 20 i = ilo,ihi
          ifine = i * lratiox - 1  ! subtract 1 so can add in next loop
          jfine = j * lratioy - 1
          do mj = 1, lratioy
          do mi = 1, lratiox
            iset = min(ifine+mi,ihifine+mbuff)  ! might as well include buffer, though done later
            jset = min(jfine+mj,jhifine+mbuff)  ! needed since grids dont align over many levels
            iset = max(iset,ilofine-mbuff)      ! but so expensive
            jset = max(jset,jlofine-mbuff)
            iflags2(iset,jset) = iflags(i,j)  
          end do
          end do
 20       continue
 21       continue
c
c need to be careful due to possibly odd buffer size
c cant just take coarse cell and do all fine fine cells within, as above loop
c  
c    handle left and right buffer zones
      do 25 j = jlofine-mbuff, jhifine+mbuff
      do 23 i = ihifine+1, ihifine+mbuff
c       get coarse indices for fine pt. i,j (in buffer zone)
        ic = i/lratiox
        jc = j/lratioy
        iflags2(i,j) = iflags(ic,jc)
 23   continue
      do 24 i = ilofine-mbuff, ilofine-1
c       get coarse indices for fine pt. i,j (in buffer zone)
        ic = i/lratiox
        jc = j/lratioy
        iflags2(i,j) = iflags(ic,jc)
 24   continue
 25   continue

c    handle top and bottom buffer zones
      do 33 i = ilofine, ihifine
      do 35 j = jlofine-mbuff, jlofine-1
c       get coarse indices for fine pt. i,j (in buffer zone)
        ic = i/lratiox
        jc = j/lratioy
        iflags2(i,j) = iflags(ic,jc)
 35    continue
      do 34 j = jhifine+1, jhifine+mbuff
c       get coarse indices for fine pt. i,j (in buffer zone)
        ic = i/lratiox
        jc = j/lratioy
        iflags2(i,j) = iflags(ic,jc)
 34   continue
 33   continue
c
c do not need to do something special for periodicity. already taken into account when
c setting enlarged grid woth buffer zone at level lbase
c
 90   continue
      if (dprint) then
         write(outunit,*)"from griddomup: flags (after ref 1 level up,",
     .                   "with buff cells)"
         do 70 j = jlofine-mbuff,jhifine+mbuff,-1
         write(outunit,100)(iflags2(i,j),i=ilofine-mbuff,ihifine+mbuff)
 100     format(80i1)
 70      continue
      endif

      return
      end

c
!> Transfer flagged arrays from errest into the one from spatial differencing 
!!
!! NOTE: not dimensioned the same. rectflags is possibly larger to accomodate
!! in-place buffering.

      subroutine addflags(rectflags,mibuff,mjbuff,
     1                    rctold,idim3,mitot,mjtot,mptr)
c
      use amr_module
      implicit double precision (a-h,o-z)


      dimension rctold(idim3,mitot,mjtot)
      dimension rectflags(mibuff,mjbuff)

c :::::::::::::::::::::: ADDFLAGS ::::::::::::::::::::::::::::::::::
c transfer flagged arrays from errest into the one from spatial
c differencing 
c NOTE: not dimensioned the same. rectflags is possibly larger to accomodate
c in-place buffering.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c

      do j = nghost+1, mjtot-nghost
      do i = nghost+1, mitot-nghost
         if (rctold(1,i,j) .gt. DONTFLAG) then
           rectflags(i,j) = DOFLAG
         endif
      end do
      end do
c
 99   return
      end

c
c
c
c     =================================================
      function fdisc(x,y,z)
c     =================================================
c
c     # For computing cell averages for initial data or coefficients that
c     # have a discontinuity along some surface in 3d.  

c     # fdisc should be negative to the "left" of the surface and 
c     # positive to the "right".

c     # The cellave routine can then be used to compute the fraction wl of
c     # a grid cell that lies to the "left" of the surface.

c     # Sample code for the case where the surface is the unit sphere:

      implicit double precision (a-h,o-z)

      fdisc = x**2 + y**2 + z**2 - 1.d0
c
      return
      end

c
c
c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,mz,xlower,ylower,zlower,
     &                   dx,dy,dz,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c
       implicit double precision (a-h,o-z)
c
       dimension   q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
       dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
c
c     # set concentration profile
c     ---------------------------
c
      do  k=1,mz
         zcell = zlower + (k-0.5d0)*dz
         do  j=1,my
            ycell = ylower + (j-0.5d0)*dy
            do  i=1,mx
               xcell = xlower + (i-0.5d0)*dx
 
               if (xcell .gt. 0.1d0 .and. xcell .lt. 0.5d0 .and.
     &             ycell .gt. 0.1d0 .and. ycell .lt. 0.5d0 .and.
     &             zcell .gt. 0.1d0 .and. zcell .lt. 0.5d0) then
                       q(1,i,j,k) = 1.d0
                    else
                       q(1,i,j,k) = 0.d0
                    endif
                end do  
             end do  
          end do  

       return
       end

c
c -----------------------------------------------------
c
      subroutine valout (lst, lend, time, nvar, naux)
c
      use amr_module
      implicit double precision (a-h,o-z)
      character*10  fname1, fname2, fname3, fname4, fname5

!> Output the results for a general system of conservation laws
!! in 2 dimensions
!!
!! Write the results to the file fort.q<iframe>
!! Use format required by matlab script  plotclaw2.m or Python tools
!!
!! set outaux = .true. to also output the aux arrays to fort.a<iframe>

      logical outaux
      integer output_aux_num 
      integer clock_start, clock_finish, clock_rate
      real(kind=8) cpu_start, cpu_finish

c      iadd(i,j,ivar) = loc + i - 1 + mitot*((ivar-1)*mjtot+j-1)
c      iaddaux(i,j,ivar) = locaux + i - 1 + mitot*((ivar-1)*mjtot+j-1)
      iadd(ivar,i,j)  = loc + ivar - 1 + nvar*((j-1)*mitot+i-1)
      iaddaux(iaux,i,j) = locaux + iaux-1 + naux*(i-1) +
     .                                      naux*mitot*(j-1)
c

      call system_clock(clock_start,clock_rate)
      call cpu_time(cpu_start)

c     # how many aux components requested?
      output_aux_num = 0
      do i=1,naux
          output_aux_num = output_aux_num + output_aux_components(i)
      enddo
                
c     # Currently outputs all aux components if any are requested!
      outaux = ((output_aux_num > 0) .and. 
     .         ((.not. output_aux_onlyonce) .or. (time==t0)))

c     open(unit=77,file='fort.b',status='unknown',access='stream')


c     ### Python graphics output
c

c        ###  make the file names and open output files
         fname1 = 'fort.qxxxx'
         fname2 = 'fort.txxxx'
         fname3 = 'fort.axxxx'
         fname4 = 'fort.bxxxx'
         matunit1 = 50
         matunit2 = 60
         matunit3 = 70
         matunit4 = 71
         nstp     = matlabu
         do 55 ipos = 10, 7, -1
            idigit = mod(nstp,10)
            fname1(ipos:ipos) = char(ichar('0') + idigit)
            fname2(ipos:ipos) = char(ichar('0') + idigit)
            fname3(ipos:ipos) = char(ichar('0') + idigit)
            fname4(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp / 10
 55      continue

         open(unit=matunit1,file=fname1,status='unknown',
     .       form='formatted')

         if (output_format == 3) then
c            # binary output          
             open(unit=matunit4,file=fname4,status='unknown',
     &               access='stream')
             endif

         level = lst
         ngrids = 0
c65      if (level .gt. lfine) go to 90
 65      if (level .gt. lend) go to 90
            mptr = lstart(level)
 70         if (mptr .eq. 0) go to 80
              ngrids  = ngrids + 1
              nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
              ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
              loc     = node(store1, mptr)
              locaux  = node(storeaux,mptr)
              mitot   = nx + 2*nghost
              mjtot   = ny + 2*nghost
              if (ny.gt.1) then
                  write(matunit1,1001) mptr, level, nx, ny
                else
c                 # output in 1d format if ny=1:
                  write(matunit1,1003) mptr, level, nx
                endif
 1001 format(i6,'                 grid_number',/,
     &       i6,'                 AMR_level',/,
     &       i6,'                 mx',/,
     &       i6,'                 my')
 1003 format(i6,'                 grid_number',/,
     &       i6,'                 AMR_level',/,
     &       i6,'                 mx')


              xlow = rnode(cornxlo,mptr)
              ylow = rnode(cornylo,mptr)
              if (ny.gt.1) then
                  write(matunit1,1002)
     &              xlow,ylow,hxposs(level),hyposs(level)
                else
                  write(matunit1,1004)
     &              xlow,hxposs(level)
                endif
 1002 format(e26.16,'    xlow', /,
     &       e26.16,'    ylow', /,
     &       e26.16,'    dx', /,
     &       e26.16,'    dy',/)
 1004 format(e26.16,'    xlow', /,
     &       e26.16,'    dx', /)


        if (output_format == 1) then
             do j = nghost+1, mjtot-nghost
                do i = nghost+1, mitot-nghost
                   do ivar=1,nvar
                      if (abs(alloc(iadd(ivar,i,j))) < 1d-90) then
                         alloc(iadd(ivar,i,j)) = 0.d0
                      endif
                   enddo
                   write(matunit1,109) 
     &                (alloc(iadd(ivar,i,j)), ivar=1,nvar)
                enddo
                write(matunit1,*) ' '
             enddo
  109        format(50e26.16)
         endif

         if (output_format == 3) then
c            # binary output          
             i1 = iadd(1,1,1)
             i2 = iadd(nvar,mitot,mjtot)
c            # NOTE: we are writing out ghost cell data also, unlike ascii
             write(matunit4) alloc(i1:i2)
             endif

            mptr = node(levelptr, mptr)
            go to 70
 80      level = level + 1
         go to 65

 90     continue

c       -------------------
c       # output aux arrays
c       -------------------

        if (outaux) then
c     # output aux array to fort.aXXXX

           level = lst
 165       if (level .gt. lfine) go to 190
           mptr = lstart(level)
 170       if (mptr .eq. 0) go to 180
           nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
           ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
           locaux  = node(storeaux,mptr)
           mitot   = nx + 2*nghost
           mjtot   = ny + 2*nghost


           if (output_format == 1) then
              open(unit=matunit3,file=fname3,status='unknown',
     .             form='formatted')
              if (ny.gt.1) then
                 write(matunit3,1001) mptr, level, nx, ny
              else
c     # output in 1d format if ny=1:
                 write(matunit3,1003) mptr, level, nx
              endif
              xlow = rnode(cornxlo,mptr)
              ylow = rnode(cornylo,mptr)
              if (ny.gt.1) then
                 write(matunit3,1002)
     &                xlow,ylow,hxposs(level),hyposs(level)
              else
                 write(matunit3,1004)
     &                xlow,hxposs(level)
              endif

              do j = nghost+1, mjtot-nghost
                 do i = nghost+1, mitot-nghost
                    do ivar=1,naux
                       if (abs(alloc(iaddaux(ivar,i,j))) .lt. 1d-90) 
     &                      alloc(iaddaux(ivar,i,j)) = 0.d0
                    enddo
                    write(matunit3,109) (alloc(iaddaux(ivar,i,j)), 
     &                   ivar=1,naux)
                 enddo
                 write(matunit3,*) ' '
              enddo
           endif
           
           if (output_format == 3) then
c     # binary output          
              open(unit=matunit3,file=fname3,status='unknown',
     &             access='stream')
              i1 = iaddaux(1,1,1)
              i2 = iaddaux(naux,mitot,mjtot)
c     # NOTE: we are writing out ghost cell data also, unlike ascii
              write(matunit3) alloc(i1:i2)
           endif


           mptr = node(levelptr, mptr)
           go to 170
 180       level = level + 1
           go to 165

 190       continue
           close(unit=matunit3)
        endif                   !# end outputting aux array


c     --------------
c     # fort.t file:
c     --------------

      open(unit=matunit2,file=fname2,status='unknown',
     .       form='formatted')
      if (ny.gt.1) then 
          ndim = 2
        else
c         # special case where 2d AMR is used for a 1d problem
c         # and we want to use 1d plotting routines
          ndim = 1
        endif

c     # NOTE: we need to print out nghost too in order to strip
c     #       ghost cells from q when reading in pyclaw.io.binary
      write(matunit2,1000) time,nvar,ngrids,naux,ndim,nghost
 1000 format(e18.8,'    time', /,
     &       i6,'                 meqn'/,
     &       i6,'                 ngrids'/,
     &       i6,'                 naux'/,
     &       i6,'                 ndim'/,
     &       i6,'                 nghost'/,/)
c

      write(6,601) matlabu,time
  601 format('AMRCLAW: Frame ',i4,
     &       ' output files done at time t = ', d13.6,/)

      matlabu = matlabu + 1

      close(unit=matunit1)
      close(unit=matunit2)
      if (output_format == 3) then
          close(unit=matunit4)
      endif

      call system_clock(clock_finish,clock_rate)
      call cpu_time(cpu_finish)
      timeValout = timeValout + clock_finish - clock_start
      timeValoutCPU = timeValoutCPU + cpu_finish - cpu_start

      return
      end

c
c -----------------------------------------------------
c
      subroutine valout (lst, lend, time, nvar, naux)
c
      use amr_module
      implicit double precision (a-h,o-z)

      parameter   (nDim = 3)
      character*14  fname
      character*13 qname2
      character*9  qname
      
      !timing variables
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish
c
c     # HDF: Declare variables that describe datasets and HDF files.
c
      integer    sd_id, sds_id, sds_rank
      integer    sds_dims, sds_start, sds_edges, sds_stride
      dimension  sds_dims(nDim), sds_start(nDim)
      dimension  sds_edges(nDim), sds_stride(nDim) 

c     # HDF: Arrays which will hold output arrays.
      integer    ntotal_output
      parameter (ntotal_output = 1000000)
      dimension  qbuf(21), qout(ntotal_output)
c
c     # HDF: Declare external HDF functions
c
      integer  sfstart, sfcreate, sfwdata, sfscompress, sfendacc, sfend
      external sfstart, sfcreate, sfwdata, sfscompress, sfendacc, sfend
c
c     # HDF: Set up HDF constants
c
      integer 	DFACC_READ, DFACC_WRITE, DFACC_CREATE 
      parameter(DFACC_READ = 1, DFACC_WRITE = 2, DFACC_CREATE = 4)

      integer   DFNT_FLOAT64, DFNT_INT32
      parameter(DFNT_FLOAT64 = 6, DFNT_INT32 = 24)

      integer   SUCCEED, FAIL
      parameter(SUCCEED = 0, FAIL = -1)
c
c     # HDF: Set up compression constants for HDF file.
c
      integer   COMP_CODE_DEFLATE, DEFLATE_LEVEL
      parameter (COMP_CODE_DEFLATE = 4, DEFLATE_LEVEL = 6)
c
c      iadd(i,j,ivar) = loc + i - 1 + mitot*((ivar-1)*mjtot+j-1)
c 3/1/02 : Taken from update.f.  Also see intfil.f
      iadd(ivar,i,j,k)   = loc     +     (ivar-1)
     &                             +     (i-1)*nvar
     &                             +     (j-1)*nvar*mitot
     &                             +     (k-1)*nvar*mitot*mjtot
c
c ::::::::::::::::::::::::::: VALOUT ::::::::::::::::::::::::::::::::::;
c valout = graphics output of soln values for contour or surface plots.
c          can output for matlab or ncar graphics post-processing
c :::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::::::::::;
c
      
      !timing
      call system_clock(clock_start, clock_rate)
      call cpu_time(cpu_start)
      
c     ### NCAR graphics output

      if (ncarout) then

        call basic (time, lst, lend )
c
        write(pltunit1,100)  nvar
100     format(10h*VALS     ,i10)
c
        level = lst
10      if (level .gt. lend) go to 60
            mptr = lstart(level)
20          if (mptr .eq. 0) go to 50
                nx = node(ndihi,mptr)-node(ndilo,mptr) + 1
                ny = node(ndjhi,mptr)-node(ndjlo,mptr) + 1
                nz = node(ndkhi,mptr)-node(ndklo,mptr) + 1
                mitot = nx + 2*nghost
                mjtot = ny + 2*nghost
                mktot = nz + 2*nghost
                loc = node(store1,mptr)
                call outvar(alloc(loc),mitot,mjtot,mktot,
     &                nvar,mptr,nghost)
                mptr = node(levelptr,mptr)
            go to 20
50          continue
            level = level + 1
        go to 10
c
60    continue
      endif


c     ### MATLAB graphics output
c
c     # HDF: Modified 8/2003 by Peter Blossey to generate HDF
c     #      (version 4) output files.  These portable, binary
c     #      format output files allow for self-describing data
c     #      sets as well as data compression.
c
c     #      For more information about HDF, see
c     #      http://hdf.ncsa.uiuc.edu/

      if (matlabout) then
c        ###  make the file names and open output files
         iframe = matlabu
         fname = 'fort.q'
     &        // char(ichar('0') + mod(iframe/1000,10)) 
     &        // char(ichar('0') + mod(iframe/100,10)) 
     &        // char(ichar('0') + mod(iframe/10,10)) 
     &        // char(ichar('0') + mod(iframe,10))
     &        // '.hdf'

         level = lst
         ngrids = 0
c
c     # HDF: create hdf file.
c
         sd_id = sfstart(fname, DFACC_CREATE)
         if (sd_id.eq.FAIL) THEN
            WRITE(*,*) 'Failed to create HDF file (call to sfstart)'
            STOP
         end if

 65      if (level .gt. lfine) go to 90
         mptr = lstart(level)
 70      if (mptr .eq. 0) go to 80
         ngrids  = ngrids + 1
         nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
         ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
         nz      = node(ndkhi,mptr) - node(ndklo,mptr) + 1
         loc     = node(store1, mptr)
         locaux  = node(storeaux,mptr)
         mitot   = nx + 2*nghost
         mjtot   = ny + 2*nghost
         mktot   = nz + 2*nghost
         xlow = rnode(cornxlo,mptr)
         ylow = rnode(cornylo,mptr)
         zlow = rnode(cornzlo,mptr)
c
c     # HDF: Check whether grid is larger than statically allocated
c     #      output array.
c
         if ((nx*ny*nz).gt.ntotal_output) then
            WRITE(*,*) 'Grid number ', mptr, ' on level number ',
     &           level, ' exceeds ntotal_output'
            WRITE(*,*) 'Increase ntotal_output in valout_hdf.f'
            STOP 
         end if
c     
c     # HDF: create a data set for parameters describing q in HDF file.
c     
         qname = 'grid_'
     &        // char(ichar('0') + mod(mptr/1000,10)) 
     &        // char(ichar('0') + mod(mptr/100,10)) 
     &        // char(ichar('0') + mod(mptr/10,10)) 
     &        // char(ichar('0') + mod(mptr,10))
         
         sds_rank = 1
         sds_dims(1) = 21
         
         sds_id = sfcreate(sd_id,qname,DFNT_FLOAT64,sds_rank,sds_dims)
         if (sds_id.eq.FAIL) THEN
            WRITE(*,*) 
     &           'Failed to create scientific data set in HDF file'
            STOP
         end if
c     
c     # HDF: set up parameters describing data set.
c     
         sds_start(1)  = 0
         sds_edges(1)  = sds_dims(1)
         sds_stride(1) = 1        
         qbuf(1) = ngrids
         qbuf(2) = nDim
         qbuf(3) = time
         qbuf(4) = nvar
         qbuf(5) = level
         qbuf(6) = nx
         qbuf(7) = ny
         qbuf(8) = nz
         qbuf(9) = 0.
         qbuf(10) = xlow
         qbuf(11) = ylow
         qbuf(12) = zlow
         qbuf(13) = 0.
         qbuf(14) = xlow+nx*hxposs(level)
         qbuf(15) = ylow+ny*hyposs(level)
         qbuf(16) = zlow+nz*hzposs(level)
         qbuf(17) = 0.
         qbuf(18) = hxposs(level)
         qbuf(19) = hyposs(level)
         qbuf(20) = hzposs(level)
         qbuf(21) = 0.
         istat = sfwdata(sds_id,sds_start,sds_stride,sds_edges,qbuf)  
         istat = sfendacc(sds_id)  
c     
c     # Loop over fields in q
c     
         do ivar = 1,nvar
c     
c     # HDF: create a data set for parameters describing q in HDF file.
c     
            qname2 = qname // '_'
     &           // char(ichar('0') + mod(ivar/100,10)) 
     &           // char(ichar('0') + mod(ivar/10,10)) 
     &           // char(ichar('0') + mod(ivar,10))
c     
c     # HDF: Reverse dimensions when storing arrays because of different
c     #      conventions between c and FORTRAN as to which dimension should
c     #      be stored first.  Reversing the dimensions here will make
c     #      the x-direction first when reading into MATLAB.
c     
            sds_rank = nDim
            sds_dims(1) = nz
            sds_dims(2) = ny
            sds_dims(3) = nx
c     
            sds_id = sfcreate(sd_id,qname2,DFNT_FLOAT64,sds_rank,
     &           sds_dims)
            if (sds_id.eq.FAIL) THEN
               WRITE(*,*) 'Failed to create data set in HDF file'
               STOP
            end if
c     
c     # HDF: set up parameters describing data set.
c     
            sds_start(1)  = 0
            sds_edges(1)  = sds_dims(1)
            sds_stride(1) = 1        

            sds_start(2)  = 0
            sds_edges(2)  = sds_dims(2)
            sds_stride(2) = 1        

            sds_start(3)  = 0
            sds_edges(3)  = sds_dims(3)
            sds_stride(3) = 1        
c     
c     # Copy current field of q into qout.
c     
            ioffset = 0
            do k = nghost+1, mitot-nghost
               do j = nghost+1, mjtot-nghost
                  do i = nghost+1, mktot-nghost
                     qout(ioffset+i-nghost) = alloc(iadd(ivar,k,j,i))
                  end do
                  ioffset = ioffset + nz
               end do
            end do
c     
c     # HDF: set compression mode and write data to hdf file.
c     
            istat=sfscompress(sds_id,COMP_CODE_DEFLATE,DEFLATE_LEVEL)
            istat = sfwdata(sds_id,sds_start,sds_stride,sds_edges,qout)
            if (istat.eq.FAIL) then
               WRITE(*,*) 'Failed to write SDS (call to sfwdata)'
               STOP
            end if
c     
c     # HDF: Close the data set
c     
            istat = sfendacc(sds_id)  
            if (istat.eq.FAIL) then
               WRITE(*,*) 'Failed to close SDS (call to sfendacc)'
               STOP
            end if
         end do

         mptr = node(levelptr, mptr)
         go to 70
 80      level = level + 1
         go to 65

 90      continue

c
c     # HDF: Close HDF file.
c
         istat = sfend(sd_id)
         if (istat.eq.FAIL) then
            WRITE(*,*) 'Failed to close SDS (call to sfendacc)'
            STOP
         end if
c
c     # Output message saying that write is complete.
c
         write(6,601) matlabu,time
 601     format('AMRCLAW: Frame ',i4,
     &        ' matlab plot files done at time t = ', d12.5,/)

         matlabu = matlabu + 1
      endif
      
      call system_clock(clock_finish,clock_rate)
      call cpu_time(cpu_finish)
      timeValout = timeValout + clock_finish - clock_start
      timeValoutCPU = timeValoutCPU + cpu_finish - cpu_start

      return
      end

! :::::::::: BC3AMR ::::::::::::::::::::::::::::::::::::::::::::::;
!
!     Take a grid patch with mesh widths hx,hy,hz, of dimensions nrow by
!     ncol by nfil,  and set the values of any piece of
!     of the patch which extends outside the physical domain
!     using the boundary conditions.
!     ------------------------------------------------
!     # Standard boundary condition choices for amr3ez in clawpack
!
!     # At each boundary  k = 1 (xlower),  2 (xupper),  3 (ylower ), 4 (yupper),
!                         5 (zlower) 6 (zupper)
!     #  
!     #   mthbc(k) =  0  for user-supplied BC's (must be inserted!)
!     #            =  1  for zero-order extrapolation
!     #            =  2  for periodic boundary coniditions
!     #            =  3  for solid walls, assuming this can be implemented
!     #                  by reflecting the data about the boundary and then
!     #                  negating the 2'nd (for k=1,2) or 3'rd (for k=3,4)
!     #                  or 4'th (for k = 5,6) component of q.
!     ------------------------------------------------
!
!     The corners of the grid patch are at
!        (xlo_patch,ylo_patch,zlo_patch)  --  lower left corner
!        (xhi_patch,yhi_patch,zhi_patch)  --  upper right corner
!
!     The physical domain itself is a rectangular parallelopiped bounded by
!        (xlower,ylower,zlower)  -- lower front left corner
!        (xupper,yupper,zupper)  -- upper rear right corner
!
!     the picture is the following:
!
!                            __________________________(xupper,yupper,zupper)
!                           /                         /|
!                          /                         / |
!                         /                         /  |
!                        /_________________________/   |
!                        |                         |   |
!                        |                         |   |
!                     ___|_____(xhi_patch,yhi_patch,zhi_patch) 
!                    /___|____/|                   |   |
!                    |   |    ||                   |   |
!                    |   |    ||                   |   |
!                    |   |    ||                   |   |
!                    |___|____|/                   |   |
!  (xlo_patch,ylo_patch,zlo_patch)                 |  /                       
!                        |                         | /
!                        |_________________________|/
!  (xlower,ylower,zlower)
!
!     Any cells that lie outside the physical domain are ghost cells whose
!     values should be set in this routine.  This is tested for by comparing
!     xlo_patch with xlower to see if values need to be set at the left, as in
!     the figure above, and similarly at the other boundaries.
!
!     Patches are guaranteed to have at least 1 row of cells filled
!     with interior values so it is possible to  extrapolate.
!     Fix trimbd if you want more than 1 row pre-set.
!
!     Make sure the order the boundaries are specified is correct
!     so that diagonal corner cells are also properly taken care of.
!
!     Periodic boundaries are set before calling this routine, so if the
!     domain is periodic in one direction only you
!     can safely extrapolate in the other direction.
!
!     Don't overwrite ghost cells in periodic directions!
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

subroutine bc3amr(val,aux,nrow,ncol,nfil,meqn,naux, hx, hy, hz, level, time,  &
                  xlo_patch, xhi_patch,                     &
                  ylo_patch, yhi_patch,                     &
                  zlo_patch, zhi_patch) 

    use amr_module, only: mthbc, xlower, ylower, xupper, yupper, zlower, zupper
    use amr_module, only: xperdom,yperdom,zperdom

    implicit none

    ! Input/Output
    integer, intent(in) :: nrow, ncol, nfil, meqn, naux, level
    real(kind=8), intent(in) :: hx, hy, hz, time
    real(kind=8), intent(in) :: xlo_patch, xhi_patch
    real(kind=8), intent(in) :: ylo_patch, yhi_patch
    real(kind=8), intent(in) :: zlo_patch, zhi_patch
    real(kind=8), intent(in out) :: val(meqn, nrow, ncol, nfil)
    real(kind=8), intent(in out) :: aux(naux, nrow, ncol, nfil)
    
    ! Local storage
    integer :: i, j, k, ibeg, jbeg, kbeg, nxl, nxr, nyl, nyr, nzl, nzr
    real(kind=8) :: hxmarg, hymarg, hzmarg, x, y, z

    hxmarg = hx * .01d0
    hymarg = hy * .01d0
    hzmarg = hz * .01d0

    ! Use periodic boundary condition specialized code only, if only one 
    ! boundary is periodic we still proceed below
    if (xperdom .and. yperdom .and. zperdom) then
        return
    end if

    ! Each check has an initial check to ensure that the boundary is a real
    ! boundary condition and otherwise skips the code.  Otherwise 
    !-------------------------------------------------------
    ! xlower boundary:
    !-------------------------------------------------------
    if (xlo_patch < xlower-hxmarg) then
        ! number of grid cells from this patch lying outside physical domain:
        nxl = int((xlower + hxmarg - xlo_patch) / hx)

        select case(mthbc(1))
            case(0) ! User defined boundary condition
                do k = 1, nfil
                    z = zlo_patch + (k - 0.5d0) * hz
                    do j = 1, ncol
                        y = ylo_patch + (j - 0.5d0) * hy
                        do i=1, nxl
                            if ((z - 0.5d0)**2 + (y - 0.5d0)**2 < 0.01d0) then
                                val(1, i, j, k) = 1.d0
                            else
                                val(1, i, j, k) = 0.d0
                            end if
                        end do
                    end do
                end do

            case(1) ! Zero-order extrapolation
                do k = 1, nfil
                    do j = 1, ncol
                        do i=1, nxl
                            val(:, i, j, k) = val(:, nxl + 1, j, k)
                        end do
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do k = 1, nfil
                    do j = 1, ncol
                        do i=1, nxl
                            val(:, i, j, k) = val(:, 2 * nxl + 1 - i, j, k)
                        end do
                    end do
                end do
                ! negate the normal velocity:
                do k = 1, nfil
                    do j = 1, ncol
                        do i=1, nxl
                            val(2, i, j, k) = -val(2, i, j, k)
                        end do
                    end do
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop
        end select
    end if

    !-------------------------------------------------------
    ! xupper boundary:
    !-------------------------------------------------------
    if (xhi_patch > xupper+hxmarg) then

        ! number of grid cells lying outside physical domain:
        nxr = int((xhi_patch - xupper + hxmarg) / hx)
        ibeg = max(nrow - nxr + 1, 1)

        select case(mthbc(2))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."
            case(1) ! Zero-order extrapolation
                do k = 1, nfil
                    do i = ibeg, nrow
                        do j = 1, ncol
                            val(:, i, j, k) = val(:, ibeg - 1, j, k)
                        end do
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do k = 1, nfil
                    do i=ibeg, nrow
                        do j = 1, ncol
                            val(:, i, j, k) = val(:, 2 * ibeg - 1 - i, j, k)
                        end do
                    end do
                end do
                ! negate the normal velocity:
                do k = 1, nfil
                    do i = ibeg, nrow
                        do j = 1, ncol
                            val(2, i, j, k) = -val(2, i, j, k)
                        end do
                    end do
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

    !-------------------------------------------------------
    ! ylower boundary:
    !-------------------------------------------------------
    if (ylo_patch < ylower - hymarg) then

        ! number of grid cells lying outside physical domain:
        nyl = int((ylower + hymarg - ylo_patch) / hy)

        select case(mthbc(3))
            case(0) ! User defined boundary condition
                do k = 1, nfil
                    z = zlo_patch + (k - 0.5d0) * hz
                    do i = 1, nrow
                        x = xlo_patch + (k - 0.5d0) * hx
                        do j = 1, nyl
                            if ((x - 0.5d0)**2 + (z - 0.5d0)**2 < 0.01d0) then
                                val(1, i ,j, k) = 1.d0
                            else
                                val(1, i, j, k) = 0.d0
                            end if
                        end do
                    end do
                end do
            
            case(1) ! Zero-order extrapolation
                do k = 1, nfil
                    do j = 1, nyl
                        do i = 1, nrow
                            val(:, i ,j, k) = val(:, i, nyl + 1, k)
                        end do
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do k = 1, nfil
                    do j = 1, nyl
                        do i = 1, nrow
                            val(:, i ,j, k) = val(:, i, 2 * nyl + 1 - j, k)
                        end do
                    end do
                end do
                ! negate the normal velocity:
                do k = 1, nfil
                    do j = 1, nyl
                        do i = 1, nrow
                            val(3, i ,j, k) = -val(3, i, j, k)
                        end do
                    end do
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

    !-------------------------------------------------------
    ! yupper boundary:
    !-------------------------------------------------------
    if (yhi_patch > yupper + hymarg) then

        ! number of grid cells lying outside physical domain:
        nyr = int((yhi_patch - yupper + hymarg) / hy)
        jbeg = max(ncol - nyr + 1, 1)

        select case(mthbc(4))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."

            case(1) ! Zero-order extrapolation
                do k = 1, nfil
                    do j = jbeg, ncol
                        do i = 1, nrow
                            val(:, i, j, k) = val(:, i, jbeg - 1, k)
                        end do
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do k = 1, nfil
                    do j = jbeg, ncol 
                        do i = 1, nrow
                            val(:, i, j, k) = val(:, i, 2 * jbeg - 1 - j, k)
                        end do
                    end do
                end do
                ! negate the normal velocity:
                do k = 1, nfil
                    do j = jbeg, ncol
                        do i = 1, nrow
                            val(3, i, j, k) = -val(3, i, j, k)
                        end do
                    end do
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

    !-------------------------------------------------------
    ! Z lower boundary:
    !-------------------------------------------------------
    if (zlo_patch < zlower - hzmarg) then

        ! Numnber of ghost cells lying outside physical domain
        nzl = (zlower + hzmarg - zlo_patch) / hz

        select case(mthbc(5))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."

            case(1) ! Zero-order extrapolation
                do k = 1, nzl
                    do j = 1, ncol
                        do i = 1, nrow
                            val(:, i, j, k) = val(:, i, j, nzl + 1)
                        end do
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do k = 1, nzl
                    do j = 1, ncol 
                        do i = 1, nrow
                            val(:, i, j, k) = val(:, i, j, 2 * nzl + 1 - k)
                        end do
                    end do
                end do
                ! negate the normal velocity:
                do k = 1, nzl
                    do j = 1, ncol
                        do i = 1, nrow
                            val(4, i, j, k) = -val(4, i, j, k)
                        end do
                    end do
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

    !-------------------------------------------------------
    ! Z upper boundary:
    !-------------------------------------------------------
    if (zhi_patch > zupper + hzmarg) then

        ! Numnber of ghost cells lying outside physical domain
        nzr = (zhi_patch - zupper + hzmarg) / hz
        kbeg = max(nfil - nzr + 1, 1)

        select case(mthbc(6))
            case(0) ! User defined boundary condition
                ! Replace this code with a user defined boundary condition
                stop "A user defined boundary condition was not provided."

            case(1) ! Zero-order extrapolation
                do k = kbeg, nfil
                    do j = 1, ncol
                        do i = 1, nrow
                            val(:, i, j, k) = val(:, i, j, kbeg - 1)
                        end do
                    end do
                end do

            case(2) ! Periodic boundary condition
                continue

            case(3) ! Wall boundary conditions
                do k = kbeg, nfil
                    do j = 1, ncol 
                        do i = 1, nrow
                            val(:, i, j, k) = val(:, i, j, 2 * kbeg - 1 - k)
                        end do
                    end do
                end do
                ! negate the normal velocity:
                do k = kbeg, nfil
                    do j = 1, ncol
                        do i = 1, nrow
                            val(4, i, j, k) = -val(4, i, j, k)
                        end do
                    end do
                end do

            case default
                print *, "Invalid boundary condition requested."
                stop

        end select
    end if

end subroutine bc3amr

c
c ---------------------------------------------------------
c
      logical function nestck1(mnew,lbase,badpts,npts,numptc,icl,
     1                        nclust, nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)
      dimension  badpts(1,npts)
      logical baseCheck, isNested

      integer   numptc(maxcl), zeroBuff
c
c ::::::::::::::::::::::: NESTCK :::::::::::::::::::::::::::::::::::
c
c nestck - check that the potential grid mnew is completely
c          contained in the (coarser) finest grid which stays
c          fixed, at level lbase. projec algo. will guarantee
c          containment in all finer grids twixt them.
c          if grid not contained in some coarse grid,  then
c          bisect in long direction.
c          EVENTUALLY this has to work, since flagged pts were
c          checked for proper nesting.
c
c input parameter:
c   mnew    - grid descriptor of potential grid
c   lbase   - level which stays fixed during regridding
c   badpts  - only the flagged pts. in this cluster (# icl)
c :::::::::::::::::::::::::::::::::;::::::::::::::::::::::::::::::::
c
       nestck1 = .true.
c
c      # for CONVEX coarsest grid at level 1, nothing to check
       if (lbase .eq. 1)  go to 99

       levnew = node(nestlevel,mnew)
       lratiox  = intratx(levnew-1)

       zeroBuff = 0 ! dont count buffer zone around grid in checking
       isNested = baseCheck(mnew,lbase,node(ndilo,mnew),
     .                      node(ndihi,mnew),nvar,naux,zeroBuff)
       if (isNested) then
           nestck1 = isNested
           go to 99
       endif
c
c  ### use grid indices coarsened by 1 level in checking
c  ### remember to offset by 1 since 1st grid cell is 0,0

c  ### grid not properly nested. bisect in long direction, and return
c  ### two clusters instead of 1.
c
 50    if (npts .gt. 1) go to 55
           write(outunit,101) levnew
           write(*,101)       levnew
 101       format(' nestck1: 1 pt. cluster at level ',i5,' still not',
     1       ' nested',/,'          pt. too close to boundary')
           write(outunit,104) badpts(1,npts)
           write(*,104)       badpts(1,npts)
 104       format(' non-nested flagged pt. at: ',e15.7)
           call outtre(mstart, .false.,nvar,naux)
           call outmsh(mnew, .false.,nvar,naux)
           stop

 55    if (nclust .lt. maxcl) go to 60
           write(outunit,102) maxcl
           write(*,102)       maxcl
 102       format(' too many clusters: > ',i5,' (from nestck1) ')
           stop

 60   if (nprint) write(outunit,103) icl, npts
 103  format(' bisecting cluster ',i5,' with ',i5,' pts. in nestck2')
c
      rmid  = (rnode(cornxhi,mnew) + rnode(cornxlo,mnew) ) / 2.
      rmid  = (node(ndihi,mnew) + node(ndilo,mnew) + 1 ) / 2.
      rmid  = rmid / lratiox
      idir = 1
c
       ipt  = 1
       ntop = npts

 90    if (badpts(idir,ipt) .lt. rmid) go to 100
c
c  ### swap with a point in top half not yet tested. keep smaller
c  ### half of rect. in bottom half
c
       temp           = badpts(1,ipt)
       badpts(1,ipt)  = badpts(1,ntop)
       badpts(1,ntop) = temp
       ntop           = ntop - 1
       if (ipt .le. ntop) go to 90
       go to 110
 100   ipt = ipt +1
       if (ipt .le. ntop) go to 90
c
c  ### ntop points to top of 1st cluster (= no. of points in 1st cluster)
c
 110   numptc(icl)     = npts - ntop
       do 120 i        = icl, nclust
          nmove           = nclust + icl - i
 120      numptc(nmove+1) = numptc(nmove)
       numptc(icl)     = ntop
       nclust          = nclust + 1
       nestck1         = .false.
c
 99    return
       end

!> When a fine grid is updated, this subroutine is called to save fluxes
!! going into an adjacent coarse cell in **svdflx**, which is for conservative 
!! fix later.
!!
c -------------------------------------------------------
c
      subroutine fluxad(xfluxm,xfluxp,yfluxm,yfluxp,
     1                  svdflx,mptr,mitot,mjtot,
     2                   nvar,lenbc,lratiox,lratioy,ng,dtf,dx,dy)
c

      use amr_module
      implicit double precision (a-h,o-z)


c :::::::::::::::::::: FLUXAD ::::::::::::::::::::::::::::::::::
c  save fine grid fluxes  at the border of the grid, for fixing
c  up the adjacent coarse cells. at each edge of the grid, only
c  save the plus or minus fluxes, as necessary. For ex., on
c  left edge of fine grid, it is the minus xfluxes that modify the
c  coarse cell.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      dimension xfluxm(nvar,mitot,mjtot), yfluxm(nvar,mitot,mjtot)
      dimension xfluxp(nvar,mitot,mjtot), yfluxp(nvar,mitot,mjtot)
      dimension svdflx(nvar,lenbc)
 
      nx  = mitot-2*ng
      ny  = mjtot-2*ng
      nyc = ny/lratioy
      nxc = nx/lratiox
 
c ::::: left side saved first
      lind = 0

      do 100 j=1,nyc
         lind = lind + 1
         jfine = (j-1)*lratioy + ng
         do 110 ivar = 1, nvar
            do 120 l=1,lratioy
               svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                             xfluxm(ivar,ng+1,jfine+l)*dtf*dy
c              write(dbugunit,900)lind,xfluxm(ivar,1,jfine+l),
c     .                           xfluxp(ivar,1,jfine+l)
 900           format(' lind ', i4,' m & p ',2e15.7,' svd ',e15.7)
120         continue
110      continue
100   continue
 
c ::::: top side
c      write(dbugunit,*)" saving top side "
      do 200 i=1,nxc
         lind = lind + 1
         ifine = (i-1)*lratiox + ng
         do 210 ivar = 1, nvar
            do 220 l=1,lratiox
               svdflx(ivar,lind) = svdflx(ivar,lind) + 
     1                     yfluxp(ivar,ifine+l,mjtot-ng+1)*dtf*dx
c              write(dbugunit,900)lind,yfluxm(ivar,ifine+l,mjtot-ng+1,
c     .                           ),yfluxp(ivar,ifine+l,mjtot-ng+1),
c     .                           svdflx(ivar,lind)
220         continue
210      continue
200   continue
 
c ::::: right side
      do 300 j=1,nyc
         lind = lind + 1
         jfine = (j-1)*lratioy + ng
         do 310 ivar = 1, nvar
            do 320 l=1,lratioy
               svdflx(ivar,lind) = svdflx(ivar,lind) + 
     1                     xfluxp(ivar,mitot-ng+1,jfine+l)*dtf*dy
c              write(dbugunit,900)lind,xfluxm(ivar,mitot-ng+1,jfine+l,
c                                 ),xfluxp(ivar,mitot-ng+1,jfine+l)
320         continue
310      continue
300   continue
 
c ::::: bottom side
c      write(dbugunit,*)" saving bottom side "
      do 400 i=1,nxc
         lind = lind + 1
         ifine = (i-1)*lratiox + ng
         do 410 ivar = 1, nvar
            do 420 l=1,lratiox
               svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                             yfluxm(ivar,ifine+l,ng+1)*dtf*dx
c              write(dbugunit,900)lind,yfluxm(ivar,ifine+l,ng+1),
c     .                      yfluxp(ivar,ifine+l,ng+1),svdflx(ivar,lind)
420         continue
410      continue
400   continue
 
      return
      end

c
c ----------------------------------------------------------------
c
       subroutine setuse(listbc,maxsp,ispot,mkid,
     1                   ilo, ihi,
     2                   iclo,ichi,kflag)
c
c :::::::::::::::::::::::: SETUSE ::::::::::::::::::::::::::::::::
c
c set up boundary list for coarse grid, to be used by fluxsv. 
c loop around boundary of fine grids to do this.  each entry has
c     i, side #, fine grid #, loc in fine grid list for fluxes.
c  for example, side 1 of fine grid fixes side 2 of coarse grid,
c  so coarse grid list will store the # 2.
c  wrt coarse grid, the sides are:
c           1     2       that is, right edge of a coarse cell = 2
c
c  # lkid is the index into the fine grid's saved fluxes.
c  # the fine grid will save all its fluxes all around its
c  # perimeter. lkid tells where the coarse grid should
c  # taking them from. (no ghost cells in this index, but 
c  # it is 1-based for indexing array, not - based for
c  # integer index of grid location).
c
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c
      use amr_module
      implicit double precision (a-h,o-z)
      parameter(numbcs=4)
      dimension listbc(numbcs,maxsp)


      ibc = ispot
      ist  = iclo - 1
      iend = ichi + 1
c
c  left side (of fine grid, right side of coarse cell)
c
      if (ist .lt. ilo .or. kflag .ne. 1) go to 20
         lkid     = 1

         ispot              = ispot + 1
         listbc(1,ispot)    = ist-ilo+nghost+1
         listbc(2,ispot)    = 2
         listbc(3,ispot)    = mkid
         listbc(4,ispot)    = lkid
         lkid               = lkid + 1
c
c  right side (of fine grid, left of coarse cell)
c (numbered from bottom to top, so not continuous in lkid numbering)
c
 20    if (iend .gt. ihi .or. kflag .ne. 1) go to 30
       lkid     = 2
          ispot              = ispot + 1
          listbc(1,ispot)    = iend-ilo+nghost+1
          listbc(2,ispot)    = 1
          listbc(3,ispot)    = mkid
          listbc(4,ispot)    = lkid
          lkid   = lkid + 1
c
 30    continue
       return
       end

! ============================================================================
!  Program:     AMRClaw
!  File:        resize_storage.f90
!  Created:     2009-01-21
!  Author:      Kyle Mandli and Marsha Berger
! ============================================================================
!  Description:  Resize the alloc array for AMR storage
! ============================================================================


! NOTE:  Older f90 compilers (e.g. gfortran prior to 4.2?)
! may not implement move_alloc.  If this fails, you may need to use
! resize_storage_static.f90 instead of this routine and set the
! allocation large enough in init_alloc.f90 to avoid running out of space.


subroutine resize_storage(new_size,status)
    
    use amr_module
    implicit none
    
    integer, intent(out) :: status
    integer, intent(in) :: new_size
    
    real(kind=8), allocatable, target, dimension(:) :: new_storage
    

    if (memsize < new_size) then
        print *, "Expanding storage from ", memsize," to ", new_size
        allocate(new_storage(new_size),STAT=status)
        if (status > 0) then
            return
        endif
!       new_storage(1:memsize) = storage   !old way, changed mjb sept. 2014
        new_storage(1:memsize) = alloc     ! new way, use allocatable, not pointer       

!        call move_alloc(new_storage,storage)
        call move_alloc(new_storage,alloc)

!        alloc => storage
        memsize = new_size
    else
        print *,'new_size < memsize,'
        print *,'new_size = ',new_size
        print *,'memsize = ',memsize
        stop
    endif
    
    return
    
end subroutine resize_storage

c
c -------------------------------------------------------
c
      subroutine fluxad(xfluxm,xfluxp,yfluxm,yfluxp,zfluxm,zfluxp,
     1                  svdflx,mptr,mitot,mjtot,mktot,
     2                  nvar,lenbc,lratiox,lratioy,lratioz,
     3                  ng,dtf,dx,dy,dz)
c

      use amr_module
      implicit double precision (a-h,o-z)

c :::::::::::::::::::: FLUXAD ::::::::::::::::::::::::::::::::::
c  save fine grid fluxes  at the border of the grid, for fixing
c  up the adjacent coarse cells. at each edge of the grid, only
c  save the plus or minus fluxes, as necessary. For ex., on
c  left edge of fine grid, it is the minus xfluxes that modify the
c  coarse cell.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

      dimension xfluxm(nvar,mitot,mjtot,mktot)
      dimension xfluxp(nvar,mitot,mjtot,mktot)
      dimension yfluxm(nvar,mitot,mjtot,mktot)
      dimension yfluxp(nvar,mitot,mjtot,mktot)
      dimension zfluxm(nvar,mitot,mjtot,mktot)
      dimension zfluxp(nvar,mitot,mjtot,mktot)
      dimension svdflx(nvar,lenbc)
 
      nx  = mitot-2*ng
      ny  = mjtot-2*ng
      nz  = mktot-2*ng
      nzc = nz/lratioz
      nyc = ny/lratioy
      nxc = nx/lratiox
 
c ::::: left side saved first
      lind = 0

      do 100 k=1,nzc
         kfine = (k-1)*lratioz + ng
         do 110 j=1,nyc
            jfine = (j-1)*lratioy + ng
            lind = lind + 1
            do 120 ivar = 1, nvar
               do 130 kl=1,lratioz
               do 130 jl=1,lratioy
                  svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                  xfluxm(ivar,ng+1,jfine+jl,kfine+kl)*dtf*dy*dz
c	          write(dbugunit,900)lind,
c     .                              xfluxm(ivar,1,jfine+jl,kfine+kl),
c     .                              xfluxp(ivar,1,jfine+jl,kfine+kl)
130            continue
120         continue
110      continue
100   continue
 
c ::::: rear side
      do 200 k=1,nzc
         kfine = (k-1)*lratioz + ng
         do 210 i=1,nxc
            ifine = (i-1)*lratiox + ng
            lind = lind + 1
            do 220 ivar = 1, nvar
               do 230 kl=1,lratioz
               do 230 il=1,lratiox
                  svdflx(ivar,lind) = svdflx(ivar,lind) + 
     1              yfluxp(ivar,ifine+il,mjtot-ng+1,kfine+kl)*dtf*dx*dz
c         	   write(dbugunit,900)lind,
c     .                       yfluxm(ivar,ifine+il,mjtot-ng+1,kfine+kl),
c     .                       yfluxp(ivar,ifine+il,mjtot-ng+1,kfine+kl)
230            continue
220         continue
210      continue
200   continue
 
c ::::: right side
      do 300 k=1,nzc
         kfine = (k-1)*lratioz + ng
         do 310 j=1,nyc
            jfine = (j-1)*lratioy + ng
            lind = lind + 1
            do 320 ivar = 1, nvar
               do 330 kl=1,lratioz
               do 330 jl=1,lratioy
                  svdflx(ivar,lind) = svdflx(ivar,lind) + 
     1              xfluxp(ivar,mitot-ng+1,jfine+jl,kfine+kl)*dtf*dy*dz
c                  write(dbugunit,900)lind
c     .                       xfluxm(ivar,mitot-ng+1,jfine+jl,kfine+kl),
c     .                       xfluxp(ivar,mitot-ng+1,jfine+jl,kfine+kl)
330            continue
320         continue
310      continue
300   continue
 
c ::::: front side
      do 400 k=1,nzc
         kfine = (k-1)*lratioz + ng
         do 410 i=1,nxc
            ifine = (i-1)*lratiox + ng
            lind = lind + 1
            do 420 ivar = 1, nvar
               do 430 kl=1,lratioz
               do 430 il=1,lratiox
                  svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                    yfluxm(ivar,ifine+il,ng+1,kfine+kl)*dtf*dx*dz
c                  write(dbugunit,900)lind,
c     .                             yfluxm(ivar,ifine+il,ng+1,kfine+kl),
c     .                             yfluxp(ivar,ifine+il,ng+1,kfine+kl)
430            continue
420         continue
410      continue
400   continue
 
c ::::: bottom side
      do 500 j=1,nyc
         jfine = (j-1)*lratioy + ng
         do 510 i=1,nxc
            ifine = (i-1)*lratiox + ng
            lind = lind + 1
            do 520 ivar = 1, nvar
               do 530 jl=1,lratioy
               do 530 il=1,lratiox
                  svdflx(ivar,lind) = svdflx(ivar,lind) +
     1                    zfluxm(ivar,ifine+il,jfine+jl,ng+1)*dtf*dx*dy
c                  write(dbugunit,900)lind,
c     .                             zfluxm(ivar,ifine+il,jfine+jl,ng+1),
c     .                             zfluxp(ivar,ifine+il,jfine+jl,ng+1) 
530            continue
520         continue
510      continue
500   continue
 
c ::::: top side
      do 600 j=1,nyc
         jfine = (j-1)*lratioy + ng
         do 610 i=1,nxc
            ifine = (i-1)*lratiox + ng
            lind = lind + 1
            do 620 ivar = 1, nvar
               do 630 jl=1,lratioy
               do 630 il=1,lratiox
                  svdflx(ivar,lind) = svdflx(ivar,lind) +
     1              zfluxp(ivar,ifine+il,jfine+jl,mktot-ng+1)*dtf*dx*dy
c                  write(dbugunit,900)lind,
c     .                             zfluxm(ivar,ifine+il,jfine+jl,ng+1),
c     .                             zfluxp(ivar,ifine+il,jfine+jl,ng+1)
630            continue
620         continue
610      continue
600   continue

 900              format(' lind ', i4,' m & p ',2e15.7)

      return
      end

! ============================================================================
!  Program:     AMRClaw
!  File:        init_nodes.f90
!  Created:     2018-06-15
!  Author:      Marsha Berger
! ============================================================================
!  Description:  Initialization of rnode and node storage
! ============================================================================


subroutine init_nodes()
    
    use amr_module
    implicit none
    
    maxgr = 10000   
    if (.not.allocated(rnode)) then      ! new way, use allocatable arrays, not pointers
        allocate(rnode(rsize,maxgr))
        print *, "rnode allocated..."
    else
        print *, "rnode already allocated!"
    endif
    if (.not.allocated(node)) then      ! new way, use allocatable arrays, not pointers
        allocate(node(nsize,maxgr))
        print *, "node allocated..."
    else
        print *, "rnode already allocated!"
    endif
    if (.not.allocated(listOfGrids)) then   ! include all vars whose size depends on maxgr
        allocate(listOfGrids(maxgr))
        print *, "listOfGrids allocated..."
    else
        print *, "listOfGrids already allocated!"
    endif
    
    
end subroutine init_nodes

!  Generic driver routine for 2D Clawpack 5.0, using claw2ez
!  Allocation has been moved int claw2ez; this file essentially
!  does nothing, but is being retained because it gives the
!  codebase more flexibility.
program driver
    implicit none

    call claw2ez

    stop
end program driver

! ==============================================================================
!  This Riemann solver provides a harness for the point-wise evaluation of 
!  Riemann solutions and requires a point-wise definition of the Riemann solver
!  in a subroutine of the form "rpn2_ptwise".
! ==============================================================================

subroutine rpn2(ixy, maxm, meqn, mwaves, maux, mbc, mx, ql, qr, auxl, auxr,   &
                wave, s, amdq, apdq)

    implicit none

    ! Input
    integer, intent(in) :: ixy, maxm, meqn, mwaves, maux, mbc, mx
    real(kind=8), intent(in out) :: ql(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: qr(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: auxl(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: auxr(maux, 1-mbc:maxm+mbc)

    ! Output
    real(kind=8), intent(in out) :: wave(meqn, mwaves, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: s(mwaves, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: amdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: apdq(meqn, 1-mbc:maxm+mbc)

    ! Locals
    integer :: i

    do i = 2 - mbc, mx + mbc

        call rpn2_ptwise(ixy, meqn, maux, mwaves, qr(:, i - 1),     &
                                                  ql(:, i),         &
                                                  auxr(:, i - 1),   &
                                                  auxl(:, i),       &
                                                  wave(:, :, i),    &
                                                  s(:, i),          &
                                                  amdq(:, i),       &
                                                  apdq(:, i))

    end do

end subroutine rpn2

c
c ----------------------------------------------------------
c
      subroutine prepc(level,nvar)
c
      use amr_module
      implicit double precision (a-h,o-z)

      parameter(numbcs=4)
c
c :::::::::::::::::::: PREPC ::::::::::::::::::::::::::::::::::::::
c
c this routine called because regridding just changed the fine grids.
c modify coarse grid boundary lists to store fluxes in appropriate
c fine grids lists.
c assume new fine grids have node(cfluxptr) initialized to null
c
c  first compute max. possible number of list cells. allocate
c  initially so that one pass through is enough.
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      maxsp  = 0
      mkid   = lstart(level+1)

 10   if (mkid .eq. 0) go to 20
c        Adding twice perimeter (which is just one cell
c         on each side)
         maxsp  = maxsp + 2
      mkid = node(levelptr,mkid)
      go to 10
 20   listsp(level) = maxsp
      if (maxsp .eq. 0) go to 99
c
      hxpar   = hxposs(level)
      hxkid   = hxposs(level+1)
      imax    = iregsz(level) - 1

      mpar = lstart(level)
 30   if (mpar .eq. 0) go to 99
c
       ispot   = 0
       ilo     = node(ndilo,mpar)
       ihi     = node(ndihi,mpar)
       locbc   = igetsp(numbcs*maxsp)
c      #  initialize list to 0 (0 terminator indicates end of bc list)
       do 35 i = 1,numbcs*maxsp
 35      alloc(locbc+i-1) = 0.d0
       node(cfluxptr,mpar) = locbc
c
       mkid = lstart(level+1)
 40    if (mkid .eq. 0) go to 60

          iclo = node(ndilo,mkid)/intratx(level)
          ichi = node(ndihi,mkid)/intratx(level)

          iplo = max(ilo,iclo)
          iphi = min(ihi,ichi)

c   regular intersections (will check in setuse that no duplication)
c   this first call is only interior interfaces. 

          if (iplo .le. iphi+1) then
               kflag = 1 ! interior stuff, no mappings

                call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,iclo,ichi,kflag)

          endif

c   for fine grids touching periodic boundary on right
          if  (xperdom .and. ilo .eq. 0 .and. ichi .eq. imax) then
              kflag = 1 ! periodic in x
              call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,iclo-iregsz(level),ichi-iregsz(level),
     3          kflag)
           endif

c   for fine grids touching periodic boundary on left
          if  (xperdom .and. iclo .eq. 0 .and. ihi .eq. imax) then
              kflag = 1
              call setuse(alloc(locbc),maxsp,ispot,mkid,
     2          ilo,ihi,iclo+iregsz(level),ichi+iregsz(level),
     3          kflag)
          endif

 50     mkid = node(levelptr,mkid)
        go to 40
c
c  done with subgrid cycle. if no cells would need fixing, all done
c  else cycle through again to set up list with info. for bc processing
c
 60     continue
c
c  for now, leave unused space allocated to the grid. alternative is to
c  return (maxsp-ispot) amt starting at loc node(cfluxptr,mpar)+ispot.
c
       mpar = node(levelptr,mpar)
       go to 30
c
 99    return
       end

c     ============================================
      subroutine movetopo(mbc,mx,my,
     &     xlow,ylow,dx,dy,t,dt,maux,aux,dtopo,
     &     xlowdtopo,ylowdtopo,xhidtopo,yhidtopo,t0dtopo,tfdtopo,
     &     dxdtopo,dydtopo,dtdtopo,mxdtopo,mydtopo,mtdtopo,mdtopo,
     &     minleveldtopo,maxleveldtopo,topoaltered)
c     ============================================
c
c     This routine changes the topography dynamically.
c     It also changes the actual topo array after the motion has ended.
c     Topography is stored in aux(i,j,1).
c
c
      use geoclaw_module
      use amr_module

      use topo_module, only: topowork
      use topo_module, only: mtopofiles,mtoposize
      use topo_module, only: xlowtopo, ylowtopo, tlowtopo
      use topo_module, only: xhitopo, yhitopo, thitopo
      use topo_module, only: dxtopo, dytopo
      use topo_module, only: topotime
      use topo_module, only: mxtopo, mytopo

      use topo_module, only: i0topo, mtopo, mtopoorder
      use topo_module, only: topoID


      implicit double precision (a-h,o-z)
      dimension aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
      dimension dtopo(mxdtopo,mydtopo,mtdtopo)

      logical topoaltered

      dimension auxorig(maux,-1:mx+mbc,-1:my+mbc)

        t0=t  !# start of coming timestep
        tf=t+dt !# end of coming timestep
        t2=t0+0.5d0*dt
        tt=t2 !# this is the time in the fault file that will be used for this timestep

c       write(26,*) 'MOVETOPO: tt, dt, t0dtopo: ',tt,dt,t0dtopo

        if (topoaltered.and.t0.le.tfdtopo) then
           write(*,*) 'MOVETOPO: WARNING!'
           write(*,*) 'FAULT MOTION HAS COMPLETED PREMATURELY'
        endif
        if (topoaltered) return
        if (tf.lt.t0dtopo) return
        if (t0.gt.tfdtopo) go to 28

c     # change topography

        write(*,*) 'MOVETOPO: setting dtopo at time = ',t
c       write(26,*) 'MOVETOPO: setting dtopo at time = ',t

        if (tt.ge.tfdtopo) then
              kkm = mtdtopo
              kkp = mtdtopo
              tau = 1.d0
              go to 14
        endif

        if (tt.le.t0dtopo) then
              kkm = 1
              kkp = 1
              tau= 1.d0
              go to 14
        endif

        dkk = (tt-t0dtopo)/dtdtopo
        kkm = dint(dkk)+1
        kkp = dint(dkk)+2

        kkm = max(kkm,1)
        kkm = min(kkm,mtdtopo)

        kkp = max(kkp,1)
        kkp = min(kkp,mtdtopo)

        tdtopom = t0dtopo+dtdtopo*(kkm-1)
        tdtopop = tdtopom+dtdtopo
        tau = 1.d0-max(0.d0,((tt-tdtopom)/dtdtopo))
        tau = max(tau,0.d0)

 14     continue


c     # recreate original topography:
      auxorig(1,:,:) = NEEDS_TO_BE_SET
      call setaux(mbc,mx,my,xlow,ylow,dx,dy,
     &                  maux,auxorig)

c=======loop through the computational grid row by row====================
        do j=1-mbc,my+mbc
            ycell = ylow + (j-0.5d0)*dy
            yjm =   ylow + (j-1.d0)*dy
            yjp =   ylow + dble(j)*dy

c           if (yjm.ge.ylowdtopo.and.yjp.le.yhidtopo) then
           if (yjp.gt.ylowdtopo.and.yjm.lt.yhidtopo) then
              yjpc=min(yjp,yhidtopo)
              yjmc=max(yjm,ylowdtopo)
              dyc=yjpc-yjmc
              ycellc=0.5d0*(yjpc+yjmc)
c=========sweep through the columns of the computational row================
           do i=1-mbc,mx+mbc
              xcell =  xlow + (i- 0.5d0)*dx
              xim =    xlow + (i- 1.0d0)*dx
              xip =   xlow + dble(i)*dx


c              if (xim.ge.xlowdtopo.and.xip.le.xhidtopo) then
              if (xip.gt.xlowdtopo.and.xim.lt.xhidtopo) then
                 xipc=min(xip,xhidtopo)
                 ximc=max(xim,xlowdtopo)
                 dxc=xipc-ximc
                 xcellc=0.5d0*(xipc+ximc)
c==========alter aux(i,j,1) if it is in the dtopo region=====================

                 aux(1,i,j) = auxorig(1,i,j)

c==================dynamically alter the topography to the interpolated value=
                 dauxijm=0.d0
                 dauxijm = topointegral(ximc,xcellc,xipc,yjmc,
     &              ycellc,yjpc,xlowdtopo,ylowdtopo,dxdtopo,dydtopo,
     &              mxdtopo,mydtopo,dtopo(1,1,kkm),1)
                 dauxijm = dauxijm/(dxc*dyc*aux(2,i,j))

                 dauxijp=0.d0
                 dauxijp = topointegral(ximc,xcellc,xipc,yjmc,
     &              ycellc,yjpc,xlowdtopo,ylowdtopo,dxdtopo,dydtopo,
     &              mxdtopo,mydtopo,dtopo(1,1,kkp),1)
                 dauxijp = dauxijp/(dxc*dyc*aux(2,i,j))

                 aux(1,i,j)=aux(1,i,j)+tau*dauxijm+(1.d0-tau)*dauxijp

              endif
           enddo
           endif
         enddo

c============= end of altering topography dynamically========================


c        # if the aux cell is outside the physical domain,
c        # boundary conditions must be reset

         if (xlowdtopo.lt.xlower.and.
     &      xlow+(0.5d0-mbc)*dx.lt.xlower) then
            do j=1-mbc,my+mbc
               ycell = ylow +(j-0.5d0)*dy
               yjm = ylow  + (j-1.0d0)*dy
               yjp = ylow + dble(j)*dy

               xcell =  xlow + (1- 0.5d0)*dx
               xim =    xlow
               xip =    xlow + dx
               if ((xim.ge.xlowdtopo.and.xip.le.xhidtopo).and.
     &                     (yjm.ge.ylowdtopo.and.yjp.le.yhidtopo)) then

                   do i=1-mbc,0
                      aux(1,i,j) = aux(1,1,j)
                   enddo
               endif
            enddo
          endif

          if (xhidtopo.gt.xupper.and.
     &      xlow+(mx+mbc-0.5d0)*dx.gt.xupper) then
            do j=1-mbc,my+mbc
               ycell = ylow+(j-0.5d0)*dy
               yjm = ylow+(j-1.0d0)*dy
               yjp = ylow + dble(j)*dy

               xcell =  xlow + (mx-0.5d0)*dx
               xim =  xlow + (mx-1.d0)*dx
               xip =  xlow + dble(mx)*dx
               if ((xim.ge.xlowdtopo.and.xip.le.xhidtopo).and.
     &                     (yjm.ge.ylowdtopo.and.yjp.le.yhidtopo)) then

                   do i=mx+1,mx+mbc
                      aux(1,i,j) = aux(1,mx,j)
                   enddo
               endif
            enddo
          endif

          if (ylowdtopo.lt.ylower.and.
     &             ylow+(.5d0-mbc)*dy.lt.ylower) then
                  do i=1-mbc,mx+mbc
               ycell = ylow+(1-0.5d0)*dy
               yjm = ylow
               yjp = ylow + dy

               xcell =  xlow + (i- 0.5d0)*dx
               xim =  xlow + (i- 1.d0)*dx
               xip = xlow + dble(i)*dx

               if ((xim.ge.xlowdtopo.and.xip.le.xhidtopo).and.
     &                     (yjm.ge.ylowdtopo.and.yjp.le.yhidtopo)) then

                   do j=1-mbc,0
                      aux(1,i,j) = aux(1,i,1)
                   enddo
               endif
            enddo
          endif

          if (yhidtopo.gt.yupper.and.
     &             ylow+(my+mbc-0.5d0)*dy.gt.yupper) then
            do i=1-mbc,mx+mbc
               ycell = ylow+(my-0.5d0)*dy
               yjm = ylow+(my-1.d0)*dy
               yjp = ylow+ dble(my)*dy

               xcell =  xlow + (i- 0.5d0)*dx
               xim =   xlow + (i- 1.d0)*dx
               xip =  xlow + dble(i)*dx

               if ((xim.ge.xlowdtopo.and.xip.le.xhidtopo).and.
     &                      (yjm.ge.ylowdtopo.and.yjp.le.yhidtopo)) then

                   do j=my+1,my+mbc
                      aux(1,i,j) = aux(1,i,my)
                   enddo
               endif
            enddo
          endif
c===========================B.C.'s reset========================================



c============= statically change topowork array for next call to setaux====
 28     continue
        if (tt-dt.gt.tfdtopo) then
c       if (.false.) then
          topoaltered=.true.  !# so this procedure only done once
          write(*,*) 'MOVETOPO: Altering topography arrays at t=',t
          write(*,*) 'MOVETOPO: Topography Motion Complete'
          do m=1,mtopofiles
            if (xlowtopo(m).lt.xhidtopo.and.xhitopo(m).gt.xlowdtopo
     &                .and.ylowtopo(m).lt.yhidtopo.and.
     &                yhitopo(m).gt.ylowdtopo) then

            do ib=1,mxtopo(m)
              xcell=xlowtopo(m) + (ib-.5d0)*dxtopo(m)
              xim=xlowtopo(m) + (ib-1.d0)*dxtopo(m)
              xip=xlowtopo(m) + ib*dxtopo(m)

             if (xim.lt.xhidtopo.and.xip.gt.xlowdtopo) then
                ximc=max(xim,xlowdtopo)
                xipc=min(xip,xhidtopo)
                dxc=xipc-ximc
                xcellc=0.5d0*(ximc+xipc)

               do jb=1,mytopo(m)
                     ycell=ylowtopo(m) + (jb-.5d0)*dytopo(m)
                     yjm=ylowtopo(m) + (jb-1.d0)*dytopo(m)
                     yjp = ylowtopo(m) + jb*dytopo(m)

                if (yjm.lt.yhidtopo.and.yjp.gt.ylowdtopo) then !orig changed to match 4-x
C                 if (yjm.lt.yhidtopo.and.yjp.gt.ylowdtopo) then
                    yjmc=max(yjm,ylowdtopo)
                    yjpc=min(yjp,yhidtopo)
                    dyc = yjpc-yjmc
                    ycellc= 0.5d0*(yjmc+yjpc)

                    ztopoij = 0.d0
                    ztopoij = topointegral(ximc,xcellc,xipc,yjmc,ycellc,
     &                   yjpc,xlowdtopo,ylowdtopo,dxdtopo,dydtopo,
     &                   mxdtopo,mydtopo,dtopo(1,1,mtdtopo),1)

c                  # topointegral actually integrates,
c                  #so need to divide by area
c                  #physical area of cell depends on coordinate system
                   ztopoij=ztopoij/(dxc*dyc)
                   if (coordinate_system.eq.2) then
                     capac_area = deg2rad*earth_radius**2*
     &               (sin(yjp*deg2rad)-sin(yjm*deg2rad))/dyc
                     ztopoij=ztopoij/capac_area
                   endif

                   jbr = mytopo(m)-jb+1
                   ij = i0topo(m) + (jbr-1)*mxtopo(m) +ib -1
                   topowork(ij) = topowork(ij)+ztopoij
                endif
               enddo
            endif
           enddo
          endif
          enddo
        endif
c=================================================================================


      return
      end

c
c -------------------------------------------------------------
c
      subroutine errest (nvar,naux,lcheck,mptr,nx)
c
      use amr_module
      use adjoint_module, only : adjoint_flagging, errf1a
      implicit double precision (a-h,o-z)
c
c   ### changed to stack based storage 2/23/13 
c   ### and broken into smaller routines to minimize 
c   ### stack space

      integer, intent(in) :: nvar,naux,lcheck,nx

      double precision valbgc(nvar,nx/2+2*nghost)
      double precision auxbgc(naux,nx/2+2*nghost)
     
 
c :::::::::::::::::::::::::: ERREST :::::::::::::::::::::::::::::::::::
c for this grid at level lcheck:
c  estimate the error by taking a large (2h,2k) step based on the
c  values in the old storage loc., then take one regular (and for
c  now wasted) step based on the new info.   compare using an
c  error relation for a pth order  accurate integration formula.
c  flag error plane as either bad (needs refinement), or good.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
       mitot  = nx + 2*nghost
       locnew = node(store1,mptr)
       locold = node(store2,mptr)
       locaux = node(storeaux,mptr)
       mi2tot = nx/2  + 2*nghost
c
c     prepare double the stencil size worth of boundary values,
c            then coarsen them for the giant step integration.
       midub = nx+4*nghost
c
       call prepbigstep(nvar,naux,lcheck,mptr,nx,midub,
     .                    valbgc,auxbgc,mi2tot)

c
c  the one giant step based on old values is done. now take
c  one regular step based on new values. 
c  boundary values already in locbig, (see subr. flagger)
c
      locbig = node(tempptr,mptr)
      locaux = node(storeaux,mptr)
      call prepregstep(nvar,naux,lcheck,mptr,nx,mitot,
     .                 alloc(locbig),alloc(locaux))
c
c     ## locamrflags allocated in flagger. may previously have been used 
c     ## by flagregions1 or flag2refine so make sure not to overwrite
      locamrflags = node(storeflags, mptr)    
      mbuff = max(nghost,ibuff+1)  
      mibuff = nx + 2*mbuff
      if(adjoint_flagging) then
          call errf1a(alloc(locbig),nvar,valbgc,mptr,mi2tot,
     1           mitot,alloc(locamrflags),mibuff,
     1           alloc(locaux),naux)
      else
          call errf1(alloc(locbig),nvar,valbgc,mptr,mi2tot,
     1           mitot,alloc(locamrflags),mibuff)
      endif

c
      return
      end

subroutine src1(meqn,mbc,mx,xlower,dx,q,maux,aux,t,dt)

    ! Called to update q by solving source term equation
    ! $q_t = \psi(q)$ over time dt starting at time t.
    !
    ! This default version integrates manning friction or other friction terms if present
    
    ! Version from 1D branch of GeoClaw originally from Dave George

    ! Also handles radial source term, if desired.
    ! Note: assumes radial about lower boundary, wall bc should be imposed

    
    use geoclaw_module, only: dry_tolerance, grav, DEG2RAD
    use geoclaw_module, only: friction_forcing
    use geoclaw_module, only: frictioncoeff => friction_coefficient
    use geoclaw_module, only: earth_radius, coordinate_system
    use grid_module, only: xcell
    use bouss_module, only: boussEquations, alpha, cm1, c01, cp1, &
                      solve_tridiag_ms, build_tridiag_sgn, &
                      solve_tridiag_sgn, useBouss


    implicit none
    integer, intent(in) :: mbc,mx,meqn,maux
    real(kind=8), intent(in) :: xlower,dx,t,dt
    real(kind=8), intent(in) ::  aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) ::  q(meqn,1-mbc:mx+mbc)

    ! Locals
    real(kind=8) :: eta(0:mx+1)
    real(kind=8) :: gamma, rcell, u, tanxR, etax
    real(kind=8) :: rk_stage(1:mx,4), delt
    integer ::  i,k,ii,rk_order
    real(kind=8)  q0(meqn,1-mbc:mx+mbc)
    real(kind=8) psi(mx+2)

    

      if (frictioncoeff.gt.0.d0 .and. friction_forcing) then
          ! integrate source term based on Manning formula
            do i=1,mx
               if (q(1,i)<=dry_tolerance) then
                  q(2,i) = 0.0
               else
                  gamma= dsqrt(q(2,i)**2)*(grav*frictioncoeff**2)/(q(1,i)**(7.0/3.0))
                  q(2,i)= q(2,i)/(1.d0 + dt*gamma)
              endif
            enddo
        endif

!      ----------------------------------------------------------------

    if (coordinate_system == -1) then
        ! radial source term for SWE:
        do i=1,mx
            if (q(1,i) .gt. dry_tolerance) then
                ! x is radial coordinate in meters, x>=0, 
                ! u = radial velocity
                q(1,i) = q(1,i) - dt/xcell(i) * q(2,i)
                u = q(2,i)/q(1,i)
                q(2,i) = q(2,i) - dt/xcell(i) * q(1,i)*u**2
            endif
         enddo
     endif

!      ----------------------------------------------------------------

    if (coordinate_system == 2) then
        ! source term for x = latitude in degrees -90 <= x <= 90,
        ! u = velocity in latitude direction (m/s) on sphere:
        do i=1,mx
            if (q(1,i) .gt. dry_tolerance) then
                tanxR = tan(xcell(i)*DEG2RAD) / earth_radius
                q(1,i) = q(1,i) + dt * tanxR * q(2,i)
                u = q(2,i)/q(1,i)
                q(2,i) = q(2,i) + dt * tanxR * q(1,i)*u**2
            endif
         enddo
     endif

    ! -------------------------------------------------
    if (boussEquations > 0) then
        
        ! Boussinesq terms 

        rk_order = 1  ! 1 for Forward Euler, 2 for second-order RK
        delt = dt / rk_order

        if (boussEquations == 2) then
            ! for SGN, need to factor matrix each step
            call build_tridiag_sgn(meqn,mbc,mx,xlower,dx,q,maux,aux)
        endif
                
        q0  = q
          
        do i=0,mx+1
           if (q(1,i) > dry_tolerance) then
               eta(i) = q(1,i)+aux(1,i)
           else
               eta(i) = 0.d0
           endif
        enddo

        !-----------------------
        ! First stage (only stage for rk_order == 1):
        
        if (boussEquations == 1) then
          call solve_tridiag_ms(mx,meqn,mbc,dx,q0,maux,aux,psi)
          ! returns solution psi = source term for Madsen
        else if (boussEquations == 2) then
          call solve_tridiag_sgn(mx,meqn,mbc,dx,q0,maux,aux,psi)
          ! modify solution psi for source term of SGN:
          do i=1,mx
              if (useBouss(i)) then
                  etax = cm1(i)*eta(i-1) + c01(i)*eta(i) + cp1(i)*eta(i+1)
                  psi(i+1) = q(1,i) * (grav/alpha * etax - psi(i+1))
              else
                  psi(i+1) = 0.d0
              endif
           enddo
        endif
              
        ! Forward Euler update to momentum q(2,:):
        ! Note psi(1) used for BC, so psi(i+1) updates q(2,i):
        q0(2,1:mx) = q0(2,1:mx) + delt*psi(2:mx+1)
          

        !-----------------------
        if (rk_order == 1) then
            q = q0 ! and we are done
              
        else if (rk_order == 2) then

            ! Second stage for 2-stage R-K, solve for psi at midpoint
            ! in time based on q0 computed in first stage:
            
            if (boussEquations == 1) then
                call solve_tridiag_ms(mx,meqn,mbc,dx,q0,maux,aux,psi)
                ! returns solution psi = source term for Madsen
            else if (boussEquations == 2) then
                call solve_tridiag_sgn(mx,meqn,mbc,dx,q0,maux,aux,psi)
                ! modify solution psi for source term of SGN:
                do i=1,mx
                    ! note that h,eta were not changed by first stage
                    if (useBouss(i)) then
                        etax = cm1(i)*eta(i-1) + c01(i)*eta(i) + cp1(i)*eta(i+1)
                        psi(i+1) = q(1,i) * (grav/alpha * etax - psi(i+1))
                    else
                        psi(i+1) = 0.d0
                    endif
                enddo
            endif
              
            ! Second stage is midpoint method dt=delt*2:
            ! Note psi(1) used for BC, so psi(i+1) updates q(2,i):
            q(2,1:mx) = q(2,1:mx) + 2.d0*delt*psi(2:mx+1)

        endif ! rk_order == 2

    endif ! end of Bouss terms


end subroutine src1

c
c
c
c     =====================================================
       subroutine qinit(meqn,mbc,mx,my,mz, xlower,ylower,zlower,
     &                  dx,dy,dz,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c
       implicit double precision (a-h,o-z)
c
       dimension q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
       dimension x(1-mbc:mx+mbc)
       dimension aux(maux,1-mbc:mx+mbc, 1-mbc:my+mbc,1-mbc:mz+mbc)
c
c     # set concentration profile
c     ---------------------------
c

       do i = 1-mbc,mx+mbc
          x(i) = xlower + (i-0.5d0)*dx
       enddo

       do i = 1,mx
          if (x(i) .lt.  0.5d0) then
             do j = 1,my
                do k = 1,mz
                   q(1,i,j,k) = 1.d0
                enddo
             enddo
          else
             do j = 1,my
                do k = 1,mz
                   q(1,i,j,k) = 0.d0
                enddo
            enddo
         endif
      enddo

      return
      end

c
c     ==================================================================
      subroutine step3z(maxm,meqn,maux,mbc,mx,my,mz,
     &                 qold,aux,dz,dt,cflgrid,
     &                 hm,hp,rpn3)
c     ==================================================================

c     # clawpack routine ...  modified for AMRCLAW

c
c     # Take one time step, updating q.
c     # On entry, qold gives
c     #    initial data for this step
c     #    and is unchanged in this version.
c
c     # fm, fp are fluxes to left and right of single cell edge
c
c     # See the flux3 documentation for more information.
c
c
      use amr_module
      implicit double precision(a-h,o-z)

      external rpn3

      dimension
     & qold(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
      dimension q1d(meqn, 1-mbc:maxm+mbc)
c
      dimension hm(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension hp(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
c
      dimension faddm(meqn, 1-mbc:maxm+mbc)
      dimension faddp(meqn, 1-mbc:maxm+mbc)
c
      dimension
     & aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc, 1-mbc:mz+mbc)
      dimension aux2(maux, 1-mbc:maxm+mbc)
      dimension dtdz1d(1-mbc:maxm+mbc)
c
      cflgrid = 0.d0
      dtdz = dt/dz
c
      do 10 i=1-mbc,mx+mbc
         do 10 j=1-mbc,my+mbc
            do 10 k=1-mbc,mz+mbc
               do 10 m=1,meqn
                  hm(m,i,j,k) = 0.d0
                  hp(m,i,j,k) = 0.d0
 10            continue

c
      if (mcapa.eq.0) then
c        # no capa array:
         do 5 i=1-mbc,maxm+mbc
            dtdz1d(i) = dtdz
    5       continue
         endif
c
c
c     # perform z sweeps (for Godunov split method, called from stepgrid_dimSplit)
    ! loop indices assume x sweep goes first, then y. z goes last
c     ==================
c
c
      do 150 j = 1, my
         do 150 i = 1, mx
c
            do 110 k = 1-mbc, mz+mbc
               do 110 m=1,meqn
c                 # copy data along a slice into 1d array:
                  q1d(m,k) = qold(m,i,j,k)
 110           continue
c
         if (mcapa.gt.0)  then
           do 130 k = 1-mbc, mz+mbc
               dtdz1d(k) = dtdz / aux(mcapa,i,j,k)
 130       continue
         endif
c
         if (maux .gt. 0)  then
            do 131 k = 1-mbc, mz+mbc
               do 131 ma=1,maux
                 aux2(ma,k) = aux(ma,i,j,k) 
  131          continue
           endif
c
c           # compute modifications fadd to fluxes along this slice:
c
            call flux3_dimSplit(3,maxm,meqn,maux,mbc,mz,
     &                 q1d,dtdz1d,aux2,
     &                 faddm,faddp,cfl1d,
     &                 rpn3)
c
            cflgrid = dmax1(cflgrid,cfl1d)
c
c
c        # update fluxes for use in AMR:
c           # Note that the roles of the flux updates are changed.
c           # fadd - modifies the h-fluxes
c
            do 125 k=1,mz+1
               do 125 m=1,meqn
               hm(m,i,j,k) = hm(m,i,j,k) + faddm(m,k)
               hp(m,i,j,k) = hp(m,i,j,k) + faddp(m,k)
  125          continue
  150    continue
c
c
      return
      end

c     
c     
c=========================================================
      subroutine copyq1(meqn,mbc,mx,q1,q2)
c=========================================================
c     
c     # copy the contents of q1 into q2
c     
      implicit double precision (a-h,o-z)
      dimension q1(meqn,1-mbc:mx+mbc)
      dimension q2(meqn,1-mbc:mx+mbc)
c     
      do i = 1-mbc, mx+mbc
         do m=1,meqn
            q2(m,i) = q1(m,i)
         end do
      end do
      return
      end

! Riemann solver in the transverse direction for the Euler equations
!  with a tracer variable.
! Split asdq (= A^* \Delta q, where * = + or -)
! into down-going flux difference bmasdq (= B^- A^* \Delta q)
!    and up-going flux difference bpasdq (= B^+ A^* \Delta q)

! Uses Roe averages and other quantities which were
! computed in rpn2eu and stored in the common block comroe.
!
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,aux1,aux2,aux3,asdq,bmasdq,bpasdq)

    implicit none

    ! Input
    integer, intent(in) :: ixy, imp, maxm, meqn, mwaves, mbc, mx, maux
    real(kind=8), intent(in) :: ql(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: qr(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: aux1(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: aux2(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: aux3(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) :: asdq(meqn, 1-mbc:maxm+mbc)
    
    ! Output
    real(kind=8), intent(in out) :: bmasdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in out) :: bpasdq(meqn, 1-mbc:maxm+mbc)

    ! Local storage
    integer :: i, mw, mu, mv
    real(kind=8) :: a(4), waveb(5,4), sb(4), rho_sqrtl, rho_sqrtr, rho_sq2
    real(kind=8) :: u, v, u2v2, pl, pr, enth, c, g1c2, euv

    ! Common block - ideal gas constant
    real(kind=8) :: gamma, gamma1
    common /cparam/  gamma

    gamma1 = gamma - 1.d0

    ! Initialize output
    bmasdq = 0.d0
    bpasdq = 0.d0

    ! Normal and transverse direction indices
    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    ! Primary loop over grid cell interfaces
    do i = 2-mbc, mx+mbc
        ! Roe averaged variables
        rho_sqrtl = dsqrt(qr(1,i-1))
        rho_sqrtr = dsqrt(ql(1,i))
        rho_sq2 = rho_sqrtl + rho_sqrtr
        u = (qr(mu,i-1) / rho_sqrtl + ql(mu,i) / rho_sqrtr) / rho_sq2
        v = (qr(mv,i-1) / rho_sqrtl + ql(mv,i) / rho_sqrtr) / rho_sq2
        u2v2 = u**2 + v**2

        pl = gamma1*(qr(4,i-1) - 0.5d0*(qr(2,i-1)**2 + qr(3,i-1)**2)/qr(1,i-1))
        pr = gamma1*(ql(4,i)   - 0.5d0*(ql(2,i)**2   + ql(3,i)**2)  /ql(1,i))
        enth = (((qr(4,i-1)+pl)/rho_sqrtl + (ql(4,i)+pr)/rho_sqrtr)) / rho_sq2

        c = sqrt(gamma1*(enth - 0.5d0*u2v2))
        g1c2 = gamma1 / c**2
        euv = enth - u2v2

        a(3) = g1c2 * (euv*asdq(1,i) + u*asdq(mu,i) + v*asdq(mv,i) - asdq(4,i))
        a(2) = asdq(mu,i) - u*asdq(1,i)
        a(4) = (asdq(mv,i) + (c-v)*asdq(1,i) - c*a(3)) / (2.d0*c)
        a(1) = asdq(1,i) - a(3) - a(4)
    
        waveb(1,1) = a(1)
        waveb(mu,1) = a(1)*u
        waveb(mv,1) = a(1)*(v-c)
        waveb(4,1) = a(1)*(enth - v*c)
        waveb(5,1) = 0.d0
        sb(1) = v - c
    
        waveb(1,2) = a(3)
        waveb(mu,2) = a(3)*u + a(2)
        waveb(mv,2) = a(3)*v
        waveb(4,2) = a(3)*0.5d0*u2v2 + a(2)*u
        waveb(5,2) = 0.d0
        sb(2) = v
    
        waveb(1,3) = a(4)
        waveb(mu,3) = a(4)*u
        waveb(mv,3) = a(4)*(v+c)
        waveb(4,3) = a(4)*(enth+v*c)
        waveb(5,3) = 0.d0
        sb(3) = v + c
    
        waveb(1,4) = 0.d0
        waveb(mu,4) = 0.d0
        waveb(mv,4) = 0.d0
        waveb(4,4) = 0.d0
        waveb(5,4) = asdq(5,i)
        sb(4) = v
    
        ! Compute the flux differences bmasdq and bpasdq
        do mw=1,4
            bmasdq(:,i) = bmasdq(:,i) + min(sb(mw), 0.d0) * waveb(:,mw)
            bpasdq(:,i) = bpasdq(:,i) + max(sb(mw), 0.d0) * waveb(:,mw)
        end do
    end do

end subroutine rpt2

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! ::::::     Support module for the adjoint_module.
! :::::: This module contains subroutines that are specific
! :::::: to GeoClaw, and is modified from a similar module that
! :::::: is specific to AMRClaw.
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

module adjointsup_module

contains

! ========================================================================
!  Routine to calculate inner product
! ========================================================================

    subroutine calculate_innerproduct(q,k,mx_f,my_f,xlower_f, &
               ylower_f,dx_f,dy_f,meqn_f,mbc_f,maux_f,aux)

        use adjoint_module
        use amr_module, only : flag_richardson, flag_gradient

        implicit none

        real(kind=8), intent(in) :: xlower_f,ylower_f,dx_f,dy_f
        integer :: k,mx_f,my_f,meqn_f,mbc_f,maux_f
        real(kind=8), intent(in) :: q(meqn_f,1-mbc_f:mx_f+mbc_f,1-mbc_f:my_f+mbc_f)

        integer :: mx_a, my_a, mptr_a, mbc_a
        integer :: i, j, i1, i2, j1, j2, level, loc, z
        real(kind=8) :: dx_a, xlower_a, xupper_a, xupper_f
        real(kind=8) :: dy_a, ylower_a, yupper_a, yupper_f
        real(kind=8) :: x1, x2, y1, y2

        real(kind=8) :: q_innerprod(mx_f,my_f)
        logical :: mask_forward(mx_f,my_f)
        ! q_interp depends on the number of euqations for the adjoint,
        ! so that eta is taken into account
        real(kind=8) :: q_interp(adjoints(k)%meqn,mx_f,my_f), eta
        real(kind=8), intent(inout) :: aux(maux_f,1-mbc_f:mx_f+mbc_f,1-mbc_f:my_f+mbc_f)

        logical, allocatable :: mask_adjoint(:,:)

        xupper_f = xlower_f + mx_f*dx_f
        yupper_f = ylower_f + my_f*dy_f

        ! Loop over patches in adjoint solution
        do z = 1, adjoints(k)%ngrids
            mptr_a = adjoints(k)%gridpointer(z)
            level = adjoints(k)%gridlevel(mptr_a)

            ! Number of points in x and y
            mx_a = adjoints(k)%ncellsx(mptr_a)
            my_a = adjoints(k)%ncellsy(mptr_a)

            ! Finding extreem values for grid
            xlower_a = adjoints(k)%xlowvals(mptr_a)
            dx_a = adjoints(k)%hxposs(level)
            xupper_a = xlower_a + mx_a*dx_a
            ylower_a = adjoints(k)%ylowvals(mptr_a)
            dy_a = adjoints(k)%hyposs(level)
            yupper_a = ylower_a + my_a*dy_a

            loc = adjoints(k)%loc(mptr_a)

            ! Check if adjoint patch overlaps with forward patch
            x1 = max(xlower_f,xlower_a)
            x2 = min(xupper_f,xupper_a)
            y1 = max(ylower_f,ylower_a)
            y2 = min(yupper_f,yupper_a)

            if ((x1 > x2) .or. (y1 > y2)) then
                ! Skipping interpolation if grids don't overlap
                mask_forward = .false.
                continue
            else
                mbc_a = adjoints(k)%nghost
                allocate(mask_adjoint(1-mbc_a:mx_a+mbc_a, 1-mbc_a:my_a+mbc_a))

                ! Create a mask that is .true. only in part of patch intersecting forward patch:
                i1 = max(int((x1 - xlower_a + 0.5d0*dx_a) / dx_a), 0)
                i2 = min(int((x2 - xlower_a + 0.5d0*dx_a) / dx_a) + 1, mx_a+1)
                j1 = max(int((y1 - ylower_a + 0.5d0*dy_a) / dy_a), 0)
                j2 = min(int((y2 - ylower_a + 0.5d0*dy_a) / dy_a) + 1, my_a+1)

                forall (i=1-mbc_a:mx_a+mbc_a, j=1-mbc_a:my_a+mbc_a)
                    mask_adjoint(i,j) = ((i >= i1) .and. (i <= i2) .and. &
                            (j >= j1) .and. (j <= j2))
                end forall

                ! Create a mask that is .true. only in part of forward patch intersecting patch:

                i1 = max(int((x1 - xlower_f + 0.5d0*dx_f) / dx_f)+1, 0)
                i2 = min(int((x2 - xlower_f + 0.5d0*dx_f) / dx_f), mx_f)
                j1 = max(int((y1 - ylower_f + 0.5d0*dy_f) / dy_f)+1, 0)
                j2 = min(int((y2 - ylower_f + 0.5d0*dy_f) / dy_f), my_f)

                forall (i=1:mx_f, j=1:my_f)
                    mask_forward(i,j) = ((i >= i1) .and. (i <= i2) .and. &
                             (j >= j1) .and. (j <= j2))
                end forall

                ! Interpolate adjoint values to q_interp
                ! Note that values in q_interp will only be set properly where
                ! mask_adjoint == .true.
                call interp_adjoint( &
                    adjoints(k)%meqn, k, q_interp, xlower_a, ylower_a, &
                    dx_a, dy_a, mx_a, my_a, xlower_f, ylower_f, &
                    dx_f, dy_f, mx_f, my_f, &
                    mask_adjoint, mptr_a, mask_forward)

                q_innerprod = 0.d0

                ! Checking wet and dry states
                ! Needed for geoclaw so we don't interpolate 
                ! between wet and dry cells
                forall(i = 1:mx_f, j = 1:my_f, mask_forward(i,j))
                    mask_forward(i,j) = (mask_forward(i,j) .and. &
                          (aux(1,i,j) < 0.d0) .and. &
                          (q_interp(4,i,j) - q_interp(1,i,j) < 0.d0))
                end forall

                ! For each valid point, calculate inner product

                ! Note, in geoclaw the inner product uses eta
                ! rather than q(1,i,j)
                if (flag_gradient) then
                  forall(i = 1:mx_f, j = 1:my_f, mask_forward(i,j))
                      q_innerprod(i,j) = abs( &
                        (q(1,i,j) + aux(1,i,j)) * q_interp(4,i,j) &
                        + q(2,i,j) * q_interp(2,i,j) &
                        + q(3,i,j) * q_interp(3,i,j))
                  end forall
                endif

                ! When using richardson error, q contains the error 
                ! in each term. q(1,i,j) contains the error in eta.
                if (flag_richardson) then
                  forall(i = 1:mx_f, j = 1:my_f, mask_forward(i,j))
                    q_innerprod(i,j) = abs( &
                        q(1,i,j) * q_interp(4,i,j) &
                        + q(2,i,j) * q_interp(2,i,j) &
                        + q(3,i,j) * q_interp(3,i,j))
                  end forall
                endif


                do i=1,mx_f
                    do j=1,my_f
                        if (q_innerprod(i,j) > aux(innerprod_index,i,j)) then
                            aux(innerprod_index,i,j) = q_innerprod(i,j)
                        endif
                    enddo
                enddo

                deallocate(mask_adjoint)
            endif
        enddo


    end subroutine calculate_innerproduct

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
! :::::     Routine to interpolate adjoint to given x,y point
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

    subroutine interp_adjoint(nvar, r, q_interp, xlower_a, ylower_a, &
              dx_a, dy_a, mx_a, my_a, xlower_f, ylower_f, dx_f, &
              dy_f, mx_f, my_f, mask_adjoint, mptr_a, mask_forward)

      use adjoint_module, only: adjoints
      implicit none

      ! Function arguments
      integer, intent(in) :: nvar, r, mx_a, my_a
      logical, intent(in) :: mask_adjoint( &
                        1-adjoints(r)%nghost:mx_a+adjoints(r)%nghost, &
                        1-adjoints(r)%nghost:my_a+adjoints(r)%nghost)
      real(kind=8), intent(in) :: xlower_a, xlower_f, ylower_a, ylower_f
      integer, intent(in) :: mx_f, my_f, mptr_a
      real(kind=8), intent(in) :: dx_f, dx_a, dy_f, dy_a

      integer :: z, k, iz, jk, mitot
      integer :: ivar, i, j, iadd, loc
      real(kind=8) :: q_interp(nvar,mx_f,my_f), denom
      real(kind=8) :: x, xhigh_a, y, yhigh_a
      real(kind=8) :: dxz, dxzp, dyk, dykp, a, b, getaux
      logical :: mask_forward(mx_f,my_f)

      iadd(ivar,i,j)  = loc + ivar - 1 + nvar*((j-1)*mitot+i-1)
      getaux(i,j) = adjoints(r)%alloc(iadd(4,i,j)) &
                          - adjoints(r)%alloc(iadd(1,i,j))

      q_interp = 0.0
      xhigh_a  = xlower_a + mx_a*dx_a
      yhigh_a = ylower_a + my_a*dx_a
      loc    = adjoints(r)%loc(mptr_a)
      mitot = adjoints(r)%ncellsx(mptr_a) + 2*adjoints(r)%nghost

      do z = 1, mx_f
        do k = 1,my_f
          if (mask_forward(z,k)) then
            x = xlower_f + (z - 0.5d0)*dx_f
            y = ylower_f + (k - 0.5d0)*dy_f

            iz = int((x - xlower_a + 0.5d0*dx_a) / dx_a) + 1
            dxz = x - (xlower_a + (iz-0.5d0)*dx_a)
            dxzp = (xlower_a + ((iz+1)-0.5d0)*dx_a) - x
            jk = int((y - ylower_a + 0.5d0*dy_a) / dy_a) + 1
            dyk = y - (ylower_a + (jk-0.5d0)*dy_a)
            dykp = (ylower_a + ((jk+1)-0.5d0)*dy_a) - y

            ! Interpolate only if this cell is overlapping with grid
            if (mask_adjoint(iz,jk)) then
              do ivar=1,nvar

                ! Interpolate only if cells are in same wet/dry state
                if(getaux(iz+1,jk) <= 0.d0 .and. getaux(iz,jk) <= 0.d0) then
                  a = (dxzp*adjoints(r)%alloc(iadd(ivar,iz,jk)) + &
                      dxz*adjoints(r)%alloc(iadd(ivar,iz+1,jk)))/dx_a
                else
                  a = adjoints(r)%alloc(iadd(ivar,iz,jk))
                endif

                if(getaux(iz+1,jk+1) <= 0.d0 .and. getaux(iz,jk+1) <= 0.d0) then
                  b = (dxzp*adjoints(r)%alloc(iadd(ivar,iz,jk+1)) + &
                      dxz*adjoints(r)%alloc(iadd(ivar,iz+1,jk+1)))/dx_a
                else
                  b = adjoints(r)%alloc(iadd(ivar,iz,jk+1))
                endif

                if(getaux(iz,jk) <= 0.d0 .and. getaux(iz,jk+1) <= 0.d0) then
                  q_interp(ivar,z,k) = (dykp*a + dyk*b)/dy_a
                else
                  q_interp(ivar,z,k) = a
                endif

              enddo
            endif
          endif
        enddo
      enddo

    end subroutine interp_adjoint

! ========================================================================
!  Routine to compute error in forward solution for the adjoint method
!  Editted from errf1a.f in amrclaw to use aux arrays
!  and correctly account for wet/dry cells.
!  Differences:
!   (i) Computes error for all of the terms in q
!   (ii) Needs the aux array passed in, because the inner product is saved
!        to the aux array (note, this changes the call sequence, which is
!        why this is not included into the AMRClaw errf1.f file. If plotting
!        of the inner product is never wanted, this could be simplified
!        and included into the AMRClaw errf1.f file.
!
!        WARNING: Richardson error adjoint-flagging is not fully 
!        implemented in GeoClaw. This code may not work as expected. ========================================================================
    subroutine errf1a(rctfine,nvar,rctcrse,mptr,mi2tot,mj2tot, &
                      mitot,mjtot,rctflg,mibuff,mjbuff,auxfine, &
                      naux,auxcrse)

      use amr_module
      use adjoint_module, only: innerprod_index, &
             totnum_adjoints, adjoints, trange_start, trange_final, &
             levtol, eptr, errors, grid_num, select_snapshots
      use refinement_module, only: wave_tolerance
      use geoclaw_module, only:dry_tolerance, sea_level

      implicit double precision (a-h,o-z)

      dimension  rctfine(nvar,mitot,mjtot)
      dimension  rctcrse(nvar,mi2tot,mj2tot)
      dimension  rctflg(mibuff,mjbuff)
      dimension  err_crse(nvar,mi2tot,mj2tot)
      dimension  est(nvar,mitot,mjtot)
      dimension  bcrse(mitot,mjtot)
      dimension  auxfine(naux,mitot,mjtot)
      dimension  auxcrse(naux,mi2tot,mj2tot)

      logical mask_selecta(totnum_adjoints)
!
!
! ::::::::::::::::::::::: Modified from ERRF1 ::::::::::::::::::::::::
!
!  Richardson error estimator:  Used when flag_richardson is .true.
!  Compare error estimates in rctfine, rctcrse,
!  A point is flagged if the inner product between the
!  error estimate and the adjoint solution is greater than tol
!  later we check if its in a region where its allowed to be flagged
!  or alternatively required.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!

      write(*,*) "Warning: adjoint-error flagging ", &
            "isn't fully implemented for GeoClaw."

      time  = rnode(timemult, mptr)
      xleft = rnode(cornxlo,mptr)
      levm  = node(nestlevel, mptr)
      hx    = hxposs(levm)
      ybot  = rnode(cornylo,mptr)
      hy    = hyposs(levm)
      dt    = possk(levm)

      jg = grid_num(mptr)
      nx = mitot - 2*nghost
      ny = mjtot - 2*nghost

      call select_snapshots(time,mask_selecta)
 
      errmax = 0.0d0
      err2   = 0.0d0
      auxfine(innerprod_index,:,:) = 0.0d0
      auxcrse(innerprod_index,:,:) = 0.0d0

      order  = dble(2**(iorder+1) - 2)

!     Calculating correct tol for this level
!     --------------------
!     Total error allowed in this time step
      tol_exact = tol*dt/tfinal
!     Error allowed at this level
      tol_exact = tol_exact/(2**(levm - 1))
!     Error allowed per cell at this level
      tol_exact = tol_exact/(numcells(levm)*hx*hy)

      if (t0+possk(levm) .eq. time) levtol(levm) = tol_exact

!
! Setting up bathymetry 
! 
      jfine = nghost+1
      do j = nghost+1,mj2tot-nghost
          ifine = nghost+1
          do i = nghost+1,mi2tot-nghost

              bcrse(ifine,jfine) = auxcrse(1,i,j)
              bcrse(ifine+1,jfine) = auxcrse(1,i,j)
              bcrse(ifine+1,jfine+1) = auxcrse(1,i,j)
              bcrse(ifine,jfine+1) = auxcrse(1,i,j)

              ifine = ifine + 2
          enddo
          jfine = jfine + 2
      enddo

!
! Main loop: calculate errors in forward problem
!
      jfine = nghost+1
      do  j = nghost+1, mj2tot-nghost
          yofj  = ybot + (dble(jfine) - .5d0)*hy
          ifine = nghost+1

          do  i  = nghost+1, mi2tot-nghost

! Only check errors if flag hasn't been set yet.
! If flag == DONTFLAG then refinement is forbidden by a region,
! if flag == DOFLAG checking is not needed

! Note: here rctcrse is being used as a temporary flag
! the fine grid amrflags array is stored in rctflg, and will be
! updated based on rctcrse at the end of this routine

! Note: here, in contrast to errf1a for amrclaw, the error 
! estimates are being stored in a fine grid vector est  
! (a coarse grid vector err_crse is used in amrclaw)
           if(rctflg(ifine,jfine) == UNSET &
              .or. rctflg(ifine+1,jfine) == UNSET &
              .or. rctflg(ifine,jfine+1) == UNSET &
              .or. rctflg(ifine+1,jfine+1) == UNSET) then

              xofi  = xleft + (dble(ifine) - .5d0)*hx

              herr  = 0.d0
              huerr = 0.d0
              hverr = 0.d0
              etaerr= 0.d0
!
!             Calculate error for each value of q and eta
!             if course grid is in wet state
!
              if (mcapa .eq. 0) then
                  capacrse=1.0d0
              else
                  capacrse=auxcrse(2,i,j)
              endif

              hcrse = rctcrse(1,i,j)
              hucrse= rctcrse(2,i,j)
              hvcrse= rctcrse(3,i,j)

              etacrse = hcrse+bcrse(ifine,jfine)

              if (hcrse > dry_tolerance) then

!               # Calculating which values to use for error
                etasum= 0.d0
                hsum  = 0.d0
                husum = 0.d0
                hvsum = 0.d0
                bsum = 0.d0

                nwet=0

                do jco = 1,2
                  do ico = 1,2
                    if (mcapa .eq. 0) then
                      capa=1.0d0
                    else
                      capa=auxfine(2,ifine+ico-1,jfine+jco-1)
                    endif

                    hf =rctfine(1,ifine+ico-1,jfine+jco-1)*capa
                    huf=rctfine(2,ifine+ico-1,jfine+jco-1)*capa
                    hvf=rctfine(3,ifine+ico-1,jfine+jco-1)*capa

                    bf =auxfine(1,ifine+ico-1,jfine+jco-1)*capa

                    if (hf > dry_tolerance) then
                        etaf = hf+bf
                        nwet=nwet+1
                    else
                        etaf = 0.d0
                        huf=0.d0
                        hvf=0.d0
                        bf = 0.d0
                    endif

                    hsum   = hsum + hf
                    husum  = husum + huf
                    hvsum  = hvsum + hvf
                    etasum = etasum + etaf
                    bsum = bsum + bf
                  enddo
                enddo

!               # Finding coarsened values
                if (nwet .gt. 0) then
                    hav  = hsum/dble(nwet)
                    etaav = etasum/dble(nwet)
                    bav = bsum/dble(nwet)

!                    hc=max(etaav-bcrse(ifine,jfine)*capacrse,0.d0) !tsunamiclaw method
                    hc = min(hav, &
                        (max(etaav-bcrse(ifine,jfine)*capacrse,0.d0)))
                    if (hsum .ne. 0) then
                        huc = (min(hav,hc)/hsum)*husum
                        hvc = (min(hav,hc)/hsum)*hvsum
                    else
                        huc = 0.d0
                        hvc = 0.d0
                    endif

                else
                    hc  = 0.d0
                    huc = 0.d0
                    hvc = 0.d0
                endif

                hc = hc / capacrse
                huc = huc / capacrse
                hvc = hvc / capacrse
                etac = hc + bcrse(ifine,jfine)

!               # Finding errors
                herr  = dabs((hc-hcrse)/ order)
                huerr = dabs((huc-hucrse)/ order)
                hverr = dabs((hvc-hvcrse)/ order)
                etaerr= dabs((etac-etacrse)/ order)

                est(1,ifine,jfine) = dabs((etac-etacrse)/ order)
                est(2,ifine,jfine) = dabs((huc-hucrse)/ order)
                est(3,ifine,jfine) = dabs((hvc-hvcrse)/ order)

!               retaining directionality of the wave
                est(1,ifine,jfine) = sign(est(1,ifine,jfine),etacrse)
                est(2,ifine,jfine) = sign(est(2,ifine,jfine),hucrse)
                est(3,ifine,jfine) = sign(est(3,ifine,jfine),hvcrse)

                do k = 1,nvar
                    est(k,ifine + 1,jfine) = est(k,ifine,jfine)
                    est(k,ifine + 1,jfine + 1) = est(k,ifine,jfine)
                    est(k,ifine,jfine + 1) = est(k,ifine,jfine)
                enddo
              endif

            endif

            ifine = ifine + 2
          enddo

          jfine = jfine + 2
      enddo

!     Loop over adjoint snapshots

! Note: here the call to calculate_innerproduct varies from 
! the one in errf1a for amrclaw, due to the fact that our error is 
! stored in a fine grid vector

      do k = 1,totnum_adjoints
!         ! Consider only snapshots that are within the desired time range
          if (mask_selecta(k)) then
!             set innerproduct for fine grid
              call calculate_innerproduct(est,k,nx,ny, &
                 xleft,ybot,hx,hy,nvar,nghost,naux,auxfine)
          endif
      enddo

!     TODO: save calculated errors to adjoint_module to be used 
!         for calculating tolerance in subsequent time steps

      do i  = 1, nx
        do j  = 1, ny
          if (auxfine(innerprod_index,i,j) .ge. tol) then
!                     ## never set rctflg to good, since flag2refine or 
!                     ## flagregions2 may have previously set it to bad
!                     ## can only add bad pts in this routine
              rctflg(i,j)    = DOFLAG
          endif

        enddo
      enddo

    end subroutine errf1a


end module adjointsup_module

! Riemann solver for the variable speed limit LWR traffic model

! q_t + (u_max(x,t) q(1-q))_x = 0

! Here the speed limit u_max (stored in aux(1,i) may vary with x and t.

! waves: 1
! equations: 1
! aux fields: 1

! Conserved quantities:
!       1 q

! Auxiliary variables:
!       1 u_max

! See http://www.clawpack.org/riemann.html for a detailed explanation
! of the Riemann solver API.

subroutine rp1(maxm,num_eqn,num_waves,num_aux,num_ghost,num_cells, &
               ql,qr,auxl,auxr,wave,s,amdq,apdq)
    implicit none
    ! Inputs
    integer, intent(in) :: maxm, num_eqn, num_waves, num_aux, num_ghost, num_cells
    double precision, intent(in), dimension(num_eqn, 1-num_ghost:maxm+num_ghost) :: ql,qr
    double precision, intent(in), dimension(num_aux, 1-num_ghost:maxm+num_ghost) :: auxl,auxr
    ! Outputs
    double precision, intent(out) :: s(num_waves,1-num_ghost:num_cells+num_ghost)
    double precision, intent(out) :: wave(num_eqn,num_waves,1-num_ghost:num_cells+num_ghost)
    double precision, intent(out), dimension(num_eqn, 1-num_ghost:maxm+num_ghost) :: amdq,apdq
    ! Locals
    double precision :: f_l, f_r, s_l, s_r, f0, q_l, q_r, v_l, v_r
    integer :: i

    do i = 2-num_ghost, num_cells+num_ghost
        q_r = ql(1,i)
        q_l = qr(1,i-1)
        v_r = auxl(1,i)
        v_l = auxr(1,i-1)

        ! compute characteristic speed in each cell:
        s_l = v_l*(1.d0 - 2.d0*q_l)
        s_r = v_r*(1.d0 - 2.d0*q_r)

        ! compute flux in each cell and flux difference:
        f_l = v_l*q_l*(1.d0 - q_l)
        f_r = v_r*q_r*(1.d0 - q_r)

        ! This seems to work well even though there can be
        ! a stationary jump in q.
        wave(1,1,i) = q_r - q_l
        s(1,i) = 0.5d0*(s_l + s_r)

        if ((f_l .ge. 0.25d0*v_r) .and. (s_r .gt. 0.d0)) then
            ! left-going shock, right-going rarefaction
            f0 = 0.25d0*v_r
        elseif ((f_r .ge. 0.25d0*v_l) .and. (s_l .lt. 0.d0)) then
            ! right-going shock, left-going rarefaction
            f0 = 0.25d0*v_l
        elseif ((s_r .le. 0.d0) .and. (f_l .gt. f_r)) then
            ! left-going shock
            f0 = f_r
        elseif ((s_l .ge. 0.d0) .and. (f_r .gt. f_l)) then
            ! right-going shock
            f0 = f_l
        elseif ((s_l .le. 0.d0) .and. (s_r .ge. 0.d0)) then
            ! Transonic rarefaction
            if (v_r .le. v_l) then
                f0 = 0.25d0*v_r
            else
                f0 = 0.25d0*v_l
            endif
        elseif (f_l .le. f_r) then
            ! left-going rarefaction
            f0 = f_r
        else
            ! right-going rarefaction
            f0 = f_l
        endif
        amdq(1,i) = f0 - f_l
        apdq(1,i) = f_r - f0


    enddo
    return
end subroutine rp1

subroutine set_eta_init(mbc,mx,my,xlow,ylow,dx,dy,t,veta)

    ! This routine is called only if variable_eta_init = .true.
    ! The input is a single grid patch at time t, as specified by
    !     mbc,mx,my,xlow,ylow,dx,dy,t
    ! The output is an array 
    !     veta(1-mbc:mx+mbc,1-mbc:my+mbc)
    ! with the desired initial surface elevation at all points on this patch.

    ! This is called by qinit and also by filpatch and filval when refining.

    ! This default version sets veta to the value sea_level everywhere and
    ! then adjusts this based on any dtopo deformation that has occured
    ! up to this time t, as determined by interpolation from the 
    ! (possibly time-dependent) ! dtopo files.

    ! There is also a commented-out section below indicating how you might set 
    ! a higher value in some region that contains an onshore lake, for example.


    use topo_module
    use geoclaw_module, only: sea_level

    implicit none

    ! Arguments
    integer, intent(in) :: mbc,mx,my
    real(kind=8), intent(in) :: xlow,ylow,dx,dy,t
    real(kind=8), intent(inout) :: veta(1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Local
    integer :: i,j,i1,i2,j1,j2,idtopo,jdtopo,kdtopo,m
    integer(kind=8) :: index0_dtopowork, ij
    real(kind=8) :: x,y
    real(kind=8) :: x1_lake,x2_lake,y1_lake,y2_lake, lake_level

    veta = sea_level  ! initialize to sea_level, update below at some (i,j)

    if (.false.) then
        ! This illustrates how you might set a higher value than sea_level
        ! in a rectangle containing an onshore lake, as an example.
        ! Depending on the geometry, a simple rectangle might not suffice.
        ! What's below has been used for Lake Ozette on the Washington coast.
        lake_level = 11.d0  ! meters relative to 0 datum of topofiles
        x1_lake = -124.67d0
        x2_lake = -124.58d0
        y1_lake = 48.03d0
        y2_lake = 48.16d0
        i1 = max(int(floor((x1_lake - xlow)/dx)), 1)
        i2 = min(int(floor((x2_lake - xlow)/dx)), mx)
        j1 = max(int(floor((y1_lake - ylow)/dy)), 1)
        j2 = min(int(floor((y2_lake - ylow)/dy)), my)

        forall(i=i1:i2, j=j1:j2)
            veta(i,j) = lake_level
        end forall

    endif

    ! The code below adjusts veta values set above for any uplift or
    ! subsidence found in this region at the current time t, which assumes
    ! that the water surface moves with the grount initially.

    if (num_dtopo == 0) return

    do m=1,num_dtopo
        if (t < t0dtopo(m)) cycle  ! this dtopo isn't moving yet
        
        ! compute indices in patch that overlap with this dtopo,
        ! cycling to the next dtopo array if we discover there's no overlap:
        
        i1 = max(int(floor((xlowdtopo(m) - xlow)/dx)), 1)
        if (i1 >= mx) cycle
        
        i2 = min(int(floor((xhidtopo(m) - xlow)/dx)), mx)
        if (i2 < 1) cycle

        j1 = max(int(floor((ylowdtopo(m) - ylow)/dy)), 1)
        if (j1 >= my) cycle
        
        j2 = min(int(floor((yhidtopo(m) - ylow)/dy)), my)
        if (j2 < 1) cycle
    
        ! There is some overlap of dtopo with this patch
        ! Next figure out index into time-dependent dtopo based on t:

        if (mtdtopo(m) == 1) then
            ! Special case: instantaneous displacement at one instant in time
            kdtopo = 1
          else
            kdtopo = int(floor((t-t0dtopo(m))/dtdtopo(m)))+1
            kdtopo = min(kdtopo,mtdtopo(m))
            kdtopo = max(kdtopo,1)
          endif

        index0_dtopowork = i0dtopo(m) + int(kdtopo-1, 8)*int(mxdtopo(m), 8)*int(mydtopo(m), 8)

        ! Adjust eta_init by dtopo on part of patch that overlaps dtopo.
        ! Code below assumes dtopo is smooth enough that we can just 
        ! evaluate at one point in space and time, not doing interpolation.
        ! This could be improved as in topo_update.f, but probably not
        ! necessary (??).

        do i=i1,i2
            x = xlow + (i-0.5d0)*dx
            do j=j1,j2
                y = ylow + (j-0.5d0)*dy
                idtopo = int(floor((x-xlowdtopo(m))/dxdtopo(m))) + 1
                idtopo = max(1, min(mxdtopo(m)-1, idtopo))
                jdtopo = int(floor((yhidtopo(m)-y)/dydtopo(m))) + 1
                jdtopo = max(1, min(mydtopo(m)-1, jdtopo))
                ij = index0_dtopowork + int(jdtopo-1, 8)*int(mxdtopo(m),8) &
                                      + int(idtopo-1, 8)

                veta(i,j) = veta(i,j) + dtopowork(ij)

                enddo
            enddo

        enddo
    return

end subroutine set_eta_init

subroutine prepBuildSparseMatrixSGNcoo(soln,rhs,nvar,naux,levelBouss,numBoussCells)

    
    use amr_module
    use bouss_module
    use geoclaw_module, only: earth_radius, deg2rad, coordinate_system, grav
    use geoclaw_module, only: sea_level
        
    implicit none
    
    integer, intent(in) :: nvar, naux, levelBouss, numBoussCells
    
    !! pass in numBoussCells for this level so can dimension this array
    real(kind=8) :: soln(0:2*numBoussCells), rhs(0:2*numBoussCells) 
    real(kind=8) fms
    
    type(matrix_patchIndex), pointer :: mi
    type(matrix_levInfo),  pointer :: minfo
    
    integer :: i,j,nng,levSt,nx,ny,mitot,mjtot,loc,locold,locaux,mptr

    integer(kind=8) :: clock_start, clock_finish, clock_rate
    real(kind=8) :: cpu_start, cpu_finish
    
    real(kind=8), allocatable, dimension(:) :: uv,Auv,rowsum
    real(kind=8), allocatable, dimension(:,:) :: hx, hy, phi
    real(kind=8), allocatable, dimension(:,:) :: Bx, By, Bxy, Bxx, Byy
    real(kind=8), allocatable, dimension(:,:) :: etax, etay
    
    integer :: nD, k
    real(kind=8) :: matrix_rhs1_max, matrix_rhs2_max
    integer :: minfo_matrix_ia(24*numBoussCells)
    integer :: minfo_matrix_ja(24*numBoussCells)
    real(kind=8) :: minfo_matrix_sa(24*numBoussCells)

    external :: MATVEC
    logical :: debug
    logical :: yhi_db, ylo_db, xlo_db, xhi_db

    
    ! bc_xlo, bc_ylo, bc_xhi, bc_yhi are set in bouss_module.
    !     0 means Dirchlet value 0 (no correction at each of union of patches)
    !     1 means Neumann (correction in first interior cell = in ghost cell)
    !     2 means use ghost cell values in q(4:5,:,:) as Dirichlet BCs
    !             Multiply by matrix element and move to RHS
    !             Requires nvar==5.
    
#ifdef WHERE_AM_I
  write(*,*) "starting prepBuildSparseMatrixSGNcoo"
#endif

    call system_clock(clock_start,clock_rate)
    call cpu_time(cpu_start)
    
    !debug = .false.
    !debug = .true.
    
    minfo => matrix_info_allLevs(levelBouss)

!
! ================== Step 2  set up for matrix elements  ======================
    

    nD = numBoussCells   ! shorthand for size of matrix blocks D1 to D4
    
    !allocate(uv(2*nD), Auv(2*nD)) ! for testing matvec
    
    ! For Boussinesq, matrix is 2*nD by 2*nD,
    !     A = [I - D1   -D2  ]
    !         [ -D3    I - D4]
    ! and the solution vector consists of 
    !     updates to hu in all Bouss cells, followed by
    !     updates to hv in all Bouss cells
    
    ! Set up matrix A in sparse triad form: 
    !    matrix_sa(k) is the nonzero element if A in 
    !    row matrix_ia(k), and column matrix_ja(a)
    
    ! count number of matrix elements as added, 
    minfo%matrix_nelt  = 0

    rhs(:) = 0.d0
    
    matrix_rhs1_max = 0.d0
    matrix_rhs2_max = 0.d0
    
    ! loop over Bouss patches, must be done sequentially:
    
    levSt  = listStart(levelBouss)
    
    nng_loop: do  nng = 1, numgrids(levelBouss)
    
        mptr   = listOfGrids(levSt+nng-1)
        
        nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
        ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
        mitot  = nx + 2*nghost
        mjtot  = ny + 2*nghost
        loc = node(store1,mptr)  ! needed for iadd
        locold = node(store2,mptr)  ! needed for iadd
        if (locold .eq. 0) locold = loc  ! finest level has no old time soln
        locaux = node(storeaux,mptr)  ! needed for iaddaux

        call buildSparseMatrixSGNcoo(alloc(loc),alloc(locold),             &
                        alloc(locaux), soln,rhs,                           &
                        minfo%matrix_ia,minfo%matrix_ja,minfo%matrix_sa,   &
                        numBoussCells,levelBouss,mptr,nx,ny,nvar,naux,     &
                        matrix_rhs1_max,matrix_rhs2_max)
            
    
    enddo  nng_loop


    !if (minfo%matrix_nelt .gt. 0) then
    !! copy into allocatable to continue. stack vars needed for debugging
    !  minfo%matrix_ia = minfo_matrix_ia
    !  minfo%matrix_ja = minfo_matrix_ja
    !  minfo%matrix_sa = minfo_matrix_sa
    !  !write(35,909) (j,minfo_matrix_ia(j),minfo_matrix_ja(j),minfo_matrix_sa(j),j=1,minfo%matrix_nelt)
 909  format(3i6,e25.15)
    !endif
    
    !============ Debug:
            
    if (.false.) then
        ! check row sums of matrix
        allocate(rowsum(2*nD))
        rowsum = 0.d0
        do k=1,minfo%matrix_nelt
            i = minfo_matrix_ia(k)
            if (minfo%matrix_ja(k) <= nD) then
                ! sums over left half of matrix:
                rowsum(i) = rowsum(i) + minfo%matrix_sa(k)
            endif
            if ((minfo_matrix_ia(k) <= nD) .and. (minfo%matrix_ja(k) > nD)) then
                write(6,*) '+++ k,ia,ja,sa: ',k,minfo_matrix_ia(k),minfo%matrix_ja(k),minfo%matrix_sa(k)
            endif
        enddo
        do i=1,2*nD
            write(6,*) '+++ row ',i,'  rowsum = ',rowsum(i)
        enddo
        
        ! test multiplication:
        ! construct uv vector that varies only in x, uniform in y
        do k = 1,nD
            uv(k) = mod(k,nx)
            uv(k+nD) = 2.d0*mod(k,nx)
            write(6,*) '+++ k,uv(k),uv(k+nD): ',k,uv(k),uv(k+nD)
            enddo
            
        call MATVEC(2*nD, uv, Auv, minfo%matrix_nelt, minfo_matrix_ia, minfo%matrix_ja, minfo%matrix_sa, 0)

        do k=1,nD
            write(6,*) '+++ k,Auv(k),Auv(k+nD): ',k,Auv(k),Auv(k+nD)
            enddo
                
        write(6,*) '+++ Set up matrix of dimension ',2*nD
        write(6,*) '+++ Number of nonzeros: ', minfo%matrix_nelt
        write(6,*) '+++ Size of minfo%matrix_sa: ', size(minfo%matrix_sa)
    endif
    
    ! =============

    if (.false.) then
        allocate(uv(2*nD), Auv(2*nD)) ! for testing matvec

        ! right hand side:
        write(63,*) '========= rhs:'
        do j=1,nD
            write(63,630) j,rhs(j),j+nD,rhs(j+nD)
        enddo
        
 630    format(i6,d26.16, i6,d26.16)
 631    format(4d26.16)
 632    format('Column',i3,'   Row',i3, d26.16, '   Row',i3,d26.16)
        
        ! print columns of matrix:
        do j=1,2*nD
            uv(1:2*nD) = 0.d0
            uv(j) = 1.d0
            
            call MATVEC(2*nD, uv, Auv, minfo%matrix_nelt, minfo_matrix_ia, &
                        minfo%matrix_ja, minfo%matrix_sa, 0)
            !write(63,*) 'Column ',j
            !write(63,631) (Auv(k), k=1,nD)
            !write(63,*) ' '
            !write(63,631) (Auv(k), k=nD+1,2*nD)
            k = 11
            write(63,632) j,k,Auv(k),k+nD,Auv(k+nD)
        enddo
        deallocate(uv,Auv)
    endif
    

    ! =============
    
    
    if (minfo%matrix_nelt > size(minfo%matrix_sa)) then
        write(6,*) '*** Error nelt > size(minfo%matrix_sa), need to allocate larger'
        stop
    endif

    call system_clock(clock_finish,clock_rate)
    call cpu_time(cpu_finish)
    timePrepBuild = timePrepBuild+ clock_finish-clock_start
    timePrepBuildCPU = timePrepBuildCPU + cpu_finish-cpu_start
!! debugging
    if (0 .eq. 1) then
    fms = real(clock_finish-clock_start,kind=8)
    write(*,*)" level ",levelBouss
    write(*,400)real(fms,kind=8)/real(clock_rate,kind=8),real(timePrepBuild,kind=8)/real(clock_rate,kind=8)
    write(*,401)cpu_finish-cpu_start,timePrepBuildCPU
 400 format("clock delta ", e15.7," timePrepBuild now ",e15.7)
 401 format("cpu   delta ", e15.7," timePrepBuildCPU  ",e15.7)
    endif
        
#ifdef WHERE_AM_I
  write(*,*) "ending   prepBuildSparseMatrixSGNcoo"
#endif

end subroutine prepBuildSparseMatrixSGNcoo

c
c  ================================================================
      subroutine saveqc(level,nvar,naux)
c  ================================================================
c
      use amr_module
      implicit double precision (a-h,o-z)

      logical sticksout, perdom3
      
      !for setaux timing
      integer :: clock_start, clock_finish, clock_rate
      real(kind=8) :: cpu_start, cpu_finish
c
c ::::::::::::::::::::::::: SAVEQC :::::::::::::::::::::::::::::::::
c prepare new fine grids to save fluxes after each integration step
c for future conservative fix-up on coarse grids.
c save all boundary fluxes of fine grid (even if on a  phys. bndry.) -
c but only save space for every intrat of them.
c:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      levc = level - 1
      hxc  = hxposs(levc)
      hyc  = hyposs(levc)
      hzc  = hzposs(levc)
      ng   = 0  ! no ghost cells on coarsened enlarged patch

      mkid = lstart(level)
 10   if (mkid .eq. 0) go to 99
       nx    = node(ndihi,mkid)-node(ndilo,mkid) + 1
       ny    = node(ndjhi,mkid)-node(ndjlo,mkid) + 1
       nz    = node(ndkhi,mkid)-node(ndklo,mkid) + 1
       ikeep = nx/intratx(level-1)
       jkeep = ny/intraty(level-1)
       kkeep = nz/intratz(level-1)
       lenbc = 2*(ikeep*jkeep+jkeep*kkeep+kkeep*ikeep)
       ist   = node(ffluxptr,mkid)
       time  = rnode(timemult,mkid)

c         make coarsened enlarged patch for conservative fixup
       ilo = node(ndilo,mkid)
       jlo = node(ndjlo,mkid)
       klo = node(ndklo,mkid)
       ihi = node(ndihi,mkid)
       jhi = node(ndjhi,mkid)
       khi = node(ndkhi,mkid)

       iclo = ilo/intratx(level-1) - 1
       jclo = jlo/intraty(level-1) - 1
       kclo = klo/intratz(level-1) - 1
       ichi = (ihi+1)/intratx(level-1)
       jchi = (jhi+1)/intraty(level-1)
       kchi = (khi+1)/intratz(level-1)

       nrow = ichi-iclo+1
       ncol = jchi-jclo+1
       nfil = kchi-kclo+1

       xl   = rnode(cornxlo,mkid) - hxc
       yf   = rnode(cornylo,mkid) - hyc
       zb   = rnode(cornzlo,mkid) - hzc
       xr   = rnode(cornxhi,mkid) + hxc
       yr   = rnode(cornyhi,mkid) + hyc
       zt   = rnode(cornzhi,mkid) + hzc

       loctmp = igetsp(nrow*ncol*nfil*(nvar+naux))
       loctx  = loctmp + nrow*ncol*nfil*nvar
       locaux = node(storeaux,mkid)

       if (iclo .lt. 0 .or. ichi .eq. iregsz(levc) .or.
     1     jclo .lt. 0 .or. jchi .eq. jregsz(levc) .or.
     2     kclo .lt. 0 .or. kchi .eq. kregsz(levc)) then
           sticksout = .true.
       else
           sticksout = .false.
       endif

       perdom3 = xperdom .and. yperdom .and. zperdom
       if (sticksout .and. perdom3) then
         call preicall(alloc(loctmp),alloc(loctx),nrow,ncol,nfil,
     .                    nvar,naux,
     .                 iclo,ichi,jclo,jchi,kclo,kchi,level-1)
       else
         call icall(alloc(loctmp),alloc(loctx),nrow,ncol,nfil,
     .                 nvar,naux,
     .                   iclo,ichi,jclo,jchi,kclo,kchi,level-1,1,1,1)
       endif

!      still need to set remaining aux cells that stick out of domain
       if (naux .gt. 0 .and. sticksout .and. .not. perdom3) then
          call system_clock(clock_start, clock_rate)
          call cpu_time(cpu_start)
          call setaux(ng,nrow,ncol,nfil,xl,yf,zb,
     .                hxc,hyc,hzc,naux,alloc(loctx))
          call system_clock(clock_finish, clock_rate)
          call cpu_time(cpu_finish)
       endif
c
          call bc3amr(alloc(loctmp),alloc(loctx),nrow,ncol,nfil,
     1               nvar,naux,hxc,hyc,hzc,level,time,
     2                xl,xr,yf,yr,zb,zt)

       call cstore(alloc(loctmp),nrow,ncol,nfil,nvar,
     .                alloc(ist+nvar*lenbc),lenbc,naux,alloc(loctx),
     .                alloc(ist+2*nvar*lenbc))
       call reclam(loctmp,nrow*ncol*nfil*(nvar+naux))

          mkid = node(levelptr,mkid)
          go to 10
 99    return
       end

subroutine src2(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux,t,dt)
      
    use storm_module, only: wind_forcing, pressure_forcing
    use storm_module, only: wind_drag
    use storm_module, only: wind_index, pressure_index
    use storm_module, only: storm_direction, storm_location

    use friction_module, only: friction_index

    use geoclaw_module, only: g => grav, RAD2DEG, pi, rho_air, ambient_pressure
    use geoclaw_module, only: coriolis_forcing, coriolis, rho
    use geoclaw_module, only: friction_forcing, friction_depth
    use geoclaw_module, only: manning_coefficient
    use geoclaw_module, only: manning_break, num_manning
    use geoclaw_module, only: spherical_distance, coordinate_system

    use amr_module, only: mcapa, cflv1
      
    use multilayer_module, only: num_layers, dry_tolerance
    
    use friction_module, only: variable_friction, friction_index

    implicit none
    
    ! Input parameters
    integer, intent(in) :: meqn,mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy,t,dt
    
    ! Output
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    ! Locals
    integer :: i, j, m, k, bottom_index, bottom_layer, layer, nman
    logical :: found
    real(kind=8) :: xm, xc, xp, ym, yc, yp, dx_meters, dy_meters
    real(kind=8) :: h(num_layers), hu, hv, u, v, hu0, hv0, coeff
    real(kind=8) :: tau, wind_speed, theta, phi, psi, P_gradient(2), S(2), sloc(2)
    real(kind=8) :: fdt, Ddt, a(2,2)

    ! Physics parameters
    real(kind=8), parameter :: manning_power = 7.d0 / 3.d0
    real(kind=8), parameter :: H_break = 2.d0
    real(kind=8), parameter :: theta_f = 10.d0
    real(kind=8), parameter :: gamma_f = 4.d0 / 3.d0

    ! Algorithm parameters
    ! Parameter controls when to zero out the momentum at a depth in the
    ! friction source term
    real(kind=8), parameter :: depth_tolerance = 1.0d-30

    character(len=*), parameter :: CFL_FORMAT =   &
                        "('*** WARNING *** Courant number  =', d12.4," // &
                         "'  is larger than input cfl_max = ', d12.4," // &
                         "' in src2.')"

    ! ----------------------------------------------------------------
    ! Friction source term - Use backward Euler to solve
    ! Hybrid friction formula with a spatially varying Manning's-N factor
    if (friction_forcing) then
        do j=1,my
            do i=1,mx
                ! Extract depths
                forall (m=1:num_layers)
                    h(m) = q(3 * (m-1) + 1,i,j) / rho(m)
                end forall

                ! Extract appropriate momentum, also zero momentum in dry layers
                m = num_layers
                found = .false.
                do while(.not.found .and. m > 0)
                    if (h(m) > depth_tolerance) then
                        ! Extract momentum components and exit loop
                        bottom_layer = m
                        bottom_index = 3 * (m - 1)
                        hu = q(bottom_index + 2, i, j) / rho(m)
                        hv = q(bottom_index + 3, i, j) / rho(m)
                        found = .true.
                    else
                        ! Set almost dry layers momentum to zero
                        q(3 * (m - 1) + 2, i, j) = 0.d0
                        q(3 * (m - 1) + 3, i, j) = 0.d0
                    endif
                    m = m - 1
                end do

                if (.not.found) then
                    cycle
                end if

                if (variable_friction) then
                    coeff = aux(friction_index, i, j)
                else
                    do nman = num_manning, 1, -1
                        if (aux(1,i,j) < manning_break(nman)) then
                            coeff = manning_coefficient(nman)
                        endif
                    enddo
                end if

                ! Apply friction if in shallow enough water
                if (sum(h) <= friction_depth) then
                    tau = g * coeff**2 / h(bottom_layer)**(manning_power) &
                            * sqrt(hu**2 + hv**2) &
                            * (1.d0 + (H_break / h(bottom_layer))**theta_f)**(gamma_f / theta_f)
                            
                    q(bottom_index + 2,i,j) = q(bottom_index + 2,i,j) / (1.d0 + dt * tau)
                    q(bottom_index + 3,i,j) = q(bottom_index + 3,i,j) / (1.d0 + dt * tau)
                endif
            enddo
        enddo
    endif
    ! End of friction source term

    ! Coriolis source term
    ! Use backward Euler to solve, q_t = A q -> q^n+1 = (I + dt * A)^-1 q^n
    ! or use first 4 terms of matrix exponential
    if (coriolis_forcing) then
        do j=1,my
            yc = ylower + (j - 0.5d0) * dy
            fdt = coriolis(yc) * dt ! Calculate f dependent on coordinate system

            ! Calculate matrix components - backward Euler
            !a(1,:) = [1.d0,  fdt]
            !a(2,:) = [-fdt, 1.d0]
            !a = a / (1.d0 + fdt**2)

            ! Matrix exponential
            a(1,1) = 1.d0 - 0.5d0 * fdt**2 + fdt**4 / 24.d0
            a(1,2) =  fdt - fdt**3 / 6.d0
            a(2,1) = -fdt + fdt**3 / 6.d0
            a(2,2) = a(1,1)

            do i=1,mx
                do m=1,num_layers
                    layer = 3 * (m-1)
                    hu = q(layer + 2,i,j)
                    hv = q(layer + 3,i,j)
                    ! Note that these are not really hu, hv but rho * hu and 
                    ! rho * hv actually
                    q(layer + 2,i,j) = hu * a(1,1) + hv * a(1,2)
                    q(layer + 3,i,j) = hu * a(2,1) + hv * a(2,2)
                end do
            enddo
        enddo
    endif
    ! End of coriolis source term

    ! wind -----------------------------------------------------------
    if (wind_forcing) then
        ! Force only the top layer of water, assumes top most layer is last
        ! to go dry
        ! Need storm location and direction for sector based wind drag
        sloc = storm_location(t)
        theta = storm_direction(t)
        do j=1,my
            yc = ylower + (j - 0.5d0) * dy
            do i=1,mx
                xc = xlower + (i - 0.5d0) * dx
                if (q(1,i,j) / rho(1) > dry_tolerance(1)) then
                    psi = atan2(yc - sloc(2), xc - sloc(1))
                    if (theta > psi) then
                        phi = (2.d0 * pi - theta + psi) * RAD2DEG
                    else
                        phi = (psi - theta) * RAD2DEG 
                    endif
                    wind_speed = sqrt(aux(wind_index,i,j)**2        &
                                    + aux(wind_index+1,i,j)**2)
                    tau = wind_drag(wind_speed, phi) * rho_air * wind_speed
                    q(2,i,j) = q(2,i,j) + dt * tau * aux(wind_index,i,j)
                    q(3,i,j) = q(3,i,j) + dt * tau * aux(wind_index+1,i,j)
                endif
            enddo
        enddo
    endif
    ! ----------------------------------------------------------------

    ! Atmosphere Pressure --------------------------------------------
    ! Not yet handled in Riemann solver
    ! if (pressure_forcing) then
    !     do j=1,my  
    !         ym = ylower + (j - 1.d0) * dy
    !         yc = ylower + (j - 0.5d0) * dy
    !         yp = ylower + j * dy
    !         do i=1,mx  
    !             xm = xlower + (i - 1.d0) * dx
    !             xc = xlower + (i - 0.5d0) * dx
    !             xp = xlower + i * dx
                
    !             if (coordinate_system == 2) then
    !                 ! Convert distance in lat-long to meters
    !                 dx_meters = spherical_distance(xp,yc,xm,yc)
    !                 dy_meters = spherical_distance(xc,yp,xc,ym)
    !             else
    !                 dx_meters = dx
    !                 dy_meters = dy
    !             endif

    !             ! Calculate gradient of Pressure
    !             P_gradient(1) = (aux(pressure_index,i+1,j) &
    !                            - aux(pressure_index,i-1,j)) / (2.d0 * dx_meters)
    !             P_gradient(2) = (aux(pressure_index,i,j+1) &
    !                            - aux(pressure_index,i,j-1)) / (2.d0 * dy_meters)

    !             ! Modify momentum in each layer
    !             do k=1,num_layers
    !                 layer = 3 * (k - 1)
    !                 h(k) = q(layer + 1, i, j) / rho(k)
    !                 if (h(k) > dry_tolerance(k)) then
    !                     q(layer + 2, i, j) = q(layer + 2, i, j)   &
    !                                 - dt * h(k) * P_gradient(1)
    !                     q(layer + 3, i, j) = q(layer + 3, i, j)   &
    !                                 - dt * h(k) * P_gradient(2)
    !                 end if
    !             end do
    !         enddo
    !     enddo
    ! endif

end subroutine src2

subroutine qinit(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    
    use geoclaw_module, only: sea_level
    use amr_module, only: t0
    use qinit_module, only: qinit_type,add_perturbation
    use qinit_module, only: variable_eta_init
    use qinit_module, only: force_dry,use_force_dry,mx_fdry, my_fdry
    use qinit_module, only: xlow_fdry, ylow_fdry, xhi_fdry, yhi_fdry
    use qinit_module, only: dx_fdry, dy_fdry
    use qinit_module, only: tend_force_dry
    
    implicit none
    
    ! Subroutine arguments
    integer, intent(in) :: meqn,mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
    
    ! Locals
    integer :: i,j,m, ii,jj
    real(kind=8) :: x,y
    real(kind=8) :: veta(1-mbc:mx+mbc,1-mbc:my+mbc)
    real(kind=8) :: ddxy
    
    q = 0.d0   ! initialize all elements to 0
    
    if (variable_eta_init) then
        ! Set initial surface eta based on eta_init
        call set_eta_init(mbc,mx,my,xlower,ylower,dx,dy,t0,veta)
      else
        veta = sea_level  ! same value everywhere
      endif

    forall(i=1:mx, j=1:my)
        q(1,i,j) = max(0.d0, veta(i,j) - aux(1,i,j))
    end forall

    if (use_force_dry .and. (t0 <= tend_force_dry)) then
     ! only use the force_dry if it specified on a grid that matches the 
     ! resolution of this patch, since we only check the cell center:
     ddxy = max(abs(dx-dx_fdry), abs(dy-dy_fdry))
     if (ddxy < 0.01d0*min(dx_fdry,dy_fdry)) then
       do i=1,mx
          x = xlower + (i-0.5d0)*dx
          ii = int((x - xlow_fdry + 1d-7) / dx_fdry)
          do j=1,my
              y = ylower + (j-0.5d0)*dy
              jj = int((y - ylow_fdry + 1d-7) / dy_fdry)
              jj = my_fdry - jj  ! since index 1 corresponds to north edge
              if ((ii>=1) .and. (ii<=mx_fdry) .and. &
                  (jj>=1) .and. (jj<=my_fdry)) then
                  ! grid cell lies in region covered by force_dry,
                  ! check if this cell is forced to be dry 
                  ! Otherwise don't change value set above:                  
                  if (force_dry(ii,jj) == 1) then
                      q(1,i,j) = 0.d0
                      endif
                  endif
          enddo ! loop on j
       enddo ! loop on i
       endif ! dx and dy agree with dx_fdry, dy_fdry
    endif ! use_force_dry

    
    ! Add perturbation to initial conditions
    if (qinit_type > 0) then
        call add_perturbation(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    endif
    
end subroutine qinit

! Contains a number of useful functions
module utility_module

    implicit none

    ! String manipulation
    character( * ), private, parameter :: LOWER_CASE = 'abcdefghijklmnopqrstuvwxyz'
    character( * ), private, parameter :: UPPER_CASE = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ' 

contains

    ! Returns number of arguments in list, assumes arbitrary number of white 
    ! space as delimiter
    integer function get_value_count(line) result(count)

        implicit none

        character(len=*), intent(in) :: line

        character(len=200) :: search_buffer
        integer :: i
        logical :: found

        count = 1

        search_buffer = trim(line(1:index(line,"=:") - 2))

        do i=1,len_trim(search_buffer)
            if (search_buffer(i:i) == " ") then
                if (.not. found) then
                    found = .true.
                    count = count + 1
                endif
            else
                found = .false.
            endif
        enddo

    end function get_value_count

    ! Converts seconds to days truncating at the second decimal place
    real(kind=8) pure function convert2days(seconds) result(days)
        
        implicit none
        real(kind=8), intent(in) :: seconds

        days = real(int(seconds * 1.d2 / 8.64d4) / 1.d2, kind=8)

    end function convert2days


    !======================================
    subroutine parse_values(str, n, values)
    !======================================

    ! Take the input string `str` and parse it to extract any numerical values,
    ! ignoring any character strings. 
    ! Returns `n` values in array `values`. 
    ! Assumes n <= 10.
    ! If you expect value(i) to be an integer, evaluate as nint(value(i)).

    implicit none

    character(len=*), intent(in) :: str
    integer, intent(out) :: n
    real(kind=8), intent(out) :: values(10)

    integer :: pos2,nw,i,e
    character(len=80) :: word(10), str2
    real(kind=8) :: x

    ! First break into words / tokens based on white space.  
    ! Each might be character or numerical:

    nw = 0
    str2 = trim(adjustl(str))
    do while (len(trim(adjustl(str2))) > 0) 
        pos2 = index(str2, " ")
        
        if (pos2 == 0) then
           nw = nw + 1
           word(nw) = trim(adjustl(str2))
           exit
           endif

        nw = nw + 1
        word(nw) = trim(adjustl(str2(1:pos2-1)))
        str2 = trim(adjustl(str2(pos2+1:)))
        if (nw == 10) then
            write(6,*) '*** too many words on line, str = '
            write(6,*) str
            stop
            endif
        enddo

    ! now extract numerical values:
    n = 0
    do i=1,nw
        read(word(i),*,IOSTAT=e) x
        if (e == 0) then
            ! this token is numerical
            n = n+1
            values(n) = x
            endif
        enddo


    end subroutine parse_values


    !------------------------------------------------------------------------------
    !S+
    ! NAME:
    !       StrUpCase
    !
    ! PURPOSE:
    !       Function to convert an input string to upper case.
    !
    ! CATEGORY:
    !       Utility
    !
    ! LANGUAGE:
    !       Fortran-95
    !
    ! CALLING SEQUENCE:
    !       Result = StrUpCase( String )
    !
    ! INPUT ARGUMENTS:
    !       String:  Character string to be converted to upper case.
    !                UNITS:      N/A
    !                TYPE:       CHARACTER( * )
    !                DIMENSION:  Scalar
    !                ATTRIBUTES: INTENT( IN )
    !
    ! OPTIONAL INPUT ARGUMENTS:
    !       None.
    !
    ! OUTPUT ARGUMENTS:
    !       None.
    !
    ! OPTIONAL OUTPUT ARGUMENTS:
    !       None.
    !
    ! FUNCTION RESULT:
    !       Result:  The input character string converted to upper case.
    !                UNITS:      N/A
    !                TYPE:       CHARACTER( LEN(String) )
    !                DIMENSION:  Scalar
    !
    ! CALLS:
    !       None.
    !
    ! SIDE EFFECTS:
    !       None.
    !
    ! RESTRICTIONS:
    !       None.
    !
    ! EXAMPLE:
    !       string = 'this is a string'
    !       WRITE( *, '( a )' ) StrUpCase( string )
    !   THIS IS A STRING
    !
    ! PROCEDURE:
    !       Figure 3.5B, pg 80, "Upgrading to Fortran 90", by Cooper Redwine,
    !       1995 Springer-Verlag, New York.
    !
    ! CREATION HISTORY:
    !       Written by:     Paul van Delst, CIMSS/SSEC 18-Oct-1999
    !                       paul.vandelst@ssec.wisc.edu
    !S-
    !------------------------------------------------------------------------------


    ! ==========================================================================
    !  function to_upper(input_string)
    !    Converts *input_string* to upper case and returns that string.
    !    Note that this makes a copy of the given string so does not modify the
    !    original string.
    !
    !   Based on code originally by Paul van Delst, CIMSS/SSEC 18-Oct-1999
    !                               paul.vandelst@ssec.wisc.edu
    !   and originally presented in
    !       Figure 3.5B, pg 80, "Upgrading to Fortran 90", by Cooper Redwine,
    !       1995 Springer-Verlag, New York.
    ! ==========================================================================
    function to_upper (input_string) result(output_string)

        implicit none
    
        ! Input
        character(len=*), intent(in) :: input_string

        ! Output
        character(len(input_string)) :: output_string

        ! Local
        integer :: i, n

        ! -- copy input string
        output_string = input_string

        ! -- loop over string elements
        do i = 1, len( output_string )

            ! -- find location of letter in lower case constant string
            n = index( lower_case, output_string( i:i ) )

            ! -- if current substring is a lower case letter, make it upper case
            if ( n /= 0 ) output_string( i:i ) = upper_case( n:n )

        end do

    end function to_upper

    ! ==========================================================================
    !  function to_lower(input_string)
    !    Converts *input_string* to lower case and returns that string.
    !    Note that this makes a copy of the given string so does not modify the
    !    original string.
    !
    !   Based on code originally by: 
    !       Paul van Delst, CIMSS/SSEC 18-Oct-1999
    !       paul.vandelst@ssec.wisc.edu
    !   and originally presented in
    !       Figure 3.5B, pg 80, "Upgrading to Fortran 90", by Cooper Redwine,
    !       1995 Springer-Verlag, New York.
    ! ==========================================================================
    function to_lower (input_string) result(output_string)

        implicit none

        ! argument and result
        character(len=*), intent(in) :: input_string
        character(len(input_string)) :: output_string

        ! local variables
        integer :: i, n


        ! copy input string
        output_string = input_string

        ! loop over string elements
        do i = 1, len( output_string )

          ! find location of letter in lower case constant string
          n = index( lower_case, output_string( i:i ) )

          ! if current substring is an lower case letter, make it lower case
          if ( n /= 0 ) output_string( i:i ) = lower_case( n:n )

        end do

    end function to_lower


end module utility_module

c
c -----------------------------------------------------------
c
      subroutine regrid  (nvar,lbase,cut,naux,start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer newnumgrids(maxlv)
      integer clock_start2, clock_finish, clock_rate
c
c :::::::::::::::::::::::::::: REGRID :::::::::::::::::::::::::::::::

c  regrid = flag points on each grid with a level > = lbase.
c  cluster them, and fit new subgrids around the clusters.
c  the lbase grids stay fixed during regridding operation.
c  when a parent grid has its error estimated, add its kid grid
c  information to the error grid before clustering. (project)
c  order of grid examination - all grids at the same level, then
c  do the next coarser level.
c
c input parameters:
c     lbase  = highest level that stays fixed during regridding
c     cutoff = criteria for measuring goodness of rect. fit.

c local variables:
c     lcheck = the level being examined.
c     lfnew  = finest grid to be. will replace lfine.

c global
c    mstart  = start of very coarsest grids.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      verbosity_regrid = method(3)
      lcheck    = min0(lfine,mxnest-1)
      lfnew     = lbase
      do 10 i   = 1, mxnest
        newnumgrids(i) = 0
 10     newstl(i) = 0
      time      = rnode(timemult, lstart(lbase))
c
 20   if (lcheck .lt. lbase) go to 50
          call grdfit(lbase,lcheck,nvar,naux,cut,time,start_time)
          if (newstl(lcheck+1) .eq. 0) go to 40
          lfnew = max0(lcheck + 1,lfnew)
 40       continue
          lcheck = lcheck - 1
c
      go to 20
 50   continue
c
c  end of level loop
c
c  remaining tasks left in regridding:
c  1.  count number of new grids at each level  
      maxnumnewgrids = 0   ! max over all levels. needed for dimensioning
      do lev = lbase+1,lfnew 
          ngridcount = 0
          mptr = newstl(lev)
 52       if (mptr .eq. 0) go to 55
             ngridcount = ngridcount + 1
             mptr = node(levelptr,mptr)
             go to 52

 55       newnumgrids(lev) = ngridcount
          maxnumnewgrids = max(maxnumnewgrids,ngridcount)
      end do
c
c  2. interpolate storage for the new grids.  the starting pointers
c  for each level are in newstl. also reclaim some space before new
c  allocations.
      call system_clock(clock_start2,clock_rate)
      call gfixup(lbase,lfnew,nvar,naux,newnumgrids,maxnumnewgrids)
      call system_clock(clock_finish,clock_rate)
      timeGrdfit2 = timeGrdfit2 + clock_finish - clock_start2
c
c  3. merge data structures (newstl and lstart )
c  finish storage allocation, reclaim space, etc. set up boundary
c  flux conservation arrays
c
      do 60 level = lbase, lfine-1
        call prepf(level+1,nvar,naux)
        call prepc(level,nvar)
 60   continue
c
c  reset numgrids per level, needed for omp parallelization.
c  note that grids may have disappeared, so next loop resets to 0
c  if there are no grids from lfine+1 to mxnest
c
      do 72 levnew = lbase+1, mxnest
        mptr = lstart(levnew)
        ngridcount = 0
        ncells = 0
        do while (mptr .gt. 0)
           ngridcount = ngridcount + 1
           ncells = ncells + (node(ndihi,mptr)-node(ndilo,mptr)+1)
           mptr = node(levelptr, mptr)
         end do
         numgrids(levnew) = ngridcount
         numcells(levnew) = ncells
         avenumgrids(levnew) = avenumgrids(levnew) + ngridcount
         iregridcount(levnew) = iregridcount(levnew) + 1
c        sort grids to first ones are the most work. this helps load
c        balancing, but doesn't help locality
         if (ngridcount .gt. 1) call arrangeGrids(levnew,ngridcount)

         if (verbosity_regrid .ge. levnew) then
           write(*,100) ngridcount,ncells,levnew
           write(outunit,100) ngridcount,ncells,levnew
 100       format("there are ",i6," grids with ",i10,
     &            " cells at level ", i3)
         endif
72     continue
c
c      set up array of grids instead of recomputing at each step
       call makeGridList(lbase)
       do levnew = lbase+1, lfine
          call makeBndryList(levnew)   ! does one level at a time
       end do

      return
      end
c
c -------------------------------------------------------------------
c
      subroutine arrangeGrids(level, numg)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer listgrids(numg), cost(numg), index(numg), prevptr
c
c   slow sort for now, putting most expensive grids first on lstart list
c   measure cost by number of cells
c
       mptr = lstart(level)
       do i = 1, numg
         listgrids(i) = mptr
         cost(i) =  (node(ndihi,mptr)-node(ndilo,mptr)+1)
         index(i) = i
         mptr = node(levelptr, mptr)
       end do
c
c        write(*,*)" before sorting"
c       write(*,*) index
c
       call  qsorti(index, numg, cost)

c       write(*,*)"after sorting"
c       write(*,*) index

c qsort returns in ascending order, repack in descending order
c grids can stay in place, just their levelptrs need to change
       lstart(level) = listgrids(index(numg))  ! last grid is most expensive
       prevptr = listgrids(index(numg))
       do i = 1, numg-1             
          node(levelptr, prevptr) = listgrids(index(numg-i))
          prevptr = listgrids(index(numg-i))
       end do
       node(levelptr,prevptr) = null  !signal the last grid

       return
       end

c
c     =====================================================
      subroutine restart(meqn,mbc,mx,my,mz,
     &      xlower,ylower,zlower,dx,dy,dz,q)
c     =====================================================
c
c     # Set initial conditions for q.
c
      implicit double precision (a-h,o-z)
c
      dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc,
     &      1-mbc:mz+mbc)
      character*10 fname1, fname2
      logical outt0
      common /restrt_block/ t0, iframe

      iunit = 16

c     # first create the file name and open file
      fname1 = 'fort.q'
     &     // char(ichar('0') + mod(iframe/1000,10)) 
     &     // char(ichar('0') + mod(iframe/100,10)) 
     &     // char(ichar('0') + mod(iframe/10,10)) 
     &     // char(ichar('0') + mod(iframe,10))
      open(iunit,file=fname1)

c     # Read grid parameters.
      read(iunit,*) igrid
      read(iunit,*) level
      read(iunit,*) mx_in
      read(iunit,*) my_in
      read(iunit,*) mz_in
      read(iunit,*) xlow_in
      read(iunit,*) ylow_in
      read(iunit,*) zlow_in
      read(iunit,*) dx_in
      read(iunit,*) dy_in
      read(iunit,*) dz_in

c     # Test for compatibility of grid resolution.
      if (mx_in .ne. mx .or. my_in .ne. my .or. mz_in .ne. mz) then
         stop 'rstart.f : data not compatible'
      endif

c     # Read variables in from old fort.qXXXX file.
      do k = 1,mz
         do j = 1,my
            do i = 1,mx
               read(iunit,*) (q(m,i,j,k),m=1,meqn)
            enddo
         enddo
      enddo
      close(iunit)

c     # Read initial time in from fort.tXXXX file.      
      fname2 = 'fort.t'
     &     // char(ichar('0') + mod(iframe/1000,10)) 
     &     // char(ichar('0') + mod(iframe/100,10)) 
     &     // char(ichar('0') + mod(iframe/10,10)) 
     &     // char(ichar('0') + mod(iframe,10))
      open(iunit,file=fname2)
      read(iunit,*) t0
      close(iunit)

      write(*,*) 'Restarting from old output file ', fname1
      write(*,*) 'Simulation will be restarted at time t = ', t0
      write(*,*) 'Inital condition will not be output to a matlab ',
     &     'plot file'
      write(*,*) 

      return
      end

c
c -------------------------------------------------------------
c
      subroutine errest (nvar,naux,lcheck,mptr,nx,ny)
c
      use amr_module
      use adjoint_module, only : adjoint_flagging
      use adjointsup_module, only: errf1a
      implicit double precision (a-h,o-z)
c
c   ### changed to stack based storage 2/23/13 
c   ### and broken into smaller routines to minimize 
c   ### stack space
     
      double precision valbgc(nvar,nx/2+2*nghost,ny/2+2*nghost)
      double precision auxbgc(naux,nx/2+2*nghost,ny/2+2*nghost)
     
 
c :::::::::::::::::::::::::: ERREST :::::::::::::::::::::::::::::::::::
!> for this grid at level lcheck:
!!  estimate the error by taking a large (2h,2k) step based on the
!!  values in the old storage loc., then take one regular (and for
!!  now wasted) step based on the new info.   compare using an
!!  error relation for a pth order  accurate integration formula.
!!  flag error plane as either bad (needs refinement), or good.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
       mitot  = nx + 2*nghost
       mjtot  = ny + 2*nghost
       locnew = node(store1,mptr)
       locold = node(store2,mptr)
       locaux = node(storeaux,mptr)
       mi2tot = nx/2  + 2*nghost
       mj2tot = ny/2  + 2*nghost
c
c     prepare double the stencil size worth of boundary values,
c            then coarsen them for the giant step integration.
       midub = nx+4*nghost
       mjdub = ny+4*nghost
c
       call prepbigstep(nvar,naux,lcheck,mptr,nx,ny,midub,
     .                    mjdub,valbgc,auxbgc,mi2tot,mj2tot)

c
c  the one giant step based on old values is done. now take
c  one regular step based on new values. 
c  boundary values already in locbig, (see subr. flagger)
c
      locbig = node(tempptr,mptr)
      locaux = node(storeaux,mptr)
      call prepregstep(nvar,naux,lcheck,mptr,nx,ny,mitot,mjtot,
     .                 alloc(locbig),alloc(locaux))
c
c     ## locamrflags allocated in flagger. may previously have been used 
c     ## by flagregions2 or flag2refine so make sure not to overwrite
      locamrflags = node(storeflags, mptr)    
      mbuff = max(nghost,ibuff+1)  
      mibuff = nx + 2*mbuff 
      mjbuff = ny + 2*mbuff
      if (adjoint_flagging) then
          call errf1a(alloc(locbig),nvar,valbgc,mptr,mi2tot,mj2tot,
     1           mitot,mjtot,alloc(locamrflags),mibuff,mjbuff,
     1           alloc(locaux),naux,auxbgc)
      else
          call errf1(alloc(locbig),nvar,valbgc,mptr,mi2tot,mj2tot,
     1           mitot,mjtot,alloc(locamrflags),mibuff,mjbuff)
      endif


c
      return
      end

! =========================================================
subroutine rp1(maxmx,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)
! =========================================================

! Solve Riemann problems for the 1D advection equation q_t + u(x)*q_x = 0
! with variable u(x) in non-conservative form (the color equation)

! waves:     1
! equations: 1

! Conserved quantities:
!       1 q

! Auxiliary variables:
!       1 velocity

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q

! Note that the i'th Riemann problem has left state qr(i-1,:)
!                                    and right state ql(i,:)
! From the basic clawpack routine step1, rp is called with ql = qr = q.


    implicit double precision (a-h,o-z)
    dimension   ql(meqn,1-mbc:maxmx+mbc)
    dimension   qr(meqn,1-mbc:maxmx+mbc)
    dimension  auxl(maux,1-mbc:maxmx+mbc)
    dimension  auxr(maux,1-mbc:maxmx+mbc)
    dimension    s(mwaves,1-mbc:maxmx+mbc)
    dimension wave(meqn, mwaves,1-mbc:maxmx+mbc)
    dimension amdq(meqn,1-mbc:maxmx+mbc)
    dimension apdq(meqn,1-mbc:maxmx+mbc)
    common /comrp/ u



    do 30 i=2-mbc,mx+mbc
    
    !        # Compute the wave and speed
    
        u = dmin1(auxr(1,i-1),0.d0) +  dmax1(auxl(1,i),0.d0)
    
    !        # the formula below seems to work as well...
    !        u = 0.5d0 * (auxr(1,i-1) +  auxl(1,i))

        wave(1,1,i) = ql(1,i) - qr(1,i-1)
        s(1,i) = u
        amdq(1,i) = dmin1(auxr(1,i-1), 0.d0) * wave(1,1,i)
        apdq(1,i) = dmax1(auxl(1,i),   0.d0) * wave(1,1,i)
    30 END DO

    return
    end subroutine rp1

c     =====================================================
      subroutine qinit(meqn,mbc,mx,my,xlower,ylower,
     &     dx,dy,q,maux,aux)
c     =====================================================
c
c     # Set initial conditions for q.
c     # Sample scalar equation with data that is piecewise constant with
c     # q = 1.0  if  0.1 < x < 0.6   and   0.1 < y < 0.6
c     #     0.1  otherwise
c
      implicit double precision (a-h,o-z)
      dimension q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)

c     # set concentration profile
c     ---------------------------
      do 20 j=1,my
C          yj = ylower + (j-0.5d0)*dy
         do 20 i=1,mx
C             xi = xlower + (i-0.5d0)*dx
C             if (xi.gt.0.1d0 .and. xi.lt.0.6d0 .and.
C      &            yj.gt.0.1d0 .and. yj.lt.0.6d0) then
C                q(1,i,j) = 1.d0
C             else
               q(1,i,j) = 0.1d0
C             endif
   20    continue


      return
      end

c
c --------------------------------------------------------------
c
!> Output a subtree of the grids. All grids from the grid level of 
!! grid **mlev** to the finest level are output.
!! \param[in] mlev root grid for current output.
!! \param[in] outgrd If true, output value on grid
!! \param[in] nvar number of equations for the system
!! \param[in] naux number of auxiliary variables
      subroutine outtre(mlev,outgrd,nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)
      logical  outgrd

c
c ::::::::::::::::::::::: OUTTRE :::::::::::::::::::::::::::::::::::
c
c outtre - output subtree
c input parameters:
c    mlev   - ptr to subtree to output i.e., start at level(mlev)
c    outgrd - if true, output the values on the grid
c tree is output from 'level' to finest level.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      write (outunit,1)
1     format(1x,14hthe subtree is)
c
      level = node(nestlevel, mlev)
10    if (level .gt. lfine) go to 99
          mptr    = lstart(level)
 20       if (mptr .eq. 0) go to 30
              call outmsh(mptr,outgrd,nvar,naux)
              mptr = node(levelptr, mptr)
          go to 20
 30       continue
          write(outunit,2) numgrids(level), level,iregst(level),
     1                     jregst(level),iregend(level),jregend(level)
 2        format(/,i5," grids at level ",i5," go from ",2i9," to",2i9,/)
          level = level + 1
      go to 10
c
 99   return
      end
c
c --------------------------------------------------------------
c
!> Output all grids on the same level as grid **mlev**.
!! \param[in] mlev representative grid of the grid level being output
!! \param[in] outgrd If true, output value on grid
!! \param[in] nvar number of equations for the system
!! \param[in] naux number of auxiliary variables
      subroutine outlev(mlev,outgrd,nvar,naux)
c
      use amr_module
      implicit double precision (a-h,o-z)
      logical  outgrd

c
c ::::::::::::::::::::::: OUTTRE :::::::::::::::::::::::::::::::::::
c
c outtre - output subtree
c input parameters:
c    mlev   - ptr to subtree to output i.e., start at level(mlev)
c    outgrd - if true, output the values on the grid
c tree is output from 'level' to finest level.
c
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      write (outunit,1)
1     format(1x,"the partially built new subtree is:")
c
          mptr = mlev
 20       if (mptr .eq. 0) go to 30
              call outmsh(mptr,outgrd,nvar,naux)
              mptr = node(levelptr, mptr)
          go to 20
 30       continue
c
 99   return
      end

module qinit_module

    use amr_module, only: rinfinity

    implicit none
    save

    logical, private :: module_setup = .false.
    
    ! Type of q initialization
    integer, public :: qinit_type
    
    ! Work array
    real(kind=8), private, allocatable :: qinit(:)

    ! Geometry
    real(kind=8) :: x_low_qinit
    real(kind=8) :: y_low_qinit
    real(kind=8) :: t_low_qinit
    real(kind=8) :: x_hi_qinit
    real(kind=8) :: y_hi_qinit
    real(kind=8) :: t_hi_qinit
    real(kind=8) :: dx_qinit
    real(kind=8) :: dy_qinit
    
    integer, private :: mx_qinit
    integer, private :: my_qinit

contains

    subroutine set_qinit(fname)
    
        use geoclaw_module, only: GEO_PARM_UNIT
    
        implicit none
        
        ! Subroutine arguments
        character(len=*), optional, intent(in) :: fname
        
        ! File handling
        integer, parameter :: unit = 7
        character(len=150) :: qinit_fname
    
        if (.not.module_setup) then

            write(GEO_PARM_UNIT,*) ' '
            write(GEO_PARM_UNIT,*) '--------------------------------------------'
            write(GEO_PARM_UNIT,*) 'SETQINIT:'
            write(GEO_PARM_UNIT,*) '-------------'
            
            ! Open the data file
            if (present(fname)) then
                call opendatafile(unit,fname)
            else
                call opendatafile(unit,"qinit.data")
            endif
            
            read(unit,"(i1)") qinit_type
            if (qinit_type == 0) then
                ! No perturbation specified
                write(GEO_PARM_UNIT,*)  '  qinit_type = 0, no perturbation'
                print *,'  qinit_type = 0, no perturbation'
                return
            endif
            read(unit,*) qinit_fname

            write(GEO_PARM_UNIT,*)  qinit_fname
            
            call read_qinit(qinit_fname)

            module_setup = .true.
        end if
    
    end subroutine set_qinit


    subroutine add_perturbation(meqn,mbc,mx,my,xlower,ylower,dx,dy,q,maux,aux)
    
        use multilayer_module, only: num_layers, eta_init
        use geoclaw_module, only: rho
    
        implicit none
    
        ! Subroutine arguments
        integer, intent(in) :: meqn,mbc,mx,my,maux
        real(kind=8), intent(in) :: xlower,ylower,dx,dy
        real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc)
        real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)
        
        ! Local
        integer :: i, j, layer_index
        real(kind=8) :: ximc,xim,x,xip,xipc,yjmc,yjm,y,yjp,yjpc,dq
        
        ! Topography integral function
        real(kind=8) :: topointegral

        if (qinit_type > 0) then
            do i=1-mbc,mx+mbc
                x = xlower + (i-0.5d0)*dx
                xim = x - 0.5d0*dx
                xip = x + 0.5d0*dx
                do j=1-mbc,my+mbc
                    y = ylower + (j-0.5d0)*dy
                    yjm = y - 0.5d0*dy
                    yjp = y + 0.5d0*dy

                    ! Check to see if we are in the qinit region at this grid point
                    if ((xip > x_low_qinit).and.(xim < x_hi_qinit).and.  &
                        (yjp > y_low_qinit).and.(yjm < y_hi_qinit)) then

                        xipc=min(xip,x_hi_qinit)
                        ximc=max(xim,x_low_qinit)

                        yjpc=min(yjp,y_hi_qinit)
                        yjmc=max(yjm,y_low_qinit)

                        dq = topointegral(ximc,xipc,yjmc,yjpc,x_low_qinit, &
                                          y_low_qinit,dx_qinit,dy_qinit,mx_qinit, &
                                          my_qinit,qinit,1)
                        dq = dq / ((xipc-ximc)*(yjpc-yjmc)*aux(2,i,j))

                        if (qinit_type <= 3 * num_layers) then 
                            if (aux(1,i,j) <= eta_init(qinit_type)) then
                                q(qinit_type,i,j) = q(qinit_type,i,j) + dq
                            endif
                        else if (qinit_type > 3 * num_layers .and.             &
                                 qinit_type <= 4 * num_layers) then
                            layer_index = qinit_type - 3 * num_layers
                            q(layer_index, i, j) = q(layer_index, i, j)        &
                                                         + dq * rho(layer_index)
                            ! modify layer above to accomodate this perturbation
                            if (layer_index > 1) then
                                stop "Not implemented yet"
                            end if
                        endif
                    endif
                enddo
            enddo
        endif
        
    end subroutine add_perturbation

        
    ! currently only supports one file type:
    ! x,y,z values, one per line in standard order from NW corner to SE
    ! z is perturbation from standard depth h,hu,hv set in qinit_geo,
    ! if iqinit = 1,2, or 3 respectively.
    ! if iqinit = 4, the z column corresponds to the definition of the 
    ! surface elevation eta. The depth is then set as q(i,j,1)=max(eta-b,0)
    subroutine read_qinit(fname)
    
        use geoclaw_module, only: GEO_PARM_UNIT
        
        implicit none
        
        ! Subroutine arguments
        character(len=150) :: fname
        
        ! Data file opening
        integer, parameter :: unit = 19
        integer :: i,num_points,status
        double precision :: x,y
        
        print *,'  '
        print *,'Reading qinit data from file  ', fname
        print *,'  '

        write(GEO_PARM_UNIT,*) '  '
        write(GEO_PARM_UNIT,*) 'Reading qinit data from'
        write(GEO_PARM_UNIT,*) fname
        write(GEO_PARM_UNIT,*) '  '
        
        open(unit=unit, file=fname, iostat=status, status="unknown", &
             form='formatted',action="read")
        if ( status /= 0 ) then
            print *,"Error opening file", fname
            stop
        endif
        
        ! Initialize counters
        num_points = 0
        mx_qinit = 0
        
        ! Read in first values, determines x_low and y_hi
        read(unit,*) x_low_qinit,y_hi_qinit
        num_points = num_points + 1
        mx_qinit = mx_qinit + 1
        
        ! Sweep through first row figuring out mx
        y = y_hi_qinit
        do while (y_hi_qinit == y)
            read(unit,*) x,y
            num_points = num_points + 1
            mx_qinit = mx_qinit + 1
        enddo
        ! We over count by one in the above loop
        mx_qinit = mx_qinit - 1
        
        ! Continue to count the rest of the lines
        do
            read(unit,*,iostat=status) x,y
            if (status /= 0) exit
            num_points = num_points + 1
        enddo
        if (status > 0) then
            print *,"ERROR:  Error reading qinit file ",fname
            stop
        endif
        
        ! Extract rest of geometry
        x_hi_qinit = x
        y_low_qinit = y
        my_qinit = num_points / mx_qinit
        dx_qinit = (x_hi_qinit - x_low_qinit) / (mx_qinit-1)
        dy_qinit = (y_hi_qinit - y_low_qinit) / (my_qinit-1)
        
        rewind(unit)
        allocate(qinit(num_points))
        
        ! Read and store the data this time
        do i=1,num_points
            read(unit,*) x,y,qinit(i)
        enddo
        close(unit)
        
    end subroutine read_qinit

end module qinit_module

!
! :::::::::::::::::::::::::::::: FILVAL ::::::::::::::::::::::::::
!
! create and fill coarser (level-1) patch with one extra coarse cell all
! around, plus the ghost cells . will interpolate from this patch to grid mptr
! without needing special boundary code.
!
! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
!
!
! ------------------------------------------------------------------
!
subroutine filval(val, mitot, mjtot, dx, dy, level, time,  mic, &
                  mjc, xleft, xright, ybot, ytop, nvar, mptr, ilo, ihi, &
                  jlo, jhi, aux, naux,  sp_over_h )

    use amr_module, only: xlower, ylower, intratx, intraty, nghost, xperdom
    use amr_module, only: yperdom, spheredom, xupper, yupper, alloc
    use amr_module, only: outunit, NEEDS_TO_BE_SET
    use amr_module, only: newstl, iregsz, jregsz

    use topo_module, only: aux_finalized
    use geoclaw_module, only: dry_tolerance, sea_level
    use refinement_module, only: varRefTime
    use qinit_module, only: variable_eta_init
    use qinit_module, only: force_dry,use_force_dry,mx_fdry, my_fdry
    use qinit_module, only: xlow_fdry, ylow_fdry, xhi_fdry, yhi_fdry
    use qinit_module, only: dx_fdry, dy_fdry
    use qinit_module, only: tend_force_dry
    
    implicit none

    ! Input
    integer, intent(in) :: mitot, mjtot, level, mic, mjc, nvar, mptr, ilo, ihi
    integer, intent(in) :: jlo, jhi, naux
    real(kind=8), intent(in) :: dx, dy, time, xleft, xright, ybot, ytop

    ! Output
    real(kind=8), intent(in out) :: sp_over_h
    real(kind=8), intent(in out) :: val(nvar,mitot,mjtot), aux(naux,mitot,mjtot)

    ! Local storage
    integer :: refinement_ratio_x, refinement_ratio_y, iclo, jclo, ichi, jchi, ng, i, ico, ifine
    integer :: ii, ivar, j, jco, jfine, jj
    real(kind=8) :: valc(nvar,mic,mjc), auxc(naux,mic,mjc)
    real(kind=8) :: coarseval(3), dx_coarse, dy_coarse, xl, xr, yb, yt, area
    real(kind=8) :: dividemass, finemass, hvf, s1m, s1p, slopex, slopey, vel
    real(kind=8) :: velmax, velmin, vf, vnew, xoff, yoff
    logical :: fineflag(3)
    real(kind=8) :: fliparray((mitot+mjtot)*(nvar+naux))
    real(kind=8) :: aux2(naux,mitot,mjtot)
    integer :: nx, ny
    real(kind=8) setflags(mitot,mjtot),maxauxdif
    integer :: jm, im, nm
    logical :: sticksoutxfine, sticksoutyfine,sticksoutxcrse,sticksoutycrse
    real(kind=8) :: vetac(mic,mjc) ! for variable eta_init
    real(kind=8) :: x,y, ddxy
    logical :: use_force_dry_this_level


    ! External function definitions
    real(kind=8) :: get_max_speed

    refinement_ratio_x = intratx(level-1)
    refinement_ratio_y = intraty(level-1)
    dx_coarse  = dx * refinement_ratio_x
    dy_coarse  = dy * refinement_ratio_y
    xl      = xleft  - dx_coarse
    xr      = xright + dx_coarse
    yb      = ybot   - dy_coarse
    yt      = ytop   + dy_coarse

    ! if topo not yet final then aux is set outside filval (in gfixup)
    ! and so aux has real data already, (ie dont overwrite here)

    ! set integer indices for coarser patch enlarged by 1 cell
    ! (can stick out of domain). proper nesting will insure this one
    ! call is sufficient.
    iclo   = ilo / refinement_ratio_x - 1
    jclo   = jlo / refinement_ratio_y - 1
    ichi   = (ihi + 1) / refinement_ratio_x - 1 + 1
    jchi   = (jhi + 1) / refinement_ratio_y - 1 + 1
    ng     = 0


    sticksoutxfine = ( (ilo .lt. 0) .or. (ihi .ge. iregsz(level)))
    sticksoutyfine = ( (jlo .lt. 0) .or. (jhi .ge. jregsz(level)))
    sticksoutxcrse = ((iclo .lt. 0) .or. (ichi .ge. iregsz(level-1)))
    sticksoutycrse = ((jclo .lt. 0) .or. (jchi .ge. jregsz(level-1)))


    if (naux == 0) then
        write(*,*)" in filval/geoclaw with naux=0:  how could this happen?"
        if ((xperdom .and. sticksoutxcrse) .or. (yperdom.and. sticksoutycrse) .or. spheredom) then
            call preintcopy(valc,mic,mjc,nvar,iclo,ichi,jclo,jchi,level-1,fliparray)
        else
            call intcopy(valc,mic,mjc,nvar,iclo,ichi,jclo,jchi,level-1,1,1)
        endif
    else  
        ! intersect grids and copy all (soln and aux)
        if ((xperdom .and. sticksoutxcrse) .or. (yperdom.and. sticksoutycrse) .or. spheredom) then
            call preicall(valc,auxc,mic,mjc,nvar,naux,iclo,ichi,jclo,jchi, &
                          level-1,fliparray)
        else
            call icall(valc,auxc,mic,mjc,nvar,naux,iclo,ichi,jclo,jchi,level-1,1,1)
        endif
        if (aux_finalized .lt. 2) then ! coarse topo was at wrong time. redo
           ! no ghost cells on coarse enlarged patch
           auxc(1,:,:) = NEEDS_TO_BE_SET  ! needs signal for setaux, set everywhere
           call setaux(ng,mic,mjc,xl,yb,dx_coarse,dy_coarse,naux,auxc)
        endif

        if (aux_finalized < 2) then
            call setaux(0,mic,mjc,xl,yb,dx_coarse,dy_coarse,naux,auxc)
        endif
    endif

    call bc2amr(valc,auxc,mic,mjc,nvar,naux,dx_coarse,dy_coarse,level-1,time,  &
                xl,xr,yb,yt)


!  NOTE change in order of code.  Since the interp from coarse to fine needs the aux
!       arrays set already, the fine copy is done first, to set up the aux arrays.
!       we can do this since we have the flag array to test where to overwrite.

!  SO this is no longer overwriting but setting for the first time.
! overwrite interpolated values with fine grid values, if available.
! can only do this if topo stoped moving, otherwise fine grid
! topo is at previous time step.
!! also might need preicallCopy???

       nx = mitot - 2*nghost
       ny = mjtot - 2*nghost

       if (naux .gt. 0) then 
             aux(1,:,:) = NEEDS_TO_BE_SET  ! will indicate fine cells not yet set
             if ((xperdom .and. sticksoutxfine)  .or. (yperdom.and.sticksoutyfine)) then
                call preicall(val,aux,mitot,mjtot,nvar,naux,ilo-nghost,ihi+nghost,  &
                              jlo-nghost,jhi+nghost,level,fliparray)  
             else
                call icall(val,aux,mitot,mjtot,nvar,naux,ilo-nghost,ihi+nghost,  &
                           jlo-nghost,jhi+nghost,level,1,1)   
             endif
             setflags = aux(1,:,:)   ! save since will overwrite in setaux when setting all aux vals
             ! need this so we know where to use coarse grid to set fine solution w/o overwriting
             if (aux_finalized .lt. 2) aux(1,:,:) = NEEDS_TO_BE_SET  ! reset entire aux array since topo moving
               !set remaining aux vals not set by copying from prev existing grids
               call setaux(nghost,nx,ny,xleft,ybot,dx,dy,naux,aux)
       else ! either no aux exists, or cant reuse yet  
          ! if topo not final, then setaux called in gfixup before this routine
          ! so only call intcopy (which copies soln) and not icall.
          if ((xperdom .and. sticksoutxfine)  .or. (yperdom.and.sticksoutyfine)) then
             call preintcopy(val,mitot,mjtot,nvar,ilo-nghost,ihi+nghost,  &
                       jlo-nghost,jhi+nghost,level,fliparray)
          else
             call intcopy(val,mitot,mjtot,nvar,ilo-nghost,ihi+nghost,  &
                          jlo-nghost,jhi+nghost,level,1,1)   
          endif
       endif
  
    !-----------------------------
    ! For shallow water over topograpdy, in coarse cells convert from h to eta,
    ! before interpolating:
    !-----------------------------

    if (variable_eta_init) then
        call set_eta_init(0,mic,mjc,xl,yb,dx_coarse,dy_coarse,time,vetac)
      else
        vetac = sea_level  ! same value everywhere
      endif

    
    use_force_dry_this_level = use_force_dry
    if (use_force_dry) then
        ! check if force_dry resolution the same as this level:
        ddxy = max(abs(dx-dx_fdry), abs(dy-dy_fdry))
        use_force_dry_this_level = (ddxy < 0.01d0*min(dx_fdry,dy_fdry))
        endif
        
    !if (use_force_dry_this_level .and. (time <= tend_force_dry)) then
    !    write(6,*) '+++ using force_dry in filval, t = ',time
    !    endif
    
    ! Prepare slopes - use min-mod limiters
    do j=2, mjc-1
        do i=2, mic-1
            fineflag(1) = .false.
            ! interpolate eta to find depth
            do ii=-1,1
                coarseval(2+ii) = valc(1,i+ii,j)  + auxc(1,i+ii,j)
                if (valc(1,i+ii,j)  <= dry_tolerance) then
                    coarseval(2+ii) = vetac(i+ii,j)
                end if
            end do
            s1p = coarseval(3) - coarseval(2)
            s1m = coarseval(2) - coarseval(1)
            slopex = min(abs(s1p), abs(s1m)) &
                                * sign(1.d0,coarseval(3) - coarseval(1))
            if (s1m*s1p <= 0.d0) slopex=0.d0

            do jj=-1,1
                coarseval(2+jj) = valc(1,i,j+jj) + auxc(1,i,j+jj)
                if (valc(1,i,j+jj) <= dry_tolerance) then
                    coarseval(2+jj) = vetac(i,j+jj)
                end if
            end do
            s1p = coarseval(3) - coarseval(2)
            s1m = coarseval(2) - coarseval(1)
            slopey = min(abs(s1p), abs(s1m)) &
                                * sign(1.d0,coarseval(3)-coarseval(1))
            if (s1m*s1p <= 0.d0) slopey=0.d0

            ! Interpolate from coarse cells to fine grid to find depth
            finemass = 0.d0
                do jco = 1,refinement_ratio_y
               do ico = 1,refinement_ratio_x
                    yoff = (real(jco,kind=8) - 0.5d0) / refinement_ratio_y - 0.5d0
                    xoff = (real(ico,kind=8) - 0.5d0) / refinement_ratio_x - 0.5d0
                    jfine = (j-2) * refinement_ratio_y + nghost + jco
                    ifine = (i-2) * refinement_ratio_x + nghost + ico
                    if (setflags(ifine,jfine) .eq. NEEDS_TO_BE_SET) then
                       val(1,ifine,jfine) = (coarseval(2) + xoff * slopex &
                                                          + yoff * slopey)
                       val(1,ifine,jfine) = max(0.d0, val(1,ifine,jfine)  &
                                               - aux(1,ifine,jfine))
                                               
                       x = xleft + (ifine-0.5d0)*dx - nghost*dx
                       y = ybot + (jfine-0.5d0)*dy - nghost*dy

                       ! Check cells newly initialized to wet using force_dry:
                       if (use_force_dry_this_level .and. &
                                (val(1,ifine,jfine) > 0) .and. &
                                (time <= tend_force_dry)) then
                           ! check if in force_dry region
                           ii = int((x - xlow_fdry + 1d-7) / dx_fdry) + 1
                           jj = int((y - ylow_fdry + 1d-7) / dy_fdry) + 1
                           jj = my_fdry - jj  ! since index 1 corresponds to north edge
                           if ((ii>=1) .and. (ii<=mx_fdry) .and. &
                               (jj>=1) .and. (jj<=my_fdry)) then
                               ! grid cell lies in region covered by force_dry,
                               ! check if this cell is forced to be dry
                               ! Otherwise don't change value set above:
                               if (force_dry(ii,jj) == 1) then
                                   val(1,ifine,jfine) = 0.d0
                                   endif
                               endif
                                                              
                           endif

                                                    
                       finemass = finemass + val(1,ifine,jfine)
                       if (val(1,ifine,jfine) <= dry_tolerance) then
                          fineflag(1) = .true.
                          val(2,ifine,jfine) = 0.d0
                          val(3,ifine,jfine) = 0.d0
                       endif
                       
                    endif ! NEEDS_TO_BE_SET
                end do
            end do

            !------ Determine Momentum ----------------------------------
            ! finemass is the total mass in all new fine grid cells
            ! all fine mass has been determined for this coarse grid cell
            ! if all fine cells are dry, momentum has already been set
            if (finemass >= dry_tolerance) then
                do ivar = 2,nvar
                    fineflag(ivar)=.false.
                    s1p = (valc(ivar,i+1,j) - valc(ivar,i,j))
                    s1m = (valc(ivar,i,j) - valc(ivar,i-1,j))
                    slopex = min(abs(s1p), abs(s1m)) &
                     * sign(1.d0,(valc(ivar,i+1,j) - valc(ivar,i-1,j)))
                    if (s1m*s1p.le.0.d0) slopex=0.d0
                
                    s1p = (valc(ivar,i,j+1) - valc(ivar,i,j))
                    s1m = (valc(ivar,i,j) - valc(ivar,i,j-1))
                    slopey = min(abs(s1p), abs(s1m)) &
                     * sign(1.d0,(valc(ivar,i,j+1) - valc(ivar,i,j-1)))
                    if (s1m*s1p <= 0.d0) slopey=0.d0

                    if (valc(1,i,j) > dry_tolerance) then
                        velmax = valc(ivar,i,j) / valc(1,i,j)
                        velmin = valc(ivar,i,j) / valc(1,i,j)
                    else
                        velmax = 0.d0
                        velmin = 0.d0
                    endif
               
                    do ii = -1,1,2
                        if (valc(1,i+ii,j) > dry_tolerance) then
                            vel = valc(ivar,i+ii,j) / valc(1,i+ii,j)
                            velmax = max(vel,velmax)
                            velmin = min(vel,velmin)
                        endif
                        if (valc(1,i,j+ii) > dry_tolerance) then
                            vel = valc(ivar,i,j+ii) / valc(1,i,j+ii)
                            velmax = max(vel,velmax)
                            velmin = min(vel,velmin)
                        endif
                    enddo

                    ! try to set momentum
                    do ico = 1,refinement_ratio_x
                        if (fineflag(1).or.fineflag(ivar)) exit

                        do jco = 1,refinement_ratio_y
                            jfine = (j-2) * refinement_ratio_y + nghost + jco
                            ifine = (i-2) * refinement_ratio_x + nghost + ico
                            yoff = (real(jco,kind=8) - 0.5d0) / refinement_ratio_y - 0.5d0
                            xoff = (real(ico,kind=8) - 0.5d0) / refinement_ratio_x - 0.5d0
                            hvf = valc(ivar,i,j) + xoff * slopex &
                                                          + yoff*slopey
                            vf = hvf / (val(1,ifine,jfine))
                            if (vf > velmax .or. vf < velmin) then
                                fineflag(ivar) = .true.
                                exit
                            else
                                val(ivar,ifine,jfine) = hvf
                            endif
                        enddo
                    enddo

                    ! momentum is set to preserve old momentum or not violate
                    ! generating new extrema in velocities
                    if (fineflag(1) .or. fineflag(ivar)) then
                        ! more mass now, conserve momentum
                        area = real(refinement_ratio_x * refinement_ratio_y,kind=8)
                        dividemass = max(finemass,valc(1,i,j))
                        Vnew = area * valc(ivar,i,j) / (dividemass)

                            do jco = 1,refinement_ratio_y
                            do ico = 1,refinement_ratio_x
                                jfine = (j-2) * refinement_ratio_y + nghost + jco
                                ifine = (i-2) * refinement_ratio_x + nghost + ico
                                val(ivar,ifine,jfine) = Vnew * val(1,ifine,jfine)
                            enddo
                        enddo
                    endif

                enddo
            endif

        enddo !end of coarse loop
    enddo !end of coarse loop

    ! scan for max wave speed on newly created grid. this will be used to set appropriate
    ! time step and appropriate refinement in time. For this app not nec to refine by same
    ! amount as refinement in space since refinement at shores where h is shallow has lower
    ! speeds.

! CHECK BY CALLING SETAUX AND SETTING ALL, THEN DIFFING
!   aux2(1,:,:) = NEEDS_TO_BE_SET   ! indicates fine cells not yet set
!   call setaux(nghost,nx,ny,xleft,ybot,dx,dy,naux,aux2)
!   maxauxdif = 1.d-13
!   do i = 1, mitot
!   do j = 1, mjtot
!     if (abs(aux(1,i,j)-aux2(1,i,j)) .gt. maxauxdif) then
!        maxauxdif = abs(aux(1,i,j)-aux2(1,i,j))
!        write(*,444)i,j,aux(1,i,j),aux2(1,i,j),maxauxdif
!444     format("i,j = ",2i4," auxs ",2e15.7," maxauxdif ",e12.5)
!     endif
!   end do
!   end do
!   if (maxauxdif .gt. 2.d-13) then
!      write(*,*)" maxauxdif = ",maxauxdif," with mitot,mjtot ",mitot,mjtot, &
!                " on grid ",mptr," level ",level
!   endif
    

    if (varRefTime) then   ! keep consistent with setgrd_geo and qinit_geo
        sp_over_h = get_max_speed(val,mitot,mjtot,nvar,aux,naux,nghost,dx,dy)
    else
        sp_over_h = 0.d0  ! not used but set so do not get exceptions
    endif

end subroutine filval

! ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

subroutine dumpaux(aux,naux,mitot,mjtot)
   implicit none
   real(kind=8) :: aux(naux,mitot,mjtot)
   integer :: naux,mitot,mjtot,i,j,iaux

   do j = 1, mjtot 
   do i = 1, mitot 
      write(*,444) i,j,(aux(iaux,i,j),iaux=1,naux)
 444  format(2i4,5e12.5)
   end do
   end do

end subroutine dumpaux

c :::::::::::::::::::: FLGLVL :::::::::::::::::::::::::::::::::
c
!> \callgraph
!! \callergraph
!! Controls the error estimation/flagging bad pts. for
!! an entire level of grids.  returns pointer into alloc
!! where the (x,y) coordinations of the flagged pts. are.
!!
!! \param nvar number of equations for the system
!! \param naux number of auxiliary variables
!! \param lcheck level to be flagged
!! \param nxypts number of flagged points in total
!! \param index starting index (memory address) in alloc of the flagged points (which occupy 2*nxypts locations)
!! \param lbase  base AMR level for current refinement, which stays
!! fixed. Note that **lbase** is always less or equal to **lcheck**
!! \param npts Number of unique flagged cells (after removing
!! duplicates)
!! \param[in] start_time start time of current simulation
c
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
c -----------------------------------------------------------
c
      subroutine flglvl2(nvar,naux,lcheck,nxypts,index,lbase,npts,
     &                   start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer(kind=8) :: clock_start, clock_finish, clock_rate
c
c
c
#ifdef WHERE_AM_I
      write(*,*)"starting flglvl2"
#endif
      nxypts = 0
      numbad = 0


c     flag arrays- based on either spatial gradients (and/or user defined 
c                  criteria),  or Richardson error estimation,
c                  or user-defined regions
    
      call system_clock(clock_start,clock_rate)
      call flagger(nvar,naux,lcheck,start_time)
      call system_clock(clock_finish,clock_rate)
      timeFlagger = timeFlagger + clock_finish - clock_start


c     buffer the flagged cells (done for each grid patch of flags)
c     also project flags from finer levels onto this level to ensure
c     proper nesting. Finally compute proper domain for each patch
      call system_clock(clock_start,clock_rate)
      call bufnst2(nvar,naux,numbad,lcheck,lbase) 
      call system_clock(clock_finish,clock_rate)
      timeBufnst = timeBufnst + clock_finish - clock_start

      nxypts = nxypts + numbad
c
c  colate flagged pts into flagged points array
c  new version needs to check for proper nesting at this point
c  also needs to sort,  so can remove duplicates.
c
      if (nxypts .gt. 0) then  
c        build domain flags for each grid at level lcheck, instead of
c        previous approach using domain flags over entire  domain
c         call domgrid(lbase,lcheck)   ! will need since there are flagged pts  NOW IN BUFNST2
c
c in new version, there are bad cells but nxypts isnt true count any longer
c since there are duplicates, and proper nesting not yet checked
           index = igetsp(2*nxypts)
           call colate2(alloc(index),nxypts,lcheck,npts,lbase)
      else 
         npts = 0  !npts is number of unique flagged points after removing duplicates
         call freeFlags(lcheck)   ! otherwise storage freed in colate2. perhaps always do it here
      endif

#ifdef WHERE_AM_I
      write(*,*)"ending   flglvl2"
#endif
      return
      end
c
c ---------------------------------------------------------------------------------
c
       subroutine freeFlags(lcheck)

       use amr_module
       implicit double precision (a-h, o-z)

       mptr = lstart(lcheck)
 10          continue
             locamrflags = node(storeflags,mptr)
             locdomflags = node(domflags_base,mptr)
             locdom2 = node(domflags2,mptr)

             nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
             ny     = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
             mbuff = max(nghost,ibuff+1)
             mibuff = nx + 2*mbuff
             mjbuff = ny + 2*mbuff

             ibytesPerDP = 8
             nwords = (mibuff*mjbuff)/ibytesPerDP+1
             call reclam(locdomflags, nwords)
             call reclam(locdom2, nwords)
             call reclam(locamrflags,mibuff*mjbuff)

        mptr = node(levelptr, mptr)
        if (mptr .ne. 0) go to 10

       return
       end

subroutine fgmax_frompatch(mx,my,meqn,mbc,maux,q,aux,dx,dy, &
           xlower,ylower,level,time,time_afterstep)

    ! Do the new fixed grid stuff on all fgrids, updating 
    ! based on the patch passed in.

    use fgmax_module
    use geoclaw_module, only: sea_level, dry_tolerance

    implicit none
    integer, intent(in) :: mx,my,meqn,mbc,maux,level
    real(kind=8), intent(in) :: q(meqn, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: aux(maux, 1-mbc:mx+mbc, 1-mbc:my+mbc)
    real(kind=8), intent(in) :: dx,dy,xlower,ylower,time,time_afterstep

    real(kind=8), allocatable, dimension(:,:) :: fg_values
    !integer, allocatable, dimension(:) :: fg_klist ! replaced by fg%klist
    type(fgrid), pointer :: fg
    integer :: ifg,k,mv, fg_klist_length, indexk
    real(kind=8) :: h,B,eta
    real(kind=8) :: x1,x2,y1,y2,x,y,xupper,yupper,eps
    integer :: i1,i2,j1,j2
    integer :: clock_start, clock_finish, clock_rate
    integer :: mythread, omp_get_thread_num
    integer :: i_fg,i1_fg,i2_fg,  j_fg,j1_fg,j2_fg
    
      mythread = 0 ! if not using OpenMP
!$    mythread = omp_get_thread_num()

    !write(6,*) '++++ mythread = ', mythread

    !print *, '+++ FG_DEBUG = ', FG_DEBUG

    if (FG_num_fgrids == 0) then
        return
        endif 

    eps = min(dx,dy)*0.01d0  ! buffer width to avoid rounding error issues
    
    !write(61,*) '++++ In frompatch, level,mx,my,xlower,ylower'
    !write(61,*) level,mx,my,xlower,ylower
    
    ifg_loop: do ifg=1,FG_num_fgrids
        fg => FG_fgrids(ifg)
        !write(6,*) '++++ in frompatch, tstart,tend: ',fg%tstart_max, fg%tend_max
        !write(6,*) '++++ ifg = ',ifg
        !write(6,*) '++++ fg%xNbb = ',fg%x1bb,fg%x2bb
        !write(61,*) '++++ frompatch xNbb', fg%x1bb, fg%x2bb

        if (FG_DEBUG) then
            write(61,61) ifg,level,time
 61         format('---------- In fgmax_frompatch ----------',/, &
               'ifg = ',i2,' level = ',i1,' time = ',d16.6)
            if (time_afterstep <= minval(fg%t_last_updated)+fg%dt_check) then
                write(61,68) time, minval(fg%t_last_updated)
     68         format('++++ Skipping update at t = ', e20.11,' min t_last = ',&
                       e20.11)
            else
                write(61,67) time, minval(fg%t_last_updated)
     67         format('++++ Doing update at t = ', e20.11,' min t_last = ', &
                       e20.11)
                endif
            endif

!        if ((time >= fg%tstart_max) .and. (time <= fg%tend_max) .and. &
!                (level >= fg%min_level_check) .and. &
!                (level >= minval(fg%levelmax)) .and. &
!                (time_afterstep > minval(fg%t_last_updated)+fg%dt_check)) &
!                then
!            ! Otherwise this level won't update any fg%valuemax elements.
!            !write(61,*) '+++ Setting fg_values'

!        if ((time < fg%tstart_max) .or. (time > fg%tend_max) .or. &
!                (time_afterstep < fg%t_last_updated(level)+fg%dt_check) .or. &
!                (level < fg%min_level_check) .or. &
!                (level < fg%min_levelmax_checked)) then 
                
        if (.not. fg%update_now(level)) then
        
!            if (level == 6) then
!                write(6,601) fg%min_level_check, &
!                 fg%min_levelmax_checked, time_afterstep, &
!                 fg%t_last_updated(level)+fg%dt_check
! 601            format('++++ not now 6: ',2i3,2d26.17)
!                endif
                
            !write(6,*) '++++ nothing:time,level,mythread:',time,level,mythread
            !write(6,*) '++++ tstart,tend: ',fg%tstart_max, fg%tend_max
            !write(6,*) '++++ ',fg%min_level_check, minval(fg%levelmax)
            
            cycle ifg_loop  ! nothing to do, go to next fgmax grid
            endif
            
            
        !===  unindented...
        call system_clock(clock_start,clock_rate)
        
        ! Determine intersection of this patch with bounding box of fgrid:

        xupper = xlower+mx*dx
        yupper = ylower+my*dy
        x1 = max(xlower, fg%x1bb) - eps
        x2 = min(xupper, fg%x2bb) + eps
        y1 = max(ylower, fg%y1bb) - eps
        y2 = min(yupper, fg%y2bb) + eps
        if (FG_DEBUG) then
            write(61,*) 'xlower,xupper: ',xlower,xupper
            write(61,*) 'ylower,yupper: ',ylower,yupper
            write(61,*) 'x1bb, x2bb: ',fg%x1bb, fg%x2bb
            write(61,*) 'y1bb, y2bb: ',fg%y1bb, fg%y2bb
            write(61,*) 'Intersection x1, x2:',x1,x2
            write(61,*) 'Intersection y1, y2:',y1,y2
            endif

        ! If this grid does not intersect the bounding box of fg, do nothing:
        if ((x1 > x2) .or. (y1 > y2)) then
            if (FG_DEBUG) then
                write(61,*) '+++ No intersection found!'
                endif
            !return
            !write(6,*) '++++ No intersection'
            cycle ifg_loop ! go to next fgmax grid
            endif
                    
        
        ! No longer create mask, just use i1,i2, j1,j2 directly
        ! only values(:,i1:i2,j1:j2) on this patch are needed for fgmax
        ! adding 0.5d0 cellwidth necessary for bilinear interp option
        i1 = max(int((x1 - xlower + 0.5d0*dx) / dx), 0)
        i2 = min(int((x2 - xlower + 0.5d0*dx) / dx) + 1, mx+1)
        j1 = max(int((y1 - ylower + 0.5d0*dy) / dy), 0)
        j2 = min(int((y2 - ylower + 0.5d0*dy) / dy) + 1, my+1)

        if (FG_DEBUG) then
            write(61,*) 'patch intersecting fgrid: i1,i2: ',i1,i2
            write(61,*) 'patch intersecting fgrid: j1,j2: ',j1,j2
            endif

        ! Create list of k values for which (fg%x(k),fg%y(k)) is in patch:
        
        fg_klist_length = 0

        if ((fg%point_style == 2) .or. (fg%point_style == 4)) then
            ! fgmax points are on masked grid giving index of each point,
            ! so we don't need to search through all fg%npts points.
            ! instead just loop over part of masked grid intersecting patch:

            ! June 2020: RJL Fixed index error arising when x1 close to fg%xll
            !    due to fact that int(A) = sgn(A)*floor(abs(A)) returns 0
            !    when A is between -1 and +1 regardless of sign.
            !    Hence i1_fg might have been 2 when it should have been 1.
            !    And similarly in y direction.
            
            ! reset eps since now we are computing ranges of indices 
            ! on the fgmax grid that lie within this patch:
            eps = min(fg%dx, fg%dy) * 0.01d0
            
            if (x1 <= fg%xll) then
                i1_fg = 1
            else
                i1_fg = max(int((x1 - fg%xll) / fg%dx + 2), 1)
            endif
            i2_fg = min(int((x2 - fg%xll) / fg%dx + 1), fg%nx)

            if (y1 <= fg%yll) then
                j1_fg = 1
            else
                j1_fg = max(int((y1 - fg%yll) / fg%dy + 2), 1)
            endif
            j2_fg = min(int((y2 - fg%yll) / fg%dy + 1), fg%ny)
            
            
            !write(6,602) x1,x2,y1,y2
            !write(6,602) xlower,xupper,ylower,yupper
            !write(6,602) fg%x1bb, fg%x2bb, fg%y1bb, fg%y2bb
            !write(6,602) fg%xll, fg%xll+(fg%nx-1)*fg%dx, &
            !             fg%yll, fg%yll+(fg%ny-1)*fg%dy
            !write(6,603) i1,i2,j1,j2, i1_fg, i2_fg, j1_fg, j2_fg
 602        format('+++ xy: ',4f13.6)
 603        format('+++ ij: ',8i7)

 
            do j_fg=j1_fg,j2_fg
                do i_fg=i1_fg,i2_fg
                    if (fg%index(i_fg,j_fg) > 0) then
                        k = fg%index(i_fg,j_fg)
                        fg_klist_length = fg_klist_length+1
                        fg%klist(fg_klist_length,mythread) = k
                        !write(6,*) '++++ k, fg%x(k), fg%y(k): ',k, fg%x(k), fg%y(k)

                        endif
                    enddo
                enddo
        else
            ! we must loop over all fgmax points to look for those on patch:
            do k=1,fg%npts
                if ((fg%x(k) >= x1) .and. (fg%x(k) <= x2) .and. &
                    (fg%y(k) >= y1) .and. (fg%y(k) <= y2)) then
                        fg_klist_length = fg_klist_length+1
                        fg%klist(fg_klist_length,mythread) = k
                        endif
                enddo
            endif
        
        !write(6,*) '+++ klength = ',   fg_klist_length
         
        if (fg_klist_length == 0) then
            !write(6,*) '++++ t with klength=0: ', time
            cycle ifg_loop  ! go to next fgmax grid
            endif

        ! now fg_values is indexed by indexk where fg%klist(indexk,mythread) = k
        ! and k is the index into the fgmax grid
        ! so fg_values can be much shorter than fg%npts:
        allocate(fg_values(FG_NUM_VAL, fg_klist_length))
        
        !write(6,*) '++++ t, klength, kfirst, klast: ', &
        !        time, fg_klist_length, fg_klist(1), fg_klist(fg_klist_length)
        
    
        ! Interpolate from q on patch to desired values fg_values on fgrid.
        call fgmax_interpolate(mx,my,meqn,mbc,maux,q,aux, &
             dx,dy,xlower,ylower,ifg,level,fg_values, &
             i1,i2,j1,j2,fg%klist(1:fg%npts,mythread), &
             fg_klist_length,fg%npts)

        if (FG_DEBUG) then
            write(61,*) '+++ updating level: ',level
            write(61,*) '+++ in fgmax_frompatch, count = ',fg_klist_length 
            endif

    
        do indexk=1,fg_klist_length
            k = fg%klist(indexk,mythread)
            ! fg_values is set only at points k where the fgrid intersects the
            ! patch, now stored in this list
            ! Also: only update valuemax if the current patch is at least
            ! as high a level as the patch last used to update:
            if ((level >= fg%levelmax(k))) then
                !fg%t_last_updated(k) = time
                do mv=1,FG_NUM_VAL
                    !print *,'+++ updating fg%valuemax(mv,k),fg_values(mv,indexk):',&
                    !      fg%valuemax(mv,k),fg_values(mv,indexk)
                    if ((level > fg%levelmax(k)) .or. &
                          (fg_values(mv,indexk) > fg%valuemax(mv,k))) then
                        fg%valuemax(mv,k) = fg_values(mv,indexk)
                        ! also keep track of time maximum happened:
                        fg%tmax(mv,k) = time  
                        endif
                    enddo
                fg%levelmax(k) = level
                endif

            ! keep track of arrival time...
            ! This might not be correct when there is subsidence or uplift?
            h = fg_values(1,indexk)
            B = fg%aux(level,1,k)
            eta = h+B
            if ((level >= fg%min_level_check) .and. &
               (h>dry_tolerance) .and. &
               (eta > sea_level + fg%arrival_tol) .and. &
               (fg%arrival_time(k) == FG_NOTSET)) then
                    fg%arrival_time(k) = time
                endif

            enddo
            
        deallocate(fg_values)
            
        !call system_clock(clock_finish,clock_rate)
        !write(6,*) '+++ t, cpu time , klength, mythread : ', &
        !    time,(clock_finish - clock_start), fg_klist_length, mythread

        enddo ifg_loop

end subroutine fgmax_frompatch

! =====================================================
subroutine rpn2_ptwise(ixy, num_eqn, num_aux, num_waves, q_l, q_r,            &
aux_l, aux_r, wave, s, amdq, apdq)
! =====================================================
! Riemann-solver for the advection equation
!    q_t  +  u*q_x + v*q_y = 0
! where u and v are a given velocity field.

! waves: 1
! equations: 1
! aux fields: 2

! Conserved quantities:
!       1 q

! Auxiliary variables:
!         1  x_velocity
!         2  y_velocity

! solve Riemann problem along one slice of data.
! This data is along a slice in the x-direction if ixy=1
!                            or the y-direction if ixy=2.

! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell

! On output, wave contains the waves, s the speeds,
! and amdq, apdq the left-going and right-going flux differences,
! respectively.  Note that in this advective form, the sum of
! amdq and apdq is not equal to a difference of fluxes except in the
! case of constant velocities.

    implicit none

    ! Input
    integer, intent(in) :: num_eqn, num_aux, num_waves, ixy
    real(kind=8), intent(in) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in) :: aux_l(num_aux), aux_r(num_aux)

    ! Output
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Locals
    integer :: normal_index, transverse_index
    real(kind=8) :: delta(3), a(2)


!     # Set wave, speed, and flux differences:
!     ------------------------------------------

        wave(1,1) = q_r(1) - q_l(1)
        s(1) = aux_r(ixy)
    !        # The flux difference df = s*wave  all goes in the downwind direction:
        amdq(1) = dmin1(aux_r(ixy), 0.d0) * wave(1,1)
        apdq(1) = dmax1(aux_r(ixy), 0.d0) * wave(1,1)

    return
    end subroutine rpn2_ptwise

c
c --------------------------------------------------------------------
c
       subroutine intcopy(val,mitot,mjtot,mktot,nvar,
     &                    ilo,ihi,jlo,jhi,klo,khi,level,
     &                    iputst,jputst,kputst)

      use amr_module
      implicit double precision (a-h, o-z)

      dimension val(nvar,mitot,mjtot,mktot)


      iadd(ivar,i,j,k)   = loc    +    (ivar-1)
     &                            +    (i-1)*nvar
     &                            +    (j-1)*nvar*mi
     &                            +    (k-1)*nvar*mi*mj

c ::::::::::::::::::::::::::: INTCOPY :::::::::::::::::::::::::::::::
c
c    find intersecting grids at the same level. copy data from
c    old grid to val. 
c    old grid has "nghost" ghost cells - passed in nodal common block.
c    new grid has no ghost cells - indices describe entire patch.
c    iputst, jputst: where to copy values into. may not be in
c                    location corresponding to ilo,ihi,etc. if
c                    the patch has been periodically wrapped.
c    
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

       mptr = lstart(level)

 10    if (mptr .eq. 0) go to 99
          iglo = node(ndilo,mptr)
          ighi = node(ndihi,mptr)
          jglo = node(ndjlo,mptr)
          jghi = node(ndjhi,mptr)
          kglo = node(ndklo,mptr)
          kghi = node(ndkhi,mptr)

c         # does it intersect?
          ixlo = max(iglo,ilo)
          ixhi = min(ighi,ihi)
          jxlo = max(jglo,jlo)
          jxhi = min(jghi,jhi)
          kxlo = max(kglo,klo)
          kxhi = min(kghi,khi)

          if ((ixlo .le. ixhi .and. jxlo .le. jxhi) .and.
     c                             (kxlo .le. kxhi)) then
              loc  = node(store1,mptr)
              nx   = ighi - iglo + 1
              ny   = jghi - jglo + 1
              nz   = kghi - kglo + 1
              mi   = nx + 2*nghost
              mj   = ny + 2*nghost
              mk   = nz + 2*nghost
              do 20 k    = kxlo, kxhi
              do 20 j    = jxlo, jxhi
              do 20 i    = ixlo, ixhi
              do 40 ivar = 1, nvar
                  val(ivar,iputst+i-ilo,jputst+j-jlo,kputst+k-klo) =
     1                alloc(iadd(ivar,i-iglo+nghost+1,j-jglo+nghost+1,
     2                                           k-kglo+nghost+1))
 40           continue
 20           continue
          endif
          mptr = node(levelptr, mptr)
          go to 10

 99   return
      end

! ============================================================================
!  Program:     AMRClaw
!  File:        restrt_alloc.f90
!  Created:     2009-10-22
!  Author:      Marsha Berger and Randy LeVeque
! ============================================================================
!  Description:  Initialization of alloc storage for restart
! ============================================================================


subroutine restrt_alloc(isize)

    use amr_module
    implicit none
    integer :: isize


!    if (.not.allocated(storage)) then  ! old way, changed mjb Sept. 2014
    if (.not.allocated(alloc)) then     ! new way uses allocatable, not pointer, arrays
        write(6,*)"allocating ",isize," -sized alloc array"
        memsize = isize
!       allocate(storage(memsize))
        allocate(alloc(memsize))
!       alloc => storage
        print *, "Storage allocated of size ",memsize," at restart"
    else
        print *, "Storage already allocated!"
    endif

end subroutine restrt_alloc

subroutine setaux(mbc,mx,my,xlower,ylower,dx,dy,maux,aux)

    ! Called at start of computation before calling qinit, and
    ! when AMR is used, also called every time a new grid patch is created.
    ! Use to set auxiliary arrays aux(1:maux, 1-mbc:mx+mbc, 1-mbc:my+mbc).
    ! Note that ghost cell values may need to be set if the aux arrays
    ! are used by the Riemann solver(s).
    !
    ! This default version does nothing, unless using adjoint-flagging.

    use amr_module, only : NEEDS_TO_BE_SET
    use adjoint_module, only : adjoint_flagging,innerprod_index
 
    implicit none
    integer, intent(in) :: mbc,mx,my,maux
    real(kind=8), intent(in) :: xlower,ylower,dx,dy
    real(kind=8), intent(inout) ::  aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc)

    integer :: jj, ii

    if(adjoint_flagging) then
        ! If a new grid has been created, but hadn't been flagged
        ! set innerproduct to zero.
        do jj=1-mbc,my+mbc
            do ii=1-mbc,mx+mbc
                if (aux(1,ii,jj) .eq. NEEDS_TO_BE_SET) then
                    aux(innerprod_index,ii,jj) = 0.d0
                endif
            enddo
        enddo
    endif

end subroutine setaux

c
c -----------------------------------------------------
c     Routine to write netcdf files in the classic format
!        #jj-2011.02.04
!        # Each file written by the fortran code has 
!        # Dimensions:
!        #           timedimension : UNLIMITED
!        #           meqn          : The number of equations
!        #           dimx_<gridno> : X dimension for grid number <gridno>
!        #           dimy_<gridno> : Y dimension for grid number <gridno>
!        # Variables:
!        #           timedimension : Stores the time of the frame
!        #           ngrids        : Number of grids in this frame
!        #           naux          : Number of Auxilary Variables
!        #           ndim          : Number of Dimensions in the frame
!        #           grid_<gridno> : A grid of (meqn,dimx,dimy)
!        # Attributes:
!        # (grid_<no>) gridno      : The number of this grid <grid_no>
!        #           level         : The AMR level
!        #           dim_names     : a list of dimensions [dimx,dimy]
!        #           dim<x,y>.low  : The lowest dimension value 
!        #           dim<x,y>.d    : The distance between grid points 
c -----------------------------------------------------
c
      subroutine valout (lst, lend, time, nvar, naux)
c
      use amr_module
      use netcdf      ! does this work????
      implicit double precision (a-h,o-z)
      character*10  matname1, matname2

c     include 'netcdf.inc'
      real(kind=8) time
      integer ncid,rcode
      integer timeid,tVarID,meqnID,ngridsVarID,nauxVarID,ndimVarID
      integer dimxid,dimyid,xlowid,ylowid,dxid,dyid
      integer gridid
      integer ntimes
      character*2 gridstr
      character*40 dim_names
      REAL, ALLOCATABLE  ::grid(:,:,:)
      real dx,dy,xlow,ylow
      
c OLD INDEXING
c     iadd(i,j,ivar) = loc + i - 1 + mitot*((ivar-1)*mjtot+j-1)
c     iaddaux(i,j,iaux) = locaux + i - 1 + mitot*((iaux-1)*mjtot+j-1)
c NEW INDEXING
      iadd(ivar,i,j)  = loc + ivar-1 + nvar*((j-1)*mitot+i-1)
      iaddaux(iaux,i,j) = locaux + iaux-1 + naux*((j-1)*mitot+i-1)


      ntimes=1
c ::::::::::::::::::::::::::: VALOUT ::::::::::::::::::::::::::::::::::;
c graphics output of soln values for contour or surface plots.
c modified for GeoClaw to output the surface level along with q.
c    surface = q(i,j,1) + aux(i,j,1)
c :::::::::::::::::::::::::::::::::::::;:::::::::::::::::::::::::::::::;

c
c     ### MATLAB graphics output
c
      if (matlabout) then
c        ###  make the file names and open output files
         matname1 = 'fort.qxxxx'
         matname2 = 'fort.txxxx'
         matunit1 = 50
         matunit2 = 60
         nstp     = matlabu
         do 55 ipos = 10, 7, -1
            idigit = mod(nstp,10)
            matname1(ipos:ipos) = char(ichar('0') + idigit)
            matname2(ipos:ipos) = char(ichar('0') + idigit)
            nstp = nstp / 10
 55      continue

        !!!!Define netcdf file
         rcode=NF_CREATE(matname1//'.nc',NF_NOCLOBBER,ncid)
         if(rcode.ne.NF_NOERR) print *,'ERROR OPENING NETCDF FILE'
         rcode=NF_DEF_DIM(ncid,'timedimension',NF_UNLIMITED,timeid)
         rcode=NF_DEF_VAR(ncid,'timedimension',NF_FLOAT,1,timeid,tVarID)
         rcode=NF_DEF_DIM(ncid,'meqn',nvar+1,meqnid)
         rcode=NF_DEF_VAR(ncid,'ngrids',NF_INT,0,0,ngridsVarID)
         rcode=NF_DEF_VAR(ncid,'naux',NF_INT,0,0,nauxVarID)
         rcode=NF_DEF_VAR(ncid,'ndim',NF_INT,0,0,ndimVarID)
         rcode=NF_ENDDEF(ncid)
!         rcode=NF_CLOSE(ncid)
         if(rcode.ne.NF_NOERR) print *,'ERROR  LEAVING DEFINE MODE'
         level = lst
         ngrids = 0
 65      if (level .gt. lfine) go to 90
            mptr = lstart(level)
 70         if (mptr .eq. 0) go to 80
              ngrids  = ngrids + 1
              nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
              ny      = node(ndjhi,mptr) - node(ndjlo,mptr) + 1
              loc     = node(store1, mptr)
              locaux  = node(storeaux,mptr)
              mitot   = nx + 2*nghost
              mjtot   = ny + 2*nghost
              xlow = rnode(cornxlo,mptr)
              ylow = rnode(cornylo,mptr)
              rcode=NF_REDEF(ncid)
              if(rcode.ne.NF_NOERR) print *,'ERROR  REDEFINE MODE'
              write(gridstr,67) mptr
              
67            format(I2.2)              
              rcode=NF_DEF_DIM(ncid,'dimx_'//trim(gridstr),nx,dimxid)
              if(rcode.ne.NF_NOERR) print *,'ERROR  DEFINE DIMS'
              rcode=NF_DEF_DIM(ncid,'dimy_'//trim(gridstr),ny,dimyid)
              if(rcode.ne.NF_NOERR) print *,'ERROR  DEFINE DIMS'
              

              rcode=NF_DEF_Var(ncid,'grid_'//trim(gridstr),NF_FLOAT,4,
     &              (/dimxid,dimyid,meqnid,timeid/),gridid)
               if(rcode.ne.NF_NOERR) print *,'ERROR  DEFINE VAR'
               
              rcode=NF_PUT_ATT_INT(ncid,gridid,'gridno',NF_INT,1,
     &              mptr)
     
              rcode=NF_PUT_ATT_INT(ncid,gridid,'level',NF_INT,1,level)
              
              dim_names="['dimx','dimy']"
              rcode=NF_PUT_ATT_TEXT(ncid,gridid,'dim_names',
     &         LEN_TRIM(dim_names),TRIM(dim_names))
     
              rcode=NF_PUT_ATT_REAL(ncid,gridid,'dimx.lower',NF_DOUBLE,
     &              1,xlow)     
              rcode=NF_PUT_ATT_REAL(ncid,gridid,'dimy.lower',NF_DOUBLE,
     &              1,ylow)
     
              dx=hxposs(level)
              dy=hyposs(level)
              rcode=NF_PUT_ATT_REAL(ncid,gridid,'dimx.d',NF_FLOAT,1,
     &          dx)
              rcode=NF_PUT_ATT_REAL(ncid,gridid,'dimy.d',NF_FLOAT,1,
     &          dy) 
     
              rcode=NF_ENDDEF(ncid)
              
              allocate(grid(nvar+1,nx,ny))
              
!!! with netcdf4 we can have groups that will encapsulate all of this data, but for now....use the netcdf3 format "universal" with scientific python

      do j = nghost+1, mjtot-nghost
         do i = nghost+1, mitot-nghost
            do ivar=1,nvar+1
               if (dabs(alloc(iadd(ivar,i,j))) .lt. 1d-90) then
                  alloc(iadd(ivar,i,j)) = 0.d0
               endif
               if ivar .eq. 4 then
                 surface = alloc(iadd(1,i,j)) + alloc(iaddaux(1,i,j))
                 grid(4,i-nghost,j-nghost) = surface
               else
                 grid(ivar,i-nghost,j-nghost)=alloc(iadd(ivar,i,j)) 
               endif
            enddo
         enddo
      enddo
      
      rcode=NF_PUT_VARA_REAL(ncid,gridid,(/1,1,1,1/), 
     &      (/nx,ny,nvar+1,1/),grid)

      deallocate(grid)

109       format(4e26.16)
            mptr = node(levelptr, mptr)
            go to 70
 80      level = level + 1
         go to 65

 90     continue

      rcode=NF_PUT_VAR_DOUBLE(ncid,tVarID,time)
      if(rcode.ne.NF_NOERR) print *,'ERROR  Write Time'
      rcode=NF_PUT_VAR_INT(ncid,ngridsVarID,int(ngrids))
      if(rcode.ne.NF_NOERR) print *,'ERROR  Write GridNo'
      rcode=NF_PUT_VAR_INT(ncid,nauxVarID,3)
      rcode=NF_PUT_VAR_INT(ncid,ndimVarID,2)
      rcode=NF_CLOSE(ncid)
      

      write(6,601) matlabu,time
  601 format('GeoClaw: Frame ',i4,
     &       ' output files done at time t = ', d12.6,/)

      matlabu = matlabu + 1

      endif

      return
      end

c     
c     
c=========================================================
      subroutine out1(meqn,mbc,mx,xlower,dx,q,t,iframe,aux,maux,outaux)
c=========================================================
c     
c     # Output the results for a general system of conservation laws
c     # in 1 dimension
c     
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw1.m
c     # The same format is used by the amrclaw package.
c     # Here it's adapted to output just the single grid.
c     
c     # set outaux = .true. to also output the aux arrays to fort.a<iframe>
c     
c     
      implicit double precision (a-h,o-z)
      dimension q(meqn,1-mbc:mx+mbc)
      dimension aux(maux,1-mbc:mx+mbc)
      character*10 fname1, fname2, fname3
      logical outaux
      character(len=8) :: file_format

      file_format = 'ascii'  ! only format currently supported

c     
c     # Write the results to the file fort.q<iframe>
c     # Use format required by matlab script  plotclaw1.m
c     # The same format is used by the amrclaw package.  
c     # Here it's adapted to output just the single grid.
c     
c     # first create the file name and open file
c     
      fname1 = 'fort.qxxxx'
      fname2 = 'fort.txxxx'
      fname3 = 'fort.axxxx'
      nstp = iframe
      do 55 ipos = 10, 7, -1
         idigit = mod(nstp,10)
         fname1(ipos:ipos) = char(ichar('0') + idigit)
         fname2(ipos:ipos) = char(ichar('0') + idigit)
         fname3(ipos:ipos) = char(ichar('0') + idigit)
         nstp = nstp / 10
 55   continue

      open(unit=50,file=fname1,status='unknown',form='formatted')
      open(unit=60,file=fname2,status='unknown',form='formatted')

c     
c     # the following parameters are used in amrclaw where there are
c     # multiple grids.  Here they are all set to 1:
      ngrids = 1
      mptr = 1
      level = 1

      write(50,1001) mptr,level,mx
 1001 format(i5,'                 grid_number',/,
     &     i5,'                 AMR_level',/,
     &     i5,'                 mx')

      write(50,1002) xlower,dx
 1002 format(e18.8,'    xlow', /,
     &     e18.8,'    dx', /)
c     
      do 10 i=1,mx
         do m=1,meqn
c     # exponents with more than 2 digits cause problems reading
c     # into matlab... reset tiny values to zero:
            if (dabs(q(m,i)) .lt. 1d-99) q(m,i) = 0.d0
         enddo
c     
         write(50,1005) (q(m,i), m=1,meqn)
 1005    format(50e26.16)
c     
 10   continue
      write(50,*) ' '
      write(50,*) ' '


      if (outaux) then 
c     # also output the aux arrays:
         open(unit=70,file=fname3,status='unknown',form='formatted')
         write(70,1001) mptr,level,mx
         write(70,1002) xlower,dx
         do 110 i=1,mx
            do m=1,maux
c     # exponents with more than 2 digits cause problems reading
c     # into matlab... reset tiny values to zero:
               if (dabs(aux(m,i)) .lt. 1d-99) aux(m,i) = 0.d0
            enddo
c     
            write(70,1005) (aux(m,i), m=1,maux)
c     
 110     continue
         write(70,*) ' '
         close(unit=70)
      endif

      write(60,1000) t,meqn,ngrids,maux,1,mbc,file_format

 1000 format(e26.16,'    time', /,
     &     i5,'                 meqn'/,
     &     i5,'                 ngrids'/,
     &     i5,'                 maux'/,
     &     i5,'                 ndim'/,
     &     i5,'                 nghost'/,
     &     a10,'                 format'/,/)
c     

      close(unit=50)
      close(unit=60)

      return
      end

c
c -----------------------------------------------------------
c
      subroutine flagger(nvar,naux,lcheck,start_time)

      use amr_module
      use adjoint_module,only:calculate_tol,eptr,errors,totnum_adjoints,
     1     adjoints,trange_start,trange_final,adjoint_flagging,grid_num
      implicit double precision (a-h,o-z)

      integer omp_get_thread_num, omp_get_max_threads
      integer mythread/0/, maxthreads/1/
      integer listgrids(numgrids(lcheck)), locuse
      logical keepflagging

c ::::::::::::::::::::: FLAGGER :::::::::::::::::::::::::
c
c flagger = set up for and call two routines that flag using
c    (a) spatial gradients, or other user-specified criteria
c    (b) richardson error estimates
c
c the two approaches share an array with boundary ghost values 
c
c ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

c      call prepgrids(listgrids,numgrids(lcheck),lcheck)
         mbuff = max(nghost,ibuff+1)


      if(adjoint_flagging) then
c        allocating space for tracking error estimates
c        (used at next regridding time to determine tolerance)
         if (flag_richardson) then
           allocate(errors(numcells(lcheck)/2))
           allocate(eptr(numgrids(lcheck)))
           errors = 0
           eptr(1) = 0

           ! new version has variable node size arrays, so need to use current size
           allocate(grid_num(maxgr))
         endif
      endif

c before parallel loop give grids the extra storage they need for error estimation
         do  jg = 1, numgrids(lcheck)
c            mptr = listgrids(jg)
            levSt  = listStart(lcheck)
            mptr   = listOfgrids(levSt+jg-1)
            nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
            mitot  = nx + 2*nghost
            if (flag_richardson) then
               locbig = igetsp(mitot*nvar)
               node(tempptr,mptr) = locbig

               if(adjoint_flagging) then
                 grid_num(mptr) = jg
                 if (jg .ne. numgrids(lcheck)) then
                   eptr(jg+1) = eptr(jg)+(nx/2)
                 endif
               endif
            else 
               locbig = 0
            endif
            mibuff = nx + 2*mbuff       ! NOTE THIS NEW DIMENSIONING TO ALLOW ROOM FOR BUFFERING IN PLACE
            locamrflags = igetsp(mibuff)
            node(storeflags,mptr) = locamrflags
          end do

!$OMP PARALLEL DO PRIVATE(jg,mptr,nx,mitot,locnew,locaux),
!$OMP&            PRIVATE(time,dx,xleft,xlow,locbig),
!$OMP&            PRIVATE(locold,mbuff,mibuff,locamrflags,i),
!$OMP&            PRIVATE(locuse,keepflagging),
!$OMP&            SHARED(numgrids,listgrids,lcheck,nghost,nvar,naux),
!$OMP&            SHARED(levSt,listStart,listOfGrids),
!$OMP&            SHARED(tolsp,alloc,node,rnode,hxposs,ibuff),
!$OMP&            SHARED(start_time,possk,flag_gradient,flag_richardson)
!$OMP&            DEFAULT(none),
!$OMP&            SCHEDULE(DYNAMIC,1)
       do  jg = 1, numgrids(lcheck)
c          mptr = listgrids(jg)
          levSt  = listStart(lcheck)
          mptr   = listOfGrids(levSt+jg-1)
          nx     = node(ndihi,mptr) - node(ndilo,mptr) + 1
          mitot  = nx + 2*nghost
          locnew = node(store1,mptr)
          locaux = node(storeaux,mptr)
          time   = rnode(timemult,mptr)
          dx     = hxposs(lcheck)
          xleft  = rnode(cornxlo,mptr)
          xlow   = xleft - nghost*dx
c
          locbig =  node(tempptr,mptr)
c         # straight copy into scratch array so don't mess up latest soln.

c         ## at later times want to use newest soln for spatial error flagging
c         ## at initial time want to use initial conditions (so retain symmetry for example)
         if (start_time+possk(lcheck) .ne. time) then !exact equality test-relying on ieee arith repeatability
c            do in other order in case user messes up locbig in flag2refine, already have
c            them in locnew
             call bound(time,nvar,nghost,alloc(locnew),mitot,mptr,
     1                  alloc(locaux),naux)
             locuse = locnew ! flag based on newest vals
             if (flag_richardson) then
               do 10 i = 1, mitot*nvar
 10             alloc(locbig+i-1) = alloc(locnew+i-1)
             endif

         else   ! boundary values already in locold
             locold = node(store2,mptr)
             locuse = locold ! flag based on old vals at initial time
             ! put back this way to agree with nosetests
             if (flag_richardson) then
               do 11 i = 1, mitot*nvar
 11              alloc(locbig+i-1) = alloc(locold+i-1)
             endif
         endif

!        # need at least as big as nghost to fit ghost cells. if ibuff is bigger make
!        # the flagged array bigger so can buffer in place
         mbuff = max(nghost,ibuff+1)  
         mibuff = nx + 2*mbuff       ! NOTE THIS NEW DIMENSIONING TO ALLOW ROOM FOR BUFFERING IN PLACE

!              ##  locamrflags used for flag storage.
!              ## flagregions flags directly into it. flag2refine and
!              ## richardson flags added to it. Then colate finished the job
                locamrflags = node(storeflags,mptr)
                do 20 i = 1, mibuff  ! initialize
 20                alloc(locamrflags+i-1) = UNSET

c      ##  new call to flag regions: check if cells must be refined, or exceed
c      ##  maximum refinement level for that region.  used to be included with
c      ## flag2refine. moved here to include flags from richardson too.
       call flagregions1(nx,mbuff,rnode(cornxlo,mptr),
     1                  dx,lcheck,time,
     2                  alloc(locamrflags))

c       ##  check if any flags remain unset
        keepflagging = .false.
        do i = 1, mibuff
            if(alloc(locamrflags+i-1) == UNSET) then
                keepflagging = .true.
                exit
            endif
        enddo

         if (flag_gradient .and. keepflagging) then

c     # call user-supplied routine to flag any points where 
c     # refinement is desired based on user's criterion.  
c     # Default version compares spatial gradient to tolsp.

c no longer getting locbig, using "real" solution array in locnew
            call flag2refine1(nx,nghost,mbuff,nvar,naux,
     &                        xleft,dx,time,lcheck,
     &                        tolsp,alloc(locuse),
     &                        alloc(locaux),alloc(locamrflags))
             endif     
c
c       ##  check if any flags remain unset
        keepflagging = .false.
        do i = 1, mibuff
            if(alloc(locamrflags+i-1) == UNSET) then
                keepflagging = .true.
                exit
            endif
        enddo

         if (flag_richardson .and. keepflagging) then
              call errest(nvar,naux,lcheck,mptr,nx)
         endif

       end do
! $OMP END PARALLEL DO

       if(adjoint_flagging)then
           if (flag_richardson) then
               call calculate_tol(lcheck)
               deallocate(errors)
               deallocate(eptr)
               deallocate(grid_num)
           endif
       endif

       return
       end

!     ==================================================================
    subroutine flux3(ixyz,maxm,num_eqn,num_waves,num_ghost,mx, &
    q1d,dtdx1d,dtdy,dtdz,aux1,aux2,aux3,num_aux, &
    method,mthlim,qadd,fadd,gadd,hadd,cfl1d, &
    wave,s,amdq,apdq,cqxx, &
    bmamdq,bmapdq,bpamdq,bpapdq, &
    cmamdq,cmapdq,cpamdq,cpapdq, &
    cmamdq2,cmapdq2,cpamdq2,cpapdq2, &
    bmcqxxp,bpcqxxp,bmcqxxm,bpcqxxm, &
    cmcqxxp,cpcqxxp,cmcqxxm,cpcqxxm, &
    bmcmamdq,bmcmapdq,bpcmamdq,bpcmapdq, &
    bmcpamdq,bmcpapdq,bpcpamdq,bpcpapdq, &
    rpn3,rpt3,rptt3,use_fwave)
!     ==================================================================

!     # Compute the modification to fluxes f, g and h that are generated by
!     # all interfaces along a 1D slice of the 3D patch.
!     #    ixyz = 1  if it is a slice in x
!     #           2  if it is a slice in y
!     #           3  if it is a slice in z
!     # This value is passed into the Riemann solvers. The flux modifications
!     # go into the arrays fadd, gadd and hadd.  The notation is written
!     # assuming we are solving along a 1D slice in the x-direction.

!     # fadd(i,.) modifies F to the left of cell i
!     # gadd(i,.,1,slice) modifies G below cell i (in the z-direction)
!     # gadd(i,.,2,slice) modifies G above cell i
!     #                   The G flux in the surrounding slices may
!     #                   also be updated.
!     #                   slice  =  -1     The slice below in y-direction
!     #                   slice  =   0     The slice used in the 2D method
!     #                   slice  =   1     The slice above in y-direction
!     # hadd(i,.,1,slice) modifies H below cell i (in the y-direction)
!     # hadd(i,.,2,slice) modifies H above cell i
!     #                   The H flux in the surrounding slices may
!     #                   also be updated.
!     #                   slice  =  -1     The slice below in z-direction
!     #                   slice  =   0     The slice used in the 2D method
!     #                   slice  =   1     The slice above in z-direction
!     #
!     # The method used is specified by method(2) and method(3):

!        method(2) = 1 No correction waves
!                  = 2 if second order correction terms are to be added, with
!                      a flux limiter as specified by mthlim.  No transverse
!                      propagation of these waves.

!         method(3) specify how the transverse wave propagation
!         of the increment wave and the correction wave are performed.
!         Note that method(3) is given by a two digit number, in
!         contrast to what is the case for claw2. It is convenient
!         to define the scheme using the pair (method(2),method(3)).

!         method(3) <  0 Gives dimensional splitting using Godunov
!                        splitting, i.e. formally first order
!                        accurate.
!                      0 Gives the Donor cell method. No transverse
!                        propagation of neither the increment wave
!                        nor the correction wave.
!                   = 10 Transverse propagation of the increment wave
!                        as in 2D. Note that method (2,10) is
!                        unconditionally unstable.
!                   = 11 Corner transport upwind of the increment
!                        wave. Note that method (2,11) also is
!                        unconditionally unstable.
!                   = 20 Both the increment wave and the correction
!                        wave propagate as in the 2D case. Only to
!                        be used with method(2) = 2.
!                   = 21 Corner transport upwind of the increment wave,
!                        and the correction wave propagates as in 2D.
!                        Only to be used with method(2) = 2.
!                   = 22 3D propagation of both the increment wave and
!                        the correction wave. Only to be used with
!                        method(2) = 2.

!         Recommended settings:   First order schemes:
!                                       (1,10) Stable for CFL < 1/2
!                                       (1,11) Stable for CFL < 1
!                                 Second order schemes:
!                                        (2,20) Stable for CFL < 1/2
!                                        (2,22) Stable for CFL < 1

!         WARNING! The schemes (2,10), (2,11) are unconditionally
!                  unstable.

!                       ----------------------------------

!     Note that if method(6)=1 then the capa array comes into the second
!     order correction terms, and is already included in dtdx1d:
!     If ixyz = 1 then
!        dtdx1d(i) = dt/dx                      if method(6) = 0
!                  = dt/(dx*capa(i,jcom,kcom))  if method(6) = 1
!     If ixyz = 2 then
!        dtdx1d(j) = dt/dy                      if method(6) = 0
!                  = dt/(dy*capa(icom,j,kcom))  if method(6) = 1
!     If ixyz = 3 then
!        dtdx1d(k) = dt/dz                      if method(6) = 0
!                  = dt/(dz*capa(icom,jcom,k))  if method(6) = 1

!     Notation:
!        The jump in q (q1d(i,:)-q1d(i-1,:))  is split by rpn3 into
!            amdq =  the left-going flux difference  A^- Delta q
!            apdq = the right-going flux difference  A^+ Delta q
!        Each of these is split by rpt3 into
!            bmasdq = the down-going transverse flux difference B^- A^* Delta q
!            bpasdq =   the up-going transverse flux difference B^+ A^* Delta q
!        where A^* represents either A^- or A^+.


    implicit real*8(a-h,o-z)
    external rpn3,rpt3, rptt3
    dimension     q1d(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension    amdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension    apdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   cqxx(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   qadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   fadd(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension   gadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)
    dimension   hadd(num_eqn,2,-1:1,1-num_ghost:maxm+num_ghost)

    dimension  cmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpapdq(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  cmamdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmapdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpamdq2(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpapdq2(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bmcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpcqxxm(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bmcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cmcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  cpcqxxp(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension  bpcmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bpcpapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcmamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcmapdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcpamdq(num_eqn,1-num_ghost:maxm+num_ghost)
    dimension  bmcpapdq(num_eqn,1-num_ghost:maxm+num_ghost)

    dimension dtdx1d(1-num_ghost:maxm+num_ghost)
    dimension aux1(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux2(num_aux,1-num_ghost:maxm+num_ghost,3)
    dimension aux3(num_aux,1-num_ghost:maxm+num_ghost,3)

    dimension    s(num_waves,1-num_ghost:maxm+num_ghost)
    dimension  wave(num_eqn,num_waves,1-num_ghost:maxm+num_ghost)

    dimension method(7),mthlim(num_waves)
    logical :: limit, use_fwave
    common/comxyt/dtcom,dxcom,dycom,dzcom,tcom,icom,jcom,kcom

!f2py external rpn3, rpt3, rptt3
!f2py intent(callback) rpn3,rpt3, rptt3

    limit = .false.
    do 5 mw=1,num_waves
        if (mthlim(mw) > 0) limit = .TRUE. 
    5 END DO

!     # initialize flux increments:
!     -----------------------------

    forall (m = 1:num_eqn, i = 1-num_ghost:mx+num_ghost)
    qadd(m,i) = 0.d0
    fadd(m,i) = 0.d0
    end forall
    forall (m=1:num_eqn,k=1:2, j = -1:1, i = 1-num_ghost:mx+num_ghost)
    gadd(m, k, j, i) = 0.d0
    hadd(m, k, j, i) = 0.d0
    end forall

!     # local method parameters
    if (method(3) < 0) then
    !        # dimensional splitting
        m3 = -1
        m4 = 0
    else
    !        # unsplit method
        m3 = method(3)/10
        m4 = method(3) - 10*m3
    endif

!     -----------------------------------------------------------
!     # solve normal Riemann problem and compute Godunov updates
!     -----------------------------------------------------------

!     # aux2(1-num_ghost,1,2) is the start of a 1d array now used by rpn3

    call rpn3(ixyz,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
    aux2(1,1-num_ghost,2),aux2(1,1-num_ghost,2), &
    wave,s,amdq,apdq)


!     # Set qadd for the donor-cell upwind method (Godunov)
    forall (m = 1:num_eqn, i = 1:mx+1)
    qadd(m,i) = qadd(m,i) - dtdx1d(i)*apdq(m,i)
    qadd(m,i-1) = qadd(m,i-1) - dtdx1d(i-1)*amdq(m,i)
    end forall

!     # compute maximum wave speed for checking Courant number:
    cfl1d = 0.d0
    do i=1,mx+1
        do mw=1,num_waves
        !          # if s>0 use dtdx1d(i) to compute CFL,
        !          # if s<0 use dtdx1d(i-1) to compute CFL:
            cfl1d = dmax1(cfl1d, dtdx1d(i)*s(mw,i), &
            -dtdx1d(i-1)*s(mw,i))
        end do
    end do

    if (method(2) == 1) go to 130

!     -----------------------------------------------------------
!     # modify F fluxes for second order q_{xx} correction terms:
!     #   F fluxes are in normal, or x-like, direction
!     -----------------------------------------------------------

!     # apply limiter to waves:
    if (limit) call limiter(maxm,num_eqn,num_waves,num_ghost,mx,wave, &
    s,mthlim)

    if (.not. use_fwave) then
        do i = 2-num_ghost,mx+num_ghost
            ! modified in Version 4.3 to use average only in cqxx, not transverse
            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))

            do m = 1, num_eqn
                cqxx(m,i) = 0.d0
            end do
            do mw = 1,num_waves
                do m = 1,num_eqn
                    cqxx(m,i) = cqxx(m,i) + 0.5d0 * dabs(s(mw,i)) &
                        * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                end do
            end do
            do m = 1,num_eqn
                fadd(m,i) = fadd(m,i) + cqxx(m,i)
            end do
        end do
    else    ! Use f-waves
        do i = 2-num_ghost,mx+num_ghost
            dtdxave = 0.5d0 * (dtdx1d(i-1) + dtdx1d(i))

            do m = 1, num_eqn
                cqxx(m,i) = 0.d0
            end do
            do mw = 1,num_waves
                do m = 1,num_eqn
                    cqxx(m,i) = cqxx(m,i) + 0.5d0 * dsign(1.d0, s(mw,i)) &
                        * (1.d0 - dabs(s(mw,i))*dtdxave) * wave(m,mw,i)
                end do
            end do
            do m = 1,num_eqn
                fadd(m,i) = fadd(m,i) + cqxx(m,i)
            end do
        end do
    end if

    130 continue

    if (m3 <= 0) return !! no transverse propagation

!     --------------------------------------------
!     # TRANSVERSE PROPAGATION
!     --------------------------------------------

!     # split the left-going flux difference into down-going and up-going
!     # flux differences (in the y-direction).

    call rpt3(ixyz,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux1,aux2,aux3,amdq,bmamdq,bpamdq)

!     # split the right-going flux difference into down-going and up-going
!     # flux differences (in the y-direction).

    call rpt3(ixyz,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux1,aux2,aux3,apdq,bmapdq,bpapdq)

!     # split the left-going flux difference into down-going and up-going
!     # flux differences (in the z-direction).

    call rpt3(ixyz,3,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux1,aux2,aux3,amdq,cmamdq,cpamdq)

!     # split the right-going flux difference into down-going and up-going
!     # flux differences (in the y-direction).

    call rpt3(ixyz,3,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx,q1d,q1d, &
              aux1,aux2,aux3,apdq,cmapdq,cpapdq)

!     # Split the correction wave into transverse propagating waves
!     # in the y-direction and z-direction.

    if (m3 == 2) then
        if (num_aux > 0) then
        !            # The corrections cqxx affect both cell i-1 to left and cell i
        !            # to right of interface.  Transverse splitting will affect
        !            # fluxes on both sides.
        !            # If there are aux arrays, then we must split cqxx twice in
        !            # each transverse direction, once with imp=1 and once with imp=2:

        !            # imp = 1 or 2 is used to indicate whether we are propagating
        !            # amdq or apdq, i.e. cqxxm or cqxxp

        !            # in the y-like direction with imp=1
            call rpt3(ixyz,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                      q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

        !            # in the y-like direction with imp=2
            call rpt3(ixyz,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                      q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxp,bpcqxxp)

        !            # in the z-like direction with imp=1
            call rpt3(ixyz,3,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                      q1d,q1d,aux1,aux2, auxnum_aux,cqxx,cmcqxxm,cpcqxxm)

        !            # in the z-like direction with imp=2
            call rpt3(ixyz,3,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
                      q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxp,cpcqxxp)
        else
        !            # aux arrays aren't being used, so we only need to split
        !            # cqxx once in each transverse direction and the same result can
        !            # presumably be used to left and right.
        !            # Set imp = 0 since this shouldn't be needed in rpt3 in this case.

        !            # in the y-like direction
            call rpt3(ixyz,2,0,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
            q1d,q1d,aux1,aux2,aux3,cqxx,bmcqxxm,bpcqxxm)

        !            # in the z-like direction
            call rpt3(ixyz,3,0,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
            q1d,q1d,aux1,aux2,aux3,cqxx,cmcqxxm,cpcqxxm)

        !             # use the same splitting to left and right:
            forall (m = 1:num_eqn, i = 0:mx+2)
            bmcqxxp(m,i) = bmcqxxm(m,i)
            bpcqxxp(m,i) = bpcqxxm(m,i)
            cmcqxxp(m,i) = cmcqxxm(m,i)
            cpcqxxp(m,i) = cpcqxxm(m,i)
            end forall
        endif
    endif

!      --------------------------------------------
!      # modify G fluxes in the y-like direction
!      --------------------------------------------

!     # If the correction wave also propagates in a 3D sense, incorporate
!     # cpcqxx,... into cmamdq, cpamdq, ... so that it is split also.

    if(m4 == 1)then
        forall (m = 1:num_eqn, i = 0:mx+2)
        cpapdq2(m,i) = cpapdq(m,i)
        cpamdq2(m,i) = cpamdq(m,i)
        cmapdq2(m,i) = cmapdq(m,i)
        cmamdq2(m,i) = cmamdq(m,i)
        end forall
    else if(m4 == 2)then
        forall (m = 1:num_eqn, i = 0:mx+2)
        cpapdq2(m,i) = cpapdq(m,i) - 3.d0*cpcqxxp(m,i)
        cpamdq2(m,i) = cpamdq(m,i) + 3.d0*cpcqxxm(m,i)
        cmapdq2(m,i) = cmapdq(m,i) - 3.d0*cmcqxxp(m,i)
        cmamdq2(m,i) = cmamdq(m,i) + 3.d0*cmcqxxm(m,i)
        end forall
    endif

!     # The transverse flux differences in the z-direction are split
!     # into waves propagating in the y-direction. If m4 = 2,
!     # then the transverse propagating correction waves in the z-direction
!     # are also split. This yields terms of the form BCAu_{xzy} and
!     # BCAAu_{xxzy}.

    if( m4 > 0 )then
        call rptt3(ixyz,2,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,cpapdq2,bmcpapdq,bpcpapdq)
        call rptt3(ixyz,2,1,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,cpamdq2,bmcpamdq,bpcpamdq)
        call rptt3(ixyz,2,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,cmapdq2,bmcmapdq,bpcmapdq)
        call rptt3(ixyz,2,1,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,cmamdq2,bmcmamdq,bpcmamdq)
    endif

!     -----------------------------
!     # The updates for G fluxes :
!     -----------------------------

    do 180 i = 1, mx+1
        do 180 m=1,num_eqn
        
        !           # Transverse propagation of the increment waves
        !           # between cells sharing interfaces, i.e. the 2D approach.
        !           # Yields BAu_{xy}.
        
            gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
            - 0.5d0*dtdx1d(i-1)*bmamdq(m,i)
            gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
            - 0.5d0*dtdx1d(i-1)*bpamdq(m,i)
            gadd(m,1,0,i)   = gadd(m,1,0,i) &
            - 0.5d0*dtdx1d(i)*bmapdq(m,i)
            gadd(m,2,0,i)   = gadd(m,2,0,i) &
            - 0.5d0*dtdx1d(i)*bpapdq(m,i)
        
        !           # Transverse propagation of the increment wave (and the
        !           # correction wave if m4=2) between cells
        !           # only having a corner or edge in common. Yields terms of the
        !           # BCAu_{xzy} and BCAAu_{xxzy}.
        
            if( m4 > 0 )then
            

                gadd(m,2,0,i) = gadd(m,2,0,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                * (bpcpapdq(m,i) - bpcmapdq(m,i))
                gadd(m,1,0,i) = gadd(m,1,0,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                * (bmcpapdq(m,i) - bmcmapdq(m,i))


                gadd(m,2,1,i) = gadd(m,2,1,i) &
                - (1.d0/6.d0)*dtdx1d(i)*dtdz &
                * bpcpapdq(m,i)
                gadd(m,1,1,i) = gadd(m,1,1,i) &
                - (1.d0/6.d0)*dtdx1d(i)*dtdz &
                * bmcpapdq(m,i)
                gadd(m,2,-1,i) = gadd(m,2,-1,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                * bpcmapdq(m,i)
                gadd(m,1,-1,i) = gadd(m,1,-1,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdz &
                * bmcmapdq(m,i)
            
                gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                * (bpcpamdq(m,i) - bpcmamdq(m,i))
                gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                * (bmcpamdq(m,i) - bmcmamdq(m,i))


                gadd(m,2,1,i-1) = gadd(m,2,1,i-1) &
                - (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                * bpcpamdq(m,i)
                gadd(m,1,1,i-1) = gadd(m,1,1,i-1) &
                - (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                * bmcpamdq(m,i)
                gadd(m,2,-1,i-1) = gadd(m,2,-1,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                * bpcmamdq(m,i)
                gadd(m,1,-1,i-1) = gadd(m,1,-1,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdz &
                * bmcmamdq(m,i)
            
            endif
        
        !           # Transverse propagation of the correction wave between
        !           # cells sharing faces. This gives BAAu_{xxy}.
        
            if(m3 < 2) go to 180
            gadd(m,2,0,i)   = gadd(m,2,0,i) &
            + dtdx1d(i)*bpcqxxp(m,i)
            gadd(m,1,0,i)   = gadd(m,1,0,i) &
            + dtdx1d(i)*bmcqxxp(m,i)
            gadd(m,2,0,i-1) = gadd(m,2,0,i-1) &
            - dtdx1d(i-1)*bpcqxxm(m,i)
            gadd(m,1,0,i-1) = gadd(m,1,0,i-1) &
            - dtdx1d(i-1)*bmcqxxm(m,i)
        
    180 END DO


!      --------------------------------------------
!      # modify H fluxes in the z-like direction
!      --------------------------------------------

!     # If the correction wave also propagates in a 3D sense, incorporate
!     # cqxx into bmamdq, bpamdq, ... so that is is split also.

    if(m4 == 2)then
        forall (m = 1:num_eqn, i = 0:mx+2)
        bpapdq(m,i) = bpapdq(m,i) - 3.d0*bpcqxxp(m,i)
        bpamdq(m,i) = bpamdq(m,i) + 3.d0*bpcqxxm(m,i)
        bmapdq(m,i) = bmapdq(m,i) - 3.d0*bmcqxxp(m,i)
        bmamdq(m,i) = bmamdq(m,i) + 3.d0*bmcqxxm(m,i)
        end forall
    endif

!     # The transverse flux differences in the y-direction are split
!     # into waves propagating in the z-direction. If m4 = 2,
!     # then the transverse propagating correction waves in the y-direction
!     # are also split. This yields terms of the form BCAu_{xzy} and
!     # BCAAu_{xxzy}.

!     # note that the output to rptt3 below should logically be named
!     # cmbsasdq and cpbsasdq rather than bmcsasdq and bpcsasdq, but
!     # we are re-using the previous storage rather than requiring new arrays.

    if( m4 > 0 )then
        call rptt3(ixyz,3,2,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,bpapdq,bmcpapdq,bpcpapdq)
        call rptt3(ixyz,3,1,2,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,bpamdq,bmcpamdq,bpcpamdq)
        call rptt3(ixyz,3,2,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,bmapdq,bmcmapdq,bpcmapdq)
        call rptt3(ixyz,3,1,1,maxm,num_eqn,num_waves,num_aux,num_ghost,mx, &
        q1d,q1d,aux1,aux2,aux3,bmamdq,bmcmamdq,bpcmamdq)
    endif

!     -----------------------------
!     # The updates for H fluxes :
!     -----------------------------

    do 200 i = 1, mx+1
        do 200 m=1,num_eqn
        
        !           # Transverse propagation of the increment waves
        !           # between cells sharing interfaces, i.e. the 2D approach.
        !           # Yields CAu_{xy}.
        
            hadd(m,1,0,i-1) = hadd(m,1,0,i-1) &
            - 0.5d0*dtdx1d(i-1)*cmamdq(m,i)
            hadd(m,2,0,i-1) = hadd(m,2,0,i-1) &
            - 0.5d0*dtdx1d(i-1)*cpamdq(m,i)
            hadd(m,1,0,i)   = hadd(m,1,0,i) &
            - 0.5d0*dtdx1d(i)*cmapdq(m,i)
            hadd(m,2,0,i)   = hadd(m,2,0,i) &
            - 0.5d0*dtdx1d(i)*cpapdq(m,i)
        
        !           # Transverse propagation of the increment wave (and the
        !           # correction wave if m4=2) between cells
        !           # only having a corner or edge in common. Yields terms of the
        !           # CBAu_{xzy} and CBAAu_{xxzy}.
        
            if( m4 > 0 )then
            
                hadd(m,2,0,i)  = hadd(m,2,0,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                * (bpcpapdq(m,i) - bpcmapdq(m,i))
                hadd(m,1,0,i)  = hadd(m,1,0,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                * (bmcpapdq(m,i) - bmcmapdq(m,i))


                hadd(m,2,1,i)  = hadd(m,2,1,i) &
                - (1.d0/6.d0)*dtdx1d(i)*dtdy &
                * bpcpapdq(m,i)
                hadd(m,1,1,i)  = hadd(m,1,1,i) &
                - (1.d0/6.d0)*dtdx1d(i)*dtdy &
                * bmcpapdq(m,i)
                hadd(m,2,-1,i) = hadd(m,2,-1,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                * bpcmapdq(m,i)
                hadd(m,1,-1,i) = hadd(m,1,-1,i) &
                + (1.d0/6.d0)*dtdx1d(i)*dtdy &
                * bmcmapdq(m,i)
            
                hadd(m,2,0,i-1)  = hadd(m,2,0,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                * (bpcpamdq(m,i) - bpcmamdq(m,i))
                hadd(m,1,0,i-1)  = hadd(m,1,0,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                * (bmcpamdq(m,i) - bmcmamdq(m,i))


                hadd(m,2,1,i-1)  = hadd(m,2,1,i-1) &
                - (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                * bpcpamdq(m,i)
                hadd(m,1,1,i-1)  = hadd(m,1,1,i-1) &
                - (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                * bmcpamdq(m,i)
                hadd(m,2,-1,i-1) = hadd(m,2,-1,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                * bpcmamdq(m,i)
                hadd(m,1,-1,i-1) = hadd(m,1,-1,i-1) &
                + (1.d0/6.d0)*dtdx1d(i-1)*dtdy &
                * bmcmamdq(m,i)
            
            endif
        
        !           # Transverse propagation of the correction wave between
        !           # cells sharing faces. This gives CAAu_{xxy}.
        
            if(m3 < 2) go to 200
            hadd(m,2,0,i)   = hadd(m,2,0,i) &
            + dtdx1d(i)*cpcqxxp(m,i)
            hadd(m,1,0,i)   = hadd(m,1,0,i) &
            + dtdx1d(i)*cmcqxxp(m,i)
            hadd(m,2,0,i-1) = hadd(m,2,0,i-1) &
            - dtdx1d(i-1)*cpcqxxm(m,i)
            hadd(m,1,0,i-1) = hadd(m,1,0,i-1) &
            - dtdx1d(i-1)*cmcqxxm(m,i)
        
    200 END DO

    return
    end subroutine flux3

module bouss_module
    
    implicit none

    ! parameters set in setrun:
    integer :: boussEquations       ! Which equations? 0=SWE, 1=Madsen, 2=SGN
    real(kind=8) :: boussMinDepth   ! depth below which to switch to SWE

    integer :: bc_xlo, bc_xhi
    real(kind=8) :: B_param, alpha

    ! for higher-order derivatives:
    real(kind=8), allocatable, dimension(:) :: rinv, dxm, dxc, cm2r, cp2r, c02r
    real(kind=8), allocatable, dimension(:) :: cm2, cp2, c02, cm1, cp1, c01

    ! for initial water depth and switching to SWE:
    real(kind=8) :: hmin
    real(kind=8), allocatable, dimension(:) :: h0
    logical, allocatable, dimension(:) :: useBouss
    
    ! for tridiagonal solver:
    integer, allocatable, dimension(:) :: IPIV
    real(kind=8), allocatable, dimension(:) :: D, DL, DU, DU2    

    save


contains

!======================================================================

    subroutine set_bouss(mx,mbc,mthbc)
    
    ! Set things up for Boussinesq solver, in particular
    ! create and factor tridiagonal matrix for implicit solves.

    use geoclaw_module, only: earth_radius,deg2rad,coordinate_system,sea_level
    use grid_module, only: xcell, grid_type
    use topo_module, only: zcell
    
    implicit none
    integer, intent(in) :: mx, mbc, mthbc(2)
    real(kind=8) :: DLi, r, denom
    integer :: i, iunit
    character*25 fname
    real(kind=8), dimension(1-mbc:mx+mbc) :: h02, h03
    integer(kind=4) :: INFO

    iunit = 7
    fname = 'bouss.data'
 !  # open the unit with new routine from Clawpack 4.4 to skip over
 !  # comment lines starting with #:
    call opendatafile(iunit, fname)

    read(7,*) boussEquations  ! which equations
    read(7,*) boussMinDepth   ! depth below which to switch to SWE
    
    if (boussEquations==1) B_param = 1.d0/15.d0  ! parameter in MS equations
    if (boussEquations==2) alpha = 1.153  ! parameter in SGN equations
    
    allocate(rinv(0:mx+1),dxm(0:mx+2),dxc(0:mx+1))
    allocate(cm1(0:mx+1),cp1(0:mx+1),c01(0:mx+1))
    allocate(cm2(0:mx+1),cp2(0:mx+1),c02(0:mx+1))
    allocate(cm2r(0:mx+1),cp2r(0:mx+1),c02r(0:mx+1))
    allocate(D(mx+2), DL(mx+1), DU(mx+2), DU2(mx+2), IPIV(mx+2))
    allocate(h0(-1:mx+2), useBouss(-1:mx+2))


    ! Boundary conditions to impose in computing Boussinesq update:
    
    if ((mthbc(1)==2) .or. (mthbc(2)==2)) then
        write(6,*) '*** Periodic BCs not supported in bouss_module'
        stop
    endif

    ! Use Dirichlet BC with value 0 for correction in ghost cells by default:
    bc_xlo = 0
    bc_xhi = 0
    
    ! Check if wall BCs specified (also be used for radial symmetry at r=0):
    
    if (mthbc(1)==3) then
        ! For wall boundary conditions at left boundary:
        bc_xlo = 3
    endif

    if (mthbc(2)==3) then
        ! For wall boundary conditions at right boundary:
        bc_xhi = 3
    endif

    if (mthbc(1)==0) then
        ! For wavemaker BC at left
        bc_xlo = 3
    endif

    ! To try out Neumann BCs:
    ! This doesn't seem to work well, so not a general option
    !bc_xlo = 1
    !bc_xhi = 1
    
    
    !------------------------------------
    ! coefficients needed for second-order derivatives:

    do i=0,mx+2
        if (coordinate_system .eq. 2) then
            ! x is latitude, convert dx to meters:
            dxm(i) = (xcell(i) - xcell(i-1)) * earth_radius * deg2rad
        else
            ! x is meters
            dxm(i) = xcell(i) - xcell(i-1)
        endif
    enddo

    do i=0,mx+1
        if (grid_type == 0) then
            ! uniform grid
            dxc(i) = 2*dxm(i)
            cm2(i) = 1.d0/dxm(i)**2
            c02(i) = -2.d0/dxm(i)**2
            cp2(i) = 1.d0/dxm(i)**2
            ! first derivative coefficients:
            cm1(i) = -1.d0/dxc(i)
            c01(i) = 0.d0
            cp1(i) = 1.d0/dxc(i)
        else
            dxc(i) = (xcell(i+1) - xcell(i-1))  ! = 2*dx for uniform grid!
            cm2(i) = 2.d0 / (dxm(i)*dxc(i))
            cp2(i) = 2.d0 / (dxm(i+1)*dxc(i))
            c02(i) = -(cm2(i) + cp2(i))
            ! first derivative coefficients:
            denom = (dxm(i)*dxm(i+1)*(dxm(i)+dxm(i+1)))
            ! CORRECT??
            cm1(i) = -dxm(i+1)**2 / denom
            c01(i) = (dxm(i+1)**2 - dxm(i)**2) / denom
            cp1(i) = +dxm(i)**2 / denom
        endif
        
        if (coordinate_system == 1) then
            cm2r(i) = cm2(i)
            cp2r(i) = cp2(i)
            c02r(i) = c02(i)
            rinv(i) = 0.d0
        else if (coordinate_system == -1) then
            ! x = radial coordinate r >= 0
            ! include factors for ((1/r)*(r*q)_r)_r 
            ! using form q_{rr} + (1/r)q_r - (1/r**2)q
            r = xcell(i)
            rinv(i) = 1.d0/r
            cm2r(i) = cm2(i) - 1.d0/(r*dxc(i))
            cp2r(i) = cp2(i) + 1.d0/(r*dxc(i))
            c02r(i) = c02(i) - 1.d0/(r**2)
            ! first derivative coefficients for d/dr are unchanged 
            ! note: *not* including 1/r term in this derivative
        else if (coordinate_system == 2) then
            write(6,*) '*** latitude coordinates correctly implemented in Bouss??'
            stop
            
            ! PROBABLY NOT CORRECT -- r derivative??
            ! x = latitude coordinate -90 < x < 90 degrees
            ! r = sin(x) goes to zero at both poles
            ! include factors for ((1/r)*(r*q)_r)_r 
            ! using form q_{rr} + (1/r)q_r - (1/r**2)q
            r = sin(deg2rad*xcell(i))
            rinv(i) = 1.d0/r
            cm2r(i) = cm2(i) - 1.d0/(r*dxc(i))
            cp2r(i) = cp2(i) + 1.d0/(r*dxc(i))
            c02r(i) = c02(i) - 1.d0/(r**2)
            ! first derivative coefficients for d/dr are unchanged 
            ! note: *not* including 1/r term in this derivative        
        endif
    enddo

    ! initial depth and where to switch to SWE:
    
    do i=1-mbc,mx+mbc
        h0(i) = max(sea_level - zcell(i), 0.d0)
    enddo
    
    do i=2-mbc,mx+mbc-1
        hmin = min(h0(i-1), h0(i), h0(i+1))
        useBouss(i) = (hmin > boussMinDepth)
        !write(6,*) '+++ useBouss: ',i,xcell(i),h0(i),useBouss(i)
    enddo        
    !------------------------------------
    
    if (boussEquations==1) then
    
        ! Madsen-Sorensen
        ! Form tridiagonal matrix and factor
        ! Done once at start and then used in each time step
        ! (for SGN, we need to build in each time step)

        call build_tridiag_ms(mx,mbc,mthbc)

    endif

    end subroutine set_bouss

!======================================================================
! Routines for Madsen-Sorensen equations
!======================================================================

subroutine build_tridiag_ms(mx,mbc,mthbc)

    use geoclaw_module, only: sea_level, coordinate_system
    use grid_module, only: xcell, grid_type
    use topo_module, only: zcell
    
    implicit none
    integer, intent(in) :: mx, mbc, mthbc(2)
    
    integer :: i
    real(kind=8) :: DLi, r
    real(kind=8), dimension(1-mbc:mx+mbc) :: h02, h03
    integer(kind=4) :: INFO
    
    !h0 = sea_level - aux(1,:)  # resting depth

    do i=1-mbc,mx+mbc
        !h0(i) = sea_level - zcell(i) ! now set in set_bouss
  666   format(i3,3e16.6)
        h02(i)=(max(0.,h0(i)))**2
        h03(i)=(max(0.,h0(i)))**3
    enddo

    ! initialize to identity matrix:
    D = 1.d0
    DU= 0.d0
    DL= 0.d0
    
    ! First and last rows (rows 1 and mx+2) of matrix corresponds to BCs
    ! Row i+1 of matrix corresponds to equation for cell i

    do i=1,mx
    
        ! Modify row i+1 (equation for i'th grid cell) to form (I-d^2) operator,
        ! unless this is a cell where SWE are used, then leave as row of I
        ! and set RHS to 0, so no modification to SWE result.
        
        if ((h0(i) > boussMinDepth)) then
            
          ! Replace this row of identity matrix with dispersion terms
          ! Note that cm2r(i)*w(i-1) + c02r(i)*w(i) + cp2r(i)*w(i+1) gives
          ! approximation to d^2 w = w_{xx} in plane wave case, or
          !                  d^2 w = (1/r * (r*w)_r)_r  in radial case
          ! Also h02 is h0**2 and h03 is h0**3:

          D(i+1) = 1.d0 - c02r(i)*((B_param+.5d0)*h02(i) &
                - 1.d0/6.d0*h03(i)/h0(i))

          DU(i+1)= -cp2r(i)*((B_param+.5d0)*h02(i) &
                - 1.d0/6.d0*h03(i)/h0(i+1))

          DL(i)= -cm2r(i)*((B_param+.5d0)*h02(i) &
                - 1.d0/6.d0*h03(i)/h0(i-1))

        !else
        !  write(66,*) 'i, h0(i): ',i,h0(i)
        endif
        
    enddo

    ! left boundary
    ! No change ==> Dirichlet value 0 in ghost cell, Q_0 = 0
    ! For other BCs, change superdiagonal in row 1:

    if (bc_xlo==1) then
        ! for Neumann BC at left: impose Q_0 = Q_1
        DU(1) = -1.d0     
    endif
    if (bc_xlo==3) then
        ! for wall-reflecting BC at left: impose Q_0 = -Q_1
        DU(1) = 1.d0     
    endif


    ! right boundary
    ! No change ==> Dirichlet value 0 in ghost cell, Q_{mx+1} = 0
    ! For other BCs, change subdiagonal in row mx+2:

    if (bc_xhi==1) then
        ! for Neumann at right: impose Q_mx = Q_{mx+1}
        DL(mx+1) = -1.d0
    endif
    if (bc_xhi==3) then
        ! for wall at right: impose Q_mx = - Q_{mx+1}
        DL(mx+1) = 1.d0
    endif

    
    if (.false.) then
        ! DEBUG:
        write(66,*) 'D matrix:'
        do i=1,mx+2
            if (i>1) then
                DLi = DL(i-1)
            else
                DLi = -9999.  ! since no subdiag in first row
            endif
            write(66,661) DLi, D(i), DU(i)
  661       format(3e16.6)
        enddo
        write(66,*) '===== end of D'
    endif

    ! factor the tridiagonal matrix:    
    call DGTTRF( mx+2, DL, D, DU, DU2, IPIV, INFO )

    end subroutine build_tridiag_ms

!------------------------------------------------------------------

    subroutine solve_tridiag_ms(mx,meqn,mbc,dx,q,maux,aux,psi)

    ! Set up right hand side for tridagonal system and then solve it
    ! psi first holds RHS and then the solution to be passed back.
    
    ! Note that matrix has already been factored in set_bouss, so the
    ! arrays D, DL, DU, DU2, IPIV are already set up for the solver.
    
    use geoclaw_module, only: g => grav, sea_level, dry_tolerance
    use geoclaw_module, only: coordinate_system
    use grid_module, only: xcell

    implicit none

    integer, intent(in) :: mx,meqn,mbc,maux
    real(kind=8), intent(in) :: dx

    real(kind=8), intent(in) ::  q(meqn,1-mbc:mx+mbc)
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(out) :: psi(mx+2)

    real(kind=8)  depth
    real(kind=8), dimension(1-mbc:mx+mbc) :: h0, h02, h03, eta, hu2
    real(kind=8), dimension(1-mbc:mx+mbc) :: h_eta_x,h0_eta_x,s1,s1_h0
    real(kind=8)  h0_eta_xxx,s1_xx,s1_h0_xx
    integer :: i,j,k,kk,iL,iR
    integer(kind=4) :: INFO
    integer :: LDB

    h0 = sea_level - aux(1,:)

    do i=1-mbc,mx+mbc
        ! compute hu2 = h*u**2
        if (q(1,i).gt.dry_tolerance) then
            hu2(i)= q(2,i)**2/q(1,i)
        else
            hu2(i)= 0.d0
        endif
        
        !hu2(i) = 0.d0  ! Debug: turning off nonlinear terms
        
        ! h0 is resting depth, h02 = h0**2 and h03 = h0**3:
        eta(i)= q(1,i) - h0(i)
        h02(i)=(max(0.d0,h0(i)))**2
        h03(i)=(max(0.d0,h0(i)))**3
        
    enddo

    ! compute these quantities, extending to one set of ghost cells:
    ! h_eta_x  = h * eta_x
    ! h0_eta_x = h0 * eta_x
    
    ! defaults to 0 if h0==0 at one of the stencil points:
    h_eta_x = 0.d0
    h0_eta_x = 0.d0
        
    do i= 0,mx+1
        if (minval(h0(i-1:i+1)) > 0.d0) then
            ! if h0 > 0 at all stencil points.  Note dxc(i) = 2*dx if uniform:
            h_eta_x(i)= q(1,i)*(eta(i+1)-eta(i-1))/dxc(i)
            h0_eta_x(i)= h0(i)*(eta(i+1)-eta(i-1))/dxc(i)
        endif
    enddo
     

    
    do i=0,mx+1
    
        ! compute approximation to
        !   s1 = (h*u**2)_x + g*h*eta_x   (plane wave) or
        !   s1 = (1/r)*(r*h*u**2)_r + r*g*h*eta_r   (radial)
        !      = (h*u**2)_r + (1/r)*h*u**2 + r*g*h*eta_r
    
        s1(i) =  (hu2(i+1) - hu2(i-1)) / dxc(i) + g*h_eta_x(i)
        !s1(i) =  g*h_eta_x(i)  ! debug
        !s1(i) =  (hu2(i+1) - hu2(i-1)) / dxc(i) 
                 
        if (coordinate_system == -1) then
            ! radial: add term for (1/r)*h*u**2:
            s1(i) =  s1(i) + hu2(i) / xcell(i) 
        else if (coordinate_system == 2) then
            ! latitude
            write(6,*) '*** latitude not yet implemented in bouss_module'
            stop
        endif
        
        ! compute s1_h0 = s1 / h0:
        
        if (h0(i) > dry_tolerance) then
            s1_h0(i)=s1(i)/h0(i)
        else
            s1_h0(i)=0.d0
        endif
    enddo
     

    ! Compute right hand side psi:
    
    psi = 0.d0

    do i=1,mx

       k = i+1  ! i'th equation corresponds to row k=i+1 of RHS

       if (h0(i) <= boussMinDepth) then
            ! no dispersive term:
            psi(k) = 0.d0

        else
            ! Note that cm2r(i)*w(i-1) + c02r(i)*w(i) + cp2r(i)*w(i+1) gives
            ! approximation to d^2 w = w_{xx} 
            ! or in radial case to d^2 w = (1/r * (rw)_r)_r

            ! compute s1_xx, approximates d^2 s1:

            s1_xx = cp2r(i)*s1(i+1) + c02r(i)*s1(i) + cm2r(i)*s1(i-1)

            ! compute s1_h0_xx, approximates d^2 s1_h0 = d^2(s1 / h0):
            
            s1_h0_xx = cp2r(i)*s1_h0(i+1) + c02r(i)*s1_h0(i) + cm2r(i)*s1_h0(i-1)
        
            ! compute h0_eta_xxx, approximates d^2 h0_eta_x:
            
            h0_eta_xxx = cp2r(i)*h0_eta_x(i+1) + c02r(i)*h0_eta_x(i) + &
                    cm2r(i)*h0_eta_x(i-1)
                    

            ! Right-hand side:
            
            psi(k) = -(B_param+.5d0) * h02(i) * s1_xx &
                        + h03(i)/6.d0 * s1_h0_xx &
                        + B_param * g * h02(i) * h0_eta_xxx
            if (.false.) then
                write(66,*) '+++i,rhs(i+1): ',i, psi(k)
                write(66,*) (B_param+.5d0) * h02(i), s1_xx
                write(66,*) h03(i)/6.d0,  s1_h0_xx 
                write(66,*) B_param * g * h02(i) * h0_eta_xxx
                write(66,*) B_param,  g,  h02(i),  h0_eta_xxx
                write(66,*) s1(i)
                write(66,*) h0_eta_x(i)
                write(66,*) eta(i)
            endif
              
                               
        endif


        ! OLD NOTATION, NOT USED NOW:
        !if ((h0(i) > sw_depth0) .and. (h0(i) < sw_depth1)) then
        !    ! reduce psi linearly between sw_depth0 and sw_depth1:
        !    psi(k) = psi(k) * (h0(i)-sw_depth0)/(sw_depth1-sw_depth0)
        !endif
            
    enddo
    
    if (.false.) then
        write(66,*) 'RHS:'
        do i=1,mx+2
            write(66,*) '+++i,rhs: ',i, psi(i)
        enddo
    endif
    
    ! -------------------------
    ! solve tridiagonal system.  
    ! psi is RHS on entry, solution on exit:
    
    LDB = mx+2  ! leading dimension of right-hand side matrix psi
    
    call DGTTRS( 'N', mx+2, 1, DL, D, DU, DU2, IPIV, psi, LDB, INFO )
                                
    if (.false.) then
        write(66,*) 'Solution psi: '
        do i=1,mx+2
            write(66,*) '+++ i,psi: ',i,psi(i)
        enddo
    endif

    return
end subroutine solve_tridiag_ms



!======================================================================
! Routines for SGN equations
!======================================================================

subroutine build_tridiag_sgn(meqn,mbc,mx,xlower,dx,q,maux,aux)

    use geoclaw_module, only: sea_level, coordinate_system
    use grid_module, only: xcell, grid_type
    use topo_module, only: zcell
    
    implicit none
    integer, intent(in) :: mbc,mx,meqn,maux
    real(kind=8), intent(in) :: xlower,dx
    real(kind=8), intent(in) ::  aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(inout) ::  q(meqn,1-mbc:mx+mbc)
    
    ! Locals
    integer :: i
    real(kind=8) :: DLi, r, Brr, denom, hmin
    real(kind=8), dimension(1-mbc:mx+mbc) :: h, B, Br, hr
    real(kind=8), dimension(1-mbc:mx+mbc) :: etar, eta, phi, w

    integer(kind=4) :: INFO

    do i=1-mbc,mx+mbc
        h(i) = q(1,i)  ! depth
        B(i) = aux(1,i)  ! topo
        eta(i) = B(i) + h(i)
    enddo
    
    ! reset useBouss(:) if it should be based on h rather than h0 or slope, etc:
    if (.false.) then
        do i=2-mbc,mx+mbc-1
            hmin = min(h(i-1), h(i), h(i+1))
            useBouss(i) = (h(i) > boussMinDepth)
        enddo
    endif
    
    do i=2-mbc,mx+mbc-1
        Br(i) = cm1(i)*B(i-1) + c01(i)*B(i) + cp1(i)*B(i+1)
        hr(i) = cm1(i)*h(i-1) + c01(i)*h(i) + cp1(i)*h(i+1)
        etar(i) = cm1(i)*eta(i-1) + c01(i)*eta(i) + cp1(i)*eta(i+1)
    enddo

    ! initialize to identity matrix:
    D = 1.d0
    DU= 0.d0
    DL= 0.d0
    
    ! First and last rows (rows 1 and mx+2) of matrix corresponds to BCs
    ! Row i+1 of matrix corresponds to equation for cell i

    do i=1,mx
    
        ! Modify row i+1 (equation for i'th grid cell) to form (I-d^2) operator,
        ! unless this is a cell where SWE are used, then leave as row of I
        ! and set RHS to 0, so no modification to SWE result.
        
        !if ((h(i) > boussMinDepth)) then
        if (useBouss(i)) then
            
          ! Replace this row of identity matrix with dispersion terms
          ! Note that cm2r(i)*w(i-1) + c02r(i)*w(i) + cp2r(i)*w(i+1) gives
          ! approximation to d^2 w = w_{xx} in plane wave case, or
          !                  d^2 w = (1/r * (r*w)_r)_r  in radial case
          ! while cm2, c02, cp2 are coefficients for pure second derivative
          ! even in radial case.
          
          Brr = cm2(i)*B(i-1) + c02(i)*B(i) + cp2(i)*B(i+1)
          
          D(i+1) = 1.d0 + alpha*(-h(i)**2/3.d0 *c02r(i) &
                    -h(i)*hr(i)*(c01(i) + rinv(i)) &
                    + 0.5d0*h(i)*(Brr - rinv(i)*Br(i)) + etar(i)*Br(i)) !CORRECT??
          
          DU(i+1) = alpha*(-h(i)**2/3.d0 *cp2r(i) - h(i)*hr(i)*cp1(i))

          DL(i) = alpha*(-h(i)**2/3.d0 *cm2r(i) - h(i)*hr(i)*cm1(i))
        endif
    enddo

    ! left boundary
    ! No change ==> Dirichlet value 0 in ghost cell, Q_0 = 0
    ! For other BCs, change superdiagonal in row 1:

    if (bc_xlo==1) then
        ! for Neumann BC at left: impose Q_0 = Q_1
        DU(1) = -1.d0     
    endif
    if (bc_xlo==3) then
        ! for wall-reflecting BC at left: impose Q_0 = -Q_1
        DU(1) = 1.d0     
    endif


    ! right boundary
    ! No change ==> Dirichlet value 0 in ghost cell, Q_{mx+1} = 0
    ! For other BCs, change subdiagonal in row mx+2:

    if (bc_xhi==1) then
        ! for Neumann at right: impose Q_mx = Q_{mx+1}
        DL(mx+1) = -1.d0
    endif
    if (bc_xhi==3) then
        ! for wall at right: impose Q_mx = - Q_{mx+1}
        DL(mx+1) = 1.d0
    endif

    
    if (.false.) then
        ! DEBUG:
        write(66,*) 'D matrix:'
        do i=1,mx+2
            if (i>1) then
                DLi = DL(i-1)
            else
                DLi = -9999.  ! since no subdiag in first row
            endif
            write(66,661) DLi, D(i), DU(i)
  661       format(3e16.6)
        enddo
        write(66,*) '===== end of D'
    endif

    ! factor the tridiagonal matrix:    
    call DGTTRF( mx+2, DL, D, DU, DU2, IPIV, INFO )

    end subroutine build_tridiag_sgn

!------------------------------------------------------------------    

    subroutine solve_tridiag_sgn(mx,meqn,mbc,dx,q,maux,aux,psi)

    ! For the SGN equations
    
    ! Set up right hand side for tridagonal system and then solve it
    ! psi first holds RHS and then the solution to be passed back.
    
    ! Note that matrix has already been factored in src1, so the
    ! arrays D, DL, DU, DU2, IPIV are already set up for the solver.
    
    use geoclaw_module, only: g => grav, sea_level, dry_tolerance
    use geoclaw_module, only: coordinate_system
    use grid_module, only: xcell

    implicit none

    integer, intent(in) :: mx,meqn,mbc,maux
    real(kind=8), intent(in) :: dx

    real(kind=8), intent(in) ::  q(meqn,1-mbc:mx+mbc)
    real(kind=8), intent(in) :: aux(maux,1-mbc:mx+mbc)
    real(kind=8), intent(out) :: psi(mx+2)

    real(kind=8), dimension(1-mbc:mx+mbc) :: h, eta, u, B, phi, w
    real(kind=8) :: Br, hr, etar, Brr, wr, phir, ur
    integer :: i,j,k,kk,iL,iR
    integer(kind=4) :: INFO
    integer :: LDB

    h = q(1,:) ! depth

    do i=1-mbc,mx+mbc
        if (q(1,i).gt.dry_tolerance) then
            u(i)= q(2,i)/q(1,i)
        else
            u(i)= 0.d0
        endif            

        B(i) = aux(1,i)  ! topo
        eta(i) = B(i) + h(i)
    enddo

        
    do i=0,mx+1
        Brr = cm2(i)*B(i-1) + c02(i)*B(i) + cp2(i)*B(i+1)  ! pure 2nd deriv
        w(i) = u(i)**2 * Brr
        ur = cm1(i)*u(i-1) + c01(i)*u(i) + cp1(i)*u(i+1)
        phi(i) = ur**2 + rinv(i)*ur*u(i) + (rinv(i)*ur)**2  ! CORRECT??
    enddo        
    

    ! Compute right hand side psi:
    
    psi = 0.d0

    do i=1,mx

       k = i+1  ! i'th equation corresponds to row k=i+1 of RHS

       !if (h(i) <= boussMinDepth) then
       if (.not. useBouss(i)) then
            ! no dispersive term:
            psi(k) = 0.d0

        else
            Br = cm1(i)*B(i-1) + c01(i)*B(i) + cp1(i)*B(i+1)   ! pure 1st deriv
            hr = cm1(i)*h(i-1) + c01(i)*h(i) + cp1(i)*h(i+1)
            etar = cm1(i)*eta(i-1) + c01(i)*eta(i) + cp1(i)*eta(i+1)
            wr = cm1(i)*w(i-1) + c01(i)*w(i) + cp1(i)*w(i+1)
            phir = cm1(i)*phi(i-1) + c01(i)*phi(i) + cp1(i)*phi(i+1)
                    

            ! Right-hand side:
            
            psi(k) = g/alpha * etar &
                    + 2*h(i)*(h(i)/3.d0 * phir + phi(i)*(hr + 0.5d0*Br)) &
                    + 0.5d0*h(i)*wr + w(i)*etar
            
            if (.false.) then
                write(66,*) '+++i,rhs(i+1): ',i, psi(k)
            endif                       
        endif


        ! OLD NOTATION, NOT USED NOW:
        !if ((h(i) > sw_depth0) .and. (h(i) < sw_depth1)) then
        !    ! reduce psi linearly between sw_depth0 and sw_depth1:
        !    psi(k) = psi(k) * (h(i)-sw_depth0)/(sw_depth1-sw_depth0)
        !endif

    enddo
    
    if (.false.) then
        write(66,*) 'RHS:'
        do i=1,mx+2
            write(66,*) '+++i,rhs: ',i, psi(i)
        enddo
    endif
    
    ! -------------------------
    ! solve tridiagonal system.  
    ! psi is RHS on entry, solution on exit:
    
    LDB = mx+2  ! leading dimension of right-hand side matrix psi
    
    call DGTTRS( 'N', mx+2, 1, DL, D, DU, DU2, IPIV, psi, LDB, INFO )
                                
    if (.false.) then
        write(66,*) 'Solution psi: '
        do i=1,mx+2
            write(66,*) '+++ i,psi: ',i,psi(i)
        enddo
    endif

    return
end subroutine solve_tridiag_sgn


end module bouss_module

c  ::::::::::::::::::::::: PROJEC2 ::::::::::::::::::::::::::::::
! For all newly created fine grids, project area onto a coarser
! grid 2 levels down. Used to recreate grids 1 level down, and
! insure proper level nesting.
! create 
!
! on entry, all coarse grids have already had error estimated, so
! add bad flags.   count number of 'added' flags only.
!
!
!> This subroutine projects all level **level**+2 grids
!! to a level **level** grid and flag the cells being projected as
!! needing refine.
!! In other words, the subroutine modify the flag array of the input
!! grid if part of it is under any grid that is two levels finer.
!!
!! This subroutine is to insure proper level nesting. For example, you
!! just create new level 5 grids. Now you need to ensure that the new
!! level 4 grids encompass the new level 5 grids. To do this, we project
!! level 5 grids to level 3 grids, which means that all locations in 
!! level 3 where level 5 exists are flagged. In this example, level
!! 3 is the **level** parameter on the arguments list of this subroutine.
!! So this subroutine is actually used to ensure **level**+1 grids can
!! encompasses **level**+2 grids.
!!
!! However, note that these cells are flagged with **badpro** parameter
!! defined in [amr_module](@ref amr_module.f90)
!! (not **DOFLAG** as in [flagregions()](@ref flagregions2.f90) and
!! [flag2refine2()](@ref flag2refine2.f90)).
!!
!! **input**: 
!! * **level** 
!! * flag array of the input grid (**rectflags**)
!!
!! **output**: 
!! * **numpro**
!! * flag array of the input grid (**rectflags**)
!!       
!! \param level AMR level of the grid which all fine subgrids are
!! projected onto
!! \param numpro number of additional flagged cells at level **level**
!!               (initialized to 0 in flglvl)
!! \param rectflags array to be flagged 
!! \param ilo global *i* index of the left border of the grid being projected to (being flagged) 
!! \param ihi global *i* index of the right border of the grid being projected to (being flagged) 
!! \param jlo global *j* index of the lower border of the grid being projected to (being flagged) 
!! \param jhi global *i* index of the upper border of the grid being projected to (being flagged) 
!! \param mbuff width of the buffer zone
c  :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      subroutine projec2(level,numpro,rectflags,ilo,ihi,jlo,jhi,mbuff)

      use amr_module
      implicit double precision (a-h,o-z)
      dimension rectflags(ilo-mbuff:ihi+mbuff,jlo-mbuff:jhi+mbuff)
      logical borderx, bordery
      integer ist(3),iend(3),jst(3),jend(3),ishift(3),jshift(3)

      levpro  =  level + 2
      lrat2x  = intratx(level)*intratx(level+1)
      lrat2y  = intraty(level)*intraty(level+1)

! local variables:
!     mkid    = grid doing the projecting
      mkid = newstl(levpro)
 10   if (mkid .eq. 0) go to 90
       ikidlo = node(ndilo,mkid) 
       jkidlo = node(ndjlo,mkid)
       ikidhi = node(ndihi,mkid)
       jkidhi = node(ndjhi,mkid)
c
c  project entire region of fine grids onto rectflag array if intersects
c  possibly take care of buffering.
c  adjust since grid descriptor (integer indices)  is 0 based, 
c  do not projec the buffer region, only interior needs it
c  since buffering will take care of rest (unless ibuff=0-see below)
c
c redo formulas using approach of nestck/baseCheck, simplified to 2 levels
      istc  = ikidlo/intratx(level+1) - 1    ! one level down
      istc  = istc/intratx(level)      - 1    ! project to second level coords
      jstc  = jkidlo/intraty(level+1) - 1
      jstc  = jstc/intraty(level)      - 1
      iendc = ikidhi/intratx(level+1) + 1  
      iendc = iendc/intratx(level)     + 1  
      jendc = jkidhi/intraty(level+1) + 1  
      jendc = jendc/intraty(level)     + 1  

c   if coarse grid not near edge of domain then periodicity wont affect it
      borderx = (istc .le. 0 .or. iendc .ge. iregsz(level)-1)  ! subtract 1 to get last cell index
      bordery = (jstc .le. 0 .or. jendc .ge. jregsz(level)-1)  ! since i/jregsz is num cells

c
c  take care of indices outside actual domain, in non-periodic case first
      if (.not. (xperdom .and. borderx) .and.
     .    .not. (yperdom .and. bordery)) then
         istc  = max(istc,0)
         jstc  = max(jstc,0)
         iendc = min(iendc,iregsz(level))
         jendc = min(jendc,jregsz(level))
         
c  include mbuff in intersection test here since is ok in new alg. to project to buffer region
         ixlo = max(istc, ilo-mbuff)
         ixhi = min(iendc,ihi+mbuff)
         jxlo = max(jstc, jlo-mbuff)
         jxhi = min(jendc,jhi+mbuff)

c        test if coarsened grid mkid intersects with this grids rectflags 
         ! has not intersection
         if (.not.((ixlo .le. ixhi) .and. (jxlo .le. jxhi))) go to 80 
c     
         ! has intersection
         do j = jxlo, jxhi
         do i = ixlo, ixhi
            if (rectflags(i,j) .le. DONTFLAG) then
               rectflags(i,j) = badpro
               numpro      = numpro + 1
               if (pprint) write(outunit,101) i,j,mkid
 101           format(' pt.',2i5,' of grid ',i5,' projected' )
            endif
         end do  
         end do  
         go to 80            ! done with projected this fine grid in non-periodic case
      endif

c
c periodic case. compute indics on coarsened level to find grids to project to
      call setIndices(ist,iend,jst,jend,iclo,ichi,jclo,jhci,
     .                ishift,jshift,level)

c     compare all regions of coarsened patch with one lbase grid at a time
      do 26 i = 1, 3
         i1 = max(istc,  ist(i))
         i2 = min(iendc, iend(i))
      do 25 j = 1, 3
         j1 = max(jstc,  jst(j))
         j2 = min(jendc, jend(j))

         if (.not. ((i1 .le. i2) .and. (j1 .le. j2))) go to 25
c
c        patch (possibly periodically wrapped) not empty.
c        see if intersects base grid. wrap coords for periodicity
         i1 = i1 + ishift(i)
         i2 = i2 + ishift(i)
         j1 = j1 + jshift(j)
         j2 = j2 + jshift(j)

         ixlo = max(i1,ilo-mbuff)
         ixhi = min(i2,ihi+mbuff)
         jxlo = max(j1,jlo-mbuff)
         jxhi = min(j2,jhi+mbuff)

         if (.not.((ixlo.le.ixhi) .and. (jxlo.le.jxhi))) go to 25

         do jx = jxlo, jxhi
         do ix = ixlo, ixhi
c           project flagged point in intersected regions
            if (rectflags(ix,jx) .le. DONTFLAG) then
               rectflags(ix,jx) = badpro   ! i,j already coarse grid indices
               numpro      = numpro + 1
               if (pprint) write(outunit,101) ix,jx,mkid
            endif
         end do
         end do

 25   continue
 26   continue
      go to 80   ! down with simple periodic case
c
c repeat above procedure for wrapped area if nec. if ibuff > 0
c this will be caught in shiftset flagging
c  DID NOT MODIFY THIS SPHEREDOM BLOCK WHEN FIXING OTHER BUGS. NEED TO LOOK AT IT
       if (spheredom .and. ibuff .eq. 0) then 
          jstc  = jkidlo/lrat2y
          jendc = jkidhi/lrat2y
          if (jstc .eq. 0) then
             iwrap1 = iregsz(level) - iendc - 1
             iwrap2 = iregsz(level) - istc - 1
c             do 61 i = iwrap1+1, iwrap2+1
             do 61 i = iwrap1, iwrap2  !changing this WITHOUT CHECKING, AS ABOVE. STILL NEED TO CHECK***
                if (rectflags(i,1) .le. DONTFLAG) then
                  rectflags(i,1) = badpro  ! only need to flag 1 wrapped buffer cell
                  numpro      = numpro + 1
                  if (pprint) write(outunit,101) i,1,mkid
                endif
 61          continue
             
          endif
          if (jendc .eq. jsize-1) then
             iwrap1 = iregsz(level) - iendc - 1
             iwrap2 = iregsz(level) - istc - 1
c             do 62 i = iwrap1+1, iwrap2+1
             do 62 i = iwrap1, iwrap2 !CHANGING W/O CHECKING 
                if (rectflags(i,jsize-1) .le. DONTFLAG) then
                  rectflags(i,jsize-1) = badpro  ! only need to flag 1 wrapped buffer cell
                  numpro            = numpro + 1
                  if (pprint) write(outunit,101) i,j,mkid
                endif
 62          continue
          endif
       endif
c
c  done with gridpt. loop for grid mkid.
c
 80     mkid = node(levelptr, mkid)
        go to 10
c
 90   if (pprint) then
         write(outunit,102) numpro,level
 102     format(i9,' more pts. projected to level ',i5)

         write(outunit,103) level
 103     format(/,'  from projec: flagged pts. (incl. buffer zone)',
     &           ' at level ',i4,':')

         do 110 j = jhi+mbuff, jlo-mbuff, -1
           write(outunit,104)(int(rectflags(i,j)),i=ilo-mbuff,ihi+mbuff)
104        format(80i1)
 110     continue
      endif
c
 99   return
      end

c
c ---------------------------------------------------------
c
      subroutine grdfit (lbase,lcheck,nvar,naux,cut,time,
     1                   start_time)
c
      use amr_module
      implicit double precision (a-h,o-z)
      integer clock_start, clock_finish, clock_rate
      integer clock_start1
c
      dimension  corner(nsize,maxcl)
      integer    numptc(maxcl), prvptr
      logical    cout
      logical    fit1, nestck1
      data       cout/.false./
c
c ::::::::::::::::::::: GRDFIT :::::::::::::::::::::::::::::::::;
c  grdfit called by setgrd and regrid to actually fit the new grids
c         on each level. lcheck is the level being error estimated
c         so that lcheck+1 will be the level of the new grids.
c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;
c

      call system_clock(clock_start,clock_rate)


c ### initialize region start and end indices for new level grids
      iregst(lcheck+1) = iinfinity
      iregend(lcheck+1) = -1

c     ## flag all grids at given level based on error ests.
c     ## npts is number of points actually colated - some
c     ## flagged points turned off due to proper nesting requirement.
c     ## (storage based on nptmax calculation however).

      call system_clock(clock_start1,clock_rate)
      call flglvl1(nvar,naux,lcheck,nptmax,index,lbase,npts,start_time)
      call system_clock(clock_finish,clock_rate)
      timeFlglvl = timeFlglvl + clock_finish - clock_start1

      if (npts .eq. 0) go to 99
c
      levnew    = lcheck + 1
      hxfine    = hxposs(levnew)
c
c     ## call smart_bisect grid gen. to make the clusters
c        till each cluster ok. needs scratch space.
c
       idim = iregsz(lcheck)
c       lociscr = igetsp(idim+jdim)

       call smartbis(alloc(index),npts,cut,numptc,nclust,lbase,
     2               corner,idim)
c     2               corner,alloc(lociscr),alloc(locjscr),idim,jdim)
c       call reclam(lociscr,idim+jdim)

       if (gprint) then
          write(outunit,103) nclust
          write(outunit,104) (icl, numptc(icl),icl=1,nclust)
 103      format(' ',i4,' clusters after bisect')
 104      format('         cluster ',i5,' has points: ',i8)
       endif
c
c     ##  for each cluster, fit the actual grid, set up some data structures
c
 50   ibase   =  0
      icl     =  1
      prvptr  =  null
c
 70   mnew      = nodget()
c       if (lcheck .eq. 2 .and. (mnew .ne. 6 .and. mnew .ne. 7)) go to 69 
c       if (lcheck .eq. 1 .and. (mnew .ne. 3 .and. mnew .ne. 2 )) go to 69 
 75   call  moment(node(1,mnew),alloc(index+1*ibase),numptc(icl),usage)

      if (gprint) write(outunit,100) icl,mnew,usage,numptc(icl)
100   format('         cluster ',i5,' new rect.',i5,
     1       ' usage ',e12.5,' with ',i5,' pts.')

      node(ndilo,mnew) = node(ndilo,mnew)*intratx(lcheck)
      node(ndihi,mnew) = (node(ndihi,mnew)+1)*intratx(lcheck) - 1
      rnode(cornxlo,mnew)  = node(ndilo,mnew)*hxfine + xlower
      rnode(cornxhi,mnew)  = (node(ndihi,mnew)+1)*hxfine + xlower
      node(nestlevel,mnew)     = levnew
      rnode(timemult,mnew)   = time

      if (gprint) write(outunit,101) (node(i,mnew),i=1,nsize),
     &                              (rnode(i,mnew),i=1,rsize)
 101  format(4i5,4i15,/,2i15,5i15,/,2i15,/,3e15.7)
c
c     ##  if new grid doesn't fit in base grid, nestck bisect it
c     ##  and returns 2 clusters where there used to be 1.
c
c 2/28/02 : Added naux to argument list; needed by call to outtre in nestck

      fit1= nestck1(mnew,lbase,alloc(index+ibase),numptc(icl),numptc,
     1             icl,nclust,nvar, naux)
      if (.not. fit1) go to 75
c
c     ##  grid accepted. put in list.
      if (newstl(levnew) .eq. null) then
          newstl(levnew)  = mnew
      else
          node(levelptr,prvptr) = mnew
      endif
      prvptr = mnew
c     # keep track of min and max location of grids at this level
      iregst(levnew)  = MIN(iregst(levnew), node(ndilo,mnew))
      iregend(levnew) = MAX(iregend(levnew),node(ndihi,mnew))

c     ##  on to next cluster
 69     ibase  = ibase + numptc(icl)
      icl = icl + 1
      if (icl .le. nclust) go to 70
c
c    ##  clean up. for all grids check final size.
      call birect(newstl(levnew))

 99   continue
c    ## may have npts 0 but array was allocated due to initially flagged points
c    ## that were not allowed for proper nesting or other reasons. in this case
c    ## the array was still allocated, so need to test further to see if colating
c    ## array space needs to be reclaimed
      if (nptmax .gt. 0) call reclam(index, nptmax)
c
      call system_clock(clock_finish,clock_rate)
      timeGrdfitAll = timeGrdfitAll + clock_finish - clock_start

      return
      end

subroutine setprob

    implicit none
    character*25 :: fname
    integer :: iunit
    real(kind=8) :: u,beta

    common /cparam/ u
    common /cqinit/ beta
 
    ! Set the material parameters for the acoustic equations
    ! Passed to the Riemann solver rp1.f in a common block
 
    iunit = 7
    fname = 'setprob.data'
    ! open the unit with new routine from Clawpack 4.4 to skip over
    ! comment lines starting with #:
    call opendatafile(iunit, fname)


    ! advection velocity:
    read(7,*) u

    ! beta for initial conditions:
    read(7,*) beta

end subroutine setprob

! =====================================================
subroutine rpt2(ixy,imp,maxm,meqn,mwaves,maux,mbc,mx,ql,qr, &
                aux1,aux2,aux3,asdq,bmasdq,bpasdq)
! =====================================================


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!                                                                           !
!      # This Riemann solver is for the shallow water adjoint               !
!             equations. It is similar to rpt2_vc_acoustics.f90
!
!      # See rpn2_geoclaw_adjoint_qwave.f90 for the equations and discussion!
!                                                                           !
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!     # Split asdq into down-going flux bmasdq and up-going flux bpasdq.
!     # imp=1  means  asdq=amdq,    imp=2 means asdq=apdq

    use geoclaw_module, only: g => grav, drytol => dry_tolerance
    use geoclaw_module, only: coordinate_system,earth_radius,deg2rad

    implicit none

    integer, intent(in) :: ixy,imp,maxm,meqn,mwaves,maux,mbc,mx
    real(kind=8), intent(in) ::    ql(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) ::    qr(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) ::    asdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) ::   aux1(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) ::   aux2(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(in) ::   aux3(maux, 1-mbc:maxm+mbc)
    real(kind=8), intent(out) :: bmasdq(meqn, 1-mbc:maxm+mbc)
    real(kind=8), intent(out) :: bpasdq(meqn, 1-mbc:maxm+mbc)

!   local:
    integer :: i,mu,mv,i1
    real(kind=8) :: h0D,h00,h0U,bD,b0,bU,c0,cU,cD,a1,a2,dxdcU,dxdcD,s1,s2

!   # initialize for dry state cells:
    bmasdq = 0.d0
    bpasdq = 0.d0
    
    if (ixy == 1) then
        mu = 2
        mv = 3
    else
        mu = 3
        mv = 2
    endif

    do i = 2-mbc, mx+mbc

         if (maxval(abs(asdq(:,i))) == 0.d0) then
            cycle  ! go to next i
            endif
    
!        # imp is used to flag whether wave is going to left or right,
!        # since material properties are different on the two sides
    
        if (imp == 1) then
!            # asdq = amdq, moving to left
            i1 = i-1
        else
!            # asdq = apdq, moving to right
            i1 = i
        endif
        
    
!       # The flux difference asdq is split into downward moving part
!       # traveling at speed -cD relative to the medium below and
!       # an upward moving part traveling
!       # at speed +cU relative to the medium above.
   
!       # Note that the sum of these parts does not give all of asdq
!       # since there is also reflection at the interfaces which decreases
!       # the flux.
    
!       # gravity wave speed in each row of cells:

        ! background depth based on topography:
        bD = aux1(1,i1)
        b0 = aux2(1,i1)
        bU = aux3(1,i1)
        h0U = max(-bU, 0.d0)
        h00 = max(-b0, 0.d0)
        h0D = max(-bD, 0.d0)
        cD = sqrt(g*h0D)
        c0 = sqrt(g*h00)
        cU = sqrt(g*h0U)

        if (h00 < drytol) then
            cycle  ! no waves in this cell
            endif

!       # transmitted part of down-going wave:
        if (h0D < drytol) then
            a1 = 0.d0  ! no transmitted wave
        else
            a1 = (asdq(1,i) + asdq(mv,i)*c0) / (c0 + cD)
        endif

!       # transmitted part of up-going wave:
        if (h0U < drytol) then
            a2 = 0.d0  ! no transmitted wave
        else
            a2 = (-asdq(1,i) + asdq(mv,i)*c0) / (c0 + cU)
        endif
        
        !====== Adjust for mapping from latitude longitude to physical space====
        if (coordinate_system.eq.2) then
           if (ixy.eq.2) then
               dxdcU=(earth_radius*deg2rad)
               dxdcD = dxdcU
           else
               dxdcU = earth_radius*cos(aux3(3,i1))*deg2rad
               dxdcD = earth_radius*cos(aux1(3,i1))*deg2rad
           endif
        else
            dxdcU = 1.d0
            dxdcD = 1.d0
        endif

    
!       # The down-going flux difference bmasdq is the product  -cD * wave1
!       # down-going eigenvector of -A(x)^T is r1 = [cD, 1]^T
    
        s1 = -cD * dxdcD  ! adjusted down-going wave speed
        bmasdq(1,i) = s1 * a1*cD
        bmasdq(mu,i) = 0.d0
        bmasdq(mv,i) = s1 * a1
    
!       # The up-going flux difference bpasdq is the product  cU * wave2
!       # up-going eigenvector of -A(x)^T is r2 = [-cU, 1]^T
    
        s2 = cU * dxdcU  ! adjusted up-going wave speed
        bpasdq(1,i) = s2 * a2*(-cU)
        bpasdq(mu,i) = 0.d0
        bpasdq(mv,i) = s2 * a2
    
        enddo

    return
    end subroutine rpt2

MODULE euler3d_mappedgrid

  REAL(kind=8), PARAMETER :: pi=3.1415926535897932385,twopi=2*pi
  REAL(kind=8), PARAMETER :: rEarth=637120000.0

CONTAINS
  !-------------------------------------------------------------------------
  ! Name:
  !   volumeOfHex(x,y,z):
  !
  ! Description:
  !   Compute Volume of an LD Hexahedron given the 8 vertices
  !    from paper: 
  !    @book{Grandy_1997, 
  !    title={Efficient computation of volume of hexahedral cells}, 
  !    url={http://www.osti.gov/scitech/servlets/purl/632793}, 
  !    DOI={10.2172/632793}, 
  !    abstractNote={This report describes an efficient method to compute 
  !                  the volume of hexahedral cells used in three-dimensional 
  !                  hydrodynamics simulation. Two common methods for 
  !                  creating the hexahedron using triangular boundaries are 
  !                  considered.}, 
  !    author={Grandy, J.}, year={1997}, month={Oct}}
  !    https://doi.org/10.2172/632793
  !
  !    6*V_LD = 
  ! |x6-x0  x3-x0  x2-x7|   |x6-x0  x4-x0  x7-x5|   |x6-x0  x1-x0  x5-x2|
  ! |y6-y0  y3-y0  y2-y7| + |y6-y0  y4-y0  y7-y5| + |y6-y0  y1-y0  y5-y2|
  ! |z6-z0  z3-z0  z2-z7|   |z6-z0  z4-z0  z7-z5|   |z6-z0  z1-z0  z5-z2|
  !
  ! Inputs:
  !   x[:],y[:],z[:]  : x,y, and z coordinates of eight hexahedron vertices
  ! 
  ! Output:
  !   volumeOfHex     : Volume of LD hexahedron
  !-------------------------------------------------------------------------
  REAL(kind=8) FUNCTION volumeOfHex(x,y,z)

    IMPLICIT NONE

    REAL(kind=8), DIMENSION(8), INTENT(IN) :: x,y,z
    
    ! Compute Volume of Hexahedron
    volumeOfHex = &
         (x(7)-x(1))*((y(4)-y(1))*(z(3)-z(8)) - (y(3)-y(8))*(z(4)-z(1)))+&
         (x(4)-x(1))*((y(3)-y(8))*(z(7)-z(1)) - (y(7)-y(1))*(z(3)-z(8)))+&
         (x(3)-x(8))*((y(7)-y(1))*(z(4)-z(1)) - (y(4)-y(1))*(z(7)-z(1)))&
         +&
         (x(7)-x(1))*((y(5)-y(1))*(z(8)-z(6)) - (y(8)-y(6))*(z(5)-z(1)))+&
         (x(5)-x(1))*((y(8)-y(6))*(z(7)-z(1)) - (y(7)-y(1))*(z(8)-z(6)))+&
         (x(8)-x(6))*((y(7)-y(1))*(z(5)-z(1)) - (y(5)-y(1))*(z(7)-z(1)))&
         +&
         (x(7)-x(1))*((y(2)-y(1))*(z(6)-z(3)) - (y(6)-y(3))*(z(2)-z(1)))+&
         (x(2)-x(1))*((y(6)-y(3))*(z(7)-z(1)) - (y(7)-y(1))*(z(6)-z(3)))+&
         (x(6)-x(3))*((y(7)-y(1))*(z(2)-z(1)) - (y(2)-y(1))*(z(7)-z(1)))
    volumeOfHex = ABS(volumeOfHex)/6.d0
    RETURN
  END FUNCTION volumeOfHex  
  
  !---------------------------------------------------------------------------
  ! Name: mapc2pWrapper(xc,yc,zc,mx,my,mz,xyz0,xyzN,mapType,xp,yp,zp)
  !
  ! Description: mapping from computational to physical space
  !
  ! Inputs: 
  !        xc,yc,zc <REAL>     : computational coordinate values
  !        mx,my,mz <INTEGER>  : grid sizes
  !        xyz0,xyzN <REAL>    : altitude at bottom and top of grid
  !        mapType <CHARACTER> : type of mapping to compute         
  !
  ! Outputs: 
  !        xp,yp,zp <REAL>     : physical coordinate values
  !---------------------------------------------------------------------------
  SUBROUTINE mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(:), INTENT(IN) :: xc,yc,zc
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: xyz0,xyzN
    INTEGER, INTENT(IN) :: mz
    CHARACTER(20) :: mapType
    
    ! Output
    REAL(kind=8), DIMENSION(SIZE(xc)), INTENT(OUT) :: xp
    REAL(kind=8), DIMENSION(SIZE(yc)), INTENT(OUT) :: yp
    REAL(kind=8), DIMENSION(SIZE(zc)), INTENT(OUT) :: zp
    
    ! Compute Physical Grid From Computational
    SELECT CASE(mapType)
    CASE("Identity")
       CALL mapc2pIdentity(xc,yc,zc,xp,yp,zp)
    CASE("ZeroToOne")
       CALL mapc2pZeroToOne(xc,yc,zc,xyz0,xyzN,xp,yp,zp)
    CASE("Rotate")
       CALL mapc2pRotate(xc,yc,zc,xyz0,xyzN,xp,yp,zp)
    CASE("Spherical")
       CALL mapc2pSpherical(xc,yc,zc,xyz0,xyzN,xp,yp,zp)
    CASE DEFAULT
       WRITE(*,*)"Invalid mapType: ",mapType
       STOP
    END SELECT
    
    RETURN
  END SUBROUTINE mapc2pWrapper

  !---------------------------------------------------------------------------
  ! Name: mapc2pIdentity(xc,yc,zc,xp,yp,zp)
  !
  ! Description: Identity mapping from computational to physical space
  !
  ! Inputs: 
  !        xc,yc,zc <REAL>     : computational coordinate values
  ! Outputs: 
  !        xp,yp,zp <REAL>     : physical coordinate values
  !---------------------------------------------------------------------------
  SUBROUTINE mapc2pIdentity(xc,yc,zc,xp,yp,zp)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(:), INTENT(IN) :: xc,yc,zc
    
    ! Output
    REAL(kind=8), DIMENSION(SIZE(xc)), INTENT(OUT) :: xp
    REAL(kind=8), DIMENSION(SIZE(yc)), INTENT(OUT) :: yp
    REAL(kind=8), DIMENSION(SIZE(zc)), INTENT(OUT) :: zp
    
    ! x,xi coordinate
    xp = xc
    
    ! y,eta coordinate
    yp = yc
    
    ! z,phi coordinate
    zp = zc
    
    RETURN
  END SUBROUTINE mapc2pIdentity
      
  !---------------------------------------------------------------------------
  ! Name: mapc2pZeroToOne(xc,yc,zc,xyz0,xyzN,xp,yp,zp)
  !
  ! Description: mapping from computational to physical space using a
  !                computational grid from 0 to 1
  !
  ! Inputs: 
  !        xc,yc,zc <REAL>     : computational coordinate values
  !        xyz0,xyzN <REAL>    : physical coordinates at bottom and top of grid
  !
  ! Outputs: 
  !        xp,yp,zp <REAL>     : physical coordinate values
  !---------------------------------------------------------------------------
  SUBROUTINE mapc2pZeroToOne(xc,yc,zc,xyz0,xyzN,xp,yp,zp)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(:), INTENT(IN) :: xc,yc,zc
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: xyz0,xyzN
    
    ! Output
    REAL(kind=8), DIMENSION(SIZE(xc)), INTENT(OUT) :: xp
    REAL(kind=8), DIMENSION(SIZE(yc)), INTENT(OUT) :: yp
    REAL(kind=8), DIMENSION(SIZE(zc)), INTENT(OUT) :: zp
    
    ! x,xi coordinate
    xp = xyz0(1) + xc*(xyzN(1)-xyz0(1))
    
    ! y,eta coordinate
    yp = xyz0(2) + yc*(xyzN(2)-xyz0(2))
    
    ! z,phi coordinate
    zp = xyz0(3) + zc*(xyzN(3)-xyz0(3))
    
    RETURN
  END SUBROUTINE mapc2pZeroToOne
    
  !---------------------------------------------------------------------------
  ! Name: mapc2pRotate(xc,yc,zc,xyz0,xyzN,xp,yp,zp)
  !
  ! Description: mapping from computational to physical space using a
  !                computational grid from 0 to 1 and rotated by angle theta
  !
  ! Inputs: 
  !        xc,yc,zc <REAL>     : computational coordinate values
  !        xyz0,xyzN <REAL>    : physical coordinates at bottom and top of grid
  !
  ! Outputs: 
  !        xp,yp,zp <REAL>     : physical coordinate values
  !---------------------------------------------------------------------------
  SUBROUTINE mapc2pRotate(xc,yc,zc,xyz0,xyzN,xp,yp,zp)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(:), INTENT(IN) :: xc,yc,zc
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: xyz0,xyzN
    
    ! Output
    REAL(kind=8), DIMENSION(SIZE(xc)), INTENT(OUT) :: xp
    REAL(kind=8), DIMENSION(SIZE(yc)), INTENT(OUT) :: yp
    REAL(kind=8), DIMENSION(SIZE(zc)), INTENT(OUT) :: zp
    
    ! Local
    REAL(kind=8) :: theta
    REAL(kind=8), DIMENSION(SIZE(xc)) :: xp0
    REAL(kind=8), DIMENSION(SIZE(yc)) :: yp0
    REAL(kind=8), DIMENSION(SIZE(zc)) :: zp0
    
    theta=0.d0*pi/180.d0

    ! x,xi coordinate
    xp = xyz0(1) + xc*(xyzN(1)-xyz0(1))

    ! y,eta coordinate
    yp = xyz0(2) + yc*(xyzN(2)-xyz0(2))

    ! z,phi coordinate
    zp = xyz0(3) + zc*(xyzN(3)-xyz0(3))

    xp0 = xp
    yp0 = yp
    zp0 = zp    
    ! Rotate about x-axis by angle theta
    xp = xp0
    yp = yp0*COS(theta) - zp0*SIN(theta)
    zp = yp0*SIN(theta) + zp0*COS(theta)

    xp0 = xp
    yp0 = yp
    zp0 = zp
    ! Rotate about y-axis by angle theta
    xp = xp0*COS(theta) + zp0*SIN(theta)
    yp = yp0
    zp =-xp0*SIN(theta) + zp0*COS(theta)

    xp0 = xp
    yp0 = yp
    zp0 = zp    
    ! Rotate about z-axis by angle theta
    xp = xp0*COS(theta) - yp0*SIN(theta)
    yp = xp0*SIN(theta) + yp0*COS(theta)
    zp = zp0

    RETURN
  END SUBROUTINE mapc2pRotate
  
  !---------------------------------------------------------------------------
  ! Name: mapc2pSpherical(xc,yc,zc,xyz0,xyzN,xp,yp,zp)
  !
  ! Description: mapping from computational to physical space using a
  !                computational grid from 0 to 1 and then using a
  !                spherical transformation
  !
  ! Inputs: 
  !        xc,yc,zc <REAL>     : computational coordinate values
  !        xyz0,xyzN <REAL>    : physical coordinates at bottom and top of grid
  !
  ! Outputs: 
  !        xp,yp,zp <REAL>     : physical coordinate values
  !---------------------------------------------------------------------------
  SUBROUTINE mapc2pSpherical(xc,yc,zc,xyz0,xyzN,xp,yp,zp)

    IMPLICIT NONE

    ! Input
    REAL(kind=8), DIMENSION(:), INTENT(IN) :: xc,yc,zc
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: xyz0,xyzN

    ! Output
    REAL(kind=8), DIMENSION(SIZE(xc)), INTENT(OUT) :: xp
    REAL(kind=8), DIMENSION(SIZE(yc)), INTENT(OUT) :: yp
    REAL(kind=8), DIMENSION(SIZE(zc)), INTENT(OUT) :: zp

    ! Local
    REAL(kind=8), DIMENSION(SIZE(xc)) :: theta
    REAL(kind=8), DIMENSION(SIZE(yc)) :: phi
    REAL(kind=8), DIMENSION(SIZE(zc)) :: r

    ! x,xi coordinate
    xp = xyz0(1) + xc*(xyzN(1)-xyz0(1))

    ! y,eta coordinate
    yp = xyz0(2) + yc*(xyzN(2)-xyz0(2))

    ! z,phi coordinate
    zp = xyz0(3) + zc*(xyzN(3)-xyz0(3))

    ! Spherical to Cartesian Coordinates
    theta = xp
    phi = yp
    r = zp    
    xp = r*SIN(theta)*COS(phi)
    yp = r*SIN(theta)*SIN(phi)
    zp = r*COS(theta)

    RETURN
  END SUBROUTINE mapc2pSpherical

  !---------------------------------------------------------------------------
  ! Name: determinant(A,detA)
  !
  ! Description: Compute the determinant of a 3x3 array
  !
  ! Inputs:  A <REAL>    : 3x3 Array
  !         
  ! Outputs: detA <REAL> : determinant of A
  !---------------------------------------------------------------------------
  SUBROUTINE determinant(A,detA)

    IMPLICIT NONE

    ! Input
    REAL(kind=8), DIMENSION(3,3), INTENT(IN) :: A

    ! Output
    REAL(kind=8), INTENT(OUT) :: detA

    detA = A(1,1)*A(2,2)*A(3,3) &
         + A(2,1)*A(3,2)*A(1,3) &
         + A(3,1)*A(1,2)*A(2,3) &
         - A(3,1)*A(2,2)*A(1,3) &
         - A(2,1)*A(1,2)*A(3,3) &
         - A(1,1)*A(3,2)*A(2,3)

    RETURN
  END SUBROUTINE determinant

  !---------------------------------------------------------------------------
  ! Name: unitNormal(a,b,c,n)
  !
  ! Description: Compute the unit normal of given 3 indices in 3D space
  !
  ! Inputs:  a,b,c <REAL> : indices with x,y, and z coordinates
  !         
  ! Outputs: n <REAL>     : unit normals of plane defined from points a,b,c
  !---------------------------------------------------------------------------
  SUBROUTINE unitNormal(a,b,c,n)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: a,b,c
    
    ! Output
    REAL(kind=8), DIMENSION(3), INTENT(OUT) :: n

    ! Local
    REAL(kind=8), DIMENSION(3,3) :: D
    REAL(kind=8) :: magnitude

    D(:,1) = (/1.d0,a(2),a(3)/)
    D(:,2) = (/1.d0,b(2),b(3)/)
    D(:,3) = (/1.d0,c(2),c(3)/)
    CALL determinant(D,n(1))
    D(:,1) = (/a(1),1.d0,a(3)/)
    D(:,2) = (/b(1),1.d0,b(3)/)
    D(:,3) = (/c(1),1.d0,c(3)/)
    CALL determinant(D,n(2))
    D(:,1) = (/a(1),a(2),1.d0/)
    D(:,2) = (/b(1),b(2),1.d0/)
    D(:,3) = (/c(1),c(2),1.d0/)
    CALL determinant(D,n(3))

    magnitude = SQRT(n(1)**2 + n(2)**2 + n(3)**2)
    n(1) = n(1)/magnitude
    n(2) = n(2)/magnitude
    n(3) = n(3)/magnitude

    RETURN
  END SUBROUTINE unitNormal

  !---------------------------------------------------------------------------
  ! Name: dot(a,b,adotb)
  !
  ! Description: Compute the dot product of vectors a and b
  !
  ! Inputs:  a,b <REAL>   : 3D vectors
  !         
  ! Outputs: adotb <REAL> : dot product of a and b
  !---------------------------------------------------------------------------
  SUBROUTINE dot(a,b,adotb)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: a,b
    
    ! Output
    REAL(kind=8), INTENT(OUT) :: adotb

    adotb = a(1)*b(1) + a(2)*b(2) + a(3)*b(3)

    RETURN
  END SUBROUTINE dot

  !---------------------------------------------------------------------------
  ! Name: cross(a,b,c)
  !
  ! Description: Compute the cross product of vectors a and b
  !
  ! Inputs:  a,b <REAL> : 3D vectors
  !         
  ! Outputs: c <REAL>   : cross product of a and b
  !---------------------------------------------------------------------------
  SUBROUTINE cross(a,b,c)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: a,b
    
    ! Output
    REAL(kind=8), DIMENSION(3), INTENT(OUT) :: c

    c(1) = a(2)*b(3) - a(3)*b(2)
    c(2) = a(3)*b(1) - a(1)*b(3)
    c(3) = a(1)*b(2) - a(2)*b(1)

    RETURN
  END SUBROUTINE cross

  !---------------------------------------------------------------------------
  ! Name: areaPolygon(poly)
  !
  ! Description: Compute the area of a polygon given its vertices
  !
  ! Inputs:  poly <REAL> : vertices of polygon
  !         
  ! Outputs: area <REAL> : area of polygon
  !---------------------------------------------------------------------------
  SUBROUTINE areaPolygon(poly,polyArea)

    IMPLICIT NONE
    
    ! Input
    REAL(kind=8), DIMENSION(:,:), INTENT(IN) :: poly
    
    ! Output
    REAL(kind=8), INTENT(OUT) :: polyArea

    ! Local
    INTEGER :: i,np
    REAL(kind=8), DIMENSION(3) :: total,prod,vi1,vi2,n

    ! Compute Area of a Polygon Given its Vertices
    np = SIZE(poly,2)
    IF(np < 3)THEN
       WRITE(*,*)"This is not a polygon, no area"
       STOP
    END IF
    total=0
    DO i = 1,np
       vi1 = poly(:,i)
       IF(i == np)THEN
          vi2 = poly(:,1)
       ELSE
          vi2 = poly(:,i+1)
       END IF
       CALL cross(vi1,vi2,prod)
       total(1) = total(1) + prod(1)
       total(2) = total(2) + prod(2)
       total(3) = total(3) + prod(3)
    END DO
    CALL unitNormal(poly(:,1),poly(:,2),poly(:,3),n)
    CALL dot(total,n,polyArea)
    polyArea = ABS(polyArea*0.5d0)

    RETURN
  END SUBROUTINE areaPolygon

  !---------------------------------------------------------------------------
  ! Name: setAuxiliaryVariables(num_aux,mbc,mx,my,mz,xlower,ylower,zlower,&
  !                             dxc,dyc,dzc,xyz0,xyzN,aux)
  !
  ! Description: Compute auxiliary variables for non-uniform/mapped grids
  !
  ! Inputs: 
  !         xc,yc,zc <REAL>    : computational coordinate values
  !         mx,my,mz <INTEGER> : grid sizes
  !         xyz0,xyzN <REAL>   : altitude at bottom and top of grid
  !         
  ! Outputs: 
  !         xp,yp,zp <REAL>    : physical coordinate values
  !---------------------------------------------------------------------------
  SUBROUTINE setAuxiliaryVariables(num_aux,mbc,mx,my,mz,xlower,ylower,zlower,&
       dxc,dyc,dzc,xyz0,xyzN,mapType,aux)

    IMPLICIT NONE
    
    ! Input
    INTEGER, INTENT(IN) :: num_aux,mbc,mx,my,mz
    REAL(kind=8), INTENT(IN) :: xlower,ylower,zlower,dxc,dyc,dzc
    REAL(kind=8), DIMENSION(3), INTENT(IN) :: xyz0,xyzN
    CHARACTER(20) :: mapType

    ! Output
    REAL(kind=8), DIMENSION(num_aux,mx+2*mbc,my+2*mbc,mz+2*mbc), &
         INTENT(OUT) :: aux
    
    ! Local
    REAL(kind=8), DIMENSION(3) :: norm
    REAL(kind=8), DIMENSION(3,4) :: poly
    REAL(kind=8), DIMENSION(8) :: xcCorner,ycCorner,zcCorner,&
         xpCorner,ypCorner,zpCorner
    INTEGER :: i,j,k
    REAL(kind=8) :: vHex,area
    REAL(kind=8), DIMENSION(1) :: xc,yc,zc,xp,yp,zp

    ! Compute Auxiliary Variables
    DO i = 1,mx+2*mbc
       DO j = 1,my+2*mbc
          DO k = 1,mz+2*mbc
             
             ! Compute Physical Coordinates of Corners of Hexahedron

             ! i-1/2, j-1/2, k-1/2 Corner
             xcCorner(1) = xlower + (i-1)*dxc
             ycCorner(1) = ylower + (j-1)*dyc
             zcCorner(1) = zlower + (k-1)*dzc
             xc(1) = xcCorner(1)
             yc(1) = ycCorner(1)
             zc(1) = zcCorner(1)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(1) = xp(1)
             ypCorner(1) = yp(1)
             zpCorner(1) = zp(1)
             
             ! i+1/2, j-1/2, k-1/2 Corner
             xcCorner(2) = xcCorner(1) + dxc
             ycCorner(2) = ycCorner(1)
             zcCorner(2) = zcCorner(1)
             xc(1) = xcCorner(2)
             yc(1) = ycCorner(2)
             zc(1) = zcCorner(2)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(2) = xp(1)
             ypCorner(2) = yp(1)
             zpCorner(2) = zp(1)
             
             ! i+1/2, j+1/2, k-1/2 Corner
             xcCorner(3) = xcCorner(1) + dxc
             ycCorner(3) = ycCorner(1) + dyc
             zcCorner(3) = zcCorner(1)
             xc(1) = xcCorner(3)
             yc(1) = ycCorner(3)
             zc(1) = zcCorner(3)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(3) = xp(1)
             ypCorner(3) = yp(1)
             zpCorner(3) = zp(1)
             
             ! i-1/2, j+1/2, k-1/2 Corner
             xcCorner(4) = xcCorner(1)
             ycCorner(4) = ycCorner(1) + dyc
             zcCorner(4) = zcCorner(1)
             xc(1) = xcCorner(4)
             yc(1) = ycCorner(4)
             zc(1) = zcCorner(4)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(4) = xp(1)
             ypCorner(4) = yp(1)
             zpCorner(4) = zp(1)

             ! i-1/2, j-1/2, k+1/2 Corner
             xcCorner(5) = xcCorner(1)
             ycCorner(5) = ycCorner(1)
             zcCorner(5) = zcCorner(1) + dzc
             xc(1) = xcCorner(5)
             yc(1) = ycCorner(5)
             zc(1) = zcCorner(5)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(5) = xp(1)
             ypCorner(5) = yp(1)
             zpCorner(5) = zp(1)

             ! i+1/2, j-1/2, k+1/2 Corner
             xcCorner(6) = xcCorner(1) + dxc
             ycCorner(6) = ycCorner(1)
             zcCorner(6) = zcCorner(1) + dzc
             xc(1) = xcCorner(6)
             yc(1) = ycCorner(6)
             zc(1) = zcCorner(6)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(6) = xp(1)
             ypCorner(6) = yp(1)
             zpCorner(6) = zp(1)
             
             ! i+1/2, j+1/2, k+1/2 Corner
             xcCorner(7) = xcCorner(1) + dxc
             ycCorner(7) = ycCorner(1) + dyc
             zcCorner(7) = zcCorner(1) + dzc
             xc(1) = xcCorner(7)
             yc(1) = ycCorner(7)
             zc(1) = zcCorner(7)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(7) = xp(1)
             ypCorner(7) = yp(1)
             zpCorner(7) = zp(1)
             
             ! i-1/2, j+1/2, k+1/2 Corner
             xcCorner(8) = xcCorner(1)
             ycCorner(8) = ycCorner(1) + dyc
             zcCorner(8) = zcCorner(1) + dzc
             xc(1) = xcCorner(8)
             yc(1) = ycCorner(8)
             zc(1) = zcCorner(8)
             CALL mapc2pWrapper(xc,yc,zc,mz,xyz0,xyzN,mapType,xp,yp,zp)
             xpCorner(8) = xp(1)
             ypCorner(8) = yp(1)
             zpCorner(8) = zp(1)

             ! Compute Aux Variables (Normals/Area Ratios/Volume Ratio)

             ! \xi normal
             poly(:,1) = (/xpCorner(1),ypCorner(1),zpCorner(1)/)
             poly(:,2) = (/xpCorner(4),ypCorner(4),zpCorner(4)/)
             poly(:,3) = (/xpCorner(8),ypCorner(8),zpCorner(8)/)
             poly(:,4) = (/xpCorner(5),ypCorner(5),zpCorner(5)/)
             CALL unitNormal(poly(:,1),poly(:,2),poly(:,3),norm)
             aux(1,i,j,k) = norm(1) ! nx(i-1/2,j,k)
             aux(2,i,j,k) = norm(2) ! ny(i-1/2,j,k)
             aux(3,i,j,k) = norm(3) ! nz(i-1/2,j,k)
             CALL areaPolygon(poly,area)
             aux(4,i,j,k) = area/(dyc*dzc) ! gamma(i-1/2,j,k)
             
             ! \eta normal
             poly(:,1) = (/xpCorner(1),ypCorner(1),zpCorner(1)/)
             poly(:,2) = (/xpCorner(5),ypCorner(5),zpCorner(5)/)
             poly(:,3) = (/xpCorner(6),ypCorner(6),zpCorner(6)/)
             poly(:,4) = (/xpCorner(2),ypCorner(2),zpCorner(2)/)
             CALL unitNormal(poly(:,1),poly(:,2),poly(:,3),norm)
             aux(5,i,j,k) = norm(1) ! nx(i,j-1/2,k)
             aux(6,i,j,k) = norm(2) ! ny(i,j-1/2,k)
             aux(7,i,j,k) = norm(3) ! nz(i,j-1/2,k)
             CALL areaPolygon(poly,area)
             aux(8,i,j,k) = area/(dxc*dzc) ! gamma(i,j-1/2,k)
           
             ! \phi normal
             poly(:,1) = (/xpCorner(1),ypCorner(1),zpCorner(1)/)
             poly(:,2) = (/xpCorner(2),ypCorner(2),zpCorner(2)/)
             poly(:,3) = (/xpCorner(3),ypCorner(3),zpCorner(3)/)
             poly(:,4) = (/xpCorner(4),ypCorner(4),zpCorner(4)/)
             CALL unitNormal(poly(:,1),poly(:,2),poly(:,3),norm)
             aux(9,i,j,k) =  norm(1) ! nx(i,j,k-1/2)
             aux(10,i,j,k) = norm(2) ! ny(i,j,k-1/2)
             aux(11,i,j,k) = norm(3) ! nz(i,j,k-1/2)
             CALL areaPolygon(poly,area)
             aux(12,i,j,k) = area/(dxc*dyc) ! gamma(i,j,k-1/2)             

             ! Volume of hexahedron
             vHex = volumeOfHex(xpCorner,ypCorner,zpCorner)
             
             ! Capacity Function (Ratio of Physical:Computational volume)
             aux(13,i,j,k) = vHex/(dxc*dyc*dzc) ! kappa(i,j,k)
             
             ! Grid Delta in Direction of Gravity
             SELECT CASE(mapType)
             CASE("Identity","ZeroToOne","Rotate")
                aux(14,i,j,k) = ABS(zpCorner(5)-zpCorner(1)) ! dz
                aux(15,i,j,k) = (zpCorner(5) + zpCorner(1))/2.d0 ! z
             CASE("Spherical")
                aux(14,i,j,k) = &
                     ABS(SQRT(xpCorner(5)**2+ypCorner(5)**2+zpCorner(5)**2) &
                     - SQRT(xpCorner(1)**2+ypCorner(1)**2+zpCorner(1)**2)) ! dr
                aux(15,i,j,k) = (SQRT(xpCorner(5)**2+ypCorner(5)**2+zpCorner(5)**2) &
                     + SQRT(xpCorner(1)**2+ypCorner(1)**2+zpCorner(1)**2))/2.d0 &
                     - rEarth
             END SELECT
             
          END DO
       END DO
    END DO

    RETURN
  END SUBROUTINE setAuxiliaryVariables

END MODULE euler3d_mappedgrid

c
c ---------------------------------------------------------
c
      subroutine cleanup(nvar,naux)
c
c :::::::::::::::::::::: CLEANUP ::::::::::::::::::::::::::::::::;
c   this is just a check to make sure all storage was accounted for.
c   routine is called after all the data has been checkpointed.
c :::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::;

      use amr_module
      implicit double precision (a-h,o-z)
c
c      ## clean up storage to double check that everything taken care of
c      ## done after the checkpoint so pointers sitll work on restart
       do  120 level = 1, lfine
         call putsp(1,level,nvar,naux)
         mptr =  lstart(level)
 110        nx      = node(ndihi,mptr) - node(ndilo,mptr) + 1
            mitot  = nx + 2*nghost
            nwords  = mitot*nvar
            call reclam(node(store1, mptr), nwords)
            if (level .lt. mxnest) 
     .         call reclam(node(store2, mptr), nwords)
            if (naux .gt. 0) 
     .         call reclam(node(storeaux, mptr), mitot*naux)
        mptr = node(levelptr, mptr)
        if (mptr .ne. 0) go to 110
120    continue 

      return
      end

c
c -------------------------------------------------------------------
      subroutine flag2refine(mx,my,mz,mbc,meqn,maux,xlower,ylower,
     &                   zlower,dx,dy,dz,t,
     &                   level,tolsp,q,aux,amrflags,DONTFLAG,DOFLAG)
c -------------------------------------------------------------------

c
c ::::::::::::::::::::: flag2refine ::::::::::::::::::::::::::::::::::
c
c User routine to control flagging of points for refinement.
c
c Default version computes spatial difference dq in each direction and
c for each component of q and flags any point where this is greater than
c the tolerance tolsp.  This is consistent with what the routine errsp did in
c earlier versions of amrclaw (4.2 and before).
c
c This routine can be copied to an application directory and modified to
c implement some other desired refinement criterion.
c
c The logical function allowflag(x,y,t,level) is called to check whether 
c further refinement at this level is allowed at this particular location
c and time.  The default library version of this routine returns .true.
c for all arguments.  Copy that routine to the application directory and
c modify it if needed to restrict the region where refinement is allowed.
c
c Points may also be flagged for refining based on a Richardson estimate
c of the error, obtained by comparing solutions on the current grid and a
c coarsened grid.  Points are flagged if the estimated error is larger than
c the parameter tol in amr2ez.data, provided tol>0.  If tol<=0 then
c the coarsening and Richardson estimation is not performed!  
c This is a change from previous versions (4.2 and before) of amrclaw.
c Note: in previous versions, the routine errf1 used a function
c allowed(x,y,level) that has been replaced by the allowflag.  This new
c function is also used in Richardson estimation if that is invoked.
c
c
c    q   = grid values including ghost cells (bndry vals at specified
c          time have already been set, so can use ghost cell values too)
c
c  aux   = aux array on this grid patch
c
c amrflags  = array to be flagged with either the value
c             DONTFLAG (no refinement needed)  or
c             DOFLAG   (refinement desired)    
c
c tolsp = tolerance specified by user in input file amr2ez.data, used in default
c         version of this routine as a tolerance for spatial differences.

c ::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
c
      implicit double precision (a-h, o-z)

      dimension   q(meqn,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension   aux(maux,1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      dimension   amrflags(1-mbc:mx+mbc,1-mbc:my+mbc,1-mbc:mz+mbc)
      logical     allowflag
      external    allowflag
   
c     # loop over interior points on this grid:
      do 30 k = 1,mz
      z = zlower + (k-0.5d0)*dz

      do 20 j = 1,my
        y = ylower + (j-0.5d0)*dy
        do 10 i = 1,mx
          x = xlower + (i-0.5d0)*dx

          amrflags(i,j,k) = DONTFLAG

          if (allowflag(x,y,z,t,level)) then
c            # check to see if we should flag this point for refinement.
c            # Here the default test is taken from errsp.f in previous
c            # versions of amrclaw -- flag this point if dq > tolsp:

             dq = 0.d0
             do 5 m = 1,meqn
                dqi = dabs(q(m,i+1,j,k) - q(m,i-1,j,k))
                dqj = dabs(q(m,i,j+1,k) - q(m,i,j-1,k))
                dqk = dabs(q(m,i,j,k+1) - q(m,i,j,k-1))
                dq  = dmax1(dq, dqi, dqj, dqk)
    5           continue

             if (dq .gt. tolsp) amrflags(i,j,k) = DOFLAG
             endif

 10          continue
 20       continue
 30    continue

      return
      end

c     =========================================
      logical function allowflag(x,y,z,t,level)
c     =========================================

c     # Indicate whether the grid point at (x,y,z,t) at this refinement level
c     # is allowed to be flagged for further refinement.
c
c     # This is useful if you wish to zoom in on some structure in a 
c     # known location but don't want the same level of refinement elsewhere.  
c     # Points are flagged only if one of the errors is greater than the 
c     # corresponding tolerance.
c
c     # For example, to allow refinement of Level 1 grids everywhere but
c     # of finer grids only for  y >= 0.4:
c     # allowed(x,y,z,t,level) = (level.le.1 .or. y.ge.0.4d0) 
c
c     # This routine is called from routine flag2refine.
c     # If Richardson error estimates are used (if tol>0) then this routine
c     # is also called from errf1.

      implicit double precision (a-h,o-z)

c     # default version allows refinement anywhere:
      allowflag = .true.

      return
      end

! =====================================================
subroutine rp1_ptwise(num_eqn, num_aux, num_waves, q_l, q_r, aux_l, aux_r,    &
                       wave, s, amdq, apdq)
! =====================================================

!     # Pointwise Riemann solver for the acoustics equations in 1d, with
!     #  variable coefficients (heterogeneous media)

! waves:     2
! equations: 2
! aux fields: 2

! Conserved quantities:
!       1 pressure
!       2 velocity

! Auxiliary variables:
!       1 impedance
!       2 sound_speed

!     # auxl(1,i) should contain the impedance Z in cell i
!     # auxl(2,i) should contain the sound speed c in cell i

!     # On input, q_l contains the state vector on the left
!     #           q_r contains the state vector on the right

!     # On output, wave contains the waves,
!     #            s the speeds,
!     #
!     #            amdq = A^- Delta q,
!     #            apdq = A^+ Delta q,
!     #                   the decomposition of the flux difference
!     #                       f(q_l) - f(q_r)
!     #                   into leftgoing and rightgoing parts respectively.
!     #


    implicit none

    ! Input Arguments
    integer, intent(in) :: num_eqn, num_aux, num_waves
    real(kind=8), intent(in out) :: q_l(num_eqn), q_r(num_eqn)
    real(kind=8), intent(in out) :: aux_l(num_aux), aux_r(num_aux)

    ! Output arguments
    real(kind=8), intent(in out) :: wave(num_eqn, num_waves)
    real(kind=8), intent(in out) :: s(num_waves)
    real(kind=8), intent(in out) :: apdq(num_eqn), amdq(num_eqn)

    ! Locals
    real(kind=8) :: delta(2), a(2), zi, zim

!   # Split the jump in q into waves:

!   # Find a(1) and a(2), the coefficients of the 2 eigenvectors
    delta = q_r - q_l

!   # Impedances
    zi = aux_r(1)
    zim = aux_l(1)

    a(1) = (-delta(1) + zi*delta(2)) / (zim + zi)
    a(2) =  (delta(1) + zim*delta(2)) / (zim + zi)
    
!   # Compute the waves:
    
    wave(1,1) = -a(1)*zim
    wave(2,1) = a(1)
    s(1) = -aux_l(2)
    
    wave(1,2) = a(2)*zi
    wave(2,2) = a(2)
    s(2) = aux_r(2)

!   # Compute the leftgoing and rightgoing fluctuations:
!   # Note s(1,i) < 0 and s(2,i) > 0.

    amdq = s(1)*wave(:,1)
    apdq = s(2)*wave(:,2)

    end subroutine rp1_ptwise

subroutine rpn2(ixy,maxm,meqn,mwaves,maux,mbc,mx,ql,qr,auxl,auxr,wave,s,amdq,apdq)

! Riemann solver for the elasticity equations in 2d, with varying
! material properties rho, lambda, and mu 
!
! waves: 4
! equations: 5
! aux fields: 5

! Conserved quantities:
!       1 sigma_11
!       2 sigma_22
!       3 sigma_12
!       4 u
!       5 v

! Auxiliary variables:
!       1  density
!       2  lamda
!       3  mu
!       4  cp
!       5  cs

! Note that although there are 5 eigenvectors, one eigenvalue
! is always zero and so we only need to compute 4 waves.	
! 
! solve Riemann problems along one slice of data.
!
! On input, ql contains the state vector at the left edge of each cell
!           qr contains the state vector at the right edge of each cell
!
! Note that the i'th Riemann problem has left state qr(:,i-1)
!                                    and right state ql(:,i)
! From the basic clawpack routines, this routine is called with ql = qr
!
! This data is along a slice in the x-direction if ixy=1 
!                            or the y-direction if ixy=2.
!
! Here it is assumed that auxl=auxr gives the cell values
! for this slice.
!
! On output, wave contains the waves,
!            s the speeds,
!            amdq the  left-going flux difference  A^- \Delta q
!            apdq the right-going flux difference  A^+ \Delta q
!
! Note that the waves are *not* in order of increasing lambda.
! Instead the 1- and 2-waves are the P-waves and the 3- and 4-waves
! are the S-waves.   (The 5th wave would have speed zero and is not computed.)

    implicit none

    integer, intent(in) :: ixy, maxm, meqn, mwaves, mbc, mx, maux
    double precision, intent(in) :: ql, qr, auxl, auxr
    double precision, intent(out) :: wave, s, amdq, apdq

    dimension wave( meqn, mwaves, 1-mbc:maxm+mbc)
    dimension    s(mwaves, 1-mbc:maxm+mbc)
    dimension   ql(meqn, 1-mbc:maxm+mbc)
    dimension   qr(meqn, 1-mbc:maxm+mbc)
    dimension apdq(meqn, 1-mbc:maxm+mbc)
    dimension amdq(meqn, 1-mbc:maxm+mbc)
    dimension auxl(maux, 1-mbc:maxm+mbc)
    dimension auxr(maux, 1-mbc:maxm+mbc)

    integer :: ksig11, ksig22, ku, kv, i, m
    double precision :: dsig11, dsig22, dsig12, du, dv
    double precision :: alamr, amur, bulkr, cpr, csr
    double precision :: alaml, amul, bulkl, cpl, csl
    double precision :: det, a1, a2, a3, a4

    ! set ku to point to  the component of the system that corresponds
    ! to velocity in the direction of this slice, kv to the orthogonal
    ! velocity.  Similarly ksig11 and ksig22 point to normal stresses.
    ! 3rd component is always shear stress sig12.

    if (ixy.eq.1) then
        ksig11 = 1
        ksig22 = 2
        ku = 4
        kv = 5
    else
        ksig11 = 2
        ksig22 = 1
        ku = 5
        kv = 4
    endif

    ! note that notation for u and v reflects assumption that the 
    ! Riemann problems are in the x-direction with u in the normal
    ! direciton and v in the orthogonal direcion, but with the above
    ! definitions of ku and kv the routine also works with ixy=2

    ! split the jump in q at each interface into waves
    ! The jump is split into leftgoing waves traveling at speeds -cp, -cs
    ! relative to the material properties to the left of the interface,
    ! and rightgoing waves traveling at speeds +cp, +cs
    ! relative to the material properties to the right of the interface,

    do i = 2-mbc, mx+mbc
        dsig11 = ql(ksig11,i) - qr(ksig11,i-1)
        dsig22 = ql(ksig22,i) - qr(ksig22,i-1)
        dsig12 = ql(3,i) - qr(3,i-1)
        du = ql(ku,i) - qr(ku,i-1)
        dv = ql(kv,i) - qr(kv,i-1)

        ! material properties in cells i (on right) and i-1 (on left):

        alamr = auxl(2,i)
        amur = auxl(3,i)
        bulkr = alamr + 2.d0*amur
        cpr = auxl(4,i)
        csr = auxl(5,i)

        alaml = auxr(2,i-1)
        amul = auxr(3,i-1)
        bulkl = alaml + 2.d0*amul
        cpl = auxr(4,i-1)
        csl = auxr(5,i-1)

        ! P-wave strengths:
        det = bulkl*cpr + bulkr*cpl
        if (det.eq.0.d0) then
            write(6,*) 'det=0 in rpn2'
            stop 
        endif
        a1 = (cpr*dsig11 + bulkr*du) / det
        a2 = (cpl*dsig11 - bulkl*du) / det

        ! S-wave strengths:
        det = amul*csr + amur*csl
        if (det.eq.0.d0) then
            ! no s-waves
            a3 = 0.d0
            a4 = 0.d0
        else
            a3 = (csr*dsig12 + amur*dv) / det
            a4 = (csl*dsig12 - amul*dv) / det
        endif

        ! 5th wave has velocity 0 so is not computed or propagated.


        ! Compute the waves.

        wave(ksig11,1,i) = a1 * bulkl
        wave(ksig22,1,i) = a1 * alaml
        wave(3,1,i)  = 0.d0
        wave(ku,1,i) = a1 * cpl
        wave(kv,1,i) = 0.d0
        s(1,i) = -cpl

        wave(ksig11,2,i) = a2 * bulkr
        wave(ksig22,2,i) = a2 * alamr
        wave(3,2,i)  = 0.d0
        wave(ku,2,i) = -a2 * cpr
        wave(kv,2,i) = 0.d0
        s(2,i) = cpr

        wave(ksig11,3,i) = 0.d0
        wave(ksig22,3,i) = 0.d0
        wave(3,3,i)  = a3*amul
        wave(ku,3,i) = 0.d0
        wave(kv,3,i) = a3*csl
        s(3,i) = -csl

        wave(ksig11,4,i) = 0.d0
        wave(ksig22,4,i) = 0.d0
        wave(3,4,i)  = a4*amur
        wave(ku,4,i) = 0.d0
        wave(kv,4,i) = -a4*csr
        s(4,i) = csr


        ! compute the leftgoing and rightgoing flux differences:
        ! Note s(i,1),s(i,3) < 0   and   s(i,2),s(i,4) > 0.
        do m=1,meqn
            amdq(m,i) = s(1,i)*wave(m,1,i) + s(3,i)*wave(m,3,i)
            apdq(m,i) = s(2,i)*wave(m,2,i) + s(4,i)*wave(m,4,i)
        enddo
    enddo

    return
end subroutine rpn2

subroutine b4step1(mbc,mx,meqn,q,xlower,dx,t,dt,maux,aux)

    ! Called before each call to step1.
    ! Use to set time-dependent aux arrays or perform other tasks.

    ! This version checks for very small or negative depths, resets to 0

    ! It also does various other things:
    ! If monitor_fgmax:
    !    keeps track of maximum value of h,s,hss over entire computation,
    !    and arrival time of wave in each cell
    ! If monitor_runup:
    !    keeps track of first and last wet cell each time to track 
    !    inundation and runup as a function of time
    ! If monitor_total_zeta:
    !    keeps track of total mass of water, or actually mass of water
    !    relative to ocean at rest, using
    !       zeta = h in initially dry cells where B < sea_level
    !       zeta = eta = h+B in initially wet cells where B > sea_level

    use geoclaw_module, only: dry_tolerance, sea_level
    use geoclaw_module, only: DEG2RAD, earth_radius, coordinate_system, pi
    use grid_module, only: xp_edge
    use grid_module, only: monitor_fgmax, hmax, smax, hssmax, arrival_time
    use grid_module, only: fgmax_arrival_tol, fgmax_tstart
    use grid_module, only: monitor_total_zeta, iunit_total_zeta_mass
    use grid_module, only: total_zeta_mass_t0, NOTSET
    use grid_module, only: monitor_runup, iunit_runup, runup_tolerance

    implicit none
    integer, intent(in) :: mbc,mx,meqn,maux
    real(kind=8), intent(in) :: xlower,dx,t,dt
    real(kind=8), intent(inout) :: q(meqn,1-mbc:mx+mbc)
    real(kind=8), intent(inout) :: aux(maux,1-mbc:mx+mbc)

    !local variables
    integer :: i,ig,j,m,mvars
    real(kind=8) :: x, capa_latitude, zeta, eta
    real(kind=8) :: speed(1-mbc:mx+mbc)
    real(kind=8) :: total_zeta_mass, cell_zeta_mass, dzeta
    real(kind=8) :: x_first_wet,z_first_wet,x_last_wet,z_last_wet
    integer :: i_first_wet, i_last_wet

    ! accumulate total mass in excess of initial sea level
    ! zeta = eta = h+B offshore and zeta = h onshore.  Should be conserved.

    if (coordinate_system == 2) then
        capa_latitude = 2.d0*pi*earth_radius**2 ! to scale to surface area
    endif

    do i=1-mbc,mx+mbc
        ! if cell nearly dry, reset h and hu to zero:
        if (q(1,i)<=dry_tolerance) then
            q(1,i) = max(q(1,i),0.0)
            do m=2,meqn
               q(m,i)=0.d0
            enddo
            speed(i) = 0.d0
        else
            speed(i) = abs(q(2,i)/q(1,i))
        endif
    enddo
         
    if (monitor_fgmax .and. (t >= fgmax_tstart)) then
        do i=1,mx
            ! check arrival time:
            ! using the same criterion as the default in 2d fgmax, 
            ! but for some cases may be better to also look at decrease
            ! in eta and/or water speed
            eta = q(1,i)+aux(1,i)
            if ((q(1,i) > dry_tolerance) &
                    .and. (eta > sea_level + fgmax_arrival_tol) &
                    .and. (arrival_time(i) == NOTSET))  then
                arrival_time(i) = t
            endif

            ! keep track of max depth, speed, momentum flux:
            hmax(i) = dmax1(hmax(i), q(1,i))
            smax(i) = dmax1(smax(i), speed(i))
            hssmax(i) = dmax1(hssmax(i), q(2,i)*speed(i))
        enddo
    endif
    
    if (monitor_total_zeta) then
        total_zeta_mass = 0.d0 
        do i=1,mx
            ! total mass deviation based on zeta:
            if (aux(1,i) < sea_level) then
                zeta = q(1,i) + aux(1,i)  ! = eta = h+B
            else
                zeta = q(1,i)             ! = h
            endif

            cell_zeta_mass = zeta * (xp_edge(i+1) - xp_edge(i))

            if (coordinate_system == -1) then
                ! for total_mass on circle when using radial symmetry:
                cell_zeta_mass = cell_zeta_mass * pi * &
                         (xp_edge(i+1) + xp_edge(i))
            else if (coordinate_system == 2) then
                ! for total mass on full sphere:
                cell_zeta_mass = cell_zeta_mass * (sin(xp_edge(i+1)*DEG2RAD) - &
                         sin(xp_edge(i)*DEG2RAD))/dx * capa_latitude
            endif

            total_zeta_mass = total_zeta_mass + cell_zeta_mass
        enddo
    
        if (total_zeta_mass_t0 == NOTSET) then
            ! this must be first step
            total_zeta_mass_t0 = total_zeta_mass
        endif
        dzeta = total_zeta_mass - total_zeta_mass_t0
 600    format(f16.2, 2e16.6)
        write(iunit_total_zeta_mass,600) t,total_zeta_mass, dzeta
    endif


    if (monitor_runup) then
        i_first_wet = 1
        do while (q(1,i_first_wet) < runup_tolerance)
            i_first_wet = i_first_wet + 1
            if (i_first_wet == mx) exit
        enddo
        x_first_wet = xp_edge(i_first_wet)
        z_first_wet = aux(1,i_first_wet) + q(1,i_first_wet)
    
        i_last_wet = mx
        do while (q(1,i_last_wet) < runup_tolerance)
            i_last_wet = i_last_wet - 1
            if (i_last_wet == 0) exit
        enddo
        x_last_wet = xp_edge(i_last_wet+1)
        z_last_wet = aux(1,i_last_wet) + q(1,i_last_wet)
    
 601    format(5e15.6)
        write(iunit_runup, 601) t,x_first_wet,z_first_wet,x_last_wet,z_last_wet
    endif
        


end subroutine b4step1

#!/usr/bin/env bash

# Get <#>
git clone https://github.com/hashdist/hashdist
( 
    cd hashdist
    git checkout 231d3ade086c9f176e0bf19a9877d31703a50295
)
export PATH=`pwd`/hashdist/bin:$PATH
hit init-home

# a reasonable profile for building petsc4py on Travis
mv ../.stack.yaml stack.yaml

# 150 MB, shouldn't take too long to download
wget https://www.dropbox.com/s/h0d27lpft4ijpei/hashdist_profile_cache_5kbtllo3bawe.tar.gz
tar -zxf hashdist_profile_cache_5kbtllo3bawe.tar.gz -C ~/.hashdist

# This should now be very fast
set -o pipefail
hit develop -v stack.yaml 2>&1 | pv -i 15 -n | cat > log.txt
tail -n 60 log.txt

# This is a sample bash script to set the parameters needed
# to run the Bouss version of GeoClaw with MPI and OpenMP.
# Adjust as needed for your system...

# You also need to set CLAW, FC, and perhaps PYTHONPATH

# For more information, see
#   https://www.clawpack.org/bouss2d.html
#   https://www.clawpack.org/setenv.html

export PETSC_DIR=/full/path/to/petsc
export PETSC_ARCH=arch-darwin-c-opt
export PETSC_OPTIONS="-options_file $CLAW/geoclaw/examples/bouss/petscMPIoptions"
export OMP_NUM_THREADS=6
export BOUSS_MPI_PROCS=6  # only used in Clawpack Boussinesq example

#!/bin/sh

# Execute this script from the top level clawpack directory, 
# assumed to be a git clone of git://github.com/clawpack/clawpack.

# Before running this you might want to do:
#    python $CLAW/clawutil/src/python/clawutil/claw_git_status.py
# and then check the files
#    claw_git_status.txt  and  claw_git_diffs.txt
# to make sure you don't have uncommitted changes in these repositories.

# The commands below check out the master branch of each repository
# and pull any recent changes.

CLAW=$PWD
echo In directory $CLAW checking out master and pulling from origin

for repo in $CLAW pyclaw classic riemann amrclaw geoclaw clawutil visclaw
do
    cd $repo
    echo "In repository $repo"
    git checkout master
    git pull origin master
    cd $CLAW
done

# Create claw_git_status and claw_git_diff files to record what's checked out. 
# Requires $CLAW set to this directory above to work properly:

python ./clawutil/src/python/clawutil/claw_git_status.py
d=$(date +%Y-%m-%d)
f1=${d}_claw_git_status.txt
f2=${d}_claw_git_diff.txt
mv claw_git_status.txt $f1
mv claw_git_diffs.txt $f2
echo "Current git status listed in files"
echo "     ./$f1"
echo "     ./$f2"

#!/bin/bash

# Script to run tests on Travis.  This is separate from the file
# .travis.yml so that we can have if statements but make sure
# that failures at intermediate steps are caught (by setting -ev).
# See http://steven.casagrande.io/articles/travis-ci-and-if-statements/

set -ev

cd src/pyclaw
if [ "${TEST_PACKAGE}" == "pyclaw" ]; then
    # pyclaw doc-tests
    nosetests --first-pkg-wins --with-doctest --exclude=limiters --exclude=sharpclaw --exclude=fileio --exclude=example --with-coverage --cover-package=clawpack.pyclaw;
    mv .coverage .coverage.doctest;
    # pyclaw examples and I/O tests
    nosetests -v --first-pkg-wins --exclude=limiters --exclude=sharpclaw --with-coverage --cover-package=clawpack.pyclaw --include=IOTest;
    cd ../../examples;
    nosetests -v --with-coverage --cover-package=clawpack.pyclaw;
    mv .coverage ../src/pyclaw/.coverage.examples;
    cd ../src/pyclaw;
    coverage combine;
fi

if [[ "${TEST_PACKAGE}" == "petclaw" ]]; then
    # petclaw I/O tests
    cd ../petclaw/tests;
    mpirun -n 4 nosetests -v --first-pkg-wins --include=IOTest;
    # petclaw examples
    cd ../../../examples;
    mpirun -n 4 nosetests -v --first-pkg-wins;
fi

if [[ "${TEST_PACKAGE}" == "forestclaw" ]]; then
    # forestclaw tests (I/O only)
    cd ../forestclaw;
    nosetests --first-pkg-wins;
fi

# Citing Clawpack

If you use Clawpack in publications, please cite the following:

    @misc{clawpack,
          title={Clawpack software}, 
          author={Clawpack Development Team}, 
          url={http://www.clawpack.org}, 
          note={Version 5.1},
          year={2014}}

If you are using a version of the software other than the one above, please make
sure to cite that instead.  Please also cite at least one of the following 
regarding the algorithms used in Clawpack:


#### Basic algorithms in 1D and 2D

    R. J. LeVeque, 1997. Wave propagation algorithms for multi-dimensional 
    hyperbolic systems. J. Comput. Phys. 131, 327–353.


    @article{rjl:wpalg,
        Author = {R. J. LeVeque},
        Title = {Wave propagation algorithms for multi-dimensional hyperbolic 
                 systems},
        Journal = {J. Comput. Phys.},
        Pages = {327--353},
        Volume = {131},
        Year = {1997}
    }

    R. J. LeVeque. Finite Volume Methods for Hyperbolic Problems. Cambridge 
    University Press, Cambridge, UK, 2002.

    @book{LeVeque-FVMHP,
          Author = {R. J. LeVeque},
          Title = {Finite Volume Methods for Hyperbolic Problems},
          Publisher = {Cambridge University Press},
          Year = {2002},
          Url = {http://www.clawpack.org/book.html}
    }

#### 3D algorithms
    
    J. O. Langseth and R. J. LeVeque. 2000. A wave-propagation method for 
    three-dimensional hyperbolic conservation laws. J. Comput. Phys. 165, 
    126–166.
    
    @article{LangsethLeVeque00,
             Author = {J. O. Langseth and R. J. LeVeque},
             Title = {A wave-propagation method for three-dimensional hyperbolic
                      conservation laws},
             Journal = {J. Comput. Phys.},
             Pages = {126--166},
             Volume = {165},
             Year = {2000}
    }

#### Adaptive Mesh Refinement (AMR)

    M. J. Berger and R. J. LeVeque. 1998. Adaptive Mesh Refinement using Wave-Propagation Algorithms for Hyperbolic Systems. SIAM J. Numer. Anal. 35, 2298–2316.

    @article{BergerLeVeque98,
             Author = {M. J. Berger and R. J. LeVeque},
             Journal = {SIAM J. Numer. Anal.},
             Pages = {2298--2316},
             Title = {Adaptive Mesh Refinement using Wave-Propagation Algorithms 
                      for Hyperbolic Systems},
             Volume = {35},
             Year = {1998}
    }
 
#### F-wave Algorithms

    D. S. Bale, R. J. LeVeque, S. Mitran, and J. A. Rossmanith. A wave-propagation 
    method for conservation laws with spatially varying flux functions, SIAM J. 
    Sci. Comput 24 (2002), 955-978.

    @article{BaleLevMitRoss02,
        Author = {D. Bale and R. J. LeVeque and S. Mitran and J. A. Rossmanith},
        Title = {A wave-propagation method for conservation laws and balance laws
                 with spatially varying flux functions},
        Journal = {SIAM J. Sci. Comput.},
        Pages = {955--978},
        Volume = {24},
        Year = {2002}
    }

#### GeoClaw

    M. J. Berger, D. L. George, R. J. LeVeque and K. M. Mandli, The GeoClaw 
    software for depth-averaged flows with adaptive refinement, Advances in Water 
    Resources 34 (2011), pp. 1195-1206.

    @article{BergerGeorgeLeVequeMandli11,
             Author = {M. J. Berger and D. L. George and R. J. LeVeque and K. T.  
             Mandli},
             Journal = {Adv. Water Res.},
             Pages = {1195-1206},
             Title = {The {GeoClaw} software for depth-averaged flows with 
                      adaptive refinement},
             Volume = {34},
             Year = {2011},
             Url = {\url{www.clawpack.org/links/papers/awr11}}
    }

    R. J. LeVeque, D. L. George, and M. J. Berger, 2011, Tsunami modelling with 
    adaptively refined finite volume methods, Acta Numerica, pp. 211-289.

    @article{mjb-dg-rjl:actanum2011,
             Author = {R.J. LeVeque  and D. L. George and M. J. Berger},
             Title = {Adaptive Mesh Refinement Techniques for Tsunamis and Other
                     Geophysical Flows Over Topography},
             Journal = {Acta Numerica},
             Pages = {211-289},
             Year = {2011}
    }

#### PyClaw

Please change the version number and year to the version you have used.

    @misc{pyclaw,
          title={PyClaw software}, 
          url={http://www.pyclaw.org}, 
          author={Mandli, Kyle T. and Ketcheson, David I. and others}, 
          note={Version 5.1}
          year={2014}
    }

    David I. Ketcheson, Kyle T. Mandli, Aron J. Ahmadia, Amal Alghamdi, Manuel 
    Quezada de Luna, Matteo Parsani, Matthew G. Knepley, and Matthew Emmett, 
    2012, PyClaw: Accessible, Extensible, Scalable Tools for Wave Propagation 
    Problems, SIAM Journal on Scientific Computing, 34(4):C210-C231

    @article{pyclaw-sisc,
             Author = {Ketcheson, David I. and Mandli, Kyle T. and Ahmadia, Aron 
             J. and Alghamdi, Amal and {Quezada de Luna}, Manuel and Parsani, 
             Matteo and Knepley, Matthew G. and Emmett, Matthew},
             Journal = {SIAM Journal on Scientific Computing},
             Month = nov,
             Number = {4},
             Pages = {C210--C231},
             Title = {{PyClaw: Accessible, Extensible, Scalable Tools for Wave    
             Propagation Problems}},
             Volume = {34},
             Year = {2012}
    }

#### SharpClaw (High Order WENO)

    D. I. Ketcheson, Matteo Parsani, and R J LeVeque, 2013, High-order Wave 
    Propagation Algorithms for Hyperbolic Systems, SIAM Journal on Scientific 
    Computing, 35(1):A351-A377 (2013)

    @article{Ketcheson2011,
             Author = {Ketcheson, David I. and Parsani, Matteo and LeVeque,
             Randall J.},
             Journal = {SIAM Journal on Scientific Computing},
             Number = {1},
             Pages = {A351--A377},
             Title = {{High-order Wave Propagation Algorithms for Hyperbolic  
                       Systems}},
             Volume = {35},
             Year = {2013}
    }
